***************************************************************************

                          IMAGER General Information
			 (S.Guilloteau 22-Nov-2022,   J.Pety, 12-oct-2004)

***************************************************************************

Contact and availability
------------------------

IMAGER home page:
  https://imager.oasu.u-bordeaux.fr
  
The most recent binary distribution for Linux is available on this Webpage

GILDAS home page: 

  http://www.iram.fr/IRAMFR/GILDAS

The most recent GILDAS version is available in the distribution section of
this web page.

Introduction
------------

GILDAS is a collection of state-of-the-art softwares oriented toward
(sub-)millimeter radioastronomical applications (either single-dish or
interferometer). It is daily used to reduce all data acquired with the IRAM
30M telescope and Plateau de Bure Interferometer PDBI (except VLBI
observations). GILDAS is easily extensible. GILDAS is written in
Fortran-90, with a few parts in C/C++ (mainly keyboard interaction,
plotting, widgets).

IMAGER is a contributed package to image interferometric data, and visualize
any 3-D data cube.

Other information
-----------------

Many more information may be found in:

  * AUTHORS               List of historical developpers and current maintainers
  * FAQ                   Frequently Asked Questions
  * INSTALL               Basics installation guidelines
  * PROBLEMS              Known problems (i.e. not yet corrected)
  * SYSTEM                The system you are compiling on (i.e. MACHINE-OS-COMPILER)
  * VERSION               Version you are looking at
  * WISHES                Improvment that may or may not happened
  * NEWS                  Last major changes commented
  * TAGS-Introduction     Introduction to an easy way to navigate through the sources
  * CVS-User-Reference    CVS reference card for standard user
  * Filename-Conventions  Description of standard about source filename
  * Tree-Structure        Description of the tree structure

***************************************************************************

subroutine combine_comm(line,error)
  !! IMAGER -- Dispatch routine for COMBINE
  character(len=*), intent(in) :: line
  logical, intent(inout) :: error
  !
  call map_combine_sub(line,error,.true.)
end subroutine combine_comm
! 
subroutine map_combine_comm(line,error)
  !! IMAGER -- Dispatch routine for MAP_COMBINE
  character(len=*), intent(in) :: line
  logical, intent(inout) :: error
  !
  call map_combine_sub(line,error,.false.)
end subroutine map_combine_comm
!
subroutine map_combine_sub(line,error,resample)
  use image_def
  use gkernel_interfaces
  use imager_interfaces, only : do_combine, map_message
  use gbl_message
  !----------------------------------------------------------------------
  ! @ private
  !*
  !   IMAGER -- Support for commands COMBINE and MAP_COMBINE
  !
  ! MAP_COMBINE Out CODE In1 In2 /factor A1 A2 /THRESHOLD T1 T2 /BLANKING Bval  
  !   or  
  ! COMBINE Out CODE In1 In2 /factor A1 A2 /THRESHOLD T1 T2 /BLANKING Bval
  !
  !     Combine in different ways two input images (or data cubes)...
  !
  !     Out can be a file name or an existing Image variable.   
  !         The distinction is made by the existence of a "." in the name
  !         If it is a file, it is created like the In1 Variable
  !         If it is an Image variable, it must match the shape of 
  !           the In1 Variable
  !     In1 can be a file name or an existing Image variable.  
  !     In2 can be a file name or an existing Image variable.  
  !         The rank of In2 must be smaller than that of In1, and
  !         other dimensions must match          
  !!
  !----------------------------------------------------------------------
  character(len=*), intent(in) :: line    !! Input command line
  logical, intent(out) :: error           !! Return error flag
  logical, intent(in) :: resample         !! Allow automatic Resampling
  !
  ! Constants 
  integer, parameter :: o_blank=1, o_factor=2, o_thre=3, o_rela=4
  character(len=*), parameter :: rname='MAP_COMBINE'
  integer, parameter :: mcode=10
  character(len=14) :: scode(mcode)
  data scode/'ADD','DIVIDE','MULTIPLY','OPTICAL_DEPTH','INDEX','SUBTRACT','PLUS','MINUS','OVER','TIMES'/ 
  ! Local ---
  character(len=filename_length) :: namex,namey,namez
  character(len=20) :: code, argum
  real :: ay,az,ty,tz,b,c
  logical :: do_blank, relative
  integer :: n, ier
  !
  ! Code ----
  call sic_ch(line,0,1,namex,n,.true.,error)
  if (error) return
  call sic_ch(line,0,2,argum,n,.true.,error)
  if (error) return
  az = 1.
  ay = 1.
  if (argum.eq.'=') then
    if (sic_present(o_factor,0)) then
      call map_message(seve%e,rname,'Option /FACTOR is incompatible with free syntax')
      error = .true.
      return
    endif
    ! COMBINE  Out = F*In1 Oper G*In2
    !
    call sic_ke(line,0,4,argum,n,.true.,error)
    if (error) return
    select case (argum)
    case ('+') 
      code = 'ADD'
    case ('-')
      code = 'SUBTRACT'
    case ('*') 
      code = 'MULTIPLY'
    case ('|')
      code = 'DIVIDE'
    case default    
      call sic_ambigs (rname,argum,code,n,scode,mcode,error)
    end select
    if (error) return
    !
    call sic_ch(line,0,3,namey,n,.true.,error)
    if (error) return
    n = index(namey,'*')
    if (n.ne.0) then
      read(namey(1:n-1),*,iostat=ier) ay
      if (ier.ne.0) then
        call map_message(seve%e,rname,'Invalid 1st factor '//namey(1:n))
        error = .true.
        return
      endif
      namey = namey(n+1:)
    endif
    !
    call sic_ch(line,0,5,namez,n,.true.,error)
    if (error) return
    n = index(namez,'*')
    if (n.ne.0) then
      read(namez(1:n-1),*,iostat=ier) az
      if (ier.ne.0) then
        call map_message(seve%e,rname,'Invalid 2nd factor '//namez(1:n))
        error = .true.
        return
      endif
      namez = namez(n+1:)
    endif
    !
    c = 0
    call sic_r4(line,0,6,c,.false.,error)
    !
  else
    call sic_ch(line,0,2,argum,n,.true.,error)
    if (error) return
    call sic_ambigs (rname,argum,code,n,scode,mcode,error)
    if (error) return
    call sic_ch(line,0,3,namey,n,.true.,error)
    if (error) return
    call sic_ch(line,0,4,namez,n,.true.,error)
    if (error) return
    c = 0
    call sic_r4(line,0,5,c,.false.,error)
    if (error) return
    call sic_r4(line,o_factor,2,az,.false.,error)
    call sic_r4(line,o_factor,1,ay,.false.,error)
  endif
  !
  tz = -huge(1.0)
  ty = tz
  !
  call sic_r4(line,o_thre,2,tz,.false.,error)
  call sic_r4(line,o_thre,1,ty,.false.,error)
  !
  if ((code.eq.'SUBTRACT').or.(code.eq.'MINUS')) then
    code = 'ADD'
    az = -az
  endif
  !
  if (sic_present(o_blank,0)) then
    call sic_r4(line,o_blank,1,b,.true.,error)
    do_blank = .true.
  else
    do_blank = .false.
  endif
  !
  relative = sic_present(o_rela,0)
  !
  call do_combine(namex,namey,namez,code,c,ay,ty,az,tz,error, &
    & resample,b,do_blank,relative)
end subroutine map_combine_sub
!
subroutine do_combine(namex,namey,namez,code,c,ay,ty,az,tz,error, &
  & resample, b, do_blank, relative)
  use imager_interfaces, except_this => do_combine
  use gkernel_types
  use gkernel_interfaces
  use gbl_message
  use iso_c_binding
  !----------------------------------------------------------------------
  ! @ private-mandatory
  !*
  !   IMAGER -- Support routine for commands COMBINE and MAP_COMBINE
  !
  ! COMBINE Out CODE In1 In2 /factor A1 A2 /THRESHOLD T1 T2 /BLANK Bval 
  !     Combine in different ways two input images
  !        (or data cubes)...
  !
  !     Out can be a file name or an existing Image variable. 
  !         The distinction is made by the existence of a "." in the name
  !         If it is a file, it is created like the In1 Variable
  !         If it is an Image variable, it must match the shape of 
  !           the In1 Variable
  !     In1 can be a file name or an existing Image variable.
  !     In2 can be a file name or an existing Image variable.
  !         The rank of In2 must be smaller than that of In1, and
  !         other dimensions must match     
  !!     
  !----------------------------------------------------------------------
  character(len=*), intent(inout) :: namex  !! Output file
  character(len=*), intent(inout) :: namey  !! Input file 1
  character(len=*), intent(inout) :: namez  !! Input file 2
  character(len=*), intent(inout) :: code   !! Combination code
  real, intent(in) :: c       !! Offset
  real, intent(inout) :: ay   !! Y Factor
  real, intent(inout) :: ty   !! Y Threshold
  real, intent(inout) :: az   !! Z Factor
  real, intent(inout) :: tz   !! Z Threshold
  logical, intent(out) :: error             !! Logical error flag
  logical, intent(in) :: resample           !! Resample 2nd image
  real, intent(inout) :: b             !! Blanking value
  logical, intent(inout) :: do_blank   !! Require Blanking
  logical, intent(in) :: relative      !! Ignore absolute positions
  !
  ! Constants
  character(len=*), parameter :: rname='MAP_COMBINE'
  real, parameter :: tole=1E-4
  real(8), parameter :: clight=299792458d-6    ! frequency in mhz
  !
  ! Local ---
  character(len=132) :: mess
  type (sic_descriptor_t) :: desc
  type (gildas) :: hx, hy, hz, ho, hspe
  type (c_ptr) :: cptr
  real, pointer :: dx(:,:), dy(:,:), dz(:,:)
  real, allocatable, target :: dres(:,:), dspe(:,:,:), dataz(:,:,:)
  logical :: x_image, y_image, z_image, found, rdonly
  logical :: do_spectral, do_spatial
  integer :: i, ier, n, sys_code
  integer(kind=index_length) :: ny, my, nz, mz, nd, np, iblank
  integer(kind=address_length) :: addr
  real :: fact, zfact, yfact
  logical :: dy_allocated, dz_allocated
  integer :: sever
  !
  ! Code ----
  error = .true.
  !
  n = len_trim(namez)
  if (n.eq.0) return
  n = len_trim(namex)
  if (n.eq.0) return
  n = len_trim(namey)
  if (n.eq.0) return
  error = .false.
  !
  z_image = .false.
  call sub_readhead (rname,namez,hz,z_image,error,rdonly,fmt_r4)
  if (error) return
  !
  y_image = .false.
  call sub_readhead (rname,namey,hy,y_image,error,rdonly,fmt_r4)
  if (error) return  
  !
  if (hz%gil%eval.ge.0.0) hz%gil%eval =   &
    max(hz%gil%eval,abs(hz%gil%bval*1e-7))
  if (hy%gil%eval.ge.0.0) hy%gil%eval =   &
    max(hy%gil%eval,abs(hy%gil%bval*1e-7))
  !
  ! Check input dimensions & spectral axis
  do_spatial = .false.
  do_spectral = .false.
  if ( (hy%gil%dim(1).ne.hz%gil%dim(1)) .or. &
    & (hy%gil%dim(2).ne.hz%gil%dim(2)) ) then
    if (resample) then
      call map_message(seve%w,rname,'Reprojecting 2nd image on 1st one grid')
      do_spatial = .true.
    else
      call map_message(seve%e,rname,'Input images are non coincident')
      error = .true.
    endif
  endif
  if (hy%gil%dim(3).ne.hz%gil%dim(3)) then
    if (hz%gil%dim(3).eq.1) then
      call map_message(seve%i,rname,'Combining a cube with a plane')
    else
      write(mess,'(A,I0,A,I0)') 'Cubes have different channel numbers: ',hy%gil%dim(3),' and ',HZ%gil%dim(3)
      if (resample) then
        do_spectral = .true.
        sever = seve%w
      else
        error = .true.
        sever = seve%e
      endif
      call map_message(sever,rname,mess)
    endif
  endif
  if (hz%gil%dim(3).ne.1) then
    if ((hy%gil%faxi.ne.0).or.(hz%gil%faxi.ne.0)) then
      !
      ! Ignore Frequency issues - Just base on Velocity sampling
      hz%gil%freq = hy%gil%freq
      hz%gil%fres = -hz%gil%vres * clight / hz%gil%freq * 1d-3
      call spectrum_consistency(rname,hy,hz,tole,error)
      if (resample.and.error) then
        do_spectral = .true.
        call map_message(seve%w,rname,'Cubes have different velocity axis')
        error = .false.
      endif
    endif
  endif
  if (error) return
  if (do_spectral) then
    call map_message(seve%w,rname,'Spectral resampling needed, but still under tests',seve%e)
  endif
  !
  ! Test also the Output
  call gildas_null(hx)
  if (index(namex,'.').eq.0) then
    x_image = .true.
    ! This must be an existing SIC Image variable
    rdonly = .false.
    call sub_readhead (rname,namex,hx,x_image,error,rdonly,fmt_r4)
    if (error) return
    !
    ! With a conforming shape with Y slot
    do i=1,max(hx%gil%ndim,hy%gil%ndim)
      if (hy%gil%dim(i).ne.hx%gil%dim(i)) then
        call map_message(seve%e,rname,'Output SIC variable does not match Input data shape')
        error = .true.
        return
      endif
    enddo
  else
    x_image = .false.
  endif
  !
  !
  ! Allocate the arrays if needed. Note that the allocated arrays do 
  ! not conform to the shape of the images, but are 2-D arrays where
  ! the second dimension is the cube planes.
  !
  nz = hz%gil%dim(1)*hz%gil%dim(2)
  ny = hy%gil%dim(1)*hy%gil%dim(2)
  mz = max(hz%gil%dim(3),1)
  my = max(hy%gil%dim(3),1)
  !
  ! Get the Y data pointer
  dy_allocated = .false.
  if (y_image) then
    call adtoad(hy%loca%addr,cptr,1)
    call c_f_pointer(cptr,dy,[ny,my])
  else
    allocate(dy(ny,my),stat=ier)
    if (ier.ne.0) then
      call map_message(seve%e,rname,'Y Memory allocation error')
      error = .true.
      return
    endif
    call map_message(seve%i,rname,'Reading '//trim(hy%file))
    call gdf_read_data(hy,dy,error)
    call gdf_close_image(hy,error) ! I do not need it anymore
    dy_allocated = .true.
  endif
  !
  ! Get the Z data pointer
  dz_allocated = .false.
  !
  ! Spectral resampling of second image if needed
  if (do_spectral) then
    if ((hy%gil%faxi.eq.0).or.(hz%gil%faxi.eq.0)) then
      call map_message(seve%e,rname,'Images have no Velocity axis')
      error = .true.
      return
    endif
    call gildas_null(hspe)
    call gdf_copy_header(hz,hspe,error)
    !
    ! Read in HSPE - DSPE first
    if (z_image) then
      hspe%loca%addr = hz%loca%addr
      call adtoad(hspe%loca%addr,cptr,1)
      call c_f_pointer(cptr,hspe%r3d,hspe%gil%dim(1:3))
    else
      allocate(dspe(hspe%gil%dim(1),hspe%gil%dim(2),hspe%gil%dim(3)),stat=ier)
      if (ier.ne.0) then
        call map_message(seve%e,rname,'Z Temporary Memory allocation error')
        error = .true.
        return
      endif
      call map_message(seve%i,rname,'Reading '//trim(hz%file))
      call gdf_read_data(hz,dspe,error)
      call gdf_close_image(hz,error) ! I do not need it anymore
      hspe%r3d => dspe
      hspe%loca%addr = locwrd(dspe)
    endif
    !
    ! Allocate DATAZ region and Convert to 3-D buffer
    allocate(dataz(hspe%gil%dim(1),hspe%gil%dim(2),my),stat=ier)
    if (ier.ne.0) then
      call map_message(seve%e,rname,'Z Memory allocation error')
      error = .true.
      return
    endif
    hz%r3d => dataz
    !
    ! Z is the output, SPE the input
    ! HY is only used as a spectral template
    call spectral_resample(rname,hy,hspe,hz,error)
    !
    ! MZ is now equal to MY
    mz = my
    ! Re-affect the DZ pointer to the Z data region
    hz%loca%addr = locwrd(dataz)
    call adtoad(hz%loca%addr,cptr,1)
    call c_f_pointer(cptr,dz,[nz,mz])
    !
    ! Nullify the hz%r3d pointer, and free DSPE scratch data area
    nullify(hz%r3d)
    if (.not.z_image) deallocate(dspe,stat=ier)
    hspe%loca%addr = 0
  else
    if (z_image) then
      call adtoad(hz%loca%addr,cptr,1)
      call c_f_pointer(cptr,dz,[nz,mz])
    else
      allocate(dz(nz,mz),stat=ier)
      if (ier.ne.0) then
        call map_message(seve%e,rname,'Z Memory allocation error')
        error = .true.
        return
      endif
      call map_message(seve%i,rname,'Reading '//trim(hz%file))
      call gdf_read_data(hz,dz,error)
      call gdf_close_image(hz,error) ! I do not need it anymore
      hz%loca%addr = locwrd(dz)
      dz_allocated = .true.
    endif
  endif
  !
  ! Spatial resampling if needed
  if (do_spatial) then
    call gildas_null(ho)
    !!Print *,'HY sizes ', hy%gil%dim(1:3), ' MY ',my, ' NY ',ny
    allocate(dres(ny,my),stat=ier)
    if (ier.ne.0) then
      call map_message(seve%e,rname,'TMP Memory allocation error')
      error = .true.
      if (dy_allocated) deallocate(dy,stat=ier)
      if (dz_allocated) deallocate(dz,stat=ier)
      return
    endif
    !
    call gdf_copy_header(hz,ho,error) ! Copy Basic Header
    !!Print *,"Z unit ",hz%char%unit
    ! Copy new coordinate system and projection
    call s_reproject_init(hz,hy,ho,sys_code,error)
    !!Print *,'Done REPROJECT_INIT '
    !!call gdf_print_header(ho)
    !!Print *,"O unit ",ho%char%unit
    if (relative) then
      hz%gil%a0 = ho%gil%a0
      hz%gil%d0 = ho%gil%d0
    endif
    !
    ! Convert 3-D buffers
    addr = locwrd(dz)
    call adtoad(addr,cptr,1)
    !!Print *,'HZ sizes ', hz%gil%dim(1:3), ' MZ ',mz, ' NZ ',nz
    call c_f_pointer(cptr,hz%r3d,hz%gil%dim(1:3))
    !
    addr = locwrd(dres)
    call adtoad(addr,cptr,1)
    !!Print *,'HO sizes ', ho%gil%dim(1:3), ' MZ ',mz, ' NY ',ny
    !!Print *,'HY sizes ', hy%gil%dim(1:3), ' MY ',my
    call c_f_pointer(cptr,ho%r3d,ho%gil%dim(1:3))
    !
    call s_reproject_do(hz,hz%r3d,ho,ho%r3d,sys_code,error)
    !!Print *,"O unit ",ho%char%unit
    if (dz_allocated) then
      deallocate(dz)
    else
      nullify (dz)
    endif
    call gdf_copy_header(ho,hz,error) ! Copy back modified header
    ! Now point to the right data
    dz => dres    
    ! Reset proper pointer
    addr = locwrd(dres)
    call adtoad(addr,cptr,1)
    call c_f_pointer(cptr,hz%r3d,hz%gil%dim(1:3))
    !
    nz = ny ! In principle NZ is unused after that, though
    dz_allocated = .false.
  endif
  !
  ! Convert to Compatible units...
  call unit_to_k(hz,zfact)
  call unit_to_k(hy,yfact)
  !
  ! Now handle the Output 
  if (x_image) then
    !
    ! OK, they match 
    call adtoad(hx%loca%addr,cptr,1)    
    call c_f_pointer(cptr,dx,[ny,my])
    ! But update the Header locally
    call gdf_copy_header(hy,hx,error)
  else
    ! This is  a file, we must create it
    call gdf_copy_header(hy,hx,error)
    call sic_parsef(namex,hx%file,' ','.gdf')
    hx%gil%extr_words = 0
    hx%gil%blan_words = 2
    allocate(dx(ny,my),stat=ier)
    if (ier.ne.0) then
      call map_message(seve%e,rname,'X Memory allocation error')
      if (dz_allocated) deallocate(dz,stat=ier)
      if (dy_allocated) deallocate(dy,stat=ier)
      error = .true.
      return
    endif
  endif
  !
  ay = ay*yfact
  az = az*zfact
  ! For Spectral index, change Brightness to Flux
  if (code.eq.'INDEX') then
    if (hz%char%unit.eq.'K') then
      ! Flux goes as nu^2
      az = az*(hz%gil%freq/hy%gil%freq)**2
    endif
  endif
  write(mess,*) 'Scaling Y by ',ay,yfact,' and Z by ',az,zfact
  call map_message(seve%i,rname,mess)
  !
  ! Guess a default blanking if not User specified
  if (.not.do_blank) then
    if (hz%gil%eval.ge.0) then
      b = hz%gil%bval
    else if (hy%gil%eval.ge.0) then
      b = hy%gil%bval
    else
      b = 1.2345600E+38
    endif
  endif
  !
  ! Do the actual job
  nd = ny*mz    ! Z size: 1 plane or All
  np = my/mz    ! Number of pseudo-planes
  !
  call map_message(seve%i,rname,'Combining data')
  call sub_combine(hx,hy,hz,     & ! Headers
    & nd,np,                     & ! Sizes
    & dx,dy,dz,                  & ! Data arrays
    & b,iblank,                  & ! Blanking information
    & code,ay,ty,az,tz,c,error)    ! Operation 
  !
  if (allocated(dres)) deallocate(dres,stat=ier)
  !
  ! Spectral Index
  if (code.eq.'INDEX') then
    ! Convert the ratio into a Spectral Index
    !   S   = S_0 (nu/nu0)^alpha
    !   S_z/freq_z^alpha = S_y / freq_y^alpha
    !   S_y/S_z = (freq_y/freq_z)^alpha
    !   log(S_y/S_z) = alpha log(freq_y/freq_z)
    !
    fact = 1.0/log(hy%gil%freq/hz%gil%freq)
    where ((dx.gt.0).and.(dx.ne.b))
      dx = fact*log(dx)
    else where
      dx = b
    end where
    hx%char%unit = 'INDEX'
    call map_message(seve%w,rname,'Spectral Index still under tests')
  endif
  !
  ! Update Blanking if specified
  if (iblank.ne.0) then
    do_blank = .true.
    write(mess,'(A,I0,A,I0,A)') "Found ",iblank," bad values, ",nd*np-iblank," good ones"
    call map_message(seve%i,rname,mess)
    hx%gil%bval = b
    hx%gil%eval = 0.0
  endif
  !
  ! Write ouput file
  if (.not.x_image) then
    call map_message(seve%i,rname,'Writing '//trim(hx%file))
    call gdf_write_image(hx,dx,error)
    ! Deallocating the Memory is required: this is a POINTER not an ALLOCATABLE
    deallocate(dx,stat=ier) 
    !
!NO!    Print *,'Closing Image ' !NO!    call gdf_close_image(hx,error)
  else
    ! Update the original SIC variable header, including Extrema
    error = .false. 
    hx%loca%addr = locwrd(dx)   ! Define the address
    call gdf_get_extrema (hx,error)
    call sic_descriptor(namex,desc,found)
    call gdf_copy_header(hx,desc%head,error)  
  endif
  !
  ! Free the Y and Z Pointer memory areas if Allocated (as for X)
  if (dy_allocated) deallocate(dy,stat=ier)
  if (dz_allocated) deallocate(dz,stat=ier)
  !
end subroutine do_combine
!
subroutine spectral_resample(comm,hy,hi,ho,error)
  use image_def
  use gbl_message
  use imager_interfaces, only : map_message
  !----------------------------------------------------------------------
  ! @ private
  !*
  !   IMAGER -- Support for command COMBINE
  !
  ! Automatic spectral resampling of the data to be combined
  !----------------------------------------------------------------------
  character(len=*), intent(in) :: comm        !! Command name
  type(gildas), intent(in) :: hy              !! Reference cube
  type(gildas), intent(inout) :: hi           !! Cube to be resampled
  type(gildas), intent(inout) :: ho           !! Output cube
  logical, intent(out) :: error               !! Logical Error flag
  !
  ! Constants
  real(8), parameter :: clight=299792458d0
  real(4) :: dv=1.0
  !
  ! Local ---
  integer(kind=index_length) :: ipix1, ipixn, nc, mrange(2)
  real(8) :: oconv(3), iconv(3), pix1, pixn, zref, zinc, zval
  integer, allocatable :: ipi(:,:)
  real, allocatable :: ipr (:,:)
  integer :: ier
  character(len=132) :: chain
  !
  ! Code ----
  error = .false.
  if (.not.associated(ho%r3d)) then
    call map_message(seve%e,comm,'HO%R3D is not associated')
    error = .true.
  endif
  if (.not.associated(hi%r3d)) then
    call map_message(seve%e,comm,'HZ%R3D is not associated')
    error = .true.
  endif
  if (error) return
  !
  if (hy%gil%faxi.ne.0) then
    if (abs(hi%gil%freq-hy%gil%freq).gt.1d-5) then  !10 Hz tolerance
      write(chain,'(A,F15.6,A,F15.6,A)') 'Rest frequency of 1st image ', &
      & hy%gil%freq,' does not match that of 2nd ',hi%gil%freq
      call map_message(seve%w,comm,chain)
    endif
    nc = hy%gil%dim(hy%gil%faxi)             ! For Data cubes
    oconv = hy%gil%convert(:,hy%gil%faxi)
    oconv(2) = hy%gil%voff
    oconv(3) = hy%gil%vres
  else
    call map_message(seve%e,comm,'Reference image has no Velocity axis')
    error = .true.
    return
  endif
  !
  ! oconv(3) is initially on a Velocity Scale.
  ho%gil%voff = oconv(2)
  ho%gil%vres = oconv(3)
  ho%gil%fres = - ho%gil%vres * 1d3 / clight * ho%gil%freq
  ho%gil%convert(:,3) = oconv
  ho%gil%dim(3) = nc
  !
  iconv = hi%gil%convert(:,3)   ! Save Frequency/Velocity axis
  zref = hi%gil%ref(3)
  zinc = hi%gil%vres
  zval = hi%gil%voff
  hi%gil%convert(:,3) = [zref,zval,zinc]
  !
  ! Check limits
  pix1 = ho%gil%ref(3) + ( zval+ (1.d0-zref)*zinc - ho%gil%val(3) )/ho%gil%inc(3)
  pixn = ho%gil%ref(3) + ( zval+ (hi%gil%dim(3)-zref)*zinc - ho%gil%val(3) )/ho%gil%inc(3)
  if (pix1.lt.pixn) then
    ipix1 = int(pix1)
    if (ipix1.ne.pix1) ipix1 = ipix1+1
    ipix1 = max(ipix1,1)
    ipixn = min(int(pixn),ho%gil%dim(3))
  else
    ipixn = min(int(pix1),ho%gil%dim(3))
    ipix1 = int(pixn)
    if (ipix1.ne.pixn) ipix1 = ipix1+1
    ipix1 = max(ipix1,1)
  endif
  !
  allocate (ipi(2,ho%gil%dim(3)), ipr(4,ho%gil%dim(3)), stat=ier)
  !
  mrange(1) = ipix1
  mrange(2) = ipixn
  !
  call map_operation('MAP_RESAMPLE',ho,ho%r3d,hi,hi%r3d,mrange,dv)
  !
  ! Restore Frequency/Velocity Axis
  hi%gil%convert(:,3) = iconv
end subroutine spectral_resample
!
subroutine sub_combine(hx,hy,hz,n,m,dx,dy,dz,b,iblank,code,ay,ty,az,tz,c,error)
  use gkernel_types
  !----------------------------------------------------------------------
  !*
  ! IMAGER  -- Support routine for commands  
  ! COMBINE Out CODE In1 In2 /FACTOR A1 A2 /THRESHOLD T1 T2 /BLANK Bval
  !!
  !----------------------------------------------------------------------
  character(len=*), intent(inout) :: code    !! Combination code
  integer(kind=index_length), intent(in) :: n  !! Size of image
  integer(kind=index_length), intent(in) :: m  !! Number of channels
  type(gildas), intent(inout) :: hx    !! Output header
  type(gildas), intent(in) :: hy    !! Input Cube header
  type(gildas), intent(in) :: hz    !! Input Cube or Plane header
  !
  real, intent(in) :: dx(n,m)       !! Output data
  real, intent(in) :: dy(n,m)       !! Input data
  real, intent(in) :: dz(n)         !! Input data
  real, intent(in) :: c             !! Offset
  real, intent(in) :: ay            !! Y Factor
  real, intent(in) :: ty            !! Y Threshold
  real, intent(in) :: az            !! Z Factor
  real, intent(in) :: tz            !! Z Threshold
  real, intent(in) :: b  !! Output blanking
  integer(kind=index_length), intent(inout) :: iblank  !! Number of blanked pixels
  logical, intent(out) :: error  ! Logical error flag
  !
  error = .false.
  hx%gil%bval = b
  select case(code)
  case ('ADD','PLUS') 
    call add002(dz,dy,dx,   &
      n,m,   &
      hz%gil%bval,hz%gil%eval,az,tz,   &
      hy%gil%bval,hy%gil%eval,ay,ty,   &
      hx%gil%bval,c,iblank)
  case ('DIVIDE','OVER','INDEX')
    hx%char%unit = 'RATIO'
    call div002(dz,dy,dx,   &
      n,m,   &
      hz%gil%bval,hz%gil%eval,az,tz,   &
      hy%gil%bval,hy%gil%eval,ay,ty,   &
      hx%gil%bval,c,iblank)
  case ('MULTIPLY','TIMES') 
    call mul002(dz,dy,dx,   &
      n,m,   &
      hz%gil%bval,hz%gil%eval,az,tz,   &
      hy%gil%bval,hy%gil%eval,ay,ty,   &
      hx%gil%bval,c,iblank)
  case ('OPTICAL_DEPTH') 
    hx%char%unit = 'OPACITY'
    call opt002(dz,dy,dx,   &
      n,m,   &
      hz%gil%bval,hz%gil%eval,az,tz,   &
      hy%gil%bval,hy%gil%eval,ay,ty,   &
      hx%gil%bval,c,iblank)
  case default
    Print *,code//' not available'
    error = .true.
    return
  end select
  !
end subroutine sub_combine
!
subroutine add002(z,y,x,n,m,bz,ez,az,tz,by,ey,ay,ty,bx,c,iblank)
  !$ use omp_lib
  use gkernel_types
  !---------------------------------------------------------------------
  !! GDF  -- Internal routine  
  !!    Linear combination of input arrays  
  !!  X = Ay*Y + Az*Z + C 
  !---------------------------------------------------------------------
  integer(kind=index_length), intent(in) :: n
  integer(kind=index_length), intent(in) :: m
  real :: z(n)                      !! Plane array
  real :: y(n,m)                    !! Input Cube
  real :: x(n,m)                    !! Output Cube
  real :: bz                        !! Z Blanking value
  real :: ez                        !! Z Tolerance on blanking
  real :: az                        !! Z factor
  real :: tz                        !! Z threshold
  real :: by                        !! Y Blanking value
  real :: ey                        !! Y Tolerance on blanking
  real :: ay                        !! Y factor
  real :: ty                        !! Y Threshold
  real :: bx                        !! X Blanking
  real :: c                         !! Constant Offset
  integer(kind=index_length), intent(inout) :: iblank !! Number of bad pixels
  !
  ! Local ---
  integer(kind=index_length) :: i,k
  integer(kind=index_length) :: zb,zl,yb,yl
  !
  ! Code ----
  iblank = 0
  zb = 0
  yb = 0
  zl = 0
  yl = 0
  !
  !$OMP PARALLEL DEFAULT(none)                    &
  !$OMP SHARED (z,x,y, bz,ez,by,ey,tz,ty,az,ay,bx,c) &
  !$OMP SHARED (n,m) PRIVATE (i,k) &
  !$OMP REDUCTION (+:zb,yb,zl,yl)
  !$OMP DO
  do k=1,m
    do i=1,n
      if (abs(z(i)-bz).le.ez) then
        zb = zb+1
        x(i,k) = bx
      else if (abs(y(i,k)-by).le.ey) then
        yb = yb+1
        x(i,k) = bx
      else if (z(i).lt.tz) then
        zl = zl+1
        x(i,k) = bx
      else if (y(i,k).lt.ty) then
        yl = yl+1
        x(i,k) = bx
      else
        x(i,k) = ay*y(i,k) + az*z(i)  +  c
      endif
    enddo
  enddo
  !$OMP END DO
  !$OMP END PARALLEL
  iblank = zb+yb+zl+yl
  !TEST!Print *,'Zbad ',zb,' Ybad ',yb,' Zlow ',zl,' Ylow ',yl
end subroutine add002
!
subroutine div002(z,y,x,n,m,bz,ez,az,tz,by,ey,ay,ty,bx,c,iblank)
  !$ use omp_lib
  use gkernel_types
  !---------------------------------------------------------------------
  !! GDF  -- Internal routine
  !!    Division of 2 input arrays  
  !!  X = Ay*Y / Az*Z + C  
  !---------------------------------------------------------------------
  integer(kind=index_length), intent(in) :: n
  integer(kind=index_length), intent(in) :: m
  real :: z(n)                      !! Plane array
  real :: y(n,m)                    !! Input Cube
  real :: x(n,m)                    !! Output Cube
  real :: bz                        !! Z Blanking value
  real :: ez                        !! Z Tolerance on blanking
  real :: az                        !! Z factor
  real :: tz                        !! Z threshold
  real :: by                        !! Y Blanking value
  real :: ey                        !! Y Tolerance on blanking
  real :: ay                        !! Y factor
  real :: ty                        !! Y Threshold
  real :: bx                        !! X Blanking
  real :: c                         !! Constant Offset
  integer(kind=index_length), intent(inout) :: iblank !! Number of bad pixels
  !
  ! Local ---
  integer(kind=index_length) :: i,k
  integer(kind=index_length) :: zb,zl,yb,yl
  real :: ayz
  !
  ! Code ----
  ayz = ay/az
  iblank = 0
  zb = 0
  yb = 0
  zl = 0
  yl = 0
  !$OMP PARALLEL DEFAULT(none)                    &
  !$OMP SHARED (z,x,y, bz,ez,by,ey,tz,ty,ayz,bx,c) &
  !$OMP SHARED (n,m) PRIVATE (i,k) & 
  !$OMP REDUCTION (+:zb,zl,yb,yl)
  !$OMP DO
  do k=1,m
    do i=1,n
      if (abs(z(i)-bz).le.ez) then
        zb = zb+1
        x(i,k) = bx
      else if (abs(y(i,k)-by).le.ey) then
        yb = yb+1
        x(i,k) = bx
      else if (z(i).lt.tz) then
        zl = zl+1
        x(i,k) = bx
      else if (y(i,k).lt.ty) then
        yl = yl+1
        x(i,k) = bx
      else
        x(i,k) = ayz * y(i,k) / z(i)  +  c
      endif
    enddo
  enddo
  !$OMP END DO
  !$OMP END PARALLEL
  iblank = zb+yb+zl+yl
end subroutine div002
!
subroutine mul002(z,y,x,n,m,bz,ez,az,tz,by,ey,ay,ty,bx,c,iblank)
  !$ use omp_lib
  use gkernel_types
  !---------------------------------------------------------------------
  !! GDF  -- Internal routine  
  !!  Multiplication of input arrays  
  !!  X = Ay*Y * Az*Z + C
  !---------------------------------------------------------------------
  integer(kind=index_length), intent(in) :: n
  integer(kind=index_length), intent(in) :: m
  real :: z(n)                      !! Plane array
  real :: y(n,m)                    !! Input Cube
  real :: x(n,m)                    !! Output Cube
  real :: bz                        !! Z Blanking value
  real :: ez                        !! Z Tolerance on blanking
  real :: az                        !! Z factor
  real :: tz                        !! Z threshold
  real :: by                        !! Y Blanking value
  real :: ey                        !! Y Tolerance on blanking
  real :: ay                        !! Y factor
  real :: ty                        !! Y Threshold
  real :: bx                        !! X Blanking
  real :: c                         !! Constant Offset
  integer(kind=index_length), intent(inout) :: iblank !! Number of bad pixels
  !
  ! Local ---
  integer(kind=index_length) :: i,k
  integer(kind=index_length) :: zb,zl,yb,yl
  real :: ayz
  !
  ! Code ----
  ayz = ay*az
  iblank = 0
  zb = 0
  yb = 0
  zl = 0
  yl = 0
  !$OMP PARALLEL DEFAULT(none)                    &
  !$OMP SHARED (z,x,y, bz,ez,by,ey,tz,ty,ayz,bx,c) &
  !$OMP SHARED (n,m) PRIVATE (i,k) &
  !$OMP REDUCTION (+:zb,zl,yb,yl)
  !$OMP DO
  do k=1,m
    do i=1,n
      if (abs(z(i)-bz).le.ez) then
        zb = zb+1
        x(i,k) = bx
      else if (abs(y(i,k)-by).le.ey) then
        yb = yb+1
        x(i,k) = bx
      else if (z(i).lt.tz) then
        zl = zl+1
        x(i,k) = bx
      else if (y(i,k).lt.ty) then
        yl = yl+1
        x(i,k) = bx
      else
        x(i,k) = ayz * z(i) * y(i,k) +  c
      endif
    enddo
  enddo
  !$OMP END DO
  !$OMP END PARALLEL
  iblank = zb+yb+zl+yl
end subroutine mul002
!
subroutine opt002(z,y,x,n,m,bz,ez,az,tz,by,ey,ay,ty,bx,c,iblank)
  !$ use omp_lib
  use gkernel_types
  !---------------------------------------------------------------------
  !! GDF -- Internal routine  
  !!  Optical depth from input arrays  
  !!  X = - LOG ( Ay*Y / Az*Z + C )  
  !---------------------------------------------------------------------
  integer(kind=index_length), intent(in) :: n
  integer(kind=index_length), intent(in) :: m
  real :: z(n)                      !! Plane array
  real :: y(n,m)                    !! Input Cube
  real :: x(n,m)                    !! Output Cube
  real :: bz                        !! Z Blanking value
  real :: ez                        !! Z Tolerance on blanking
  real :: az                        !! Z factor
  real :: tz                        !! Z threshold
  real :: by                        !! Y Blanking value
  real :: ey                        !! Y Tolerance on blanking
  real :: ay                        !! Y factor
  real :: ty                        !! Y Threshold
  real :: bx                        !! X Blanking
  real :: c                         !! Constant Offset
  integer(kind=index_length), intent(inout) :: iblank !! Number of bad pixels
  !
  ! Local ---
  real :: v
  integer(kind=index_length) :: i,k
  integer(kind=index_length) :: zb,zl,yb,yl
  real :: ayz
  !
  ! Code ----
  ayz = ay/az
  iblank = 0
  zb = 0
  yb = 0
  zl = 0
  yl = 0
  !$OMP PARALLEL DEFAULT(none)                    &
  !$OMP SHARED (z,x,y, bz,ez,by,ey,tz,ty,ayz,bx,c) &
  !$OMP SHARED (n,m) PRIVATE (i,k,v) &
  !$OMP REDUCTION (+:iblank,zb,zl,yb,yl)
  !$OMP DO
  do k=1,m
    do i=1,n
      if (abs(z(i)-bz).le.ez) then
        zb = zb+1
        x(i,k) = bx
      else if (abs(y(i,k)-by).le.ey) then
        yb = yb+1
        x(i,k) = bx
      else if (z(i).lt.tz) then
        zl = zl+1
        x(i,k) = bx
      else if (y(i,k).lt.ty) then
        yl = yl+1
        x(i,k) = bx
      else
        v = ayz * y(i,k) / z(i)  +  c
        if (v.gt.0.0) then
          x(i,k) = - log( v )
        else
          x(i,k) = bx
          iblank = iblank+1
        endif
      endif
    enddo
  enddo
  !$OMP END DO
  !$OMP END PARALLEL
  iblank = iblank+zb+yb+zl+yl
end subroutine opt002
!
subroutine sub_readhead(rname,namez,hz,z_image,error,rdonly,fmt,type)
  use gkernel_types
  use gkernel_interfaces
  use gbl_message
  use imager_interfaces, only : map_message
  !---------------------------------------------------------------------
  ! @ private-mandatory
  !*
  !     IMAGER -- Utility routine  
  !   Return the Header of a GILDAS File or SIC Image variable
  !!
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: rname     !! Caller name
  character(len=*), intent(in) :: namez     !! Name of File or Variable
  type(gildas), intent(out) :: hz           !! GILDAS Header
  logical, intent(inout) :: z_image         !! Is it a SIC image variable ?
  logical, intent(out) :: error             !! Error flag
  logical, intent(out), optional :: rdonly  !! Ask for ReadOnly status
  integer, intent(in), optional :: fmt      !! Required format
  character(len=*), intent(in), optional :: type   !! File extension
  !
  ! Local ---
  logical :: found
  type (sic_descriptor_t) :: desc
  integer :: i
  character(len=16) :: atype
  !
  ! Code ----
  !
  ! Search if any SIC variable like this one...
  call sic_descriptor(namez,desc,found)
  if (found) then
    if (.not.associated(desc%head)) then
      call map_message(seve%e,rname,  &
        'Variable '//trim(namez)//' does not provide a header')
      found = .false.
    else if (present(fmt)) then
      if (desc%type.ne.fmt) then
        call map_message(seve%e,rname,  &
          'Variable '//trim(namez)//' is of wrong type')
        found = .false.
      endif
    endif
    if (found) then
      if (abs(desc%head%gil%type_gdf) .eq. code_gdf_uvt) then
        call gildas_null(hz,type='UVT')
      else
        call gildas_null(hz)
      endif
      call gdf_copy_header(desc%head,hz,error)
      if (error) return
      hz%loca%addr = desc%addr
      z_image = .true.
      if (present(rdonly)) rdonly = desc%readonly
      ! Reset Size in the HEADER also
      hz%gil%ndim = desc%ndim
      hz%gil%dim = 1
      hz%loca%size = 1
      do i=1,hz%gil%ndim
        hz%gil%dim(i) = desc%dims(i)
        hz%loca%size = hz%loca%size * hz%gil%dim(i)
      enddo
    endif
  endif
  !
  ! If not, fall back on File, unless Image mode is specified
  if (.not.found) then
    if (z_image) then
      call map_message(seve%e,rname, 'No such Variable '//trim(namez))
      error = .true.
      return
    else
      if (present(type)) then
        atype = type
      else
        atype = '.gdf'
      endif
      !
      call sic_parse_file(namez,' ',atype,hz%file)
      call gdf_read_header(hz,error)
      if (error) then
        call map_message(seve%e,rname,'Cannot read input file '//trim(hz%file))
        return
      endif
    endif
  endif
end subroutine sub_readhead
!
subroutine unit_to_k(hin,fact)
  use image_def
  ! @ private
  !*
  !   IMAGER -- Utility routine
  !     Get the Unit to Kelvin conversion factor - Returns 1 if none.
  !!
  type(gildas), intent(inout) :: hin  !! Gildas header
  real, intent(out) :: fact           !! Conversion factor
  !
  character(len=12) :: unit
  real :: beam, lambda, jyperk
  !
  unit = hin%char%unit
  call sic_upper(unit)
  !
  select case (unit)
  case ('JY/BEAM')
    call get_jyperk(hin,beam,jyperk)
    if (jyperk.eq.0) then
      fact = 1.0
    else
      lambda = 2.99792458e8/hin%gil%freq*1e-6
      fact = 1.0/jyperk
      hin%char%unit = 'K'
    endif
  case ('JY/PIXEL')
    beam = abs(hin%gil%inc(1)*hin%gil%inc(2))
    lambda = 2.99792458e8/hin%gil%freq*1e-6
    jyperk = 2.0*1.38023e3*beam/lambda**2.
    fact = 1.0/jyperk
    hin%char%unit = 'K'
  case ('MJY/STERADIA','MJY/SR')
    beam = 1.0
    lambda = 2.99792458e8/hin%gil%freq*1e-6
    jyperk = 2.0*1.38023e3*beam/lambda**2.
    fact = 1.0E6/jyperk
    hin%char%unit = 'K'
  case ('K')
    fact = 1.0
  case default
    fact = 1.0
  end select
end subroutine unit_to_k

!*
! Support for UV_PREVIEW
!
! The algorithm is a bit complex.
!
! 1) For each TAPER and each SMOOTH number, compute the
!     corresponding spectrum  
! 2) Apply a Sigma-Clipping method to clip channels with line emission
!     Caveat: this is based on deviation from a median, no 
!       linear baseline is removed in this process  
! 3) Take the union of all line emitting channels
! 4) Identify contiguous ranges  
!     - guess typical line half-width by mean of initial window widths  
!     - concatenate adjacent windows if their separation is below
!       the typical half-width  
!     - expand each resulting window by its half-width or at 
!       least by the mean half-width. (Ensure at this stage...)
! 5) Build a list of final "line" channels (1 Line, 0 Continuum)
!
!!   
subroutine uv_preview(line,error)
  use image_def
  use gkernel_interfaces
  use gkernel_types
  use imager_interfaces, except_this => uv_preview
  use gbl_message
  use clean_arrays
  use preview_mod
  !---------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER  --  Support for command
  !   UV_PREVIEW  [TAPER Ntaper] [THRESHOLD Threshold] [HISTO Nhisto] [
  !     SMOOTH Nsmooth] [/BROWSE] [/FILE UvData.uvt [Drop]]
  !!
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: line  !! Command line 
  logical, intent(inout) :: error       !! Error flag
  !
  ! Constans
  character(len=*), parameter :: rname='UV_PREVIEW'
  integer, parameter :: o_file=2
  integer, parameter :: o_browse=1
  !
  ! Local ---
  type(gildas) :: hfile
  integer :: n, ntaper
  character(len=filename_length) :: name
  character(len=16) :: chainbrowse, argum
  logical :: do_insert, do_browse, do_file, an_error
  !
  do_browse = sic_present(o_browse,0) 
  if (do_browse) then
    if (sic_narg(o_browse).ne.0) then  
      call sic_i4(line,o_browse,1,ntaper,.false.,error)
      write(chainbrowse,'(A,I0)') '@ p_browse ',ntaper
    else
      chainbrowse = '@ p_browse'
    endif
  endif
  do_file   = sic_present(o_file,0)
  do_insert = sic_lire().eq.0
  !
  if (do_browse.and.(sic_narg(0).eq.0)) then
    ! UV_PREVIEW /BROWSE
    !   Just replay the existing spectrum if any
    if (number_of_channels.gt.0) then
      if (number_of_channels.lt.64) then      
        call map_message(seve%w,rname,'Too few channels')
        call exec_program('@ uv_preview') 
        if (number_of_channels.ge.1) call exec_program('@ preview_lines')   
      else
        call exec_program(chainbrowse)
      endif
      if (do_insert) call sic_insert_log(line)
      return
    endif
    ! If not, do the full Job
  endif
  !
  if (sic_narg(0).eq.1) then
    call sic_ke(line,0,1,argum,n,.true.,error)
    if (argum.eq.'?') then
      write(*,'(A)') "UV_PREVIEW current control parameters:"
      write(*,'(A,I5,A)')    "     TAPER  ",utaper,  "   (number of UV tapers)"
      write(*,'(A,I5,A)')    "     SMOOTH ",usmooth, "   (number of spectral kernels)"
      write(*,'(A,F5.2,A)')  "     CLIP   ",uclip,   "   (Clipping threshold)"
      if (uhist.eq.0) then
        write(*,'(A,I5,A)')  "     HISTO  ",uhist,   "   (Automatic Histogram Size)"
      else
        write(*,'(A,I5,A)')  "     HISTO  ",uhist,   "   (Histogram Size)"
      endif
      write(*,'(A)') 'Use command "UV_PREVIEW KEY Value" to change any of these'
      return
    endif
  endif
  !
  error = .false.
  call sic_delvariable('PREVIEW',.false.,error)
  error = .false.
  call sic_delvariable('SPECTRUM',.false.,error)
  error = .false.
  call sic_delvariable('CLIPPED',.false.,error)
  error = .false.
  call sic_delvariable('CHANNEL_LIST',.false.,error)
  error = .false.
  !
  if (sic_present(o_file,0)) then
    ! /FILE option
    call gildas_null(hfile,type='UVT')
    call sic_ch(line,o_file,1,name,n,.true.,error)
    if (error) return
    call sic_parse_file(name,' ','.uvt',hfile%file)
    !
    call gdf_read_header(hfile,error)
    if (error) return
    hfile%loca%size = 0
    !
    call uv_preview_sub(hfile,line,error)
    !
    call gdf_close_image(hfile,an_error)
  else
    if (huv_current%loca%size.eq.0) then
      call map_message(seve%e,rname,'No UV data loaded')
      error = .true.
      return
    endif
    huv_current%r2d => duv    ! SG Should already be true
    call uv_preview_sub(huv_current,line,error)
  endif
  !
  if (error) return
  !
  call exec_program('@ uv_preview') 
  if (number_of_channels.ge.1) call exec_program('@ preview_lines') 
  do_browse = do_browse.and.(number_of_channels.ge.64)
  if (do_browse) call exec_program(chainbrowse)   
  !
  if (do_insert) call sic_insert_log(line)
  !
end subroutine uv_preview
!
subroutine uv_preview_sub (huvl,line,error)
  use image_def
  use gkernel_interfaces
  use gkernel_types 
  use imager_interfaces, except_this => uv_preview_sub
  use gbl_message
  use preview_mod
  !$ use omp_lib
  !---------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- Support for command  
  !   UV_PREVIEW  [TAPER Ntaper] [THRESHOLD Threshold] [HISTO Nhisto] 
  !     [SMOOTH Nsmooth] [/BROWSE] [/FILE UvData.uvt [Drop]]
  !!
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: line  !! Command line
  logical, intent(inout) :: error       !! Error flag
  type(gildas), intent(inout) :: huvl    !! Input UV data set
  !
  ! Constants
  character(len=*), parameter :: rname='UV_PREVIEW'
  integer, parameter :: o_file=2
  integer, parameter :: mtaper=4
  integer, parameter :: mmode=6
  character(len=8) :: smode(mmode), mode, argum
  data smode /'TAPER','CLIP','HISTO','SMOOTH','NOFILTER','ONLY'/
  real, save :: mu=3.0    ! Rejection threshold
  !
  ! Local ---
  character(len=message_length) :: mess
  integer(kind=4) :: ntaper
  integer(kind=index_length) :: nvisi, nchan
  integer(kind=index_length) :: nhist, mhist, lc
  integer :: it,jc,kc,jv,kr,kw,ier,n,narg
  real :: ww, rr, uvmin, uvmax, blank, rms
  real :: tapermin, tapermax, tapercurrent, taperfactor
  integer :: ib,nb,ksum, fchan, lchan
  real :: vtaper(mtaper)
  real, allocatable :: wall(:), wreal(:), wplus(:)
  real, allocatable :: weights(:,:), poids(:,:,:), spec(:,:,:)
  real, pointer :: uvdata(:,:)  ! Pointer to UV data subset
  integer, allocatable :: kplus(:)
  integer, allocatable :: mylines(:), idx(:)
  integer :: mvisi
  integer :: nt
  integer :: ithread, nthread
  real :: clip_value, correlation_factor, rmsdiff, rmstheo 
  real :: amed, amin, amax, arms, noise_ratio, ctaper
  logical :: debug=.false.
  logical :: view_only
  real :: fraction
  !
  ! EDGE_FREQUENCIES
  real(kind=8) :: tmp 
  real :: ldrop
  integer :: i, nlines, inb, iextent
  integer(kind=index_length) :: dim(4)
  !
  ! Channel smmothing factors
  integer :: is, msmooth
  integer :: nsmooth(4)
  real, allocatable :: smarray(:)
  real :: weight
  !
  ! Code ----
  call sic_get_logi('DEBUG_PREVIEW',debug,error)
  error = .false.
  !
  nsmooth(:) = [1,4,16,32] 
  view_only = .false.
  !
  if (associated(htab%r2d)) deallocate(htab%r2d)
  if (associated(hclip%r2d)) deallocate(hclip%r2d)
  if (allocated(final_lines)) deallocate(final_lines)
  if (allocated(edge_freq)) deallocate(edge_freq)
  if (allocated(edge_chan)) deallocate(edge_chan)
  call gildas_null(hclip)
  call gildas_null(htab)
  !
  nvisi = huvl%gil%nvisi
  !
  ! Reload previous control values
  ntaper = utaper
  clip_value = uclip
  uhist = 0
  msmooth = usmooth   
  !
  narg = sic_narg(0)
  do i=1,narg,2
    call sic_ke(line,0,i,argum,n,.true.,error)
    call sic_ambigs (rname,argum,mode,n,smode,mmode,error)
    if (error) return
    select case(mode)
    case ('TAPER')            
      call sic_i4(line,0,i+1,ntaper,.false.,error)
      if (error) return
      if (ntaper.lt.1 .or. ntaper.gt.mtaper) then
        call map_message(seve%e,rname,'Number of tapers out of range 1-4')
        error = .true.
        return
      endif
      utaper = ntaper
    case ('CLIP')
      call sic_r4(line,0,i+1,clip_value,.false.,error)
      if (error) return
      if (clip_value.lt.1.0 .or. clip_value.gt.7.0) then
        call map_message(seve%e,rname,'Clipping value outside of recommended [1-7] range')
        error = .true.
        return
      endif
      uclip = clip_value
    case ('HISTO')
      call sic_i4(line,0,i+1,uhist,.false.,error)
      if (error) return
      if (uhist.lt.8) then
        call map_message(seve%e,rname,'Histogram size too small')
        error = .true.
        return
      endif
    case ('SMOOTH') 
      call sic_i4(line,0,i+1,msmooth,.false.,error)
      if (error) return
      if (msmooth.lt.1 .or. msmooth.gt.4) then
        call map_message(seve%e,rname,'Number of smoothing kernels not in range [1,4]')
        error = .true.
        return
      endif
      usmooth = msmooth
    case ('NOFILTER','ONLY')
      view_only = .true.
    end select
  enddo 
  !
  fchan = 1
  lchan = huvl%gil%nchan
  if (huvl%loca%size.eq.0 .and. lchan.gt.80) then 
    ldrop = 5
    call sic_r4(line,o_file,2,ldrop,.false.,error)
    if (error) return
    fraction = 0.1
    call sic_r4(line,o_file,3,fraction,.false.,error)
    ldrop = min(100.,max(0.,ldrop))*0.01
    ! Drop 5 % at each edge for files
    fchan = nint(ldrop*huvl%gil%nchan)
    lchan = nint((1.-ldrop)*huvl%gil%nchan)
  endif
  !
  ! If UV_CHECK BEAM has been used, 
  ! restrict the range to the most significant (bad edge recognition)
  call channel_restrict(rname,fchan,lchan,error)
  write(mess,'(A,I0,A,I0,A)') 'Selecting channel range [',fchan,',',lchan,']'
  call map_message(seve%i,rname,mess)
  !
  fchan = fchan-1          ! Offset for channel numbers from here
  nchan = lchan-fchan
  !
  ! Default histogram size (after NCHAN definition)
  mhist = max(8,nint(sqrt(real(nchan))))
  nhist = max(8,mhist)
  !
  if (uhist.ne.0) nhist = uhist
  !
  if (view_only) then
    write(mess,'(A,I0,A)') 'No filtering, Display only'
    call map_message(seve%i,rname,mess,seve%w)
    nhist = 1
    msmooth = 1
  else if (nchan.le.32) then
    write(mess,'(A,I0,A)') 'Too few channels [',nchan,'], display only'
    call map_message(seve%w,rname,mess,seve%w)
    nhist = 1
    msmooth = 1
  else if (nhist.lt.8) then
    write(mess,'(A,I0,A,I0,A)') 'Histogram size ',nhist,' out of recommended range [8-',mhist,']'
    call map_message(seve%e,rname,mess)
    error = .true.
    return
  else if (nhist.gt.mhist)  then
    write(mess,'(A,I0,A,I0,A)') 'Histogram size ',nhist,' out of recommended range [8-',mhist,']'
    call map_message(seve%w,rname,mess,seve%w)
  endif
  if (nchan.lt.64) msmooth = min(3,msmooth) ! Do not smooth too much if few channels.
  ! 
  call gildas_null(htab)
  call gdf_copy_header(huvl,htab,error)
  !
  htab%gil%ndim = 2
  htab%gil%dim(1) = nchan
  htab%gil%dim(2) = ntaper+2
  !
  allocate(htab%r2d(nchan,ntaper+2),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'HTAB Memory allocation error')
    error = .true.
    return
  endif
  allocate(wplus(ntaper),kplus(ntaper),wall(ntaper),wreal(nchan),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'Taper Memory allocation error')
    error = .true.
    return
  endif
  !
  ! Define the Tapers here
  if (huvl%loca%size.ne.0) then
    if (huvl%gil%basemax.eq.0 .or. huvl%gil%basemin.eq.0) then
      uvmax = 0.0
      uvmin = 1e36
      do jv=1,huvl%gil%nvisi
        ww = huvl%r2d(1,jv)**2 + huvl%r2d(2,jv)**2 
        if (ww.gt.0.0) then
          uvmax = max(uvmax,ww)
          uvmin = min(uvmin,ww)
        endif
      enddo
      if (uvmin.gt.uvmax) uvmin = uvmax
      huvl%gil%basemax = sqrt(uvmax)
      huvl%gil%basemin = sqrt(uvmin)
    endif
    tapermax = huvl%gil%basemax
    if (huvl%gil%nteles.ge.1) then
      tapermin = 3*max(huvl%gil%teles(1)%diam,huvl%gil%basemin)
    else
      tapermin = 3*huvl%gil%basemin
    endif
  else if (huvl%gil%basemax.eq.0) then
    call map_message(seve%w,rname,'No Baseline extrema, can only guess tapers')
    tapermax = 1000.0
    tapermin = 45.0
  else
    tapermax = huvl%gil%basemax
    if (huvl%gil%nteles.ge.1) then
      tapermin = 3*max(huvl%gil%teles(1)%diam,huvl%gil%basemin)
    else
      tapermin = 3*huvl%gil%basemin
    endif
  endif
  !
  ! Full range of Tapers is obtained only with Ntaper = Mtaper
  taperfactor = log(tapermax/tapermin)/(mtaper-1)/log(2.0)
  tapercurrent = tapermax
  mess = 'Taper values: [ None'
  nt = len_trim(mess)+1
  !
  vtaper(1) = 0.
  do it=2,ntaper
    tapercurrent = tapercurrent/2.0**taperfactor
    vtaper(it) = tapercurrent
    write(mess(nt:),'(A,F8.1)') ',',tapercurrent
    nt = nt+9
  enddo
  mess(nt:nt)=']'
  call map_message(seve%i,rname,mess(1:nt))
  ! 
  ! Initialize X Axis
  htab%r2d = 0.0
  do jc=1,nchan
    htab%r2d(jc,1) = (jc+fchan-huvl%gil%ref(1))*huvl%gil%vres + huvl%gil%voff
  enddo
  !
  ! Compute various spectra
  !
  ! Header is in Memory, but Data may be on file 
  !
  ! Allocate spaces for each array
  if (huvl%loca%size.eq.0) then
    ! Data is on file and and must be read sequentially
    ! Define blocking factor, on data file
    mvisi = space_nitems('SPACE_IMAGER',huvl,1) ! Visibilities at once
    mvisi = min(mvisi,huvl%gil%dim(2))
    allocate(uvdata(huvl%gil%dim(1),mvisi),stat=ier)
    if (ier.ne.0) then
      write(mess,*) 'UVDATA Memory allocation error ',huvl%gil%dim(1), mvisi
      call map_message(seve%e,rname,mess)
      error = .true.
      return
    endif
  else
    mvisi = huvl%gil%nvisi
    uvdata => huvl%r2d
  endif
  allocate(weights(nchan,ntaper),stat=ier)
  if (ier.ne.0) then
    write(mess,*) 'WEIGHTS Memory allocation error ',huvl%gil%dim(1), mvisi
    call map_message(seve%e,rname,mess)
    error = .true.
    return
  endif
  weights = 0.0
  !
  wplus = 0.
  kplus = 0
  !
  ! Loop on blocks
  nthread = 1
  !$ nthread = omp_get_max_threads()
  allocate(spec(nchan,ntaper,nthread),poids(nchan,ntaper,nthread),stat=ier)
  if (ier.ne.0) then
    write(mess,*) 'Memory allocation error ',nchan,ntaper,nthread
    call map_message(seve%e,rname,mess)
    error = .true.
    return
  endif
  !
  ! Shift the reference channel by Fchan
  htab%gil%ref(1) = htab%gil%ref(1)-fchan
  !
  do ib=1,huvl%gil%nvisi,mvisi
    write(mess,*) ib,' / ',huvl%gil%dim(2),mvisi
    call map_message(seve%i,rname,mess)
    !
    ! Read the data
    huvl%blc(2) = ib
    huvl%trc(2) = min(huvl%gil%nvisi,ib-1+mvisi)
    nvisi = huvl%trc(2)-huvl%blc(2)+1
    !
    if (huvl%loca%size.eq.0) then
      call gdf_read_data(huvl,uvdata,error)
      if (error) return
!    else
!      uvdata => huvl%r2d(:,huvl%blc(2):huvl%trc(2))
    endif
    !
    ! On this block, increment the htab array
    !
    spec = 0.
    poids = 0.
    !$OMP PARALLEL DEFAULT(none)  SHARED(uvdata) &
    !$OMP & SHARED (fchan,nchan,nvisi,htab,huvl,vtaper,ntaper,poids,spec) &
    !$OMP & PRIVATE (kr,kw,rr,ww,jc,jv,it,ctaper,ithread) 
    ithread = 1
    !$ ithread = omp_get_thread_num()+1      
    !$OMP DO
    do jv = 1,nvisi
      do it = 1,ntaper
        if (it.eq.1) then
          ctaper = 1.0
        else
          ctaper = exp(-(uvdata(1,jv)**2 + uvdata(2,jv)**2)/vtaper(it)**2)
        endif
        !
        do jc = 1,nchan
          kw = 7 + 3*(jc+fchan)   ! Weight            
          ww = uvdata(kw,jv) * ctaper
          if (ww.gt.0.0) then
            poids(jc,it,ithread) = poids(jc,it,ithread) + ww
            kr = 5 + 3*(jc+fchan)   ! Real part
            rr = uvdata(kr,jv) * ww
            ! Move to the Thread-based arrays
            spec(jc,it,ithread) = spec(jc,it,ithread) + rr
          endif
        enddo
      enddo
    enddo
    !$OMP END DO
    !$OMP END PARALLEL
    !
    ! Reduce the Thread-based arrays
    do ithread=1,nthread
      do it=1,ntaper
        do jc=1,nchan
          htab%r2d(jc,it+1) = htab%r2d(jc,it+1) + spec(jc,it,ithread)
        enddo
        do jc=1,nchan
          weights(jc,it) = weights(jc,it) + poids(jc,it,ithread)
        enddo
      enddo
    enddo
    !
    ! next block
  enddo
  !
  deallocate(spec,poids,stat=ier)
  if (huvl%loca%size.eq.0) then
    deallocate(uvdata)
  else
    nullify(uvdata)
  endif     
  !
  ! Final reduction of Weights and Spectrum
  wplus = 0.0
  ksum = 0
  do jc = 1,nchan
    if (weights(jc,1).ne.0) then
      ksum = ksum+1
      wplus(1) = wplus(1) + weights(jc,1)
    endif
  enddo
  do it = 2,ntaper
    do jc = 1,nchan
      wplus(it) = wplus(it) + weights(jc,it)
    enddo
  enddo
  !
  ! Normalize to get the correct spectrum
  htab%r2d(:,ntaper+2) = weights(:,1)  ! Natural weights
  do it=1,ntaper
    do jc=1,nchan
      htab%r2d(jc,it+1) = htab%r2d(jc,it+1) / weights(jc,it) 
    enddo
  enddo
  !
  ! Estimate the RMS noise for each taper
  do it=1,ntaper
    wall(it) = wplus(it)/ksum
  enddo
  ! Display noise estimate
  wall = 1e-3/sqrt(wall)    ! Units are Jy and MHz
  rmstheo = wall(1)
  call prnoise(rname,'Natural',rmstheo,rms,seve%i)
  !
  ! We need to define a Blanking value outside of the range
  blank = minval(htab%r2d)
  if (blank.gt.0) then
    htab%gil%bval = -2.0*blank
    htab%gil%eval = blank
  else if (blank.lt.0) then
    htab%gil%bval = 3.0*blank
    htab%gil%eval = -blank
  else
    htab%gil%bval = -1.0
    htab%gil%eval = 0.0
  endif
  htab%gil%blan_words = 2   ! Ensure the Blanking section exists
  do it=2,ntaper+1
    where (htab%r2d(:,ntaper+2).eq.0) htab%r2d(:,it) = htab%gil%bval
  enddo
  !
  call sic_mapgildas('SPECTRUM',htab,error,htab%r2d)
  call sic_defstructure('PREVIEW',.true.,error)
  !
  ! Clip them to compute the histograms
  if (nhist.gt.1) then
    ! wall(2:ntaper) = 0.0  ! No, this is creating issues
    !
    ! Evaluate the channel correlation factor and/or noise scaling factor
    ! by computing the rms on the difference between adjacent channels
    it = 2
    lc = 0
    do jc=1,nchan-1
      kc = jc+1
      if (htab%r2d(jc,ntaper+2).ne.0 .and. htab%r2d(kc,ntaper+2).ne.0) then
        lc = lc+1
        wreal(lc) = htab%r2d(jc,it)-htab%r2d(kc,it)
      endif
    enddo
    ! This normally has filtered out wide lines, but a one pass median filtering 
    ! is required to estimate the noise, because lines can be narrow.
    call median_filter (wreal,lc,htab%gil%bval,htab%gil%eval,amed,amin,amax,arms,mu)
    call comp_r4_rms_blank (wreal,lc,rmsdiff,htab%gil%bval,htab%gil%eval)
    rmsdiff =  rmsdiff / sqrt(2.0) 
    noise_ratio = 1.0
    if (rmsdiff.lt.0.9*rmstheo) then
      write(mess,'(A,1PG10.2,A,1PG10.2)') 'Theoretical RMS ',rmstheo, &
      & ' larger than Difference RMS ',rmsdiff
      call map_message(seve%w,rname,mess)
      correlation_factor = rmstheo/rmsdiff
      write(mess,'(A,1PG10.2,A,1PG10.2)') 'Estimated correlation factor ', &
        & rmstheo/rmsdiff
      call map_message(seve%i,rname,mess)
    else if (rmsdiff.gt.1.1*rmstheo) then
      noise_ratio = rmsdiff/rmstheo
      if (noise_ratio.gt.3.0) then
        call median_filter (wreal,lc,htab%gil%bval,htab%gil%eval,amed,amin,amax,arms,mu)
        call comp_r4_rms_blank (wreal,lc,rmsdiff,htab%gil%bval,htab%gil%eval)
        rmsdiff = rmsdiff / sqrt(2.0)
        noise_ratio = rmsdiff/rmstheo
      endif
      write(mess,'(A,1PG10.2,A,1PG10.2)') 'Theoretical RMS ',rmstheo, &
        & ' smaller than Difference RMS ',rmsdiff
      call map_message(seve%w,rname,mess)
      noise_ratio = rmsdiff/rmstheo
      write(mess,'(A,1PG10.2,A,1PG10.2)') 'Noise should be rescaled by ', & 
        & noise_ratio
      call map_message(seve%i,rname,mess,seve%w)
      noise_ratio = min(2.,noise_ratio)
    endif
    ! 
    ! Why is this done using the NOISE ratio. It should be SQUARED, hum ?
    wall = noise_ratio*wall
    !
    ! Separate Line from Continuum level, and identify regions...
    call gdf_copy_header(htab,hclip,error)
    allocate(hclip%r2d(nchan,ntaper+2),mylines(nchan),smarray(nchan),stat=ier)
    if (ier.ne.0) then
      call map_message(seve%e,rname,'CLIP allocation error')
      error = .true.
      return
    endif
    !
    nb = 0    ! Empty channel list
    !
    hclip%r2d = htab%r2d
    !
    correlation_factor = 1.0
    do it=2,ntaper+1
      !
      ! Here we 
      !   1) Smooth by some N channels
      !   2) Apply the Clip / Guess on the Smoothed array
      ! and this for the M possible smoothing
      do is=1,msmooth
        !
        if (nsmooth(is).gt.1) then
          call smooth_array(nchan,hclip%r2d(:,it),smarray,nsmooth(is), &
          & hclip%gil%bval,hclip%gil%eval)
        else
          smarray(:) = hclip%r2d(:,it)
        endif
        !
        weight = wall(it-1)/sqrt(float(nsmooth(is)))
        !
        call clip_lineregions(rname,smarray,nchan,nhist,  &
          & hclip%gil%bval,hclip%gil%eval,clip_value, &
          & debug,weight,noise_ratio) 
        call guess_lineregions(smarray,nchan,       &
          & hclip%gil%bval,hclip%gil%eval,            &
          & mylines,nb)
      enddo
    enddo
    !
    if (nb.gt.0) then
      !
      inb = nb
      allocate (final_lines(huvl%gil%nchan),stat=ier)
      iextent = 32
      call clip_expand(nchan,mylines,inb,final_lines,nb,iextent)
      do while ((nchan-nb).lt.fraction*nchan)
        iextent=iextent/2
        if (iextent.lt.2) then
          call map_message(seve%w,rname,'Complete spectral confusion at this level',seve%w)
          exit
        endif
        call clip_expand(nchan,mylines,inb,final_lines,nb,iextent)
      end do
      !
      hclip%r2d(:,1) = 0.0
      do ib=1,nb
        hclip%r2d(final_lines(ib),1) = 1.0
      enddo
      call sic_mapgildas('CLIPPED',hclip,error,hclip%r2d)
      !
      ! After SPECTRUM and CLIPPED are defined,
      !   Add the channel offset
      final_lines = final_lines + fchan
      ! and
      !   Add the edge channels [1,fchan] and [lchan+1,nchan]
      if (fchan.gt.0) then
        do ib=1,fchan
          nb = nb+1
          final_lines(nb) = ib
        enddo
      endif
      if (lchan.lt.huvl%gil%nchan) then
        do ib=lchan+1,huvl%gil%nchan
          nb = nb+1
          final_lines(nb) = ib
        enddo
      endif
      ! Sort if needed
      if ((fchan.gt.1).or.(lchan.lt.nchan)) then
        allocate(idx(nb),stat=ier)
        call gi4_trie (final_lines,idx,nb,error) 
        error = .false. 
      endif
      ! and define the result
      call sic_def_inte('PREVIEW%CHANNELS',final_lines,1,nb,.false.,error)
      !
      ! Find edges of contiguous regions over the whole channel range [1,nchan]
      allocate(edge_freq(2,nb), edge_chan(2,nb) ,stat=ier)
      if (ier.ne.0) then
        call map_message(seve%e,rname,'PREVIEW allocation error')
        error = .true.
        return
      endif
      call channel_to_edges(final_lines,nb,edge_chan,nlines)
      !
      ! Convert to Rest Frequencies
      edge_freq(:,:) = (edge_chan - huvl%gil%ref(1))*huvl%gil%fres + huvl%gil%freq
      if (huvl%gil%fres.lt.0) then
        do i = 1,nlines
          tmp = edge_freq(1,i)
          edge_freq(1,i) = edge_freq(2,i)
          edge_freq(1,i) = tmp
        enddo
      endif
      dim(1:2) = [2,nlines]
      call sic_def_dble('PREVIEW%FREQUENCIES',edge_freq,2,dim,.false.,error)
      call sic_def_inte('PREVIEW%EDGES',edge_chan,2,dim,.false.,error)
    else
      ! Just one non existent channel
      allocate (final_lines(1),stat=ier)
      final_lines = 0
      call sic_def_inte('PREVIEW%CHANNELS',final_lines,1,1,.false.,error)
    endif
  endif
  !
  number_of_channels = nchan
end subroutine uv_preview_sub
!
subroutine fit_parabola(n,x,y,a,b,c,d)
  !---------------------------------------------------------------------
  ! @ public
  !*
  !   IMAGER -- generic tool
  !
  ! Find the characteristics of a parabola.
  ! Parabola definition y = a + b.x + c.x^2
  !---------------------------------------------------------------------
  integer, intent(in) :: n    !! Number of values
  real, intent(in) :: x(n)    !! X coordinates
  real, intent(in) :: y(n)    !! Y values
  real, intent(inout) :: a    !! Constant term
  real, intent(inout) :: b    !! Linear term
  real, intent(inout) :: c    !! Second order term
  real, intent(inout) :: d    !! rms of fit
  !
  real :: a0, a1, a2, a3, a4
  real :: b0, b1, b2, d1
  integer :: m, k
  !
  a0 = 1; a1 = 0; a2 = 0; a3 = 0; a4 = 0
  b0 = 0; b1 = 0; b2 = 0
  k = 0
  do m = 1, n
    if (y(m).gt.0) then
      a1 = a1 + x(m)
      a2 = a2 + x(m) * x(m)
      a3 = a3 + x(m) * x(m) * x(m)
      a4 = a4 + x(m) * x(m) * x(m) * x(m)
      b0 = b0 + y(m)
      b1 = b1 + y(m) * x(m)
      b2 = b2 + y(m) * x(m) * x(m)
      k = k+1
    endif
  enddo
  !
  ! Protect against severe clipping: do not change values, and set RMS 0
  if (k.le.3) then
    d = 0.0
    return
  endif
  a1 = a1 / k; a2 = a2 / k; a3 = a3 / k; a4 = a4 / k
  b0 = b0 / k; b1 = b1 / k; b2 = b2 / k
  d = a0 * (a2 * a4 - a3 * a3) - a1 * (a1 * a4 - a2 * a3) + a2 * (a1 * a3 - a2 * a2)
  a = b0 * (a2 * a4 - a3 * a3) + b1 * (a2 * a3 - a1 * a4) + b2 * (a1 * a3 - a2 * a2)
  a = a / d
  b = b0 * (a2 * a3 - a1 * a4) + b1 * (a0 * a4 - a2 * a2) + b2 * (a1 * a2 - a0 * a3)
  b = b / d
  c = b0 * (a1 * a3 - a2 * a2) + b1 * (a2 * a1 - a0 * a3) + b2 * (a0 * a2 - a1 * a1)
  c = c / d
  !
  ! Evaluation of standard deviation d
  d = 0.
  do m = 1, n
    if (y(m).gt.0) then
      d1 = y(m) - a - b * x(m) - c * x(m) * x(m)
      d = d + d1 * d1
    endif
  enddo
  d = SQRT(d / (k - 3))
end subroutine fit_parabola
!
subroutine clip_lineregions(rname,data,nchan,nhist,bval,eval,clip, &
  & debug,rms,noise_ratio)
  use gildas_def
  use gbl_message
  use gkernel_interfaces
  use imager_interfaces, except_this => clip_lineregions
  !---------------------------------------------------------------------
  ! @ public
  !*
  !   IMAGER -  Support for command UV_PREVIEW
  !
  !   Clip the possible "spectral line" regions, i.e. those
  ! that deviate from the median by a sufficient amount
  !!
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: rname             !! Caller name
  integer(kind=index_length), intent(in) :: nchan   !! Data size
  integer(kind=index_length), intent(in) :: nhist   !! Histogram size
  real, intent(inout) :: data(nchan)                !! Data to be clipped
  real, intent(in) :: bval, eval                    !! Blanking values to be used
  real, intent(in) :: clip                          !! Clipping level in Sigma
  logical, intent(in) :: debug                      !! Debug printout
  real, intent(in) :: rms                           !! Expected rms noise
  real, intent(in) :: noise_ratio                   !! Noise scaling factor
  !
  ! Local ---
  real, allocatable :: hist(:,:), logv(:), temp(:)  ! Small automatic array
  real :: amed, amin,amax,arms,aoff
  real :: a,b,c,d,mu,sigma,peak,logbase
  logical :: error, goon
  integer :: jc,ier, count
  integer(kind=index_length) :: mloc(1)
  integer(kind=4) :: mhist
  character(len=128) :: chain
  real :: thremu=3.0
  !
  ! Code ----
  error = .false.
  mhist = nhist   ! Integer(4) version
  ! Arrays 
  allocate(hist(mhist,2), logv(mhist), temp(nchan), stat=ier)
  if (ier.ne.0) then
    Print *,'clip_lineregions allocation error ',ier
    return
  endif
  !
  ! Define the Histogram range around the median
  temp(:) = data
  call median_filter (temp,nchan,bval,eval,aoff,amin,amax,arms,thremu)
  if (debug) print *,' Amin ',amin,', Amax ',amax,', Aoff ',aoff,' RMS ',rms
  goon = (amin.lt.amax)     ! Protect against fully constant data (0 in models...)
  !
  if (goon .and. rms.ne.0) then
    ! Protect against High S/N lines with both negative and positive features
    if (arms.gt.3*rms) then
      amin = max(-5.0*rms,amin)
      amax = -amin
    endif
  endif
  !
  amed = (amin+amax)/2.0
  count = 0
  do while (goon) 
    ! Use NHIST here
    call histo44(temp,nchan,hist,nhist,2,amin,amax,bval,eval)
    !
    ! Apply Caruana algorithm : the Log of a Gaussian is a Parabola
    logv(:) = log(hist(:,1)+1.0)       ! Bias by 1 to avoid Log(0)
    logbase = maxval(logv)-4.0         ! Truncate wings
    where (logv.lt.logbase) logv=0.0
    ! Use MHIST there
    call fit_parabola(mhist,hist(1:mhist,2),logv,a,b,c,d)
    if (debug) print *,' A B C D ',a,b,c,d
    !
    ! Now back to Gaussian characteristics
    mu = -b/(2.0*c)             ! Position
    sigma = sqrt(-1.0/(2.0*c))  ! Sigma
    peak = exp(a-b**2/(4.0*c))  ! Intensity (biased)
    if (debug) then
      count= count+10
      do jc=1,mhist
        write(count,*) hist(jc,2), logv(jc), a+b*hist(jc,2)+c*hist(jc,2)**2, d
      enddo
      close(unit=count)
      count = count-10
    endif    
    !
    ! Treat the confusion case: the Gaussian  peak should be close 
    ! to the maximum of the Histogram - if not, this must be line 
    ! contamination
    if (debug) Print *,'Peak ',log(peak),' MaxVal ',maxval(logv),' D ',d
    amed = mu                   ! Define the position of maximum 
    if (count.eq.8) then
      ! 8 iterations, this is too much...
      goon = .false.
    else if (d.gt.0.25 .or. log(peak).lt.maxval(logv)-d) then
      ! If not converged, the Maximum can be wrong - iterate
      mloc = maxloc(hist,1)
      amed = hist(mloc(1),2)
      amin = amed-2.0*sigma
      amax = amed+2.0*sigma
      if (debug) Print *,count,': Min ',amin,' Median ',aoff,' Max ',amax,' Rms ',sigma
      count = count+1
    else
      goon = .false.
    endif
    if (debug) then
      call gr4_give('X',nhist,hist(:,2))
      call gr4_give('Y',nhist,logv)
      call gr_exec('CLEAR')
      call gr_exec('LIMITS')
      call gr_exec('BOX')
      call gr_exec('HISTO')
      logv(:) = a+b*hist(:,2)+c*hist(:,2)**2
      call gr4_give('Y',nhist,logv)
      call gr_exec('CONNECT')
      write(*,*) 'Enter an integer to continue '
      read(*,*) mloc
    endif
  enddo
  !
  ! Correct for the Offset
  amed = amed+aoff
  if (rms.ne.0.0 .and. sigma.gt.rms) then
    write(chain,'(A,1PG10.2,A,1PG10.2)')  'Expected noise ',rms, &
      & ' is smaller than measured noise ',sigma
    call map_message(seve%w,rname,chain,seve%w)
  endif
  !
  ! If there is a noise correction, apply it
  sigma = sigma*noise_ratio
  !
  ! Now clip the Spectrum where it deviates by more than 
  ! CLIP_VALUE sigma
  if (debug) Print *,'Clipping around median ',amed,' by ',clip*sigma
  do jc=1,nchan
    if (abs(data(jc)-bval).le.eval) then
      data(jc) = bval
    else if (abs(data(jc)-amed).gt.clip*sigma) then
      data(jc) = bval
    endif
  enddo
  !
end subroutine clip_lineregions
!
subroutine guess_lineregions(data,nchan,bval,eval,mylines,nb)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ public
  !*
  !     IMAGER  -- Support for UV_PREVIEW
  !
  !   Identify the edges of regions which consecutive channels
  ! that have been clipped (i.e. Blanked)
  !!
  !---------------------------------------------------------------------
  integer(kind=index_length), intent(in) :: nchan   !! Data size
  real, intent(in) :: data(nchan)                   !! Blanked data 
  real, intent(in) :: bval, eval                    !! Blanking values to be used
  integer, intent(inout) :: mylines(nchan)          !! Line channel list
  integer, intent(inout) :: nb                      !! Number of line channels
  !
  ! Local ---
  integer :: jc,jb,lb
  !
  ! Code ----
  do jc=1,nchan
    if (abs(data(jc)-bval).le.eval) then
      jb = 0
      do lb=1,nb
        if (mylines(lb).eq.jc) then
          jb = lb
          exit
        endif
      enddo
      if (jb.eq.0) then
        nb = nb+1
        mylines(nb) = jc
      endif
    endif
  enddo
end subroutine guess_lineregions
!
subroutine comp_r4_rms_blank (x,n,out,vblank4,eblank4)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ private-mandatory (because symbol is used elsewhere)
  !*
  ! IMAGER -- Utility routine
  !
  ! Support routine for command
  !   COMPUTE OutVar RMS InVar  (single precision)
  ! Protected against NaNs and Using Blanking Values. If Blanking
  ! enabled, will return blanking value if no valid result. If Blanking
  ! is not enabled, will return NaN if no valid result.
  !
  !   (Duplicated from Kernel code because symbol is private there)
  !!
  !---------------------------------------------------------------------
  real*4,                    intent(in)  :: x(*)  !! Data values to compute
  integer(kind=size_length), intent(in)  :: n     !! Number of data values
  real*4,                    intent(out) :: out   !! Output scalar value
  real*4,                    intent(in) :: vblank4, eblank4 !! Blanking
  !
  ! Local ---
  integer(kind=size_length) :: i,count
  real*4 :: s0,s1
  !
  ! Code ----
  !Print *,'N ',n,' Bval ',vblank4,eblank4
  out = vblank4
  if (n.lt.1) return
  out = 0.0
  !
  s0 = 0.
  s1 = 0.
  count = 0
  do i = 1,n
    if (x(i).eq.x(i)) then
      if (eblank4.ge.0) then
        if (abs(x(i)-vblank4).gt.eblank4) then
          s0 = s0+x(i)
          count = count+1
        endif
      else
        s0 = s0+x(i)
        count = count+1
      endif
    endif
  enddo
  if (count.gt.0) then
    s0 = s0/dble(count)
  else
    out = vblank4 ! lastchanceretval
    return
  endif
  !
  ! Note philosophique: Count is the same in the 2 loops
  do i = 1,n
    if (x(i).eq.x(i)) then
      if (eblank4.lt.0) then
        s1 = s1 + (x(i)-s0)**2
      else
        if (abs(x(i)-vblank4).gt.eblank4) then
          s1 = s1 + (x(i)-s0)**2
        endif
      endif
    endif
  enddo
  s1 = s1/dble(count)
  out = sqrt (s1)
end subroutine comp_r4_rms_blank
!
subroutine clip_expand(nc,inlines,inb,oulines,onb,iextent)
  use gildas_def
  use gkernel_interfaces
  !---------------------------------------------------------------------  
  ! @ private
  !*
  !   IMAGE -- Support for UV_PREVIEW
  !
  !   Expand the list of "bad" channels by continuity to account for 
  ! possible line wings
  !!
  !---------------------------------------------------------------------
  integer(kind=index_length), intent(in) :: nc !! Number of channels
  integer, intent(inout) :: inlines(nc)  !! List of bad channels
  integer, intent(in) :: inb             !! Number of bad channels
  integer, intent(out) :: oulines(nc)    !! List of bad channels
  integer, intent(out) :: onb            !! Number of bad channels
  integer, intent(in) :: iextent         !! Side channel Extension 
  !
  ! Local ---
  integer :: ier, nrange, iwide, ib, lb, jend, jwide
  integer, allocatable :: istart(:), iend(:)
  real :: rwide
  logical :: error
  !
  ! Code ----
  error = .false.
  onb = inb
  allocate(istart(inb),iend(inb),stat=ier)
  if (ier.ne.0) return
  oulines(1:nc) = inlines(1:nc)
  call gi4_trie (oulines,istart,inb,error)
  inlines(1:nc) = oulines(1:nc)
  if (error) return
  !
  ! Define the number of ranges
  nrange = 1
  istart(1) = oulines(1)
  iend(1) = oulines(1)
  !
  ! 1) Find out the ranges
  iwide = 1
  do ib=1,inb
    if ((oulines(ib)-iend(nrange)).gt.iwide) then  
      ! A gap wider than the current range
      nrange = nrange+1
      istart(nrange) = oulines(ib)
      iend(nrange) = oulines(ib)
    else
      iend(nrange) = oulines(ib)
    endif
  enddo
  !
  ! 2) compute the Mean Line Width 
  !- Assume it is not too different from the Median
  rwide = 0.
  do ib=1,nrange
    rwide = rwide +(iend(ib)-istart(ib)+1)
  enddo
  rwide = rwide/(2.*nrange)
  iwide = max(1,nint(rwide))
  !
  ! 3) Figure out continuity at this level
  nrange = 1
  do ib = 2,inb
    if ((oulines(ib)-iend(nrange)).gt.iwide) then  
      ! A gap wider than the current half-width
      nrange = nrange+1
      istart(nrange) = oulines(ib)
      iend(nrange) = oulines(ib)
    else
      iend(nrange) = oulines(ib)
    endif
  enddo
  !
  ! Extend the ranges by doubling or adding +/- iextent channels to
  ! their width to account for typical line widths, but 
  ! ignore single channels in this process
  onb = 0
  oulines = 0
  jend = 1
  do ib=1,nrange
    jwide = min((iend(ib)-istart(ib))/2,iextent)  ! At least iextent
    jwide = max(iwide,jwide)  ! At least iwide
    istart(ib) = max(jend,istart(ib)-jwide)
    iend(ib) = min(nc,iend(ib)+jwide)
    jend = iend(ib)+1 ! To avoid overlap with previous end
    !
    do lb=istart(ib),iend(ib) 
      onb = onb+1
      If (onb.gt.nc) then
        Print *,'Serious programming error ',onb,nc
        Print *,'at ',lb,istart(lb),iend(lb)
      else
        oulines(onb) = lb
      endif
    enddo
  enddo
end subroutine clip_expand
!
subroutine median_filter(temp,nchan,bval,eval,amed,amin,amax,arms,mu)
  use gildas_def
  use gkernel_interfaces
  use imager_interfaces, only : comp_r4_rms_blank 
  !---------------------------------------------------------------------
  ! @ public
  !*
  !     IMAGER  -- Utility routine
  !
  !   Median filtering, returning Median, symmetric Min, Max and Rms 
  !!
  !---------------------------------------------------------------------
  integer(kind=index_length), intent(in) :: nchan !! Array size
  real, intent(inout) :: temp(nchan)    !! Data array  
  real, intent(in) :: bval              !! Blanking value
  real, intent(in) :: eval              !! Blanking tolerance
  real, intent(out) :: amed             !! Median
  real, intent(out) :: amin             !! Min
  real, intent(out) :: amax             !! Max
  real, intent(out) :: arms             !! Rms
  real, intent(in) :: mu                !! Rejection threshold
  !
  ! Local ---
  integer(kind=index_length) :: nmin,nmax
  logical :: error
  !
  ! Code ----
  arms = 0.
  amin = 0.
  amax = 0.
  amed = 0.
  !
  error = .false.
  call gr4_median(temp,nchan,bval,eval,amed,error)
  if (error) return  ! No valid data
  temp = temp-amed   ! Remove the median
  call gr4_extrema (nchan,temp,bval,eval,amin,amax,nmin,nmax)
  if (amin.eq.amax) return 
  ! 
  amax = min(-amin,amax)
  amin = -amax 
  where(temp.lt.amin .or. temp.gt.amax) temp = bval
  call comp_r4_rms_blank (temp,nchan,arms,bval,eval)
  ! 
  where(abs(temp).gt.mu*arms) temp = bval
end subroutine median_filter
!
subroutine channel_to_edges(clist,nc,edges,nl)
  use image_def
  !---------------------------------------------------------------------
  ! @ private
  !*
  !   IMAGER -- Utility routine
  !
  !   Convert a list of channels into a list of edges of the
  ! independent (continuous) ranges.
  !!
  !---------------------------------------------------------------------
  integer, intent(in) :: nc            !! Number of selected channels
  integer, intent(in) :: clist(nc)     !! Channel numbers
  integer, intent(out) :: edges(2,nc)  !! Start and End channels 
  integer, intent(out) :: nl           !! Number of ranges found
  !
  ! Local ---
  integer :: i,istart,iend
  !
  ! Code ----
  if (nc.lt.2) then
    nl = 1
    edges(1,1) = clist(1)
    edges(2,1) = clist(1) 
  else 
    istart = clist(1)
    iend = clist(1)
    nl = 1
    do i=2,nc
      if (clist(i)-iend.gt.1) then
        edges(1,nl) = istart
        edges(2,nl) = iend
        nl = nl+1
        istart = clist(i)
        iend = istart
      else
        iend = clist(i)
      endif
    enddo
    iend = clist(nc)
    edges(1,nl) = istart
    edges(2,nl) = iend
  endif
end subroutine channel_to_edges
!
subroutine channel_restrict(rname,fchan,lchan,error)
  use gkernel_interfaces
  use gkernel_types
  use gbl_message
  use clean_beams
  !---------------------------------------------------------------------
  ! @ private
  !*
  !   IMAGER -- Utility routine
  !
  !   If UV_CHECK BEAM has been used, restrict the range to the 
  ! most significant (to avoid issues with bad edge recognition)
  !
  !   Also used in SELFCAL
  !!
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: rname !! Caller name
  integer, intent(inout) :: fchan       !! First channel
  integer, intent(inout) :: lchan       !! Last channel
  logical, intent(inout) :: error       !! Error flag
  !
  integer :: icode, nbr
  integer, allocatable :: branges(:,:)
  !
  icode = 0
  allocate(branges(2,max(1,nbeam_ranges)))
  call channel_range(rname,fchan,lchan,icode,nbr,branges)
  error = icode.ne.0
  !
end subroutine channel_restrict
!
subroutine smooth_array(nchan,raw,smooth,ksmoo,bval,eval)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ private
  !*
  !   IMAGER -- Utility routine
  ! 
  ! Smooth an array by K channels, accounting for Blanking
  !!
  !---------------------------------------------------------------------
  integer(kind=index_length), intent(in) :: nchan  !! Number of channels
  real, intent(in) :: raw(nchan)      !! Input array
  real, intent(out) :: smooth(nchan)  !! Smoothed array 
  integer, intent(in):: ksmoo         !! Smoothing length
  real, intent(in) :: bval, eval      !! Blanking value
  !
  ! Local ---
  integer :: ic, im, ip, k, nc
  real :: w
  !
  ! Code ----
  nc = (ksmoo-1)/2
  do ic=1,nchan
    smooth(ic) = 0
    im = max(1,ic-nc)
    ip = min(nchan,ic+ksmoo-nc-1)
    w = 0.0
    do k=im,ip
      if (abs(raw(k)-bval).gt.eval) then
        smooth(ic) = smooth(ic) + raw(k)
        w = w+1.0
      endif
    enddo
    if (w.gt.0) then
      smooth(ic) = smooth(ic)/w
    else
      smooth(ic) = bval
    endif
  enddo
end subroutine smooth_array

subroutine uv_linear_comm(line,comm,error)
  use clean_def
  use clean_arrays
  use clean_beams
  use gbl_message
  use gkernel_interfaces
  use imager_interfaces, except_this => uv_linear_comm
  !-----------------------------------------------------------
  ! @ private
  ! IMAGER -- Support for command  
  !   UV_LINEARIZE   [/FILE FileIn FileOut]
  !
  !     Linearize random frequency axis by  
  !     - ordering the frequencies  
  !     - filling the holes by empty (zero weight) channels
  !   as much as possible, i.e. if and only if  
  !     - spacing tolerance between "adjacent" frequencies is
  !       smaller than specified threshold  
  !     - gaps are not too large either
  !!
  !-----------------------------------------------------------
  character(len=*), intent(in) :: comm    !! Command name
  character(len=*), intent(inout) :: line !! Command line
  logical, intent(inout) :: error         !! Error flag
  !
  ! Constants
  character(len=*), parameter :: rname='UV_LINEARIZE'
  integer, parameter :: o_file=1
  real(kind=8) :: btole=1.D-3 !! Strictly speaking it 
  !! should be dependent on the number of channels
  !
  ! Local ---
  type(gildas) :: uvout
  real, pointer :: duv_previous(:,:), duv_next(:,:)
  real(kind=8), allocatable :: the_freqs(:)
  integer, allocatable :: indx(:), itmp(:), acount(:), pixels(:), filled(:)
  real, allocatable :: rdiff(:)
  real(kind=8), allocatable :: adiff(:)
  integer :: nfreq, ier, i, j, jdiff, mdiff, npix
  integer :: iv,ic, kfi,kla, jfi,jla
  real :: bzero, bdiff
  integer :: nu,nv
  logical :: err
  !
  ! Code ----
  call sic_r8(line,0,1,btole,.false.,error)
  !
  if (sic_present(o_file,0)) then
    call map_message(seve%e,rname,'Option /FILE not yet implemented')
    error = .true.
    return
  endif
  !
  ! Only in memory work so far
  if (huv_current%loca%size.eq.0) then
    call map_message(seve%e,rname,'No UV data')
    error = .true.
    return
  endif
  if (huv_current%gil%nfreq.eq.0) then
    call map_message(seve%i,rname,'UV data is already linear',seve%w)
    return
  endif
  !
  nfreq = huv_current%gil%nfreq
  allocate(the_freqs(nfreq),indx(nfreq),itmp(nfreq), &
    & adiff(nfreq),acount(nfreq),stat=ier)
  !
  the_freqs(:) = huv_current%gil%freqs(:)
  call gr8_trie(the_freqs,indx,nfreq,error)
  !
  ! Count the differences
  adiff(1) = the_freqs(2)-the_freqs(1)
  mdiff = 1
  acount(1) = 1
  bzero = adiff(1)
  !
  do i=2,nfreq-1
    bdiff = the_freqs(i+1)-the_freqs(i)
    jdiff = 0
    do j=1,mdiff
      if (abs(bdiff-adiff(j)).le.bzero*btole) then
        jdiff = j
        exit
      endif
    enddo
    if (jdiff.eq.0) then
      Print *,'Found new spacing at I ',i,the_freqs(i),the_freqs(i+1)
      jdiff = mdiff+1
      adiff(jdiff) = bdiff
      acount(jdiff) = 1
      mdiff = jdiff
    else
      acount(jdiff) = acount(jdiff)+1
    endif
  enddo
  !
  if (mdiff.gt.1) then
    call map_message(seve%w,rname,'More than one Frequency range')
    allocate (rdiff(mdiff))
    Print *,'Range      Spacing     Occurence  Ratio '
    do j=1,mdiff
      rdiff(j) = adiff(j)/adiff(1)
      Print *,j,adiff(j),acount(j),rdiff(j)
      if (abs(nint(rdiff(j))-rdiff(j)).gt.btole) error = .true.
    enddo
    if (error) then
      call map_message(seve%e,rname,'Input frequency axis is not sufficiently regular')
      return
    endif
  endif
  !
  ! Now define the axis
  npix = ceiling((the_freqs(nfreq)-the_freqs(1))/adiff(1)+1.0)
  !
  if (npix.gt.huv_current%gil%nchan*2) then
    call map_message(seve%e,rname,'Linearization would create too many  or too large gaps')
    error = .true.
    return
  endif
  !
  allocate(pixels(npix),filled(nfreq),stat=ier)
  do i=1,npix
    pixels(i) = (i-1)*adiff(1)+the_freqs(1)
  enddo
  !
  do i=1,nfreq
    j = nint((huv_current%gil%freqs(i)-the_freqs(1))/adiff(1) + 1d0)
    filled(i) = j
    if (j.gt.npix) then
      Print *,'Rounding error J ',j,' > NPIX ',npix
      Print *,'   Please enter a number to continue'
      read(5,*) iv
    endif 
    if (i.gt.1) then
      if (j.eq.filled(i-1)) then
        Print *,'Duplicate entry j ',j,' at I ',i,huv_current%gil%freqs(i),adiff(1)
        Print *,'Entry I-1 ',i-1,huv_current%gil%freqs(i-1),filled(i-1), (& 
          & huv_current%gil%freqs(i)-the_freqs(1))/adiff(1) + 1d0
        print *,filled(1:i)
        Print *,'   Please enter a number to continue'
        read(5,*) iv
      endif
    endif
  enddo
  !
  ! Get a new UV data set
  call gildas_null(uvout,type='UVT')
  call gdf_copy_header(huv_current,uvout,error)
  uvout%gil%nfreq = 0
  !
  ! Prepare appropriate array...
  nu = huv_current%gil%dim(1)+(npix-nfreq)*3  ! No Stokes anyway...
  nv = huv_current%gil%nvisi
  uvout%gil%dim(1) = nu
  uvout%gil%dim(2) = nv 
  uvout%gil%convert(:,1) = [1.d0,the_freqs(1),dble(adiff(1))]
  uvout%gil%nchan = npix
  uvout%gil%freq = (npix/2-1)*uvout%gil%convert(3,1)+uvout%gil%convert(2,1)
  uvout%gil%convert(1,1) = npix/2
  uvout%gil%convert(2,1) = uvout%gil%freq
  call gdf_uv_shift_columns(huv_current,uvout)
  call gdf_setuv(uvout,error)
  !
  nullify (duv_previous, duv_next)
  call uv_find_buffers (comm,nu,nv,duv_previous, duv_next,error)
  if (error) then
    call map_message(seve%e,comm,'Cannot set buffer pointers')
    return
  endif
  !
  do iv=1,nv
    duv_next(1:7,iv) = duv_previous(1:7,iv)
    do ic=1,nfreq
      kfi = 5+3*ic
      kla = kfi+2
      jfi = 5+3*filled(ic)
      jla = jfi+2
      duv_next(jfi:jla,iv) = duv_previous(kfi:kla,iv)
    enddo
  enddo  
  !
  ! Set header back
  call gdf_copy_header(uvout,huv_current,error)
  !
  ! Reset proper pointers
  call uv_clean_buffers (duv_previous, duv_next,error)
  if (error) return
  !
  ! Delete variables that may have been affected
  !
  ! Channel range is no longer meaningful
  nbeam_ranges = -1
  call sic_delvariable ('BEAM_RANGES',.false.,err)
  if (sic_varexist('UVS')) call sic_delvariable('UVS',.false.,err)
  !
  ! Indicate UV data has changed, and weight must be computed
  call uv_new_data(weight=.true., resample=.true.)  
end subroutine uv_linear_comm

subroutine howto_comm(line,error,icode)
  use gkernel_interfaces
  use gbl_message
  use imager_interfaces, only : map_message
  !---------------------------------------------------------------------
  !! IMAGER -- Support for command HOW_TO
  !---------------------------------------------------------------------
  character(len=*), intent(inout) :: line  !! Command line
  logical, intent(out) :: error            !! Logical error flag
  integer, intent(inout) :: icode  !! Operation code: 0 examine ambiguities, 1 use unambiguous result
  !
  ! Constants
  character(len=*), parameter :: rname='HOW_TO'
  integer, parameter :: nuse=13
  character(len=8) :: useless(nuse)
  data useless /'?','a','all','and','at','do','i','it','my','some','the','to','we'/
  integer, parameter :: mkeys=10
  ! Local ---
  integer :: nkeys, lkeys(mkeys), ikey
  character(len=20) :: ckeys(mkeys),string,comm
  character(len=4) :: ch
  character(len=120) :: ligne,cmatch
  character(len=256) :: file
  integer, save :: luntem=0
  integer :: ier, i, j, itry, ifound, lt, nline, nfound, fline, lline
  logical :: found, used, lfound
  !
  ! Code ----
  error = .true.
  nkeys = sic_narg(0)
  if (nkeys.le.0) then
    call map_message(seve%e,rname,'Missing keywords')
    return
  endif
  !
  if (nkeys.gt.mkeys) then
    call map_message(seve%e,rname,'Too many keywords')
    return
  endif
  !
  ikey = 0
  do i=1,nkeys
    call sic_ch(line,0,i,string,lt,.true.,error)
    if (error) return
    if (nkeys.eq.1 .and. string.eq.'?') then
      ikey = 1
      exit
    endif
    !
    call sic_lower(string)
    used = .true.
    do j=1,nuse
      if (string.eq.useless(j)) then
        used = .false.
        exit
      endif
    enddo
    if (used) then
      ikey = ikey+1
      ckeys(ikey) = string
      if (string(lt:lt).eq.'*') then
        lkeys(ikey) = lt-1
        ckeys(ikey)(lt:) = ' '
      else
        lkeys(ikey) = lt+1
      endif
    endif
  enddo
  nkeys = ikey
  !
  ! Open file (in production, will use a rewind(luntem) statement)
  if (luntem.eq.0) then
    ier = sic_getlun(luntem)
    if (ier.ne.1) return
    call sic_parse_file('imager-howto','gag_pro:','.hlp',file)    
    ier = sic_open(luntem,file,'old',.true.)
    if (ier.ne.0) then
      call map_message(seve%e,'HOW_TO','No gag_pro:imager-howto.hlp file')
      error = .true.
      call sic_frelun(luntem)
      luntem = 0
    endif
  else    
    rewind(unit=luntem)
  endif
  !
  ! Special case HOWTO ?
  if (nkeys.eq.1 .and. string.eq.'?') then
    do 
      read(luntem,'(A)',iostat=ier) ligne
      if (ier.ne.0)  exit
      !
      if (ligne(1:1).eq.'1') then
        read(luntem,'(A)',iostat=ier) ligne
        if (ier.eq.0) write(*,'(A)') trim(ligne)
      endif
    enddo
    error = .false.
    return
  endif
  !
  ! Scan for Keywords
  found = .false.
  ifound = 0
  !
  ! First pass, look for ambiguities
  nline = 0
  nfound = 0
  fline = 0
  lline = 0
  do
    lfound = .false.
    ifound = 0
    do 
      read(luntem,'(A)',iostat=ier) ligne
      if (ier.ne.0)  then
        if (ifound.eq.nkeys) nfound = nfound+1
        exit
      endif
      nline = nline+1
      !
      if (ligne(1:1).eq.'1') then
        if (ifound.eq.nkeys) then
          lline = nline
          nfound = nfound+1
          !!Print *,'STARTing ',ifound, nkeys,nline,trim(ligne) 
        endif
        ! We check 1 more character in ligne, which should be blank
        ! for correct match
        ifound = 0  ! Nothing found so far
        lfound = .false.
        do i=1,nkeys
          lt = lkeys(i)
          if (index(ligne,ckeys(i)(1:lt)).ne.0) then
            error = .false.
            ifound = ifound+1
          endif
        enddo
        lfound = ifound.eq.nkeys
        if (lfound) then
          found = .true.
          fline = nline
          read(luntem,'(A)',iostat=ier) ligne
          if (ier.ne.0)  exit
          write(*,'(A)') trim(ligne)
        endif
        !!Print *,ifound,nkeys,nline,trim(ligne)
      endif
    enddo
    !!Print *,'NLINE ',nline
    if (ier.ne.0) exit
  enddo
  if (lline.eq.0) lline = nline
  !
  if (found) then
    !!Print *,'NFOUND ',nfound,' FLINE ',fline,' LLINE ',lline
    !
    ! Second pass to write if no ambiguity
    if (nfound.gt.1) then
      write(*,'(A,I0,A)') 'Sorry, found ',nfound, &
        & ' different results for "how '//trim(line(17:))//'"'
      write(*,'(A)') 'Please, specify additional keywords ' 
    else 
      rewind(luntem)
      do i=1,fline+1
        read(luntem,'(A)',iostat=ier) ch
      enddo
      do i=fline+2,lline
        read(luntem,'(A)',iostat=ier) ligne
        write(*,'(A)') trim(ligne)
      enddo    
    endif
    return
  endif
  !
  if (icode.eq.1) then
    Print *,'Autoguess failed...'
    error = .true.
    return
  endif
  !
  ! Third chance: list relevant HOW_TOs
  do itry=1,2
    if (itry.eq.2) then
      write(*,'(A)') 'Sorry, no result for '//trim(line)
      if (ifound.eq.0) return
      write(*,'(A)') '  Related information could be: '
    endif
    !
    ifound = 0
    rewind(luntem)
    do 
      read(luntem,'(A)',iostat=ier) ligne
      if (ier.ne.0)  exit
      !
      if (ligne(1:1).eq.'1') then
        if (ifound.eq.nkeys) exit  ! Every keyword has been found
        ! We check 1 more character in ligne, which should be blank
        ! for correct match
        found = .false.
        do i=1,nkeys
          lt = lkeys(i)
          if (index(ligne,ckeys(i)(1:lt)).ne.0) then
            found = itry.eq.2
            error = .false.
            ifound = ifound+1
            if (ifound.eq.1) cmatch = ligne(3:len_trim(ligne))
          endif
        enddo
        if (found) write(*,'(A)') ligne(3:len_trim(ligne))
      endif
    enddo
    !
    ! Automatic fall back to the only possible match
    if (ifound.eq.1) then
      icode = 1
      line = 'HOW_TO '//cmatch
      nline = len_trim(line)
      call sic_analyse(comm,line,nline,error)
      return
    endif
  enddo
end subroutine howto_comm

subroutine uv_shift_comm(line,comm,error)
  use gkernel_interfaces, only : sic_present
  use imager_interfaces, only : map_message
  use clean_types
  use clean_arrays
  use gbl_message
  !-------------------------------------------------------------------
  ! @ private
  !*
  !  IMAGER  -- Support routine for command  
  !       UV_SHIFT [Xpos Ypos UNIT] [ANGLE [Angle]]  [/FILE FileIn]
  !
  !   Dispatch according to option present.
  !!
  !-------------------------------------------------------------------
  character(len=*), intent(in) :: line  !! Command line
  character(len=*), intent(in) :: comm  !! Command name 
  logical error                         !! Logical error flag
  !
  integer, parameter :: o_file=1
  !
  if (sic_present(o_file,0)) then
    call uv_shift_file(line,comm,error)
  else
    if (huv_current%loca%size.eq.0) then
      call map_message(seve%e,comm,'No UV data loaded')
      error = .true.
      return
    endif
    call uv_shift_mosaic(line,comm,error)
  endif
end subroutine uv_shift_comm
!
subroutine uv_shift_file(line,comm,error)
  use clean_def
  use clean_default
  use phys_const
  use gkernel_types
  use gkernel_interfaces
  use gbl_message
  use imager_interfaces, except_this => uv_shift_file
  !-------------------------------------------------------------------
  ! @ private
  !*
  !  IMAGER -- Support routine for command  
  !       UV_SHIFT [Xpos Ypos UNIT] [ANGLE [Angle]] /FILE FileIn
  !
  !   Phase shift a Mosaic or Single Field UV Table to a new
  !   common phase center and orientation. 
  !     Offx OffY are offsets in Angle UNIT or ABSOLUTE values
  !               (default 0,0).
  !     Angle     is the final position angle from North in Degree
  !               (default: no change)
  !!!
  !-------------------------------------------------------------------
  character(len=*), intent(in) :: line  !! Command line
  character(len=*), intent(in) :: comm  !! Command name 
  logical error                         !! Logical error flag
  !
  character(len=*), parameter :: rname='UV_SHIFT'
  integer, parameter :: o_file=1
  !
  type(gildas) :: hiouv
  type(uvmap_par) :: map
  character(len=filename_length) :: file
  real, allocatable :: offxy(:,:)       ! Work arrays for fields offsets
  real, allocatable :: doff(:,:)        ! Fields offsets
  integer, allocatable :: teles(:)
  integer :: nf, n
  !
  character(len=80) :: mess
  character(len=12) :: chain
  type(projection_t) :: proj, old_proj, new_proj
  real(8) :: newoff(3), newabs(3), oldabs(3)
  real(4) :: cs(2), angold
  real(8), allocatable :: rpos(:,:)
  real(8) :: freq
  logical :: precise=.true.
  logical :: shift, doit, lshift, err
  integer :: nc,nu,nv,i,ier,loff,moff,xoff,yoff,lid,ixoff,iyoff,itele
  !
  real(8) :: old(2), new(2), tabs(2), off(2)
  integer :: iv,ib,nblock
  integer :: ncode, np
  integer :: codes(3)
  real :: value
  !
  call sic_ch(line,o_file,1,file,n,.true.,error)
  if (error) return
  !
  call gildas_null(hiouv,type='UVT')
  call sic_parse_file(file,' ','.uvt',hiouv%file)
  call gdf_read_header(hiouv,error)
  if (error) return
  !
  loff = hiouv%gil%column_pointer(code_uvt_loff)
  moff = hiouv%gil%column_pointer(code_uvt_moff)
  xoff = hiouv%gil%column_pointer(code_uvt_xoff)
  yoff = hiouv%gil%column_pointer(code_uvt_yoff)
  lid  = hiouv%gil%column_pointer(code_uvt_id)
  itele  = hiouv%gil%column_pointer(code_uvt_tele)
  !
  oldabs = [hiouv%gil%a0,hiouv%gil%d0,hiouv%gil%pang]   !!! Remember map_center
  newabs = oldabs
  newoff = 0.d0
  !
  if (lid.ne.0 .and. (loff.eq.0.or.moff.eq.0)) then
    !
    ! Source ID column: check status...
    ncode = 1
    codes(1) = code_uvt_id
    if (itele.ne.0) then
      ncode = ncode+1
      codes(ncode) = code_uvt_tele
    endif
    allocate(offxy(ncode,hiouv%gil%nvisi),stat=ier)    
    call gdf_read_uvonly_codes(hiouv,offxy,codes,ncode,error)
    !
    !WWW  -  There could be issues with Same pointing, Different telescopes
    value = offxy(1,1)
    if (any(offxy(1,:).ne.value)) then 
      nf = maxval(offxy(1,:))
      write(chain,'(I12)') nf
      call map_message(seve%e,'READ','Mosaic of '//adjustl(trim(chain))//' fields with only Source ID column')
      call map_message(seve%i,'READ','Use command UV_FIELDS to specify field coordinates')
      error = .true.
      return
    else
      map%nfields = 0
      call map_message(seve%w,'READ','Degenerate mosaic of 1 field with Source ID column')
    endif    
    shift = .false.
  else if (xoff.eq.0 .and. yoff.eq.0 .and. loff.eq.0 .and. moff.eq.0) then
    call map_message(seve%i,rname,'UV data is a single field') 
    shift = .false.
    map%nfields = 0
  else if (xoff.ne.0 .or. yoff.ne.0) then
    call map_message(seve%i,rname,'Mosaic UV data is already in Pointing offsets')
    shift = .false.
    map%nfields = 0  ! Will be updated later
  else
    call map_message(seve%w,rname,'Mosaic UV data is in Phase offsets')
    !
    ! One should derive the number of fields here: Read the Phase offsets
    ! and telescope offsets if present
    !
    ncode = 2
    codes(1:2) = [code_uvt_loff,code_uvt_moff]
    if (itele.ne.0) then
      ncode = ncode+1
      codes(ncode) = code_uvt_tele
    endif
    allocate(offxy(ncode,hiouv%gil%nvisi),stat=ier)  
    if (ier.ne.0) then
      call map_message(seve%e,rname,'Memory allocation error')
      error = .true.
      return
    endif
    !
    call gdf_read_uvonly_codes(hiouv,offxy,codes,ncode,error)
    if (error) return
    !
    nv = hiouv%gil%nvisi
    np = ncode
    ixoff = 1
    iyoff = 2
    if (itele.ne.0) itele = ncode
    call mosaic_getfields (offxy,np,nv,ixoff,iyoff,itele,nf,doff,teles)
    !
    map%nfields = -nf   ! Negative: it is phase. It seems there was an error, to be checked 
    write(mess,'(A,I0,A)') 'Mosaic UV data has ',abs(map%nfields),' fields'
    call map_message(seve%i,rname,mess)
    !
    ! Compute the mean offset as phase center position
    newoff(1) = minval(doff(1,:)) + maxval(doff(1,:))
    newoff(2) = minval(doff(2,:)) + maxval(doff(2,:))
    newoff = newoff*0.5d0
    !
    call gwcs_projec(hiouv%gil%a0,hiouv%gil%d0,hiouv%gil%pang,hiouv%gil%ptyp,proj,error)
    if (error)  return
    call rel_to_abs(proj,newoff(1),newoff(2),newabs(1),newabs(2),1)
    !
    shift = .true.
    call print_change_header('PHASE_TO_POINT',hiouv,newabs,shift)
    !
    ! Set the new center so that the Offsets are relative to this one now
    hiouv%gil%a0 = newabs(1)
    hiouv%gil%d0 = newabs(2)
  endif   
  !
  ! Check for valid syntax
  if (.not.sic_present(0,2)) then
    if (sic_present(0,1).or.(map%nfields.eq.0)) then
      call map_message(seve%e,rname,'Missing or insufficient argument(s) to command')
      error = .true.
      return
    else
      call map_message(seve%w,rname,'No argument, converting Mosaic to default phase center')
    endif
  endif
  !
  ! Check if command line specifies another center and/or orientation
  call map_center(line,rname,hiouv,lshift,newabs,error)
  if (error) return
  !
  ! Restore the original Projection 
  hiouv%gil%a0 = oldabs(1)
  hiouv%gil%d0 = oldabs(2)
  hiouv%gil%pang = oldabs(3)
  !
  ! Shifting is the Combination of Phase-->Pointing conversion
  ! and User requested shift through MAP_CENTER or command line arguments
  shift = shift .or. lshift 
  doit = .false.
  !
  if (.not.shift) then
    call map_message(seve%w,rname,'No shift required')
  else
    if ((newabs(3).ne.0.0).and.(map%nfields.ne.0)) then
      call map_message(seve%w,rname,'Rotated UV Mosaic cannot be saved -- No convention adopted by IRAM')
    endif  
    !
    doit = .true.   ! Make absolutely sure we do the shift ...
    call uv_shift_header (newabs,hiouv%gil%a0,hiouv%gil%d0,hiouv%gil%pang,newoff,doit)
    ! This may have returned doit =.false. if insufficient position change
    !
    ! Verify the case of Pointing Offsets now
    if (xoff.ne.0 .or. yoff.ne.0) then      
      !
      ! One should derive the number of fields here: Read the Pointing offsets
      ! and Telescope offsets if present
      ncode = 2
      codes(1:2) = [code_uvt_xoff,code_uvt_yoff]
      if (itele.ne.0) then
        ncode = ncode+1
        codes(ncode) = code_uvt_tele
      endif        
      allocate(offxy(ncode,hiouv%gil%nvisi),stat=ier)  
      if (ier.ne.0) then
        call map_message(seve%e,rname,'Memory allocation error')
        error = .true.
        return
      endif
      !
      call gdf_read_uvonly_codes(hiouv,offxy,codes,ncode,error)
      if (error) return
      !
      nv = hiouv%gil%nvisi
      np = ncode
      ixoff = 1
      iyoff = 2
      if (itele.ne.0) itele = ncode
      call mosaic_getfields (offxy,np,nv,ixoff,iyoff,itele,nf,doff,teles)
      !
      map%nfields = nf    ! Positive: must be POINTING
      write(mess,'(A,I0,A)') 'Mosaic UV data has ',abs(map%nfields),' fields'
      call map_message(seve%i,rname,mess)
    else
      ! Conversion Phase to Point
      doit = .true. ! Force shift
    endif
    !
    if (.not.doit) then
      call map_message(seve%w,rname,'Shift is below possible precision')
      ! So, no change of Phase Center and Orientation, but the conversion
      ! from Phase to Pointing centers remains to be done.
      !
    else
      !
      ! Compute observing frequency, and new phase center in wavelengths
      !
      if (precise) then
        nc = hiouv%gil%nchan
        allocate(rpos(2,nc),stat=ier)
        do i=1,hiouv%gil%nchan
          freq = gdf_uv_frequency(hiouv,dble(i))
          rpos(1:2,i) = - freq * f_to_k * newoff(1:2)
        enddo
      else
        nc = 1
        allocate(rpos(2,1),stat=ier)
        freq = gdf_uv_frequency(hiouv)
        rpos(1:2,1) = - freq * f_to_k * newoff(1:2)
      endif
      !
      ! Define the rotation
      cs  = [1.0,0.0]
      angold = hiouv%gil%pang
      hiouv%gil%pang = newabs(3)
      cs(1)  =  cos(hiouv%gil%pang-angold)
      cs(2)  = -sin(hiouv%gil%pang-angold) !! This sign MAY BE WRONG
    endif
    !
    if (map%nfields.ne.0 .or. doit) then
      !
      ! Do things only if needed
      !
      ! BLOCK Operations -----------------------------------------------
      !
      ! Set the Blocking Factor
      nblock = space_nitems('SPACE_IMAGER',hiouv,1)
      ! Recenter all channels, Loop over line table
      ! We work in place - We do not play with UV buffers
      !
      ! Allocate respective space for each file
      allocate (hiouv%r2d(hiouv%gil%dim(1),nblock),stat=ier)
      if (failed_allocate(rname,'UV data allocation error',ier,error)) then
        call gdf_close_image(hiouv,err)
        return    
      endif
      !
      if (map%nfields.ne.0) then
        ! Prepare the Offset changes
        !
        ! The code below assumes everything is relative to the Phase Center.
        !
        if (map%nfields.lt.0) then
          ixoff = hiouv%gil%column_pointer(code_uvt_loff) 
          iyoff = hiouv%gil%column_pointer(code_uvt_moff)
        else if (map%nfields.gt.0) then
          ixoff = hiouv%gil%column_pointer(code_uvt_xoff) 
          iyoff = hiouv%gil%column_pointer(code_uvt_yoff)
        endif
        !
        hiouv%blc(2) = 1
        hiouv%trc(2) = 1
        call gdf_read_data(hiouv,hiouv%r2d,error)
        old(1) = hiouv%r2d(ixoff,1)
        old(2) = hiouv%r2d(iyoff,1)
        !
        call gwcs_projec(oldabs(1),oldabs(2),oldabs(3),hiouv%gil%ptyp,old_proj,error)  ! Previous projection system
        call gwcs_projec(newabs(1),newabs(2),newabs(3),hiouv%gil%ptyp,new_proj,error)  ! New projection system
        call rel_to_abs(old_proj,old(1),old(2),tabs(1),tabs(2),1)
        call abs_to_rel(new_proj,tabs(1),tabs(2),new(1),new(2),1)
      endif
      !
      ! Loop over line table
      hiouv%blc = 0
      hiouv%trc = 0
      !
      do ib = 1,hiouv%gil%dim(2),nblock
        write(mess,*) ib,' / ',hiouv%gil%dim(2),nblock
        call map_message(seve%i,rname,mess)
        hiouv%blc(2) = ib
        hiouv%trc(2) = min(hiouv%gil%nvisi,ib-1+nblock)
        call gdf_read_data(hiouv,hiouv%r2d,error)
        if (error) exit
        !
        nu = hiouv%gil%dim(1)
        nv = hiouv%trc(2)-hiouv%blc(2)+1
        !
        ! This rotates the U,V coordinates and Shift the Phases
        if (doit .or. map%nfields.lt.0) then
          call shift_uvdata (hiouv,nu,nv,hiouv%r2d,cs,nc,rpos)
        endif
        !
        ! This modifies the offsets
        if (map%nfields.ne.0) then
          do iv=1,nv
            off(1) = hiouv%r2d(xoff,iv)
            off(2) = hiouv%r2d(yoff,iv)
            if (any(off.ne.old)) then
              old(1) = hiouv%r2d(xoff,iv)
              old(2) = hiouv%r2d(yoff,iv)
              call rel_to_abs(old_proj,old(1),old(2),tabs(1),tabs(2),1)
              call abs_to_rel(new_proj,tabs(1),tabs(2),new(1),new(2),1)
            endif
            hiouv%r2d(xoff,iv) = new(1)
            hiouv%r2d(yoff,iv) = new(2)
          enddo
        endif
        !
        call gdf_write_data (hiouv,hiouv%r2d,error)
        if (error) exit
      enddo
      !
      !! END OF BLOCK OPERATIONS
      !
      ! Set the new Phase center and Orientation
      hiouv%gil%a0 = newabs(1)
      hiouv%gil%d0 = newabs(2)  
      hiouv%gil%pang = newabs(3)
    endif
  endif
  !
  ! Work is Done if Single Field (0) or already Pointing columns (>0)
  ! but header must be updated
  !
  ! Convert the LOFF - MOFF columns into Pointing columns if needed
  if (map%nfields.lt.0) then
    ! "Phase" columns
    hiouv%gil%column_pointer(code_uvt_xoff) = loff
    hiouv%gil%column_pointer(code_uvt_yoff) = moff
    hiouv%gil%column_size(code_uvt_xoff) = 1
    hiouv%gil%column_size(code_uvt_yoff) = 1
    !
    hiouv%gil%column_pointer(code_uvt_loff) = 0
    hiouv%gil%column_pointer(code_uvt_moff) = 0
    hiouv%gil%column_size(code_uvt_loff) = 0
    hiouv%gil%column_size(code_uvt_moff) = 0
    !
    map%nfields = abs(map%nfields)
  endif
  !
  if (doit.and.map%nfields.ne.0) then
    !
    ! For convenience, to avoid any ambiguity, we set the
    ! Pointing center equal to the Phase center in Mosaics...
    !
    hiouv%gil%ra = hiouv%gil%a0
    hiouv%gil%dec = hiouv%gil%d0 
    !
  endif
  !
  ! And now, we update the File Header
  !
  call gdf_update_header(hiouv,error)
  if (error) return
  call gdf_close_image(hiouv,error)
  if (error) return
end subroutine uv_shift_file

!
subroutine diagonal(m,n,r,c)
  integer :: m                      !! First dimension
  integer :: n                      !! Second dimension (=< M)
  real(kind=8) :: r(m,n)            !! Matrix
  real(kind=8) :: c(n)              !! Diagonal vector
  ! Local
  integer :: i
  do i=1, n
    c(i) = r(i,i)
  enddo
end subroutine diagonal
!
subroutine outfit(nc,ic,ncol,y,rms,vit,nbpar,par,epar)
  use gildas_def
  use uvfit_data
  !---------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- Support routine for UV_FIT
  !
  ! Store the fitted parameters into the output table Y
  !
  ! Format of table is, for each channel:  
  ! 1-4  RMS of fit, number of functions, number of parameters, velocity
  ! then for each function, 3+mpin*2 columns:  
  !        Function number, type of function, number of parameters
  !        then 6 times (parameter, error)
  !!
  !---------------------------------------------------------------------
  integer, intent(in) :: nc         !! Number of channels
  integer, intent(in) :: ic         !! Current channel
  integer, intent(in) :: ncol       !! Size of Y
  real, intent(out) :: y(nc,ncol)   !! Output table
  real(8), intent(in) :: rms        !! RMS of fit
  real, intent(in) :: vit           !! Velocity
  integer, intent(in) :: nbpar      !! Number of parameters
  real(8), intent(in) :: par(nbpar) !! Parameters
  real(8), intent(in) :: epar(nbpar)!! Errors
  !
  ! Local ---
  integer :: if, ip, k, kcol
  !
  ! Code ----
  y(ic,1) = rms
  y(ic,2) = nf
  y(ic,3) = nbpar
  y(ic,4) = vit
  kcol = 5
  k = 1
  do if=1, nf
    kcol = 5+(if-1)*(3+2*mpin)
    y(ic,kcol) = if
    y(ic,kcol+1) = ifunc(if)
    y(ic,kcol+2) = npfunc(if)
    kcol = kcol+3
    do ip=1, npfunc(if)
      y(ic,kcol) = par(k)
      y(ic,kcol+1) = epar(k)
      k = k+1
      kcol = kcol+2
    enddo
  enddo
end subroutine outfit
!
subroutine load_data(ndata,nx,ic,fact,visi,np,uvriw,uv_min,uv_max)
  !---------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- Support routine for UV_FIT
  !
  ! Load Data of channel IC from the input UV table into array UVRIW.
  !---------------------------------------------------------------------
  integer, intent(in) :: ndata        !! Number of visibilities
  integer, intent(in) :: nx           !! Size of a visibility
  integer, intent(in) :: ic           !! Channel number
  real, intent(in) :: fact            !! Conversion factor of baselines
  real, intent(in) :: visi(nx,ndata)  !! Visibilities
  integer, intent(out) :: np          !! Number of non zero visibilities
  real, intent(out) :: uvriw(5,ndata) !! Output array
  real, intent(in) :: uv_min          !! Min UV
  real, intent(in) :: uv_max          !! Max UV
  !
  ! Local ---
  integer :: i, irc, iic, iwc
  real :: uv1, uv2, uv
  !
  ! Code ----
  irc = 5 + 3*ic
  iic = irc + 1
  iwc = iic + 1
  np = 0
  if (uv_min.eq.0.0 .and. uv_max.eq.0.0) then
    do i = 1, ndata
      if (visi(iwc,i).gt.0) then
        np = np + 1
        uvriw(1,np) = visi(1,i) * fact
        uvriw(2,np) = visi(2,i) * fact
        uvriw(3,np) = visi(irc,i)
        uvriw(4,np) = visi(iic,i)
        uvriw(5,np) = visi(iwc,i) * 1e6
      endif
    enddo
  else
    uv1 = uv_min**2
    if (uv_max.ne.0) then
      uv2 = uv_max**2
    else
      uv2 = huge(1.0)
    endif
    do i = 1, ndata
      if (visi(iwc,i).gt.0) then
        uv = visi(1,i)**2+visi(2,i)**2
        if (uv.ge.uv1 .and. uv.lt.uv2) then
          np = np + 1
          uvriw(1,np) = visi(1,i) * fact
          uvriw(2,np) = visi(2,i) * fact
          uvriw(3,np) = visi(irc,i)
          uvriw(4,np) = visi(iic,i)
          uvriw(5,np) = visi(iwc,i) * 1e6
        endif
      endif
    enddo
  endif
  return
end subroutine load_data
!
subroutine model_data(huv,nd,nx,nc,ic1,ic2,ncol,vin,vy,if,subtract)
  use image_def
  use uvfit_data
  !---------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER --Support routine for UV_FIT
  !
  ! Subtract the model uv data for component function number IF
  ! from the input visibility data.
  !!
  !---------------------------------------------------------------------
  type (gildas), intent(in) :: huv  !! Input UV Table header
  integer, intent(in) :: nd         !! Number of visibilities
  integer, intent(in) :: nx         !! Size of a visbility
  integer, intent(in) :: nc         !! Number of channels in Fit...
  integer, intent(in) :: ic1        !! First channel
  integer, intent(in) :: ic2        !! Last channel
  integer, intent(in) :: ncol       !! Size of VY
  real, intent(inout) :: vin(nx,nd) !! Visibilities
  real, intent(in) :: vy(nc,ncol)   !! Model parameters
  integer, intent(in) :: if         !! Function number
  logical, intent(in) :: subtract   !! Subtract (Residual) or Add (Model)
  !
  ! Constants
  real(8), parameter :: pi = 3.14159265358979323846d0
  real(8), parameter :: clight = 299792458.d-6   ! in meter.mhz
  !
  ! Local ---
  real :: fact 
  integer :: j, i, k, iif, npf, kcol, ic, jc
  real(8) :: y(2), dy(2,7), paris(7), uu, vv
  !
  ! Code:
  !$OMP PARALLEL DEFAULT(NONE) &
  !$OMP & SHARED(vin,vy,if,ic1,ic2,ncol,nx,nc,nd,huv,subtract) &
  !$OMP & PRIVATE(i,j,k, ic, jc, kcol,fact, uu,vv,iif,npf,paris,y,dy)
  !$OMP DO
  do j=1, nd
    !
    ! Kcol is the first column number in result table VY for function IF
    kcol = 5+(if-1)*(3+2*mpin)
    do ic = ic1, ic2
      ! We should use gdf_uv_frequency here ?
      fact = huv%gil%val(1) * &
     &        (1.d0+huv%gil%fres/huv%gil%freq*(ic-huv%gil%ref(1)))/clight   &
     &        *pi/180.d0/3600.d0
      uu = vin(1,j)*fact
      vv = vin(2,j)*fact
      !
      ! IIF is the function type and NPF its number of parameters.
      jc = min(ic,nc)
      iif = nint(vy(jc,kcol+1))
      npf = nint(vy(jc,kcol+2))
      do i=1, npf
        paris(i) = vy(jc,kcol+3+2*(i-1))
      enddo
      call uvfit_model(iif,npf,uu,vv,paris,y,dy)
      k = 8 + 3*(ic-1)
      if (subtract) then
        vin(k,j) = vin(k,j) - y(1)
        vin(k+1,j) = vin(k+1,j) - y(2)
      else
        vin(k,j) = vin(k,j) + y(1)
        vin(k+1,j) = vin(k+1,j) + y(2)
      endif
    enddo
  enddo
  !$OMP END DO
  !$OMP END PARALLEL
end subroutine model_data
!
subroutine fitfcn(iflag,m,nvpar,x,f,fjac,ljc)
  use gildas_def
  use uvfit_data
  use gbl_message
  use imager_interfaces, only : map_message
  !$ use omp_lib
  !---------------------------------------------------------------------
  !! IMAGER -- Support routine for UV_FIT  
  !! FITFCN is called by DNLS1E
  !---------------------------------------------------------------------
  integer, intent(in) :: iflag          !! Code for print out
  integer, intent(in) :: m              !! Number of data points
  integer, intent(in) :: nvpar          !! Number of variables
  real(8), intent(in) :: x(nvpar)       !! Variable parameters
  real(8), intent(out) :: f(m)          !! Function value at each point
  integer, intent(in) :: ljc            !! First dimension of FJAC
  real(8), intent(out) :: fjac(ljc,nvpar) !! Partial derivatives
  !
  real(8), external :: denorm
  character(len=*), parameter :: rname='UV_FIT'
  !
  ! Local ---
  integer :: k, i, l, j, kpar, iif, kvpar, kf, kl
  integer :: ithread, nthread, ier
  real(8) :: uu, vv, rr, ii, ww, fact, y(2), dy(2,mpar), fa, fb
  real(8), allocatable :: swi(:)
  real(8), allocatable :: fone(:), ftwo(:)
  real(8) :: elapsed_s, elapsed_e, elapsed
  real(8), save :: elapsem 
  character(len=80) :: chain
  !
  ! Code ----
  !$ elapsed_s = omp_get_wtime()
  if (ncall.eq.0) elapsem = 0.
  if (iflag.ne.0) then
    elapsed_e = 0.
    elapsed_s = 0.
    elapsed = 0.
    ncall = ncall+1
  endif
  !  
  k = 1
  sw = 0
  !
  ! Put the variable parameters in PARS (already including the fixed ones)
  kvpar = 1
  do j=1, npar
    if (nstart(j).ge.0) then
      pars(j) = x(kvpar)
      kvpar = kvpar+1
    endif
  enddo
  !
  nthread = 1
  !$ nthread = omp_get_max_threads()
  allocate(swi(nthread),fone(nvpar),ftwo(nvpar),stat=ier)
  if (ier.ne.0) then
    write(*,*) 'Memory allocation error in FITCN'
    return
  endif
  swi = 0.0
  !
  !$OMP PARALLEL DEFAULT(none)  &
  !$OMP & SHARED(uvriw) &  ! Input Visibility array
  !$OMP & SHARED(f,fjac) & ! Ouput arrays
  !$OMP & SHARED(npuvfit,nf,nvpar,npfunc,iflag,pars,ifunc,nstart, swi) &
  !$OMP & PRIVATE(i,uu,vv,rr,ii,ww,kf,kl,fact,kpar,kvpar,j,l)  &
  !$OMP & PRIVATE(ithread, iif, y, dy, fone, ftwo, fa, fb)
  !
  ithread = 1
  !$ ithread = omp_get_thread_num()+1
  !$OMP DO
  do i=1, npuvfit
    kf = 2*i-1
    kl = 2*i
    !
    ! Get real and imaginary part of visibility
    call getvisi(npuvfit,uvriw,i,uu,vv,rr,ii,ww)
    !
    ! Initialize F and derivatives.
    ! the weights are 1/sigma**2 (within a factor 2)
    fact = ww
    !
    ! Compute F and FJAC from model
    kpar  = 1
    kvpar = 1
    if (iflag.eq.1) then
      fa = -rr
      fb = -ii
      do j = 1, nf
        iif = ifunc(j)
        call uvfit_model(iif,npfunc(j),uu,vv,pars(kpar),y,dy)
        fa = fa + y(1)
        fb = fb + y(2)
        kpar = kpar + npfunc(j)
      enddo
      f(kf) = fa*fact
      f(kl) = fb*fact
      !
    else if (iflag.eq.2) then
      fone = 0.d0
      ftwo = 0.d0
      do j = 1, nf
        iif = ifunc(j)
        call uvfit_model(iif,npfunc(j),uu,vv,pars(kpar),y,dy)
        do l = 1, npfunc(j)
          if (nstart(kpar).ge.0) then
            fone(kvpar) = fone(kvpar) + dy(1,l)
            ftwo(kvpar) = ftwo(kvpar) + dy(2,l)
            kvpar = kvpar+1
          endif
          kpar = kpar + 1
        enddo
      enddo
      do l=1, nvpar
        fjac(kf,l) = fone(l)*fact
        fjac(kl,l) = ftwo(l)*fact
      enddo
      !
    else if (iflag.eq.0) then
      continue
    endif
    !
    ! Weight appropriately:
    swi(ithread) = swi(ithread) + fact
  enddo
  !$OMP END DO
  !$OMP END PARALLEL
  !
  sw = 0.0
  do i=1,nthread
    sw = sw+swi(i)
  enddo
  !
  ! In the end: normalize by the sum of weights.
  k = 1
  if (iflag.eq.1) then
    do k = 1, 2*npuvfit
      f(k) = f(k)/sw
    enddo
  else if (iflag.eq.2) then
    !$OMP PARALLEL DEFAULT(none)  &
    !$OMP & SHARED(fjac, npuvfit, nvpar, sw) &  
    !$OMP & PRIVATE(l,k)
    !$OMP DO COLLAPSE(2)
    do l=1, nvpar
      do k=1,2*npuvfit
        fjac(k,l) = fjac(k,l)/sw
      enddo
    enddo
    !$OMP END DO
    !$OMP END PARALLEL
  endif
  if (iflag.eq.0) then
    write(*,1000) (x(i), i=1, nvpar), denorm(2*npuvfit,f)
    1000     format (10(1pg19.12))
  else
    !$ elapsed_e = omp_get_wtime()
    !$ elapsed = elapsed_e - elapsed_s
    !$ elapsem = elapsem + elapsed
    if (elapsem.ne.0) then
      write(chain,'(A,F8.3,A,I0)') 'Elapsed ',elapsem/ncall,' sec #',iflag
      call map_message(seve%d,rname,chain)
    endif
  endif
  !!  print *,'Done FITFCN'
end subroutine fitfcn
!
subroutine getvisi(n,uvriw,k,u,v,r,i,w)
  !---------------------------------------------------------------------
  !*
  ! IMAGER --  Support routine for UV_FIT
  !
  !     Obtain U, V, and the visibility from the array UVRIW.
  !!
  !---------------------------------------------------------------------
  integer, intent(in) :: n         !! Number of visibilities
  real, intent(in) :: uvriw(5,n)   !! Visibilities
  integer, intent(in) :: k         !! Desired visibility number
  real(8), intent(out) ::  u       !! U coordinate
  real(8), intent(out) ::  v       !! V coordinate
  real(8), intent(out) ::  r       !! Real part
  real(8), intent(out) ::  i       !! Imaginary part
  real(8), intent(out) ::  w       !! Weight
  !
  u = uvriw(1,k)
  v = uvriw(2,k)
  r = uvriw(3,k)
  i = uvriw(4,k)
  w = uvriw(5,k)
end subroutine getvisi
!
subroutine outpar(id,kfunc,pars,errs)
  !---------------------------------------------------------------------
  !*
  ! IMAGER -- Support routine for UV_FIT
  !
  ! Process fitted parameters to be saved, according to fitted functions
  !!
  !---------------------------------------------------------------------
  integer, intent(in) :: id    !! Function code
  integer, intent(in) :: kfunc !! Number of parameters
  real(8), intent(inout) :: pars(kfunc)  !! Parameters
  real(8), intent(inout) :: errs(kfunc)  !! Uncertainties
  ! Local -
  real(8) :: dummy, factor
  !  integer :: ipoint, icgauss, iegauss, icdisk, iedisk, iexpo
  !  parameter (ipoint=1,iegauss=2,icgauss=3,icdisk=4,iexpo=6,iedisk=9)
  !
  ! Elliptical structures:  Reorder the axes, and change the P. Angle accordingly
  ! Make sure the axes are positive.
  select case (id)
  case (2,9,13,14)
    ! E_GAUSS, E_DISK, E_SPERGEL, E_EXPO
    pars(5) = abs(pars(5))
    pars(4) = abs(pars(4))
    if (pars(4).lt.pars(5)) then
      pars(6) = pars(6)+90d0
      dummy = pars(4)
      pars(4) = pars(5)
      pars(5) = dummy
      dummy = errs(4)
      errs(4) = errs(5)
      errs(5) = dummy
    endif
    pars(6) = -90d0+mod(pars(6)+90d0,180d0) ! Main determination of PA
  case(11)
    ! E_RING 
    !    'R.A.','Dec.','Flux','Outer','Inner','Pos.Ang.','Ratio', &
    ! Swap Inner and Outer if needed
    if (pars(5).gt.pars(4)) then
      dummy = pars(4)
      pars(4) = pars(5)
      pars(5) = dummy
      dummy = errs(4)
      errs(4) = errs(5)
      errs(5) = dummy
    endif
    ! Ratio and Pos.Ang are more subtle
    ! Bring the aspect ratio < 1 to have the proper size...
    if (pars(7).gt.1.0) then
      factor = pars(7)
      pars(4) = pars(4)*factor
      pars(5) = pars(5)*factor
      errs(4) = errs(4)*factor
      errs(5) = errs(5)*factor
      pars(6) = 90.d0+pars(6) 
      pars(7) = 1./factor
      errs(7) = errs(7)/factor**2
    endif
    pars(6) = -90d0+mod(pars(6)+90d0,180d0) ! Main determination of PA
  case (3,4,6,7,8,10,12)
    ! C_GAUSS, C_DISK, EXPO, POWER-2, POWER-3, U_RING, SPERGEL
    pars(4) = abs(pars(4))     
  case (5)
    ! RING  
    pars(4) = abs(pars(4))
    pars(5) = abs(pars(5))
    if (pars(5).lt.pars(4)) then
      dummy = pars(4)
      pars(4) = pars(5)
      pars(5) = dummy
      dummy = errs(4)
      errs(4) = errs(5)
      errs(5) = dummy
    endif
  end select
end subroutine outpar

!
subroutine hogbom_cycle(rname,pflux, beam,mx,my,resid,nx,ny,               &
     &    ixbeam,iybeam, box, fracres, absres, miter, piter, niter,          &
     &    gainloop, converge, cct_list, start_iter, msk, list, nl, np, primary, weight, wtrun, &
     &    cflux, jcode, next_flux)
  use gkernel_interfaces
  use imager_interfaces, except_this=>hogbom_cycle
  use clean_def
  use clean_default
  use gbl_message
  use omp_control
  !$ use omp_lib
  !----------------------------------------------------------------------
  ! @ private-mandatory
  !*
  ! IMAGER  -- CLEAN Method HOGBOM  
  !     Deconvolve map into residual map and source list
  !-----------------------------------------------------------------------
  external :: next_flux                         !! Cumulative flux display
  character(len=*), intent(in) :: rname         !! Calling command
  logical, intent(in) :: pflux                  !! Plot cumulative flux ?
  integer, intent(in) :: mx                     !! X size of beam
  integer, intent(in) :: my                     !! Y size of beam
  integer, intent(in) :: nx                     !! X size of image
  integer, intent(in) :: ny                     !! Y size of image
  integer, intent(in) :: np                     !! Number of fields
  real, intent(in) :: beam(mx,my,np)            !! Primary beam(s)
  real, intent(inout) :: resid(nx,ny)           !! residual image
  real, intent(in) :: fracres                   !! Fractional residual
  real, intent(in) :: absres                    !! Absolute residual
  integer, intent(inout) :: miter               !! Maximum number of clean components
  integer, intent(in) :: ixbeam, iybeam         !! Beam maximum position
  integer, intent(in) :: box(4)                 !! Cleaning box
  real, intent(in) :: gainloop                  !! Clean loop gain
  integer, intent(in) :: converge               !! Convergence iteration number 
  integer, intent(out) :: niter                 !! Resulting number of Iterations
  integer, intent(in) :: piter                  !! Positive Iterations
  logical, intent(in) :: msk(nx,ny)             !! Mask for clean search
  integer, intent(in) :: nl                     !! Size of search list
  integer, intent(in) :: list(nl)               !! Search list
  real, intent(in) :: primary(np,nx,ny)         !! Primary beams
  real, intent(in) :: weight(nx,ny)             !! Weight function
  real, intent(in) :: wtrun                     !! Safety threshold on primary beams
  type(cct_lst), intent(inout) :: cct_list      !! Clean Component List
  integer, intent(in) :: start_iter             !! Starting Component Number
  integer, intent(out) :: jcode                 !! Stopping code
  real, intent(out) :: cflux                    !! Cleaned Flux
  !
  ! Local ---
  logical :: ok
  integer :: dimcum
  real, allocatable :: oldcum(:)
  real :: cum, conv, sign
  real :: valmax, valmin, f, vnew, borne, gain
  integer :: i, j, ix, iy, ip, imax, jmax, imin, jmin, k, l
  character(len=message_length) :: chain
  integer, allocatable :: imax_it(:), jmax_it(:)
  real, allocatable :: vnew_it(:)
  integer :: it, ier, nthread, mthread, ithread
  integer :: max_iter ! Maximum number of Clean Components
  !
  ! Code ----
  dimcum = converge
  allocate(oldcum(max(1,dimcum)),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'Memory allocation error')
    return
  endif
  !
  oldcum = 0.0
  !
  ! Find highest point in region to be searched
  call maxlst (resid,nx,ny,list,nl,valmax,imax,jmax,   &
     &    valmin,imin,jmin)
  write(chain,'(A,1PG10.3,A,I6,I6,A,1PG10.3,A,I6,I6)') &
    &   'Map max. ',valmax,' at ',imax,jmax,  &
    &   ', Min. ',valmin,' at ',imin,jmin
  call map_message(seve%d,rname,chain)
  !
  ! Subtract +ve and -ve peaks
  niter = 0
  if (niter.lt.piter) then
    vnew = valmax
    ix = imax
    iy = jmax
    sign = 1.0
  elseif (abs(valmin) .gt. abs(valmax)) then
    vnew = valmin
    ix = imin
    iy = jmin
    sign = -1.0
  else
    vnew = valmax
    ix = imax
    iy = jmax
    sign = 1.0
  endif
  !
  ! Setup Subtraction loop
  cum    = 0.
  niter  = 0
  conv   = 0.
  borne = max(absres,fracres*abs(vnew))
  if (np.le.1) then
    gain = gainloop / beam(ixbeam,iybeam,1)
  else
    gain = gainloop
  endif
  !
  ! Main subtraction loop
  mthread = 1
  !$  mthread = omp_get_max_threads()
  !$  if (omp_in_parallel()) then
  !$    if (omp_get_nested()) then
  !$      ! Further optimisation requires to know the number of Outer Threads
  !$      mthread = omp_inner_thread
  !$      if (omp_debug) Print *,'Already in parallel mode, Outer THREAD ',omp_outer_thread,' Inner ',omp_inner_thread
  !$    else
  !$      mthread = 1
  !$      if (omp_debug) Print *,'Already in parallel mode, Outer THREAD ',omp_outer_thread,' No Inner threads'
  !$    endif
  !$  else
  !$    mthread = omp_inner_thread
  !$    if (omp_get_nested()) then
  !$      if (omp_debug) Print *,'Activating nesting ',omp_get_max_threads(),' possible, used ',mthread
  !$    else
  !$      if (omp_debug) Print *,'No parallel, and No nesting either, ',mthread
  !$    endif
  !$  endif
  allocate(vnew_it(mthread),imax_it(mthread),jmax_it(mthread),stat=ier)
  if (ier.ne.0) then
    write(chain,'(A,I4)') 'Memory allocation error for Mthread ',mthread
    call map_message(seve%e,rname,chain)
    return
  endif
  !
  if (miter.eq.0) then
    max_iter = 2**30  ! A Large  number
  else
    max_iter = miter
  endif
  !
  niter = start_iter-1 ! Could use the cct_list%cur_iter instead.
  ok = niter.lt.max_iter .and. abs(vnew).gt.borne
  !
  ! !Print *,'VNEW at start ',vnew
  do while (ok)
    !
    ! Get the component flux
    niter = niter+1
    f = vnew * gain
    if (np.gt.1) then
      f = f * weight(ix,iy)    ! Convert to Clean component
    endif
    if (niter.gt.cct_list%max_size) then
      ! !Print *,'Re-allocting CCT list  in HOGBOM_CYCLE'
      call cct_list%reallocate()
    endif
    !
    cct_list%cc(niter)%value = f       ! Store as fractions of beam max
    cct_list%cc(niter)%ix = ix
    cct_list%cc(niter)%iy = iy
    cct_list%cc(niter)%size = 0
    cct_list%cur_size = niter          ! That one was missing...
    ! !Print *,'Niter ',niter,cct_list%cc(niter)
    !
    cum = cum + f
    if (dimcum.ne.0) then
      !
      ! Keep last DIMCUM cumulative fluxes to test convergence
      oldcum(mod(niter,dimcum)+1) = cum
      conv = sign * (cum - oldcum(mod(niter+1,dimcum)+1))
    endif
    !
    ! Plot the new point
    if (pflux) call next_flux(niter,cum,0)
    !
    ! Subtract previous component from residual map
    nthread = 1
    !
    ! Parallel programming comment:
    ! Note that the gain is significant only in case of enough primary beams.
    ! It may slow down the method quite significantly otherwise, unless
    ! the number of inner threads has been properly evaluated.
    !
    !$OMP PARALLEL DEFAULT(none) NUM_THREADS(mthread) &
    !$OMP   &   SHARED(beam,resid,primary,weight,msk) &
    !$OMP   &   SHARED(nx,ny,mx,my,np,box,niter,piter,wtrun) &
    !$OMP   &   SHARED(vnew_it,imax_it,jmax_it) &
    !$OMP   &   SHARED(ixbeam,iybeam,f)  SHARED(ix,iy) &
    !$OMP   &   PRIVATE(j,l,i,k,ip,ithread) SHARED(nthread,omp_debug)
    !
    ithread = 1
    !$  nthread = omp_get_num_threads()
    !$  ithread = omp_get_thread_num()+1
    !$  if (omp_debug.and.niter.eq.1) Print *,'Inner Hogbom Nthread ',nthread,' Ithread ',ithread
    !
    vnew_it(ithread)  = 0
    !$OMP DO SCHEDULE(STATIC,1) 
    !$ ! The type of Scheduling does not seem to affect the timing
    !$ ! significantly.  DYNAMIC may be slightly better.
    do j=1,ny
      !
      ! Proceed Row by Row
      l = j-iy+iybeam
      if (l.ge.1 .and. l.le.my) then
        !
        ! Along that row, subtract clean component if in beam
        do i = 1,nx
          k = i-ix+ixbeam
          if (k.ge.1 .and. k.le.mx) then
            if (np.le.1) then
              resid(i,j) = resid(i,j) - f*beam(k,l,1)
            else
              if (resid(i,j).ne.0) then
                do ip = 1,np
                  !
                  ! Beware of truncating the primary beam.
                  if (primary(ip,i,j).gt.wtrun) then
                    resid(i,j) = resid(i,j) -   &
     &                      f*beam(k,l,ip)*primary(ip,i,j)   &
     &                      *primary(ip,ix,iy)*weight(i,j)
                  endif
                enddo
              endif
            endif
          endif
        enddo
      endif
      !
      ! Find new maximum inside cleaning box in residual map for this row
      if ((j.ge.box(2)).and.(j.le.box(4))) then
        if (niter.lt.piter) then
          ! Force positive components
          do i = box(1), box(3)
            if (msk(i,j)) then
              if (vnew_it(ithread).lt.resid(i,j)) then
                vnew_it(ithread)=resid(i,j)
                imax_it(ithread)=i
                jmax_it(ithread)=j
              endif
            endif
          enddo
        else
          ! Do not force positivity
          do i = box(1), box(3)
            if (msk(i,j)) then
              if (abs(vnew_it(ithread)).lt.abs(resid(i,j))) then
                vnew_it(ithread)=resid(i,j)
                imax_it(ithread)=i
                jmax_it(ithread)=j
              endif
            endif
          enddo
        endif
      endif
      !
      ! Loop for next row
    enddo
    !$OMP END DO
    !$OMP END PARALLEL
    !
    ! Compute VNEW and Position for next iteration
    vnew = vnew_it(1) 
    it = 1
    do i=2,nthread
      if (abs(vnew).lt.abs(vnew_it(i))) then
        it = i
        vnew = vnew_it(i)
      endif
    enddo
    vnew = vnew_it(it)
    ix = imax_it(it)
    iy = jmax_it(it)
    !
    ! !Print *,'Niter ',niter,' < ',max_iter,niter.lt.miter
    ! !Print *,'Converge ',converge, ' > 0',(converge.gt.0)
    ! !Print *,'Vnew = ',vnew,' > Borne = ',borne,abs(vnew).gt.borne
    !
    jcode = 0
    if (sic_ctrlc()) exit
    !
    if (niter.ge.max_iter) then
      jcode = 1
      exit
    endif
    if ((converge.gt.0).and.(conv.le.0)) then
      jcode = 2
      exit
    endif
    if (abs(vnew) .le. borne) then
      jcode = 3
      exit
    endif
  enddo
  !
  cflux = cum
  deallocate(vnew_it,imax_it,jmax_it,stat=ier)
end subroutine hogbom_cycle

!! Code to manage IMAGER messages
module map_message_private
  use gpack_def
  !
  ! Identifier used for message identification
  integer :: map_message_id = gpack_global_id  ! Default value for startup message
  !
end module map_message_private
!
subroutine map_message_set_id(id)
  use map_message_private
  use gbl_message
  !---------------------------------------------------------------------
  !*
  ! IMAGER -- Message Utility  
  ! Alter library id into input id. Should be called by the library
  ! which wants to share its id with the current one.
  !!
  !---------------------------------------------------------------------
  integer, intent(in) :: id  !! Package ID
  ! Local
  character(len=message_length) :: mess
  !
  map_message_id = id
  !
  write (mess,'(A,I3)') 'Now use id #',map_message_id
  call gmessage_write(map_message_id,seve%d,'map_message_set_id',mess)
  !
end subroutine map_message_set_id
!
subroutine map_message(mkind,procname,message,colour)
  use gbl_ansicodes
  use gkernel_interfaces
  use map_message_private
  !---------------------------------------------------------------------
  ! @ public-mandatory
  !*
  ! IMAGER -- Message Utility
  !
  !   Messaging facility for the current library. Calls the low-level
  !   (internal) messaging routine with its own identifier.
  ! This is a variant of the GILDAS message, with color options added.
  !!
  !---------------------------------------------------------------------
  integer,          intent(in) :: mkind       !! Message kind
  character(len=*), intent(in) :: procname    !! Name of calling procedure
  character(len=*), intent(in) :: message     !! Message string
  integer, intent(in), optional :: colour     !! Colour of message 
  !
  ! Constants
  logical, parameter :: new=.true.         ! With updated SIC
  integer :: color_codes(0:7) ! Only Black, RGB,CYM, and White
  data color_codes /2, 3,4,6, 8,10,7, 9/
  character(len=8), parameter :: colors(10) = &
      (/ 'NONE    ',  &
         'BLACK   ',  &
         'RED     ',  &
         'GREEN   ',  &
         'YELLOW  ',  &
         'BLUE    ',  &
         'MAGENTA ',  &
         'CYAN    ',  &
         'WHITE   ',  &
         'ORANGE  ' /)
  !
  ! Code ---
  if (present(colour)) then
    if (new) then
      call gmessage_write_color(map_message_id,mkind,procname,message, &
          & colour)
    else
      call message_colour(colour)
      call gmessage_colors_swap(.false.)
      call gmessage_write(map_message_id,mkind,procname,message)
      write(*,'(A)',advance='NO') c_clear
      call gmessage_colors_swap(.true.)
    endif
  else
    call gmessage_write(map_message_id,mkind,procname,message)
  endif
  !
end subroutine map_message
!
subroutine map_iostat(mkind,procname,ier)
  use gkernel_interfaces
  use map_message_private
  !---------------------------------------------------------------------
  ! @ public
  !*
  ! IMAGER -- Message utility - IO error 
  !
  !   Output system message corresponding to IO error code IER, and
  !   using the Message facility
  !!
  !---------------------------------------------------------------------
  integer,          intent(in) :: mkind       !! Message severity
  character(len=*), intent(in) :: procname    !! Calling routine name
  integer,          intent(in) :: ier         !! IO error number
  !
  ! Local
  character(len=message_length) :: msg
  !
  if (ier.eq.0) return
  call gag_iostat(msg,ier)
  call gmessage_write(map_message_id,mkind,procname,msg)
  !
end subroutine map_iostat
!
subroutine message_colour(colour)
  use gbl_ansicodes
  !---------------------------------------------------------------------
  ! @ public
  !
  !! IMAGER --  Message Utility: Change the colour of the next message
  !---------------------------------------------------------------------
  integer, intent(in) :: colour  !! Desired colour index
  !
  character(len=12) :: chain
  !
  select case (colour)
    case(0)
      chain = c_bold//c_black
    case(1)
      chain = c_bold//c_red
    case(2)
      chain = c_bold//c_green
    case(3)
      chain = c_bold//c_blue
    case(4)
      chain = c_bold//c_cyan 
    case(5)
      chain = c_bold//c_yellow
    case(6)
      chain = c_bold//c_magenta
    case(7)
      chain = c_bold//c_white
    case default
      chain = c_clear
  end select
  write(*,'(A)',advance='NO') trim(chain)
  !
end subroutine message_colour
!
subroutine message_attribute(cattr)
  use gbl_ansicodes
  !! IMAGER -- Message Utility -- Write color or bold modifier to terminal
  character(len=*), intent(in) :: cattr  !! Attribute modifier
  !
  write(*,'(A)',advance='NO') c_start//cattr//c_end
end subroutine message_attribute

subroutine uv_squeeze_clean(nc,ccin,ccou, mic, first, last)
  use image_def
  !$ use omp_lib
  !-----------------------------------------------------------------
  ! @ private-mandatory
  !*
  ! IMAGER --  Support for UV_RESTORE
  !
  !   Compact the component list by summing up all values at the
  !   same position in a range of channels.
  !   The output list has a transposed order
  !!
  !-----------------------------------------------------------------
  integer, intent(in) :: nc           !! Number of channels
  real, intent(in) :: ccin(:,:,:)     !! Initial Clean Component List
  real, intent(out) :: ccou(:,:,:)    !! Resulting list
  integer, intent(inout) :: mic(:)    !! Number of Clean component per channel
  integer, intent(in) :: first        !! First channel
  integer, intent(in) :: last         !! Last channel
  !
  ! Local ---
  integer :: ii,jj,ic,jc,kc, scc
  integer :: ki    ! Number of different components per channel
  integer :: nin   ! Number of input channels
  logical :: doit, do_size
  integer :: ithread
  !
  ! Code ----
  ccou = 0
  !
  scc = size(ccin,1)    ! Size of a Clean Component (3 or 4)
  nin = size(ccin,2)    ! That is the number of channels
  do_size = scc.eq.4    ! Check size if needed
  !
  if (nin.eq.1) then
    ki = 0
    do ii=1,mic(1)
      if (ccin(3,1,ii).eq.0) then
        exit
      else
        doit = .true.
        do jj=1,ki
          if (ccou(1,jj,1).eq.ccin(1,1,ii)) then
            if (ccou(2,jj,1).eq.ccin(2,1,ii)) then
              if (do_size) then
                if (ccou(4,jj,1).eq.ccin(4,1,ii)) then
                  doit = .false.
                  ccou(3,jj,1) = ccou(3,jj,1) + ccin(3,1,ii)
                  exit
                endif
              else
                doit = .false.
                ccou(3,jj,1) = ccou(3,jj,1) + ccin(3,1,ii)
                exit
              endif
            endif
          endif
        enddo
        if (doit) then
          ki = ki+1
          ccou(1:scc,ki,1) = ccin(1:scc,1,ii)
        endif
      endif
    enddo
    mic(1) = ki
    !
    ! Then duplicate 
    do ic=2,last-first+1
      ccou(:,:,ic) = ccou(:,:,1)
    enddo
  else
    !
    !$OMP PARALLEL DEFAULT(none) SHARED(ccin,ccou) &
    !$OMP    & SHARED(first,last, mic, nin, do_size) &
    !$OMP    & PRIVATE(ic,jc,kc,ki, ii, doit, ithread)   
    !
    ithread = 1
    !$ ithread = omp_get_thread_num()+1
    !$OMP DO
    do ic=first,last
      jc = ic-first+1
      ki = 0
      do ii=1,mic(jc)
        kc = min(ic,nin)
        if (ccin(3,kc,ii).eq.0) then
          exit
        else
          doit = .true.
          do jj=1,ki
            if (ccou(1,jj,jc).eq.ccin(1,kc,ii)) then
              if (ccou(2,jj,jc).eq.ccin(2,kc,ii)) then
                if (do_size) then
                  if (ccou(4,jj,1).eq.ccin(4,1,ii)) then
                    doit = .false.
                    ccou(3,jj,jc) = ccou(3,jj,jc) + ccin(3,kc,ii)
                    exit
                  endif
                else
                  doit = .false.
                  ccou(3,jj,jc) = ccou(3,jj,jc) + ccin(3,kc,ii)
                  exit
                endif
              endif
            endif
          enddo
          if (doit) then
            ki = ki+1
            ccou(:,ki,jc) = ccin(:,ic,ii)
          endif
        endif
      enddo
      mic(jc) = ki
    enddo
    !$OMP END DO
    !$OMP END PARALLEL
  endif
end subroutine uv_squeeze_clean
!
subroutine uv_extract_clean(visi,ouv,nv,nc,first,last)
  !-----------------------------------------------------------------
  ! @ private-mandatory
  !*
  ! IMAGER  --  Support for UV_MAP,  UV_RESTORE and others  
  !     Extract a subset of visibilities
  !!
  !-----------------------------------------------------------------
  integer, intent(in) :: nc           !! Number of channels
  real, intent(in) :: visi(:,:)       !! Input visbilities
  real, intent(out) :: ouv(:,:)       !! Output visibilities
  integer, intent(in) :: nv           !! Number of visibilities
  integer, intent(in) :: first        !! First channel
  integer, intent(in) :: last         !! Last channel
  !
  ! Local --
  integer :: iv
  !
  ! Code ---
  do iv=1,nv
    ouv(1:7,iv) = visi(1:7,iv)
    ouv(8:,iv) = visi(5+3*first:7+3*last,iv)
  enddo
end subroutine uv_extract_clean
!
subroutine uv_clean_sizes(hcct,ccin, mic, first, last)
  use image_def
  !-----------------------------------------------------------------
  ! @ private-mandatory
  !*
  ! IMAGER  -- Support for UV_RESTORE
  !
  !   Compute the actual number of components by locating the first
  !   null. Note that if storage after that was all zeros, a
  !   dichotomic search could do that faster.
  !!
  !-----------------------------------------------------------------
  type(gildas), intent(in) :: hcct    !! header of CCT data set
  real, intent(in) :: ccin(:,:,:)     !! Clean component table
  integer, intent(out) :: mic(:)      !! Number of iterations per channel
  integer, intent(in) :: first        !! First
  integer, intent(in) :: last         !! and last channel
  !
  ! Local ---
  integer :: nc
  integer :: ni, ki
  integer :: i,ic,jc, mi
  !
  ! Code ----
  nc = hcct%gil%dim(2)  ! Number of channels
  ni = hcct%gil%dim(3)  ! Maximum number of Clean Components
  ! 
  if (nc.eq.1) then
    mi = ni
    do i=1,ni
      if (ccin(3,1,i).eq.0) then
        mi = i-1
        exit
      endif
    enddo
    mic(:) = mi
  else
    !
    mic(:) = ni ! Up to the last one
    do ic=first,last
      jc = ic-first+1
      ki = 0
      do i=1,ni
        if (ccin(3,ic,i).eq.0) then
          mic(jc) = i-1
          exit
        endif
      enddo
    enddo
  endif
end subroutine uv_clean_sizes
!
subroutine do_smodel (nc,visi,nu,nv,a,nx,ny,nf,freq,xinc,yinc,factor,mthread,subtract)
  !$ use omp_lib
  !-----------------------------------------------------------------
  ! @ private-mandatory
  !*
  ! IMAGER  --  Support for UV_RESTORE
  !
  !     Remove model visibilities from UV data set.
  !     Interpolate from a grid of values obtained by FFT before.
  !
  !     This neglects the different angular scales as a function of 
  !   frequency. It should thus be used only on a narrow frequency range.
  !!
  !-----------------------------------------------------------------
  integer, intent(in) :: nc             !! Number of channels
  integer, intent(in) :: nu             !! Visibility size
  integer, intent(in) :: nv             !! Number of visibilities
  integer, intent(in) :: nx             !! X size
  integer, intent(in) :: ny             !! Y size
  integer, intent(in) :: nf             !! Number of frequencies in FFT
  real, intent(inout) :: visi(:,:)      !! Computed visibilities
  real(8), intent(in) :: freq           !! Effective frequency
  real, intent(in)  :: factor           !! Flux factor
  complex, intent(in) ::  a(:,:,:)      !! FFT
  real(8), intent(in) :: xinc,yinc      !! Pixel sizes
  integer, intent(in) :: mthread        !! Thread number (for messages)
  logical, intent(in) :: subtract       !! Compute Diff or Model
  !
  real(8), parameter :: clight=299792458d0
  !
  ! Local ---
  real(8) :: kwx,kwy,stepx,stepy,lambda,xr,yr
  complex(8) :: aplus,amoin,azero,afin
  integer :: i,if,ic,ia,ja,old_if,izero,ithread
  !
  ! Code ----
  lambda = clight/(freq*1d6)
  stepx = 1.d0/(nx*xinc)*lambda
  stepy = 1.d0/(ny*yinc)*lambda
  !
  ! Print *,'NChannel oout ',nc,' Nchan CCT ',nf
  !
  ! Loop on visibility
  !$OMP PARALLEL DEFAULT(none) NUM_THREADS(mthread) private(izero,ithread) &
  !$OMP   SHARED(visi,a, factor,nc,nu,nv,nf,nx,ny,stepx,stepy,subtract) &
  !$OMP   PRIVATE(kwx,ia,kwy,ja,xr,yr,aplus,azero,amoin,afin,if,ic,old_if) 
  !$ ithread = omp_get_thread_num()+1
  izero = 1
  !$OMP DO
  do i = 1, nv
    !if (izero.eq.1) then
    !  Print *,'Thread ',ithread,' iv ',i
    !  izero = 0
    !endif
    kwx =  visi(1,i) / stepx + dble(nx/2 + 1)
    ia = int(kwx)
    if (ia.le.1) cycle
    if (ia.ge.nx) cycle
    kwy =  visi(2,i) / stepy + dble(ny/2 + 1)
    ja = int(kwy)
    if (ja.le.1) cycle
    if (ja.ge.ny) cycle
    !
    xr = kwx - ia
    yr = kwy - ja
    old_if = 0
    afin = 0.  ! To avoid initialization warning
    do ic=1,nc
      if = min(ic,nf)     ! If only Continuum, use it for all Planes.
      if (if.ne.old_if) then
        !
        ! Interpolate (X or Y first, does not matter in this case)
        aplus = ( (a(ia+1,ja+1,if)+a(ia-1,ja+1,if)   &
     &          - 2.d0*a(ia,ja+1,if) )*xr   &
     &          + a(ia+1,ja+1,if)-a(ia-1,ja+1,if) )*xr*0.5d0   &
     &          + a(ia,ja+1,if)
        azero = ( (a(ia+1,ja,if)+a(ia-1,ja,if)   &
     &          - 2.d0*a(ia,ja,if) )*xr   &
     &          + a(ia+1,ja,if)-a(ia-1,ja,if) )*xr*0.5d0   &
     &          + a(ia,ja,if)
        amoin = ( (a(ia+1,ja-1,if)+a(ia-1,ja-1,if)   &
     &          - 2.d0*a(ia,ja-1,if) )*xr   &
     &          + a(ia+1,ja-1,if)-a(ia-1,ja-1,if) )*xr*0.5d0   &
     &          + a(ia,ja-1,if)
        ! Then Y (or X)
        afin = ( (aplus+amoin-2.d0*azero)   &
     &          *yr + aplus-amoin )*yr*0.5d0 + azero
      endif
      old_if = if
      !
      if (subtract) then
        visi(5+3*ic,i) =  visi(5+3*ic,i) - real(afin)*factor
        visi(6+3*ic,i) =  visi(6+3*ic,i) - imag(afin)*factor
      else
        visi(5+3*ic,i) =  real(afin)*factor
        visi(6+3*ic,i) =  imag(afin)*factor
      endif
    enddo
  enddo
  !$OMP ENDDO
  !$OMP END PARALLEL
end subroutine do_smodel
! 
subroutine cube_flag_extrema(huv_call,varname,mcol,hvar)
  use clean_arrays
  use gbl_message
  use imager_interfaces, only : map_message
  !------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- Utility routine
  !   Set flagged channels to Zero and re-compute extrema
  !!
  !------------------------------------------------------------
  type(gildas), intent(in) :: huv_call !! Initial UV data
  integer, intent(in) :: mcol(2)  !! First and last channel
  character(len=*), intent(in) :: varname !! Variable name
  type(gildas), intent(inout) :: hvar     !! Data Header 
  !! data itself is in the %r3d pointer)
  !
  ! Local ---
  integer :: ic
  logical :: error
  !
  ! Code ----
  ! 1 channel only means Continuum data
  if (huv_call%gil%nchan.ne.1) then
    if (any(huv_call%img%flags.eq.0)) then
      !!Print *,'MCOL ',mcol,' Nchan ',nchan
      !!Print *,'Nullifying Filtered Channels ',huv_call%img%flags(mcol(1):mcol(2)) 
      call map_message(seve%i,'UV_MAP','Nullifying Filtered Channels ')
      do ic=1,hvar%gil%dim(3)
        if (huv_call%img%flags(ic+mcol(1)-1).eq.0) then
          hvar%r3d(:,:,ic) = 0
        endif
      enddo
    endif
  endif
  !
  ! Compute extrema
  error = .false.
  call cube_minmax(varname,hvar,error)
end subroutine cube_flag_extrema
!
subroutine cct_fft_size(mx,my,nx,ny)
  !*
  ! IMAGER -- Utility routine 
  !   Get best FFT size given the data size
  !!
  integer, intent(in) :: mx,my   !! Data size
  integer, intent(out) :: nx,ny  !! FFT Size
  !
  ! Local ---
  integer :: kx,ky
  real :: rx,ry
  !
  ! Code -- just works with powers of 2
  !
  ! Define the image size
  rx = log(float(mx))/log(2.0)
  kx = nint(rx)
  if (kx.lt.rx) kx = kx+1
  nx = 2**kx
  ry = log(float(my))/log(2.0)
  ky = nint(ry)
  if (ky.lt.ry) ky = ky+1
  ny = 2**ky
  kx = max(nx,ny)
  kx = min(4*kx,4096)
  !
  ! If the image is already fine enough, use it "as is"
  !    even if it is not a power of two...
  nx = max(kx,mx)  ! max(kx,nx) for power of two
  ny = max(kx,my)  ! max(kx,ny) for power of two
end subroutine cct_fft_size
!

subroutine get_i4list_fromsic(rname,line,opt,nf,list,error)
  use iso_c_binding
  use gkernel_interfaces
  use gkernel_types
  use gbl_message
  use gbl_format
  use imager_interfaces, only : map_message
  !
  ! @ public-mandatory
  !*
  !   SIC -- Utility routine
  !
  ! Return in the allocatable array the content of the 1-D
  ! SIC variable given as (first and only) argument of Option # opt.
  ! Return the size of the array in NF.
  ! If NF is non zero on entry, the size must match and the
  ! array is pre-allocated.
  !!
  character(len=*), intent(in) :: rname  !! Caller name
  character(len=*), intent(in) :: line   !! Command line
  integer, intent(in) :: opt             !! Option number
  integer, intent(inout) :: nf           !! Size of array. 
  !! If Zero on entry, automatic. If non zero, must match variable size.
  integer, allocatable, intent(inout) :: list(:)  !! List 
  logical, intent(out) :: error          !! Logical error flag
  !
  ! Local ---
  character(len=64) :: listname
  logical :: found
  type(sic_descriptor_t) :: desc
  integer :: na, ier
  type(c_ptr) :: cptr
  integer(4), pointer :: i1ptr(:)
  !
  ! Code ----
  call sic_ch(line,opt,1,listname,na,.true.,error)
  if (error) return
  call sic_descriptor(listname,desc,found)
  if (.not.found) then
    call sic_i4(line,opt,1,na,.true.,error)
    if (error) then
      call map_message(seve%e,rname,'Variable '//trim(listname)//' does not exists.')
      return 
    endif
    if (nf.eq.0) then
      nf = 1
      allocate(list(nf),stat=ier)
    else if (.not.allocated(list)) then
      call map_message(seve%e,rname,'List is not allocated')
      error = .true.
    endif
    if (error) return
    list(1:nf) = na
    return
  else if (desc%type.ne.fmt_i4) then
    call map_message(seve%e,rname,'Variable '//trim(listname)//' must be Integer ')
    error = .true.
    return
  endif
  if (desc%ndim.ne.1) then
    call map_message(seve%e,rname,'Variable '//trim(listname)//' must have rank 1')
    error = .true.
    return
  endif
  !
  if (nf.eq.0) then
    nf = desc%dims(1)
    allocate(list(nf),stat=ier)
  else if (nf.ne.desc%dims(1)) then
    call map_message(seve%e,rname,'Number of elements mismatch in List')
    error = .true.
  else if (.not.allocated(list)) then
    call map_message(seve%e,rname,'List is not allocated')
    error = .true.
  endif
  if (error) return
  !
  call adtoad(desc%addr,cptr,1)
  call c_f_pointer(cptr,i1ptr,[nf])
  list(1:nf) = i1ptr
end subroutine get_i4list_fromsic
!
subroutine get_r4list_fromsic(rname,line,opt,nf,list,error)
  use iso_c_binding
  use gkernel_interfaces
  use gkernel_types
  use gbl_message
  use gbl_format
  use imager_interfaces, only : map_message
  !
  ! @ public-mandatory
  !*
  !   SIC -- Utility routine
  !
  ! Return in the allocatable array the content of the 1-D
  ! SIC variable given as (first and only) argument of Option # opt.
  ! Return the size of the array in NF.
  ! If NF is non zero on entry, the size must match and the
  ! array is pre-allocated.
  !!
  character(len=*), intent(in) :: rname  !! Caller name
  character(len=*), intent(in) :: line   !! Command line
  integer, intent(in) :: opt             !! Option number
  integer, intent(inout) :: nf           !! Size of array. 
  !! If Zero on entry, automatic. If non zero, must match variable size.
  real(kind=4), allocatable, intent(inout) :: list(:)  !! List 
  logical, intent(out) :: error  !! Logical error flag
  !
  ! Local ---
  character(len=64) :: listname
  logical :: found
  type(sic_descriptor_t) :: desc
  integer :: na, ier
  real(4) :: re
  type(c_ptr) :: cptr
  real(4), pointer :: r1ptr(:)
  !
  ! Code ----
  call sic_ch(line,opt,1,listname,na,.true.,error)
  if (error) return
  call sic_descriptor(listname,desc,found)
  if (.not.found) then
    call sic_r4(line,opt,1,re,.true.,error)
    if (error) then
      call map_message(seve%e,rname,'Variable '//trim(listname)//' does not exists.')
      return 
    endif
    if (nf.eq.0) then
      nf = 1
      allocate(list(nf),stat=ier)
    else if (.not.allocated(list)) then
      call map_message(seve%e,rname,'List is not allocated')
      error = .true.
    endif
    if (error) return
    list(1:nf) = re
    return
  else if (desc%type.ne.fmt_r4) then
    call map_message(seve%e,rname,'Variable '//trim(listname)//' must be Real ')
    error = .true.
    return
  endif
  if (desc%ndim.ne.1) then
    call map_message(seve%e,rname,'Variable '//trim(listname)//' must have rank 1')
    error = .true.
    return
  endif
  if (nf.eq.0) then
    nf = desc%dims(1)
    allocate(list(nf),stat=ier)
  else if (nf.ne.desc%dims(1)) then
    call map_message(seve%e,rname,'Number of elements mismatch in List')
    error = .true.
  else if (.not.allocated(list)) then
    call map_message(seve%e,rname,'List is not allocated')
    error = .true.
  endif
  if (error) return
  !
  call adtoad(desc%addr,cptr,1)
  call c_f_pointer(cptr,r1ptr,[nf])
  list(1:nf) = r1ptr
end subroutine get_r4list_fromsic
!
subroutine compress_list_i4(ilist,ival,istart,iend,n)
  !
  ! @ public-mandatory
  !
  integer, intent(in) :: ilist(:)                 !! List of values
  integer, intent(in) :: ival                     !! Test value
  integer, allocatable, intent(out) :: istart(:)  !! Start of block
  integer, allocatable, intent(out) :: iend(:)    !! End of block
  integer, intent(out) :: n                       !! Number of blocks
  !
  ! Local --
  integer :: i, k, ilast, m
  !
  ! Code ---
  m = size(ilist)
  allocate(istart(m),iend(m))  ! Could use (m/2+1)
  if (ilist(1).eq.ival) then
    k = 1
    istart(k) = 1
    iend(1:2) = 0
  else
    k = 0
  endif
  ilast = ilist(1)
  !
  do i=2,m
    if (ilist(i).ne.ilast) then
      if (ilist(i).ne.ival) then
        if (k.ne.0) iend(k) = i-1
      else
        k = k+1
        istart(k) = i
        iend(k:k+1) = 0
      endif
      ilast = ilist(i)
    endif
  enddo
  !
  if (iend(k).eq.0) iend(k) = m
  n = k
end subroutine compress_list_i4

        

subroutine show_sources_comm(line,error)
  use image_def
  use clean_arrays
  use gbl_message
  use gkernel_interfaces
  use imager_interfaces, except_this => show_sources_comm
  !-----------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER
  !   Support for command SHOW SOURCES  
  !
  !   SHOW the position of Clean Components and their sizes proportional
  !   to the component Flux. We  must compact the CCT list before
  !   and Transpose it
  !!
  !-----------------------------------------------------------------------
  character(len=*), intent(in) :: line  !! Command line
  logical, intent(inout) :: error       !! Logical error flag
  !
  character(len=*), parameter :: rname='SHOW SOURCES'
  !
  ! Local ---
  type(gildas) :: occt
  type(gildas), save :: htcc
  real, allocatable :: ccou(:,:,:)
  real, allocatable, save :: dtcc(:,:,:)
  !
  character(len=4) :: code
  integer :: ier
  integer :: maxic, mic
  integer :: i,j,k
  !
  ! Code ----
  if (hcct%loca%size.eq.0) then
    call map_message(seve%e,rname,'No Clean Component Table')
    error = .true.
    return
  endif
  !
  if (hcct%char%code(2).eq.'COMPONENT') then
    ! This is already the right order
    call exec_program('@ p_show_tcc CCT')    
    return
  endif
  ! 
  call sic_delvariable('TCC',.false.,error)
  if (allocated(dtcc)) deallocate(dtcc)
  !
  call gildas_null (occt)
  call gildas_null (htcc)
  call gdf_copy_header(hcct,occt, error) ! Copy headers
  !
  ! We may truncate to a smaller number by parsing the command line
  maxic = hcct%gil%dim(3)   
  call uv_clean_size(hcct,dcct,mic)
  if (mic.eq.0) then
    call map_message(seve%w,rname,'No valid Clean Component')
    error = .true.
    return
  endif
  mic = min(mic,maxic)
  occt%gil%dim(3) = mic
  allocate(ccou(occt%gil%dim(1),occt%gil%dim(2),occt%gil%dim(3)),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%i,rname,'Component Allocation error')
    error = .true.
    return
  endif
  call uv_compact_clean(hcct,dcct,occt,ccou, mic)
  !
  ! Transpose it
  code = '312'
  call gdf_transpose_header(occt,htcc,code,error)
  ! Reset the projection, and Type of First Axis so that
  ! Absolute coordinates can be used (even though it is not an Image)
  htcc%gil%xaxi = 1
  htcc%gil%yaxi = 2
  htcc%char%code(1) = 'RA'
  htcc%char%code(2) = 'DEC'  
  ! Determine chunk sizes from code and dimensions. Unclear here
  ! because we are truncating the CCT Table
  if (error) return
  !
  ! Make sure this is a 3-D array, even if last dimension is 1
  htcc%gil%dim(1) = mic
  htcc%gil%ndim = 3
  allocate(dtcc(htcc%gil%dim(1),htcc%gil%dim(2),htcc%gil%dim(3)),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%w,rname,'Memory allocation error')
    error = .true.
    return
  endif
  !
  ! Transpose (simply, this should not be big arrays)
  do k=1,htcc%gil%dim(3)
    do j=1,htcc%gil%dim(2)
      do i=1,htcc%gil%dim(1)
        dtcc(i,j,k) = ccou(j,k,i)
      enddo
    enddo
  enddo
  ! Big arrays solution, but with some issue about the CCT Table size ?
  !TEST!  call transpose_getblock(occt%gil%dim,gdf_maxdims,code,iblock,error)
  !TEST!  nelems = iblock(1)
  !TEST!  nfirst = iblock(2)
  !TEST!  nmiddl = iblock(3)
  !TEST!  nsecon = iblock(4)
  !TEST!  nlast  = iblock(5)
  !TEST!  Print *,'Transposing ',iblock
  !TEST!  call trans4all(dtcc,ccou,nelems,nfirst,nmiddl,nsecon,nlast)
  !
  ! Make it accessible to Scripts as a SIC Image
  call sic_mapgildas ('TCC',htcc,error,dtcc)
  !
  ! Now display it
  call exec_program('@ p_show_tcc')
  ! 
end subroutine show_sources_comm

!
subroutine uv_chop_comm(line,rname,error)
  use phys_const
  use gkernel_interfaces
  use gkernel_types
  use image_def
  use gbl_message
  use imager_interfaces, only : map_message
  !----------------------------------------------------------------------
  ! @ private
  !*
  !   IMAGER -- Support for command UV_CHOP  
  !     UV_CHOP UvData KEY UvFileGenericName
  !
  ! "Chop" into separate files a UV data file according to the specified
  ! KEY.  KEY can be
  !   DATES
  !   FIELDS
  !   PROPER_MOTION
  ! and more choices may come (e.g. STOKES ?)
  !----------------------------------------------------------------------
  character(len=*), intent(in)    :: rname  !! Command name
  character(len=*), intent(in)    :: line   !! Command line
  logical,          intent(inout) :: error  !! Errorflag
  !
  ! Constants
  integer(kind=4), parameter :: code_mosaic_phase=1  ! Mosaic UV table with phase offsets
  integer(kind=4), parameter :: code_mosaic_point=2  ! Mosaic UV table with pointing offsets
  integer(kind=4), parameter :: code_mosaic_field=3  ! Mosaic UV table with Fields ID 
  integer, parameter :: mkey=3
  character(len=16) :: vkey(mkey)
  data vkey /'DATES','FIELDS','PROPER_MOTION'/
  !
  ! Local ---
  type(gildas) :: chopped
  type(gildas) :: whole
  real(kind=4), allocatable :: dwhole(:,:)
  real(kind=4), allocatable :: dchopped(:,:)
  character(len=filename_length) :: name
  character(len=filename_length) :: generic
  !
  character(len=65) :: chain
  character(len=16) :: key, argum
  integer(kind=4) :: code,ier,n
  integer(kind=4) :: nlast,mvisi
  integer(kind=4) :: jv,iv,ifi,kfi,nfi,mfi
  integer(kind=4) :: xcol,ycol
  real(kind=8) :: doffx,doffy,ra,dec
  real(kind=8), allocatable :: doff(:,:),dtmp(:,:)
  type(projection_t) :: proj
  !
  ! Initialization
  call gildas_null(chopped,type='UVT')
  call gildas_null(whole,type='UVT')
  !
  ! Get whole header and copy it to the chopped header
  call sic_ch(line,0,1,generic,jv,.true.,error)
  if (error) return
  call sic_parse_file(generic,' ','.uvt',whole%file)
  call gdf_read_header(whole,error)
  if (error) then
    call map_message(seve%e,rname,'Cannot open '//trim(whole%file))
    return
  endif
  !
  ! Get the keyword
  call sic_ke(line,0,2,argum,n,.true.,error)
  if (error) return
  call sic_ambigs (rname,argum,key,n,vkey,mkey,error)
  if (error) return
  !
  ! Prepare the Field headers
  call gdf_copy_header(whole,chopped,error)
  if (error) return
  call sic_ch(line,0,3,generic,jv,.false.,error)
  if (error) return
  !
  ! Keep the trailing columns as they are.
  ! If they do not exist, the only good keyword is DATES
  xcol = 0
  ycol = 0
  code = 0
  if (chopped%gil%ntrail.eq.0) then
    if (key.ne.'DATES') then
      call map_message(seve%e,rname,'No extra column, only DATES keyword allowed')
      error = .true.
      return
    endif
    xcol = code_uvt_date
    ycol = 0
  else  
    !
    ! Check mosaic kind
    if (key.eq.'FIELDS') then
      if (chopped%gil%column_pointer(code_uvt_xoff).ne.0) then
        chain = 'Splitting a Pointing mosaic'
        xcol = chopped%gil%column_pointer(code_uvt_xoff)
        ycol = chopped%gil%column_pointer(code_uvt_yoff)
        code = code_mosaic_point
      else if (chopped%gil%column_pointer(code_uvt_loff).ne.0) then
        chain = 'Splitting a Phase mosaic'
        xcol = chopped%gil%column_pointer(code_uvt_loff)
        ycol = chopped%gil%column_pointer(code_uvt_moff)
        code = code_mosaic_phase
      else if (chopped%gil%column_pointer(code_uvt_id).ne.0) then
        chain = 'Splitting fields based on Source ID only'
        xcol = chopped%gil%column_pointer(code_uvt_id)        
        ycol = 0
        code = code_mosaic_field
      endif
      call map_message(seve%i,rname,chain)
    else if (key.eq.'DATES') then
      xcol = code_uvt_date
      ycol = 0
    else if (key.eq.'PROPER_MOTION') then
      ! Undefined yet...
      ! xcol = chopped%gil%column_pointer(code_uvt_pmra)
      ! ycol = chopped%gil%column_pointer(code_uvt_pmdec)
      call map_message(seve%e,rname,'PROPER_MOTION not yet supported')
      call map_message(seve%i,rname,'Use UV_SHIFT first to get a common reference',seve%e)
      error = .true.
    endif
  endif
  nlast = chopped%gil%dim(1)
  !
  ! Read data
  allocate(dwhole(whole%gil%dim(1),whole%gil%dim(2)),stat=ier)
  if (failed_allocate(rname,'Mosaic uv table',ier,error)) return
  call gdf_read_data(whole,dwhole,error)
  if (error) return
  call map_message(seve%i,rname,'Finished reading data')
  !
  ! Scan the list of offset
  doffx = dwhole(xcol,1)
  if (ycol.ne.0) then
    doffy = dwhole(ycol,1)
  else
    doffy = 0
  endif
  !
  ! Allow up to MFI different values
  nfi = 1
  mfi = 100
  allocate(doff(3,mfi),stat=ier)
  doff(1,1) = doffx
  doff(2,1) = doffy
  doff(3,1) = 1
  !
  do iv=2,whole%gil%nvisi
    kfi = 0
    do ifi=1,nfi
      doffx = dwhole(xcol,iv)
      if (ycol.ne.0) doffy = dwhole(ycol,iv)
      if (doffx.eq.doff(1,ifi)) then
        if (doffy.eq.doff(2,ifi)) then
          kfi = ifi
          doff(3,kfi) = doff(3,kfi)+1
          exit
        endif
      endif
    enddo ! ifi
    ! New chopped => Initialize
    if (kfi.eq.0) then
      if (nfi.eq.mfi) then
        allocate(dtmp(3,2*mfi),stat=ier)
        dtmp(:,1:mfi) = doff(:,:)
        deallocate(doff)
        allocate(doff(3,2*mfi),stat=ier)
        doff(:,:) = dtmp
        deallocate(dtmp)
        mfi = 2*mfi
      endif
      nfi = nfi+1
      doff(1,nfi) = doffx
      doff(2,nfi) = doffy 
      doff(3,nfi) = 1
    endif
  enddo ! iv
  write(chain,'(A,I0,A)') 'Chopping file in ',nfi,' pieces'
  call map_message(seve%i,rname,chain)
  !
  ! Allocate enough space for chopped uv table
  mvisi = 0
  do ifi=1,nfi
    mvisi = max(nint(doff(3,ifi)),mvisi)
  enddo
  allocate(dchopped(nlast,mvisi),stat=ier)
  if (failed_allocate(rname,'Field uv table',ier,error)) return
  !
  ! Create, fill, and write the output UV tables
  call gwcs_projec(whole%gil%a0,whole%gil%d0,whole%gil%pang,whole%gil%ptyp,proj,error)
  if (error) return
  do ifi=1,nfi
    write(name,'(A,I0)') trim(generic)//'-',ifi
    call sic_parse_file(name,' ','.uvt',chopped%file)
    call map_message(seve%i,rname,'Writing '//chopped%file)
    chopped%gil%nvisi = doff(3,ifi)
    chopped%gil%dim(2) = chopped%gil%nvisi
    !
    ! No specific case for FIELDS: will end up with a degenerate Mosaic
    ! A specific case would be obtained by using FIELDS instead of NOTHING
    if (key.eq."NOTHING") then  ! Could be for FIELDS instead
      call rel_to_abs(proj,doff(1,ifi),doff(2,ifi),ra,dec,1)
      chopped%gil%ra = ra
      chopped%gil%dec = dec
      if (code.eq.code_mosaic_phase) then
        chopped%gil%a0 = ra
        chopped%gil%d0 = dec
      endif
    endif
    !
    jv = 0
    do iv=1,whole%gil%nvisi
      doffx = dwhole(xcol,iv)
      if (doffx.eq.doff(1,ifi)) then
        if (ycol.eq.0) then
          jv = jv+1
          dchopped(:,jv) = dwhole(:,iv)
        else if (dwhole(ycol,iv).eq.doff(2,ifi)) then
          jv = jv+1
          dchopped(:,jv) = dwhole(:,iv)
        endif
      endif
    enddo    
    chopped%gil%nvisi = jv
    !
    call gdf_create_image(chopped,error)
    if (error) return
    chopped%blc = 0
    chopped%trc = 0
    call gdf_write_data(chopped,dchopped,error)
    if (error) return
    call gdf_close_image(chopped,error)
    if (error) return
  enddo ! ifi
end subroutine uv_chop_comm

subroutine uv_subtract_comm(line,comm,error)
  use image_def
  use gbl_format
  use gkernel_interfaces
  use imager_interfaces, only : sub_uv_subtract, map_message 
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- Support for command  
  !     UV_SUBTRACT Integration [Factor] /FILE LineUVTable ContUVTable    
  !       [/RANGE Cmin Cmax [TYPE]]  ! Not yet implemented
  !
  !       Subtract a continuum from a line table
  !
  !   LineUVTable     The line UV table  
  !   ContUVTable     The Continuum UV Table  
  !   Integration     The smoothing time constant 
  !   Factor          Scale factor  
  !
  !!
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: line !! Command line
  character(len=*), intent(in) :: comm !! Command name
  logical, intent(inout) :: error      !! Logical error flag
  ! Constants
  character(len=*), parameter :: rname='UV_SUBTRACT'
  integer, parameter :: o_file =1  ! /FILE (mandatory...) option
  ! Local
  character(len=filename_length) :: all_table
  character(len=filename_length) :: cont_table
  character(len=filename_length) :: line_table
  real(8) :: dtime
  integer :: wcol(2)
  real :: factor
  integer :: n
  !
  ! Code 
  call sic_ch(line,o_file,1,all_table,n,.true.,error)
  if ((n.eq.0).or.error) then
    call map_message(seve%e,rname,'Missing Input Line UV table name')
    error = .true.
    return
  endif
  call sic_ch(line,o_file,2,cont_table,n,.true.,error)
  if ((n.eq.0).or.error) then
    call map_message(seve%e,rname,'Missing Continuum UV table name')
    error = .true.
    return
  endif
  !
  if (sic_narg(o_file).ge.3) then
    call sic_ch(line,o_file,3,line_table,n,.true.,error)
    if ((n.eq.0).or.error) then
      call map_message(seve%e,rname,'Missing Output Line UV table name')
      error = .true.
      return
    endif
  else
    call map_message(seve%w,rname,'Overwriting Input UV Table '//trim(all_table))
    line_table = ' '
    n = 1
  endif  
  !
  dtime = 2.0  ! Seconds
  call sic_r8(line,0,1,dtime,.false.,error)
  if (error) return
  dtime = 0.5d0*dtime
  factor = 1.0
  call sic_r4(line,0,2,factor,.false.,error)
  if (error) return
  !
  ! Need to implement the /RANGE option - Header needed for that...
  wcol = 0 ! Default to full range
  call sub_uv_subtract(all_table,cont_table,line_table(1:n),dtime,wcol,factor,error)
end subroutine uv_subtract_comm
!
subroutine sub_uv_subtract(uv_input,uv_cont,uv_output,dtime,wicol,factor,error)
  use image_def
  use gbl_format
  use gkernel_interfaces
  use imager_interfaces, except_this => sub_uv_subtract
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- Support for command UV_SUBTRACT  
  !       Subtract a continuum from a line table
  !
  ! From  original UV_SUBTRACT task created by S.Guilloteau 19-Jun-1991
  !!
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: uv_input    !! Input  UV table name
  character(len=*), intent(in) :: uv_cont     !! Continuum UV table
  character(len=*), intent(in) :: uv_output   !! Output UV table
  real(8), intent(in)  :: dtime               !! Smoothing Time
  integer, intent(in)  :: wicol(2)            !! Channel range
  real, intent(in)  :: factor                 !! Scale factor
  logical, intent(out) :: error               !! Error flag
  !
  ! Constants
  character(len=*), parameter :: rname='UV_SUBTRACT'
  real(8), parameter :: pi=3.14159265358979323846d0
  real(8), parameter :: f_to_k = 1.d0/299792458.d-6
  ! Local
  type(gildas) :: x,y,z ! Input, Continuum, Output
  character(len=filename_length) :: name
  character(len=80) :: mess
  character(len=3) :: cwrite
  real(8) :: time,stime
  integer :: wcol(2)
  logical :: err, lexist, do_over
  !
  complex(4) :: resul, self
  integer :: i,nvs,nvi,nsc,nc,n,j, k, nblock, ier
  real :: rbase(2),reel,imgi,uv(2)
  real :: kilow,weight
  real(8), allocatable :: ipw(:)
  integer, allocatable :: ipi(:)
  real(8) :: freq
  integer :: igood, ibad, sever
  !
  error = .false.
  self = cmplx(1.0,0.0)
  weight = 1.0
  wcol = wicol
  !
  call gildas_null(z, type = 'UVT')
  do_over = (len_trim(uv_output).eq.0)
  !
  ! Open continuum table
  n = len_trim(uv_cont)
  call gildas_null (y, type = 'UVT')
  name = uv_cont(1:n)
  call gdf_read_gildas (y, name, '.uvt', error)
  if (error) then
    call map_message(seve%e,rname,'Cannot read continuum UV table')
    return
  endif
  !
  ! Open Input line table
  call gildas_null (x, type = 'UVT')
  name = uv_input
  call sic_parse_file (name,' ','.uvt',x%file)
  inquire(file=trim(x%file),exist=lexist)  !! ,readwrite=cwrite)
  if (.not.lexist) then
    call map_message(seve%e,rname,'No such file '//trim(x%file))
    error = .true.
    return
  endif
  !
  if (do_over) then
    ! Rewrite to Input file 
    cwrite = 'NO  '
    inquire(file=trim(x%file),WRITE=cwrite)   ! It seems that READWRITE does not produce the expected result
    if (cwrite.eq.'YES') then
      x%loca%read = .false.
    else
      call map_message(seve%e,rname,'Input/output UV table is not Writable')
      error = .true.
      return
    endif
  else
    ! Open input file for Read only
    x%loca%read = .true.
  endif
  call gdf_read_gildas (x, name, '.uvt', error, data=.false.)
  if (error) then
    call map_message(seve%e,rname,'Cannot read input/output UV table')
    error = .true.
    return
  endif
  !
  call gdf_copy_header(x,z,error)  
  if (.not.do_over) then
    name = uv_output
    call sic_parse_file (name,' ','.uvt',z%file)    
    call gdf_create_image(z,error)
    if (error) then
      call map_message(seve%e,rname,'Cannot Create output UV table')
      return
    endif
  endif
  !
  ! All images connected -- do the job
  freq = y%gil%val(1)+y%gil%fres*(y%gil%val(1)/y%gil%freq)*((y%gil%nchan+1)*0.5-y%gil%ref(1))
  kilow = freq*f_to_k
  nsc = min(max(1,wcol(1)),y%gil%nchan)
  wcol(1) = nsc 
  if (wcol(2).eq.0) then
    wcol(2) = nsc
  else
    wcol(2) = max(1,min(wcol(2),nsc))
  endif
  !
  ! Load time variable and sort by time order
  !
  ! Sort self-cal table
  nvs = y%gil%dim(1)
  nvi = y%gil%nvisi
  allocate (ipw(nvi), ipi(nvi), stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'Memory allocation error')
    error = .true.
    return
  endif
  call dotime (nvs, nvi, y%r2d, ipw, ipi, stime)
  !
  call gdf_nitems('SPACE_GILDAS',nblock,x%gil%dim(1))
  nblock = min(nblock,x%gil%dim(2))  ! A decent number of visibilities...
  !
  allocate (x%r2d(x%gil%dim(1),nblock), stat=ier)
  nc = x%gil%nchan
  !
  ! Loop over line table
  x%blc = 0
  x%trc = 0
  igood = 0
  ibad = 0
  do i=1,x%gil%dim(2),nblock
    write(mess,*) i,' / ',x%gil%nvisi,nblock
    call map_message(seve%d,rname,mess)
    x%blc(2) = i
    x%trc(2) = min(x%gil%dim(2),i-1+nblock) 
    call gdf_read_data(x,x%r2d,error)
    if (error) exit
    k = 1
    do j=x%blc(2),x%trc(2)
      !
      ! Get time and baseline
      call getiba (x%r2d(:,k),stime,time,rbase,uv)
      !
      ! Compute the observed reference visibility for that baseline
      call geself (nvs, nvi, wcol,y%r2d,    &
     &        time,dtime,ipw,ipi,   &
     &        rbase,resul,uv)
      !
      ! No data: flag
      if (resul.eq.cmplx(0.,0.)) then
        call doflag (nc,x%r2d(:,k))
        ibad = ibad+1
      else
        ! Compute fraction of source to remove
        reel = factor*real(resul)
        imgi = factor*imag(resul)
        ! Remove source
        call dosubt (nc,x%r2d(:,k),reel,imgi)
        igood = igood+1
      endif
      k = k+1
    enddo
    ! Write through Z output (X == Z if overwriting)
    z%blc = x%blc
    z%trc = x%trc
    call gdf_write_data (z,x%r2d,error)
    if (error) exit
  enddo
  ! end loop
  if (igood.eq.0) then
    mess = 'All visibilities flagged'
    sever = seve%e
    error = .true.
  else 
    write(mess,'(A,I0,A,I0,A)') 'Subtracted ',igood,' Visibilities, flagged ',ibad,' ones'
    if (igood.gt.2*ibad) then 
      sever = seve%i
    else
      sever = seve%w
    endif
  endif
  call map_message(sever,rname,mess)
  if (.not.do_over) then
    err = .false.
    call gdf_close_image(z,err)
    error = err.or.error
  endif
  err = .false.
  call gdf_close_image(y,err)
  error = err.or.error
  call gdf_close_image(x,err)
  error = err.or.error
  !
end subroutine sub_uv_subtract

!
subroutine apply_comm(line,error)
  use gildas_def
  use gkernel_interfaces
  use imager_interfaces, except_this => apply_comm
  use gbl_message
  use clean_arrays
  !---------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- Control routine for  
  !     CALIBRATE\APPLY [Mode [Gain]] 
  !         [/FILE UvIN [UvOut]] [/FLAG] Threshold
  ! 
  ! Apply gains from the GAIN data set to the UV data set.
  ! If no available solution, keep the data as it was or flag it,
  ! according to the /FLAG option.
  ! Work on current UV data if no /FILE option.
  ! Work in place if /FILE is specified, and no UvOut argument is given
  !!
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: line  !! Command line
  logical, intent(inout) :: error       !! Logical error flag
  !
  ! Constants
  character(len=*), parameter :: rname='CALIBRATE'
  real(8), parameter :: pi=3.141592653589793d0
  integer, parameter :: o_flag=2, o_file=1
  integer, parameter :: mmode=3
  character(len=12) :: smode(mmode)
  data smode /'AMPLITUDE','DELAY','PHASE'/
  !
  ! Local ----
  character(len=80) :: mess
  real, pointer :: duv_previous(:,:), duv_next(:,:)
  real(8), allocatable :: itimg(:), it(:)
  integer, allocatable :: flagged(:)
  integer, allocatable :: idxg(:), idx(:)
  integer(4) ::  n, nvis, ncol, nvg, ndc, ier
  real(8) :: phase_gain, ampli_gain
  real(8) :: phase_seuil, ampli_seuil
  real(8) :: fdata, fgain ! Reference frequencies for Gain and UV
  real(4) :: gain, seuil
  logical :: do_flag
  character(len=12) :: mode, argum
  character(len=32) :: chain
  !
  ! /FILE option variables
  character(len=filename_length) :: file
  type (gildas) :: uvin, uvou
  logical :: dofile, err
  integer :: nblock, ib, nf, narg
  !
  ! Code ----
  error = .false.
  !
  if (hbgain%loca%size.eq.0) then
    call map_message(seve%e,rname,'Gain table is not defined')
    error = .true.
    return
  endif
  !
  gain = 1.0
  seuil = 0 ! 0 means a large number
  do_flag = sic_present(o_flag,0)
  if (do_flag) then
    call sic_r4(line,o_flag,1,seuil,.false.,error)
    if (error) return
  endif
  !
  if (sic_present(0,1)) then
    call sic_ke(line,0,1,argum,n,.true.,error)
    call sic_r4(line,0,2,gain,.false.,error)
    if (error) return
  else
    call sic_get_char('SELF_MODE',argum,n,error)
  endif    
  call sic_ambigs (rname,argum,mode,n,smode,mmode,error)
  if (error) return
  !
  if (gain.lt.0. .or. gain.gt.1.0) then
    call map_message(seve%e,rname,trim(mode)//' gain out of range [0,1]')
    error = .true.
    return
  endif
  write(chain,'(F5.2)') gain
  mess = 'Applying '//trim(mode)//' calibration with gain '//trim(chain)
  call map_message(seve%i,rname,mess)  
  !
  select case(mode)
  case ('AMPLITUDE') 
    ampli_gain = gain
    ampli_seuil = seuil
    phase_gain = 0.0
    phase_seuil = 0.0
  case ('PHASE')
    phase_gain = gain
    phase_seuil = seuil*pi/180d0
    ampli_gain = 0.0
    ampli_seuil = 0.0
  case ('DELAY')
    fgain = gdf_uv_frequency(hbgain)
    fdata = gdf_uv_frequency(huv_current)
    write(mess,'(A,F10.1,A,F10.1,A)') 'Frequencies : Data ',fdata, ',  Gain table ',fgain,' MHz'
    call map_message(seve%i,rname,mess)  
    phase_gain = gain * fdata/fgain
    phase_seuil = seuil*pi/180d0
    write(mess,'(A,F6.3)',iostat=ier) 'Phase gain is ',phase_gain
    call map_message(seve%i,rname,mess)  
    ampli_gain = 0.0
    ampli_seuil = 0.0
  end select
  !Print *,'DO_FLAG ', do_flag,' SEUIL ',seuil
  !Print *,'Phase & Ampli gain ',phase_gain,ampli_gain,' Seuils ',phase_seuil,ampli_seuil
  if (do_flag.and.seuil.ne.0) then
    if (ampli_gain.eq.0) then
      if (seuil.le.0) then
        write(chain,*) seuil
        call map_message(seve%e,rname,'Invalid threshold '//trim(chain) &
          & //' for PHASE or DELAY flagging, must be > 0')
        error = .true.
        return
      endif
      write(mess,'(A,F8.1,A)',iostat=ier) 'Flagging data with phase errors  > ',phase_seuil,' degree'
    else 
      if (seuil.le.1) then
        write(chain,*) seuil
        call map_message(seve%e,rname,'Invalid threshold '//trim(chain) &
          & //' for AMPLI flagging, must be > 1')
        error = .true.
        return
      endif
      write(mess,'(A,F8.1,A)',iostat=ier) 'Flagging data with Amplitude error  > ',ampli_seuil
    endif
    call map_message(seve%i,rname,mess)  
  endif
  !
  ! Now do the job
  nvg = hbgain%gil%dim(2)
  allocate (itimg(nvg), idxg(nvg), stat=ier)
  if (ier.ne.0) then
    error = .true.
    call map_message(seve%e,rname,'Gain work array allocation error')
    return
  endif  
  !
  dofile = sic_present(o_file,0)
  if (dofile) then
    narg = sic_narg(o_file)
    if (narg.lt.1 .or. narg.gt.2) then
      call map_message(seve%e,rname,'/FILE option requires 1 or 2 arguments')
      error = .true.
      return
    endif
    !
    ! Layout for a by-block operation, used by the /FILE option
    !
    call gildas_null (uvin, type = 'UVT')     ! Define a UVTable gildas header
    call gildas_null (uvou, type = 'UVT')     ! Define a UVTable gildas header
    !
    call sic_ch(line,o_file,1,file,nf,.true.,error)
    if (error)  return
    call gdf_read_gildas (uvin, file, '.uvt', error, data=.false.)
    if (error) return
    call gdf_copy_header(uvin,uvou,error)
    !
    if (narg.eq.2) then
      call sic_ch(line,o_file,2,file,nf,.true.,error)
      if (error) return
      call sic_parse_file(file,' ','.uvt',uvou%file)
      if (error) return
      call gdf_create_image(uvou,error)
      if (error) then
        call gdf_close_image(uvin,err)
        return    
      endif
    endif
    !
    ! Define blocking factor on data file
    !
    ! Set the Blocking Factor
    nblock = space_nitems('SPACE_IMAGER',uvin,1)
    ! Allocate respective space for each file
    ncol = uvin%gil%dim(1)
    ndc =  uvin%gil%nchan
    allocate (uvin%r2d(ncol,nblock),uvou%r2d(ncol,nblock), &
      & it(nblock), idx(nblock), flagged(nblock), stat=ier)
    if (failed_allocate(rname,'UV input data',ier,error)) then
      call gdf_close_image(uvin,err)
      if (narg.eq.2) call gdf_close_image(uvou,err)
      return
    endif
    !
    ! Loop over line table
    uvin%blc = 0
    uvin%trc = 0
    !
    do ib = 1,uvin%gil%dim(2),nblock
      write(mess,*) ib,' / ',uvin%gil%dim(2),nblock
      call map_message(seve%i,rname,mess)
      uvin%blc(2) = ib
      uvin%trc(2) = min(uvin%gil%dim(2),ib-1+nblock)
      call gdf_read_data(uvin,uvin%r2d,error)
      if (error) exit
      !
      nvis = uvin%trc(2)-uvin%blc(2)+1
      !
      ! Here do the job 
      call sub_uvcal(ncol,nvis, uvin%r2d, ndc, uvou%r2d, &
         &    idx, it, do_flag, flagged, nvg, duvbg, idxg, itimg,  &
         &    ampli_gain,phase_gain,ampli_seuil,phase_seuil,error)
      !Print *,'Done do_cal ',self%blc(2),self%trc(2),self%gil%dim(2),error
      if (error) return
      !
      if (sic_ctrlc()) then
        error = .true.
        call map_message(seve%e,rname,'Aborted by ^C')
      else
        call gdf_write_data(uvou,uvou%r2d,error)
      endif
      if (error) exit
    enddo
    !
    deallocate(uvin%r2d,uvou%r2d,stat=ier)
    call gdf_close_image(uvin,err)
    error = err.or.error
    if (narg.eq.2) then
      call gdf_close_image(uvou,err)
      error = err.or.error
    endif
    !
  else
    ! Re-select the UV data SG
!    call uvdata_select(rname,error) ! Perhaps
    !
    ! In memory version
    nvis = huv_current%gil%nvisi ! not %dim(2)
    ncol = huv_current%gil%dim(1)
    ndc =  huv_current%gil%nchan
    !
    nullify (duv_previous, duv_next)  
    call uv_find_buffers (rname,ncol,nvis,duv_previous, duv_next,error)
    if (error) return
    !
    nvg = hbgain%gil%dim(2)
    !
    ! Get a bunch of memory ...
    allocate (it(nvis), idx(nvis), flagged(nvis), stat=ier)
    if (ier.ne.0) then
      error = .true.
      call map_message(seve%e,rname,'Visibility work array allocation error')
      return
    endif
    !
    call sub_uvcal(ncol,nvis, duv_previous, ndc, duv_next, &
       &    idx, it, do_flag, flagged, nvg, duvbg, idxg, itimg,  &
       &    ampli_gain,phase_gain,ampli_seuil,phase_seuil,error)
    if (error) return
    !
    call uv_clean_buffers (duv_previous, duv_next,error)
    !
    ! Signal the change in UV data - Self Calibration also affects Weights
    call uv_new_data (weight=.true.)
  endif
end subroutine apply_comm 
!
subroutine sub_uvcal(ncol,nvis,data,ndc,cal, &
     &    index,times,do_flag,flagged,nvg,gain,indg,timesg,   &
     &    ampli_gain,phase_gain,ampli_seuil,phase_seuil,error)
  use imager_interfaces, only : map_message
  use gbl_message
  use gkernel_interfaces
  !---------------------------------------------------------------------
  ! @ public
  !*
  ! IMAGER -- Support routine for command APPLY
  !
  !   Apply phase and/or amplitude calibration to
  !   the "raw" UV data.   Phase and Amplitudes are stored in
  !   the "gain" UV table, and usually come from a previous
  !   use of Task uv_gain.    This subroutine allows to apply the
  !   corrections to a spectral line table, whatever the way the gains
  !   were computed before.
  !!
  !---------------------------------------------------------------------
  integer, intent(in) :: ncol              !! Visibility size
  integer, intent(in) :: nvis              !! Number of visibilities
  real, intent(in) :: data(ncol,nvis)      !! Visibility array
  integer, intent(in) :: ndc               !! Number of channels
  real, intent(out) :: cal(ncol,nvis)      !! Calibrated visibilities
  integer, intent(inout) :: index(nvis)    !! Visibility Index
  real(8), intent(inout) :: times(nvis)    !! Visibility Time stamp
  logical, intent(in) :: do_flag           !! Flag data with no solution
  integer, intent(inout) :: flagged(nvis)  !! Flag work array
  integer, intent(in) :: nvg               !! Number of gains
  real, intent(in) :: gain(10,nvg)         !! Gain array
  integer, intent(out) :: indg(nvg)        !! Index in gains
  real(8), intent(out) :: timesg(nvg)      !! Gain time stamp
  real(8), intent(in) :: ampli_gain        !! Amplitude gain
  real(8), intent(in) :: phase_gain        !! Phase gain
  real(8), intent(in) :: ampli_seuil       !! Amplitude threshold for flag
  real(8), intent(in) :: phase_seuil       !! Phase threshold for flag
  logical, intent(out) :: error            !! Logical Error Flag
  !
  ! Constants
  character(len=*), parameter :: rname='CALIBRATE'
  integer, parameter :: mant=256  ! ALMA maximum, after renumbering
  !
  ! Local ---
  integer :: iv, jv, k, ivg, jvg, ia, ja, kv, isev, ier, ncold
  complex :: zdata, zgain(mant,mant), zcal, zg
  real :: wg, gg
  real(8) :: t, tg, tgold
  real(8) :: ampli, phase, ampli_min, ampli_max
  real(8) :: time_step = 1.0d0
  character(len=80) :: mess, cflag
  integer :: debug,iv_first,iv_last,lc
  real :: time_lapse
  logical :: first
  complex, allocatable :: zvis(:)
  !
  ! Code ----
  debug = 0
  call sic_get_inte('DEBUG_APPLY',debug,error)
  time_lapse = 0.9  ! A little less than 1 sec in case integration time is short
  call sic_get_real('SELF_MARGIN',time_lapse,error)
  !
  allocate(zvis(nvis),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'Memory allocation error')
    error = .true.
    return
  endif
  ! Get the chronological order, for both input tables:
  do iv=1, nvis
    times(iv) = data(4,iv)*86400.d0+data(5,iv)
  enddo
  call gr8_trie (times,index,nvis,error)
  if (error) then
    call map_message(seve%e,rname,'Error sorting UV Table')
    return
  endif
  !
  do ivg=1, nvg
    timesg(ivg) = gain(4,ivg)*86400.d0+gain(5,ivg)
  enddo
  call gr8_trie (timesg,indg,nvg,error)
  if (error) then
    call map_message(seve%e,rname,'Error sorting Gain Table')
    return
  endif
  !
  if (ampli_seuil.ne.0) then
    ampli_min = 1./ampli_seuil
    ampli_max = ampli_seuil
  else
    ampli_min = 0.d0
    ampli_max = 1d30
  endif
  !
  iv = 1
  jv = index(iv)
  ivg = 1
  tgold = timesg(ivg)
  zgain = 0.0
  !
  ! The loop is done on calibration times, so
  ! there is no guarantee that a given data visibility is treated.
  !
  ! To handle this, we set a counter for each visibility, to
  ! check whether it has indeed been affected...
  !
  flagged(1:nvis) = 1
  jvg = indg(1) ! To suppress compiler warning
  cflag = ' '
  !
  if (debug.ne.0) Print *,'Starting solution search'
  do ivg = 1, nvg+1
    if (ivg.le.nvg) then
      jvg = indg(ivg)
      tg = timesg(ivg)
    else
      ! Last one, force a dummy time change
      tg = tgold+1e20
    endif
    if (debug.gt.1)         Print *, 'ivg, jvg, tg, tgold'
    if (debug.gt.1)         Print *, ivg, jvg, tg, tgold
    !
    ! Verify we are in the same "closed-loop" of antennas, i.e.
    ! same time within the allowed tolerance
    if (tg-tgold.gt.time_lapse) then  
      !
      ! Time change, apply calibration
      t = times(iv)
      jv = index(iv)
      do while (t-tgold.le.time_step)
        !               type *, 'iv,jv,t'
        !               type *, iv,jv,t
        if (t.ge.tgold-time_step) then
          ia = nint(data(6,jv))
          ja = nint(data(7,jv))
          if (debug.ge.1) Print *,'Calibrating ',ia, ja, zgain(ia,ja)
          if (zgain(ia,ja).ne.0) then
            flagged(jv) = 0 
            zg = zgain(ia,ja)
            zvis(jv) = zg   ! Remember complex gain
          else
            zvis(jv) = 1.0  ! No correction at all
          endif
        endif
        iv = iv+1
        if (iv.gt.nvis) exit
        t = times(iv)
        jv = index(iv)
        if (debug.gt.2) print *,'IV ',iv,' JV ', jv, 't-TGOLD', t-tgold
      enddo
      if (iv.gt.nvis) exit
      tgold = tg
      zgain = 0.0
    endif
    !
    ! Always fill the baseline gain array (even if new time !)
    ia = nint(gain(6,jvg))
    ja = nint(gain(7,jvg))
    if (debug.gt.0) Print *,'Setting ',ia,ja,GAIN(10,ivg), gain(10,jvg)
    zgain(ia,ja) = 0.0       ! Although already done just above
    !
    ! Sign of weight gain(10,jvg) indicates if there is a solution
    if (gain(10,jvg).gt.0) then   
      ampli = sqrt(gain(8,jvg)**2+gain(9,jvg)**2)
      phase = atan2(gain(9,jvg),gain(8,jvg))
      if (phase_seuil.gt.0) then
        if (abs(phase).gt.phase_seuil) then
          if (debug.gt.1) Print *,'Flagging ',ia,ja,' Phase ',phase,'> ',phase_seuil
          ampli = 0 ! Will be flagged...
        endif
      endif
      !    
      if (ampli.gt.ampli_min .and. ampli.lt.ampli_max) then
        !
        ! Correct (a fraction of) the phase
        phase = phase_gain*phase
        zg = cmplx(cos(phase),sin(phase))
        ! and (a fraction of) the amplitude
        ampli = 1d0-ampli_gain+ampli*ampli_gain
        zg = ampli*zg
        !
        ! Fill both baseline directions...
        zgain(ia,ja) = zg
        zgain(ja,ia) = conjg(zg)
        if (debug.gt.0) Print *,'Set ',ia,ja,zgain(ia,ja),gain(10,jvg)
      endif
    endif
  enddo
  !
  if (debug.ne.0) Print *,'Applying calibration '
  ncold = 7+3*ndc   ! Last data column
  !$OMP PARALLEL DEFAULT(none) &
  !$OMP & SHARED(data,cal,flagged,zvis,nvis,ncol,ncold,do_flag) &
  !$OMP & PRIVATE(jv,zg,gg,wg,zdata,zcal,k)
  !$OMP DO
  do jv=1,nvis
    if (flagged(jv).eq.0) then
      cal(:,jv) = data(:,jv)    ! Copy visibility
      zg = zvis(jv)             ! Retrieve complex gain
      ! Down weight all points with amplitude correction.
      !   Down-weights those which have been increased in flux,
      ! as the noise has increased too !...
      !   But do not give more weights to those whose flux has
      ! decreased, as it is a sign of problems anyway...
      ! Hence the min() function below
      gg = abs(zg)
      wg = min(1.0,gg**2)
      do k=8, ncold, 3
        zdata = cmplx(data(k,jv),data(k+1,jv))
        zcal = zdata/zg
        cal(k,jv) = real(zcal)
        cal(k+1,jv) = aimag(zcal)
        cal(k+2,jv) = data(k+2,jv)*wg
      enddo
    else if (do_flag) then
      cal(1:7,jv) = data(1:7,jv)        ! Keep information
      cal(8:ncold,jv) = 0.0            ! Nullify visibility
      if (ncol.gt.ncold) cal(ncold+1:,jv) = data(ncold+1:,jv) ! Trailing
    else
      cal(:,jv) = data(:,jv)    ! Copy visibility "as is", uncalibrated
    endif
  enddo
  !$OMP ENDDO
  !$OMP END PARALLEL
  !
  iv_first = 0
  iv_last  = 0
  kv = sum(flagged)             ! Number of un-calibrated visibilitie
  !
  if (do_flag.and.(kv.lt.1000)) then
    first = .true.
    cflag = ' '
    lc = 1
    do iv = 1,nvis
      if (flagged(iv).ne.0) then
        if (iv_first.eq.0) then
          iv_first = iv
          iv_last = iv
        else
          iv_last = iv
        endif
      else
        if (iv_last.ne.0) then
          if (first) then
            write(*,*) 'Flagged visibilities: '
            first =.false.
          endif
          call coutput(iv_first,iv_last,cflag,lc)
          iv_first = 0
          iv_last = 0
        endif
      endif
    enddo
  endif
  !
  if (iv_last.ne.0) then
    if (first) write(*,*) 'Flagged visibilities: '
    call coutput(iv_first,iv_last,cflag,lc)
    if (lc.gt.0) write(*,*) cflag
  endif
  !
  if (kv.eq.0) then
    write(mess,'(A,I0,A)') 'Calibrated all ',nvis,' visibilities'
    isev = seve%i
  else if (do_flag) then
    write(mess,'(A,I0,A,I0,A)') 'Calibrated ',nvis-kv,', flagged ',kv, &
      & ' visibilities'
    isev = seve%w
  else
    write(mess,'(A,I0,A,I0,A)') 'Calibrated ',nvis-kv,', kept ',kv, &
      & ' visibilities'
    isev = seve%w
  endif
  call map_message(isev,rname,mess)
end subroutine sub_uvcal
!
subroutine coutput(iv_first,iv_last,cflag,lc)
  !---------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- Support routine for commands APPLY and SELFCAL APPLY
  !
  !   Printout list of flagged visibilities
  !!
  !---------------------------------------------------------------------  
  integer, intent(inout) :: iv_first   !! First visibility of range
  integer, intent(inout) :: iv_last    !! Last visibility of range
  integer, intent(inout) :: lc         !! Current length of CFLAG
  character(len=*), intent(inout) :: cflag  !! Character string to be appended
  !
  ! Local ---
  integer :: nf, mc
  !
  ! Code ----
  if (iv_last.eq.0) return
  ! 
  mc = len(cflag)
  nf = iv_last-iv_first+1
  if (nf.gt.1) then
    if (lc.gt.mc-24) then
      write(*,*) cflag(1:lc-1)
      lc = 1
    else
      lc = lc+1
    endif
    write(cflag(lc:),'(A,I0,A,I0,A)')  ' [',iv_first,' - ',iv_last,'], ' 
  else
    if (lc.gt.mc-12) then
      write(*,*) cflag(1:lc-1)
      lc = 1
    else
      lc = lc+1
    endif
    write(cflag(lc:),'(1X,I0,A)') iv_first,', '
  endif
  lc = len_trim(cflag)
  iv_first = 0
  iv_last = 0
end subroutine coutput  

subroutine uv_removes_clean(nv,visi,ouv,nc,mic,dcct,freq,first,last,subtract)
  use image_def
  use gbl_message
  use imager_interfaces, only : ompget_inner_threads
  !$ use omp_lib
  !-----------------------------------------------------------------
  ! @ private-mandatory
  !*
  ! IMAGER -- Support for UV_RESTORE and similar
  !
  !     Compute visibilities for a UV data set according to a
  !     set of Clean Components, and remove them from the original
  !     UV table.
  !
  !   Slow version using machine  Sin and Cos function.
  !
  !   A semi-Slow version using interpolation from pre-tabulated
  !   Sin/Cos can be implemented, but would still need to be optimized
  !   It seems the Modulo function costs a lot, not just the Sin & Cos.
  !!
  !-----------------------------------------------------------------
  integer, intent(in) :: nv           !! Number of visibilities
  real, intent(in) :: visi(:,:)       !! UV data set
  integer, intent(in) :: nc           !! Number of channels
  integer, intent(in) :: mic(:)       !! Number of Clean Components
  real, intent(out) :: ouv(:,:)       !! Extracted UV data set
  real, intent(in) :: dcct(:,:,:)     !! Clean component
  real(8), intent(in) :: freq         !! Apparent observing frequency
  integer, intent(in) :: first        !! First channel
  integer, intent(in) :: last         !! Last channel
  logical, intent(in) :: subtract     !! Compute Diff (.TRUE.) or Model (.FALSE.)
  !
  ! Constants
  real(8), parameter :: pi=3.14159265358979323846d0
  real(8), parameter :: clight = 299792458.d-6   ! in meter and MHz units
  real(8), parameter :: f_to_k=2.d0*pi/clight    !
  !
  ! Local ---
  real(8) :: cst
  real(8) :: pidsur            ! 2*pi/Lambda  to convert D (in m) to wave numbers
  real(8) :: phase, cp, sp
  real(4) :: rvis, ivis, value
  integer ii, ir, iw
  integer oi, or, ow
  integer ic,iv,jc,kc
  !
  real :: cc_size(20), cc_count(20), cc_flux(20)
  real :: gauss, q2
  logical :: do_size
  integer :: no, icmax, scc, ncc_size
  integer :: iplane, j, jsize
  integer :: nthread
  !
  ! Code ---
  scc = size(dcct,1)      
  !SG PRINT *,'uv_removes_clean: SIZE OF DCCT ',size(dcct,1),size(dcct,2),size(dcct,3), ' NC ',nc
  !SG PRINT *,'uv_removes_clean: Number of channels ',last-first+1,' First ', first,' Last', last
  pidsur = f_to_k * freq
  !
  if (scc.ne.3) then
    ncc_size = 0
    do iplane=1,nc  ! jc = first, last
      do ic=1,mic(iplane)
        if (dcct(3,ic,iplane).eq.0) exit
        jsize = 0
        do j=1,ncc_size
          if (dcct(4,ic,iplane).eq.cc_size(j)) then
            jsize = j
            exit
          endif
        enddo
        if (jsize.eq.0) then
          ncc_size = ncc_size+1
          cc_size(ncc_size) =  dcct(4,ic,iplane)
        endif
        if (ncc_size.gt.10) exit
      enddo
    enddo
    cc_count = 0
    cc_flux = 0.
  else
    ncc_size = 1
  endif
  !
  no = ubound(mic,1)
  if (no.lt.last-first+1 .or. no.gt.ubound(dcct,3)) then
    if (no.ne.1) Print *,'Remove Clean Slow dimension error ',no,last-first+1,ubound(dcct,3)
  endif
  icmax = maxval(mic)
  if (icmax.gt.ubound(dcct,2))  then
    Print *,'Remove Clean Slow -- too many Clean Comp.',icmax,ubound(dcct,2)
  endif
  ! Print *,'CCT Bounds ',ubound(dcct),' FIRST ',first,' LAST ',last
  !
  ! Remove clean component from UV data set
  !
  ! G = flux * exp(-2i*pi(u*x0+v*y0)) * g(u,v)
  ! and for the 1-D Gaussian
  !     model = flux*4*ln2/(pi*b**2) * exp (-4*ln2*(r/b)**2)
  !     g(u,v) = exp(- pi**2/4/ln(2)*(b*q)**2)
  !     where q**2 = u**2+v**2
  !      and  b is the beam size in Radian (FWHM)
  !
  cst = pi**2/4d0/log(2D0) * (freq/clight)**2   ! Scale factor from u^2+v^2 in m^2 to radian^-2
  !
  do_size = scc.eq.4    ! Check size if needed
  !
  !$ nthread = ompget_inner_threads() 
  !$OMP PARALLEL DEFAULT(none) NUM_THREADS(nthread) &
  !$OMP    & SHARED(visi,ouv,dcct)  SHARED(pidsur,nv,first,last,mic,nc) &
  !$OMP    & PRIVATE(iv,jc,ic,kc,ir,ii,iw,or,oi,ow,phase,rvis,ivis,cp,sp) &
  !$OMP    & PRIVATE(value, q2, gauss) SHARED(do_size, cst, subtract)
  !
  !$OMP DO SCHEDULE(DYNAMIC,32)
  do iv=1,nv            ! Visibilies
    ouv(1:7,iv) = visi(1:7,iv)
    if (do_size) then
      ! Load (U,V) in radian**-1
      q2 = cst * (ouv(1,iv)**2 + ouv(2,iv)**2)
    endif
    !
    do jc = first,last  ! Channels
      ir = 5+3*jc
      ii = 6+3*jc
      iw = 7+3*jc
      !
      kc = jc-first+1
      or = 5+3*kc      
      oi = 6+3*kc
      ow = 7+3*kc
      !
      ouv(or,iv) = visi(ir,iv)
      ouv(oi,iv) = visi(ii,iv)
      kc = min(kc,nc)   ! Handle the Continuum Subtraction case 
      !
      do ic = 1,mic(kc) ! Clean components
        if (dcct(3,ic,kc).ne.0) then
          value = dcct(3,ic,kc)
          !
          ! Apply the Gauss factor if any
          if (do_size) then
            if (dcct(4,ic,kc).ne.0) then
              gauss = q2 * dcct(4,ic,kc)**2
              if (gauss.lt.40) then
                gauss = exp(-gauss)
                value = value*gauss
              else
                cycle  ! Too faint, no signal, but do not exit
              endif
            endif
          endif
          !
          ! Small bandwidth approximatione
          !   May be changed by using the element pidsur(jc) from an array
          ! of observing frequencies. Would not slow the computation
          ! 
          phase = (ouv(1,iv)*dcct(1,ic,kc) + ouv(2,iv)*dcct(2,ic,kc))*pidsur
          cp = cos(phase)
          sp = sin(phase)
          !!call cossin(phase,cp,sp)
          rvis = value*cp
          ivis = value*sp
          !
          if (subtract) then
            ouv(or,iv) = ouv(or,iv) - rvis   ! Subtract
            ouv(oi,iv) = ouv(oi,iv) - ivis
          else
            ouv(or,iv) = rvis   ! Model
            ouv(oi,iv) = ivis
          endif
        else if (iv.eq.1) then
          Print *,'Premature end of work for channel ',jc, kc, mic(kc)
          exit ! End of work, jump to next channel
        endif
      enddo             ! Clean components
      ouv(ow,iv) = visi(iw,iv)
    enddo               ! Channels
  enddo                 ! Visibilities
  !$OMP END DO
  !$OMP END PARALLEL
end subroutine uv_removes_clean
!
subroutine uv_removeh_clean(method,hprim,hclean, &
  & hcct,visi,ouv,nc,mic,fcou,freq,first,last,ifield,subtract)
  use image_def
  use clean_def
  use imager_interfaces, except_this => uv_removeh_clean
  use gbl_message
  use gkernel_interfaces
  !$ use omp_lib
  !-----------------------------------------------------------------
  ! @ private-mandatory
  !*
  ! IMAGER   -- Support for UV_RESTORE
  !
  !     Compute visibilities for a UV data set according to a
  !     set of Clean Components , and remove them from the original
  !     UV table. Valid for Mosaics, treating just one Field at
  !     a time.
  !
  !   This version is for tranpose CCT data (3 or 4,ncomp,nchannels)
  !   and uses an intermediate FFT for speed.
  !!
  !-----------------------------------------------------------------
  type(clean_par), intent(in) :: method !! Cleaning Method
  type(gildas), intent(in) :: hprim     !! header of Primary beams
  type(gildas), intent(in) :: hclean    !! header of Clean cube
  type(gildas), intent(in) :: hcct      !! header of Clean Components Table
  integer, intent(in) :: nc             !! Number of channels
  integer, intent(in) :: mic(:)         !! Number of Clean Components
  real, intent(in) :: visi(:,:)          !! Input visibilities
  real, intent(out) :: ouv(:,:)         !! Output visibilities
  real, intent(in), target :: fcou(:,:,:)   !! Clean Components
  real(8), intent(in) :: freq           !! Apparent observing frequency
  integer, intent(in) :: first          !! First channel
  integer, intent(in) :: last           !! Last channel
  integer, intent(in) :: ifield         !! Field number
  logical, intent(in) :: subtract       !! Compute Diff or Model
  !
  ! Local ---
  integer :: jc,kc,oic,olc,ier
  real, allocatable :: dmap(:,:,:)
  real, pointer :: fctmp(:,:,:)
  integer :: nx,ny
  integer :: ibeam
  real, allocatable :: primary(:,:)
  !
  oic = first
  olc = last
  !
  nx = (hcct%gil%convert(1,1)-1)*2   ! Reference pixel is at Mx/2+1
  ny = (hcct%gil%convert(1,3)-1)*2
  if ( (nx.ne.hprim%gil%dim(2)).or.(ny.ne.hprim%gil%dim(3)) ) then
    Print *,'Clean Component and Primary beam size inconsistent'
    Print *,nx,hprim%gil%dim(2)
    Print *,ny,hprim%gil%dim(3)
  endif
  ! 
  allocate(dmap(nx,ny,nc),primary(nx,ny),stat=ier)  ! This is assumed not to fail - it is unsafe
  !
  ! Loop over channels to compute the Clean Component Cube
  fctmp => fcou(:,:,:) !! oic-ic+1:) ! A voir
  do jc=oic,olc
    kc = jc-oic+1
    call clean_make_cct(method,hclean,dmap(:,:,kc:kc),fctmp(:,:,kc:kc),method%gsize)
  enddo
  !
  ! We identifiy here the most appropriate primary beam,
  ! for the current block of channels.
  !
  jc = (oic+olc)/2
  ibeam = beam_for_channel(jc,hclean,hprim)
  !
  primary = hprim%r4d(ifield,:,:,ibeam)
  call uv_removeg_clean(hcct,visi,ouv,olc-oic+1,mic(oic:olc), &
    & dmap,freq, oic, olc, primary,subtract)
end subroutine uv_removeh_clean
!
subroutine uv_removeg_clean(hcct,visi,ouv,nc,mic,rmap,freq,first,last,rprim,subtract)
  use image_def
  use imager_interfaces, except_this => uv_removeg_clean
  use gbl_message
  !$ use omp_lib
  !-----------------------------------------------------------------
  ! @ private-mandatory
  !*
  ! IMAGER  -- Support for UV_RESTORE  
  !
  !     Compute visibilities for a UV data set according to a
  !     set of Clean Components , and remove them from the original
  !     UV table
  !
  !   This version is for tranpose CCT data (3 or 4,ncomp,nchannels)
  !   and uses an intermediate FFT for speed
  !!
  !-----------------------------------------------------------------
  type(gildas), intent(in) :: hcct    !! header of Clean Components Table
  integer, intent(in) :: nc           !! Number of channels
  integer, intent(in) :: mic(:)       !! Number of Clean Components
  real, intent(in) :: visi(:,:)       !! Input visibilities
  real, intent(out) :: ouv(:,:)       !! Output visibilities
  real, intent(in) :: rmap(:,:,:)     !! Sky distribution of Clean components
  real(8), intent(in) :: freq         !! Apparent observing frequency
  integer, intent(in) :: first        !! First channel
  integer, intent(in) :: last         !! last channel
  real, intent(in) :: rprim(:,:)      !! Primary Beam for current field
  logical, intent(in) :: subtract     !! Compute Diff or Model
  !
  ! Constants
  real(8), parameter :: pi=3.14159265358979323846d0
  integer, parameter :: mscales=20
  !
  ! Local ---
  integer :: nv    ! Number of visibilities
  integer :: mv    ! Size of a visibility
  integer :: nx,ny ! Large size for FFT
  integer :: mx,my ! Small size 
  integer :: kx,ky
  complex, allocatable :: cfft(:,:,:)
  real, allocatable :: work(:)
  real, allocatable :: lmap(:,:)
  integer :: iplane,iv,ier, dim(2)
  logical :: error
  real(8) :: xinc, yinc, xref, yref, xval, yval
  integer :: mthread, lx,ly
  !
  ! Code ---
  nv = ubound(visi,2)    ! Number of Visibilities  TO BE DONE
  mv = 7+3*nc
  if (nc.ne.last-first+1) then
    Print *,'REMOVEH  Channels mistmatch',nc,first,last
  endif
  !
  ! Image size - Twice the (reference_pixel-1) by convention
  mx = (hcct%gil%convert(1,1)-1)*2
  my = (hcct%gil%convert(1,3)-1)*2
  if ((mx.ne.size(rmap,1)).or.(my.ne.size(rmap,2))) then
    Print *,'MX MY ',mx,my
    Print *,'Sizes ',size(rmap,1),size(rmap,2)
    call map_message(seve%e,'RESTORE_G','Size mismatch ')
    error = .true.
    return
  endif
  !
  nx = mx
  ny = my
  ! No reinterpolation - Will come later if needed
  ! call cct_fft_size(mx,my,nx,ny)
  !
  ! Get Virtual Memory & compute the FFT
  allocate(cfft(nx,ny,nc),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,'RESTORE_G','uv_removeg_clean -- allocation error')
    error = .true.
    return
  endif
  !
  xref = hcct%gil%convert(1,1)
  xval = hcct%gil%convert(2,1)
  xinc = hcct%gil%convert(3,1)
  yref = hcct%gil%convert(1,3)
  yval = hcct%gil%convert(2,3)
  yinc = hcct%gil%convert(3,3)
  dim = [nx,ny]
  !
  !  call fourt_plan(ftbeam,dim,2,1,1)
  kx = mx/2+1
  lx = nx/2+1
  ky = my/2+1
  ly = ny/2+1
  !
  ! Must set the number of threads according to number of channels
  ! and available Thread nesting
  mthread = 1
  !$ mthread = ompget_inner_threads()
  mthread = min(nc,mthread)
  !
  !$OMP PARALLEL IF (nc.gt.1) DEFAULT(none) NUM_THREADS(mthread) &
  !$OMP    & SHARED(rmap,rprim,cfft) &
  !$OMP    & SHARED(nc,nx,ny,mx,my,dim) &
  !$OMP    & PRIVATE(iplane,work,lmap,ier) 
  !
  allocate(work(2*max(nx,ny)),lmap(nx,ny),stat=ier)
  !!Print *,'IER ',ier, size(rprim,1), size(rprim,2)
  !$OMP DO
  do iplane=1,nc
    ! Apply primary beam
    lmap(:,:) = rprim * rmap(:,:,iplane)
    cfft(:,:,iplane) = cmplx(lmap,0.0)
    ! FOURT is now Thread-safe for the non-FFTW version.
    call fourt(cfft(:,:,iplane),dim,2,1,1,work)
    call recent(nx,ny,cfft(:,:,iplane))
  enddo
  !$OMP END DO
  deallocate(work,lmap)
  !$OMP END PARALLEL
  !
  ! Extract the visibility subset
  do iv = 1,nv
    ouv(1:7,iv) = visi(1:7,iv)
    ouv(8:mv,iv) = visi(5+3*first:7+3*last,iv)
  enddo
  !
  ! Interpolate and subtract the model visibilities
  !$ mthread = ompget_inner_threads()
  call do_smodel(nc,ouv,mv,nv,cfft,nx,ny,nc,freq,xinc,yinc,1.0,mthread,subtract)
  !
  deallocate(cfft)
end subroutine uv_removeg_clean
!
subroutine uv_removef_clean(hcct,visi,ouv,nc,mic,dcct,freq,first,last,subtract)
  use image_def
  use imager_interfaces, except_this => uv_removef_clean
  use gbl_message
  !$ use omp_lib
  !-----------------------------------------------------------------
  ! @ private-mandatory
  !*
  ! IMAGER  -- Support for UV_RESTORE
  !
  !     Compute visibilities for a UV data set according to a
  !     set of Clean Components , and remove them from the original
  !     UV table.
  !   This version is for tranpose CCT data (3 or 4,ncomp,nchannels)
  !   and uses an intermediate FFT for speed.
  !!
  !-----------------------------------------------------------------
  type(gildas), intent(in) :: hcct    !! header of Clean Components Table
  integer, intent(in) :: nc           !! Number of channels
  integer, intent(in) :: mic(:)       !! Number of Clean Components
  real, intent(in) :: visi(:,:)       !! Input visibilities
  real, intent(out) :: ouv(:,:)       !! Output visibilities
  real, intent(in) :: dcct(:,:,:)     !! Clean components
  real(8), intent(in) :: freq         !! Apparent observing mean frequency of channel range
  integer, intent(in) :: first        !! First channel
  integer, intent(in) :: last         !! Last channel
  logical, intent(in) :: subtract     !! Compute Diff or Model
  !
  ! Constants
  real(8), parameter :: pi=3.14159265358979323846d0
  integer, parameter :: mscales=20    ! Maximum number of size scales
  !
  ! Local ---
  integer :: nv    ! Number of visibilities
  integer :: mv    ! Size of a visibility
  integer :: nx,ny
  integer :: mx,my
  integer :: kx,ky
  real :: dxy
  real :: value
  complex, allocatable :: cfft(:,:,:)
  complex, allocatable :: lfft(:,:,:)
  real, allocatable :: work(:)
  integer :: iplane,ic,ix,iy,iv,ier, dim(2), mc
  logical :: error
  real(8) :: xinc, yinc, xref, yref, xval, yval
  integer :: mthread, lx,ly, scc, ncc_size, jsize, j, is
  real :: asize, cc_size(mscales), fact(mscales), cc_count(mscales), cc_flux(mscales)
  !
  ! Code ---
  !
  mc = size(mic)
  if (mc.ne.size(dcct,3)) then
    Print *,'E-Uv_RemoveF_clean : omic ',mc,', DCCT ',size(dcct,3)
  endif
  if (nc.ne.last-first+1) then
    Print *,'E-Uv_RemoveF_clean : nc ',nc,' UV range ',first,last
  endif
  mc = min(size(mic),size(dcct,3))
  !
  scc = size(dcct,1)    ! Size of a Clean Component (3 or 4)
  if (scc.ne.3) then
    ! Extended sources -- Find out number of sizes and size values
    ncc_size = 0
    do iplane=1,mc      ! mc - Number of planes in CCT
      do ic=1,mic(iplane)
        if (dcct(3,ic,iplane).eq.0) exit
        jsize = 0
        do j=1,ncc_size
          if (dcct(4,ic,iplane).eq.cc_size(j)) then
            jsize = j
            exit
          endif
        enddo
        if (jsize.eq.0) then
          ncc_size = ncc_size+1
          cc_size(ncc_size) =  dcct(4,ic,iplane)
        endif
        if (ncc_size.gt.mscales) exit
      enddo
    enddo
    cc_count = 0
    cc_flux = 0.
  else
    ! Simple point sources
    ncc_size = 1
  endif
  !
  nv = ubound(visi,2)      ! Number of Visibilities TO BE DONE
  ! ! Print *,'Number of visibilities ',nv,' in removef_clean'
  mv = 7+3*(last-first+1)  ! Size of an output visibility
  !
  ! Image size - Twice the (reference_pixel-1) by convention
  mx = (hcct%gil%convert(1,1)-1)*2
  my = (hcct%gil%convert(1,3)-1)*2
  !
  call cct_fft_size(mx,my,nx,ny)
  !
  ! Get Virtual Memory & compute the FFT
  allocate(cfft(nx,ny,mc),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,'UV_RESTORE','uv_removef_clean -- allocation error')
    error = .true.
    return
  endif
  !
  xref = hcct%gil%convert(1,1)
  xval = hcct%gil%convert(2,1)
  xinc = hcct%gil%convert(3,1)
  yref = hcct%gil%convert(1,3)
  yval = hcct%gil%convert(2,3)
  yinc = hcct%gil%convert(3,3)
  dim = [nx,ny]
  !
  !  call fourt_plan(ftbeam,dim,2,1,1)
  kx = mx/2+1
  lx = nx/2+1
  ky = my/2+1
  ly = ny/2+1
  !
  ! Must set the number of threads according to number of channels
  ! and available Thread nesting
  mthread = 1
  !$ mthread = ompget_inner_threads()
  mthread = min(nc,mthread)
  !
  if (scc.eq.3) then
    ! Simple point sources
    !
    !$OMP PARALLEL IF (mc.gt.1) DEFAULT(none) NUM_THREADS(mthread) SHARED(dcct,cfft) &
    !$OMP    & SHARED(mc,mic,nx,ny,mx,my,dim,xinc,yinc,xref,yref,xval,yval) &
    !$OMP    & PRIVATE(iplane,ic,ix,iy,value,ier) PRIVATE(work) &
    !$OMP    & PRIVATE(dxy) SHARED(kx,lx,ky,ly)
    !
    allocate(work(2*max(nx,ny)),stat=ier)
    !$OMP DO
    do iplane=1,mc      
      cfft(:,:,iplane) = 0.0
      do ic=1,mic(iplane)
        if (dcct(3,ic,iplane).eq.0) exit
        !
        value = dcct(3,ic,iplane)
        ! The NINT is required because of rounding errors
        ix = nint( (dcct(1,ic,iplane)-xval) / xinc + xref )
        iy = nint( (dcct(2,ic,iplane)-yval) / yinc + yref )
        cfft(ix-kx+lx,iy-ky+ly,iplane) = cfft(ix-kx+lx,iy-ky+ly,iplane) + &
          & cmplx(value,0.0)
      enddo
      !
      ! FOURT is now Thread-safe for the non-FFTW version.
      call fourt(cfft(:,:,iplane),dim,2,1,1,work)
      call recent(nx,ny,cfft(:,:,iplane))
    enddo
    !$OMP END DO
    deallocate(work)
    !$OMP END PARALLEL
    !
  else
    ! Variable size components
    !
    !$OMP PARALLEL IF (mc.gt.1) DEFAULT(none) NUM_THREADS(mthread) SHARED(dcct,cfft) &
    !$OMP    & SHARED(nc,mic,nx,ny,mx,my,dim,xinc,yinc,xref,yref,xval,yval, fact) &
    !$OMP    & PRIVATE(iplane,ic,ix,iy,is,value,ier) PRIVATE(work) &
    !$OMP    & PRIVATE(asize, lfft) SHARED(kx,lx,ky,ly,cc_size,ncc_size) &
    !$OMP    & PRIVATE(cc_count,cc_flux)
    !
    allocate(work(2*max(nx,ny)),lfft(nx,ny,ncc_size),stat=ier)
    !$OMP DO
    do iplane=1,nc
      cfft(:,:,iplane) = 0.0
      cc_count = 0
      cc_flux = 0.0
      lfft = cmplx(0.,0.)
      do ic=1,mic(iplane)
        if (dcct(3,ic,iplane).eq.0) exit
        !
        value = dcct(3,ic,iplane)
        ! The NINT is required because of rounding errors
        ix = nint( (dcct(1,ic,iplane)-xval) / xinc + xref )
        iy = nint( (dcct(2,ic,iplane)-yval) / yinc + yref )
        asize = dcct(4,ic,iplane)
        do is=1,ncc_size
          if (cc_size(is).eq.asize) then
            lfft(ix-kx+lx,iy-ky+ly,is) = lfft(ix-kx+lx,iy-ky+ly,is) + &
              & cmplx(value,0.0)
            cc_count(is) = cc_count(is)+1
            cc_flux(is) = cc_flux(is)+value
            exit
          endif
        enddo
      enddo
      !
      do is=1,ncc_size
        ! FOURT is now Thread-safe for the non-FFTW version.
        call fourt(lfft(:,:,is),dim,2,1,1,work)
        ! For flux normalisation
        ! fact = cmajor*cminor*pi/(4.0*log(2.0))   &
        !     &    /abs(xinc*yinc)/(nx*ny)
        ! For simple FFT normalization  1./(nx*ny)
        if (cc_size(is).ne.0) then
          ! Factor is just 1.0 here, since we work in total flux
          ! and directly in the Fourier Plane
          call mulgau(lfft(:,:,is),nx,ny,   &
               &    cc_size(is),cc_size(is),0.0,  &
               &    1.0,real(xinc),real(yinc),-1)
        endif
        !
        cfft(:,:,iplane) = cfft(:,:,iplane) + lfft(:,:,is)
      enddo
      !
      call recent(nx,ny,cfft(:,:,iplane))
    enddo
    !$OMP END DO
    deallocate(work)
    !$OMP END PARALLEL
    !
  endif
  !
  ! Extract the visibility subset
  do iv = 1,nv
    ouv(1:7,iv) = visi(1:7,iv)
    ouv(8:mv,iv) = visi(5+3*first:7+3*last,iv)
  enddo
  !
  ! Interpolate and subtract the model visibilities
  !$ mthread = ompget_inner_threads()
  call do_smodel(nc,ouv,mv,nv,cfft,nx,ny,mc,freq,xinc,yinc,1.0,mthread,subtract)
  !
  deallocate(cfft)
end subroutine uv_removef_clean
!
subroutine cossin(phase,rcos,rsin)
  !-------------------------------------------------------
  !*
  ! Semi-Fast,  Semi-accurate Sin/Cos pair computation
  ! using (not yet clever) interpolation from a precise
  ! loop-up table
  !
  ! A solution using Taylor expansion and symmetries
  ! would be faster and more accurate. The speed is
  ! unfortunately controlled by the Modulo function.
  !    Might become faster if a simple test is made
  ! to avoid this Modulo.  To be developped as needed.
  !! 
  !-------------------------------------------------------
  real(8), intent(inout) :: phase  !! Phase value (radian)
  real(8), intent(out) :: rcos     !! Approximate Cosine
  real(8), intent(out) :: rsin     !! Approximate Sine
  !
  ! Constants
  real(8), parameter :: pi=3.14159265358979323846d0
  integer, parameter :: mcos=2048
  integer, save :: ncos = 0
  real(8), save :: cosine(mcos)
  real(8), save :: sine(mcos)
  ! Local ---
  real(8), save :: rstep
  real(8) :: rdeg
  integer :: i
  logical :: minus
  !
  if (.TRUE.) then
  !
  ! Use accurate value
    rcos = cos(phase)
    rsin = sin(phase)
    return
  endif
  !
  ! Approximate solution below
  if (ncos.eq.0) then
    ncos = mcos
    rstep = 2.01d0*pi/mcos
    do i=1,ncos
      rdeg = (i-1)*rstep
      cosine(i) = cos(rdeg)
      sine(i) = sin(rdeg)
    enddo
  endif
  !
  ! Unclear why 0.5*step offset is added ? 
  if (phase.ge.0) then
    minus =.false.
    rdeg = modulo(phase,2.0d0*pi)+0.5d0*rstep
  else
    minus = .true.
    rdeg = modulo(-phase,2.0d0*pi)+0.5d0*rstep
  endif
  rdeg = rdeg/rstep
  i = int(rdeg)
  rdeg = rdeg - i
  i = i+1
  ! One could do better also by noting the Sin/Cos are
  ! the derivatives of Cos/Sin...
  rcos = (1.0-rdeg)*cosine(i) + rdeg*cosine(i+1)
  rsin = (1.0-rdeg)*sine(i) + rdeg*sine(i+1)
  if (minus) rsin = -rsin
end subroutine cossin
!

subroutine compresswcl(wcl,ncl)
  use clean_def
  !----------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- CLEAN   Internal routine!
  !   Compress list of component in (cct_par) format
  !!
  !----------------------------------------------------------------------
  integer, intent(inout) :: ncl          !! Number of clean components
  type(cct_par), intent(inout) :: wcl(*) !! Clean component list
  !
  ! Local
  integer :: i,mcl
  !
  ! Code
  mcl = 1
  do i=2,ncl
    if (wcl(i)%value.ne.0) then
      mcl = mcl+1
      if (mcl.ne.i) then
        wcl(mcl) = wcl(i)
      endif
    endif
  enddo
  !
  if (mcl.lt.ncl) then
    wcl(mcl+1)%ix = 0
    wcl(mcl+1)%iy = 0
    wcl(mcl+1)%value= 0
  endif
  ncl = mcl
end subroutine compresswcl
!
subroutine remisajour (clean,resid,tfbeam,fcomp,   &
     &    wcl,ncl,nx,ny,wfft,   &
     &    np,primary,weight,wtrun)
  use gkernel_interfaces, only : fourt
  use clean_def
  use clean_default
  !----------------------------------------------------------------------
  ! @ public
  !*
  ! IMAGER --  CLEAN   Internal routine
  !
  !   Subtract last major cycle components from residual map.
  !!
  !----------------------------------------------------------------------
  integer, intent(in) :: nx,ny    !! Problem size
  integer, intent(in) :: ncl      !! Number of clean components
  integer, intent(in) :: np       !! Number of primary beams
  type(cct_par), intent(in) :: wcl(ncl)   !! Clean component list
  real, intent(in) :: tfbeam(nx,ny,np)    !! TF of dirty beams
  complex, intent(inout) :: fcomp(nx,ny)  !! Work area
  real, intent(inout) :: clean(nx,ny)     !! Clean map
  real, intent(inout) :: resid(nx,ny)     !! Residual map
  real, intent(in) :: primary(np,nx,ny)   !! Primary beams
  real, intent(in) :: weight(nx,ny)       !! Flat field weights
  real, intent(in) :: wtrun               !! Truncation of mosaic
  real, intent(in) :: wfft(*)             !! work fft area
  !
  ! Local ---
  integer i,j,k,ndim,nn(2),ip
  !
  ! Code ----
  ndim = 2
  !
  ! One could compress in place the Clean Component List
  if (np.eq.1) then
    nn(1) = nx
    nn(2) = ny
    fcomp = 0.0
    do k = 1,ncl
      fcomp(wcl(k)%ix,wcl(k)%iy) = cmplx(wcl(k)%value,0.0)
    enddo
    call fourt(fcomp,nn,ndim,-1,0,wfft)
    fcomp = fcomp*tfbeam(:,:,1)
    call fourt(fcomp,nn,ndim,1,1,wfft)
    resid = resid-real(fcomp)
  else
    ! This may change later, when using smaller dirty beams
    nn(1) = nx
    nn(2) = ny
    !
    ! Optimized by using CLEAN to store sum of components before multiplying
    ! by the weights to subtract from the Residuals
    clean = 0.0
    do ip=1,np
      fcomp = 0.0
      do k=1,ncl
        fcomp(wcl(k)%ix,wcl(k)%iy) = wcl(k)%value   &
     &          * primary(ip,wcl(k)%ix,wcl(k)%iy)
      enddo
      call fourt(fcomp,nn,ndim,-1,0,wfft)
      fcomp = fcomp*tfbeam(:,:,ip)
      call fourt(fcomp,nn,ndim,1,1,wfft)
      do j=1,ny
        do i=1,nx
          if (primary(ip,i,j).gt.wtrun) then
            clean(i,j) = clean(i,j) + real(fcomp(i,j))   &
     &              *primary(ip,i,j)
          endif
        enddo
      enddo
    enddo
    resid = resid - clean*weight
  endif
end subroutine remisajour
!
subroutine comshi (beam,nx,ny,ix,iy,shift)
  use gbl_message
  use imager_interfaces, only : map_message
  !-----------------------------------------------------
  ! @ private
  !
  ! IMAGER -- Shift beam if needed
  !-----------------------------------------------------
  integer, intent(in) :: nx,ny     !! X,Y Size
  integer, intent(in) :: ix,iy     !! Position of maximum
  real, intent(in) :: beam(nx,ny)  !! Beam
  integer, intent(out) :: shift(3) !! Shift information
  !
  ! Local ---
  real :: tol
  character(len=120) :: mess
  !
  ! Code
  ! Attempt to find where is the true maximum of the (SYMMETRIC) beam
  ! based on a fit by a parabola in 9 points around maximum
  !
  tol = 1e-4*beam(ix,iy)
  shift(3) = 1
  if (abs(beam(ix-1,iy-1)-beam(ix+1,iy+1)).lt.tol) then
    shift(1) = 0
    shift(2) = 0
    shift(3) = 0
  elseif (abs(beam(ix+1,iy+1)-beam(ix,iy)).lt.tol) then
    shift(1) = 1
    shift(2) = 1
  elseif (abs(beam(ix-1,iy-1)-beam(ix,iy)).lt.tol) then
    shift(1) = -1
    shift(2) = -1
  elseif (abs(beam(ix+1,iy-1)-beam(ix,iy)).lt.tol) then
    shift(1) =  1
    shift(2) = -1
  elseif (abs(beam(ix-1,iy+1)-beam(ix,iy)).lt.tol) then
    shift(1) = -1
    shift(2) = 1
  elseif (abs(beam(ix+1,iy-1)-beam(ix,iy+1)).lt.tol) then
    shift(1) = 1
    shift(2) = 0
  elseif (abs(beam(ix-1,iy-1)-beam(ix,iy+1)).lt.tol) then
    shift(1) = -1
    shift(2) = 0
  elseif (abs(beam(ix-1,iy-1)-beam(ix+1,iy)).lt.tol) then
    shift(1) = 0
    shift(2) = -1
  elseif (abs(beam(ix-1,iy+1)-beam(ix+1,iy)).lt.tol) then
    shift(1) = 0
    shift(2) = 1
  else
    !
    write(mess,*) 'No Beam symmetry NX NY ',nx,ny,' IX IY ',ix,iy
    call map_message(seve%w,'SHIFT',mess,seve%e)
    shift(1) = 0
    shift(2) = 0
    shift(3) = 0
  endif
end subroutine comshi
!
subroutine domima(a,rmi,rma,imi,ima,n)
  !----------------------------------------------------------
  ! @ public
  !!*
  ! IMAGER  --  Utility
  !
  !   Compute minmax and location
  !!
  !----------------------------------------------------------
  integer, intent(in) :: n        !! Problem size
  integer, intent(out) :: ima,imi !! Min Max positions
  real, intent(in) ::  a(n)       ! Values
  real, intent(inout) :: rmi,rma  ! Min Max values
  !
  integer :: i
  !
  ima = 0
  imi = 0
  if (a(1).gt.rma) then
    rma = a(1)
    ima = 1
  endif
  if (a(1).lt.rmi) then
    rmi = a(1)
    imi = 1
  endif
  do i=2,n
    if (a(i).gt.rma) then
      rma = a(i)
      ima = i
    elseif (a(i).lt.rmi) then
      rmi = a(i)
      imi = i
    endif
  enddo
end subroutine domima
!
subroutine progress_report(action,iv,nv,mv,percentage_step)
  !--------------------------------------------------------------
  ! @ public
  !
  !!   IMAGER  -- Utility: Printout progress report
  !--------------------------------------------------------------
  character(len=*), intent(in) :: action !! Action name
  integer, intent(in) :: iv    !! Current index
  integer, intent(in) :: nv    !! Number of values per block
  integer, intent(in) :: mv    !! Total number of values
  integer, intent(in) :: percentage_step !! Frequency of report
  !
  ! Local ---
  real, save :: next_percentage  ! Next report value
  integer, save :: next          ! Next report index
  integer :: nleft
  integer, save :: last_step     ! Current percentage step
  integer, save :: next_step     ! Next percentage step
  !
  ! Code ----
  if (iv.eq.1) then
    next_percentage = percentage_step
    next = nint((next_percentage*mv)/100.)
    next_step = percentage_step
    write(*,'(A)',ADVANCE="NO") trim(action)//' % '
  else
    last_step = next_step
    nleft = min(nv,mv-iv+1)
    !! Print *,'Iv ',iv,' Next ',next,' Nleft ',nleft 
    if (iv.lt.next.and.iv+nleft.ge.next) then
      if (last_step.eq.1) then
        if (next_percentage.ge.100.) then
          write(*,'(A)',ADVANCE="NO") ' 100.'
        else
          write(*,'(A)',ADVANCE="NO") '.'
        endif
      else
        write(*,'(F5.0)',ADVANCE="NO") next_percentage
      endif
      if (next_percentage.ge.95) then
        next_step = 1 
      else if (next_percentage.ge.90) then
        next_step = 5
      else
        next_step = percentage_step
      endif
      next_percentage = next_percentage+next_step 
      next = nint((next_percentage*mv)/100.)
    endif
  endif
end subroutine progress_report
!

subroutine cct_merge_comm(line,error)
  use gkernel_interfaces
  use gkernel_types
  use gbl_message
  use imager_interfaces, only : map_message
  !---------------------------------------------------------------------
  ! @ private
  !*
  !   IMAGER  -- Support for command CCT_MERGE OutFile In1 In2 
  !
  !     Merge two Clean Component Tables. Parsing routine only.
  !!
  !---------------------------------------------------------------------
  character(len=*), intent(inout) :: line !! Command line
  logical, intent(out) :: error           !! Logical error flag
  ! global
  character(len=*), parameter :: rname='CCT_MERGE'
  ! Local
  character(len=filename_length) :: table_out, namey, namez
  integer :: n
  !------------------------------------------------------------------------
  ! Code:
  error = .false.
  !
  ! Names from Command line
  call sic_ch(line,0,3,namez,n,.true.,error)
  if (error) return
  call sic_ch(line,0,2,namey,n,.true.,error)
  if (error) return
  !
  call sic_ch(line,0,1,table_out,n,.true.,error)
  if (error) return
  !
  call cct_combine(table_out,namey,namez,error)
  !
contains
!
subroutine cct_combine(namex,namey,namez,error)
  use imager_interfaces, only : sub_readhead, map_message
  use gkernel_types
  use gkernel_interfaces
  use gbl_message
  use clean_def
  use iso_c_binding
  !----------------------------------------------------------------------
  ! @ private
  !*
  !   IMAGER  Support routine for command  CCT_MERGE  Out In1 In2  
  !     Combine two input Clean Component Tables
  !
  !  Out can be a file name or an existing Image variable. 
  !   The distinction is made by the existence of a "." in the name
  !   If it is a file, it is created like the In1 Variable. 
  !   If it is an Image variable, it must match the number
  !   of channels of the In1 Variable, and  be large enough 
  !   to handle the total number of components.
  !        
  !   In1 and In2 can be file names or existing Image variables.
  !   They must match in terms of number of channels.
  !!
  !----------------------------------------------------------------------
  character(len=*), intent(inout) :: namex   !! Output file or SIC variable
  character(len=*), intent(inout) :: namey   !! Input file 1 or SIC variable
  character(len=*), intent(inout) :: namez   !! Input file 2 or SIC variable
  logical, intent(out) :: error              !! Logical error flag
  !
  ! Constants
  character(len=*), parameter :: rname='CCT_MERGE'
  !
  ! Local ---
  type(c_ptr) :: cptr
  type (sic_descriptor_t) :: desc
  type (gildas) :: hx, hy, hz
  real, pointer :: dx(:,:,:), dy(:,:,:), dz(:,:,:)
  logical :: x_image, y_image, z_image, found, rdonly
  integer :: ier, iline, ccsize
  !
  ! Code ----
  error = .true.
  !
  n = len_trim(namez)
  if (n.eq.0) return
  n = len_trim(namex)
  if (n.eq.0) return
  n = len_trim(namey)
  if (n.eq.0) return
  error = .false.
  !
  z_image = .false.
  call sub_readhead (rname,namez,hz,z_image,error,rdonly,fmt_r4,'.cct')
  if (error) return
  call cct_check(hz,error)
  if (error) then
    call map_message(seve%e,rname,trim(namez)//' is not a Clean Component Table')
    return
  endif
  !
  y_image = .false.
  call sub_readhead (rname,namey,hy,y_image,error,rdonly,fmt_r4,'.cct')
  if (error) return  
  call cct_check(hy,error)
  if (error) then
    call map_message(seve%e,rname,trim(namey)//' is not a Clean Component Table')
    return
  endif
  !
  iline = 1
  if (hy%gil%dim(2).ne.hz%gil%dim(2)) then
    if ((hy%gil%dim(2).eq.1).or.(hz%gil%dim(2).eq.1)) then
      call map_message(seve%w,rname,'Merging a Continuum and a Line Clean Component Table')
      if (hy%gil%dim(2).eq.1) iline = 2
    else  
      call map_message(seve%e,rname,'Input Clean Component Tables have different number of channels')
      error = .true.
      return
    endif
  endif  
  !
  if (hz%gil%dim(1).ne.hy%gil%dim(1)) then
    call map_message(seve%w,rname,'Clean Component Tables are of different types')
  endif
  ccsize = max(hy%gil%dim(1),hz%gil%dim(1))
  !
  ! Allocate the arrays if needed. 
  !
  ! Get the Z data pointer
  if (z_image) then
    call adtoad(hz%loca%addr,cptr,1)
    call c_f_pointer(cptr,dz,hz%gil%dim(1:3))
  else
    allocate(dz(hz%gil%dim(1),hz%gil%dim(2),hz%gil%dim(3)),stat=ier)
    if (ier.ne.0) then
      call map_message(seve%e,rname,'Memory allocation error')
      error = .true.
      return
    endif
    call gdf_read_data(hz,dz,error)
    call gdf_close_image(hz,error) ! I do not need it anymore
  endif
  !
  ! Get the Y data pointer
  if (y_image) then
    call adtoad(hy%loca%addr,cptr,1)
    call c_f_pointer(cptr,dy,hy%gil%dim(1:3))
  else
    allocate(dy(hy%gil%dim(1),hy%gil%dim(2),hy%gil%dim(3)),stat=ier)
    if (ier.ne.0) then
      call map_message(seve%e,rname,'Memory allocation error')
      error = .true.
      return
    endif
    call gdf_read_data(hy,dy,error)
    call gdf_close_image(hy,error) ! I do not need it anymore
  endif
  !
  ! Now handle the Output 
  call gildas_null(hx)
  if (index(namex,'.').eq.0) then 
    x_image = .true.
    ! This must be an existing SIC Image variable
    rdonly = .false.
    call sub_readhead (rname,namex,hx,x_image,error,rdonly,fmt_r4)
    if (error) return
    !
    call cct_check(hx,error)
    if (error) then
      call map_message(seve%e,rname,trim(namex)//' is not a Clean Component Table')
      return
    endif
    !
    ! With a conforming shape 
    if (iline.eq.1) then
      if (hx%gil%dim(2).ne.hy%gil%dim(2)) then
        call map_message(seve%e,rname,'Output SIC variable does not match Input data shape')
        error = .true.
        return
      endif
    else
      if (hx%gil%dim(2).ne.hz%gil%dim(2)) then
        call map_message(seve%e,rname,'Output SIC variable does not match Input data shape')
        error = .true.
        return
      endif
    endif
    if (hx%gil%dim(1).ne.ccsize) then
      call map_message(seve%e,rname,'Output SIC variable cannot accomodate input Clean Components')
      error = .true.
      return
    endif
    !
    if (hx%gil%dim(3).le.(hy%gil%dim(3)+hz%gil%dim(3))) then
      call map_message(seve%e,rname,'Output SIC variable is too small')
      error = .true.
      return
    endif
    !
    ! OK, they match 
    call adtoad(hx%loca%addr,cptr,1)
    call c_f_pointer(cptr,dx,hx%gil%dim(1:3))
    ! But update the Header locally
    call gdf_copy_header(hy,hx,error)
    hx%gil%dim(1) = ccsize
  else
    x_image = .false.
    ! This is  a file, we must create it
    if (iline.eq.1) then
      call gdf_copy_header(hy,hx,error)
    else
      call gdf_copy_header(hz,hx,error)
    endif
    hx%gil%dim(3) = hy%gil%dim(3)+hz%gil%dim(3)
    call sic_parsef(namex,hx%file,' ','.cct')
    hx%gil%extr_words = 0
    hx%gil%blan_words = 2
    allocate(dx(ccsize,hx%gil%dim(2),hx%gil%dim(3)),stat=ier)
    if (ier.ne.0) then
      call map_message(seve%e,rname,'Memory allocation error')
      error = .true.
      return
    endif
  endif
  !
  ! Do the actual job
  call sub_cct_collect (ccsize,hy%gil%dim(1),hz%gil%dim(1), &   ! Sizes
    & hx%gil%dim(2),hy%gil%dim(2),hz%gil%dim(2), &              !  and
    & hy%gil%dim(3),hz%gil%dim(3), dx, dy, dz )                 ! Data arrays
  !
  ! Write ouput file
  if (.not.x_image) then
    call gdf_write_image(hx,dx,error)
  else
    ! Update the original SIC variable header
    call sic_descriptor(namex,desc,found)
    call gdf_copy_header(hx,desc%head,error)  
  endif
  !
end subroutine cct_combine
!
subroutine cct_check(hz,error)
  use image_def
  use clean_def
  !---------------------------------------------------------------------
  ! @ public
  !! IMAGER - Check input Header is that of a Clean Component Table
  !---------------------------------------------------------------------
  type(gildas), intent(in) :: hz    !! Header to be checked as CCT
  logical, intent(out) :: error     !! Error return
  !
  ! Code ----
  ! CCTs have dim  (cct_size,nchan,mcct)
  if (hz%char%code(3).ne.'COMPONENT' .or. hz%gil%faxi.ne.2) then
    error = .true.
  else if ((hz%gil%dim(1).ne.3) .and. (hz%gil%dim(1).ne.4)) then
    error = .true.
  else
    error = .false.
  endif
end subroutine cct_check
!  
end subroutine cct_merge_comm
! 
! Things that should not have interfaces
!
subroutine sub_cct_collect(sx,sy,sz,ncx,ncy,ncz,ny,nz,x,y,z)
  use gildas_def
  use clean_def
  !! Concatenate CCT Tables
  integer, intent(in) :: sx                        !! Size of a Clean Component (3 or 4)
  integer(kind=address_length), intent(in) :: sy   !! Size of Y Clean component
  integer(kind=address_length), intent(in) :: sz   !! Size of Z Clean component
  integer(kind=address_length), intent(in) :: ncx  !! Number of channels in X (output) CCT table
  integer(kind=address_length), intent(in) :: ncy  !! Number of channels in Y CCT Table
  integer(kind=address_length), intent(in) :: ncz  !! Number of channels in Z CCT Table
  integer(kind=address_length), intent(in) :: ny   !! Number of components in Y table
  integer(kind=address_length), intent(in) :: nz   !! Number of compoents in Z table
  real, intent(in) :: y(sy,ncy,ny)      !! Y CCT table
  real, intent(in) :: z(sz,ncz,nz)      !! Z CCT table
  real, intent(out) :: x(sx,ncx,ny+nz)  !! Combined CCT table
  !
  ! Local ---
  integer :: i,j,mx, sxy, sxz
  !
  ! Code ----
  sxy = min(sx,sy)
  sxz = min(sx,sz)
  !
  x = 0.
  if (ncy.eq.1) then
    ! Concatenate at first null component
    mx = ny
    do j=1,ny
      if (y(3,1,j).eq.0) then
        mx = j
        exit
      endif
    enddo
    !
    ! Loop on channels
    do i=1,ncx
      x(1:sxy,i,1:mx) = y(1:sxy,1,1:mx)
      x(1:sxy,i,mx:mx+nz-1) = z(1:sxy,i,1:nz)
    enddo
  else
    ! Concatenate at first null component
    mx = nz
    do j=1,nz
      if (z(3,1,j).eq.0) then
        mx = j
        exit
      endif
    enddo
    !
    ! Loop on channels
    do i=1,ncx
      x(1:sxz,i,1:mx) = z(1:sxz,1,1:mx)
      x(1:sxz,i,mx:mx+ny-1) = y(1:sxz,i,1:ny)
    enddo
  endif
end subroutine sub_cct_collect
!
subroutine cct_convert_comm(line,error)
  use gkernel_interfaces
  use clean_def
  use clean_arrays
  use clean_types
  use gbl_message
  use imager_interfaces, only : map_message
  !---------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- Support for command CCT_CONVERT [Threshold]  
  !   Convert the CLEAN image into the CCT table
  !
  !     Theshold is the minimum (absolute value of) flux per pixel 
  !   retained. Default is 0
  !!
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: line  !! Command Line
  logical, intent(inout) :: error       !! Logical error flag
  !
  ! Constants
  character(len=*), parameter :: rname='CCT_CONVERT'
  ! Local ---
  integer :: i, imax, nx, ny, nc
  integer :: ic, ix, iy, ier
  real :: flux, minclean, factor
  character(len=64) :: chain
  !
  ! Code ----
  if (hclean%loca%size.eq.0) then
    call map_message(seve%w,rname,'No CLEAN image')
    error = .true.
    return
  endif
  !
  ! Delete the CCT 
  save_data(code_save_cct) = .false.
  call sic_delvariable ('CCT',.false.,error)
  error = .false.
  if (allocated(dcct)) deallocate(dcct,stat=ier)
  !
  minclean = 0.0
  if (len_trim(line).ne.0) then
    call sic_r4(line,0,1,minclean,.false.,error)
  endif
  !
  call gdf_copy_header(hclean, hcct, error)
  !
  hcct%gil%ndim = 3
  hcct%char%unit = 'Jy'
  !
  hcct%gil%dim(1) = 3
  ! Keep the same axis description
  hcct%gil%xaxi = 1
  !
  hcct%gil%convert(:,2) = hclean%gil%convert(:,3)
  hcct%gil%convert(:,3) = hclean%gil%convert(:,2)
  hcct%gil%dim(2) = hclean%gil%dim(3)
  hcct%char%code(2) = hclean%char%code(3)
  hcct%gil%faxi = 2
  hcct%char%code(3) = 'COMPONENT'
  hcct%gil%yaxi = 3
  hcct%loca%size = 3*hcct%gil%dim(2)*hcct%gil%dim(3)
  !
  ! Initialize BLCs...
  hcct%blc = 0
  hcct%trc = 0
  !
  ! First pass to determine Number of Clean Components
  imax = 0
  nc = hclean%gil%dim(3)
  nx = hclean%gil%dim(1)
  ny = hclean%gil%dim(2)
  do ic=1,nc
    i = 0
    do iy=1,ny
      do ix=1,nx
        if (abs(dclean(ix,iy,ic)-hclean%gil%bval).gt.hclean%gil%eval) then
          if (abs(dclean(ix,iy,ic)).gt.minclean) i=i+1
        endif
      enddo
    enddo
    imax = max(i,imax)
  enddo
  !
  hcct%gil%dim(3) = max(imax,1)  ! Must have one Clean component at least
  allocate(dcct(3,nc,imax),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'Memory allocation error')
    error = .true.
    return
  endif
  !
  factor = abs(hclean%gil%inc(1)*hclean%gil%inc(2))/(hclean%gil%majo*hclean%gil%mino)
  dcct = 0. ! Just in case
  flux = 0
  do ic=1,nc
    i = 0
    flux = 0
    do iy=1,ny
      do ix=1,nx
        if (abs(dclean(ix,iy,ic)-hclean%gil%bval).gt.hclean%gil%eval) then
          if (abs(dclean(ix,iy,ic)).gt.minclean) then
            i = i+1
            dcct(1,ic,i) = (dble(ix) -   &
             & hclean%gil%convert(1,1)) * hclean%gil%convert(3,1) + &
             & hclean%gil%convert(2,1)
            dcct(2,ic,i) = (dble(iy) -   &
             & hclean%gil%convert(1,2)) * hclean%gil%convert(3,2) + &
             & hclean%gil%convert(2,2)
            dcct(3,ic,i) = dclean(ix,iy,ic)*factor
            flux = flux+dcct(3,ic,i)
          endif
        endif
      enddo
    enddo
  enddo
  write(chain,'(A,1PG11.3)') 'Retained cumulative flux ',flux
  call map_message(seve%i,rname,chain)
  !
  hcct%loca%size = hcct%gil%dim(2)*hcct%gil%dim(3)*3
  hcct%loca%addr = locwrd(dcct)
  !
  call sic_mapgildas ('CCT',hcct,error,dcct)
end subroutine cct_convert_comm
!
subroutine cct_to_clean(method,hclean,clean,tcc)
  use clean_def
  use image_def
  use gkernel_interfaces
  !---------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER --  Support for command CLEAN  
  !   Build the clean image from Component List
  !!
  !---------------------------------------------------------------------
  type (clean_par), intent(inout) :: method      !! Clean method parameters
  type (gildas), intent(inout) :: hclean         !! Clean header
  real, intent(inout) :: clean(hclean%gil%dim(1),hclean%gil%dim(2))  !! Clean data plane
  type (cct_par), intent(in) :: tcc(method%n_iter)    !! Clean components
  !
  ! Local ---
  integer nx,ny,nc,ix,iy,ic
  real flux
  !
  ! Code ----
  if (method%method.eq.'SDI'.or.method%method.eq.'MULTI') return
  !
  nx = hclean%gil%dim(1)
  ny = hclean%gil%dim(2)
  clean = 0.0
  nc = method%n_iter
  !
  ! Convolve source list into residual map ---
  if (method%bshift(3).eq.0) then
    do ic=1,nc
      ix = tcc(ic)%ix
      iy = tcc(ic)%iy
      clean(ix,iy) = clean(ix,iy) + tcc(ic)%value
    enddo
  else
    do ic=1,nc
      flux = 0.5*tcc(ic)%value
      ix = tcc(ic)%ix
      iy = tcc(ic)%iy
      clean(ix,iy) = clean(ix,iy) + flux
      ix = ix+method%bshift(1)
      iy = iy+method%bshift(2)
      clean(ix,iy) = clean(ix,iy) + flux
    enddo
  endif
end subroutine cct_to_clean
!
subroutine cct_mask_comm(line,error)
  use gkernel_interfaces
  use clean_def
  use clean_arrays
  use clean_types
  use gbl_message
  use imager_interfaces, only : map_message
  !---------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER --  Support for command MASK APPLY CCT  
  !   Apply the MASK to the CCT table, ignoring all components outside
  !!
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: line  !! Command line
  logical, intent(inout) :: error       !! Logical error flag
  !
  character(len=*), parameter :: rname='MASK APPLY CCT'
  ! Local ---
  character(len=120) :: chain
  integer, allocatable :: list(:)
  integer :: nc, ic, iter, niter, liter, iplane, jplane, ix, iy
  !
  ! Code ----
  !
  !TEST!Print *,'Mask rank ',hmask%gil%ndim,hmask%gil%dim(1:3)
  nc = hcct%gil%dim(2)
  allocate (list(nc))
  !
  if (hmask%gil%dim(3).le.1) then
    list(:) = 1
  else if (hmask%gil%dim(3).ne.hcct%gil%dim(2)) then
    write(chain,'(A,I0,A,I0)') 'Mismatched number of channels between MASK', &
      & hmask%gil%dim(3),' and CCT ',hcct%gil%dim(2)
    call map_message(seve%e,rname,chain)
    error = .true.
    return
  else
    if (any(hcct%gil%convert(1:3,2).ne.hmask%gil%convert(1:3,3))) then
      call map_message(seve%e,rname,'Frequency axis mismatch')
      error = .true.
      return
    endif
    do ic=1,nc
      list(ic) = ic
    enddo      
  endif
  !
  ! Verify matching in Pixels 
  if ( (any(hcct%gil%convert(1:3,1).ne.hmask%gil%convert(1:3,1))) &
    &   .or. any(hcct%gil%convert(1:3,3).ne.hmask%gil%convert(1:3,2))) then
    call map_message(seve%e,rname,'Pixel size mismatch')
    error = .true.
    return
  endif
  !
  do iplane=1,nc
    jplane = list(iplane)
    niter = hcct%gil%dim(3)     ! Do not forget initialization
    !
    do iter=1,hcct%gil%dim(3)   ! Max number of iterations
      if (dcct(3,iplane,iter).eq.0) then
        niter = iter-1
        exit
      endif
      !
      ix = (dcct(1,iplane,iter)-hcct%gil%val(1))/hcct%gil%inc(1) + hcct%gil%ref(1) 
      iy = (dcct(2,iplane,iter)-hcct%gil%val(3))/hcct%gil%inc(3) + hcct%gil%ref(3) 
      if (ix.ge.1 .and. ix.le.hmask%gil%dim(1) .and. iy.ge.1 .and. iy.le.hmask%gil%dim(2)) then
        if (dmask(ix,iy,jplane).eq.0) dcct(3,iplane,iter) = 0
      endif
    enddo
    !
    ! List may be with Empty Holes, compact it
    liter = 1
    do iter = 1,niter
      if (dcct(3,iplane,iter).ne.0) then
        if (iter.gt.liter) then
          dcct(:,iplane,liter) = dcct(:,iplane,iter)
          liter = liter+1
        endif
      endif
    enddo
    ! Zero the remainder
    if (liter+1.le.niter) then
      dcct(:,iplane,liter+1:niter) = 0
    endif
    if (nc.eq.1) then
      write(chain,'(A,I0,A,I0)') 'Retained ',liter,' Components out of ',niter
      call map_message(seve%i,rname,chain)
    endif
    !
  enddo
  !
  call set_buffer_modified('CCT')
end subroutine cct_mask_comm
!
subroutine cct_clean_comm(line,error)
  use gkernel_interfaces
  use clean_def
  use clean_arrays
  use clean_types
  use gbl_message
  use imager_interfaces, except_this => cct_clean_comm
  !---------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER  --  Support for command CCT_CLEAN [MaxIter]  
  !   Convert the CCT table into the CLEAN image
  !
  !     MaxIter is the last iteration retained.
  !!
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: line  !! Command line
  logical, intent(inout) :: error       !! Logical Error flag
  !
  character(len=*), parameter :: rname='CCT_CLEAN'
  !
  ! Local ---
  real, allocatable, target :: ccou(:,:,:)
  integer, allocatable :: omic(:), nmic(:)
  integer :: maxic, ic,lc, icmax, oic, olc, ier
  integer :: nthread, ithread, nchan
  logical :: debug
  real(8) :: elapsed_s, elapsed_e, elapsed
  character(len=80) :: chain
  character(len=12) :: old_method
  !
  ! Code ----
  error = .false.
  if (.not.allocated(dcct)) then
    call map_message(seve%w,rname,'No CCT Table')
    error = .true.
  endif
  if (.not.allocated(dclean)) then
    call map_message(seve%w,rname,'No CLEAN image')
    error = .true.
  endif
  !
  nchan = hcct%gil%dim(2) 
  ic = 1
  lc = nchan
  ithread = 1
  nthread = 1
  elapsed_e = 0.
  elapsed_s = 0.
  elapsed = 0.
  debug = .false.
  call sic_get_logi('DEBUG_CCT',debug,error)
  error = .false.
  !
  ! Verify number of channels match
  if (hcct%gil%dim(2).ne.hclean%gil%dim(3)) then
    write(chain,'(A,I0,A,I0,A)') 'Number of channels in CCT [', &
    & hcct%gil%dim(2),'] and in CLEAN [',hclean%gil%dim(3),'] do not match'
    call map_message(seve%e,rname,chain)
    error = .true.
    return
  endif  
  !
  maxic = hcct%gil%dim(3)
  call sic_i4(line,0,1,maxic,.false.,error)
  if (error) return
  if (maxic.lt.0) maxic = hcct%gil%dim(3)
  maxic = min(hcct%gil%dim(3),maxic)
  if (maxic.eq.0) return ! Nothing to do then...
  !
  allocate (omic(nchan),nmic(nchan),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'Memory allocation error')
    error = .true.
    return
  endif
  !
  ! Compact the Clean components first
  call gdf_print_header(hcct)
  !
  hcct%r3d => dcct
  call uv_clean_sizes(hcct,hcct%r3d,omic,ic,lc)
  icmax = maxval(omic)
  if (debug) Print *,'Max number of clean components ',icmax
  !
  ! Nothing to do if no Clean component
  dclean = 0 
  !
  if (icmax.eq.0) then
    call map_message(seve%w,rname,'No valid Clean Component')
    return
  endif  
  !
  ! Spatially compress the Clean Component List
  oic = ic    ! This must be 1
  olc = lc    ! This must be nchan
  !
  allocate(ccou(3,icmax,nchan),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'Memory allocation error')
    error = .true.
    return
  endif
  if (debug) Print *,'uv_squeeze_clean ',nchan,omic,ic,lc
  call uv_squeeze_clean(nchan,hcct%r3d,ccou, omic,ic,lc)
  ! 
  ! Remember the Full Clean Component List size
  nmic(:) = omic
  !
  ! OK, now do the job
  ! Use the Full Clean Component list size
  hclean%r3d => dclean
  if (debug) Print *,'generate_clean ',nchan,omic,ic,lc
  old_method = the_method%method
  the_method%method = 'UV_RESTORE'
  the_method%bshift = 0
  call generate_clean(the_method,hclean,ic,lc,ccou,nmic)
  the_method%method = old_method
  !
  ! Update the CLEAN variable
  call sic_delvariable ('CLEAN',.false.,error)
  save_data(code_save_clean) = .false.
  call sic_mapgildas ('CLEAN',hclean,error,dclean)
end subroutine cct_clean_comm
!

subroutine dofft (np,nv,visi,jx,jy,jo   &
     &    ,nc,nx,ny,map,mapx,mapy,sup,cell,taper,we  &
     &    ,ubias,vbias,ubuff,vbuff,ctype)
  use gildas_def
  use gkernel_interfaces
  use clean_default
  !$ use omp_lib
  !----------------------------------------------------------------------
  ! @ public
  !*
  ! IMAGER  --   Support for UV_MAP and UV_RESTORE
  !
  !   Compute FFT of image by gridding UV data
  !   Select basic routine according to OMP_MAP%GRID
  !!
  !----------------------------------------------------------------------
  integer, intent(in) :: nv                   !! number of values
  integer, intent(in) :: np                   !! Number of "visibilities", normally 7+3*nc
  real, intent(in) :: visi(np,nv)             !! values
  integer, intent(in) :: nc                   !! number of channels
  integer, intent(in) :: jx                   !! X coord location in VISI
  integer, intent(in) :: jy                   !! Y coord location in VISI
  integer, intent(in) :: jo                   !! first channel to map
  integer, intent(in) :: nx                   !! X map size
  integer, intent(in) :: ny                   !! Y map size
  complex, intent(out) :: map(nc+1,nx,ny)     !! gridded visibilities
  real, intent(in) :: mapx(nx)                !! X Coordinates of grid
  real, intent(in) :: mapy(ny)                !! Y Coordinates of grid
  real, intent(in) :: sup(2)                  !! Support of convolving function in Meters
  real, intent(in) :: cell(2)                 !! cell size in Meters
  real, intent(in) :: taper(4)                !! 1/e taper in Meters + Angle in Radians
  real, intent(in) :: we(nv)                  !! Weight array
  real, intent(in) :: ubias                   !! U gridding offset
  real, intent(in) :: vbias                   !! V gridding offset
  real, intent(in) :: ubuff(4096)             !! U gridding buffer
  real, intent(in) :: vbuff(4096)             !! V gridding buffer
  integer, intent(in) :: ctype                !! type of gridding
  !
  integer, external :: ompget_grid_code
  !
  ! Local ---
  integer :: ipara
  real, allocatable :: vv(:)                  ! V Values
  !
  ! Code ----
  call imager_tree('DOFFT '//char(ctype+ichar('0')),.false.)
  !
  ! Initialize
  map = 0.0
  ipara = ompget_grid_code()  
  !
  if (ctype.eq.1) then  ! Simple nearest cell
    call dofft_fast (np,nv,visi,jx,jy,jo,   &
     &      nc,nx,ny,map,mapx,mapy,sup,cell,taper,we)
  else                  ! Gridding with extended support
    if (ipara.eq.0) then
      !
      ! This is the Default algorithm - Others are for test only.
      !
      ! The OMP version would work for several channels, but the 
      ! required image storage may become quite large. One could
      ! think of adjusting the number of Threads to the Problem size
      !   On the other hand, the number of visibilities is small,
      ! so sequential programming is enough
      if (nc.ne.1) then
        call dofft_quick (np,nv,visi,jx,jy,jo,   &
     &      nc,nx,ny,map,mapx,mapy,sup,cell,taper,we,   &
     &      ubias,vbias,ubuff,vbuff)
      else
        ! Continuum images are "small", but number of visibilities
        ! can be large in this case, so OMP is useful
        call dofft_quick_omp (np,nv,visi,jx,jy,jo,   &
     &      nc,nx,ny,map,mapx,mapy,sup,cell,taper,we,   &
     &      ubias,vbias,ubuff,vbuff,ipara)     
      endif
    else if (ipara.gt.4) then
      !$ Print *,'OMP in parallel ',omp_in_parallel()
      ! This could be the Default algorithm for small number
      ! of channels -- under test.
      Print *,'CASE 42 DOFFT_QUICK_OMP'
      call dofft_quick_omp (np,nv,visi,jx,jy,jo,   &
     &      nc,nx,ny,map,mapx,mapy,sup,cell,taper,we,   &
     &      ubias,vbias,ubuff,vbuff,ipara) 
    else
      ! Setup VV as V Values
      allocate(vv(nv))
      vv = visi(2,1:nv)
      !
      select case(ipara)
      case(-1)
        call dofft_parallel_v_pseudo (np,nv,visi,jx,jy,jo,   &
       &      nc,nx,ny,map,mapx,mapy,sup,cell,taper,we,vv,   &
       &      ubias,vbias,ubuff,vbuff)
      case(-2)
        call dofft_parallel_v_true (np,nv,visi,jx,jy,jo,   &
       &      nc,nx,ny,map,mapx,mapy,sup,cell,taper,we,vv,   &
       &      ubias,vbias,ubuff,vbuff)
      case(-3)
        call dofft_quick_para (np,nv,visi,jx,jy,jo,   &
       &      nc,nx,ny,map,mapx,mapy,sup,cell,taper,we,vv,   &
       &      ubias,vbias,ubuff,vbuff)
      case(-4)
        call dofft_quick_debug (np,nv,visi,jx,jy,jo,   &
       &      nc,nx,ny,map,mapx,mapy,sup,cell,taper,we,vv,   &
       &      ubias,vbias,ubuff,vbuff)
      case(-11)
        call dofft_parallel_v_pseudo_out (np,nv,visi,jx,jy,jo,   &
       &      nc,nx,ny,map,mapx,mapy,sup,cell,taper,we,vv,   &
       &      ubias,vbias,ubuff,vbuff)
      case(-12)
        call dofft_parallel_v_true_out (np,nv,visi,jx,jy,jo,   &
       &      nc,nx,ny,map,mapx,mapy,sup,cell,taper,we,vv,   &
       &      ubias,vbias,ubuff,vbuff)
      case(1)
        call dofft_slow (np,nv,visi,jx,jy,jo,   &
       &      nc,nx,ny,map,mapx,mapy,sup,cell,taper,we,vv,   &
       &      ubias,vbias,ubuff,vbuff)
      case(2)
        call dofft_parallel_x (np,nv,visi,jx,jy,jo,   &
       &      nc,nx,ny,map,mapx,mapy,sup,cell,taper,we,vv,   &
       &      ubias,vbias,ubuff,vbuff)
      case(3)
        call dofft_parallel_y (np,nv,visi,jx,jy,jo,   &
       &      nc,nx,ny,map,mapx,mapy,sup,cell,taper,we,vv,   &
       &      ubias,vbias,ubuff,vbuff)
      end select 
    endif
  endif
  call imager_tree('DOFFT '//char(ctype+ichar('0')),.false.)
end subroutine dofft
!

subroutine uv_model_comm(line,error)
  use gildas_def
  use gbl_message
  use gkernel_interfaces
  use clean_default
  use clean_arrays
  use imager_interfaces, except_this => uv_model_comm
  !---------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- Support routine for command  
  !     MODEL [Args] [/MINVAL Value [Unit]] [/OUTPUT]  
  !           [/MODE CCT|UV_FIT|IMAGE|SELF [Frequency]]
  !
  ! Dispatch to adequate routine as specified by /MODE option to   
  !  - Compute the UV_MODEL data set from the current CCT table  
  ! or  
  !  - Compute the UV_MODEL data set from the current UV_FIT results  
  ! or  
  !  - Compute the UV_MODEL data set from the specified IMAGE variable
  !
  !   If no /MODE option is specified, the operation depends on whether 
  ! CLEAN or UV_FIT was executed last.
  !
  !   The /OUTPUT option is dummy, being present only for compatibility
  ! with the UV_RESIDUAL command
  !!
  !---------------------------------------------------------------------
  character(len=*), intent(inout) :: line       !! Command line
  logical, intent(inout) :: error               !! Logical Error flag
  !
  ! Constants
  character(len=*), parameter :: rname='MODEL'
  integer, parameter :: o_minval=1 ! 
  integer, parameter :: o_output=2 ! Must be 2 ...
  integer, parameter :: o_mode=3  
  integer, parameter :: mmode=5
  character(len=12) vocs(mmode)
  data vocs/'CCT','COMPONENT','IMAGE','UV_FIT','SELF'/ 
  !
  ! Local ---
  integer :: imode
  character(len=12) argu,cmode
  logical :: OLD=.TRUE.
  !
  call sic_get_logi('MODEL_OLD',old,error)
  error = .false.
  !
  ! Code ----
  if (sic_present(o_mode,0)) then
    call sic_ke(line,o_mode,1,argu,imode,.true.,error)
    if (error) return
    call sic_ambigs(rname,argu,cmode,imode,vocs,mmode,error)
    if (error) return
  else
    cmode = last_resid ! CCT or UV_FIT
  endif
  call sic_delvariable('UV_MODEL',.false.,error)
  !
  error = .false.
  !
  uv_model_updated = .true.
  select case (cmode)
  case ('UV_FIT')    
    call uvfit_residual_model(line,'MODEL',1,error)
    return
  case ('CCT','COMPONENT')
    huv_current%r2d => duv
    if (OLD) then
      call cct_fast_uvmodel(line,huv_current,error)
    else
      call cct_new_uvmodel(line,huv_current,error)
    endif
  case ('SELF')
    if (themap%nfields.le.1) then
      ! Single field case...
      if (OLD) then
        if (hself_calib%gil%nchan.gt.1) then
          hself_calib%r2d => duvcalib
          call cct_fast_uvmodel(line,hself_calib,error)
        else
          hself_self%r2d => duvself
          call cct_fast_uvmodel(line,hself_self,error)
        endif
      else
        if (hself_calib%gil%nchan.gt.1) then
          hself_calib%r2d => duvcalib
          call map_message(seve%w,rname,'Using ctt_new_uvmodel with Line data',seve%e)
          call cct_new_uvmodel(line,hself_calib,error)
        else
          hself_self%r2d => duvself
          call map_message(seve%w,rname,'Using ctt_new_uvmodel with Continuum',seve%e)
          call cct_new_uvmodel(line,hself_self,error)
        endif
      endif
    else
      if (hself_calib%gil%nchan.gt.1) then
        hself_calib%r2d => duvcalib
        call map_message(seve%w,rname,'New MODEL for Mosaic Self-Calibration -- Not yet Finished ....',seve%e)
        call map_message(seve%w,rname,'Using cct_new_uvmodel ',seve%e)
        call cct_new_uvmodel(line,hself_calib,error)
      else
        hself_self%r2d => duvself
        call map_message(seve%w,rname,'Using self_uvmodel ',seve%e)
        call self_uvmodel(line,hself_self,error)
      endif
    endif
      !
  case default
    !!Print *,'Mode IMAGE '
    call map_uvmodel(line,error)
  end select
  if (error) return
  !
  huv_model%loca%size = huv_model%gil%dim(1)*huv_model%gil%dim(2)
  huv_model%r2d => duvm
  call sic_mapgildas('UV_MODEL',huv_model,error,huv_model%r2d)
  !
end subroutine uv_model_comm
!<FF>
subroutine map_uvmodel(line,error)
  use gildas_def
  use gbl_message
  use gkernel_interfaces
  use clean_arrays
  use iso_c_binding
  use imager_interfaces, except_this => map_uvmodel
  !---------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- Parsing routine for command  
  !     MODEL ImageName [/MINVAL Value [Unit]] /MODE IMAGE [Frequency]
  !
  ! Compute the UV_MODEL data set from the specified image.
  ! Parsing only to call the effective routine. 
  !
  !!
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: line      !! Command line
  logical, intent(inout) :: error           !! Logical Error flag
  !
  ! Constants
  character(len=*), parameter :: rname='MODEL'
  real(kind=8), parameter :: pi=3.14159265358979323846d0
  integer, parameter :: o_minval=1 ! 
  integer, parameter :: o_output=2 ! Must be 2 ...
  integer, parameter :: o_mode=3   
  ! 
  ! Local ---
  real :: fmin ! Minimum flux
  real(8) :: freq ! Effective frequency - to be checked !!!
  character(len=filename_length) :: namex
  type(gildas) :: hmap
  real, allocatable, target :: dmap(:,:,:)
  integer :: nf,mx,my, nc, ier
  logical :: is_image, is_clean, rdonly, large
  type(c_ptr) :: cptr
  real, pointer :: rptr(:,:,:)
  real :: cpu0
  !
  ! Code ----
  large = sic_present(0,2) ! Test
  !
  if (.not.associated(duv)) then
    call map_message(seve%e,rname,'No UV data (DUV is not associated)') 
    error = .true.
    return
  endif
  !
  error = .false.
  call gag_cpu(cpu0)
  !
  ! Input data is the current UV Data  huv & duv
  !
  ! Input MAP is specified as first argument, or defaults to CLEAN
  call gildas_null(hmap)
  if (sic_present(0,1)) then
    call sic_ch(line,0,1,namex,nc,.true.,error)
    if (error) return
    is_clean = .false.
    is_image = .false.    ! Allow SIC variable or GILDAS Data file
    call sub_readhead (rname,namex,hmap,is_image,error,rdonly,fmt_r4)
  else
    ! Use the CLEAN image so far for a test...
    if (hclean%loca%size.eq.0) then
      call map_message(seve%w,rname,'No CLEAN image')
      error = .true.
      return
    endif
    call gdf_copy_header(hclean,hmap,error)
    is_clean = .true.
  endif
  !
  ! There must be some match of the Velocity axis (not the frequency axis)
  ! This match may imply a change of number of channels, i.e.
  ! we should be able to define the intersection of the two velocity
  ! axis.  For the time being, just assume they are identical,
  ! or take the Image axis if the UV data is just 1 channel.
  if (huv_current%gil%nchan.ne.1) then
    if (hmap%gil%dim(3).ne.huv_current%gil%nchan) then
      call map_message(seve%w,rname,'Velocity axis mis-match, using UV coverage only')
    endif
  endif
  nf = hmap%gil%dim(3) ! In all cases
  mx = hmap%gil%dim(1)
  my = hmap%gil%dim(2)
  !
  ! Then do the job as in the CCT case, except for the Scale factor...
  allocate (dmap(mx,my,nf),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'MAP Allocation error')
    error = .true.
    return
  endif
  !
  ! We need a copy because we ignore edges
  if (is_clean) then
    !TEST!Print *,'Using CLEAN'
    dmap(:,:,:) = dclean 
  else if (is_image) then
    !TEST!Print *,'Using an IMAGE '
    call adtoad(hmap%loca%addr,cptr,1)
    call c_f_pointer(cptr,rptr,hmap%gil%dim(1:3))
    dmap(:,:,:) = rptr
  else
    !TEST!Print *,'Reading a data file'
    call gdf_read_data(hmap,dmap,error)
    if (error) return
    call gdf_close_image(hmap,error)
  endif
  !
  ! Retrieve minimum value and Frequency
  call mod_min_image (line,hmap,huv_current,freq,fmin,error)
  if (error) return
  !
  if (fmin.gt.0) then
    where (abs(dmap).lt.fmin)  dmap = 0.
  endif
  !
  ! Now call the Sub-routine
  call map_fast_uvmodel(huv_current,duv,huv_model,duvm,hmap,dmap,themap,freq,error)
  deallocate(dmap)
  !
end subroutine map_uvmodel
!<FF>
subroutine map_fast_uvmodel(huvl,duvl,huvm,duvm,hmap,dmap,map,freq,error)
  use image_def
  use gbl_message
  use gkernel_interfaces
  use clean_def
  use iso_c_binding
  use imager_interfaces, except_this => map_fast_uvmodel
  !---------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- Support routine for command  
  !     MODEL ImageName [/MINVAL Value [Unit]] /MODE IMAGE [Frequency]
  !
  ! Compute the UV_MODEL data set from the specified image. 
  ! Uses an intermediate FFT with further interpolation for 
  !    better speed than UV_CCT. Also works for Mosaic Self Calibration
  !!
  !---------------------------------------------------------------------
  type(gildas), intent(in) :: huvl  !! Input UV Header
  type(gildas), intent(inout) :: huvm  !! Output Model UV Header
  real, intent(in) :: duvl(:,:)     !! Input UV data (used for UV and Frequency coverage)
  real, intent(out), allocatable :: duvm(:,:) !! Output UV data
  type(gildas), intent(in) :: hmap  !! Input Map Header
  real, intent(inout), target :: dmap(:,:,:)  !! Input dat cube
  type(uvmap_par), intent(inout) :: map       !! Imaging parameters
  real(8), intent(in) :: freq                 !! Effective frequency
  logical, intent(inout) :: error             !! Logical Error flag
  !
  ! Constants
  character(len=*), parameter :: rname='MODEL'
  real(kind=8), parameter :: pi=3.14159265358979323846d0
  integer, parameter :: o_minval=1 ! 
  integer, parameter :: o_output=2 ! Must be 2 ...
  integer, parameter :: o_mode=3   
  ! Local ---
  character(len=132) :: mess
  logical :: large
  complex, allocatable :: fft(:,:,:)
  real, allocatable :: work(:)
  integer :: if,it,nc,nx,ny,mx,my,nt,nv,mt,mv, ier, ix,iy
  real :: cpu0, cpu1
  real :: factor
  real(8) :: xinc, yinc, area, jyperk
  character(len=8) :: cunit
  real(8) :: vres
  real :: lambda, pixel_area
  real, pointer :: dlocal(:,:,:)
  integer :: ifuv, iluv, nfield, iv, ic
  ! I have an issue with IDcol
  integer :: idcol, jdcol
  integer :: ioff, joff, xoff, yoff
  logical :: doprint
  ! Radial profile
  integer :: nr, ntel
  real :: bsize(10)
  real(8), allocatable :: profile(:,:,:) ! Radial profile
  !
  ! Code ----
  large = sic_present(0,2) ! Test
  !
  idcol = huvl%gil%column_pointer(code_uvt_id)
  !
  ! Code
  error = .false.
  call gag_cpu(cpu0)
  !
  nc = hmap%gil%dim(3) ! In all cases
  mx = hmap%gil%dim(1)
  my = hmap%gil%dim(2)
  !
  ! Then do the job as in the CCT case, except for the Scale factor...
  !
  ! Define observing frequency
  vres = hmap%gil%vres
  xinc = hmap%gil%inc(1)
  yinc = hmap%gil%inc(2)
  !
  ! Replace Blanking by 0
  if (hmap%gil%eval.ge.0) then
    do ic=1,nc
      do iy=1,my
        do ix=1,mx
          if (abs(dmap(ix,iy,ic)-hmap%gil%bval).le.hmap%gil%eval) then
            dmap(ix,iy,ic) = 0
          endif
        enddo
      enddo
    enddo
  endif
  !
  ! Prepare the UV output
  call gildas_null(huvm, type = 'UVT')
  !
  ! Do we want the same frequency layout as the UV data or that of the TEMPLATE (MAP or CLEAN COMPONENT) ? 
  ! The UV data specifies the appropriate UV coverage, 
  ! but the MAP specifies the Spectroscopy by default
  !
  ! Analysis of the /MODE option yields the choice
  call gdf_copy_header(huvl,huvm,error) 
  !
  write(mess,'(A,I0,A,I0)') 'Channels: in UV data ',huvl%gil%nchan,' ; in Model cube ',hmap%gil%dim(3)
  call map_message(seve%i,rname,mess,seve%w)
  huvm%gil%nchan = nc ! Reset number of channels
  !
  if (huvl%gil%nchan.eq.huvm%gil%nchan) then
    call map_message(seve%i,rname,'Number of channels match between UV data and Model')
  else if (huvl%gil%nchan.eq.1) then
    call map_message(seve%i,rname,'Extending UV data to number of channels in Model')
    ! Push the extra column by the difference in the Channel number
    do ic=1,code_uvt_last
      if (huvm%gil%column_pointer(ic).gt.10) then
        huvm%gil%column_pointer(ic) = huvm%gil%column_pointer(ic) + 3*(huvm%gil%nchan-1)
      endif
    enddo
    huvm%gil%dim(1) = huvl%gil%dim(1)+3*(huvm%gil%nchan-1)
  else
    write(mess,'(A,I0,A,I0)') 'Mismatch Channels UV data ',huvl%gil%nchan,' - Model cube ',huvm%gil%nchan
    call map_message(seve%e,rname,mess)
    error = .true.
    return
  endif
  !
  ! Avoid edges by default - Do not even bother to check for a mask
  ! or whatever - It is needed to avoid aliasing in any case
  do ic=1,nc
    dmap(1:(mx/8),:,ic) = 0
    dmap((7*mx)/8:mx,:,ic) = 0
    dmap(:,1:(my/8),ic) = 0
    dmap(:,(7*my)/8:my,ic) = 0
  enddo
  !
  ! Define the image size
  call mod_fft_size(large,mx,my,nx,ny)
  call gag_cpu(cpu1)
  !
  ! Get Virtual Memory & compute the FFT
  allocate (fft(nx,ny,nc),work(2*max(nx,ny)),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'FFT space allocation error')
    error = .true.
    return
  endif
  !
  ! Loop over fields if needed
  nfield = abs(map%nfields) 
  if (nfield.gt.1) then
    if (huvl%gil%column_pointer(code_uvt_id).eq.0) then
      call map_message(seve%e,rname,'MODEL does not work for Mosaics that have no POINTING Table')
      call map_message(seve%i,rname,'Use the MOSAIC command before')
      error = .true.
      return
    endif
  else
    nfield = 1
  endif
  !
  ioff = code_uvt_xoff
  joff = code_uvt_yoff
  xoff = huvm%gil%column_pointer(ioff)
  yoff = huvm%gil%column_pointer(joff)
  !
  if ((idcol.ne.0).and.((xoff.eq.0).or.(yoff.eq.0))) then
    xoff = huvm%gil%column_pointer(code_uvt_loff)
    yoff = huvm%gil%column_pointer(code_uvt_moff)
    if ((xoff.eq.0).or.(yoff.eq.0)) then
      jdcol = huvm%gil%column_pointer(code_uvt_id)
      huvm%gil%column_pointer(code_uvt_id) = 0
      huvm%gil%column_size(code_uvt_id) = 0
      if (jdcol.lt.huvm%gil%dim(1)) then
        huvm%gil%column_pointer(ioff)= jdcol
        huvm%gil%column_pointer(joff)= jdcol+1
      else if (jdcol.eq.huvm%gil%dim(1)) then
        huvm%gil%dim(1) = huvm%gil%dim(1)+1
        huvm%gil%column_pointer(ioff)= huvm%gil%dim(1)-1
        huvm%gil%column_pointer(joff)= huvm%gil%dim(1)
      else
        huvm%gil%dim(1) = huvm%gil%dim(1)+2
        huvm%gil%column_pointer(ioff)= huvm%gil%dim(1)-1
        huvm%gil%column_pointer(joff)= huvm%gil%dim(1)
      endif
    else
      huvm%gil%column_pointer(code_uvt_xoff) = huvm%gil%column_pointer(code_uvt_loff)
      huvm%gil%column_pointer(code_uvt_loff) = 0
      huvm%gil%column_size(code_uvt_loff) = 0
      huvm%gil%column_pointer(code_uvt_yoff) = huvm%gil%column_pointer(code_uvt_moff)
      huvm%gil%column_pointer(code_uvt_moff) = 0
      huvm%gil%column_size(code_uvt_moff) = 0
    endif
    huvm%gil%column_size(ioff) = 1
    huvm%gil%column_size(joff) = 1
    xoff = huvm%gil%column_pointer(ioff)
    yoff = huvm%gil%column_pointer(joff)
  endif
  !
  if (allocated(duvm)) deallocate(duvm)
  allocate (duvm(huvm%gil%dim(1),huvm%gil%dim(2)),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'UV Model allocation error')
    error = .true.
    return
  endif
  nt = huvm%gil%dim(1)
  nv = huvm%gil%dim(2)
  mt = huvl%gil%dim(1)
  mv = huvl%gil%nvisi
  !
  huvm%gil%ref(1)  = hmap%gil%ref(3)
  huvm%gil%val(1)  = freq
  !
  ! Set the velocity resolution
  huvm%gil%vres = vres
  huvm%gil%fres = -vres*freq/299792.458d0  ! Velocity in km/s
  huvm%gil%inc(1)  = huvm%gil%fres 
  !
  huvm%gil%freq = freq
  huvm%char%line = hmap%char%line 
  huvm%gil%voff = hmap%gil%voff
  !
  ! Set the number of channels
  huvm%gil%nchan = nc
  huvm%gil%convert(:,1) = hmap%gil%convert(:,3)
  !
  write(mess,'(A,I0,A,I0)') 'Channels UV coverage ',huvl%gil%nchan,' - in Model cube ',huvm%gil%nchan
  call map_message(seve%w,rname,mess)
  !
  ! Unit is according to Image characteristics
  !
  cunit = hmap%char%unit
  call sic_upper(cunit)
  jyperk = 1.0
  if (cunit.eq.'JY/BEAM') then
    ! Get the scale factor of the input data. We want
    ! a model image in K for the rest of the job.
    area = pi*hmap%gil%majo*hmap%gil%mino/4/log(2.0)
    if (area.ne.0) then
      jyperk = 2*1.38e3*area/(299792458d0/freq*1d-6)**2
    else
      call map_message(seve%w,rname,'No beam size, using arbitrary units')
    endif
  else if (cunit.eq.'JY/PIXEL') then
    area = abs(hmap%gil%inc(1)*hmap%gil%inc(2))
    jyperk = 2*1.38e3*area/(299792458d0/freq*1d-6)**2
  else if (cunit.eq.'K') then
    jyperk = 1.0
  endif
  !
  ! Define scaling factor from Brightness to Flux (2 k B^2 / l^2)
  lambda = 299792.458e3/(freq*1e6) ! in meter
  ! 1.38E3 is the Boltzmann constant times 10^26 to give result in Jy
  pixel_area = abs(xinc*yinc)   ! in radian
  factor = 2*1.38e3/lambda**2*pixel_area
  !
  factor = factor/jyperk  
  !
  if (nfield.gt.1) then
    allocate (dlocal(mx,my,nc),stat=ier)
  endif
  !
  ! Cannot save Memory by Splitting into UV data copy first
  !   and 
  ! Model computation next, except for Single field
  bsize = 0
  ntel = huvl%gil%nteles
  if (nfield.gt.1) then
    call primary_radial(' ',bsize,hmap,nr,ntel,profile,error)
    if (error) return
  endif
  !
  doprint = real(mv)*real(nc).GE.5E7
  iluv = 0  
  do if=1,nfield      ! This is purely SEQUENTIAL, as the ifuv / iluv pointers are incremented
    if (nfield.eq.1) then
      dlocal => dmap
      ifuv = 1
      iluv = nv
      ! At this stage, we just copy the DAPs and the weights.
      if (huvl%gil%nchan.eq.huvm%gil%nchan) then
        if (doprint) call map_message(seve%i,rname,'Copying Visibilities')
        duvm(1:nt,1:nv) = duvl(1:nt,1:nv)
      else if (huvl%gil%nchan.eq.1) then
        if (doprint) call map_message(seve%i,rname,'Copying Leading columns and Weights')
        do iv=1,mv
          duvm(1:7,iv) = duvl(1:7,iv)
          do ic=1,huvm%gil%nchan
            duvm(7+3*ic,iv) = duvl(10,iv)
          enddo
        enddo
      endif
    else
      !
      ! Compute and apply Primary beam attenuation
      it = huvl%mos%fields(if)%jteles
      call apply_primary_single(dlocal,dmap,dble(huvl%mos%fields(if)%opoint(1)), &
        dble(huvl%mos%fields(if)%opoint(2)),hmap,nr,profile(:,:,it),error)
      !
      ! Copy appropriate UV data 
      ifuv = iluv+1      
      do iv=1,mv
        if (duvl(idcol,iv).eq.if) then
          iluv = iluv+1
          if (huvl%gil%nchan.eq.huvm%gil%nchan) then
            duvm(1:nt,iluv) = duvl(1:nt,iv)
          else if (huvl%gil%nchan.eq.1) then
            duvm(1:nt,iluv) = 0
            duvm(1:7,iluv) = duvl(1:7,iv)
            do ic=1,huvm%gil%nchan
              duvm(7+3*ic,iluv) = duvl(10,iv)
            enddo
          endif
          duvm(xoff,iluv) = huvl%mos%fields(if)%opoint(1)
          duvm(yoff,iluv) = huvl%mos%fields(if)%opoint(2)
        endif
      enddo
      nv = iluv-ifuv+1
      if (nv.ne.huvl%mos%fields(if)%nvisi) then
        write(mess,'(A,I0,A,I0,A,I0)') 'Mismatch UV data for field ',if, &
          & ' expected ',huvl%mos%fields(if)%nvisi,' got ',nv
        call map_message(seve%e,rname,mess)
      endif  
    endif
    !
    ! See UV_RESTORE also for this code
    if (doprint) call map_message(seve%i,rname,'Setting FFT for all channels')
    if (nx.eq.mx .and. ny.eq.my) then
      fft(:,:,:) = cmplx(dlocal,0.0)
    else
      fft = 0.
      do ic = 1,nc
        call plunge_real (dlocal(:,:,ic),mx,my,fft(:,:,ic),nx,ny)
      enddo
    endif
    !
    ! Compute the FFT
    if (doprint) call map_message(seve%i,rname,'Computing FFTs')
    call do_fft(nx,ny,nc,fft,work)
    call gag_cpu(cpu1)
    !
    ! Now compute the model
    if (doprint) call map_message(seve%i,rname,'Extracting Model Visibilities')
    !Print *,'Field ',if,'  IFUV ',ifuv,' ILUV ',iluv
    call do_uvmodel(duvm(:,ifuv:iluv), nt, nv, fft,nx,ny,nc,freq,xinc,yinc,factor)
    error = .false.
    call gag_cpu(cpu1) 
    !
  enddo
  !
  ! Free data cube
  if (associated(dlocal,dmap)) then
    nullify(dlocal)
  else
    deallocate(dlocal)
  endif
  !Print *,'Finish map_fast_uvmodel (T/F) ? '
  !read(5,*) error
  if (.not.error) return
  !
  huvm%file = 'model.uvt'
  call gdf_write_image(huvm,duvm,error)
  call map_message(seve%e,rname,'Map_Fast_uvmodel error. Saved on "model.uvt"')
  error = .true.
  !
end subroutine map_fast_uvmodel
!<FF>
subroutine cct_fast_uvmodel(line,huvl,error)
  use gildas_def
  use gbl_message
  use gkernel_interfaces
  use clean_arrays
  use imager_interfaces, except_this => cct_fast_uvmodel
  !---------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER --  Support routine for command  
  !     MODEL [MaxIter] [/MINVAL Value [Unit]] [/MODE CCT [Frequency]]
  !
  ! Compute the MODEL UV data set from the current CCT table
  !
  !     Uses an intermediate FFT with further interpolation for
  !     better speed than UV_CCT
  !!
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: line      !! Command line
  type(gildas), intent(in) :: huvl          !! Input UV data
  logical, intent(inout) :: error           !! Error flag
  !
  ! Constants
  character(len=*), parameter :: rname='MODEL'
  real(kind=8), parameter :: pi=3.14159265358979323846d0
  integer, parameter :: o_minval=1 ! 
  integer, parameter :: o_output=2 ! Must be 2 ...
  integer, parameter :: o_mode=3   
  ! Local ---
  integer :: nclean ! Number of clean components retained
  logical :: large
  complex, allocatable :: fft(:,:,:)
  real, allocatable :: dmap(:,:,:)
  real, allocatable :: work(:)
  integer :: if,nf,nx,ny,mx,my,nt,nv,mt, ier
  real :: cpu0, cpu1
  real :: factor
  real(8) :: xinc, yinc, freq, vres
  character(len=80) :: mess
  !
  ! Code ----
  nclean = 0
  call sic_i4(line,0,1,nclean,.false.,error)
  if (error) return
  large = sic_present(0,2) ! Test
  !
  if (.not.associated(huvl%r2d)) then
    call map_message(seve%e,rname,'Input UV pointer is not associated') 
    error = .true.
    return
  endif
  ! Code
  error = .false.
  call gag_cpu(cpu0)
  !
  ! Input data is the current UV Data  huv & duv
  !
  ! Input CCT is the current CCT Data (it should match the UV data)
  !
  ! Compact it into an image
  ! This depends on the CCT type, and is done in a subroutine
  !    First, define the sampling and image size 
  call cct_def_image (hcct,mx,my,nf,xinc,yinc,error)
  if (error) return
  !
  if (nf.ne.1) then
    if (nf.ne.huvl%gil%nchan) then
      write(mess,'(A,I0,A,I0)') 'Velocity channels mis-match, CCT ',nf,' UV_DATA ',huvl%gil%nchan
      call map_message(seve%e,rname,mess)
      error = .true.
      return
    endif
  endif
  !
  !    Then do the job
  allocate (dmap(mx,my,nf),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'MAP Allocation error')
    error = .true.
    return
  endif
  call cct_set_image (hcct,dcct,mx,my,nclean,xinc,yinc,nf,dmap,error)
  !
  ! Do we want the same velocity layout as the UV data or that of the MAP? 
  ! The UV data specifies the appropriate UV coverage, 
  ! but the MAP specifies the Spectroscopy 
  call gildas_null(huv_model, type = 'UVT')
  call gdf_copy_header(huvl,huv_model,error) ! Will work in all cases
  !
  ! Define the image size
  call mod_fft_size(large,mx,my,nx,ny)
  call gag_cpu(cpu1)
  !
  ! Get Virtual Memory & compute the FFT
  allocate (fft(nx,ny,nf),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'FFT space allocation error')
    error = .true.
    return
  endif
  !
  ! See UV_RESTORE also for this code
  if (nx.eq.mx .and. ny.eq.my) then
    fft(:,:,:) = cmplx(dmap,0.0)
  else
    do if = 1,nf
      call plunge_real (dmap(:,:,if),mx,my,fft(:,:,if),nx,ny)
    enddo
  endif
  ! Free map
  deallocate (dmap,stat=ier)
  allocate (work(2*max(nx,ny)),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'FFT work allocation error')
    error = .true.
    return
  endif
  !
  ! Compute the FFT
  call do_fft(nx,ny,nf,fft,work)
  call gag_cpu(cpu1)
  !
  freq = gdf_uv_frequency(huv_model)
  !
  huv_model%gil%dim(1) = 7+3*nf
  huv_model%gil%ref(1)  = hcct%gil%ref(hcct%gil%faxi)
  huv_model%gil%val(1)  = freq
  !
  ! Set the velocity resolution
  vres = hcct%gil%vres
  huv_model%gil%vres = vres
  huv_model%gil%fres = -vres*freq/299792.458d0  ! Velocity in km/s
  huv_model%gil%inc(1)  = huv_model%gil%fres 
  !
  huv_model%gil%freq = freq
  huv_model%char%line = hcct%char%line 
  huv_model%gil%voff = hcct%gil%voff
  !
  ! Set the number of channels
  huv_model%gil%nchan = nf
  huv_model%gil%convert(:,1) = hcct%gil%convert(:,hcct%gil%faxi)
  ! 
  ! Define scaling factor to Flux: we are in Jy, so this is simple
  factor = 1.0
  !
  if (allocated(duvm)) deallocate(duvm)
  allocate (duvm(huv_model%gil%dim(1),huv_model%gil%dim(2)),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'UV Model allocation error')
    error = .true.
    return
  endif
  nt = huv_model%gil%dim(1)
  nv = huv_model%gil%dim(2)
  mt = huvl%gil%dim(1)
  !
  ! At this stage, copy the DAPs and Weights
  call copyuv (nt,nv,duvm,mt,huvl%r2d)
  !
  ! Now compute the model
  call do_uvmodel(duvm, nt, nv, fft,nx,ny,nf,freq,xinc,yinc,factor)
  !
  call gag_cpu(cpu1)
  error = .false.
end subroutine cct_fast_uvmodel
!<FF>
subroutine mod_min_image(line,hmap,huvl,freq,fmin,error)
  use gkernel_types
  use gkernel_interfaces
  use gbl_message
  use imager_interfaces, only : map_message
  !---------------------------------------------------------------------
  ! @ private-mandatory
  !*
  ! IMAGER -- Support routine for command MODEL  
  !
  !   Define output frequency and truncate the data range if needed
  !!
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: line    !! Command line
  type(gildas), intent(in) :: hmap        !! Header of input data set
  type(gildas), intent(in) :: huvl        !! Header of input UV set
  real(8), intent(inout) :: freq          !! Frequency of output    
  real(4), intent(out) :: fmin            !! Minimum significant flux
  logical, intent(inout) :: error         !! Logical error flag
  !
  ! Constants
  integer, parameter :: o_minval=1        ! /MINVAL option
  integer, parameter :: o_mode=3          ! /MODE option
  real(kind=8), parameter :: pi=3.14159265358979323846d0
  character(len=*), parameter :: rname='MODEL'
  character(len=12), parameter :: cimage='IMAGE       '
  character(len=12), parameter :: cuv   ='UV_DATA     '
  !
  ! Local ---
  integer :: narg, nc
  real :: area, jyperk
  character(len=64) :: chain
  !
  ! Code ----
  !
  ! Override output frequency if needed
  freq = hmap%gil%freq+hmap%gil%fres*((hmap%gil%dim(3)+1)*0.5-hmap%gil%ref(3))
  if (sic_present(o_mode,2)) then
    call sic_ke(line,o_mode,2,chain,nc,.true.,error)
    nc = min(nc,12)
    if (chain(1:nc).eq.cimage(1:nc)) then
      continue
    else if (chain(1:nc).eq.cuv(1:nc)) then
      freq = gdf_uv_frequency(huvl)
    else
      call sic_r8(line,o_mode,2,freq,.false.,error)
      if (error) return
    endif
  endif
  write(chain,'(A,F14.6,A)') 'Frequency ',freq,' MHz'
  call map_message(seve%i,rname,chain)
  !
  narg = sic_narg(o_minval)  ! /MINVAL option
  if (narg.le.0) return
  !
  fmin = 0.
  call sic_r4(line,o_minval,1,fmin,.true.,error)
  if (error) return
  !
  if (narg.gt.1) then
    call sic_ch(line,o_minval,2,chain,nc,.true.,error)
    if (error) return
    if (chain(1:nc).eq.'sigma') then
      fmin = fmin * max(hmap%gil%noise,hmap%gil%rms)
    elseif (chain(1:nc).eq.'mJy') then
      fmin = 1e-3*fmin
    elseif (chain(1:nc).eq.'K') then
      if (hmap%gil%majo.ne.0) then
        area = pi*hmap%gil%majo*hmap%gil%mino/4/log(2.0)
        jyperk = 2*1.38e3*area/(299792458d0/freq*1d-6)**2
        fmin = fmin * jyperk 
      else
        call map_message(seve%e,rname,'Unit K unsupported in this context')
        error = .true.
        return
      endif      
    elseif (chain(1:nc).eq.'Jy') then
      fmin = fmin
    else
      call map_message(seve%e,rname,'Unrecognized unit '//chain(1:nc))
      error = .true.
      return
    endif
  endif
end subroutine mod_min_image
!<FF>
subroutine do_uvmodel (visi,nt,nv,a,nx,ny,nf,   &
     &    freq,xinc,yinc,factor)
  !$ use omp_lib
  use gbl_message
  use imager_interfaces, only : map_message
  !---------------------------------------------------------------------
  ! @ public
  !*
  ! IMAGER -- Support for command MODEL    
  ! Compute the MODEL UV data set from the current CCT table
  !
  !     Uses an intermediate FFT with further interpolation for
  !     better speed than UV_CCT
  ! CAUTION  
  !     Frequency (and hence Lambda/D) is assumed constant 
  !!
  !---------------------------------------------------------------------
  integer, intent(in) :: nt                       !! Size of visibility
  integer, intent(in) :: nv                       !! Number of visibilities
  real, intent(inout) :: visi(nt,nv)              !! Visibilities
  integer, intent(in) :: nx                       !! X Size of image
  integer, intent(in) :: ny                       !! Y Size of image
  integer, intent(in) :: nf                       !! Number of frequencies
  complex, intent(in) :: a(nx,ny,nf)              !! Clean Component Image
  real(8), intent(in) :: freq                     !! Reference frequency
  real(8), intent(in) :: xinc                     !! X Pixel increment
  real(8), intent(in) :: yinc                     !! Y Pixel increment
  real, intent(in) :: factor                      !! Flux scale factor
  !
  real(kind=8), parameter :: clight=299792458d0
  ! Local ---
  real(kind=8) :: kwx,kwy,stepx,stepy,lambda,xr,yr
  complex(kind=8) :: aplus,amoin,azero,afin
  integer :: i,if,ia,ja
  integer(kind=8) :: icount
  logical :: inside
  character(len=80) :: chain
  !
  ! Code ----
  lambda = clight/(freq*1d6)
  stepx = 1.d0/(nx*xinc)*lambda
  stepy = 1.d0/(ny*yinc)*lambda
  !
  ! Loop on visibility
  icount = 0
  !$OMP PARALLEL DEFAULT(none) &
  !$OMP SHARED(visi,nv,nt, a,nx,ny,nf, stepx,stepy,lambda, factor) &
  !$OMP PRIVATE(i,kwx,kwy,ia,ja,xr,yr,inside,if,azero,aplus,amoin,afin) &
  !$OMP REDUCTION(+:icount)
  !$OMP DO
  do i = 1, nv
    kwx =  visi(1,i) / stepx + dble(nx/2 + 1)
    kwy =  visi(2,i) / stepy + dble(ny/2 + 1)
    ia = int(kwx)
    ja = int(kwy)
    inside = (ia.gt.1 .and. ia.lt.nx) .and.   &
        &      (ja.gt.1 .and. ja.lt.ny)
    if (inside) then
      xr = kwx - ia
      yr = kwy - ja
      do if=1,nf
        !
        ! Interpolate (X or Y first, does not matter in this case)
        aplus = ( (a(ia+1,ja+1,if)+a(ia-1,ja+1,if)   &
            &          - 2.d0*a(ia,ja+1,if) )*xr   &
            &          + a(ia+1,ja+1,if)-a(ia-1,ja+1,if) )*xr*0.5d0   &
            &          + a(ia,ja+1,if)
        azero = ( (a(ia+1,ja,if)+a(ia-1,ja,if)   &
            &          - 2.d0*a(ia,ja,if) )*xr   &
            &          + a(ia+1,ja,if)-a(ia-1,ja,if) )*xr*0.5d0   &
            &          + a(ia,ja,if)
        amoin = ( (a(ia+1,ja-1,if)+a(ia-1,ja-1,if)   &
            &          - 2.d0*a(ia,ja-1,if) )*xr   &
            &          + a(ia+1,ja-1,if)-a(ia-1,ja-1,if) )*xr*0.5d0   &
            &          + a(ia,ja-1,if)
        ! Then Y (or X)
        afin = ( (aplus+amoin-2.d0*azero)   &
            &          *yr + aplus-amoin )*yr*0.5d0 + azero
        !
        visi(5+3*if,i) =  real(afin)*factor
        ! There was a - sign in the precedent version
        visi(6+3*if,i) =  imag(afin)*factor
      enddo
    else
      icount = icount+1
    endif
  enddo
  !$OMP END DO
  !$OMP END PARALLEL
  if (icount.ne.0) then
    write(chain,'(A,I0,A,I0,A)') 'Input model insufficiently spatially sampled: lost ', &
      & icount,' / ',nv, ' Visibilities'
    call map_message(seve%w,'CCT_UVMODEL',chain)
  endif
end subroutine do_uvmodel
!<FF>
subroutine do_fft (nx,ny,nf,fft,work)
  !$ use omp_lib
  use imager_interfaces, only : recent
  !! IMAGER -- Compute a Cube from its FFT
  !
  integer, intent(in)  :: nx                       !! X size
  integer, intent(in)  :: ny                       !! Y size
  integer, intent(in)  :: nf                       !! Z size
  complex, intent(inout) :: fft(nx,ny,nf)          !! FFT cube
  real, intent(inout)  :: work(2*max(nx,ny))       !! Work space
  !
  ! Local ---
  integer :: if,dim(2), ier, ithread
  real, allocatable :: lwork(:)
  !
  ! Code ----
  dim(1) = nx
  dim(2) = ny
  ! Loop on channels
  !$OMP PARALLEL DEFAULT(none) &
  !$OMP & SHARED(dim,nx,ny,nf,fft) &
  !$OMP & PRIVATE(if, ier, lwork, ithread)
  allocate(lwork(2*max(nx,ny)),stat=ier)
  !$ ithread = omp_get_thread_num()+1
  !$OMP DO
  do if = 1, nf
    !!Print *,'Starting channel ',if,' Thread ',ithread
    call fourt(fft(:,:,if),dim,2,1,1,lwork)
    call recent(nx,ny,fft(:,:,if))
  enddo
  !$OMP END DO
  !$OMP END PARALLEL
end subroutine do_fft
!<FF>
subroutine copyuv (nco,nv,out,nci,in)
  !---------------------------------------------------------------------
  ! @ public
  !
  !! IMAGER --  Copy structure of UV data, but not the (Real,Imag) columns
  !---------------------------------------------------------------------
  integer, intent(in)  :: nco                      !! Size of output visi.
  integer, intent(in)  :: nv                       !! Number of visibilities
  real, intent(out)  :: out(nco,nv)                !! Output Visibilities
  integer, intent(in) :: nci                       !! Size of input visi.
  real, intent(in)  :: in(nci,nv)                  !! Input visibilities
  !
  ! Local ---
  integer :: i,j
  !
  ! Code ----
  ! This does not handle extra columns
  do i=1,nv
    out(1:7,i) = in(1:7,i)
    do j=8,nco,3
      out(j,i) = 0
      out(j+1,i) = 0
      out(j+2,i) = in(10,i)
    enddo
  enddo
end subroutine copyuv
!
subroutine cct_def_image (hima,mx,my,nf,xinc,yinc,error)
  use image_def
  use imager_interfaces, only : map_message
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !
  !! IMAGER -- Define Image size from CCT information.  
  !! Supports both layouts of CCT tables.
  !---------------------------------------------------------------------
  type (gildas), intent(in) :: hima   !! Input CCT Table
  integer, intent(out) :: mx,my,nf    !! Ouput data cube size
  real(8), intent(out) :: xinc,yinc   !! Pixel size
  logical, intent(out) :: error       !! Error flag
  !
  error = .false.
  if (hima%char%code(3).eq.'COMPONENT') then
    call map_message(seve%i,'UV_FCCT','Clean Components from IMAGER')
    nf = hima%gil%dim(2)  ! Number of channels
    mx = (hima%gil%ref(1)-1)*2
    xinc = hima%gil%inc(1)
    my = (hima%gil%ref(3)-1)*2
    yinc = hima%gil%inc(3)
  else
    call map_message(seve%w,'UV_FCCT','Clean Components from old CLEAN Task')
    nf = hima%gil%dim(3)
    mx = (hima%gil%ref(1)-1)*2
    xinc = hima%gil%inc(1)
    my = (hima%gil%ref(2)-1)*2
    yinc = hima%gil%inc(2)
  endif
end subroutine cct_def_image
!
subroutine cct_set_image (hcct,clean,mx,my,mc,xinc,yinc,nf,image,error)
  use image_def
  use gbl_message
  use imager_interfaces, only : map_message
  !---------------------------------------------------------------------
  ! @ private
  !
  !! IMAGER -- Fill an Image from the list of Clean Components 
  !---------------------------------------------------------------------
  type (gildas), intent(in) :: hcct          !! CCT Table header
  real clean(hcct%gil%dim(1),hcct%gil%dim(2),hcct%gil%dim(3))  !! CCT Table
  integer, intent(in) :: mx,my,nf         !! Output data cube size
  integer, intent(in) :: mc               !! Max component number
  real(8), intent(in) :: xinc,yinc        !! Pixel size
  real, intent(out) :: image(mx,my,nf)    !! Output data
  logical, intent(out) :: error           !! Logical Error flag
  !
  ! Local ---
  integer :: lc,nc,kc,ic,jf,ix,iy
  character(len=80) :: mess
  !
  ! Code ----
  image = 0
  if (hcct%char%code(3).eq.'COMPONENT') then
    lc = hcct%gil%dim(1)
    nc = hcct%gil%dim(2)  ! Number of channels
    if (nc.ne.nf) then
      write(mess,*) 'Channel mismatch ',nc,nf
      call map_message(seve%e,'MODEL',mess)
      error = .true.
      return
    endif
    if (mc.eq.0) then
      kc = hcct%gil%dim(3)  ! Number of components
    else
      kc = min(mc,hcct%gil%dim(3))
    endif
    !
    do jf = 1,nf
      do ic = 1,kc
        if (clean(3,jf,ic).ne.0) then
          ix = nint(clean(1,jf,ic)/xinc)+mx/2+1
          iy = nint(clean(2,jf,ic)/yinc)+my/2+1
          image(ix,iy,jf) = image(ix,iy,jf) + clean(3,jf,ic)
        else
          exit ! No more components for this channel
        endif
      enddo
    enddo
  else
    lc = hcct%gil%dim(1)
    if (mc.eq.0) then
      kc = hcct%gil%dim(2)  ! Number of components
    else
      kc = min(mc,hcct%gil%dim(2))
    endif
    nc = hcct%gil%dim(3)
    if (nc.ne.nf) then
      write(mess,*) 'Channel mismatch ',nc,nf
      call map_message(seve%e,'MODEL',mess)
      error = .true.
      return
    endif
    do jf = 1,nf
      do ic = 1,kc
        if (clean(1,ic,jf).ne.0) then
          ix = nint(clean(2,ic,jf))
          iy = nint(clean(3,ic,jf))
          image(ix,iy,jf) = image(ix,iy,jf) + clean(1,ic,jf)
        else
          exit ! No more components for this channel
        endif
      enddo
    enddo
  endif
end subroutine cct_set_image
!
subroutine mod_fft_size(large,mx,my,nx,ny)
  !---------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- Support for MODEL  
  !   Define the intermediate FFT size - Make it square by default
  !!
  !---------------------------------------------------------------------
  logical, intent(in) :: large      !! Should size be enlarged ?
  integer, intent(in) :: mx,my      !! Input map size
  integer, intent(out) :: nx,ny     !! Output fft size
  !
  ! Local ---
  integer :: kxy, mxy
  real :: rxy
  !
  ! Code ----
  mxy = max(mx,my)
  rxy = log(float(mxy))/log(2.0)
  kxy = nint(rxy)
  if (kxy.lt.rxy) kxy = kxy+1
  nx = 2**kxy
  if (large) nx = max(mxy,min(4*nx,4096))
  ny = nx
end subroutine mod_fft_size
!!
subroutine apply_primary_single(dmap,dsky,offx,offy,hsky,nr,profile,error)
  use gkernel_interfaces
  use imager_interfaces, except_this=>apply_primary_single
  use image_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private-mandatory
  !*
  ! IMAGER -- Support for command MODEL [BeamSize]  
  ! Compute and Applies primary beam for a single field
  !!
  !---------------------------------------------------------------------
  real, intent(out) :: dmap(:,:,:)  !! Attenuated Image
  real, intent(in) :: dsky(:,:,:)   !! True sky distribution
  real(8), intent(in) :: offx       !! X pointing offset (radians)
  real(8), intent(in) :: offy       !! Y pointing offset (radians)
  type(gildas), intent(in) :: hsky  !! Sky Header
  integer, intent(in) :: nr         !! Number of radial points for beam profile
  real(8), intent(in) :: profile(:,:)   !! Radial beam profile ((radii, values)
  logical, intent(out) :: error     !! Logical error flag
  !
  ! Constants
  character(len=*), parameter :: rname='PRIMARY'
  real(8), parameter :: pi=3.14159265358979323846d0
  integer, parameter :: o_trunc=1
  !
  ! Local ---
  integer :: ir,ix,iy
  real(8) :: ioffx, ioffy, dr, r, x, y
  real(4) :: factor
  !
  ! Code ----
  ioffx = offx/hsky%gil%inc(1)
  ioffy = offy/hsky%gil%inc(2)
  dr = profile(2,1) - profile(1,1) ! Increment
  !
  do iy=1,hsky%gil%dim(2)
    y = (iy-hsky%gil%ref(2)-ioffy)*hsky%gil%inc(2) + hsky%gil%val(2)
    do ix=1,hsky%gil%dim(1)
      x = (ix-hsky%gil%ref(1)-ioffx)*hsky%gil%inc(1) + hsky%gil%val(1)
      r = sqrt(x**2+y**2)
      !
      ! Locate by interpolation
      ir = int(r/dr)+1
      if (ir.lt.nr) then
        factor = ((profile(ir+1,1)-r)*profile(ir,2) + (r-profile(ir,1))*profile(ir+1,2) ) /dr
        dmap(ix,iy,:) = dsky(ix,iy,:) * factor
      else
        dmap(ix,iy,:) = 0.
      endif
    enddo
  enddo
  !
end subroutine apply_primary_single
!
subroutine self_uvmodel(line,huvl,error)
  use gildas_def
  use gbl_message
  use gkernel_interfaces
  use clean_arrays
  use imager_interfaces, except_this => self_uvmodel
  !---------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER --  Support routine for command  
  !     MODEL [MaxIter] [/MINVAL Value [Unit]] /MODE SELF CCT 
  !
  ! Compute the MODEL UV data set from the current CCT table
  ! for Self-Calibration
  !
  !     Uses an intermediate FFT with further interpolation for
  !     better speed than UV_CCT
  !!
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: line      !! Command line
  type(gildas), intent(in) :: huvl          !! Input UV data
  logical, intent(inout) :: error           !! Error flag
  !
  ! Constants
  character(len=*), parameter :: rname='MODEL'
  real(kind=8), parameter :: pi=3.14159265358979323846d0
  integer, parameter :: o_minval=1 ! 
  integer, parameter :: o_output=2 ! Must be 2 ...
  integer, parameter :: o_mode=3   
  !
  ! Local ---
  integer :: nclean ! Number of clean components retained
  logical :: large
  real, allocatable :: dmap(:,:,:)
  integer :: nf,mx,my, ier
  real :: cpu0
  real(8) :: xinc, yinc, freq
  !
  ! Code ----
  nclean = 0
  call sic_i4(line,0,1,nclean,.false.,error)
  if (error) return
  large = sic_present(0,2) ! Test
  !
  if (.not.associated(huvl%r2d)) then
    call map_message(seve%e,rname,'Input UV pointer is not associated') 
    error = .true.
    return
  endif
  ! Code
  error = .false.
  call gag_cpu(cpu0)
  !
  ! Input data is passed as argument through HUVL and its data
  ! is defined by its HUVL%R2D pointer
  ! 
  ! This is in general HUV and DUV
  !
  ! Input CCT is the current CCT Data (it should match the UV data)
  !
  ! Compact it into an image
  ! This depends on the CCT type, and is done in a subroutine
  !    First, define the sampling and image size 
  !
  call cct_def_image (hcct,mx,my,nf,xinc,yinc,error)
  if (error) return
  !Print *,'XINC ',xinc,hsky%gil%inc(1)
  !Print *,'YINC ',yinc,hsky%gil%inc(2)
  !Print *,'CCT size ',mx,my
  !Print *,'SKY size ',hsky%gil%dim(1:2)
  !read(5,*) mx,my
  !
  if (nf.ne.1) then
    if (nf.ne.huvl%gil%nchan) then
      Print *,'CCT channels ',nf,'  UVDATA chanels ',huvl%gil%nchan
      call map_message(seve%w,rname,'Velocity axis mis-match')
      error = .true.
      return
    endif
  endif
  !
  !    Then do the job
  allocate (dmap(mx,my,nf),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'MAP Allocation error')
    error = .true.
    return
  endif
  call cct_set_image (hcct,dcct,mx,my,nclean,xinc,yinc,nf,dmap,error)
  !
  !Print *,'--------------------------'
  !Print *,' Before map_fast_uvmodel '
  !Print *,' ' 
  ! call gdf_print_header(huvl)
  freq = gdf_uv_frequency(huvl)  
  call map_fast_uvmodel(huvl,huvl%r2d,huv_model,duvm,hsky,dmap,themap,freq,error)
end subroutine self_uvmodel


subroutine cct_new_uvmodel(line,huvl,error)
  use gildas_def
  use gbl_message
  use gkernel_interfaces
  use clean_arrays
  use imager_interfaces, except_this => cct_new_uvmodel
  !---------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER --  Support routine for command  
  !     MODEL [MaxIter] [/MINVAL Value [Unit]] [/MODE CCT [Frequency]]
  !
  ! Compute the MODEL UV data set from the current CCT table
  !
  !     Uses an intermediate FFT with further interpolation for
  !     better speed than UV_CCT
  !!
  !---------------------------------------------------------------------
  character(len=*), intent(inout) :: line   !! Command line
  type(gildas), intent(in) :: huvl          !! Input UV data
  logical, intent(inout) :: error           !! Error flag
  !
  ! Constants
  character(len=*), parameter :: rname='MODEL'
  real(kind=8), parameter :: pi=3.14159265358979323846d0
  integer, parameter :: o_minval=1 ! 
  integer, parameter :: o_output=2 ! Must be 2 ...
  integer, parameter :: o_mode=3   
  logical, parameter :: subtract=.false.
  ! Local ---
  integer :: nclean ! Number of clean components retained
  integer :: ier, iarg
  real :: cpu0
  logical :: do_clean, do_resi
  !
  ! Code ----
  nclean = 0
  call sic_i4(line,0,1,nclean,.false.,error)
  if (error) return
  !
  if (.not.associated(huvl%r2d)) then
    call map_message(seve%e,rname,'Input UV pointer is not associated') 
    error = .true.
    return
  endif
  ! Code
  error = .false.
  call gag_cpu(cpu0)
  !
  error = .false.
  if (themap%nfields.ne.0) then
    call map_message(seve%w,rname,'UV data is a Mosaic - UNDER TESTS !!!')
! Unclear - which mosaic is to be shited ???  Why does not depend on HUVL
!    call uv_shift_mosaic(line,rname,error)
!    if (error) return
  endif
  !
  call sic_delvariable('UV_MODEL',.false.,error)
  !
  if (allocated(duvm)) deallocate(duvm)
  call gildas_null(huv_model,type='UVT')
  call gdf_copy_header(huvl,huv_model,error)
  allocate (duvm(huv_model%gil%dim(1),huv_model%gil%dim(2)),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'UV Model allocation error')
!    call gdf_copy_header(htmp,huvl,error)  ! Save SG  Why ?
    error = .true.
    return
  endif
  !
  ! Do the job. 
  do_clean = .false. 
  do_resi = .true.
  !
  ! Buffer choice will depend on the MODEL option
  Print *,'HUVL ',associated(huvl%r2d)
  Print *,'DUVM ',allocated(duvm) 
  Print *,'Calling SUB_UV_RESIDUAL with HUV_MODEL and DUVM'
  call sub_uv_residual(rname,line,iarg,huv_model,huvl%r2d,duvm, &
    &   do_clean,do_resi,subtract,error)
  huv_model%r2d => duvm
end subroutine cct_new_uvmodel

subroutine init_kernel(ker,mk,nk,smooth)
  !-----------------------------------------------------------------------
  ! @ public
  !*
  ! IMAGER --  Support for MULTISCALE clean
  !
  !   Initialize a smoothing Kernel by a Gaussian shape
  !!
  !-----------------------------------------------------------------------
  integer, intent(in) :: mk            !! Kernel size
  integer, intent(in) :: nk            !! Kernel size
  real(4), intent(inout) :: ker(mk,mk) !! Kernel, centered on (NK+1)/2
  real(4), intent(in) :: smooth        !! Smoothing factor
  !
  ! Local ---
  integer :: i,j
  real :: lk,r,s2,sker
  !
  ! Code ----
  if (nk.eq.1) then     ! Dirac
    ker(1,1) = 1.
    return
  endif
  if (smooth.eq.0) then ! Constant box
    ker = 1.0/(nk*nk)
    return
  endif
  !
  ! Discret Gaussian kernel
  lk = (nk+1.0)/2.0
  s2 = 1.0/smooth**2
  sker = 0.0
  ker = 0.0
  do j=1,nk
    do i=1,nk
      r = (i-lk)**2 + (j-lk)**2
      r = r*s2
      ker(i,j) = exp(-r)
      sker = sker+ker(i,j)
    enddo
  enddo
  sker = 1.0/sker
  ker = ker * sker
  !! Print *,'Kernel ratio ',minval(ker)/maxval(ker)
end subroutine init_kernel
!
subroutine smooth_mask (mask,smask,nx,ny,nk)
  !-----------------------------------------------------------------------
  ! @ public
  !*
  ! IMAGER --  Support for MULTISCALE clean
  !
  !   Enlarge a mask using a kernel, based only on kernel size
  !!
  !-----------------------------------------------------------------------
  integer, intent(in) :: nx             !! X size
  integer, intent(in) :: ny             !! Y size
  logical, intent(in) :: mask(nx,ny)    !! Input array
  logical, intent(out) :: smask(nx,ny)  !! Smoothed array
  integer, intent(in) :: nk             !! kernel size
  !
  ! Local ---
  integer i,j,lk,lj,li
  !
  ! Code ----
  if (nk.eq.1) then
    smask = mask
  else
    smask = mask
    lk = (nk+1)/2
    do j=lk,ny-lk+1
      do i=lk,nx-lk+1
        if (.not.smask(i,j)) then
          do lj=1,nk
            do li=1,nk
              if (mask(i-li+lk,j-lj+lk)) then
                smask(i,j) = .true.
              endif
            enddo
          enddo
        endif
      enddo
    enddo
  endif
end subroutine smooth_mask
!
subroutine smooth_kernel (array,sarray,nx,ny,mk,nk,ker)
  !-----------------------------------------------------------------------
  ! @ public
  !*
  ! IMAGER --  Support for MULTISCALE clean
  !
  !   Smooth an array using a kernel.
  ! Parallel programming is useful here
  !!
  !-----------------------------------------------------------------------
  integer, intent(in) :: nx             !! X size
  integer, intent(in) :: ny             !! Y size
  real, intent(in) :: array(nx,ny)      !! Input array
  real, intent(out) :: sarray(nx,ny)    !! Smoothed array
  integer, intent(in) :: nk             !! Actual Kernel size
  integer, intent(in) :: mk             !! Kernel dimensions
  real, intent(in) :: ker(mk,mk)        !! Smoothing kernel, centered on (nk+1)/2
  !
  integer, external :: ompget_inner_threads
  !
  ! Local ---
  integer nthread
  integer i,j,lk,lj,li
  !
  ! Code ----
  if (nk.eq.1) then
    sarray = array
  else
    nthread = ompget_inner_threads()
    sarray = 0.      ! Mandatory
    lk = (nk+1)/2
    !$OMP PARALLEL PRIVATE(lj,j,li,i) NUM_THREADS(nthread)
    !$OMP DO COLLAPSE(2)
    do j=lk,ny-lk+1
      do i=lk,nx-lk+1
        do lj=1,nk
          do li=1,nk
            sarray(i,j) = sarray(i,j)+ker(li,lj)   &
    &              *array(i-li+lk,j-lj+lk)
          enddo
        enddo
      enddo
    enddo
    !$OMP END DO
    !$OMP END PARALLEL
  endif
end subroutine smooth_kernel
!
subroutine smooth_masked (nx,ny,sarray,array,mask,mk,nk,ker)
  !-----------------------------------------------------------------------
  ! @ public
  !*
  ! IMAGER -- Support for MULTISCALE
  !
  !   Smooth an array using a kernel, but only in a mask.
  ! Parallel programming is useful here
  !!
  !-----------------------------------------------------------------------
  integer, intent(in) :: nx             !! X size
  integer, intent(in) :: ny             !! Y size
  real, intent(in) :: array(nx,ny)      !! Input array
  real, intent(out) :: sarray(nx,ny)    !! Smoothed array
  logical, intent(in) :: mask(nx,ny)    !! Valid area
  integer, intent(in) :: mk             !! Kernel array size
  integer, intent(in) :: nk             !! Kernel actual size
  real, intent(in) :: ker(mk,mk)        !! Smoothing kernel, centered on (nk+1)/2
  !
  integer, external :: ompget_inner_threads
  !
  ! Local
  integer nthread
  integer i,j,lk,lj,li,ii,jj
  !
  ! Code
  if (nk.eq.1) then
    sarray = array
  else
    nthread = ompget_inner_threads()
    sarray = 0.0  ! Mandatory
    !
    lk = (nk+1)/2
    !$OMP PARALLEL PRIVATE(i,j,lj,jj,li,ii) NUM_THREADS(nthread)
    !$OMP DO COLLAPSE(2)
    do j=lk,ny-lk+1
      do i=lk,nx-lk+1
        if (mask(i,j)) then
          do lj=1,nk
            jj = j-lj+lk
            do li=1,nk
              ii = i-li+lk
              sarray(i,j) = sarray(i,j)+ker(li,lj)*array(ii,jj)
            enddo
          enddo
        endif
      enddo
    enddo
    !$OMP END DO
    !$OMP END PARALLEL
  endif
end subroutine smooth_masked
!
subroutine add_kernel (clean,nx,ny,value,kx,ky,mk,nk,ker)
  !-----------------------------------------------------------------------
  ! @ public
  !*
  ! IMAGER  -- Support for MULTISCALE Clean
  !
  !   Spread a value using a Kernel and add it to result
  ! 
  !   Parallel programming does not help here, as the Kernel is small
  !!
  !-----------------------------------------------------------------------
  integer, intent(in) :: nx           !! X Image size
  integer, intent(in) :: ny           !! Y Image size
  real, intent(inout) :: clean(nx,ny) !! Summed output array
  real, intent(in) :: value           !! Input value
  integer, intent(in) :: kx           !! X Center of value
  integer, intent(in) :: ky           !! Y Center of value
  integer, intent(in) :: mk           !! Kernel  array size
  integer, intent(in) :: nk           !! Kernel actual size
  real, intent(in) :: ker(mk,mk)      !! Smoothing kernel, centered on (nk+1)/2
  !
  ! Local ---
  integer i,j,lk,li,lj
  !
  ! Code ----
  if (nk.eq.1) then
    clean(kx,ky) = clean(kx,ky) + value
  else
    lk = (nk-1)/2
    do j=ky-lk,ky+lk
      lj = j-ky+lk+1
      do i=kx-lk,kx+lk
        li = i-kx+lk+1
        clean(i,j) = clean(i,j) + ker (li,lj) * value
      enddo
    enddo
  endif
end subroutine add_kernel
!
subroutine amaxmask (a,mask,nx,ny,ix,iy)
  !-----------------------------------------------------------------------
  ! @ public
  !*
  ! IMAGER -- Support for deconvolution
  !
  !     Search the absolute maximum, in a masked region
  !
  ! Parallel programming does not help  here.
  !!
  !-----------------------------------------------------------------------
  integer, intent(in) :: nx           !! X size
  integer, intent(in) :: ny           !! Y size
  real, intent(in) :: a(nx,ny)        !! Values
  logical, intent(in) :: mask(nx,ny)  !! Mask
  integer, intent(out) :: ix          !! X position of max
  integer, intent(out) :: iy          !! Y position of max
  !
  ! Local ---
  real rmax
  integer i,j
  !
  ! Code ----
  rmax = -1.0
  ix = 1
  iy = 1
  do j=1,ny
    do i=1,nx
      if (mask(i,j)) then
        if (abs(a(i,j)).gt.rmax) then
          rmax = abs(a(i,j))
          ix = i
          iy = j
        endif
      endif
    enddo
  enddo  
end subroutine amaxmask
!
subroutine translate (in, nx, ny, trans, ix, jy)
  !-----------------------------------------------------------------------
  ! @ private
  !
  !!     Translate an Array by IX, IY
  !-----------------------------------------------------------------------
  integer, intent(in) :: nx          !! X size
  integer, intent(in) :: ny          !! Y size
  real, intent(in) :: in(nx,ny)      !! Input beam
  real, intent(out) :: trans(nx,ny)  !! Translated beam
  integer, intent(in) :: ix          !! X shift
  integer, intent(in) :: jy          !! Y shift
  !
  ! Local ---
  integer :: i,j
  !
  ! Code ----
  trans = 0.0  
  do j=max(1,jy+1),min(ny,ny+jy)
    do i=max(1,ix+1),min(nx,nx+ix)
      trans(i,j) = in(i-ix,j-jy)
    enddo
  enddo
end subroutine translate
!
subroutine spread_kernel (nx,ny,ip,nc,dcct,value,kx,ky,nk,ker)
  !-----------------------------------------------------------------------
  ! @ public-mandatory
  !
  ! IMAGER -- Support for MULTISCALE Clean
  !
  !   Spread a value using a Kernel and add it to result
  !!
  !-----------------------------------------------------------------------
  integer, intent(in) :: nx           !! X Image size
  integer, intent(in) :: ny           !! Y Image size
  integer, intent(in) :: ip           !! Plane number 
  integer, intent(inout) :: nc        !! Number of clean components
  real, intent(out) :: dcct(:,:,:)    !! Expanded Clean Components 
  real, intent(in) :: value           !! Input value
  integer, intent(in) :: kx           !! X Center of value
  integer, intent(in) :: ky           !! Y Center of value
  integer, intent(in) :: nk           !! Actual Kernel size
  real, intent(in) :: ker(:,:)        !! Smoothing kernel, centered on (nk+1)/2
  !
  ! Local ---
  integer :: ix,iy,j,li,lj,lk
  !
  ! Code ----
  j = nc 
  if (nk.eq.1) then
    j = j+1
    dcct(1,ip,j) = kx
    dcct(2,ip,j) = ky
    dcct(3,ip,j) = value 
  else
    lk = (nk-1)/2
    do lj=-lk,lk
      iy = ky+lj
      if (iy.gt.0 .and. iy.le.ny) then
        do li=-lk,lk
          ix = kx+li
          if (ix.gt.0 .and. ix.le.nx) then
            j = j+1
            dcct(1,ip,j) = ix
            dcct(2,ip,j) = iy
            dcct(3,ip,j) = value * ker(li+(nk+1)/2,lj+(nk+1)/2)
          endif
        enddo
      endif
    enddo
  endif
  !
  nc = j
end subroutine spread_kernel
!
subroutine multi_shift(ip,ox,oy,px,py)
  use clean_arrays
  !------------------------------------------------------
  ! @ private
  !*
  !   IMAGER -- Support for Mosaics
  !
  !     Temporary routine to define the pixel offsets.
  !   The relevant information may have to go into a module
  !   
  !   No longer used ...
  !!
  !------------------------------------------------------
  integer, intent(in) :: ip   !! Field number
  integer, intent(out) :: ox  !! Offset in X
  integer, intent(out) :: oy  !! Offset in Y
  integer, intent(out) :: px  !! Offset in X
  integer, intent(out) :: py  !! Offset in Y
  !!
  ox = 0
  oy = 0
  px = hprim%gil%dim(2)
  py = hprim%gil%dim(3)
  !
  if (.not.allocated(huv_current%mos%fields)) return
  ox = huv_current%mos%fields(ip)%jxy(1)
  oy = huv_current%mos%fields(ip)%jxy(2)
end subroutine multi_shift
  

subroutine mask_comm(line,error)
  use gildas_def
  use gbl_message
  use gkernel_types
  use clean_arrays
  use clean_default
  use clean_support
  use gkernel_interfaces
  use imager_interfaces, except_this => mask_comm
  !---------------------------------------------------------------------
  ! @ private
  !*
  !   IMAGER -- Support routine for commandADVANCED\MASK Arguments... 
  !
  ! Several modes  
  !   MASK  ADD Figure Description  
  !                 Add the corresponding figure to mask  
  !   MASK  APPLY Variable    
  !                 Apply the current mask to 3-D Variable  
  !   MASK  INIT [2D|3D] [/FROM ....]  
  !                 Initialize a mask  
  !   MASK  OVERLAY  
  !                 Overlay the mask on the current Image  
  !   MASK  READ File  
  !                 Read a Mask from disk (is that a .msk or a .pol ?)   
  !                 (redundant with READ MASK )
  !   MASK  REGIONS Nregions  
  !                 Only keep the most important domains  
  !   MASK  REMOVE  Fig_Description  
  !                 Removed the figure from mask  
  !   MASK  USE   
  !                 Activate the current mask as a Support
  !                 (redundant with SUPPORT /MASK)
  !   MASK  SHOW    
  !                 as SHOW MASK  
  !   MASK  THRESHOLD Value Unit [SMOOTH Smooth Length] [GUARG Guard]
  !                 [REGIONS Nregions]  
  !                 automatic Mask builder by Thresholding
  !   MASK  WRITE File  
  !                 Write a mask to disk. 
  !                 (almost redundant with WRITE MASK ? )
  !
  !   MASK          Launch interactive mask definition  
  !          (would be better on currently displayed image, rather
  !           than only the CLEAN data cube. Rank could depend
  !           on how many channels are displayed)
  !!
  !---------------------------------------------------------------------
  character(len=*), intent(in)  :: line     !! Input command line
  logical,          intent(out) :: error    !! Logical error flag
  !
  ! Constants
  character(len=*), parameter :: rname='MASK'
  !
  integer, parameter :: mvoc=15
  character(len=12) :: vocab(mvoc), key, lkey
  data vocab /'ADD','APPLY','CHECK','COLLAPSE','INITIALIZE', &
    & 'INTERACTIVE','LABEL','OVERLAY','READ','REGIONS','REMOVE', &
    & 'SHOW','THRESHOLD','USE','WRITE'/
  integer, parameter :: mfig=4
  character(len=12) :: figure(mfig), kfig
  data figure /'CIRCLE','ELLIPSE','POLYGON','RECTANGLE'/
  integer :: margs(mfig)
  data margs /3,5,1,5/
  !
  ! Local ---
  character(len=96), save  :: lstring=' '
  type(gildas) :: head
  character(len=24) :: argum, chain
  character(len=filename_length) :: name
  character(len=commandline_length) :: aline
  integer :: ikey,is,nc,na,narg
  logical :: do_insert
  real :: r4
  logical :: is_image
  logical :: rdonly
  !
  ! Code ----
  error = .false.
  do_insert = sic_lire().eq.0
  !
  ! If no argument, activate the default interactive mode
  argum = 'INTERACTIVE'
  !
  call sic_ke(line,0,1,argum,nc,.false.,error)
  if (error) return  !
  call sic_ambigs (rname,argum,key,ikey,vocab,mvoc,error)
  if (error) return
  !
  if (key.eq.'CHECK') then
    if (sic_present(0,2)) then
      call sic_ke(line,0,2,name,nc,.true.,error)
      if (error) return
      call gildas_null(head) 
      is_image = .false.    ! Can check against a file
      call sub_readhead('MASK',name,head,is_image,error,rdonly) !,fmt,type)
      if (error) return
      call mask_check(name,head,error)
    else
      call mask_check(mask_template,hmask_temp,error)
    endif
    if (do_insert) call sic_insert_log(line)
    return
  endif
  !
  ! These create the MASK
  select case(key)
  case ('INITIALIZE')
    if (sic_narg(0).eq.1) then
      argum = '3D'
    else
      call sic_ke(line,0,2,argum,nc,.false.,error)
    endif
    call mask_init(line,argum,error)
    if (error) return
    call exec_program('@ p_mask init NO')  ! Support is void at this stage
  case ('READ') 
    call sic_ch(line,0,2,name,nc,.true.,error)
    if (error) return
    !
    call exec_program('READ MASK '//name(1:nc))
    call exec_program('@ p_mask init YES')  ! Support is filled 
  case ('THRESHOLD')
    call mask_threshold(line,error)
    if (error) return  
    call exec_program('@ p_mask init YES')  ! Support is filled 
  case ('REGIONS')
    call mask_regions(line,error)
    if (error) return  
    call exec_program('@ p_mask init YES')  ! Support is filled 
  case ('LABEL')
    call mask_to_label(error)
    if (error) return
  case ('COLLAPSE')
    call mask_collapse(error)
    if (error) return
  !
  ! These need the MASK and the Clean image
  case ('INTERACTIVE') 
    call mask_check(mask_template,hmask_temp,error)
    if (error) return
    !
    argum = '1'
    call sic_ke(line,0,2,argum,nc,.false.,error)
    call exec_program('@ p_mask interactive '//argum)
    do_insert = .false.
  case ('ADD','REMOVE')
    call mask_check(mask_template,hmask_temp,error)
    if (error) return
    !
    lkey = key
    call sic_lower(lkey)
    if (key.eq.'ADD') then
      lkey = 'add'
    else
      lkey = 'rm'
    endif
    !
    narg = sic_narg(0)
    if ((narg.eq.1).and.(lkey.eq.'rm')) then
      if (len_trim(lstring).eq.0) return ! Silent return
      call map_message(seve%i,rname,'Removing '//lstring(4:))
      continue ! Re-use the previous Lstring
    else
      call sic_ke(line,0,2,argum,nc,.true.,error)
      if (error) return  !
      call sic_ambigs (rname,argum,kfig,ikey,figure,mfig,error)
      if (error) return
      call sic_lower(kfig)
      lstring = kfig
      !
      if (narg.eq.margs(ikey)+2) then
        na = len_trim(lstring)+2
        if (kfig.ne.'polygon') then
          ! Get the numerical values of all arguments
          do is=3,narg
            call sic_r4(line,0,is,r4,.true.,error)
            if (error) return
            write(chain,*) r4
            lstring(na:) = chain
            na = na + len_trim(chain)
          enddo
        else
          call sic_ch(line,0,3,chain,nc,.true.,error)
          if (error) return
          lstring(na:) = chain(1:nc)
        endif
      else
        call map_message(seve%e,rname,trim(key)//' '//trim(kfig)//' requires ' &
          & //char(margs(ikey)+ichar('0'))//' additional arguments')
        error = .true.
        return
      endif
    endif
    aline = '@ p_mask '//trim(lkey)//' '//lstring
    call exec_program(aline)
  case default
    select case (key)
    case ('APPLY') 
      call mask_apply(line,error)
      do_insert = .false.
    case ('OVERLAY') 
      call mask_check(mask_template,hmask_temp,error)
      if (error) return
      call exec_program('@ p_mask over')
    !
    ! Only MASK is needed below
    case ('USE')
      call mask_present(error)
      if (error) return
      call sub_support_mask(rname,.true.,.false.,error)
    case ('SHOW')
      call mask_present(error)
      if (error) return
      call exec_program('SHOW MASK')
    case ('WRITE')
      call mask_present(error)
      if (error) return
      !
      is = sic_start(0,2) 
      call exec_program('WRITE MASK '//line(is:))
    case default
      call map_message(seve%e,rname,trim(key)//' not yet supported')
      error = .true.
      return
    end select  
    if (do_insert) call sic_insert_log(line)
    return
  end select
  !
  ! Activate the modified Mask if needed
  if (support_type.eq.support_mask) then
    call sub_support_mask(rname,.true.,.false.,error)
  endif
  if (do_insert) call sic_insert_log(line)
  !
  ! A final trick to avoid inserting the command
  call no_logstack()
end subroutine mask_comm
!
subroutine mask_apply(line,error)
  use gildas_def
  use gbl_message
  use gkernel_types
  use clean_arrays
  use gkernel_interfaces
  use imager_interfaces, only : map_message
  use iso_c_binding
  !---------------------------------------------------------------------
  ! @ private
  !*
  !   IMAGER -- Support routine for command ADVANCED\MASK APPLY Variable
  !!
  !---------------------------------------------------------------------  
  character(len=*), intent(in)  :: line     !! Input command line
  logical,          intent(out) :: error    !! Logical error flag
  !
  ! Constants
  character(len=*), parameter :: rname='MASK'
  !
  ! Local ---
  type(sic_descriptor_t) :: desc
  integer(kind=4) :: nc
  character(len=6) :: argum
  logical :: equal, found
  type(c_ptr) :: cptr
  real(4), pointer :: r3ptr(:,:,:)
  !
  if (hmask%loca%size.eq.0) then
    call map_message(seve%e,rname,'No mask defined,')
    error = .true.
    return
  endif
  error = .false.
  !
  call sic_ke(line,0,2,argum,nc,.false.,error)
  if (error) return
  !
  if (argum.eq.'MASK') then
    call map_message(seve%e,rname,'Cannot MASK the Mask...')
    error = .true.
    return
  else if (argum.eq.'CCT') then
    call map_message(seve%w,rname,'Applying MASK to CCT not fully tested...')
    call cct_mask_comm(line,error)
    return  
  endif
  !
  ! Any SIC 2-D+ variable with matching coordinate is acceptable
  ! But "get_gildas" mechanism is not acceptable, since the Header
  ! must be modified for the Blanking.
  !
  ! Look at the SIC variable
  call sic_descriptor(argum,desc,found)  
  if (.not.found) then
    call map_message(seve%e,rname,'No such SIC variable '//argum)
    error = .true.
    return
  endif
  if (.not.associated(desc%head)) then
    ! Else, no match anyway
    call map_message(seve%w,rname,  &
      'Variable '//trim(argum)//' does not provide a header')
      error = .true.
      return
  endif
  !
  ! Check that desc%head and HMASK match in 2-D and that Frequency axis
  ! can be interpolated properly
  call gdf_compare_2d(desc%head,hmask,equal)
  if (.not.equal) then
    call map_message(seve%e,rname,'MASK and '//trim(argum)//' do not match')
    error = .true.
    return
  endif
  !
  hmask%r3d => dmask
  call adtoad(desc%addr,cptr,1)
  call c_f_pointer(cptr,r3ptr,desc%dims(1:3))
  call sub_mask_apply(desc%head,hmask,r3ptr,error)
  desc%head%gil%blan_words = 2
  desc%head%gil%eval = max(desc%head%gil%eval,0.0)
  !
  ! Update the Optimization counter if it is a known buffer
  call set_buffer_modified(argum)
end subroutine mask_apply
  !
subroutine sub_mask_apply(hin,hmask,din,error)
  use image_def
  use gbl_message
  use imager_interfaces, only : map_message
  !---------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- MASK internal routine: Apply a mask
  !!
  !---------------------------------------------------------------------
  type(gildas), intent(in) :: hin    !! Data cube header
  type(gildas), intent(in) :: hmask  !! Mask header
  real, intent(inout) :: din(hin%gil%dim(1),hin%gil%dim(2),hin%gil%dim(3))
  !! Data cube to be masked
  logical :: error                   !! Logical error flag
  !
  ! Local ---
  character(len=*), parameter :: rname='MASK'
  integer :: iplane, imask
  real(4) :: velocity
  real :: blank
  !
  ! Code ----
  blank = hin%gil%bval
  !
  !!Print *,'Mask rank ',hmask%gil%ndim,hmask%gil%dim(1:3)
  if (hmask%gil%dim(3).le.1) then
    !
    ! Apply Mask to all planes
    do iplane=1,hin%gil%dim(3)
      where (hmask%r3d(:,:,1).eq.0) din(:,:,iplane) = blank
    enddo
  else
    if (hin%gil%faxi.ne.3) then
      call map_message(seve%e,rname,'3rd axis is not Frequency | Velocity')
      error = .true.
      return
    endif
    !
    ! Find matching planes in Velocity
    do iplane=1,hin%gil%dim(3)
      velocity = (iplane-hin%gil%ref(3))*hin%gil%vres + hin%gil%voff
      imask = nint((velocity-hmask%gil%voff)/hmask%gil%vres + hmask%gil%ref(3))
      imask = min(max(1,imask),hmask%gil%dim(3)) ! Just  in case
      where (hmask%r3d(:,:,imask).eq.0) din(:,:,iplane) = blank
    enddo
  endif
  !
end subroutine sub_mask_apply
!
subroutine gdf_compare_2d(hone,htwo,equal)
  use image_def
  !---------------------------------------------------------------------
  ! @ private
  !!   IMAGER -- GDF: Check 2D consistency of data cubes
  !---------------------------------------------------------------------
  type(gildas), intent(in) :: hone  !! First header
  type(gildas), intent(in) :: htwo  !! Second header
  logical, intent(out) :: equal     !! Logical result
  !
  real(8) :: tolerance=0.001    ! Pixels...
  real(8) :: x0, y0
  integer :: i
  !
  ! Compare first 2 axes
  equal = .true.
  do i=1,2
    if (hone%gil%dim(i).ne.htwo%gil%dim(i)) then
      equal = .false.
      return
    else
      x0 = (0-hone%gil%ref(i))*hone%gil%inc(i) + hone%gil%val(i)
      y0 = (0-htwo%gil%ref(i))*htwo%gil%inc(i) + htwo%gil%val(i)
      if ( abs(x0-y0).gt.tolerance*abs(hone%gil%inc(i)) ) then
        equal = .false.
        return
      endif
    endif
  enddo
end subroutine gdf_compare_2d  
!
subroutine mask_threshold(line,error)
  use iso_c_binding
  use gkernel_interfaces
  use imager_interfaces, only : map_message, sub_mask_threshold, mask_init
  use clean_arrays
  use clean_default
  use clean_support
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !*
  !   IMAGER -- Support for command ADVANCED\MASK THRESHOLD
  !
  !   ADVANCED\MASK  THRESHOLD Value Unit [SMOOTH Smooth Length]  
  !                  [GUARG Guard] [REGIONS Nregions] [/FROM MaskData]
  !
  !  Automatic Mask builder by Thresholding from data in MaskData  
  !
  !  Value    Thresholding (in Unit) of the Clean image  
  !  Smooth   Thresholding (in Unit) after smoothing  
  !  Length   Smoothing length (in arcsec): default is Clean beam major axis  
  !  Guard    Guard band ignored at edges  
  !  Nregions Number of separate areas kept in mask.  
  !
  ! Select MaskData if specified, fall back to CLEAN or SKY depending on 
  !   last one available. Mask is a 3D data cube.
  !!
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: line  !! Command line
  logical, intent(inout) :: error       !! Logical error flag
  !
  ! Code ----
  call mask_init(line,'3D',error)
  if (error) then
    support_type = support_none
    return
  endif
  !
  call sub_mask_threshold(hmask_temp,mask_template,line,error)
  hmask%gil%eval = -1.0
end subroutine mask_threshold
!
subroutine mask_regions(line,error)
  use gkernel_interfaces
  use imager_interfaces, only : map_message, mask_prune
  use clean_arrays
  use clean_default
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !*
  !   IMAGER -- Support for command  ADVANCED\MASK REGIONS Nregions
  !
  ! Keep only the requested number of Regions
  !!
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: line  !! Command line
  logical, intent(inout) :: error       !! Logical error flag
  !
  integer :: nregions
  logical, parameter :: doflux=.false.
  !
  if (hmask%loca%size.eq.0) then
    call map_message(seve%e,'MASK','No mask defined')
    error = .true.
    return
  endif
  !
  call sic_i4(line,0,2,nregions,.false.,error)
  if (nregions.eq.0) return
  !
  call mask_prune(hmask,dmask,nregions,doflux,error)
  if (error) return
  hmask%gil%rmax = nregions
end subroutine mask_regions
!
subroutine sub_mask_threshold(head,name,line,error)
  use gkernel_interfaces
  use imager_interfaces, only : map_message, mask_clean, mask_prune
  use clean_default
  use clean_arrays
  use clean_support
  use gbl_message
  !--------------------------------------------------------------------
  ! @ private
  !*
  !   IMAGER -- Support for command ADVANCED\MASK THRESHOLD
  !
  !   ADVANCED\MASK  THRESHOLD Value Unit [SMOOTH Smooth Length]  
  !                  [GUARG Guard] [REGIONS Nregions] [/FROM MaskData]
  !
  !  Automatic Mask builder by Thresholding from data in MaskData  
  !
  !  Value    Thresholding (in Unit) of the Clean image  
  !  Smooth   Thresholding (in Unit) after smoothing  
  !  Length   Smoothing length (in arcsec): default is Clean beam major axis  
  !  Guard    Guard band ignored at edges  
  !  Nregions Number of separate areas kept in mask.  
  !
  ! Select MaskData if specified, fall back to CLEAN or SKY depending on 
  !   last one available. Mask is a 3D data cube.
  !!
  !---------------------------------------------------------------------
  type(gildas), intent(in) :: head        !! Header of data used for threshold
  character(len=*), intent(in) :: name    !! Data cube name
  character(len=*), intent(in) :: line    !! Command line
  logical, intent(inout) :: error         !! Logical error flag
  !
  ! Constants
  integer, parameter :: o_thre=0 ! In command line, not in option
  integer, parameter :: a_offs=1 ! But shifted by 1 argument
  integer, parameter :: code_pos=1
  integer, parameter :: code_neg=-1
  integer, parameter :: code_all=0
  logical, parameter :: doflux=.true.
  real(kind=8), parameter :: pi=3.14159265358979323846d0
  character(len=*), parameter :: rname='MASK'  
  integer, parameter :: mvoc=3
  character(len=8) :: vocab(mvoc)
  data vocab /'SMOOTH','GUARD','REGIONS'/
  !
  ! Local ---
  character(len=12) :: cunit
  character(len=8) :: string, lstring, key
  integer :: icode, ns
  character(len=64) :: chain
  real :: raw,smo,length,noise,margin,jyperk,lwave,unit
  integer :: ier, nregions, mregions, ikey, iarg, narg
  logical :: debug
  !
  ! Code ----
  narg = sic_narg(o_thre)
  if (narg.lt.3) then
    call map_message(seve%e,rname,'Invalid syntax, see HELP MASK THRESHOLD')
    error = .true.
    return
  endif
  !
  if (head%loca%size.eq.0) then
    call map_message(seve%e,rname,'No '//trim(name)//' image')
    error = .true.
    return
  endif
  raw = 5.0
  smo = 3.0
  length = 0
  margin = 0.18
  nregions = 0
  iarg = a_offs+1
  !
  ! First argument is the Threshold, coded in a strange way
  call sic_ch(line,o_thre,iarg,string,ier,.false.,error)
  if (string(1:1).eq.'+') then
    icode = code_pos
  else if (string(1:1).eq.'-') then
    icode = code_neg
  else
    icode = code_all
  endif
  call sic_r4(line,o_thre,iarg,raw,.false.,error)
  if (error) return
  iarg = iarg+1
  !
  ! Second argument is the Unit
  unit = 1.0
  call sic_ch(Line,o_thre,iarg,lstring,ier,.false.,error)
  string = lstring
  call sic_upper(string)
  select case (string)
  case ('%')
    raw = raw*head%gil%rmax*0.01
  case ('NOISE','SIGMA')
    noise = max(hdirty%gil%noise,head%gil%noise,head%gil%rms)
    ! !noise = max(head%gil%noise,head%gil%rms)
    ! !Print *,'Noise ',noise
    if (noise.le.0) then
      call map_message(seve%e,rname,'No noise estimate, use STATISTIC before')
      error = .true.
      return
    endif
    unit = noise
  case ('NATIVE','UNIT')
    unit = 1.0
  case default
    if (head%gil%majo.ne.0) then
      lwave = 2.99792458e8/head%gil%freq*1e-6
      jyperk = 2.0*1.38e3*pi*head%gil%majo*head%gil%mino/(4.*log(2.0)*lwave**2)
    else
      jyperk = 1
    endif
    !
    ns = len_trim(string)
    if (string(ns-1:ns).eq.'JY') then
      if (head%char%unit.eq."K") then
        unit = 1./jyperk
      endif
      ns = ns-2
    else if (string(ns:ns).eq.'K') then
      cunit = head%char%unit
      call sic_upper(cunit)
      if (cunit.eq."JY".or.cunit.eq."JY/BEAM") then
        unit = jyperk
      endif
      ns = ns-1
    else
      call map_message(seve%e,rname,'Invalid threshold unit, see HELP MASK THRESHOLD')
      error = .true.
      return
    endif
    ! Scale modifier
    if (ns.gt.0) then
      select case (string(1:ns))
      case ('MILLI')
        unit = 1E-3*unit
      case ('MICRO')
        unit = 1E-6*unit
      case ('M')
        if (lstring(1:ns).eq.'m') then
          unit = 1E-3*unit
        else
          unit = 1E6*unit
        endif
      case default
        call map_message(seve%e,rname,'Invalid threshold unit, see HELP MASK THRESHOLD')
        error = .true.
        return
      end select
    endif
    !
  end select
  iarg = iarg+1
  !
  !TEST! Print *,'NARG ',narg,' IARG ',iarg
  do while (iarg.lt.narg)
    call sic_ke(line,o_thre,iarg,string,ier,.false.,error)
    !! Print *,'STRING ',trim(string)
    call sic_ambigs (rname,string,key,ikey,vocab,mvoc,error)
    if (error) return
    select case (key)
    case ('GUARD')
      iarg = iarg+1
      call sic_r4(line,o_thre,iarg,margin,.false.,error)
      if (error) return
      if (margin.lt.0 .or. margin.gt.0.5) then
        call map_message(seve%e,rname,'Margin must be >0 and <0.5')
        error = .true.
        return
      endif
    case ('SMOOTH')
      iarg = iarg+1
      call sic_r4(line,o_thre,iarg,smo,.false.,error)
      iarg = iarg+1
      length = head%gil%majo
      if (iarg.le.narg) then
        call sic_ch(line,o_thre,iarg,string,ier,.false.,error)
        if (string.ne.'*') then
          call sic_r4(line,o_thre,iarg,length,.false.,error)
          if (error) then
            call map_message(seve%e,rname,'Invalid Length argument, expected * or Number of "')
            return
          endif
          if (length.lt.0 .or. length.gt.60.0) then
            call map_message(seve%e,rname,'Length must be >0 and < 60" (most likely...)' )
            error = .true.
            return
          endif
          length = length*pi/180./3600.
        endif
      endif
    case ('REGIONS') 
      iarg = iarg+1
      call sic_i4(line,o_thre,iarg,nregions,.false.,error)
    end select
    iarg = iarg+1
  enddo
  !
  debug = .false.
  call sic_get_logi('DEBUG_MASK',debug,error)
  if (debug) then
    print *,'RAW     ',raw, ' Unit ',unit
    print *,'SMOOTH  ',smo
    print *,'LENGTH  ',length*180*3600/pi
    print *,'MARGIN  ',margin
    print *,'REGIONS ',nregions
  endif
  error = .false.
  !
  !
  call sic_delvariable('MASK',.false.,error)
  if (allocated(dmask)) deallocate(dmask)    
  call gdf_copy_header(head,hmask,error)
  allocate(dmask(hmask%gil%dim(1),hmask%gil%dim(2),hmask%gil%dim(3)),   &
   &        stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'Mask memory allocation error')
    error = .true.
    return
  endif
  !
  call mask_clean(hmask,dmask,head%r3d,raw*unit,smo*unit,length,      &
    & margin,icode,error)
  if (error) return
  mregions = nregions
  call mask_prune(hmask,dmask,mregions,doflux,error,head%r3d)
  if (error) return
  if (nregions.ne.0) then
    write(chain,'(A,I0,A,I0)') 'Kept only ',nregions,' regions, out of ',mregions
  else
    write(chain,'(A,I0,A)') 'Found ',mregions,' regions'
    nregions = mregions
  endif
  call map_message(seve%i,rname,chain)
  !
  ! sic_mapgildas produces a Read-Only variable, so preset the
  ! content as 0/1 and the Min Max as appropriate for convenience.
  !   where(dmask.ne.0) dmask = 1.0 
  ! NO - keep the mask as is with Region numbers
  !
  ! Command MASK APPLY can use it, and in scripts,
  !   LET Masked Raw /where Mask.ne.0  
  ! will do the job as well
  hmask%gil%rmin = 0.0
  hmask%gil%rmax = nregions
  !
  ! Attempt to make it Writeable
  hmask%loca%read = .false.
  call sic_mapgildas('MASK',hmask,error,dmask)
  user_method%do_mask = .true.
  support_type = 1 ! First plane will be used by default 
  !
end subroutine sub_mask_threshold
!
subroutine mask_clean (head,mask,data,raw,smo,length,margin,icode,error) 
  !$ use omp_lib
  use clean_def
  use image_def
  use gbl_message
  use gkernel_interfaces
  use imager_interfaces, only : mulgau, map_message
  !---------------------------------------------------------------------
  ! @ private-mandatory
  !*
  ! IMAGER -- Support routine for MASK THRESHOLD 
  !
  !   Builds a Mask from a Threshold and Smoothing 
  !
  !   icode indicates whether the mask is from Positive, Negative
  !   or Both values compared to the Threshold.
  ! 
  !   The mask is the .OR. of the Raw and Smooth version of the image.
  !   Blanking are set to Zero.
  !---------------------------------------------------------------------
  type (gildas), intent(inout) :: head        !! Data header
  real, intent(out), target :: mask(:,:,:)    !! Mask cube
  real, intent(in) :: data (:,:,:)            !! Data cube
  real, intent(in) :: raw             !! Raw threshold
  real, intent(in) :: smo             !! Smooth threshold
  real, intent(in) :: length          !! Smoothing length
  real, intent(in) :: margin          !! Guard band
  integer, intent(in) :: icode        !! Code for threshold sign
  logical, intent(out) :: error       !! Logical error flag
  !
  ! Constants
  real(8), parameter :: pi=3.141592653589793d0
  character(len=*), parameter :: rname='MASK'
  integer, parameter :: code_pos=1
  integer, parameter :: code_neg=-1
  integer, parameter :: code_all=0
  !
  ! Local ---
  integer nx,ny,nc,ix,iy,ic,jx,jy,ndim,dim(2),ier,kc
  real xinc, yinc,fact
  real, allocatable :: wfft(:)
  real, allocatable :: stmp(:,:)
  complex, allocatable :: ft(:,:)
  character(len=80) :: chain
  real :: lsmooth
  !
  integer(kind=index_length) :: nxy
  !
  ! Code ----
  lsmooth = length/1.665 ! FWHM to Sigma, just an empirical factor
  ! that produces a rather natural result. 2 would be good also !...
  !
  nx = head%gil%dim(1)
  ny = head%gil%dim(2)
  nc = head%gil%dim(3)
  allocate (wfft(2*max(nx,ny)),ft(nx,ny),stmp(nx,ny),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'Memory allocation error in MASK_CLEAN')
    error = .true.
    return
  endif
  !
  xinc = head%gil%convert(3,1)
  yinc = head%gil%convert(3,2)
  !
  dim(1) = nx
  dim(2) = ny
  ndim = 2
  jy = margin*ny
  jx = margin*nx
  !
  write(chain,'(A,1PG10.2,1PG10.2,A,0PF8.2,A,F6.2)') 'Threshold',raw,smo, &
    & ',  Smoothing ',length*180.*3600./pi,'", guard band ',margin
  call map_message(seve%i,rname,chain)
  !
  if (length.ne.0) then
    write(chain,'(A,F10.1,A)') 'Smoothing by ',length*180*3600/pi,' arcsec'
    call map_message(seve%i,rname,chain)
  endif
  !
  mask = 0.0
  nxy = nx*ny
  !
  !$OMP PARALLEL if (nc.gt.1) DEFAULT(none)  &
  !$OMP & SHARED(head,mask,data, nx,ny,jx,jy,nc,nxy, length, smo, raw) &
  !$OMP & SHARED(icode, xinc, yinc, dim, ndim, lsmooth) &
  !$OMP & PRIVATE(ic, kc, stmp, ft, wfft, ix, iy, fact, ier)
  !
  !$OMP DO
  do ic=1,nc
    !
    ! Guard band of margin-th of the image size on each edge to
    ! avoid aliased sidelobes and "raw" thresholding
    stmp = 0.0
    if (head%gil%eval.ge.0.0) then
      do iy=jy+1,ny-jy
        do ix=jx+1,nx-jx
          if (abs(data(ix,iy,ic)-head%gil%bval).gt.head%gil%eval) then
            stmp(ix,iy) = data(ix,iy,ic)
          endif
        enddo
      enddo    
    else
      do iy=jy+1,ny-jy
        do ix=jx+1,nx-jx
          stmp(ix,iy) = data(ix,iy,ic)
        enddo
      enddo
    endif
    !
    ! a 2-D version may be implemented by using kc=1 instead of kc=ic
    kc = ic
    if (icode.eq.code_all) then 
      do iy=jy+1,ny-jy
        do ix=jx+1,nx-jx
          if (abs(stmp(ix,iy)).gt.raw) mask(ix,iy,kc) = mask(ix,iy,kc)+1.0
        enddo
      enddo
    else if (icode.eq.code_neg) then
      do iy=jy+1,ny-jy
        do ix=jx+1,nx-jx
          if (stmp(ix,iy).lt.-raw) mask(ix,iy,kc) = mask(ix,iy,kc)+1.0
        enddo
      enddo
    else
      do iy=jy+1,ny-jy
        do ix=jx+1,nx-jx
          if (stmp(ix,iy).gt.raw) mask(ix,iy,kc) = mask(ix,iy,kc)+1.0
        enddo
      enddo
    endif
    !
    if (length.ne.0) then
      !
      ! Smoothing of initial image
      ft(:,:) = cmplx(stmp,0.0)
      call fourt(ft,dim,ndim,-1,0,wfft)
      !
      fact = 1.0
      call mulgau(ft,nx,ny,   &
           &    lsmooth, lsmooth, 0.0,   &
           &    fact,xinc,yinc, -1)
      call fourt(ft,dim,ndim,1,1,wfft)
      !
      ! Extract Real part
      stmp(:,:) = abs(real(ft))
      if (icode.eq.code_all) then 
        stmp = abs(stmp)
      else if (icode.eq.code_neg) then
        stmp = -stmp
      endif
      !! fact = lsmooth**2*pi/(4.0*log(2.0))/abs(xinc*yinc)/(nx*ny) ! Flux Factor
      fact = 1.0/(nx*ny)      ! Brightness factor
      ! Correct for Beam Area for flux density normalisation
      fact = smo/fact
      do iy=jy+1,ny-jy
        do ix=jx+1,nx-jx
          if (stmp(ix,iy).gt.fact) mask(ix,iy,kc) = mask(ix,iy,kc)+1.0
        enddo
      enddo
    endif
    !
  enddo
  !$OMP END DO
  !$OMP END PARALLEL
  !
end subroutine mask_clean
!
subroutine mask_prune (head,mask,nregions,doflux,error,values) 
  use clean_def
  use image_def
  use gbl_message
  use gkernel_interfaces
  use imager_interfaces, only : mulgau, map_message, label_field
  !---------------------------------------------------------------------
  ! @ private-mandatory
  !*
  ! IMAGER -- Support routine for  
  !     MASK THRESHOLD Args... REGIONS Regions  
  ! and   
  !     MASK REGIONS Regions  
  !
  !   Regions are ordered by decreasing number of pixels, or if requested 
  ! (doflux = .true. and values present) by decreasing integrated flux.
  !!!
  !---------------------------------------------------------------------
  type (gildas), intent(inout) :: head        !! Data header
  real, intent(inout), target :: mask(:,:,:)  !! Mask to be pruned
  integer, intent(inout) :: nregions          !! Number of regions selected
  logical, intent(in) :: doflux               !! Order by flux
  logical, intent(out) :: error               !! Logical error flag
  real, intent(in), optional :: values(:,:,:) !! Intensity values
  !
  ! Local ---
  character(len=*), parameter :: rname='MASK'
  integer :: ic, nc, nx, ny, ier, nfields, mfields
  integer :: ir, ix, iy
  real, pointer :: tmp(:,:)
  real, allocatable :: stmp(:,:),rtmp(:,:)
  real, allocatable :: fluxes(:)
  integer, allocatable :: isort(:)
  !
  ! Code ---
  nc = head%gil%dim(3)    ! Number of "channels" of Mask
  nx = head%gil%dim(1)
  ny = head%gil%dim(2)
  if (doflux ) then
    if (present(values)) then
      if (size(values,1).ne.nx .or. size(values,2).ne.ny &
        & .or. size(values,3).ne.nc) then
        call map_message(seve%e,rname,'MASK and Data size mismatch')
        error = .true.
        return
      endif
    else
      call map_message(seve%e,rname,'Programming error: doflux set and no values argument')
      error = .true.
      return
    endif
  endif
  !
  ! Pruning if more than 1 region
  allocate(stmp(nx,ny),rtmp(nx,ny),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'Prune - Memory allocation error')
    error = .true.
    return
  endif
  !
  mfields = 0
  do ic=1,nc
    tmp => mask(:,:,ic)
    rtmp = mask(:,:,ic)   ! Can save this copy ...
    !
    ! Pruning small isolated regions
    where (rtmp.ne.0) rtmp = 1.0
    !
    ! The mask is now a 0/1 valued image
    ! We convert it to a 0 - N valued image,
    ! where the N is the number of separate regions
    ! Label fields and Sort them by size OR by flux
    !
    call label_field(rtmp,head%gil%dim(1),head%gil%dim(2), &
      & stmp,nfields,0.1,0.0,-1.0,error)
    mfields = max(mfields,nfields)
    !
    if (doflux.and.nfields.ne.0) then
      allocate(fluxes(nfields),isort(nfields))
      fluxes = 0.0
      do iy=1,ny
        do ix=1,nx
          if (stmp(ix,iy).ne.0) then
            ir = stmp(ix,iy)
            fluxes(ir) = fluxes(ir)-values(ix,iy,ic) 
          endif
        enddo
      enddo
      !
      ! Re-order the NFIELDS flux values
      do ir=1,nfields
        isort(ir) = ir
      enddo
      call gr4_trie(fluxes,isort,nfields,error)
      do iy=1,ny
        do ix=1,nx
          if (stmp(ix,iy).ne.0) then
            ir = stmp(ix,iy)
            stmp(ix,iy) = isort(ir)
          endif
        enddo
      enddo
      deallocate(fluxes,isort)
    endif
    tmp = stmp     ! Copy back 
    if (nregions.ne.0) then
      ! Prune excess regions
      where (tmp.gt.nregions) tmp = 0.
    endif
  enddo
  if (nregions.eq.0) nregions = mfields
end subroutine mask_prune
!
subroutine mask_setup(line,iopt,iarg,error)
  use iso_c_binding
  use clean_arrays
  use clean_types
  use clean_default
  use clean_support
  use gkernel_interfaces
  use gbl_message
  use imager_interfaces, only : map_message, sub_readhead
  !---------------------------------------------------------------------
  ! @ private
  !*
  !   IMAGER -- Support for command  
  !      MASK INIT [2D|3D] [/FROM Variable]
  !!
  !--------------------------------------------------------------------- 
  character(len=*), intent(in) :: line  !! Comand line
  integer, intent(in) :: iopt, iarg     !! Option and Argument numbers
  logical, intent(inout) :: error       !! Logical error flag
  !
  ! Constants
  character(len=*), parameter :: rname='MASK'
  integer, parameter :: o_from=1 ! /FROM Variable option
  !
  ! Local ---
  logical :: is_image
  logical :: rdonly
  integer :: n
  character(len=64) :: name
  type (c_ptr) :: cptr
  !
  ! Code ----
  error = .false.
  !
  is_image = .true.     ! Only on Images
  if (sic_present(iopt,iarg)) then
    call sic_ke(line,iopt,iarg,name,n,.true.,error)
    if (error) return    !
    mask_template = name
  else if (last_shown.eq.'CLEAN') then
    if (hclean%loca%size.eq.0) then
      call map_message(seve%e,rname,'no Clean image')
      error = .true.
      return
    endif
    mask_template = 'CLEAN'
  else if (last_shown.eq.'SKY') then
    if (hsky%loca%size.eq.0) then
      call map_message(seve%e,rname,'no SKY image')
      error = .true.
      return
    endif
    mask_template = 'SKY'
  else if (hsky%loca%size.ne.0) then
    mask_template = 'SKY'
  else if (hclean%loca%size.ne.0) then
    mask_template = 'CLEAN'
  else if (hdirty%loca%size.ne.0) then
    mask_template = 'DIRTY'
  else
    call map_message(seve%e,'MASK','No CLEAN, DIRTY or SKY available')
    error = .true.
    return
  endif
  !
  call sic_delvariable('DATAMASK',.false.,error)
  call gildas_null(hmask_temp)
  call sub_readhead('MASK',mask_template,hmask_temp,is_image,error,rdonly) !,fmt,type)
  if (error) return
  !
  call adtoad(hmask_temp%loca%addr,cptr,1)
  call c_f_pointer(cptr,hmask_temp%r3d,hmask_temp%gil%dim(1:3))
  call sic_def_char('DATAMASK',mask_template,.false.,error)  
  !
end subroutine mask_setup
!
subroutine mask_init(line,key,error)
  use iso_c_binding
  use clean_arrays
  use clean_types
  use clean_default
  use clean_support
  use gkernel_interfaces
  use gbl_message
  use imager_interfaces, only : map_message, mask_setup
  !---------------------------------------------------------------------
  ! @ private
  !*
  !   IMAGER -- Support for command  
  !   MASK INIT [2D|3D] [/FROM CubeVariable]
  !!
  !--------------------------------------------------------------------- 
  character(len=*), intent(in) :: line  !! Command line
  character(len=*), intent(in) :: key   !! Action key: 
  !!  ' ' reset, 2D or 3D initialize with specified rank
  logical, intent(inout) :: error       !! Logical error flag
  !
  ! Constants
  character(len=*), parameter :: rname='MASK'
  integer, parameter :: o_from=1 ! /FROM Variable option
  !
  ! Local ---
  integer :: ier
  !
  ! Code ----
  error = .false.
  !
  ! Free the current MASK if any
  save_data(code_save_mask) = .false.
  call sic_delvariable ('MASK',.false.,error)
  if (allocated(dmask)) deallocate(dmask,stat=ier)
  hmask%loca%size = 0
  call gildas_null(hmask)
  ! And do not try to use it...
  user_method%do_mask = .false.
  !
  if (key.eq.' ') return
  !
  if (key.ne.'2D'.and.key.ne.'3D') then
    call map_message(seve%e,rname,' INITIALIZE invalid argument '//trim(key))
    error = .true.
    return
  endif
  !
  call mask_setup(line,o_from,1,error)
  if (error) return
  !
  call gdf_copy_header(hmask_temp,hmask,error)
  if (key.eq.'2D') hmask%gil%dim(3) = 1
  allocate(dmask(hmask%gil%dim(1),hmask%gil%dim(2),hmask%gil%dim(3)),   &
   &        stat=ier)
  dmask = 0.0 ! By default, nothing is selected
  hmask%loca%size = hmask%gil%dim(1)*hmask%gil%dim(2)*hmask%gil%dim(3)
  !
  call sic_mapgildas ('MASK',hmask,error,dmask)
end subroutine mask_init
!
subroutine mask_present(error)
  use clean_arrays
  use gbl_message
  use imager_interfaces, only : map_message
  !---------------------------------------------------------------------
  ! @ private
  !   IMAGER
  ! Support for command MASK 
  !   Check MASK existence
  !---------------------------------------------------------------------
  logical, intent(inout) :: error
  !
  character(len=*), parameter :: rname='MASK'
  !
  if (hmask%loca%size.eq.0) then
    call map_message(seve%e,rname,'No Mask defined')
    error = .true.
    return
  endif  
end subroutine mask_present
!
subroutine mask_check(name,head,error)
  use clean_arrays
  use clean_types
  use clean_default
  use gbl_message
  use imager_interfaces, only : map_message
  !---------------------------------------------------------------------
  ! @ private
  !*
  !   IMAGER --  Support for command MASK 
  
  !   Check MASK existence and conformance.
  !!
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: name  !! Cube variable name
  type(gildas), intent(in) :: head      !! Cube header 
  logical, intent(inout) :: error       !! Logical error flag
  !
  character(len=*), parameter :: rname='MASK'
  !
  if (hmask%loca%size.eq.0) then
    call map_message(seve%e,rname,'No Mask defined, use MASK INIT first')
    error = .true.
    return
  endif  
  !
  if (any(hmask%gil%dim(1:2).ne.head%gil%dim(1:2))) then
    call map_message(seve%e,rname,'Mask and '//trim(name)//' sizes do not match')
    error = .true.
    return
  else if (hmask%gil%dim(3).ne.1) then
    ! Check matching velocity range would be better
    if (hmask%gil%dim(3).ne.head%gil%dim(3)) then
      call map_message(seve%w,rname,'Mask and '//trim(name)//' planes mismatch, proceed at own risk',seve%e)
    endif
  endif 
end subroutine mask_check
!
subroutine mask_to_label (error)
  use clean_arrays
  use clean_types
  use clean_default
  use gbl_message
  use imager_interfaces, only : map_message, sub_mask_to_label
  !---------------------------------------------------------------------
  ! @ private
  !*
  !   IMAGER -- Support for command MASK LABEL
  !
  ! Attribute a unique lable to each connex region of the MASK.
  !!
  !---------------------------------------------------------------------
  logical, intent(out) :: error  !! Logical error flag
  !
  ! Local ---
  integer :: nfields
  !
  ! Code ----
  if (hmask%loca%size.eq.0) then
    call map_message(seve%e,'MASK','No Mask defined')
    error = .true.
    return
  endif
  error = .false.
  !
  hmask%r3d => dmask
  call sub_mask_to_label (hmask,hmask%r3d(:,:,1),nfields,error)
  hmask%gil%rmax = nfields
end subroutine mask_to_label
!
subroutine mask_collapse (error)
  use clean_arrays
  use clean_types
  use clean_default
  use gbl_message
  use gkernel_interfaces
  use imager_interfaces, only : map_message, sub_mask_to_label
  !---------------------------------------------------------------------
  ! @ private
  !*
  !   IMAGER -- Support for command MASK COLLAPSE
  !
  !   Collapse a 3D mask into a 2D one by the .OR. of all planes.
  !!
  !---------------------------------------------------------------------
  logical, intent(out) :: error  !! Logical error flag
  !
  ! Local ---
  integer :: i, ier
  real, allocatable :: cmask(:,:)
  !
  ! Code ----
  if (hmask%loca%size.eq.0) then
    call map_message(seve%e,'MASK','No Mask defined')
    error = .true.
    return
  endif
  error = .false.
  !
  if (hmask%gil%dim(3).le.1) return
  !
  allocate(cmask(hmask%gil%dim(1),hmask%gil%dim(2)),stat=ier)
  cmask = 0.
  do i=1,hmask%gil%dim(3)
    cmask(:,:) = cmask(:,:) + dmask(:,:,i)
  enddo
  !
  call sic_delvariable('MASK',.false.,error)
  deallocate(dmask)
  allocate(dmask(hmask%gil%dim(1),hmask%gil%dim(2),1),stat=ier)
  !
  hmask%gil%dim(3) = 1
  dmask(:,:,1) = cmask(:,:)
  hmask%loca%size = hmask%gil%dim(1)*hmask%gil%dim(2)
  ! 
  hmask%r3d => dmask
  call cube_minmax('MASK',hmask,error)
  call sic_mapgildas('MASK',hmask,error,dmask)
end subroutine mask_collapse
!
subroutine sub_mask_to_label (hmask,fmask,nfields,error)
  use gkernel_types
  use gbl_message
  use imager_interfaces, only : map_message, label_field
  !---------------------------------------------------------------------
  ! @ private
  !*
  !   IMAGER -- Support for command MASK LABEL
  !
  ! Attribute a unique label to each connex region of a MASK.
  ! Automatically collapse to 2D if mask is 3D.
  !! 
  !---------------------------------------------------------------------
  type(gildas), intent(in) :: hmask         !! Mask structure
  real, intent(inout) :: fmask(:,:)         !! 2-D final mask
  integer, intent(out) :: nfields           !! Number of regions
  logical, intent(out) :: error             !! Error flag
  !
  integer :: ic,ier
  real :: threshold
  real, allocatable :: gmask(:,:)
  !
  threshold = 0.1
  allocate(gmask(hmask%gil%dim(1),hmask%gil%dim(2)),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,'MASK','Temporary Mask allocation error')
    error = .true.
    return
  endif
  if (hmask%gil%dim(3).gt.1) then
    call map_message(seve%i,'MASK','Collapsing Mask planes')
    do ic=1,hmask%gil%dim(3)
      gmask(:,:) = gmask(:,:)+hmask%r3d(:,:,ic)
    enddo
  else
    gmask(:,:) = hmask%r3d(:,:,1)
  endif
  where (gmask.ne.0) gmask = 1.0
  !
  ! The mask is now a 0/1 valued image
  ! We convert it to a 0 - N valued image,
  ! where the N is the number of isolated regions
  error = .false.
  !
  call label_field(gmask,hmask%gil%dim(1),hmask%gil%dim(2), &
    & fmask,nfields,threshold,0.0,-1.0,error)
  if (error) return
end subroutine sub_mask_to_label

subroutine uv_line2cont(line,error)
  use gkernel_interfaces
  use imager_interfaces, except_this=>uv_line2cont
  use clean_def
  use clean_default
  use clean_types
  use clean_arrays
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER  Support routine for command   
  !     UV_CONT [Step] [/RANGE Start End TYPE] /INDEX Alpha [Frequency]
  !
  ! Create a continuum UV table from a Line one
  !!
  !---------------------------------------------------------------------
  character(len=*), intent(inout) :: line  !! Command line
  logical, intent(out) :: error            !! Error flag
  !
  ! Constants
  character(len=*), parameter :: rname='UV_CONT'
  integer, parameter :: o_naver=0
  integer, parameter :: o_index=1
  integer, parameter :: o_range=2
  !
  ! Local ---
  real, pointer :: duv_previous(:,:), duv_next(:,:)
  integer :: nu, nv
  type (gildas) :: hcuv
  integer :: channels(3)
  !
  ! Code ----
  call map_message(seve%w,rname,'Deprecated Command. See UV_MAP /CONTINUUM and UV_FIT /CONTINUUM instead',seve%e)
  !
  ! Define the Header
  call sub_uvcont_header(line,error,hcuv,channels,o_naver,o_index,o_range)
  if (error) return
  !
  ! Define the Data
  nu = hcuv%gil%dim(1)
  nv = hcuv%gil%dim(2)
  nullify (duv_previous, duv_next)
  call uv_find_buffers (rname,nu,nv,duv_previous,duv_next,error)
  if (error) return
  !
  hcuv%r2d => duv_next
  huv_current%r2d => duv_previous
  call sub_uvcont_data(line,hcuv,huv_Current,channels,o_index,error)
  !
  call uv_clean_buffers (duv_previous, duv_next,error)
  if (error) return
  !
  ! Copy back to UV data set
  call gdf_copy_header(hcuv,huv_current,error)  
  !
  ! Indicate UV data has changed, and weight must be computed
  call uv_new_data(weight=.true.)
end subroutine uv_line2cont
!
subroutine sub_uvcont_header(line,error,hcuv,channels,o_step,o_index,o_range)
  use gkernel_interfaces
  use imager_interfaces, except_this=>sub_uvcont_header
  use clean_def
  use clean_default
  use clean_types
  use clean_arrays
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER  Support routine for commands  
  !   UV_CONT [Step] /INDEX Alpha [Frequency] [/RANGE Min Max Type]  
  ! and
  !   UV_MAP [Map Center Args] /CONT [Step] /INDEX Alpha [Frequency] [/RANGE Min Max Type]
  !
  ! Create a continuum UV table from the Line one
  !!
  !---------------------------------------------------------------------
  character(len=*), intent(inout) :: line  !! Command line
  logical, intent(out) :: error            !! Error flag
  type (gildas), intent(inout) :: hcuv     !! UV header
  integer, intent(out) :: channels(3)      !! Channels (first, last, step)
  integer, intent(in) :: o_step            !! Location of channel step
  integer, intent(in) :: o_index           !! Location of /INDEX option
  integer, intent(in) :: o_range           !! Location of /RANGE option
  !
  ! Constants
  character(len=*), parameter :: rname='UV_CONT'
  real(kind=8), parameter :: pi=3.14159265358979323846d0
  real(kind=8), parameter :: f_to_k = 2.d0*pi/299792458.d-6
  integer(kind=4), parameter :: msort=3
  character(len=12) :: types(msort)
  data types /'CHANNEL','VELOCITY','FREQUENCY'/
  !
  ! Local ---
  integer :: nchan
  character(len=80) :: mess
  real :: uvmax, uvmin
  integer :: msize
  type (uvmap_par) :: map
  !
  real(8) :: drange(2), freq
  character(len=12) :: csort
  integer :: isort, n
  integer :: nc(2)
  character(len=12) :: mysort
  !
  ! Code ----
  if (huv_current%loca%size.eq.0) then
    call map_message(seve%e,rname,'No UV data loaded')
    error = .true.
    return
  endif
  if (huv_current%gil%nstokes.gt.1) then
    call map_message(seve%e,rname,'Only single polarization data supported',seve%e)
    error = .true.
    return
  endif
  !
  channels = 0
  !
  msize = maxval(default_map%size)
  if (msize.eq.0) then
    map = default_map
    freq = gdf_uv_frequency(huv_current)
    call uvgmax (huv_current,duv,uvmax,uvmin)
    ! Now transform UVMAX in kiloWavelength (including 2 pi factor)
    uvmax = uvmax*freq*f_to_k
    uvmin = uvmin*freq*f_to_k
    error = .false.
    call map_parameters(rname,map,huv_current,freq,uvmax,uvmin,error)
    if (error) return
    msize = maxval(map%size)
  endif
  channels = 0
  call t_channel_sampling (rname,huv_current,channels(3),msize)
  !
  if (sic_present(o_step,1)) then
    call sic_i4(line,o_step,1,channels(3),.false.,error)
  else
    write(mess,'(A,I0,A)') 'Averaging by ',channels(3),' original channels'
    call map_message(seve%i,rname,mess)
  endif
  !
  if (sic_present(o_range,0)) then
    ! Get channel range from /RANGE option
    call sic_r8 (line,o_range,1,drange(1),.true.,error)
    if (error) return
    call sic_r8 (line,o_range,2,drange(2),.true.,error)
    if (error) return
    call sic_ke (line,o_range,3,csort,n,.true.,error)
    if (error) return
    error = .false.
    call sic_ambigs(rname,csort,mysort,isort,types,msort,error)
    if (error)  return    
    ! Define the input range
    call out_range(rname,mysort,drange,nc,huv_current,error)
    if (error) return
    channels(1:2) = nc
  else
    !
    nchan = huv_current%gil%nchan
    channels(1) = 1
    channels(2) = nchan
  endif
  !
  call uv_cont_header(rname,huv_current,hcuv,channels,expand_cont,error)
  !
end subroutine sub_uvcont_header
!
subroutine uv_cont_header(rname,hluv,hcuv,channels,mc,error)
  use gbl_message
  use gkernel_interfaces
  use image_def
  use imager_interfaces, only : map_message
  !-----------------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- Continuum handling routine
  !
  !   Derive the Continuum UV header from the Line UV header
  !   once the channel range has been specified
  !!
  !-----------------------------------------------------------------------------
  character(len=*), intent(in) :: rname !! Caller name
  type(gildas), intent(in) :: hluv      !! Line UV header
  type(gildas), intent(inout) :: hcuv   !! Continuum UV header
  integer, intent(in) :: channels(3)    !! Channel range
  integer, intent(out) :: mc            !! Expansion factor in number of visibilities
  logical, intent(out) :: error         !! Logical error flag
  !
  ! Local ---
  integer :: i, nchan
  character(len=80) :: mess
  logical :: add_if
  !
  ! Code ----
  nchan = channels(2)-channels(1)+1
  !
  ! Make sure things remain tractable for "random" Frequency axis...
  if (hluv%gil%nfreq.ne.0 .and. nchan.ne.1) then
    if (channels(3).ne.1) then
      !
      ! Ultimately, one may check here pseudo-linear axes...
      call map_message(seve%e,rname,'UV tables with random Frequency axis ' &
      & //' can only be converted with channel step = 1',seve%e)
      error = .true.
      return
    endif
  endif
  !
  error = .false.
  call gildas_null(hcuv, type = 'UVT')
  call gdf_copy_header(hluv,hcuv,error)
  !
  mc = nchan/channels(3)
  if (mc*channels(3).ne.nchan) mc = mc+1
  write(mess,'(A,I0,A)') 'Generating visibilities for ',mc,' frequencies' 
  call map_message(seve%i,rname,mess)
  !
  ! Add the IF id if not already present
  hcuv%gil%dim(2) = hluv%gil%dim(2)*mc
  hcuv%gil%dim(1) = 10+hluv%gil%ntrail
  if (mc.eq.1) then
    add_if = .false.
  else if ( (hluv%gil%column_pointer(code_uvt_if).gt.0).and. &
    & (hluv%gil%column_pointer(code_uvt_if).le.hluv%gil%dim(1)) ) then
    add_if = .false.
  else
    add_if = .true.
    hcuv%gil%dim(1) = hcuv%gil%dim(1)+1
  endif
  hcuv%gil%nchan = 1
  hcuv%gil%nvisi = hcuv%gil%dim(2)
  hcuv%gil%inc(1) = hluv%gil%inc(1)*mc
  !
  ! The effective bandwidth does not account for blanked channels
  ! in the range
  hcuv%gil%fres = (channels(2)-channels(1)+1)*hcuv%gil%fres
  hcuv%gil%vres = (channels(2)-channels(1)+1)*hcuv%gil%vres
  !
  hcuv%gil%nfreq = 0 ! Reset this
  !
  ! Shift trailing columns to handle Mosaicing
  hcuv%gil%lcol = 10
  do i=1,code_uvt_last
    if (hluv%gil%column_pointer(i).gt.hluv%gil%lcol) then
      hcuv%gil%column_pointer(i) = hluv%gil%column_pointer(i)-hluv%gil%lcol+hcuv%gil%lcol
    endif
  enddo
  if (add_if) then
    hcuv%gil%column_pointer(code_uvt_if) = hcuv%gil%dim(1)
    hcuv%gil%column_size(code_uvt_if) = 1
    hcuv%gil%ntrail = hcuv%gil%ntrail + 1
  endif
  !
  error = .false.
  call gdf_setuv(hcuv,error) ! Test
end subroutine uv_cont_header
!
subroutine sub_uvcont_data(line,hcuv,hiuv,channels,o_index,error)
  use image_def
  use gkernel_interfaces
  use imager_interfaces, except_this=>sub_uvcont_data
  !---------------------------------------------------------------------
  ! @ private-mandatory
  !*
  !   IMAGER -- Support routine to UV_MAP /CONTINUUM, UV_FIT /CONTINUUM
  ! UV_CONTINUUM
  !
  !     Transform the Line UV data into a Continuum UV data
  !!
  !---------------------------------------------------------------------  
  character(len=*), intent(in) :: line  !! Command line
  type(gildas), intent(inout) :: hcuv   !! UV Continuum header
  type(gildas), intent(inout) :: hiuv   !! UV Line header
  integer, intent(in) :: channels(3)    !! Selected channels
  integer, intent(in) :: o_index        !! Spectral index option
  logical, intent(inout) :: error       !! Logical error flag
  !
  ! Local ---
  real :: alpha
  real(8) :: ofreq
  integer :: uvcode=1
  !
  ! Code ----
  if (sic_present(o_index,0)) then
    call sic_r4(line,o_index,1,alpha,.true.,error)
    if (error) return
    ofreq = 0.D0
    call sic_r8(line,o_index,2,ofreq,.false.,error)
    if (error) return
    call t_continuum(hiuv,hcuv,channels,uvcode,error,alpha,ofreq)
  else
    call t_continuum(hiuv,hcuv,channels,uvcode,error)
  endif
  !
end subroutine sub_uvcont_data
!
subroutine t_continuum(hluv,hcuv,channels,uvcode,error,spindex,ofreq)
  use gkernel_interfaces
  use gildas_def
  use image_def
  use uvmap_def
  use gbl_message
  use imager_interfaces, only : map_message
  !$ use omp_lib
  !---------------------------------------------------------------------
  ! @ public-mandatory
  !*
  ! IMAGER
  !   Support routine for UV_CONTINUUM 
  !
  !   Create a continuum UV table from a Line one
  !---------------------------------------------------------------------
  !
  type (gildas), intent(in), target :: hluv       !! Line UV header
  type (gildas), intent(inout) :: hcuv    !! Continuum UV header
  integer, intent(in) :: channels(3)      !! Channel selection
  integer, intent(in) :: uvcode           !! Type of UV data
  logical, intent(out) :: error           !! Logical error flag
  real, intent(in), optional :: spindex   !! Spectral index
  real(8), intent(in), optional :: ofreq  !! Reference Frequency
  !
  ! Constants
  character(len=*), parameter :: rname='UV_CONT'
  !
  ! Local ---
  character(len=80) :: mess
  real(8) :: freq,fval,scale_uv,scale_flux,scale_w
  real(8) :: uv_smin,uv_smax
  real, allocatable :: are(:), aim(:), awe(:), adw(:)
  real :: re, im, we, dw, alpha
  integer :: ifi,ila,nv,ic,jc,kc,ier
  integer :: nt,ft
  integer :: if_add, kif ! Pointer to IF column, and IF pointer
  integer(kind=index_length) :: iv,ov
  integer :: othread, nthread, ov_num, env
  real(8), allocatable :: uv_scale(:)
  real(8), parameter :: clight_kms = 299792.458d0   ! [km/s] Light velocity
  integer, pointer :: chflag(:)        !! Channel Flags
  !
  ! Code ----
  error = .false.
  !
  ! Define number of Visibilities and Channels...
  nv = hluv%gil%nvisi
  nt = hluv%gil%ntrail
  ft = hluv%gil%lcol+1
  if ( (hluv%gil%column_pointer(code_uvt_if).ge.ft) .and. &
    & (hluv%gil%column_pointer(code_uvt_if).le.hluv%gil%dim(1)) ) then
    if_add = 0
  else
    if_add = hcuv%gil%column_pointer(code_uvt_if)
  endif
  !
  ov_num =  (channels(2)-channels(1))/channels(3)+1
  !
  allocate(uv_scale(channels(2)),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'Memory allocation error')
    error = .true.
    return
  endif
  !
  ! The problem is to define the effective "mean" frequency of the observation.  
  !
  !  fval = hluv%gil%val(hluv%gil%faxi)    ! This is not correct... 
  ! For linear sampling this is
  !  fval = fval + ((channels(1)+channels(2))*0.5d0-hluv%gil%ref(hluv%gil%faxi)) * hluv%gil%inc(hluv%gil%faxi)  
  ! or more precisely
  !  fval = gdf_uv_frequency(hluv, dble (channels(1)+channels(2))/2.d0 )
  !
  ! In general, including irregular sampling
  fval = 0d0
  do ic=channels(1),channels(2)
    fval = fval+gdf_uv_frequency(hluv, dble (ic))
  enddo
  fval = fval/dble(channels(2)-channels(1)+1)
  if (present(spindex)) then
    alpha = spindex    
    if (ofreq.ne.0D0) then
      if (abs(fval-ofreq)/fval.gt.0.3) then
        write (mess,'(A,F10.0,A)') 'Specified frequency is too far from mean frequency ',fval,' MHz'
        call map_message(seve%e,rname,mess,seve%e)
        error = .true.
        return
      endif
      fval = ofreq
    endif
  else
    alpha = 0.
  endif
  !
  ! All these assume similar weights for all channels
  !
  uv_smin = 1D36
  uv_smax = 0.
  do ic=channels(1),channels(2),channels(3)
    freq = gdf_uv_frequency(hluv, dble (2*ic+channels(3)-1)/2.d0 )
    !
    ! The angular scale goes as Lambda/B, i.e. 1/(B nu)
    ! so to preserve a constant angular scale, the "apparent"
    ! B must scale as 1/nu  Bnew = Bold * Fold /Fnew
    !
    ! so
    uv_scale(ic) = freq/fval ! This is the right formula...
    scale_uv = uv_scale(ic)
    uv_smin = min(scale_uv,uv_smin)
    uv_smax = max(scale_uv,uv_smax)
    scale_flux = scale_uv**(-alpha)
    scale_w = scale_uv**(2*alpha)
    ! if (alpha.ne.0) Print *,'Scale UV ',ic, (2*ic+channels(3)-1.0)/2.0, scale_uv, fval, freq, scale_flux, scale_w
  enddo
  !  
  chflag => hluv%img%flags
  if (alpha.ne.0.) then
    !
    ! Spectral index code
    if (uvcode.eq.code_uvt) then  ! UVT order
      !
      !$OMP PARALLEL DEFAULT(none) &
      !$OMP   & SHARED(nv, ov_num, uv_scale, hluv, hcuv, channels, if_add) &
      !$OMP   & SHARED(chflag, alpha, nt, ft) &
      !$OMP   & PRIVATE(iv,ov,fval,ic,freq,re,im,we,kc,jc,dw,kif) &
      !$OMP   & PRIVATE(scale_uv,scale_flux,scale_w)
      !
      !$OMP DO
      do iv=1,nv
        ov = (iv-1)*ov_num+1
        !
        ! Fill in, channel after channel
        kif = 0
        do ic=channels(1),channels(2),channels(3)
          scale_uv = uv_scale(ic)
          scale_flux = scale_uv**(-alpha)
          scale_w = scale_uv**(2*alpha)
          !
          hcuv%r2d(1:3,ov) = hluv%r2d(1:3,iv)*scale_uv
          hcuv%r2d(4:7,ov) = hluv%r2d(4:7,iv)
          !
          ! Compact the channels first
          if (channels(3).gt.1) then
            re = 0
            im = 0
            we = 0
            kc = 5+3*ic
            do jc = ic,min(ic+channels(3)-1,channels(2))
              if (chflag(jc).eq.1) then
                ! Here we use the Channel mask defined by UV_FILTER in addition
                ! to any previous flag.   UV_FILTER /RESET would then work in all cases
                dw = max(0.,hluv%r2d(kc+2,iv))
                !
                re = re + hluv%r2d(kc,iv)*dw
                kc = kc+1
                im = im + hluv%r2d(kc,iv)*dw
                we = we+dw
                kc = kc+2
              else
                kc = kc+3   ! Skip channel
              endif
            enddo
            if (we.ne.0.0) then
              re = re/we
              im = im/we
            end if
            hcuv%r2d(8,ov) = re*scale_flux
            hcuv%r2d(9,ov) = im*scale_flux
            hcuv%r2d(10,ov) = we*scale_w
          else
            if (chflag(ic).eq.1) then
              ! Here we use the Channel mask defined by UV_FILTER in addition
              ! to any previous flag.   UV_FILTER /RESET would then work in all cases
              hcuv%r2d(8:9,ov)  = hluv%r2d(5+3*ic:6+3*ic,iv)*scale_flux
              hcuv%r2d(10,ov)  = hluv%r2d(7+3*ic,iv)*scale_w
            else
              hcuv%r2d(8:10,ov) = 0.0
            endif
          endif
          if (nt.gt.0) then
            hcuv%r2d(11:11+nt-1,ov) = hluv%r2d(ft:ft+nt-1,iv)
          endif
          if (if_add.ne.0) then
            kif = kif+1
            hcuv%r2d(if_add,ov) = kif
          endif
          ov = ov+1
        enddo
        if (ov.ne.iv*ov_num+1) print *,'Programming error ',iv,ov,ov_num
      enddo
      !$OMP END DO
      !$OMP END PARALLEL
      !
    else if (uvcode.eq.code_tuv) then ! TUV order
      !
      Print *,'TUV order '
      if (channels(3).gt.1) then
        env = nv  ! Work arrays per visibility
      else
        env = 1   ! Dummies
      endif
      allocate (are(env),aim(env),awe(env),adw(env),stat=ier)
      if (ier.ne.0) then
        call map_message(seve%e,rname,'Channels allocation error')
        error = .true.
        return
      endif
      !
      ! Fill in, channel after channel
      othread = 1
      nthread = 1
      !$ othread = omp_get_max_threads()
      !$ nthread = min(othread,ov_num)
      !$ call omp_set_num_threads(nthread)
      !
      !$OMP PARALLEL DEFAULT(none) &
      !$OMP   & SHARED(nv,uv_scale,hluv,hcuv,channels,alpha,nt,ft,chflag,if_add) &
      !$OMP   & PRIVATE(ic,ifi,ila,freq) &
      !$OMP   & PRIVATE(are,aim,awe,jc,adw,kif) &
      !$OMP   & PRIVATE(scale_uv,scale_flux,scale_w)
      !
      !$OMP DO
      do ic=channels(1),channels(2),channels(3)
        ! Block counter
        kif = (ic-channels(1)+channels(3)-1)/channels(3) + 1
        ifi = (ic-1)*nv+1
        ila = ifi+nv-1
        scale_uv = uv_scale(ic)
        scale_flux = scale_uv**(-alpha)
        scale_w = scale_uv**(2*alpha)
        !
        hcuv%r2d(ifi:ila,1:3) = hluv%r2d(1:nv,1:3)*scale_uv
        hcuv%r2d(ifi:ila,4:7) = hluv%r2d(1:nv,4:7)
        !
        ! Compact the channels first
        if (channels(3).gt.1) then
          are = 0
          aim = 0
          awe = 0
          do jc = ic,min(ic+channels(3)-1,channels(2))
            if (chflag(jc).eq.1) then
              ! Here we use the Channel mask defined by UV_FILTER in addition
              ! to any previous flag.   UV_FILTER /RESET would then work in all cases
              adw(:) = max(0.,hluv%r2d(1:nv,7+3*jc))
              are(:) = are + hluv%r2d(1:nv,5+3*jc)*adw
              aim(:) = aim + hluv%r2d(1:nv,6+3*jc)*adw
              awe(:) = awe+adw
            endif
          enddo
          where (awe.ne.0.)
            are(:) = are/awe
            aim(:) = aim/awe
          end where
          hcuv%r2d(ifi:ila,8) = are*scale_flux
          hcuv%r2d(ifi:ila,9) = aim*scale_flux
          hcuv%r2d(ifi:ila,10) = awe*scale_w
        else
          if (chflag(ic).eq.1) then
            hcuv%r2d(ifi:ila,8:9) = hluv%r2d(1:nv,5+3*ic:6+3*ic)*scale_flux
            ! Here we use the Channel mask defined by UV_FILTER in addition
            ! to any previous flag.   UV_FILTER /RESET would then work in all cases
            hcuv%r2d(ifi:ila,10) = hluv%r2d(1:nv,7+3*ic)*scale_w
          else
            hcuv%r2d(ifi:ila,8:10) = 0.
          endif
        endif
        if (nt.gt.0) then
          hcuv%r2d(ifi:ila,11:11+nt-1) = hluv%r2d(1:nv,ft:ft+nt-1)
        endif
        if (if_add.ne.0) then
          hcuv%r2d(ifi:ila,if_add) = kif
        endif
      enddo
      !$OMP END DO
      !$OMP END PARALLEL
      !$ call omp_set_num_threads(othread)
      deallocate (are,aim,awe,stat=ier)
    endif
    !
  else
    ! Simple code with no spectral index
    if (uvcode.eq.code_uvt) then  ! UVT order
      !
      !$OMP PARALLEL DEFAULT(none) &
      !$OMP   & SHARED(nv, ov_num, uv_scale, hluv, hcuv, channels, nt, ft, chflag, if_add) &
      !$OMP   & PRIVATE(iv,ov,fval,ic,freq,scale_uv,re,im,we,kc,jc,dw, kif)
      !
      !$OMP DO
      do iv=1,nv
        ov = (iv-1)*ov_num+1
        !
        ! Fill in, channel after channel
        kif = 0
        do ic=channels(1),channels(2),channels(3)
          scale_uv = uv_scale(ic)
          !
          hcuv%r2d(1:3,ov) = hluv%r2d(1:3,iv)*scale_uv
          hcuv%r2d(4:7,ov) = hluv%r2d(4:7,iv)
          !
          ! Compact the channels first
          if (channels(3).gt.1) then
            re = 0
            im = 0
            we = 0
            kc = 5+3*ic
            do jc = ic,min(ic+channels(3)-1,channels(2))
              if (chflag(jc).eq.1) then
                ! Here we use the Channel mask defined by UV_FILTER in addition
                ! to any previous flag.   UV_FILTER /RESET would then work in all cases
                dw = max(0.,hluv%r2d(kc+2,iv))
                re = re + hluv%r2d(kc,iv)*dw
                kc = kc+1
                im = im + hluv%r2d(kc,iv)*dw
                we = we+dw
                kc = kc+2
              else
                kc = kc+3
              endif
            enddo
            if (we.ne.0.0) then
              re = re/we
              im = im/we
            end if
            hcuv%r2d(8,ov) = re
            hcuv%r2d(9,ov) = im
            hcuv%r2d(10,ov) = we
          else
            if (chflag(ic).eq.1) then
              ! Here we use the Channel mask defined by UV_FILTER in addition
              ! to any previous flag.   UV_FILTER /RESET would then work in all cases
              hcuv%r2d(8:10,ov)  = hluv%r2d(5+3*ic:7+3*ic,iv)
            else
              hcuv%r2d(8:10,ov)  = 0.
            endif            
          endif
          if (nt.gt.0) then
            hcuv%r2d(11:11+nt-1,ov) = hluv%r2d(ft:ft+nt-1,iv)
          endif
          if (if_add.ne.0) then
            kif = kif+1
            hcuv%r2d(if_add,ov) = kif
          endif
          ov = ov+1
        enddo
        if (ov.ne.iv*ov_num+1) print *,'Programming error ',iv,ov,ov_num
      enddo
      !$OMP END DO
      !$OMP END PARALLEL
      !
    else if (uvcode.eq.code_tuv) then ! TUV order
      Print *,'TUV order '
      if (channels(3).gt.1) then
        env = nv
      else 
        env = 1
      endif
      allocate (are(env),aim(env),awe(env),adw(env),stat=ier)
      if (ier.ne.0) then
        call map_message(seve%e,rname,'Channels allocation error')
        error = .true.
        return
      endif
      !
      ! Fill in, channel after channel
      othread = 1
      nthread = 1
      !$ othread = omp_get_max_threads()
      !$ nthread = min(othread,ov_num)
      !$ call omp_set_num_threads(nthread)
      !
      !$OMP PARALLEL DEFAULT(none) &
      !$OMP   & SHARED(nv,uv_scale,hluv,hcuv,channels,nt,ft,chflag,if_add) &
      !$OMP   & PRIVATE(ic,ifi,ila,freq,scale_uv) &
      !$OMP   & PRIVATE(are,aim,awe,jc,adw,kif)
      !
      !$OMP DO
      do ic=channels(1),channels(2),channels(3)
        ! Block counter
        kif = (ic-channels(1)+channels(3)-1)/channels(3) + 1
        !
        ifi = (ic-1)*nv+1
        ila = ifi+nv-1
        scale_uv = uv_scale(ic)
        !
        hcuv%r2d(ifi:ila,1:3) = hluv%r2d(1:nv,1:3)*scale_uv
        hcuv%r2d(ifi:ila,4:7) = hluv%r2d(1:nv,4:7)
        !
        ! Compact the channels first
        if (channels(3).gt.1) then
          are = 0
          aim = 0
          awe = 0
          do jc = ic,min(ic+channels(3)-1,channels(2))
            if (chflag(jc).eq.1) then
              ! Here we use the Channel mask defined by UV_FILTER in addition
              ! to any previous flag.   UV_FILTER /RESET would then work in all cases
              adw(:) = max(0.,hluv%r2d(1:nv,7+3*jc))
              are(:) = are + hluv%r2d(1:nv,5+3*jc)*adw
              aim(:) = aim + hluv%r2d(1:nv,6+3*jc)*adw
              awe(:) = awe+adw
            endif
          enddo
          where (awe.ne.0.)
            are(:) = are/awe
            aim(:) = aim/awe
          end where
          hcuv%r2d(ifi:ila,8) = are
          hcuv%r2d(ifi:ila,9) = aim
          hcuv%r2d(ifi:ila,10) = awe
        else
          if (chflag(ic).eq.1) then
            ! Here we use the Channel mask defined by UV_FILTER in addition
            ! to any previous flag.   UV_FILTER /RESET would then work in all cases
            hcuv%r2d(ifi:ila,8:10) = hluv%r2d(1:nv,5+3*ic:7+3*ic)
          else
            hcuv%r2d(ifi:ila,8:10) = 0.
          endif
        endif
        if (nt.gt.0) then
          hcuv%r2d(ifi:ila,11:11+nt-1) = hluv%r2d(1:nv,ft:ft+nt-1)
        endif
        if (if_add.ne.0) then
          hcuv%r2d(ifi:ila,if_add) = kif
        endif
      enddo
      !$OMP END DO
      !$OMP END PARALLEL
      !$ call omp_set_num_threads(othread)
      deallocate (are,aim,awe,stat=ier)
    endif
    !
  endif
  !
  ! FVAL should be the new Rest Frequency
  fval = fval / (1.d0 + hcuv%gil%dopp - hcuv%gil%voff/clight_kms)
  call gdf_modify(hcuv,hcuv%gil%voff,fval,error=error)
  hcuv%gil%ref(1) = 1.D0 
  !
  ! Reset Baseline lengths
  hcuv%gil%basemin = hluv%gil%basemin*uv_smin
  hcuv%gil%basemax = hluv%gil%basemax*uv_smax
  !
  ! Update number of visibilities
  hcuv%gil%nvisi = nv*ov_num
  hcuv%img%flags = 1
end subroutine t_continuum
!
subroutine t_channel_sampling(rname,huvl,nident,msize)
  use image_def
  use clean_default
  use gbl_message
  use imager_interfaces, only : map_message
  !---------------------------------------------------------------------
  ! @ public-mandatory
  !*
  ! IMAGER -- Support routine for continuum data
  !
  !   Check how many channels can share the same beam with a user
  !   specified accuracy
  !*
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: rname      !! Caller name
  type(gildas), intent(in) :: huvl            !! UV data header
  integer, intent(out) :: nident             !! returned step
  integer, intent(in) :: msize               !! Current map_size
  !
  ! Local ---
  real :: df, dc, r
  integer :: q
  character(len=80) :: chain
  !
  ! Code ----
  !
  ! Allow Cell_Precis (default 10 %) pixel difference at map edge
  !
  ! Relative Delta Frequency per channel is
  df = abs(huvl%gil%fres/huvl%gil%freq)
  !
  ! so scale error at map edge is, in pixel units
  dc = df * msize / 2
  !
  ! so allowed number of channels with same beam is
  nident = max(nint(default_map%precis/dc),1)
  nident = min(nident,huvl%gil%nchan)
  !
  write(chain,'(A,I6,A,F10.1)') 'Maximum number of channels '// &
    & 'for same beam ',nident,' Bandwidth ',abs(nident*huvl%gil%fres)
  call map_message(seve%i,rname,chain)
  !
  ! With random Frequency axis, use only 1 channel
  if (huvl%gil%nfreq.gt.1) then
    nident = 1
    return
  endif
  !
  ! Equalize the number of averaged channels to get channels of similar widths. 
  r = real(huvl%gil%nchan)/real(nident)
  if (r.lt.10.0) then
    q = int(r)
    if (real(q).ne.r) q = q+1
    nident = int((huvl%gil%nchan+q-1.)/real(q))
  endif
  !  
end subroutine t_channel_sampling
!

subroutine uv_map_mosaic(line,comm,error)
  use clean_arrays
  use clean_default
  use gbl_message
  use gkernel_interfaces
  use imager_interfaces, except_this => uv_map_mosaic
  !---------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- Support for commands
  ! UV_MAP or UV_RESTORE /FIELDS /RANGE /TRUNCATE  /CONTINUUM /INDEX  
  !   or  
  ! UV_SELF /RANGE /RESTORE
  !!
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: comm     !! Caller name
  character(len=*), intent(inout) :: line  !! Command line
  logical, intent(inout) :: error          !! Logical error flag
  !
  ! Constants
  real(kind=8), parameter :: pi=3.14159265358979323846d0
  real(kind=4), parameter :: sec_to_rad=pi/3600.0/180.0
  character(len=1), parameter :: question_mark='?'
  ! ' UV_MAP', '/TRUNCATE',  '/FIELDS', '/RANGE', '/CONTINUUM', '/INDEX'
  integer, parameter :: o_trunc=1
  integer, parameter :: o_field=2
  integer, parameter :: o_range=3
  integer, parameter :: o_cont=4
  integer, parameter :: o_index=5
  ! ' UV_SELF', '/RANGE', '/RESTORE'
  integer, parameter :: opt_rang=1  ! /RANGE Option for UV_SELF
  integer, parameter :: opt_rest=2  ! /RESTORE Option for UV_SELF
  ! Memories ...
  logical, save :: use_cont=.false.
  !
  ! Local ---
  type(imaging_mode) :: tmp_mode
  logical :: do_cct
  integer :: ier
  character(len=2) :: code, new_code
  type(gildas) :: huv_local
  logical :: err, goon
  character(len=80) :: chain, string
  integer :: debug
  !
  ! Code ----
  code = ' '
  new_code = ' '
  call imager_tree('UV_MAP_MOSAIC',.false.)
  debug = 0
  call sic_get_inte('DEBUG_UVMAP',debug,error)
  error = .false.
  !
  ! Check command line syntax
  call map_query (line,comm,themap,goon,error) 
  if ((.not.goon).or.error) return
  !
  err = .false.
  if (comm.eq.'UV_SELF') then
    ! Self Calibration image !
    if (huv_current%gil%column_pointer(code_uvt_if).ne.0) then
      call map_message(seve%e,comm, &
      & 'This UV table (probably a result of UV_CONTINUUM) is not suited for self-calibration')
      error = .true.
      return
    endif
    call map_message(seve%w,'UV_SELF','not fully tested for Mosaics')
    call uv_self_mosaic(line,comm,error)
    return
  endif
  !
  ! Normal Mosaic imaging: UV_MAP or UV_RESTORE, Cube or /CONTINUUM mode
  string = defmap_center
  !
  ! Select current data set or possibly its Continuum sibbling 
  do_cct = comm.eq.'UV_RESTORE'
  ! In a UV_RESTORE command, USE_CONT is remembered from last UV_MAP command
  ! In a UV_MAP command, USE_CONT is defined by the /CONT option
  if (.not.do_cct) use_cont = sic_present(o_cont,0)
  !
  if (comm.eq.'UV_MAP') then
    ! UV_MAP only
    if (huv_current%gil%column_pointer(code_uvt_xoff).ne.0) then
      call map_message(seve%i,'UV_MOSAIC','UV data is a Pointing Mosaic',seve%w)
    else if (huv_current%gil%column_pointer(code_uvt_loff).ne.0) then
      call map_message(seve%i,'UV_MOSAIC','UV data is a Phase Mosaic',seve%w)
    else if (huv_current%gil%column_pointer(code_uvt_id).ne.0) then
      call map_message(seve%i,'UV_MOSAIC','UV data is a Mosaic with field ID',seve%w)
    else
      call map_message(seve%w,'UV_MOSAIC','UV data is a Mosaic of unknown type',seve%e)
    endif
  endif
  !
  if (use_cont) then
    !
    ! Select Continuum data set (UV_MAP /CONT or UV_RESTORE after a UV_MAP /CONT)
    if (do_cct) then
      call print_imaging(comm,' -- DO_CCT Current ',huv_current%img) 
      !
      if (.not.associated(huv_cont%r2d,duvc)) then
        call map_message(seve%w,comm,'HUV_Cont Pointer was incorrectly associated',seve%e)
        huv_cont%r2d => duvc
      endif
      tmp_mode = huv_current%img ! Save the initial imaging mode
    else
      call print_imaging(comm,' -- UV_MAP Current ',huv_current%img) 
      call switch_uv_cont(line,comm,do_cct,error)
      if (error) return
      tmp_mode = huv_cont%img ! Save the initial imaging mode
    endif
    !
    ! Perform the imaging
    if (do_cct) then
      call print_imaging(comm,' -- DO_CCT Cont ',huv_cont%img) 
      defmap_center = ' '   ! The Continuum UV data has already been shifted
    else
      call print_imaging(comm,' -- UV_MAP Current ',huv_current%img)     
    endif
    if (do_cct) then
      call mosaic_restore(line,huv_cont,error)     ! Image
      call print_imaging(comm,'-- DO_CCT Restore ',huv_cont%img) 
    else
      call mosaic_uvmap('UV_MOSAIC',line,huv_cont,error)     ! Image Continuum one...
      call print_imaging(comm,'UV_MAP Continuum ',huv_cont%img) 
    endif
    defmap_center = string 
    if (error) return
    !
    if (do_cct) then    ! Use DSKY instead of DCLEAN ?...
      ! There can be a size mis-match here ...
      if (any(hcont%gil%dim(1:2).ne.hsky%gil%dim(1:2))) then
        write(chain,'(A,I0,A,I0,A)') 'Re-sizing continuum image to [', &
          &   hsky%gil%dim(1),',',hsky%gil%dim(2),']'
        call map_message(seve%w,comm,chain)
        deallocate(dcont,stat=ier)
        allocate(dcont(hsky%gil%dim(1),hsky%gil%dim(2)),stat=ier)
        call gdf_copy_header(hsky,hcont,error)
        hcont%gil%ndim = 2
        hcont%loca%size = hcont%gil%dim(1)*hcont%gil%dim(2)
        call sic_delvariable('CONTINUUM',.false.,error)
        call sic_mapgildas ('CONTINUUM',hcont,error,dcont)
      endif          
      !
      dcont(:,:) = dsky(:,:,1) ! Update CONTINUUM image too
      hcont%gil%minloc = hsky%gil%minloc
      hcont%gil%maxloc = hsky%gil%maxloc
      hcont%gil%rmin = hsky%gil%rmin
      hcont%gil%rmax = hsky%gil%rmax
    else
      do_continuum = .true.  ! Next CLEAN, there will be a CONTINUUM image
    endif
    saved_chan = tmp_mode    ! Restore the proper imaging mode
    huv_current%img = saved_chan
    huv_current%img%mode = code_img_cont
  else
    ! Cube Mode ---
    ! Select the data set. Can be UV_DATA, UV_MODEL, or UV_RESIDUAL
    if (current_uvdata.eq.'DATA_UV') then
      if (do_cct) then
        defmap_center = ' '
        call mosaic_restore(line,huv_current,error)     ! Image 
        defmap_center = string
      else
        call mosaic_uvmap('UV_MOSAIC',line,huv_current,error)     ! Image  
        huv_current%img%bounds = saved_chan%bounds
        huv_current%img%mode = code_img_line 
      endif        
    else 
      call gildas_null (huv_local,type='UVT')
      call uv_select_data(comm,huv_local,error)
      if (do_cct) then
        defmap_center = ' '
        call mosaic_restore(line,huv_local,error)     ! Image 
        defmap_center = string
      else
        call mosaic_uvmap('UV_MOSAIC',line,huv_local,error)     ! Image  
        huv_local%img%bounds = saved_chan%bounds
        huv_local%img%mode = code_img_line !! This may not work...
      endif        
    endif
    do_continuum = .false.  ! Next CLEAN will be no CONTINUUM
  endif
  if (error) return
  !
  call imager_tree('UV_MAP_MOSAIC',.true.)
end subroutine uv_map_mosaic
!
subroutine uv_self_mosaic(line,comm,error)
  use clean_arrays
  use clean_default
  use gbl_message
  use gkernel_interfaces
  use imager_interfaces, except_this => uv_self_mosaic
  !---------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- Support for command  
  !   UV_SELF /RANGE /RESTORE
  !!
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: comm     !! Caller name
  character(len=*), intent(inout) :: line  !! Command line
  logical, intent(inout) :: error          !! Logical error flag
  !
  ! Constants
  real(kind=8), parameter :: pi=3.14159265358979323846d0
  real(kind=4), parameter :: sec_to_rad=pi/3600.0/180.0
  character(len=1), parameter :: question_mark='?'
  ! ' UV_MAP', '/TRUNCATE',  '/FIELDS', '/RANGE', '/CONTINUUM', '/INDEX'
  integer, parameter :: o_trunc=1
  integer, parameter :: o_field=2
  integer, parameter :: o_range=3
  integer, parameter :: o_cont=4
  integer, parameter :: o_index=5
  ! ' UV_SELF', '/RANGE', '/RESTORE'
  integer, parameter :: opt_rang=1  ! /RANGE Option for UV_SELF
  integer, parameter :: opt_rest=2  ! /RESTORE Option for UV_SELF
  ! Memories ...
  logical, save :: do_self=.false.
  !
  ! Local ---
  logical :: do_cct, do_init
  integer :: saved_nfields ! Also used to distinguish Mosaic mode
  integer :: nline
  character(len=2) :: code, new_code
  character(len=16) :: acomm
  type(gildas) :: huv_tmp
  logical :: err, goon
  character(len=80) :: string
  integer :: debug
  !
  ! Code ----
  call map_message(seve%t,comm,'Uv_Self_Mosaic starting ',seve%e)
  code = ' '
  new_code = ' '
  call imager_tree('UV_SELF_MOSAIC',.false.)
  debug = 0
  call sic_get_inte('DEBUG_UVMAP',debug,error)
  error = .false.
  !
  ! Check command line syntax
  call map_query (line,comm,themap,goon,error) 
  if ((.not.goon).or.error) return
  !
  err = .false.
  if (comm.ne.'UV_SELF') then
    call map_message(seve%e,comm, &
    & 'Programming error - Expected UV_SELF command',seve%e)
    error = .true.
    return
  endif
  !
  do_init = hself_self%loca%size.eq.0 .or. sic_present(opt_rang,0)
  !
  saved_nfields = themap%nfields
  !
  ! Mosaic case
  call map_message(seve%w,'UV_SELF','not fully tested for Mosaics')
  error = .false.
  string = defmap_center
  if (.not.do_self) do_weig = .true.
  !
  ! Self-calibrated data
  do_cct = sic_present(opt_rest,0) ! /RESTORE option
  if (.not.do_cct) then
    if (do_init) then
      if (hself_self%loca%size.ne.0) call uvdebug_pointers(comm,'hself_self' ,hself_self)
      call init_selfcal('UV_SELF',line,error)
      if (error) return
        if (debug.gt.0) call uvdebug_pointers(comm,'hself_self ',hself_self)
      !! call uv_dump_buffers('UV_SELF *')
      line = 'UV_SELF'
      nline = len_trim(line)
      call sic_analyse(acomm,line,nline,error)
    endif
  else
    if (hself_self%loca%size.eq.0) then
      call map_message(seve%e,comm,'/RESTORE  Self calibrated UV data not defined')
      error = .true.
    else if (sic_narg(opt_rang).ge.0) then
      call map_message(seve%e,comm,'/RESTORE  conflicts with /RANGE')
      error = .true.
    endif
  endif
  if (error) return
  call gildas_null(huv_tmp,type='UVT')
  call uv_buffer_finduv(code)
  call gdf_copy_header(huv_current,huv_tmp,error)
  call gdf_copy_header(hself_self,huv_current,error)
    if (debug.gt.0) then
      call uvdebug_pointers(comm,'hself_self ',hself_self)
      call uvdebug_pointers(comm,'hself_raw  ',hself_raw)
      call uvdebug_pointers(comm,'Huv    ',huv_current)
    endif
  duv => duvself ! SG Probably WRONG 
  ! ! call uv_dump_buffers('SELFCAL')
  !
  if (.not.do_cct) then ! UV_SELF only case
    if (huv_current%gil%column_pointer(code_uvt_xoff).ne.0) then
      call map_message(seve%i,'UV_MOSAIC','UV data is a Pointing Mosaic',seve%e)
    else if (huv_current%gil%column_pointer(code_uvt_loff).ne.0) then
      call map_message(seve%i,'UV_MOSAIC','UV data is a Phase Mosaic',seve%e)
    else if (huv_current%gil%column_pointer(code_uvt_id).ne.0) then
      call map_message(seve%i,'UV_MOSAIC','UV data is a Mosaic with field ID',seve%e)
    else
      call map_message(seve%w,'UV_MOSAIC','UV data is a Mosaic of unknown type',seve%e)
    endif
    !
    ! Shift and Convert to Pointing offsets only (common Phase center) if needed
    if ((huv_current%gil%column_pointer(code_uvt_id).eq.0).and.(do_init)) then
      ! The question is which UV data is being shifted ? 
      ! The RAW one ?  The Line one ? The compressed one ? 
      call sub_shift_mosaic(line,comm,hself_self,themap,error)
      if (error) then
        themap%nfields = saved_nfields
        return
      endif
      !
      ! Copy back headers since Column types may have changed
      call gdf_copy_header(huv_current,hself_self,error)
      call uv_buffer_finduv(new_code)
    endif
    !
    ! This should be done on the HRAW data also if different from the HSELF one
    if (hself_raw%gil%nchan.ne.1) then
      call map_message(seve%w,comm,'Shifting RAW mosaic also ',seve%e)
      call sub_shift_mosaic(line,comm,hself_raw,themap,error)
    endif
    call mosaic_uvmap('UV_MOSAIC',line,hself_self,error)     ! Image
    do_continuum = .false.  ! Next CLEAN will be no CONTINUUM
    !
  else ! UV_SELF /RESTORE case
    !
    ! Here, MOSAIC_RESTORE should work because the UV table is already sorted...
    call map_message(seve%w,comm,'UV data is a Mosaic, under test...')
    !   The UV table is a priori already sorted & shifted
    !        call uv_shift_mosaic(line,'UV_MOSAIC',error)  ! Convert to Pointing offsets
    !        if (error) return
    call mosaic_restore(line,hself_self,error)
  endif
  defmap_center = string          ! Restore MAP_CENTER
  if (debug.gt.1) call uv_dump_buffers('UV_SELF_MOSAIC -- Before reset')
  call uv_buffer_resetuv(code)
  ! ! call gdf_print_header(huv_current)
  ! ! Print *,'UVSELF Header '
  if (debug.gt.1) call uv_dump_buffers('UV_SELF_MOSAIC -- At end')
  call gdf_copy_header(huv_tmp,huv_current,err)
  if (debug.gt.0) call uvdebug_pointers(comm,'hself_self ',hself_self)
  !
  themap%nfields = saved_nfields ! Restore the initial status of UV data
  if (error) return
  do_self = .true.
  !
  call map_message(seve%t,comm,'Uv_Self_Mosaic Ending',-2)
end subroutine uv_self_mosaic

subroutine mx_major_cycle90 (map,uvdata,nu,nv,   &
     &    w_weight,w_v,   &
     &    method,head,   &
     &    clean,beam,resid,nx,ny,nb,   &
     &    wcl,mcl,cct_list,ncct,   &
     &    list, nl, nf, primary, weight,   &
     &    grid, mapu, mapv, mapx, mapy,   &
     &    wfft, cpu0, uvmax, conv)
  use gkernel_interfaces
  use clean_def
  use image_def
  use gbl_message
  use imager_interfaces, except_this=>mx_major_cycle90
  !----------------------------------------------------------------------
  ! @ private-mandatory
  !
  ! IMAGER -- Support for command MX
  !
  !   Major cycle loop according to Cotton-Schwab idea.
  !   Treat only one "plane/channel" at a time. 
  !   Plane is specified by method%iplane
  !----------------------------------------------------------------------
  type (clean_par), intent(inout) :: method !! Clean parameters
  type (uvmap_par), intent(in) :: map       !! UV_MAP parameters
  type (gildas), intent(inout) :: head      !! Image header
  !
  integer, intent(in) :: nu                 !! Visibility size
  integer, intent(in) :: nv                 !! Number of visibilities
  integer, intent(in) :: nb                 !! Number of beams
  real, intent(inout) :: uvdata(nu,nv)      !! Visibilities (iterated residuals)
  real, intent(in) ::  w_weight(nv)         !! Weight array
  real, intent(in) ::  w_v(nv)              !! V values
  real, intent(in) ::  uvmax                !! Max baseline
  !
  integer, intent(in) ::  nx,ny             !! X,Y size
  real, intent(in) ::  mapx(nx),mapy(ny)    !! X,Y coordinates
  real, intent(out) ::  mapu(:),mapv(:)     !! U,V coordinates
  real, intent(inout) ::  grid(nx,ny)       !! Grid correction
  !
  real, intent(inout) ::  clean(nx,ny)      !! Clean image
  real, intent(inout) ::  resid(nx,ny)      !! Residuals
  real, intent(in) ::     beam(nx,ny,nb)    !! Synthesized beams (for all fields)
  integer, intent(in)  ::  nl               !! Search list size
  integer, intent(in)  ::  mcl              !! Maximum number of clean components
  integer, intent(out) ::  ncct             !! Number of clean components / plane
  real, intent(inout)  ::  wfft(*)          !! Work space for FFT
  type (cct_lst), intent(out) :: cct_list   !! Clean components list
  integer, intent(in)  ::  list(nx*ny)      !! List of valid pixels
  !
  integer, intent(in) ::  nf                !! Number of fields
  real, intent(inout) ::  primary(nf,nx,ny) !! Primary beams
  real, intent(inout) ::  weight (nx,ny)    !! Flat field
  !
  type(cct_par), intent(inout) :: wcl(mcl)  !! Work space for Clean Components
  type(gridding), intent(in) :: conv        !! Gridding parameters & coefficients
  !
  ! Constants
  character(len=2), parameter :: rname = 'MX'
  !
  ! Local ---
  real    maxc,minc,maxabs     ! max and min of data, absolute max value
  integer imax,jmax,imin,jmin  ! coordinates of the Max and Min pixels
  real    borne                ! Fraction of initial data
  real    limite               ! Minimal intensity retained
  real    clarkl               ! Clark worry limit
  real flux                    ! Total clean flux density
  integer ncl                  ! Number of selected data points
  logical fini                 ! Stopping criterium 
  logical converge             ! Stop by flux convergence
  integer k, kcl
  character(len=message_length) :: chain
  character(len=32) :: str
  !
  complex, allocatable :: tfgrid(:,:,:)
  complex, allocatable :: ftbeam(:,:)
  !
  real cpu1,cpu0
  integer nn(2),ndim,kz,ier
  !
  integer lx, ly
  !
  ! Code ----
  call imager_tree('MX_MAJOR_CYCLE90',.false.)
  !
  Print *,'GRID Max ',maxval(grid)
  Print *,'BEAM Max ',beam(nx/2+1,ny/2+1,1)
  !
  lx = (uvmax+map%support(1))/map%uvcell(1) + 2
  ly = (uvmax+map%support(2))/map%uvcell(2) + 2
  lx = 2*lx
  ly = 2*ly
  if (ly.gt.ny) then
    write(chain,'(A,A,F8.3)') 'Map cell is too large ',   &
     &      ' Undersampling ratio ',   &
     &      float(ly)/float(ny)
    call map_message(seve%w,rname,chain,seve%w)
    write(chain,*) 'UVMAX ',uvmax,map%support, map%uvcell
    call map_message(seve%w,rname,chain)
  endif
  ly = min(ly,ny)
  lx = min(lx,nx)
  ! !Print *,'MAPU Size ',size(mapu), lx
  call docoor (lx,-map%uvcell(1),mapu)
  call docoor (ly,map%uvcell(2),mapv)
  !
  kz = 1
  allocate (tfgrid(kz+1,lx,ly),ftbeam(nx,ny),stat=ier)
  !
  nn(1) = nx
  nn(2) = ny
  ndim = 2
  call fourt_plan(ftbeam,nn,ndim,-1,1)
  call gag_cpu(cpu0)
  !
  ! Find maximum residual
  call maxlst (resid,nx,ny,list,nl,   &
     &    maxc,imax,jmax,minc,imin,jmin)
  if (method%n_iter.lt.method%p_iter) then
    maxabs=abs(maxc)
  elseif ( abs(maxc).lt.abs(minc) ) then
    maxabs=abs(minc)
  else
    maxabs=abs(maxc)
  endif
  borne= max(method%fres*maxabs,method%ares)
  fini = maxabs.lt.borne
  method%n_iter= 0
  !
  !!Print *,'Weight ',w_weight(1:100)
  !!Print *,'V ',w_v
  !
  ! Major cycle
  k = 0
  flux = 0.0
  do while (.not.fini)
    !
    ! Define minor cycle limit
    k = k+1
    write(chain,100) 'Major cycle ',k,' loop gain ',method%gain
    call map_message(seve%d,rname,chain)
    limite = max(maxabs*method%bgain,0.8*borne)
    clarkl = maxabs*method%bgain
    !
    kcl = mcl
    !
    ! Select points of maximum strength and load them in
    call choice (      &
     &      resid,     &      ! Current residuals
     &      nx,ny,     &      ! image size
     &      list, nl,  &      ! Search list
     &      limite,    &      ! Detection threshold
     &      kcl,       &      ! Maximum number of candidates
     &      wcl,       &      ! Selected candidate components
     &      ncl,       &      ! Selected Number of components
     &      maxabs, method%ngoal)
    !
    if (ncl.gt.0) then
      write(chain,100) 'Selected ',ncl,' points above ',limite
      call map_message(seve%d,rname,chain)
      !
      ! Make minor cycles
      call clark_minor (method,   &
     &        wcl,    &     ! Selected candidate components
     &        ncl,   &         ! Number of candidates
     &        beam,nx,ny,   &  ! Dirty beams and Size
     &        nx,ny,        &  ! Image sizes
     &        method%beam0(1),method%beam0(2),   & ! Beam center
     &        method%patch(1),method%patch(2),   & ! Beam patch
     &        clarkl,limite,   &
     &        converge,   &    !
     &        cct_list,   &    ! Cumulated components
     &        nf, primary, weight, method%trunca,   &
     &        flux,   &        ! Total Flux
     &        method%pflux, next_flux90)
      !
      ! Remove all components by FT : RESID = RESID - BEAM # WCL(*,4)
      !
      call mx_uvsub90 (nx,ny,mapx,mapy,   &
     &        wcl, ncl,   &
     &        nu,nv,uvdata,method%iplane)
      write (chain,101)  'Cleaned ',flux,' Jy with ',   &
     &        method%n_iter,' clean components'
      call map_message(seve%d,rname,chain)
      !
      ! Compute FFTs and loop again
      call gag_cpu(cpu1)
      write(chain,101) 'Start FFT back at ',cpu1-cpu0
      call map_message(seve%d,rname,chain)
      call dofft (nu,nv,     &   ! Size of visibility array
     &        uvdata,        &   ! Visibilities
     &        1,2,           &   ! U, V pointers
     &        method%iplane, &   ! First channel to map
     &        1,lx,ly,       &   ! Cube size
     &        tfgrid,        &   ! FFT cube
     &        mapu,mapv,     &   ! U and V grid coordinates
     &        map%support,   &
     &        map%uvcell,map%taper,   &    ! Gridding parameters
     &        w_weight,      &   ! Weight & Visi arrays
     &        conv%ubias,conv%vbias,conv%ubuff,conv%vbuff,map%ctype)
      !
      ! Make maps with grid correction
      call extracs (2,nx,ny,1,tfgrid,ftbeam,lx,ly)
      call fourt  (ftbeam,nn,ndim,-1,1,wfft)
      call cmtore (ftbeam,resid,nx,ny)
      !
      call docorr (resid,grid,nx*ny)
      call gag_cpu(cpu1)
      write(chain,101) 'Finished gridding again ',cpu1-cpu0
      call map_message(seve%d,rname,chain)
      !
      ! Find new extrema
      call maxlst (resid,nx,ny,list,nl,   &
     &        maxc,imax,jmax,minc,imin,jmin)
      if (method%n_iter.lt.method%p_iter) then
        maxabs=abs(maxc)
      elseif ( abs(maxc).lt.abs(minc) ) then
        maxabs=abs(minc)
      else
        maxabs=abs(maxc)
      endif
      !
      ! Check if converge
      Print *,'MaxAbs ',maxabs,' Borne ',borne, ' Converge ',converge,' Ares ',method%ares
      Print *,'Niter ',method%n_iter,' Max  ',method%m_iter
      fini = (maxabs.le.borne)   &
     &        .or. (method%m_iter.le.method%n_iter)   &
     &        .or. converge
    else
      ! No component found: finish...
      write(chain,101) 'No points selected above ',limite
      call map_message(seve%i,rname,chain)
      fini = .true.
    endif
    !
    converge = fini
    !
    ! Unclear here ...
    call major_plot90 (method,head,   &
     &      converge,method%n_iter,nx,ny,nf,   &
     &      cct_list%cc,clean,resid,weight)
    fini = converge
    !
    ! Get new list
!TEST!    if (.not.fini) then
!TEST!      call re_mask (method,head,nl,error)
!TEST!      nl = method%nlist
!TEST!      list = method%list
!TEST!    endif
  enddo
  ncct = method%n_iter
  !
  ! End
  if (maxabs.le.borne) then
    str = '(minimum flux density)'
  elseif (method%m_iter.le.method%n_iter) then
    str = '(maximum number of components)'
  elseif (method%n_major.le.k) then
    str = '(maximum number of cycles)'
  elseif (converge) then
    str = '(converged)'
  else
    str = '(unknown reason)'
  endif
  write(chain,'(a,i6,a,1pg10.3,a,i5,a)')  'Plane ',method%iplane,': ',flux,' Jy in ',   &
     &    method%n_iter,' clean components '//trim(str)
  call map_message(seve%i,rname,chain)
  !
  if (allocated(tfgrid)) deallocate(tfgrid)
  if (allocated(ftbeam)) deallocate(ftbeam)
  call imager_tree('MX_MAJOR_CYCLE90',.true.)
  !
  100   format (a,i6,a,1pg10.3,a)
  101   format (a,1pg10.3,a,i5,a)
end subroutine mx_major_cycle90
!
subroutine mx_uvsub90 (nx,ny,mapx,mapy,   &
     &    wcl,ncl,nu,nv,visi,ip)
  use clean_def
  !----------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER --  Support for MX  
  !   Subtract last major cycle components from UV table.
  !   Treats only one channel.
  !!
  !----------------------------------------------------------------------
  integer, intent(in) ::  nx,ny               !! X,Y size
  real, intent(in) ::  mapx(nx),mapy(ny)      !! X,Y coordinates
  integer, intent(in) :: nu                   !! Visibility size
  integer, intent(in) :: nv                   !! Number of visibilities
  integer, intent(in) :: ncl                  !! Number of clean components
  real, intent(inout) :: visi(nu,nv)          !! Visibilities
  integer, intent(in) :: ip                   !! Current "plane/channel"
  type(cct_par), intent(inout) :: wcl(ncl)    !! Clean component values
  !
  ! Local ---
  integer ncomp
  integer ic,iv,ir,ii
  real x,y,phase,rvis,ivis
  !
  ! Code ----
  ir = 5+3*ip  ! Real part
  ii = ir+1    ! Imaginary part
  !
  ! Compress clean component list
  ncomp = 0
  do ic=1,ncl
    if (wcl(ic)%value.ne.0.0) then
      ncomp = ncomp+1
      wcl(ncomp) = wcl(ic)
    endif
  enddo
  !
  ! Remove clean component from UV data set
  do iv = 1,nv
    do ic = 1,ncomp
      x = mapx(wcl(ic)%ix)
      y = mapy(wcl(ic)%iy)
      phase = visi(1,iv)*x+visi(2,iv)*y
      rvis = wcl(ic)%value*cos(phase)
      ivis = wcl(ic)%value*sin(phase)
      visi(ir,iv) = visi(ir,iv) - rvis
      visi(ii,iv) = visi(ii,iv) - ivis
    enddo
  enddo
end subroutine mx_uvsub90

module imager_interfaces_none
  interface
    subroutine new_dirty_beam
      use clean_def
      use clean_arrays
      use clean_beams
      !
      !! IMAGER -- BEAM Utility  
      !! Called when a new dirty map is computed by command UV_MAP
      !
    end subroutine new_dirty_beam
  end interface
  !
  interface
    subroutine imager_write_data(head,data,error)
      use image_def
      use gkernel_types
      use gbl_message
      use clean_types
      !*
      !   Utility routine to write a Data Set in various formats.
      ! Supported formats are GILDAS, FITS, and also CSV fro 2-D Tables
      !!
      type(gildas), intent(inout) :: head  !! Data header
      real, intent(in) :: data(*)          !! Data buffer - Contiguous array
      logical, intent(inout) :: error      !! Logical error flag
    end subroutine imager_write_data
  end interface
  !
  interface
    subroutine table_to_csv(head,data,error)
      use image_def
      use iso_c_binding
      !*
      !   Utility routine
      !
      ! Write GILDAS Table to CSV file. Supports Real(8) and
      ! Real(4) tables.
      !!
      type(gildas), intent(inout) :: head  !! Table Header
      real, intent(in) :: data(*)          !! Data buffer -- contiguous, no type checking
      logical, intent(inout) :: error
    end subroutine table_to_csv
  end interface
  !
  interface
    subroutine table_to_csv4(nx,ny,file,data)
      !*
      !   Utility routine
      !
      ! Write Real(4) 2-D array Table to CSV file. 
      !!
      integer, intent(in) :: nx   !! First dimension
      integer, intent(in) :: ny   !! Second dimension
      character(len=*), intent(inout) :: file !! File name
      real, intent(in) :: data(nx,ny)   !! Array
    end subroutine table_to_csv4
  end interface
  !
  interface
    subroutine table_to_csv8(nx,ny,file,data)
      !*
      !   Utility routine
      !
      ! Write Real(8) 2-D array Table to CSV file. 
      !!
      integer, intent(in) :: nx   !! First dimension
      integer, intent(in) :: ny   !! Second dimension
      character(len=*), intent(inout) :: file !! File name
      real(kind=8), intent(in) :: data(nx,ny) !! Array
    end subroutine table_to_csv8
  end interface
  !
  interface
    subroutine astro_message(seve,comm,mess)
      !! Remap to MAP_MESSAGE
      integer, intent(in) :: seve
      character(len=*), intent(in) :: comm
      character(len=*), intent(in) :: mess
    end subroutine astro_message
  end interface
  !
  interface
    subroutine astro_teles(freqs)
      use ast_astro
      use ast_telescope
      !
      real(4), intent(in) :: freqs ! Frequency in GHz
    end subroutine astro_teles
  end interface
  !
  interface
    subroutine cdaten(cdate,ndate,error)
      use gbl_message
      !---------------------------------------------------------------------
      !  Convert the date '01-JAN-1984' in integers for year, month, and day
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: cdate     !! String date
      integer(kind=4),  intent(out)   :: ndate(3)  !! Integer values
      logical,          intent(inout) :: error     !! Logical error flag
    end subroutine cdaten
  end interface
  !
  interface
    subroutine ndatec(ndate,cdate,error)
      use gbl_message
      !------------------------------------------------------------------------
      !  Convert the integers for year, month, and day into date '01-JAN-1984'
      !------------------------------------------------------------------------
      integer(kind=4),  intent(in)    :: ndate(3)  !! Year Month Day
      character(len=*), intent(out)   :: cdate     !! DD-MMM-YYYY
      logical,          intent(inout) :: error     !! Logical error flag
    end subroutine ndatec
  end interface
  !
  interface
    subroutine ctimen(ctime,ntime,error)
      use gbl_message
      !---------------------------------------------------------------------
      ! Converts the TIME '12:34:56.1234' in integers for Hours, Minutes,
      ! Seconds, and milliSeconds
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: ctime     !! Time string
      integer(kind=4),  intent(out)   :: ntime(4)  !! H, M, S and milliSec
      logical,          intent(inout) :: error     !! Logical error flag
    end subroutine ctimen
  end interface
  !
  interface
    subroutine ntimec(ntime,ctime,error)
      use gbl_message
      !---------------------------------------------------------------------
      ! Converts the integers for Hours, Minutes, Seconds, milliSeconds to
      ! formatted TIME
      !---------------------------------------------------------------------
      character(len=*), intent(out)   :: ctime     !
      integer(kind=4),  intent(in)    :: ntime(4)  !
      logical,          intent(inout) :: error     !
    end subroutine ntimec
  end interface
  !
  interface
    subroutine utc(date)
      use gbl_message
      !---------------------------------------------------------------------
      !  Lecture de l'heure du systeme par appel des routines systeme
      ! SIC_DATE en sortie : DATE date gregorienne (year, month, day, hour,
      ! minute, second)
      !---------------------------------------------------------------------
      integer(kind=4), intent(out) :: date(7)  !! Gregorian day
    end subroutine utc
  end interface
  !
  interface
    subroutine astro_check_tsys
      use atm_params
      use ast_astro
      use ast_telescope
      use gbl_message
      !
    end subroutine astro_check_tsys
  end interface
  !
  interface
    subroutine catalog_init(imol,error)
      !
      !! IMAGER --  Initialize or Update catalog variables
      integer, intent(inout) :: imol  !! Number of molecules
      logical, intent(out) :: error   !! Logical error flag
    end subroutine catalog_init
  end interface
  !
  interface
    subroutine sub_cct_collect(sx,sy,sz,ncx,ncy,ncz,ny,nz,x,y,z)
      use gildas_def
      use clean_def
      !! Concatenate CCT Tables
      integer, intent(in) :: sx                        !! Size of a Clean Component (3 or 4)
      integer(kind=address_length), intent(in) :: sy   !! Size of Y Clean component
      integer(kind=address_length), intent(in) :: sz   !! Size of Z Clean component
      integer(kind=address_length), intent(in) :: ncx  !! Number of channels in X (output) CCT table
      integer(kind=address_length), intent(in) :: ncy  !! Number of channels in Y CCT Table
      integer(kind=address_length), intent(in) :: ncz  !! Number of channels in Z CCT Table
      integer(kind=address_length), intent(in) :: ny   !! Number of components in Y table
      integer(kind=address_length), intent(in) :: nz   !! Number of compoents in Z table
      real, intent(in) :: y(sy,ncy,ny)      !! Y CCT table
      real, intent(in) :: z(sz,ncz,nz)      !! Z CCT table
      real, intent(out) :: x(sx,ncx,ny+nz)  !! Combined CCT table
    end subroutine sub_cct_collect
  end interface
  !
  interface
    subroutine do_fft (nx,ny,nf,fft,work)
      !$ use omp_lib
      !! IMAGER -- Compute a Cube from its FFT
      !
      integer, intent(in)  :: nx                       !! X size
      integer, intent(in)  :: ny                       !! Y size
      integer, intent(in)  :: nf                       !! Z size
      complex, intent(inout) :: fft(nx,ny,nf)          !! FFT cube
      real, intent(inout)  :: work(2*max(nx,ny))       !! Work space
    end subroutine do_fft
  end interface
  !
  interface
    subroutine color_comm(line,error)
      use gbl_message
      !---------------------------------------------------------------------
      !*
      ! IMAGER -- Support for command  
      !   COLOR Span HueMin HueMax [/TYPE Noise|Percent]
      !
      !   calls "@ p_color.ima" to derive a lut
      !   with unsaturated colours up to Span around 0,
      !   and a Hue range between Min and Max 
      !!
      !---------------------------------------------------------------------
      character(len=*), intent(in) :: line  !! Command line
      logical, intent(inout) :: error       !! Error flag
    end subroutine color_comm
  end interface
  !
  interface
    subroutine no_logstack
      !* 
      ! IMAGER -- Ensure that previous command is not written in the 
      !  Stack or LogFile.
      !  Some otherwise "normal" commands require this after some
      !  interactive use
      !!
    end subroutine no_logstack
  end interface
  !
  interface
    subroutine combine_comm(line,error)
      !! IMAGER -- Dispatch routine for COMBINE
      character(len=*), intent(in) :: line
      logical, intent(inout) :: error
    end subroutine combine_comm
  end interface
  !
  interface
    subroutine map_combine_comm(line,error)
      !! IMAGER -- Dispatch routine for MAP_COMBINE
      character(len=*), intent(in) :: line
      logical, intent(inout) :: error
    end subroutine map_combine_comm
  end interface
  !
  interface
    subroutine sub_combine(hx,hy,hz,n,m,dx,dy,dz,b,iblank,code,ay,ty,az,tz,c,error)
      use gkernel_types
      !----------------------------------------------------------------------
      !*
      ! IMAGER  -- Support routine for commands  
      ! COMBINE Out CODE In1 In2 /FACTOR A1 A2 /THRESHOLD T1 T2 /BLANK Bval
      !!
      !----------------------------------------------------------------------
      character(len=*), intent(inout) :: code    !! Combination code
      integer(kind=index_length), intent(in) :: n  !! Size of image
      integer(kind=index_length), intent(in) :: m  !! Number of channels
      type(gildas), intent(inout) :: hx    !! Output header
      type(gildas), intent(in) :: hy    !! Input Cube header
      type(gildas), intent(in) :: hz    !! Input Cube or Plane header
      !
      real, intent(in) :: dx(n,m)       !! Output data
      real, intent(in) :: dy(n,m)       !! Input data
      real, intent(in) :: dz(n)         !! Input data
      real, intent(in) :: c             !! Offset
      real, intent(in) :: ay            !! Y Factor
      real, intent(in) :: ty            !! Y Threshold
      real, intent(in) :: az            !! Z Factor
      real, intent(in) :: tz            !! Z Threshold
      real, intent(in) :: b  !! Output blanking
      integer(kind=index_length), intent(inout) :: iblank  !! Number of blanked pixels
      logical, intent(out) :: error  ! Logical error flag
    end subroutine sub_combine
  end interface
  !
  interface
    subroutine add002(z,y,x,n,m,bz,ez,az,tz,by,ey,ay,ty,bx,c,iblank)
      !$ use omp_lib
      use gkernel_types
      !---------------------------------------------------------------------
      !! GDF  -- Internal routine  
      !!    Linear combination of input arrays  
      !!  X = Ay*Y + Az*Z + C 
      !---------------------------------------------------------------------
      integer(kind=index_length), intent(in) :: n
      integer(kind=index_length), intent(in) :: m
      real :: z(n)                      !! Plane array
      real :: y(n,m)                    !! Input Cube
      real :: x(n,m)                    !! Output Cube
      real :: bz                        !! Z Blanking value
      real :: ez                        !! Z Tolerance on blanking
      real :: az                        !! Z factor
      real :: tz                        !! Z threshold
      real :: by                        !! Y Blanking value
      real :: ey                        !! Y Tolerance on blanking
      real :: ay                        !! Y factor
      real :: ty                        !! Y Threshold
      real :: bx                        !! X Blanking
      real :: c                         !! Constant Offset
      integer(kind=index_length), intent(inout) :: iblank !! Number of bad pixels
    end subroutine add002
  end interface
  !
  interface
    subroutine div002(z,y,x,n,m,bz,ez,az,tz,by,ey,ay,ty,bx,c,iblank)
      !$ use omp_lib
      use gkernel_types
      !---------------------------------------------------------------------
      !! GDF  -- Internal routine
      !!    Division of 2 input arrays  
      !!  X = Ay*Y / Az*Z + C  
      !---------------------------------------------------------------------
      integer(kind=index_length), intent(in) :: n
      integer(kind=index_length), intent(in) :: m
      real :: z(n)                      !! Plane array
      real :: y(n,m)                    !! Input Cube
      real :: x(n,m)                    !! Output Cube
      real :: bz                        !! Z Blanking value
      real :: ez                        !! Z Tolerance on blanking
      real :: az                        !! Z factor
      real :: tz                        !! Z threshold
      real :: by                        !! Y Blanking value
      real :: ey                        !! Y Tolerance on blanking
      real :: ay                        !! Y factor
      real :: ty                        !! Y Threshold
      real :: bx                        !! X Blanking
      real :: c                         !! Constant Offset
      integer(kind=index_length), intent(inout) :: iblank !! Number of bad pixels
    end subroutine div002
  end interface
  !
  interface
    subroutine mul002(z,y,x,n,m,bz,ez,az,tz,by,ey,ay,ty,bx,c,iblank)
      !$ use omp_lib
      use gkernel_types
      !---------------------------------------------------------------------
      !! GDF  -- Internal routine  
      !!  Multiplication of input arrays  
      !!  X = Ay*Y * Az*Z + C
      !---------------------------------------------------------------------
      integer(kind=index_length), intent(in) :: n
      integer(kind=index_length), intent(in) :: m
      real :: z(n)                      !! Plane array
      real :: y(n,m)                    !! Input Cube
      real :: x(n,m)                    !! Output Cube
      real :: bz                        !! Z Blanking value
      real :: ez                        !! Z Tolerance on blanking
      real :: az                        !! Z factor
      real :: tz                        !! Z threshold
      real :: by                        !! Y Blanking value
      real :: ey                        !! Y Tolerance on blanking
      real :: ay                        !! Y factor
      real :: ty                        !! Y Threshold
      real :: bx                        !! X Blanking
      real :: c                         !! Constant Offset
      integer(kind=index_length), intent(inout) :: iblank !! Number of bad pixels
    end subroutine mul002
  end interface
  !
  interface
    subroutine opt002(z,y,x,n,m,bz,ez,az,tz,by,ey,ay,ty,bx,c,iblank)
      !$ use omp_lib
      use gkernel_types
      !---------------------------------------------------------------------
      !! GDF -- Internal routine  
      !!  Optical depth from input arrays  
      !!  X = - LOG ( Ay*Y / Az*Z + C )  
      !---------------------------------------------------------------------
      integer(kind=index_length), intent(in) :: n
      integer(kind=index_length), intent(in) :: m
      real :: z(n)                      !! Plane array
      real :: y(n,m)                    !! Input Cube
      real :: x(n,m)                    !! Output Cube
      real :: bz                        !! Z Blanking value
      real :: ez                        !! Z Tolerance on blanking
      real :: az                        !! Z factor
      real :: tz                        !! Z threshold
      real :: by                        !! Y Blanking value
      real :: ey                        !! Y Tolerance on blanking
      real :: ay                        !! Y factor
      real :: ty                        !! Y Threshold
      real :: bx                        !! X Blanking
      real :: c                         !! Constant Offset
      integer(kind=index_length), intent(inout) :: iblank !! Number of bad pixels
    end subroutine opt002
  end interface
  !
  interface
    subroutine read_and_map(name,head,file,error)
      use gkernel_types
      use gbl_message
      !*
      ! IMAGER -- Utility routine 
      !   Read a data cube and define an associated SIC variable
      !!
      character(len=*), intent(in) :: name      !! SIC Variable name
      character(len=*), intent(inout) :: file   !! Data file
      type(gildas), intent(inout) :: head       !! Data cube header
      logical, intent(out) :: error             !! Logical error flag
    end subroutine read_and_map
  end interface
  !
  interface
    subroutine sub_print_debug(var,purpose)
      character(len=*), intent(in) :: var
      character(len=*), intent(in) :: purpose
    end subroutine sub_print_debug
  end interface
  !
  interface
    subroutine sub_print_idebug(var,purpose)
      character(len=*), intent(in) :: var
      character(len=*), intent(in) :: purpose
    end subroutine sub_print_idebug
  end interface
  !
  interface
    subroutine init_display 
      !! Initialize the DISPLAY language from VIEWER
    end subroutine init_display
  end interface
  !
  interface
    subroutine save_result(error)
      use gildas_def
      use clean_types
      use gbl_message
      !-------------------------------------------------------------------
      !! IMAGER - Exit routine: ask user whether to save data or not
      !-------------------------------------------------------------------
      logical error !! Logical error flag
    end subroutine save_result
  end interface
  !
  interface
    subroutine define_imager_vars (error)
      use gildas_def
      use clean_def
      use clean_arrays
      use clean_types
      use clean_default
      use clean_support
      use clean_beams
      use grid_control
      !----------------------------------------------------
      !! IMAGER -- Define internal SIC variables
      !----------------------------------------------------
      logical :: error    !! Logical error flag
    end subroutine  define_imager_vars
  end interface
  !
  interface
    subroutine dump_memory(error)
      use clean_default
      use gbl_message
      !
      !*
      ! IMAGER -- Support for DUMP MEMORY: Printout memory usage.
      !
      ! There is no generic code to retrieve the memory use.
      !
      ! On Linux, one could scan directly the /proc/self/status   file.
      !
      ! Most efficient would be to call the C Posix standard "getrusage"
      ! but that only returns the Maximum used memory, not the current one.
      ! 
      ! Other methods are system dependent, and require to fork a child, 
      ! which duplicates the memory content and can lead to Crashes !...
      !!
      logical, intent(out) :: error  !! Logical error flag
      interface
        subroutine getSize(val) bind(c, name='getSize')
          import :: c_long
          integer(kind=c_long) :: val
        end
      end interface
    end subroutine dump_memory
  end interface
  !
  interface
    subroutine big_wait(n,b)
      real, intent(inout) :: b
      integer, intent(in) :: n
    end subroutine big_wait
  end interface
  !
  interface
    subroutine explore_comm(line,comm,error)
      use gkernel_types
      use clean_default
      use gbl_message
      !---------------------------------------------------------------------
      !*
      ! VIEWER -- Support for command  
      ! EXPLORE [DataCube] [/ADD Ux Uy [Ibox]] [/NOWAIT]
      !
      !    Call the "explore" scripts that allow to display from a data cube:  
      ! - a 2-D image (channel or integrated area)  
      ! - spectra at selected positions around it  
      !
      ! The display is organized in a Keypad layout  
      !     7 8 9  
      !     4 5 6  
      !     1 2 3  
      !!
      !---------------------------------------------------------------------
      character(len=*), intent(in) :: line  !! Command line
      character(len=*), intent(in) :: comm  !! Command name
      logical, intent(out) :: error  !! Logical error flag
    end subroutine explore_comm
  end interface
  !
  interface
    subroutine extract_real (c,mx,my,r,nx,ny)  
      !-----------------------------------------------------------------
      !!     Extract a Real array from a larger Complex array
      !! while shuffling the quarters 
      !-----------------------------------------------------------------
      integer nx,ny                        !! size of input array
      real r(nx,ny)                        !! input real array
      integer mx,my                        !! size of output array
      complex c(mx,my)                     !! output complex array
    end subroutine extract_real
  end interface
  !
  interface
    subroutine scale_factor(nx,ny,cbig,chigh,rmask,fscale,flux) 
      !*
      !  Compute best fit scaling factor for overlapping regions
      ! of visibilities.
      !
      integer, intent(in) :: nx,ny
      !! FFT of image size
      complex, intent(in) :: cbig(nx,ny)
      !! First FFT
      complex, intent(in) :: chigh(nx,ny)
      !! Second FFT
      real, intent(in) :: rmask(nx,ny)
      !! Masked regions
      real, intent(out) :: fscale
      !! Scale factor
      real, intent(out) :: flux
    end subroutine scale_factor
  end interface
  !
  interface
    subroutine howto_comm(line,error,icode)
      use gbl_message
      !---------------------------------------------------------------------
      !! IMAGER -- Support for command HOW_TO
      !---------------------------------------------------------------------
      character(len=*), intent(inout) :: line  !! Command line
      logical, intent(out) :: error            !! Logical error flag
      integer, intent(inout) :: icode  !! Operation code: 0 examine ambiguities, 1 use unambiguous result
    end subroutine howto_comm
  end interface
  !
  interface
    subroutine imager_version
      use gbl_ansicodes
      use gkernel_types
      !
      !! IMAGER -- Test last IMAGER usage
      !
    end subroutine imager_version
  end interface
  !
  interface
    subroutine gclean_init
      use gclean_mod
      !! IMAGER - CLEAN Method GAUSS -- GCLEAN command  
      !!  Initialize scale arrays
    end subroutine gclean_init
  end interface
  !
  interface
    subroutine uv_grid_comm(line,comm,error)
      use clean_arrays
      use clean_default
      !! Test routine -- not yet used
      character(len=*), intent(in) :: comm
      character(len=*), intent(in) :: line
      logical, intent(out) :: error
    end subroutine uv_grid_comm
  end interface
  !
  interface
    function continuum_emg(x, amp, mu, sig, lamb)
      !! IMAGER -- Implementation of an Exponentially modified Gaussian function
      real(4) :: continuum_emg ! intent(out)
      real(4), intent(in) :: x
      ! Input value
      real(4), intent(in) :: amp 
      !! Amplitude of function
      real(4), intent(in) :: mu  
      !! Position
      real(4), intent(in) :: sig 
      !! Width
      real(4), intent(in) :: lamb 
    end function continuum_emg
  end interface
  !
  interface
    function continuum_gauss(x, amp, mu, sig)
      real(4) :: continuum_gauss ! intent(out)
      !! IMAGER -- Implementation of a Gaussian function 
      real(4), intent(in) :: x
      ! Input value
      real(4), intent(in) :: amp 
      !! Amplitude of function
      real(4), intent(in) :: mu  
      !! Position
      real(4), intent(in) :: sig 
    end function continuum_gauss
  end interface
  !
  interface
    subroutine map_message_set_id(id)
      use gbl_message
      !---------------------------------------------------------------------
      !*
      ! IMAGER -- Message Utility  
      ! Alter library id into input id. Should be called by the library
      ! which wants to share its id with the current one.
      !!
      !---------------------------------------------------------------------
      integer, intent(in) :: id  !! Package ID
    end subroutine map_message_set_id
  end interface
  !
  interface
    subroutine message_attribute(cattr)
      use gbl_ansicodes
      !! IMAGER -- Message Utility -- Write color or bold modifier to terminal
      character(len=*), intent(in) :: cattr  !! Attribute modifier
    end subroutine message_attribute
  end interface
  !
  interface
    subroutine sub_modify_scale(head,rdata,rsize,scale)
      use image_def
      !
      !*
      !   IMAGER -- GILDAS Utility --  Change the Unit of data cube
      ! 
      !     Support routine for SPECIFY UNIT
      !!
      type(gildas), intent(inout) :: head   !! Cube Header
      integer(kind=index_length), intent(in) :: rsize  !! Data length
      real, intent(inout) :: rdata(rsize)   !! Data array
      real, intent(in) :: scale             !! Scale factor
    end subroutine sub_modify_scale
  end interface
  !
  interface
    subroutine sub_modify_blank(head,rdata,rsize,bval)
      use image_def
      !*
      !   IMAGER -- GILDAS Utility --  Change the Cube blanking value
      ! 
      !     Support routine for SPECIFY BLANKING
      !!
      type(gildas), intent(inout) :: head               !! Cube Header
      integer(kind=index_length), intent(in) :: rsize   !! Data length
      real, intent(inout) :: rdata(rsize)               !! Data array
      real, intent(in) :: bval                          !! New blanking
    end subroutine sub_modify_blank
  end interface
  !
  interface
    subroutine moments_comm(line,error)
      use gkernel_types
      use iso_c_binding
      use clean_arrays
      use moment_arrays
      use gbl_message
      !---------------------------------------------------------------------
      !*
      ! IMAGER -- Support for command MOMENTS  
      !       MOMENTS  [SMOOTH]  
      !         [/MASK]  
      !         [/METHOD Mean Peak Parabolic]  
      !         [/RANGE Min Max TYPE] [/THRESHOLD Min]  
      ! or  
      !         MOMENTS /CUTS Threshold [Regions]  
      !!
      !---------------------------------------------------------------------
      character(len=*), intent(in) :: line  !! Command line
      logical, intent(inout) :: error       !! Logical error flag
    end subroutine moments_comm
  end interface
  !
  interface
    subroutine moments_cuts(line,error)
      use clean_arrays
      use moment_arrays
      use gbl_message
      !---------------------------------------------------------------------
      !*
      ! IMAGER  -- Support for command MOMENTS /CUTS Threshold [Regions]
      !!
      !---------------------------------------------------------------------
      character(len=*), intent(in) :: line  !! Command line
      logical, intent(inout) :: error       !! Logical error flag
    end subroutine moments_cuts
  end interface
  !
  interface
    subroutine sub_moments(horigin,line,error)
      use clean_arrays
      use moment_arrays
      use gbl_message
      !---------------------------------------------------------------------
      !*
      ! IMAGER -- Support for command  
      !       MOMENT  
      !         [/MASK]  
      !         [/METHOD Mean Peak Parabolic]  
      !         [/RANGE Min Max TYPE] [/THRESHOLD Min]  
      !
      ! A dedicated routine to compute the moment of an input data cube.
      ! Produces any or all of 4 following images:  
      !           1) the integrated intensity map  
      !           2) the Peak brightness  
      !           3) The mean velocity  
      !           4) The line width  
      ! Method:  
      !     AREA      Integrated intensity in Velocity range  
      !     PEAK      Peak intensity in Velocity range  
      !     VELOCITY  Velocity of peak    
      !     WIDTH     2nd moment: line width
      !
      ! The peak intensity is obtained either as a per-channel basis,
      ! or a parabolic fit around the maximum. The Velocity is obtained
      ! in a similar way, or intensity weighted.
      !     
      !        For each spectrum, make a gate in velocity and clip based on
      !       intensity. Sum up weighted velocity and mean intensity.
      !!
      !---------------------------------------------------------------------
      type(gildas), intent(in) :: horigin   !! Input image, CLEAN or SKY
      character(len=*), intent(in) :: line  !! Command line
      logical, intent(inout) :: error       !! Logical error flag
    end subroutine sub_moments
  end interface
  !
  interface
    subroutine set_velo(nv,av,ref,val,inc)
      use gildas_def
      !! IMAGER -- Utility routine : Compute velocity sampling
      integer(kind=index_length), intent(in)  :: nv  !! Number of channels
      real(kind=4), intent(out) :: av(nv)       !! Velocities
      real(kind=8), intent(in)  :: ref,val,inc  !! Reference, Value and Increment
    end subroutine set_velo
  end interface
  !
  interface
    subroutine imager_pack_set(pack)
      use gpack_def
      !! Declare the IMAGER package
      type(gpack_info_t), intent(out) :: pack
    end subroutine imager_pack_set
  end interface
  !
  interface
    subroutine imager_pack_init(gpack_id,error)
      use sic_def
      !! Initialize the IMAGER program
      integer :: gpack_id   !! Package ID
      logical :: error      !! Logical error flag
    end subroutine imager_pack_init
  end interface
  !
  interface
    subroutine imager_pack_on_exit(error)
      !! Clean up buffers and exit
      logical :: error    !! Logical error flag
    end subroutine imager_pack_on_exit
  end interface
  !
  interface
    subroutine plait_comm(line,comm,error)
      use image_def
      use gbl_message
      !--------------------------------------------------------------------
      !*
      ! IMAGER -- Support for PLAIT command  
      ! PLAIT Output In1 Angle1 Length1 In2 Angle2 Length2 ...
      !
      ! Elaborated on original ideas from Ch. Nieten, 
      !   see https://articles.adsabs.harvard.edu/pdf/2000ASPC..217...72N
      ! and the NOD2 package, namely the "Basket Weaving" technique described
      ! in Emerson & Graeve 1988, 
      !   see https://articles.adsabs.harvard.edu/pdf/1988A%26A...190..353E.
      !
      ! Initial coding P. Hily-Blant feb-2005  
      ! Documented and Cleaned    Stéphane Guilloteau May-2023
      !---------------------------------------------------------------------
      character(len=*), intent(in) :: line  !! Command line
      character(len=*), intent(in) :: comm  !! Command name
      logical :: error                      !! Logical error flag
    end subroutine plait_comm
  end interface
  !
  interface
    function mth_bessj1 (x)
      !-------------------------------------------------------------------
      !! Compute Bessel function J1
      !-------------------------------------------------------------------
      real(8) :: mth_bessj1       
      real(8), intent(in) :: x 
    end function mth_bessj1
  end interface
  !
  interface
    subroutine gdf_uv_size(huvl,nc)
      use image_def
      !
      type(gildas), intent(inout) :: huvl
      integer, intent(in) :: nc(2)
    end subroutine gdf_uv_size
  end interface
  !
  interface
    subroutine cossin(phase,rcos,rsin)
      !-------------------------------------------------------
      !*
      ! Semi-Fast,  Semi-accurate Sin/Cos pair computation
      ! using (not yet clever) interpolation from a precise
      ! loop-up table
      !
      ! A solution using Taylor expansion and symmetries
      ! would be faster and more accurate. The speed is
      ! unfortunately controlled by the Modulo function.
      !    Might become faster if a simple test is made
      ! to avoid this Modulo.  To be developped as needed.
      !! 
      !-------------------------------------------------------
      real(8), intent(inout) :: phase  !! Phase value (radian)
      real(8), intent(out) :: rcos     !! Approximate Cosine
      real(8), intent(out) :: rsin     !! Approximate Sine
    end subroutine cossin
  end interface
  !
  interface
    subroutine get_sys_code(in,out,sys_code,error)
      use gbl_format
      use image_def
      use gbl_message
      !---------------------------------------------------------------------
      !*
      ! GILDAS  Utility
      !
      ! Get old-system to new-system conversion code.
      ! Trap illegal/impossible conversions.
      !
      ! Caution: ICRS not yet supported here
      !---------------------------------------------------------------------
      type(gildas),    intent(in)  :: in          !! Input header
      type(gildas),    intent(in)  :: out         !! Desired output header
      integer(kind=4), intent(out) :: sys_code    !! Conversion code
      logical,         intent(out) :: error       !! Logical error flag
    end subroutine get_sys_code
  end interface
  !
  interface
    subroutine cct_fft_size(mx,my,nx,ny)
      !*
      ! IMAGER -- Utility routine 
      !   Get best FFT size given the data size
      !!
      integer, intent(in) :: mx,my   !! Data size
      integer, intent(out) :: nx,ny  !! FFT Size
    end subroutine cct_fft_size
  end interface
  !
  interface
    subroutine uvdebug_pointers(name,text,huvl)
      use image_def
      use gbl_message
      !! IMAGER - Debug the Mosaic offset pointers
      character(len=*), intent(in) :: name    !! Caller name
      character(len=*), intent(in) :: text    !! Buffers name
      type (gildas), intent(in) :: huvl       !! UV header
    end subroutine uvdebug_pointers
  end interface
  !
  interface
    subroutine uv_check_mosaic
      use clean_def
      use clean_arrays
      use gbl_message
      !
    end subroutine uv_check_mosaic
  end interface
  !
  interface
    function zant(i,r)
      !*
      ! Return the apparent number of Antenna #i when reference
      ! antenna is #r. Since #r is not in the list of antennas for
      ! which a solution is to be searched, this number
      ! is #i for #i < #r, and #i-1 for #i > #r
      !!
      integer :: zant                   ! intent(out)
      integer, intent(in) :: i  !! Apparent number of antenna #i
      integer, intent(in) :: r  !! Reference antenna number
    end function zant
  end interface
  !
  interface
    subroutine mth_dpotrf (name, uplo, n, a, lda, error)
      character(len=*) :: name           !
      character(len=*) :: uplo           !
      integer :: n                       !
      integer :: lda                     !
      real(8) :: a(lda,*)                !
      logical :: error                   !
    end subroutine mth_dpotrf
  end interface
  !
  interface
    subroutine mth_dpotrs (name, uplo, n, nrhs, a, lda, b, ldb, info )
      character(len=*) :: name           !
      character(len=*) :: uplo           !
      integer :: n                       !
      integer :: nrhs                    !
      integer :: lda                     !
      real(8) :: a(lda,*)                !
      integer :: ldb                     !
      real(8) :: b(ldb,*)                !
      integer :: info
      !
      !  Purpose
      !  =======
      !
      !  DPOTRS solves a system of linear equations A*X = B with a symmetric
      !  positive definite matrix A using the Cholesky factorization
      !  A = U**T*U or A = L*L**T computed by DPOTRF.
      !
      !  Arguments
      !  =========
      !
      !  UPLO    (input) CHARACTER*1
      !          = 'U':  Upper triangle of A is stored;
      !          = 'L':  Lower triangle of A is stored.
      !
      !  N       (input) INTEGER
      !          The order of the matrix A.  N >= 0.
      !
      !  NRHS    (input) INTEGER
      !          The number of right hand sides, i.e., the number of columns
      !          of the matrix B.  NRHS >= 0.
      !
      !  A       (input) DOUBLE PRECISION array, dimension (LDA,N)
      !          The triangular factor U or L from the Cholesky factorization
      !          A = U**T*U or A = L*L**T, as computed by DPOTRF.
      !
      !  LDA     (input) INTEGER
      !          The leading dimension of the array A.  LDA >= max(1,N).
      !
      !  B       (input/output) DOUBLE PRECISION array, dimension (LDB,NRHS)
      !          On entry, the right hand side matrix B.
      !          On exit, the solution matrix X.
      !
      !  LDB     (input) INTEGER
      !          The leading dimension of the array B.  LDB >= max(1,N).
      !
      !  INFO    (output) INTEGER
      !          = 0:  successful exit
      !          < 0:  if INFO = -i, the i-th argument had an illegal value
      !
      logical :: error
      !
      ! Call LAPACK routine
    end subroutine mth_dpotrs
  end interface
  !
  interface
    subroutine mth_dpbtrf (name, uplo, n, kd, ab, ldab, error)
      character(len=*) :: name             !
      character(len=*) :: uplo             !
      integer :: n                         !
      integer :: kd                        !
      integer :: ldab                      !
      real(8) :: ab(ldab,*)                !
      logical :: error                     !
    end subroutine mth_dpbtrf
  end interface
  !
  interface
    subroutine mth_dpbtrs (name, uplo, n, kd, nrhs, ab, ldab, b, ldb, error)
      character(len=*) :: name             !
      character(len=*) :: uplo             !
      integer :: n                         !
      integer :: kd                        !
      integer :: nrhs                      !
      integer :: ldab                      !
      real(8) :: ab(ldab,*)                !
      integer :: ldb                       !
      real(8) :: b(ldb,*)                  !
      logical :: error                     !
    end subroutine mth_dpbtrs
  end interface
  !
  interface
    subroutine mth_fail (fac,prog,ifail,error)
      use gbl_message
      !---------------------------------------------------------------------
      ! Error handling routine
      !---------------------------------------------------------------------
      character(len=*) :: fac           !
      character(len=*) :: prog          !
      integer :: ifail                  !
      logical :: error                  !
    end subroutine mth_fail
  end interface
  !
  interface
    subroutine overlap(a,n,b,m,c,k)
      !
      ! Find the intersection of ensembles A and B
      !
      integer, intent(in) :: n        !! Size of Ensemble A
      integer, intent(in) :: a(n)     !! First Ensemble
      integer, intent(in) :: m        !! Size of Ensemble B
      integer, intent(in) :: b(m)     !! Second Ensemble
      integer, intent(inout) :: k     !! Size of Intersection
      integer, intent(inout) :: c(*)  !! Ensemble Intersection
    end subroutine overlap
  end interface
  !
  interface
    subroutine union(a,n,b,m,c,k)
      !
      !! Find the Union of ensembles A and B
      !
      integer, intent(in) :: n        !! Size of Ensemble A
      integer, intent(in) :: a(n)     !! First Ensemble
      integer, intent(in) :: m        !! Size of Ensemble B
      integer, intent(in) :: b(m)     !! Second Ensemble
      integer, intent(inout) :: k     !! Size of Union
      integer, intent(inout) :: c(*)  !! Ensemble Union
    end subroutine union
  end interface
  !
  interface
    subroutine maxcmp(nx,ny,wl,a)
      !! Maximum of real part of a 2-D complex array
      integer, intent(in) :: nx,ny    !! Array size
      real, intent(in) :: wl(2,nx,ny) !! Complex array
      real, intent(out) :: a    !! Max of real part
    end subroutine maxcmp
  end interface
  !
  interface
    subroutine userc (nv,coords,xref,xval,xinc,yref,yval,yinc)
      integer, intent(in) :: nv                     !
      real(4), intent(out) :: coords(2,nv)          !
      real(8), intent(in) :: xref                   !
      real(8), intent(in) :: xval                   !
      real(8), intent(in) :: xinc                   !
      real(8), intent(in) :: yref                   !
      real(8), intent(in) :: yval                   !
      real(8), intent(in) :: yinc                   !
    end subroutine userc
  end interface
  !
  interface
    subroutine mos_primary (prim,primary,bsize)
      use image_def
      use gkernel_types
      !--------------------------------------------------------------
      !*
      ! IMAGER -- Support routine for MOSAIC
      !
      ! Mosaic and Primary beam support.
      ! Compute a Gaussian primary beam
      !!
      !--------------------------------------------------------------
      type(gildas), intent(in) :: prim         !! Primary beam header
      real, intent(inout) :: primary(prim%gil%dim(1),prim%gil%dim(2)) !! Values
      real, intent(in) :: bsize                !! Primary beam size in radian
    end subroutine mos_primary
  end interface
  !
  interface
    subroutine mos_inverse (n,weight,thre)
      !! IMAGER -- Returns the inverse for the weights for Mosaic
      integer, intent(in) :: n          !! Size of problem
      real, intent(inout) :: weight(n)  !! Weight to be inversed
      real, intent(in) :: thre          !! Threhsold
    end subroutine mos_inverse
  end interface
  !
  interface
    subroutine mos_addsq (n,nf,weight,lobe)
      !! IMAGER -- Increment weights by Square of primary beam
      integer, intent(in) :: n                      !! Size of arrays
      integer, intent(in) :: nf                     !! Number of fields
      real, intent(inout) :: weight(n)              !! Total weight
      real, intent(in) :: lobe(nf,n)                !! Primary beam array
    end subroutine mos_addsq
  end interface
  !
  interface
    subroutine omp_setup
      use omp_control
      !$ use omp_lib
      !
    end subroutine omp_setup
  end interface
  !
  interface
    function ompget_debug_code()
      use omp_control
      logical :: ompget_debug_code    ! Intent(out)
    end function ompget_debug_code
  end interface
  !
  interface
    subroutine mrc_clear
    end subroutine mrc_clear
  end interface
  !
  interface
    subroutine douvext(jc,nv,visi,jx,jy,umin,umax,vmin,vmax)
      !---------------------------------------------------------------------
      !*
      ! IMAGER -- Utility routine
      !
      !   Compute extrema of UV coverage. No assumption,
      !   but may return 0 if all Negative or all Positive
      !!
      !---------------------------------------------------------------------
      integer, intent(in) :: jc         !! Size of a visibility
      integer, intent(in) :: nv         !! Number of visibilities
      integer, intent(in) :: jx         !! X coordinate pointer
      integer, intent(in) :: jy         !! Y coordinate pointer
      real, intent(in) :: visi(jc,nv)   !! Visibilities
      real, intent(out) :: umin,umax    !! U extrema
      real, intent(out) :: vmin,vmax    !! V extrema
    end subroutine douvext
  end interface
  !
  interface
    subroutine uv_addnoise(line,comm,error)
      use gildas_def
      use gbl_message
      use clean_types
      use clean_arrays
      !---------------------------------------------------------------------
      !*
      ! IMAGER -- Support routine for command SIMULATE\ADD_NOISE
      ! 
      !   ADD_NOISE Value [Bandwidth [Wcol]] /FILE InputFile OutputFile
      !!
      !---------------------------------------------------------------------
      character(len=*), intent(in) :: line  !! Command line
      character(len=*), intent(in) :: comm  !! Command name
      logical, intent(inout) :: error       !! Error flag
    end subroutine uv_addnoise
  end interface
  !
  interface
    subroutine uv_free_buffers
      use clean_def
      use clean_arrays
      !---------------------------------------------------------------------
      !*
      ! IMAGER -- Utility routine
      !
      !   Deallocate all UV buffers.
      !!
      !---------------------------------------------------------------------
    end subroutine uv_free_buffers
  end interface
  !
  interface
    subroutine uv_free_init
      use clean_def
      use clean_arrays
      !---------------------------------------------------------------------
      !*
      ! IMAGER -- Utility routine
      !
      !   Deallocate the Initial UV buffer.
      !!
      !---------------------------------------------------------------------
    end subroutine uv_free_init
  end interface
  !
  interface
    subroutine uv_buffer_finduv(code) 
      use clean_arrays
      !! IMAGER -- Find code of current buffer 
      character(len=1), intent(out) :: code
    end subroutine uv_buffer_finduv
  end interface
  !
  interface
    subroutine uv_buffer_resetuv(code) 
      use clean_arrays
      !! IMAGER -- Reset current buffer to the specified code
      character(len=1), intent(in) :: code  !! Code (i,r,s or space) of current buffer
    end subroutine uv_buffer_resetuv
  end interface
  !
  interface
    subroutine discard_uvdata(error)
      use clean_def
      use clean_arrays
      use clean_default
      use clean_types
      use gbl_message
      !! IMAGER -- Discard all UV data
      logical, intent(inout) :: error
    end subroutine discard_uvdata
  end interface
  !
  interface
    subroutine set_buffer_modified(bufnam)
      use clean_types
      !! IMAGER -- Indicate the named buffer has been modified
      character(len=*), intent(in) :: bufnam  !! Buffer name 
    end subroutine set_buffer_modified
  end interface
  !
  interface
    subroutine print_buffer_asso(name,head)
      use image_def
      use clean_default
      character(len=*), intent(in) :: name
      type(gildas), intent(in) :: head
    end subroutine print_buffer_asso
  end interface
  !
  interface
    subroutine diagonal(m,n,r,c)
      integer :: m                      !! First dimension
      integer :: n                      !! Second dimension (=< M)
      real(kind=8) :: r(m,n)            !! Matrix
      real(kind=8) :: c(n)              !! Diagonal vector
    end subroutine diagonal
  end interface
  !
  interface
    subroutine fitfcn(iflag,m,nvpar,x,f,fjac,ljc)
      use gildas_def
      use uvfit_data
      use gbl_message
      !$ use omp_lib
      !---------------------------------------------------------------------
      !! IMAGER -- Support routine for UV_FIT  
      !! FITFCN is called by DNLS1E
      !---------------------------------------------------------------------
      integer, intent(in) :: iflag          !! Code for print out
      integer, intent(in) :: m              !! Number of data points
      integer, intent(in) :: nvpar          !! Number of variables
      real(8), intent(in) :: x(nvpar)       !! Variable parameters
      real(8), intent(out) :: f(m)          !! Function value at each point
      integer, intent(in) :: ljc            !! First dimension of FJAC
      real(8), intent(out) :: fjac(ljc,nvpar) !! Partial derivatives
    end subroutine fitfcn
  end interface
  !
  interface
    subroutine getvisi(n,uvriw,k,u,v,r,i,w)
      !---------------------------------------------------------------------
      !*
      ! IMAGER --  Support routine for UV_FIT
      !
      !     Obtain U, V, and the visibility from the array UVRIW.
      !!
      !---------------------------------------------------------------------
      integer, intent(in) :: n         !! Number of visibilities
      real, intent(in) :: uvriw(5,n)   !! Visibilities
      integer, intent(in) :: k         !! Desired visibility number
      real(8), intent(out) ::  u       !! U coordinate
      real(8), intent(out) ::  v       !! V coordinate
      real(8), intent(out) ::  r       !! Real part
      real(8), intent(out) ::  i       !! Imaginary part
      real(8), intent(out) ::  w       !! Weight
    end subroutine getvisi
  end interface
  !
  interface
    subroutine outpar(id,kfunc,pars,errs)
      !---------------------------------------------------------------------
      !*
      ! IMAGER -- Support routine for UV_FIT
      !
      ! Process fitted parameters to be saved, according to fitted functions
      !!
      !---------------------------------------------------------------------
      integer, intent(in) :: id    !! Function code
      integer, intent(in) :: kfunc !! Number of parameters
      real(8), intent(inout) :: pars(kfunc)  !! Parameters
      real(8), intent(inout) :: errs(kfunc)  !! Uncertainties
    end subroutine outpar
  end interface
  !
  interface
    subroutine uvfit_comm(line,error)
      use iso_fortran_env
      use gbl_message
      use clean_default
      use clean_arrays
      !---------------------------------------------------------------------
      !*
      ! IMAGER -- Support for command UV_FIT   
      !   UV_FIT [Func1 ... FuncN] [/QUIET] 
      !     [/WIDGET Nfunc] [/SAVE File] [/RESULT]
      !     [/UVRANGE Min [Max]]
      !     [/CONTINUUM [Field] [/INDEX Sp] [/RANGE Min Max TYPE]]
      !---------------------------------------------------------------------
      character(len=*), intent(inout) :: line !! Command line
      logical, intent(inout) :: error         !! Error flag
    end subroutine uvfit_comm
  end interface
  !
  interface
    subroutine  uvfit_model(ifunc,kfunc,uu,vv,x,y,dy)
      !---------------------------------------------------------------------
      !*
      ! IMAGER --  Support routine for UV_FIT
      !
      ! Compute a model function.
      !!
      !---------------------------------------------------------------------
      integer, intent(in) :: ifunc       !! Fuction type
      integer, intent(in) :: kfunc       !! Number of parameters
      real(8), intent(in) :: uu          !! U coordinate in arcsec^-1
      real(8), intent(in) :: vv          !! V coordinate in arcsec^-1
      real(8), intent(in) :: x(kfunc)    !! Parameters
      real(8), intent(inout) :: y(2)        !! Function (real, imag.)
      real(8), intent(inout) :: dy(2,kfunc) !! Partial derivatives.
    end subroutine uvfit_model
  end interface
  !
  interface
    function z_exp(x)
      !---------------------------------------------------------------------
      ! protect again underflows in exp(x)
      !---------------------------------------------------------------------
      real(8) :: z_exp                   !! Underflowed Exponential
      real(8) :: x                       !! Argument    
    end function z_exp
  end interface
  !
  interface
    subroutine sub_uvfit_results(line,error)
      use uvfit_data
      use gbl_message
      !---------------------------------------------------------------------
      !* 
      ! IMAGER --  Support for command 
      !     UV_FIT [Func1 ... FuncN] /RESULT
      !
      ! Only works for  
      !  - all functions  
      !  - 1 channel only  
      ! Test functionality only. May disappear at any time...
      !---------------------------------------------------------------------
      character(len=*), intent(in) :: line  !! Command line
      logical, intent(inout) :: error       !! Error flag
    end subroutine sub_uvfit_results
  end interface
  !
  interface
    subroutine get_uvfit_model(nvisi,uu,vv,rr,ii,error)
      use uvfit_data
      !$ use omp_lib
      !---------------------------------------------------------------------
      !* 
      ! IMAGER -- Support for command   
      !     UV_FIT [Func1 ... FuncN] /RESULT
      !!
      !---------------------------------------------------------------------
      integer, intent(in) :: nvisi    !! Number of visibilities
      real, intent(in) :: uu(nvisi)   !! U coordinates
      real, intent(in) :: vv(nvisi)   !! V coordinates
      real, intent(out) :: rr(nvisi)  !! Real part
      real, intent(out) :: ii(nvisi)  !! Imaginary part
      logical, intent(inout) :: error !! Error flag
    end subroutine get_uvfit_model
  end interface
  !
  interface
    subroutine uvmergec (nv,ndx,x,ndz,z,weight,factor,scaleuv)
      use gildas_def
      !------------------------------------------------------------------------
      !*
      ! IMAGER -- Support routine for Continuum handling
      !
      ! Append a Continuum Data set
      !!
      !------------------------------------------------------------------------
      integer(kind=size_length), intent(in) :: nv   !! Number of visibilities
      integer(kind=size_length), intent(in) :: ndx  !!                  !!
      real, intent(inout) :: x(ndx,nv)              !! Merged UV table
      integer(kind=size_length), intent(in) :: ndz  !!
      real, intent(in) :: z(ndz,nv)                 !! Input UV table
      real, intent(in) :: weight                    !! Weight scale factor
      real, intent(in) :: factor                    !! Intensity scale factor
      real, intent(in) :: scaleuv(3)                !! Baseline length scale
    end subroutine uvmergec
  end interface
  !
  interface
    subroutine uvmergef (nv,ndx,x,ndz,z,weight,factor,w1,w2,error)
      use gildas_def
      !------------------------------------------------------------------------
      !*
      ! IMAGER -- Support routine for Continuum handling
      !
      ! Merge two Continuum Data Set: Average visibilities
      !!
      !------------------------------------------------------------------------
      integer(kind=size_length), intent(in) :: nv   !! Number of visibilities
      integer(kind=size_length), intent(in) :: ndx  !!
      real, intent(inout) :: x(ndx,nv)              !! Merged UV table
      integer(kind=size_length), intent(in) :: ndz  !!
      real, intent(in) :: z(ndz,nv)                 !! Input UV table
      real, intent(in) :: weight                    !! Weight scale factor
      real, intent(in) :: factor                    !! Intensity scale factor
      real(8), intent(out) :: w1,w2                 !! Relative weights
      logical, intent(out) :: error                 !! Error flag
    end subroutine uvmergef
  end interface
  !
  interface
    subroutine shouldresample(rname,xnc,xref,xval,xinc, &
      & znc,zref,zval,zinc,ctol, resample,error)
      !
      use gbl_message
      !------------------------------------------------------------------------
      !*
      ! IMAGER -- Support routine for UV_MERGE
      !
      ! Merge two Line Data Set: Average visibilities
      !!
      !------------------------------------------------------------------------
      character(len=*), intent(in) :: rname   !! Command name
      integer(kind=4),intent(in) :: xnc       !! Size of X velocity axis
      real(kind=8),   intent(in) :: xref      !! X reference channel
      real(kind=8),   intent(in) :: xval      !! X Value at reference
      real(kind=8),   intent(in) :: xinc      !! X increment
      integer(kind=4),intent(in) :: znc       !! Size of Z velocity axis
      real(kind=8),   intent(in) :: zref      !! Z reference channel
      real(kind=8),   intent(in) :: zval      !! Z Value at reference
      real(kind=8),   intent(in) :: zinc      !! Z increment
      real(kind=8),   intent(in) :: ctol      !! Match tolerancs
      logical, intent(out) :: resample        !! Should we resample ?
      logical, intent(out) :: error           !! Error flag
    end subroutine shouldresample
  end interface
  !
  interface
    subroutine parabola(x,y,a,b,c) 
      !----------------------------------------------------------------------
      !!  Solve for Y = a + b*x() + c*x()^2
      !----------------------------------------------------------------------
      real, intent(in) :: x(3)
      real, intent(in) :: y(3)
      real, intent(out) :: a,b,c
    end subroutine parabola
  end interface
  !
  interface
    subroutine uvsort_check_fields(hiuv,ioff,joff,itel,sorted)
      use image_def
      !
      type(gildas), intent(in) :: hiuv  !! Input UV header
      integer, intent(in) :: ioff       !! X column pointer
      integer, intent(in) :: joff       !! Y column pointer
      integer, intent(in) :: itel       !! Telescope ID pointer
      logical, intent(out) :: sorted    !! Is data sorted ?
    end subroutine uvsort_check_fields
  end interface
  !
  interface
    subroutine big_stupid_uvsort(uvdata,uvtri,type,error)
      use image_def
      use gbl_message
      !----------------------------------------------------------------------
      ! IMAGER -- Sort an input UV table
      !
      !       Add CC code to implement precession
      !----------------------------------------------------------------------
      character(len=*), intent(in) :: type
      character(len=*), intent(in) :: uvdata,uvtri
      logical, intent(out) :: error
    end subroutine big_stupid_uvsort
  end interface
  !
  interface
    subroutine uvshort_dotrans (a,b,n,m)
      !
      ! Utility routine -- Output table "b" is table "a" transposed in line/column order
      !
      integer, intent(in) :: n,m
      real, intent(in) :: a(n,m)
      real, intent(out) ::  b(m,n)
    end subroutine uvshort_dotrans
  end interface
  !
  interface
    subroutine uvshort_prmult(z,f,nx,ny)
      !*
      ! IMAGER -- Support for UV_SHORT
      !
      ! Update z(nx,ny) table with z*f, calculate in uv plane
      ! Used to multiply by interferometer primary beam
      !
      integer, intent(in) :: nx, ny           !! Problem size
      complex, intent(inout) :: z(nx, ny)     !! Complex values
      real, intent(in) :: f(nx,ny)            !! Multiplication factors 
    end subroutine uvshort_prmult
  end interface
  !
  interface
    subroutine uvshort_dopoint(sdt,data,nd,np,xcol,ycol,old,new)
      use image_def
      use gkernel_types
      !---------------------------------------------------------------------
      !*
      ! IMAGER  --  Support routine for command UV_SHORT
      !
      ! Recompute data(nd,np) xcol and ycol coordinates values
      ! in case of changing reference position a0 d0 from old to new
      !!
      !---------------------------------------------------------------------
      type(gildas), intent(in) :: sdt      !! Single Dish Table
      integer, intent(in) :: nd            !! Size of a spectrum
      integer, intent(in) :: np            !! Number of spectra
      integer, intent(in) :: xcol          !! RA offset pointer
      integer, intent(in) :: ycol          !! Dec offset pointer
      real, intent(inout) :: data(nd,np)   !! Spectra
      real(8), intent(in) :: old(2)        !! Old RA and Dec center
      real(8), intent(in) :: new(2)        !! New Ra and Dec center
    end subroutine uvshort_dopoint
  end interface
  !
end module imager_interfaces_none

subroutine get_clean (method,hbeam,dbeam,error)
  use gkernel_interfaces
  use imager_interfaces, only : fibeam
  use clean_def
  use image_def
  !----------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- Support for FIT and CLEAN
  !
  !   Get Clean beam parameters
  !!
  !----------------------------------------------------------------------
  type (gildas), intent(in) :: hbeam         !! Beam header
  type (clean_par), intent(inout) :: method  !! Clean parameters
  real, intent(in) :: dbeam(hbeam%gil%dim(1),hbeam%gil%dim(2))  !! Beam array
  logical, intent(out) :: error              !! Logical error flag
  !
  ! Local ---
  character(len=12) :: name
  integer :: nx,ny
  !
  ! Code ----
  name = method%method
  if (name.ne.'  ') name='CLEAN'
  !
  ! Use beam patch to search for maximum
  error = .false.
  nx =  hbeam%gil%dim(1)
  ny =  hbeam%gil%dim(2)
  call fibeam (name,dbeam,nx,ny,   &
       &    method%patch(1),method%patch(2),method%thresh,   &
       &    method%major,method%minor,method%angle,   &
       &    hbeam%gil%convert,error)
  !
end subroutine get_clean
!
subroutine pribeam(name,majo,mino,pa, field, plane, jvm)
  use gbl_message
  use imager_interfaces, only : map_message
  !----------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- Print beam characteristics
  !!
  !----------------------------------------------------------------------
  character(len=*), intent(in) :: name  !! Caller name
  real, intent(in) :: majo              !! Beam major axis
  real, intent(in) :: mino              !! Beam minor axis
  real, intent(in) :: pa                !! Beam Position Angle
  integer, intent(in) :: field          !! Field in Mosaic
  integer, intent(in) :: plane          !! Beam plane for Frequency dependent beams
  real, intent(in) :: jvm               !! JvM scale factor
  !
  ! Constants
  real(8), parameter :: pi=3.141592653589793d0
  !
  ! Local ---
  character(len=120) :: mess
  !
  ! Code ----
  if (jvm.gt.0) then
    write(mess,110) 'Beam is ',majo*3600*180/pi,mino*3600*180/pi,pa,  jvm, field, plane
  else  
    write(mess,120) 'Beam is ',majo*3600*180/pi,mino*3600*180/pi,pa, field, plane
  endif
  call map_message(seve%i,name,mess)
  !
  110   format (a,f8.3,'" by ',f8.3,'" at PA ',f5.1,' deg., JvM factor ',f5.2,' Field ',I3,', Channel ',I5)
  120   format (a,f8.3,'" by ',f8.3,'" at PA ',f5.1,' deg. Field ',I3,', Channel ',I5,A,F5.2)
end subroutine pribeam
!
subroutine fibeam (name,dirty,nx,ny,nbx,nby,thre,majo,mino,pa,convert,error)
  use gildas_def
  use gkernel_interfaces
  use imager_interfaces, except_this => fibeam
  use mod_fitbeam
  use gbl_message
  !---------------------------------------------------------------------
  ! @ public
  !*
  ! IMAGER -- Support for FIT and CLEAN commands
  !
  !   Find beam parameters for deconvolution. 
  !   Fit an elliptical gaussian clean beam to main beam
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: name            !! Caller name
  integer, intent(in) :: nx                       !! X size
  integer, intent(in) :: ny                       !! Y size
  real, intent(in) :: dirty(nx,ny)                !! Dirty beam
  integer, intent(in) :: nbx                      !! X patch
  integer, intent(in) :: nby                      !! Y patch
  real, intent(inout) :: thre                     !! Threshold
  real, intent(inout) :: majo                     !! Major axis
  real, intent(inout) :: mino                     !! Minor axis
  real, intent(inout) :: pa                       !! Position Angle
  real(8), intent(in) :: convert(3,2)             !! Axis Conversion formula
  logical, intent(inout) :: error                 !! Logical error flag
  !
  ! Global
  real(8), parameter :: pi=3.141592653589793d0
  ! Local ---
  integer, allocatable :: ipl(:), ipk(:), ipw(:)
  character(len=80) :: mess
  integer :: blc(2),trc(2),ml,nf,mx,my,ier
  real :: dmaj,dmin,fact,minor
  real(8) :: xinc
  logical :: liter
  !
  ! Code ----
  error = .false.
  !
  ! Do nothing if specified
  if (majo.ne.0.0) then
    if (mino.eq.0.0) then
      mino = majo
    endif
    return
  else
    if (mino.ne.0.0) then
      majo = mino
      return
    endif
  endif
  !
  if (dirty(nx/2+1,ny/2+1).le.0.0) then
    error = .true.
    return
  endif
  !
  ! Reset PA to 0 if Axis size is not given
  pa = 0 
  !
  liter = .false.
  mx = patch_size(nbx,nx,6,32)
  my = patch_size(nby,ny,6,32)
  !
  ! Assume beam maximum is near NX/2 NY/2
  blc(1) = nx/2+1-mx
  blc(2) = ny/2+1-my
  mx = 2*mx
  my = 2*my
  trc(1) = blc(1)+mx-1
  trc(2) = blc(2)+my-1
  ! 30 % sidelobes define the main beam
  if (thre.le.0. .or. thre.ge.1.0) thre = 0.30
  !
  ! Load beam patch into work array
  ml = mx*my
  allocate (ip_values(ml), ip_coords(2,ml), ipl(ml), ipk(ml), ipw(ml), stat=ier)
  if (ier.ne.0) then
    write(mess,*) 'Memory allocation error ',ier
    call map_message(seve%e,name,mess)
    error = .true.
    return
  endif
  !
  ! Make a segmentation to define "Main" beam
  ! IPK is used here as a work array...
  call sub_threshold (dirty,nx,ny,blc,trc,ipl,mx,my,   &
     &    nf,ipk,ipw,ml,thre,   &
     &    0.0, -1.0)
  !
  ! Load values and coordinates
  call loadv (dirty,nx,ny,blc,trc,ipl,mx,my,   &
     &    nv,ip_values,ip_coords)
  !
  ! Convert to user coordinates
  xinc = max(abs(convert(3,1)),abs(convert(3,2)))
  call userc (nv,ip_coords,   &
     &    convert(1,1),convert(2,1),convert(3,1)/xinc,   &
     &    convert(1,2),convert(2,2),convert(3,2)/xinc)
  !
  call fast_fit2d(nv,ip_values,ip_coords,spar)
  !
  ! Find initial guesses
  call guess (nv,ip_values,ip_coords,spar)
  err(1) = 0.01*spar(1)
  err(2) = 0.5*abs(convert(3,1)/xinc)
  err(3) = 0.5*abs(convert(3,2)/xinc)
  err(4) = 2.0*err(2)
  err(5) = err(4)
  err(6) = 90.0
  spar(5) = 2.0*sqrt(abs(convert(3,1)*convert(3,2)))/xinc
  spar(4) = 1.5*spar(5)
  spar(6) = pa
  !
  liter = .false.
  call fit2d (min2d,liter,error)
  if (par(4).ge.par(5)) then
    majo = par(4)
    mino = par(5)
    dmaj = err(4)
    dmin = err(5)
    pa = 90.0-par(6)
  else
    majo = par(5)
    mino = par(4)
    dmaj = err(5)
    dmin = err(4)
    pa = -par(6)
  endif
  majo = majo*xinc
  mino = mino*xinc
  dmaj = dmaj*xinc
  dmin = dmin*xinc
  deallocate (ip_values, ip_coords, ipl, ipk, ipw, stat=ier)
  !
  ! Bring PA in [0,180[ range
  if (pa.lt.0) pa = pa+1440.
  pa = mod(pa,180.)
  !
  if (name.eq.' ') return
  !
  minor = mino*3600*180/pi
  if (minor.gt.10.) then
    write(mess,100) 'Beam is ',majo*3600*180/pi,mino*3600*180/pi,pa
    call map_message(seve%i,name,mess)
    write(mess,101) 'Errors (',dmaj*3600*180/pi,dmin*3600*180/pi,err(6)
    call map_message(seve%i,name,mess)
  else if (minor.gt.0.2) then
    write(mess,110) 'Beam is ',majo*3600*180/pi,mino*3600*180/pi,pa
    call map_message(seve%i,name,mess)
    write(mess,111) 'Errors (',dmaj*3600*180/pi,dmin*3600*180/pi,err(6)
    call map_message(seve%i,name,mess)
  else
    write(mess,120) 'Beam is ',majo*3600*180/pi,mino*3600*180/pi,pa
    call map_message(seve%i,name,mess)
    write(mess,121) 'Errors (',dmaj*3600*180/pi,dmin*3600*180/pi,err(6)
    call map_message(seve%i,name,mess)
  endif
  !
  fact = mino/xinc ! nb of pixels per beam, should be < mx/2 for proper fit
  if (fact.gt.min(mx,my)/2) then
    call map_message(seve%w,name,'Large dirty beam, please increase Map Field, Pixel size or Beam patch') 
  endif
  !
  100   format (a,f8.1,'" by ',f8.1,'" at PA ',f8.1,' deg.')
  101   format (a,f8.1,')   (',f8.1,')      (',f8.1,')    ')
  110   format (a,f8.2,'" by ',f8.2,'" at PA ',f8.1,' deg.')
  111   format (a,f8.2,')   (',f8.2,')      (',f8.1,')    ')
  120   format (a,f8.3,'" by ',f8.3,'" at PA ',f8.1,' deg.')
  121   format (a,f8.3,')   (',f8.3,')      (',f8.1,')    ')
end subroutine fibeam
!
subroutine guess (nv,values,coords,par)
  !----------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- Support for FIT or CLEAN commands
  !
  !   Setup starting values for beam fit by find  maximum
  !!
  !----------------------------------------------------------------------
  integer, intent(in)  :: nv           !! Number of data
  real, intent(in)  :: values(nv)      !! Data values
  real, intent(in)  :: coords(2,nv)    !! X and Y coordinates of data
  real, intent(out) :: par(6)          !! Guessed parameters
  !
  ! Local ---
  integer :: ipar,i
  !
  ! Code ----
  ipar = 1
  do i=2,nv
    if (values(i).gt.values(ipar)) then
      ipar = i
    endif
  enddo
  par(1) = values(ipar)    ! Flux
  par(2) = coords(1,ipar)  ! X position
  par(3) = coords(2,ipar)  ! Y position
end subroutine guess
!
subroutine min2d (npar,g,f,var,iflag)
  use gildas_def
  use mod_fitbeam
  use imager_interfaces, only : mn2d
  !------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- Support for FIT of beam minimizing function
  !
  ! Calls another function, exposing additional parameters from
  ! a module.
  !------------------------------------------------------------------
  integer, intent(in) :: npar          !! Number of parameters
  real(8), intent(out)  :: g(npar)     !! First derivatives
  real(8), intent(out)  :: f           !! Function value
  real(8), intent(in)  :: var(npar)    !! Parameter values
  integer, intent(in)  :: iflag        !! Operation code
  !
  call mn2d (npar,g,f,var,iflag,   &
     &    ip_values, ip_coords, nv,   &
     &    sigbas,sigrai)
end subroutine min2d
!
subroutine mn2d (npar,g,f,var,iflag,values,coords,nv,   &
     &    sigbas,sigrai)
  !---------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER --  Support for FIT of beam
  !
  ! Internal routine to support the non linear fit; Returns
  ! the function value, its derivative respective to the fitted parameters
  ! and the rms (on signal and baseline)
  !!
  !---------------------------------------------------------------------
  integer, intent(in) :: npar          !! Number of parameters
  real(8), intent(out)  :: g(npar)     !! First derivatives
  real(8), intent(out)  :: f           !! Function value
  real(8), intent(in)  :: var(npar)    !! Parameter values
  integer, intent(in)  :: iflag        !! Operation code
  integer, intent(in)  :: nv           !! Number of data
  real, intent(in)  :: values(nv)      !! Data values
  real, intent(in)  :: coords(2,nv)    !! X and Y coordinates of data
  real, intent(out)  :: sigbas         !! Baseline noise
  real, intent(out)  :: sigrai         !! On Source noise
  !
  real, parameter :: far=24.0d0
  !
  ! Local ---
  logical :: dograd,dosig
  integer :: i,nrai,nbas
  real :: x,y
  real :: i0, x0,y0,a,b,alpha
  real :: dfx0,dfy0,dfa,dfb,dfalp
  real :: dgx0,dgy0,dga,dgb,dgalp
  real :: dt1x0,dt1y0,dt1alp
  real :: dt2x0,dt2y0,dt2alp
  real :: dgt1,dgt2
  real :: t1,t2, gint, gsxy, gd,gg, ca, sa
  real :: frai, fbas
  !
  if (iflag.eq.3) then
    dosig = .true.
    nbas = 0
    nrai = 0
  else
    dosig = .false.
  endif
  dograd = iflag.eq.2
  !
  ! Setup
  i0 = var(1)
  x0 = var(2)
  y0 = var(3)
  a = var(4)
  b = var(5)
  alpha = var(6)
  dfx0 = 0.0
  dfy0 = 0.0
  dfa = 0.0
  dfb = 0.0
  dfalp = 0.0
  !
  ! Constants
  ca = cos(alpha)
  sa = sin(alpha)
  !
  ! Constant intermediate values for derivatives
  if (dograd) then
    dt1y0 = - sa
    dt1x0 = - ca
    dt2x0 = sa
    dt2y0 = - ca
  else
    dt1y0 = 0
    dt1x0 = 0 
    dt2x0 = 0
    dt2y0 = 0
  endif
  !
  ! Preliminaries
  fbas = 0.0
  frai = 0.0
  gsxy = 0.0
  !
  ! Loop on values
  do i = 1,nv
    y = coords(2,i)
    x = coords(1,i)
    t1 = ca * (x - x0) + sa * (y - y0)
    t2 = - sa * (x - x0) + ca * (y - y0)
    gint = (t1/a)**2 + (t2/b)**2
    !
    ! Skip zero values
    if (gint.ge.far) then
      fbas = fbas+values(i)**2
      if (dosig) nbas = nbas+1
    else
      !
      ! Function
      gg = exp(-gint)
      gd = i0*gg-values(i)
      frai = frai + gd*gd      ! sum of squares
      !
      if (dograd) then
        dt1alp = t2
        dt2alp = - t1
        dgt1 = 2*t1/a/a        ! Sign was reversed
        dgt2 = 2*t2/b/b        ! Sign was reversed
        dga = -t1*dgt1/a
        dgb = -t2*dgt2/b
        dgx0 = dgt1 * dt1x0 + dgt2 * dt2x0
        dgy0 = dgt1 * dt1y0 + dgt2 * dt2y0
        dgalp = dgt1 * dt1alp + dgt2 * dt2alp
        !
        gg = 2*gd*gg
        gsxy = gsxy + gg
        gg = i0*gg
        !
        dfx0 = dfx0 + dgx0*gg
        dfy0 = dfy0 + dgy0*gg
        dfalp = dfalp + dgalp*gg
        dfa = dfa + dga*gg
        dfb = dfb + dgb*gg
      endif
      if (dosig) nrai = nrai+1
    endif
  enddo
  !
  if (dosig) then
    if (nbas.ne.0) then
      sigbas = sqrt (fbas/nbas)
      if (nrai.ne.0) then
        sigrai = sqrt (frai/nrai)
      else
        sigrai = sigbas
      endif
    else
      sigrai = sqrt (frai/nrai)
      sigbas = sigrai
    endif
  endif
  f = fbas+frai
  if (.not.dograd) return
  !
  g(1) = gsxy/i0
  g(2) = -dfx0
  g(3) = -dfy0
  g(4) = -dfa
  g(5) = -dfb
  g(6) = -dfalp
end subroutine mn2d
!
subroutine fit2d (fcn,liter,error)
  use gildas_def
  use gkernel_interfaces
  use imager_interfaces, except_this => fit2d
  use fit_minuit
  use mod_fitbeam
  !---------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- Support for FIT of beam
  !
  !   Setup and starts a GAUSS fit minimisation using MINUIT
  !!
  !---------------------------------------------------------------------
  external :: fcn                     !!   Function to be minimized
  logical, intent(in) :: liter        !!   Iterate ?
  logical, intent(out) :: error       !!   Logical error flag
  !
  ! Constant
  real(8), parameter :: pi=3.141592653589793d0
  ! Local ---
  integer :: i,k,l,ifatal,ier
  real(8):: dx, al, ba, du1, du2
  type(fit_minuit_t) :: fit
  !
  ! Code ----
  error = .false.
  fit%maxext=ntot
  fit%maxint=nvar
  fit%isyswr=6
  fit%verbose = .false.
  fit%owner = gpack_get_id('imager',.true.,error)  ! .false. because can be called from tasks
  if (error)  return
  !
  ! Initialise values
  call mid2d(fit,ifatal,liter)
  if (ifatal.ne.0) then
    error = .true.
    return
  endif
  call intoex(fit,fit%x)
  call fcn(fit%npar,fit%g,fit%amin,fit%u,3)
  ! write(6,*) 'SIGMAS ',sigbas,sigrai
  fit%up = sigbas**2
  fit%nfcnmx  = 5000
  fit%epsi  = 0.1d0 * fit%up
  fit%newmin  = 0
  fit%itaur  = 0
  fit%isw(1)  = 0
  fit%isw(3)  = 1
  fit%nfcn = 1
  fit%vtest  = 0.04
  call intoex(fit,fit%x)
  call fcn(fit%npar,fit%g,fit%amin,fit%u,1)
  !
  ! Simplex Minimization
  if (.not.liter) then
    call simplx(fit,fcn,ier)
    if (ier.ne.0) then
      error = .true.
      return
    endif
    do k=1,fit%nu
      par(k) = fit%u(k)
    enddo
  endif
  !
  ! Gradient Minimization
  fit%nfcnmx  = 5000
  call intoex(fit,fit%x)
  call fcn(fit%npar,fit%g,fit%amin,fit%u,3)
  ! write(6,*) 'SIGMAS ',sigbas,sigrai
  fit%up = sigbas**2
  fit%epsi  = 0.1d0 * fit%up
  fit%apsi  = fit%epsi
  call hesse(fit,fcn)
  call migrad(fit,fcn,ier)
  if (ier.ne.0) then
    call intoex(fit,fit%x)
    call fcn(fit%npar,fit%g,fit%amin,fit%u,3)
    ! write(6,*) 'SIGMAS ',sigbas,sigrai
    fit%up = sigbas**2
    fit%epsi = 0.1d0 * fit%up
    fit%apsi = fit%epsi
    call hesse(fit,fcn)
    call migrad(fit,fcn,ier)
    error=.false.
  endif
  !
  ! Print Results
  do k=1,fit%nu
    par(k) = fit%u(k)
  enddo
  call intoex(fit,fit%x)
  call fcn(fit%npar,fit%g,fit%amin,fit%u,3)
  fit%up = sigbas**2
  !
  ! Calculate External Errors
  do i=1,fit%nu
    l  = fit%lcorsp(i)
    if (l .eq. 0)  then
      fit%werr(i)=0.
    else
      if (fit%isw(2) .ge. 1)  then
        dx = dsqrt(dabs(fit%v(l,l)*fit%up))
        if (fit%lcode(i) .gt. 1) then
          al = fit%alim(i)
          ba = fit%blim(i) - al
          du1 = al + 0.5d0 *(dsin(fit%x(l)+dx) +1.0d0) * ba - fit%u(i)
          du2 = al + 0.5d0 *(dsin(fit%x(l)-dx) +1.0d0) * ba - fit%u(i)
          if (dx .gt. 1.0d0)  du1 = ba
          dx = 0.5d0 * (dabs(du1) + dabs(du2))
        endif
        fit%werr(i) = dx
      endif
    endif
  enddo
  !
  ! Setup results
  par(1) = fit%u(1)
  err(1) = fit%werr(1)
  par(2) = fit%u(2)
  err(2) = fit%werr(2)
  par(3) = fit%u(3)
  err(3) = fit%werr(3)
  par(4) = 2.0*sqrt(log(2.0))*fit%u(4)
  err(4) = 2.0*sqrt(log(2.0))*fit%werr(4)
  par(5) = 2.0*sqrt(log(2.0))*fit%u(5)
  err(5) = 2.0*sqrt(log(2.0))*fit%werr(5)
  par(6) = fit%u(6)*180.0/pi
  err(6) = fit%werr(6)*180.0/pi
end subroutine fit2d
!
subroutine mid2d(fit,ifatal,liter)
  use gildas_def
  use gkernel_interfaces
  use mod_fitbeam
  use fit_minuit
  !---------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER --  Support for FIT of beam
  !
  !   Start a gaussian fit by building the PAR array and internal
  !   variable used by Minuit
  !---------------------------------------------------------------------
  type(fit_minuit_t), intent(inout) :: fit    !! Fitting variables
  integer, intent(out) :: ifatal              !! Error code
  logical, intent(in) :: liter                !! Iterate ?
  !
  ! Constants
  real(8), parameter :: pi=3.141592653589793d0
  real, parameter :: sln2=2.0*sqrt(log(2.0))
  !
  ! Local ---
  integer :: i, nint, k
  real(8) :: sav, sav2, vplu, vminu, xx, tmp8
  !
  ! Code ----
  do i= 1, 7
    fit%isw(i) = 0
  enddo
  fit%sigma = 0.d0
  fit%npfix = 0
  nint = 0
  fit%nu = 0
  fit%npar = 0
  ifatal = 0
  do i= 1, fit%maxext
    fit%u(i) = 0.0d0
    fit%lcode(i) = 0
    fit%lcorsp (i) = 0
  enddo
  fit%isw(5) = 1
  !
  ! Starting values
  par(1) = spar(1)             ! Intensite
  fit%u(1) = par(1)
  if (kpar(1).eq.1) then
    fit%werr(1)=0.
  else
    fit%werr(1) = abs(0.1*fit%u(1))
    ! if (liter) fit%werr(1) = err(1)
    if (fit%u(1).lt.0) then
      fit%alim(1) = 10.*fit%u(1)
      fit%blim(1) = 0.1*fit%u(1)
    else
      fit%blim(1) = 10.*fit%u(1)
      fit%alim(1) = 0.1*fit%u(1)
    endif
  endif
  !
  par(2) = spar(2)             ! X Position
  fit%u(2) = par(2)
  if (kpar(2).eq.1) then
    fit%werr(2)=0.
  else
    fit%werr(2) = err(2)
    fit%alim(2) = fit%u(2) - 40.*fit%werr(2)
    fit%blim(2) = fit%u(2) + 40.*fit%werr(2)
  endif
  !
  par(3) = spar(3)             ! Y Position
  fit%u(3) = par(3)
  if (kpar(3).eq.1) then
    fit%werr(3)=0.
  else
    fit%werr(3) = err(3)
    fit%alim(3) = fit%u(3) - 40.*fit%werr(3)
    fit%blim(3) = fit%u(3) + 40.*fit%werr(3)
  endif
  !
  par(4) = spar(4) / sln2      ! Major axis
  fit%u(4) = par(4)
  if (kpar(4).eq.1) then
    fit%werr(4)=0.
  else
    fit%werr(4) = err(4) / sln2
    fit%alim(4) = fit%werr(4)/ 9.0
    fit%blim(4) = 100.0*err(4)
  endif
  !
  par(5) = spar(5) / sln2      ! Minor axis
  fit%u(5) = par(5)
  if (kpar(5).eq.1) then
    fit%werr(5)=0.
  else
    fit%werr(5) = fit%werr(4)
    fit%alim(5) = fit%alim(4)
    fit%blim(5) = fit%blim(4)
  endif
  !
  par(6) = spar(6)*pi/180.0    ! Position Angle
  fit%u(6) = par(6)
  if (kpar(6).eq.1) then
    fit%werr(6)=0.
  else
    fit%werr(6) = 0.3*err(6)*pi/180.0
    fit%alim(6) = fit%u(6)-1.5*pi
    fit%blim(6) = fit%u(6)+1.5*pi
  endif
  !
  fit%nu = 6
  !
  ! Various checks
  do k= 1, fit%nu
    if (k .gt. fit%maxext)  then
      ifatal = ifatal + 1
    elseif (fit%werr(k) .le. 0.0d0) then
      ! Fixed parameter
      fit%lcode(k) = 0
      write(6,1010) k,' is fixed'
    else
      ! Variable parameter
      nint = nint + 1
      if (fit%lcode(k).ne.1) then
        fit%lcode(k) = 4
        xx = (fit%blim(k)-fit%u(k))*(fit%u(k)-fit%alim(k))
        if (xx.lt.0d0) then
          ifatal = ifatal + 1
          write (fit%isyswr,1011) k,fit%alim(k),fit%blim(k)
        elseif (xx.eq.0d0) then
          if (k.gt.3) write(6,1010) k,' is at limit'
        endif
      endif
    endif
  enddo
  !
  ! End parameter cards
  ! Stop if fatal error
  if (nint .gt. fit%maxint)  then
    write (fit%isyswr,1008)  nint,fit%maxint
    ifatal = ifatal + 1
  endif
  if (nint .eq. 0) then
    write (fit%isyswr,1009)
    ifatal = ifatal + 1
  endif
  if (ifatal .gt. 0)  then
    write (fit%isyswr,1013)  ifatal
    return
  endif
  !
  ! O.K. Start
  ! Calculate step sizes DIRIN
  fit%npar = 0
  do k= 1, fit%nu
    if (fit%lcode(k) .gt. 0)  then
      fit%npar = fit%npar + 1
      fit%lcorsp(k) = fit%npar
      sav = fit%u(k)
      tmp8 = pintf(fit,sav,k)
      fit%x(fit%npar) = tmp8
      fit%xt(fit%npar) = tmp8 ! fit%x(fit%npar)
      sav2 = sav + fit%werr(k)
      vplu = pintf(fit,sav2,k) - fit%x(fit%npar)
      sav2 = sav - fit%werr(k)
      vminu = pintf(fit,sav2,k) - fit%x(fit%npar)
      fit%dirin(fit%npar) = 0.5d0 * (dabs(vplu) +dabs(vminu))
    endif
  enddo
  return
  !
  1008  format (' Too many variable parameters.  You request ',i5/,   &
     &    ' This version of MINUIT is only dimensioned for ',i4)
  1009  format (' All input parameters are fixed')
  1010  format (' Warning - Parameter ',i2,' ',a)
  1011  format (' Error - Parameter ',i2,' outside limits ',1pg11.4,1x,   &
     &    1pg11.4)
  1013  format (1x,i3,' Errors on input parameters. ABORT.')
end subroutine mid2d
!
subroutine userc (nv,coords,xref,xval,xinc,yref,yval,yinc)
  integer, intent(in) :: nv                     !
  real(4), intent(out) :: coords(2,nv)          !
  real(8), intent(in) :: xref                   !
  real(8), intent(in) :: xval                   !
  real(8), intent(in) :: xinc                   !
  real(8), intent(in) :: yref                   !
  real(8), intent(in) :: yval                   !
  real(8), intent(in) :: yinc                   !
  ! Local
  integer :: i
  !
  do i=1,nv
    coords(1,i) = (coords(1,i)-xref)*xinc+xval
    coords(2,i) = (coords(2,i)-yref)*yinc+yval
  enddo
end subroutine userc
!
subroutine loadv (image,nx,ny,blc,trc,label,mx,my,   &
     &    nv,values,coords)
!---------------------------------------------------------
! @ private
!*
! IMAGER -- Support for FIT of beam
!
!   Load the values from the region around the peak
!   of the primary beam (assumed centered).
!!
!---------------------------------------------------------
  integer, intent(in) :: nx                 !! X size
  integer, intent(in) :: ny                 !! Y size
  real(4), intent(in) :: image(nx,ny)       !! Image
  integer, intent(in) :: blc(2)             !! BLC
  integer, intent(in) :: trc(2)             !! TRC
  integer, intent(in) :: mx                 !! Output X size
  integer, intent(in) :: my                 !! Output Y size
  integer, intent(in) :: label(mx,my)       !! Field identification
  integer, intent(out) :: nv                !! Number of values
  real(4), intent(out) :: values(mx*my)     !! Selected values
  real(4), intent(out) :: coords(2,mx*my)   !! X and Y pixel numbers
  !
  ! Local
  integer :: i,j,ii,jj,label0
  !
  ! Note : since VALUES is loaded sequentially after LABEL is explored
  ! VALUES and LABEL may point to the same address, but it is
  ! not recommended...
  !
  label0 = label(mx/2+1,my/2+1)
  nv = 0
  do j=1,my
    do i=1,mx
      if (label(i,j).eq.label0) then
        nv = nv+1
        ii = blc(1)+i-1
        jj = blc(2)+j-1
        values(nv) = image(ii,jj)
        coords(1,nv) = ii
        coords(2,nv) = jj
      endif
    enddo
  enddo
end subroutine loadv
!
subroutine sub_threshold (image,nx,ny,blc,trc,labelo,mx,my,   &
     &    nf,labeli,labelf,mf,thre,   &
     &    blank, eblank)
  use imager_interfaces, only : descen
  !---------------------------------------------------------------------
  ! @ private
  !
  ! IMAGER -- Support for FIT of beam
  !
  !   Divide an image in connex labelled areas above (or below)
  !   a given threshold
  !!
  !---------------------------------------------------------------------
  integer, intent(in) :: nx                !! X size
  integer, intent(in) :: ny                !! Y size
  real(4), intent(in) :: image(nx,ny)      !! Image
  integer, intent(in) :: blc(2)            !! BLC
  integer, intent(in) :: trc(2)            !! TRC
  integer, intent(in) :: mx                !! Output X size
  integer, intent(in) :: my                !! Output Y size
  integer, intent(out) :: labelo(mx,my)    !! Field identification
  integer, intent(out) :: nf               !! Number of fields
  integer, intent(in) :: mf                !! Maximum number of fields
  integer, intent(out) :: labeli(mf)       !! work area: intermediate numbers
  integer, intent(out) :: labelf(mf)       !! Final field number
  real(4), intent(in) :: thre              !! Threshold for field id
  real(4), intent(in) :: blank             !! Blanking value
  real(4), intent(in) :: eblank            !! Tolerance on blanking
  !
  ! Local ---
  integer :: nfi,jj,ii,j,i,l1,l2,la1,la2,la,ifield,jfield
  !
  ! Code ----
  nfi=0
  j = 0
  l1 = 0
  l2 = 0
  do jj=blc(2),trc(2)
    j = j+1
    i = 0
    do ii=blc(1),trc(1)
      i = i+1
      if (image(ii,jj).lt.thre .and. thre.gt.0) then
        labelo(i,j) = 0
      else if (image(ii,jj).gt.thre .and. thre.lt.0) then
        labelo(i,j) = 0
      else if (abs(image(ii,jj)-blank).le.eblank) then
        labelo(i,j) = 0
      else
        labelo(i,j) = 0
        if (i.ne.1) then
          l1 = labelo(i-1,j)
          if (l1.ne.0) labelo(i,j)=l1
        endif
        if (j.ne.1) then
          l2=labelo(i,j-1)
          if (l1.eq.0) then
            if (l2.eq.0) then
              nfi=nfi+1
              labeli(nfi)=nfi
              labelo(i,j)=nfi
            else
              labelo(i,j)=l2
            endif
          else
            if (l2.ne.0) then
              if (l2.ne.l1) then
                call descen (labeli,l1,la1)
                call descen (labeli,l2,la2)
                la = min0(la1,la2)
                labeli(la1)=la
                labeli(la2)=la
                labelo(i,j)=la
              endif
            endif
          endif
        endif
      endif
    enddo
  enddo
  nf=0
  do ifield = 1,nfi
    call descen (labeli,ifield,jfield)
    if (ifield.eq.jfield) then
      nf = nf+1
      labelf(ifield) = nf
    endif
  enddo
  do j=1,my
    do i=1,mx
      l1 = labelo(i,j)
      if (l1.ne.0) then
        call descen (labeli,l1,la1)
        labelo(i,j) = labelf (la1)
      endif
    enddo
  enddo
end subroutine sub_threshold
!
subroutine descen(label,labin,labout)
  !----------------------------------------------------
  ! @ private
  !   Identify connex areas and propagate label
  !----------------------------------------------------
  integer, intent(in) :: label(*)     ! Labels
  integer, intent(in) :: labin        ! Starting label
  integer, intent(out) :: labout      ! Ending label
  ! Local
  integer :: lab
  !
  labout = labin
  do
    lab = label(labout)
    if (lab.eq.labout) return
    labout = lab
  enddo
end subroutine descen
!
subroutine fast_fit2d(nv,values,coords,spar)
  !----------------------------------------------------
  ! @ private
  !*
  !   IMAGER  -- Utility routine 
  !
  ! Fast Gaussian fit
  ! Anthony & Granick 2009, Langmuir 2009, 25(14),8152–8160
  !
  !   Vaut pas grand chose: ne traite pas l orientation...
  !
  ! Methode de la covariance bi-dim: une Gaussienne est définie par
  ! sa matrice de covariance
  !
  ! p(X) = 1/(2.pi.|C|) exp[ -1/2 (X-mu)^ C (X-mu) ]
  !
  ! where mu is the Centroid vector, 
  !   C is the correlation matrix
  ! and the quantity within brackets is the dot product of X(-mu) by
  ! its transform through matrix C.
  !
  ! The covariance matrix can be taken from the data as  
  !  Cov_xx = Sum_ij (i-m_i)**2*p(i,j)  
  !  Cov_xy = Cov_yx = Sum_ij ((i-m_i)*(i-m_j)*p(i,j)  
  !  Cov_yy = Sum_ij (j-m_j)**2*p(i,j)  
  ! with p(i,j) normalized to a total sum of 1, and  
  !  m_i = Sum_ij (i*p(i,j))  
  !  m_j = Sum_ij (j%p(i,j))  
  !
  ! It works well if the noise is low enough...
  !!
  !-----------------------------------------------------
  integer, intent(in) :: nv          !! Number of selected pixels
  real, intent(in) :: values(nv)     !! Pixel values
  real, intent(in) :: coords(2,nv)   !! Pixel coordinates
  real, intent(inout) :: spar(6)     !! Symmetric matrix
  !
  real :: cov_xx, cov_xy, cov_yy
  real :: m_x, m_y, s
  integer :: iv
  !
  m_x = 0
  m_y = 0
  s = 0
  do iv = 1,nv
    m_x = m_x + coords(1,iv)*values(iv)
    m_y = m_y + coords(2,iv)*values(iv)
    s = s+values(iv)
  enddo
  s = 1./s
  !
  cov_xx = 0
  cov_xy = 0
  cov_yy = 0
  do iv=1,nv
    cov_xx = cov_xx + (coords(1,iv)-m_x)**2 * values(iv) * s
    cov_yy = cov_yy + (coords(2,iv)-m_y)**2 * values(iv) * s
    cov_xy = cov_xy + (coords(1,iv)-m_x)*(coords(2,iv)-m_y) * values(iv) * s
  enddo
  !
!  minor = Sqrt[1/2 (cov_xx + cov_yy - Sqrt[a^2 + 4 b^2 - 2 a c + c^2])],
!  major = Sqrt[1/2 (cov_xx + cov_yy + Sqrt[a^2 + 4 b^2 - 2 a c + c^2])]}], 
  !
  ! The matrix is something like
  ! Major 0     times   cos(PA) sin(PA)
  ! 0 Minor            -sin(PA) cos(PA)
  !
  ! i.e.
  !   Major cos(PA)    Major sin(PA) + Minor cos(PA)
  !   M sin(PA) + 
  ! etc... to be developped...
end subroutine fast_fit2d
! 
function patch_size(patch,size,maxr,minv)
  ! @ private
  !! IMAGER -- Define the Beam Patch size for Beam fitting ?
  !
  integer :: patch_size ! Intent(out)
  integer, intent(in) :: patch  !! Input patch size
  integer, intent(in) :: size   !! Image size 
  integer, intent(in) :: maxr   !! Maximum compression factor
  integer, intent(in) :: minv   !! Minimum patch size
  !
  patch_size = size/maxr
  if (patch.ne.0) patch_size = min(patch,size/maxr)
  patch_size = max(patch_size,minv)
end function patch_size

subroutine get_gildas(rname,cinp,desc,hin,error)
  use gkernel_types
  use gkernel_interfaces
  use gbl_message
  use imager_interfaces, only : map_message
  !---------------------------------------------------------------------
  ! @ public
  !*
  ! IMAGER  -- GILDAS tool  
  !   General tool to incarnate the SIC variable into a Gildas 
  !   derived type Fortran variable
  !!
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: rname           !! Input caller name
  character(len=*), intent(in) :: cinp            !! Input variable name
  type(sic_descriptor_t), intent(out) :: desc     !! Descriptor
  type(gildas), intent(inout) :: hin              !! Gildas header 
  logical, intent(inout) :: error                 !! Error flag 
  !
  ! Local ---
  logical :: found
  !
  ! Code ----
  !
  ! Look at the SIC variable
  call sic_descriptor(cinp,desc,found)  
  if (.not.found) then
    call map_message(seve%e,rname,'No such SIC variable '//cinp)
    error = .true.
    return
  endif
  !
  ! If the descriptor is here, copy the Header in HIN
  if (.not.associated(desc%head)) then
    call map_message(seve%w,rname,  &
      'Variable '//trim(cinp)//' does not provide a header')
    call gildas_null(hin)
    ! This will be a simple Table
    hin%gil%form = desc%type              ! Variable type
    hin%gil%ndim = desc%ndim
    hin%gil%dim(1:desc%ndim) = desc%dims(1:desc%ndim)
  else
    !
    ! Locate the header - data area is given by desc%addr
    if (abs(desc%head%gil%type_gdf).eq.abs(code_gdf_uvt)) then
      call gildas_null(hin,type='UVT')
    else
      call gildas_null(hin)
    endif
    call gdf_copy_header(desc%head,hin,error)
  endif
end subroutine get_gildas
!
subroutine specify_comm(line,error)
  use gkernel_interfaces
  use imager_interfaces, only : map_message 
  use phys_const
  use clean_arrays
  use clean_types
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER   -- Support for command SPECIFY [Buffer|File|*] KeyWord Value
  !!
  !---------------------------------------------------------------------
  character(len=*), intent(inout) :: line  !! Command line
  logical, intent(out) :: error            !! Logical error flag
  !
  ! Constants
  integer, parameter :: o_for=1
  character(len=*), parameter :: rname = 'SPECIFY'
  integer, parameter :: icode_uv=1, icode_dirty=2, icode_clean=3, icode_sky=4, icode_all=5
  integer, parameter :: code_blank=0, code_scale=1
  integer, parameter :: nterm=7
  integer, parameter :: ncode=5
  character(len=12) :: cunits(5),lunits(5)
  data cunits /'K           ','JY/BEAM     ','JY/PIXEL    ','MJY/STERADIA','MJY/SR      '/
  data lunits /'K           ','Jy/beam     ','Jy/pixel    ','MJy/Steradia','MJy/Sr      '/
  character(len=12) :: term(nterm)
  data term/'FREQUENCY', 'LINENAME', 'TELESCOPE', 'VELOCITY','BLANKING', 'SPECUNIT', 'UNIT'/
  !
  ! Local ---
  character(len=varname_length) :: arg
  character(len=filename_length) :: fich
  character(len=8) :: ctype, ounit
  character(len=12) :: chain,key,cline,clines(ncode), spec_type
  integer :: i, iterm, narg, nc, nf, ista, iopt
  real(8) :: freq, freq_a,freq_b,value(3)
  real(4) :: velo, bval
  real(8) :: freqs(ncode)
  real(4) :: velos(ncode)
  logical :: do_freq, do_line, do_velo, do_freqs, do_blank, do_odd, found, err
  logical :: do_uv, do_dirty, do_clean, do_sky, do_one, do_cont, do_spec, do_unit, do_file
  type(sic_descriptor_t) :: desc, descuv   ! Descriptor
  type(gildas) :: hin, hou
  integer :: iloop, nblock, new_nhb, ier
  real, allocatable :: din(:,:)
  real :: fact, fact_k, fact_u
  !
  ! Code ---
  freq = 0.d0
  velo = -1.e9                     ! An impossible velocity
  do_freq = .false.
  do_line = .false.
  do_velo = .false.
  do_dirty = .false.
  do_clean = .false.
  do_sky = .false.
  do_uv = .false.
  do_blank = .false.
  do_freqs = .false.
  do_cont = .false.  ! Continuum image
  do_spec = .false.
  do_unit = .false.
  !
  do_one = sic_present(o_for,0)
  ! Odd number of arguments ?
  narg = sic_narg(0)
  do_odd = mod(narg,2).eq.1
  if (do_one) then
    if (do_odd) then
      call map_message(seve%e,'SPECIFY','deprecate /FOR option is invalid in this context')
      iopt = 0
      ista = 2
    else
      call map_message(seve%w,'SPECIFY','option /FOR is deprecated, converting to alternate syntax')
      iopt = o_for
      ista = 1
    endif
  else if (do_odd) then
    iopt = 0
    ista = 2
    do_one = .true.
  else
    ista = 1
  endif
  if (do_one) then
    ! Get variable or file name - First argument (of command or deprecated /FOR option)
    call sic_ch(line,iopt,1,fich,nf,.true.,error)
    if (error) return
    if (index(fich,'.').ne.0) then
      do_file = .true.
    else if (fich.eq.'*') then
      do_one = .false.
    else
      call sic_upper(fich)
      do_file = .false.
    endif
  endif
  !
  ! * argument (implicitely if an even number of arguments)
  if (.not.do_one) then
    do_file = .false.
    if (hcont%loca%size.ne.0) do_cont = .true.
    if (hdirty%loca%size.ne.0) then
      freq = hdirty%gil%freq
      velo = hdirty%gil%voff
      cline = hdirty%char%line
      clines(icode_dirty) = hdirty%char%line
      freqs(icode_dirty) = freq
      velos(icode_dirty) = velo
      do_dirty = .true.
    endif
    if (hclean%loca%size.ne.0) then
      freq = hclean%gil%freq
      velo = hclean%gil%voff
      cline = hclean%char%line
      clines(icode_clean) = hclean%char%line
      freqs(icode_clean) = freq
      velos(icode_clean) = velo
      do_clean = .true.
    endif
    if (hsky%loca%size.ne.0) then
      freq = hsky%gil%freq
      velo = hsky%gil%voff
      cline = hsky%char%line
      clines(icode_sky) = hsky%char%line
      freqs(icode_sky) = freq
      velos(icode_sky) = velo
      do_sky = .true.
    endif
    !
    ! UV data must be last, to be pre-dominant in case a new UV
    ! table has been read, but Images are not yet recomputed.
    !
    ! Some warning should be given then
    if (huv_current%loca%size.ne.0) then
      if (freq.ne.0 .and. abs(freq-huv_current%gil%freq).gt.1.d0) then  ! MHz
        call map_message(seve%w,rname,'Images and UV data have different frequencies')
      endif
      freq = huv_current%gil%freq
      if (velo.ne.-1e9 .and. abs(velo-huv_current%gil%voff).gt.1.d-3) then ! km/s
        call map_message(seve%w,rname,'Images and UV data have different velocity frames')
      endif
      velo = huv_current%gil%voff
      cline = huv_current%char%line
      clines(icode_uv) = huv_current%char%line
      freqs(icode_uv) = freq
      velos(icode_uv) = velo
      do_uv = .true.
    endif
  endif
  !
  do i = ista, narg, 2
    call sic_ke(line,0,i,chain,nc,.true.,error)
    if (error) return
    call sic_ambigs(rname,chain,key,iterm,term,nterm,error)
    if (error) return
    !
    select case (key)
    case ('FREQUENCY')
      call sic_ke(line,0,i+1,arg,nc,.true.,error)
      if (error) return
      !
      ! Look at the SIC variable holding the Frequencies
      call sic_descriptor(arg,desc,found)
      if (.not.found) then
        ! A plain number
        call sic_r8(line,0,i+1,freq,.true.,error)
        if (error) return
        do_freq = .true.
      else if (desc%type.ne.fmt_r8) then
        call map_message(seve%e,rname,'SIC variable '//arg(1:nc)//' is not DOUBLE')
        error = .true.
        return
      else if (desc%size.eq.2) then
        ! Check if size is a single 64-bit word
        call sic_r8(line,0,i+1,freq,.true.,error)
        if (error) return
        do_freq = .true.
      else if (sic_narg(0).ne.2) then
        call map_message(seve%e,rname,'SPECIFY FREQUENCY FreqListArray is exclusive of other actions')
        error =.true.
        return
      else
        call map_message(seve%i,rname,'Setting per-channel frequencies from '//arg(1:nc))
        do_freqs = .true.
      endif
      !
    case ('VELOCITY')
      ! Modify Frequency scale according to new velocity (km/s)
      call sic_r4(line,0,i+1,velo,.true.,error)
      do_velo = .true.
      !
    case ('LINENAME')
      call sic_ch(line,0,i+1,cline,nc,.true.,error)
      do_line = .true.
      !
    case ('TELESCOPE')
      if (narg.gt.2) then
        call map_message(seve%e,rname,'TELESCOPE keyword is exclusive of other keywords')
        error = .true.
        return
      endif
      call sic_ke(line,0,i+1,chain,nc,.true.,error)
      if (error) return
      !
      if (do_one) then
        if (do_file) then
          call map_message(seve%e,rname,'SPECIFY TELESCOPE not yet supported for file')
          error = .true.
          return
        else
          arg = fich
          !
          ! Look at the SIC variable
          call sic_descriptor(fich,desc,found)
          if (.not.found) then
            call map_message(seve%e,rname,'No such SIC variable '//arg(1:nc))
            error = .true.
            return
          endif
          !
          ! There must be a Header in the descriptor...
          if (.not.associated(desc%head)) then
            call map_message(seve%w,rname,  &
              'Variable '//arg(1:nc)//' does not provide a header')
            error = .true.
            return
          endif
          call gdf_setteles(desc%head,chain(1:nc),value,error)
        endif
      else
        !
        ! Update current UV and Initial UV data set if needed
        if (do_uv) then
          if (huv_current%gil%nteles.ge.1) then
            if (huv_current%gil%teles(1)%ctele .ne. chain(1:nc)) then
              call map_message(seve%i,rname,'Telescope ' &
              & //trim(huv_current%gil%teles(1)%ctele) &
              & //' in UV data overwritten by SPECIFY TELESCOPE '//chain(1:nc)) 
              ! Undefine the telescope so that all characteristics
              ! are re-defined by gdf_addteles after
              huv_current%gil%teles(1)%ctele = ' '
              huv_init%gil%teles(1)%ctele = ' '
            endif
          endif
          call gdf_addteles(huv_current,'TELE',chain(1:nc),value,error)
          call gdf_addteles(huv_init,'TELE',chain(1:nc),value,error)
        endif
        if (do_dirty) call gdf_setteles(hdirty,chain(1:nc),value,error)
        if (do_clean) call gdf_setteles(hclean,chain(1:nc),value,error)
        if (do_cont) call gdf_setteles(hcont,chain(1:nc),value,error)
        if (do_dirty) call gdf_setteles(hdirty,chain(1:nc),value,error)
      endif
      return
      !
    case ('BLANKING','SPECUNIT','UNIT')
      if (narg-ista.ne.1) then
        call map_message(seve%e,rname,'SPECIFY '//trim(key)//' is exclusive of other actions')
        error =.true.
      endif
      if (.not.do_one) then
        call map_message(seve%e,rname,'SPECIFY '//trim(key)//' requires a Buffer name')
        error =.true.
      endif
      if (error) return
      call sic_ke(line,0,i+1,arg,nc,.true.,error)
      !
      if (key.eq.'BLANKING') then
        call sic_r4(line,0,i+1,bval,.true.,error)
        if (error) return
        do_blank = .true.
      else if (key.eq.'SPECUNIT') then
        call sic_ambigs(rname,arg,spec_type,nc,['FREQUENCY ','VELOCITY  '],2,error)
        do_spec = .true.
      else if (key.eq.'UNIT') then
        call sic_ambigs(rname,arg,spec_type,nc, cunits, 5, error)
        do_unit = .true.
        spec_type = lunits(nc)
      endif
      if (error) return
    end select
    if (error) return
  enddo
  !
  ! FREQUENCY Array case, very specific
  if (do_freqs) then
    ! 
    ! Look at the SIC variable holding the Frequencies
    call sic_descriptor(arg,desc,found)  
    if (.not.found) then
      call map_message(seve%e,rname,'No such SIC variable '//arg(1:nc))
      error = .true.
      return
    endif
    if (desc%type.ne.fmt_r8) then
      call map_message(seve%e,rname,'SIC variable '//arg(1:nc)//' is not DOUBLE')
      error = .true.
      return
    endif
    !
    ! /FOR option
    if (do_one) then
      !
      if (do_file) then
        ! It must be a file
        call gildas_null(hou,type='UVT')
        hou%file = fich
        !
        call gdf_read_header(hou,error)
        if (error)  return
        !
        ! Test if in-place work is possible
        new_nhb = 2 + (3*desc%dims(1)+ 2+10*hou%gil%nteles + 127)/128   ! Total number of HEADER blocks required...
        if (new_nhb.gt.hou%gil%nhb) then
          !
          ! A copy of the file is required - preceded or followed by renaming...
          call gdf_close_image(hou,error)
          !
          error = .false.    ! Indicate that Header Extension IS allowed
          call gdf_setfreqs(rname,desc,hou,error)
          if (error) return
          !
          call gildas_null(hin,type='UVT')
          hin%file = trim(arg)//'.old'
          ier = gag_filrename(hou%file,hin%file)
          !
          ! Read the header again (to get the proper NVB, actually)
          call gdf_read_header(hin,error)
          if (error) return
          !
          ! OK copy the whole stuff...
          call gdf_nitems('SPACE_GILDAS',nblock,hin%gil%dim(1))
          nblock = min(nblock,hin%gil%dim(2))
          !
          allocate (din(hin%gil%dim(1),nblock),stat=ier)
          if (ier.ne.0) then
            call map_message(seve%e,rname,'Memory allocation error ')
            error = .true.
            return
          endif
          !
          hin%blc = 0
          hin%trc = 0
          hou%blc = 0
          hou%trc = 0
          call gdf_create_image(hou,error)
          if (error) return
          !
          call map_message(seve%i,rname,'Copying UV data ')
          do iloop = 1,hin%gil%dim(2),nblock
            hin%blc(2) = iloop
            hin%trc(2) = min(iloop+nblock-1,hin%gil%dim(2))
            hou%blc(2) = iloop
            hou%trc(2) = hin%trc(2)
            call gdf_read_data (hin,din,error)
            if (error) exit
            call gdf_write_data (hou,din, error)
            if (error) exit
          enddo
          err = .false.
          call gdf_close_image(hou,err)
          error = err.or.error
          !
          ! Remove the old file, or get back to it in case of failure
          if (error) then
            ier = gag_filrename(hin%file,hou%file)
          else
            call gag_filrm(hin%file)
          endif
        else
          !
          ! In place header update
          error = .true.    ! Indicate that Header Extension is NOT allowed
          call gdf_setfreqs(rname,desc,hou,error)
          if (.not.error) call gdf_update_header(hou,error)
          err = .false.
          call gdf_close_image(hou,err)
          error = err.or.error
        endif
      else
        !
        ! It must be a SIC variable
        call sic_descriptor(arg,descuv,found)  
        if (.not.found) then
          call map_message(seve%e,rname,'No such SIC variable '//arg(1:nc))
          error = .true.
          return
        endif
        !
        ! There must be a Header in the descriptor... 
        if (.not.associated(descuv%head)) then
          call map_message(seve%w,rname,  &
            'Variable '//arg(1:nc)//' does not provide a header')
          error = .true.
          return
        endif
        error = .true.    ! Indicate that Header Extension is NOT allowed
        call gdf_setfreqs(rname,desc,descuv%head,error)
      endif
      !
    else
      !
      call sic_delvariable('UV',.false.,error)
      error = .false.    ! Indicate that Header Extension IS allowed
      call gdf_setfreqs(rname,desc,huv_current,error)
      err = .false.
      call sic_mapgildas('UV',huv_current,err,duv)
      error = err.or.error
    endif
    return
  endif
  !
  ! Single Buffer Case
  if (do_one) then
    if (do_file) then
      call map_message(seve%w,rname,'SPECIFY FileName Item Value -- still experimental')
      allocate(desc%head,stat=ier)
      call gildas_null(desc%head)
      desc%head%file = fich
      call gdf_read_header(desc%head,error)
      if (error) return
      !
      ctype = 'File'
    else
      arg = fich
      nc = len_trim(arg)
      !
      ! Look at the SIC variable
      call sic_descriptor(arg,desc,found)
      if (.not.found) then
        call map_message(seve%e,rname,'No such SIC variable '//arg(1:nc))
        error = .true.
        return
      endif
      !
      ! There must be a Header in the descriptor...
      if (.not.associated(desc%head)) then
        call map_message(seve%w,rname,  &
          'Variable '//arg(1:nc)//' does not provide a header')
        error = .true.
        return
      endif
      !
      ctype = 'Variable '
    endif
    !
    if (do_spec) then
      if (desc%head%gil%faxi.eq.0) then
        call map_message(seve%w,rname,  &
          ctype//fich(1:nf)//' has no Spectral axis')
        error = .true.
        return
      endif
      !
      if (spec_type.eq.'VELOCITY') then
        desc%head%gil%convert(2,desc%head%gil%faxi) = desc%head%gil%voff
        desc%head%gil%convert(3,desc%head%gil%faxi) = desc%head%gil%vres
        desc%head%char%code(desc%head%gil%faxi) = 'VELOCITY'
      else
        desc%head%gil%convert(2,desc%head%gil%faxi) = desc%head%gil%freq
        desc%head%gil%convert(3,desc%head%gil%faxi) = desc%head%gil%fres
        desc%head%char%code(desc%head%gil%faxi) = 'FREQUENCY'
      endif
    else if (do_unit) then
      !
      ! Convert from Jy/area to K or vice-versa
      ounit = desc%head%char%unit
      if (desc%head%char%unit.ne."K") then
        ! Convert from some Jy per Area unit to K
        call unit_to_k(desc%head,fact_k)
      else
        fact_k = 1.0
      endif
      ! Then convert from K to desired unit, if needed
      desc%head%char%unit = spec_type
      call unit_to_k(desc%head,fact_u)
      !
      ! And restore desired unit in header
      fact = fact_k/fact_u
      desc%head%char%unit = spec_type
      if (fact.eq.1.0) then
        call map_message(seve%i,'SPECIFY','No conversion required')
      else
        call map_message(seve%w,'SPECIFY','Converting from '//trim(ounit)//' to '//spec_type)
        call modify_scale_blank(desc,fact,error,code_scale)
      endif
    else if (do_blank) then
      call modify_scale_blank(desc,bval,error,code_blank)
    else
      !
      if (.not.do_freq) freq = desc%head%gil%freq
      if (.not.do_velo) velo = desc%head%gil%voff
      if (.not.do_line) cline = desc%head%char%line
      !
      clines(icode_all) = cline
      freqs(icode_all) = freq
      velos(icode_all) = velo
      call gdf_modify(desc%head,velos(icode_all),freqs(icode_all),error=error)
      desc%head%char%line = clines(icode_all)
    endif
    !
    if (ctype.eq.'File') then
      if (error) then
        call gdf_close_image(desc%head,err)
      else
        call gdf_update_header(desc%head,error)
        call gdf_close_image(desc%head,error)
      endif
    endif
    !
  else
    !
    ! Update all available buffers - multiple modifications at once
    if (do_freq) freqs = freq
    if (do_velo) velos = velo
    if (do_line) clines = cline
    !
    if (do_uv) then  !!  if (huv_current%loca%size.ne.0) then
      freq_b = gdf_uv_frequency(huv_current,1.d0)
      call gdf_modify(huv_current,velos(icode_uv),freqs(icode_uv),error=error)
      freq_a = gdf_uv_frequency(huv_current,1.d0)
      if (abs(freq_a-freq_b).gt.10.0) then
        Print *,'Frequency Before ',freq_b
        Print *,'Frequency After ',freq_a
        Print *,'Frequency Difference ',freq_a-freq_b
      endif
      huv_current%char%line = clines(icode_uv)
    endif
    if (do_dirty) then
      call gdf_modify(hdirty,velos(icode_dirty),freqs(icode_dirty),error=error)
      hdirty%char%line = clines(icode_dirty)
    endif
    if (do_clean) then
      call gdf_modify(hclean,velos(icode_clean),freqs(icode_clean),error=error)
      hclean%char%line = clines(icode_clean)
    endif
    if (do_sky) then
      call gdf_modify(hsky,velos(icode_sky),freqs(icode_sky),error=error)
      hsky%char%line = clines(icode_sky)
    endif
  endif
  !
end subroutine specify_comm
!
subroutine gdf_setfreqs(rname,desc,huv_current,error)
  use gkernel_types
  use gkernel_interfaces
  use imager_interfaces, only : map_message 
  use gbl_message
  use iso_c_binding
  !---------------------------------------------------------------------
  ! @ private
  !*
  !   IMAGER   -- GILDAS Utility
  !
  !   Set values of the Frequency section in the specified UV Buffer header.  
  !   Support for command SPECIFY UVbuffer FREQUENCIES Array
  !!
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: rname       !! Buffer name
  type(sic_descriptor_t), intent(in) :: desc  !! Descriptor of Frequency array
  type(gildas), intent(inout) :: huv_current          !! UV data header
  logical, intent(inout) :: error             !! Logical error flag
  !
  ! Local ---
  integer :: stoke, new_nhb, ier
  type(c_ptr) :: cptr
  real(8), pointer :: dptr(:)
  !
  ! Code ----
  !
  ! Verify Number of frequencies against number of channels of UV data
  if (desc%dims(1).ne.huv_current%gil%nchan) then
    call map_message(seve%e,rname,'Frequencies list does not match number of channels in UV data')
    error = .true.
    return
  endif
  !
  stoke = 0
  if (huv_current%gil%nstokes.eq.1) then
    if (associated(huv_current%gil%stokes)) stoke = huv_current%gil%stokes(1)
  else if (huv_current%gil%nstokes.ne.0) then
    call map_message(seve%e,rname,'FREQUENCIES only work for 1 Stokes')
    error = .true.
    return
  endif
  !
  if (huv_current%gil%nfreq.eq.0) then
    huv_current%gil%nfreq = desc%dims(1)
    allocate (huv_current%gil%freqs(huv_current%gil%nfreq),huv_current%gil%stokes(huv_current%gil%nfreq),stat=ier)
    if (ier.ne.0) then
      call map_message(seve%e,rname,'FREQUENCIES allocation error')
      error = .true.
      return
    endif
    huv_current%gil%stokes = stoke
  endif
  !
  new_nhb = 2 + (3*huv_current%gil%nfreq + 2+10*huv_current%gil%nteles + 127)/128   ! Total number of HEADER blocks required...
  if (new_nhb.gt.huv_current%gil%nhb) then
    if (error) then
      call map_message(seve%e,rname,'Header cannot be extended in place')
      return
    endif
    call map_message(seve%w,rname,'Header is being extended')
  else
    call map_message(seve%d,rname,'Header is updated in place')
  endif
  !
  call adtoad(desc%addr,cptr,1)
  call c_f_pointer(cptr,dptr,[huv_current%gil%nfreq])
  huv_current%gil%freqs(:) = dptr
  call gdf_setuv(huv_current,error)
  !
end subroutine gdf_setfreqs
!
subroutine gdf_setteles(head,chain,value,error)
  use image_def
  use gkernel_interfaces, only : gdf_addteles
  use imager_interfaces, only : map_message
  use gbl_message
  ! @ private
  !! IMAGER -- GILDAS Utility -- Set the Telescope section
  !--------------------------------------------------------------------
  type(gildas), intent(inout) :: head
  !! Gildas Header
  character(len=*), intent(in) :: chain
  !! Telescope name
  real(8), intent(in) :: value(3)
  !! Telescope parameters
  logical, intent(inout) :: error
  !! Logical error flag
  !
  if (head%gil%nteles.ge.1) then
    if (head%gil%teles(1)%ctele .ne. chain) then
      if ( abs(head%gil%type_gdf).eq.abs(code_gdf_uvt) ) then        
          call map_message(seve%i,'SPECIFY','Telescope ' &
          & //trim(head%gil%teles(1)%ctele) &
          & //' in UV dataset overwritten by SPECIFY TELESCOPE '//chain)
      endif
      ! Undefine the telescope so that all characteristics
      ! are re-defined by gdf_laddteles after
      head%gil%teles(1)%ctele = ' '
    endif
  endif
  call gdf_addteles(head,'TELE',chain,value,error)
end subroutine gdf_setteles
!
subroutine modify_scale_blank(desc,scale,error,code)
  use gkernel_types
  use gkernel_interfaces
  use gbl_message
  use iso_c_binding
  use imager_interfaces, only : map_message
  !---------------------------------------------------------------------
  ! @ private
  !*
  !   IMAGER -- GILDAS Utility --  Change the Unit of data cube, or
  ! its blanking value
  ! 
  !     Support routine for SPECIFY UNIT and SPECIFY BLANKING
  !!
  !---------------------------------------------------------------------
  type(sic_descriptor_t), intent(inout) :: desc !! Descriptor of SIC variable
  real, intent(in) :: scale                     !! Scale factor for the data
  logical, intent(out) :: error                 !! Logical error flag
  integer, intent(in) :: code                   !! Keyword code
  !
  ! Local ---
  integer, parameter :: code_blank=0    !! BLANKING keyword
  integer, parameter :: code_scale=1    !! UNIT Keyword
  type(c_ptr) :: cptr 
  real(4), pointer :: rdata(:)
  integer(kind=index_length) :: j, asize, nblock
  type(gildas) :: htmp
  real :: rblock
  integer :: ier
  !
  ! Code ----
  if (desc%head%gil%form.ne.fmt_r4) then
    call map_message(seve%e,'SPECIFY','Unsupported data format')
    error = .true.
    return
  endif
  !
  if (code.eq.code_scale) then
    desc%head%gil%rmax = scale*desc%head%gil%rmax
    desc%head%gil%rmin = scale*desc%head%gil%rmin
  endif
  !
  if (desc%size.ne.0) then
    call adtoad(desc%addr,cptr,1)
    call c_f_pointer(cptr,rdata,[desc%size])
    if (code.eq.code_scale) then
      call sub_modify_scale(desc%head,rdata,desc%size,scale)
    else if (code.eq.code_blank) then
      call sub_modify_blank(desc%head,rdata,desc%size,scale)
    endif
  else
    asize = product(desc%head%gil%dim(1:desc%head%gil%ndim))
    call gildas_null(htmp,type='IMAGE')
    htmp = desc%head    ! Copy full header
    !
    ! Flatten the array to 1-D only
    htmp%gil%dim = 1
    htmp%gil%dim(1) = asize
    htmp%gil%ndim = 1
    !
    ier = sic_ramlog('SPACE_GILDAS',rblock)
    nblock = rblock*1024*256
    allocate(rdata(nblock),stat=ier)
    !
    do j=1,htmp%gil%dim(1),nblock
      htmp%blc(1) = j
      htmp%trc(1) = min(htmp%gil%dim(1),j+nblock-1)
      asize = htmp%trc(1)-htmp%blc(1)+1
      !! print *,'Block ',htmp%blc(1),htmp%trc(1),asize
      call gdf_read_data(htmp,rdata,error)
      if (error) return
      !
      if (code.eq.code_scale) then
        call sub_modify_scale(htmp,rdata,asize,scale)
      else if (code.eq.code_blank) then
        call sub_modify_blank(htmp,rdata,asize,scale)
      endif
      call gdf_write_data(htmp,rdata,error)
    enddo
  endif
  !
  if (code.eq.code_scale) then
    ! Adjust Blanking if it would fall in the new Min Max range
    if (desc%head%gil%rmin.le.desc%head%gil%bval .and. &
      & desc%head%gil%bval.le.desc%head%gil%rmax) then
      desc%head%gil%bval = scale*desc%head%gil%bval
    endif
    desc%head%gil%rms = scale*desc%head%gil%rms
    desc%head%gil%noise = scale*desc%head%gil%noise
  else
    desc%head%gil%bval = scale
    desc%head%gil%eval = 0.0
  endif
end subroutine modify_scale_blank
!
subroutine sub_modify_scale(head,rdata,rsize,scale)
  use image_def
  !
  !*
  !   IMAGER -- GILDAS Utility --  Change the Unit of data cube
  ! 
  !     Support routine for SPECIFY UNIT
  !!
  type(gildas), intent(inout) :: head   !! Cube Header
  integer(kind=index_length), intent(in) :: rsize  !! Data length
  real, intent(inout) :: rdata(rsize)   !! Data array
  real, intent(in) :: scale             !! Scale factor
  !
  ! Local ---
  integer(kind=index_length) :: i
  !
  ! Code ----
  if (head%gil%eval.lt.0) then
    do i=1,rsize
      rdata(i) = scale*rdata(i)
    enddo
  else
    ! Adjust Blanking if it would fall in the new Min Max range
    if (head%gil%rmin.le.head%gil%bval .and. &
      & head%gil%bval.le.head%gil%rmax) then
      do i=1,rsize
        rdata(i) = scale*rdata(i)
      enddo
    else
      do i=1,rsize
        if (abs(rdata(i)-head%gil%bval).gt.head%gil%eval) rdata(i) = scale*rdata(i)
      enddo
    endif
  endif
end subroutine sub_modify_scale
!
subroutine sub_modify_blank(head,rdata,rsize,bval)
  use image_def
  !*
  !   IMAGER -- GILDAS Utility --  Change the Cube blanking value
  ! 
  !     Support routine for SPECIFY BLANKING
  !!
  type(gildas), intent(inout) :: head               !! Cube Header
  integer(kind=index_length), intent(in) :: rsize   !! Data length
  real, intent(inout) :: rdata(rsize)               !! Data array
  real, intent(in) :: bval                          !! New blanking
  !
  integer(kind=index_length) :: i
  !
  do i=1,rsize
    if (abs(rdata(i)-head%gil%bval).le.head%gil%eval) rdata(i) = bval
  enddo
end subroutine sub_modify_blank

!>
!   This File contains all CLEAN command related dispatching
! sub-routines
!!
subroutine clean_comm(line,error)
  use gbl_message
  use gkernel_interfaces
  use imager_interfaces, except_this=>clean_comm
  use clean_arrays
  use clean_default
  !----------------------------------------------------------------------
  ! @ public
  !*  IMAGER --  Support for command CLEAN & GCLEAN  
  !   Call appropriate subroutine according to METHOD%METHOD
  !!
  !----------------------------------------------------------------------
  character(len=*), intent(inout) :: line    !! Command line
  logical,          intent(out)   :: error   !! Logical error flag
  !
  integer, parameter :: opt_start=6
  character(len=1), parameter :: question_mark='?'
  character(len=12) :: cmethod
  character(len=24) :: topic
  character(len=80) :: chain
  integer :: nm, narg, ier, nt
  !
  narg = sic_narg(0) 
  if (narg.gt.0) then
    call sic_ch(line,0,1,cmethod,nm,.false.,error)
    if (cmethod(1:1).eq.question_mark) then
      if (sic_present(0,2)) then
        call sic_ch(line,0,2,topic,nt,.true.,error)
        chain = 'HELP CLEAN '//topic
      else
        chain = "@ i_clean "//cmethod
      endif
      call exec_program(chain)
      return
    else if (narg.eq.2) then
      call sic_ch(line,0,2,cmethod,nm,.false.,error)
      if (cmethod(1:1).eq.question_mark) then
        call sic_ch(line,0,1,topic,nt,.true.,error)
        chain = 'HELP CLEAN '//topic
        call exec_program(chain)
        return 
      endif    
    endif
    !
    if (sic_present(opt_start,0)) then
      call map_message(seve%w,'CLEAN','First and Last argument not tested with /RESTART option',seve%e)
    endif
  endif
  !
  call sic_get_char('METHOD',cmethod,nm,error)
  call sic_upper(cmethod)
  !
  select case (cmethod)
  case ('CLARK')
    call clark_comm(line,error)
  case ('HOGBOM')
    call hogbom_comm(line,error)
  case ('MRC')
    call mrc_comm(line,error)
  case ('MULTI')
    call multi_comm(line,error)
  case ('SDI')
    call sdi_comm(line,error)
  case ('GAUSS')
    call gauss_comm(line,error)
  case default
    call map_message(seve%e,'CLEAN','Unsupported method '//cmethod)
    error = .true.
    return
  end select
  ! 
  ! Reset the per-plane stopping criterium
  ares_listsize = 0
  niter_listsize = 0
  !
  if (error) return 
  !
  ! Re-define continuum image if needed
  if (do_continuum) then
    call sic_delvariable('CONTINUUM',.false.,error)
    if (allocated(dcont)) deallocate(dcont)
    call gildas_null(hcont)
    if (user_method%mosaic) then
      call gdf_copy_header(hsky,hcont,error)
    else
      call gdf_copy_header(hclean,hcont,error)
    endif
    hcont%gil%ndim = 2
    allocate(dcont(hcont%gil%dim(1),hcont%gil%dim(2)),stat=ier)
    if (ier.ne.0) then
      call map_message(seve%e,'CLEAN','Memory allocation error')
      error = .true.
      return
    endif
    !
    if (user_method%mosaic) then
      dcont(:,:) = dsky(:,:,1)
    else
      dcont(:,:) = dclean(:,:,1)
    endif
    hcont%loca%size = hcont%gil%dim(1) * hcont%gil%dim(2)
    hcont%r2d => dcont
    !
    call sic_mapgildas('CONTINUUM',hcont,error,dcont)
  endif    
  !
end subroutine clean_comm
!
subroutine mrc_comm (line,error)
  use gkernel_interfaces
  use imager_interfaces, except_this=>mrc_comm
  use clean_def
  use clean_default
  use clean_arrays
  use gbl_message
  !----------------------------------------------------------------------
  ! @ private
  !
  !*  IMAGER --  CLEAN Internal routine for MRC  
  !   Implementation of Multi Resolution Clean according to Wakker & Schwartz
  !!
  !----------------------------------------------------------------------
  character(len=*), intent(inout) :: line    !! Command line
  logical, intent(out) :: error              !! Logical error flag
  !
  character(len=3) :: rname = 'MRC'
  !
  ! Local ---
  integer ratio,nx,ny
  !
  ! Code ----
  if (user_method%mosaic) then
    call map_message(seve%e,rname,'Not valid for mosaic')
    error = .true.
    return
  endif
  !
  ! Data checkup
  user_method%method = 'MRC'
  call clean_data (error)
  if (error) return
  !
  ! Parameter Definitions
  call beam_unit_conversion(user_method)
  call copy_method(user_method,the_method)
  !
  ! Smoothing ratio : given by user or 2, 4 or 8 according to image size
  if (the_method%ratio.ne.0) then
    ratio = the_method%ratio
    if (power_of_two(ratio).eq.-1) then
      call map_message(seve%e,rname,'Smoothing ratio has to be a power of 2')
      error = .true.
      return
    endif
  else
    nx = hdirty%gil%dim(1)
    ny = hdirty%gil%dim(2)
    if (nx*ny.gt.512*512) then
      ratio = 8
    elseif (nx*ny.gt.128*128) then
      ratio = 4
    else
      ratio = 2
    endif
  endif
  the_method%ratio = ratio
  the_method%pflux = sic_present(1,0)
  the_method%pcycle = sic_present(2,0)
  if (sic_present(6,0)) then
    the_method%restart = 6
  else
    the_method%restart = 0
  endif
  the_method%qcycle = .false.
  !
  call sub_clean(the_method,line,error)
  user_method%do_mask = .true. ! important sinon CLARK ne marche plus
end subroutine mrc_comm
!
subroutine multi_comm (line,error)
  use gkernel_interfaces
  use imager_interfaces, except_this=>multi_comm
  use clean_def
  use clean_default
  use clean_arrays
  use gbl_message
  !----------------------------------------------------------------------
  ! @ private
  !
  !*
  !   IMAGER -- CLEAN  Internal routine for MULTISCALE
  !
  !   Implementation of Multi Scale Clean, using a pixel-based 
  !   user-define kernel with limited support.
  !     Slow, but precise in convergence (deprecated)
  !!
  !----------------------------------------------------------------------
  character(len=*), intent(inout) :: line  !! Command line
  logical, intent(out) :: error            !! Logical error flag
  !
  ! Code ----
  if (user_method%mosaic) then
    call map_message(seve%w,'MULTI','MultiScale method still experimental for mosaic')
  endif
  !
  ! Data checkup
  user_method%method = 'MULTI'
  call clean_data (error)
  if (error) return
  !
  ! Parameter Definitions
  call beam_unit_conversion(user_method)
  call copy_method(user_method,the_method)
  the_method%pflux = sic_present(1,0)
  the_method%pcycle = .false.
  the_method%qcycle = .false.
  if (sic_present(6,0)) then
    the_method%restart = 6
  else
    the_method%restart = 0
  endif
!
  the_method%gains = the_method%gain
  call sic_get_real('CLEAN_GAINS[1]',the_method%gains(1),error)
  call sic_get_real('CLEAN_GAINS[2]',the_method%gains(2),error)
  call sic_get_real('CLEAN_GAINS[3]',the_method%gains(3),error)
  !
  call sub_clean(the_method,line,error)
end subroutine multi_comm
!
subroutine sdi_comm (line,error)
  use gkernel_interfaces
  use imager_interfaces, except_this=>sdi_comm
  use clean_def
  use clean_default
  use clean_arrays
  !----------------------------------------------------------------------
  ! @ private
  !
  !*
  !   IMAGER -- CLEAN Internal routine for SDI  
  !   Implementation of Steer Dewdney Ito Clean
  !
  !     Very sensitive to chosen support.
  !!
  !----------------------------------------------------------------------
  character(len=*), intent(inout) :: line  !! Command line
  logical, intent(out) :: error            !! Logical error flag
  !
  character(len=8) :: voc1(2)
  data voc1/'CLEAN','RESIDUAL'/
  !
  ! Local ---
  integer iv,na,m_iter
  character(len=8) :: name,argum
  !
  ! Code ----
  ! Save default number of components
  m_iter = user_method%m_iter
  user_method%m_iter = hdirty%gil%dim(1) * hdirty%gil%dim(2)
  !
  ! Data checkup: method must be defined first ?
  user_method%method = 'SDI'
  call clean_data (error)
  if (error) return
  !
  ! Parameter Definitions
  call beam_unit_conversion(user_method)
  call copy_method(user_method,the_method)
  the_method%pflux = .false.
  if (sic_present(6,0)) then
    the_method%restart = 6
  else
    the_method%restart = 0
  endif
  the_method%pcycle = sic_present(2,0)
  the_method%qcycle = sic_present(3,0)
  if (the_method%pcycle) then
    argum = 'RESIDUAL'
    call sic_ke (line,2,1,argum,na,.false.,error)
    if (error) return
    call sic_ambigs ('PLOT',argum,name,iv,voc1,2,error)
    if (error) return
    the_method%pclean = iv.eq.1
  else
    the_method%pclean = .false.
  endif
  call sub_clean(the_method,line,error)
  ! Restore default number of components
  user_method%m_iter = m_iter
end subroutine sdi_comm
!
subroutine hogbom_comm (line,error)
  use gkernel_interfaces
  use imager_interfaces, except_this=>hogbom_comm
  use clean_def
  use clean_default
  use clean_arrays
  !----------------------------------------------------------------------
  ! @ private
  !
  !*
  !   IMAGER - CLEAN Internal routine for HOGBOM  
  !   Implementation of classical Hogbom Clean
  !
  !     Slow, but extremely robust, and with a minimum of parameters
  !!
  !----------------------------------------------------------------------
  character(len=*), intent(inout) :: line  !! Command line
  logical, intent(out) :: error            !! Logical error flag
  !
  ! Code ----
  ! Data checkup
  user_method%method = 'HOGBOM'
  call clean_data (error)
  if (error) return
  !
  ! Parameter Definitions
  call beam_unit_conversion(user_method)
  call copy_method(user_method,the_method)
  the_method%pflux = sic_present(1,0)
  if (sic_present(6,0)) then
    the_method%restart = 6
  else
    the_method%restart = 0
  endif
  the_method%pcycle = .false.
  the_method%qcycle = .false.
  call sub_clean(the_method,line,error)
end subroutine hogbom_comm
!
subroutine clark_comm (line,error)
  use gkernel_interfaces
  use imager_interfaces, except_this=>clark_comm
  use clean_def
  use clean_default
  use clean_arrays
  !----------------------------------------------------------------------
  ! @ private
  !
  !*
  !   IMAGER -- CLEAN Internal routine for CLARK  
  !   Implementation of Barry Clark Clean
  !
  !     Faster than HOGBOM, requiring more limited map sizes, but 
  !   convergence is difficult to control in some cases
  !!
  !----------------------------------------------------------------------
  character(len=*), intent(inout) :: line  !! Command line
  logical, intent(out) :: error            !! Logical error flag
  !
  ! Constants
  character(len=8) :: voc1(2)
  data voc1/'CLEAN','RESIDUAL'/
  ! Local ---
  character(len=8) :: name,argum
  integer iv,na
  !
  ! Data checkup
  user_method%method = 'CLARK'
  call clean_data (error)
  if (error) return
  !
  ! Parameter Definitions
  call beam_unit_conversion(user_method)
  call copy_method(user_method,the_method)
  the_method%pflux = sic_present(1,0)
  if (sic_present(6,0)) then
    the_method%restart = 6
  else
    the_method%restart = 0
  endif
  the_method%pcycle = sic_present(2,0)
  the_method%qcycle = sic_present(3,0)
  if (the_method%pcycle) then
    argum = 'RESIDUAL'
    call sic_ke (line,2,1,argum,na,.false.,error)
    if (error) return
    call sic_ambigs ('PLOT',argum,name,iv,voc1,2,error)
    if (error) return
    the_method%pclean = iv.eq.1
  else
    the_method%pclean = .false.
  endif
  call sub_clean(the_method,line,error)
end subroutine clark_comm
!
subroutine gauss_comm (line,error)
  use gkernel_interfaces
  use imager_interfaces, except_this=>gauss_comm
  use clean_def
  use clean_default
  use clean_arrays
  use gbl_message
  !----------------------------------------------------------------------
  ! @ private
  !
  !* 
  !   IMAGER -- CLEAN Internal routine for GAUSS method  
  !   Implementation of Gaussian Multi Scale.
  !
  !     Faster than pixel-based Multi Scale.  A spheroidal kernel should be
  !   provided also instead of the Gaussian kernel. Support limitations
  !   could be implemented as well.
  !!
  !----------------------------------------------------------------------
  character(len=*), intent(inout) :: line  !! Command line
  logical, intent(out) :: error            !! Logical error flag
  !
  ! Constants
  real, parameter :: rad_to_sec=180.*3600./acos(-1.0)
  !
  ! Local ---
  integer :: i,j,narg,nchan,nfield
  real :: bsize
  logical :: sticky
  !
  ! Code ----
  if (user_method%mosaic) then
    call map_message(seve%w,'GAUSS', &
      & 'MultiScale Gauss method still experimental for mosaic')
  endif
  !
  ! Data checkup
  user_method%method = 'GAUSS'
  call clean_data (error)
  if (error) return
  !
  ! Parameter Definitions
  call beam_unit_conversion(user_method)
  call copy_method(user_method,the_method)
  !
  the_method%pflux = sic_present(1,0)
  if (sic_present(2,0)) then
    the_method%restart = 2
  else
    the_method%restart = 0
  endif
  the_method%pcycle = .false.
  the_method%qcycle = .false.
  !
  the_method%gsize = 0.
  narg = min(sic_narg(0),clean_mscale-1)
  sticky = .false.
  if (narg.ne.0) then
    ! User defined scale factors
    do i=1,narg
      call sic_r4(line,0,i,the_method%gsize(i+1),.true.,error)
      if (error) return
    enddo
    sticky = .true.
  else if (any(user_method%gsize.ne.0)) then
    ! No assumption on order in entry
    ! Size 0 (Point Sources) is always first on exit
    the_method%gsize(1) = 0.
    j = 1
    do i=1,size(user_method%gsize)
      if (user_method%gsize(i).ne.0) then
        j = j+1
        if (j.gt.size(the_method%gsize)) exit
        the_method%gsize(j) = user_method%gsize(i)
      endif
    enddo
  else
    ! Automatic scale factors
    bsize = sqrt(hbeam%gil%majo*hbeam%gil%mino)
    if (bsize.eq.0) then
      nchan = max(hbeam%gil%dim(3),1)
      nfield = max(1,abs(themap%nfields))
      call sub_fit_beam(nfield,nchan,1,nfield,1,nchan, &
      & .false., .false., .false., error)
    endif
    bsize = sqrt(hbeam%gil%majo*hbeam%gil%mino)*rad_to_sec
    the_method%gsize(2) = bsize
    the_method%gsize(3) = 2*bsize
  endif
  !
  ! This is only valid for 3 scales...
  the_method%gains = the_method%gain
  call sic_get_real('CLEAN_GAINS[1]',the_method%gains(1),error)
  call sic_get_real('CLEAN_GAINS[2]',the_method%gains(2),error)
  call sic_get_real('CLEAN_GAINS[3]',the_method%gains(3),error)
  error = .false.
  !
  call sub_clean(the_method,line,error)
  if (error) return
  if (sticky) user_method%gsize = the_method%gsize
end subroutine gauss_comm
!
subroutine sub_clean (method,line,error)
  use gkernel_interfaces
  use imager_interfaces, except_this=>sub_clean
  use clean_def
  use clean_default
  use clean_arrays
  use clean_types
  use gbl_message
  !$  use omp_lib
  !----------------------------------------------------------------------
  ! @ private
  !
  !*
  !   IMAGER -- CLEAN Internal routine.  
  !     Implementation of all standard CLEAN deconvolution algorithms,
  ! Parsing has been done before, for all methods. 
  !
  !   To be done: some additional parsing is still done here, about
  !   First and Last channels, flux limits, and also in CCT_PREPARE.
  !   It should be moved to a separate routine.
  !!
  !----------------------------------------------------------------------
  type(clean_par), intent(inout) :: method  !! Clean control parameters
  character(len=*), intent(inout) :: line   !! Command line
  logical, intent(out) :: error             !! Logical error flag
  !
  real(8), parameter :: pi=3.14159265358979323846d0
  character(len=*), parameter :: rname='CLEAN'
  character(len=6) :: clist(3)=['CLEAN ','CCT   ','SKY   ']
  character(len=80) :: chain
  !
  integer :: i, ipen, nx, ny, np, nsizes(3)
  logical limits
  real ylimn,ylimp
  logical :: clean_extrema=.true.
  integer :: mthread, plot_case, save_converge
  logical :: err
  !
  call map_message(seve%d,rname,'Calling SUB_CLEAN in all_clean.f90')
  call sic_get_logi('CLEAN_EXTREMA',clean_extrema,error)
  !
  if (user_method%mosaic) then
    where (method%blc.eq.0) method%blc = 17
    where (method%trc.eq.0) method%trc = hdirty%gil%dim(1:2)-16
    write(chain,'(A,4(1X,I0))') 'Set default search box to ',method%blc, method%trc
    call map_message(seve%i,rname,chain)
  endif    
  !
  ! General First Last channel selection (Obsolescent)...
  call sic_get_inte('FIRST',method%first,error)
  call sic_get_inte('LAST',method%last,error)
  !
  if (method%method.eq.'GAUSS') then
    method%nscale = clean_mscale
    do i=2,clean_mscale
      if (method%gsize(i).eq.0) then
        method%nscale = i-1
        exit
      endif
    enddo
    if (method%nscale.eq.0) then
      call map_message(seve%e,rname,'Smoothing Gaussians  are all Zero')
      error = .true.
      return
    endif
    write(chain,'(A,5(F9.2))') 'Gaussian sizes ',method%gsize(1:method%nscale)
    call map_message(seve%i,rname,chain)
  else  if (sic_present(0,1)) then
    ! Optional FIRST and LAST
    call sic_i4(line,0,1,method%first,.false.,error)
    if (error) return
    method%last = method%first
    call sic_i4(line,0,2,method%last,.false.,error)
    if (error) return
  endif
  !
  ! Usefull variables
  nx = hdirty%gil%dim(1)
  ny = hdirty%gil%dim(2)
  np = max(1,hprim%gil%dim(1))
  !
  ! Update the Channel range
  if (method%first.eq.0) method%first = 1
  if (method%last.eq.0) method%last = hdirty%gil%dim(3)
  method%first = max(1,min(method%first,hdirty%gil%dim(3)))
  method%last = max(method%first,min(method%last,hdirty%gil%dim(3)))
  !
  call check_area(method,hdirty,.false.)
  call check_mask(method,hdirty)
  user_method%do_mask = method%do_mask
  !
  ! Allocate the CCT Table
  nsizes(1:3) = hdirty%gil%dim(1:3)
  call cct_prepare(line,nsizes,method,rname,error)
  if (error) return
  !
  ! Set the pointers for use in subroutines
  hdirty%r3d => ddirty
  if (user_method%mosaic) then
    hclean%r3d => dsky 
  else
    hclean%r3d => dclean    
  endif  
  hbeam%r4d  => dbeam
  hresid%r3d => dresid
  hprim%r4d  => dprim
  hmask%r3d => dmask
  !
  ! Flux limits
  limits = sic_present(1,0)
  if (sic_present(1,1)) then
    call sic_r4 (line,1,1,ylimn,.true.,error)
    if (error) return
    call sic_r4 (line,1,2,ylimp,.true.,error)
    if (error) return
  else
    ylimp = sqrt (float(method%m_iter+200) *   &
     &      log(float(method%m_iter+1)) ) * method%gain
    if (ylimp.eq.0.) ylimp = 1.0
    if (-hdirty%gil%rmin.gt.1.3*hdirty%gil%rmax) then
      ! Probably negative
      ylimn = ylimp*hdirty%gil%rmin
      ylimp = 0.0
    elseif (-1.3*hdirty%gil%rmin.gt.hdirty%gil%rmax) then
      ! Probably positive
      ylimn = 0.0
      ylimp = ylimp*hdirty%gil%rmax
    else
      ! Do not know...,
      ylimn = ylimp*hdirty%gil%rmin
      ylimp = ylimp*hdirty%gil%rmax
    endif
    if (sic_present(1,0)) then
      ! Start with a small range - This will be increased later
      ylimn = 0.001*ylimn
      ylimp = 0.001*ylimp
      call sic_r4 (line,1,1,ylimn,.false.,error)
      if (error) return
      call sic_r4 (line,1,2,ylimp,.false.,error)
      if (error) return
    endif
  endif
  !
  ! Beam patch according to Method and adjust the convergence criterium also
  save_converge = method%converge 
  if (method%method.eq.'CLARK'.or.   &
     &    method%method.eq.'MRC') then
    if (user_method%patch(1).ne.0) then
      method%patch(1) = min(user_method%patch(1),nx)
    else
      method%patch(1) = min(nx,max(32,nx/4))
    endif
    if (user_method%patch(2).ne.0) then
      method%patch(2) = min(user_method%patch(2),ny)
    else
      method%patch(2) = min(ny,max(32,ny/4))
    endif
    !
    if (method%converge.gt.0) then
     ! Make sure the convergence length is short enough 
     ! as CLARK method is easily unstable
     method%converge = min(method%converge,20)
    else
     ! Negative values are for tests only
     method%converge = -method%converge
    endif
  elseif (method%method.eq.'SDI') then
    if (user_method%patch(1).ne.0) then
      method%patch(1) = min(user_method%patch(1),nx/4)
    else
      method%patch(1) = min(nx/2,max(16,nx/8))
    endif
    if (user_method%patch(2).ne.0) then
      method%patch(2) = min(user_method%patch(2),ny/4)
    else
      method%patch(2) = min(ny,max(16,ny/8))
    endif
    method%converge = abs(method%converge)
  else
    method%converge = abs(method%converge)
  endif
  !
  ! Disable Plotting in Parallel mode
  mthread = 1
  !$  mthread = omp_get_max_threads()
  if (mthread.gt.1 .and. method%last.ne.method%first) then
    if (method%pcycle .or. method%pflux) then
      call map_message(seve%w,rname,'Ignoring /PLOT and /FLUX option in Parallel mode')
      method%pcycle = .false.
      method%pflux = .false.
    endif
    plot_case = 1
  else
    plot_case = 0
  endif
  !
  if (method%pflux) call init_flux90(method,hdirty,ylimn,ylimp,ipen)
  !
  ! Delete CCT variable
  call sic_delvariable('CCT',.false.,error)
  !
  ! Avoid array constructors (too touchy about Kind)
  method%bzone(1:2) = 1
  method%bzone(3:4) = hdirty%gil%dim(1:2)
  if (method%method.eq.'MRC') then
    call sub_mrc('MRC',method,hdirty,hresid,hclean,hbeam,hprim,d_mask, &
      &   error, plot_mrc)
  else
    if (plot_case.eq.1) then
      call sub_major(method,hdirty,hresid,hclean,hbeam,hprim,hmask, &
        &   dcclist,dcct,d_mask,d_list,error, no_major_plot, no_next_flux)
    else
      call sub_major(method,hdirty,hresid,hclean,hbeam,hprim,hmask, &
        &   dcclist,dcct,d_mask,d_list,error, major_plot90, next_flux90)
    endif
  endif
  !
  ! Close display in all cases
  method%converge = save_converge
  if (method%pflux .and. method%method.ne.'MRC') then
    err = .false.
    call close_flux90(ipen,err)
  else
    call gr_execl('CHANGE DIRECTORY <GREG')
  endif
  !
  ! Abort in case of Errors
  if (error) return 
  !
  ! Reset extrema
  if (user_method%mosaic) then
    hsky%gil%blan_words = 2
    hsky%gil%eval = 0.0 
  endif
  if (clean_extrema) then
    hresid%loca%addr = locwrd(dresid)
    call gdf_get_extrema (hresid,error)
    hresid%gil%extr_words = def_extr_words
    !
    if (user_method%mosaic) then
      call map_message(seve%i,rname,'Computing extrema of SKY and DIRTY')
      hsky%gil%blan_words = 2
      hsky%gil%eval = 0.0 
      hsky%loca%addr = locwrd(dsky)   
      call gdf_get_extrema (hsky,error)
      hsky%gil%extr_words = def_extr_words
    else
      call map_message(seve%i,rname,'Computing extrema of CLEAN and DIRTY')
      hclean%loca%addr = locwrd(dclean) 
      call gdf_get_extrema (hclean,error)
      hclean%gil%extr_words = def_extr_words
    endif    
  else
    hresid%gil%extr_words = 0
    hclean%gil%extr_words = 0
    hsky%gil%extr_words = 0
  endif
  !
  if (method%method.ne.'MRC') save_data(code_save_cct) = .true.
  !
  ! Save general parameters...
  user_method%ibeam = method%ibeam
  user_method%nlist = method%nlist
  !
  if (user_method%mosaic) then
    ! Specify clean beam parameters
    hsky%gil%reso_words = 3
    hsky%gil%majo = method%major
    hsky%gil%mino = method%minor
    hsky%gil%posa = pi*method%angle/180.0
    hclean%loca%size = 0  ! No Clean data
    last_shown = 'SKY'    ! For SHOW NOISE
    save_data(code_save_sky) = .true.
    !
    hatten%gil%bval = 0.
    where (datten.ne.0.0) datten = 1.0/datten
    if (hatten%gil%dim(3).le.1) then
      hatten%gil%ndim = 2
      hatten%gil%dim(3) = 1
    endif
    hatten%r3d => datten
    call cube_minmax('WEIGHT',hatten,error)
    if (error) return
    !
  else
    ! Specify clean beam parameters
    hclean%gil%reso_words = 3
    hclean%gil%majo = method%major
    hclean%gil%mino = method%minor
    hclean%gil%posa = pi*method%angle/180.0
    hsky%loca%size = 0    ! Reset the Sky (primary beam corrected) image
    ! and in beam too
    hbeam%gil%reso_words = 3
    hbeam%gil%majo = method%major
    hbeam%gil%mino = method%minor
    hbeam%gil%posa = pi*method%angle/180.0
    !
    hsky%loca%size = 0    ! Reset the Sky (primary beam corrected) image
    last_shown = 'CLEAN'  ! For SHOW NOISE
    save_data(code_save_clean) = .true.
  endif
  !
  call cct_truncate(hcct,dcct)
  call sic_mapgildas ('CCT',hcct,error,dcct)
  last_resid = 'CCT'    ! For UV_RESIDUAL
  !
  ! Signal that these display have been updated
  call set_buffer_modified('CCT')
  clist = ['CLEAN ','CCT   ','SKY   ']
  call check_view(3,clist)   ! Force VIEW re-computation for these
  !
end subroutine sub_clean
!
subroutine cct_truncate(hcct,dcct)
  use image_def
  use clean_def
  !----------------------------------------------------------------------
  ! @ private-mandatory
  !
  !*
  !   IMAGER -- CCT handling support routine  
  !     Truncate the CCT variable to its actual non-zero size
  !!
  !----------------------------------------------------------------------
  type(gildas), intent(inout) :: hcct 
  !! CCT Header
  real, intent(in) :: dcct(:,:,:)     
  !! CCT data
  !
  integer :: j
  integer(kind=index_length) :: mclean,i
  integer(kind=index_length), allocatable :: nclean(:) 
  !
  allocate(nclean(hcct%gil%dim(2)))
  nclean(:) = -1 ! No clean component by default
  do i=1,size(dcct,3) !! hcct%gil%dim(3)
    do j=1,hcct%gil%dim(2)
      if (nclean(j).eq.-1) then
        if (dcct(3,j,i).eq.0) nclean(j) = i-1
      endif
    enddo
    ! Exit when all set
    if (.not.(any(nclean(:).eq.-1) )) exit
  enddo
  do j=1,hcct%gil%dim(2)
    if (nclean(j).eq.-1) nclean(j) = size(dcct,3) !! hcct%gil%dim(3)
  enddo
  mclean = maxval(nclean)
  hcct%gil%dim(3) = max(mclean,1) ! No empty size...
  hcct%loca%size = product(hcct%gil%dim(1:3))
  deallocate(nclean)
end subroutine cct_truncate
!
subroutine clean_data(error)
  use gkernel_interfaces
  use imager_interfaces, except_this=>clean_data
  use clean_def
  use clean_default
  use clean_arrays
  use gbl_message
  !--------------------------------------------------------
  ! @ private
  !
  !*
  ! IMAGER -- CLEAN Support routine  
  !   Prepare Clean parameters.  
  !   Prepare Clean arrays: CLEAN or SKY, RESIDUAL  
  !!
  !--------------------------------------------------------
  logical, intent(out) :: error  !! Logical error flag
  !
  character(len=5), parameter :: rname = 'CLEAN'
  !
  ! Local ---
  integer nx,ny,nc,nb,ier
  logical equal
  !
  ! Code ----
  error = .false.
  if (hdirty%loca%size.eq.0) then
    call map_message(seve%e,rname,'No dirty image')
    error = .true.
  endif
  if (hbeam%loca%size.eq.0) then
    call map_message(seve%e,rname,'No dirty beam')
    error = .true.
  endif
  if (user_method%mosaic) then
    if (hprim%loca%size.eq.0) then
      call map_message(seve%e,rname,'No primary beam')
      error = .true.
    endif
  endif
  if (error) return
  !
  ! Create clean image if needed
  nx = hdirty%gil%dim(1)
  ny = hdirty%gil%dim(2)
  nc = hdirty%gil%dim(3)
  !
  call gdf_compare_shape(hdirty,hclean,equal)
  if (.not.equal) then
    if (allocated(dclean)) deallocate(dclean,stat=ier)
    call sic_delvariable ('CLEAN',.false.,error)
    if (allocated(dsky)) deallocate(dsky,stat=ier)
    call sic_delvariable ('SKY',.false.,error)
    if (allocated(dresid)) deallocate(dresid,stat=ier)
    call sic_delvariable ('RESIDUAL',.false.,error)
    if (allocated(datten)) deallocate(datten,stat=ier)
    if (allocated(d_mask)) deallocate(d_mask,stat=ier)
    if (allocated(d_list)) deallocate(d_list,stat=ier)
    call sic_delvariable ('THEMASK',.false.,error)
  endif
  !
  call gildas_null(hclean)
  call gdf_copy_header(hdirty,hclean,error)       ! Define header in all cases...
  !
  ! Clean image is either CLEAN or SKY
  if (user_method%mosaic) then
    call gdf_copy_header(hdirty,hsky,error)       ! Define header ?
    if (.not.allocated(dsky)) then
      allocate(dsky(nx,ny,nc),stat=ier)
      if (ier.ne.0) then
        call map_message(seve%e,rname,'Sky Memory allocation failure')
        error = .true.
        return
      endif
      call sic_mapgildas ('SKY',hsky,error,dsky)
    endif  
  else
    if (.not.allocated(dclean)) then
      allocate(dclean(nx,ny,nc),stat=ier)
      if (ier.ne.0) then
        call map_message(seve%e,rname,'Clean Memory allocation failure')
        error = .true.
        return
      endif
      call sic_mapgildas ('CLEAN',hclean,error,dclean)
    endif
  endif
  !
  if (.not.allocated(dresid)) then
    hresid = hdirty
    allocate(dresid(nx,ny,nc),stat=ier)
    if (ier.ne.0) then
      call map_message(seve%e,rname,'Residual Memory allocation failure')
      error = .true.
      return
    endif
    call sic_mapgildas('RESIDUAL',hresid,error,dresid)
  endif
  !
  if (.not.allocated(d_mask)) then
    allocate(d_mask(nx,ny),d_list(nx*ny),stat=ier)
    if (ier.ne.0) then
      call map_message(seve%e,rname,'Mask & List memory allocation failure')
      error = .true.
      return
    endif
    call sic_def_inte_addr ('THEMASK',d_mask,2,hdirty%gil%dim,   &
     &      .true.,error)
    user_method%do_mask = .true.
  endif
  !
  if (user_method%do_mask) then
    user_method%nlist = 0
  endif
  !
  ! Clean Component Table
  !
  ! Must define M_ITER before allocating space
!  m_iter = user_method%m_iter
  if (user_method%m_iter.eq.0) then
     call beam_unit_conversion(user_method)
     call copy_method(user_method,the_method)
     call check_area(the_method,hdirty,.true.)
!     m_iter = method%m_iter
  else
     call copy_method(user_method,the_method)
  endif
  !
  ! Allocate weight and check beam/image compatibility
  ! Weights are only defined if a Mosaic is treated.
  call gildas_null(hatten)
  call sic_delvariable ('WEIGHT',.false.,error)
  !
  if (user_method%mosaic) then
    !  Mosaic mode check...
    if (hbeam%gil%dim(3).ne.hprim%gil%dim(1)) then
      call map_message(seve%e,rname, &
      & 'MOSAIC mode: Beam and Primary have different number of pointings')
      error = .true.
    endif
    !
    if (hbeam%gil%dim(hbeam%gil%faxi).ne.hprim%gil%dim(4)) then
      call map_message(seve%e,rname, &
      & 'MOSAIC mode: Beam and Primary have different number of Frequencies')
      error = .true.
    endif
    if (error) return
    nb = hbeam%gil%dim(4)
    !
    call gdf_copy_header(hdirty,hatten,error)        ! Define header in all cases...
    hatten%gil%dim(3) = hbeam%gil%dim(4)            ! Number of frequency beams
    hatten%gil%convert(:,3) = hbeam%gil%convert(:,4)
    hatten%char%code(3) = hbeam%char%code(4)
    hatten%gil%ndim = 3          ! No spectral channels, but frequency beams
    hatten%loca%size = nx*ny*nb  ! It differs from that of hdirty !...
    !
    if (.not.allocated(datten)) then
      allocate(datten(nx,ny,nb),stat=ier)
      if (ier.ne.0) then
        call map_message(seve%e,rname,'Memory allocation failure')
        error = .true.
        return
      endif
      user_method%atten => datten
    endif
    ! Define the WEIGHT variable
    call sic_mapgildas('WEIGHT',hatten,error,datten)
    !
  elseif (hbeam%gil%dim(3).ne.1) then
    if (hbeam%gil%ndim.eq.3) then
      ! In Single-Field images, 3rd axis is Frequency
      if (hbeam%gil%dim(3).ne.hdirty%gil%dim(3)) then
        call map_message(seve%w,rname,'Different beam and image spectral resolution, '// &
        'not fully tested yet')
        !! error = .true.
        ! Single field verification
      endif
    else
      ! 4-D beam means a Mosaic for sure.
      ! In Single-Field images, 3rd axis is Frequency
      if (hbeam%char%code(3).ne.'VELOCITY') then
        !!
        call map_message(seve%e,rname,'More than 1 pointing, and Mosaic mode OFF')
        error = .true.
      endif
    endif
  endif
  !
  ! Frequency matching case - The ordering is LMVF - 
  if (hbeam%gil%dim(4).le.1) then
    continue
  elseif (hbeam%gil%dim(3).ne.hdirty%gil%dim(3)) then
    call map_message(seve%w,rname,'Different beam and image spectral resolution, '// &
    'not fully tested yet')
    !! error = .true.
  endif
  !
end subroutine clean_data

!
subroutine uv_baseline_comm(line,error)
  use gkernel_interfaces
  use gbl_message
  use clean_arrays
  use uvsplit_mod
  use imager_interfaces, only : uv_filter_base, opt_filter_base, &
    map_message
  !---------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- Support routine for command UV_BASELINE
  !
  !   UV_BASELINE [Degree] /CHANNEL ListVariable [/ZERO]  
  !   UV_BASELINE [Degree] /FREQUENCIES ListFreq /WIDTH Width  
  !   UV_BASELINE [Degree] /VELOCITIES ListVelo /WIDTH Width  
  !   UV_BASELINE [Degree] /RANGE Min Max [TYPE]  
  !      [/FILE FileIn [FileOut]]  
  !
  ! Subtract a continuum baseline, ignoring a list of channels
  ! in the current UV data set.
  !!
  !---------------------------------------------------------------------
  character(len=*), intent(inout) :: line  !! Command line
  logical, intent(out) :: error            !! Error flag
  !
  character(len=*), parameter :: rname='UV_BASELINE'
  integer :: degree
  !
  degree = 0
  call sic_i4(line,0,1,degree,.false.,error)
  if (error) return
  if (degree.ne.0 .and. degree.ne.1) then
    call map_message(seve%e,rname,'Only degree 0 or 1 supported')
    error = .true.
    return
  endif
  !
  call opt_filter_base(line,rname,error)
  if (error) return
  ! Argument ZERDEG is set to the specified Degree
  call uv_filter_base ('UV_BASELINE',line,error,rname,degree)
  ! 
  if (sic_present(opt_file,0)) return
  ! Reset Channel Flags
  huv_current%img%flags = 1
end subroutine uv_baseline_comm
!
subroutine uv_filter_comm(line,error)
  use gkernel_interfaces
  use imager_interfaces, only : uv_filter_base, map_message
  use gbl_message
  use uvsplit_mod
  !---------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER  support routine for command UV_FILTER
  !
  !   UV_FILTER  /CHANNEL ListVariable [/ZERO]  
  !   UV_FILTER  /FREQUENCIES ListFreq /WIDTH Width [UNIT]  
  !   UV_FILTER  /VELOCITY ListVelo /WIDTH Width [UNIT]  
  !   UV_FILTER  /RANGE Min Max [TYPE]  
  !     [/FILE FileIn [FileOut]]
  !
  ! "Filter", i.e. flag, a list of channels in the current UV
  ! data set. Flagging is reversible, unless the /ZERO option is
  ! present. With /ZERO, the "filtered" visibilities are set to zero.
  !!
  !---------------------------------------------------------------------
  character(len=*), intent(inout) :: line  !! Command line
  logical, intent(out) :: error            !! Error flag
  !
  character(len=*), parameter :: rname='UV_FILTER'
  !
  integer :: zero
  !
  if (sic_present(opt_zero,0)) then
    if (sic_present(opt_reset,0)) then
      call map_message(seve%e,rname,'Incompatible options /ZERO and /RESET')
      error = .true.
      return
    endif
    zero = 0    ! /ZERO   Nullify data
  else if (sic_present(opt_reset,0)) then
    zero = -1   ! /RESET  Unflag
  else
    zero = 1    ! Flag data
  endif
  !
  call opt_filter_base(line,rname,error)
  if (error) return
  ! ZERDEG is set to ZERO, which is -1,0,1 according to options.
  call uv_filter_base ('UV_FILTER',line,error,rname,zero)
end subroutine uv_filter_comm
!
subroutine uv_split_comm(line,error)
  use gkernel_interfaces
  use gbl_message
  use imager_interfaces, only : uv_filter_base, opt_filter_base, &
    & map_message
  !---------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- Support routine for command UV_SPLIT 
  !
  !   UV_SPLIT [Degree] /CHANNEL ListVariable [/ZERO]  
  !   UV_SPLIT [Degree] /FREQUENCIES ListFreq /WIDTH Width  
  !   UV_SPLIT [Degree] /VELOCITIES ListVelo /WIDTH Width  
  !   UV_SPLIT [Degree] /RANGE Min Max [TYPE]  
  !      /FILE FileIn [FileLine [FileCont]
  !
  ! Subtract a continuum baseline, ignoring a list of channels
  ! in UV data set. Create two output UV tables from this:
  !   - a line free one, 
  !   - a continuum free one
  !!
  !---------------------------------------------------------------------
  character(len=*), intent(inout) :: line  !! Command line
  logical, intent(out) :: error            !! Error flag
  !
  character(len=*), parameter :: rname='UV_SPLIT'
  external :: t_split
  integer :: degree
  !
  degree = 0
  call sic_i4(line,0,1,degree,.false.,error)
  if (error) return
  if (degree.ne.0 .and. degree.ne.1) then
    call map_message(seve%e,rname,'Only degree 0 or 1 supported')
    error = .true.
    return
  endif
  !
  call opt_filter_base(line,rname,error)
  if (error) return
  call uv_filter_base ('UV_SPLIT',line,error,rname,degree)
end subroutine uv_split_comm
!
subroutine opt_filter_base(line,rname,error)
  use gkernel_interfaces
  use uvsplit_mod
  use clean_def
  use clean_arrays
  use clean_default
  use clean_types
  use gbl_message
  use imager_interfaces, except_this => opt_filter_base
  !---------------------------------------------------------------------
  ! @ private
  !
  ! IMAGER  support routine for
  !   UV_FILTER  /CHANNEL ListVariable [/ZERO]
  !   UV_FILTER  /FREQUENCIES ListFreq /WIDTH Width [UNIT]
  !   UV_FILTER  /VELOCITY ListVelo /WIDTH Width [UNIT]
  !   UV_FILTER  /RANGE Min Max [TYPE]
  !      [/FILE FileIn [FileOut]]
  !
  ! Parse the /FILE option
  !---------------------------------------------------------------------
  character(len=*), intent(inout) :: line  !! Command line
  character(len=*), intent(in) :: rname    !! Command name
  logical, intent(out) :: error            !! Error flag
  !
  ! Constants
  real(kind=8), parameter :: pi=3.14159265358979323846d0
  real(kind=8), parameter :: f_to_k = 2.d0*pi/299792458.d-6
  !
  ! Local ---
  type(gildas) :: htmp
  real :: uvmax, uvmin
  real(8) :: freq
  integer :: msize, mc, nchan
  type (uvmap_par) :: map
  integer :: n
  integer :: channels(3)
  logical :: present, err
  !
  ! Code ----
  if (sic_present(opt_file,0)) then
    call gildas_null(hiuv,type='UVT')
    call gildas_null(houv,type='UVT')
    call sic_ch(line,opt_file,1,in_file,n,.true.,error)
    if (error) return
    call sic_parse_file(in_file,' ','.uvt',hiuv%file)
    !
    ! Strip extension if present
    call sic_parsef(in_file,ou_file,' ','.uvt')
    ou_file = in_file
    !
    ! Line (continuum-Free) UV table
    if (sic_present(2,opt_file)) then
      call sic_ch(line,opt_file,2,ou_file,n,.true.,error)
    else if (rname.eq.'UV_FILTER') then
      ou_file = trim(in_file)//'-noline'
    else
      ou_file = trim(in_file)//'-nocont'
    endif
    call sic_parse_file(ou_file,' ','.uvt',houv%file)
    !
    call gdf_read_header(hiuv,error)
    if (error) return
    !
    call gdf_copy_header(hiuv,houv,error)
    !
    call gdf_create_image(houv,error)
    if (error) return
    !
    ! Set the Blocking Factor
    nblock = space_nitems('SPACE_IMAGER',hiuv,1)
    use_file = .true.
    !
    ! Continuum (line-Free) UV table
    if (rname.eq.'UV_SPLIT') then
      call gildas_null(hfuv,type='UVT')
      call gdf_copy_header(hiuv,hfuv,error)
      if (sic_present(3,opt_file)) then
        call sic_ch(line,opt_file,3,ou_file,n,.true.,error)
      else
        ou_file = trim(in_file)//'-cont'
      endif
      call sic_parse_file(ou_file,' ','.uvt',hfuv%file)
      !
      ! Define the compression factor
      channels = 0
      ncompr = 1
      !
      msize = maxval(default_map%size)
      present = .false.
      if (msize.eq.0) then
        map = default_map
        if (hfuv%gil%basemax.eq.0) then
          call map_message(seve%w,rname,'No Baseline extrema') 
          present = .true.
        else
          uvmax = hfuv%gil%basemax
          uvmin = hfuv%gil%basemin
          ! Now transform UVMAX in kiloWavelength (including 2 pi factor)
          freq = gdf_uv_frequency(hfuv)
          !! Print *,'UVmax min freq ',uvmax, uvmin, freq
          uvmax = uvmax*freq*f_to_k
          uvmin = uvmin*freq*f_to_k
          error = .false.
          ! This works on HUV only unfortunately - The call sequence
          ! should be changed at some time
          call gildas_null(htmp,type='UVT')
          call gdf_copy_header(huv_current,htmp,err)
          call gdf_copy_header(hfuv,huv_current,err)
          call map_parameters(rname,map,huv_current,freq,uvmax,uvmin,error)
          call gdf_copy_header(htmp,huv_current,err)
          if (error) return
          msize = maxval(map%size)
        endif
      endif
      call t_channel_sampling (rname,hiuv,channels(3),msize)
      !
      call sic_i4(line,0,2,channels(3),present,error)
      if (error) return
      !
      ! Ignore these for the time being
      !call sic_i4(line,0,3,channels(1),.false.,error)
      !call sic_i4(line,0,4,channels(2),.false.,error)
      !
      nchan = hfuv%gil%nchan
      ! Use the <0 convention to start from the end
      if (channels(1).lt.0) then
         channels(1) = max(1,nchan+channels(1))
      else
         channels(1) = min(max(1,channels(1)),nchan)
      endif
      if (channels(2).lt.0) then
         channels(2) = max(channels(1),nchan+channels(2))
      else if (channels(2).eq.0) then
         channels(2) = nchan
      else
         channels(2) = max(channels(1),min(nchan,channels(2)))
      endif
      nchan = channels(2)-channels(1)+1
      !
      ncompr = channels(3)
      mc = nchan/ncompr 
      if (mc*ncompr.ne.nchan) mc = mc+1
      !
      ! Edge of channel 0.5
      ! - before
      ! fmin = (0.5-oldref)*hfuv%gil%inc(1) + hfuv%gil%val(1)
      ! - after
      ! fmin = (0.5-newref)*ncompr*hfuv%gil%inc(1) + huvf%gil%val(1)
      ! so
      !  (0.5-newref)*ncompr*hfuv%gil%inc(1) = (0.5-hfuv%gil%ref(1))%hfuv%gil%inc(1)
      !  (0.5-newref)*ncompr = (0.5-oldref)
      ! newref = (oldref-0.5)/ncompr + 0.5
      hfuv%gil%ref(1) = (hfuv%gil%ref(1)-0.5d0)/ncompr + 0.5d0
      hfuv%gil%dim(1) = 7+3*mc+hfuv%gil%ntrail
      hfuv%gil%nchan = mc
      hfuv%gil%inc(1) = hfuv%gil%inc(1)*ncompr
      hfuv%gil%fres = ncompr*hfuv%gil%fres
      hfuv%gil%vres = ncompr*hfuv%gil%vres
      !
      call gdf_create_image(hfuv,error)
      if (error) return
    endif
  else
    call gildas_null(hiuv,type='UVT')
    if (huv_current%loca%size.eq.0) then
      call map_message(seve%e,rname,'No UV data loaded')
      error = .true.
      return
    endif
    if (huv_current%gil%nstokes.gt.1) then
      call map_message(seve%e,rname,'Only single polarization data supported')
      error = .true.
      return
    endif
    call gdf_copy_header(huv_current,hiuv,error)
    !
    use_file = .false.
  endif
end subroutine opt_filter_base
!
subroutine uv_filter_base(comm,line,error,rname,zerdeg)
  use gkernel_interfaces
  use gildas_def
  use gkernel_types
  use gbl_format
  use clean_types
  use clean_arrays
  use uvsplit_mod
  use gbl_message
  use iso_c_binding
  use imager_interfaces, only : map_message, out_range
  !---------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER  -- Support for  
  !   UV_FILTER or UV_BASELINE  /CHANNEL ListVariable [/ZERO]  
  !   UV_FILTER or UV_BASELINE  /FREQUENCIES ListFreq /WIDTH Width [UNIT]  
  !   UV_FILTER or UV_BASELINE  /VELOCITY ListVelo /WIDTH Width [UNIT]  
  !   UV_FILTER or UV_BASELINE  /RANGE Min Max [TYPE]  
  !      [/FILE FileIn [FileOut]]
  !
  ! "Filter", i.e. flag, a list of channels in the current UV
  ! data set. Flagging is reversible, using the /RESET option
  ! With /ZERO, the "filtered" visibilities are set to zero.
  !!
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: comm     !! Command name
  character(len=*), intent(inout) :: line  !! Command line
  logical, intent(out) :: error            !! Error flag
  character(len=*), intent(in) :: rname    !! Caller name
  integer, intent(in) :: zerdeg            !! Flag or Degree
  !
  ! Constants
  real(kind=8), parameter :: pi=3.14159265358979323846d0
  real(kind=8), parameter :: f_to_k = 2.d0*pi/299792458.d-6
  !
  ! Local ---
  real(8) :: drange(2)
  integer :: nn, nc(2)
  character(len=64) :: listname
  logical :: found
  type(sic_descriptor_t) :: desc
  integer :: nf, k, i, j, l, m, ichan, jchan, narg, ier
  real(8) :: freq, velo
  real(4) :: width
  type(c_ptr) :: cptr
  integer, pointer :: channels(:)
  real(kind=8), pointer :: freqs(:)
  integer :: na, nstyle
  integer, parameter :: mstyle=3
  character(len=12) :: vstyle(mstyle), astyle, argu
  data vstyle/'CHANNEL','FREQUENCY','VELOCITY'/
  !
  ! Code ----
  select case(comm)
  case ('UV_BASELINE')
    code_routine = code_baseline
  case ('UV_FILTER')
    code_routine = code_filter
  case ('UV_SPLIT')
    code_routine = code_split
  case default
    call map_message(seve%e,comm,'Unsupported command at this stage')
    error = .true.
    return
  end select
  !
  if (sic_present(opt_chan,0)) then
    narg = sic_narg(opt_chan)
    if (narg.gt.0) then
      call sic_ke(line,opt_chan,1,listname,na,.true.,error)
    else
      listname = 'PREVIEW%CHANNELS'
      na = len_trim(listname)
    endif
    !
    call sic_ch(line,opt_chan,1,listname,na,.false.,error)
    call sic_descriptor(listname,desc,found)
    if (.not.found) then
      desc%ndim = 1
      desc%dims(1) = 1
      desc%addr = locwrd(ichan)
      desc%type = fmt_i4
      if (narg.eq.0) then
        ichan = 0 
      else
        call sic_i4(line,opt_chan,1,ichan,.true.,error)
        if (error) then
          call map_message(seve%e,rname,'Variable '//trim(listname)//' does not exists')
          error = .true.
          return
        endif
      endif
    endif
    if (desc%type.ne.fmt_i4) then
      call map_message(seve%e,rname,'Variable '//trim(listname)//' must be Integer ')
      error = .true.
      return
    endif
    if (desc%ndim.ne.1) then
      call map_message(seve%e,rname,'Variable '//trim(listname)//' must have rank 1')
      error = .true.
      return
    endif
    call adtoad(desc%addr,cptr,1)
    nf = desc%dims(1)
    call c_f_pointer(cptr,channels,desc%dims(1:1))
    call t_routine (nf,channels,zerdeg,error)
    !
  else if (sic_present(opt_freq,0)) then
    width = abs(hiuv%gil%fres)  ! In MHz
    call sic_r4(line,opt_width,1,width,.false.,error)
    if (sic_present(opt_width,2)) then
      call sic_ke(line,opt_width,2,argu,na,.true.,error)
      call sic_ambigs (rname,argu,astyle,nstyle,vstyle,mstyle,error)
      select case(astyle)
        case ('CHANNEL')
          width = width*abs(hiuv%gil%fres)
        case ('VELOCITY')
          width = width*abs(hiuv%gil%fres/hiuv%gil%vres)
      end select
    endif
    width = 0.5*width
    !
    narg = sic_narg(opt_freq)
    allocate(channels(hiuv%gil%nchan),stat=ier)
    if (ier.ne.0) then
      call map_message(seve%e,rname,'Channels allocation error')
      error = .true.
      return
    endif
    k = 0
    !
    found = .false.
    if (narg.eq.1) then
      call sic_ke(line,opt_freq,1,listname,na,.true.,error)
      call sic_descriptor(listname,desc,found)
      if (found) then
        call adtoad(desc%addr,cptr,1)
        nf = desc%dims(1)
        call c_f_pointer(cptr,freqs,desc%dims(1:1))
      endif
    endif
    !
    if (.not.found) then
      allocate(freqs(narg),stat=ier)
      do i=1,narg
        call sic_r8(line,opt_freq,i,freqs(i),.true.,error)
        if (error) return
      enddo
      nf = narg
    endif
    !
    ! call freq_to_channel(hiuv,nf,freqs,k,channels)
    !
    do i=1,nf
      freq = freqs(i)
      if (hiuv%gil%fres.gt.0) then
        ichan = (freq-hiuv%gil%freq-width)/hiuv%gil%fres + hiuv%gil%ref(1)
        jchan = (freq-hiuv%gil%freq+width)/hiuv%gil%fres + hiuv%gil%ref(1)
      else
        ichan = (freq-hiuv%gil%freq+width)/hiuv%gil%fres + hiuv%gil%ref(1)
        jchan = (freq-hiuv%gil%freq-width)/hiuv%gil%fres + hiuv%gil%ref(1)
      endif
      !
      ! Set channels only once...
      do j=ichan,jchan
        if (j.lt.0 .or. j.gt.hiuv%gil%nchan) then
          cycle
        else
          m = 0
          do l=1,k
            if (channels(l).eq.j) then
              m = l
              exit
            endif
          enddo
          if (m.eq.0) then
            k = k+1
            channels(k) = j
          endif
        endif
      enddo
    enddo
    !
    call t_routine(k,channels,zerdeg,error)
    deallocate(channels)
    !
  else if (sic_present(opt_velo,0)) then
    width = abs(hiuv%gil%vres)  ! In km/s
    call sic_r4(line,opt_width,1,width,.false.,error)
    if (sic_present(opt_width,2)) then
      call sic_ke(line,opt_width,2,argu,na,.true.,error)
      call sic_ambigs (rname,argu,astyle,nstyle,vstyle,mstyle,error)
      select case(astyle)
        case ('CHANNEL')
          width = width*abs(hiuv%gil%vres)
        case ('FREQUENCY')
          width = width*abs(hiuv%gil%vres/hiuv%gil%fres)
      end select
    endif
    width = 0.5*width
    !
    narg = sic_narg(opt_velo)
    allocate(channels(hiuv%gil%nchan),stat=ier)
    if (ier.ne.0) then
      call map_message(seve%e,rname,'Channels allocation error')
      error = .true.
      return
    endif
    k = 0
    !
    do i=1,narg
      call sic_r8(line,opt_velo,i,velo,.true.,error)
      if (error) return
      if (hiuv%gil%vres.gt.0) then
        ichan = (velo-hiuv%gil%voff-width)/hiuv%gil%vres + hiuv%gil%ref(1)
        jchan = (velo-hiuv%gil%voff+width)/hiuv%gil%vres + hiuv%gil%ref(1)
      else
        ichan = (velo-hiuv%gil%voff+width)/hiuv%gil%vres + hiuv%gil%ref(1)
        jchan = (velo-hiuv%gil%voff-width)/hiuv%gil%vres + hiuv%gil%ref(1)
      endif
      !
      ! Set channels only once...
      do j=ichan,jchan
        if (j.lt.0 .or. j.gt.hiuv%gil%nchan) then
          cycle
        else
          m = 0
          do l=1,k
            if (channels(l).eq.j) then
              m = l
              exit
            endif
          enddo
          if (m.eq.0) then
            k = k+1
            channels(k) = j
          endif
        endif
      enddo
    enddo
    call t_routine(k,channels,zerdeg,error)
    deallocate(channels)
    !
  else if (sic_present(opt_range,0)) then
    call sic_r8 (line,opt_range,1,drange(1),.true.,error)
    if (error) return
    call sic_r8 (line,opt_range,2,drange(2),.true.,error)
    if (error) return
    call sic_ke (line,opt_range,3,argu,nn,.true.,error)
    if (error) return
    error = .false.
    call sic_ambigs (rname,argu,astyle,nstyle,vstyle,mstyle,error)
    if (error)  return
    call out_range(rname,astyle,drange,nc,hiuv,error)
    if (error) return
    narg = nc(2)-nc(1)+1
    allocate(channels(narg),stat=ier)
    if (ier.ne.0) then
      call map_message(seve%e,rname,'Channels allocation error')
      error = .true.
      return
    endif
    do i=1,narg
      channels(i) = i+nc(1)-1
    enddo
    call t_routine (narg,channels,zerdeg,error)
  else
    ! If no option, try as if /CHANNEL with no Arguments...
    listname = 'PREVIEW%CHANNELS'
    call sic_descriptor(listname,desc,found)
    if (.not.found) then
      if (zerdeg.eq.-1) then  
        ! Reset everything
        if (allocated(huv_current%img%flags)) huv_current%img%flags = 1
      else
        ! But to set it, we must have some information
        call map_message(seve%e,rname,'No PREVIEW and '// &
          &  ' missing option /CHANNEL, /FREQUENCY, /RANGE or /VELOCITY')
        error = .true.
      endif
      return
    endif
    if (desc%type.ne.fmt_i4) then
      call map_message(seve%e,rname,'Variable '//trim(listname)//' must be Integer ')
      error = .true.
      return
    endif
    if (desc%ndim.ne.1) then
      call map_message(seve%e,rname,'Variable '//trim(listname)//' must have rank 1')
      error = .true.
      return
    endif
    call adtoad(desc%addr,cptr,1)
    nf = desc%dims(1)
    call c_f_pointer(cptr,channels,desc%dims(1:1))
    call t_routine (nf,channels,zerdeg,error)
  endif
  !
  save_data(code_save_uv) = .true.
  !
  ! We do not use Buffers here - Need to play safe to force re-reading
  optimize(code_save_uv)%change = optimize(code_save_uv)%change+100
  !
end subroutine uv_filter_base
!
subroutine t_routine(mf,channels,zero,error)
  use gildas_def
  use uvsplit_mod
  use imager_interfaces, only : t_baseline, t_filter, t_split
  !---------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- Support routine for UV_BASELINE, UV_FILTER, UV_SPLIT
  !
  ! Dispatch according to "code_routine" (in uvsplit_mode)
  !!
  !---------------------------------------------------------------------
  integer, intent(in) :: mf           !! Number of channels
  integer, intent(in) :: channels(mf) !! Channels
  integer, intent(in) :: zero         !! Zero or not
  logical, intent(inout) :: error     !! Error flag
  !
  if (code_routine.eq.code_baseline) then
    call t_baseline(mf,channels,zero,error)
  else if (code_routine.eq.code_split) then
    call t_split(mf,channels,zero,error)
  else if (code_routine.eq.code_filter) then
    call t_filter(mf,channels,zero,error)
  else
    Print *,'invalid code in T_ROUTINE ',code_routine
    error = .true.
  endif
end subroutine t_routine
!
subroutine t_filter(mf,filter,zero,error)
  use gildas_def
  use image_def
  use clean_arrays
  use uvsplit_mod
  use gbl_message
  use imager_interfaces, only : filter_line, map_message
  !---------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER --  Support routine for UV_FILTER
  !
  !   Filter / Flag a list of channels
  !!
  !---------------------------------------------------------------------
  integer, intent(in) :: mf          !! Number of values
  integer, intent(in) :: filter(mf)  !! Channel list
  integer, intent(in) :: zero        !! Zero or not
  logical, intent(out) :: error      !! Error flag
  !
  character(len=*), parameter :: rname='UV_FILTER'
  !
  ! Local ---
  integer :: nf, nv, nc, i, ier, nfi, ndrop
  integer, allocatable :: filtre(:)
  integer :: nvisi, mvisi, ib
  character(len=120) :: mess
  !
  ! Code ---
  nc = hiuv%gil%nchan
  ndrop = nint(edge_drop*nc)
  nfi = mf + 2*ndrop
  allocate(filtre(nfi),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'Memory allocation error')
    error = .true.
    return
  endif
  !
  nf = 0
  do i=1,mf
    if (filter(i).gt.0 .and. filter(i).le.nc) then
      nf = nf+1
      filtre(nf) = filter(i)
    endif
  enddo
  !
  if (use_file) then
    !
    ! Drop EDGE_DROP at each edge
    do i=1,ndrop
      nf = nf+1
      filtre(nf) = i
    enddo
    do i=nc-ndrop+1,nc
      nf = nf+1
      filtre(nf) = i
    enddo
    !
    mvisi = nblock
    allocate(hiuv%r2d(hiuv%gil%dim(1),mvisi),stat=ier)
    if (ier.ne.0) then
      call map_message(seve%e,rname,'Memory allocation error')
      error = .true.
      return
    endif
    !
    do ib=1,hiuv%gil%dim(2),mvisi
      !
      ! Read the data
      write(mess,*) ib,' / ',hiuv%gil%dim(2),mvisi
      call map_message(seve%i,rname,mess)
      hiuv%blc(2) = ib
      hiuv%trc(2) = min(hiuv%gil%dim(2),ib-1+mvisi)
      nvisi = hiuv%trc(2)-hiuv%blc(2)+1
      call gdf_read_data(hiuv,hiuv%r2d,error)
      if (error) return
      !
      call filter_line(nc,nf,nvisi,hiuv%r2d,filtre,0)
      if (error) return
      !
      houv%blc = hiuv%blc
      houv%trc = hiuv%trc
      call gdf_write_data (houv,hiuv%r2d,error)
      if (error) return
    enddo
    call gdf_close_image(houv,error)
    if (error) return
    !
    call gdf_close_image(hiuv,error)
    if (error) return
    !
    call map_message(seve%i,rname,'Created '//trim(houv%file))
    error = .false.
    !
  else
    ! Just set the channel mask according to the "filtre" 
    if (allocated(huv_current%img%flags)) then 
      !
      ! Just remember the status of each channel
      do i=1,nf
        if ((filtre(i).gt.0).and.(filtre(i).le.huv_current%gil%nchan)) &
          & huv_current%img%flags(filtre(i)) = -zero  ! -1,0,1 
      enddo
    else
      call map_message(seve%w,rname,'No Channel Mask associated to UV data')
      !
      ! If we cannot, apply it here on the data
      nv = hiuv%gil%dim(2)
      call filter_line(nc,nf,nv,duv,filtre,zero)
    endif
  endif
  !
  deallocate (filtre)
end subroutine t_filter
!
subroutine filter_line(nc,nf,nv,visi,filtre,zero)
  !---------------------------------------------------------------------
  ! @ private-mandatory
  !*
  ! IMAGER --  Support routine for UV_FILTER 
  !
  !   Flag or set to Zero the line regions
  !!
  !---------------------------------------------------------------------
  integer, intent(in) :: nf          !! Number of good channels
  integer, intent(in) :: nv          !! Number of visibilities
  integer, intent(in) :: nc          !! Number of channels
  integer, intent(in) :: zero        !! Set to zero or Flag ?
  integer, intent(in) :: filtre(nf)  !! List of channels
  real, intent(inout) :: visi(:,:)   !! Visibilities
  !
  ! Local ---
  integer :: iv,i
  !
  ! Code ----
  select case (zero)
  case (1)
    !$OMP PARALLEL DEFAULT(none)  &
    !$OMP & SHARED(visi,nv,nf,filtre) &
    !$OMP & PRIVATE(iv,i)
    !$OMP DO
    do iv=1,nv
      do i=1,nf
        visi(7+3*filtre(i),iv) = -abs(visi(7+3*filtre(i),iv))
      enddo
    enddo  
    !$OMP END DO
    !$OMP END PARALLEL
  case (0)
    !$OMP PARALLEL DEFAULT(none) &
    !$OMP & SHARED(visi,nv,nf,filtre) &
    !$OMP & PRIVATE(iv,i)
    !$OMP DO
    do iv=1,nv
      do i=1,nf
        visi(5+3*filtre(i):7+3*filtre(i),iv) = 0
      enddo
    enddo
    !$OMP END DO
    !$OMP END PARALLEL
  case(-1)
    !$OMP PARALLEL DEFAULT(none) &
    !$OMP & SHARED(visi,nv,nf,filtre) &
    !$OMP & PRIVATE(iv,i)
    !$OMP DO
    do iv=1,nv
      do i=1,nf
        visi(7+3*filtre(i),iv) =  abs(visi(7+3*filtre(i),iv))
      enddo
    enddo
    !$OMP END DO
    !$OMP END PARALLEL
  end select
end subroutine filter_line
!
subroutine t_baseline(mf,filter,degree,error)
  use gildas_def
  use image_def
  use clean_arrays
  use uvsplit_mod
  use gbl_message
  use imager_interfaces, only : remove_base, map_message
  !---------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- Support routine for UV_BASELINE
  !
  !    Subtract a baseline with a list of channels to be ignored
  !!
  !---------------------------------------------------------------------
  integer, intent(in) :: mf          !! Number of values
  integer, intent(in) :: filter(mf)  !! Channel list
  integer, intent(in) :: degree      !! Polynomial degree
  logical, intent(out) :: error      !! Error flag
  !
  character(len=*), parameter :: rname='UV_BASELINE'
  !
  ! Local ---
  integer :: nf, nv, nc, i, j, ier
  integer, allocatable :: filtre(:)
  integer :: nvisi, mvisi, ib, fc, lc
  character(len=120) :: mess
  !
  ! Code ----
  error = .false.
  nv = hiuv%gil%nvisi ! not %dim(2)
  nc = hiuv%gil%nchan
  !
  ! FILTER contains the ones to be ignored.
  ! We must build the list of valid continuum channels...
  allocate(filtre(nc),stat=ier)
  if (ier.ne.0) then
    error = .true.
    return
  endif
  !
  nf = 0
  if (use_file) then
    fc = edge_drop*nc
    lc = (1.0-edge_drop)*nc
  else
    fc = 1
    lc = nc
  endif
  do i=1,nc
    nf = nf+1
    filtre(nf) = i
    do j=1,mf
      if (filter(j).eq.i) then
        nf = nf-1
        exit
      endif
    enddo
  enddo
  !
  if (use_file) then
    !
    mvisi = nblock
    !
    allocate(hiuv%r2d(hiuv%gil%dim(1),mvisi),stat=ier)
    if (ier.ne.0) then
      call map_message(seve%e,rname,'Memory allocation error')
      error = .true.
      return
    endif
    !
    do ib=1,hiuv%gil%nvisi,mvisi
      !
      ! Read the data
      write(mess,*) ib,' / ',hiuv%gil%nvisi,mvisi
      call map_message(seve%i,rname,mess)
      hiuv%blc(2) = ib
      hiuv%trc(2) = min(hiuv%gil%nvisi,ib-1+mvisi)
      nvisi = hiuv%trc(2)-hiuv%blc(2)+1
      call gdf_read_data(hiuv,hiuv%r2d,error)
      if (error) return
      !
      ! From data file, normally no need to unflag anything
      call remove_base(nf,nvisi,nc,hiuv%r2d,degree,filtre,mf,filter,error)
      if (error) return
      !
      houv%blc = hiuv%blc
      houv%trc = hiuv%trc
      call gdf_write_data (houv,hiuv%r2d,error)
      if (error) return
    enddo
    call gdf_close_image(houv,error)
    if (error) return
    !
    call gdf_close_image(hiuv,error)
    if (error) return
    !
    call map_message(seve%i,rname,'Created '//trim(houv%file))
    error = .false.
    !
  else
    call remove_base(nf,nv,nc,duv,degree,filtre,mf,filter,error)
  endif
  deallocate (filtre)
end subroutine t_baseline
!
subroutine remove_base(nf,nv,nc,visi,degree,filtre,nb,filter,error)
  !---------------------------------------------------------------------
  ! @ private-mandatory  
  !*
  ! IMAGER -- Support routine for UV_BASELINE
  !
  !   Remove a baseline in a UV data
  !!
  !---------------------------------------------------------------------
  integer, intent(in) :: nf           !! Number of good channels
  integer, intent(in) :: nv           !! Number of visibilities
  integer, intent(in) :: nc           !! Number of channels
  integer, intent(in) :: degree       !! Degree of polynomial
  integer, intent(in) :: filtre(:)    !! The channels to be considered
  integer, intent(in) :: nb           !! Number of filtered channels
  integer, intent(in) :: filter(:)    !! The filtered channels
  real, intent(inout) :: visi(:,:)    !! Visibilities
  logical, intent(out) :: error       !! Error flag
  !
  ! Local ---
  real, allocatable :: wreal(:), wimag(:), wx(:), wxx(:), wxy(:)
  integer :: iv,i,ier, enf
  real :: mreal, mimag, sx, sy, sxx, sxy, delta, a, b, w
  !
  ! Code ----
  error = .true.
  if (degree.eq.0) then
    enf = 1
  else
    enf = nf
  endif
  allocate(wreal(nf),wimag(nf),wx(enf),wxx(enf),wxy(enf),stat=ier)
  if (ier.ne.0) return
  !
  if (enf.eq.nf) then
    wx(:) = filtre(1:nf)
  endif
  error = .false.
  !
  !$OMP PARALLEL DEFAULT(none) &
  !$OMP & SHARED(nv,nf,visi,degree,nc,nb,filtre,filter) &
  !$OMP & PRIVATE(iv,w,wreal,wimag,mreal,mimag,i) &
  !$OMP & PRIVATE(sx,sy,sxx,sxy,wx,wxx,wxy,delta,a,b)
  !$OMP DO
  do iv=1,nv
    w = 0
    do i=1,nf
      wreal(i) = visi(5+3*filtre(i),iv)
      wimag(i) = visi(6+3*filtre(i),iv)
      ! Reset the Weights to > 0 (un-flagged) if any channel is unflagged
      if (visi(7+3*i,iv).gt.0) w = 1
    enddo
    !
    ! Compute the fitting polynomials.
    ! Filtre(:) is the channel number which can be used as abscissa
    ! For the time being, only mean value...
    if (degree.eq.0) then
      mreal = sum(wreal)/nf
      mimag = sum(wimag)/nf
      !
      ! Subtract
      do i=1,nc
        visi(5+3*i,iv) = visi(5+3*i,iv)-mreal
        visi(6+3*i,iv) = visi(6+3*i,iv)-mimag
      enddo
    else if (degree.eq.1) then
      ! This code actually does a poor job. There is not enough
      ! Signal to noise ratio to fit a linear baseline per Visibility
      sx = sum(wx)
      sy = sum(wreal)
      wxx(:) = wx**2
      sxx = sum(wxx)
      wxy(:) = wx*wreal
      sxy = sum(wxy)
      delta = (nf*sxx-sx**2)
      a = (sxx*sy-sx*sxy)/delta
      b = (nf*sxy-sx*sy)/delta
      do i=1,nc
        visi(5+3*i,iv) = visi(5+3*i,iv)-(a+b*i)
      enddo
      !
      sy = sum(wimag)
      wxx(:) = wx**2
      sxx = sum(wxx)
      wxy(:) = wx*wimag 
      sxy = sum(wxy)
      delta = (nf*sxx-sx**2)
      a = (sxx*sy-sx*sxy)/delta
      b = (nf*sxy-sx*sy)/delta
      do i=1,nc
        visi(6+3*i,iv) = visi(6+3*i,iv)-(a+b*i)
      enddo
      !
    endif
    !
    ! Remove the filter
    if (w.gt.0) then
      do i=1,nb
        visi(7+3*filter(i),iv) = abs(visi(7+3*filter(i),iv))
      enddo
    endif      
  enddo
  !$OMP END DO
  !$OMP END PARALLEL
  !
  if (degree.eq.0) then
    deallocate (wreal,wimag)
  else
    deallocate (wreal,wimag,wx,wxx,wxy)
  endif
  error = .false.
end subroutine remove_base
!
subroutine t_split(mf,filter,degree,error)
  use gildas_def
  use image_def
  use clean_arrays
  use gbl_message
  use uvsplit_mod
  use imager_interfaces, only : split_base_line, map_message
  !---------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- Support routine for UV_SPLIT
  !
  !    Subtract a baseline with a list of channels to be ignored
  !!
  !---------------------------------------------------------------------
  integer, intent(in) :: mf          !! Number of values
  integer, intent(in) :: filter(mf)  !! Channel list
  integer, intent(in) :: degree      !! Polynomial degree
  logical, intent(out) :: error      !! Error flag
  !
  character(len=*), parameter :: rname='UV_SPLIT'
  !
  ! Local ---
  integer :: nf, nv, nc, i, j, ier
  integer, allocatable :: filtre(:)
  integer :: nvisi, mvisi, ib, fc, lc, mc
  character(len=120) :: mess
  !
  ! Code ----
  error = .false.
  nv = hiuv%gil%nvisi !! not %dim(2)
  nc = hiuv%gil%nchan
  mc = hfuv%gil%nchan
  !
  ! FILTER contains the ones to be ignored.
  ! We must build the list of valid continuum channels...
  allocate(filtre(nc),stat=ier)
  if (ier.ne.0) then
    error = .true.
    return
  endif
  !
  nf = 0
  if (use_file) then
    fc = edge_drop*nc
    lc = (1.0-edge_drop)*nc
  else
    fc = 1
    lc = nc
  endif
  do i=fc,lc
    nf = nf+1
    filtre(nf) = i
    do j=1,mf
      if (filter(j).eq.i) then
        nf = nf-1
        exit
      endif
    enddo
  enddo
  !
  if (use_file) then
    !
    mvisi = nblock
    !
    allocate(hiuv%r2d(hiuv%gil%dim(1),mvisi),hfuv%r2d(hfuv%gil%dim(1),mvisi),stat=ier)
    if (ier.ne.0) then
      call map_message(seve%e,rname,'Memory allocation error')
      error = .true.
      return
    endif
    !
    do ib=1,hiuv%gil%nvisi,mvisi
      !
      ! Read the data
      write(mess,*) ib,' / ',hiuv%gil%nvisi,mvisi
      call map_message(seve%i,rname,mess)
      hiuv%blc(2) = ib
      hiuv%trc(2) = min(hiuv%gil%nvisi,ib-1+mvisi)
      nvisi = hiuv%trc(2)-hiuv%blc(2)+1
      call gdf_read_data(hiuv,hiuv%r2d,error)
      if (error) return
      !
      call split_base_line(nf,nvisi,nc,hiuv%r2d,mc,hfuv%r2d,degree,filtre,error)
      if (error) return
      !
      houv%blc = hiuv%blc
      houv%trc = hiuv%trc
      call gdf_write_data (houv,hiuv%r2d,error)
      if (error) return
      !
      hfuv%blc = hiuv%blc
      hfuv%trc = hiuv%trc
      call gdf_write_data (hfuv,hfuv%r2d,error)
    enddo
    call gdf_close_image(houv,error)
    if (error) return
    !
    call gdf_close_image(hiuv,error)
    if (error) return
    !
    call map_message(seve%i,rname,'Created '//trim(houv%file))
    call map_message(seve%i,rname,'Created '//trim(hfuv%file))
    !
    deallocate(hiuv%r2d,hfuv%r2d)
  else
    call map_message(seve%e,rname,'Programming error: SPLIT only valid with files')
    error = .true.
  endif
  deallocate (filtre)
end subroutine t_split
!
subroutine split_base_line(nf,nv,nc,visi,mc,cuv,degree,filtre,error)
  use uvsplit_mod
  use imager_interfaces, only : compress_uv
  !---------------------------------------------------------------------
  ! @ private-mandatory
  !*
  ! IMAGER --  Support routine for UV_SPLIT
  !
  !   Remove a baseline in a UV data, and produce the
  !   Continuum free and Line free UV tables from it.
  !   The Spectral Windows can be indicated by the options, including
  !   the default one derived by UV_PREVIEW.
  !!
  !---------------------------------------------------------------------
  integer, intent(in) :: nf         !! Number of good channels
  integer, intent(in) :: nv         !! Number of visibilities
  integer, intent(in) :: nc         !! Number of line channels
  integer, intent(in) :: mc         !! Number of continuum channels
  integer, intent(in) :: degree     !! Degree of polynomial
  integer, intent(in) :: filtre(nf) !! Channels with line
  real, intent(inout) :: visi(:,:)  !! Input line + continuum, output line
  real, intent(out) :: cuv(:,:)     !! Output continuum
  logical, intent(out) :: error     !! Error flag
  !
  ! Local ---
  real, allocatable :: wreal(:), wimag(:), wx(:), wxx(:), wxy(:)
  integer :: iv,i,ier, lc, lt, kt, nt, nstart, enf
  logical :: trail
  real :: mreal, mimag, sx, sy, sxx, sxy, delta, a, b
  real, allocatable :: xuv(:,:)
  !
  ! Code ----
  lt = ubound(visi,1)   ! Size of line visibility
  kt = ubound(cuv,1)    ! Size of continuum visibility
  lc = 7+3*NC
  nt = lt-lc
  !Print *,' IN LC ',lc,' LT ',lt,' NT ',nt
  !Print *,' OUT MC ',mc,' LT ',kt,' NT ',nt
  trail = nt.ne.0
  !
  if (degree.eq.0) then
    enf = 1
  else
    enf = nf
  endif
  allocate(wreal(nf),wimag(nf),xuv(lt,1),wx(enf),wxx(enf),wxy(enf),stat=ier)
  if (ier.ne.0) then
    error = .true.
    return
  endif
  if (enf.eq.nf) wx(1:nf) = filtre(1:nf)
  !
  !
  nstart = 1
  !
  do iv=1,nv
    !
    ! Copy  continuum and compress it if needed
    xuv = 0.0
    do i=1,nf
      wreal(i) = visi(5+3*filtre(i),iv)
      wimag(i) = visi(6+3*filtre(i),iv)
      xuv(5+3*filtre(i):7+3*filtre(i),1) = visi(5+3*filtre(i):7+3*filtre(i),iv)
    enddo
    if (trail) xuv(lc:,1) = visi(lc:,iv) 
    if (ncompr.eq.1) then
      cuv(1:7,iv) = visi(1:7,iv)
      cuv(8:,iv) = xuv(8:,1)
    else
      cuv(:,iv:iv) = 0.0
      call compress_uv(cuv(:,iv:iv), &
        & kt,     & ! Output visibility size
        & 1,      & ! Number of output visibilities
        & mc,     & ! Number of output channels
        & xuv,    & ! Input visibilities
        & lt,     & ! Input visibility size
        & ncompr, & ! Compression factor
        & nt)       ! Number of trailing columns
      cuv(1:7,iv) = visi(1:7,iv)
    endif
    !
    ! Compute the fitting polynomials.
    ! Filtre(:) is the channel number which can be used as abscissa
    if (degree.eq.0) then
      ! For the time being, only mean value...
      mreal = sum(wreal)/nf
      mimag = sum(wimag)/nf
      !
      ! Subtract
      do i=1,nc
        visi(5+3*i,iv) = visi(5+3*i,iv)-mreal
        visi(6+3*i,iv) = visi(6+3*i,iv)-mimag
      enddo
    else if (degree.eq.1) then
      ! This code actually does a poor job. There is not enough
      ! Signal to noise ratio to fit a linear baseline per Visibility
      sx = sum(wx)
      sy = sum(wreal)
      wxx(:) = wx**2
      sxx = sum(wxx)
      wxy(:) = wx*wreal
      sxy = sum(wxy)
      delta = (nf*sxx-sx**2)
      a = (sxx*sy-sx*sxy)/delta
      b = (nf*sxy-sx*sy)/delta
      do i=1,nc
        visi(5+3*i,iv) = visi(5+3*i,iv)-(a+b*i)
      enddo
      !
      sy = sum(wimag)
      wxx(:) = wx**2
      sxx = sum(wxx)
      wxy(:) = wx*wimag 
      sxy = sum(wxy)
      delta = (nf*sxx-sx**2)
      a = (sxx*sy-sx*sxy)/delta
      b = (nf*sxy-sx*sy)/delta
      do i=1,nc
        visi(6+3*i,iv) = visi(6+3*i,iv)-(a+b*i)
      enddo
    endif
  enddo
  !
  if (degree.eq.0) then
    deallocate (wreal,wimag)
  else
    deallocate (wreal,wimag,wx,wxx,wxy)
  endif
  error = .false.
end subroutine split_base_line
!
function space_nitems(name,head,last)
  use image_def
  use gkernel_interfaces, only: gdf_nitems
  !---------------------------------------------------------------------
  ! @ public
  !*
  ! IMAGER -- Utility routine
  !
  !   Returns the number of blocks in the last dimension
  !   according to the NAME logical name
  !!
  !--------------------------------------------------------------------- 
  character(len=*), intent(in) :: name  !! Caller name
  integer ::space_nitems           !! intent(out) function value
  type(gildas), intent(in) :: head !! Input Gildas header
  integer, intent(in) :: last      !! Last blocked dimension
  !
  ! Local ---
  integer :: nblock, mblock, i 
  integer(kind=8) :: dims     ! Size of a "row"
  integer(kind=8) :: rows     ! Number of "rows"
  !
  ! Code ----
  dims = 1
  do i=1,min(last,head%gil%ndim)
    if (head%gil%dim(i).gt.0) dims =dims*head%gil%dim(i)
  enddo
  !
  rows = 1
  do i=last,head%gil%ndim 
    if (head%gil%dim(i).gt.0) rows = rows*head%gil%dim(i)
  enddo
  !
  call gdf_nitems(name,nblock,dims)  ! "Rows" at once
  nblock = min(nblock,rows)
  mblock = (head%gil%dim(2)+nblock-1)/nblock   ! Number of blocks
  nblock = (head%gil%dim(2)+mblock-1)/mblock   ! Uniform block size
  !
  space_nitems = nblock
end function space_nitems

subroutine uv_map_comm(line,comm,error)
  use clean_arrays
  use clean_default
  use gbl_message
  use gkernel_interfaces
  use imager_interfaces, except_this => uv_map_comm
  !---------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- Support for commands
  ! UV_MAP or UV_RESTORE /FIELDS /RANGE /TRUNCATE  /CONTINUUM /INDEX  
  !   or  
  ! UV_SELF /RANGE /RESTORE
  !!
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: comm     !! Caller name
  character(len=*), intent(inout) :: line  !! Command line
  logical, intent(inout) :: error          !! Logical error flag
  !
  ! Constants
  real(kind=8), parameter :: pi=3.14159265358979323846d0
  real(kind=4), parameter :: sec_to_rad=pi/3600.0/180.0
  character(len=1), parameter :: question_mark='?'
  ! ' UV_MAP', '/TRUNCATE',  '/FIELDS', '/RANGE', '/CONTINUUM', '/INDEX'
  integer, parameter :: o_trunc=1
  integer, parameter :: o_field=2
  integer, parameter :: o_range=3
  integer, parameter :: o_cont=4
  integer, parameter :: o_index=5
  ! ' UV_SELF', '/RANGE', '/RESTORE'
  integer, parameter :: opt_rang=1  ! /RANGE Option for UV_SELF
  integer, parameter :: opt_rest=2  ! /RESTORE Option for UV_SELF
  !
  ! Local ---
  logical :: use_self, do_init
  logical :: true_mosaic   ! Distiniguish Mosaics from Single pointings
  integer :: ifi
  logical :: err, goon
  character(len=80) :: chain
  real :: offmax
  integer :: debug
  !
  ! Code ----
  call map_message(seve%t,comm,'Entering Uv_Map_Comm',seve%e)
  debug = 0
  call sic_get_inte('DEBUG_UVMAP',debug,error)
  error = .false.
  !
  ! Check command line syntax
  call map_query (line,comm,themap,goon,error) 
  if ((.not.goon).or.error) return
  !
  err = .false.
  use_self = comm.eq.'UV_SELF'      ! Self Calibration image !
  if (use_self) then
    if (huv_current%gil%column_pointer(code_uvt_if).ne.0) then
      call map_message(seve%e,comm, &
      & 'This UV table (probably a result of UV_CONTINUUM) is not suited for self-calibration')
      error = .true.
      return
    endif
  endif
  do_init = hself_self%loca%size.eq.0 .or. sic_present(opt_rang,0)
  !
  true_mosaic = themap%nfields.ne.0
  if (true_mosaic) then
    offmax = 0
    do ifi = 1,abs(themap%nfields)
      offmax = max(offmax,(themap%offxy(1,ifi)**2+themap%offxy(2,ifi)**2))
    enddo
    offmax = sqrt(offmax)/sec_to_rad
    if (offmax.lt.mosaic_tolerance) then
      if (huv_current%gil%nteles.le.1) then
        write(chain,'(A,F8.4,A,F8.4,A)') 'Treating tiny mosaic as a single field (Size ', &
          & offmax,' < Tolerance ',mosaic_tolerance,') '
        call map_message(seve%w,comm,chain)
        true_mosaic = .false.
      else
        chain = 'Mosaic with more than 1 primary beam'
        call map_message(seve%w,comm,chain)
        true_mosaic = .true.
      endif
    endif
  endif
  !
  if (true_mosaic) then
    call uv_map_mosaic(line,comm,error)
  else
    call uv_map_single(line,comm,error)
  endif
  !
  if (comm.eq.'UV_RESTORE') then
    if (true_mosaic) then
      last_shown = 'SKY'
    else
      last_shown = 'CLEAN'
    endif
  else
    last_shown = 'DIRTY'
  endif
  call check_view(1,last_shown)  ! Force VIEW re-computation for this
  !
  call map_message(seve%t,comm,'Uv_Map_Comm -- Finished',-2)
end subroutine uv_map_comm
!
subroutine uv_map_single(line,comm,error)
  use clean_arrays
  use clean_default
  use gbl_message
  use gkernel_interfaces
  use imager_interfaces, except_this => uv_map_single
  !---------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- Support for commands
  ! UV_MAP or UV_RESTORE /FIELDS /RANGE /TRUNCATE  /CONTINUUM /INDEX  
  !   or  
  ! UV_SELF /RANGE /RESTORE
  !!
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: comm     !! Caller name
  character(len=*), intent(inout) :: line  !! Command line
  logical, intent(inout) :: error          !! Logical error flag
  !
  ! Constants
  real(kind=8), parameter :: pi=3.14159265358979323846d0
  real(kind=4), parameter :: sec_to_rad=pi/3600.0/180.0
  character(len=1), parameter :: question_mark='?'
  ! ' UV_MAP', '/TRUNCATE',  '/FIELDS', '/RANGE', '/CONTINUUM', '/INDEX'
  integer, parameter :: o_trunc=1
  integer, parameter :: o_field=2
  integer, parameter :: o_range=3
  integer, parameter :: o_cont=4
  integer, parameter :: o_index=5
  ! ' UV_SELF', '/RANGE', '/RESTORE'
  integer, parameter :: opt_rang=1  ! /RANGE Option for UV_SELF
  integer, parameter :: opt_rest=2  ! /RESTORE Option for UV_SELF
  ! Memories ...
  logical, save :: use_cont=.false.
  logical, save :: do_self=.false.
  !
  ! Local ---
  type(gildas) :: huv_local
  !
  type(imaging_mode) :: tmp_mode
  logical :: use_self, do_cct, do_init
  integer :: nline, ier
  character(len=16) :: acomm
  logical :: err, goon
  character(len=80) :: chain, string
  integer :: debug
  !
  ! Code ----
  call map_message(seve%t,comm,'Entering Uv_Map_Single',seve%e)
  debug = 0
  call sic_get_inte('DEBUG_UVMAP',debug,error)
  error = .false.
  !
  ! Check command line syntax
  call map_query (line,comm,themap,goon,error) 
  if ((.not.goon).or.error) return
  !
  err = .false.
  use_self = comm.eq.'UV_SELF'      ! Self Calibration image !
  if (use_self) then
    if (huv_current%gil%column_pointer(code_uvt_if).ne.0) then
      call map_message(seve%e,comm, &
      & 'This UV table (probably a result of UV_CONTINUUM) is not suited for self-calibration')
      error = .true.
      return
    endif
  endif
  do_init = hself_self%loca%size.eq.0 .or. sic_present(opt_rang,0)
  !
  !
  call sub_mosaic('OFF',error)
  call gildas_null(huv_local,type='UVT')
  !
  ! Single-Field, New version
  if (use_self) then
    !
    string = defmap_center
    if (.not.do_self) do_weig = .true.
    !
    ! Self-calibrated data 
    do_cct = sic_present(opt_rest,0) ! /RESTORE option
    if (.not.do_cct) then
      if (hself_self%loca%size.eq.0 .or. sic_present(opt_rang,0)) then
        call init_selfcal('UV_SELF',line,error)
        if (error) return
        ! ! call uv_dump_buffers('UV_SELF *')
        line = 'UV_SELF'
        nline = len_trim(line)
        call sic_analyse(acomm,line,nline,error)
      endif
    else 
      if (hself_self%loca%size.eq.0) then
        call map_message(seve%e,comm,'/RESTORE  Self calibrated UV data not defined')
        error = .true.
      else if (sic_narg(opt_rang).ge.0) then
        call map_message(seve%e,comm,'/RESTORE  conflicts with /RANGE')
        error = .true.
      endif
    endif
    if (error) return  
    !
    ! Here, sub_map_single works because the UV table is already sorted...
    call sub_map_single(comm,line,the_method,hself_self,do_cct,error)
    defmap_center = string          ! Restore MAP_CENTER
    hself_self%img%mode = code_img_cont
    if (error) return
    do_self = .true.
  else
    ! Normal UV_MAP or UV_RESTORE
    string = defmap_center
    do_self = .false.
    !
    ! Select current data set or possibly its Continuum sibbling 
    do_cct = comm.eq.'UV_RESTORE'
    ! In a UV_RESTORE command, USE_CONT is remembered from last UV_MAP command
    ! In a UV_MAP command, USE_CONT is defined by the /CONT option
    if (.not.do_cct) use_cont = sic_present(o_cont,0)
    !
    if (use_cont) then
      !
      ! Select Continuum data set (UV_MAP /CONT or UV_RESTORE after a UV_MAP /CONT)
      call switch_uv_cont(line,comm,do_cct,error)
      if (error) return
      !
      ! Perform the imaging
      if (do_cct) then
        call print_imaging(comm,'DO_CCT ',huv_cont%img) 
        defmap_center = ' '   ! The Continuum UV data has already been shifted
      endif
      tmp_mode = huv_cont%img ! Save the initial imaging mode
      call sub_map_single(comm,line,the_method,huv_cont,do_cct,error) 
      defmap_center = string 
      if (error) return
      !
      if (do_cct) then
        ! There can be a size mis-match here ...
        if (any(hcont%gil%dim(1:2).ne.hclean%gil%dim(1:2))) then
          write(chain,'(A,I0,A,I0,A)') 'Re-sizing continuum image to [', &
            &   hclean%gil%dim(1),',',hclean%gil%dim(2),']'
          call map_message(seve%w,comm,chain)
          deallocate(dcont,stat=ier)
          allocate(dcont(hclean%gil%dim(1),hclean%gil%dim(2)),stat=ier)
          call gdf_copy_header(hclean,hcont,error)
          hcont%gil%ndim = 2
          hcont%loca%size = hcont%gil%dim(1)*hcont%gil%dim(2)
          call sic_delvariable('CONTINUUM',.false.,error)
          call sic_mapgildas ('CONTINUUM',hcont,error,dcont)
        endif          
        !
        dcont(:,:) = dclean(:,:,1) ! Update CONTINUUM image too
        hcont%gil%minloc = hclean%gil%minloc
        hcont%gil%maxloc = hclean%gil%maxloc
        hcont%gil%rmin = hclean%gil%rmin
        hcont%gil%rmax = hclean%gil%rmax
      else
        do_continuum = .true.  ! Next CLEAN, there will be a CONTINUUM image
      endif
      saved_chan = tmp_mode  ! Restore the proper imaging mode
      huv_current%img = saved_chan
      huv_current%img%mode = code_img_cont
    else
      ! Cube Mode ---
      ! Select the data set. Can be UV_DATA, UV_MODEL, or UV_RESIDUAL
      if (current_uvdata.eq.'DATA_UV') then
        if (do_cct) defmap_center = ' '
        call sub_map_single(comm,line,the_method,huv_current,do_cct,error) 
        defmap_center = string
        huv_current%img%bounds = saved_chan%bounds
        huv_current%img%mode = code_img_line 
      else if (.true.) then
        call gildas_null (huv_local,type='UVT')
        call uv_select_data(comm,huv_local,error)
        if (do_cct) defmap_center = ' '
        call sub_map_single(comm,line,the_method,huv_local,do_cct,error) 
        defmap_center = string
        huv_local%img%bounds = saved_chan%bounds
        huv_local%img%mode = code_img_line !! This may not work...
      endif
      do_continuum = .false.  ! Next CLEAN will be no CONTINUUM
    endif
    if (error) return
  endif
  !
  if (.not.do_cct) call no_mosaic(comm)
  !
  call map_message(seve%t,comm,'Uv_Map_Single  -- Finished',-2)
end subroutine uv_map_single

subroutine cascade ( n, t_length, t, c_length, c, s )

!
!
!! cascade() carries out the cascade algorithm.
!
!  Discussion:
!
!    The value of T3 computed by
!
!      call cascade ( 3, t_length, t0, c_length, c, t3 )
!
!    will be the same if computed in three steps by:
!
!      call cascade ( 1, t_length, t0, c_length, c, t1 )
!      call cascade ( 1, t_length, t1, c_length, c, t2 )
!      call cascade ( 1, t_length, t2, c_length, c, t3 )
!
!    If C represents a vector of Daubechies filter coefficients, then
!
!      call cascade ( 5, c_length, c, c_length, c, c5 )
!
!    computes an approximation to the corresponding scaling function, and
!
!      call r8vec_conjugate ( c_length, c, w )
!      call cascade ( 5, c_length, w, c_length, c, w5 )
!
!    computes an approximation to the corresponding wavelet.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license.
!
!  Modified:
!
!    13 August 2011
!
!  Author:
!
!    John Burkardt
!
!  Parameters:
!
!    Input, integer N, the number of iterations to carry out.
!    0 <= N.
!
!    Input, integer T_LENGTH, the length of T.
!
!    Input, real ( kind = rk ) T(T_LENGTH), the initial value of the quantity, 
!    or the value of the quantity at the integers 0 through P-1.
!
!    Input, integer C_LENGTH, the number of transform coefficients.
!
!    Input, real ( kind = rk ) C(C_LENGTH), the transform coefficients.
!
!    Output, real ( kind = rk ) S(2^N * T_LENGTH + (2^N-1)*C_LENGTH - 2*(2^N-1)),
!    the values of  the function.
!
  implicit none

  integer, parameter :: rk = kind ( 1.0D+00 )

  integer c_length
  integer n
  integer t_length

  real ( kind = rk ) c(c_length)
  integer i
  real ( kind = rk ) s(*)
  integer s_length
  real ( kind = rk ) t(t_length)
  integer x_length
  real ( kind = rk ), allocatable :: x(:)

  s_length = t_length

  s(1:t_length) = t(1:t_length)

  do i = 1, n

    x_length = s_length * 2 - 1

    allocate ( x(1:x_length) )

    x(1:x_length  :2) = s(1:s_length)
    x(2:x_length-1:2) = 0.0D+00

    call r8vec_convolution ( x_length, x, c_length, c, s )

    deallocate ( x )

    s_length = x_length + c_length - 1

  end do

  return
end
subroutine daub_coefficients ( n, c )

!
!! DAUB_COEFFICIENTS returns a set of Daubechies coefficients.
!
!  Discussion:
!
!    Often, the uses to which these coefficients are applied require that they
!    be rescaled, by being multiplied by sqrt ( 2 ).
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license.
!
!  Modified:
!
!    13 August 2011
!
!  Author:
!
!    John Burkardt
!
!  Parameters:
!
!    Input, integer N, the order of the coefficient set.
!    2 <= N <= 20, and N must be even.
!
!    Output, real ( kind = rk ) C(N), the coefficients.
!
  implicit none

  integer, parameter :: rk = kind ( 1.0D+00 )

  integer n

  real ( kind = rk ) c(n)

  if ( n == 2 ) then

    c = (/ &
      7.071067811865475D-01, &
      7.071067811865475D-01 /)

  else if ( n == 4 ) then

    c = (/ &
      0.4829629131445341D+00, &
      0.8365163037378079D+00, &
      0.2241438680420133D+00, &
    - 0.1294095225512603D+00 /)

  else if ( n == 6 ) then

    c = (/ &
      0.3326705529500826D+00, &
      0.8068915093110925D+00, &
      0.4598775021184915D+00, &
    - 0.1350110200102545D+00, &
    - 0.8544127388202666D-01, &
      0.3522629188570953D-01 /)

  else if ( n == 8 ) then

    c = (/ &
      0.2303778133088965D+00, &
      0.7148465705529156D+00, &
      0.6308807679298589D+00, &
     -0.2798376941685985D-01, &
     -0.1870348117190930D+00, &
      0.3084138183556076D-01, &
      0.3288301166688519D-01, &
     -0.1059740178506903D-01 /)

  else if ( n == 10 ) then

    c = (/ &
      0.1601023979741929D+00, &
      0.6038292697971896D+00, &
      0.7243085284377729D+00, &
      0.1384281459013207D+00, &
     -0.2422948870663820D+00, &
     -0.3224486958463837D-01, &
      0.7757149384004571D-01, &
     -0.6241490212798274D-02, &
     -0.1258075199908199D-01, &
      0.3335725285473771D-02 /);

  else if ( n == 12 ) then

    c = (/ &
      0.1115407433501094D+00, &
      0.4946238903984530D+00, &
      0.7511339080210953D+00, &
      0.3152503517091976D+00, &
     -0.2262646939654398D+00, &
     -0.1297668675672619D+00, &
      0.9750160558732304D-01, &
      0.2752286553030572D-01, &
     -0.3158203931748602D-01, &
      0.5538422011614961D-03, &
      0.4777257510945510D-02, &
     -0.1077301085308479D-02 /)

  else if ( n == 14 ) then

    c = (/ &
       7.785205408500917D-02, &
       3.965393194819173D-01, &
       7.291320908462351D-01, &
       4.697822874051931D-01, &
      -1.439060039285649D-01, &
      -2.240361849938749D-01, &
       7.130921926683026D-02, &
       8.061260915108307D-02, &
      -3.802993693501441D-02, &
      -1.657454163066688D-02, &
       1.255099855609984D-02, &
       4.295779729213665D-04, &
      -1.801640704047490D-03, &
       3.537137999745202D-04 /)

  else if ( n == 16 ) then

    c = (/ &
       5.441584224310400D-02, &
       3.128715909142999D-01, &
       6.756307362972898D-01, &
       5.853546836542067D-01, &
      -1.582910525634930D-02, &
      -2.840155429615469D-01, &
       4.724845739132827D-04, &
       1.287474266204784D-01, &
      -1.736930100180754D-02, &
      -4.408825393079475D-02, &
       1.398102791739828D-02, &
       8.746094047405776D-03, &
      -4.870352993451574D-03, &
      -3.917403733769470D-04, &
       6.754494064505693D-04, &
      -1.174767841247695D-04 /)

  else if ( n == 18 ) then

    c = (/ &
       3.807794736387834D-02, &
       2.438346746125903D-01, &
       6.048231236901111D-01, &
       6.572880780513005D-01, &
       1.331973858250075D-01, &
      -2.932737832791749D-01, &
      -9.684078322297646D-02, &
       1.485407493381063D-01, &
       3.072568147933337D-02, &
      -6.763282906132997D-02, &
       2.509471148314519D-04, &
       2.236166212367909D-02, &
      -4.723204757751397D-03, &
      -4.281503682463429D-03, &
       1.847646883056226D-03, &
       2.303857635231959D-04, &
      -2.519631889427101D-04, &
       3.934732031627159D-05 /)

  else if ( n == 20 ) then

    c = (/ &
       2.667005790055555D-02, &
       1.881768000776914D-01, &
       5.272011889317255D-01, &
       6.884590394536035D-01, &
       2.811723436605774D-01, &
      -2.498464243273153D-01, &
      -1.959462743773770D-01, &
       1.273693403357932D-01, &
       9.305736460357235D-02, &
      -7.139414716639708D-02, &
      -2.945753682187581D-02, &
       3.321267405934100D-02, &
       3.606553566956169D-03, &
      -1.073317548333057D-02, &
       1.395351747052901D-03, &
       1.992405295185056D-03, &
      -6.858566949597116D-04, &
      -1.164668551292854D-04, &
       9.358867032006959D-05, &
      -1.326420289452124D-05 /)

  else

    write ( *, '(a)' ) ' '
    write ( *, '(a)' ) 'DAUB_COEFFICIENTS - Fatal error!'
    write ( *, '(a,i8)' ) '  Value of N = ', n
    write ( *, '(a)' ) '  Legal values are 2, 4, 6, 8, 10, 12, 14, 16, 18, 20.'
    stop 1

  end if

  return
end
subroutine daub2_matrix ( n, a )

!
!! DAUB2_MATRIX returns the DAUB2 matrix.
!
!  Discussion:
!
!    The DAUB2 matrix is the Daubechies wavelet transformation matrix 
!    with 2 coefficients.
!
!    The DAUB2 matrix is also known as the Haar matrix.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license.
!
!  Modified:
!
!    18 July 2011
!
!  Author:
!
!    John Burkardt
!
!  Parameters:
!
!    Input, integer N, the order of the matrix.
!    N must be at least 2 and a multiple of 2.
!
!    Output, real ( kind = rk ) A(N,N), the matrix.
!
  implicit none

  integer, parameter :: rk = kind ( 1.0D+00 )

  integer n
  integer, parameter :: p = 1

  real ( kind = rk ) a(n,n)
  real ( kind = rk ), dimension(0:p) :: c = (/ &
    7.071067811865475D-01, &
    7.071067811865475D-01 /)
  integer i
  integer m

  if ( n < 2 .or. mod ( n, 2 ) /= 0 ) then
    write ( *, '(a)' ) ' '
    write ( *, '(a)' ) 'DAUB2_MATRIX - Fatal error!'
    write ( *, '(a)' ) '  Order N must be at least 2 and a multiple of 2.'
    stop 1
  end if

  a(1:n,1:n) = 0.0D+00

  m = n / 2

  do i = 1, n - 1, 2

    a(i,i)     =   c(0)
    a(i,i+1)   =   c(1)

    a(i+1,i)   =   c(1)
    a(i+1,i+1) = - c(0)

  end do

  return
end
recursive function daub2_scale ( n, x ) result ( y )

!
!! DAUB2_SCALE recursively evaluates the DAUB2 scaling function.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license.
!
!  Modified:
!
!    01 August 2011
!
!  Author:
!
!    John Burkardt
!
!  Parameters:
!
!    Input, integer N, the recursion level.
!
!    Input, real ( kind = rk ) X, the point at which the function is to 
!    be evaluated.
!
!    Output, real ( kind = rk ) Y, the estimated value of the function.
!
  implicit none

  integer, parameter :: rk = kind ( 1.0D+00 )

  integer n
  real ( kind = rk ), dimension(0:1) :: c = (/ &
    7.071067811865475D-01, &
    7.071067811865475D-01 /)
  real ( kind = rk ) x
  real ( kind = rk ) y

  if ( 0 < n ) then
    y = sqrt ( 2.0D+00 ) * &
        ( c(0) * daub2_scale ( n - 1, 2.0D+00 * x           ) &
        + c(1) * daub2_scale ( n - 1, 2.0D+00 * x - 1.0D+00 ) )
  else
    if ( 0.0D+00 <= x .and. x < 1.0D+00 ) then
      y = 1.0D+00
    else
      y = 0.0D+00
    end if
  end if

  return
end
subroutine daub2_transform ( n, x, y )

!
!! DAUB2_TRANSFORM computes the DAUB2 transform of a vector.
!
!  Discussion:
!
!    DAUB2 is better known as the Haar transform.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license.
!
!  Modified:
!
!    18 July 2011
!
!  Author:
!
!    John Burkardt
!
!  Parameters:
!
!    Input, integer N, the dimension of the vector.
!    N must be a power of 2.
!
!    Input, real ( kind = rk ) X(N), the vector to be transformed. 
!
!    Output, real ( kind = rk ) Y(N), the transformed vector.
!
  implicit none

  integer, parameter :: rk = kind ( 1.0D+00 )

  integer n
  integer, parameter :: p = 1

  real ( kind = rk ), dimension(0:p) :: c = (/ &
    7.071067811865475D-01, &
    7.071067811865475D-01 /)
  integer i
  integer m
  real ( kind = rk ) x(n)
  real ( kind = rk ) y(n)
  real ( kind = rk ) z(n)

  y(1:n) = x(1:n)
  z(1:n) = 0.0D+00

  m = n

  do while ( 2 <= m )
  
    m = m / 2

    do i = 1, m
      z(i)   = c(0) * ( y(2*i-1) + y(2*i) )
      z(i+m) = c(1) * ( y(2*i-1) - y(2*i) )
    end do

    y(1:2*m) = z(1:2*m)

  end do

  return
end
subroutine daub2_transform_inverse ( n, y, x )

!
!! DAUB2_TRANSFORM_INVERSE inverts the DAUB2 transform of a vector.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license.
!
!  Modified:
!
!    18 July 2011
!
!  Author:
!
!    John Burkardt
!
!  Parameters:
!
!    Input, integer N, the dimension of the vector.
!    N must be a power of 2.
!
!    Input, real ( kind = rk ) Y(N), the transformed vector.
!
!    Output, real ( kind = rk ) X(N), the original vector.
!
  implicit none

  integer, parameter :: rk = kind ( 1.0D+00 )

  integer n
  integer, parameter :: p = 1

  real ( kind = rk ), dimension(0:p) :: c = (/ &
    7.071067811865475D-01, &
    7.071067811865475D-01 /)
  integer i
  integer m
  real ( kind = rk ) x(n)
  real ( kind = rk ) y(n)
  real ( kind = rk ) z(n)

  x(1:n) = y(1:n)
  z(1:n) = 0.0D+00
 
  m = 1

  do while ( m * 2 <= n )

    do i = 1, m
      z(2*i-1) = c(0) * ( x(i) + x(i+m) )
      z(2*i)   = c(1) * ( x(i) - x(i+m) )
    end do

    x(1:2*m) = z(1:2*m)

    m = m * 2

  end do

  return
end
subroutine daub4_matrix ( n, a )

!
!! DAUB4_MATRIX returns the DAUB4 matrix.
!
!  Discussion:
!
!    The DAUB4 matrix is the Daubechies wavelet transformation matrix 
!    with 4 coefficients.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license.
!
!  Modified:
!
!    27 June 2011
!
!  Author:
!
!    John Burkardt
!
!  Parameters:
!
!    Input, integer N, the order of the matrix.
!    N must be at least 4 and a multiple of 2.
!
!    Output, real ( kind = rk ) A(N,N), the matrix.
!
  implicit none

  integer, parameter :: rk = kind ( 1.0D+00 )

  integer n
  integer, parameter :: p = 3

  real ( kind = rk ) a(n,n)
  real ( kind = rk ), dimension(0:p) :: c = (/ &
     0.4829629131445341D+00, &
     0.8365163037378079D+00, &
     0.2241438680420133D+00, &
    -0.1294095225512603D+00 /)
  integer i
  integer i4_wrap

  if ( n < 4 .or. mod ( n, 2 ) /= 0 ) then
    write ( *, '(a)' ) ' '
    write ( *, '(a)' ) 'DAUB4_MATRIX - Fatal error!'
    write ( *, '(a)' ) '  Order N must be at least 4 and a multiple of 2.'
    stop 1
  end if

  a(1:n,1:n) = 0.0D+00

  do i = 1, n - 1, 2

    a(i,i)                  =   c(0)
    a(i,i+1)                =   c(1)
    a(i,i4_wrap(i+2,1,n))   =   c(2)
    a(i,i4_wrap(i+3,1,n))   =   c(3)

    a(i+1,i)                =   c(3)
    a(i+1,i+1)              = - c(2)
    a(i+1,i4_wrap(i+2,1,n)) =   c(1)
    a(i+1,i4_wrap(i+3,1,n)) = - c(0)

  end do

  return
end
recursive function daub4_scale ( n, x ) result ( y )

!
!! DAUB4_SCALE recursively evaluates the DAUB4 scaling function.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license.
!
!  Modified:
!
!    01 August 2011
!
!  Author:
!
!    John Burkardt
!
!  Parameters:
!
!    Input, integer N, the recursion level.
!
!    Input, real ( kind = rk ) X, the point at which the function is to 
!    be evaluated.
!
!    Output, real ( kind = rk ) Y, the estimated value of the function.
!
  implicit none

  integer, parameter :: rk = kind ( 1.0D+00 )

  integer n
  real ( kind = rk ), dimension(0:3) :: c = (/ &
     0.4829629131445341D+00, &
     0.8365163037378079D+00, &
     0.2241438680420133D+00, &
    -0.1294095225512603D+00 /)
  real ( kind = rk ) x
  real ( kind = rk ) y

  if ( 0 < n ) then
    y = sqrt ( 2.0D+00 ) * &
        ( c(0) * daub4_scale ( n - 1, 2.0D+00 * x           ) &
        + c(1) * daub4_scale ( n - 1, 2.0D+00 * x - 1.0D+00 ) &
        + c(2) * daub4_scale ( n - 1, 2.0D+00 * x - 2.0D+00 ) &
        + c(3) * daub4_scale ( n - 1, 2.0D+00 * x - 3.0D+00 ) )
  else
    if ( 0.0D+00 <= x .and. x < 1.0D+00 ) then
      y = 1.0D+00
    else
      y = 0.0D+00
    end if
  end if

  return
end
subroutine daub4_transform ( n, x, y )

!
!! DAUB4_TRANSFORM computes the DAUB4 transform of a vector.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license.
!
!  Modified:
!
!    18 July 2011
!
!  Author:
!
!    John Burkardt
!
!  Parameters:
!
!    Input, integer N, the dimension of the vector.
!    N must be a power of 2 and at least 4.
!
!    Input, real ( kind = rk ) X(N), the vector to be transformed. 
!
!    Output, real ( kind = rk ) Y(N), the transformed vector.
!
  implicit none

  integer, parameter :: rk = kind ( 1.0D+00 )

  integer n
  integer, parameter :: p = 3

  real ( kind = rk ), dimension(0:p) :: c = (/ &
     0.4829629131445341D+00, &
     0.8365163037378079D+00, &
     0.2241438680420133D+00, &
    -0.1294095225512603D+00 /)
  integer i
  integer i4_wrap
  integer j
  integer j0
  integer j1
  integer j2
  integer j3
  integer m
  real ( kind = rk ) x(n)
  real ( kind = rk ) y(n)
  real ( kind = rk ) z(n)

  y(1:n) = x(1:n)
  z(1:n) = 0.0D+00

  m = n

  do while ( 4 <= m )
  
    i = 1

    do j = 1, m - 1, 2

      j0 = i4_wrap ( j,     1, m )
      j1 = i4_wrap ( j + 1, 1, m )
      j2 = i4_wrap ( j + 2, 1, m )
      j3 = i4_wrap ( j + 3, 1, m )

      z(i)     = c(0) * y(j0) + c(1) * y(j1) &
               + c(2) * y(j2) + c(3) * y(j3)

      z(i+m/2) = c(3) * y(j0) - c(2) * y(j1) &
               + c(1) * y(j2) - c(0) * y(j3)

      i = i + 1

    end do

    y(1:m) = z(1:m)

    m = m / 2

  end do

  return
end
subroutine daub4_transform_inverse ( n, y, x )

!
!! DAUB4_TRANSFORM_INVERSE inverts the DAUB4 transform of a vector.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license.
!
!  Modified:
!
!    18 July 2011
!
!  Author:
!
!    John Burkardt
!
!  Parameters:
!
!    Input, integer N, the dimension of the vector.
!    N must be a power of 2 and at least 4.
!
!    Input, real ( kind = rk ) Y(N), the transformed vector. 
!
!    Output, real ( kind = rk ) X(N), the original vector.
!
  implicit none

  integer, parameter :: rk = kind ( 1.0D+00 )

  integer n
  integer, parameter :: p = 3

  real ( kind = rk ), dimension(0:p) :: c = (/ &
     0.4829629131445341D+00, &
     0.8365163037378079D+00, &
     0.2241438680420133D+00, &
    -0.1294095225512603D+00 /)
  integer i
  integer i0
  integer i1
  integer i2
  integer i3
  integer i4_wrap
  integer j
  integer m
  real ( kind = rk ) x(n)
  real ( kind = rk ) y(n)
  real ( kind = rk ) z(n)

  x(1:n) = y(1:n)
  z(1:n) = 0.0D+00

  m = 4

  do while ( m <= n )
  
    j = 1

    do i = 0, m / 2 - 1
      
      i0 = i4_wrap ( i,                 1,         m / 2 )
      i2 = i4_wrap ( i + 1,             1,         m / 2 )

      i1 = i4_wrap ( i + m / 2,         m / 2 + 1, m     )
      i3 = i4_wrap ( i + m / 2 + 1,     m / 2 + 1, m     )

      z(j)   = c(2) * x(i0) + c(1) * x(i1) &
             + c(0) * x(i2) + c(3) * x(i3)

      z(j+1) = c(3) * x(i0) - c(0) * x(i1) &
             + c(1) * x(i2) - c(2) * x(i3)

      j = j + 2

    end do

    x(1:m) = z(1:m)

    m = m * 2

  end do

  return
end
subroutine daub6_matrix ( n, a )

!
!! DAUB6_MATRIX returns the DAUB6 matrix.
!
!  Discussion:
!
!    The DAUB6 matrix is the Daubechies wavelet transformation matrix 
!    with 6 coefficients.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license.
!
!  Modified:
!
!    27 June 2011
!
!  Author:
!
!    John Burkardt
!
!  Parameters:
!
!    Input, integer N, the order of the matrix.
!    N must be at least 6, and a multiple of 2.
!
!    Output, real ( kind = rk ) A(N,N), the matrix.
!
  implicit none

  integer, parameter :: rk = kind ( 1.0D+00 )

  integer n
  integer, parameter :: p = 5

  real ( kind = rk ) a(n,n)
  real ( kind = rk ), dimension(0:p) :: c = (/ &
     0.3326705529500826D+00, &
     0.8068915093110925D+00, &
     0.4598775021184915D+00, &
   - 0.1350110200102545D+00, &
   - 0.08544127388202666D+00, &
     0.03522629188570953D+00 /)
  integer i
  integer i4_wrap

  if ( n < 6 .or. mod ( n, 2 ) /= 0 ) then
    write ( *, '(a)' ) ' '
    write ( *, '(a)' ) 'DAUB6_MATRIX - Fatal error!'
    write ( *, '(a)' ) '  N must be at least 6 and a multiple of 2.'
    stop 1
  end if

  a(1:n,1:n) = 0.0D+00

  do i = 1, n - 1, 2

    a(i,i)                  =   c(0)
    a(i,i+1)                =   c(1)
    a(i,i4_wrap(i+2,1,n))   =   c(2)
    a(i,i4_wrap(i+3,1,n))   =   c(3)
    a(i,i4_wrap(i+4,1,n))   =   c(4)
    a(i,i4_wrap(i+5,1,n))   =   c(5)

    a(i+1,i)                =   c(5)
    a(i+1,i+1)              = - c(4)
    a(i+1,i4_wrap(i+2,1,n)) =   c(3)
    a(i+1,i4_wrap(i+3,1,n)) = - c(2)
    a(i+1,i4_wrap(i+4,1,n)) =   c(1)
    a(i+1,i4_wrap(i+5,1,n)) = - c(0)

  end do

  return
end
recursive function daub6_scale ( n, x ) result ( y )

!
!! DAUB6_SCALE recursively evaluates the DAUB6 scaling function.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license.
!
!  Modified:
!
!    31 July 2011
!
!  Author:
!
!    John Burkardt
!
!  Parameters:
!
!    Input, integer N, the recursion level.
!
!    Input, real ( kind = rk ) X, the point at which the function is to 
!    be evaluated.
!
!    Output, real ( kind = rk ) Y, the estimated value of the function.
!
  implicit none

  integer, parameter :: rk = kind ( 1.0D+00 )

  integer n
  real ( kind = rk ), dimension(0:5) :: c = (/ &
     0.3326705529500826D+00, &
     0.8068915093110925D+00, &
     0.4598775021184915D+00, &
   - 0.1350110200102545D+00, &
   - 0.08544127388202666D+00, &
     0.03522629188570953D+00 /)
  real ( kind = rk ) x
  real ( kind = rk ) y

  if ( 0 < n ) then
    y = sqrt ( 2.0D+00 ) * &
        ( c(0) * daub6_scale ( n - 1, 2.0D+00 * x           ) &
        + c(1) * daub6_scale ( n - 1, 2.0D+00 * x - 1.0D+00 ) &
        + c(2) * daub6_scale ( n - 1, 2.0D+00 * x - 2.0D+00 ) &
        + c(3) * daub6_scale ( n - 1, 2.0D+00 * x - 3.0D+00 ) &
        + c(4) * daub6_scale ( n - 1, 2.0D+00 * x - 4.0D+00 ) &
        + c(5) * daub6_scale ( n - 1, 2.0D+00 * x - 5.0D+00 ) )
  else
    if ( 0.0D+00 <= x .and. x < 1.0D+00 ) then
      y = 1.0D+00
    else
      y = 0.0D+00
    end if
  end if

  return
end
subroutine daub6_transform ( n, x, y )

!
!! DAUB6_TRANSFORM computes the DAUB6 transform of a vector.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license.
!
!  Modified:
!
!    17 July 2011
!
!  Author:
!
!    John Burkardt
!
!  Parameters:
!
!    Input, integer N, the dimension of the vector.
!    N must be a power of 2 and at least 4.
!
!    Input, real ( kind = rk ) X(N), the vector to be transformed. 
!
!    Output, real ( kind = rk ) Y(N), the transformed vector.
!
  implicit none

  integer, parameter :: rk = kind ( 1.0D+00 )

  integer n
  integer, parameter :: p = 5

  real ( kind = rk ), dimension(0:p) :: c = (/ &
     0.3326705529500826D+00, &
     0.8068915093110925D+00, &
     0.4598775021184915D+00, &
   - 0.1350110200102545D+00, &
   - 0.08544127388202666D+00, &
     0.03522629188570953D+00 /)
  integer i
  integer i4_wrap
  integer j
  integer j0
  integer j1
  integer k
  integer m
  integer q
  real ( kind = rk ) x(n)
  real ( kind = rk ) y(n)
  real ( kind = rk ) z(n)

  y(1:n) = x(1:n)

  m = n
  q = ( p - 1 ) / 2

  do while ( 4 <= m )
  
    i = 1
    z(1:m) = 0.0D+00

    do j = 1, m - 1, 2

      do k = 0, p - 1, 2
        j0 = i4_wrap ( j + k,     1, m )
        j1 = i4_wrap ( j + k + 1, 1, m )
        z(i)     = z(i)     + c(  k) * y(j0) + c(  k+1) * y(j1)
        z(i+m/2) = z(i+m/2) + c(p-k) * y(j0) - c(p-k-1) * y(j1)
      end do

      i = i + 1

    end do

    y(1:m) = z(1:m)

    m = m / 2

  end do

  return
end
subroutine daub6_transform_inverse ( n, y, x )

!
!! DAUB6_TRANSFORM_INVERSE inverts the DAUB6 transform of a vector.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license.
!
!  Modified:
!
!    17 July 2011
!
!  Author:
!
!    John Burkardt
!
!  Parameters:
!
!    Input, integer N, the dimension of the vector.
!    N must be a power of 2 and at least 4.
!
!    Input, real ( kind = rk ) Y(N), the transformed vector. 
!
!    Output, real ( kind = rk ) X(N), the original vector.
!
  implicit none

  integer, parameter :: rk = kind ( 1.0D+00 )

  integer n
  integer, parameter :: p = 5

  real ( kind = rk ), dimension(0:p) :: c = (/ &
     0.3326705529500826D+00, &
     0.8068915093110925D+00, &
     0.4598775021184915D+00, &
   - 0.1350110200102545D+00, &
   - 0.08544127388202666D+00, &
     0.03522629188570953D+00 /)
  integer i
  integer i0
  integer i1
  integer i4_wrap
  integer j
  integer k
  integer m
  integer q
  real ( kind = rk ) x(n)
  real ( kind = rk ) y(n)
  real ( kind = rk ) z(n)

  x(1:n) = y(1:n)

  m = 4
  q = ( p - 1 ) / 2

  do while ( m <= n )
  
    z(1:m) = 0.0D+00

    j = 1

    do i = - q + 1, m / 2 - q
      
      do k = 0, p - 1, 2
        i0 = i4_wrap ( i         + k / 2,     1,         m / 2 )
        i1 = i4_wrap ( i + m / 2 + k / 2,     m / 2 + 1, m     )
        z(j)   = z(j)   + c(p-k-1) * x(i0) + c(k+1) * x(i1)
        z(j+1) = z(j+1) + c(p-k)   * x(i0) - c(k)   * x(i1)
      end do

      j = j + 2

    end do

    x(1:m) = z(1:m)

    m = m * 2

  end do

  return
end
subroutine daub8_matrix ( n, a )

!
!! DAUB8_MATRIX returns the DAUB8 matrix.
!
!  Discussion:
!
!    The DAUB8 matrix is the Daubechies wavelet transformation matrix 
!    with 8 coefficients.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license.
!
!  Modified:
!
!    28 June 2011
!
!  Author:
!
!    John Burkardt
!
!  Reference:
!
!    Gilbert Strang, Truong Nguyen,
!    Wavelets and Filter Banks,
!    Wellesley-Cambridge Press, 1997,
!    ISBN: 0-9614088-7-1,
!    LC: TK7872.F5S79 / QA403.3.S87
!
!  Parameters:
!
!    Input, integer N, the order of the matrix.
!    N must be at least 8, and a multiple of 2.
!
!    Output, real ( kind = rk ) A(N,N), the matrix.
!
  implicit none

  integer, parameter :: rk = kind ( 1.0D+00 )

  integer n

  real ( kind = rk ) a(n,n)
  real ( kind = rk ), dimension ( 0 : 7 ) :: c = (/ &
    0.2303778133088964D+00, &
    0.7148465705529154D+00, &
    0.6308807679298587D+00, &
   -0.0279837694168599D+00, &
   -0.1870348117190931D+00, &
    0.0308413818355607D+00, &
    0.0328830116668852D+00, &
   -0.0105974017850690D+00 /)
  integer i
  integer i4_wrap

  if ( n < 8 .or. mod ( n, 2 ) /= 0 ) then
    write ( *, '(a)' ) ' '
    write ( *, '(a)' ) 'DAUB8_MATRIX - Fatal error!'
    write ( *, '(a)' ) '  N must be at least 8 and a multiple of 2.'
    stop 1
  end if

  a(1:n,1:n) = 0.0D+00

  do i = 1, n - 1, 2

    a(i,i)                  =   c(0)
    a(i,i+1)                =   c(1)
    a(i,i4_wrap(i+2,1,n))   =   c(2)
    a(i,i4_wrap(i+3,1,n))   =   c(3)
    a(i,i4_wrap(i+4,1,n))   =   c(4)
    a(i,i4_wrap(i+5,1,n))   =   c(5)
    a(i,i4_wrap(i+6,1,n))   =   c(6)
    a(i,i4_wrap(i+7,1,n))   =   c(7)

    a(i+1,i)                =   c(7)
    a(i+1,i+1)              = - c(6)
    a(i+1,i4_wrap(i+2,1,n)) =   c(5)
    a(i+1,i4_wrap(i+3,1,n)) = - c(4)
    a(i+1,i4_wrap(i+4,1,n)) =   c(3)
    a(i+1,i4_wrap(i+5,1,n)) = - c(2)
    a(i+1,i4_wrap(i+6,1,n)) =   c(1)
    a(i+1,i4_wrap(i+7,1,n)) = - c(0)

  end do

  return
end
recursive function daub8_scale ( n, x ) result ( y )

!
!! DAUB8_SCALE recursively evaluates the DAUB8 scaling function.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license.
!
!  Modified:
!
!    31 July 2011
!
!  Author:
!
!    John Burkardt
!
!  Parameters:
!
!    Input, integer N, the recursion level.
!
!    Input, real ( kind = rk ) X, the point at which the function is to 
!    be evaluated.
!
!    Output, real ( kind = rk ) Y, the estimated value of the function.
!
  implicit none

  integer, parameter :: rk = kind ( 1.0D+00 )

  integer n
  real ( kind = rk ), dimension(0:7) :: c = (/ &
    0.2303778133088964D+00, &
    0.7148465705529154D+00, &
    0.6308807679298587D+00, &
   -0.0279837694168599D+00, &
   -0.1870348117190931D+00, &
    0.0308413818355607D+00, &
    0.0328830116668852D+00, &
   -0.0105974017850690D+00 /)
  real ( kind = rk ) x
  real ( kind = rk ) y

  if ( 0 < n ) then
    y = sqrt ( 2.0D+00 ) * &
        ( c(0) * daub8_scale ( n - 1, 2.0D+00 * x           ) &
        + c(1) * daub8_scale ( n - 1, 2.0D+00 * x - 1.0D+00 ) &
        + c(2) * daub8_scale ( n - 1, 2.0D+00 * x - 2.0D+00 ) &
        + c(3) * daub8_scale ( n - 1, 2.0D+00 * x - 3.0D+00 ) &
        + c(4) * daub8_scale ( n - 1, 2.0D+00 * x - 4.0D+00 ) &
        + c(5) * daub8_scale ( n - 1, 2.0D+00 * x - 5.0D+00 ) &
        + c(6) * daub8_scale ( n - 1, 2.0D+00 * x - 6.0D+00 ) &
        + c(7) * daub8_scale ( n - 1, 2.0D+00 * x - 7.0D+00 ) )
  else
    if ( 0.0D+00 <= x .and. x < 1.0D+00 ) then
      y = 1.0D+00
    else
      y = 0.0D+00
    end if
  end if

  return
end
subroutine daub8_transform ( n, x, y )

!
!! DAUB8_TRANSFORM computes the DAUB8 transform of a vector.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license.
!
!  Modified:
!
!    17 July 2011
!
!  Author:
!
!    John Burkardt
!
!  Parameters:
!
!    Input, integer N, the dimension of the vector.
!    N must be a power of 2 and at least 4.
!
!    Input, real ( kind = rk ) X(N), the vector to be transformed. 
!
!    Output, real ( kind = rk ) Y(N), the transformed vector.
!
  implicit none

  integer, parameter :: rk = kind ( 1.0D+00 )

  integer n
  integer, parameter :: p = 7

  real ( kind = rk ), dimension(0:p) :: c = (/ &
     0.2303778133088964D+00, &
     0.7148465705529154D+00, &
     0.6308807679298587D+00, &
    -0.02798376941685985D+00, &
    -0.1870348117190931D+00, &
     0.03084138183556076D+00, &
     0.03288301166688519D+00, &
    -0.01059740178506903D+00 /)
  integer i
  integer i4_wrap
  integer j
  integer j0
  integer j1
  integer k
  integer m
  integer q
  real ( kind = rk ) x(n)
  real ( kind = rk ) y(n)
  real ( kind = rk ) z(n)

  y(1:n) = x(1:n)

  m = n
  q = ( p - 1 ) / 2

  do while ( 4 <= m )
  
    i = 1
    z(1:m) = 0.0D+00

    do j = 1, m - 1, 2

      do k = 0, p - 1, 2
        j0 = i4_wrap ( j + k,     1, m )
        j1 = i4_wrap ( j + k + 1, 1, m )
        z(i)     = z(i)     + c(  k) * y(j0) + c(  k+1) * y(j1)
        z(i+m/2) = z(i+m/2) + c(p-k) * y(j0) - c(p-k-1) * y(j1)
      end do

      i = i + 1

    end do

    y(1:m) = z(1:m)

    m = m / 2

  end do

  return
end
subroutine daub8_transform_inverse ( n, y, x )

!
!! DAUB8_TRANSFORM_INVERSE inverts the DAUB8 transform of a vector.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license.
!
!  Modified:
!
!    17 July 2011
!
!  Author:
!
!    John Burkardt
!
!  Parameters:
!
!    Input, integer N, the dimension of the vector.
!    N must be a power of 2 and at least 4.
!
!    Input, real ( kind = rk ) Y(N), the transformed vector. 
!
!    Output, real ( kind = rk ) X(N), the original vector.
!
  implicit none

  integer, parameter :: rk = kind ( 1.0D+00 )

  integer n
  integer, parameter :: p = 7

  real ( kind = rk ), dimension(0:p) :: c = (/ &
     0.2303778133088964D+00, &
     0.7148465705529154D+00, &
     0.6308807679298587D+00, &
    -0.02798376941685985D+00, &
    -0.1870348117190931D+00, &
     0.03084138183556076D+00, &
     0.03288301166688519D+00, &
    -0.01059740178506903D+00 /)
  integer i
  integer i0
  integer i1
  integer i4_wrap
  integer j
  integer k
  integer m
  integer q
  real ( kind = rk ) x(n)
  real ( kind = rk ) y(n)
  real ( kind = rk ) z(n)

  x(1:n) = y(1:n)

  m = 4
  q = ( p - 1 ) / 2

  do while ( m <= n )
  
    z(1:m) = 0.0D+00

    j = 1

    do i = - q + 1, m / 2 - q
      
      do k = 0, p - 1, 2
        i0 = i4_wrap ( i         + k / 2,     1,         m / 2 )
        i1 = i4_wrap ( i + m / 2 + k / 2,     m / 2 + 1, m     )
        z(j)   = z(j)   + c(p-k-1) * x(i0) + c(k+1) * x(i1)
        z(j+1) = z(j+1) + c(p-k)   * x(i0) - c(k)   * x(i1)
      end do

      j = j + 2

    end do

    x(1:m) = z(1:m)

    m = m * 2

  end do

  return
end
subroutine daub10_matrix ( n, a )

!
!! DAUB10_MATRIX returns the DAUB10 matrix.
!
!  Discussion:
!
!    The DAUB10 matrix is the Daubechies wavelet transformation matrix 
!    with 10 coefficients.
!
!    Note that in the reference, the coefficient 0.0775714938400459D+00 
!    is given incorrectly, with the "8" misrepresented as a "0".
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license.
!
!  Modified:
!
!    03 July 2011
!
!  Author:
!
!    John Burkardt
!
!  Reference:
!
!    Gilbert Strang, Truong Nguyen,
!    Wavelets and Filter Banks,
!    Wellesley-Cambridge Press, 1997,
!    ISBN: 0-9614088-7-1,
!    LC: TK7872.F5S79 / QA403.3.S87
!
!  Parameters:
!
!    Input, integer N, the order of the matrix.
!    N must be at least 10, and a multiple of 2.
!
!    Output, real ( kind = rk ) A(N,N), the matrix.
!
  implicit none

  integer, parameter :: rk = kind ( 1.0D+00 )

  integer n

  real ( kind = rk ) a(n,n)
  real ( kind = rk ), dimension ( 0 : 9 ) :: c = (/ &
    0.1601023979741929D+00, &
    0.6038292697971895D+00, &
    0.7243085284377726D+00, &
    0.1384281459013203D+00, &
   -0.2422948870663823D+00, &
   -0.0322448695846381D+00, &
    0.0775714938400459D+00, &
   -0.0062414902127983D+00, &
   -0.0125807519990820D+00, &
    0.0033357252854738D+00 /)
  integer i
  integer i4_wrap

  if ( n < 10 .or. mod ( n, 2 ) /= 0 ) then
    write ( *, '(a)' ) ' '
    write ( *, '(a)' ) 'DAUB10_MATRIX - Fatal error!'
    write ( *, '(a)' ) '  N must be at least 10 and a multiple of 2.'
    stop 1
  end if

  a(1:n,1:n) = 0.0D+00

  do i = 1, n - 1, 2

    a(i,i)                  =   c(0)
    a(i,i+1)                =   c(1)
    a(i,i4_wrap(i+2,1,n))   =   c(2)
    a(i,i4_wrap(i+3,1,n))   =   c(3)
    a(i,i4_wrap(i+4,1,n))   =   c(4)
    a(i,i4_wrap(i+5,1,n))   =   c(5)
    a(i,i4_wrap(i+6,1,n))   =   c(6)
    a(i,i4_wrap(i+7,1,n))   =   c(7)
    a(i,i4_wrap(i+8,1,n))   =   c(8)
    a(i,i4_wrap(i+9,1,n))   =   c(9)

    a(i+1,i)                =   c(9)
    a(i+1,i+1)              = - c(8)
    a(i+1,i4_wrap(i+2,1,n)) =   c(7)
    a(i+1,i4_wrap(i+3,1,n)) = - c(6)
    a(i+1,i4_wrap(i+4,1,n)) =   c(5)
    a(i+1,i4_wrap(i+5,1,n)) = - c(4)
    a(i+1,i4_wrap(i+6,1,n)) =   c(3)
    a(i+1,i4_wrap(i+7,1,n)) = - c(2)
    a(i+1,i4_wrap(i+8,1,n)) =   c(1)
    a(i+1,i4_wrap(i+9,1,n)) = - c(0)

  end do

  return
end
recursive function daub10_scale ( n, x ) result ( y )

!
!! DAUB10_SCALE recursively evaluates the DAUB10 scaling function.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license.
!
!  Modified:
!
!    01 August 2011
!
!  Author:
!
!    John Burkardt
!
!  Parameters:
!
!    Input, integer N, the recursion level.
!
!    Input, real ( kind = rk ) X, the point at which the function is to 
!    be evaluated.
!
!    Output, real ( kind = rk ) Y, the estimated value of the function.
!
  implicit none

  integer, parameter :: rk = kind ( 1.0D+00 )

  integer n
  real ( kind = rk ), dimension(0:9) :: c = (/ &
    0.1601023979741929D+00, &
    0.6038292697971895D+00, &
    0.7243085284377726D+00, &
    0.1384281459013203D+00, &
   -0.2422948870663823D+00, &
   -0.0322448695846381D+00, &
    0.0775714938400459D+00, &
   -0.0062414902127983D+00, &
   -0.0125807519990820D+00, &
    0.0033357252854738D+00 /)
  real ( kind = rk ) x
  real ( kind = rk ) y

  if ( 0 < n ) then
    y = sqrt ( 2.0D+00 ) * &
        ( c(0) * daub10_scale ( n - 1, 2.0D+00 * x           ) &
        + c(1) * daub10_scale ( n - 1, 2.0D+00 * x - 1.0D+00 ) &
        + c(2) * daub10_scale ( n - 1, 2.0D+00 * x - 2.0D+00 ) &
        + c(3) * daub10_scale ( n - 1, 2.0D+00 * x - 3.0D+00 ) &
        + c(4) * daub10_scale ( n - 1, 2.0D+00 * x - 4.0D+00 ) &
        + c(5) * daub10_scale ( n - 1, 2.0D+00 * x - 5.0D+00 ) &
        + c(6) * daub10_scale ( n - 1, 2.0D+00 * x - 6.0D+00 ) &
        + c(7) * daub10_scale ( n - 1, 2.0D+00 * x - 7.0D+00 ) &
        + c(8) * daub10_scale ( n - 1, 2.0D+00 * x - 8.0D+00 ) &
        + c(9) * daub10_scale ( n - 1, 2.0D+00 * x - 9.0D+00 ) )
  else
    if ( 0.0D+00 <= x .and. x < 1.0D+00 ) then
      y = 1.0D+00
    else
      y = 0.0D+00
    end if
  end if

  return
end
subroutine daub10_transform ( n, x, y )

!
!! DAUB10_TRANSFORM computes the DAUB10 transform of a vector.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license.
!
!  Modified:
!
!    17 July 2011
!
!  Author:
!
!    John Burkardt
!
!  Parameters:
!
!    Input, integer N, the dimension of the vector.
!    N must be a power of 2 and at least 4.
!
!    Input, real ( kind = rk ) X(N), the vector to be transformed. 
!
!    Output, real ( kind = rk ) Y(N), the transformed vector.
!
  implicit none

  integer, parameter :: rk = kind ( 1.0D+00 )

  integer n
  integer, parameter :: p = 9

  real ( kind = rk ), dimension(0:p) :: c = (/ &
     1.601023979741929D-01, &
     6.038292697971896D-01, &
     7.243085284377729D-01, &
     1.384281459013207D-01, &
    -2.422948870663820D-01, &
    -3.224486958463837D-02, &
     7.757149384004571D-02, &
    -6.241490212798274D-03, &
    -1.258075199908199D-02, &
     3.335725285473771D-03 /)
  integer i
  integer i4_wrap
  integer j
  integer j0
  integer j1
  integer k
  integer m
  integer q
  real ( kind = rk ) x(n)
  real ( kind = rk ) y(n)
  real ( kind = rk ) z(n)

  y(1:n) = x(1:n)

  m = n
  q = ( p - 1 ) / 2

  do while ( 4 <= m )
  
    i = 1
    z(1:m) = 0.0D+00

    do j = 1, m - 1, 2

      do k = 0, p - 1, 2
        j0 = i4_wrap ( j + k,     1, m )
        j1 = i4_wrap ( j + k + 1, 1, m )
        z(i)     = z(i)     + c(  k) * y(j0) + c(  k+1) * y(j1)
        z(i+m/2) = z(i+m/2) + c(p-k) * y(j0) - c(p-k-1) * y(j1)
      end do

      i = i + 1

    end do

    y(1:m) = z(1:m)

    m = m / 2

  end do

  return
end
subroutine daub10_transform_inverse ( n, y, x )

!
!! DAUB10_TRANSFORM_INVERSE inverts the DAUB10 transform of a vector.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license.
!
!  Modified:
!
!    17 July 2011
!
!  Author:
!
!    John Burkardt
!
!  Parameters:
!
!    Input, integer N, the dimension of the vector.
!    N must be a power of 2 and at least 4.
!
!    Input, real ( kind = rk ) Y(N), the transformed vector. 
!
!    Output, real ( kind = rk ) X(N), the original vector.
!
  implicit none

  integer, parameter :: rk = kind ( 1.0D+00 )

  integer n
  integer, parameter :: p = 9

  real ( kind = rk ), dimension(0:p) :: c = (/ &
     1.601023979741929D-01, &
     6.038292697971896D-01, &
     7.243085284377729D-01, &
     1.384281459013207D-01, &
    -2.422948870663820D-01, &
    -3.224486958463837D-02, &
     7.757149384004571D-02, &
    -6.241490212798274D-03, &
    -1.258075199908199D-02, &
     3.335725285473771D-03 /)
  integer i
  integer i0
  integer i1
  integer i4_wrap
  integer j
  integer k
  integer m
  integer q
  real ( kind = rk ) x(n)
  real ( kind = rk ) y(n)
  real ( kind = rk ) z(n)

  x(1:n) = y(1:n)

  m = 4
  q = ( p - 1 ) / 2

  do while ( m <= n )
  
    z(1:m) = 0.0D+00

    j = 1

    do i = - q + 1, m / 2 - q
      
      do k = 0, p - 1, 2
        i0 = i4_wrap ( i         + k / 2,     1,         m / 2 )
        i1 = i4_wrap ( i + m / 2 + k / 2,     m / 2 + 1, m     )
        z(j)   = z(j)   + c(p-k-1) * x(i0) + c(k+1) * x(i1)
        z(j+1) = z(j+1) + c(p-k)   * x(i0) - c(k)   * x(i1)
      end do

      j = j + 2

    end do

    x(1:m) = z(1:m)

    m = m * 2

  end do

  return
end
subroutine daub12_matrix ( n, a )

!
!! DAUB12_MATRIX returns the DAUB12 matrix.
!
!  Discussion:
!
!    The DAUB12 matrix is the Daubechies wavelet transformation matrix 
!    with 12 coefficients.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license.
!
!  Modified:
!
!    03 July 2011
!
!  Author:
!
!    John Burkardt
!
!  Reference:
!
!    Gilbert Strang, Truong Nguyen,
!    Wavelets and Filter Banks,
!    Wellesley-Cambridge Press, 1997,
!    ISBN: 0-9614088-7-1,
!    LC: TK7872.F5S79 / QA403.3.S87
!
!  Parameters:
!
!    Input, integer N, the order of the matrix.
!    N must be at least 12, and a multiple of 2.
!
!    Output, real ( kind = rk ) A(N,N), the matrix.
!
  implicit none

  integer, parameter :: rk = kind ( 1.0D+00 )

  integer n
  integer, parameter :: p = 11

  real ( kind = rk ) a(n,n)
  real ( kind = rk ), dimension ( 0 : p ) :: c = (/ &
    0.1115407433501095D+00, &
    0.4946238903984533D+00, &
    0.7511339080210959D+00, &
    0.3152503517091982D+00, &
   -0.2262646939654400D+00, &
   -0.1297668675672625D+00, &
    0.0975016055873225D+00, &
    0.0275228655303053D+00, &
   -0.0315820393174862D+00, &
    0.0005538422011614D+00, &
    0.0047772575109455D+00, &
   -0.0010773010853085D+00 /)
  integer i
  integer i4_wrap
  integer q

  if ( n < 12 .or. mod ( n, 2 ) /= 0 ) then
    write ( *, '(a)' ) ' '
    write ( *, '(a)' ) 'DAUB12_MATRIX - Fatal error!'
    write ( *, '(a)' ) '  N must be at least 12 and a multiple of 2.'
    stop 1
  end if

  q = ( p - 1 ) / 2

  a(1:n,1:n) = 0.0D+00

  do i = 1, n - 1, 2

    a(i,i)                   =    c(0)
    a(i,i+1)                 =    c(1)
    a(i,i4_wrap(i+ 2,1,n))   =    c(2)
    a(i,i4_wrap(i+ 3,1,n))   =    c(3)
    a(i,i4_wrap(i+ 4,1,n))   =    c(4)
    a(i,i4_wrap(i+ 5,1,n))   =    c(5)
    a(i,i4_wrap(i+ 6,1,n))   =    c(6)
    a(i,i4_wrap(i+ 7,1,n))   =    c(7)
    a(i,i4_wrap(i+ 8,1,n))   =    c(8)
    a(i,i4_wrap(i+ 9,1,n))   =    c(9)
    a(i,i4_wrap(i+10,1,n))   =   c(10)
    a(i,i4_wrap(i+11,1,n))   =   c(11)

    a(i+1,i)                 =   c(11)
    a(i+1,i+1)               = - c(10)
    a(i+1,i4_wrap(i+ 2,1,n)) =    c(9)
    a(i+1,i4_wrap(i+ 3,1,n)) =  - c(8)
    a(i+1,i4_wrap(i+ 4,1,n)) =    c(7)
    a(i+1,i4_wrap(i+ 5,1,n)) =  - c(6)
    a(i+1,i4_wrap(i+ 6,1,n)) =    c(5)
    a(i+1,i4_wrap(i+ 7,1,n)) =  - c(4)
    a(i+1,i4_wrap(i+ 8,1,n)) =    c(3)
    a(i+1,i4_wrap(i+ 9,1,n)) =  - c(2)
    a(i+1,i4_wrap(i+10,1,n)) =    c(1)
    a(i+1,i4_wrap(i+11,1,n)) =  - c(0)

  end do

  return
end
subroutine daub12_transform ( n, x, y )

!
!! DAUB12_TRANSFORM computes the DAUB12 transform of a vector.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license.
!
!  Modified:
!
!    15 July 2011
!
!  Author:
!
!    John Burkardt
!
!  Parameters:
!
!    Input, integer N, the dimension of the vector.
!    N must be a power of 2 and at least 4.
!
!    Input, real ( kind = rk ) X(N), the vector to be transformed. 
!
!    Output, real ( kind = rk ) Y(N), the transformed vector.
!
  implicit none

  integer, parameter :: rk = kind ( 1.0D+00 )

  integer n
  integer, parameter :: p = 11

  real ( kind = rk ), dimension(0:p) :: c = (/ &
    0.1115407433501095D+00, &
    0.4946238903984533D+00, &
    0.7511339080210959D+00, &
    0.3152503517091982D+00, &
   -0.2262646939654400D+00, &
   -0.1297668675672625D+00, &
    0.0975016055873225D+00, &
    0.0275228655303053D+00, &
   -0.0315820393174862D+00, &
    0.0005538422011614D+00, &
    0.0047772575109455D+00, &
   -0.0010773010853085D+00 /)
  integer i
  integer i4_wrap
  integer j
  integer j0
  integer j1
  integer k
  integer m
  integer q
  real ( kind = rk ) x(n)
  real ( kind = rk ) y(n)
  real ( kind = rk ) z(n)

  y(1:n) = x(1:n)

  m = n
  q = ( p - 1 ) / 2

  do while ( 4 <= m )
  
    i = 1
    z(1:m) = 0.0D+00

    do j = 1, m - 1, 2

      do k = 0, p - 1, 2
        j0 = i4_wrap ( j + k,     1, m )
        j1 = i4_wrap ( j + k + 1, 1, m )
        z(i)     = z(i)     + c(  k) * y(j0) + c(  k+1) * y(j1)
        z(i+m/2) = z(i+m/2) + c(p-k) * y(j0) - c(p-k-1) * y(j1)
      end do

      i = i + 1

    end do

    y(1:m) = z(1:m)

    m = m / 2

  end do

  return
end
subroutine daub12_transform_inverse ( n, y, x )

!
!! DAUB12_TRANSFORM_INVERSE inverts the DAUB12 transform of a vector.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license.
!
!  Modified:
!
!    15 July 2011
!
!  Author:
!
!    John Burkardt
!
!  Parameters:
!
!    Input, integer N, the dimension of the vector.
!    N must be a power of 2 and at least 4.
!
!    Input, real ( kind = rk ) Y(N), the transformed vector. 
!
!    Output, real ( kind = rk ) X(N), the original vector.
!
  implicit none

  integer, parameter :: rk = kind ( 1.0D+00 )

  integer n
  integer, parameter :: p = 11

  real ( kind = rk ), dimension ( 0:p ) :: c = (/ &
    0.1115407433501095D+00, &
    0.4946238903984533D+00, &
    0.7511339080210959D+00, &
    0.3152503517091982D+00, &
   -0.2262646939654400D+00, &
   -0.1297668675672625D+00, &
    0.0975016055873225D+00, &
    0.0275228655303053D+00, &
   -0.0315820393174862D+00, &
    0.0005538422011614D+00, &
    0.0047772575109455D+00, &
   -0.0010773010853085D+00 /)
  integer i
  integer i0
  integer i1
  integer i4_wrap
  integer j
  integer k
  integer m
  integer q
  real ( kind = rk ) x(n)
  real ( kind = rk ) y(n)
  real ( kind = rk ) z(n)

  x(1:n) = y(1:n)

  m = 4
  q = ( p - 1 ) / 2

  do while ( m <= n )
  
    z(1:m) = 0.0D+00

    j = 1

    do i = - q + 1, m / 2 - q
      
      do k = 0, p - 1, 2
        i0 = i4_wrap ( i         + k / 2,     1,         m / 2 )
        i1 = i4_wrap ( i + m / 2 + k / 2,     m / 2 + 1, m     )
        z(j)   = z(j)   + c(p-k-1) * x(i0) + c(k+1) * x(i1)
        z(j+1) = z(j+1) + c(p-k)   * x(i0) - c(k)   * x(i1)
      end do

      j = j + 2

    end do

    x(1:m) = z(1:m)

    m = m * 2

  end do

  return
end
subroutine daub14_transform ( n, x, y )

!
!! DAUB14_TRANSFORM computes the DAUB14 transform of a vector.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license.
!
!  Modified:
!
!    15 July 2011
!
!  Author:
!
!    John Burkardt
!
!  Parameters:
!
!    Input, integer N, the dimension of the vector.
!    N must be a power of 2 and at least 4.
!
!    Input, real ( kind = rk ) X(N), the vector to be transformed. 
!
!    Output, real ( kind = rk ) Y(N), the transformed vector.
!
  implicit none

  integer, parameter :: rk = kind ( 1.0D+00 )

  integer n
  integer, parameter :: p = 13

  real ( kind = rk ), dimension(0:p) :: c = (/ &
     7.785205408500917D-02, &
     3.965393194819173D-01, &
     7.291320908462351D-01, &
     4.697822874051931D-01, &
    -1.439060039285649D-01, &
    -2.240361849938749D-01, &
     7.130921926683026D-02, &
     8.061260915108307D-02, &
    -3.802993693501441D-02, &
    -1.657454163066688D-02, &
     1.255099855609984D-02, &
     4.295779729213665D-04, &
    -1.801640704047490D-03, &
     3.537137999745202D-04 /)
  integer i
  integer i4_wrap
  integer j
  integer j0
  integer j1
  integer k
  integer m
  integer q
  real ( kind = rk ) x(n)
  real ( kind = rk ) y(n)
  real ( kind = rk ) z(n)

  y(1:n) = x(1:n)

  m = n
  q = ( p - 1 ) / 2

  do while ( 4 <= m )
  
    i = 1
    z(1:m) = 0.0D+00

    do j = 1, m - 1, 2

      do k = 0, p - 1, 2
        j0 = i4_wrap ( j + k,     1, m )
        j1 = i4_wrap ( j + k + 1, 1, m )
        z(i)     = z(i)     + c(  k) * y(j0) + c(  k+1) * y(j1)
        z(i+m/2) = z(i+m/2) + c(p-k) * y(j0) - c(p-k-1) * y(j1)
      end do

      i = i + 1

    end do

    y(1:m) = z(1:m)

    m = m / 2

  end do

  return
end
subroutine daub14_transform_inverse ( n, y, x )

!
!! DAUB14_TRANSFORM_INVERSE inverts the DAUB14 transform of a vector.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license.
!
!  Modified:
!
!    15 July 2011
!
!  Author:
!
!    John Burkardt
!
!  Parameters:
!
!    Input, integer N, the dimension of the vector.
!    N must be a power of 2 and at least 4.
!
!    Input, real ( kind = rk ) Y(N), the transformed vector. 
!
!    Output, real ( kind = rk ) X(N), the original vector.
!
  implicit none

  integer, parameter :: rk = kind ( 1.0D+00 )

  integer n
  integer, parameter :: p = 13

  real ( kind = rk ), dimension(0:p) :: c = (/ &
     7.785205408500917D-02, &
     3.965393194819173D-01, &
     7.291320908462351D-01, &
     4.697822874051931D-01, &
    -1.439060039285649D-01, &
    -2.240361849938749D-01, &
     7.130921926683026D-02, &
     8.061260915108307D-02, &
    -3.802993693501441D-02, &
    -1.657454163066688D-02, &
     1.255099855609984D-02, &
     4.295779729213665D-04, &
    -1.801640704047490D-03, &
     3.537137999745202D-04 /)
  integer i
  integer i0
  integer i1
  integer i4_wrap
  integer j
  integer k
  integer m
  integer q
  real ( kind = rk ) x(n)
  real ( kind = rk ) y(n)
  real ( kind = rk ) z(n)

  x(1:n) = y(1:n)

  m = 4
  q = ( p - 1 ) / 2

  do while ( m <= n )
  
    z(1:m) = 0.0D+00

    j = 1

    do i = - q + 1, m / 2 - q
      
      do k = 0, p - 1, 2
        i0 = i4_wrap ( i         + k / 2,     1,         m / 2 )
        i1 = i4_wrap ( i + m / 2 + k / 2,     m / 2 + 1, m     )
        z(j)   = z(j)   + c(p-k-1) * x(i0) + c(k+1) * x(i1)
        z(j+1) = z(j+1) + c(p-k)   * x(i0) - c(k)   * x(i1)
      end do

      j = j + 2

    end do

    x(1:m) = z(1:m)

    m = m * 2

  end do

  return
end
subroutine daub16_transform ( n, x, y )

!*****************************************************************************80
!
!! DAUB16_TRANSFORM computes the DAUB16 transform of a vector.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license.
!
!  Modified:
!
!    15 July 2011
!
!  Author:
!
!    John Burkardt
!
!  Parameters:
!
!    Input, integer N, the dimension of the vector.
!    N must be a power of 2 and at least 4.
!
!    Input, real ( kind = rk ) X(N), the vector to be transformed. 
!
!    Output, real ( kind = rk ) Y(N), the transformed vector.
!
  implicit none

  integer, parameter :: rk = kind ( 1.0D+00 )

  integer n
  integer, parameter :: p = 15

  real ( kind = rk ), dimension(0:p) :: c = (/ &
     5.441584224310400D-02, &
     3.128715909142999D-01, &
     6.756307362972898D-01, &
     5.853546836542067D-01, &
    -1.582910525634930D-02, &
    -2.840155429615469D-01, &
     4.724845739132827D-04, &
     1.287474266204784D-01, &
    -1.736930100180754D-02, &
    -4.408825393079475D-02, &
     1.398102791739828D-02, &
     8.746094047405776D-03, &
    -4.870352993451574D-03, &
    -3.917403733769470D-04, &
     6.754494064505693D-04, &
    -1.174767841247695D-04 /)
  integer i
  integer i4_wrap
  integer j
  integer j0
  integer j1
  integer k
  integer m
  integer q
  real ( kind = rk ) x(n)
  real ( kind = rk ) y(n)
  real ( kind = rk ) z(n)

  y(1:n) = x(1:n)

  m = n
  q = ( p - 1 ) / 2

  do while ( 4 <= m )
  
    i = 1
    z(1:m) = 0.0D+00

    do j = 1, m - 1, 2

      do k = 0, p - 1, 2
        j0 = i4_wrap ( j + k,     1, m )
        j1 = i4_wrap ( j + k + 1, 1, m )
        z(i)     = z(i)     + c(  k) * y(j0) + c(  k+1) * y(j1)
        z(i+m/2) = z(i+m/2) + c(p-k) * y(j0) - c(p-k-1) * y(j1)
      end do

      i = i + 1

    end do

    y(1:m) = z(1:m)

    m = m / 2

  end do

  return
end
subroutine daub16_transform_inverse ( n, y, x )

!
!! DAUB16_TRANSFORM_INVERSE inverts the DAUB16 transform of a vector.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license.
!
!  Modified:
!
!    15 July 2011
!
!  Author:
!
!    John Burkardt
!
!  Parameters:
!
!    Input, integer N, the dimension of the vector.
!    N must be a power of 2 and at least 4.
!
!    Input, real ( kind = rk ) Y(N), the transformed vector. 
!
!    Output, real ( kind = rk ) X(N), the original vector.
!
  implicit none

  integer, parameter :: rk = kind ( 1.0D+00 )

  integer n
  integer, parameter :: p = 15

  real ( kind = rk ), dimension(0:p) :: c = (/ &
     5.441584224310400D-02, &
     3.128715909142999D-01, &
     6.756307362972898D-01, &
     5.853546836542067D-01, &
    -1.582910525634930D-02, &
    -2.840155429615469D-01, &
     4.724845739132827D-04, &
     1.287474266204784D-01, &
    -1.736930100180754D-02, &
    -4.408825393079475D-02, &
     1.398102791739828D-02, &
     8.746094047405776D-03, &
    -4.870352993451574D-03, &
    -3.917403733769470D-04, &
     6.754494064505693D-04, &
    -1.174767841247695D-04 /)
  integer i
  integer i0
  integer i1
  integer i4_wrap
  integer j
  integer k
  integer m
  integer q
  real ( kind = rk ) x(n)
  real ( kind = rk ) y(n)
  real ( kind = rk ) z(n)

  x(1:n) = y(1:n)

  m = 4
  q = ( p - 1 ) / 2

  do while ( m <= n )
  
    z(1:m) = 0.0D+00

    j = 1

    do i = - q + 1, m / 2 - q
      
      do k = 0, p - 1, 2
        i0 = i4_wrap ( i         + k / 2,     1,         m / 2 )
        i1 = i4_wrap ( i + m / 2 + k / 2,     m / 2 + 1, m     )
        z(j)   = z(j)   + c(p-k-1) * x(i0) + c(k+1) * x(i1)
        z(j+1) = z(j+1) + c(p-k)   * x(i0) - c(k)   * x(i1)
      end do

      j = j + 2

    end do

    x(1:m) = z(1:m)

    m = m * 2

  end do

  return
end
subroutine daub18_transform ( n, x, y )

!
!! DAUB18_TRANSFORM computes the DAUB18 transform of a vector.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license.
!
!  Modified:
!
!    15 July 2011
!
!  Author:
!
!    John Burkardt
!
!  Parameters:
!
!    Input, integer N, the dimension of the vector.
!    N must be a power of 2 and at least 4.
!
!    Input, real ( kind = rk ) X(N), the vector to be transformed. 
!
!    Output, real ( kind = rk ) Y(N), the transformed vector.
!
  implicit none

  integer, parameter :: rk = kind ( 1.0D+00 )

  integer n
  integer, parameter :: p = 17

  real ( kind = rk ), dimension(0:p) :: c = (/ &
     3.807794736387834D-02, &
     2.438346746125903D-01, &
     6.048231236901111D-01, &
     6.572880780513005D-01, &
     1.331973858250075D-01, &
    -2.932737832791749D-01, &
    -9.684078322297646D-02, &
     1.485407493381063D-01, &
     3.072568147933337D-02, &
    -6.763282906132997D-02, &
     2.509471148314519D-04, &
     2.236166212367909D-02, &
    -4.723204757751397D-03, &
    -4.281503682463429D-03, &
     1.847646883056226D-03, &
     2.303857635231959D-04, &
    -2.519631889427101D-04, &
     3.934732031627159D-05 /)
  integer i
  integer i4_wrap
  integer j
  integer j0
  integer j1
  integer k
  integer m
  integer q
  real ( kind = rk ) x(n)
  real ( kind = rk ) y(n)
  real ( kind = rk ) z(n)

  y(1:n) = x(1:n)

  m = n
  q = ( p - 1 ) / 2

  do while ( 4 <= m )
  
    i = 1
    z(1:m) = 0.0D+00

    do j = 1, m - 1, 2

      do k = 0, p - 1, 2
        j0 = i4_wrap ( j + k,     1, m )
        j1 = i4_wrap ( j + k + 1, 1, m )
        z(i)     = z(i)     + c(  k) * y(j0) + c(  k+1) * y(j1)
        z(i+m/2) = z(i+m/2) + c(p-k) * y(j0) - c(p-k-1) * y(j1)
      end do

      i = i + 1

    end do

    y(1:m) = z(1:m)

    m = m / 2

  end do

  return
end
subroutine daub18_transform_inverse ( n, y, x )

!
!! DAUB18_TRANSFORM_INVERSE inverts the DAUB18 transform of a vector.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license.
!
!  Modified:
!
!    15 July 2011
!
!  Author:
!
!    John Burkardt
!
!  Parameters:
!
!    Input, integer N, the dimension of the vector.
!    N must be a power of 2 and at least 4.
!
!    Input, real ( kind = rk ) Y(N), the transformed vector. 
!
!    Output, real ( kind = rk ) X(N), the original vector.
!
  implicit none

  integer, parameter :: rk = kind ( 1.0D+00 )

  integer n
  integer, parameter :: p = 17

  real ( kind = rk ), dimension(0:p) :: c = (/ &
     3.807794736387834D-02, &
     2.438346746125903D-01, &
     6.048231236901111D-01, &
     6.572880780513005D-01, &
     1.331973858250075D-01, &
    -2.932737832791749D-01, &
    -9.684078322297646D-02, &
     1.485407493381063D-01, &
     3.072568147933337D-02, &
    -6.763282906132997D-02, &
     2.509471148314519D-04, &
     2.236166212367909D-02, &
    -4.723204757751397D-03, &
    -4.281503682463429D-03, &
     1.847646883056226D-03, &
     2.303857635231959D-04, &
    -2.519631889427101D-04, &
     3.934732031627159D-05 /)
  integer i
  integer i0
  integer i1
  integer i4_wrap
  integer j
  integer k
  integer m
  integer q
  real ( kind = rk ) x(n)
  real ( kind = rk ) y(n)
  real ( kind = rk ) z(n)

  x(1:n) = y(1:n)

  m = 4
  q = ( p - 1 ) / 2

  do while ( m <= n )
  
    z(1:m) = 0.0D+00

    j = 1

    do i = - q + 1, m / 2 - q
      
      do k = 0, p - 1, 2
        i0 = i4_wrap ( i         + k / 2,     1,         m / 2 )
        i1 = i4_wrap ( i + m / 2 + k / 2,     m / 2 + 1, m     )
        z(j)   = z(j)   + c(p-k-1) * x(i0) + c(k+1) * x(i1)
        z(j+1) = z(j+1) + c(p-k)   * x(i0) - c(k)   * x(i1)
      end do

      j = j + 2

    end do

    x(1:m) = z(1:m)

    m = m * 2

  end do

  return
end
subroutine daub20_transform ( n, x, y )

!
!! DAUB20_TRANSFORM computes the DAUB20 transform of a vector.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license.
!
!  Modified:
!
!    16 July 2011
!
!  Author:
!
!    John Burkardt
!
!  Parameters:
!
!    Input, integer N, the dimension of the vector.
!    N must be a power of 2 and at least 4.
!
!    Input, real ( kind = rk ) X(N), the vector to be transformed. 
!
!    Output, real ( kind = rk ) Y(N), the transformed vector.
!
  implicit none

  integer, parameter :: rk = kind ( 1.0D+00 )

  integer n
  integer, parameter :: p = 19

  real ( kind = rk ), dimension(0:p) :: c = (/ &
     2.667005790055555D-02, &
     1.881768000776914D-01, &
     5.272011889317255D-01, &
     6.884590394536035D-01, &
     2.811723436605774D-01, &
    -2.498464243273153D-01, &
    -1.959462743773770D-01, &
     1.273693403357932D-01, &
     9.305736460357235D-02, &
    -7.139414716639708D-02, &
    -2.945753682187581D-02, &
     3.321267405934100D-02, &
     3.606553566956169D-03, &
    -1.073317548333057D-02, &
     1.395351747052901D-03, &
     1.992405295185056D-03, &
    -6.858566949597116D-04, &
    -1.164668551292854D-04, &
     9.358867032006959D-05, &
    -1.326420289452124D-05 /)
  integer i
  integer i4_wrap
  integer j
  integer j0
  integer j1
  integer k
  integer m
  integer q
  real ( kind = rk ) x(n)
  real ( kind = rk ) y(n)
  real ( kind = rk ) z(n)

  y(1:n) = x(1:n)

  m = n
  q = ( p - 1 ) / 2

  do while ( 4 <= m )
  
    i = 1
    z(1:m) = 0.0D+00

    do j = 1, m - 1, 2

      do k = 0, p - 1, 2
        j0 = i4_wrap ( j + k,     1, m )
        j1 = i4_wrap ( j + k + 1, 1, m )
        z(i)     = z(i)     + c(  k) * y(j0) + c(  k+1) * y(j1)
        z(i+m/2) = z(i+m/2) + c(p-k) * y(j0) - c(p-k-1) * y(j1)
      end do

      i = i + 1

    end do

    y(1:m) = z(1:m)

    m = m / 2

  end do

  return
end
subroutine daub20_transform_inverse ( n, y, x )

!
!! DAUB20_TRANSFORM_INVERSE inverts the DAUB20 transform of a vector.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license.
!
!  Modified:
!
!    16 July 2011
!
!  Author:
!
!    John Burkardt
!
!  Parameters:
!
!    Input, integer N, the dimension of the vector.
!    N must be a power of 2 and at least 4.
!
!    Input, real ( kind = rk ) Y(N), the transformed vector. 
!
!    Output, real ( kind = rk ) X(N), the original vector.
!
  implicit none

  integer, parameter :: rk = kind ( 1.0D+00 )

  integer n
  integer, parameter :: p = 19

  real ( kind = rk ), dimension(0:p) :: c = (/ &
     2.667005790055555D-02, &
     1.881768000776914D-01, &
     5.272011889317255D-01, &
     6.884590394536035D-01, &
     2.811723436605774D-01, &
    -2.498464243273153D-01, &
    -1.959462743773770D-01, &
     1.273693403357932D-01, &
     9.305736460357235D-02, &
    -7.139414716639708D-02, &
    -2.945753682187581D-02, &
     3.321267405934100D-02, &
     3.606553566956169D-03, &
    -1.073317548333057D-02, &
     1.395351747052901D-03, &
     1.992405295185056D-03, &
    -6.858566949597116D-04, &
    -1.164668551292854D-04, &
     9.358867032006959D-05, &
    -1.326420289452124D-05 /)
  integer i
  integer i0
  integer i1
  integer i4_wrap
  integer j
  integer k
  integer m
  integer q
  real ( kind = rk ) x(n)
  real ( kind = rk ) y(n)
  real ( kind = rk ) z(n)

  x(1:n) = y(1:n)

  m = 4
  q = ( p - 1 ) / 2

  do while ( m <= n )
  
    z(1:m) = 0.0D+00

    j = 1

    do i = - q + 1, m / 2 - q
      
      do k = 0, p - 1, 2
        i0 = i4_wrap ( i         + k / 2,     1,         m / 2 )
        i1 = i4_wrap ( i + m / 2 + k / 2,     m / 2 + 1, m     )
        z(j)   = z(j)   + c(p-k-1) * x(i0) + c(k+1) * x(i1)
        z(j+1) = z(j+1) + c(p-k)   * x(i0) - c(k)   * x(i1)
      end do

      j = j + 2

    end do

    x(1:m) = z(1:m)

    m = m * 2

  end do

  return
end
function i4_is_power_of_2 ( n )

!
!! I4_IS_POWER_OF_2 reports whether an I4 is a power of 2.
!
!  Discussion:
!
!    The powers of 2 are 1, 2, 4, 8, 16, and so on.
!
!    An I4 is an integer value.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license.
!
!  Modified:
!
!    19 December 2001
!
!  Author:
!
!    John Burkardt
!
!  Parameters:
!
!    Input, integer N, the integer to be tested.
!
!    Output, logical I4_IS_POWER_OF_2, is TRUE if N is a power of 2.
!
  implicit none

  logical i4_is_power_of_2
  integer n
  integer n_copy

  n_copy = n
  i4_is_power_of_2 = .false.

  if ( n_copy <= 0 ) then
    return
  end if

  do while ( n_copy /= 1 )

    if ( mod ( n_copy, 2 ) == 1 ) then
      return
    end if

    n_copy = n_copy / 2

  end do

  i4_is_power_of_2 = .true.

  return
end
function i4_modp ( i, j )

!
!! I4_MODP returns the nonnegative remainder of I4 division.
!
!  Discussion:
!
!    If
!      NREM = I4_MODP ( I, J )
!      NMULT = ( I - NREM ) / J
!    then
!      I = J * NMULT + NREM
!    where NREM is always nonnegative.
!
!    The MOD function computes a result with the same sign as the
!    quantity being divided.  Thus, suppose you had an angle A,
!    and you wanted to ensure that it was between 0 and 360.
!    Then mod(A,360) would do, if A was positive, but if A
!    was negative, your result would be between -360 and 0.
!
!    On the other hand, I4_MODP(A,360) is between 0 and 360, always.
!
!    An I4 is an integer value.
!
!  Example:
!
!        I     J     MOD I4_MODP    Factorization
!
!      107    50       7       7    107 =  2 *  50 + 7
!      107   -50       7       7    107 = -2 * -50 + 7
!     -107    50      -7      43   -107 = -3 *  50 + 43
!     -107   -50      -7      43   -107 =  3 * -50 + 43
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license.
!
!  Modified:
!
!    02 March 1999
!
!  Author:
!
!    John Burkardt
!
!  Parameters:
!
!    Input, integer I, the number to be divided.
!
!    Input, integer J, the number that divides I.
!
!    Output, integer I4_MODP, the nonnegative remainder when I is
!    divided by J.
!
  implicit none

  integer i
  integer i4_modp
  integer j
  integer value

  if ( j == 0 ) then
    write ( *, '(a)' ) ' '
    write ( *, '(a)' ) 'I4_MODP - Fatal error!'
    write ( *, '(a,i8)' ) '  Illegal divisor J = ', j
    stop
  end if

  value = mod ( i, j )

  if ( value < 0 ) then
    value = value + abs ( j )
  end if

  i4_modp = value

  return
end
function i4_wrap ( ival, ilo, ihi )

!
!! I4_WRAP forces an I4 to lie between given limits by wrapping.
!
!  Discussion:
!
!    An I4 is an integer value.
!
!    There appears to be a bug in the GFORTRAN compiler which can lead to
!    erroneous results when the first argument of I4_WRAP is an expression.
!    In particular:
!
!    do i = 1, 3
!      if ( test ) then
!        i4 = i4_wrap ( i + 1, 1, 3 )
!      end if
!    end do
!
!    was, when I = 3, returning I4 = 3.  So I had to replace this with
!
!    do i = 1, 3
!      if ( test ) then
!        i4 = i + 1
!        i4 = i4_wrap ( i4, 1, 3 )
!      end if
!    end do
!
!  Example:
!
!    ILO = 4, IHI = 8
!
!    I  Value
!
!    -2     8
!    -1     4
!     0     5
!     1     6
!     2     7
!     3     8
!     4     4
!     5     5
!     6     6
!     7     7
!     8     8
!     9     4
!    10     5
!    11     6
!    12     7
!    13     8
!    14     4
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license.
!
!  Modified:
!
!    07 September 2009
!
!  Author:
!
!    John Burkardt
!
!  Parameters:
!
!    Input, integer IVAL, a value.
!
!    Input, integer ILO, IHI, the desired bounds.
!
!    Output, integer I4_WRAP, a "wrapped" version of the value.
!
  implicit none

  integer i4_modp
  integer i4_wrap
  integer ihi
  integer ilo
  integer ival
  integer jhi
  integer jlo
  integer value
  integer wide

  jlo = min ( ilo, ihi )
  jhi = max ( ilo, ihi )

  wide = jhi - jlo + 1

  if ( wide == 1 ) then
    value = jlo
  else
    value = jlo + i4_modp ( ival - jlo, wide )
  end if

  i4_wrap = value

  return
end
subroutine r8mat_is_identity ( n, a, error_frobenius )

!
!! R8MAT_IS_IDENTITY determines if an R8MAT is the identity.
!
!  Discussion:
!
!    An R8MAT is a matrix of real ( kind = rk ) values.
!
!    The routine returns the Frobenius norm of A - I.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license.
!
!  Modified:
!
!    02 November 2007
!
!  Author:
!
!    John Burkardt
!
!  Parameters:
!
!    Input, integer N, the order of the matrix.
!
!    Input, real ( kind = rk ) A(N,N), the matrix.
!
!    Output, real ( kind = rk ) ERROR_FROBENIUS, the Frobenius norm
!    of the difference matrix A - I, which would be exactly zero
!    if A were the identity matrix.
!
  implicit none

  integer, parameter :: rk = kind ( 1.0D+00 )

  integer n

  real ( kind = rk ) a(n,n)
  real ( kind = rk ) error_frobenius
  integer i
  integer j

  error_frobenius = 0.0D+00

  do i = 1, n
    do j = 1, n
      if ( i == j ) then
        error_frobenius = error_frobenius + ( a(i,j) - 1.0D+00 )**2
      else
        error_frobenius = error_frobenius + a(i,j)**2
      end if
    end do 
  end do

  error_frobenius = sqrt ( error_frobenius )

  return
end
subroutine r8vec_conjugate ( n, c, d )

!
!! R8VEC_CONJUGATE reverses a vector and negates even-indexed entries.
!
!  Discussion:
!
!    There are many times in wavelet computations when such an operation
!    is invoked.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license.
!
!  Modified:
!
!    13 August 2011
!
!  Author:
!
!    John Burkardt
!
!  Parameters:
!
!    Input, integer N, the dimension of the vector.
!
!    Input, real ( kind = rk ) C(N), the input vector.
!
!    Output, real ( kind = rk ) D(N), the "conjugated" vector.
!
  implicit none

  integer, parameter :: rk = kind ( 1.0D+00 )

  integer n

  real ( kind = rk ) c(n)
  real ( kind = rk ) d(n)

  d(1:n) = c(n:-1:1)

  d(2:2:n) = - d(2:2:n)

  return
end
subroutine r8vec_convolution ( m, x, n, y, z )

!
!! R8VEC_CONVOLUTION returns the convolution of two R8VECs.
!
!  Discussion:
!
!    An R8VEC is a vector of R8.
!
!    The I-th entry of the convolution can be formed by summing the products 
!    that lie along the I-th diagonal of the following table:
!
!    Y3 | 3   4   5   6   7
!    Y2 | 2   3   4   5   6
!    Y1 | 1   2   3   4   5
!       +------------------
!        X1  X2  X3  X4  X5
!
!    which will result in:
!
!    Z = ( X1 * Y1,
!          X1 * Y2 + X2 * Y1,
!          X1 * Y3 + X2 * Y2 + X3 * Y1,
!                    X2 * Y3 + X3 * Y2 + X4 * Y1,
!                              X3 * Y3 + X4 * Y2 + X5 * Y1,
!                                        X4 * Y3 + X5 * Y2,
!                                                  X5 * Y3 )
!            
!  Example:
!
!    Input:
!
!      X = (/ 1, 2, 3, 4 /)
!      Y = (/ -1, 5, 3 /)
!
!    Output:
!
!      Z = (/ -1, 3, 10, 17, 29, 12 /)
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license.
!
!  Modified:
!
!    02 August 2011
!
!  Author:
!
!    John Burkardt
!
!  Parameters:
!
!    Input, integer M, the dimension of X.
!
!    Input, real ( kind = rk ) X(M), the first vector to be convolved.
!
!    Input, integer N, the dimension of Y.
!
!    Input, real ( kind = rk ) Y(N), the second vector to be convolved.
!
!    Output, real ( kind = rk ) Z(M+N-1), the convolution of X and Y.
!
  implicit none

  integer, parameter :: rk = kind ( 1.0D+00 )

  integer m
  integer n

  integer j
  real ( kind = rk ) x(m)
  real ( kind = rk ) y(n)
  real ( kind = rk ) z(m+n-1)

  z(1:m+n-1) = 0.0D+00

  do j = 1, n
    z(j:j+m-1) = z(j:j+m-1) + x(1:m) * y(j)
  end do

  return
end
subroutine r8vec_linspace ( n, a_first, a_last, a )

!
!! R8VEC_LINSPACE creates a vector of linearly spaced values.
!
!  Discussion:
!
!    An R8VEC is a vector of R8.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license.
!
!  Modified:
!
!    14 March 2011
!
!  Author:
!
!    John Burkardt
!
!  Parameters:
!
!    Input, integer N, the number of entries in the vector.
!
!    Input, real ( kind = rk ) A_FIRST, A_LAST, the first and last entries.
!
!    Output, real ( kind = rk ) A(N), a vector of linearly spaced data.
!
  implicit none

  integer, parameter :: rk = kind ( 1.0D+00 )

  integer n

  real ( kind = rk ) a(n)
  real ( kind = rk ) a_first
  real ( kind = rk ) a_last
  integer i

  if ( n == 1 ) then

    a(1) = ( a_first + a_last ) / 2.0D+00

  else

    do i = 1, n
      a(i) = ( real ( n - i,     kind = rk ) * a_first &
             + real (     i - 1, kind = rk ) * a_last ) &
             / real ( n     - 1, kind = rk )
    end do

  end if

  return
end
subroutine r8vec_print ( n, a, title )

!
!! R8VEC_PRINT prints an R8VEC.
!
!  Discussion:
!
!    An R8VEC is a vector of R8.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license.
!
!  Modified:
!
!    22 August 2000
!
!  Author:
!
!    John Burkardt
!
!  Parameters:
!
!    Input, integer N, the number of components of the vector.
!
!    Input, real ( kind = rk ) A(N), the vector to be printed.
!
!    Input, character ( len = * ) TITLE, a title.
!
  implicit none

  integer, parameter :: rk = kind ( 1.0D+00 )

  integer n

  real ( kind = rk ) a(n)
  integer i
  character ( len = * ) title

  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) trim ( title )
  write ( *, '(a)' ) ' '

  do i = 1, n
    write ( *, '(2x,i8,a,1x,g16.8)' ) i, ':', a(i)
  end do

  return
end
subroutine timestamp ( )

!
!! TIMESTAMP prints the current YMDHMS date as a time stamp.
!
!  Example:
!
!    31 May 2001   9:45:54.872 AM
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license.
!
!  Modified:
!
!    18 May 2013
!
!  Author:
!
!    John Burkardt
!
  implicit none

  character ( len = 8 ) ampm
  integer d
  integer h
  integer m
  integer mm
  character ( len = 9 ), parameter, dimension(12) :: month = (/ &
    'January  ', 'February ', 'March    ', 'April    ', &
    'May      ', 'June     ', 'July     ', 'August   ', &
    'September', 'October  ', 'November ', 'December ' /)
  integer n
  integer s
  integer values(8)
  integer y

  call date_and_time ( values = values )

  y = values(1)
  m = values(2)
  d = values(3)
  h = values(5)
  n = values(6)
  s = values(7)
  mm = values(8)

  if ( h < 12 ) then
    ampm = 'AM'
  else if ( h == 12 ) then
    if ( n == 0 .and. s == 0 ) then
      ampm = 'Noon'
    else
      ampm = 'PM'
    end if
  else
    h = h - 12
    if ( h < 12 ) then
      ampm = 'PM'
    else if ( h == 12 ) then
      if ( n == 0 .and. s == 0 ) then
        ampm = 'Midnight'
      else
        ampm = 'AM'
      end if
    end if
  end if

  write ( *, '(i2,1x,a,1x,i4,2x,i2,a1,i2.2,a1,i2.2,a1,i3.3,1x,a)' ) &
    d, trim ( month(m) ), y, h, ':', n, ':', s, '.', mm, trim ( ampm )

  return
end

subroutine view_load_comm(line,error)
  use gkernel_interfaces
  use imager_interfaces, only : sub_read_image, map_message
  use clean_default
  use clean_arrays
  use clean_types
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !*
  ! VIEWER -- Support for command LOAD
  !
  !   Support routine for command  
  !   DISPLAY\LOAD File [Write] [[/RANGE Start End Type]
  !   [/FREQUENCY RestFreqMHz] and [/PLANE Start End]
  !!
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: line  !! Command line
  logical, intent(inout) :: error       !! Logical error flag
  !
  ! Constants
  integer, parameter :: o_freq=1
  integer, parameter :: o_plane=2
  integer, parameter :: o_range=3
  integer, parameter :: o_cache=5
  integer, parameter :: o_trail=6
  logical, parameter :: compact = .false.
  character(len=8), parameter :: cread ='READ    '
  character(len=8), parameter :: cwrite='WRITE   '
  integer(kind=4), parameter :: msort=3
  character(len=12) :: types(msort)
  data types /'CHANNEL','VELOCITY','FREQUENCY'/
  !
  ! Local ---
  logical, save :: do_reload=.false.
  integer :: np,nn,isort,save_opt
  character(len=filename_length) :: name
  logical :: do_freq, do_write
  real(8) :: drange(2), freq
  character(len=8) :: ckey
  character(len=12) :: csort
  character(len=12) :: mysort
  !
  ! Code ----
  ckey = ' '
  call sic_ke (line,0,2,ckey,np,.false.,error)
  if (np.ne.0) then
    nn = min(np,8)
    if (ckey(1:nn).eq.cread(1:nn)) then
      do_write = .false.
    else if (ckey(1:nn).eq.cwrite(1:nn)) then
      do_write = .true.
    else
      call map_message(seve%e,'LOAD','Invalid 2nd argument '//ckey(1:np))
      error = .true.
      return
    endif
  else
    do_write = .false.
  endif
  !
  call sic_ch (line,0,1,name,nn,.true.,error)
  if (error) return
  !
  ! Default settings
  drange = 0
  mysort = 'NONE'
  !
  ! /PLANE (for compatibility or different application)
  if (sic_present(o_plane,0)) then
    if (sic_present(o_range,0)) then
      call map_message(seve%e,'LOAD','Options /RANGE and /PLANES are incompatible')
      error =.true.
      return
    endif
    call sic_r8 (line,o_plane,1,drange(1),.true.,error)
    if (error) return
    call sic_r8 (line,o_plane,2,drange(2),.true.,error)
    if (error) return
  endif
  !
  ! /RANGE (for flexibility)
  if (sic_present(o_range,0)) then
    call sic_r8 (line,o_range,1,drange(1),.true.,error)
    if (error) return
    call sic_r8 (line,o_range,2,drange(2),.true.,error)
    if (error) return
    call sic_ke (line,o_range,3,csort,nn,.true.,error)
    if (error) return
    error = .false.
    call sic_ambigs('LOAD',csort,mysort,isort,types,msort,error)
    if (error)  return
  endif
  !
  ! /FREQUENCY Option
  do_freq = sic_present(o_freq,0)
  if (do_freq) then
    call sic_r8(line,o_freq,1,freq,.true.,error)
    if (error) return
  endif
  !
  !
  ! 'DATA'  is the last item of the list...
  save_opt = rw_optimize
  if (do_reload) rw_optimize = 0
  if (do_freq) then
    call sub_read_image (name,mtype,drange,mysort,compact,o_range,error,freq)
  else
    call sub_read_image (name,mtype,drange,mysort,compact,o_range,error)
  endif
  rw_optimize = save_opt
  if (error) return
  !
  ! Make it write-able if needed
  !
  call check_view(1,'DATA')  ! Force VIEW re-computation for these
  last_shown = 'DATA' ! Could be an issue since it has not been SHOWn or VIEWed yet
  !
  ! Set ReadOnly status
  if (do_write) then
    call sic_delvariable ('DATA',.false.,error)
    hview%loca%read = .false.
    call sic_mapgildas ('DATA',hview,error,dview)
    call map_message(seve%w,'LOAD','DATA array is writeable')
  endif
  do_reload = do_write    ! Force reloading if Writeable
end subroutine view_load_comm
!
subroutine read_comm (line,error)
  use gkernel_interfaces
  use imager_interfaces, except_this=>read_comm
  use clean_def
  use clean_arrays
  use clean_types
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- Support for command  READ
  !
  !   READ Type File [/COMPACT] [/NOCACHE] [/NOTRAIL] [/RANGE Start End Type]
  !   [/FREQUENCY RestFreqMHz] and [/PLANE Start End]
  !!
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: line  !! Command line
  logical, intent(inout) :: error       !! Logical error flag
  !
  ! Constants
  integer, parameter :: o_compact=1
  integer, parameter :: o_freq=2
  integer, parameter :: o_plane=3
  integer, parameter :: o_range=4
  integer, parameter :: o_cache=5
  integer, parameter :: o_trail=6
  integer(kind=4), parameter :: msort=3
  character(len=12) :: types(msort)
  data types /'CHANNEL','VELOCITY','FREQUENCY'/
  !
  ! Local ---
  character(len=filename_length), save :: uv_data_name=' '
  character(len=12) :: mysort
  integer ntype,nn,isort, i, nline, iarg
  character(len=12) argu,atype,acomm
  character(len=filename_length) :: name, aline
  logical compact,lexist,do_freq
  character(len=filename_length) :: file
  real(8) :: drange(2), freq
  character(len=12) :: csort
  !
  integer, save :: old_trail=0
  integer :: cur_trail, save_opt
  integer :: do_reload
  !
  ! Code ----
  call sic_ke (line,0,1,argu,nn,.true.,error)
  if (error) return
  !
  if ((argu.eq.'?').and.(sic_narg(0).eq.1)) then
    call sic_ambigs_list('READ',seve%i,'Choices are:',vtype,vread)
    return
  endif
  !
  if (argu.eq.'UV') argu = 'UV_DATA'
  if (argu.eq.'SINGLE') argu = 'SINGLEDISH'
  !
  if (argu.ne.'*') then
    iarg = 0
    do i=1,mtype
      if (argu.eq.vtype(i)) then
        iarg = i
        exit
      endif
    enddo
    if (iarg.eq.0) then
      call map_message(seve%e,'READ','No such Buffer '//argu)
      call sic_ambigs_list('READ',seve%i,'Choices are:',vtype,vread)
      error = .true.
      return
    endif
  endif
  !
  save_opt = rw_optimize
  if (sic_present(o_cache,0)) then
    do_reload = -2
  else
    do_reload = rw_optimize
  endif
  if (argu.eq.'UV_DATA') then
    if (sic_narg(0).eq.1) then
      name = uv_data_name
      nn = len_trim(name)
      error = nn.eq.0
      if (error) then
        call map_message(seve%e,'READ','No UV data already read')
        return
      endif
    else
      call sic_ch (line,0,2,name,nn,.true.,error)
    endif
    !
    ! Test TRAIL handling status
    ! Deactivate RW_OPTIMIZE if status changed
    if (sic_present(o_trail,0).or.(.not.read_trail)) then
      cur_trail = 1     ! /NOTRAIL option or by SET TRAIL
    else
      cur_trail = 0
    endif
    if (cur_trail.ne.old_trail) then
      do_reload = -1
    endif
    ! if different from last one...
    !WWWW
  else
    cur_trail = 0
    call sic_ch (line,0,2,name,nn,.true.,error)
  endif
  if (error) return
  !
  ! Default settings
  drange = 0
  mysort = 'NONE'
  !
  ! /PLANE (for compatibility or different application)
  if (sic_present(o_plane,0)) then
    if (sic_present(o_range,0)) then
      call map_message(seve%e,'READ','Options /RANGE and /PLANES are incompatible')
      error =.true.
      return
    endif
    call sic_r8 (line,o_plane,1,drange(1),.true.,error)
    if (error) return
    call sic_r8 (line,o_plane,2,drange(2),.true.,error)
    if (error) return
  endif
  !
  ! /RANGE (for flexibility)
  if (sic_present(o_range,0)) then
    call sic_r8 (line,o_range,1,drange(1),.true.,error)
    if (error) return
    call sic_r8 (line,o_range,2,drange(2),.true.,error)
    if (error) return
    call sic_ke (line,o_range,3,csort,nn,.true.,error)
    if (error) return
    error = .false.
    call sic_ambigs('READ',csort,mysort,isort,types,msort,error)
    if (error)  return
  endif
  !
  ! /FREQUENCY Option
  do_freq = sic_present(o_freq,0)
  if (do_freq) then
    call sic_r8(line,o_freq,1,freq,.true.,error)
    if (error) return
  endif
  !
  ! /COMPACT
  compact = sic_present(o_compact,0)
  !
  select case(argu)
  case ('*')
    !
    ! Find all files of relevant extension, and load them
    do ntype = 2, ptype
      !
      lexist = sic_findfile(name,file,' ',etype(ntype))
      !Print *,vtype(ntype),trim(file), lexist
      if (lexist) then
        !Read(5,*) nn
        call map_message(seve%i,'READ','Loading '//vtype(ntype)//trim(file))
        if (ntype.eq.1 .or. ntype.eq.mtype) then
          csort = 'NONE'
        else
          csort = mysort
        endif
        if (do_freq) then
          call sub_read_image (name,ntype,drange,csort,compact,o_range,error,freq)
        else
          call sub_read_image (name,ntype,drange,csort,compact,o_range,error)
        endif
        call check_view(1,atype)  ! Force VIEW re-computation for these
      endif
    enddo
  case ('FLUX','SUPPORT','POLYGON')
    do i=1,5
      if (sic_present(i,0)) then
        call map_message(seve%e,'READ','Option(s) incompatible with '//trim(argu)//' argument')
        error = .true.
        return
      endif
    enddo
    select case (argu)
    case ('FLUX')
      call sub_read_flux(name,error)
    case ('SUPPORT')
      aline = 'SUPPORT '//trim(name)
      nline = len_trim(aline)
      call sic_analyse(acomm,aline,nline,error)
      call support_comm(aline,error)
    case ('POLYGON')
      call exec_program('GREG2\POLYGON '//trim(name))
    end select
  case default
    call sic_ambigs ('READ',argu,atype,ntype,vtype,mtype,error)
    if (error) return
    !
    rw_optimize = do_reload  ! Force reload if needed
    if (do_freq) then
      call sub_read_image (name,ntype,drange,mysort,compact,o_range,error,freq)
    else
      call sub_read_image (name,ntype,drange,mysort,compact,o_range,error)
    endif
    if (.not.error) call check_view(1,atype)  ! Force VIEW re-computation for these
  end select
  rw_optimize = save_opt
  if (error) return
  !
  if (argu.eq.'UV_DATA') then
    uv_data_name = name
    call uv_check_mosaic    ! Convert to POINT Mosaic if needed
    old_trail = cur_trail   ! Always true ?
    ! Unset self-calibration status
    call sic_let_inte('SELF_APPLIED',0,error)
  endif
end subroutine read_comm
!
subroutine sub_read_image (name,ntype,drange,crange,compact,o_range,error, freq)
  use gkernel_interfaces
  use gkernel_types
  use imager_interfaces, only : map_read, map_message
  use clean_def
  use clean_arrays
  use clean_default
  use clean_types
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private-mandatory
  !*
  ! IMAGER -- Support routine for command READ 
  !
  !   READ Type File [/COMPACT] [/FREQUENCY RestFreqMHz] [/RANGE Start End Type]
  !   [/NOCACHE] [/NOTRAIL] and, for transposed data,  [/PLANE Start End]
  !
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: name      !! Name of file
  integer, intent(in) :: ntype              !! Type of data
  real(8), intent(in) :: drange(2)          !! Range to be read
  character(len=*), intent(in) :: crange    !! Type of range
  logical, intent(in) :: compact            !! ACA buffer flag
  integer, intent(in) :: o_range            !! Number of Option /RANGE
  logical, intent(inout) :: error           !! Logical error flag
  real(8), intent(in), optional :: freq     !! Desired rest frequency
  !
  ! Constants
  character(len=*), parameter :: rname='READ'
  !
  ! Local ---
  character(len=filename_length), save :: filename
  character(len=12), save :: otype
  integer, save :: nf=0
  logical, save :: first=.true.
  !
  type (gildas) :: head
  character(len=filename_length) :: file
  character(len=12) :: cteles
  integer :: nc(2), n
  integer(8) :: attempt
  logical :: nochange, err, is_uvfits, fits_format
  integer :: fits_fmt   ! Is in FITS format -1 IMAGE, 0 1 2 or 4 UVFITS with no or 1,2,4 Stokes state
  real(4) :: velo
  !
  integer(kind=4), parameter :: khdu=1  ! Desired HDU. 1 is Primary HDU.
  type(gfits_hdesc_t) :: fd             ! I hope this is available here
  logical :: question, check, x_window
  integer :: a_style
  integer :: pcount
  !
  ! Code ----
  error = .false.
  call gildas_null(head)
  call sic_parse_file(name,' ',etype(ntype),file)
  !
  ! If the name contains a "*", it is a filter. Open a File Widget
  ! to get the filename.
  if (index(file,'*').ne.0) then
    if (first) then
      call sic_def_char('FILENAME',filename,.false.,error)
      if (error) return
      first = .false.
      call sic_get_logi('SIC%WINDOW',x_window,error)
      if (.not.x_window) call map_message(seve%w,rname, &
      & 'File filter only usable with a Widget-supporting environment')
    endif
    if (etype(ntype).ne.otype) nf = 0
    !
    if (x_window) then
      call exec_program('GUI\PANEL FILE toto')
      if (nf.eq.0) then
        call exec_program('SIC\LET FILENAME /PROMPT "Select file" /FILE '//trim(file))
      else
        call exec_program('SIC\LET FILENAME "'//filename(1:nf)//'" /PROMPT "Select file" /FILE '//trim(file))
        otype = etype(ntype)
      endif
      call exec_program('GUI\GO')     ! Launch the widget
      call exec_program('GUI\WAIT')   ! Wait for answer
      call end_dialog                 ! Close the last widget
      if (error) return
    else
      call exec_program('SIC\LET FILENAME /PROMPT "Specify file" /FILE '//trim(file))
    endif
    file = filename
    nf = len_trim(file)
  endif
  head%file = file
  !
  is_uvfits = .false.
  fits_fmt = 0    ! Not a FITS file by default
  if (ftype(ntype).eq.1) then
    ! Allow direct reading of FITS file in this case
    ! Test if FITS file, by .fits extension
    call is_fitsfile(file,fits_format,error)
    if (error) return
    if (fits_format) then
      call map_message(seve%w,rname,trim(file)//' is a FITS image')
      if (sic_present(o_range,0)) then
        call map_message(seve%e,rname,'Option /RANGE not (yet) valid for FITS image')
        error = .true.
        return
      endif
      fits_fmt = -1 ! Image ...
    endif
  else
    fits_format = .false.
    n = len_trim(file)
    if ((file(n-4:n).eq.'.fits').or.(file(n-6:n).eq.'.uvfits'))  then
      call map_message(seve%w,rname,'Reading FITS format not yet thoroughly tested for '//vtype(ntype))
      fits_format = .true.
      fits_fmt = 1
    endif
  endif
  !
  if (fits_format) then
    ! Open FITS file, including basic sanity checks
    call gfits_open(file,'IN',error)
    if (error)  return
    call gfits_goto_hdu(fd,khdu,error)
    if (error)  return
    !
    ! --- Read the header (always) ---
    call gildas_null(head)
    head%blc = 0
    head%trc = 0
    !
    if (fits_fmt.ge.0) then
      question = .false.
      a_style =  4 ! code_fits_casa = 4 - Get all Stokes by default
      check = .false.
      call touvt(head,a_style,question,check,error,pcount,sic_getsymbol)
      if (error) then
        call gio_message(seve%e,rname,'Error reading UVFITS header')
        call gfits_close(err)
        return
      endif
      fits_fmt = max(head%gil%nstokes,1)
      !
      ! If less than 2  Stokes, ignore Stokes states
      if ((.not.sic_present(0,3)).and.(head%gil%nstokes.eq.2)) then
        call map_message(seve%w,rname,'Only 2 Stokes states, selecting Unpolarized signal')
        a_style = 0 ! No change
        fits_fmt = 1
      else if (head%gil%nstokes.gt.1) then
        call map_message(seve%w,rname,'Keeping all Stokes states')
      endif
      !
      if (head%gil%nteles.gt.0) then
        cteles = head%gil%teles(1)%ctele
        if ((cteles.eq."ALMA").or.(cteles.eq."ACA")) then
          head%char%syst = "ICRS"
          call map_message(seve%w,rname,'Telescope '//trim(cteles)//': Assuming ICRS coordinate system')
        endif
      endif
      !
      head%file = file
    else
      ! Convert the HDU to a GILDAS Header
      call fitscube2gdf_header(file,khdu,fd,head,sic_getsymbol,error)
      if (error) return
      head%loca%size = product(head%gil%dim(1:head%gil%ndim))
      head%file = file
    endif
    !
  else
    head%blc = 0
    head%trc = 0
    !
    !
    ! Read Header
    call gdf_read_header (head,error)
    if (error) return
    !
    if (head%gil%nteles.gt.0) then
      cteles = head%gil%teles(1)%ctele
      if ((cteles.eq."ALMA").or.(cteles.eq."ACA")) then
        if (head%char%syst.eq.' ') then
          head%char%syst = "ICRS"
          call map_message(seve%i,rname,'Telescope '//trim(cteles)//': Assuming ICRS coordinate system',seve%w)
        else if (head%char%syst.ne.'ICRS') then
          call map_message(seve%w,rname,'Inconsistent coordinate system '// &
            & trim(head%char%syst)//' for telescope '//trim(cteles))
          if (head%char%syst.eq.'EQUATORIAL') then
            call map_message(seve%i,rname,'Telescope '//trim(cteles)//': Assuming ICRS coordinate system',seve%w)
            head%char%syst = "ICRS"
          endif
        endif
      endif
    endif
    !
    ! Shift it to the requested Rest Frequency if needed
    if (present(freq)) then
      velo = head%gil%voff
      call gdf_modify(head,velo,freq,error=error)
      if (error) return
    endif
    !
  endif
  !
  ! Hum, this is valid only for IMAGES - Need
  ! special case for SINGLEDISH which can be Table or Image
  call out_range('READ',crange,drange,nc,head,error)
  if (error) return
  head%loca%size = product(head%gil%dim(1:head%gil%ndim))
  !
  ! Check if anything changed
  if (.not.compact) then
    ! We must check if the corresponding buffer is still allocated !...
    select case(vtype(ntype))
    case ('UV_DATA') 
      attempt = huv_init%loca%size
    case ('CCT')
      attempt = hcct%loca%size
      last_resid = 'CCT'
    case ('RESIDUAL')
      attempt = hresid%loca%size
    case ('CLEAN')
      attempt = hclean%loca%size
    case ('DATA')
      attempt = hview%loca%size
    case ('MASK') 
      attempt = hmask%loca%size
    case ('CONTINUUM') 
      attempt = huv_cont%loca%size
    case ('SKY') 
      attempt = hsky%loca%size
    case default
      attempt = -1   ! No optimization if unknown buffer
    end select
    if (attempt.ge.0) then
      call sub_modified(ntype,file,optimize(ntype),nc,nochange,attempt)
      if (nochange) then
        if (fits_format) then
          call gfits_close(err)
        else
          error = .false.
          call gdf_close_image(head,error)  ! Must free the open slot
        endif
        return
      endif
    endif
    !
    if (vtype(ntype).eq.'UV_DATA') then
      if (allocated(drobust)) then
        deallocate(drobust)
        call sic_delvariable('ROBUST_BEAMS',.false.,error)
      endif
    endif
  endif
  !
  ! Read Data as required
  call map_read(head,fd,fits_fmt,vtype(ntype),nc,compact,error,pcount)
  !
  ! Indicate Buffer has been read
  optimize(ntype)%change = 0
  !
  ! Free image slot 
  if (.not.fits_format) then
    err = .false.
    call gdf_close_image (head,err)
    if (err) error = .true.
  endif
  !
  ! First loaded will be shown, not the last one...
  if (last_shown.eq.' ') then
    select case(vtype(ntype))
    case('CLEAN')
      last_shown = 'CLEAN'
    case ('SKY') 
      last_shown = 'SKY'
    end select
  endif  
  !
end subroutine sub_read_image
!
subroutine sub_modified(atype,file,opti,nc,nochange,osize)
  use gkernel_interfaces
  use gkernel_types
  use clean_types
  use clean_arrays
  use gbl_message
  use imager_interfaces, only : map_uvgildas, map_message
  !---------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- Support for command READ
  !
  !   Check if the file of type "atype" needs to be read again.
  !!
  !---------------------------------------------------------------------
  integer, intent(in) :: atype            !! Code of type of file
  character(len=*), intent(in) :: file    !! Filename
  type(readop_t), intent(inout) :: opti   !! Status of corresponding buffer
  integer, intent(in) :: nc(2)            !! Range to be read
  logical, intent(out) :: nochange        !! Change status
  integer(8), intent(in) :: osize         !! Previous size of data - If Zero, force reading
  !
  ! Local ---
  logical :: error
  character(len=36) :: mess, trail
  integer :: msev
  !
  ! Code ----
  nochange = .false.           ! By default
  !
  opti%modif%modif = .true.    ! In case of error
  call gag_filmodif(file,opti%modif,error)
  if (osize.eq.0) opti%modif%modif = .true. ! If not loaded ...
  if (.not.opti%modif%modif) then
    if (nc(1).eq.opti%lastnc(1) .and. nc(2).eq.opti%lastnc(2)) then
      mess = 'File not modified and same range  -- '
      msev = seve%w
      nochange = .true.
    else
      mess = 'File not modified, different range - '
      msev = seve%i
    endif
  else
    opti%lastnc = nc          ! Remember channel range
    return
  endif
  error = .false.             ! For further use
  opti%lastnc = nc
  !
  ! The buffers may however have been manipulated in IMAGER
  if (.FALSE.) then
    ! Old code - Temporarily kept for the record
    if (optimize(atype)%change.gt.1) then
      nochange = .false.
      trail = ' Buffer changed -- Reloaded '
      msev = seve%i
    else if (optimize(atype)%change.eq.1 .and. nochange) then
      !
      ! Is there a buffer to be Reset ?
      if (atype.eq.code_save_uv) then
        call uv_reset_buffer('READ')
        duv => huv_init%r2d !SG
        call map_uvgildas('UV',huv_current,error,huv_init%r2d) 
      endif
      optimize(atype)%change = 0
      trail = ' Reset from Buffer'
    else if (nochange) then
      if (rw_optimize.lt.0) then
        trail = ' /NOTRAIL status changed, reloaded'
        nochange = .false.
      else
        trail = ' not reloaded '
      endif
    else
      trail = ' reloaded '
    endif
  ENDIF
  !
  if (optimize(atype)%change.gt.1) then
    nochange = .false.
    trail = ' Buffer changed -- Reloaded '
    msev = seve%i
  else if (nochange) then
    if (rw_optimize.lt.0) then ! Value can be tested to specify message
      if (rw_optimize.eq.-1) then
        trail = ' /NOTRAIL status changed, reloaded'
      else if (rw_optimize.eq.-2) then
        trail = ' /NOCACHE option, reloaded'
      else
        trail = ' Reload forced by user'
      endif
      nochange = .false.
    else if (optimize(atype)%change.eq.1) then
      !
      ! Is there a buffer to be Reset ? 
      if (atype.eq.code_save_uv) then
        call uv_reset_buffer('READ')
        duv => huv_init%r2d
        call map_uvgildas('UV',huv_current,error,huv_init%r2d) 
      endif
      optimize(atype)%change = 0
      trail = ' Reset from Buffer'
    else
      ! ! Print *,'Optimize value ',optimize(atype)%change
      ! On essaye cela, mais c est peut-être superflu
      if (atype.eq.code_save_uv) then
        call uv_reset_buffer('READ')
        call map_uvgildas('UV',huv_current,error,huv_init%r2d) 
      endif
      trail = ' not reloaded '
    endif
  else
    trail = ' reloaded '
  endif
  !
  call map_message(msev,'READ',mess//trail)
  ! RW_Optimize is an integer, so that we may distinguish
  !    optimization based on "atype"
  ! 0 means No Read / Write optimization by user
  if (rw_optimize.eq.0) then
    call map_message(seve%w,'READ','Reading enforced by user')
    nochange = .false.
  endif
  !
end subroutine sub_modified
!
subroutine map_read (head,fd,fits_fmt,out,nc,compact,error,count)
  use gkernel_interfaces
  use imager_interfaces, except_this=>map_read
  use clean_def
  use clean_arrays
  use clean_types
  use clean_beams
  use clean_default
  use uvfit_data
  use gbl_message
  !------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- Read some type of input data, UV or Image, even
  !   from FITS format if needed
  !!
  !------------------------------------------------------------------
  type (gildas), intent(inout) :: head      !! Header of input data
  type(gfits_hdesc_t), intent(in) :: fd     !! FITS descriptor 
  integer, intent(in) :: fits_fmt           !! Input FITS file
  character(len=*), intent(in) :: out       !! Desired data
  integer, intent(in) :: nc(2)              !! Channel range
  logical, intent(in) :: compact            !! Put in ACA space ?
  logical, intent(out) :: error             !! Logical error flag
  integer, intent(in), optional :: count    !! Group size indicator for FITS ?
  !
  ! Constants
  character(len=4) :: rname = 'READ'
  integer, parameter :: o_trail=6
  !
  ! Local ---
  type (gildas) :: htmp
  character(len=80) :: chain
  integer :: i, ier, nchan, local_nc(2), blc, pcount
  logical :: subset
  real, allocatable :: tmp_data(:,:)
  !
  ! Code ----
  error = .false.
  pcount = 0
  if (present(count)) pcount = count
  !
  if (.not.compact) then
    !
    ! First, verify that the data set matches the required format
    select case(out)
    case ('UV_DATA','MODEL','CGAINS') 
      !
      if (head%char%type(1:9).ne.'GILDAS_UV') then
        call map_message(seve%e,'READ',trim(head%file)//' is not a UV data set')
        error = .true.
      endif
    case ('CCT')
      if ((head%char%code(2).ne.'COMPONENT') .and. &
        & (head%char%code(3).ne.'COMPONENT') ) then
        call map_message(seve%e,rname,trim(head%file)//' is not a CCT Table')
        error = .true.
      endif      
!    case ('AGAINS')
!    
    case ('SINGLEDISH')
      if (abs(head%gil%type_gdf).eq.code_gdf_uvt) then
        call map_message(seve%e,rname,trim(head%file)//' is not a SINGLE DISH data set')
        error = .true.
      endif     
    case ('DATA')
      if (head%gil%type_gdf.ne.code_gdf_image) then
        call map_message(seve%e,'READ',trim(head%file)//' is not an hypercube')
        error = .true.
      endif  
      if (head%char%code(3).eq.'COMPONENT') then
        call map_message(seve%e,rname,trim(head%file)//' is not a hypercube, but a CCT Table')
        error = .true.
      endif      
    case default
      if (head%gil%type_gdf.ne.code_gdf_image) then
        call map_message(seve%e,'READ',trim(head%file)//' is not an hypercube')
        error = .true.
      endif          
    end select
    if (error) return
    !
    select case (out)
    case ('BEAM')
      ! Beam is a 4-D array of dimension Nx Ny Np Nb
      ! where Nb is the number of "beam frequencies"
      ! and Np the number of pointing centers
      call gdf_copy_header(head, hbeam, error)
      hbeam%loca = head%loca
      save_data(code_save_beam) = .false.
      call sic_delvariable ('BEAM',.false.,error)
      if (allocated(dbeam)) deallocate(dbeam,stat=ier)
      hbeam%gil%dim(3) = max(1,hbeam%gil%dim(3))
      hbeam%gil%dim(4) = max(1,hbeam%gil%dim(4))
      allocate(dbeam(hbeam%gil%dim(1),hbeam%gil%dim(2),   &
       &        hbeam%gil%dim(3),hbeam%gil%dim(4)),stat=ier)
      call map_read_data(fd,fits_fmt,hbeam,dbeam,error)
      if (error) return
      !
      ! One should check here the beam order:
      ! input beams can also be
      !   Nx Ny Nb
      ! or
      !   NX Ny Np
      ! depending on GILDAS  version used for creation
      call sic_mapgildas('BEAM',hbeam,error,dbeam)
    case ('UV_DATA')
      ! Special case for UV data
      ! Do not discard the current UV Data.
      !   call map_message(seve%i,'READ','Discarding current UV Data')
      !   call discard_uvdata(error)
      ! It would suppress the READ UV optimization
      call getset_uvdata('READ',head,[0.,0.],fd,fits_fmt,nc,pcount,error)
    case ('MODEL')
      !
      if (head%char%type(1:9).ne.'GILDAS_UV') then
        call map_message(seve%e,'READ','Input file is not a UV data set')
        error = .true.
        return
      endif
      !
      uv_model_updated = .true.
      !
      ! Free the previous zone
      call sic_delvariable ('UV_MODEL',.false.,error)
      if (allocated(duvm)) then
        deallocate(duvm,stat=ier)
        huv_model%loca%size = 0
      endif
      !
      call gildas_null (huv_model, type= 'UVT')
      call gildas_null (htmp, type= 'UVT')
      call gdf_copy_header(head, htmp, error)
      ! Check appropriate order
      if (htmp%char%code(1).eq."RANDOM") then
        call map_message(seve%w,rname,'UV data is transposed')
        call gdf_transpose_header (htmp, huv_model, '21', error)
      else
        call gdf_copy_header(htmp, huv_model, error)
      endif
      if (error)  return
      htmp%loca = head%loca
      huv_model%loca = head%loca   ! Why ?  See above !
      !
      ! Extract desired channels
      nchan = huv_model%gil%nchan
      local_nc = nc
      ier = gdf_range (local_nc, nchan)
      call gdf_uv_size(huv_model,local_nc)
      allocate(duvm(huv_model%gil%dim(1),huv_model%gil%dim(2)),stat=ier)
      call gdf_read_uvdataset(htmp,huv_model,local_nc,duvm,error)
      if (error) return
      !
      huv_model%loca%size = huv_model%gil%dim(1)*huv_model%gil%dim(2)
      call sic_mapgildas('UV_MODEL',huv_model,error,duvm)
      !
    case ('CGAINS')
      !
      ! Free the previous zone
      call sic_delvariable ('CGAINS',.false.,error)
      if (allocated(duvbg)) then
        deallocate(duvbg,stat=ier)
      endif
      !
      call gildas_null (hbgain, type= 'UVT')
      call gildas_null (htmp, type= 'UVT')
      call gdf_copy_header(head, htmp, error)
      ! Check appropriate order
      if (htmp%char%code(1).eq."RANDOM") then
        call map_message(seve%w,rname,'Gain data is transposed')
        call gdf_transpose_header (htmp, hbgain, '21', error)
      else
        call gdf_copy_header(htmp, hbgain, error)
      endif
      if (error)  return
      htmp%loca = head%loca
      hbgain%loca = head%loca   ! Why ? See above !
      !
      ! Extract 1 channel
      local_nc = 1
      nchan = 1
      hbgain%gil%ref(1) = hbgain%gil%ref(1)-local_nc(1)+1
      hbgain%gil%dim(1) = hbgain%gil%nlead+hbgain%gil%natom*nchan
      hbgain%gil%nchan = 1
      ! Trim trailing column
      if (hbgain%gil%ntrail.gt.0) then
        do i=1,code_uvt_last
          if (hbgain%gil%column_pointer(i).gt.hbgain%gil%dim(1)) then
            call map_message(seve%w,rname,'Found column '//uv_column_name(i))
            hbgain%gil%column_size(i) = 0
            hbgain%gil%column_pointer(i) = 0
          endif
        enddo
        hbgain%gil%ntrail = 0
      endif
      !
      allocate(duvbg(hbgain%gil%dim(1),hbgain%gil%dim(2)),stat=ier)
      call gdf_read_uvdataset(htmp,hbgain,local_nc,duvbg,error)
      if (error) return
      !
      hbgain%loca%size = hbgain%gil%dim(1)*hbgain%gil%dim(2)
      call sic_mapgildas ('CGAINS',hbgain,error,duvbg)
      !
    case ('DATA')
      !
      call sic_delvariable ('DATA',.false.,error)
      if (allocated(dview)) deallocate(dview,stat=ier)
      !
      ! Specify the subset
      error = map_range(nc,head,hview)
      if (error) return
      allocate(dview(hview%gil%dim(1),hview%gil%dim(2),   &
       &        hview%gil%dim(3)),stat=ier)
      call map_read_data(fd,fits_fmt,head,dview,error)
      if (error) return
      call get_more_header(fits_fmt,head%file,hview)
      !
      call sic_mapgildas ('DATA',hview,error,dview)
      !
    case ('DIRTY')
      save_data(code_save_dirty) = .false.
      call sic_delvariable ('DIRTY',.false.,error)
      if (allocated(ddirty)) deallocate(ddirty,stat=ier)
      !
      ! Specify the subset
      error = map_range(nc,head,hdirty)
      if (error) return
      !
      allocate(ddirty(hdirty%gil%dim(1),hdirty%gil%dim(2),   &
       &        hdirty%gil%dim(3)),stat=ier)
      call map_read_data(fd,fits_fmt,head,ddirty,error)
      if (error) return
      !
      call get_more_header(fits_fmt,head%file,hdirty)
      call sic_mapgildas('DIRTY',hdirty,error,ddirty)
      user_method%do_mask = .true.
      !
      ! Define Min Max
      d_max = hdirty%gil%rmax
      if (hdirty%gil%rmin.eq.0) then
        d_min = -0.03*hdirty%gil%rmax
      else
        d_min = hdirty%gil%rmin
      endif
      !
    case ('RESIDUAL')
      save_data(code_save_resid) = .false.
      call sic_delvariable ('RESIDUAL',.false.,error)
      if (allocated(dresid)) deallocate(dresid,stat=ier)
      ! Specify the subset
      error = map_range(nc,head,hresid)
      if (error) return
      allocate(dresid(hresid%gil%dim(1),hresid%gil%dim(2),   &
       &        hresid%gil%dim(3)),stat=ier)
      call map_read_data(fd,fits_fmt,head,dresid,error)
      if (error) return
      call get_more_header(fits_fmt,head%file,hdirty)
      call sic_mapgildas('RESIDUAL',hresid,error,dresid)
      user_method%do_mask = .true.
      !
    case ('CLEAN')
      save_data(code_save_clean) = .false.
      call sic_delvariable ('CLEAN',.false.,error)
      if (allocated(dclean)) deallocate(dclean,stat=ier)
      !
      ! Specify the subset
      error = map_range(nc,head,hclean)
      if (error) return
      allocate(dclean(hclean%gil%dim(1),hclean%gil%dim(2),   &
       &        hclean%gil%dim(3)),stat=ier)
      call map_read_data(fd,fits_fmt,head,dclean,error)
      if (error) return
      call get_more_header(fits_fmt,head%file,hclean)
      call sic_mapgildas ('CLEAN',hclean,error,dclean)
      !
    case ('SKY')
      save_data(code_save_sky) = .false.
      call sic_delvariable ('SKY',.false.,error)
      if (allocated(dsky)) deallocate(dsky,stat=ier)
      ! Specify the subset
      error = map_range(nc,head,hsky)
      if (error) return
      allocate(dsky(hsky%gil%dim(1),hsky%gil%dim(2),   &
       &        hsky%gil%dim(3)),stat=ier)
      call map_read_data(fd,fits_fmt,head,dsky,error)
      if (error) return
      call get_more_header(fits_fmt,head%file,hsky)
      call sic_mapgildas ('SKY',hsky,error,dsky)
      !
    case ('MASK')
      save_data(code_save_mask) = .false.
      call sic_delvariable ('MASK',.false.,error)
      if (allocated(dmask)) deallocate(dmask,stat=ier)
      ! Specify the subset
      error = map_range(nc,head,hmask)
      if (error) return
      allocate(dmask(hmask%gil%dim(1),hmask%gil%dim(2),hmask%gil%dim(3)),   &
       &        stat=ier)
      call map_read_data(fd,fits_fmt,head,dmask,error)
      if (error) return
      call sic_mapgildas ('MASK',hmask,error,dmask)
      user_method%do_mask = .true.
      !
    case ('PRIMARY')
      !
      ! Primary is a 4-D array of dimension Np Nx Ny Nb
      ! where Nb is the number of "beam frequencies"
      ! and Np the number of pointing centers
      !
      ! /RANGE option not effective here
      !
      call gdf_copy_header(head, hprim, error)
      hprim%loca = head%loca
      save_data(code_save_primary) = .false.
      call sic_delvariable ('PRIMARY',.false.,error)
      if (allocated(dprim)) deallocate(dprim,stat=ier)
      hprim%gil%dim(4) = max(1,hprim%gil%dim(4))
      allocate(dprim(hprim%gil%dim(1),hprim%gil%dim(2),   &
       &        hprim%gil%dim(3),hprim%gil%dim(4)),stat=ier)
      call map_read_data(fd,fits_fmt,hprim,dprim,error)
      if (error) return
      call get_more_header(fits_fmt,head%file,hprim)
      call sic_mapgildas('PRIMARY',hprim,error,dprim)
      !
      ! Old GILDAS primary beams had only one Frequency channel
      !
      ! Switch to mosaic mode only if more than 1 field
      if (hprim%gil%dim(1).le.1) return
      !
      user_method%trunca = hprim%gil%inc(1)  ! Truncation of beam
      user_method%search = user_method%trunca
      user_method%restor = user_method%trunca
      call map_message(seve%i,rname,'Primary Beam read, setting MOSAIC')
      call sub_mosaic('ON',error)
      if (error) return
    case ('CCT')
      call cct_read(nc,head,error)
    case ('SINGLEDISH')
      save_data(code_save_single) = .false.
      call sic_delvariable ('SINGLE',.false.,error)
      call sic_delvariable ('SHORT',.false.,error)
      if (associated(hshort%r3d,dsingle)) then
        nullify(hshort%r3d)
      else if (associated(hshort%r3d,dshort)) then
        nullify(hshort%r3d)
      else if (associated(hshort%r3d))  then
        deallocate(hshort%r3d,stat=ier)
      endif
      if (allocated(dshort)) deallocate(dshort,stat=ier)
      if (allocated(dsingle)) deallocate(dsingle,stat=ier)
      hsingle%loca%size = 0
      hshort%loca%size = 0
      !
      ! Find out what type of data it is
      if (head%gil%xaxi*head%gil%yaxi.eq.2) then
        call map_message(seve%i,rname,'Reading a 3-D data cube')
        ! This is an image
        if (head%gil%ndim.eq.2) then
          ! Extend 2-D images as a data cube
          head%gil%ndim = 3
          head%gil%dim(3) = 1
        endif
      else
        ! This must be a Class Table
        if (head%gil%ndim.ne.2) then
          call map_message(seve%e,rname,'Unrecognized SINGLEDISH data')
          error = .true.
          return
        endif
        call map_message(seve%i,rname,'Reading a CLASS table')
      endif
      ! Hereafter ndim=2 will say it is a Table
      !  
      ! Specify the subset if possible
      if (head%gil%ndim.eq.2) then        
        error = tab_range(nc,head,hsingle,subset)
        if (error) return
        hsingle%gil%dim(3) = 1
      else if (head%gil%ndim.eq.3) then        
        error = map_range(nc,head,hsingle)
        if (error) return
      else if (product(head%gil%dim(4:head%gil%ndim)).gt.1) then
        call map_message(seve%e,rname,'SINGLEDISH data must have rank 2 or 3')
        error = .true.
        return
      else
        head%gil%ndim = 3
        error = map_range(nc,head,hsingle)
        if (error) return
      endif
      !
      allocate(dsingle(hsingle%gil%dim(1),hsingle%gil%dim(2),   &
       &        hsingle%gil%dim(3)),stat=ier)
      if (ier.ne.0) then
        call map_message(seve%e,rname,'SINGLEDISH data allocation error')
        error = .true.
        return
      endif
      !      
      if (hsingle%gil%ndim.eq.2) then     
        ! The section to be read is not-contiguous...
        ! Read the smallest contiguous section for simplicity,
        ! i.e. up to the last selected channel
        allocate(tmp_data(head%trc(1),head%gil%dim(2)),stat=ier)
        if (ier.ne.0) then
          call map_message(seve%e,rname,'SINGLEDISH temporary data allocation error')
          error = .true.
          return
        endif
        blc = head%blc(1)
        head%blc(1) = 1
        call map_read_data(fd,fits_fmt,head,tmp_data,error)
        !
        ! Put in place
        dsingle(1:3,:,1) = tmp_data(1:3,:)  ! Extra columns
        dsingle(4:,:,1) = tmp_data(blc:,:)  ! Real data
        deallocate(tmp_data)
      else
        call map_read_data(fd,fits_fmt,head,dsingle,error)
      endif
      if (error) return
      !
      call get_more_header(fits_fmt,head%file,hsingle)
      call sic_mapgildas('SINGLE',hsingle,error,dsingle)
    case ('UV_FIT')
      call sic_delvariable ('UV_FIT',.false.,error)
      if (allocated(duvfit)) deallocate(duvfit,stat=ier)
      ! Specify the subset
      error = map_range(nc,head,huvfit)
      if (error) return
      allocate(duvfit(huvfit%gil%dim(1),huvfit%gil%dim(2)), & 
       &        stat=ier)
      call gdf_read_data(head,duvfit,error) 
      if (error) return
      call sic_mapgildas ('UV_FIT',huvfit,error,duvfit)
      !
    case ('CONTINUUM')
      call gdf_trim_header(head,2,error)
      if (error) return
      !
      save_data(code_save_cont) = .false.
      call sic_delvariable ('CONTINUUM',.false.,error)
      if (allocated(dcont)) deallocate(dcont,stat=ier)
      ! No subset allowed
      call gdf_copy_header(head, hcont, error)
      allocate(dcont(hcont%gil%dim(1),hcont%gil%dim(2)),   &
       &        stat=ier)
      call map_read_data(fd,fits_fmt,head,dcont,error)
      if (error) return
      call sic_mapgildas ('CONTINUUM',hcont,error,dcont)
      !
    case default
      chain = 'Unsupported operation '//out
      call map_message(seve%e,rname,chain)
      error = .true.
    end select
    !
    ! Compact Array data
  else
    ! 4-D not yet done...
    !
    select case (out)
    case ('BEAM')
      call gdf_copy_header(head, c_hbeam, error)
      c_hbeam%loca = head%loca
      save_data(code_save_beam) = .false.
      call sic_delvariable ('C_BEAM',.false.,error)
      if (allocated(c_dbeam)) deallocate(c_dbeam,stat=ier)
      allocate(c_dbeam(c_hbeam%gil%dim(1),c_hbeam%gil%dim(2),   &
           &        c_hbeam%gil%dim(3)),stat=ier)
      call map_read_data(fd,fits_fmt,c_hbeam,c_dbeam,error)
      if (error) return
      c_hbeam%gil%dim(3) = max(1,c_hbeam%gil%dim(3))
      call sic_def_real ('C_BEAM',c_dbeam,c_hbeam%gil%ndim,   &
           &        c_hbeam%gil%dim,.true.,error)
    case ('DIRTY')
      call gdf_copy_header(head, c_hdirty, error)
      c_hdirty%loca = head%loca
      save_data(code_save_dirty) = .false.
      call sic_delvariable ('C_DIRTY',.false.,error)
      if (allocated(c_ddirty)) deallocate(c_ddirty,stat=ier)
      allocate(c_ddirty(c_hdirty%gil%dim(1),c_hdirty%gil%dim(2),   &
           &        c_hdirty%gil%dim(3)),stat=ier)
      call map_read_data(fd,fits_fmt,c_hdirty,c_ddirty,error)
      if (error) return
      call sic_def_real ('C_DIRTY',c_ddirty,c_hdirty%gil%ndim,   &
           &        c_hdirty%gil%dim,.true.,error)
      cuse_method%do_mask = .true.
      !
    case ('RESIDUAL')
      call gdf_copy_header(head, c_hresid, error)
      c_hresid%loca = head%loca
      save_data(code_save_resid) = .false.
      call sic_delvariable ('C_RESIDUAL',.false.,error)
      if (allocated(c_dresid)) deallocate(c_dresid,stat=ier)
      allocate(c_dresid(c_hresid%gil%dim(1),c_hresid%gil%dim(2),   &
           &        c_hresid%gil%dim(3)),stat=ier)
      call map_read_data(fd,fits_fmt,c_hresid,c_dresid,error)
      if (error) return
      call sic_def_real ('C_RESIDUAL',c_dresid,c_hresid%gil%ndim,   &
           &        c_hresid%gil%dim,.true.,error)
      cuse_method%do_mask = .true.
      !
    case ('PRIMARY')
      call gdf_copy_header(head, c_hprim, error)
      c_hprim%loca = head%loca
      call sic_delvariable ('C_PRIMARY',.false.,error)
      if (allocated(c_dprim)) deallocate(c_dprim,stat=ier)
      allocate(c_dprim(c_hprim%gil%dim(1),c_hprim%gil%dim(2),   &
           &        c_hprim%gil%dim(3)),stat=ier)
      call map_read_data(fd,fits_fmt,c_hprim,c_dprim,error)
      if (error) return
      call sic_def_real ('C_PRIMARY',c_dprim,c_hprim%gil%ndim,   &
           &        c_hprim%gil%dim,.true.,error)
      !
      ! Switch to mosaic mode
      cuse_method%trunca = c_hprim%gil%inc(1)  ! Truncation of beam
      cuse_method%search = cuse_method%trunca
      cuse_method%mosaic = .true.
    case default
      chain = 'Unsupported operation '//out
      call map_message(seve%e,rname,chain)
      error = .true.
    end select
  endif
end subroutine map_read
!
function map_range (nc,hin,hou)
  use image_def
  use imager_interfaces, only : map_message
  use gkernel_interfaces, only : gdf_range
  use gbl_message
  !---------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- Utility routine  
  !   Define channel range and set output Map header
  ! accordingly.
  !!
  !---------------------------------------------------
  logical :: map_range ! intent(out)
  integer, intent(in) :: nc(2)           !! Input channel range
  type (gildas), intent(inout) :: hin    !! Input header
  type (gildas), intent(inout) :: hou    !! Output header
  !
  ! Local ---
  integer :: local_nc(2), hdim, faxi, rank
  !
  ! Code ----
  map_range = .false.
  !
  ! Trim header to 3
  rank = 3
  call gdf_trim_header(hin,rank,map_range)
  if (map_range) return
  !
  ! Copy header
  call gdf_copy_header(hin, hou, map_range)
  if (map_range) return
  hou%loca = hin%loca
  !
  ! Verif Frequency axsi
  faxi = hin%gil%faxi
  !
  if (faxi.eq.0) then
    ! NO Frequency axis -- map_range must called with default value
    local_nc = abs(nc)
    map_range = (local_nc(1).lt.1).or.(local_nc(2).gt.hin%gil%dim(3))
    if (map_range) then
      call map_message(seve%e,'READ','invalid /RANGE option arguments')
      return
    endif
    faxi = 3
  else
    !
    ! Frequency axis: Find out the actual range
    if (nc(2).lt.0) then
      faxi = 3
      local_nc = -nc
    else
      local_nc = nc
    endif
    map_range = gdf_range(local_nc,hin%gil%dim(faxi)).ne.0
    if (map_range) return
  endif
  !
  hdim = local_nc(2) - local_nc(1) + 1
  !
  ! Set the input header subset range
  hin%blc(faxi) = local_nc(1)
  hin%trc(faxi) = local_nc(2)
  !
  ! Set the output header reference channel and number of channels
  hou%gil%ref(faxi) = hou%gil%ref(faxi)+1-max(hin%blc(faxi),1)
  hou%gil%dim(faxi) = hdim
  !
  ! Correct the data size
  hou%loca%size = hin%loca%size*hou%gil%dim(faxi)/hin%gil%dim(faxi)
end function map_range
!
subroutine out_range(rname,atype,drange,nc,head,error)
  use image_def
  use gbl_message
  use gkernel_interfaces
  use imager_interfaces, only : map_message
  !---------------------------------------------------------------------
  ! @ private
  !* 
  ! IMAGER -- Utility routine to define a channel range from a
  !   Velocity, Frequency or Channel range
  !!
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: rname    !! Caller name
  character(len=*), intent(in) :: atype    !! Type of range
  real(8), intent(in) :: drange(2)         !! Input range
  integer, intent(out) :: nc(2)            !! Ouput channel number
  type(gildas), intent(in) :: head         !! Reference GILDAS data frame
  logical, intent(out) :: error            !! Logical error flag
  !
  ! Constants
  integer(kind=4), parameter :: mtype=4
  character(len=12) :: types(mtype)
  data types /'CHANNEL','VELOCITY','FREQUENCY','NONE'/
  !
  ! Local ---
  character(len=12) :: mytype,ctype
  real(8) :: frange(2)
  integer :: itype, nn, ier, nchan
  character(len=80) :: chain
  !
  ! Code ----
  ctype = atype
  call sic_upper(ctype)
  error = .false.
  call sic_ambigs(rname,ctype,mytype,itype,types,mtype,error)
  if (error)  return
  !
  if (abs(head%gil%type_gdf).eq.code_gdf_uvt) then
    nchan = head%gil%nchan
  else if (mytype.ne.'NONE') then
    if (head%gil%faxi.ne.0) then
      nchan = head%gil%dim(head%gil%faxi)
    else if (head%gil%ndim.eq.2) then
      call map_message(seve%w,rname,'Dataset is 2-D only') 
      nchan = 1
    else if (mytype.ne.'CHANNEL') then
      call map_message(seve%e,rname, &
        & 'No Frequency axis, /RANGE option ignored.')
      error = .true.
      return
    else
      nchan = head%gil%dim(3)
    endif
  else 
    nchan = max(1,head%gil%dim(3))
    ! Oops, need to Handle the special Class Table case
    ! But what happens when loading a single-channel map ???
    if (head%gil%ndim.eq.2) then
      if (head%gil%faxi.ne.0) then
        nchan = max(1,head%gil%dim(head%gil%faxi))
      endif
    endif
  endif
  !
  if (mytype.eq.'CHANNEL') then
    nc = nint(drange)
  else if (mytype.eq.'VELOCITY') then
    if ( abs(head%gil%type_gdf).eq.abs(code_gdf_uvt) ) then
      ! UV data case
      frange = (drange - head%gil%voff) / head%gil%vres + head%gil%ref(head%gil%faxi)
    else if  (head%gil%faxi.eq.0) then  !
      call map_message(seve%e,rname,'No Velocity/Frequency Axis')
      error = .true.
      return
    else if (head%char%code(head%gil%faxi).eq.'FREQUENCY') then
      frange = -(drange-head%gil%voff)*head%gil%freq/299792.458d0+head%gil%freq
      frange = (frange - head%gil%val(head%gil%faxi)) / head%gil%fres + head%gil%ref(head%gil%faxi)
    else if (head%char%code(head%gil%faxi).eq.'VELOCITY') then
      frange = (drange - head%gil%voff) / head%gil%vres + head%gil%ref(head%gil%faxi)
    else
      call map_message(seve%e,rname,'Axis type '//head%char%code(head%gil%faxi)//' not supported')
      error = .true.
      return
    endif
    !
    nc = nint(frange)
    if (nc(1).gt.nc(2)) then
      nn = nc(2)
      nc(2) = nc(1)
      nc(1) = nn
    endif
    if (nc(1).gt.nchan .or. nc(2).lt.1) then
      write(chain,'(A,I0,A,I0,A,I0,A)') 'Channel Range [',nc(1),',',nc(2),'] out of bounds [1,',nchan,']'
      call map_message(seve%e,rname,chain)
      error = .true.
      return
    else
      write(chain,'(A,I0,A,I0,A)') 'Selecting Channel Range [',nc(1),',',nc(2),']'
      call map_message(seve%i,rname,chain)
    endif
    nc = max(1,min(nc,nchan))
  else if (mytype.eq.'FREQUENCY') then
    ! The current code is only valid for UV Tables.
    ! See as above for the VELOCITY case
    ! drange = nc - head%gil%ref(head%gil%faxi) ) * head%gil%vres + head%gil%voff
    if ( abs(head%gil%type_gdf).eq.abs(code_gdf_uvt) ) then
      ! UV data case is always the same...
      frange = (drange - head%gil%freq) / head%gil%fres + head%gil%ref(head%gil%faxi)
    else if (head%gil%faxi.eq.0) then  !
      call map_message(seve%e,rname,'No Velocity/Frequency Axis')
      error = .true.
      return
    else if (head%char%code(head%gil%faxi).eq.'FREQUENCY') then
      frange = (drange - head%gil%val(head%gil%faxi)) / head%gil%fres + head%gil%ref(head%gil%faxi)
    else if (head%char%code(head%gil%faxi).eq.'VELOCITY') then
      frange = -(drange-head%gil%freq)/head%gil%freq*299792.458d0 + head%gil%voff
      frange = (frange - head%gil%val(head%gil%faxi)) / head%gil%vres + head%gil%ref(head%gil%faxi)
    else
      call map_message(seve%e,rname,'Axis type '//head%char%code(head%gil%faxi)//' not supported')
      error = .true.
      return
    endif
    !
    nc = nint(frange)
    if (nc(1).gt.nc(2)) then
      nn = nc(2)
      nc(2) = nc(1)
      nc(1) = nn
    endif
    if (nc(1).gt.nchan .or. nc(2).lt.1) then
      write(chain,'(A,I8,A,I8,A,I8,A)') 'Range [',nc(1),',',nc(2),'] out of bounds [1,',nchan,']'
      call map_message(seve%e,rname,chain)
      error = .true.
      return
    endif
    nc = max(1,min(nc,nchan))
  else if (mytype.eq.'NONE') then
    nc = nint(drange)
  else
    call map_message(seve%f,rname,"Type of value '"//trim(mytype)//"' not supported")
    error = .true.
    return
  endif
  !
  ier = gdf_range (nc, nchan)
  if (abs(head%gil%type_gdf).eq.code_gdf_uvt) then
    continue
  else
    if (mytype.eq.'NONE') nc = -nc  ! Negative value special code
  endif
  if (ier.ne.0) error = .true.
  !
end subroutine out_range
!
function tab_range (nc,hin,hou,subset)
  use image_def
  use gkernel_interfaces, only : gdf_range
  !---------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- Internal routine. 
  !
  !   Define channel range and set output Table header
  ! accordingly. Valid for a CLASS Table of Spectra
  !!
  !---------------------------------------------------
  logical :: tab_range ! intent(out)
  integer, intent(in) :: nc(2)          !! Input channel range
  type (gildas), intent(inout) :: hin   !! Input header
  type (gildas), intent(inout) :: hou   !! Output header
  logical, intent(out) :: subset        !! Is this a subset ?
  !
  ! Local ---
  integer local_nc(2), hdim, faxi
  integer(kind=index_length) :: fdim
  !
  ! Code ----
  subset = .false.
  ! Copy header
  call gdf_copy_header(hin, hou, tab_range)
  if (tab_range) return
  hou%loca = hin%loca
  !
  ! Find out the actual range
  faxi = hin%gil%faxi
  local_nc = abs(nc)    ! Out_Range may return negative value as code
  fdim = hin%gil%dim(faxi)-3
  tab_range = gdf_range(local_nc,fdim).ne.0
  if (tab_range) return
  hdim = local_nc(2) - local_nc(1) + 1 + 3 ! Allow 3 additional columns
  !
  ! Set the input header subset range
  local_nc = local_nc+3                    ! Shift by the 3 columns
  hin%blc(faxi) = local_nc(1)
  hin%trc(faxi) = local_nc(2)
  !
  ! Set the output header reference channel and number of channels
  hou%gil%ref(faxi) = hou%gil%ref(faxi)+1-max(hin%blc(faxi)-3,1)
  hou%gil%dim(faxi) = hdim
  !
  ! Correct the data size
  hou%loca%size = hin%loca%size*hou%gil%dim(faxi)/hin%gil%dim(faxi)
end function tab_range
!
subroutine check_view(n,argu)
  ! @ public-mandatory
  !*
  ! IMAGER -- VIEWER -- Support for VIEW command
  !
  ! Declare that all buffers specificied in argu(n) must be
  ! reloaded by VIEW.
  !!
  integer, intent(in) :: n                !! Number of buffers to be checked
  character(len=*), intent(in) :: argu(n) !! Buffer name
  !
  ! Local ---
  logical :: error
  character(len=12) :: previous
  integer :: i,nn
  !
  ! Code ----
  ! Do not use commands here, only direct SIC routines
  call sic_get_char('IVIEW%PREVIOUS',previous,nn,error)
  do i=1,n
    if (previous.eq.argu(i)) then    
      call sic_let_char('IVIEW%PREVIOUS','outdated',error)
    endif
  enddo
end subroutine check_view
!
subroutine parse_range_opt(line,o_range,head,nc,error)
  use image_def
  use gkernel_interfaces
  use imager_interfaces, only : out_range
  !---------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- Utility routine.  
  ! Parse the /RANGE option in a general way, once the data Header is
  ! defined.
  !!
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: line      !! Command line
  integer, intent(in) :: o_range            !! /RANGE option number
  type(gildas), intent(in) :: head          !! Data header
  integer, intent(inout) :: nc(2)           !! Channel range
  logical, intent(out) :: error             !! Error flag
  !
  ! Constants
  integer(kind=4), parameter :: msort=3
  character(len=12) :: types(msort)
  data types /'CHANNEL','VELOCITY','FREQUENCY'/
  !
  ! Local ---
  real(8) :: drange(2)        ! Range to be read
  character(len=12) :: csort, mysort
  integer :: isort, nn
  !
  ! Code ----
  error = .false.
  ! /RANGE (for flexibility)
  if (sic_present(o_range,0)) then
    call sic_r8 (line,o_range,1,drange(1),.true.,error)
    if (error) return
    call sic_r8 (line,o_range,2,drange(2),.true.,error)
    if (error) return
    call sic_ke (line,o_range,3,csort,nn,.true.,error)
    if (error) return
    error = .false.
    call sic_ambigs('READ',csort,mysort,isort,types,msort,error)
    if (error)  return
  else
    return
  endif
  !
  call out_range('READ',csort,drange,nc,head,error)
end subroutine parse_range_opt
!
subroutine sub_read_flux(name,error)
  use gkernel_interfaces
  use moment_arrays
  use gbl_message
  use imager_interfaces, only : map_message
  !-------------------------------------------------------
  ! @ private
  !*
  !   IMAGER -- Support routine for READ FLUX  
  !-------------------------------------------------------
  character(len=*), intent(in) :: name    !! Short file name
  logical, intent(inout) :: error         !! Error return flag
  !
  ! Local ---
  character(len=*), parameter :: rname='READ FLUX'
  type(gildas) :: htab
  integer :: ier
  logical :: err
  integer(kind=index_length) :: dim(2)
  !
  ! Code ----
  ! Delete any existing structure
  err = .false.
  call sic_delvariable('FLUX',.false.,err)
  if (allocated(flux_velo)) then
    deallocate(flux_velo,flux_freq,flux_values,stat=ier)
  endif
  flux_nc = 0
  flux_nf = 0
  !
  call gildas_null(htab)
  call sic_parse_file (name,' ','.tab',htab%file)
  call gdf_read_header(htab,error)
  if (error) return
  if (htab%gil%ndim.ne.2 .or. htab%gil%dim(2).lt.3) then
    call map_message(seve%e,rname,trim(htab%file)//' is not a Flux Table')
    err = .true.
    goto 98
  endif
  !
  flux_nc = htab%gil%dim(1) 
  flux_nf = htab%gil%dim(2) - 2 
  allocate (flux_velo(flux_nc),flux_freq(flux_nc),flux_values(flux_nc,flux_nf), &
    & htab%r2d(htab%gil%dim(1),htab%gil%dim(2)),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'Memory allocation error')
    err = .true.
    goto 98
  endif  
  !
  call gdf_read_data(htab,htab%r2d,err)
  if (err) goto 98
  !
  flux_velo(:) =   htab%r2d(:,1) 
  flux_freq(:) =   htab%r2d(:,2) ! Loss of precision, but tolerable in most cases.
  flux_values(:,:) =  htab%r2d(:,3:)
  !
  ! Redefine the FLUX structure
  !
  call sic_defstructure('FLUX',.true.,error)
  dim(1:2) = [flux_nc,flux_nf]
  call sic_def_real('FLUX%VALUES',flux_values,2,dim,.false.,error) 
  dim(1:2) = [flux_nc,1]
  call sic_def_real('FLUX%VELOCITIES',flux_velo,1,dim,.false.,error) 
  call sic_def_dble('FLUX%FREQUENCIES',flux_freq,1,dim,.false.,error) 
  call sic_def_inte('FLUX%NF',flux_nf,0,dim,.false.,error) 
  call sic_def_inte('FLUX%NC',flux_nc,0,dim,.false.,error) 
  !  
98  continue
  call gdf_close_image(htab,error)
  if (associated(htab%r2d)) deallocate(htab%r2d)
  error = err
end subroutine sub_read_flux
!
subroutine map_read_data(fd,fits_fmt,head,rdata,error)
  use gkernel_interfaces
  use gkernel_types
  use imager_interfaces, only : map_message
  use gbl_message
  !-------------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- Utility routine  
  !   Read data in an internal buffer, from a GDF file
  !   or a FITS file, as indicated by "is_fits"
  !!
  !-------------------------------------------------------
  type(gfits_hdesc_t), intent(in) :: fd     !! FITS descriptor
  integer, intent(in) :: fits_fmt           !! Is a FITS file ?
  type(gildas), intent(inout) :: head       !! GILDAS header
  real, intent(out) :: rdata(*)             !! Data array
  logical, intent(inout) :: error           !! Error flag
  !
  ! Local ---
  integer(kind=size_length) :: nfill,ndata,nblank
  logical :: err
  !
  ! Code ----
  if (fits_fmt.eq.0) then
    call gdf_read_data(head,rdata,error)
  else
    ndata = product(head%gil%dim(1:head%gil%ndim))
    ! Make sure the FITS file is at the right position
    nfill = 0
    call gfits_flush_data(error)
    if (error) return
    !
    ! Read data - Subset will come later
    call read_allmap(fd,rdata,ndata,nfill,head%gil%bval,error)
    if (nfill.lt.ndata) call map_message(seve%w,'READ','FITS data file is incomplete')
    ! Close FITS file now for immediate re-use
    err = .false.
    call gfits_close(err)
    !
    ! Patch Blanks if any
    nblank = 0
    err = .false.
    call fitscube2gdf_patch_bval(fd,head,rdata,ndata,nblank,err)
    if (nblank.eq.0) head%gil%eval = -1.0
    !
  endif
  !
  ! Set size
  head%loca%size = product(head%gil%dim(1:head%gil%ndim))
end subroutine map_read_data
!
subroutine get_more_header(fits_fmt,file,head)
  use image_def
  use iso_c_binding
  use gkernel_interfaces
  use gbl_message
  use gkernel_types
  use imager_interfaces, only : map_message, sub_memory_fields, get_beam_fits_value
  !-------------------------------------------------------
  ! @ private
  !*
  !   IMAGER -- Utility routine  
  !
  !     Update an internal Gildas Header by converting
  ! some possibly non-standard units. If the origin is
  ! a FITS file, update missing information from that found
  ! in specific FITS Table extensions.  The SIC command 
  ! DEFINE FITS is used for this purpose.
  !!
  !-------------------------------------------------------
  type(gildas), intent(inout) :: head     !! Header to be updated
  character(len=*), intent(in) :: file    !! Input file name
  integer, intent(in) :: fits_fmt         !! Is it FITS ?
  !
  ! Constants
  real, parameter :: pi=acos(-1.0)
  character(len=*), parameter :: rname='READ'
  real(8), parameter :: clight=299792458d0
  real(4), parameter :: rad_to_sec=180.*3600./pi
  integer, parameter :: lmax=54
  !
  ! Local ---
  real(8), pointer :: d1ptr(:)
  real(4), pointer :: r1ptr(:)
  type(c_ptr) :: cptr
  character(len=filename_length) :: chain
  logical :: error, err, found
  type(sic_descriptor_t) :: desc
  character(len=512) :: mess
  character(len=64) :: name, string
  character(len=24) :: c24
  character(len=80) :: c80
  integer :: nnn, n, n_if, i, nf, ier, next, nstok, ll
  real(4) :: diaml, diamu
  real(8) :: xx, fratio, obsfreq, restfre, redshift, dummy(3)
  real(8) :: ra,dec,dm,dp,ifzero
  real(8), allocatable :: raval(:),deval(:),raoff(:),deoff(:), offs(:,:), ifreq(:)
  real(8), allocatable :: pmra(:), pmdec(:)
  real(8) :: yy,scale
  type(projection_t) :: uv_proj
  !
  ! Code ---
  call map_message(seve%t,'READ','Entering get_more_header')
  !
  ! Always set size
  head%loca%size = product(head%gil%dim(1:head%gil%ndim))
  ll = len_trim(file)
  if (ll.gt.lmax) then
    head%file = '[ '//file(1:20)//'...'//file(ll+30-lmax:ll)//' ]'
  else
    head%file = '[ '//trim(file)//' ]' ! File name
  endif
  !
  ! Convert unusual Keywords
  if (head%char%unit.eq.'beam-1 Jy') head%char%unit ='Jy/beam'
  if (fits_fmt.eq.0) return
  !
  ! Now handle any other critical information from additional Tables
  if (file(1:1).eq.'/'.or.index(file(1:ll),' ').ne.0) then
    chain = 'define fits atmpf "'//trim(file)//'" header /global'
  else
    chain = 'define fits atmpf '//trim(file)//' header /global'
  endif
  !
  error = .false.
  call exec_command(chain,error)
  if (error) then
    call map_message(seve%w,rname,'Ignoring read error in Binary Tables, continuing as much as possible',seve%e)
    error = .false.
  endif
  !
  if (head%gil%type_gdf.eq.code_gdf_image) then
    if (sic_varexist('ATMPF%BEAMS')) then
      head%gil%reso_words = 3
      call get_beam_fits_value(head%gil%majo,'BMAJ',error)
      head%gil%majo = pi*head%gil%majo/180./3600.
      call get_beam_fits_value(head%gil%mino,'BMIN',error)
      head%gil%mino = pi*head%gil%mino/180./3600.
      call get_beam_fits_value(head%gil%posa,'BPA',error)
      head%gil%posa = pi*head%gil%posa/180.
    endif
  else if (head%gil%type_gdf.eq.code_gdf_uvt) then
    !
    ! Frequency axis must be defined, otherwise this is NOT a UVFITS file
    obsfreq = 0
    do i=3,6
      call sic_get_char('ATMPF%CTYPE'//char(i+ichar('0')),string,n,error)
      if (string.eq."FREQ") then
        call sic_get_dble('ATMPF%CRVAL'//char(i+ichar('0')),obsfreq,error)
      else if (string.eq."IF") then
        call sic_get_inte('ATMPF%NAXIS['//char(i+ichar('0'))//']',n_if,error)
        if (n_if.gt.1) then
          call map_message(seve%w,rname,"More than 1 IF in UVFITS file, proceed with caution",seve%e)
        endif
      endif
    enddo
    if (obsfreq.eq.0) then
      call map_message(seve%e,rname,"Input file is not a UVFITS")
      ! 
      err = .false.
      call sic_delvariable('ATMPF',.true.,err)
      error = .true.
      return 
    endif
    ! This has already been handled by the basic Header
    !   head%gil%val(1) = obsfreq*1D-6
    !
    ! Unit
    if (head%char%unit.eq."UNCALIB") head%char%unit = 'Jy'
    !
    ! Pointing and Phase centers
    name = 'ATMPF%AIPS_SU%COL%RAEPO'
    nnn = len_trim(name)
    if (sic_varexist(name)) then
      ! Mosaic (possibly degenerate)
      call sic_descriptor(name(1:nnn),desc,found)
      nf = desc%size/2  ! It is a Double Precision variable
      if (nf.le.1) then
        ! Single field case, just set A0 D0
        call sic_get_dble('ATMPF%AIPS_SU%COL%RAEPO',xx,error)
        xx = xx*pi/180
        if (xx.lt.0) xx = xx+2*pi
        head%gil%a0 = xx
        head%gil%ra = xx
        !
        call sic_get_dble('ATMPF%AIPS_SU%COL%DECEPO',xx,error)
        xx = xx*pi/180
        if (xx.lt.0) xx = xx+2*pi
        head%gil%d0 = xx
        head%gil%dec = xx
        !
        call sic_get_char('ATMPF%AIPS_SU%COL%SOURCE',head%char%name,nnn,error)
      else
        ! Convert the Descriptors to Fortran arrays
        allocate(raval(nf),deval(nf),raoff(nf),deoff(nf),offs(2,nf),stat=ier)
        if (ier.ne.0) then
          call map_message(seve%e,rname,'Array allocation error')
          err = .false.
          call sic_delvariable('ATMPF',.true.,err)
          error = .true.
          error = .true.
          return
        endif
        !
        call adtoad(desc%addr,cptr,1)
        call c_f_pointer(cptr,d1ptr,[nf])
        raval(:) = d1ptr * pi/180.d0
        do i=1,nf
          if (raval(i).lt.0) raval(i) = raval(i)+2*pi
        enddo
        dm = minval(raval)
        dp = maxval(raval)
        ra = (dm+dp)/2
        !
        name = 'ATMPF%AIPS_SU%COL%DECEPO'
        nnn = len_trim(name)
        call sic_descriptor(name(1:nnn),desc,found)
        call adtoad(desc%addr,cptr,1)
        call c_f_pointer(cptr,d1ptr,[nf])
        deval(:) = d1ptr * pi/180d0
        !
        dm = minval(deval)
        dp = maxval(deval)
        dec = (dm+dp)/2
        !
        head%gil%a0 = ra
        head%gil%d0 = dec
        !
        ! Set the Projection
        call gwcs_projec(head%gil%a0,head%gil%d0,head%gil%pang,head%gil%ptyp,uv_proj,error)
        !
        ! Convert to Offsets
        call abs_to_rel(uv_proj,raval,deval,raoff,deoff,nf)
        offs(1,:) = raoff
        offs(2,:) = deoff
        ! List the Offsets
        call map_message(seve%i,rname,'Offsets : ')
        next = 1
        do i=1,nf
          write(c24,'(A,F9.4,A,F9.4,A)') "(",offs(1,i)*rad_to_sec,',',offs(2,i)*rad_to_sec,')'
          c80(next:) = c24
          next = next+24
          if (next.ge.70) then
            write(*,'(A)') c80
            next = 1
          endif
        enddo
        if (next.gt.1) write(*,'(A)') c80(1:next-1)
        !
        call sic_get_char('ATMPF%AIPS_SU%COL%SOURCE[1]',head%char%name,nnn,error)
        error = .false.
        call sub_memory_fields(head,head%r2d,nf,offs,error)
        !
      endif
    else
      ! Single fields: Assume RA & Dec from phase center
      if (head%gil%a0.eq.0 .and. head%gil%d0.eq.0) then
        call map_message(seve%w,rname,'Phase center is 0,0 => please check source coordinates afterwards.',seve%w)
      else
        head%gil%ra = head%gil%a0
        head%gil%dec = head%gil%d0
      endif
      call sic_get_char('ATMPF%AIPS_SU%COL%SOURCE',head%char%name,nnn,error) ! Does not harm...
    endif
    !
    ! Proper Motion information
    name = 'ATMPF%AIPS_SU%COL%PMRA'
    nnn = len_trim(name)
    if (sic_varexist(name)) then
      ! Mosaic (possibly degenerate)
      call sic_descriptor(name(1:nnn),desc,found)
      nf = desc%size/2  ! It is a Double Precision variable
      nf = max(nf,1)
      allocate(pmra(nf),pmdec(nf),stat=ier)
      if (ier.ne.0) then
        call map_message(seve%e,rname,'Array allocation error')
        err = .false.
        call sic_delvariable('ATMPF',.true.,err)
        error = .true.
        return
      endif      
      if (nf.le.1) then
        ! Single field case, just set A0 D0
        call sic_get_dble('ATMPF%AIPS_SU%COL%PMRA',pmra(1),error)
        call sic_get_dble('ATMPF%AIPS_SU%COL%PMDEC',pmdec(1),error)
        !
      else
        ! Convert the Descriptors to Fortran arrays
        !
        call adtoad(desc%addr,cptr,1)
        call c_f_pointer(cptr,d1ptr,[nf])
        pmra(:) = d1ptr
        !
        name = 'ATMPF%AIPS_SU%COL%PMDEC'
        nnn = len_trim(name)
        call sic_descriptor(name(1:nnn),desc,found)
        call adtoad(desc%addr,cptr,1)
        call c_f_pointer(cptr,d1ptr,[nf])
        pmdec(:) = d1ptr
        !
      endif
      xx = maxval(abs(pmra))
      yy = maxval(abs(pmdec))
      xx = max(xx,yy)
      if (xx.gt.0.) then
        if (xx.gt.3E-11) then
          scale = 3600E3*365.25 
        else
          scale = 180/pi*3600E3*86400*365.25
        endif
        pmra = pmra*scale
        pmdec = pmdec*scale
        !
        ! List the Proper Motions 
        call map_message(seve%i,rname,'Proper Motions : ')
        next = 1
        do i=1,nf
          write(c24,'(A,F8.2,A,F8.2,A)') "(",pmra(i),',',pmdec(i),')'
          c80(next:) = c24
          next = next+24
          if (next.ge.70) then
            write(*,'(A)') c80
            next = 1
          endif
        enddo
        if (next.gt.1) write(*,'(A)') c80(1:next-1)
      endif
      !
    endif
    !
    ! ACA antenna size
    if (sic_varexist('ATMPF%AIPS_AN')) then
      ! In theory, one should loop over the various version of the AIPS_AN extensions.
      ! In practice, they are nearly identical for these informations.
      call sic_get_char('ATMPF%AIPS_AN%ARRNAM',name,nnn,error)
      if (name.eq."ALMA") then
        ! Get a pointer 
        name = 'ATMPF%AIPS_AN%COL%DIAMETER'
        nnn = len_trim(name)
        call sic_descriptor(name(1:nnn),desc,found)
        if (found) then
          nf = desc%size
          call adtoad(desc%addr,cptr,1)
          call c_f_pointer(cptr,r1ptr,[nf])
          !
          diaml = minval(r1ptr)
          diamu = maxval(r1ptr)
          if (diaml.ne.diamu) then
            head%gil%teles(1)%diam = diamu
            call map_message(seve%w,rname,"Mixed array telescope size in UVFITS, use at your own risk...",seve%e)
            call gdf_addteles(head,'NAME','ACA',dummy,error)
            head%gil%teles(2) = head%gil%teles(1)
            head%gil%teles(2)%ctele = 'ACA'
            head%gil%teles(2)%diam = diaml
          else
            head%gil%teles(1)%diam = diaml
            if (diaml.ne.0.and.diaml.lt.10) then
              head%gil%teles(1)%ctele = "ACA"
              call map_message(seve%w,rname,"Found ACA data, changed array name")
            endif
          endif
        endif
      endif
    endif
    !
    ! Verify Frequency axis
    if (sic_varexist('ATMPF%RESTFREQ')) then
      call sic_get_dble('ATMPF%RESTFREQ',restfre,error)
      !TEST!Print *,'RestFreq ',RestFre,' ObsFreq ',obsfreq,' reference ',head%gil%convert(2,1)
      !TEST!Print *,'Velocity ',head%gil%voff, ' Header ',head%gil%freq
      fratio = restfre/obsfreq
      if (fratio.gt.1.004) then
        redshift = fratio-1d0
        write(mess,'(A,F9.5,A,F12.3,A)') "Estimated redshift ",redshift," for Rest Frequency ",restfre*1D-6," MHz"
        call map_message(seve%i,rname,mess)
        call map_message(seve%w,rname,'Velocity reset to Zero and Rest Frequency adjusted accordingly')
        head%gil%voff = 0d0
        restfre = obsfreq
        !
        if (sic_varexist('REDSHIFT')) then
          call sic_let_dble('REDSHIFT',redshift,error)
        endif
      endif
      head%gil%freq = restfre*1D-6
      head%gil%val(1) = head%gil%freq
    endif
    !
    ! Velocities in excess of 2000 km/s are also presumably Extragalactic 
    if (head%gil%voff.gt.2000) then
      write(mess,'(A,1PG10.3,A)') 'Excessive Velocity ',head%gil%voff, &
        & 'reset to Zero and Rest Frequency adjusted accordingly'
      head%gil%val(1) = head%gil%freq*(1.d0-head%gil%voff/clight)
      head%gil%voff = 0
      head%gil%vres = head%gil%fres/head%gil%val(1)*clight
      head%gil%freq = head%gil%val(1)
      call map_message(seve%w,rname,mess)
    endif  
    !
    ! IFs are a special VLA - ALMA - CASA convention to specify the
    ! frequencies if n_IF is non zero
    name = 'ATMPF%AIPS_FQ%COL%IF_FREQ'
    nnn = len_trim(name)
    if (sic_varexist(name)) then
      call sic_descriptor(name(1:nnn),desc,found)
      nf = desc%size/2  ! It is a Double Precision variable
      if (n_if.ne.1) then
        if (nf.ne.head%gil%nchan) then
          call map_message(seve%w,rname,'Mismatch IF and Number of channels')
        else
          ! Convert the Descriptors to Fortran arrays
          allocate(ifreq(nf),stat=ier)
          !
          call adtoad(desc%addr,cptr,1)
          call c_f_pointer(cptr,d1ptr,[nf])
          ifreq(:) = d1ptr(:)
          !
          ! Get the Zero frequency
          call sic_get_dble('ATMPF%CRVAL4',ifzero,error)
          ifreq = ifreq+ifzero
          ! 
          ! Set the Random Frequency axis and Stokes values
          nstok = max(1,head%gil%nstokes)
          do i=1,nf !! head%gil%nchan
            head%gil%freqs((i-1)*nstok+1:i*nstok) = ifreq(i)*1d-6
          enddo
        endif
      endif
    endif
  endif
  ! 
  err = .false.
  call sic_delvariable('ATMPF',.true.,err)
  !
end subroutine get_more_header
!
subroutine get_beam_fits_value(r,key,error)
  use gkernel_interfaces
  !-------------------------------------------------------
  ! @ private
  !*
  !   IMAGER -- Utility routine 
  !
  !   Update a variable from a FITS  Beam%Col% column
  !   of specified name. Use SIC commands for this.
  !!
  !-------------------------------------------------------
  real, intent(inout) :: r              !! Variable
  character(len=*), intent(in) :: key   !! FITS Column name
  logical, intent(inout) :: error       !! Logical error flag
  !
  character(len=120) :: chain
  !
  !! This could be re-coded using a SIC Descriptor and C_PTR
  !! That would avoid Line command pointer issues
  call sic_def_real('A_TMP_VAR',r,0,0,.false.,error)
  chain = 'COMPUTE A_TMP_VAR MEDIAN ATMPF%BEAMS%COL%'//key
  call exec_command(chain,error)
  call sic_delvariable('A_TMP_VAR',.false.,error)
  error = .false.
end subroutine get_beam_fits_value
!
subroutine is_fitsfile(file,isfits,error)
  use gbl_message
  use imager_interfaces, only : map_message, map_iostat
  !-------------------------------------------------------
  ! @ private
  !*
  !   IMAGER -- Utility routine 
  !
  !   Test if a File is a valid FITS (image) file.
  !   No assumption is made about the file extension.
  !!
  !-------------------------------------------------------
  character(len=*), intent(in) :: file    !! File name
  logical, intent(out) :: isfits          !! Return value
  logical, intent(inout) :: error         !! Logical Error flag
  !
  ! Local ---
  integer :: ier
  character(len=10) :: chead
  !
  isfits = .false.
  error = .true.
  open(unit=1,file=file,status='OLD',action='READ',iostat=ier)
  if (ier.ne.0) then
    call map_iostat(seve%e,'READ',ier)
    return
  endif
  read(unit=1,fmt='(A)',iostat=ier) chead
  close(unit=1)
  if (ier.ne.0) then
    call map_iostat(seve%e,'READ',ier)
    return
  endif
  !
  if (chead.eq.'SIMPLE  = ') then
    isfits = .true.
    error = .false.
  else if (chead(1:6).eq.'GILDAS') then
    error = .false.
  else
    call map_message(seve%e,'READ',trim(file)// &
      & ' is neither a GILDAS nor a FITS format file')
    error = .true.
  endif
end subroutine is_fitsfile
!
subroutine map_read_uvdataset(fd,fits_fmt,pcount,htmp,head,local_nc,rdata,error)
  use gkernel_interfaces
  use gkernel_types
  use imager_interfaces, only : map_message, map_read_uvfits
  use gbl_message
  !-------------------------------------------------------
  ! @ private
  !*
  !   IMAGER -- Utility routine 
  !
  !   Read data in an internal buffer, from a GDF file
  !   or a FITS file, as indicated by "is_fits"
  !!
  !-------------------------------------------------------
  type(gfits_hdesc_t), intent(in) :: fd   !! FITS descriptor
  integer, intent(in) :: fits_fmt         !! FITS format file
  integer, intent(in) :: pcount           !! Fits group size if any
  type(gildas), intent(inout) :: htmp     !! Temporary header, with complete channel range
  type(gildas), intent(inout) :: head     !! Header of actual data,
  !!  using the specified channel range
  integer, intent(in) :: local_nc(2)      !! Channel range
  real, intent(out) :: rdata(:,:)         !! Data array
  logical, intent(inout) :: error         !! Logical Error flag
  !
  ! Local ---
  integer :: astoke
  logical :: eot, err
  !
  ! Code ----
  if (fits_fmt.eq.0) then
    call gdf_read_uvdataset(htmp,head,local_nc,rdata,error)
  else
    ! Make sure the FITS file is at the right position
    call gfits_flush_data(error)
    if (error) return
    !
    if (fits_fmt.gt.1) then
      astoke = 0   ! Get all Stokes parameters, otherwise inconsistent data size
    else
      astoke = 1   ! Only 1 output Stokes
    endif
    call map_read_uvfits(head,astoke,error,eot,pcount,rdata)
    ! Close FITS file now for immediate re-use
    err = .false.
    call gfits_close(err)
    !
  endif
  !
end subroutine map_read_uvdataset

subroutine map_read_uvfits(fits,astoke,error,eot,pcount,outarray)
  use image_def
  use gbl_format
  use gbl_message
  use image_def
  use gkernel_interfaces
  use imager_interfaces, only : map_message
  !---------------------------------------------------------------------
  ! @ private
  !*
  !  IMAGER -- Read a complete FITS UV table
  !!
  !---------------------------------------------------------------------
  type(gildas),    intent(inout) :: fits    !! Gildas header corresponding to FITS file
  integer(kind=4), intent(in)    :: astoke  !! Stokes parameter to be read
  logical,         intent(out)   :: error   !! Logical Error flag
  logical,         intent(out)   :: eot     !! End ot Tape flag
  integer(kind=4), intent(in)    :: pcount  !! Daps count
  real, intent(out) :: outarray(:,:)        !! Data array
  !
  ! Constants
  character(len=*), parameter :: rname='READ_UVFITS'
  real(kind=4), parameter :: ps=1.0e-6 ! Because GILDAS uses MHz
  ! Local ---
  character(len=message_length) :: mess
  character(len=1) :: cstoke
  logical :: err, do_stokes
  integer(kind=4) :: jv,ib,inchan,onchan,nblock
  real(kind=4) :: ws
  real(kind=4), allocatable :: inarray(:)
  integer(kind=4), allocatable :: in_stokes(:)
  integer(kind=4) :: in_nstokes, insize, stokes_order
  real(kind=4) :: trail, mtrail, rinte, indaps(7), parang, msou
  integer(kind=4) :: ier, i, lc
  ! 
  integer(kind=index_length) :: ngood, nflag, nempty, kv, iblc, idim, itrc
  logical :: good, needs_good
  integer :: lsour, lpara
  !
  ! Code ---
  !
  ! Prepare reading of the visibilities
  rinte = 0       ! Integration time
  eot = .false.   ! Otherwise, error on Ifort
  err = .false.   ! Make sure it is initialized
  error = .false.
  call gfits_flush_data(error)
  if (error) return
  mtrail = 0
  !
  call gdf_nitems('SPACE_GILDAS',nblock,fits%gil%dim(1)) ! Visibilities at once
  nblock = min(nblock,fits%gil%dim(2))
  !
  ! Optionally change the Stokes parameters
  in_nstokes = fits%gil%nstokes
  allocate(in_stokes(in_nstokes))
  if (associated(fits%gil%stokes)) then
    in_stokes(:) = fits%gil%stokes(1:in_nstokes)
  else
    in_stokes(:) = code_stokes_none
  endif
  !
  ! Keep all Stokes only if Astoke is 0 or all 4 Stokes present
  if (in_nstokes.eq.4) then
    if (astoke.ne.0) then
      call gio_message(seve%w,rname,'Keeping all 4 stokes parameters')
    endif
  else if (astoke.ne.0) then
    if (in_nstokes.gt.1) then
      call gio_message(seve%i,rname,'Treating signal as unpolarized')
    endif
    fits%gil%nstokes = 1
    fits%gil%stokes(1) =  code_stokes_none
    stokes_order = fits%gil%order
    fits%gil%order = 0                        ! No order if only 1 Stokes
  else
    if (in_nstokes.gt.1) then
      cstoke = char(in_nstokes+ichar('0'))
      call gio_message(seve%w,rname,'Keeping all '//cstoke//' stokes parameters')
    endif
  endif
  !
  if (in_nstokes.eq.fits%gil%nstokes) then
    allocate(inarray(fits%gil%dim(1)),stat=ier)
    inchan = fits%gil%nchan*fits%gil%nstokes
    onchan = inchan
  else
    ! Change a number of sizes and properly shift the Column Pointers
    ! before creating the data file
    onchan = fits%gil%nchan*fits%gil%nstokes
    inchan = fits%gil%nchan*in_nstokes
    insize = fits%gil%nlead + inchan*3 + fits%gil%ntrail
    fits%gil%dim(1) = (fits%gil%nlead + onchan*3 + fits%gil%ntrail)
    allocate(inarray(insize),stat=ier)
    !
    ! Shift trailing columns
    if (fits%gil%ntrail.ne.0) then
      ! This is a generic code 
      do i=1,code_uvt_last
       if (fits%gil%column_pointer(i).gt.fits%gil%nlead) then
          fits%gil%column_pointer(i) = fits%gil%column_pointer(i) + 3*(onchan-inchan)
        endif
      enddo
    endif
  endif
  if (ier.ne.0) then
    call gio_message(seve%e,rname,'Memory allocation error')
    error = .true.
    return
  endif
  !
  lc = fits%gil%dim(1)-fits%gil%ntrail
  !  
  ! Get useful trailer pointers (from the internals of the GIO library)
  ! WS is the Weight Scaling Factor, WPS in the GIO common !...
  call gio_internals(weight=ws,source=lsour,parang=lpara)
  ws = ws * ps                ! Final weight scaling factor
  !
  fits%blc(1) = 1
  fits%trc(1) = fits%gil%dim(1)
  fits%blc(2) = 0
  fits%trc(2) = 0
  error = .false.
  !
  if (in_nstokes.eq.fits%gil%nstokes) then
    if (in_nstokes.gt.1) call gio_message(seve%w,rname,'Keeping all Stokes parameters')
    do_stokes = .false.
    needs_good = .true.   ! Test ...
  else
    call gio_message(seve%w,rname,'Extracting unpolarized signal')
    do_stokes = .true.
    needs_good = .false.  ! Test itou...
  endif
  !
  ngood = 0
  nflag = 0
  nempty = 0
  msou = -1
  !
  ! Input sizes
  idim = fits%gil%dim(2)
  itrc = 0
  kv = 0  ! Output counter
  !
  do ib = 1, idim, nblock
    iblc = itrc+1
    itrc = min(idim,itrc+nblock)
    !
    write(mess,'(A,I9,A,I9,A,I9,A,I0,A)') &
         & 'Reading ',iblc,' to ', itrc, &
         & ' / ',idim,' (',nint((100.*itrc)/idim),'%)'
    call gio_message(seve%i,rname,mess)
    do jv = 1,itrc-iblc+1 
      good = needs_good
      call read_visi (indaps,inarray,inchan,ws,error,pcount,trail,rinte,parang,good)
      if (error) then
        write(mess,'(A,I0,A)') 'Error occcured at visibility ',KV+IBLC,'  - Rest ignored'
        call gio_message(seve%w,rname,mess)
      endif
      !
      if (good) then
        kv = kv+1
        ! Daps
        outarray(1:7,kv) = indaps 
        ! Visibilities
        if (do_stokes) then
          call uvfits_stokes_select(inarray,inchan,outarray(8:lc,kv),onchan, &
            & in_nstokes,in_stokes,fits%gil%stokes(1),stokes_order)
        else
          outarray(8:lc,kv) = inarray
        endif
        !
        ! Trailing columns
        if (fits%gil%ntrail.ne.0) then
          if (lsour.ne.0) then
            outarray(fits%gil%column_pointer(code_uvt_id),kv) = trail
            msou = max(msou,trail)
          endif
          if (lpara.ne.0) then
            outarray(fits%gil%column_pointer(code_uvt_para),kv) = parang
          endif
        endif
        ngood = ngood+1
      else
        nflag = nflag+1
      endif
    enddo
    !
    if (kv.ne.0) then
      fits%blc(2) = fits%trc(2)+1
      fits%trc(2) = fits%trc(2)+kv
    else
      nempty = nempty+1
    endif
    if (error) exit
  enddo
  !
  error = .false.
  write(mess,'(A,I9,A)') 'Read   ',ngood,' visibilities'
  call gio_message(seve%i,rname,mess)
  !
  ! If some data has been ignored, say it and update visibility number
  if (nempty.gt.0) then
    write(mess,'(I0,A)') nempty ,' input blocks were empty'
    call gio_message(seve%w,rname,mess)
  endif
  if (nflag.gt.0) then
    write(mess,'(A,I9,A)') 'Ignored ',nflag,' flagged visibilities'
    call gio_message(seve%w,rname,mess)
    fits%gil%nvisi = ngood  ! This is needed but not sufficient...
    fits%gil%dim(2) = ngood ! so it is better to also change the array size 
    !! call gdf_update_header(fits,error)
  endif
  if (fits%gil%nstokes.gt.1)  call map_message(seve%w,rname, &
      &   'More than 1 Stokes parameter, use STOKES command after',seve%w)
  !
  if (msou.ne.-1) then
    !
    ! Msou contains the largest Source ID, i.e. the number of sources
    if (msou.le.1) then
      call gio_message(seve%w,rname,'Only one source found in MultiSource UVFITS file')
      ! We could (and perhaps should) set these to 0,
      ! since the information is to be ignored. But that would mean
      ! undefined trailing columns in the UV data.
      !  ! fits%gil%column_pointer(code_uvt_id) = fits%gil%dim(1)-1
      !  ! fits%gil%column_size(code_uvt_id) = 1
    endif
    ! ! Needed only in case we update the Pointers.
    ! ! call gdf_update_header(fits,error)
  endif
  !
end subroutine map_read_uvfits

subroutine map_reproject_comm(line,error)
  use image_def
  use imager_interfaces, except_this => map_reproject_comm 
  use gkernel_interfaces, no_interface1 => gdf_copy_header
  use gkernel_types
  use gbl_message
  use clean_arrays
  use iso_c_binding
  !---------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- Support routine for command MAP_REPROJECT
  !
  ! MAP_REPROJECT Out In   
  !   /BLANKING Bval Eval  
  !   /LIKE Template  
  !   /PROJECTION Type Cx Cy [Unit] [Angle]  
  !   /SYSTEM Type [Equinox]  
  !   /X_AXIS Nx Ref Val Inc  
  !   /Y_AXIS Ny Ref Val Inc
  !!
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: line  !! Command line
  logical, intent(out) :: error         !! Logical error flag
  !
  ! Constants
  integer, parameter :: o_blank=1
  integer, parameter :: o_like=2
  integer, parameter :: o_proj=3
  integer, parameter :: o_syst=4
  integer, parameter :: o_xaxis=5
  integer, parameter :: o_yaxis=6
  real(8), parameter :: pi=3.141592653589793d0
  character(len=1), parameter :: question_mark='?'
  character(len=*), parameter :: rname='REPROJECT'
  integer(kind=4), parameter :: msys=5
  character(len=13) :: system(msys)
  data system /'UNKNOWN','EQUATORIAL','GALACTIC','HORIZONTAL','ICRS'/
  integer, parameter :: munit=5
  character(len=12) :: units(munit)
  data units/'ABSOLUTE','DEGREE','MINUTE','SECOND','RADIAN'/
  real(8), parameter :: vunit(munit)=[0.d0,pi/180.d0,pi/180.d0/60.d0,pi/180.d0/3600.d0,1.0d0]
  !
  ! Local ---
  character(len=13) :: argum,keywor,projnam_array(0:mproj)
  character(len=64) :: args
  real(8) :: funit, x0, y0, rr
  type (projection_t) :: gin_proj
  integer :: ier, iangle
  !
  type(gildas) :: gin, gout, gtemp
  character(len=filename_length) :: fich
  integer :: nsys, nkey, nunit
  integer :: sys_code, i
  integer :: n, rank, type, istart, length, nc
  real(kind=4) :: equinox
  real(kind=8) :: ra, dec, ang, convert(3)
  type(sic_descriptor_t) :: desc
  type(c_ptr) :: cptr
  logical :: found, is_image, in_image, out_image, rdonly, match
  !
  ! Code ---
  x0 = 0.d0
  y0 = 0.d0
  call gildas_null(gin)
  !
  call sic_ch(line,0,2,fich,n,.true.,error)
  in_image = .false.
  call sub_readhead (rname,fich,gin,in_image,error,rdonly,fmt_r4)
  if (error) return
  !
  rank=3
  call gdf_trim_header(gin,rank,error)  
  if (error) return
  !
  ! Template can be a SIC variable or a Gildas file...  !
  if (sic_present(o_like,0)) then
    if (sic_present(o_proj,0).or.sic_present(o_xaxis,0).or. &
        & sic_present(o_yaxis,0).or.sic_present(o_syst,0)) then
      call map_message(seve%e,rname,'/FILE option is incompatible ' &
        & //'with /PROJECTION, /SYSTEM, /X_AXIS and /Y_AXIS')
      error = .true.
      return
    endif
    ! Get shape from Template
    call sic_ch(line,o_like,1,fich,n,.true.,error)
    is_image = .false.
    call sub_readhead(rname,fich,gtemp,is_image,error)
  else
    ! Get shape from Input file, modified by other options
    call gildas_null(gtemp)
    call gdf_copy_header(gin,gtemp,error)
    if (error) return
    !
    if (sic_present(o_proj,0)) then
      call sic_ke(line,o_proj,1,argum,n,.true.,error)
      if (argum.ne.'*') then
        ! Solve the Ambiguity
        ! Set the projection type
        call projnam_list(projnam_array)
        call sic_ambigs(rname,argum,keywor,nkey,projnam_array,mproj+1,error)
        if (error) return
        gtemp%gil%ptyp = nkey-1
      endif
      !
      argum = '*'
      call sic_ke(line,o_syst,1,argum,n,.false.,error)
      if (argum.ne.'*') then
        call sic_ambigs(rname,argum,keywor,nsys,system,msys,error)
        if (error) return
        gtemp%char%syst = keywor
        !
        if (nsys.eq.type_eq) then
          equinox = 2000.0
          call sic_r4(line,o_syst,1,equinox,.false.,error)
          if (error)  return
          gtemp%gil%epoc = equinox
        endif
      endif
      !
      type = gtemp%gil%ptyp
      !
      ! Find input projection center
      funit = 0
      if (type.ne.p_none) then
        ! Check if UNIT keyword is present
        if (sic_present(o_proj,4)) then
          argum = '*'
          call sic_ke(line,o_proj,4,argum,n,.false.,error)
          if (.not.sic_present(o_proj,5)) then
            read(argum,*,iostat=ier) rr
          else
            ier = 1
          endif
          if (ier.ne.0) then            
            call sic_ambigs(rname,argum,keywor,nunit,units,munit,error)
            if (error) return
            funit = vunit(nunit)
          endif
          !
        endif
        !
        if (type.ne.p_aitoff) then
          if (sic_present(o_proj,3)) then
            if (funit.eq.0) then
              call sic_ke(line,o_proj,3,args,n,.false.,error)
              istart = sic_start(o_proj,3)
              length = sic_len(o_proj,3)
              if (line(istart:istart+2).ne.'*') then
                call sic_sexa(line(istart:),length,dec,error)
                if (error)  return
                gtemp%gil%d0 = dec*pi/180.0d0
              endif
            else
              call sic_r8(line,o_proj,3,y0,.false.,error)
              if (error) return
            endif
          endif
        elseif (sic_present(o_proj,2)) then
          call map_message(seve%w,rname,'Declination ignored in AITOFF')
          gtemp%gil%d0 = 0.0d0
        endif
        !
        if (sic_present(o_proj,2)) then
          if (funit.eq.0) then
            call sic_ke(line,o_proj,2,args,n,.false.,error)
            istart = sic_start(o_proj,2)
            length = sic_len(o_proj,2)
            ra = gtemp%gil%a0
            if (line(istart:istart+2).ne.'*') then
              call sic_sexa(line(istart:),length,ra,error)
              if (error)  return
              if (gtemp%char%syst.eq.'EQUATORIAL'.or.gtemp%char%syst.eq.'ICRS') then
                ra = ra*pi/12.0d0
              else
                ra = ra*pi/180.0d0
              endif
            endif
            gtemp%gil%a0 = ra
          else
            call sic_r8(line,o_proj,2,x0,.false.,error)
            if (error) return            
          endif
        endif
        !
        iangle = 4   ! Pointer to Rotation Angle argument
        if (funit.ne.0) then
          ! Setup Input projection
          call gwcs_projec(gin%gil%a0,gin%gil%d0,gin%gil%pang,gin%gil%ptyp,gin_proj,error)
          if (error) return
          !
          x0 = x0*funit
          y0 = y0*funit
          call rel_to_abs(gin_proj,x0,y0,gtemp%gil%a0,gtemp%gil%d0,1)
          iangle = 5    ! Pointer to Rotation Angle argument
        endif
        !
        ! Angle
        if (sic_present(o_proj,iangle)) then
          if (type.eq.p_aitoff) then
            call map_message(seve%w,rname,'Angle ignored in AITOFF')
            ang = 0.d0
          elseif (type.eq.p_radio) then
            call map_message(seve%w,rname,'Angle ignored in RADIO')
            ang = 0.d0
          else
            istart = sic_start(o_proj,iangle)
            length = sic_len(o_proj,iangle)
            call sic_sexa(line(istart:),length,ang,error)
            if (error)  return
            ang = ang*pi/180.0d0
          endif
          gtemp%gil%pang = ang
        endif
      elseif (sic_present(o_proj,1)) then
        call map_message(seve%w,rname,'Projection center ignored in /TYPE NONE')
      endif
      !
    endif
    !
    ! /X_AXIS N Ref Val Inc
    if (sic_present(o_xaxis,0)) then
      call sic_i4(line,o_xaxis,1,nc,.true.,error)
      if (error) return
      ! Set default resampling
      convert = gtemp%gil%convert(:,1)
      !
      call sic_r8(line,o_xaxis,2,convert(1),.false.,error)
      if (error) return
      call sic_r8(line,o_xaxis,3,convert(2),.false.,error)
      if (error) return
      call sic_r8(line,o_xaxis,4,convert(3),.false.,error)
      if (error) return
      gtemp%gil%convert(:,1) = convert
      gtemp%gil%dim(1) = nc
    endif
    ! /Y_AXIS N Ref Val Inc
    if (sic_present(o_yaxis,0)) then
      call sic_i4(line,o_yaxis,1,nc,.true.,error)
      if (error) return
      ! Set default resampling
      convert = gtemp%gil%convert(:,2)
      !
      call sic_r8(line,o_yaxis,2,convert(1),.false.,error)
      if (error) return
      call sic_r8(line,o_yaxis,3,convert(2),.false.,error)
      if (error) return
      call sic_r8(line,o_yaxis,4,convert(3),.false.,error)
      if (error) return
      gtemp%gil%convert(:,2) = convert
      gtemp%gil%dim(2) = nc
    endif
    !
  endif
  !
  call gildas_null(gout)
  call gdf_copy_header(gin,gout,error)
  call s_reproject_init(gin,gtemp,gout,sys_code,error)
  if (error) return
  !
  call sic_ch(line,0,1,fich,n,.true.,error)
  if (error) return
  !
  ! Test matching positions to avoid useless resampling
  call position_check(rname,gin,gout,match)
  !
  ! Now handle the Output 
  out_image = .false.
  if (index(fich,'.').eq.0) then 
    out_image = .true.
    ! This must be an existing SIC Image variable
    rdonly = .false.
    call sub_readhead (rname,fich,gtemp,out_image,error,rdonly,fmt_r4)
    if (error) return
    do i=gtemp%gil%ndim+1,gout%gil%ndim
      gtemp%gil%dim(i) = 1
    enddo
    !
    !TEST!Print *,'OUT ',gout%gil%ndim,gout%gil%dim(1:4)
    !TEST!Print *,'Existing ',gtemp%gil%ndim,gtemp%gil%dim(1:4)
    !
    ! With a conforming shape with GOUT slot 
    do i=1,max(gtemp%gil%ndim,gout%gil%ndim) 
      if (gout%gil%dim(i).ne.gtemp%gil%dim(i)) then
        call map_message(seve%e,rname,'Output SIC variable does not match Template data shape')
        error = .true.
        return
      endif
    enddo
    !
    ! OK, the shapes are conforming
    call adtoad(gtemp%loca%addr,cptr,1)
    call c_f_pointer(cptr,gout%r3d,gtemp%gil%dim(1:3))
  else
    out_image = .false.
    ! This is  a file, we must create it
    call sic_parsef(fich,gout%file,' ','.gdf')
    call gdf_allocate(gout,error)
    if (error) return
  endif
  !
  ! Get the IN data pointer
  if (in_image) then
    call adtoad(gin%loca%addr,cptr,1)
    call c_f_pointer(cptr,gin%r3d,gin%gil%dim(1:3))
  else
    call gdf_allocate(gin,error)
    if (error) return
    call gdf_read_data(gin,gin%r3d,error)
    if (error) return
    call gdf_close_image(gin,error) ! not needed it anymore
  endif
  !
  if (match) then
    ! There are 3 cases of useless copy implied here, but it is
    ! much simpler than testing combinations of in_image / out_image
    gout%r3d = gin%r3d
  else
    call s_reproject_do(gin,gin%r3d,gout,gout%r3d,sys_code,error)
    if (error) return
  endif
  !
  if (.not.out_image) then
    call gdf_write_image(gout,gout%r3d,error)
  else  
    ! We need the descriptor as output in this case...
    call sic_descriptor(fich,desc,found)      
    call gdf_copy_header(gout,desc%head,error)
  endif
  !  
end subroutine map_reproject_comm
!
subroutine s_reproject_init(in,tem,out,sys_code,error)
  use image_def
  use gkernel_interfaces
  use gbl_message
  use imager_interfaces, only : map_message
  !---------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- Support for MAP_REPROJECT
  !
  !     Prepare Spatial resampling of a data cube as specified by 
  !       a Template.
  !     Prepare the Ouput header and Code
  !!
  !---------------------------------------------------------------------  
  type(gildas), intent(in) :: in        !! Input data cube
  type(gildas), intent(in) :: tem       !! Grid template
  type(gildas), intent(inout) :: out    !! Output data cube
  integer, intent(out) :: sys_code      !! Reprojection code
  logical, intent(out) :: error         !! Logical error code
  !
  character(len=*), parameter :: pname='REPROJECT'
  !
  ! Local ---
  integer :: o_xaxi,o_yaxi,t_xaxi,t_yaxi
  !
  ! Code ----
  sys_code = 0
  call sanity_check(pname,tem,error)
  if (error) return
  !
  ! Copy part of header of Template, but NOT the Resolution section !...
  out%char%syst = tem%char%syst
  out%gil%ra   = tem%gil%ra
  out%gil%dec  = tem%gil%dec
  out%gil%lii  = tem%gil%lii
  out%gil%bii  = tem%gil%bii
  out%gil%epoc = tem%gil%epoc
  out%gil%ptyp = tem%gil%ptyp
  out%gil%a0   = tem%gil%a0
  out%gil%d0   = tem%gil%d0
  out%gil%pang = tem%gil%pang
  ! Beware of the projection axis (default 1,2)
  o_xaxi = out%gil%xaxi
  if (o_xaxi.eq.0) o_xaxi = 1
  o_yaxi = out%gil%yaxi
  if (o_yaxi.eq.0) o_yaxi = 2
  t_xaxi = tem%gil%xaxi
  if (t_xaxi.eq.0) t_xaxi = 1
  t_yaxi = tem%gil%yaxi
  if (t_yaxi.eq.0) t_yaxi = 2
  out%char%code(o_xaxi) = tem%char%code(t_xaxi)
  out%char%code(o_yaxi) = tem%char%code(t_yaxi)
  out%gil%dim(o_xaxi) = tem%gil%dim(t_xaxi)
  out%gil%dim(o_yaxi) = tem%gil%dim(t_yaxi)
  out%loca%size = out%gil%dim(1)*out%gil%dim(2)*out%gil%dim(3)*out%gil%dim(4)
  out%gil%proj_words = tem%gil%proj_words
  out%gil%convert(:,o_xaxi) = tem%gil%convert(:,t_xaxi)
  out%gil%convert(:,o_yaxi) = tem%gil%convert(:,t_yaxi)
  !
  call get_sys_code(in,out,sys_code, error)
  if (error) return
  !
end subroutine s_reproject_init
!
subroutine s_reproject_do(in,din,out,dout,sys_code,error)
  use image_def
  use gkernel_interfaces
  use gbl_message
  use imager_interfaces, only : map_message
  !---------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- Support for MAP_REPROJECT
  !
  !     Spatial resampling of a data cube, according to Header and Code
  !     Use s_reproject_init to prepare the Output header
  !!
  !---------------------------------------------------------------------  
  type(gildas), intent(in) :: in      !! Input Header
  type(gildas), intent(inout) :: out  !! Output Header
  real, intent(in) :: din(in%gil%dim(1),in%gil%dim(2),in%gil%dim(3))  !! Input data
  real, intent(out) :: dout(out%gil%dim(1),out%gil%dim(2),out%gil%dim(3))  !! Output data
  integer, intent(in) :: sys_code     !! Reprojection code
  logical, intent(inout) :: error     !! Logical error flag
  !
  character(len=*), parameter :: rname='REPROJECT'
  !
  ! Local ---
  real :: in_blank(2)  ! Input blanking
  logical :: doblank
  !
  ! Code ----
  !
  ! Set blanking
  in_blank = [in%gil%bval,in%gil%eval] 
  out%gil%blan_words = 2
  if (in%gil%blan_words.eq.0) then
    in_blank = [0.,-1.]
  endif
  !
  ! Method of solution
  if (in_blank(2).lt.0.0) then
    call map_message(seve%i,rname, &
    & 'Using bilinear gridding method with no input blanking')
  else
    call map_message(seve%i,rname, &
    & 'Using bilinear gridding method with input blanking')
  endif
  !
  call gridlin(                                                     &
    din,in%gil%dim(1),in%gil%dim(2),in%gil%dim(3),                  &
    in%gil%convert,in%gil%ptyp,[in%gil%a0,in%gil%d0,in%gil%pang],in%gil%epoc,in_blank,      &
    dout,out%gil%dim(1),out%gil%dim(2),                             &
    out%gil%convert,out%gil%ptyp,[out%gil%a0,out%gil%d0,out%gil%pang],out%gil%epoc,out%gil%bval, &
    doblank,sys_code,error)
  if (doblank) out%gil%eval = 0.
  !
end subroutine s_reproject_do
!
subroutine sanity_check(rname,x,error)
  use image_def
  use gbl_message
  use imager_interfaces, only : map_message
  !-------------------------------------------------------------------
  ! @ private
  !*
  !  IMAGER -- Sanity check for input or template file usage in the
  !   MAP_REPROJECT command context
  !!
  !-------------------------------------------------------------------
  character(len=*), intent(in) :: rname  !! Caller name
  type(gildas), intent(in)    :: x       !! Data eader
  logical,      intent(inout) :: error   !! Logical error flag
  !
  if (x%gil%ptyp.eq.p_none) return
  !
  ! Check if the 2 first dimensions are spatial. We could support any
  ! order but this is not implemented (and would be unefficient)
  if (x%gil%xaxi*x%gil%yaxi.ne.2) then
    call map_message(seve%e,rname,'Spatial dimensions must be first and second dimensions')
    error = .true.
    return
  endif
  !
end subroutine sanity_check
!
subroutine position_check(rname,x,y,result)
  use image_def
  use gbl_message
  use imager_interfaces, only : map_message
  !-------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- Position check for input and template files usaage in
  ! the MAP_REPROJECT command context
  !!
  !-------------------------------------------------------------------
  character(len=*), intent(in) :: rname   !! Caller name
  type(gildas), intent(in)    :: x,y      !! Input and Template headers
  logical,      intent(inout) :: result   !! Logical error flag
  !
  ! Check whether the 2 first dimensions match, and the projection also
  result = .false.
  if (any(x%gil%dim(1:2).ne.y%gil%dim(1:2))) return
  if (any(x%gil%convert(:,1:2).ne.y%gil%convert(:,1:2))) return
  if (x%char%syst.ne.y%char%syst) return
  if (x%char%syst.eq.'EQUATORIAL') then
    if (x%gil%epoc.ne.y%gil%epoc) return
  endif
  if (x%gil%a0.ne.y%gil%a0) return
  if (x%gil%d0.ne.y%gil%d0) return
  if (x%gil%pang.ne.y%gil%pang) return
  if (x%gil%ptyp.ne.y%gil%ptyp) return
  result = .true.
  call map_message(seve%i,rname,'Input images match spatially')
end subroutine position_check
!
subroutine get_sys_code(in,out,sys_code,error)
  use gbl_format
  use image_def
  use gbl_message
  use imager_interfaces, only : map_message
  !---------------------------------------------------------------------
  !*
  ! GILDAS  Utility
  !
  ! Get old-system to new-system conversion code.
  ! Trap illegal/impossible conversions.
  !
  ! Caution: ICRS not yet supported here
  !---------------------------------------------------------------------
  type(gildas),    intent(in)  :: in          !! Input header
  type(gildas),    intent(in)  :: out         !! Desired output header
  integer(kind=4), intent(out) :: sys_code    !! Conversion code
  logical,         intent(out) :: error       !! Logical error flag
  !
  ! Constants
  character(len=*), parameter :: pname='REPROJECT'
  integer(kind=4), parameter :: conv_none   = 0
  integer(kind=4), parameter :: conv_equ2gal= 1
  integer(kind=4), parameter :: conv_gal2equ=-1
  integer(kind=4), parameter :: conv_equ2equ=-2
  !
  error = .false.
  select case (out%char%syst)
  case ('GALACTIC')
    if (in%char%syst.eq.'EQUATORIAL') then
      sys_code = conv_equ2gal
    elseif (in%char%syst.eq.'GALACTIC') then
      sys_code = conv_none
    else
      error = .true.
    endif
    !
  case ('EQUATORIAL')
    if (in%char%syst.eq.'EQUATORIAL') then
      if (in%gil%epoc.ne.out%gil%epoc) then
        ! Both Equatorial, not same equinox
        call map_message(seve%i,pname, &
          & 'Converting from equinox '//trim(equinox_name(in%gil%epoc))//  &
          &                     ' to '//trim(equinox_name(out%gil%epoc)))
        sys_code = conv_equ2equ
      else
        ! Both Equatorial, same equinox
        sys_code = conv_none
      endif
    elseif (in%char%syst.eq.'GALACTIC') then
      sys_code = conv_gal2equ
    else
      error = .true.
    endif
    !
  case ('UNKNOWN')
    if (in%char%syst.eq.'GALACTIC') then
      error = .true.
    elseif (in%char%syst.eq.'EQUATORIAL') then
      error = .true.
    else
      sys_code = conv_none
    endif
    !
  case default
    call map_message(seve%w,pname,'Unknown system '//out%char%syst//', no conversion applied')
    sys_code = conv_none
    !
  end select
  !
  if (error) then
    call map_message(seve%e,pname,'Cannot convert from '//in%char%syst//' to '//out%char%syst)
  endif
  return
  !
contains
  function equinox_name(equinox)
    !! Returns printable name of Equinox number
    real(kind=4), intent(in) :: equinox
    character(len=10) :: equinox_name
    if (equinox.eq.equinox_null) then
      equinox_name = 'Unknown'
    else
      write(equinox_name,'(F0.2)') equinox
    endif
  end function equinox_name
  !
end subroutine get_sys_code
!
subroutine gridlin(a,mx,my,mz,aconv,atype,aproj,aepoc,ablank,  &
                   b,nx,ny,   bconv,btype,bproj,bepoc,bblank,  &
                   doblank, code,error)
  use gildas_def
  use gkernel_interfaces, no_interface1=>abs_to_rel_1dn4,  &
                          no_interface2=>rel_to_abs_1dn4
  use gkernel_types
  !$ use omp_lib
  !---------------------------------------------------------------------
  ! @ private
  !
  !   IMAGER -- Regrid a map on a different grid and projection system.
  !
  !     Extracted from GREG Stand alone subroutine.
  !  Regrid an input map in a given projection to an output map in
  !  another projection, bilinear interpolation
  !!
  !---------------------------------------------------------------------
  integer(kind=index_length), intent(in) :: mx    !! X Size of A
  integer(kind=index_length), intent(in) :: my    !! Y Size of A
  integer(kind=index_length), intent(in) :: mz    !! 3rd dimension of A
  real(kind=4), intent(in)    :: a(mx,my,mz)      !! Input map of dimensions MX MY MZ
  real(kind=8), intent(in)    :: aconv(6)         !! Pixel conversion 
  !! formulae: CONV(1) = Xref, CONV(2)=Xval, CONV(3)=Xinc
  integer(kind=4), intent(in) :: atype            !! Type of projection
  real(kind=8), intent(in)    :: aproj(3)         !! Projection constants 
  !! PROJ(1)=A0, PROJ(2)=D0, PROJ(3)=Angle
  real(kind=4), intent(in)    :: aepoc            !! Epoch if Needed
  real(kind=4), intent(in)    :: ablank(2)        !! Blanking values
  integer(kind=index_length), intent(in) :: nx    !! X Size of B
  integer(kind=index_length), intent(in) :: ny    !! Y Size of B
  real(kind=4), intent(out)   :: b(nx,ny,mz)      !! Output map 
  real(kind=8), intent(in)    :: bconv(6)         !! Pixel conversion 
  !! formulae: CONV(1) = Xref, CONV(2)=Xval, CONV(3)=Xinc
  integer(kind=4), intent(in) :: btype            !! Type of projection
  real(kind=8), intent(in)    :: bproj(3)         !! Projection constants 
  real(kind=4), intent(in)    :: bepoc            !! Epoch if Needed
  real(kind=4), intent(in)    :: bblank           !! Blanking value
  integer(kind=4), intent(in) :: code             !! Sytem conversion code
  !! Galactic to Equatorial (-1) or Equatorial to Galactic (1) or 0 (none)
  logical, intent(out) :: doblank                 !! Was blanking applied ?
  logical, intent(out) :: error                   !! Logical error flag
  !
  ! Constants
  integer(kind=4), parameter :: conv_none   = 0
  integer(kind=4), parameter :: conv_equ2gal= 1
  integer(kind=4), parameter :: conv_gal2equ=-1
  integer(kind=4), parameter :: conv_equ2equ=-2
  !
  ! Local ---
  real(kind=4) :: bval,eval
  integer(kind=index_length) :: ia,ja,k
  integer(kind=4) :: ib,jb,ier
  real(kind=8) :: axref,axval,axinc, ayref,ayval,ayinc
  real(kind=8) :: bxref,bxval,bxinc, byref,byval,byinc
  real(kind=8) :: xa,ya
  real(kind=4) :: xr,yr
  ! Work arrays to handle the coordinates conversion
  real(kind=8), allocatable :: axb(:),ayb(:),bxb(:),byb(:)
  real(kind=8), allocatable :: xb(:,:), yb(:,:)
  type(projection_t) :: proj
  integer :: ithread,nthread
  integer :: nxy, nblank
  integer, allocatable :: blanked(:)
  !
  ! Code ----
  error = .false.
  !
  ! Preliminary processing
  bval=ablank(1)
  eval=ablank(2)
  nxy = nx*ny
  !
  ! I force the conversion formula for input to be adapted to the
  ! NINT function that will be used below. Now Xref=1.0
  axref = 1.0d0                ! was ACONV(1)
  axval = (1.0d0-aconv(1))*aconv(3)+aconv(2)
  axinc = aconv(3)
  ayref = 1.0d0                ! was ACONV(4)
  ayval = (1.0d0-aconv(4))*aconv(6)+aconv(5)
  ayinc = aconv(6)
  ! the output is unchanged.
  bxref = bconv(1)
  bxval = bconv(2)
  bxinc = bconv(3)
  byref = bconv(4)
  byval = bconv(5)
  byinc = bconv(6)
  !
  ! Setup Output projection
  error = .false.
  call gwcs_projec(bproj(1),bproj(2),bproj(3),btype,proj,error)
  if (error) return
  !
  if (code.ne.conv_none) then
    allocate(xb(nx,ny),yb(nx,ny),axb(nxy),ayb(nxy),bxb(nxy),byb(nxy),stat=ier)
  else
    allocate(xb(nx,ny),yb(nx,ny),axb(nxy),ayb(nxy),stat=ier)
  endif
  if (ier.ne.0) then
    error = .true.
    return
  endif    
  ! Convert Output projection to Absolute coordinates
  do jb=1,ny
    do ib=1,nx
      xb(ib,jb) = (ib-bxref)*bxinc + bxval
      yb(ib,jb) = (jb-byref)*byinc + byval
    enddo
  enddo
  !
  if (code.ne.conv_none) then
    call rel_to_abs_1dn4(proj,xb,yb,bxb,byb,nxy)
    !
    ! Change coordinate system. use new epoch also. Warning: codes are
    ! reversed since we start form output map!
    if (code.eq.1) then
      call gal_equ(bxb,byb,axb,ayb,aepoc,nxy,error)
    elseif (code.eq.-1) then
      call equ_gal(bxb,byb,bepoc,axb,ayb,nxy,error)
    elseif (code.eq.-2) then
      call equ_equ(bxb,byb,bepoc,axb,ayb,aepoc,nxy,error)
    endif
    if (error) return
  else
    call rel_to_abs_1dn4(proj,xb,yb,axb,ayb,nxy)
  endif
  !
  ! Setup Input projection
  call gwcs_projec(aproj(1),aproj(2),aproj(3),atype,proj,error)
  if (error) return
  !
  ! Convert Absolute coordinates to input projection
  call abs_to_rel_1dn4(proj,axb,ayb,xb,yb,nxy)
  !
  ! Interpolate
  !
  ! Take Blanking into account, version #1
  if (eval.lt.0.0) then
    nthread = 1
    !$ nthread = omp_get_max_threads()
    allocate(blanked(nthread))
    blanked = 0
    ! Loop over Output data points
    !$OMP PARALLEL DEFAULT(NONE) &
    !$OMP &  SHARED(xb,yb,b,a, mz,mx,my,nx,ny, blanked) &
    !$OMP &  SHARED(axinc, axval, axref, ayinc, ayval, ayref,bblank) &
    !$OMP &  PRIVATE(k,ib,jb,xa,ya,xr,yr,ia,ja, nthread, ithread)
    ithread = 1
    !$ ithread = omp_get_thread_num()+1
    !$OMP DO COLLAPSE (2)
    do k = 1,mz
      do jb = 1,ny
        do ib = 1,nx
          !
          ! Find pixel coordinate in input map
          xa = xb(ib,jb)
          ya = yb(ib,jb)
          xr = (xa-axval)/axinc+axref
          yr = (ya-ayval)/ayinc+ayref
          ia = int(xr)
          ja = int(yr)
          !
          ! Avoid edges
          if (ia.lt.1 .or. ia.gt.mx .or. ja.lt.1 .or. ja.gt.my) then
            b(ib,jb,k) = bblank
            blanked(ithread) = blanked(ithread)+1
          else
            if (ia.eq.mx) ia = ia-1
            if (ja.eq.my) ja = ja-1
            ! Interpolate
            xr = xr-dble(ia)
            yr = yr-dble(ja)
            b(ib,jb,k) = (1-xr)*(1-yr)*a(ia,ja,k)+   &
                         xr*(1-yr)*a(ia+1,ja,k)+   &
                         xr*yr*a(ia+1,ja+1,k)+   &
                         (1-xr)*yr*a(ia,ja+1,k)
          endif
        enddo
      enddo
    enddo
    !$OMP END DO
    !$OMP END PARALLEL
    nblank = sum(blanked)/mz
    doblank = nblank.ne.0
  else
    doblank = .true.
    ! Loop over Output data points
    !$OMP PARALLEL DEFAULT(NONE) &
    !$OMP &  SHARED(xb,yb,b,a, mz,mx,my,nx,ny) &
    !$OMP &  SHARED(axinc, axval, axref, ayinc, ayval, ayref, bblank, bval, eval) &
    !$OMP &  PRIVATE(k,ib,jb,xa,ya,xr,yr,ia,ja)
    !$OMP DO COLLAPSE (2)
    do k = 1,mz
      do jb = 1,ny
        do ib = 1,nx
          xa = xb(ib,jb)
          ya = yb(ib,jb)
          xr = (xa-axval)/axinc+axref
          yr = (ya-ayval)/ayinc+ayref
          ia = int(xr)
          ja = int(yr)
          if (ia.lt.1 .or. ia.gt.mx .or. ja.lt.1 .or. ja.gt.my) then
            b(ib,jb,k) = bblank
          else
            if (ia.eq.mx) ia = ia-1
            if (ja.eq.my) ja = ja-1
            if (abs(a(ia,ja,k)-bval).le.eval) then
              b(ib,jb,k) = bblank
            elseif (abs(a(ia+1,ja,k)-bval).le.eval) then
              b(ib,jb,k) = bblank
            elseif (abs(a(ia,ja+1,k)-bval).le.eval) then
              b(ib,jb,k) = bblank
            elseif (abs(a(ia+1,ja+1,k)-bval).le.eval) then
              b(ib,jb,k) = bblank
            else
              xr = xr-float(ia)
              yr = yr-float(ja)
              b(ib,jb,k) = (1-xr)*(1-yr)*a(ia,ja,k)+  &
                           xr*(1-yr)*a(ia+1,ja,k)+   &
                           xr*yr*a(ia+1,ja+1,k)+   &
                           (1-xr)*yr*a(ia,ja+1,k)
            endif
          endif
        enddo
      enddo
    enddo
    !$OMP END DO
    !$OMP END PARALLEL
  endif
  !
end subroutine gridlin

subroutine color_comm(line,error)
  use gkernel_interfaces
  use imager_interfaces, only : map_message
  use gbl_message
  !---------------------------------------------------------------------
  !*
  ! IMAGER -- Support for command  
  !   COLOR Span HueMin HueMax [/TYPE Noise|Percent]
  !
  !   calls "@ p_color.ima" to derive a lut
  !   with unsaturated colours up to Span around 0,
  !   and a Hue range between Min and Max 
  !!
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: line  !! Command line
  logical, intent(inout) :: error       !! Error flag
  !
  character(len=8), parameter :: chue  ='HUE     '
  character(len=8), parameter :: cnoise='NOISE   '
  character(len=8) :: key
  real :: colour
  logical :: do_insert
  integer :: n
  !
  if (sic_present(1,0)) then
    call sic_ke(line,1,1,key,n,.true.,error)
    if (error) return
    n = min(n,8)
    if (key(1:n).eq.chue(1:n)) then
      call sic_let_real('COLOR[4]',0.,error)
    else if (key(1:n).eq.cnoise(1:n)) then
      call sic_let_real('COLOR[4]',1.,error)
    else
      call map_message(seve%e,'COLOR','Invalid type '//key(1:n)//'. Choice is '//chue//cnoise)
      error = .true.
      return
    endif
  endif
  call sic_get_real('COLOR[3]',colour,error)
  call sic_r4(line,0,1,colour,.false.,error)
  call sic_let_real('COLOR[3]',colour,error)
  !
  call sic_get_real('COLOR[1]',colour,error)
  call sic_r4(line,0,2,colour,.false.,error)
  call sic_let_real('COLOR[1]',colour,error)
  !
  call sic_get_real('COLOR[2]',colour,error)
  call sic_r4(line,0,3,colour,.false.,error)
  call sic_let_real('COLOR[2]',colour,error)
  !
  do_insert = sic_lire().eq.0
  call exec_program('@ p_color')
  if (do_insert) call sic_insert_log(line)  
end subroutine color_comm

!*
! Tools to Sort UV data in V order
!!
subroutine check_order(visi,np,nv,sorted)
  !----------------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- Utility routine  
  !   Check if visibilites are sorted.
  !   Chksuv does a similar job, but using V values and an index.
  !!
  !----------------------------------------------------------
  integer, intent(in) :: np         !! Size of a visibility
  integer, intent(in) :: nv         !! Number of visibilities
  real, intent(in) :: visi(np,nv)   !! Visibilities
  logical, intent(out) :: sorted    !! Is data sorted ?
  !
  real vmax
  integer iv
  !
  vmax = visi(2,1)
  do iv=1,nv
    if (visi(2,iv).lt.vmax) then
      sorted = .false.
      return
    endif
    vmax = visi(2,iv)
  enddo
  sorted = .true.
end subroutine check_order
!
subroutine uv_sort (huvx,duvx,error,sorted,shift,newabs,uvmax,uvmin,needed)
  use gkernel_interfaces
  use imager_interfaces, except_this=>uv_sort
  use clean_def
  use clean_arrays
  use gbl_message
  !----------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER --  Sort the input UV table
  !!
  !----------------------------------------------------------------------
  type(gildas), intent(inout) :: huvx        !! UV Header
  real, intent(inout) :: duvx(:,:)           !! Data to be sorted
  logical, intent(out) :: error              !! Logical error flag
  logical, intent(inout) :: sorted           !! Is table sorted ?
  logical, intent(inout) :: shift            !! Do we shift phase center ?
  logical, intent(in) :: needed              !! Is sorting mandatory ?
  real(kind=8), intent(inout) :: newabs(3)   !! New phase center and PA
  real, intent(out) :: uvmin                 !! Min baseline
  real, intent(out) :: uvmax                 !! Max baseline
  !
  ! Constants
  real(8), parameter :: pi=3.14159265358979323846d0
  real(8), parameter :: f_to_k = 2.d0*pi/299792458.d-6
  character(len=*), parameter :: rname='UV_SORT'
  !
  ! Local ---
  real, allocatable :: duv_tmp(:,:)
  real(kind=8) :: freq, off(3)
  real(kind=4) :: pos(2), cs(2)
  integer :: nu,nv,ier
  !
  ! Code ----
  call imager_tree('UV_SORT',.false.)
  !
  ! The UV table is available in HUVT%
  if (huvx%loca%size.eq.0) then
    call map_message(seve%e,rname,'No UV data loaded')
    error = .true.
    return
  endif
  nu = huvx%gil%dim(1)
  nv = huvx%gil%nvisi
  !
  ! Correct for new phase center if required
  if (shift) then
    if (huvx%gil%ptyp.eq.p_none) then
      call map_message(seve%w,rname,'No previous phase center info')
      huvx%gil%a0 = huvx%gil%ra
      huvx%gil%d0 = huvx%gil%dec
      huvx%gil%pang = 0.d0
      huvx%gil%ptyp = p_azimuthal
    elseif (huvx%gil%ptyp.ne.p_azimuthal) then
      call map_message(seve%w,rname,'Previous projection type not SIN')
      huvx%gil%ptyp = p_azimuthal
    endif
    call uv_shift_header (newabs,huvx%gil%a0,huvx%gil%d0,huvx%gil%pang,   &
        &      off,shift)
    huvx%gil%posi_words = def_posi_words
    huvx%gil%proj_words = def_proj_words
  endif
  if (shift) then
    sorted = .false.
  else
    sorted = .true.
    if (needed) then 
      call check_order (duvx,nu,nv,sorted)
    else
      call map_message(seve%i,rname,'Sorting UV table is not needed...')
    endif
  endif
  !
  ! Get center frequency
  freq = gdf_uv_frequency(huvx,huvx%gil%ref(1))
  !
  ! If already sorted, use it
  if (sorted) then
    if (needed) call map_message(seve%i,rname,'UV table is already sorted')
    !
    ! Compute UVMAX
    call uvgmax (huvx,duvx,uvmax,uvmin)
    !
    ! Else, create another copy
  else
    call map_message(seve%i,rname,'Sorting UV table...',seve%w)
    !
    ! Compute observing frequency, and new phase center in wavelengths
    if (shift) then
      huvx%gil%a0 = newabs(1)
      huvx%gil%d0 = newabs(2)
      huvx%gil%pang = newabs(3)
      cs(1)  =  cos(off(3))
      cs(2)  = -sin(off(3))
      ! Note that the new phase center is counter-rotated because rotations
      ! are applied before phase shift.
      pos(1) = - freq * f_to_k * ( off(1)*cs(1) - off(2)*cs(2) )
      pos(2) = - freq * f_to_k * ( off(2)*cs(1) + off(1)*cs(2) )
    else
      pos(1) = 0.0
      pos(2) = 0.0
      cs(1) = 1.0
      cs(2) = 0.0
    endif
    !
    ! OK, rotate, shift, copy and sort ...
    call map_message(seve%d,rname,'Sorting DUVT ')
    allocate(duv_tmp(nu,nv),stat=ier)
    duv_tmp(:,:) = duvx(:,:)    ! Copy
    call uvsort_uv (nu,nv,huvx%gil%ntrail,duv_tmp,duvx,   &
         &        pos,cs,uvmax,uvmin,error) ! Sort
    deallocate(duv_tmp)
    huvx%gil%basemax = uvmax
    huvx%gil%basemin = uvmin
  endif
  !
  ! Now transform UVMAX in kiloWavelength (including 2 pi factor)
  uvmax = uvmax*freq*f_to_k
  uvmin = uvmin*freq*f_to_k
  error = .false.
  call imager_tree('UV_SORT',.true.)
end subroutine uv_sort

subroutine compress(nx,ny,large,wl,mx,my,small,ws,wfft)
  use gkernel_interfaces, only : fourt
  !----------------------------------------------------------------------
  !	@ public
  ! 
  ! IMAGER -- Utility routine
  !
  !   Compress an image through TF truncation
  !!
  !----------------------------------------------------------------------
  integer, intent(in) :: nx,ny         !! Large image size
  integer, intent(in) :: mx,my         !! Small image size
  real, intent(in) :: large(nx,ny)     !! Large image
  complex, intent(inout) :: wl(nx,ny)  !! Workspace for large FT
  real, intent(out) :: small(mx,my)    !! Small image
  complex, intent(inout) :: ws(mx,my)  !! Workspace for small FT
  real, intent(inout) :: wfft(*)       !! FFT workspace
  !
  ! Local ---
  integer :: j,ndim,dim(2)
  real :: fact
  !
  wl(:,:) = cmplx(large,0.0)
  !
  ndim = 2
  dim(1) = nx
  dim(2) = ny
  call fourt(wl,dim,ndim,-1,0,wfft)
  !
  ! Keep inner quarter
  do j=1,my/2
    ws(1:mx/2,j) = wl(1:mx/2,j)   
    ws(mx/2+1:mx,j) = wl(nx-mx/2+1:nx,j) 
  enddo
  do j=my/2+1,my
    ws(1:mx/2,j) = wl(1:mx/2,j+ny-my) 
    ws(mx/2+1:mx,j) = wl(nx-mx/2+1:nx,j+ny-my) 
  enddo
  dim(1) = mx
  dim(2) = my
  call fourt (ws,dim,ndim,1,1,wfft)
  fact = 1.0/(nx*ny)
  small(:,:) = fact*real(ws)
end subroutine compress
!
subroutine expand (nx,ny,large,wl,mx,my,small,ws,wfft)
  use gkernel_interfaces, only : fourt
  !----------------------------------------------------------------------
  ! @ public
  !*
  !   IMAGER -- Utility routine
  !
  !	  Expand an image through TF zero extension
  !!
  !----------------------------------------------------------------------
  integer, intent(in) :: nx,ny        !! Large image size
  integer, intent(in) :: mx,my        !! Small image size
  real, intent(out) :: large(nx,ny)   !! Large image
  complex, intent(inout) :: wl(nx,ny) !! Workspace for large FT
  real, intent(in) :: small(mx,my)    !! Small image
  complex, intent(inout) :: ws(mx,my) !! Workspace for small FT
  real, intent(inout) :: wfft(*)      !! FFT workspace
  !
  ! Local ---
  integer :: j,ndim,dim(2)
  real :: fact
  !
  ! Code ----
  ws = cmplx(small,0.0)
  !
  ndim = 2
  dim(1) = mx
  dim(2) = my
  call fourt(ws,dim,ndim,-1,0,wfft)
  !
  ! Clear output FT
  wl = 0.0
  ! Load inner quarter
  do j=1,my/2
    wl(1:mx/2,j) = ws(1:mx/2,j) 
    wl(nx-mx/2+1:nx,j) = ws(mx/2+1:mx,j) 
  enddo
  do j=my/2+1,my
    wl(1:mx/2,j+ny-my) = ws(1:mx/2,j)          
    wl(nx-mx/2+1:nx,j+ny-my) = ws(mx/2+1:mx,j) 
  enddo
  dim(1) = nx
  dim(2) = ny
  call fourt (wl,dim,ndim,1,1,wfft)
  fact = 1.0/(mx*my)
  large(:,:) = fact*real(wl)
end subroutine expand

subroutine sub_uv_residual(comm,line,iarg,huv_call,duv_a,duv_b, &
  & do_clean,do_resi,subtract,error)
  use gkernel_interfaces
  use imager_interfaces, except_this=>sub_uv_residual
  use clean_def
  use clean_arrays
  use clean_types
  use clean_default
  use clean_beams
  use gbl_message
  use utils
  !$ use omp_lib
  !------------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER --  Support for routine UV_RESIDUAL & MODEL
  !
  !   Remove all Clean Components from a UV Table  
  !   [CLEAN\]UV_RESIDUAL CLEAN [Niter] [/FIELDS List]   
  !   -- or --
  !   [CALIBRATE\]MODEL [Niter] [/MINVAL Value]
  ! 
  ! Input :  
  !     a precessed UV table  
  !     a list of Clean Components, in DCCT format
  !      i.e. (x,y,v)(iplane,icomponent)  
  !     this organisation is not efficient, and one may need to switch to
  !           (x,y,v,)(icomponent,iplane)
  !     which is more easily transmitted
  ! Output :  
  !     a precessed, rotated, shifted UV table, sorted in V,
  !     ordered in (U,V,W,D,T,iant,jant,nchan(real,imag,weig))
  !!
  !------------------------------------------------------------------------
  character(len=*), intent(in) :: comm              !! Calling Command
  character(len=*), intent(inout) :: line           !! Command line
  integer, intent(in) :: iarg                       !! First useful argument
  type(gildas), intent(inout) :: huv_call           !! UV data to be changed
  real, intent(in) , target :: duv_a(:,:)           !! Input buffer
  real, intent(inout), target :: duv_b(:,:)         !! May not be defined here
  logical, intent(in) :: do_clean                   !! Re-image ?
  logical, intent(in) :: do_resi                    !! Evaluate UV residual ?
  logical, intent(in) :: subtract                   !! Subtract model ?
  logical, intent(out) :: error                     !! Error flag
  !
  ! Constants
  real(8), parameter :: pi=3.14159265358979323846d0
  real(8), parameter :: sec_to_rad=pi/3600.d0/180d0
  real(8), parameter :: f_to_k = 2.d0*pi/299792458.d-6
  integer, parameter :: o_field=1
  integer, parameter :: o_minval=1
  ! Minimum number of Visibilities to activate the FFT mode
  integer, parameter :: fft_mode=20000 
  !
  ! Local ---
  character(len=24) :: task
  real(8) :: freq
  character(len=message_length) :: chain
  real :: cpu0, cpu1
  integer :: ier,nu,nv,mv,nchan
  !
  real, pointer :: duv_in(:,:), duv_out(:,:)
  real, allocatable, target :: ccou(:,:,:)
  real, allocatable, target :: fcou(:,:,:)
  real, pointer :: fctmp(:,:,:)
  real, allocatable :: duv_tmp(:,:)
  real, allocatable :: dmap(:,:,:)          ! Storage for GAUSS method in Mosaics.
  integer, allocatable :: omic(:), nmic(:)
  integer :: ci_nchan, ci_ic, ci_lc         ! Input CCT channel range
  integer :: co_nchan, co_ic, co_lc         ! Compressed CCT channel_range
  integer :: map_nchan, map_ic, map_lc      ! Output UV Chnnell range
  integer :: oic, olc, iic, ilc, mic, maxic, icmax, iv
  integer :: nthread, ithread, np
  logical :: fft, debug
  real(8) :: elapsed_s, elapsed_e, elapsed
  !
  ! For mosaics
  logical :: do_mosaic
  type(clean_par) :: my_method
  type(projection_t) :: proj
  real(8) :: pos(2)
  real(4) :: bsize(10), beamsize, save_major
  integer :: ifield, jfield, nfields! Field number & Number of fields
  real, allocatable :: doff(:,:)    ! Field offsets
  real, allocatable :: rprim(:,:)   ! Current primaru beam
  integer, allocatable :: ivoff(:)  ! Input Visibility pointers
  integer, allocatable :: jvoff(:)  ! Output Visibility pointers
  integer :: ivstart, ivend, kvstart, kvend, ibeam
  logical :: sorted, shift
  real(8) :: new(3)
  real(4) :: uvmin, uvmax
  logical :: omp_nested
  integer :: outer_threads, inner_threads, jc, kc, mc
  !
  integer :: wcol, cctsize
  integer :: chunk, mx, my
  integer :: itrail
  real :: bstep ! Words per image pixel
  logical :: compact ! Test logical for code development
  integer, allocatable :: teles(:)
  !
  character(len=*), parameter :: prefix='SUB_UV_RESIDUAL -- '
  integer :: othread
  logical :: per_field
  !
  ! Code ---
  !
  ! Change Message header 
  if (comm.eq.'MOSAIC_RESTORE') then
    task = 'MOSAIC_RESIDUAL'
  else
    task = comm
  endif
  call print_buffer_asso('UV Call at SUB_UV_RESIDUAL start',huv_call)
  !
  call imager_tree('SUB_UV_RESIDUAL',.false.)
  debug = .false.
  call sic_get_logi('DEBUG_RESIDUAL',debug,error)
  error = .false.
  !
  ! Subtract all Clean Components
  if (.not.associated(duv)) then
    call map_message(seve%e,task,'DUV is NOT allocated')
    error = .true.
    return
  endif
  if (.not.allocated(dcct)) then
    call map_message(seve%e,task,'DCCT is NOT allocated')
    error = .true.
    return
  endif
  !
  if (allocated(doff)) then
    Print *,'DOFF is still allocated '
    deallocate(doff)
  endif
  if (allocated(ivoff)) then
    Print *,'IVOFF is still allocated '
    deallocate(ivoff)
  endif
  !
  ! Basic initializations
  nu = huv_call%gil%dim(1)
  nv = huv_call%gil%nvisi    ! not %dim(2)
  nchan = huv_call%gil%nchan ! Default value 
  map_nchan = huv_call%gil%nchan ! Default value 
  !
  ! That only works for UV_RESTORE, not for UV_RESIDUAL
  do_mosaic = abs(themap%nfields).gt.1
  if (do_mosaic) then
    ! Saved_chan%bounds may be incorrect in /CONTINUUM mode...`
    ! Unclear for Single fields so far
    saved_chan%bounds = [1,nchan]
    if (debug) then
      Print *,'Enter channel range ',saved_chan%bounds
      read(*,*) saved_chan%bounds
    endif
  endif
  call get_cols(map_nchan,saved_chan%bounds,map_ic,map_lc,wcol)
  if (debug) then
    Print *,'Saved_chan%bound ' ,saved_chan%bounds   !SG
    Print *,'Done GET_COLS Map '//str(map_ic)//'-'//str(map_lc)//' NCHAN '//str(map_nchan)
  endif 
  call print_buffer_asso('UV Call after GET_COLS',huv_call)
  !
  ithread = 1
  nthread = 1
  elapsed_e = 0.
  elapsed_s = 0.
  elapsed = 0.
  error = .false.
  !
  ! Verify number of channels match
  if (hcct%gil%dim(2).ne.huv_call%gil%nchan) then
    if (hcct%gil%dim(2).eq.1) then
      call map_message(seve%w,task,'Subtracting a Continuum CCT from a Line data set')
      if (debug) Print *,'Channel range ',saved_chan%bounds
      ci_nchan = 1
      ci_ic = 1
      ci_lc = 1
    else
      write(chain,'(A,I0,A,I0,A)') 'Number of channels in CCT [', &
      & hcct%gil%dim(2),'] and in UV [',huv_call%gil%nchan,'] do not match'
      if (debug) Print *,'SAVED_MCOL ',saved_chan%bounds 
      call map_message(seve%w,task,chain)
      !
      ci_nchan = map_nchan
      ci_ic = 1
      ci_lc = map_nchan
    endif
  else
    ci_nchan = map_lc-map_ic+1
    ci_ic = 1
    ci_lc = ci_nchan 
  endif  
  co_nchan = ci_nchan
  co_ic = 1
  co_lc = co_nchan
  if (debug) then
    Print *,prefix,'CI ',ci_ic,ci_lc,ci_nchan
    Print *,prefix,'CO ',co_ic,co_lc,co_nchan
    Print *,prefix,'Map ',map_ic,map_lc,map_nchan
  endif
  !
  maxic = hcct%gil%dim(3)
  if (iarg.gt.0) then
    call sic_i4(line,0,iarg,maxic,.false.,error)
    if (error) return
    if (maxic.lt.0) maxic = hcct%gil%dim(3)
    maxic = min(hcct%gil%dim(3),maxic)
    if (maxic.eq.0) return ! Nothing to do then...
  endif
  !
  allocate (omic(co_nchan),nmic(co_nchan),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,task,'Memory allocation error')
    error = .true.
    return
  endif
  !
  ! Compact the Clean components first
  hcct%r3d => dcct
  if (debug) then
    Print *,prefix,'DCCT size ',size(dcct,1),size(dcct,2),size(dcct,3)
    Print *,prefix,'CO_NCHAN ',co_nchan,' IC LC ',co_ic,co_lc
    Print *,prefix,'CI_NCHAN ',ci_nchan,' IC LC ',ci_ic,ci_lc
  endif
  call uv_clean_sizes(hcct,hcct%r3d,omic,ci_ic,ci_lc)
  icmax = maxval(omic)
  if (debug) Print *,prefix,'Max number of clean components ',icmax
  !
  ! Nothing to do if no Clean component
  if (icmax.eq.0) then
    call map_message(seve%w,task,'No valid Clean Component')
    return
  endif  
  !
  call gag_cpu(cpu0)
  do_mosaic = (themap%nfields.ne.0).and.(abs(themap%nfields).ne.1)
  !
  bsize = 0.
  if (do_mosaic) then
    !
    ! Get primary beam size
    call get_bsize(huv_call,task,' ',bsize,error)
    call print_buffer_asso('UV Call after GET_BSIZE',huv_call)
    if (debug) Print *,prefix,'Primary beam size ',bsize/sec_to_rad,' " '
    !
  endif
  !
  if (do_resi) then
    if (do_mosaic) then
      !
      ! True Mosaic case
      nfields = abs(themap%nfields)
      allocate(doff(2,nfields),ivoff(nfields+1),jvoff(nfields+1), &
      & teles(nfields),stat=ier)
      if (ier.ne.0) then
        call map_message(seve%e,task,'Memory allocation error')
        error = .true.
        return
      endif
      shift = .false.
      sorted = .false.
      error = .false.
      if (debug) Print *,'Sorting Mosaic ',themap%nfields, &
        & huv_call%gil%column_pointer(code_uvt_xoff), &
        & huv_call%gil%column_pointer(code_uvt_yoff), &
        & nfields
      !
      new = 0.D0 ! No change of Phase center
      !
!SG! NON !...      huv_call%r2d => duv
    call print_buffer_asso('UV Call before MOSAIC_SORT',huv_call)
      call mosaic_sort (huv_call,error,sorted,shift,new,uvmax,uvmin, &
        & huv_call%gil%column_pointer(code_uvt_xoff), &
        & huv_call%gil%column_pointer(code_uvt_yoff), &
        & huv_call%gil%column_pointer(code_uvt_id), &
        & nfields,doff,ivoff)
    call print_buffer_asso('UV Call after MOSAIC_SORT',huv_call)
      if (error) return
      teles(1:nfields) = huv_call%mos%fields(:)%jteles
      if (debug) Print *,'Nfields ',nfields
      !
      ! Shift offset coordinates to Phase center 
      call gwcs_projec(huv_call%gil%a0,huv_call%gil%d0,huv_call%gil%pang,huv_call%gil%ptyp,proj,error)
      if (debug) Print *,'Posangle ',huv_call%gil%pang
      ! POS is here the Offset of the Pointing center relative to the Phase center
      call abs_to_rel (proj,huv_call%gil%ra,huv_call%gil%dec,pos(1),pos(2),1)
      if (debug) Print *,'POS ',pos
      do ifield=1,nfields
        doff(:,ifield) = doff(:,ifield)+pos
        if (debug) Print *,doff(1,ifield)/sec_to_rad, doff(2,ifield)/sec_to_rad
      enddo
      !
      ! For tests per field - not useable in production
      if (task.eq.'UV_RESIDUAL'.and.sic_present(o_field,0)) then
        call select_fields(task,line,o_field,nfields,np,selected_fields,error)
        if (error) return
        selected_fieldsize = np
      endif
      !
      if (selected_fieldsize.ne.0) then
        if (.not.allocated(selected_fields)) then
          call map_message(seve%f,task, &
            & 'Programming error, Selected_Fields not allocated')
          error = .true.
          return
        endif
        if (debug) Print *,'Selected Fields ',selected_fields(1:selected_fieldsize) !!
        nv = 1
        mv = 0
        do jfield=1,selected_fieldsize
          ifield = selected_fields(jfield)
          jvoff(jfield) = nv
          mv = max(ivoff(ifield+1)-ivoff(ifield),mv)
          nv = nv + ivoff(ifield+1)-ivoff(ifield)
          jvoff(jfield+1) = nv
        enddo
        nv = nv-1
        nfields = selected_fieldsize
      else
        jvoff(:) = ivoff
        mv = 0
        do ifield=1,nfields
          mv = max(ivoff(ifield+1)-ivoff(ifield),mv)
        enddo
      endif
    else
      nfields = 1
      mv = nv
      allocate(doff(2,1),ivoff(2),jvoff(2),stat=ier)
      if (ier.ne.0) then
        call map_message(seve%e,task,'Memory allocation error')
        error = .true.
        return
      endif
      doff = 0.0
      bsize = 0.
      ivoff(1) = 1
      ivoff(2) = nv+1
      jvoff(:) = ivoff
      !
      if (debug) Print *,prefix,'Single Field case'
    endif 
    !
    ! Select the FFT or DIRECT mode by default, according to the
    ! problem size. This may need to be tested in more details
    if (mv.lt.fft_mode) then
      fft = .false.
    else
      fft = .true.
      !
      ! Define the Chunk size
    endif
    if (debug) Print *,'Default FFT ',fft, mv
    call sic_get_logi('FAST',fft,error)
    if (debug) Print *,'User set FFT ',fft, error
    error = .false.
  endif ! DO_RESI
  beamsize = maxval(bsize)
  !
  ! Redo that by block - At this stage NFIELDS is the actual number of selected fields.
  !
  ! Spatially compress the Clean Component List
  cctsize = hcct%gil%dim(1)
  if ((cctsize.eq.4).and.(nfields.gt.1)) fft = .true.    ! For mosaics only
  !
  allocate(ccou(cctsize,icmax,co_nchan),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,task,'CCOU Memory allocation error')
    error = .true.
    return
  endif
  if (debug) Print *,prefix,'uv_squeeze_clean ',co_nchan,omic,co_ic,co_lc
  call uv_squeeze_clean(co_nchan,hcct%r3d, ccou, omic,co_ic, co_lc)
  if (debug) then
    Print *,prefix,'CCOU size ',cctsize,icmax,co_nchan
    Print *,prefix,'DCCT size ',hcct%gil%dim(1:3)
  endif
  ! 
  ! Remember the Full Clean Component List size
  nmic(:) = omic
  !
  if ((cctsize.eq.3).or.(beamsize.eq.0)) then
    maxic = maxval(omic)
    write(chain,'(A,I0,A,I0,A)') 'Compressing CCT from ',icmax,' to ',maxic,' components'
    call map_message(seve%i,task,chain)
    allocate(fcou(cctsize,maxic,co_nchan),stat=ier)
    if (ier.ne.0) then
      call map_message(seve%e,task,'CCT Memory allocation error')
      error = .true.
      return
    endif
  endif
  freq = gdf_uv_frequency(huv_call,0.5d0*(map_ic+map_lc))
  !
  itrail = -huv_call%gil%lcol + huv_call%gil%dim(1) 
  !
  if (debug) Print *,prefix,'LCOL ',huv_call%gil%lcol,' and DIM ',huv_call%gil%dim(1)
  !
  ! Simple sequential stuff - parallelism is inside the
  !   uv_remove_...  subroutines to avoid memory issues
  ! Unfortunately, this parallelism is only efficient if
  ! the number of visibilities is sufficient.
  !
  ! So a mode with per-field parallelism would be good.
  ! But one has to be careful about IC and LC
  !
  if (do_resi) then
    bstep = 0.05               ! Small memory imprint
    mc = huv_call%gil%nchan
    if (fft) then
      bstep = 2.0     ! 1 complex word
      if (hcct%gil%dim(2).eq.1) bstep = 0.05+2.0/mc ! 1 fft for All
    endif
    mx = (hcct%gil%convert(1,1)-1)*2   ! Reference pixel is at Mx/2+1
    my = (hcct%gil%convert(1,3)-1)*2
    ! Would be better based on Frequency accuracy
    call uv_get_block(fft,mx,my,mc,1,bstep,chunk)
    !
    if ((cctsize.eq.4).and.(nfields.gt.1)) then
      allocate(dmap(mx,my,nchan),stat=ier) !! Which NCHAN ?... co_nchan Probably
      if (ier.ne.0) then
        call map_message(seve%e,task,'DMAP Memory allocation error')
        error = .true.
        return
      endif
    endif
    !
    !
    if ((cctsize.eq.3).or.(beamsize.eq.0)) then
      save_major = the_method%major
      continue
    else
      ! Set the beam size to Zero for this
      save_major = the_method%major
      the_method%major = 0.
      !
      ! FCOU is assigned to CCOU by pointer association here.
      !
      compact = .true.
      call sic_get_logi('RESTORE_COMPACT',compact,error)
      error = .false.
      if (debug) Print *,'User set RESTORE_COMPACT ',compact, error     
    endif
    !
    ! Test -- for parallelism
    per_field = .false.  ! Make sure it is initialized
    !
    othread = 1  
    !$ othread = omp_get_max_threads()
    if (othread.gt.map_nchan) then
      omp_nested = .false.
      nthread = othread
      !$ call ompset_thread_nesting(task, nthread, othread, omp_nested)    
      !$ nthread = ompget_outer_threads()
      per_field = .true.    
      write(chain,'(A,I0,A,I0,A)') 'Using per-field parallel mode. - Threads ',nthread,' Fields ',nfields
    else
      omp_nested = .true.
      !$ inner_threads = omp_get_max_threads()
      !$ outer_threads = 1 ! Should be nfields if Outer parallel mode is activated
      !$ call ompset_thread_nesting(task, outer_threads, inner_threads, omp_nested)
      write(chain,'(A,I0,A,I0,A)') 'Using squential fields - Threads ',nthread,' Fields ',nfields
    endif
    call map_message(seve%i,task,chain,seve%w)
    !
    !
    !$OMP PARALLEL DEFAULT(none) if (per_field) NUM_THREADS (nthread) &
    !$OMP   & SHARED(np,task,themap,huv_call,dprim,dbeam) & 
    !$OMP   & SHARED(hdirty,hbeam,hclean,hprim,hcct,the_method) &
    !$OMP   & SHARED(nfields,error,selected_fieldsize,selected_fields) &
    !$OMP   & SHARED(ivoff,jvoff,fft, doff, duv_a,duv_b, chunk) &
    !$OMP   & SHARED(save_major, beamsize, compact, debug) &
    !$OMP   & SHARED(nmic, cctsize, comm, ccou, itrail) &
    !$OMP   & SHARED(map_lc,map_ic,subtract,co_ic,co_lc,co_nchan,ci_ic,ci_lc) &
    !$OMP   & SHARED(freq, teles, bsize) &
    !$OMP   & PRIVATE(ifield,jfield,ivstart,ivend,kvstart,kvend,nv,iv) &
    !$OMP   & PRIVATE(chain,ibeam,kc,jc,omic, fcou) &
    !$OMP   & PRIVATE(duv_in, duv_tmp, dmap, rprim, fctmp, duv_out) &
    !$OMP   & PRIVATE(ilc, iic, olc, oic, mic, ier) 
    !
    !$OMP DO
    do jfield=1,nfields
      !
      if (sic_ctrlc()) then
        call map_message(seve%w,task,'Aborted by user ^C')
        error = .true.
        cycle
      endif
      !
      ifield = jfield
      if (selected_fieldsize.ne.0) ifield = selected_fields(jfield)
      if (debug) Print *,prefix,'Field ',ifield,jfield
      !
      ! This looks tricky, but is working.
      ! It used to extract an arbitrary subset from all fields
      ! In input Ifield
      ivstart = ivoff(ifield)      ! Starting Visibility of field
      ivend   = ivoff(ifield+1)-1  ! Ending Visibility of field
      ! In output Jfield
      kvstart = jvoff(jfield)      ! Starting Visibility of field
      kvend   = jvoff(jfield+1)-1  ! Ending Visibility of field
      if (nfields.gt.0) then
        write(chain,'(A,I0,4(1X,I0),2F10.2)') 'Processing field # ',ifield, &
          & ivstart,ivend, kvstart, kvend, doff(1,ifield)/sec_to_rad, doff(2,ifield)/sec_to_rad
        call map_message(seve%i,task,chain)
      endif
      !
      nv = ivend-ivstart+1
      if (ivend.gt.ubound(duv_a,2)) then
        Print *,prefix,'Programming error IVEND',kvend,' > Input Bound ',ubound(duv_a,2)
      endif
      ! 
      duv_in => duv_a(:,ivstart:ivend)    !! DUV_A should be used, DUV associated outside if needed
      if (kvend.gt.ubound(duv_b,2)) then   
        Print *,prefix,'Programming error KVEND ',kvend,' > Output Bound ',ubound(duv_b,2)
      endif
      duv_out => duv_b(:,kvstart:kvend)    ! We put in DUV_B
      !
      if (fft) then
        if (allocated(duv_tmp)) then
          call map_message(seve%e,task,'Programming error, DUV_TMP already allocated')
          deallocate(duv_tmp)
        endif
        allocate(duv_tmp(7+3*chunk+itrail,kvend-kvstart+1),stat=ier)
        if (ier.ne.0) then
          call map_message(seve%e,comm,'FFT memory allocation error')
          error = .true.
          cycle
        endif
      endif
      !
      if ((cctsize.eq.3).or.(beamsize.eq.0)) then
        if (beamsize.ne.0) then
          ! Mosaic only
          if (debug) Print *,'prefix','Calling attenuate_clean'
          omic(:) = nmic(:)   ! Restart from un-attenuate Clean Component List size
          call attenuate_clean(co_nchan,ccou,doff(:,ifield), & 
          & bsize(teles(ifield)),fcou,omic)
        endif
        !
        if (.not.fft) then
          if (debug) then
            Print *,prefix,'SLOW case IC ',co_ic,' LC ',co_lc,' OMIC '!! ,omic
            Print *,prefix,'Channels ',map_ic,map_lc, ' IFIELD ',ifield,' SUBTRACT ',subtract
          endif
          call uv_removes_clean(nv,duv_in,duv_out,co_nchan,omic, &
            & fcou,freq, map_ic, map_lc, subtract)
        else
          if (debug) then
            Print *,prefix,'FAST case IC ',co_ic,' LC ',co_lc,' OMIC ',omic, &
            'Channels ',map_ic,map_lc, ' IFIELD ',ifield,' SUBTRACT ',subtract
          endif
          !
          ! By channel chunks
          mic = size(omic)
          do oic=map_ic,map_lc,chunk
            olc = min(map_lc,oic+chunk-1)
            duv_tmp = 0.
            !
            ! Offset in OMIC but Also in FCOU
            if (mic.eq.1) then
              call uv_removef_clean(hcct,duv_in,duv_tmp,olc-oic+1,omic(1:1), &
                & fcou,freq, oic, olc, subtract)
            else
              iic = oic-map_ic+ci_ic ! Or co ???
              ilc = olc-map_ic+ci_ic ! Or co ???
              fctmp => fcou(:,:,oic-co_ic+1:olc-co_ic+1)  ! Ensure size is correct
              call uv_removef_clean(hcct,duv_in,duv_tmp,olc-oic+1,omic(iic:ilc), &
                & fctmp,freq, oic, olc, subtract)
            endif
            !
            do iv=1,nv
              duv_out(5+3*oic:7+3*olc,iv) = duv_tmp(8:7+3*(olc-oic+1),iv)
            enddo
          enddo
        endif
      else    ! GCLEAN on Mosaic
        ! Compute the Clean Component Map, but unsmoothed by the Clean beam
        !
        omic(:) = nmic(:)   ! Restart from un-attenuate Clean Component List size
        if (.not.compact) then
          if (ifield.eq.1) then
            call map_message(seve%i,task,'Using REMOVEG for GCLEAN on Mosaic')
            allocate(rprim(hprim%gil%dim(2),hprim%gil%dim(3)),stat=ier)
            if (ier.ne.0) then
              call map_message(seve%e,task,'RPRIM Memory allocation error')
              error = .true.
              cycle 
            endif
          endif
          !
          ! Do by Fields, using FFT by channel chunks
          do oic=map_ic,map_lc,chunk
            olc = min(map_lc,oic+chunk-1)
            duv_tmp = 0.
            !
            !SG - Not ready for Continuum residual in Line 
            !SG  FFT could use only 1 plane
            ! Offset in OMIC but also in FCOU
            fctmp => ccou(:,:,oic-map_ic+1:)
            ! Loop over channels to compute the Clean Component Cube
            do jc=oic,olc
              kc = jc-oic+1
              call clean_make_cct(the_method,hclean,dmap(:,:,kc:kc),fctmp(:,:,kc:kc),the_method%gsize)
            enddo
            !
            ! This is approximate
            jc = (oic+olc)/2
            ibeam = beam_for_channel(jc,hdirty,hprim)
            !
            rprim = hprim%r4d(ifield,:,:,ibeam)
            call uv_removeg_clean(hcct,duv_in,duv_tmp,olc-oic+1,omic(oic:olc), &
              & dmap, freq, oic, olc, rprim, subtract)
            !
            do iv=1,nv
              duv_out(5+3*oic:7+3*olc,iv) = duv_tmp(8:7+3*(olc-oic+1),iv)
            enddo
          enddo
          deallocate(rprim)
        else
          if (ifield.eq.1) call map_message(seve%i,task,'Using REMOVEH for GCLEAN on Mosaic')
          ! Do by Fields, using FFT
          !SG - Not ready for Continuum residual in Line 
          !SG - FFT could use only 1 plane
          ! By channel chunks
          do oic=map_ic,map_lc,chunk
            olc = min(map_lc,oic+chunk-1)
            duv_tmp = 0.
            fctmp => ccou(:,:,oic-map_ic+1:)
            !
            call uv_removeh_clean(the_method,hprim,hclean,hcct, &
              & duv_in,duv_tmp,olc-oic+1,omic,fctmp,freq,oic,olc,ifield,subtract) !
            !
            do iv=1,nv
              duv_out(5+3*oic:7+3*olc,iv) = duv_tmp(8:7+3*(olc-oic+1),iv)
            enddo
          enddo
        endif
      endif
      !
      ! Add leading and trailing data if any
      if (huv_call%gil%lcol.lt.huv_call%gil%dim(1)) then
        do iv=1,nv
          duv_out(1:7,iv) = duv_in(1:7,iv)
          duv_out(huv_call%gil%lcol+1:huv_call%gil%dim(1),iv) = &
            & duv_in(huv_call%gil%lcol+1:huv_call%gil%dim(1),iv)  
        enddo
      else
        do iv=1,nv
          duv_out(1:7,iv) = duv_in(1:7,iv)
        enddo
      endif
      !
      if (allocated(duv_tmp)) deallocate (duv_tmp)
    enddo ! Fields
    !$OMP END DO
    !$OMP END PARALLEL
    the_method%major = save_major  ! Restore the beam for further use.
    !
    if (error) return ! In case of ^C
  endif ! DO_RESI
  !
  call gag_cpu(cpu1)
  if (elapsed.eq.0) then
    write(chain,102) 'Finished Residual CPU ',cpu1-cpu0
  else
    write(chain,102) 'Finished Residual Elapsed ',elapsed,'; CPU ',cpu1-cpu0
  endif
  call map_message(seve%i,task,chain)
  !
  !
  ! Compute the CLEAN image
  if (do_clean) then
    call copy_method(the_method,my_method)
    my_method%method = 'UV_RESTORE'
    my_method%bshift = 0      ! This looks uninitialized
    if (debug) Print *,'Calling GENERATE_CLEAN ',my_method%method,my_method%bshift
    ! We need a Clean Beam size    
    !
    call mosaic_set_beam(task,my_method)
    !
    ! Use the Full Clean Component list size
    call generate_clean(my_method,hsky,1,co_nchan,ccou,nmic)
    call gag_cpu(cpu1)
    if (elapsed.eq.0) then
      write(chain,102) 'Finished Clean generation CPU ',cpu1-cpu0
    else
      write(chain,102) 'Finished Clean generation Elapsed ',elapsed,'; CPU ',cpu1-cpu0
    endif
    call map_message(seve%i,task,chain)
  endif
  !
  if (allocated(fcou)) deallocate(fcou)
  if (allocated(ccou)) deallocate(ccou)
  !
  call imager_tree('SUB_UV_RESIDUAL',.true.)
  !
102 format(a,f9.2,a,f9.2)
end subroutine sub_uv_residual
!
subroutine uv_clean_size(hcct,ccin, mic)
  use image_def
  !-----------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER --  Support for UV_RESTORE  
  !   Compute the actual number of components
  !!
  !-----------------------------------------------------------------
  type(gildas), intent(in) :: hcct    !! header of CCT data set
  real, intent(in) :: ccin(hcct%gil%dim(1),hcct%gil%dim(2),hcct%gil%dim(3))  !! CCT data set
  integer, intent(out) :: mic         !! Last valid component
  !
  ! Local ---
  integer :: nc, ic, i, ni, ki, mi
  !
  ! Code ----
  nc = hcct%gil%dim(2)
  ni = hcct%gil%dim(3)
  !
  mi = 0
  do ic=1,nc
    ki = 0
    do i=1,ni
      if (ccin(3,ic,i).eq.0) then
        ki = i-1
        exit
      endif
    enddo
    if (ki.ne.0) then
      mi = max(mi,ki)
    endif
  enddo
  if (mi.eq.0) mi = ni
  mic = mi
end subroutine uv_clean_size
!
subroutine old_generate_clean(amethod,hmap,first,last,ccou,mic)
  !$ use omp_lib
  use clean_def
  use image_def
  use imager_interfaces, only : clean_make
  !---------------------------------------------------------------------
  ! @ private-mandatory
  !*
  ! IMAGER -- Support for UV_RESTORE
  !
  !   Generate the Clean image (without residuals) from the 
  !   (compressed or not) list of Clean components, over
  !   the specified range of channels
  !!
  !---------------------------------------------------------------------
  type(clean_par), intent(in) :: amethod  !! Clean Method
  type(gildas), intent(inout) :: hmap     !! Clean Header
  integer, intent(in) :: first            !! First channel
  integer, intent(in) :: last             !! Last channel
  real, intent(in) :: ccou(:,:,:)         !!  (x,y,Value,Size),Component,Plane
  integer, intent(in) :: mic(:)           !! Niter per plane
  !
  real(kind=8), parameter :: pi=acos(-1d0)
  !
  ! Local ---
  type (cct_par), allocatable :: p_cct(:)
  real, allocatable :: gauss(:)
  type (clean_par) :: my_method 
  integer :: iplane, jplane, niter, miter, i, ier, nthread, isize, nsize
  !
  ! Code ----
  miter = max(1,maxval(mic))
  nsize = 0
  allocate (p_cct(miter),stat=ier)
  isize = size(ccou,1) 
  if (isize.eq.4) then
    Print *,'Multi-Scale CLEAN component not yet handled'
    nsize = 1
    do i=size(amethod%gsize),2,-1
      if (amethod%gsize(i).ne.0) then
        nsize = i
        exit
      endif
    enddo
    Print *,'Scale sizes ',amethod%gsize(1:nsize)
    Print *,'Type / to proceed'
    read(*,*) i
    allocate(gauss(nsize))
    gauss = amethod%gsize(1:nsize)*pi/180/3600
    Print *,'Gaussian sizes in Radian ',gauss
  endif
  !$ nthread = omp_get_max_threads()
  !  !$ Print *,'OMP Already parallel ',omp_in_parallel(),' Nesting ',omp_get_nested(),
  !$ nthread = min(nthread,last-first+1)
  !$OMP PARALLEL DEFAULT(NONE) NUM_THREADS(nthread) &
  !$OMP & SHARED(amethod, first, last, hmap, mic, ccou, nthread) &
  !$OMP & SHARED(isize, nsize, gauss) &
  !$OMP & PRIVATE(my_method, iplane, jplane, p_cct, niter, i) 
  !
  !$OMP DO
  do iplane = first, last
    my_method = amethod
    !
    my_method%iplane = iplane
    !
    ! Recover the component list in pixels
    jplane = iplane-first+1
    niter = mic(jplane) 
    do i=1,niter
      if (ccou(3,i,jplane).eq.0) then
        p_cct(i)%value = 0 ! Required
        niter = i-1
        exit
      else
        !
        ! The NINT is required because of rounding errors
        p_cct(i)%ix = nint( (ccou(1,i,jplane)-hmap%gil%convert(2,1)) /  &
            &        hmap%gil%convert(3,1) + hmap%gil%convert(1,1))
        p_cct(i)%iy = nint( (ccou(2,i,jplane)-hmap%gil%convert(2,2)) /  &
            &        hmap%gil%convert(3,2) + hmap%gil%convert(1,2))
        p_cct(i)%value = ccou(3,i,jplane)
        if (isize.eq.4) then
          p_cct(i)%size = ccou(4,i,jplane)
          if (p_cct(i)%size.ne.0) Print *,'Iter ',i,p_cct(i)%size
        endif
      endif
    enddo
    ! Stupid test
    if (niter.gt.0) then
      my_method%n_iter = niter
      if (nsize.gt.1) then
        call clean_make(my_method,hmap, hmap%r3d(:,:,iplane),p_cct,gauss)
      else
        call clean_make(my_method,hmap, hmap%r3d(:,:,iplane),p_cct)
      endif
    else
      hmap%r3d(:,:,iplane) = 0
    endif
  enddo
  !$OMP END DO
  !$OMP END PARALLEL
  !
  deallocate(p_cct)
end subroutine old_generate_clean
!
subroutine generate_clean(amethod,hmap,first,last,ccou,mic)
  !$ use omp_lib
  use clean_def
  use image_def
  use imager_interfaces, only : clean_make_cct
  !---------------------------------------------------------------------
  ! @ private-mandatory
  !*
  ! IMAGER -- Support for UV_RESTORE
  !
  !   Generate the Clean image (without residuals) from the 
  !   (compressed or not) list of Clean components, over
  !   the specified range of channels
  !!
  !---------------------------------------------------------------------
  type(clean_par), intent(in) :: amethod  !! Clean Method
  type(gildas), intent(inout) :: hmap     !! Clean Header
  integer, intent(in) :: first            !! First channel
  integer, intent(in) :: last             !! Last channel
  real, intent(in) :: ccou(:,:,:)         !! (x,y,Value,Size),Component,Plane
  integer, intent(in) :: mic(:)           !! Niter per plane
  !
  real(kind=8), parameter :: pi=acos(-1d0)
  !
  ! Local ---
  real, allocatable :: gauss(:)
  type (clean_par) :: my_method 
  integer :: iplane, jplane, miter, i, isize, nsize
  !
  ! Code ----
  miter = max(1,maxval(mic))
  nsize = 0
  isize = size(ccou,1) 
  if (isize.eq.4) then
    ! !Print *,'Multi-Scale CLEAN component not yet Verified'
    nsize = 1
    do i=size(amethod%gsize),2,-1
      if (amethod%gsize(i).ne.0) then
        nsize = i
        exit
      endif
    enddo
    ! !Print *,'Scale sizes ',amethod%gsize(1:nsize)
    allocate(gauss(nsize))
    gauss = amethod%gsize(1:nsize) ! It must be in ArcSeconds 
  else
    ! !Print *,'Normal Clean Generation'
  endif
  !
  do iplane=first,last
    jplane = iplane-first+1
    my_method = amethod
    my_method%n_iter = mic(jplane)
    if (nsize.gt.1) then
      call clean_make_cct(my_method,hmap,hmap%r3d(:,:,iplane), &
        & ccou(:,1:mic(jplane),jplane:jplane),gauss)
    else
      call clean_make_cct(my_method,hmap,hmap%r3d(:,:,iplane), &
        & ccou(:,1:mic(jplane),jplane:jplane))        
    endif
  enddo
  !
end subroutine generate_clean
!
subroutine attenuate_clean(nchan,ccou,doff,bsize,fcou,mic,dpha)
  !---------------------------------------------------------------------
  ! @ private-mandatory
  !*
  ! IMAGER -- Support for UV_RESIDUAL
  !
  !   Apply primary beam attenuation to Clean Components
  ! at specified offset. Compress Clean component based on position
  ! while doing so.
  !
  ! If a Phase Offset argument DPHA is present, shift the Clean
  ! Component positions to this new phase center.
  !!
  !---------------------------------------------------------------------
  integer, intent(in) :: nchan          !! Number of channels
  real, intent(in) :: ccou(:,:,:)       !! Shape (3 or 4,Ncomp,Nplane)
  real, intent(out) :: fcou(:,:,:)      !! Same shape, but different sizes 
  real, intent(in) :: doff(2)           !! Offset value
  real, intent(in) :: bsize             !! Beam size
  integer, intent(inout) :: mic(nchan)  !! Effective number of Clean components
  real(8), intent(in), optional :: dpha(2)  !! Phase offsets if any
  !
  integer, external :: locwrd
  !
  logical, parameter :: debug=.false.
  ! Local ---
  real :: beam_e, b2, fact
  integer :: ic,jc,kc
  logical :: do_shift, gauss
  real :: isum(nchan), osum(nchan)  !! Debug - automatic arrays
  !
  ! Code ----
  if (locwrd(ccou).eq.locwrd(fcou)) then
    Print *,'F-ATTENUATE_CLEAN,  Programming error - Overlapping arrays)'
    STOP
  endif
  do_shift = present(dpha)
  if (do_shift) then
    if ((dpha(1).eq.0).and.(dpha(2).eq.0)) then
      do_shift = .false.
    endif
    if (debug) Print *,'Attenuate_Clean -- DOSHIFT ',do_shift,dpha
  else
    if (debug) Print *,'Attenuate_Clean -- NO Shift'
  endif
  if (debug) then
    Print *,'Attenuate_Clean ',nchan,doff(1:2),size(ccou,1),size(fcou,1)
    Print *,'Adress ccou ',locwrd(ccou),' fcou ',locwrd(fcou)
  endif
  !
  beam_e = bsize/(2.*sqrt(log(2.0)))
  b2 = (1.0/beam_e)**2
  gauss = size(ccou,1).eq.4 ! GCLEAN size
  !
  ! The attenuation here is currently purely Gaussian
  ! We MUST use the beam profile mechanism to do better.
  if (debug) then
    isum = 0.
    osum = 0.
    Print *,'Attenuate_Clean In Components ',mic
  endif
  do ic=1,nchan
    kc = 0
    do jc=1,mic(ic)
      if (debug) isum(ic) = isum(ic)+ccou(3,jc,ic)
      fact = ((ccou(1,jc,ic)-doff(1))**2+(ccou(2,jc,ic)-doff(2))**2)*b2
      if (fact.lt.16) then   ! for 1E-7 precision, more than enough
        kc = kc+1
        fcou(3,kc,ic) = ccou(3,jc,ic)*exp(-fact)
        if (debug) osum(ic) = osum(ic)+fcou(3,kc,ic)
        if (do_shift) then
!Initial          fcou(1:2,kc,ic) = ccou(1:2,jc,ic)-dpha(1:2)
          fcou(1:2,kc,ic) = ccou(1:2,jc,ic)-dpha(1:2)
!Non  with final DPHA        fcou(1:2,kc,ic) = ccou(1:2,jc,ic)+dpha(1:2) !SG
!Non          fcou(1:2,kc,ic) = ccou(1:2,jc,ic)! -dpha(1:2)
        else
          fcou(1:2,kc,ic) = ccou(1:2,jc,ic)
        endif
        if (gauss) fcou(4,kc,ic) = ccou(4,jc,ic)
      endif
    enddo
    mic(ic) = kc
  enddo
  if (debug) then
    Print *,'Attenuate_Clean In FLUX ',isum
    Print *,'Attenuate_Clean Out Components ',mic
    Print *,'Attenuate_Clean Out FLUX ',osum
  endif
  !
end subroutine attenuate_clean
!
subroutine mosaic_set_beam(task,my_method)
  use gkernel_interfaces
  use imager_interfaces, only : fibeam, map_message
  use clean_def
  use clean_arrays
  use clean_types
  use clean_default
  use clean_beams
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !
  !! IMAGER -- Define the Mosaic Clean Beam
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: task        !! Caller name
  type(clean_par), intent(inout) :: my_method !! Clean parameters 
  !! to be completed by Clean beam
  !
  ! Constants
  real(8), parameter :: pi=3.14159265358979323846d0
  real(8), parameter :: sec_to_rad=pi/3600.d0/180d0
  !
  ! Local ---
  character(len=80) :: mess
  integer :: nx,ny
  logical :: error
  !
  ! Code ----
  if (hsky%gil%majo.eq.0) then
    if (beam_defined) then
      my_method%major = beam_fitted(1) * sec_to_rad
      my_method%minor = beam_fitted(2) * sec_to_rad
      my_method%angle = beam_fitted(3)   ! Keep it Degree...
    else
      my_method%major = 0
      my_method%minor = 0
      my_method%angle = 0
      nx = hbeam%gil%dim(1)
      ny = hbeam%gil%dim(2)
      error = .false.
      call fibeam (task,dbeam,nx,ny,   &
       &    my_method%patch(1),my_method%patch(2),my_method%thresh,   &
       &    my_method%major,my_method%minor,my_method%angle,   &
       &    hbeam%gil%convert,error)
    endif
    !
    hsky%gil%majo = my_method%major
    hsky%gil%mino = my_method%minor
    hsky%gil%posa = my_method%angle*pi/180.
    hsky%gil%reso_words = 3
  else
    write(mess,'(A,F8.2)') 'Spatial Resolution was already defined ', &
      & hsky%gil%majo*180*3600/pi
    call map_message(seve%w,task,mess)
  endif
end subroutine mosaic_set_beam
!
subroutine get_cols(nchan,ucol,fcol,lcol,wcol)
  !------------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- Utility routine  
  !     Define Channel range and Weight channel
  !!
  !------------------------------------------------------------------------
  integer, intent(in) :: ucol(2)        !! User input channel range
  integer, intent(inout) :: nchan       !! Number of channels
  integer, intent(out) :: fcol          !! First channel
  integer, intent(out) :: lcol          !! Last channel
  integer, intent(out) :: wcol          !! Default weight channel
  !
  ! Local ---
  integer :: mcol(2)
  !
  ! Code ----
  mcol = ucol
  if (mcol(1).eq.0) then
    mcol(1) = 1
  else
    mcol(1) = max(1,min(mcol(1),nchan))
  endif
  if (mcol(2).eq.0) then
    mcol(2) = nchan
  else
    mcol(2) = max(1,min(mcol(2),nchan))
  endif
  fcol = min(mcol(1),mcol(2))
  lcol = max(mcol(1),mcol(2))
  if (wcol.eq.0) then
    wcol = (fcol+lcol)/3
  endif
  wcol = max(1,wcol)
  wcol = min(wcol,nchan)
  nchan = lcol-fcol+1
end subroutine get_cols
!

module clean_arrays
  use clean_def
  use image_def
  !!
  !!  Define all Static variables first, then allocatable next.
  !!
  type (gildas), save, target :: hview  !! VIEWER DATA header
  type (uvmap_par), save :: themap      !! UV_MAP parameters
  type (clean_par), target :: the_method    !! CLEAN parameters
  type (gildas), save, target :: hbeam  !! Synthesized beam Header
  type (gildas), save, target :: hdirty !! Dirty image Header
  type (gildas), save, target :: hclean !! Clean image Header
  type (gildas), save, target :: hresid !! Residual image Header
  type (gildas), save, target :: hatten !! Field weights header
  type (gildas), save, target :: hprim  !! Primary beams Header
  type (gildas), save :: hfields        !! Fields Header
  type (gildas), save, target :: hcct   !! Clean component table Header
  type (gildas), save, target :: hmask  !! Mask Header
  type (gildas), save, target :: hsky   !! Sky brightness image Header
  type (gildas), save, target :: hcont  !! Continuum image (Clean or Sky)
  type (gildas), save :: hpv            !! Position-Velocity data
  type (gildas), save :: hrobust        !! Beams as a function of Robust parameter
  !
  !! Self-calibration headers
  type (gildas), save :: hself_raw      !! Raw (non self-calibrated) UV header
  type (gildas), save :: hself_calib    !! Self-calibrated UV header 
  type (gildas), save :: hself_self     !! Self-calibrated UV header for Display
  type (gildas), save :: hagain         !! Antenna-based gain Header
  type (gildas), save :: hbgain         !! Baseline-based gain Header
  !
  !! Mosaics & Short spacings
  type (gildas), save :: hsingle        !! Single Dish Cube or Table
  type (gildas), save :: hshort         !! Short spacing Cube 
  type (gildas), save :: hpoint
  !
  !! UV data like headers
  type (gildas), save, target :: huv_init    !! Initial UV data Header        HUVI
  type (gildas), save, target :: huv_sort    !! Sorting UV data (for Mosaics)  
  type (gildas), save, target :: huv_current !! Current UV data Header        HUV
  type (gildas), save, target :: huvt        !! Transposed UV data Header
  type (gildas), save, target :: huv_cont    !! Continuum UV data Header      HUVC
  type (gildas), save, target :: huv_model   !! Model UV data Header          HUVM
  type (gildas), save, target :: huv_resid   !! Fit residual UV data Header   HUVF
  !
  type (clean_par), target :: c_method, cuse_method
  !! For the Multi-Primary beams Mosaic deconvolution
  !! C_ stands for "Compact Array"
  type (gildas), save :: c_hbeam, c_hdirty, c_hresid, c_hclean
  type (gildas), save :: c_hprim
  !
  !! UV_MAP optimization arrays: Weigts and V values
  real, allocatable, save :: g_weight(:)  !! UV weights
  real, allocatable, save :: g_v(:)       !! V values
  logical, save :: do_weig                !! Optimization of weight computing
  !
  !! Viewer data 
  real, allocatable, target, save :: dview(:,:,:)     !! VIEWER DATA area 
  !! Imaging and deconvolution arrays
  real, allocatable, target, save :: dbeam(:,:,:,:)   !! 4-D         (lm,m,v,p)
  real, allocatable, target, save :: ddirty(:,:,:)    !! Dirty 3-D   (l,m,v)
  real, allocatable, target, save :: dclean(:,:,:)    !! Clean 3-D   (l,m,v)
  real, allocatable, target, save :: dresid(:,:,:)    !! Residual 3-D  (l,m,v)
  real, allocatable, target, save :: dprim(:,:,:,:)   !! Primary beam 4-D    (p,x,y,v)
  real, allocatable, target, save :: datten(:,:,:)    !! Mosaic weights 3-D  (lm,m,v)
  real, allocatable, target, save :: dsky(:,:,:)      !! Primary beam corrected 3-D  (l,m,v)
  real, allocatable, target, save :: dfields(:,:,:,:) !! Mosaic fields 4-D   (l,m,v,p)
  real, allocatable, target, save :: dcont(:,:)       !! Continuum image 2-D (l,m)  (and SKY ?)
  real, allocatable, target, save :: dsmooth(:,:,:,:) !! Spectrally Smoothed array UNDER TEST ONLY
  real, allocatable, target, save :: drobust(:,:,:)   !! Beams as a function of Robust parameter
  !
  !! Deconvolution arrays
  real, allocatable, target, save :: dmask(:,:,:)     !! Input 3-D 0, #0 mask  (lm,m,v)
  integer, allocatable, target, save :: d_list(:)     !! List of selected pixels
  logical, allocatable, target, save :: d_mask(:,:)   !! Logical mask for pixel selection
  real, allocatable, target, save :: dcct(:,:,:)      !! Clean component values (cct_size,v,n)
  type(cct_lst), allocatable, save :: dcclist(:)      !! Clean component list (v) all channels
  !
  !! UV data like arrays
  real, pointer :: duv(:,:)                        !! Current UV data
  real, pointer :: duvr(:,:)                       !! "Resampled" UV data
  real, pointer :: duvs(:,:)                       !! "Sorted" UV data
  real, allocatable, target, save :: duvc(:,:)     !! Sorted or Unsorted Continuum UV data
  real, allocatable, target, save :: duvt(:,:)     !! Time-Baseline sorted UV data, for UV_FLAG
  real, allocatable, target, save :: duvm(:,:)     !! Model UV data
  real, allocatable, target, save :: duvf(:,:)     !! Fit residual UV data  
  real, allocatable, target, save :: duvbg(:,:)    !! Baseline Gains (UV data like)
  real, allocatable, target, save :: duvraw(:,:)   !! Raw UV data for Self calibration
  real, allocatable, target, save :: duvcalib(:,:) !! Self calibrated UV data
  real, pointer, save :: duvself(:,:)              !! Self calibrated UV data, continuum version
  real, allocatable, target, save :: dagain(:,:)   !! Antenna based gain
  !
  !! Short spacing data array
  real, allocatable, target, save :: dsingle(:,:,:)   !! Short spacing data (Table or Cube)
  real, allocatable, target, save :: dshort(:,:,:)    !! Short spacing 3-D cube (x,y,v)
  !! The above one was by hshort%r3d only before 26-Apr-2023
  !
  !! For the Multi-Primary beams Mosaic deconvolution
  !! C_ stands for "Compact Array"
  real, allocatable, target, save :: c_dbeam(:,:,:)
  real, allocatable, target, save :: c_ddirty(:,:,:)
  real, allocatable, target, save :: c_dclean(:,:,:)
  real, allocatable, target, save :: c_dresid(:,:,:)
  real, allocatable, target, save :: c_dprim(:,:,:)
  logical, allocatable, target, save :: c_mask(:,:)
  integer, allocatable, target, save :: c_list(:)
  real, allocatable, target, save :: c_atten(:,:,:)  !! 3-D
  !
  integer :: niter_listsize=0
  integer, allocatable :: niter_list(:)  !! Per channel CLEAN Niter - little used
  integer :: ares_listsize=0
  real, allocatable :: ares_list(:)  !! Per channel CLEAN Ares - little used
  !
  integer :: selected_fieldsize=0
  integer, allocatable :: selected_fields(:)
  !! List of selected fields in UV_MAP (used for UV_RESTORE and also for SHOW FIELDS)
end module clean_arrays
!!
module moment_arrays
  use image_def
  !! Moment Images
  type(gildas), save :: hpeak, hmean, hvelo, hwidth
  real, allocatable, target, save :: dmean(:,:), dpeak(:,:), dvelo(:,:), dwidth(:,:)
  !! Flux spectra
  integer, target, save :: flux_nf=0
  integer, target, save :: flux_nc=0
  real(4), target, save, allocatable :: flux_velo(:)
  real(8), target, save, allocatable :: flux_freq(:)
  real(4), target, save, allocatable :: flux_values(:,:)
  real(4), target, save, allocatable :: flux_errors(:,:)
end module moment_arrays
!!
module uvsplit_mod
  use image_def
  !! Module for the UV_SPLIT command
  integer, parameter :: opt_chan=1
  integer, parameter :: opt_file=2
  integer, parameter :: opt_freq=3
  integer, parameter :: opt_range=4
  integer, parameter :: opt_velo=5
  integer, parameter :: opt_width=6
  integer, parameter :: opt_reset=7
  integer, parameter :: opt_zero=8
  integer, parameter :: code_baseline=-1
  integer, parameter :: code_split=0
  integer, parameter :: code_filter=1
  !!
  character(len=filename_length) :: in_file
  character(len=filename_length) :: ou_file
  !!
  type(gildas), target, save :: hiuv
  type(gildas), target, save :: houv
  type(gildas), target, save :: hfuv
  integer :: code_routine
  integer :: nblock        !! Blocking factor
  integer :: ncompr        !! Channel compression factor
  logical :: use_file      !! /FILE option
  real :: edge_drop=0.05   !! Fraction of bandwidth dropped at edges for continuum
  !!
end module uvsplit_mod
!!
module clean_support
  use gkernel_types
  !! CLEAN\SUPPORT polygon, mapped on SUPPORT%
  integer, parameter :: support_mask = 1 
  integer, parameter :: support_poly = -1
  integer, parameter :: support_none = 0
  character(len=varname_length), parameter :: supportvar='SUPPORT'
  !!
  type(polygon_t), save :: supportpol
  integer, save :: support_type         !! Current type of support
  type (gildas), save :: hmask_temp     !! Mask Template
  character(len=64) :: mask_template    !! Name of Mask Template Variable
end module clean_support
!!
module clean_types
  use gkernel_types
  !!
  !! Definitions of known Buffers names and status
  !!
  integer, parameter :: mtype=34
  integer, parameter :: ptype=11
  integer :: ftype(1:mtype) = (/0,0,1,1,1,1,1,1,0,0,1,0,0,0,-1,1,1,-1,-1,-1,-1,-1,-1,-1,-1,-1,1,-1,-1,-1, 0,-1,-1,1/)
  !!  0 -- No or Special buffer (e.g. POLYGON)
  !!  1 -- Normal FITS or Gildas buffers
  !! -1 -- No buffer - special display action
  integer :: vwrite(1:22) = (/2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,20,23,26,27,31,34/)
  !! List of Writeable entities
  integer :: vshow(1:32) = (/1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,32,34/)
  !! List of Entities that can be Shown or Viewed
  integer :: vread(1:20) = (/2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,23,26,27,31/)
  !! List of Readable quantities
  character(len=12) :: vtype(1:mtype) = (/ &
  &  'COVERAGE    ',  &     !! 1
  &  'UV_DATA     ',  &     !! 2
  &  'BEAM        ',  &     !! 3
  &  'DIRTY       ',  &     !! 4
  &  'CLEAN       ',  &     !! 5
  &  'PRIMARY     ',  &     !! 6
  &  'RESIDUAL    ',  &     !! 7
  &  'MASK        ',  &     !! 8
  &  'SUPPORT     ',  &     !! 9
  &  'CCT         ',  &     !! 10
  &  'SKY         ',  &     !! 11      !! Up to PTYPE, allowed Images (FITS support allowed)
  &  'MODEL       ',  &     !! 12
  &  'FIELDS      ',  &     !! 13
  &  'CGAINS      ',  &     !! 14
  &  'SELFCAL     ',  &     !! 15
  &  'SHORT       ',  &     !! 16
  &  'SINGLEDISH  ',  &     !! 17
  &  'NOISE       ',  &     !! 18
  &  'SNR         ',  &     !! NOISE and SNR are special, just for SHOW NOISE  
  &  'MOMENTS     ',  &     !! special, just for SHOW MOMENTS      20
  &  'COMPOSITE   ',  &     !! special, Moments + Flux on one plot
  &  'KEPLER      ',  &     !! special, for SHOW KEPLER
  &  'FLUX        ',  &     !! special, for SHOW FLUX and WRITE FLUX and READ FLUX    
  &  'SOURCES     ',  &     !! special, for SHOW SOURCES
  &  'SPECTRA     ',  &     !! special, for SHOW SPECTRA           25
  &  'UV_FIT      ',  &
  &  'CONTINUUM   ',  &     !! Continuum Image (if any)            27
  &  'SED         ',  &     !! Special, for SHOW SED
  &  'PV          ',  &     !! special, for SHOW PV
  &  'SIMULATION  ',  &     !! Special, for SHOW SIMU              30
  &  'POLYGON     ',  &     !! To avoid issues with WRITE POLY     31
  &  'INTENSITY   ',  &     !! Like NOISE but Logarithm
  &  'STATISTIC   ',  &     !! Like NOISE but Logarithm, and fit the RMS noise
  &  'DATA        '   /)    !! DATA, must be the last one 
  !!
  character(len=12) :: etype(1:mtype) = (/ &
  & '            ',  &
  & '.uvt        ',  &
  & '.beam       ',  &
  & '.lmv        ',  &
  & '.lmv-clean  ',  &
  & '.lobe       ',  &
  & '.lmv-res    ',  &
  & '.msk        ',  &
  & '.pol        ',  &
  & '.cct        ',  &
  & '.lmv-sky    ',  &
  & '.uvt        ',  &
  & '.fields     ',  &
  & '.uvt        ',  &      
  & '.tab        ',  &
  & '.lmv-sky    ',  &
  & '.tab        ',  &
  & '            ',  &
  & '            ',  &
  & '            ',  &
  & '            ',  &
  & '            ',  &
  & '.tab        ',  &
  & '            ',  &
  & '            ',  &
  & '.uvfit      ',  &
  & '.lmv-clean  ',  &
  & '.txt        ',  &
  & '            ',  &
  & '            ',  &
  & '.pol        ',  &
  & '            ',  &
  & '            ',  &
  & '            ' /)    !! DATA, no genering extension       
  !!
  integer, parameter :: mbuffer=27+3
  character(len=12) :: cbuffer(1:mbuffer) = (/ &
  &  'AGAINS      ',  &
  &  'BEAM        ',  &
  &  'CCT         ',  &
  &  'CGAINS      ',  &
  &  'CLEAN       ',  &
  &  'CLIPPED     ',  &  
  &  'CONTINUUM   ',  &
  &  'DATA        ',  &
  &  'DIRTY       ',  &
  &  'EXTRACTED   ',  &
  &  'MASK        ',  &
  &  'M_AREA      ',  &
  &  'M_PEAK      ',  &
  &  'M_VELO      ',  &
  &  'M_WIDTH     ',  &
  &  'MODEL       ',  &
  &  'PRIMARY     ',  &
  &  'RESIDUAL    ',  &
  &  'WEIGHT      ',  &
  &  'FIELDS      ',  &
  &  'SHORT       ',  &
  &  'SINGLE      ',  &
  &  'SKY         ',  &
  &  'SLICE       ',  &
  &  'SPECTRUM    ',  &
  &  'UV          ',  &
  &  'UV_FIT      ',  &
  &  'UV_RESIDUAL ',  &
  &  'UVCONT      ',  &
  &  'UVRADIAL    '  /)  
  character(len=36) :: sbuffer(1:mbuffer) = (/ &
!     123456789 12345678 123456789 123456
  &  'Self-Cal Antenna Gains             ',  &
  &  'Synthesized Dirty Beam             ',  &
  &  'Clean Component Table              ',  &
  &  'Self-Calibration Complex Gains     ',  &
  &  'Clean-ed data cube                 ',  &
  &  'Clipped Spectrum from UV_PREVIEW   ',  &  
  &  'Continuum image from MAP_CONTINUUM ',  &
  &  'Generic VIEWER data area           ',  &        
  &  'Dirty Image                        ',  &
  &  'Image extracted by EXTRACT         ',  &
  &  'Current Mask                       ',  &
  &  'Integrated Area from MOMENTS       ',  &
  &  'Peak flux from MOMENTS             ',  &
  &  'Mean Velocity from MOMENTS         ',  &
  &  'Line Width from MOMENTS            ',  &
  &  'UV Model visibilities              ',  &
  &  'Primary Beam                       ',  &
  &  'Residual Image                     ',  &  
  &  'Mosaic Weight Image                ',  &
  &  'Mosaic Fields                      ',  &
  &  'Short Spacing Image                ',  &
  &  'Single-Dish Data                   ',  &
  &  'Sky Brightness (PB corrected)      ',  &
  &  'Image extracted by SLICE           ',  &
  &  'Initial Spectrum from UV_PREVIEW   ',  &
  &  'UV data                            ',  &
  &  'UV Fit results binary table        ',  &
  &  'Residual visibilities              ',  &
  &  'Continuum UV data                  ',  &
  &  'Azimutally averaged UV data        '  /)  
  !!
  character(len=12) display_type
  !!
  integer, parameter :: code_save_none=0
  integer, parameter :: code_save_uv=2
  integer, parameter :: code_save_beam=3
  integer, parameter :: code_save_dirty=4
  integer, parameter :: code_save_clean=5
  integer, parameter :: code_save_primary=6
  integer, parameter :: code_save_resid=7
  integer, parameter :: code_save_mask=8
  integer, parameter :: code_save_support=9
  integer, parameter :: code_save_cct=10
  integer, parameter :: code_save_sky=11
  integer, parameter :: code_save_model=12
  integer, parameter :: code_save_fields=13
  integer, parameter :: code_save_gains=14
  integer, parameter :: code_save_short=16
  integer, parameter :: code_save_single=17
  integer, parameter :: code_save_cont=27 
  !!
  !! Output data format
  integer, parameter :: write_gildas=0
  integer, parameter :: write_fits=1
  integer, parameter :: write_fits_velo=2
  integer, parameter :: write_fits_freq=3
  integer, parameter :: write_csv=-1
  integer, save :: write_default = write_gildas
  integer, save :: write_format  = write_gildas
  !!
  !! Input read option
  logical, save :: read_trail=.true.
  !!
  !! Read / Write optimization
  type readop_t
    type(mfile_t) :: modif   !! From kernel / gsys_types
    integer :: lastnc(2) = 0
    integer :: change = 0
  end type
  !!
  logical :: save_data(mtype)
  type (readop_t), save :: optimize(mtype)
  !!
  integer :: rw_optimize
end module clean_types
!!
module clean_default
  use image_def
  use clean_def
  !!
  !! Default values for IMAGER behaviours
  real d_min,d_max       !! min max of dirty image, used by MRC plots only
  real beam_size(3)      !! Major, Minor (in arcsecond) and Angle (in degree)
  !!
  type(clean_par), save, target :: user_method !! CLEAN parameters
  type(uvmap_par), save :: default_map, old_map, save_map
  character(len=16), save :: current_uvdata = 'DATA_UV'
  character(len=32), save :: gtv_root = '<GREG'
  logical, save :: uv_model_updated
  logical, save :: uv_resid_updated
  logical, save :: uv_data_updated
  !!
  real, save :: field_size = 4.0           !! Size of 1 field in Mosaics (FWHP) could be in Method%
  real, save :: guard_size = 2.5           !! Guard size around Mosaics (FWHP)
  integer, save :: mosaic_enlarge = 1      !! Enlarge Beam Mode
  integer, save :: multi_print = 0         !! Step between Printing in MULTI mode
  character(len=8) :: mosaic_mode='GUETH'  !! Mosaic Mode (NONE, GUETH or SAULT)
  real, save :: mosaic_tolerance=1.0       !! In arcsec, Mosaic tolerance
  !
  logical, save :: call_debug = .false.    !! Call Tree Debugging
  !
  integer, save :: map_version = 0         !! Imaging tool version (deprecated)
  !! Non zero means old non-optimized code.
  !!
  logical, save :: cct_dynamic = .true.    !! Parameter for dynamic Clean Component List
  !
  ! Parameters for determining image size
  integer, save :: map_power = 2           !! Max exponent of powers of 3 and 5
  real, save :: map_rounding = 0.05        !! Tolerance for rounding to floor
  !
  logical, save :: ImagerError = .false.  !! Error status from scripts
  character(len=16), save :: last_shown=' '       !! CLEAN, DATA, DIRTY or SKY
  character(len=16), save :: last_resid=' '       !! CCT or UV_FIT
  character(len=filename_length), save :: last_temporary=' '  !! Last TEMPORARY data file
  character(len=16), save :: clean_stop(2) !! CLEAN_STOP criterium
  logical, save :: view_do_loop            !! Interactive mode for VIEW
  logical, save :: show_side               !! Side view for SHOW 
  logical, save :: do_continuum            !! Save the Continuum image ?
  integer, save :: expand_cont             !! Continuum expansion factor
  integer, save :: iangle_unit=-3          !! Angle Unit code, default Second
  !!
  integer, save :: sys_ramsize             !! RAM size in MBytes
  !!
  real(8), save :: area_size(2)            !! SIZE[2]
  real(8), save :: area_center(2)          !! CENTER[2]
  !!
  character(len=64) :: defmap_center       !! MAP_CENTER string
  !!      
  real(4), save :: recmap_field(2)         !! Recommended map field (radians)
  integer, save :: recmap_size(2)          !! recommended map size  (pixels)
  real(4), save :: recmap_xycell(2)        !! recommended map cell  (radians)
  real(4), save :: recmap_uvcell           !! recommended UV cell (m)
  !!
  !! Active values
  type(imaging_mode), save  :: saved_chan
  type(imaging_mode), save  :: uvmap_chan
  !!
  !! SHOW NOISE issues
  integer, save :: noise_type
  logical, save :: noise_fit
  logical, save :: noise_one
  logical, save :: noise_plot
  !! UV_REWEIGHT output
  real, save :: uv_weight_scale             !! Weight scale factor found by UV_REWEIGHT
  logical, save :: debug_buffer=.false.     !! Buffer pointer debug
  !! Color Model
  character(len=8) :: color_model='No'
end module clean_default
!!
module clean_beams
  !! Dirty beam control parameters
  real, save, target :: beam_tolerance=0.01 !! 1 % loss is not much an issue usually
  real, allocatable, save :: beam_ranges(:,:) !! Edges of beam ranges
  integer, save :: nbeam_ranges           !! Number of Beam ranges
  integer, save :: beam_gap               !! Size of allowed "gaps" in channels  
  logical, save :: beam_defined=.false.   !! 
  integer, save, target :: beams_number=0 !! Number of Frequency dependent beams
  integer, save, target :: beams_field=0  !! Number of Fields
  real, save, target :: beam_fitted(4)    !! Beam size in "convenient" units (user-readable)
  !! Major & Minor axis (arcsec), Position Angle (deg) and JvM factor
  real, allocatable, save, target :: beams_param(:,:,:) 
  !! Array (4,beams_number,beams_field), in same units: Major, Minor, Angle, JvM
end module clean_beams
!!
module uvfit_data
  !! Support module for command UV_FIT
  use image_def
  integer, parameter :: mpar=70         !! Max number of parameters
  integer, parameter :: mf=10           !! Max number of functions
  integer, parameter :: mpin=7          !! Max number of parameters per function
  real(kind=8) :: pars(mpar)            !! Parameter values
  real(kind=8) :: sw
  real, allocatable :: uvriw(:,:)       !! Work space for visibilities
  integer :: nf                         !! number of functions
  integer :: ifunc(mf)                  !! Function codes
  integer :: npfunc(mf)                 !! number of parameters per function
  logical :: savef(mf)                  !! Subtract function
  integer :: npuvfit                    !! number of points
  integer :: npar                       !! Number of parameters
  integer :: nstart(mpar)               !! Number of starts per parameter
  integer :: ncall                      !! Number of function calls
  !!
  real(kind=4) :: uvf_results(mpin,mf)  !! Results for each function
  real(kind=4) :: uvf_errors(mpin,mf)   !! Errors 
  !!
  type (gildas) :: huvfit               !! Table of fitted parameters
  real, allocatable :: duvfit(:,:)      !! UV_FIT results
end module uvfit_data
!!
module preview_mod
  use image_def
  !! UV_PREVIEW control parameters and associated data structures
  type(gildas), save :: htab
  type(gildas), save :: hclip 
  integer, allocatable, save :: final_lines(:)
  real(kind=8), allocatable, save :: edge_freq(:,:)   !! Edge Frequencies
  integer, allocatable, save :: edge_chan(:,:)        !! Edge channels
  integer, save :: number_of_channels = 0
  integer, save :: browse_last = -1
  !!
  !! Control parameters
  integer, save :: utaper=3
  real,    save :: uclip=3.0
  integer, save :: uhist=0
  integer, save :: usmooth=3
  !!
end module preview_mod
!!
module omp_control
  !! OPEN-MP control parameters
  logical, save :: omp_compiled = .false.
  integer, save :: omp_grid = 0
  integer, save :: omp_single_beam = 0
  logical, save :: omp_debug = .false.
  integer, save :: omp_outer_thread = 1   !! Number of Threads at outer stage
  integer, save :: omp_inner_thread = 1   !! Number of Threads at inner stage
  integer, save :: omp_outer_threadgoal = 4 !!
end module omp_control
!!
module grid_control
  !! Gridding method control parameters (speed issues)
  integer, save :: grid_bigvisi=10000000  !! Threshold for Gridding weights
  integer, save :: grid_subcell=8         !! Sub-cell per Uniform cell 
  integer, save :: grid_weighting=0       !! Weighting mode
end module grid_control
!!
module gclean_mod
  !! GCLEAN  Smoothed Dirty beams and Scale factors
  integer, save :: n_scales               !! ms*(ms+1)/2
  integer, allocatable :: beamindex(:,:)
  real, allocatable ::  gbeam(:,:,:,:)    !! (nx,ny,n_scales,np)
  real, allocatable :: scales(:,:)        !! (n_scales,np) Scales factor for each beam
  real, allocatable :: scale(:)           !! (n_scales)    Mean Scale factor 
  real, allocatable :: loss(:)            !! (n_scales)    Noise degradation factor...
end module gclean_mod
!!

subroutine do_object(coord,equinox,lambda,beta,s_2,s_3,dop,lsr,svec,x_0,  &
  parang,error)
  use gbl_message
  use ast_astro
  use ast_constant
  !---------------------------------------------------------------------
  ! @ public
  !*
  ! ASTRO
  !
  !  Reduce coordinates of a fixed object
  !!
  !---------------------------------------------------------------------
  character(len=2), intent(in)    :: coord      !! Coordinate system
  real(kind=4),     intent(in)    :: equinox    !! Equinox (ignored if not EQ)
  real(kind=8),     intent(in)    :: lambda     !! Longitude like coordinate in Radian
  real(kind=8),     intent(in)    :: beta       !! Latitude like coordinate in Radian
  real(kind=8),     intent(out)   :: s_2(2)     !! Specified coordinates in Degree
  real(kind=8),     intent(out)   :: s_3(3)     !! ra, dec & distance of Sun at current epoch
  real(kind=8),     intent(out)   :: dop        !! Doppler velocity
  real(kind=8),     intent(out)   :: lsr        !! LSR velocity
  real(kind=8),     intent(out)   :: svec(3)    !! Direction vector
  real(kind=8),     intent(out)   :: x_0(3)   
  !!
  real(kind=8),     intent(out)   :: parang     !! Parallactic angle
  logical,          intent(inout) :: error      !! Logical error flag
  !
  ! Global
  real(kind=8), external :: sun_distance
  ! Constants
  real(kind=8), parameter :: apx1 = 0.289977970217382d0
  real(kind=8), parameter :: apx2 = -11.9099497383444d0
  real(kind=8), parameter :: apx3 = 16.0645264529100d0
  real(kind=8), parameter :: degrad = pi /180.d0
  real(kind=8), parameter :: stv = 2d0* pi / 86400d0*366.25d0 / 365.25d0
  !
  ! Local
  real(kind=8) :: x_2(3), v_2(3), x_3(3), x_1(3), vp_2(3), sp_2
  real(kind=8) :: psi, the, phi, jfix, epsm, mat1(9), mat2(9), mat3(9)
  real(kind=8) :: angles(6), trfm_03(9), trfm_01(9), oblimo, y_2(3), n_3(3)
  real(kind=8) :: n_2(3), den
  integer(kind=4) :: i
  !          
  ! vp_2 is the vector product of y_2 and n_2
  ! sp_2 is the scalar product of vp_2 and x_2
  !
  !      SAVE
  !------------------------------------------------------------------------
  ! Code :
  if (coord.eq.'HO') then           ! horizontal coordinates
    s_2(1) = lambda * 180.d0 /pi
    s_2(2) = beta * 180.d0 /pi
    call rect(s_2,x_2)              ! To prepare the SUN_DISTANCE
    s_3(3) = sun_distance(x_2)      ! This is the sun distance
    return                          ! Nothing else there
    !
    !  Case : present day "true" coordinates, no transformation matrix, (R1) = (R3)
    !  considered as fixed coordinates in fixed frame, but formally maps
    !  are meaningless
  elseif (coord.eq.'DA') then
    s_3(1) = lambda
    s_3(2) = beta
    call rect (s_3, x_3)
    call matvec (x_3, trfm_23, x_2) ! needed to compute ...
    call transp (trfm_30, trfm_03)  ! The LSR correction.
    call matvec (x_3, trfm_03, x_0) ! needed for Horizon command
    !
    !  Case : galactic II coordinates, transformation (R1) to (R0)
  elseif (coord.eq.'GA') then       ! galactic coordinates
    s_1(1) = lambda
    s_1(2) = beta
    call rect (s_1, x_1)
    !  transformation matrix from galactic II to ecliptic (J2000.0)
    !  ### Euler angles could be computed once for all ...
    !  Computation in 3 steps
    psi = 33.d0 * degrad            ! well known Euler angles
    the = -62.6d0 * degrad          ! for transformation
    phi = -282.25d0 * degrad        ! matrix from
    call eulmat (psi,the,phi,mat1)  ! gal. (II) to equ. (1950.0)
    jfix=j2000+(1950.d0-2000.d0)*365.25d0  ! fixed equinox (julian days)
    epsm=oblimo (jfix)              ! mean obliquity at fixed equinox
    psi=0.d0                        ! Euler angles of transformation
    the=epsm
    phi=0.d0
    call eulmat (psi,the,phi,mat2)  ! equ. (1950.0) to ecl. (1950.0)
    call mulmat (mat1,mat2,mat3)    ! product MAT3 = MAT2 x MAT1
    !                               ! gal. (II) to ecl. (1950.0)
    call qprec (jfix,j2000,angles)  ! compute precession angles
    psi=angles(5)                   ! Euler angles
    the=angles(4)                   ! of transformation
    phi=-angles(6)-angles(5)        ! matrix from
    call eulmat (psi,the,phi,mat1)  ! ecl. (1950.0) to ecl. (2000.0)
    call mulmat (mat3,mat1,trfm_01) ! product TRFM01 = MAT1 x MAT3
    !                               ! gal. (II) to ecl. (1950.0)
    call matvec (x_1, trfm_01, x_0)
    call matvec (x_0, trfm_20, x_2)
    call matvec (x_0, trfm_30, x_3) ! needed for Horizon command
    call spher (x_3, s_3(1:2))
    !
    ! Case: mean equatorial coordinates at fixed equinox, transformation (R1) to (R0)
  elseif (coord.eq.'EQ') then
    s_1(1) = lambda
    s_1(2) = beta
    call rect (s_1, x_1)
    !  Transformation matrix from equatorial (JFIX) to ecliptic (J2000.0)
    jfix=j2000+(equinox-2000.0d0)*365.25d0   ! fixed equinox (julian days)
    epsm=oblimo (jfix)              ! mean obliquity at fixed equinox
    psi=0.d0                        ! Euler angles of transformation
    the=epsm
    phi=0.d0
    call eulmat (psi,the,phi,mat1)  ! compute matrix from (R1) to ecl (JFIX)
    call qprec (jfix,j2000,angles)  ! compute precession angles
    psi=angles(5)                   ! Euler angles of transformation
    the=angles(4)
    phi=-angles(6)-angles(5)
    call eulmat (psi,the,phi,mat2)  ! compute matrix from ecl (JFIX) to (R0)
    call mulmat (mat1,mat2,trfm_01) ! product TRFM01 = MAT2 x MAT1
    call matvec (x_1, trfm_01, x_0)
    call matvec (x_0, trfm_20, x_2)
    call matvec (x_0, trfm_30, x_3) ! needed for Horizon command
    call spher (x_3, s_3(1:2))
  else
    call astro_message(seve%e,'OBJECT','Unsupported coordinates')
    return
  endif
  call matvec (vg_0, trfm_20, v_2)
  !
  ! Check Sun Distance
  s_3(3) = sun_distance(x_2)        ! This is the sun distance
  !
  ! Doppler correction
  v_2(2) = v_2(2) - cos(pi*(lonlat(2))/180.0d0) * stv * (radius + altitude)
  dop = (v_2(1) * x_2(1) + v_2(2) * x_2(2) + v_2(3) * x_2(3))
  lsr = - (apx1 * x_0(1) + apx2 * x_0(2) + apx3 * x_0(3))
  !
  ! Aberration
  do i = 1, 3
    x_2(i) = x_2(i) - v_2(i) / light
  enddo
  call spher(x_2, s_2(1:2))
  s_2(1) = - s_2(1) * 180.d0/pi
  s_2(2) = s_2(2) * 180.d0/pi
  !
  ! XYZ
  call matvec (x_3, trfm_43, svec)
  !
  ! Compute parallactic angle
  ! parallactic angle
  ! x_3 is the source vector in eq coordinates (3)
  ! n_3 is the normal to the source meridian plane
  ! TRFM_23 goes from (3) to (2)
  ! n_2 is the normal to the source meridian plane, in horiz coords.(2)
  ! x_2 is the source vector in in horiz coords.
  ! y_2 is the intersection of the vertical plane of the source and
  ! the plane of the sky
  den = sqrt(x_3(1)**2+x_3(2)**2)
  n_3(1) = -x_3(2)/den
  n_3(2) = x_3(1)/den
  n_3(3) = 0
  call matvec (n_3, trfm_23, n_2)
  den = sqrt(x_2(1)**2+x_2(2)**2)
  y_2(1) = x_2(1)*x_2(3) / den
  y_2(2) = x_2(2)*x_2(3) / den
  y_2(3) = -den
  
!OLD -  parang = -(pi/2-acos(y_2(1)*n_2(1)+y_2(2)*n_2(2)+y_2(3)*n_2(3)))
! vector produc y_2xn_2
  vp_2(1) = y_2(2)*n_2(3)-y_2(3)*n_2(2)
  vp_2(2) = y_2(3)*n_2(1)-y_2(1)*n_2(3)
  vp_2(3) = y_2(1)*n_2(2)-y_2(2)*n_2(1)
! scalar product
  sp_2 = vp_2(1)*x_2(1)+vp_2(2)*x_2(2)+vp_2(3)*x_2(3)
!
  parang = -pi/2+sign(acos(y_2(1)*n_2(1)+y_2(2)*n_2(2)+y_2(3)*n_2(3)),sp_2)
  return
end subroutine do_object
!
function sun_distance (x_2)
  use ast_constant
  use ast_astro
  !---------------------------------------------------------------------
  ! @ private
  !*
  ! ASTRO -- Ephemeris Utility routine
  !
  !	Returns angular distance from Sun
  !
  !	X_2: apparent horizontal coordinates of the source  
  !	Xsun_2: apparent horizontal coordinates of the sun  
  !
  ! The angle between the 2 directions is derived from the scalar product 
  ! of the vectors in the horizontal coordinate frame:  
  ! Vobj.Vsun=(XOXSun+YOYSun+ZOZSun)=||Vobj||*||Vsun||*cos(SunObserverTarget)
  !!
  !---------------------------------------------------------------------
  real(kind=8) :: sun_distance        !! Sun distance in Degrees
  real(kind=8), intent(in) :: x_2(3)  !! Horizontal coordinates of source
  !
  sun_distance = 180.d0/pi*acos( (x_2(1)*xsun_2(1)+x_2(2)*xsun_2(2)+  &
    x_2(3)*xsun_2(3)) /sqrt(x_2(1)**2+x_2(2)**2+x_2(3)**2) /          &
    sqrt(xsun_2(1)**2+xsun_2(2)**2+xsun_2(3)**2) )
end function sun_distance

      SUBROUTINE DFMAT(X,Y,YP)
      REAL*8 X,Y,YP
      END
      SUBROUTINE FMAT(X,Y,YP)
      REAL*4 X,Y,YP
      END
      SUBROUTINE GVEC(x,g)
      real x,g
      end
      subroutine DGVEC(x,g)
      REAL*8 x,g
      end
      subroutine UVEC(x,u,g)
      real x,u,g
      end
      subroutine DUVEC(x,u,g)
      real*8 x,u,g
      end
      subroutine UIVP(x,u,up)
      real x,u,up
      end
      subroutine DUIVP(x,u,up)
      real*8 x,u,up
      end

subroutine uv_residual_comm(line,error)
  use gkernel_interfaces
  use clean_default
  use gbl_message
  use imager_interfaces, except_this => uv_residual_comm
  !---------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- Dispatch routine for command  
  !     UV_RESIDUAL [CLEAN|CCT|[Func1 ... FuncN] [/QUIET]
  !     [/WIDGET Nfunc] [/SAVE File] [/RESULT]
  !---------------------------------------------------------------------
  character(len=*), intent(inout) :: line !! Command line
  logical, intent(inout) :: error         !! Error flag
  !
  character(len=*), parameter :: comm='UV_RESIDUAL'
  character(len=12) :: key
  integer :: iarg, nk
  !
  if (last_resid.eq.' ') then
    call map_message(seve%e,comm,'No CLEAN or UV_FIT performed')
    error = .true. 
    return
  endif
  !
  key = last_resid
  call sic_ke(line,0,1,key,nk,.false.,error)
  !
  if (key.eq.'CCT'.or.key.eq.'CLEAN') then
    iarg = 2
    key = 'CCT'
  else if (key.eq.'FIT'.or.key.eq.'UV_FIT') then
    iarg = 2
    key = 'UV_FIT'
  else
    iarg = 1
    key = last_resid
  endif
  !  
  if (key.eq.'CCT') then
    call uv_residual_clean(line,comm,iarg,error)
  else
    call uvfit_residual_model(line,comm,iarg,error)
  endif
end subroutine uv_residual_comm
!
subroutine uv_residual_clean(line,task,iarg,error)
  use gkernel_interfaces
  use imager_interfaces, except_this=>uv_residual_clean
  use clean_def
  use clean_arrays
  use clean_types
  use clean_default
  use gbl_message
  !------------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER  - Support for command  
  !      UV_RESIDUAL [FIELDS List]
  !
  !   Remove all Clean Components from a UV Table
  !
  ! Input :
  !     a precessed UV table
  !     a list of Clean Components, in DCCT format
  !      i.e. (x,y,v)(iplane,icomponent)
  !     this organisation is not efficient, and one may need to switch to
  !           (x,y,v,)(icomponent,iplane)
  !     which is more easily transmitted
  ! Output :
  !     a precessed, rotated, shifted UV table, sorted in V,
  !     ordered in (U,V,W,D,T,iant,jant,nchan(real,imag,weig))
  !!
  !------------------------------------------------------------------------
  character(len=*), intent(inout) :: line !! Command line
  character(len=*), intent(in) :: task    !! Calling command
  integer, intent(in) :: iarg             !! Pointer to FIELDS argument list
  logical, intent(out) :: error           !! Error flag
  !
  ! Constants
  integer, parameter :: o_field=1
  character(len=*), parameter :: rname='UV_RESIDUAL'
  logical, parameter :: subtract = .true.
  !
  ! Local ---
  logical :: do_clean, do_resi 
  integer :: ier
  !
  ! Code ----
  error = .false.
  if (themap%nfields.ne.0) then
    call map_message(seve%w,rname,'UV data is a Mosaic - UNDER TESTS !!!')
    call uv_shift_mosaic(line,rname,error)
    if (error) return
  endif
  !
  call map_message(seve%i,rname,'Subtracting CLEAN components')
  call sic_delvariable('UV_RESIDUAL',.false.,error)
  !
  ! Do the job. 
  uv_resid_updated = .true.
  ! do_clean = .false.  means do not re-image with Clean components added, 
  ! and thus, do not store in duv_next, but rather in DUVF 
  ! ("Fit" or "Residual" buffer)
  do_clean = .false. 
  do_resi = .true.
  !
  ! Allocate the UVF area
  call gdf_copy_header(huv_current,huv_resid,error)
  if (allocated(duvf)) deallocate(duvf)
  allocate(duvf(huv_resid%gil%dim(1),huv_resid%gil%dim(2)),stat=ier)   !NEW!
  if (ier.ne.0) then
    call map_message(seve%e,task,'DUVF Memory allocation failure')
    error = .true.
    return
  endif
  !
  huv_resid%r2d => duv      ! Associate in input
  call sub_uv_residual(task,line,iarg,huv_resid,duv,duvf, &
    &   do_clean,do_resi,subtract,error)
  if (error) return
  !
  huv_resid%r2d => duvf ! Pointer association
  call sic_mapgildas('UV_RESIDUAL',huv_resid,error,duvf)
  !  
end subroutine uv_residual_clean
!
subroutine uv_model_comm_bis(line,error)
  use gkernel_interfaces
  use imager_interfaces, except_this=>uv_model_comm_bis
  use clean_def
  use clean_arrays
  use clean_types
  use clean_default
  use gbl_message
  !------------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER  - Support for command  
  !      UV_MODEL [FIELDS List]
  !
  !   Make a Model UV table for Clean Components and an input UV Table
  !
  ! Input :
  !     a precessed UV table
  !     a list of Clean Components, in DCCT format
  !      i.e. (x,y,v)(iplane,icomponent)
  !     this organisation is not efficient, and one may need to switch to
  !           (x,y,v,)(icomponent,iplane)
  !     which is more easily transmitted
  ! Output :
  !     a precessed, rotated, shifted UV table, sorted in V,
  !     ordered in (U,V,W,D,T,iant,jant,nchan(real,imag,weig))
  !!
  !------------------------------------------------------------------------
  character(len=*), intent(inout) :: line !! Command line
!  character(len=*), intent(in) :: task    !! Calling command
!  integer, intent(in) :: iarg             !! Pointer to FIELDS argument list
  logical, intent(out) :: error           !! Error flag
  !
  character(len=12) :: task    !! Calling command
  integer :: iarg             !! Pointer to FIELDS argument list

  ! Constants
  integer, parameter :: o_field=1
  character(len=*), parameter :: rname='UV_MODEL'
  logical, parameter :: subtract = .false.    ! Compute Model, not residual
  !
  ! Local ---
  type(gildas) :: htmp
  real, pointer :: duv_previous(:,:), duv_next(:,:)
  logical :: do_clean, do_resi 
  integer :: ier
  !
  task  = rname
  iarg = 1
  !
  ! Code ----
  error = .false.
  if (themap%nfields.ne.0) then
    call map_message(seve%w,rname,'UV data is a Mosaic - UNDER TESTS !!!')
    call uv_shift_mosaic(line,rname,error)
    if (error) return
  endif
  !
  call map_message(seve%i,rname,'Subtracting CLEAN components')
  nullify(duv_previous,duv_next)
  call sic_delvariable('UV_MODEL',.false.,error)
  !
  ! Temporary
  call gildas_null(htmp,'UVT')
  call gdf_copy_header(huv_current,htmp,error)  ! Save
  call gdf_copy_header(hself_self,huv_current,error) ! Test
  !
  call gildas_null(huv_model,type='UVT')
  if (allocated(duvm)) deallocate(duvm)
  call gdf_copy_header(huv_current,huv_model,error)
  allocate (duvm(huv_model%gil%dim(1),huv_model%gil%dim(2)),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'UV Model allocation error')
    call gdf_copy_header(htmp,huv_current,error)  ! Save
    error = .true.
    return
  endif
  !
  ! Do the job. 
  uv_resid_updated = .true.
  do_clean = .false. 
  do_resi = .true.
  !
  ! Buffer choice will depend on the MODEL option
  Print *,'Calling SUB_UV_RESIDUAL with DUVSELF and DUVM'
  call sub_uv_residual(task,line,iarg,huv_model,duvself,duvm, &
    &   do_clean,do_resi,subtract,error)
  if (error) then
    call gdf_copy_header(htmp,huv_current,error)  ! Restore
    error = .true.
    return
  endif
  call gdf_copy_header(htmp,huv_current,error)  ! Restore
  !
  huv_model%r2d => duvm
  call sic_mapgildas('UV_MODEL',huv_model,error,duvm)
  !  
end subroutine uv_model_comm_bis

subroutine bldprt (klire)
  use sic_interfaces, except_this=>bldprt
  use sic_structures
  use sic_interactions
  !---------------------------------------------------------------------
  ! @ private
  !  Modify the suffix of the prompt, suited for the current execution
  ! level and execution mode
  !---------------------------------------------------------------------
  integer(kind=4), intent(in) :: klire  ! Execution level
  !
  integer :: lglen
  !
  if (klire.eq.gprompt_nlire_old) return
  lverif = iverif(klire).gt.0            ! Current Verification status
  !
  gprompt(lgprompt_base+1:lgprompt_base+klire) = '____________________'
  lglen = lgprompt_base+min(klire,20)    ! Limit indent to 20 levels
  if (klire.le.1) then
    lgprompt = lglen+1
  elseif (klire.lt.10) then
    gprompt(lglen:) = char(klire+48)
    lgprompt = lglen+2
  else if (klire.lt.100) then
    write(gprompt(lglen:),'(I2)') klire
    lgprompt = lglen+3
  else
    write(gprompt(lglen:),'(I3)') klire
    lgprompt = lglen+4
  endif
  !
  if (compil.or.proced) then
    gprompt(lgprompt-1:) = ':'
  else
    gprompt(lgprompt-1:) = '>'
  endif
  !
  gprompt_nlire_old = klire
end subroutine bldprt
!
subroutine gprompt_set(newprompt)
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>gprompt_set
  use sic_interactions
  !---------------------------------------------------------------------
  ! @ public
  !  Modify the prompt, the base prompt, and the master prompt
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: newprompt
  ! Local
  character(len=gprompt_length) :: prefix
  integer(kind=4) :: ier
  !
  ! Get prompt prefix from logical value
  prefix = ''
  ier = sic_getlog('prompt_prefix',prefix)
  !
  gprompt_master = trim(prefix)//newprompt
  if (gprompt_master.eq.'')  gprompt_master = 'SIC'
  !
  call gprompt_base_set(gprompt_master)
  !
end subroutine gprompt_set
!
subroutine gprompt_base_set(newbase)
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>gprompt_base_set
  use sic_interactions
  !---------------------------------------------------------------------
  ! @ public
  !  Modify the prompt and the base prompt, do not modify the master
  ! prompt.
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: newbase
  !
  gprompt_base = newbase
  lgprompt_base = min(len_trim(gprompt_base),gprompt_length-5)  ! for suffix "_99> "
  !
  gprompt = gprompt_base(1:lgprompt_base)//'>'
  lgprompt = lgprompt_base+2
  !
end subroutine gprompt_base_set
!
subroutine gprompt_get(pr)
  use sic_interfaces, except_this=>gprompt_get
  use sic_interactions
  !---------------------------------------------------------------------
  ! @ private
  ! Get current prompt
  !---------------------------------------------------------------------
  character(len=*), intent(out) :: pr
  !
  pr = gprompt
  !
end subroutine gprompt_get

subroutine int2_to_real(int2,ni,array,ndata,nfill,bscal,bzero)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ no-interface
  !  Convert an integer(2) array (a la FITS, i.e., little-endian) into a
  ! real array using an offset and a scale factor.
  !---------------------------------------------------------------------
  integer(kind=2),           intent(in)    :: int2(*)       ! Input FITS buffer
  integer(kind=size_length), intent(in)    :: ni            ! Size of buffer
  integer(kind=size_length), intent(in)    :: ndata         ! Size of output array
  real(kind=4),              intent(out)   :: array(ndata)  ! Output array
  integer(kind=size_length), intent(inout) :: nfill         ! EOB pointer in output array
  real(kind=4),              intent(in)    :: bscal         ! Scaling
  real(kind=4),              intent(in)    :: bzero         ! Offset
  ! Local
  integer(kind=size_length) :: i
  !
#if defined(IEEE) || defined(VAX)
  call iei2ei_sl(int2,int2,ni)
#endif
  do i=1,ni
    nfill=nfill+1
    if (nfill.gt.ndata) return
    array(nfill) = bscal*int2(i) + bzero
  enddo
end subroutine int2_to_real
!
subroutine int4_to_real(int4,ni,array,ndata,nfill,bscal,bzero)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ no-interface
  !  Convert an integer(4) array (a la FITS, i.e., little-endian) into a
  ! real array using an offset and a scale factor.
  !---------------------------------------------------------------------
  integer(kind=4),           intent(in)    :: int4(*)       ! Input FITS buffer
  integer(kind=size_length), intent(in)    :: ni            ! Size of buffer
  integer(kind=size_length), intent(in)    :: ndata         ! Size of output array
  real(kind=4),              intent(out)   :: array(ndata)  ! Output array
  integer(kind=size_length), intent(inout) :: nfill         ! EOB pointer in output array
  real(kind=4),              intent(in)    :: bscal         ! Scaling
  real(kind=4),              intent(in)    :: bzero         ! Offset
  ! Local
  integer(kind=size_length) :: i
  !
#if defined(IEEE) || defined(VAX)
  call iei4ei_sl(int4,int4,ni)
#endif
  do i=1,ni
    nfill=nfill+1
    if(nfill.gt.ndata) return
    array(nfill) = bscal*int4(i) + bzero
  enddo
end subroutine int4_to_real
!
subroutine byte_to_real(int1,ni,array,ndata,nfill,bscal,bzero)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !  Convert a BYTE array into a real array using an offset and a scale
  ! factor.
  !---------------------------------------------------------------------
  integer(kind=1),           intent(in)    :: int1(*)       ! Input FITS buffer
  integer(kind=size_length), intent(in)    :: ni            ! Size of buffer
  integer(kind=size_length), intent(in)    :: ndata         ! Size of output array
  real(kind=4),              intent(out)   :: array(ndata)  ! Output array
  integer(kind=size_length), intent(inout) :: nfill         ! EOB pointer in output array
  real(kind=4),              intent(in)    :: bscal         ! Scaling
  real(kind=4),              intent(in)    :: bzero         ! Offset
  ! Local
  integer(kind=4) :: entier
  integer(kind=size_length) :: i
  !
  do i=1,ni
    nfill=nfill+1
    if(nfill.gt.ndata) return
    entier = int1(i)
    if (entier.lt.0) entier=entier+256
    array(nfill) = bscal*entier + bzero
  enddo
end subroutine byte_to_real
!
subroutine real_to_int2(int2,ni,array,ndata,nfill,bscal,bzero,bval,eval)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ no-interface
  !  Convert a real array into an integer(2) array (a la FITS, i.e.
  ! little-endian) using an offset and a scale factor.
  !---------------------------------------------------------------------
  integer(kind=2),      intent(out)   :: int2(*)       ! Output FITS buffer
  integer(kind=4),      intent(in)    :: ni            ! Size of buffer
  integer(size_length), intent(in)    :: ndata         ! Size of input array
  real(kind=4),         intent(in)    :: array(ndata)  ! Input array
  integer(size_length), intent(inout) :: nfill         ! EOB pointer in input array
  real(kind=4),         intent(in)    :: bscal         ! Scaling
  real(kind=4),         intent(in)    :: bzero         ! Offset
  real(kind=4),         intent(in)    :: bval          ! Blanking value
  real(kind=4),         intent(in)    :: eval          ! Blanking tolerance
  ! Local
  integer(kind=4) :: i
  !
  if (eval.ge.0.0) then
    do i=1,ni
      nfill=nfill+1
      if (nfill.gt.ndata) then
        int2(i) = 0  ! Zero padding (Wells et al, A&A Sup. Ser 44, P.364, line 47)
      elseif (abs(array(nfill)-bval).gt.eval) then
        int2(i) = nint ((array(nfill)-bzero)/bscal)
      else
        int2(i) = 32767
      endif
    enddo
  else
    do i=1,ni
      nfill=nfill+1
      if (nfill.gt.ndata) then
        int2(i) = 0  ! Zero padding (Wells et al, A&A Sup. Ser 44, P.364, line 47)
      else
        int2(i) = nint ((array(nfill)-bzero)/bscal)
      endif
    enddo
  endif
#if defined(IEEE) || defined(VAX)
  call iei2ei(int2,int2,ni)
#endif
end subroutine real_to_int2
!
subroutine real_to_int4(int4,ni,array,ndata,nfill,bscal,bzero,bval,eval)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ no-interface
  !  Convert a real array into an integer(4) array (a la FITS, i.e.,
  ! little-endian) using an offset and a scale factor.
  !---------------------------------------------------------------------
  integer(kind=4),      intent(out)   :: int4(*)       ! Output FITS buffer
  integer(kind=4),      intent(in)    :: ni            ! Size of buffer
  integer(size_length), intent(in)    :: ndata         ! Size of input array
  real(kind=4),         intent(in)    :: array(ndata)  ! Input array
  integer(size_length), intent(inout) :: nfill         ! EOB pointer in input array
  real(kind=4),         intent(in)    :: bscal         ! Scaling
  real(kind=4),         intent(in)    :: bzero         ! Offset
  real(kind=4),         intent(in)    :: bval          ! Blanking value
  real(kind=4),         intent(in)    :: eval          ! Blanking tolerance
  ! Local
  integer(kind=4) :: i
  !
  if (eval.ge.0.0) then
    do i=1,ni
      nfill=nfill+1
      if (nfill.gt.ndata) then
        int4(i) = 0  ! Zero padding (Wells et al, A&A Sup. Ser 44, P.364, line 47)
      elseif (abs(array(nfill)-bval).gt.eval) then
        int4(i) = nint ((array(nfill)-bzero)/bscal)
      else
        int4(i) = 2147483647
      endif
    enddo
  else
    do i=1,ni
      nfill=nfill+1
      if (nfill.gt.ndata) then
        int4(i) = 0  ! Zero padding (Wells et al, A&A Sup. Ser 44, P.364, line 47)
      else
        int4(i) = nint ((array(nfill)-bzero)/bscal)
      endif
    enddo
  endif
#if defined(IEEE) || defined(VAX)
  call iei4ei(int4,int4,ni)
#endif
end subroutine real_to_int4
!
subroutine real_to_real4(real4,nr,array,ndata,nfill,bval,eval)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ no-interface
  !  Convert a real array into an real(4) array (a la FITS, i.e.,
  ! little-endian).
  !---------------------------------------------------------------------
  real(kind=4),         intent(out)   :: real4(*)      ! Output FITS buffer
  integer(kind=4),      intent(in)    :: nr            ! Size of buffer
  integer(size_length), intent(in)    :: ndata         ! Size of input array
  real(kind=4),         intent(in)    :: array(ndata)  ! Input array
  integer(size_length), intent(inout) :: nfill         ! EOB pointer in input array
  real(kind=4),         intent(in)    :: bval          ! Blanking value
  real(kind=4),         intent(in)    :: eval          ! Blanking tolerance
  ! Global
  include 'gbl_nan.inc'
  ! Local
  integer(kind=4) :: i
  !
  if (eval.ge.0.0) then
    do i=1,nr
      nfill=nfill+1
      if (nfill.gt.ndata) then
        real4(i) = 0.0  ! Zero padding (Wells et al, A&A Sup. Ser 44, P.364, line 47)
      elseif (abs(array(nfill)-bval).gt.eval) then
        real4(i) = array(nfill)
      else
        real4(i) = s_nan
      endif
    enddo
  else
    do i=1,nr
      nfill=nfill+1
      if (nfill.gt.ndata) then
        real4(i) = 0.0  ! Zero padding (Wells et al, A&A Sup. Ser 44, P.364, line 47)
      else
        real4(i) = array(nfill)
      endif
    enddo
  endif
#if defined(IEEE) || defined(VAX)
  call ier4ei(real4,real4,nr)
#endif
end subroutine real_to_real4
!
subroutine real_to_real8(real8,nr,array,ndata,nfill,bval,eval)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ no-interface
  !  Convert a real array into an real(8) array (a la FITS, i.e.,
  ! little-endian).
  !---------------------------------------------------------------------
  real(kind=8),         intent(out)   :: real8(*)      ! Output FITS buffer
  integer(kind=4),      intent(in)    :: nr            ! Size of buffer
  integer(size_length), intent(in)    :: ndata         ! Size of input array
  real(kind=4),         intent(in)    :: array(ndata)  ! Input array
  integer(size_length), intent(inout) :: nfill         ! EOB pointer in input array
  real(kind=4),         intent(in)    :: bval          ! Blanking value
  real(kind=4),         intent(in)    :: eval          ! Blanking tolerance
  ! Global
  include 'gbl_nan.inc'
  ! Local
  integer(kind=4) :: i
  !
  if (eval.ge.0.0) then
    do i=1,nr
      nfill=nfill+1
      if (nfill.gt.ndata) then
        real8(i) = 0.d0  ! Zero padding (Wells et al, A&A Sup. Ser 44, P.364, line 47)
      elseif (abs(array(nfill)-bval).gt.eval) then
        real8(i) = array(nfill)
      else
        real8(i) = d_nan
      endif
    enddo
  else
    do i=1,nr
      nfill=nfill+1
      if (nfill.gt.ndata) then
        real8(i) = 0.d0  ! Zero padding (Wells et al, A&A Sup. Ser 44, P.364, line 47)
      else
        real8(i) = array(nfill)
      endif
    enddo
  endif
#if defined(IEEE) || defined(VAX)
  call ier8ei(real8,real8,nr)
#endif
end subroutine real_to_real8

 
subroutine sub_uv_stitch(n_in, table_in, table_out, &
     weight, factor, mode, spindex, freqref, error)
  use gildas_def
  use gkernel_interfaces
  use image_def
  use gbl_message
  use clean_def
  use clean_default
  use imager_interfaces, except_this=>sub_uv_stitch
  !---------------------------------------------------------------------
  ! @ private
  !
  ! IMAGER -- Merge an arbitray number of UV tables in STITCHING mpde
  !
  ! 
  ! Input :  names of several UV tables  
  ! Output :  one new UV table
  !
  !   UV tables must have the same UV coverage ---
  ! 
  ! UV coverage is set as  
  !   - the Union of the available ones, with data flagged 
  !   if not available, leading to frequency dependent beams.
  ! or  
  !   - the Intersection of the available ones, losing data
  !   but ensuring only one beam for all (except for the frequency
  !   dependence
  !
  ! The Intersect mode is obtained by flagging data that has at least
  ! one channel flagged ...
  !
  ! This is a 3 or 4 pass process. 
  ! - Pass 1: Headers only, build the list of frequency channels
  ! - Pass 2: build required Time - Baseline list.
  ! - Pass 3: Stitch (per file) the spectral visibilities
  ! - Pass 4: Flag data if needed
  !
  ! For the time being, Pass 2 uses the Time - Baseline of the First
  ! UV table.
  !!
  !---------------------------------------------------------------------
  integer, intent(in) :: n_in                 !! Number of input tables
  character(len=*), intent(in) :: table_out   !! Output Table name
  character(len=*), intent(in) :: table_in(*) !! Other tables names
  real, intent(in)  :: weight(*)              !! Weights
  real, intent(in)  :: factor(*)              !! Scale factors
  integer, intent(in)  :: mode                !! Merging mode
  logical, intent(out) :: error               !! Error flag
  real, intent(in) :: spindex                 !! Spectral index
  real, intent(in) :: freqref                 !! Reference frequency
  !
  ! Constants
  character(len=*), parameter :: rname='UV_MERGE'
  integer, parameter :: code_line=0
  integer, parameter :: code_cont=1
  integer, parameter :: code_stack=2
  integer, parameter :: code_concat=-1
  integer, parameter :: code_stitch=-2
  integer, parameter :: code_inter=-3
  real(kind=8), parameter :: pi=3.14159265358979323846d0
  real(kind=8), parameter :: f_to_k = 2.d0*pi/299792458.d-6
  !
  ! Local ---
  character(len=256) :: table_ref   ! Reference Table name
  type(gildas) :: in,inref,out,horigin
  integer, allocatable :: iwork(:,:)
  real(4), allocatable :: rwork(:,:)
  real :: scale_uv(3)
  real(8) :: rfreq
  real :: fact, weig
  integer :: nblock, ier, im
  character(len=80) :: mess
  integer :: code
  integer(kind=size_length) :: in_gil_dim1,in_gil_dim2
  !
!  real(8) :: vinf, vsup, vmin, vmax, vres
  integer :: im_first
  real :: basemin, basemax
  integer :: multiplier, sever
  !
  integer, allocatable :: cmin(:), cmax(:)
  real(8), pointer :: afreq(:)
  real(8), allocatable :: the_freqs(:), tfreq(:)
  integer :: ifi, nfi, nfreq, kfi, kla, jfi, jla, mblock, ib, iv, lv
  real :: oinc, iinc
  real, parameter :: spec_tol=1E-4
  logical :: notrail=.false.    ! TO BE DONE
  integer :: ignore=0 
  integer :: astoke
  !
  ! Code ----
  !  
  error = .true.
  if (n_in.eq.0) return
  if (len_trim(table_out).eq.0) return
  !
  table_ref = table_in(1)
  if (len_trim(table_ref).eq.0) return
  error = .false.
  !
  ! Input file TABLE_REF  (INREF) is the reference one
  call gildas_null(inref, type = 'UVT')
  call gildas_null(in, type = 'UVT')
  call gildas_null(out, type = 'UVT')
  call gildas_null(horigin, type = 'UVT')
  !     
  multiplier = 1 ! Number of output visibilities per input one
  scale_uv = 1.0 ! UV scale by default
  allocate(cmin(n_in),cmax(n_in),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'Memory allocation error')
    error = .true.
    return
  endif
  !
  basemin = 1E38
  basemax = 0.0
  !
  ! Dummy initialization to avoid messages
  in_gil_dim1 = 1
  in_gil_dim2 = 1
  astoke = 0
  rfreq = 1.d0
  !
  im_first = 0
  if (mode.ne.code_stitch) then
    !
    ! Pure Stitching -
    ! All UV tables must have the same Time-Baseline ordering
    !   Channels are "glued" together, using a Random Frequency axis
    !
    call map_message(seve%e,rname,'Invalid mode (expected STITCH)')
    error = .true.
    return
  endif
  !
  ! Setup the Outer UV table from the First data file
  call gdf_read_gildas (horigin, table_in(1), '.uvt', error, data=.false.)
  call gdf_copy_header (horigin, inref, error)
  call gdf_close_image (horigin, error)
  !
  ! Build list of frequencies and verify spectral resolution, except
  ! for continuum stitch mode
  nfi = 0
  allocate(the_freqs(1))  ! Avoid allocation warning message
  do im=1,n_in    ! This loop must execute sequentially
    call gdf_read_gildas (horigin, table_in(im), '.uvt', error, data=.false.)
    if (error) then
      write(mess,'(A,I0)') 'Cannot read input UV table #',im
      call map_message(seve%e,rname,mess)
      return
    endif
    oinc = abs(horigin%gil%inc(1))
    iinc = abs(inref%gil%inc(1)) 
    if (abs(oinc-iinc).gt. spec_tol*iinc) then
      call map_message(seve%w,rname,'Spectral resolution do not match')
    endif
    !
    if (horigin%gil%nfreq.ne.0) then
      ! Random Frequency axis
      nfreq = horigin%gil%nfreq
      afreq => horigin%gil%freqs(1:nfreq)
    else
      nfreq = horigin%gil%nchan
      allocate(afreq(nfreq))
      do ifi=1,nfreq
        afreq(ifi) = (ifi-horigin%gil%convert(1,1))*horigin%gil%convert(3,1) + horigin%gil%convert(2,1)
      enddo
    endif
    if (nfi.eq.0) then
      deallocate(the_freqs) 
      allocate(the_freqs(nfreq))
      nfi = nfreq
      the_freqs(:) = afreq
      cmin(im) = 1
    else
      allocate(tfreq(nfi))
      tfreq(:) = the_freqs(:)
      deallocate(the_freqs)
      allocate(the_freqs(nfi+nfreq))
      the_freqs(1:nfi) = tfreq
      cmin(im) = nfi+1
      the_freqs(nfi+1:) = afreq
      nfi = nfi+nfreq
      deallocate(tfreq)
    endif
    cmax(im) = nfi
    if (abs(horigin%gil%order).eq.abs(code_stok_chan)) then
      inref%gil%order = horigin%gil%order
      astoke = horigin%gil%stokes(1) 
    else
      inref%gil%order = horigin%gil%order
      astoke = horigin%gil%order
    endif
    call gdf_close_image (horigin,error)
    !
  enddo
  !
  ! Compute the number of channels
  inref%gil%nstokes = 0
  if (associated(inref%gil%stokes)) then
    call map_message(seve%w,rname,'Nullifying Stokes ')
  endif
  inref%gil%nchan = nfi
  inref%gil%nfreq = nfi
  allocate(inref%gil%freqs(nfi),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'Memory allocation error')
    error = .true.
    return
  endif
  inref%gil%freqs(1:nfi) = the_freqs(1:nfi)
  !
  inref%gil%dim(1) = horigin%gil%dim(1) + 3*(inref%gil%nchan-horigin%gil%nchan)
  in_gil_dim1 = inref%gil%dim(1)  
  in_gil_dim2 = inref%gil%dim(2)  
  !
  im_first = 0
  inref%gil%freq = sum(inref%gil%freqs) / nfi
  !
  ! Set the Stokes parameters
  if (associated(inref%gil%stokes)) then
    deallocate(inref%gil%stokes,stat=ier)
    Print *,'Stokes deallocation error ',ier
  endif
  nullify(inref%gil%stokes)
  allocate(inref%gil%stokes(inref%gil%nfreq),stat=ier)
  inref%gil%stokes = astoke
  inref%gil%nstokes = 1
  ! Do not forget trailing columns
  call gdf_uv_shift_columns(horigin,inref)
  call gdf_setuv(inref,error)
  call gdf_copy_header (inref, out, error)
  call sic_parse_file(table_out,' ','.uvt',out%file)
  !
  error = .false.
  !
  ! Loop over tables to be merged for further verifications
  do im=1,n_in    ! This loop must execute sequentially
    call gdf_read_gildas (horigin, table_in(im), '.uvt', error, data=.false.)
    if (error) then
      write(mess,'(A,I0)') 'Cannot read input UV table # ',im
      call map_message(seve%e,rname,mess)
      return
    endif
    call gdf_close_image(horigin,error)
    !
    ! Verify number of visibilities match
    if (horigin%gil%nvisi.ne.out%gil%nvisi) then
      write(mess,'(A,I0,A,I0)') 'Visibilities mismatch: Out ',out%gil%nvisi, &
        & ', In ',horigin%gil%nvisi
      call map_message(seve%e,rname,trim(mess)//' '//trim(table_in(im)))
      error = .true.
      return
    endif
    !
    ! Verify Baseline lengths are present
!    if (horigin%gil%basemax.le.horigin%gil%basemin) then
!      call map_message(seve%e,rname,'Missing baseline lengths range in file '//trim(table_in(im)))
!      call map_message(seve%i,rname,'Use command HEADER '//trim(table_in(im))//' /EXTREMA to set them')
!      error = .true.
!      return
!    endif
    !
    call gdf_copy_header(horigin,in,error)
    !
    ! Verify Proper Motion & Epoch match
    if ((in%gil%mura.ne.out%gil%mura).or.(in%gil%mudec.ne.out%gil%mudec)) then
      call map_message(seve%e,rname,'Proper Motions do not match')
      error = .true.
    else if ((in%gil%mura.ne.0.).or.(in%gil%mudec.ne.0.)) then
      if (in%gil%epoc.ne.out%gil%epoc) then
        call map_message(seve%e,rname,'Proper Motions match, but Epochs do not match')
        error = .true.
      endif
    endif
    if (error) return
    !
    ! Verify if trailing columns do match
    call gdf_uvmatch_codes(inref,in,code,ignore)
    if (code.eq.3) then
      ! Column # 3 has a mismatch - Make sure the Ref is now SCAN
      inref%gil%column_pointer(code_uvt_w) = 0
      inref%gil%column_size(code_uvt_w) = 0
      inref%gil%column_pointer(code_uvt_scan) = 3
      inref%gil%column_size(code_uvt_scan) = 1
    else if (code.lt.0) then
      if (notrail) then
        sever = seve%w
        error = .false.
      else
        sever = seve%e
        error = .true. 
      endif
      if (code.eq.-1) then
        call map_message(sever,rname,'Leading columns do not match')
      else if (code.eq.-2) then
        call map_message(sever,rname,'Trailing columns do not match')
        Print *,'Ntrail out ',inref%gil%ntrail,' in ',in%gil%ntrail
      else
        call map_message(sever,rname,'Leading columns do not match')
      endif
      if (error) then
        call map_message(seve%e,rname,'Second pass verification error')
        return
      endif
    endif
    !
  enddo
  !
  ! Finished preparatory work, and create the OUT table
  call map_message(seve%i,rname,'Creating UV table '//trim(out%file))
  call gdf_create_image(out, error)
  if (error) then
    call map_message(seve%e,rname,'Cannot create output UV table')
    return
  endif
  !
  ! Define blocking factor on input file
  call gdf_nitems('SPACE_GILDAS',nblock,in_gil_dim1) ! Visibilities at once
  nblock = min(nblock,in_gil_dim2)
  allocate (out%r2d(out%gil%dim(1),nblock*multiplier), stat=ier)
  if (ier.ne.0) then
    write(mess,*) 'Memory allocation error OUT ',out%gil%dim(1), nblock, multiplier
    call map_message(seve%e,rname,mess)
    call gdf_close_image(out, error)
    error = .true.
    return
  endif
  !
  if (out%gil%nchan.eq.1 .and. in%gil%nchan.eq.1) then
    call map_message(seve%i,rname,'Merging continuum tables')
  else if (mode.eq.code_cont) then
    call map_message(seve%i,rname,'Merging line tables in continuum mode')  
  else 
    allocate (iwork(2,out%gil%nchan), rwork(4,out%gil%nchan), stat=ier)
    if (ier.ne.0) then
      write(mess,*) 'Memory allocation error WORK ',6,out%gil%nchan
      call map_message(seve%e,rname,mess)
      call gdf_close_image(out, error)
      error = .true.
      return
    endif
    call map_message(seve%i,rname,'Merging line tables')
  endif
  !
  ! Append IN channels to OUT with rescaling when needed
  out%trc = 0
  out%blc = 0 
  !
  ! Allocate the appropriate work-space
  allocate (out%r2d(out%gil%dim(1),nblock),stat=ier)
  if (ier.ne.0) then
    write(mess,*) 'Memory allocation error OUT',out%gil%dim(1), nblock
    call map_message(seve%e,rname,mess)
    goto 98
  endif
  !
  mblock = out%gil%dim(2)/nblock
  if (mblock*nblock.ne.out%gil%dim(2)) mblock = mblock+1
  in%blc = 0
  in%trc = 0
  !
  iv = 1
  do ib = 1,mblock
    lv = min(out%gil%nvisi,iv+nblock-1)
    if (mblock.gt.1) then
      write(mess,'(A,I0,A,I0,1X,I0)') 'Handling block ',ib,' Visi ',iv,lv
      call map_message(seve%i,rname,mess)
    endif
    out%blc(2) = iv
    out%trc(2) = lv 
    write(mess,*) iv,' / ',out%gil%dim(2),min(100,nint((iv+nblock-1)*100./out%gil%dim(2))),' %'
    call map_message(seve%i,rname,mess)
    !
    do im = 1,n_in
      mess = 'Reading '//trim(table_in(im))
      call map_message(seve%i,rname,mess)
      call gdf_read_gildas (in, table_in(im), '.uvt', error, data=.false.)
      if (error) then
        write(mess,*) 'Cannot read input UV table #',im
        call map_message(seve%e,rname,mess)
        goto 98
      endif
      !
      allocate (in%r2d(in%gil%dim(1),nblock), stat=ier)
      if (ier.ne.0) then
        write(mess,*) 'Memory allocation error IN ',in%gil%dim(1), nblock
        call map_message(seve%e,rname,mess)
        goto 98
      endif
      !
      fact = factor(im)
      weig = weight(im)
      write(mess,'(A,F8.2,A,F8.2,A,F8.4)') 'Factors: Flux ',fact, &
        & ', Weight ',weig
      call map_message(seve%i,rname,mess)
      !
      in%blc(2) = iv
      in%trc(2) = lv 
      !
      ! read Block on current input file
      if (sic_ctrlc()) goto 98
      !
      call gdf_read_data(in,in%r2d,error)
      if (error) goto 98
      !
      ! Place it at appropriate channel range
      kfi = out%gil%nlead+3*(cmin(im)-1)+1
      kla = out%gil%nlead+3*cmax(im)
      jfi = in%gil%nlead+1
      jla = in%gil%nlead+3*in%gil%nchan
      !
      ! Scale factors and Weight factors should be applied - to be done
      out%r2d(kfi:kla,1:lv-iv+1) = in%r2d(jfi:jla,1:lv-iv+1)
      !
      if (im.eq.1) then
        ! Set leading column
        out%r2d(1:out%gil%nlead,1:lv-iv+1) = in%r2d(1:in%gil%nlead,1:lv-iv+1)
        if (in%gil%ntrail.gt.0) then
          ! Set trailing columns
          kfi = out%gil%lcol+1
          kla = out%gil%dim(1)
          jfi = in%gil%lcol+1
          jla = in%gil%dim(1)
          out%r2d(kfi:kla,1:lv-iv+1) = in%r2d(jfi:jla,1:lv-iv+1)
        endif
      endif
      !
      call gdf_close_image(in,error)
      !
    enddo     ! Block loop
    !
    call gdf_write_data(out,out%r2d,error)
    if (error) goto 98
    ! Increment position
    iv = lv+1
  enddo       ! Block loop
  !
  call gdf_close_image(out,error)
  deallocate(out%r2d)
  return
  !
  ! Error handling
98      continue
  call gdf_close_image(out, error)
  call gdf_close_image(in, error)
  error = .true.
  return
end subroutine sub_uv_stitch
!

!-----------------------------------------------------------------------
! Drawing routines specific to the Windows protocol (p_x)
!-----------------------------------------------------------------------
subroutine gti_xforceupdate(output)
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  ! Specifique au protocole X
  !---------------------------------------------------------------------
  type(gt_display) :: output  ! Output instance
  output%x%update_status = 2
end subroutine gti_xforceupdate
!
subroutine gti_ximage(output,image)
  use gtv_interfaces, except_this=>gti_ximage
  use gildas_def
  use gtv_bitmap
  use gtv_buffers
  use gtv_plot
  use gtv_tree
  use gtv_types
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! Specifique au protocole X. Version MAC (support de PICT) plus bas
  !---------------------------------------------------------------------
  type(gt_display), intent(inout) :: output  ! Input gt_display
  type(gt_image),   target        :: image   ! Image instance
  ! Global
  include 'gbl_memory.inc'
  ! Local
  real(kind=4) :: clip(4),trans(4),rmin
  integer(kind=4) :: window(4),ier,wnx,wny
  logical :: recompute,visible
  type(gt_lut), pointer :: lut
  type(gt_bitmap), pointer :: xbitmap,xbtmp
  !
  if (.not.associated(image%r%values))  return  ! Image has been cleaned
  !
  ! Test ridiculous scaling mode:
  rmin = min(image%r%cuts(1),image%r%cuts(2))
  if (rmin.le.0.0 .and. image%scaling.eq.scale_log) then
    call gtv_message(seve%e,'GTI_BITMAP','LowCut is negative!')
    return
  endif
  !
  ! Check the clipping box
  call clip_image(output,  &
    image%r%taille(1),  &
    image%r%taille(2),  &
    image%conv,         &
    image%position,     &
    image%limits,       &
    .true.,             &  ! Always resample to device pixels
    1.0,                &  ! Resampling factor (1 = no extra factor)
    visible,clip,window,trans)
  if (.not.visible)  return
  !
  ! if we are here because of a screen that needs update, we know
  ! that the image pixels have been saved. Else we create the image pixels
  wnx=window(1)
  wny=window(2)
  !
  if (.not.image%isrgb) then
    ! Image is indexed: which LUT use?
    if (associated(image%lut)) then
      lut => image%lut  ! Custom LUT
      if (lut%xlut.eq.0)  &
        call gti_lut(output,lut)  ! Load this LUT, since it is not yet
    else
      lut => gbl_colormap  ! Global LUT
    endif
  endif
  !
  ! Check if we already have a bitmap for this image
  xbitmap => null()
  xbtmp => output%x%bitmap_first
  do while (associated(xbtmp))
    if (associated(xbtmp%image,image)) then
      xbitmap => xbtmp
      exit
    endif
    xbtmp => xbtmp%next
  enddo
  !
  if (associated(xbitmap)) then
    recompute = xbitmap%size(1).ne.wnx .or. xbitmap%size(2).ne.wny .or. &
                any(xbitmap%trans.ne.trans)
  else
    allocate(xbitmap)
    xbitmap%next => null()
    xbitmap%image => image
    xbitmap%irvalues => null()
    xbitmap%igvalues => null()
    xbitmap%ibvalues => null()
    !
    ! Set up the list
    if (associated(output%x%bitmap_first)) then
      output%x%bitmap_last%next => xbitmap
    else
      output%x%bitmap_first => xbitmap
    endif
    output%x%bitmap_last => xbitmap
    !
    recompute = .true.
  endif
  !
  ! No need to recompute if the position on the window changes. Just
  ! update the position.
  xbitmap%position(1) = window(3)
  xbitmap%position(2) = window(4)
  !
  ! Do we need to recompute the bitmap?
  if (output%x%update_status.eq.2 .or. recompute) then
    ! Deallocate the previous resampled image
    if (associated(xbitmap%irvalues))  deallocate(xbitmap%irvalues)
    if (associated(xbitmap%igvalues))  deallocate(xbitmap%igvalues)
    if (associated(xbitmap%ibvalues))  deallocate(xbitmap%ibvalues)
    !
    ! Allocate the new resampled image
    xbitmap%size(1) = window(1)
    xbitmap%size(2) = window(2)
    xbitmap%trans = trans
    if (image%isrgb) then
      allocate(xbitmap%irvalues(wnx,wny),  &
               xbitmap%igvalues(wnx,wny),  &
               xbitmap%ibvalues(wnx,wny),stat=ier)
    else
      allocate(xbitmap%irvalues(wnx,wny),stat=ier)
    endif
    if (ier.ne.0) then
      call gtv_message(seve%e,'GTI_BITMAP','Memory allocation failure')
      return
    endif
    call gti_bitmap(image,output,xbitmap)
    !
  endif
  !
  ! Display it in X_Window
  if (image%isrgb) then
    call x_draw_rgb(output%x%graph_env,         &  ! The window
      xbitmap%irvalues,                         &  ! The R bitmap
      xbitmap%igvalues,                         &  ! The G bitmap
      xbitmap%ibvalues,                         &  ! The B bitmap
      xbitmap%position(1),xbitmap%position(2),  &  ! Its position
      xbitmap%size(1),xbitmap%size(2))             ! Its size
  else
    call x_affiche_image(output%x%graph_env,    &  ! The window
      xbitmap%irvalues,                         &  ! The bitmap
      xbitmap%position(1),xbitmap%position(2),  &  ! Its position
      xbitmap%size(1),xbitmap%size(2),          &  ! Its size
      lut%xlut)                                    ! The LUT to use
  endif
  !
end subroutine gti_ximage

*DECK AAAAAA
      SUBROUTINE AAAAAA (VER)
C***BEGIN PROLOGUE  AAAAAA
C***PURPOSE  SLATEC Common Mathematical Library disclaimer and version.
C***LIBRARY   SLATEC
C***CATEGORY  Z
C***TYPE      ALL (AAAAAA-A)
C***KEYWORDS  DISCLAIMER, DOCUMENTATION, VERSION
C***AUTHOR  SLATEC Common Mathematical Library Committee
C***DESCRIPTION
C
C   The SLATEC Common Mathematical Library is issued by the following
C
C           Air Force Weapons Laboratory, Albuquerque
C           Lawrence Livermore National Laboratory, Livermore
C           Los Alamos National Laboratory, Los Alamos
C           National Institute of Standards and Technology, Washington
C           National Energy Research Supercomputer Center, Livermore
C           Oak Ridge National Laboratory, Oak Ridge
C           Sandia National Laboratories, Albuquerque
C           Sandia National Laboratories, Livermore
C
C   All questions concerning the distribution of the library should be
C   directed to the NATIONAL ENERGY SOFTWARE CENTER, 9700 Cass Ave.,
C   Argonne, Illinois  60439, and not to the authors of the subprograms.
C
C                    * * * * * Notice * * * * *
C
C   This material was prepared as an account of work sponsored by the
C   United States Government.  Neither the United States, nor the
C   Department of Energy, nor the Department of Defense, nor any of
C   their employees, nor any of their contractors, subcontractors, or
C   their employees, makes any warranty, expressed or implied, or
C   assumes any legal liability or responsibility for the accuracy,
C   completeness, or usefulness of any information, apparatus, product,
C   or process disclosed, or represents that its use would not infringe
C   upon privately owned rights.
C
C *Usage:
C
C        CHARACTER * 16 VER
C
C        CALL AAAAAA (VER)
C
C *Arguments:
C
C     VER:OUT   will contain the version number of the SLATEC CML.
C
C *Description:
C
C   This routine contains the SLATEC Common Mathematical Library
C   disclaimer and can be used to return the library version number.
C
C***REFERENCES  Kirby W. Fong, Thomas H. Jefferson, Tokihiko Suyehiro
C                 and Lee Walton, Guide to the SLATEC Common Mathema-
C                 tical Library, April 10, 1990.
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   800424  DATE WRITTEN
C   890414  REVISION DATE from Version 3.2
C   890713  Routine modified to return version number.  (WRB)
C   900330  Prologue converted to Version 4.0 format.  (BAB)
C   920501  Reformatted the REFERENCES section.  (WRB)
C   921215  Updated for Version 4.0.  (WRB)
C   930701  Updated for Version 4.1.  (WRB)
C***END PROLOGUE  AAAAAA
      CHARACTER * (*) VER
C***FIRST EXECUTABLE STATEMENT  AAAAAA
      VER = ' 4.1'
      RETURN
      END
*DECK ACOSH
      FUNCTION ACOSH (X)
C***BEGIN PROLOGUE  ACOSH
C***PURPOSE  Compute the arc hyperbolic cosine.
C***LIBRARY   SLATEC (FNLIB)
C***CATEGORY  C4C
C***TYPE      SINGLE PRECISION (ACOSH-S, DACOSH-D, CACOSH-C)
C***KEYWORDS  ACOSH, ARC HYPERBOLIC COSINE, ELEMENTARY FUNCTIONS, FNLIB,
C             INVERSE HYPERBOLIC COSINE
C***AUTHOR  Fullerton, W., (LANL)
C***DESCRIPTION
C
C ACOSH(X) computes the arc hyperbolic cosine of X.
C
C***REFERENCES  (NONE)
C***ROUTINES CALLED  R1MACH, XERMSG
C***REVISION HISTORY  (YYMMDD)
C   770401  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890531  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900315  CALLs to XERROR changed to CALLs to XERMSG.  (THJ)
C   900326  Removed duplicate information from DESCRIPTION section.
C           (WRB)
C***END PROLOGUE  ACOSH
      SAVE ALN2,XMAX
      DATA ALN2 / 0.6931471805 5994530942E0/
      DATA XMAX /0./
C***FIRST EXECUTABLE STATEMENT  ACOSH
      IF (XMAX.EQ.0.) XMAX = 1.0/SQRT(R1MACH(3))
C
      IF (X .LT. 1.0) CALL XERMSG ('SLATEC', 'ACOSH', 'X LESS THAN 1',
     +   1, 2)
C
      IF (X.LT.XMAX) ACOSH = LOG (X + SQRT(X*X-1.0))
      IF (X.GE.XMAX) ACOSH = ALN2 + LOG(X)
C
      RETURN
      END
*DECK AI
      FUNCTION AI (X)
C***BEGIN PROLOGUE  AI
C***PURPOSE  Evaluate the Airy function.
C***LIBRARY   SLATEC (FNLIB)
C***CATEGORY  C10D
C***TYPE      SINGLE PRECISION (AI-S, DAI-D)
C***KEYWORDS  AIRY FUNCTION, FNLIB, SPECIAL FUNCTIONS
C***AUTHOR  Fullerton, W., (LANL)
C***DESCRIPTION
C
C AI(X) computes the Airy function Ai(X)
C Series for AIF        on the interval -1.00000D+00 to  1.00000D+00
C                                        with weighted error   1.09E-19
C                                         log weighted error  18.96
C                               significant figures required  17.76
C                                    decimal places required  19.44
C
C Series for AIG        on the interval -1.00000D+00 to  1.00000D+00
C                                        with weighted error   1.51E-17
C                                         log weighted error  16.82
C                               significant figures required  15.19
C                                    decimal places required  17.27
C
C***REFERENCES  (NONE)
C***ROUTINES CALLED  AIE, CSEVL, INITS, R1MACH, R9AIMP, XERMSG
C***REVISION HISTORY  (YYMMDD)
C   770701  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890531  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900315  CALLs to XERROR changed to CALLs to XERMSG.  (THJ)
C   900326  Removed duplicate information from DESCRIPTION section.
C           (WRB)
C   920618  Removed space from variable names.  (RWC, WRB)
C***END PROLOGUE  AI
      DIMENSION AIFCS(9), AIGCS(8)
      LOGICAL FIRST
      SAVE AIFCS, AIGCS, NAIF, NAIG, X3SML, XMAX, FIRST
      DATA AIFCS( 1) /   -.0379713584 9666999750E0 /
      DATA AIFCS( 2) /    .0591918885 3726363857E0 /
      DATA AIFCS( 3) /    .0009862928 0577279975E0 /
      DATA AIFCS( 4) /    .0000068488 4381907656E0 /
      DATA AIFCS( 5) /    .0000000259 4202596219E0 /
      DATA AIFCS( 6) /    .0000000000 6176612774E0 /
      DATA AIFCS( 7) /    .0000000000 0010092454E0 /
      DATA AIFCS( 8) /    .0000000000 0000012014E0 /
      DATA AIFCS( 9) /    .0000000000 0000000010E0 /
      DATA AIGCS( 1) /    .0181523655 8116127E0 /
      DATA AIGCS( 2) /    .0215725631 6601076E0 /
      DATA AIGCS( 3) /    .0002567835 6987483E0 /
      DATA AIGCS( 4) /    .0000014265 2141197E0 /
      DATA AIGCS( 5) /    .0000000045 7211492E0 /
      DATA AIGCS( 6) /    .0000000000 0952517E0 /
      DATA AIGCS( 7) /    .0000000000 0001392E0 /
      DATA AIGCS( 8) /    .0000000000 0000001E0 /
      DATA FIRST /.TRUE./
C***FIRST EXECUTABLE STATEMENT  AI
      IF (FIRST) THEN
         NAIF = INITS (AIFCS, 9, 0.1*R1MACH(3))
         NAIG = INITS (AIGCS, 8, 0.1*R1MACH(3))
C
         X3SML = R1MACH(3)**0.3334
         XMAXT = (-1.5*LOG(R1MACH(1)))**0.6667
         XMAX = XMAXT - XMAXT*LOG(XMAXT)/
     *                   (4.0*SQRT(XMAXT)+1.0) - 0.01
      ENDIF
      FIRST = .FALSE.
C
      IF (X.GE.(-1.0)) GO TO 20
      CALL R9AIMP (X, XM, THETA)
      AI = XM * COS(THETA)
      RETURN
C
 20   IF (X.GT.1.0) GO TO 30
      Z = 0.0
      IF (ABS(X).GT.X3SML) Z = X**3
      AI = 0.375 + (CSEVL (Z, AIFCS, NAIF) - X*(0.25 +
     1  CSEVL (Z, AIGCS, NAIG)) )
      RETURN
C
 30   IF (X.GT.XMAX) GO TO 40
      AI = AIE(X) * EXP(-2.0*X*SQRT(X)/3.0)
      RETURN
C
 40   AI = 0.0
      CALL XERMSG ('SLATEC', 'AI', 'X SO BIG AI UNDERFLOWS', 1, 1)
      RETURN
C
      END
*DECK AIE
      FUNCTION AIE (X)
C***BEGIN PROLOGUE  AIE
C***PURPOSE  Calculate the Airy function for a negative argument and an
C            exponentially scaled Airy function for a non-negative
C            argument.
C***LIBRARY   SLATEC (FNLIB)
C***CATEGORY  C10D
C***TYPE      SINGLE PRECISION (AIE-S, DAIE-D)
C***KEYWORDS  EXPONENTIALLY SCALED AIRY FUNCTION, FNLIB,
C             SPECIAL FUNCTIONS
C***AUTHOR  Fullerton, W., (LANL)
C***DESCRIPTION
C
C AIE(X) computes the exponentially scaled Airy function for
C non-negative X.  It evaluates AI(X) for X .LE. 0.0 and
C EXP(ZETA)*AI(X) for X .GE. 0.0 where ZETA = (2.0/3.0)*(X**1.5).
C
C Series for AIF        on the interval -1.00000D+00 to  1.00000D+00
C                                        with weighted error   1.09E-19
C                                         log weighted error  18.96
C                               significant figures required  17.76
C                                    decimal places required  19.44
C
C Series for AIG        on the interval -1.00000D+00 to  1.00000D+00
C                                        with weighted error   1.51E-17
C                                         log weighted error  16.82
C                               significant figures required  15.19
C                                    decimal places required  17.27
C
C Series for AIP        on the interval  0.          to  1.00000D+00
C                                        with weighted error   5.10E-17
C                                         log weighted error  16.29
C                               significant figures required  14.41
C                                    decimal places required  17.06
C
C***REFERENCES  (NONE)
C***ROUTINES CALLED  CSEVL, INITS, R1MACH, R9AIMP
C***REVISION HISTORY  (YYMMDD)
C   770701  DATE WRITTEN
C   890206  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   920618  Removed space from variable names.  (RWC, WRB)
C***END PROLOGUE  AIE
      DIMENSION AIFCS(9), AIGCS(8), AIPCS(34)
      LOGICAL FIRST
      SAVE AIFCS, AIGCS, AIPCS, NAIF, NAIG,
     1 NAIP, X3SML, X32SML, XBIG, FIRST
      DATA AIFCS( 1) /   -.0379713584 9666999750E0 /
      DATA AIFCS( 2) /    .0591918885 3726363857E0 /
      DATA AIFCS( 3) /    .0009862928 0577279975E0 /
      DATA AIFCS( 4) /    .0000068488 4381907656E0 /
      DATA AIFCS( 5) /    .0000000259 4202596219E0 /
      DATA AIFCS( 6) /    .0000000000 6176612774E0 /
      DATA AIFCS( 7) /    .0000000000 0010092454E0 /
      DATA AIFCS( 8) /    .0000000000 0000012014E0 /
      DATA AIFCS( 9) /    .0000000000 0000000010E0 /
      DATA AIGCS( 1) /    .0181523655 8116127E0 /
      DATA AIGCS( 2) /    .0215725631 6601076E0 /
      DATA AIGCS( 3) /    .0002567835 6987483E0 /
      DATA AIGCS( 4) /    .0000014265 2141197E0 /
      DATA AIGCS( 5) /    .0000000045 7211492E0 /
      DATA AIGCS( 6) /    .0000000000 0952517E0 /
      DATA AIGCS( 7) /    .0000000000 0001392E0 /
      DATA AIGCS( 8) /    .0000000000 0000001E0 /
      DATA AIPCS( 1) /   -.0187519297 793868E0 /
      DATA AIPCS( 2) /   -.0091443848 250055E0 /
      DATA AIPCS( 3) /    .0009010457 337825E0 /
      DATA AIPCS( 4) /   -.0001394184 127221E0 /
      DATA AIPCS( 5) /    .0000273815 815785E0 /
      DATA AIPCS( 6) /   -.0000062750 421119E0 /
      DATA AIPCS( 7) /    .0000016064 844184E0 /
      DATA AIPCS( 8) /   -.0000004476 392158E0 /
      DATA AIPCS( 9) /    .0000001334 635874E0 /
      DATA AIPCS(10) /   -.0000000420 735334E0 /
      DATA AIPCS(11) /    .0000000139 021990E0 /
      DATA AIPCS(12) /   -.0000000047 831848E0 /
      DATA AIPCS(13) /    .0000000017 047897E0 /
      DATA AIPCS(14) /   -.0000000006 268389E0 /
      DATA AIPCS(15) /    .0000000002 369824E0 /
      DATA AIPCS(16) /   -.0000000000 918641E0 /
      DATA AIPCS(17) /    .0000000000 364278E0 /
      DATA AIPCS(18) /   -.0000000000 147475E0 /
      DATA AIPCS(19) /    .0000000000 060851E0 /
      DATA AIPCS(20) /   -.0000000000 025552E0 /
      DATA AIPCS(21) /    .0000000000 010906E0 /
      DATA AIPCS(22) /   -.0000000000 004725E0 /
      DATA AIPCS(23) /    .0000000000 002076E0 /
      DATA AIPCS(24) /   -.0000000000 000924E0 /
      DATA AIPCS(25) /    .0000000000 000417E0 /
      DATA AIPCS(26) /   -.0000000000 000190E0 /
      DATA AIPCS(27) /    .0000000000 000087E0 /
      DATA AIPCS(28) /   -.0000000000 000040E0 /
      DATA AIPCS(29) /    .0000000000 000019E0 /
      DATA AIPCS(30) /   -.0000000000 000009E0 /
      DATA AIPCS(31) /    .0000000000 000004E0 /
      DATA AIPCS(32) /   -.0000000000 000002E0 /
      DATA AIPCS(33) /    .0000000000 000001E0 /
      DATA AIPCS(34) /   -.0000000000 000000E0 /
      DATA FIRST /.TRUE./
C***FIRST EXECUTABLE STATEMENT  AIE
      IF (FIRST) THEN
         ETA = 0.1*R1MACH(3)
         NAIF  = INITS (AIFCS, 9, ETA)
         NAIG  = INITS (AIGCS, 8, ETA)
         NAIP  = INITS (AIPCS, 34, ETA)
C
         X3SML = ETA**0.3333
         X32SML = 1.3104*X3SML**2
         XBIG = R1MACH(2)**0.6666
      ENDIF
      FIRST = .FALSE.
C
      IF (X.GE.(-1.0)) GO TO 20
      CALL R9AIMP (X, XM, THETA)
      AIE = XM * COS(THETA)
      RETURN
C
 20   IF (X.GT.1.0) GO TO 30
      Z = 0.0
      IF (ABS(X).GT.X3SML) Z = X**3
      AIE = 0.375 + (CSEVL (Z, AIFCS, NAIF) - X*(0.25 +
     1  CSEVL (Z, AIGCS, NAIG)) )
      IF (X.GT.X32SML) AIE = AIE * EXP(2.0*X*SQRT(X)/3.0)
      RETURN
C
 30   SQRTX = SQRT(X)
      Z = -1.0
      IF (X.LT.XBIG) Z = 2.0/(X*SQRTX) - 1.0
      AIE = (.28125 + CSEVL (Z, AIPCS, NAIP))/SQRT(SQRTX)
      RETURN
C
      END
*DECK ALBETA
      FUNCTION ALBETA (A, B)
C***BEGIN PROLOGUE  ALBETA
C***PURPOSE  Compute the natural logarithm of the complete Beta
C            function.
C***LIBRARY   SLATEC (FNLIB)
C***CATEGORY  C7B
C***TYPE      SINGLE PRECISION (ALBETA-S, DLBETA-D, CLBETA-C)
C***KEYWORDS  FNLIB, LOGARITHM OF THE COMPLETE BETA FUNCTION,
C             SPECIAL FUNCTIONS
C***AUTHOR  Fullerton, W., (LANL)
C***DESCRIPTION
C
C ALBETA computes the natural log of the complete beta function.
C
C Input Parameters:
C       A   real and positive
C       B   real and positive
C
C***REFERENCES  (NONE)
C***ROUTINES CALLED  ALNGAM, ALNREL, GAMMA, R9LGMC, XERMSG
C***REVISION HISTORY  (YYMMDD)
C   770701  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890531  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900315  CALLs to XERROR changed to CALLs to XERMSG.  (THJ)
C   900326  Removed duplicate information from DESCRIPTION section.
C           (WRB)
C   900727  Added EXTERNAL statement.  (WRB)
C***END PROLOGUE  ALBETA
      EXTERNAL GAMMA
      SAVE SQ2PIL
      DATA SQ2PIL / 0.9189385332 0467274 E0 /
C***FIRST EXECUTABLE STATEMENT  ALBETA
      P = MIN (A, B)
      Q = MAX (A, B)
C
      IF (P .LE. 0.0) CALL XERMSG ('SLATEC', 'ALBETA',
     +   'BOTH ARGUMENTS MUST BE GT ZERO', 1, 2)
      IF (P.GE.10.0) GO TO 30
      IF (Q.GE.10.0) GO TO 20
C
C P AND Q ARE SMALL.
C
      ALBETA = LOG(GAMMA(P) * (GAMMA(Q)/GAMMA(P+Q)) )
      RETURN
C
C P IS SMALL, BUT Q IS BIG.
C
 20   CORR = R9LGMC(Q) - R9LGMC(P+Q)
      ALBETA = ALNGAM(P) + CORR + P - P*LOG(P+Q) +
     1  (Q-0.5)*ALNREL(-P/(P+Q))
      RETURN
C
C P AND Q ARE BIG.
C
 30   CORR = R9LGMC(P) + R9LGMC(Q) - R9LGMC(P+Q)
      ALBETA = -0.5*LOG(Q) + SQ2PIL + CORR + (P-0.5)*LOG(P/(P+Q))
     1  + Q*ALNREL(-P/(P+Q))
      RETURN
C
      END
*DECK ALGAMS
      SUBROUTINE ALGAMS (X, ALGAM, SGNGAM)
C***BEGIN PROLOGUE  ALGAMS
C***PURPOSE  Compute the logarithm of the absolute value of the Gamma
C            function.
C***LIBRARY   SLATEC (FNLIB)
C***CATEGORY  C7A
C***TYPE      SINGLE PRECISION (ALGAMS-S, DLGAMS-D)
C***KEYWORDS  ABSOLUTE VALUE OF THE LOGARITHM OF THE GAMMA FUNCTION,
C             FNLIB, SPECIAL FUNCTIONS
C***AUTHOR  Fullerton, W., (LANL)
C***DESCRIPTION
C
C Evaluates the logarithm of the absolute value of the gamma
C function.
C     X           - input argument
C     ALGAM       - result
C     SGNGAM      - is set to the sign of GAMMA(X) and will
C                   be returned at +1.0 or -1.0.
C
C***REFERENCES  (NONE)
C***ROUTINES CALLED  ALNGAM
C***REVISION HISTORY  (YYMMDD)
C   770701  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890531  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C***END PROLOGUE  ALGAMS
C***FIRST EXECUTABLE STATEMENT  ALGAMS
      ALGAM = ALNGAM(X)
      SGNGAM = 1.0
      IF (X.GT.0.0) RETURN
C
      INT = MOD (-AINT(X), 2.0) + 0.1
      IF (INT.EQ.0) SGNGAM = -1.0
C
      RETURN
      END
*DECK ALI
      FUNCTION ALI (X)
C***BEGIN PROLOGUE  ALI
C***PURPOSE  Compute the logarithmic integral.
C***LIBRARY   SLATEC (FNLIB)
C***CATEGORY  C5
C***TYPE      SINGLE PRECISION (ALI-S, DLI-D)
C***KEYWORDS  FNLIB, LOGARITHMIC INTEGRAL, SPECIAL FUNCTIONS
C***AUTHOR  Fullerton, W., (LANL)
C***DESCRIPTION
C
C ALI(X) computes the logarithmic integral; i.e., the
C integral from 0.0 to X of (1.0/ln(t))dt.
C
C***REFERENCES  (NONE)
C***ROUTINES CALLED  EI, XERMSG
C***REVISION HISTORY  (YYMMDD)
C   770601  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890531  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900315  CALLs to XERROR changed to CALLs to XERMSG.  (THJ)
C   900326  Removed duplicate information from DESCRIPTION section.
C           (WRB)
C***END PROLOGUE  ALI
C***FIRST EXECUTABLE STATEMENT  ALI
      IF (X .LE. 0.0) CALL XERMSG ('SLATEC', 'ALI',
     +   'LOG INTEGRAL UNDEFINED FOR X LE 0', 1, 2)
      IF (X .EQ. 1.0) CALL XERMSG ('SLATEC', 'ALI',
     +   'LOG INTEGRAL UNDEFINED FOR X = 1', 2, 2)
C
      ALI = EI (LOG(X) )
C
      RETURN
      END
*DECK ALNGAM
      FUNCTION ALNGAM (X)
C***BEGIN PROLOGUE  ALNGAM
C***PURPOSE  Compute the logarithm of the absolute value of the Gamma
C            function.
C***LIBRARY   SLATEC (FNLIB)
C***CATEGORY  C7A
C***TYPE      SINGLE PRECISION (ALNGAM-S, DLNGAM-D, CLNGAM-C)
C***KEYWORDS  ABSOLUTE VALUE, COMPLETE GAMMA FUNCTION, FNLIB, LOGARITHM,
C             SPECIAL FUNCTIONS
C***AUTHOR  Fullerton, W., (LANL)
C***DESCRIPTION
C
C ALNGAM(X) computes the logarithm of the absolute value of the
C gamma function at X.
C
C***REFERENCES  (NONE)
C***ROUTINES CALLED  GAMMA, R1MACH, R9LGMC, XERMSG
C***REVISION HISTORY  (YYMMDD)
C   770601  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890531  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900315  CALLs to XERROR changed to CALLs to XERMSG.  (THJ)
C   900326  Removed duplicate information from DESCRIPTION section.
C           (WRB)
C   900727  Added EXTERNAL statement.  (WRB)
C***END PROLOGUE  ALNGAM
      LOGICAL FIRST
      EXTERNAL GAMMA
      SAVE SQ2PIL, SQPI2L, PI, XMAX, DXREL, FIRST
      DATA SQ2PIL / 0.9189385332 0467274E0/
      DATA SQPI2L / 0.2257913526 4472743E0/
      DATA PI     / 3.1415926535 8979324E0/
      DATA FIRST  /.TRUE./
C***FIRST EXECUTABLE STATEMENT  ALNGAM
      IF (FIRST) THEN
         XMAX = R1MACH(2)/LOG(R1MACH(2))
         DXREL = SQRT (R1MACH(4))
      ENDIF
      FIRST = .FALSE.
C
      Y = ABS(X)
      IF (Y.GT.10.0) GO TO 20
C
C LOG (ABS (GAMMA(X))) FOR  ABS(X) .LE. 10.0
C
      ALNGAM = LOG (ABS (GAMMA(X)))
      RETURN
C
C LOG (ABS (GAMMA(X))) FOR ABS(X) .GT. 10.0
C
 20   IF (Y .GT. XMAX) CALL XERMSG ('SLATEC', 'ALNGAM',
     +   'ABS(X) SO BIG ALNGAM OVERFLOWS', 2, 2)
C
      IF (X.GT.0.) ALNGAM = SQ2PIL + (X-0.5)*LOG(X) - X + R9LGMC(Y)
      IF (X.GT.0.) RETURN
C
      SINPIY = ABS (SIN(PI*Y))
      IF (SINPIY .EQ. 0.) CALL XERMSG ('SLATEC', 'ALNGAM',
     +   'X IS A NEGATIVE INTEGER', 3, 2)
C
      IF (ABS((X-AINT(X-0.5))/X) .LT. DXREL) CALL XERMSG ('SLATEC',
     +   'ALNGAM', 'ANSWER LT HALF PRECISION BECAUSE X TOO NEAR ' //
     +   'NEGATIVE INTEGER', 1, 1)
C
      ALNGAM = SQPI2L + (X-0.5)*LOG(Y) - X - LOG(SINPIY) - R9LGMC(Y)
      RETURN
C
      END
*DECK ALNREL
      FUNCTION ALNREL (X)
C***BEGIN PROLOGUE  ALNREL
C***PURPOSE  Evaluate ln(1+X) accurate in the sense of relative error.
C***LIBRARY   SLATEC (FNLIB)
C***CATEGORY  C4B
C***TYPE      SINGLE PRECISION (ALNREL-S, DLNREL-D, CLNREL-C)
C***KEYWORDS  ELEMENTARY FUNCTIONS, FNLIB, LOGARITHM
C***AUTHOR  Fullerton, W., (LANL)
C***DESCRIPTION
C
C ALNREL(X) evaluates ln(1+X) accurately in the sense of relative
C error when X is very small.  This routine must be used to
C maintain relative error accuracy whenever X is small and
C accurately known.
C
C Series for ALNR       on the interval -3.75000D-01 to  3.75000D-01
C                                        with weighted error   1.93E-17
C                                         log weighted error  16.72
C                               significant figures required  16.44
C                                    decimal places required  17.40
C
C***REFERENCES  (NONE)
C***ROUTINES CALLED  CSEVL, INITS, R1MACH, XERMSG
C***REVISION HISTORY  (YYMMDD)
C   770401  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890531  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900315  CALLs to XERROR changed to CALLs to XERMSG.  (THJ)
C   900326  Removed duplicate information from DESCRIPTION section.
C           (WRB)
C***END PROLOGUE  ALNREL
      DIMENSION ALNRCS(23)
      LOGICAL FIRST
      SAVE ALNRCS, NLNREL, XMIN, FIRST
      DATA ALNRCS( 1) /   1.0378693562 743770E0 /
      DATA ALNRCS( 2) /   -.1336430150 4908918E0 /
      DATA ALNRCS( 3) /    .0194082491 35520563E0 /
      DATA ALNRCS( 4) /   -.0030107551 12753577E0 /
      DATA ALNRCS( 5) /    .0004869461 47971548E0 /
      DATA ALNRCS( 6) /   -.0000810548 81893175E0 /
      DATA ALNRCS( 7) /    .0000137788 47799559E0 /
      DATA ALNRCS( 8) /   -.0000023802 21089435E0 /
      DATA ALNRCS( 9) /    .0000004164 04162138E0 /
      DATA ALNRCS(10) /   -.0000000735 95828378E0 /
      DATA ALNRCS(11) /    .0000000131 17611876E0 /
      DATA ALNRCS(12) /   -.0000000023 54670931E0 /
      DATA ALNRCS(13) /    .0000000004 25227732E0 /
      DATA ALNRCS(14) /   -.0000000000 77190894E0 /
      DATA ALNRCS(15) /    .0000000000 14075746E0 /
      DATA ALNRCS(16) /   -.0000000000 02576907E0 /
      DATA ALNRCS(17) /    .0000000000 00473424E0 /
      DATA ALNRCS(18) /   -.0000000000 00087249E0 /
      DATA ALNRCS(19) /    .0000000000 00016124E0 /
      DATA ALNRCS(20) /   -.0000000000 00002987E0 /
      DATA ALNRCS(21) /    .0000000000 00000554E0 /
      DATA ALNRCS(22) /   -.0000000000 00000103E0 /
      DATA ALNRCS(23) /    .0000000000 00000019E0 /
      DATA FIRST /.TRUE./
C***FIRST EXECUTABLE STATEMENT  ALNREL
      IF (FIRST) THEN
         NLNREL = INITS (ALNRCS, 23, 0.1*R1MACH(3))
         XMIN = -1.0 + SQRT(R1MACH(4))
      ENDIF
      FIRST = .FALSE.
C
      IF (X .LE. (-1.0)) CALL XERMSG ('SLATEC', 'ALNREL', 'X IS LE -1',
     +   2, 2)
      IF (X .LT. XMIN) CALL XERMSG ('SLATEC', 'ALNREL',
     +   'ANSWER LT HALF PRECISION BECAUSE X TOO NEAR -1', 1, 1)
C
      IF (ABS(X).LE.0.375) ALNREL = X*(1. -
     1  X*CSEVL (X/.375, ALNRCS, NLNREL))
      IF (ABS(X).GT.0.375) ALNREL = LOG (1.0+X)
C
      RETURN
      END
*DECK ASINH
      FUNCTION ASINH (X)
C***BEGIN PROLOGUE  ASINH
C***PURPOSE  Compute the arc hyperbolic sine.
C***LIBRARY   SLATEC (FNLIB)
C***CATEGORY  C4C
C***TYPE      SINGLE PRECISION (ASINH-S, DASINH-D, CASINH-C)
C***KEYWORDS  ARC HYPERBOLIC SINE, ASINH, ELEMENTARY FUNCTIONS, FNLIB,
C             INVERSE HYPERBOLIC SINE
C***AUTHOR  Fullerton, W., (LANL)
C***DESCRIPTION
C
C ASINH(X) computes the arc hyperbolic sine of X.
C
C Series for ASNH       on the interval  0.          to  1.00000D+00
C                                        with weighted error   2.19E-17
C                                         log weighted error  16.66
C                               significant figures required  15.60
C                                    decimal places required  17.31
C
C***REFERENCES  (NONE)
C***ROUTINES CALLED  CSEVL, INITS, R1MACH
C***REVISION HISTORY  (YYMMDD)
C   770401  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890531  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C***END PROLOGUE  ASINH
      DIMENSION ASNHCS(20)
      LOGICAL FIRST
      SAVE ALN2, ASNHCS, NTERMS, XMAX, SQEPS, FIRST
      DATA ALN2 /0.6931471805 5994530942E0/
      DATA ASNHCS( 1) /   -.1282003991 1738186E0 /
      DATA ASNHCS( 2) /   -.0588117611 89951768E0 /
      DATA ASNHCS( 3) /    .0047274654 32212481E0 /
      DATA ASNHCS( 4) /   -.0004938363 16265361E0 /
      DATA ASNHCS( 5) /    .0000585062 07058557E0 /
      DATA ASNHCS( 6) /   -.0000074669 98328931E0 /
      DATA ASNHCS( 7) /    .0000010011 69358355E0 /
      DATA ASNHCS( 8) /   -.0000001390 35438587E0 /
      DATA ASNHCS( 9) /    .0000000198 23169483E0 /
      DATA ASNHCS(10) /   -.0000000028 84746841E0 /
      DATA ASNHCS(11) /    .0000000004 26729654E0 /
      DATA ASNHCS(12) /   -.0000000000 63976084E0 /
      DATA ASNHCS(13) /    .0000000000 09699168E0 /
      DATA ASNHCS(14) /   -.0000000000 01484427E0 /
      DATA ASNHCS(15) /    .0000000000 00229037E0 /
      DATA ASNHCS(16) /   -.0000000000 00035588E0 /
      DATA ASNHCS(17) /    .0000000000 00005563E0 /
      DATA ASNHCS(18) /   -.0000000000 00000874E0 /
      DATA ASNHCS(19) /    .0000000000 00000138E0 /
      DATA ASNHCS(20) /   -.0000000000 00000021E0 /
      DATA FIRST /.TRUE./
C***FIRST EXECUTABLE STATEMENT  ASINH
      IF (FIRST) THEN
         NTERMS = INITS (ASNHCS, 20, 0.1*R1MACH(3))
         SQEPS = SQRT (R1MACH(3))
         XMAX = 1.0/SQEPS
      ENDIF
      FIRST = .FALSE.
C
      Y = ABS(X)
      IF (Y.GT.1.0) GO TO 20
C
      ASINH = X
      IF (Y.GT.SQEPS) ASINH = X*(1.0 + CSEVL (2.*X*X-1., ASNHCS,NTERMS))
      RETURN
C
 20   IF (Y.LT.XMAX) ASINH = LOG (Y + SQRT(Y**2+1.))
      IF (Y.GE.XMAX) ASINH = ALN2 + LOG(Y)
      ASINH = SIGN (ASINH, X)
C
      RETURN
      END
*DECK ASYIK
      SUBROUTINE ASYIK (X, FNU, KODE, FLGIK, RA, ARG, IN, Y)
C***BEGIN PROLOGUE  ASYIK
C***SUBSIDIARY
C***PURPOSE  Subsidiary to BESI and BESK
C***LIBRARY   SLATEC
C***TYPE      SINGLE PRECISION (ASYIK-S, DASYIK-D)
C***AUTHOR  Amos, D. E., (SNLA)
C***DESCRIPTION
C
C                    ASYIK computes Bessel functions I and K
C                  for arguments X.GT.0.0 and orders FNU.GE.35
C                  on FLGIK = 1 and FLGIK = -1 respectively.
C
C                                    INPUT
C
C      X    - argument, X.GT.0.0E0
C      FNU  - order of first Bessel function
C      KODE - a parameter to indicate the scaling option
C             KODE=1 returns Y(I)=        I/SUB(FNU+I-1)/(X), I=1,IN
C                    or      Y(I)=        K/SUB(FNU+I-1)/(X), I=1,IN
C                    on FLGIK = 1.0E0 or FLGIK = -1.0E0
C             KODE=2 returns Y(I)=EXP(-X)*I/SUB(FNU+I-1)/(X), I=1,IN
C                    or      Y(I)=EXP( X)*K/SUB(FNU+I-1)/(X), I=1,IN
C                    on FLGIK = 1.0E0 or FLGIK = -1.0E0
C     FLGIK - selection parameter for I or K function
C             FLGIK =  1.0E0 gives the I function
C             FLGIK = -1.0E0 gives the K function
C        RA - SQRT(1.+Z*Z), Z=X/FNU
C       ARG - argument of the leading exponential
C        IN - number of functions desired, IN=1 or 2
C
C                                    OUTPUT
C
C         Y - a vector whose first in components contain the sequence
C
C     Abstract
C         ASYIK implements the uniform asymptotic expansion of
C         the I and K Bessel functions for FNU.GE.35 and real
C         X.GT.0.0E0. The forms are identical except for a change
C         in sign of some of the terms. This change in sign is
C         accomplished by means of the flag FLGIK = 1 or -1.
C
C***SEE ALSO  BESI, BESK
C***ROUTINES CALLED  R1MACH
C***REVISION HISTORY  (YYMMDD)
C   750101  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900328  Added TYPE section.  (WRB)
C   910408  Updated the AUTHOR section.  (WRB)
C***END PROLOGUE  ASYIK
C
      INTEGER IN, J, JN, K, KK, KODE, L
      REAL AK,AP,ARG,C, COEF,CON,ETX,FLGIK,FN, FNU,GLN,RA,S1,S2,
     1 T, TOL, T2, X, Y, Z
      REAL R1MACH
      DIMENSION Y(*), C(65), CON(2)
      SAVE CON, C
      DATA CON(1), CON(2)  /
     1        3.98942280401432678E-01,    1.25331413731550025E+00/
      DATA C(1), C(2), C(3), C(4), C(5), C(6), C(7), C(8), C(9), C(10),
     1     C(11), C(12), C(13), C(14), C(15), C(16), C(17), C(18),
     2     C(19), C(20), C(21), C(22), C(23), C(24)/
     3       -2.08333333333333E-01,        1.25000000000000E-01,
     4        3.34201388888889E-01,       -4.01041666666667E-01,
     5        7.03125000000000E-02,       -1.02581259645062E+00,
     6        1.84646267361111E+00,       -8.91210937500000E-01,
     7        7.32421875000000E-02,        4.66958442342625E+00,
     8       -1.12070026162230E+01,        8.78912353515625E+00,
     9       -2.36408691406250E+00,        1.12152099609375E-01,
     1       -2.82120725582002E+01,        8.46362176746007E+01,
     2       -9.18182415432400E+01,        4.25349987453885E+01,
     3       -7.36879435947963E+00,        2.27108001708984E-01,
     4        2.12570130039217E+02,       -7.65252468141182E+02,
     5        1.05999045252800E+03,       -6.99579627376133E+02/
      DATA C(25), C(26), C(27), C(28), C(29), C(30), C(31), C(32),
     1     C(33), C(34), C(35), C(36), C(37), C(38), C(39), C(40),
     2     C(41), C(42), C(43), C(44), C(45), C(46), C(47), C(48)/
     3        2.18190511744212E+02,       -2.64914304869516E+01,
     4        5.72501420974731E-01,       -1.91945766231841E+03,
     5        8.06172218173731E+03,       -1.35865500064341E+04,
     6        1.16553933368645E+04,       -5.30564697861340E+03,
     7        1.20090291321635E+03,       -1.08090919788395E+02,
     8        1.72772750258446E+00,        2.02042913309661E+04,
     9       -9.69805983886375E+04,        1.92547001232532E+05,
     1       -2.03400177280416E+05,        1.22200464983017E+05,
     2       -4.11926549688976E+04,        7.10951430248936E+03,
     3       -4.93915304773088E+02,        6.07404200127348E+00,
     4       -2.42919187900551E+05,        1.31176361466298E+06,
     5       -2.99801591853811E+06,        3.76327129765640E+06/
      DATA C(49), C(50), C(51), C(52), C(53), C(54), C(55), C(56),
     1     C(57), C(58), C(59), C(60), C(61), C(62), C(63), C(64),
     2     C(65)/
     3       -2.81356322658653E+06,        1.26836527332162E+06,
     4       -3.31645172484564E+05,        4.52187689813627E+04,
     5       -2.49983048181121E+03,        2.43805296995561E+01,
     6        3.28446985307204E+06,       -1.97068191184322E+07,
     7        5.09526024926646E+07,       -7.41051482115327E+07,
     8        6.63445122747290E+07,       -3.75671766607634E+07,
     9        1.32887671664218E+07,       -2.78561812808645E+06,
     1        3.08186404612662E+05,       -1.38860897537170E+04,
     2        1.10017140269247E+02/
C***FIRST EXECUTABLE STATEMENT  ASYIK
      TOL = R1MACH(3)
      TOL = MAX(TOL,1.0E-15)
      FN = FNU
      Z  = (3.0E0-FLGIK)/2.0E0
      KK = INT(Z)
      DO 50 JN=1,IN
        IF (JN.EQ.1) GO TO 10
        FN = FN - FLGIK
        Z = X/FN
        RA = SQRT(1.0E0+Z*Z)
        GLN = LOG((1.0E0+RA)/Z)
        ETX = KODE - 1
        T = RA*(1.0E0-ETX) + ETX/(Z+RA)
        ARG = FN*(T-GLN)*FLGIK
   10   COEF = EXP(ARG)
        T = 1.0E0/RA
        T2 = T*T
        T = T/FN
        T = SIGN(T,FLGIK)
        S2 = 1.0E0
        AP = 1.0E0
        L = 0
        DO 30 K=2,11
          L = L + 1
          S1 = C(L)
          DO 20 J=2,K
            L = L + 1
            S1 = S1*T2 + C(L)
   20     CONTINUE
          AP = AP*T
          AK = AP*S1
          S2 = S2 + AK
          IF (MAX(ABS(AK),ABS(AP)) .LT. TOL) GO TO 40
   30   CONTINUE
   40   CONTINUE
      T = ABS(T)
      Y(JN) = S2*COEF*SQRT(T)*CON(KK)
   50 CONTINUE
      RETURN
      END
*DECK ASYJY
      SUBROUTINE ASYJY (FUNJY, X, FNU, FLGJY, IN, Y, WK, IFLW)
C***BEGIN PROLOGUE  ASYJY
C***SUBSIDIARY
C***PURPOSE  Subsidiary to BESJ and BESY
C***LIBRARY   SLATEC
C***TYPE      SINGLE PRECISION (ASYJY-S, DASYJY-D)
C***AUTHOR  Amos, D. E., (SNLA)
C***DESCRIPTION
C
C                 ASYJY computes Bessel functions J and Y
C               for arguments X.GT.0.0 and orders FNU.GE.35.0
C               on FLGJY = 1 and FLGJY = -1 respectively
C
C                                  INPUT
C
C      FUNJY - external function JAIRY or YAIRY
C          X - argument, X.GT.0.0E0
C        FNU - order of the first Bessel function
C      FLGJY - selection flag
C              FLGJY =  1.0E0 gives the J function
C              FLGJY = -1.0E0 gives the Y function
C         IN - number of functions desired, IN = 1 or 2
C
C                                  OUTPUT
C
C         Y  - a vector whose first in components contain the sequence
C       IFLW - a flag indicating underflow or overflow
C                    return variables for BESJ only
C      WK(1) = 1 - (X/FNU)**2 = W**2
C      WK(2) = SQRT(ABS(WK(1)))
C      WK(3) = ABS(WK(2) - ATAN(WK(2)))  or
C              ABS(LN((1 + WK(2))/(X/FNU)) - WK(2))
C            = ABS((2/3)*ZETA**(3/2))
C      WK(4) = FNU*WK(3)
C      WK(5) = (1.5*WK(3)*FNU)**(1/3) = SQRT(ZETA)*FNU**(1/3)
C      WK(6) = SIGN(1.,W**2)*WK(5)**2 = SIGN(1.,W**2)*ZETA*FNU**(2/3)
C      WK(7) = FNU**(1/3)
C
C     Abstract
C         ASYJY implements the uniform asymptotic expansion of
C         the J and Y Bessel functions for FNU.GE.35 and real
C         X.GT.0.0E0. The forms are identical except for a change
C         in sign of some of the terms. This change in sign is
C         accomplished by means of the flag FLGJY = 1 or -1. On
C         FLGJY = 1 the AIRY functions AI(X) and DAI(X) are
C         supplied by the external function JAIRY, and on
C         FLGJY = -1 the AIRY functions BI(X) and DBI(X) are
C         supplied by the external function YAIRY.
C
C***SEE ALSO  BESJ, BESY
C***ROUTINES CALLED  I1MACH, R1MACH
C***REVISION HISTORY  (YYMMDD)
C   750101  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   891009  Removed unreferenced variable.  (WRB)
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900328  Added TYPE section.  (WRB)
C   910408  Updated the AUTHOR section.  (WRB)
C***END PROLOGUE  ASYJY
      INTEGER I, IFLW, IN, J, JN,JR,JU,K, KB,KLAST,KMAX,KP1, KS, KSP1,
     * KSTEMP, L, LR, LRP1, ISETA, ISETB
      INTEGER I1MACH
      REAL ABW2, AKM, ALFA, ALFA1, ALFA2, AP, AR, ASUM, AZ,
     * BETA, BETA1, BETA2, BETA3, BR, BSUM, C, CON1, CON2,
     * CON548,CR,CRZ32, DFI,ELIM, DR,FI, FLGJY, FN, FNU,
     * FN2, GAMA, PHI,  RCZ, RDEN, RELB, RFN2,  RTZ, RZDEN,
     * SA, SB, SUMA, SUMB, S1, TA, TAU, TB, TFN, TOL, TOLS, T2, UPOL,
     *  WK, X, XX, Y, Z, Z32
      REAL R1MACH
      DIMENSION Y(*), WK(*), C(65)
      DIMENSION ALFA(26,4), BETA(26,5)
      DIMENSION ALFA1(26,2), ALFA2(26,2)
      DIMENSION BETA1(26,2), BETA2(26,2), BETA3(26,1)
      DIMENSION GAMA(26), KMAX(5), AR(8), BR(10), UPOL(10)
      DIMENSION CR(10), DR(10)
      EQUIVALENCE (ALFA(1,1),ALFA1(1,1))
      EQUIVALENCE (ALFA(1,3),ALFA2(1,1))
      EQUIVALENCE (BETA(1,1),BETA1(1,1))
      EQUIVALENCE (BETA(1,3),BETA2(1,1))
      EQUIVALENCE (BETA(1,5),BETA3(1,1))
      SAVE TOLS, CON1, CON2, CON548, AR, BR, C, ALFA1, ALFA2,
     1 BETA1, BETA2, BETA3, GAMA
      DATA TOLS            /-6.90775527898214E+00/
      DATA CON1,CON2,CON548/
     1 6.66666666666667E-01, 3.33333333333333E-01, 1.04166666666667E-01/
      DATA  AR(1),  AR(2),  AR(3),  AR(4),  AR(5),  AR(6),  AR(7),
     A      AR(8)          / 8.35503472222222E-02, 1.28226574556327E-01,
     1 2.91849026464140E-01, 8.81627267443758E-01, 3.32140828186277E+00,
     2 1.49957629868626E+01, 7.89230130115865E+01, 4.74451538868264E+02/
      DATA  BR(1), BR(2), BR(3), BR(4), BR(5), BR(6), BR(7), BR(8),
     A      BR(9), BR(10)  /-1.45833333333333E-01,-9.87413194444444E-02,
     1-1.43312053915895E-01,-3.17227202678414E-01,-9.42429147957120E-01,
     2-3.51120304082635E+00,-1.57272636203680E+01,-8.22814390971859E+01,
     3-4.92355370523671E+02,-3.31621856854797E+03/
      DATA C(1), C(2), C(3), C(4), C(5), C(6), C(7), C(8), C(9), C(10),
     1     C(11), C(12), C(13), C(14), C(15), C(16), C(17), C(18),
     2     C(19), C(20), C(21), C(22), C(23), C(24)/
     3       -2.08333333333333E-01,        1.25000000000000E-01,
     4        3.34201388888889E-01,       -4.01041666666667E-01,
     5        7.03125000000000E-02,       -1.02581259645062E+00,
     6        1.84646267361111E+00,       -8.91210937500000E-01,
     7        7.32421875000000E-02,        4.66958442342625E+00,
     8       -1.12070026162230E+01,        8.78912353515625E+00,
     9       -2.36408691406250E+00,        1.12152099609375E-01,
     A       -2.82120725582002E+01,        8.46362176746007E+01,
     B       -9.18182415432400E+01,        4.25349987453885E+01,
     C       -7.36879435947963E+00,        2.27108001708984E-01,
     D        2.12570130039217E+02,       -7.65252468141182E+02,
     E        1.05999045252800E+03,       -6.99579627376133E+02/
      DATA C(25), C(26), C(27), C(28), C(29), C(30), C(31), C(32),
     1     C(33), C(34), C(35), C(36), C(37), C(38), C(39), C(40),
     2     C(41), C(42), C(43), C(44), C(45), C(46), C(47), C(48)/
     3        2.18190511744212E+02,       -2.64914304869516E+01,
     4        5.72501420974731E-01,       -1.91945766231841E+03,
     5        8.06172218173731E+03,       -1.35865500064341E+04,
     6        1.16553933368645E+04,       -5.30564697861340E+03,
     7        1.20090291321635E+03,       -1.08090919788395E+02,
     8        1.72772750258446E+00,        2.02042913309661E+04,
     9       -9.69805983886375E+04,        1.92547001232532E+05,
     A       -2.03400177280416E+05,        1.22200464983017E+05,
     B       -4.11926549688976E+04,        7.10951430248936E+03,
     C       -4.93915304773088E+02,        6.07404200127348E+00,
     D       -2.42919187900551E+05,        1.31176361466298E+06,
     E       -2.99801591853811E+06,        3.76327129765640E+06/
      DATA C(49), C(50), C(51), C(52), C(53), C(54), C(55), C(56),
     1     C(57), C(58), C(59), C(60), C(61), C(62), C(63), C(64),
     2     C(65)/
     3       -2.81356322658653E+06,        1.26836527332162E+06,
     4       -3.31645172484564E+05,        4.52187689813627E+04,
     5       -2.49983048181121E+03,        2.43805296995561E+01,
     6        3.28446985307204E+06,       -1.97068191184322E+07,
     7        5.09526024926646E+07,       -7.41051482115327E+07,
     8        6.63445122747290E+07,       -3.75671766607634E+07,
     9        1.32887671664218E+07,       -2.78561812808645E+06,
     A        3.08186404612662E+05,       -1.38860897537170E+04,
     B        1.10017140269247E+02/
      DATA ALFA1(1,1), ALFA1(2,1), ALFA1(3,1), ALFA1(4,1), ALFA1(5,1),
     1     ALFA1(6,1), ALFA1(7,1), ALFA1(8,1), ALFA1(9,1), ALFA1(10,1),
     2     ALFA1(11,1),ALFA1(12,1),ALFA1(13,1),ALFA1(14,1),ALFA1(15,1),
     3     ALFA1(16,1),ALFA1(17,1),ALFA1(18,1),ALFA1(19,1),ALFA1(20,1),
     4     ALFA1(21,1),ALFA1(22,1),ALFA1(23,1),ALFA1(24,1),ALFA1(25,1),
     5     ALFA1(26,1)     /-4.44444444444444E-03,-9.22077922077922E-04,
     6-8.84892884892885E-05, 1.65927687832450E-04, 2.46691372741793E-04,
     7 2.65995589346255E-04, 2.61824297061501E-04, 2.48730437344656E-04,
     8 2.32721040083232E-04, 2.16362485712365E-04, 2.00738858762752E-04,
     9 1.86267636637545E-04, 1.73060775917876E-04, 1.61091705929016E-04,
     1 1.50274774160908E-04, 1.40503497391270E-04, 1.31668816545923E-04,
     2 1.23667445598253E-04, 1.16405271474738E-04, 1.09798298372713E-04,
     3 1.03772410422993E-04, 9.82626078369363E-05, 9.32120517249503E-05,
     4 8.85710852478712E-05, 8.42963105715700E-05, 8.03497548407791E-05/
      DATA ALFA1(1,2), ALFA1(2,2), ALFA1(3,2), ALFA1(4,2), ALFA1(5,2),
     1     ALFA1(6,2), ALFA1(7,2), ALFA1(8,2), ALFA1(9,2), ALFA1(10,2),
     2     ALFA1(11,2),ALFA1(12,2),ALFA1(13,2),ALFA1(14,2),ALFA1(15,2),
     3     ALFA1(16,2),ALFA1(17,2),ALFA1(18,2),ALFA1(19,2),ALFA1(20,2),
     4     ALFA1(21,2),ALFA1(22,2),ALFA1(23,2),ALFA1(24,2),ALFA1(25,2),
     5     ALFA1(26,2)     / 6.93735541354589E-04, 2.32241745182922E-04,
     6-1.41986273556691E-05,-1.16444931672049E-04,-1.50803558053049E-04,
     7-1.55121924918096E-04,-1.46809756646466E-04,-1.33815503867491E-04,
     8-1.19744975684254E-04,-1.06184319207974E-04,-9.37699549891194E-05,
     9-8.26923045588193E-05,-7.29374348155221E-05,-6.44042357721016E-05,
     1-5.69611566009369E-05,-5.04731044303562E-05,-4.48134868008883E-05,
     2-3.98688727717599E-05,-3.55400532972042E-05,-3.17414256609022E-05,
     3-2.83996793904175E-05,-2.54522720634871E-05,-2.28459297164725E-05,
     4-2.05352753106481E-05,-1.84816217627666E-05,-1.66519330021394E-05/
      DATA ALFA2(1,1), ALFA2(2,1), ALFA2(3,1), ALFA2(4,1), ALFA2(5,1),
     1     ALFA2(6,1), ALFA2(7,1), ALFA2(8,1), ALFA2(9,1), ALFA2(10,1),
     2     ALFA2(11,1),ALFA2(12,1),ALFA2(13,1),ALFA2(14,1),ALFA2(15,1),
     3     ALFA2(16,1),ALFA2(17,1),ALFA2(18,1),ALFA2(19,1),ALFA2(20,1),
     4     ALFA2(21,1),ALFA2(22,1),ALFA2(23,1),ALFA2(24,1),ALFA2(25,1),
     5     ALFA2(26,1)     /-3.54211971457744E-04,-1.56161263945159E-04,
     6 3.04465503594936E-05, 1.30198655773243E-04, 1.67471106699712E-04,
     7 1.70222587683593E-04, 1.56501427608595E-04, 1.36339170977445E-04,
     8 1.14886692029825E-04, 9.45869093034688E-05, 7.64498419250898E-05,
     9 6.07570334965197E-05, 4.74394299290509E-05, 3.62757512005344E-05,
     1 2.69939714979225E-05, 1.93210938247939E-05, 1.30056674793963E-05,
     2 7.82620866744497E-06, 3.59257485819352E-06, 1.44040049814252E-07,
     3-2.65396769697939E-06,-4.91346867098486E-06,-6.72739296091248E-06,
     4-8.17269379678658E-06,-9.31304715093561E-06,-1.02011418798016E-05/
      DATA ALFA2(1,2), ALFA2(2,2), ALFA2(3,2), ALFA2(4,2), ALFA2(5,2),
     1     ALFA2(6,2), ALFA2(7,2), ALFA2(8,2), ALFA2(9,2), ALFA2(10,2),
     2     ALFA2(11,2),ALFA2(12,2),ALFA2(13,2),ALFA2(14,2),ALFA2(15,2),
     3     ALFA2(16,2),ALFA2(17,2),ALFA2(18,2),ALFA2(19,2),ALFA2(20,2),
     4     ALFA2(21,2),ALFA2(22,2),ALFA2(23,2),ALFA2(24,2),ALFA2(25,2),
     5     ALFA2(26,2)     / 3.78194199201773E-04, 2.02471952761816E-04,
     6-6.37938506318862E-05,-2.38598230603006E-04,-3.10916256027362E-04,
     7-3.13680115247576E-04,-2.78950273791323E-04,-2.28564082619141E-04,
     8-1.75245280340847E-04,-1.25544063060690E-04,-8.22982872820208E-05,
     9-4.62860730588116E-05,-1.72334302366962E-05, 5.60690482304602E-06,
     1 2.31395443148287E-05, 3.62642745856794E-05, 4.58006124490189E-05,
     2 5.24595294959114E-05, 5.68396208545815E-05, 5.94349820393104E-05,
     3 6.06478527578422E-05, 6.08023907788436E-05, 6.01577894539460E-05,
     4 5.89199657344698E-05, 5.72515823777593E-05, 5.52804375585853E-05/
      DATA BETA1(1,1), BETA1(2,1), BETA1(3,1), BETA1(4,1), BETA1(5,1),
     1     BETA1(6,1), BETA1(7,1), BETA1(8,1), BETA1(9,1), BETA1(10,1),
     2     BETA1(11,1),BETA1(12,1),BETA1(13,1),BETA1(14,1),BETA1(15,1),
     3     BETA1(16,1),BETA1(17,1),BETA1(18,1),BETA1(19,1),BETA1(20,1),
     4     BETA1(21,1),BETA1(22,1),BETA1(23,1),BETA1(24,1),BETA1(25,1),
     5     BETA1(26,1)     / 1.79988721413553E-02, 5.59964911064388E-03,
     6 2.88501402231133E-03, 1.80096606761054E-03, 1.24753110589199E-03,
     7 9.22878876572938E-04, 7.14430421727287E-04, 5.71787281789705E-04,
     8 4.69431007606482E-04, 3.93232835462917E-04, 3.34818889318298E-04,
     9 2.88952148495752E-04, 2.52211615549573E-04, 2.22280580798883E-04,
     1 1.97541838033063E-04, 1.76836855019718E-04, 1.59316899661821E-04,
     2 1.44347930197334E-04, 1.31448068119965E-04, 1.20245444949303E-04,
     3 1.10449144504599E-04, 1.01828770740567E-04, 9.41998224204238E-05,
     4 8.74130545753834E-05, 8.13466262162801E-05, 7.59002269646219E-05/
      DATA BETA1(1,2), BETA1(2,2), BETA1(3,2), BETA1(4,2), BETA1(5,2),
     1     BETA1(6,2), BETA1(7,2), BETA1(8,2), BETA1(9,2), BETA1(10,2),
     2     BETA1(11,2),BETA1(12,2),BETA1(13,2),BETA1(14,2),BETA1(15,2),
     3     BETA1(16,2),BETA1(17,2),BETA1(18,2),BETA1(19,2),BETA1(20,2),
     4     BETA1(21,2),BETA1(22,2),BETA1(23,2),BETA1(24,2),BETA1(25,2),
     5     BETA1(26,2)     /-1.49282953213429E-03,-8.78204709546389E-04,
     6-5.02916549572035E-04,-2.94822138512746E-04,-1.75463996970783E-04,
     7-1.04008550460816E-04,-5.96141953046458E-05,-3.12038929076098E-05,
     8-1.26089735980230E-05,-2.42892608575730E-07, 8.05996165414274E-06,
     9 1.36507009262147E-05, 1.73964125472926E-05, 1.98672978842134E-05,
     1 2.14463263790823E-05, 2.23954659232457E-05, 2.28967783814713E-05,
     2 2.30785389811178E-05, 2.30321976080909E-05, 2.28236073720349E-05,
     3 2.25005881105292E-05, 2.20981015361991E-05, 2.16418427448104E-05,
     4 2.11507649256221E-05, 2.06388749782171E-05, 2.01165241997082E-05/
      DATA BETA2(1,1), BETA2(2,1), BETA2(3,1), BETA2(4,1), BETA2(5,1),
     1     BETA2(6,1), BETA2(7,1), BETA2(8,1), BETA2(9,1), BETA2(10,1),
     2     BETA2(11,1),BETA2(12,1),BETA2(13,1),BETA2(14,1),BETA2(15,1),
     3     BETA2(16,1),BETA2(17,1),BETA2(18,1),BETA2(19,1),BETA2(20,1),
     4     BETA2(21,1),BETA2(22,1),BETA2(23,1),BETA2(24,1),BETA2(25,1),
     5     BETA2(26,1)     / 5.52213076721293E-04, 4.47932581552385E-04,
     6 2.79520653992021E-04, 1.52468156198447E-04, 6.93271105657044E-05,
     7 1.76258683069991E-05,-1.35744996343269E-05,-3.17972413350427E-05,
     8-4.18861861696693E-05,-4.69004889379141E-05,-4.87665447413787E-05,
     9-4.87010031186735E-05,-4.74755620890087E-05,-4.55813058138628E-05,
     1-4.33309644511266E-05,-4.09230193157750E-05,-3.84822638603221E-05,
     2-3.60857167535411E-05,-3.37793306123367E-05,-3.15888560772110E-05,
     3-2.95269561750807E-05,-2.75978914828336E-05,-2.58006174666884E-05,
     4-2.41308356761280E-05,-2.25823509518346E-05,-2.11479656768913E-05/
      DATA BETA2(1,2), BETA2(2,2), BETA2(3,2), BETA2(4,2), BETA2(5,2),
     1     BETA2(6,2), BETA2(7,2), BETA2(8,2), BETA2(9,2), BETA2(10,2),
     2     BETA2(11,2),BETA2(12,2),BETA2(13,2),BETA2(14,2),BETA2(15,2),
     3     BETA2(16,2),BETA2(17,2),BETA2(18,2),BETA2(19,2),BETA2(20,2),
     4     BETA2(21,2),BETA2(22,2),BETA2(23,2),BETA2(24,2),BETA2(25,2),
     5     BETA2(26,2)     /-4.74617796559960E-04,-4.77864567147321E-04,
     6-3.20390228067038E-04,-1.61105016119962E-04,-4.25778101285435E-05,
     7 3.44571294294968E-05, 7.97092684075675E-05, 1.03138236708272E-04,
     8 1.12466775262204E-04, 1.13103642108481E-04, 1.08651634848774E-04,
     9 1.01437951597662E-04, 9.29298396593364E-05, 8.40293133016090E-05,
     1 7.52727991349134E-05, 6.69632521975731E-05, 5.92564547323195E-05,
     2 5.22169308826976E-05, 4.58539485165361E-05, 4.01445513891487E-05,
     3 3.50481730031328E-05, 3.05157995034347E-05, 2.64956119950516E-05,
     4 2.29363633690998E-05, 1.97893056664022E-05, 1.70091984636413E-05/
      DATA BETA3(1,1), BETA3(2,1), BETA3(3,1), BETA3(4,1), BETA3(5,1),
     1     BETA3(6,1), BETA3(7,1), BETA3(8,1), BETA3(9,1), BETA3(10,1),
     2     BETA3(11,1),BETA3(12,1),BETA3(13,1),BETA3(14,1),BETA3(15,1),
     3     BETA3(16,1),BETA3(17,1),BETA3(18,1),BETA3(19,1),BETA3(20,1),
     4     BETA3(21,1),BETA3(22,1),BETA3(23,1),BETA3(24,1),BETA3(25,1),
     5     BETA3(26,1)     / 7.36465810572578E-04, 8.72790805146194E-04,
     6 6.22614862573135E-04, 2.85998154194304E-04, 3.84737672879366E-06,
     7-1.87906003636972E-04,-2.97603646594555E-04,-3.45998126832656E-04,
     8-3.53382470916038E-04,-3.35715635775049E-04,-3.04321124789040E-04,
     9-2.66722723047613E-04,-2.27654214122820E-04,-1.89922611854562E-04,
     1-1.55058918599094E-04,-1.23778240761874E-04,-9.62926147717644E-05,
     2-7.25178327714425E-05,-5.22070028895634E-05,-3.50347750511901E-05,
     3-2.06489761035552E-05,-8.70106096849767E-06, 1.13698686675100E-06,
     4 9.16426474122779E-06, 1.56477785428873E-05, 2.08223629482467E-05/
      DATA GAMA(1),   GAMA(2),   GAMA(3),   GAMA(4),   GAMA(5),
     1     GAMA(6),   GAMA(7),   GAMA(8),   GAMA(9),   GAMA(10),
     2     GAMA(11),  GAMA(12),  GAMA(13),  GAMA(14),  GAMA(15),
     3     GAMA(16),  GAMA(17),  GAMA(18),  GAMA(19),  GAMA(20),
     4     GAMA(21),  GAMA(22),  GAMA(23),  GAMA(24),  GAMA(25),
     5     GAMA(26)        / 6.29960524947437E-01, 2.51984209978975E-01,
     6 1.54790300415656E-01, 1.10713062416159E-01, 8.57309395527395E-02,
     7 6.97161316958684E-02, 5.86085671893714E-02, 5.04698873536311E-02,
     8 4.42600580689155E-02, 3.93720661543510E-02, 3.54283195924455E-02,
     9 3.21818857502098E-02, 2.94646240791158E-02, 2.71581677112934E-02,
     1 2.51768272973862E-02, 2.34570755306079E-02, 2.19508390134907E-02,
     2 2.06210828235646E-02, 1.94388240897881E-02, 1.83810633800683E-02,
     3 1.74293213231963E-02, 1.65685837786612E-02, 1.57865285987918E-02,
     4 1.50729501494096E-02, 1.44193250839955E-02, 1.38184805735342E-02/
C***FIRST EXECUTABLE STATEMENT  ASYJY
      TA = R1MACH(3)
      TOL = MAX(TA,1.0E-15)
      TB = R1MACH(5)
      JU = I1MACH(12)
      IF(FLGJY.EQ.1.0E0) GO TO 6
      JR = I1MACH(11)
      ELIM = -2.303E0*TB*(JU+JR)
      GO TO 7
    6 CONTINUE
      ELIM = -2.303E0*(TB*JU+3.0E0)
    7 CONTINUE
      FN = FNU
      IFLW = 0
      DO 170 JN=1,IN
        XX = X/FN
        WK(1) = 1.0E0 - XX*XX
        ABW2 = ABS(WK(1))
        WK(2) = SQRT(ABW2)
        WK(7) = FN**CON2
        IF (ABW2.GT.0.27750E0) GO TO 80
C
C     ASYMPTOTIC EXPANSION
C     CASES NEAR X=FN, ABS(1.-(X/FN)**2).LE.0.2775
C     COEFFICIENTS OF ASYMPTOTIC EXPANSION BY SERIES
C
C     ZETA AND TRUNCATION FOR A(ZETA) AND B(ZETA) SERIES
C
C     KMAX IS TRUNCATION INDEX FOR A(ZETA) AND B(ZETA) SERIES=MAX(2,SA)
C
        SA = 0.0E0
        IF (ABW2.EQ.0.0E0) GO TO 10
        SA = TOLS/LOG(ABW2)
   10   SB = SA
        DO 20 I=1,5
          AKM = MAX(SA,2.0E0)
          KMAX(I) = INT(AKM)
          SA = SA + SB
   20   CONTINUE
        KB = KMAX(5)
        KLAST = KB - 1
        SA = GAMA(KB)
        DO 30 K=1,KLAST
          KB = KB - 1
          SA = SA*WK(1) + GAMA(KB)
   30   CONTINUE
        Z = WK(1)*SA
        AZ = ABS(Z)
        RTZ = SQRT(AZ)
        WK(3) = CON1*AZ*RTZ
        WK(4) = WK(3)*FN
        WK(5) = RTZ*WK(7)
        WK(6) = -WK(5)*WK(5)
        IF(Z.LE.0.0E0) GO TO 35
        IF(WK(4).GT.ELIM) GO TO 75
        WK(6) = -WK(6)
   35   CONTINUE
        PHI = SQRT(SQRT(SA+SA+SA+SA))
C
C     B(ZETA) FOR S=0
C
        KB = KMAX(5)
        KLAST = KB - 1
        SB = BETA(KB,1)
        DO 40 K=1,KLAST
          KB = KB - 1
          SB = SB*WK(1) + BETA(KB,1)
   40   CONTINUE
        KSP1 = 1
        FN2 = FN*FN
        RFN2 = 1.0E0/FN2
        RDEN = 1.0E0
        ASUM = 1.0E0
        RELB = TOL*ABS(SB)
        BSUM = SB
        DO 60 KS=1,4
          KSP1 = KSP1 + 1
          RDEN = RDEN*RFN2
C
C     A(ZETA) AND B(ZETA) FOR S=1,2,3,4
C
          KSTEMP = 5 - KS
          KB = KMAX(KSTEMP)
          KLAST = KB - 1
          SA = ALFA(KB,KS)
          SB = BETA(KB,KSP1)
          DO 50 K=1,KLAST
            KB = KB - 1
            SA = SA*WK(1) + ALFA(KB,KS)
            SB = SB*WK(1) + BETA(KB,KSP1)
   50     CONTINUE
          TA = SA*RDEN
          TB = SB*RDEN
          ASUM = ASUM + TA
          BSUM = BSUM + TB
          IF (ABS(TA).LE.TOL .AND. ABS(TB).LE.RELB) GO TO 70
   60   CONTINUE
   70   CONTINUE
        BSUM = BSUM/(FN*WK(7))
        GO TO 160
C
   75   CONTINUE
        IFLW = 1
        RETURN
C
   80   CONTINUE
        UPOL(1) = 1.0E0
        TAU = 1.0E0/WK(2)
        T2 = 1.0E0/WK(1)
        IF (WK(1).GE.0.0E0) GO TO 90
C
C     CASES FOR (X/FN).GT.SQRT(1.2775)
C
        WK(3) = ABS(WK(2)-ATAN(WK(2)))
        WK(4) = WK(3)*FN
        RCZ = -CON1/WK(4)
        Z32 = 1.5E0*WK(3)
        RTZ = Z32**CON2
        WK(5) = RTZ*WK(7)
        WK(6) = -WK(5)*WK(5)
        GO TO 100
   90   CONTINUE
C
C     CASES FOR (X/FN).LT.SQRT(0.7225)
C
        WK(3) = ABS(LOG((1.0E0+WK(2))/XX)-WK(2))
        WK(4) = WK(3)*FN
        RCZ = CON1/WK(4)
        IF(WK(4).GT.ELIM) GO TO 75
        Z32 = 1.5E0*WK(3)
        RTZ = Z32**CON2
        WK(7) = FN**CON2
        WK(5) = RTZ*WK(7)
        WK(6) = WK(5)*WK(5)
  100   CONTINUE
        PHI = SQRT((RTZ+RTZ)*TAU)
        TB = 1.0E0
        ASUM = 1.0E0
        TFN = TAU/FN
        RDEN=1.0E0/FN
        RFN2=RDEN*RDEN
        RDEN=1.0E0
        UPOL(2) = (C(1)*T2+C(2))*TFN
        CRZ32 = CON548*RCZ
        BSUM = UPOL(2) + CRZ32
        RELB = TOL*ABS(BSUM)
        AP = TFN
        KS = 0
        KP1 = 2
        RZDEN = RCZ
        L = 2
        ISETA=0
        ISETB=0
        DO 140 LR=2,8,2
C
C     COMPUTE TWO U POLYNOMIALS FOR NEXT A(ZETA) AND B(ZETA)
C
          LRP1 = LR + 1
          DO 120 K=LR,LRP1
            KS = KS + 1
            KP1 = KP1 + 1
            L = L + 1
            S1 = C(L)
            DO 110 J=2,KP1
              L = L + 1
              S1 = S1*T2 + C(L)
  110       CONTINUE
            AP = AP*TFN
            UPOL(KP1) = AP*S1
            CR(KS) = BR(KS)*RZDEN
            RZDEN = RZDEN*RCZ
            DR(KS) = AR(KS)*RZDEN
  120     CONTINUE
          SUMA = UPOL(LRP1)
          SUMB = UPOL(LR+2) + UPOL(LRP1)*CRZ32
          JU = LRP1
          DO 130 JR=1,LR
            JU = JU - 1
            SUMA = SUMA + CR(JR)*UPOL(JU)
            SUMB = SUMB + DR(JR)*UPOL(JU)
  130     CONTINUE
          RDEN=RDEN*RFN2
          TB = -TB
          IF (WK(1).GT.0.0E0) TB = ABS(TB)
          IF (RDEN.LT.TOL) GO TO 131
          ASUM = ASUM + SUMA*TB
          BSUM = BSUM + SUMB*TB
          GO TO 140
  131     IF(ISETA.EQ.1) GO TO 132
          IF(ABS(SUMA).LT.TOL) ISETA=1
          ASUM=ASUM+SUMA*TB
  132     IF(ISETB.EQ.1) GO TO 133
          IF(ABS(SUMB).LT.RELB) ISETB=1
          BSUM=BSUM+SUMB*TB
  133     IF(ISETA.EQ.1 .AND. ISETB.EQ.1) GO TO 150
  140   CONTINUE
  150   TB = WK(5)
        IF (WK(1).GT.0.0E0) TB = -TB
        BSUM = BSUM/TB
C
  160   CONTINUE
        CALL FUNJY(WK(6), WK(5), WK(4), FI, DFI)
        TA=1.0E0/TOL
        TB=R1MACH(1)*TA*1.0E+3
        IF(ABS(FI).GT.TB) GO TO 165
        FI=FI*TA
        DFI=DFI*TA
        PHI=PHI*TOL
  165   CONTINUE
        Y(JN) = FLGJY*PHI*(FI*ASUM+DFI*BSUM)/WK(7)
        FN = FN - FLGJY
  170 CONTINUE
      RETURN
      END
*DECK ATANH
      FUNCTION ATANH (X)
C***BEGIN PROLOGUE  ATANH
C***PURPOSE  Compute the arc hyperbolic tangent.
C***LIBRARY   SLATEC (FNLIB)
C***CATEGORY  C4C
C***TYPE      SINGLE PRECISION (ATANH-S, DATANH-D, CATANH-C)
C***KEYWORDS  ARC HYPERBOLIC TANGENT, ATANH, ELEMENTARY FUNCTIONS,
C             FNLIB, INVERSE HYPERBOLIC TANGENT
C***AUTHOR  Fullerton, W., (LANL)
C***DESCRIPTION
C
C ATANH(X) computes the arc hyperbolic tangent of X.
C
C Series for ATNH       on the interval  0.          to  2.50000D-01
C                                        with weighted error   6.70E-18
C                                         log weighted error  17.17
C                               significant figures required  16.01
C                                    decimal places required  17.76
C
C***REFERENCES  (NONE)
C***ROUTINES CALLED  CSEVL, INITS, R1MACH, XERMSG
C***REVISION HISTORY  (YYMMDD)
C   770401  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890531  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900315  CALLs to XERROR changed to CALLs to XERMSG.  (THJ)
C   900326  Removed duplicate information from DESCRIPTION section.
C           (WRB)
C***END PROLOGUE  ATANH
      DIMENSION ATNHCS(15)
      LOGICAL FIRST
      SAVE ATNHCS, NTERMS, DXREL, SQEPS, FIRST
      DATA ATNHCS( 1) /    .0943951023 93195492E0 /
      DATA ATNHCS( 2) /    .0491984370 55786159E0 /
      DATA ATNHCS( 3) /    .0021025935 22455432E0 /
      DATA ATNHCS( 4) /    .0001073554 44977611E0 /
      DATA ATNHCS( 5) /    .0000059782 67249293E0 /
      DATA ATNHCS( 6) /    .0000003505 06203088E0 /
      DATA ATNHCS( 7) /    .0000000212 63743437E0 /
      DATA ATNHCS( 8) /    .0000000013 21694535E0 /
      DATA ATNHCS( 9) /    .0000000000 83658755E0 /
      DATA ATNHCS(10) /    .0000000000 05370503E0 /
      DATA ATNHCS(11) /    .0000000000 00348665E0 /
      DATA ATNHCS(12) /    .0000000000 00022845E0 /
      DATA ATNHCS(13) /    .0000000000 00001508E0 /
      DATA ATNHCS(14) /    .0000000000 00000100E0 /
      DATA ATNHCS(15) /    .0000000000 00000006E0 /
      DATA FIRST /.TRUE./
C***FIRST EXECUTABLE STATEMENT  ATANH
      IF (FIRST) THEN
         NTERMS = INITS (ATNHCS, 15, 0.1*R1MACH(3))
         DXREL = SQRT (R1MACH(4))
         SQEPS = SQRT (3.0*R1MACH(3))
      ENDIF
      FIRST = .FALSE.
C
      Y = ABS(X)
      IF (Y .GE. 1.0) CALL XERMSG ('SLATEC', 'ATANH', 'ABS(X) GE 1', 2,
     +   2)
C
      IF (1.0-Y .LT. DXREL) CALL XERMSG ('SLATEC', 'ATANH',
     +   'ANSWER LT HALF PRECISION BECAUSE ABS(X) TOO NEAR 1', 1, 1)
C
      ATANH = X
      IF (Y.GT.SQEPS .AND. Y.LE.0.5) ATANH = X*(1.0 + CSEVL (8.*X*X-1.,
     1  ATNHCS, NTERMS))
      IF (Y.GT.0.5) ATANH = 0.5*LOG((1.0+X)/(1.0-X))
C
      RETURN
      END
*DECK AVINT
      SUBROUTINE AVINT (X, Y, N, XLO, XUP, ANS, IERR)
C***BEGIN PROLOGUE  AVINT
C***PURPOSE  Integrate a function tabulated at arbitrarily spaced
C            abscissas using overlapping parabolas.
C***LIBRARY   SLATEC
C***CATEGORY  H2A1B2
C***TYPE      SINGLE PRECISION (AVINT-S, DAVINT-D)
C***KEYWORDS  INTEGRATION, QUADRATURE, TABULATED DATA
C***AUTHOR  Jones, R. E., (SNLA)
C***DESCRIPTION
C
C     Abstract
C         AVINT integrates a function tabulated at arbitrarily spaced
C         abscissas.  The limits of integration need not coincide
C         with the tabulated abscissas.
C
C         A method of overlapping parabolas fitted to the data is used
C         provided that there are at least 3 abscissas between the
C         limits of integration.  AVINT also handles two special cases.
C         If the limits of integration are equal, AVINT returns a result
C         of zero regardless of the number of tabulated values.
C         If there are only two function values, AVINT uses the
C         trapezoid rule.
C
C     Description of Parameters
C         The user must dimension all arrays appearing in the call list
C              X(N), Y(N).
C
C         Input--
C         X    - real array of abscissas, which must be in increasing
C                order.
C         Y    - real array of functional values. i.e., Y(I)=FUNC(X(I)).
C         N    - the integer number of function values supplied.
C                N .GE. 2 unless XLO = XUP.
C         XLO  - real lower limit of integration.
C         XUP  - real upper limit of integration.
C                Must have XLO .LE. XUP.
C
C         Output--
C         ANS  - computed approximate value of integral
C         IERR - a status code
C              --normal code
C                =1 means the requested integration was performed.
C              --abnormal codes
C                =2 means XUP was less than XLO.
C                =3 means the number of X(I) between XLO and XUP
C                   (inclusive) was less than 3 and neither of the two
C                   special cases described in the Abstract occurred.
C                   No integration was performed.
C                =4 means the restriction X(I+1) .GT. X(I) was violated.
C                =5 means the number N of function values was .LT. 2.
C                ANS is set to zero if IERR=2,3,4,or 5.
C
C     AVINT is documented completely in SC-M-69-335
C     Original program from "Numerical Integration" by Davis &
C     Rabinowitz.
C     Adaptation and modifications for Sandia Mathematical Program
C     Library by Rondall E. Jones.
C
C***REFERENCES  R. E. Jones, Approximate integrator of functions
C                 tabulated at arbitrarily spaced abscissas,
C                 Report SC-M-69-335, Sandia Laboratories, 1969.
C***ROUTINES CALLED  XERMSG
C***REVISION HISTORY  (YYMMDD)
C   690901  DATE WRITTEN
C   890831  Modified array declarations.  (WRB)
C   890831  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900315  CALLs to XERROR changed to CALLs to XERMSG.  (THJ)
C   900326  Removed duplicate information from DESCRIPTION section.
C           (WRB)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  AVINT
C
      DOUBLE PRECISION R3,RP5,SUM,SYL,SYL2,SYL3,SYU,SYU2,SYU3,X1,X2,X3
     1,X12,X13,X23,TERM1,TERM2,TERM3,A,B,C,CA,CB,CC
      DIMENSION X(*),Y(*)
C***FIRST EXECUTABLE STATEMENT  AVINT
      IERR=1
      ANS =0.0
      IF (XLO-XUP) 3,100,200
    3 IF (N.LT.2) GO TO 215
      DO 5 I=2,N
      IF (X(I).LE.X(I-1)) GO TO 210
      IF (X(I).GT.XUP) GO TO 6
    5 CONTINUE
    6 CONTINUE
      IF (N.GE.3) GO TO 9
C
C     SPECIAL N=2 CASE
      SLOPE = (Y(2)-Y(1))/(X(2)-X(1))
      FL = Y(1) + SLOPE*(XLO-X(1))
      FR = Y(2) + SLOPE*(XUP-X(2))
      ANS = 0.5*(FL+FR)*(XUP-XLO)
      RETURN
    9 CONTINUE
      IF (X(N-2).LT.XLO)  GO TO 205
      IF (X(3).GT.XUP)    GO TO 205
      I = 1
   10 IF (X(I).GE.XLO) GO TO 15
      I = I+1
      GO TO 10
   15 INLFT = I
      I = N
   20 IF (X(I).LE.XUP) GO TO 25
      I = I-1
      GO TO 20
   25 INRT = I
      IF ((INRT-INLFT).LT.2) GO TO 205
      ISTART = INLFT
      IF (INLFT.EQ.1) ISTART = 2
      ISTOP  = INRT
      IF (INRT.EQ.N)  ISTOP  = N-1
C
      R3 = 3.0D0
      RP5= 0.5D0
      SUM = 0.0
      SYL = XLO
      SYL2= SYL*SYL
      SYL3= SYL2*SYL
C
      DO 50 I=ISTART,ISTOP
      X1 = X(I-1)
      X2 = X(I)
      X3 = X(I+1)
      X12 = X1-X2
      X13 = X1-X3
      X23 = X2-X3
      TERM1 = DBLE(Y(I-1))/(X12*X13)
      TERM2 =-DBLE(Y(I)) /(X12*X23)
      TERM3 = DBLE(Y(I+1))/(X13*X23)
      A = TERM1+TERM2+TERM3
      B = -(X2+X3)*TERM1 - (X1+X3)*TERM2 - (X1+X2)*TERM3
      C = X2*X3*TERM1 + X1*X3*TERM2 + X1*X2*TERM3
      IF (I-ISTART) 30,30,35
   30 CA = A
      CB = B
      CC = C
      GO TO 40
   35 CA = 0.5*(A+CA)
      CB = 0.5*(B+CB)
      CC = 0.5*(C+CC)
   40 SYU = X2
      SYU2= SYU*SYU
      SYU3= SYU2*SYU
      SUM = SUM + CA*(SYU3-SYL3)/R3  + CB*RP5*(SYU2-SYL2) + CC*(SYU-SYL)
      CA  = A
      CB  = B
      CC  = C
      SYL = SYU
      SYL2= SYU2
      SYL3= SYU3
   50 CONTINUE
      SYU = XUP
      ANS = SUM + CA*(SYU**3-SYL3)/R3 + CB*RP5*(SYU**2-SYL2)
     1  + CC*(SYU-SYL)
  100 RETURN
  200 IERR=2
      CALL XERMSG ('SLATEC', 'AVINT',
     +   'THE UPPER LIMIT OF INTEGRATION WAS NOT GREATER THAN THE ' //
     +   'LOWER LIMIT.', 4, 1)
      RETURN
  205 IERR=3
      CALL XERMSG ('SLATEC', 'AVINT',
     +   'THERE WERE LESS THAN THREE FUNCTION VALUES BETWEEN THE ' //
     +   'LIMITS OF INTEGRATION.', 4, 1)
      RETURN
  210 IERR=4
      CALL XERMSG ('SLATEC', 'AVINT',
     +   'THE ABSCISSAS WERE NOT STRICTLY INCREASING.  MUST HAVE ' //
     +   'X(I-1) .LT. X(I) FOR ALL I.', 4, 1)
      RETURN
  215 IERR=5
      CALL XERMSG ('SLATEC', 'AVINT',
     +   'LESS THAN TWO FUNCTION VALUES WERE SUPPLIED.', 4, 1)
      RETURN
      END

program combine
  use image_def
  use gkernel_interfaces
  !----------------------------------------------------------------------
  ! GILDAS Combine in different ways two input images
  !        (or data cubes)...
  !----------------------------------------------------------------------
  !
  character(len=filename_length) :: namex,namey,namez
  character(len=20) :: code
  logical error
  real ay,az,ty,tz,b,c
  type (gildas) :: hx, hy, hz
  real, allocatable :: dx(:,:), dy(:,:), dz(:)
  integer i, j, n, m, ier
  !
  call gildas_open
  call gildas_char('Z_NAME$',namez)
  call gildas_real('Z_FACTOR$',az,1)
  call gildas_real('Z_MIN$',tz,1)
  call gildas_char('Y_NAME$',namey)
  call gildas_real('Y_FACTOR$',ay,1)
  call gildas_real('Y_MIN$',ty,1)
  call gildas_char('X_NAME$',namex)
  call gildas_real('BLANKING$',b,1)
  call gildas_real('OFFSET$',c,1)
  call gildas_char('FUNCTION$',code)
  call gildas_close
  !
  n = len_trim(namez)
  if (n.eq.0) goto 100
  n = len_trim(namex)
  if (n.eq.0) goto 100
  n = len_trim(namey)
  if (n.eq.0) goto 100
  !
  call gildas_null(hz)
  call sic_parsef(namez,hz%file,' ','.gdf')
  call gdf_read_header(hz,error)
  if (error) then
    call gagout('F-COMBINE,  Cannot read input file')
    goto 100
  endif
  !
  call gildas_null(hy)
  call sic_parsef(namey,hy%file,' ','.gdf')
  call gdf_read_header(hy,error)
  if (error) then
    call gagout('F-COMBINE,  Cannot read input file')
    goto 100
  endif
  !
  if (hz%gil%eval.ge.0.0) hz%gil%eval =   &
    max(hz%gil%eval,abs(hz%gil%bval*1e-7))
  if (hy%gil%eval.ge.0.0) hy%gil%eval =   &
    max(hy%gil%eval,abs(hy%gil%bval*1e-7))
  !
  ! Check input dimensions
  do i=1,4
    if (hy%gil%dim(i).ne.hz%gil%dim(i)) then
      n = 1
      do j=i,4
        n = n*hz%gil%dim(j)
      enddo
      if (n.ne.1) then
        call gagout('F-COMBINE,  Input images are non coincident')
        goto 100
      else
        call gagout('W-COMBINE,  Combining a cube with a plane')
      endif
    endif
  enddo
  !
  call gildas_null(hx)
  call gdf_copy_header(hy,hx,error)
  call sic_parsef(namex,hx%file,' ','.gdf')
  hx%gil%extr_words = 0
  hx%gil%blan_words = 2
  hx%gil%bval = b
  hx%gil%eval = 0.0
  !
  ! Allocate the arrays. Note that the allocated arrays do not conform
  ! to the shape of the images: DZ is allocated as a 1-D array, DX,DY
  ! as 2-D arrays, possibly of second dimension 1.
  !
  n = hz%loca%size
  m = hx%loca%size/hz%loca%size
  allocate(dx(n,m),dy(n,m),dz(n),stat=ier)
  if (ier.ne.0) then
    call gagout('F-COMBINE,  Input images are non coincident')
    goto 100
  endif
  !
  ! Read the input data
  call gdf_read_data(hz,dz,error)
  call gdf_read_data(hy,dy,error)
  !
  if (code.eq.'ADD') then
    call add002(dz,dy,dx,   &
      n,m,   &
      hz%gil%bval,hz%gil%eval,az,tz,   &
      hy%gil%bval,hy%gil%eval,ay,ty,   &
      hx%gil%bval,c)
  elseif (code.eq.'DIVIDE') then
    call div002(dz,dy,dx,   &
      n,m,   &
      hz%gil%bval,hz%gil%eval,az,tz,   &
      hy%gil%bval,hy%gil%eval,ay,ty,   &
      hx%gil%bval,c)
  elseif (code.eq.'MULTIPLY') then
    call mul002(dz,dy,dx,   &
      n,m,   &
      hz%gil%bval,hz%gil%eval,az,tz,   &
      hy%gil%bval,hy%gil%eval,ay,ty,   &
      hx%gil%bval,c)
  elseif (code.eq.'OPTICAL_DEPTH') then
    call opt002(dz,dy,dx,   &
      n,m,   &
      hz%gil%bval,hz%gil%eval,az,tz,   &
      hy%gil%bval,hy%gil%eval,ay,ty,   &
      hx%gil%bval,c)
  else
    call gagout('Invalid operation code '//code)
    goto 100
  endif
  !
  ! Write ouput file
  call gdf_write_image(hx,dx,error)
  !
  stop 'S-COMBINE,  Successful completion'
  !
  100     call sysexi (fatale)
end program combine
!
subroutine add002(z,y,x,n,m,bz,ez,az,tz,by,ey,ay,ty,bx,c)
  !---------------------------------------------------------------------
  ! GDF	Internal routine
  !	Linear combination of input arrays
  !	X = Ay*Y + Az*Z + C
  ! Arguments
  !	Z		R*4(*)	Input array (N)
  !	Y		R*4(*)	Input array (N,M)
  !	X		R*4(*)	Output array (N,M)
  !	N,M		I	Dimensions of arrays
  !	BX,BY,BZ	R*4	Blanking values
  !	EY,EZ		R*4	Tolerance on blanking
  !	AZ,AY		R*4	Multiplicative factor of array Z, Y
  !	TZ,TY		R*4	Threshold on Z,Y
  !	C		R*4	Additive constant
  !---------------------------------------------------------------------
  integer :: n                      !
  real :: z(n)                      !
  integer :: m                      !
  real :: y(n,m)                    !
  real :: x(n,m)                    !
  real :: bz                        !
  real :: ez                        !
  real :: az                        !
  real :: tz                        !
  real :: by                        !
  real :: ey                        !
  real :: ay                        !
  real :: ty                        !
  real :: bx                        !
  real :: c                         !
  ! Local
  integer :: i,k
  !
  do k=1,m
    do i=1,n
      if (abs(z(i)-bz).gt.ez .and. abs(y(i,k)-by).gt.ey   &
     &        .and. z(i).gt.tz .and. y(i,k).gt.ty) then
        x(i,k) = ay*y(i,k) + az*z(i)  +  c
      else
        x(i,k) = bx
      endif
    enddo
  enddo
end subroutine add002
!
subroutine div002(z,y,x,n,m,bz,ez,az,tz,by,ey,ay,ty,bx,c)
  !---------------------------------------------------------------------
  ! GDF	Internal routine
  !	Optical depth from input arrays
  !	X = Ay*Y / Az*Z + C
  ! Arguments
  !	Z		R*4(*)	Input array (N)
  !	Y		R*4(*)	Input array (N,M)
  !	X		R*4(*)	Output array (N,M)
  !	N,M		I	Dimensions of arrays
  !	BX,BY,BZ	R*4	Blanking values
  !	EY,EZ		R*4	Tolerance on blanking
  !	AZ,AY		R*4	Multiplicative factor of array Z, Y
  !	TZ,TY		R*4	Threshold on Z,Y
  !	C		R*4	Additive constant
  !---------------------------------------------------------------------
  integer :: n                      !
  real :: z(n)                      !
  integer :: m                      !
  real :: y(n,m)                    !
  real :: x(n,m)                    !
  real :: bz                        !
  real :: ez                        !
  real :: az                        !
  real :: tz                        !
  real :: by                        !
  real :: ey                        !
  real :: ay                        !
  real :: ty                        !
  real :: bx                        !
  real :: c                         !
  ! Local
  integer :: i,k
  real :: ayz
  !
  ayz = ay/az
  do k=1,m
    do i=1,n
      if (abs(z(i)-bz).gt.ez .and. abs(y(i,k)-by).gt.ey   &
     &        .and. z(i).gt.tz .and. y(i,k).gt.ty) then
        x(i,k) = ayz * y(i,k) / z(i)  +  c
      else
        x(i,k) = bx
      endif
    enddo
  enddo
end subroutine div002
!
subroutine mul002(z,y,x,n,m,bz,ez,az,tz,by,ey,ay,ty,bx,c)
  !---------------------------------------------------------------------
  ! GDF	Internal routine
  !	Multiplication of input arrays
  !	X = Ay*Y * Az*Z + B
  ! Arguments
  !	Z		R*4(*)	Input array (N)
  !	Y		R*4(*)	Input array (N,M)
  !	X		R*4(*)	Output array (N,M)
  !	N,M		I	Dimensions of arrays
  !	BX,BY,BZ	R*4	Blanking values
  !	EY,EZ		R*4	Tolerance on blanking
  !	AZ,AY		R*4	Multiplicative factor of array Z, Y
  !	TZ,TY		R*4	Threshold on Z,Y
  !	C		R*4	Additive constant
  !---------------------------------------------------------------------
  integer :: n                      !
  real :: z(n)                      !
  integer :: m                      !
  real :: y(n,m)                    !
  real :: x(n,m)                    !
  real :: bz                        !
  real :: ez                        !
  real :: az                        !
  real :: tz                        !
  real :: by                        !
  real :: ey                        !
  real :: ay                        !
  real :: ty                        !
  real :: bx                        !
  real :: c                         !
  ! Local
  integer :: i,k
  real :: ayz
  !
  ayz = ay*az
  do k=1,m
    do i=1,n
      if (abs(z(i)-bz).gt.ez .and. abs(y(i,k)-by).gt.ey   &
     &        .and. z(i).gt.tz .and. y(i,k).gt.ty) then
        x(i,k) = ayz * z(i) * y(i,k) +  c
      else
        x(i,k) = bx
      endif
    enddo
  enddo
end subroutine mul002
!
subroutine opt002(z,y,x,n,m,bz,ez,az,tz,by,ey,ay,ty,bx,c)
  !---------------------------------------------------------------------
  ! GDF	Internal routine
  !	Optical depth from input arrays
  !	X = - LOG ( Ay*Y / Az*Z + C )
  ! Arguments
  !	Z		R*4(*)	Input array (N)
  !	Y		R*4(*)	Input array (N,M)
  !	X		R*4(*)	Output array (N,M)
  !	N,M		I	Dimensions of arrays
  !	BX,BY,BZ	R*4	Blanking values
  !	EY,EZ		R*4	Tolerance on blanking
  !	AZ,AY		R*4	Multiplicative factor of array Z, Y
  !	TZ,TY		R*4	Threshold on Z,Y
  !	C		R*4	Additive constant
  !---------------------------------------------------------------------
  integer :: n                      !
  real :: z(n)                      !
  integer :: m                      !
  real :: y(n,m)                    !
  real :: x(n,m)                    !
  real :: bz                        !
  real :: ez                        !
  real :: az                        !
  real :: tz                        !
  real :: by                        !
  real :: ey                        !
  real :: ay                        !
  real :: ty                        !
  real :: bx                        !
  real :: c                         !
  ! Local
  real :: v
  integer :: i,k
  real :: ayz
  !
  ayz = ay/az
  do k=1,m
    do i=1,n
      if (abs(z(i)-bz).gt.ez .and. abs(y(i,k)-by).gt.ey   &
     &        .and. z(i).gt.tz .and. y(i,k).gt.ty) then
        v = ayz * y(i,k) / z(i)  +  c
        if (v.gt.0.0) then
          x(i,k) = - log( v )
        else
          x(i,k) = bx
        endif
      else
        x(i,k) = bx
      endif
    enddo
  enddo
end subroutine opt002

program merge
  use image_def
  use gkernel_interfaces
  !---------------------------------------------------------------------
  ! GILDAS	Stand Alone Program
  !	Merges column by column or line by line
  !     two input tables into a third one
  ! S. Guilloteau
  !---------------------------------------------------------------------
  ! Global
  type (gildas) :: tab1
  type (gildas) :: tab2
  type (gildas) :: out
  !
  logical :: error,doline
  integer :: ier
  character(len=filename_length) :: namex,namey,namez
  !
  ! Open file
  call gildas_open
  call gildas_char('Z_TABLE$',namez)
  call gildas_char('Y_TABLE$',namey)
  call gildas_char('X_TABLE$',namex)
  call gildas_logi('LINE$',doline,1)
  call gildas_close
  !
  call gildas_null(tab1)
  call gildas_null(tab2)
  call gildas_null(out, type = 'TABLE')
  call sic_parsef(namez,tab1%file,' ','.tab')
  call sic_parsef(namey,tab2%file,' ','.tab')
  call sic_parsef(namex,out%file,' ','.tab')
  !
  ! Check files
  call merge_file_check(tab1,tab2,out,doline,error)
  if (error) then
     call sysexi(fatale)
  endif
  !
  ! Allocate work space
  allocate ( &
       tab1%r2d(tab1%gil%dim(1),tab1%gil%dim(2)), &
       tab2%r2d(tab2%gil%dim(1),tab2%gil%dim(2)), & 
       out%r2d(out%gil%dim(1),out%gil%dim(2)), &
       stat=ier)
  if (ier.ne.0) then
     call gagout('E-MERGE, Memory allocation error')
     call sysexi(fatale)
  endif
  call gdf_read_data(tab1,tab1%r2d,error)
  call gdf_read_data(tab2,tab2%r2d,error)
  !
  call merge_file_do(tab1,tab2,out,doline)
  call gdf_write_image(out,out%r2d,error)
  if (error) call sysexi(fatale)
  !
  call gagout('S-MERGE,  Successful completion')
end program merge
!  
subroutine merge_file_check(tab1,tab2,out,doline,error)
  use image_def
  use gkernel_interfaces
  type (gildas), intent(inout) :: tab1
  type (gildas), intent(inout) :: tab2
  type (gildas), intent(inout) :: out
  logical, intent(in) :: doline ! Line or Column mode
  logical, intent(out) :: error
  !
  integer icheck
  character(len=10) verb
  !
  call gdf_read_header(tab1,error)
  if (error) then 
     call gagout('F-MERGE, Cannot read Table 1')
     return 
  endif
  if (tab1%gil%ndim.ne.2) then
     call gagout('F-MERGE, File 1 is not a 2-D Table')
     error = .true.
     return
  endif
  !
  call gdf_read_header(tab2,error)
  if (error) then 
     call gagout('F-MERGE, Cannot read Table 2')
     return 
  endif
  if (tab2%gil%ndim.ne.2) then
     call gagout('F-MERGE, File 2 is not a 2-D Table')
     error = .true.
     return
  endif
  !
  ! Line mode: must have same number of Columns
  if (doline) then
     icheck = 2
     verb = 'Columns'
  else
     icheck = 1
     verb = 'Lines'
  endif
  if (tab1%gil%dim(icheck).ne.tab2%gil%dim(icheck)) then
     call gagout('E-MERGE, Tables do not have the same number of '//verb)
     error = .true.
     return
  endif
  !
  out%gil%ndim = 2
  out%gil%dim(icheck) = tab1%gil%dim(icheck)
  out%gil%dim(3-icheck) = tab1%gil%dim(3-icheck) + tab2%gil%dim(3-icheck)
end subroutine merge_file_check
!
subroutine merge_file_do(tab1,tab2,out,doline)
  use image_def
  type (gildas), intent(inout) :: tab1
  type (gildas), intent(inout) :: tab2
  type (gildas), intent(inout) :: out
  logical, intent(in) :: doline ! Line or Column mode
  !
  integer :: i,nc,nx,ny,nz
  !
  ! Line mode: must have same number of Columns
  if (doline) then
     nc = out%gil%dim(2)
     nx = tab1%gil%dim(1)
     ny = nx+1
     nz = out%gil%dim(1)
     do i=1,nc
        out%r2d(1:nx, i) = tab1%r2d(:,i)
        out%r2d(ny:nz,i) = tab2%r2d(:,i)
     enddo
  else
     nc = tab1%gil%dim(1)
     nx = tab1%gil%dim(2)
     ny = nx+1
     nz = out%gil%dim(2)
     out%r2d(:,1:nx) = tab1%r2d
     out%r2d(:,ny:nz) = tab2%r2d
  endif
end subroutine merge_file_do

!-----------------------------------------------------------------------
!  Support file for writing the content of a Sic variable into a target
! Fortran variable, with automatic type casting.
!  (For the reverse operation, i.e. writing a Sic variable into a
! Fortran variable, see file get.f90)
!-----------------------------------------------------------------------
!
subroutine r8_fill(n,array,value)
  use sic_interfaces
  use gildas_def
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !---------------------------------------------------------------------
  integer(kind=size_length), intent(in)  :: n         ! Size of array
  real(kind=8),              intent(out) :: array(n)  ! Array
  real(kind=8),              intent(in)  :: value     ! Scalar value to assign
  !
  array(1:n) = value
end subroutine r8_fill
!
subroutine r4_fill(n,array,value)
  use sic_interfaces
  use gildas_def
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !---------------------------------------------------------------------
  integer(kind=size_length), intent(in)  :: n         ! Size of array
  real(kind=4),              intent(out) :: array(n)  ! Array
  real(kind=4),              intent(in)  :: value     ! Scalar value to assign
  !
  array(1:n) = value
end subroutine r4_fill
!
subroutine i8_fill(n,array,value)
  use sic_interfaces
  use gildas_def
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !---------------------------------------------------------------------
  integer(kind=size_length), intent(in)  :: n         ! Size of array
  integer(kind=8),           intent(out) :: array(n)  ! Array
  integer(kind=8),           intent(in)  :: value     ! Scalar value to assign
  !
  array(1:n) = value
end subroutine i8_fill
!
subroutine i4_fill(n,array,value)
  use sic_interfaces
  use gildas_def
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !---------------------------------------------------------------------
  integer(kind=size_length), intent(in)  :: n         ! Size of array
  integer(kind=4),           intent(out) :: array(n)  ! Array
  integer(kind=4),           intent(in)  :: value     ! Scalar value to assign
  !
  array(1:n) = value
end subroutine i4_fill
!
subroutine c4_fill(n,array,value)
  use sic_interfaces
  use gildas_def
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !---------------------------------------------------------------------
  integer(kind=size_length), intent(in)  :: n         ! Size of array
  complex(kind=4),           intent(out) :: array(n)  ! Array
  complex(kind=4),           intent(in)  :: value     ! Scalar value to assign
  !
  array(1:n) = value
end subroutine c4_fill
!
subroutine mask_fill (idesc,odesc,ldesc)
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>mask_fill
  use gildas_def
  use gbl_format
  use sic_types
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(sic_descriptor_t) :: idesc  !
  type(sic_descriptor_t) :: odesc  !
  type(sic_descriptor_t) :: ldesc  !
  ! Global
  include 'gbl_memory.inc'
  ! Local
  integer(kind=size_length) :: size
  integer(kind=address_length) :: ipnt,opnt,lpnt
  !
  ipnt = gag_pointer(idesc%addr,memory)
  opnt = gag_pointer(odesc%addr,memory)
  lpnt = gag_pointer(ldesc%addr,memory)
  size = ldesc%size
  if (idesc%type.eq.fmt_r8 .or. idesc%type.eq.fmt_i8) then
    call mask_fill_r8 (memory(ipnt),memory(opnt),memory(lpnt),size)
  else
    call mask_fill_r4 (memory(ipnt),memory(opnt),memory(lpnt),size)
  endif
end subroutine mask_fill
!
subroutine mask_fill_r4(in,out,mask,n)
  use sic_interfaces
  use gildas_def
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  ! Fill OUT array with IN array values where MASK logical array is .true.
  ! Integer*4 / Real*4 / Logical*4 version for IN/OUT arrays.
  !---------------------------------------------------------------------
  integer(kind=size_length), intent(in)  :: n  ! Number of elements in arrays
  integer*4, intent(in)    :: in(n)            ! Read values from this one
  integer*4, intent(inout) :: out(n)           ! Put values in this one
  logical,   intent(in)    :: mask(n)          ! Mask array
  !
  where (mask) out = in
end subroutine mask_fill_r4
!
subroutine mask_fill_r8(in,out,mask,n)
  use sic_interfaces
  use gildas_def
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  ! Fill OUT array with IN array values where MASK logical array is .true.
  ! Integer*8 / Real*8 version for IN/OUT arrays.
  !---------------------------------------------------------------------
  integer(kind=size_length), intent(in) :: n  ! Number of elements in arrays
  real*8,  intent(in)    :: in(n)             ! Read values from this one
  real*8,  intent(inout) :: out(n)            ! Put values in this one
  logical, intent(in)    :: mask(n)           ! Mask array
  !
  where (mask) out = in
end subroutine mask_fill_r8
!
!-----------------------------------------------------------------------
!
subroutine sic_variable_filli4_0d(caller,varname,i4,error)
  use gildas_def
  use sic_interfaces, except_this=>sic_variable_filli4_0d
  !---------------------------------------------------------------------
  ! @ public-generic sic_variable_fill
  !  Fill a SIC variable with the i4 value
  ! ---
  !  Scalar version
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: caller   !
  character(len=*), intent(in)    :: varname  !
  integer(kind=4),  intent(in)    :: i4       ! Scalar value to be copied
  logical,          intent(inout) :: error    ! Logical error flag
  ! Local
  integer(kind=4) :: val(1)
  integer(kind=size_length), parameter :: one=1
  !
  val(1) = i4
  call sic_variable_filli4_1d(caller,varname,val,one,error)
  if (error)  return
  !
end subroutine sic_variable_filli4_0d
!
subroutine sic_variable_filli4_1d(caller,varname,i4,nelem,error)
  use gbl_message
  use sic_interfaces, except_this=>sic_variable_filli4_1d
  use sic_types
  !---------------------------------------------------------------------
  ! @ public-generic sic_variable_fill
  !  Fill a SIC variable with the i4 value
  ! ---
  !  Flat array version
  !---------------------------------------------------------------------
  character(len=*),          intent(in)    :: caller   !
  character(len=*),          intent(in)    :: varname  !
  integer(kind=4),           intent(in)    :: i4(*)    ! Flat array of values to be copied
  integer(kind=size_length), intent(in)    :: nelem    ! Number of i4 values
  logical,                   intent(inout) :: error    ! Logical error flag
  ! Local
  type(sic_descriptor_t) :: desc
  !
  call sic_variable_getdesc(caller,varname,.true.,desc,error)
  if (error)  return
  !
  call sic_descriptor_fill_i41d(desc,i4,nelem,error)
  if (error)  return
  !
end subroutine sic_variable_filli4_1d
!
subroutine sic_variable_filli8_0d(caller,varname,i8,error)
  use gildas_def
  use sic_interfaces, except_this=>sic_variable_filli8_0d
  !---------------------------------------------------------------------
  ! @ public-generic sic_variable_fill
  !  Fill a SIC variable with the i8 value
  ! ---
  !  Scalar version
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: caller   !
  character(len=*), intent(in)    :: varname  !
  integer(kind=8),  intent(in)    :: i8       ! Scalar value to be copied
  logical,          intent(inout) :: error    ! Logical error flag
  ! Local
  integer(kind=8) :: val(1)
  integer(kind=size_length), parameter :: one=1
  !
  val(1) = i8
  call sic_variable_filli8_1d(caller,varname,val,one,error)
  if (error)  return
  !
end subroutine sic_variable_filli8_0d
!
subroutine sic_variable_filli8_1d(caller,varname,i8,nelem,error)
  use gbl_message
  use sic_interfaces, except_this=>sic_variable_filli8_1d
  use sic_types
  !---------------------------------------------------------------------
  ! @ public-generic sic_variable_fill
  !  Fill a SIC variable with the i8 value
  ! ---
  !  Flat array version
  !---------------------------------------------------------------------
  character(len=*),          intent(in)    :: caller   !
  character(len=*),          intent(in)    :: varname  !
  integer(kind=8),           intent(in)    :: i8(*)    ! Flat array of values to be copied
  integer(kind=size_length), intent(in)    :: nelem    ! Number of i8 values
  logical,                   intent(inout) :: error    ! Logical error flag
  ! Local
  type(sic_descriptor_t) :: desc
  !
  call sic_variable_getdesc(caller,varname,.true.,desc,error)
  if (error)  return
  !
  call sic_descriptor_fill_i81d(desc,i8,nelem,error)
  if (error)  return
  !
end subroutine sic_variable_filli8_1d
!
subroutine sic_variable_fillr4_0d(caller,varname,r4,error)
  use gildas_def
  use sic_interfaces, except_this=>sic_variable_fillr4_0d
  !---------------------------------------------------------------------
  ! @ public-generic sic_variable_fill
  !  Fill a SIC variable with the r4 value
  ! ---
  !  Scalar version
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: caller   !
  character(len=*), intent(in)    :: varname  !
  real(kind=4),     intent(in)    :: r4       ! Scalar value to be copied
  logical,          intent(inout) :: error    ! Logical error flag
  ! Local
  real(kind=4) :: val(1)
  integer(kind=size_length), parameter :: one=1
  !
  val(1) = r4
  call sic_variable_fillr4_1d(caller,varname,val,one,error)
  if (error)  return
  !
end subroutine sic_variable_fillr4_0d
!
subroutine sic_variable_fillr4_1d(caller,varname,r4,nelem,error)
  use gbl_message
  use sic_interfaces, except_this=>sic_variable_fillr4_1d
  use sic_types
  !---------------------------------------------------------------------
  ! @ public-generic sic_variable_fill
  !  Fill a SIC variable with the r4 value
  ! ---
  !  Flat array version
  !---------------------------------------------------------------------
  character(len=*),          intent(in)    :: caller   !
  character(len=*),          intent(in)    :: varname  !
  real(kind=4),              intent(in)    :: r4(*)    ! Flat array of values to be copied
  integer(kind=size_length), intent(in)    :: nelem    ! Number of r4 values
  logical,                   intent(inout) :: error    ! Logical error flag
  ! Local
  type(sic_descriptor_t) :: desc
  !
  call sic_variable_getdesc(caller,varname,.true.,desc,error)
  if (error)  return
  !
  call sic_descriptor_fill_r41d(desc,r4,nelem,error)
  if (error)  return
  !
end subroutine sic_variable_fillr4_1d
!
subroutine sic_variable_fillr8_0d(caller,varname,r8,error)
  use gildas_def
  use sic_interfaces, except_this=>sic_variable_fillr8_0d
  !---------------------------------------------------------------------
  ! @ public-generic sic_variable_fill
  !  Fill a SIC variable with the r8 value
  ! ---
  !  Scalar version
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: caller   !
  character(len=*), intent(in)    :: varname  !
  real(kind=8),     intent(in)    :: r8       ! Scalar value to be copied
  logical,          intent(inout) :: error    ! Logical error flag
  ! Local
  real(kind=8) :: val(1)
  integer(kind=size_length), parameter :: one=1
  !
  val(1) = r8
  call sic_variable_fillr8_1d(caller,varname,val,one,error)
  if (error)  return
  !
end subroutine sic_variable_fillr8_0d
!
subroutine sic_variable_fillr8_1d(caller,varname,r8,nelem,error)
  use gbl_message
  use sic_interfaces, except_this=>sic_variable_fillr8_1d
  use sic_types
  !---------------------------------------------------------------------
  ! @ public-generic sic_variable_fill
  !  Fill a SIC variable with the r8 value
  ! ---
  !  Flat array version
  !---------------------------------------------------------------------
  character(len=*),          intent(in)    :: caller   !
  character(len=*),          intent(in)    :: varname  !
  real(kind=8),              intent(in)    :: r8(*)    ! Flat array of values to be copied
  integer(kind=size_length), intent(in)    :: nelem    ! Number of r8 values
  logical,                   intent(inout) :: error    ! Logical error flag
  ! Local
  type(sic_descriptor_t) :: desc
  !
  call sic_variable_getdesc(caller,varname,.true.,desc,error)
  if (error)  return
  !
  call sic_descriptor_fill_r81d(desc,r8,nelem,error)
  if (error)  return
  !
end subroutine sic_variable_fillr8_1d
!
subroutine sic_variable_fillc4_0d(caller,varname,c4,error)
  use gildas_def
  use sic_interfaces, except_this=>sic_variable_fillc4_0d
  !---------------------------------------------------------------------
  ! @ public-generic sic_variable_fill
  !  Fill a SIC variable with the c4 value
  ! ---
  !  Scalar version
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: caller   !
  character(len=*), intent(in)    :: varname  !
  complex(kind=4),  intent(in)    :: c4       ! Scalar value to be copied
  logical,          intent(inout) :: error    ! Logical error flag
  ! Local
  complex(kind=4) :: val(1)
  integer(kind=size_length), parameter :: one=1
  !
  val(1) = c4
  call sic_variable_fillc4_1d(caller,varname,val,one,error)
  if (error)  return
  !
end subroutine sic_variable_fillc4_0d
!
subroutine sic_variable_fillc4_1d(caller,varname,c4,nelem,error)
  use gbl_message
  use sic_interfaces, except_this=>sic_variable_fillc4_1d
  use sic_types
  !---------------------------------------------------------------------
  ! @ public-generic sic_variable_fill
  !  Fill a SIC variable with the c4 value
  ! ---
  !  Flat array version
  !---------------------------------------------------------------------
  character(len=*),          intent(in)    :: caller   !
  character(len=*),          intent(in)    :: varname  !
  complex(kind=4),           intent(in)    :: c4(*)    ! Flat array of values to be copied
  integer(kind=size_length), intent(in)    :: nelem    ! Number of c4 values
  logical,                   intent(inout) :: error    ! Logical error flag
  ! Local
  type(sic_descriptor_t) :: desc
  !
  call sic_variable_getdesc(caller,varname,.true.,desc,error)
  if (error)  return
  !
  call sic_descriptor_fill_c41d(desc,c4,nelem,error)
  if (error)  return
  !
end subroutine sic_variable_fillc4_1d
!
subroutine sic_variable_filll_0d(caller,varname,l,error)
  use gildas_def
  use sic_interfaces, except_this=>sic_variable_filll_0d
  !---------------------------------------------------------------------
  ! @ public-generic sic_variable_fill
  !  Fill a SIC variable with the l value
  ! ---
  !  Scalar version
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: caller   !
  character(len=*), intent(in)    :: varname  !
  logical,          intent(in)    :: l        ! Scalar value to be copied
  logical,          intent(inout) :: error    ! Logical error flag
  ! Local
  logical :: val(1)
  integer(kind=size_length), parameter :: one=1
  !
  val(1) = l
  call sic_variable_filll_1d(caller,varname,val,one,error)
  if (error)  return
  !
end subroutine sic_variable_filll_0d
!
subroutine sic_variable_filll_1d(caller,varname,l,nelem,error)
  use gbl_message
  use sic_interfaces, except_this=>sic_variable_filll_1d
  use sic_types
  !---------------------------------------------------------------------
  ! @ public-generic sic_variable_fill
  !  Fill a SIC variable with the l value
  ! ---
  !  Flat array version
  !---------------------------------------------------------------------
  character(len=*),          intent(in)    :: caller   !
  character(len=*),          intent(in)    :: varname  !
  logical,                   intent(in)    :: l(*)     ! Flat array of values to be copied
  integer(kind=size_length), intent(in)    :: nelem    ! Number of l values
  logical,                   intent(inout) :: error    ! Logical error flag
  ! Local
  type(sic_descriptor_t) :: desc
  !
  call sic_variable_getdesc(caller,varname,.true.,desc,error)
  if (error)  return
  !
  call sic_descriptor_fill_l1d(desc,l,nelem,error)
  if (error)  return
  !
end subroutine sic_variable_filll_1d
!
subroutine sic_variable_fillch_0d(caller,varname,ch,error)
  use gildas_def
  use sic_interfaces, except_this=>sic_variable_fillch_0d
  !---------------------------------------------------------------------
  ! @ public-generic sic_variable_fill
  !  Fill a SIC variable with the ch value
  ! ---
  !  Scalar version
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: caller   !
  character(len=*), intent(in)    :: varname  !
  character(len=*), intent(in)    :: ch       ! Scalar value to be copied
  logical,          intent(inout) :: error    ! Logical error flag
  ! Local
  character(len=512) :: val(1)  ! Arbitrary limited to 512 characters
  integer(kind=size_length), parameter :: one=1
  !
  val(1) = ch
  call sic_variable_fillch_1d(caller,varname,val,one,error)
  if (error)  return
  !
end subroutine sic_variable_fillch_0d
!
subroutine sic_variable_fillch_1d(caller,varname,ch,nelem,error)
  use gbl_message
  use sic_interfaces, except_this=>sic_variable_fillch_1d
  use sic_types
  !---------------------------------------------------------------------
  ! @ public-generic sic_variable_fill
  !  Fill a SIC variable with the ch value
  ! ---
  !  Flat array version
  !---------------------------------------------------------------------
  character(len=*),          intent(in)    :: caller   !
  character(len=*),          intent(in)    :: varname  !
  character(len=*),          intent(in)    :: ch(*)    ! Flat array of values to be copied
  integer(kind=size_length), intent(in)    :: nelem    ! Number of l values
  logical,                   intent(inout) :: error    ! Logical error flag
  ! Local
  type(sic_descriptor_t) :: desc
  !
  call sic_variable_getdesc(caller,varname,.true.,desc,error)
  if (error)  return
  !
  call sic_descriptor_fill_ch1d(desc,ch,nelem,error)
  if (error)  return
  !
end subroutine sic_variable_fillch_1d
!
subroutine sic_variable_getdesc(caller,varname,readwrite,desc,error)
  use gbl_message
  use sic_interfaces, except_this=>sic_variable_getdesc
  use sic_types
  !---------------------------------------------------------------------
  ! @ private
  ! Get the descriptor of a variable and perform the appropriate checks
  ! for use by the sic_variable_fill* subroutines
  !---------------------------------------------------------------------
  character(len=*),       intent(in)    :: caller     ! Calling routine name
  character(len=*),       intent(in)    :: varname    !
  logical,                intent(in)    :: readwrite  ! Need read-write access?
  type(sic_descriptor_t), intent(out)   :: desc       !
  logical,                intent(inout) :: error      !
  ! Local
  logical :: found
  !
  found = .true.  ! Verbose
  call sic_descriptor(varname,desc,found)
  if (.not.found) then
    call sic_message(seve%e,caller,'No such variable '//varname)
    error = .true.
    return
  endif
  if (readwrite .and. desc%readonly) then
    ! NB: maybe we would like to allow writing in a read-only variable
    ! from the program. Pass a flag to the subroutine?
    call sic_message(seve%e,caller,'Readonly variables cannot be modified')
    error = .true.
    return
  endif
  !
end subroutine sic_variable_getdesc
!
!-----------------------------------------------------------------------
!
subroutine sic_descriptor_getnelem(desc,neleml,istarget,nelem0,ipnt0,error)
  use gildas_def
  use gbl_format
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_descriptor_getnelem
  use sic_types
  !---------------------------------------------------------------------
  ! @ private
  !  Compute and return the number of elements and the 'ipnt' of the Sic
  ! variable described by its descriptor, and check if it is consistent
  ! with 'neleml'.
  !  Technical subroutine mostly to be used by the sic_descriptor_fill*
  ! and sic_descriptor_getval* subroutines below.
  !---------------------------------------------------------------------
  type(sic_descriptor_t),       intent(in)    :: desc      !
  integer(kind=size_length),    intent(in)    :: neleml    !
  logical,                      intent(in)    :: istarget  ! 'desc' is target or source of values?
  integer(kind=size_length),    intent(out)   :: nelem0    !
  integer(kind=address_length), intent(out)   :: ipnt0     !
  logical,                      intent(inout) :: error     !
  ! Global
  include 'gbl_memory.inc'
  ! Local
  character(len=*), parameter :: rname='MTH'
  character(len=message_length) :: mess
  logical :: match
  !
  if (istarget .and. desc%readonly) then
    call sic_message(seve%e,rname,'Variable is read-only')
    error = .true.
    return
  endif
  !
  ! Convert Nwords to Nelem
  select case (desc%type)
  case (fmt_r8,fmt_i8,fmt_c4)
    nelem0 = desc%size/2
  case (fmt_r4,fmt_i4,fmt_l)
    nelem0 = desc%size
  case (fmt_un)
    call sic_message(seve%e,rname,'Data type is unknown (fmt_un)')
    error = .true.
    return
  case default
    if (desc%type.gt.0) then
      call sic_message(seve%e,rname,  &
        'Can not convert character string to/from numeric or logical')
    else
      call sic_message(seve%e,rname,'Data type not supported (4)')
    endif
    error = .true.
    return
  end select
  !
  ! Accepted combinations are:
  ! - arrays of equal size
  ! - input is scalar and output is array
  match = nelem0.eq.neleml             .or.  &
          (istarget .and. neleml.eq.1) .or.  &  ! desc is output
          (.not.istarget .and. nelem0.eq.1)     ! desc is input
  if (.not.match) then
    write(mess,'(A,I0,1X,I0)')  &
      'Mathematics on arrays of inconsistent dimensions ',nelem0,neleml
    call sic_message(seve%e,rname,mess)
    error = .true.
    return
  endif
  !
  ipnt0 = gag_pointer(desc%addr,memory)
  !
end subroutine sic_descriptor_getnelem
!
subroutine sic_descriptor_get1elem(desc,istarget,ielem,ipnt0,error)
  use gbl_format
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_descriptor_get1elem
  use sic_types
  !---------------------------------------------------------------------
  ! @ private
  ! Get the address of the ielem-th element in array
  !---------------------------------------------------------------------
  type(sic_descriptor_t),       intent(in)    :: desc
  logical,                      intent(in)    :: istarget  ! 'desc' is target or source of values?
  integer(kind=size_length),    intent(in)    :: ielem
  integer(kind=address_length), intent(out)   :: ipnt0
  logical,                      intent(inout) :: error
  ! Global
  include 'gbl_memory.inc'
  ! Local
  character(len=*), parameter :: rname='MTH'
  integer(kind=4) :: nwords
  character(len=message_length) :: mess
  !
  if (istarget .and. desc%readonly) then
    call sic_message(seve%e,rname,'Variable is read-only')
    error = .true.
    return
  endif
  !
  ! Convert Nwords to Nelem
  select case (desc%type)
  case (fmt_r8,fmt_i8,fmt_c4)
    nwords = 2
  case (fmt_r4,fmt_i4,fmt_l)
    nwords = 1
  case (fmt_un)
    call sic_message(seve%e,rname,'Data type is unknown (fmt_un)')
    error = .true.
    return
  case default
    if (desc%type.gt.0) then
      call sic_message(seve%e,rname,  &
        'Can not convert character string to/from numeric or logical')
    else
      call sic_message(seve%e,rname,'Data type not supported (4)')
    endif
    error = .true.
    return
  end select
  !
  if (ielem.lt.1 .or. ielem.gt.desc%size/nwords) then
    write(mess,'(A,I0,1X,I0)')  'Out of bounds ',ielem,desc%size/nwords
    call sic_message(seve%e,rname,mess)
    error = .true.
    return
  endif
  !
  ipnt0 = gag_pointer(desc%addr,memory)+(ielem-1)*nwords
  !
end subroutine sic_descriptor_get1elem
!
subroutine sic_descriptor_fill_i40d(desc,ielem,i4,error)
  use gildas_def
  use gbl_format
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_descriptor_fill_i40d
  use sic_types
  !---------------------------------------------------------------------
  ! @ public-generic sic_descriptor_fill
  !  Fill the ielem-th value from the descriptor target. The value is
  ! casted to the descriptor type if needed
  !---------------------------------------------------------------------
  type(sic_descriptor_t),    intent(in)    :: desc    ! The variable descriptor
  integer(kind=size_length), intent(in)    :: ielem   ! The value position
  integer(kind=4),           intent(in)    :: i4      ! Scalar value to fill
  logical,                   intent(inout) :: error   ! Logical error flag
  ! Global
  include 'gbl_memory.inc'
  ! Local
  character(len=*), parameter :: rname='MTH'
  integer(kind=address_length) :: ipnt0
  integer(kind=size_length), parameter :: one=1
  !
  call sic_descriptor_get1elem(desc,.true.,ielem,ipnt0,error)
  if (error)  return
  !
  select case (desc%type)
  case (fmt_i4)
    call w4tow4_sl (i4,memory(ipnt0),one)
  case (fmt_r8)
    call i4tor8_sl (i4,memory(ipnt0),one)
  case (fmt_r4)
    call i4tor4_sl (i4,memory(ipnt0),one)
  case (fmt_i8)
    call i4toi8_sl (i4,memory(ipnt0),one)
  case (fmt_c4)
    call i4toc4_sl (i4,memory(ipnt0),one)
  case default
    call sic_message(seve%e,rname,'Result type mismatch (1)')
    error = .true.
    return
  end select
  !
end subroutine sic_descriptor_fill_i40d
!
subroutine sic_descriptor_fill_r80d(desc,ielem,r8,error)
  use gildas_def
  use gbl_format
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_descriptor_fill_r80d
  use sic_types
  !---------------------------------------------------------------------
  ! @ public-generic sic_descriptor_fill
  !  Fill the ielem-th value from the descriptor target. The value is
  ! casted to the descriptor type if needed
  !---------------------------------------------------------------------
  type(sic_descriptor_t),    intent(in)    :: desc    ! The variable descriptor
  integer(kind=size_length), intent(in)    :: ielem   ! The value position
  real(kind=8),              intent(in)    :: r8      ! Scalar value to fill
  logical,                   intent(inout) :: error   ! Logical error flag
  ! Global
  include 'gbl_memory.inc'
  ! Local
  character(len=*), parameter :: rname='MTH'
  integer(kind=address_length) :: ipnt0
  integer(kind=size_length), parameter :: one=1
  !
  call sic_descriptor_get1elem(desc,.true.,ielem,ipnt0,error)
  if (error)  return
  !
  select case (desc%type)
  case (fmt_r8)
    call w8tow8_sl (r8,memory(ipnt0),one)
  case (fmt_r4)
    call r8tor4_sl (r8,memory(ipnt0),one)
  case (fmt_i4)
    call r8toi4_fini_sl (r8,memory(ipnt0),one,error)
    if (error)  return
  case (fmt_i8)
    call r8toi8_fini_sl (r8,memory(ipnt0),one,error)
    if (error)  return
  case (fmt_c4)
    call r8toc4_sl (r8,memory(ipnt0),one)
  case default
    call sic_message(seve%e,rname,'Result type mismatch (2)')
    error = .true.
    return
  end select
  !
end subroutine sic_descriptor_fill_r80d
!
subroutine sic_descriptor_fill_ch0d(desc,ielem,ch,error)
  use gildas_def
  use gbl_format
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_descriptor_fill_ch0d
  use sic_types
  !---------------------------------------------------------------------
  ! @ public-generic sic_descriptor_fill
  !  Fill a descriptor target with the ch(*) values. A consistency check
  ! of the number of values is performed, and value is casted if needed
  ! to be SIC variable type if needed.
  !---------------------------------------------------------------------
  type(sic_descriptor_t),    intent(in)    :: desc    ! The variable descriptor
  integer(kind=size_length), intent(in)    :: ielem   ! The value position
  character(len=*),          intent(in)    :: ch      ! Scalar string to fill
  logical,                   intent(inout) :: error   ! Logical error flag
  ! Global
  include 'gbl_memory.inc'
  ! Local
  character(len=*), parameter :: rname='MTH'
  integer(kind=address_length) :: addr
  !
  if (ielem.lt.1 .or. ielem.gt.desc_nelem(desc)) then
    call sic_message(seve%e,rname,'Out of bounds (1)')
    error = .true.
    return
  endif
  !
  if (desc%type.le.0) then
    call sic_message(seve%e,rname,'Can not convert character to numeric/logical')
    error = .true.
    return
  endif
  !
  addr = desc%addr+(ielem-1)*desc%type
  call ctodes(ch,desc%type,addr)
  !
end subroutine sic_descriptor_fill_ch0d
!
subroutine sic_descriptor_fill_i41d(desc,i4,neleml,error)
  use gildas_def
  use gbl_format
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_descriptor_fill_i41d
  use sic_types
  !---------------------------------------------------------------------
  ! @ public-generic sic_descriptor_fill
  !  Fill a descriptor target with the i4(*) values. A consistency check
  ! of the number of values is performed, and value is casted if needed
  ! to be SIC variable type if needed.
  !---------------------------------------------------------------------
  type(sic_descriptor_t),    intent(in)    :: desc    ! The variable descriptor
  integer(kind=4),           intent(in)    :: i4(*)   ! Flat array of values to be copied
  integer(kind=size_length), intent(in)    :: neleml  ! Number of i4 values
  logical,                   intent(inout) :: error   ! Logical error flag
  ! Global
  include 'gbl_memory.inc'
  ! Local
  character(len=*), parameter :: rname='MTH'
  integer(kind=size_length) :: nelem0
  integer(kind=address_length) :: ipnt0
  !
  ! Get appropriate and perform consistency check:
  call sic_descriptor_getnelem(desc,neleml,.true.,nelem0,ipnt0,error)
  if (error)  return
  !
  select case (desc%type)
  case (fmt_i4)
    if (neleml.eq.nelem0) then
      call w4tow4_sl (i4,memory(ipnt0),neleml)  ! Word copy
    elseif (neleml.eq.1) then
      call i4_fill(nelem0,memory(ipnt0),i4)
    endif
    !
  case (fmt_r8)
    if (neleml.eq.nelem0) then
      call i4tor8_sl (i4,memory(ipnt0),neleml)
    elseif (neleml.eq.1) then
      call i4tor8_sl (i4,memory(ipnt0),neleml)  ! Convert first element
      call r8_fill(nelem0,memory(ipnt0),memory(ipnt0) )  ! Duplicate
    endif
    !
  case (fmt_r4)
    if (neleml.eq.nelem0) then
      call i4tor4_sl (i4,memory(ipnt0),neleml)
    elseif (neleml.eq.1) then
      call i4tor4_sl (i4,memory(ipnt0),neleml)
      call r4_fill (nelem0,memory(ipnt0),memory(ipnt0) )
    endif
    !
  case (fmt_i8)
    if (neleml.eq.nelem0) then
      call i4toi8_sl (i4,memory(ipnt0),neleml)
    elseif (neleml.eq.1) then
      call i4toi8_sl (i4,memory(ipnt0),neleml)
      call i8_fill (nelem0,memory(ipnt0),memory(ipnt0) )
    endif
    !
  case (fmt_c4)
    if (neleml.eq.nelem0) then
      call i4toc4_sl (i4,memory(ipnt0),neleml)
    elseif (neleml.eq.1) then
      call i4toc4_sl (i4,memory(ipnt0),neleml)
      call c4_fill (nelem0,memory(ipnt0),memory(ipnt0) )
    endif
    !
  case default
    call sic_message(seve%e,rname,'Result type mismatch (3)')
    error = .true.
    return
  end select
  !
end subroutine sic_descriptor_fill_i41d
!
subroutine sic_descriptor_fill_i81d(desc,i8,neleml,error)
  use gildas_def
  use gbl_format
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_descriptor_fill_i81d
  use sic_types
  !---------------------------------------------------------------------
  ! @ public-generic sic_descriptor_fill
  !  Fill a descriptor target with the i8(*) values. A consistency check
  ! of the number of values is performed, and value is casted if needed
  ! to be SIC variable type if needed.
  !---------------------------------------------------------------------
  type(sic_descriptor_t),    intent(in)    :: desc    ! The variable descriptor
  integer(kind=8),           intent(in)    :: i8(*)   ! Flat array of values to be copied
  integer(kind=size_length), intent(in)    :: neleml  ! Number of i8 values
  logical,                   intent(inout) :: error   ! Logical error flag
  ! Global
  include 'gbl_memory.inc'
  ! Local
  character(len=*), parameter :: rname='MTH'
  integer(kind=size_length) :: nelem0
  integer(kind=address_length) :: ipnt0
  !
  ! Get appropriate and perform consistency check:
  call sic_descriptor_getnelem(desc,neleml,.true.,nelem0,ipnt0,error)
  if (error)  return
  !
  select case (desc%type)
  case (fmt_i8)
    if (neleml.eq.nelem0) then
      call w8tow8_sl (i8,memory(ipnt0),neleml)
    elseif (neleml.eq.1) then
      call i8_fill(nelem0,memory(ipnt0),i8)
    endif
    !
  case (fmt_r8)
    if (neleml.eq.nelem0) then
      call i8tor8_sl (i8,memory(ipnt0),neleml)
    elseif (neleml.eq.1) then
      call i8tor8_sl (i8,memory(ipnt0),neleml)
      call r8_fill(nelem0,memory(ipnt0),memory(ipnt0) )
    endif
    !
  case (fmt_r4)
    if (neleml.eq.nelem0) then
      call i8tor4_sl (i8,memory(ipnt0),neleml)
    elseif (neleml.eq.1) then
      call i8tor4_sl (i8,memory(ipnt0),neleml)
      call r4_fill (nelem0,memory(ipnt0),memory(ipnt0) )
    endif
    !
  case (fmt_i4)
    if (nelem0.eq.neleml) then
      call i8toi4_fini_sl (i8,memory(ipnt0),neleml,error)
      if (error)  return
    elseif (neleml.eq.1) then
      call i8toi4_fini_sl (i8,memory(ipnt0),neleml,error)
      if (error)  return
      call i4_fill (nelem0,memory(ipnt0),memory(ipnt0))
    endif
    !
  case (fmt_c4)
    if (nelem0.eq.neleml) then
      call i8toc4_sl (i8,memory(ipnt0),neleml)
    elseif (neleml.eq.1) then
      call i8toc4_sl (i8,memory(ipnt0),neleml)
      call c4_fill (nelem0,memory(ipnt0),memory(ipnt0))
    endif
    !
  case default
    call sic_message(seve%e,rname,'Result type mismatch (4)')
    error = .true.
    return
  end select
  !
end subroutine sic_descriptor_fill_i81d
!
subroutine sic_descriptor_fill_r41d(desc,r4,neleml,error)
  use gildas_def
  use gbl_format
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_descriptor_fill_r41d
  use sic_types
  !---------------------------------------------------------------------
  ! @ public-generic sic_descriptor_fill
  !  Fill a descriptor target with the r4(*) values. A consistency check
  ! of the number of values is performed, and value is casted if needed
  ! to be SIC variable type if needed.
  !---------------------------------------------------------------------
  type(sic_descriptor_t),    intent(in)    :: desc    ! The variable descriptor
  real(kind=4),              intent(in)    :: r4(*)   ! Flat array of values to be copied
  integer(kind=size_length), intent(in)    :: neleml  ! Number of r4 values
  logical,                   intent(inout) :: error   ! Logical error flag
  ! Global
  include 'gbl_memory.inc'
  ! Local
  character(len=*), parameter :: rname='MTH'
  integer(kind=size_length) :: nelem0
  integer(kind=address_length) :: ipnt0
  !
  ! Get appropriate and perform consistency check:
  call sic_descriptor_getnelem(desc,neleml,.true.,nelem0,ipnt0,error)
  if (error)  return
  !
  select case (desc%type)
  case (fmt_r4)
    if (neleml.eq.nelem0) then
      call w4tow4_sl (r4,memory(ipnt0),neleml)
    elseif (neleml.eq.1) then
      call r4_fill(nelem0,memory(ipnt0),r4)
    endif
    !
  case (fmt_r8)
    if (neleml.eq.nelem0) then
      call r4tor8_sl (r4,memory(ipnt0),neleml)
    elseif (neleml.eq.1) then
      call r4tor8_sl (r4,memory(ipnt0),neleml)
      call r8_fill(nelem0,memory(ipnt0),memory(ipnt0))
    endif
    !
  case (fmt_i4)
    if (neleml.eq.nelem0) then
      call r4toi4_fini_sl (r4,memory(ipnt0),neleml,error)
      if (error)  return
    elseif (neleml.eq.1) then
      call r4toi4_fini_sl (r4,memory(ipnt0),neleml,error)
      if (error)  return
      call i4_fill (nelem0,memory(ipnt0),memory(ipnt0) )
    endif
    !
  case (fmt_i8)
    if (neleml.eq.nelem0) then
      call r4toi8_fini_sl (r4,memory(ipnt0),neleml,error)
      if (error)  return
    elseif (neleml.eq.1) then
      call r4toi8_fini_sl (r4,memory(ipnt0),neleml,error)
      if (error)  return
      call i8_fill (nelem0,memory(ipnt0),memory(ipnt0) )
    endif
    !
  case (fmt_c4)
    if (neleml.eq.nelem0) then
      call r4toc4_sl (r4,memory(ipnt0),neleml)
    elseif (neleml.eq.1) then
      call r4toc4_sl (r4,memory(ipnt0),neleml)
      call c4_fill (nelem0,memory(ipnt0),memory(ipnt0) )
    endif
    !
  case default
    call sic_message(seve%e,rname,'Result type mismatch (5)')
    error = .true.
    return
  end select
  !
end subroutine sic_descriptor_fill_r41d
!
subroutine sic_descriptor_fill_r81d(desc,r8,neleml,error)
  use gildas_def
  use gbl_format
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_descriptor_fill_r81d
  use sic_types
  !---------------------------------------------------------------------
  ! @ public-generic sic_descriptor_fill
  !  Fill a descriptor target with the r8(*) values. A consistency check
  ! of the number of values is performed, and value is casted if needed
  ! to be SIC variable type if needed.
  !---------------------------------------------------------------------
  type(sic_descriptor_t),    intent(in)    :: desc    ! The variable descriptor
  real(kind=8),              intent(in)    :: r8(*)   ! Flat array of values to be copied
  integer(kind=size_length), intent(in)    :: neleml  ! Number of r8 values
  logical,                   intent(inout) :: error   ! Logical error flag
  ! Global
  include 'gbl_memory.inc'
  ! Local
  character(len=*), parameter :: rname='MTH'
  integer(kind=size_length) :: nelem0
  integer(kind=address_length) :: ipnt0
  !
  ! Get appropriate and perform consistency check:
  call sic_descriptor_getnelem(desc,neleml,.true.,nelem0,ipnt0,error)
  if (error)  return
  !
  select case (desc%type)
  case (fmt_r8)
    if (nelem0.eq.neleml) then
      call w8tow8_sl (r8,memory(ipnt0),neleml)
    elseif (neleml.eq.1) then
      call r8_fill(nelem0,memory(ipnt0),r8)
    endif
    !
  case (fmt_r4)
    if (nelem0.eq.neleml) then
      call r8tor4_sl (r8,memory(ipnt0),neleml)
    elseif (neleml.eq.1) then
      call r8tor4_sl (r8,memory(ipnt0),neleml)
      call r4_fill (nelem0,memory(ipnt0),memory(ipnt0))
    endif
    !
  case (fmt_i4)
    if (nelem0.eq.neleml) then
      call r8toi4_fini_sl (r8,memory(ipnt0),neleml,error)
      if (error)  return
    elseif (neleml.eq.1) then
      call r8toi4_fini_sl (r8,memory(ipnt0),neleml,error)
      if (error)  return
      call i4_fill (nelem0,memory(ipnt0),memory(ipnt0))
    endif
    !
  case (fmt_i8)
    if (nelem0.eq.neleml) then
      call r8toi8_fini_sl (r8,memory(ipnt0),neleml,error)
      if (error)  return
    elseif (neleml.eq.1) then
      call r8toi8_fini_sl (r8,memory(ipnt0),neleml,error)
      if (error)  return
      call i8_fill (nelem0,memory(ipnt0),memory(ipnt0))
    endif
  case (fmt_c4)
    if (nelem0.eq.neleml) then
      call r8toc4_sl (r8,memory(ipnt0),neleml)
    elseif (neleml.eq.1) then
      call r8toc4_sl (r8,memory(ipnt0),neleml)
      call c4_fill (nelem0,memory(ipnt0),memory(ipnt0))
    endif
    !
  case default
    call sic_message(seve%e,rname,'Result type mismatch (6)')
    error = .true.
    return
  end select
  !
end subroutine sic_descriptor_fill_r81d
!
subroutine sic_descriptor_fill_c41d(desc,c4,neleml,error)
  use gildas_def
  use gbl_format
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_descriptor_fill_c41d
  use sic_types
  !---------------------------------------------------------------------
  ! @ public-generic sic_descriptor_fill
  !  Fill a descriptor target with the c4(*) values. A consistency check
  ! of the number of values is performed, and value is casted if needed
  ! to be SIC variable type if needed.
  !---------------------------------------------------------------------
  type(sic_descriptor_t),    intent(in)    :: desc    ! The variable descriptor
  complex(kind=4),           intent(in)    :: c4(*)   ! Flat array of values to be copied
  integer(kind=size_length), intent(in)    :: neleml  ! Number of c4 values
  logical,                   intent(inout) :: error   ! Logical error flag
  ! Global
  include 'gbl_memory.inc'
  ! Local
  character(len=*), parameter :: rname='MTH'
  integer(kind=size_length) :: nelem0
  integer(kind=address_length) :: ipnt0
  !
  ! Get appropriate and perform consistency check:
  call sic_descriptor_getnelem(desc,neleml,.true.,nelem0,ipnt0,error)
  if (error)  return
  !
  select case (desc%type)
  case (fmt_c4)
    if (nelem0.eq.neleml) then
      call w8tow8_sl (c4,memory(ipnt0),neleml)
    elseif (neleml.eq.1) then
      call c4_fill(nelem0,memory(ipnt0),c4)
    endif
    !
  case (fmt_r4)
    call sic_message(seve%e,rname,'Cannot convert COMPLEX*4 to REAL*4')
    error = .true.
    !
  case (fmt_r8)
    call sic_message(seve%e,rname,'Cannot convert COMPLEX*4 to REAL*8')
    error = .true.
    !
  case (fmt_i4)
    call sic_message(seve%e,rname,'Cannot convert COMPLEX*4 to INTEGER*4')
    error = .true.
    !
  case (fmt_i8)
    call sic_message(seve%e,rname,'Cannot convert COMPLEX*4 to INTEGER*8')
    error = .true.
    !
  case default
    call sic_message(seve%e,rname,'Complex not supported (3)')
    error = .true.
    !
  end select
  !
end subroutine sic_descriptor_fill_c41d
!
subroutine sic_descriptor_fill_l1d(desc,l,neleml,error)
  use gildas_def
  use gbl_format
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_descriptor_fill_l1d
  use sic_types
  !---------------------------------------------------------------------
  ! @ public-generic sic_descriptor_fill
  !  Fill a descriptor target with the l(*) values. A consistency check
  ! of the number of values is performed, and value is casted if needed
  ! to be SIC variable type if needed.
  !---------------------------------------------------------------------
  type(sic_descriptor_t),    intent(in)    :: desc    ! The variable descriptor
  logical,                   intent(in)    :: l(*)    ! Flat array of values to be copied
  integer(kind=size_length), intent(in)    :: neleml  ! Number of l values
  logical,                   intent(inout) :: error   ! Logical error flag
  ! Global
  include 'gbl_memory.inc'
  ! Local
  character(len=*), parameter :: rname='MTH'
  integer(kind=size_length) :: nelem0
  integer(kind=address_length) :: ipnt0
  !
  ! Get appropriate and perform consistency check:
  call sic_descriptor_getnelem(desc,neleml,.true.,nelem0,ipnt0,error)
  if (error)  return
  !
  select case (desc%type)
  case (fmt_l)
    if (nelem0.eq.neleml) then
      call w4tow4_sl (l,memory(ipnt0),neleml)
    elseif (neleml.eq.1) then
      call i4_fill(nelem0,memory(ipnt0),l)
    endif
    !
  case default
    call sic_message(seve%e,rname,'Can not convert numeric to logical')
    error = .true.
    return
    !
  end select
  !
end subroutine sic_descriptor_fill_l1d
!
subroutine sic_descriptor_fill_ch1d(desc,ch,neleml,error)
  use gildas_def
  use gbl_format
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_descriptor_fill_ch1d
  use sic_types
  !---------------------------------------------------------------------
  ! @ public-generic sic_descriptor_fill
  !  Fill a descriptor target with the ch(*) values. A consistency check
  ! of the number of values is performed, and value is casted if needed
  ! to be SIC variable type if needed.
  !---------------------------------------------------------------------
  type(sic_descriptor_t),    intent(in)    :: desc    ! The variable descriptor
  character(len=*),          intent(in)    :: ch(*)   ! Flat array of values to be copied
  integer(kind=size_length), intent(in)    :: neleml  ! Number of l values
  logical,                   intent(inout) :: error   ! Logical error flag
  ! Global
  include 'gbl_memory.inc'
  ! Local
  character(len=*), parameter :: rname='MTH'
  integer(kind=size_length) :: nelem0,ielem,addr
  integer(kind=4) :: nc
  character(len=message_length) :: mess
  !
  nelem0 = desc_nelem(desc)
  !
  if (nelem0.ne.neleml .and. neleml.ne.1) then
    write(mess,'(A,I0,1X,I0)')  &
      'Mathematics on arrays of inconsistent dimensions ',nelem0,neleml
    call sic_message(seve%e,rname,mess)
    error = .true.
    return
  endif
  !
  if (desc%type.le.0) then
    call sic_message(seve%e,rname,'Can not convert numeric/logical to character')
    error = .true.
    return
  endif
  !
  nc = len(ch(1))
  addr = desc%addr
  if (nelem0.eq.neleml) then
    do ielem=1,nelem0
      call ctodes(ch(ielem),desc%type,addr)
      addr = addr+desc%type
    enddo
  elseif (neleml.eq.1) then
    do ielem=1,nelem0
      call ctodes(ch(1),desc%type,addr)
      addr = addr+desc%type
    enddo
  endif
  !
end subroutine sic_descriptor_fill_ch1d
!
!-----------------------------------------------------------------------
!
subroutine sic_descriptor_getval_i40d(desc,ielem,i4,error)
  use gildas_def
  use gbl_format
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_descriptor_getval_i40d
  use sic_types
  !---------------------------------------------------------------------
  ! @ public-generic sic_descriptor_getval
  !  Get the ielem-th value from the descriptor target. The value is
  ! casted to I*4 if needed
  !---------------------------------------------------------------------
  type(sic_descriptor_t),    intent(in)    :: desc    ! The variable descriptor
  integer(kind=size_length), intent(in)    :: ielem   ! The value position
  integer(kind=4),           intent(out)   :: i4      ! Scalar value to be filled
  logical,                   intent(inout) :: error   ! Logical error flag
  ! Global
  include 'gbl_memory.inc'
  ! Local
  character(len=*), parameter :: rname='MTH'
  integer(kind=address_length) :: ipnt0
  integer(kind=size_length), parameter :: one=1
  !
  call sic_descriptor_get1elem(desc,.false.,ielem,ipnt0,error)
  if (error)  return
  !
  select case (desc%type)
  case (fmt_i4)
    call w4tow4_sl (memory(ipnt0),i4,one)
  case (fmt_r8)
    call r8toi4_sl (memory(ipnt0),i4,one)
  case (fmt_r4)
    call r4toi4_sl (memory(ipnt0),i4,one)
  case (fmt_i8)
    call i8toi4_sl (memory(ipnt0),i4,one)
  case (fmt_c4)
    call sic_message(seve%e,rname,'Cannot convert COMPLEX*4 to INTEGER*4')
    error = .true.
    return
  case default
    call sic_message(seve%e,rname,'Result type mismatch (7)')
    error = .true.
    return
  end select
  !
end subroutine sic_descriptor_getval_i40d
!
subroutine sic_descriptor_getval_i80d(desc,ielem,i8,error)
  use gildas_def
  use gbl_format
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_descriptor_getval_i80d
  use sic_types
  !---------------------------------------------------------------------
  ! @ public-generic sic_descriptor_getval
  !  Get the ielem-th value from the descriptor target. The value is
  ! casted to I*8 if needed
  !---------------------------------------------------------------------
  type(sic_descriptor_t),    intent(in)    :: desc    ! The variable descriptor
  integer(kind=size_length), intent(in)    :: ielem   ! The value position
  integer(kind=8),           intent(out)   :: i8      ! Scalar value to be filled
  logical,                   intent(inout) :: error   ! Logical error flag
  ! Global
  include 'gbl_memory.inc'
  ! Local
  character(len=*), parameter :: rname='MTH'
  integer(kind=address_length) :: ipnt0
  integer(kind=size_length), parameter :: one=1
  !
  call sic_descriptor_get1elem(desc,.false.,ielem,ipnt0,error)
  if (error)  return
  !
  select case (desc%type)
  case (fmt_i4)
    call i4toi8_sl (memory(ipnt0),i8,one)
  case (fmt_r8)
    call r8toi8_fini_sl (memory(ipnt0),i8,one,error)
    if (error)  return
  case (fmt_r4)
    call r4toi8_fini_sl (memory(ipnt0),i8,one,error)
    if (error)  return
  case (fmt_i8)
    call w8tow8_sl (memory(ipnt0),i8,one)
  case (fmt_c4)
    call sic_message(seve%e,rname,'Cannot convert COMPLEX*4 to INTEGER*8')
    error = .true.
    return
  case default
    call sic_message(seve%e,rname,'Result type mismatch (8)')
    error = .true.
    return
  end select
  !
end subroutine sic_descriptor_getval_i80d
!
subroutine sic_descriptor_getval_r40d(desc,ielem,r4,error)
  use gildas_def
  use gbl_format
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_descriptor_getval_r40d
  use sic_types
  !---------------------------------------------------------------------
  ! @ public-generic sic_descriptor_getval
  !  Get the ielem-th value from the descriptor target. The value is
  ! casted to R*4 if needed
  !---------------------------------------------------------------------
  type(sic_descriptor_t),    intent(in)    :: desc    ! The variable descriptor
  integer(kind=size_length), intent(in)    :: ielem   ! The value position
  real(kind=4),              intent(out)   :: r4      ! Scalar value to be filled
  logical,                   intent(inout) :: error   ! Logical error flag
  ! Global
  include 'gbl_memory.inc'
  ! Local
  character(len=*), parameter :: rname='MTH'
  integer(kind=address_length) :: ipnt0
  integer(kind=size_length), parameter :: one=1
  !
  call sic_descriptor_get1elem(desc,.false.,ielem,ipnt0,error)
  if (error)  return
  !
  select case (desc%type)
  case (fmt_r8)
    call r8tor4_sl (memory(ipnt0),r4,one)
  case (fmt_r4)
    call w4tow4_sl (memory(ipnt0),r4,one)
  case (fmt_i4)
    call i4tor4_sl (memory(ipnt0),r4,one)
  case (fmt_i8)
    call i8tor4_sl (memory(ipnt0),r4,one)
  case (fmt_c4)
    call sic_message(seve%e,rname,'Cannot convert COMPLEX*4 to REAL*4')
    error = .true.
    return
  case default
    call sic_message(seve%e,rname,'Result type mismatch (9)')
    error = .true.
    return
  end select
  !
end subroutine sic_descriptor_getval_r40d
!
subroutine sic_descriptor_getval_r80d(desc,ielem,r8,error)
  use gildas_def
  use gbl_format
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_descriptor_getval_r80d
  use sic_types
  !---------------------------------------------------------------------
  ! @ public-generic sic_descriptor_getval
  !  Get the ielem-th value from the descriptor target. The value is
  ! casted to R*8 if needed
  !---------------------------------------------------------------------
  type(sic_descriptor_t),    intent(in)    :: desc    ! The variable descriptor
  integer(kind=size_length), intent(in)    :: ielem   ! The value position
  real(kind=8),              intent(out)   :: r8      ! Scalar value to be filled
  logical,                   intent(inout) :: error   ! Logical error flag
  ! Global
  include 'gbl_memory.inc'
  ! Local
  character(len=*), parameter :: rname='MTH'
  integer(kind=address_length) :: ipnt0
  integer(kind=size_length), parameter :: one=1
  !
  call sic_descriptor_get1elem(desc,.false.,ielem,ipnt0,error)
  if (error)  return
  !
  select case (desc%type)
  case (fmt_r8)
    call w8tow8_sl (memory(ipnt0),r8,one)
  case (fmt_r4)
    call r4tor8_sl (memory(ipnt0),r8,one)
  case (fmt_i4)
    call i4tor8_sl (memory(ipnt0),r8,one)
  case (fmt_i8)
    call i8tor8_sl (memory(ipnt0),r8,one)
  case (fmt_c4)
    call sic_message(seve%e,rname,'Cannot convert COMPLEX*4 to REAL*8')
    error = .true.
    return
  case default
    call sic_message(seve%e,rname,'Result type mismatch (10)')
    error = .true.
    return
  end select
  !
end subroutine sic_descriptor_getval_r80d
!
subroutine sic_descriptor_getval_c40d(desc,ielem,c4,error)
  use gildas_def
  use gbl_format
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_descriptor_getval_c40d
  use sic_types
  !---------------------------------------------------------------------
  ! @ public-generic sic_descriptor_getval
  !  Get the ielem-th value from the descriptor target. The value is
  ! casted to C*4 if needed
  !---------------------------------------------------------------------
  type(sic_descriptor_t),    intent(in)    :: desc    ! The variable descriptor
  integer(kind=size_length), intent(in)    :: ielem   ! The value position
  complex(kind=4),           intent(out)   :: c4      ! Scalar value to be filled
  logical,                   intent(inout) :: error   ! Logical error flag
  ! Global
  include 'gbl_memory.inc'
  ! Local
  character(len=*), parameter :: rname='MTH'
  integer(kind=address_length) :: ipnt0
  integer(kind=size_length), parameter :: one=1
  !
  call sic_descriptor_get1elem(desc,.false.,ielem,ipnt0,error)
  if (error)  return
  !
  select case (desc%type)
  case (fmt_r8)
    call r8toc4_sl (memory(ipnt0),c4,one)
  case (fmt_r4)
    call r4toc4_sl (memory(ipnt0),c4,one)
  case (fmt_i4)
    call i4toc4_sl (memory(ipnt0),c4,one)
  case (fmt_i8)
    call i8toc4_sl (memory(ipnt0),c4,one)
  case (fmt_c4)
    call c4toc4_sl (memory(ipnt0),c4,one)
  case default
    call sic_message(seve%e,rname,'Result type mismatch (11)')
    error = .true.
    return
  end select
  !
end subroutine sic_descriptor_getval_c40d
!
subroutine sic_descriptor_getval_l0d(desc,ielem,l,error)
  use gildas_def
  use gbl_format
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_descriptor_getval_l0d
  use sic_types
  !---------------------------------------------------------------------
  ! @ public-generic sic_descriptor_getval
  !  Get the ielem-th value from the descriptor target.
  !---------------------------------------------------------------------
  type(sic_descriptor_t),    intent(in)    :: desc    ! The variable descriptor
  integer(kind=size_length), intent(in)    :: ielem   ! The value position
  logical,                   intent(out)   :: l       ! Scalar value to be filled
  logical,                   intent(inout) :: error   ! Logical error flag
  ! Global
  include 'gbl_memory.inc'
  ! Local
  character(len=*), parameter :: rname='MTH'
  integer(kind=address_length) :: ipnt0
  integer(kind=size_length), parameter :: one=1
  !
  call sic_descriptor_get1elem(desc,.false.,ielem,ipnt0,error)
  if (error)  return
  !
  select case (desc%type)
  case (fmt_l)
    call l4tol4_sl (memory(ipnt0),l,one)
  case (fmt_r8)
    call sic_message(seve%e,rname,'Cannot convert REAL*8 to LOGICAL*4')
    error = .true.
    return
  case (fmt_r4)
    call sic_message(seve%e,rname,'Cannot convert REAL*4 to LOGICAL*4')
    error = .true.
    return
  case (fmt_i4)
    call sic_message(seve%e,rname,'Cannot convert INTEGER*4 to LOGICAL*4')
    error = .true.
    return
  case (fmt_i8)
    call sic_message(seve%e,rname,'Cannot convert INTEGER*8 to LOGICAL*4')
    error = .true.
    return
  case (fmt_c4)
    call sic_message(seve%e,rname,'Cannot convert COMPLEX*4 to LOGICAL*4')
    error = .true.
    return
  case default
    call sic_message(seve%e,rname,'Result type mismatch (12)')
    error = .true.
    return
  end select
  !
end subroutine sic_descriptor_getval_l0d
!
subroutine sic_descriptor_getval_ch0d(desc,ielem,ch,error)
  use gildas_def
  use gbl_format
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_descriptor_getval_ch0d
  use sic_types
  !---------------------------------------------------------------------
  ! @ public-generic sic_descriptor_getval
  !  Get the ielem-th value from the descriptor target.
  !---------------------------------------------------------------------
  type(sic_descriptor_t),    intent(in)    :: desc   ! The variable descriptor
  integer(kind=size_length), intent(in)    :: ielem  ! The value position
  character(len=*),          intent(out)   :: ch     ! Scalar value to be filled
  logical,                   intent(inout) :: error  ! Logical error flag
  ! Global
  include 'gbl_memory.inc'
  ! Local
  character(len=*), parameter :: rname='MTH'
  integer(kind=address_length) :: addr
  !
  if (ielem.le.0 .or. ielem.gt.desc_nelem(desc)) then
    call sic_message(seve%e,rname,'Out of bounds (4)')
    error = .true.
    return
  endif
  !
  if (desc%type.le.0) then
    call sic_message(seve%e,rname,'Can not convert numeric/logical to character')
    error = .true.
    return
  endif
  !
  addr = desc%addr+(ielem-1)*desc%type
  call destoc(desc%type,addr,ch)
  !
end subroutine sic_descriptor_getval_ch0d
!
subroutine sic_descriptor_getval_i4nd(desc,i4,neleml,error)
  use gildas_def
  use gbl_format
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_descriptor_getval_i4nd
  use sic_types
  !---------------------------------------------------------------------
  ! @ public-generic sic_descriptor_getval
  !  Get the descriptor target values into the i4(*) array. A
  ! consistency check of the number of values is performed, and values
  ! are casted if needed to I*4
  !---------------------------------------------------------------------
  type(sic_descriptor_t),    intent(in)    :: desc    ! The variable descriptor
  integer(kind=4),           intent(out)   :: i4(*)   ! Flat array of values to be filled
  integer(kind=size_length), intent(in)    :: neleml  ! Number of i4 values
  logical,                   intent(inout) :: error   ! Logical error flag
  ! Global
  include 'gbl_memory.inc'
  ! Local
  character(len=*), parameter :: rname='MTH'
  integer(kind=size_length) :: nelem0
  integer(kind=address_length) :: ipnt0
  !
  ! Get appropriate and perform consistency check:
  call sic_descriptor_getnelem(desc,neleml,.false.,nelem0,ipnt0,error)
  if (error)  return
  !
  select case (desc%type)
  case (fmt_i4)
    if (neleml.eq.nelem0) then
      call w4tow4_sl (memory(ipnt0),i4,nelem0)
    elseif (nelem0.eq.1) then
      call i4_fill(neleml,i4,memory(ipnt0))
    endif
    !
  case (fmt_r8)
    if (neleml.eq.nelem0) then
      call r8toi4_sl (memory(ipnt0),i4,nelem0)
    elseif (nelem0.eq.1) then
      call r8toi4_sl (memory(ipnt0),i4,nelem0)  ! Convert first element
      call i4_fill(neleml,i4,i4)  ! Duplicate
    endif
    !
  case (fmt_r4)
    if (neleml.eq.nelem0) then
      call r4toi4_sl (memory(ipnt0),i4,nelem0)
    elseif (nelem0.eq.1) then
      call r4toi4_sl (memory(ipnt0),i4,nelem0)
      call i4_fill (neleml,i4,i4)
    endif
    !
  case (fmt_i8)
    if (neleml.eq.nelem0) then
      call i8toi4_sl (memory(ipnt0),i4,nelem0)
    elseif (nelem0.eq.1) then
      call i8toi4_sl (memory(ipnt0),i4,nelem0)
      call i4_fill (neleml,i4,i4)
    endif
    !
  case (fmt_c4)
    call sic_message(seve%e,rname,'Cannot convert COMPLEX*4 to INTEGER*4')
    error = .true.
    return
    !
  case default
    call sic_message(seve%e,rname,'Result type mismatch (13)')
    error = .true.
    return
  end select
  !
end subroutine sic_descriptor_getval_i4nd
!
subroutine sic_descriptor_getval_i41d(desc,i4,error)
  use gildas_def
  use sic_interfaces, except_this=>sic_descriptor_getval_i41d
  use sic_types
  !---------------------------------------------------------------------
  ! @ public-generic sic_descriptor_getval
  !  Get the descriptor target values into the i4(:) array.
  !---------------------------------------------------------------------
  type(sic_descriptor_t), intent(in)    :: desc   ! The variable descriptor
  integer(kind=4),        intent(out)   :: i4(:)  ! Flat array of values to be filled
  logical,                intent(inout) :: error  ! Logical error flag
  !
  integer(kind=size_length) :: nelem
  !
  nelem = size(i4,kind=size_length)
  call sic_descriptor_getval_i4nd(desc,i4,nelem,error)
  if (error)  return
end subroutine sic_descriptor_getval_i41d
!
subroutine sic_descriptor_getval_i42d(desc,i4,error)
  use gildas_def
  use sic_interfaces, except_this=>sic_descriptor_getval_i42d
  use sic_types
  !---------------------------------------------------------------------
  ! @ public-generic sic_descriptor_getval
  !  Get the descriptor target values into the i4(:,:) array.
  !---------------------------------------------------------------------
  type(sic_descriptor_t), intent(in)    :: desc     ! The variable descriptor
  integer(kind=4),        intent(out)   :: i4(:,:)  ! Flat array of values to be filled
  logical,                intent(inout) :: error    ! Logical error flag
  !
  integer(kind=size_length) :: nelem
  !
  nelem = size(i4,kind=size_length)
  call sic_descriptor_getval_i4nd(desc,i4,nelem,error)
  if (error)  return
end subroutine sic_descriptor_getval_i42d
!
subroutine sic_descriptor_getval_i43d(desc,i4,error)
  use gildas_def
  use sic_interfaces, except_this=>sic_descriptor_getval_i43d
  use sic_types
  !---------------------------------------------------------------------
  ! @ public-generic sic_descriptor_getval
  !  Get the descriptor target values into the i4(:,:,:) array.
  !---------------------------------------------------------------------
  type(sic_descriptor_t), intent(in)    :: desc       ! The variable descriptor
  integer(kind=4),        intent(out)   :: i4(:,:,:)  ! Flat array of values to be filled
  logical,                intent(inout) :: error      ! Logical error flag
  !
  integer(kind=size_length) :: nelem
  !
  nelem = size(i4,kind=size_length)
  call sic_descriptor_getval_i4nd(desc,i4,nelem,error)
  if (error)  return
end subroutine sic_descriptor_getval_i43d
!
subroutine sic_descriptor_getval_i8nd(desc,i8,neleml,error)
  use gildas_def
  use gbl_format
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_descriptor_getval_i8nd
  use sic_types
  !---------------------------------------------------------------------
  ! @ public-generic sic_descriptor_getval
  !  Get the descriptor target values into the i8(*) array. A
  ! consistency check of the number of values is performed, and values
  ! are casted if needed to I*8
  !---------------------------------------------------------------------
  type(sic_descriptor_t),    intent(in)    :: desc    ! The variable descriptor
  integer(kind=8),           intent(out)   :: i8(*)   ! Flat array of values to be filled
  integer(kind=size_length), intent(in)    :: neleml  ! Number of i8 values
  logical,                   intent(inout) :: error   ! Logical error flag
  ! Global
  include 'gbl_memory.inc'
  ! Local
  character(len=*), parameter :: rname='MTH'
  integer(kind=size_length) :: nelem0
  integer(kind=address_length) :: ipnt0
  !
  ! Get appropriate and perform consistency check:
  call sic_descriptor_getnelem(desc,neleml,.false.,nelem0,ipnt0,error)
  if (error)  return
  !
  select case (desc%type)
  case (fmt_i4)
    if (neleml.eq.nelem0) then
      call i4toi8_sl (memory(ipnt0),i8,nelem0)
    elseif (nelem0.eq.1) then
      call i4toi8_sl (memory(ipnt0),i8,nelem0)
      call i8_fill(neleml,i8,i8)
    endif
    !
  case (fmt_r8)
    if (neleml.eq.nelem0) then
      call r8toi8_fini_sl (memory(ipnt0),i8,nelem0,error)
      if (error)  return
    elseif (nelem0.eq.1) then
      call r8toi8_fini_sl (memory(ipnt0),i8,nelem0,error)  ! Convert first element
      if (error)  return
      call i8_fill(neleml,i8,i8)  ! Duplicate
    endif
    !
  case (fmt_r4)
    if (neleml.eq.nelem0) then
      call r4toi8_fini_sl (memory(ipnt0),i8,nelem0,error)
      if (error)  return
    elseif (nelem0.eq.1) then
      call r4toi8_fini_sl (memory(ipnt0),i8,nelem0,error)
      if (error)  return
      call i8_fill (neleml,i8,i8)
    endif
    !
  case (fmt_i8)
    if (neleml.eq.nelem0) then
      call w8tow8_sl (memory(ipnt0),i8,nelem0)
    elseif (nelem0.eq.1) then
      call i8_fill (neleml,i8,memory(ipnt0))
    endif
    !
  case (fmt_c4)
    call sic_message(seve%e,rname,'Cannot convert COMPLEX*4 to INTEGER*8')
    error = .true.
    return
    !
  case default
    call sic_message(seve%e,rname,'Result type mismatch (14)')
    error = .true.
    return
  end select
  !
end subroutine sic_descriptor_getval_i8nd
!
subroutine sic_descriptor_getval_i81d(desc,i8,error)
  use gildas_def
  use sic_interfaces, except_this=>sic_descriptor_getval_i81d
  use sic_types
  !---------------------------------------------------------------------
  ! @ public-generic sic_descriptor_getval
  !  Get the descriptor target values into the i8(:) array.
  !---------------------------------------------------------------------
  type(sic_descriptor_t), intent(in)    :: desc   ! The variable descriptor
  integer(kind=8),        intent(out)   :: i8(:)  ! Flat array of values to be filled
  logical,                intent(inout) :: error  ! Logical error flag
  !
  integer(kind=size_length) :: nelem
  !
  nelem = size(i8,kind=size_length)
  call sic_descriptor_getval_i8nd(desc,i8,nelem,error)
  if (error)  return
end subroutine sic_descriptor_getval_i81d
!
subroutine sic_descriptor_getval_i82d(desc,i8,error)
  use gildas_def
  use sic_interfaces, except_this=>sic_descriptor_getval_i82d
  use sic_types
  !---------------------------------------------------------------------
  ! @ public-generic sic_descriptor_getval
  !  Get the descriptor target values into the i8(:,:) array.
  !---------------------------------------------------------------------
  type(sic_descriptor_t), intent(in)    :: desc     ! The variable descriptor
  integer(kind=8),        intent(out)   :: i8(:,:)  ! Flat array of values to be filled
  logical,                intent(inout) :: error    ! Logical error flag
  !
  integer(kind=size_length) :: nelem
  !
  nelem = size(i8,kind=size_length)
  call sic_descriptor_getval_i8nd(desc,i8,nelem,error)
  if (error)  return
end subroutine sic_descriptor_getval_i82d
!
subroutine sic_descriptor_getval_i83d(desc,i8,error)
  use gildas_def
  use sic_interfaces, except_this=>sic_descriptor_getval_i83d
  use sic_types
  !---------------------------------------------------------------------
  ! @ public-generic sic_descriptor_getval
  !  Get the descriptor target values into the i8(:,:,:) array.
  !---------------------------------------------------------------------
  type(sic_descriptor_t), intent(in)    :: desc       ! The variable descriptor
  integer(kind=8),        intent(out)   :: i8(:,:,:)  ! Flat array of values to be filled
  logical,                intent(inout) :: error      ! Logical error flag
  !
  integer(kind=size_length) :: nelem
  !
  nelem = size(i8,kind=size_length)
  call sic_descriptor_getval_i8nd(desc,i8,nelem,error)
  if (error)  return
end subroutine sic_descriptor_getval_i83d
!
subroutine sic_descriptor_getval_r4nd(desc,r4,neleml,error)
  use gildas_def
  use gbl_format
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_descriptor_getval_r4nd
  use sic_types
  !---------------------------------------------------------------------
  ! @ public-generic sic_descriptor_getval
  !  Get the descriptor target values into the r4(*) array. A
  ! consistency check of the number of values is performed, and values
  ! are casted if needed to R*4
  !---------------------------------------------------------------------
  type(sic_descriptor_t),    intent(in)    :: desc    ! The variable descriptor
  real(kind=4),              intent(out)   :: r4(*)   ! Flat array of values to be filled
  integer(kind=size_length), intent(in)    :: neleml  ! Number of r4 values
  logical,                   intent(inout) :: error   ! Logical error flag
  ! Global
  include 'gbl_memory.inc'
  ! Local
  character(len=*), parameter :: rname='MTH'
  integer(kind=size_length) :: nelem0
  integer(kind=address_length) :: ipnt0
  !
  ! Get appropriate and perform consistency check:
  call sic_descriptor_getnelem(desc,neleml,.false.,nelem0,ipnt0,error)
  if (error)  return
  !
  select case (desc%type)
  case (fmt_r4)
    if (nelem0.eq.neleml) then
      call w4tow4_sl (memory(ipnt0),r4,nelem0)
    elseif (nelem0.eq.1) then
      call r4_fill(neleml,r4,memory(ipnt0))
    endif
    !
  case (fmt_r8)
    if (nelem0.eq.neleml) then
      call r8tor4_sl (memory(ipnt0),r4,nelem0)
    elseif (nelem0.eq.1) then
      call r8tor4_sl (memory(ipnt0),r4,nelem0)
      call r4_fill (neleml,r4,r4)
    endif
    !
  case (fmt_i4)
    if (nelem0.eq.neleml) then
      call i4tor4_sl (memory(ipnt0),r4,nelem0)
    elseif (nelem0.eq.1) then
      call i4tor4_sl (memory(ipnt0),r4,nelem0)
      call r4_fill (neleml,r4,r4)
    endif
    !
  case (fmt_i8)
    if (nelem0.eq.neleml) then
      call i8tor4_sl (memory(ipnt0),r4,nelem0)
    elseif (nelem0.eq.1) then
      call i8tor4_sl (memory(ipnt0),r4,nelem0)
      call r4_fill (neleml,r4,r4)
    endif
    !
  case (fmt_c4)
    call sic_message(seve%e,rname,'Cannot convert COMPLEX*4 to REAL*4')
    error = .true.
    return
    !
  case default
    call sic_message(seve%e,rname,'Result type mismatch (15)')
    error = .true.
    return
  end select
  !
end subroutine sic_descriptor_getval_r4nd
!
subroutine sic_descriptor_getval_r41d(desc,r4,error)
  use gildas_def
  use sic_interfaces, except_this=>sic_descriptor_getval_r41d
  use sic_types
  !---------------------------------------------------------------------
  ! @ public-generic sic_descriptor_getval
  !  Get the descriptor target values into the r4(:) array.
  !---------------------------------------------------------------------
  type(sic_descriptor_t), intent(in)    :: desc   ! The variable descriptor
  real(kind=4),           intent(out)   :: r4(:)  ! Flat array of values to be filled
  logical,                intent(inout) :: error  ! Logical error flag
  !
  integer(kind=size_length) :: nelem
  !
  nelem = size(r4,kind=size_length)
  call sic_descriptor_getval_r4nd(desc,r4,nelem,error)
  if (error)  return
end subroutine sic_descriptor_getval_r41d
!
subroutine sic_descriptor_getval_r42d(desc,r4,error)
  use gildas_def
  use sic_interfaces, except_this=>sic_descriptor_getval_r42d
  use sic_types
  !---------------------------------------------------------------------
  ! @ public-generic sic_descriptor_getval
  !  Get the descriptor target values into the r4(:,:) array.
  !---------------------------------------------------------------------
  type(sic_descriptor_t), intent(in)    :: desc     ! The variable descriptor
  real(kind=4),           intent(out)   :: r4(:,:)  ! Flat array of values to be filled
  logical,                intent(inout) :: error    ! Logical error flag
  !
  integer(kind=size_length) :: nelem
  !
  nelem = size(r4,kind=size_length)
  call sic_descriptor_getval_r4nd(desc,r4,nelem,error)
  if (error)  return
end subroutine sic_descriptor_getval_r42d
!
subroutine sic_descriptor_getval_r43d(desc,r4,error)
  use gildas_def
  use sic_interfaces, except_this=>sic_descriptor_getval_r43d
  use sic_types
  !---------------------------------------------------------------------
  ! @ public-generic sic_descriptor_getval
  !  Get the descriptor target values into the r4(:,:,:) array.
  !---------------------------------------------------------------------
  type(sic_descriptor_t), intent(in)    :: desc       ! The variable descriptor
  real(kind=4),           intent(out)   :: r4(:,:,:)  ! Flat array of values to be filled
  logical,                intent(inout) :: error      ! Logical error flag
  !
  integer(kind=size_length) :: nelem
  !
  nelem = size(r4,kind=size_length)
  call sic_descriptor_getval_r4nd(desc,r4,nelem,error)
  if (error)  return
end subroutine sic_descriptor_getval_r43d
!
subroutine sic_descriptor_getval_r8nd(desc,r8,neleml,error)
  use gildas_def
  use gbl_format
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_descriptor_getval_r8nd
  use sic_types
  !---------------------------------------------------------------------
  ! @ public-generic sic_descriptor_getval
  !  Get the descriptor target values into the r8(*) array. A
  ! consistency check of the number of values is performed, and values
  ! are casted if needed to R*8
  !---------------------------------------------------------------------
  type(sic_descriptor_t),    intent(in)    :: desc    ! The variable descriptor
  real(kind=8),              intent(out)   :: r8(*)   ! Flat array of values to be filled
  integer(kind=size_length), intent(in)    :: neleml  ! Number of r8 values
  logical,                   intent(inout) :: error   ! Logical error flag
  ! Global
  include 'gbl_memory.inc'
  ! Local
  character(len=*), parameter :: rname='MTH'
  integer(kind=size_length) :: nelem0
  integer(kind=address_length) :: ipnt0
  !
  ! Get appropriate and perform consistency check:
  call sic_descriptor_getnelem(desc,neleml,.false.,nelem0,ipnt0,error)
  if (error)  return
  !
  select case (desc%type)
  case (fmt_r8)
    if (nelem0.eq.neleml) then
      call w8tow8_sl (memory(ipnt0),r8,nelem0)
    elseif (nelem0.eq.1) then
      call r8_fill(neleml,r8,memory(ipnt0))
    endif
    !
  case (fmt_r4)
    if (nelem0.eq.neleml) then
      call r4tor8_sl (memory(ipnt0),r8,nelem0)
    elseif (nelem0.eq.1) then
      call r4tor8_sl (memory(ipnt0),r8,nelem0)
      call r8_fill (neleml,r8,r8)
    endif
    !
  case (fmt_i4)
    if (nelem0.eq.neleml) then
      call i4tor8_sl (memory(ipnt0),r8,nelem0)
    elseif (nelem0.eq.1) then
      call i4tor8_sl (memory(ipnt0),r8,nelem0)
      call r8_fill (neleml,r8,r8)
    endif
    !
  case (fmt_i8)
    if (nelem0.eq.neleml) then
      call i8tor8_sl (memory(ipnt0),r8,nelem0)
    elseif (nelem0.eq.1) then
      call i8tor8_sl (memory(ipnt0),r8,nelem0)
      call r8_fill (neleml,r8,r8)
    endif
    !
  case (fmt_c4)
    call sic_message(seve%e,rname,'Cannot convert COMPLEX*4 to REAL*8')
    error = .true.
    return
    !
  case default
    call sic_message(seve%e,rname,'Result type mismatch (16)')
    error = .true.
    return
  end select
  !
end subroutine sic_descriptor_getval_r8nd
!
subroutine sic_descriptor_getval_r81d(desc,r8,error)
  use gildas_def
  use sic_interfaces, except_this=>sic_descriptor_getval_r81d
  use sic_types
  !---------------------------------------------------------------------
  ! @ public-generic sic_descriptor_getval
  !  Get the descriptor target values into the r8(:) array.
  !---------------------------------------------------------------------
  type(sic_descriptor_t), intent(in)    :: desc   ! The variable descriptor
  real(kind=8),           intent(out)   :: r8(:)  ! Flat array of values to be filled
  logical,                intent(inout) :: error  ! Logical error flag
  !
  integer(kind=size_length) :: nelem
  !
  nelem = size(r8,kind=size_length)
  call sic_descriptor_getval_r8nd(desc,r8,nelem,error)
  if (error)  return
end subroutine sic_descriptor_getval_r81d
!
subroutine sic_descriptor_getval_r82d(desc,r8,error)
  use gildas_def
  use sic_interfaces, except_this=>sic_descriptor_getval_r82d
  use sic_types
  !---------------------------------------------------------------------
  ! @ public-generic sic_descriptor_getval
  !  Get the descriptor target values into the r8(:,:) array.
  !---------------------------------------------------------------------
  type(sic_descriptor_t), intent(in)    :: desc     ! The variable descriptor
  real(kind=8),           intent(out)   :: r8(:,:)  ! Flat array of values to be filled
  logical,                intent(inout) :: error    ! Logical error flag
  !
  integer(kind=size_length) :: nelem
  !
  nelem = size(r8,kind=size_length)
  call sic_descriptor_getval_r8nd(desc,r8,nelem,error)
  if (error)  return
end subroutine sic_descriptor_getval_r82d
!
subroutine sic_descriptor_getval_r83d(desc,r8,error)
  use gildas_def
  use sic_interfaces, except_this=>sic_descriptor_getval_r83d
  use sic_types
  !---------------------------------------------------------------------
  ! @ public-generic sic_descriptor_getval
  !  Get the descriptor target values into the r8(:,:,:) array.
  !---------------------------------------------------------------------
  type(sic_descriptor_t), intent(in)    :: desc       ! The variable descriptor
  real(kind=8),           intent(out)   :: r8(:,:,:)  ! Flat array of values to be filled
  logical,                intent(inout) :: error      ! Logical error flag
  !
  integer(kind=size_length) :: nelem
  !
  nelem = size(r8,kind=size_length)
  call sic_descriptor_getval_r8nd(desc,r8,nelem,error)
  if (error)  return
end subroutine sic_descriptor_getval_r83d
!
subroutine sic_descriptor_getval_c4nd(desc,c4,neleml,error)
  use gildas_def
  use gbl_format
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_descriptor_getval_c4nd
  use sic_types
  !---------------------------------------------------------------------
  ! @ public-generic sic_descriptor_getval
  !  Get the descriptor target values into the c4(*) array. A
  ! consistency check of the number of values is performed, and values
  ! are casted if needed to R*4
  !---------------------------------------------------------------------
  type(sic_descriptor_t),    intent(in)    :: desc    ! The variable descriptor
  complex(kind=4),           intent(out)   :: c4(*)   ! Flat array of values to be filled
  integer(kind=size_length), intent(in)    :: neleml  ! Number of c4 values
  logical,                   intent(inout) :: error   ! Logical error flag
  ! Global
  include 'gbl_memory.inc'
  ! Local
  character(len=*), parameter :: rname='MTH'
  integer(kind=size_length) :: nelem0
  integer(kind=address_length) :: ipnt0
  !
  ! Get appropriate and perform consistency check:
  call sic_descriptor_getnelem(desc,neleml,.false.,nelem0,ipnt0,error)
  if (error)  return
  !
  select case (desc%type)
  case (fmt_r4)
    if (nelem0.eq.neleml) then
      call r4toc4_sl (memory(ipnt0),c4,nelem0)
    elseif (nelem0.eq.1) then
      call r4toc4_sl (memory(ipnt0),c4,nelem0)
      call c4_fill(neleml,c4,c4)
    endif
    !
  case (fmt_r8)
    if (nelem0.eq.neleml) then
      call r8toc4_sl (memory(ipnt0),c4,nelem0)
    elseif (nelem0.eq.1) then
      call r8toc4_sl (memory(ipnt0),c4,nelem0)
      call c4_fill (neleml,c4,c4)
    endif
    !
  case (fmt_i4)
    if (nelem0.eq.neleml) then
      call i4toc4_sl (memory(ipnt0),c4,nelem0)
    elseif (nelem0.eq.1) then
      call i4toc4_sl (memory(ipnt0),c4,nelem0)
      call c4_fill (neleml,c4,c4)
    endif
    !
  case (fmt_i8)
    if (nelem0.eq.neleml) then
      call i8toc4_sl (memory(ipnt0),c4,nelem0)
    elseif (nelem0.eq.1) then
      call i8toc4_sl (memory(ipnt0),c4,nelem0)
      call c4_fill (neleml,c4,c4)
    endif
    !
  case (fmt_c4)
    if (nelem0.eq.neleml) then
      call c4toc4_sl (memory(ipnt0),c4,nelem0)
    elseif (nelem0.eq.1) then
      call c4_fill(neleml,c4,memory(ipnt0))
    endif
    !
  case default
    call sic_message(seve%e,rname,'Result type mismatch (17)')
    error = .true.
    return
  end select
  !
end subroutine sic_descriptor_getval_c4nd
!
subroutine sic_descriptor_getval_c41d(desc,c4,error)
  use gildas_def
  use sic_interfaces, except_this=>sic_descriptor_getval_c41d
  use sic_types
  !---------------------------------------------------------------------
  ! @ public-generic sic_descriptor_getval
  !  Get the descriptor target values into the c4(:) array.
  !---------------------------------------------------------------------
  type(sic_descriptor_t), intent(in)    :: desc   ! The variable descriptor
  complex(kind=4),        intent(out)   :: c4(:)  ! Flat array of values to be filled
  logical,                intent(inout) :: error  ! Logical error flag
  !
  integer(kind=size_length) :: nelem
  !
  nelem = size(c4,kind=size_length)
  call sic_descriptor_getval_c4nd(desc,c4,nelem,error)
  if (error)  return
end subroutine sic_descriptor_getval_c41d
!
subroutine sic_descriptor_getval_c42d(desc,c4,error)
  use gildas_def
  use sic_interfaces, except_this=>sic_descriptor_getval_c42d
  use sic_types
  !---------------------------------------------------------------------
  ! @ public-generic sic_descriptor_getval
  !  Get the descriptor target values into the c4(:,:) array.
  !---------------------------------------------------------------------
  type(sic_descriptor_t), intent(in)    :: desc     ! The variable descriptor
  complex(kind=4),        intent(out)   :: c4(:,:)  ! Flat array of values to be filled
  logical,                intent(inout) :: error    ! Logical error flag
  !
  integer(kind=size_length) :: nelem
  !
  nelem = size(c4,kind=size_length)
  call sic_descriptor_getval_c4nd(desc,c4,nelem,error)
  if (error)  return
end subroutine sic_descriptor_getval_c42d
!
subroutine sic_descriptor_getval_c43d(desc,c4,error)
  use gildas_def
  use sic_interfaces, except_this=>sic_descriptor_getval_c43d
  use sic_types
  !---------------------------------------------------------------------
  ! @ public-generic sic_descriptor_getval
  !  Get the descriptor target values into the c4(:,:,:) array.
  !---------------------------------------------------------------------
  type(sic_descriptor_t), intent(in)    :: desc       ! The variable descriptor
  complex(kind=4),        intent(out)   :: c4(:,:,:)  ! Flat array of values to be filled
  logical,                intent(inout) :: error      ! Logical error flag
  !
  integer(kind=size_length) :: nelem
  !
  nelem = size(c4,kind=size_length)
  call sic_descriptor_getval_c4nd(desc,c4,nelem,error)
  if (error)  return
end subroutine sic_descriptor_getval_c43d
!
subroutine sic_descriptor_getval_chnd(desc,ch,neleml,error)
  use gildas_def
  use gbl_format
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_descriptor_getval_chnd
  use sic_types
  !---------------------------------------------------------------------
  ! @ public-generic sic_descriptor_getval
  !  Get the descriptor target values into the c*(*) array. A
  ! consistency check of the number of values is performed.
  !---------------------------------------------------------------------
  type(sic_descriptor_t),    intent(in)    :: desc    ! The variable descriptor
  character(len=*),          intent(out)   :: ch(*)   ! Flat array of values to be filled
  integer(kind=size_length), intent(in)    :: neleml  ! Number of ch values
  logical,                   intent(inout) :: error   ! Logical error flag
  ! Global
  include 'gbl_memory.inc'
  ! Local
  character(len=*), parameter :: rname='MTH'
  integer(kind=size_length) :: nelem0,ielem,addr
  integer(kind=4) :: nc
  character(len=message_length) :: mess
  !
  nelem0 = desc_nelem(desc)
  !
  if (nelem0.ne.neleml .and. nelem0.ne.1) then
    write(mess,'(A,I0,1X,I0)')  &
      'Mathematics on arrays of inconsistent dimensions ',nelem0,neleml
    call sic_message(seve%e,rname,mess)
    error = .true.
    return
  endif
  !
  if (desc%type.le.0) then
    call sic_message(seve%e,rname,'Can not convert numeric/logical to character')
    error = .true.
    return
  endif
  !
  nc = len(ch(1))
  addr = desc%addr
  if (nelem0.eq.neleml) then
    do ielem=1,nelem0
      call destoc(desc%type,addr,ch(ielem))
      addr = addr+desc%type
    enddo
  elseif (nelem0.eq.1) then
    do ielem=1,neleml
      call destoc(desc%type,addr,ch(ielem))
    enddo
  endif
  !
end subroutine sic_descriptor_getval_chnd

subroutine gtl_mkdir(line,error)
  use gildas_def
  use gtv_buffers
  use gtv_graphic
  use gtv_dependencies_interfaces
  use gtv_interfaces, except_this=>gtl_mkdir
  use gtv_protocol
  use gtv_tree
  use gtv_types
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! Support routine for command
  !   CREATE DIRECTORY nomdir
  !   1      [/PLOT_PAGE SizeX SizeY]
  !   2      [/PIXEL Px Py]
  !   5      [/SIZE SizeX SizeY]
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line   ! Command line
  logical,          intent(inout) :: error  ! Error flag
  ! Local
  character(len=*), parameter :: rname='CREATE DIRECTORY'
  character(len=32) :: nomdir
  character(len=80) :: dir_parent,chemin_cour
  integer :: nc,indice,ld
  logical :: opt,isdir,found
  type(greg_values) :: tab_greg
  type(gt_directory), pointer :: dir,parent
  type(gt_segment), pointer :: segm
  !
  call sic_ch(line,0,2,nomdir,nc,.true.,error)
  if (error) return
  call sic_upper(nomdir)
  opt = sic_present(1,0) .or. sic_present(2,0) .or.  &
        sic_present(3,0) .or. sic_present(4,0) .or.  &
        sic_present(5,0)  ! /SIZE, but is obsolete
  !
  ! 0) Current working directory
  call cree_chemin_dir(cw_directory,chemin_cour,nc)
  ! Update GREG values of Current Working Directory. If we create a
  ! subdirectory of this cwd hereafter, it will inherit up-to-date
  ! GREG values from its father.
  if (flag_greg) then
    call get_greg_values(tab_greg)
    call attach_greg_values(cw_directory,tab_greg,error)
  endif
  !
  ! 1) Check if input directory does not exists
  call decode_chemin(nomdir,cw_directory,dir,isdir,segm,found)
  if (found) then
     if (isdir) then
       call cree_chemin_dir(dir,nomdir,ld)
       call gtv_message(seve%e,rname,'Directory '//trim(nomdir)//  &
       ' already exists')
     else
       call cree_chemin_seg(segm,nomdir,ld)
       call gtv_message(seve%e,rname,trim(nomdir)//' already exists and '//  &
       'is a segment')
     endif
     error = .true.
     return
  endif
  !
  ! 2) Rewind up to the parent directory, which must exist
  indice = index(nomdir,dir_sep,.true.)
  if (indice.eq.1) then
     dir_parent = dir_root
     parent => root
     !
  elseif (indice.gt.1) then
     dir_parent = nomdir(:indice-1)  ! e.g. A<B<..<C<D
     ! If path is absolute (starts with '<'), decode_chemin ignores input
     ! ad_cour and searches from root. Fine!
     call decode_chemin(dir_parent,cw_directory,dir,isdir,segm,found)
     if (.not.found .or. .not.isdir) then
        call gtv_message(seve%e,rname,'Parent directory '//trim(dir_parent)//  &
        ' does not exist')
        error = .true.
        return
     else
        call cree_chemin_dir(dir,dir_parent,ld)
        ! call gtv_message(seve%i,rname,'Found parent directory '//dir_parent)
        parent => dir
     endif
     !
  else
     dir_parent = chemin_cour
     parent => cw_directory
  endif
  !
  ! 3) Create the son
  nomdir = nomdir(indice+1:)
  call gtv_message(seve%d,rname,  &
    'Creating directory '//trim(nomdir)//' in '//dir_parent)
  !
  if (associated(parent,root)) then
    call gtl_mkdir_topdir(line,nomdir,error)
    if (error)  return
    !
  elseif (opt) then
    call gtv_message(seve%e,rname,'Options are forbidden for sub-directories')
    error = .true.
    return
    !
  else
    ! Create a standard sub-directory. Inherits its parent physical size.
    call gtsegm_dir(nomdir,parent,parent%phys_size(1),parent%phys_size(2),error)
    if (error) then
      ! This means directory already exists. This is already tested, should
      ! not happen.
      return
    endif
  endif
  !
end subroutine gtl_mkdir
!
subroutine gtl_mkdir_topdir(line,nomdir,error)
  use gbl_message
  use gtv_buffers
  use gtv_graphic
  use gtv_dependencies_interfaces
  use gtv_interfaces, except_this=>gtl_mkdir_topdir
  use gtv_protocol
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  ! Support routine for command
  !   CREATE DIRECTORY DirName
  ! 1 [/PLOT_PAGE Sx Sy]
  ! 5 [/SIZE Sx Sy]  (obsolete)
  ! Create a top-level directory
  !---------------------------------------------------------------------
  character(len=*),   intent(in)    :: line    ! Command line
  character(len=*),   intent(in)    :: nomdir  ! The new directory name
  logical,            intent(inout) :: error   ! Error flag
  ! Local
  character(len=*), parameter :: rname='CREATE DIRECTORY'
  integer(kind=4) :: nc,sever
  real*4 :: sizex,sizey
  type(x_output) :: xdisplay
  logical :: isdir,found
  type(gt_directory), pointer :: dir
  type(gt_segment), pointer :: segm
  character(len=12) :: argx,argy
  !
  ! 1) Option /PLOT_PAGE
  sizex = phys_sizex_def
  call sic_r4(line,1,1,sizex,.false.,error)
  if (error) return
  sizex = abs(sizex)
  !
  sizey = phys_sizey_def
  call sic_r4(line,1,2,sizey,.false.,error)
  if (error) return
  sizey = abs(sizey)
  !
  if (sic_present(5,0)) then
    ! /SIZE
    if (strict2011) then
      sever = seve%e
    else
      sever = seve%w
    endif
    call gtv_message(sever,rname,  &
      'Option /SIZE is obsolete. Use /PLOT_PAGE instead')
    if (strict2011) then
      error = .true.
      return
    endif
    !
    call sic_r4(line,5,1,sizex,.true.,error)
    if (error) return
    sizex = abs(sizex)
    !
    call sic_r4(line,5,2,sizey,.true.,error)
    if (error) return
    sizey = abs(sizey)
  endif
  !
  call gtsegm_dir(nomdir,root,sizex,sizey,error)
  if (error) then
    ! This means that the directory already exists, but it has been already
    ! tested, i.e. it should not happen
    call gtv_message(seve%e,rname,'Internal error when creating '//nomdir)
    return
  else
    ! Get the directory just created in 'dir'
    call decode_chemin(nomdir,root,dir,isdir,segm,found)
  endif
  !
  ! go back from whence we came if ERROR or Single-window terminal
  if (error .or. (cw_device%protocol.ne.p_x.and.cw_device%protocol.ne.p_svg)) then
    continue
    !
  else
    ! X protocol: create a top window. Get its characteristics
    call x_display_reset(xdisplay)  ! Default values
    !
    ! /GEOMETRY arguments
    if (sic_present(3,0)) then
      call sic_ch(line,3,1,argx,nc,.true.,error)
      if (error) return
      call sic_ch(line,3,2,argy,nc,.true.,error)
      if (error) return
      call decode_coordinates(xdisplay%geometry,argx,argy,error)
      if (error)  return
    endif
    !
    ! /POSITION arguments
    if (sic_present(4,0)) then
      call sic_ch(line,4,1,argx,nc,.true.,error)
      if (error) return
      call sic_ch(line,4,2,argy,nc,.true.,error)
      if (error) return
      call decode_coordinates(xdisplay%position,argx,argy,error)
      if (error)  return
    endif
    !
    ! /PIXEL (obsolete since 11-oct-2010)
    if (sic_present(2,0)) then
      if (strict2011) then
        sever = seve%e
      else
        sever = seve%w
      endif
      call gtv_message(sever,rname,  &
        'Option /PIXEL is obsolete. Use /GEOMETRY instead.')
      if (strict2011) then
        error = .true.
        return
      endif
      !
      call sic_r4(line,2,1,xdisplay%geometry%x,.true.,error)
      if (error) return
      xdisplay%geometry%unitx = 'p'  ! pixels
      !
      call sic_r4(line,2,2,xdisplay%geometry%y,.true.,error)
      if (error) return
      xdisplay%geometry%unity = 'p'  ! pixels
    endif
    !
    ! Create the initial window for that directory for graphical displays
    call gtv_mkdir_topwindow(dir,xdisplay,error)
    if (error)  return
  endif
  !
end subroutine gtl_mkdir_topdir
!
subroutine gtv_mkdir_topwindow(topdir,xdisplay,error)
  use gtv_interfaces, except_this=>gtv_mkdir_topwindow
  use gtv_protocol
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  ! Create the initial window for a top directory for graphical displays
  ! ---
  !  Thread status: safe to call from main thread.
  !---------------------------------------------------------------------
  type(gt_directory), intent(inout) :: topdir    ! The top directory
  type(x_output),     intent(in)    :: xdisplay  ! The new window descriptor
  logical,            intent(inout) :: error     ! Logical error flag
  ! Local
  type(gt_display), pointer :: output
  !
  ! A new window will be attached to the output instances list:
  call get_free_slot_output(output,error)
  if (error)  return
  output%dev => cw_device  ! Point on the shared X-protocol instance
  output%color = .true.
  output%background = output%dev%background  ! Use the device default color
  output%x = xdisplay
  !
  call create_window(output,.false.,topdir,.true.,.true.,error)
  if (error) return
  !
  call sp_gtwindow(output,0.0,topdir%phys_size(1),0.0,topdir%phys_size(2))
  !
end subroutine gtv_mkdir_topwindow

program nrtex
!
! This program translates a .nroff file into a .tex LaTeX file suitable
! for the internal HELP of Gildas programs
!
! The output maximum width is set by default to 50em in the .css file
! I have no idea on how to change that, but after manual editing, it 
! seems the specified value persists.
!
! Perhaps a "page width" in Latex file ?
!
  character(len=128) :: infile, outfile, curfile
  character(len=256) :: line
  character(len=64) :: prefix
  integer, parameter :: iout=3
  integer :: idep, iunit(6), nl,lp, ier
  logical :: verb
  data iunit/10,11,12,13,14,15/
  !
  call get_command_argument(1,infile)
  outfile = trim(infile)//".tex"
  infile = trim(infile)//".nroff"
  Print *,trim(infile)
  Print *,trim(outfile)
  !
  open(unit=iunit(1),file=infile,status='OLD')
  open(unit=iout,file=outfile,status='UNKNOWN')
  open(unit=2, file='error.txt', status='unknown')
  rewind(2)
  rewind(iout)
  !
  idep = 1
  ier = 0
  verb = .false.
  lp = 0
  do 
    read(iunit(idep),'(A)',iostat=ier) line
    if (ier.ne.0) then
      ! Decrease depth or exit
      Print *,'Closing '//trim(curfile)
      close(unit=iunit(idep))
      if (idep.eq.1) exit
      idep = idep-1
    endif
    !
    if (line(1:1).eq.'.') then
      if (line(1:4).eq.'.nf') then
        write(iout,'(A,A)') "\begin{verbatim}"
        verb = .true.
      else if (line(1:4).eq.'.fi') then
        write(iout,'(A,A)') "\end{verbatim}"
        verb = .false.
      else if (line(1:4).eq.'.br') then
        write(iout,'(A)') "\htbreak"
      else if (line(1:3).eq.'.so ') then
        ! Branch to another source file and increase depth
        idep = idep+1
        curfile = adjustl(line(4:))
        Print *,'Branching to ['//trim(curfile)//']'
        open(iunit(idep),file=curfile,status='OLD')
      endif
    else if (line(1:2).eq.'1 ') then
      flush(unit=iout)
      flush(unit=2)
      ! Command level help
      if (line(iout:).eq."ENDOFHELP") exit
      call escape(line)
!      call special(line,'%')
!      call special(line,'#')
      write(iout,*) "\subsection{"//trim(line(3:))//"}"
      lp = 0
    else if (line(1:2).eq.'2 ') then
      flush(unit=iout)
      flush(unit=2)
      ! Option, Argument, Variable or Result level help
      call escape(line)
      call special(line,'%')
      nl = len_trim(line)
      if (line(nl:nl).eq.':') then
        write(iout,*) "\subsubsection{"//trim(line(3:nl))//"}"
        prefix = "\htpad "  !rawhtml &nbsp;&nbsp;&nbsp;&nbsp; \endrawhtml"
        lp = len_trim(prefix)+1
      else if (lp.eq.0) then
        write(iout,*) "\subsubsection{"//trim(line(3:nl))//"}"
      else
        write(iout,*) "\subsubsection{"//prefix(1:lp)//trim(line(3:nl))//"}"
      endif
    else if (verb) then
      call verbatim(line)
      write(iout,*) trim(line)
    else
      call escape(line)
      call special(line,'%')
      call special(line,'#')
      call special(line,'^')
      call special(line,'$')
      call spmath(line,'>')
      call spmath(line,'<')
      write(iout,*) trim(line)
    endif      
  enddo
  close(unit=iout)
end program
!
subroutine special(line,token)
  character(len=*), intent(inout) :: line
  character(len=1), intent(in) :: token
  !
  ! Prefix the specific token by an escape character
  character(len=256) :: myline
  integer :: iesc,iinp, iout
  iesc = index(line,token) 
  !
  if (iesc.eq.0) return
  !
  iinp = 1
  iout = 1
  myline = ' '
  do while (iesc.ne.0) 
    myline(iout:) = line(iinp:iesc-1)
    iout = iout+iesc-iinp
    iinp = iesc+1
    myline(iout:) = "\"//token
    iout = iout+2
    iesc = index(line(iinp:),token) 
    if (iesc.eq.0) then
      myline(iout:) = line(iinp:)
      exit
    else
      write(2,*) 'IESC ',iesc,iinp,line(iinp:),iesc+iinp
      iesc = iinp+iesc-1
    endif
  enddo
  Write(2,*) 'Token '//token//' LINE ',trim(line)
  Write(2,*) 'Out  ',trim(myline)
  line = myline
end subroutine special
!

subroutine spmath(line,token)
  character(len=*), intent(inout) :: line
  character(len=1), intent(in) :: token
  !
  ! Includes the specific token in a Math mode
  character(len=256) :: myline
  integer :: iesc,iinp, iout
  iesc = index(line,token) 
  !
  if (iesc.eq.0) return
  !
  iinp = 1
  iout = 1
  myline = ' '
  do while (iesc.ne.0) 
    myline(iout:) = line(iinp:iesc-1)
    iout = iout+iesc-iinp
    iinp = iesc+1
    myline(iout:) = "$"//token//"$"
    iout = iout+3
    iesc = index(line(iinp:),token) 
    if (iesc.eq.0) then
      myline(iout:) = line(iinp:)
      exit
    else
      write(2,*) 'IESC ',iesc,iinp,line(iinp:),iesc+iinp
      iesc = iinp+iesc-1
    endif
  enddo
  Write(2,*) 'Token '//token//' LINE ',trim(line)
  Write(2,*) 'Out  ',trim(myline)
  line = myline
end subroutine spmath
!
subroutine verbatim(line)
  character(len=*), intent(inout) :: line
  !
  character(len=256) :: myline
  integer :: iesc,iinp, iout
  iesc = index(line,'_') 
  !
  if (iesc.eq.0) return
  !
  iinp = 1
  iout = 1
  myline = ' '
  do while (iesc.ne.0) 
    if (line(iesc:iesc+1).eq.'_\') then
      myline(iout:) = line(iinp:iesc-1)
      iout = iout+iesc-iinp
      iinp = iesc+2
      myline(iout:) = "\"
      iout = iout+1
      iesc = index(line(iinp:),'_') 
    else if (line(iesc:iesc+1).eq.'__') then
      myline(iout:) = line(iinp:iesc-1)
      iout = iout+iesc-iinp
      iinp = iesc+2
      myline(iout:) = "_"
      iout = iout+1 
      iesc = index(line(iinp:),'_') 
    endif
    if (iesc.eq.0) then
      myline(iout:) = line(iinp:)
      exit
    else
      iesc = iinp+iesc-1
    endif
  enddo
  Write(2,*) 'LINE ',trim(line)
  Write(2,*) 'Out  ',trim(myline)
  line = myline
end subroutine verbatim

subroutine escape(line)
  character(len=*), intent(inout) :: line
  !
  character(len=256) :: myline
  integer :: iesc,iinp, iout
  !
  iesc = index(line,'_') 
  if (iesc.eq.0) return
  !
  iinp = 1
  iout = 1
  myline = ' '
  do while (iesc.ne.0) 
    if (line(iesc:iesc+1).eq.'_\') then
      myline(iout:) = line(iinp:iesc-1)
      iout = iout+iesc-iinp
      iinp = iesc+2
      myline(iout:) = "\textbackslash{}"
      iout = len_trim(myline)+1
      iesc = index(line(iinp:),'_') 
    else if (line(iesc:iesc+1).eq.'__') then
      myline(iout:) = line(iinp:iesc-1)
      iout = iout+iesc-iinp
      iinp = iesc+2
      myline(iout:) = "\_"
      iout = iout+2 
      iesc = index(line(iinp:),'_') 
    endif
    if (iesc.eq.0) then
      myline(iout:) = line(iinp:)
      exit
    else
      iesc = iinp+iesc-1
    endif
  enddo
  line = myline
end subroutine escape

subroutine gtl_refresh(line,error)
  use gbl_message
  use gtv_dependencies_interfaces
  use gtv_interfaces, except_this=>gtl_refresh
  use gtv_buffers
  use gtv_protocol
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  !  Support routine for command
  !    GTV\REFRESH [DirName [WinNum|ZOOM]]
  !  Redraw the active (or specified) X window.
  !
  !  X protocol is always refreshed on-demand of the system, so there
  ! should be no need for such a user request.
  !  However, images are implicitly created at depth 2, so what you see
  ! at first drawing (when segments are stacked in chronological order)
  ! is not what you see at subsequent redrawing. This is annoying and
  ! requires some action. One would think about implicit redraw when an
  ! image is plotted, but this would be very uneffecient (think about
  ! GO BIT). On the other hand, users are well used to this
  ! "bug-feature" (formerly known as ZOOM REFRESH), so we let them
  ! decide when they want a redraw.
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line  ! Command line
  logical,          intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='REFRESH'
  integer(kind=4), parameter :: mode_update=-2  ! See module 'gtview_modes'
  integer(kind=4) :: cnum,nc
  character(len=gtvpath_length) :: dirname
  logical :: isdir,found,err
  type(gt_directory), pointer :: dir
  type(gt_segment), pointer :: segm
  integer(kind=address_length) :: genv
  !
  if (cw_device%protocol.ne.p_x) then
    call gtv_message(seve%w,rname,'Ignored when not using X-Window')
    return
  endif
  !
  ! Argument parsing
  if (sic_present(0,1)) then
    ! 1) Directory, if present
    call sic_ch (line,0,1,dirname,nc,.true.,error)
    if (error) return
    call sic_upper(dirname)
    call decode_chemin(dirname,cw_directory,dir,isdir,segm,found)
    ! Not found?
    if (.not. (found.and.isdir)) then
      call gtv_message(seve%e,rname,'No such directory '//dirname)
      error = .true.
      return
    endif
  else
    dir => root
  endif
  !
  if (sic_present(0,2)) then
    ! 2 arguments: 1 window in one directory
    !
    cnum = get_window_cnum_byname(dir,rname,line,0,2,error)
    if (cnum.lt.0) then
      call gtv_message(seve%w,rname,'No such window, nothing done')
      return
    endif
    !
    genv = c_get_win_genv(dir%x%genv_array,cnum)
    err = x_refresh_genv(dir,mode_update,genv)
    !
  else
    call gtview_update(dir,error)
  endif
  !
end subroutine gtl_refresh

module greg_column
  !---------------------------------------------------------------------
  ! Support module for command GREG\COLUMN
  !---------------------------------------------------------------------
  integer(kind=4) :: jund              ! Logical unit for formatted files
  integer(kind=4) :: line1             ! First line to read in file
  integer(kind=4) :: line2             ! Last line to read in file
  !
end module greg_column
!
subroutine defdel_xyz(action,i,error)
  use gbl_message
  use sic_types
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>defdel_xyz
  use greg_xyz
  !---------------------------------------------------------------------
  ! @ private
  !  Define or delete one of the X, Y, or Z Greg variables. An error is
  ! raised if the variable already exists and was not created by Greg.
  !---------------------------------------------------------------------
  integer(kind=4), intent(in)    :: action  ! 0=check, 1=define, 2=delete
  integer(kind=4), intent(in)    :: i       ! 1=X, 2=Y, 3=Z
  logical,         intent(inout) :: error   ! Logical error flag
  ! Local
  type(sic_descriptor_t) :: desc
  logical :: found,err
  character(len=1), parameter :: var(3) = (/ 'X','Y','Z' /)
  character(len=60) :: chain
  ! Data
  data chain /'Variable # not defined by GreG'/
  !
  found = .false.
  call sic_descriptor(var(i),desc,found)
  if (found) then
    ! Variable exists
    if (desc%addr.ne.locwrd(column_xyz(1,i))) then
      chain(10:10) = var(i)
      call greg_message(seve%e,'COLUMN',chain)
      error = .true.
      return
    endif
    !
    if (action.eq.2) then
      call sic_delvariable(var(i),.false.,err)
    endif
    !
  elseif (action.eq.1) then
    ! Variable does not yet exist
    call sic_def_dble(var(i),column_xyz(1,i),1,nxy,.false.,error)
    if (error)  return
  endif
  !
end subroutine defdel_xyz
!
subroutine delete_xyz(delv,error)
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>delete_xyz
  use gildas_def
  use greg_xyz
  !---------------------------------------------------------------------
  ! @ private
  ! Delete the SIC variables named X, Y and Z
  !---------------------------------------------------------------------
  logical, intent(in)    :: delv
  logical, intent(inout) :: error
  ! Local
  integer(kind=4) :: action,i
  !
  if (delv) then
    action = 2  ! Check and delete
  else
    action = 0  ! Check only
  endif
  !
  do i=1,3
    call defdel_xyz(action,i,error)
    if (error)  return
  enddo
  !
end subroutine delete_xyz
!
subroutine create_xyz(error)
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>create_xyz
  use greg_xyz
  !---------------------------------------------------------------------
  ! @ private
  !  Create the SIC variables named X, Y and Z, if they are not yet
  ! defined. If yes, they are assumed to point to the correct memory
  ! object (checked in delete_xyz).
  !---------------------------------------------------------------------
  logical, intent(inout) :: error
  ! Local
  integer(kind=4) :: action
  !
  action = 1  ! Check and create
  !
  if (associated(column_x)) then
    call defdel_xyz(action,1,error)
    if (error)  return
  endif
  !
  if (associated(column_y)) then
    call defdel_xyz(action,2,error)
    if (error)  return
  endif
  !
  if (associated(column_z)) then
    call defdel_xyz(action,3,error)
    if (error)  return
  endif
  !
end subroutine create_xyz
!
subroutine more_xyz(n,error)
  use gildas_def
  use gbl_message
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>more_xyz
  use greg_xyz
  !---------------------------------------------------------------------
  ! @ private
  ! Re-allocate more buffer space for the internal X, Y and Z buffers
  !---------------------------------------------------------------------
  integer(kind=4), intent(in)    :: n      !
  logical,         intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='GREG'
  integer :: ier
  character(len=message_length) :: mess
  !
  if (n.lt.maxxy) return  ! Current allocation is enough
  !
  if (maxxy.ne.0) then
    deallocate(column_xyz)
    nullify(column_x,column_y,column_z)
    maxxy = max(2*maxxy,n)
  else
    maxxy = n
  endif
  maxxy = max(8192,maxxy)
  write(mess,*) 'Re-allocating XYZ buffers to ',maxxy,' > ',n
  call greg_message(seve%i,rname,mess)
  !
  allocate(column_xyz(maxxy,3),stat=ier)
  if (failed_allocate(rname,'X, Y, and Z buffers',ier,error))  return
  !
  column_x => column_xyz(:,1)
  column_y => column_xyz(:,2)
  ! Not yet, only when required
  !   column_z => column_xyz(:,3)
  ! but then the Z array must be undefined
  column_z => null()
  nxy = 0
end subroutine more_xyz
!
! Logic used to know if Z is defined must be revised
! Are we allowed to read X, Y, Z from 3 different files?
! This might be useful, but is quite difficult with the dynamic
! reallocation of arrays.
!
! Currently:
!    re-read X or Y implies re-initializing Z
!    re-read Z does not implies anything on X or Y, resulting in a problem
!       if Z is longer than X
!
subroutine column(line,error)
  use gildas_def
  use image_def
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>column
  use greg_column
  use greg_xyz
  use greg_image
  use gbl_message
  use gbl_format
  !---------------------------------------------------------------------
  ! @ private
  ! GREG  Support routine for command
  !       COLUMN [X nx] [Y ny] [Z nz]
  !  1           [/FILE Filename]
  !  2           [/LINE L1 L2]
  !  3           [/TABLE Tablename]
  !  4           [/COMMENT "Separator"]
  !  5           [/CLOSE]
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line   ! Command line
  logical,          intent(inout) :: error  ! Error flag
  ! Global
  include 'gbl_memory.inc'
  ! Local
  character(len=*), parameter :: rname='COLUMN'
  character(len=1) :: code,com
  character(len=filename_length) :: chain
  integer(4) :: ncx,ncy,ncz,ncxyz(3),iarg
  integer :: nc,icode,ier,i
  integer :: ifirst
  logical :: newx,delv
  character(len=message_length) :: mess
  character(len=1), parameter :: c(3) =  (/ 'X','Y','Z' /)
  integer, allocatable :: work(:)
  type(gildas) :: t
  integer(kind=4), parameter :: optfile=1
  integer(kind=4), parameter :: optline=2
  integer(kind=4), parameter :: opttable=3
  integer(kind=4), parameter :: optcomment=4
  integer(kind=4), parameter :: optclose=5
  ! Save
  character(len=filename_length), save :: datafile=''
  logical, save :: table=.false.
  save newx,t
  !
  ! The /TABLE option will be re-written in the following way
  ! - read the header when the /TABLE option is given
  ! - only read the desired columns by setting BLC / TRC adequately
  ! - transfer to appropriate location according to /LINE option
  !
  ! - Reading is done indirectly, though, as the data type
  !   may (and usually will) not match.
  !
  ! The TABLE is closed only if needed (/FILE or /TABLE options
  ! are present)
  !
  delv = .false.
  if (sic_present(opttable,0)) then  ! /TABLE option
    ! Open new table if necessary
    if (sic_present(opttable,1)) then
      if (sic_present(optfile,0)) then   ! /FILE
        call greg_message(seve%e,rname,'Incompatible options /FILE and /TABLE')
        error = .true.
        return
      else
        call sic_ch (line,opttable,1,chain,nc,.true.,error)
        if (error) return
      endif
    else
      call greg_message(seve%e,rname,'Missing argument of option /TABLE')
      error = .true.
      return
    endif
    if (t%loca%islo.ne.0) then
      call gdf_close_image (t,error)
    endif
    call sic_parse_file(chain,' ','.gdf',t%file)
    call gdf_read_header(t,error)
    if (t%gil%ndim.gt.2) then
      call greg_message(seve%e,rname,'Table must have 1 or 2 dimensions')
      error = .true.
    endif
    if (error) then
      call greg_message(seve%e,rname,'Error reading table')
      goto 98
    endif
    write(chain,'(A,I0,A,I0,A)') 'Input file has ',t%gil%dim(2),' column(s) ',t%gil%dim(1),  &
    ' lines'
    call greg_message(seve%i,rname,chain)
    ! New file: reset start/end lines
    line1 = 0  ! Code for everything (default)
    line2 = 0  ! Code for everything (default)
    table = .true.
    newx = .true.
    delv = .true.
    !
  elseif (sic_present(optfile,0)) then  ! /FILE option
    table = .false.
    call sic_ch (line,1,1,chain,nc,.true.,error)
    if (error) return
    call sic_parse_file(chain,' ','.dat',datafile)
    call column_open(datafile,maxxy,error)
    if (error) return
    newx = .true.
    delv = .true.
    !
  else
    ! No /TABLE nor /FILE: reuse previous one
    if (table) then
      ! Check the TABLE is valid
      if (t%loca%islo.eq.0) then
        call greg_message(seve%e,rname,'No previous table connected')
        error = .true.
        return
      endif
    else
      if (datafile.eq.'') then
        call greg_message(seve%e,rname,'No previous file connected')
        error = .true.
        return
      endif
      call column_open(datafile,maxxy,error)
      if (error) return
      newx = .true.
      delv = .false.  ! Should be .false. if the columns are read in several calls,
                      ! but should be .true. if e.g. the number of lines changes
                      ! between calls...
    endif
  endif
  !
  !  /LINES option: set up Lines
  if (sic_present(optline,0)) then
    call sic_i4 (line,optline,1,line1,.true.,error)
    if (error) return
    call sic_i4 (line,optline,2,line2,.false.,error)
    if (error) return
    newx = .true.  ! Not obvious, if these are the same lines as before...
    delv = .true.
  endif
  !
  ! Delete X,Y,Z buffers, unless we are just simply closing an open file
  if (sic_present(optclose,0).and.(sic_narg(0).le.0).and..not.table) then
    ! COLUMN /CLOSE (with no more argument nor options)
    call greg_message(seve%w,rname,'Closing previous /FILE with /CLOSE is obsolete')
    ! Close the file uselessly opened just above
    call column_close(error)
  else
    call delete_xyz (delv,error)
    if (error) return
  endif
  !
  ! Skip reading data if nothing else
  if (sic_narg(0).le.0) goto 97
  !
  ! Delete Z buffer if new data set
  if (delv .and. newx)  nullify(column_z)
  !
  ncx=0
  ncy=0
  ncz=0
  !
  ! Check syntax and number of arguments
  do iarg=1,sic_narg(0),2
    !
    ! Get variable name
    call sic_ke (line,0,iarg,code,nc,.true.,error)
    if (error) goto 99
    !
    ! Get column number
    call sic_i4 (line,0,iarg+1,nc,.true.,error)
    if (error) goto 99
    if (nc.le.0) then
      write(mess,'(3A,I0)') 'Invalid ',code,' column number ',nc
      call greg_message(seve%e,rname,mess)
      error = .true.
      return
    endif
    !
    ! Associate variable and column number
    if (code.eq.'X') then
      ncx = nc
    elseif (code.eq.'Y') then
      ncy = nc
    elseif (code.eq.'Z') then
      ncz = nc
      if (.not.associated(column_z)) column_z => column_xyz(:,3)
    else
      call greg_message(seve%e,rname,'Invalid variable '//code)
      error = .true.
      return
    endif
  enddo
  !
  ! Read the values
  if (table) then  ! /TABLE
    if (line1.eq.0) line1 = 1
    if (line2.eq.0) line2 = t%gil%dim(1)
    ifirst = min(line1,t%gil%dim(1))-1
    nxy  = min(line2,t%gil%dim(1)) - ifirst
    ! Should try to recover by allocating more virtual memory
    do while (nxy.gt.maxxy)
      call more_xyz(nxy,error)
      newx = .true.
      if (ncz.ne.0)  column_z => column_xyz(:,3)
      nxy = min(line2,t%gil%dim(1)) - ifirst
    enddo
    if (nxy.gt.maxxy) then
      write(chain,'(A,I6)') 'Too many data points, maximum is ',maxxy
      call greg_message(seve%e,rname,chain)
      error = .true.
      return
    elseif (nxy.le.0) then
      write(chain,'(A)') 'Negative number of data points'
      call greg_message(seve%e,rname,chain)
      error = .true.
      return
    endif
    !
    allocate (work(t%gil%dim(1)), stat=ier)
    ncxyz = (/ ncx,ncy,ncz /)
    !
    do i=1,3
      if (ncxyz(i).gt.0 .and. ncxyz(i).le.t%gil%dim(2)) then
        ! Read the appropriate BLC / TRC here
        t%blc(2) = ncxyz(i)
        t%trc(2) = ncxyz(i)
        !
        if (t%gil%form.eq.fmt_r4) then
          call gdf_read_data (t,work,error)
          if (error) return
          call r4tor8(work,column_xyz(1,i),nxy)
        elseif (t%gil%form.eq.fmt_i4) then
          call gdf_read_data (t,work,error)
          if (error) return
          call i4tor8(work,column_xyz(1,i),nxy)
        elseif (t%gil%form.eq.fmt_r8) then
          call gdf_read_data (t,column_xyz(1,i),error)
        endif
      elseif (ncxyz(i).ne.0) then
        call greg_message(seve%e,rname,C(i)//' column out of range')
      endif
    enddo
    deallocate( work)
  else  ! /FILE
    if (sic_present(optcomment,0)) then
      call sic_ch(line,optcomment,1,com,nc,.true.,error)
      if (error) return
      if (nc.ne.1) then
        call greg_message(seve%e,rname,'Comment separator must be 1 char')
        error = .true.
        return
      endif
    else
      com = comment
    endif
    if (ncx.ge.1 .or. ncy.ge.1 .or. ncz.ge.1) then
      call readcol(ncx,column_x,ncy,column_y,ncz,column_z,nxy,maxxy,  &
        error,icode,com)
      if (error) then   ! Close file in case of error
        call column_close(error)
        error = .true.
        return
      endif
      do while (icode.ne.0)
        call more_xyz(2*nxy,error)
        if (ncz.ge.1) column_z => column_xyz(:,3)
        newx = .true.
        call readcol(ncx,column_x,ncy,column_y,ncz,column_z,nxy,  &
          maxxy,error,icode,com)
        if (error) then
          call column_close(error)
          error = .true.
          return
        endif
      enddo
    endif
    call column_close(error)
  endif
  if (newx) then
    call create_xyz(error)
    newx = .false.
  endif
  !
  ! /CLOSE option: only to free /TABLE
97 if (sic_present(optclose,0)) then
    if (t%loca%islo.ne.0) then
      call gdf_close_image (t,error)
    endif
  endif
  !
  ! Normal exit
  return
  !
  ! Error reading table
98 continue
  call gdf_close_image (t,error)
  return
  !
  ! Error in list
99 call greg_message(seve%e,rname,'Syntax error in list')
  error = .true.
  !
contains
  subroutine column_open(name,maxxy,error)
    !---------------------------------------------------------------------
    ! Open a formatted file for reading columns
    !---------------------------------------------------------------------
    character(len=*), intent(in)    :: name   ! The file name
    integer(kind=4),  intent(in)    :: maxxy  ! Maximum number of lines in file
    logical,          intent(inout) :: error  ! Logical error flag
    ! Local
    integer(kind=4) :: ier
    character(len=message_length) :: chain
    !
    ! New file: reset start/end lines
    line1 = 1
    line2 = 2147483647
    !
    ier = sic_getlun(jund)
    if (ier.ne.1) then
      error = .true.
      return
    endif
    ier = sic_open(jund,name,'OLD',.true.)
    if (ier.ne.0) then
      chain = 'Error opening file '//name
      call greg_message(seve%e,'COLUMN',chain)
      call putios('E-COLUMN, ',ier)
      error = .true.
    endif
  end subroutine column_open
  !
  subroutine column_close(error)
    !---------------------------------------------------------------------
    ! Close the COLUMN reserved logical unit (if opened)
    !---------------------------------------------------------------------
    logical, intent(inout) :: error
    ! Local
    integer(kind=4) :: ier
    !
    ier = sic_close(jund)
    call sic_frelun(jund)
    !
  end subroutine column_close
  !
end subroutine column
!
subroutine readcol(ncx,arrx,ncy,arry,ncz,arrz,nxy,mxy,error,icode,com)
  use gbl_message
  use greg_interfaces, except_this=>readcol
  use greg_column
  !---------------------------------------------------------------------
  ! @ private
  !   Read up to 3 columns in the input file. Uses list-directed format
  ! but avoid comment lines beginning with a comment character (default
  ! "!", but user selectable).
  !---------------------------------------------------------------------
  integer(kind=4),  intent(in)    :: ncx      ! Column number of X values
  real(kind=8),     intent(out)   :: arrx(*)  ! X array of values
  integer(kind=4),  intent(in)    :: ncy      ! Column number of Y values
  real(kind=8),     intent(out)   :: arry(*)  ! Y array of values
  integer(kind=4),  intent(in)    :: ncz      ! Column number of Z values
  real(kind=8),     intent(out)   :: arrz(*)  ! Z array of values
  integer(kind=4),  intent(out)   :: nxy      ! Number of values read
  integer(kind=4),  intent(in)    :: mxy      ! Maximum number of values
  logical,          intent(inout) :: error    ! Logical error flag
  integer(kind=4),  intent(out)   :: icode    ! Return code
  character(len=1), intent(in)    :: com      ! Comment character
  ! Local
  character(len=*), parameter :: rname='COLUMN'
  character(len=1) :: acom
  real(kind=8), allocatable :: vars(:)
  integer(kind=4) :: i,ier,nc,iline
  character(len=256) :: line
  character(len=message_length) :: mess
  !
  icode = 0
  nxy = 0
  !
  ! Skip the first 'line1-1' lines
  do iline = 1,line1-1
    read(jund,*,iostat=ier)
    if (ier.lt.0)  goto 13     ! EOF
    if (ier.ne.0)  goto 25     ! Error
  enddo
  !
  nc = max(ncx,ncy,ncz)
  if (nc.le.0) then
    call greg_message(seve%e,rname,'Invalid column numbers')
    error = .true.
    return
  endif
  !
  ! Allocate a line array
  allocate(vars(nc),stat=ier)
  if (ier.ne.0) then
    write(mess,'(A,I0)') 'Can not allocate array for column ',nc
    call greg_message(seve%e,rname,mess)
    error = .true.
    return
  endif
  !
  ! Loop on lines
  do iline = line1,line2
    read(jund,*,iostat=ier) (vars(i),i=1,nc)
    if (ier.lt.0)  exit      ! EOF
    !
    if (ier.ne.0) then
      ! Could not read into numerics. Try into a string.
      backspace(jund)
      read(jund,'(A)',iostat=ier) line
      if (ier.ne.0)  goto 25 ! Error
      !
      ! Recover from the comment lines
      acom = adjustl(line)
      if (acom.eq.com) cycle
      !
      ! Else abort reading
      write (mess,'(A,I0,A)')  &
        'Error in list-directed read, line number ',iline,':'
      call greg_message(seve%e,rname,mess)
      call greg_message(seve%r,rname,line)
      goto 26
    endif
    !
    nxy = nxy+1
    if (nxy.gt.mxy) then
      icode = 1  ! Return to allocate more XYZ, re-start reading from beginning
      goto 13
    endif
    !
    ! Assign
    if (ncx.ge.1) arrx(nxy) = vars(ncx)
    if (ncy.ge.1) arry(nxy) = vars(ncy)
    if (ncz.ge.1) arrz(nxy) = vars(ncz)
  enddo
  !
  ! Successful exit
13 continue
  if (nxy.eq.0)  call greg_message(seve%w,rname,'No data read')
  rewind(jund)
  if (allocated(vars))  deallocate(vars)
  return
  !
  ! Erroneous exit
25 continue
  write (mess,'(A,I0)')  &
    'Serious error with this file, line number ',iline
  call greg_message(seve%e,rname,mess)
26 continue
  error = .true.
  rewind(jund)
  if (allocated(vars))  deallocate(vars)
  return
  !
end subroutine readcol

! Code for command DISCARD
! Code for command BUFFERS
! and some generic routines to support Buffers
! Specific UV routines in uv_buffers.f90
!
subroutine discard_comm(line,comm,error)
  use clean_def
  use clean_arrays
  use clean_default
  use clean_types
  use gbl_message
  use gkernel_interfaces
  use imager_interfaces, only : map_message, sub_discard
  !---------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- Support for command DISCARD
  !
  ! Delete some internal buffer(s) and associated SIC variable
  ! This is the parsing routine only.
  !!
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: line  !! Command line
  character(len=*), intent(in) :: comm  !! Command
  logical, intent(out) :: error         !! Logical error flag
  !
  integer, parameter :: muv=7
  integer, parameter :: mimag=13
  character(len=16) :: vuv(muv), vimag(mimag) 
  data vuv/    'UV_DATA',  'UVCONT', 'UVCALIB', 'UVSELF',  'UV_MODEL', 'CGAINS', 'UVRAW'/
  data vimag/ &
    & 'BEAM',    'CONTINUUM',    'DIRTY',    'RESIDUAL',    'CLEAN',    'SKY', &
    & 'MASK',    'PRIMARY',    'CCT',    'SINGLE',    'SHORT',    'SUPPORT', 'DATA' /
  !
  ! Local ---
  character(len=32) :: key
  character(len=512) :: str
  integer :: nk,i,istr
  logical :: doall, douv
  !
  ! Code ----
  error = .false.
  call sic_ch(line,0,1,key,nk,.true.,error)
  if (key.eq.'?') then
    call map_message(seve%i,'DISCARD','Available UV-Like buffers')
    write(*,*) vuv
    call map_message(seve%i,'DISCARD','Available Image-Like buffers')
    write(*,*) vimag
    return
  endif
  !
  str = ' '
  doall = .false.
  douv = .false.
  do i=1,sic_narg(0)
    !
    call sic_ke(line,0,i,key,nk,.true.,error)
    if (error) exit 
    !
    doall = key.eq.'*'
    douv  = key.eq.'UV*'
    if (key.eq.'UV') key = 'UV_DATA'
    call sub_discard(str,key,doall,douv)
    !
    if (doall.or.douv) then
      istr = len_trim(str)
      if (istr.gt.0) then
        str(istr:istr) = ']'
        call map_message(seve%i,comm,'Deallocated ['//str(1:istr))
      endif    
      str = ' '
    endif
  enddo
  !
  istr = len_trim(str)
  if (istr.gt.0) then
    str(istr:istr) = ']'
    call map_message(seve%i,comm,'Deallocated ['//str(1:istr))
  endif    
end subroutine discard_comm
!
subroutine sub_discard(str,key,doall,douv)  
  use clean_def
  use clean_arrays
  use clean_default
  use clean_types
  use clean_support
  use gbl_message
  use gkernel_interfaces, only : sic_delvariable, locwrd, gildas_null
  use imager_interfaces, only : map_message
  !---------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- Support for command DISCARD
  !
  ! Delete some internal buffer and its associated SIC variable
  !!
  !---------------------------------------------------------------------
  character(len=*), intent(inout) :: str  !! List of discarded buffers
  character(len=*), intent(in) :: key     !! Buffer to be discarded 
  logical :: doall !! Indicate if all Cube-like buffers should be discarded
  logical :: douv  !! Indicate if all UV-like buffers should be discarded
  !
  integer :: ier
  logical :: error
  !
  error = .false.
  ier = 0
  !
  if ((key.eq.'UV').or.(key.eq.'UV_DATA').or.douv) then
    if (associated(huv_init%r2d)) str = 'UV_DATA,'//trim(str)
    call discard_uvdata(error)
    if (error) ier = 1
    if (.not.douv) goto 100
  endif
  !
  if ((key.eq.'UVCONT').or.douv) then
    ! Delete the CONTINUUM UV data if defined
    call sic_delvariable ('UVCONT',.false.,error)
    if (allocated(duvc)) then
      str = 'UVCONT, '//trim(str)
      deallocate(duvc,stat=ier)
    endif
    huv_cont%loca%size = 0
    if (.not.douv) goto 100
  endif
  !
  if ((key.eq.'UVSELF').or.douv) then
    !
    ! Delete the SELF array if defined
    call sic_delvariable ('UVCALIB',.false.,error)
    call sic_delvariable ('UVSELF',.false.,error)
    if (associated(duvself)) then
      if (associated(duvself,duvcalib)) then
        nullify(duvself)
      else
        deallocate(duvself,stat=ier)
      endif
    endif
    if (allocated(duvcalib)) deallocate(duvcalib,stat=ier)
    str = 'UVSELF, '//trim(str)
    hself_self%loca%size = 0
    hself_calib%loca%size = 0
    if (.not.douv) goto 100
  endif
  !
  if ((key.eq.'UV_MODEL').or.douv) then
    ! Free the previous zone
    call sic_delvariable ('UV_MODEL',.false.,error)
    if (allocated(duvm)) then
      str = 'UV_MODEL, '//trim(str)
      deallocate(duvm,stat=ier)
      huv_model%loca%size = 0
    endif
    if (.not.douv) goto 100
  endif
  !
  if ((key.eq.'CGAINS').or.douv) then
    ! Free the previous zone
    call sic_delvariable ('CGAINS',.false.,error)
    if (allocated(duvbg)) then
      str = 'CGAINS, '//trim(str)
      deallocate(duvbg,stat=ier)
      hbgain%loca%size = 0
    endif
    if (.not.douv) goto 100
  endif
  !
  if ((key.eq.'UVRAW').or.douv) then
    ! Free the previous zone
    call sic_delvariable ('UVRAW',.false.,error)
    if (allocated(duvraw)) then
      str = 'UVRAW, '//trim(str)
      deallocate(duvraw,stat=ier)
      hself_raw%loca%size = 0
    endif
    if (.not.douv) goto 100
  endif
  
  !
  if ((key.eq.'BEAM').or.doall) then
    save_data(code_save_beam) = .false.
    call sic_delvariable ('BEAM',.false.,error)
    if (allocated(dbeam)) then
      str = 'BEAM, '//trim(str)
      deallocate(dbeam,stat=ier)
    endif
    hbeam%loca%size = 0
    if (.not.doall) goto 100
  endif
  !
  if ((key.eq.'CONTINUUM').or.doall) then
    ! Delete the CONTINUUM image if defined
    save_data(code_save_cont) = .false.
    call sic_delvariable ('CONTINUUM',.false.,error)
    if (allocated(dcont)) then
      deallocate(dcont,stat=ier)
      str = 'CONTINUUM, '//trim(str)
    endif
    hcont%loca%size = 0
    if (.not.doall) goto 100
  endif
  !
  !
  if ((key.eq.'DIRTY').or.doall) then
    save_data(code_save_dirty) = .false.
    call sic_delvariable ('DIRTY',.false.,error)
    if (allocated(ddirty)) then
      str = 'DIRTY, '//trim(str)
      deallocate(ddirty,stat=ier)
    endif
    hdirty%loca%size = 0
    if (.not.doall) goto 100
  endif
  !
  if ((key.eq.'RESIDUAL').or.doall) then
    save_data(code_save_resid) = .false.
    call sic_delvariable ('RESIDUAL',.false.,error)
    if (allocated(dresid)) then
      str = 'RESIDUAL, '//trim(str)
      deallocate(dresid,stat=ier)
    endif
    hresid%loca%size = 0
    if (.not.doall) goto 100
  endif
  !
  if ((key.eq.'CLEAN').or.doall) then
    save_data(code_save_clean) = .false.
    call sic_delvariable ('CLEAN',.false.,error)
    if (allocated(dclean)) then
      str = 'CLEAN, '//trim(str)
      deallocate(dclean,stat=ier)
    endif
    hclean%loca%size = 0
    if (.not.doall) goto 100
  endif
  !
  if ((key.eq.'SKY').or.doall) then
    save_data(code_save_sky) = .false.
    call sic_delvariable ('SKY',.false.,error)
    if (allocated(dsky)) then
      str = 'SKY, '//trim(str)
      deallocate(dsky,stat=ier)
    endif
    hsky%loca%size = 0
    if (.not.doall) goto 100
  endif
  !
  if ((key.eq.'MASK').or.doall) then
    save_data(code_save_mask) = .false.
    call sic_delvariable ('MASK',.false.,error)
    if (allocated(dmask)) then
      str = 'MASK, '//trim(str)
      deallocate(dmask,stat=ier)
    endif
    hmask%loca%size = 0
    user_method%do_mask = .true.  ! The mask HAS changed...
    if (support_type.gt.0) support_type = support_none
    if (.not.doall) goto 100
  endif
  !
  if ((key.eq.'PRIMARY').or.doall) then
    save_data(code_save_primary) = .false.
    call sic_delvariable ('PRIMARY',.false.,error)
    if (allocated(dprim)) then
      str = 'PRIMARY, '//trim(str)
      deallocate(dprim,stat=ier)
    endif
    hprim%loca%size = 0
    if (.not.doall) goto 100
  endif
  !
  if ((key.eq.'CCT').or.doall) then
    save_data(code_save_cct) = .false.
    call sic_delvariable ('CCT',.false.,error)
    if (allocated(dcct)) then
      str = 'CCT, '//trim(str)
      deallocate(dcct,stat=ier)
    endif
    hcct%loca%size = 0
    if (.not.doall) goto 100
  endif
  !
  if ((key.eq.'SINGLEDISH').or.doall) then
    save_data(code_save_single) = .false.
    call sic_delvariable ('SINGLE',.false.,error)
    call sic_delvariable ('SHORT',.false.,error)
    if (allocated(dshort)) then
      str = 'SHORT, '//trim(str)
      deallocate(dshort,stat=ier)
    endif
    hshort%loca%size = 0
    call gildas_null(hshort) ! Play safe
    if (allocated(dsingle)) then
      str = 'SINGLE, '//trim(str)
      deallocate(dsingle,stat=ier)
    endif
    hsingle%loca%size = 0
    if (.not.doall) goto 100
  endif
  !
  if ((key.eq.'SHORT').or.doall) then
    save_data(code_save_single) = .false.
    call sic_delvariable ('SHORT',.false.,error)
    if (allocated(dshort)) then
      str = 'SHORT, '//trim(str)
      deallocate(dshort,stat=ier)
    endif
    hshort%loca%size = 0
    call gildas_null(hshort) ! Play safe
    if (.not.doall) goto 100
  endif
  !
  if ((key.eq.'SUPPORT').or.doall) then
    call greg_poly_reset(supportpol,supportvar,error)
    if (error)  return
    user_method%do_mask = .true.  ! The mask HAS changed...
    support_type = support_none
    !
    ! Delete the "supportvar" structure
    call sic_delvariable(supportvar,.false.,error)
    if (.not.doall) goto 100
  endif
  !
  if (key.eq.'DATA') then    ! hview
    !! save_data(code_save_none) = .false.
    call sic_delvariable ('DATA',.false.,error)
    if (allocated(dview)) then
      str = 'DATA, '//trim(str)
      deallocate(dview,stat=ier)
    endif
    hview%loca%size = 0
    call gildas_null(hview)
  endif
  !
  if (.not.(doall.or.douv)) then
    call map_message(seve%w,'DISCARD','No code for '//key)
    error = .true.
    return
  endif
  !
100 continue
  if (ier.ne.0) then
    call map_message(seve%e,'DISCARD',trim(key)//' deallocation error')
    error = .true.
  endif
end subroutine sub_discard
!
subroutine buffers_comm(line,error)
  use gkernel_interfaces
  use clean_types
  !---------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- Support for command BUFFERS
  !
  ! List known buffer status
  !
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: line    !! Command line  
  logical :: error                        !! Logical error flag
  !
  ! Local ---
  type(sic_descriptor_t) :: desc   ! Descriptor
  logical :: found
  character(len=32) :: chain
  character(len=12) :: cmem
  character(len=12) :: ctotal
  integer :: i, j, nc
  real :: tmem, rmem
  !
  ! Code ----
  tmem = 0.
  chain = '  Size'
  cmem =  '  Memory'
  write(*,'(A,A,A,A)') 'Name        ',chain,cmem, ' Purpose '
  do i=1,mbuffer
    call sic_descriptor(cbuffer(i),desc,found)  
    if (found) then
      if (desc%ndim.eq.0) then
        chain = '(undefined)'
        cmem = ' '
      else
        chain='['
        nc = 2
        do j=1,desc%ndim
          write(chain(nc:),'(I0,A)') desc%dims(j),','
          nc = len_trim(chain)+1
        enddo
        nc = nc-1
        chain(nc:nc) = ']'
        !
        rmem = product(desc%dims(1:desc%ndim))*4/1024./1024./1024.
        write(cmem,'(F9.2)') rmem
        tmem = tmem+rmem
      endif
    else
      chain = '(undefined)  '
      cmem = ' '
    endif
    write(*,'(A,A,A,A)') cbuffer(i), chain, cmem, sbuffer(i)
  enddo
  !
  ctotal = ' '
  chain  = '   ----- Total memory ---- '
  write(cmem,'(F9.2)') tmem
  write(*,'(A,A,A,A)') ctotal, chain, cmem,'(Gbytes)'
end subroutine buffers_comm
!
subroutine dump_memory(error)
  use clean_default
  use gbl_message
  use gkernel_interfaces
  use imager_interfaces, only : map_message
  !
  !*
  ! IMAGER -- Support for DUMP MEMORY: Printout memory usage.
  !
  ! There is no generic code to retrieve the memory use.
  !
  ! On Linux, one could scan directly the /proc/self/status   file.
  !
  ! Most efficient would be to call the C Posix standard "getrusage"
  ! but that only returns the Maximum used memory, not the current one.
  ! 
  ! Other methods are system dependent, and require to fork a child, 
  ! which duplicates the memory content and can lead to Crashes !...
  !!
  logical, intent(out) :: error  !! Logical error flag
  !
  ! Local
  character(len=256) :: tmp, str, line
  character(len=16) :: cpid
  real(8) :: umem, pmem, pcpu, vsz
  integer :: ilun, idx, pid, ier
  integer(8) :: valueRSS
  ! 
  ! Code ----
  error = .true.
  ! Initialization to avoid system dependent compilation warnings 
  cpid = ' '
  line = ' '
  str = ' '
  idx = 0 
  pcpu = 0.d0
  vsz = 0.d0
  pid = 0
  !
#if defined(DARWIN)
  !
  ! System fork uses extra memory...
  ier = sic_getlog("GAG_SCRATCH:",tmp)
  ier = gag_system("LANG=US; ps -awxm -o %mem,vsz,rss,comm | sort -nr | grep imager > "// &
    & trim(tmp)//"top.tmp" )
  if (ier.eq.0) then
    ier = sic_getlun(ilun)
    open(unit=ilun,file=trim(tmp)//'top.tmp',status='old',iostat=ier)
    if (ier.eq.0) then
      read(ilun,*) pmem
      umem = (pmem*sys_ramsize/100)/1024
      write(tmp,'(A,F8.1,A,F5.1,A)') 'Current memory used ',umem,' Gbytes (',pmem,' %) of available'
      close(unit=ilun)
      call sic_message(seve%i,'DEBUG',tmp)
    endif
    call sic_frelun(ilun)
  endif
  !
  ! This only returns the max in history, not the current value...
  valueRSS = 0
  valueRSS = systMemUsageC()
  umem = valueRSS/1024.0/1024.0
  pmem = umem*100.0/sys_ramsize
  umem = umem/1024.0
  write(tmp,'(A,F8.1,A,F5.1,A)') 'Maximum memory used ',umem,' Gbytes (',pmem,' %) of available'
  call map_message(seve%i,'DEBUG',tmp)
#elif defined(LINUX)
  ier = sic_getlun(ilun)
  !
  ! Data is available in a virtual file 
  valueRSS = -1   
  open(unit=ilun, file='/proc/self/status', action='read')
  do
    read(ilun, '(a)',iostat=ier ) line
    if (ier /=0) exit
    if (line(1:6) == 'VmRSS:') then
      read(line(7:), *) valueRSS
      exit
    endif
  enddo
  close(ilun)
  call sic_frelun(ilun)
  !! Print *,'ValueRSS ',valueRSS
  umem = valueRSS/1024.0/1024.0
  pmem = umem/sys_ramsize*100.
  write(tmp,'(A,F8.1,A,F5.1,A)') 'Current memory used ',umem,' Gbytes (',pmem,' %) of available'
  call map_message(seve%i,'DEBUG',tmp)
  !
  ! This only returns the max in history, not the current value...
  valueRSS = 0
  valueRSS = systMemUsageC()
  !! Print *,'ValueRSS ',valueRSS
  umem = valueRSS/1024.0/1024.0
  pmem = umem/sys_ramsize*100.
  write(tmp,'(A,F8.1,A,F5.1,A)') 'Maximum memory used ',umem,' Gbytes (',pmem,' %) of available'
  call map_message(seve%i,'DEBUG',tmp)
#else
  ! May work on generic Unix system, but doubles the memory usage
  ! while using "system" fork. So it is prompt to crashes when
  ! reaching memory limits. This is exactly when one wants to 
  ! monitor the use, so a real issue...
  ier = sic_getlog("GAG_SCRATCH:",tmp)
  pid = gag_getpid()
  write(cpid,'(I0)') pid
  ier = gag_system("ps aux | grep imager | grep "//trim(cpid)//" > "// &
    & trim(tmp)//"ps.tmp" )
  if (ier.ne.0) return
  ier = sic_getlun(ilun)
  open(unit=ilun,file=trim(tmp)//'ps.tmp',status='old',iostat=ier)
  if (ier.ne.0) then
    call sic_frelun(ilun)
    return
  endif
  do 
    read(ilun,'(A)',iostat=ier) str
    if (ier.ne.0) exit
    idx = index(str,trim(cpid))
    if ((idx.ne.0).and.(idx.lt.16)) then
      read(str(idx:),*,iostat=ier) pid, pcpu, pmem, vsz
      umem = (pmem*sys_ramsize/100)/1024
      write(tmp,'(A,F8.1,A,F5.1,A)') 'Used memory ',umem,' Gbytes (',pmem,' % of available'
      exit
    endif
  enddo
  close(unit=ilun)
  call sic_frelun(ilun)
  if (idx.ne.0) call map_message(seve%i,'DEBUG',tmp)
#endif
  error = .false.
  !
contains
!
function systMemUsageC() result(valueRSS)
  use iso_c_binding
  interface
    subroutine getSize(val) bind(c, name='getSize')
      import :: c_long
      integer(kind=c_long) :: val
    end
  end interface
  integer(kind=8) :: valueRSS
  !
  call getSize(valueRSS)
end
end subroutine dump_memory

subroutine beam_jvm(hbeam,dbeam,jvm,circle,print,error)
  use image_def
  use gkernel_interfaces
  !-------------------------------------------------------------
  !   @ private
  !
  !*
  !   IMAGER -- Support for FIT /JVM command 
  !   Evaluate the Jorsater - van Moorsel residual scaling factor.
  !   from the dirty beam shape.
  !!
  !-------------------------------------------------------------
  type(gildas), intent(in) :: hbeam       !! Beam header
  real, intent(in) :: dbeam(:,:)          !! 2-D beam
  real, intent(out) :: jvm                !! Scaling factor
  logical, intent(in) :: circle           !! Method of circular averaging
  logical, intent(in) :: print            !! Save results for display
  logical, intent(out) :: error           !! Logical Error flag
  !
  ! Local ---
  integer :: npix, nx, ny, ix, iy, ir, ier, io
  real(8) :: cospa, sinpa, ux, uy, vx, vy, zz, ctot, dtot
  real(8) :: radius, major, minor, angle, zero, epsilon
  real(8), allocatable :: axis(:), dc(:), dd(:), cc(:), cd(:), area(:)
  integer, allocatable :: count(:)
  !
  ! Code ----
  error = .false.
  nx = hbeam%gil%dim(1)
  ny = hbeam%gil%dim(2)
  npix = min(nx,ny)/2
  !
  allocate (axis(npix), dd(npix), dc(npix), cc(npix), cd(npix), count(npix), area(npix), stat=ier)
  if (ier.ne.0) then
    error = .true.
    return
  endif
  !
  ! Compute Clean beam
  major = hbeam%gil%majo
  minor = hbeam%gil%mino
  angle = hbeam%gil%posa
  cospa = cos(angle) 
  sinpa = sin(angle)
  !
  count = 0
  dc = 0
  dd = 0
  axis = 0
  !
  ! Compute the azimutal averages of the Clean and Dirty beams,
  ! after circularization of the Clean beam, or not (according to "circle" 
  do iy=1,ny
    uy = (iy-hbeam%gil%convert(1,2))*hbeam%gil%convert(3,2)
    do ix=1,nx
      ux = (ix-hbeam%gil%convert(1,1))*hbeam%gil%convert(3,1)
      !
      vx = cospa * ux - sinpa * uy
      vy = sinpa * ux + cospa * uy
      !
      ! zz is the Square of the "deprojected" distance in Clean beam axis size
      ! so we might directly use that for the distance instead of the coordinate
      !
      zz = (vx/major)**2 + (vy/minor)**2
      zz = zz * 4.d0*log(2d0) ! FWHM to sigma conversion
      !
      if (circle) then
        radius = sqrt(zz)*major     ! Circularized beam
      else
        !
        radius = sqrt(ux**2+uy**2)  ! Elliptical beam
      endif
      ir = nint(radius/abs(hbeam%gil%convert(3,1)))
      if (ir.gt.0 .and. ir.le.npix) then
        count(ir) = count(ir)+1
        dc(ir) = dc(ir) + exp(-zz)
        dd(ir) = dd(ir) + dbeam(ix,iy) 
        axis(ir) = axis(ir) + radius
      endif
    enddo
  enddo
  !
  io = 0
  do ir=1,npix
    if (count(ir).ne.0) then
      io = io+1
      axis(io) = axis(ir)/count(ir)
      dc(io) = dc(ir)/count(ir)
      dd(io) = dd(ir)/count(ir)
      area(io) = count(ir)
    endif
  enddo
  !
  npix = io
  call gr8_trie(axis,count,npix,error)
  call gr8_sort(dc,cc,count,npix)
  call gr8_sort(dd,cc,count,npix)
  call gr8_sort(area,cc,count,npix)
  !
  ! Compute cumulative areas as a function of radius.
  ! Identify first null of the Dirty beam.
  ! Derive JvM factor as ratio of Clean to Dirty beam areas at first null.
  ctot = 0
  dtot = 0
  zero = 0
  epsilon = 0
  do ir=1,npix
    cc(ir) = ctot
    cd(ir) = dtot
    ctot = ctot + dc(ir)*area(ir)
    dtot = dtot + dd(ir)*area(ir)
    !!Print *,'IR ',ir,' Zero ',zero,' DD ',dd(ir),' Epsilon ',epsilon
    if ((zero.eq.0).and.(dd(ir).lt.zero)) then
      zero = axis(min(npix,ir+5))
      epsilon = cc(ir-1)/cd(ir-1) 
    endif
  enddo
  jvm = epsilon
  if (.not.print) return
  !
  ! This part is not Thread-Safe, but never called if in a parallel mode.
  !
  ! This is to debug the behaviour. It is based on the value of the 
  ! JVM_PRINT SIC variable decoded in the "clean_beam" routine.
  write(1,*) zero, epsilon
  write(1,*) axis(1),dc(1),dd(1),cc(1),cd(1),1.0d0,area(ir)
  do ir=2,npix
    write(1,*) axis(ir),dc(ir),dd(ir),cc(ir),cd(ir),cc(ir)/cd(ir),area(ir)
  enddo
  close(unit=1)
  !
end subroutine beam_jvm
!
subroutine fit_comm (line,error)
  use gkernel_interfaces
  use clean_def
  use clean_default
  use clean_arrays
  use clean_beams
  use gbl_message
  use imager_interfaces, only : map_message, sub_fit_beam
  !-------------------------------------------------------------
  !   @ private
  !*
  ! IMAGER -- Code for COMMAND  
  !   FIT [First Last] [PLANE|CHANNEL|FIELD First Last]   
  !       [PLANE|CHANNEL|FIELD First Last] [/JVM_FACTOR  [NoCircle]]  
  !       [/THRESHOLD Value]
  !!
  !-------------------------------------------------------------
  character(len=*), intent(in) :: line  !! Command line
  logical, intent(inout) :: error       !! Logical error flag
  !
  ! Constants
  character(len=*), parameter :: rname = 'FIT'
  real(kind=8), parameter :: pi=acos(-1d0)
  real, parameter :: sec_to_rad=acos(-1.0)/180./3600.
  real, parameter :: rad_to_sec=180.*3600./acos(-1.0)
  integer, parameter :: o_thresh=2
  integer, parameter :: o_jvm=1
  integer, parameter :: mtype=3
  character(len=8) :: ctype(mtype)
  data ctype /'CHANNEL','PLANE','FIELD'/
  !
  ! Local ---
  integer :: nfield, cfirst, clast, ffirst, flast, nchan, iarg, itype, narg, k
  logical :: do_jvm, do_circle, jvm_print
  character(len=8) :: argum, ktype
  !
  ! Code ----
  error =.true.
  !
  if (hbeam%loca%size.eq.0) then
    call map_message(seve%e,rname,'No Dirty Beam')
    return
  endif
  error = .false.
  !
  nchan = hbeam%gil%dim(hbeam%gil%faxi)
  !
  nfield = 1
  if (hbeam%char%code(3).eq.'FIELD') then
    nfield = hbeam%gil%dim(3)
  endif
  if (hbeam%gil%ndim.gt.3) then
    if (hbeam%char%code(4).eq.'FIELD') then
      nfield = hbeam%gil%dim(4)
    endif
  endif
  !
  ffirst = 1
  flast = 0
  cfirst = 1
  clast = 0
  narg = sic_narg(0)
  !
  if ((nfield.gt.1).and.(nchan.gt.1)) then
    !
    ! Required Keyword FIELD or PLANE or CHANNEL
    iarg = 1
    do while (iarg.le.narg)
      argum = ' '
      call sic_ke(line,0,1,argum,k,.true.,error)
      if (error) return
      call sic_ambigs('FIT',argum,ktype,itype,ctype,mtype,error)
      if (error) return
      iarg = iarg+1
      !
      if (itype.eq.3) then ! FIELD
        ffirst = 1
        call sic_i4 (line,0,iarg,ffirst,.false.,error)
        if (iarg.eq.narg) then
          flast = ffirst
        else
          iarg = iarg+1
          flast = 0
          call sic_i4 (line,0,iarg,flast,.false.,error)
          if (error) return
        endif
      else
        cfirst = 1
        call sic_i4 (line,0,iarg,cfirst,.false.,error)
        if (iarg.eq.narg) then
          clast = cfirst
        else
          iarg = iarg+1
          clast = 0
          call sic_i4 (line,0,iarg,clast,.false.,error)
          if (error) return
        endif
        if (error) return
      endif
      iarg = iarg+1
    enddo
    !
  else if (narg.gt.0) then     
    ! Here, keywords are optional
    argum = ' '
    call sic_ke(line,0,1,argum,k,.false.,error)
    if (nchan.gt.1) then
      !  only CHANNEL or PLANE is allowed
      if ((argum(1:1).ne.'P').and.(argum(1:1).ne.'C')) then
        iarg = 1
      else
        call sic_ambigs(' ',argum,ktype,itype,ctype,2,error)
        if (.not.error) iarg = 2
        error = .false.
      endif
      cfirst = 1
      call sic_i4 (line,0,iarg,cfirst,.false.,error)
      iarg = iarg+1
      clast = 0
      call sic_i4 (line,0,iarg,clast,.false.,error)
      if (error) return
    else
      ! only FIELD is allowed
      if (argum(1:1).ne.'F') then
        iarg = 1
      else
        call sic_ambigs(' ',argum,ktype,itype,ctype(3),1,error)
        if (.not.error) iarg = 2
        error = .false.
      endif
      ffirst = 1
      call sic_i4 (line,0,iarg,ffirst,.false.,error)
      iarg = iarg+1
      flast = 0
      call sic_i4 (line,0,iarg,flast,.false.,error)
      if (error) return
    endif    
    !
  endif
  if (flast.le.0) flast = nfield+flast
  if (clast.le.0) clast = nchan+clast
  !
  cfirst = min(max(1,cfirst),nchan)
  clast = max(cfirst,min(clast,nchan))
  ffirst = min(max(1,ffirst),nfield)
  flast = max(ffirst,min(flast,nfield))
  !
  the_method%thresh = user_method%thresh
  call sic_r4(line,o_thresh,1,the_method%thresh,.false.,error)
  if (error) return
  !
  do_jvm = sic_present(o_jvm,0)
  if (do_jvm) then
    do_circle = .not.sic_present(o_jvm,1)
    jvm_print = .false.
    call sic_get_logi('JVM_PRINT',jvm_print,error)
    error = .false.
  endif
  !--- End of parsing section
  call sub_fit_beam(nfield,nchan,ffirst,flast,cfirst,clast, &
    & do_jvm, do_circle, jvm_print, error)
end subroutine fit_comm
!
subroutine sub_fit_beam(nfield,nchan,ffirst,flast,cfirst,clast, &
    & do_jvm, do_circle, jvm_print, error)
  use gkernel_interfaces
  use clean_def
  use clean_default
  use clean_arrays
  use clean_beams
  use gbl_message
  use imager_interfaces, only : map_message, get_clean, beam_jvm
  !-------------------------------------------------------------
  !   @ private
  !*
  ! IMAGER -- BEAM Utility  
  !     Fit the dirty beam to get the beam sizes
  !!
  !-------------------------------------------------------------
  integer, intent(in) :: nfield     !! Number of fields 
  integer, intent(in) :: nchan      !! Number of channels
  integer, intent(in) :: ffirst     !! first field
  integer, intent(in) :: cfirst     !! first channel
  integer, intent(in) :: flast      !! last field
  integer, intent(in) :: clast      !! last channel
  logical, intent(in) :: do_jvm     !! Use JVM factor
  logical, intent(in) :: do_circle  !! circularize for JVM
  logical, intent(in) :: jvm_print  !! Print JVM factors
  logical, intent(inout) :: error   !! Error flag
  !
  ! Global
  character(len=*), parameter :: rname='FIT'
  real(kind=8), parameter :: pi=acos(-1d0)
  real, parameter :: sec_to_rad=acos(-1.0)/180./3600.
  real, parameter :: rad_to_sec=180.*3600./acos(-1.0)
  !
  ! Local
  type(gildas) :: head
  character(len=12) :: name
  character(len=132) :: chain
  integer(kind=index_length) :: dim(3)
  real :: jvm
  integer :: ier, kgood, kempty, jplane, jfield, iw,iz
  !
  ! Define the BEAM_VALUES variable
  if ((nchan.ne.beams_number).or.(nfield.ne.beams_field)) then
    beam_defined = .False.
    if (beams_number.ne.0) then
      call sic_delvariable('BEAM_VALUES',.false.,error)
      error = .false.
      deallocate(beams_param)
      beams_number  = 0
      beams_field = 1
    endif
    allocate(beams_param(4,nchan,nfield),stat=ier)
    if (ier.ne.0) then
      call map_message(seve%e,rname,'BEAM_VALUES allocation error')
      error = .true.
      return
    endif
    beams_param = 0.
    beams_field = nfield
    beams_number = nchan
    dim = [4,beams_number,beams_field]
    call sic_def_real('BEAM_VALUES',beams_param,3,dim,.true.,error)
  endif
  !
  if (do_jvm) then
    call gildas_null(head)
    call gdf_copy_header(hbeam,head,error)
  endif
  !
  ! Ok, now compute 
  beam_fitted = 0.
  jvm = 0 ! Required...
  kgood = 0
  kempty = 0
  !
  name = the_method%method
  the_method%method = '  '
  do jfield = ffirst, flast
    do jplane = cfirst, clast
      the_method%major = 0.0
      the_method%minor = 0.0
      the_method%angle = 0.0
      !
      call beam_unit_conversion(the_method)
      !
      if (hbeam%gil%faxi.eq.3) then
        iz = jplane
        iw = jfield
      else
        iz = jfield
        iw = jplane
      endif
      error = .false.
      call get_clean (the_method, hbeam, dbeam(:,:,iz,iw),error)
      if (error) then
        kempty = kempty+1
        cycle  ! Avoid empty beams
      endif
      if (do_jvm) then 
        head%gil%majo = the_method%major
        head%gil%mino = the_method%minor
        head%gil%posa = the_method%angle*pi/180
        call beam_jvm(head,dbeam(:,:,iz,iw),jvm,do_circle,jvm_print,error)
        error = .false.
        beam_fitted(4) = beam_fitted(4) + jvm
      endif
      call pribeam('FIT',the_method%major,the_method%minor,the_method%angle,jfield,jplane,jvm)
      !
      ! Put in output variables
      beams_param(:,jplane,jfield) = [the_method%major,the_method%minor,the_method%angle,jvm]
      !
      beam_fitted(1) = beam_fitted(1) + the_method%major*rad_to_sec
      beam_fitted(2) = beam_fitted(2) + the_method%minor*rad_to_sec
      beam_fitted(3) = beam_fitted(3) + the_method%angle
      kgood = kgood+1
    enddo
  enddo
  the_method%method = name
  beam_fitted = beam_fitted/kgood
  if (beam_fitted(4).eq.0) beam_fitted(4) = 1.0
  !
  ! Put in Beam Header
  hbeam%gil%reso_words = 3
  hbeam%gil%majo = beam_fitted(1)*sec_to_rad 
  hbeam%gil%mino = beam_fitted(2)*sec_to_rad
  hbeam%gil%posa = beam_fitted(3) * pi /180
  !
  if (.not.beam_defined) then
    call sic_def_real('BEAM_FITTED',beam_fitted,1,3,.true.,error)
    call sic_def_real('BEAM_JVM',beam_fitted(4),0,0,.true.,error)
    call sic_def_inte('BEAM_NUMBER',beams_number,0,0,.true.,error)
    call sic_def_inte('BEAM_FIELD',beams_field,0,0,.true.,error)
    beam_defined = .true.
  endif
  !
  if (kempty.ne.0) then
    write(chain,'(A,I0,A)') 'Found ',kempty,' empty beams' 
    call map_message(seve%w,rname,chain)
  endif
  if (kgood.gt.1) then
    write(chain,'(A,I0,A)') 'Averaged ',kgood,' beams'
    call map_message(seve%i,rname,chain)
    if (beam_fitted(4).eq.1.0) then
      write(chain,120) 'Beam is ',beam_fitted(1), beam_fitted(2),beam_fitted(3) 
    else
      write(chain,110) 'Beam is ',beam_fitted(1), beam_fitted(2),beam_fitted(3), beam_fitted(4) 
    endif
    call map_message(seve%i,rname,chain)
  endif
  !
  110   format (a,f8.3,'" by ',f8.3,'" at PA ',f5.1,' deg., JvM factor ',f6.3)
  120   format (a,f8.3,'" by ',f8.3,'" at PA ',f5.1,' deg. ') ! ' Field ',I3,', Channel ',I5,A,F5.2)
end subroutine sub_fit_beam
!
subroutine new_dirty_beam
  use gkernel_interfaces
  use clean_def
  use clean_arrays
  use clean_beams
  !
  !! IMAGER -- BEAM Utility  
  !! Called when a new dirty map is computed by command UV_MAP
  !
  logical :: error
  !
  ! Code ----
  error = .false.
  if (beam_defined) then
    call sic_delvariable('BEAM_VALUES',.false.,error)
    call sic_delvariable('BEAM_FITTED',.false.,error)
    call sic_delvariable('BEAM_JVM',.false.,error)
    call sic_delvariable('BEAM_NUMBER',.false.,error)
    call sic_delvariable('BEAM_FIELD',.false.,error)
    error = .false.
    deallocate(beams_param)
    beams_number  = 0
    beams_field = 1
    beam_defined = .false.
  endif
  !
  if (allocated(dclean)) deallocate(dclean)
  call sic_delvariable ('CLEAN',.false.,error)
  hclean%loca%size = 0
  !
  if (allocated(dresid)) deallocate(dresid)
  call sic_delvariable ('RESIDUAL',.false.,error)
  hresid%loca%size = 0
  !
  if (allocated(dcct)) deallocate(dcct)
  call sic_delvariable ('CCT',.false.,error)
  hcct%loca%size = 0
  !
  if (allocated(dsky)) deallocate(dsky)
  call sic_delvariable ('SKY',.false.,error)
  hsky%loca%size = 0
end subroutine new_dirty_beam
!
subroutine map_beams(task,map_beam,huv,nx,ny,nb,nc)
  use gbl_message
  use image_def
  use clean_default
  use imager_interfaces, only : t_channel_sampling, map_message
  !-------------------------------------------------------------
  ! @ private
  !
  !*   
  ! IMAGER -- BEAM Utility  
  !   Define number of dirty beams.
  !
  !   Define dirty beams number according to user specification
  !   and UV table characteristics. The control code indicates
  !   the goal.  
  !     -1    Automatic guess to avoid resolution effects  
  !      0    One beam for all, if possible  
  !     >0    Number of adjacents channels sharing same beam  
  !  Code -2 was for debugging only
  !!
  !-------------------------------------------------------------
  character(len=*), intent(in) :: task      !! Caller name
  integer, intent(out) :: map_beam          !! Number of channels per beam 
  type(gildas), intent(in) :: huv           !! UV Header
  integer, intent(in) :: nx                 !! X size
  integer, intent(in) :: ny                 !! Y size
  integer, intent(in) :: nc                 !! Number of channels
  integer, intent(out) :: nb                !! Number of beams
  !
  ! Local ---
  character(len=80) :: chain
  !
  ! Code ----
  map_beam = default_map%beam     ! Mapped to BEAM_STEP variable
  !
  if (map_beam.eq.-2) then
    nb = 1
    call map_message(seve%w,task,'You are using an obsolete BEAM_STEP value',seve%w)
  else
    !
    if (map_beam.eq.-1) then
      call t_channel_sampling(task,huv,map_beam,min(nx,ny))
      nb = (nc+map_beam-1)/map_beam       
      map_beam = (nc+nb-1)/nb
    endif
    !
    ! Round-off odd cases
    if (map_beam.eq.0) then
      nb = 1
      map_beam = nc
    else
      nb = (nc+map_beam-1)/map_beam
      map_beam = (nc+nb-1)/nb
    endif
    if (nb.eq.1) then
      chain = 'Producing a single beam for all channels'
    else
      write(chain,'(A,I4,A,I0,A,I0,A)') 'Producing one beam every ',map_beam, &
        &   ' channels, total ',nb,' beams for ',nc,' channels'
    endif
    call map_message(seve%i,task,chain)
  endif
end subroutine map_beams
!
subroutine channel_range(rname,fchan,lchan,icode,nbr,branges)
  use gkernel_interfaces
  use gkernel_types
  use gbl_message
  use clean_beams
  use imager_interfaces, only : map_message
  !---------------------------------------------------------------------
  ! @ private
  !*
  !   IMAGER -- BEAM Utility  
  ! Verify the channel ranges and restrict to most signifcant.
  !
  !   If UV_CHECK BEAM has been used, restrict the range to the 
  ! most significant one (to avoid issues with bad edge recognition)
  !!
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: rname   !! Caller name
  integer, intent(inout) :: fchan         !! First channel
  integer, intent(inout) :: lchan         !! Last channel
  integer, intent(inout) :: icode         !! Integer error code
  integer, intent(out) :: nbr             !! Number of effective ranges
  integer, intent(inout) :: branges(2,*)  !! Beam ranges
  !
  ! Constants
  real, parameter :: tol=1e-4 
  !
  ! Local ---
  integer :: krange, mrange, nrange, frange, lrange
  integer :: i, ichan, jchan
  integer, allocatable :: ranges(:), irptr(:)
  real :: weight, aweig
  character(len=120) :: chain
  !
  ! Code ----
  icode = 0
  nbr = 0
  if (nbeam_ranges.le.0) return
  !
  allocate(ranges(nbeam_ranges),irptr(nbeam_ranges),stat=icode)
  if (icode.ne.0) return
  do i=1,nbeam_ranges
    ranges(i) = beam_ranges(2,i)-beam_ranges(1,i)
  enddo
  !
  ! Ignore the small gap (< beam_gap channels) regions that may occur
  ! between regions of identical weights.
  mrange = beam_gap
  !
  nrange = 0
  frange = nbeam_ranges
  lrange = 1
  weight = 0.
  do i=1,nbeam_ranges 
    if (ranges(i).gt.mrange) then
      aweig = beam_ranges(3,i) ! Local weight !! *ranges(i) ! Total weight
      if ((weight.eq.0).or.(abs(aweig-weight).gt.tol*weight)) then
        ! Range has new weight
        weight = aweig
        krange = i
        nrange = nrange+1
        irptr(nrange) = krange
        frange = min(i,frange) 
        lrange = max(i,lrange)
        branges(1:2,nrange) = beam_ranges(1:2,i)
      else
        lrange = max(i,lrange)  ! Range has same weight than previous ones, gaps ignored
        branges(2,nrange) = beam_ranges(2,i)
      endif
    else if (i.ne.nbeam_ranges) then
      write(chain,'(A,I0,A,I0,A,I0)') 'Ignoring differing weights in BEAM_RANGE #', &
        & i,', channels ',nint(beam_ranges(1,i)),' to ',nint(beam_ranges(2,i))
      call map_message(seve%w,rname,chain)
    endif
  enddo
  !
  ! But fall back to more detailed range if NRANGE is Zero at this stage
  if (nrange.eq.0) then
    frange = nbeam_ranges
    lrange = 1
    do i=1,nbeam_ranges 
      krange = i
      nrange = nrange+1
      frange = min(i,frange) 
      lrange = max(i,lrange)
      branges(1:2,nrange) = beam_ranges(1:2,i)
    enddo
  endif
  nbr = nrange
  !
  ichan = beam_ranges(1,frange)
  ichan = max(ichan,fchan)
  jchan = beam_ranges(2,lrange)
  if (lchan.ne.0) jchan = min(lchan,jchan)
  if ((ichan.eq.fchan).and.(jchan.eq.lchan)) then
    return ! No change is good
  endif
  !
  fchan = ichan
  lchan = jchan
  if (nrange.gt.1)  then 
    ! Several Beams: Take First and Last range ends, but issue a clear warning
    call map_message(seve%w,rname,'More than 1 significant beam regions',seve%e)
    write(chain,'(A,I0,A,I0,A,I0,A,I0,A)') 'Channel range restricted to [',fchan,',',lchan, &
      & '] from BEAM_RANGES[',frange,'] and BEAM_RANGES[',lrange,']'
    call map_message(seve%w,rname,chain,seve%w)
  else 
    !TEST!  if (frange.ne.lrange) print *,'Strange case Frange ',frange,' Lrange ',lrange
    write(chain,'(A,I0,A,I0,A,I0,A,I0,A)') 'Channel range restricted to [',fchan,',',lchan, &
      & '] from BEAM_RANGES[',frange,'] and [',lrange,']'
    call map_message(seve%i,rname,chain)
  endif
  !
  icode = 0
end subroutine channel_range
!
subroutine define_beams(task,map_beam,nx,ny,huv,mcol,nb,error)
  use image_def
  use clean_default
  use gbl_message
  use imager_interfaces, only : map_message
  !---------------------------------------------------------------------
  ! @ private
  !
  !*
  ! IMAGER -- BEAM Utility  
  ! Define the number of beams according to the BEAM_STEP variable
  ! and number of data channels.
  !!
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: task   !! Caller name
  integer, intent(in) :: nx              !! X size
  integer, intent(in) :: ny              !! Y size
  integer, intent(inout) :: map_beam     !! Desired number of channels per beams
  type(gildas), intent(in) :: huv        !! UV data
  integer, intent(inout) :: mcol(2)      !! Channel range
  integer, intent(out) :: nb             !! Number of beams
  logical, intent(out) :: error          !! Logical Error Flag
  !
  ! Local ---
  integer :: nc         ! Number of channels
  integer :: icode
  character(len=120) :: chain
  !
  ! Code ----
  nc = mcol(2)-mcol(1)+1
  !
  ! Find out how many beams are required
  map_beam = default_map%beam     ! Mapped to BEAM_STEP variable
  !
  if (map_beam.eq.-2) then
    nb = 1
    call map_message(seve%w,task,'You are using an obsolete BEAM_STEP value',seve%w)
  else if (map_beam.le.0) then
    !
    if (map_beam.eq.-1) then
      call t_channel_sampling(task,huv,map_beam,min(nx,ny))
      nb = (nc+map_beam-1)/map_beam       
      map_beam = (nc+nb-1)/nb
    endif
    !
    ! Round-off odd cases
    if (map_beam.eq.0) then
      nb = 1
      map_beam = nc
    else
      nb = (nc+map_beam-1)/map_beam
      map_beam = (nc+nb-1)/nb
    endif
    if (nb.eq.1) then
      chain = 'Producing a single beam for all channels'
    else
      write(chain,'(A,I4,A,I0,A,I0,A)') 'Producing one beam every ',map_beam, &
        &   ' channels, total ',nb,' beams for ',nc,' channels'
    endif
  else
    nb = (nc+map_beam-1)/map_beam
  endif
  !
  ! Verify the beam ranges
  if (map_beam.ne.1) call check_beams_mem(error)     ! Check beam consistency if needed
  call verify_beam_ranges(task,map_beam,mcol,icode) !! ,default_map%beam)
  if (icode.eq.-1) then
    call map_message(seve%e,task,'Beam consistency is unknown, use UV_CHECK first')
    error = .true.
    return
  else if (icode.eq.1) then
    write(chain,'(A,I0,A)') 'Number of channels per beam ', map_beam, &
    ' does not fit in BEAM_RANGES'
    if (default_map%beam.eq.-1) then
      map_beam = 1
      nb = nc
      call map_message(seve%w,task,chain)
    else if (default_map%beam.eq.-2) then
      nb = 1     ! Pick up any beam
      call map_message(seve%w,task,'User forced a common beam by BEAM_STEP = -2')
    else
      call map_message(seve%e,task,chain,seve%e)
      call map_message(seve%i,task,'Use LET BEAM_STEP -1 to allow one beam per channel')
      error = .true.
      return
    endif
  endif
  !
  if (nb.eq.1) then
    chain = 'Producing a single beam for all channels'
  else if (map_beam.eq.1) then
    chain = 'Producing one beam per channel' 
    call map_message(seve%i,task,chain,seve%w)
    return
  else
    write(chain,'(A,I4,A,I0,A,I0,A)') 'Producing one beam every ',map_beam, &
      &   ' channels, total ',nb,' beams for ',nc,' channels'
  endif
  call map_message(seve%i,task,chain)
end subroutine define_beams
!
subroutine verify_beam_ranges(task,mbeam,mcol,icode)
  use gbl_message
  use clean_beams 
  use imager_interfaces, only : map_message, channel_range
  !---------------------------------------------------------------------
  !   @ private
  !*
  ! IMAGER --  BEAM utility  
  ! Verify that the selected channel range is consistent 
  ! with required number of beams.
  !!
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: task    !! Calling command
  integer, intent(in) :: mbeam            !! Number of planes per beam
  integer, intent(inout) :: mcol(2)       !! Channel range
  integer, intent(out) :: icode           !! Returned Error Code (-1 No check done, 
  !
  ! Local ---
  character(len=80) :: chain
  integer :: i, nc, nbr
  integer, allocatable :: branges(:,:)
  !
  ! Code ----
  icode = 0
  !
  if (mbeam.eq.1) return          ! One beam per plane, no problem
  if (nbeam_ranges.lt.0) then     ! No verification performed yet
    icode = -1                    ! Return error code
    return
  endif
  if (nbeam_ranges.eq.0) return   ! No beam range, no problem
  !
  ! ! Print *,'MCOL on entry ',mcol
  allocate(branges(2,nbeam_ranges))
  call channel_range(task,mcol(1),mcol(2),icode,nbr,branges) !! frange,lrange)
  if (icode.ne.0) return
  !
  if (mbeam.eq.0) then            ! Only 1 beam in total  OR
    ! Only 1 range: does it contain the imaged region ?
    ! Verify MCOL is included in one of the Beam Ranges
    do i=1,nbr
      if (mcol(1).ge.branges(1,i) .and. mcol(2).le.branges(2,i)) then
        return
      endif
    enddo
    !
  else
    !
    ! The algorithm is more complex. A solution is possible if the
    ! grid defined by the Channels per beam matches MCOL, but that is
    ! tricky to verify.
    !
    ! One may build the grid MCOL[1], MCOL[1]+MBEAM, ... MCOL[2]
    ! and figure out if BEAM_RANGES fall on that grid
    do i=1,nbr
      if (branges(1,i).le.mcol(1) .and. branges(2,i).ge.mcol(2)) then
        ! Everything is in one beam Range
        nc = mcol(2)-mcol(1)+1
        if (nc.lt.mbeam) then
          ! Less channels than "Channels per Beam"
          return ! It works, just return
        else if (mod(nc,mbeam).eq.0) then
          ! An integer number of beams, it works too
          return
        else
          write(chain,'(A,I0,A,I0,A,I0,A)') 'Beam Range #',i, &
          & ' includes Channel range [',mcol(1),',',mcol(2),']'
          call map_message(seve%w,task,chain,seve%w)
        endif
      endif
    enddo
    !
    ! There could be other matches, but they are more complex.
    !   Leave them as an error so far
    icode = 1
    !
    ! The other option is to adjust MBEAM (which then should be INOUT)
    ! to 1 channel per beam, but that makes a big difference in
    ! image size... Also, synthesized beams can be quite different
    ! in this case
  endif
end subroutine verify_beam_ranges

program extract
  use gildas_def
  use image_def
  use gbl_format
  use gkernel_interfaces
  !---------------------------------------------------------------------
  ! GILDAS	Stand alone program
  !	Extract a subset from an input n-Dim image, and place
  !	it into an output p-Dim image, which may be created
  !	at the same time.
  !
  ! "Stupid" version, which reads the whole dataset...
  !---------------------------------------------------------------------
  ! Local
  character(len=filename_length) :: namex,namey
  logical :: error,init, blankout
  integer :: i, ier, n
  integer(kind=index_length) :: iblc(4),itrc(4),iout(4),pin(4)
  integer(kind=index_length) :: oblc(4),otrc(4),pout(4),odim(4)
  real :: initval
  !
  type(gildas) :: x,y
  !
  call gildas_open
  call gildas_char('Y_NAME$',namey)
  call gildas_char('X_NAME$',namex)
  call gildas_inte('BLC$',iblc,4)
  call gildas_inte('TRC$',itrc,4)
  call gildas_inte('PIXEL_IN$',pin,4)
  call gildas_inte('PIXEL_OUT$',pout,4)
  call gildas_logi('INITIALIZE$',init,1)
  if (init) then
    call gildas_inte('X_DIM$',odim,4)
    call gildas_logi('BLANKOUT$',blankout,1)
    if (.not.blankout) then
      call gildas_real('INITVAL$',initval,1)
    endif
  endif
  call gildas_close
  !
  n = len_trim(namey)
  if (n.eq.0) call sysexi(1)
  call gildas_null(y)
  y%gil%form = fmt_r4
  call gdf_read_gildas(y,namey,'.gdf',error, rank=4)
  if (error) then
    call gagout('F-EXTRACT,  Cannot read input file')
    goto 100
  endif
  do i=1,4
    if (iblc(i).eq.0) then
      oblc(i) = 1
      iblc(i) = 1
    else
      oblc(i) = iblc(i)  ! No min-max
      iblc(i) = max(iblc(i),1)
    endif
    if (itrc(i).eq.0) then
      otrc(i) = y%gil%dim(i)
      itrc(i) = y%gil%dim(i)
    else
      otrc(i) = itrc(i)  ! No min-max
      itrc(i) = min(itrc(i),y%gil%dim(i))
    endif
    if (iblc(i).gt.itrc(i)) then
      call gagout('F-EXTRACT,  Invalid subset')
      goto 100
    endif
  enddo
  !
  call gildas_null(x)
  call gdf_copy_header(y,x,error)
  n = len_trim(namex)
  call sic_parsef(namex(1:n),x%file,' ','.gdf')
  !
  ! Init
  ! IOUT is the place of bottom left corner (IBLC) in output image
  ! Then if PIN=IBLC, IOUT = POUT
  do i=1,4
    iout(i) = pout(i)-pin(i)+iblc(i)
  enddo
  if (init) then
    x%gil%ndim = 4
    do i=1,4
      if (odim(i).eq.0) then
        x%gil%dim(i) = otrc(i)-oblc(i)+1
      else
        x%gil%dim(i) = odim(i)
      endif
    enddo
    i = 4
    do while (x%gil%dim(i).eq.1)
      x%gil%ndim = x%gil%ndim-1
      i = i-1
    enddo
    !
    ! Create output image
    x%gil%extr_words = 0
    !
    ! Put pixel IMIN,JMIN at IOUT of output image
    x%gil%ref = x%gil%ref + iout - iblc
    !
    allocate (x%r4d(x%gil%dim(1), x%gil%dim(2), x%gil%dim(3), x%gil%dim(4)), stat=ier)
    if (blankout) then
      initval = x%gil%bval
      x%gil%eval = max(x%gil%eval,0.0)
    endif
    call ext001 (   &
     &      y%r4d,y%gil%dim(1),y%gil%dim(2),y%gil%dim(3),y%gil%dim(4),   &
     &      x%r4d,x%gil%dim(1),x%gil%dim(2),x%gil%dim(3),x%gil%dim(4),   &
     &      iblc,itrc,iout,initval)
    !
  else
    !
    ! Place in
    x%gil%form = fmt_r4
    call gdf_read_gildas(x,namex,'.gdf',error, rank=4)
    if (error) then
      call gagout('F-EXTRACT,  Cannot open output file ')
      call gagout(x%file)
      goto 100
    endif
    call ext002 (   &
     &      y%r4d,y%gil%dim(1),y%gil%dim(2),y%gil%dim(3),y%gil%dim(4),   &
     &      x%r4d,x%gil%dim(1),x%gil%dim(2),x%gil%dim(3),x%gil%dim(4),   &
     &      iblc,itrc,iout,y%gil%bval,y%gil%eval)
     
  endif
  !
  call gdf_write_image(x,x%r4d,error)
  if (error) goto 100
  call gagout('S-EXTRACT,  Successful completion')
  call sysexi(1)
  !
100 call sysexi (fatale)
end program extract
!
subroutine ext001(a,na1,na2,na3,na4,   &
     &    b,nb1,nb2,nb3,nb4,ni,nu,np,blank)
  use gildas_def
  integer(kind=index_length) :: na1                    !
  integer(kind=index_length) :: na2                    !
  integer(kind=index_length) :: na3                    !
  integer(kind=index_length) :: na4                    !
  real :: a(na1,na2,na3,na4)        !
  integer(kind=index_length) :: nb1                    !
  integer(kind=index_length) :: nb2                    !
  integer(kind=index_length) :: nb3                    !
  integer(kind=index_length) :: nb4                    !
  real :: b(nb1,nb2,nb3,nb4)        !
  integer(kind=index_length) :: ni(4)                  !
  integer(kind=index_length) :: nu(4)                  !
  integer(kind=index_length) :: np(4)                  !
  real :: blank                     !
  ! Local
  integer :: ia,ja,ka,la, ib,jb,kb,lb
  !
  do lb=1,nb4
    la = lb+ni(4)-np(4)
    if (la.ge.ni(4) .and. la.le.nu(4)) then
      do kb=1,nb3
        ka = kb+ni(3)-np(3)
        if (ka.ge.ni(3) .and. ka.le.nu(3)) then
          do jb=1,nb2
            ja = jb+ni(2)-np(2)
            if (ja.ge.ni(2) .and. ja.le.nu(2)) then
              do ib=1,nb1
                ia = ib+ni(1)-np(1)
                if (ia.ge.ni(1) .and. ia.le.nu(1)) then
                  b(ib,jb,kb,lb) = a(ia,ja,ka,la)
                else
                  b(ib,jb,kb,lb) = blank
                endif
              enddo
            else
              do ib=1,nb1
                b(ib,jb,kb,lb) = blank
              enddo
            endif
          enddo
        else
          do jb=1,nb2
            do ib=1,nb1
              b(ib,jb,kb,lb) = blank
            enddo
          enddo
        endif
      enddo
    else
      do kb=1,nb3
        do jb=1,nb2
          do ib=1,nb1
            b(ib,jb,kb,lb) = blank
          enddo
        enddo
      enddo
    endif
  enddo
end subroutine ext001
!
subroutine ext002(a,na1,na2,na3,na4,   &
     &    b,nb1,nb2,nb3,nb4,ni,nu,np,ybl,tbl)
  use gildas_def
  integer(kind=index_length) :: na1                    !
  integer(kind=index_length) :: na2                    !
  integer(kind=index_length) :: na3                    !
  integer(kind=index_length) :: na4                    !
  real :: a(na1,na2,na3,na4)        !
  integer(kind=index_length) :: nb1                    !
  integer(kind=index_length) :: nb2                    !
  integer(kind=index_length) :: nb3                    !
  integer(kind=index_length) :: nb4                    !
  real :: b(nb1,nb2,nb3,nb4)        !
  integer(kind=index_length) :: ni(4)                  !
  integer(kind=index_length) :: nu(4)                  !
  integer(kind=index_length) :: np(4)                  !
  real :: ybl                       !
  real :: tbl                       !
  ! Local
  integer :: ia,ja,ka,la, ib,jb,kb,lb
  real :: v
  !
  do la = ni(4),nu(4)
    lb = la - ni(4) + np(4)
    if (lb.ge.1 .and. lb.le.nb4) then
      do ka = ni(3),nu(3)
        kb = ka - ni(3) + np(3)
        if (kb.ge.1 .and. kb.le.nb3) then
          do ja = ni(2),nu(2)
            jb = ja - ni(2) + np(2)
            if (jb.ge.1 .and. jb.le.nb2) then
              do ia = ni(1),nu(1)
                ib = ia - ni(1) + np(1)
                if (ib.ge.1 .and. ib.le.nb1) then
                  v = a (ia,ja,ka,la)
                  if (abs(v-ybl).gt.tbl) then
                    b(ib,jb,kb,lb) = v
                  endif
                endif
              enddo
            endif
          enddo
        endif
      enddo
    endif
  enddo
end subroutine ext002

subroutine gr8_trie_i4(x,it,n,error)
  use gbl_message
  use gmath_interfaces, except_this=>gr8_trie_i4
  !---------------------------------------------------------------------
  ! @ public-generic gr8_trie
  !  Sorting program that uses a quicksort algorithm.
  ! Applies for an input array of real*8 values. Also returns an array
  ! of indexes sorted for increasing order of X which can used in
  ! GR8_SORT to reorder other arrays
  ! ---
  !  This version for I*4 indices
  !---------------------------------------------------------------------
  integer(kind=4), intent(in)    :: n      ! Length of arrays
  real(kind=8),    intent(inout) :: x(n)   ! Unsorted array
  integer(kind=4), intent(out)   :: it(n)  ! Integer array of sorted indexes
  logical,         intent(out)   :: error  ! Error flag
  ! Local
  integer(kind=4), parameter :: maxstack=1000,nstop=15
  integer(kind=4) :: i,j,k,itemp
  integer(kind=4) :: l,r,m,lstack(maxstack),rstack(maxstack),sp
  real(kind=8) :: temp,key
  !
  include 'quicksort-index-numeric.inc'
end subroutine gr8_trie_i4
!
subroutine gr8_trie_i8(x,it,n,error)
  use gbl_message
  use gmath_interfaces, except_this=>gr8_trie_i8
  !---------------------------------------------------------------------
  ! @ public-generic gr8_trie
  !  Sorting program that uses a quicksort algorithm.
  ! Applies for an input array of real*8 values. Also returns an array
  ! of indexes sorted for increasing order of X which can used in
  ! GR8_SORT to reorder other arrays
  ! ---
  !  This version for I*8 indices
  !---------------------------------------------------------------------
  integer(kind=8), intent(in)    :: n      ! Length of arrays
  real(kind=8),    intent(inout) :: x(n)   ! Unsorted array
  integer(kind=8), intent(out)   :: it(n)  ! Integer array of sorted indexes
  logical,         intent(out)   :: error  ! Error flag
  ! Local
  integer(kind=8), parameter :: maxstack=1000,nstop=15
  integer(kind=8) :: i,j,k,itemp
  integer(kind=8) :: l,r,m,lstack(maxstack),rstack(maxstack),sp
  real(kind=8) :: temp,key
  !
  include 'quicksort-index-numeric.inc'
end subroutine gr8_trie_i8
!
subroutine gr8_sort(x,xwork,key,n)
  use gmath_interfaces, except_this=>gr8_sort
  !---------------------------------------------------------------------
  ! @ public-mandatory (because symbol is used elsewhere)
  !  Reorder a real*8 array by increasing order using the sorted indexes
  ! computed by a G*_TRIE subroutine
  !---------------------------------------------------------------------
  integer(kind=4), intent(in)    :: n         ! Length of arrays
  real(kind=8),    intent(inout) :: x(n)      ! Unsorted array
  real(kind=8)                   :: xwork(n)  ! Working buffer
  integer(kind=4), intent(in)    :: key(n)    ! Integer array of sorted indexes
  ! Local
  integer(kind=4) :: i
  !
  if (n.le.1) return
  do i=1,n
    xwork(i) = x(key(i))
  enddo
  do i=1,n
    x(i) = xwork(i)
  enddo
end subroutine gr8_sort
!
subroutine gr4_trie_i4(x,it,n,error)
  use gbl_message
  use gmath_interfaces, except_this=>gr4_trie_i4
  !---------------------------------------------------------------------
  ! @ public-generic gr4_trie
  !  Sorting program that uses a quicksort algorithm.
  !  Applies for an input array of real*4 values. Also returns an array
  ! of indexes sorted for increasing order of X which can used in
  ! GR4_SORT to reorder other arrays
  ! ---
  !  This version for I*4 indices
  !---------------------------------------------------------------------
  integer(kind=4), intent(in)    :: n      !
  real(kind=4),    intent(inout) :: x(n)   !
  integer(kind=4), intent(out)   :: it(n)  !
  logical,         intent(out)   :: error  !
  ! Local
  integer(kind=4), parameter :: maxstack=1000,nstop=15
  integer(kind=4) :: i,j,k,itemp,l,r,m
  integer(kind=4) :: lstack(maxstack),rstack(maxstack),sp
  real(kind=4) :: temp,key
  !
  include 'quicksort-index-numeric.inc'
end subroutine gr4_trie_i4
!
subroutine gr4_trie_i8(x,it,n,error)
  use gbl_message
  use gmath_interfaces, except_this=>gr4_trie_i8
  !---------------------------------------------------------------------
  ! @ public-generic gr4_trie
  !  Sorting program that uses a quicksort algorithm.
  !  Applies for an input array of real*4 values. Also returns an array
  ! of indexes sorted for increasing order of X which can used in
  ! GR4_SORT to reorder other arrays
  ! ---
  !  This version for I*8 indices
  !---------------------------------------------------------------------
  integer(kind=8), intent(in)    :: n      !
  real(kind=4),    intent(inout) :: x(n)   !
  integer(kind=8), intent(out)   :: it(n)  !
  logical,         intent(out)   :: error  !
  ! Local
  integer(kind=4), parameter :: maxstack=1000,nstop=15
  integer(kind=4) :: i,j,k,itemp,l,r,m
  integer(kind=4) :: lstack(maxstack),rstack(maxstack),sp
  real(kind=4) :: temp,key
  !
  include 'quicksort-index-numeric.inc'
end subroutine gr4_trie_i8
!
subroutine gr4_sort(x,xwork,key,n)
  use gmath_interfaces, except_this=>gr4_sort
  !---------------------------------------------------------------------
  ! @ public-mandatory (because symbol is used elsewhere)
  !  Reorder a real*4 array by increasing order using the sorted indexes
  ! computed by a G*_TRIE subroutine
  !---------------------------------------------------------------------
  integer(kind=4), intent(in)    :: n         !
  real(kind=4),    intent(inout) :: x(n)      !
  real(kind=4)                   :: xwork(n)  ! Working buffer
  integer(kind=4), intent(in)    :: key(n)    !
  ! Local
  integer(kind=4) :: i
  !
  if (n.le.1) return
  do i=1,n
    xwork(i) = x(key(i))
  enddo
  do i=1,n
    x(i) = xwork(i)
  enddo
end subroutine gr4_sort
!
subroutine gi4_trie_i4(x,it,n,error)
  use gbl_message
  use gmath_interfaces, except_this=>gi4_trie_i4
  !---------------------------------------------------------------------
  ! @ public-generic gi4_trie
  !  Sorting program that uses a quicksort algorithm.
  !  Applies for an input array of integer*4 values. Also returns an
  ! array of indexes sorted for increasing order of X which can used in
  ! GI4_SORT to reorder other arrays
  ! ---
  !  This version for I*4 indices
  !---------------------------------------------------------------------
  integer(kind=4), intent(in)    :: n      ! Length of arrays
  integer(kind=4), intent(inout) :: x(n)   ! Unsorted array
  integer(kind=4), intent(out)   :: it(n)  ! Integer array of sorted indexes
  logical,         intent(out)   :: error  ! Error flag
  ! Local
  integer(kind=4), parameter :: maxstack=1000,nstop=15
  integer(kind=4) :: i,j,k,itemp,l,r,m
  integer(kind=4) :: lstack(maxstack),rstack(maxstack),sp
  integer(kind=4) :: temp,key
  !
  include 'quicksort-index-numeric.inc'
end subroutine gi4_trie_i4
!
subroutine gi4_trie_i8(x,it,n,error)
  use gbl_message
  use gmath_interfaces, except_this=>gi4_trie_i8
  !---------------------------------------------------------------------
  ! @ public-generic gi4_trie
  !  Sorting program that uses a quicksort algorithm.
  !  Applies for an input array of integer*4 values. Also returns an
  ! array of indexes sorted for increasing order of X which can used in
  ! GI4_SORT to reorder other arrays
  ! ---
  !  This version for I*8 indices
  !---------------------------------------------------------------------
  integer(kind=8), intent(in)    :: n      ! Length of arrays
  integer(kind=4), intent(inout) :: x(n)   ! Unsorted array
  integer(kind=8), intent(out)   :: it(n)  ! Integer array of sorted indexes
  logical,         intent(out)   :: error  ! Error flag
  ! Local
  integer(kind=8), parameter :: maxstack=1000,nstop=15
  integer(kind=8) :: i,j,k,itemp,l,r,m
  integer(kind=8) :: lstack(maxstack),rstack(maxstack),sp
  integer(kind=4) :: temp,key
  !
  include 'quicksort-index-numeric.inc'
end subroutine gi4_trie_i8
!
subroutine gi4_sort(x,xwork,key,n)
  use gmath_interfaces, except_this=>gi4_sort
  !---------------------------------------------------------------------
  ! @ public-mandatory (because symbol is used elsewhere)
  !  Reorder an integer*4 array by increasing order using the sorted
  ! indexes computed by a G*_TRIE subroutine
  !---------------------------------------------------------------------
  integer(kind=4), intent(in)    :: n         ! Length of arrays
  integer(kind=4), intent(inout) :: x(n)      ! Unsorted array
  integer(kind=4)                :: xwork(n)  ! Working buffer
  integer(kind=4), intent(in)    :: key(n)    ! Integer array of sorted indexes
  ! Local
  integer(kind=4) :: i
  !
  if (n.le.1) return
  do i=1,n
    xwork(i) = x(key(i))
  enddo
  do i=1,n
    x(i) = xwork(i)
  enddo
end subroutine gi4_sort
!
subroutine gi8_trie_i4(x,it,n,error)
  use gbl_message
  use gmath_interfaces, except_this=>gi8_trie_i4
  !---------------------------------------------------------------------
  ! @ public-generic gi8_trie
  !  Sorting program that uses a quicksort algorithm.
  !  Applies for an input array of integer*8 values. Also returns an
  ! array of indexes sorted for increasing order of X which can used in
  ! GI8_SORT to reorder other arrays
  ! ---
  !  This version for I*4 indices
  !---------------------------------------------------------------------
  integer(kind=4), intent(in)    :: n      ! Length of arrays
  integer(kind=8), intent(inout) :: x(n)   ! Unsorted array
  integer(kind=4), intent(out)   :: it(n)  ! Integer array of sorted indexes
  logical,         intent(out)   :: error  ! Error flag
  ! Local
  integer(kind=4), parameter :: maxstack=1000,nstop=15
  integer(kind=4) :: i,j,k,itemp,l,r,m
  integer(kind=4) :: lstack(maxstack),rstack(maxstack),sp
  integer(kind=8) :: temp,key
  !
  include 'quicksort-index-numeric.inc'
end subroutine gi8_trie_i4
!
subroutine gi8_trie_i8(x,it,n,error)
  use gbl_message
  use gmath_interfaces, except_this=>gi8_trie_i8
  !---------------------------------------------------------------------
  ! @ public-generic gi8_trie
  !  Sorting program that uses a quicksort algorithm.
  !  Applies for an input array of integer*8 values. Also returns an
  ! array of indexes sorted for increasing order of X which can used in
  ! GI8_SORT to reorder other arrays
  ! ---
  !  This version for I*8 indices
  !---------------------------------------------------------------------
  integer(kind=8), intent(in)    :: n      ! Length of arrays
  integer(kind=8), intent(inout) :: x(n)   ! Unsorted array
  integer(kind=8), intent(out)   :: it(n)  ! Integer array of sorted indexes
  logical,         intent(out)   :: error  ! Error flag
  ! Local
  integer(kind=8), parameter :: maxstack=1000,nstop=15
  integer(kind=8) :: i,j,k,itemp,l,r,m
  integer(kind=8) :: lstack(maxstack),rstack(maxstack),sp
  integer(kind=8) :: temp,key
  !
  include 'quicksort-index-numeric.inc'
end subroutine gi8_trie_i8
!
subroutine gi8_sort(x,xwork,key,n)
  use gmath_interfaces, except_this=>gi8_sort
  !---------------------------------------------------------------------
  ! @ public-mandatory (because symbol is used elsewhere)
  !  Reorder an integer*8 array by increasing order using the sorted
  ! indexes computed by a G*_TRIE subroutine
  !---------------------------------------------------------------------
  integer(kind=4), intent(in)    :: n         ! Length of arrays
  integer(kind=8), intent(inout) :: x(n)      ! Unsorted array
  integer(kind=8)                :: xwork(n)  ! Working buffer
  integer(kind=4), intent(in)    :: key(n)    ! Integer array of sorted indexes
  ! Local
  integer(kind=4) :: i
  !
  if (n.le.1) return
  do i=1,n
    xwork(i) = x(key(i))
  enddo
  do i=1,n
    x(i) = xwork(i)
  enddo
end subroutine gi8_sort
!
subroutine gch_trie_i4(x,it,n,nc,error)
  use gbl_message
  use gmath_interfaces, except_this=>gch_trie_i4
  !---------------------------------------------------------------------
  ! @ public-generic gch_trie
  !  Sorting program that uses a quicksort algorithm.
  !  Applies for an input array of CHARACTER(len=*) values. Also returns
  ! an array of indexes sorted for increasing order of X which can used
  ! in GCH_SORT to reorder other arrays
  ! ---
  !  This version for I*4 indices
  !---------------------------------------------------------------------
  integer(kind=4),   intent(in)    :: n      ! Length of arrays
  integer(kind=4),   intent(in)    :: nc     ! Size of strings
  character(len=nc), intent(inout) :: x(n)   ! Unsorted array
  integer(kind=4),   intent(out)   :: it(n)  ! Integer array of sorted indexes
  logical,           intent(out)   :: error  ! Error flag
  ! Local
  integer(kind=4), parameter :: maxstack=1000,nstop=15
  integer(kind=4) :: i,j,k,itemp,l,r,m
  integer(kind=4) :: lstack(maxstack),rstack(maxstack),sp
  character(len=nc) :: temp,key
  !
  include 'quicksort-index-character.inc'
end subroutine gch_trie_i4
!
subroutine gch_trie_i8(x,it,n,nc,error)
  use gbl_message
  use gmath_interfaces, except_this=>gch_trie_i8
  !---------------------------------------------------------------------
  ! @ public-generic gch_trie
  !  Sorting program that uses a quicksort algorithm.
  !  Applies for an input array of CHARACTER(len=*) values. Also returns
  ! an array of indexes sorted for increasing order of X which can used
  ! in GCH_SORT to reorder other arrays
  ! ---
  !  This version for I*8 indices
  !---------------------------------------------------------------------
  integer(kind=8),   intent(in)    :: n      ! Length of arrays
  integer(kind=4),   intent(in)    :: nc     ! Size of strings
  character(len=nc), intent(inout) :: x(n)   ! Unsorted array
  integer(kind=8),   intent(out)   :: it(n)  ! Integer array of sorted indexes
  logical,           intent(out)   :: error  ! Error flag
  ! Local
  integer(kind=8), parameter :: maxstack=1000,nstop=15
  integer(kind=8) :: i,j,k,itemp,l,r,m
  integer(kind=8) :: lstack(maxstack),rstack(maxstack),sp
  character(len=nc) :: temp,key
  !
  include 'quicksort-index-character.inc'
end subroutine gch_trie_i8
!
subroutine gch_sort(x,xwork,key,nc,n)
  use gmath_interfaces, except_this=>gch_sort
  !---------------------------------------------------------------------
  ! @ public-mandatory (because symbol is used elsewhere)
  !   Reorder a character array by increasing order using the sorted
  ! indexes computed by a G*_TRIE subroutine
  !---------------------------------------------------------------------
  integer(kind=4),   intent(in)    :: nc        ! Size of strings
  character(len=nc), intent(inout) :: x(*)      ! The array
  character(len=nc)                :: xwork(*)  ! Work buffer
  integer(kind=4),   intent(in)    :: key(*)    ! Integer array of sorted indexes
  integer(kind=4),   intent(in)    :: n         ! Length of arrays
  ! Local
  integer(kind=4) :: i
  !
  if (n.le.1) return
  do i=1,n
    xwork(i) = x(key(i))
  enddo
  do i=1,n
    x(i) = xwork(i)
  enddo
end subroutine gch_sort
!
subroutine gl_sort(x,xwork,key,n)
  use gmath_interfaces, except_this=>gl_sort
  !---------------------------------------------------------------------
  ! @ public-mandatory (because symbol is used elsewhere)
  !  Reorder a logical*4 array by increasing order using the sorted
  ! indexes computed by a G*_TRIE subroutine
  !---------------------------------------------------------------------
  integer(kind=4), intent(in)    :: n         ! Length of arrays
  logical,         intent(inout) :: x(n)      ! Unsorted array
  logical                        :: xwork(n)  ! Working buffer
  integer(kind=4), intent(in)    :: key(n)    ! Integer array of sorted indexes
  ! Local
  integer(kind=4) :: i
  !
  if (n.le.1) return
  do i=1,n
    xwork(i) = x(key(i))
  enddo
  do i=1,n
    x(i) = xwork(i)
  enddo
end subroutine gl_sort
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine gi4_quicksort_index_with_user_gtge(x,n,ugt,uge,error)
  use gmath_interfaces, except_this=>gi4_quicksort_index_with_user_gtge
  use gbl_message
  !---------------------------------------------------------------------
  ! @ public-generic gi0_quicksort_index_with_user_gtge
  ! Sort an integer*4 index array according to an external comparison
  ! criteria. The index array can then be used by gi4_quicksort_array
  ! to sort an associated array.
  !---------------------------------------------------------------------
  integer(kind=4), intent(in)    :: n      ! Length of index array
  integer(kind=4), intent(inout) :: x(n)   ! Index array to be sorted
  logical,         external      :: ugt    ! User greater than
  logical,         external      :: uge    ! User greater than or equal
  logical,         intent(out)   :: error  ! Error status
  ! Local
  integer(kind=4), parameter :: maxstack=1000, nstop=15
  integer(kind=4) :: temp,key
  integer(kind=4) :: i,j,k,l,r,m
  integer(kind=4) :: lstack(maxstack),rstack(maxstack),sp
  !
  include 'quicksort-index-with-user-gtge.inc'
end subroutine gi4_quicksort_index_with_user_gtge
!
subroutine gi8_quicksort_index_with_user_gtge(x,n,ugt,uge,error)
  use gmath_interfaces, except_this=>gi8_quicksort_index_with_user_gtge
  use gbl_message
  !---------------------------------------------------------------------
  ! @ public-generic gi0_quicksort_index_with_user_gtge
  ! Sort an integer*8 index array according to an external comparison
  ! criteria. The index array can then be used by gi4_quicksort_array
  ! to sort an associated array.
  !---------------------------------------------------------------------
  integer(kind=8), intent(in)    :: n      ! Length of index array
  integer(kind=8), intent(inout) :: x(n)   ! Index array to be sorted
  logical,         external      :: ugt    ! User greater than
  logical,         external      :: uge    ! User greater than or equal
  logical,         intent(out)   :: error  ! Error status
  ! Local
  integer(kind=4), parameter :: maxstack=1000, nstop=15
  integer(kind=8) :: temp,key
  integer(kind=8) :: i,j,k,l,r,m
  integer(kind=8) :: lstack(maxstack),rstack(maxstack),sp
  !
  include 'quicksort-index-with-user-gtge.inc'
end subroutine gi8_quicksort_index_with_user_gtge
!
subroutine gi4_quicksort_array(array,work,index,n,error)
  use gmath_interfaces, except_this=>gi4_quicksort_array
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! Reorder an integer(4) array by increasing order using the sorted
  ! index computed by gi4_quicksort_index
  !---------------------------------------------------------------------
  integer(kind=4), intent(in)    :: n         ! Length of arrays
  integer(kind=4), intent(inout) :: array(n)  ! Array
  integer(kind=4), intent(inout) :: work(n)   ! Work space
  integer(kind=4), intent(in)    :: index(n)  ! index array
  logical,         intent(out)   :: error     ! Error status
  ! Local
  integer(kind=4) :: i
  !
  error = .false.
  if (n.le.1) then
     call gmath_message(seve%e,'SORT','Input array dimension < 1')
     error = .true.
     return
  endif
  do i=1,n
    work(i) = array(index(i))
  enddo
  do i=1,n
    array(i) = work(i)
  enddo
end subroutine gi4_quicksort_array
!
function gr8_in (x0,y0,ngon,gons,bound)
  use gmath_interfaces, except_this=>gr8_in
  !---------------------------------------------------------------------
  ! @ public
  ! Find if a point is within a n-gon.
  !
  ! This uses the Ray casting algorithm, counting how many times a ray
  ! starting from the point crosses the polygon boundaries. Note that
  ! there are critical conditions to be taken into account when the
  ! point is on a vertex or on a boundary or when the ray strikes
  ! through a vertex.
  ! References:
  !  https://en.wikipedia.org/wiki/Point_in_polygon
  !  https://rosettacode.org/wiki/Ray-casting_algorithm
  !---------------------------------------------------------------------
  logical :: gr8_in  ! Function value on return
  real(kind=8),    intent(in) :: x0,y0      ! Coordinate of point to test
  integer(kind=4), intent(in) :: ngon       ! Current number of summits
  real(kind=8),    intent(in) :: gons(:,:)  ! Description of polygon
  real(kind=8),    intent(in) :: bound(5)   ! Polygon boundary
  ! Local
  integer(kind=4) :: index,i
  real(kind=8) :: d,x,y,xx
  logical :: yin
  !
  ! Quick check.
  if (x0.lt.bound(2) .or. x0.gt.bound(3) .or.  &
      y0.lt.bound(4) .or. y0.gt.bound(5)) then
    gr8_in = .false.
    return
  endif
  gr8_in = .true.
  !
  ! Count intersection.
  x = x0
  y = y0
  index = 0
  do i=1,ngon
    !
    if (x0.eq.gons(i,1) .and. y0.eq.gons(i,2)) then
      return                   ! Summit is in
    endif
    !
    ! Ray on vertex?
    if (y0.eq.gons(i,2) .or. y0.eq.gons(i+1,2)) then
      ! To avoid the "ray on vertex" problem, the point is moved upward
      ! of a small quantity. Otherwise it would always be considered to
      ! cross the 2 segments connected to the vertex and might mess the
      ! intersection count.
      y = y0+(bound(5)-bound(4))*1.d-9
    else
      y = y0
    endif
    !
    ! Check Y range
    if (y.le.gons(i,2) .and. y.ge.gons(i+1,2)) then
      yin = .true.
    elseif (y.ge.gons(i,2) .and. y.le.gons(i+1,2)) then
      yin = .true.
    else
      yin = .false.
    endif
    !
    ! If Y is OK, check X
    if (yin) then
      !
      ! Polygon side is normal
      if (gons(i,3).ne.0) then
        d = gons(i,4)/gons(i,3)
        ! Lines intersect
        if (d.ne.0d0) then
          xx =  (y-gons(i,2))/d + gons(i,1)
          if (xx.lt.x) then
            index = index+1
          elseif (xx.eq.x) then
            return
          endif
          ! Lines have same slope (i.e. Horizontal)
        else
          if (x.ge.gons(i,1) .and. x.le.gons(i+1,1) ) then
            return             ! On edge
          elseif (x.le.gons(i,1) .and. x.ge.gons(i+1,1) ) then
            return             ! On edge
          endif
        endif
      else
        !
        ! Polygon side is vertical
        if (gons(i,1).lt.x) then
          index = index+1      ! Crosses
        elseif (gons(i,1).eq.x) then
          return               ! On edge
        endif
      endif
    endif
  enddo
  !
  gr8_in = mod(index,2).eq.1
end function gr8_in

module gmath_interfaces_private
  interface
    subroutine gr4_load(in,out,n,bval,eval,m)
      use gildas_def
      !---------------------------------------------------------------------
      ! @ private
      ! Copy input array into output array, but remove blanked values if
      ! any. Return the number of elements kept accordingly. Real*4 version.
      !---------------------------------------------------------------------
      integer(kind=size_length), intent(in)  :: n       ! Number of elements to copy
      real(kind=4),              intent(in)  :: in(n)   ! Input array
      real(kind=4),              intent(out) :: out(n)  ! Output array
      real(kind=4),              intent(in)  :: bval    ! Blanking value
      real(kind=4),              intent(in)  :: eval    ! Error value for blanking
      integer(kind=size_length), intent(out) :: m       ! Number elements kept
    end subroutine gr4_load
  end interface
  !
  interface
    subroutine gr8_load(in,out,n,bval,eval,m)
      use gildas_def
      !---------------------------------------------------------------------
      ! @ private
      ! Copy input array into output array, but remove blanked values if
      ! any. Return the number of elements kept accordingly. Real*8 version.
      !---------------------------------------------------------------------
      integer(kind=size_length), intent(in)  :: n       !
      real(kind=8),              intent(in)  :: in(n)   !
      real(kind=8),              intent(out) :: out(n)  !
      real(kind=8),              intent(in)  :: bval    !
      real(kind=8),              intent(in)  :: eval    !
      integer(kind=size_length), intent(out) :: m       !
    end subroutine gr8_load
  end interface
  !
  interface
    subroutine fit_message(fit,mseve,rname,message)
      use fit_minuit
      !---------------------------------------------------------------------
      ! @ private
      !  Print messages as usual, but they are owned by fit%owner, i.e.
      ! the message filter rules are those of the owner, not those of gmath
      ! ---
      !  Private to this file (i.e. to be used by MINUIT fitting routines
      ! only).
      !---------------------------------------------------------------------
      type(fit_minuit_t), intent(in) :: fit      !
      integer(kind=4),    intent(in) :: mseve    ! Message severity
      character(len=*),   intent(in) :: rname    ! Calling routine name
      character(len=*),   intent(in) :: message  !
    end subroutine fit_message
  end interface
  !
  interface
    subroutine derive(fit,gg,gg2,fcn)
      use fit_minuit
      !----------------------------------------------------------------------
      ! @ private
      ! Internal routine
      !      Calculates the first derivatives of FCN (GG),
      !      either by finite differences or by transforming the user-
      !      supplied derivatives to internal coordinates,
      !      according to whether ISW(3) is zero or one.
      !      if ISW(3) = 0, an error estimate GG2  is available
      !
      !      External routine FCN added to allow use of various
      !      minimization functions.
      !----------------------------------------------------------------------
      type(fit_minuit_t), intent(inout) :: fit        !
      real(kind=8),       intent(inout) :: gg(ntot)   ! First derivatives of function FCN
      real(kind=8),       intent(out)   :: gg2(nvar)  ! Error estimate for variables
      external                          :: fcn        ! Function to minimise
    end subroutine derive
  end interface
  !
  interface
    subroutine fixpar(fit,i2,kode,ilax)
      use gbl_message
      use fit_minuit
      !----------------------------------------------------------------------
      ! @ private
      ! MINUIT      Internal routine
      !      Removes parameter I2 from the internal (variable) parameter
      !      list, and arranges the rest of the list to fill the hole.
      !      If KODE=0, I2 is an external number, otherwise internal.
      !      ILAX is returned as the external number of the parameter.
      !----------------------------------------------------------------------
      type(fit_minuit_t), intent(inout) :: fit   !
      integer(kind=4),    intent(in)    :: kode  ! Indicates Internal (1) or External (0)
      integer(kind=4),    intent(in)    :: i2    ! Internal or external parameter number
      integer(kind=4),    intent(out)   :: ilax  ! External number
    end subroutine fixpar
  end interface
  !
  interface
    subroutine razzia(fit,ynew,pnew,ier)
      use gbl_message
      use fit_minuit
      !----------------------------------------------------------------------
      ! @ private
      ! MINUIT      Internal routine
      !      Called only by SIMPLEX (and IMPROV) to add a new point
      !      and remove an old one from the current simplex, and get the
      !      estimated distance to minimum.
      !----------------------------------------------------------------------
      type(fit_minuit_t), intent(inout) :: fit         !
      real(kind=8),       intent(in)    :: ynew        !
      real(kind=8),       intent(in)    :: pnew(nvar)  !
      integer(kind=4),    intent(out)   :: ier         !
    end subroutine razzia
  end interface
  !
  interface
    subroutine restor(fit,k)
      use gbl_message
      use fit_minuit
      !----------------------------------------------------------------------
      ! @ private
      ! MINUIT      Internal routine
      !      Restores a fixed parameter to variable status
      !      by inserting it into the internal parameter list at the
      !      appropriate place.
      !
      !       K = 0 means restore all parameters
      !       K = 1 means restore the last parameter fixed
      !       K = -I means restore external parameter I (if possible)
      !       IQ = fix-location where internal parameters were stored
      !       IR = external number of parameter being restored
      !       IS = internal number of parameter being restored
      !----------------------------------------------------------------------
      type(fit_minuit_t), intent(inout) :: fit  !
      integer(kind=4),    intent(in)    :: k    ! Code for operation
    end subroutine restor
  end interface
  !
  interface
    subroutine vermin(fit,a,l,m,n,ifail)
      use fit_minuit
      !----------------------------------------------------------------------
      ! @ private
      ! MINUIT      Internal routine
      !      Inverts a symmetric matrix.   Matrix is first scaled to
      !      have all ones on the diagonal (equivalent to change of units)
      !      but no pivoting is done since matrix is positive-definite.
      !----------------------------------------------------------------------
      type(fit_minuit_t), intent(in)    :: fit     !
      integer(kind=4),    intent(in)    :: l       ! 1st dim of matrix A
      integer(kind=4),    intent(in)    :: m       ! 2nd dim of matrix A
      integer(kind=4),    intent(in)    :: n       !
      real(kind=8),       intent(inout) :: a(l,m)  ! Matrix to be inverted
      integer(kind=4),    intent(out)   :: ifail   ! Error code
    end subroutine vermin
  end interface
  !
  interface
    subroutine fft1d(data,n,isign,m,xr,xi)
      !---------------------------------------------------------------------
      ! @ private-mandatory (because of explicit renaming elsewhere)
      ! Transformee de Fourier               Pierre Duhamel
      !
      ! Ce sous-programme calcule la transformee de Fourier directe
      ! (ISIGN=-1) ou inverse (ISIGN=1) du tableau complexe DATA de
      ! dimension N=2**M (n doit etre compris entre 8 et 2**mmax et etre
      ! une puissance de 2)
      !---------------------------------------------------------------------
      complex(kind=4), intent(inout) :: data(*)  !
      integer(kind=4), intent(in)    :: n        !
      integer(kind=4), intent(in)    :: isign    !
      integer(kind=4), intent(in)    :: m        !
      real(kind=4)                   :: xr(*)    !
      real(kind=4)                   :: xi(*)    !
    end subroutine fft1d
  end interface
  !
  interface
    subroutine fft2d(data,dim1,dim2,isign,m1,m2,xr,xi,mm)
      !---------------------------------------------------------------------
      ! @ private-mandatory (because of explicit renaming elsewhere)
      ! Joue le meme role que Fourt : Pas de Normalisation.
      !
      ! If Signe=-1 Then
      !       Direct Fourier Transform
      ! Else
      !       Inverse Fourier Transform
      !---------------------------------------------------------------------
      integer(kind=4), intent(in)    :: dim1             !
      integer(kind=4), intent(in)    :: dim2             !
      complex(kind=4), intent(inout) :: data(dim1,dim2)  !
      integer(kind=4), intent(in)    :: isign            !
      integer(kind=4), intent(in)    :: m1               !
      integer(kind=4), intent(in)    :: m2               !
      integer(kind=4), intent(in)    :: mm               !
      real(kind=4)                   :: xr(mm)           !
      real(kind=4)                   :: xi(mm)           !
    end subroutine fft2d
  end interface
  !
  interface
    subroutine fftcfr(xr,xi,m,n)
      !---------------------------------------------------------------------
      ! @ private
      ! FFT de sequence complexe (xr + j*xi) de taille 2**m
      !
      ! Algorithme SRFFT, version rapide, qui necessite donc un appel
      ! de INIFFT , et decimation en frequences (les rearrangements sont a
      ! effectuer apres appel a la FFT)
      !
      !  Un algorithme de transformation de Fourier rapide a double base.
      !    Pierre DUHAMEL
      !  Annales des teleommunications, tome 40, n! 9-10, sept-oct 1985
      !---------------------------------------------------------------------
      real(kind=4)                 :: xr(*)  !
      real(kind=4)                 :: xi(*)  !
      integer(kind=4), intent(in)  :: m      !
      integer(kind=4), intent(in)  :: n      !
    end subroutine fftcfr
  end interface
  !
  interface
    subroutine inifft(ind,m,n)
      !---------------------------------------------------------------------
      ! @ private
      !  Precalcul des cos, debuts de blocs et bit-reversal
      !
      !  Sous programme a appeler avant utilisation des versions rapides.
      ! Il est commun a toutes les versions, et un seul appel a INIFFT est
      ! necessaire.
      !
      ! Taille memoire requise :
      !         w1c     :       nmax/4
      !         w3c     :       nmax/4
      !         jx0     :       nmax/3
      !         BITREV  :       nmax
      !                      ---------
      !         total   :    11*nmax/6
      !---------------------------------------------------------------------
      integer(kind=4), intent(out) :: ind(*)  !
      integer(kind=4), intent(in)  :: m       !
      integer(kind=4), intent(in)  :: n       !
    end subroutine inifft
  end interface
  !
  interface
    subroutine fourct(data,nn,ndim,isign,iform,work)
      !---------------------------------------------------------------------
      ! @ private-mandatory (because symbol is used elsewhere)
      ! Cooley-Tukey Fast Fourier Transform
      !
      ! If the data is of type Real (IFORM=0), the imaginary part should be
      ! set to 0. WORK should be dimensioned to twice the largest dimension
      ! which is not a power of 2. It can be replaced by 0 if all dimensions
      ! are powers of 2.
      !
      ! The FT are not normalized in the standard way. If a Direct FT is
      ! performed, then an Inverse FT on the result, the original data is
      ! multiply by the size of the data (product of all dimensions).
      !----------------------------------------------------------------------
      real(kind=4),    intent(inout) :: data(*)  ! Complex array of data
      integer(kind=4), intent(in)    :: nn(*)    ! Dimensions of data array
      integer(kind=4), intent(in)    :: ndim     ! Number of dimensions
      integer(kind=4), intent(in)    :: isign    ! Sign of FT (-1 Direct, 1 Inverse)
      integer(kind=4), intent(in)    :: iform    ! Type of data (0 Real, 1 Complex)
      real(kind=4)                   :: work(*)  ! Work space
    end subroutine fourct
  end interface
  !
  interface
    subroutine gmath_message(mkind,procname,message)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ private
      ! Messaging facility for the current library. Calls the low-level
      ! (internal) messaging routine with its own identifier.
      !---------------------------------------------------------------------
      integer,          intent(in) :: mkind     ! Message kind
      character(len=*), intent(in) :: procname  ! Name of calling procedure
      character(len=*), intent(in) :: message   ! Message string
    end subroutine gmath_message
  end interface
  !
  interface
    subroutine gi4_quicksort_array(array,work,index,n,error)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ private
      ! Reorder an integer(4) array by increasing order using the sorted
      ! index computed by gi4_quicksort_index
      !---------------------------------------------------------------------
      integer(kind=4), intent(in)    :: n         ! Length of arrays
      integer(kind=4), intent(inout) :: array(n)  ! Array
      integer(kind=4), intent(inout) :: work(n)   ! Work space
      integer(kind=4), intent(in)    :: index(n)  ! index array
      logical,         intent(out)   :: error     ! Error status
    end subroutine gi4_quicksort_array
  end interface
  !
  interface
    subroutine gmath_random_seed_datetime(error)
      !---------------------------------------------------------------------
      ! @ private
      !  (Re)set the Fortran random seed, based on current date and time
      !  Based on Gfortran online help
      !---------------------------------------------------------------------
      logical, intent(inout) :: error  !
    end subroutine gmath_random_seed_datetime
  end interface
  !
  interface
    subroutine gmath_random_seed_urandom(error)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ private
      !  (Re)set the Fortran random seed, based on the OS random generator
      ! (if any)
      !---------------------------------------------------------------------
      logical, intent(inout) :: error  !
    end subroutine gmath_random_seed_urandom
  end interface
  !
  interface
    subroutine gmath_random_seed_value(argum,error)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ private
      !  (Re)set the Fortran random seed by using the caller input value,
      ! so that the seed and the random number sequence will be the same
      ! for an identical value.
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: argum  !
      logical,          intent(inout) :: error  !
    end subroutine gmath_random_seed_value
  end interface
  !
  interface
    subroutine gmath_random_seed_print(error)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ private
      ! Print the current Fortran random seed
      !---------------------------------------------------------------------
      logical, intent(inout) :: error  !
    end subroutine gmath_random_seed_print
  end interface
  !
  interface
    subroutine transpose_check(code,error)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ private
      ! Check that the input code is correct, i.e. check:
      !  - code too large (unsupported number of dimensions)
      !  - illegal characters (e.g. letters)
      !  - correct numbering (each dimension must be present once and only
      !    once)
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: code   !
      logical,          intent(inout) :: error  !
    end subroutine transpose_check
  end interface
  !
  interface
    subroutine transpose_repack(start,goal,repack)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ private
      !   Compute the repack array for the 'goal' starting from 'start'
      !   Note that there is no assumption on the order of the start code
      ! (in particular you can not assume it is '1234567'). This is a
      ! desired feature to call consecutively this subroutine to achieve the
      ! goal in several steps.
      !   Note also that there no assumption on the characters it contains,
      ! e.g. if you plan to modify this code, think on what should be done
      ! if start='baefdcg' and goal='bedgafc'
      !---------------------------------------------------------------------
      character(len=*), intent(inout) :: start      ! Updated on return
      character(len=*), intent(in)    :: goal       !
      integer(kind=4),  intent(out)   :: repack(5)  ! How the dimensions should be packed
    end subroutine transpose_repack
  end interface
  !
  interface
    subroutine transpose_guess(code)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ private
      !  Give users the serie of permutations needed to achieve the goal.
      ! Note that each user permutation must be given from '1234567' to
      ! 'intermediate-goal', e.g. 2143 = 2134 + 1243
      !---------------------------------------------------------------------
      character(len=*), intent(in) :: code
    end subroutine transpose_guess
  end interface
  !
  interface
    subroutine transposition_repack_to_code(repack,code)
      !---------------------------------------------------------------------
      ! @ private
      !  Generate the transposition code from the repack array
      !---------------------------------------------------------------------
      integer(kind=4),  intent(in)  :: repack(5)  !
      character(len=*), intent(out) :: code       !
    end subroutine transposition_repack_to_code
  end interface
  !
  interface
    subroutine gwavelet_mirror(nvec,vec1,vec2,error)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ private
      ! Double the size of a vector, fill the central part with the initial
      ! vector and fill the left and right part with mirror versions of the
      ! initial vector.
      ! On return the vec2 array has been allocated and filled
      !---------------------------------------------------------------------
      integer(kind=4),           intent(in)    :: nvec       ! Data size
      real(kind=4),              intent(in)    :: vec1(nvec) ! Data
      real(kind=4), allocatable, intent(inout) :: vec2(:)    ! Results
      logical,                   intent(inout) :: error      ! Logical error flag
    end subroutine gwavelet_mirror
  end interface
  !
  interface
    subroutine gwavelet_extract(nvec,nwav,wavelets2,wavelets1,error)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ private
      ! Extract the central part of a wavelet array
      ! On return the wavelet1 array has been allocated and filled
      !---------------------------------------------------------------------
      integer(kind=4),           intent(in)    :: nvec                   ! Data size
      integer(kind=4),           intent(in)    :: nwav                   ! Number of wavelets
      real(kind=4),              intent(in)    :: wavelets2(2*nvec,nwav) ! Data
      real(kind=4), allocatable, intent(inout) :: wavelets1(:,:)         ! Results
      logical,                   intent(inout) :: error                  ! Logical error flag
    end subroutine gwavelet_extract
  end interface
  !
  interface
    subroutine gwavelet_gaps_sub(vec,vsize,wavelets,nwav,error)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ private
      ! Compute and modify inplace the wavelets for input 1D data
      ! On return the input wavelets array has been allocated and filled
      !---------------------------------------------------------------------
      integer(kind=4),           intent(in)    :: vsize          ! Vector size
      real(kind=4),              intent(inout) :: vec(vsize)     ! Data / working buffer
      real(kind=4), allocatable, intent(inout) :: wavelets(:,:)  ! Results
      integer(kind=4),           intent(out)   :: nwav           ! Number of wavelets in working buffer
      logical,                   intent(inout) :: error          ! Logical error flag
    end subroutine gwavelet_gaps_sub
  end interface
  !
  interface
    subroutine gwavelet_gaps_prepare(vsize,fw,nwav)
      !---------------------------------------------------------------------
      ! @ private
      ! Compute the number of wavelets which will be needed
      !---------------------------------------------------------------------
      integer(kind=4), intent(in)  :: vsize  ! Data size
      integer(kind=4), intent(in)  :: fw     ! Filter width
      integer(kind=4), intent(out) :: nwav   ! Number of wavelets
    end subroutine gwavelet_gaps_prepare
  end interface
  !
  interface
    subroutine gwavelet_gaps_compute(vec,vsize,f1,fw1,nwav,wav,error)
      !---------------------------------------------------------------------
      ! @ private
      ! Compute the wavelets
      !---------------------------------------------------------------------
      integer(kind=4), intent(in)    :: vsize            ! Data size
      real(kind=4),    intent(inout) :: vec(vsize)       ! Data / working buffer
      integer(kind=4), intent(in)    :: fw1              ! Original filter width
      real(kind=4),    intent(in)    :: f1(fw1)          ! Original filter
      integer(kind=4), intent(in)    :: nwav             ! Number of wavelets
      real(kind=4),    intent(out)   :: wav(vsize,nwav)  ! Wavelets on return
      logical,         intent(inout) :: error            ! Logical error flag
    end subroutine gwavelet_gaps_compute
  end interface
  !
  interface
    subroutine gwavelet_convolve(din,dout,dsize,kern,ksize)
      !---------------------------------------------------------------------
      ! @ private
      ! 1D convolution
      ! This version is optimized for convolution kernels which have
      ! 0-valued elements.
      !---------------------------------------------------------------------
      integer(kind=4), intent(in)  :: dsize        ! Data size
      real(kind=4),    intent(in)  :: din(dsize)   ! Data in
      real(kind=4),    intent(out) :: dout(dsize)  ! Data out
      integer(kind=4), intent(in)  :: ksize        ! Kernel size
      real(kind=4),    intent(in)  :: kern(ksize)  ! Kernel
    end subroutine gwavelet_convolve
  end interface
  !
end module gmath_interfaces_private

*DECK SGBCO
      SUBROUTINE SGBCO (ABD, LDA, N, ML, MU, IPVT, RCOND, Z)
C***BEGIN PROLOGUE  SGBCO
C***PURPOSE  Factor a band matrix by Gaussian elimination and
C            estimate the condition number of the matrix.
C***LIBRARY   SLATEC (LINPACK)
C***CATEGORY  D2A2
C***TYPE      SINGLE PRECISION (SGBCO-S, DGBCO-D, CGBCO-C)
C***KEYWORDS  BANDED, CONDITION NUMBER, LINEAR ALGEBRA, LINPACK,
C             MATRIX FACTORIZATION
C***AUTHOR  Moler, C. B., (U. of New Mexico)
C***DESCRIPTION
C
C     SBGCO factors a real band matrix by Gaussian
C     elimination and estimates the condition of the matrix.
C
C     If  RCOND  is not needed, SGBFA is slightly faster.
C     To solve  A*X = B , follow SBGCO by SGBSL.
C     To compute  INVERSE(A)*C , follow SBGCO by SGBSL.
C     To compute  DETERMINANT(A) , follow SBGCO by SGBDI.
C
C     On Entry
C
C        ABD     REAL(LDA, N)
C                contains the matrix in band storage.  The columns
C                of the matrix are stored in the columns of  ABD  and
C                the diagonals of the matrix are stored in rows
C                ML+1 through 2*ML+MU+1 of  ABD .
C                See the comments below for details.
C
C        LDA     INTEGER
C                the leading dimension of the array  ABD .
C                LDA must be .GE. 2*ML + MU + 1 .
C
C        N       INTEGER
C                the order of the original matrix.
C
C        ML      INTEGER
C                number of diagonals below the main diagonal.
C                0 .LE. ML .LT. N .
C
C        MU      INTEGER
C                number of diagonals above the main diagonal.
C                0 .LE. MU .LT. N .
C                More efficient if  ML .LE. MU .
C
C     On Return
C
C        ABD     an upper triangular matrix in band storage and
C                the multipliers which were used to obtain it.
C                The factorization can be written  A = L*U  where
C                L  is a product of permutation and unit lower
C                triangular matrices and  U  is upper triangular.
C
C        IPVT    INTEGER(N)
C                an integer vector of pivot indices.
C
C        RCOND   REAL
C                an estimate of the reciprocal condition of  A .
C                For the system  A*X = B , relative perturbations
C                in  A  and  B  of size  EPSILON  may cause
C                relative perturbations in  X  of size  EPSILON/RCOND .
C                If  RCOND  is so small that the logical expression
C                           1.0 + RCOND .EQ. 1.0
C                is true, then  A  may be singular to working
C                precision.  In particular,  RCOND  is zero  if
C                exact singularity is detected or the estimate
C                underflows.
C
C        Z       REAL(N)
C                a work vector whose contents are usually unimportant.
C                If  A  is close to a singular matrix, then  Z  is
C                an approximate null vector in the sense that
C                NORM(A*Z) = RCOND*NORM(A)*NORM(Z) .
C
C     Band Storage
C
C           If  A  is a band matrix, the following program segment
C           will set up the input.
C
C                   ML = (band width below the diagonal)
C                   MU = (band width above the diagonal)
C                   M = ML + MU + 1
C                   DO 20 J = 1, N
C                      I1 = MAX(1, J-MU)
C                      I2 = MIN(N, J+ML)
C                      DO 10 I = I1, I2
C                         K = I - J + M
C                         ABD(K,J) = A(I,J)
C                10    CONTINUE
C                20 CONTINUE
C
C           This uses rows  ML+1  through  2*ML+MU+1  of  ABD .
C           In addition, the first  ML  rows in  ABD  are used for
C           elements generated during the triangularization.
C           The total number of rows needed in  ABD  is  2*ML+MU+1 .
C           The  ML+MU by ML+MU  upper left triangle and the
C           ML by ML  lower right triangle are not referenced.
C
C     Example:  If the original matrix is
C
C           11 12 13  0  0  0
C           21 22 23 24  0  0
C            0 32 33 34 35  0
C            0  0 43 44 45 46
C            0  0  0 54 55 56
C            0  0  0  0 65 66
C
C      then  N = 6, ML = 1, MU = 2, LDA .GE. 5  and ABD should contain
C
C            *  *  *  +  +  +  , * = not used
C            *  * 13 24 35 46  , + = used for pivoting
C            * 12 23 34 45 56
C           11 22 33 44 55 66
C           21 32 43 54 65  *
C
C***REFERENCES  J. J. Dongarra, J. R. Bunch, C. B. Moler, and G. W.
C                 Stewart, LINPACK Users' Guide, SIAM, 1979.
C***ROUTINES CALLED  SASUM, SAXPY, SDOT, SGBFA, SSCAL
C***REVISION HISTORY  (YYMMDD)
C   780814  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890831  Modified array declarations.  (WRB)
C   890831  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900326  Removed duplicate information from DESCRIPTION section.
C           (WRB)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  SGBCO
      INTEGER LDA,N,ML,MU,IPVT(*)
      REAL ABD(LDA,*),Z(*)
      REAL RCOND
C
      REAL SDOT,EK,T,WK,WKM
      REAL ANORM,S,SASUM,SM,YNORM
      INTEGER IS,INFO,J,JU,K,KB,KP1,L,LA,LM,LZ,M,MM
C
C     COMPUTE 1-NORM OF A
C
C***FIRST EXECUTABLE STATEMENT  SGBCO
      ANORM = 0.0E0
      L = ML + 1
      IS = L + MU
      DO 10 J = 1, N
         ANORM = MAX(ANORM,SASUM(L,ABD(IS,J),1))
         IF (IS .GT. ML + 1) IS = IS - 1
         IF (J .LE. MU) L = L + 1
         IF (J .GE. N - ML) L = L - 1
   10 CONTINUE
C
C     FACTOR
C
      CALL SGBFA(ABD,LDA,N,ML,MU,IPVT,INFO)
C
C     RCOND = 1/(NORM(A)*(ESTIMATE OF NORM(INVERSE(A)))) .
C     ESTIMATE = NORM(Z)/NORM(Y) WHERE  A*Z = Y  AND  TRANS(A)*Y = E .
C     TRANS(A)  IS THE TRANSPOSE OF A .  THE COMPONENTS OF  E  ARE
C     CHOSEN TO CAUSE MAXIMUM LOCAL GROWTH IN THE ELEMENTS OF W  WHERE
C     TRANS(U)*W = E .  THE VECTORS ARE FREQUENTLY RESCALED TO AVOID
C     OVERFLOW.
C
C     SOLVE TRANS(U)*W = E
C
      EK = 1.0E0
      DO 20 J = 1, N
         Z(J) = 0.0E0
   20 CONTINUE
      M = ML + MU + 1
      JU = 0
      DO 100 K = 1, N
         IF (Z(K) .NE. 0.0E0) EK = SIGN(EK,-Z(K))
         IF (ABS(EK-Z(K)) .LE. ABS(ABD(M,K))) GO TO 30
            S = ABS(ABD(M,K))/ABS(EK-Z(K))
            CALL SSCAL(N,S,Z,1)
            EK = S*EK
   30    CONTINUE
         WK = EK - Z(K)
         WKM = -EK - Z(K)
         S = ABS(WK)
         SM = ABS(WKM)
         IF (ABD(M,K) .EQ. 0.0E0) GO TO 40
            WK = WK/ABD(M,K)
            WKM = WKM/ABD(M,K)
         GO TO 50
   40    CONTINUE
            WK = 1.0E0
            WKM = 1.0E0
   50    CONTINUE
         KP1 = K + 1
         JU = MIN(MAX(JU,MU+IPVT(K)),N)
         MM = M
         IF (KP1 .GT. JU) GO TO 90
            DO 60 J = KP1, JU
               MM = MM - 1
               SM = SM + ABS(Z(J)+WKM*ABD(MM,J))
               Z(J) = Z(J) + WK*ABD(MM,J)
               S = S + ABS(Z(J))
   60       CONTINUE
            IF (S .GE. SM) GO TO 80
               T = WKM - WK
               WK = WKM
               MM = M
               DO 70 J = KP1, JU
                  MM = MM - 1
                  Z(J) = Z(J) + T*ABD(MM,J)
   70          CONTINUE
   80       CONTINUE
   90    CONTINUE
         Z(K) = WK
  100 CONTINUE
      S = 1.0E0/SASUM(N,Z,1)
      CALL SSCAL(N,S,Z,1)
C
C     SOLVE TRANS(L)*Y = W
C
      DO 120 KB = 1, N
         K = N + 1 - KB
         LM = MIN(ML,N-K)
         IF (K .LT. N) Z(K) = Z(K) + SDOT(LM,ABD(M+1,K),1,Z(K+1),1)
         IF (ABS(Z(K)) .LE. 1.0E0) GO TO 110
            S = 1.0E0/ABS(Z(K))
            CALL SSCAL(N,S,Z,1)
  110    CONTINUE
         L = IPVT(K)
         T = Z(L)
         Z(L) = Z(K)
         Z(K) = T
  120 CONTINUE
      S = 1.0E0/SASUM(N,Z,1)
      CALL SSCAL(N,S,Z,1)
C
      YNORM = 1.0E0
C
C     SOLVE L*V = Y
C
      DO 140 K = 1, N
         L = IPVT(K)
         T = Z(L)
         Z(L) = Z(K)
         Z(K) = T
         LM = MIN(ML,N-K)
         IF (K .LT. N) CALL SAXPY(LM,T,ABD(M+1,K),1,Z(K+1),1)
         IF (ABS(Z(K)) .LE. 1.0E0) GO TO 130
            S = 1.0E0/ABS(Z(K))
            CALL SSCAL(N,S,Z,1)
            YNORM = S*YNORM
  130    CONTINUE
  140 CONTINUE
      S = 1.0E0/SASUM(N,Z,1)
      CALL SSCAL(N,S,Z,1)
      YNORM = S*YNORM
C
C     SOLVE  U*Z = W
C
      DO 160 KB = 1, N
         K = N + 1 - KB
         IF (ABS(Z(K)) .LE. ABS(ABD(M,K))) GO TO 150
            S = ABS(ABD(M,K))/ABS(Z(K))
            CALL SSCAL(N,S,Z,1)
            YNORM = S*YNORM
  150    CONTINUE
         IF (ABD(M,K) .NE. 0.0E0) Z(K) = Z(K)/ABD(M,K)
         IF (ABD(M,K) .EQ. 0.0E0) Z(K) = 1.0E0
         LM = MIN(K,M) - 1
         LA = M - LM
         LZ = K - LM
         T = -Z(K)
         CALL SAXPY(LM,T,ABD(LA,K),1,Z(LZ),1)
  160 CONTINUE
C     MAKE ZNORM = 1.0
      S = 1.0E0/SASUM(N,Z,1)
      CALL SSCAL(N,S,Z,1)
      YNORM = S*YNORM
C
      IF (ANORM .NE. 0.0E0) RCOND = YNORM/ANORM
      IF (ANORM .EQ. 0.0E0) RCOND = 0.0E0
      RETURN
      END
*DECK SGBDI
      SUBROUTINE SGBDI (ABD, LDA, N, ML, MU, IPVT, DET)
C***BEGIN PROLOGUE  SGBDI
C***PURPOSE  Compute the determinant of a band matrix using the factors
C            computed by SGBCO or SGBFA.
C***LIBRARY   SLATEC (LINPACK)
C***CATEGORY  D3A2
C***TYPE      SINGLE PRECISION (SGBDI-S, DGBDI-D, CGBDI-C)
C***KEYWORDS  BANDED, DETERMINANT, INVERSE, LINEAR ALGEBRA, LINPACK,
C             MATRIX
C***AUTHOR  Moler, C. B., (U. of New Mexico)
C***DESCRIPTION
C
C     SGBDI computes the determinant of a band matrix
C     using the factors computed by SBGCO or SGBFA.
C     If the inverse is needed, use SGBSL  N  times.
C
C     On Entry
C
C        ABD     REAL(LDA, N)
C                the output from SBGCO or SGBFA.
C
C        LDA     INTEGER
C                the leading dimension of the array  ABD .
C
C        N       INTEGER
C                the order of the original matrix.
C
C        ML      INTEGER
C                number of diagonals below the main diagonal.
C
C        MU      INTEGER
C                number of diagonals above the main diagonal.
C
C        IPVT    INTEGER(N)
C                the pivot vector from SBGCO or SGBFA.
C
C     On Return
C
C        DET     REAL(2)
C                determinant of original matrix.
C                Determinant = DET(1) * 10.0**DET(2)
C                with  1.0 .LE. ABS(DET(1)) .LT. 10.0
C                or  DET(1) = 0.0 .
C
C***REFERENCES  J. J. Dongarra, J. R. Bunch, C. B. Moler, and G. W.
C                 Stewart, LINPACK Users' Guide, SIAM, 1979.
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   780814  DATE WRITTEN
C   890831  Modified array declarations.  (WRB)
C   890831  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900326  Removed duplicate information from DESCRIPTION section.
C           (WRB)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  SGBDI
      INTEGER LDA,N,ML,MU,IPVT(*)
      REAL ABD(LDA,*),DET(2)
C
      REAL TEN
      INTEGER I,M
C***FIRST EXECUTABLE STATEMENT  SGBDI
      M = ML + MU + 1
      DET(1) = 1.0E0
      DET(2) = 0.0E0
      TEN = 10.0E0
      DO 50 I = 1, N
         IF (IPVT(I) .NE. I) DET(1) = -DET(1)
         DET(1) = ABD(M,I)*DET(1)
         IF (DET(1) .EQ. 0.0E0) GO TO 60
   10    IF (ABS(DET(1)) .GE. 1.0E0) GO TO 20
            DET(1) = TEN*DET(1)
            DET(2) = DET(2) - 1.0E0
         GO TO 10
   20    CONTINUE
   30    IF (ABS(DET(1)) .LT. TEN) GO TO 40
            DET(1) = DET(1)/TEN
            DET(2) = DET(2) + 1.0E0
         GO TO 30
   40    CONTINUE
   50 CONTINUE
   60 CONTINUE
      RETURN
      END
*DECK SGBFA
      SUBROUTINE SGBFA (ABD, LDA, N, ML, MU, IPVT, INFO)
C***BEGIN PROLOGUE  SGBFA
C***PURPOSE  Factor a band matrix using Gaussian elimination.
C***LIBRARY   SLATEC (LINPACK)
C***CATEGORY  D2A2
C***TYPE      SINGLE PRECISION (SGBFA-S, DGBFA-D, CGBFA-C)
C***KEYWORDS  BANDED, LINEAR ALGEBRA, LINPACK, MATRIX FACTORIZATION
C***AUTHOR  Moler, C. B., (U. of New Mexico)
C***DESCRIPTION
C
C     SGBFA factors a real band matrix by elimination.
C
C     SGBFA is usually called by SBGCO, but it can be called
C     directly with a saving in time if  RCOND  is not needed.
C
C     On Entry
C
C        ABD     REAL(LDA, N)
C                contains the matrix in band storage.  The columns
C                of the matrix are stored in the columns of  ABD  and
C                the diagonals of the matrix are stored in rows
C                ML+1 through 2*ML+MU+1 of  ABD .
C                See the comments below for details.
C
C        LDA     INTEGER
C                the leading dimension of the array  ABD .
C                LDA must be .GE. 2*ML + MU + 1 .
C
C        N       INTEGER
C                the order of the original matrix.
C
C        ML      INTEGER
C                number of diagonals below the main diagonal.
C                0 .LE. ML .LT. N .
C
C        MU      INTEGER
C                number of diagonals above the main diagonal.
C                0 .LE. MU .LT. N .
C                More efficient if  ML .LE. MU .
C     On Return
C
C        ABD     an upper triangular matrix in band storage and
C                the multipliers which were used to obtain it.
C                The factorization can be written  A = L*U , where
C                L  is a product of permutation and unit lower
C                triangular matrices and  U  is upper triangular.
C
C        IPVT    INTEGER(N)
C                an integer vector of pivot indices.
C
C        INFO    INTEGER
C                = 0  normal value.
C                = K  if  U(K,K) .EQ. 0.0 .  This is not an error
C                     condition for this subroutine, but it does
C                     indicate that SGBSL will divide by zero if
C                     called.  Use  RCOND  in SBGCO for a reliable
C                     indication of singularity.
C
C     Band Storage
C
C           If  A  is a band matrix, the following program segment
C           will set up the input.
C
C                   ML = (band width below the diagonal)
C                   MU = (band width above the diagonal)
C                   M = ML + MU + 1
C                   DO 20 J = 1, N
C                      I1 = MAX(1, J-MU)
C                      I2 = MIN(N, J+ML)
C                      DO 10 I = I1, I2
C                         K = I - J + M
C                         ABD(K,J) = A(I,J)
C                10    CONTINUE
C                20 CONTINUE
C
C           This uses rows  ML+1  through  2*ML+MU+1  of  ABD .
C           In addition, the first  ML  rows in  ABD  are used for
C           elements generated during the triangularization.
C           The total number of rows needed in  ABD  is  2*ML+MU+1 .
C           The  ML+MU by ML+MU  upper left triangle and the
C           ML by ML  lower right triangle are not referenced.
C
C***REFERENCES  J. J. Dongarra, J. R. Bunch, C. B. Moler, and G. W.
C                 Stewart, LINPACK Users' Guide, SIAM, 1979.
C***ROUTINES CALLED  ISAMAX, SAXPY, SSCAL
C***REVISION HISTORY  (YYMMDD)
C   780814  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890831  Modified array declarations.  (WRB)
C   890831  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900326  Removed duplicate information from DESCRIPTION section.
C           (WRB)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  SGBFA
      INTEGER LDA,N,ML,MU,IPVT(*),INFO
      REAL ABD(LDA,*)
C
      REAL T
      INTEGER I,ISAMAX,I0,J,JU,JZ,J0,J1,K,KP1,L,LM,M,MM,NM1
C
C***FIRST EXECUTABLE STATEMENT  SGBFA
      M = ML + MU + 1
      INFO = 0
C
C     ZERO INITIAL FILL-IN COLUMNS
C
      J0 = MU + 2
      J1 = MIN(N,M) - 1
      IF (J1 .LT. J0) GO TO 30
      DO 20 JZ = J0, J1
         I0 = M + 1 - JZ
         DO 10 I = I0, ML
            ABD(I,JZ) = 0.0E0
   10    CONTINUE
   20 CONTINUE
   30 CONTINUE
      JZ = J1
      JU = 0
C
C     GAUSSIAN ELIMINATION WITH PARTIAL PIVOTING
C
      NM1 = N - 1
      IF (NM1 .LT. 1) GO TO 130
      DO 120 K = 1, NM1
         KP1 = K + 1
C
C        ZERO NEXT FILL-IN COLUMN
C
         JZ = JZ + 1
         IF (JZ .GT. N) GO TO 50
         IF (ML .LT. 1) GO TO 50
            DO 40 I = 1, ML
               ABD(I,JZ) = 0.0E0
   40       CONTINUE
   50    CONTINUE
C
C        FIND L = PIVOT INDEX
C
         LM = MIN(ML,N-K)
         L = ISAMAX(LM+1,ABD(M,K),1) + M - 1
         IPVT(K) = L + K - M
C
C        ZERO PIVOT IMPLIES THIS COLUMN ALREADY TRIANGULARIZED
C
         IF (ABD(L,K) .EQ. 0.0E0) GO TO 100
C
C           INTERCHANGE IF NECESSARY
C
            IF (L .EQ. M) GO TO 60
               T = ABD(L,K)
               ABD(L,K) = ABD(M,K)
               ABD(M,K) = T
   60       CONTINUE
C
C           COMPUTE MULTIPLIERS
C
            T = -1.0E0/ABD(M,K)
            CALL SSCAL(LM,T,ABD(M+1,K),1)
C
C           ROW ELIMINATION WITH COLUMN INDEXING
C
            JU = MIN(MAX(JU,MU+IPVT(K)),N)
            MM = M
            IF (JU .LT. KP1) GO TO 90
            DO 80 J = KP1, JU
               L = L - 1
               MM = MM - 1
               T = ABD(L,J)
               IF (L .EQ. MM) GO TO 70
                  ABD(L,J) = ABD(MM,J)
                  ABD(MM,J) = T
   70          CONTINUE
               CALL SAXPY(LM,T,ABD(M+1,K),1,ABD(MM+1,J),1)
   80       CONTINUE
   90       CONTINUE
         GO TO 110
  100    CONTINUE
            INFO = K
  110    CONTINUE
  120 CONTINUE
  130 CONTINUE
      IPVT(N) = N
      IF (ABD(M,N) .EQ. 0.0E0) INFO = N
      RETURN
      END
*DECK SGBSL
      SUBROUTINE SGBSL (ABD, LDA, N, ML, MU, IPVT, B, JOB)
C***BEGIN PROLOGUE  SGBSL
C***PURPOSE  Solve the real band system A*X=B or TRANS(A)*X=B using
C            the factors computed by SGBCO or SGBFA.
C***LIBRARY   SLATEC (LINPACK)
C***CATEGORY  D2A2
C***TYPE      SINGLE PRECISION (SGBSL-S, DGBSL-D, CGBSL-C)
C***KEYWORDS  BANDED, LINEAR ALGEBRA, LINPACK, MATRIX, SOLVE
C***AUTHOR  Moler, C. B., (U. of New Mexico)
C***DESCRIPTION
C
C     SGBSL solves the real band system
C     A * X = B  or  TRANS(A) * X = B
C     using the factors computed by SBGCO or SGBFA.
C
C     On Entry
C
C        ABD     REAL(LDA, N)
C                the output from SBGCO or SGBFA.
C
C        LDA     INTEGER
C                the leading dimension of the array  ABD .
C
C        N       INTEGER
C                the order of the original matrix.
C
C        ML      INTEGER
C                number of diagonals below the main diagonal.
C
C        MU      INTEGER
C                number of diagonals above the main diagonal.
C
C        IPVT    INTEGER(N)
C                the pivot vector from SBGCO or SGBFA.
C
C        B       REAL(N)
C                the right hand side vector.
C
C        JOB     INTEGER
C                = 0         to solve  A*X = B ,
C                = nonzero   to solve  TRANS(A)*X = B , where
C                            TRANS(A)  is the transpose.
C
C     On Return
C
C        B       the solution vector  X .
C
C     Error Condition
C
C        A division by zero will occur if the input factor contains a
C        zero on the diagonal.  Technically, this indicates singularity,
C        but it is often caused by improper arguments or improper
C        setting of LDA .  It will not occur if the subroutines are
C        called correctly and if SBGCO has set RCOND .GT. 0.0
C        or SGBFA has set INFO .EQ. 0 .
C
C     To compute  INVERSE(A) * C  where  C  is a matrix
C     with  P  columns
C           CALL SBGCO(ABD,LDA,N,ML,MU,IPVT,RCOND,Z)
C           If (RCOND is too small) GO TO ...
C           DO 10 J = 1, P
C              CALL SGBSL(ABD,LDA,N,ML,MU,IPVT,C(1,J),0)
C        10 CONTINUE
C
C***REFERENCES  J. J. Dongarra, J. R. Bunch, C. B. Moler, and G. W.
C                 Stewart, LINPACK Users' Guide, SIAM, 1979.
C***ROUTINES CALLED  SAXPY, SDOT
C***REVISION HISTORY  (YYMMDD)
C   780814  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890831  Modified array declarations.  (WRB)
C   890831  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900326  Removed duplicate information from DESCRIPTION section.
C           (WRB)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  SGBSL
      INTEGER LDA,N,ML,MU,IPVT(*),JOB
      REAL ABD(LDA,*),B(*)
C
      REAL SDOT,T
      INTEGER K,KB,L,LA,LB,LM,M,NM1
C***FIRST EXECUTABLE STATEMENT  SGBSL
      M = MU + ML + 1
      NM1 = N - 1
      IF (JOB .NE. 0) GO TO 50
C
C        JOB = 0 , SOLVE  A * X = B
C        FIRST SOLVE L*Y = B
C
         IF (ML .EQ. 0) GO TO 30
         IF (NM1 .LT. 1) GO TO 30
            DO 20 K = 1, NM1
               LM = MIN(ML,N-K)
               L = IPVT(K)
               T = B(L)
               IF (L .EQ. K) GO TO 10
                  B(L) = B(K)
                  B(K) = T
   10          CONTINUE
               CALL SAXPY(LM,T,ABD(M+1,K),1,B(K+1),1)
   20       CONTINUE
   30    CONTINUE
C
C        NOW SOLVE  U*X = Y
C
         DO 40 KB = 1, N
            K = N + 1 - KB
            B(K) = B(K)/ABD(M,K)
            LM = MIN(K,M) - 1
            LA = M - LM
            LB = K - LM
            T = -B(K)
            CALL SAXPY(LM,T,ABD(LA,K),1,B(LB),1)
   40    CONTINUE
      GO TO 100
   50 CONTINUE
C
C        JOB = NONZERO, SOLVE  TRANS(A) * X = B
C        FIRST SOLVE  TRANS(U)*Y = B
C
         DO 60 K = 1, N
            LM = MIN(K,M) - 1
            LA = M - LM
            LB = K - LM
            T = SDOT(LM,ABD(LA,K),1,B(LB),1)
            B(K) = (B(K) - T)/ABD(M,K)
   60    CONTINUE
C
C        NOW SOLVE TRANS(L)*X = Y
C
         IF (ML .EQ. 0) GO TO 90
         IF (NM1 .LT. 1) GO TO 90
            DO 80 KB = 1, NM1
               K = N - KB
               LM = MIN(ML,N-K)
               B(K) = B(K) + SDOT(LM,ABD(M+1,K),1,B(K+1),1)
               L = IPVT(K)
               IF (L .EQ. K) GO TO 70
                  T = B(L)
                  B(L) = B(K)
                  B(K) = T
   70          CONTINUE
   80       CONTINUE
   90    CONTINUE
  100 CONTINUE
      RETURN
      END
*DECK SGECO
      SUBROUTINE SGECO (A, LDA, N, IPVT, RCOND, Z)
C***BEGIN PROLOGUE  SGECO
C***PURPOSE  Factor a matrix using Gaussian elimination and estimate
C            the condition number of the matrix.
C***LIBRARY   SLATEC (LINPACK)
C***CATEGORY  D2A1
C***TYPE      SINGLE PRECISION (SGECO-S, DGECO-D, CGECO-C)
C***KEYWORDS  CONDITION NUMBER, GENERAL MATRIX, LINEAR ALGEBRA, LINPACK,
C             MATRIX FACTORIZATION
C***AUTHOR  Moler, C. B., (U. of New Mexico)
C***DESCRIPTION
C
C     SGECO factors a real matrix by Gaussian elimination
C     and estimates the condition of the matrix.
C
C     If  RCOND  is not needed, SGEFA is slightly faster.
C     To solve  A*X = B , follow SGECO by SGESL.
C     To compute  INVERSE(A)*C , follow SGECO by SGESL.
C     To compute  DETERMINANT(A) , follow SGECO by SGEDI.
C     To compute  INVERSE(A) , follow SGECO by SGEDI.
C
C     On Entry
C
C        A       REAL(LDA, N)
C                the matrix to be factored.
C
C        LDA     INTEGER
C                the leading dimension of the array  A .
C
C        N       INTEGER
C                the order of the matrix  A .
C
C     On Return
C
C        A       an upper triangular matrix and the multipliers
C                which were used to obtain it.
C                The factorization can be written  A = L*U , where
C                L  is a product of permutation and unit lower
C                triangular matrices and  U  is upper triangular.
C
C        IPVT    INTEGER(N)
C                an integer vector of pivot indices.
C
C        RCOND   REAL
C                an estimate of the reciprocal condition of  A .
C                For the system  A*X = B , relative perturbations
C                in  A  and  B  of size  EPSILON  may cause
C                relative perturbations in  X  of size  EPSILON/RCOND .
C                If  RCOND  is so small that the logical expression
C                           1.0 + RCOND .EQ. 1.0
C                is true, then  A  may be singular to working
C                precision.  In particular,  RCOND  is zero  if
C                exact singularity is detected or the estimate
C                underflows.
C
C        Z       REAL(N)
C                a work vector whose contents are usually unimportant.
C                If  A  is close to a singular matrix, then  Z  is
C                an approximate null vector in the sense that
C                NORM(A*Z) = RCOND*NORM(A)*NORM(Z) .
C
C***REFERENCES  J. J. Dongarra, J. R. Bunch, C. B. Moler, and G. W.
C                 Stewart, LINPACK Users' Guide, SIAM, 1979.
C***ROUTINES CALLED  SASUM, SAXPY, SDOT, SGEFA, SSCAL
C***REVISION HISTORY  (YYMMDD)
C   780814  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890831  Modified array declarations.  (WRB)
C   890831  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900326  Removed duplicate information from DESCRIPTION section.
C           (WRB)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  SGECO
      INTEGER LDA,N,IPVT(*)
      REAL A(LDA,*),Z(*)
      REAL RCOND
C
      REAL SDOT,EK,T,WK,WKM
      REAL ANORM,S,SASUM,SM,YNORM
      INTEGER INFO,J,K,KB,KP1,L
C
C     COMPUTE 1-NORM OF A
C
C***FIRST EXECUTABLE STATEMENT  SGECO
      ANORM = 0.0E0
      DO 10 J = 1, N
         ANORM = MAX(ANORM,SASUM(N,A(1,J),1))
   10 CONTINUE
C
C     FACTOR
C
      CALL SGEFA(A,LDA,N,IPVT,INFO)
C
C     RCOND = 1/(NORM(A)*(ESTIMATE OF NORM(INVERSE(A)))) .
C     ESTIMATE = NORM(Z)/NORM(Y) WHERE  A*Z = Y  AND  TRANS(A)*Y = E .
C     TRANS(A)  IS THE TRANSPOSE OF A .  THE COMPONENTS OF  E  ARE
C     CHOSEN TO CAUSE MAXIMUM LOCAL GROWTH IN THE ELEMENTS OF W  WHERE
C     TRANS(U)*W = E .  THE VECTORS ARE FREQUENTLY RESCALED TO AVOID
C     OVERFLOW.
C
C     SOLVE TRANS(U)*W = E
C
      EK = 1.0E0
      DO 20 J = 1, N
         Z(J) = 0.0E0
   20 CONTINUE
      DO 100 K = 1, N
         IF (Z(K) .NE. 0.0E0) EK = SIGN(EK,-Z(K))
         IF (ABS(EK-Z(K)) .LE. ABS(A(K,K))) GO TO 30
            S = ABS(A(K,K))/ABS(EK-Z(K))
            CALL SSCAL(N,S,Z,1)
            EK = S*EK
   30    CONTINUE
         WK = EK - Z(K)
         WKM = -EK - Z(K)
         S = ABS(WK)
         SM = ABS(WKM)
         IF (A(K,K) .EQ. 0.0E0) GO TO 40
            WK = WK/A(K,K)
            WKM = WKM/A(K,K)
         GO TO 50
   40    CONTINUE
            WK = 1.0E0
            WKM = 1.0E0
   50    CONTINUE
         KP1 = K + 1
         IF (KP1 .GT. N) GO TO 90
            DO 60 J = KP1, N
               SM = SM + ABS(Z(J)+WKM*A(K,J))
               Z(J) = Z(J) + WK*A(K,J)
               S = S + ABS(Z(J))
   60       CONTINUE
            IF (S .GE. SM) GO TO 80
               T = WKM - WK
               WK = WKM
               DO 70 J = KP1, N
                  Z(J) = Z(J) + T*A(K,J)
   70          CONTINUE
   80       CONTINUE
   90    CONTINUE
         Z(K) = WK
  100 CONTINUE
      S = 1.0E0/SASUM(N,Z,1)
      CALL SSCAL(N,S,Z,1)
C
C     SOLVE TRANS(L)*Y = W
C
      DO 120 KB = 1, N
         K = N + 1 - KB
         IF (K .LT. N) Z(K) = Z(K) + SDOT(N-K,A(K+1,K),1,Z(K+1),1)
         IF (ABS(Z(K)) .LE. 1.0E0) GO TO 110
            S = 1.0E0/ABS(Z(K))
            CALL SSCAL(N,S,Z,1)
  110    CONTINUE
         L = IPVT(K)
         T = Z(L)
         Z(L) = Z(K)
         Z(K) = T
  120 CONTINUE
      S = 1.0E0/SASUM(N,Z,1)
      CALL SSCAL(N,S,Z,1)
C
      YNORM = 1.0E0
C
C     SOLVE L*V = Y
C
      DO 140 K = 1, N
         L = IPVT(K)
         T = Z(L)
         Z(L) = Z(K)
         Z(K) = T
         IF (K .LT. N) CALL SAXPY(N-K,T,A(K+1,K),1,Z(K+1),1)
         IF (ABS(Z(K)) .LE. 1.0E0) GO TO 130
            S = 1.0E0/ABS(Z(K))
            CALL SSCAL(N,S,Z,1)
            YNORM = S*YNORM
  130    CONTINUE
  140 CONTINUE
      S = 1.0E0/SASUM(N,Z,1)
      CALL SSCAL(N,S,Z,1)
      YNORM = S*YNORM
C
C     SOLVE  U*Z = V
C
      DO 160 KB = 1, N
         K = N + 1 - KB
         IF (ABS(Z(K)) .LE. ABS(A(K,K))) GO TO 150
            S = ABS(A(K,K))/ABS(Z(K))
            CALL SSCAL(N,S,Z,1)
            YNORM = S*YNORM
  150    CONTINUE
         IF (A(K,K) .NE. 0.0E0) Z(K) = Z(K)/A(K,K)
         IF (A(K,K) .EQ. 0.0E0) Z(K) = 1.0E0
         T = -Z(K)
         CALL SAXPY(K-1,T,A(1,K),1,Z(1),1)
  160 CONTINUE
C     MAKE ZNORM = 1.0
      S = 1.0E0/SASUM(N,Z,1)
      CALL SSCAL(N,S,Z,1)
      YNORM = S*YNORM
C
      IF (ANORM .NE. 0.0E0) RCOND = YNORM/ANORM
      IF (ANORM .EQ. 0.0E0) RCOND = 0.0E0
      RETURN
      END
*DECK SGEDI
      SUBROUTINE SGEDI (A, LDA, N, IPVT, DET, WORK, JOB)
C***BEGIN PROLOGUE  SGEDI
C***PURPOSE  Compute the determinant and inverse of a matrix using the
C            factors computed by SGECO or SGEFA.
C***LIBRARY   SLATEC (LINPACK)
C***CATEGORY  D2A1, D3A1
C***TYPE      SINGLE PRECISION (SGEDI-S, DGEDI-D, CGEDI-C)
C***KEYWORDS  DETERMINANT, INVERSE, LINEAR ALGEBRA, LINPACK, MATRIX
C***AUTHOR  Moler, C. B., (U. of New Mexico)
C***DESCRIPTION
C
C     SGEDI computes the determinant and inverse of a matrix
C     using the factors computed by SGECO or SGEFA.
C
C     On Entry
C
C        A       REAL(LDA, N)
C                the output from SGECO or SGEFA.
C
C        LDA     INTEGER
C                the leading dimension of the array  A .
C
C        N       INTEGER
C                the order of the matrix  A .
C
C        IPVT    INTEGER(N)
C                the pivot vector from SGECO or SGEFA.
C
C        WORK    REAL(N)
C                work vector.  Contents destroyed.
C
C        JOB     INTEGER
C                = 11   both determinant and inverse.
C                = 01   inverse only.
C                = 10   determinant only.
C
C     On Return
C
C        A       inverse of original matrix if requested.
C                Otherwise unchanged.
C
C        DET     REAL(2)
C                determinant of original matrix if requested.
C                Otherwise not referenced.
C                Determinant = DET(1) * 10.0**DET(2)
C                with  1.0 .LE. ABS(DET(1)) .LT. 10.0
C                or  DET(1) .EQ. 0.0 .
C
C     Error Condition
C
C        A division by zero will occur if the input factor contains
C        a zero on the diagonal and the inverse is requested.
C        It will not occur if the subroutines are called correctly
C        and if SGECO has set RCOND .GT. 0.0 or SGEFA has set
C        INFO .EQ. 0 .
C
C***REFERENCES  J. J. Dongarra, J. R. Bunch, C. B. Moler, and G. W.
C                 Stewart, LINPACK Users' Guide, SIAM, 1979.
C***ROUTINES CALLED  SAXPY, SSCAL, SSWAP
C***REVISION HISTORY  (YYMMDD)
C   780814  DATE WRITTEN
C   890831  Modified array declarations.  (WRB)
C   890831  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900326  Removed duplicate information from DESCRIPTION section.
C           (WRB)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  SGEDI
      INTEGER LDA,N,IPVT(*),JOB
      REAL A(LDA,*),DET(2),WORK(*)
C
      REAL T
      REAL TEN
      INTEGER I,J,K,KB,KP1,L,NM1
C***FIRST EXECUTABLE STATEMENT  SGEDI
C
C     COMPUTE DETERMINANT
C
      IF (JOB/10 .EQ. 0) GO TO 70
         DET(1) = 1.0E0
         DET(2) = 0.0E0
         TEN = 10.0E0
         DO 50 I = 1, N
            IF (IPVT(I) .NE. I) DET(1) = -DET(1)
            DET(1) = A(I,I)*DET(1)
            IF (DET(1) .EQ. 0.0E0) GO TO 60
   10       IF (ABS(DET(1)) .GE. 1.0E0) GO TO 20
               DET(1) = TEN*DET(1)
               DET(2) = DET(2) - 1.0E0
            GO TO 10
   20       CONTINUE
   30       IF (ABS(DET(1)) .LT. TEN) GO TO 40
               DET(1) = DET(1)/TEN
               DET(2) = DET(2) + 1.0E0
            GO TO 30
   40       CONTINUE
   50    CONTINUE
   60    CONTINUE
   70 CONTINUE
C
C     COMPUTE INVERSE(U)
C
      IF (MOD(JOB,10) .EQ. 0) GO TO 150
         DO 100 K = 1, N
            A(K,K) = 1.0E0/A(K,K)
            T = -A(K,K)
            CALL SSCAL(K-1,T,A(1,K),1)
            KP1 = K + 1
            IF (N .LT. KP1) GO TO 90
            DO 80 J = KP1, N
               T = A(K,J)
               A(K,J) = 0.0E0
               CALL SAXPY(K,T,A(1,K),1,A(1,J),1)
   80       CONTINUE
   90       CONTINUE
  100    CONTINUE
C
C        FORM INVERSE(U)*INVERSE(L)
C
         NM1 = N - 1
         IF (NM1 .LT. 1) GO TO 140
         DO 130 KB = 1, NM1
            K = N - KB
            KP1 = K + 1
            DO 110 I = KP1, N
               WORK(I) = A(I,K)
               A(I,K) = 0.0E0
  110       CONTINUE
            DO 120 J = KP1, N
               T = WORK(J)
               CALL SAXPY(N,T,A(1,J),1,A(1,K),1)
  120       CONTINUE
            L = IPVT(K)
            IF (L .NE. K) CALL SSWAP(N,A(1,K),1,A(1,L),1)
  130    CONTINUE
  140    CONTINUE
  150 CONTINUE
      RETURN
      END
*DECK SGEFA
      SUBROUTINE SGEFA (A, LDA, N, IPVT, INFO)
C***BEGIN PROLOGUE  SGEFA
C***PURPOSE  Factor a matrix using Gaussian elimination.
C***LIBRARY   SLATEC (LINPACK)
C***CATEGORY  D2A1
C***TYPE      SINGLE PRECISION (SGEFA-S, DGEFA-D, CGEFA-C)
C***KEYWORDS  GENERAL MATRIX, LINEAR ALGEBRA, LINPACK,
C             MATRIX FACTORIZATION
C***AUTHOR  Moler, C. B., (U. of New Mexico)
C***DESCRIPTION
C
C     SGEFA factors a real matrix by Gaussian elimination.
C
C     SGEFA is usually called by SGECO, but it can be called
C     directly with a saving in time if  RCOND  is not needed.
C     (Time for SGECO) = (1 + 9/N)*(Time for SGEFA) .
C
C     On Entry
C
C        A       REAL(LDA, N)
C                the matrix to be factored.
C
C        LDA     INTEGER
C                the leading dimension of the array  A .
C
C        N       INTEGER
C                the order of the matrix  A .
C
C     On Return
C
C        A       an upper triangular matrix and the multipliers
C                which were used to obtain it.
C                The factorization can be written  A = L*U , where
C                L  is a product of permutation and unit lower
C                triangular matrices and  U  is upper triangular.
C
C        IPVT    INTEGER(N)
C                an integer vector of pivot indices.
C
C        INFO    INTEGER
C                = 0  normal value.
C                = K  if  U(K,K) .EQ. 0.0 .  This is not an error
C                     condition for this subroutine, but it does
C                     indicate that SGESL or SGEDI will divide by zero
C                     if called.  Use  RCOND  in SGECO for a reliable
C                     indication of singularity.
C
C***REFERENCES  J. J. Dongarra, J. R. Bunch, C. B. Moler, and G. W.
C                 Stewart, LINPACK Users' Guide, SIAM, 1979.
C***ROUTINES CALLED  ISAMAX, SAXPY, SSCAL
C***REVISION HISTORY  (YYMMDD)
C   780814  DATE WRITTEN
C   890831  Modified array declarations.  (WRB)
C   890831  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900326  Removed duplicate information from DESCRIPTION section.
C           (WRB)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  SGEFA
      INTEGER LDA,N,IPVT(*),INFO
      REAL A(LDA,*)
C
      REAL T
      INTEGER ISAMAX,J,K,KP1,L,NM1
C
C     GAUSSIAN ELIMINATION WITH PARTIAL PIVOTING
C
C***FIRST EXECUTABLE STATEMENT  SGEFA
      INFO = 0
      NM1 = N - 1
      IF (NM1 .LT. 1) GO TO 70
      DO 60 K = 1, NM1
         KP1 = K + 1
C
C        FIND L = PIVOT INDEX
C
         L = ISAMAX(N-K+1,A(K,K),1) + K - 1
         IPVT(K) = L
C
C        ZERO PIVOT IMPLIES THIS COLUMN ALREADY TRIANGULARIZED
C
         IF (A(L,K) .EQ. 0.0E0) GO TO 40
C
C           INTERCHANGE IF NECESSARY
C
            IF (L .EQ. K) GO TO 10
               T = A(L,K)
               A(L,K) = A(K,K)
               A(K,K) = T
   10       CONTINUE
C
C           COMPUTE MULTIPLIERS
C
            T = -1.0E0/A(K,K)
            CALL SSCAL(N-K,T,A(K+1,K),1)
C
C           ROW ELIMINATION WITH COLUMN INDEXING
C
            DO 30 J = KP1, N
               T = A(L,J)
               IF (L .EQ. K) GO TO 20
                  A(L,J) = A(K,J)
                  A(K,J) = T
   20          CONTINUE
               CALL SAXPY(N-K,T,A(K+1,K),1,A(K+1,J),1)
   30       CONTINUE
         GO TO 50
   40    CONTINUE
            INFO = K
   50    CONTINUE
   60 CONTINUE
   70 CONTINUE
      IPVT(N) = N
      IF (A(N,N) .EQ. 0.0E0) INFO = N
      RETURN
      END
*DECK SGEFS
      SUBROUTINE SGEFS (A, LDA, N, V, ITASK, IND, WORK, IWORK)
C***BEGIN PROLOGUE  SGEFS
C***PURPOSE  Solve a general system of linear equations.
C***LIBRARY   SLATEC
C***CATEGORY  D2A1
C***TYPE      SINGLE PRECISION (SGEFS-S, DGEFS-D, CGEFS-C)
C***KEYWORDS  COMPLEX LINEAR EQUATIONS, GENERAL MATRIX,
C             GENERAL SYSTEM OF LINEAR EQUATIONS
C***AUTHOR  Voorhees, E. A., (LANL)
C***DESCRIPTION
C
C    Subroutine SGEFS solves a general NxN system of single
C    precision linear equations using LINPACK subroutines SGECO
C    and SGESL.  That is, if A is an NxN real matrix and if X
C    and B are real N-vectors, then SGEFS solves the equation
C
C                          A*X=B.
C
C    The matrix A is first factored into upper and lower tri-
C    angular matrices U and L using partial pivoting.  These
C    factors and the pivoting information are used to find the
C    solution vector X.  An approximate condition number is
C    calculated to provide a rough estimate of the number of
C    digits of accuracy in the computed solution.
C
C    If the equation A*X=B is to be solved for more than one vector
C    B, the factoring of A does not need to be performed again and
C    the option to only solve (ITASK .GT. 1) will be faster for
C    the succeeding solutions.  In this case, the contents of A,
C    LDA, N and IWORK must not have been altered by the user follow-
C    ing factorization (ITASK=1).  IND will not be changed by SGEFS
C    in this case.
C
C  Argument Description ***
C
C    A      REAL(LDA,N)
C             on entry, the doubly subscripted array with dimension
C               (LDA,N) which contains the coefficient matrix.
C             on return, an upper triangular matrix U and the
C               multipliers necessary to construct a matrix L
C               so that A=L*U.
C    LDA    INTEGER
C             the leading dimension of the array A.  LDA must be great-
C             er than or equal to N.  (terminal error message IND=-1)
C    N      INTEGER
C             the order of the matrix A.  The first N elements of
C             the array A are the elements of the first column of
C             the  matrix A.  N must be greater than or equal to 1.
C             (terminal error message IND=-2)
C    V      REAL(N)
C             on entry, the singly subscripted array(vector) of di-
C               mension N which contains the right hand side B of a
C               system of simultaneous linear equations A*X=B.
C             on return, V contains the solution vector, X .
C    ITASK  INTEGER
C             If ITASK=1, the matrix A is factored and then the
C               linear equation is solved.
C             If ITASK .GT. 1, the equation is solved using the existing
C               factored matrix A and IWORK.
C             If ITASK .LT. 1, then terminal error message IND=-3 is
C               printed.
C    IND    INTEGER
C             GT. 0  IND is a rough estimate of the number of digits
C                     of accuracy in the solution, X.
C             LT. 0  see error message corresponding to IND below.
C    WORK   REAL(N)
C             a singly subscripted array of dimension at least N.
C    IWORK  INTEGER(N)
C             a singly subscripted array of dimension at least N.
C
C  Error Messages Printed ***
C
C    IND=-1  terminal   N is greater than LDA.
C    IND=-2  terminal   N is less than 1.
C    IND=-3  terminal   ITASK is less than 1.
C    IND=-4  terminal   The matrix A is computationally singular.
C                         A solution has not been computed.
C    IND=-10 warning    The solution has no apparent significance.
C                         The solution may be inaccurate or the matrix
C                         A may be poorly scaled.
C
C               Note-  The above terminal(*fatal*) error messages are
C                      designed to be handled by XERMSG in which
C                      LEVEL=1 (recoverable) and IFLAG=2 .  LEVEL=0
C                      for warning error messages from XERMSG.  Unless
C                      the user provides otherwise, an error message
C                      will be printed followed by an abort.
C
C***REFERENCES  J. J. Dongarra, J. R. Bunch, C. B. Moler, and G. W.
C                 Stewart, LINPACK Users' Guide, SIAM, 1979.
C***ROUTINES CALLED  R1MACH, SGECO, SGESL, XERMSG
C***REVISION HISTORY  (YYMMDD)
C   800317  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890831  Modified array declarations.  (WRB)
C   890831  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900315  CALLs to XERROR changed to CALLs to XERMSG.  (THJ)
C   900510  Convert XERRWV calls to XERMSG calls.  (RWC)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  SGEFS
C
      INTEGER LDA,N,ITASK,IND,IWORK(*)
      REAL A(LDA,*),V(*),WORK(*),R1MACH
      REAL RCOND
      CHARACTER*8 XERN1, XERN2
C***FIRST EXECUTABLE STATEMENT  SGEFS
      IF (LDA.LT.N) THEN
         IND = -1
         WRITE (XERN1, '(I8)') LDA
         WRITE (XERN2, '(I8)') N
         CALL XERMSG ('SLATEC', 'SGEFS', 'LDA = ' // XERN1 //
     *      ' IS LESS THAN N = ' // XERN2, -1, 1)
         RETURN
      ENDIF
C
      IF (N.LE.0) THEN
         IND = -2
         WRITE (XERN1, '(I8)') N
         CALL XERMSG ('SLATEC', 'SGEFS', 'N = ' // XERN1 //
     *      ' IS LESS THAN 1', -2, 1)
         RETURN
      ENDIF
C
      IF (ITASK.LT.1) THEN
         IND = -3
         WRITE (XERN1, '(I8)') ITASK
         CALL XERMSG ('SLATEC', 'SGEFS', 'ITASK = ' // XERN1 //
     *      ' IS LESS THAN 1', -3, 1)
         RETURN
      ENDIF
C
      IF (ITASK.EQ.1) THEN
C
C        FACTOR MATRIX A INTO LU
C
         CALL SGECO(A,LDA,N,IWORK,RCOND,WORK)
C
C        CHECK FOR COMPUTATIONALLY SINGULAR MATRIX
C
         IF (RCOND.EQ.0.0) THEN
            IND = -4
            CALL XERMSG ('SLATEC', 'SGEFS',
     *         'SINGULAR MATRIX A - NO SOLUTION', -4, 1)
            RETURN
         ENDIF
C
C        COMPUTE IND (ESTIMATE OF NO. OF SIGNIFICANT DIGITS)
C        AND CHECK FOR IND GREATER THAN ZERO
C
         IND = -LOG10(R1MACH(4)/RCOND)
         IF (IND.LE.0) THEN
            IND=-10
            CALL XERMSG ('SLATEC', 'SGEFS',
     *         'SOLUTION MAY HAVE NO SIGNIFICANCE', -10, 0)
         ENDIF
      ENDIF
C
C     SOLVE AFTER FACTORING
C
      CALL SGESL(A,LDA,N,IWORK,V,0)
      RETURN
      END
*DECK SGEIR
      SUBROUTINE SGEIR (A, LDA, N, V, ITASK, IND, WORK, IWORK)
C***BEGIN PROLOGUE  SGEIR
C***PURPOSE  Solve a general system of linear equations.  Iterative
C            refinement is used to obtain an error estimate.
C***LIBRARY   SLATEC
C***CATEGORY  D2A1
C***TYPE      SINGLE PRECISION (SGEIR-S, CGEIR-C)
C***KEYWORDS  COMPLEX LINEAR EQUATIONS, GENERAL MATRIX,
C             GENERAL SYSTEM OF LINEAR EQUATIONS
C***AUTHOR  Voorhees, E. A., (LANL)
C***DESCRIPTION
C
C    Subroutine SGEIR solves a general NxN system of single
C    precision linear equations using LINPACK subroutines SGEFA and
C    SGESL.  One pass of iterative refinement is used only to obtain
C    an estimate of the accuracy.  That is, if A is an NxN real
C    matrix and if X and B are real N-vectors, then SGEIR solves
C    the equation
C
C                          A*X=B.
C
C    The matrix A is first factored into upper and lower tri-
C    angular matrices U and L using partial pivoting.  These
C    factors and the pivoting information are used to calculate
C    the solution, X.  Then the residual vector is found and
C    used to calculate an estimate of the relative error, IND.
C    IND estimates the accuracy of the solution only when the
C    input matrix and the right hand side are represented
C    exactly in the computer and does not take into account
C    any errors in the input data.
C
C    If the equation A*X=B is to be solved for more than one vector
C    B, the factoring of A does not need to be performed again and
C    the option to solve only (ITASK .GT. 1) will be faster for
C    the succeeding solutions.  In this case, the contents of A,
C    LDA, N, WORK, and IWORK must not have been altered by the
C    user following factorization (ITASK=1).  IND will not be
C    changed by SGEIR in this case.
C
C  Argument Description ***
C
C    A      REAL(LDA,N)
C             the doubly subscripted array with dimension (LDA,N)
C             which contains the coefficient matrix.  A is not
C             altered by the routine.
C    LDA    INTEGER
C             the leading dimension of the array A.  LDA must be great-
C             er than or equal to N.  (terminal error message IND=-1)
C    N      INTEGER
C             the order of the matrix A.  The first N elements of
C             the array A are the elements of the first column of
C             matrix A.  N must be greater than or equal to 1.
C             (terminal error message IND=-2)
C    V      REAL(N)
C             on entry, the singly subscripted array(vector) of di-
C               mension N which contains the right hand side B of a
C               system of simultaneous linear equations A*X=B.
C             on return, V contains the solution vector, X .
C    ITASK  INTEGER
C             If ITASK=1, the matrix A is factored and then the
C               linear equation is solved.
C             If ITASK .GT. 1, the equation is solved using the existing
C               factored matrix A (stored in WORK).
C             If ITASK .LT. 1, then terminal error message IND=-3 is
C               printed.
C    IND    INTEGER
C             GT. 0  IND is a rough estimate of the number of digits
C                     of accuracy in the solution, X.  IND=75 means
C                     that the solution vector X is zero.
C             LT. 0  see error message corresponding to IND below.
C    WORK   REAL(N*(N+1))
C             a singly subscripted array of dimension at least N*(N+1).
C    IWORK  INTEGER(N)
C             a singly subscripted array of dimension at least N.
C
C  Error Messages Printed ***
C
C    IND=-1  terminal   N is greater than LDA.
C    IND=-2  terminal   N is less than one.
C    IND=-3  terminal   ITASK is less than one.
C    IND=-4  terminal   The matrix A is computationally singular.
C                         A solution has not been computed.
C    IND=-10 warning    The solution has no apparent significance.
C                         The solution may be inaccurate or the matrix
C                         A may be poorly scaled.
C
C               Note-  The above terminal(*fatal*) error messages are
C                      designed to be handled by XERMSG in which
C                      LEVEL=1 (recoverable) and IFLAG=2 .  LEVEL=0
C                      for warning error messages from XERMSG.  Unless
C                      the user provides otherwise, an error message
C                      will be printed followed by an abort.
C
C***REFERENCES  J. J. Dongarra, J. R. Bunch, C. B. Moler, and G. W.
C                 Stewart, LINPACK Users' Guide, SIAM, 1979.
C***ROUTINES CALLED  R1MACH, SASUM, SCOPY, SDSDOT, SGEFA, SGESL, XERMSG
C***REVISION HISTORY  (YYMMDD)
C   800430  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890831  Modified array declarations.  (WRB)
C   890831  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900315  CALLs to XERROR changed to CALLs to XERMSG.  (THJ)
C   900510  Convert XERRWV calls to XERMSG calls.  (RWC)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  SGEIR
C
      INTEGER LDA,N,ITASK,IND,IWORK(*),INFO,J
      REAL A(LDA,*),V(*),WORK(N,*),XNORM,DNORM,SDSDOT,SASUM,R1MACH
      CHARACTER*8 XERN1, XERN2
C***FIRST EXECUTABLE STATEMENT  SGEIR
      IF (LDA.LT.N) THEN
         IND = -1
         WRITE (XERN1, '(I8)') LDA
         WRITE (XERN2, '(I8)') N
         CALL XERMSG ('SLATEC', 'SGEIR', 'LDA = ' // XERN1 //
     *      ' IS LESS THAN N = ' // XERN2, -1, 1)
         RETURN
      ENDIF
C
      IF (N.LE.0) THEN
         IND = -2
         WRITE (XERN1, '(I8)') N
         CALL XERMSG ('SLATEC', 'SGEIR', 'N = ' // XERN1 //
     *      ' IS LESS THAN 1', -2, 1)
         RETURN
      ENDIF
C
      IF (ITASK.LT.1) THEN
         IND = -3
         WRITE (XERN1, '(I8)') ITASK
         CALL XERMSG ('SLATEC', 'SGEIR', 'ITASK = ' // XERN1 //
     *      ' IS LESS THAN 1', -3, 1)
         RETURN
      ENDIF
C
      IF (ITASK.EQ.1) THEN
C
C        MOVE MATRIX A TO WORK
C
         DO 10 J=1,N
            CALL SCOPY(N,A(1,J),1,WORK(1,J),1)
   10    CONTINUE
C
C        FACTOR MATRIX A INTO LU
C
         CALL SGEFA(WORK,N,N,IWORK,INFO)
C
C        CHECK FOR COMPUTATIONALLY SINGULAR MATRIX
C
         IF (INFO.NE.0) THEN
            IND = -4
            CALL XERMSG ('SLATEC', 'SGEIR',
     *         'SINGULAR MATRIX A - NO SOLUTION', -4, 1)
            RETURN
         ENDIF
      ENDIF
C
C     SOLVE WHEN FACTORING COMPLETE
C     MOVE VECTOR B TO WORK
C
      CALL SCOPY(N,V(1),1,WORK(1,N+1),1)
      CALL SGESL(WORK,N,N,IWORK,V,0)
C
C     FORM NORM OF X0
C
      XNORM=SASUM(N,V(1),1)
      IF (XNORM.NE.0.0) THEN
         IND = 75
         RETURN
      ENDIF
C
C     COMPUTE  RESIDUAL
C
      DO 40 J=1,N
         WORK(J,N+1) = SDSDOT(N,-WORK(J,N+1),A(J,1),LDA,V,1)
   40 CONTINUE
C
C     SOLVE A*DELTA=R
C
      CALL SGESL(WORK,N,N,IWORK,WORK(1,N+1),0)
C
C     FORM NORM OF DELTA
C
      DNORM = SASUM(N,WORK(1,N+1),1)
C
C     COMPUTE IND (ESTIMATE OF NO. OF SIGNIFICANT DIGITS)
C     AND CHECK FOR IND GREATER THAN ZERO
C
      IND = -LOG10(MAX(R1MACH(4),DNORM/XNORM))
      IF (IND.LE.0) THEN
         IND = -10
         CALL XERMSG ('SLATEC', 'SGEIR',
     *      'SOLUTION MAY HAVE NO SIGNIFICANCE', -10, 0)
      ENDIF
      RETURN
      END
*DECK SGESL
      SUBROUTINE SGESL (A, LDA, N, IPVT, B, JOB)
C***BEGIN PROLOGUE  SGESL
C***PURPOSE  Solve the real system A*X=B or TRANS(A)*X=B using the
C            factors of SGECO or SGEFA.
C***LIBRARY   SLATEC (LINPACK)
C***CATEGORY  D2A1
C***TYPE      SINGLE PRECISION (SGESL-S, DGESL-D, CGESL-C)
C***KEYWORDS  LINEAR ALGEBRA, LINPACK, MATRIX, SOLVE
C***AUTHOR  Moler, C. B., (U. of New Mexico)
C***DESCRIPTION
C
C     SGESL solves the real system
C     A * X = B  or  TRANS(A) * X = B
C     using the factors computed by SGECO or SGEFA.
C
C     On Entry
C
C        A       REAL(LDA, N)
C                the output from SGECO or SGEFA.
C
C        LDA     INTEGER
C                the leading dimension of the array  A .
C
C        N       INTEGER
C                the order of the matrix  A .
C
C        IPVT    INTEGER(N)
C                the pivot vector from SGECO or SGEFA.
C
C        B       REAL(N)
C                the right hand side vector.
C
C        JOB     INTEGER
C                = 0         to solve  A*X = B ,
C                = nonzero   to solve  TRANS(A)*X = B  where
C                            TRANS(A)  is the transpose.
C
C     On Return
C
C        B       the solution vector  X .
C
C     Error Condition
C
C        A division by zero will occur if the input factor contains a
C        zero on the diagonal.  Technically, this indicates singularity,
C        but it is often caused by improper arguments or improper
C        setting of LDA .  It will not occur if the subroutines are
C        called correctly and if SGECO has set RCOND .GT. 0.0
C        or SGEFA has set INFO .EQ. 0 .
C
C     To compute  INVERSE(A) * C  where  C  is a matrix
C     with  P  columns
C           CALL SGECO(A,LDA,N,IPVT,RCOND,Z)
C           IF (RCOND is too small) GO TO ...
C           DO 10 J = 1, P
C              CALL SGESL(A,LDA,N,IPVT,C(1,J),0)
C        10 CONTINUE
C
C***REFERENCES  J. J. Dongarra, J. R. Bunch, C. B. Moler, and G. W.
C                 Stewart, LINPACK Users' Guide, SIAM, 1979.
C***ROUTINES CALLED  SAXPY, SDOT
C***REVISION HISTORY  (YYMMDD)
C   780814  DATE WRITTEN
C   890831  Modified array declarations.  (WRB)
C   890831  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900326  Removed duplicate information from DESCRIPTION section.
C           (WRB)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  SGESL
      INTEGER LDA,N,IPVT(*),JOB
      REAL A(LDA,*),B(*)
C
      REAL SDOT,T
      INTEGER K,KB,L,NM1
C***FIRST EXECUTABLE STATEMENT  SGESL
      NM1 = N - 1
      IF (JOB .NE. 0) GO TO 50
C
C        JOB = 0 , SOLVE  A * X = B
C        FIRST SOLVE  L*Y = B
C
         IF (NM1 .LT. 1) GO TO 30
         DO 20 K = 1, NM1
            L = IPVT(K)
            T = B(L)
            IF (L .EQ. K) GO TO 10
               B(L) = B(K)
               B(K) = T
   10       CONTINUE
            CALL SAXPY(N-K,T,A(K+1,K),1,B(K+1),1)
   20    CONTINUE
   30    CONTINUE
C
C        NOW SOLVE  U*X = Y
C
         DO 40 KB = 1, N
            K = N + 1 - KB
            B(K) = B(K)/A(K,K)
            T = -B(K)
            CALL SAXPY(K-1,T,A(1,K),1,B(1),1)
   40    CONTINUE
      GO TO 100
   50 CONTINUE
C
C        JOB = NONZERO, SOLVE  TRANS(A) * X = B
C        FIRST SOLVE  TRANS(U)*Y = B
C
         DO 60 K = 1, N
            T = SDOT(K-1,A(1,K),1,B(1),1)
            B(K) = (B(K) - T)/A(K,K)
   60    CONTINUE
C
C        NOW SOLVE TRANS(L)*X = Y
C
         IF (NM1 .LT. 1) GO TO 90
         DO 80 KB = 1, NM1
            K = N - KB
            B(K) = B(K) + SDOT(N-K,A(K+1,K),1,B(K+1),1)
            L = IPVT(K)
            IF (L .EQ. K) GO TO 70
               T = B(L)
               B(L) = B(K)
               B(K) = T
   70       CONTINUE
   80    CONTINUE
   90    CONTINUE
  100 CONTINUE
      RETURN
      END
*DECK SGLSS
      SUBROUTINE SGLSS (A, MDA, M, N, B, MDB, NB, RNORM, WORK, LW,
     +   IWORK, LIW, INFO)
C***BEGIN PROLOGUE  SGLSS
C***PURPOSE  Solve a linear least squares problems by performing a QR
C            factorization of the matrix using Householder
C            transformations.  Emphasis is put on detecting possible
C            rank deficiency.
C***LIBRARY   SLATEC
C***CATEGORY  D9, D5
C***TYPE      SINGLE PRECISION (SGLSS-S, DGLSS-D)
C***KEYWORDS  LINEAR LEAST SQUARES, LQ FACTORIZATION, QR FACTORIZATION,
C             UNDERDETERMINED LINEAR SYSTEMS
C***AUTHOR  Manteuffel, T. A., (LANL)
C***DESCRIPTION
C
C     SGLSS solves both underdetermined and overdetermined
C     LINEAR systems AX = B, where A is an M by N matrix
C     and B is an M by NB matrix of right hand sides. If
C     M.GE.N, the least squares solution is computed by
C     decomposing the matrix A into the product of an
C     orthogonal matrix Q and an upper triangular matrix
C     R (QR factorization). If M.LT.N, the minimal
C     length solution is computed by factoring the
C     matrix A into the product of a lower triangular
C     matrix L and an orthogonal matrix Q (LQ factor-
C     ization). If the matrix A is determined to be rank
C     deficient, that is the rank of A is less than
C     MIN(M,N), then the minimal length least squares
C     solution is computed.
C
C     SGLSS assumes full machine precision in the data.
C     If more control over the uncertainty in the data
C     is desired, the codes LLSIA and ULSIA are
C     recommended.
C
C     SGLSS requires MDA*N + (MDB + 1)*NB + 5*MIN(M,N) dimensioned
C     real space and M+N dimensioned integer space.
C
C
C   ******************************************************************
C   *                                                                *
C   *         WARNING - All input arrays are changed on exit.        *
C   *                                                                *
C   ******************************************************************
C     SUBROUTINE SGLSS(A,MDA,M,N,B,MDB,NB,RNORM,WORK,LW,IWORK,LIW,INFO)
C
C     Input..
C
C     A(,)          Linear coefficient matrix of AX=B, with MDA the
C      MDA,M,N      actual first dimension of A in the calling program.
C                   M is the row dimension (no. of EQUATIONS of the
C                   problem) and N the col dimension (no. of UNKNOWNS).
C
C     B(,)          Right hand side(s), with MDB the actual first
C      MDB,NB       dimension of B in the calling program. NB is the
C                   number of M by 1 right hand sides. Must have
C                   MDB.GE.MAX(M,N). If NB = 0, B is never accessed.
C
C
C     RNORM()       Vector of length at least NB.  On input the contents
C                   of RNORM are unused.
C
C     WORK()        A real work array dimensioned 5*MIN(M,N).
C
C     LW            Actual dimension of WORK.
C
C     IWORK()       Integer work array dimensioned at least N+M.
C
C     LIW           Actual dimension of IWORK.
C
C
C     INFO          A flag which provides for the efficient
C                   solution of subsequent problems involving the
C                   same A but different B.
C                   If INFO = 0 original call
C                      INFO = 1 subsequent calls
C                   On subsequent calls, the user must supply A, INFO,
C                   LW, IWORK, LIW, and the first 2*MIN(M,N) locations
C                   of WORK as output by the original call to SGLSS.
C
C
C     Output..
C
C     A(,)          Contains the triangular part of the reduced matrix
C                   and the transformation information. It together with
C                   the first 2*MIN(M,N) elements of WORK (see below)
C                   completely specify the factorization of A.
C
C     B(,)          Contains the N by NB solution matrix X.
C
C
C     RNORM()       Contains the Euclidean length of the NB residual
C                   vectors  B(I)-AX(I), I=1,NB.
C
C     WORK()        The first 2*MIN(M,N) locations of WORK contain value
C                   necessary to reproduce the factorization of A.
C
C     IWORK()       The first M+N locations contain the order in
C                   which the rows and columns of A were used.
C                   If M.GE.N columns then rows. If M.LT.N rows
C                   then columns.
C
C     INFO          Flag to indicate status of computation on completion
C                  -1   Parameter error(s)
C                   0 - Full rank
C                   N.GT.0 - Reduced rank  rank=MIN(M,N)-INFO
C
C***REFERENCES  T. Manteuffel, An interval analysis approach to rank
C                 determination in linear least squares problems,
C                 Report SAND80-0655, Sandia Laboratories, June 1980.
C***ROUTINES CALLED  LLSIA, ULSIA
C***REVISION HISTORY  (YYMMDD)
C   810801  DATE WRITTEN
C   890831  Modified array declarations.  (WRB)
C   890831  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  SGLSS
      DIMENSION A(MDA,*),B(MDB,*),RNORM(*),WORK(*)
      INTEGER IWORK(*)
C
C***FIRST EXECUTABLE STATEMENT  SGLSS
      RE=0.
      AE=0.
      KEY=0
      MODE=2
      NP=0
C
C     IF M.GE.N CALL LLSIA
C     IF M.LT.N CALL ULSIA
C
      IF(M.LT.N) GO TO 10
      CALL LLSIA(A,MDA,M,N,B,MDB,NB,RE,AE,KEY,MODE,NP,
     1            KRANK,KSURE,RNORM,WORK,LW,IWORK,LIW,INFO)
      IF(INFO.EQ.-1) RETURN
      INFO=N-KRANK
      RETURN
   10 CALL ULSIA(A,MDA,M,N,B,MDB,NB,RE,AE,KEY,MODE,NP,
     1            KRANK,KSURE,RNORM,WORK,LW,IWORK,LIW,INFO)
      IF(INFO.EQ.-1) RETURN
      INFO=M-KRANK
      RETURN
      END
*DECK SGMRES
      SUBROUTINE SGMRES (N, B, X, NELT, IA, JA, A, ISYM, MATVEC, MSOLVE,
     +   ITOL, TOL, ITMAX, ITER, ERR, IERR, IUNIT, SB, SX, RGWK, LRGW,
     +   IGWK, LIGW, RWORK, IWORK)
C***BEGIN PROLOGUE  SGMRES
C***PURPOSE  Preconditioned GMRES Iterative Sparse Ax=b Solver.
C            This routine uses the generalized minimum residual
C            (GMRES) method with preconditioning to solve
C            non-symmetric linear systems of the form: Ax = b.
C***LIBRARY   SLATEC (SLAP)
C***CATEGORY  D2A4, D2B4
C***TYPE      SINGLE PRECISION (SGMRES-S, DGMRES-D)
C***KEYWORDS  GENERALIZED MINIMUM RESIDUAL, ITERATIVE PRECONDITION,
C             NON-SYMMETRIC LINEAR SYSTEM, SLAP, SPARSE
C***AUTHOR  Brown, Peter, (LLNL), pnbrown@llnl.gov
C           Hindmarsh, Alan, (LLNL), alanh@llnl.gov
C           Seager, Mark K., (LLNL), seager@llnl.gov
C             Lawrence Livermore National Laboratory
C             PO Box 808, L-60
C             Livermore, CA 94550 (510) 423-3141
C***DESCRIPTION
C
C *Usage:
C      INTEGER   N, NELT, IA(NELT), JA(NELT), ISYM, ITOL, ITMAX
C      INTEGER   ITER, IERR, IUNIT, LRGW, IGWK(LIGW), LIGW
C      INTEGER   IWORK(USER DEFINED)
C      REAL      B(N), X(N), A(NELT), TOL, ERR, SB(N), SX(N)
C      REAL      RGWK(LRGW), RWORK(USER DEFINED)
C      EXTERNAL  MATVEC, MSOLVE
C
C      CALL SGMRES(N, B, X, NELT, IA, JA, A, ISYM, MATVEC, MSOLVE,
C     $     ITOL, TOL, ITMAX, ITER, ERR, IERR, IUNIT, SB, SX,
C     $     RGWK, LRGW, IGWK, LIGW, RWORK, IWORK)
C
C *Arguments:
C N      :IN       Integer.
C         Order of the Matrix.
C B      :IN       Real B(N).
C         Right-hand side vector.
C X      :INOUT    Real X(N).
C         On input X is your initial guess for the solution vector.
C         On output X is the final approximate solution.
C NELT   :IN       Integer.
C         Number of Non-Zeros stored in A.
C IA     :IN       Integer IA(NELT).
C JA     :IN       Integer JA(NELT).
C A      :IN       Real A(NELT).
C         These arrays contain the matrix data structure for A.
C         It could take any form.  See "Description", below,
C         for more details.
C ISYM   :IN       Integer.
C         Flag to indicate symmetric storage format.
C         If ISYM=0, all non-zero entries of the matrix are stored.
C         If ISYM=1, the matrix is symmetric, and only the upper
C         or lower triangle of the matrix is stored.
C MATVEC :EXT      External.
C         Name of a routine which performs the matrix vector multiply
C         Y = A*X given A and X.  The name of the MATVEC routine must
C         be declared external in the calling program.  The calling
C         sequence to MATVEC is:
C             CALL MATVEC(N, X, Y, NELT, IA, JA, A, ISYM)
C         where N is the number of unknowns, Y is the product A*X
C         upon return, X is an input vector, and NELT is the number of
C         non-zeros in the SLAP IA, JA, A storage for the matrix A.
C         ISYM is a flag which, if non-zero, denotes that A is
C         symmetric and only the lower or upper triangle is stored.
C MSOLVE :EXT      External.
C         Name of the routine which solves a linear system Mz = r for
C         z given r with the preconditioning matrix M (M is supplied via
C         RWORK and IWORK arrays.  The name of the MSOLVE routine must
C         be declared external in the calling program.  The calling
C         sequence to MSOLVE is:
C             CALL MSOLVE(N, R, Z, NELT, IA, JA, A, ISYM, RWORK, IWORK)
C         Where N is the number of unknowns, R is the right-hand side
C         vector and Z is the solution upon return.  NELT, IA, JA, A and
C         ISYM are defined as above.  RWORK is a real array that can
C         be used to pass necessary preconditioning information and/or
C         workspace to MSOLVE.  IWORK is an integer work array for
C         the same purpose as RWORK.
C ITOL   :IN       Integer.
C         Flag to indicate the type of convergence criterion used.
C         ITOL=0  Means the  iteration stops when the test described
C                 below on  the  residual RL  is satisfied.  This is
C                 the  "Natural Stopping Criteria" for this routine.
C                 Other values  of   ITOL  cause  extra,   otherwise
C                 unnecessary, computation per iteration and     are
C                 therefore  much less  efficient.  See  ISSGMR (the
C                 stop test routine) for more information.
C         ITOL=1  Means   the  iteration stops   when the first test
C                 described below on  the residual RL  is satisfied,
C                 and there  is either right  or  no preconditioning
C                 being used.
C         ITOL=2  Implies     that   the  user    is   using    left
C                 preconditioning, and the second stopping criterion
C                 below is used.
C         ITOL=3  Means the  iteration stops   when  the  third test
C                 described below on Minv*Residual is satisfied, and
C                 there is either left  or no  preconditioning being
C                 used.
C         ITOL=11 is    often  useful  for   checking  and comparing
C                 different routines.  For this case, the  user must
C                 supply  the  "exact" solution or  a  very accurate
C                 approximation (one with  an  error much less  than
C                 TOL) through a common block,
C                     COMMON /SSLBLK/ SOLN( )
C                 If ITOL=11, iteration stops when the 2-norm of the
C                 difference between the iterative approximation and
C                 the user-supplied solution  divided by the  2-norm
C                 of the  user-supplied solution  is  less than TOL.
C                 Note that this requires  the  user to  set up  the
C                 "COMMON     /SSLBLK/ SOLN(LENGTH)"  in the calling
C                 routine.  The routine with this declaration should
C                 be loaded before the stop test so that the correct
C                 length is used by  the loader.  This procedure  is
C                 not standard Fortran and may not work correctly on
C                 your   system (although  it  has  worked  on every
C                 system the authors have tried).  If ITOL is not 11
C                 then this common block is indeed standard Fortran.
C TOL    :INOUT    Real.
C         Convergence criterion, as described below.  If TOL is set
C         to zero on input, then a default value of 500*(the smallest
C         positive magnitude, machine epsilon) is used.
C ITMAX  :DUMMY    Integer.
C         Maximum number of iterations in most SLAP routines.  In
C         this routine this does not make sense.  The maximum number
C         of iterations here is given by ITMAX = MAXL*(NRMAX+1).
C         See IGWK for definitions of MAXL and NRMAX.
C ITER   :OUT      Integer.
C         Number of iterations required to reach convergence, or
C         ITMAX if convergence criterion could not be achieved in
C         ITMAX iterations.
C ERR    :OUT      Real.
C         Error estimate of error in final approximate solution, as
C         defined by ITOL.  Letting norm() denote the Euclidean
C         norm, ERR is defined as follows..
C
C         If ITOL=0, then ERR = norm(SB*(B-A*X(L)))/norm(SB*B),
C                               for right or no preconditioning, and
C                         ERR = norm(SB*(M-inverse)*(B-A*X(L)))/
C                                norm(SB*(M-inverse)*B),
C                               for left preconditioning.
C         If ITOL=1, then ERR = norm(SB*(B-A*X(L)))/norm(SB*B),
C                               since right or no preconditioning
C                               being used.
C         If ITOL=2, then ERR = norm(SB*(M-inverse)*(B-A*X(L)))/
C                                norm(SB*(M-inverse)*B),
C                               since left preconditioning is being
C                               used.
C         If ITOL=3, then ERR =  Max  |(Minv*(B-A*X(L)))(i)/x(i)|
C                               i=1,n
C         If ITOL=11, then ERR = norm(SB*(X(L)-SOLN))/norm(SB*SOLN).
C IERR   :OUT      Integer.
C         Return error flag.
C               IERR = 0 => All went well.
C               IERR = 1 => Insufficient storage allocated for
C                           RGWK or IGWK.
C               IERR = 2 => Routine SGMRES failed to reduce the norm
C                           of the current residual on its last call,
C                           and so the iteration has stalled.  In
C                           this case, X equals the last computed
C                           approximation.  The user must either
C                           increase MAXL, or choose a different
C                           initial guess.
C               IERR =-1 => Insufficient length for RGWK array.
C                           IGWK(6) contains the required minimum
C                           length of the RGWK array.
C               IERR =-2 => Illegal value of ITOL, or ITOL and JPRE
C                           values are inconsistent.
C         For IERR <= 2, RGWK(1) = RHOL, which is the norm on the
C         left-hand-side of the relevant stopping test defined
C         below associated with the residual for the current
C         approximation X(L).
C IUNIT  :IN       Integer.
C         Unit number on which to write the error at each iteration,
C         if this is desired for monitoring convergence.  If unit
C         number is 0, no writing will occur.
C SB     :IN       Real SB(N).
C         Array of length N containing scale factors for the right
C         hand side vector B.  If JSCAL.eq.0 (see below), SB need
C         not be supplied.
C SX     :IN       Real SX(N).
C         Array of length N containing scale factors for the solution
C         vector X.  If JSCAL.eq.0 (see below), SX need not be
C         supplied.  SB and SX can be the same array in the calling
C         program if desired.
C RGWK   :INOUT    Real RGWK(LRGW).
C         Real array used for workspace by SGMRES.
C         On return, RGWK(1) = RHOL.  See IERR for definition of RHOL.
C LRGW   :IN       Integer.
C         Length of the real workspace, RGWK.
C         LRGW >= 1 + N*(MAXL+6) + MAXL*(MAXL+3).
C         See below for definition of MAXL.
C         For the default values, RGWK has size at least 131 + 16*N.
C IGWK   :INOUT    Integer IGWK(LIGW).
C         The following IGWK parameters should be set by the user
C         before calling this routine.
C         IGWK(1) = MAXL.  Maximum dimension of Krylov subspace in
C            which X - X0 is to be found (where, X0 is the initial
C            guess).  The default value of MAXL is 10.
C         IGWK(2) = KMP.  Maximum number of previous Krylov basis
C            vectors to which each new basis vector is made orthogonal.
C            The default value of KMP is MAXL.
C         IGWK(3) = JSCAL.  Flag indicating whether the scaling
C            arrays SB and SX are to be used.
C            JSCAL = 0 => SB and SX are not used and the algorithm
C               will perform as if all SB(I) = 1 and SX(I) = 1.
C            JSCAL = 1 =>  Only SX is used, and the algorithm
C               performs as if all SB(I) = 1.
C            JSCAL = 2 =>  Only SB is used, and the algorithm
C               performs as if all SX(I) = 1.
C            JSCAL = 3 =>  Both SB and SX are used.
C         IGWK(4) = JPRE.  Flag indicating whether preconditioning
C            is being used.
C            JPRE = 0  =>  There is no preconditioning.
C            JPRE > 0  =>  There is preconditioning on the right
C               only, and the solver will call routine MSOLVE.
C            JPRE < 0  =>  There is preconditioning on the left
C               only, and the solver will call routine MSOLVE.
C         IGWK(5) = NRMAX.  Maximum number of restarts of the
C            Krylov iteration.  The default value of NRMAX = 10.
C            if IWORK(5) = -1,  then no restarts are performed (in
C            this case, NRMAX is set to zero internally).
C         The following IWORK parameters are diagnostic information
C         made available to the user after this routine completes.
C         IGWK(6) = MLWK.  Required minimum length of RGWK array.
C         IGWK(7) = NMS.  The total number of calls to MSOLVE.
C LIGW   :IN       Integer.
C         Length of the integer workspace, IGWK.  LIGW >= 20.
C RWORK  :WORK     Real RWORK(USER DEFINED).
C         Real array that can be used for workspace in MSOLVE.
C IWORK  :WORK     Integer IWORK(USER DEFINED).
C         Integer array that can be used for workspace in MSOLVE.
C
C *Description:
C       SGMRES solves a linear system A*X = B rewritten in the form:
C
C        (SB*A*(M-inverse)*(SX-inverse))*(SX*M*X) = SB*B,
C
C       with right preconditioning, or
C
C        (SB*(M-inverse)*A*(SX-inverse))*(SX*X) = SB*(M-inverse)*B,
C
C       with left preconditioning, where A is an N-by-N real matrix,
C       X  and  B are N-vectors,   SB and SX   are  diagonal scaling
C       matrices,   and M is  a preconditioning    matrix.   It uses
C       preconditioned  Krylov   subpace  methods  based     on  the
C       generalized minimum residual  method (GMRES).   This routine
C       optionally performs  either  the  full     orthogonalization
C       version of the  GMRES  algorithm or an incomplete variant of
C       it.  Both versions use restarting of the linear iteration by
C       default, although the user can disable this feature.
C
C       The GMRES  algorithm generates a sequence  of approximations
C       X(L) to the  true solution of the above  linear system.  The
C       convergence criteria for stopping the  iteration is based on
C       the size  of the  scaled norm of  the residual  R(L)  =  B -
C       A*X(L).  The actual stopping test is either:
C
C               norm(SB*(B-A*X(L))) .le. TOL*norm(SB*B),
C
C       for right preconditioning, or
C
C               norm(SB*(M-inverse)*(B-A*X(L))) .le.
C                       TOL*norm(SB*(M-inverse)*B),
C
C       for left preconditioning, where norm() denotes the Euclidean
C       norm, and TOL is  a positive scalar less  than one  input by
C       the user.  If TOL equals zero  when SGMRES is called, then a
C       default  value  of 500*(the   smallest  positive  magnitude,
C       machine epsilon) is used.  If the  scaling arrays SB  and SX
C       are used, then  ideally they  should be chosen  so  that the
C       vectors SX*X(or SX*M*X) and  SB*B have all their  components
C       approximately equal  to  one in  magnitude.  If one wants to
C       use the same scaling in X  and B, then  SB and SX can be the
C       same array in the calling program.
C
C       The following is a list of the other routines and their
C       functions used by SGMRES:
C       SPIGMR  Contains the main iteration loop for GMRES.
C       SORTH   Orthogonalizes a new vector against older basis vectors.
C       SHEQR   Computes a QR decomposition of a Hessenberg matrix.
C       SHELS   Solves a Hessenberg least-squares system, using QR
C               factors.
C       SRLCAL  Computes the scaled residual RL.
C       SXLCAL  Computes the solution XL.
C       ISSGMR  User-replaceable stopping routine.
C
C       This routine does  not care  what matrix data   structure is
C       used for  A and M.  It simply   calls  the MATVEC and MSOLVE
C       routines, with  the arguments as  described above.  The user
C       could write any type of structure and the appropriate MATVEC
C       and MSOLVE routines.  It is assumed  that A is stored in the
C       IA, JA, A  arrays in some fashion and  that M (or INV(M)) is
C       stored  in  IWORK  and  RWORK   in  some fashion.   The SLAP
C       routines SSDCG and SSICCG are examples of this procedure.
C
C       Two  examples  of  matrix  data structures  are the: 1) SLAP
C       Triad  format and 2) SLAP Column format.
C
C       =================== S L A P Triad format ===================
C       This routine requires that the  matrix A be   stored in  the
C       SLAP  Triad format.  In  this format only the non-zeros  are
C       stored.  They may appear in  *ANY* order.  The user supplies
C       three arrays of  length NELT, where  NELT is  the number  of
C       non-zeros in the matrix: (IA(NELT), JA(NELT), A(NELT)).  For
C       each non-zero the user puts the row and column index of that
C       matrix element  in the IA and  JA arrays.  The  value of the
C       non-zero   matrix  element is  placed  in  the corresponding
C       location of the A array.   This is  an  extremely  easy data
C       structure to generate.  On  the  other hand it   is  not too
C       efficient on vector computers for  the iterative solution of
C       linear systems.  Hence,   SLAP changes   this  input    data
C       structure to the SLAP Column format  for  the iteration (but
C       does not change it back).
C
C       Here is an example of the  SLAP Triad   storage format for a
C       5x5 Matrix.  Recall that the entries may appear in any order.
C
C           5x5 Matrix      SLAP Triad format for 5x5 matrix on left.
C                              1  2  3  4  5  6  7  8  9 10 11
C       |11 12  0  0 15|   A: 51 12 11 33 15 53 55 22 35 44 21
C       |21 22  0  0  0|  IA:  5  1  1  3  1  5  5  2  3  4  2
C       | 0  0 33  0 35|  JA:  1  2  1  3  5  3  5  2  5  4  1
C       | 0  0  0 44  0|
C       |51  0 53  0 55|
C
C       =================== S L A P Column format ==================
C
C       This routine  requires that  the matrix A  be stored in  the
C       SLAP Column format.  In this format the non-zeros are stored
C       counting down columns (except for  the diagonal entry, which
C       must appear first in each  "column")  and are stored  in the
C       real array A.  In other words, for each column in the matrix
C       put the diagonal entry in A.  Then put in the other non-zero
C       elements going down   the  column (except  the diagonal)  in
C       order.  The IA array holds the row  index for each non-zero.
C       The JA array holds the offsets into the IA, A arrays for the
C       beginning of   each    column.    That  is,    IA(JA(ICOL)),
C       A(JA(ICOL)) points to the beginning of the ICOL-th column in
C       IA and  A.  IA(JA(ICOL+1)-1),  A(JA(ICOL+1)-1) points to the
C       end  of   the ICOL-th  column.  Note   that  we  always have
C       JA(N+1) = NELT+1, where  N  is the number of columns in  the
C       matrix and  NELT   is the number of non-zeros in the matrix.
C
C       Here is an example of the  SLAP Column  storage format for a
C       5x5 Matrix (in the A and IA arrays '|'  denotes the end of a
C       column):
C
C           5x5 Matrix      SLAP Column format for 5x5 matrix on left.
C                              1  2  3    4  5    6  7    8    9 10 11
C       |11 12  0  0 15|   A: 11 21 51 | 22 12 | 33 53 | 44 | 55 15 35
C       |21 22  0  0  0|  IA:  1  2  5 |  2  1 |  3  5 |  4 |  5  1  3
C       | 0  0 33  0 35|  JA:  1  4  6    8  9   12
C       | 0  0  0 44  0|
C       |51  0 53  0 55|
C
C *Cautions:
C     This routine will attempt to write to the Fortran logical output
C     unit IUNIT, if IUNIT .ne. 0.  Thus, the user must make sure that
C     this logical unit is attached to a file or terminal before calling
C     this routine with a non-zero value for IUNIT.  This routine does
C     not check for the validity of a non-zero IUNIT unit number.
C
C***REFERENCES  1. Peter N. Brown and A. C. Hindmarsh, Reduced Storage
C                  Matrix Methods in Stiff ODE Systems, Lawrence Liver-
C                  more National Laboratory Report UCRL-95088, Rev. 1,
C                  Livermore, California, June 1987.
C               2. Mark K. Seager, A SLAP for the Masses, in
C                  G. F. Carey, Ed., Parallel Supercomputing: Methods,
C                  Algorithms and Applications, Wiley, 1989, pp.135-155.
C***ROUTINES CALLED  R1MACH, SCOPY, SNRM2, SPIGMR
C***REVISION HISTORY  (YYMMDD)
C   871001  DATE WRITTEN
C   881213  Previous REVISION DATE
C   890915  Made changes requested at July 1989 CML Meeting.  (MKS)
C   890922  Numerous changes to prologue to make closer to SLATEC
C           standard.  (FNF)
C   890929  Numerous changes to reduce SP/DP differences.  (FNF)
C   891004  Added new reference.
C   910411  Prologue converted to Version 4.0 format.  (BAB)
C   910506  Corrected errors in C***ROUTINES CALLED list.  (FNF)
C   920407  COMMON BLOCK renamed SSLBLK.  (WRB)
C   920511  Added complete declaration section.  (WRB)
C   920929  Corrected format of references.  (FNF)
C   921019  Changed 500.0 to 500 to reduce SP/DP differences.  (FNF)
C   921026  Added check for valid value of ITOL.  (FNF)
C***END PROLOGUE  SGMRES
C         The following is for optimized compilation on LLNL/LTSS Crays.
CLLL. OPTIMIZE
C     .. Scalar Arguments ..
      REAL ERR, TOL
      INTEGER IERR, ISYM, ITER, ITMAX, ITOL, IUNIT, LIGW, LRGW, N, NELT
C     .. Array Arguments ..
      REAL A(NELT), B(N), RGWK(LRGW), RWORK(*), SB(N), SX(N), X(N)
      INTEGER IA(NELT), IGWK(LIGW), IWORK(*), JA(NELT)
C     .. Subroutine Arguments ..
      EXTERNAL MATVEC, MSOLVE
C     .. Local Scalars ..
      REAL BNRM, RHOL, SUM
      INTEGER I, IFLAG, JPRE, JSCAL, KMP, LDL, LGMR, LHES, LQ, LR, LV,
     +        LW, LXL, LZ, LZM1, MAXL, MAXLP1, NMS, NMSL, NRMAX, NRSTS
C     .. External Functions ..
      REAL R1MACH, SNRM2
      EXTERNAL R1MACH, SNRM2
C     .. External Subroutines ..
      EXTERNAL SCOPY, SPIGMR
C     .. Intrinsic Functions ..
      INTRINSIC SQRT
C***FIRST EXECUTABLE STATEMENT  SGMRES
      IERR = 0
C   ------------------------------------------------------------------
C         Load method parameters with user values or defaults.
C   ------------------------------------------------------------------
      MAXL = IGWK(1)
      IF (MAXL .EQ. 0) MAXL = 10
      IF (MAXL .GT. N) MAXL = N
      KMP = IGWK(2)
      IF (KMP .EQ. 0) KMP = MAXL
      IF (KMP .GT. MAXL) KMP = MAXL
      JSCAL = IGWK(3)
      JPRE = IGWK(4)
C         Check for valid value of ITOL.
      IF( (ITOL.LT.0) .OR. ((ITOL.GT.3).AND.(ITOL.NE.11)) ) GOTO 650
C         Check for consistent values of ITOL and JPRE.
      IF( ITOL.EQ.1 .AND. JPRE.LT.0 ) GOTO 650
      IF( ITOL.EQ.2 .AND. JPRE.GE.0 ) GOTO 650
      NRMAX = IGWK(5)
      IF( NRMAX.EQ.0 ) NRMAX = 10
C         If NRMAX .eq. -1, then set NRMAX = 0 to turn off restarting.
      IF( NRMAX.EQ.-1 ) NRMAX = 0
C         If input value of TOL is zero, set it to its default value.
      IF( TOL.EQ.0.0E0 ) TOL = 500*R1MACH(3)
C
C         Initialize counters.
      ITER = 0
      NMS = 0
      NRSTS = 0
C   ------------------------------------------------------------------
C         Form work array segment pointers.
C   ------------------------------------------------------------------
      MAXLP1 = MAXL + 1
      LV = 1
      LR = LV + N*MAXLP1
      LHES = LR + N + 1
      LQ = LHES + MAXL*MAXLP1
      LDL = LQ + 2*MAXL
      LW = LDL + N
      LXL = LW + N
      LZ = LXL + N
C
C         Load IGWK(6) with required minimum length of the RGWK array.
      IGWK(6) = LZ + N - 1
      IF( LZ+N-1.GT.LRGW ) GOTO 640
C   ------------------------------------------------------------------
C         Calculate scaled-preconditioned norm of RHS vector b.
C   ------------------------------------------------------------------
      IF (JPRE .LT. 0) THEN
         CALL MSOLVE(N, B, RGWK(LR), NELT, IA, JA, A, ISYM,
     $        RWORK, IWORK)
         NMS = NMS + 1
      ELSE
         CALL SCOPY(N, B, 1, RGWK(LR), 1)
      ENDIF
      IF( JSCAL.EQ.2 .OR. JSCAL.EQ.3 ) THEN
         SUM = 0
         DO 10 I = 1,N
            SUM = SUM + (RGWK(LR-1+I)*SB(I))**2
 10      CONTINUE
         BNRM = SQRT(SUM)
      ELSE
         BNRM = SNRM2(N,RGWK(LR),1)
      ENDIF
C   ------------------------------------------------------------------
C         Calculate initial residual.
C   ------------------------------------------------------------------
      CALL MATVEC(N, X, RGWK(LR), NELT, IA, JA, A, ISYM)
      DO 50 I = 1,N
         RGWK(LR-1+I) = B(I) - RGWK(LR-1+I)
 50   CONTINUE
C   ------------------------------------------------------------------
C         If performing restarting, then load the residual into the
C         correct location in the RGWK array.
C   ------------------------------------------------------------------
 100  CONTINUE
      IF( NRSTS.GT.NRMAX ) GOTO 610
      IF( NRSTS.GT.0 ) THEN
C         Copy the current residual to a different location in the RGWK
C         array.
         CALL SCOPY(N, RGWK(LDL), 1, RGWK(LR), 1)
      ENDIF
C   ------------------------------------------------------------------
C         Use the SPIGMR algorithm to solve the linear system A*Z = R.
C   ------------------------------------------------------------------
      CALL SPIGMR(N, RGWK(LR), SB, SX, JSCAL, MAXL, MAXLP1, KMP,
     $       NRSTS, JPRE, MATVEC, MSOLVE, NMSL, RGWK(LZ), RGWK(LV),
     $       RGWK(LHES), RGWK(LQ), LGMR, RWORK, IWORK, RGWK(LW),
     $       RGWK(LDL), RHOL, NRMAX, B, BNRM, X, RGWK(LXL), ITOL,
     $       TOL, NELT, IA, JA, A, ISYM, IUNIT, IFLAG, ERR)
      ITER = ITER + LGMR
      NMS = NMS + NMSL
C
C         Increment X by the current approximate solution Z of A*Z = R.
C
      LZM1 = LZ - 1
      DO 110 I = 1,N
         X(I) = X(I) + RGWK(LZM1+I)
 110  CONTINUE
      IF( IFLAG.EQ.0 ) GOTO 600
      IF( IFLAG.EQ.1 ) THEN
         NRSTS = NRSTS + 1
         GOTO 100
      ENDIF
      IF( IFLAG.EQ.2 ) GOTO 620
C   ------------------------------------------------------------------
C         All returns are made through this section.
C   ------------------------------------------------------------------
C         The iteration has converged.
C
 600  CONTINUE
      IGWK(7) = NMS
      RGWK(1) = RHOL
      IERR = 0
      RETURN
C
C         Max number((NRMAX+1)*MAXL) of linear iterations performed.
 610  CONTINUE
      IGWK(7) = NMS
      RGWK(1) = RHOL
      IERR = 1
      RETURN
C
C         GMRES failed to reduce last residual in MAXL iterations.
C         The iteration has stalled.
 620  CONTINUE
      IGWK(7) = NMS
      RGWK(1) = RHOL
      IERR = 2
      RETURN
C         Error return.  Insufficient length for RGWK array.
 640  CONTINUE
      ERR = TOL
      IERR = -1
      RETURN
C         Error return.  Inconsistent ITOL and JPRE values.
 650  CONTINUE
      ERR = TOL
      IERR = -2
      RETURN
C------------- LAST LINE OF SGMRES FOLLOWS ----------------------------
      END
*DECK SGTSL
      SUBROUTINE SGTSL (N, C, D, E, B, INFO)
C***BEGIN PROLOGUE  SGTSL
C***PURPOSE  Solve a tridiagonal linear system.
C***LIBRARY   SLATEC (LINPACK)
C***CATEGORY  D2A2A
C***TYPE      SINGLE PRECISION (SGTSL-S, DGTSL-D, CGTSL-C)
C***KEYWORDS  LINEAR ALGEBRA, LINPACK, MATRIX, SOLVE, TRIDIAGONAL
C***AUTHOR  Dongarra, J., (ANL)
C***DESCRIPTION
C
C     SGTSL given a general tridiagonal matrix and a right hand
C     side will find the solution.
C
C     On Entry
C
C        N       INTEGER
C                is the order of the tridiagonal matrix.
C
C        C       REAL(N)
C                is the subdiagonal of the tridiagonal matrix.
C                C(2) through C(N) should contain the subdiagonal.
C                On output, C is destroyed.
C
C        D       REAL(N)
C                is the diagonal of the tridiagonal matrix.
C                On output, D is destroyed.
C
C        E       REAL(N)
C                is the superdiagonal of the tridiagonal matrix.
C                E(1) through E(N-1) should contain the superdiagonal.
C                On output, E is destroyed.
C
C        B       REAL(N)
C                is the right hand side vector.
C
C     On Return
C
C        B       is the solution vector.
C
C        INFO    INTEGER
C                = 0 normal value.
C                = K if the K-th element of the diagonal becomes
C                    exactly zero.  The subroutine returns when
C                    this is detected.
C
C***REFERENCES  J. J. Dongarra, J. R. Bunch, C. B. Moler, and G. W.
C                 Stewart, LINPACK Users' Guide, SIAM, 1979.
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   780814  DATE WRITTEN
C   890831  Modified array declarations.  (WRB)
C   890831  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900326  Removed duplicate information from DESCRIPTION section.
C           (WRB)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  SGTSL
      INTEGER N,INFO
      REAL C(*),D(*),E(*),B(*)
C
      INTEGER K,KB,KP1,NM1,NM2
      REAL T
C***FIRST EXECUTABLE STATEMENT  SGTSL
         INFO = 0
         C(1) = D(1)
         NM1 = N - 1
         IF (NM1 .LT. 1) GO TO 40
            D(1) = E(1)
            E(1) = 0.0E0
            E(N) = 0.0E0
C
            DO 30 K = 1, NM1
               KP1 = K + 1
C
C              FIND THE LARGEST OF THE TWO ROWS
C
               IF (ABS(C(KP1)) .LT. ABS(C(K))) GO TO 10
C
C                 INTERCHANGE ROW
C
                  T = C(KP1)
                  C(KP1) = C(K)
                  C(K) = T
                  T = D(KP1)
                  D(KP1) = D(K)
                  D(K) = T
                  T = E(KP1)
                  E(KP1) = E(K)
                  E(K) = T
                  T = B(KP1)
                  B(KP1) = B(K)
                  B(K) = T
   10          CONTINUE
C
C              ZERO ELEMENTS
C
               IF (C(K) .NE. 0.0E0) GO TO 20
                  INFO = K
                  GO TO 100
   20          CONTINUE
               T = -C(KP1)/C(K)
               C(KP1) = D(KP1) + T*D(K)
               D(KP1) = E(KP1) + T*E(K)
               E(KP1) = 0.0E0
               B(KP1) = B(KP1) + T*B(K)
   30       CONTINUE
   40    CONTINUE
         IF (C(N) .NE. 0.0E0) GO TO 50
            INFO = N
         GO TO 90
   50    CONTINUE
C
C           BACK SOLVE
C
            NM2 = N - 2
            B(N) = B(N)/C(N)
            IF (N .EQ. 1) GO TO 80
               B(NM1) = (B(NM1) - D(NM1)*B(N))/C(NM1)
               IF (NM2 .LT. 1) GO TO 70
               DO 60 KB = 1, NM2
                  K = NM2 - KB + 1
                  B(K) = (B(K) - D(K)*B(K+1) - E(K)*B(K+2))/C(K)
   60          CONTINUE
   70          CONTINUE
   80       CONTINUE
   90    CONTINUE
  100 CONTINUE
C
      RETURN
      END

subroutine gtx_truncate(output,ax,ay)
  use gtv_protocol
  !---------------------------------------------------------------------
  ! @ private
  !  Forces AX and AY within the clipping area
  !---------------------------------------------------------------------
  type(gt_display), intent(in)    :: output  ! 'gt_display' instance
  real,             intent(inout) :: ax,ay   !
  !
  ax = max(ax,output%gx1)
  ax = min(ax,output%gx2)
  ay = max(ay,output%gy1)
  ay = min(ay,output%gy2)
  !
end subroutine gtx_truncate
!
subroutine gtg_screen(qx1,qx2,qy1,qy2)
  use gtv_interfaces, except_this=>gtg_screen
  use gtv_protocol
  !---------------------------------------------------------------------
  ! @ public
  !  Returns the coordinates of the end pixels of the physical screen
  ! (world units). Very useful for interactive zooming. Works on the
  ! Current Working Output.
  !---------------------------------------------------------------------
  real, intent(out) :: qx1,qx2  !
  real, intent(out) :: qy1,qy2  !
  !
  call gtg_screen_sub(cw_output,qx1,qx2,qy1,qy2)
  !
end subroutine gtg_screen
!
subroutine gtg_screen_sub(output,qx1,qx2,qy1,qy2)
  use gtv_graphic
  use gtv_interfaces, except_this=>gtg_screen_sub
  use gtv_protocol
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !  Returns the coordinates of the end pixels of the physical screen
  ! (world units). Very useful for interactive zooming. Works on the
  ! input instance
  !---------------------------------------------------------------------
  type(gt_display), intent(in)  :: output   ! 'gt_display' instance
  real,             intent(out) :: qx1,qx2  !
  real,             intent(out) :: qy1,qy2  !
  ! Local
  character(len=*), parameter :: rname='GTG_SCREEN'
  !
  if (.not.awake .or. output%dev%protocol.eq.p_null) then
    call gtv_message(seve%e,rname,'No output device')
    call gtx_err
    qx1 = 0.
    qx2 = 0.
    qy1 = 0.
    qy2 = 0.
    return
  endif
  !
  if (error_condition) then
    call gtv_message(seve%e,rname,'Library in error condition')
    call gtx_err
    qx1 = 0.
    qx2 = 0.
    qy1 = 0.
    qy2 = 0.
    return
  endif
  !
  call pixel_to_world(output,output%px1,output%py1,qx1,qy1)
  call pixel_to_world(output,output%px2,output%py2,qx2,qy2)
  !
end subroutine gtg_screen_sub
!
function gtg_curs()
  use gtv_interfaces, except_this=>gtg_curs
  use gtv_protocol
  !---------------------------------------------------------------------
  ! @ public
  !   Informs if a cursor is available on the current device
  !---------------------------------------------------------------------
  logical :: gtg_curs  ! Function value on return
  !
  gtg_curs = gtg_curs_sub(cw_device)
  !
end function gtg_curs
!
function gtg_curs_sub(dev)
  use gtv_types
  use gtv_graphic
  !---------------------------------------------------------------------
  ! @ private
  !   Informs if a cursor is available on the input device
  !---------------------------------------------------------------------
  logical         :: gtg_curs_sub  ! Function value on return
  type(gt_device) :: dev           ! Device
  !
  if (awake .and. .not.error_condition) then
    gtg_curs_sub = dev%hardw_cursor
  else
    gtg_curs_sub = .false.
  endif
end function gtg_curs_sub
!
subroutine gtcurs(xcm,ycm,ch,error)
  use gbl_message
  use gtv_buffers
  use gtv_interfaces, except_this=>gtcurs
  use gtv_protocol
  !---------------------------------------------------------------------
  ! @ public
  ! Same as gtcurs_sub but works on the Current Working Output
  !---------------------------------------------------------------------
  real,             intent(inout) :: xcm,ycm  !
  character(len=*), intent(out)   :: ch       !
  logical,          intent(inout) :: error    !
  ! Local
  character(len=*), parameter :: rname='GTCURS'
  type(gt_display), pointer :: out
  type(gt_directory), pointer :: dir
  !
  if (cw_device%protocol.eq.p_x) then
    if (cw_directory%x%nbwin.eq.0) then
      ! Current working directory has no window, let see in the
      ! ancestor...
      dir => cw_directory%ancestor
      ! call cree_chemin_dir(dir_zoom,gpname,nd)
      ! call gtv_message(seve%i,rname,'Call cursor in directory '//gpname)
      if (dir%x%nbwin.eq.0) then
        call gtv_message(seve%e,rname,'No window found')
        error = .true.
        return
      endif
      ! Call cursor in first window of grand-pere
      call get_slot_output_by_num(dir,0,out,error)
      if (error)  return
    else
      ! Call cursor in current working window
      out => cw_output
    endif
  else
    out => cw_output
  endif
  !
  call gtcurs_sub(out,xcm,ycm,ch)
  !
end subroutine gtcurs
!
subroutine gicurs(xcm,ycm,rect_xw_cm,rect_yw_cm,ch,error)
  use gbl_message
  use gtv_buffers
  use gtv_interfaces, except_this=>gicurs
  use gtv_protocol
  !---------------------------------------------------------------------
  ! @ public
  ! Same as gicurs_sub but works on the Current Working Output
  !---------------------------------------------------------------------
  real(kind=4),     intent(inout) :: xcm,ycm                !
  real(kind=4),     intent(in)    :: rect_xw_cm,rect_yw_cm  !
  character(len=*), intent(out)   :: ch                     !
  logical,          intent(inout) :: error                  !
  ! Local
  character(len=*), parameter :: rname='GICURS'
  type(gt_display), pointer :: out
  type(gt_directory), pointer :: dir
  !
  if (cw_device%protocol.eq.p_x) then
    if (cw_directory%x%nbwin.eq.0) then
      ! Current working directory has no window, let see in the
      ! ancestor...
      dir => cw_directory%ancestor
      ! call cree_chemin_dir(dir_zoom,gpname,nd)
      ! call gtv_message(seve%i,rname,'Call cursor in directory '//gpname)
      if (dir%x%nbwin.eq.0) then
        call gtv_message(seve%e,rname,'No window found')
        error = .true.
        return
      endif
      ! Call cursor in first window of grand-pere
      call get_slot_output_by_num(dir,0,out,error)
      if (error)  return
    else
      ! Call cursor in current working window
      out => cw_output
    endif
  else
    out => cw_output
  endif
  !
  call gicurs_sub(out,xcm,ycm,rect_xw_cm,rect_yw_cm,ch)
  !
end subroutine gicurs
!
subroutine gtcurs_sub(output,xcm,ycm,ch)
  use gtv_graphic
  use gtv_interfaces, except_this=>gtcurs_sub
  use gtv_protocol
  use gtv_types
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !	Activates the cursor. CH contains the character struck
  !	and XCM YCM are the adresses of the cursor position, in
  !	plot units with respect to the current origin.
  !	Preset the cursor position at XCM YCM if possible
  !
  !	Does not modify the virtuel pen position and the immediate
  !	pen position.
  !---------------------------------------------------------------------
  type(gt_display), intent(in)    :: output   ! Output instance
  real,             intent(inout) :: xcm,ycm  !
  character(len=*), intent(out)   :: ch       !
  ! Local
  character(len=*), parameter :: rname='GTCURS'
  character(len=1) :: cc               ! For X_CURS
  integer :: rect_xw,rect_yw,ix,iy,fzoom
  real*4 :: rect_xw_cm,rect_yw_cm
  !
  ! "Pick up a value" mode. Draw a cross only for selecting a position.
  ! No rectangle size defined since it will be ignored in this mode.
  fzoom = 0
  goto 10
  !
entry gicurs_sub(output,xcm,ycm,rect_xw_cm,rect_yw_cm,ch)
  ! Zoom mode. Draw cross + rectangle for zooming. Define the size (in
  ! world units) of the rectangle which defines the zooming area.
  fzoom = 1
  !
10 continue
  !
  if (.not.awake) then
    call gtv_message(seve%e,rname,'Library sleeping')
    call gtx_err
    return
  endif
  if (error_condition) then
    call gtv_message(seve%e,rname,'Library in error condition')
    call gtx_err
    return
  endif
  !
  ! Same problem for device without cursor hardware
  if (.not.output%dev%hardw_cursor) then
    call gtv_message(seve%e,rname,'No cursor available on current device')
    call gtx_err
    return
    !
  elseif (output%dev%protocol.eq.p_x) then
    if (output%x%graph_env.eq.0) then
      call gtv_message(seve%e,rname,  &
        'No active window in current working GTV directory')
      call gtx_err
      return
    endif
    !
    ! Not quite portable...
    cc = ' '
    if (fzoom.eq.1) then
      call world_to_pixel_size(output,rect_xw_cm,rect_yw_cm,rect_xw,rect_yw)
    else
      rect_xw = 0
      rect_yw = 0
    endif
    call x_curs(output%x%graph_env,fzoom,rect_xw,rect_yw,ix,iy,cc)
    ch = cc
    !
    call pixel_to_world(output,ix,iy,xcm,ycm)
    return
    !
  else
    ! Could become available for Display Postscript
    call gtv_message(seve%e,rname,'No cursor available on current device')
    call gtx_err
    return
  endif
  !
end subroutine gtcurs_sub

program sortint
  use gildas_def
  use image_def
  use gkernel_interfaces
  !---------------------------------------------------------------------
  ! GILDAS	Stand alone program
  !	Sort a table according to a given column
  !	This version considers the data in the sorting column as I*4
  !---------------------------------------------------------------------
  ! Local
  integer :: i,scol,ier
  logical :: error
  character(len=filename_length) :: name
  type(gildas) :: x
  integer, allocatable :: it(:),iw(:),ix(:)
  integer(kind=4) :: n
  !
  call gildas_open
  call gildas_char('TABLE$',name)
  call gildas_inte('COLUMN$',scol,1)
  call gildas_close
  !
  call gildas_null(x, type = 'TABLE')
  x%gil%form = fmt_i4
  call gdf_read_gildas(x, name, '.tab', error, data=.false.)
  if (error) then 
    write(6,*) 'E-SORT,  Error reading table'
    goto 100
  endif
  if (scol.lt.1 .or. scol.gt.x%gil%dim(2)) then
    write(6,*) 'E-SORT,  Sorting column does not exist'
    goto 100
  endif
  !
  allocate (ix(x%gil%dim(1)),it(x%gil%dim(1)),iw(x%gil%dim(1)), stat=ier)
  if (ier.ne.0) goto 98 
  x%blc(2) = scol
  x%trc(2) = scol
  call gdf_read_data(x, ix, error)
  n = x%gil%dim(1)
  call gi4_trie(ix,it,n,error)
  if (error) then
    call gagout ('F-SORT,  Table not sorted')
    call sysexi (fatale)
  endif
  call gdf_write_data(x, x%r1d, error)
  do i=1,x%gil%dim(2)
    if (i.ne.scol) then
      x%blc(2) = i
      x%trc(2) = i
      call gdf_read_data(x, ix, error)
      call gi4_sort(ix,iw,it,n)
      call gdf_write_data(x, ix, error)
    endif
  enddo
  call gdf_close_image (x,error)
  call gagout ('S-SORT,  Successfull completion')
  call sysexi (1)
  goto 100
98 call gagout ('E-SORT,  Memory allocation failure on work space')
100 call sysexi(fatale)
end program sortint

subroutine sicsort(line,error)
  use gildas_def
  use gbl_format
  use gbl_message
  use sic_dependencies_interfaces, no_interface1=>gr4_trie_i4,  &
                                   no_interface2=>gr8_trie_i4,  &
                                   no_interface3=>gi4_trie_i4,  &
                                   no_interface4=>gi8_trie_i4,  &
                                   no_interface5=>gch_trie_i4,  &
                                   no_interface6=>gi4_sort,  &
                                   no_interface7=>gi8_sort,  &
                                   no_interface8=>gch_sort
  use sic_interfaces, except_this=>sicsort
  use sic_types
  !---------------------------------------------------------------------
  ! @ private
  ! SIC Support routine for command
  !  SORT KeyVar Var1 Var2 ... VarN
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line   ! Command line
  logical,          intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='SORT'
  character(len=varname_length) :: var
  integer(kind=address_length) :: ipkey,ipvar
  type(sic_descriptor_t) :: desc
  integer :: vtype
  integer(kind=4), allocatable :: iwork(:)
  real(kind=4), allocatable :: swork(:)
  real(kind=8), allocatable :: dwork(:)
  integer(kind=1), allocatable :: cwork(:)  ! Support for character arrays
  !
  integer :: nc,ier,i,nsort
  integer(kind=index_length) :: nxy,nplane,j
  integer(kind=4) :: memory(1)
  integer(kind=1) :: membyt(1)
  logical :: found
  !
  call sic_ke(line,0,1,var,nc,.true.,error)
  if (error) return
  call sic_descriptor (var,desc,found)  ! no transposition
  !
  ! Check it is a 1-D array
  if (desc%ndim.ne.1) then
     call sic_message(seve%e,rname,'Only 1-D array allowed')
     error = .true.
     return
  else
     nxy = desc%dims(1)
  endif
  !
  vtype = desc%type
  allocate(iwork(nxy),stat=ier)
  if (ier.ne.0) then
     call sic_message(seve%e,rname,'Insufficient memory for work space')
     error = .true.
     return
  endif
  ipkey = gag_pointer(desc%addr,memory)
  if (vtype.eq.fmt_r4) then
     call gr4_trie_i4(memory(ipkey),iwork,nxy,error)
  else if (vtype.eq.fmt_r8) then
     call gr8_trie_i4(memory(ipkey),iwork,nxy,error)
  else if (vtype.eq.fmt_i4) then
     call gi4_trie_i4(memory(ipkey),iwork,nxy,error)
  else if (vtype.eq.fmt_i8) then
     call gi8_trie_i4(memory(ipkey),iwork,nxy,error)
  else if (vtype.gt.0) then
     call gch_trie_i4(memory(ipkey),iwork,nxy,vtype,error)
  else
     call sic_message(seve%e,rname,'Kind of data not supported for sorting key')
     error = .true.
  endif
  if (error) then
     deallocate(iwork)
     return
  endif
  !
  ! Now sort all the others by G*_SORT
  nsort = sic_narg(0)
  do i=2,nsort
     call sic_ke(line,0,i,var,nc,.true.,error)
     if (error) exit
     call sic_descriptor (var,desc,found)  ! no transposition
     if (.not.found) cycle
     !
     vtype = desc%type
     !
     if (desc%ndim.le.2 .and. desc%dims(1).eq.nxy) then
        nplane = max(1,desc%dims(2))
        if (vtype.eq.fmt_r4 .or. vtype.eq.fmt_i4 .or. vtype.eq.fmt_l) then
           ipvar = gag_pointer(desc%addr,memory)
           if (.not.allocated(swork))  allocate(swork(nxy),stat=ier)
           do j=1,nplane
              ! Sort with gi4_sort which preserves bits (R*4 to R*4 may not
              ! preserve bits)
              if (ipvar.ne.ipkey)  call gi4_sort(memory(ipvar),swork,iwork,nxy)
              ipvar = ipvar+nxy
           enddo
           !
        else if (vtype.eq.fmt_r8 .or. vtype.eq.fmt_i8) then
           ipvar = gag_pointer(desc%addr,memory)
           if (.not.allocated(dwork))  allocate(dwork(nxy),stat=ier)
           do j=1,nplane
              ! Sort with gi8_sort which preserves bits (R*8 to R*8 may not
              ! preserve bits)
              if (ipvar.ne.ipkey)  call gi8_sort(memory(ipvar),dwork,iwork,nxy)
              ipvar = ipvar+2*nxy
           enddo
           !
        else if (vtype.gt.0) then  ! Character array
           ipvar = bytpnt(desc%addr,membyt)
           allocate(cwork(vtype*nxy),stat=ier)
           do j=1,nplane
              if (ipvar.ne.ipkey)  call gch_sort(membyt(ipvar),cwork,iwork,vtype,nxy)
              ipvar = ipvar+vtype*nxy
           enddo
           deallocate(cwork)  ! Always, size can differ from one variable to another
           !
        else
           call sic_message(seve%e,rname,  &
             'Type of array '//trim(var)//' is not supported for sorting')
           error = .true.
           exit
        endif
     else
        call sic_message(seve%e,rname,'Size mismatch for '//var)
        error = .true.
        exit
     endif
  enddo
  !
  if (allocated(swork)) deallocate(swork)
  if (allocated(dwork)) deallocate(dwork)
  if (allocated(iwork)) deallocate(iwork)
end subroutine sicsort
!
subroutine gr8_locate (x,np,xlim,nlim,mlim)
  use gildas_def
  use sic_interfaces
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  ! DISPLAY	Internal routine
  !	Find NLIM and MLIM such as
  !	 	X(NLIM) < XLIM < X(MLIM)
  ! or vice versa
  !	 	X(NLIM) > XLIM > X(MLIM)
  !	for input data ordered.
  !	Use a dichotomic search for that
  !---------------------------------------------------------------------
  integer(kind=size_length), intent(in)  :: np     !
  real(kind=8),              intent(in)  :: x(np)  !
  real(kind=8),              intent(in)  :: xlim   !
  integer(kind=size_length), intent(out) :: nlim   !
  integer(kind=size_length), intent(out) :: mlim   !
  ! Local
  integer(kind=size_length) :: ninf,nsup,nmid
  !
  if (x(1).lt.x(np)) then
     if (x(1).gt.xlim) then
        nlim = 1
        mlim = 1
        return
     elseif (x(np).lt.xlim) then
        nlim = np
        mlim = np
        return
     endif
     ninf = 1
     nsup = np
     !
     do while(nsup.gt.ninf+1)
        nmid = (nsup + ninf)/2
        if (x(nmid).lt.xlim) then
           ninf = nmid
        else
           nsup = nmid
        endif
     enddo
     nlim = ninf
     mlim = nsup
  else
     if (x(1).lt.xlim) then
        nlim = 1
        mlim = 1
        return
     elseif (x(np).gt.xlim) then
        nlim = np
        mlim = np
        return
     endif
     ninf = 1
     nsup = np
     !
     do while(nsup.gt.ninf+1)
        nmid = (nsup + ninf)/2
        if (x(nmid).gt.xlim) then
           ninf = nmid
        else
           nsup = nmid
        endif
     enddo
     nlim = ninf
     mlim = nsup
  endif
end subroutine gr8_locate
!
subroutine gr4_locate (x,np,xlim,nlim,mlim)
  use gildas_def
  use sic_interfaces
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  ! DISPLAY	Internal routine
  !	Find NLIM and MLIM such as
  !	 	X(NLIM) < XLIM < X(MLIM)
  ! or vice versa
  !	 	X(NLIM) > XLIM > X(MLIM)
  !	for input data ordered.
  !	Use a dichotomic search for that
  !---------------------------------------------------------------------
  integer(kind=size_length), intent(in)  :: np     !
  real(kind=4),              intent(in)  :: x(np)  !
  real(kind=4),              intent(in)  :: xlim   !
  integer(kind=size_length), intent(out) :: nlim   !
  integer(kind=size_length), intent(out) :: mlim   !
  ! Local
  integer(kind=size_length) :: ninf,nsup,nmid
  !
  if (x(1).lt.x(np)) then
     if (x(1).gt.xlim) then
        nlim = 1
        mlim = 1
        return
     elseif (x(np).lt.xlim) then
        nlim = np
        mlim = np
        return
     endif
     ninf = 1
     nsup = np
     !
     do while(nsup.gt.ninf+1)
        nmid = (nsup + ninf)/2
        if (x(nmid).lt.xlim) then
           ninf = nmid
        else
           nsup = nmid
        endif
     enddo
     nlim = ninf
     mlim = nsup
  else
     if (x(1).lt.xlim) then
        nlim = 1
        mlim = 1
        return
     elseif (x(np).gt.xlim) then
        nlim = np
        mlim = np
        return
     endif
     ninf = 1
     nsup = np
     !
     do while(nsup.gt.ninf+1)
        nmid = (nsup + ninf)/2
        if (x(nmid).gt.xlim) then
           ninf = nmid
        else
           nsup = nmid
        endif
     enddo
     nlim = ninf
     mlim = nsup
  endif
end subroutine gr4_locate

!!
subroutine mosaic_sort (huv_call,error,sorted,shift,newabs,uvmax,uvmin, &
  & ixoff,iyoff,idoff,nf,doff,voff)
  use gkernel_interfaces
  use imager_interfaces, except_this=>mosaic_sort
  use clean_def
  use clean_arrays
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private-mandatory
  !*
  ! IMAGER -- UV_MAP: Sort the input Mosaic UV table
  !!
  !---------------------------------------------------------------------
  type(gildas), intent(inout) :: huv_call    !! UV Header & Data
  logical, intent(inout) :: sorted           !! Is table sorted ?
  logical, intent(inout) :: shift            !! Do we shift phase center ?
  logical, intent(out) :: error              !! Logical error flag
  real(kind=8), intent(inout) :: newabs(3)   !! New phase center and PA
  real, intent(out) :: uvmin                 !! Min baseline
  real, intent(out) :: uvmax                 !! Max baseline
  integer, intent(in) :: ixoff, iyoff, idoff !! Offset pointers
  integer, intent(inout) :: nf               !! Number of fields
  real, intent(inout) :: doff(:,:)           !! Field offsets
  integer, intent(inout) :: voff(:)          !! Field visibility pointers
  !
  ! Constants
  real(8), parameter :: pi=3.14159265358979323846d0
  real(8), parameter :: f_to_k = 2.d0*pi/299792458.d-6
  character(len=*), parameter :: rname='UV_MOSAIC'
  !
  ! Local ---
  type(gildas) :: hold  ! Temporary holder of unsorted UV data
  integer :: ioff, joff, itel, ier
  logical :: ismosaic
  real(kind=8) :: freq, off(3)
  real :: pos(2), cs(2)
  integer :: nu,nv
  !
  ! Code ----
  call imager_tree('MOSAIC_SORT',.false.)
  if (newabs(3).ne.0) then
    Print *,'Non zero angle, NEW ABS ',newabs
  endif
  !
  call print_buffer_asso('UV Unsorted ',huv_call)
  !
  ! The UV table is available in huv_call%
  if (huv_call%loca%size.eq.0) then
    call map_message(seve%e,rname,'No UV data loaded')
    error = .true.
    return
  endif
  nu = huv_call%gil%dim(1)
  nv = huv_call%gil%nvisi ! not %dim(2)
  !
  ! Correct for new phase center if required
  if (shift) then
    if (huv_call%gil%ptyp.eq.p_none) then
      call map_message(seve%w,rname,'No previous phase center info')
      huv_call%gil%a0 = huv_call%gil%ra
      huv_call%gil%d0 = huv_call%gil%dec
      huv_call%gil%pang = 0.d0
      huv_call%gil%ptyp = p_azimuthal
    elseif (huv_call%gil%ptyp.ne.p_azimuthal) then
      call map_message(seve%w,rname,'Previous projection type not SIN')
      huv_call%gil%ptyp = p_azimuthal
    endif
    call uv_shift_header (newabs,huv_call%gil%a0,huv_call%gil%d0,huv_call%gil%pang,   &
        &      off,shift)
    huv_call%gil%posi_words = def_posi_words
    huv_call%gil%proj_words = def_proj_words
    !
    call print_buffer_asso('UV Shifted ',huv_call)
  endif
  !
  sorted = .false.
  !
  if (.not.associated(huv_call%r2d)) then
    call map_message(seve%e,rname,'huv_call%R2d pointer not set ',seve%e)
    error = .true.
    return
  else
    if ( (huv_call%gil%dim(1).ne.size(huv_call%r2d,1)) .or. &
      & (huv_call%gil%dim(2).ne.size(huv_call%r2d,2)) ) then
      call map_message(seve%e,rname,'huv_call%r2d pointer size is incorrect ',seve%e)
      Print *,'Dimensions ',huv_call%gil%dim(1:2)
      Print *,'Sizes      ',size(huv_call%r2d,1),size(huv_call%r2d,2)
      error = .true.
      return
    endif
  endif
  call get_mosaic_cols(huv_call,ioff,joff,itel,ismosaic)  
  call uvsort_check_fields(huv_call,ioff,joff,itel,sorted)
  !
  ! Get center frequency
  freq = gdf_uv_frequency(huv_call,huv_call%gil%ref(1))
  !
  if (sorted) then
    !
    call mosaic_loadfield (huv_call%r2d,nu,nv,ioff,joff,nf,doff,voff,uvmax,uvmin)
  else
    !
    ! Else, create another copy
    call map_message(seve%w,rname,'Sorting UV table...')
    !
    ! Compute observing frequency, and new phase center in wavelengths
    if (shift) then
      huv_call%gil%a0 = newabs(1)
      huv_call%gil%d0 = newabs(2)
      huv_call%gil%pang = newabs(3)
      cs(1)  =  cos(off(3))
      cs(2)  = -sin(off(3))
      pos = off(1:2)  ! Real*8 to Real*4
    else
      pos(1) = 0.0
      pos(2) = 0.0
      cs(1) = 1.0
      cs(2) = 0.0
    endif
    !
    ! OK, copy, rotate, shift, and sort ...
    !
    call gildas_null(hold,type='UVT')
    call gdf_copy_header(huv_call,hold,error)
    ! First copy the data pointer
    allocate(hold%r2d(huv_call%gil%dim(1),huv_call%gil%dim(2)),stat=ier)
    if (ier.ne.0) then
      call map_message(seve%e,rname,'Pointer allocation failed')
      error = .true.
      return
    endif
    hold%r2d = huv_call%r2d   ! Copy data
    !
    ! This also loads the fields
    call mosaic_sortuv (huv_call,nu,nv,huv_call%gil%ntrail,hold%r2d, &
      & huv_call%r2d,freq,pos,cs,uvmax,uvmin,error, & 
      & ixoff,iyoff,idoff,nf,doff,voff)
    deallocate(hold%r2d,stat=ier)
  endif
  !
  ! Now transform UVMAX in kiloWavelength (including 2 pi factor)
  uvmax = uvmax*freq*f_to_k
  uvmin = uvmin*freq*f_to_k
  error = .false.
  call imager_tree('MOSAIC_SORT',.true.)
end subroutine mosaic_sort
!
subroutine mosaic_sortuv (huvl,np,nv,ntrail,vin,vout,freq,off,cs,uvmax,uvmin, &
  & error,ixoff,iyoff,idoff,nf,doff,voff)
  use image_def
  use gkernel_interfaces
  use gbl_message
  use clean_default
  use imager_interfaces, except_this=> mosaic_sortuv
  !---------------------------------------------------------------------
  ! @ private-mandatory
  !*
  ! IMAGER -- UV_MAP:  Sort a UV table by fields  
  !     Rotate, Shift and Sort a UV table for map making
  !     Differential precession should have been applied before.
  !!
  !---------------------------------------------------------------------
  type(gildas), intent(in) :: huvl    !! UV Header
  integer, intent(in) :: np           !! Size of a visibility
  integer, intent(in) :: nv           !! Number of visibilities
  integer, intent(in) :: ntrail       !! Number of trailing daps
  real, intent(in) :: vin(np,nv)      !! Input visibilities
  real, intent(out) :: vout(np,nv)    !! Output visibilities
  real(8), intent(in) :: freq         !! Reference Frequency
  real, intent(in) :: off(2)          !! Offset of Reference
  real, intent(in) :: cs(2)           !! Frame Rotation
  real, intent(out) :: uvmax          !! Max UV value
  real, intent(out) :: uvmin          !! Min UV value
  integer, intent(in) :: ixoff, iyoff, idoff  !! Offset pointers
  integer, intent(out) :: nf          !! Number of fields
  real, intent(out) :: doff(:,:)      !! Offsets of the fields
  integer, intent(out) :: voff(:)     !! Visibility offset - range
  logical, intent(out) :: error       !! Logical error flag
  !
  ! Constant
  real(8), parameter :: pi=3.14159265358979323846d0
  real(8), parameter :: f_to_k = 2.d0*pi/299792458.d-6
  integer, parameter :: mprint=0
  !
  ! Local ---
  logical, allocatable :: ips(:)       ! Sign of visibility
  real, allocatable :: rpu(:), rpv(:)  ! U,V coordinates
  real, allocatable :: spv(:)          ! Sorted V coordinates
  integer, allocatable :: ipi(:)       ! Index
  real(8), allocatable :: dtr(:)       ! Sorting number
  real, allocatable :: xy(:,:)         ! Phase Shifts
  logical :: sorted
  integer :: ier, ifi, iv, ioff, joff
  !
  ! Code ----
  call imager_tree('MOSAIC_SORTUV',.false.)
  !
  ! Load U,V coordinates, applying possible rotation (CS),
  ! and making all V negative
  allocate (ips(nv),rpu(nv),rpv(nv),ipi(nv),dtr(nv),stat=ier)
  if (ier.ne.0) then
    error = .true.
    return
  endif
  call loaduv (vin,np,nv,cs,rpu,rpv,ips,uvmax,uvmin)
  !TEST!Print *,'UVMIN ',uvmin,' UVMAX ',uvmax,' NP ',np,' NV ',nv
  !
  ! Modify the uv coordinates to minimize
  ! the projection errors ... See Sault et al 1996 Appendix 1
  ! Key question here
  ! - modification must be done before sorting
  ! - but should we use the modified or intrinsic UV coordinates ?
  !
  ! For the rotation above, it does not matter, actually: the
  ! matrix commutes (I think so - That can be check later...)
  !
  !  call remapuv(nv,cs,rpu,rpv,ixoff,iyoff,uvmax,uvmin)
  !
  ! Identify number of fields
  if (ixoff.ne.0 .and. iyoff.ne.0) then
    call loadfiuv_xy(vin,np,nv,dtr,ipi,sorted,ixoff,iyoff,rpv,nf,doff)
  else if (idoff.ne.0) then
    call map_message(seve%w,'LOADFIUV_ID', &
      & 'Sorting UV data set with associated Mosaic table is obsolescent')
    call loadfiuv_id(huvl,vin,np,nv,dtr,ipi,sorted,idoff,rpv,nf,doff)
  endif
  !
  allocate(xy(2,nf))
  ! Note that the new phase center is counter-rotated because rotations
  ! are applied before phase shift.
  if ((idoff.ne.0).and.(mosaic_mode.eq.'SAULT')) then
    !
    ! Should we Add the Global Offset ?
    ! We should also find the fractional pixel shift if needed here...
    ! The shifting should also always be done in this case, 
    ! and the initial UV table not changed ? 
    do ifi=1,nf
      xy(1,ifi) = - freq * f_to_k * ( doff(1,ifi)*cs(1) - doff(2,ifi)*cs(2) )
      xy(2,ifi) = - freq * f_to_k * ( doff(2,ifi)*cs(1) + doff(1,ifi)*cs(2) )
    enddo  
  else
    !
    ! In the GUETH method, add the global offset - CHECKPLEASE
    xy(1,:) = - freq * f_to_k * ( off(1)*cs(1) - off(2)*cs(2) )
    xy(2,:) = - freq * f_to_k * ( off(2)*cs(1) + off(1)*cs(2) )
  endif
  !
  ! Sort by fields (major number) then V (fractionary part)
  if (.not.sorted) then
    !!Print *,'Sorting UV data '
    call gr8_trie (dtr,ipi,nv,error)
    if (error) return
    deallocate (dtr,stat=ier)
    allocate (spv(nv),stat=ier)
    if (ier.ne.0) then
      error = .true.
      return
    endif
    !
    ! One must sort RPV here to use SORTUV later...
    do iv=1,nv
      spv(iv) = rpv(ipi(iv))
    enddo
    rpv(:) = spv(:)
    deallocate (spv,stat=ier)
  else
    deallocate (dtr,stat=ier)
    !! Print *,'UV Data is already sorted '
  endif
  ! !Read(5,*) ifi
  !
  ! Apply phase shift and copy to output visibilities
  !
  ! For Mosaics using the Sault et al method, this must be done
  ! per Pointing, as the phase shift to be applied is Pointing
  ! dependent. We may need an intermediate routine to do so, or
  ! to generalize the XY array to one per field.
  !
  call imager_tree('SUB_SORTUV',.false.)
  call sub_sortuv (vin,vout,np,nv,ntrail,xy,nf,idoff,rpu,rpv,ips,ipi)
  call imager_tree('SUB_SORTUV',.true.)
  !
  if (ixoff.ne.0 .and. iyoff.ne.0) then
    ifi = 1
    voff(ifi) = 1
    do iv=1,nv
      if ( (doff(1,ifi).ne.vout(ixoff,iv)) .or. &
        &  (doff(2,ifi).ne.vout(iyoff,iv)) ) then
        ifi = ifi+1
        voff(ifi) = iv
      endif
    enddo
    voff(nf+1) = nv+1
  else if (idoff.ne.0) then
    ifi = 0
    joff = -1 
    do iv=1,nv
      ioff = vout(idoff,iv)
      if (ioff.ne.joff) then
        ifi = ifi+1
        voff(ifi) = iv
        joff = ioff
      endif
    enddo
    voff(nf+1) = nv+1
  endif
  !
  if (mprint.eq.0) return
  !
  ! !Print *,'XOFF ',ixoff,' YOFF ',iyoff
  do ifi=1,min(nf,mprint)
    write(*,'(I4,A,2F12.4,2I10)') ifi,' DOFF ', &
      & doff(1,ifi)*180.*3600./pi, &
      & doff(2,ifi)*180.*3600./pi, &
      & voff(ifi), voff(ifi+1)-1
  enddo
  if (nf.gt.mprint) write(*,*) 'and ',nf-mprint,' more fields used but not printed above'
  !
  error = .false.
  !
  call imager_tree('MOSAIC_SORTUV',.true.)
end subroutine mosaic_sortuv

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Main program management utilities
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module gmaster_private
  use sic_def
  use sic_interactions
  use gpack_def
  !---------------------------------------------------------------------
  ! @ private
  ! Structure for handling static master informations. They can be set
  ! from logical variables, command line or gmaster API.
  !---------------------------------------------------------------------
  type :: master_info_t
     character(len=filename_length) :: logname = ""           ! Basename for log_file and message_file
     character(len=filename_length) :: log_file = ""          ! For specific log_file
     character(len=filename_length) :: message_file = ""      ! For specific message_file
     logical                        :: append_date_on_logname = .false. ! Do not append date on logname
     character(len=gprompt_length)  :: prompt = ""            ! Prompt at startup
     logical                        :: disable_gui = .false.  ! Enable gui
     logical                        :: disable_log = .false.  ! Enable log files
     logical                        :: disable_menu = .false. ! Enable menu
     logical                        :: hide_gui = .false.     ! Show gui at startup
     logical                        :: hide_welcome = .false. ! Show welcome message at startup
     logical                        :: no_welcome_procedure = .false. ! Run welcome procedure at startup
     logical                        :: use_debug = .false.    ! Do not display debug messages
     logical                        :: usage = .false.        ! Display usage only?
     character(len=filename_length) :: display = ""           ! XWindow display to use
  end type master_info_t
  !
  !---------------------------------------------------------------------
  ! Structure for handling master dynamic state.
  !---------------------------------------------------------------------
  type :: master_prop_t
     type(master_info_t)               :: info              ! Master static info
     integer                           :: id = 0            ! Master package id
     character(len=filename_length)    :: logname = ""      ! Effective logname
     character(len=filename_length)    :: log_file = ""
     character(len=filename_length)    :: message_file = ""
     character(len=filename_length)    :: history_file = ""
     character(len=commandline_length) :: command_line = ""
  end type master_prop_t
  !
  type(master_prop_t), save :: gmaster         ! The master instance
  !
  logical :: exit_noprompt=.false.  ! For programs which may prompt answers at EXIT time.
  integer(kind=4) :: exit_code=0    ! EXIT status?
  !
end module gmaster_private
!
function gmaster_get_id()
  use gmaster_private
  !---------------------------------------------------------------------
  ! @ private
  ! Return master package id.
  !---------------------------------------------------------------------
  integer :: gmaster_get_id         !
  !
  gmaster_get_id = gmaster%id
  !
end function gmaster_get_id
!
subroutine gmaster_build_logname
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>gmaster_build_logname
  use gmaster_private
  !---------------------------------------------------------------------
  ! @ private
  ! Build effective logname by appending date to logname.
  !---------------------------------------------------------------------
  character(len=64) :: mess
  integer :: i
  !
  !if (.not.gmaster%info%append_date_on_logname) then
  !   gmaster%logname = gmaster%info%logname
  !   return
  !endif
  !
  call sic_date(mess)
  call sic_lower(mess)
  i = index(mess,':')
  do while (i.gt.0)
     mess(i:) = mess(i+1:)
     i = index(mess,':')
  enddo
  i = index(mess,'-')
  do while (i.gt.0)
     mess(i:) = mess(i+1:)
     i = index(mess,'-')
  enddo
  !
  gmaster%logname = trim(gmaster%info%logname)//'-'//mess(1:9)//'-'//mess(11:16)
  !
end subroutine gmaster_build_logname
!
subroutine gmaster_set_logname(logname)
  use sic_interfaces, except_this=>gmaster_set_logname
  use gmaster_private
  !---------------------------------------------------------------------
  ! @ public
  ! Set logname instead of default (i.e. package name).
  !---------------------------------------------------------------------
  character(len=*) :: logname       !
  !
  gmaster%info%logname = logname
  !
  call gmaster_build_logname
  !
end subroutine gmaster_set_logname
!
subroutine gmaster_set_message_file(message_file)
  use gmaster_private
  !---------------------------------------------------------------------
  ! @ public
  ! Set logname instead of default (i.e. package name).
  !---------------------------------------------------------------------
  character(len=*) :: message_file  !
  !
  gmaster%info%message_file = message_file
  !
end subroutine gmaster_set_message_file
!
subroutine gmaster_set_log_file(log_file)
  use gmaster_private
  !---------------------------------------------------------------------
  ! @ public
  ! Set logname instead of default (i.e. package name).
  !---------------------------------------------------------------------
  character(len=*) :: log_file      !
  !
  gmaster%info%log_file = log_file
  !
end subroutine gmaster_set_log_file
!
subroutine gmaster_append_date_on_logname
  use gmaster_private
  !---------------------------------------------------------------------
  ! @ public
  ! Append date on logname
  !---------------------------------------------------------------------
  !
  gmaster%info%append_date_on_logname = .true.
  !
end subroutine gmaster_append_date_on_logname
!
subroutine gmaster_set_prompt(prompt)
  use sic_interfaces, except_this=>gmaster_set_prompt
  use gbl_message
  use gmaster_private
  !---------------------------------------------------------------------
  ! @ public
  ! Set prompt instead of default (i.e. package name)
  !---------------------------------------------------------------------
  character(len=*) :: prompt        !
  !
  call sic_message(seve%d,'MASTER','Setting prompt to '//prompt)
  !
  gmaster%info%prompt = prompt
  !
end subroutine gmaster_set_prompt
!
subroutine gmaster_set_display(display)
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>gmaster_set_display
  use gbl_message
  use gmaster_private
  !---------------------------------------------------------------------
  ! @ public
  ! Set display instead of default
  !---------------------------------------------------------------------
  character(len=*) :: display       !
  ! Local
  integer :: ier
  !
  call sic_message(seve%d,'MASTER','Setting display to '//display)
  !
  gmaster%info%display = display
  ier = sic_setlog('display',gmaster%info%display)  ! Set the logical DISPLAY
  !
end subroutine gmaster_set_display
!
subroutine gmaster_set_disable_log
  use sic_interfaces, except_this=>gmaster_set_disable_log
  use gbl_message
  use gmaster_private
  use sic_interactions
  !---------------------------------------------------------------------
  ! @ public
  ! Disable the log files (.log and .mes)
  !---------------------------------------------------------------------
  !
  call sic_message(seve%d,'MASTER','Disabling log')
  !
  gmaster%info%disable_log = .true.
  !
end subroutine gmaster_set_disable_log
!
subroutine gmaster_set_disable_gui
  use sic_interfaces, except_this=>gmaster_set_disable_gui
  use gbl_message
  use gmaster_private
  use sic_interactions
  !---------------------------------------------------------------------
  ! @ public
  ! Disable gui
  !---------------------------------------------------------------------
  !
  call sic_message(seve%d,'MASTER','Disabling gui')
  !
  gmaster%info%disable_gui = .true.
  sic_window = .false.  ! SIC%WINDOW is mapped on it
  call gmaster_set_hide_gui
  !
end subroutine gmaster_set_disable_gui
!
subroutine gmaster_set_disable_menu
  use sic_interfaces, except_this=>gmaster_set_disable_menu
  use gbl_message
  use gmaster_private
  !---------------------------------------------------------------------
  ! @ public
  ! Disable gui
  !---------------------------------------------------------------------
  !
  call sic_message(seve%d,'MASTER','Disabling menu')
  !
  gmaster%info%disable_menu = .true.
  !
end subroutine gmaster_set_disable_menu
!
subroutine gmaster_set_hide_gui
  use sic_interfaces, except_this=>gmaster_set_hide_gui
  use gbl_message
  use gmaster_private
  use sic_interactions
  !---------------------------------------------------------------------
  ! @ public
  ! Hide gui at startup
  !---------------------------------------------------------------------
  !
  call sic_message(seve%d,'MASTER','Hiding gui')
  !
  gmaster%info%hide_gui = .true.
  sic_initwindow = .false.  ! SIC%INITWINDOW is mapped on it
  !
end subroutine gmaster_set_hide_gui
!
function gmaster_hide_gui()
  use gmaster_private
  !---------------------------------------------------------------------
  ! @ public
  ! return "hide gui" property
  !---------------------------------------------------------------------
  logical :: gmaster_hide_gui       !
  !
  gmaster_hide_gui = gmaster%info%hide_gui
  !
end function gmaster_hide_gui
!
subroutine gmaster_set_hide_welcome
  use sic_interfaces, except_this=>gmaster_set_hide_welcome
  use gbl_message
  use gmaster_private
  !---------------------------------------------------------------------
  ! @ public
  ! Hide welcome at startup
  !---------------------------------------------------------------------
  !
  call sic_message(seve%d,'MASTER','Hiding welcome')
  !
  gmaster%info%hide_welcome = .true.
  !
end subroutine gmaster_set_hide_welcome
!
subroutine gmaster_set_usage
  use sic_interfaces, except_this=>gmaster_set_usage
  use gmaster_private
  !---------------------------------------------------------------------
  ! @ private
  ! Activate 'usage' message at startup
  !---------------------------------------------------------------------
  !
  gmaster%info%usage = .true.
  call gmaster_set_hide_welcome
  call gmaster_set_disable_gui  ! No menu nor window
  !
end subroutine gmaster_set_usage
!
subroutine gmaster_set_no_welcome_procedure
  use gmaster_private
  !---------------------------------------------------------------------
  ! @ public
  ! Hide welcome at startup
  !---------------------------------------------------------------------
  !
  gmaster%info%no_welcome_procedure = .true.
  !
end subroutine gmaster_set_no_welcome_procedure
!
subroutine gmaster_set_use_debug
  use gmaster_private
  !---------------------------------------------------------------------
  ! @ public
  ! Enable display of debug messages
  !---------------------------------------------------------------------
  !
  gmaster%info%use_debug = .true.
  !
end subroutine gmaster_set_use_debug
!
subroutine gmaster_get_command_line(command_line)
  use gmaster_private
  !---------------------------------------------------------------------
  ! @ public
  ! Get input command line
  !---------------------------------------------------------------------
  character(len=*) , intent(out) :: command_line  !
  !
  command_line = gmaster%command_line
  !
end subroutine gmaster_get_command_line
!
subroutine gmaster_gui(pack_id)
  use sic_interfaces, except_this=>gmaster_gui
  use gbl_message
  use gmaster_private
  use sic_dependencies_interfaces
  !---------------------------------------------------------------------
  ! @ private
  ! Show user interface of loaded packages
  !---------------------------------------------------------------------
  integer, intent(in) :: pack_id    !
  ! Local
  integer :: lun,ier
  character(len=filename_length) :: menu_file
  type(gpack_info_t) :: pack
  logical :: error
  !
  if (gmaster%info%disable_gui.or.gmaster%info%disable_menu) return
  !
  call sic_message(seve%t,'gmaster_gui',"Welcome")
  !
  error = .false.
  !
  ier = sic_getlun(lun)
  if (ier.ne.1) call sic_message(seve%f,'gmaster_gui','sic_getlun failed')
  !
  pack = gpack_get_info(gmaster%id)
  if (pack%ext.eq."") return
  !
  call sic_parse_file('menu-proc'//trim(pack%ext),'gag_proc:',"",menu_file)
  ier = sic_open(lun,menu_file,'NEW',.false.)
  if (ier.ne.0) then
     call sic_message(seve%f,'gmaster_gui','Unable to open '//trim(menu_file))
     call putios('E-GMASTER_GUI,  ',ier)
  else
     write (lun,'(A)') 'begin procedure menu'
     !
     write (lun,'(A)') 'gui\panel "'//trim(pack%name)//' GUI" gag_pro:greg-menu.hlp /detach'
     call gmaster_gui_menus(lun,error)
     call gmaster_gui_demo(lun,error)
     call gmaster_gui_help(lun,error)
     write (lun,'(A)') 'gui\go'
     !
     write (lun,'(A)') 'end procedure menu'
     close(lun)
     !
     call exec_program('@ "'//trim(menu_file)//'"')
     call gag_filrm(menu_file)
     if (.not.gmaster%info%hide_gui) then
        call exec_program('@ menu')
     endif
  endif
  call sic_frelun(lun)
  !
  call sic_message(seve%t,'gmaster_gui',"Bye")
  !
end subroutine gmaster_gui
!
subroutine gmaster_gui_menus(lun,error)
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>gmaster_gui_menus
  use gpack_def
  !---------------------------------------------------------------------
  ! @ private
  !  Define the menus in the gui. One menu per package, if provided by
  ! the package.
  !---------------------------------------------------------------------
  integer(kind=4), intent(in)    :: lun    ! The logical to write in
  logical,         intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='GUI'
  integer(kind=4) :: ipack,ier
  type(gpack_info_t) :: pack
  character(len=filename_length) :: pack_menu_file
  !
  do ipack=1,gpack_get_count(),1
    pack = gpack_get_info(ipack)
    if (sic_query_file('submenu'//trim(pack%ext),'macro#dir:',"",pack_menu_file)) then
      write (lun,'(A)',iostat=ier) '@ "submenu'//trim(pack%ext)//'"'
      if (ier.ne.0) then
        call sic_message(seve%e,rname,'Could not build gui menus')
        error = .true.
        return
      endif
    endif
  end do
  !
end subroutine gmaster_gui_menus
!
subroutine gmaster_gui_demo(lun,error)
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>gmaster_gui_demo
  use gpack_def
  !---------------------------------------------------------------------
  ! @ private
  !  Define the Demo menu in the gui. One submenu per package, if
  ! provided by the package.
  !---------------------------------------------------------------------
  integer(kind=4), intent(in)    :: lun    ! The logical to write in
  logical,         intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='GUI'
  integer(kind=4) :: ipack,ier
  type(gpack_info_t) :: pack
  character(len=filename_length) :: pack_menu_file
  !
  write (lun,'(A)') 'gui\menu "Demos"'
  !
  do ipack=gpack_get_count(),1,-1
    pack = gpack_get_info(ipack)
    if (sic_query_file('subdemo'//trim(pack%ext),'macro#dir:',"",pack_menu_file)) then
      write (lun,'(A)',iostat=ier) '@ "subdemo'//trim(pack%ext)//'"'
      if (ier.ne.0) then
        call sic_message(seve%e,rname,'Could not build gui Demo')
        error = .true.
        return
      endif
    endif
  end do
  !
  write (lun,'(A)') 'gui\menu /close'
  !
end subroutine gmaster_gui_demo
!
subroutine gmaster_gui_help(lun,error)
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>gmaster_gui_help
  use gpack_def
  use sic_dictionaries
  !---------------------------------------------------------------------
  ! @ private
  !  Define the Help menu in the gui. One submenu per package, if
  ! provided by the package.
  !---------------------------------------------------------------------
  integer(kind=4), intent(in)    :: lun    ! The logical to write in
  logical,         intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='GUI'
  integer(kind=4) :: ipack,ier,ilan
  type(gpack_info_t) :: pack
  character(len=filename_length) :: pack_menu_file
  !
  write (lun,'(A)') 'gui\menu "Help"'
  !
  ! Load help submenus for each dependency
  do ipack=gpack_get_count(),1,-1
    pack = gpack_get_info(ipack)
    if (sic_query_file('subhelp'//trim(pack%ext),'macro#dir:',"",pack_menu_file)) then
      write (lun,'(A)',iostat=ier) '@ "subhelp'//trim(pack%ext)//'"'
      if (ier.ne.0) then
        call sic_message(seve%e,rname,'Could not build gui Help')
        error = .true.
        return
      endif
    endif
  end do
  !
  ! Build a list of languages help
  write (lun,'(A)') 'gui\submenu "Languages"'
  do ilan=1,nlang
    write (lun,'(5A)')  &
      'gui\button "sic\help ',trim(languages(ilan)%name),'\" "',trim(languages(ilan)%name),'\"'
  enddo
  write (lun,'(A)') 'gui\submenu /close'
  !
  write (lun,'(A)') 'gui\menu /close'
  !
end subroutine gmaster_gui_help
!
subroutine gmaster_show_loaded_packages
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>gmaster_show_loaded_packages
  use gmaster_private
  !---------------------------------------------------------------------
  ! @ private
  ! Print informations on screen of all loaded packages
  !---------------------------------------------------------------------
  integer :: ipack
  type(gpack_info_t) :: pack
  !
  ! Show all loaded packages on screen
  write (*,'(A)') ""
  write (*,'(A)') ' * Loaded modules'
  do ipack=1,gpack_get_count(),1
     pack = gpack_get_info(ipack)
     if (pack%authors.ne."") then
        write (*,'(A)') '    '//trim(pack%name)//' ('//trim(pack%authors)//')'
     else
        write (*,'(A)') '    '//trim(pack%name)
     endif
  end do
  !
end subroutine gmaster_show_loaded_packages
!
subroutine gmaster_welcome(pack_id)
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>gmaster_welcome
  use gmaster_private
  !---------------------------------------------------------------------
  ! @ private
  ! Execute the welcome procedure from master package
  !---------------------------------------------------------------------
  integer, intent(in) :: pack_id    !
  ! Local
  type(gpack_info_t) :: pack
  character(len=gpack_name_length) :: pack_name
  character(len=32) :: name
  character(len=filename_length) :: file
  logical :: found
  !
  if (gmaster%info%hide_welcome) return
  !
  pack = gpack_get_info(pack_id)
  !
  ! Print Welcome
  pack_name = pack%name
  call sic_upper(pack_name)
  write (*,'(A)') ""
  write (*,'(A)') ' * Welcome to '//pack_name
  !
  call gmaster_show_loaded_packages
  !
  ! Execute welcome procedure
  if (.not.gmaster%info%no_welcome_procedure.and.pack%ext.ne."") then
    name = 'welcome'//trim(pack%pro_suffix)//pack%ext
    call find_procedure(name,file,found)
    if (found)  call exec_program('@ '//name)  ! No error if no welcome procedure
  endif
  !
end subroutine gmaster_welcome
!
subroutine gmaster_loop
  use sic_interfaces, except_this=>gmaster_loop
  use gbl_message
  use gmaster_private
  !---------------------------------------------------------------------
  ! @ private
  ! Execute optionnal commands from command line and run the interpreter
  ! loop
  !---------------------------------------------------------------------
  !
  call sic_message(seve%t,"GAG_LOOP","Welcome")
  !
  ! Begin session with user command or nothing
  ! Start the real work
  if (gmaster%command_line.ne."") then
     call play_program(gmaster%command_line)
  else
     call enter_program
  endif
  !
  call sic_message(seve%t,"GAG_LOOP","Bye")
  !
end subroutine gmaster_loop
!
subroutine gmaster_custom_init
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>gmaster_custom_init
  !---------------------------------------------------------------------
  ! @ private
  ! Check if some features are customized in dictionaries and different
  ! from defaults.
  ! Nothing is done if values are the defaults (e.g. "sic_window yes")
  !---------------------------------------------------------------------
  ! Local
  character(len=32) :: logic
  integer :: ier
  !
  ! No initial window
  logic = 'sic_initwindow'
  ier = sic_getlog(logic)
  if (ier.eq.0) then
    call sic_upper(logic)
    if (logic.eq.'NO') call gmaster_set_hide_gui
  endif
  !
  ! No window (from global dictionary)
  logic = 'gag_widgets'
  ier = sic_getlog(logic)
  if (ier.eq.0) then
    call sic_upper(logic)
    if (logic.eq.'NONE') call gmaster_set_disable_gui
  endif
  !
  ! No window (from local dictionary)
  logic = 'sic_window'
  ier = sic_getlog(logic)
  if (ier.eq.0) then
    call sic_upper(logic)
    if (logic.eq.'NO') call gmaster_set_disable_gui
  endif
  !
  ! Display
  logic = 'display'
  ier = sic_getlog(logic)
  if (ier.eq.0) call gmaster_set_display(logic)
  !
  ! No log files?
  logic = 'sic_logfiles'
  ier = sic_getlog(logic)
  if (ier.eq.0) then
    call sic_upper(logic)
    if (logic.eq.'NO')  call gmaster_set_disable_log
  endif
  !
end subroutine gmaster_custom_init
!
subroutine gmaster_parse_command_line(nomore,error)
  use sic_interfaces, except_this=>gmaster_parse_command_line
  use sic_dependencies_interfaces
  use sic_def
  use gbl_message
  use gmaster_private
  !---------------------------------------------------------------------
  ! @ private
  ! Parse command line options. Override customizations from
  ! dictionaries
  !---------------------------------------------------------------------
  logical, intent(out)   :: nomore  ! Should program stop after this?
  logical, intent(inout) :: error   !
  ! Local
  integer :: iarg, arg_count
  integer :: command_line_length = 0
  character(len=filename_length) :: arg  ! Longest argument can be a file name
  !
  iarg = 1
  arg_count = sic_get_arg_count()
  nomore = .false.
  do while (iarg.le.arg_count)
     call sic_get_arg(iarg,arg)
     if (arg(1:1).eq.'-'.and.command_line_length.eq.0) then
        if (arg.eq.'-nw') then
           call gmaster_set_disable_gui
        elseif (arg.eq.'-niw') then
           call gmaster_set_hide_gui
        elseif (arg.eq.'-nl') then
           call gmaster_set_disable_log
        elseif (arg.eq.'-display') then
           iarg = iarg+1
           call sic_get_arg(iarg,arg)
           call gmaster_set_display(arg)
        elseif (arg.eq.'-logname') then
           iarg = iarg+1
           call sic_get_arg(iarg,arg)
           call gmaster_set_logname(arg)
! Examples for new options
!        elseif (arg.eq.'-prompt') then
!           iarg = iarg+1
!           call sic_get_arg(iarg,arg)
!           call gmaster_set_prompt(arg)
        elseif (arg.eq.'-d') then
           call gmaster_set_use_debug
        elseif (arg.eq.'-v') then
           ! At this stage version has already been displayed
           nomore = .true.
        elseif (arg.eq.'-h') then
           call gmaster_set_usage
        else
          call sic_message(seve%e,'gmaster_get_command_line','unrecognized option '//arg)
          error = .true.
        endif
     else
        gmaster%command_line(command_line_length+1:) = arg
        command_line_length = command_line_length+1+len_trim(arg)
     endif
     iarg = iarg+1
  enddo
  !
  ! Memorize this command line in the keyboard recall stack
  call gprompt_set_command_line(gmaster%command_line)
  !
end subroutine gmaster_parse_command_line
!
subroutine gmaster_usage
  use sic_interfaces, except_this=>gmaster_usage
  !---------------------------------------------------------------------
  ! @ private
  ! Display the usage and exit. In particular, describe the available
  ! options.
  !---------------------------------------------------------------------
  !
  call exec_program('@ usage.sic')
  !
end subroutine gmaster_usage
!
subroutine gmaster_on_exit(error)
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>gmaster_on_exit
  use gmaster_private
  !---------------------------------------------------------------------
  ! @ private
  ! Execute the on_exit routines of all registered packages
  ! Program can exit if error is false on output
  !---------------------------------------------------------------------
  logical, intent(inout) :: error   !
  ! Global
  include 'gbl_memory.inc'
  ! Local
  integer :: ipack
  type(gpack_info_t) :: pack
  !
  ! Close all the GUI-menus (needed if their support procedure is to
  ! be removed, e.g. in GAG_PROC: : some NFS servers deny the cleaning
  ! as long as the GUI-menu exists). Must be called before routine
  ! 'end_procedure'.
  if (sic_inter_state(0))  &
     call xgag_end_detach_all
  !
  ! Loop over the registered packages and call on_exit routine
  ! in registering reverse order
  do ipack=gpack_get_count(),1,-1
     pack = gpack_get_info(ipack)
     if (pack%on_exit.ne.0) then
        call gexec1(membyt(bytpnt(pack%on_exit,membyt)),error)
        if (error) return
     endif
  end do
  !
end subroutine gmaster_on_exit
!
subroutine gmaster_clean(error)
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>gmaster_clean
  use sic_def
  use gmaster_private
  !---------------------------------------------------------------------
  ! @ private
  ! Execute the clean routines of all registered packages
  !---------------------------------------------------------------------
  logical, intent(inout) :: error   !
  ! Global
  include 'gbl_memory.inc'
  ! Local
  integer :: ipack,ier
  type(gpack_info_t) :: pack
  character(len=filename_length) :: file
  !
  ! Loop over the registered packages and call clean routine
  ! in registering reverse order (just in case...)
  do ipack=gpack_get_count(),1,-1
     pack = gpack_get_info(ipack)
     if (pack%clean.ne.0) call gexec1(membyt(bytpnt(pack%clean,membyt)),error)
  end do
  !
  ! Close opened units
  call sic_close_log(error)
  call gmessage_close(error)
  !
  ! Any remaining?
!   ier = gag_stalun(0)  ! Debug: stat all the units. Should be already closed
!                        ! (sic_close) and freed (gag_frelun).
  ier = sic_close(0)  ! => close all for safety
  !
  if (.not.gmaster%info%disable_log) then
    ! Log files were activated
    if (.not.gmaster%info%append_date_on_logname) then
      ! Remove date from filenames
      if (gmaster%info%message_file.eq."") then
          call sic_parse_file(gmaster%info%logname,'gag_log:','.mes',file)
          ier = gag_filrename(gmaster%message_file,file)
      endif
      if (gmaster%info%log_file.eq."") then
          call sic_parse_file(gmaster%info%logname,'gag_log:','.log',file)
          ier = gag_filrename(gmaster%log_file,file)
      endif
    endif
  endif
  !
end subroutine gmaster_clean
!
subroutine gmaster_build_info(pack_set)
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>gmaster_build_info
  use gmaster_private
  !---------------------------------------------------------------------
  ! @ private
  ! Build master info
  !---------------------------------------------------------------------
  external :: pack_set              ! Package definition routine
  ! Local
  type(gpack_info_t) :: pack
  !
  call pack_set(pack)
  !
  if (gmaster%info%logname.eq."") then
     call gmaster_set_logname(pack%name)
  endif
  !
  if (gmaster%info%prompt.eq."") then
     gmaster%info%prompt = pack%name
     call sic_upper(gmaster%info%prompt)
  endif
  !
end subroutine gmaster_build_info
!
subroutine gmaster_raw_import(master,pack_set,debug,error)
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>gmaster_raw_import
  use gmaster_private
  !---------------------------------------------------------------------
  ! @ public
  ! Imports a package, and returns package registration id
  !---------------------------------------------------------------------
  logical, intent(in)    :: master    ! Import master package
  external               :: pack_set  ! Package definition method
  logical, intent(in)    :: debug     ! Debug mode
  logical, intent(inout) :: error     !
  ! Local
  integer :: pack_id
  logical :: already_registered
  !
  if (.not.debug) then
     call gmessage_quiet
  endif
  !
  pack_id = gpack_build(pack_set,already_registered,error)
  if (master) gmaster%id = pack_id
  !
  if (.not.already_registered) call gmaster_gui(pack_id)
  !
  if (.not.debug) then
     call gmessage_standard
  endif
  !
end subroutine gmaster_raw_import
!
subroutine gmaster_main_import(pack_set,debug,error)
  use sic_interfaces, except_this=>gmaster_main_import
  use gmaster_private
  !---------------------------------------------------------------------
  ! @ private
  ! Imports the main package and sets the master package id
  !---------------------------------------------------------------------
  external               :: pack_set  ! Package definition method
  logical, intent(in)    :: debug     ! Debug mode
  logical, intent(inout) :: error     !
  !
  call gmaster_raw_import(.true.,pack_set,debug,error)
  !
  call gmaster_welcome(gmaster%id)
  !
end subroutine gmaster_main_import
!
subroutine gmaster_import(pack_set,debug,error)
  use sic_interfaces, except_this=>gmaster_import
  use gmaster_private
  !---------------------------------------------------------------------
  ! @ private
  ! Imports a package
  !---------------------------------------------------------------------
  external               :: pack_set  ! Package definition method
  logical, intent(in)    :: debug     ! Debug mode
  logical, intent(inout) :: error     !
  !
  call gmaster_raw_import(.false.,pack_set,debug,error)
  !
end subroutine gmaster_import
!
subroutine gmaster_build(pack_set,error)
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>gmaster_build
  use gbl_message
  use gmaster_private
  !---------------------------------------------------------------------
  ! @ public (should be private!)
  ! Build master package
  !---------------------------------------------------------------------
  external               :: pack_set  ! Package definition routine
  logical, intent(inout) :: error     ! Error code
  !
  ! If '-d' was present, revert debugging mode (default is off)
  if (gmaster%info%use_debug) call gmessage_debug_swap
  !
  call sic_message(seve%t,"gmaster_build","Start package setting")
  !
  ! Initialize widget library
#if defined(GAG_USE_STATICLINK)
  call init_gui
#endif
  !
  call gmaster_build_info(pack_set)
  !
  ! Must be first to ensure that gag directories are available (e.g.
  ! for message file)
  call sic_build_environment
  !
  ! Must be called ASAP to ensure correct logging of message afterwards
  if (.not.gmaster%info%disable_log) then
    ! Message file (.mes)
    if (gmaster%info%message_file.eq."") then
      call sic_parse_file(gmaster%logname,'gag_log:','.mes',gmaster%message_file)
    else
      gmaster%message_file = gmaster%info%message_file
    endif
    call gmessage_init(gmaster%message_file,error)
    if (error) return
    !
    ! Log file (.log)
    if (gmaster%info%log_file.eq."") then
      call sic_parse_file(gmaster%logname,'gag_log:','.log',gmaster%log_file)
    else
      gmaster%log_file = gmaster%info%log_file
    endif
    call sic_open_log(gmaster%log_file,error)
    if (error) return
  endif
  !
  call gprompt_set(gmaster%info%prompt)
  !
  ! Set keyboard history filename
  call sic_parse_file(gmaster%info%logname,'gag_log:','.hist',gmaster%history_file)
  call gkbd_f_histo_set_filename(gmaster%history_file)
  !
  ! Import package
  call gmaster_main_import(pack_set,gmaster%info%use_debug,error)
  if (error) return
  !
  call sic_message(seve%t,"gmaster_build","Stop package setting")
  !
end subroutine gmaster_build
!
subroutine gmaster_run(pack_set)
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>gmaster_run
  use gpack_def
  use gmaster_private
  use gbl_message
  !---------------------------------------------------------------------
  ! @ public
  ! Run master program
  !---------------------------------------------------------------------
  external :: pack_set              ! Package definition routine
  ! Local
  logical :: error,nomore
  character(len=256) :: release
  !
  error = .false.
  !
  call sic_message(seve%t,"gmaster_run","Welcome")
  !
  ! Echo the Gildas version
  call gag_release(release)
  write(*,'(a)') trim(release)
  !
  ! Get custom initialization from dictionaries
  call gmaster_custom_init
  !
  ! Parse command line options (override custom init)
  call gmaster_parse_command_line(nomore,error)
  if (nomore.or.error) return
  !
  ! Disable gui for non interactive session
  if (gmaster%info%usage) then
    ! If e.g. sic -h, disable interactive status. This will avoid launching
    ! the keyboard thread in gmaster_build.
    call set_inter_state(.false.)
  else
    call sense_inter_state
  endif
  if (.not.sic_inter_state(0))  call gmaster_set_disable_gui
  !
  call gmaster_set_ismaster(.true.)  ! Set program as master, Python slave
  call gmaster_build(pack_set,error)
  !
  if (gmaster%info%usage) then
    ! Print usage and leave cleanly. Must come after build (gmaster%id must
    ! have been set)
    call gmaster_usage
    !
  elseif (.not.error) then
    ! Main loop
    call gmaster_enter_loop(gmaster%command_line)
  endif
  !
  call gmaster_clean(error)
  if (error) return
  !
  if (exit_code.ne.0)  call exit(exit_code)  ! EXIT() is GNU and Intel
  !
  call sic_message(seve%t,"gmaster_run","Bye")
  !
end subroutine gmaster_run
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine gmaster_set_exitcode(code)
  use gmaster_private
  !---------------------------------------------------------------------
  ! @ private (should it be public?)
  ! Set the 'exit code' to be issued when leaving
  !---------------------------------------------------------------------
  integer(kind=4), intent(in) :: code
  exit_code = code
end subroutine gmaster_set_exitcode
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine gmaster_set_exitnoprompt(flag)
  use gmaster_private
  !---------------------------------------------------------------------
  ! @ private (should it be public?)
  ! Set the 'exit noprompt' flag
  !---------------------------------------------------------------------
  logical, intent(in) :: flag
  exit_noprompt = flag
end subroutine gmaster_set_exitnoprompt
!
subroutine gmaster_get_exitnoprompt(flag)
  use gmaster_private
  !---------------------------------------------------------------------
  ! @ public
  ! Get the 'exit noprompt' flag. To be called by the exit subroutine of
  ! the program (and their dependent packages) to know if they are
  ! allowed to ask anything at exit time.
  !---------------------------------------------------------------------
  logical, intent(out) :: flag
  flag = exit_noprompt
end subroutine gmaster_get_exitnoprompt

*DECK LA05AD
      SUBROUTINE LA05AD (A, IND, NZ, IA, N, IP, IW, W, G, U)
C***BEGIN PROLOGUE  LA05AD
C***SUBSIDIARY
C***PURPOSE  Subsidiary to DSPLP
C***LIBRARY   SLATEC
C***TYPE      DOUBLE PRECISION (LA05AS-S, LA05AD-D)
C***AUTHOR  (UNKNOWN)
C***DESCRIPTION
C
C     THIS SUBPROGRAM IS A SLIGHT MODIFICATION OF A SUBPROGRAM
C     FROM THE C. 1979 AERE HARWELL LIBRARY.  THE NAME OF THE
C     CORRESPONDING HARWELL CODE CAN BE OBTAINED BY DELETING
C     THE FINAL LETTER =D= IN THE NAMES USED HERE.
C     REVISIONS MADE BY R J HANSON, SNLA, AUGUST, 1979.
C     REVISED SEP. 13, 1979.
C
C     ROYALTIES HAVE BEEN PAID TO AERE-UK FOR USE OF THEIR CODES
C     IN THE PACKAGE GIVEN HERE.  ANY PRIMARY USAGE OF THE HARWELL
C     SUBROUTINES REQUIRES A ROYALTY AGREEMENT AND PAYMENT BETWEEN
C     THE USER AND AERE-UK.  ANY USAGE OF THE SANDIA WRITTEN CODES
C     DSPLP( ) (WHICH USES THE HARWELL SUBROUTINES) IS PERMITTED.
C
C IP(I,1),IP(I,2) POINT TO THE START OF ROW/COL I.
C IW(I,1),IW(I,2) HOLD THE NUMBER OF NON-ZEROS IN ROW/COL I.
C DURING THE MAIN BODY OF THIS SUBROUTINE THE VECTORS IW(.,3),IW(.,5),
C     IW(.,7) ARE USED TO HOLD DOUBLY LINKED LISTS OF ROWS THAT HAVE
C     NOT BEEN PIVOTAL AND HAVE EQUAL NUMBERS OF NON-ZEROS.
C IW(.,4),IW(.,6),IW(.,8) HOLD SIMILAR LISTS FOR THE COLUMNS.
C IW(I,3),IW(I,4) HOLD FIRST ROW/COLUMN TO HAVE I NON-ZEROS
C     OR ZERO IF THERE ARE NONE.
C IW(I,5), IW(I,6) HOLD ROW/COL NUMBER OF ROW/COL PRIOR TO ROW/COL I
C     IN ITS LIST, OR ZERO IF NONE.
C IW(I,7), IW(I,8) HOLD ROW/COL NUMBER OF ROW/COL AFTER ROW/COL I
C     IN ITS LIST, OR ZERO IF NONE.
C FOR ROWS/COLS THAT HAVE BEEN PIVOTAL IW(I,5),IW(I,6) HOLD NEGATION OF
C     POSITION OF ROW/COL I IN THE PIVOTAL ORDERING.
C
C***SEE ALSO  DSPLP
C***ROUTINES CALLED  D1MACH, LA05ED, MC20AD, XERMSG, XSETUN
C***COMMON BLOCKS    LA05DD
C***REVISION HISTORY  (YYMMDD)
C   811215  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890605  Added D1MACH to list of DOUBLE PRECISION variables.
C   890605  Corrected references to XERRWV.  (WRB)
C           (WRB)
C   890831  Modified array declarations.  (WRB)
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900315  CALLs to XERROR changed to CALLs to XERMSG.  (THJ)
C   900402  Added TYPE section.  (WRB)
C   900510  Convert XERRWV calls to XERMSG calls.  (RWC)
C***END PROLOGUE  LA05AD
      INTEGER IP(N,2)
      INTEGER IND(IA,2), IW(N,8)
      DOUBLE PRECISION A(*), AMAX, AU, AM, D1MACH, EPS, G, U, SMALL,
     *                 W(*)
      LOGICAL FIRST
      CHARACTER*8 XERN0, XERN1, XERN2
C
      COMMON /LA05DD/ SMALL, LP, LENL, LENU, NCP, LROW, LCOL
C EPS IS THE RELATIVE ACCURACY OF FLOATING-POINT COMPUTATION
      SAVE EPS, FIRST
      DATA FIRST /.TRUE./
C***FIRST EXECUTABLE STATEMENT  LA05AD
      IF (FIRST) THEN
         EPS = 2.0D0 * D1MACH(4)
      ENDIF
      FIRST = .FALSE.
C
C     SET THE OUTPUT UNIT NUMBER FOR THE ERROR PROCESSOR.
C     THE USAGE OF THIS ERROR PROCESSOR IS DOCUMENTED IN THE
C     SANDIA LABS. TECH. REPT. SAND78-1189, BY R E JONES.
      CALL XSETUN(LP)
      IF (U.GT.1.0D0) U = 1.0D0
      IF (U.LT.EPS) U = EPS
      IF (N.LT.1) GO TO 670
      G = 0.
      DO 50 I=1,N
         W(I) = 0.
         DO 40 J=1,5
            IW(I,J) = 0
   40    CONTINUE
   50 CONTINUE
C
C FLUSH OUT SMALL ENTRIES, COUNT ELEMENTS IN ROWS AND COLUMNS
      L = 1
      LENU = NZ
      DO 80 IDUMMY=1,NZ
         IF (L.GT.LENU) GO TO 90
         DO 60 K=L,LENU
            IF (ABS(A(K)).LE.SMALL) GO TO 70
            I = IND(K,1)
            J = IND(K,2)
            G = MAX(ABS(A(K)),G)
            IF (I.LT.1 .OR. I.GT.N) GO TO 680
            IF (J.LT.1 .OR. J.GT.N) GO TO 680
            IW(I,1) = IW(I,1) + 1
            IW(J,2) = IW(J,2) + 1
   60    CONTINUE
         GO TO 90
   70    L = K
         A(L) = A(LENU)
         IND(L,1) = IND(LENU,1)
         IND(L,2) = IND(LENU,2)
         LENU = LENU - 1
   80 CONTINUE
C
   90 LENL = 0
      LROW = LENU
      LCOL = LROW
C MCP IS THE MAXIMUM NUMBER OF COMPRESSES PERMITTED BEFORE AN
C     ERROR RETURN RESULTS.
      MCP = MAX(N/10,20)
      NCP = 0
C CHECK FOR NULL ROW OR COLUMN AND INITIALIZE IP(I,2) TO POINT
C     JUST BEYOND WHERE THE LAST COMPONENT OF COLUMN I OF A WILL
C     BE STORED.
      K = 1
      DO 110 IR=1,N
         K = K + IW(IR,2)
         IP(IR,2) = K
         DO 100 L=1,2
            IF (IW(IR,L).LE.0) GO TO 700
  100    CONTINUE
  110 CONTINUE
C REORDER BY ROWS
C CHECK FOR DOUBLE ENTRIES WHILE USING THE NEWLY CONSTRUCTED
C     ROW FILE TO CONSTRUCT THE COLUMN FILE. NOTE THAT BY PUTTING
C    THE ENTRIES IN BACKWARDS AND DECREASING IP(J,2) EACH TIME IT
C     IS USED WE AUTOMATICALLY LEAVE IT POINTING TO THE FIRST ELEMENT.
      CALL MC20AD(N, LENU, A, IND(1,2), IP, IND(1,1), 0)
      KL = LENU
      DO 130 II=1,N
         IR = N + 1 - II
         KP = IP(IR,1)
         DO 120 K=KP,KL
            J = IND(K,2)
            IF (IW(J,5).EQ.IR) GO TO 660
            IW(J,5) = IR
            KR = IP(J,2) - 1
            IP(J,2) = KR
            IND(KR,1) = IR
  120    CONTINUE
         KL = KP - 1
  130 CONTINUE
C
C SET UP LINKED LISTS OF ROWS AND COLS WITH EQUAL NUMBERS OF NON-ZEROS.
      DO 150 L=1,2
         DO 140 I=1,N
            NZ = IW(I,L)
            IN = IW(NZ,L+2)
            IW(NZ,L+2) = I
            IW(I,L+6) = IN
            IW(I,L+4) = 0
            IF (IN.NE.0) IW(IN,L+4) = I
  140    CONTINUE
  150 CONTINUE
C
C
C START OF MAIN ELIMINATION LOOP.
      DO 590 IPV=1,N
C FIND PIVOT. JCOST IS MARKOWITZ COST OF CHEAPEST PIVOT FOUND SO FAR,
C     WHICH IS IN ROW IPP AND COLUMN JP.
         JCOST = N*N
C LOOP ON LENGTH OF COLUMN TO BE SEARCHED
         DO 240 NZ=1,N
            IF (JCOST.LE.(NZ-1)**2) GO TO 250
            J = IW(NZ,4)
C SEARCH COLUMNS WITH NZ NON-ZEROS.
            DO 190 IDUMMY=1,N
               IF (J.LE.0) GO TO 200
               KP = IP(J,2)
               KL = KP + IW(J,2) - 1
               DO 180 K=KP,KL
                  I = IND(K,1)
                  KCOST = (NZ-1)*(IW(I,1)-1)
                  IF (KCOST.GE.JCOST) GO TO 180
                  IF (NZ.EQ.1) GO TO 170
C FIND LARGEST ELEMENT IN ROW OF POTENTIAL PIVOT.
                  AMAX = 0.
                  K1 = IP(I,1)
                  K2 = IW(I,1) + K1 - 1
                  DO 160 KK=K1,K2
                     AMAX = MAX(AMAX,ABS(A(KK)))
                     IF (IND(KK,2).EQ.J) KJ = KK
  160             CONTINUE
C PERFORM STABILITY TEST.
                  IF (ABS(A(KJ)).LT.AMAX*U) GO TO 180
  170             JCOST = KCOST
                  IPP = I
                  JP = J
                  IF (JCOST.LE.(NZ-1)**2) GO TO 250
  180          CONTINUE
               J = IW(J,8)
  190       CONTINUE
C SEARCH ROWS WITH NZ NON-ZEROS.
  200       I = IW(NZ,3)
            DO 230 IDUMMY=1,N
               IF (I.LE.0) GO TO 240
               AMAX = 0.
               KP = IP(I,1)
               KL = KP + IW(I,1) - 1
C FIND LARGEST ELEMENT IN THE ROW
               DO 210 K=KP,KL
                  AMAX = MAX(ABS(A(K)),AMAX)
  210          CONTINUE
               AU = AMAX*U
               DO 220 K=KP,KL
C PERFORM STABILITY TEST.
                  IF (ABS(A(K)).LT.AU) GO TO 220
                  J = IND(K,2)
                  KCOST = (NZ-1)*(IW(J,2)-1)
                  IF (KCOST.GE.JCOST) GO TO 220
                  JCOST = KCOST
                  IPP = I
                  JP = J
                  IF (JCOST.LE.(NZ-1)**2) GO TO 250
  220          CONTINUE
               I = IW(I,7)
  230       CONTINUE
  240    CONTINUE
C
C PIVOT FOUND.
C REMOVE ROWS AND COLUMNS INVOLVED IN ELIMINATION FROM ORDERING VECTORS.
  250    KP = IP(JP,2)
         KL = IW(JP,2) + KP - 1
         DO 290 L=1,2
            DO 280 K=KP,KL
               I = IND(K,L)
               IL = IW(I,L+4)
               IN = IW(I,L+6)
               IF (IL.EQ.0) GO TO 260
               IW(IL,L+6) = IN
               GO TO 270
  260          NZ = IW(I,L)
               IW(NZ,L+2) = IN
  270          IF (IN.GT.0) IW(IN,L+4) = IL
  280       CONTINUE
            KP = IP(IPP,1)
            KL = KP + IW(IPP,1) - 1
  290    CONTINUE
C STORE PIVOT
         IW(IPP,5) = -IPV
         IW(JP,6) = -IPV
C ELIMINATE PIVOTAL ROW FROM COLUMN FILE AND FIND PIVOT IN ROW FILE.
         DO 320 K=KP,KL
            J = IND(K,2)
            KPC = IP(J,2)
            IW(J,2) = IW(J,2) - 1
            KLC = KPC + IW(J,2)
            DO 300 KC=KPC,KLC
               IF (IPP.EQ.IND(KC,1)) GO TO 310
  300       CONTINUE
  310       IND(KC,1) = IND(KLC,1)
            IND(KLC,1) = 0
            IF (J.EQ.JP) KR = K
  320    CONTINUE
C BRING PIVOT TO FRONT OF PIVOTAL ROW.
         AU = A(KR)
         A(KR) = A(KP)
         A(KP) = AU
         IND(KR,2) = IND(KP,2)
         IND(KP,2) = JP
C
C PERFORM ELIMINATION ITSELF, LOOPING ON NON-ZEROS IN PIVOT COLUMN.
         NZC = IW(JP,2)
         IF (NZC.EQ.0) GO TO 550
         DO 540 NC=1,NZC
            KC = IP(JP,2) + NC - 1
            IR = IND(KC,1)
C SEARCH NON-PIVOT ROW FOR ELEMENT TO BE ELIMINATED.
            KR = IP(IR,1)
            KRL = KR + IW(IR,1) - 1
            DO 330 KNP=KR,KRL
               IF (JP.EQ.IND(KNP,2)) GO TO 340
  330       CONTINUE
C BRING ELEMENT TO BE ELIMINATED TO FRONT OF ITS ROW.
  340       AM = A(KNP)
            A(KNP) = A(KR)
            A(KR) = AM
            IND(KNP,2) = IND(KR,2)
            IND(KR,2) = JP
            AM = -A(KR)/A(KP)
C COMPRESS ROW FILE UNLESS IT IS CERTAIN THAT THERE IS ROOM FOR NEW ROW.
            IF (LROW+IW(IR,1)+IW(IPP,1)+LENL.LE.IA) GO TO 350
            IF (NCP.GE.MCP .OR. LENU+IW(IR,1)+IW(IPP,1)+LENL.GT.IA) GO
     *       TO 710
            CALL LA05ED(A, IND(1,2), IP, N, IW, IA, .TRUE.)
            KP = IP(IPP,1)
            KR = IP(IR,1)
  350       KRL = KR + IW(IR,1) - 1
            KQ = KP + 1
            KPL = KP + IW(IPP,1) - 1
C PLACE PIVOT ROW (EXCLUDING PIVOT ITSELF) IN W.
            IF (KQ.GT.KPL) GO TO 370
            DO 360 K=KQ,KPL
               J = IND(K,2)
               W(J) = A(K)
  360       CONTINUE
  370       IP(IR,1) = LROW + 1
C
C TRANSFER MODIFIED ELEMENTS.
            IND(KR,2) = 0
            KR = KR + 1
            IF (KR.GT.KRL) GO TO 430
            DO 420 KS=KR,KRL
               J = IND(KS,2)
               AU = A(KS) + AM*W(J)
               IND(KS,2) = 0
C IF ELEMENT IS VERY SMALL REMOVE IT FROM U.
               IF (ABS(AU).LE.SMALL) GO TO 380
               G = MAX(G,ABS(AU))
               LROW = LROW + 1
               A(LROW) = AU
               IND(LROW,2) = J
               GO TO 410
  380          LENU = LENU - 1
C REMOVE ELEMENT FROM COL FILE.
               K = IP(J,2)
               KL = K + IW(J,2) - 1
               IW(J,2) = KL - K
               DO 390 KK=K,KL
                  IF (IND(KK,1).EQ.IR) GO TO 400
  390          CONTINUE
  400          IND(KK,1) = IND(KL,1)
               IND(KL,1) = 0
  410          W(J) = 0.
  420       CONTINUE
C
C SCAN PIVOT ROW FOR FILLS.
  430       IF (KQ.GT.KPL) GO TO 520
            DO 510 KS=KQ,KPL
               J = IND(KS,2)
               AU = AM*W(J)
               IF (ABS(AU).LE.SMALL) GO TO 500
               LROW = LROW + 1
               A(LROW) = AU
               IND(LROW,2) = J
               LENU = LENU + 1
C
C CREATE FILL IN COLUMN FILE.
               NZ = IW(J,2)
               K = IP(J,2)
               KL = K + NZ - 1
               IF (NZ .EQ. 0) GO TO 460
C IF POSSIBLE PLACE NEW ELEMENT AT END OF PRESENT ENTRY.
               IF (KL.NE.LCOL) GO TO 440
               IF (LCOL+LENL.GE.IA) GO TO 460
               LCOL = LCOL + 1
               GO TO 450
  440          IF (IND(KL+1,1).NE.0) GO TO 460
  450          IND(KL+1,1) = IR
               GO TO 490
C NEW ENTRY HAS TO BE CREATED.
  460          IF (LCOL+LENL+NZ+1.LT.IA) GO TO 470
C COMPRESS COLUMN FILE IF THERE IS NOT ROOM FOR NEW ENTRY.
               IF (NCP.GE.MCP .OR. LENU+LENL+NZ+1.GE.IA) GO TO 710
               CALL LA05ED(A, IND, IP(1,2), N, IW(1,2), IA, .FALSE.)
               K = IP(J,2)
               KL = K + NZ - 1
C TRANSFER OLD ENTRY INTO NEW.
  470          IP(J,2) = LCOL + 1
               IF (KL .LT. K) GO TO 485
               DO 480 KK=K,KL
                  LCOL = LCOL + 1
                  IND(LCOL,1) = IND(KK,1)
                  IND(KK,1) = 0
  480          CONTINUE
  485          CONTINUE
C ADD NEW ELEMENT.
               LCOL = LCOL + 1
               IND(LCOL,1) = IR
  490          G = MAX(G,ABS(AU))
               IW(J,2) = NZ + 1
  500          W(J) = 0.
  510       CONTINUE
  520       IW(IR,1) = LROW + 1 - IP(IR,1)
C
C STORE MULTIPLIER
            IF (LENL+LCOL+1.LE.IA) GO TO 530
C COMPRESS COL FILE IF NECESSARY.
            IF (NCP.GE.MCP) GO TO 710
            CALL LA05ED(A, IND, IP(1,2), N, IW(1,2), IA, .FALSE.)
  530       K = IA - LENL
            LENL = LENL + 1
            A(K) = AM
            IND(K,1) = IPP
            IND(K,2) = IR
            LENU = LENU - 1
  540    CONTINUE
C
C INSERT ROWS AND COLUMNS INVOLVED IN ELIMINATION IN LINKED LISTS
C     OF EQUAL NUMBERS OF NON-ZEROS.
  550    K1 = IP(JP,2)
         K2 = IW(JP,2) + K1 - 1
         IW(JP,2) = 0
         DO 580 L=1,2
            IF (K2.LT.K1) GO TO 570
            DO 560 K=K1,K2
               IR = IND(K,L)
               IF (L.EQ.1) IND(K,L) = 0
               NZ = IW(IR,L)
               IF (NZ.LE.0) GO TO 720
               IN = IW(NZ,L+2)
               IW(IR,L+6) = IN
               IW(IR,L+4) = 0
               IW(NZ,L+2) = IR
               IF (IN.NE.0) IW(IN,L+4) = IR
  560       CONTINUE
  570       K1 = IP(IPP,1) + 1
            K2 = IW(IPP,1) + K1 - 2
  580    CONTINUE
  590 CONTINUE
C
C RESET COLUMN FILE TO REFER TO U AND STORE ROW/COL NUMBERS IN
C     PIVOTAL ORDER IN IW(.,3),IW(.,4)
      DO 600 I=1,N
         J = -IW(I,5)
         IW(J,3) = I
         J = -IW(I,6)
         IW(J,4) = I
         IW(I,2) = 0
  600 CONTINUE
      DO 620 I=1,N
         KP = IP(I,1)
         KL = IW(I,1) + KP - 1
         DO 610 K=KP,KL
            J = IND(K,2)
            IW(J,2) = IW(J,2) + 1
  610    CONTINUE
  620 CONTINUE
      K = 1
      DO 630 I=1,N
         K = K + IW(I,2)
         IP(I,2) = K
  630 CONTINUE
      LCOL = K - 1
      DO 650 II=1,N
         I = IW(II,3)
         KP = IP(I,1)
         KL = IW(I,1) + KP - 1
         DO 640 K=KP,KL
            J = IND(K,2)
            KN = IP(J,2) - 1
            IP(J,2) = KN
            IND(KN,1) = I
  640    CONTINUE
  650 CONTINUE
      RETURN
C
C     THE FOLLOWING INSTRUCTIONS IMPLEMENT THE FAILURE EXITS.
C
  660 IF (LP.GT.0) THEN
         WRITE (XERN1, '(I8)') IR
         WRITE (XERN2, '(I8)') J
         CALL XERMSG ('SLATEC', 'LA05AD', 'MORE THAN ONE MATRIX ' //
     *      'ENTRY.  HERE ROW = ' // XERN1 // ' AND COL = ' // XERN2,
     *      -4, 1)
      ENDIF
      G = -4.
      RETURN
C
  670 IF (LP.GT.0) CALL XERMSG ('SLATEC', 'LA05AD',
     *   'THE ORDER OF THE SYSTEM, N, IS NOT POSITIVE.', -1, 1)
      G = -1.0D0
      RETURN
C
  680 IF (LP.GT.0) THEN
         WRITE (XERN0, '(I8)') K
         WRITE (XERN1, '(I8)') I
         WRITE (XERN2, '(I8)') J
         CALL XERMSG ('SLATEC', 'LA05AD', 'ELEMENT K = ' // XERN0 //
     *      ' IS OUT OF BOUNDS.$$HERE ROW = ' // XERN1 //
     *      ' AND COL = ' // XERN2, -3, 1)
      ENDIF
      G = -3.
      RETURN
C
  700 IF (LP.GT.0) THEN
         WRITE (XERN1, '(I8)') L
         CALL XERMSG ('SLATEC', 'LA05AD', 'ROW OR COLUMN HAS NO ' //
     *      'ELEMENTS.  HERE INDEX = ' // XERN1, -2, 1)
      ENDIF
      G = -2.
      RETURN
C
  710 IF (LP.GT.0) CALL XERMSG ('SLATEC', 'LA05AD',
     *   'LENGTHS OF ARRAYS A(*) AND IND(*,2) ARE TOO SMALL.', -7, 1)
      G = -7.
      RETURN
C
  720 IPV = IPV + 1
      IW(IPV,1) = IR
      DO 730 I=1,N
         II = -IW(I,L+4)
         IF (II.GT.0) IW(II,1) = I
  730 CONTINUE
C
      IF (LP.GT.0) THEN
         XERN1 = 'ROWS'
         IF (L.EQ.2) XERN1 = 'COLUMNS'
         CALL XERMSG ('SLATEC', 'LA05AD', 'DEPENDANT ' // XERN1, -5, 1)
C
  740    WRITE (XERN1, '(I8)') IW(I,1)
         XERN2 = ' '
         IF (I+1.LE.IPV) WRITE (XERN2, '(I8)') IW(I+1,1)
         CALL XERMSG ('SLATEC', 'LA05AD',
     *      'DEPENDENT VECTOR INDICES ARE ' // XERN1 // ' AND ' //
     *      XERN2, -5, 1)
         I = I + 2
         IF (I.LE.IPV) GO TO 740
      ENDIF
      G = -5.
      RETURN
      END
*DECK LA05AS
      SUBROUTINE LA05AS (A, IND, NZ, IA, N, IP, IW, W, G, U)
C***BEGIN PROLOGUE  LA05AS
C***SUBSIDIARY
C***PURPOSE  Subsidiary to SPLP
C***LIBRARY   SLATEC
C***TYPE      SINGLE PRECISION (LA05AS-S, LA05AD-D)
C***AUTHOR  (UNKNOWN)
C***DESCRIPTION
C
C     THIS SUBPROGRAM IS A SLIGHT MODIFICATION OF A SUBPROGRAM
C     FROM THE C. 1979 AERE HARWELL LIBRARY.  THE NAME OF THE
C     CORRESPONDING HARWELL CODE CAN BE OBTAINED BY DELETING
C     THE FINAL LETTER =S= IN THE NAMES USED HERE.
C     REVISIONS MADE BY R J HANSON, SNLA, AUGUST, 1979.
C     REVISED SEP. 13, 1979.
C
C     ROYALTIES HAVE BEEN PAID TO AERE-UK FOR USE OF THEIR CODES
C     IN THE PACKAGE GIVEN HERE.  ANY PRIMARY USAGE OF THE HARWELL
C     SUBROUTINES REQUIRES A ROYALTY AGREEMENT AND PAYMENT BETWEEN
C     THE USER AND AERE-UK.  ANY USAGE OF THE SANDIA WRITTEN CODES
C     SPLP( ) (WHICH USES THE HARWELL SUBROUTINES) IS PERMITTED.
C
C IP(I,1),IP(I,2) POINT TO THE START OF ROW/COL I.
C IW(I,1),IW(I,2) HOLD THE NUMBER OF NON-ZEROS IN ROW/COL I.
C DURING THE MAIN BODY OF THIS SUBROUTINE THE VECTORS IW(.,3),IW(.,5),
C     IW(.,7) ARE USED TO HOLD DOUBLY LINKED LISTS OF ROWS THAT HAVE
C     NOT BEEN PIVOTAL AND HAVE EQUAL NUMBERS OF NON-ZEROS.
C IW(.,4),IW(.,6),IW(.,8) HOLD SIMILAR LISTS FOR THE COLUMNS.
C IW(I,3),IW(I,4) HOLD FIRST ROW/COLUMN TO HAVE I NON-ZEROS
C     OR ZERO IF THERE ARE NONE.
C IW(I,5), IW(I,6) HOLD ROW/COL NUMBER OF ROW/COL PRIOR TO ROW/COL I
C     IN ITS LIST, OR ZERO IF NONE.
C IW(I,7), IW(I,8) HOLD ROW/COL NUMBER OF ROW/COL AFTER ROW/COL I
C     IN ITS LIST, OR ZERO IF NONE.
C FOR ROWS/COLS THAT HAVE BEEN PIVOTAL IW(I,5),IW(I,6) HOLD NEGATION OF
C     POSITION OF ROW/COL I IN THE PIVOTAL ORDERING.
C
C***SEE ALSO  SPLP
C***ROUTINES CALLED  LA05ES, MC20AS, R1MACH, XERMSG, XSETUN
C***COMMON BLOCKS    LA05DS
C***REVISION HISTORY  (YYMMDD)
C   811215  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890605  Corrected references to XERRWV.  (WRB)
C   890831  Modified array declarations.  (WRB)
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900315  CALLs to XERROR changed to CALLs to XERMSG.  (THJ)
C   900402  Added TYPE section.  (WRB)
C   900510  Convert XERRWV calls to XERMSG calls.  (RWC)
C***END PROLOGUE  LA05AS
      INTEGER IP(N,2)
      INTEGER IND(IA,2), IW(N,8)
      REAL A(*), AMAX, AU, AM, G, U, SMALL, W(*)
      LOGICAL FIRST
      CHARACTER*8 XERN0, XERN1, XERN2
C
      COMMON /LA05DS/ SMALL, LP, LENL, LENU, NCP, LROW, LCOL
C EPS IS THE RELATIVE ACCURACY OF FLOATING-POINT COMPUTATION
      SAVE EPS, FIRST
      DATA FIRST /.TRUE./
C***FIRST EXECUTABLE STATEMENT  LA05AS
      IF (FIRST) THEN
         EPS = 2.0E0 * R1MACH(4)
      ENDIF
      FIRST = .FALSE.
C
C     SET THE OUTPUT UNIT NUMBER FOR THE ERROR PROCESSOR.
C     THE USAGE OF THIS ERROR PROCESSOR IS DOCUMENTED IN THE
C     SANDIA LABS. TECH. REPT. SAND78-1189, BY R E JONES.
      CALL XSETUN(LP)
      IF (U.GT.1.0E0) U = 1.0E0
      IF (U.LT.EPS) U = EPS
      IF (N.LT.1) GO TO 670
      G = 0.
      DO 50 I=1,N
         W(I) = 0.
         DO 40 J=1,5
            IW(I,J) = 0
   40    CONTINUE
   50 CONTINUE
C
C FLUSH OUT SMALL ENTRIES, COUNT ELEMENTS IN ROWS AND COLUMNS
      L = 1
      LENU = NZ
      DO 80 IDUMMY=1,NZ
         IF (L.GT.LENU) GO TO 90
         DO 60 K=L,LENU
            IF (ABS(A(K)).LE.SMALL) GO TO 70
            I = IND(K,1)
            J = IND(K,2)
            G = MAX(ABS(A(K)),G)
            IF (I.LT.1 .OR. I.GT.N) GO TO 680
            IF (J.LT.1 .OR. J.GT.N) GO TO 680
            IW(I,1) = IW(I,1) + 1
            IW(J,2) = IW(J,2) + 1
   60    CONTINUE
         GO TO 90
   70    L = K
         A(L) = A(LENU)
         IND(L,1) = IND(LENU,1)
         IND(L,2) = IND(LENU,2)
         LENU = LENU - 1
   80 CONTINUE
C
   90 LENL = 0
      LROW = LENU
      LCOL = LROW
C MCP IS THE MAXIMUM NUMBER OF COMPRESSES PERMITTED BEFORE AN
C     ERROR RETURN RESULTS.
      MCP = MAX(N/10,20)
      NCP = 0
C CHECK FOR NULL ROW OR COLUMN AND INITIALIZE IP(I,2) TO POINT
C     JUST BEYOND WHERE THE LAST COMPONENT OF COLUMN I OF A WILL
C     BE STORED.
      K = 1
      DO 110 IR=1,N
         K = K + IW(IR,2)
         IP(IR,2) = K
         DO 100 L=1,2
            IF (IW(IR,L).LE.0) GO TO 700
  100    CONTINUE
  110 CONTINUE
C REORDER BY ROWS
C CHECK FOR DOUBLE ENTRIES WHILE USING THE NEWLY CONSTRUCTED
C     ROW FILE TO CONSTRUCT THE COLUMN FILE. NOTE THAT BY PUTTING
C    THE ENTRIES IN BACKWARDS AND DECREASING IP(J,2) EACH TIME IT
C     IS USED WE AUTOMATICALLY LEAVE IT POINTING TO THE FIRST ELEMENT.
      CALL MC20AS(N, LENU, A, IND(1,2), IP, IND(1,1), 0)
      KL = LENU
      DO 130 II=1,N
         IR = N + 1 - II
         KP = IP(IR,1)
         DO 120 K=KP,KL
            J = IND(K,2)
            IF (IW(J,5).EQ.IR) GO TO 660
            IW(J,5) = IR
            KR = IP(J,2) - 1
            IP(J,2) = KR
            IND(KR,1) = IR
  120    CONTINUE
         KL = KP - 1
  130 CONTINUE
C
C SET UP LINKED LISTS OF ROWS AND COLS WITH EQUAL NUMBERS OF NON-ZEROS.
      DO 150 L=1,2
         DO 140 I=1,N
            NZ = IW(I,L)
            IN = IW(NZ,L+2)
            IW(NZ,L+2) = I
            IW(I,L+6) = IN
            IW(I,L+4) = 0
            IF (IN.NE.0) IW(IN,L+4) = I
  140    CONTINUE
  150 CONTINUE
C
C
C START OF MAIN ELIMINATION LOOP.
      DO 590 IPV=1,N
C FIND PIVOT. JCOST IS MARKOWITZ COST OF CHEAPEST PIVOT FOUND SO FAR,
C     WHICH IS IN ROW IPP AND COLUMN JP.
         JCOST = N*N
C LOOP ON LENGTH OF COLUMN TO BE SEARCHED
         DO 240 NZ=1,N
            IF (JCOST.LE.(NZ-1)**2) GO TO 250
            J = IW(NZ,4)
C SEARCH COLUMNS WITH NZ NON-ZEROS.
            DO 190 IDUMMY=1,N
               IF (J.LE.0) GO TO 200
               KP = IP(J,2)
               KL = KP + IW(J,2) - 1
               DO 180 K=KP,KL
                  I = IND(K,1)
                  KCOST = (NZ-1)*(IW(I,1)-1)
                  IF (KCOST.GE.JCOST) GO TO 180
                  IF (NZ.EQ.1) GO TO 170
C FIND LARGEST ELEMENT IN ROW OF POTENTIAL PIVOT.
                  AMAX = 0.
                  K1 = IP(I,1)
                  K2 = IW(I,1) + K1 - 1
                  DO 160 KK=K1,K2
                     AMAX = MAX(AMAX,ABS(A(KK)))
                     IF (IND(KK,2).EQ.J) KJ = KK
  160             CONTINUE
C PERFORM STABILITY TEST.
                  IF (ABS(A(KJ)).LT.AMAX*U) GO TO 180
  170             JCOST = KCOST
                  IPP = I
                  JP = J
                  IF (JCOST.LE.(NZ-1)**2) GO TO 250
  180          CONTINUE
               J = IW(J,8)
  190       CONTINUE
C SEARCH ROWS WITH NZ NON-ZEROS.
  200       I = IW(NZ,3)
            DO 230 IDUMMY=1,N
               IF (I.LE.0) GO TO 240
               AMAX = 0.
               KP = IP(I,1)
               KL = KP + IW(I,1) - 1
C FIND LARGEST ELEMENT IN THE ROW
               DO 210 K=KP,KL
                  AMAX = MAX(ABS(A(K)),AMAX)
  210          CONTINUE
               AU = AMAX*U
               DO 220 K=KP,KL
C PERFORM STABILITY TEST.
                  IF (ABS(A(K)).LT.AU) GO TO 220
                  J = IND(K,2)
                  KCOST = (NZ-1)*(IW(J,2)-1)
                  IF (KCOST.GE.JCOST) GO TO 220
                  JCOST = KCOST
                  IPP = I
                  JP = J
                  IF (JCOST.LE.(NZ-1)**2) GO TO 250
  220          CONTINUE
               I = IW(I,7)
  230       CONTINUE
  240    CONTINUE
C
C PIVOT FOUND.
C REMOVE ROWS AND COLUMNS INVOLVED IN ELIMINATION FROM ORDERING VECTORS.
  250    KP = IP(JP,2)
         KL = IW(JP,2) + KP - 1
         DO 290 L=1,2
            DO 280 K=KP,KL
               I = IND(K,L)
               IL = IW(I,L+4)
               IN = IW(I,L+6)
               IF (IL.EQ.0) GO TO 260
               IW(IL,L+6) = IN
               GO TO 270
  260          NZ = IW(I,L)
               IW(NZ,L+2) = IN
  270          IF (IN.GT.0) IW(IN,L+4) = IL
  280       CONTINUE
            KP = IP(IPP,1)
            KL = KP + IW(IPP,1) - 1
  290    CONTINUE
C STORE PIVOT
         IW(IPP,5) = -IPV
         IW(JP,6) = -IPV
C ELIMINATE PIVOTAL ROW FROM COLUMN FILE AND FIND PIVOT IN ROW FILE.
         DO 320 K=KP,KL
            J = IND(K,2)
            KPC = IP(J,2)
            IW(J,2) = IW(J,2) - 1
            KLC = KPC + IW(J,2)
            DO 300 KC=KPC,KLC
               IF (IPP.EQ.IND(KC,1)) GO TO 310
  300       CONTINUE
  310       IND(KC,1) = IND(KLC,1)
            IND(KLC,1) = 0
            IF (J.EQ.JP) KR = K
  320    CONTINUE
C BRING PIVOT TO FRONT OF PIVOTAL ROW.
         AU = A(KR)
         A(KR) = A(KP)
         A(KP) = AU
         IND(KR,2) = IND(KP,2)
         IND(KP,2) = JP
C
C PERFORM ELIMINATION ITSELF, LOOPING ON NON-ZEROS IN PIVOT COLUMN.
         NZC = IW(JP,2)
         IF (NZC.EQ.0) GO TO 550
         DO 540 NC=1,NZC
            KC = IP(JP,2) + NC - 1
            IR = IND(KC,1)
C SEARCH NON-PIVOT ROW FOR ELEMENT TO BE ELIMINATED.
            KR = IP(IR,1)
            KRL = KR + IW(IR,1) - 1
            DO 330 KNP=KR,KRL
               IF (JP.EQ.IND(KNP,2)) GO TO 340
  330       CONTINUE
C BRING ELEMENT TO BE ELIMINATED TO FRONT OF ITS ROW.
  340       AM = A(KNP)
            A(KNP) = A(KR)
            A(KR) = AM
            IND(KNP,2) = IND(KR,2)
            IND(KR,2) = JP
            AM = -A(KR)/A(KP)
C COMPRESS ROW FILE UNLESS IT IS CERTAIN THAT THERE IS ROOM FOR NEW ROW.
            IF (LROW+IW(IR,1)+IW(IPP,1)+LENL.LE.IA) GO TO 350
            IF (NCP.GE.MCP .OR. LENU+IW(IR,1)+IW(IPP,1)+LENL.GT.IA) GO
     *       TO 710
            CALL LA05ES(A, IND(1,2), IP, N, IW, IA, .TRUE.)
            KP = IP(IPP,1)
            KR = IP(IR,1)
  350       KRL = KR + IW(IR,1) - 1
            KQ = KP + 1
            KPL = KP + IW(IPP,1) - 1
C PLACE PIVOT ROW (EXCLUDING PIVOT ITSELF) IN W.
            IF (KQ.GT.KPL) GO TO 370
            DO 360 K=KQ,KPL
               J = IND(K,2)
               W(J) = A(K)
  360       CONTINUE
  370       IP(IR,1) = LROW + 1
C
C TRANSFER MODIFIED ELEMENTS.
            IND(KR,2) = 0
            KR = KR + 1
            IF (KR.GT.KRL) GO TO 430
            DO 420 KS=KR,KRL
               J = IND(KS,2)
               AU = A(KS) + AM*W(J)
               IND(KS,2) = 0
C IF ELEMENT IS VERY SMALL REMOVE IT FROM U.
               IF (ABS(AU).LE.SMALL) GO TO 380
               G = MAX(G,ABS(AU))
               LROW = LROW + 1
               A(LROW) = AU
               IND(LROW,2) = J
               GO TO 410
  380          LENU = LENU - 1
C REMOVE ELEMENT FROM COL FILE.
               K = IP(J,2)
               KL = K + IW(J,2) - 1
               IW(J,2) = KL - K
               DO 390 KK=K,KL
                  IF (IND(KK,1).EQ.IR) GO TO 400
  390          CONTINUE
  400          IND(KK,1) = IND(KL,1)
               IND(KL,1) = 0
  410          W(J) = 0.
  420       CONTINUE
C
C SCAN PIVOT ROW FOR FILLS.
  430       IF (KQ.GT.KPL) GO TO 520
            DO 510 KS=KQ,KPL
               J = IND(KS,2)
               AU = AM*W(J)
               IF (ABS(AU).LE.SMALL) GO TO 500
               LROW = LROW + 1
               A(LROW) = AU
               IND(LROW,2) = J
               LENU = LENU + 1
C
C CREATE FILL IN COLUMN FILE.
               NZ = IW(J,2)
               K = IP(J,2)
               KL = K + NZ - 1
               IF (NZ .EQ. 0) GO TO 460
C IF POSSIBLE PLACE NEW ELEMENT AT END OF PRESENT ENTRY.
               IF (KL.NE.LCOL) GO TO 440
               IF (LCOL+LENL.GE.IA) GO TO 460
               LCOL = LCOL + 1
               GO TO 450
  440          IF (IND(KL+1,1).NE.0) GO TO 460
  450          IND(KL+1,1) = IR
               GO TO 490
C NEW ENTRY HAS TO BE CREATED.
  460          IF (LCOL+LENL+NZ+1.LT.IA) GO TO 470
C COMPRESS COLUMN FILE IF THERE IS NOT ROOM FOR NEW ENTRY.
               IF (NCP.GE.MCP .OR. LENU+LENL+NZ+1.GE.IA) GO TO 710
               CALL LA05ES(A, IND, IP(1,2), N, IW(1,2), IA, .FALSE.)
               K = IP(J,2)
               KL = K + NZ - 1
C TRANSFER OLD ENTRY INTO NEW.
  470          IP(J,2) = LCOL + 1
               IF (KL .LT. K) GO TO 485
               DO 480 KK=K,KL
                  LCOL = LCOL + 1
                  IND(LCOL,1) = IND(KK,1)
                  IND(KK,1) = 0
  480          CONTINUE
  485          CONTINUE
C ADD NEW ELEMENT.
               LCOL = LCOL + 1
               IND(LCOL,1) = IR
  490          G = MAX(G,ABS(AU))
               IW(J,2) = NZ + 1
  500          W(J) = 0.
  510       CONTINUE
  520       IW(IR,1) = LROW + 1 - IP(IR,1)
C
C STORE MULTIPLIER
            IF (LENL+LCOL+1.LE.IA) GO TO 530
C COMPRESS COL FILE IF NECESSARY.
            IF (NCP.GE.MCP) GO TO 710
            CALL LA05ES(A, IND, IP(1,2), N, IW(1,2), IA, .FALSE.)
  530       K = IA - LENL
            LENL = LENL + 1
            A(K) = AM
            IND(K,1) = IPP
            IND(K,2) = IR
            LENU = LENU - 1
  540    CONTINUE
C
C INSERT ROWS AND COLUMNS INVOLVED IN ELIMINATION IN LINKED LISTS
C     OF EQUAL NUMBERS OF NON-ZEROS.
  550    K1 = IP(JP,2)
         K2 = IW(JP,2) + K1 - 1
         IW(JP,2) = 0
         DO 580 L=1,2
            IF (K2.LT.K1) GO TO 570
            DO 560 K=K1,K2
               IR = IND(K,L)
               IF (L.EQ.1) IND(K,L) = 0
               NZ = IW(IR,L)
               IF (NZ.LE.0) GO TO 720
               IN = IW(NZ,L+2)
               IW(IR,L+6) = IN
               IW(IR,L+4) = 0
               IW(NZ,L+2) = IR
               IF (IN.NE.0) IW(IN,L+4) = IR
  560       CONTINUE
  570       K1 = IP(IPP,1) + 1
            K2 = IW(IPP,1) + K1 - 2
  580    CONTINUE
  590 CONTINUE
C
C RESET COLUMN FILE TO REFER TO U AND STORE ROW/COL NUMBERS IN
C     PIVOTAL ORDER IN IW(.,3),IW(.,4)
      DO 600 I=1,N
         J = -IW(I,5)
         IW(J,3) = I
         J = -IW(I,6)
         IW(J,4) = I
         IW(I,2) = 0
  600 CONTINUE
      DO 620 I=1,N
         KP = IP(I,1)
         KL = IW(I,1) + KP - 1
         DO 610 K=KP,KL
            J = IND(K,2)
            IW(J,2) = IW(J,2) + 1
  610    CONTINUE
  620 CONTINUE
      K = 1
      DO 630 I=1,N
         K = K + IW(I,2)
         IP(I,2) = K
  630 CONTINUE
      LCOL = K - 1
      DO 650 II=1,N
         I = IW(II,3)
         KP = IP(I,1)
         KL = IW(I,1) + KP - 1
         DO 640 K=KP,KL
            J = IND(K,2)
            KN = IP(J,2) - 1
            IP(J,2) = KN
            IND(KN,1) = I
  640    CONTINUE
  650 CONTINUE
      RETURN
C
C     THE FOLLOWING INSTRUCTIONS IMPLEMENT THE FAILURE EXITS.
C
  660 IF (LP.GT.0) THEN
         WRITE (XERN1, '(I8)') IR
         WRITE (XERN2, '(I8)') J
         CALL XERMSG ('SLATEC', 'LA05AS', 'MORE THAN ONE MATRIX ' //
     *      'ENTRY.  HERE ROW = ' // XERN1 // ' AND COL = ' // XERN2,
     *      -4, 1)
      ENDIF
      G = -4.
      RETURN
C
  670 IF (LP.GT.0) CALL XERMSG ('SLATEC', 'LA05AS',
     *   'THE ORDER OF THE SYSTEM, N, IS NOT POSITIVE.', -1, 1)
      G = -1.0E0
      RETURN
C
  680 IF (LP.GT.0) THEN
         WRITE (XERN0, '(I8)') K
         WRITE (XERN1, '(I8)') I
         WRITE (XERN2, '(I8)') J
         CALL XERMSG ('SLATEC', 'LA05AS', 'ELEMENT K = ' // XERN0 //
     *      ' IS OUT OF BOUNDS.$$HERE ROW = ' // XERN1 //
     *      ' AND COL = ' // XERN2, -3, 1)
      ENDIF
      G = -3.
      RETURN
C
  700 IF (LP.GT.0) THEN
         WRITE (XERN1, '(I8)') L
         CALL XERMSG ('SLATEC', 'LA05AS', 'ROW OR COLUMN HAS NO ' //
     *      'ELEMENTS.  HERE INDEX = ' // XERN1, -2, 1)
      ENDIF
      G = -2.
      RETURN
C
  710 IF (LP.GT.0) CALL XERMSG ('SLATEC', 'LA05AS',
     *   'LENGTHS OF ARRAYS A(*) AND IND(*,2) ARE TOO SMALL.', -7, 1)
      G = -7.
      RETURN
C
  720 IPV = IPV + 1
      IW(IPV,1) = IR
      DO 730 I=1,N
         II = -IW(I,L+4)
         IF (II.GT.0) IW(II,1) = I
  730 CONTINUE
C
      IF (LP.GT.0) THEN
         XERN1 = 'ROWS'
         IF (L.EQ.2) XERN1 = 'COLUMNS'
         CALL XERMSG ('SLATEC', 'LA05AS', 'DEPENDANT ' // XERN1, -5, 1)
C
  740    WRITE (XERN1, '(I8)') IW(I,1)
         XERN2 = ' '
         IF (I+1.LE.IPV) WRITE (XERN2, '(I8)') IW(I+1,1)
         CALL XERMSG ('SLATEC', 'LA05AS',
     *      'DEPENDENT VECTOR INDICES ARE ' // XERN1 // ' AND ' //
     *      XERN2, -5, 1)
         I = I + 2
         IF (I.LE.IPV) GO TO 740
      ENDIF
      G = -5.
      RETURN
      END
*DECK LA05BD
      SUBROUTINE LA05BD (A, IND, IA, N, IP, IW, W, G, B, TRANS)
C***BEGIN PROLOGUE  LA05BD
C***SUBSIDIARY
C***PURPOSE  Subsidiary to DSPLP
C***LIBRARY   SLATEC
C***TYPE      DOUBLE PRECISION (LA05BS-S, LA05BD-D)
C***AUTHOR  (UNKNOWN)
C***DESCRIPTION
C
C     THIS SUBPROGRAM IS A SLIGHT MODIFICATION OF A SUBPROGRAM
C     FROM THE C. 1979 AERE HARWELL LIBRARY.  THE NAME OF THE
C     CORRESPONDING HARWELL CODE CAN BE OBTAINED BY DELETING
C     THE FINAL LETTER =D= IN THE NAMES USED HERE.
C     REVISED SEP. 13, 1979.
C
C     ROYALTIES HAVE BEEN PAID TO AERE-UK FOR USE OF THEIR CODES
C     IN THE PACKAGE GIVEN HERE.  ANY PRIMARY USAGE OF THE HARWELL
C     SUBROUTINES REQUIRES A ROYALTY AGREEMENT AND PAYMENT BETWEEN
C     THE USER AND AERE-UK.  ANY USAGE OF THE SANDIA WRITTEN CODES
C     DSPLP( ) (WHICH USES THE HARWELL SUBROUTINES) IS PERMITTED.
C
C IP(I,1),IP(I,2) POINT TO START OF ROW/COLUMN I OF U.
C IW(I,1),IW(I,2) ARE LENGTHS OF ROW/COL I OF U.
C IW(.,3),IW(.,4) HOLD ROW/COL NUMBERS IN PIVOTAL ORDER.
C
C***SEE ALSO  DSPLP
C***ROUTINES CALLED  XERMSG, XSETUN
C***COMMON BLOCKS    LA05DD
C***REVISION HISTORY  (YYMMDD)
C   811215  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890831  Modified array declarations.  (WRB)
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900315  CALLs to XERROR changed to CALLs to XERMSG.  (THJ)
C   900402  Added TYPE section.  (WRB)
C   920410  Corrected second dimension on IW declaration.  (WRB)
C***END PROLOGUE  LA05BD
      DOUBLE PRECISION A(*), B(*), AM, W(*), G, SMALL
      LOGICAL TRANS
      INTEGER IND(IA,2), IW(N,8)
      INTEGER IP(N,2)
      COMMON /LA05DD/ SMALL, LP, LENL, LENU, NCP, LROW, LCOL
C***FIRST EXECUTABLE STATEMENT  LA05BD
      IF (G.LT.0.D0) GO TO 130
      KLL = IA - LENL + 1
      IF (TRANS) GO TO 80
C
C     MULTIPLY VECTOR BY INVERSE OF L
      IF (LENL.LE.0) GO TO 20
      L1 = IA + 1
      DO 10 KK=1,LENL
         K = L1 - KK
         I = IND(K,1)
         IF (B(I).EQ.0.D0) GO TO 10
         J = IND(K,2)
         B(J) = B(J) + A(K)*B(I)
   10 CONTINUE
   20 DO 30 I=1,N
         W(I) = B(I)
         B(I) = 0.D0
   30 CONTINUE
C
C     MULTIPLY VECTOR BY INVERSE OF U
      N1 = N + 1
      DO 70 II=1,N
         I = N1 - II
         I = IW(I,3)
         AM = W(I)
         KP = IP(I,1)
         IF (KP.GT.0) GO TO 50
         KP = -KP
         IP(I,1) = KP
         NZ = IW(I,1)
         KL = KP - 1 + NZ
         K2 = KP + 1
         DO 40 K=K2,KL
            J = IND(K,2)
            AM = AM - A(K)*B(J)
   40    CONTINUE
   50    IF (AM.EQ.0.) GO TO 70
         J = IND(KP,2)
         B(J) = AM/A(KP)
         KPC = IP(J,2)
         KL = IW(J,2) + KPC - 1
         IF (KL.EQ.KPC) GO TO 70
         K2 = KPC + 1
         DO 60 K=K2,KL
            I = IND(K,1)
            IP(I,1) = -ABS(IP(I,1))
   60    CONTINUE
   70 CONTINUE
      GO TO 140
C
C     MULTIPLY VECTOR BY INVERSE OF TRANSPOSE OF U
   80 DO 90 I=1,N
         W(I) = B(I)
         B(I) = 0.D0
   90 CONTINUE
      DO 110 II=1,N
         I = IW(II,4)
         AM = W(I)
         IF (AM.EQ.0.D0) GO TO 110
         J = IW(II,3)
         KP = IP(J,1)
         AM = AM/A(KP)
         B(J) = AM
         KL = IW(J,1) + KP - 1
         IF (KP.EQ.KL) GO TO 110
         K2 = KP + 1
         DO 100 K=K2,KL
            I = IND(K,2)
            W(I) = W(I) - AM*A(K)
  100    CONTINUE
  110 CONTINUE
C
C     MULTIPLY VECTOR BY INVERSE OF TRANSPOSE OF L
      IF (KLL.GT.IA) RETURN
      DO 120 K=KLL,IA
         J = IND(K,2)
         IF (B(J).EQ.0.D0) GO TO 120
         I = IND(K,1)
         B(I) = B(I) + A(K)*B(J)
  120 CONTINUE
      GO TO 140
C
  130 CALL XSETUN(LP)
      IF (LP .GT. 0) CALL XERMSG ('SLATEC', 'LA05BD',
     +   'EARLIER ENTRY GAVE ERROR RETURN.', -8, 2)
  140 RETURN
      END
*DECK LA05BS
      SUBROUTINE LA05BS (A, IND, IA, N, IP, IW, W, G, B, TRANS)
C***BEGIN PROLOGUE  LA05BS
C***SUBSIDIARY
C***PURPOSE  Subsidiary to SPLP
C***LIBRARY   SLATEC
C***TYPE      SINGLE PRECISION (LA05BS-S, LA05BD-D)
C***AUTHOR  (UNKNOWN)
C***DESCRIPTION
C
C     THIS SUBPROGRAM IS A SLIGHT MODIFICATION OF A SUBPROGRAM
C     FROM THE C. 1979 AERE HARWELL LIBRARY.  THE NAME OF THE
C     CORRESPONDING HARWELL CODE CAN BE OBTAINED BY DELETING
C     THE FINAL LETTER =S= IN THE NAMES USED HERE.
C     REVISED SEP. 13, 1979.
C
C     ROYALTIES HAVE BEEN PAID TO AERE-UK FOR USE OF THEIR CODES
C     IN THE PACKAGE GIVEN HERE.  ANY PRIMARY USAGE OF THE HARWELL
C     SUBROUTINES REQUIRES A ROYALTY AGREEMENT AND PAYMENT BETWEEN
C     THE USER AND AERE-UK.  ANY USAGE OF THE SANDIA WRITTEN CODES
C     SPLP( ) (WHICH USES THE HARWELL SUBROUTINES) IS PERMITTED.
C
C IP(I,1),IP(I,2) POINT TO START OF ROW/COLUMN I OF U.
C IW(I,1),IW(I,2) ARE LENGTHS OF ROW/COL I OF U.
C IW(.,3),IW(.,4) HOLD ROW/COL NUMBERS IN PIVOTAL ORDER.
C
C***SEE ALSO  SPLP
C***ROUTINES CALLED  XERMSG, XSETUN
C***COMMON BLOCKS    LA05DS
C***REVISION HISTORY  (YYMMDD)
C   811215  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890831  Modified array declarations.  (WRB)
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900315  CALLs to XERROR changed to CALLs to XERMSG.  (THJ)
C   900402  Added TYPE section.  (WRB)
C   920410  Corrected second dimension on IW declaration.  (WRB)
C***END PROLOGUE  LA05BS
      REAL A(IA), B(*), AM, W(*), G, SMALL
      LOGICAL TRANS
      INTEGER IND(IA,2), IW(N,8)
      INTEGER IP(N,2)
      COMMON /LA05DS/ SMALL, LP, LENL, LENU, NCP, LROW, LCOL
C***FIRST EXECUTABLE STATEMENT  LA05BS
      IF (G.LT.0.) GO TO 130
      KLL = IA - LENL + 1
      IF (TRANS) GO TO 80
C
C     MULTIPLY VECTOR BY INVERSE OF L
      IF (LENL.LE.0) GO TO 20
      L1 = IA + 1
      DO 10 KK=1,LENL
         K = L1 - KK
         I = IND(K,1)
         IF (B(I).EQ.0.) GO TO 10
         J = IND(K,2)
         B(J) = B(J) + A(K)*B(I)
   10 CONTINUE
   20 DO 30 I=1,N
         W(I) = B(I)
         B(I) = 0.
   30 CONTINUE
C
C     MULTIPLY VECTOR BY INVERSE OF U
      N1 = N + 1
      DO 70 II=1,N
         I = N1 - II
         I = IW(I,3)
         AM = W(I)
         KP = IP(I,1)
         IF (KP.GT.0) GO TO 50
         KP = -KP
         IP(I,1) = KP
         NZ = IW(I,1)
         KL = KP - 1 + NZ
         K2 = KP + 1
         DO 40 K=K2,KL
            J = IND(K,2)
            AM = AM - A(K)*B(J)
   40    CONTINUE
   50    IF (AM.EQ.0.) GO TO 70
         J = IND(KP,2)
         B(J) = AM/A(KP)
         KPC = IP(J,2)
         KL = IW(J,2) + KPC - 1
         IF (KL.EQ.KPC) GO TO 70
         K2 = KPC + 1
         DO 60 K=K2,KL
            I = IND(K,1)
            IP(I,1) = -ABS(IP(I,1))
   60    CONTINUE
   70 CONTINUE
      GO TO 140
C
C     MULTIPLY VECTOR BY INVERSE OF TRANSPOSE OF U
   80 DO 90 I=1,N
         W(I) = B(I)
         B(I) = 0.
   90 CONTINUE
      DO 110 II=1,N
         I = IW(II,4)
         AM = W(I)
         IF (AM.EQ.0.) GO TO 110
         J = IW(II,3)
         KP = IP(J,1)
         AM = AM/A(KP)
         B(J) = AM
         KL = IW(J,1) + KP - 1
         IF (KP.EQ.KL) GO TO 110
         K2 = KP + 1
         DO 100 K=K2,KL
            I = IND(K,2)
            W(I) = W(I) - AM*A(K)
  100    CONTINUE
  110 CONTINUE
C
C     MULTIPLY VECTOR BY INVERSE OF TRANSPOSE OF L
      IF (KLL.GT.IA) RETURN
      DO 120 K=KLL,IA
         J = IND(K,2)
         IF (B(J).EQ.0.) GO TO 120
         I = IND(K,1)
         B(I) = B(I) + A(K)*B(J)
  120 CONTINUE
      GO TO 140
C
  130 CALL XSETUN(LP)
      IF (LP .GT. 0) CALL XERMSG ('SLATEC', 'LA05BS',
     +   'EARLIER ENTRY GAVE ERROR RETURN.', -8, 2)
  140 RETURN
      END
*DECK LA05CD
      SUBROUTINE LA05CD (A, IND, IA, N, IP, IW, W, G, U, MM)
C***BEGIN PROLOGUE  LA05CD
C***SUBSIDIARY
C***PURPOSE  Subsidiary to DSPLP
C***LIBRARY   SLATEC
C***TYPE      DOUBLE PRECISION (LA05CS-D, LA05CD-D)
C***AUTHOR  (UNKNOWN)
C***DESCRIPTION
C
C     THIS SUBPROGRAM IS A SLIGHT MODIFICATION OF A SUBPROGRAM
C     FROM THE C. 1979 AERE HARWELL LIBRARY.  THE NAME OF THE
C     CORRESPONDING HARWELL CODE CAN BE OBTAINED BY DELETING
C     THE FINAL LETTER =D= IN THE NAMES USED HERE.
C     REVISED SEP. 13, 1979.
C
C     ROYALTIES HAVE BEEN PAID TO AERE-UK FOR USE OF THEIR CODES
C     IN THE PACKAGE GIVEN HERE.  ANY PRIMARY USAGE OF THE HARWELL
C     SUBROUTINES REQUIRES A ROYALTY AGREEMENT AND PAYMENT BETWEEN
C     THE USER AND AERE-UK.  ANY USAGE OF THE SANDIA WRITTEN CODES
C     DSPLP( ) (WHICH USES THE HARWELL SUBROUTINES) IS PERMITTED.
C
C***SEE ALSO  DSPLP
C***ROUTINES CALLED  LA05ED, XERMSG, XSETUN
C***COMMON BLOCKS    LA05DD
C***REVISION HISTORY  (YYMMDD)
C   811215  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890831  Modified array declarations.  (WRB)
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900315  CALLs to XERROR changed to CALLs to XERMSG.  (THJ)
C   900402  Added TYPE section.  (WRB)
C   900510  Convert XERRWV calls to XERMSG calls.  (RWC)
C   920410  Corrected second dimension on IW declaration.  (WRB)
C   920422  Changed upper limit on DO from LAST to LAST-1.  (WRB)
C***END PROLOGUE  LA05CD
      DOUBLE PRECISION A(*), G, U, AM, W(*), SMALL, AU
      INTEGER IND(IA,2), IW(N,8)
      INTEGER IP(N,2)
      CHARACTER*8 XERN1
C
      COMMON /LA05DD/ SMALL, LP, LENL, LENU, NCP, LROW, LCOL
C***FIRST EXECUTABLE STATEMENT  LA05CD
      CALL XSETUN(LP)
      IF (G.LT.0.0D0) GO TO 620
      JM = MM
C MCP LIMITS THE VALUE OF NCP PERMITTED BEFORE AN ERROR RETURN RESULTS.
      MCP = NCP + 20
C REMOVE OLD COLUMN
      LENU = LENU - IW(JM,2)
      KP = IP(JM,2)
      IM = IND(KP,1)
      KL = KP + IW(JM,2) - 1
      IW(JM,2) = 0
      DO 30 K=KP,KL
         I = IND(K,1)
         IND(K,1) = 0
         KR = IP(I,1)
         NZ = IW(I,1) - 1
         IW(I,1) = NZ
         KRL = KR + NZ
         DO 10 KM=KR,KRL
            IF (IND(KM,2).EQ.JM) GO TO 20
   10    CONTINUE
   20    A(KM) = A(KRL)
         IND(KM,2) = IND(KRL,2)
         IND(KRL,2) = 0
   30 CONTINUE
C
C INSERT NEW COLUMN
      DO 110 II=1,N
         I = IW(II,3)
         IF (I.EQ.IM) M = II
         IF (ABS(W(I)).LE.SMALL) GO TO 100
         LENU = LENU + 1
         LAST = II
         IF (LCOL+LENL.LT.IA) GO TO 40
C COMPRESS COLUMN FILE IF NECESSARY.
         IF (NCP.GE.MCP .OR. LENL+LENU.GE.IA) GO TO 610
         CALL LA05ED(A, IND, IP(1,2), N, IW(1,2), IA, .FALSE.)
   40    LCOL = LCOL + 1
         NZ = IW(JM,2)
         IF (NZ.EQ.0) IP(JM,2) = LCOL
         IW(JM,2) = NZ + 1
         IND(LCOL,1) = I
         NZ = IW(I,1)
         KPL = IP(I,1) + NZ
         IF (KPL.GT.LROW) GO TO 50
         IF (IND(KPL,2).EQ.0) GO TO 90
C NEW ENTRY HAS TO BE CREATED.
   50    IF (LENL+LROW+NZ.LT.IA) GO TO 60
         IF (NCP.GE.MCP .OR. LENL+LENU+NZ.GE.IA) GO TO 610
C COMPRESS ROW FILE IF NECESSARY.
         CALL LA05ED(A, IND(1,2), IP, N, IW, IA, .TRUE.)
   60    KP = IP(I,1)
         IP(I,1) = LROW + 1
         IF (NZ.EQ.0) GO TO 80
         KPL = KP + NZ - 1
         DO 70 K=KP,KPL
            LROW = LROW + 1
            A(LROW) = A(K)
            IND(LROW,2) = IND(K,2)
            IND(K,2) = 0
   70    CONTINUE
   80    LROW = LROW + 1
         KPL = LROW
C PLACE NEW ELEMENT AT END OF ROW.
   90    IW(I,1) = NZ + 1
         A(KPL) = W(I)
         IND(KPL,2) = JM
  100    W(I) = 0.0D0
  110 CONTINUE
      IF (IW(IM,1).EQ.0 .OR. IW(JM,2).EQ.0 .OR. M.GT.LAST) GO TO 590
C
C FIND COLUMN SINGLETONS, OTHER THAN THE SPIKE. NON-SINGLETONS ARE
C     MARKED WITH W(J)=1. ONLY IW(.,3) IS REVISED AND IW(.,4) IS USED
C     FOR WORKSPACE.
      INS = M
      M1 = M
      W(JM) = 1.0D0
      DO 140 II=M,LAST
         I = IW(II,3)
         J = IW(II,4)
         IF (W(J).EQ.0.) GO TO 130
         KP = IP(I,1)
         KL = KP + IW(I,1) - 1
         DO 120 K=KP,KL
            J = IND(K,2)
            W(J) = 1.0D0
  120    CONTINUE
         IW(INS,4) = I
         INS = INS + 1
         GO TO 140
C PLACE SINGLETONS IN NEW POSITION.
  130    IW(M1,3) = I
         M1 = M1 + 1
  140 CONTINUE
C PLACE NON-SINGLETONS IN NEW POSITION.
      IJ = M + 1
      DO 150 II=M1,LAST-1
         IW(II,3) = IW(IJ,4)
         IJ = IJ + 1
  150 CONTINUE
C PLACE SPIKE AT END.
      IW(LAST,3) = IM
C
C FIND ROW SINGLETONS, APART FROM SPIKE ROW. NON-SINGLETONS ARE MARKED
C     WITH W(I)=2. AGAIN ONLY IW(.,3) IS REVISED AND IW(.,4) IS USED
C     FOR WORKSPACE.
      LAST1 = LAST
      JNS = LAST
      W(IM) = 2.0D0
      J = JM
      DO 180 IJ=M1,LAST
         II = LAST + M1 - IJ
         I = IW(II,3)
         IF (W(I).NE.2.0D0) GO TO 170
         K = IP(I,1)
         IF (II.NE.LAST) J = IND(K,2)
         KP = IP(J,2)
         KL = KP + IW(J,2) - 1
         IW(JNS,4) = I
         JNS = JNS - 1
         DO 160 K=KP,KL
            I = IND(K,1)
            W(I) = 2.0D0
  160    CONTINUE
         GO TO 180
  170    IW(LAST1,3) = I
         LAST1 = LAST1 - 1
  180 CONTINUE
      DO 190 II=M1,LAST1
         JNS = JNS + 1
         I = IW(JNS,4)
         W(I) = 3.0D0
         IW(II,3) = I
  190 CONTINUE
C
C DEAL WITH SINGLETON SPIKE COLUMN. NOTE THAT BUMP ROWS ARE MARKED BY
C    W(I)=3.
      DO 230 II=M1,LAST1
         KP = IP(JM,2)
         KL = KP + IW(JM,2) - 1
         IS = 0
         DO 200 K=KP,KL
            L = IND(K,1)
            IF (W(L).NE.3.0D0) GO TO 200
            IF (IS.NE.0) GO TO 240
            I = L
            KNP = K
            IS = 1
  200    CONTINUE
         IF (IS.EQ.0) GO TO 590
C MAKE A(I,JM) A PIVOT.
         IND(KNP,1) = IND(KP,1)
         IND(KP,1) = I
         KP = IP(I,1)
         DO 210 K=KP,IA
            IF (IND(K,2).EQ.JM) GO TO 220
  210    CONTINUE
  220    AM = A(KP)
         A(KP) = A(K)
         A(K) = AM
         IND(K,2) = IND(KP,2)
         IND(KP,2) = JM
         JM = IND(K,2)
         IW(II,4) = I
         W(I) = 2.0D0
  230 CONTINUE
      II = LAST1
      GO TO 260
  240 IN = M1
      DO 250 IJ=II,LAST1
         IW(IJ,4) = IW(IN,3)
         IN = IN + 1
  250 CONTINUE
  260 LAST2 = LAST1 - 1
      IF (M1.EQ.LAST1) GO TO 570
      DO 270 I=M1,LAST2
         IW(I,3) = IW(I,4)
  270 CONTINUE
      M1 = II
      IF (M1.EQ.LAST1) GO TO 570
C
C CLEAR W
      DO 280 I=1,N
         W(I) = 0.0D0
  280 CONTINUE
C
C PERFORM ELIMINATION
      IR = IW(LAST1,3)
      DO 560 II=M1,LAST1
         IPP = IW(II,3)
         KP = IP(IPP,1)
         KR = IP(IR,1)
         JP = IND(KP,2)
         IF (II.EQ.LAST1) JP = JM
C SEARCH NON-PIVOT ROW FOR ELEMENT TO BE ELIMINATED.
C  AND BRING IT TO FRONT OF ITS ROW
         KRL = KR + IW(IR,1) - 1
         DO 290 KNP=KR,KRL
            IF (JP.EQ.IND(KNP,2)) GO TO 300
  290    CONTINUE
         IF (II-LAST1) 560, 590, 560
C BRING ELEMENT TO BE ELIMINATED TO FRONT OF ITS ROW.
  300    AM = A(KNP)
         A(KNP) = A(KR)
         A(KR) = AM
         IND(KNP,2) = IND(KR,2)
         IND(KR,2) = JP
         IF (II.EQ.LAST1) GO TO 310
         IF (ABS(A(KP)).LT.U*ABS(AM)) GO TO 310
         IF (ABS(AM).LT.U*ABS(A(KP))) GO TO 340
         IF (IW(IPP,1).LE.IW(IR,1)) GO TO 340
C PERFORM INTERCHANGE
  310    IW(LAST1,3) = IPP
         IW(II,3) = IR
         IR = IPP
         IPP = IW(II,3)
         K = KR
         KR = KP
         KP = K
         KJ = IP(JP,2)
         DO 320 K=KJ,IA
            IF (IND(K,1).EQ.IPP) GO TO 330
  320    CONTINUE
  330    IND(K,1) = IND(KJ,1)
         IND(KJ,1) = IPP
  340    IF (A(KP).EQ.0.0D0) GO TO 590
         IF (II.EQ.LAST1) GO TO 560
         AM = -A(KR)/A(KP)
C COMPRESS ROW FILE UNLESS IT IS CERTAIN THAT THERE IS ROOM FOR NEW ROW.
         IF (LROW+IW(IR,1)+IW(IPP,1)+LENL.LE.IA) GO TO 350
         IF (NCP.GE.MCP .OR. LENU+IW(IR,1)+IW(IPP,1)+LENL.GT.IA) GO TO
     *    610
         CALL LA05ED(A, IND(1,2), IP, N, IW, IA, .TRUE.)
         KP = IP(IPP,1)
         KR = IP(IR,1)
  350    KRL = KR + IW(IR,1) - 1
         KQ = KP + 1
         KPL = KP + IW(IPP,1) - 1
C PLACE PIVOT ROW (EXCLUDING PIVOT ITSELF) IN W.
         IF (KQ.GT.KPL) GO TO 370
         DO 360 K=KQ,KPL
            J = IND(K,2)
            W(J) = A(K)
  360    CONTINUE
  370    IP(IR,1) = LROW + 1
C
C TRANSFER MODIFIED ELEMENTS.
         IND(KR,2) = 0
         KR = KR + 1
         IF (KR.GT.KRL) GO TO 430
         DO 420 KS=KR,KRL
            J = IND(KS,2)
            AU = A(KS) + AM*W(J)
            IND(KS,2) = 0
C IF ELEMENT IS VERY SMALL REMOVE IT FROM U.
            IF (ABS(AU).LE.SMALL) GO TO 380
            G = MAX(G,ABS(AU))
            LROW = LROW + 1
            A(LROW) = AU
            IND(LROW,2) = J
            GO TO 410
  380       LENU = LENU - 1
C REMOVE ELEMENT FROM COL FILE.
            K = IP(J,2)
            KL = K + IW(J,2) - 1
            IW(J,2) = KL - K
            DO 390 KK=K,KL
               IF (IND(KK,1).EQ.IR) GO TO 400
  390       CONTINUE
  400       IND(KK,1) = IND(KL,1)
            IND(KL,1) = 0
  410       W(J) = 0.0D0
  420    CONTINUE
C
C SCAN PIVOT ROW FOR FILLS.
  430    IF (KQ.GT.KPL) GO TO 520
         DO 510 KS=KQ,KPL
            J = IND(KS,2)
            AU = AM*W(J)
            IF (ABS(AU).LE.SMALL) GO TO 500
            LROW = LROW + 1
            A(LROW) = AU
            IND(LROW,2) = J
            LENU = LENU + 1
C
C CREATE FILL IN COLUMN FILE.
            NZ = IW(J,2)
            K = IP(J,2)
            KL = K + NZ - 1
C IF POSSIBLE PLACE NEW ELEMENT AT END OF PRESENT ENTRY.
            IF (KL.NE.LCOL) GO TO 440
            IF (LCOL+LENL.GE.IA) GO TO 460
            LCOL = LCOL + 1
            GO TO 450
  440       IF (IND(KL+1,1).NE.0) GO TO 460
  450       IND(KL+1,1) = IR
            GO TO 490
C NEW ENTRY HAS TO BE CREATED.
  460       IF (LCOL+LENL+NZ+1.LT.IA) GO TO 470
C COMPRESS COLUMN FILE IF THERE IS NOT ROOM FOR NEW ENTRY.
            IF (NCP.GE.MCP .OR. LENU+LENL+NZ+1.GE.IA) GO TO 610
            CALL LA05ED(A, IND, IP(1,2), N, IW(1,2), IA, .FALSE.)
            K = IP(J,2)
            KL = K + NZ - 1
C TRANSFER OLD ENTRY INTO NEW.
  470       IP(J,2) = LCOL + 1
            DO 480 KK=K,KL
               LCOL = LCOL + 1
               IND(LCOL,1) = IND(KK,1)
               IND(KK,1) = 0
  480       CONTINUE
C ADD NEW ELEMENT.
            LCOL = LCOL + 1
            IND(LCOL,1) = IR
  490       G = MAX(G,ABS(AU))
            IW(J,2) = NZ + 1
  500       W(J) = 0.0D0
  510    CONTINUE
  520    IW(IR,1) = LROW + 1 - IP(IR,1)
C
C STORE MULTIPLIER
         IF (LENL+LCOL+1.LE.IA) GO TO 530
C COMPRESS COL FILE IF NECESSARY.
         IF (NCP.GE.MCP) GO TO 610
         CALL LA05ED(A, IND, IP(1,2), N, IW(1,2), IA, .FALSE.)
  530    K = IA - LENL
         LENL = LENL + 1
         A(K) = AM
         IND(K,1) = IPP
         IND(K,2) = IR
C CREATE BLANK IN PIVOTAL COLUMN.
         KP = IP(JP,2)
         NZ = IW(JP,2) - 1
         KL = KP + NZ
         DO 540 K=KP,KL
            IF (IND(K,1).EQ.IR) GO TO 550
  540    CONTINUE
  550    IND(K,1) = IND(KL,1)
         IW(JP,2) = NZ
         IND(KL,1) = 0
         LENU = LENU - 1
  560 CONTINUE
C
C CONSTRUCT COLUMN PERMUTATION AND STORE IT IN IW(.,4)
  570 DO 580 II=M,LAST
         I = IW(II,3)
         K = IP(I,1)
         J = IND(K,2)
         IW(II,4) = J
  580 CONTINUE
      RETURN
C
C     THE FOLLOWING INSTRUCTIONS IMPLEMENT THE FAILURE EXITS.
C
  590 IF (LP.GT.0) THEN
         WRITE (XERN1, '(I8)') MM
         CALL XERMSG ('SLATEC', 'LA05CD', 'SINGULAR MATRIX AFTER ' //
     *      'REPLACEMENT OF COLUMN.  INDEX = ' // XERN1, -6, 1)
      ENDIF
      G = -6.0D0
      RETURN
C
  610 IF (LP.GT.0) CALL XERMSG ('SLATEC', 'LA05CD',
     *   'LENGTHS OF ARRAYS A(*) AND IND(*,2) ARE TOO SMALL.', -7, 1)
      G = -7.0D0
      RETURN
C
  620 IF (LP.GT.0) CALL XERMSG ('SLATEC', 'LA05CD',
     *   'EARLIER ENTRY GAVE ERROR RETURN.', -8, 2)
      G = -8.0D0
      RETURN
      END
*DECK LA05CS
      SUBROUTINE LA05CS (A, IND, IA, N, IP, IW, W, G, U, MM)
C***BEGIN PROLOGUE  LA05CS
C***SUBSIDIARY
C***PURPOSE  Subsidiary to SPLP
C***LIBRARY   SLATEC
C***TYPE      SINGLE PRECISION (LA05CS-S, LA05CD-D)
C***AUTHOR  (UNKNOWN)
C***DESCRIPTION
C
C     THIS SUBPROGRAM IS A SLIGHT MODIFICATION OF A SUBPROGRAM
C     FROM THE C. 1979 AERE HARWELL LIBRARY.  THE NAME OF THE
C     CORRESPONDING HARWELL CODE CAN BE OBTAINED BY DELETING
C     THE FINAL LETTER =S= IN THE NAMES USED HERE.
C     REVISED SEP. 13, 1979.
C
C     ROYALTIES HAVE BEEN PAID TO AERE-UK FOR USE OF THEIR CODES
C     IN THE PACKAGE GIVEN HERE.  ANY PRIMARY USAGE OF THE HARWELL
C     SUBROUTINES REQUIRES A ROYALTY AGREEMENT AND PAYMENT BETWEEN
C     THE USER AND AERE-UK.  ANY USAGE OF THE SANDIA WRITTEN CODES
C     SPLP( ) (WHICH USES THE HARWELL SUBROUTINES) IS PERMITTED.
C
C***SEE ALSO  SPLP
C***ROUTINES CALLED  LA05ES, XERMSG, XSETUN
C***COMMON BLOCKS    LA05DS
C***REVISION HISTORY  (YYMMDD)
C   811215  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890605  Corrected references to XERRWV.  (WRB)
C   890831  Modified array declarations.  (WRB)
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900315  CALLs to XERROR changed to CALLs to XERMSG.  (THJ)
C   900402  Added TYPE section.  (WRB)
C   900510  Convert XERRWV calls to XERMSG calls.  (RWC)
C   920410  Corrected second dimension on IW declaration.  (WRB)
C   920422  Changed upper limit on DO from LAST to LAST-1.  (WRB)
C***END PROLOGUE  LA05CS
      REAL A(*), G, U, AM, W(*), SMALL, AU
      INTEGER IND(IA,2), IW(N,8)
      INTEGER IP(N,2)
      CHARACTER*8 XERN1
C
      COMMON /LA05DS/ SMALL, LP, LENL, LENU, NCP, LROW, LCOL
C***FIRST EXECUTABLE STATEMENT  LA05CS
      CALL XSETUN(LP)
      IF (G.LT.0.0E0) GO TO 620
      JM = MM
C MCP LIMITS THE VALUE OF NCP PERMITTED BEFORE AN ERROR RETURN RESULTS.
      MCP = NCP + 20
C REMOVE OLD COLUMN
      LENU = LENU - IW(JM,2)
      KP = IP(JM,2)
      IM = IND(KP,1)
      KL = KP + IW(JM,2) - 1
      IW(JM,2) = 0
      DO 30 K=KP,KL
         I = IND(K,1)
         IND(K,1) = 0
         KR = IP(I,1)
         NZ = IW(I,1) - 1
         IW(I,1) = NZ
         KRL = KR + NZ
         DO 10 KM=KR,KRL
            IF (IND(KM,2).EQ.JM) GO TO 20
   10    CONTINUE
   20    A(KM) = A(KRL)
         IND(KM,2) = IND(KRL,2)
         IND(KRL,2) = 0
   30 CONTINUE
C
C INSERT NEW COLUMN
      DO 110 II=1,N
         I = IW(II,3)
         IF (I.EQ.IM) M = II
         IF (ABS(W(I)).LE.SMALL) GO TO 100
         LENU = LENU + 1
         LAST = II
         IF (LCOL+LENL.LT.IA) GO TO 40
C COMPRESS COLUMN FILE IF NECESSARY.
         IF (NCP.GE.MCP .OR. LENL+LENU.GE.IA) GO TO 610
         CALL LA05ES(A, IND, IP(1,2), N, IW(1,2), IA, .FALSE.)
   40    LCOL = LCOL + 1
         NZ = IW(JM,2)
         IF (NZ.EQ.0) IP(JM,2) = LCOL
         IW(JM,2) = NZ + 1
         IND(LCOL,1) = I
         NZ = IW(I,1)
         KPL = IP(I,1) + NZ
         IF (KPL.GT.LROW) GO TO 50
         IF (IND(KPL,2).EQ.0) GO TO 90
C NEW ENTRY HAS TO BE CREATED.
   50    IF (LENL+LROW+NZ.LT.IA) GO TO 60
         IF (NCP.GE.MCP .OR. LENL+LENU+NZ.GE.IA) GO TO 610
C COMPRESS ROW FILE IF NECESSARY.
         CALL LA05ES(A, IND(1,2), IP, N, IW, IA, .TRUE.)
   60    KP = IP(I,1)
         IP(I,1) = LROW + 1
         IF (NZ.EQ.0) GO TO 80
         KPL = KP + NZ - 1
         DO 70 K=KP,KPL
            LROW = LROW + 1
            A(LROW) = A(K)
            IND(LROW,2) = IND(K,2)
            IND(K,2) = 0
   70    CONTINUE
   80    LROW = LROW + 1
         KPL = LROW
C PLACE NEW ELEMENT AT END OF ROW.
   90    IW(I,1) = NZ + 1
         A(KPL) = W(I)
         IND(KPL,2) = JM
  100    W(I) = 0.0E0
  110 CONTINUE
      IF (IW(IM,1).EQ.0 .OR. IW(JM,2).EQ.0 .OR. M.GT.LAST) GO TO 590
C
C FIND COLUMN SINGLETONS, OTHER THAN THE SPIKE. NON-SINGLETONS ARE
C     MARKED WITH W(J)=1. ONLY IW(.,3) IS REVISED AND IW(.,4) IS USED
C     FOR WORKSPACE.
      INS = M
      M1 = M
      W(JM) = 1.0E0
      DO 140 II=M,LAST
         I = IW(II,3)
         J = IW(II,4)
         IF (W(J).EQ.0.0E0) GO TO 130
         KP = IP(I,1)
         KL = KP + IW(I,1) - 1
         DO 120 K=KP,KL
            J = IND(K,2)
            W(J) = 1.0E0
  120    CONTINUE
         IW(INS,4) = I
         INS = INS + 1
         GO TO 140
C PLACE SINGLETONS IN NEW POSITION.
  130    IW(M1,3) = I
         M1 = M1 + 1
  140 CONTINUE
C PLACE NON-SINGLETONS IN NEW POSITION.
      IJ = M + 1
      DO 150 II=M1,LAST-1
         IW(II,3) = IW(IJ,4)
         IJ = IJ + 1
  150 CONTINUE
C PLACE SPIKE AT END.
      IW(LAST,3) = IM
C
C FIND ROW SINGLETONS, APART FROM SPIKE ROW. NON-SINGLETONS ARE MARKED
C     WITH W(I)=2. AGAIN ONLY IW(.,3) IS REVISED AND IW(.,4) IS USED
C     FOR WORKSPACE.
      LAST1 = LAST
      JNS = LAST
      W(IM) = 2.0E0
      J = JM
      DO 180 IJ=M1,LAST
         II = LAST + M1 - IJ
         I = IW(II,3)
         IF (W(I).NE.2.0E0) GO TO 170
         K = IP(I,1)
         IF (II.NE.LAST) J = IND(K,2)
         KP = IP(J,2)
         KL = KP + IW(J,2) - 1
         IW(JNS,4) = I
         JNS = JNS - 1
         DO 160 K=KP,KL
            I = IND(K,1)
            W(I) = 2.0E0
  160    CONTINUE
         GO TO 180
  170    IW(LAST1,3) = I
         LAST1 = LAST1 - 1
  180 CONTINUE
      DO 190 II=M1,LAST1
         JNS = JNS + 1
         I = IW(JNS,4)
         W(I) = 3.0E0
         IW(II,3) = I
  190 CONTINUE
C
C DEAL WITH SINGLETON SPIKE COLUMN. NOTE THAT BUMP ROWS ARE MARKED BY
C    W(I)=3.0E0
      DO 230 II=M1,LAST1
         KP = IP(JM,2)
         KL = KP + IW(JM,2) - 1
         IS = 0
         DO 200 K=KP,KL
            L = IND(K,1)
            IF (W(L).NE.3.0E0) GO TO 200
            IF (IS.NE.0) GO TO 240
            I = L
            KNP = K
            IS = 1
  200    CONTINUE
         IF (IS.EQ.0) GO TO 590
C MAKE A(I,JM) A PIVOT.
         IND(KNP,1) = IND(KP,1)
         IND(KP,1) = I
         KP = IP(I,1)
         DO 210 K=KP,IA
            IF (IND(K,2).EQ.JM) GO TO 220
  210    CONTINUE
  220    AM = A(KP)
         A(KP) = A(K)
         A(K) = AM
         IND(K,2) = IND(KP,2)
         IND(KP,2) = JM
         JM = IND(K,2)
         IW(II,4) = I
         W(I) = 2.0E0
  230 CONTINUE
      II = LAST1
      GO TO 260
  240 IN = M1
      DO 250 IJ=II,LAST1
         IW(IJ,4) = IW(IN,3)
         IN = IN + 1
  250 CONTINUE
  260 LAST2 = LAST1 - 1
      IF (M1.EQ.LAST1) GO TO 570
      DO 270 I=M1,LAST2
         IW(I,3) = IW(I,4)
  270 CONTINUE
      M1 = II
      IF (M1.EQ.LAST1) GO TO 570
C
C CLEAR W
      DO 280 I=1,N
         W(I) = 0.0E0
  280 CONTINUE
C
C PERFORM ELIMINATION
      IR = IW(LAST1,3)
      DO 560 II=M1,LAST1
         IPP = IW(II,3)
         KP = IP(IPP,1)
         KR = IP(IR,1)
         JP = IND(KP,2)
         IF (II.EQ.LAST1) JP = JM
C SEARCH NON-PIVOT ROW FOR ELEMENT TO BE ELIMINATED.
C  AND BRING IT TO FRONT OF ITS ROW
         KRL = KR + IW(IR,1) - 1
         DO 290 KNP=KR,KRL
            IF (JP.EQ.IND(KNP,2)) GO TO 300
  290    CONTINUE
         IF (II-LAST1) 560, 590, 560
C BRING ELEMENT TO BE ELIMINATED TO FRONT OF ITS ROW.
  300    AM = A(KNP)
         A(KNP) = A(KR)
         A(KR) = AM
         IND(KNP,2) = IND(KR,2)
         IND(KR,2) = JP
         IF (II.EQ.LAST1) GO TO 310
         IF (ABS(A(KP)).LT.U*ABS(AM)) GO TO 310
         IF (ABS(AM).LT.U*ABS(A(KP))) GO TO 340
         IF (IW(IPP,1).LE.IW(IR,1)) GO TO 340
C PERFORM INTERCHANGE
  310    IW(LAST1,3) = IPP
         IW(II,3) = IR
         IR = IPP
         IPP = IW(II,3)
         K = KR
         KR = KP
         KP = K
         KJ = IP(JP,2)
         DO 320 K=KJ,IA
            IF (IND(K,1).EQ.IPP) GO TO 330
  320    CONTINUE
  330    IND(K,1) = IND(KJ,1)
         IND(KJ,1) = IPP
  340    IF (A(KP).EQ.0.0E0) GO TO 590
         IF (II.EQ.LAST1) GO TO 560
         AM = -A(KR)/A(KP)
C COMPRESS ROW FILE UNLESS IT IS CERTAIN THAT THERE IS ROOM FOR NEW ROW.
         IF (LROW+IW(IR,1)+IW(IPP,1)+LENL.LE.IA) GO TO 350
         IF (NCP.GE.MCP .OR. LENU+IW(IR,1)+IW(IPP,1)+LENL.GT.IA) GO TO
     *    610
         CALL LA05ES(A, IND(1,2), IP, N, IW, IA, .TRUE.)
         KP = IP(IPP,1)
         KR = IP(IR,1)
  350    KRL = KR + IW(IR,1) - 1
         KQ = KP + 1
         KPL = KP + IW(IPP,1) - 1
C PLACE PIVOT ROW (EXCLUDING PIVOT ITSELF) IN W.
         IF (KQ.GT.KPL) GO TO 370
         DO 360 K=KQ,KPL
            J = IND(K,2)
            W(J) = A(K)
  360    CONTINUE
  370    IP(IR,1) = LROW + 1
C
C TRANSFER MODIFIED ELEMENTS.
         IND(KR,2) = 0
         KR = KR + 1
         IF (KR.GT.KRL) GO TO 430
         DO 420 KS=KR,KRL
            J = IND(KS,2)
            AU = A(KS) + AM*W(J)
            IND(KS,2) = 0
C IF ELEMENT IS VERY SMALL REMOVE IT FROM U.
            IF (ABS(AU).LE.SMALL) GO TO 380
            G = MAX(G,ABS(AU))
            LROW = LROW + 1
            A(LROW) = AU
            IND(LROW,2) = J
            GO TO 410
  380       LENU = LENU - 1
C REMOVE ELEMENT FROM COL FILE.
            K = IP(J,2)
            KL = K + IW(J,2) - 1
            IW(J,2) = KL - K
            DO 390 KK=K,KL
               IF (IND(KK,1).EQ.IR) GO TO 400
  390       CONTINUE
  400       IND(KK,1) = IND(KL,1)
            IND(KL,1) = 0
  410       W(J) = 0.0E0
  420    CONTINUE
C
C SCAN PIVOT ROW FOR FILLS.
  430    IF (KQ.GT.KPL) GO TO 520
         DO 510 KS=KQ,KPL
            J = IND(KS,2)
            AU = AM*W(J)
            IF (ABS(AU).LE.SMALL) GO TO 500
            LROW = LROW + 1
            A(LROW) = AU
            IND(LROW,2) = J
            LENU = LENU + 1
C
C CREATE FILL IN COLUMN FILE.
            NZ = IW(J,2)
            K = IP(J,2)
            KL = K + NZ - 1
C IF POSSIBLE PLACE NEW ELEMENT AT END OF PRESENT ENTRY.
            IF (KL.NE.LCOL) GO TO 440
            IF (LCOL+LENL.GE.IA) GO TO 460
            LCOL = LCOL + 1
            GO TO 450
  440       IF (IND(KL+1,1).NE.0) GO TO 460
  450       IND(KL+1,1) = IR
            GO TO 490
C NEW ENTRY HAS TO BE CREATED.
  460       IF (LCOL+LENL+NZ+1.LT.IA) GO TO 470
C COMPRESS COLUMN FILE IF THERE IS NOT ROOM FOR NEW ENTRY.
            IF (NCP.GE.MCP .OR. LENU+LENL+NZ+1.GE.IA) GO TO 610
            CALL LA05ES(A, IND, IP(1,2), N, IW(1,2), IA, .FALSE.)
            K = IP(J,2)
            KL = K + NZ - 1
C TRANSFER OLD ENTRY INTO NEW.
  470       IP(J,2) = LCOL + 1
            DO 480 KK=K,KL
               LCOL = LCOL + 1
               IND(LCOL,1) = IND(KK,1)
               IND(KK,1) = 0
  480       CONTINUE
C ADD NEW ELEMENT.
            LCOL = LCOL + 1
            IND(LCOL,1) = IR
  490       G = MAX(G,ABS(AU))
            IW(J,2) = NZ + 1
  500       W(J) = 0.0E0
  510    CONTINUE
  520    IW(IR,1) = LROW + 1 - IP(IR,1)
C
C STORE MULTIPLIER
         IF (LENL+LCOL+1.LE.IA) GO TO 530
C COMPRESS COL FILE IF NECESSARY.
         IF (NCP.GE.MCP) GO TO 610
         CALL LA05ES(A, IND, IP(1,2), N, IW(1,2), IA, .FALSE.)
  530    K = IA - LENL
         LENL = LENL + 1
         A(K) = AM
         IND(K,1) = IPP
         IND(K,2) = IR
C CREATE BLANK IN PIVOTAL COLUMN.
         KP = IP(JP,2)
         NZ = IW(JP,2) - 1
         KL = KP + NZ
         DO 540 K=KP,KL
            IF (IND(K,1).EQ.IR) GO TO 550
  540    CONTINUE
  550    IND(K,1) = IND(KL,1)
         IW(JP,2) = NZ
         IND(KL,1) = 0
         LENU = LENU - 1
  560 CONTINUE
C
C CONSTRUCT COLUMN PERMUTATION AND STORE IT IN IW(.,4)
  570 DO 580 II=M,LAST
         I = IW(II,3)
         K = IP(I,1)
         J = IND(K,2)
         IW(II,4) = J
  580 CONTINUE
      RETURN
C
C     THE FOLLOWING INSTRUCTIONS IMPLEMENT THE FAILURE EXITS.
C
  590 IF (LP.GT.0) THEN
         WRITE (XERN1, '(I8)') MM
         CALL XERMSG ('SLATEC', 'LA05CS', 'SINGULAR MATRIX AFTER ' //
     *      'REPLACEMENT OF COLUMN.  INDEX = ' // XERN1, -6, 1)
      ENDIF
      G = -6.0E0
      RETURN
C
  610 IF (LP.GT.0) CALL XERMSG ('SLATEC', 'LA05CS',
     *   'LENGTHS OF ARRAYS A(*) AND IND(*,2) ARE TOO SMALL.', -7, 1)
      G = -7.0E0
      RETURN
C
  620 IF (LP.GT.0) CALL XERMSG ('SLATEC', 'LA05CS',
     *   'EARLIER ENTRY GAVE ERROR RETURN.', -8, 2)
      G = -8.0E0
      RETURN
      END
*DECK LA05ED
      SUBROUTINE LA05ED (A, IRN, IP, N, IW, IA, REALS)
C***BEGIN PROLOGUE  LA05ED
C***SUBSIDIARY
C***PURPOSE  Subsidiary to DSPLP
C***LIBRARY   SLATEC
C***TYPE      DOUBLE PRECISION (LA05ES-S, LA05ED-D)
C***AUTHOR  (UNKNOWN)
C***DESCRIPTION
C
C     THIS SUBPROGRAM IS A SLIGHT MODIFICATION OF A SUBPROGRAM
C     FROM THE C. 1979 AERE HARWELL LIBRARY.  THE NAME OF THE
C     CORRESPONDING HARWELL CODE CAN BE OBTAINED BY DELETING
C     THE FINAL LETTER =D= IN THE NAMES USED HERE.
C     REVISED SEP. 13, 1979.
C
C     ROYALTIES HAVE BEEN PAID TO AERE-UK FOR USE OF THEIR CODES
C     IN THE PACKAGE GIVEN HERE.  ANY PRIMARY USAGE OF THE HARWELL
C     SUBROUTINES REQUIRES A ROYALTY AGREEMENT AND PAYMENT BETWEEN
C     THE USER AND AERE-UK.  ANY USAGE OF THE SANDIA WRITTEN CODES
C     DSPLP( ) (WHICH USES THE HARWELL SUBROUTINES) IS PERMITTED.
C
C***SEE ALSO  DSPLP
C***ROUTINES CALLED  (NONE)
C***COMMON BLOCKS    LA05DD
C***REVISION HISTORY  (YYMMDD)
C   811215  DATE WRITTEN
C   890831  Modified array declarations.  (WRB)
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900402  Added TYPE section.  (WRB)
C***END PROLOGUE  LA05ED
      LOGICAL REALS
      DOUBLE PRECISION A(*),SMALL
      INTEGER IRN(*), IW(*)
      INTEGER IP(*)
      COMMON /LA05DD/ SMALL, LP, LENL, LENU, NCP, LROW, LCOL
C***FIRST EXECUTABLE STATEMENT  LA05ED
      NCP = NCP + 1
C     COMPRESS FILE OF POSITIVE INTEGERS. ENTRY J STARTS AT IRN(IP(J))
C  AND CONTAINS IW(J) INTEGERS,J=1,N. OTHER COMPONENTS OF IRN ARE ZERO.
C  LENGTH OF COMPRESSED FILE PLACED IN LROW IF REALS IS .TRUE. OR LCOL
C  OTHERWISE.
C  IF REALS IS .TRUE. ARRAY A CONTAINS A FILE ASSOCIATED WITH IRN
C  AND THIS IS COMPRESSED TOO.
C  A,IRN,IP,IW,IA ARE INPUT/OUTPUT VARIABLES.
C  N,REALS ARE INPUT/UNCHANGED VARIABLES.
C
      DO 10 J=1,N
C STORE THE LAST ELEMENT OF ENTRY J IN IW(J) THEN OVERWRITE IT BY -J.
         NZ = IW(J)
         IF (NZ.LE.0) GO TO 10
         K = IP(J) + NZ - 1
         IW(J) = IRN(K)
         IRN(K) = -J
   10 CONTINUE
C KN IS THE POSITION OF NEXT ENTRY IN COMPRESSED FILE.
      KN = 0
      IPI = 0
      KL = LCOL
      IF (REALS) KL = LROW
C LOOP THROUGH THE OLD FILE SKIPPING ZERO (DUMMY) ELEMENTS AND
C     MOVING GENUINE ELEMENTS FORWARD. THE ENTRY NUMBER BECOMES
C     KNOWN ONLY WHEN ITS END IS DETECTED BY THE PRESENCE OF A NEGATIVE
C     INTEGER.
      DO 30 K=1,KL
         IF (IRN(K).EQ.0) GO TO 30
         KN = KN + 1
         IF (REALS) A(KN) = A(K)
         IF (IRN(K).GE.0) GO TO 20
C END OF ENTRY. RESTORE IRN(K), SET POINTER TO START OF ENTRY AND
C     STORE CURRENT KN IN IPI READY FOR USE WHEN NEXT LAST ENTRY
C     IS DETECTED.
         J = -IRN(K)
         IRN(K) = IW(J)
         IP(J) = IPI + 1
         IW(J) = KN - IPI
         IPI = KN
   20    IRN(KN) = IRN(K)
   30 CONTINUE
      IF (REALS) LROW = KN
      IF (.NOT.REALS) LCOL = KN
      RETURN
      END
*DECK LA05ES
      SUBROUTINE LA05ES (A, IRN, IP, N, IW, IA, REALS)
C***BEGIN PROLOGUE  LA05ES
C***SUBSIDIARY
C***PURPOSE  Subsidiary to SPLP
C***LIBRARY   SLATEC
C***TYPE      SINGLE PRECISION (LA05ES-S, LA05ED-D)
C***AUTHOR  (UNKNOWN)
C***DESCRIPTION
C
C     THIS SUBPROGRAM IS A SLIGHT MODIFICATION OF A SUBPROGRAM
C     FROM THE C. 1979 AERE HARWELL LIBRARY.  THE NAME OF THE
C     CORRESPONDING HARWELL CODE CAN BE OBTAINED BY DELETING
C     THE FINAL LETTER =S= IN THE NAMES USED HERE.
C     REVISED SEP. 13, 1979.
C
C     ROYALTIES HAVE BEEN PAID TO AERE-UK FOR USE OF THEIR CODES
C     IN THE PACKAGE GIVEN HERE.  ANY PRIMARY USAGE OF THE HARWELL
C     SUBROUTINES REQUIRES A ROYALTY AGREEMENT AND PAYMENT BETWEEN
C     THE USER AND AERE-UK.  ANY USAGE OF THE SANDIA WRITTEN CODES
C     SPLP( ) (WHICH USES THE HARWELL SUBROUTINES) IS PERMITTED.
C
C***SEE ALSO  SPLP
C***ROUTINES CALLED  (NONE)
C***COMMON BLOCKS    LA05DS
C***REVISION HISTORY  (YYMMDD)
C   811215  DATE WRITTEN
C   890831  Modified array declarations.  (WRB)
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900402  Added TYPE section.  (WRB)
C***END PROLOGUE  LA05ES
      LOGICAL REALS
      REAL A(*)
      INTEGER IRN(*), IW(*)
      INTEGER IP(*)
      COMMON /LA05DS/ SMALL, LP, LENL, LENU, NCP, LROW, LCOL
C***FIRST EXECUTABLE STATEMENT  LA05ES
      NCP = NCP + 1
C     COMPRESS FILE OF POSITIVE INTEGERS. ENTRY J STARTS AT IRN(IP(J))
C  AND CONTAINS IW(J) INTEGERS,J=1,N. OTHER COMPONENTS OF IRN ARE ZERO.
C  LENGTH OF COMPRESSED FILE PLACED IN LROW IF REALS IS .TRUE. OR LCOL
C  OTHERWISE.
C  IF REALS IS .TRUE. ARRAY A CONTAINS A REAL FILE ASSOCIATED WITH IRN
C  AND THIS IS COMPRESSED TOO.
C  A,IRN,IP,IW,IA ARE INPUT/OUTPUT VARIABLES.
C  N,REALS ARE INPUT/UNCHANGED VARIABLES.
C
      DO 10 J=1,N
C STORE THE LAST ELEMENT OF ENTRY J IN IW(J) THEN OVERWRITE IT BY -J.
         NZ = IW(J)
         IF (NZ.LE.0) GO TO 10
         K = IP(J) + NZ - 1
         IW(J) = IRN(K)
         IRN(K) = -J
   10 CONTINUE
C KN IS THE POSITION OF NEXT ENTRY IN COMPRESSED FILE.
      KN = 0
      IPI = 0
      KL = LCOL
      IF (REALS) KL = LROW
C LOOP THROUGH THE OLD FILE SKIPPING ZERO (DUMMY) ELEMENTS AND
C     MOVING GENUINE ELEMENTS FORWARD. THE ENTRY NUMBER BECOMES
C     KNOWN ONLY WHEN ITS END IS DETECTED BY THE PRESENCE OF A NEGATIVE
C     INTEGER.
      DO 30 K=1,KL
         IF (IRN(K).EQ.0) GO TO 30
         KN = KN + 1
         IF (REALS) A(KN) = A(K)
         IF (IRN(K).GE.0) GO TO 20
C END OF ENTRY. RESTORE IRN(K), SET POINTER TO START OF ENTRY AND
C     STORE CURRENT KN IN IPI READY FOR USE WHEN NEXT LAST ENTRY
C     IS DETECTED.
         J = -IRN(K)
         IRN(K) = IW(J)
         IP(J) = IPI + 1
         IW(J) = KN - IPI
         IPI = KN
   20    IRN(KN) = IRN(K)
   30 CONTINUE
      IF (REALS) LROW = KN
      IF (.NOT.REALS) LCOL = KN
      RETURN
      END
*DECK LLSIA
      SUBROUTINE LLSIA (A, MDA, M, N, B, MDB, NB, RE, AE, KEY, MODE, NP,
     +   KRANK, KSURE, RNORM, W, LW, IWORK, LIW, INFO)
C***BEGIN PROLOGUE  LLSIA
C***PURPOSE  Solve a linear least squares problems by performing a QR
C            factorization of the matrix using Householder
C            transformations.  Emphasis is put on detecting possible
C            rank deficiency.
C***LIBRARY   SLATEC
C***CATEGORY  D9, D5
C***TYPE      SINGLE PRECISION (LLSIA-S, DLLSIA-D)
C***KEYWORDS  LINEAR LEAST SQUARES, QR FACTORIZATION
C***AUTHOR  Manteuffel, T. A., (LANL)
C***DESCRIPTION
C
C     LLSIA computes the least squares solution(s) to the problem AX=B
C     where A is an M by N matrix with M.GE.N and B is the M by NB
C     matrix of right hand sides.  User input bounds on the uncertainty
C     in the elements of A are used to detect numerical rank deficiency.
C     The algorithm employs a row and column pivot strategy to
C     minimize the growth of uncertainty and round-off errors.
C
C     LLSIA requires (MDA+6)*N + (MDB+1)*NB + M dimensioned space
C
C   ******************************************************************
C   *                                                                *
C   *         WARNING - All input arrays are changed on exit.        *
C   *                                                                *
C   ******************************************************************
C     SUBROUTINE LLSIA(A,MDA,M,N,B,MDB,NB,RE,AE,KEY,MODE,NP,
C    1   KRANK,KSURE,RNORM,W,LW,IWORK,LIW,INFO)
C
C     Input..
C
C     A(,)          Linear coefficient matrix of AX=B, with MDA the
C      MDA,M,N      actual first dimension of A in the calling program.
C                   M is the row dimension (no. of EQUATIONS of the
C                   problem) and N the col dimension (no. of UNKNOWNS).
C                   Must have MDA.GE.M and M.GE.N.
C
C     B(,)          Right hand side(s), with MDB the actual first
C      MDB,NB       dimension of B in the calling program. NB is the
C                   number of M by 1 right hand sides. Must have
C                   MDB.GE.M. If NB = 0, B is never accessed.
C
C   ******************************************************************
C   *                                                                *
C   *         Note - Use of RE and AE are what make this             *
C   *                code significantly different from               *
C   *                other linear least squares solvers.             *
C   *                However, the inexperienced user is              *
C   *                advised to set RE=0.,AE=0.,KEY=0.               *
C   *                                                                *
C   ******************************************************************
C     RE(),AE(),KEY
C     RE()          RE() is a vector of length N such that RE(I) is
C                   the maximum relative uncertainty in column I of
C                   the matrix A. The values of RE() must be between
C                   0 and 1. A minimum of 10*machine precision will
C                   be enforced.
C
C     AE()          AE() is a vector of length N such that AE(I) is
C                   the maximum absolute uncertainty in column I of
C                   the matrix A. The values of AE() must be greater
C                   than or equal to 0.
C
C     KEY           For ease of use, RE and AE may be input as either
C                   vectors or scalars. If a scalar is input, the algo-
C                   rithm will use that value for each column of A.
C                   The parameter key indicates whether scalars or
C                   vectors are being input.
C                        KEY=0     RE scalar  AE scalar
C                        KEY=1     RE vector  AE scalar
C                        KEY=2     RE scalar  AE vector
C                        KEY=3     RE vector  AE vector
C
C     MODE          The integer mode indicates how the routine
C                   is to react if rank deficiency is detected.
C                   If MODE = 0 return immediately, no solution
C                             1 compute truncated solution
C                             2 compute minimal length solution
C                   The inexperienced user is advised to set MODE=0
C
C     NP            The first NP columns of A will not be interchanged
C                   with other columns even though the pivot strategy
C                   would suggest otherwise.
C                   The inexperienced user is advised to set NP=0.
C
C     WORK()        A real work array dimensioned 5*N.  However, if
C                   RE or AE have been specified as vectors, dimension
C                   WORK 4*N. If both RE and AE have been specified
C                   as vectors, dimension WORK 3*N.
C
C     LW            Actual dimension of WORK
C
C     IWORK()       Integer work array dimensioned at least N+M.
C
C     LIW           Actual dimension of IWORK.
C
C     INFO          Is a flag which provides for the efficient
C                   solution of subsequent problems involving the
C                   same A but different B.
C                   If INFO = 0 original call
C                      INFO = 1 subsequent calls
C                   On subsequent calls, the user must supply A, KRANK,
C                   LW, IWORK, LIW, and the first 2*N locations of WORK
C                   as output by the original call to LLSIA. MODE must
C                   be equal to the value of MODE in the original call.
C                   If MODE.LT.2, only the first N locations of WORK
C                   are accessed. AE, RE, KEY, and NP are not accessed.
C
C     Output..
C
C     A(,)          Contains the upper triangular part of the reduced
C                   matrix and the transformation information. It togeth
C                   with the first N elements of WORK (see below)
C                   completely specify the QR factorization of A.
C
C     B(,)          Contains the N by NB solution matrix for X.
C
C     KRANK,KSURE   The numerical rank of A,  based upon the relative
C                   and absolute bounds on uncertainty, is bounded
C                   above by KRANK and below by KSURE. The algorithm
C                   returns a solution based on KRANK. KSURE provides
C                   an indication of the precision of the rank.
C
C     RNORM()       Contains the Euclidean length of the NB residual
C                   vectors  B(I)-AX(I), I=1,NB.
C
C     WORK()        The first N locations of WORK contain values
C                   necessary to reproduce the Householder
C                   transformation.
C
C     IWORK()       The first N locations contain the order in
C                   which the columns of A were used. The next
C                   M locations contain the order in which the
C                   rows of A were used.
C
C     INFO          Flag to indicate status of computation on completion
C                  -1   Parameter error(s)
C                   0 - Rank deficient, no solution
C                   1 - Rank deficient, truncated solution
C                   2 - Rank deficient, minimal length solution
C                   3 - Numerical rank 0, zero solution
C                   4 - Rank .LT. NP
C                   5 - Full rank
C
C***REFERENCES  T. Manteuffel, An interval analysis approach to rank
C                 determination in linear least squares problems,
C                 Report SAND80-0655, Sandia Laboratories, June 1980.
C***ROUTINES CALLED  R1MACH, U11LS, U12LS, XERMSG
C***REVISION HISTORY  (YYMMDD)
C   810801  DATE WRITTEN
C   890831  Modified array declarations.  (WRB)
C   891009  Removed unreferenced variable.  (WRB)
C   891009  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900315  CALLs to XERROR changed to CALLs to XERMSG.  (THJ)
C   900510  Fixed an error message.  (RWC)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  LLSIA
      DIMENSION A(MDA,*),B(MDB,*),RE(*),AE(*),RNORM(*),W(*)
      INTEGER IWORK(*)
C
C***FIRST EXECUTABLE STATEMENT  LLSIA
      IF(INFO.LT.0 .OR. INFO.GT.1) GO TO 514
      IT=INFO
      INFO=-1
      IF(NB.EQ.0 .AND. IT.EQ.1) GO TO 501
      IF(M.LT.1) GO TO 502
      IF(N.LT.1) GO TO 503
      IF(N.GT.M) GO TO 504
      IF(MDA.LT.M) GO TO 505
      IF(LIW.LT.M+N) GO TO 506
      IF(MODE.LT.0 .OR. MODE.GT.3) GO TO 515
      IF(NB.EQ.0) GO TO 4
      IF(NB.LT.0) GO TO 507
      IF(MDB.LT.M) GO TO 508
      IF(IT.EQ.0) GO TO 4
      GO TO 400
    4 IF(KEY.LT.0.OR.KEY.GT.3) GO TO 509
      IF(KEY.EQ.0 .AND. LW.LT.5*N) GO TO 510
      IF(KEY.EQ.1 .AND. LW.LT.4*N) GO TO 510
      IF(KEY.EQ.2 .AND. LW.LT.4*N) GO TO 510
      IF(KEY.EQ.3 .AND. LW.LT.3*N) GO TO 510
      IF(NP.LT.0 .OR. NP.GT.N) GO TO 516
C
      EPS=10.*R1MACH(4)
      N1=1
      N2=N1+N
      N3=N2+N
      N4=N3+N
      N5=N4+N
C
      IF(KEY.EQ.1) GO TO 100
      IF(KEY.EQ.2) GO TO 200
      IF(KEY.EQ.3) GO TO 300
C
      IF(RE(1).LT.0.0) GO TO 511
      IF(RE(1).GT.1.0) GO TO 512
      IF(RE(1).LT.EPS) RE(1)=EPS
      IF(AE(1).LT.0.0) GO TO 513
      DO 20 I=1,N
      W(N4-1+I)=RE(1)
      W(N5-1+I)=AE(1)
   20 CONTINUE
      CALL U11LS(A,MDA,M,N,W(N4),W(N5),MODE,NP,KRANK,KSURE,
     1            W(N1),W(N2),W(N3),IWORK(N1),IWORK(N2))
      GO TO 400
C
  100 CONTINUE
      IF(AE(1).LT.0.0) GO TO 513
      DO 120 I=1,N
      IF(RE(I).LT.0.0) GO TO 511
      IF(RE(I).GT.1.0) GO TO 512
      IF(RE(I).LT.EPS) RE(I)=EPS
      W(N4-1+I)=AE(1)
  120 CONTINUE
      CALL U11LS(A,MDA,M,N,RE,W(N4),MODE,NP,KRANK,KSURE,
     1            W(N1),W(N2),W(N3),IWORK(N1),IWORK(N2))
      GO TO 400
C
  200 CONTINUE
      IF(RE(1).LT.0.0) GO TO 511
      IF(RE(1).GT.1.0) GO TO 512
      IF(RE(1).LT.EPS) RE(1)=EPS
      DO 220 I=1,N
      W(N4-1+I)=RE(1)
      IF(AE(I).LT.0.0) GO TO 513
  220 CONTINUE
      CALL U11LS(A,MDA,M,N,W(N4),AE,MODE,NP,KRANK,KSURE,
     1            W(N1),W(N2),W(N3),IWORK(N1),IWORK(N2))
      GO TO 400
C
  300 CONTINUE
      DO 320 I=1,N
      IF(RE(I).LT.0.0) GO TO 511
      IF(RE(I).GT.1.0) GO TO 512
      IF(RE(I).LT.EPS) RE(I)=EPS
      IF(AE(I).LT.0.0) GO TO 513
  320 CONTINUE
      CALL U11LS(A,MDA,M,N,RE,AE,MODE,NP,KRANK,KSURE,
     1            W(N1),W(N2),W(N3),IWORK(N1),IWORK(N2))
C
C     DETERMINE INFO
C
  400 IF(KRANK.NE.N) GO TO 402
          INFO=5
          GO TO 410
  402 IF(KRANK.NE.0) GO TO 404
          INFO=3
          GO TO 410
  404 IF(KRANK.GE.NP) GO TO 406
          INFO=4
          RETURN
  406 INFO=MODE
      IF(MODE.EQ.0) RETURN
  410 IF(NB.EQ.0) RETURN
C
C     SOLUTION PHASE
C
      N1=1
      N2=N1+N
      N3=N2+N
      IF(INFO.EQ.2) GO TO 420
      IF(LW.LT.N2-1) GO TO 510
      CALL U12LS(A,MDA,M,N,B,MDB,NB,MODE,KRANK,
     1            RNORM,W(N1),W(N1),IWORK(N1),IWORK(N2))
      RETURN
C
  420 IF(LW.LT.N3-1) GO TO 510
      CALL U12LS(A,MDA,M,N,B,MDB,NB,MODE,KRANK,
     1            RNORM,W(N1),W(N2),IWORK(N1),IWORK(N2))
      RETURN
C
C     ERROR MESSAGES
C
  501 CALL XERMSG ('SLATEC', 'LLSIA',
     +   'SOLUTION ONLY (INFO=1) BUT NO RIGHT HAND SIDE (NB=0)', 1, 0)
      RETURN
  502 CALL XERMSG ('SLATEC', 'LLSIA', 'M.LT.1', 2, 1)
      RETURN
  503 CALL XERMSG ('SLATEC', 'LLSIA', 'N.LT.1', 2, 1)
      RETURN
  504 CALL XERMSG ('SLATEC', 'LLSIA', 'N.GT.M', 2, 1)
      RETURN
  505 CALL XERMSG ('SLATEC', 'LLSIA', 'MDA.LT.M', 2, 1)
      RETURN
  506 CALL XERMSG ('SLATEC', 'LLSIA', 'LIW.LT.M+N', 2, 1)
      RETURN
  507 CALL XERMSG ('SLATEC', 'LLSIA', 'NB.LT.0', 2, 1)
      RETURN
  508 CALL XERMSG ('SLATEC', 'LLSIA', 'MDB.LT.M', 2, 1)
      RETURN
  509 CALL XERMSG ('SLATEC', 'LLSIA', 'KEY OUT OF RANGE', 2, 1)
      RETURN
  510 CALL XERMSG ('SLATEC', 'LLSIA', 'INSUFFICIENT WORK SPACE', 8, 1)
      INFO=-1
      RETURN
  511 CALL XERMSG ('SLATEC', 'LLSIA', 'RE(I) .LT. 0', 2, 1)
      RETURN
  512 CALL XERMSG ('SLATEC', 'LLSIA', 'RE(I) .GT. 1', 2, 1)
      RETURN
  513 CALL XERMSG ('SLATEC', 'LLSIA', 'AE(I) .LT. 0', 2, 1)
      RETURN
  514 CALL XERMSG ('SLATEC', 'LLSIA', 'INFO OUT OF RANGE', 2, 1)
      RETURN
  515 CALL XERMSG ('SLATEC', 'LLSIA', 'MODE OUT OF RANGE', 2, 1)
      RETURN
  516 CALL XERMSG ('SLATEC', 'LLSIA', 'NP OUT OF RANGE', 2, 1)
      RETURN
      END
*DECK LMPAR
      SUBROUTINE LMPAR (N, R, LDR, IPVT, DIAG, QTB, DELTA, PAR, X,
     +   SIGMA, WA1, WA2)
C***BEGIN PROLOGUE  LMPAR
C***SUBSIDIARY
C***PURPOSE  Subsidiary to SNLS1 and SNLS1E
C***LIBRARY   SLATEC
C***TYPE      SINGLE PRECISION (LMPAR-S, DMPAR-D)
C***AUTHOR  (UNKNOWN)
C***DESCRIPTION
C
C     Given an M by N matrix A, an N by N nonsingular DIAGONAL
C     matrix D, an M-vector B, and a positive number DELTA,
C     the problem is to determine a value for the parameter
C     PAR such that if X solves the system
C
C           A*X = B ,     SQRT(PAR)*D*X = 0 ,
C
C     in the least squares sense, and DXNORM is the Euclidean
C     norm of D*X, then either PAR is zero and
C
C           (DXNORM-DELTA) .LE. 0.1*DELTA ,
C
C     or PAR is positive and
C
C           ABS(DXNORM-DELTA) .LE. 0.1*DELTA .
C
C     This subroutine completes the solution of the problem
C     if it is provided with the necessary information from the
C     QR factorization, with column pivoting, of A. That is, if
C     A*P = Q*R, where P is a permutation matrix, Q has orthogonal
C     columns, and R is an upper triangular matrix with diagonal
C     elements of nonincreasing magnitude, then LMPAR expects
C     the full upper triangle of R, the permutation matrix P,
C     and the first N components of (Q TRANSPOSE)*B. On output
C     LMPAR also provides an upper triangular matrix S such that
C
C            T   T                   T
C           P *(A *A + PAR*D*D)*P = S *S .
C
C     S is employed within LMPAR and may be of separate interest.
C
C     Only a few iterations are generally needed for convergence
C     of the algorithm. If, however, the limit of 10 iterations
C     is reached, then the output PAR will contain the best
C     value obtained so far.
C
C     The subroutine statement is
C
C       SUBROUTINE LMPAR(N,R,LDR,IPVT,DIAG,QTB,DELTA,PAR,X,SIGMA,
C                        WA1,WA2)
C
C     where
C
C       N is a positive integer input variable set to the order of R.
C
C       R is an N by N array. On input the full upper triangle
C         must contain the full upper triangle of the matrix R.
C         On output the full upper triangle is unaltered, and the
C         strict lower triangle contains the strict upper triangle
C         (transposed) of the upper triangular matrix S.
C
C       LDR is a positive integer input variable not less than N
C         which specifies the leading dimension of the array R.
C
C       IPVT is an integer input array of length N which defines the
C         permutation matrix P such that A*P = Q*R. Column J of P
C         is column IPVT(J) of the identity matrix.
C
C       DIAG is an input array of length N which must contain the
C         diagonal elements of the matrix D.
C
C       QTB is an input array of length N which must contain the first
C         N elements of the vector (Q TRANSPOSE)*B.
C
C       DELTA is a positive input variable which specifies an upper
C         bound on the Euclidean norm of D*X.
C
C       PAR is a nonnegative variable. On input PAR contains an
C         initial estimate of the Levenberg-Marquardt parameter.
C         On output PAR contains the final estimate.
C
C       X is an output array of length N which contains the least
C         squares solution of the system A*X = B, SQRT(PAR)*D*X = 0,
C         for the output PAR.
C
C       SIGMA is an output array of length N which contains the
C         diagonal elements of the upper triangular matrix S.
C
C       WA1 and WA2 are work arrays of length N.
C
C***SEE ALSO  SNLS1, SNLS1E
C***ROUTINES CALLED  ENORM, QRSOLV, R1MACH
C***REVISION HISTORY  (YYMMDD)
C   800301  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890831  Modified array declarations.  (WRB)
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900326  Removed duplicate information from DESCRIPTION section.
C           (WRB)
C   900328  Added TYPE section.  (WRB)
C***END PROLOGUE  LMPAR
      INTEGER N,LDR
      INTEGER IPVT(*)
      REAL DELTA,PAR
      REAL R(LDR,*),DIAG(*),QTB(*),X(*),SIGMA(*),WA1(*),WA2(*)
      INTEGER I,ITER,J,JM1,JP1,K,L,NSING
      REAL DXNORM,DWARF,FP,GNORM,PARC,PARL,PARU,P1,P001,SUM,TEMP,ZERO
      REAL R1MACH,ENORM
      SAVE P1, P001, ZERO
      DATA P1,P001,ZERO /1.0E-1,1.0E-3,0.0E0/
C***FIRST EXECUTABLE STATEMENT  LMPAR
      DWARF = R1MACH(1)
C
C     COMPUTE AND STORE IN X THE GAUSS-NEWTON DIRECTION. IF THE
C     JACOBIAN IS RANK-DEFICIENT, OBTAIN A LEAST SQUARES SOLUTION.
C
      NSING = N
      DO 10 J = 1, N
         WA1(J) = QTB(J)
         IF (R(J,J) .EQ. ZERO .AND. NSING .EQ. N) NSING = J - 1
         IF (NSING .LT. N) WA1(J) = ZERO
   10    CONTINUE
      IF (NSING .LT. 1) GO TO 50
      DO 40 K = 1, NSING
         J = NSING - K + 1
         WA1(J) = WA1(J)/R(J,J)
         TEMP = WA1(J)
         JM1 = J - 1
         IF (JM1 .LT. 1) GO TO 30
         DO 20 I = 1, JM1
            WA1(I) = WA1(I) - R(I,J)*TEMP
   20       CONTINUE
   30    CONTINUE
   40    CONTINUE
   50 CONTINUE
      DO 60 J = 1, N
         L = IPVT(J)
         X(L) = WA1(J)
   60    CONTINUE
C
C     INITIALIZE THE ITERATION COUNTER.
C     EVALUATE THE FUNCTION AT THE ORIGIN, AND TEST
C     FOR ACCEPTANCE OF THE GAUSS-NEWTON DIRECTION.
C
      ITER = 0
      DO 70 J = 1, N
         WA2(J) = DIAG(J)*X(J)
   70    CONTINUE
      DXNORM = ENORM(N,WA2)
      FP = DXNORM - DELTA
      IF (FP .LE. P1*DELTA) GO TO 220
C
C     IF THE JACOBIAN IS NOT RANK DEFICIENT, THE NEWTON
C     STEP PROVIDES A LOWER BOUND, PARL, FOR THE ZERO OF
C     THE FUNCTION. OTHERWISE SET THIS BOUND TO ZERO.
C
      PARL = ZERO
      IF (NSING .LT. N) GO TO 120
      DO 80 J = 1, N
         L = IPVT(J)
         WA1(J) = DIAG(L)*(WA2(L)/DXNORM)
   80    CONTINUE
      DO 110 J = 1, N
         SUM = ZERO
         JM1 = J - 1
         IF (JM1 .LT. 1) GO TO 100
         DO 90 I = 1, JM1
            SUM = SUM + R(I,J)*WA1(I)
   90       CONTINUE
  100    CONTINUE
         WA1(J) = (WA1(J) - SUM)/R(J,J)
  110    CONTINUE
      TEMP = ENORM(N,WA1)
      PARL = ((FP/DELTA)/TEMP)/TEMP
  120 CONTINUE
C
C     CALCULATE AN UPPER BOUND, PARU, FOR THE ZERO OF THE FUNCTION.
C
      DO 140 J = 1, N
         SUM = ZERO
         DO 130 I = 1, J
            SUM = SUM + R(I,J)*QTB(I)
  130       CONTINUE
         L = IPVT(J)
         WA1(J) = SUM/DIAG(L)
  140    CONTINUE
      GNORM = ENORM(N,WA1)
      PARU = GNORM/DELTA
      IF (PARU .EQ. ZERO) PARU = DWARF/MIN(DELTA,P1)
C
C     IF THE INPUT PAR LIES OUTSIDE OF THE INTERVAL (PARL,PARU),
C     SET PAR TO THE CLOSER ENDPOINT.
C
      PAR = MAX(PAR,PARL)
      PAR = MIN(PAR,PARU)
      IF (PAR .EQ. ZERO) PAR = GNORM/DXNORM
C
C     BEGINNING OF AN ITERATION.
C
  150 CONTINUE
         ITER = ITER + 1
C
C        EVALUATE THE FUNCTION AT THE CURRENT VALUE OF PAR.
C
         IF (PAR .EQ. ZERO) PAR = MAX(DWARF,P001*PARU)
         TEMP = SQRT(PAR)
         DO 160 J = 1, N
            WA1(J) = TEMP*DIAG(J)
  160       CONTINUE
         CALL QRSOLV(N,R,LDR,IPVT,WA1,QTB,X,SIGMA,WA2)
         DO 170 J = 1, N
            WA2(J) = DIAG(J)*X(J)
  170       CONTINUE
         DXNORM = ENORM(N,WA2)
         TEMP = FP
         FP = DXNORM - DELTA
C
C        IF THE FUNCTION IS SMALL ENOUGH, ACCEPT THE CURRENT VALUE
C        OF PAR. ALSO TEST FOR THE EXCEPTIONAL CASES WHERE PARL
C        IS ZERO OR THE NUMBER OF ITERATIONS HAS REACHED 10.
C
         IF (ABS(FP) .LE. P1*DELTA
     1       .OR. PARL .EQ. ZERO .AND. FP .LE. TEMP
     2            .AND. TEMP .LT. ZERO .OR. ITER .EQ. 10) GO TO 220
C
C        COMPUTE THE NEWTON CORRECTION.
C
         DO 180 J = 1, N
            L = IPVT(J)
            WA1(J) = DIAG(L)*(WA2(L)/DXNORM)
  180       CONTINUE
         DO 210 J = 1, N
            WA1(J) = WA1(J)/SIGMA(J)
            TEMP = WA1(J)
            JP1 = J + 1
            IF (N .LT. JP1) GO TO 200
            DO 190 I = JP1, N
               WA1(I) = WA1(I) - R(I,J)*TEMP
  190          CONTINUE
  200       CONTINUE
  210       CONTINUE
         TEMP = ENORM(N,WA1)
         PARC = ((FP/DELTA)/TEMP)/TEMP
C
C        DEPENDING ON THE SIGN OF THE FUNCTION, UPDATE PARL OR PARU.
C
         IF (FP .GT. ZERO) PARL = MAX(PARL,PAR)
         IF (FP .LT. ZERO) PARU = MIN(PARU,PAR)
C
C        COMPUTE AN IMPROVED ESTIMATE FOR PAR.
C
         PAR = MAX(PARL,PAR+PARC)
C
C        END OF AN ITERATION.
C
         GO TO 150
  220 CONTINUE
C
C     TERMINATION.
C
      IF (ITER .EQ. 0) PAR = ZERO
      RETURN
C
C     LAST CARD OF SUBROUTINE LMPAR.
C
      END
*DECK LPDP
      SUBROUTINE LPDP (A, MDA, M, N1, N2, PRGOPT, X, WNORM, MODE, WS,
     +   IS)
C***BEGIN PROLOGUE  LPDP
C***SUBSIDIARY
C***PURPOSE  Subsidiary to LSEI
C***LIBRARY   SLATEC
C***TYPE      SINGLE PRECISION (LPDP-S, DLPDP-D)
C***AUTHOR  Hanson, R. J., (SNLA)
C           Haskell, K. H., (SNLA)
C***DESCRIPTION
C
C     DIMENSION A(MDA,N+1),PRGOPT(*),X(N),WS((M+2)*(N+7)),IS(M+N+1),
C     where N=N1+N2.  This is a slight overestimate for WS(*).
C
C     Determine an N1-vector W, and
C               an N2-vector Z
C     which minimizes the Euclidean length of W
C     subject to G*W+H*Z .GE. Y.
C     This is the least projected distance problem, LPDP.
C     The matrices G and H are of respective
C     dimensions M by N1 and M by N2.
C
C     Called by subprogram LSI( ).
C
C     The matrix
C                (G H Y)
C
C     occupies rows 1,...,M and cols 1,...,N1+N2+1 of A(*,*).
C
C     The solution (W) is returned in X(*).
C                  (Z)
C
C     The value of MODE indicates the status of
C     the computation after returning to the user.
C
C          MODE=1  The solution was successfully obtained.
C
C          MODE=2  The inequalities are inconsistent.
C
C***SEE ALSO  LSEI
C***ROUTINES CALLED  SCOPY, SDOT, SNRM2, SSCAL, WNNLS
C***REVISION HISTORY  (YYMMDD)
C   790701  DATE WRITTEN
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900328  Added TYPE section.  (WRB)
C   910408  Updated the AUTHOR section.  (WRB)
C***END PROLOGUE  LPDP
C
C     SUBROUTINES CALLED
C
C     WNNLS         SOLVES A NONNEGATIVELY CONSTRAINED LINEAR LEAST
C                   SQUARES PROBLEM WITH LINEAR EQUALITY CONSTRAINTS.
C                   PART OF THIS PACKAGE.
C
C++
C     SDOT,         SUBROUTINES FROM THE BLAS PACKAGE.
C     SSCAL,SNRM2,  SEE TRANS. MATH. SOFT., VOL. 5, NO. 3, P. 308.
C     SCOPY
C
      REAL             A(MDA,*), PRGOPT(*), WS(*), WNORM, X(*)
      INTEGER IS(*)
      REAL             FAC, ONE, RNORM, SC, YNORM, ZERO
      REAL             SDOT, SNRM2
      SAVE ZERO, ONE, FAC
      DATA ZERO, ONE /0.E0,1.E0/, FAC /0.1E0/
C***FIRST EXECUTABLE STATEMENT  LPDP
      N = N1 + N2
      MODE = 1
      IF (.NOT.(M.LE.0)) GO TO 20
      IF (.NOT.(N.GT.0)) GO TO 10
      X(1) = ZERO
      CALL SCOPY(N, X, 0, X, 1)
   10 WNORM = ZERO
      RETURN
   20 NP1 = N + 1
C
C     SCALE NONZERO ROWS OF INEQUALITY MATRIX TO HAVE LENGTH ONE.
      DO 40 I=1,M
        SC = SNRM2(N,A(I,1),MDA)
        IF (.NOT.(SC.NE.ZERO)) GO TO 30
        SC = ONE/SC
        CALL SSCAL(NP1, SC, A(I,1), MDA)
   30   CONTINUE
   40 CONTINUE
C
C     SCALE RT.-SIDE VECTOR TO HAVE LENGTH ONE (OR ZERO).
      YNORM = SNRM2(M,A(1,NP1),1)
      IF (.NOT.(YNORM.NE.ZERO)) GO TO 50
      SC = ONE/YNORM
      CALL SSCAL(M, SC, A(1,NP1), 1)
C
C     SCALE COLS OF MATRIX H.
   50 J = N1 + 1
   60 IF (.NOT.(J.LE.N)) GO TO 70
      SC = SNRM2(M,A(1,J),1)
      IF (SC.NE.ZERO) SC = ONE/SC
      CALL SSCAL(M, SC, A(1,J), 1)
      X(J) = SC
      J = J + 1
      GO TO 60
   70 IF (.NOT.(N1.GT.0)) GO TO 130
C
C     COPY TRANSPOSE OF (H G Y) TO WORK ARRAY WS(*).
      IW = 0
      DO 80 I=1,M
C
C     MOVE COL OF TRANSPOSE OF H INTO WORK ARRAY.
        CALL SCOPY(N2, A(I,N1+1), MDA, WS(IW+1), 1)
        IW = IW + N2
C
C     MOVE COL OF TRANSPOSE OF G INTO WORK ARRAY.
        CALL SCOPY(N1, A(I,1), MDA, WS(IW+1), 1)
        IW = IW + N1
C
C     MOVE COMPONENT OF VECTOR Y INTO WORK ARRAY.
        WS(IW+1) = A(I,NP1)
        IW = IW + 1
   80 CONTINUE
      WS(IW+1) = ZERO
      CALL SCOPY(N, WS(IW+1), 0, WS(IW+1), 1)
      IW = IW + N
      WS(IW+1) = ONE
      IW = IW + 1
C
C     SOLVE EU=F SUBJECT TO (TRANSPOSE OF H)U=0, U.GE.0.  THE
C     MATRIX E = TRANSPOSE OF (G Y), AND THE (N+1)-VECTOR
C     F = TRANSPOSE OF (0,...,0,1).
      IX = IW + 1
      IW = IW + M
C
C     DO NOT CHECK LENGTHS OF WORK ARRAYS IN THIS USAGE OF WNNLS( ).
      IS(1) = 0
      IS(2) = 0
      CALL WNNLS(WS, NP1, N2, NP1-N2, M, 0, PRGOPT, WS(IX), RNORM,
     1 MODEW, IS, WS(IW+1))
C
C     COMPUTE THE COMPONENTS OF THE SOLN DENOTED ABOVE BY W.
      SC = ONE - SDOT(M,A(1,NP1),1,WS(IX),1)
      IF (.NOT.(ONE+FAC*ABS(SC).NE.ONE .AND. RNORM.GT.ZERO)) GO TO 110
      SC = ONE/SC
      DO 90 J=1,N1
        X(J) = SC*SDOT(M,A(1,J),1,WS(IX),1)
   90 CONTINUE
C
C     COMPUTE THE VECTOR Q=Y-GW.  OVERWRITE Y WITH THIS VECTOR.
      DO 100 I=1,M
        A(I,NP1) = A(I,NP1) - SDOT(N1,A(I,1),MDA,X,1)
  100 CONTINUE
      GO TO 120
  110 MODE = 2
      RETURN
  120 CONTINUE
  130 IF (.NOT.(N2.GT.0)) GO TO 180
C
C     COPY TRANSPOSE OF (H Q) TO WORK ARRAY WS(*).
      IW = 0
      DO 140 I=1,M
        CALL SCOPY(N2, A(I,N1+1), MDA, WS(IW+1), 1)
        IW = IW + N2
        WS(IW+1) = A(I,NP1)
        IW = IW + 1
  140 CONTINUE
      WS(IW+1) = ZERO
      CALL SCOPY(N2, WS(IW+1), 0, WS(IW+1), 1)
      IW = IW + N2
      WS(IW+1) = ONE
      IW = IW + 1
      IX = IW + 1
      IW = IW + M
C
C     SOLVE RV=S SUBJECT TO V.GE.0.  THE MATRIX R =(TRANSPOSE
C     OF (H Q)), WHERE Q=Y-GW.  THE (N2+1)-VECTOR S =(TRANSPOSE
C     OF (0,...,0,1)).
C
C     DO NOT CHECK LENGTHS OF WORK ARRAYS IN THIS USAGE OF WNNLS( ).
      IS(1) = 0
      IS(2) = 0
      CALL WNNLS(WS, N2+1, 0, N2+1, M, 0, PRGOPT, WS(IX), RNORM, MODEW,
     1 IS, WS(IW+1))
C
C     COMPUTE THE COMPONENTS OF THE SOLN DENOTED ABOVE BY Z.
      SC = ONE - SDOT(M,A(1,NP1),1,WS(IX),1)
      IF (.NOT.(ONE+FAC*ABS(SC).NE.ONE .AND. RNORM.GT.ZERO)) GO TO 160
      SC = ONE/SC
      DO 150 J=1,N2
        L = N1 + J
        X(L) = SC*SDOT(M,A(1,L),1,WS(IX),1)*X(L)
  150 CONTINUE
      GO TO 170
  160 MODE = 2
      RETURN
  170 CONTINUE
C
C     ACCOUNT FOR SCALING OF RT.-SIDE VECTOR IN SOLUTION.
  180 CALL SSCAL(N, YNORM, X, 1)
      WNORM = SNRM2(N1,X,1)
      RETURN
      END
*DECK LSAME
      LOGICAL FUNCTION LSAME (CA, CB)
C***BEGIN PROLOGUE  LSAME
C***SUBSIDIARY
C***PURPOSE  Test two characters to determine if they are the same
C            letter, except for case.
C***LIBRARY   SLATEC
C***CATEGORY  R, N3
C***TYPE      LOGICAL (LSAME-L)
C***KEYWORDS  CHARACTER COMPARISON, LEVEL 2 BLAS, LEVEL 3 BLAS
C***AUTHOR  Hanson, R., (SNLA)
C           Du Croz, J., (NAG)
C***DESCRIPTION
C
C  LSAME  tests if CA is the same letter as CB regardless of case.
C  CB is assumed to be an upper case letter. LSAME returns .TRUE. if
C  CA is either the same as CB or the equivalent lower case letter.
C
C  N.B. This version of the code is correct for both ASCII and EBCDIC
C       systems.  Installers must modify the routine for other
C       character-codes.
C
C       For CDC systems using 6-12 bit representations, the system-
C       specific code in comments must be activated.
C
C  Parameters
C  ==========
C
C  CA     - CHARACTER*1
C  CB     - CHARACTER*1
C           On entry, CA and CB specify characters to be compared.
C           Unchanged on exit.
C
C***REFERENCES  (NONE)
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   860720  DATE WRITTEN
C   910606  Modified to meet SLATEC prologue standards.  Only comment
C           lines were modified.  (BKS)
C   910607  Modified to handle ASCII and EBCDIC codes.  (WRB)
C   930201  Tests for equality and equivalence combined.  (RWC and WRB)
C***END PROLOGUE  LSAME
C     .. Scalar Arguments ..
      CHARACTER CA*1, CB*1
C     .. Local Scalars ..
      INTEGER IOFF
      LOGICAL FIRST
C     .. Intrinsic Functions ..
      INTRINSIC ICHAR
C     .. Save statement ..
      SAVE FIRST, IOFF
C     .. Data statements ..
      DATA FIRST /.TRUE./
C***FIRST EXECUTABLE STATEMENT  LSAME
      IF (FIRST) IOFF = ICHAR('a') - ICHAR('A')
C
      FIRST = .FALSE.
C
C     Test if the characters are equal or equivalent.
C
      LSAME = (CA.EQ.CB) .OR. (ICHAR(CA)-IOFF.EQ.ICHAR(CB))
C
      RETURN
C
C  The following comments contain code for CDC systems using 6-12 bit
C  representations.
C
C     .. Parameters ..
C     INTEGER                ICIRFX
C     PARAMETER            ( ICIRFX=62 )
C     .. Scalar Arguments ..
C     CHARACTER*1            CB
C     .. Array Arguments ..
C     CHARACTER*1            CA(*)
C     .. Local Scalars ..
C     INTEGER                IVAL
C     .. Intrinsic Functions ..
C     INTRINSIC              ICHAR, CHAR
C     .. Executable Statements ..
C     INTRINSIC              ICHAR, CHAR
C
C     See if the first character in string CA equals string CB.
C
C     LSAME = CA(1) .EQ. CB .AND. CA(1) .NE. CHAR(ICIRFX)
C
C     IF (LSAME) RETURN
C
C     The characters are not identical. Now check them for equivalence.
C     Look for the 'escape' character, circumflex, followed by the
C     letter.
C
C     IVAL = ICHAR(CA(2))
C     IF (IVAL.GE.ICHAR('A') .AND. IVAL.LE.ICHAR('Z')) THEN
C        LSAME = CA(1) .EQ. CHAR(ICIRFX) .AND. CA(2) .EQ. CB
C     ENDIF
C
C     RETURN
C
C     End of LSAME.
C
      END
*DECK LSEI
      SUBROUTINE LSEI (W, MDW, ME, MA, MG, N, PRGOPT, X, RNORME, RNORML,
     +   MODE, WS, IP)
C***BEGIN PROLOGUE  LSEI
C***PURPOSE  Solve a linearly constrained least squares problem with
C            equality and inequality constraints, and optionally compute
C            a covariance matrix.
C***LIBRARY   SLATEC
C***CATEGORY  K1A2A, D9
C***TYPE      SINGLE PRECISION (LSEI-S, DLSEI-D)
C***KEYWORDS  CONSTRAINED LEAST SQUARES, CURVE FITTING, DATA FITTING,
C             EQUALITY CONSTRAINTS, INEQUALITY CONSTRAINTS,
C             QUADRATIC PROGRAMMING
C***AUTHOR  Hanson, R. J., (SNLA)
C           Haskell, K. H., (SNLA)
C***DESCRIPTION
C
C     Abstract
C
C     This subprogram solves a linearly constrained least squares
C     problem with both equality and inequality constraints, and, if the
C     user requests, obtains a covariance matrix of the solution
C     parameters.
C
C     Suppose there are given matrices E, A and G of respective
C     dimensions ME by N, MA by N and MG by N, and vectors F, B and H of
C     respective lengths ME, MA and MG.  This subroutine solves the
C     linearly constrained least squares problem
C
C                   EX = F, (E ME by N) (equations to be exactly
C                                       satisfied)
C                   AX = B, (A MA by N) (equations to be
C                                       approximately satisfied,
C                                       least squares sense)
C                   GX .GE. H,(G MG by N) (inequality constraints)
C
C     The inequalities GX .GE. H mean that every component of the
C     product GX must be .GE. the corresponding component of H.
C
C     In case the equality constraints cannot be satisfied, a
C     generalized inverse solution residual vector length is obtained
C     for F-EX.  This is the minimal length possible for F-EX.
C
C     Any values ME .GE. 0, MA .GE. 0, or MG .GE. 0 are permitted.  The
C     rank of the matrix E is estimated during the computation.  We call
C     this value KRANKE.  It is an output parameter in IP(1) defined
C     below.  Using a generalized inverse solution of EX=F, a reduced
C     least squares problem with inequality constraints is obtained.
C     The tolerances used in these tests for determining the rank
C     of E and the rank of the reduced least squares problem are
C     given in Sandia Tech. Rept. SAND-78-1290.  They can be
C     modified by the user if new values are provided in
C     the option list of the array PRGOPT(*).
C
C     The user must dimension all arrays appearing in the call list..
C     W(MDW,N+1),PRGOPT(*),X(N),WS(2*(ME+N)+K+(MG+2)*(N+7)),IP(MG+2*N+2)
C     where K=MAX(MA+MG,N).  This allows for a solution of a range of
C     problems in the given working space.  The dimension of WS(*)
C     given is a necessary overestimate.  Once a particular problem
C     has been run, the output parameter IP(3) gives the actual
C     dimension required for that problem.
C
C     The parameters for LSEI( ) are
C
C     Input..
C
C     W(*,*),MDW,   The array W(*,*) is doubly subscripted with
C     ME,MA,MG,N    first dimensioning parameter equal to MDW.
C                   For this discussion let us call M = ME+MA+MG.  Then
C                   MDW must satisfy MDW .GE. M.  The condition
C                   MDW .LT. M is an error.
C
C                   The array W(*,*) contains the matrices and vectors
C
C                                  (E  F)
C                                  (A  B)
C                                  (G  H)
C
C                   in rows and columns 1,...,M and 1,...,N+1
C                   respectively.
C
C                   The integers ME, MA, and MG are the
C                   respective matrix row dimensions
C                   of E, A and G.  Each matrix has N columns.
C
C     PRGOPT(*)    This real-valued array is the option vector.
C                  If the user is satisfied with the nominal
C                  subprogram features set
C
C                  PRGOPT(1)=1 (or PRGOPT(1)=1.0)
C
C                  Otherwise PRGOPT(*) is a linked list consisting of
C                  groups of data of the following form
C
C                  LINK
C                  KEY
C                  DATA SET
C
C                  The parameters LINK and KEY are each one word.
C                  The DATA SET can be comprised of several words.
C                  The number of items depends on the value of KEY.
C                  The value of LINK points to the first
C                  entry of the next group of data within
C                  PRGOPT(*).  The exception is when there are
C                  no more options to change.  In that
C                  case, LINK=1 and the values KEY and DATA SET
C                  are not referenced.  The general layout of
C                  PRGOPT(*) is as follows.
C
C               ...PRGOPT(1) = LINK1 (link to first entry of next group)
C               .  PRGOPT(2) = KEY1 (key to the option change)
C               .  PRGOPT(3) = data value (data value for this change)
C               .       .
C               .       .
C               .       .
C               ...PRGOPT(LINK1)   = LINK2 (link to the first entry of
C               .                       next group)
C               .  PRGOPT(LINK1+1) = KEY2 (key to the option change)
C               .  PRGOPT(LINK1+2) = data value
C               ...     .
C               .       .
C               .       .
C               ...PRGOPT(LINK) = 1 (no more options to change)
C
C                  Values of LINK that are nonpositive are errors.
C                  A value of LINK .GT. NLINK=100000 is also an error.
C                  This helps prevent using invalid but positive
C                  values of LINK that will probably extend
C                  beyond the program limits of PRGOPT(*).
C                  Unrecognized values of KEY are ignored.  The
C                  order of the options is arbitrary and any number
C                  of options can be changed with the following
C                  restriction.  To prevent cycling in the
C                  processing of the option array, a count of the
C                  number of options changed is maintained.
C                  Whenever this count exceeds NOPT=1000, an error
C                  message is printed and the subprogram returns.
C
C                  Options..
C
C                  KEY=1
C                         Compute in W(*,*) the N by N
C                  covariance matrix of the solution variables
C                  as an output parameter.  Nominally the
C                  covariance matrix will not be computed.
C                  (This requires no user input.)
C                  The data set for this option is a single value.
C                  It must be nonzero when the covariance matrix
C                  is desired.  If it is zero, the covariance
C                  matrix is not computed.  When the covariance matrix
C                  is computed, the first dimensioning parameter
C                  of the array W(*,*) must satisfy MDW .GE. MAX(M,N).
C
C                  KEY=10
C                         Suppress scaling of the inverse of the
C                  normal matrix by the scale factor RNORM**2/
C                  MAX(1, no. of degrees of freedom).  This option
C                  only applies when the option for computing the
C                  covariance matrix (KEY=1) is used.  With KEY=1 and
C                  KEY=10 used as options the unscaled inverse of the
C                  normal matrix is returned in W(*,*).
C                  The data set for this option is a single value.
C                  When it is nonzero no scaling is done.  When it is
C                  zero scaling is done.  The nominal case is to do
C                  scaling so if option (KEY=1) is used alone, the
C                  matrix will be scaled on output.
C
C                  KEY=2
C                         Scale the nonzero columns of the
C                         entire data matrix.
C                  (E)
C                  (A)
C                  (G)
C
C                  to have length one.  The data set for this
C                  option is a single value.  It must be
C                  nonzero if unit length column scaling
C                  is desired.
C
C                  KEY=3
C                         Scale columns of the entire data matrix
C                  (E)
C                  (A)
C                  (G)
C
C                  with a user-provided diagonal matrix.
C                  The data set for this option consists
C                  of the N diagonal scaling factors, one for
C                  each matrix column.
C
C                  KEY=4
C                         Change the rank determination tolerance for
C                  the equality constraint equations from
C                  the nominal value of SQRT(SRELPR).  This quantity can
C                  be no smaller than SRELPR, the arithmetic-
C                  storage precision.  The quantity SRELPR is the
C                  largest positive number such that T=1.+SRELPR
C                  satisfies T .EQ. 1.  The quantity used
C                  here is internally restricted to be at
C                  least SRELPR.  The data set for this option
C                  is the new tolerance.
C
C                  KEY=5
C                         Change the rank determination tolerance for
C                  the reduced least squares equations from
C                  the nominal value of SQRT(SRELPR).  This quantity can
C                  be no smaller than SRELPR, the arithmetic-
C                  storage precision.  The quantity used
C                  here is internally restricted to be at
C                  least SRELPR.  The data set for this option
C                  is the new tolerance.
C
C                  For example, suppose we want to change
C                  the tolerance for the reduced least squares
C                  problem, compute the covariance matrix of
C                  the solution parameters, and provide
C                  column scaling for the data matrix.  For
C                  these options the dimension of PRGOPT(*)
C                  must be at least N+9.  The Fortran statements
C                  defining these options would be as follows:
C
C                  PRGOPT(1)=4 (link to entry 4 in PRGOPT(*))
C                  PRGOPT(2)=1 (covariance matrix key)
C                  PRGOPT(3)=1 (covariance matrix wanted)
C
C                  PRGOPT(4)=7 (link to entry 7 in PRGOPT(*))
C                  PRGOPT(5)=5 (least squares equas.  tolerance key)
C                  PRGOPT(6)=... (new value of the tolerance)
C
C                  PRGOPT(7)=N+9 (link to entry N+9 in PRGOPT(*))
C                  PRGOPT(8)=3 (user-provided column scaling key)
C
C                  CALL SCOPY (N, D, 1, PRGOPT(9), 1)  (Copy the N
C                    scaling factors from the user array D(*)
C                    to PRGOPT(9)-PRGOPT(N+8))
C
C                  PRGOPT(N+9)=1 (no more options to change)
C
C                  The contents of PRGOPT(*) are not modified
C                  by the subprogram.
C                  The options for WNNLS( ) can also be included
C                  in this array.  The values of KEY recognized
C                  by WNNLS( ) are 6, 7 and 8.  Their functions
C                  are documented in the usage instructions for
C                  subroutine WNNLS( ).  Normally these options
C                  do not need to be modified when using LSEI( ).
C
C     IP(1),       The amounts of working storage actually
C     IP(2)        allocated for the working arrays WS(*) and
C                  IP(*), respectively.  These quantities are
C                  compared with the actual amounts of storage
C                  needed by LSEI( ).  Insufficient storage
C                  allocated for either WS(*) or IP(*) is an
C                  error.  This feature was included in LSEI( )
C                  because miscalculating the storage formulas
C                  for WS(*) and IP(*) might very well lead to
C                  subtle and hard-to-find execution errors.
C
C                  The length of WS(*) must be at least
C
C                  LW = 2*(ME+N)+K+(MG+2)*(N+7)
C
C                  where K = max(MA+MG,N)
C                  This test will not be made if IP(1).LE.0.
C
C                  The length of IP(*) must be at least
C
C                  LIP = MG+2*N+2
C                  This test will not be made if IP(2).LE.0.
C
C     Output..
C
C     X(*),RNORME,  The array X(*) contains the solution parameters
C     RNORML        if the integer output flag MODE = 0 or 1.
C                   The definition of MODE is given directly below.
C                   When MODE = 0 or 1, RNORME and RNORML
C                   respectively contain the residual vector
C                   Euclidean lengths of F - EX and B - AX.  When
C                   MODE=1 the equality constraint equations EX=F
C                   are contradictory, so RNORME .NE. 0.  The residual
C                   vector F-EX has minimal Euclidean length.  For
C                   MODE .GE. 2, none of these parameters is defined.
C
C     MODE          Integer flag that indicates the subprogram
C                   status after completion.  If MODE .GE. 2, no
C                   solution has been computed.
C
C                   MODE =
C
C                   0  Both equality and inequality constraints
C                      are compatible and have been satisfied.
C
C                   1  Equality constraints are contradictory.
C                      A generalized inverse solution of EX=F was used
C                      to minimize the residual vector length F-EX.
C                      In this sense, the solution is still meaningful.
C
C                   2  Inequality constraints are contradictory.
C
C                   3  Both equality and inequality constraints
C                      are contradictory.
C
C                   The following interpretation of
C                   MODE=1,2 or 3 must be made.  The
C                   sets consisting of all solutions
C                   of the equality constraints EX=F
C                   and all vectors satisfying GX .GE. H
C                   have no points in common.  (In
C                   particular this does not say that
C                   each individual set has no points
C                   at all, although this could be the
C                   case.)
C
C                   4  Usage error occurred.  The value
C                      of MDW is .LT. ME+MA+MG, MDW is
C                      .LT. N and a covariance matrix is
C                      requested, or the option vector
C                      PRGOPT(*) is not properly defined,
C                      or the lengths of the working arrays
C                      WS(*) and IP(*), when specified in
C                      IP(1) and IP(2) respectively, are not
C                      long enough.
C
C     W(*,*)        The array W(*,*) contains the N by N symmetric
C                   covariance matrix of the solution parameters,
C                   provided this was requested on input with
C                   the option vector PRGOPT(*) and the output
C                   flag is returned with MODE = 0 or 1.
C
C     IP(*)         The integer working array has three entries
C                   that provide rank and working array length
C                   information after completion.
C
C                      IP(1) = rank of equality constraint
C                              matrix.  Define this quantity
C                              as KRANKE.
C
C                      IP(2) = rank of reduced least squares
C                              problem.
C
C                      IP(3) = the amount of storage in the
C                              working array WS(*) that was
C                              actually used by the subprogram.
C                              The formula given above for the length
C                              of WS(*) is a necessary overestimate.
C                              If exactly the same problem matrices
C                              are used in subsequent executions,
C                              the declared dimension of WS(*) can
C                              be reduced to this output value.
C     User Designated
C     Working Arrays..
C
C     WS(*),IP(*)              These are respectively type real
C                              and type integer working arrays.
C                              Their required minimal lengths are
C                              given above.
C
C***REFERENCES  K. H. Haskell and R. J. Hanson, An algorithm for
C                 linear least squares problems with equality and
C                 nonnegativity constraints, Report SAND77-0552, Sandia
C                 Laboratories, June 1978.
C               K. H. Haskell and R. J. Hanson, Selected algorithms for
C                 the linearly constrained least squares problem - a
C                 users guide, Report SAND78-1290, Sandia Laboratories,
C                 August 1979.
C               K. H. Haskell and R. J. Hanson, An algorithm for
C                 linear least squares problems with equality and
C                 nonnegativity constraints, Mathematical Programming
C                 21 (1981), pp. 98-118.
C               R. J. Hanson and K. H. Haskell, Two algorithms for the
C                 linearly constrained least squares problem, ACM
C                 Transactions on Mathematical Software, September 1982.
C***ROUTINES CALLED  H12, LSI, R1MACH, SASUM, SAXPY, SCOPY, SDOT, SNRM2,
C                    SSCAL, SSWAP, XERMSG
C***REVISION HISTORY  (YYMMDD)
C   790701  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890618  Completely restructured and extensively revised (WRB & RWC)
C   890831  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900315  CALLs to XERROR changed to CALLs to XERMSG.  (THJ)
C   900510  Convert XERRWV calls to XERMSG calls.  (RWC)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  LSEI
      INTEGER IP(3), MA, MDW, ME, MG, MODE, N
      REAL             PRGOPT(*), RNORME, RNORML, W(MDW,*), WS(*), X(*)
C
      EXTERNAL H12, LSI, R1MACH, SASUM, SAXPY, SCOPY, SDOT, SNRM2,
     *   SSCAL, SSWAP, XERMSG
      REAL             R1MACH, SASUM, SDOT, SNRM2
C
      REAL             ENORM, FNORM, GAM, RB, RN, RNMAX, SIZE, SN,
     *   SNMAX, SRELPR, T, TAU, UJ, UP, VJ, XNORM, XNRME
      INTEGER I, IMAX, J, JP1, K, KEY, KRANKE, LAST, LCHK, LINK, M,
     *   MAPKE1, MDEQC, MEND, MEP1, N1, N2, NEXT, NLINK, NOPT, NP1,
     *   NTIMES
      LOGICAL COV, FIRST
      CHARACTER*8 XERN1, XERN2, XERN3, XERN4
      SAVE FIRST, SRELPR
C
      DATA FIRST /.TRUE./
C***FIRST EXECUTABLE STATEMENT  LSEI
C
C     Set the nominal tolerance used in the code for the equality
C     constraint equations.
C
      IF (FIRST) SRELPR = R1MACH(4)
      FIRST = .FALSE.
      TAU = SQRT(SRELPR)
C
C     Check that enough storage was allocated in WS(*) and IP(*).
C
      MODE = 4
      IF (MIN(N,ME,MA,MG) .LT. 0) THEN
         WRITE (XERN1, '(I8)') N
         WRITE (XERN2, '(I8)') ME
         WRITE (XERN3, '(I8)') MA
         WRITE (XERN4, '(I8)') MG
         CALL XERMSG ('SLATEC', 'LSEI', 'ALL OF THE VARIABLES N, ME,' //
     *      ' MA, MG MUST BE .GE. 0$$ENTERED ROUTINE WITH' //
     *      '$$N  = ' // XERN1 //
     *      '$$ME = ' // XERN2 //
     *      '$$MA = ' // XERN3 //
     *      '$$MG = ' // XERN4, 2, 1)
         RETURN
      ENDIF
C
      IF (IP(1).GT.0) THEN
         LCHK = 2*(ME+N) + MAX(MA+MG,N) + (MG+2)*(N+7)
         IF (IP(1).LT.LCHK) THEN
            WRITE (XERN1, '(I8)') LCHK
            CALL XERMSG ('SLATEC', 'LSEI', 'INSUFFICIENT STORAGE ' //
     *         'ALLOCATED FOR WS(*), NEED LW = ' // XERN1, 2, 1)
            RETURN
         ENDIF
      ENDIF
C
      IF (IP(2).GT.0) THEN
         LCHK = MG + 2*N + 2
         IF (IP(2).LT.LCHK) THEN
            WRITE (XERN1, '(I8)') LCHK
            CALL XERMSG ('SLATEC', 'LSEI', 'INSUFFICIENT STORAGE ' //
     *         'ALLOCATED FOR IP(*), NEED LIP = ' // XERN1, 2, 1)
            RETURN
         ENDIF
      ENDIF
C
C     Compute number of possible right multiplying Householder
C     transformations.
C
      M = ME + MA + MG
      IF (N.LE.0 .OR. M.LE.0) THEN
         MODE = 0
         RNORME = 0
         RNORML = 0
         RETURN
      ENDIF
C
      IF (MDW.LT.M) THEN
         CALL XERMSG ('SLATEC', 'LSEI', 'MDW.LT.ME+MA+MG IS AN ERROR',
     +      2, 1)
         RETURN
      ENDIF
C
      NP1 = N + 1
      KRANKE = MIN(ME,N)
      N1 = 2*KRANKE + 1
      N2 = N1 + N
C
C     Set nominal values.
C
C     The nominal column scaling used in the code is
C     the identity scaling.
C
      CALL SCOPY (N, 1.E0, 0, WS(N1), 1)
C
C     No covariance matrix is nominally computed.
C
      COV = .FALSE.
C
C     Process option vector.
C     Define bound for number of options to change.
C
      NOPT = 1000
      NTIMES = 0
C
C     Define bound for positive values of LINK.
C
      NLINK = 100000
      LAST = 1
      LINK = PRGOPT(1)
      IF (LINK.EQ.0 .OR. LINK.GT.NLINK) THEN
         CALL XERMSG ('SLATEC', 'LSEI',
     +      'THE OPTION VECTOR IS UNDEFINED', 2, 1)
         RETURN
      ENDIF
C
  100 IF (LINK.GT.1) THEN
         NTIMES = NTIMES + 1
         IF (NTIMES.GT.NOPT) THEN
            CALL XERMSG ('SLATEC', 'LSEI',
     +         'THE LINKS IN THE OPTION VECTOR ARE CYCLING.', 2, 1)
            RETURN
         ENDIF
C
         KEY = PRGOPT(LAST+1)
         IF (KEY.EQ.1) THEN
            COV = PRGOPT(LAST+2) .NE. 0.E0
         ELSEIF (KEY.EQ.2 .AND. PRGOPT(LAST+2).NE.0.E0) THEN
            DO 110 J = 1,N
               T = SNRM2(M,W(1,J),1)
               IF (T.NE.0.E0) T = 1.E0/T
               WS(J+N1-1) = T
  110       CONTINUE
         ELSEIF (KEY.EQ.3) THEN
            CALL SCOPY (N, PRGOPT(LAST+2), 1, WS(N1), 1)
         ELSEIF (KEY.EQ.4) THEN
            TAU = MAX(SRELPR,PRGOPT(LAST+2))
         ENDIF
C
         NEXT = PRGOPT(LINK)
         IF (NEXT.LE.0 .OR. NEXT.GT.NLINK) THEN
         CALL XERMSG ('SLATEC', 'LSEI',
     +      'THE OPTION VECTOR IS UNDEFINED', 2, 1)
            RETURN
         ENDIF
C
         LAST = LINK
         LINK = NEXT
         GO TO 100
      ENDIF
C
      DO 120 J = 1,N
         CALL SSCAL (M, WS(N1+J-1), W(1,J), 1)
  120 CONTINUE
C
      IF (COV .AND. MDW.LT.N) THEN
         CALL XERMSG ('SLATEC', 'LSEI',
     +      'MDW .LT. N WHEN COV MATRIX NEEDED, IS AN ERROR', 2, 1)
         RETURN
      ENDIF
C
C     Problem definition and option vector OK.
C
      MODE = 0
C
C     Compute norm of equality constraint matrix and right side.
C
      ENORM = 0.E0
      DO 130 J = 1,N
         ENORM = MAX(ENORM,SASUM(ME,W(1,J),1))
  130 CONTINUE
C
      FNORM = SASUM(ME,W(1,NP1),1)
      SNMAX = 0.E0
      RNMAX = 0.E0
      DO 150 I = 1,KRANKE
C
C        Compute maximum ratio of vector lengths. Partition is at
C        column I.
C
         DO 140 K = I,ME
            SN = SDOT(N-I+1,W(K,I),MDW,W(K,I),MDW)
            RN = SDOT(I-1,W(K,1),MDW,W(K,1),MDW)
            IF (RN.EQ.0.E0 .AND. SN.GT.SNMAX) THEN
               SNMAX = SN
               IMAX = K
            ELSEIF (K.EQ.I .OR. SN*RNMAX.GT.RN*SNMAX) THEN
               SNMAX = SN
               RNMAX = RN
               IMAX = K
            ENDIF
  140    CONTINUE
C
C        Interchange rows if necessary.
C
         IF (I.NE.IMAX) CALL SSWAP (NP1, W(I,1), MDW, W(IMAX,1), MDW)
         IF (SNMAX.GT.RNMAX*TAU**2) THEN
C
C        Eliminate elements I+1,...,N in row I.
C
            CALL H12 (1, I, I+1, N, W(I,1), MDW, WS(I), W(I+1,1), MDW,
     +                1, M-I)
         ELSE
            KRANKE = I - 1
            GO TO 160
         ENDIF
  150 CONTINUE
C
C     Save diagonal terms of lower trapezoidal matrix.
C
  160 CALL SCOPY (KRANKE, W, MDW+1, WS(KRANKE+1), 1)
C
C     Use Householder transformation from left to achieve
C     KRANKE by KRANKE upper triangular form.
C
      IF (KRANKE.LT.ME) THEN
         DO 170 K = KRANKE,1,-1
C
C           Apply transformation to matrix cols. 1,...,K-1.
C
            CALL H12 (1, K, KRANKE+1, ME, W(1,K), 1, UP, W, 1, MDW, K-1)
C
C           Apply to rt side vector.
C
            CALL H12 (2, K, KRANKE+1, ME, W(1,K), 1, UP, W(1,NP1), 1, 1,
     +                1)
  170    CONTINUE
      ENDIF
C
C     Solve for variables 1,...,KRANKE in new coordinates.
C
      CALL SCOPY (KRANKE, W(1, NP1), 1, X, 1)
      DO 180 I = 1,KRANKE
         X(I) = (X(I)-SDOT(I-1,W(I,1),MDW,X,1))/W(I,I)
  180 CONTINUE
C
C     Compute residuals for reduced problem.
C
      MEP1 = ME + 1
      RNORML = 0.E0
      DO 190 I = MEP1,M
         W(I,NP1) = W(I,NP1) - SDOT(KRANKE,W(I,1),MDW,X,1)
         SN = SDOT(KRANKE,W(I,1),MDW,W(I,1),MDW)
         RN = SDOT(N-KRANKE,W(I,KRANKE+1),MDW,W(I,KRANKE+1),MDW)
         IF (RN.LE.SN*TAU**2 .AND. KRANKE.LT.N)
     *      CALL SCOPY (N-KRANKE, 0.E0, 0, W(I,KRANKE+1), MDW)
  190 CONTINUE
C
C     Compute equality constraint equations residual length.
C
      RNORME = SNRM2(ME-KRANKE,W(KRANKE+1,NP1),1)
C
C     Move reduced problem data upward if KRANKE.LT.ME.
C
      IF (KRANKE.LT.ME) THEN
         DO 200 J = 1,NP1
            CALL SCOPY (M-ME, W(ME+1,J), 1, W(KRANKE+1,J), 1)
  200    CONTINUE
      ENDIF
C
C     Compute solution of reduced problem.
C
      CALL LSI(W(KRANKE+1, KRANKE+1), MDW, MA, MG, N-KRANKE, PRGOPT,
     +         X(KRANKE+1), RNORML, MODE, WS(N2), IP(2))
C
C     Test for consistency of equality constraints.
C
      IF (ME.GT.0) THEN
         MDEQC = 0
         XNRME = SASUM(KRANKE,W(1,NP1),1)
         IF (RNORME.GT.TAU*(ENORM*XNRME+FNORM)) MDEQC = 1
         MODE = MODE + MDEQC
C
C        Check if solution to equality constraints satisfies inequality
C        constraints when there are no degrees of freedom left.
C
         IF (KRANKE.EQ.N .AND. MG.GT.0) THEN
            XNORM = SASUM(N,X,1)
            MAPKE1 = MA + KRANKE + 1
            MEND = MA + KRANKE + MG
            DO 210 I = MAPKE1,MEND
               SIZE = SASUM(N,W(I,1),MDW)*XNORM + ABS(W(I,NP1))
               IF (W(I,NP1).GT.TAU*SIZE) THEN
                  MODE = MODE + 2
                  GO TO 290
               ENDIF
  210       CONTINUE
         ENDIF
      ENDIF
C
C     Replace diagonal terms of lower trapezoidal matrix.
C
      IF (KRANKE.GT.0) THEN
         CALL SCOPY (KRANKE, WS(KRANKE+1), 1, W, MDW+1)
C
C        Reapply transformation to put solution in original coordinates.
C
         DO 220 I = KRANKE,1,-1
            CALL H12 (2, I, I+1, N, W(I,1), MDW, WS(I), X, 1, 1, 1)
  220    CONTINUE
C
C        Compute covariance matrix of equality constrained problem.
C
         IF (COV) THEN
            DO 270 J = MIN(KRANKE,N-1),1,-1
               RB = WS(J)*W(J,J)
               IF (RB.NE.0.E0) RB = 1.E0/RB
               JP1 = J + 1
               DO 230 I = JP1,N
                  W(I,J) = RB*SDOT(N-J,W(I,JP1),MDW,W(J,JP1),MDW)
  230          CONTINUE
C
               GAM = 0.5E0*RB*SDOT(N-J,W(JP1,J),1,W(J,JP1),MDW)
               CALL SAXPY (N-J, GAM, W(J,JP1), MDW, W(JP1,J), 1)
               DO 250 I = JP1,N
                  DO 240 K = I,N
                     W(I,K) = W(I,K) + W(J,I)*W(K,J) + W(I,J)*W(J,K)
                     W(K,I) = W(I,K)
  240             CONTINUE
  250          CONTINUE
               UJ = WS(J)
               VJ = GAM*UJ
               W(J,J) = UJ*VJ + UJ*VJ
               DO 260 I = JP1,N
                  W(J,I) = UJ*W(I,J) + VJ*W(J,I)
  260          CONTINUE
               CALL SCOPY (N-J, W(J, JP1), MDW, W(JP1,J), 1)
  270       CONTINUE
         ENDIF
      ENDIF
C
C     Apply the scaling to the covariance matrix.
C
      IF (COV) THEN
         DO 280 I = 1,N
            CALL SSCAL (N, WS(I+N1-1), W(I,1), MDW)
            CALL SSCAL (N, WS(I+N1-1), W(1,I), 1)
  280    CONTINUE
      ENDIF
C
C     Rescale solution vector.
C
  290 IF (MODE.LE.1) THEN
         DO 300 J = 1,N
            X(J) = X(J)*WS(N1+J-1)
  300    CONTINUE
      ENDIF
C
      IP(1) = KRANKE
      IP(3) = IP(3) + 2*KRANKE + N
      RETURN
      END
*DECK LSI
      SUBROUTINE LSI (W, MDW, MA, MG, N, PRGOPT, X, RNORM, MODE, WS, IP)
C***BEGIN PROLOGUE  LSI
C***SUBSIDIARY
C***PURPOSE  Subsidiary to LSEI
C***LIBRARY   SLATEC
C***TYPE      SINGLE PRECISION (LSI-S, DLSI-D)
C***AUTHOR  Hanson, R. J., (SNLA)
C***DESCRIPTION
C
C     This is a companion subprogram to LSEI.  The documentation for
C     LSEI has complete usage instructions.
C
C     Solve..
C              AX = B,  A  MA by N  (least squares equations)
C     subject to..
C
C              GX.GE.H, G  MG by N  (inequality constraints)
C
C     Input..
C
C      W(*,*) contains  (A B) in rows 1,...,MA+MG, cols 1,...,N+1.
C                       (G H)
C
C     MDW,MA,MG,N
C              contain (resp) var. dimension of W(*,*),
C              and matrix dimensions.
C
C     PRGOPT(*),
C              Program option vector.
C
C     OUTPUT..
C
C      X(*),RNORM
C
C              Solution vector(unless MODE=2), length of AX-B.
C
C      MODE
C              =0   Inequality constraints are compatible.
C              =2   Inequality constraints contradictory.
C
C      WS(*),
C              Working storage of dimension K+N+(MG+2)*(N+7),
C              where K=MAX(MA+MG,N).
C      IP(MG+2*N+1)
C              Integer working storage
C
C***ROUTINES CALLED  H12, HFTI, LPDP, R1MACH, SASUM, SAXPY, SCOPY, SDOT,
C                    SSCAL, SSWAP
C***REVISION HISTORY  (YYMMDD)
C   790701  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890618  Completely restructured and extensively revised (WRB & RWC)
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900328  Added TYPE section.  (WRB)
C   920422  Changed CALL to HFTI to include variable MA.  (WRB)
C***END PROLOGUE  LSI
      INTEGER IP(*), MA, MDW, MG, MODE, N
      REAL             PRGOPT(*), RNORM, W(MDW,*), WS(*), X(*)
C
      EXTERNAL H12, HFTI, LPDP, R1MACH, SASUM, SAXPY, SCOPY, SDOT,
     *   SSCAL, SSWAP
      REAL             R1MACH, SASUM, SDOT
C
      REAL             ANORM, FAC, GAM, RB, SRELPR, TAU, TOL, XNORM
      INTEGER I, J, K, KEY, KRANK, KRM1, KRP1, L, LAST, LINK, M, MAP1,
     *   MDLPDP, MINMAN, N1, N2, N3, NEXT, NP1
      LOGICAL COV, FIRST, SCLCOV
C
      SAVE SRELPR, FIRST
      DATA FIRST /.TRUE./
C
C***FIRST EXECUTABLE STATEMENT  LSI
C
C     Set the nominal tolerance used in the code.
C
      IF (FIRST) SRELPR = R1MACH(4)
      FIRST = .FALSE.
      TOL = SQRT(SRELPR)
C
      MODE = 0
      RNORM = 0.E0
      M = MA + MG
      NP1 = N + 1
      KRANK = 0
      IF (N.LE.0 .OR. M.LE.0) GO TO 370
C
C     To process option vector.
C
      COV = .FALSE.
      SCLCOV = .TRUE.
      LAST = 1
      LINK = PRGOPT(1)
C
  100 IF (LINK.GT.1) THEN
         KEY = PRGOPT(LAST+1)
         IF (KEY.EQ.1) COV = PRGOPT(LAST+2) .NE. 0.E0
         IF (KEY.EQ.10) SCLCOV = PRGOPT(LAST+2) .EQ. 0.E0
         IF (KEY.EQ.5) TOL = MAX(SRELPR,PRGOPT(LAST+2))
         NEXT = PRGOPT(LINK)
         LAST = LINK
         LINK = NEXT
         GO TO 100
      ENDIF
C
C     Compute matrix norm of least squares equations.
C
      ANORM = 0.E0
      DO 110 J = 1,N
         ANORM = MAX(ANORM,SASUM(MA,W(1,J),1))
  110 CONTINUE
C
C     Set tolerance for HFTI( ) rank test.
C
      TAU = TOL*ANORM
C
C     Compute Householder orthogonal decomposition of matrix.
C
      CALL SCOPY (N, 0.E0, 0, WS, 1)
      CALL SCOPY (MA, W(1, NP1), 1, WS, 1)
      K = MAX(M,N)
      MINMAN = MIN(MA,N)
      N1 = K + 1
      N2 = N1 + N
      CALL HFTI (W, MDW, MA, N, WS, MA, 1, TAU, KRANK, RNORM, WS(N2),
     +           WS(N1), IP)
      FAC = 1.E0
      GAM = MA - KRANK
      IF (KRANK.LT.MA .AND. SCLCOV) FAC = RNORM**2/GAM
C
C     Reduce to LPDP and solve.
C
      MAP1 = MA + 1
C
C     Compute inequality rt-hand side for LPDP.
C
      IF (MA.LT.M) THEN
         IF (MINMAN.GT.0) THEN
            DO 120 I = MAP1,M
               W(I,NP1) = W(I,NP1) - SDOT(N,W(I,1),MDW,WS,1)
  120       CONTINUE
C
C           Apply permutations to col. of inequality constraint matrix.
C
            DO 130 I = 1,MINMAN
               CALL SSWAP (MG, W(MAP1,I), 1, W(MAP1,IP(I)), 1)
  130       CONTINUE
C
C           Apply Householder transformations to constraint matrix.
C
            IF (KRANK.GT.0 .AND. KRANK.LT.N) THEN
               DO 140 I = KRANK,1,-1
                  CALL H12 (2, I, KRANK+1, N, W(I,1), MDW, WS(N1+I-1),
     +                      W(MAP1,1), MDW, 1, MG)
  140          CONTINUE
            ENDIF
C
C           Compute permuted inequality constraint matrix times r-inv.
C
            DO 160 I = MAP1,M
               DO 150 J = 1,KRANK
                  W(I,J) = (W(I,J)-SDOT(J-1,W(1,J),1,W(I,1),MDW))/W(J,J)
  150          CONTINUE
  160       CONTINUE
         ENDIF
C
C        Solve the reduced problem with LPDP algorithm,
C        the least projected distance problem.
C
         CALL LPDP(W(MAP1,1), MDW, MG, KRANK, N-KRANK, PRGOPT, X,
     +             XNORM, MDLPDP, WS(N2), IP(N+1))
C
C        Compute solution in original coordinates.
C
         IF (MDLPDP.EQ.1) THEN
            DO 170 I = KRANK,1,-1
               X(I) = (X(I)-SDOT(KRANK-I,W(I,I+1),MDW,X(I+1),1))/W(I,I)
  170       CONTINUE
C
C           Apply Householder transformation to solution vector.
C
            IF (KRANK.LT.N) THEN
               DO 180 I = 1,KRANK
                  CALL H12 (2, I, KRANK+1, N, W(I,1), MDW, WS(N1+I-1),
     +                      X, 1, 1, 1)
  180          CONTINUE
            ENDIF
C
C           Repermute variables to their input order.
C
            IF (MINMAN.GT.0) THEN
               DO 190 I = MINMAN,1,-1
                  CALL SSWAP (1, X(I), 1, X(IP(I)), 1)
  190          CONTINUE
C
C              Variables are now in original coordinates.
C              Add solution of unconstrained problem.
C
               DO 200 I = 1,N
                  X(I) = X(I) + WS(I)
  200          CONTINUE
C
C              Compute the residual vector norm.
C
               RNORM = SQRT(RNORM**2+XNORM**2)
            ENDIF
         ELSE
            MODE = 2
         ENDIF
      ELSE
         CALL SCOPY (N, WS, 1, X, 1)
      ENDIF
C
C     Compute covariance matrix based on the orthogonal decomposition
C     from HFTI( ).
C
      IF (.NOT.COV .OR. KRANK.LE.0) GO TO 370
      KRM1 = KRANK - 1
      KRP1 = KRANK + 1
C
C     Copy diagonal terms to working array.
C
      CALL SCOPY (KRANK, W, MDW+1, WS(N2), 1)
C
C     Reciprocate diagonal terms.
C
      DO 210 J = 1,KRANK
         W(J,J) = 1.E0/W(J,J)
  210 CONTINUE
C
C     Invert the upper triangular QR factor on itself.
C
      IF (KRANK.GT.1) THEN
         DO 230 I = 1,KRM1
            DO 220 J = I+1,KRANK
               W(I,J) = -SDOT(J-I,W(I,I),MDW,W(I,J),1)*W(J,J)
  220       CONTINUE
  230    CONTINUE
      ENDIF
C
C     Compute the inverted factor times its transpose.
C
      DO 250 I = 1,KRANK
         DO 240 J = I,KRANK
            W(I,J) = SDOT(KRANK+1-J,W(I,J),MDW,W(J,J),MDW)
  240    CONTINUE
  250 CONTINUE
C
C     Zero out lower trapezoidal part.
C     Copy upper triangular to lower triangular part.
C
      IF (KRANK.LT.N) THEN
         DO 260 J = 1,KRANK
            CALL SCOPY (J, W(1,J), 1, W(J,1), MDW)
  260    CONTINUE
C
         DO 270 I = KRP1,N
            CALL SCOPY (I, 0.E0, 0, W(I,1), MDW)
  270    CONTINUE
C
C        Apply right side transformations to lower triangle.
C
         N3 = N2 + KRP1
         DO 330 I = 1,KRANK
            L = N1 + I
            K = N2 + I
            RB = WS(L-1)*WS(K-1)
C
C           If RB.GE.0.E0, transformation can be regarded as zero.
C
            IF (RB.LT.0.E0) THEN
               RB = 1.E0/RB
C
C              Store unscaled rank one Householder update in work array.
C
               CALL SCOPY (N, 0.E0, 0, WS(N3), 1)
               L = N1 + I
               K = N3 + I
               WS(K-1) = WS(L-1)
C
               DO 280 J = KRP1,N
                  WS(N3+J-1) = W(I,J)
  280          CONTINUE
C
               DO 290 J = 1,N
                  WS(J) = RB*(SDOT(J-I,W(J,I),MDW,WS(N3+I-1),1)+
     +                    SDOT(N-J+1,W(J,J),1,WS(N3+J-1),1))
  290          CONTINUE
C
               L = N3 + I
               GAM = 0.5E0*RB*SDOT(N-I+1,WS(L-1),1,WS(I),1)
               CALL SAXPY (N-I+1, GAM, WS(L-1), 1, WS(I), 1)
               DO 320 J = I,N
                  DO 300 L = 1,I-1
                     W(J,L) = W(J,L) + WS(N3+J-1)*WS(L)
  300             CONTINUE
C
                  DO 310 L = I,J
                     W(J,L) = W(J,L) + WS(J)*WS(N3+L-1)+WS(L)*WS(N3+J-1)
  310             CONTINUE
  320          CONTINUE
            ENDIF
  330    CONTINUE
C
C        Copy lower triangle to upper triangle to symmetrize the
C        covariance matrix.
C
         DO 340 I = 1,N
            CALL SCOPY (I, W(I,1), MDW, W(1,I), 1)
  340    CONTINUE
      ENDIF
C
C     Repermute rows and columns.
C
      DO 350 I = MINMAN,1,-1
         K = IP(I)
         IF (I.NE.K) THEN
            CALL SSWAP (1, W(I,I), 1, W(K,K), 1)
            CALL SSWAP (I-1, W(1,I), 1, W(1,K), 1)
            CALL SSWAP (K-I-1, W(I,I+1), MDW, W(I+1,K), 1)
            CALL SSWAP (N-K, W(I, K+1), MDW, W(K, K+1), MDW)
         ENDIF
  350 CONTINUE
C
C     Put in normalized residual sum of squares scale factor
C     and symmetrize the resulting covariance matrix.
C
      DO 360 J = 1,N
         CALL SSCAL (J, FAC, W(1,J), 1)
         CALL SCOPY (J, W(1,J), 1, W(J,1), MDW)
  360 CONTINUE
C
  370 IP(1) = KRANK
      IP(2) = N + MAX(M,N) + (MG+2)*(N+7)
      RETURN
      END
*DECK LSOD
      SUBROUTINE LSOD (F, NEQ, T, Y, TOUT, RTOL, ATOL, IDID, YPOUT, YH,
     +   YH1, EWT, SAVF, ACOR, WM, IWM, JAC, INTOUT, TSTOP, TOLFAC,
     +   DELSGN, RPAR, IPAR)
C***BEGIN PROLOGUE  LSOD
C***SUBSIDIARY
C***PURPOSE  Subsidiary to DEBDF
C***LIBRARY   SLATEC
C***TYPE      SINGLE PRECISION (LSOD-S, DLSOD-D)
C***AUTHOR  (UNKNOWN)
C***DESCRIPTION
C
C   DEBDF  merely allocates storage for  LSOD  to relieve the user of
C   the inconvenience of a long call list.  Consequently  LSOD  is used
C   as described in the comments for  DEBDF .
C
C***SEE ALSO  DEBDF
C***ROUTINES CALLED  HSTART, INTYD, R1MACH, STOD, VNWRMS, XERMSG
C***COMMON BLOCKS    DEBDF1
C***REVISION HISTORY  (YYMMDD)
C   800901  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890831  Modified array declarations.  (WRB)
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900328  Added TYPE section.  (WRB)
C   900510  Convert XERRWV calls to XERMSG calls.  (RWC)
C***END PROLOGUE  LSOD
C
C
      LOGICAL INTOUT
C
      DIMENSION Y(*),YPOUT(*),YH(NEQ,6),YH1(*),EWT(*),SAVF(*),
     1          ACOR(*),WM(*),IWM(*),RTOL(*),ATOL(*),RPAR(*),IPAR(*)
      CHARACTER*8 XERN1
      CHARACTER*16 XERN3, XERN4
C
      COMMON /DEBDF1/ TOLD, ROWNS(210),
     1   EL0, H, HMIN, HMXI, HU, X, U,
     2   IQUIT, INIT, LYH, LEWT, LACOR, LSAVF, LWM, KSTEPS,
     3   IBEGIN, ITOL, IINTEG, ITSTOP, IJAC, IBAND, IOWNS(6),
     4   IER, JSTART, KFLAG, LDUM, METH, MITER, MAXORD, N, NQ, NST,
     5   NFE, NJE, NQU
C
      EXTERNAL F, JAC
C
C.......................................................................
C
C  THE EXPENSE OF SOLVING THE PROBLEM IS MONITORED BY COUNTING THE
C  NUMBER OF  STEPS ATTEMPTED. WHEN THIS EXCEEDS  MAXNUM, THE COUNTER
C  IS RESET TO ZERO AND THE USER IS INFORMED ABOUT POSSIBLE EXCESSIVE
C  WORK.
C
      SAVE MAXNUM
      DATA MAXNUM/500/
C
C.......................................................................
C
C***FIRST EXECUTABLE STATEMENT  LSOD
      IF (IBEGIN .EQ. 0) THEN
C
C        ON THE FIRST CALL , PERFORM INITIALIZATION --
C        DEFINE THE MACHINE UNIT ROUNDOFF QUANTITY  U  BY CALLING THE
C        FUNCTION ROUTINE R1MACH. THE USER MUST MAKE SURE THAT THE
C        VALUES SET IN R1MACH ARE RELEVANT TO THE COMPUTER BEING USED.
C
         U = R1MACH(4)
C                          -- SET ASSOCIATED MACHINE DEPENDENT PARAMETER
         WM(1) = SQRT(U)
C                          -- SET TERMINATION FLAG
         IQUIT = 0
C                          -- SET INITIALIZATION INDICATOR
         INIT = 0
C                          -- SET COUNTER FOR ATTEMPTED STEPS
         KSTEPS = 0
C                          -- SET INDICATOR FOR INTERMEDIATE-OUTPUT
         INTOUT = .FALSE.
C                          -- SET START INDICATOR FOR STOD CODE
         JSTART = 0
C                          -- SET BDF METHOD INDICATOR
         METH = 2
C                          -- SET MAXIMUM ORDER FOR BDF METHOD
         MAXORD = 5
C                          -- SET ITERATION MATRIX INDICATOR
C
         IF (IJAC .EQ. 0 .AND. IBAND .EQ. 0) MITER = 2
         IF (IJAC .EQ. 1 .AND. IBAND .EQ. 0) MITER = 1
         IF (IJAC .EQ. 0 .AND. IBAND .EQ. 1) MITER = 5
         IF (IJAC .EQ. 1 .AND. IBAND .EQ. 1) MITER = 4
C
C                          -- SET OTHER NECESSARY ITEMS IN COMMON BLOCK
         N = NEQ
         NST = 0
         NJE = 0
         HMXI = 0.
         NQ = 1
         H = 1.
C                          -- RESET IBEGIN FOR SUBSEQUENT CALLS
         IBEGIN=1
      ENDIF
C
C.......................................................................
C
C      CHECK VALIDITY OF INPUT PARAMETERS ON EACH ENTRY
C
      IF (NEQ .LT. 1) THEN
         WRITE (XERN1, '(I8)') NEQ
         CALL XERMSG ('SLATEC', 'LSOD',
     *      'IN DEBDF, THE NUMBER OF EQUATIONS MUST BE A POSITIVE ' //
     *      'INTEGER.$$YOU HAVE CALLED THE CODE WITH NEQ = ' // XERN1,
     *      6, 1)
         IDID=-33
      ENDIF
C
      NRTOLP = 0
      NATOLP = 0
      DO 60 K = 1,NEQ
         IF (NRTOLP .LE. 0) THEN
            IF (RTOL(K) .LT. 0.) THEN
               WRITE (XERN1, '(I8)') K
               WRITE (XERN3, '(1PE15.6)') RTOL(K)
               CALL XERMSG ('SLATEC', 'LSOD',
     *            'IN DEBDF, THE RELATIVE ERROR TOLERANCES MUST ' //
     *            'BE NON-NEGATIVE.$$YOU HAVE CALLED THE CODE WITH ' //
     *            'RTOL(' // XERN1 // ') = ' // XERN3 // '$$IN THE ' //
     *            'CASE OF VECTOR ERROR TOLERANCES, NO FURTHER ' //
     *            'CHECKING OF RTOL COMPONENTS IS DONE.', 7, 1)
               IDID = -33
               IF (NATOLP .GT. 0) GO TO 70
               NRTOLP = 1
            ELSEIF (NATOLP .GT. 0) THEN
               GO TO 50
            ENDIF
         ENDIF
C
         IF (ATOL(K) .LT. 0.) THEN
            WRITE (XERN1, '(I8)') K
            WRITE (XERN3, '(1PE15.6)') ATOL(K)
            CALL XERMSG ('SLATEC', 'LSOD',
     *         'IN DEBDF, THE ABSOLUTE ERROR ' //
     *         'TOLERANCES MUST BE NON-NEGATIVE.$$YOU HAVE CALLED ' //
     *         'THE CODE WITH ATOL(' // XERN1 // ') = ' // XERN3 //
     *         '$$IN THE CASE OF VECTOR ERROR TOLERANCES, NO FURTHER '
     *         // 'CHECKING OF ATOL COMPONENTS IS DONE.', 8, 1)
            IDID=-33
            IF (NRTOLP .GT. 0) GO TO 70
            NATOLP=1
         ENDIF
   50    IF (ITOL .EQ. 0) GO TO 70
   60 CONTINUE
C
   70 IF (ITSTOP .EQ. 1) THEN
         IF (SIGN(1.,TOUT-T) .NE. SIGN(1.,TSTOP-T) .OR.
     1      ABS(TOUT-T) .GT. ABS(TSTOP-T)) THEN
            WRITE (XERN3, '(1PE15.6)') TOUT
            WRITE (XERN4, '(1PE15.6)') TSTOP
            CALL XERMSG ('SLATEC', 'LSOD',
     *         'IN DEBDF, YOU HAVE CALLED THE ' //
     *         'CODE WITH TOUT = ' // XERN3 // '$$BUT YOU HAVE ' //
     *         'ALSO TOLD THE CODE NOT TO INTEGRATE PAST THE POINT ' //
     *         'TSTOP = ' // XERN4 // ' BY SETTING INFO(4) = 1.  ' //
     *         'THESE INSTRUCTIONS CONFLICT.', 14, 1)
            IDID=-33
         ENDIF
      ENDIF
C
C        CHECK SOME CONTINUATION POSSIBILITIES
C
      IF (INIT .NE. 0) THEN
         IF (T .EQ. TOUT) THEN
            WRITE (XERN3, '(1PE15.6)') T
            CALL XERMSG ('SLATEC', 'LSOD',
     *         'IN DEBDF, YOU HAVE CALLED THE CODE WITH T = TOUT = ' //
     *         XERN3 // '  THIS IS NOT ALLOWED ON CONTINUATION CALLS.',
     *         9, 1)
            IDID=-33
         ENDIF
C
         IF (T .NE. TOLD) THEN
            WRITE (XERN3, '(1PE15.6)') TOLD
            WRITE (XERN4, '(1PE15.6)') T
            CALL XERMSG ('SLATEC', 'LSOD',
     *         'IN DEBDF, YOU HAVE CHANGED THE VALUE OF T FROM ' //
     *         XERN3 // ' TO ' // XERN4 //
     *         '  THIS IS NOT ALLOWED ON CONTINUATION CALLS.', 10, 1)
            IDID=-33
         ENDIF
C
         IF (INIT .NE. 1) THEN
            IF (DELSGN*(TOUT-T) .LT. 0.) THEN
               WRITE (XERN3, '(1PE15.6)') TOUT
               CALL XERMSG ('SLATEC', 'LSOD',
     *            'IN DEBDF, BY CALLING THE CODE WITH TOUT = ' //
     *            XERN3 // ' YOU ARE ATTEMPTING TO CHANGE THE ' //
     *            'DIRECTION OF INTEGRATION.$$' //
     *            'THIS IS NOT ALLOWED WITHOUT RESTARTING.', 11, 1)
               IDID=-33
            ENDIF
         ENDIF
      ENDIF
C
      IF (IDID .EQ. (-33)) THEN
         IF (IQUIT .NE. (-33)) THEN
C                       INVALID INPUT DETECTED
            IQUIT=-33
            IBEGIN=-1
         ELSE
            CALL XERMSG ('SLATEC', 'LSOD',
     *         'IN DEBDF, INVALID INPUT WAS ' //
     *         'DETECTED ON SUCCESSIVE ENTRIES.  IT IS IMPOSSIBLE ' //
     *         'TO PROCEED BECAUSE YOU HAVE NOT CORRECTED THE ' //
     *         'PROBLEM, SO EXECUTION IS BEING TERMINATED.', 12, 2)
         ENDIF
         RETURN
      ENDIF
C
C.......................................................................
C
C     RTOL = ATOL = 0. IS ALLOWED AS VALID INPUT AND INTERPRETED AS
C     ASKING FOR THE MOST ACCURATE SOLUTION POSSIBLE. IN THIS CASE,
C     THE RELATIVE ERROR TOLERANCE RTOL IS RESET TO THE SMALLEST VALUE
C     100*U WHICH IS LIKELY TO BE REASONABLE FOR THIS METHOD AND MACHINE
C
      DO 170 K=1,NEQ
        IF (RTOL(K)+ATOL(K) .GT. 0.) GO TO 160
        RTOL(K)=100.*U
        IDID=-2
  160   IF (ITOL .EQ. 0) GO TO 180
  170   CONTINUE
C
  180 IF (IDID .NE. (-2)) GO TO 190
C                       RTOL=ATOL=0 ON INPUT, SO RTOL IS CHANGED TO A
C                                                SMALL POSITIVE VALUE
      IBEGIN=-1
      RETURN
C
C     BRANCH ON STATUS OF INITIALIZATION INDICATOR
C            INIT=0 MEANS INITIAL DERIVATIVES AND NOMINAL STEP SIZE
C                   AND DIRECTION NOT YET SET
C            INIT=1 MEANS NOMINAL STEP SIZE AND DIRECTION NOT YET SET
C            INIT=2 MEANS NO FURTHER INITIALIZATION REQUIRED
C
  190 IF (INIT .EQ. 0) GO TO 200
      IF (INIT .EQ. 1) GO TO 220
      GO TO 240
C
C.......................................................................
C
C     MORE INITIALIZATION --
C                         -- EVALUATE INITIAL DERIVATIVES
C
  200 INIT=1
      CALL F(T,Y,YH(1,2),RPAR,IPAR)
      NFE=1
      IF (T .NE. TOUT) GO TO 220
      IDID=2
      DO 210 L = 1,NEQ
  210    YPOUT(L) = YH(L,2)
      TOLD=T
      RETURN
C
C                         -- COMPUTE INITIAL STEP SIZE
C                         -- SAVE SIGN OF INTEGRATION DIRECTION
C                         -- SET INDEPENDENT AND DEPENDENT VARIABLES
C                                              X AND YH(*) FOR STOD
C
  220 LTOL = 1
      DO 225 L=1,NEQ
        IF (ITOL .EQ. 1) LTOL = L
        TOL = RTOL(LTOL)*ABS(Y(L)) + ATOL(LTOL)
        IF (TOL .EQ. 0.) GO TO 380
  225   EWT(L) = TOL
C
      BIG = SQRT(R1MACH(2))
      CALL HSTART (F,NEQ,T,TOUT,Y,YH(1,2),EWT,1,U,BIG,
     1             YH(1,3),YH(1,4),YH(1,5),YH(1,6),RPAR,IPAR,H)
C
      DELSGN = SIGN(1.0,TOUT-T)
      X = T
      DO 230 L = 1,NEQ
        YH(L,1) = Y(L)
  230   YH(L,2) = H*YH(L,2)
      INIT = 2
C
C.......................................................................
C
C   ON EACH CALL SET INFORMATION WHICH DETERMINES THE ALLOWED INTERVAL
C   OF INTEGRATION BEFORE RETURNING WITH AN ANSWER AT TOUT
C
  240 DEL = TOUT - T
      ABSDEL = ABS(DEL)
C
C.......................................................................
C
C   IF ALREADY PAST OUTPUT POINT, INTERPOLATE AND RETURN
C
  250 IF (ABS(X-T) .LT. ABSDEL) GO TO 270
      CALL INTYD(TOUT,0,YH,NEQ,Y,INTFLG)
      CALL INTYD(TOUT,1,YH,NEQ,YPOUT,INTFLG)
      IDID = 3
      IF (X .NE. TOUT) GO TO 260
      IDID = 2
      INTOUT = .FALSE.
  260 T = TOUT
      TOLD = T
      RETURN
C
C   IF CANNOT GO PAST TSTOP AND SUFFICIENTLY CLOSE,
C   EXTRAPOLATE AND RETURN
C
  270 IF (ITSTOP .NE. 1) GO TO 290
      IF (ABS(TSTOP-X) .GE. 100.*U*ABS(X)) GO TO 290
      DT = TOUT - X
      DO 280 L = 1,NEQ
  280   Y(L) = YH(L,1) + (DT/H)*YH(L,2)
      CALL F(TOUT,Y,YPOUT,RPAR,IPAR)
      NFE = NFE + 1
      IDID = 3
      T = TOUT
      TOLD = T
      RETURN
C
  290 IF (IINTEG .EQ. 0  .OR.  .NOT.INTOUT) GO TO 300
C
C   INTERMEDIATE-OUTPUT MODE
C
      IDID = 1
      GO TO 500
C
C.......................................................................
C
C     MONITOR NUMBER OF STEPS ATTEMPTED
C
  300 IF (KSTEPS .LE. MAXNUM) GO TO 330
C
C                       A SIGNIFICANT AMOUNT OF WORK HAS BEEN EXPENDED
      IDID=-1
      KSTEPS=0
      IBEGIN = -1
      GO TO 500
C
C.......................................................................
C
C   LIMIT STEP SIZE AND SET WEIGHT VECTOR
C
  330 HMIN = 100.*U*ABS(X)
      HA = MAX(ABS(H),HMIN)
      IF (ITSTOP .NE. 1) GO TO 340
      HA = MIN(HA,ABS(TSTOP-X))
  340 H = SIGN(HA,H)
      LTOL = 1
      DO 350 L = 1,NEQ
        IF (ITOL .EQ. 1) LTOL = L
        EWT(L) = RTOL(LTOL)*ABS(YH(L,1)) + ATOL(LTOL)
        IF (EWT(L) .LE. 0.0) GO TO 380
  350   CONTINUE
      TOLFAC = U*VNWRMS(NEQ,YH,EWT)
      IF (TOLFAC .LE. 1.) GO TO 400
C
C                       TOLERANCES TOO SMALL
      IDID = -2
      TOLFAC = 2.*TOLFAC
      RTOL(1) = TOLFAC*RTOL(1)
      ATOL(1) = TOLFAC*ATOL(1)
      IF (ITOL .EQ. 0) GO TO 370
      DO 360 L = 2,NEQ
        RTOL(L) = TOLFAC*RTOL(L)
  360   ATOL(L) = TOLFAC*ATOL(L)
  370 IBEGIN = -1
      GO TO 500
C
C                       RELATIVE ERROR CRITERION INAPPROPRIATE
  380 IDID = -3
      IBEGIN = -1
      GO TO 500
C
C.......................................................................
C
C     TAKE A STEP
C
  400 CALL STOD(NEQ,Y,YH,NEQ,YH1,EWT,SAVF,ACOR,WM,IWM,F,JAC,RPAR,IPAR)
C
      JSTART = -2
      INTOUT = .TRUE.
      IF (KFLAG .EQ. 0) GO TO 250
C
C.......................................................................
C
      IF (KFLAG .EQ. -1) GO TO 450
C
C                       REPEATED CORRECTOR CONVERGENCE FAILURES
      IDID = -6
      IBEGIN = -1
      GO TO 500
C
C                       REPEATED ERROR TEST FAILURES
  450 IDID = -7
      IBEGIN = -1
C
C.......................................................................
C
C                       STORE VALUES BEFORE RETURNING TO DEBDF
  500 DO 555 L = 1,NEQ
        Y(L) = YH(L,1)
  555   YPOUT(L) = YH(L,2)/H
      T = X
      TOLD = T
      INTOUT = .FALSE.
      RETURN
      END
*DECK LSSODS
      SUBROUTINE LSSODS (A, X, B, M, N, NRDA, IFLAG, IRANK, ISCALE, Q,
     +   DIAG, KPIVOT, ITER, RESNRM, XNORM, Z, R, DIV, TD, SCALES)
C***BEGIN PROLOGUE  LSSODS
C***SUBSIDIARY
C***PURPOSE  Subsidiary to BVSUP
C***LIBRARY   SLATEC
C***TYPE      SINGLE PRECISION (LSSODS-S)
C***AUTHOR  (UNKNOWN)
C***DESCRIPTION
C
C     LSSODS solves the same problem as SODS (in fact, it is called by
C     SODS) but is somewhat more flexible in its use. In particular,
C     LSSODS allows for iterative refinement of the solution, makes the
C     transformation and triangular reduction information more
C     accessible, and enables the user to avoid destruction of the
C     original matrix A.
C
C     Modeled after the ALGOL codes in the articles in the REFERENCES
C     section.
C
C **********************************************************************
C   INPUT
C **********************************************************************
C
C     A -- Contains the matrix of M equations in N unknowns and must
C          be dimensioned NRDA by N. A remains unchanged
C     X -- Solution array of length at least N
C     B -- Given constant vector of length M, B remains unchanged
C     M -- Number of equations, M greater or equal to 1
C     N -- Number of unknowns, N not larger than M
C  NRDA -- Row dimension of A, NRDA greater or equal to M
C IFLAG -- Status indicator
C         = 0 for the first call (and for each new problem defined by
C             a new matrix A) when the matrix data is treated as exact
C         =-K for the first call (and for each new problem defined by
C             a new matrix A) when the matrix data is assumed to be
C             accurate to about K digits
C         = 1 for subsequent calls whenever the matrix A has already
C             been decomposed (problems with new vectors B but
C             same matrix a can be handled efficiently)
C ISCALE -- Scaling indicator
C         =-1 if the matrix A is to be pre-scaled by
C             columns when appropriate
C             If the scaling indicator is not equal to -1
C             no scaling will be attempted
C             For most problems scaling will probably not be necessary
C   ITER -- Maximum number of iterative improvement steps to be
C           performed,  0 .LE. ITER .LE. 10   (SODS uses ITER=0)
C      Q -- Matrix used for the transformation, must be dimensioned
C           NRDA by N  (SODS puts A in the Q location which conserves
C           storage but destroys A)
C           When iterative improvement of the solution is requested,
C           ITER .GT. 0, this additional storage for Q must be
C           made available
C DIAG,KPIVOT,Z,R, -- Arrays of length N (except for R which is M)
C   DIV,TD,SCALES     used for internal storage
C
C **********************************************************************
C   OUTPUT
C **********************************************************************
C
C  IFLAG -- Status indicator
C            =1 if solution was obtained
C            =2 if improper input is detected
C            =3 if rank of matrix is less than N
C               if the minimal length least squares solution is
C               desired, simply reset IFLAG=1 and call the code again
C
C       The next three IFLAG values can occur only when
C        the iterative improvement mode is being used.
C            =4 if the problem is ill-conditioned and maximal
C               machine accuracy is not achievable
C            =5 if the problem is very ill-conditioned and the solution
C               IS likely to have no correct digits
C            =6 if the allowable number of iterative improvement steps
C               has been completed without getting convergence
C      X -- Least squares solution of  A X = B
C  IRANK -- Contains the numerically determined matrix rank
C           the user must not alter this value on succeeding calls
C           with input values of IFLAG=1
C      Q -- Contains the strictly upper triangular part of the reduced
C           matrix and the transformation information in the lower
C           triangular part
C   DIAG -- Contains the diagonal elements of the triangular reduced
C           matrix
C KPIVOT -- Contains the pivotal information.  The column interchanges
C           performed on the original matrix are recorded here
C   ITER -- The actual number of iterative corrections used
C RESNRM -- The Euclidean norm of the residual vector  B - A X
C  XNORM -- The Euclidean norm of the solution vector
C DIV,TD -- Contains transformation information for rank
C           deficient problems
C SCALES -- Contains the column scaling parameters
C
C **********************************************************************
C
C***SEE ALSO  BVSUP
C***REFERENCES  G. Golub, Numerical methods for solving linear least
C                 squares problems, Numerische Mathematik 7, (1965),
C                 pp. 206-216.
C               P. Businger and G. Golub, Linear least squares
C                 solutions by Householder transformations, Numerische
C                 Mathematik  7, (1965), pp. 269-276.
C***ROUTINES CALLED  J4SAVE, OHTROR, ORTHOL, R1MACH, SDOT, SDSDOT,
C                    XERMAX, XERMSG, XGETF, XSETF
C***REVISION HISTORY  (YYMMDD)
C   750601  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890831  Modified array declarations.  (WRB)
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900315  CALLs to XERROR changed to CALLs to XERMSG.  (THJ)
C   900402  Added TYPE section.  (WRB)
C   910408  Updated the REFERENCES section.  (WRB)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  LSSODS
      DIMENSION A(NRDA,*),X(*),B(*),Q(NRDA,*),DIAG(*),
     1          Z(*),KPIVOT(*),R(*),DIV(*),TD(*),SCALES(*)
C
C **********************************************************************
C
C     MACHINE PRECISION (COMPUTER UNIT ROUNDOFF VALUE) IS DEFINED
C     THE FUNCTION R1MACH.
C
C***FIRST EXECUTABLE STATEMENT  LSSODS
      URO = R1MACH(3)
C
C **********************************************************************
C
      IF (N .LT. 1  .OR.  M .LT. N  .OR.  NRDA .LT. M) GO TO 1
      IF (ITER .LT. 0) GO TO 1
      IF (IFLAG .LE. 0) GO TO 5
      IF (IFLAG .EQ. 1) GO TO 15
C
C     INVALID INPUT FOR LSSODS
    1 IFLAG=2
      CALL XERMSG ('SLATEC', 'LSSODS', 'INVALID INPUT PARAMETERS.', 2,
     +   1)
      RETURN
C
    5 CALL XGETF (NFATAL)
      MAXMES = J4SAVE (4,0,.FALSE.)
      IF (IFLAG .EQ. 0) GO TO 7
      NFAT = -1
      IF(NFATAL .EQ. 0) NFAT=0
      CALL XSETF (NFAT)
      CALL XERMAX (1)
C
C     COPY MATRIX A INTO MATRIX Q
C
    7 DO 10 J=1,N
         DO 10 K=1,M
   10       Q(K,J)=A(K,J)
C
C     USE ORTHOGONAL TRANSFORMATIONS TO REDUCE Q TO
C     UPPER TRIANGULAR FORM
C
      CALL ORTHOL(Q,M,N,NRDA,IFLAG,IRANK,ISCALE,DIAG,KPIVOT,SCALES,Z,TD)
C
      CALL XSETF (NFATAL)
      CALL XERMAX (MAXMES)
      IF (IRANK .EQ. N) GO TO 12
C
C     FOR RANK DEFICIENT PROBLEMS USE ADDITIONAL ORTHOGONAL
C     TRANSFORMATIONS TO FURTHER REDUCE Q
C
      IF (IRANK .NE. 0) CALL OHTROR(Q,N,NRDA,DIAG,IRANK,DIV,TD)
      RETURN
C
C     STORE DIVISORS FOR THE TRIANGULAR SOLUTION
C
   12 DO 13 K=1,N
   13    DIV(K)=DIAG(K)
C
   15 IRM=IRANK-1
      IRP=IRANK+1
      ITERP=MIN(ITER+1,11)
      ACC=10.*URO
C
C     ZERO OUT SOLUTION ARRAY
C
      DO 20 K=1,N
   20    X(K)=0.
C
      IF (IRANK .GT. 0) GO TO 25
C
C     SPECIAL CASE FOR THE NULL MATRIX
      ITER=0
      XNORM=0.
      RESNRM=SQRT(SDOT(M,B(1),1,B(1),1))
      RETURN
C
C     COPY CONSTANT VECTOR INTO R
C
   25 DO 30 K=1,M
   30    R(K)=B(K)
C
C **********************************************************************
C     SOLUTION SECTION
C     ITERATIVE REFINEMENT OF THE RESIDUAL VECTOR
C **********************************************************************
C
      DO 100 IT=1,ITERP
         ITER=IT-1
C
C        APPLY ORTHOGONAL TRANSFORMATION TO R
C
         DO 35 J=1,IRANK
            MJ=M-J+1
            GAMMA=SDOT(MJ,Q(J,J),1,R(J),1)/(DIAG(J)*Q(J,J))
            DO 35 K=J,M
   35          R(K)=R(K)+GAMMA*Q(K,J)
C
C        BACKWARD SUBSTITUTION FOR TRIANGULAR SYSTEM SOLUTION
C
         Z(IRANK)=R(IRANK)/DIV(IRANK)
         IF (IRM .EQ. 0) GO TO 45
         DO 40 L=1,IRM
            K=IRANK-L
            KP=K+1
   40       Z(K)=(R(K)-SDOT(L,Q(K,KP),NRDA,Z(KP),1))/DIV(K)
C
   45    IF (IRANK .EQ. N) GO TO 60
C
C        FOR RANK DEFICIENT PROBLEMS OBTAIN THE
C        MINIMAL LENGTH SOLUTION
C
         NMIR=N-IRANK
         DO 50 K=IRP,N
   50       Z(K)=0.
         DO 55 K=1,IRANK
            GAM=((TD(K)*Z(K))+SDOT(NMIR,Q(K,IRP),NRDA,Z(IRP),1))/
     1                (TD(K)*DIV(K))
            Z(K)=Z(K)+GAM*TD(K)
            DO 55 J=IRP,N
   55          Z(J)=Z(J)+GAM*Q(K,J)
C
C        REORDER SOLUTION COMPONENTS ACCORDING TO PIVOTAL POINTS
C        AND RESCALE ANSWERS AS DICTATED
C
   60    DO 65 K=1,N
            Z(K)=Z(K)*SCALES(K)
            L=KPIVOT(K)
   65       X(L)=X(L)+Z(K)
C
C        COMPUTE CORRECTION VECTOR NORM (SOLUTION NORM)
C
         ZNORM=SQRT(SDOT(N,Z(1),1,Z(1),1))
         IF (IT .EQ. 1) XNORM=ZNORM
         IF (ITERP .GT. 1) GO TO 80
C
C        NO ITERATIVE CORRECTIONS TO BE PERFORMED, SO COMPUTE
C        THE APPROXIMATE RESIDUAL NORM DEFINED BY THE EQUATIONS
C        WHICH ARE NOT SATISFIED BY THE SOLUTION
C        THEN WE ARE DONE
C
         MMIR=M-IRANK
         IF (MMIR .EQ. 0) GO TO 70
         RESNRM=SQRT(SDOT(MMIR,R(IRP),1,R(IRP),1))
         RETURN
   70    RESNRM=0.
         RETURN
C
C        COMPUTE RESIDUAL VECTOR FOR THE ITERATIVE IMPROVEMENT PROCESS
C
   80    DO 85 K=1,M
   85       R(K)=-SDSDOT(N,-B(K),A(K,1),NRDA,X(1),1)
         RESNRM=SQRT(SDOT(M,R(1),1,R(1),1))
         IF (IT .EQ. 1) GO TO 100
C
C        TEST FOR CONVERGENCE
C
         IF (ZNORM .LE. ACC*XNORM) RETURN
C
C        COMPARE SUCCESSIVE REFINEMENT VECTOR NORMS
C        FOR LOOP TERMINATION CRITERIA
C
         IF (ZNORM .LE. 0.25*ZNRM0) GO TO 100
         IF (IT .EQ. 2) GO TO 90
C
         IFLAG=4
         CALL XERMSG ('SLATEC', 'LSSODS',
     +   'PROBLEM MAY BE ILL-CONDITIONED.  MAXIMAL MACHINE ACCURACY ' //
     +   'IS NOT ACHIEVABLE.', 3, 1)
         RETURN
C
   90    IFLAG=5
         CALL XERMSG ('SLATEC', 'LSSODS',
     +      'PROBLEM IS VERY ILL-CONDITIONED.  ITERATIVE ' //
     +      'IMPROVEMENT IS INEFFECTIVE.', 8, 1)
         RETURN
C
  100    ZNRM0=ZNORM
C **********************************************************************
C
C **********************************************************************
      IFLAG=6
         CALL XERMSG ('SLATEC', 'LSSODS',
     +      'CONVERGENCE HAS NOT BEEN OBTAINED WITH ALLOWABLE ' //
     +      'NUMBER OF ITERATIVE IMPROVEMENT STEPS.', 8, 1)
C
      RETURN
      END
*DECK LSSUDS
      SUBROUTINE LSSUDS (A, X, B, N, M, NRDA, U, NRDU, IFLAG, MLSO,
     +   IRANK, ISCALE, Q, DIAG, KPIVOT, S, DIV, TD, ISFLG, SCALES)
C***BEGIN PROLOGUE  LSSUDS
C***SUBSIDIARY
C***PURPOSE  Subsidiary to BVSUP
C***LIBRARY   SLATEC
C***TYPE      SINGLE PRECISION (LSSUDS-S, DLSSUD-D)
C***AUTHOR  Watts, H. A., (SNLA)
C***DESCRIPTION
C
C    LSSUDS solves the underdetermined system of equations  A Z = B,
C    where A is N by M and N .LE. M.  In particular, if rank A equals
C    IRA, a vector X and a matrix U are determined such that X is the
C    UNIQUE solution of smallest length, satisfying A X = B, and the
C    columns of U form an orthonormal basis for the null space of A,
C    satisfying A U = 0 .  Then all solutions Z are given by
C              Z = X + C(1)*U(1) + ..... + C(M-IRA)*U(M-IRA)
C    where U(J) represents the J-th column of U and the C(J) are
C    arbitrary constants.
C    If the system of equations are not compatible, only the least
C    squares solution of minimal length is computed.
C
C *********************************************************************
C   INPUT
C *********************************************************************
C
C     A -- Contains the matrix of N equations in M unknowns, A remains
C          unchanged, must be dimensioned NRDA by M.
C     X -- Solution array of length at least M.
C     B -- Given constant vector of length N, B remains unchanged.
C     N -- Number of equations, N greater or equal to 1.
C     M -- Number of unknowns, M greater or equal to N.
C     NRDA -- Row dimension of A, NRDA greater or equal to N.
C     U -- Matrix used for solution, must be dimensioned NRDU by
C          (M - rank of A).
C          (storage for U may be ignored when only the minimal length
C           solution X is desired)
C     NRDU -- Row dimension of U, NRDU greater or equal to M.
C             (if only the minimal length solution is wanted,
C              NRDU=0 is acceptable)
C     IFLAG -- Status indicator
C           =0  for the first call (and for each new problem defined by
C               a new matrix A) when the matrix data is treated as exact
C           =-K for the first call (and for each new problem defined by
C               a new matrix A) when the matrix data is assumed to be
C               accurate to about K digits.
C           =1  for subsequent calls whenever the matrix A has already
C               been decomposed (problems with new vectors B but
C               same matrix A can be handled efficiently).
C     MLSO -- =0 if only the minimal length solution is wanted.
C             =1 if the complete solution is wanted, includes the
C                linear space defined by the matrix U.
C     IRANK -- Variable used for the rank of A, set by the code.
C     ISCALE -- Scaling indicator
C               =-1 if the matrix A is to be pre-scaled by
C               columns when appropriate.
C               If the scaling indicator is not equal to -1
C               no scaling will be attempted.
C            For most problems scaling will probably not be necessary.
C     Q -- Matrix used for the transformation, must be dimensioned
C            NRDA by M.
C     DIAG,KPIVOT,S, -- Arrays of length at least N used for internal
C      DIV,TD,SCALES    storage (except for SCALES which is M).
C     ISFLG -- Storage for an internal variable.
C
C *********************************************************************
C   OUTPUT
C *********************************************************************
C
C     IFLAG -- Status indicator
C            =1 if solution was obtained.
C            =2 if improper input is detected.
C            =3 if rank of matrix is less than N.
C               To continue, simply reset IFLAG=1 and call LSSUDS again.
C            =4 if the system of equations appears to be inconsistent.
C               However, the least squares solution of minimal length
C               was obtained.
C     X -- Minimal length least squares solution of A Z = B
C     IRANK -- Numerically determined rank of A, must not be altered
C              on succeeding calls with input values of IFLAG=1.
C     U -- Matrix whose M-IRANK columns are mutually orthogonal unit
C          vectors which span the null space of A. This is to be ignored
C          when MLSO was set to zero or IFLAG=4 on output.
C     Q -- Contains the strictly upper triangular part of the reduced
C           matrix and transformation information.
C     DIAG -- Contains the diagonal elements of the triangular reduced
C             matrix.
C     KPIVOT -- Contains the pivotal information.  The row interchanges
C               performed on the original matrix are recorded here.
C     S -- Contains the solution of the lower triangular system.
C     DIV,TD -- Contains transformation information for rank
C               deficient problems.
C     SCALES -- Contains the column scaling parameters.
C
C *********************************************************************
C
C***SEE ALSO  BVSUP
C***REFERENCES  H. A. Watts, Solving linear least squares problems
C                 using SODS/SUDS/CODS, Sandia Report SAND77-0683,
C                 Sandia Laboratories, 1977.
C***ROUTINES CALLED  J4SAVE, OHTROL, ORTHOR, R1MACH, SDOT, XERMAX,
C                    XERMSG, XGETF, XSETF
C***REVISION HISTORY  (YYMMDD)
C   750601  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890831  Modified array declarations.  (WRB)
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900315  CALLs to XERROR changed to CALLs to XERMSG.  (THJ)
C   900328  Added TYPE section.  (WRB)
C   900510  Fixed an error message.  (RWC)
C   910408  Updated the AUTHOR and REFERENCES sections.  (WRB)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  LSSUDS
      DIMENSION A(NRDA,*),X(*),B(*),U(NRDU,*),Q(NRDA,*),
     1          DIAG(*),KPIVOT(*),S(*),DIV(*),TD(*),SCALES(*)
C
C **********************************************************************
C
C     MACHINE PRECISION (COMPUTER UNIT ROUNDOFF VALUE) IS DEFINED
C     BY THE FUNCTION R1MACH.
C
C***FIRST EXECUTABLE STATEMENT  LSSUDS
      URO = R1MACH(4)
C
C **********************************************************************
C
      IF (N .LT. 1  .OR.  M .LT. N  .OR.  NRDA .LT. N) GO TO 1
      IF (NRDU .NE. 0  .AND.  NRDU .LT. M) GO TO 1
      IF (IFLAG .LE. 0) GO TO 5
      IF (IFLAG .EQ. 1) GO TO 25
C
C     INVALID INPUT FOR LSSUDS
    1 IFLAG=2
      CALL XERMSG ('SLATEC', 'LSSUDS', 'INVALID INPUT PARAMETERS.', 2,
     +   1)
      RETURN
C
    5 CALL XGETF(NFATAL)
      MAXMES = J4SAVE (4,0,.FALSE.)
      ISFLG=-15
      IF (IFLAG .EQ. 0) GO TO 7
      ISFLG=IFLAG
      NFAT = -1
      IF (NFATAL .EQ. 0) NFAT=0
      CALL XSETF(NFAT)
      CALL XERMAX(1)
C
C     COPY MATRIX A INTO MATRIX Q
C
    7 DO 10 K=1,M
         DO 10 J=1,N
   10       Q(J,K)=A(J,K)
C
C     USE ORTHOGONAL TRANSFORMATIONS TO REDUCE Q TO LOWER
C     TRIANGULAR FORM
C
      CALL ORTHOR(Q,N,M,NRDA,IFLAG,IRANK,ISCALE,DIAG,KPIVOT,SCALES,
     1            DIV,TD)
C
      CALL XSETF(NFATAL)
      CALL XERMAX(MAXMES)
      IF (IRANK .EQ. N) GO TO 15
C
C     FOR RANK DEFICIENT PROBLEMS USE ADDITIONAL ORTHOGONAL
C     TRANSFORMATIONS TO FURTHER REDUCE Q
C
      IF (IRANK .NE. 0) CALL OHTROL(Q,N,NRDA,DIAG,IRANK,DIV,TD)
      RETURN
C
C     STORE DIVISORS FOR THE TRIANGULAR SOLUTION
C
   15 DO 20 K=1,N
   20    DIV(K)=DIAG(K)
C
C
   25 IF (IRANK .GT. 0) GO TO 40
C
C     SPECIAL CASE FOR THE NULL MATRIX
      DO 35 K=1,M
         X(K)=0.
         IF (MLSO .EQ. 0) GO TO 35
         U(K,K)=1.
         DO 30 J=1,M
            IF (J .EQ. K) GO TO 30
            U(J,K)=0.
   30    CONTINUE
   35 CONTINUE
      DO 37 K=1,N
         IF (B(K) .GT. 0.) IFLAG=4
   37 CONTINUE
      RETURN
C
C     COPY CONSTANT VECTOR INTO S AFTER FIRST INTERCHANGING
C     THE ELEMENTS ACCORDING TO THE PIVOTAL SEQUENCE
C
   40 DO 45 K=1,N
         KP=KPIVOT(K)
   45    X(K)=B(KP)
      DO 50 K=1,N
   50    S(K)=X(K)
C
      IRP=IRANK+1
      NU=1
      IF (MLSO .EQ. 0) NU=0
      IF (IRANK .EQ. N) GO TO 60
C
C     FOR RANK DEFICIENT PROBLEMS WE MUST APPLY THE
C     ORTHOGONAL TRANSFORMATION TO S
C     WE ALSO CHECK TO SEE IF THE SYSTEM APPEARS TO BE INCONSISTENT
C
      NMIR=N-IRANK
      SS=SDOT(N,S(1),1,S(1),1)
      DO 55 L=1,IRANK
         K=IRP-L
         GAM=((TD(K)*S(K))+SDOT(NMIR,Q(IRP,K),1,S(IRP),1))/
     1             (TD(K)*DIV(K))
         S(K)=S(K)+GAM*TD(K)
         DO 55 J=IRP,N
   55       S(J)=S(J)+GAM*Q(J,K)
      RES=SDOT(NMIR,S(IRP),1,S(IRP),1)
      IF (RES .LE. SS*(10.*MAX(10.**ISFLG,10.*URO))**2) GO TO 60
C
C     INCONSISTENT SYSTEM
      IFLAG=4
      NU=0
C
C     APPLY FORWARD SUBSTITUTION TO SOLVE LOWER TRIANGULAR SYSTEM
C
   60 S(1)=S(1)/DIV(1)
      IF (IRANK .EQ. 1) GO TO 70
      DO 65 K=2,IRANK
   65    S(K)=(S(K)-SDOT(K-1,Q(K,1),NRDA,S(1),1))/DIV(K)
C
C     INITIALIZE X VECTOR AND THEN APPLY ORTHOGONAL TRANSFORMATION
C
   70 DO 75 K=1,M
         X(K)=0.
         IF (K .LE. IRANK) X(K)=S(K)
   75 CONTINUE
C
      DO 80 JR=1,IRANK
         J=IRP-JR
         MJ=M-J+1
         GAMMA=SDOT(MJ,Q(J,J),NRDA,X(J),1)/(DIAG(J)*Q(J,J))
         DO 80 K=J,M
   80       X(K)=X(K)+GAMMA*Q(J,K)
C
C     RESCALE ANSWERS AS DICTATED
C
      DO 85 K=1,M
   85    X(K)=X(K)*SCALES(K)
C
      IF ((NU .EQ. 0) .OR. (M .EQ. IRANK)) RETURN
C
C     INITIALIZE U MATRIX AND THEN APPLY ORTHOGONAL TRANSFORMATION
C
      L=M-IRANK
      DO 100 K=1,L
         DO 90 I=1,M
            U(I,K)=0.
            IF (I .EQ. IRANK+K) U(I,K)=1.
   90    CONTINUE
C
         DO 100 JR=1,IRANK
            J=IRP-JR
            MJ=M-J+1
            GAMMA=SDOT(MJ,Q(J,J),NRDA,U(J,K),1)/(DIAG(J)*Q(J,J))
            DO 100 I=J,M
  100          U(I,K)=U(I,K)+GAMMA*Q(J,I)
C
      RETURN
      END

  subroutine uv_select_buffer(rname,nu,nv,error)
  !-----------------------------------------------------------------------
  !*
  ! The use of UV buffers in IMAGER
  !
  ! IMAGER has three virtual UV buffers, named
  ! "UVI" (Initial), "UVS" (Sorted) and "UVR" (Resampled).
  ! UVR and UVS are used indifferently, depending on which one is
  ! available, rather than using UVS only for sorting and UVR only
  ! for Resampling. Only one of those two is allocated at any time
  ! (except temporarily when using one as input and the other as output).
  !
  ! UVR and UVS may point to UVI, as sorting is not always needed.
  !
  ! Command READ uses UVI, and nullifies or deallocate UVR and UVS.
  !
  ! Commands UV_MAP, UV_CONT, UV_TIME, UV_RESIDUAL, UV_COMPRESS
  ! and UV_RESAMPLE use the UVR and UVS buffers.
  !   A little tricky logic allows to select UVS or UVR
  ! for the output, depending on which one is busy as input,
  ! allocating on demand as needed.
  !
  ! Through the use of a pointer, "UV" (actually a header
  ! HUV and a pointer to the data DUV), the so-called "current UV data"
  ! points towards one of them, depending on the last issued commands.
  !
  ! Other commands like UV_BASELINE, UV_FILTER, UV_REWEIGHT or UV_FLAG
  ! work on the "current UV data". UV_FLAG is partially reversible.
  !
  ! Finally, UV_SORT does not affect the "current UV data", but produces
  ! a transposed copy of it (which thus cannot be written by WRITE UV),
  ! called UVT.
  !
  ! The whole thing is a little complex and perhaps should be changed.
  !
  ! In addition to the buffer use, the code must account for the
  ! weight computation optimization.
  !
  ! NOTE: In an earlier version, commands UV_COMPRESS and UV_RESAMPLE 
  ! only worked with UVI as input. This makes little sense, as a 
  ! combination of UV_TIME - UV_COMPRESS did not give the same as 
  ! UV_COMPRESS - UV_TIME for example. The only "nice" feature of 
  ! this behaviour was to allow the spectral resampling to start 
  ! from the full resolution data.
  !
  ! The original data can always be recovered through a READ, which
  ! is optimized by proper caching if no modification has been done
  ! to the data.
  !!
  !-----------------------------------------------------------------------
  use clean_def
  use clean_arrays
  use clean_types
  use gbl_message
  use imager_interfaces, only : map_message
  !---------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- Utility routine
  !
  !   Select the next available UV buffer (UVR or UVS) for
  ! commands using them. This routine is NO LONGER USED
  !!
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: rname    !! Caller name
  integer, intent(in) :: nu                !! Visibility size
  integer, intent(in) :: nv                !! Number of visibilities
  logical, intent(out) :: error            !! Error flag
  !
  ! Local ---
  character(len=4) :: bufname
  character(len=64) :: chain
  integer :: ier
  !
  ! Code ----
  if (associated(duvr)) then
    allocate (duvs(nu,nv),stat=ier)
    if (ier.ne.0) then
      error = .true.
      call map_message(seve%f,rname,'Memory allocation failure on UVS')
      return
    endif
    if (associated(duvr,huv_init%r2d)) then
      nullify(duvr)
    else if (associated(duvr)) then
      deallocate (duvr)     ! Free the old one
    endif
    duv => duvs             ! Point to new one
    bufname = 'UVS'
  else
    allocate (duvr(nu,nv),stat=ier)
    if (ier.ne.0) then
      error = .true.
      call map_message(seve%f,rname,'Memory allocation failure on UVR')
      return
    endif
    if (associated(duvs,huv_init%r2d)) then
      nullify(duvs)
    else if (associated(duvs)) then
      deallocate (duvs)      ! Free the old one
    endif
    duv => duvr               ! Point to new one
    bufname = 'UVR'
  endif
  optimize(code_save_uv)%change = optimize(code_save_uv)%change+1
  write(chain,'(A,A,A,I3)') 'Selected buffer ',bufname, &
    & ' Optimize ',optimize(code_save_uv)%change
  call map_message(seve%w,rname,chain)
  error = .false.
end subroutine uv_select_buffer
!
subroutine uv_reset_buffer(rname)
  use gkernel_interfaces
  use clean_def
  use clean_arrays
  use clean_beams
  use clean_types
  use gbl_message
  use imager_interfaces, only : map_message
  !---------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- Utility routine
  !
  !   Reset pointers to UV datasets (back to UVI). Deallocate
  ! UVR or UVS if needed, as well as the "transposed" buffer UVT
  !---------------------------------------------------------------------
  character(len=*) :: rname  !! Caller name
  !
  ! Local ---
  logical, parameter :: do_print=.false.
  logical :: error
  !
  ! Code ---
  !
  ! What happens when no compressed data is defined ?
  ! well we have to set the same pointers DUV and DUVR as in READ...
  !
  if (allocated(duvt)) deallocate (duvt)        ! UV data not plotted
  !
  if (.not.associated(huv_init%r2d)) then
    call map_message(seve%w,rname,'No UV data (DUVI not allocated)')
    return
  endif
  !
  ! Find out which one DUVI is pointing about
  if (associated(duvr,huv_init%r2d)) then
    if (do_print) Print *,'DUVR was pointing towards DUVI'
    nullify(duvr)
  else if (associated(duvr)) then
    if (do_print) Print *,'DUVR was allocated '
    deallocate (duvr)     ! Free the old one
  else
    if (do_print) Print *,'DUVR not allocated '
  endif
  if (associated(duvs,huv_init%r2d)) then
    if (do_print) Print *,'DUVS was pointing towards DUVI'
    nullify(duvs)
  else if (associated(duvs)) then
    if (do_print) Print *,'DUVS was allocated '
    deallocate (duvs)     ! Free the old one
  else
    if (do_print) Print *,'DUVS not allocated '
  endif
  !
  ! Copy back the UV header and re-define the file name
  call gdf_copy_header(huv_init,huv_current, error)
  huv_current%file = huv_init%file
  !
  duvr => huv_init%r2d     ! As in READ
  !
  ! This means we were already pointing to the previous UV data set
  if (do_print) Print *,'Sizes DUV ',size(duv,1),size(duv,2),' HUV_INIT ', &
    size(huv_init%r2d,1),size(huv_init%r2d,2)
  if (do_print) Print *,'Association DUV ',associated(duv,huv_init%r2d)
  if (associated(duv,huv_init%r2d))   return
  !
  ! Here we point back...
  if (optimize(code_save_uv)%change.gt.1) then
    optimize(code_save_uv)%change = optimize(code_save_uv)%change - 1
    call map_message(seve%i,rname,'Returning to previous UV data set')
  else
    optimize(code_save_uv)%change = 0
    call map_message(seve%i,rname,'Returning to original UV data set')
    ! Delete the BEAM_RANGES array if any
    nbeam_ranges = -1    ! Beam ranges unchecked
    call sic_delvariable ('BEAM_RANGES',.false.,error)
  endif
  duv => huv_init%r2d
  if (do_print) Print *,'Association DUV Current ',associated(duv,huv_current%r2d)
  !
  huv_current%r2d => duv  ! Also needed ?
  do_weig = .true. ! Recompute weight
  error = .false.
  call sic_delvariable ('UV',.false.,error)
  error = .false.
  call sic_delvariable ('UVS',.false.,error)
  !
end subroutine uv_reset_buffer
!
subroutine uv_dump_buffers(rname)
  use clean_def
  use clean_arrays
  use gbl_message
  use gkernel_interfaces
  use imager_interfaces, only : map_message
  !---------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- Utility routine
  !
  !   Dump the allocation status of the UV buffers. (Debugging only)
  !!
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: rname    !! Caller name
  !
  ! Local ---
  integer(kind=index_length) :: udim(2)
  logical :: error
  integer :: isev
  !
  ! Code ----
  isev = seve%u
  !
  if (associated(duvr)) then
    if (associated(duvr,huv_init%r2d)) then
      call map_message(isev,rname,'DUVR associated to DUVI')
    else
      call map_message(isev,rname,'DUVR allocated')
    endif
    !
    ! Redefine SIC variables
    udim(1) = ubound(duvr,1)
    udim(2) = ubound(duvr,2)
    call sic_delvariable ('UVR',.false.,error)
    call sic_def_real ('UVR',duvr,2,udim,.false.,error)
  else
    call map_message(isev,rname,'no DUVR ...')
  endif
  !
  if (associated(duvs)) then
    if (associated(duvs,huv_init%r2d)) then
      call map_message(isev,rname,'DUVS associated to DUVI')
    else
      call map_message(isev,rname,'DUVS allocated')
    endif
    ! Redefine SIC variables
    udim(1) = ubound(duvs,1)
    udim(2) = ubound(duvs,2)
    call sic_delvariable ('UVS',.false.,error)
    call sic_def_real ('UVS',duvs,2,udim,.false.,error)
  else
    call map_message(isev,rname,'no DUVS ...')
  endif
  !
  if (allocated(duvt)) call map_message(isev,rname,'Transposed buffer allocated.')
  !
  if (associated(duv,huv_init%r2d)) then
    call map_message(isev,rname,'DUV associated to HUV_Init%r2d')
  else if (associated(duv,duvr)) then
    call map_message(isev,rname,'DUV associated to DUVR')
  else if (associated(duv,duvs)) then
    call map_message(isev,rname,'DUV associated to DUVS')
  else if (associated(duv,duvm)) then
    call map_message(isev,rname,'DUV associated to DUVM (Model)')
  else if (associated(duv,duvf)) then
    call map_message(isev,rname,'DUV associated to DUVF (Fit residual)')
  else if (associated(duv,duvself)) then
    call map_message(isev,rname,'DUV associated to DUVSELF (Self cal)')
  else if (associated(duv,duvraw)) then
    call map_message(isev,rname,'DUV associated to DUVRAW (Raw for self-cal)')
  else if (associated(duv)) then
    call map_message(isev,rname,'DUV is associated to some other buffer '// &
      & '(neither DUVR nor DUVS, no known Data either)')
  else
    call map_message(isev,rname,'DUV is undefined')
  endif
  !
  if (associated(huv_init%r2d)) call dump_loc('HUV_Init',huv_init%r2d,' ')
  if (associated(huv_current%r2d)) call dump_loc('HUV_Current',huv_current%r2d,' ')
  if (associated(duvr)) call dump_loc('DUVR',duvr,' ')
  if (associated(duvs)) call dump_loc('DUVS',duvs,' ')
  if (allocated(duvm)) then
    call dump_loc('DUVM',duvm,' Model UV buffer')
    call dump_loc('HUV_Model',huv_model%r2d,' Model UV buffer')
  endif
  if (allocated(duvf)) then
    call dump_loc('DUVF',duvf,' Fit Residual ')
    call dump_loc('HUV_Model',huv_resid%r2d,' Fit or Clean Residual')
  endif
  if (associated(duvself)) then
    call dump_loc('DUVSELF',duvself,' Self Calibrated ')
    call dump_loc('HSelf_Calib',hself_calib%r2d,' Self CALIBRATED ')
    call dump_loc('HSelf_Self ',hself_self%r2d,' SELF Calibrated ')
  endif
  if (allocated(duvraw)) then
    call dump_loc('DUVRAW',duvraw,' Raw for Self Cal ')
    call dump_loc('HSelf_Raw',hself_raw%r2d,' Raw for Self Cal ')
  endif
  if (allocated(duvbg)) then
    call dump_loc('CGAINS',duvbg,' Baseline Gains from Self Cal ')
  endif
  !
contains
  subroutine dump_loc(buf,array,name)
    character(len=*), intent(in) :: buf
    character(len=*), intent(in) :: name
    real, intent(in) :: array(:,:)
    !
    integer(kind=address_length) :: addr
    character(len=128) :: chain
    !
    addr = locwrd(array)
    write(chain,'(A,T16,I18,A,I0,A,I0,A,A)') buf,addr,'   Size [', &
      & ubound(array,1),',',ubound(array,2),'] ',name
    call map_message(isev,rname,chain)
  end subroutine dump_loc
end subroutine uv_dump_buffers
!
subroutine uv_free_buffers
  use clean_def
  use clean_arrays
  !---------------------------------------------------------------------
  !*
  ! IMAGER -- Utility routine
  !
  !   Deallocate all UV buffers.
  !!
  !---------------------------------------------------------------------
  logical, parameter :: do_print=.false.   ! Use .true. to debug
  integer :: ier
  !
  ! Free the previous zone
  ! ! Print *,'Into uv_free_buffers'
  if (associated(duvr)) then
    if (associated(duvr,huv_init%r2d)) then
      nullify(duvr)
      if (do_print) Print *,'Nullify duvr'
    else
      if (do_print) Print *,'Deallocate duvr'
      deallocate(duvr,stat=ier)
    endif
  endif
  if (associated(duvs)) then
    if (associated(duvs,huv_init%r2d)) then
      if (do_print) Print *,'Nullify duvs'
      nullify(duvs)
    else
      if (do_print) Print *,'Deallocate duvs'
      deallocate(duvs,stat=ier)
    endif
  endif
  !
  ! Free the input UV area
  call uv_free_init
  !
  if (allocated(duvt)) deallocate(duvt,stat=ier)
  if (do_print) Print *,'Done uv_free_buffers'
end subroutine uv_free_buffers
!
subroutine uv_free_init
  use clean_def
  use clean_arrays
  !---------------------------------------------------------------------
  !*
  ! IMAGER -- Utility routine
  !
  !   Deallocate the Initial UV buffer.
  !!
  !---------------------------------------------------------------------
  integer :: ier
  !
  if (associated(huv_init%r2d,huv_sort%r2d)) then
    nullify(huv_init%r2d)
    !!print *,'IER Init ',ier
    !!Print *,'Init ',associated(huv_init%r2d), ' Sort ',associated(huv_sort%r2d)
    deallocate(huv_sort%r2d,stat=ier)
    !!print *,'IER Sort ',ier
    !!Print *,'Init ',associated(huv_init%r2d), ' Sort ',associated(huv_sort%r2d)
  else
    !!Print *,'Allocation case '
    if (associated(huv_init%r2d)) then
      deallocate(huv_init%r2d,stat=ier)
      if (ier.ne.0) print *,'IER Init ',ier
    endif
    if (associated(huv_sort%r2d)) then
      deallocate(huv_sort%r2d,stat=ier)
      if (ier.ne.0) print *,'IER Sort ',ier
    endif
  endif
end subroutine uv_free_init
!
subroutine uv_find_buffers (rname,nu,nv,duv_previous, duv_next,error)
  use clean_arrays
  use gbl_message
  use imager_interfaces, only : map_message
  !---------------------------------------------------------------------
  ! @ private-mandatory
  !*
  ! IMAGER -- Utility routine
  !
  !   Find the next available UV buffer (UVR or UVS).
  ! This routine should not be used by UV_SELF (at least for mosaics)
  ! which should only work on the HRAW and HSELF buffers.
  !!
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: rname       !! Caller name
  integer, intent(in) :: nu                   !! Size of a visiblity
  integer, intent(in) :: nv                   !! Number of visibilities
  real, pointer, intent(out) :: duv_previous(:,:)  !! Pointer to previous buffer
  real, pointer, intent(out) :: duv_next(:,:) !! Pointer to next available buffer
  logical, intent(out) :: error               !! Logical error flag
  !       
  ! Local ---
  integer :: ier
  !
  ! Code ----
  if (associated(duvr)) then
    allocate (duvs(nu,nv),stat=ier)
    if (ier.ne.0) then
      error = .true.
      call map_message(seve%f,rname, &
      & 'UV_FIND_BUFFERS: Memory allocation failure on UVS')
      return
    endif
    call map_message(seve%w,rname,'Storing in DUVS')
    duv_previous => duvr
    duv_next => duvs
  else
    allocate (duvr(nu,nv),stat=ier)
    if (ier.ne.0) then
      error = .true.
      call map_message(seve%f,rname, &
      & 'UV_FIND_BUFFERS: Memory allocation failure on UVR')
      return
    endif
    call map_message(seve%w,rname,'Storing in DUVR')
    duv_previous => duvs
    duv_next => duvr
  endif
  error = .false.
end subroutine uv_find_buffers
!
subroutine uv_clean_buffers(duv_previous,duv_next,error)
  use clean_arrays
  !---------------------------------------------------------------------
  ! @ private-mandatory
  !*
  ! IMAGER -- Utility routine
  !
  !   Take care of freeing the unused UV buffer, and set UV to point to
  ! the new one.
  !---------------------------------------------------------------------
  real, pointer, intent(inout) :: duv_previous(:,:) !! Previous buffer
  real, pointer, intent(inout) :: duv_next(:,:)     !! Next buffer
  logical, intent(in) :: error  !! Logical error flag
  !
  if (associated(duv_previous,duvr)) then
    if (error) then
      deallocate(duvs)
      nullify (duv_previous, duv_next)
      return
    endif
    !
    if (associated(duvr,huv_init%r2d)) then
      nullify(duvr)
    else
      deallocate (duvr)      ! Free the old one
    endif
    duv => duvs              ! Point to new one
  else if (associated(duv_previous,duvs)) then
    if (error) then
      deallocate(duvr)
      nullify (duv_previous, duv_next)
      return
    endif
    !
    if (associated(duvs,huv_init%r2d)) then
      nullify(duvs)
    else
      deallocate (duvs)     ! Free the old one
    endif
    duv => duvr             ! Point to new one
  endif
  huv_current%r2d => duv        ! That must be the case
end subroutine uv_clean_buffers
!
subroutine uv_discard_buffers(duv_previous,duv_next,error)
  use clean_arrays
  !---------------------------------------------------------------------
  ! @ private-mandatory
  !
  ! IMAGER -- Utility routine
  !
  !   Take care of freeing the last used UV buffer, and reset 
  !   UV to point to the previous one.
  !!
  !---------------------------------------------------------------------
  real, pointer, intent(inout) :: duv_previous(:,:) !! Previous buffer
  real, pointer, intent(inout) :: duv_next(:,:)     !! Next buffer
  logical, intent(in) :: error  !! Logical error flag
  !
  if (associated(duv_next,duvr)) then
    if (error) then
      deallocate(duvr)
      nullify (duv_previous, duv_next)
      return
    endif
    !
    if (associated(duvr,huv_init%r2d)) then
      nullify(duvr)
    else
      deallocate (duvr)      ! Free it 
    endif
    duv => duvs              ! Point to new one
  else if (associated(duv_next,duvs)) then
    if (error) then
      deallocate(duvs)
      nullify (duv_previous, duv_next)
      return
    endif
    !
    if (associated(duvs,huv_init%r2d)) then
      nullify(duvs)
    else
      deallocate (duvs)     ! Free it
    endif
    duv => duvr             ! Point to new one
  endif
end subroutine uv_discard_buffers
!<FF>
subroutine uv_buffer_finduv(code) 
  use clean_arrays
  !! IMAGER -- Find code of current buffer 
  character(len=1), intent(out) :: code
  !! Code (i,r,s or space) of current buffer
  !
  ! Order matters a lot here ...
  if (associated(duv,huv_init%r2d)) then
    code = 'i'
  else if (associated(duv,duvr)) then
    code = 'r'
  else if (associated(duv,duvs)) then
    code = 's'
  else
    code = ' '
  endif
end subroutine uv_buffer_finduv
!
subroutine uv_buffer_resetuv(code) 
  use clean_arrays
  !! IMAGER -- Reset current buffer to the specified code
  character(len=1), intent(in) :: code  !! Code (i,r,s or space) of current buffer
  !
  if (code.eq.'r') then
    duv => duvr
  else if (code.eq.'s') then
    duv => duvs
  else if (code.eq.'i') then
    duv => huv_init%r2d
  else
    nullify(duv)
  endif
end subroutine uv_buffer_resetuv
!
subroutine uv_new_data (weight,resample)
  use gkernel_interfaces
  use clean_arrays
  use clean_types
  use imager_interfaces, only : map_uvgildas
  !---------------------------------------------------------------------
  ! @ private-mandatory
  !*
  ! IMAGER -- Internal routine
  !
  ! Declare that the UV data has been modified 
  ! so that   
  ! - the sorting must be redone (no longer needed)  
  ! - the transposed UV data is no longer consistent  
  ! - Data should be read again when asked by the user  
  ! - (optionally) Weights should be re-computed by UV_MAP  
  ! - and SIC variables must be re-defined  
  ! - The "uvself" data set must be discarded  
  !!
  !---------------------------------------------------------------------
  logical, intent(in), optional :: weight    !! Should Weight be discarded
  logical, intent(in), optional :: resample  !! Has resampling be performed 
  !
  logical, parameter :: do_print=.false.   ! Use .true. to debug
  logical :: error, increase
  integer :: ier
  !
  error = .false.
  increase = .true.
  if (present(resample)) increase = resample
  if (present(weight)) do_weig = weight
  !
  ! Increase the Optimization level if not going back
  if (increase) then
    optimize(code_save_uv)%change = optimize(code_save_uv)%change + 1
    save_data(code_save_uv) = .true.
  endif
  ! Redefine SIC variables (mandatory)
  if (do_print) Print *,'Address in UV_NEW_DATA before ',locwrd(duv), huv_current%loca%addr
  huv_current%file = ' '  ! Reset associated file name
  call map_uvgildas ('UV',huv_current,error,duv)
  if (do_print) Print *,'Address in UV_NEW_DATA after ',locwrd(duv), huv_current%loca%addr
  !
  ! Discard the transposed, sorted equivalent
  if (allocated(duvt)) deallocate(duvt)
  !
  ! Set the Channel Flags to 1 (good)
  if (present(resample)) then
    if (allocated(huv_current%img%flags)) deallocate(huv_current%img%flags)
    allocate(huv_current%img%flags(huv_current%gil%nchan),stat=ier)
    huv_current%img%flags = 1
  endif
  !
  hself_self%loca%size = 0 ! Discard the "uvself" data
end subroutine uv_new_data
!
subroutine map_uvgildas(name,uvh,error,duv)
  use image_def
  use gkernel_types
  use gkernel_interfaces
  !---------------------------------------------------------------------
  ! @ private-mandatory
  !*
  !   IMAGER  -- This should be in GILDAS kernel
  !
  !   (re-)Define the NAME% SIC header variable and corresponding
  !   NAME data area for UV-like data.
  !
  !   Also define additional variables in the NAME% SIC variable
  !   to handle the pointers towards extra columns for UV data.
  !!
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: name               !! SIC variable name
  type(gildas), intent(inout), target :: uvh         !! Header
  logical, intent(inout) :: error                    !! Logical Error flag
  real, intent(in), target :: duv(:,:)               !! Data area
  !
  ! Local ---
  integer :: i, ier
  logical :: found
  integer(kind=address_length) :: dim(2)
  !
  integer :: iname, jname(code_uvt_last)
  character(len=12) :: lower
  character(len=12), allocatable, save :: enames(:)
  integer, allocatable, save :: ecols(:)
  !
  ! Code ---
  call sic_delvariable(name,.false.,error)
  error = .false.
  !
  call sic_mapgildas (name,uvh,error,duv)
  if (error) return
  !
  if (uvh%gil%uvda_words.eq.0) return
  !
  ! Here print the UV data layout if non standard
  ! This code should normally be in SIC
  if (name.ne.'UV') return    ! For the time being, we only need this for UV%
  !                           ! in the Imager Scripts.
  !
  found = .false.
  iname = 0
  !
  do i=code_uvt_scan,code_uvt_last
    if (uvh%gil%column_pointer(i).gt.0) then
      iname = iname+1
      jname(iname) = i
    endif
  enddo
  if (iname.eq.0) return
  !
  !
  if (allocated(ecols)) deallocate(ecols,enames)
  allocate(ecols(iname),enames(iname),stat=ier)
  !
  dim(1) = iname
  call sic_def_inte('UV%EXTRA_COLUMNS',ecols,1,dim,.false.,error)
  call sic_def_charn('UV%EXTRA_NAMES',enames,1,dim,.false.,error)
  do i=1,iname
    lower = uv_column_name(jname(i))
    call sic_lower(lower)
    enames(i) = lower
    ecols(i) = uvh%gil%column_pointer(jname(i))
  enddo
  !
end subroutine map_uvgildas  
!
!<FF>
!
subroutine discard_uvdata(error)
  use clean_def
  use clean_arrays
  use clean_default
  use clean_types
  use gbl_message
  use imager_interfaces, only : map_message
  use gkernel_interfaces, only : sic_delvariable, gildas_null
  !! IMAGER -- Discard all UV data
  logical, intent(inout) :: error
  !
  ! Local ---
  integer :: atype
  logical :: err
  !
  ! Free the previous zone
  error = .false.
  !
  call uv_free_buffers
  nullify(duv)
  if (associated(huv_init%r2d)) then
    call map_message(seve%e,'BUFFERS','Programming error HUV_Init pointer still allocated',seve%e)
  endif 
  call gildas_null(huv_current, type='UVT')
  save_data(code_save_uv) = .false.
  !
  ! No UV_PREVIEW done, then...
  err = .false.
  call sic_delvariable ('PREVIEW',.false.,err)
  call sic_delvariable ('UV',.false.,err)
  call sic_delvariable ('UVS',.false.,err) 
  if (allocated(drobust)) then
    deallocate(drobust)
    call sic_delvariable ('ROBUST_BEAMS',.false.,err)
  endif
  !
  ! Unset optimization (this seems done automatically on other buffers ?)
  atype = 2
!    Print *,'Optimize status ',optimize(atype)%change, optimize(atype)%lastnc, ' change ',optimize(atype)%modif%modif 
!    Print *,'         file ',trim(optimize(atype)%modif%file)
!    
!  type mfile_t
!    character(len=filename_length) :: file=' '  ! File name
!    ! Last modification time (to the file system granularity)
!    integer(kind=8) :: mtime
!    ! Last time a modification was probed (to the OS granularity)
!    integer(kind=8) :: ptime
!    ! Was the file modified before last evaluation?
!    logical         :: modif
!  end type mfile_t
!
  optimize(atype)%change = 2          ! Make sure it has changed
  optimize(atype)%modif%file = ' '    ! Reset the filename
  !
  ! Do not do this --  user_method%mosaic = .false.
  call sic_delvariable ('FIELDS',.false.,err)
  call reset_fields(themap)
  !
  ! Undo the Weights buffers also
  if (allocated(g_weight)) deallocate(g_weight)
  if (allocated(g_v)) deallocate(g_v)
  do_weig = .true.
end subroutine discard_uvdata
!
subroutine set_buffer_modified(bufnam)
  use clean_types
  !! IMAGER -- Indicate the named buffer has been modified
  character(len=*), intent(in) :: bufnam  !! Buffer name 
  !!  It must be among the known list
  !
  ! Local ---
  integer :: i, atype
  !
  ! Code ----
  do i=1,mtype
    if (bufnam.eq.vtype(i)) then
      atype = i
      optimize(atype)%change = 10 ! Has been modified
      exit
    endif
  enddo
end subroutine set_buffer_modified
!
subroutine print_buffer_asso(name,head)
  use image_def
  use clean_default
  character(len=*), intent(in) :: name
  type(gildas), intent(in) :: head
  !
  if (.not.debug_buffer) return
  !
  if (head%gil%type_gdf.eq.code_gdf_uvt) then
    Print *,'UV-Like Header '//name
    Print *,' Header dimensions ',head%gil%dim(1:2)
    Print *,' Pointer size ',size(head%r2d,1),size(head%r2d,2)
  else
    Print *,'IMAGE Header '//name
    Print *,' Header dimensions ',head%gil%dim(1:head%gil%ndim)
    select case(head%gil%ndim)
    case(1)
      Print *,' Pointer size ',size(head%r1d,1)
    case(2)
      Print *,' Pointer size ',size(head%r2d,1),size(head%r2d,2)
    case(3)
      Print *,' Pointer size ',size(head%r3d,1),size(head%r3d,2),size(head%r3d,3)
    case(4)
      Print *,' Pointer size ',size(head%r4d,1),size(head%r4d,2),size(head%r4d,3),size(head%r4d,4)
    case  DEFAULT
      Print *,' Pointer size ',size(head%r1d)
    end select
  endif
end subroutine print_buffer_asso

subroutine extract_comm(line,error)
  use image_def
  use gkernel_interfaces
  use gkernel_types
  use gbl_message
  use iso_c_binding
  use clean_default
  use imager_interfaces, only : map_message
  !---------------------------------------------------------------------
  ! @ private  
  !*
  ! IMAGER -- Support for command EXTRACT Name [BLC TRC]
  ! 
  !	  Extract a subset from an input n-Dim image (n<4)  
  !   Uses specified BLC TRC or SIZE, CENTER and RANGE
  !!
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: line   !! Command line
  logical, intent(out) :: error         !! Logical error flag
  !
  character(len=*), parameter :: rname='EXTRACT'
  real(8), parameter :: pi=acos(-1.D0)
  ! Local ---
  integer :: i, ier, nc
  integer(kind=index_length) :: iblc(4),itrc(4),iout(4),pin(4)
  integer(kind=index_length) :: oblc(4),otrc(4)
  character(len=80) :: cinp
  type(sic_descriptor_t) :: desc
  type(gildas) :: hin
  type(gildas), save :: hou
  real, allocatable, save, target :: extract_data(:,:,:,:)
  type(c_ptr) :: cptr
  real, pointer :: r4ptr(:,:,:,:)
  real(4) :: x(2),xsize,ysize,xcent,ycent,xvelo,yvelo
  real(8) :: xref, factor
  integer :: ia(2)
  logical :: expand_size, expand_velo
  integer :: ndef, def(4), j
  character(len=132) :: mess
  !
  ! Code ----
  ! Input 3-D array: Locate the header and data area
  call sic_ch(line,0,1,cinp,nc,.true.,error)
  if (error) return
  call get_gildas(rname,cinp,desc,hin,error)
  if (error) return
  call gdf_copy_header(desc%head,hin,error)
  if (error) return
  !
  ! Expand to 4-D
  hin%gil%dim(1:4) = max(1,hin%gil%dim(1:4))
  !
  iblc = 0
  itrc = 0
  expand_size = .false.
  expand_velo = .false.
  !
  if (sic_narg(0).gt.1) then
    ! Have BLC TRC
    iblc = 1
    call sic_i4(line,0,2,i,.true.,error)
    iblc(1) = i
    call sic_i4(line,0,3,i,.true.,error)
    iblc(2) = i
    call sic_i4(line,0,4,i,.true.,error)
    iblc(3) = i
    itrc = 1
    call sic_i4(line,0,5,i,.true.,error)
    itrc(1) = i
    call sic_i4(line,0,6,i,.true.,error)
    itrc(2) = i
    call sic_i4(line,0,7,i,.true.,error)
    itrc(3) = i
    if (error) return
  else
    ! Derive from SIZE, CENTER and RANGE
    if (hin%gil%ptyp.ne.p_none) then
      call get_size_factor(factor)
    else
      factor = 1
    endif
    xsize = area_size(1)*factor
    ysize = area_size(2)*factor
    xcent = area_center(1)*factor
    ycent = area_center(2)*factor
    !
    call sic_get_real('RANGE[1]',xvelo,error)
    call sic_get_real('RANGE[2]',yvelo,error)
    !
    if (xsize.eq.0 .and. ysize.eq.0 .and. xvelo.eq.0 .and. yvelo.eq.0) then
      call map_message(seve%e,rname,'SIZE and RANGE undefined, please specify BLC TRC')
      error = .true.
      return
    else
      call map_message(seve%i,rname,'Using SIZE, CENTER and RANGE to define subset')
    endif
    if (xsize.ne.0) then
      x(1) = xcent-xsize/2
      x(2) = xcent+xsize/2
      ia(:)  = nint((x-hin%gil%val(1))/hin%gil%inc(1) + hin%gil%ref(1) )
      iblc(1) = minval(ia)
      itrc(1) = maxval(ia)
    endif
    if (ysize.ne.0) then
      x(1) = ycent-ysize/2
      x(2) = ycent+ysize/2
      ia(:)  = nint((x-hin%gil%val(2))/hin%gil%inc(2) + hin%gil%ref(2) )
      iblc(2) = minval(ia)
      itrc(2) = maxval(ia)
    endif
    if (xvelo.ne.0.or.yvelo.ne.0) then
      x(1) = xvelo
      x(2) = yvelo
      if ((hin%gil%faxi.eq.3).and.(hin%char%code(3).eq.'FREQUENCY')) then
        ! Use VELOCITY if it is a Frequency axis
        ! but find out at which pixel is the Rest Frequency
        xref = (hin%gil%freq-hin%gil%val(3))/hin%gil%inc(3) + hin%gil%ref(3)
        ia(:)  = nint( (x-hin%gil%voff)/hin%gil%vres + xref)
      else
        ! Use default axis unit,
        ia(:)  = nint( (x-hin%gil%val(3))/hin%gil%inc(3) + hin%gil%ref(3) )
      endif
      iblc(3) = minval(ia)
      itrc(3) = maxval(ia)
    endif
    !
    ! Now anything about enlarging the Output image...
    if ( xsize.gt.abs(hin%gil%dim(1)*hin%gil%inc(1)) .or. &
      &  ysize.gt.abs(hin%gil%dim(2)*hin%gil%inc(2)) ) then
      expand_size = .true.
    endif
    if ( abs(xvelo-yvelo).gt.abs(hin%gil%dim(3)*hin%gil%inc(3)) ) then
      expand_velo = .true.
    endif    
  endif
  !
  if (allocated(extract_data)) then
    deallocate(extract_data)
    call sic_delvariable('EXTRACTED',.false.,error)
  endif
  !
  call gildas_null(hou)
  call gdf_copy_header(hin,hou,error)
  !
  ! If any "expand_stuff" is set, the corresponding IBLC and ITRC can exceed the allowed range. 
  ! They  are used to define the span of the output data.
  ! Otherwise, usual defaults apply and must fit in the input range.
  ndef = 0
  if (expand_size) then
    oblc(1:2) = 1
    otrc(1:2) = itrc(1:2)-iblc(1:2)+1
  else
    ndef = 2
    def(1:2) = [1,2]
  endif
  if (expand_velo) then
    oblc(3) = 1
    otrc(3) = itrc(3)-iblc(3)+1
  else
    ndef = ndef+1
    def(ndef) = 3
  endif
  ndef = ndef+1
  def(ndef) = 4
  !
  do j=1,ndef
    i = def(j)
    if (iblc(i).eq.0) then
      oblc(i) = 1
      iblc(i) = 1
    else
      oblc(i) = iblc(i)  ! No min-max
      iblc(i) = max(iblc(i),1)
    endif
    if (itrc(i).eq.0) then
      otrc(i) = hin%gil%dim(i)
      itrc(i) = hin%gil%dim(i)
    else
      otrc(i) = itrc(i)  ! No min-max
      itrc(i) = min(itrc(i),hin%gil%dim(i))
    endif
    if (iblc(i).gt.itrc(i)) then
      write(mess,'(A,6(1X,I0))') 'Invalid subset ',iblc(1:3), itrc(1:3)
      call map_message(seve%e,rname,mess)
      error = .true.
      return
    endif
  enddo
  !
  if (sic_narg(0).le.1) then
    write(mess,'(A,I0,A,I0,A,I0,A,I0,A,I0,A,I0,A)') 'Selecting pixel range (',iblc(1),',',iblc(2),',',iblc(3), &
      & ')  - (',itrc(1),',',itrc(2),',',itrc(3),') '
    call map_message(seve%i,rname,mess)
  endif
  !
  do i=1,ndef
    if (iblc(i).gt.hin%gil%dim(i).or.itrc(i).lt.1) then
      call map_message(seve%e,rname,'Subset is out of data')
      return
    endif
  enddo
  !
  ! Get the true size
  hou%gil%dim(1:4) = itrc-iblc+1
  !
  pin = iblc
  ! Now restrict IBLC and ITRC to allowed range
  iblc = max(1,iblc)
  itrc = min(hin%gil%dim(1:4),itrc)
  !
  ! Initial PIN always moves at POUT = 1, so New IBLC moves at 
  iout = iblc-pin+1
  !
  ! Create output image
  hou%gil%extr_words = 0
  !
  ! Put pixel IMIN,JMIN at IOUT of output image
  hou%gil%ref = hin%gil%ref + iout - iblc
  !
  !
  allocate (extract_data(hou%gil%dim(1), hou%gil%dim(2), hou%gil%dim(3), hou%gil%dim(4)), stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'Output memory allocation error')
    error = .true.
    return
  endif
  !
  ! Adapt output Blanking if needed
  if (ndef.ne.4) then
    if (hou%gil%eval.lt.0) hou%gil%bval = 0
    extract_data = hou%gil%bval
  endif
  !
  ! ! hou%gil%eval = max(hou%gil%eval,0.0)
  hou%r4d => extract_data
  call adtoad(desc%addr,cptr,1)
  call c_f_pointer(cptr,r4ptr,hou%gil%dim(1:4))
  call sub_extract (   &
   &      r4ptr,hin%gil%dim(1),hin%gil%dim(2),hin%gil%dim(3),hin%gil%dim(4),   &
   &      extract_data,hou%gil%dim(1),hou%gil%dim(2),hou%gil%dim(3),hou%gil%dim(4),   &
   &      iblc,itrc,iout,hou%gil%bval)
  !
  ! Post the result as a SIC Image variable
  if (hou%gil%ndim.eq.2) then
    call sic_mapgildas('EXTRACTED',hou,error,extract_data(:,:,1,1))
  else if (hou%gil%ndim.eq.3) then
    call sic_mapgildas('EXTRACTED',hou,error,extract_data(:,:,:,1))
  else if (hou%gil%ndim.eq.4) then
    call sic_mapgildas('EXTRACTED',hou,error,extract_data)
  endif
end subroutine extract_comm
!
subroutine old_slice_comm(line,error)
  use image_def
  use gkernel_interfaces
  use gkernel_types
  use gbl_message
  use iso_c_binding
  use imager_interfaces, only : map_message
  !---------------------------------------------------------------------
  ! @ private  
  !*
  ! IMAGER -- Support routine for command SLICE  
  !   SLICE  DataSet  Xblc Xtrc Yblc Ytrc Type  
  !     or  
  !   SLICE  Dataset  Xc Yc Unit ANGLE PosAngle  
  !
  !   Arbitrary slice in a 3-D data set, using bilinear interpolation
  !!
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: line  !! Command line
  logical, intent(out) :: error         !! Logical error flag
  !
  ! Constants
  integer, external :: pix_axis
  character(len=*), parameter :: rname='SLICE'
  real(kind=8), parameter :: pi=3.14159265358979323846d0
  character(len=6), parameter :: cangle='ANGLE '
  character(len=8) :: unit_type(6)
  data unit_type /'ABSOLUTE','SECONDS','MINUTES','DEGREES','RADIANS','PIXELS'/
  !
  ! Local ---
  character(len=256) :: cinp
  integer :: nc
  integer :: axe,ier
  real(4), allocatable :: lgu(:), mgu(:)
  ! !real(8), allocatable :: ii(:), rr(:), xx(:), yy(:)
  real(8) :: Startx,Starty,Endx,Endy,Centerx,Centery
  real(8) :: aa, bb, xmin, ymin
  !
  integer :: istart(2), iend(2)
  integer :: npoints 
  real(8) :: dstart(2), dend(2), dl, dm, dx, dy, ang, dd
  real(8) :: user1,user2
  character(len=24) :: ra_start, dec_start, ra_end, dec_end
  character(len=24) :: ra_center, dec_center
  real(8) :: ustart(2), uend(2)
  type(gildas) :: hin
  type(gildas), save :: hou
  type(sic_descriptor_t) :: desc
  real, allocatable, target, save :: slice_data(:,:)
  type(projection_t) :: proj
  integer :: itype
  character(len=8) :: ctype, ktype
  character(len=64) :: dtype
  real(kind=8) :: angle_scale(6), angle, length
  type(c_ptr) :: cptr
  !
  ! Code ----
  !
  ! Get name of data file/buffer
  call sic_ch(line,0,1,cinp,nc,.true.,error)
  if (error) return
  !
  ! Incarnate the SIC variable into a local header
  call get_gildas(rname,cinp,desc,hin,error)
  if (error) return
  call adtoad(desc%addr,cptr,1)
  call c_f_pointer(cptr,hin%r3d,hin%gil%dim(1:3))
  !
  call sic_ke(line,0,5,dtype,nc,.true.,error)
  if (error) return
  !
  nc = min(nc,6)
  ctype = dtype
  if (ctype(1:nc).eq.cangle(1:nc)) then
    ! ANGLE Keyword found
    !
    call sic_r8(line,0,6,angle,.true.,error)
    if (error) return
    ! Angle is in Degree North from East - Bring it in range [-180,180[
    ! Define Slice Length according to appropriate Image size in selected
    ! direction.
    if (angle.gt.180) angle = angle-360
    !
    ! The test should also consider the Projection Angle hin%gil%pang
    ! Ignore it so far
    if (abs(angle).lt.22.5) then
      length = abs(hin%gil%inc(1)*hin%gil%dim(1))
    else if (abs(angle).lt.67.5) then    
      length = min(abs(hin%gil%inc(1)*hin%gil%dim(1)),abs(hin%gil%inc(2))*hin%gil%dim(2))
    else if (abs(angle).lt.112.5) then
      length = abs(hin%gil%inc(2)*hin%gil%dim(2))
    else if (abs(angle).lt.157.5) then    
      length = min(abs(hin%gil%inc(1)*hin%gil%dim(1)),abs(hin%gil%inc(2))*hin%gil%dim(2))
    else
      length = abs(hin%gil%inc(1)*hin%gil%dim(1))    
    endif
    length = length/2
    angle = 90-angle ! North towards East in sky...
    angle = angle*pi/180    ! Convert to Radian
    !
    !   SLICE  Dataset  Xc Yc Unit ANGLE PosAngle
    call sic_ke(line,0,4,ctype,nc,.false.,error)
    call sic_ambigs(rname,ctype,ktype,itype,unit_type,6,error)
    if (error) return
    angle_scale = [0.d0,pi/180d0/3600d0,pi/180d0/60d0,pi/180d0,1.d0,-1.d0]  
    !
    call gwcs_projec(hin%gil%a0,hin%gil%d0,hin%gil%pang,hin%gil%ptyp,proj,error)
    if (error) return
    select case (ktype)
    case ('ABSOLUTE')
      call sic_ch(line,0,2,ra_center,nc,.true.,error)
      call sic_ch(line,0,3,dec_center,nc,.true.,error)
      call sic_decode(ra_center,ustart(1),24,error)
      if (error) then
        call map_message(seve%e,rname,'Error in SIC_DECODE RA Start')
        return
      endif
      call sic_decode(dec_center,ustart(2),360,error)
      if (error) then
        call map_message(seve%e,rname,'Error in SIC_DECODE Dec Start')
        return
      endif
      call abs_to_rel(proj,ustart(1), ustart(2), CenterX, CenterY, 1)
      user1 = CenterX - length * cos(angle)
      user2 = CenterY - length * sin(angle)
      istart(1) = pix_axis(hin,user1,1)
      istart(2) = pix_axis(hin,user2,2)
      user1 = CenterX + length * cos(angle)
      user2 = CenterY + length * sin(angle)
      iend(1) = pix_axis(hin,user1,1)
      iend(2) = pix_axis(hin,user2,2)
    case ('PIXELS')
      if (mod(angle,90*pi/180).ne.0) then
        if (abs(hin%gil%inc(1)).ne.abs(hin%gil%inc(2))) then
          call map_message(seve%e,rname,'Cannot specify rotated direction with non square pixels')
          return
        endif
      endif
      call sic_i4(line,0,2,istart(1),.true.,error)
      call sic_i4(line,0,3,istart(2),.true.,error)
      iend(1) = istart(1) + length*cos(angle)/hin%gil%inc(1)
      iend(2) = istart(2) + length*sin(angle)/hin%gil%inc(2)
      istart(1) = istart(1) - length*cos(angle)/hin%gil%inc(1)
      istart(2) = istart(2) - length*sin(angle)/hin%gil%inc(2)
    case default
      call sic_r8(line,0,2,user1,.true.,error)
      call sic_r8(line,0,3,user2,.true.,error)
      CenterX = user1*angle_scale(itype)
      CenterY = user2*angle_scale(itype)
      !
      user1 = CenterX - length * cos(angle)
      user2 = CenterY - length * sin(angle)
      istart(1) = pix_axis(hin,user1,1)
      istart(2) = pix_axis(hin,user2,2)
      user1 = CenterX + length * cos(angle)
      user2 = CenterY + length * sin(angle)
      iend(1) = pix_axis(hin,user1,1)
      iend(2) = pix_axis(hin,user2,2)
    end select
  else    
    ctype = 'ABSOLUTE'
    call sic_ke(line,0,6,ctype,nc,.false.,error)
    call sic_ambigs(rname,ctype,ktype,itype,unit_type,6,error)
    if (error) return
    angle_scale = [0.d0,pi/180d0/3600d0,pi/180d0/60d0,pi/180d0,1.d0,-1.d0]  
    !
    ! Prepare the output
    !
    call gwcs_projec(hin%gil%a0,hin%gil%d0,hin%gil%pang,hin%gil%ptyp,proj,error)
    if (error) return
    select case (ktype)
    case ('ABSOLUTE')
      call sic_ch(line,0,2,ra_start,nc,.true.,error)
      call sic_ch(line,0,3,dec_start,nc,.true.,error)
      call sic_ch(line,0,4,ra_end,nc,.true.,error)
      call sic_ch(line,0,5,dec_end,nc,.true.,error)
      if (error) return
      call sic_decode(ra_start,ustart(1),24,error)
      if (error) then
        call map_message(seve%e,rname,'Error in SIC_DECODE RA Start')
        return
      endif
      call sic_decode(dec_start,ustart(2),360,error)
      if (error) then
        call map_message(seve%e,rname,'Error in SIC_DECODE Dec Start')
        return
      endif
      call sic_decode(ra_end,uend(1),24,error)
      if (error) then
        call map_message(seve%e,rname,'Error in SIC_DECODE RA End')
        return
      endif
      call sic_decode(dec_end,uend(2),360,error)
      if (error) then
        call map_message(seve%e,rname,'Error in SIC_DECODE Dec End')
        return
      endif
      call abs_to_rel(proj,ustart(1), ustart(2), user1, user2, 1)
      istart(1) = pix_axis(hin,user1,1)
      istart(2) = pix_axis(hin,user2,2)
      call abs_to_rel(proj,uend(1), uend(2), user1, user2, 1)
      iend(1) = pix_axis(hin,user1,1)
      iend(2) = pix_axis(hin,user2,2)
    case ('PIXELS')
      call sic_i4(line,0,2,istart(1),.true.,error)
      call sic_i4(line,0,3,istart(2),.true.,error)
      call sic_i4(line,0,4,iend(1),.true.,error)
      call sic_i4(line,0,5,iend(2),.true.,error)
    case default
      call sic_r8(line,0,2,user1,.true.,error)
      call sic_r8(line,0,3,user2,.true.,error)
      user1 = user1*angle_scale(itype)
      user2 = user2*angle_scale(itype)
      istart(1) = pix_axis(hin,user1,1)
      istart(2) = pix_axis(hin,user2,2)
      call sic_r8(line,0,4,user1,.true.,error)
      call sic_r8(line,0,5,user2,.true.,error)
      user1 = user1*angle_scale(itype)
      user2 = user2*angle_scale(itype)
      iend(1) = pix_axis(hin,user1,1)
      iend(2) = pix_axis(hin,user2,2)
    end select
  endif
  !
  if (allocated(slice_data)) then
    error = .false.
    call sic_delvariable('SLICED',.false.,error)
    deallocate (slice_data)
  endif
  call gildas_null(hou)
  !
  call gdf_copy_header(hin,hou,error)
  !
  dstart(1) = dble(istart(1))
  dstart(2) = dble(istart(2))
  dend(1) = dble(iend(1))
  dend(2) = dble(iend(2))
  !
  ! Define number of points
  ang = 0.0
  if (dstart(1).eq.dend(1)) then
    axe = 2
    dx = 0.
    dy = 1.
    npoints = dabs(dend(2) - dstart(2)) + 1.
  elseif (dstart(2).eq.dend(2)) then
    axe = 1
    dx = 1.
    dy = 0.
    npoints = dabs(dend(1) - dstart(1)) + 1.
  else
    axe = 0
    dl = dabs(dend(1)-dstart(1)) + 1.
    dm = dabs(dend(2)-dstart(2)) + 1.
    npoints = sqrt(dl*dl + dm*dm)
    dx = dl/dble(npoints)
    dy = dm/dble(npoints)
  endif
  !
  allocate (lgu(npoints), mgu(npoints), stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'Memory allocation error')
    error = .true.
    return
  endif
  !
  ! Why do not we simply exchange at this stage ?
  ! Because we want to keep the order specified by the user...
  if (dend(1).lt.dstart(1)) then
    dx = -dx
  endif
  if (dend(2).lt.dstart(2)) then
    dy = -dy
  endif
  if (axe.eq.0) then
    ang = atan2(dx*hin%gil%inc(1),dy*hin%gil%inc(2))
  else if (axe.eq.1) then
    dd = dx
  else
    dd = dy
  endif
  !
  ! !Print *,'Axe ',axe,'DX ',dx,' DY ',dy,' ANGLE ',ang 
  !
  !     Allocate arrays for slice coordinates
  call fill_gu(lgu, dstart(1), dx, npoints)
  call fill_gu(mgu, dstart(2), dy, npoints)
  !
  ! Now we would like to know where is the closest point to the (0,0)
  !
  ! We have a straight line dermined by two points: Startx,Starty and Endx,Endy
  Startx = (dstart(1)-hin%gil%ref(1))*hin%gil%inc(1) + hin%gil%val(1)
  Starty = (dstart(2)-hin%gil%ref(2))*hin%gil%inc(2) + hin%gil%val(2)
  Endx = (dend(1)-hin%gil%ref(1))*hin%gil%inc(1) + hin%gil%val(1)
  Endy = (dend(2)-hin%gil%ref(2))*hin%gil%inc(2) + hin%gil%val(2)
  !
  ! Find out the nearest point to (0,0) 
  if (abs(Endx-Startx).gt.abs(Endy-Starty)) then
    ! The line equation is 
    !   y(x) = (x-Startx)/(Endx-Startx)*(Endy-Starty) + Starty
    ! which I write y(x) = aa * x + bb
    aa = (Endy-Starty)/(Endx-Startx) 
    bb = -aa * Startx + Starty
    !
    ! and the distance to (0,0) is sqrt(x^2+y2), whose minimum is obtained
    ! for d(x^2+y^2)/dx = 0 or 
    xmin = -aa*bb/(aa**2+1.d0)
    !
    ! We now want AA and BB to be the (x,y) of the closest point
    BB = xmin*aa+bb
    AA = xmin
  else
    !
    ! As above, but swapping (x,y)
    aa = (Endx-Startx)/(Endy-Starty) 
    bb = -aa * Starty + Startx
    ymin = -aa*bb/(aa**2+1.d0)
    !
    ! We now want AA and BB to be the (x,y) of the closest point
    AA = ymin*aa+bb
    BB = ymin
  endif
  !
  ! !Print *,' AA ',aa*180*3600/pi,' BB ',bb*180*3600/pi
  !
  ! Prepare the header
  hou%gil%dim(1) = npoints
  hou%gil%dim(2) = hin%gil%dim(3)
  hou%gil%dim(3) = 1
  hou%gil%ndim = 2
  hou%loca%size = hou%gil%dim(1)*hou%gil%dim(2)
  hou%char%code(2) = hin%char%code(3)
  hou%gil%yaxi = 3
  hou%gil%faxi = 2
  hou%char%code(3) = 'ANGLE'
  !
  hou%gil%convert(:,2) = hin%gil%convert(:,3)
  !
  user1 = (lgu(1)-hin%gil%ref(1))*hin%gil%inc(1) + hin%gil%val(1)
  user2 = (mgu(1)-hin%gil%ref(2))*hin%gil%inc(2) + hin%gil%val(2)
  !
  if (axe.ne.0) then
    hou%char%code(1) = hin%char%code(axe)
    hou%gil%inc(1) =  dd*hin%gil%inc(axe)
    hou%gil%xaxi = hin%gil%xaxi
    hou%gil%val(1) = 0.
    !
    ! Here we would like to put the other axis information as 3rd
    ! degenerate axis
    hou%char%code(3) = hin%char%code(3-axe)
    hou%gil%inc(3) =  hin%gil%inc(3-axe)
    hou%gil%ref(3) = hin%gil%ref(3-axe)
  else
    hou%char%code(1) = 'ANGLE'
    hou%gil%xaxi = 1
    hou%gil%pang = ang
    ! The pixel size is also different - pixels have orthogonal sides,
    ! and this is the hypotenuse of the right-angled triangle.
    hou%gil%inc(1) = sqrt((dx*hin%gil%inc(1))**2 + (dy*hin%gil%inc(2))**2)
    if (abs(dx).gt.abs(dy)) then
      if (dx.lt.0) hou%gil%inc(1) = -hou%gil%inc(1)
    else
      if (dy.lt.0) hou%gil%inc(1) = -hou%gil%inc(1)
    endif
    !
    hou%gil%ref(3) = 1.0
    hou%gil%val(3) = sqrt(AA**2+bb**2)  ! Distance to (0,0) 
    hou%gil%inc(3) = hou%gil%inc(1)
    hou%gil%pang = ang
  endif
  !
  ! First axis
  hou%gil%val(1) = 0.0
  ! But now, we have our Reference pixel that has an X value of
  ! AA and an YY value of BB - We take the most precise
  if (abs(dx).gt.abs(dy)) then
    hou%gil%ref(1) = (AA-user1)/(hin%gil%inc(1)*dx) + 1.0
  else
    hou%gil%ref(1) = (BB-user2)/(hin%gil%inc(2)*dy) + 1.0
  endif
  !
  hou%gil%ndim = 3
  hou%gil%dim(3) = 1
  hou%gil%extr_words = 0
  !
  ! Allocate the data
  allocate(slice_data(hou%gil%dim(1),hou%gil%dim(2)), stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'Output memory allocation error')
    error = .true.
    return
  endif
  hou%r2d => slice_data
  !
  ! Compute the slice
  call do_sliceb(hin%r3d, hin%gil%dim(1), hin%gil%dim(2), hin%gil%dim(3),   &
   &      lgu, mgu, hou%r2d, npoints, hin%gil%bval, hin%gil%eval)
  hou%gil%eval = max(hin%gil%eval,0.)
  !
  ! Post the result as a SIC Image variable
  error = .false.
  call sic_mapgildas('SLICED',hou,error,slice_data)
  !
end subroutine old_slice_comm
!
subroutine slice_comm(line,error)
  use image_def
  use gkernel_interfaces
  use gkernel_types
  use gbl_message
  use iso_c_binding
  use imager_interfaces, only : map_message, slice_sub
  !---------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- Support routine for command SLICE  
  !   SLICE  DataSet  Xblc Xtrc Yblc Ytrc Type  
  !     or  
  !   SLICE  Dataset  Xc Yc Unit ANGLE PosAngle  
  !
  !   Arbitrary slice in a 3-D data set, using bilinear interpolation
  !!
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: line  !! Command line
  logical, intent(out) :: error         !! Logical error flag
  !
  ! Constants
  integer, external :: pix_axis
  character(len=*), parameter :: rname='SLICE'
  real(kind=8), parameter :: pi=3.14159265358979323846d0
  character(len=6), parameter :: cangle='ANGLE '
  integer, parameter :: munit=6
  character(len=8) :: unit_type(munit)
  data unit_type /'ABSOLUTE','SECONDS','MINUTES','DEGREES','RADIANS','PIXELS'/
  real(8), parameter :: angle_scale(munit) = [0.d0,pi/180d0/3600d0,pi/180d0/60d0,pi/180d0,1.d0,-1.d0]
  ! Local
  character(len=256) :: cinp
  integer :: nc
  !
  real(8) :: Centerx,Centery
  !
  integer :: istart(2), iend(2)
  real(8) :: user1,user2
  character(len=24) :: ra_start, dec_start, ra_end, dec_end
  character(len=24) :: ra_center, dec_center
  real(8) :: ustart(2), uend(2)
  type(gildas) :: hin
  type(gildas), save :: hou
  type(sic_descriptor_t) :: desc
  real, allocatable, target, save :: slice_data(:,:)
  type(projection_t) :: proj
  integer :: itype
  character(len=64) :: dtype
  character(len=8) :: ctype, ktype
  real(kind=8) :: angle, length
  type(c_ptr) :: cptr
  !
  ! Code ----
  if (sic_narg(0).eq.0) then
    call sic_get_char('LAST_SHOWN',cinp,nc,error)
  else
    ! Get name of data file/buffer
    call sic_ch(line,0,1,cinp,nc,.true.,error)
  endif
  if (error) return
  !
  ! Incarnate the SIC variable into a local header
  call get_gildas(rname,cinp,desc,hin,error)
  if (error) return
  call adtoad(desc%addr,cptr,1)
  call c_f_pointer(cptr,hin%r3d,hin%gil%dim(1:3))
  !
  if (sic_narg(0).eq.0) then
    !
    ! Call the cursor if it is a 2-D array
    call exec_program('@ p_slice_corner 1')
    call sic_get_inte('PIX_CURS[1]',istart(1),error)
    call sic_get_inte('PIX_CURS[2]',istart(2),error)
    if (istart(1).eq.0 .and. istart(2).eq.0) then
      call map_message(seve%e,rname,'No available 2-D display for SLICE /CURSOR')
      error = .true.
      return
    endif
    call exec_program('@ p_slice_corner 2')
    call sic_get_inte('PIX_CURS[1]',iend(1),error)
    call sic_get_inte('PIX_CURS[2]',iend(2),error)
  else
    call sic_ke(line,0,5,dtype,nc,.true.,error)
    if (error) return
    !
    nc = min(nc,6)
    ctype = dtype
    if (ctype(1:nc).eq.cangle(1:nc)) then
      ! ANGLE Keyword found
      !
      call sic_r8(line,0,6,angle,.true.,error)
      if (error) return
      ! Angle is in Degree North from East - Bring it in range [-180,180[
      ! Define Slice Length according to appropriate Image size in selected
      ! direction.
      if (angle.gt.180) angle = angle-360
      !
      ! The test should also consider the Projection Angle hin%gil%pang
      ! Ignore it so far
      if (abs(angle).lt.22.5) then
        length = abs(hin%gil%inc(1)*hin%gil%dim(1))
      else if (abs(angle).lt.67.5) then
        length = min(abs(hin%gil%inc(1)*hin%gil%dim(1)),abs(hin%gil%inc(2))*hin%gil%dim(2))
      else if (abs(angle).lt.112.5) then
        length = abs(hin%gil%inc(2)*hin%gil%dim(2))
      else if (abs(angle).lt.157.5) then
        length = min(abs(hin%gil%inc(1)*hin%gil%dim(1)),abs(hin%gil%inc(2))*hin%gil%dim(2))
      else
        length = abs(hin%gil%inc(1)*hin%gil%dim(1))
      endif
      length = length/2
      angle = 90-angle ! North towards East in sky...
      angle = angle*pi/180    ! Convert to Radian
      !
      !   SLICE  Dataset  Xc Yc Unit ANGLE PosAngle
      call sic_ke(line,0,4,ctype,nc,.false.,error)
      call sic_ambigs(rname,ctype,ktype,itype,unit_type,6,error)
      if (error) return
      !
      call gwcs_projec(hin%gil%a0,hin%gil%d0,hin%gil%pang,hin%gil%ptyp,proj,error)
      if (error) return
      select case (ktype)
      case ('ABSOLUTE')
        call sic_ch(line,0,2,ra_center,nc,.true.,error)
        call sic_ch(line,0,3,dec_center,nc,.true.,error)
        call sic_decode(ra_center,ustart(1),24,error)
        if (error) then
          call map_message(seve%e,rname,'Error in SIC_DECODE RA Start')
          return
        endif
        call sic_decode(dec_center,ustart(2),360,error)
        if (error) then
          call map_message(seve%e,rname,'Error in SIC_DECODE Dec Start')
          return
        endif
        call abs_to_rel(proj,ustart(1), ustart(2), CenterX, CenterY, 1)
        user1 = CenterX - length * cos(angle)
        user2 = CenterY - length * sin(angle)
        istart(1) = pix_axis(hin,user1,1)
        istart(2) = pix_axis(hin,user2,2)
        user1 = CenterX + length * cos(angle)
        user2 = CenterY + length * sin(angle)
        iend(1) = pix_axis(hin,user1,1)
        iend(2) = pix_axis(hin,user2,2)
      case ('PIXELS')
        if (mod(angle,90*pi/180).ne.0) then
          if (abs(hin%gil%inc(1)).ne.abs(hin%gil%inc(2))) then
            call map_message(seve%e,rname,'Cannot specify rotated direction with non square pixels')
            return
          endif
        endif
        call sic_i4(line,0,2,istart(1),.true.,error)
        call sic_i4(line,0,3,istart(2),.true.,error)
        iend(1) = istart(1) + length*cos(angle)/hin%gil%inc(1)
        iend(2) = istart(2) + length*sin(angle)/hin%gil%inc(2)
        istart(1) = istart(1) - length*cos(angle)/hin%gil%inc(1)
        istart(2) = istart(2) - length*sin(angle)/hin%gil%inc(2)
      case default
        call sic_r8(line,0,2,user1,.true.,error)
        call sic_r8(line,0,3,user2,.true.,error)
        CenterX = user1*angle_scale(itype)
        CenterY = user2*angle_scale(itype)
        !
        user1 = CenterX - length * cos(angle)
        user2 = CenterY - length * sin(angle)
        istart(1) = pix_axis(hin,user1,1)
        istart(2) = pix_axis(hin,user2,2)
        user1 = CenterX + length * cos(angle)
        user2 = CenterY + length * sin(angle)
        iend(1) = pix_axis(hin,user1,1)
        iend(2) = pix_axis(hin,user2,2)
      end select
    else
      ctype = 'ABSOLUTE'
      call sic_ke(line,0,6,ctype,nc,.false.,error)
      call sic_ambigs(rname,ctype,ktype,itype,unit_type,6,error)
      if (error) return
      !
      ! Prepare the output
      !
      call gwcs_projec(hin%gil%a0,hin%gil%d0,hin%gil%pang,hin%gil%ptyp,proj,error)
      if (error) return
      select case (ktype)
      case ('ABSOLUTE')
        call sic_ch(line,0,2,ra_start,nc,.true.,error)
        call sic_ch(line,0,3,dec_start,nc,.true.,error)
        call sic_ch(line,0,4,ra_end,nc,.true.,error)
        call sic_ch(line,0,5,dec_end,nc,.true.,error)
        if (error) return
        call sic_decode(ra_start,ustart(1),24,error)
        if (error) then
          call map_message(seve%e,rname,'Error in SIC_DECODE RA Start')
          return
        endif
        call sic_decode(dec_start,ustart(2),360,error)
        if (error) then
          call map_message(seve%e,rname,'Error in SIC_DECODE Dec Start')
          return
        endif
        call sic_decode(ra_end,uend(1),24,error)
        if (error) then
          call map_message(seve%e,rname,'Error in SIC_DECODE RA End')
          return
        endif
        call sic_decode(dec_end,uend(2),360,error)
        if (error) then
          call map_message(seve%e,rname,'Error in SIC_DECODE Dec End')
          return
        endif
        call abs_to_rel(proj,ustart(1), ustart(2), user1, user2, 1)
        istart(1) = pix_axis(hin,user1,1)
        istart(2) = pix_axis(hin,user2,2)
        call abs_to_rel(proj,uend(1), uend(2), user1, user2, 1)
        iend(1) = pix_axis(hin,user1,1)
        iend(2) = pix_axis(hin,user2,2)
      case ('PIXELS')
        call sic_i4(line,0,2,istart(1),.true.,error)
        call sic_i4(line,0,3,istart(2),.true.,error)
        call sic_i4(line,0,4,iend(1),.true.,error)
        call sic_i4(line,0,5,iend(2),.true.,error)
      case default
        call sic_r8(line,0,2,user1,.true.,error)
        call sic_r8(line,0,3,user2,.true.,error)
        user1 = user1*angle_scale(itype)
        user2 = user2*angle_scale(itype)
        istart(1) = pix_axis(hin,user1,1)
        istart(2) = pix_axis(hin,user2,2)
        call sic_r8(line,0,4,user1,.true.,error)
        call sic_r8(line,0,5,user2,.true.,error)
        user1 = user1*angle_scale(itype)
        user2 = user2*angle_scale(itype)
        iend(1) = pix_axis(hin,user1,1)
        iend(2) = pix_axis(hin,user2,2)
      end select
    endif
  endif
  !
  if (allocated(slice_data)) then
    error = .false.
    call sic_delvariable('SLICED',.false.,error)
    deallocate (slice_data)
  endif
  !
  call slice_sub(hin,hou,slice_data,istart,iend,error)
  if (error) return
  ! Post the result as a SIC Image variable
  call sic_mapgildas('SLICED',hou,error,slice_data)
  !
end subroutine slice_comm
!
subroutine slice_sub(hin,hou,slice_data,istart,iend,error)
  use image_def
  use gkernel_types
  use gkernel_interfaces
  use gbl_message
  use imager_interfaces, only : map_message
  !---------------------------------------------------
  ! @ private-mandatory
  !*
  ! IMAGER -- Internal routine for command SLICE
  !!
  !---------------------------------------------------
  type(gildas), intent(in) :: hin     !! Input cube header
  type(gildas), intent(out) :: hou    !! Output slice header
  real, allocatable, intent(inout), target :: slice_data(:,:)  !! Slice data
  integer, intent(in) :: istart(2)    !! Starting pixel
  integer, intent(in) :: iend(2)      !! Ending pixel
  logical, intent(inout) :: error     !! Logical error flag
  !
  ! Constants
  character(len=*), parameter :: rname='SLICE'
  real(8), parameter :: pi=acos(-1d0)
  !
  ! Local ---
  integer :: axe,ier
  real(4), allocatable :: lgu(:), mgu(:)
  real(8) :: Startx,Starty,Endx,Endy
  real(8) :: aa, bb, xmin, ymin
  !
  integer :: npoints
  real(8) :: dstart(2), dend(2), dl, dm, dx, dy, ang, dd
  real(8) :: user1,user2
  !
  ! Code ----
  call gildas_null(hou)
  call gdf_copy_header(hin,hou,error)
  !
  dstart(1) = dble(istart(1))
  dstart(2) = dble(istart(2))
  dend(1) = dble(iend(1))
  dend(2) = dble(iend(2))
  !
  ! Define number of points
  ang = 0.0
  if (dstart(1).eq.dend(1)) then
    axe = 2
    dx = 0.
    dy = 1.
    npoints = dabs(dend(2) - dstart(2)) + 1.
  elseif (dstart(2).eq.dend(2)) then
    axe = 1
    dx = 1.
    dy = 0.
    npoints = dabs(dend(1) - dstart(1)) + 1.
  else
    axe = 0
    dl = dabs(dend(1)-dstart(1)) + 1.
    dm = dabs(dend(2)-dstart(2)) + 1.
    npoints = sqrt(dl*dl + dm*dm)
    dx = dl/dble(npoints)
    dy = dm/dble(npoints)
  endif
  !
  allocate (lgu(npoints), mgu(npoints), stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'Memory allocation error')
    error = .true.
    return
  endif
  !
  ! Why do not we simply exchange at this stage ?
  ! Because we want to keep the order specified by the user...
  if (dend(1).lt.dstart(1)) then
    dx = -dx
  endif
  if (dend(2).lt.dstart(2)) then
    dy = -dy
  endif
  if (axe.eq.0) then
    ang = atan2(dx*hin%gil%inc(1),dy*hin%gil%inc(2))
  else if (axe.eq.1) then
    dd = dx
  else
    dd = dy
  endif
  !
  !     Allocate arrays for slice coordinates
  call fill_gu(lgu, dstart(1), dx, npoints)
  call fill_gu(mgu, dstart(2), dy, npoints)
  !
  ! Now we would like to know where is the closest point to the (0,0)
  !
  ! We have a straight line dermined by two points: Startx,Starty and Endx,Endy
  Startx = (dstart(1)-hin%gil%ref(1))*hin%gil%inc(1) + hin%gil%val(1)
  Starty = (dstart(2)-hin%gil%ref(2))*hin%gil%inc(2) + hin%gil%val(2)
  Endx = (dend(1)-hin%gil%ref(1))*hin%gil%inc(1) + hin%gil%val(1)
  Endy = (dend(2)-hin%gil%ref(2))*hin%gil%inc(2) + hin%gil%val(2)
  !
  ! Find out the nearest point to (0,0)
  if (abs(Endx-Startx).gt.abs(Endy-Starty)) then
    ! The line equation is
    !   y(x) = (x-Startx)/(Endx-Startx)*(Endy-Starty) + Starty
    ! which I write y(x) = aa * x + bb
    aa = (Endy-Starty)/(Endx-Startx)
    bb = -aa * Startx + Starty
    !
    ! and the distance to (0,0) is sqrt(x^2+y2), whose minimum is obtained
    ! for d(x^2+y^2)/dx = 0 or
    xmin = -aa*bb/(aa**2+1.d0)
    !
    ! We now want AA and BB to be the (x,y) of the closest point
    BB = xmin*aa+bb
    AA = xmin
  else
    !
    ! As above, but swapping (x,y)
    aa = (Endx-Startx)/(Endy-Starty)
    bb = -aa * Starty + Startx
    ymin = -aa*bb/(aa**2+1.d0)
    !
    ! We now want AA and BB to be the (x,y) of the closest point
    AA = ymin*aa+bb
    BB = ymin
  endif
  !
  ! Prepare the header
  hou%gil%dim(1) = npoints
  hou%gil%dim(2) = hin%gil%dim(3)
  hou%gil%dim(3) = 1
  hou%gil%ndim = 2
  hou%loca%size = hou%gil%dim(1)*hou%gil%dim(2)
  hou%char%code(2) = hin%char%code(3)
  hou%gil%yaxi = 3
  hou%gil%faxi = 2
  hou%char%code(3) = 'ANGLE'
  !
  hou%gil%convert(:,2) = hin%gil%convert(:,3)
  !
  user1 = (lgu(1)-hin%gil%ref(1))*hin%gil%inc(1) + hin%gil%val(1)
  user2 = (mgu(1)-hin%gil%ref(2))*hin%gil%inc(2) + hin%gil%val(2)
  !
  if (axe.ne.0) then
    hou%char%code(1) = hin%char%code(axe)
    hou%gil%inc(1) =  dd*hin%gil%inc(axe)
    hou%gil%xaxi = hin%gil%xaxi
    hou%gil%val(1) = 0.
    !
    ! Here we would like to put the other axis information as 3rd
    ! degenerate axis
    hou%char%code(3) = hin%char%code(3-axe)
    hou%gil%inc(3) =  hin%gil%inc(3-axe)
    hou%gil%ref(3) = hin%gil%ref(3-axe)
  else
    hou%char%code(1) = 'ANGLE'
    hou%gil%xaxi = 1
    hou%gil%pang = ang
    ! The pixel size is also different - pixels have orthogonal sides,
    ! and this is the hypotenuse of the right-angled triangle.
    hou%gil%inc(1) = sqrt((dx*hin%gil%inc(1))**2 + (dy*hin%gil%inc(2))**2)
    if (abs(dx).gt.abs(dy)) then
      if (dx.lt.0) hou%gil%inc(1) = -hou%gil%inc(1)
    else
      if (dy.lt.0) hou%gil%inc(1) = -hou%gil%inc(1)
    endif
    !
    hou%gil%ref(3) = 1.0
    hou%gil%val(3) = sqrt(AA**2+bb**2)  ! Distance to (0,0) 
    hou%gil%inc(3) = hou%gil%inc(1)
    hou%gil%pang = ang
  endif
  !
  ! First axis
  hou%gil%val(1) = 0.0
  ! But now, we have our Reference pixel that has an X value of
  ! AA and an YY value of BB - We take the most precise
  if (abs(dx).gt.abs(dy)) then
    hou%gil%ref(1) = (AA-user1)/(hin%gil%inc(1)*dx) + 1.0
  else
    hou%gil%ref(1) = (BB-user2)/(hin%gil%inc(2)*dy) + 1.0
  endif
  !
  hou%gil%ndim = 3
  hou%gil%dim(3) = 1
  hou%gil%extr_words = 0
  !
  ! Allocate the data
  allocate(slice_data(hou%gil%dim(1),hou%gil%dim(2)), stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'Output memory allocation error')
    error = .true.
    return
  endif
  hou%r2d => slice_data
  !
  ! Compute the slice
  call do_sliceb(hin%r3d, hin%gil%dim(1), hin%gil%dim(2), hin%gil%dim(3),   &
   &      lgu, mgu, hou%r2d, npoints, hin%gil%bval, hin%gil%eval)
  hou%gil%eval = max(hin%gil%eval,0.)
  !
end subroutine slice_sub
!
subroutine do_sliceb(in, nx, ny, nc, x, y, out, np, blank, eblank)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ public
  !*
  ! IMAGER -- Support routine for command SLICE
  !
  !   Arbitrary slice in a 3-D data set, using bilinear interpolation
  !   Compute the slice, with blanking
  !!
  !---------------------------------------------------------------------  
  integer(kind=index_length), intent(in) :: nx    !! Number of X pixels
  integer(kind=index_length), intent(in) :: ny    !! Number of Y pixels
  integer(kind=index_length), intent(in) :: nc    !! Number of channels
  real, intent(in) :: in(nx,ny,nc)                !! Input cube
  integer :: np                                   !! Number of points
  real, intent(in) :: x(np)                       !! X coordinates
  real, intent(in) :: y(np)                       !! Y coordinates
  real, intent(out) :: out(np,nc)                 !! Output slice
  real, intent(in) :: blank                       !! Blanking
  real, intent(in) :: eblank                      !! and tolerance
  !
  ! Local ---
  real :: dx,dy,coeff(4),weight
  integer :: ic,n,i,j
  !
  if (eblank.lt.0.) then
    do n=1,np
      i = int(x(n))
      j = int(y(n))
      if((i.lt.1).or.(j.lt.1).or.(i.ge.nx).or.(j.ge.ny))then
        !              Interpolated point outside input image
        out(n, 1:nc) = blank
      else
        dx = x(n) - float(i)
        dy = y(n) - float(j)
        do ic=1,nc
              out(n,ic) = dx * dy * in(i+1, j+1, ic)   &
           &          + (1.0 - dx) * dy * in(i, j+1, ic)   &
           &          + (1.0 - dx) * (1.0 - dy) * in(i, j, ic)   &
           &          + dx * (1.0 - dy) * in(i+1, j, ic)
        enddo
      endif
    enddo
  else  
    do n=1,np
      i = int(x(n))
      j = int(y(n))
      if((i.lt.1).or.(j.lt.1).or.(i.ge.nx).or.(j.ge.ny))then
        !             Interpolated point outside input image
        out(n, 1:nc) = blank
      else
        dx = x(n) - float(i)
        dy = y(n) - float(j)
        do ic=1,nc
          coeff(1:4) = 1.0
          if (abs(in(i, j, ic)-blank).le.eblank) then
            coeff(1) = 0.
          else
            coeff(1) = (1.0 - dx) * (1.0 - dy)
          endif
          if (abs(in(i+1, j, ic)-blank).le.eblank) then
            coeff(2) = 0.
          else
            coeff(2) = dx * (1.0 - dy) 
          endif
          if (abs(in(i, j+1, ic)-blank).le.eblank) then
            coeff(3) = 0. 
          else
            coeff(3) = (1.0 - dx) * dy
          endif
          if (abs(in(i+1, j+1, ic)-blank).le.eblank) then
            coeff(4) = 0.
          else
            coeff(4) = dx * dy
          endif
          weight = sum(coeff)
          if (weight.gt.0) then
            weight = 1.0/weight
            out(n,ic) =   weight * ( & 
         &          coeff(1) * in(i, j, ic)   +  &
         &          coeff(2) * in(i+1, j, ic) +  &
         &          coeff(3) * in(i, j+1, ic) +  &
         &          coeff(4) * in(i+1, j+1, ic) ) 
          else
            out(n,ic) = blank
          endif
        enddo
      endif
    enddo
  endif
end subroutine do_sliceb
!
subroutine fill_gu(ipgu, ds, dt, np)
  ! @ private
  !! IMAGER - Utility routine: Fill a real grid
  integer, intent(in) :: np                        !! Number of points
  real, intent(out) :: ipgu(np)                    !! Output grid
  real(8), intent(in) :: ds                        !! Starting value
  real(8), intent(in) :: dt                        !! Step
  !
  ! Local ---
  integer :: n
  real(8) :: t
  !
  ! Code ----
  t = ds
  do n=1,np
    ipgu(n) = t
    t = t + dt
  enddo
end subroutine fill_gu
!
!
function pix_axis (head, user, iaxis)
  use image_def
  ! @ private
  !! IMAGER -- Utility routine: Get pixel corresponding to a 
  !!! user coordinate along the specified axis.
  real(8), intent(in) :: user         !! User coordinates
  type(gildas), intent(in) :: head    !! Image header
  integer, intent(in) :: iaxis        !! Axis
  integer :: pix_axis ! intent(out)   !! corresponding pixel 
  !
  ! Test error...
  if ((iaxis.lt.1).or.(iaxis.gt.gdf_maxdims)) then
    pix_axis = 0
  else
    pix_axis = nint( (user - head%gil%val(iaxis)) /  &
        head%gil%inc(iaxis) + head%gil%ref(iaxis) )
  endif
end function pix_axis
!
subroutine sub_extract(a,na1,na2,na3,na4,   &
     &    b,nb1,nb2,nb3,nb4,ni,nu,np,blank)
  use gildas_def
  ! @ private
  !! IMAGER -- Utility routine: 4-D extraction
  integer(kind=index_length) :: na1                    !
  integer(kind=index_length) :: na2                    !
  integer(kind=index_length) :: na3                    !
  integer(kind=index_length) :: na4                    !
  real, intent(in) :: a(na1,na2,na3,na4)               !
  integer(kind=index_length) :: nb1                    !
  integer(kind=index_length) :: nb2                    !
  integer(kind=index_length) :: nb3                    !
  integer(kind=index_length) :: nb4                    !
  real, intent(inout) :: b(nb1,nb2,nb3,nb4)            !
  integer(kind=index_length) :: ni(4)                  !
  integer(kind=index_length) :: nu(4)                  !
  integer(kind=index_length) :: np(4)                  !
  real, intent(in) :: blank                            !
  ! Local
  integer :: ia,ja,ka,la, ib,jb,kb,lb
  !
  do lb=1,nb4
    la = lb+ni(4)-np(4)
    if (la.ge.ni(4) .and. la.le.nu(4)) then
      do kb=1,nb3
        ka = kb+ni(3)-np(3)
        if (ka.ge.ni(3) .and. ka.le.nu(3)) then
          do jb=1,nb2
            ja = jb+ni(2)-np(2)
            if (ja.ge.ni(2) .and. ja.le.nu(2)) then
              do ib=1,nb1
                ia = ib+ni(1)-np(1)
                if (ia.ge.ni(1) .and. ia.le.nu(1)) then
                  b(ib,jb,kb,lb) = a(ia,ja,ka,la)
                else
                  b(ib,jb,kb,lb) = blank
                endif
              enddo
            else
              do ib=1,nb1
                b(ib,jb,kb,lb) = blank
              enddo
            endif
          enddo
        else
          do jb=1,nb2
            do ib=1,nb1
              b(ib,jb,kb,lb) = blank
            enddo
          enddo
        endif
      enddo
    else
      do kb=1,nb3
        do jb=1,nb2
          do ib=1,nb1
            b(ib,jb,kb,lb) = blank
          enddo
        enddo
      enddo
    endif
  enddo
end subroutine sub_extract 
!
subroutine parabola_3pt8(x,y,aa,bb,cc) 
  !----------------------------------------------------------------------
  ! @ private
  !* 
  ! IMAGER -- Utility routine  
  !	Solve for Y = aa*x^2 + bb*x + cc with 3 points input data
  !!
  !----------------------------------------------------------------------
  real(8), intent(in) :: x(3)  !! Abscissa
  real(8), intent(in) :: y(3)  !! Ordinate
  real(8), intent(out) :: cc,bb,aa  !! 3rd order polynom coefficients
  !
  aa = (y(3)-y(2))*(x(2)-x(1))-(y(2)-y(1))*(x(3)-x(2))
  bb = (x(2)-x(1))*(x(3)*x(3)-x(2)*x(2))-(x(2)*x(2)-x(1)*x(1))*(x(3)-x(2))
  aa = aa/bb
  bb = (y(2)-y(1))-aa*(x(2)*x(2)-x(1)*x(1))
  bb = bb/(x(2)-x(1))
  cc = y(1)-aa*x(1)*x(1)-bb*x(1)
end subroutine parabola_3pt8

subroutine define_symbol (line,nline,error)
  use sic_dependencies_interfaces
  use sic_structures
  use sic_dictionaries
  use sic_interfaces, except_this=>define_symbol
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! SIC   Support routine for command
  !       SYMBOL [ABBREV] ["ANYTHING you want"] [/INQUIRE ["Question"]]
  !       Defines, list or delete an abbreviation
  ! Arguments :
  !       LINE    C*(*)   Command line defining the abbreviation
  !---------------------------------------------------------------------
  character(len=*)       :: line   !
  integer                :: nline  !
  logical, intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='SYMBOL'
  character(len=40) :: question
  character(len=16) :: argum
  character(len=translation_length) :: symb
  character(len=symbol_length) :: name
  integer :: list(maxsym),i,lt,in,nc,ier
  character(len=symbol_length+translation_length+7) :: mess  ! Matches format 100 below
  !
  ! Check if one is listing the Symbol table
  if (.not.sic_present(0,1)) then
    if (symbols%pf(27).eq.0) then
      call sic_message(seve%r,rname,'Table is empty')
    else
      call gag_hassort(maxsym,symbols%pf,symbols%pn,symbols%name,list,in)
      call sic_message(seve%r,rname,'Table contains : ')
      do i=1,in
        write(mess,100) symbols%name(list(i)),  &
                        symbols%trans(list(i))(1:symbols%ltrans(list(i)))
        call sic_message(seve%r,rname,mess)
      enddo
    endif
    return
  endif
  !
  ! Find the symbol and truncate to symbol_length characters, exclude quotes
  call sic_ch (line,0,1,argum,nc,.true.,error)
  if (error) return
  call sic_upper(argum)
  name = argum
  if (nc.gt.symbol_length)  &
    call sic_message(seve%w,rname,'Symbol truncated to '//name)
  !
  ! Check if symbol is to be listed
  if (.not.sic_present(0,2).and..not.sic_present(1,0)) then
    ier = gag_hasfin(maxsym,symbols%pf,symbols%pn,symbols%name,name,in)
    if (mod(ier,2).ne.0) then
      write(mess,100) name,  &
                      symbols%trans(in)(1:symbols%ltrans(in))
      call sic_message(seve%r,rname,mess)
    else
      call sic_message(seve%w,rname,'Undefined symbol '//name)
    endif
    return
  endif
  !
  ! Create a new symbol definition
  if (sic_present(0,3)) then
    call sic_message(seve%e,rname,"Trailing arguments in assignment: "//line)
    error = .true.
    return
  endif
  !
  ! Check if enquiry needed
  if (sic_present(1,0)) then
    question = name//'Translation ?'
    call sic_ch (line,1,1,question,nc,.false.,error)
    if (error) return
    call sic_wprn(question(1:nc),symb,lt)
    if (lt.eq.0) return
  else
    !
    ! Define abbreviation
    call sic_ch (line,0,2,symb,lt,.true.,error)
    if (error) return
  endif
  !
  ! Insert or replace in symbol dictionnary
  call sic_setsymbol (name,symb(1:lt),error)
  return
  !
100 format("'",a,"'",' = "',a,'"')
end subroutine define_symbol
!
subroutine replace_usercom(user,command,line,nline,error)
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>replace_usercom
  use sic_types
  !---------------------------------------------------------------------
  ! @ private
  !   Identifies and translate the user command from the input command
  ! line
  !---------------------------------------------------------------------
  type(sic_language_t), intent(in)    :: user     ! The user language
  character(len=*),     intent(inout) :: command  ! The user command to translate
  character(len=*),     intent(inout) :: line     ! Line to be translated (updated)
  integer(kind=4),      intent(inout) :: nline    ! Line length (updated)
  logical,              intent(inout) :: error    ! Logical error flag
  ! Local
  integer(kind=4) :: ier,in,lt,ls,pos
  !
  ier = gag_hasfin(user%usym%msym,user%usym%pf,user%usym%pn,user%usym%name,  &
    command,in)
  if (ier.ne.1) then
    call sic_message(seve%e,'SIC','User command not understood')
    error = .true.
    return
  endif
  ! Length of translation
  lt = user%usym%ltrans(in)
  !
  ! Length of symbol:
  !       USER      \     COMMAND
  ls = user%lname + 1 + len_trim(command)
  !
  ! Position in line
  pos = 1
  !
  call replace_symlog(line,ls,user%usym%trans(in),lt,pos,nline,error)
  if (error) return
  !
end subroutine replace_usercom
!
subroutine replace_symbol(line,nline,error)
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>replace_symbol
  use sic_dictionaries
  !---------------------------------------------------------------------
  ! @ private
  !  Identifies and translate all the SIC symbols from the input
  ! command line
  !---------------------------------------------------------------------
  character(len=*), intent(inout) :: line   ! Line to be translated (updated)
  integer(kind=4),  intent(inout) :: nline  ! Line length (updated)
  logical,          intent(out)   :: error  ! Logical error flag
  ! Local
  logical :: symb
  character(len=symbol_length) :: name
  integer :: pos,next,lsymb,ltrans,in,ier
  !
  ! If no symbol, return
  error = .false.
  if (symbols%pf(27).eq.0) return
  !
  ! POS   Pointer of current position in LINE
  ! NEXT  Relative position of next word separator
  !       The absolute position of next word separator is POS+NEXT
  !       The length of pseudo-symbol is also NEXT
  !
  ! First word
  symb = .false.
  pos  = 1
  next = index(line(pos+1:),' ')
  !
  ! Set name to be translated
  name = line(pos:next)
  next = next-1
  !
  ! All other words
  do
    lsymb = next+1
    ier = gag_hasfin(maxsym,symbols%pf,symbols%pn,symbols%name,name,in)
    if (ier.eq.1) then
      ltrans = symbols%ltrans(in)
      call replace_symlog(line,lsymb,symbols%trans(in),ltrans,pos,nline,error)
      if (error) return
      symb = .true.
    endif
    !
    ! Search for beginning of next symbol.
    next=index(line(pos+1:),"'")
    ! Nothing left
    if (next.eq.0) then
      if (symb) call sic_blanc(line,nline)
      return
    endif
    !
    ! Find next WORD separator
30  pos = pos+next
    next = index(line(pos+1:),"'")
    ! Nothing left
    if (next.eq.0) then
      if (symb) call sic_blanc(line,nline)
      return
    endif
    if (index(line(pos+1:),' ').lt.next) goto 30
    !
    ! Valid symbol look for translation
    name = line(pos+1:pos+next-1)
    call sic_upper(name)
  enddo
end subroutine replace_symbol
!
subroutine replace_logical(line,nline,error)
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>replace_logical
  !---------------------------------------------------------------------
  ! @ private
  ! SIC Internal Routine
  !     Replace logical names between Back Quotes by their translation
  !---------------------------------------------------------------------
  character(len=*)       :: line   !
  integer                :: nline  !
  logical, intent(inout) :: error  !
  ! Local
  integer :: i,ier,istart,iend,lenlog,lentrans
  character(len=512) :: lognam, inpnam
  character(len=1) :: bquot,dquot
  logical :: string
  ! Data
  data bquot/'`'/, dquot/'"'/
  !
  string = .false.
  istart = 0
  iend = 0
  !
  i = 1
  do while (i.le.nline)
    if (line(i:i).eq.dquot) then
      string = .not.string
    elseif  (.not.string) then
      if (line(i:i).eq.bquot) then
        if (istart.ne.0) then
          iend = i
          lenlog = iend-istart+1
          ! This line does not recursively translate logical names
          ier = sic_getlog(line(istart+1:iend-1),lognam)
          if (ier.eq.0) then
            ! These 2 lines will do the recursive translation
            inpnam = line(istart+1:iend-1)
            call sic_parse_file(inpnam,"","",lognam)
            !
            lentrans = len_trim(lognam)
            call replace_symlog(line,lenlog,lognam,lentrans,istart,nline,error)
            i = istart
            istart = 0
          endif
        else
          istart = i
        endif
      endif
    endif
    i = i+1
  enddo
end subroutine replace_logical
!
subroutine replace_symlog(line,lsymb,trans,ltrans,pos,nline,error)
  use gbl_message
  use sic_interfaces, except_this=>replace_symlog
  !---------------------------------------------------------------------
  ! @ private
  ! Replace a Symbol or Logical name by its translation.
  ! Note that the surrounding quotes (for Symbols) or backquotes (for
  ! logical names) are striped off.
  !---------------------------------------------------------------------
  character(len=*), intent(inout) :: line    ! Command line
  integer(kind=4),  intent(in)    :: lsymb   ! Length of symbol
  character(len=*), intent(in)    :: trans   ! Translation
  integer(kind=4),  intent(in)    :: ltrans  ! Length of translation
  integer(kind=4),  intent(inout) :: pos     ! Curent position in line
  integer(kind=4),  intent(inout) :: nline   ! Length of line
  logical,          intent(inout) :: error   !
  ! Local
  integer(kind=4) :: i
  !
  if (nline+ltrans-lsymb .ge. len(line)) then
    call sic_message(seve%e,'SYMLOG','String too long, translation failed')
    error=.true.
    return
  endif
  !
  if (ltrans.lt.lsymb) then
    ! Shift the trailing characters to the left
    do i=pos+lsymb,nline
      line(i+ltrans-lsymb:i+ltrans-lsymb) = line(i:i)
    enddo
    line(nline+ltrans-lsymb+1:nline) = ' '
  elseif (ltrans.gt.lsymb) then
    ! Shift the trailing characters to the right
    do i=nline,pos+lsymb,-1
      line(i+ltrans-lsymb:i+ltrans-lsymb) = line(i:i)
    enddo
  endif
  ! Then replace symbol in-place
  line(pos:pos+ltrans-1) = trans(1:ltrans)
  nline = nline+ltrans-lsymb
  ! Move the cursor at the end of the translation. We could also move
  ! the cursor at the start of the translation to enable recursion,
  ! with proper adaptation of the callers.
  pos = pos+ltrans-1
  !
end subroutine replace_symlog

module gio_interfaces_public
  interface
    subroutine gio_message_set_id(id)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      ! Alter library id into input id. Should be called by the library
      ! which wants to share its id with the current one.
      !---------------------------------------------------------------------
      integer, intent(in) :: id
    end subroutine gio_message_set_id
  end interface
  !
  interface
    subroutine gdf_setuv(h,error)
      use image_def
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      ! Define the UV section consistently.
      ! It could also define the column_types and column_codes if needed
      !---------------------------------------------------------------------
      type(gildas), intent(inout) :: h
      logical,      intent(inout) :: error
    end subroutine gdf_setuv
  end interface
  !
  interface
    subroutine gdf_uv_shift_columns(huvin,huvou)
      use image_def
      !---------------------------------------------------------------------
      ! @ public
      !   Shift the trailing columns when copying and modifying
      !   a UV table (channel extraction, Stokes reduction, etc...)
      !---------------------------------------------------------------------
      type(gildas), intent(in) :: huvin
      type(gildas), intent(inout) :: huvou
    end subroutine gdf_uv_shift_columns
  end interface
  !
  interface
    subroutine gdf_index_to_where(inone,ndim,dims,iwhere)
      use gildas_def
      !---------------------------------------------------------------------
      ! @ public
      ! GDF Convert a (rank-1) position in a pixel number for arbitrary dimensions
      ! Will need an INTERFACE from outside
      !---------------------------------------------------------------------
      integer(kind=8), intent(in)  :: inone         ! Relative position in rank-1 array
      integer(kind=4), intent(in)  :: ndim          ! Number of dimensions
      integer(kind=index_length), intent(in)  :: dims(ndim)    ! Number of dimensions
      integer(kind=index_length), intent(out) :: iwhere(ndim)  ! Pixel position
    end subroutine gdf_index_to_where
  end interface
  !
  interface
    subroutine gdf_where_to_index(inone,ndim,dims,iwhere)
      use gildas_def
      !---------------------------------------------------------------------
      ! @ public
      ! GDF Convert a pixel number in a (rank-1) position for arbitrary dimensions
      ! Will need an INTERFACE from outside
      !---------------------------------------------------------------------
      integer(kind=8), intent(out) :: inone         ! Relative position in rank-1 array
      integer(kind=4), intent(in)  :: ndim          ! Number of dimensions
      integer(kind=index_length), intent(in)  :: dims(ndim)    ! Number of dimensions
      integer(kind=index_length), intent(in)  :: iwhere(ndim)  ! Pixel position
    end subroutine gdf_where_to_index
  end interface
  !
  interface
    subroutine gdf_dims(is,ndim,dims)
      use gildas_def
      use gio_image
      !---------------------------------------------------------------------
      ! @ public
      ! GDF  API routine
      !             Return image dimensions (for SIC, in fact)
      ! The output dimensions are kind=index_length
      !---------------------------------------------------------------------
      integer(kind=4), intent(in) :: is                  ! Image slot
      integer(kind=4), intent(out) :: ndim               ! Number of dimensions
      integer(kind=index_length), intent(out) :: dims(:) ! Dimensions
    end subroutine gdf_dims
  end interface
  !
  interface
    function gdf_check_nvisi(is,mess)
      use gio_image
      !---------------------------------------------------------------------
      ! @ public
      ! Return value:
      !  = 0 if visibility axis exists and Nvisi is equal to this axis, or
      !      if visibility axis does not exist
      !  < 0 if visibility axis exists and Nvisi is valid (lower than this
      !      axis: 0<=Nvisi<axis. Note 0 is still valid).
      !  > 0 if visibility axis exists but Nvisi is invalid (greater than
      !      this axis, or negative)
      ! A message is also set describing this status. The caller can use it
      ! or ignore it.
      !---------------------------------------------------------------------
      integer(kind=4) :: gdf_check_nvisi
      integer(kind=4),  intent(in)  :: is    ! Image slot
      character(len=*), intent(out) :: mess  ! Message in return
    end function gdf_check_nvisi
  end interface
  !
  interface
    subroutine gdf_getcod (csyst)
      !---------------------------------------------------------------------
      ! @ public
      !   Return the "System" code in a comprehensible string. 
      !---------------------------------------------------------------------
      character(len=4), intent(out) :: csyst  ! Code
    end subroutine gdf_getcod
  end interface
  !
  interface
    subroutine gdf_convcod (cfile,csyst,conver)
      use gio_convert
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      !   Determine the conversion code to be applied
      !   between cfile (the data file) and csyst (the current OS code)
      !   Return 0 if no conversion
      !---------------------------------------------------------------------
      character(len=4), intent(in) :: cfile         ! File Gildas system code
      character(len=4), intent(in) :: csyst         ! Operating system Gildas code
      integer, intent(out) :: conver                ! Conversion code
    end subroutine gdf_convcod
  end interface
  !
  interface
    subroutine gdf_conversion(code,conver)
      use gio_convert
      !---------------------------------------------------------------------
      ! @ public
      !   Translate a Gildas conversion code into a human readable string. 
      !---------------------------------------------------------------------
      integer, intent(in) :: code                   ! Conversion code
      character(len=*), intent(out) :: conver       ! Name of conversion
    end subroutine gdf_conversion
  end interface
  !
  interface
    subroutine gio_cris (is,gtype,name,form,size,error)
      use gio_image
      use gbl_message
      use gbl_format
      !---------------------------------------------------------------------
      ! @ public
      ! GDF CReate Image Slot  - Used by SIC only
      !---------------------------------------------------------------------
      integer(4), intent(in)  :: is                  ! Image slot
      character(len=*), intent(in)  :: gtype         ! Image type (GILDAS_vwxyz)
      character(len=*), intent(in)  :: name          ! File name
      integer(4), intent(in)  :: form                ! Data format
      integer(kind=size_length), intent(in)  :: size ! Data size
      logical, intent(out) :: error                  ! Error flag
    end subroutine gio_cris
  end interface
  !
  interface
    function gio_blocking(leng,startbl,new)
      use gildas_def
      use gbl_message
      use gio_params
      !------------------------------------------------------------------------
      ! @ public
      !
      !   Return best blocking factor for new file
      !------------------------------------------------------------------------
      integer(kind=4) :: gio_blocking  ! intent(out)   ! Blocking factor
      integer(kind=size_length), intent(inout) :: leng ! Number of 512 Byte blocks
      integer(kind=4) :: startbl                       ! Number of starting blocks
      logical(kind=4) :: new                           ! New or old file ?
    end function gio_blocking
  end interface
  !
  interface
    subroutine gio_crws (is,gtype,form,size,error)
      use gio_image
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      ! GDF CReate Work Slot
      !     This is a pure virtual memory slot
      !     Used by SIC only
      !---------------------------------------------------------------------
      integer(kind=4),           intent(in)  :: is     ! Image slot
      character(len=*),          intent(in)  :: gtype  ! Image type (GILDAS_vwxyz)
      integer(kind=4),           intent(in)  :: form   ! Data format
      integer(kind=size_length), intent(in)  :: size   ! Data size
      logical,                   intent(out) :: error  ! Error flag
    end subroutine gio_crws
  end interface
  !
  interface
    subroutine gio_exis (is,gtype,name,form,size,error)
      use gbl_format
      use gbl_message
      use gio_convert
      use gio_image
      !---------------------------------------------------------------------
      ! @ public
      ! GDF EXtend Image Slot
      !     Extend a Greg Data Frame, and return size and address to caller
      !     Used by SIC only
      !---------------------------------------------------------------------
      integer(kind=4),           intent(in)    :: is     ! Image slot
      character(len=*),          intent(out)   :: gtype  ! Image type (GILDAS_vwxyz)
      character(len=*),          intent(in)    :: name   ! File name
      integer(kind=4),           intent(out)   :: form   ! Data format
      integer(kind=size_length), intent(inout) :: size   ! Data size
      logical,                   intent(out)   :: error  ! Error flag
    end subroutine gio_exis
  end interface
  !
  interface
    subroutine gdf_extend_image (x,newdim,error)
      use image_def
      use gbl_format
      !---------------------------------------------------------------------
      ! @ public
      ! GDF API routine
      !     Extend an existing image by increasing its LAST dimension
      !---------------------------------------------------------------------
      type(gildas),               intent(inout) :: x       ! Gildas Image
      integer(kind=index_length)                :: newdim  ! New value of last dimension
      logical,                    intent(inout) :: error   ! Logical error flag
    end subroutine gdf_extend_image
  end interface
  !
  interface
    subroutine gdf_stbl(stbl,error)
      use gio_image
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      ! GDF set STarting BLOcks default
      !     temporary routine to change the number of header blocks
      !---------------------------------------------------------------------
      integer, intent(in)  :: stbl      ! Number of starting blocks
      logical, intent(out) :: error     ! Error flag
    end subroutine gdf_stbl
  end interface
  !
  interface
    function gdf_stbl_get()
      use gio_image
      !---------------------------------------------------------------------
      ! @ public
      ! Return the STarting BLOcks default
      !     temporary routine to change the number of header blocks
      !---------------------------------------------------------------------
      integer(kind=4) :: gdf_stbl_get
    end function gdf_stbl_get
  end interface
  !
  interface
    subroutine gio_geis (is,error)
      use gio_image
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      ! GDF GEt Image Slot
      !     Only used by SIC
      !---------------------------------------------------------------------
      integer, intent(out) :: is        ! Image slot
      logical, intent(out) :: error     ! Error flag
    end subroutine gio_geis
  end interface
  !
  interface
    subroutine gio_fris (is,error)
      use gio_image
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      ! GDF FRee Image Slot
      !   Only used by SIC
      !
      ! In case of success, error flag (T/F) is preserved on return. Code is
      ! insensitive to error=T on input.
      !---------------------------------------------------------------------
      integer, intent(in)    :: is     ! Image slot
      logical, intent(inout) :: error  ! Error flag
    end subroutine gio_fris
  end interface
  !
  interface
    subroutine gio_clis (is,error)
      use gio_image
      use gbl_message
      !----------------------------------------------------------------------
      ! @ public
      ! GDF CLose Image Slot
      !   Only used by SIC
      !
      ! In case of success, error flag (T/F) is preserved on return. Code is
      ! insensitive to error=T on input.
      !----------------------------------------------------------------------
      integer, intent(in)    :: is     ! Image slot
      logical, intent(inout) :: error  ! Error flag
    end subroutine gio_clis
  end interface
  !
  interface
    function gdf_stis (is)
      use gio_image
      !---------------------------------------------------------------------
      ! @ public
      ! GDF STatus of Image Slot
      !             return slot status (-1 if not available)
      !---------------------------------------------------------------------
      integer :: gdf_stis               ! intent(out)
      integer, intent(in) :: is         ! Image slot
    end function gdf_stis
  end interface
  !
  interface
    function gio_chis (is,rdonly)
      use gio_image
      !---------------------------------------------------------------------
      ! @ public
      ! Change READ Status to allow or avoid rewriting buffers...
      !     Only used by SIC
      !---------------------------------------------------------------------
      integer :: gio_chis               ! intent(out)
      integer, intent(in) :: is         ! Image slot
      logical, intent(in) :: rdonly     ! ReadOnly Status
    end function gio_chis
  end interface
  !
  interface
    subroutine gio_lsis (chain,error)
      use gildas_def
      use gio_image
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      ! GDF LiSt Image Slot
      !             A debugging routine only used by SIC
      ! It will prompt for user input if CHAIN is not empty.
      !---------------------------------------------------------------------
      character(len=*), intent(in) :: chain
      logical, intent(out) :: error     ! Error flag
    end subroutine gio_lsis
  end interface
  !
  interface
    subroutine gio_gems (ms, is, blc, trc, addr, form, error)
      use gildas_def
      use gio_image
      use gbl_message
      use gbl_format
      !---------------------------------------------------------------------
      ! @ public
      ! GIO
      !     GEt Memory Slot
      !     Generalized version to also obtain non-contiguous subsets
      !---------------------------------------------------------------------
      integer, intent(out) :: ms                         ! Memory slot
      integer, intent(in)  :: is                         ! Image slot
      integer(kind=index_length), intent(in)  :: blc(:)  ! Bottom left corner
      integer(kind=index_length), intent(in)  :: trc(:)  ! Top right corner
      integer(kind=address_length), intent(out) :: addr  ! Returned address
      integer, intent(in)  :: form                       ! Image format
      logical, intent(out) :: error                      ! Flag
    end subroutine gio_gems
  end interface
  !
  interface
    subroutine gio_frms (ms,error)
      use gio_image
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      ! GDF   FRee Memory Slot
      !
      ! In case of success, error flag (T/F) is preserved on return. Code is
      ! insensitive to error=T on input.
      !---------------------------------------------------------------------
      integer, intent(in)    :: ms     ! Memory slot
      logical, intent(inout) :: error  ! error flag
    end subroutine gio_frms
  end interface
  !
  interface
    subroutine gildas_open
      use gio_headers
      !---------------------------------------------------------------------
      ! @ public
      ! GILDAS
      !       I/O routines for GILDAS tasks.
      !---------------------------------------------------------------------
      ! Local
    end subroutine gildas_open
  end interface
  !
  interface
    subroutine gildas_char (name,chain)
      use gildas_def
      !---------------------------------------------------------------------
      ! @ public
      !---------------------------------------------------------------------
      character(len=*), intent(in)  :: name
      character(len=*), intent(out) :: chain
    end subroutine gildas_char
  end interface
  !
  interface
    subroutine gildas_charn (name,string,n)
      use gildas_def
      !---------------------------------------------------------------------
      ! @ public
      !---------------------------------------------------------------------
      character(len=*), intent(in)  :: name
      integer(kind=4),  intent(in)  :: n
      character(len=*), intent(out) :: string(n)
    end subroutine gildas_charn
  end interface
  !
  interface
    subroutine gildas_close
      !---------------------------------------------------------------------
      ! @ public
      !---------------------------------------------------------------------
    end subroutine gildas_close
  end interface
  !
  interface gildas_dble
    subroutine gildas_dble_0d (name,adble,n)
      use gildas_def
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public-generic gildas_dble
      ! ---
      ! This version for scalar argument
      !---------------------------------------------------------------------
      character(len=*), intent(in)  :: name
      integer(kind=4),  intent(in)  :: n
      real(kind=8),     intent(out) :: adble
    end subroutine gildas_dble_0d
    subroutine gildas_dble_1d (name,adble,n)
      use gildas_def
      !---------------------------------------------------------------------
      ! @ public-generic gildas_dble
      ! ---
      ! This version for 1D array as argument
      !---------------------------------------------------------------------
      character(len=*), intent(in)  :: name
      integer(kind=4),  intent(in)  :: n
      real(kind=8),     intent(out) :: adble(n)
    end subroutine gildas_dble_1d
  end interface gildas_dble
  !
  interface gildas_inte
    subroutine gildas_inte4_0d(name,ainte,n)
      use gildas_def
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public-generic gildas_inte
      ! ---
      ! This version for scalar I*4 argument
      !---------------------------------------------------------------------
      character(len=*), intent(in)  :: name
      integer(kind=4),  intent(in)  :: n
      integer(kind=4),  intent(out) :: ainte
    end subroutine gildas_inte4_0d
    subroutine gildas_inte4_1d(name,ainte,n)
      use gildas_def
      !---------------------------------------------------------------------
      ! @ public-generic gildas_inte
      ! ---
      ! This version for a 1D I*4 variable
      !---------------------------------------------------------------------
      character(len=*), intent(in)  :: name
      integer(kind=4),  intent(in)  :: n
      integer(kind=4),  intent(out) :: ainte(n)
    end subroutine gildas_inte4_1d
    subroutine gildas_inte8_1d(name,along,n)
      use gildas_def
      !---------------------------------------------------------------------
      ! @ public-generic gildas_inte
      ! ---
      ! This version for a 1D I*8 variable
      !---------------------------------------------------------------------
      character(len=*), intent(in)  :: name
      integer(kind=4),  intent(in)  :: n
      integer(kind=8),  intent(out) :: along(n)
    end subroutine gildas_inte8_1d
  end interface gildas_inte
  !
  interface gildas_logi
    subroutine gildas_logi_0d (name,alogi,n)
      use gildas_def
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public-generic gildas_logi
      ! ---
      ! This version for scalar argument
      !---------------------------------------------------------------------
      character(len=*), intent(in)  :: name
      integer(kind=4),  intent(in)  :: n
      logical,          intent(out) :: alogi
    end subroutine gildas_logi_0d
    subroutine gildas_logi_1d (name,alogi,n)
      use gildas_def
      !---------------------------------------------------------------------
      ! @ public-generic gildas_logi
      ! ---
      ! This version for 1D array as argument
      !---------------------------------------------------------------------
      character(len=*), intent(in)  :: name
      integer(kind=4),  intent(in)  :: n
      logical,          intent(out) :: alogi(n)
    end subroutine gildas_logi_1d
  end interface gildas_logi
  !
  interface gildas_real
    subroutine gildas_real_0d (name,areal,n)
      use gildas_def
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public-generic gildas_real
      ! ---
      ! This version for scalar argument
      !---------------------------------------------------------------------
      character(len=*), intent(in)  :: name
      integer(kind=4),  intent(in)  :: n
      real(kind=4),     intent(out) :: areal
    end subroutine gildas_real_0d
    subroutine gildas_real_1d (name,areal,n)
      use gildas_def
      !---------------------------------------------------------------------
      ! @ public-generic gildas_real
      ! ---
      ! This version for 1D array as argument
      !---------------------------------------------------------------------
      character(len=*), intent(in)  :: name
      integer(kind=4),  intent(in)  :: n
      real(kind=4),     intent(out) :: areal(n)
    end subroutine gildas_real_1d
  end interface gildas_real
  !
  interface
    subroutine gio_reis (is,gtype,name,form,size,error)
      use gildas_def
      !---------------------------------------------------------------------
      ! @ public
      ! GDF   REad Image Slot
      !   Only used by SIC
      !---------------------------------------------------------------------
      integer(kind=4),           intent(in)    :: is     ! Image SLot
      character(len=*),          intent(out)   :: gtype  ! Image type
      character(len=*),          intent(in)    :: name   ! File name
      integer(kind=4),           intent(out)   :: form   ! Data type
      integer(kind=size_length), intent(out)   :: size   ! Data size
      logical,                   intent(inout) :: error  ! Error flag
    end subroutine gio_reis
  end interface
  !
  interface
    subroutine gio_wris (is,gtype,name,form,size,error)
      use gildas_def
      !----------------------------------------------------------------------
      ! @ public
      ! GDF   WRite Image Slot
      !   Only used by SIC
      !----------------------------------------------------------------------
      integer(kind=4),           intent(in)    :: is     ! Image SLot
      character(len=*),          intent(out)   :: gtype  ! Image type
      character(len=*),          intent(in)    :: name   ! File name
      integer(kind=4),           intent(out)   :: form   ! Data type
      integer(kind=size_length), intent(out)   :: size   ! Data size
      logical,                   intent(inout) :: error  ! Error flag
    end subroutine gio_wris
  end interface
  !
  interface gag_file_guess
    subroutine gag_file_guess_fromname(caller,filename,filekind,error)
      use gbl_format
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public-generic gag_file_guess
      ! Guess if the input file is a GDF file (code 1), a FITS file (code
      ! 2), or something else (code 0)
      ! ---
      ! This version with the file name as argument, to be Fortran-opened-
      ! and-closed during the guess
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: caller
      character(len=*), intent(in)    :: filename
      integer(kind=4),  intent(out)   :: filekind
      logical,          intent(inout) :: error
    end subroutine gag_file_guess_fromname
    subroutine gag_file_guess_fromlun(caller,lun,filekind,error)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public-generic gag_file_guess
      ! Guess if the input file is a GDF file (code 1), a FITS file (code
      ! 2), or something else (code 0)
      ! ---
      ! This version with the file name already opened in input logical unit
      ! (must be opened as OLD, DIRECT, UNFORMATTED).
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: caller
      integer(kind=4),  intent(in)    :: lun
      integer(kind=4),  intent(out)   :: filekind
      logical,          intent(inout) :: error
    end subroutine gag_file_guess_fromlun
  end interface gag_file_guess
  !
  interface
    subroutine gdf_geih(is,p,error)
      use gbl_message
      use gio_image
      !---------------------------------------------------------------------
      ! @ public
      ! GDF   GEt a pointer to Image Header
      !       Return the image header for further use
      !---------------------------------------------------------------------
      integer(kind=4), intent(in)    :: is     ! Image Slot
      type(gildas),    pointer       :: p      ! Pointer to header
      logical,         intent(inout) :: error  ! Error flag
    end subroutine gdf_geih
  end interface
  !
  interface
    subroutine gdf_flih (is,check,error)
      use gio_image
      use gbl_message
      use gbl_format
      !---------------------------------------------------------------------
      ! @ public
      ! GDF   FLush Image Header
      !       FLush an image header
      !---------------------------------------------------------------------
      integer, intent(in) :: is                        ! Image Slot
      logical, intent(in) :: check                     ! Check if slot is writeable
      logical, intent(out) :: error                    ! Error flag
    end subroutine gdf_flih
  end interface
  !
  interface
    function gdf_uv_frequency(huv, dchan)
      use image_def
      !-----------------------------------------------------------------------
      ! @ public
      !
      ! GIO Library
      !   Get observing frequency at given channel
      !-----------------------------------------------------------------------
      type(gildas), intent(in) :: huv   ! UV Header
      real(8), intent(in), optional :: dchan      ! Channel number (possibly fractional)
      real(8) :: gdf_uv_frequency       ! Intent(out)
    end function gdf_uv_frequency
  end interface
  !
  interface
    subroutine gdf_modify(h,velocity,frequency,unit,error)
      use image_def
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      !   Modify the reference frequency and reference velocity of an input
      ! GDF header, and optionaly the axis unit (FREQUENCY or VELOCITY)
      !---------------------------------------------------------------------
      type(gildas),     intent(inout), target :: h          ! Header to be shifted
      real(kind=4),     intent(in)            :: velocity   ! New velocity
      real(kind=8),     intent(in)            :: frequency  ! New frequency
      character(len=*), intent(in), optional  :: unit       ! New axis unit
      logical,          intent(out)           :: error      ! Error flag
    end subroutine gdf_modify
  end interface
  !
  interface
    subroutine gdf_uv_doppler(huv,version_uv)
      use image_def
      use gbl_message
      use gio_uv
      !------------------------------------------------------------------
      ! @ public
      !   GIO
      !     Convert a UV table Frequency information to the appropriate
      !     shape. The Frequency information model of the data is
      !     in huv%gil%version_uv, and it is converted towards model
      !     described by version_uv, which can be
      !   code_version_uvt_freq
      !     Observing frequency is in the first axis - This is the
      !     historical behaviour.
      !   code_version_uvt_dopp
      !     Observing frequency is derived from a mean Doppler correction
      !     and the rest frequency in the Spectroscopy section.
      !   code_version_uvt_syst
      !     Observing frequency is derived from a time-dependent Doppler
      !     correction stored in the code_uvt_topo column,
      !     and the rest frequency in the Spectroscopy section
      !     It falls back to the code_version_uvt_dopp behaviour if
      !     no such column is found.
      !------------------------------------------------------------------
      type(gildas), intent(inout) :: huv
      integer, intent(in) :: version_uv
    end subroutine gdf_uv_doppler
  end interface
  !
  interface
    subroutine gdf_set_uvt_version(name)
      use image_def
      use gio_uv
      use gbl_message
      !----------------------------------------------------
      ! @ public
      !   Select GDF data format version beyond 2.0
      !----------------------------------------------------
      character(len=*), intent(in) :: name
    end subroutine gdf_set_uvt_version
  end interface
  !
  interface
    subroutine gdf_get_uvt_version(code)
      use gio_uv
      !----------------------------------------------------
      ! @ public
      !   Get UVT data format version beyond 2.0
      !----------------------------------------------------
      integer(kind=4), intent(out) :: code
    end subroutine gdf_get_uvt_version
  end interface
  !
  interface
    subroutine gdf_gauss2d_convolution(h,a2,b2,t2,error)
      use image_def
      use phys_const
      !---------------------------------------------------------------------
      ! @ public
      !   Convolve the resolution section of the input header by a 2D
      ! gaussian. Results are saved in the header itself.
      !   All input and output angles use GDF convention i.e. from North to
      ! East. The convolution position angle should be defined in the same
      ! frame as the input header is defined.
      !---------------------------------------------------------------------
      type(gildaS), intent(inout) :: h      !
      real(kind=4), intent(in)    :: a2     ! [same as h%gil%major] Convolution major axis
      real(kind=4), intent(in)    :: b2     ! [same as h%gil%major] Convolution minor axis
      real(kind=4), intent(in)    :: t2     ! [rad]                 Convolution position angle
      logical,      intent(inout) :: error  ! Logical error flag
    end subroutine gdf_gauss2d_convolution
  end interface
  !
  interface
    subroutine gdf_gauss2d_deconvolution(h,a3,b3,t3,a2,b2,t2,error)
      use image_def
      use phys_const
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      !   Compute the convolution kernel needed to reach the desired
      ! resolution starting from the input header resolution section.
      !   All input and output angles use GDF convention i.e. from North to
      ! East. The goal position angle should be defined in the same
      ! frame as the input header is defined.
      !---------------------------------------------------------------------
      type(gildaS), intent(in)    :: h      !
      real(kind=4), intent(in)    :: a3     ! [same as h%gil%major] Goal major axis
      real(kind=4), intent(in)    :: b3     ! [same as h%gil%major] Goal minor axis
      real(kind=4), intent(in)    :: t3     ! [rad]                 Goal position angle
      real(kind=4), intent(out)   :: a2     ! [same as h%gil%major] Convolution major axis
      real(kind=4), intent(out)   :: b2     ! [same as h%gil%major] Convolution minor axis
      real(kind=4), intent(out)   :: t2     ! [rad]                 Convolution position angle
      logical,      intent(inout) :: error  ! Logical error flag
    end subroutine gdf_gauss2d_deconvolution
  end interface
  !
  interface
    subroutine gdf_read_uvonly(huv,uv,error)
      use image_def
      use gio_image
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      ! GDF API
      !       Read the UV data of a GILDAS UV structure
      !       UVT and TUV order are allowed...
      !---------------------------------------------------------------------
      type (gildas), intent(inout) :: huv               ! UV table descriptor
      real(kind=4), intent(out) :: uv(huv%gil%nvisi,2)  ! Return U,V coordinates
      logical, intent(out) :: error                     ! Flag
    end subroutine gdf_read_uvonly
  end interface
  !
  interface
    subroutine gdf_read_uvonly_codes(huv,uv,codes,ncode,error)
      use image_def
      use gio_image
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      ! GDF API
      !       Read the Time-Baseline data of a GILDAS UV structure
      !       UVT and TUV order are allowed...
      !---------------------------------------------------------------------
      type (gildas), intent(inout) :: huv               ! UV table descriptor
      integer(4), intent(in) :: ncode                   ! Number of codes
      integer(4), intent(in) :: codes(ncode)            ! Desired codes
      real(kind=4), intent(out) :: uv(ncode,huv%gil%nvisi)  ! Return Values
      logical, intent(out) :: error                     ! Flag
    end subroutine gdf_read_uvonly_codes
  end interface
  !
  interface
    subroutine gdf_read_uvdataset(huvin,huvou,nc,duvou,error)
      use image_def
      use gio_image
      use gbl_message
      use gbl_format
      !---------------------------------------------------------------------
      ! @ public
      !       Read UV data and Associated parameters from a GILDAS UV
      !       structure and place it in the specified array
      !---------------------------------------------------------------------
      type(gildas), intent(inout) :: huvin     ! Input UV header (data file)
      type(gildas), intent(inout) :: huvou     ! Output UV header (program used)
      integer(kind=4), intent(in) :: nc(2)     ! Selected channels
      real(kind=4), intent(inout) :: duvou(huvou%gil%dim(1),huvou%gil%dim(2))  ! Data
      logical,      intent(out)   :: error     ! Flag
    end subroutine gdf_read_uvdataset
  end interface
  !
  interface
    subroutine gdf_compare_shape(first,second,equal)
      use image_def
      !---------------------------------------------------------------------
      ! @ public
      ! GDF API
      !       Compare shapes of two GILDAS images
      !---------------------------------------------------------------------
      type (gildas), intent(in) :: first       ! First GILDAS data set
      type (gildas), intent(in) :: second      ! Second GILDAS data set
      logical, intent(out) :: equal         ! are they equal ?
    end subroutine gdf_compare_shape
  end interface
  !
  interface
    subroutine gdf_read_gdforfits_header(name,isfits,hgdf,hfits,error)
      use gbl_message
      use image_def
      use gfits_types
      !------------------------------------------------------------------
      ! @ public
      ! Read the named file and store its header under GDF format
      ! in 'hgdf' structure. The input file can be either a standard GDF
      ! or a supported FITS.
      ! In return, the internal buffers are set to be ready to read data.
      !------------------------------------------------------------------
      character(len=*),    intent(in)    :: name    ! File name
      logical,             intent(out)   :: isfits  ! Found a GDF or a FITS?
      type(gildas),        intent(inout) :: hgdf    ! GDF image structure
      type(gfits_hdesc_t), intent(inout) :: hfits   ! FITS internal description, if relevant
      logical,             intent(inout) :: error   ! Error flag
    end subroutine gdf_read_gdforfits_header
  end interface
  !
  interface
    subroutine gdf_read_header(imag,error,rank)
      use image_def
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      ! GDF API
      !       Read an image header from the requested file
      !---------------------------------------------------------------------
      type(gildas), intent(inout) :: imag   ! Image structure
      logical,      intent(out)   :: error  ! Error flag
      integer,      intent(in), optional :: rank  ! Desired rank
    end subroutine gdf_read_header
  end interface
  !
  interface
    subroutine gdf_trim_header(imag,rank,error)
      use image_def
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      ! GDF API
      !       Read an image header from the requested file
      !---------------------------------------------------------------------
      type(gildas), intent(inout) :: imag    ! Image structure
      integer(4),   intent(in)    :: rank    ! Requested Rank
      logical,      intent(out)   :: error   ! Error flag
    end subroutine gdf_trim_header
  end interface
  !
  interface
    subroutine sub_trim_header(caller,imag,therank,error)
      use image_def
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      ! GDF API
      !       Read an image header from the requested file
      !---------------------------------------------------------------------
      character(len=*), intent(in) :: caller  ! Name of caller
      type(gildas), intent(inout)  :: imag    ! Image structure
      integer(4),   intent(in)     :: therank ! Requested Rank
      logical,      intent(inout)  :: error   ! Error flag
    end subroutine sub_trim_header
  end interface
  !
  interface
    subroutine gdf_update_header(imag,error)
      use image_def
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      ! GDF API routine
      !     Update an image header
      !---------------------------------------------------------------------
      type (gildas), intent(inout) :: imag      ! Image structure
      logical, intent(out) :: error             ! Flag
    end subroutine gdf_update_header
  end interface
  !
  interface
    subroutine gdf_copy_header(input,output, error)
      use image_def
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      ! Copy (a part of) the input header into the output header.
      ! Since the arguments are the full gildas type, 'output' must be
      ! inout to avoid resetting the data part of the type. This implies that
      ! the other header components must also have been set/initialized
      ! before.
      !---------------------------------------------------------------------
      type(gildas), intent(in)    :: input   ! Input header
      type(gildas), intent(inout) :: output  ! Output header
      logical,      intent(inout) :: error   !
    end subroutine gdf_copy_header
  end interface
  !
  interface
    subroutine gdf_transpose_header(input,output,order,error,drop)
      use image_def
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      !       Transpose a header information
      !---------------------------------------------------------------------
      type (gildas),     intent(in)    :: input   ! Initial Header
      type (gildas),     intent(inout) :: output  ! Transposed Header
      character(len=*),  intent(in)    :: order   ! Transposition code
      logical,           intent(inout) :: error   ! Flag
      logical, optional, intent(in)    :: drop    ! Drop trailing dimensions?
    end subroutine gdf_transpose_header
  end interface
  !
  interface
    function gildas_error(header,name,error)
      use image_def
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      ! GDF API routine
      !     Translate any possible error code, and return an error if needed
      !---------------------------------------------------------------------
      logical gildas_error                  ! intent(out)
      type (gildas), intent(in) :: header   ! Image header
      character(len=*), intent(in) :: name  ! Calling facility name
      logical, intent(out) :: error         ! Error flag
    end function gildas_error
  end interface
  !
  interface
    subroutine gio_read_header(imag,islo,error)
      use image_def
      use gio_image
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      ! GDF / GIO Internal routine
      !       Read an image header on a specified image slot
      !           The slot must have been opened before
      !---------------------------------------------------------------------
      type(gildas),    intent(inout) :: imag   !
      logical,         intent(inout) :: error  !
      integer(kind=4), intent(in)    :: islo   !
    end subroutine gio_read_header
  end interface
  !
  interface
    subroutine gio_write_header(imag,islo,error)
      use image_def
      use gio_image
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      ! GDF / GIO Internal routine
      !       Update an image header on a specified image slot
      !           The slot must have been opened before
      !---------------------------------------------------------------------
      type (gildas), intent(in) :: imag  !
      logical, intent(out) :: error      !
      integer(kind=4), intent(in) :: islo
    end subroutine gio_write_header
  end interface
  !
  interface
    subroutine gdf_get_extrema (mine,error)
      use gbl_format
      use image_def
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      ! GDF API
      !   Compute the extrema from a Virtual Memory image (one with the
      !   appropriate address field). Note that the address field
      !   can have been set independently of the %getvm status
      !---------------------------------------------------------------------
      type (gildas), intent(inout) :: mine   !
      logical,       intent(out)   :: error  !
    end subroutine gdf_get_extrema
  end interface
  !
  interface
    subroutine gdf_get_baselines (mine,error)
      use image_def
      use gbl_message
      use gbl_format
      !---------------------------------------------------------------------
      ! @ public
      ! GDF API
      !   Compute the baseline range from a Virtual Memory UV data (one with the
      !   appropriate address field). Note that the address field
      !   can have been set independently of the %getvm status
      !---------------------------------------------------------------------
      type (gildas), intent(inout) :: mine   !
      logical,       intent(out)   :: error  !
    end subroutine gdf_get_baselines
  end interface
  !
  interface
    subroutine gildas_null(hx, type)
      use image_def
      use gio_uv
      !---------------------------------------------------------------------
      ! @ public
      ! GDF API
      !   Initialize a Gildas structure and reset its content
      !---------------------------------------------------------------------
      type(gildas), intent(out), target :: hx ! Gildas structure
      character(len=*), intent(in), optional :: type
    end subroutine gildas_null
  end interface
  !
  interface
    subroutine gdf_copy_gil(input,output,error)
      use image_def
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      ! Copy the %gil%  part of the input header into the output header.
      !   Only used by SIC outside of GIO...
      !---------------------------------------------------------------------
      type (gildas), intent(in) :: input   ! Input header
      type (gildas), intent(inout) :: output  ! Output header
      logical, intent(out) :: error
    end subroutine gdf_copy_gil
  end interface
  !
  interface
    subroutine gdf_update_image(imag,array,error)
      use gildas_def
      use image_def
      use gbl_message
      use gio_params
      !---------------------------------------------------------------------
      ! @ public
      ! GDF API Routine
      !     Save an image structure and the specified data on the image file
      !     This version is for updating an existing file
      !---------------------------------------------------------------------
      type(gildas), intent(inout) :: imag      ! Image descriptor
      real,         intent(in)    :: array(*)  ! Data to be written
      logical,      intent(inout) :: error     ! Flag
    end subroutine gdf_update_image
  end interface
  !
  interface
    subroutine gdf_write_image(imag,array,error)
      use gildas_def
      use image_def
      use gbl_message
      use gio_params
      !---------------------------------------------------------------------
      ! @ public 
      ! GDF API routine
      !     Save an image structure and the specified data on the image file
      !     This version is to create a new file
      !---------------------------------------------------------------------
      type(gildas), intent(inout) :: imag      ! Image descriptor
      real,         intent(in)    :: array(*)  ! Data array
      logical,      intent(inout) :: error     ! Flag
    end subroutine gdf_write_image
  end interface
  !
  interface
    subroutine gdf_open_image(imag,error)
      use image_def
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      ! GDF API
      !     Open an image structure on the requested file for writing
      !---------------------------------------------------------------------
      type(gildas), intent(inout) :: imag   ! Image descriptor
      logical,      intent(inout) :: error  ! Flag
    end subroutine gdf_open_image
  end interface
  !
  interface
    subroutine gdf_create_image(imag,error)
      use gio_params
      use image_def
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      ! GDF API Routine
      !     Create an image structure on the requested file
      !     Nothing is written yet to the file.
      !---------------------------------------------------------------------
      type(gildas), intent(inout) :: imag   ! Image descriptor
      logical,      intent(inout) :: error  ! Flag
    end subroutine gdf_create_image
  end interface
  !
  interface
    subroutine gdf_close_image(imag,error)
      use image_def
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      ! Close an image structure. No further READ allowed on this image
      !
      ! In case of success, error flag (T/F) is preserved on return. Code is
      ! insensitive to error=T on input.
      !---------------------------------------------------------------------
      type(gildas), intent(inout) :: imag   ! Image descriptor
      logical,      intent(inout) :: error  ! Flag
    end subroutine gdf_close_image
  end interface
  !
  interface
    subroutine gdf_allocate (hx,error)
      use image_def
      use gbl_message
      !-----------------------------------------------------------------
      ! @ public
      !   Allocate the appropriate work space
      !   for a Gildas data type.
      ! CAUTION
      !   blc, trc not yet tested ...
      !
      !-----------------------------------------------------------------
      type (gildas), intent(inout) :: hx    ! Gildas data type
      logical, intent(out) :: error         ! Error flag
    end subroutine gdf_allocate
  end interface
  !
  interface
    subroutine gdf_read_gildas(hx,name,ext,error, rank, data)
      use image_def
      use gbl_message
      !-----------------------------------------------------------------
      ! @ public
      ! Read a Gildas Data File of name "name" and extention "ext"
      ! and return it into the "hx" Gildas data type.
      !
      ! Desired Form & Rank can be specified: an error will happen
      ! in case of mismatch.
      !-----------------------------------------------------------------
      type(gildas),     intent(inout)        :: hx      ! Gildas data type
      character(len=*), intent(in)           :: name    ! Filename
      character(len=*), intent(in)           :: ext     ! Extension
      logical,          intent(inout)        :: error   ! Error flag
      integer,          intent(in), optional :: rank    !
      logical,          intent(in), optional :: data    !
    end subroutine gdf_read_gildas
  end interface
  !
  interface gdf_range
    function gdf_range_48(nc,nchan)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public-generic   gdf_range
      ! GDF API
      !       Return a range of (pixel / channel / items)
      !---------------------------------------------------------------------
      integer(4) :: gdf_range_48  ! Intent(out)  0 if no error
      integer(8), intent(in) :: nchan     ! The actual number of channels
      integer(4), intent(inout) :: nc(2)  ! The interpreted range of selected channels
    end function gdf_range_48
    function gdf_range_88(nc,nchan)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public-generic  gdf_range
      ! GDF API
      !       Return a range of (pixel / channel / items)
      !---------------------------------------------------------------------
      integer(4) :: gdf_range_88          ! Intent(out)
      integer(8), intent(in) :: nchan     ! The actual number of channels
      integer(8), intent(inout) :: nc(2)  ! The interpreted range of selected channels
    end function gdf_range_88
    function gdf_range_44(nc,nchan) ! result (res)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public-generic  gdf_range
      ! GDF API
      !       Return a range of (pixel / channel / items)
      !---------------------------------------------------------------------
      integer(4) :: gdf_range_44          ! Intent(out)  0 if no error
      integer(4), intent(in) :: nchan     ! The actual number of channels
      integer(4), intent(inout) :: nc(2)  ! The interpreted range of selected channels
    end function gdf_range_44
    function gdf_range_84(nc,nchan)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public-generic  gdf_range
      ! GDF API
      !       Return a range of (pixel / channel / items)
      !---------------------------------------------------------------------
      integer(4) :: gdf_range_84          ! Intent(out)  0 if no error
      integer(4), intent(in) :: nchan     ! The actual number of channels
      integer(8), intent(inout) :: nc(2)  ! The interpreted range of selected channels
    end function gdf_range_84
  end interface gdf_range
  !
  interface
    subroutine gdf_print_header(img)
      use image_def
      use gbl_ansicodes
      !---------------------------------------------------------------------
      ! @ public
      ! GIO Library
      !       Support routine for command HEADER
      !---------------------------------------------------------------------
      type(gildas), intent(in) :: img  ! Header to be printed
    end subroutine gdf_print_header
  end interface
  !
  interface
    subroutine gdf_setcolor_header(ic)
      !---------------------------------------------------------------------
      ! @ public
      ! GIO Library
      !       Support routine for command HEADER
      !---------------------------------------------------------------------
      integer, intent(in) :: ic
    end subroutine gdf_setcolor_header
  end interface
  !
  interface
    subroutine gdf_addteles(fits,key,name,value,error)
      use image_def
      use gbl_message
      !---------------------------------------------------------------
      ! @ public
      ! GDF
      !   Add a new telescope
      !---------------------------------------------------------------
      type(gildas),     intent(inout) :: fits      ! Output GILDAS structure
      character(len=*), intent(in)    :: key       ! Operation Key
      character(len=*), intent(in)    :: name      ! Telescope name
      real(kind=8),     intent(in)    :: value(3)  ! Input values
      logical,          intent(inout) :: error     !
    end subroutine gdf_addteles
  end interface
  !
  interface
    subroutine gdf_rmteles(fits,name,error)
      use image_def
      use gbl_message
      !---------------------------------------------------------------
      ! @ public
      !  Remove a telescope from section, identified by its name
      !---------------------------------------------------------------
      type(gildas),     intent(inout) :: fits      ! Output GILDAS structure
      character(len=*), intent(in)    :: name      ! Telescope name
      logical,          intent(inout) :: error     !
    end subroutine gdf_rmteles
  end interface
  !
  interface
    subroutine gdf_transpose (nameou,namein,code,space_gildas,error)
      use gsys_types
      use image_def
      use gbl_message
      use gio_params
      use gio_fitsdef
      !---------------------------------------------------------------------
      ! @ public
      ! GDF API routine
      !  Transpose a GILDAS image
      !  Disk version when needed
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: nameou        ! Output transposed file name
      character(len=*), intent(in)    :: namein        ! Input file name
      character(len=*), intent(inout) :: code          ! Transposition code
      integer(kind=4),  intent(in)    :: space_gildas  ! Useable memory size
      logical,          intent(inout) :: error         ! Error flag
    end subroutine gdf_transpose
  end interface
  !
  interface gdf_nitems
    subroutine gdf_nitems_4(logname,nitems,asize)
      !---------------------------------------------------------------------
      ! @ public-generic gdf_nitems
      !   Return the number of items of size ASIZE in a block size specified
      !   by LOGNAME (typically SPACE_GILDAS)
      !---------------------------------------------------------------------
      character(len=*), intent(in)  :: logname
      integer(kind=4),  intent(out) :: nitems
      integer(kind=4),  intent(in)  :: asize
    end subroutine gdf_nitems_4
    subroutine gdf_nitems_8(logname,nitems,asize)
      !---------------------------------------------------------------------
      ! @ public-generic gdf_nitems
      !   Return the number of items of size ASIZE in a block size specified
      !   by LOGNAME (typically SPACE_GILDAS)
      !---------------------------------------------------------------------
      character(len=*), intent(in)  :: logname
      integer(kind=4),  intent(out) :: nitems
      integer(kind=8),  intent(in)  :: asize
    end subroutine gdf_nitems_8
  end interface gdf_nitems
  !
  interface gdf_dump_array
    subroutine gdf_dump_array1(file,array)
      use image_def
      !
      ! @ public-generic gdf_dump_array 
      ! 
      character(len=*), intent(in) :: file
      real, intent(in) :: array(:)
    end subroutine gdf_dump_array1
    subroutine gdf_dump_array2(file,array)
      use image_def
      !
      ! @ public-generic gdf_dump_array 
      ! 
      character(len=*), intent(in) :: file
      real, intent(in) :: array(:,:)
    end subroutine gdf_dump_array2
    subroutine gdf_dump_array3(file,array)
      use image_def
      !
      ! @ public-generic gdf_dump_array 
      ! 
      character(len=*), intent(in) :: file
      real, intent(in) :: array(:,:,:)
    end subroutine gdf_dump_array3
    subroutine gdf_dump_array4(file,array)
      use image_def
      !
      ! @ public-generic gdf_dump_array 
      ! 
      character(len=*), intent(in) :: file
      real, intent(in) :: array(:,:,:,:)
    end subroutine gdf_dump_array4
  end interface gdf_dump_array
  !
  interface
    function gag_sizeof(form)
      use gbl_format
      !---------------------------------------------------------------------
      ! @ public
      ! Return data word length in Bytes
      ! This function is generic for GDF, SIC variables, etc as they share
      ! the same codes. Hence the prefix gag_
      !---------------------------------------------------------------------
      integer(kind=4) :: gag_sizeof     ! Function value on return
      integer(kind=4), intent(in) :: form ! Data format
    end function gag_sizeof
  end interface
  !
  interface
    function gdf_nelem(h)
      use image_def
      !---------------------------------------------------------------------
      ! @ public
      ! Return the number of elements from the input GDF header
      !---------------------------------------------------------------------
      integer(kind=size_length) :: gdf_nelem
      type(gildas), intent(in) :: h
    end function gdf_nelem
  end interface
  !
  interface
    function gdf_size(h)
      use image_def
      !---------------------------------------------------------------------
      ! @ public
      ! Return the whole data size in bytes
      !---------------------------------------------------------------------
      integer(kind=size_length) :: gdf_size
      type(gildas), intent(in) :: h
    end function gdf_size
  end interface
  !
  interface
    subroutine gdf_toobig(h,error)
      use image_def
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      ! Return an error if the image is too large to be opened on the
      ! current system
      !---------------------------------------------------------------------
      type(gildas), intent(in)    :: h
      logical,      intent(inout) :: error       !
    end subroutine gdf_toobig
  end interface
  !
  interface
    subroutine fitscube2gdf_header(file,ihdu,fd,ghead,getsymbol,error)
      use image_def
      use gbl_message
      use gfits_types
      !---------------------------------------------------------------------
      ! @ public
      ! Load the header of the extension currently opened in gfits and
      ! translate it as a GDF header. Suited for N-dimensional cubes only.
      !---------------------------------------------------------------------
      character(len=*),    intent(in)    :: file       ! FITS file name
      integer(kind=4),     intent(in)    :: ihdu       ! HDU we are reading (1=Primary)
      type(gfits_hdesc_t), intent(inout) :: fd         !
      type(gildas),        intent(inout) :: ghead      ! Gildas header
      external                           :: getsymbol  ! Symbol translation routine
      logical,             intent(inout) :: error      !
    end subroutine fitscube2gdf_header
  end interface
  !
  interface
    subroutine fitscube2gdf_patch_bval(fd,ghead,data,ndata,nblank,error)
      use gildas_def
      use image_def
      use gfits_types
      !---------------------------------------------------------------------
      ! @ public
      ! Patch blanking values to a better value in input data array
      !---------------------------------------------------------------------
      type(gfits_hdesc_t),       intent(in)    :: fd           !
      type(gildas),              intent(in)    :: ghead        !
      integer(kind=size_length), intent(in)    :: ndata        !
      real(kind=4),              intent(inout) :: data(ndata)  !
      integer(kind=size_length), intent(inout) :: nblank       ! Updated in return
      logical,                   intent(inout) :: error        !
    end subroutine fitscube2gdf_patch_bval
  end interface
  !
  interface
    subroutine unit_prefix_scale(prefix,unit,scale,error)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      ! Find the scaling factor to go from 'unit' (e.g. 'Hz') to prefix
      ! (e.g. 'MHz').
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: prefix  ! Prefixed unit
      character(len=*), intent(in)    :: unit    ! Natural unit
      real(kind=8),     intent(out)   :: scale   ! Scaling factor
      logical,          intent(inout) :: error   ! Logical error flag
    end subroutine unit_prefix_scale
  end interface
  !
  interface
    subroutine fits_gildas_sub(iname,oname,style,blc,trc,khdu,check,overwrite,error,  &
      getsymbol,wpr)
      use gio_params
      use gio_xy
      use gio_fitsdef
      use gbl_message
      !--------------------------------------------------------------------
      ! @ public
      ! GIO FITS interface
      ! Convert a FITS file to a GDF file
      !--------------------------------------------------------------------
      character(len=*),           intent(in)    :: iname      ! Input FITS file
      character(len=*),           intent(in)    :: oname      ! Output GILDAS file
      character(len=*),           intent(in)    :: style      ! FITS style
      integer(kind=index_length), intent(in)    :: blc(:)     ! Bottom Left Corner
      integer(kind=index_length), intent(in)    :: trc(:)     ! Top Right Corner
      integer(kind=4),            intent(in)    :: khdu       ! HDU number (1=Primary)
      logical,                    intent(in)    :: check      ! Echo keywords ?
      logical,                    intent(in)    :: overwrite  ! Overwrite existing output file?
      logical,                    intent(inout) :: error      ! Returned error code
      external                                  :: getsymbol  ! Translate FITS keyword
      external                                  :: wpr        ! Ask a question if unknown
    end subroutine fits_gildas_sub
  end interface
  !
  interface
    subroutine gildas_fits_sub(iname,oname,style,nbits,overwrite,error)
      use gio_xy
      use gio_fitsdef
      use gbl_message
      !--------------------------------------------------------
      ! @ public
      ! FITS
      !     Convert a GDF file to a FITS file
      !--------------------------------------------------------
      character(len=*), intent(in)    :: iname      ! GILDAS file name
      character(len=*), intent(in)    :: oname      ! FITS file name
      character(len=*), intent(in)    :: style      ! FITS style
      integer(kind=4),  intent(in)    :: nbits      ! Number of bits
      logical,          intent(in)    :: overwrite  ! Overwrite existing file?
      logical,          intent(inout) :: error      ! Error flag
    end subroutine gildas_fits_sub
  end interface
  !
  interface
    subroutine gildas_to_fits(hfits,oname,style,nbits,overwrite,error)
      use image_def
      use gio_fitsdef
      !--------------------------------------------------------
      ! @ public
      ! FITS
      !     Write a GDF data set in memory onto a FITS file
      !--------------------------------------------------------
      type(gildas), intent(inout) :: hfits          ! GILDAS Header & Data
      character(len=*), intent(in)    :: oname      ! FITS file name
      character(len=*), intent(in)    :: style      ! FITS style
      integer(kind=4),  intent(in)    :: nbits      ! Number of bits
      logical,          intent(in)    :: overwrite  ! Overwrite existing file?
      logical,          intent(inout) :: error      ! Error flag
    end subroutine gildas_to_fits
  end interface
  !
  interface
    subroutine gfits_set_nbit(nbits,error)
      use gio_fitsdef
      use gbl_message
      !--------------------------------------------------------
      ! @ public
      ! FITS
      !     Set number NBIT in FITS Library
      !--------------------------------------------------------
      integer(kind=4),  intent(in)    :: nbits      ! Number of bits
      logical,          intent(inout) :: error      ! Error flag
    end subroutine gfits_set_nbit
  end interface
  !
  interface
    subroutine gfits_set_style(style)
      use gio_fitsdef
      !--------------------------------------------------------
      ! @ public
      ! FITS
      !     Define the FITS style in library
      !--------------------------------------------------------
      character(len=*), intent(in) :: style  ! Style name
    end subroutine gfits_set_style
  end interface
  !
  interface
    subroutine gio_internals(weight,source,parang)
      use gio_fitsdef
      !---------------------------------------------------------------------
      ! @ public
      !   Return the dap numbers of Parallactic Angle and Source ID
      !---------------------------------------------------------------------
      real, intent(out), optional :: weight
      integer, intent(out), optional :: source
      integer, intent(out), optional :: parang
    end subroutine gio_internals
  end interface
  !
  interface
    function stokes_from_fits(rfits)
      use image_def
      !--------------------------------------------------------
      ! @ public
      !
      ! Here we decode the Stokes convention from the FITS Header
      ! -8  -7  -6  -5  -4  -3  -2  -1   0   1   2   3   4
      ! YX  XY  YY  XX  LR  RL  LL  RR  None I   Q   U   V
      !--------------------------------------------------------
      !
      integer :: stokes_from_fits
      real, intent(in) :: rfits
    end function stokes_from_fits
  end interface
  !
  interface
    function fits_from_stokes(istoke)
      use image_def
      !--------------------------------------------------------
      ! @ public
      !
      ! Here we decode the Stokes convention from the FITS Header
      ! -8  -7  -6  -5  -4  -3  -2  -1  0    1   2   3   4
      ! YX  XY  YY  XX  LR  RL  LL  RR  None I   Q   U   V
      !--------------------------------------------------------
      !
      integer :: fits_from_stokes
      integer, intent(in) :: istoke
    end function fits_from_stokes
  end interface
  !
end module gio_interfaces_public

subroutine greg_box(line,error)
  use gildas_def
  use phys_const
  use gbl_message
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>greg_box
  use greg_axes
  use greg_kernel
  use greg_pen
  use greg_types
  use greg_wcs
  !---------------------------------------------------------------------
  ! @ private
  ! GREG Support routine for command
  !   BOX [Parallel [Orthogonal [In]]]  [/ABSOLUTE]
  !       [Orthogonal [Parallel [Out]]] [/UNIT Angle]
  !       [None [None [None]]]
  !                                     [/LABEL Pen]
  !                                     [/FILL Color]
  !                                     [/BRIEF [X|Y]]
  !                                     [/NOBRIEF [X|Y]]
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line   ! Command line
  logical,          intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='BOX'
  character(len=1) :: c1,c2,c3
  real(kind=8) :: ax1,ax2,ay1,ay2,a
  real(kind=8), parameter :: precision=1.0d-10
  integer(kind=size_length), parameter :: nsummits=5
  real(kind=4) :: boxx(nsummits),boxy(nsummits)
  type(axis_t) :: axis(4)
  real(kind=4) :: loffset
  logical :: dolabel,fancypen
  integer(kind=4) :: lpen,open,ncolo,nc
  character(len=12) :: argum,name,angu(4)
  integer(kind=4) :: c_angle,n,ioff
  integer(kind=4) :: xsix,ysix
  ! Data
  data angu /'SECOND','MINUTE','DEGREE','RADIAN'/
  !
  fancypen=sic_present(3,1)
  if (fancypen) then
    call sic_i4 (line,3,1,lpen,.true.,error)
    if (error) return
  endif
  !
  ! Decode arguments
  c1 = 'P'
  c2 = 'O'
  c3 = 'I'
  call sic_ke (line,0,1,c1,nc,.false.,error)
  if (error) goto 99
  call sic_ke (line,0,2,c2,nc,.false.,error)
  if (error) goto 99
  call sic_ke (line,0,3,c3,nc,.false.,error)
  if (error) goto 99
  if (index('POIN',c1).eq.0) goto 99
  if (index('POIN',c2).eq.0) goto 99
  if (index('POIN',c3).eq.0) goto 99
  !
  ! Force dashed to none for the box outline. Have ever seen a dashed box?
  if (sic_present(4,0)) then
    call gtv_pencol_arg2id(rname,line,4,1,ncolo,error)
    if (error) return
    call gtsegm('BACK',error)
    call setcol(ncolo)
    boxx(1) = gx1
    boxy(1) = gy1
    boxx(2) = gx1
    boxy(2) = gy2
    boxx(3) = gx2
    boxy(3) = gy2
    boxx(4) = gx2
    boxy(4) = gy1
    boxx(5) = gx1
    boxy(5) = gy1
    call gr_fillpoly(nsummits,boxx,boxy)
    call gtsegm_close(error)
    if (error) return
  endif
  !
  ! Simple outer box
  if (c3.eq.'N') then
    call gtsegm('BOX',error)
    if (penupd) call setpen(cpen)
    call setdas(1)
    call grelocate(gx1,gy1)
    call gdraw(gx2,gy1)
    call gdraw(gx2,gy2)
    call gdraw(gx1,gy2)
    call gdraw(gx1,gy1)
    if (penupd) call setpen(cpen)
    call gtsegm_close(error)
    return
  endif
  !
  ! No projection, No system, Nothing
  if (gproj%type.eq.p_none .and. i_system.eq.type_un .and. sic_present(1,0)) then
    call greg_message(seve%w,rname,'/ABSOLUTE coordinates ignored when '//  &
    'no projection')
    ax1 = gux1
    ax2 = gux2
    ay1 = guy1
    ay2 = guy2
    xsix = format_decimal
    ysix = format_decimal
    !
    ! Absolute labelling
  elseif (sic_present(1,0).and.(abs(gproj%angle).le.precision)) then
    if (max(abs(gux1),abs(gux2),abs(guy1),abs(guy2)).gt.0.2 .and.  &
        gproj%type.ne.p_none) then
      call greg_message(seve%e,rname,  &
        'Field of view is too large for absolute labelling')
      call greg_message(seve%e,rname,'Try GRID /LABEL')
      error = .true.
      return
    endif
    if (i_system.eq.type_eq .or. i_system.eq.type_ic) then
      xsix = format_sexage_hour
      ysix = format_sexage_degree
      ax1 = (axrem1+axrem2)*0.5d0/pi*3.6d3*1.2d1
      ax2 = (axrem5+axrem6)*0.5d0/pi*3.6d3*1.2d1
      ay1 = (ayrem1+ayrem5)*0.5d0/pi*3.6d3*1.8d2
      ay2 = (ayrem2+ayrem6)*0.5d0/pi*3.6d3*1.8d2
    elseif (i_system.eq.type_ga) then
      if (xsixty.eq.format_sexage_none) then
        ax1 = (axrem1+axrem2)*0.5d0/pi*1.8d2*3.6d3
        ax2 = (axrem5+axrem6)*0.5d0/pi*1.8d2*3.6d3
        xsix = format_sexage_degree
      else
        ax1 = (axrem1+axrem2)*0.5d0/pi*1.8d2
        ax2 = (axrem5+axrem6)*0.5d0/pi*1.8d2
        xsix = format_decimal
      endif
      if (ysixty.eq.format_sexage_none) then
        ay1 = (ayrem1+ayrem5)*0.5d0/pi*1.8d2*3.6d3
        ay2 = (ayrem2+ayrem6)*0.5d0/pi*1.8d2*3.6d3
        ysix = format_sexage_degree
      else
        ay1 = (ayrem1+ayrem5)*0.5d0/pi*1.8d2
        ay2 = (ayrem2+ayrem6)*0.5d0/pi*1.8d2
        ysix = format_decimal
      endif
    else
      if (xsixty.eq.format_sexage_none) then
        ax1 = (axrem1+axrem2)*0.5d0/pi*1.8d2*3.6d3
        ax2 = (axrem5+axrem6)*0.5d0/pi*1.8d2*3.6d3
        xsix = format_sexage_none
      else
        ax1 = (axrem1+axrem2)*0.5d0/pi*1.8d2
        ax2 = (axrem5+axrem6)*0.5d0/pi*1.8d2
        xsix = format_decimal
      endif
      if (ysixty.eq.format_sexage_none) then
        ay1 = (ayrem1+ayrem5)*0.5d0/pi*1.8d2*3.6d3
        ay2 = (ayrem2+ayrem6)*0.5d0/pi*1.8d2*3.6d3
        ysix = format_sexage_none
      else
        ay1 = (ayrem1+ayrem5)*0.5d0/pi*1.8d2
        ay2 = (ayrem2+ayrem6)*0.5d0/pi*1.8d2
        ysix = format_decimal
      endif
    endif
    if (gux1.lt.gux2) then
      a = ax1
      ax1 = ax2
      ax2 = a
    endif
    if (guy1.gt.guy2) then
      a = ay1
      ay1 = ay2
      ay2 = a
    endif
  else
    if (sic_present(1,0)) then
      call greg_message(seve%w,rname,'/ABSOLUTE unsupported for rotated axis')
      call greg_message(seve%w,rname,'Try GRID /LABEL')
    endif
    !
    ! Relative labelling in current angle unit
    c_angle = u_angle
    if (sic_present(2,0)) then
      call sic_ke (line,2,1,name,nc,.true.,error)
      if (error) return
      call sic_ambigs('BOX',name,argum,n,angu,4,error)
      if (error) return
      c_angle = n
    endif
    xsix = format_decimal
    ysix = format_decimal
    if (c_angle.eq.u_second) then
      ax1 = gux1/pi*3.6d3*1.8d2
      ax2 = gux2/pi*3.6d3*1.8d2
      ay1 = guy1/pi*3.6d3*1.8d2
      ay2 = guy2/pi*3.6d3*1.8d2
    elseif (c_angle.eq.u_minute) then
      ax1 = gux1/pi*6.0d1*1.8d2
      ax2 = gux2/pi*6.0d1*1.8d2
      ay1 = guy1/pi*6.0d1*1.8d2
      ay2 = guy2/pi*6.0d1*1.8d2
    elseif (c_angle.eq.u_degree) then
      ax1 = gux1/pi*1.8d2
      ax2 = gux2/pi*1.8d2
      ay1 = guy1/pi*1.8d2
      ay2 = guy2/pi*1.8d2
    else
      ax1 = gux1
      ax2 = gux2
      ay1 = guy1
      ay2 = guy2
    endif
  endif
  !
  if (c3.ne.'O') then
    loffset = 1.
    ioff = 0
  else
    loffset = -2.
    ioff = 1
  endif
  !
  ! XLow
  axis(1)%doline = .true.
  axis(1)%angle = 0.d0
  axis(1)%loga = axis_xlog
  axis(1)%label%format = xsix
  if (xsix.eq.format_decimal) then
    axis(1)%label%brief = axis_xdecim_brief
  else
    axis(1)%label%brief = axis_xsexag_brief
    axis(1)%label%format_nd = ndecimx
  endif
  if (c1.eq.'N') then
    axis(1)%dolabel = .false.
    axis(1)%label%justif = 1
  elseif (c1.eq.'O') then
    axis(1)%dolabel = .true.
    axis(1)%label%justif = just(1+ioff)
  else
    axis(1)%dolabel = .true.
    axis(1)%label%justif = 1
  endif
  axis(1)%tdirect = jclock(1+ioff)
  axis(1)%label%offset = loffset
  axis(1)%label%expo = axis_xexpo
  !
  ! YRight
  axis(2)%doline = .true.
  axis(2)%dolabel = .false.
  axis(2)%angle = pi/2.d0
  axis(2)%loga = axis_ylog
  axis(2)%label%format = ysix
  if (ysix.eq.format_decimal) then
    axis(2)%label%brief = axis_ydecim_brief
  else
    axis(2)%label%brief = axis_ysexag_brief
    axis(2)%label%format_nd = ndecimy
  endif
  axis(2)%tdirect = jclock(7+ioff)
  axis(2)%label%justif = 0
  axis(2)%label%offset = loffset
  axis(2)%label%expo = axis_yexpo
  !
  ! YLeft
  axis(3)%doline = .true.
  axis(3)%angle = pi/2.d0
  axis(3)%loga = axis_ylog
  axis(3)%label%format = ysix
  if (ysix.eq.format_decimal) then
    axis(3)%label%brief = axis_ydecim_brief
  else
    axis(3)%label%brief = axis_ysexag_brief
    axis(3)%label%format_nd = ndecimy
  endif
  if (c2.eq.'N') then
    axis(3)%dolabel = .false.
  elseif (c2.eq.'P') then
    axis(3)%dolabel = .true.
    axis(3)%label%justif = 1
  else
    axis(3)%dolabel = .true.
    axis(3)%label%justif = just(5+ioff)
  endif
  axis(3)%tdirect = jclock(5+ioff)
  axis(3)%label%offset = loffset
  axis(3)%label%expo = axis_yexpo
  !
  ! XUp
  axis(4)%doline = .true.
  axis(4)%dolabel = .false.
  axis(4)%angle = 0.d0
  axis(4)%loga = axis_xlog
  axis(4)%label%format = xsix
  if (xsix.eq.format_decimal) then
    axis(4)%label%brief = axis_xdecim_brief
  else
    axis(4)%label%brief = axis_xsexag_brief
    axis(4)%label%format_nd = ndecimx
  endif
  axis(4)%tdirect = jclock(3+ioff)
  axis(4)%label%justif = 1
  axis(4)%label%offset = loffset
  axis(4)%label%expo = axis_xexpo
  !
  ! /BRIEF|NOBRIEF
  call greg_box_brief(line,axis,error)
  if (error)  return
  !
  ! Do the graphic work. Open the box segment
  call gtsegm('BOX',error)
  if (penupd) call setpen(cpen)
  open=cpen
  call setdas(1)
  !
  ! Draw the axis first WITHOUT labels, whatever the labelling
  ! status. They will be drawn after if needed.
  dolabel = axis(1)%dolabel
  axis(1)%dolabel = .false.
  call plot_axis(ax1,ax2,smallx,bigx,gx1,gy1,gx2-gx1,axis(1),error)
  axis(1)%dolabel = dolabel
  call plot_axis(ax1,ax2,smallx,bigx,gx1,gy2,gx2-gx1,axis(4),error)
  !
  call plot_axis(ay1,ay2,smally,bigy,gx2,gy1,gy2-gy1,axis(2),error)
  dolabel = axis(3)%dolabel
  axis(3)%dolabel = .false.
  call plot_axis(ay1,ay2,smally,bigy,gx1,gy1,gy2-gy1,axis(3),error)
  axis(3)%dolabel = dolabel
  !
  ! Label is a different segment only when /LABEL pen is explicitely
  ! used. Thus, for regular uses, a CLEAR SEGMENT will kill the complete
  ! box, which is the normal use.
  if (c1.ne.'N' .or. c2.ne.'N') then
    if (fancypen) then
      ! Close the BOX segment
      call gtsegm_close(error)
      if (error) return
      !
      call gr_segm('LABEL',error)
      call setpen(lpen)
      call setdas(1)
    endif
    if (axis(3)%dolabel) then
      axis(3)%doline = .false.
      call plot_axis(ay1,ay2,smally,bigy,gx1,gy1,gy2-gy1,axis(3),error)
    endif
    if (axis(1)%dolabel) then
      axis(1)%doline = .false.
      call plot_axis(ax1,ax2,smallx,bigx,gx1,gy1,gx2-gx1,axis(1),error)
    endif
    if (fancypen) then
      cpen = open
      penupd = .true.
    endif
  endif
  !
  ! And close/draw the segment
  call gtsegm_close(error)
  if (error) return
  !
  return
  !
99 call greg_message(seve%e,rname,'Invalid arguments. Should be P/O/N '//  &
     'O/P/N I/O/N')
  error = .true.
end subroutine greg_box
!
subroutine greg_box_brief(line,axis,error)
  use gbl_message
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>greg_box_brief
  use greg_types
  !---------------------------------------------------------------------
  ! @ private
  ! Support routine for command
  !   G\BOX /BRIEF|NOBRIEF [X|Y]
  ! Parse the command line options /BRIEF and /NOBRIEF. They are
  ! compatible as long as the same axis is not used twice, like e.g.
  ! in /BRIEF X /NOBRIEF Y
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line     ! Command line
  type(axis_t),     intent(inout) :: axis(4)  ! Axes parameters
  logical,          intent(inout) :: error    ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='BOX'
  logical :: briefx,briefy,nobriefx,nobriefy,donex,doney
  character(len=12) :: argum
  integer(kind=4) :: nc
  !
  donex = .false.
  doney = .false.
  !
  ! /BRIEF [X|Y]
  if (sic_present(5,0)) then
    if (sic_present(5,1)) then
      briefx = .false.
      briefy = .false.
      call sic_ke(line,5,1,argum,nc,.true.,error)
      if (error)  return
      if (argum.eq.'X')  then
        briefx = .true.
      elseif (argum.eq.'Y')  then
        briefy = .true.
      elseif (argum.ne.'') then
        call greg_message(seve%e,rname,  &
          '/BRIEF argument must be X, Y, or nothing')
        error = .true.
        return
      endif
    else
      briefx = .true.
      briefy = .true.
    endif
    !
    if (briefx) then
      donex = .true.
      axis(1)%label%brief = .true.  ! XLow
      axis(4)%label%brief = .true.  ! XUp
    endif
    if (briefy) then
      doney = .true.
      axis(2)%label%brief = .true.  ! YLeft
      axis(3)%label%brief = .true.  ! YRight
    endif
  endif
  !
  ! /NOBRIEF [X|Y]
  if (sic_present(6,0)) then
    if (sic_present(6,1)) then
      nobriefx = .false.
      nobriefy = .false.
      call sic_ke(line,6,1,argum,nc,.true.,error)
      if (error)  return
      if (argum.eq.'X')  then
        nobriefx = .true.
      elseif (argum.eq.'Y')  then
        nobriefy = .true.
      elseif (argum.ne.'') then
        call greg_message(seve%e,rname,  &
          '/NOBRIEF argument must be X, Y, or nothing')
        error = .true.
        return
      endif
    else
      nobriefx = .true.
      nobriefy = .true.
    endif
    !
    if (nobriefx .and. donex) then
      call greg_message(seve%e,rname,'X used twice with /BRIEF and /NOBRIEF')
      error = .true.
      return
    endif
    if (nobriefy .and. doney) then
      call greg_message(seve%e,rname,'Y used twice with /BRIEF and /NOBRIEF')
      error = .true.
      return
    endif
    !
    if (nobriefx) then
      axis(1)%label%brief = .false.  ! XLow
      axis(4)%label%brief = .false.  ! XUp
    endif
    if (nobriefy) then
      axis(2)%label%brief = .false.  ! YLeft
      axis(3)%label%brief = .false.  ! YRight
    endif
  endif
  !
end subroutine greg_box_brief

subroutine bars(line,error)
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>bars
  use gildas_def
  use sic_types
  use greg_kernel
  use greg_xyz
  use gbl_message
  use gbl_format
  !---------------------------------------------------------------------
  ! @ private
  ! GREG	Support routine for command
  !	ERRORBAR [+X] [X] [-X] [+Y] [Y] [-Y] [[+/-]O] [X_var Y_var Z_var]
  !	Draw error bars at data point location. The error bar size is
  !	defined by array Z value.
  !---------------------------------------------------------------------
  character(len=*)               :: line   ! Input command line
  logical,         intent(inout) :: error  ! Logical error flag
  ! Global
  include 'gbl_memory.inc'
  ! Local
  character(len=*), parameter :: rname='ERRORBAR'
  type(sic_descriptor_t) :: xinca,yinca,zinca
  integer(kind=address_length) :: xaddr,yaddr,zaddr
  integer(kind=size_length) :: ixy
  integer(kind=4) :: form,narg,nc,ier
  character(len=4) :: cloc
  character(len=60) :: chain
  real(kind=8) :: bval,eval
  logical :: orient
  real(kind=8), allocatable :: ovalues(:)
  character(len=varname_length) :: var
  !
  save xinca,yinca,zinca
  !
  cloc = ' '
  call sic_ke (line,0,1,cloc,nc,.true.,error)
  if (error) return
  if (cloc.ne.'+X' .and. cloc.ne.'-X' .and. cloc.ne.'X' .and.  &
      cloc.ne.'+Y' .and. cloc.ne.'-Y' .and. cloc.ne.'Y' .and.  &
      cloc.ne.'+O' .and. cloc.ne.'-O' .and. cloc.ne.'O') then
    chain = 'Invalid error bar type '//cloc
    error = .true.
    call greg_message(seve%e,rname,chain)
    return
  endif
  error = .false.
  orient = cloc.eq.'+O' .or. cloc.eq.'-O' .or. cloc.eq.'O'
  !
  narg = sic_narg(0)
  if (narg.ne.1.and.narg.ne.4.and..not.(narg.eq.5.and.orient)) then
    call greg_message(seve%e,rname,'1 or 4 arguments required')
    error = .true.
    return
  endif
  !
  ixy = 0
  form = fmt_r8
  if (narg.ge.4) then
    call get_same_inca ('ERRORBAR',line,0,2,form,ixy,xinca,error)
    if (error) return
    call get_same_inca ('ERRORBAR',line,0,3,form,ixy,yinca,error)
    if (error) then
      call sic_volatile(xinca)
      return
    endif
    call get_same_inca ('ERRORBAR',line,0,4,form,ixy,zinca,error)
    if (error) then
      call sic_volatile(xinca)
      call sic_volatile(yinca)
      return
    endif
  else
    call get_greg_inca ('ERRORBAR','X',form,ixy,xinca,error)
    if (error) return
    call get_greg_inca ('ERRORBAR','Y',form,ixy,yinca,error)
    if (error) then
      call sic_volatile(xinca)
      return
    endif
    call get_greg_inca ('ERRORBAR','Z',form,ixy,zinca,error)
    if (error) then
      call sic_volatile(xinca)
      call sic_volatile(yinca)
      return
    endif
  endif
  !
  ! Non trivial errorbar orientation: get the specifier array
  if (orient) then
    allocate(ovalues(ixy),stat=ier)
    if (failed_allocate(rname,'O values',ier,error))  goto 100
    if (narg.eq.5) then
      ! Orientation specified by an array
      call sic_ke (line,0,5,var,nc,.true.,error)
      if (error)  goto 100
      call sic_variable_getr8_1d(rname,var,ovalues,ixy,error)
      if (error)  goto 100
    else
      ! Fill a scratch array with current marker orientation
      ovalues(:) = dble(sangle)
    endif
  else
    allocate(ovalues(0))  ! Unused (this is valid Fortran array)
  endif
  !
  xaddr = gag_pointer(xinca%addr,memory)
  yaddr = gag_pointer(yinca%addr,memory)
  zaddr = gag_pointer(zinca%addr,memory)
  !
  call gtsegm(rname,error)
  bval = cblank
  eval = eblank
  call gr8_bars(cloc,ixy,memory(xaddr),memory(yaddr),memory(zaddr),  &
   ovalues,bval,eval)
  call gtsegm_close(error)
  !
100 continue
  call sic_volatile(xinca)
  call sic_volatile(yinca)
  call sic_volatile(zinca)
  if (allocated(ovalues))  deallocate(ovalues)
end subroutine bars
!
subroutine gr8_bars (cloc,nxy,x,y,err,orient,bval,eval)
  use phys_const
  use gbl_message
  use greg_dependencies_interfaces
  use greg_interfaces
  use greg_kernel
  use greg_pen
  !---------------------------------------------------------------------
  ! @ no-interface (because of type mismatch)
  ! 	Plot an errorbar of length ERR at point (X,Y)
  ! 	LOC = '-X' 'X' '+X' '-Y' 'Y' '+Y' '-O' 'O' '+O'
  ! Arguments :
  !	CLOC	C*(*)	Conventional orientation of errorbar
  !	X	R*8 (*)	Array of X user coordinates
  !	Y	R*8 (*)	Array of Y user coordinates
  !	ERR	R*8 (*) Array of error values
  !	ORIENT	R*8 (*) Array of errorbar orientations (only used for CLOC='O')
  !	NXY	I	Number of points
  ! Subroutines :
  !	INQANG	/ SETANG
  !	DRAW / RELOCATE
  !	SETDAS
  !	POINT
  !---------------------------------------------------------------------
  character(len=*) :: cloc          !
  integer(kind=4) :: nxy                    !
  real(kind=8) :: x(*)                    !
  real(kind=8) :: y(*)                    !
  real(kind=8) :: err(*)                  !
  real(kind=8) :: orient(*)               !
  real(kind=8) :: bval                    !
  real(kind=8) :: eval                    !
  ! Local
  character(len=*), parameter :: rname='BARS'
  real(kind=8) :: xx,yy,co,so,ss
  integer(kind=4) :: j,idas
  real(kind=4) :: o_angl,o_sangl,symbsize
  logical :: error
  real(kind=4), parameter :: epsr4=1e-7
  !
  if (nxy.lt.1) return
  call inqang(o_angl,o_sangl)
  if (cloc.eq.'+X' .or. cloc.eq.'-X' .or. cloc.eq.'X') then
    call setang(o_angl,90.)
  elseif (cloc.eq.'+Y' .or. cloc.eq.'-Y' .or. cloc.eq.'Y') then
    call setang(o_angl,0.)
  elseif (cloc.eq.'+O' .or. cloc.eq.'-O' .or. cloc.eq.'O') then
    call inqsym(symbsize)
    ss = 0.5*symbsize/sqrt(abs(gux*guy))
    if (abs(guy).lt.abs(gux)*(1-10*epsr4) .or.  &
        abs(guy).gt.abs(gux)*(1+10*epsr4))  &
      call greg_message(seve%w,rname,'O code with mismatched axes')
  else
    call greg_message(seve%e,rname,'Unknown orientation code')
    return
  endif
  call inqdas(idas)
  !
  if (penupd) call setpen(cpen)
  !
  error = .false.
  !
  if (cloc.eq.'+X') then
    if (idas.eq.1) then
      do j = 1,nxy
        if (y(j).eq.y(j).and.abs(y(j)-bval).gt.eval) then
          xx = x(j)
          yy = y(j)
          call relocate(xx,yy)
          xx = xx + err(j)
          call draw(xx,yy)
          call gr_point(2,0)
        endif
      enddo
    else
      do j = 1,nxy
        if (y(j).eq.y(j).and.abs(y(j)-bval).gt.eval) then
          xx = x(j)
          yy = y(j)
          call relocate(xx,yy)
          xx = xx + err(j)
          call draw(xx,yy)
        endif
      enddo
      call gtsegm_close(error)
      call gtsegm('ERRORTICK',error)
      call setdas(1)  ! Ticks always use solid lines
      do j = 1,nxy
        if (y(j).eq.y(j).and.abs(y(j)-bval).gt.eval) then
          xx = x(j) + err(j)
          yy = y(j)
          call relocate(xx,yy)
          call gr_point(2,0)
        endif
      enddo
    endif
  elseif (cloc.eq.'+Y') then
    if (idas.eq.1) then
      do j=1,nxy
        if (y(j).eq.y(j).and.abs(y(j)-bval).gt.eval) then
          xx = x(j)
          yy = y(j)
          call relocate(xx,yy)
          yy = yy + err(j)
          call draw(xx,yy)
          call gr_point(2,0)
        endif
      enddo
    else
      do j=1,nxy
        if (y(j).eq.y(j).and.abs(y(j)-bval).gt.eval) then
          xx = x(j)
          yy = y(j)
          call relocate(xx,yy)
          yy = yy + err(j)
          call draw(xx,yy)
        endif
      enddo
      call gtsegm_close(error)
      call gtsegm('ERRORTICK',error)
      call setdas(1)  ! Ticks always use solid lines
      do j=1,nxy
        if (y(j).eq.y(j).and.abs(y(j)-bval).gt.eval) then
          xx = x(j)
          yy = y(j) + err(j)
          call relocate(xx,yy)
          call gr_point(2,0)
        endif
      enddo
    endif
  elseif (cloc.eq.'-X') then
    if (idas.eq.1) then
      do j=1,nxy
        if (y(j).eq.y(j).and.abs(y(j)-bval).gt.eval) then
          xx = x(j)
          yy = y(j)
          call relocate(xx,yy)
          xx = xx - err(j)
          call draw(xx,yy)
          call gr_point(2,0)
        endif
      enddo
    else
      do j=1,nxy
        if (y(j).eq.y(j).and.abs(y(j)-bval).gt.eval) then
          xx = x(j)
          yy = y(j)
          call relocate(xx,yy)
          xx = xx - err(j)
          call draw(xx,yy)
        endif
      enddo
      call gtsegm_close(error)
      call gtsegm('ERRORTICK',error)
      call setdas(1)  ! Ticks always use solid lines
      do j=1,nxy
        if (y(j).eq.y(j).and.abs(y(j)-bval).gt.eval) then
          xx = x(j) - err(j)
          yy = y(j)
          call relocate(xx,yy)
          call gr_point(2,0)
        endif
      enddo
    endif
  elseif (cloc.eq.'-Y') then
    if (idas.eq.1) then
      do j=1,nxy
        if (y(j).eq.y(j).and.abs(y(j)-bval).gt.eval) then
          xx = x(j)
          yy = y(j)
          call relocate(xx,yy)
          yy = yy - err(j)
          call draw(xx,yy)
          call gr_point(2,0)
        endif
      enddo
    else
      do j=1,nxy
        if (y(j).eq.y(j).and.abs(y(j)-bval).gt.eval) then
          xx = x(j)
          yy = y(j)
          call relocate(xx,yy)
          yy = yy - err(j)
          call draw(xx,yy)
        endif
      enddo
      call gtsegm_close(error)
      call gtsegm('ERRORTICK',error)
      call setdas(1)  ! Ticks always use solid lines
      do j=1,nxy
        if (y(j).eq.y(j).and.abs(y(j)-bval).gt.eval) then
          xx = x(j)
          yy = y(j)
          call relocate(xx,yy)
          yy = yy - err(j)
          call relocate(xx,yy)
          call gr_point(2,0)
        endif
      enddo
    endif
  elseif (cloc.eq.'X') then
    if (idas.eq.1) then
      do j=1,nxy
        if (y(j).eq.y(j).and.abs(y(j)-bval).gt.eval) then
          yy = y(j)
          xx = x(j) + err(j)
          call relocate(xx,yy)
          call gr_point(2,0)
          xx = x(j) - err(j)
          call draw(xx,yy)
          call gr_point(2,0)
        endif
      enddo
    else
      do j=1,nxy
        if (y(j).eq.y(j).and.abs(y(j)-bval).gt.eval) then
          yy = y(j)
          xx = x(j) + err(j)
          call relocate(xx,yy)
          xx = x(j) - err(j)
          call draw(xx,yy)
        endif
      enddo
      call gtsegm_close(error)
      call gtsegm('ERRORTICK',error)
      call setdas(1)  ! Ticks always use solid lines
      do j=1,nxy
        if (y(j).eq.y(j).and.abs(y(j)-bval).gt.eval) then
          yy = y(j)
          xx = x(j) + err(j)
          call relocate(xx,yy)
          call gr_point(2,0)
          xx = x(j) - err(j)
          call relocate(xx,yy)
          call gr_point(2,0)
        endif
      enddo
    endif
  elseif (cloc.eq.'Y') then
    if (idas.eq.1) then
      do j=1,nxy
        if (y(j).eq.y(j).and.abs(y(j)-bval).gt.eval) then
          yy = y(j) + err(j)
          xx = x(j)
          call relocate(xx,yy)
          call gr_point(2,0)
          yy = y(j) - err(j)
          call draw(xx,yy)
          call gr_point(2,0)
        endif
      enddo
    else
      do j=1,nxy
        if (y(j).eq.y(j).and.abs(y(j)-bval).gt.eval) then
          yy = y(j) + err(j)
          xx = x(j)
          call relocate(xx,yy)
          yy = y(j) - err(j)
          call draw(xx,yy)
        endif
      enddo
      call gtsegm_close(error)
      call gtsegm('ERRORTICK',error)
      call setdas(1)  ! Ticks always use solid lines
      do j=1,nxy
        if (y(j).eq.y(j).and.abs(y(j)-bval).gt.eval) then
          yy = y(j) + err(j)
          xx = x(j)
          call relocate(xx,yy)
          call gr_point(2,0)
          yy = y(j) - err(j)
          call relocate(xx,yy)
          call gr_point(2,0)
        endif
      enddo
    endif
  elseif (cloc.eq.'+O') then
    if (idas.eq.1) then
      do j=1,nxy
        if (y(j).eq.y(j).and.abs(y(j)-bval).gt.eval) then
          xx = x(j)
          yy = y(j)
          co = cos(rad_per_deg*orient(j))
          so = sin(rad_per_deg*orient(j))
          call relocate(xx,yy)
          xx = xx + err(j)*co
          yy = yy + err(j)*so
          call draw(xx,yy)
          call relocate(xx+so*ss,yy-co*ss)
          call draw(xx-so*ss,yy+co*ss)
        endif
      enddo
    else
      do j=1,nxy
        if (y(j).eq.y(j).and.abs(y(j)-bval).gt.eval) then
          co = cos(rad_per_deg*orient(j))
          so = sin(rad_per_deg*orient(j))
          xx = x(j)
          yy = y(j)
          call relocate(xx,yy)
          xx = xx + err(j)*co
          yy = yy + err(j)*so
          call draw(xx,yy)
        endif
      enddo
      call gtsegm_close(error)
      call gtsegm('ERRORTICK',error)
      call setdas(1)  ! Ticks always use solid lines
      do j=1,nxy
        if (y(j).eq.y(j).and.abs(y(j)-bval).gt.eval) then
          co = cos(rad_per_deg*orient(j))
          so = sin(rad_per_deg*orient(j))
          xx = x(j) + err(j)*co
          yy = y(j) + err(j)*so
          call relocate(xx+so*ss,yy-co*ss)
          call draw(xx-so*ss,yy+co*ss)
        endif
      enddo
    endif
  elseif (cloc.eq.'-O') then
    if (idas.eq.1) then
      do j=1,nxy
        if (y(j).eq.y(j).and.abs(y(j)-bval).gt.eval) then
          co = cos(rad_per_deg*orient(j))
          so = sin(rad_per_deg*orient(j))
          xx = x(j)
          yy = y(j)
          call relocate(xx,yy)
          xx = xx - err(j)*co
          yy = yy - err(j)*so
          call draw(xx,yy)
          call relocate(xx+so*ss,yy-co*ss)
          call draw(xx-so*ss,yy+co*ss)
        endif
      enddo
    else
      do j=1,nxy
        if (y(j).eq.y(j).and.abs(y(j)-bval).gt.eval) then
          xx = x(j)
          yy = y(j)
          call relocate(xx,yy)
          xx = xx - err(j)*cos(rad_per_deg*orient(j))
          yy = yy - err(j)*sin(rad_per_deg*orient(j))
          call draw(xx,yy)
        endif
      enddo
      call gtsegm_close(error)
      call gtsegm('ERRORTICK',error)
      call setdas(1)  ! Ticks always use solid lines
      do j=1,nxy
        if (y(j).eq.y(j).and.abs(y(j)-bval).gt.eval) then
          co = cos(rad_per_deg*orient(j))
          so = sin(rad_per_deg*orient(j))
          xx = x(j) - err(j)*co
          yy = y(j) - err(j)*so
          call relocate(xx+so*ss,yy-co*ss)
          call draw(xx-so*ss,yy+co*ss)
        endif
      enddo
    endif
  elseif (cloc.eq.'O') then
    if (idas.eq.1) then
      do j=1,nxy
        if (y(j).eq.y(j).and.abs(y(j)-bval).gt.eval) then
          co = cos(rad_per_deg*orient(j))
          so = sin(rad_per_deg*orient(j))
          xx = x(j) - err(j)*co
          yy = y(j) - err(j)*so
          call relocate(xx+so*ss,yy-co*ss)
          call draw(xx-so*ss,yy+co*ss)
          call relocate(xx,yy)
          xx = x(j) + err(j)*co
          yy = y(j) + err(j)*so
          call draw(xx,yy)
          call relocate(xx+so*ss,yy-co*ss)
          call draw(xx-so*ss,yy+co*ss)
        endif
      enddo
    else
      do j=1,nxy
        if (y(j).eq.y(j).and.abs(y(j)-bval).gt.eval) then
          co = cos(rad_per_deg*orient(j))
          so = sin(rad_per_deg*orient(j))
          xx = x(j) - err(j)*co
          yy = y(j) - err(j)*so
          call relocate(xx,yy)
          xx = x(j) + err(j)*co
          yy = y(j) + err(j)*so
          call draw(xx,yy)
        endif
      enddo
      call gtsegm_close(error)
      call gtsegm('ERRORTICK',error)
      call setdas(1)  ! Ticks always use solid lines
      do j=1,nxy
        if (y(j).eq.y(j).and.abs(y(j)-bval).gt.eval) then
          co = cos(rad_per_deg*orient(j))
          so = sin(rad_per_deg*orient(j))
          xx = x(j) - err(j)*co
          yy = y(j) - err(j)*so
          call relocate(xx+so*ss,yy-co*ss)
          call draw(xx-so*ss,yy+co*ss)
          xx = x(j) + err(j)*co
          yy = y(j) + err(j)*so
          call relocate(xx+so*ss,yy-co*ss)
          call draw(xx-so*ss,yy+co*ss)
        endif
      enddo
    endif
  else
    call greg_message(seve%e,rname,'Unknown orientation code')
    error = .true.
  endif
  !
  if (idas.ne.1) then
    ! If idas.ne.1, this means that we have forced the current dash
    ! style to 1 for the ticks (setdas(1)). This style is applied to
    ! the currently opened segment (ERRORTICK). We can not reset it
    ! to its original value (setdas(idas)), because this would affect
    ! the segment ERRORTICK: it must be closed before. Since it is
    ! closed out of this subroutine, just turn the Greg global flag to
    ! the correct value, and set "pen update" to true for a later udpate.
    cdashe = idas
    penupd = .true.
  endif
  call setang(o_angl,o_sangl)
  !
end subroutine gr8_bars
!
subroutine gr4_bars (cloc,nxy,x,y,err,orient,bval,eval)
  use phys_const
  use gbl_message
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>gr4_bars
  use greg_kernel
  use greg_pen
  !---------------------------------------------------------------------
  ! @ public
  !	Plot an errorbar of length ERR at point (X,Y)
  ! 	LOC = '-X' 'X' '+X' '-Y' 'Y' '+Y' '-O' 'O' '+O'
  ! Arguments :
  !	CLOC	C*(*)	Conventional orientation of errorbar
  !	X	R*4 (*)	Array of X user coordinates
  !	Y	R*4 (*)	Array of Y user coordinates
  !	ERR	R*4 (*) Array of error values
  !	ORIENT	R*4 (*) Array of errorbar orientations (only used for CLOC='O')
  !	NXY	I	Number of points
  ! Subroutines :
  !	INQANG	/ SETANG
  !	DRAW / RELOCATE
  !	SETDAS
  !	POINT
  !---------------------------------------------------------------------
  character(len=*) :: cloc          !
  integer(kind=4) :: nxy                    !
  real(kind=4) :: x(*)                    !
  real(kind=4) :: y(*)                    !
  real(kind=4) :: err(*)                  !
  real(kind=4) :: orient(*)               !
  real(kind=4) :: bval                    !
  real(kind=4) :: eval                    !
  ! Local
  character(len=*), parameter :: rname='BARS'
  real(kind=8) :: xx,yy,co,so,ss
  integer(kind=4) :: j,idas
  real(kind=4) :: o_angl,o_sangl,symbsize
  logical :: error
  real(kind=4), parameter :: epsr4=1e-7
  !
  if (nxy.lt.1) return
  call inqang(o_angl,o_sangl)
  if (cloc.eq.'+X' .or. cloc.eq.'-X' .or. cloc.eq.'X') then
    call setang(o_angl,90.)
  elseif (cloc.eq.'+Y' .or. cloc.eq.'-Y' .or. cloc.eq.'Y') then
    call setang(o_angl,0.)
  elseif (cloc.eq.'+O' .or. cloc.eq.'-O' .or. cloc.eq.'O') then
    call inqsym(symbsize)
    ss = 0.5*symbsize/sqrt(abs(gux*guy))
    if (abs(guy).lt.abs(gux)*(1-10*epsr4) .or.  &
        abs(guy).gt.abs(gux)*(1+10*epsr4))  &
      call greg_message(seve%w,rname,'O code with mismatched axes')
  else
    call greg_message(seve%e,rname,'Unknown orientation code')
    return
  endif
  call inqdas(idas)
  !
  if (penupd) call setpen(cpen)
  !
  error = .false.
  !
  if (cloc.eq.'+X') then
    if (idas.eq.1) then
      do j = 1,nxy
        if (y(j).eq.y(j).and.abs(y(j)-bval).gt.eval) then
          xx = x(j)
          yy = y(j)
          call relocate(xx,yy)
          xx = xx + err(j)
          call draw(xx,yy)
          call gr_point(2,0)
        endif
      enddo
    else
      do j = 1,nxy
        if (y(j).eq.y(j).and.abs(y(j)-bval).gt.eval) then
          xx = x(j)
          yy = y(j)
          call relocate(xx,yy)
          xx = xx + err(j)
          call draw(xx,yy)
        endif
      enddo
      call gtsegm_close(error)
      call gtsegm('ERRORTICK',error)
      call setdas(1)  ! Ticks always use solid lines
      do j = 1,nxy
        if (y(j).eq.y(j).and.abs(y(j)-bval).gt.eval) then
          xx = x(j) + err(j)
          yy = y(j)
          call relocate(xx,yy)
          call gr_point(2,0)
        endif
      enddo
    endif
  elseif (cloc.eq.'+Y') then
    if (idas.eq.1) then
      do j=1,nxy
        if (y(j).eq.y(j).and.abs(y(j)-bval).gt.eval) then
          xx = x(j)
          yy = y(j)
          call relocate(xx,yy)
          yy = yy + err(j)
          call draw(xx,yy)
          call gr_point(2,0)
        endif
      enddo
    else
      do j=1,nxy
        if (y(j).eq.y(j).and.abs(y(j)-bval).gt.eval) then
          xx = x(j)
          yy = y(j)
          call relocate(xx,yy)
          yy = yy + err(j)
          call draw(xx,yy)
        endif
      enddo
      call gtsegm_close(error)
      call gtsegm('ERRORTICK',error)
      call setdas(1)  ! Ticks always use solid lines
      do j=1,nxy
        if (y(j).eq.y(j).and.abs(y(j)-bval).gt.eval) then
          xx = x(j)
          yy = y(j) + err(j)
          call relocate(xx,yy)
          call gr_point(2,0)
        endif
      enddo
    endif
  elseif (cloc.eq.'-X') then
    if (idas.eq.1) then
      do j=1,nxy
        if (y(j).eq.y(j).and.abs(y(j)-bval).gt.eval) then
          xx = x(j)
          yy = y(j)
          call relocate(xx,yy)
          xx = xx - err(j)
          call draw(xx,yy)
          call gr_point(2,0)
        endif
      enddo
    else
      do j=1,nxy
        if (y(j).eq.y(j).and.abs(y(j)-bval).gt.eval) then
          xx = x(j)
          yy = y(j)
          call relocate(xx,yy)
          xx = xx - err(j)
          call draw(xx,yy)
        endif
      enddo
      call gtsegm_close(error)
      call gtsegm('ERRORTICK',error)
      call setdas(1)  ! Ticks always use solid lines
      do j=1,nxy
        if (y(j).eq.y(j).and.abs(y(j)-bval).gt.eval) then
          xx = x(j) - err(j)
          yy = y(j)
          call relocate(xx,yy)
          call gr_point(2,0)
        endif
      enddo
    endif
  elseif (cloc.eq.'-Y') then
    if (idas.eq.1) then
      do j=1,nxy
        if (y(j).eq.y(j).and.abs(y(j)-bval).gt.eval) then
          xx = x(j)
          yy = y(j)
          call relocate(xx,yy)
          yy = yy - err(j)
          call draw(xx,yy)
          call gr_point(2,0)
        endif
      enddo
    else
      do j=1,nxy
        if (y(j).eq.y(j).and.abs(y(j)-bval).gt.eval) then
          xx = x(j)
          yy = y(j)
          call relocate(xx,yy)
          yy = yy - err(j)
          call draw(xx,yy)
        endif
      enddo
      call gtsegm_close(error)
      call gtsegm('ERRORTICK',error)
      call setdas(1)  ! Ticks always use solid lines
      do j=1,nxy
        if (y(j).eq.y(j).and.abs(y(j)-bval).gt.eval) then
          xx = x(j)
          yy = y(j)
          call relocate(xx,yy)
          yy = yy - err(j)
          call relocate(xx,yy)
          call gr_point(2,0)
        endif
      enddo
    endif
  elseif (cloc.eq.'X') then
    if (idas.eq.1) then
      do j=1,nxy
        if (y(j).eq.y(j).and.abs(y(j)-bval).gt.eval) then
          yy = y(j)
          xx = x(j) + err(j)
          call relocate(xx,yy)
          call gr_point(2,0)
          xx = x(j) - err(j)
          call draw(xx,yy)
          call gr_point(2,0)
        endif
      enddo
    else
      do j=1,nxy
        if (y(j).eq.y(j).and.abs(y(j)-bval).gt.eval) then
          yy = y(j)
          xx = x(j) + err(j)
          call relocate(xx,yy)
          xx = x(j) - err(j)
          call draw(xx,yy)
        endif
      enddo
      call gtsegm_close(error)
      call gtsegm('ERRORTICK',error)
      call setdas(1)  ! Ticks always use solid lines
      do j=1,nxy
        if (y(j).eq.y(j).and.abs(y(j)-bval).gt.eval) then
          yy = y(j)
          xx = x(j) + err(j)
          call relocate(xx,yy)
          call gr_point(2,0)
          xx = x(j) - err(j)
          call relocate(xx,yy)
          call gr_point(2,0)
        endif
      enddo
    endif
  elseif (cloc.eq.'Y') then
    if (idas.eq.1) then
      do j=1,nxy
        if (y(j).eq.y(j).and.abs(y(j)-bval).gt.eval) then
          yy = y(j) + err(j)
          xx = x(j)
          call relocate(xx,yy)
          call gr_point(2,0)
          yy = y(j) - err(j)
          call draw(xx,yy)
          call gr_point(2,0)
        endif
      enddo
    else
      do j=1,nxy
        if (y(j).eq.y(j).and.abs(y(j)-bval).gt.eval) then
          yy = y(j) + err(j)
          xx = x(j)
          call relocate(xx,yy)
          yy = y(j) - err(j)
          call draw(xx,yy)
        endif
      enddo
      call gtsegm_close(error)
      call gtsegm('ERRORTICK',error)
      call setdas(1)  ! Ticks always use solid lines
      do j=1,nxy
        if (y(j).eq.y(j).and.abs(y(j)-bval).gt.eval) then
          yy = y(j) + err(j)
          xx = x(j)
          call relocate(xx,yy)
          call gr_point(2,0)
          yy = y(j) - err(j)
          call relocate(xx,yy)
          call gr_point(2,0)
        endif
      enddo
    endif
  elseif (cloc.eq.'+O') then
    if (idas.eq.1) then
      do j=1,nxy
        if (y(j).eq.y(j).and.abs(y(j)-bval).gt.eval) then
          co = cos(rad_per_deg*orient(j))
          so = sin(rad_per_deg*orient(j))
          xx = x(j)
          yy = y(j)
          call relocate(xx,yy)
          xx = xx + err(j)*co
          yy = yy + err(j)*so
          call draw(xx,yy)
          call relocate(xx+so*ss,yy-co*ss)
          call draw(xx-so*ss,yy+co*ss)
        endif
      enddo
    else
      do j=1,nxy
        if (y(j).eq.y(j).and.abs(y(j)-bval).gt.eval) then
          co = cos(rad_per_deg*orient(j))
          so = sin(rad_per_deg*orient(j))
          xx = x(j)
          yy = y(j)
          call relocate(xx,yy)
          xx = xx + err(j)*co
          yy = yy + err(j)*so
          call draw(xx,yy)
        endif
      enddo
      call gtsegm_close(error)
      call gtsegm('ERRORTICK',error)
      call setdas(1)  ! Ticks always use solid lines
      do j=1,nxy
        if (y(j).eq.y(j).and.abs(y(j)-bval).gt.eval) then
          co = cos(rad_per_deg*orient(j))
          so = sin(rad_per_deg*orient(j))
          xx = x(j) + err(j)*co
          yy = y(j) + err(j)*so
          call relocate(xx+so*ss,yy-co*ss)
          call draw(xx-so*ss,yy+co*ss)
        endif
      enddo
    endif
  elseif (cloc.eq.'-O') then
    if (idas.eq.1) then
      do j=1,nxy
        if (y(j).eq.y(j).and.abs(y(j)-bval).gt.eval) then
          co = cos(rad_per_deg*orient(j))
          so = sin(rad_per_deg*orient(j))
          xx = x(j)
          yy = y(j)
          call relocate(xx,yy)
          xx = xx - err(j)*co
          yy = yy - err(j)*so
          call draw(xx,yy)
          call relocate(xx+so*ss,yy-co*ss)
          call draw(xx-so*ss,yy+co*ss)
        endif
      enddo
    else
      do j=1,nxy
        if (y(j).eq.y(j).and.abs(y(j)-bval).gt.eval) then
          co = cos(rad_per_deg*orient(j))
          so = sin(rad_per_deg*orient(j))
          xx = x(j)
          yy = y(j)
          call relocate(xx,yy)
          xx = xx - err(j)*co
          yy = yy - err(j)*so
          call draw(xx,yy)
        endif
      enddo
      call gtsegm_close(error)
      call gtsegm('ERRORTICK',error)
      call setdas(1)  ! Ticks always use solid lines
      do j=1,nxy
        if (y(j).eq.y(j).and.abs(y(j)-bval).gt.eval) then
          co = cos(rad_per_deg*orient(j))
          so = sin(rad_per_deg*orient(j))
          xx = x(j) - err(j)*co
          yy = y(j) - err(j)*so
          call relocate(xx+so*ss,yy-co*ss)
          call draw(xx-so*ss,yy+co*ss)
        endif
      enddo
    endif
  elseif (cloc.eq.'O') then
    if (idas.eq.1) then
      do j=1,nxy
        if (y(j).eq.y(j).and.abs(y(j)-bval).gt.eval) then
          co = cos(rad_per_deg*orient(j))
          so = sin(rad_per_deg*orient(j))
          xx = x(j) - err(j)*co
          yy = y(j) - err(j)*so
          call relocate(xx+so*ss,yy-co*ss)
          call draw(xx-so*ss,yy+co*ss)
          call relocate(xx,yy)
          xx = x(j) + err(j)*co
          yy = y(j) + err(j)*so
          call draw(xx,yy)
          call relocate(xx+so*ss,yy-co*ss)
          call draw(xx-so*ss,yy+co*ss)
        endif
      enddo
    else
      do j=1,nxy
        if (y(j).eq.y(j).and.abs(y(j)-bval).gt.eval) then
          co = cos(rad_per_deg*orient(j))
          so = sin(rad_per_deg*orient(j))
          xx = x(j) - err(j)*co
          yy = y(j) - err(j)*so
          call relocate(xx,yy)
          xx = x(j) + err(j)*co
          yy = y(j) + err(j)*so
          call draw(xx,yy)
        endif
      enddo
      call gtsegm_close(error)
      call gtsegm('ERRORTICK',error)
      call setdas(1)  ! Ticks always use solid lines
      do j=1,nxy
        if (y(j).eq.y(j).and.abs(y(j)-bval).gt.eval) then
          co = cos(rad_per_deg*orient(j))
          so = sin(rad_per_deg*orient(j))
          xx = x(j) - err(j)*co
          yy = y(j) - err(j)*so
          call relocate(xx+so*ss,yy-co*ss)
          call draw(xx-so*ss,yy+co*ss)
          xx = x(j) + err(j)*so
          yy = y(j) + err(j)*so
          call relocate(xx+so*ss,yy-co*ss)
          call draw(xx-so*ss,yy+co*ss)
        endif
      enddo
    endif
  else
    call greg_message(seve%e,rname,'Unknown orientation code')
    error = .true.
  endif
  !
  if (idas.ne.1) then
    ! If idas.ne.1, this means that we have forced the current dash
    ! style to 1 for the ticks (setdas(1)). This style is applied to
    ! the currently opened segment (ERRORTICK). We can not reset it
    ! to its original value (setdas(idas)), because this would affect
    ! the segment ERRORTICK: it must be closed before. Since it is
    ! closed out of this subroutine, just turn the Greg global flag to
    ! the correct value, and set "pen update" to true for a later udpate.
    cdashe = idas
    penupd = .true.
  endif
  call setang(o_angl,o_sangl)
  !
end subroutine gr4_bars

subroutine gridder (line,error)
  use gildas_def
  use gbl_format
  use gbl_message
  use sic_types
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>gridder
  use greg_kernel
  use greg_rg
  use greg_xyz
  !---------------------------------------------------------------------
  ! @ private
  ! Support routine for command
  !  RANDOM_MAP Grid_descriptor[S]
  !  1    [/BLANKING Bval]
  !  2    [/NEIGHBOURS N]
  !  3    [/TRIANGLES]
  !  4    [/EXTRAPOLATE]
  !  5    [/VARIABLE]
  !  6    [/SKIP [TRIANGULATION] [INTERPOLATION]]
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line   !
  logical,          intent(inout) :: error  ! Logical error flag
  ! Global
  include 'gbl_memory.inc'
  ! Local
  character(len=*), parameter :: rname='RANDOM_MAP'
  integer(kind=4), parameter :: optblan=1  ! /BLANKING
  integer(kind=4), parameter :: optneig=2  ! /NEIGHBOURS
  integer(kind=4), parameter :: opttria=3  ! /TRIANGLES
  integer(kind=4), parameter :: optextr=4  ! /EXTRAPOLATE
  integer(kind=4), parameter :: optvari=5  ! /VARIABLE
  integer(kind=4), parameter :: optskip=6  ! /SKIP
  integer(kind=4) :: igrad,ncp,mrand,nc,ier,iarg,iskip
  integer(kind=size_length) :: nmin,nmax
  real(kind=4) :: xdmin,xdmax,ydmin,ydmax,blank
  logical :: done,logran(7)
  character(len=80) :: chain
  character(len=20) :: argum,key
  !
  integer(kind=address_length) :: ipx,ipy,ipz
  integer(kind=address_length) :: my_addr_x,my_addr_y,my_addr_z
  integer(kind=4) :: my_nxy,form
  type(sic_descriptor_t), save :: xinca,yinca,zinca
  type(sic_descriptor_t) :: xdesc,ydesc,zdesc
  character(len=varname_length) :: var
  logical :: found,donex,donez
  real(kind=8) :: rxref,rxval,rxinc,ryref,ryval,ryinc
  integer(kind=4) :: nrx,nry
  integer(kind=size_length) :: ndp
  !
  real(kind=4), allocatable, save :: xd(:)
  real(kind=4), allocatable, save :: yd(:)
  real(kind=4), allocatable, save :: zd(:)
  real(kind=4), allocatable, save :: wk(:)
  integer(kind=4), allocatable, save :: iwk(:)
  !
  save xdmin,xdmax,ydmin,ydmax,blank
  save igrad,ncp,ndp
  ! Save
  save logran,mrand
  save ipx,ipy,ipz
  ! Data
  character(len=20), parameter :: rgmap='RGMAP'
  integer(kind=4), parameter :: nskip=2
  character(len=*), parameter :: skip(nskip) = (/ 'TRIANGULATION','INTERPOLATION' /)
  data mrand/0/,logran/7*.false./,igrad/40/,ncp/4/
  !
  ! RANDOM /VARIABLE VarX VarY VarZ
  if (sic_present(optvari,0)) then
    if (sic_narg(optvari).ne.3) then
      chain = '/VARIABLE option requires 3 arguments'
      call greg_message(seve%e,rname,chain)
      error = .true.
      return
    endif
    !
    call sic_ch (line,optvari,1,var,nc,.true.,error)
    found = .true.
    call sic_materialize(var,xdesc,found)
    if (.not.found) then
      chain = 'Unknown variable '//var
      call greg_message(seve%e,rname,chain)
      error = .true.
      return
    endif
    call sic_ch (line,optvari,2,var,nc,.true.,error)
    found = .true.
    call sic_materialize(var,ydesc,found)
    if (.not.found) then
      error = .true.
      chain = 'Unknown variable '//var
      call greg_message(seve%e,rname,chain)
      call sic_volatile(xdesc)   ! It may have been transposed...
      return
    endif
    call sic_ch (line,optvari,3,var,nc,.true.,error)
    found = .true.
    call sic_materialize(var,zdesc,found)
    if (.not.found) then
      error = .true.
      chain = 'Unknown variable '//var
      call greg_message(seve%e,rname,chain)
      call sic_volatile(xdesc)   ! It may have been transposed...
      call sic_volatile(ydesc)   ! It may have been transposed...
      return
    endif
    !
    form = fmt_r8
    call sic_incarnate(form,xdesc,xinca,error)
    call sic_incarnate(form,ydesc,yinca,error)
    call sic_incarnate(form,zdesc,zinca,error)
    !
    if (yinca%size.ne.xinca%size .or. xinca%size.ne.zinca%size) then
      call greg_message(seve%w,rname,'Arrays have different sizes')
    endif
    if (sic_notsamedesc(xdesc,xinca)) call sic_volatile(xdesc)
    if (sic_notsamedesc(ydesc,yinca)) call sic_volatile(ydesc)
    if (sic_notsamedesc(zdesc,zinca)) call sic_volatile(zdesc)
    !
    my_nxy = xinca%size/2
    my_addr_x = xinca%addr
    my_addr_y = yinca%addr
    my_addr_z = zinca%addr
  else
    my_nxy = nxy
    my_addr_x = locwrd(column_x)
    my_addr_y = locwrd(column_y)
    my_addr_z = locwrd(column_z)
  endif
  !
  ! Optimizations (/SKIP). See HELP RANDOM_MAP for details.
  donex = .false.
  donez = .false.
  do iarg=1,sic_narg(optskip)
    call sic_ke(line,optskip,iarg,argum,nc,.true.,error)
    if (error)  return
    call sic_ambigs(rname,argum,key,iskip,skip,nskip,error)
    if (error)  return
    select case (iskip)
    case (1)  ! TRIANGULATION
      donex = .true.
    case (2)  ! INTERPOLATION
      donez = .true.
    end select
  enddo
  !
  ! First copy the X, Y, Z arrays if not already done
  done = donex.and.donez
  if (.not.done .or. ndp.eq.0) then
    !
    ! Check arguments
    if (.not.sic_present(0,1)) then
      call greg_message(seve%e,rname,'Argument(s) required')
      error = .true.
      return
    endif
    if (my_nxy.le.4) then
      call greg_message(seve%e,rname,'Too few data points')
      error = .true.
      return
    endif
    !
    ! Compute Blanking value
    if (eblank.ge.0.) then
      blank = cblank
      call sic_r4 (line,optblan,1,blank,.false.,error)
      if (error) return
    else
      call sic_r4 (line,optblan,1,blank,.true.,error)
      if (error) then
        call greg_message(seve%e,rname,'No blanking value')
        return
      endif
    endif
    write(chain,'(A,1PG13.6)') 'Using blanking value ',blank
    call greg_message(seve%i,rname,chain)
    if (my_nxy.gt.mrand) then
      if (allocated(xd)) then
        deallocate(xd,yd,zd,wk,iwk)
        donex = .false.
        donez = .false.
      endif
      ! NB: size of working buffers is inherited from older code but
      ! is completely obscur! Have to understand how gridran works...
      allocate(xd(my_nxy),yd(my_nxy),zd(my_nxy),  &
               wk(13*my_nxy),iwk(35*my_nxy),stat=ier)
      if (failed_allocate(rname,'XD, YD, ZD, WK, IWK buffers',ier,error))  return
      mrand = my_nxy
    endif
    !
    ipx = gag_pointer(my_addr_x,memory)
    ipy = gag_pointer(my_addr_y,memory)
    ipz = gag_pointer(my_addr_z,memory)
    !
    if (.not.donex) then
      call us8_to_int(memory(ipx),memory(ipy),xd,yd,my_nxy)
      logran(2) = .false.      ! Loaded
      logran(3) = .false.      ! Repeat
    endif
    if (.not.donez) then
      if (my_addr_z.eq.0) then
        call greg_message(seve%e,rname,'No Z data loaded')
        error = .true.
        return
      endif
      call r8tor4(memory(ipz),zd,my_nxy)
      logran(2) = .false.  ! Must reload the values
    endif
    ndp = my_nxy
  endif
  !
  ! Define optional actions
  logran(1) = sic_present(optextr,0)  ! Extrapolate
  logran(6) = .false.                 ! Extrema
  if (sic_present(optneig,0)) then    ! /NEIGHBOURS
    ncp = 4
    call sic_i4 (line,optneig,1,ncp,.false.,error)
    if (error) return
    ncp = min(max(2,ncp),8)
    logran(2) = .false.
    logran(3) = .false.
  else
    ncp = 4
  endif
  logran(5) = sic_present(opttria,0) ! /TRIANGLES
  logran(7) = .false.                ! /VALUES suppressed
  !
  ! Just plot additional values of existing data
  if (logran(2) .and. .not.sic_present(0,1)) then
    ! logran(2) = .true. => Reload not needed
    ! sic_present(0,1) = .false. => No argument i.e. grid not redefined
    call gridset(ncp,blank,logran)
    call gridran(xd,yd,zd,int(ndp,kind=4),wk,iwk,rg%data,drawg,relog,gwrite,error)
    return
  endif
  !
  ! Set the data structure
  call sic_ke (line,0,1,argum,nc,.true.,error)
  if (error) return
  if (argum(1:nc).eq.rgmap(1:nc)) then
    if (rg%status.eq.code_pointer_null) then
      call greg_message(seve%e,rname,'No reference map')
      error = .true.
      return
    endif
    rxinc = rg%xinc*gux
    ryinc = rg%yinc*guy
    rxref = rg%xref
    ryref = rg%yref
    rxval = gx1 + (rg%xval-gux1)*gux
    ryval = gy1 + (rg%yval-guy1)*guy
    logran(2) = .false.
    nrx = rg%nx
    nry = rg%ny
  else
    call sic_i4 (line,0,1,igrad,.true.,error)
    if (error) return
    if (igrad.lt.2) then
      call greg_message(seve%e,rname,'Too few grid points in X or Y')
      error = .true.
      return
    endif
    if (nrx.ne.igrad) logran(2) = .false.
    nrx = igrad
    igrad = nrx
    call sic_i4 (line,0,2,igrad,.false.,error)
    if (error) return
    if (igrad.lt.2) then
      call greg_message(seve%e,rname,'Too few grid points in X or Y')
      error = .true.
      return
    endif
    if (nry.ne.igrad) logran(2) = .false.
    nry = igrad
    call gr4_minmax (ndp,xd,0.0,-1.0,xdmin,xdmax,nmin,nmax)
    call gr4_minmax (ndp,yd,0.0,-1.0,ydmin,ydmax,nmin,nmax)
    rxinc = (xdmax-xdmin)/nrx
    ryinc = (ydmax-ydmin)/nry
    rxref = 0.5d0
    ryref = 0.5d0
    rxval = xdmin
    ryval = ydmin
  endif
  call gridini(nrx,rxref,rxval,rxinc,nry,ryref,ryval,ryinc)
  !
  ! Load Virtual memory for interpolated grid
  if (.not.logran(2)) then
    call reallocate_rgdata(nrx,nry,error)
    if (error)  return
  endif
  !
  ! CALL CONRAN(XD,YD,ZD,NDP,WK,IWK,SARRAY,ERROR)
  !
  call gridset(ncp,blank,logran)
  call gridran(xd,yd,zd,int(ndp,kind=4),wk,iwk,rg%data,drawg,relog,gwrite,error)
  ! Check error code, and abort if set
  if (error) return
  !
  ! Everything OK
  logran(2) = .true.           ! Loaded
  logran(3) = .true.           ! Repeat
  !
  if (axis_xlog) then
    rg%xval = lux + (rxval - gx1)/gux
    call greg_message(seve%w,rname,'X Logarithmic scale converted to linear')
    call greg_message(seve%w,rname,'Use LIMITS /RGDATA to process map')
  else
    rg%xval = gux1 + (rxval - gx1)/gux
  endif
  rg%xref = rxref
  rg%xinc = rxinc/gux
  if (axis_ylog) then
    rg%yval = luy + (ryval - gy1)/guy
    call greg_message(seve%w,rname,'Y Logarithmic scale converted to linear')
    call greg_message(seve%w,rname,'Use LIMITS /RGDATA to process map')
  else
    rg%yval = guy1 + (ryval - gy1)/guy
  endif
  rg%yref = ryref
  rg%yinc = ryinc/guy
end subroutine gridder
!
subroutine drawg(x,y)
  use greg_interfaces, except_this=>drawg
  !---------------------------------------------------------------------
  ! @ private-mandatory (because symbol is used elsewhere)
  !---------------------------------------------------------------------
  real :: x                         !
  real :: y                         !
  call gdraw(y,x)
end subroutine drawg
!
subroutine relog(x,y)
  use greg_interfaces, except_this=>relog
  !---------------------------------------------------------------------
  ! @ private-mandatory (because symbol is used elsewhere)
  !---------------------------------------------------------------------
  real :: x                         !
  real :: y                         !
  call grelocate(y,x)
end subroutine relog

module greg3_def
  use image_def
  !---------------------------------------------------------------------
  ! Variables and parameters for image support in GREG3
  ! For portability, SAVE Fortran variables which are target of SIC
  ! variables.
  !---------------------------------------------------------------------
  !
  ! Subset
  integer(kind=4) :: ixmin(4),ixmax(4)
  integer(kind=4) :: ixdim(4)
  !
  ! Support 'file' for the IMAGE buffer (not strictly the RG buffer...)
  type(gildas), save :: imag
  !
end module greg3_def
!
subroutine greg3_close
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>greg3_close
  use greg3_def
  !---------------------------------------------------------------------
  ! @ private
  ! GREG  -- Support routine for command GREG3\IMAGE [Name]
  !   Close the current image
  !---------------------------------------------------------------------
  ! Global
  include 'gbl_memory.inc'
  !
  integer(kind=address_length) :: zero,ip
  character(len=filename_length) :: file
  logical :: error
  integer :: ier
  !
  if (imag%loca%islo.ne.0) then
    error = .false.
    if (.not.imag%loca%read) then
      call gdf_write_data(imag, imag%r2d, error)
    endif
    call gdf_close_image(imag,error)
    if (associated(imag%r2d)) deallocate (imag%r2d, stat=ier)
    if (associated(imag%d2d)) deallocate (imag%d2d, stat=ier)
    zero = 0
    ip = gag_pointer(zero,memory)
    call gr4_rgive(0,0,imag%gil%convert,memory(ip))
  endif
  file = imag%file
  call gildas_null(imag)
  imag%file = file
end subroutine greg3_close
!
subroutine greg3_image(line,error)
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>greg3_image
  use gildas_def
  use greg3_def
  use gbl_message
  use gbl_format
  use gbl_constant
  !---------------------------------------------------------------------
  ! @ private
  ! GREG  -- Support routine for command
  !  GREG3\IMAGE [Name]
  !  1     [/PLANE I1 I2]
  !  2     [/SUBSET Imin Imax Jmin Jmax]
  !  3     [/WRITE]
  !  4     [/CLOSE]
  !---------------------------------------------------------------------
  character(len=*)                :: line   ! Input command line
  logical,          intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='IMAGE'
  character(len=filename_length) :: name 
  integer(kind=8) :: ipl4,ipl3
  integer :: i,n,nx1,nx2,ny1,ny2,ier
  integer :: nfx,nfy,ninfx,nsupx,ninfy,nsupy
  integer(kind=address_length) :: zero,addr,addrs
  logical :: alloc
  ! Data
  data addr/0/,addrs/0/,zero/0/
  !
  call greg3_variables(error)  ! Should be moved after successful load of the image, isn't it?
  if (error)  return
  !
  if (sic_present(4,0)) then
    ! IMAGE /CLOSE : disconnect current image
    call greg3_close
    call gildas_null(imag)
    return
    !
  elseif (sic_present(0,1)) then
    ! With argument: open new one
    call sic_ch (line,0,1,name,n,.true.,error)
    if (error) return
    !
    ! New image, free previous one
    call greg3_close
    call gildas_null(imag)
    alloc = .true.
    !
    ! Open new one
    imag%file = name(1:n)
    imag%loca%read = .not.sic_present(3,0)
    call gdf_read_header(imag,error)
    if (error) then
      call greg_message(seve%e,rname,'Cannot read input file')
    elseif (imag%gil%form.ne.fmt_r4 .and. imag%gil%form.ne.fmt_r8) then
      call greg_message(seve%e,rname,'Only real images supported')
      call gdf_close_image(imag,error)
      error = .true.
    endif
    if (error) goto 98
    !
    ! Prepare graphic context
    if (imag%gil%proj_words.ne.0 .and. imag%gil%ptyp.ne.p_none) then
      if (imag%gil%xaxi.eq.0.and.imag%gil%yaxi.eq.0) then
        imag%gil%xaxi = 1
        imag%gil%yaxi = 2
      endif
      if (imag%gil%xaxi.eq.1.and.imag%gil%yaxi.eq.2) then
        call greg_projec(imag%gil%ptyp,imag%gil%a0)
      elseif (imag%gil%xaxi.eq.2.and.imag%gil%yaxi.eq.1) then
        call greg_projec(imag%gil%ptyp,imag%gil%a0)
      else
        call greg_projec(p_none,imag%gil%a0)
      endif
    else
      call greg_projec(p_none,imag%gil%a0)
    endif
    if (imag%gil%blan_words.ne.0) then
      call gr8_blanking(dble(imag%gil%bval),dble(imag%gil%eval))
    else
      imag%gil%bval = 0.0
      imag%gil%eval = -1.0
    endif
    if (imag%gil%desc_words.ne.0) then
      if (imag%char%syst.eq.'ICRS') then
        call gr8_system(type_ic,error)
      elseif (imag%char%syst.eq.'EQUATORIAL') then
        call gr8_system(type_eq,error,imag%gil%epoc)
      elseif (imag%char%syst.eq.'GALACTIC') then
        call gr8_system(type_ga,error)
      elseif (imag%char%syst.eq.'HORIZONTAL') then
        call gr8_system(type_ho,error)
      else
        call gr8_system(type_un,error)
      endif
      if (error)  goto 98
    endif
    !
  elseif (sic_present(1,0) .or. sic_present(2,0)) then
    ! No argument, /PLANE or /SUBSET
    ! Old image: use the existing one
    if (imag%loca%islo.eq.0) then
      call greg_message(seve%e,rname,'No image loaded yet')
      error = .true.
      return
    endif
    if (.not.imag%loca%read) then
      call gdf_write_data(imag, imag%r2d, error)
    endif
    alloc = .false.
    !
  else
    ! No argument, no option: list the header
    if (imag%loca%islo.eq.0) then
      call greg_message(seve%e,rname,'No image loaded yet')
      error = .true.
    else
      call gdf_print_header(imag)
    endif
    return
  endif
  !
  imag%blc = 0
  imag%trc = 0
  !
  if (sic_present(1,0)) then
    ! IMAGE /PLANE
    ! Image mode : select one plane only
    if (imag%gil%dim(4).gt.1) then
      call sic_i8 (line,1,2,ipl4,.true.,error)
      if (error) goto 98
      if (ipl4.gt.imag%gil%dim(4) .or. ipl4.lt.1) then
         call greg_message(seve%e,rname,'Slice out of bounds')
         goto 98
      endif
      imag%blc(4) = ipl4
      imag%trc(4) = ipl4
    endif
    if (imag%gil%dim(3).gt.1) then
      call sic_i8 (line,1,1,ipl3,.true.,error)
      if (error) goto 98
      if (ipl3.gt.imag%gil%dim(3) .or. ipl3.lt.1) then
        call greg_message(seve%e,rname,'Slice out of bounds')
        goto 98
      endif
      ixmin(3) = ipl3
      ixmax(3) = ipl3
      imag%blc(3) = ipl3
      imag%trc(3) = ipl3
    endif
  else
    !
    ! 1st (default) plane
    imag%blc(3) = 1
    imag%trc(3) = 1
    imag%blc(4) = 1
    imag%trc(4) = 1
  endif
  !
  ! Subset
  if (sic_present(2,0)) then
    ! IMAGE /SUBSET
    call sic_i4 (line,2,4,ny2,.true.,error)
    if (error) goto 98
    call sic_i4 (line,2,3,ny1,.true.,error)
    if (error) goto 98
    call sic_i4 (line,2,2,nx2,.true.,error)
    if (error) goto 98
    call sic_i4 (line,2,1,nx1,.true.,error)
    if (error) goto 98
    ninfx = min(nx1,nx2)
    ninfy = min(ny1,ny2)
    nsupx = max(nx1,nx2)
    nsupy = max(ny1,ny2)
    if (ninfx.lt.1 .or. nsupx.gt.imag%gil%dim(1) .or.  &
        ninfy.lt.1 .or. nsupy.gt.imag%gil%dim(2)) then
      call greg_message(seve%e,rname,'Subset does not lie in the map')
      goto 98
    endif
    !
    nfx = nsupx-ninfx+1
    nfy = nsupy-ninfy+1
    if (nfx.le.1 .or. nfy.le.1) then
      call greg_message(seve%e,rname,'Image is one-dimensional, not loaded')
      goto 98
    endif
    ixmin (1) = ninfx
    ixmax (1) = nsupx
    ixmin (2) = ninfy
    ixmax (2) = nsupy
  else
    if (imag%gil%dim(1).le.1 .or. imag%gil%dim(2).le.1) then
      call greg_message(seve%e,rname,'Image is one-dimensional, not loaded')
      goto 98
    endif
    ixmin (1) = 1
    ixmax (1) = imag%gil%dim(1)
    ixmin (2) = 1
    ixmax (2) = imag%gil%dim(2)
  endif
  do i=1,4
    ixdim(i) = ixmax(i)-ixmin(i)+1
  enddo
  !
  ! Read only required part
  if (imag%gil%form.eq.fmt_r4) then
    if (alloc)  allocate(imag%r2d(imag%gil%dim(1),imag%gil%dim(2)),stat=ier)
    call gdf_read_data (imag,imag%r2d,error)
  else
    if (alloc)  allocate(imag%d2d(imag%gil%dim(1),imag%gil%dim(2)),stat=ier)
    call gdf_read_data (imag,imag%d2d,error)
  endif
  if (error) then
     call greg3_close 
     error = .true.
     return
  endif
  imag%status = 0
  !
  if (sic_present(2,0)) then
    ! Load subset into GreG
    if (imag%gil%form.eq.fmt_r4) then
      call gr4_rgivesub(imag%gil%dim(1),imag%gil%dim(2),imag%gil%convert, &
           imag%r2d,ninfx,nsupx,ninfy,nsupy)
    else
      call gr8_tgivesub(imag%gil%dim(1),imag%gil%dim(2),imag%gil%convert, &
           imag%d2d,ninfx,nsupx,ninfy,nsupy)
    endif
  else
    ! Full image
    if (imag%gil%form.eq.fmt_r4) then
      call gr4_rgive(imag%gil%dim(1),imag%gil%dim(2),imag%gil%convert,imag%r2d)
    else
      call gr8_tgive(imag%gil%dim(1),imag%gil%dim(2),imag%gil%convert,imag%d2d)
    endif
  endif
  !
  if (imag%gil%extr_words.ne.0) then
    call gr4_egive(imag%gil%rmin,imag%gil%rmax,imag%gil%minloc(1),imag%gil%maxloc(1),  &
    imag%gil%minloc(2),imag%gil%maxloc(2),imag%gil%bval,imag%gil%eval)
  endif
  !
  return
  !
98 continue
   error = .true.
end subroutine greg3_image
!
subroutine greg3_spectrum(line,error)
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>greg3_spectrum
  !---------------------------------------------------------------------
  ! @ private
  ! Support routine for the 2 alternate syntaxes of command
  !     GREG3\SPECTRUM
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line   ! Input command line
  logical,          intent(inout) :: error  ! Logical error flag
  ! Local
  integer(kind=4) :: iopt
  logical :: anyoption
  !
  anyoption = .false.
  do iopt=1,4  ! Command has up to 4 options
    if (sic_present(iopt,0))  anyoption = .true.
  enddo
  !
  if (anyoption) then
    call greg3_spectrum_compute(line,error)
  else
    call greg3_spectrum_extract(line,error)
  endif
  !
end subroutine greg3_spectrum
!
subroutine greg3_spectrum_extract(line,error)
  use gildas_def
  use gbl_format
  use gbl_message
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>greg3_spectrum_extract
  use greg3_def
  !---------------------------------------------------------------------
  ! @ private
  ! GILDAS      Support routine for command
  !     GREG3\SPECTRUM I,J,K
  !---------------------------------------------------------------------
  character(len=*) :: line          ! Input command line
  logical :: error                  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='SPECTRUM'
  integer :: i,ier
  integer(kind=index_length) :: j, save_blc(gdf_maxdims), save_trc(gdf_maxdims)
  integer :: islice(4)
  real(8), allocatable :: xarray(:)
  !
  ! Note: this is one of the few places where we may access (temporarily)
  ! two Memory Slots on a single Image Slot.  Accordingly, the %loca%mslo
  ! %loca%addr variables MUST be restored to their previous values...
  !
  if (imag%loca%islo.eq.0) then
    call greg_message(seve%e,rname,'No image loaded')
    error = .true.
    return
  endif
  !
  islice = 0
  do i=4,2,-1
    if (imag%gil%dim(i).gt.1) then
      call sic_i4 (line,0,i-1,islice(i),.true.,error)
      if (error) return
      if (islice(i).gt.imag%gil%dim(i) .or. islice(i).lt.1) then
        call greg_message(seve%e,rname,'Spectrum out of bounds')
        error = .true.
      endif
    endif
  enddo
  !
  save_blc = imag%blc
  save_trc = imag%trc
  imag%blc(1:4) = islice
  imag%trc(1:4) = islice
  if (imag%gil%form.eq.fmt_r4) then
    allocate (imag%r1d(imag%gil%dim(1)), stat=ier)
    call gdf_read_data (imag,imag%r1d,error)
    if (.not.error) call gr4_give('Y',imag%gil%dim(1),imag%r1d)
    deallocate(imag%r1d, stat=ier)
  elseif (imag%gil%form.eq.fmt_r8) then
    allocate (imag%d1d(imag%gil%dim(1)), stat=ier)
    call gdf_read_data (imag,imag%d1d,error)
    if (.not.error) call gr8_give('Y',imag%gil%dim(1),imag%r1d)
    deallocate(imag%d1d, stat=ier)
  else
    error = .true.
  endif
  imag%blc = save_blc 
  imag%trc = save_trc
  if (error) return
  !
  allocate(xarray(imag%gil%dim(1)),stat=ier)
  if (ier.ne.0) then
     error = .true.
     return
  endif
  do j=1,imag%gil%dim(1)
     xarray(j) = imag%gil%convert(2,1) + (j-imag%gil%convert(1,1))*imag%gil%convert(3,1)
  enddo
  call gr8_give('X',imag%gil%dim(1),xarray)
  deallocate(xarray)
end subroutine greg3_spectrum_extract
!
subroutine greg3_kill(line,error)
  use gildas_def
  use gbl_message
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>greg3_kill
  use greg3_def
  use greg_rg
  !---------------------------------------------------------------------
  ! @ private
  !  Support routine for command
  !   GRGE3\KILL
  !  Call the cursor, and display the map value or kill the pixel
  ! depending on the cursor code
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line   !
  logical,          intent(inout) :: error  !
  ! Local
  character(len=*), parameter :: rname='KILL'
  integer :: nc,pixel(2)
  character(len=1) :: code
  real(8) :: xu,yu
  real(4) :: xp,yp
  !
  if (imag%loca%islo.eq.0 .or. imag%loca%mslo.eq.0) then
     call greg_message(seve%e,rname,'No image loaded')
     error = .true.
  elseif (imag%loca%read) then
     call greg_message(seve%e,rname,'Image is mapped in ReadOnly')
     error = .true.
  else
     error = .false.
  endif
  if (error) return
  !
  if (sic_present(0,1)) then
    call sic_ke (line,0,1,code,nc,.true.,error)
    if (error) return
    call sic_i4 (line,0,2,pixel(1),.true.,error)
    if (error) return
    call sic_i4 (line,0,3,pixel(2),.true.,error)
    if (error) return
    ! The data was "rgiven" to the RG buffer: work on rg%data
    call killr(rg%data,pixel,code)
  elseif (.not.gtg_curs()) then
    call greg_message(seve%e,rname,'No cursor available')
    error = .true.
  else
    do while (.true.)
      call gr_curs(xu,yu,xp,yp,code)
      if (code.eq.'E') return
      pixel(1) = nint((xu-imag%gil%convert(2,1))/imag%gil%convert(3,1)  &
                 + imag%gil%convert(1,1) )
      pixel(2) = nint((yu-imag%gil%convert(2,2))/imag%gil%convert(3,2)  &
                 + imag%gil%convert(1,2) )
      ! The data was "rgiven" to the RG buffer: work on rg%data
      call killr(rg%data,pixel,code)
    enddo
  endif
  !
end subroutine greg3_kill
!
subroutine killr(xarray,pixel,code)
  use gbl_message
  use greg_interfaces, except_this=>killr
  use greg3_def
  !---------------------------------------------------------------------
  ! @ private
  !  Support routine for command
  !    GREG3\KILL
  !  Display the map value or kill the pixel depending on the cursor
  ! code.
  !---------------------------------------------------------------------
  real(kind=4),     intent(inout) :: xarray(:,:)  ! Current map
  integer(kind=4),  intent(in)    :: pixel(2)     ! Pixel coordinate
  character(len=*), intent(in)    :: code         ! Code for operation
  ! Local
  real(kind=4) :: rk
  integer(kind=4) :: i,j,k,l
  !
  i = pixel(1)
  j = pixel(2)
  if (i.ge.ixmin(1) .and. i.le.ixmax(1) .and.  &
      j.ge.ixmin(2) .and. j.le.ixmax(2)) then
    k = i-ixmin(1)+1
    l = j-ixmin(2)+1
    if (code.eq.'K') then
      xarray(k,l) = imag%gil%bval
    elseif (code.eq.'V') then
      write(6,100) i,j,xarray(k,l)
    elseif (code.eq.'I') then
      rk = 0.0
      write(6,100) i,j,xarray(k,l)
      xarray(k,l) = 0.0
      if (k.gt.1) then
        if (abs(xarray(k-1,l)-imag%gil%bval).gt.imag%gil%eval) then
          xarray(k,l) = xarray(k,l)+xarray(k-1,l)
          rk = rk+1.0
        endif
      endif
      if (k.lt.ixdim(1)) then
        if (abs(xarray(k+1,l)-imag%gil%bval).gt.imag%gil%eval) then
          xarray(k,l) = xarray(k,l)+xarray(k+1,l)
          rk = rk+1.0
        endif
      endif
      if (l.gt.1) then
        if (abs(xarray(k,l-1)-imag%gil%bval).gt.imag%gil%eval) then
          xarray(k,l) = xarray(k,l)+xarray(k,l-1)
          rk = rk+1.0
        endif
      endif
      if (l.lt.ixdim(2)) then
        if (abs(xarray(k,l+1)-imag%gil%bval).gt.imag%gil%eval) then
          xarray(k,l) = xarray(k,l)+xarray(k,l+1)
          rk = rk+1.0
        endif
      endif
      if (rk.gt.0.0) then
        xarray(k,l) = xarray(k,l)/rk
        write(6,100) i,j,xarray(k,l)
      else
        call greg_message(seve%w,'KILL','All neighbours blanked')
      endif
    endif
  endif
100 format(' Pixel (',i6,',',i6,')  Value = ',1pg13.6)
end subroutine killr
!
subroutine run_greg3(line,comm,error)
  use gbl_message
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>run_greg3
  !---------------------------------------------------------------------
  ! @ public-mandatory (public but should not) (mandatory because symbol
  ! is used elsewhere)
  ! This entry is for 3-D analysis
  !---------------------------------------------------------------------
  character(len=*), intent(in)  :: line   !
  character(len=*), intent(in)  :: comm   !
  logical,          intent(out) :: error  !
  ! Local
  character(len=*), parameter :: rname='GREG3'
  integer(kind=4), save :: icall=0
  !
  error = .false.
  !
  if (icall.ne.0)  &
    call greg_message(seve%d,rname,'Reentrant call to RUN_GREG3 '//comm)
  icall = icall+1
  !
  call greg_message(seve%c,rname,line)
  !
  error = .false.
  select case (comm)
  case('IMAGE')
    call greg3_image(line,error)
  case('KILL')
    call greg3_kill(line,error)
  case('SPECTRUM')
    call greg3_spectrum(line,error)
  case default
    call greg_message(seve%e,rname,'No code to execute for '//comm)
    error = .true.
  end select
  !
  icall = icall-1
end subroutine run_greg3
!
subroutine greg3_variables(error)
  use gbl_message
  use sic_types
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>greg3_variables
  use greg3_def
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  logical, intent(inout) :: error  ! Logical error flag
  ! Local
  logical :: readonly
  type(sic_identifier_t) :: var
  logical, save :: first=.true.
  !
  if (.not.first)  return
  !
  call greg_message(seve%w,'GREG3','Defining GREG3 variables')
  call gildas_null(imag)
  !
  var%name = 'G'
  var%lname = 1
  var%level = 0
  readonly = .false.
  ! Use a nasty trick to call (without check) directly the SIC inner routine
  ! to use _ instead of % as the separator...
  call sub_def_header(var,'_',imag,readonly,0,error)
  if (error)  return
  !
  ! Keep old (obsolete) names (SB, 08-mar-2013)
  call sic_def_char('G_COORD',imag%char%syst,.false.,error)
  call sic_def_inte('G_PTYP',imag%gil%ptyp,0,0,.false.,error)
  call sic_def_inte('G_XAXI',imag%gil%xaxi,0,0,.false.,error)
  call sic_def_inte('G_YAXI',imag%gil%yaxi,0,0,.false.,error)
  !
  first = .false.
  !
end subroutine greg3_variables

module greg_interfaces_private
  interface
    subroutine greg_arrow(line,error)
      use sic_types
      !---------------------------------------------------------------------
      ! @ private
      ! Support file for command
      !   G\ARROW Xref Yref Length Angle [Reference]
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: line
      logical,          intent(inout) :: error
    end subroutine greg_arrow
  end interface
  !
  interface
    subroutine greg_arrow_desc(xdesc,ydesc,ldesc,adesc,reference,error)
      use sic_types
      !---------------------------------------------------------------------
      ! @ private
      ! Incarnate the arguments as R*4
      !---------------------------------------------------------------------
      type(sic_descriptor_t), intent(in)    :: xdesc
      type(sic_descriptor_t), intent(in)    :: ydesc
      type(sic_descriptor_t), intent(in)    :: ldesc
      type(sic_descriptor_t), intent(in)    :: adesc
      real(kind=4),           intent(in)    :: reference
      logical,                intent(inout) :: error
    end subroutine greg_arrow_desc
  end interface
  !
  interface
    subroutine greg_arrow_do(xdesc,ydesc,ldesc,adesc,reference,error)
      use gbl_message
      use sic_types
      !---------------------------------------------------------------------
      ! @ private
      ! Incarnate the arguments as R*4
      !---------------------------------------------------------------------
      type(sic_descriptor_t), intent(in)    :: xdesc
      type(sic_descriptor_t), intent(in)    :: ydesc
      type(sic_descriptor_t), intent(in)    :: ldesc
      type(sic_descriptor_t), intent(in)    :: adesc
      real(kind=4),           intent(in)    :: reference
      logical,                intent(inout) :: error
    end subroutine greg_arrow_do
  end interface
  !
  interface
    subroutine greg_axis(line,error)
      use gbl_message
      use greg_axes
      use greg_kernel
      use greg_pen
      use greg_types
      use greg_wcs
      !---------------------------------------------------------------------
      ! @ private
      ! GREG Support routines for commands
      !   AXIS  XLow|XUp|YLeft|YRight [A1 A2]
      ! 1       /TICK ICLOCK SMALL BIG
      ! 2       /LABEL POSITION [FORMAT]
      ! 3       /LOCATION   X Y LENGTH
      ! 4-5     /[NO]LOGARITHM
      ! 6       /ABSOLUTE
      ! 7       /UNIT Angle
      ! 8-9     /[NO]BRIEF
      ! --- to be implemented ---
      !                       /WINDOW AMIN AMAX
      !   TICKSPACE  [X SMALL BIG]  [Y SMALL BIG]
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: line   ! Command line
      logical,          intent(inout) :: error  ! Logical error flag
    end subroutine greg_axis
  end interface
  !
  interface
    subroutine greg_rule(line,error)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ private
      ! GREG Support for command RULE
      !  RULE [X] [Y] [/MAJOR] [/MINOR]
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: line   !
      logical,          intent(inout) :: error  !
    end subroutine greg_rule
  end interface
  !
  interface
    subroutine rulexy(major,ixy,error)
      use phys_const
      use greg_axes
      use greg_kernel
      use greg_types
      use greg_wcs
      !---------------------------------------------------------------------
      ! @ private
      ! GREG Support routine for command
      !  RULE [X] [Y] [/MAJOR] [/MINOR]
      ! Arguments :
      !  IXY    For ruling X or Y ticks
      !    1 Rule X ticks
      !    2 Rule Y ticks
      !    3 Rule both X and Y ticks
      !---------------------------------------------------------------------
      logical,         intent(in)    :: major  ! T for lines at labelled ticks, F for all ticks
      integer(kind=4), intent(in)    :: ixy    ! For ruling X or Y ticks (1:X, 2:Y, 3:both)
      logical,         intent(inout) :: error  ! Logical flag
    end subroutine rulexy
  end interface
  !
  interface
    subroutine plot_axis(a1,a2,small,big,ax,ay,alen,axis,error)
      use greg_kernel
      use greg_types
      !---------------------------------------------------------------------
      ! @ private
      !  Plot an axis: line+ticks and/or tick labels
      !---------------------------------------------------------------------
      real(kind=8), intent(in)    :: a1     ! User coordinate value at start point of axis
      real(kind=8), intent(in)    :: a2     ! User coordinate value at end point of axis
      real(kind=8), intent(in)    :: small  ! Minor tick space
      real(kind=8), intent(in)    :: big    ! Major (labelled) tick space
      real(kind=4), intent(in)    :: ax     ! Page coordinates of start point of axis
      real(kind=4), intent(in)    :: ay     ! Page coordinates of start point of axis
      real(kind=4), intent(in)    :: alen   ! Length of axis
      type(axis_t), intent(inout) :: axis   ! Parameters for labels and ticks
      logical,      intent(inout) :: error  ! Error flag
    end subroutine plot_axis
  end interface
  !
  interface
    subroutine plot_at_tick(a1,a2,small,big,ax,ay,alen,axis,func,error)
      use gbl_message
      use greg_kernel
      use greg_types
      !---------------------------------------------------------------------
      ! @ private
      !  Execute the input function at each tick position
      !---------------------------------------------------------------------
      real(kind=8), intent(in)    :: a1     ! User coordinate value at start point of axis
      real(kind=8), intent(in)    :: a2     ! User coordinate value at end point of axis
      real(kind=8), intent(in)    :: small  ! Minor tick space
      real(kind=8), intent(in)    :: big    ! Major (labelled) tick space
      real(kind=4), intent(in)    :: ax     ! Page X coordinates of start point of axis
      real(kind=4), intent(in)    :: ay     ! Page Y coordinates of start point of axis
      real(kind=4), intent(in)    :: alen   ! Length of axis
      type(axis_t), intent(inout) :: axis   ! Parameters for labels and ticks
      external                    :: func   ! Tick drawing function
      logical,      intent(inout) :: error  ! Logical flag
    end subroutine plot_at_tick
  end interface
  !
  interface
    subroutine plot_tickmark(tick,axis)
      use greg_kernel
      use greg_types
      !---------------------------------------------------------------------
      ! @ private-mandatory (because symbol is used elsewhere)
      !  Plot one tick mark
      !---------------------------------------------------------------------
      type(tick_t), intent(in) :: tick    ! Tick description
      type(axis_t), intent(in) :: axis     ! Axis description
    end subroutine plot_tickmark
  end interface
  !
  interface
    subroutine plot_ticklabel(tick,axis)
      use phys_const
      use greg_kernel
      use greg_types
      !---------------------------------------------------------------------
      ! @ private-mandatory (because symbol is used elsewhere)
      !  Plot one tick label
      !---------------------------------------------------------------------
      type(tick_t), intent(in) :: tick  ! Tick description
      type(axis_t), intent(in) :: axis  ! Axis description
    end subroutine plot_ticklabel
  end interface
  !
  interface
    subroutine plot_rulexy(tick,axis)
      use greg_types
      !---------------------------------------------------------------------
      ! @ private-mandatory (because symbol is used elsewhere)
      !  Used by command RULE for gridding the plot page
      !---------------------------------------------------------------------
      type(tick_t), intent(in) :: tick  ! Tick description
      type(axis_t), intent(in) :: axis  ! Axis description
    end subroutine plot_rulexy
  end interface
  !
  interface
    subroutine greg_tickspace(line,error)
      use greg_axes
      use gbl_message
      !---------------------------------------------------------------------
      ! @ private
      ! GREG  Support routine for command
      !  TICKSPACE SMALLX BIGX SMALLY BIGY
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: line   ! Command line
      logical,          intent(inout) :: error  ! Logical error flag
    end subroutine greg_tickspace
  end interface
  !
  interface
    subroutine tick_offset(sexage,v1,v2,brief,o)
      use gbl_message
      use greg_kernel
      use greg_types
      !---------------------------------------------------------------------
      ! @ private
      ! Custom rounding function. Takes 2 floats as input and return
      ! the most common value.
      ! - Example 1: d1=111259. and d2=111335.
      !    We want to return 111000. There is trap here: dx<100 but we have
      !    to round to the 1000s.
      ! - Example 2: d1=123456. and d2=3.
      !    We want to return 0.
      ! - Example 3: d1=123456. and d2=-120000.
      !    We want to return 0.
      ! - Example 4: d1=123456.789 and d2=d1
      !    We want to return d1
      !---------------------------------------------------------------------
      logical,      intent(in)  :: sexage  ! Sexagesimal notation?
      real(kind=8), intent(in)  :: v1,v2   !
      logical,      intent(out) :: brief   !
      real(kind=8), intent(out) :: o       !
    end subroutine tick_offset
  end interface
  !
  interface
    subroutine bars(line,error)
      use gildas_def
      use sic_types
      use greg_kernel
      use greg_xyz
      use gbl_message
      use gbl_format
      !---------------------------------------------------------------------
      ! @ private
      ! GREG	Support routine for command
      !	ERRORBAR [+X] [X] [-X] [+Y] [Y] [-Y] [[+/-]O] [X_var Y_var Z_var]
      !	Draw error bars at data point location. The error bar size is
      !	defined by array Z value.
      !---------------------------------------------------------------------
      character(len=*)               :: line   ! Input command line
      logical,         intent(inout) :: error  ! Logical error flag
    end subroutine bars
  end interface
  !
  interface
    subroutine greg_box(line,error)
      use gildas_def
      use phys_const
      use gbl_message
      use greg_axes
      use greg_kernel
      use greg_pen
      use greg_types
      use greg_wcs
      !---------------------------------------------------------------------
      ! @ private
      ! GREG Support routine for command
      !   BOX [Parallel [Orthogonal [In]]]  [/ABSOLUTE]
      !       [Orthogonal [Parallel [Out]]] [/UNIT Angle]
      !       [None [None [None]]]
      !                                     [/LABEL Pen]
      !                                     [/FILL Color]
      !                                     [/BRIEF [X|Y]]
      !                                     [/NOBRIEF [X|Y]]
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: line   ! Command line
      logical,          intent(inout) :: error  ! Logical error flag
    end subroutine greg_box
  end interface
  !
  interface
    subroutine greg_box_brief(line,axis,error)
      use gbl_message
      use greg_types
      !---------------------------------------------------------------------
      ! @ private
      ! Support routine for command
      !   G\BOX /BRIEF|NOBRIEF [X|Y]
      ! Parse the command line options /BRIEF and /NOBRIEF. They are
      ! compatible as long as the same axis is not used twice, like e.g.
      ! in /BRIEF X /NOBRIEF Y
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: line     ! Command line
      type(axis_t),     intent(inout) :: axis(4)  ! Axes parameters
      logical,          intent(inout) :: error    ! Logical error flag
    end subroutine greg_box_brief
  end interface
  !
  interface
    subroutine defdel_xyz(action,i,error)
      use gbl_message
      use sic_types
      use greg_xyz
      !---------------------------------------------------------------------
      ! @ private
      !  Define or delete one of the X, Y, or Z Greg variables. An error is
      ! raised if the variable already exists and was not created by Greg.
      !---------------------------------------------------------------------
      integer(kind=4), intent(in)    :: action  ! 0=check, 1=define, 2=delete
      integer(kind=4), intent(in)    :: i       ! 1=X, 2=Y, 3=Z
      logical,         intent(inout) :: error   ! Logical error flag
    end subroutine defdel_xyz
  end interface
  !
  interface
    subroutine delete_xyz(delv,error)
      use gildas_def
      use greg_xyz
      !---------------------------------------------------------------------
      ! @ private
      ! Delete the SIC variables named X, Y and Z
      !---------------------------------------------------------------------
      logical, intent(in)    :: delv
      logical, intent(inout) :: error
    end subroutine delete_xyz
  end interface
  !
  interface
    subroutine create_xyz(error)
      use greg_xyz
      !---------------------------------------------------------------------
      ! @ private
      !  Create the SIC variables named X, Y and Z, if they are not yet
      ! defined. If yes, they are assumed to point to the correct memory
      ! object (checked in delete_xyz).
      !---------------------------------------------------------------------
      logical, intent(inout) :: error
    end subroutine create_xyz
  end interface
  !
  interface
    subroutine more_xyz(n,error)
      use gildas_def
      use gbl_message
      use greg_xyz
      !---------------------------------------------------------------------
      ! @ private
      ! Re-allocate more buffer space for the internal X, Y and Z buffers
      !---------------------------------------------------------------------
      integer(kind=4), intent(in)    :: n      !
      logical,         intent(inout) :: error  ! Logical error flag
    end subroutine more_xyz
  end interface
  !
  interface
    subroutine column(line,error)
      use gildas_def
      use image_def
      use greg_xyz
      use greg_image
      use gbl_message
      use gbl_format
      !---------------------------------------------------------------------
      ! @ private
      ! GREG  Support routine for command
      !       COLUMN [X nx] [Y ny] [Z nz]
      !  1           [/FILE Filename]
      !  2           [/LINE L1 L2]
      !  3           [/TABLE Tablename]
      !  4           [/COMMENT "Separator"]
      !  5           [/CLOSE]
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: line   ! Command line
      logical,          intent(inout) :: error  ! Error flag
    end subroutine column
  end interface
  !
  interface
    subroutine readcol(ncx,arrx,ncy,arry,ncz,arrz,nxy,mxy,error,icode,com)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ private
      !   Read up to 3 columns in the input file. Uses list-directed format
      ! but avoid comment lines beginning with a comment character (default
      ! "!", but user selectable).
      !---------------------------------------------------------------------
      integer(kind=4),  intent(in)    :: ncx      ! Column number of X values
      real(kind=8),     intent(out)   :: arrx(*)  ! X array of values
      integer(kind=4),  intent(in)    :: ncy      ! Column number of Y values
      real(kind=8),     intent(out)   :: arry(*)  ! Y array of values
      integer(kind=4),  intent(in)    :: ncz      ! Column number of Z values
      real(kind=8),     intent(out)   :: arrz(*)  ! Z array of values
      integer(kind=4),  intent(out)   :: nxy      ! Number of values read
      integer(kind=4),  intent(in)    :: mxy      ! Maximum number of values
      logical,          intent(inout) :: error    ! Logical error flag
      integer(kind=4),  intent(out)   :: icode    ! Return code
      character(len=1), intent(in)    :: com      ! Comment character
    end subroutine readcol
  end interface
  !
  interface
    subroutine gwrite(val,x,y)
      use greg_kernel
      !---------------------------------------------------------------------
      ! @ private-mandatory (because symbol is used elsewhere)
      ! GREG	Internal routine
      !	This subroutine writes the value VAL at location X,Y in User
      ! 	Coordinates. VAL is encoded in shortest format.
      ! Arguments :
      !	VAL	R*4	Value to be encoded
      !	X	R*4	X coordinate
      !	Y	R*4	Y coordinate
      !---------------------------------------------------------------------
      real*4 :: val                     !
      real*4 :: x                       !
      real*4 :: y                       !
    end subroutine gwrite
  end interface
  !
  interface
    subroutine conecd (arg,string,ns)
      !---------------------------------------------------------------------
      ! @ private
      ! GREG	Internal routine
      !	Encode the ARG value in the string STRING in the shortest
      !	possible format
      ! Arguments :
      !	ARG	R*4	Value to be encoded
      !	STRING	C*(*)	String to receive the coded value
      !	NS	I	Length of string
      ! Subroutines :
      !	(SIC)
      !---------------------------------------------------------------------
      real :: arg                       !
      character(len=*) :: string        !
      integer :: ns                     !
    end subroutine conecd
  end interface
  !
  interface
    subroutine gconne(line,error)
      use gildas_def
      use sic_types
      use greg_kernel
      use greg_xyz
      use gbl_format
      !---------------------------------------------------------------------
      ! @ private
      ! GREG Support routine for command
      !   CONNECT/BLANKING Bval Eval
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: line   ! Command line
      logical,          intent(inout) :: error  ! Logical error flag
    end subroutine gconne
  end interface
  !
  interface
    subroutine get_incarnation(command,line,form,ixy,xinca,yinca,error)
      use gildas_def
      use sic_types
      use greg_xyz
      use gbl_message
      use gbl_format
      !---------------------------------------------------------------------
      ! @ private
      ! GreG Internal routine
      !   Get incarnation of variables in command line, defaulting to X Y
      ! Warning: this routine may be called with more than 3 arguments on
      ! the command line (see RGDATA command).
      !---------------------------------------------------------------------
      character(len=*),          intent(in)    :: command  !
      character(len=*),          intent(in)    :: line     !
      integer(kind=4),           intent(inout) :: form     !
      integer(kind=size_length), intent(out)   :: ixy      !
      type(sic_descriptor_t),    intent(out)   :: xinca    !
      type(sic_descriptor_t),    intent(out)   :: yinca    !
      logical,                   intent(inout) :: error    !
    end subroutine get_incarnation
  end interface
  !
  interface
    subroutine conmap(line,error)
      use gbl_message
      use gildas_def
      use greg_contours
      use greg_kernel
      use greg_pen
      use greg_rg
      !---------------------------------------------------------------------
      ! @ private
      !  Support routine for command
      !     RGMAP
      !   1     /ABSOLUTE aval
      !   2     /PERCENT  pval
      !   3     /KEEP filename [blank]
      !   4     /BLANKING bval Eval
      !   5     /GREY First nstep
      !   6     /PENS pos neg
      !   7     /ONLY Positive|Negative 
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: line   ! Command line
      logical,          intent(inout) :: error  ! Logical error flag
    end subroutine conmap
  end interface
  !
  interface
    subroutine ext001(a,nx,ny,b,kx,ky,minx,maxx,miny,maxy)
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      integer(kind=4), intent(in) :: nx        !
      integer(kind=4), intent(in) :: ny        !
      real(kind=4),    intent(in) :: a(nx,ny)  !
      integer(kind=4), intent(in) :: kx        !
      integer(kind=4), intent(in) :: ky        !
      real(kind=4)                :: b(kx,ky)  ! inout?
      integer(kind=4), intent(in) :: minx      !
      integer(kind=4), intent(in) :: maxx      !
      integer(kind=4), intent(in) :: miny      !
      integer(kind=4), intent(in) :: maxy      !
    end subroutine ext001
  end interface
  !
  interface
    subroutine frstd (icode,error)
      use gbl_message
      use greg_contours
      use greg_kernel
      !---------------------------------------------------------------------
      ! @ private-mandatory (because symbol is used elsewhere)
      !  For each contour level, puts (X,Y) Coordinates of contour into
      ! arrays XU,YU. Then plots the contour line using CONNECT
      !  Take care of grey scale contouring on SECAPA.
      !---------------------------------------------------------------------
      integer(kind=4), intent(in)    :: icode  !
      logical,         intent(inout) :: error  !
    end subroutine frstd
  end interface
  !
  interface
    subroutine vectd(x,y,error)
      use greg_contours
      use greg_kernel
      use greg_rg
      !---------------------------------------------------------------------
      ! @ private-mandatory (because symbol is used elsewhere)
      !  For each contour level, puts (X,Y) Coordinates of contour into
      ! arrays XU,YU. Then plots the contour line using CONNECT
      !  Middle of contour line; Convert to user coordinates
      !  Return if still some place left in buffer
      !---------------------------------------------------------------------
      real(kind=4), intent(in)    :: x      !
      real(kind=4), intent(in)    :: y      !
      logical,      intent(inout) :: error  !
    end subroutine vectd
  end interface
  !
  interface
    subroutine lastd(error)
      use gildas_def
      use greg_contours
      use greg_kernel
      !---------------------------------------------------------------------
      ! @ private-mandatory (because symbol is used elsewhere)
      !  End of contour line; Plots the contour line using CONNECT.
      !---------------------------------------------------------------------
      logical, intent(inout) :: error  !
    end subroutine lastd
  end interface
  !
  interface
    subroutine contd(error)
      use greg_contours
      !---------------------------------------------------------------------
      ! @ private-mandatory (because symbol is used elsewhere)
      !  End of contour line; Show it
      !---------------------------------------------------------------------
      logical, intent(inout) :: error  !
    end subroutine contd
  end interface
  !
  interface
    subroutine frstg(icode,error)
      use gildas_def
      use gbl_message
      use greg_contours
      use greg_kernel
      !---------------------------------------------------------------------
      ! @ private-mandatory (because symbol is used elsewhere)
      !   For each contour level, puts (X,Y) Coordinates of contour into
      ! arrays XU,YU. For Grey-scale.
      !   Call INIT_TREE to reset the filling capability
      !---------------------------------------------------------------------
      integer(kind=4)                :: icode  ! Unused
      logical,         intent(inout) :: error  !
    end subroutine frstg
  end interface
  !
  interface
    subroutine vectg(x,y,error)
      use gildas_def
      use gbl_message
      use greg_contours
      !---------------------------------------------------------------------
      ! @ private-mandatory (because symbol is used elsewhere)
      !  Middle of contour line; Convert to user coordinates.
      !  We should also clip here... If clipping applies, then a pseudo-end
      ! of contour appears
      !---------------------------------------------------------------------
      real(kind=4), intent(in) :: x      !
      real(kind=4), intent(in) :: y      !
      logical                  :: error  !
    end subroutine vectg
  end interface
  !
  interface
    subroutine lastg(error)
      use gildas_def
      use greg_contours
      !---------------------------------------------------------------------
      ! @ private-mandatory (because symbol is used elsewhere)
      !  End of contour line; Plots the contour line using FILL_VECT (to
      ! put a vector) and FILL_CONT (to end a contour)
      !---------------------------------------------------------------------
      logical, intent(inout) :: error
    end subroutine lastg
  end interface
  !
  interface
    subroutine contg(error)
      use gildas_def
      use greg_contours
      !---------------------------------------------------------------------
      ! @ private-mandatory (because symbol is used elsewhere)
      ! End of contour line; Show it using FLUSH_TREE
      !---------------------------------------------------------------------
      logical, intent(inout) :: error  !
    end subroutine contg
  end interface
  !
  interface
    subroutine press_ctrlc(error)
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      logical, intent(inout) :: error  !
    end subroutine press_ctrlc
  end interface
  !
  interface
    subroutine grisclip(x,y,c)
      use greg_contours
      !---------------------------------------------------------------------
      ! @ private
      !  Support routine for the clipping algorithm ; called from DRAW and
      ! GRPOLY only. C is a 4 bit code indicating the relationship between
      ! point (X,Y) and the window boundaries ; 0 implies the point is
      ! within the window.
      !---------------------------------------------------------------------
      integer(kind=4), intent(in)  :: x  ! Position of point
      integer(kind=4), intent(in)  :: y  ! Position of point
      integer(kind=4), intent(out) :: c  ! Code
    end subroutine grisclip
  end interface
  !
  interface
    subroutine greg_corners(line,error)
      !---------------------------------------------------------------------
      ! @ private
      ! Support routine for command
      !   CORNERS
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: line   ! Input command line
      logical,          intent(inout) :: error  ! Logical error flag
    end subroutine greg_corners
  end interface
  !
  interface
    subroutine curse(line,error)
      use gildas_def
      use phys_const
      use gbl_format
      use gbl_message
      use sic_types
      use greg_kernel
      use greg_pen
      use greg_rg
      use greg_wcs
      !---------------------------------------------------------------------
      ! @ private
      ! GREG	Support routine for command
      !	DRAW	Code
      !		LINE	[X Y]	[/USER]	[/BOX]	[/CHARACTER] [/CLIP]
      !		MARKER
      !		ARROW
      !		TEXT	[X Y "texte a ecrire" [Center [Orientation]]]
      !		VALUE
      ! Uses the interactive cursor to perform various functions.
      !	The cursor routine of GREG is GR_CURS
      ! Arguments :
      !	LINE	C*(*)	Command line		Input
      !	ERROR	L	Logical error flag	Output
      !
      ! Force the line style to solid for the end of an arrow	PV, 17-jul-87
      !---------------------------------------------------------------------
      character(len=*) :: line          !
      logical :: error                  !
    end subroutine curse
  end interface
  !
  interface
    subroutine draw_parse_coordmode(line,kbox,ibox,error)
      use gbl_message
      use greg_kernel
      use greg_wcs
      !---------------------------------------------------------------------
      ! @ private
      ! Parse command line to retrieve the coordinates conversion mode, i.e.
      ! how the input coordinates have to be understood
      !
      !  kbox < 0: user coordinates
      !  kbox = 0: physical coordinates from box "corner"
      !  kbox = 1: character coordinates from box "corner"
      !
      !  ibox = -1   irrelevant
      !  ibox = 1-9  the box "corner" to be used if relevant
      !  ibox = 0    automatic corner choice if cursor mode, corner 1 otherwise
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: line
      integer(kind=4),  intent(out)   :: kbox
      integer(kind=4),  intent(out)   :: ibox
      logical,          intent(inout) :: error
    end subroutine draw_parse_coordmode
  end interface
  !
  interface
    subroutine draw_setcursor_relative(ckind,v,kbox,ibox,error)
      use phys_const
      use gbl_message
      use greg_kernel
      !---------------------------------------------------------------------
      ! @ private
      ! Set the current cursor position (user and physical) according to
      ! relative coordinate 'v' and system of coordinates (kbox,ibox)
      !
      !  kbox < 0: user coordinates
      !  kbox = 0: physical coordinates from box "corner"
      !  kbox = 1: character coordinates from box "corner"
      !  kbox = 2: absolute physical coordinates on page
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: ckind  ! Coordinate kind ('X' or 'Y')
      real(kind=8),     intent(in)    :: v
      integer(kind=4),  intent(in)    :: kbox,ibox
      logical,          intent(inout) :: error
    end subroutine draw_setcursor_relative
  end interface
  !
  interface
    subroutine draw_setcursor_absolute(xc,yc,kbox,error)
      use phys_const
      use gbl_message
      use greg_wcs
      !---------------------------------------------------------------------
      ! @ private
      ! Set the current cursor position (user and physical) according to
      ! absolute coordinates (xc,yc) and system of coordinates (kbox)
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: xc,yc  ! Sexagesimal absolute coordinates
      integer(kind=4),  intent(in)    :: kbox   !
      logical,          intent(inout) :: error  !
    end subroutine draw_setcursor_absolute
  end interface
  !
  interface
    subroutine arrow(xa,ya)
      use gildas_def
      use phys_const
      use greg_kernel
      use greg_pen
      !---------------------------------------------------------------------
      ! @ private
      ! GREG	Internal routine
      !	Draws an arrow from current pen position to (XA,YA) (User)
      !	Entry GARROW does the same thing for paper coordinates (XZ,YZ)
      ! Arguments :
      !	XA,YA	R*8	User coordinates		Input
      !	XZ,YZ	R*4	Plot coordinates		Input
      ! Subroutines :
      !	GDRAW
      !
      ! Force the line style to solid for the end of an arrow	PV, 17-jul-87
      !---------------------------------------------------------------------
      real(kind=8) :: xa                      !
      real(kind=8) :: ya                      !
    end subroutine arrow
  end interface
  !
  interface
    subroutine regval(z,xa,ya,value,lecri)
      use gbl_message
      use greg_rg
      !---------------------------------------------------------------------
      ! @ private
      ! GREG 	Internal routine
      !	Computes the Regular Grid array value at user coordinates XA,YA
      ! Arguments :
      !	Z	R*4 (*)	Regular grid array		Input
      !	XA	R*8	X user coordinate 		Input
      !	YA	R*8	Y user coordinate		Input
      !	VALUE	R*4	Value at this position		Output
      !	LECRI	L	Logical flag for writing	Input
      !---------------------------------------------------------------------
      real(kind=4) :: z(*)                    !
      real(kind=8) :: xa                      !
      real(kind=8) :: ya                      !
      real(kind=4) :: value                   !
      logical :: lecri                  !
    end subroutine regval
  end interface
  !
  interface
    function voisin(x,y)
      use greg_kernel
      !---------------------------------------------------------------------
      ! @ private
      !  Find the nearest of the 9 significant points in BOX
      !---------------------------------------------------------------------
      integer(kind=4) :: voisin        !
      real(kind=4), intent(in) :: x,y  ! Absolute position of point
    end function voisin
  end interface
  !
  interface
    subroutine corner(k,x,y)
      use greg_kernel
      !---------------------------------------------------------------------
      ! @ private
      !  Returns the coordinate of the significant point number K
      !---------------------------------------------------------------------
      integer(kind=4), intent(in)  :: k    ! Point number
      real(kind=4),    intent(out) :: x,y  ! Coordinates
    end subroutine corner
  end interface
  !
  interface
    function centre(x,y)
      use greg_kernel
      !---------------------------------------------------------------------
      ! @ private
      ! Find the appropriate centering option
      !---------------------------------------------------------------------
      integer(kind=4) :: centre        !
      real(kind=4), intent(in) :: x,y  ! Absolute position of point
    end function centre
  end interface
  !
  interface
    subroutine arraydraw2(code,cra,la,cdec,ld,error)
      use phys_const
      use greg_kernel
      use greg_wcs
      !---------------------------------------------------------------------
      ! @ private
      !     Draw what CODE indicates, at absolute position defined by
      !     CRA and CDEC.
      !
      !     CODE    C*(*)    Drawing action (Relocate, Line, Marker, Arrow)
      !     CRA     C*(*)    String for X position
      !     LA      I        Length of CRA
      !     CDEC    C*(*)    String for Y position
      !     LD      I        Length of CDEC
      !---------------------------------------------------------------------
      character(len=1)                :: code   !
      character(len=*)                :: cra    !
      integer(kind=4)                 :: la     !
      character(len=*)                :: cdec   !
      integer(kind=4)                 :: ld     !
      logical,          intent(inout) :: error  ! Logical error flag
    end subroutine arraydraw2
  end interface
  !
  interface
    subroutine draw_text_relative(x,y,string,nchar,kbox,ic,doclip_soft)
      use phys_const
      use greg_kernel
      use greg_wcs
      !---------------------------------------------------------------------
      ! @ private
      !  Draw a TEXT, at position X,Y in coordinate system KBOX
      !---------------------------------------------------------------------
      real(kind=8),     intent(in) :: x,y          ! Coordinates
      character(len=*), intent(in) :: string       ! Text to be drawn
      integer(kind=4),  intent(in) :: nchar        ! Length of STRING
      integer(kind=4),  intent(in) :: kbox         ! Coordinate system
      integer(kind=4),  intent(in) :: ic           ! Centering code
      logical,          intent(in) :: doclip_soft  ! Soft clipping enabled?
    end subroutine draw_text_relative
  end interface
  !
  interface
    subroutine garrow2(xz,yz)
      use phys_const
      use greg_kernel
      use greg_pen
      !---------------------------------------------------------------------
      ! @ private
      ! GREG	Internal routine
      !	Draws an arrow from current pen position to (XZ,YZ)
      !	in paper coordinates (XZ,YZ)
      ! Arguments :
      !	XZ,YZ	R*4	Plot coordinates		Input
      !
      ! Does not change the line style to solid for the end of an arrow
      ! since it would create spurious segments
      !---------------------------------------------------------------------
      real(kind=4) :: xz                      !
      real(kind=4) :: yz                      !
    end subroutine garrow2
  end interface
  !
  interface
    subroutine print_position (w_angle)
      use phys_const
      use greg_kernel
      use greg_wcs
      use gbl_message
      !---------------------------------------------------------------------
      ! @ private
      !     Print current cursor position
      !
      !     W_ANGLE  I        Coordinate system                         Input
      !---------------------------------------------------------------------
      integer(kind=4) :: w_angle                !
    end subroutine print_position
  end interface
  !
  interface
    subroutine print_line(line,kbox,ibox,chain,fact)
      use phys_const
      use greg_kernel
      use greg_wcs
      !---------------------------------------------------------------------
      ! @ private
      !  Re-write the command line for a DRAW Code action
      !
      !  kbox < 0: user coordinates
      !  kbox = 0: physical coordinates from box "corner"
      !  kbox = 1: character coordinates from box "corner"
      !  kbox = 2: absolute physical coordinates on page
      !---------------------------------------------------------------------
      character(len=*), intent(out) :: line   ! Command line
      integer(kind=4),  intent(in)  :: kbox   ! Coordinate system
      integer(kind=4),  intent(in)  :: ibox   ! Box corner (if relevant according to KBOX)
      character(len=*), intent(in)  :: chain  ! Code of action (all but TEXT)
      real(kind=4),     intent(in)  :: fact   ! Scaling factor
    end subroutine print_line
  end interface
  !
  interface
    subroutine print_text(line,kbox,ibox,chain,fact,string,ic,ang)
      use phys_const
      use greg_kernel
      use greg_wcs
      !---------------------------------------------------------------------
      ! @ private
      !  Re-write the command line for a DRAW TEXT action
      !
      !  kbox < 0: user coordinates
      !  kbox = 0: physical coordinates from box "corner"
      !  kbox = 1: character coordinates from box "corner"
      !  kbox = 2: absolute physical coordinates on page
      !---------------------------------------------------------------------
      character(len=*), intent(out) :: line    ! Command line
      integer(kind=4),  intent(in)  :: kbox    ! Coordinate system
      integer(kind=4),  intent(in)  :: ibox    ! Box corner (if relevant according to KBOX)
      character(len=*), intent(in)  :: chain   ! Code of action (all but TEXT)
      real(kind=4),     intent(in)  :: fact    ! Scaling factor
      character(len=*), intent(in)  :: string  ! Text to be drawn
      integer(kind=4),  intent(in)  :: ic      ! Centering code
      real(kind=8),     intent(in)  :: ang     ! Orientation of text
    end subroutine print_text
  end interface
  !
  interface
    subroutine glook(line,error)
      use greg_kernel
      use greg_pen
      use greg_rg
      !---------------------------------------------------------------------
      ! @ private
      ! GREG
      !     Support for command
      !     LOOK "command"
      !
      ! Calls the cursor, and execute the specified command each time it is
      ! pressed. The command can be a procedure (e.g. @my_look) and can test
      ! the pressed character which is added at the end as first argument.
      !---------------------------------------------------------------------
      character(len=*)                :: line   !
      logical,          intent(inout) :: error  !
    end subroutine glook
  end interface
  !
  interface
    subroutine curve (line,error)
      use gildas_def
      use sic_types
      use greg_kernel
      use greg_xyz
      use gbl_message
      use gbl_format
      !---------------------------------------------------------------------
      ! @ private
      ! GREG	Support routine for command
      ! 	CURVE [Array_X Array_Y]
      !	/ACCURACY [en cm]
      !		Fonctions:
      !	/VARIABLE X			Y=F(X)
      !	/VARIABLE Y			X=F(Y)
      !		Courbes parametriques:
      !	/VARIABLE Z [Array_Z]		Parametre: Z
      !	/VARIABLE NUMBERING		Parametre: Numero du point
      !	/VARIABLE POLYGONAL_LENGTH	(Analytique)
      !	/VARIABLE CURVILINEAR_LENGTH	(Iteratif, non analytique)
      !
      !	/PERIODIC
      !		Suppose que les points 1 et NXY sont separes par
      !		un nombre entier de periodes:
      !		/VARIABLE X	Suppose Y(1) = Y(NXY)
      !		/VARIABLE Y	Suppose X(1) = X(NXY)
      !		Courbe parametrique, suppose
      !				X(1) = X(NXY) et Y(1)=Y(NXY)
      !	/BLANKING [Bval [Eval]]
      !
      ! Arguments :
      !	LINE	C*(*)	Command line			Input/Output
      !---------------------------------------------------------------------
      character(len=*)                :: line   !
      logical,          intent(inout) :: error  ! Logical error flag
    end subroutine curve
  end interface
  !
  interface
    subroutine get_same_inca (command,line,iopt,iarg,form,ixy,xinca,error)
      use gildas_def
      use sic_types
      use gbl_message
      use gbl_format
      !---------------------------------------------------------------------
      ! @ private
      ! GreG  Internal routine
      !  Get incarnation of variables in command line
      !---------------------------------------------------------------------
      character(len=*),          intent(in)    :: command  !
      character(len=*),          intent(in)    :: line     !
      integer(kind=4),           intent(in)    :: iopt     !
      integer(kind=4),           intent(in)    :: iarg     !
      integer(kind=4),           intent(in)    :: form     !
      integer(kind=size_length), intent(inout) :: ixy      !
      type(sic_descriptor_t),    intent(out)   :: xinca    !
      logical,                   intent(inout) :: error    !
    end subroutine get_same_inca
  end interface
  !
  interface
    subroutine get_greg_inca (command,name,form,ixy,xinca,error)
      use gildas_def
      use sic_types
      use gbl_message
      use gbl_format
      !---------------------------------------------------------------------
      ! @ private
      ! Get incarnation of GREG X Y or Z variable. Note that the code does
      ! not distinguish the program-defined variables (by e.g. COLUMN) from
      ! user-defined ones.
      !---------------------------------------------------------------------
      character(len=*),          intent(in)    :: command  ! Command name (feedback)
      character(len=*),          intent(in)    :: name     ! Variable name
      integer(kind=4),           intent(in)    :: form     ! Desired incarnation type
      integer(kind=size_length), intent(inout) :: ixy      ! Number of elements
      type(sic_descriptor_t),    intent(out)   :: xinca    ! Incarnation descriptor
      logical,                   intent(inout) :: error    ! Logical error flag
    end subroutine get_greg_inca
  end interface
  !
  interface
    subroutine rstrip(line,error)
      use gildas_def
      use gbl_message
      use greg_kernel
      use greg_rg
      use greg_xyz
      !---------------------------------------------------------------------
      ! @ private
      !  Make a strip across the regular grid array
      !---------------------------------------------------------------------
      character(len=*), intent(inout) :: line   ! Command line, updated in return
      logical,          intent(inout) :: error  ! Logical error flag
    end subroutine rstrip
  end interface
  !
  interface
    subroutine sloppy(x1,x2,y1,y2,r,sample,value,nxy,error)
      use gbl_message
      use greg_rg
      !---------------------------------------------------------------------
      ! @ private
      !  Make a diagonal strip across the regular grid array
      !  The number of pixels is NX or NY, according to wether the slope is
      ! greater than NX/NY and interpolation in the non-sampled direction is
      ! made using a parabola fitting the 3 nearby points.
      !---------------------------------------------------------------------
      real(kind=8),    intent(in)  :: x1,y1      ! Coordinates of one point on line
      real(kind=8),    intent(in)  :: x2,y2      ! Coordinates of another point on line
      real(kind=4),    intent(in)  :: r(*)       ! Array of map value
      real(kind=8),    intent(out) :: sample(*)  ! Array of coordinates to be filled
      real(kind=8),    intent(out) :: value(*)   ! Array of values to be filled
      integer(kind=4), intent(out) :: nxy        ! Number of samples filled
      logical,         intent(out) :: error      ! Logical error flag
    end subroutine sloppy
  end interface
  !
  interface
    subroutine difsys4 (f,eps,h,x,y)
      !---------------------------------------------------------------------
      ! @ private
      ! GREG	Internal routine
      !       adapted from Prof. Dr. R. BULIRSCH, 1972-73
      !	P. VALIRON				21-AUG-80
      !	adapted for single precision		27-SEP-84
      !	Integration of first order differential equations.
      !	The equation is supposed to be of the form:
      !             DY/DX = F(X,Y)
      ! Arguments :
      !	F	Ext	User supplied subroutine. Computes
      !			the right end of (1) for a given X and Y
      !			F must contain the instructions:
      !				SUBROUTINE F(X,Y,DYDX)
      !				REAL*4 X,Y,DYDX
      !	EPS	R*4	Accuracy, kept internally > 1.E-11
      !	H	R*4	User estimate of the best step of
      !			integration, updated.
      !	X	R*4	initial abcissa.
      !	Y	R*4	Initial value of Y.
      !	After the calculation, X is replaced by X+H2 and Y by its
      !	value for the abscissa X+H2. H2 is less or equal to H, its value
      !	is chosen internally to satisfy the required accuracy EPS.
      !	The subroutine returns H equal to the best value for the next
      !	step. If the system seems to be ill conditioned, or if the initial
      !	value for H is much too high, H is returned equal to 0.
      !	( See BULIRSCH,R. and STOER,J.; NUM.MATH. /8/,1-13 (1966) )
      ! Subroutines :
      !	F	External
      !---------------------------------------------------------------------
      external :: f                     !
      real*4 :: eps                     !
      real*4 :: h                       !
      real*4 :: x                       !
      real*4 :: y                       !
    end subroutine difsys4
  end interface
  !
  interface
    subroutine grline(cxa,cya,cxb,cyb)
      use greg_kernel
      !---------------------------------------------------------------------
      ! @ private
      !   Plot a line from CXA,CYA to CXB,CYB with current pen attributes.
      !---------------------------------------------------------------------
      real(kind=4), intent(in) :: cxa  ! Plot X coordinate of start point
      real(kind=4), intent(in) :: cya  ! Plot Y coordinate of start point
      real(kind=4), intent(in) :: cxb  ! Plot X coordinate of end point
      real(kind=4), intent(in) :: cyb  ! Plot Y coordinate of end point
    end subroutine grline
  end interface
  !
  interface
    subroutine grpoly(nq,xq,yq)
      use gildas_def
      use greg_kernel
      !---------------------------------------------------------------------
      ! @ private-mandatory (because symbol is used elsewhere)
      ! Plots a poly-line in paper coordinate, with clipping in the BOX
      !---------------------------------------------------------------------
      integer(kind=size_length), intent(in) :: nq     ! Number of points
      real(kind=4),              intent(in) :: xq(*)  ! Plot X coordinates
      real(kind=4),              intent(in) :: yq(*)  ! Plot Y coordinates
    end subroutine grpoly
  end interface
  !
  interface
    subroutine grclip (x,y,c)
      use greg_kernel
      !---------------------------------------------------------------------
      ! @ private
      !   Support routine for the clipping algorithm ; called from DRAW
      ! and GRPOLY only.  C is a 4 bit code indicating the relationship
      ! between point (X,Y) and the window boundaries ; 0 implies the
      ! point is within the window.
      !---------------------------------------------------------------------
      real(kind=4),    intent(in)  :: x  ! Plot X coordinate
      real(kind=4),    intent(in)  :: y  ! Plot Y coordinate
      integer(kind=4), intent(out) :: c  ! Code for clipping
    end subroutine grclip
  end interface
  !
  interface
    subroutine cross(xp,yp,xq,yq,x1,x2,y1,y2,xc,yc,xd,yd,ok)
      !---------------------------------------------------------------------
      ! @ private
      ! Clipping subroutine. Not used, kept for reference.
      !
      ! Return segment XC,YC,XD,YD where the segment XP,YP,XQ,YQ crosses the
      ! box X1,Y1,X2,Y2. Set OK to FALSE if never in the box.
      ! It is assumed that X1 < X2 and Y1 < Y2.
      !---------------------------------------------------------------------
      real(kind=4), intent(in)  :: xp,yp  ! Line to be clipped (start point)
      real(kind=4), intent(in)  :: xq,yq  ! Line to be clipped (end point)
      real(kind=4), intent(in)  :: x1,y1  ! Box BLC
      real(kind=4), intent(in)  :: x2,y2  ! Box TRC
      real(kind=4), intent(out) :: xc,yc  ! Clipped line (start point)
      real(kind=4), intent(out) :: xd,yd  ! Clipped line (end point)
      logical,      intent(out) :: ok     ! Is the clipped line visible?
    end subroutine cross
  end interface
  !
  interface
    subroutine ellipse(line,error)
      use phys_const
      use gbl_constant
      use gbl_message
      use greg_kernel
      use greg_pen
      use greg_types
      use greg_wcs
      !---------------------------------------------------------------------
      ! @ private
      !  Support routine for command:
      !   ELLIPSE Major Minor PA
      ! 1  /BOX  X Y
      ! 2  /USER X Y
      ! 3  /ARC THETA1 THETA2
      ! 4  /FILL [Icolor]
      ! 5  /HATCH [Ipen] [Angle] [Separ] [Phase]
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: line   ! Command line
      logical,          intent(inout) :: error  ! Logical error flag
    end subroutine ellipse
  end interface
  !
  interface
    subroutine ellipse_scalar(line,box,user,abso,usunit,uscale,arc,drawing,error)
      use phys_const
      use greg_kernel
      use greg_types
      use greg_wcs
      !---------------------------------------------------------------------
      ! @ private
      ! Draw a single ellipse, command line arguments must be scalar
      !---------------------------------------------------------------------
      character(len=*),        intent(in)    :: line     ! Input command line
      logical,                 intent(in)    :: box      !
      logical,                 intent(in)    :: user     ! /USER
      logical,                 intent(in)    :: abso     ! /USER ABSO
      integer(kind=4),         intent(in)    :: usunit   !
      real(kind=8),            intent(in)    :: uscale   !
      logical,                 intent(in)    :: arc      ! /ARC
      type(polygon_drawing_t), intent(in)    :: drawing  ! Drawing description
      logical,                 intent(inout) :: error    ! Logical error flag
    end subroutine ellipse_scalar
  end interface
  !
  interface
    subroutine ellipse_array(line,uscale,arc,drawing,error)
      use gildas_def
      use gbl_format
      use gbl_message
      use sic_types
      use greg_types
      !---------------------------------------------------------------------
      ! @ private
      !  Draw one or several ellipses, command line arguments can be scalar
      ! or array
      !---------------------------------------------------------------------
      character(len=*),        intent(in)    :: line     ! Input command line
      real(kind=8),            intent(in)    :: uscale   !
      logical,                 intent(in)    :: arc      ! /ARC
      type(polygon_drawing_t), intent(in)    :: drawing  ! Drawing description
      logical,                 intent(inout) :: error    ! Logical error flag
    end subroutine ellipse_array
  end interface
  !
  interface
    subroutine greg_extrema(line,error)
      use gildas_def
      use gbl_message
      use greg_kernel
      use greg_pen
      use greg_rg
      !---------------------------------------------------------------------
      ! @ private
      ! Support routine for command
      !  [GREG2\]EXTREMA
      !  1       [/BLANKING Bval Eval]
      !  2       [/PLOT]
      !  3       [/COMPUTE]
      !  4       [/LOCAL PLOT|TERMINAL|FileName]
      ! Find the extrema of regular grid array loaded
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: line   ! Input command line
      logical,          intent(inout) :: error  ! Logical error flag
    end subroutine greg_extrema
  end interface
  !
  interface
    subroutine rgextr(itype,zmin,zmax,z,bval,eval,forced)
      use gbl_message
      use greg_rg
      !---------------------------------------------------------------------
      ! @ private
      !  Finds the maxima and minima for Regular Grid array and writes on
      ! screen the values and corresponding position if ITYPE = 1
      !---------------------------------------------------------------------
      integer(kind=4), intent(in) :: itype   ! Type values on screen
      real(kind=4)                :: zmin    ! Minimum map value (output)
      real(kind=4)                :: zmax    ! Maximum map value (output)
      real(kind=4),    intent(in) :: z(*)    ! RG map array
      real(kind=4),    intent(in) :: bval    ! Blanking value
      real(kind=4),    intent(in) :: eval    ! Tolerance on blanking
      logical,         intent(in) :: forced  ! Force computation
    end subroutine rgextr
  end interface
  !
  interface
    subroutine rgextr_local(z,toplot,toterm,tolun,error)
      use greg_kernel
      use greg_rg
      !---------------------------------------------------------------------
      ! @ private
      !  Finds local extrema of the Regular Grid array
      !---------------------------------------------------------------------
      real(kind=4),    intent(in)    :: z(rg%nx,rg%ny)  ! Regular grid array
      logical,         intent(in)    :: toplot          ! Display on plot
      logical,         intent(in)    :: toterm          ! Display on terminal
      integer(kind=4), intent(in)    :: tolun           ! Output lun, if defined
      logical,         intent(inout) :: error           ! Logical error flag
    end subroutine rgextr_local
  end interface
  !
  interface
    subroutine grfill(line,error)
      use gildas_def
      use sic_types
      use greg_kernel
      use greg_xyz
      use gbl_format
      !---------------------------------------------------------------------
      ! @ private
      ! GREG Support routine for command FILL X Y
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: line   ! Command line
      logical,          intent(inout) :: error  ! Logical error flag
    end subroutine grfill
  end interface
  !
  interface
    subroutine gr_fillpoly(n,x,y)
      use gildas_def
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      integer(kind=size_length), intent(in) :: n     !
      real(kind=4),              intent(in) :: x(*)  !
      real(kind=4),              intent(in) :: y(*)  !
    end subroutine gr_fillpoly
  end interface
  !
  interface
    subroutine parse_polygon_drawing(rname,line,optfill,opthatch,drawing,error)
      use phys_const
      use gbl_message
      use greg_types
      use greg_pen
      !---------------------------------------------------------------------
      ! @ private
      ! Parse the following options in the command line:
      !   /FILL [Icolor]
      !   /HATCH [Ipen] [Angle] [Separ] [Phase]
      ! Defaults for the arguments are defined here.
      !---------------------------------------------------------------------
      character(len=*),        intent(in)    :: rname     !
      character(len=*),        intent(in)    :: line      !
      integer(kind=4),         intent(in)    :: optfill   ! Number of option /FILL
      integer(kind=4),         intent(in)    :: opthatch  ! Number of option /HATCH
      type(polygon_drawing_t), intent(out)   :: drawing   !
      logical,                 intent(inout) :: error     ! Logical error flag
    end subroutine parse_polygon_drawing
  end interface
  !
  interface
    subroutine reallocate_poly_buffers(npts,error)
      use gildas_def
      !---------------------------------------------------------------------
      ! @ private
      ! 'npts' is the number of points of the input polygon
      ! This subroutine will allocate:
      ! - npts+1 values (so that the caller can close the polygon) for the
      !   unclipped buffer.
      ! - clipping buffer: npts*3/2+1, because clipping may add more
      !   summits, and this is the worst case.
      !---------------------------------------------------------------------
      integer(kind=size_length), intent(in)    :: npts
      logical,                   intent(inout) :: error
    end subroutine reallocate_poly_buffers
  end interface
  !
  interface
    subroutine flimit
      use gbl_message
      use greg_image
      use greg_rg
      !---------------------------------------------------------------------
      ! @ private
      ! GREG	Internal routine
      !
      !	This subroutine computes the limits of the Regular Grid array.
      !	It tries to handle "Astronomical Maps" as best as possible (!).
      !---------------------------------------------------------------------
    end subroutine flimit
  end interface
  !
  interface
    subroutine greg_point(line,error)
      use gildas_def
      use sic_types
      use greg_kernel
      use greg_xyz
      use gbl_message
      use gbl_format
      !---------------------------------------------------------------------
      ! @ private
      ! Support routine for command
      !    POINTS [Array__X Array__Y]
      ! 1    [/BLANKING [Bval [Eval]]]
      ! 2    [/SIZE MaxVal [Array__Z [Expo]]]
      ! 3    [/MARKER]
      !
      !  Draw markers of current style and size. If MaxVal is given, draws
      ! symbols of current style but of size proportional to Z value at
      ! positions (X,Y). The current marker size corresponds to points with
      ! value MaxVal.
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: line   ! Input command line
      logical,          intent(inout) :: error  ! Logical error flag
    end subroutine greg_point
  end interface
  !
  interface
    subroutine threed (line,error)
      use gildas_def
      use gbl_message
      use greg_axes
      use greg_kernel
      use greg_rg
      !---------------------------------------------------------------------
      ! @ private
      ! GREG Support routine for command
      !
      ! PERSPECTIVE [Altitude Azimuth]
      ! 1           [/FACTOR factor offset]
      ! 2           [/LOWER]
      ! 3           [/LINES]
      ! 4           [/STEP nx ny]
      ! 5           [/AXES Xmin Xmax Ymin Ymax]
      ! 6           [/CENTER]
      ! 7           [/VERTICAL Vmin Vmax]
      !
      ! 3D perspective plot, define the projective transformation
      !
      ! ALTitude      : degrees
      ! AZImuth       : degrees
      ! XLEN and YLEN : Length of X and Y axes (cf SET LOCATION)
      ! XOFF and YOFF : Origin position
      ! ZFACtor       : Conversion factor from Z to physical units
      ! ZOFF          : Origine offset along Z (physical units)
      !---------------------------------------------------------------------
      character(len=*) :: line          ! Command line               Input
      logical :: error                  ! Logical error flag         Output
    end subroutine threed
  end interface
  !
  interface
    subroutine pswap (xin,nx,ny,xout,mx,my,ix1,ix2,ix3,iy1,iy2,iy3)
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      integer :: nx                     !
      integer :: ny                     !
      real :: xin(nx,ny)                !
      integer :: mx                     !
      integer :: my                     !
      real :: xout(mx,my)               !
      integer :: ix1                    !
      integer :: ix2                    !
      integer :: ix3                    !
      integer :: iy1                    !
      integer :: iy2                    !
      integer :: iy3                    !
    end subroutine pswap
  end interface
  !
  interface
    subroutine plt3d(a,m,n,x,y,l,alt,az,xlen,xoff,ylen,yoff,zfac,zoff,blnk3d,  &
      rgblank,eblank,ier)
      use greg_axes
      !---------------------------------------------------------------------
      ! @ private
      ! 3D plot routine, adapted from SAS-3 routine of same name
      !---------------------------------------------------------------------
      integer :: m     ! Dimensions of data array A
      integer :: n     ! Dimensions of data array A
      real :: a(m,n)   ! Array, represents height of surface as function of location in plane
      integer :: l     ! Length of work arrays, .GE. 2*MIN(M,N)
      real :: x(l)     ! Real work array
      real :: y(l)     ! Real work array
      real :: alt      ! Altitude viewing angle in degrees
      real :: az       ! Azimuth viewing angle in degrees
      real :: xlen     ! Length of unprojected X axis in plot coordinates
      real :: xoff     ! Offset of origin in plot coordinates
      real :: ylen     ! Length of unprojected Y axis in plot coordinates
      real :: yoff     ! Offset of origin in plot coordinates
      real :: zfac     ! Scaling of Z-axis from data units to unprojected plot coordinates
      real :: zoff     ! Offset of Z-origin in plot coordinates
      real :: blnk3d   !
      real :: rgblank  !
      real :: eblank   !
      integer :: ier   ! Returns 0 for no error
    end subroutine plt3d
  end interface
  !
  interface
    subroutine nxtvu(ic,x,y,n,ier)
      use greg_kernel
      !---------------------------------------------------------------------
      ! @ private
      ! GREG Internal routine
      ! Find the next vector visible and plot it.
      !---------------------------------------------------------------------
      integer :: ic           ! Integer code                         Input
      integer :: n            ! Length of X and Y arrays             Input
      real :: x(n)            ! Work array
      real :: y(n)            ! Work array
      integer :: ier          ! Error code                           Output
    end subroutine nxtvu
  end interface
  !
  interface
    subroutine outp(x,y,ier)
      !---------------------------------------------------------------------
      ! @ private
      ! GREG Internal routine
      ! Buffers the vector to keep track of vectors plotted
      !---------------------------------------------------------------------
      real :: x                         !              Input
      real :: y                         !              Input
      integer :: ier                    ! Error code   Output
    end subroutine outp
  end interface
  !
  interface
    function alin(x0,x1,y0,y1,x)
      !---------------------------------------------------------------------
      ! @ private
      ! GREG Internal routine
      ! Find the Y coordinate of absissae X along line (X0,Y0)-->(X1,Y1)
      !---------------------------------------------------------------------
      real :: alin          ! Y coordinate of point                 Output
      real :: x0            ! X coordinate of start point           Input
      real :: x1            ! X coordinate of end point             Input
      real :: y0            ! Y coordinate of start point           Input
      real :: y1            ! Y coordinate of end point             Input
      real :: x             ! X coordinate of point                 Input
    end function alin
  end interface
  !
  interface
    subroutine sub_axes(a,m,n,a3,a2,a1,b1,b2,b3,b4,saz,caz,blnk3d)
      use greg_pen
      use greg_axes
      !---------------------------------------------------------------------
      ! @ private
      ! GREG Internal routine
      ! Cette routine trace les axes sur la vue en perspective lorsque
      ! l'option /AXES est presente dans la commande PERSPECTIVE.
      !---------------------------------------------------------------------
      integer :: m                      !
      integer :: n                      !
      real :: a(m,n)                    !
      real :: a3                        !
      real :: a2                        !
      real :: a1                        !
      real :: b1                        !
      real :: b2                        !
      real :: b3                        !
      real :: b4                        !
      real :: saz                       !
      real :: caz                       !
      real :: blnk3d                    !
    end subroutine sub_axes
  end interface
  !
  interface
    subroutine traxes (alpha,beta,ex,exx,zlxx,zlyy,ey,eyy,ez,ezz,vz,zlzz)
      use greg_axes
      use greg_xyz
      !---------------------------------------------------------------------
      ! @ private
      ! GREG Internal routine
      ! Cette routine est utilisee par la routine SUB_AXES pour afficher ces
      ! axes
      !---------------------------------------------------------------------
      real :: alpha              ! Orientation de l'axe des abscisses
      real :: beta               ! Orientation de l'axe des ordonnees
      real :: ex                 ! abscisse du coin apparaissant au centre
      real :: exx                ! ordonnee du coin apparaissant au centre
      real :: zlxx               ! longueur de l'axe des abscisses
      real :: zlyy               ! longueur de l'axe des ordonnees
      real :: ey                 ! abscisse du coin apparaissant a gauche
      real :: eyy                ! ordonnee du coin apparaissant a gauche
      real :: ez                 ! abscisse du coin apparaissant a droite
      real :: ezz                ! ordonnee du coin apparaissant a droite
      real :: vz                 ! ordonnee du bas de l'axe vertical
      real :: zlzz               ! longueur de l'axe des donnees
    end subroutine traxes
  end interface
  !
  interface
    subroutine echange (xl1,xl2,yl1,yl2)
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      real*4 :: xl1                     !
      real*4 :: xl2                     !
      real*4 :: yl1                     !
      real*4 :: yl2                     !
    end subroutine echange
  end interface
  !
  interface
    subroutine permute (val1,val2)
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      real*4 :: val1                    !
      real*4 :: val2                    !
    end subroutine permute
  end interface
  !
  interface
    subroutine greg3_close
      !---------------------------------------------------------------------
      ! @ private
      ! GREG  -- Support routine for command GREG3\IMAGE [Name]
      !   Close the current image
      !---------------------------------------------------------------------
      ! Global
    end subroutine greg3_close
  end interface
  !
  interface
    subroutine greg3_image(line,error)
      use gildas_def
      use gbl_message
      use gbl_format
      use gbl_constant
      !---------------------------------------------------------------------
      ! @ private
      ! GREG  -- Support routine for command
      !  GREG3\IMAGE [Name]
      !  1     [/PLANE I1 I2]
      !  2     [/SUBSET Imin Imax Jmin Jmax]
      !  3     [/WRITE]
      !  4     [/CLOSE]
      !---------------------------------------------------------------------
      character(len=*)                :: line   ! Input command line
      logical,          intent(inout) :: error  ! Logical error flag
    end subroutine greg3_image
  end interface
  !
  interface
    subroutine greg3_spectrum(line,error)
      !---------------------------------------------------------------------
      ! @ private
      ! Support routine for the 2 alternate syntaxes of command
      !     GREG3\SPECTRUM
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: line   ! Input command line
      logical,          intent(inout) :: error  ! Logical error flag
    end subroutine greg3_spectrum
  end interface
  !
  interface
    subroutine greg3_spectrum_extract(line,error)
      use gildas_def
      use gbl_format
      use gbl_message
      !---------------------------------------------------------------------
      ! @ private
      ! GILDAS      Support routine for command
      !     GREG3\SPECTRUM I,J,K
      !---------------------------------------------------------------------
      character(len=*) :: line          ! Input command line
      logical :: error                  ! Logical error flag
    end subroutine greg3_spectrum_extract
  end interface
  !
  interface
    subroutine greg3_kill(line,error)
      use gildas_def
      use gbl_message
      use greg_rg
      !---------------------------------------------------------------------
      ! @ private
      !  Support routine for command
      !   GRGE3\KILL
      !  Call the cursor, and display the map value or kill the pixel
      ! depending on the cursor code
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: line   !
      logical,          intent(inout) :: error  !
    end subroutine greg3_kill
  end interface
  !
  interface
    subroutine killr(xarray,pixel,code)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ private
      !  Support routine for command
      !    GREG3\KILL
      !  Display the map value or kill the pixel depending on the cursor
      ! code.
      !---------------------------------------------------------------------
      real(kind=4),     intent(inout) :: xarray(:,:)  ! Current map
      integer(kind=4),  intent(in)    :: pixel(2)     ! Pixel coordinate
      character(len=*), intent(in)    :: code         ! Code for operation
    end subroutine killr
  end interface
  !
  interface
    subroutine greg3_variables(error)
      use gbl_message
      use sic_types
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      logical, intent(inout) :: error  ! Logical error flag
    end subroutine greg3_variables
  end interface
  !
  interface
    subroutine gr4_sub_extrema(z,n,m,bval,eval,zmin,zmax,i1,i2,j1,j2)
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      integer(kind=4) :: n                      !
      integer(kind=4) :: m                      !
      real(kind=4) :: z(n,m)                  !
      real(kind=4) :: bval                    !
      real(kind=4) :: eval                    !
      real(kind=4) :: zmin                    !
      real(kind=4) :: zmax                    !
      integer(kind=4) :: i1                     !
      integer(kind=4) :: i2                     !
      integer(kind=4) :: j1                     !
      integer(kind=4) :: j2                     !
    end subroutine gr4_sub_extrema
  end interface
  !
  interface
    subroutine subset4 (x,nx,ny,y,mx,my,i1,i2,j1,j2)
      use gildas_def
      !---------------------------------------------------------------------
      ! @ private
      ! GILDAS Internal routine
      ! Extract a two dimensional subset from a two dimensional image
      !---------------------------------------------------------------------
      integer(kind=index_length), intent(in)  :: nx,ny     ! Dimensions of X
      real(kind=4),               intent(in)  :: x(nx,ny)  ! Input array
      integer(kind=4),            intent(in)  :: mx,my     ! Dimensions of Y
      real(kind=4),               intent(out) :: y(mx,my)  ! Output subset
      integer(kind=index_length), intent(in)  :: i1,i2     ! Min and Max pixels along first axis
      integer(kind=index_length), intent(in)  :: j1,j2     ! Min and Max pixels along second axis
    end subroutine subset4
  end interface
  !
  interface
    subroutine subset8(x,nx,ny,y,mx,my,i1,i2,j1,j2)
      use gildas_def
      !---------------------------------------------------------------------
      ! @ private
      ! GILDAS Internal routine
      ! Extract a two dimensional subset from a two dimensional image
      !---------------------------------------------------------------------
      integer(kind=index_length), intent(in)  :: nx,ny     ! Dimensions of X
      real(kind=8),               intent(in)  :: x(nx,ny)  ! Input array
      integer(kind=4),            intent(in)  :: mx,my     ! Dimensions of Y
      real(kind=4),               intent(out) :: y(mx,my)  ! Output subset
      integer(kind=index_length), intent(in)  :: i1,i2     ! Min and Max pixels along first axis
      integer(kind=index_length), intent(in)  :: j1,j2     ! Min and Max pixels along second axis
    end subroutine subset8
  end interface
  !
  interface
    subroutine greg_kernel_init
      !--------------------------------------------------------------------
      ! @ private
      ! Initialization routine for greg_kernel module.
      ! It must be called once and only once, otherwise an error will
      ! raise and program will exit.
      !--------------------------------------------------------------------
      !
    end subroutine greg_kernel_init
  end interface
  !
  interface
    subroutine greg_mod_init
      !--------------------------------------------------------------------
      ! @ private
      ! Call to initialization routines for GREG modules.
      ! It must be called once and only once, otherwise an error will
      ! raise and program will exit.
      !--------------------------------------------------------------------
    end subroutine greg_mod_init
  end interface
  !
  interface
    subroutine gr_axis(name,narg,arg1,arg2)    ! 28-Sep-1986
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      character(len=*) :: name          !
      integer :: narg                   !
      real*4 :: arg1                    !
      real*4 :: arg2                    !
    end subroutine gr_axis
  end interface
  !
  interface
    subroutine gr_box(name)        ! 28-Sep-1986
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      character(len=*) :: name          !
    end subroutine gr_box
  end interface
  !
  interface
    subroutine gr_clea(name)       ! 28-Sep-1986
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      character(len=*) :: name          !
    end subroutine gr_clea
  end interface
  !
  interface
    subroutine gr_colu(name)       ! 28-Sep-1986
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      character(len=*) :: name          !
    end subroutine gr_colu
  end interface
  !
  interface
    subroutine gr_conn             ! Incomplete
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
    end subroutine gr_conn
  end interface
  !
  interface
    subroutine gr_devi(name)       ! 28-Sep-1986
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      character(len=*) :: name          !
    end subroutine gr_devi
  end interface
  !
  interface
    subroutine gr_erro(name)       ! 28-Sep-1986
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      character(len=*) :: name          !
    end subroutine gr_erro
  end interface
  !
  interface
    subroutine gr_hist             ! 28-Sep-1986
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
    end subroutine gr_hist
  end interface
  !
  interface
    subroutine gr_poin(narg,arg1)  ! 28-Sep-1986
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      integer :: narg                   !
      real*4 :: arg1                    !
    end subroutine gr_poin
  end interface
  !
  interface
    subroutine gr_rule(name)       ! 28-Sep-1986
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      character(len=*) :: name          !
    end subroutine gr_rule
  end interface
  !
  interface
    subroutine gr_set(name,narg,arg1,arg2,arg3,arg4)   ! 28-Sep-1986
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      character(len=*) :: name          !
      integer :: narg                   !
      real*4 :: arg1                    !
      real*4 :: arg2                    !
      real*4 :: arg3                    !
      real*4 :: arg4                    !
    end subroutine gr_set
  end interface
  !
  interface
    subroutine gr_show(name)
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      character(len=*) :: name          !
    end subroutine gr_show
  end interface
  !
  interface
    subroutine gr_tick(narg,arg1,arg2,arg3,arg4)
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      integer :: narg                   !
      real*4 :: arg1                    !
      real*4 :: arg2                    !
      real*4 :: arg3                    !
      real*4 :: arg4                    !
    end subroutine gr_tick
  end interface
  !
  interface
    subroutine gr_valu             ! 28-Sep-1986
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
    end subroutine gr_valu
  end interface
  !
  interface
    subroutine gr_extr             ! 28-Sep-1986
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
    end subroutine gr_extr
  end interface
  !
  interface
    subroutine gr_leve(name)       ! Incomplete
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      character(len=*) :: name          !
    end subroutine gr_leve
  end interface
  !
  interface
    subroutine gr_rgda(name)       ! 28-Sep-1986
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      character(len=*) :: name          !
    end subroutine gr_rgda
  end interface
  !
  interface
    subroutine gr_rgma             ! 28-Sep-1986
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
    end subroutine gr_rgma
  end interface
  !
  interface
    subroutine greg_message_set_id(id)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ private
      ! Alter library id into input id. Should be called by the library
      ! which wants to share its id with the current one.
      !---------------------------------------------------------------------
      integer, intent(in) :: id
    end subroutine greg_message_set_id
  end interface
  !
  interface
    subroutine greg_message(mkind,procname,message)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ private
      ! Messaging facility for the current library. Calls the low-level
      ! (internal) messaging routine with its own identifier.
      !---------------------------------------------------------------------
      integer,          intent(in) :: mkind     ! Message kind
      character(len=*), intent(in) :: procname  ! Name of calling procedure
      character(len=*), intent(in) :: message   ! Message string
    end subroutine greg_message
  end interface
  !
  interface
    subroutine greg_pack_init(gpack_id,error)
      !----------------------------------------------------------------------
      ! @ private-mandatory (because symbol is used elsewhere)
      ! Private routine to set the GREG environment.
      !----------------------------------------------------------------------
      integer :: gpack_id
      logical :: error
    end subroutine greg_pack_init
  end interface
  !
  interface
    subroutine greg_pack_clean(error)
      !----------------------------------------------------------------------
      ! @ private-mandatory (because symbol is used elsewhere)
      ! Private routine to clean the GREG environment
      ! (e.g. Remove temporary buffers, unregister languages...)
      !----------------------------------------------------------------------
      logical, intent(inout) :: error
    end subroutine greg_pack_clean
  end interface
  !
  interface
    subroutine gridder (line,error)
      use gildas_def
      use gbl_format
      use gbl_message
      use sic_types
      use greg_kernel
      use greg_rg
      use greg_xyz
      !---------------------------------------------------------------------
      ! @ private
      ! Support routine for command
      !  RANDOM_MAP Grid_descriptor[S]
      !  1    [/BLANKING Bval]
      !  2    [/NEIGHBOURS N]
      !  3    [/TRIANGLES]
      !  4    [/EXTRAPOLATE]
      !  5    [/VARIABLE]
      !  6    [/SKIP [TRIANGULATION] [INTERPOLATION]]
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: line   !
      logical,          intent(inout) :: error  ! Logical error flag
    end subroutine gridder
  end interface
  !
  interface
    subroutine drawg(x,y)
      !---------------------------------------------------------------------
      ! @ private-mandatory (because symbol is used elsewhere)
      !---------------------------------------------------------------------
      real :: x                         !
      real :: y                         !
    end subroutine drawg
  end interface
  !
  interface
    subroutine relog(x,y)
      !---------------------------------------------------------------------
      ! @ private-mandatory (because symbol is used elsewhere)
      !---------------------------------------------------------------------
      real :: x                         !
      real :: y                         !
    end subroutine relog
  end interface
  !
  interface
    subroutine init_tree(icode,clipit,error)
      use greg_contours
      use greg_kernel
      use greg_rg
      !---------------------------------------------------------------------
      ! @ private
      ! (re)initialize the tree structure for later filling contour
      ! capability
      !---------------------------------------------------------------------
      integer(kind=4)              :: icode   ! Unused
      logical,         intent(out) :: clipit  !
      logical,         intent(out) :: error   !
    end subroutine init_tree
  end interface
  !
  interface
    subroutine fill_vect(x,y,error)
      !---------------------------------------------------------------------
      ! @ private
      ! GREG	Internal routine
      !     For each contour level, puts (X,Y) Coordinates of contour
      !     into tree structure
      !---------------------------------------------------------------------
      integer*4 :: x                    !
      integer*4 :: y                    !
      logical :: error                  !
    end subroutine fill_vect
  end interface
  !
  interface
    subroutine fill_cont(error)
      !---------------------------------------------------------------------
      ! @ private
      ! GREG	Internal routine
      !     End of contour line; starts an other contour
      !---------------------------------------------------------------------
      logical :: error                  !
    end subroutine fill_cont
  end interface
  !
  interface
    subroutine flush_tree(error)
      use greg_contours
      use greg_rg
      !---------------------------------------------------------------------
      ! @ private
      ! GREG	Internal routine
      !     End of contour line; Show it
      !---------------------------------------------------------------------
      logical, intent(out) :: error  !
    end subroutine flush_tree
  end interface
  !
  interface
    subroutine initialise_tree(current_leaf,error)
      use greg_contours
      !---------------------------------------------------------------------
      ! @ private
      !     Initialisation structure : 1 noeud, 2 feuilles.
      !     la Droite sera toujours vide
      !     VECT_I 	Occupation buffer
      !     next_cont	Liste chainee sur descripteurs deb_cont et fin_cont
      !     ( La fin de liste est un element next_cont nul, ce n'est pas
      !     un contour valide )
      !     deb_cont	Premier point liste chainee X_vect, Y_vect, next_vect
      !     fin_cont	Dernier point valide !!!       (ou 0 si aucun points)
      !     X_vect	Abscisse point
      !     Y_vect	Ordonnee
      !     next_vect	Pointeur element suivant. on y va Pen Up si
      !     next_vect est <0
      !     ( La fin de liste est un element next_vect nul, ce n'est pas
      !     un point valide )
      ! A NOTER QUE DANS CETTE VERSION IL N'Y A PAS DE NOTION DE PEN_UP
      !---------------------------------------------------------------------
      integer :: current_leaf           !
      logical :: error                  !
    end subroutine initialise_tree
  end interface
  !
  interface
    subroutine gris_minmax(feuille)
      !---------------------------------------------------------------------
      ! @ private
      !	MIN MAX sur une feuille
      !---------------------------------------------------------------------
      integer :: feuille                !
    end subroutine gris_minmax
  end interface
  !
  interface
    subroutine info_create(feuille,nvect,xmin,ymin,xmax,ymax,error)
      !---------------------------------------------------------------------
      ! @ private
      !
      !---------------------------------------------------------------------
      integer :: feuille                !
      integer :: nvect                  !
      integer :: xmin                   !
      integer :: ymin                   !
      integer :: xmax                   !
      integer :: ymax                   !
      logical :: error                  !
    end subroutine info_create
  end interface
  !
  interface
    subroutine info_write(feuille,nvect,xmin,ymin,xmax,ymax)
      !---------------------------------------------------------------------
      ! @ private
      !
      !---------------------------------------------------------------------
      integer :: feuille                !
      integer :: nvect                  !
      integer :: xmin                   !
      integer :: ymin                   !
      integer :: xmax                   !
      integer :: ymax                   !
    end subroutine info_write
  end interface
  !
  interface
    subroutine info_read(feuille,nvect,xmin,ymin,xmax,ymax)
      !---------------------------------------------------------------------
      ! @ private
      !
      !---------------------------------------------------------------------
      integer :: feuille                !
      integer :: nvect                  !
      integer :: xmin                   !
      integer :: ymin                   !
      integer :: xmax                   !
      integer :: ymax                   !
    end subroutine info_read
  end interface
  !
  interface
    subroutine get_triplet(nn,type,error)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      integer :: nn                     !
      integer :: type                   !
      logical :: error                  !
    end subroutine get_triplet
  end interface
  !
  interface
    subroutine init_search(nn,encore)
      !---------------------------------------------------------------------
      ! @ private
      ! initialise la quete sur une feuille de l'arbre
      !---------------------------------------------------------------------
      integer :: nn                     !
      logical :: encore                 !
    end subroutine init_search
  end interface
  !
  interface
    subroutine explore_tree (nn,encore)
      !---------------------------------------------------------------------
      ! @ private
      ! explore l'arbre dont les feuilles sont des contours...
      !---------------------------------------------------------------------
      integer :: nn                     !adresse feuille G ou D
      logical :: encore                 !
    end subroutine explore_tree
  end interface
  !
  interface
    subroutine bord (xa,ya,xb,yb,xmin,xmax,ymin,ymax,trigo,tx,ty,nt)
      !---------------------------------------------------------------------
      ! @ private
      !	Rajoute le bord
      !
      !	Xa, Ya		Fin de l'element de contour courant
      !	Xb, Yb		Debut du suivant
      !	Xmin, Ymin, ...	Valeur des bords
      !	Trigo		Logique, sens rotation trigo ou non.
      !	Tx(12)		Vecteur d'abcisses suivant le bord
      !	Ty(12)		Vecteur d'ordonnees suivant le bord
      !	Nt		Nombre de points suivant le bord
      !			( Tx(1) et Ty(1) sont Xa et Ya,
      !			  Tx(Nt) et Ty(Nt) sont Xb et Yb)
      !
      !	Attention -- Nt est renvoye nul sur erreur. Les valeurs possibles
      !	de Nt en sortie sont 0 (contour deja ferme) ou [2...12].
      !
      !				( PV, sous la surveillance de GD)
      !---------------------------------------------------------------------
      integer :: xa                     !
      integer :: ya                     !
      integer :: xb                     !
      integer :: yb                     !
      integer :: xmin                   !
      integer :: xmax                   !
      integer :: ymin                   !
      integer :: ymax                   !
      logical :: trigo                  !
      integer :: tx(12)                 !
      integer :: ty(12)                 !
      integer :: nt                     !
    end subroutine bord
  end interface
  !
  interface
    function modulo_gris (i,n)
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      integer :: modulo_gris            !
      integer :: i                      !
      integer :: n                      !
    end function modulo_gris
  end interface
  !
  interface
    subroutine find_border(feuille,caracterize,error)
      use greg_contours
      !---------------------------------------------------------------------
      ! @ private
      ! Expansion de la feuille pour ajouter des vecteurs de bord.
      ! En d'autres termes, on veut des contours fermes...
      ! On a 4 sortes de contours disponibles: ceux fermes
      ! sur eux-meme, ceux qui partent d'un point interieur et arrivent au
      ! bord, ceux qui partent du bord et arrivent a un point interieur,
      ! et ceux qui vont de bord a bord. les categories 2 et 3, apres tri,
      ! donnent une categorie 4 par chainage; il faut maintenant chainer
      ! la categorie 4 , apres tri, dans le sens "trigo" pour "fermer
      ! le contour gris le plus exterieur".
      ! Par la suite, un algorithme simple de coupure de feuille en 2
      ! donnera toujours des contours caracterises (et donc remplissables
      ! par des traceurs even-odd fill , non-zero-winding fill et
      ! circular-oriented fill )
      ! Bord stocke dans Tx et Ty les valeurs de vecteurs (le premier
      ! etant le dernier vecteur du contour precedent, le dernier
      ! etant le premier du contour actuel, nt le nbre de vecteurs (>= 2)
      !---------------------------------------------------------------------
      integer :: feuille                !
      logical :: caracterize            !dit si on doit caracteriser le bord
      logical :: error                  !
    end subroutine find_border
  end interface
  !
  interface
    function distance(xb,yb,xmin,xmax,ymin,ymax,trigo)
      !---------------------------------------------------------------------
      ! @ private
      ! Calcule une distance sur le bord oriente entre xmin,ymin et xb,yb
      !
      !	Xb, Yb		Debut du contour
      !	Xmin, Ymin, ...	Valeur des bords
      !	Trigo		Logique, sens rotation trigo ou non.
      !---------------------------------------------------------------------
      integer :: distance               !
      integer :: xb                     !
      integer :: yb                     !
      integer :: xmin                   !
      integer :: xmax                   !
      integer :: ymin                   !
      integer :: ymax                   !
      logical :: trigo                  !
    end function distance
  end interface
  !
  interface
    subroutine coupe_feuille(feuille,force,x,y,error)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ private
      !	coupe une feuille en 2 feuilles + 1 noeud
      !---------------------------------------------------------------------
      integer :: feuille                !
      logical :: force                  !
      integer :: x                      !
      integer :: y                      !
      logical :: error                  !
    end subroutine coupe_feuille
  end interface
  !
  interface
    subroutine menage(feuille)
      !---------------------------------------------------------------------
      ! @ private
      ! This routine cleans the contours, first by removing consecutive,
      ! identical points, then (parts of) contour that do not close any
      ! surface (i.e, line segments), then contours of .le. two points.
      !---------------------------------------------------------------------
      integer :: feuille                !
    end subroutine menage
  end interface
  !
  interface
    subroutine check_wind(feuille,wind,x,y)
      !---------------------------------------------------------------------
      ! @ private
      ! This routine looks for imbricated contours which do not turn in the same
      ! direction, (WIND=.TRUE.) suggesting a point (X,Y) where to cut this gordian
      ! knot.
      !---------------------------------------------------------------------
      integer :: feuille                !
      logical :: wind                   !
      integer :: x                      !
      integer :: y                      !
    end subroutine check_wind
  end interface
  !
  interface
    subroutine ghisto(line,error)
      use gildas_def
      use gbl_format
      use phys_const
      use gbl_message
      use sic_types
      use greg_kernel
      use greg_pen
      use greg_types
      use greg_xyz
      !---------------------------------------------------------------------
      ! @ private
      ! Support routine for command
      !   HISTOGRAM [Array_X Array_Y]
      ! 1   [/BLANKING  Bval Eval]
      ! 2   [/FILL [Icolor]]
      ! 3   [/BASE [Base]]
      ! 4   [/HATCH [Ipen] [Angle] [Separ] [Phase]]
      ! 5   [/Y]
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: line   !
      logical,          intent(inout) :: error  !
    end subroutine ghisto
  end interface
  !
  interface
    subroutine gr8_histo_base(nxy,x,y,nbase,base,bval,eval)
      use gildas_def
      !---------------------------------------------------------------------
      ! @ private-mandatory
      ! Connect a set of points with blanked values using histogram
      !---------------------------------------------------------------------
      integer(kind=size_length), intent(in) :: nxy          ! Number of points
      real(kind=8),              intent(in) :: x(nxy)       ! Array of X coordinates
      real(kind=8),              intent(in) :: y(nxy)       ! Array of Y coordinates
      integer(kind=size_length), intent(in) :: nbase        ! Number base points (1 or Nxy)
      real(kind=8),              intent(in) :: base(nbase)  ! Base value(s)
      real(kind=8),              intent(in) :: bval         ! Blanking value
      real(kind=8),              intent(in) :: eval         ! Tolerance on blanking
    end subroutine gr8_histo_base
  end interface
  !
  interface
    subroutine gr8_yxhisto_base(nxy,x,y,nbase,base,bval,eval)
      use gildas_def
      !---------------------------------------------------------------------
      ! @ private-mandatory
      !  Same as gr8_histo_base, but binning is along Y, and X provides the
      ! counts per bin. Bval/Eval apply on X.
      !---------------------------------------------------------------------
      integer(kind=size_length), intent(in) :: nxy          ! Number of points
      real(kind=8),              intent(in) :: x(nxy)       ! Array of X coordinates
      real(kind=8),              intent(in) :: y(nxy)       ! Array of Y coordinates
      integer(kind=size_length), intent(in) :: nbase        ! Number base points (1 or Nxy)
      real(kind=8),              intent(in) :: base(nbase)  ! Base value(s)
      real(kind=8),              intent(in) :: bval         ! Blanking value
      real(kind=8),              intent(in) :: eval         ! Tolerance on blanking
    end subroutine gr8_yxhisto_base
  end interface
  !
  interface
    subroutine greg_plot (line,error)
      !---------------------------------------------------------------------
      ! @ private
      ! GREG
      ! Support for command PLOT
      !  [GREG2\]PLOT [Var_name]
      !     [/BLANKING Bval Eval Colour]
      !     [/SCALING Type Low_cut High_cut]
      !     [/POSITION Posx1 Posx2 Posy1 Posy2]
      !     [/BOUNDARIES Userx1 Userx2 Usery1 Usery2]
      !     [/VISIBLE]
      !
      ! Usage:
      !   Var_name is a 2-D SIC variable name. Subsets like A[4] where A
      ! is a 3-D sic variable are not yet allowed. This command is normally
      ! used in the following sequence:
      !
      !     SET BOX LOCATION Gx1 Gx2 Gy1 Gy2  ! Define box position
      !     RGDATA /VARIABLE Var_name         ! Get characteristics from image.
      !     LIMITS /RGDATA                    ! Get limits
      !     PLOT Var_name                     ! Plot the array in the box
      !     BOX
      !     RGMAP                             ! Draw contour levels (...)
      !
      ! Without argument, the RG variable is plotted
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: line   ! Input command line
      logical,          intent(inout) :: error  ! Logical error flag
    end subroutine greg_plot
  end interface
  !
  interface
    subroutine im_plot (line,error)
      use gildas_def
      use gbl_format
      use gbl_message
      use sic_types
      use greg_kernel
      use greg_rg
      !---------------------------------------------------------------------
      ! @ private
      ! GREG
      ! Support for command PLOT
      !  [GREG2\]PLOT [Var_name]
      !     [/BLANKING Bval Eval Colour]
      !     [/SCALING Type Low_cut High_cut]
      !     [/POSITION Posx1 Posx2 Posy1 Posy2]
      !     [/BOUNDARIES Userx1 Userx2 Usery1 Usery2]
      !     [/VISIBLE]
      !
      ! Usage:
      !   Var_name is a 2-D SIC variable name. Subsets like A[4] where A
      ! is a 3-D sic variable are not yet allowed. This command is normally
      ! used in the following sequence:
      !
      !     SET BOX LOCATION Gx1 Gx2 Gy1 Gy2  ! Define box position
      !     RGDATA /VARIABLE Var_name         ! Get characteristics from image.
      !     LIMITS /RGDATA                    ! Get limits
      !     PLOT Var_name                     ! Plot the array in the box
      !     BOX
      !     RGMAP                             ! Draw contour levels (...)
      !
      ! Without argument, the RG variable is plotted
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: line   ! Input command line
      logical,          intent(inout) :: error  ! Logical error flag
    end subroutine im_plot
  end interface
  !
  interface
    subroutine plot_getvar(name,inca,error)
      use gildas_def
      use gbl_format
      use gbl_message
      use sic_types
      !---------------------------------------------------------------------
      ! @ private
      ! Check if the variable is something you can plot
      !---------------------------------------------------------------------
      character(len=*),       intent(in)    :: name   ! Variable name
      type(sic_descriptor_t), intent(out)   :: inca   ! REAL*4 incarnation
      logical,                intent(inout) :: error  ! Logical error flag
    end subroutine plot_getvar
  end interface
  !
  interface
    subroutine setdas(n)
      use greg_pen
      use greg_kernel
      use greg_wcs
      !---------------------------------------------------------------------
      ! @ private
      ! GREG	Internal routines
      !	This is a set of routines and entry points used to communicate
      !	with GREG internal commons without addressing the common
      !	themselves.
      !
      !	SETDAS	Calls GTEDIT with the dashed pattern N and other pen
      !		attributes of the current PENCIL. The modification is
      !		only valid until the next call to SETPEN. Sets PENUPD.
      !		HINT! SETDAS is inactive if the dashed pattern N has
      !		already been selected by a previous call to SETPEN or
      !		SETDAS.
      !	SETWEI	Idem for the weight attribute
      !	SETCOL	Idem for the colour attribute
      !
      !	INQDAS	Returns the current dashed pattern in use
      !		(Current pen, possibly altered by SETDAS)
      !	INQWEI	Idem for the weight attribute
      !	INQCOL	Idem for the colour attribute
      !
      !	SETPEN	Calls GTEDIT with the attributes of the current PENCIL.
      !		Resets any alterations by SETDAS, SETWEI, SETCOL.
      !		Resets the PENUPD flag which is set by PENCIL and by
      !		calls to SETDAS, SETWEI, SETCOL and SETPHYSICAL.
      !		To open a new segment with pen N :
      !			CALL GTSEGM('INQUIRE',ERROR)
      !			CALL SETPEN (N)
      !		To open a new segment with the current pen IPEN :
      !			CALL GTSEGM('INQUIRE',ERROR)
      !			IF (PENUPD) CALL SETPEN (IPEN)
      !---------------------------------------------------------------------
      integer :: n                      !
    end subroutine setdas
  end interface
  !
  interface
    subroutine setsys(system,equinox)
      use gbl_constant
      use greg_wcs
      !---------------------------------------------------------------------
      ! @ private
      !  Set the internal coordinate system (and equinox if relevant)
      !  Do not use out of Greg. Use gr8_system instead.
      !---------------------------------------------------------------------
      integer(kind=4), intent(in)           :: system
      real(kind=4),    intent(in), optional :: equinox
    end subroutine setsys
  end interface
  !
  interface
    subroutine labels(line,error)
      use greg_kernel
      use gbl_message
      !---------------------------------------------------------------------
      ! @ private
      ! GREG	Support routine for command
      !	LABEL "Un texte quelconque" [Orien] /APPEND /CENTERING n 
      !       /X [Yoffset] /Y [Xoffset]
      !---------------------------------------------------------------------
      character(len=*), intent(in) :: line          ! Command line
      logical, intent(inout) :: error               ! Error flag
    end subroutine labels
  end interface
  !
  interface
    subroutine xlabel(nchar,string,off)
      use greg_kernel
      use greg_pen
      use gbl_message
      !---------------------------------------------------------------------
      ! @ private
      ! GREG	Internal routine
      !	  Write an X label
      !---------------------------------------------------------------------
      integer(4), intent(in) :: nchar                ! Number of characters
      character(len=*), intent(in) :: string         ! String
      real(4), intent(in) :: off                     ! Offset in Y from axis
    end subroutine xlabel
  end interface
  !
  interface
    subroutine ylabel(nchar,string,off)
      use phys_const
      use gbl_message
      use greg_kernel
      use greg_pen
      !---------------------------------------------------------------------
      ! @ private
      ! GREG	Internal routine
      !	Write an Y label at proper position
      !---------------------------------------------------------------------
      integer(4), intent(in) :: nchar                ! Number of characters
      character(len=*), intent(in) :: string         ! String
      real(4), intent(in) :: off                     ! Offset in X from axis
    end subroutine ylabel
  end interface
  !
  interface
    subroutine putlabel(nchar,string,loc,angle,doclip)
      use phys_const
      use greg_kernel
      use greg_pen
      !---------------------------------------------------------------------
      ! @ private
      !  Puts a label according to location (VT100 numeric Keypad...)
      !     7 8 9
      !     4 5 6
      !     1 2 3
      ! Left, center or right in X and Y
      !---------------------------------------------------------------------
      integer(kind=4),  intent(in) :: nchar   ! Number of characters
      character(len=*), intent(in) :: string  ! String
      integer(kind=4),  intent(in) :: loc     ! Centering option
      real(kind=8),     intent(in) :: angle   ! [deg] Text angle
      logical,          intent(in) :: doclip  ! Clip the text to the current box?
    end subroutine putlabel
  end interface
  !
  interface
    subroutine label(nchar,string,angle,doclip)
      use phys_const
      !---------------------------------------------------------------------
      ! @ private
      ! Puts a label at current location, with current angle
      !---------------------------------------------------------------------
      integer(kind=4),  intent(in) :: nchar   ! Number of characters
      character(len=*), intent(in) :: string  ! String
      real(kind=8),     intent(in) :: angle   ! [deg] Text angle
      logical,          intent(in) :: doclip  ! Soft clipping?
    end subroutine label
  end interface
  !
  interface
    subroutine level(line,error)
      use gildas_def
      use sic_types
      use greg_contours
      use gbl_message
      !---------------------------------------------------------------------
      ! @ private
      ! GREG Support routine for command
      !   LEVELS n1 TO n2 BY n3 ...
      ! or
      !   LEVELS EXPO [Step [Number [Factor]]
      ! or
      !   LEVELS LevelArray
      !
      ! Contour definition for RGMAP or RANDOM_MAP
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: line   ! Command line
      logical,          intent(inout) :: error  ! Logical error flag
    end subroutine level
  end interface
  !
  interface
    subroutine limits(line,error)
      use gildas_def
      use gbl_format
      use gbl_message
      use sic_types
      use greg_kernel
      use greg_rg
      use greg_wcs
      use greg_xyz
      !---------------------------------------------------------------------
      ! @ private
      ! GREG Support routine for command
      !   LIMITS [X1 X2 Y1 Y2 [TYPE]]
      ! 1        [/XLOG]
      ! 2        [/YLOG]
      ! 3        [/RGDATA [Var_name]]
      ! 4        [/BLANKING]
      ! 5        [/REVERSE [X] [Y]]
      ! 6        [/VARIABLES Xv Yv]
      !
      ! With:
      !   Automatic computation if Xi     *
      !   Last value if                   =
      !   Union with last values          >
      !   Intersection with last values   <
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: line   ! Command line
      logical,          intent(inout) :: error  ! Logical error flag
    end subroutine limits
  end interface
  !
  interface
    subroutine setlim(ax1,ax2,ay1,ay2)
      use greg_kernel
      use gbl_message
      !---------------------------------------------------------------------
      ! @ private
      ! GREG  Internal routine
      !   Setup new limits and conversion formulae
      !---------------------------------------------------------------------
      real(kind=8), intent(in) :: ax1  ! Left limit of X axis
      real(kind=8), intent(in) :: ax2  ! Right limit of X axis
      real(kind=8), intent(in) :: ay1  ! Low limit of Y axis
      real(kind=8), intent(in) :: ay2  ! High limit of Y axis
    end subroutine setlim
  end interface
  !
  interface
    subroutine limits_margin(name,logf,xl,xr,lmarg,rmarg,error)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ private
      !  Apply margins on the provided range
      !  NB: margin can be negative, i.e. truncate the [xl-xr] range
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: name         ! Axis name
      logical,          intent(in)    :: logf         ! Log or linear axis?
      real(kind=8),     intent(inout) :: xl,xr        ! Current (in) and new (out) values
      real(kind=8),     intent(in)    :: lmarg,rmarg  ! Left and right margins (fraction of [xl-max])
      logical,          intent(inout) :: error        !
    end subroutine limits_margin
  end interface
  !
  interface
    subroutine exit_greg(error)
      use greg_kernel
      !---------------------------------------------------------------------
      ! @ private
      ! Clean the GREG-related components on exit
      !---------------------------------------------------------------------
      logical, intent(inout) :: error  ! Logical error flag
    end subroutine exit_greg
  end interface
  !
  interface
    subroutine greg_user(flagin,array)
      use greg_kernel
      use greg_pen
      !---------------------------------------------------------------------
      ! @ private-mandatory (because symbol is used elsewhere)
      !   Give or retrieve coordinate conversion formula to/from GTVIRT.
      ! The buffer is of size 26, same as the type 'greg_values' in the
      ! GTVIRT.
      !---------------------------------------------------------------------
      integer(kind=4), intent(in) :: flagin     !
      integer(kind=4)             :: array(26)  !
    end subroutine greg_user
  end interface
  !
  interface
    subroutine maskon(line,error)
      use gildas_def
      use gbl_message
      use greg_kernel
      use greg_poly
      use greg_rg
      !---------------------------------------------------------------------
      ! @ private
      ! GreG Support routine for command
      !  GREG2\MASK [IN|OUT] [/BLANKING Bval]
      ! Mask the inside or the outside of a polygon
      !---------------------------------------------------------------------
      character(len=*), intent(in)  :: line   ! Input command line
      logical,          intent(out) :: error  ! Logical error flag
    end subroutine maskon
  end interface
  !
  interface
    subroutine pencil(line,error)
      use greg_kernel
      use greg_pen
      use gbl_message
      !---------------------------------------------------------------------
      ! @ private
      ! Support routine for command:
      !  PEN [I|*]
      !      [/COLOUR Name]
      !      [/DASHED ND]
      !      [/WEIGHT NW|Valmm]
      !      [/DEFAULT]
      ! Define the status of the pen(s) or change the default pen
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: line   ! Input command line
      logical,          intent(inout) :: error  ! Logical error flag
    end subroutine pencil
  end interface
  !
  interface
    subroutine setpendef(kpen)
      use greg_pen
      !---------------------------------------------------------------------
      ! @ private
      !  Update all or single the pen attributes to their default, and
      ! reset the pen number
      !---------------------------------------------------------------------
      integer(kind=4), intent(in), optional :: kpen
    end subroutine setpendef
  end interface
  !
  interface
    subroutine plcurv4 (nxy,x,y,z,accur,algorithm,variable,periodic,grelo,gvect,  &
        error)
      use gildas_def
      use gbl_message
      !---------------------------------------------------------------------
      ! @ private
      ! GREG	Support routine
      !       This routine connects a series of points in the subject space
      !	with a solid line or a dashed line. Cubic spline interpolation
      !	is available either for functions of X or functions of Y or for
      !	curves (X and Y both interpolated, see below). If the number of
      !	points exceeds spline-buffer capacity, the total curve is cut
      !	into several arcs and care is taken to ensure a good fitting
      !	between two adjacent splines.
      !
      !	Adapted from PIGRA.  P. Valiron  16-OCT-84
      !
      !     /VARIABLE X : the variable is X (abscissa)
      !                  	*** Y = F(X)
      !     /VARIABLE Y : the variable is Y (ordinate)
      !                  	*** X = F(Y)
      !     /VARIABLE Z : the variable is the Z array
      !                  	*** explicit parametric form.
      !     /VARIABLE NUMBERING : the variable is the numbering of the points
      !                  *** The sequence of the points is related to a fixed
      !                      increment in an explicit or implicit parametrisa-
      !                      tion of the curve (plotting the solution of a dif
      !                      -ferential equation for equally spaced steps...)
      !     /VARIABLE POLYGONAL_LENGTH OR CURVILINEAR_LENGTH :
      !		   *** the variable is an approximation of the
      !			curvilinear abscissa
      !                  *** The curvilinear abscissa is estimated iteratively.
      !                  The starting approximation is the sum of the distan-
      !                  ces of the points. For each iteration, the spline
      !                  coefficients are computed and the curvilinear abscis-
      !                  sa is integrated along the spline curve.
      !		   The number of iterations is ITERMX.
      !			POLYGONAL_LENGTH	ITERMX=0
      !			CURVILINEAR_LENGTH	ITERMX=2
      ! Arguments :
      !	X	R*4 (*)	Array of X coordinates		Input
      !	Y	R*4 (*)	Array of Y coordinates		Input
      !	Z	R*4 (*)	Array of parameter values	Input
      !	ACCUR	R*4	Accuracy of interpolation	Input
      !	ALGORITHM C*(*)	Algorithm used by interpolation	Input
      !	VARIABLE  C*(*)	Variable used for interpolation	Input
      !	PERIODIC  L	Is it a periodic function	Input
      !	GRELO	Ext	Pen up plotting function	Input
      !	GVECT	Ext	Pen down plotting function	Input
      !	ERROR	L	Logical error flag		Output
      !---------------------------------------------------------------------
      integer(kind=size_length), intent(in) :: nxy  ! Number of data points
      real*4 :: x(1)                    !
      real*4 :: y(1)                    !
      real*4 :: z(1)                    !
      real :: accur                     !
      character(len=*) :: algorithm     !
      character(len=*) :: variable      !
      logical :: periodic               !
      external :: grelo                 !
      external :: gvect                 !
      logical :: error                  !
    end subroutine plcurv4
  end interface
  !
  interface
    subroutine curvil (s,error)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ private
      ! GREG	Internal routine
      !    	This routine is called by CURV to compute the curvilinear length
      !     	S of the spline arc [PSTO(K-1),PSTO(K)].
      !	RETURN 1 occurs if DIFSYS4 fails to integrate
      ! Arguments :
      !	S	R*4	Curvilinear length		Output
      !     ERROR	L	Error return		        Output
      ! Subroutines :
      !	CURFUN, DIFSYS4
      !---------------------------------------------------------------------
      real :: s                         !
      logical :: error                  !
    end subroutine curvil
  end interface
  !
  interface
    subroutine curfun (p,s,dsdp)
      !---------------------------------------------------------------------
      ! @ private-mandatory (because symbol is used elsewhere)
      ! GREG	Internal routine
      !	This routine states the differential equation to be solved by
      !	DIFSYS4 in order to obtain the curvilinear length of an arc of
      !	spline.
      ! Arguments :
      !	P	R*4	Value of parameter			Input
      !	S	R*4	Curvilinear length			Input
      !	DSDP	R*4	Derivative of S relative to P		Output
      !---------------------------------------------------------------------
      real :: p                         !
      real :: s                         !
      real :: dsdp                      !
    end subroutine curfun
  end interface
  !
  interface
    subroutine clip_poly(n,x,y,xc,yc)
      use gildas_def
      use gbl_message
      use greg_kernel
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      integer(kind=size_length), intent(inout) :: n      ! Number of summits (updated, may be 0 on return, may be more)
      real(kind=4),              intent(in)    :: x(:)   !
      real(kind=4),              intent(in)    :: y(:)   !
      real(kind=4),              intent(out)   :: xc(:)  !
      real(kind=4),              intent(out)   :: yc(:)  !
    end subroutine clip_poly
  end interface
  !
  interface
    subroutine clip_one (x0,y0,x1,y1,ok)
      use greg_kernel
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      real :: x0                        !
      real :: y0                        !
      real :: x1                        !
      real :: y1                        !
      logical :: ok                     !
    end subroutine clip_one
  end interface
  !
  interface
    subroutine setgon(line,error)
      use gildas_def
      use phys_const
      use gbl_message
      use greg_kernel
      use greg_poly
      use greg_types
      !---------------------------------------------------------------------
      ! @ private
      ! Support routine for command
      !   POLYGON [(File)Name]
      ! 1  [/PLOT]
      ! 2  [/VARIABLE]
      ! 3  [/FILL [Icolor]]
      ! 4  [/RESET]
      ! 5  [/HATCH [Ipen] [Angle] [Separ] [Phase]]
      !---------------------------------------------------------------------
      character(len=*), intent(in)  :: line
      logical,          intent(out) :: error
    end subroutine setgon
  end interface
  !
  interface
    subroutine greg_poly_delvar(varname,error)
      !---------------------------------------------------------------------
      ! @ private
      !  Delete the content of the polygon variable (NOT the structure
      ! itself: this is a program defined reserved name, always present)
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: varname  ! Support variable in Sic
      logical,          intent(inout) :: error    ! Input status preserved if no error here
    end subroutine greg_poly_delvar
  end interface
  !
  interface
    subroutine meanva(line,error)
      use gildas_def
      use gbl_message
      use greg_kernel
      use greg_poly
      use greg_rg
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      character(len=*), intent(in)  :: line
      logical,          intent(out) :: error
    end subroutine meanva
  end interface
  !
  interface
    subroutine gr8_moments(z,poly,b,eb,clip,center,range,sum,aire,npix,mean,  &
      sigma,minmax)
      use phys_const
      use greg_types
      use greg_rg
      !---------------------------------------------------------------------
      ! @ private
      ! Compute statistics about the regular grid array within a N-gon
      !---------------------------------------------------------------------
      real(kind=4),    intent(in)  :: z(*)       ! Regular grid array
      type(polygon_t), intent(in)  :: poly       ! Current polygon
      real(kind=4),    intent(in)  :: b          ! Blanking value
      real(kind=4),    intent(in)  :: eb         ! Tolerance on blanking
      logical,         intent(in)  :: clip       ! Clip out of range values
      real(kind=4),    intent(in)  :: center     ! Center of accepted interval
      real(kind=4),    intent(in)  :: range      ! Half width of accepted interval
      real(kind=4),    intent(out) :: sum        ! Integrated map value
      real(kind=4),    intent(out) :: aire       ! Area of polygon
      integer(kind=4), intent(out) :: npix       ! Number of interior pixels
      real(kind=4),    intent(out) :: mean       ! Mean map value
      real(kind=4),    intent(out) :: sigma      ! RMS value
      real(kind=4),    intent(out) :: minmax(2)  ! Min and max values
    end subroutine gr8_moments
  end interface
  !
  interface
    subroutine print_mean(sum,aire,npix,mean,sigma,minmax)
      use phys_const
      use gbl_message
      use greg_wcs
      !---------------------------------------------------------------------
      ! @ private
      ! Print statistics about the regular grid array within a N-gon
      !---------------------------------------------------------------------
      real(kind=4),    intent(in) :: sum        ! Integrated map value
      real(kind=4),    intent(in) :: aire       ! Area of polygon
      integer(kind=4), intent(in) :: npix       ! Number of pixels within polygon
      real(kind=4),    intent(in) :: mean       ! Mean map value
      real(kind=4),    intent(in) :: sigma      ! RMS value
      real(kind=4),    intent(in) :: minmax(2)  ! Min and max values
    end subroutine print_mean
  end interface
  !
  interface
    subroutine greg_poly_loadsub(rname,poly,lun,chain,error)
      use gildas_def
      use gbl_message
      use greg_types
      !---------------------------------------------------------------------
      ! @ private
      !  Defines a polygon, either from file, from variable, or with the
      ! cursor.
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: rname  ! Calling command name
      type(polygon_t),  intent(out)   :: poly   ! Defined polygon
      integer(kind=4),  intent(in)    :: lun    ! Logical unit number (0=>Cursor)
      character(len=*), intent(in)    :: chain  ! Variable name
      logical,          intent(inout) :: error  ! Logical error flag
    end subroutine greg_poly_loadsub
  end interface
  !
  interface
    subroutine greg_poly_variable(rname,varname,poly,error)
      use gbl_format
      use gbl_message
      use sic_types
      use greg_types
      !---------------------------------------------------------------------
      ! @ private
      ! Define the polygon from a Sic variable name. The variables can be:
      !  - a real or double array of the form:
      !       VAR[NXY,2]  Real or Double
      !  - a structure of the form:
      !       VAR%NXY         Integer or Long
      !       VAR%X[VAR%NXY]  Real or Double
      !       VAR%Y[VAR%NXY]  Real or Double
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: rname    ! Calling routine name
      character(len=*), intent(in)    :: varname  ! Sic variable name
      type(polygon_t),  intent(out)   :: poly     ! Defined polygon
      logical,          intent(inout) :: error    ! Logical error flag
    end subroutine greg_poly_variable
  end interface
  !
  interface
    subroutine greg_convert(line,error)
      use gildas_def
      use phys_const
      use gbl_format
      use gbl_message
      use gwcs_types
      use sic_types
      use greg_xyz
      use greg_wcs
      !---------------------------------------------------------------------
      ! @ private
      ! Support routine for command
      !    CONVERT RA0 DEC0 [ANGLE]
      !    1  [/TYPE P_TYPE]
      !    2  [/UNIT]
      !    3  [/SYSTEM EQUATORIAL|GALACTIC [Equinox]]
      !    4  [/VARIABLE A B]
      ! Converts from one projection system or absolute coordinates to the
      ! current projection system.
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: line   ! Command line
      logical,          intent(inout) :: error  ! Logical error flag
    end subroutine greg_convert
  end interface
  !
  interface
    subroutine defpro(line,error)
      use phys_const
      use gbl_message
      use greg_wcs
      !---------------------------------------------------------------------
      ! @ private
      ! GREG Support routine for command
      !    PROJECTION [Ra Dec] [Angle] [/TYPE Type]
      ! Defines the projection type and center
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: line   !
      logical,          intent(inout) :: error  !
    end subroutine defpro
  end interface
  !
  interface
    subroutine greg_grid(line,error)
      !---------------------------------------------------------------------
      ! @ private
      ! Support routine for command
      !  GRID Step [/LABEL] [/ALTERNATE]
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: line   !
      logical,          intent(inout) :: error  ! Logical error flag
    end subroutine greg_grid
  end interface
  !
  interface
    subroutine gridmp(line,error)
      use phys_const
      use gbl_message
      use greg_wcs
      !---------------------------------------------------------------------
      ! @ private
      ! Support routine for command
      !  GRID Step [/LABEL]
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: line   !
      logical,          intent(inout) :: error  ! Logical error flag
    end subroutine gridmp
  end interface
  !
  interface
    subroutine galac(line,error)
      use gbl_message
      use phys_const
      use gwcs_types
      use greg_wcs
      !---------------------------------------------------------------------
      ! @ private
      ! Support routine for command GRID
      !  Plot a Lii/Bii grid onto a RA-DEC plot or Vice-Versa
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: line   !
      logical,          intent(inout) :: error  !
    end subroutine galac
  end interface
  !
  interface
    subroutine meridien(ra,myrelocate,mydraw,error)
      use gildas_def
      use phys_const
      use gbl_message
      use greg_kernel
      use greg_wcs
      !---------------------------------------------------------------------
      ! @ private
      !  Plot the meridian at a given RA
      !---------------------------------------------------------------------
      real(kind=8), intent(in)    :: ra          ! Right ascension of meridian
      external                    :: myrelocate  !
      external                    :: mydraw      !
      logical,      intent(inout) :: error       ! Logical error flag
    end subroutine meridien
  end interface
  !
  interface
    subroutine parallele(dec,myrelocate,mydraw,error)
      use gildas_def
      use phys_const
      use gbl_message
      use greg_kernel
      use greg_wcs
      !---------------------------------------------------------------------
      ! @ private
      !  Draw a parallel
      !---------------------------------------------------------------------
      real(kind=8), intent(in)    :: dec         ! Declination
      external                    :: myrelocate  !
      external                    :: mydraw      !
      logical,      intent(inout) :: error       ! Logical error flag
    end subroutine parallele
  end interface
  !
  interface
    subroutine grid_label(proj,ra,dec,dora,error)
      use gildas_def
      use phys_const
      use greg_kernel
      use greg_wcs
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      type(projection_t), intent(in)    :: proj    ! Projection description
      real(kind=8),       intent(in)    :: ra,dec  ! [rad]
      logical,            intent(in)    :: dora    ! Do RA or DEC?
      logical,            intent(inout) :: error   !
    end subroutine grid_label
  end interface
  !
  interface
    subroutine setrem
      use greg_kernel
      use greg_wcs
      !---------------------------------------------------------------------
      ! @ private
      ! MAP	Computes the coordinates in the absolute system
      !	of the remarkable points of the projection
      !
      ! There are 6 privileged points
      !
      !	2------------4-------------6
      !	|                          |
      !	|                          |	RX,RY	Relative coordinates
      !	|                          |
      !	|                          |	AX,AY	Absolute coordinates
      !	|                          |
      !	1------------3-------------5
      !
      !
      ! En fait en cas d'angle non nul, la methode ci-dessus ne marche plus.
      ! Une astuce COLOSSALE consiste a considerer le plus petit cercle contenant
      ! le rectangle et centre sur le centre de projection. Ce cercle est la
      ! projection de points angulairement equidistants du centre de projection.
      ! Or, en projection GNOMONIC, les points d'elongations extremes
      ! correspondent aux tangentes au cercle passant par le pole.
      ! i.e.	Xgnom	= 	SQRT(Yg(POLE)**2 - D**2) * D / Yg(POLE)
      !	Ygnom	=	D**2 / Yg(POLE)
      ! Les coordonnees absolues s'en deduise trivialement
      !
      ! Pour la declinaison, le probleme est evident.
      !
      ! Bien sur tout ca ne marche pas avec les projections AITOFF et RADIO .
      !---------------------------------------------------------------------
      ! Global
    end subroutine setrem
  end interface
  !
  interface
    function lever(d,d0)
      !---------------------------------------------------------------------
      ! @ private
      !	Lever d'une etoile de declinaison D a latitude D0
      !
      !	PI/2-D0 < D	Circumpolaire
      !	D0-PI/2 < D < PI/2-D0	H = ACOS (TAN(D)/TAN(D0-PI/2))
      !	D < D0-PI/2	Toujours couchee...
      !
      ! Formule applicable a la partie visible du ciel en projection
      ! sur un plan
      !---------------------------------------------------------------------
      real*8 :: lever                   !
      real*8 :: d                       !
      real*8 :: d0                      !
    end function lever
  end interface
  !
  interface
    subroutine sexfor(xa,ya)
      use phys_const
      use gbl_message
      use greg_wcs
      !---------------------------------------------------------------------
      ! @ private
      !  Makes a nice format for projection information
      !
      !  Coordinates are displayed with 0.1 milliarcsecond precision
      !  (prec=2.78e-8 degrees), namely:
      !  a) log10(360/(24*3600*prec)) = 5.2 digits fractional part for 24
      !     div/turn sexagesimal notation (Right Ascension)
      !  b) log10(360/(360*3600*prec)) = 4 digits fractional part for 360
      !     div/turn sexagesimal notation (Declination)
      !  c) log10(360/(360*prec)) = 7.6 digits fractional part for 360
      !     div/turn decimal notation (Latitude/Longitude)
      !---------------------------------------------------------------------
      real(kind=8), intent(in) :: xa  ! X position
      real(kind=8), intent(in) :: ya  ! Y position
    end subroutine sexfor
  end interface
  !
  interface
    subroutine rgimag(line,optrgdata,dosubset,optsubset,error)
      use gildas_def
      use gbl_format
      use gbl_constant
      use gbl_message
      use sic_types
      use greg_image
      use greg_rg
      !---------------------------------------------------------------------
      ! @ private
      ! Support routine for subset of commands
      !   RGDATA  Name
      !     /VARIABLE
      !     [/SUBSET]
      ! and
      !   LIMITS /RGDATA  Name
      ! Load RG data from variable name
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: line       ! Command line
      integer(kind=4),  intent(in)    :: optrgdata  ! RG data option
      logical,          intent(in)    :: dosubset   ! Subset option present?
      integer(kind=4),  intent(in)    :: optsubset  ! Subset option number, if relevant
      logical,          intent(inout) :: error      ! Error flag
    end subroutine rgimag
  end interface
  !
  interface
    subroutine rgrsd(line,error)
      use gildas_def
      use gbl_format
      use gbl_message
      use sic_types
      use greg_kernel
      use greg_rg
      !---------------------------------------------------------------------
      ! @ private
      ! Subroutine for Regularly Spaced Data, possibly uncompletely sampled,
      ! in column (XYZ or other variables) "format".
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: line   ! Command line
      logical,          intent(inout) :: error  !
    end subroutine rgrsd
  end interface
  !
  interface
    subroutine greg_rgdata(line,error)
      use gildas_def
      use gbl_constant
      use gbl_format
      use gbl_message
      use greg_image
      use greg_kernel
      use greg_rg
      !---------------------------------------------------------------------
      ! @ private
      ! Support routine for command
      !  RGDATA Name
      !   [/SUBSET Imin Jmin Imax Jmax]
      !   [/VARIABLE]
      !   [/FORMAT fmt_code]
      !  Read a RGDATA file into the Regular grid array
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: line   !
      logical,          intent(inout) :: error  ! Logical error flag
    end subroutine greg_rgdata
  end interface
  !
  interface
    subroutine rghead (error)
      use greg_kernel
      use greg_image
      use gbl_message
      !---------------------------------------------------------------------
      ! @ private
      ! GREG	Internal routine
      !	This subroutine reads a map header and retrieves the following
      ! 	information for later use by GREG
      !		XREF, NX, XVAL, XINC, XUNIT
      !		YREF, NY, YVAL, YINC, YUNIT
      ! Arguments :
      !	NX	I	Number of X pixels		Output
      !	NY	I	Number of Y pixels		Output
      !	*	*	Alternate error return		Input
      ! No subroutine referenced
      ! Commons	GRUNIT, FITS
      !---------------------------------------------------------------------
      logical :: error                  !
    end subroutine rghead
  end interface
  !
  interface
    subroutine rgread(regmap,all,nfx,nfy,fmt,error)
      use gbl_message
      use greg_kernel
      use greg_image
      use greg_rg
      !---------------------------------------------------------------------
      ! @ private
      ! GREG 	Internal routine
      !	  Read the data in a RGDATA file
      !   An optional format can be specified. Default is 10Z8.8
      !---------------------------------------------------------------------
      integer, intent(in) :: nfx                    ! X grid size
      integer, intent(in) :: nfy                    ! Y grid size
      real(4), intent(out):: regmap(nfx*nfy)        ! Grid values
      logical, intent(in) :: all                    ! Read all map ?
      character(len=*), intent(in) :: fmt           ! Format for reading
      logical, intent(out) :: error                 !
    end subroutine rgread
  end interface
  !
  interface
    subroutine rgread_all(regmap,nfx,nfy,fmt,code,error)
      use gbl_format
      use gbl_message
      use greg_kernel
      use greg_image
      use greg_rg
      !---------------------------------------------------------------------
      ! @ private
      ! GREG 	Internal routine
      !	Read the data in a RGDATA file
      ! Arguments :
      !     REGMAP	R*4 (*)	Regular grid array to be filled		Output
      !     NFX	I*4	First map dimension			Output
      !     NFY	I*4	Second map dimension			Output
      !     FMT	C*(*)	Data file format			Input
      !     CODE      I*4     Input data type                         Input
      !     ERROR	L	Error return			        Output
      !---------------------------------------------------------------------
      integer, intent(in) :: nfx                    ! X grid size
      integer, intent(in) :: nfy                    ! Y grid size
      real(4), intent(out):: regmap(nfx*nfy)        ! Grid values
      character(len=*), intent(in) :: fmt           ! Format for reading
      integer, intent(in) :: code                   ! Type of data
      logical, intent(out) :: error                 !
    end subroutine rgread_all
  end interface
  !
  interface
    subroutine find_mapchar8(x,y,n,xinc,yinc,xmin,ymin,xmax,ymax,eb,cb)
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      integer :: n                      !
      real(8) :: x(n)                    !
      real(8) :: y(n)                    !
      real(8) :: xinc                    !
      real(8) :: yinc                    !
      real(8) :: xmin                    !
      real(8) :: ymin                    !
      real(8) :: xmax                    !
      real(8) :: ymax                    !
      real(8) :: eb                      !
      real(8) :: cb                      !
    end subroutine find_mapchar8
  end interface
  !
  interface
    subroutine find_siz8(x,y,n,xmin,xmax,ymin,ymax,eb,cb)
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      integer :: n                      !
      real(8) :: x(n)                    !
      real(8) :: y(n)                    !
      real(8) :: xmin                    !
      real(8) :: xmax                    !
      real(8) :: ymin                    !
      real(8) :: ymax                    !
      real(8) :: eb                      !
      real(8) :: cb                      !
    end subroutine find_siz8
  end interface
  !
  interface
    subroutine reallocate_rgdata(mx,my,error)
      use gildas_def
      use gbl_message
      use greg_rg
      !---------------------------------------------------------------------
      ! @ private
      !  (Re)allocate the RG buffer, taking care of its previous allocation
      ! status.
      !---------------------------------------------------------------------
      integer(kind=4), intent(in)    :: mx     !
      integer(kind=4), intent(in)    :: my     !
      logical,         intent(inout) :: error  !
    end subroutine reallocate_rgdata
  end interface
  !
  interface
    subroutine reassociate_rgdata(rgbuf,mx,my,error)
      use gildas_def
      use gbl_message
      use greg_rg
      !---------------------------------------------------------------------
      ! @ private
      !  (Re)associate the RG buffer, taking care of its previous allocation
      ! status.
      ! ---
      !  Bug fix. Using an explicit-shape dummy argument
      !     real(kind=4), intent(in), target :: rgbuf(mx,my)
      ! and pointing to it:
      !     rg%data => rgbuf
      ! is processor-dependent according to the Fortran. See Fortran 2003
      ! Section 12.4.1.2:
      !  "If the dummy argument has the TARGET attribute and is an
      ! explicit-shape array or is an assumed-size array, and the corresponding
      ! actual argument has the TARGET attribute but is not an array section
      ! with a vector subscript then:
      !   1) [...]
      !   2) when execution of the procedure completes, the pointer association
      !      status of any pointer that is pointer associated with the dummy
      !      argument is processor dependent."
      ! In other words, when sending the data array to the subroutine, the
      ! caller may send a copy of the actual argument, so that the dummy
      ! argument is contiguous and satisfies the explicit-shape declaration.
      !
      !   Ifort 9.0 to 14.0.1 (at least): seems indeed affected by this. The
      ! association status "seems" correct in return, but according to the
      ! standard the pointer association status is undefined (i.e. not
      ! reliable). In practice, a subsequent deallocation of the pointer
      ! fails if the allocation has been stealed to the target in the
      ! context:
      !  pointer :: a,b
      !  allocate(a)
      !  b => a
      !  deallocate(b)
      ! This is done in some cases.
      !
      !  On the other hand, one can use an assumed-shape dummy argument:
      !    real(kind=4), intent(in), target :: rgbuf(:,:)
      ! In this case, the caller knows the interface and can send the actual
      ! array (maybe with strides and boundaries specific to the call), so
      ! that it is not a problem to associate a pointer.
      !---------------------------------------------------------------------
      integer(kind=4), intent(in)         :: mx          !
      integer(kind=4), intent(in)         :: my          !
      real(kind=4),    intent(in), target :: rgbuf(:,:)  !
      logical,         intent(inout)      :: error       !
    end subroutine reassociate_rgdata
  end interface
  !
  interface
    subroutine deallocate_rgdata(error)
      use gildas_def
      use greg_rg
      !---------------------------------------------------------------------
      ! @ private
      !  Deallocate the RG buffer, taking care of its previous allocation
      ! status.
      !---------------------------------------------------------------------
      logical, intent(inout) :: error  !
    end subroutine deallocate_rgdata
  end interface
  !
  interface
    subroutine greg_write(line,error)
      use gbl_format
      use gbl_message
      use greg_kernel
      use greg_poly
      use greg_rg
      use greg_xyz
      !---------------------------------------------------------------------
      ! @ private
      ! GREG	Support routine for command
      !
      !   WRITE
      !     COLUMN Filename [NEW [Format]] /TABLE X Nx Y Ny z Nz
      !     IMAGE
      !     RGDATA Filename "Comment X" "Comment Y"
      !     POLYGON
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: line   ! Command line
      logical,          intent(inout) :: error  ! Error flag
    end subroutine greg_write
  end interface
  !
  interface
    subroutine greg_write_column(line,fname,error)
      use image_def
      use gbl_message
      use greg_xyz
      !---------------------------------------------------------------------
      ! @ private
      ! Support routine for command
      !   WRITE COLUMN Filename [NEW [Format]] /TABLE X Nx Y Ny z Nz
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: line
      character(len=*), intent(in)    :: fname
      logical,          intent(inout) :: error
    end subroutine greg_write_column
  end interface
  !
  interface
    subroutine greg_write_rgdata(line,jtmp,regmap,mreg,error)
      use greg_rg
      !---------------------------------------------------------------------
      ! @ private
      !  Writes a RGDATA like file from the Regular_Grid array
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: line          ! Input command line
      integer(kind=4),  intent(in)    :: jtmp          ! Logical unit number
      integer(kind=4),  intent(in)    :: mreg          ! Size of array
      real(kind=4),     intent(in)    :: regmap(mreg)  ! Array to write
      logical,          intent(inout) :: error         ! Logical error flag
    end subroutine greg_write_rgdata
  end interface
  !
  interface
    subroutine wrcol2(jun,n,x,y)
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      integer(kind=4), intent(in) :: jun   !
      integer(kind=4), intent(in) :: n     !
      real(kind=8),    intent(in) :: x(*)  !
      real(kind=8),    intent(in) :: y(*)  !
    end subroutine wrcol2
  end interface
  !
  interface
    subroutine wrcol3(jun,n,x,y,z)
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      integer(kind=4), intent(in) :: jun   !
      integer(kind=4), intent(in) :: n     !
      real(kind=8),    intent(in) :: x(*)  !
      real(kind=8),    intent(in) :: y(*)  !
      real(kind=8),    intent(in) :: z(*)  !
    end subroutine wrcol3
  end interface
  !
  interface
    subroutine greg_write_image(name,array,error)
      use gildas_def
      use gbl_message
      use gbl_format
      use phys_const
      use greg_wcs
      use greg_kernel
      use greg_rg
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: name      ! File name
      real(kind=4),     intent(in)    :: array(*)  ! Data array
      logical,          intent(inout) :: error     ! Error flag
    end subroutine greg_write_image
  end interface
  !
  interface
    subroutine sampler(line,error)
      use gildas_def
      use gbl_message
      use greg_kernel
      use greg_rg
      !---------------------------------------------------------------------
      ! @ private
      ! GREG	Support routine for Command
      !	RESAMPLE NX NY/ [/X Xref Xval Xinc] [/Y Yref Yval Yinc]
      !		[/BLANKING Blank]
      ! 	Resample the current Regular Grid onto a different one.
      ! Arguments :
      !	LINE	C*(*)	Command line		Input
      !	ERROR	L	Logical error flag	Output
      !---------------------------------------------------------------------
      character(len=*) :: line          !
      logical :: error                  !
    end subroutine sampler
  end interface
  !
  interface
    subroutine resamp(a,mx,my,aconv,ablank,b,nx,ny,bconv)
      !---------------------------------------------------------------------
      ! @ private
      ! GREG	Stand alone subroutine
      !	Resample an input map to a different grid. bilinear interpolation.
      ! Arguments
      !	A	R*4(*)	Input map of dimensions MX MY
      !	MX,MY	I
      !	ACONV	R*8(6)	Pixel conversion formulae
      !			CONV(1) = Xref, CONV(2)=Xval, CONV(3)=Xinc
      !	B	R*4(*)	Output map of dimensions NX,NY
      !	NX,NY	I
      !	BCONV	R*8(6)
      !	BLANK	R*4	Blanking value
      !---------------------------------------------------------------------
      integer :: mx                     !
      integer :: my                     !
      real*4 :: a(mx,my)                !
      real*8 :: aconv(6)                !
      real*4 :: ablank(2)               !
      integer :: nx                     !
      integer :: ny                     !
      real*4 :: b(nx,ny)                !
      real*8 :: bconv(6)                !
    end subroutine resamp
  end interface
  !
  interface
    subroutine setup(line,error)
      use greg_kernel
      use greg_pen
      use greg_xyz
      use greg_axes
      use greg_image
      use greg_wcs
      use gbl_message
      !---------------------------------------------------------------------
      ! @ private
      !  GREG Support routine for command
      !  SET ...
      !---------------------------------------------------------------------
      character(len=*), intent(inout) :: line   ! Command line
      logical,          intent(out)   :: error  !
    end subroutine setup
  end interface
  !
  interface
    subroutine greg_show(line,error)
      use gbl_message
      use greg_kernel
      use greg_pen
      use greg_axes
      use greg_wcs
      !---------------------------------------------------------------------
      ! @ private
      !  GREG  Support routine for command
      !  SHOW
      !---------------------------------------------------------------------
      character(len=*), intent(in)  :: line   ! Command line
      logical,          intent(out) :: error  ! Logical error flag
    end subroutine greg_show
  end interface
  !
  interface
    subroutine show_limits(line,error)
      use phys_const
      use gbl_constant
      use gbl_message
      use greg_kernel
      use greg_wcs
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: line   !
      logical,          intent(inout) :: error  !
    end subroutine show_limits
  end interface
  !
  interface
    subroutine spanum_to_greg(string,nchar,doexpo)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ private
      !   This subroutine converts a floating point number produced by
      ! SPANUM such as 1.234E+07 or 1.E+12 in a string of characters
      ! allowing usual exponential notation with GREG e.g.
      !                              7
      !     1.2345E+07 -->  1.2345 10
      !
      !                       12
      !     1.E+12  ----->  10
      !
      !                         -8
      !     2.E-08  ----->  2 10
      !---------------------------------------------------------------------
      character(len=*), intent(inout) :: string  ! Character string to convert
      integer(kind=4),  intent(inout) :: nchar   ! Length of string
      logical,          intent(in)    :: doexpo  ! Prefer exponential notation when possible?
    end subroutine spanum_to_greg
  end interface
  !
  interface
    subroutine gag_cflabh(chrstr,x,w,d,type,short)
      !---------------------------------------------------------------------
      ! @ private
      !  Convert floating point value to a display of the form of the
      ! "Babylonian" ddd mm ss.s, where each field represents a sexagesimal
      ! increment over its successor. The value X must be in the units of
      ! the rightmost field. For instance, X must be in seconds of time for
      ! hours, minutes, seconds
      !
      ! This routine insert the proper labelling in GreG style display.
      !---------------------------------------------------------------------
      character(len=*), intent(out) :: chrstr  ! Formatted string
      real(kind=8),     intent(in)  :: x       ! Input number
      integer(kind=4),  intent(out) :: w       ! Length of string
      integer(kind=4),  intent(in)  :: d       ! Number of decimals
      integer(kind=4),  intent(in)  :: type    ! Type of label (None/Hour/Degree)
      logical,          intent(in)  :: short   ! Drop off zero-leading fields?
    end subroutine gag_cflabh
  end interface
  !
  interface
    subroutine gstring(n,string,angle,doclip)
      use greg_kernel
      !---------------------------------------------------------------------
      ! @ private
      !   Interprets and writes a character string
      !---------------------------------------------------------------------
      integer(kind=4),  intent(in) :: n       ! Length of string
      character(len=*), intent(in) :: string  !
      real(kind=8),     intent(in) :: angle   ! Text angle, in radians
      logical,          intent(in) :: doclip  ! Clip the text in the box?
    end subroutine gstring
  end interface
  !
  interface
    subroutine gvaleur (line,error)
      use gildas_def
      use gbl_format
      use gbl_message
      use sic_types
      use greg_kernel
      use greg_xyz
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      character(len=*)                :: line   !
      logical,          intent(inout) :: error  !
    end subroutine gvaleur
  end interface
  !
  interface
    subroutine greg_variables
      use greg_contours
      use greg_kernel
      use greg_rg
      use greg_wcs
      use greg_xyz
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      ! Local
    end subroutine greg_variables
  end interface
  !
  interface
    subroutine greg_set_structure(error)
      !---------------------------------------------------------------------
      ! @ private
      ! Create the structure SET%GREG and fill it.
      !---------------------------------------------------------------------
      logical, intent(inout) :: error  ! Logical error flag
    end subroutine greg_set_structure
  end interface
  !
  interface
    subroutine grwedge(line,error)
      use gbl_message
      use gbl_format
      use gildas_def
      use phys_const
      use sic_types
      use greg_kernel
      use greg_axes
      use greg_contours
      use greg_pen
      use greg_types
      !---------------------------------------------------------------------
      ! @ private
      ! GreG
      !  Support routine for command
      !  WEDGE [Top|Bottom|Left|Right [Size]]
      !  1     [/SCALING Lin|Log Min Max]
      !  2     [/LEVELS [YES] ]
      !---------------------------------------------------------------------
      character(len=*)                :: line   !
      logical,          intent(inout) :: error  !
    end subroutine grwedge
  end interface
  !
  interface
    subroutine zmont(z,id1,nxi,nxf,nyi,nyf,x0,y0,dx,dy,az,el,fe)
      !---------------------------------------------------------------------
      ! @ private
      !  This subroutine plots a perspective of profiles of a bidimensional
      ! functions. (L. DELGADO Yebes 1983)
      !---------------------------------------------------------------------
      integer(kind=4), intent(in)    :: id1       ! First dimension of Z
      real(kind=4),    intent(inout) :: z(id1,*)  ! Function values array, destroyed in the process
      integer(kind=4), intent(in)    :: nxi       ! First index to be shown in X
      integer(kind=4), intent(in)    :: nxf       ! Last index to be shown in X
      integer(kind=4), intent(in)    :: nyi       ! First index to be shown in Y
      integer(kind=4), intent(in)    :: nyf       ! Last index to be shown in Y
      real(kind=4),    intent(in)    :: x0        ! X paper coordinate of lower left point for Z=0.
      real(kind=4),    intent(in)    :: y0        ! Y paper coordinate of this point
      real(kind=4),    intent(in)    :: dx        ! X Size of projection area
      real(kind=4),    intent(in)    :: dy        ! Y Size of projection area
      real(kind=4),    intent(in)    :: az        ! Azimuth of projection (-90<AZ<90)
      real(kind=4),    intent(in)    :: el        ! Elevation of projection (0<EL<90)
      real(kind=4),    intent(in)    :: fe        ! Scaling factor in Z
    end subroutine zmont
  end interface
  !
  interface
    subroutine zsom(z,id1,x0,axx,axy,nxi,nxf,nyi,i,j)
      !---------------------------------------------------------------------
      ! @ private
      !  This subroutine is used by ZMONT for determining visible areas
      !---------------------------------------------------------------------
      integer(kind=4), intent(in) :: id1       ! First dimension of Z
      real(kind=4),    intent(in) :: z(id1,*)  ! Function values array
      real(kind=4),    intent(in) :: x0        ! X paper coordinate of lower left point for Z=0
      real(kind=4),    intent(in) :: axx       ! X paper coordinate increment between consecutive lines
      real(kind=4),    intent(in) :: axy       ! Y paper coordinate increment
      integer(kind=4), intent(in) :: nxi       ! First index to be shown in X
      integer(kind=4), intent(in) :: nxf       ! Last index to be shown in X
      integer(kind=4), intent(in) :: nyi       ! First index to be shown in Y
      integer(kind=4), intent(in) :: i         ! X Index of the starting point of current line
      integer(kind=4), intent(in) :: j         ! Y Index of this point
    end subroutine zsom
  end interface
  !
  interface
    subroutine zmx(z,id1,ili,ilf,l,xili,axx,xi,yi,xf,yf)
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      integer(kind=4), intent(in)    :: id1       !
      real(kind=4),    intent(in)    :: z(id1,*)  !
      integer(kind=4), intent(in)    :: ili,ilf   !
      integer(kind=4), intent(in)    :: l         !
      real(kind=4),    intent(in)    :: xili      !
      real(kind=4),    intent(in)    :: axx       !
      real(kind=4),    intent(inout) :: xi,yi     !
      real(kind=4),    intent(inout) :: xf,yf     !
    end subroutine zmx
  end interface
  !
end module greg_interfaces_private

subroutine exec_greg(buffer)
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>exec_greg
  use gildas_def
  use greg_kernel
  use gbl_message
  !---------------------------------------------------------------------
  ! @ public (but should not)
  !---------------------------------------------------------------------
  character(len=*) :: buffer        !
  ! Local
  character(len=*), parameter :: rname='GREG'
  character(len=2048) :: line
  character(len=12) :: lang
  character(len=12) :: comm
  logical :: error
  integer :: icode,ocode
  !
  if (library) goto 99
  line = buffer
  icode = -1
  !
  error = .false.
  do while (.true.)
    call sic_run (line,lang,comm,error,icode,ocode)
    if (ocode.eq.-1) return    ! From subroutine mode
    if (ocode.eq.1) return     ! Final return
    select case (lang)
    case('GREG1')
      call run_greg1(line,comm,error)
    case('GREG2')
      call run_greg2(line,comm,error)
    case('GREG3')
      call run_greg3(line,comm,error)
    case('GTVL')
      call run_gtvl(line,comm,error)
      if (comm.eq.'CLEAR') call greset
    case('VECTOR')
      call run_vector(line,comm,error)
    case default
      call greg_message(seve%e,rname,'Unknown Language '//lang)
      error = .true.
    end select
    error = error .or. gterrtst()
    icode = 0
  enddo
  !
99 call greg_message(seve%f,rname,'Call to *_GREG with GreG loaded in '//  &
   'Library Mode')
  call sysexi (fatale)
end subroutine exec_greg
!
recursive subroutine run_greg1(line,comm,error)
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>run_greg1
  use gbl_message
  !---------------------------------------------------------------------
  ! @ public-mandatory (public but should not) (mandatory because symbol
  ! is used elsewhere)
  !	Dispatch the command line
  ! Arguments :
  !	LINE	C*(*)	Command line			Input/Output
  !	COMM	C*(*)	Command				Input
  !	ERROR	L	Logical error flag		Output
  !---------------------------------------------------------------------
  character(len=*) :: line          !
  character(len=*) :: comm          !
  logical :: error                  !
  ! Local
  character(len=*), parameter :: rname='GREG1'
  integer, save :: icall=0
  !
  if (icall.ne.0)  &
    call greg_message(seve%d,rname,'Reentrant call to RUN_GREG1 '//comm)
  !
  icall = icall+1
  !
  call greg_message(seve%c,rname,line)
  !
  error = .false.
  select case (comm)
  case('AXIS')
    call gr_segm(comm,error)
    call greg_axis(line,error)  ! Calls SETDAS
    call gtsegm_close(error)
  case('BOX')
    call greg_box(line,error)   ! Calls SETDAS
  case('CONNECT')
    call gr_segm(comm,error)
    call gconne(line,error)
    call gtsegm_close(error)
  case('COLUMN')
    call column(line,error)
  case('CORNERS')
    call greg_corners(line,error)
  case('CURVE')
    call gr_segm(comm,error)
    call curve(line,error)
    call gtsegm_close(error)
  case('DRAW')
    ! Calls GR_SEGM(COMM,ERROR), and SETPEN [SETDAS]
    call curse(line,error)
  case('ERRORBAR')
    call bars(line,error)
  case('HISTOGRAM')
    call ghisto(line,error)
  case('LABEL')
    call gr_segm(comm,error)
    call labels(line,error)    ! Calls SETDAS
    call gtsegm_close(error)
  case('LIMITS')
    call limits(line,error)
  case('PENCIL')
    call pencil(line,error)
  case('POINTS')
    call gr_segm(comm,error)
    call greg_point(line,error)    ! Calls SETDAS
    call gtsegm_close(error)
  case('SHOW')
    call greg_show(line,error)
  case('SET')
    call setup(line,error)
  case('RULE')
    call gr_segm(comm,error)
    call greg_rule(line,error)
    call gtsegm_close(error)
  case('TICKSPACE')
    call greg_tickspace(line,error)
  case('VALUES')
    call gr_segm(comm,error)
    call gvaleur(line,error)
    call gtsegm_close(error)
  case('LOOK')
    call glook(line,error)
  case default
    call greg_message(seve%w,rname,'No code to execute for '//comm)
    error = .true.
  end select
  !
  icall = icall-1
end subroutine run_greg1
!
subroutine run_greg2(line,comm,error)
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>run_greg2
  use gbl_message
  !---------------------------------------------------------------------
  ! @ public-mandatory (public but should not) (mandatory because symbol
  ! is used elsewhere)
  ! This entry is for 2-D analysis
  !---------------------------------------------------------------------
  character(len=*) :: line          !
  character(len=*) :: comm          !
  logical :: error                  !
  ! Local
  character(len=*), parameter :: rname='GREG2'
  integer, save :: icall=0
  !
  if (icall.ne.0)  &
    call greg_message(seve%d,rname,'Reentrant call to RUN_GREG2 '//comm)
  !
  icall = icall+1
  !
  call greg_message(seve%c,rname,line)
  !
  error = .false.
  select case (comm)
  case('ARROW')
    call greg_arrow(line,error)
  case('RGMAP')
    call conmap(line,error)
  case('LEVELS')
    call level(line,error)
  case('EXTREMA')
    call greg_extrema(line,error)
! case('FITS')
!   call fits(line,error)
  case('PLOT')
    call greg_plot(line,error)
  case('RGDATA')
    call greg_rgdata(line,error)
  case('PERSPECTIVE')
    call threed(line,error)
  case('RANDOM_MAP')
    call gr_segm(comm,error)
    call gridder(line,error)
    call gtsegm_close(error)
  case('WRITE')
    call greg_write(line,error)
  case('ELLIPSE')
    call ellipse(line,error)
  case('MEAN')
    call meanva(line,error)
  case('MASK')
    call maskon(line,error)
  case('POLYGON')
    call setgon(line,error)
  case('STRIP')
    call rstrip(line,error)
  case('CONVERT')
    call greg_convert(line,error)
  case('PROJECTION')
    call defpro(line,error)
  case('GRID')
    call greg_grid(line,error)
  case('RESAMPLE')
    call sampler(line,error)
  case('WEDGE')
    call grwedge(line,error)
  case default
    call greg_message(seve%w,rname,'No code to execute for '//comm)
    error = .true.
  end select
  !
  icall = icall-1
end subroutine run_greg2

!
subroutine debug_all(line,error)
  !$ use omp_lib
  use gkernel_interfaces
  use imager_interfaces, except_this => debug_all
  use clean_def
  use clean_arrays
  use clean_types
  use clean_default
  use gbl_message
  !----------------------------------------------------------------------
  ! @  private
  !
  !! IMAGER  -- Support routine for command DEBUG
  !----------------------------------------------------------------------
  character(len=*), intent(inout) :: line  !! Command line
  logical, intent(out) :: error            !! Logical error flag
  !
  ! Constants
  integer, parameter :: mvoc=8
  character(len=8) :: voca(mvoc)
  data voca /'BUFFERS', 'DEBUG',  'MEMORY', 'METHOD', 'OPTIMIZE', &
    & 'SG', 'THREADS ', 'USER    '/
  ! Local ---
  character(len=8) :: name,argum
  integer :: n, nc, ier, mthread
  integer, allocatable :: mic(:)
  !
  ! Code ----
  argum = '?'
  call sic_ke(line,0,1,argum,n,.false.,error)
  if (error) return
  call sic_ambigs ('DUMP',argum,name,n,voca,mvoc,error)
  if (error) return
  !
  select case(name)
  case ('MEMORY')
    call dump_memory(error)
  case ('USER') 
     call mapping_print_debug(user_method)
  case ('METHOD') 
     call mapping_print_debug(the_method)
  case ('BUFFERS') 
    call uv_dump_buffers('DUMP')
  case ('SG') 
    !
    nc = huv_current%gil%nchan
    if (nc.ne.hcct%gil%dim(2)) then
      Print *,'Mismatch number of channels between HUV ',nc,' and CCT ',hcct%gil%dim(2)
    endif
    !
    allocate(mic(nc),stat=ier)
    call uv_clean_sizes(hcct,dcct,mic,1,nc)
    Print *,'SG_DEBUG -- MIC ',mic
    deallocate(mic)
  case ('THREADS') 
    mthread = 0
    !$ mthread = omp_get_max_threads()
    Print *,'Number of Threads ',mthread
  case ('DEBUG') 
    call sub_print_idebug('DEBUG_APPLY','SELFCAL APPLY')
    call sub_print_debug('DEBUG_CCT','CCT_MERGE')
    call sub_print_debug('DEBUG_GAUSS','CLEAN with GAUSS method')
    call sub_print_debug('DEBUG_MULTI','CLEAN with MULTI method')
    call sub_print_debug('DEBUG_CONT','MAP_CONTINUUM')
    call sub_print_debug('DEBUG_MASK','MASK')
    call sub_print_debug('DEBUG_GUETH','UV_MAP in Mosaic mode GUETH')
    call sub_print_idebug('DEBUG_RESTORE','UV_RESTORE')
    call sub_print_idebug('DEBUG_SAULT','UV_MAP Mosaic mode SAULT')
    call sub_print_debug('DEBUG_MOSAIC','UV_MAP in Mosaic mode')
    call sub_print_idebug('DEBUG_UVMAP','UV_MAP')
    call sub_print_debug('DEBUG_SELF','SELFCAL')
    call sub_print_debug('DEBUG_STOKES','STOKES')
    call sub_print_debug('DEBUG_PREVIEW','UV_PREVIEW')
    call sub_print_debug('DEBUG_RESIDUAL','UV_RESIDUAL and/or UV_RESTORE')
    error = .false.
  case ('OPTIMIZE')
    !! call debug_optimize
  end select
  !
end subroutine debug_all
!
subroutine sub_print_debug(var,purpose)
  character(len=*), intent(in) :: var
  character(len=*), intent(in) :: purpose
  logical :: error, debug
  !
  debug = .false.
  call sic_get_logi(var,debug,error)
  if (error) then
    write(*,'(A,T20,A,T40,A)') var,' logical undefined',' (for '//purpose//') '
  else
    write(*,'(A,T20,A,L,T40,A)') var,' is set to ',debug,' (for '//purpose//') '
  endif
end subroutine sub_print_debug
!
subroutine sub_print_idebug(var,purpose)
  character(len=*), intent(in) :: var
  character(len=*), intent(in) :: purpose
  logical :: error
  integer :: idebug
  !
  idebug = 0
  call sic_get_inte(var,idebug,error)
  if (error) then
    write(*,'(A,T20,A,T40,A)') var,' integer undefined',' (for '//purpose//') '
  else
    write(*,'(A,T20,A,I3,T40,A)') var,' is set to ',idebug,' (for '//purpose//') '
  endif
end subroutine sub_print_idebug
!
subroutine print_imaging(comm,name,img)
  use image_def
  use gbl_message
  use imager_interfaces, only : map_message
  ! @ private
  !!    Print a Debug message to track selected channels
  character(len=*),intent(in) :: comm     !! Command name
  character(len=*),intent(in) :: name     !! Buffer name
  type(imaging_mode), intent(in) :: img   !! Imaging structure
  !
  character(len=128) :: chain
  character(len=14) :: img_mode(-1:1)
  data img_mode /'Continuum --', 'No Imaging --', 'Cube -- '/
  !
  write(chain,'(A,A,I0,A,I0,A,F9.3,A,I0)') name//' -- ', &
    & trim(img_mode(img%mode))//" from [", &
    & img%bounds(1),",",img%bounds(2),"]  Reference ",img%chfreq, &
    & "    Weight ",img%weight
  if (comm.ne.' ') then
    call map_message(seve%i,comm,chain,seve%w)
  else
    write(*,'(A)') trim(chain)
  endif
end subroutine print_imaging

subroutine defpro(line,error)
  use phys_const
  use gbl_message
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>defpro
  use greg_wcs
  !---------------------------------------------------------------------
  ! @ private
  ! GREG Support routine for command
  !    PROJECTION [Ra Dec] [Angle] [/TYPE Type]
  ! Defines the projection type and center
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line   !
  logical,          intent(inout) :: error  !
  ! Local
  character(len=*), parameter :: rname='PROJECTION'
  character(len=13) :: argum,keywor,projnam_array(0:mproj)
  character(len=80) :: chain
  character(len=24) :: prochain
  real(kind=8) :: ra,dec,ang
  integer(kind=4) :: nkey,type,nc
  character(len=6), parameter :: angu(4) = (/ 'SECOND','MINUTE','DEGREE','RADIAN' /)
  !
  ! Decode projection type
  type = gproj%type
  if (sic_present(1,0)) then
    if (.not.sic_present(1,1)) then
      type = p_none
    else
      call sic_ke (line,1,1,argum,nc,.true.,error)
      if (error) return
      !
      call projnam_list(projnam_array)
      call sic_ambigs(rname,argum,keywor,nkey,projnam_array,mproj+1,error)
      if (error) return
      type = nkey-1
    endif
  endif
  !
  ! Decode center
  if (sic_present(0,1)) then
    if (type.ne.p_aitoff) then
      call sic_ke (line,0,2,prochain,nc,.true.,error)
      call sic_sexa(prochain,nc,dec,error)
      if (error) return
      dec = pi*dec/180.0d0
    else
      call greg_message(seve%w,rname,'Declination ignored in AITOFF')
    endif
    call sic_ke (line,0,1,prochain,nc,.true.,error)
    call sic_sexa(prochain,nc,ra,error)
    if (error) return
    if (i_system.eq.type_eq .or. i_system.eq.type_ic) then
      ra = pi*ra/12.0d0
    else
      ra = pi*ra/180.0d0
    endif
    ang = 0.d0
    if (sic_present(0,3)) then
      if (type.eq.p_aitoff) then
        call greg_message(seve%w,rname,'Angle ignored in AITOFF')
      elseif (type.eq.p_radio) then
        call greg_message(seve%w,rname,'Angle ignored in RADIO')
      else
        call sic_ke(line,0,3,prochain,nc,.true.,error)
        call sic_sexa(prochain,nc,ang,error)
        if (error) return
        ang = pi*ang/180.0d0
      endif
    endif
    !
    ! Set it only if specified
    call gwcs_projec(ra,dec,ang,type,gproj,error)
    if (error)  return
    call setrem
    !
  else
    gproj%type = type  ! Simpler than calling gwcs_projec
  endif
  !
  if (type.eq.p_none) then
    call greg_message(seve%i,rname,'No projection defined')
    if (type.eq.p_none .and. u_angle.ne.u_radian) then
      chain = 'Angular unit is '//angu(u_angle)
      call greg_message(seve%w,rname,chain)
    endif
  else
    write (chain,110) projnam(gproj%type),180.d0*gproj%angle/pi
    call greg_message(seve%r,rname,chain)
    call sexfor(0.d0,0.d0)
  endif
  !
110 format('Projection ',a,' at angle ',f12.6,' from center')
end subroutine defpro

subroutine vsinit (array,npage)
  use gildas_def
  use gbl_format
  use gbl_message
  use gchar_dependencies_interfaces
  use gchar_interfaces
  !---------------------------------------------------------------------
  ! @ no-interface (because 'vstrsh1' is used as 1st word of a common block)
  ! CHAR	Initialise the common from the disk file
  !---------------------------------------------------------------------
  integer :: npage                  !
  logical :: array(128,npage)       !
  ! Local
  character(len=4) :: ficode,sycode
  integer :: i,ier,lun
  character(len=filename_length) :: filnam
  !
  if (.not.sic_query_file('gag_font','data#dir:','',filnam)) then
    call gchar_message(seve%f,'VSINIT','gag_font not found')
    call sysexi(fatale)
  endif
  !
  ier = sic_getlun(lun)
  if (mod(ier,2).eq.0) call sysexi (ier)
  open(unit=lun,status='OLD',file=filnam,form='UNFORMATTED',access='DIRECT',  &
       recl=facunf*128)
  do i=1,npage
    call wread (lun,array(1,i),i)
  enddo
  !
  call bytoch(array(1,1),ficode,4)
  call gdf_getcod(sycode)
  !
  if (ficode.ne.sycode) then
    call gchar_message(seve%w,'CHAR','Font File not in native format')
    call vsconv (ficode,sycode)
  else
    call gchar_message(seve%d,'CHAR','Fonts loaded')
  endif
  close(unit=lun)
  call sic_frelun (lun)
end subroutine vsinit
!
subroutine wread (iunit,array,block)
  !---------------------------------------------------------------------
  ! @ no-interface (because of type mismatch)
  !---------------------------------------------------------------------
  integer :: iunit                  !
  integer :: array(128)             !
  integer :: block                  !
  read  (unit=iunit,rec=block) array
end subroutine wread

program gauss_smooth
  use gildas_def
  use gbl_format
  use phys_const
  use image_def
  use gbl_message
  use gkernel_interfaces
  !---------------------------------------------------------------------
  !   Main program for 2D smoothing in fourier plane by an elliptical
  ! gaussian.
  !   First 2 dimensions (in pixels) should be powers of two, but the
  ! map doesn't need to be square. Map is plunged into a factor 2
  ! larger image to avoid aliasing.
  !---------------------------------------------------------------------
  character(len=*), parameter :: pname = 'GAUSS_SMOOTH'
  character(len=filename_length) :: namex,namey
  logical :: error
  real(kind=8) :: bmaj,bmin,pa
  real(kind=4) :: bmaj4,bmin4,pa4
  integer(kind=4) :: i, j, nx, ny, nxy, ndim, dim(2), mx, my, ier
  complex(kind=4), allocatable :: cdata(:,:)
  real(kind=4), allocatable :: rdata(:,:), work(:)
  type(gildas) :: x,y
  character(len=message_length) :: mess
  !
  call gildas_open
  call gildas_char('Y_NAME$',namey)
  call gildas_char('X_NAME$',namex)
  call gildas_dble('MAJOR$',bmaj,1)
  call gildas_dble('MINOR$',bmin,1)
  call gildas_dble('PA$',pa,1)
  call gildas_close
  !
  call gildas_null(y)
  call gdf_read_gildas(y,namey,'.gdf',error,data=.false.)
  if (error) then
    call gagout ('F-'//pname//',  Cannot read input file')
    goto 100
  endif
  !
  ! Prepare the output header
  call gildas_null(x)
  call gdf_copy_header(y,x,error)
  x%gil%extr_words = 0  ! Disable extrema section
  !
  ! Resolution section if present
  if (x%gil%reso_words.gt.0) then
    bmaj4 = bmaj
    bmin4 = bmin
    pa4 = pa*rad_per_deg
    call gdf_gauss2d_convolution(x,bmaj4,bmin4,pa4,error)
    if (error)  goto 99
    write(mess,'(A,3(1PG14.7,A))')  &
      'I-'//pname//', Smoothed beam is ', &
      x%gil%majo*sec_per_rad,' x ',  &
      x%gil%mino*sec_per_rad,' sec (PA ', &
      x%gil%posa*deg_per_rad,' deg)'
    call gagout(mess)
    !
  endif
  !
  ! Create output image
  call sic_parsef(namex,x%file,' ','.gdf')
  call gdf_create_image (x,error)
  if (error) then
    call gagout ('F-'//pname//',  Cannot create output image')
    goto 100
  endif
  !
  mx = x%gil%dim(1)
  my = x%gil%dim(2)
  !
  nx = 2*mx
  ny = 2*my
  ndim = 2
  dim(1) = nx
  dim(2) = ny
  nxy = nx * ny 
  allocate (work(2*max(nx,ny)), cdata(nx, ny), rdata(mx,my), stat=ier)
  if (ier.ne.0) goto 99
  !
  call fourt_plan (cdata,dim,ndim,1,0)
  call fourt_plan (cdata,dim,ndim,-1,1)
  do j=1,x%gil%dim(4)
    x%blc(4) = j
    x%trc(4) = j
    do i=1,x%gil%dim(3)
      x%blc(3) = i
      x%trc(3) = i
      y%blc = x%blc
      y%trc = x%trc
      call gdf_read_data(y,rdata,error)
      !
      call copyc (mx,my,rdata,nx,ny,cdata)
      call fourt (cdata,dim,ndim,1,0,work)
      call mulgau(cdata,nx,ny,   &
     &        bmaj,bmin,pa,x%gil%inc(1),x%gil%inc(2))
      call fourt (cdata,dim,ndim,-1,+1,work)
      !
      call copyn (nx,ny,cdata,mx,my,rdata)
      call gdf_write_data (x,rdata,error)
    enddo
  enddo
  call gagout ('S-'//pname//',  Successful completion')
  call sysexi (1)
  !
99 call gagout ('F-'//pname//',  Lost my mind')
100 call sysexi (fatale)
end program gauss_smooth
!
subroutine copyc(mx,my,r,nx,ny,c)
  !---------------------------------------------------------------------
  !     Insert Real array R(NX,NY) into Complex array C(MX,MY)
  !---------------------------------------------------------------------
  integer :: mx                     !
  integer :: my                     !
  real :: r(mx,my)                  !
  integer :: nx                     !
  integer :: ny                     !
  complex :: c(nx,ny)                !
  ! Local
  integer :: i,j,i0,j0
  !
  c = 0.0
  !
  i0 = nx/2-mx/2
  j0 = ny/2-my/2
  !
  do j=1,my
    do i=1,mx
      c(i+i0,j+j0) = r(i,j)
    enddo
  enddo
end subroutine copyc
!
subroutine copyn(nx,ny,c,mx,my,r)
  !---------------------------------------------------------------------
  !     Copy and normalize the result
  !     Extract Real array R(NX,NY) from Complex array C(MX,MY)
  !---------------------------------------------------------------------
  integer :: nx                     !
  integer :: ny                     !
  complex :: c(nx,ny)               !
  integer :: mx                     !
  integer :: my                     !
  real :: r(mx,my)                  !
  ! Local
  integer :: i,j,i0,j0
  real :: w
  !
  i0 = nx/2-mx/2
  j0 = ny/2-my/2
  !
  w = 1.0/(nx*ny)
  do j=1,my
    do i=1,mx
      r(i,j) = real(c(i+i0,j+j0)) * w
    enddo
  enddo
end subroutine copyn
!
subroutine mulgau(data,nx,ny,bmaj,bmin,pa,x_inc1,x_inc2)
  !---------------------------------------------------------------------
  ! GDF   Multiply the TF of an image by the TF of
  !       a convolving gaussian function. BMAJ and BMIN are the
  !       widths of the original gaussian. PA is the position angle of major
  !       axis (from north towards east)
  !---------------------------------------------------------------------
  integer :: nx                     !
  integer :: ny                     !
  complex :: data(nx,ny)            !
  real*8 :: bmaj                    !
  real*8 :: bmin                    !
  real*8 :: pa                      !
  real*8 :: x_inc1                  !
  real*8 :: x_inc2                  !
  ! Local
  integer :: i,j,nx1,nx2
  real :: amaj,amin,fact,cx,cy,sx,sy
  logical :: norot,rot90
  real*8 :: pi,rpa
  parameter (pi=3.141592653589793d0)
  real*4 :: eps
  parameter (eps=1.e-7)
  !
  norot = ( abs(mod(pa,180.d0)).le.eps)
  rot90 = ( abs(mod(pa,180.d0)-90.d0).le.eps)
  amaj = bmaj*pi/(2.*sqrt(log(2.)))
  amin = bmin*pi/(2.*sqrt(log(2.)))
  rpa = pa*pi/180.d0
  !
  cx = cos(rpa)/nx*amin
  cy = cos(rpa)/ny*amaj
  sx = sin(rpa)/nx*amaj
  sy = sin(rpa)/ny*amin
  !
  ! Convert map units to pixels
  cx = cx / x_inc1
  cy = cy / x_inc2
  sx = sx / x_inc1
  sy = sy / x_inc2
  nx2 = nx/2
  nx1 = nx2+1
  !
  ! Optimised code for Position Angle 0 degrees
  if (norot) then
    do j=1,ny/2
      do i=1,nx2
        fact = (float(j-1)*cy)**2 + (float(i-1)*cx)**2
        if (fact.lt.80.) then
          fact = exp (-fact)
          data(i,j) = data(i,j)*fact
        else
          data(i,j) = 0.
        endif
      enddo
      do i=nx1,nx
        fact = (float(j-1)*cy)**2 + (float(i-nx-1)*cx)**2
        if (fact.lt.80.) then
          fact = exp (-fact)
          data(i,j) = data(i,j)*fact
        else
          data(i,j) = 0.
        endif
      enddo
    enddo
    do j=ny/2+1,ny
      do i=1,nx2
        fact = (float(j-ny-1)*cy)**2 + (float(i-1)*cx)**2
        if (fact.lt.80.) then
          fact = exp (-fact)
          data(i,j) = data(i,j)*fact
        else
          data(i,j) = 0.
        endif
      enddo
      do i=nx1,nx
        fact = (float(j-ny-1)*cy)**2 + (float(i-nx-1)*cx)**2
        if (fact.lt.80.) then
          fact = exp (-fact)
          data(i,j) = data(i,j)*fact
        else
          data(i,j) = 0.
        endif
      enddo
    enddo
    !
    ! Optimised code for Position Angle 90 degrees
  elseif (rot90) then
    do j=1,ny/2
      do i=1,nx2
        fact = (float(i-1)*sx)**2 +(float(j-1)*sy)**2
        if (fact.lt.80.) then
          fact = exp (-fact)
          data(i,j) = data(i,j)*fact
        else
          data(i,j) = 0.
        endif
      enddo
      do i=nx1,nx
        fact = (float(i-nx-1)*sx)**2 + (float(j-1)*sy)**2
        if (fact.lt.80.) then
          fact = exp (-fact)
          data(i,j) = data(i,j)*fact
        else
          data(i,j) = 0.
        endif
      enddo
    enddo
    do j=ny/2+1,ny
      do i=1,nx2
        fact = (float(i-1)*sx)**2 + (float(j-ny-1)*sy)**2
        if (fact.lt.80.) then
          fact = exp (-fact)
          data(i,j) = data(i,j)*fact
        else
          data(i,j) = 0.
        endif
      enddo
      do i=nx1,nx
        fact = (float(i-nx-1)*sx)**2 + (float(j-ny-1)*sy)**2
        if (fact.lt.80.) then
          fact = exp (-fact)
          data(i,j) = data(i,j)*fact
        else
          data(i,j) = 0.
        endif
      enddo
    enddo
    !
    ! General case of a rotated elliptical gaussian
  else
    do j=1,ny/2
      do i=1,nx2
        fact = (float(i-1)*sx + float(j-1)*cy)**2 +   &
     &          (-float(i-1)*cx + float(j-1)*sy)**2
        if (fact.lt.80.) then
          fact = exp (-fact)
          data(i,j) = data(i,j)*fact
        else
          data(i,j) = 0.
        endif
      enddo
      do i=nx1,nx
        fact = (float(i-nx-1)*sx + float(j-1)*cy)**2 +   &
     &          ( -float(i-nx-1)*cx + float(j-1)*sy)**2
        if (fact.lt.80.) then
          fact = exp (-fact)
          data(i,j) = data(i,j)*fact
        else
          data(i,j) = 0.
        endif
      enddo
    enddo
    do j=ny/2+1,ny
      do i=1,nx2
        fact = (float(i-1)*sx + float(j-ny-1)*cy)**2 +   &
     &          ( -float(i-1)*cx + float(j-ny-1)*sy)**2
        if (fact.lt.80.) then
          fact = exp (-fact)
          data(i,j) = data(i,j)*fact
        else
          data(i,j) = 0.
        endif
      enddo
      do i=nx1,nx
        fact = (float(i-nx-1)*sx   &
     &          + float(j-ny-1)*cy)**2 +   &
     &          ( -float(i-nx-1)*cx + float(j-ny-1)*sy)**2
        if (fact.lt.80.) then
          fact = exp (-fact)
          data(i,j) = data(i,j)*fact
        else
          data(i,j) = 0.
        endif
      enddo
    enddo
  endif
end subroutine mulgau

subroutine gr8_connect(nxy,x,y,bval,eval)
  use gildas_def
  use greg_interfaces
  !---------------------------------------------------------------------
  ! @ no-interface (because of type mismatch)
  !   Connect a polyline with blanking value
  !---------------------------------------------------------------------
  integer(kind=4) :: nxy                    ! Number of data points
  real(kind=8)    :: x(nxy)                 ! Array of X coordinates
  real(kind=8)    :: y(nxy)                 ! Array of Y coordinates
  real(kind=8)    :: bval                   ! Blanking value
  real(kind=8)    :: eval                   ! Tolerance on blanking value
  ! Local
  integer(kind=size_length) :: j,n,js
  integer(kind=size_length), parameter :: gtv_max_poly=1024  ! GTV internal limit for polylines
  ! Buffers are SAVE'd to avoid reallocation each time entering this subroutine. Is this useful?
  real(kind=4), save :: xwork(gtv_max_poly), ywork(gtv_max_poly)
  !
  if (nxy.lt.2) return
  j = 1
  js= 1
  n = 0
  do while (.true.)
    if (y(j).eq.y(j).and.abs(y(j)-bval).gt.eval) then
      if (n.eq.gtv_max_poly) then
        call us8_to_int(x(js),y(js),xwork,ywork,n)
        call grpoly(n,xwork,ywork)
        js = j-1
        n = 1
      endif
      if (j.eq.nxy) then
        n = n+1
        call us8_to_int(x(js),y(js),xwork,ywork,n)
        if (n.gt.1) then
          call grpoly(n,xwork,ywork)
        else
          call grelocate(xwork(1),ywork(1))
          call gdraw(xwork,ywork)
        endif
        return
      endif
      n = n+1
      j = j+1
    else
      if (n.gt.1) then
        call us8_to_int(x(js),y(js),xwork,ywork,n)
        call grpoly(n,xwork,ywork)
      elseif (n.eq.1) then
        call us8_to_int(x(js),y(js),xwork,ywork,n)
        call grelocate(xwork(1),ywork(1))
        call gdraw(xwork,ywork)
      endif
      n = 0
      j = j+1
      if (j.gt.nxy) return
      do while ( (y(j).ne.y(j)).or.(abs(y(j)-bval).le.eval) )
        j = j+1
        if (j.gt.nxy) return
      enddo
      js = j
    endif
  enddo
end subroutine gr8_connect
!
subroutine gr4_connect(nxy,x,y,bval,eval)
  use gildas_def
  use greg_interfaces
  !---------------------------------------------------------------------
  ! @ no-interface (because of type mismatch)
  !   Connect a polyline with blanking value
  !---------------------------------------------------------------------
  integer(kind=4) :: nxy                    ! Number of data points
  real(kind=4)    :: x(nxy)                 ! Array of X coordinates
  real(kind=4)    :: y(nxy)                 ! Array of Y coordinates
  real(kind=4)    :: bval                   ! Blanking value
  real(kind=4)    :: eval                   ! Tolerance on blanking value
  ! Local
  integer(kind=size_length) :: j,n,js
  integer(kind=size_length), parameter :: gtv_max_poly=1024  ! GTV internal limit for polylines
  ! Buffers are SAVE'd to avoid reallocation each time entering this subroutine. Is this useful?
  real(kind=4), save :: xwork(gtv_max_poly), ywork(gtv_max_poly)
  !
  if (nxy.lt.2) return
  j = 1
  js= 1
  n = 0
  do while (.true.)
    if (y(j).eq.y(j).and.abs(y(j)-bval).gt.eval) then
      if (n.eq.gtv_max_poly) then
        call us4_to_int(x(js),y(js),xwork,ywork,n)
        call grpoly(n,xwork,ywork)
        js = j-1
        n = 1
      endif
      if (j.eq.nxy) then
        n = n+1
        call us4_to_int(x(js),y(js),xwork,ywork,n)
        if (n.gt.1) then
          call grpoly(n,xwork,ywork)
        else
          call grelocate(xwork(1),ywork(1))
          call gdraw(xwork,ywork)
        endif
        return
      endif
      n = n+1
      j = j+1
    else
      if (n.gt.1) then
        call us4_to_int(x(js),y(js),xwork,ywork,n)
        call grpoly(n,xwork,ywork)
      elseif (n.eq.1) then
        call us4_to_int(x(js),y(js),xwork,ywork,n)
        call grelocate(xwork(1),ywork(1))
        call gdraw(xwork,ywork)
      endif
      n = 0
      j = j+1
      if (j.gt.nxy) return
      do while ( (y(j).ne.y(j)).or.(abs(y(j)-bval).le.eval) )
        j = j+1
        if (j.gt.nxy) return
      enddo
      js = j
    endif
  enddo
end subroutine gr4_connect
!
subroutine gr8_marker(nxy,x,y,bval,eval)
  use gildas_def
  use greg_interfaces, except_this=>gr8_marker
  !---------------------------------------------------------------------
  ! @ public-mandatory (because symbol is used elsewhere)
  !   Plot markers with blanking value
  !---------------------------------------------------------------------
  integer(kind=4) :: nxy                    ! Number of data points
  real(kind=8)    :: x(nxy)                 ! Array of X coordinates
  real(kind=8)    :: y(nxy)                 ! Array of Y coordinates
  real(kind=8)    :: bval                   ! Blanking value
  real(kind=8)    :: eval                   ! Tolerance on blanking value
  ! Local
  integer(kind=4) :: nsides,istyle
  integer(kind=size_length) :: in,is,ne,nxysl
  real(kind=4) :: zfact
  real(kind=8) :: z
  !
  if (nxy.lt.1) return
  call inqnsides(nsides)
  call inqsty(istyle)
  call setdas(1)
  !
  nxysl = nxy
  in = 1
  z = 0.d0  ! Ignored with zfact<0
  zfact = -1.0  ! No factor applied on Z values = ignore Z values
  do while (in.ne.0)
    call find_blank8(y,bval,eval,nxysl,is,ne,in)
    call points(nsides,istyle,zfact,1.,x(is),y(is),z,ne,.true.)
  enddo
end subroutine gr8_marker
!
subroutine gr4_marker(nxy,x,y,bval,eval)
  use greg_interfaces, except_this=>gr4_marker
  !---------------------------------------------------------------------
  ! @ public-mandatory (because symbol is used elsewhere)
  !   Plot markers with blanking value
  !---------------------------------------------------------------------
  integer(kind=4) :: nxy                    ! Number of data points
  real(kind=4)    :: x(nxy)                 ! Array of X coordinates
  real(kind=4)    :: y(nxy)                 ! Array of Y coordinates
  real(kind=4)    :: bval                   ! Blanking value
  real(kind=4)    :: eval                   ! Tolerance on blanking value
  ! Local
  integer(kind=4) :: j,nsides,istyle
  !
  if (nxy.lt.1) return
  call inqnsides(nsides)
  call inqsty(istyle)
  call setdas(1)
  !
  do j = 1,nxy
    if (y(j).eq.y(j).and.abs(y(j)-bval).gt.eval) then
      call relocate(dble(x(j)),dble(y(j)))
      call gr_point(nsides,istyle)
    endif
  enddo
end subroutine gr4_marker
!
subroutine points(nsides,istyle,zfact,expo,x,y,z,nxy,same_marker)
  use gildas_def
  use greg_dependencies_interfaces
  use greg_interfaces
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  ! GREG Internal routine
  !  Plot symbols at each point (X,Y) in user coordinates
  !  If ZFACT .GT. 0. symbol size is proportional to Z value with power
  ! law of exponent EXPO
  !---------------------------------------------------------------------
  integer(kind=size_length) :: nxy          !
  integer(kind=4)           :: nsides(nxy)  !
  integer(kind=4)           :: istyle(nxy)  !
  real(kind=4)              :: zfact        !
  real(kind=4)              :: expo         !
  real(kind=8)              :: x(nxy)       !
  real(kind=8)              :: y(nxy)       !
  real(kind=8)              :: z(nxy)       !
  logical                   :: same_marker  !
  ! Local
  real(kind=4) :: size,symsiz
  integer(kind=size_length) :: j
  integer(kind=4) :: np,ier
  real(kind=4), allocatable :: xp(:),yp(:)
  logical :: error
  !
  if (nxy.lt.1) return
  call setdas(1)
  !
  if (same_marker .and. nsides(1).lt.2) then
    ! A list of dot-points. Use optimized API
    allocate(xp(nxy),yp(nxy),stat=ier)
    error = .false.
    if (failed_allocate('POINTS','XP and XP',ier,error))  return
    !
    np = nxy
    call gr8_user_phys (x,y,xp,yp,np)  ! Convert from user to plot coordinates
    call grdots(nxy,xp,yp)
    deallocate(xp,yp)
    !
  elseif (zfact.le.0.e0) then
    ! A list of points (any kind), default size
    if (same_marker) then      ! Same marker type for all points
      do j = 1,nxy
        call relocate(x(j),y(j))
        call gr_point(nsides(1),istyle(1))
      enddo
    else                       !
      do j = 1,nxy
        call relocate(x(j),y(j))
        call gr_point(nsides(j),istyle(j))
      enddo
    endif
    !
  else
    ! A list of points (any kind), custom size
    call inqsym(symsiz)
    if (same_marker) then      ! Same marker type for all points
      do j = 1,nxy
        size = zfact*abs(z(j))**expo
        call setsym (size)
        call relocate(x(j),y(j))
        call gr_point(nsides(1),istyle(1))
      enddo
    else
      do j = 1,nxy
        size = zfact*abs(z(j))**expo
        call setsym (size)
        call relocate(x(j),y(j))
        call gr_point(nsides(j),istyle(j))
      enddo
    endif
    call setsym(symsiz)
  endif
  !
end subroutine points
!
subroutine gr8_text(nxy,x,y,text,code,bval,eval)
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>gr8_text
  use greg_kernel
  !---------------------------------------------------------------------
  ! @ public
  !   Plot text with blanking value
  ! CODE (1-9) of text placement (ex: 5=center); negative values for
  ! "append" code
  !---------------------------------------------------------------------
  integer(kind=4)  :: nxy           ! Number of data points
  real(kind=8)     :: x(nxy)        ! Array of X coordinates
  real(kind=8)     :: y(nxy)        ! Array of Y coordinates
  character(len=*) :: text          ! TEXT to be plotted
  integer(kind=4)  :: code          ! CODE (1-9) of text placement
  real(kind=8)     :: bval          ! Blanking value
  real(kind=8)     :: eval          ! Tolerance on blanking value
  ! Local
  integer(kind=4) :: nchar,ii,j
  logical :: user
  !
  if (nxy.lt.1) return
  user = (code.ge.0)
  if (user) then
    ii = code
    if (code.eq.0) ii = centre(xcurse,ycurse)
  else
    ii = -code
  endif
  nchar=lenc(text)
  !
  do j = 1,nxy
    if (y(j).eq.y(j).and.abs(y(j)-bval).gt.eval) then
      if (user) call relocate(x(j),y(j))
      call putlabel(nchar,text,ii,tangle,.false.)
    endif
  enddo
end subroutine gr8_text
!
subroutine gr4_text(nxy,x,y,text,code,bval,eval)
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>gr4_text
  use greg_kernel
  !---------------------------------------------------------------------
  ! @ public
  !   Plot text with blanking value
  ! CODE (1-9) of text placement (ex: 5=center); negative values for
  ! "append" code
  !---------------------------------------------------------------------
  integer(kind=4)  :: nxy           ! Number of data points
  real(kind=4)     :: x(nxy)        ! Array of X coordinates
  real(kind=4)     :: y(nxy)        ! Array of Y coordinates
  character(len=*) :: text          ! TEXT to be plotted
  integer(kind=4)  :: code          ! CODE (1-9) of text placement
  real(kind=4)     :: bval          ! Blanking value
  real(kind=4)     :: eval          ! Tolerance on blanking value
  ! Local
  integer(kind=4) :: nchar,ii,j
  logical :: user
  !
  if (nxy.lt.1) return
  user = (code.ge.0)
  if (user) then
    ii = code
    if (code.eq.0) ii = centre(xcurse,ycurse)
  else
    ii = -code
  endif
  nchar=lenc(text)
  !
  do j = 1,nxy
    if (y(j).eq.y(j).and.abs(y(j)-bval).gt.eval) then
      if (user) call relocate(dble(x(j)),dble(y(j)))
      call putlabel(nchar,text,ii,tangle,.false.)
    endif
  enddo
end subroutine gr4_text
!
subroutine gr8_hatch(rname,nxy,x,y,angle,separ,phase,error)
  use gildas_def
  use gbl_message
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>gr8_hatch
  !---------------------------------------------------------------------
  ! @ public
  ! Hatch the input polygon with parallel lines. Polygon must be closed
  ! (last point = first point)
  !---------------------------------------------------------------------
  character(len=*),          intent(in)    :: rname   ! Calling routine name
  integer(kind=size_length), intent(in)    :: nxy     ! Number of points
  real(kind=8),              intent(in)    :: x(nxy)  ! X coordinates (user units)
  real(kind=8),              intent(in)    :: y(nxy)  ! Y coordinates (user units)
  real(kind=4),              intent(in)    :: angle   ! Hatching angle (radians)
  real(kind=4),              intent(in)    :: separ   ! Hatching separation (physical units)
  real(kind=4),              intent(in)    :: phase   ! Hatching phase (0. to 1.)
  logical,                   intent(inout) :: error   ! Logical error flag
  ! Local
  real(kind=4) :: x2(nxy),y2(nxy),x3(nxy),y3(nxy)  ! Automatic arrays
  real(kind=4) :: y3min,y3max,xl4(1024),xu4(1024),y4,cosa,sina,x5,y5
  integer(kind=size_length) :: j
  integer(kind=4) :: nr(2),lnx,inx
  !
  ! Sanity checks
  if (separ.eq.0.) then
    call greg_message(seve%e,rname,'Hatching separation must be non-zero')
    error = .true.
    return
  endif
  !
  ! 1) Convert to physical units
  call gr8_user_phys(x,y,x2,y2,int(nxy,kind=4))
  !
  ! 2) Rotate the coordinates (BLTLIS can draw only horizontal lines)
  cosa = cos(-angle)
  sina = sin(-angle)
  do j=1,nxy
    x3(j) = x2(j)*cosa-y2(j)*sina
    y3(j) = x2(j)*sina+y2(j)*cosa
  enddo
  y3min = minval(y3)
  y3max = maxval(y3)
  !
  ! 3) Compute segments striking though the polygon + derotate
  nr(1) = nxy
  ! The floor() below ensures that all the lines are aligned for all
  ! polygons on the plot. The phase allow to shift them on purpose.
  y4 = (floor(y3min/abs(separ))+phase)*abs(separ)
  do while (y4.lt.y3max)
    call gr4_bltlis(1,1,1,nr,x3,y3,y4,lnx,xl4,xu4)
    do inx=1,lnx
      ! Left
      x5 =  xl4(inx)*cosa+y4*sina
      y5 = -xl4(inx)*sina+y4*cosa
      call grelocate(x5,y5)
      ! Right
      x5 =  xu4(inx)*cosa+y4*sina
      y5 = -xu4(inx)*sina+y4*cosa
      call gdraw(x5,y5)
    enddo
    y4 = y4+abs(separ)
  enddo
  !
end subroutine gr8_hatch

module utils

! Various general utilities.
! Based on a code by John E. Pask, LLNL.
! Simple and Double precision cases.
! 
implicit none

integer, parameter :: dp=8
private
public str

interface str
    module procedure str_int, str_long, str_real, str_real_n, str_dble, str_dble_n
end interface

contains

pure integer function str_long_len(i) result(sz)
! Returns the length of the string representation of 'i'
integer(kind=8), intent(in) :: i
integer, parameter :: MAX_STR = 100
character(MAX_STR) :: s
! If 's' is too short (MAX_STR too small), Fortan will abort with:
! "Fortran runtime error: End of record"
write(s, '(i0)') i
sz = len_trim(s)
end function

pure function str_long(i) result(s)
! Converts integer "i" to string
integer(kind=8), intent(in) :: i
character(len=str_long_len(i)) :: s
write(s, '(i0)') i
end function

pure integer function str_int_len(i) result(sz)
! Returns the length of the string representation of 'i'
integer, intent(in) :: i
integer, parameter :: MAX_STR = 100
character(MAX_STR) :: s
! If 's' is too short (MAX_STR too small), Fortan will abort with:
! "Fortran runtime error: End of record"
write(s, '(i0)') i
sz = len_trim(s)
end function

pure function str_int(i) result(s)
! Converts integer "i" to string
integer, intent(in) :: i
character(len=str_int_len(i)) :: s
write(s, '(i0)') i
end function

pure integer function str_dble_len(r, fmt) result(sz)
! Returns the length of the string representation of 'i'
real(dp), intent(in) :: r
character(len=*), intent(in) :: fmt
integer, parameter :: MAX_STR = 100
character(MAX_STR) :: s
! If 's' is too short (MAX_STR too small), Fortan will abort with:
! "Fortran runtime error: End of record"
write(s, fmt) r
sz = len_trim(s)
end function

pure integer function str_real_len(r, fmt) result(sz)
! Returns the length of the string representation of 'i'
real, intent(in) :: r
character(len=*), intent(in) :: fmt
integer, parameter :: MAX_STR = 100
character(MAX_STR) :: s
! If 's' is too short (MAX_STR too small), Fortan will abort with:
! "Fortran runtime error: End of record"
write(s, fmt) r
sz = len_trim(s)
end function

pure function str_dble(r) result(s)
! Converts the real number "r" to string with 7 decimal digits.
real(dp), intent(in) :: r
character(len=*), parameter :: fmt="(f0.6)"
character(len=str_dble_len(r, fmt)) :: s
write(s, fmt) r
end function

pure function str_dble_n(r, n) result(s)
! Converts the real number "r" to string with 'n' decimal digits.
real(dp), intent(in) :: r
integer, intent(in) :: n
character(len=str_dble_len(r, "(f0." // str_int(n) // ")")) :: s
write(s, "(f0." // str_int(n) // ")") r
end function

pure function str_real(r) result(s)
! Converts the real number "r" to string with 7 decimal digits.
real, intent(in) :: r
character(len=*), parameter :: fmt="(f0.6)"
character(len=str_real_len(r, fmt)) :: s
write(s, fmt) r
end function

pure function str_real_n(r, n) result(s)
! Converts the real number "r" to string with 'n' decimal digits.
real, intent(in) :: r
integer, intent(in) :: n
character(len=str_real_len(r, "(f0." // str_int(n) // ")")) :: s
write(s, "(f0." // str_int(n) // ")") r
end function

end module

program field_list
  use gildas_def
  use image_def
  use gkernel_interfaces
  use gbl_format
  !---------------------------------------------------------------------
  ! GDF	Extract parameters from fields
  ! Subroutines
  !	FIELD001
  !---------------------------------------------------------------------
  ! Local
  character(len=filename_length) :: namex,namey,names
  logical :: error
  integer :: nf, nfi, ier
  real, allocatable :: work(:)
  type(gildas) :: x,y,z
  !
  call gildas_open
  call gildas_char('Y_NAME$',namey)
  call gildas_char('X_NAME$',namex)
  call gildas_inte('FIELD$',nf,1)
  call gildas_char('T_NAME$',names)
  !
  call gildas_null(y)
  y%gil%form = fmt_r4
  call gdf_read_gildas(y,namey,'.gdf',error)
  if (error) then
    call gagout('F-FIELD,  Cannot read input file')
    goto 100
  endif
  !
  ! Read label image
  call gildas_null(x)
  x%gil%form = fmt_r4
  call gdf_read_gildas(x,namex,'.gdf',error)
  if (error) then
    call gagout('F-FIELD,  Cannot read label image')
    goto 100
  endif
  !
  ! Open output table
  call gildas_null (z, type='TABLE' )
  call sic_parsef(names,z%file,' ','.gdf')
  z%gil%dim(1) = nf
  z%gil%dim(2) = 7
  !
  call gdf_create_image(z,error)
  if (error) then
    call gagout('E-FIELD_LIST,  Cannot create output table')
    goto 100
  endif
  !
  allocate (work(5*nf), z%r2d (z%gil%dim(1), z%gil%dim(2)), stat=ier)
  if (ier.ne.0) goto 99
  !
  call field001(y%r2d,   &  !
     &    y%gil%dim(1),y%gil%dim(2),   &   !Size (BUT should equal x%gil%dim[i] !!!)
     &    x%r2d,   &     !Label
     &    y%gil%bval,y%gil%eval,   &   !
     &    y%gil%ref(1),y%gil%val(1), y%gil%inc(1),   &
     &    y%gil%ref(2),y%gil%val(2), y%gil%inc(2),   &  
     &    nf, nfi,   &         !
     &    z%r2d,   &
     &    work,    &
     &    ier)
  call gdf_write_data (z,z%r2d,error)
  if (nfi.eq.0) then
    call gagout('W-FIELD,  No field found')
  elseif (nfi.eq.1) then
    call gagout('I-FIELD,  Found 1 field in image')
  else
    write(namex,'(A,I12,A)') 'I-FIELD,  Found ',nfi,   &
     &      ' fields in image'
    call gagout(namex)
  endif
  if (ier.ne.0) call gagout('W-FIELD,  Too many fields')
  call sysexi(1)
  !
99 call gagout('F-FIELD,  Memory allocation failure')
100 call sysexi(fatale)
end program field_list
!
subroutine field001( imagein, ncolumns, nlines, labelin,   &
     &    blank, eblank, xref,xval,incx,yref,yval,incy, nf, nfi,   &
     &    table, work, ierr)
  use gildas_def
  !---------------------------------------------------------------------
  !	S.Guilloteau	Blanking Value			(Oct-1985)
  !			All fields at a time
  !	A.Bijaoui M.Khouchane E.Slezak 14 janvier 1985
  !	Saidi5 permet de determiner les parametres structuraux elementaires
  !	d'un domaine image
  !---------------------------------------------------------------------
  integer(kind=index_length) :: ncolumns                  !
  integer(kind=index_length) :: nlines                    !
  real(4) ::  imagein(ncolumns,nlines)  !
  real(4) ::  labelin(ncolumns,nlines)  !
  real(4) ::  blank                     !
  real(4) ::  eblank                    !
  real(8) ::  xref                      !
  real(8) ::  xval                      !
  real(8) ::  incx                      !
  real(8) ::  yref                      !
  real(8) ::  yval                      !
  real(8) ::  incy                      !
  integer :: nf                        !
  integer :: nfi                       !
  real(4) ::  table(nf,7)               !
  real(4) ::  work(5,nf)                !
  integer :: ierr                      !
  ! Local
  real(4) ::  npi
  !
  !	ImageIn		= Original Image
  !	Ncolumns	= Image Number of columns
  !	Nlines		= Image Number of lines
  !	LabelIn		= Labels table of the image
  !	Blank		= Blanking value
  !	Eblank		= Tolerance on blanking
  !	IncX		= User increment per column
  !	IncY		= ------------------ line
  !	Nf		= Maximum number of fields
  !	Nfi		= Number of fields found
  !	Table(*,1) 	= Number of pixels of the field
  !	Table(*,2)	= Integrate intensity of the field
  !	Table(*,3)	= Field X position (weighted by intensity) in pixels
  !	Table(*,4)	= Field Y position (---------------------) in pixels
  !	Table(*,5)	= Equivalent Major axis of the contour
  !	Table(*,6)	= Equivalent Minor Axis of the contour
  !	Table(*,7)	= Orientation of the ellipsis fitted to the contour
  !	Work		= Work space
  !	Ierr		= Output error parameter
  !	0 no error
  !	1 Too many fields
  !
  integer i,j,iline,icolumn,label,if
  real y,x,value,s3,s4,s5,bx,ax,orientation,s,c,w3,w4,b
  !
  table = 0.0
  work = 0.0
  ierr = 0
  nfi  = 0
  !
  do iline=1,nlines
    y = (iline-yref)*incy+yval
    do icolumn=1,ncolumns
      x = (icolumn-xref)*incx+xval
      label = labelin(icolumn,iline)
      if (label.gt.nf) then
        nfi = nf
        ierr = 1
      elseif (label.gt.0) then
        value = imagein(icolumn,iline)
        if (abs(value-blank).gt.eblank) then
          table(label,1)=table(label,1)+1
          table(label,2)=table(label,2)+value
          table(label,3)=table(label,3)+value*x
          table(label,4)=table(label,4)+value*y
          work(1,label)=work(1,label)+x
          work(2,label)=work(2,label)+y
          work(3,label)=work(3,label)+x*x
          work(4,label)=work(4,label)+y*y
          work(5,label)=work(5,label)+x*y
        endif
        nfi = max(nfi,label)
      endif
    enddo
  enddo
  !
  do if=1,nfi
    npi = table(if,1)
    ! check against possible null integrated intensity
    if (table(if,2).ne.0) then
      table(if,3)=table(if,3)/table(if,2)
      table(if,4)=table(if,4)/table(if,2)
    else
      ! we should provide an option to compute non-weighted centroids
      ! in that case...
      write(6,'(A,I12,A)') 'W-FIELD_FIND, object #',if,   &
     &        ' has a null intensity'
    endif
    if (npi.gt.1.1) then
      work(1,if)=work(1,if)/npi
      work(2,if)=work(2,if)/npi
      s3=work(3,if)/npi-work(1,if)*work(1,if)
      s4=work(4,if)/npi-work(2,if)*work(2,if)
      s5=work(5,if)/npi-work(1,if)*work(2,if)
      if (s3.eq.0.0.and.s4.eq.0.0) then
        ax = abs(0.5*incx)
        bx = abs(0.5*incy)
        orientation = 0.
      elseif (s3.eq.0.0) then
        bx = abs(0.5*incx)
        ax = sqrt(abs(s4))
        orientation = -90.
      elseif (s4.eq.0.0) then
        bx = abs(0.5*incy)
        ax = sqrt(abs(s3))
        orientation = 0.
      else
        if (s3.ne.s4) then
          orientation=atan(2.*s5/(s4-s3))/2.
        else
          orientation=0.7854
        endif
        s=sin(orientation)
        c=cos(orientation)
        w3= sqrt( abs(c*c*s3-2.*s*c*s5+s*s*s4) )
        w4= sqrt( abs(s*s*s3+2.*s*c*s5+c*c*s4) )
        bx = (2.*w4/w3)*sqrt(w3*w4/3.14159)
        ax = bx*w3/w4
        if (s3.gt.s4) then
          b=ax
          ax=bx
          bx=b
          orientation=orientation+1.57079
        endif
        orientation=180.*orientation/3.14159
      endif
      table(if,5)=ax
      table(if,6)=bx
      table(if,7)=-orientation
    else
      table(if,5)=abs(incx*0.5)
      table(if,6)=abs(incy*0.5)
      table(if,7)=0.0
    endif
  enddo
end subroutine field001

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module sic_types
  use gildas_def
  use image_def
  !--------------------------------------------------------------------
  !
  !--------------------------------------------------------------------
  !
  type :: sic_identifier_t
    ! Unique identifier of a Sic variable
    character(len=varname_length) :: name
    integer(kind=4)               :: lname
    integer(kind=4)               :: level
  end type sic_identifier_t
  !
  ! Code for variable descriptor status. A positive status indicates a
  ! variable mapped to an image file, and stores its image slot. These
  ! codes should therefore be negative to avoid conflicts.
  integer, parameter :: program_defined=0    ! Code for program defined (static) named variables
  integer, parameter :: scratch_operand=-1   ! Code for scratch (allocated, used) un-named operands
  integer, parameter :: free_operand=-2      ! Code for free (allocated, unused) un-named operands
  integer, parameter :: readonly_operand=-3  ! Code for READONLY un-named operands (static strings, variable parts...)
  integer, parameter :: interm_operand=-4    ! Code for intermediate results (un-named operands pointing to final result)
  integer, parameter :: user_defined=-5      ! Code for interactively defined variables, i.e. SIC\DEFINE REAL A
  integer, parameter :: alias_defined=-6     ! Variable is an alias
  integer, parameter :: empty_operand=-999   ! Code for unallocated operands
  !
  type :: sic_descriptor_t
    integer(kind=4)              :: type              ! Variable type
    integer(kind=4)              :: ndim              ! Variable number of dimensions
    integer(kind=index_length)   :: dims(sic_maxdims) ! Variable dimensions
    integer(kind=address_length) :: addr = ptr_null   ! Data address (if relevant)
    type(gildas), pointer        :: head => null()    ! Pointer to header (if relevant)
    integer(kind=size_length)    :: size              ! Size of allocation (words)
    integer(kind=4)        :: status = empty_operand  ! Origin of variable (codes above)
                                                      !    0     program defined
                                                      !  < 0     various codes
                                                      !  > 0     image (slot in gio)
    logical                      :: readonly          ! Variable is read only for user?
  end type sic_descriptor_t
  !
  type :: sic_variable_t
    ! A Sic variable has an identifier and an internal descriptor
    type(sic_identifier_t) :: id
    type(sic_descriptor_t) :: desc
  end type sic_variable_t
  !
  ! Description dimensions in Sic, for parsing e.g. A[1,2][3:4]
  type :: sic_dimensions_do_t
    logical :: strict    ! Must be a valid specifier, as opposed to an expression like "A[1].eq.B[2]"
    logical :: range     ! e.g. A[3:5] allowed
    logical :: subset    ! e.g. A[2,] allowed
    logical :: implicit  ! e.g. A[i] allowed
    logical :: twospec   ! e.g. A[i][j:k] allowed
  end type sic_dimensions_do_t
  type :: sic_dimensions_done_t
    logical :: range     ! e.g. A[3:5] was found
  ! logical :: subset    ! e.g. A[2,] was found
    logical :: implicit  ! e.g. A[i] was found
    integer(kind=4) :: ndim
    integer(kind=index_length) :: dims(sic_maxdims,2)
    type(sic_identifier_t)     :: vars(sic_maxdims)  ! Name of implicit dimensions
  end type sic_dimensions_done_t
  type :: sic_dimensions_t
    type(sic_dimensions_do_t)   :: do
    type(sic_dimensions_done_t) :: done(2)
  end type sic_dimensions_t
  !
  integer(kind=4), parameter :: symbol_length=12
  integer(kind=4), parameter :: translation_length=512
  type :: sic_symdict_t
    ! Symbols
    integer(kind=4)                                :: msym=0     ! Maximum number of symbols
    character(len=symbol_length),      allocatable :: name(:)    ! Symbol name
    character(len=translation_length), allocatable :: trans(:)   ! Symbol translation
    integer(kind=4),                   allocatable :: ltrans(:)  ! Length of translation
    ! Dictionary hashing
    integer(kind=4)              :: pf(0:27)  ! Alphabetic pointers PF(27)=number of symbols
    integer(kind=4), allocatable :: pn(:)     ! Chained pointers
  end type sic_symdict_t
  !
  ! Type describing a program-defined function (sic_def_func)
  type :: sic_function_t
    integer(kind=4)                :: code  ! Identifier
    integer(kind=4)                :: narg  ! Number of arguments
    character(len=filename_length) :: help  ! Associated HLP file / SIC logical
  end type sic_function_t
  !
  integer, parameter :: language_length=12 ! Internal limit on languages name
  type :: sic_language_t
    character(len=language_length) :: name          ! Language name
    integer(kind=4)                :: lname         ! Name length
    character(len=132)             :: mess          ! Short language description
    character(len=filename_length) :: help          ! Logical name of help file
    integer(kind=4)                :: prio          ! Language priority
    logical                        :: asleep        ! Language not in scope
    logical                        :: libmod        ! Library only mode
    logical                        :: user=.false.  ! Is the language a user language?
    type(sic_symdict_t), pointer   :: usym=>null()  ! Dictionary of symbols is user language
  end type sic_language_t
  !
  ! Type for parsed command line
  integer(kind=4), parameter :: command_length=16  ! Internal limit on commands and options name
  integer(kind=4), parameter :: mword=512          ! Maximum number of items on a command line
  integer(kind=4), parameter :: maxopt=128         ! Maximum number of options to a command
  type :: sic_command_t
    ! Command line
    integer(kind=address_length)   :: aline        ! Memory address of command line
    ! Language
    integer(kind=4)                :: ilang        ! Language id
    character(len=language_length) :: lang         ! Language name
    ! Command
    integer(kind=4)                :: icom         ! Command number id
    character(len=command_length)  :: command      ! Command name
    integer(kind=4)                :: mopt         ! Max number of options for this command
    ! Arguments
    integer(kind=4) :: nword           ! Total number of word in command line (command included)
    integer(kind=4) :: ibeg(mword)     ! Pointer to beginning of word in line
    integer(kind=4) :: iend(mword)     ! Pointer to end of word in line
    integer(kind=4) :: narg(0:maxopt)  ! Number of arguments of command/options
    integer(kind=4) :: popt(0:maxopt)  ! Position of option in command line [words]
    ! Initialization done?
    logical :: initialized=.false.
  end type sic_command_t
  !
  ! Support types for Sic lists:
  ! List1 ... ListN
  !  where
  ! ListI = a [TO b [BY c]]
  type :: sic_listi4_t
    integer(kind=4)              :: nlist=0  ! Actual number of lists
    integer(kind=4)              :: mlist=0  ! Maximum number of lists (size of allocation)
    integer(kind=4), allocatable :: i1(:)    ! Lower bounds
    integer(kind=4), allocatable :: i2(:)    ! Upper bounds
    integer(kind=4), allocatable :: i3(:)    ! Steps
  end type sic_listi4_t
  type :: sic_listi8_t
    integer(kind=4)              :: nlist=0  ! Actual number of lists
    integer(kind=4)              :: mlist=0  ! Maximum number of lists (size of allocation)
    integer(kind=8), allocatable :: i1(:)    ! Lower bounds
    integer(kind=8), allocatable :: i2(:)    ! Upper bounds
    integer(kind=8), allocatable :: i3(:)    ! Steps
  end type sic_listi8_t
  type :: sic_listr8_t
    integer(kind=4)           :: nlist=0  ! Actual number of lists
    integer(kind=4)           :: mlist=0  ! Maximum number of lists (size of allocation)
    real(kind=8), allocatable :: r1(:)    ! Lower bounds
    real(kind=8), allocatable :: r2(:)    ! Upper bounds
    real(kind=8), allocatable :: r3(:)    ! Steps
  end type sic_listr8_t
  !
  type datetime_spec_t
    logical                   :: isvar  ! Termimal or variable?
    type(sic_descriptor_t)    :: desc   !
    integer(kind=4)           :: form   !
    integer(kind=size_length) :: nelem  !
  end type datetime_spec_t
  !
end module sic_types
!
module sic_structures
  use gildas_def
  use sic_types
  !--------------------------------------------------------------------
  ! Basic support of SIC interpreter.
  ! For portability, SAVE Fortran variables which are target of SIC
  ! variables.
  !--------------------------------------------------------------------
  !
  ! Limits for SIC interpreter execution
  integer, parameter :: mcif=255     ! Maximum nesting of IF blocks
  integer, parameter :: maxlev=127   ! Maximum nesting of levels
  integer, parameter :: mcloop=127   ! Maximum nesting of FOR loops
  integer, parameter :: maxmacarg=32 ! Maximum number of macro arguments
  ! CAUTION: look at code in getcom.f if the above number no longer fits in one digit
  integer, parameter :: maxext=32    ! Maximum number of default extensions,
                                     ! should be related to gpack_max_count
  !
  ! Macros support
  character(len=12) :: sicext(maxext)             ! Macro default extension
  integer :: lext(maxext)                         ! Macro default extension length
  ! Commands support
  type(sic_command_t), save :: ccomm           ! Current command line
  !
  ! Program status
  logical, save :: lverif          ! Verify ON
  integer, save :: iverif(maxlev)  ! Level Verification status
  integer :: mlire(maxlev)         ! Read status for each level
  !       -2 = Read in loop buffers
  !       -1 = Read from program
  !        0 = Read on unit 5
  !       +N = Read in Nth active macro
  integer :: nlire                 ! Level depth
  integer :: nmacro                ! Number of active macros
  integer :: jmac(maxlev)          ! Current line in each macro
  logical :: library_mode          ! Mode is library only
  logical :: sic_quiet             ! SIC is not active (in IF blocks)
  integer, save :: sic_stepin=0    ! Macro Step by Step (for Debug)
  !
  ! Error handling
  character(len=128) :: errcom(0:maxlev) ! Buffer for error recovery command
                                         ! Length of ERRCOM if > 0, or error code:
  integer :: nerr(0:maxlev)              !
  integer, parameter :: e_pause=0        !  0 PAUSE
  integer, parameter :: e_cont=-1        ! -1 CONTINUE
  integer, parameter :: e_quit=-2        ! -2 QUIT
  integer, parameter :: e_retu=-3        ! -3 RETURN
  logical, save :: sicvar_error=.false.  ! Support for variable SIC%ERROR
  !
  ! IF blocks support
  integer :: if_depth(maxlev)            !
  integer :: if_loop_level(mcloop)       !
  integer :: if_current                  !
  integer :: if_last                     !
  logical :: if_active(mcif)             !
  logical :: if_elsefound(mcif)          ! Standalone ELSE already found once?
  logical :: if_finished(mcif)           !
  !
  ! FOR loops support
  integer, parameter :: mloop=10         ! Number of sub-loops in a FOR command
  integer, parameter :: looend=1024*20   ! 80 kBytes max size for loop contents
  integer(kind=address_length) :: loobuf(looend) ! Loop buffer
  integer :: loolen                      ! Current length of buffer
  integer :: bulend                      ! Number of commands in buffer
  integer :: mlen                        !
  integer :: firllo(mcloop)              ! Pointer to first line of loop
  integer :: firblo(mcloop)              ! Pointer to first byte of loop
  integer :: lasllo(mcloop)              ! Pointer to last line of loop
  integer :: lasblo(mcloop)              ! Pointer to last byte of loop
  integer :: ploop(mcloop)               ! Previous loop number
  integer :: ifloop(maxlev)              ! Number of loops at this level
  integer :: curbyt(maxlev)              ! Current byte at this level
  integer :: curlin(maxlev)              ! Current line at this level
  integer :: iloo                        ! First command to be considered
  integer :: jloo                        ! Current command played
  integer :: kloo(mcloop)                ! Current index list used
  integer :: nloo                        ! Byte pointer for next command
  logical :: compil                      ! Compilation flag
  !
  integer :: cloop                       ! Current loop number
  integer :: aloop                       ! Current number of loops
  integer :: loop_length(mcloop)         ! Length of logical test
  type(sic_listr8_t), save :: loop_index(mcloop)  ! Loop lists
  real(8) :: indice(mcloop)              ! Value of loop index
  !
  integer(kind=4), parameter :: loop_string_length=240  ! 240 = 3*MLOOP*8, but this is by chance...
  character(len=loop_string_length) :: loop_string(mcloop)
  integer(kind=4) :: loop_list(mcloop)    ! Variable number in dictionary for /IN List
  integer(kind=4) :: loop_size(mcloop)    ! Dimension of /IN List
  integer(kind=4) :: loop_curarg(mcloop)  ! Current list counter for /IN List
  integer(kind=4) :: loop_var(mcloop)     ! Identifier of the loop variable
  !
  ! Procedures
  integer(kind=4), parameter :: maxpro=512
  integer(kind=4), parameter :: procname_length=64
  !
  character(len=procname_length) :: proc_name(maxpro)  ! Procedure name
  character(len=filename_length) :: proc_file(maxpro)  ! Associated file name
  character(len=filename_length) :: gag_proc           ! GAG_PROC: value
  integer :: iproc                                     ! Current procedure
  integer :: nproc                                     ! Number of procedures
  logical :: proced                                    !
  !
  ! Logical units used by SIC
  integer, parameter :: mlun=40   ! MLUN   Max number of logical units allocatable by SIC
  integer, parameter :: mlunpa=8  ! MLUNPA Number of pre-allocated logical units for macro by SIC_LUNMAC_INIT (Range 0 ... MLUN)
  integer :: lunlog=0             ! LUNLOG Logical unit for the log_file (permanent connection)
  integer :: luntem               ! LUNTEM Logical unit for temporary connection to files
  integer :: lunmac(mlun)         ! LUNMAC Array of logical units for macros.
end module sic_structures
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module sic_expressions
  !--------------------------------------------------------------------
  ! Support for interpretation of functions or formulas
  !--------------------------------------------------------------------
  !
  ! User-defined functions (DEFINE FUNCTION)
  integer, parameter :: mfun=128    ! Maximum number of functions
  integer, parameter :: mfunarg=8   ! Maximum number of arguments
  integer, parameter :: mpoi=20     ! Maximum number of pointers
  integer :: nfun                   ! Number of functions
  integer :: nfunarg(mfun)          ! Number of arguments per fonction
  integer :: lonc(mfun)             ! Length of function name
  integer :: lptr(mfun)             ! Number of pointers for function
  integer :: ifi(mpoi,mfun)         ! Pointer to beg. in definition
  integer :: ila(mpoi,mfun)         ! Pointer to end  in definition
  integer :: iva(mpoi,mfun)         ! Argument number
  character(len=24) :: fonc(mfun)   ! Function name
  character(len=80) :: defi(mfun)   ! Function definition
  !
  ! Formulas
  integer, parameter :: maxterm=10          ! Maximum number of terms in block
  integer, parameter :: formula_length=512  ! Maximum length of formula
  integer, parameter :: maxtree=512         ! Length of buffer space
  integer, parameter :: maxpar=32           ! Maximum parenthesis level
  integer, parameter :: maxoper=32          ! Maximum number of operands
  real(8), parameter :: eps=1.d-15          ! Relative accuracy on real(8)
  !
  ! Arguments
  integer, parameter :: margu=100        !
  integer :: next_arg,next_st            !
  real(kind=8)        :: argu_r8(margu)  !
  real(kind=4)        :: argu_r4(margu)  !
  integer(kind=4)     :: argu_i4(margu)  !
  integer(kind=8)     :: argu_i8(margu)  !
  logical             :: argu_l4(margu)  !
  character(len=1024) :: argu_st(margu)  !
end module sic_expressions
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module sic_dictionaries
  use gildas_def
  use sic_structures
  use sic_types
  !--------------------------------------------------------------------
  ! Dictionaries used to store SIC objects or features
  !--------------------------------------------------------------------
  !
  ! Languages
  integer, parameter :: mvocab=2048         ! Limit of 400 is exhausted by CLIC,
                                            ! ... and 500 by CLASS90,
                                            ! ... and 1000 by MOPSIC
  integer, parameter :: mlang=32            ! Limit of 15 is exhausted by MOPSIC
  type(sic_language_t), save :: languages(mlang)  ! The languages
  integer :: nopt(0:mvocab)                 ! Total number of commands and options
  integer :: hasopt(0:mvocab)               ! Does the command accepts options or not?
  integer :: mbuilt(0:mlang) = 0            ! Last command in a given language
  integer :: nlang                          ! Number of languages
  integer, parameter :: mbuilt_sic_inter=23  ! Number of commands in the SIC\
                                             ! language which can alter the normal
                                             ! flow of commands (e.g. @, IF, FOR, ...)
  integer, parameter :: mucom=100           ! Maximum number of commands per user language.
  !
  ! Language priorities
  integer(kind=4), parameter :: mprio=mlang        ! Maximum number of priority levels
  integer(kind=4) :: klang(mprio) = 0              ! Number of languages at each priority level
  integer(kind=4) :: olang(mlang,mprio)            ! Language at each priority level
  integer(kind=4) :: nprio                         ! Current number of priority levels
  !
  character(len=command_length) :: vocab(mvocab) = ' ' ! Array of commands and options
  !
  ! Help (general)
  integer :: lsynt                                         ! SIC syntax
  character(len=filename_length) :: help_text(mvocab)=' '  ! Help files for USER\ commands
  integer :: help_mode                                     ! Help mode
  integer, parameter :: help_scroll=1                      !
  integer, parameter :: help_page=2                        !
  integer, parameter :: help_html=3                        !
  !
  ! Variables
  integer, parameter :: maxvardef=10000   ! Default value for maxvar
  integer :: maxvar                       ! Number of different variable names
  integer :: pfvar(0:27)                  ! Pointers PF(27)=number of symbols
  integer, allocatable :: pnvar(:)        ! Chained pointers
  integer :: var_n                        ! Number of local user defined variables
  integer :: var_g                        ! Number of global user defined variables
  integer :: var_level                    ! Current level for local variables
  integer :: var_macro(maxlev+1)          ! First local variable for level i
  integer, allocatable :: var_pointer(:)  ! Pointer to user defined variables
  integer, allocatable :: alias(:)        ! List of variables which are aliases
  integer, allocatable :: pointee(:)      ! List of variables which are aliased
  integer :: nalias                       ! Number of aliases
  integer :: lsavcom                      ! Length of SAVCOM command
  integer :: lunsav                       ! LUN for saving variables...
  type(sic_variable_t), allocatable :: dicvar(:)
  character(len=varname_length) :: savcom
  type(sic_identifier_t), allocatable :: dicali(:)
  !
  ! Symbols
  integer(kind=4), parameter :: maxsym=400  ! Max number of symbols
  type(sic_symdict_t), save :: symbols      ! The dictionary of SIC symbols
  !
  ! --- Program-defined functions (i.e. added by the programs) ---------
  integer(kind=4), parameter :: maxfun=53  ! Maximum number of defined functions
  integer(kind=4) :: pffun(0:27)           ! Alphabetic pointers PF(27)=number of symbols
  integer(kind=4) :: pnfun(maxfun)         ! Chained pointers
  character(len=16) :: namfun(maxfun)      ! Function names
  type(sic_function_t) :: descfun(maxfun)  ! Function descriptions
  integer(kind=4) :: code_user             ! Next available function code
  !
  ! --- Intrinsic functions (i.e. native support in SIC) ---------------
  integer(kind=address_length) :: addr_function(300)  ! Function address
  !
  ! Special cases
  integer, parameter :: code_nop      = 0    ! Null operator
  integer, parameter :: code_coma     = 1    ! Coma
  !
  ! Logical operators
  integer, parameter :: code_or       = 2    ! OR operator
  integer, parameter :: code_and      = 3    ! AND operator
  integer, parameter :: code_not      = 4    ! NOT operator
  !
  ! Relational operators
  integer, parameter :: code_ne       = 5    ! Not equal
  integer, parameter :: code_eq       = 6    ! Equal
  integer, parameter :: code_le       = 7    ! Less or equal than
  integer, parameter :: code_lt       = 8    ! Less than
  integer, parameter :: code_ge       = 9    ! Greater or equal than
  integer, parameter :: code_gt       = 10   ! Greater than
  !
  ! Codes for arithmetic operators
  integer, parameter :: code_bplus    = 11   ! Binary plus
  integer, parameter :: code_bminus   = 12   ! Binary minus
  integer, parameter :: code_mul      = 13   ! Multiply
  integer, parameter :: code_div      = 14   ! Divide
  integer, parameter :: code_uplus    = 15   ! Unary plus
  integer, parameter :: code_uminus   = 16   ! Unary minus
  integer, parameter :: code_power    = 17   ! Exponentiation
  !
  ! Codes for intrinsic one operator functions
  integer, parameter :: min_code_func  = 21   ! Minimum code for a function
  integer, parameter :: code_abs       = 21   ! Absolute value
  integer, parameter :: code_acos      = 22   ! Arc cosine
  integer, parameter :: code_asin      = 23   ! Arc sine
  integer, parameter :: code_atan      = 24   ! Arc tangent
  integer, parameter :: code_atanh     = 25   ! Hyperbolic arc tangent
  integer, parameter :: code_bessel_i0 = 26   ! Modified Bessel function of the first kind of order zero
  integer, parameter :: code_bessel_i1 = 27   ! Modified Bessel function of the first kind of order one
  integer, parameter :: code_bessel_j0 = 28   ! Bessel function of the first kind of order zero
  integer, parameter :: code_bessel_j1 = 29   ! Bessel function of the first kind of order one
  integer, parameter :: code_bessel_y0 = 30   ! Bessel function of the second kind of order zero
  integer, parameter :: code_bessel_y1 = 31   ! Bessel function of the second kind of order one
  integer, parameter :: code_cos       = 32   ! Cosine
  integer, parameter :: code_cosh      = 33   ! Hyperbolic cosine
  integer, parameter :: code_erf       = 34   ! Error function
  integer, parameter :: code_erfc      = 35   ! Complementary error function
  integer, parameter :: code_erfinv    = 36   ! Inverse error function
  integer, parameter :: code_erfcinv   = 37   ! Inverse complementary error function
  integer, parameter :: code_exp       = 38   ! Exponential
  integer, parameter :: code_int       = 39   ! Truncation
  integer, parameter :: code_log       = 40   ! Natural logarithm
  integer, parameter :: code_log10     = 41   ! Decimal logarithm
  integer, parameter :: code_nint      = 42   ! Rounding
  integer, parameter :: code_sin       = 43   ! Sine
  integer, parameter :: code_sinh      = 44   ! Hyperbolic sine
  integer, parameter :: code_sqrt      = 45   ! Square root
  integer, parameter :: code_tan       = 46   ! Tangent
  integer, parameter :: code_tanh      = 47   ! Hyperbolic tangent
  integer, parameter :: code_floor     = 48   ! Round to floor
  integer, parameter :: code_ceiling   = 49   ! Round to ceiling
  !
  ! Intrinsic function with 2 arguments or more
  integer, parameter :: code_max       = 50   ! 2 argument maximum
  integer, parameter :: code_min       = 51   ! 2 argument minimum
  integer, parameter :: code_atan2     = 52   ! 2 argument arc tangent
  integer, parameter :: code_bessel_in = 53   ! Modified Bessel function of the first kind of order N
  integer, parameter :: code_bessel_jn = 54   ! Bessel function of the first kind of order N
  integer, parameter :: code_bessel_yn = 55   ! Bessel function of the second kind of order N
  integer, parameter :: code_dim       = 56   ! Positive difference (a-min(a,b))
  integer, parameter :: code_mod       = 57   ! Remainder
  integer, parameter :: code_sign      = 58   ! Transfer of sign
! integer, parameter :: code_conc      =      ! Concatenation (not yet implemented!)
  !
  ! Intrinsic function with a name as argument
  integer, parameter :: code_exist    = 59   ! Exist(NAME)
  integer, parameter :: code_file     = 60   ! File(NAME)
  integer, parameter :: code_typeof   = 61   ! Typeof(NAME)
  integer, parameter :: code_rank     = 62   ! Rank(NAME)
  integer, parameter :: code_size     = 63   ! Size(NAME,DIM)
  integer, parameter :: code_index    = 64   ! Index(STRING,SUBSTRING)
  integer, parameter :: code_function = 65   ! Function(NAME) (is NAME a function ?)
  integer, parameter :: code_len      = 66   ! Length of character string
  integer, parameter :: code_len_trim = 67   ! Length of trimmed character string
  integer, parameter :: code_all      = 68   ! All(LogicalArray)
  integer, parameter :: code_any      = 69   ! Any(LogicalArray)
  integer, parameter :: code_symbol   = 70   ! Symbol(NAME)
  integer, parameter :: code_isnan    = 71   ! IsNaN(NAME)
  integer, parameter :: code_isnum    = 72   ! IsNUM(String)
  integer, parameter :: max_code_func = 72   ! Maximum code for a function
  !
  ! Python Generic function
  integer, parameter :: code_pyfunc   = 73   ! Function in python namespace
  !
  ! Start Scalar functions. Is this useful?
  integer, parameter :: code_scalar   = 73   ! Vector defined function end here
  !
  ! Keep list of intrinsic functions, useful only for HELP FUNCTION (for now)
  integer(kind=4), parameter :: mintfunc=max_code_func-min_code_func+1
  character(len=16), parameter :: name_function(mintfunc) = (/  &
    'ABS             ','ACOS            ','ALL             ','ANY             ',  &
    'ASIN            ','ATAN            ','ATANH           ','ATAN2           ',  &
    'BESSEL_I0       ','BESSEL_I1       ','BESSEL_IN       ','BESSEL_J0       ',  &
    'BESSEL_J1       ','BESSEL_JN       ','BESSEL_Y0       ','BESSEL_Y1       ',  &
    'BESSEL_YN       ','CEILING         ','COS             ','COSH            ',  &
    'DIM             ','EXIST           ','ERF             ','ERFC            ',  &
    'ERFINV          ','ERFCINV         ','EXP             ','FILE            ',  &
    'FLOOR           ','FUNCTION        ','INDEX           ','INT             ',  &
    'ISNAN           ','ISNUM           ','LEN             ','LEN_TRIM        ',  &
    'LOG             ','LOG10           ','MAX             ','MIN             ',  &
    'MOD             ','NINT            ','RANK            ','SIGN            ',  &
    'SIN             ','SINH            ','SIZE            ','SQRT            ',  &
    'SYMBOL          ','TAN             ','TANH            ','TYPEOF          ' /)
  !
end module sic_dictionaries
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine extracs (np,nx,ny,ip,in,out,lx,ly)
  !----------------------------------------------------------------------
  ! @ public
  !*
  ! IMAGER - Utility routine
  !
  !     Extract a Fourier plane from the FFT cube.
  !     Plane and Cube may have different X,Y dimensions
  !----------------------------------------------------------------------
  integer,intent(in) :: np  !! Number of planes
  integer,intent(in) :: nx  !! output FFT X plane size
  integer,intent(in) :: ny  !! output FFT Y plane size
  integer,intent(in) :: ip  !! Plane to be extracted
  integer,intent(in) :: lx  !! input FFT cube X plane size
  integer,intent(in) :: ly  !! input FFT cube Y plane size
  complex,intent(in) :: in(np,lx,ly) !! Input FFT cube
  complex,intent(out) :: out(nx,ny)  !! Output 2-D FFT
  !
  ! Local ---
  integer i,j,my,mx,kx,ky,ii,jj
  !
  ! Code ----
  mx = nx/2
  my = ny/2
  kx = lx/2
  ky = ly/2
  !
  out = 0.0
  !
  do j=1,ky
    jj = j+my-ky
    do i=1,kx
      ii = i+mx-kx
      out(ii+mx,jj+my) = in(ip,i,j)
    enddo
    do i=1,kx
      out(i,jj+my) = in(ip,i+kx,j)
    enddo
  enddo
  do j=1,ky
    do i=1,kx
      ii = i+mx-kx
      out(ii+mx,j) = in(ip,i,j+ky)
    enddo
    do i=1,kx
      out(i,j) = in(ip,i+kx,j+ky)
    enddo
  enddo
end subroutine extracs
!
subroutine extrac (np,nx,ny,ip,in,out)
  !----------------------------------------------------------------------
  ! @ public
  !*
  ! IMAGER -- Utility routine
  !
  !     Extract a Fourier plane from an FFT cube
  !     Plane and Cube must have same X,Y dimensions
  !----------------------------------------------------------------------
  integer,intent(in) :: np  !! Number of planes
  integer,intent(in) :: nx  !! FFT X plane size
  integer,intent(in) :: ny  !! FFT Y plane size
  integer,intent(in) :: ip  !! Plane to be extracted
  complex,intent(in) :: in(np,nx,ny) !! Input FFT cube
  complex,intent(out) :: out(nx,ny)  !! Output 2-D FFT
  !
  ! Local ---
  integer i,j,my,mx
  !
  ! Code ----
  mx = nx/2
  my = ny/2
  !
  do j=1,my
    do i=1,mx
      out(i+mx,j+my) = in(ip,i,j)
    enddo
    do i=1,mx
      out(i,j+my) = in(ip,i+mx,j)
    enddo
  enddo
  do j=1,my
    do i=1,mx
      out(i+mx,j) = in(ip,i,j+my)
    enddo
    do i=1,mx
      out(i,j) = in(ip,i+mx,j+my)
    enddo
  enddo
end subroutine extrac
!
subroutine dovisi (np,nv,visi,vv,ww,jw)
  !----------------------------------------------------------------------
  ! @ public
  !
  ! IMAGER -- Visibility handling routine
  !
  !   Extract V coordinate and Weight value
  !
  !----------------------------------------------------------------------
  integer, intent(in) :: np        !! Size of visibilities
  integer, intent(in) :: nv        !! Number of visibilities
  real, intent(in) :: visi(np,nv)  !! Visibilities
  real, intent(out) :: vv(nv)      !! V values
  real, intent(out) :: ww(nv)      !! Weight values
  integer, intent(in) :: jw        !! Weight column
  !
  integer i
  do i=1,nv
    vv(i) = visi(2,i)
    ww(i) = visi(jw,i)
  enddo
end subroutine dovisi
!
subroutine dogrid (corr,corx,cory,nx,ny,beam)
  !----------------------------------------------------------------------
  ! @ public
  !
  ! IMAGER -- Gridding routine
  !
  !   Compute grid correction array, with normalisation
  !   of beam to 1.0 at maximum pixel
  !!
  !----------------------------------------------------------------------
  integer, intent(in) :: nx         !! X size
  integer, intent(in) :: ny         !! Y size
  real, intent(in) :: beam(nx,ny)   !! Denormalized beam
  real, intent(in) :: corx(nx)      !! X grid correction
  real, intent(in) :: cory(ny)      !! Y Grid correction
  real, intent(out) :: corr(nx,ny)  !! Final grid correction and beam normalization
  !
  real(4) x
  integer  ::i,j
  !
  x = corx(nx/2+1)*cory(ny/2+1)/beam(nx/2+1,ny/2+1)
  do j=1,ny
    do i=1,nx
      corr(i,j) = x/(corx(i)*cory(j))
    enddo
  enddo
end subroutine dogrid
!
subroutine docorr (map,corr,nd)
  !----------------------------------------------------------------------
  ! @ public
  !*
  ! IMAGER - Gridding routine
  !
  !   Apply grid correction to map
  !!
  !----------------------------------------------------------------------
  integer, intent(in) :: nd         !! Number of data
  real, intent(inout) :: map(nd)    !! Data
  real, intent(in) :: corr(nd)      !! Correction
  integer i
  !
  do i=1,nd
    map(i) = map(i)*corr(i)
  enddo
end subroutine docorr
!
subroutine docoor (n,xinc,x)
  !----------------------------------------------------------------------
  ! @ public
  !*
  ! IMAGER  -- Grdding routine
  !
  !   Compute FFT grid coordinates in U or V
  !!
  !----------------------------------------------------------------------
  integer,intent(in) :: n     !! Number of values
  real, intent(out) :: x(n)   !! Values
  real, intent(in) :: xinc    !! Increment
  !
  integer :: i
  do i=1,n
    x(i) = float(i-n/2-1)*xinc
  enddo
end subroutine docoor
!
subroutine findp (nv,xx,xlim,nlim)
  !----------------------------------------------------------------------
  ! @ public
  !*
  ! IMAGER --  Utility routine
  !
  !   Find NLIM such that  
  !   XX(NLIM-1) < XLIM < XX(NLIM)  
  !   for input data ordered, retrieved from memory. It 
  !   assumes NLIM already preset so that XX(NLIM-1) < XLIM
  !----------------------------------------------------------------------
  integer, intent(in) :: nv       !! Number of values
  integer, intent(inout) :: nlim  !! Preset Position
  real, intent(in) :: xx(nv)      !! Input order value
  real, intent(in) :: xlim        !! Value to be located
  !
  ! Local ---
  integer :: ninf,nsup,nmid
  !
  ! Code ----
  if (xx(nv).lt.xlim) then
    nlim = nv+1
    return
  elseif (xx(nlim).gt.xlim) then
    return
  endif
  !
  ninf = nlim
  nsup = nv
  do while (nsup.gt.ninf+1)
    nmid = (nsup + ninf)/2
    if (xx(nmid).lt.xlim) then
      ninf = nmid
    else
      nsup = nmid
    endif
  enddo
  nlim = nsup
end subroutine findp
!
subroutine findm (nv,xx,xlim,nlim)
  !----------------------------------------------------------------------
  ! @ public
  !*
  ! IMAGER -- Utility routine 
  !
  !   Find NLIM such that   
  !     XX(NLIM-1) < XLIM < XX(NLIM)  
  !   for input data ordered, retrieved from memory. It
  !   assumes NLIM already preset so that XLIM < XX(NLIM)
  !!
  !----------------------------------------------------------------------
  integer, intent(in) :: nv        !! Number of values
  integer, intent(inout) :: nlim   !! Preset Position
  real, intent(in) :: xx(nv)       !! Input order value
  real, intent(in) :: xlim         !! Value to be located
  !
  ! Local ---
  integer :: ninf,nsup,nmid
  !
  ! Code -----
  if (xx(nv).lt.xlim) then
    nlim = nv+1
    return
  elseif (xx(1).gt.xlim) then
    nlim = 1
    return
  endif
  !
  nsup = nlim
  ninf = 1
  do while (nsup.gt.ninf+1)
    nmid = (nsup + ninf)/2
    if (xx(nmid).lt.xlim) then
      ninf = nmid
    else
      nsup = nmid
    endif
  enddo
  nlim = nsup
end subroutine findm
!
subroutine grdtab (n, buff, bias, corr)
  !----------------------------------------------------------------------
  ! @ public
  !*
  ! IMAGER -- Utility routine
  !
  !   Compute fourier transform of gridding function
  !!
  !----------------------------------------------------------------------
  integer, intent(in) :: n     !! Number of pixels, assuming center on N/2+1
  real, intent(in) :: buff(*)  !! Gridding function, tabulated every 1/100 cell
  real, intent(in) :: bias     !! Center of gridding function
  real, intent(out) :: corr(n) !! Gridding correction FT
  !
  ! PI is defined with more digits than necessary to avoid losing
  ! the last few bits in the decimal to binary conversion
  real(kind=8), parameter :: pi=3.14159265358979323846d0
  !
  ! Local ---
  integer :: i,j,m,l
  real(4) :: kw,kx
  !
  do j=1,n
    corr(j) = 0.0
  enddo
  m = n/2+1
  kw = 0.01 * pi / m
  l = 2*bias+1
  do i=1,l
    if (buff(i).ne.0.0) then
      kx  = kw*(float(i)-bias)
      do j=1,n
        corr(j) = corr(j) + buff(i) * cos(kx*float(j-m))
      enddo
    endif
  enddo
end subroutine grdtab
!
subroutine retocm(r,z,nx,ny)
  !------------------------------------------------------------------------
  ! @  public
  !
  ! IMAGER -- FFT support routine
  !
  !   Convert real to complex, with Shifting in corners for FFT
  !!
  !------------------------------------------------------------------------
  integer, intent(in) :: nx, ny         !! Problem size
  real, intent(in) :: r(nx,ny)          !! Real values
  complex, intent(out) :: z(nx, ny)     !! Complex shifted values
  !
  ! Local ---
  integer :: i, j, ii, jj
  !
  ! Code ----
  do j=1, ny
    jj = mod(j+ny/2-1,ny)+1
    do i=1, nx
      ii = mod(i+nx/2-1,nx)+1
      z(ii,jj) = cmplx(r(i,j),0.0)
    enddo
  enddo
end subroutine retocm
!
subroutine cmtore (in,out,nx,ny)
  !----------------------------------------------------------------------
  ! @ public
  !*
  ! IMAGER -- FFT support routine
  !
  !   Extract Real image from Fourier Transform of its complex FFT
  !   with appropriate recentering
  !!
  !----------------------------------------------------------------------
  integer, intent(in) :: nx         !! Size of map
  integer, intent(in) :: ny         !! Size of map
  complex, intent(in) :: in(nx,ny)  !! Complex FFT
  real, intent(out) :: out(nx,ny)   !! Extracted real image
  !
  ! Local ---
  integer :: mx,my,i,j
  !
  ! Code ----
  mx = nx/2
  my = ny/2
  do j=1,my
    do i=1,mx
      out(i+mx,j+my) = real(in(i,j))
    enddo
    do i=1,mx
      out(i,j+my) = real(in(i+mx,j))
    enddo
  enddo
  do j=1,my
    do i=1,mx
      out(i+mx,j) = real(in(i,j+my))
    enddo
    do i=1,mx
      out(i,j) = real(in(i+mx,j+my))
    enddo
  enddo
end subroutine cmtore
!
subroutine convfn (ctype, parm, buffer, bias)
  use gkernel_interfaces
  use gildas_def
  use gbl_message
  !----------------------------------------------------------------------
  ! @ public-mandatory
  !
  ! IMAGER -- Gridding routine
  !
  !   CONVFN computes the convolving functions and stores them in
  !   the supplied buffer. Values are tabulated every 1/100 cell.
  !!
  !----------------------------------------------------------------------
  integer, intent(inout) :: ctype     !! Convolution type
  real(4), intent(inout) :: parm(10)  !! Convolution parameters
  real(4), intent(out)   :: buffer(:) !! Sampled values
  real(4), intent(out)   :: bias      !! Center of samples
  !
  real(4), parameter :: pi=3.1415926536
  !
  ! Local ---
  integer :: lim, i, im, ialf, ier, ibias, mbuf
  real(4) :: p1, p2, u, umax, absu, eta, psi
  !
  ! Code ----
  !
  ! Number of elements
  i = max (1, ceiling(parm(1))) ! Ensure at least one cell
  i = i * 2 + 1
  lim = i * 100 + 1
  !
  mbuf = ubound(buffer,1)
  if (lim.gt.mbuf) then
    Print *,'MBUF ',lim, mbuf
    call gag_message(seve%f,'GRID','Work buffer insufficient')
    call sysexi(fatale)
  endif
  bias = 50.0 * i + 1.0
  umax = parm(1)                ! Compute to that cell fraction
  !
  !  Check function types.
  if (ctype.lt.1 .or. ctype.gt.5) then
    !
    ! Type defaulted or not implemented, use Default = EXP * SINC
    ctype = 4
    parm(1) = 3.0
    parm(2) = 1.55
    parm(3) = 2.52
    parm(4) = 2.00
  endif
  !
  buffer(:) = 0.0
  !
  select case(ctype)
  case(1)
    ! Pill box
    do i = 1,lim
      u = (i-bias) * 0.01
      absu = abs (u)
      if (absu.lt.umax) then
        buffer(i) = 1.0
      elseif (absu.eq.umax) then
        buffer(i) = 0.5
      else
        buffer(i) = 0.0
      endif
    enddo
    !
  case(2)
    ! Exponential function.
    p1 = 1.0 / parm(2)
    do i = 1,lim
      u = (i-bias) * 0.01
      absu = abs (u)
      if (absu.gt.umax) then
        buffer(i) = 0.0
      else
        buffer(i) = exp (-((p1*absu) ** parm(3)))
      endif
    enddo
    !
  case(3)
    ! Sinc function.
    p1 = pi / parm(2)
    do i = 1,lim
      u = (i-bias)*0.01
      absu = abs (u)
      if (absu.gt.umax) then
        buffer(i) = 0.0
      elseif (absu.eq.0.0) then
        buffer(i) = 1.0
      else
        buffer(i) = sin (p1*absu) / (p1*absu)
      endif
    enddo
    !
  case(4)
    ! EXP * SINC convolving function
    p1 = pi / parm(2)
    p2 = 1.0 / parm(3)
    do i = 1,lim
      u = (i-bias)*0.01
      absu = abs (u)
      if (absu.gt.umax) then
        buffer(i) = 0.0
      elseif (absu.lt.0.01) then
        buffer(i) = 1.0
      else
        buffer(i) = sin(u*p1) / (u*p1) *   &
       &        exp (-((absu * p2) ** parm(4)))
      endif
    enddo
    !
  case(5)
    ! Spheroidal functions
    ialf = 2.0 * parm(2) + 1.1
    im = 2.0 * parm(1) + 0.1
    ialf = max (1, min (5, ialf))
    im = max (4, min (8, im))
    lim = parm(1) * 100.0 + 0.1
    ibias = bias
    do i = 1,lim
      eta = float (i-1) / float (lim-1)
      call sphfn (ialf, im, 0, eta, psi, ier)
      buffer(ibias+i-1) = psi
    enddo
    lim = ibias-1
    do i = 1,lim
      buffer(ibias-i) = buffer(ibias+i)
    enddo
  end select
  !
end subroutine convfn
!
subroutine sphfn (ialf, im, iflag, eta, psi, ier)
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !
  !     SPHFN is a subroutine to evaluate rational approximations to se-
  !  lected zero-order spheroidal functions, psi(c,eta), which are, in a
  !  sense defined in VLA Scientific Memorandum No. 132, optimal for
  !  gridding interferometer data.  The approximations are taken from
  !  VLA Computer Memorandum No. 156.  The parameter c is related to the
  !  support width, m, of the convoluting function according to c=
  !  pi*m/2.  The parameter alpha determines a weight function in the
  !  definition of the criterion by which the function is optimal.
  !  SPHFN incorporates approximations to 25 of the spheroidal func-
  !  tions, corresponding to 5 choices of m (4, 5, 6, 7, or 8 cells)
  !  and 5 choices of the weighting exponent (0, 1/2, 1, 3/2, or 2).
  !
  !  Input:
  !    IALF    I*4   Selects the weighting exponent, alpha.  IALF =
  !                  1, 2, 3, 4, and 5 correspond, respectively, to
  !                  alpha = 0, 1/2, 1, 3/2, and 2.
  !    IM      I*4   Selects the support width m, (=IM) and, correspond-
  !                  ingly, the parameter c of the spheroidal function.
  !                  Only the choices 4, 5, 6, 7, and 8 are allowed.
  !    IFLAG   I*4   Chooses whether the spheroidal function itself, or
  !                  its Fourier transform, is to be approximated.  The
  !                  latter is appropriate for gridding, and the former
  !                  for the u-v plane convolution.  The two differ on-
  !                  by a factor (1-eta**2)**alpha.  IFLAG less than or
  !                  equal to zero chooses the function appropriate for
  !                  gridding, and IFLAG positive chooses its F.T.
  !    ETA     R*4   Eta, as the argument of the spheroidal function, is
  !                  a variable which ranges from 0 at the center of the
  !                  convoluting function to 1 at its edge (also from 0
  !                  at the center of the gridding correction function
  !                  to unity at the edge of the map).
  !
  !  Output:
  !    PSI      R*4  The function value which, on entry to the subrou-
  !                  tine, was to have been computed.
  !    IER      I*4  An error flag whose meaning is as follows:
  !                     IER = 0  =>  No evident problem.
  !                           1  =>  IALF is outside the allowed range.
  !                           2  =>  IM is outside of the allowed range.
  !                           3  =>  ETA is larger than 1 in absolute
  !                                     value.
  !                          12  =>  IALF and IM are out of bounds.
  !                          13  =>  IALF and ETA are both illegal.
  !                          23  =>  IM and ETA are both illegal.
  !                         123  =>  IALF, IM, and ETA all are illegal.
  !
  !---------------------------------------------------------------------
  integer(4), intent(in)  :: ialf     !! Exponent
  integer(4), intent(in)  :: im       !! Width of support
  integer(4), intent(in)  :: iflag    !! Gridding function
  real(4), intent(in)     :: eta      !! For spheroidals only
  real(4), intent(out)    :: psi      !! Result
  integer(4), intent(out) :: ier      !! Error code
  !
  character(len=message_length) :: mess
  integer(4) j
  real(4) alpha(5), eta2, x
  real(4) p4(5,5), q4(2,5), p5(7,5), q5(5), p6l(5,5), q6l(2,5),   &
     &    p6u(5,5), q6u(2,5), p7l(5,5), q7l(2,5), p7u(5,5),   &
     &    q7u(2,5), p8l(6,5), q8l(2,5), p8u(6,5), q8u(2,5)
  data alpha / 0., .5, 1., 1.5, 2. /
  data p4 /   &
     &    1.584774e-2, -1.269612e-1,  2.333851e-1, -1.636744e-1,   &
     &    5.014648e-2,  3.101855e-2, -1.641253e-1,  2.385500e-1,   &
     &    -1.417069e-1,  3.773226e-2,  5.007900e-2, -1.971357e-1,   &
     &    2.363775e-1, -1.215569e-1,  2.853104e-2,  7.201260e-2,   &
     &    -2.251580e-1,  2.293715e-1, -1.038359e-1,  2.174211e-2,   &
     &    9.585932e-2, -2.481381e-1,  2.194469e-1, -8.862132e-2,   &
     &    1.672243e-2 /
  data q4 /   &
     &    4.845581e-1,  7.457381e-2,  4.514531e-1,  6.458640e-2,   &
     &    4.228767e-1,  5.655715e-2,  3.978515e-1,  4.997164e-2,   &
     &    3.756999e-1,  4.448800e-2 /
  data p5 /   &
     &    3.722238e-3, -4.991683e-2,  1.658905e-1, -2.387240e-1,   &
     &    1.877469e-1, -8.159855e-2,  3.051959e-2,  8.182649e-3,   &
     &    -7.325459e-2,  1.945697e-1, -2.396387e-1,  1.667832e-1,   &
     &    -6.620786e-2,  2.224041e-2,  1.466325e-2, -9.858686e-2,   &
     &    2.180684e-1, -2.347118e-1,  1.464354e-1, -5.350728e-2,   &
     &    1.624782e-2,  2.314317e-2, -1.246383e-1,  2.362036e-1,   &
     &    -2.257366e-1,  1.275895e-1, -4.317874e-2,  1.193168e-2,   &
     &    3.346886e-2, -1.503778e-1,  2.492826e-1, -2.142055e-1,   &
     &    1.106482e-1, -3.486024e-2,  8.821107e-3 /
  data q5 /   &
     &    2.418820e-1,  2.291233e-1,  2.177793e-1,  2.075784e-1,   &
     &    1.983358e-1 /
  data p6l /   &
     &    5.613913e-2, -3.019847e-1,  6.256387e-1, -6.324887e-1,   &
     &    3.303194e-1,  6.843713e-2, -3.342119e-1,  6.302307e-1,   &
     &    -5.829747e-1,  2.765700e-1,  8.203343e-2, -3.644705e-1,   &
     &    6.278660e-1, -5.335581e-1,  2.312756e-1,  9.675562e-2,   &
     &    -3.922489e-1,  6.197133e-1, -4.857470e-1,  1.934013e-1,   &
     &    1.124069e-1, -4.172349e-1,  6.069622e-1, -4.405326e-1,   &
     &    1.618978e-1 /
  data q6l /   &
     &    9.077644e-1,  2.535284e-1,  8.626056e-1,  2.291400e-1,   &
     &    8.212018e-1,  2.078043e-1,  7.831755e-1,  1.890848e-1,   &
     &    7.481828e-1,  1.726085e-1 /
  data p6u /   &
     &    8.531865e-4, -1.616105e-2,  6.888533e-2, -1.109391e-1,   &
     &    7.747182e-2,  2.060760e-3, -2.558954e-2,  8.595213e-2,   &
     &    -1.170228e-1,  7.094106e-2,  4.028559e-3, -3.697768e-2,   &
     &    1.021332e-1, -1.201436e-1,  6.412774e-2,  6.887946e-3,   &
     &    -4.994202e-2,  1.168451e-1, -1.207733e-1,  5.744210e-2,   &
     &    1.071895e-2, -6.404749e-2,  1.297386e-1, -1.194208e-1,   &
     &    5.112822e-2 /
  data q6u /   &
     &    1.101270e+0,  3.858544e-1,  1.025431e+0,  3.337648e-1,   &
     &    9.599102e-1,  2.918724e-1,  9.025276e-1,  2.575336e-1,   &
     &    8.517470e-1,  2.289667e-1 /
  data p7l /   &
     &    2.460495e-2, -1.640964e-1,  4.340110e-1, -5.705516e-1,   &
     &    4.418614e-1,  3.070261e-2, -1.879546e-1,  4.565902e-1,   &
     &    -5.544891e-1,  3.892790e-1,  3.770526e-2, -2.121608e-1,   &
     &    4.746423e-1, -5.338058e-1,  3.417026e-1,  4.559398e-2,   &
     &    -2.362670e-1,  4.881998e-1, -5.098448e-1,  2.991635e-1,   &
     &    5.432500e-2, -2.598752e-1,  4.974791e-1, -4.837861e-1,   &
     &    2.614838e-1 /
  data q7l /   &
     &    1.124957e+0,  3.784976e-1,  1.075420e+0,  3.466086e-1,   &
     &    1.029374e+0,  3.181219e-1,  9.865496e-1,  2.926441e-1,   &
     &    9.466891e-1,  2.698218e-1 /
  data p7u /   &
     &    1.924318e-4, -5.044864e-3,  2.979803e-2, -6.660688e-2,   &
     &    6.792268e-2,  5.030909e-4, -8.639332e-3,  4.018472e-2,   &
     &    -7.595456e-2,  6.696215e-2,  1.059406e-3, -1.343605e-2,   &
     &    5.135360e-2, -8.386588e-2,  6.484517e-2,  1.941904e-3,   &
     &    -1.943727e-2,  6.288221e-2, -9.021607e-2,  6.193000e-2,   &
     &    3.224785e-3, -2.657664e-2,  7.438627e-2, -9.500554e-2,   &
     &    5.850884e-2 /
  data q7u /   &
     &    1.450730e+0,  6.578685e-1,  1.353872e+0,  5.724332e-1,   &
     &    1.269924e+0,  5.032139e-1,  1.196177e+0,  4.460948e-1,   &
     &    1.130719e+0,  3.982785e-1 /
  data p8l /   &
     &    1.378030e-2, -1.097846e-1,  3.625283e-1, -6.522477e-1,   &
     &    6.684458e-1, -4.703556e-1,  1.721632e-2, -1.274981e-1,   &
     &    3.917226e-1, -6.562264e-1,  6.305859e-1, -4.067119e-1,   &
     &    2.121871e-2, -1.461891e-1,  4.185427e-1, -6.543539e-1,   &
     &    5.904660e-1, -3.507098e-1,  2.580565e-2, -1.656048e-1,   &
     &    4.426283e-1, -6.473472e-1,  5.494752e-1, -3.018936e-1,   &
     &    3.098251e-2, -1.854823e-1,  4.637398e-1, -6.359482e-1,   &
     &    5.086794e-1, -2.595588e-1 /
  data q8l /   &
     &    1.076975e+0,  3.394154e-1,  1.036132e+0,  3.145673e-1,   &
     &    9.978025e-1,  2.920529e-1,  9.617584e-1,  2.715949e-1,   &
     &    9.278774e-1,  2.530051e-1 /
  data p8u /   &
     &    4.290460e-5, -1.508077e-3,  1.233763e-2, -4.091270e-2,   &
     &    6.547454e-2, -5.664203e-2,  1.201008e-4, -2.778372e-3,   &
     &    1.797999e-2, -5.055048e-2,  7.125083e-2, -5.469912e-2,   &
     &    2.698511e-4, -4.628815e-3,  2.470890e-2, -6.017759e-2,   &
     &    7.566434e-2, -5.202678e-2,  5.259595e-4, -7.144198e-3,   &
     &    3.238633e-2, -6.946769e-2,  7.873067e-2, -4.889490e-2,   &
     &    9.255826e-4, -1.038126e-2,  4.083176e-2, -7.815954e-2,   &
     &    8.054087e-2, -4.552077e-2 /
  data q8u /   &
     &    1.379457e+0,  5.786953e-1,  1.300303e+0,  5.135748e-1,   &
     &    1.230436e+0,  4.593779e-1,  1.168075e+0,  4.135871e-1,   &
     &    1.111893e+0,  3.744076e-1 /
  !
  ! Code ----
  ier = 0
  if (ialf.lt.1 .or. ialf.gt.5) ier = 1
  if (im.lt.4 .or. im.gt.8) ier = 2+10*ier
  if (abs(eta).gt.1.) ier = 3+10*ier
  if (ier.ne.0) then
    write(mess,*) 'Error ',ier
    call gag_message(seve%e,'SPHEROIDAL',mess)
    return
  endif
  eta2 = eta**2
  j = ialf
  !
  ! Support width = 4 cells:
  if (im.eq.4) then
    x = eta2-1.
    psi = (p4(1,j)+x*(p4(2,j)+x*(p4(3,j)+x*(p4(4,j)+x*p4(5,j)))))   &
     &      / (1.+x*(q4(1,j)+x*q4(2,j)))
    !
    ! Support width = 5 cells:
  elseif (im.eq.5) then
    x = eta2-1.
    psi = (p5(1,j)+x*(p5(2,j)+x*(p5(3,j)+x*(p5(4,j)+x*(p5(5,j)   &
     &      +x*(p5(6,j)+x*p5(7,j)))))))   &
     &      / (1.+x*q5(j))
    !
    ! Support width = 6 cells:
  elseif (im.eq.6) then
    if (abs(eta).le..75) then
      x = eta2-.5625
      psi = (p6l(1,j)+x*(p6l(2,j)+x*(p6l(3,j)+x*(p6l(4,j)   &
     &        +x*p6l(5,j))))) / (1.+x*(q6l(1,j)+x*q6l(2,j)))
    else
      x = eta2-1.
      psi = (p6u(1,j)+x*(p6u(2,j)+x*(p6u(3,j)+x*(p6u(4,j)   &
     &        +x*p6u(5,j))))) / (1.+x*(q6u(1,j)+x*q6u(2,j)))
    endif
    !
    ! Support width = 7 cells:
  elseif (im.eq.7) then
    if (abs(eta).le..775) then
      x = eta2-.600625
      psi = (p7l(1,j)+x*(p7l(2,j)+x*(p7l(3,j)+x*(p7l(4,j)   &
     &        +x*p7l(5,j))))) / (1.+x*(q7l(1,j)+x*q7l(2,j)))
    else
      x = eta2-1.
      psi = (p7u(1,j)+x*(p7u(2,j)+x*(p7u(3,j)+x*(p7u(4,j)   &
     &        +x*p7u(5,j))))) / (1.+x*(q7u(1,j)+x*q7u(2,j)))
    endif
    !
    ! Support width = 8 cells:
  elseif (im.eq.8) then
    if (abs(eta).le..775) then
      x = eta2-.600625
      psi = (p8l(1,j)+x*(p8l(2,j)+x*(p8l(3,j)+x*(p8l(4,j)   &
     &        +x*(p8l(5,j)+x*p8l(6,j)))))) / (1.+x*(q8l(1,j)+x*q8l(2,j)))
    else
      x = eta2-1.
      psi = (p8u(1,j)+x*(p8u(2,j)+x*(p8u(3,j)+x*(p8u(4,j)   &
     &        +x*(p8u(5,j)+x*p8u(6,j)))))) / (1.+x*(q8u(1,j)+x*q8u(2,j)))
    endif
  endif
  !
  ! Normal return:
  if (iflag.gt.0 .or. ialf.eq.1 .or. eta.eq.0.) return
  if (abs(eta).eq.1.) then
    psi = 0.0
  else
    psi = (1.-eta2)**alpha(ialf)*psi
  endif
end subroutine sphfn
!
subroutine grdflt (ctypx, ctypy, xparm, yparm)
  !----------------------------------------------------------------------
  ! @ public
  !
  ! IMAGER -- Gridding function
  !
  !     GRDFLT determines default parameters for the convolution functions
  !     If no convolving type is chosen, an Spheroidal is picked.
  !     Otherwise any unspecified values ( = 0.0) will be set to some
  !     value.
  ! Arguments:
  !     CTYPX,CTYPY           I  Convolution types for X and Y direction
  !                                1 = pill box
  !                                2 = exponential
  !                                3 = sinc
  !                                4 = expontntial * sinc
  !                                5 = spheroidal function
  !     XPARM(10),YPARM(10)   R*4  Parameters for the convolution fns.
  !                                (1) = support radius (cells)
  !
  !----------------------------------------------------------------------
  integer, intent(inout) :: ctypx,ctypy !! Function type
  real(4), intent(inout) :: xparm(10)   !! X function parameters
  real(4), intent(inout) :: yparm(10)   !! Y function parameters
  !
  ! Constants
  character(len=12) chtyps(5)   !! Function types
  integer numprm(5)             !! Number of parameters
  data numprm /1, 3, 2, 4, 2/
  data chtyps /'Pillbox','Exponential','Sin(X)/(X)',   &
     &    'Exp*Sinc','Spheroidal'/
  !
  integer :: i
  !
  ! Code ---
  !
  ! Default = type 5
  if ((ctypx.le.0) .or. (ctypx.gt.5)) ctypx = 5
  !
  ! Pillbox
  if (ctypx.eq.1) then
    if (xparm(1).le.0.0) xparm(1) = 0.5
  elseif (ctypx.eq.2) then
    ! Exponential.
    if (xparm(1).le.0.0) xparm(1) = 3.0
    if (xparm(2).le.0.0) xparm(2) = 1.00
    if (xparm(3).le.0.0) xparm(3) = 2.00
  elseif (ctypx.eq.3) then
    ! Sinc.
    if (xparm(1).le.0.0) xparm(1) = 3.0
    if (xparm(2).le.0.0) xparm(2) = 1.14
  elseif (ctypx.eq.4) then
    ! Exponential * sinc
    if (xparm(1).le.0.0) xparm(1) = 3.0
    if (xparm(2).le.0.0) xparm(2) = 1.55
    if (xparm(3).le.0.0) xparm(3) = 2.52
    if (xparm(4).le.0.0) xparm(4) = 2.00
  else
    ! Spheroidal function
    if (xparm(1).le.0.0) xparm(1) = 3.0
    if (xparm(2).le.0.0) xparm(2) = 1.0
  endif
  !
  ! Put default cheking here for further function types

  ! Check Y convolution defaults
  if (ctypy.le.0) then
    ! Use X values
    ctypy = ctypx
    do i = 1,10
      yparm(i) = xparm(i)
    enddo
  elseif (ctypy.eq.1) then
    ! Pillbox
    if (yparm(1).le.0.0) yparm(1) = 0.5
  elseif (ctypy.eq.2) then
    ! Exponential
    if (yparm(1).le.0.0) yparm(1) = 3.0
    if (yparm(2).le.0.0) yparm(2) = 1.0
    if (yparm(3).le.0.0) yparm(3) = 2.0
  elseif (ctypy.eq.3) then
    ! Sinc
    if (yparm(1).le.0.0) yparm(1) = 3.0
    if (yparm(2).le.0.0) yparm(2) = 1.14
  elseif (ctypy.eq.4) then
    ! Exponential * sinc
    if (yparm(1).le.0.0) yparm(1) = 3.0
    if (yparm(2).le.0.0) yparm(2) = 1.55
    if (yparm(3).le.0.0) yparm(3) = 2.52
    if (yparm(4).le.0.0) yparm(4) = 2.00
  else
    ! Spheroidal function
    if (yparm(1).le.0.0) yparm(1) = 3.0
    if (yparm(2).le.0.0) yparm(2) = 1.0
  endif
  !
  ! Put default checking for new types here.
  ! Print parameters chosen.
  !      WRITE(6,1001) 'X',CHTYPS(CTYPX),(XPARM(K),K=1,NUMPRM(CTYPX))
  !      WRITE(6,1001) 'Y',CHTYPS(CTYPY),(YPARM(K),K=1,NUMPRM(CTYPY))
  !1001  FORMAT(1X,A,' Convolution ',A,' Par.=',5F8.4)
end subroutine grdflt
!
subroutine uvgmax(huv,visi,uvmax,uvmin)
  use image_def
  !----------------------------------------------------------------------
  ! @ public
  !*
  ! IMAGER -- Support for UV_MAP
  !
  !       Get the Min Max of UV distances
  !!
  !----------------------------------------------------------------------
  type (gildas), intent(inout) :: huv   !! UV data header
  real, intent(in) ::  visi(:,:)        !! Visibilities
  real, intent(out) :: uvmax            !! Max baseline
  real, intent(out) :: uvmin            !! Min baseline
  !
  ! Local ---
  integer :: j
  real(4) :: v
  !
  ! Code ----
  if (huv%gil%basemax.eq.0) then
    uvmax = 0.0
    uvmin = 1e36
    do j=1,huv%gil%nvisi        ! Consider only valid visibilities
      if (visi(6,j).gt.0) then  ! Avoid Null or Negative antenna numbers
        v = visi(1,j)*visi(1,j)+visi(2,j)*visi(2,j)
        if (v.ne.0) then
          uvmax = max(uvmax,v)
          uvmin = min(uvmin,v)
        endif
      endif
    enddo
    if (uvmin.gt.uvmax) uvmin = uvmax
    huv%gil%basemax = sqrt(uvmax)
    huv%gil%basemin = sqrt(uvmin)
  endif
  !
  uvmax = huv%gil%basemax
  uvmin = huv%gil%basemin
end subroutine uvgmax
!
function sump(n,a)
  !----------------------------------------------------------------------
  ! @ public
  !*
  ! IMAGER --  Support for UV_MAP
  !
  !       Return the sum of positive values in array
  !!
  !----------------------------------------------------------------------
  real :: sump               !! Return value, intent(out)
  integer, intent(in) :: n   !! Number of values
  real, intent(in) :: a(n)   !! Values
  !
  ! Local ---
  integer :: i
  real(kind=8) :: sumd    ! use extended precision to avoid losses
  !
  ! Code ----
  sumd = 0.0
  do i=1,n
    if (a(i).gt.0) sumd = sumd+a(i)
  enddo
  sump = sumd
end function sump
!

subroutine greg3_spectrum_compute(line,error)
  use image_def
  use sic_types
  use greg_interfaces, except_this=>greg3_spectrum_compute
  use greg_dependencies_interfaces
  use greg_poly
  use gbl_message
  !-----------------------------------------------------------------
  ! @ public  
  !
  ! SPECTRUM OutVar Invar [Mask] /MEAN  [Mean|Sum]
  !     /CORNER Blc Trc /Plane First Last
  !
  !   Compute the mean spectrum over the specified region,
  !   bounded by the GreG polygon.
  !
  ! Invar is a SIC Image Variable
  ! Return this in the specified Outvar SIC variable
  !
  ! The idea is that this routine will be callable by GO VIEW as
  !   SPECTRUM MSPECTRE &1 /CORNER IBLC[1] IBLC[2] ITRC[1] ITRC[2]
  !     /PLANE MIPLANE[1] MIPLANE[2 [/MEAN] [/SUM]
  ! Invar will then be VUE, while for command VIEW in Mapping, Invar
  ! is  W. Outvar is MSPECTRE in the GO VIEW application.
  ! Loops can be parallelized for speed.
  !------------------------------------------------------------------
  character(len=*), intent(in)    :: line
  logical,          intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='SPECTRUM'
  type(gildas) :: hin
  integer(kind=address_length) :: ipin,ipou,ipma,ip
  type(sic_descriptor_t) :: descr, desco, descm
  integer(kind=4) :: ibound(6),ier,nm,n,m,nc
  character(len=varname_length) :: invar,ouvar
  integer(kind=4) :: memory(2)
  integer(kind=size_length), allocatable :: ngood(:)
  real(kind=4), allocatable :: mask(:,:)
  logical :: found
  real(kind=4), save, target :: aire
  integer(kind=4), parameter :: opt_corner=1
  integer(kind=4), parameter :: opt_mean=2
  integer(kind=4), parameter :: opt_plane=3
  integer(kind=4), parameter :: opt_sum=4
  logical :: do_sum
  character(len=message_length) :: mess
  !
  if (greg_poly_isnull()) then
    call greg_message(seve%e,rname,'Greg polygon is not defined')
    error = .true.
    return
  endif
  !
  if (sic_present(opt_mean,0)) then
    if (sic_present(opt_sum,0)) then
      call greg_message(seve%e,rname,'Conflicting option /MEAN and /SUM')
      error = .true.
      return
    endif
    do_sum = .false.
  else if (sic_present(opt_sum,0)) then
    do_sum = .true.
  else
    call greg_message(seve%e,rname,'Missing option /MEAN or /SUM')
    error = .true.
    return
  endif
  !
  call gildas_null(hin)
  !
  invar = 'W'
  call sic_ch(line,0,2,invar,n,.false.,error)
  m = len_trim(invar)
  call sic_upper(invar)
  ! Allow the name to have the %data postfix
  if (m.gt.5 .and. invar(m-4:m).eq."%DATA") then
    n = m-5
  else
    n = m
  endif
  !
  ! Get dimensions
  error = .true.
  hin%gil%ndim = 3
  call sic_descriptor(invar(1:n)//'%DIM',descr,found)
  if (.not.found) then
    call greg_message(seve%e,rname,'Input variable '//invar(1:m)//' not found')
    return
  endif
  ip = gag_pointer(descr%addr,memory)
  if (index_length.eq.4) then
    call i4toi4(memory(ip),hin%gil%dim,3)
  else
    call i8toi8(memory(ip),hin%gil%dim,3)
  endif
  !
  ! Get conversion formula
  call sic_descriptor(invar(1:n)//'%CONVERT',descr,found)
  if (.not.found) return
  ip = gag_pointer(descr%addr,memory)
  call r8tor8(memory(ip),hin%gil%convert,12)
  !
  ! Get Blanking
  call sic_descriptor(invar(1:n)//'%BLANK',descr,found)
  if (.not.found) return
  ip = gag_pointer(descr%addr,memory)
  call r4tor4(memory(ip),hin%gil%bval,2)
  !
  ! Get input array
  call sic_descriptor(invar(1:m),descr,found)
  if (.not.found) return
  ipin = gag_pointer(descr%addr,memory)
  !
  ! Get output array
  call sic_ch(line,0,1,ouvar,n,.true.,error)
  if (error) return
  call sic_descriptor(ouvar(1:n),desco,found)
  if (.not.found) then
    call greg_message(seve%e,rname,'Output variable not found')
    error = .true.
    return
  endif
  ipou = gag_pointer(desco%addr,memory)
  !
  ! Get mask if any
  if (sic_present(0,3)) then
    call sic_ch(line,0,3,ouvar,n,.true.,error)
    if (error) return
    call sic_descriptor(ouvar(1:n),descm,found)
    if (.not.found) then
      call greg_message(seve%e,rname,'Mask variable not found')
      error = .true.
      return
    endif
    ipma = gag_pointer(descm%addr,memory)
    nm = max(descm%dims(3),1)
  else
    allocate(mask(hin%gil%dim(1),hin%gil%dim(2)),stat=ier)
    if (ier.ne.0) then
      call greg_message(seve%e,rname,'Mask allocation error')
      error = .true.
      return
    endif
    mask = 1.0
    nm = 1
    ipma = gag_pointer(locwrd(mask),memory)
  endif
  !
  ! /CORNER option handling
  ibound(1:2) = 0
  call sic_i4(line,opt_corner,1,ibound(1),.false.,error)
  if (error) return
  call sic_i4(line,opt_corner,2,ibound(3),.false.,error)
  if (error) return
  ier = gdf_range(ibound(1:2),hin%gil%dim(1))
  !
  ibound(3:4) = 0
  call sic_i4(line,opt_corner,3,ibound(3),.false.,error)
  if (error) return
  call sic_i4(line,opt_corner,4,ibound(4),.false.,error)
  if (error) return
  ier = gdf_range(ibound(3:4),hin%gil%dim(2))
  !
  ! /PLANE option handling
  ibound(5:6) = 0
  call sic_i4(line,opt_plane,1,ibound(5),.false.,error)
  if (error) return
  call sic_i4(line,opt_plane,2,ibound(6),.false.,error)
  if (error) return
  ier = gdf_range(ibound(5:6),hin%gil%dim(3))
  !
  nc = ibound(6)-ibound(5)+1
  if (nc.ne.desco%size) then
    call greg_message(seve%e,rname,'Spectrum dimension mismatch')
    !!Print *,'nc ',nc,ibound(5:6),desco%size
    error = .true.
    return
  endif
  write(mess,'(A,I0)') 'Output number of channels ',nc
  call greg_message(seve%i,rname,mess)
  write(mess,'(A,I0,1X,I0)') 'Number of pixels ',hin%gil%dim(1),hin%gil%dim(2)
  call greg_message(seve%i,rname,mess)
  !
  allocate(ngood(nc),stat=ier)
  if (ier.ne.0) then
    call greg_message(seve%e,rname,'Allocation error')
    error = .true.
    return
  endif
  !
  call greg_drive_spectre(nc,memory(ipou),ngood,aire,hin,memory(ipin),ibound, &
       memory(ipma),nm,gpoly,do_sum,error)
  if (error) return
  if (all(ngood.eq.ngood(1))) then
    write(mess,'(A,I0)') 'Number of selected pixels ',ngood(1)
    call greg_message(seve%i,rname,mess)
  endif
  if (sic_varexist('POLY%AREA')) call sic_delvariable('POLY%AREA',.false.,error)
  call sic_def_real ('POLY%AREA',aire,0,1,.true.,error)
  !
end subroutine greg3_spectrum_compute
!
subroutine greg_drive_spectre(nc,spectrum,ngood,aire,hin,din,ibound,rmask,nm,poly,do_sum,error)
  use image_def
  use greg_interfaces
  use greg_types
  use greg_dependencies_interfaces
  use gbl_message
  !$ use omp_lib
  !
  ! @ no-interfaces
  !
  integer(kind=4),            intent(in)    :: nc               ! Number of channels
  real(kind=4),               intent(out)   :: spectrum(nc)     ! Integrated area per plane
  integer(kind=size_length),  intent(out)   :: ngood(nc)        ! Area of valid pixels per plane
  real(kind=4),               intent(out)   :: aire             ! Area of support
  type(gildas),               intent(inout) :: hin              ! Image header
  real(kind=4),               intent(in)    :: din(hin%gil%dim(1),hin%gil%dim(2),hin%gil%dim(3)) ! Cube
  integer(kind=4),            intent(inout) :: ibound(6)        ! Cube boundaries
  integer(kind=4),            intent(in)    :: nm               ! Mask last dim
  real(kind=4),               intent(in)    :: rmask(hin%gil%dim(1),hin%gil%dim(2),nm) ! Real mask (0 or 1)
  type (polygon_t),           intent(in)    :: poly             ! Polygon
  logical,                    intent(in)    :: do_sum           ! Sum or Mean
  logical,                    intent(inout) :: error            ! Error flag
  !                           
  integer(kind=size_length) :: i,j,imin,imax,jmin,jmax,kmin,kmax,nk
  real(kind=8) :: x,y
  integer(kind=4) :: k
  !
  real(kind=8), allocatable :: t_spec(:,:), ouspec(:)
  integer(kind=size_length),allocatable :: t_good(:,:),t_nk(:)
  integer(kind=4) :: nt, ithread, ier
  character(len=message_length) :: mess
  !
  character(len=*), parameter :: rname = "GREG>DRIVE>SPECTRE"
  !
  if (poly%ngon.gt.0) then
    !
    ! Avoid exploring all the Map by finding IMIN,IMAX,JMIN,JMAX
    if (hin%gil%inc(1).gt.0.) then
      imin = max (1,    int((poly%xgon1-hin%gil%val(1))/hin%gil%inc(1)+hin%gil%ref(1)) )
      imax = min (hin%gil%dim(1),int((poly%xgon2-hin%gil%val(1))/hin%gil%inc(1)+hin%gil%ref(1))+1 )
    else
      imin = max (1,    int((poly%xgon2-hin%gil%val(1))/hin%gil%inc(1)+hin%gil%ref(1)) )
      imax = min (hin%gil%dim(1),int((poly%xgon1-hin%gil%val(1))/hin%gil%inc(1)+hin%gil%ref(1))+1 )
    endif
    if (hin%gil%inc(2).gt.0.) then
      jmin = max (1,    int((poly%ygon1-hin%gil%val(2))/hin%gil%inc(2)+hin%gil%ref(2)) )
      jmax = min (hin%gil%dim(2),int((poly%ygon2-hin%gil%val(2))/hin%gil%inc(2)+hin%gil%ref(2))+1 )
    else
      jmin = max (1,    int((poly%ygon2-hin%gil%val(2))/hin%gil%inc(2)+hin%gil%ref(2)) )
      jmax = min (hin%gil%dim(2),int((poly%ygon1-hin%gil%val(2))/hin%gil%inc(2)+hin%gil%ref(2))+1 )
    endif
    ibound(1) = max(ibound(1),imin)
    ibound(2) = min(ibound(2),imax)
    ibound(3) = max(ibound(3),jmin)
    ibound(4) = min(ibound(4),jmax)
  endif
  !
  !
  ! Avoid exploring all the Map by finding IMIN,IMAX,JMIN,JMAX
  imin = ibound(1)
  imax = ibound(2)
  jmin = ibound(3)
  jmax = ibound(4)
  kmin = ibound(5)
  kmax = ibound(6)
  !
  nt = 1
  !$ nt = omp_get_max_threads()
  allocate(t_spec(nc,nt),t_good(nc,nt),t_nk(nt),ouspec(nc),stat=ier)
  if (failed_allocate(rname,"Spectrum per thread",ier,error)) return
  t_nk(:) = 0
  t_spec(:,:) = 0.0
  t_good(:,:) = 0
  ithread = 1
  !
  !$OMP PARALLEL DEFAULT(none) SHARED(t_good,t_spec,poly,rmask,din,nt) &
  !$OMP  & SHARED(kmin,kmax,jmin,jmax,imin,imax) &
  !$OMP  & PRIVATE(i,j,x,y,ithread) &
  !$OMP  & SHARED(nm, hin, t_nk, mess,nc)
  !$  ithread = omp_get_thread_num()+1
  !$  if (ithread.eq.1) then
  !$    nt = omp_get_num_threads()
  !$    if (nt.gt.1) then
  !$      write(mess,'(A,I0,A)') 'Using ',nt,' threads'
  !$      call greg_message(seve%d,'T_SPECTRUM',mess)
  !$    endif
  !$  endif
  !
  ! Now explore a reasonable part of the map
  if (hin%gil%eval.lt.0.0) then ! No blanking value, using nans
     if (nm.le.1) then
        ! Global mask
        !$OMP DO COLLAPSE(2)
        do j=jmin,jmax
           do i=imin,imax
              x = (i-hin%gil%ref(1))*hin%gil%inc(1) + hin%gil%val(1)
              y = (j-hin%gil%ref(2))*hin%gil%inc(2) + hin%gil%val(2)
              if (greg_poly_inside(x,y,poly).and.rmask(i,j,1).gt.0.0) then
                 t_nk(ithread) = t_nk(ithread)+1
                 do k=1,nc
                    if (din(i,j,kmin+k-1).eq.din(i,j,kmin+k-1)) then  ! Not NaN
                       t_good(k,ithread) = t_good(k,ithread) + 1
                       t_spec(k,ithread) = t_spec(k,ithread) + din(i,j,kmin+k-1)
                    endif
                 enddo
              endif
           enddo
        enddo
        !$OMP END DO
     else
        ! Per plane mask
        !$OMP DO COLLAPSE(2)
        do j=jmin,jmax
           do i=imin,imax
              x = (i-hin%gil%ref(1))*hin%gil%inc(1) + hin%gil%val(1)
              y = (j-hin%gil%ref(2))*hin%gil%inc(2) + hin%gil%val(2)
              if (greg_poly_inside(x,y,poly)) then
                 t_nk(ithread) = t_nk(ithread)+1
                 do k=1,nc
                    if (din(i,j,kmin+k-1).eq.din(i,j,kmin+k-1) .and. &  ! Not NaN
                        rmask(i,j,kmin+k-1).gt.0.0) then
                       t_good(k,ithread) = t_good(k,ithread) + 1
                       t_spec(k,ithread) = t_spec(k,ithread) + din(i,j,kmin+k-1)
                    endif
                 enddo
              endif
           enddo
        enddo
        !$OMP END DO
     endif
  else
    if (nm.le.1) then
        ! Global mask
        !$OMP DO COLLAPSE(2)
        do j=jmin,jmax
           do i=imin,imax
              x = (i-hin%gil%ref(1))*hin%gil%inc(1) + hin%gil%val(1)
              y = (j-hin%gil%ref(2))*hin%gil%inc(2) + hin%gil%val(2)
              if (greg_poly_inside(x,y,poly).and.rmask(i,j,1).gt.0.0) then
                 t_nk(ithread) = t_nk(ithread)+1
                 do k=1,nc
                    if (abs(din(i,j,kmin+k-1)-hin%gil%bval).gt.hin%gil%eval) then
                       t_good(k,ithread) = t_good(k,ithread) + 1
                       t_spec(k,ithread) = t_spec(k,ithread) + din(i,j,kmin+k-1)
                    endif
                 enddo
              endif
           enddo
        enddo
        !$OMP END DO
     else
        ! Per plane mask
        !$OMP DO COLLAPSE(2)
        do j=jmin,jmax
           do i=imin,imax
              x = (i-hin%gil%ref(1))*hin%gil%inc(1) + hin%gil%val(1)
              y = (j-hin%gil%ref(2))*hin%gil%inc(2) + hin%gil%val(2)
              if (greg_poly_inside(x,y,poly)) then
                 t_nk(ithread) = t_nk(ithread)+1
                 do k=1,nc
                    if (abs(din(i,j,kmin+k-1)-hin%gil%bval).gt.hin%gil%eval.and.rmask(i,j,kmin+k-1).gt.0.0) then
                       t_good(k,ithread) = t_good(k,ithread) + 1
                       t_spec(k,ithread) = t_spec(k,ithread) + din(i,j,kmin+k-1)
                    endif
                 enddo
              endif
           enddo
        enddo
        !$OMP END DO
     endif
  endif
  !$OMP END PARALLEL
  !
  ! Post treatment
  ngood(:)  = 0
  ouspec(:) = 0.
  nk        = 0
  do i=1,nt
     nk = nk + t_nk(i)
     ouspec(:) = ouspec(:) + t_spec(:,i)
     ngood(:)  = ngood(:)  + t_good(:,i)
  enddo
  !
  if (.not.do_sum) then
     where (ngood.ne.0) ouspec = ouspec/ngood
  endif
  !
  if (do_sum) ouspec(:) = ouspec(:) * abs(hin%gil%inc(1) * hin%gil%inc(2))
  aire = nk * abs(hin%gil%inc(1) * hin%gil%inc(2))
  !
  spectrum(:) = real(ouspec(:),kind=4)
  !
end subroutine greg_drive_spectre

*DECK DH12
      SUBROUTINE DH12 (MODE, LPIVOT, L1, M, U, IUE, UP, C, ICE, ICV,
     +   NCV)
C***BEGIN PROLOGUE  DH12
C***SUBSIDIARY
C***PURPOSE  Subsidiary to DHFTI, DLSEI and DWNNLS
C***LIBRARY   SLATEC
C***TYPE      DOUBLE PRECISION (H12-S, DH12-D)
C***AUTHOR  (UNKNOWN)
C***DESCRIPTION
C
C      *** DOUBLE PRECISION VERSION OF H12 ******
C
C     C.L.Lawson and R.J.Hanson, Jet Propulsion Laboratory, 1973 Jun 12
C     to appear in 'Solving Least Squares Problems', Prentice-Hall, 1974
C
C     Construction and/or application of a single
C     Householder transformation..     Q = I + U*(U**T)/B
C
C     MODE    = 1 or 2   to select algorithm  H1  or  H2 .
C     LPIVOT is the index of the pivot element.
C     L1,M   If L1 .LE. M   the transformation will be constructed to
C            zero elements indexed from L1 through M.   If L1 GT. M
C            THE SUBROUTINE DOES AN IDENTITY TRANSFORMATION.
C     U(),IUE,UP    On entry to H1 U() contains the pivot vector.
C                   IUE is the storage increment between elements.
C                                       On exit from H1 U() and UP
C                   contain quantities defining the vector U of the
C                   Householder transformation.   On entry to H2 U()
C                   and UP should contain quantities previously computed
C                   by H1.  These will not be modified by H2.
C     C()    On entry to H1 or H2 C() contains a matrix which will be
C            regarded as a set of vectors to which the Householder
C            transformation is to be applied.  On exit C() contains the
C            set of transformed vectors.
C     ICE    Storage increment between elements of vectors in C().
C     ICV    Storage increment between vectors in C().
C     NCV    Number of vectors in C() to be transformed. If NCV .LE. 0
C            no operations will be done on C().
C
C***SEE ALSO  DHFTI, DLSEI, DWNNLS
C***ROUTINES CALLED  DAXPY, DDOT, DSWAP
C***REVISION HISTORY  (YYMMDD)
C   790101  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890831  Modified array declarations.  (WRB)
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900328  Added TYPE section.  (WRB)
C   900911  Added DDOT to DOUBLE PRECISION statement.  (WRB)
C***END PROLOGUE  DH12
      INTEGER I, I2, I3, I4, ICE, ICV, INCR, IUE, J, KL1, KL2, KLP,
     *     L1, L1M1, LPIVOT, M, MML1P2, MODE, NCV
      DOUBLE PRECISION B, C, CL, CLINV, ONE, UL1M1, SM, U, UP, DDOT
      DIMENSION U(IUE,*), C(*)
C     BEGIN BLOCK PERMITTING ...EXITS TO 140
C***FIRST EXECUTABLE STATEMENT  DH12
         ONE = 1.0D0
C
C     ...EXIT
         IF (0 .GE. LPIVOT .OR. LPIVOT .GE. L1 .OR. L1 .GT. M) GO TO 140
         CL = ABS(U(1,LPIVOT))
         IF (MODE .EQ. 2) GO TO 40
C           ****** CONSTRUCT THE TRANSFORMATION. ******
            DO 10 J = L1, M
               CL = MAX(ABS(U(1,J)),CL)
   10       CONTINUE
            IF (CL .GT. 0.0D0) GO TO 20
C     .........EXIT
               GO TO 140
   20       CONTINUE
            CLINV = ONE/CL
            SM = (U(1,LPIVOT)*CLINV)**2
            DO 30 J = L1, M
               SM = SM + (U(1,J)*CLINV)**2
   30       CONTINUE
            CL = CL*SQRT(SM)
            IF (U(1,LPIVOT) .GT. 0.0D0) CL = -CL
            UP = U(1,LPIVOT) - CL
            U(1,LPIVOT) = CL
         GO TO 50
   40    CONTINUE
C        ****** APPLY THE TRANSFORMATION  I+U*(U**T)/B  TO C. ******
C
         IF (CL .GT. 0.0D0) GO TO 50
C     ......EXIT
            GO TO 140
   50    CONTINUE
C     ...EXIT
         IF (NCV .LE. 0) GO TO 140
         B = UP*U(1,LPIVOT)
C        B  MUST BE NONPOSITIVE HERE.  IF B = 0., RETURN.
C
         IF (B .LT. 0.0D0) GO TO 60
C     ......EXIT
            GO TO 140
   60    CONTINUE
         B = ONE/B
         MML1P2 = M - L1 + 2
         IF (MML1P2 .LE. 20) GO TO 80
            L1M1 = L1 - 1
            KL1 = 1 + (L1M1 - 1)*ICE
            KL2 = KL1
            KLP = 1 + (LPIVOT - 1)*ICE
            UL1M1 = U(1,L1M1)
            U(1,L1M1) = UP
            IF (LPIVOT .NE. L1M1) CALL DSWAP(NCV,C(KL1),ICV,C(KLP),ICV)
            DO 70 J = 1, NCV
               SM = DDOT(MML1P2,U(1,L1M1),IUE,C(KL1),ICE)
               SM = SM*B
               CALL DAXPY(MML1P2,SM,U(1,L1M1),IUE,C(KL1),ICE)
               KL1 = KL1 + ICV
   70       CONTINUE
            U(1,L1M1) = UL1M1
C     ......EXIT
            IF (LPIVOT .EQ. L1M1) GO TO 140
            KL1 = KL2
            CALL DSWAP(NCV,C(KL1),ICV,C(KLP),ICV)
         GO TO 130
   80    CONTINUE
            I2 = 1 - ICV + ICE*(LPIVOT - 1)
            INCR = ICE*(L1 - LPIVOT)
            DO 120 J = 1, NCV
               I2 = I2 + ICV
               I3 = I2 + INCR
               I4 = I3
               SM = C(I2)*UP
               DO 90 I = L1, M
                  SM = SM + C(I3)*U(1,I)
                  I3 = I3 + ICE
   90          CONTINUE
               IF (SM .EQ. 0.0D0) GO TO 110
                  SM = SM*B
                  C(I2) = C(I2) + SM*UP
                  DO 100 I = L1, M
                     C(I4) = C(I4) + SM*U(1,I)
                     I4 = I4 + ICE
  100             CONTINUE
  110          CONTINUE
  120       CONTINUE
  130    CONTINUE
  140 CONTINUE
      RETURN
      END
*DECK DHELS
      SUBROUTINE DHELS (A, LDA, N, Q, B)
C***BEGIN PROLOGUE  DHELS
C***SUBSIDIARY
C***PURPOSE  Internal routine for DGMRES.
C***LIBRARY   SLATEC (SLAP)
C***CATEGORY  D2A4, D2B4
C***TYPE      DOUBLE PRECISION (SHELS-S, DHELS-D)
C***KEYWORDS  GENERALIZED MINIMUM RESIDUAL, ITERATIVE PRECONDITION,
C             NON-SYMMETRIC LINEAR SYSTEM, SLAP, SPARSE
C***AUTHOR  Brown, Peter, (LLNL), pnbrown@llnl.gov
C           Hindmarsh, Alan, (LLNL), alanh@llnl.gov
C           Seager, Mark K., (LLNL), seager@llnl.gov
C             Lawrence Livermore National Laboratory
C             PO Box 808, L-60
C             Livermore, CA 94550 (510) 423-3141
C***DESCRIPTION
C        This routine is extracted from the LINPACK routine SGESL with
C        changes due to the fact that A is an upper Hessenberg matrix.
C
C        DHELS solves the least squares problem:
C
C                   MIN(B-A*X,B-A*X)
C
C        using the factors computed by DHEQR.
C
C *Usage:
C      INTEGER LDA, N
C      DOUBLE PRECISION A(LDA,N), Q(2*N), B(N+1)
C
C      CALL DHELS(A, LDA, N, Q, B)
C
C *Arguments:
C A       :IN       Double Precision A(LDA,N)
C          The output from DHEQR which contains the upper
C          triangular factor R in the QR decomposition of A.
C LDA     :IN       Integer
C          The leading dimension of the array A.
C N       :IN       Integer
C          A is originally an (N+1) by N matrix.
C Q       :IN       Double Precision Q(2*N)
C          The coefficients of the N Givens rotations
C          used in the QR factorization of A.
C B       :INOUT    Double Precision B(N+1)
C          On input, B is the right hand side vector.
C          On output, B is the solution vector X.
C
C***SEE ALSO  DGMRES
C***ROUTINES CALLED  DAXPY
C***REVISION HISTORY  (YYMMDD)
C   890404  DATE WRITTEN
C   890404  Previous REVISION DATE
C   890915  Made changes requested at July 1989 CML Meeting.  (MKS)
C   890922  Numerous changes to prologue to make closer to SLATEC
C           standard.  (FNF)
C   890929  Numerous changes to reduce SP/DP differences.  (FNF)
C   910411  Prologue converted to Version 4.0 format.  (BAB)
C   910502  Added C***FIRST EXECUTABLE STATEMENT line.  (FNF)
C   910506  Made subsidiary to DGMRES.  (FNF)
C   920511  Added complete declaration section.  (WRB)
C***END PROLOGUE  DHELS
C         The following is for optimized compilation on LLNL/LTSS Crays.
CLLL. OPTIMIZE
C     .. Scalar Arguments ..
      INTEGER LDA, N
C     .. Array Arguments ..
      DOUBLE PRECISION A(LDA,*), B(*), Q(*)
C     .. Local Scalars ..
      DOUBLE PRECISION C, S, T, T1, T2
      INTEGER IQ, K, KB, KP1
C     .. External Subroutines ..
      EXTERNAL DAXPY
C***FIRST EXECUTABLE STATEMENT  DHELS
C
C         Minimize(B-A*X,B-A*X).  First form Q*B.
C
      DO 20 K = 1, N
         KP1 = K + 1
         IQ = 2*(K-1) + 1
         C = Q(IQ)
         S = Q(IQ+1)
         T1 = B(K)
         T2 = B(KP1)
         B(K) = C*T1 - S*T2
         B(KP1) = S*T1 + C*T2
 20   CONTINUE
C
C         Now solve  R*X = Q*B.
C
      DO 40 KB = 1, N
         K = N + 1 - KB
         B(K) = B(K)/A(K,K)
         T = -B(K)
         CALL DAXPY(K-1, T, A(1,K), 1, B(1), 1)
 40   CONTINUE
      RETURN
C------------- LAST LINE OF DHELS FOLLOWS ----------------------------
      END
*DECK DHEQR
      SUBROUTINE DHEQR (A, LDA, N, Q, INFO, IJOB)
C***BEGIN PROLOGUE  DHEQR
C***SUBSIDIARY
C***PURPOSE  Internal routine for DGMRES.
C***LIBRARY   SLATEC (SLAP)
C***CATEGORY  D2A4, D2B4
C***TYPE      DOUBLE PRECISION (SHEQR-S, DHEQR-D)
C***KEYWORDS  GENERALIZED MINIMUM RESIDUAL, ITERATIVE PRECONDITION,
C             NON-SYMMETRIC LINEAR SYSTEM, SLAP, SPARSE
C***AUTHOR  Brown, Peter, (LLNL), pnbrown@llnl.gov
C           Hindmarsh, Alan, (LLNL), alanh@llnl.gov
C           Seager, Mark K., (LLNL), seager@llnl.gov
C             Lawrence Livermore National Laboratory
C             PO Box 808, L-60
C             Livermore, CA 94550 (510) 423-3141
C***DESCRIPTION
C        This   routine  performs  a QR   decomposition  of an  upper
C        Hessenberg matrix A using Givens  rotations.  There  are two
C        options  available: 1)  Performing  a fresh decomposition 2)
C        updating the QR factors by adding a row and  a column to the
C        matrix A.
C
C *Usage:
C      INTEGER LDA, N, INFO, IJOB
C      DOUBLE PRECISION A(LDA,N), Q(2*N)
C
C      CALL DHEQR(A, LDA, N, Q, INFO, IJOB)
C
C *Arguments:
C A      :INOUT    Double Precision A(LDA,N)
C         On input, the matrix to be decomposed.
C         On output, the upper triangular matrix R.
C         The factorization can be written Q*A = R, where
C         Q is a product of Givens rotations and R is upper
C         triangular.
C LDA    :IN       Integer
C         The leading dimension of the array A.
C N      :IN       Integer
C         A is an (N+1) by N Hessenberg matrix.
C Q      :OUT      Double Precision Q(2*N)
C         The factors c and s of each Givens rotation used
C         in decomposing A.
C INFO   :OUT      Integer
C         = 0  normal value.
C         = K  if  A(K,K) .eq. 0.0 .  This is not an error
C           condition for this subroutine, but it does
C           indicate that DHELS will divide by zero
C           if called.
C IJOB   :IN       Integer
C         = 1     means that a fresh decomposition of the
C                 matrix A is desired.
C         .ge. 2  means that the current decomposition of A
C                 will be updated by the addition of a row
C                 and a column.
C
C***SEE ALSO  DGMRES
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   890404  DATE WRITTEN
C   890404  Previous REVISION DATE
C   890915  Made changes requested at July 1989 CML Meeting.  (MKS)
C   890922  Numerous changes to prologue to make closer to SLATEC
C           standard.  (FNF)
C   890929  Numerous changes to reduce SP/DP differences.  (FNF)
C   910411  Prologue converted to Version 4.0 format.  (BAB)
C   910506  Made subsidiary to DGMRES.  (FNF)
C   920511  Added complete declaration section.  (WRB)
C***END PROLOGUE  DHEQR
C         The following is for optimized compilation on LLNL/LTSS Crays.
CLLL. OPTIMIZE
C     .. Scalar Arguments ..
      INTEGER IJOB, INFO, LDA, N
C     .. Array Arguments ..
      DOUBLE PRECISION A(LDA,*), Q(*)
C     .. Local Scalars ..
      DOUBLE PRECISION C, S, T, T1, T2
      INTEGER I, IQ, J, K, KM1, KP1, NM1
C     .. Intrinsic Functions ..
      INTRINSIC ABS, SQRT
C***FIRST EXECUTABLE STATEMENT  DHEQR
      IF (IJOB .GT. 1) GO TO 70
C   -------------------------------------------------------------------
C         A new factorization is desired.
C   -------------------------------------------------------------------
C         QR decomposition without pivoting.
C
      INFO = 0
      DO 60 K = 1, N
         KM1 = K - 1
         KP1 = K + 1
C
C           Compute K-th column of R.
C           First, multiply the K-th column of A by the previous
C           K-1 Givens rotations.
C
         IF (KM1 .LT. 1) GO TO 20
         DO 10 J = 1, KM1
            I = 2*(J-1) + 1
            T1 = A(J,K)
            T2 = A(J+1,K)
            C = Q(I)
            S = Q(I+1)
            A(J,K) = C*T1 - S*T2
            A(J+1,K) = S*T1 + C*T2
 10      CONTINUE
C
C         Compute Givens components C and S.
C
 20      CONTINUE
         IQ = 2*KM1 + 1
         T1 = A(K,K)
         T2 = A(KP1,K)
         IF( T2.EQ.0.0D0 ) THEN
            C = 1
            S = 0
         ELSEIF( ABS(T2).GE.ABS(T1) ) THEN
            T = T1/T2
            S = -1.0D0/SQRT(1.0D0+T*T)
            C = -S*T
         ELSE
            T = T2/T1
            C = 1.0D0/SQRT(1.0D0+T*T)
            S = -C*T
         ENDIF
         Q(IQ) = C
         Q(IQ+1) = S
         A(K,K) = C*T1 - S*T2
         IF( A(K,K).EQ.0.0D0 ) INFO = K
 60   CONTINUE
      RETURN
C   -------------------------------------------------------------------
C         The old factorization of a will be updated.  A row and a
C         column has been added to the matrix A.  N by N-1 is now
C         the old size of the matrix.
C   -------------------------------------------------------------------
 70   CONTINUE
      NM1 = N - 1
C   -------------------------------------------------------------------
C         Multiply the new column by the N previous Givens rotations.
C   -------------------------------------------------------------------
      DO 100 K = 1,NM1
         I = 2*(K-1) + 1
         T1 = A(K,N)
         T2 = A(K+1,N)
         C = Q(I)
         S = Q(I+1)
         A(K,N) = C*T1 - S*T2
         A(K+1,N) = S*T1 + C*T2
 100  CONTINUE
C   -------------------------------------------------------------------
C         Complete update of decomposition by forming last Givens
C         rotation, and multiplying it times the column
C         vector(A(N,N),A(NP1,N)).
C   -------------------------------------------------------------------
      INFO = 0
      T1 = A(N,N)
      T2 = A(N+1,N)
      IF ( T2.EQ.0.0D0 ) THEN
         C = 1
         S = 0
      ELSEIF( ABS(T2).GE.ABS(T1) ) THEN
         T = T1/T2
         S = -1.0D0/SQRT(1.0D0+T*T)
         C = -S*T
      ELSE
         T = T2/T1
         C = 1.0D0/SQRT(1.0D0+T*T)
         S = -C*T
      ENDIF
      IQ = 2*N - 1
      Q(IQ) = C
      Q(IQ+1) = S
      A(N,N) = C*T1 - S*T2
      IF (A(N,N) .EQ. 0.0D0) INFO = N
      RETURN
C------------- LAST LINE OF DHEQR FOLLOWS ----------------------------
      END
*DECK DHFTI
      SUBROUTINE DHFTI (A, MDA, M, N, B, MDB, NB, TAU, KRANK, RNORM, H,
     +   G, IP)
C***BEGIN PROLOGUE  DHFTI
C***PURPOSE  Solve a least squares problem for banded matrices using
C            sequential accumulation of rows of the data matrix.
C            Exactly one right-hand side vector is permitted.
C***LIBRARY   SLATEC
C***CATEGORY  D9
C***TYPE      DOUBLE PRECISION (HFTI-S, DHFTI-D)
C***KEYWORDS  CURVE FITTING, LEAST SQUARES
C***AUTHOR  Lawson, C. L., (JPL)
C           Hanson, R. J., (SNLA)
C***DESCRIPTION
C
C     DIMENSION A(MDA,N),(B(MDB,NB) or B(M)),RNORM(NB),H(N),G(N),IP(N)
C
C     This subroutine solves a linear least squares problem or a set of
C     linear least squares problems having the same matrix but different
C     right-side vectors.  The problem data consists of an M by N matrix
C     A, an M by NB matrix B, and an absolute tolerance parameter TAU
C     whose usage is described below.  The NB column vectors of B
C     represent right-side vectors for NB distinct linear least squares
C     problems.
C
C     This set of problems can also be written as the matrix least
C     squares problem
C
C                       AX = B,
C
C     where X is the N by NB solution matrix.
C
C     Note that if B is the M by M identity matrix, then X will be the
C     pseudo-inverse of A.
C
C     This subroutine first transforms the augmented matrix (A B) to a
C     matrix (R C) using premultiplying Householder transformations with
C     column interchanges.  All subdiagonal elements in the matrix R are
C     zero and its diagonal elements satisfy
C
C                       ABS(R(I,I)).GE.ABS(R(I+1,I+1)),
C
C                       I = 1,...,L-1, where
C
C                       L = MIN(M,N).
C
C     The subroutine will compute an integer, KRANK, equal to the number
C     of diagonal terms of R that exceed TAU in magnitude. Then a
C     solution of minimum Euclidean length is computed using the first
C     KRANK rows of (R C).
C
C     To be specific we suggest that the user consider an easily
C     computable matrix norm, such as, the maximum of all column sums of
C     magnitudes.
C
C     Now if the relative uncertainty of B is EPS, (norm of uncertainty/
C     norm of B), it is suggested that TAU be set approximately equal to
C     EPS*(norm of A).
C
C     The user must dimension all arrays appearing in the call list..
C     A(MDA,N),(B(MDB,NB) or B(M)),RNORM(NB),H(N),G(N),IP(N).  This
C     permits the solution of a range of problems in the same array
C     space.
C
C     The entire set of parameters for DHFTI are
C
C     INPUT.. All TYPE REAL variables are DOUBLE PRECISION
C
C     A(*,*),MDA,M,N    The array A(*,*) initially contains the M by N
C                       matrix A of the least squares problem AX = B.
C                       The first dimensioning parameter of the array
C                       A(*,*) is MDA, which must satisfy MDA.GE.M
C                       Either M.GE.N or M.LT.N is permitted.  There
C                       is no restriction on the rank of A.  The
C                       condition MDA.LT.M is considered an error.
C
C     B(*),MDB,NB       If NB = 0 the subroutine will perform the
C                       orthogonal decomposition but will make no
C                       references to the array B(*).  If NB.GT.0
C                       the array B(*) must initially contain the M by
C                       NB matrix B of the least squares problem AX =
C                       B.  If NB.GE.2 the array B(*) must be doubly
C                       subscripted with first dimensioning parameter
C                       MDB.GE.MAX(M,N).  If NB = 1 the array B(*) may
C                       be either doubly or singly subscripted.  In
C                       the latter case the value of MDB is arbitrary
C                       but it should be set to some valid integer
C                       value such as MDB = M.
C
C                       The condition of NB.GT.1.AND.MDB.LT. MAX(M,N)
C                       is considered an error.
C
C     TAU               Absolute tolerance parameter provided by user
C                       for pseudorank determination.
C
C     H(*),G(*),IP(*)   Arrays of working space used by DHFTI.
C
C     OUTPUT.. All TYPE REAL variables are DOUBLE PRECISION
C
C     A(*,*)            The contents of the array A(*,*) will be
C                       modified by the subroutine. These contents
C                       are not generally required by the user.
C
C     B(*)              On return the array B(*) will contain the N by
C                       NB solution matrix X.
C
C     KRANK             Set by the subroutine to indicate the
C                       pseudorank of A.
C
C     RNORM(*)          On return, RNORM(J) will contain the Euclidean
C                       norm of the residual vector for the problem
C                       defined by the J-th column vector of the array
C                       B(*,*) for J = 1,...,NB.
C
C     H(*),G(*)         On return these arrays respectively contain
C                       elements of the pre- and post-multiplying
C                       Householder transformations used to compute
C                       the minimum Euclidean length solution.
C
C     IP(*)             Array in which the subroutine records indices
C                       describing the permutation of column vectors.
C                       The contents of arrays H(*),G(*) and IP(*)
C                       are not generally required by the user.
C
C***REFERENCES  C. L. Lawson and R. J. Hanson, Solving Least Squares
C                 Problems, Prentice-Hall, Inc., 1974, Chapter 14.
C***ROUTINES CALLED  D1MACH, DH12, XERMSG
C***REVISION HISTORY  (YYMMDD)
C   790101  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   891006  Cosmetic changes to prologue.  (WRB)
C   891006  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900315  CALLs to XERROR changed to CALLs to XERMSG.  (THJ)
C   901005  Replace usage of DDIFF with usage of D1MACH.  (RWC)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  DHFTI
      INTEGER I, II, IOPT, IP(*), IP1, J, JB, JJ, K, KP1, KRANK, L,
     *     LDIAG, LMAX, M, MDA, MDB, N, NB, NERR
      DOUBLE PRECISION A, B, D1MACH, DZERO, FACTOR,
     *     G, H, HMAX, RELEPS, RNORM, SM, SM1, SZERO, TAU, TMP
      DIMENSION A(MDA,*),B(MDB,*),H(*),G(*),RNORM(*)
      SAVE RELEPS
      DATA RELEPS /0.D0/
C     BEGIN BLOCK PERMITTING ...EXITS TO 360
C***FIRST EXECUTABLE STATEMENT  DHFTI
         IF (RELEPS.EQ.0.D0) RELEPS = D1MACH(4)
         SZERO = 0.0D0
         DZERO = 0.0D0
         FACTOR = 0.001D0
C
         K = 0
         LDIAG = MIN(M,N)
         IF (LDIAG .LE. 0) GO TO 350
C           BEGIN BLOCK PERMITTING ...EXITS TO 130
C              BEGIN BLOCK PERMITTING ...EXITS TO 120
                  IF (MDA .GE. M) GO TO 10
                     NERR = 1
                     IOPT = 2
                     CALL XERMSG ('SLATEC', 'DHFTI',
     +                  'MDA.LT.M, PROBABLE ERROR.',
     +                  NERR, IOPT)
C     ...............EXIT
                     GO TO 360
   10             CONTINUE
C
                  IF (NB .LE. 1 .OR. MAX(M,N) .LE. MDB) GO TO 20
                     NERR = 2
                     IOPT = 2
                     CALL XERMSG ('SLATEC', 'DHFTI',
     +                  'MDB.LT.MAX(M,N).AND.NB.GT.1. PROBABLE ERROR.',
     +                  NERR, IOPT)
C     ...............EXIT
                     GO TO 360
   20             CONTINUE
C
                  DO 100 J = 1, LDIAG
C                    BEGIN BLOCK PERMITTING ...EXITS TO 70
                        IF (J .EQ. 1) GO TO 40
C
C                           UPDATE SQUARED COLUMN LENGTHS AND FIND LMAX
C                          ..
                           LMAX = J
                           DO 30 L = J, N
                              H(L) = H(L) - A(J-1,L)**2
                              IF (H(L) .GT. H(LMAX)) LMAX = L
   30                      CONTINUE
C                    ......EXIT
                           IF (FACTOR*H(LMAX) .GT. HMAX*RELEPS) GO TO 70
   40                   CONTINUE
C
C                        COMPUTE SQUARED COLUMN LENGTHS AND FIND LMAX
C                       ..
                        LMAX = J
                        DO 60 L = J, N
                           H(L) = 0.0D0
                           DO 50 I = J, M
                              H(L) = H(L) + A(I,L)**2
   50                      CONTINUE
                           IF (H(L) .GT. H(LMAX)) LMAX = L
   60                   CONTINUE
                        HMAX = H(LMAX)
   70                CONTINUE
C                    ..
C                     LMAX HAS BEEN DETERMINED
C
C                     DO COLUMN INTERCHANGES IF NEEDED.
C                    ..
                     IP(J) = LMAX
                     IF (IP(J) .EQ. J) GO TO 90
                        DO 80 I = 1, M
                           TMP = A(I,J)
                           A(I,J) = A(I,LMAX)
                           A(I,LMAX) = TMP
   80                   CONTINUE
                        H(LMAX) = H(J)
   90                CONTINUE
C
C                     COMPUTE THE J-TH TRANSFORMATION AND APPLY IT TO A
C                     AND B.
C                    ..
                     CALL DH12(1,J,J+1,M,A(1,J),1,H(J),A(1,J+1),1,MDA,
     *                         N-J)
                     CALL DH12(2,J,J+1,M,A(1,J),1,H(J),B,1,MDB,NB)
  100             CONTINUE
C
C                  DETERMINE THE PSEUDORANK, K, USING THE TOLERANCE,
C                  TAU.
C                 ..
                  DO 110 J = 1, LDIAG
C              ......EXIT
                     IF (ABS(A(J,J)) .LE. TAU) GO TO 120
  110             CONTINUE
                  K = LDIAG
C           ......EXIT
                  GO TO 130
  120          CONTINUE
               K = J - 1
  130       CONTINUE
            KP1 = K + 1
C
C           COMPUTE THE NORMS OF THE RESIDUAL VECTORS.
C
            IF (NB .LT. 1) GO TO 170
            DO 160 JB = 1, NB
               TMP = SZERO
               IF (M .LT. KP1) GO TO 150
               DO 140 I = KP1, M
                  TMP = TMP + B(I,JB)**2
  140          CONTINUE
  150          CONTINUE
               RNORM(JB) = SQRT(TMP)
  160       CONTINUE
  170       CONTINUE
C           SPECIAL FOR PSEUDORANK = 0
            IF (K .GT. 0) GO TO 210
               IF (NB .LT. 1) GO TO 200
               DO 190 JB = 1, NB
                  DO 180 I = 1, N
                     B(I,JB) = SZERO
  180             CONTINUE
  190          CONTINUE
  200          CONTINUE
            GO TO 340
  210       CONTINUE
C
C               IF THE PSEUDORANK IS LESS THAN N COMPUTE HOUSEHOLDER
C               DECOMPOSITION OF FIRST K ROWS.
C              ..
               IF (K .EQ. N) GO TO 230
                  DO 220 II = 1, K
                     I = KP1 - II
                     CALL DH12(1,I,KP1,N,A(I,1),MDA,G(I),A,MDA,1,I-1)
  220             CONTINUE
  230          CONTINUE
C
C
               IF (NB .LT. 1) GO TO 330
               DO 320 JB = 1, NB
C
C                  SOLVE THE K BY K TRIANGULAR SYSTEM.
C                 ..
                  DO 260 L = 1, K
                     SM = DZERO
                     I = KP1 - L
                     IP1 = I + 1
                     IF (K .LT. IP1) GO TO 250
                     DO 240 J = IP1, K
                        SM = SM + A(I,J)*B(J,JB)
  240                CONTINUE
  250                CONTINUE
                     SM1 = SM
                     B(I,JB) = (B(I,JB) - SM1)/A(I,I)
  260             CONTINUE
C
C                  COMPLETE COMPUTATION OF SOLUTION VECTOR.
C                 ..
                  IF (K .EQ. N) GO TO 290
                     DO 270 J = KP1, N
                        B(J,JB) = SZERO
  270                CONTINUE
                     DO 280 I = 1, K
                        CALL DH12(2,I,KP1,N,A(I,1),MDA,G(I),B(1,JB),1,
     *                            MDB,1)
  280                CONTINUE
  290             CONTINUE
C
C                   RE-ORDER THE SOLUTION VECTOR TO COMPENSATE FOR THE
C                   COLUMN INTERCHANGES.
C                 ..
                  DO 310 JJ = 1, LDIAG
                     J = LDIAG + 1 - JJ
                     IF (IP(J) .EQ. J) GO TO 300
                        L = IP(J)
                        TMP = B(L,JB)
                        B(L,JB) = B(J,JB)
                        B(J,JB) = TMP
  300                CONTINUE
  310             CONTINUE
  320          CONTINUE
  330          CONTINUE
  340       CONTINUE
  350    CONTINUE
C        ..
C         THE SOLUTION VECTORS, X, ARE NOW
C         IN THE FIRST  N  ROWS OF THE ARRAY B(,).
C
         KRANK = K
  360 CONTINUE
      RETURN
      END
*DECK DHKSEQ
      SUBROUTINE DHKSEQ (X, M, H, IERR)
C***BEGIN PROLOGUE  DHKSEQ
C***SUBSIDIARY
C***PURPOSE  Subsidiary to DBSKIN
C***LIBRARY   SLATEC
C***TYPE      DOUBLE PRECISION (HKSEQ-S, DHKSEQ-D)
C***AUTHOR  Amos, D. E., (SNLA)
C***DESCRIPTION
C
C   DHKSEQ is an adaptation of subroutine DPSIFN described in the
C   reference below.  DHKSEQ generates the sequence
C   H(K,X) = (-X)**(K+1)*(PSI(K,X) PSI(K,X+0.5))/GAMMA(K+1), for
C            K=0,...,M.
C
C***SEE ALSO  DBSKIN
C***REFERENCES  D. E. Amos, A portable Fortran subroutine for
C                 derivatives of the Psi function, Algorithm 610, ACM
C                 Transactions on Mathematical Software 9, 4 (1983),
C                 pp. 494-502.
C***ROUTINES CALLED  D1MACH, I1MACH
C***REVISION HISTORY  (YYMMDD)
C   820601  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890911  Removed unnecessary intrinsics.  (WRB)
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900328  Added TYPE section.  (WRB)
C   910722  Updated AUTHOR section.  (ALS)
C   920528  DESCRIPTION and REFERENCES sections revised.  (WRB)
C***END PROLOGUE  DHKSEQ
      INTEGER I, IERR, J, K, M, MX, NX
      INTEGER I1MACH
      DOUBLE PRECISION B, FK, FLN, FN, FNP, H, HRX, RLN, RXSQ, R1M5, S,
     * SLOPE, T, TK, TRM, TRMH, TRMR, TST, U, V, WDTOL, X, XDMY, XH,
     * XINC, XM, XMIN, YINT
      DOUBLE PRECISION D1MACH
      DIMENSION B(22), TRM(22), TRMR(25), TRMH(25), U(25), V(25), H(*)
      SAVE B
C-----------------------------------------------------------------------
C             SCALED BERNOULLI NUMBERS 2.0*B(2K)*(1-2**(-2K))
C-----------------------------------------------------------------------
      DATA B(1), B(2), B(3), B(4), B(5), B(6), B(7), B(8), B(9), B(10),
     * B(11), B(12), B(13), B(14), B(15), B(16), B(17), B(18), B(19),
     * B(20), B(21), B(22) /1.00000000000000000D+00,
     * -5.00000000000000000D-01,2.50000000000000000D-01,
     * -6.25000000000000000D-02,4.68750000000000000D-02,
     * -6.64062500000000000D-02,1.51367187500000000D-01,
     * -5.06103515625000000D-01,2.33319091796875000D+00,
     * -1.41840972900390625D+01,1.09941936492919922D+02,
     * -1.05824747562408447D+03,1.23842434241771698D+04,
     * -1.73160495905935764D+05,2.85103429084961116D+06,
     * -5.45964619322445132D+07,1.20316174668075304D+09,
     * -3.02326315271452307D+10,8.59229286072319606D+11,
     * -2.74233104097776039D+13,9.76664637943633248D+14,
     * -3.85931586838450360D+16/
C
C***FIRST EXECUTABLE STATEMENT  DHKSEQ
      IERR=0
      WDTOL = MAX(D1MACH(4),1.0D-18)
      FN = M - 1
      FNP = FN + 1.0D0
C-----------------------------------------------------------------------
C     COMPUTE XMIN
C-----------------------------------------------------------------------
      R1M5 = D1MACH(5)
      RLN = R1M5*I1MACH(14)
      RLN = MIN(RLN,18.06D0)
      FLN = MAX(RLN,3.0D0) - 3.0D0
      YINT = 3.50D0 + 0.40D0*FLN
      SLOPE = 0.21D0 + FLN*(0.0006038D0*FLN+0.008677D0)
      XM = YINT + SLOPE*FN
      MX = INT(XM) + 1
      XMIN = MX
C-----------------------------------------------------------------------
C     GENERATE H(M-1,XDMY)*XDMY**(M) BY THE ASYMPTOTIC EXPANSION
C-----------------------------------------------------------------------
      XDMY = X
      XINC = 0.0D0
      IF (X.GE.XMIN) GO TO 10
      NX = INT(X)
      XINC = XMIN - NX
      XDMY = X + XINC
   10 CONTINUE
      RXSQ = 1.0D0/(XDMY*XDMY)
      HRX = 0.5D0/XDMY
      TST = 0.5D0*WDTOL
      T = FNP*HRX
C-----------------------------------------------------------------------
C     INITIALIZE COEFFICIENT ARRAY
C-----------------------------------------------------------------------
      S = T*B(3)
      IF (ABS(S).LT.TST) GO TO 30
      TK = 2.0D0
      DO 20 K=4,22
        T = T*((TK+FN+1.0D0)/(TK+1.0D0))*((TK+FN)/(TK+2.0D0))*RXSQ
        TRM(K) = T*B(K)
        IF (ABS(TRM(K)).LT.TST) GO TO 30
        S = S + TRM(K)
        TK = TK + 2.0D0
   20 CONTINUE
      GO TO 110
   30 CONTINUE
      H(M) = S + 0.5D0
      IF (M.EQ.1) GO TO 70
C-----------------------------------------------------------------------
C     GENERATE LOWER DERIVATIVES, I.LT.M-1
C-----------------------------------------------------------------------
      DO 60 I=2,M
        FNP = FN
        FN = FN - 1.0D0
        S = FNP*HRX*B(3)
        IF (ABS(S).LT.TST) GO TO 50
        FK = FNP + 3.0D0
        DO 40 K=4,22
          TRM(K) = TRM(K)*FNP/FK
          IF (ABS(TRM(K)).LT.TST) GO TO 50
          S = S + TRM(K)
          FK = FK + 2.0D0
   40   CONTINUE
        GO TO 110
   50   CONTINUE
        MX = M - I + 1
        H(MX) = S + 0.5D0
   60 CONTINUE
   70 CONTINUE
      IF (XINC.EQ.0.0D0) RETURN
C-----------------------------------------------------------------------
C     RECUR BACKWARD FROM XDMY TO X
C-----------------------------------------------------------------------
      XH = X + 0.5D0
      S = 0.0D0
      NX = INT(XINC)
      DO 80 I=1,NX
        TRMR(I) = X/(X+NX-I)
        U(I) = TRMR(I)
        TRMH(I) = X/(XH+NX-I)
        V(I) = TRMH(I)
        S = S + U(I) - V(I)
   80 CONTINUE
      MX = NX + 1
      TRMR(MX) = X/XDMY
      U(MX) = TRMR(MX)
      H(1) = H(1)*TRMR(MX) + S
      IF (M.EQ.1) RETURN
      DO 100 J=2,M
        S = 0.0D0
        DO 90 I=1,NX
          TRMR(I) = TRMR(I)*U(I)
          TRMH(I) = TRMH(I)*V(I)
          S = S + TRMR(I) - TRMH(I)
   90   CONTINUE
        TRMR(MX) = TRMR(MX)*U(MX)
        H(J) = H(J)*TRMR(MX) + S
  100 CONTINUE
      RETURN
  110 CONTINUE
      IERR=2
      RETURN
      END
*DECK DHSTRT
      SUBROUTINE DHSTRT (DF, NEQ, A, B, Y, YPRIME, ETOL, MORDER, SMALL,
     +   BIG, SPY, PV, YP, SF, RPAR, IPAR, H)
C***BEGIN PROLOGUE  DHSTRT
C***SUBSIDIARY
C***PURPOSE  Subsidiary to DDEABM, DDEBDF and DDERKF
C***LIBRARY   SLATEC
C***TYPE      DOUBLE PRECISION (HSTART-S, DHSTRT-D)
C***AUTHOR  Watts, H. A., (SNLA)
C***DESCRIPTION
C
C   DHSTRT computes a starting step size to be used in solving initial
C   value problems in ordinary differential equations.
C
C **********************************************************************
C  ABSTRACT
C
C     Subroutine DHSTRT computes a starting step size to be used by an
C     initial value method in solving ordinary differential equations.
C     It is based on an estimate of the local Lipschitz constant for the
C     differential equation   (lower bound on a norm of the Jacobian) ,
C     a bound on the differential equation  (first derivative) , and
C     a bound on the partial derivative of the equation with respect to
C     the independent variable.
C     (all approximated near the initial point A)
C
C     Subroutine DHSTRT uses a function subprogram DHVNRM for computing
C     a vector norm. The maximum norm is presently utilized though it
C     can easily be replaced by any other vector norm. It is presumed
C     that any replacement norm routine would be carefully coded to
C     prevent unnecessary underflows or overflows from occurring, and
C     also, would not alter the vector or number of components.
C
C **********************************************************************
C  On input you must provide the following
C
C      DF -- This is a subroutine of the form
C                               DF(X,U,UPRIME,RPAR,IPAR)
C             which defines the system of first order differential
C             equations to be solved. For the given values of X and the
C             vector  U(*)=(U(1),U(2),...,U(NEQ)) , the subroutine must
C             evaluate the NEQ components of the system of differential
C             equations  DU/DX=DF(X,U)  and store the derivatives in the
C             array UPRIME(*), that is,  UPRIME(I) = * DU(I)/DX *  for
C             equations I=1,...,NEQ.
C
C             Subroutine DF must not alter X or U(*). You must declare
C             the name DF in an external statement in your program that
C             calls DHSTRT. You must dimension U and UPRIME in DF.
C
C             RPAR and IPAR are DOUBLE PRECISION and INTEGER parameter
C             arrays which you can use for communication between your
C             program and subroutine DF. They are not used or altered by
C             DHSTRT. If you do not need RPAR or IPAR, ignore these
C             parameters by treating them as dummy arguments. If you do
C             choose to use them, dimension them in your program and in
C             DF as arrays of appropriate length.
C
C      NEQ -- This is the number of (first order) differential equations
C             to be integrated.
C
C      A -- This is the initial point of integration.
C
C      B -- This is a value of the independent variable used to define
C             the direction of integration. A reasonable choice is to
C             set  B  to the first point at which a solution is desired.
C             You can also use  B, if necessary, to restrict the length
C             of the first integration step because the algorithm will
C             not compute a starting step length which is bigger than
C             ABS(B-A), unless  B  has been chosen too close to  A.
C             (it is presumed that DHSTRT has been called with  B
C             different from  A  on the machine being used. Also see the
C             discussion about the parameter  SMALL.)
C
C      Y(*) -- This is the vector of initial values of the NEQ solution
C             components at the initial point  A.
C
C      YPRIME(*) -- This is the vector of derivatives of the NEQ
C             solution components at the initial point  A.
C             (defined by the differential equations in subroutine DF)
C
C      ETOL -- This is the vector of error tolerances corresponding to
C             the NEQ solution components. It is assumed that all
C             elements are positive. Following the first integration
C             step, the tolerances are expected to be used by the
C             integrator in an error test which roughly requires that
C                        ABS(LOCAL ERROR)  .LE.  ETOL
C             for each vector component.
C
C      MORDER -- This is the order of the formula which will be used by
C             the initial value method for taking the first integration
C             step.
C
C      SMALL -- This is a small positive machine dependent constant
C             which is used for protecting against computations with
C             numbers which are too small relative to the precision of
C             floating point arithmetic.  SMALL  should be set to
C             (approximately) the smallest positive DOUBLE PRECISION
C             number such that  (1.+SMALL) .GT. 1.  on the machine being
C             used. The quantity  SMALL**(3/8)  is used in computing
C             increments of variables for approximating derivatives by
C             differences.  Also the algorithm will not compute a
C             starting step length which is smaller than
C             100*SMALL*ABS(A).
C
C      BIG -- This is a large positive machine dependent constant which
C             is used for preventing machine overflows. A reasonable
C             choice is to set big to (approximately) the square root of
C             the largest DOUBLE PRECISION number which can be held in
C             the machine.
C
C      SPY(*),PV(*),YP(*),SF(*) -- These are DOUBLE PRECISION work
C             arrays of length NEQ which provide the routine with needed
C             storage space.
C
C      RPAR,IPAR -- These are parameter arrays, of DOUBLE PRECISION and
C             INTEGER type, respectively, which can be used for
C             communication between your program and the DF subroutine.
C             They are not used or altered by DHSTRT.
C
C **********************************************************************
C  On Output  (after the return from DHSTRT),
C
C      H -- is an appropriate starting step size to be attempted by the
C             differential equation method.
C
C           All parameters in the call list remain unchanged except for
C           the working arrays SPY(*),PV(*),YP(*), and SF(*).
C
C **********************************************************************
C
C***SEE ALSO  DDEABM, DDEBDF, DDERKF
C***ROUTINES CALLED  DHVNRM
C***REVISION HISTORY  (YYMMDD)
C   820301  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890831  Modified array declarations.  (WRB)
C   890911  Removed unnecessary intrinsics.  (WRB)
C   891024  Changed references from DVNORM to DHVNRM.  (WRB)
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900328  Added TYPE section.  (WRB)
C   910722  Updated AUTHOR section.  (ALS)
C***END PROLOGUE  DHSTRT
C
      INTEGER IPAR, J, K, LK, MORDER, NEQ
      DOUBLE PRECISION A, ABSDX, B, BIG, DA, DELF, DELY,
     1      DFDUB, DFDXB, DHVNRM,
     2      DX, DY, ETOL, FBND, H, PV, RELPER, RPAR, SF, SMALL, SPY,
     3      SRYDPB, TOLEXP, TOLMIN, TOLP, TOLSUM, Y, YDPB, YP, YPRIME
      DIMENSION Y(*),YPRIME(*),ETOL(*),SPY(*),PV(*),YP(*),
     1          SF(*),RPAR(*),IPAR(*)
      EXTERNAL DF
C
C     ..................................................................
C
C     BEGIN BLOCK PERMITTING ...EXITS TO 160
C***FIRST EXECUTABLE STATEMENT  DHSTRT
         DX = B - A
         ABSDX = ABS(DX)
         RELPER = SMALL**0.375D0
C
C        ...............................................................
C
C             COMPUTE AN APPROXIMATE BOUND (DFDXB) ON THE PARTIAL
C             DERIVATIVE OF THE EQUATION WITH RESPECT TO THE
C             INDEPENDENT VARIABLE. PROTECT AGAINST AN OVERFLOW.
C             ALSO COMPUTE A BOUND (FBND) ON THE FIRST DERIVATIVE
C             LOCALLY.
C
         DA = SIGN(MAX(MIN(RELPER*ABS(A),ABSDX),
     1                    100.0D0*SMALL*ABS(A)),DX)
         IF (DA .EQ. 0.0D0) DA = RELPER*DX
         CALL DF(A+DA,Y,SF,RPAR,IPAR)
         DO 10 J = 1, NEQ
            YP(J) = SF(J) - YPRIME(J)
   10    CONTINUE
         DELF = DHVNRM(YP,NEQ)
         DFDXB = BIG
         IF (DELF .LT. BIG*ABS(DA)) DFDXB = DELF/ABS(DA)
         FBND = DHVNRM(SF,NEQ)
C
C        ...............................................................
C
C             COMPUTE AN ESTIMATE (DFDUB) OF THE LOCAL LIPSCHITZ
C             CONSTANT FOR THE SYSTEM OF DIFFERENTIAL EQUATIONS. THIS
C             ALSO REPRESENTS AN ESTIMATE OF THE NORM OF THE JACOBIAN
C             LOCALLY.  THREE ITERATIONS (TWO WHEN NEQ=1) ARE USED TO
C             ESTIMATE THE LIPSCHITZ CONSTANT BY NUMERICAL DIFFERENCES.
C             THE FIRST PERTURBATION VECTOR IS BASED ON THE INITIAL
C             DERIVATIVES AND DIRECTION OF INTEGRATION. THE SECOND
C             PERTURBATION VECTOR IS FORMED USING ANOTHER EVALUATION OF
C             THE DIFFERENTIAL EQUATION.  THE THIRD PERTURBATION VECTOR
C             IS FORMED USING PERTURBATIONS BASED ONLY ON THE INITIAL
C             VALUES. COMPONENTS THAT ARE ZERO ARE ALWAYS CHANGED TO
C             NON-ZERO VALUES (EXCEPT ON THE FIRST ITERATION). WHEN
C             INFORMATION IS AVAILABLE, CARE IS TAKEN TO ENSURE THAT
C             COMPONENTS OF THE PERTURBATION VECTOR HAVE SIGNS WHICH ARE
C             CONSISTENT WITH THE SLOPES OF LOCAL SOLUTION CURVES.
C             ALSO CHOOSE THE LARGEST BOUND (FBND) FOR THE FIRST
C             DERIVATIVE.
C
C                               PERTURBATION VECTOR SIZE IS HELD
C                               CONSTANT FOR ALL ITERATIONS. COMPUTE
C                               THIS CHANGE FROM THE
C                                       SIZE OF THE VECTOR OF INITIAL
C                                       VALUES.
         DELY = RELPER*DHVNRM(Y,NEQ)
         IF (DELY .EQ. 0.0D0) DELY = RELPER
         DELY = SIGN(DELY,DX)
         DELF = DHVNRM(YPRIME,NEQ)
         FBND = MAX(FBND,DELF)
         IF (DELF .EQ. 0.0D0) GO TO 30
C           USE INITIAL DERIVATIVES FOR FIRST PERTURBATION
            DO 20 J = 1, NEQ
               SPY(J) = YPRIME(J)
               YP(J) = YPRIME(J)
   20       CONTINUE
         GO TO 50
   30    CONTINUE
C           CANNOT HAVE A NULL PERTURBATION VECTOR
            DO 40 J = 1, NEQ
               SPY(J) = 0.0D0
               YP(J) = 1.0D0
   40       CONTINUE
            DELF = DHVNRM(YP,NEQ)
   50    CONTINUE
C
         DFDUB = 0.0D0
         LK = MIN(NEQ+1,3)
         DO 140 K = 1, LK
C           DEFINE PERTURBED VECTOR OF INITIAL VALUES
            DO 60 J = 1, NEQ
               PV(J) = Y(J) + DELY*(YP(J)/DELF)
   60       CONTINUE
            IF (K .EQ. 2) GO TO 80
C              EVALUATE DERIVATIVES ASSOCIATED WITH PERTURBED
C              VECTOR  AND  COMPUTE CORRESPONDING DIFFERENCES
               CALL DF(A,PV,YP,RPAR,IPAR)
               DO 70 J = 1, NEQ
                  PV(J) = YP(J) - YPRIME(J)
   70          CONTINUE
            GO TO 100
   80       CONTINUE
C              USE A SHIFTED VALUE OF THE INDEPENDENT VARIABLE
C                                    IN COMPUTING ONE ESTIMATE
               CALL DF(A+DA,PV,YP,RPAR,IPAR)
               DO 90 J = 1, NEQ
                  PV(J) = YP(J) - SF(J)
   90          CONTINUE
  100       CONTINUE
C           CHOOSE LARGEST BOUNDS ON THE FIRST DERIVATIVE
C                          AND A LOCAL LIPSCHITZ CONSTANT
            FBND = MAX(FBND,DHVNRM(YP,NEQ))
            DELF = DHVNRM(PV,NEQ)
C        ...EXIT
            IF (DELF .GE. BIG*ABS(DELY)) GO TO 150
            DFDUB = MAX(DFDUB,DELF/ABS(DELY))
C     ......EXIT
            IF (K .EQ. LK) GO TO 160
C           CHOOSE NEXT PERTURBATION VECTOR
            IF (DELF .EQ. 0.0D0) DELF = 1.0D0
            DO 130 J = 1, NEQ
               IF (K .EQ. 2) GO TO 110
                  DY = ABS(PV(J))
                  IF (DY .EQ. 0.0D0) DY = DELF
               GO TO 120
  110          CONTINUE
                  DY = Y(J)
                  IF (DY .EQ. 0.0D0) DY = DELY/RELPER
  120          CONTINUE
               IF (SPY(J) .EQ. 0.0D0) SPY(J) = YP(J)
               IF (SPY(J) .NE. 0.0D0) DY = SIGN(DY,SPY(J))
               YP(J) = DY
  130       CONTINUE
            DELF = DHVNRM(YP,NEQ)
  140    CONTINUE
  150    CONTINUE
C
C        PROTECT AGAINST AN OVERFLOW
         DFDUB = BIG
  160 CONTINUE
C
C     ..................................................................
C
C          COMPUTE A BOUND (YDPB) ON THE NORM OF THE SECOND DERIVATIVE
C
      YDPB = DFDXB + DFDUB*FBND
C
C     ..................................................................
C
C          DEFINE THE TOLERANCE PARAMETER UPON WHICH THE STARTING STEP
C          SIZE IS TO BE BASED.  A VALUE IN THE MIDDLE OF THE ERROR
C          TOLERANCE RANGE IS SELECTED.
C
      TOLMIN = BIG
      TOLSUM = 0.0D0
      DO 170 K = 1, NEQ
         TOLEXP = LOG10(ETOL(K))
         TOLMIN = MIN(TOLMIN,TOLEXP)
         TOLSUM = TOLSUM + TOLEXP
  170 CONTINUE
      TOLP = 10.0D0**(0.5D0*(TOLSUM/NEQ + TOLMIN)/(MORDER+1))
C
C     ..................................................................
C
C          COMPUTE A STARTING STEP SIZE BASED ON THE ABOVE FIRST AND
C          SECOND DERIVATIVE INFORMATION
C
C                            RESTRICT THE STEP LENGTH TO BE NOT BIGGER
C                            THAN ABS(B-A).   (UNLESS  B  IS TOO CLOSE
C                            TO  A)
      H = ABSDX
C
      IF (YDPB .NE. 0.0D0 .OR. FBND .NE. 0.0D0) GO TO 180
C
C        BOTH FIRST DERIVATIVE TERM (FBND) AND SECOND
C                     DERIVATIVE TERM (YDPB) ARE ZERO
         IF (TOLP .LT. 1.0D0) H = ABSDX*TOLP
      GO TO 200
  180 CONTINUE
C
      IF (YDPB .NE. 0.0D0) GO TO 190
C
C        ONLY SECOND DERIVATIVE TERM (YDPB) IS ZERO
         IF (TOLP .LT. FBND*ABSDX) H = TOLP/FBND
      GO TO 200
  190 CONTINUE
C
C        SECOND DERIVATIVE TERM (YDPB) IS NON-ZERO
         SRYDPB = SQRT(0.5D0*YDPB)
         IF (TOLP .LT. SRYDPB*ABSDX) H = TOLP/SRYDPB
  200 CONTINUE
C
C     FURTHER RESTRICT THE STEP LENGTH TO BE NOT
C                               BIGGER THAN  1/DFDUB
      IF (H*DFDUB .GT. 1.0D0) H = 1.0D0/DFDUB
C
C     FINALLY, RESTRICT THE STEP LENGTH TO BE NOT
C     SMALLER THAN  100*SMALL*ABS(A).  HOWEVER, IF
C     A=0. AND THE COMPUTED H UNDERFLOWED TO ZERO,
C     THE ALGORITHM RETURNS  SMALL*ABS(B)  FOR THE
C                                     STEP LENGTH.
      H = MAX(H,100.0D0*SMALL*ABS(A))
      IF (H .EQ. 0.0D0) H = SMALL*ABS(B)
C
C     NOW SET DIRECTION OF INTEGRATION
      H = SIGN(H,DX)
C
      RETURN
      END
*DECK DHVNRM
      DOUBLE PRECISION FUNCTION DHVNRM (V, NCOMP)
C***BEGIN PROLOGUE  DHVNRM
C***SUBSIDIARY
C***PURPOSE  Subsidiary to DDEABM, DDEBDF and DDERKF
C***LIBRARY   SLATEC
C***TYPE      DOUBLE PRECISION (HVNRM-S, DHVNRM-D)
C***AUTHOR  Watts, H. A., (SNLA)
C***DESCRIPTION
C
C     Compute the maximum norm of the vector V(*) of length NCOMP and
C     return the result as DHVNRM
C
C***SEE ALSO  DDEABM, DDEBDF, DDERKF
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   820301  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890831  Modified array declarations.  (WRB)
C   891024  Changed references from DVNORM to DHVNRM.  (WRB)
C   891024  Changed routine name from DVNORM to DHVNRM.  (WRB)
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900328  Added TYPE section.  (WRB)
C   910722  Updated AUTHOR section.  (ALS)
C***END PROLOGUE  DHVNRM
C
      INTEGER K, NCOMP
      DOUBLE PRECISION V
      DIMENSION V(*)
C***FIRST EXECUTABLE STATEMENT  DHVNRM
      DHVNRM = 0.0D0
      DO 10 K = 1, NCOMP
         DHVNRM = MAX(DHVNRM,ABS(V(K)))
   10 CONTINUE
      RETURN
      END

subroutine rmask_to_list(rmask,m,list,n)
  !---------------------------------------------------------------------
  ! @ public
  !*
  !   IMAGER -- public routine  
  !   Get list of positions from a Real mask (1-D index)
  !!
  !---------------------------------------------------------------------
  integer, intent(in) :: m           !! Number of entries
  real, intent(in) :: rmask(m)       !! Mask values
  integer, intent(out) :: n          !! Number of POSITIVE values
  integer, intent(out) :: list(m)    !! Position of entries 
  !
  ! Local --- 
  integer i,j
  !
  ! Code ----
  j = 0
  do i=1,m
    if (rmask(i).gt.0) then
      j = j+1
      list(j) = i
    endif
  enddo
  n = j
  do i=n+1,m
    list(i) = 0
  enddo
end subroutine rmask_to_list
!
subroutine lmask_to_list(lmask,m,list,n)
  !---------------------------------------------------------------------
  ! @ public
  !*
  !   IMAGER -- public routine  
  !   Get list of positions from a Logical mask (1-D index)
  !!
  !---------------------------------------------------------------------
  integer, intent(in) :: m           !! Size of mask 
  logical, intent(in) :: lmask(m)    !! Mask values
  integer, intent(out) :: n          !! Number of TRUE values
  integer, intent(out) :: list(m)    !! Position of entries 
  ! 
  ! Local ---
  integer i,j
  !
  ! Code ----
  j = 0
  do i=1,m
    if (lmask(i)) then
      j = j+1
      list(j) = i
    endif
  enddo
  n = j
  do i=n+1,m
    list(i) = 0
  enddo
end subroutine lmask_to_list
!
subroutine get_listsize (mask,m,n)
  !---------------------------------------------------------------------
  ! @ public
  !!* 
  !   IMAGER public routine  
  !   Count number of TRUE values (Rank 1 arrays)
  !!
  !---------------------------------------------------------------------
  integer, intent(in) :: m        !! Number of entries
  integer, intent(out) :: n       !! Number of TRUE values
  logical, intent(in) :: mask(m)  !! Mask values
  !
  integer i
  !
  n = 0
  do i=1,m
    if (mask(i)) n = n+1
  enddo
end subroutine get_listsize
!
subroutine compute_atten (nx,ny,np,atten,primary,mask,   &
     &    wsear,wrest,wmin)
  !---------------------------------------------------------------------
  ! @ public
  !* 
  !   IMAGER -- Support for MOSAICs  
  !   Set the mosaic weights 
  !!
  !---------------------------------------------------------------------
  integer, intent(in) :: nx                 !! X size
  integer, intent(in) :: ny                 !! Y size 
  integer, intent(in) :: np                 !! Number of pointings
  real, intent(out) ::  atten(nx,ny)        !! Weight map
  real, intent(in) ::  primary(np,nx,ny)    !! Primary beams
  real, intent(in) ::  wsear                !! Search threshold
  real, intent(in) ::  wrest                !! Restore threshold   
  real, intent(in) ::  wmin                 !! Minimum real value  
  logical, intent(inout) ::  mask(nx,ny)    !! Search mask
  !
  ! Local ---
  real :: wr,ws2,wr2
  integer :: i,j,ip
  !
  ! Code ----
  wr2 = wrest*wrest  ! It is a square quantity 
  ws2 = wsear*wsear  ! Also 
  !
  ! Compute the "atten" function 1/N
  do j=1,ny
    do i=1,nx
      wr = 0.0
      do ip=1,np
        if (primary(ip,i,j).gt.wmin) then
          wr = wr+primary(ip,i,j)*primary(ip,i,j)
        endif
      enddo
      ! Cut the search mask
      if (wr.le.ws2) mask(i,j) = .false.
      ! Cut the restore area if it is not a search area also
      if (wr.le.wr2 .and. .not.mask(i,j)) wr = 0.0
      ! Convert to the 1/N function
      if (wr.ne.0.0) then
        atten(i,j) = 1.0/sqrt(wr)
      else
        atten(i,j) = 0.0
      endif
    enddo
  enddo
end subroutine compute_atten
!
subroutine cmplx_mul (out,in,n)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ no-interface
  !* 
  !   IMAGER -- support routine  
  !   Complex multiplication, using pseudo-complexes     OUT = OUT*IN
  !!
  !---------------------------------------------------------------------
  integer(kind=size_length), intent(in) :: n       !! Size of arrays
  real, intent(inout) :: out(2,n)                  !! Result array
  real, intent(in) :: in(2,n)                      !! Second input array
  !
  ! Local ---
  integer(kind=size_length) :: i
  real :: ar,ai
  !
  ! Code ----
  do i=1,n
    ar = in(1,i)*out(1,i)-in(2,i)*out(2,i)
    ai = in(1,i)*out(2,i)+in(2,i)*out(1,i)
    out(1,i) = ar
    out(2,i) = ai
  enddo
end subroutine cmplx_mul
!
subroutine check_box(nx,ny,blc,trc)
  !---------------------------------------------------------------------
  ! @ public
  !* 
  !   IMAGER -- support routine  
  !   Define the search box corners. 
  !   The default is the inner quarter of the image
  !!
  !---------------------------------------------------------------------
  integer, intent(in) :: nx,ny           !! Size of image
  integer, intent(inout) :: blc(2)       !! Bottom left corner
  integer, intent(inout) :: trc(2)       !! Top right corner
  !
  ! Check inner quarter if not specified
  if (blc(1).eq.0) then
    blc(1) = nx/4+1
  else
    blc(1) = max(blc(1),1)
  endif
  if (blc(2).eq.0) then
    blc(2) = ny/4+1
  else
    blc(2) = max(blc(2),1)
  endif
  if (trc(1).eq.0) then
    trc(1) = 3*nx/4
  else
    trc(1) = min(trc(1),nx)
  endif
  if (trc(2).eq.0) then
    trc(2) = 3*ny/4
  else
    trc(2) = min(trc(2),ny)
  endif
end subroutine check_box

!>
! This file is a collection of PUBLIC entries of IMAGER 
! which must not refer to any SIC-GREG-GTV routines
!!
subroutine telescope_beam(rname,bsize,head)
  use gkernel_interfaces
  use imager_interfaces, only: map_message
  use image_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ public
  !
  !! IMAGER --  Get telescope beamsize for the frequency of a GILDAS data set
  !---------------------------------------------------------------------  
  character(len=*), intent(in) :: rname !! Caller name
  real, intent(inout) :: bsize(:)       !! Primary beam size
  type(gildas), intent(in) :: head      !! Gildas header
  !
  ! Constants
  integer, parameter :: mteles=7
  real(8), parameter :: clight=299792458d0
  real(8), parameter :: pi=3.14159265358979323846d0
  character(len=12) :: vteles(mteles)
  data vteles /'ACA','ALMA','ATCA','NOEMA','SMA','JVLA','VELETA'/
  real :: factors(mteles), diams(mteles)
  data diams  /7.,12.,20.,15.,6.,25.,30.0/
  ! These factors depend on dish illumination 
  !   Validated for NOEMA and VELETA
  !   Validated for ALMA
  ! unclear for ATCA, SMA and JVLA
  data factors /1.13,1.13,1.13,1.22,1.13,1.13,1.20/
  !
  ! 
  character(len=12) :: cteles,kteles
  character(len=120) :: chain
  integer :: iteles, it
  logical :: error
  real :: diamet, factor, beamsize
  !
  beamsize = 0.0
  !
  if (head%gil%nteles.ne.0) then
    do it=1,head%gil%nteles
      !
      cteles = head%gil%teles(it)%ctele
      if (cteles.eq.'30M') cteles = 'VELETA'
      diamet = head%gil%teles(it)%diam
      kteles = cteles
      call sic_ambigs(' ',cteles,kteles,iteles,vteles,mteles,error)
      call map_message(seve%i,rname,'Found telescope '//trim(kteles)//' from data')
      if (error) then
        factor = 1.13
        call map_message(seve%w,rname,'Using default Beam size 1.13 Lambda/D')
        error = .false.
      else
        factor = factors(iteles)
      endif
      beamsize = factor*(clight/head%gil%freq/1d6)/diamet
      bsize(it) = beamsize
    enddo
  endif
  !
  if (head%gil%nteles.le.1) then
    if (abs(head%gil%type_gdf).eq.abs(code_gdf_uvt)) then
      ! This is to handle old UVT files in which the primary beam size was
      ! given in the "Beam" parameters
      if (head%gil%majo.ne.0) then    
        if (head%gil%mino.eq.0 .or. head%gil%mino.eq.head%gil%majo) then
          bsize(1) = head%gil%majo
          if (beamsize.ne.0) then
            if (abs(beamsize-bsize(1)).gt.0.02*beamsize) then
              write(chain,'(A,F8.1,A,F8.1,A)') 'Using major axis ', &
              &	bsize(1)*180*3600/pi, &
              &   '" instead of Beam size ',beamsize*180*3600/pi,'"'
              call map_message(seve%w,rname,chain)
            endif
          endif
        else if (beamsize.eq.0) then
            write(chain,'(A,F8.1,A,F8.1,A)') & 
            & 'Inconsistent primary beam major axis (', & 
            & head%gil%majo*180*3600/pi,'") and minor axis ', &
            & head%gil%mino*180*3600/pi,'")'
            call map_message(seve%w,rname,chain)
        endif
      endif
    endif
  endif
  !
end subroutine telescope_beam
!
subroutine no_major_plot (method,head   &
     &    ,conv,niter,nx,ny,np,tcc  &
     &    ,clean,resid,poids)
  use clean_def
  use image_def
  !---------------------------------------------------------------------
  ! @ public
  !!
  ! IMAGER  -- Support for CLEAN
  !
  !   Dummy replacement of "major_plot". 
  !   Do not Plot result of Major Cycle
  !!
  !---------------------------------------------------------------------
  type (clean_par), intent(inout) :: method
  type (gildas), intent(in) :: head
  !
  logical, intent(in) ::  conv          !! Convergence status
  integer, intent(in) ::  niter         !! Number of iterations
  integer, intent(in) ::  nx            !! X size
  integer, intent(in) ::  ny            !! Y size
  integer, intent(in) ::  np            !! Number of planes
  real, intent(in) :: clean(nx,ny)      !! Clean image
  real, intent(in) :: resid(nx,ny)      !! Residuals
  real, intent(in) :: poids(nx,ny)      !! Weight image
  type (cct_par), intent(in) :: tcc(niter)
  !
  return
end subroutine no_major_plot
!
subroutine no_next_flux(niter,cum,is)
  !---------------------------------------------------------------------
  ! @ public
  !*
  ! IMAGER -- Support for Clean 
  !
  !   Dummy replacement of "next_flux". 
  !   Do not draw in the <FLUX window
  !!
  !---------------------------------------------------------------------
  integer, intent(in) :: niter
  real, intent(in) :: cum
  integer :: is
end subroutine no_next_flux
!
!
subroutine no_remask(method,head,nl,error)
  use clean_def
  use image_def
  !---------------------------------------------------------------------
  ! @ public
  !
  ! IMAGER -- Support for Clean 
  !
  ! Dummy replacement of "remask"
  !!
  !---------------------------------------------------------------------
  type (clean_par), intent(in) :: method
  type (gildas), intent(in) :: head
  integer, intent(in) :: nl
  logical, intent(in) :: error
  !
end subroutine no_remask
!
!
subroutine get_maskplane(amethod,hmask,hdirty,mask,list)
  use clean_def
  use image_def
  use gbl_message
  use clean_support
  use gkernel_interfaces
  use imager_interfaces, except_this => get_maskplane 
  !---------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- Support for CLEAN
  !
  !   Get mask plane method%imask corresponding to current channel, as 
  !   defined in method%iplane
  !!
  !---------------------------------------------------------------------
  type (clean_par), intent(inout) :: amethod     !! Clean method parameters
  type (gildas), intent(in) :: hmask             !! Mask Header
  type (gildas), intent(in) :: hdirty            !! Used to figure out which plane
  logical, intent(inout) :: mask(:,:)            !! Current logical mask
  integer, intent(inout) :: list(:)              !! Selected list of pixels
  !
  ! Local ---
  integer :: iplane, nxy
  real(8) :: i_freq
  !
  ! Code ----
  if (support_type.ne.support_mask) return
  !
  if (hmask%gil%dim(3).le.1) then
    !!Print *,'Only one mask Plane '
    amethod%imask = 1
    return ! 
  else 
    i_freq = (amethod%iplane-hdirty%gil%ref(3))*hdirty%gil%fres + hdirty%gil%freq
    iplane = nint((i_freq-hmask%gil%freq)/hmask%gil%fres + hmask%gil%ref(3))
    iplane = min(max(1,iplane),hmask%gil%dim(3)) ! Just  in case
    !!Print *,'IPLANE ',iplane,' IMASK ',method%imask
    !
    ! Should also work in OMP mode...
    if (amethod%imask.ne.iplane) then
      !
      ! Optimize: only re-define if needed...
      nxy = hdirty%gil%dim(1)*hdirty%gil%dim(2)
      call get_lmask (hmask,hmask%r3d(:,:,iplane:iplane),hdirty,mask,amethod%box)
      call lmask_to_list(mask,nxy,list,amethod%nlist)
      amethod%imask = iplane
    endif
  endif
end subroutine get_maskplane
!
subroutine get_rlist (rmsk,nx,ny,box,list,nl)
  !---------------------------------------------------------------------
  ! @ public
  !*
  ! IMAGER -- Utility routine
  !
  !     Return a List of selected pixels from a (0 - non zero) real mask, 
  ! and also computes its boundaries
  !!
  !---------------------------------------------------------------------
  integer, intent(in) :: nx                       !! X size
  integer, intent(in) :: ny                       !! Y size
  real(kind=4), intent(in) :: rmsk(nx,ny)         !! Real mask
  integer, intent(out) :: box(4)                  !! Mask Boundary
  integer, intent(out) :: list(nx*ny)             !! List of pixels in mask
  integer, intent(out) :: nl          !! Number of selected pixels in list
  !
  ! Local ---
  integer :: i,j,k,l
  !
  ! Code ----
  box(1) = nx
  box(2) = ny
  box(3) = 1
  box(4) = 1
  !
  l = 0
  k = 0
  do j=1,ny
    do i=1,nx
      k = k+1
      if (rmsk(i,j).ne.0) then
        box(1) = min(i,box(1))
        box(2) = min(j,box(2))
        box(3) = max(i,box(3))
        box(4) = max(j,box(4))
        l = l+1
        list(l) = k
      endif
    enddo
  enddo
  nl = l
end subroutine get_rlist
!
subroutine gr4_slmsk (rmsk,lmsk,nx,ny,box)
  !---------------------------------------------------------------------
  ! @ public
  !*
  ! IMAGER -- Utility routine
  !
  !     Return a LOGICAL mask from the a (0 - non zero) mask, and also
  !       computes its boundaries
  !!
  !---------------------------------------------------------------------
  integer, intent(in) :: nx                  !! X size
  integer, intent(in) :: ny                  !! Y size
  real(kind=4), intent(in) :: rmsk(nx,ny)    !! Real mask
  logical, intent(out) :: lmsk(nx,ny)        !! Logical mask
  integer, intent(out) :: box(4)             !! Mask boundary (xblc,yblc,xtrc,ytrc)
  !
  ! Local ---
  integer :: i,j
  !
  ! Code ----
  box(1) = nx
  box(2) = ny
  box(3) = 1
  box(4) = 1
  !
  do j=1,ny
    do i=1,nx
      if (rmsk(i,j).ne.0) then
        lmsk(i,j) = .true.
        box(1) = min(i,box(1))
        box(2) = min(j,box(2))
        box(3) = max(i,box(3))
        box(4) = max(j,box(4))
      else
        lmsk(i,j) = .false.
      endif
    enddo
  enddo
end subroutine gr4_slmsk
!
subroutine get_lmask(hmask,rmask,hmap,lmask,box)
  use image_def
  !---------------------------------------------------------------------
  ! @ public
  !*
  ! IMAGER -- Support routine for Mask operations
  !
  !     Return a LOGICAL mask from the a (0 - non zero) possibly 3-D mask, 
  !   and also computes its boundaries.
  !     The initial mask (=0 or #0) does not need to match the data: pixel
  !   correspondances is derived from relative coordinates (not absolute).
  !   The LOGICAL mask matches the data pixel per pixel, and is a 2-D mask
  !   resulting from collapsing of the initial 3-D mask 
  !---------------------------------------------------------------------
  type(gildas), intent(in) :: hmask          !! Mask header
  type(gildas), intent(in) :: hmap           !! Map header  
  real(kind=4), intent(in) :: rmask(:,:,:)   !! Real mask
  logical, intent(out) :: lmask(:,:)         !! Logical mask
  integer, intent(out) :: box(4)             !! Mask boundary (xblc,yblc,xtrc,ytrc)
  !
  ! Local ---
  integer :: nx,ny,nz                      ! X,Y,Z size of mask
  integer :: i,j,k,ier
  integer, allocatable :: im(:),jm(:)      ! Pixels in mask matching image pixels
  real(kind=8) :: r
  !
  ! Code ----
  ! We may simplify the call sequence by using size(rmask,A) where A=1,2,3
  nx = hmap%gil%dim(1)
  ny = hmap%gil%dim(2)
  nz = ubound(rmask,3)
  !
  allocate(im(nx),jm(ny),stat=ier)
  !
  do i=1,nx
    r = (i-hmap%gil%ref(1))*hmap%gil%inc(1) + hmap%gil%val(1)
    im(i) = (r-hmask%gil%val(1))/hmask%gil%inc(1) + hmask%gil%ref(1)
    im(i) = max(1,im(i))
    im(i) = min(hmask%gil%dim(1),im(i))
  enddo
  !
  do i=1,ny
    r = (i-hmap%gil%ref(2))*hmap%gil%inc(2) + hmap%gil%val(2)
    jm(i) = (r-hmask%gil%val(2))/hmask%gil%inc(2) + hmask%gil%ref(2)
    jm(i) = max(1,jm(i))
    jm(i) = min(hmask%gil%dim(2),jm(i))
  enddo
  !
  box(1) = nx
  box(2) = ny
  box(3) = 1
  box(4) = 1
  !
  lmask = .false.
  do j=1,ny
    do i=1,nx
      do k=1,nz
        if (rmask(im(i),jm(j),k).ne.0) then
          lmask(i,j) = .true.
          box(1) = min(i,box(1))
          box(2) = min(j,box(2))
          box(3) = max(i,box(3))
          box(4) = max(j,box(4))
        endif
      enddo
    enddo
  enddo
  deallocate(im,jm)
end subroutine get_lmask

!
subroutine uvsort_uv (np,nv,ntrail,vin,vout,xy,cs,uvmax,uvmin,error)
  use gildas_def
  use gkernel_interfaces
  use imager_interfaces, except_this=> uvsort_uv
  !---------------------------------------------------------------------
  ! @ public
  !*
  ! IMAGER -- UV handling routine
  !
  !     Rotate, Shift and Sort a UV table for map making
  !     Differential precession should have been applied before.
  !     Single Field case
  !!
  !---------------------------------------------------------------------
  integer, intent(in) :: np        !! Size of a visibility
  integer, intent(in) :: nv        !! Number of visibilities
  integer, intent(in) :: ntrail    !! Number of trailing daps
  real, intent(in) :: vin(np,nv)   !! Input visibilities
  real, intent(out) :: vout(np,nv) !! Output visibilities
  real, intent(in) :: xy(2)        !! Phase shift
  real, intent(in) :: cs(2)        !! Frame Rotation
  real, intent(out) :: uvmax       !! Max UV value
  real, intent(out) :: uvmin       !! Min UV value
  logical, intent(out) :: error    !! Error flag
  !
  ! Local ---
  logical, allocatable :: ips(:)       ! Sign of visibility
  real, allocatable :: ipu(:), ipv(:)  ! U,V coordinates
  integer, allocatable :: ipi(:)       ! Index
  logical :: sorted
  integer :: ier
  !
  ! Code ----
  ! Load U,V coordinates, applying possible rotation (CS), and
  ! making all V negative
  allocate (ips(nv),ipu(nv),ipv(nv),ipi(nv),stat=ier)
  error = ier.ne.0
  if (error) return
  call loaduv (vin,np,nv,cs,ipu,ipv,ips,uvmax,uvmin)
  !
  ! Sort if needed
  call chksuv (nv,ipv,ipi,sorted)
  if (.not.sorted) then
    call gr4_trie (ipv,ipi,nv,error)
    if (error) return
  endif
  !
  ! Apply phase shift and copy to output visibilities
  call sub_sortuv (vin,vout,np,nv,ntrail,xy,1,0,ipu,ipv,ips,ipi)
  Print *,'Done SUB_SORTUV '
  !
  deallocate (ips,ipu,ipv,ipi,stat=ier)
end subroutine uvsort_uv
!
subroutine loaduv (visi,np,nv,cs,u,v,s,uvmax,uvmin)
  !---------------------------------------------------------------------
  ! @ public
  !*
  ! IMAGER  --   UV_SORT routines
  !
  !     Load new U,V coordinates and sign indicator into work arrays
  !     for sorting.
  !!
  !---------------------------------------------------------------------
  integer, intent(in) :: np       !! Size of a visibility
  integer, intent(in) :: nv       !! Number of visibilities
  real, intent(in) :: visi(np,nv) !! Input visibilities
  real, intent(in) :: cs(2)       !! Rotation parameter
  real, intent(out) :: u(nv)      !! Output U and V coordinates
  real, intent(out) :: v(nv)      !! Output U and V coordinates
  logical, intent(out) :: s(nv)   !! V Sign indicator
  real, intent(inout) :: uvmax    !! Maximum length
  real, intent(inout) :: uvmin    !! Minimum baseline
  !
  ! Local
  integer :: iv
  real(4) :: uv
  !
  uv = 0
  do iv=1,nv
    uv = visi(1,iv)**2 + visi(2,iv)**2
    if (uv.ne.0) exit
  enddo
  uvmax = uv
  uvmin = uv
  !
  if (cs(2).eq.0.0) then
    do iv=1,nv
      v(iv) = visi(2,iv)
      if (v(iv).gt.0) then
        u(iv) = -visi(1,iv)
        v(iv) = -v(iv)
        s(iv) = .false.
      else
        u(iv) = visi(1,iv)
        s(iv) = .true.
      endif
      uv = u(iv)*u(iv)+v(iv)*v(iv)
      if (uv.gt.uvmax) then
        uvmax = uv
      else if (uv.lt.uvmin .and. uv.ne.0) then
        uvmin = uv
      endif
    enddo
  else
    do iv=1,nv
      u(iv) = cs(1)*visi(1,iv) - cs(2)*visi(2,iv)
      v(iv) = cs(2)*visi(1,iv) + cs(1)*visi(2,iv)
      if (v(iv).gt.0) then
        u(iv) = -u(iv)
        v(iv) = -v(iv)
        s(iv) = .false.
      else
        s(iv) = .true.
      endif
      uv = u(iv)*u(iv)+v(iv)*v(iv)
      if (uv.gt.uvmax) then
        uvmax = uv
      else if (uv.lt.uvmin .and. uv.ne.0) then
        uvmin = uv
      endif
    enddo
  endif
  uvmax = sqrt(uvmax)
  uvmin = sqrt(uvmin)
end subroutine loaduv
!
subroutine chksuv (nv,v,it,sorted)
  !---------------------------------------------------------------------
  ! @ public
  !*
  ! IMAGER -- UV_SORT routines
  !
  !   Check if visibilities are sorted
  !!
  !---------------------------------------------------------------------
  integer, intent(in) :: nv      !! Number of visibilities
  real, intent(in) :: v(nv)      !! Visibilities
  integer, intent(out) :: it(nv) !! Sorting pointer
  logical, intent(out) :: sorted !! short cut
  !
  ! Local
  integer :: iv
  real(4) :: vmax
  !
  do iv=1,nv
    it(iv) = iv
  enddo
  !
  vmax = v(1)
  do iv = 1,nv
    if (v(iv).gt.0 .or. v(iv).lt.vmax) then
      sorted = .false.
      return
    endif
    vmax = v(iv)
  enddo
  sorted = .true.
end subroutine chksuv
!
subroutine sub_sortuv (vin,vout,np,nv,ntrail,xy,nf,id,u,v,s,it)
  use gbl_message
  use imager_interfaces, only : map_message
  !---------------------------------------------------------------------
  ! @ public
  !*
  ! IMAGER  --  UV_SORT routines
  !
  !     Sort an input UV table into an output one.
  !     The output UV table is a rotated, phase shifted copy of
  !     the input one, with all V negative and increasing
  !!
  !---------------------------------------------------------------------
  integer, intent(in) :: np         !! Size of a visibility
  integer, intent(in) :: nv         !! Number of visibilities
  integer, intent(in) :: ntrail     !! Number of trailing daps
  real, intent(in) :: vin(np,nv)    !! Input visibilities
  real, intent(out) :: vout(np,nv)  !! Output visibilities
  integer, intent(in) :: nf         !! Number of fields
  integer, intent(in) :: id         !! Fields ID column
  real, intent(in) :: xy(2,nf)      !! Phase shifting factors
  real, intent(in) :: u(nv)         !! New U coordinates
  real, intent(in) :: v(nv)         !! New V coordinates
  logical, intent(in) :: s(nv)      !! Sign of new visibility
  integer, intent(in) :: it(nv)     !! Pointer to old visibility
  !
  ! Local ---
  integer :: ip,iv,kv,no,idi,ifi
  real(4) :: phi, cphi, sphi
  character(len=80) :: mess
  !
  ! Code ----
  logical :: debug, error
  !
  ! There may be trailing columns in UV table
  debug = .false.
  call sic_get_logi('DEBUG',debug,error)
  !
  no = np-ntrail
  !
  if (nf.gt.1) then
    if ((id.ne.0).and.((id.le.no).or.(id.gt.np))) then
      write(mess,'(A,I0,A,I0)') 'Temporary Case (ultimately a Programming error) Fields ',nf,' ID col ',id
      call map_message(seve%w,'SUB_SORTUV',mess,seve%e)
      idi = 0
    else
      write(mess,'(A,I0,A,I0)') 'Temporary Case: Per Field shift on ',nf,' fields, ID col ',id
      call map_message(seve%w,'SUB_SORTUV',mess)
      idi = id
    endif
  else
    idi = 0   ! Ignore the ID column in this case
  endif
  !
  ! Simple case: no phase shift -- simple sort
  if (all(xy.eq.0)) then
    if (debug) Print *,'No SHIFT case '
    !$OMP PARALLEL DEFAULt(none) &
    !$OMP & SHARED(u,v,vin,vout,s,it,no,np,nv, debug) &
    !$OMP & PRIVATE(kv,iv,ip)
    !$OMP DO
    do iv=1,nv
      kv = it(iv)
      if (debug) then
        if (iv.lt.10) then
          Print *,'IV ',iv,' / ',nv
          Print *,' V ',v(iv),' KV ',it(iv)
          Print *,' U ',u(kv),' S ',s(kv)
        endif
      endif
      vout(1,iv) = u(kv)
      vout(2,iv) = v(iv)       ! This one is sorted already
      vout(3,iv) = vin(3,kv)
      vout(4,iv) = vin(4,kv)
      vout(5,iv) = vin(5,kv)
      if (s(kv)) then
        vout(6,iv) = vin(6,kv)
        vout(7,iv) = vin(7,kv)
        do ip=8,no
          vout(ip,iv) = vin(ip,kv)
        enddo
      else
        vout(6,iv) = vin(7,kv)
        vout(7,iv) = vin(6,kv)
        do ip=8,no,3
          vout(ip,iv)   =  vin(ip,kv)
          vout(ip+1,iv) = -vin(ip+1,kv)
          vout(ip+2,iv) =  vin(ip+2,kv)
        enddo
      endif
      do ip=no+1,np
        vout(ip,iv)   =  vin(ip,kv)
      enddo
    enddo
    !$OMP END DO
    !$OMP END PARALLEL
  else
    if (debug) Print *,'SHIFTing case '
    !
    ! Complex case: phase center has been shifted
    !$OMP PARALLEL DEFAULT(none) &
    !$OMP & SHARED(u,v,vin,vout,s,it,no,np,nv,xy,idi,nf, debug) &
    !$OMP & PRIVATE(kv,iv,ip, phi,cphi,sphi,ifi)
    !$OMP DO
    do iv=1,nv
      kv = it(iv)
      if (debug) then
        if (iv.lt.10) then
          Print *,'IV ',iv,' / ',nv
          Print *,' V ',v(iv),' KV ',it(iv)
          Print *,' U ',u(kv),' S ',s(kv)
        endif
      endif
      vout(1,iv) = u(kv)
      vout(2,iv) = v(iv)       ! This one is sorted already
      vout(3,iv) = vin(3,kv)
      vout(4,iv) = vin(4,kv)
      vout(5,iv) = vin(5,kv)
      !
      if (idi.eq.0) then
        ifi = 1
      else
        ifi = vin(idi,kv)
        if (ifi.gt.nf) then
          Print *,'F-UVSORT,  Programming error more Fields ',ifi,' at Visi ',kv,' than declared ',nf
          stop
        endif
      endif
      phi = xy(1,ifi)*u(kv)+xy(2,ifi)*v(iv)
      cphi = cos(phi)
      sphi = sin(phi)
      if (s(kv)) then
        vout(6,iv) = vin(6,kv)
        vout(7,iv) = vin(7,kv)
        do ip=8,no,3
          vout(ip,iv) = vin(ip,kv)*cphi - vin(ip+1,kv)*sphi
          vout(ip+1,iv) = vin(ip,kv)*sphi + vin(ip+1,kv)*cphi
          vout(ip+2,iv) = vin(ip+2,kv)
        enddo
      else
        vout(6,iv) = vin(7,kv)
        vout(7,iv) = vin(6,kv)
        do ip=8,no,3
          vout(ip,iv) = vin(ip,kv)*cphi + vin(ip+1,kv)*sphi
          vout(ip+1,iv) = vin(ip,kv)*sphi - vin(ip+1,kv)*cphi
          vout(ip+2,iv) = vin(ip+2,kv)
        enddo
      endif
      do ip=no+1,np
        vout(ip,iv)   =  vin(ip,kv)
      enddo
    enddo
    !$OMP END DO
    !$OMP END PARALLEL
    Print *,'Done loop '
  endif
end subroutine sub_sortuv

subroutine init_display 
  !! Initialize the DISPLAY language from VIEWER
  call load_display
  call setup_display
  call gprompt_set('VIEWER')
end subroutine init_display
!
subroutine setup_display
  use gkernel_interfaces
  use clean_def
  use clean_arrays
  use clean_default
  use clean_types
  !----------------------------------------------------------------------
  ! @ public
  !*
  ! IMAGER -- Initialize the DISPLAY\ language associated variables
  !!
  !----------------------------------------------------------------------
  !
  logical :: error
  !
  error = .false.
  ImagerError = .false.
  call sic_def_logi('MAPPING_ERROR',ImagerError,.false.,error)
  !
  call sic_def_char('GTV%ROOT',gtv_root,.false.,error)
  !
  ! Re-define the DO_LOOP variable for VIEW
  call sic_delvariable('DO_LOOP',.false.,error)
  call sic_def_logi('DO_LOOP',view_do_loop,.false.,error)
  view_do_loop = .true.
  !
  call sic_delvariable('SHOW_SIDE',.false.,error)
  call sic_def_logi('SHOW_SIDE',show_side,.false.,error)
  show_side = .false.
  !
  ! Angular Unit of Angle-like axes
  call sic_def_inte('ANGLE_UNIT',iangle_unit,0,0,.false.,error)
  call sic_delvariable('SIZE',.false.,error)
  call sic_delvariable('CENTER',.false.,error)
  call sic_def_dble('SIZE',area_size,1,2,.false.,error)
  call sic_def_dble('CENTER',area_center,1,2,.false.,error)
  !
  ! Last type of active Image (CLEAN or SKY)
  call sic_def_char('LAST_SHOWN',last_shown,.false.,error)
end subroutine setup_display
!
subroutine run_self (line,comm,error)
  use clean_arrays
  use clean_default
  use gbl_message
  use imager_interfaces, except_this=>run_self
  use gkernel_interfaces, only : sic_present, sic_mapgildas, sic_delvariable, sic_lire
  !----------------------------------------------------------------------
  ! @ public
  !*
  ! IMAGER  -- Dispatching routine for Language CALIBRATE\
  !!
  !----------------------------------------------------------------------
  character(len=*), intent(inout) :: line    !! Command line
  character(len=*), intent(in)    :: comm    !! Command name
  logical,          intent(out)   :: error   !! Logical error flag
  !
  ! Local ---
  integer, save :: icall=0
  integer :: i
  logical :: quiet, tmod
  real(8) :: elapsed
  !
  ! Code ----
  if (icall.ne.0) then
    Print *,'Rentrant call to RUN_SELF ',comm
    read(5,*) i
  endif
  icall = icall+1
  !
  call report_init(elapsed)
  call quiet_message(line,quiet)
  !
  ImagerError = .false.
  call map_message(seve%c,'CALIBRATE',line)
  !
  select case (comm)
  case ('UV_SELF')
    call uv_map_comm(line,comm,error)
  case ('APPLY')
    call apply_comm(line,error)
  case ('MODEL') 
    tmod = .false.
    call sic_get_logi('TEST_MODEL',tmod,error)
    if (tmod) then
      Print *,'Calling uv_model_comm_bis '
      call uv_model_comm_bis(line,error)
    else
      call uv_model_comm(line,error)
    endif
  case ('SOLVE') 
    call solve_comm(line,error)
  case ('COLLECT')
    call collect_comm(line,comm,error)
  case ('DERIVE')
    call derive_comm(line,comm,error)
  case ('SCALE_FLUX')
    call flux_dispatch (line,error)
  case ('UV_SELECT')
    call uv_select_comm(line,comm,error)
  case ('UV_SORT')
    if (sic_present(1,0)) then
      call uv_sort_file(line,error)
    else
      call uv_sort_comm(line,error)
    endif
  case ('FIND')
    call catalog_find(line,error)
    quiet = .true.
  case ('TRANSFORM')
    call transform_comm(line,error)
  case ('PLAIT')
    call map_message(seve%w,'CALIBRATE',comm//' is experimental')
    call plait_comm(line,comm,error)
  case ('AMPLITUDE')
    call amplitude_comm(line,error)
  case default
    call map_message(seve%e,'CALIBRATE','No code for '//comm)
    error = .true.
  end select
  icall = icall-1  
  if (ImagerError) error = .true.
  !
  call end_message(comm,elapsed,quiet,error)
  !
end subroutine run_self
!
subroutine run_clean (line,comm,error)
  use clean_arrays
  use clean_default
  use gbl_message
  use imager_interfaces, except_this=>run_clean
  use gkernel_types
  use gkernel_interfaces, only : sic_present, sic_mapgildas, sic_delvariable
  !----------------------------------------------------------------------
  ! @ public
  !*
  ! IMAGER   -- Dispatching routine for Language CLEAN\
  !!
  !----------------------------------------------------------------------
  character(len=*), intent(inout) :: line    !! Command line
  character(len=*), intent(in)    :: comm    !! Command name
  logical,          intent(out)   :: error   !! Logical error flag
  !
  ! Local ---
  integer, save :: icall=0
  type(sic_descriptor_t) :: desc   ! Descriptor
  integer :: i
  logical :: err, found, quiet
  real(8) :: elapsed
  !
  ! Code ---
  if (icall.ne.0) then
     Print *,'Rentrant call to RUN_CLEAN ',comm
     read(5,*) i
  endif
  icall = icall+1
  !
  call report_init(elapsed)
  call quiet_message(line,quiet)
  !
  ImagerError = .false.
  call map_message(seve%c,'CLEAN',line)
  !
  ! Analyze command
  ! First cases do not require to update variables
  select case (comm)
  case ('FIT')
    call fit_comm(line,error)
    quiet = .true.
  case ('DISCARD')
    call discard_comm(line,comm,error)
    quiet = .true.
  case ('COLOR')
    call color_comm(line,error)
    quiet = .true.
  case ('WRITE')
    call write_comm(line,error)
  case ('SUPPORT')
    call support_comm(line,error)
    quiet = .true.
  case ('UV_STAT')
    call uv_stat_comm(line,error)
  case ('DUMP')
    call debug_all(line,error)
    quiet = .true.
  case ('LOG')
    call log_stack_comm(line,error)
    quiet = .true.
  case ('BUFFERS')
    call buffers_comm(line,error)
    quiet = .true.
  case ('MOSAIC')
    call mosaic_comm (line,error)
    quiet = .true.
  case ('CCT_MERGE')
    call cct_merge_comm(line,error)
  !
  ! Other cases should update their own variables
  case default
    select case (comm)
    case ('READ')
      call read_comm(line,error)
    case ('CLEAN')
      call clean_comm(line,error)
    case ('MX')
      if (themap%nfields.ne.0) then
        call map_message(seve%e,comm,'UV data is a Mosaic, not supported')
        error = .true.
      else 
        call map_message(seve%w,comm,'MX is deprecated, use at your own risk',seve%e)
        call mx_uvmap_clean('MX',line,error)
      endif
!OBSOLETE!    case ('ALMA')
!OBSOLETE!      call alma_clean(line,error)
    case ('UV_CHOP') 
      call uv_chop_comm(line,comm,error)
    case ('UV_FLAG')
      call uv_flag_comm(line,error)
    case ('UV_MAP')
      call uv_map_comm(line,comm,error)
    case ('UV_RESAMPLE','UV_COMPRESS','UV_HANNING','UV_SMOOTH')
      call uv_resample_comm(line,comm,error)
    case ('UV_RESTORE')
      call uv_map_comm(line,comm,error)
    case ('UV_SHIFT')
      call uv_shift_comm(line,comm,error)
    case ('UV_CONTINUUM')
      call uv_line2cont (line,error)
    case ('UV_FILTER')
      call uv_filter_comm (line,error)
    case ('UV_BASELINE')
      call uv_baseline_comm (line,error)
    case ('UV_TIME')
      if (themap%nfields.ne.0) call map_message(seve%w,comm,'UV data is a Mosaic')
      call uv_time_comm (line,error)
    case ('UV_TRUNCATE')
      call uv_truncate_comm (line,error)
    case ('UV_TRIM')
      call uv_trim_comm (line,error)
    case ('UV_REWEIGHT')
      call uv_reweight_comm (line,comm,error)
    case ('UV_CHECK')
      call uv_check_comm (line,error)
    case ('UV_FIELDS')
      call uv_fields_comm (line,comm,error)
    case ('UV_SUBTRACT') 
      call uv_subtract_comm (line,comm,error)
    case ('PRIMARY')
      call primary_comm (line,error)
    case ('SPECIFY')
      call specify_comm (line,error)
      quiet = .true.
    case ('UV_RESIDUAL')
      call uv_residual_comm(line,error)
    case ('MAP_RESAMPLE','MAP_COMPRESS','MAP_INTEGRATE','MAP_SMOOTH') 
      call map_resample_comm(line,comm,error)
    case ('MAP_COMBINE')
      call map_combine_comm(line,error)
    case ('MAP_REPROJECT')
      call map_reproject_comm(line,error)
    case ('UV_SPLIT')
      call uv_split_comm(line,error)
    case ('UV_EXTRACT')
      call uv_extract_comm(line,error)
    case ('CCT_CONVERT')
      call cct_convert_comm(line,error)
    case ('CCT_CLEAN')
      call cct_clean_comm(line,error)
    case ('MAP_CONVOLVE')
      call map_convolve_comm(line,error)
    case default
      call map_message(seve%i,'CLEAN',comm//' not yet implemented')
      icall = icall-1
      error = .true.
      return
    end select
    ! Delete variables that may have been affected
    call sic_descriptor('SPECTRA',desc,found)  
    err = .false.
    if (found) call sic_delvariable('SPECTRA',.false.,err)
  end select
  icall = icall-1
  if (ImagerError) error = .true.
  !
  call end_message(comm,elapsed,quiet,error)
end subroutine run_clean
!
subroutine run_display (line,comm,error)
  use clean_arrays
  use clean_default
  use gbl_message
  use imager_interfaces, except_this=>run_display
  use gkernel_types
  use gkernel_interfaces
  !----------------------------------------------------------------------
  ! @ public
  !*
  ! IMAGER   -- Dispatching routine for Language DISPLAY\
  !!
  !----------------------------------------------------------------------
  character(len=*), intent(inout) :: line    !! Command line
  character(len=*), intent(in)    :: comm    !! Command name
  logical,          intent(out)   :: error   !! Logical error flag
  !
  ! Memory -- 
  integer, save :: icall=0
  character(len=16), save :: last_comm=' '
  character(len=64), save :: last_arg =' '
  character(len=16), save :: last_root='<GREG'
  logical, save :: force_clear=.false.    ! Patch for the Static Pen LUT in VIEW CCT
  ! Local ---
  integer :: i, ia
  logical :: quiet
  real(8) :: elapsed
  character(len=8) :: key
  character(len=64) :: arg
  !
  ! Code ----
  if (icall.ne.0) then
    if  ( (icall.eq.1) .and. ( &
      & (comm.eq.'FIND').or.(comm.eq.'STATISTIC').or. &
      & (comm.eq.'LOAD').or.(comm.eq.'SPECTRUM').or. &
      & (comm.eq.'SET') .or.(comm.eq.'EXTRACT').or. &
      & (comm.eq.'SLICE') ) ) then
      continue
    else
      Print *,'Unforeseen Rentrant call to RUN_DISPLAY ',comm
      read(5,*) i
    endif
  endif
  icall = icall+1
  !
  ImagerError = .false.
  quiet = .true.  ! In general here, as these are interactive commands
  call report_init(elapsed)
  call map_message(seve%c,'DISPLAY',line)
  !
  ! Dispatch command
  select case (comm)
  case ('CATALOG')
    call catalog_comm(line,quiet,error)
  case ('COLOR')
    call color_comm(line,error)
  case ('LOAD')
    call view_load_comm (line,error)
    quiet = sic_lire().ne.0 .or. icall.gt.1
  case ('STATISTIC')
    call statistic(line,error)
    quiet = sic_lire().ne.0 .or. icall.gt.1
  case ('EXTRACT') 
    call extract_comm(line,error)
  case ('FIND')
    call catalog_find(line,error)
  case ('POPUP')
    ia = index(line,' ')
    call exec_program('@ p_popup_all '//line(ia:)) !SG
    quiet = .true.
  case ('SPECTRUM')
    call greg3_spectrum_compute(line,error)
    quiet = sic_lire().ne.0 .or. icall.gt.1
  case ('SET')
    call display_set_comm(line,comm,error)
    quiet = .true.
  case ('SLICE') 
    call slice_comm(line,error)
    quiet = sic_lire().ne.0 .or. icall.gt.1
  case default
    if (force_clear) call gtv_destroy_all(error)
    error = .false.
    !
    ! Reset the LUT to dynamic
    !
    if ((comm.eq.'SHOW').and.sic_present(0,1)) then
      call sic_ke(line,0,1,key,ia,.true.,error)
      if (key.eq.'MOSAIC') then
        call mosaic_show(huv_current%mos%fields)
        icall = icall-1
        return
      endif
    endif
    ! All effective plotting commands with a /DIR option
    quiet = .true.
    call sic_let_char('GTV%ROOT','<GREG',error)
    if (comm.eq.last_comm .and. gtexist(last_root)) then
      if (comm.eq.'SHOW' .or. comm.eq.'VIEW' .or. comm.eq.'INSPECT') then
        if (sic_present(0,1)) then
          call sic_ke(line,0,1,arg,ia,.true.,error)
          if (arg.eq.last_arg) then
            call sic_let_char('GTV%ROOT',last_root,error)
          else
            last_arg = arg
          endif
        else
          call sic_let_char('GTV%ROOT',last_root,error)
        endif
      endif
    endif
    !
    select case (comm)
    case ('COMPARE')
      call compare_comm(line,error)
    case ('SHOW','VIEW','INSPECT_3D')
      if (sic_present(0,1)) call sic_ke(line,0,1,last_arg,ia,.true.,error)
      call display_buffer(comm,line,error)
      force_clear = comm.eq."VIEW".and.last_arg.eq."CCT"
    case ('EXPLORE')
      call explore_comm(line,comm,error)
    case default
      call map_message(seve%i,'DISPLAY',comm//' not yet implemented')
      icall = icall-1
      error = .true.
      return
    end select
    last_comm = comm 
    call sic_get_char('GTV%ROOT',last_root,ia,error)
    call sic_upper(last_root)
  end select
  icall = icall-1
  if (ImagerError) error = .true.
  !
  call end_message(comm,elapsed,quiet,error)
end subroutine run_display
!
subroutine end_message(comm,elapsed,quiet,error)
  use gbl_ansicodes
  use gbl_message
  use imager_interfaces, only : map_message
  !-----------------------------------------------------------
  !@ private
  !
  !! IMAGER -- Print a Timing and Status message if needed
  !-----------------------------------------------------------
  character(len=*), intent(in) :: comm   !! Command line name
  logical, intent(in) :: error           !! Error flag
  logical, intent(in) :: quiet           !! Quiet flag
  real(8), intent(inout) :: elapsed      !! Elapsed time
  !
  character(len=80) :: chain
  !
  if (error) then
    call map_message(seve%e,comm,'failed to complete',seve%e)  
  else if (.not.quiet) then
    call report_time(elapsed)
    if (elapsed.gt.0) then
      write(chain,'(a,a,f9.2,a)') 'Successful completion','  - Elapsed time ',elapsed,' sec'
    else
      chain = 'Successful completion '
    endif
    ! Order is _DRGYBCMW  
    ! (void, Dark, Red, Green, Yellow, Blue, Cyan, Magenta, White)
    call map_message(seve%i,comm,chain,-4)
  endif
  !
end subroutine end_message
!
module time_support
  use gsys_types
  !! Timing support module
  real(8), save :: elapsed_s    !! Start time
  real(8), save :: elapsed_e    !! End (current) time
  logical, save :: nopara       !! Parallel mode
  type(cputime_t), save :: time   !! Timing structure
end module time_support
!
subroutine report_time(elapsed)
  !$ use omp_lib
  use time_support
  ! @ private
  !! IMAGER -- Timing support routine: compute Elapsed time
  real(8), intent(inout) :: elapsed !! Elapsed time
  !
  if (nopara) then
    call gag_cputime_get(time)
    elapsed = time%diff%elapsed
  endif
  !$ elapsed_e = omp_get_wtime()
  !$ elapsed = elapsed_e - elapsed_s
end subroutine report_time
!
subroutine report_init(elapsed)
  !$ use omp_lib
  use time_support
  ! @ private
  !! IMAGER -- Timing support routine: Initialize Elapsed starting time
  real(8), intent(inout) :: elapsed !! Elapsed time
  !
  elapsed = 0
  !
  nopara = .true.
  !$ nopara = .false.
  if (nopara) call gag_cputime_init(time)
  !$ elapsed_s = omp_get_wtime()
end subroutine report_init
!
subroutine run_advanced(line,comm,error)
  use clean_arrays
  use clean_default
  use gbl_message
  use imager_interfaces, except_this=>run_advanced
  !----------------------------------------------------------------------
  ! @ public
  !*
  ! IMAGER  -- Dispatching routine for Language ADVANCED\
  !!
  !----------------------------------------------------------------------
  character(len=*), intent(inout) :: line    !! Command line
  character(len=*), intent(in)    :: comm    !! Command name
  logical,          intent(out)   :: error   !! Logical error flag
  !
  ! Local ---
  integer, save :: icall=0
  integer :: i, icode
  real(8) :: elapsed
  logical :: quiet
  !
  ! Code ----
  if (icall.ne.0) then
    Print *,'Rentrant call to RUN_ADVANCED ',comm
    read(5,*) i
  endif
  icall = icall+1
  !
  quiet = .true.
  call report_init(elapsed)
  !
  ImagerError = .false.
  call map_message(seve%c,'ADVANCED',line)
  !
  ! Analyze command
  select case (comm)
  case ('UV_PREVIEW')
    call uv_preview(line,error)
    quiet = .false.
  case ('PROPER_MOTION')
    call comm_proper_motion(line,comm,error)
    quiet = .false.
  case ('MAP_CONTINUUM')
    call map_continuum(line,error)
    quiet = .false.
  case ('MAP_POLAR')
    call map_polar(line,comm,error)
  case ('MFS')
    call clean_mfs (line,error)
  case ('UV_DEPROJECT','UV_RADIAL','UV_CIRCLE') 
    call uv_radial(line,comm,error)
    quiet = .false.
  case ('UV_SHORT')
    call uvshort_comm(line,comm,error,quiet)
  case ('XY_SHORT')
    call uvshort_comm(line,comm,error,quiet)
  case ('UV_FIT')
    call uvfit_comm(line,error)
    quiet = .false.
  case ('STOKES')
    call stokes_comm(line,error)
    quiet = .false.
  case ('EXTRACT') 
    call extract_comm(line,error)
  case ('MOMENTS')
    call moments_comm(line,error)
    quiet = .false.
  case ('MASK') 
    call mask_comm(line,error)
  case ('UV_ADD') 
    call uv_add_comm(line,error)
    quiet = .false.
  case ('UV_MERGE') 
    call uv_merge_comm(line,error)
    quiet = .false.
  case ('FLUX')
    call flux_comm(line,error)
  case ('HOW_TO')
    icode = 0
    call howto_comm(line,error,icode)
    if (icode.eq.1) call howto_comm(line,error,icode)
  case ('FEATHER')
    call feather_comm(line,error)
    quiet = .false.
  case ('UV_CORRELATE')
    call correlate_comm(line,comm,error)
    quiet = .false.
  case ('UV_MOSAIC')
    call uv_mosaic_comm(line,comm,error)
    quiet = .false.
  case ('UV_GRID')
    call uv_grid_comm (line,comm,error)      
  case ('UV_LINEARIZE')
    call uv_linear_comm (line,comm,error)
    quiet = .false.
  case default
    call map_message(seve%i,'ADVANCED',comm//' not yet implemented')
  end select
  icall = icall-1
  if (ImagerError) error = .true.
  !
  call end_message(comm,elapsed,quiet,error)
  !
end subroutine run_advanced
!
subroutine run_bundles(line,comm,error)
  use clean_arrays
  use clean_default
  use gbl_message
  use imager_interfaces, except_this=>run_bundles
  !----------------------------------------------------------------------
  ! @ public
  !*
  ! IMAGER -- Dispatching routine for Language BUNDLES\
  !!
  !----------------------------------------------------------------------
  character(len=*), intent(inout) :: line    !! Command line
  character(len=*), intent(in)    :: comm    !! Command name
  logical,          intent(out)   :: error   !! Logical error flag
  !
  ! Local ---
  integer, save :: icall=0
  integer :: i
  real(8) :: elapsed
  logical :: quiet
  !
  ! Code ----
  quiet = .true.
  call report_init(elapsed)
  !
  if (icall.ne.0) then
    Print *,'Rentrant call to RUN_BUNDLES ',comm
    read(5,*) i
  endif
  icall = icall+1
  !
  ImagerError = .false.
  call map_message(seve%c,'BUNDLES',line)
  !
  ! Analyze command
  select case (comm)
  case ('SELFCAL') 
    call selfcal_comm(line,comm,error)
  case ('COMBINE')
    call combine_comm(line,error)
    quiet = .false.
!  case ('EXPLORE')
!    call explore_comm(line,comm,error)
  case ('KEPLER')
    call kepler_comm(line,comm,quiet,error)
  case ('UV_DETECT')
    call detect_comm(line,comm,error)
    quiet = .false.
  case ('SPECTRAL_CLEAN')
    call spectral_comm(line,comm,error)
  case default
    call map_message(seve%i,'BUNDLES',comm//' not yet implemented')
  end select
  icall = icall-1
  if (ImagerError) error = .true.
  !
  call end_message(comm,elapsed,quiet,error)
  !
end subroutine run_bundles
!
subroutine run_imager (line,comm,error)
  use clean_arrays
  use clean_default
  use gbl_message
  use imager_interfaces, except_this=>run_imager
  use gkernel_types
  use gkernel_interfaces, only : sic_present, sic_lire, sic_ambigs, sic_narg
  !----------------------------------------------------------------------
  ! @ public
  !*
  ! IMAGER  -- Dispatching routine for Language IMAGER\
  !!
  !----------------------------------------------------------------------
  character(len=*), intent(inout) :: line    !! Command line
  character(len=*), intent(in)    :: comm    !! Command name
  logical,          intent(out)   :: error   !! Logical error flag
  !
  ! Constants
  integer(4), parameter :: mvoc=4
  character(len=12) :: voca(mvoc)
  data voca/'ALL', 'CONTINUUM', 'SPLIT','SURVEY'/
  integer(4), parameter :: msim=7
  character(len=12) :: vsim(msim)
  data vsim/'COVERAGE','FIDELITY','IMAGE','MODEL','NOISE','SETUP','SHOW'/
  !
  ! Local ---
  integer, save :: icall=0
  character(len=16), save :: ocomm
  character(len=12) :: argum,name
  integer(4) :: i, ia,ie, ja,n
  logical :: do_insert
  logical :: quiet
  real(8) :: elapsed
  !
  ! Code ----
  ImagerError = .false.
  call map_message(seve%c,'IMAGER',line)
  !
  if (icall.ne.0) then
    if  ( (icall.eq.1) .and. (ocomm.eq.'REPORT') ) then
      continue
    else
      Print *,'OCOMM ',ocomm
      Print *,'Rentrant call to RUN_IMAGER ',comm
      read(5,*) i
    endif
  endif
  icall = icall+1
  if (icall.eq.1) ocomm = comm
  !
  ImagerError = .false.
  call map_message(seve%c,'IMAGER',line)
  quiet = .true.
  !
  ! Dispatch command
  select case (comm)
  case ('CLARK','HOGBOM','MRC','MULTISCALE','SDI','GCLEAN') 
    call report_init(elapsed)
    call quiet_message(line,quiet)
    !
    if (comm.eq.'MULTISCALE') then
      call sic_let_char('METHOD','MULTI',error)
    else if (comm.eq.'GCLEAN') then
      call sic_let_char('METHOD','GAUSS',error)
    else
      call sic_let_char('METHOD',comm,error)
    endif
    call clean_comm(line,error)
  case ('PIPELINE')
    do_insert = sic_lire().eq.0
    if (sic_present(2,0)) then        ! /WIDGET option
      if (sic_present(1,0)) then
        call map_message(seve%e,comm,'/MODE and /WIDGET options are conflicting')
        icall = icall-1
        error = .true.
        return
      endif
      call exec_program('@ all-widget')
    else if (sic_present(1,0)) then   ! /MODE option
      !
      icall = icall-1
      call sic_ke(line,1,1,argum,n,.true.,error)
      if (error) return
      call sic_ambigs (comm,argum,name,n,voca,mvoc,error)
      if (error) return
      argum = ' '
      call sic_ke(line,0,1,argum,n,.false.,error)
      n = max(n,1)
      !
      icall = icall+1
      call exec_program('@ all-pipeline "'//argum(1:n)//'" '//name)
    else
      ia = index(line,' ')
      call exec_program('@ all-pipeline'//line(ia:))
    endif
    if (do_insert) call sic_insert_log(line)
  case ('REPORT')
    if (sic_narg(0).ne.0) then
      call sic_ch(line,0,1,argum,n,.false.,error)
      call exec_program('@ all-report '//argum(1:n))
    else
      call exec_program('@ all-report')
    endif    
  case ('TIPS')
    if (sic_narg(0).ne.0) then
      call sic_ch(line,0,1,argum,n,.false.,error)
      call exec_program('@ gag_pro:tips '//argum(1:n))
    else
      call exec_program('@ gag_pro:tips')
    endif    
  case ('SIMULATE')
    do_insert = sic_lire().eq.0
    ia = index(line,'/')
    ie = len_trim(line)
    !
    ! Parse the arguments to lift ambiguities
    if (sic_present(0,1)) then
      icall = icall-1
      call sic_ke(line,0,1,argum,n,.true.,error)
      if (error) return
      if (argum.eq.'*') then
        continue
      else if (argum.eq.'?') then
        continue
      else
        call sic_ambigs (comm,argum,name,n,vsim,msim,error)
        if (error) return
        argum = name
        ja = index(line,' ')+1
        if (ia.ne.0) then
          line(ja:) = trim(argum)//line(ia-1:ie)  ! Need the Space before the "/"
        else if (argum.ne.'SHOW') then
          line(ja:) = argum
        else
          name = ' '
          call sic_ke(line,0,2,name,n,.false.,error)
          line(ja:) = trim(argum)//' '//trim(name)
        endif
        ie = len_trim(line)
      endif
      icall = icall+1
    endif
    !
    ia = index(line,' ')
    ie = max(ia,ie)
    call exec_program('@ p_simulate '//line(ia:ie))
    if (do_insert) call sic_insert_log(line)
  case default
    call map_message(seve%i,'IMAGER',comm//' not yet implemented')
    icall = icall-1
    error = .true.
    return
  end select
  icall = icall-1
  if (ImagerError) error = .true.
  if (icall.eq.0) ocomm = ' '
  !
  call end_message(comm,elapsed,quiet,error)
end subroutine run_imager
!
subroutine run_simu (line,comm,error)
  use clean_arrays
  use clean_default
  use gbl_message
  use imager_interfaces, except_this=>run_simu
  use gkernel_types
  use gkernel_interfaces, only : sic_present, sic_lire, sic_ambigs
  !----------------------------------------------------------------------
  ! @ public
  !*
  ! IMAGER  -- Dispatching routine for Language SIMULATE\
  !!
  !----------------------------------------------------------------------
  character(len=*), intent(inout) :: line    !! Command line
  character(len=*), intent(in)    :: comm    !! Command name
  logical,          intent(out)   :: error   !! Logical error flag
  !
  ! Constants
  integer(4), parameter :: mvoc=4
  character(len=12) :: voca(mvoc)
  data voca/'ALL', 'CONTINUUM', 'SPLIT','SURVEY'/
  !
  ! Local ---
  integer, save :: icall=0
  integer(4) :: i
  logical :: quiet
  real(8) :: elapsed
  !
  ! Code ----
  if (icall.ne.0) then
    Print *,'Unforeseen Rentrant call to RUN_SIMULATE ',comm
    read(5,*) i
  endif
  icall = icall+1
  !
  ImagerError = .false.
  call map_message(seve%c,'SIMULATE',line)
  quiet = .true.
  !
  ! Dispatch command
  select case (comm)
  case ('UV_TRACKS')
    call astro_uv(line,error)
  case ('ARRAY')
    call astro_observatory_command(line,error)
  case ('ADD_NOISE')
    call uv_addnoise(line,comm,error)
  case default
    call map_message(seve%i,'SIMULATE',comm//' not yet implemented')
    icall = icall-1
    error = .true.
    return
  end select
  icall = icall-1
  if (ImagerError) error = .true.
  !
  call end_message(comm,elapsed,quiet,error)
end subroutine run_simu
!
subroutine save_result(error)
  use gkernel_interfaces
  use gildas_def
  use clean_types
  use gbl_message
  use imager_interfaces, only : map_message
  !-------------------------------------------------------------------
  !! IMAGER - Exit routine: ask user whether to save data or not
  !-------------------------------------------------------------------
  logical error !! Logical error flag
  !
  character(len=filename_length) :: ans
  character(len=filename_length) :: autosave='autosave'  ! Default name when saving
  character(len=commandline_length) line
  character(len=message_length) :: chain
  character(len=*), parameter :: rname = 'IMAGER'
  integer :: n, icode
  logical :: do_write,noprompt
  !
  ans = ' '
  error = .false.
  do_write = .false.
  call gmaster_get_exitnoprompt(noprompt)  ! Check for SIC\EXIT /NOPROMPT
  !
  if (any(save_data) .and. .not.noprompt) then
    call map_message(seve%w,rname,'There are unsaved data, should we save them?')
    do while (.true.)
      call sic_wprn('Y)es, N)o, C)ancel exit (default No): ',ans,n)
      call sic_upper(ans)
      if (ans(1:1).eq.'C') then
        error = .true.
        return
      elseif (ans(1:1).eq.'N' .or. ans(1:1).eq.' ') then
        do_write = .false.
      elseif (ans(1:1).ne.'Y') then
        call map_message(seve%e,rname,'Unrecognized answer '//ans)
        cycle
      else 
        do_write = .true.
      endif
      exit
    enddo
  endif
  !
  call sic_delvariable('DIRTY',.false.,error)
  call sic_delvariable('CLEAN',.false.,error)
  call sic_delvariable('RESIDUAL',.false.,error)
  call sic_delvariable('PRIMARY',.false.,error)
  call sic_delvariable('SKY',.false.,error)
  if (.not.do_write) return
  !
  do icode=1,mtype
    ans = ' '
    error = .false.
    do while (save_data(icode))
       write(chain,100) vtype(icode)
       call sic_wprn(trim(chain)//' ',ans,n)
       if (ans.eq.' ') ans = autosave
       line = 'CLEAN'//char(92)//'WRITE '//vtype(icode)//' "'//trim(ans)//'"'
       call exec_command (line,error)
    enddo
  enddo
  !
100 format('Enter a filename for ',a,' (default ''autosave''): ')
end subroutine save_result
!
subroutine quiet_message(line,quiet)
  use gildas_def
  use gkernel_interfaces
  !----------------------------------------------------------------------
  ! @ private
  !! IMAGER -- Test if command should be "Quiet", i.e. is only a Help-like command
  !----------------------------------------------------------------------
  character(len=*), intent(in) :: line    !! Command line
  logical, intent(out) :: quiet           !! Is command quiet ?
  !
  logical :: error
  character(len=filename_length) :: ctest
  integer :: i
  !
  if (sic_present(0,1)) then
    ctest = ' '    
    call sic_ch(line,0,1,ctest,i,.false.,error)
    quiet = (ctest(1:1).eq.'?')
    if (.not.quiet) then
      if (sic_present(0,2)) then
        call sic_ch(line,0,2,ctest,i,.false.,error)
        quiet = (ctest(1:1).eq.'?')
      endif
    endif
  else
    quiet = .false.
  endif
end subroutine quiet_message

subroutine uv_add_comm(line,error)
  !$ use omp_lib
  use image_def
  use clean_arrays
  use gkernel_interfaces
  use gbl_format
  use gbl_message
  use imager_interfaces, only : map_message 
  !-----------------------------------------------------------------------
  ! @ private
  !*
  !  IMAGER -- Support for command UV_ADD
  !
  !   UV_ADD ITEM [Mode] [/FILE FileIn FileOut]
  !
  ! Task to compute and add some missing information in a UV
  ! Table, such as the Doppler correction and the Parallactic Angle 
  !
  ! Gets the Observatory from the Telescope name in the input UV table,
  ! suggests to use SPECIFY command if not available.
  !!
  !-----------------------------------------------------------------------
  character(len=*), intent(in)    :: line   !! Command line
  logical,          intent(inout) :: error  !! Logical error flag
  ! 
  ! Constants
  character(len=*), parameter :: rname='UV_ADD'
  real(kind=8), parameter :: clight_kms=299792.458d0
  real(kind=8),  parameter :: pi=3.141592653589793d0
  integer, parameter :: o_file=1
  integer, parameter :: mvoc=2
  character(len=16) :: vocab(mvoc)
  data vocab/'DOPPLER','PARALLACTIC'/
  !
  ! Local ---
  character(len=16) :: argum,key
  integer :: ikey
  integer :: mthread
  character(len=filename_length) :: file
  character(len=12) :: telescope
  type (gildas) :: uvin, uvou
  integer(kind=4) :: nf, ier, ib, n
  integer(kind=index_length) :: i,j
  real(kind=4) :: rdate, rtime, doppler, parang
  character(len=2) :: coord
  character(len=80) :: mess
  real(kind=4) :: equinox
  real(kind=8) :: lambda, beta
  integer(kind=4) :: nblock, nvisi, idate, itime
  logical :: dofile
  integer(kind=4) :: mode
  integer(kind=4) :: idopp
  integer(kind=4) :: ipara
  integer :: count
  real(8), allocatable :: when(:)
  integer(kind=4), allocatable :: iorder(:)
  !
  ! Code ----
  ! Make sure the Ephemeris are available
  call astro_init
  !
  ! Get the Key for adding some stuff.
  argum = '*'
  call sic_ke(line,0,1,argum,n,.false.,error)
  if (argum.ne.'*') then
    call sic_ambigs (rname,argum,key,ikey,vocab,mvoc,error)
    if (error) return
  else
    key = '*'
  endif
  !
  ! /FILE option
  dofile = sic_present(o_file,0)
  !
  ! Argument MODE is a test control only
  mode = 0
  if (dofile) mode = -1
  call sic_i4(line,0,2,mode,.false.,error)
  if (error)  return
  if (mode.lt.0) then
    if (.not.dofile) then
      call map_message(seve%e,rname,'Negative MODE not allowed without /FILE')
      error = .true.
      return
    endif
  else if (mode.gt.0 .and. mode.ne.3) then
    if (mode.gt.uvin%gil%dim(1)) then
      call map_message(seve%e,rname,'Error: MODE larger than number of columns')
      error = .true.
      return
    else
      call map_message(seve%w,rname,'Warning: MODE is neither 0 nor 3')
    endif
  endif  
  !
  ! Open the input file and read Header
  call gildas_null (uvin, type = 'UVT')     ! Define a UVTable gildas header
  if (dofile) then
    call sic_ch(line,o_file,1,file,nf,.true.,error)
    if (error)  return
    call gdf_read_gildas (uvin, file, '.uvt', error, data=.false.)
    if (error) then
      call map_message(seve%e,rname,'Cannot read input UV table')
      return
    endif
  else
    if (huv_current%loca%size.eq.0) then
      call map_message(seve%e,rname,'No UV table loaded')
      error = .true.
    else
      call gdf_copy_header(huv_current,uvin,error)
    endif
    if (error) return
  endif
  !
  ! Define the telescope name
  if (uvin%gil%nteles.ne.0) then
    telescope = uvin%gil%teles(1)%ctele   
  else
    call map_message(seve%e,rname,'No telescope in UV table, use SPECIFY command')
    error = .true.
    return
  endif
  call astro_observatory_byname(telescope,error)
  if (error) return
  !
  call gildas_null (uvou, type = 'UVT')     ! Define a UVTable gildas header
  if (dofile) then
    call sic_ch(line,o_file,2,file,nf,.true.,error)
    if (error) return
    ! Define blocking factor, on largest data file, usually the input one
    ! but not always...
    call gdf_nitems('SPACE_GILDAS',nblock,uvin%gil%dim(1)) ! Visibilities at once
    nblock = min(nblock,uvin%gil%dim(2))
    ! Allocate respective space for each file
    allocate (uvin%r2d(uvin%gil%dim(1),nblock),stat=ier)
    if (failed_allocate(rname,'UV input data',ier,error))  return
    !
  else
    ! Work in place
    uvin%r2d => duv 
  endif
  !
  ! Here modify the header of the output UV table according
  ! to the desired goal
  call gdf_copy_header(uvin,uvou,error)
  !
  idopp = 0
  ipara = 0
  if (key.eq.'*' .or. key.eq.'DOPPLER') then
    !
    ! Inherit the Pointer for Doppler effect
    idopp = uvou%gil%column_pointer(code_uvt_topo) 
    call find_dummy_column (uvou,idopp,mode)
    if (key.eq.'DOPPLER' .and. idopp.eq.0) then
      call map_message(seve%e,rname,'No Doppler column available')
      error = .true.
    else
      uvou%gil%column_pointer(code_uvt_topo) = idopp
      uvou%gil%column_size(code_uvt_topo) = 1
    endif
  endif
  !
  if (key.eq.'*' .or. key.eq.'PARALLACTIC') then
    !
    ! Inherit the Pointer for Doppler effect
    ipara = uvou%gil%column_pointer(code_uvt_para) 
    call find_dummy_column (uvou,ipara,mode)
    if (key.eq.'PARALLACTIC' .and. ipara.eq.0) then
      call map_message(seve%e,rname,'No Parallactic Angle column available')
      error = .true.
    else
      uvou%gil%column_pointer(code_uvt_para) = ipara
      uvou%gil%column_size(code_uvt_para) = 1
    endif
  endif
  !
  if (ipara.eq.idopp) then
    call map_message(seve%e,rname,'Cannot place Doppler and Parallactic angle in same column')
    error = .true.
  else if (.not.error) then
    if (idopp.ne.0) then
      write(mess,'(A,I0)') 'Placing Doppler factor in column ',idopp
      call map_message(seve%i,rname,mess)
    endif
    if (ipara.ne.0) then
      write(mess,'(A,I0)') 'Placing Parallactic Angle in column ',ipara
      call map_message(seve%i,rname,mess)
    endif
  endif
  if (error) then
    call gdf_close_image(uvin,error)
    deallocate(uvin%r2d,stat=ier)
    error = .true.
    return
  endif
  !
  !
  uvou%gil%vtyp = vel_lsr
  coord = uvin%char%syst
  if (coord.eq.'EQ') then
    equinox = uvin%gil%epoc
    lambda = uvin%gil%ra
    beta   = uvin%gil%dec
  else if (coord.eq.'GA') then
    equinox = uvin%gil%epoc
    lambda = uvin%gil%lii
    beta   = uvin%gil%bii
  else
    call map_message(seve%w,rname,'Unsupported system '//coord)
    call map_message(seve%w,rname,'Assuming EQUATORIAL 2000.0')
    coord = 'EQ'
    equinox = 2000.0
    lambda = uvin%gil%ra
    beta   = uvin%gil%dec
  endif
  !
  rdate = -1e38
  rtime = -1e38
  idate = uvin%gil%column_pointer(code_uvt_date)
  itime = uvin%gil%column_pointer(code_uvt_time)
  !
  if (dofile) then
    call sic_parse_file(file,' ','.uvt',uvou%file)
    !
    ! create the image
    uvou%gil%dopp = 0.d0
    uvou%gil%version_uv = code_version_uvt_syst
    call gdf_create_image(uvou,error)
    if (error) then
      call gdf_close_image(uvin,error)
      deallocate(uvin%r2d,stat=ier)
      error = .true.
      return
    endif
    !
    ! Check if additional columns are needed
    if (uvin%gil%dim(1).ne.uvou%gil%dim(2)) then
      allocate(uvou%r2d(uvou%gil%dim(1),uvou%gil%dim(2)),stat=ier)
      if (ier.ne.0) then
        call gdf_close_image(uvin,error)
        call gdf_close_image(uvou,error)
        deallocate(uvin%r2d,stat=ier)
        error = .true.
        return
      endif
    else
      uvou%r2d => uvin%r2d
    endif
    !
    ! Loop over line table
    allocate (when(nblock),iorder(nblock))
    !
    uvou%blc = 0
    uvou%trc = 0
    uvin%blc = 0
    uvin%trc = 0
    !
    mthread = 1
    !$ mthread = omp_get_max_threads()
    count = 0
    do ib = 1,uvou%gil%dim(2),nblock
      write(mess,*) ib,' / ',uvou%gil%dim(2),nblock
      call map_message(seve%i,rname,mess)
      uvin%blc(2) = ib
      uvin%trc(2) = min(uvin%gil%dim(2),ib-1+nblock)
      uvou%blc(2) = ib
      uvou%trc(2) = uvin%trc(2)
      !
      call gdf_read_data(uvin,uvin%r2d,error)
      nvisi = uvin%trc(2)-uvin%blc(2)+1
      if (uvin%gil%dim(1).ne.uvou%gil%dim(2)) then
        uvou%r2d(1:uvin%gil%dim(1),:) = uvin%r2d(:,:)
      endif
      !
      ! Do the job - This is be much faster if the file is Time sorted
      when(1:nvisi) = uvou%r2d(idate,1:nvisi)*86400d0 + uvou%r2d(itime,1:nvisi)
      do i=1,nvisi
        iorder(i) = i
      enddo
      call gr8_trie(when,iorder,nvisi,error)
      !
      ! Parallelism is possible if RDATE and RTIME are PRIVATE and 
      ! re-initialized at each block, but this proved inefficient.
      !
      ! svisi = (nvisi+mthread-1)/mthread
      ! !$OMP PARALLEL DEFAULT(none) NUM_THREADS(mthread) &
      ! !$OMP & SHARED (nvisi,uvou, idate, itime, ipara, idopp) &
      ! !$OMP & PRIVATE (i,j,rdate,rtime,doppler,parang,error,rw) &
      ! !$OMP & SHARED (coord,equinox,lambda,beta, svisi, count, iorder, when)
      ! !$ rdate = -1e38
      ! !$ rtime = -1e38
      ! !$OMP DO SCHEDULE(STATIC,svisi) REDUCTION(+:count)
      do j=1,nvisi
        i  = iorder(j)
        !
        ! 2 seconds is more than enough a tolerance for our case.
        ! In practice, we recompute at each scan, in fact.
        if (uvou%r2d(idate,i).ne.rdate .or. (abs(uvou%r2d(itime,i)-rtime).gt.2.0) ) then
          rdate = uvou%r2d(idate,i)
          rtime = uvou%r2d(itime,i)
          call sub_uv_doppler_para(uvou%gil%vtyp,rdate,rtime,doppler,parang,&
            coord,equinox,lambda,beta,error)
          count = count+1
        endif
        if (idopp.ne.0) uvou%r2d(idopp,i) = doppler
        if (ipara.ne.0) uvou%r2d(ipara,i) = parang
      enddo
      ! !$OMP ENDDO
      ! !$OMP END PARALLEL
      if (sic_ctrlc()) then
        error = .true.
        call map_message(seve%e,rname,'Aborted by ^C')
      else
        call gdf_write_data (uvou,uvou%r2d,error)
      endif
      if (error) then
        call gdf_close_image(uvou,error)
        call gdf_close_image(uvin,error)
        if (uvin%gil%dim(1).ne.uvou%gil%dim(2)) then
          deallocate(uvou%r2d,stat=ier)
        else
          nullify(uvou%r2d)
        endif
        deallocate(uvin%r2d,stat=ier)
        error = .true.
        return
      endif
    enddo
    write(mess,'(A,I0,A)') 'Called ',count,' times ephemerides'
    call map_message(seve%i,rname,mess)
    !
    call gdf_close_image(uvin,error)
    call gdf_close_image(uvou,error)
    if (uvin%gil%dim(1).ne.uvou%gil%dim(2)) then
      deallocate(uvou%r2d,stat=ier)
    else
      nullify(uvou%r2d)
    endif
    deallocate(uvin%r2d,stat=ier)
  else
    call map_message(seve%i,rname,'Working on current UV table')
    do i=1,uvin%gil%nvisi
      !
      if (uvin%r2d(idate,i).ne.rdate .or. uvin%r2d(itime,i).ne.rtime) then
        rdate = uvin%r2d(idate,i)
        rtime = uvin%r2d(itime,i)
        call sub_uv_doppler_para(uvou%gil%vtyp,rdate,rtime,doppler,parang,&
          coord,equinox,lambda,beta,error)
        ! factor = (1.d0 + doppler)
      endif
      if (idopp.ne.0) uvin%r2d(idopp,i) = doppler
      if (ipara.ne.0) uvin%r2d(ipara,i) = parang
    enddo
    if (sic_ctrlc()) then
      error = .true.
      call map_message(seve%e,rname,'Aborted by ^C')
      return
    endif
    !
    call gdf_copy_header(uvou,huv_current,error)
  endif
end subroutine uv_add_comm
!
subroutine sub_uv_doppler_para(vtype,rdate,rtime,doppler,parang, &
        & coord,equinox,lambda,beta,error)
  use gbl_constant
  use phys_const
  use image_def
  !---------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- Support for UV_ADD command
  !
  ! Compute the Doppler correction, calling ASTRO routine, according to:
  ! * observatory location, 
  ! * reference frame (LSR, Helio...)
  ! Radio convention is used
  !
  ! Also get the Parallactic Angle 
  !!
  !---------------------------------------------------------------------
  integer(kind=4),  intent(in)  :: vtype    !! Type of referential
  real(kind=4),     intent(in)  :: rdate    !! GAG Date
  real(kind=4),     intent(in)  :: rtime    !! UT Time
  real(kind=4),     intent(out) :: doppler  !! Doppler factor
  real(kind=4),     intent(out) :: parang   !! Parallactic Angle
  character(len=2), intent(in)  :: coord    !!
  real(kind=4),     intent(in)  :: equinox  !!
  real(kind=8),     intent(in)  :: lambda   !!
  real(kind=8),     intent(in)  :: beta     !!
  logical,          intent(out) :: error    !! flag
  !
  ! Local ---
  real(kind=8) :: vshift
  real(kind=8) :: s_2(2), s_3(3), dop, lsr, svec(3), x_0(3), dparang
  real(kind=8) :: jtdt, jut1, jutc
  !
  ! Code ---
  doppler = -1d0
  !
  ! Reset the time
  jutc = rdate + rtime/86400.d0 +  2460549.5d0
  !
  ! For what we want to do, these are negligible
  jut1 = 0.d0
  Jtdt = 0.
  call do_astro_time(jutc,jut1,jtdt,error)
  if (error) return
  !
  ! Call ASTRO
  call do_object(coord,equinox,lambda,beta,s_2,s_3,dop,lsr,svec, &
      &   x_0,dparang,error)
  if (error) return
  !
  ! Now retrieve the Doppler value
  !
  select case (vtype)
  case (vel_lsr)
     vshift = dop+lsr
  case (vel_hel)
     vshift = dop
  case (vel_ear)
     vshift = 0.0d0
  case default
     vshift = 0.0d0
  end select
  !
  ! This follows the CLASS convention, but it seems that the
  ! CLIC convention is WRONG ...
  doppler = - vshift / clight * 1d3
  !
  parang = dparang
end subroutine sub_uv_doppler_para
!
subroutine find_dummy_column(uvou,icode,mode)
  use image_def
  !---------------------------------------------------------------------
  ! @ private
  ! GILDAS --  Locate a re-usable dummy or empty column in UV header
  !---------------------------------------------------------------------
  type(gildas), intent(inout) :: uvou !! UV Header
  integer, intent(inout) :: icode     !! Column code -- must be zero
  integer, intent(in)    :: mode      !! Preferred column - if zero, an empty one
  !
  ! Local ---
  integer :: i
  !
  ! Code ----
  if (icode.ne.0) return
  !
  if (uvou%gil%column_pointer(code_uvt_moff).ne.0 .and. &
    & uvou%gil%column_pointer(code_uvt_loff).eq.0) then
    ! Use the (often) Dummy MOFF column
    icode = uvou%gil%column_pointer(code_uvt_moff)
    uvou%gil%column_size(code_uvt_moff) = 0
    uvou%gil%column_pointer(code_uvt_moff) = 0
  else if (uvou%gil%column_pointer(code_uvt_id).ne.0) then
    ! or the Source ID column
    icode = uvou%gil%column_pointer(code_uvt_id)
    uvou%gil%column_size(code_uvt_id) = 0
    uvou%gil%column_pointer(code_uvt_id) = 0 
  else if (mode.gt.0) then
    ! or as a fall back, column indicated by MODE
    icode = mode 
    do i = 1,code_uvt_last
      if (uvou%gil%column_pointer(i).eq.icode)  then
        uvou%gil%column_size(i) = 0
        uvou%gil%column_pointer(i) = 0
      endif
    enddo
  else if (mode.lt.0) then
    !
    ! Add an Empty column
    uvou%gil%ntrail = uvou%gil%ntrail+1
    uvou%gil%dim(1) = uvou%gil%dim(1)+1
    icode = uvou%gil%dim(1)
  else
    ! or find an empty column (not coded yet)
  endif
end subroutine find_dummy_column

subroutine gfits_load_header(hdict,check,getsymbol,error)
  use gfits_interfaces, except_this=>gfits_load_header
  use gfits_types
  !---------------------------------------------------------------------
  ! @ public
  ! Load the FITS header in the dictionary structure.
  !  COMMENT lines are ignored
  !  HISTORY lines are ignored
  !  HIERARCH lines are interpreted as appropriate
  ! This could be customized
  !---------------------------------------------------------------------
  type(gfits_hdict_t), intent(out)   :: hdict      !
  logical,             intent(in)    :: check      !
  external                           :: getsymbol  ! Symbol translation routine
  logical,             intent(inout) :: error      !
  ! Local
  integer(kind=4) :: icard
  !
  ! Read cards until END is reached
  hdict%ncard = 0
  do
    call gfits_reallocate_dict(hdict,error)
    if (error)  return
    !
    icard = hdict%ncard+1
    call gfits_get(hdict%card(icard)%key,hdict%card(icard)%val,  &
      check,error,continue=.true.,comment=hdict%card(icard)%comment)
    if (error)  return
    call gfits_patch_key(hdict%card(icard))
    if (hdict%card(icard)%key.eq.'COMMENT')  cycle
    if (hdict%card(icard)%key.eq.'HISTORY')  cycle
    if (hdict%card(icard)%key.eq.'')         cycle  ! Must be a comment
    if (hdict%card(icard)%key.eq.'END')      exit
    if (hdict%card(icard)%key.eq.'HIERARCH') then
      call gfits_hierarch(hdict%card(icard)%key,hdict%card(icard)%val,error)
      if (error)  return
    endif
    ! That's a valid card: keep it
    hdict%ncard = icard
    hdict%sort(icard) = icard
  enddo
  !
  ! Compute the sorting array
  call gfits_setsort(hdict,error)
  if (error)  return
  !
contains
  !
  subroutine gfits_patch_key(card)
    type(fits_unkn_0d_t), intent(inout) :: card
    ! Local
    character(len=key_length) :: trans
    logical :: error  ! Local error, never set to .true.
    !
    error = .false.
    call getsymbol(card%key,trans,error)
    if (error) then
      error = .false.
    else
      card%key = trans
    endif
  end subroutine
  !
  subroutine print_header()
    !---------------------------------------------------------------------
    ! Debug
    !---------------------------------------------------------------------
    integer(kind=4) :: jcard
    do icard=1,hdict%ncard
      jcard = hdict%sort(icard)
      write(*,'(I0,A)') jcard,':'
      write(*,'(2X,A)') hdict%card(jcard)%key
      write(*,'(2X,A)') hdict%card(jcard)%val
      write(*,'(2X,A)') hdict%card(jcard)%comment
    enddo
  end subroutine print_header
  !
end subroutine gfits_load_header
!
subroutine gfits_setsort(fh,error)
  use gfits_dependencies_interfaces
  use gfits_interfaces, except_this=>gfits_setsort
  use gfits_types
  !---------------------------------------------------------------------
  ! @ private
  !  Compute the sorting list of the input fits header (fh%sort)
  !  Remark: fh%sort() must contain the unsorted elements before
  ! entering gi0_quicksort_index_with_user_gtge. It can be partially
  ! sorted, or not at all, this will work.
  !---------------------------------------------------------------------
  type(gfits_hdict_t), intent(inout) :: fh
  logical,             intent(inout) :: error
  !
  call gi0_quicksort_index_with_user_gtge(fh%sort,fh%ncard,  &
    gfits_sort_gt,gfits_sort_ge,error)
  if (error)  return
  !
contains
  !
  ! Sorting functions: just sort the cards by key names
  function gfits_sort_gt(m,l)
    logical :: gfits_sort_gt
    integer(kind=4), intent(in) :: m,l
    gfits_sort_gt = lgt(fh%card(m)%key,fh%card(l)%key)
  end function gfits_sort_gt
  !
  function gfits_sort_ge(m,l)
    logical :: gfits_sort_ge
    integer(kind=4), intent(in) :: m,l
    gfits_sort_ge = lge(fh%card(m)%key,fh%card(l)%key)
  end function gfits_sort_ge
  !
end subroutine gfits_setsort
!
subroutine gfits_check_simple(card,error)
  use gbl_message
  use gfits_types
  use gfits_interfaces, except_this=>gfits_check_simple
  !---------------------------------------------------------------------
  ! @ public
  ! Sanity check of the SIMPLE card in FITS header. This is generic for
  ! any FITS file.
  !---------------------------------------------------------------------
  type(fits_unkn_0d_t), intent(in)    :: card   !
  logical,              intent(inout) :: error  !
  ! Local
  character(len=*), parameter :: rname='FITS'
  character(len=char0d_length) :: lval
  !
  lval = adjustl(card%val)  ! Insensitive to leading spaces, i.e. tolerate free format
  !
  if (card%key.ne.'SIMPLE') then
    call gfits_message(seve%e,rname,'First keyword is not SIMPLE (got '//trim(card%key)//')')
    error = .true.
    return
    !
  elseif (lval.eq.'F') then
    call gfits_message(seve%w,rname,'Not a SIMPLE FITS file, trying...')
    !
  elseif (lval.ne.'T') then
    call gfits_message(seve%e,rname,'Not a standard FITS file')
    error = .true.
    return
    !
  endif
  !
end subroutine gfits_check_simple
!
subroutine gfits_check_xtension(card,error,xkind)
  use gbl_message
  use gfits_types
  use gfits_interfaces, except_this=>gfits_check_xtension
  !---------------------------------------------------------------------
  ! @ public
  ! Sanity check of the XTENSION card in FITS header. This is generic
  ! for any FITS file. Optionally check for the XTENSION kind.
  !---------------------------------------------------------------------
  type(fits_unkn_0d_t),       intent(in)    :: card   !
  logical,                    intent(inout) :: error  !
  character(len=*), optional, intent(in)    :: xkind  ! Desired XTENSION kind
  ! Local
  character(len=*), parameter :: rname='FITS'
  character(len=80) :: value
  !
  if (card%key.ne.'XTENSION') then
    call gfits_message(seve%e,rname,'First keyword in extension is not XTENSION (got '//trim(card%key)//')')
    error = .true.
    return
  endif
  !
  if (present(xkind)) then
    value = gfits_unquote(card%val)
    if (value.ne.xkind) then
      call gfits_message(seve%e,rname,'XTENSION kind is not '//trim(xkind)//' (got '//trim(value)//')')
      error = .true.
      return
    endif
  endif
  !
end subroutine gfits_check_xtension
!
subroutine gfits_check_format(card,nbit,fmt,error)
  use gbl_format
  use gbl_message
  use gfits_types
  use gfits_interfaces, except_this=>gfits_check_format
  !---------------------------------------------------------------------
  ! @ public
  ! Translate BITPIX to internal format code. This is generic for any
  ! FITS file.
  !---------------------------------------------------------------------
  type(fits_unkn_0d_t), intent(in)    :: card   !
  integer(kind=4),      intent(out)   :: nbit   !
  integer(kind=4),      intent(out)   :: fmt    !
  logical,              intent(inout) :: error  !
  ! Local
  character(len=*), parameter :: rname='FITS'
  character(len=message_length) :: mess
  !
  if (card%key.ne.'BITPIX') then
    call gfits_message(seve%e,rname,'Second keyword is not BITPIX: '//card%key)
    error = .true.
    return
  endif
  !
  read(card%val,'(I20)') nbit
  select case (nbit)
  case (8)
    fmt = fmt_by
  case (16)
    fmt = eei_i2
  case (32)
    fmt = eei_i4
  case (-32)
    fmt = eei_r4
  case (-64)
    fmt = eei_r8
  case default
    write(mess,*) 'Unsupported BITPIX size: ',nbit
    call gfits_message(seve%e,rname,mess)
    error = .true.
    return
  end select
  !
end subroutine gfits_check_format
!
subroutine gfits_check_naxis(card,naxis,error)
  use gildas_def
  use gbl_message
  use gfits_types
  use gfits_interfaces, except_this=>gfits_check_naxis
  !---------------------------------------------------------------------
  ! @ public
  ! Translate NAXIS. This is generic for any FITS extension.
  !---------------------------------------------------------------------
  type(fits_unkn_0d_t), intent(in)    :: card   !
  integer(kind=4),      intent(out)   :: naxis  !
  logical,              intent(inout) :: error  !
  ! Local
  character(len=*), parameter :: rname='FITS'
  integer(kind=4) :: ier
  !
  if (card%key.ne.'NAXIS') then
    call gfits_message(seve%e,rname,'Third keyword is not NAXIS: '//card%key)
    error = .true.
    return
  endif
  !
  read(card%val,'(I20)',iostat=ier) naxis
  if (ier.ne.0) then
    call gfits_message(seve%e,rname,'Error decoding NAXIS = '//card%val)
    error = .true.
    return
  endif
  if (naxis.lt.0 .or. naxis.gt.sic_maxdims) then
    call gfits_message(seve%e,rname,'Unsupported NAXIS value: '//card%val)
    error = .true.
    return
  endif
  !
end subroutine gfits_check_naxis
!
subroutine gfits_check_naxisi(fhdict,dims,error)
  use gildas_def
  use gbl_message
  use gfits_types
  use gfits_interfaces, except_this=>gfits_check_naxisi
  !---------------------------------------------------------------------
  ! @ public
  ! Translate all the NAXISi. This is generic for any FITS extension.
  !---------------------------------------------------------------------
  type(gfits_hdict_t),        intent(in)    :: fhdict   !
  integer(kind=index_length), intent(out)   :: dims(:)  !
  logical,                    intent(inout) :: error    !
  ! Local
  character(len=*), parameter :: rname='FITS'
  integer(kind=4) :: iaxis
  character(len=6) :: key
  logical :: found
  !
  do iaxis=1,size(dims)
    write(key,'(A5,I1)')  'NAXIS',iaxis
    dims(iaxis) = 1  ! Default if missing (same as GDF default)
    call gfits_get_value(fhdict,key,found,dims(iaxis),error)
    if (error)  return
    !
    if (dims(iaxis).lt.0) then
      call gfits_message(seve%e,rname,'Unexpected '//trim(key)//' value')
      error = .true.
      return
    endif
    !
  enddo
  !
end subroutine gfits_check_naxisi
!
subroutine gfits_find_value(fh,key,found,value,error)
  use gfits_dependencies_interfaces
  use gfits_interfaces, except_this=>gfits_find_value
  use gfits_types
  !---------------------------------------------------------------------
  ! @ private
  ! Get the value in the dictionary from the given key. Output is the
  ! raw character string (not evaluated).
  !---------------------------------------------------------------------
  type(gfits_hdict_t), intent(in)    :: fh
  character(len=*),    intent(in)    :: key
  logical,             intent(out)   :: found
  character(len=*),    intent(out)   :: value
  logical,             intent(inout) :: error
  ! Local
  integer(kind=4) :: icard
  !
  value = ''
  found = .false.
  !
  ! Unefficient access looping on all elements:
  ! do icard=1,fh%ncard
  !   if (fh%card(icard)%key.eq.key) then
  !     found = .true.
  !     value = fh%card(icard)%val
  !     return
  !   endif
  ! enddo
  !
  ! Efficient access using dichotomic search within the sorted cards
  if (llt(key,fh%card(fh%sort(1       ))%key)  .or.  &
      lgt(key,fh%card(fh%sort(fh%ncard))%key)) then
    ! Key is beyond the sorted cards list: nothing to find
    return
  endif
  call gi0_dicho_with_user_ltgt(fh%ncard,.false.,icard,  &
    find_key_lt,find_key_gt,error)
  if (error)  return
  ! Using floor mode, result satisfies X(ival) <= xval < X(ival+1)
  found = fh%card(fh%sort(icard))%key.eq.key
  if (found)  value = fh%card(fh%sort(icard))%val
  !
contains
  function find_key_lt(icard)
    logical :: find_key_lt
    integer(kind=4) :: icard
    find_key_lt = llt(fh%card(fh%sort(icard))%key,key)
  end function find_key_lt
  function find_key_gt(icard)
    logical :: find_key_gt
    integer(kind=4) :: icard
    find_key_gt = lgt(fh%card(fh%sort(icard))%key,key)
  end function find_key_gt
end subroutine gfits_find_value
!
subroutine gfits_get_char(fh,key,found,value,error)
  use gfits_interfaces, except_this=>gfits_get_char
  use gfits_types
  !---------------------------------------------------------------------
  ! @ public-generic gfits_get_value
  ! Get the value in the dictionary from the given key, and evaluate it
  ! as character string. Quotes are removed if any. The output value is
  ! not modified if its key is not found.
  !---------------------------------------------------------------------
  type(gfits_hdict_t), intent(in)    :: fh
  character(len=*),    intent(in)    :: key
  logical,             intent(out)   :: found
  character(len=*),    intent(inout) :: value
  logical,             intent(inout) :: error
  ! Local
  character(len=80) :: string
  !
  call gfits_find_value(fh,key,found,string,error)
  if (error .or. .not.found)  return
  !
  value = gfits_unquote(string)
  !
end subroutine gfits_get_char
!
subroutine gfits_get_inte(fh,key,found,value,error)
  use gbl_message
  use gfits_dependencies_interfaces
  use gfits_interfaces, except_this=>gfits_get_inte
  use gfits_types
  !---------------------------------------------------------------------
  ! @ public-generic gfits_get_value
  ! Get the value in the dictionary from the given key, and evaluate it
  ! as an integer. The output value is not modified if its key is not
  ! found.
  !---------------------------------------------------------------------
  type(gfits_hdict_t), intent(in)    :: fh
  character(len=*),    intent(in)    :: key
  logical,             intent(out)   :: found
  integer(kind=4),     intent(inout) :: value
  logical,             intent(inout) :: error
  ! Local
  integer(kind=4) :: ier
  character(len=80) :: string
  real(kind=8) :: tmp
  !
  call gfits_find_value(fh,key,found,string,error)
  if (error .or. .not.found)  return
  !
  read(string,'(I20)',iostat=ier)  value
  if (ier.eq.0)  return
  !
  ! Try to read as float, but must fit as integer afterwards
  read(string,*,iostat=ier)  tmp
  if (ier.ne.0) then
    call gfits_message(seve%e,'FITS','Error decoding '//trim(key)//' = '//trim(string)//' to I*4')
    error = .true.
    return
  endif
  !
  value = nint(tmp)
  if (.not.(nearly_equal(dble(value),tmp,1.d-6))) then
    call gfits_message(seve%e,'FITS','Error decoding '//trim(key)//' = '//trim(string)//' to I*4')
    error = .true.
    return
  endif
  !
end subroutine gfits_get_inte
!
subroutine gfits_get_long(fh,key,found,value,error)
  use gbl_message
  use gfits_dependencies_interfaces
  use gfits_interfaces, except_this=>gfits_get_long
  use gfits_types
  !---------------------------------------------------------------------
  ! @ public-generic gfits_get_value
  ! Get the value in the dictionary from the given key, and evaluate it
  ! as long integer. The output value is not modified if its key is not
  ! found.
  !---------------------------------------------------------------------
  type(gfits_hdict_t), intent(in)    :: fh
  character(len=*),    intent(in)    :: key
  logical,             intent(out)   :: found
  integer(kind=8),     intent(inout) :: value
  logical,             intent(inout) :: error
  ! Local
  integer(kind=4) :: ier
  character(len=80) :: string
  real(kind=8) :: tmp
  !
  call gfits_find_value(fh,key,found,string,error)
  if (error .or. .not.found)  return
  !
  read(string,'(I20)',iostat=ier)  value
  if (ier.eq.0)  return
  !
  ! Try to read as float, but must fit as integer afterwards
  read(string,*,iostat=ier)  tmp
  if (ier.ne.0) then
    call gfits_message(seve%e,'FITS','Error decoding '//trim(key)//' = '//trim(string)//' to I*8')
    error = .true.
    return
  endif
  !
  value = nint(tmp)
  if (.not.(nearly_equal(dble(value),tmp,1.d-6))) then
    call gfits_message(seve%e,'FITS','Error decoding '//trim(key)//' = '//trim(string)//' to I*8')
    error = .true.
    return
  endif
  !
end subroutine gfits_get_long
!
subroutine gfits_get_real(fh,key,found,value,error)
  use gbl_message
  use gfits_interfaces, except_this=>gfits_get_real
  use gfits_types
  !---------------------------------------------------------------------
  ! @ public-generic gfits_get_value
  ! Get the value in the dictionary from the given key, and evaluate it
  ! as single precision float. The output value is not modified if its
  ! key is not found.
  !---------------------------------------------------------------------
  type(gfits_hdict_t), intent(in)    :: fh
  character(len=*),    intent(in)    :: key
  logical,             intent(out)   :: found
  real(kind=4),        intent(inout) :: value
  logical,             intent(inout) :: error
  ! Local
  integer(kind=4) :: ier
  character(len=80) :: string
  !
  call gfits_find_value(fh,key,found,string,error)
  if (error .or. .not.found)  return
  !
  read(string,*,iostat=ier)  value
  if (ier.ne.0) then
    call gfits_message(seve%e,'FITS','Error decoding '//trim(key)//' = '//trim(string)//' to R*4')
    error = .true.
    return
  endif
  !
end subroutine gfits_get_real
!
subroutine gfits_get_dble(fh,key,found,value,error)
  use gbl_message
  use gfits_interfaces, except_this=>gfits_get_dble
  use gfits_types
  !---------------------------------------------------------------------
  ! @ public-generic gfits_get_value
  ! Get the value in the dictionary from the given key, and evaluate it
  ! as double precision float. The output value is not modified if its
  ! key is not found.
  !---------------------------------------------------------------------
  type(gfits_hdict_t), intent(in)    :: fh
  character(len=*),    intent(in)    :: key
  logical,             intent(out)   :: found
  real(kind=8),        intent(inout) :: value
  logical,             intent(inout) :: error
  ! Local
  integer(kind=4) :: ier
  character(len=80) :: string
  !
  call gfits_find_value(fh,key,found,string,error)
  if (error .or. .not.found)  return
  !
  read(string,*,iostat=ier)  value
  if (ier.ne.0) then
    call gfits_message(seve%e,'FITS','Error decoding '//trim(key)//' = '//trim(string)//' to R*8')
    error = .true.
    return
  endif
  !
end subroutine gfits_get_dble
!
subroutine gfits_get_logi(fh,key,found,value,error)
  use gbl_message
  use gfits_interfaces, except_this=>gfits_get_logi
  use gfits_types
  !---------------------------------------------------------------------
  ! @ public-generic gfits_get_value
  ! Get the value in the dictionary from the given key, and evaluate it
  ! as a logical. The output value is not modified if its key is not
  ! found.
  !---------------------------------------------------------------------
  type(gfits_hdict_t), intent(in)    :: fh
  character(len=*),    intent(in)    :: key
  logical,             intent(out)   :: found
  logical,             intent(inout) :: value
  logical,             intent(inout) :: error
  ! Local
  integer(kind=4) :: ier
  character(len=80) :: string
  !
  call gfits_find_value(fh,key,found,string,error)
  if (error .or. .not.found)  return
  !
  read(string,*,iostat=ier)  value
  if (ier.ne.0) then
    call gfits_message(seve%e,'FITS','Error decoding '//trim(key)//' = '//trim(string)//' to logical')
    error = .true.
    return
  endif
  !
end subroutine gfits_get_logi
!
subroutine gfits_getnosymbol(symb,tran,error)
  !---------------------------------------------------------------------
  ! @ public-mandatory (because symbol is used elsewhere)
  ! No symbol translation. 2 main use cases:
  ! - no symbol dictionary available in the current context, or
  ! - user should not be able to modify the critical elements (e.g.
  !   NAXIS*) needed in the context
  !---------------------------------------------------------------------
  character(len=*), intent(in)  :: symb   ! Symbol name
  character(len=*), intent(in)  :: tran   ! Symbol translation
  logical,          intent(out) :: error  ! Logical error flag
  error = .true.
end subroutine gfits_getnosymbol

subroutine read_allmap(fd,array,nsize,nfill,bval,error)
  use gildas_def
  use gbl_message
  use gfits_interfaces
  use gfits_buf
  use gfits_types
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  ! Read a complete data set from FITS file.
  ! The code cannot be used by pieces. However, avoiding the fits_flush
  ! call at the beginning would make that possible.
  !
  ! Floating point values are read "as is". In particular NaN are
  ! transmitted without change, except for VAX which does not support
  ! NaN: in this case they are replaced by the 'bval' value passed here.
  !---------------------------------------------------------------------
  type(gfits_hdesc_t),       intent(in)    :: fd            !
  integer(kind=size_length), intent(in)    :: nsize         ! Size of array to read
  real(kind=4),              intent(out)   :: array(nsize)  ! Data array
  integer(kind=size_length), intent(out)   :: nfill         ! Number of items effectively read
  real(kind=4),              intent(in)    :: bval          ! Blanking value
  logical,                   intent(inout) :: error         ! Logical error flag
  ! Local
  integer(kind=size_length) :: nbyt
  character(len=message_length) :: mess
  !
100 nbyt = 2880
  call gfits_getbuf(buffer,nbyt,error)
  if ((nbyt.eq.0).or.error) then
    call gfits_message(seve%e,'READ','Error reading FITS file')
    error = .true.
    return
  endif
  if (fd%nbit.eq.8) then
    call byte_to_real(buffer,nbyt,array,nsize,nfill,fd%bscal,fd%bzero)
  elseif (fd%nbit.eq.16) then
    nbyt = nbyt/2
    call int2_to_real(buffer,nbyt,array,nsize,nfill,fd%bscal,fd%bzero)
  elseif (fd%nbit.eq.32) then
    nbyt = nbyt/4
    call int4_to_real(buffer,nbyt,array,nsize,nfill,fd%bscal,fd%bzero)
  elseif (fd%nbit.eq.-32) then
    nbyt = nbyt/4
    call ieee32_to_real(buffer,nbyt,array,nsize,nfill,fd%bscal,fd%bzero,bval)
  elseif (fd%nbit.eq.-64) then
    ! For the time being, degrade double precision FITS to single precision.
    nbyt = nbyt/8
    call ieee64_to_real(buffer,nbyt,array,nsize,nfill,fd%bscal,fd%bzero,bval)
  else
    write(mess,*) 'BITPIX = ',fd%nbit,' not yet supported'
    call gfits_message(seve%e,'FITS',mess)
    error = .true.
    return
  endif
  if (nfill.lt.nsize) goto 100
end subroutine read_allmap
!
subroutine read_subset(fd,array,nsize,odim,iblc,itrc,error,bval)
  use gbl_message
  use image_def  ! for gdf_maxdims...
  use gfits_interfaces
  use gfits_types
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  ! (Reasonably) efficient (but not optimal) way to read a subset of a
  ! FITS file:
  !      1) First define the smallest contiguous subset containing
  !         the desired result
  !      2) Read it at once...
  !      3) Extract the result
  !---------------------------------------------------------------------
  type(gfits_hdesc_t),        intent(inout) :: fd                 !
  integer(kind=size_length),  intent(in)    :: nsize              ! Size of array to read
  real(kind=4),               intent(out)   :: array(nsize)       ! Data array
  integer(kind=index_length), intent(in)    :: odim(gdf_maxdims)  ! Array shape
  integer(kind=index_length), intent(in)    :: iblc(gdf_maxdims)  ! Bottom Left Corner
  integer(kind=index_length), intent(in)    :: itrc(gdf_maxdims)  ! Top Left Corner
  logical,                    intent(inout) :: error              ! Logical error flag
  real(kind=4),               intent(in)    :: bval               ! Blanking value
  !
  ! Local
  integer(kind=size_length) :: nfill,ndata, ioffs
  integer(kind=index_length) :: jblc(gdf_maxdims), jtrc(gdf_maxdims), inof(gdf_maxdims), &
    dimin(gdf_maxdims), dimou(gdf_maxdims)
  integer :: ndim, i, j, ier
  real, allocatable :: myarray(:)
  !
  ! 1) Define smallest contiguous containing subset
  ndim = gdf_maxdims
  do i=1,ndim
    jblc(i) = max(iblc(i),1)
    jtrc(i) = itrc(i)
    if (jtrc(i).eq.0) jtrc(i) = max(odim(i),1)
    inof(i) = jblc(i)
    dimou(i) = jtrc(i)-jblc(i)+1
  enddo
  do i=ndim,1,-1
    if (jblc(i).ne.jtrc(i)) then
      do j=1,i-1
        jblc(j) = 1
        jtrc(j) = odim(j) 
      enddo
      inof(i) = 1
      exit ! Job is done now...
    endif
  enddo
  !
  do i=1,ndim
    dimin(i) = jtrc(i)-jblc(i)+1
  enddo
  !
  ! Get the offset of the subset
  ioffs = 0
  do i=ndim,1,-1
    ioffs = ioffs*odim(i)+jblc(i)-1
  enddo
  !
  ! Skip the number of items. Status of NB unclear ?...
  fd%nb = 2881 ! ?..
  call gfits_skidat(fd,ioffs,error)
  if (error) return
  !
  nfill = 0
  !
  ! Allocate the whole data space...
  ndata = 1
  do i=1,ndim
    ndata = ndata * dimin(i)
  enddo
  allocate (myarray(ndata), stat=ier)
  if (ier.ne.0) then
    error = .true.
    return
  endif
  !
  ! Read it. 
  call gfits_getreal(fd,ndata,myarray,fd%bscal,fd%bzero,error)
  !
  ! Now extract the desired subset...
  if (.not.error) then
    call gfits_extract_bytearray(myarray,ndim,dimin,inof,4, &
    array,ndim,dimou)
  endif
  !
  ! Cleanup
  deallocate(myarray,stat=ier)
  !
end subroutine read_subset
!
subroutine gfits_extract_bytearray(in,ndin,indim,inoff,size,out,ndout,outdim)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ no-interface
  !   Extract a subarray variable with arbitrary bounds and element size
  !   Valid for a maximum of 4 dimensions
  !---------------------------------------------------------------------
  integer(kind=1),            intent(in)    :: in(*)       ! Input value array
  integer(kind=4),            intent(in)    :: ndin        ! Number of dimensions to input variable (unused)
  integer(kind=index_length), intent(in)    :: indim(4)    ! Dimensions of input array
  integer(kind=index_length), intent(in)    :: inoff(4)    ! Offsets of subarray within input array
  integer,                    intent(in)    :: size        ! Size (in bytes) of array elements
  integer(kind=1),            intent(out)   :: out(*)      ! Output buffer
  integer(kind=4)                           :: ndout       ! Number of dimensions of output array (unused)
  integer(kind=index_length), intent(in)    :: outdim(4)   ! Dimensions of output array
  ! Local
  integer(kind=index_length) :: i2,i3,i4
  integer(kind=size_length) :: off_in,off_out
  integer(kind=size_length) :: off_in2,off_out2
  integer(kind=size_length) :: off_in3,off_out3
  integer(kind=size_length) :: off_in4,off_out4
  !
  do i4=1,outdim(4)
    off_in4 = (i4+inoff(4)-2)*indim(3)
    off_out4 = (i4-1)*outdim(3)
    do i3=1,outdim(3)
      off_in3 = (off_in4+(i3+inoff(3)-2))*indim(2)
      off_out3 = (off_out4+(i3-1))*outdim(2)
      do i2=1,outdim(2)
        off_in2 = (off_in3+(i2+inoff(2)-2))*indim(1)
        off_out2 = (off_out3+(i2-1))*outdim(1)
        !
        ! Compress the inner loop
        off_in = (off_in2+(inoff(1)-1))*size+1
        off_out = off_out2*size+1
        out(off_out:off_out+outdim(1)*size-1) = in(off_in:off_in+outdim(1)*size-1)
      enddo
    enddo
  enddo
  !
end subroutine gfits_extract_bytearray

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine gtl_gtv(line,error)
  use gtv_dependencies_interfaces
  use gtv_interfaces, except_this=>gtl_gtv
  use gildas_def
  use gtv_graphic
  !----------------------------------------------------------------------
  ! @ private
  ! Support routine for command GTVL\GTV
  !  - GTV SEARCH Search for the existence of a GTV directory
  !----------------------------------------------------------------------
  character(len=*), intent(in)    :: line   ! Input line
  logical,          intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='GTV'
  integer :: nc,nact
  character(len=filename_length) :: directory
  integer, parameter :: mact=1
  character(len=12) :: name,action,acts(mact)
  data acts /'SEARCH'/
  !
  ! Retrieve action
  call sic_ke(line,0,1,name,nc,.true.,error)
  if (error) return
  !
  ! Resolve ambiguities
  call sic_ambigs(rname,name(1:nc),action,nact,acts,mact,error)
  if (error) return
  !
  ! Do the job
  if (action.eq.'SEARCH') then
    ! Get directory name
    call sic_ch(line,0,2,directory,nc,.true.,error)
    if (error) return
    ! Upcase
    call sic_upper(directory)
    ! Search for the directory existence
    dexist = gtexist(directory)
  endif
  !
end subroutine gtl_gtv
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

program swap
  use gildas_def
  use gkernel_interfaces
  use image_def
  use gbl_format
  !---------------------------------------------------------------------
  !	Mirrors a GDF frame with respect to X or Y axis (2 first dimensions)
  !	and rotate 180 , +90 and -90 .
  !---------------------------------------------------------------------
  ! Local
  character(len=1) :: axis
  character(len=filename_length) :: namey,namex
  logical :: error
  integer :: i, j, iaxis, ier
  type(gildas) :: x,y
  !
  call gildas_open
  call gildas_char('Y_NAME$',namey)
  call gildas_char('X_NAME$',namex)
  call gildas_char('AXIS$',axis)
  call gildas_close
  !
  call gildas_null(y)
  call gdf_read_gildas(y,namey,'.gdf',error,data=.false.)
  if (error) then
    call gagout ('F-SWAP,  Cannot read input file')
    goto 100
  endif
  !
  ! Define the mirroring wanted
  call gildas_null(x)
  call gdf_copy_header(y,x,error)
  call sic_upper(axis)
  if (axis.eq.'X') then
    iaxis = 1
  elseif (axis.eq.'Y') then
    iaxis = 2
  else
    call gagout('F-SWAP,  Unsupported axis '//axis)
    goto 100
  endif
  x%gil%ref(iaxis) =  x%gil%dim(iaxis)-x%gil%ref(iaxis)+1.d0
  x%gil%inc(iaxis) = -x%gil%inc(iaxis)
  !
  ! Create output image
  call sic_parsef(namex,x%file,' ','.gdf')
  call gdf_create_image (x,error)
  if (error) then
    call gagout ('F-SWAP,  Cannot create output file')
    goto 100
  endif
  !
  allocate ( x%r2d(x%gil%dim(1),x%gil%dim(2)), y%r2d(x%gil%dim(1),x%gil%dim(2)), stat=ier) 
  !
  if (iaxis.eq.1) then
    do j=1,x%gil%dim(4)
      x%blc(4) = j 
      x%trc(4) = j
      do i=1,x%gil%dim(3)
        x%blc(3) = i
        x%trc(3) = i
        y%blc = x%blc
        y%trc = x%trc
        call gdf_read_data(y,y%r2d,error)
        if (error) goto 100
        call mirror_1(y%r2d,x%r2d,x%gil%dim(1),x%gil%dim(2))
        call gdf_write_data(x,x%r2d,error)
      enddo
    enddo
  elseif (iaxis.eq.2) then
    do j=1,x%gil%dim(4)
      x%blc(4) = j 
      x%trc(4) = j
      do i=1,x%gil%dim(3)
        x%blc(3) = i
        x%trc(3) = i
        y%blc = x%blc
        y%trc = x%trc
        call gdf_read_data(y,y%r2d,error)
        if (error) goto 100
        call mirror_2(y%r2d,x%r2d,x%gil%dim(1),x%gil%dim(2))
        call gdf_write_data(x,x%r2d,error)
      enddo
    enddo
  endif
  call gagout ('S-SWAP,  Successful completion')
  call sysexi (1)
  !
100 call sysexi (fatale)
end program swap
!
subroutine mirror_1(in,out,nx,ny)
  use gildas_def
  integer(kind=index_length), intent(in) :: nx                     !
  integer(kind=index_length), intent(in) :: ny                     !
  real(4), intent(in) :: in(nx,ny)               !
  real(4), intent(out) :: out(nx,ny)              !
  ! Local
  integer :: j
  !
  do j=1,ny
    out(:,ny-j+1) = in(:,j)
  enddo
end subroutine mirror_1
!
subroutine mirror_2(in,out,nx,ny)
  use gildas_def
  integer(kind=index_length), intent(in) :: nx                     !
  integer(kind=index_length), intent(in) :: ny                     !
  real(4), intent(in) :: in(nx,ny)               !
  real(4), intent(out) :: out(nx,ny)              !
  ! Local
  integer :: i,j
  !
  do j=1,ny
    do i=1,nx
      out(nx-i+1,j) = in(i,j)
    enddo
  enddo
end subroutine mirror_2

subroutine uv_mosaic_comm(line,comm,error)
  use gildas_def
  use gkernel_interfaces
  use gbl_message
  use imager_interfaces, only : map_message, uv_mosaic_group, uv_mosaic_split
  !----------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- Support for command   
  !     UV_MOSAIC Mosaic MERGE|SPLIT [Fields...]
  !
  ! Make a mosaic UV Tables from a set of single field UV tables, 
  ! or vice-versa
  !
  ! The original UV Tables are assumed to have the same number of channels and
  ! 1) either to have the same phase tracking center
  ! 2) or a phase tracking center corresponding to the pointing center
  !----------------------------------------------------------------------
  character(len=*), intent(in) :: line  !! Command line
  character(len=*), intent(in) :: comm  !! Command name
  logical, intent(inout) :: error       !! Error flag
  !
  ! Local ---
  integer(kind=4) :: nf
  character(len=12) :: direction
  character(len=12) :: merge='MERGE'
  character(len=12) :: split='SPLIT'
  !
  ! Code ----
  call sic_ke(line,0,2,direction,nf,.true.,error)
  if (error) return
  nf = min(nf,12)
  !
  if (direction(1:nf).eq.merge(1:nf)) then
    call uv_mosaic_group(line,comm,error)
  else if (direction(1:nf).eq.split(1:nf)) then
    call uv_mosaic_split(line,comm,error)
  else
    call map_message(seve%e,comm,'Second argument must be MERGE or SPLIT')
    error = .true.
  endif
end subroutine uv_mosaic_comm
!
subroutine uv_mosaic_group(line,rname,error)
  use phys_const
  use image_def
  use gbl_message
  use gkernel_types
  use gkernel_interfaces
  use iso_c_binding
  use imager_interfaces, only : map_message
  !----------------------------------------------------------------------
  ! @ private
  !
  !   IMAGER -- Support for command  
  !     UV_MOSAIC Mosaic MERGE Fields [...]
  !
  ! Build a Mosaic from an ensemble of independent fields.
  ! Argument Fields can be a SIC variable handling all the fields filenames.
  !!
  !----------------------------------------------------------------------
  character(len=*), intent(in)    :: line   !! Command line
  character(len=*), intent(in)    :: rname  !! Caller name
  logical,          intent(inout) :: error  !! Error flag
  !
  ! Constants
  integer(kind=4), parameter :: code_mosaic_void=0   ! Mosaic UV table with undecided offsets
  integer(kind=4), parameter :: code_mosaic_phase=1  ! Mosaic UV table with phase offsets
  integer(kind=4), parameter :: code_mosaic_point=2  ! Mosaic UV table with pointing offsets
  real(kind=4), parameter :: point_accuracy=0.1*rad_per_sec   ! Pointing accuracy
  real(kind=4), parameter :: phase_accuracy=0.001*rad_per_sec ! Phase accuracy
  !
  real(kind=4) :: spectral_accuracy  ! Spectral tolerance
  ! Local ---
  type(gildas) :: field
  type(gildas) :: mosaic
  real(kind=4), allocatable :: dmos(:,:)
  real(kind=4), allocatable :: dfield(:,:)
  !
  integer(kind=4) :: ier,nvisi,mvisi
  integer(kind=4) :: jf,nf,iv,it,i_xoff,i_yoff,j_xoff,j_yoff,i_tele,luv
  real(kind=8) :: doffx,doffy
  type(projection_t) :: proj
  !
  integer(kind=4) :: code,code_x,code_y
  !
  real(kind=8) :: a0,d0
  character(len=15) :: chde,chra
  integer :: nchan
  real :: tole
  !
  ! Local
  integer(kind=address_length) :: addr
  character(len=varname_length) :: listname
  character(len=filename_length) :: table_out
  character(len=filename_length), allocatable :: table_in(:)
  type(sic_descriptor_t) :: desc
  real, allocatable :: weight(:), factor(:)
  real(8) :: dummy(3)
  integer, allocatable :: telids(:)
  integer :: i, n, nt, ns, nteles
  logical :: err, found, add_it, cont
  logical :: debug
  !
  ! Initialization
  spectral_accuracy=0.01  ! Default Spectral tolerance
  call sic_get_real('SPECTRAL_ACCURACY',spectral_accuracy,error)
  error = .false.
  !
  debug = .false.
  call sic_get_logi('DEBUG_MOSAIC',debug,error)
  error = .false.
  call gildas_null(field,type='UVT')
  call gildas_null(mosaic,type='UVT')
  !
  ! Sanity check
  ns = sic_narg(0)
  if (ns.lt.3) then
    call map_message(seve%e,rname,'Requires at least 3 arguments')
    error = .true.
    return
  endif
  ns = ns-2
  !
  ! Get the output file name
  call sic_ch(line,0,1,table_out,n,.true.,error)
  if (error) return
  call sic_parse_file(table_out,' ','.uvt',mosaic%file)
  !
  ! Get the input table nameS (1 is acceptable: will add the Trailing column)
  found = .false.
  if (ns.eq.1) then
    ! This may be a character array handling the file names
    call sic_ch(line,0,3,listname,n,.true.,error)
    if (error) return
    call sic_descriptor(listname,desc,found)    
    ! Names from Character array
    if (found) then
      !
      ! Check the Descriptor: it must be a character array
      if (desc%type.lt.1 .or. desc%ndim.ne.1) then
        call map_message(seve%e,rname,trim(listname)//' is not a character array')
        error = .true.
        return
      endif
      ! and it normally should refer to more than 1 file
      nt = desc%dims(1)
      !
      allocate(table_in(nt),weight(nt),factor(nt),stat=ier)
      if (ier.ne.0) then
        call map_message(seve%e,rname,'Memory allocation error')
        return
      endif
      addr = desc%addr
      do i=1,nt
        call destoc(desc%type,addr,table_in(i))
        addr = addr + desc%type
      enddo
    endif
  endif
  !
  if (.not.found) then
    ! Names from Command line
    nt = ns 
    allocate(table_in(nt),weight(nt),factor(nt),stat=ier)
    if (ier.ne.0) then
      call map_message(seve%e,rname,'Memory allocation error')
      return
    endif
    do i=1,nt
      call sic_ch(line,0,i+2,table_in(i),n,.true.,err)
      if (err) return
    enddo
  endif
  if (nt.eq.1) then
    call map_message(seve%w,rname,'Single field mosaic, adding/checking trailing columns')
  endif
  !
  ! Get first header and copy it in output image
  field%file = table_in(1)
  call gdf_read_header(field,error)
  if (error) then
    call map_message(seve%e,rname,'Cannot open '//trim(field%file))
    return
  endif
  call gdf_close_image(field,error)
  if (error) return
  call gdf_copy_header(field,mosaic,error)
  !
  ! Check consistency of headers
  code = code_mosaic_void
  if (abs(field%gil%ra-field%gil%a0).gt.point_accuracy .or. &
    & abs(field%gil%dec-field%gil%d0).gt.point_accuracy) then
    ! Phase & Pointing center differ:
    ! we must check that all fields have a common phase center
    code = code_mosaic_point
  endif
  nvisi = 0
  mvisi = 0
  a0 = 0d0
  d0 = 0d0
  !
  nteles = 0
  !
  ! Store Telescope IDs
  allocate(telids(nt))
  telids = 0
  !
  ! Continuum Mode
  cont = mosaic%gil%nchan.eq.1
  !
  nf = nt
  do jf=1,nf
    ! Read header of field #jf
    field%file = table_in(jf)
    call gdf_read_header(field,error)
    if (error) then
      call map_message(seve%e,rname,'Cannot open '//trim(field%file))
      return
    endif
    call gdf_close_image(field,error)
    if (error) return
    !
    ! Check telescopes
    if (field%gil%nteles.ne.0) then
      add_it = .true.
      do it=1,nteles
        if (mosaic%gil%teles(it)%ctele.eq.field%gil%teles(1)%ctele) then
          add_it = .false.
        endif
      enddo
      if (add_it) then
        nteles = nteles+1
        call gdf_addteles(mosaic,'TELE',field%gil%teles(1)%ctele,dummy,error)
      endif
      telids(jf) = 101*nteles
    endif
    !
    ! Check spectral axis
    if (field%gil%nchan.ne.mosaic%gil%nchan) then
      call map_message(seve%w,rname,'Inconsistent channel number at '//trim(field%file))
      Print *,'Nchan ',field%gil%nchan,mosaic%gil%nchan
      error = .true.
    endif
    if (field%gil%dim(1).ne.mosaic%gil%dim(1)) then
      call map_message(seve%w,rname,'Inconsistent columns at '//trim(field%file))
      Print *,'Dim ',field%gil%dim(1),mosaic%gil%dim(1)
    endif
    !
    if (.not.cont) then
      nchan = max(field%gil%nchan,mosaic%gil%nchan)
      if (abs(field%gil%ref(1)-mosaic%gil%ref(1)).gt.spectral_accuracy) then
        Print *,'Reference       ',field%gil%ref(1), mosaic%gil%ref(1)
        error = .true.
      endif
      tole = spectral_accuracy * max(abs(field%gil%vres),abs(mosaic%gil%vres))
      if (abs(field%gil%voff-mosaic%gil%voff).gt.tole) then
        Print *,'Velocity        ',field%gil%voff, mosaic%gil%voff
        error = .true.
      endif
      tole = tole/nchan
      if (abs(field%gil%vres-mosaic%gil%vres).gt.tole) then
        Print *,'Velo. resolution',field%gil%vres,mosaic%gil%vres
        error = .true.
      endif
      tole = spectral_accuracy * max(abs(field%gil%fres),abs(mosaic%gil%fres))
      if (abs(field%gil%freq-mosaic%gil%freq).gt.tole) then
        Print *,'Frequency       ',field%gil%freq,mosaic%gil%freq
        error = .true.
      endif
      tole = 2*tole/nchan
      if (abs(field%gil%fres-mosaic%gil%fres).gt.tole) then
        Print *,'Freq. resolution',field%gil%fres,mosaic%gil%fres
        error = .true.
      endif
    else
      tole = spectral_accuracy * max(abs(field%gil%fres),abs(mosaic%gil%fres))
      if (abs(field%gil%freq-mosaic%gil%freq).gt.tole) then
        Print *,'Frequency       ',field%gil%freq,mosaic%gil%freq
      endif
    endif
    if (error) then
      call map_message(seve%e,rname,'Inconsistent spectral axis at '//trim(field%file))
      error = .true.
    endif
    !
    ! Check projection
    !!Print *,'jf ',jf,'CODE ',code,' code_mosaic_point ',code_mosaic_point
    if (code.eq.code_mosaic_point) then
      if (debug) Print *,jf,' Pointing '
      if (abs(mosaic%gil%a0-field%gil%a0).gt.phase_accuracy .or. &
           & abs(mosaic%gil%d0-field%gil%d0).gt.phase_accuracy) then
        call map_message(seve%e,rname,'#1 Inconsistent phase center at '//trim(field%file))
        error = .true.
      endif
    else if (code.eq.code_mosaic_phase) then
      if (debug) Print *,jf,' Phase '
      if (abs(field%gil%ra-field%gil%a0).gt.phase_accuracy .or. &
          & abs(field%gil%dec-field%gil%d0).gt.phase_accuracy) then
        call map_message(seve%e,rname,'Phase & Pointing center mismatch at '//trim(field%file))
        error = .true.
      endif
    else if (abs(field%gil%ra-field%gil%a0).gt.point_accuracy .or. &
        abs(field%gil%dec-field%gil%d0).gt.point_accuracy) then
      ! Previously undefined, but phase center differ from pointing center
      ! - must have common phase center
      if (debug) Print *,jf,' Undefined '
      code = code_mosaic_point
      if (abs(mosaic%gil%a0-field%gil%a0).gt.phase_accuracy .or. &
           abs(mosaic%gil%d0-field%gil%d0).gt.phase_accuracy) then
        Print *,'A0 ',mosaic%gil%a0, field%gil%a0, 180*3600/pi*abs(mosaic%gil%a0-field%gil%a0)
        Print *,'D0 ',mosaic%gil%d0, field%gil%d0, 180*3600/pi*abs(mosaic%gil%d0-field%gil%d0)
        call map_message(seve%e,rname,'#2 Inconsistent phase center at '//trim(field%file))
        error = .true.
      endif
    else
      ! Phase and Pointing  centers are equal.
      ! Type is determined from presense of POINT or PHASE offsets
      if (debug) Print *,jf,' Default found from type of offsets      '
      if (field%gil%column_pointer(code_uvt_xoff).ne.0 ) then
        code = code_mosaic_point
      else if (field%gil%column_pointer(code_uvt_loff).ne.0 ) then
        code = code_mosaic_phase
      else
        if (debug) Print *,jf,' No pointer, PHASE by default ?'
        code = code_mosaic_phase
      endif 
    endif
    a0 = a0+field%gil%ra
    d0 = d0+field%gil%dec
    if (error) return
    !
    ! Update Baseline lengthsbm%blmin
    mosaic%gil%basemin = min(mosaic%gil%basemin,field%gil%basemin)
    mosaic%gil%basemax = max(mosaic%gil%basemax,field%gil%basemax)
    ! Iterate visibility sizes
    nvisi = nvisi + field%gil%nvisi
    mvisi = max(mvisi,field%gil%dim(2))
  enddo ! jf
  a0 = a0/nf
  d0 = d0/nf
  !
  ! Prepare the mosaic UV table
  mosaic%gil%nvisi = nvisi
  mosaic%gil%dim(2) = nvisi
  !
  ! There may be problems if a column of the other type is already
  ! present in the initial UV table...
  if (nf.eq.1) then
    ! Single file transformed into a Degenerate Pointing Mosaic
    if (debug) then
      Print *,'XOFF ',mosaic%gil%column_pointer(code_uvt_xoff) &
        & ,' YOFF ',mosaic%gil%column_pointer(code_uvt_yoff)
      Print *,'LOFF ',mosaic%gil%column_pointer(code_uvt_loff) &
        & ,' MOFF ',mosaic%gil%column_pointer(code_uvt_moff)
      Print *,'IDOFF ',mosaic%gil%column_pointer(code_uvt_id) 
    endif 
    if (mosaic%gil%column_pointer(code_uvt_xoff).eq.0) then
      if (mosaic%gil%column_pointer(code_uvt_loff).ne.0) then
        mosaic%gil%column_pointer(code_uvt_xoff) = &
         & mosaic%gil%column_pointer(code_uvt_loff)               
        mosaic%gil%column_pointer(code_uvt_loff) = 0              
        code_x = code_uvt_xoff
        mosaic%gil%column_size(code_uvt_loff) = 0
        mosaic%gil%column_size(code_x) = 1
      else if (mosaic%gil%column_pointer(code_uvt_id).ne.0) then
        mosaic%gil%column_pointer(code_uvt_xoff) = &
         & mosaic%gil%column_pointer(code_uvt_id)               
        mosaic%gil%column_pointer(code_uvt_id) = 0              
        code_x = code_uvt_xoff
        mosaic%gil%column_size(code_uvt_id) = 0
        mosaic%gil%column_size(code_x) = 1
      else 
        code_x = code_uvt_xoff
      endif
    else
      code_x = code_uvt_xoff
    endif
    if (mosaic%gil%column_pointer(code_uvt_yoff).eq.0) then
      if (mosaic%gil%column_pointer(code_uvt_moff).ne.0) then
        mosaic%gil%column_pointer(code_uvt_yoff) = &
         & mosaic%gil%column_pointer(code_uvt_moff)               
        mosaic%gil%column_pointer(code_uvt_moff) = 0              
        mosaic%gil%column_size(code_uvt_moff) = 0
        code_y = code_uvt_yoff
        mosaic%gil%column_size(code_y) = 1
      else
        code_y = code_uvt_yoff
      endif
    else
      code_y = code_uvt_yoff
    endif
    if (debug) then
      Print *,'XOFF ',mosaic%gil%column_pointer(code_uvt_xoff) &
        & ,' YOFF ',mosaic%gil%column_pointer(code_uvt_yoff)
      Print *,'LOFF ',mosaic%gil%column_pointer(code_uvt_loff) &
        & ,' MOFF ',mosaic%gil%column_pointer(code_uvt_moff)
      Print *,'IDOFF ',mosaic%gil%column_pointer(code_uvt_id) 
    endif
    !
    code = code_mosaic_point ! Now for sure ?
  else if (code.eq.code_mosaic_point) then
    if (debug) Print *,'Found CODE_MOSAIC_POINT ',jf
    code_x = code_uvt_xoff
    code_y = code_uvt_yoff
    if ((mosaic%gil%column_pointer(code_uvt_loff).ne.0) .or. &
        (mosaic%gil%column_pointer(code_uvt_moff).ne.0)) then
      error = .true.
    endif
  else 
    if (debug) Print *,'Found CODE_MOSAIC_PHASE ',jf
    code_x = code_uvt_loff
    code_y = code_uvt_moff
    if ((mosaic%gil%column_pointer(code_uvt_xoff).ne.0) .or. &
        (mosaic%gil%column_pointer(code_uvt_yoff).ne.0)) then
      error = .true.
    endif
  endif
  if (error) then
    if (debug) then
      Print *,'Code ',code,' Point ',code_mosaic_point
      Print *,'Codes ',code_x,code_y
    endif
    call map_message(seve%e,rname,'Combination of PHASE_OFF and POINT_OFF not allowed')
    return
  endif
  ! Add or reuse the offset columns
  if ((nf.eq.1).and.debug) Print *,'code_x ',code_x,code_y
  if (mosaic%gil%column_pointer(code_x).eq.0) then
    mosaic%gil%dim(1) = mosaic%gil%dim(1)+1
    mosaic%gil%column_pointer(code_x) = mosaic%gil%dim(1)
    mosaic%gil%column_size(code_x) = 1
  endif
  if (mosaic%gil%column_pointer(code_y).eq.0) then
    mosaic%gil%dim(1) = mosaic%gil%dim(1)+1
    mosaic%gil%column_pointer(code_y) = mosaic%gil%dim(1)
    mosaic%gil%column_size(code_y) = 1
  endif
  if (nteles.ne.0) then
    if (mosaic%gil%column_pointer(code_uvt_tele).eq.0) then
      mosaic%gil%dim(1) = mosaic%gil%dim(1)+1
      mosaic%gil%column_pointer(code_uvt_tele) = mosaic%gil%dim(1)
      mosaic%gil%column_size(code_uvt_tele) = 1
    endif
    i_tele = mosaic%gil%column_pointer(code_uvt_tele)
  else 
    i_tele = 0
  endif
  !
  i_xoff = mosaic%gil%column_pointer(code_x)
  i_yoff = mosaic%gil%column_pointer(code_y)
  if ((nf.eq.1).and.debug) then
    Print *,'Code ',code,code_mosaic_phase
    Print *,'Code_X ',code_x,' I_xoff ',i_xoff
    Print *,'Code_Y ',code_y,' I_xoff ',i_yoff
  endif
  ! Define the projection center for the offset columns
  if (code.eq.code_mosaic_phase) then
    mosaic%gil%a0 = a0
    mosaic%gil%d0 = d0
  endif
  mosaic%gil%ra = mosaic%gil%a0
  mosaic%gil%dec = mosaic%gil%d0
  call gwcs_projec(mosaic%gil%a0,mosaic%gil%d0,mosaic%gil%pang,mosaic%gil%ptyp,proj,error)
  !
  ! Allocate visibility buffers
  allocate(dmos(mosaic%gil%dim(1),nvisi), stat=ier)
  if (failed_allocate(rname,'Mosaic uv table',ier,error)) return
  allocate(dfield(field%gil%dim(1),mvisi), stat=ier)
  if (failed_allocate(rname,'Field uv table',ier,error)) return
  !
  ! Create, fill, and write the mosaic UV table
  call gdf_create_image(mosaic,error)
  if (error) return
  field%blc = 0
  field%trc = 0
  mosaic%blc = 0
  mosaic%trc = 0
  do jf=1,nf
    field%file = table_in(jf)
    call gdf_read_header(field,error)
    if (error) return
    !
    j_xoff = field%gil%column_pointer(code_x)
    j_yoff = field%gil%column_pointer(code_y)
    call abs_to_rel(proj,field%gil%ra,field%gil%dec,doffx,doffy,1)
    call gdf_read_data(field,dfield,error)
    if (error) return
    call gdf_close_image(field,error)
    if (error) return
    luv = field%gil%dim(1)
    !
    do iv=1,field%gil%nvisi
      dmos(1:luv,iv) = dfield(1:luv,iv)
      dmos(i_xoff,iv) = doffx
      dmos(i_yoff,iv) = doffy
      ! Add the appropriate local offsets if any
      if (j_xoff.ne.0) dmos(i_xoff,iv) = doffx+dfield(j_xoff,iv)
      if (j_yoff.ne.0) dmos(i_yoff,iv) = doffy+dfield(j_yoff,iv)
      if (i_tele.ne.0) dmos(i_tele,iv) = telids(jf)
    enddo
    !
    mosaic%blc(2) = mosaic%trc(2)+1
    mosaic%trc(2) = mosaic%blc(2)+field%gil%nvisi-1
    !
    call gdf_write_data(mosaic,dmos,error)
    if (error) return
  enddo
  call gdf_close_image(mosaic,error)
  if (error) return
  !
  call rad2sexa (mosaic%gil%a0,24,chra)
  call rad2sexa (mosaic%gil%d0,360,chde)
  call map_message(seve%i,rname,'Mosaic center is '//chra//' '//chde)
end subroutine uv_mosaic_group
!
subroutine uv_mosaic_split(line,rname,error)
  use phys_const
  use gkernel_interfaces
  use gkernel_types
  use image_def
  use gbl_message
  use imager_interfaces, only : map_message
  !----------------------------------------------------------------------
  ! @ private
  !*
  !   IMAGER -- Support for command  
  !     UV_MOSAIC Mosaic SPLIT [Fields]
  !
  ! Explode a Mosaic to an ensemble of NF single fields
  ! with a name following the convention 'Fields'-'i'
  !!
  !----------------------------------------------------------------------
  character(len=*), intent(in)    :: rname  ! Command name
  character(len=*), intent(in)    :: line   !! Command line
  logical,          intent(inout) :: error  !! Errorflag
  !
  ! Constants
  integer(kind=4), parameter :: code_mosaic_phase=1  ! Mosaic UV table with phase offsets
  integer(kind=4), parameter :: code_mosaic_point=2  ! Mosaic UV table with pointing offsets
  !
  ! Local ---
  type(gildas) :: field
  type(gildas) :: mosaic
  real(kind=4), allocatable :: dmos(:,:)
  real(kind=4), allocatable :: dfield(:,:)
  character(len=filename_length) :: name
  character(len=filename_length) :: generic
  !
  integer(kind=4) :: code,ier
  integer(kind=4) :: nlast,mvisi
  integer(kind=4) :: jv,iv,ifi,kfi,nfi,mfi
  integer(kind=4) :: loff,moff,xoff,yoff,xcol,ycol
  real(kind=8) :: doffx,doffy,ra,dec
  real(kind=8), allocatable :: doff(:,:),dtmp(:,:)
  type(projection_t) :: proj
  !
  ! Code ----
  call gildas_null(field,type='UVT')
  call gildas_null(mosaic,type='UVT')
  !
  ! Get mosaic header and copy it to the field header
  call sic_ch(line,0,1,generic,jv,.true.,error)
  if (error) return
  call sic_parse_file(generic,' ','.uvt',mosaic%file)
  call gdf_read_header(mosaic,error)
  if (error) then
    call map_message(seve%e,rname,'Cannot open '//trim(mosaic%file))
    return
  endif
  !
  ! Check mosaic kind
  loff = mosaic%gil%column_pointer(code_uvt_loff)
  moff = mosaic%gil%column_pointer(code_uvt_moff)
  xoff = mosaic%gil%column_pointer(code_uvt_xoff)
  yoff = mosaic%gil%column_pointer(code_uvt_yoff)
  if ((loff.ne.0).and.(moff.ne.0)) then
    call map_message(seve%i,rname,'Input UV table is a Phase offset mosaic')
    xcol = loff
    ycol = moff
    code = code_mosaic_phase
  else if ((xoff.ne.0).and.(yoff.ne.0)) then
    call map_message(seve%i,rname,'Input UV table is a Pointing offset mosaic')
    xcol = xoff
    ycol = yoff
    code = code_mosaic_point
  else
    call map_message(seve%e,rname,'Input UV table is not a mosaic (No XY or LM offset columns)')
    error = .true.
    return
  endif
  !
  ! Prepare the Field headers
  call gdf_copy_header(mosaic,field,error)
  if (error) return
  call sic_ch(line,0,3,generic,jv,.false.,error)
  if (error) return
  !
  ! Get rid of the trailing columns if possible. Just verify
  ! that ntrail is 2, and that these are the two appropriate
  ! columns
  if (field%gil%ntrail.eq.2) then
    if (((xcol.eq.field%gil%lcol+1) .and. &
        (ycol.eq.field%gil%lcol+2)) .or. &
       ((xcol.eq.field%gil%lcol+2) .and. &
        (ycol.eq.field%gil%lcol+1))) then
      if (code.eq.code_mosaic_point) then
        field%gil%column_pointer(code_uvt_xoff) = 0
        field%gil%column_pointer(code_uvt_yoff) = 0
        field%gil%column_size(code_uvt_xoff) = 0
        field%gil%column_size(code_uvt_yoff) = 0
      else
        field%gil%column_pointer(code_uvt_loff) = 0
        field%gil%column_pointer(code_uvt_moff) = 0
        field%gil%column_size(code_uvt_loff) = 0
        field%gil%column_size(code_uvt_moff) = 0
      endif
    endif
    field%gil%ntrail = 0
    field%gil%dim(1) = field%gil%lcol
    nlast = field%gil%lcol
  else
    nlast = field%gil%dim(1)
  endif
  !
  ! Read data
  allocate(dmos(mosaic%gil%dim(1),mosaic%gil%dim(2)),stat=ier)
  if (failed_allocate(rname,'Mosaic uv table',ier,error)) return
  call gdf_read_data(mosaic,dmos,error)
  if (error) return
  !
  ! Scan the list of offset
  doffx = dmos(xcol,1)
  doffy = dmos(ycol,1)
  nfi = 1
  mfi = 100
  allocate(doff(3,mfi),stat=ier)
  doff(1,1) = doffx
  doff(2,1) = doffy
  doff(3,1) = 1
  do iv=2,mosaic%gil%nvisi
    kfi = 0
    do ifi=1,nfi
      if (dmos(xcol,iv).eq.doff(1,ifi) .and. &
          dmos(ycol,iv).eq.doff(2,ifi)) then
         kfi = ifi
         doff(3,kfi) = doff(3,kfi)+1
         exit
      endif
    enddo ! ifi
    ! New field => Initialize
    if (kfi.eq.0) then
      if (nfi.eq.mfi) then
        allocate(dtmp(3,2*mfi),stat=ier)
        dtmp(:,1:mfi) = doff(:,:)
        deallocate(doff)
        allocate(doff(3,2*mfi),stat=ier)
        doff(:,:) = dtmp
        deallocate(dtmp)
        mfi = 2*mfi
      endif
      nfi = nfi+1
      doff(1,nfi) = dmos(xcol,iv)
      doff(2,nfi) = dmos(ycol,iv)
      doff(3,nfi) = 1
    endif
  enddo ! iv
  !
  ! Allocate enough space for field uv table
  mvisi = 0
  do ifi=1,nfi
    mvisi = max(nint(doff(3,ifi)),mvisi)
  enddo
  allocate(dfield(nlast,mvisi),stat=ier)
  if (failed_allocate(rname,'Field uv table',ier,error)) return
  !
  ! Create, fill, and write the output UV tables
  call gwcs_projec(mosaic%gil%a0,mosaic%gil%d0,mosaic%gil%pang,mosaic%gil%ptyp,proj,error)
  if (error) return
  do ifi=1,nfi
    write(name,'(A,I0)') trim(generic)//'-',ifi
    call sic_parse_file(name,' ','.uvt',field%file)
    field%gil%nvisi = doff(3,ifi)
    field%gil%dim(2) = field%gil%nvisi
    call rel_to_abs(proj,doff(1,ifi),doff(2,ifi),ra,dec,1)
    field%gil%ra = ra
    field%gil%dec = dec
    if (code.eq.code_mosaic_phase) then
      field%gil%a0 = ra
      field%gil%d0 = dec
    endif
    !
    jv = 0
    do iv=1,mosaic%gil%nvisi
      if ((dmos(xcol,iv).eq.doff(1,ifi)) .and. &
        & (dmos(ycol,iv).eq.doff(2,ifi))) then
        jv = jv+1
        dfield(1:nlast,jv) = dmos(1:nlast,iv)
      endif
    enddo
    field%gil%nvisi = jv
    !
    call gdf_create_image(field,error)
    if (error) return
    field%blc = 0
    field%trc = 0
    call gdf_write_data(field,dfield,error)
    if (error) return
    call gdf_close_image(field,error)
    if (error) return
  enddo ! ifi
end subroutine uv_mosaic_split

module gkernel_interfaces
  use ginc_interfaces_public
  use gsys_interfaces_public
  use gsys_interfaces_public_c
  use gmath_interfaces_public
  use gwcs_interfaces_public
  use gfits_interfaces_public
  use gio_interfaces_public
  use ggui_interfaces_public_c
  use sic_interfaces_public
  use gtv_interfaces_public
  use greg_interfaces_public
end module gkernel_interfaces

subroutine gtinit(sx,sy,lunt,lunh,main,greg_user,error)
  use gildas_def
  use gbl_message
  use gtv_dependencies_interfaces
  use gtv_interfaces, except_this=>gtinit
  use gtv_bitmap
  use gtv_buffers
  use gtv_colors
  use gtv_graphic
  use gtv_plot
  use gtv_protocol
  use gtv_segatt
  use gtv_tree
  !---------------------------------------------------------------------
  ! @ public
  ! Initializes the GTVIRT on a blank world space
  !---------------------------------------------------------------------
  real(kind=4),     intent(in)    :: sx     ! World space in X [0...SX]
  real(kind=4),     intent(in)    :: sy     ! World space in Y [0...SY]
  integer(kind=4),  intent(in)    :: lunt   ! Logical unit number for terminal
  integer(kind=4),  intent(in)    :: lunh   ! Logical unit number for hardcopy. Unused.
  character(len=*), intent(in)    :: main   ! Main directory name
  external :: greg_user  ! Address of a routine to get user coordinates transformation
  logical,          intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='GTINIT'
  integer(kind=bitmap_depth) :: bitmap
  type(greg_values) :: tab_greg
  !
  if (awake) then
    call gtv_message(seve%e,rname,'Programming error: multiple call to the initialization routine')
    error = .true.
    return
  endif
  !
  ! World area
  phys_sizex_def = sx
  phys_sizey_def = sy
  !
  call sic_defstructure('GTV',.true.,error)
  call sic_def_inte('GTV%NIMA',nb_image,0,0,.true.,error)
  !
  ! Awake the library. This is done only once during a process's life.
  call gtnone
  !
  ! Setup some default values. This is needed because some inializations in
  ! this routine rely on the device values (e.g. background color) while we
  ! do not have yet loaded a device!
  cw_output%color = .true.
  cw_output%background = 1  ! White
  !
  ! Default segment attributes at startup
  cattr%dash   = 1                     ! Continuous
  cattr%weight = graisse(1)            !
  cattr%colour = pen_color_foreground  ! Foreground
  cattr%depth  = 1                     ! First level
  !
  ! Load the language
  call load_gtvl
  !
  ! Define some basic variable
  call sic_def_logi('GTV%NOFAIL',nofail,.false.,error)
  call sic_def_logi('GTV%STDOUT',stdout,.false.,error)
  call sic_def_logi('GTV%FITPAGE',fitpage,.false.,error)
  call sic_def_logi('GTV%EXIST',dexist,.false.,error)
  call sic_def_logi('GTV%STRICT2011',strict2011,.false.,error)
  call sic_def_char('GTV%PWD',pwd,.true.,error)
  call sic_def_char('GTV%DEVICE',gtv_device,.true.,error)
  call sic_def_charn('GTV%DEVICES',device_list,1,1+ndevices,.true.,error)
  call sic_def_charn('GTV%COLORS',pen_colors,1,pen_ncolors,.true.,error)
  if (error) then
    call gtv_message(seve%f,rname,'Failed to initialize GTV% variables')
    call sysexi(fatale)
  endif
  !
  awake = .true.
  call gtx_reset
  !
  ! Get IUNIT
  cw_output%tofile = .true.
  cw_output%iunit = lunt
  !
  ! Define main directory name
  top_dir = main
  !
  ! Save GREG_USER routine address
  gt_greg_user => greg_user
  flag_greg = associated(gt_greg_user)  ! Always true...
  cdepth = 0
  vdepth(:) = .false.
  !
  ! Prepare the colormaps and bitmaps related variables
  bitmap = 0  ! Dummy value to avoid compiler warning
  bitmap_dynamic_max = (huge(bitmap)+1)*2
  !
  ! Load the Colormap and Pen luts
  call init_lut(error)
  if (error)  return
  call init_pen(error)
  if (error)  return
  !
  ! Full clear (internal metacode and interactive screen)
  call gtv_destroy_all(error)
  if (error)  return
  !
  ! Initialisation des constantes Greg pour la racine
  if (flag_greg) call get_greg_values(tab_greg)
  call attach_greg_values(root,tab_greg,error)
  if (error)  return
  !
  ! Initialisation des constantes Greg pour le premier repertoire
  call attach_greg_values(root%son_first,tab_greg,error)
  if (error) return
  !
end subroutine gtinit
!
subroutine gt_setphysical(sx,sy,error)
  use gtv_buffers
  use gtv_graphic
  use gtv_interfaces, except_this=>gt_setphysical
  use gtv_protocol
  use gtv_types
  !---------------------------------------------------------------------
  !  @ public
  !  Reset the physical size of the current tree (only): top directory
  ! must be emptied and use the new values before storing anything. Next
  ! top directories will also use these values.
  !  In practice, this is done like this:
  !   1) go to top directory
  !   2) empty top directory
  !   3) set new physical size of top directory in GTV
  !   4) store new physical size of top directory in GREG (callback)
  !---------------------------------------------------------------------
  real(kind=4), intent(in)    :: sx     ! World space in X [0...SX]
  real(kind=4), intent(in)    :: sy     ! World space in X [0...SX]
  logical,      intent(inout) :: error  ! Logical error flag
  ! Local
  logical :: keepall
  type(gt_directory), pointer :: topdir
  !
  ! World area
  phys_sizex_def = sx
  phys_sizey_def = sy
  !
  ! Go to top directory
  topdir => cw_directory%ancestor
  call gtv_open_segments_for_writing_from_main()
  call cd_by_adr(topdir,topdir%x%curwin,error)
  call gtv_close_segments_for_writing_from_main()
  if (error)  return
  !
  ! Clear its content
  keepall = .false.
  call gt_clear_directory(topdir,keepall,error)
  if (error)  return
  call gtview_update(topdir,error)  ! Update the windows which see 'topdir'
  if (error)  return
  !
  call gtv_open_segments_for_writing_from_main()
  !
  ! Reset its physical size
  topdir%phys_size(1) = phys_sizex_def
  topdir%phys_size(2) = phys_sizey_def
  !
  ! Undefined MINMAX information
  topdir%gen%minmax(1) = phys_sizex_def
  topdir%gen%minmax(2) = 0.0
  topdir%gen%minmax(3) = phys_sizey_def
  topdir%gen%minmax(4) = 0.0
  !
  ! Transmit new values to Greg
  if (flag_greg) then
    call attach_greg_values(cw_directory,cw_directory%val_greg,error)  ! Update val_greg
    call send_greg_values(cw_directory%val_greg)
  endif
  !
  call gtv_close_segments_for_writing_from_main()
  !
  ! Reset clipping area
  call sp_gtwindow(cw_output,0.0,phys_sizex_def,0.0,phys_sizey_def)
  !
end subroutine gt_setphysical
!
subroutine gtpolyl(n,vx,vy,error)
  use gtv_interfaces, except_this=>gtpolyl
  use gtv_tree
  use gtv_buffers
  use gtv_graphic
  !---------------------------------------------------------------------
  ! @ private-mandatory (because symbol is used elsewhere)
  !  Connects points (world coordinates).
  !  GTPOLYL has no effect for N less than 1.
  !  GTPOLYL behaves like GTRELOC for N equal to 1.
  !  Much more efficient than calls to GTRELOC and GTDRAW when N is
  ! substancially larger than 2.
  !---------------------------------------------------------------------
  integer, intent(in)    :: n      ! Number of points
  real*4,  intent(in)    :: vx(n)  ! Array of abscissae
  real*4,  intent(in)    :: vy(n)  ! Array of ordinates
  logical, intent(inout) :: error  ! Logical error flag
  !
  if (.not.awake .or. error_condition) return
  !
  ! Flush POLYL%X and POLYL%Y buffers if they are not empty
  call gtx_frxry(error)
  if (error) return
  !
  ! N is less than 2.
  if (n.lt.2) then
    if (n.lt.1) return
    polyl%x(1) = vx(1)
    polyl%y(1) = vy(1)
    return
  endif
  !
  ! Store the new values in POLYL
  polyl%x(1:n) = vx(1:n)
  polyl%y(1:n) = vy(1:n)
  polyl%n = n
  !
  ! Flush the new values into the tree
  call gtx_frxry(error)
  if (error) return
  !
end subroutine gtpolyl
!
subroutine gtx_frxry(error)
  use gtv_interfaces, except_this=>gtx_frxry
  use gtv_tree
  use gtv_buffers
  use gtv_graphic
  use gtv_plot
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! Flushes POLYL%X and POLYL%Y buffers into internal metacode.
  !
  !  CAUTION !!!
  !   The indirect return happens if the ERROR_CONDITION flag is set.
  ! This flag may have been set previously by another error condition.
  ! Thus the calling program SHOULD be inactive if he is called with
  ! the error_condition flag set.
  ! ---
  !   Threads status: thread safe
  !---------------------------------------------------------------------
  logical, intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='GTX_FRXRY'
  integer :: ier
  !
  error = .false.
  if (error_condition) then
    error = .true.
    return
  endif
  !
  if (.not.associated(co_segment)) then
    call gtv_message(seve%e,rname,'Programming error: no segment opened')
    error = .true.
    return
  endif
  !
  ! Nothing to do if less than 2 points in the buffer
  if (polyl%n.le.1)  return
  !
  ! Do we need to save the current PENLUT in the metacode before starting
  ! to write the polyline?
  if (lut_static) then
    if (.not.associated(co_segment%head%lut)) then
      ! We have to save to current global PENLUT in the metacode
      call gt_penlut_segdata(error)  ! This sets co_segment%head%lut
      if (error)  return
    endif
  endif
  !
  ! Update MINMAX
  co_segment%head%gen%minmax(1) = min(minval(polyl%x(1:polyl%n)),co_segment%head%gen%minmax(1))
  co_segment%head%gen%minmax(2) = max(maxval(polyl%x(1:polyl%n)),co_segment%head%gen%minmax(2))
  co_segment%head%gen%minmax(3) = min(minval(polyl%y(1:polyl%n)),co_segment%head%gen%minmax(3))
  co_segment%head%gen%minmax(4) = max(maxval(polyl%y(1:polyl%n)),co_segment%head%gen%minmax(4))
  !
  call gtv_open_segments_for_writing_from_main()
  !
  if (.not.associated(co_segment_data)) then
    allocate(co_segment%data,stat=ier)
    if (ier.ne.0) then
      call gtv_message(seve%e,rname,'Internal error: allocation failure (1)')
      error = .true.
      goto 10
    endif
    co_segment_data => co_segment%data
  else
    allocate(co_segment_data%nextdata,stat=ier)
    if (ier.ne.0) then
      call gtv_message(seve%e,rname,'Internal error: allocation failure (2)')
      error = .true.
      goto 10
    endif
    co_segment_data => co_segment_data%nextdata
  endif
  co_segment_data%nextdata => null()
  !
  allocate(co_segment_data%poly%x(polyl%n),co_segment_data%poly%y(polyl%n),stat=ier)
  if (ier.ne.0) then
    call gtv_message(seve%e,rname,'Internal error: allocation failure (3)')
    error = .true.
    goto 10
  endif
  co_segment_data%kind = seg_poly
  co_segment_data%poly%n = polyl%n
  co_segment_data%poly%x = polyl%x(1:polyl%n)
  co_segment_data%poly%y = polyl%y(1:polyl%n)
  co_segment_data%poly%penlut => co_segment%head%lut  ! Which can be null()
  !
  ! Update POLYL%X and POLYL%Y
  polyl%x(1) = polyl%x(polyl%n)
  polyl%y(1) = polyl%y(polyl%n)
  polyl%n = 1
  !
10 continue
  !
  call gtv_close_segments_for_writing_from_main()
  !
end subroutine gtx_frxry
!
subroutine gtreloc(x,y)
  use gtv_interfaces, except_this=>gtreloc
  use gtv_tree
  use gtv_buffers
  use gtv_graphic
  !---------------------------------------------------------------------
  ! @ public-mandatory (because symbol is used elsewhere)
  !
  !	Relocates the virtual pen to (X,Y)
  !	X,Y	World coordinates			Real*4
  !---------------------------------------------------------------------
  real*4 :: x                       !
  real*4 :: y                       !
  ! Local
  logical :: error
  !
  if (.not.awake .or. error_condition) return
  !
  if (x.eq.polyl%x(polyl%n) .and. y.eq.polyl%y(polyl%n)) return  ! Is this useful ?
  !
  error = .false.
  !
  ! Flush POLYL%X and POLYL%Y buffers
  call gtx_frxry(error)
  if (error) return
  !
  ! Relocate
  polyl%x(1) = x
  polyl%y(1) = y
  !
end subroutine gtreloc
!
subroutine gtdraw(x,y)
  use gtv_interfaces, except_this=>gtdraw
  use gtv_tree
  use gtv_buffers
  use gtv_graphic
  !---------------------------------------------------------------------
  ! @ public-mandatory (because symbol is used elsewhere)
  !
  !	Draws to (X,Y)
  !	X,Y	World coordinates			Real*4
  !---------------------------------------------------------------------
  real*4 :: x                       !
  real*4 :: y                       !
  ! Local
  logical :: error
  !
  if (.not.awake .or. error_condition) return
  !
  error = .false.
  !
  ! Test if POLYL%X and POLYL%Y buffers are full
  if (polyl%n.eq.nrdim) then
    call gtx_frxry(error)
    if (error) return
  endif
  !
  ! Append (X,Y) to POLYL%X and POLYL%Y
  polyl%n = polyl%n+1
  polyl%x(polyl%n) = x
  polyl%y(polyl%n) = y
end subroutine gtdraw
!
subroutine dir_extrema(dir,minmax)
  use gtv_tree
  use gtv_buffers
  use gtv_interfaces, except_this=>dir_extrema
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  !   Updates the minmax values of the directory given in input (compose
  ! the areas).
  !---------------------------------------------------------------------
  type(gt_directory), intent(inout) :: dir        ! The directory to be updated
  real(kind=4),       intent(in)    :: minmax(4)  ! The new minmax values
  !
  dir%gen%minmax(1) = min(minmax(1),dir%gen%minmax(1))  ! xmin
  dir%gen%minmax(2) = max(minmax(2),dir%gen%minmax(2))  ! xmax
  dir%gen%minmax(3) = min(minmax(3),dir%gen%minmax(3))  ! ymin
  dir%gen%minmax(4) = max(minmax(4),dir%gen%minmax(4))  ! ymax
  !
end subroutine dir_extrema
!
subroutine gtsegm(name,error)
  use gtv_tree
  use gtv_buffers
  use gtv_graphic
  use gtv_interfaces, except_this=>gtsegm
  use gbl_message
  !---------------------------------------------------------------------
  ! @ public
  !   Initialise a new segment with the current line attributes. No
  ! action if the current segment is empty (except making the
  ! Attribute(4) positive, i.e. visible).
  ! ---
  !   Threads status: thread safe
  !---------------------------------------------------------------------
  character(len=*), intent(in)  :: name   ! Name of the new segment
  logical,          intent(out) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='GTSEGM'
  integer :: sever
  character(len=message_length) :: mess
  !
  if (.not.awake .or. error_condition) return
  !
  error = .false.  ! Making error 'inout' would require to check all
                   ! calling routines in the outworld.
  !
  if (associated(co_segment)) then
    if (strict2011) then
      sever = seve%e
    else
      sever = seve%w
    endif
    write(mess,'(3A)')  'Attempt to create a new segment "',trim(name),'"'
    call gtv_message(sever,rname,mess)
    write(mess,'(3A)')  'while the previous (',trim(co_segment%head%gen%name),') is not closed'
    call gtv_message(sever,rname,mess)
    call gtv_message(sever,rname,  &
      'Programmer: call ''gr_segm_close(error)'' to close the previous segment')
    if (strict2011) then
      error = .true.
      return
    endif
    ! Close the segment currently opened. Should not be automatic in the
    ! future, i.e. always raise an error.
    call gtsegm_close(error)  ! Write protected
    if (error)  return
  endif
  !
  ! Par convention la racine de l'arbre n'a pas de feuilles. Decision
  ! scandaleuse et arbitraire, prise avec P.Valiron. Or donc, si le
  ! repertoire courant est < ....
  if (associated(cw_directory,root)) then
    call gtv_message(seve%e,rname,'Can not create leaf under root <')
    error = .true.
    return
  endif
  !
  call gtsegm_create(name,cw_directory,error)
  if (error)  return
  !
end subroutine gtsegm
!
subroutine gtsegm_create(name,parent,error)
  use gbl_message
  use gtv_buffers
  use gtv_interfaces, except_this=>gtsegm_create
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  character(len=*),   intent(in)    :: name    ! Segment name
  type(gt_directory), pointer       :: parent  ! Parent directory
  logical,            intent(inout) :: error   ! Logical error flag
  ! Local
  character(len=segname_length) :: nom_seg
  integer :: segnum
  character(len=10) :: suffix
  !
  ! Generation d'un nom de segment
  segnum = parent%segn+1
  !
  if (segnum .le. 9) then
    write(suffix,100) segnum
  elseif (segnum .le. 99) then
    write(suffix,101) segnum
  elseif (segnum .le. 999) then
    write(suffix,102) segnum
  elseif (segnum .le. 9999) then
    write(suffix,103) segnum
  elseif (segnum .le. 99999) then
    write(suffix,104) segnum
  elseif (segnum .le. 999999) then
    write(suffix,105) segnum
  endif
  if (len_trim(name)+len_trim(suffix).gt.segname_length) then
    call gtv_message(seve%e,'GTSEGM','Name too long')
    error = .true.
    return
  endif
  nom_seg = trim(name)//suffix
  call sic_upper(nom_seg)
  !
  call gtv_open_segments_for_writing_from_main()
  !
  ! Reset the global pointers
  co_segment => gtv_newsegment(error)
  if (error)  return
  co_segment_data => null()
  co_segment%data => null()
  !
  ! Current line attributes
  co_segment%head%attr = cattr
  vdepth(cattr%depth) = .true.
  ! Old or new, the segment must be viewable:
  co_segment%head%gen%visible = .true.
  !
  ! Undefined MINMAX information. Get paper size from parent
  co_segment%head%gen%minmax(1) = parent%phys_size(1)
  co_segment%head%gen%minmax(2) = 0.0
  co_segment%head%gen%minmax(3) = parent%phys_size(2)
  co_segment%head%gen%minmax(4) = 0.0
  !
  ! Mise a jour des differents pointeurs.
  co_segment%nextseg => null()  ! Pointer on the next leaf
  co_segment%father => parent   ! Pointer on the father
  !
100 format(':',i1)
101 format(':',i2)
102 format(':',i3)
103 format(':',i4)
104 format(':',i5)
105 format(':',i6)
  !
  ! Mise a jour du nom du segment
  co_segment%head%gen%name = nom_seg
  !
  parent%segn = parent%segn+1
  !
  ! Update the last_leaf of the directory and the forward pointing
  if (associated(parent%leaf_last)) then
    ! Parent directory already contains leaves
    parent%leaf_last%nextseg => co_segment
    parent%leaf_last => co_segment
  else
    ! Parent directory had no leaf
    parent%leaf_first => co_segment
    parent%leaf_last => co_segment
  endif
  !
  call gtv_close_segments_for_writing_from_main()
  !
end subroutine gtsegm_create
!
subroutine gtsegm_flush(error)
  use gtv_buffers
  use gtv_interfaces, except_this=>gtsegm_flush
  use gtv_tree
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  !  Flush the internal buffers into the currently opened segment, i.e.
  ! make it ready to be drawn.
  !---------------------------------------------------------------------
  logical, intent(inout) :: error  ! Logical error flag
  ! Local
  type(gt_directory), pointer :: father
  !
  if (.not.associated(co_segment))  return
  !
  ! 1) Flush POLYL%X and POLYL%Y buffers if they are not empty
  call gtx_frxry(error)
  if (error)  return
  !
  ! 2) Update the extrema of the parent directory of the segment we are closing
  father => co_segment%father
  call dir_extrema(father,co_segment%head%gen%minmax)
  !
end subroutine gtsegm_flush
!
subroutine gtsegm_close(error)
  use gtv_interfaces, except_this=>gtsegm_close
  use gbl_message
  use gtv_buffers
  use gtv_graphic
  !---------------------------------------------------------------------
  ! @ public?
  !  Close the segment currently opened. It is harmless to close several
  ! time the same segment.
  !---------------------------------------------------------------------
  logical, intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='GTSEGM_CLOSE'
  integer :: sever
  logical :: lerror
  !
  if (.not.associated(co_segment)) then
    if (strict2011) then
      sever = seve%e
      error = .true.
    else
      sever = seve%w
    endif
    call gtv_message(sever,rname,  &
      'No segment to close here. Duplicate call to ''gr_segm_close''?')
    return
  endif
  !
  ! 1) Prepare the segment to be drawn
  lerror = .false.
  call gtsegm_flush(lerror)
  if (lerror) then
    ! Use a "local" error, since 'gtsegm_close' can be called with
    ! the 'error' flag flag already .true., but we still want to close
    ! the segment (i.e. ignore the input value)
    error = .true.
    return
  endif
  !
  ! 2) Draw it
  call gtview_append(co_segment,lerror)
  if (lerror) then
    error = .true.
    return
  endif
  !
  ! 3) Definitely close it: can not be used anymore
  co_segment => null()
  co_segment_data => null()
  !
end subroutine gtsegm_close
!
subroutine gtedit(dashed,weight,colour,level,visible)
  use gbl_message
  use gtv_buffers
  use gtv_graphic
  use gtv_interfaces, except_this=>gtedit
  use gtv_tree
  use gtv_types
  !---------------------------------------------------------------------
  ! @ public
  !   Edit the current segment with the current line attributes
  ! ---
  !   Threads status: thread safe
  !---------------------------------------------------------------------
  integer(kind=4), intent(in) :: dashed   ! Line Type
  real(kind=4),    intent(in) :: weight   ! [cm] Line width
  integer(kind=4), intent(in) :: colour   ! Colour index
  integer(kind=4), intent(in) :: level    ! Display Depth
  logical,         intent(in) :: visible  ! Visible segment attribute
  ! Local
  character(len=*), parameter :: rname='GTEDIT'
  character(len=message_length) :: mess
  logical :: error
  !
  if (.not.awake .or. error_condition) return
  !
  ! Check ranges
  error = .false.
  if (dashed.lt.min_dash  .or. dashed.gt.max_dash) then
    write(mess,'(A,I0,A,2(1X,I0))')  &
      'Dash argument ',dashed,' out of range',min_dash,max_dash
    call gtv_message(seve%e,rname,mess)
    error = .true.
  endif
! ZZZ
!   if (weight.lt.min_weight  .or. weight.gt.max_weight) then
!     write(mess,'(A,I0,A,2I0)')  &
!       'Weight argument ',weight,' out of range ',min_weight,max_weight
!     call gtv_message(seve%e,rname,mess)
!     error = .true.
!   endif
! ZZZ
!   if (colour.lt.min_colour  .or. colour.gt.max_colour) then
!     write(mess,'(A,I0,A,2I0)')  &
!       'Colour argument ',colour,' out of range ',min_colour,max_colour
!     call gtv_message(seve%e,rname,mess)
!     error = .true.
!   endif
  if (level.lt.0 .or. level.gt.max_depth) then  ! 0 means unchanged
    write(mess,'(A,I0,A,2(1X,I0))')  &
      'Depth argument ',level,' out of range',0,max_depth
    call gtv_message(seve%e,rname,mess)
    error = .true.
  endif
  if (error) then
    call gtx_err
    return
  endif
  !
  ! Define line attributes
  cattr%dash = dashed
  cattr%weight = weight
  cattr%colour = colour
  if (level.ne.0) then
    cattr%depth = level
    if (level.gt.cdepth)  cdepth = level
  endif
  !
  ! Set the attributes of the current segment
  call gtv_open_segments_for_writing_from_main()
  if (associated(co_segment)) then
    co_segment%head%attr = cattr
    vdepth(cattr%depth) = .true.
    co_segment%head%gen%visible = visible
  else
    ! Well, this is embarassing, I do not know what to update...
    cw_directory%gen%visible = visible
  endif
  call gtv_close_segments_for_writing_from_main()
  !
end subroutine gtedit
!
subroutine gtdls
  use gtv_buffers
  use gtv_graphic
  use gtv_interfaces, except_this=>gtdls
  use gtv_segatt
  use gtv_tree
  use gtv_types
  use gbl_message
  !---------------------------------------------------------------------
  ! @ public
  !   Deletes the last segment in the current directory, taking care
  ! of the chain and pointers in the tree.
  !
  ! Does not modify:
  !  - the virtuel pen position,
  !  - the immediate pen position,
  !  - the pen attributes. Those from the previous segment might not be
  !    consistent with the current pen exposed in GreG.
  ! ---
  !   Threads status: thread safe
  !---------------------------------------------------------------------
  ! Local
  character(len=*), parameter :: rname='GTDLS'
  logical :: error
  type(gt_segment), pointer :: segm,previous
  !
  if (.not.awake .or. error_condition) return
  !
  error = .false.
  !
  ! Avant de s'affoler la tete comme des malades, il faudrait voir
  ! si ce pauvre segment auquel on veut faire la peau est un repertoire.
  ! Flinguer un repertoire se fera par une commande speciale.
  if (.not.associated(cw_directory%leaf_last)) then
    call gtv_message(seve%e,rname,'Unable to delete a Directory segment')
    call gtv_message(seve%e,rname,'Use CLEAR DIRECTORY [Name]')
    return
  endif
  !
  ! Segment to destroy
  segm => cw_directory%leaf_last
  if (associated(segm,co_segment)) then
    co_segment => null()
    co_segment_data => null()
  endif
  !
  call gtv_open_segments_for_writing_from_main()
  !
  polyl%x(1) = polyl%x(polyl%n)
  polyl%y(1) = polyl%y(polyl%n)
  polyl%n = 1
  cw_directory%segn = cw_directory%segn - 1
  !
  ! Update the segments chain in the directory
  segm => cw_directory%leaf_first
  previous => null()
  do while (associated(segm%nextseg))
    previous => segm
    segm => previous%nextseg
  enddo
  !
  ! Update the directory pointers
  if (.not.associated(previous)) then
    cw_directory%leaf_first => null()
    cw_directory%leaf_last => null()
  else
    cw_directory%leaf_last => previous
    previous%nextseg => null()
  endif
  !
  ! And finally update the limits
  call gtv_limits(cw_directory,error)
  !
  call gtv_close_segments_for_writing_from_main()
  !
  ! Free the segment: put it in the stack for later deletion. This can
  ! be done out of the threads protection, since nobody new can know
  ! about it now.
  ! segm%nextseg is already null()
  if (associated(segm))  &
    call x_destroy_segment(segm)  ! will call gtv_delsegments(segm)
  !
end subroutine gtdls
!
function gtv_newsegment(error)
  use gtv_types
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !  Allocate a new GTVIRT segment.
  !---------------------------------------------------------------------
  type(gt_segment), pointer :: gtv_newsegment  ! Function value on return
  logical,    intent(inout) :: error           ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='GTV_NEWSEGMENT'
  integer :: ier
  !
  allocate(gtv_newsegment,stat=ier)
  if (ier.ne.0) then
    call gtv_message(seve%e,rname,'Internal error: allocation failure')
    error = .true.
    return
  endif
  !
end function gtv_newsegment
!
subroutine gtv_delsegment_elem(segm)
  use gtv_interfaces, except_this=>gtv_delsegment_elem
  use gtv_buffers
  use gtv_plot
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  !   Elemental routine which deallocates the input segment and frees
  ! the data associated. This routine does NOT take care of the pointers
  ! to this segment in the GTV tree: it is up to the calling routine
  ! to remake the chain, if required.
  ! ---
  !   Threads status: NOT thread safe -> calling routine must be thread
  !  safe.
  !---------------------------------------------------------------------
  type(gt_segment), target :: segm  ! Segment to clean
  ! Local
  logical :: error
  type(gt_segment), pointer :: segm_p
  type(gt_segment_data), pointer :: father,son
  !
  if (associated(co_segment,segm)) then
    co_segment => null()
    co_segment_data => null()
  endif
  !
  error = .false.
  father => segm%data
  do while (associated(father))
    ! Data
    if (associated(father%poly%x))  &
      deallocate(father%poly%x,father%poly%y)
    if (allocated(father%lut%r)) then
      call gt_lut_dealloc(father%lut,error)
    endif
    if (associated(father%image)) then
      call gtv_delimage(father%image)
      nullify(father%image)
    endif
    !
    ! Chain
    son => father%nextdata  ! Keep track before destruction
    deallocate(father)
    father => son
  enddo
  !
  segm_p => segm
  deallocate(segm_p)
  !
end subroutine gtv_delsegment_elem
!
subroutine gtv_delsegments(segm)
  use gtv_interfaces, except_this=>gtv_delsegments
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  !  Destroy the input linked list of segments, without taking care of
  ! the surrounding elements in the GTV tree.
  !  This subroutine can only be called if:
  ! - all the segments we are about to destroy have been dereferenced
  !   from the GTV tree,
  ! - all the previous events in the stack (which may refer to these
  !   segments) have been processed, i.e. only the stack can call this
  !   subroutine.
  !
  ! BEWARE! As we receive a target, the caller must ensure that a
  !         it never passes a null() pointer to this subroutine!
  !---------------------------------------------------------------------
  type(gt_segment), target :: segm  ! First segment to destroy
  ! Local
  type(gt_segment), pointer :: nextsegm,cursegm
  !
  nextsegm => segm
  do while (associated(nextsegm))
    cursegm => nextsegm
    nextsegm => cursegm%nextseg  ! Keep track *before* deleting 'cursegm'
    !
    ! Free the segment
    call gtv_delsegment_elem(cursegm)
  enddo
  !
end subroutine gtv_delsegments
!
!-----------------------------------------------------------------------
!
function gtv_newdirectory(error)
  use gtv_types
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !  Allocate a new GTVIRT directory.
  !---------------------------------------------------------------------
  type(gt_directory), pointer :: gtv_newdirectory  ! Function value on return
  logical,      intent(inout) :: error             ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='GTV_NEWDIRECTORY'
  integer :: ier
  !
  allocate(gtv_newdirectory,stat=ier)
  if (ier.ne.0) then
    call gtv_message(seve%e,rname,'Internal error: allocation failure')
    error = .true.
    return
  endif
  !
end function gtv_newdirectory
!
subroutine gtv_deldirectory_elem(dir)
  use gtv_buffers
  use gtv_interfaces, except_this=>gtv_deldirectory_elem
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  !   Elemental routine which frees the data associated to the input
  ! directory. This routine:
  !  - does NOT take care of the pointers to this directory in the GTV
  !    tree,
  !  - does NOT delete the subdirectories it might contain, if any.
  ! ---
  !   Threads status: NOT thread safe -> calling routine must be thread
  !  safe.
  !---------------------------------------------------------------------
  type(gt_directory), target :: dir  !
  ! Local
  type(gt_directory), pointer :: dir_p
  !
  ! Destroy the list of segments
  if (associated(dir%leaf_first))  &
    call gtv_delsegments(dir%leaf_first)
  !
  ! Pointers. No need...
  ! dir%ancestor => null()
  ! dir%father => null()
  ! dir%brother => null()
  ! dir%son_first => null()
  ! dir%son_last => null()
  ! dir%leaf_first => null()
  ! dir%leaf_last => null()
  !
  dir_p => dir
  deallocate(dir_p)
  !
end subroutine gtv_deldirectory_elem
!
recursive subroutine gtv_deldirectory_recurs(dir)
  use gtv_interfaces, except_this=>gtv_deldirectory_recurs
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  ! Destroy the input directory:
  !  - destroy its segments and data
  !  - destroy its subdirectories (by a recursive call to this routine)
  ! This does NOT take care of the pointers and chain to the destroyed
  ! directory.
  !---------------------------------------------------------------------
  type(gt_directory) :: dir  ! Directory to destroy
  ! Local
  type(gt_directory), pointer :: son,nextson
  !
  ! 1) Destroy its subdirectories
  nextson => dir%son_first
  do while (associated(nextson))
    son => nextson
    nextson => son%brother  ! Keep track before deleting 'son'
    call gtv_deldirectory_recurs(son)
  enddo
  !
  ! 2) Destroy all its segments and data
  call gtv_deldirectory_elem(dir)
  !
end subroutine gtv_deldirectory_recurs
!
subroutine gtv_deldirectories(dir)
  use gtv_interfaces, except_this=>gtv_deldirectories
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  !  Destroy the input linked list of directories, recursively for each
  ! of them, without taking care of the surrounding elements in the
  ! GTV tree.
  !  This subroutine can only be called if:
  ! - all the elements we are about to destroy have been dereferenced
  !   from the GTV tree,
  ! - all the previous events in the stack (which may refer to these
  !   elements) have been processed, i.e. only the stack can call this
  !   subroutine.
  !
  ! BEWARE! As we receive a target, the caller must ensure that a
  !         it never passes a null() pointer to this subroutine!
  !---------------------------------------------------------------------
  type(gt_directory), target :: dir  ! First directory to destroy
  ! Local
  type(gt_directory), pointer :: curdir,nextdir
  !
  nextdir => dir
  do while (associated(nextdir))
    curdir => nextdir
    nextdir => curdir%brother  ! Keep track before deleting 'curdir'
    !
    call gtv_deldirectory_recurs(curdir)
  enddo
  !
end subroutine gtv_deldirectories
!
recursive subroutine exec_poly_recurs(dir,execop)
  use gtv_buffers
  use gtv_interfaces, except_this=>exec_poly_recurs
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  !  Traverse all the leaves of the input directory and recursively in
  ! subdirectories and execute the input routine 'execop' on the GTV
  ! polylines and polygons it finds.
  !---------------------------------------------------------------------
  type(gt_directory) :: dir     ! Starting directory
  external           :: execop  !
  ! Local
  type(gt_segment), pointer :: leaf
  type(gt_directory), pointer :: son
  !
  ! 1) Search for all the leaves
  leaf => dir%leaf_first
  do while (associated(leaf))
    call poly_codeop(leaf,execop)
    leaf => leaf%nextseg
  enddo
  !
  ! 2) Loop on all the subdirectories
  son => dir%son_first
  do while (associated(son))
    call exec_poly_recurs(son,execop)
    son => son%brother
  enddo
  !
end subroutine exec_poly_recurs
!
subroutine poly_codeop(leaf,execop)
  use gtv_interfaces, except_this=>poly_codeop
  use gtv_buffers
  use gtv_plot
  use gtv_tree
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  !  Generic entry point which reads the input 'leaf' and execute
  ! the input routine if it finds a the GTV polyline or polygon.
  !  'execop' takes the segment header and the polyline/polygon address
  ! as argument
  !---------------------------------------------------------------------
  type(gt_segment), pointer :: leaf    ! Segment instance
  external                  :: execop  ! Routine to execute on the image
  ! Local
  type(gt_segment_data), pointer :: segdata
  logical :: error
  !
  if (lut_static) then
    ! Save the current global LUT as last data in this segment
    co_segment => leaf
    co_segment_data => null()
    segdata => leaf%data
    do while (associated(segdata))
      co_segment_data => segdata
      segdata => segdata%nextdata
    enddo
    error= .false.
    call gt_penlut_segdata(error)
    co_segment => null()
    co_segment_data => null()
  else
    ! Unset the LUT to be used by the polylines. We should also remove its
    ! data (which is somewhere in the linked list of data)
    leaf%head%lut => null()
  endif
  !
  ! Follow the linked list of data to make all the polylines use the
  ! LUT we just saved
  segdata => leaf%data
  do while (associated(segdata))
    if (segdata%kind.eq.seg_poly   .or.  &
        segdata%kind.eq.seg_hfpoly .or.  &
        segdata%kind.eq.seg_vfpoly)      &
      call execop(leaf%head,segdata%poly)
    !
    segdata => segdata%nextdata
  enddo
  !
end subroutine poly_codeop

subroutine sic_transpose(line,error)
  use sic_dependencies_interfaces
  use gildas_def
  use sic_interfaces, except_this=>sic_transpose
  use sic_types
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! GILDAS Transpose a cube
  !  The algorithm is stupid, but it should not matter on relatively
  ! small cubes
  !---------------------------------------------------------------------
  character(len=*)               :: line   !
  logical,         intent(inout) :: error  !
  ! Local
  character(len=256) :: namex,namey
  character(len=sic_maxdims) :: code
  integer :: space_gildas,n,ier
  !
  logical :: found
  type(sic_descriptor_t) :: descin,descout
  !
  call sic_ke (line,0,3,code,n,.true.,error)
  if (error) return
  call sic_ch (line,0,2,namex,n,.true.,error)
  if (error) return
  call sic_ch (line,0,1,namey,n,.true.,error)
  if (error) return
  !
  ! Check if output (X) is a Variable or a File
  found = .true.
  call sic_descriptor(namey,descin,found)  ! Checked
  if (found) then
    call sic_descriptor(namex,descout,found)   ! Checked
    if (.not.found) then
      call sic_message(seve%e,'TRANSPOSE','Input and Output are not variables')
      error = .true.
      return
    endif
    !
    ! Transpose Variables
    call var_transpose(descin,descout,code,error,namey,namex)
  else
    !
    ! Transpose Files
    space_gildas = 256
    ier = sic_getlog('SPACE_GILDAS',space_gildas)
    call gdf_transpose(namex,namey,code,space_gildas,error)
  endif
end subroutine sic_transpose
!
subroutine get_dims(desc,dims)
  use sic_interfaces, except_this=>get_dims
  use sic_types
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(sic_descriptor_t)     :: desc  !
  integer(kind=index_length) :: dims(sic_maxdims)  !
  ! Local
  integer :: i
  !
  do i=1,sic_maxdims
    dims(i) = desc%dims(i)
    dims(i) = max(1,dims(i))
  enddo
  !
end subroutine get_dims
!
subroutine var_transpose(descin,descout,code,error,namei,nameo)
  use gildas_def
  use image_def
  use gbl_format
  use gbl_message
  use sic_dependencies_interfaces, no_interface1=>trans4all,  &
                                   no_interface2=>trans8all
  use sic_interfaces, except_this=>var_transpose
  use sic_types
  use sic_dictionaries
  !---------------------------------------------------------------------
  ! @ private
  !
  !---------------------------------------------------------------------
  type(sic_descriptor_t)               :: descin   !
  type(sic_descriptor_t)               :: descout  !
  character(len=*),      intent(in)    :: code     !
  logical,               intent(inout) :: error    !
  character(len=*),      intent(in)    :: namei     !
  character(len=*),      intent(in)    :: nameo     !
  ! Global
  include 'gbl_memory.inc'
  ! Local
  character(len=*), parameter :: rname='TRANSPOSE'
  integer(kind=address_length) :: ipx,ipy
  integer(kind=index_length) :: idim(sic_maxdims),odim(sic_maxdims),iblock(sic_maxdims)
  integer(kind=4) :: itr(sic_maxdims),i,form
  integer(kind=index_length) :: nfirst,nsecon,nmiddl,nlast,nelems
  integer(kind=size_length) :: ntot
  !
  form = descout%type
  if (form.ne.descin%type) then
    call sic_message(seve%e,rname,'Variable type mismatch')
    error = .true.
    return
  endif
  call transpose_getorder(code,itr,sic_maxdims,error)
  if (error) return
  do i=1,descin%ndim
    if (itr(i).eq.0) itr(i) = i
  enddo
  !
  ! Check output variable dimensions
  if (descout%ndim.ne.descin%ndim) then
    error = .true.
  else
    call get_dims(descout,odim)
    call get_dims(descin,idim)
    do i=1,descout%ndim
      if (idim(itr(i)).ne.odim(i)) then
        error = .true.
      endif
    enddo
  endif
  if (error) then
    call sic_message(seve%e,rname,'Dimension mismatch')
    return
  endif
  !
  ! Get the block sizes
  call transpose_getblock(idim,sic_maxdims,code,iblock,error)
  if (error) return
  !
  nelems = iblock(1)
  nfirst = iblock(2)
  nmiddl = iblock(3)
  nsecon = iblock(4)
  nlast  = iblock(5)
  !
  ipy = gag_pointer(descin%addr,memory)
  ipx = gag_pointer(descout%addr,memory)
  if (form.eq.fmt_r4 .or. form.eq.fmt_i4 .or. form.eq.fmt_l) then
    if (nfirst*nmiddl.eq.1 .or. nsecon*nmiddl.eq.1) then
      ntot = 1_8*nelems*nfirst*nmiddl*nsecon*nlast
      call w4tow4_sl(memory(ipy),memory(ipx),ntot)
    else
      call trans4all(memory(ipx),memory(ipy),nelems,nfirst,nmiddl,nsecon,nlast)
    endif
    !
  elseif (form.eq.fmt_r8 .or. form.eq.fmt_i8 .or. form.eq.fmt_c4) then
    if (nfirst*nmiddl.eq.1 .or. nsecon*nmiddl.eq.1) then
      ntot = 1_8*nelems*nfirst*nmiddl*nsecon*nlast
      call w8tow8_sl(memory(ipy),memory(ipx),ntot)
    else
      call trans8all(memory(ipx),memory(ipy),nelems,nfirst,nmiddl,nsecon,nlast)
    endif
    !
  else
    call sic_message(seve%e,rname,'Unsupported data kind')
    error = .true.
    return
  endif
  !
  ! Transpose the Header of Image Variables
  !! Print *,'Desc%Status IN ',descin%status,' OUT ',descout%status
  if (.not.associated(descin%head))  return
  if (.not.associated(descout%head))  return
  !
  call gdf_transpose_header(descin%head,descout%head,code,error)
  if (error)  return
  !
end subroutine var_transpose
!
subroutine tmp_print(iarray,n)
  integer(kind=8) n
  integer iarray(n)
  integer i
  do i =1,n
    print *,'I ',i,' Value ',iarray(i)
  enddo
end subroutine tmp_print

subroutine convolve (image,dirty,nx,ny,fbeam,fcomp,wfft)
  use gkernel_interfaces, only : fourt
  !----------------------------------------------------------------------
  ! @ public
  !*
  ! IMAGER -- Utility routine
  !
  !	  Convolve an image by a beam through Fourier Transform
  !!
  !----------------------------------------------------------------------
  integer, intent(in) :: nx,ny            !! Problem size
  complex, intent(in) :: fbeam(nx,ny)     !! Beam Fourier Transform
  complex, intent(inout) :: fcomp(nx,ny)  !! FT workspace
  real, intent(in) :: image(nx,ny)        !! Input image
  real, intent(out) :: dirty(nx,ny)       !! Convolved image
  real, intent(inout) :: wfft(*)          !! Work area
  !
  ! Local ---
  integer :: ndim,nn(2)
  !
  ! Code ----
  ndim = 2
  nn(1) = nx
  nn(2) = ny
  fcomp = cmplx(image,0.0)
  !
  ! Direct TF
  call fourt(fcomp,nn,ndim,-1,0,wfft)
  !
  ! Multiplication (note normalisation done in FBEAM)
  fcomp = fcomp*fbeam
  !
  ! Reverse TF
  call fourt(fcomp,nn,ndim,1,1,wfft)
  !
  ! Dirty map
  dirty = real(fcomp)
end subroutine convolve
!
subroutine init_convolve (i0,j0,nx,ny,beam,fbeam,area,work)
  !----------------------------------------------------------------------
  ! @ private
  !*
  !   IMAGER -- Utility routine
  !
  !	  Compute the FT of a beam centered on pixel I0,J0
  !!
  !----------------------------------------------------------------------
  integer, intent(in) :: nx,ny            !! Problem size
  integer, intent(in) :: i0,j0            !! Position of peak
  complex, intent(out) :: fbeam(nx,ny)    !! FT of beam
  real, intent(in) :: beam(nx,ny)         !! Beam
  real, intent(inout) :: work(*)          !! Work space
  real, intent(out) :: area               !! Beam area
  !
  ! Local ---
  integer :: i,j,nn(2),ndim
  real :: fact
  !
  ! Code ----
  ndim = 2
  nn(1) = nx
  nn(2) = ny
  fact = 1.0/float(nx*ny)
  do j=1,j0-1
    do i=1,i0-1
      fbeam(i+nx-i0+1,j+ny-j0+1) = cmplx(beam(i,j)*fact,0.0)
    enddo
    do i=i0, nx
      fbeam(i-i0+1,j+ny-j0+1) = cmplx(beam(i,j)*fact,0.0)
    enddo
  enddo
  do j=j0,ny
    do i=1,i0-1
      fbeam(i+nx-i0+1,j-j0+1) = cmplx(beam(i,j)*fact,0.0)
    enddo
    do i=i0,nx
      fbeam(i-i0+1,j-j0+1) = cmplx(beam(i,j)*fact,0.0)
    enddo
  enddo
  call fourt(fbeam,nn,ndim,-1,0,work)
  area = real(fbeam(1,1))/beam(i0,j0)
end subroutine init_convolve

program table_density
  use gildas_def
  use gkernel_interfaces
  ! Purpose:
  !   Computes a 2-D array holding the density of points
  !   from 2 columns of a table
  character(len=filename_length) :: table, image, output
  integer(kind=4) :: cols(2),dims(2)
  real :: percent
  logical error
  !
  call gildas_open
  call gildas_char('NAME_IN$',table)
  call gildas_inte('COLS$',cols,2)
  call gildas_char('NAME_OUT$',image)
  call gildas_inte('DIMS$',dims,2)
  call gildas_char('TABLE_OUT$',output)
  call gildas_real('PERCENT$',percent,1)
  call gildas_close
  !
  call sub_table_density(table,cols,image,dims,output,percent,error)
end program
!
subroutine sub_table_density(table,cols,image,dims,output,percent,error)
  use image_def
  use gbl_message
  use gkernel_interfaces
  !
  character(len=*), intent(inout) :: table, image, output
  integer(kind=4), intent(in) :: cols(2),dims(2)
  real, intent(in) :: percent
  logical, intent(out) :: error
  !
  character(len=*), parameter :: rname='TABLE_DENSITY'
  integer(kind=size_length) :: nxy,nmin,nmax
  real :: xmin, xmax, ymin, ymax, dmin, dmax, bval, eval
  real(8) :: incx, incy 
  integer :: i,j,k,l, ier
  type(gildas) :: tab, img, tbl
  real, allocatable :: xx(:),yy(:)
  !
  call gildas_null(tab,type='TABLE')
  call gdf_read_gildas(tab,table,'.tab',error,data=.false.)
  if (error) return
  !
  if (cols(1).gt.tab%gil%dim(2) .or. cols(2).gt.tab%gil%dim(2)) then
    call gag_message(seve%e,rname,'Columns out of bound')
    error = .true.
    return
  endif
  !
  nxy = tab%gil%dim(1)
  allocate (xx(nxy),yy(nxy),stat=ier)
  if (ier.ne.0) then
    call gag_message(seve%e,rname,'TABLE allocation error')
    error = .true.
    return
  endif
  tab%blc(2) = cols(1)
  tab%trc(2) = cols(1)
  call gdf_read_data(tab,xx,error)
  if (error) return
  tab%blc(2) = cols(2)
  tab%trc(2) = cols(2)
  call gdf_read_data(tab,yy,error)
  if (error) return  
  !
  bval = 0.0
  eval = -1.0
  call gr4_extrema (nxy,xx,bval,eval,xmin,xmax,nmin,nmax)
  call gr4_extrema (nxy,yy,bval,eval,ymin,ymax,nmin,nmax)
  !
  ! Now compute the density
  call gildas_null(img)
  call sic_parse_file(image,' ','.gdf',img%file)
  !
  img%gil%ndim = 2
  img%gil%dim(1) = dims(1)
  img%gil%dim(2) = dims(2)
  incx = (xmax-xmin)/(dims(1)-1)
  incy = (ymax-ymin)/(dims(2)-1)
  ! Axis conversion semigroup
  img%gil%convert(1,1)=1.0d0
  img%gil%convert(2,1)=xmin
  img%gil%convert(3,1)=incx
  img%gil%convert(1,2)=1.0d0
  img%gil%convert(2,2)=ymin
  img%gil%convert(3,2)=incy
  allocate(img%r2d(dims(1),dims(2)),stat=ier)
  if (ier.ne.0) then
    call gag_message(seve%e,rname,'DATA allocation error')
    error = .true.
    return
  endif
  !
  img%r2d = 0.0
  !
  ! Loop on entries
  do k=1,nxy
    i = nint ( (xx(k)-img%gil%val(1))/img%gil%inc(1) + img%gil%ref(1))
    j = nint ( (yy(k)-img%gil%val(2))/img%gil%inc(2) + img%gil%ref(2))
    if (i.ge.1 .and. i.le.dims(1) .and. j.ge.1 .and. j.le.dims(2)) then
      img%r2d(i,j) = img%r2d(i,j)+1
    else
      Print *,'invalid point ',k,xx(k),xmax,yy(k),ymax,i,j
    endif
  enddo
  !
  call gdf_write_image(img,img%r2d,error)
  if (error) return
  !
  ! Retain only points below some threshold  
  call gr4_extrema (img%loca%size,img%r2d,bval,eval,dmin,dmax,nmin,nmax)
  dmax = percent*dmax/100.
  !
  l = 0
  do k=1,nxy
    i = nint ( (xx(k)-img%gil%val(1))/img%gil%inc(1) + img%gil%ref(1))
    j = nint ( (yy(k)-img%gil%val(2))/img%gil%inc(2) + img%gil%ref(2))
    if (img%r2d(i,j).lt.dmax) then
      l = l+1
      xx(l) = xx(k)
      yy(l) = yy(k)
    endif
  enddo
  deallocate(img%r2d)
  if (l.eq.0) then
     Print *,'Threshold is too low, no data selected'
     l = nxy
  endif
  !
  call gildas_null(tbl, type='TABLE')
  call sic_parse_file(output,' ','.tab',tbl%file)
  tbl%gil%dim(1) = l
  tbl%gil%dim(2) = 2
  tbl%gil%ndim = 2
  allocate(tbl%r2d(l,2),stat=ier)
  tbl%r2d(:,1) = xx(1:l)
  tbl%r2d(:,2) = yy(1:l)
  call gdf_write_image(tbl,tbl%r2d,error)
  if (error) return
  !
end subroutine sub_table_density

subroutine astro_uv(line,error)
  use gildas_def
  use image_def
  use gkernel_interfaces
  use gkernel_types
  use gbl_message
  use ast_astro
  use ast_constant
  use atm_params
  use ast_telescope
  use imager_interfaces, except_this=>astro_uv
  !---------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER Support for command
  ! UV_TRACKS Config [Dec Freq]  
  !       [/FRAME Max_U]  
  !       [/HOUR Hmin Hmax]   
  !       [/TABLE Name ’NEW]]   
  !       [/HORIZON Elv]   
  !       [/INTEGRATION T]   
  !       [/STATIONS Station1_ .. StationN ]   
  !       [/SIZE size1 nsize1 size2 nsize2 ...]   
  !       [/OFFSET offset]  
  !       [/WEIGHT mode [Jy_per_K Bandwidth]]  
  !!
  !------------------------------------------------------------------------
  ! Notes:
  ! - RL 09-nov-1998 /SIZE must be given to antenna size.
  ! - OFFSET is the position of the fixed delay line which corresponds to the
  ! the first station. It is then necessary to insure that in the following
  ! the tables X(MSTAT) reflect the order in which the stations were entered
  ! in the command line.
  !
  ! Note about XX YY ZZ TT, the positions written in the station's file:
  ! TT is (or should be) the total length (in m) from the center of
  ! the aperture to a reference plane common to all beams (preferably the
  ! entrance plane of delay lines). For XX, YY and ZZ, these are the 3
  ! components of the vector going from the earth centre to the location of
  ! the station on the surface of the earth (local equatorial coordinates),
  ! with XX along this direction, YY in the W-E direction
  ! (positive towards EAST) and ZZ in the N direction. Given local horizontal
  ! (on earth surface) coordinates x,y,z of the station,
  ! x towards Local east, y toward N and z toward Zenith,
  ! the transformation matrix is :
  !
  ! XX      / 0,-sin(lat),  cos(lat) \   x  
  ! YY =    | 1,        0,         0 | * y  
  ! ZZ      \ 0, cos(lat),  sin(lat) /   z
  !  
  ! Where lat is the latitude of the interferometer center
  ! Note about u,v,w:
  ! the transformation from the equatorial coordinates Bx,By,Bz
  ! of a Baseline B to u,v,w is given by the matrix:
  ! u       / sin(H)       , cos(H)       ,      0 \   Bx
  ! v  =    |-sin(D)*cos(H), sin(D)*sin(H), cos(D) | * By
  ! w       \ cos(D)*cos(H),-cos(D)*sin(H), sin(D) /   Bz
  ! where H is the hour angle and D the declination of the source
  !
  ! which give ellipses of centre (0, (B/lambda)*sin(d)*cos(D)), with semi-major
  ! axis (B/lambda)*cos(d) and semi-minor axis (B/lambda)*cos(d)*sin(D)
  !
  ! Taking into account a maximum throw for delay lines may be useful for
  ! RadioInterferometers too (some may have cable length limitations) but
  ! is not desirable by default for them. However, the geometrical delay between
  ! apertures ('aerials'? 'telescopes'?) is used deep in the program. To avoid
  ! problems, we define the throw of fake 'delay lines' for radio
  ! interferometers to 2 a.u = 3.0E11 m ,with OFFSET to 1 a.u.
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line     !! Input command line
  logical,          intent(inout) :: error    !! Logical error flag
  !
  ! Constants
  character(len=*), parameter :: rname='UV_TRACK'
  !
  !  & ' UV_TRACKS', '/FRAME', '/HORIZON', '/HOUR_ANGLE', '/INTEGRATION', &
  !  & '/OFFSET', '/SIZE', '/STATIONS', '/TABLE', '/WEIGHT'   /   
  integer(kind=4), parameter :: iopt_frame=1
  integer(kind=4), parameter :: iopt_hori=2
  integer(kind=4), parameter :: iopt_hour=3
  integer(kind=4), parameter :: iopt_int=4
  integer(kind=4), parameter :: iopt_offset=5
  integer(kind=4), parameter :: iopt_size=6
  integer(kind=4), parameter :: iopt_stations=7
  integer(kind=4), parameter :: iopt_table=8
  integer(kind=4), parameter :: iopt_weight=9
  integer(kind=4), parameter :: mstat=100,mlist=20
  integer(kind=4), parameter :: hori_min=3 ! minimum elevation in degrees
  integer(kind=4), parameter :: mw=3
  character(len=8) :: weight(mw)
  data weight /'UNIFORM','AIRMASS','FULL'/
  !
  ! Local ---
  type(uv_track_t) :: uvt
  integer(kind=4) :: muv
  real(kind=4), allocatable :: zch(:), zsh(:)
  integer(kind=4) :: visi_size ! number of column of output table
  integer(kind=4) :: nstat_in, ier, nc, ii, i1, i2,iline
  integer(kind=4) :: istation(mstat), nlu, nn,nskip,nces,nsize,nfilled
  type(sic_listi4_t) :: list
  character(len=12) :: name, statn,stations_in(mstat), cmode
  character(len=132) :: clu, oldlis, stalis, delay_mess
  real(kind=4) ::  tt
  integer(kind=4) :: flag
  real(kind=8) :: dx,dy,dz
  real(kind=4) ::  xx, yy, zz,  h, sh, ch, xm(2), ym(2)
  real(kind=4) :: hmin, hmax, array,hh1,hh2,poff(4)
  real(kind=4) :: uk, vk, wk, uvmin,psize,throw, latitud
  real(kind=8) :: decs, az, el,avec(3), bvec(3), amat(9)
  integer(kind=4) :: i, j, k, l, ns, nh, lun, nvis
  character(len=256) :: chain
  character(len=message_length) :: mess
  character(len=132) :: fstation
  logical :: take, found(mstat), table_ok,delay_ok
  logical :: complete(mstat)
  real(kind=4) ::  frac
  integer(kind=4) ::  iused, nused, ntake,check_nsize
  real(kind=4), allocatable :: myvisi(:,:)
  integer(kind=4) :: ivisi
  integer :: date(7)
  character(len=16) :: d_chain
  integer :: idate 
  real :: rdate
  real(kind=4) :: px                ! page_x from GreG
  ! Saved variables
  type(gildas), save :: xtab            ! Probably needs to be SAVE'd
  integer(kind=4), save :: icount=0     ! Date counter 
  integer(kind=4), save :: icolour=0    ! Pen colour counter
  real(kind=4), save :: extr=300.0      ! Array size in meters
  real(kind=4), save :: integ_time=1    ! Integration time (in Minutes !...)
  real(kind=8), save :: decd=+20.d0     ! Source declination
  real(kind=4), save :: hori=hori_min   ! Lower elevation limit
  character(len=filename_length), save :: file = ' ' ! output table name 
  !
  logical, save :: do_plot              ! Plot UV Tracks 
  logical :: do_station                 ! Plot Configuration
  logical :: do_cover                   ! Plot a quick coverage
  logical :: do_shadow                  ! Print a message for Shadowing
  integer :: ih
  !
  character(len=4) :: key
  integer :: n_stations, n
  integer :: nfield
  real, allocatable :: offs(:,:)
  integer :: jf
  real :: theoff(2)
  character(len=256) :: string
  logical :: by_number=.false.    ! An old code version was using Station Numbers, not Names
  real(8) :: xvla,yvla,zvla
  !
  ! Code ----
  !
  ! Figure out the Pointing Offsets in case of a Mosaic
  call astro_uv_fields(nfield,offs)
  if (nfield.le.1) then
    visi_size = 12
  else
    visi_size = 14
  endif
  error = .false.
  !
  if (obsname.eq.' ') then
    call map_message(seve%e,rname,'Telescope array is undefined, use ARRAY command before UV_TRACK')
    error = .true.
    return
  endif
  !
  ! Check that station files is found
  if (sic_present(0,1)) then
    call sic_ch(line,0,1,string,n,.true.,error)
    if (string(1:n).ne.'*') then
      call sic_lower(string(1:n))
      string = trim(config_prefix)//string(1:n)
      ier = sic_setlog('astro_stations',trim(string))
    endif
    ! Get Declination unless using an existing Table
    if (.not.sic_present(iopt_table,0)) then
      if (.not.sic_present(0,2)) then
        call map_message(seve%e,rname,'Missing Source Declination as 1st argument')
        error = .true.
        return
      endif
      call sic_r8(line,0,2,decd,.true.,error)
      if (error) return
      ! Frequency in GHz
      call sic_r8(line,0,3,freq,.false.,error)
      if (error) return
    endif
    !
  endif
  if (.not.sic_query_file('astro_stations','data#dir:','.cfg',fstation)) then
    call map_message(seve%e,rname,'Astro_Stations file '//trim(fstation)//' not found')
    error = .true.
    return
  endif
  !
  ! backward compatibility to understand 3digit station names (E68 instead o E068)
  ! for NOEMA
  uvt%in%three_digit_name_compatible = .true.   
  !
  uvt%in%do_frame = sic_present(iopt_frame,0)
  uvt%in%do_hour=sic_present(iopt_hour,0)
  uvt%in%do_table=sic_present(iopt_table,0)
  uvt%in%do_hori=sic_present(iopt_hori,0)
  uvt%in%do_int=sic_present(iopt_int,0)
  uvt%in%do_stations=sic_present(iopt_stations,0)
  uvt%in%do_size=sic_present(iopt_size,0)
  uvt%in%do_offset=sic_present(iopt_offset,0)
  uvt%in%do_weight=sic_present(iopt_weight,0)
  !
  !
  ! Change the logic of /TABLE and /FRAME compared to ASTRO
  !   /TABLE Name NEW       to initialize a new table
  !   /TABLE [Name]         to add to existing table
  !       (in memory or from a previous file)
  !       Declination and Frequency derived from that table.
  if (uvt%in%do_table) then
    key = 'OLD'
    call sic_ke(line,iopt_table,2,key,nc,.false.,error)
    if (error) return 
    icount = icount+2   ! Increment Date counter
    icolour = icolour+1
    !
    if (key.eq.'NEW') then
      do_plot = sic_present(iopt_frame,0)
      if (do_plot) uvt%in%user_array = 0.
      ! Declination
      if (.not.sic_present(0,2)) then
        call map_message(seve%e,rname,'Missing Source Declination as 1st argument')
        error = .true.
        return
      endif
      call sic_r8(line,0,2,decd,.true.,error)
      if (error) return
      ! Frequency in GHz
      call sic_r8(line,0,3,freq,.false.,error)
      if (error) return
      call sic_ch (line,iopt_table,1,chain,nc,.true.,error)
      if (error) return
      call sic_parsef(chain,file,' ','.uvt')
      call map_message(seve%i,rname,"Initializing "//trim(file))
      config_count = 0       ! Reset line counter
      icount = 0      ! And date increment
      icolour = 0     ! Pen color    
    else if (sic_present(iopt_table,1)) then
      ! Append to an existing Table
      call sic_ch (line,iopt_table,1,chain,nc,.true.,error)
      if (error) return
      call sic_parsef(chain,file,' ','.uvt')
      call gildas_null(xtab,type='UVT')
      xtab%file = file
      call map_message(seve%i,rname,"Appending to "//trim(file))
      call gdf_read_header(xtab,error)
      if (error) return
      if (sic_narg(0).gt.1) then
        call map_message(seve%w,rname,"Specified Declination and Frequency ignored")
      endif
      ! Recover Declination and Frequency
      decd = xtab%gil%d0*180d0/pi
      freq = xtab%gil%freq*1d-3
      write(mess,'(A,f5 .1,A,f8.3,A)') "Declination ",decd,",  Frequency ",freq, " GHz"
      call map_message(seve%i,rname,mess)
      call gdf_close_image(xtab,error)
      !
    else if (len_trim(file).eq.0) then
      call map_message(seve%e,rname,'No previous Table')
      error = .true.
      return
    endif
    !
    if (do_plot) then
      call sic_r4 (line,iopt_frame,1,uvt%in%user_array,.false.,error)
      if (error) return
    endif
  else if (uvt%in%do_frame) then
    icolour = 0
    ! Option /FRAME
    do_plot = .true.
    ! Size
    uvt%in%user_array = 0.
    call sic_r4 (line,iopt_frame,1,uvt%in%user_array,.false.,error)
    if (error) return
  else
    icolour = icolour+1
  endif
  !
  uvt%in%do_all=.false.
  !
  ! /STATIONS
  n_stations = sic_narg(iopt_stations)
  if (n_stations.le.0) then
    uvt%in%do_all = .true.
    nstat_in = -1
  else if (n_stations.gt.mstat) then
    call map_message(seve%e,rname,'Too many stations entered')
    error=.true.
    return
  else if (by_number) then  ! Old code, by number
    i1 = sic_start(iopt_stations,1)
    i2 = sic_end(iopt_stations,sic_narg(iopt_stations))
    stalis = line(i1:i2)
    call sic_parse_listi4('UV_TRACKS',stalis,list,mlist,error)
    if (error) return
    nstat_in = 0
    do i=1,list%nlist
      do ii=list%i1(i),list%i2(i),list%i3(i)
        if (nstat_in.ge.mstat) then
          call map_message(seve%e,rname,'Too many stations')
          error=.true.
          return
        else
          nstat_in = nstat_in+1
          istation(nstat_in) = ii
          stations_in(nstat_in) = ''
        endif
      enddo
    enddo
  else      ! New code, by stations names
    stalis = ' '
    nc = 0
    ns = 0
    !
    do i=1, n_stations
      call sic_ke (line,iopt_stations,i,statn,l,.true.,error)
      if (error) return
      if (l.gt.0) then !! (lenc(statn).gt.0)then
        ns = ns+1
        call sic_blanc(statn,l)
        stations_in(ns) = statn(1:l)
        istation(ns) = -1
      endif
    enddo
    nstat_in = ns
    if (nstat_in.eq.0) then
      call map_message(seve%e,rname,'No stations')
      error = .true.
      return
    endif
  endif
  !
  ! /SIZES size1 nsize1 size2 nsize2 ...
  ! Compute minimum valid UV spacing from dish sizes. For inhomogeneous arrays
  ! (i.e. for the VLT) this should be done for each baseline.
  uvt%in%nsize=1
  uvt%in%nant_size(1) = mstat
  uvt%in%sizes(1) = 0.   ! default set to no size
  ! Part related to limit in delay line
  throw = 2.0*au_m               ! essentially, ignore delay (radio interferometers)
  uvt%in%offset= au_m                   ! so the dl max is +- 1 au
  ! Note that OFFSET and THROW are updated
  !
  ! Defaults for some observatories we know of. Note that there is no external
  ! definition of THROW, nor different THROWS for pairs of telescopes.
  select case (obsname(1:4))
  case ('BURE','NOEM','PDBI')
    uvt%in%sizes(1) = 15.0
  case ('ALMA') 
    uvt%in%sizes(1) = 12.0
  case ('ACA ') 
    uvt%in%sizes(1) = 7.0
  case ('VLA ')
    uvt%in%sizes(1) = 25.0
  case ('SMA ')
    uvt%in%sizes(1) = 6.0
  case ('NGVL') 
    uvt%in%sizes(1) = 18.0
  case ('PARA','VLT ')
    ! Assume Main UT telescopes for the time being...
    uvt%in%nsize = 2
    uvt%in%nant_size(1) = 4
    uvt%in%sizes(1) = 8.0
    uvt%in%nant_size(2) = 2
    uvt%in%sizes(2) = 1.5
    throw   = 127
    uvt%in%offset = 0.0
  case ('PTI ') 
    uvt%in%sizes(1) = 0.40
    throw = 76.0               ! 2 delay lines
    uvt%in%offset = 0.0
  case ('GI2T') 
    uvt%in%sizes(1) = 1.50
    throw = 6.0                ! 2 delay lines
    uvt%in%offset = 0.0
  case ('IOTA')
    uvt%in%sizes(1) = 0.45
    throw = 3.9                ! new iota small delay ?
    uvt%in%offset = 0.0
  case ('USER') 
    uvt%in%sizes(1) = diam
  end select
  ! Here one can update the default OFFSET:
  ! option /OFFSET
  ! Load the value of the fixed delay line
  if (uvt%in%do_offset) then
    call sic_r4 (line,iopt_offset,1,uvt%in%offset,.true.,error)
    if (error) then
      call map_message(seve%e,rname,'No valid offset given')
      return
    endif
  endif
  !
  ! Size of the antennas (mostly for shadowing)
  if (uvt%in%do_size) then
    if (sic_narg(iopt_size).eq.1) then
      ! 1 size for all the antennas
      call sic_r4(line,iopt_size,1,uvt%in%sizes(1),.true.,error)
      if (error) return
      uvt%in%nant_size(1) = mstat
      nsize = 1
    else if (mod(sic_narg(iopt_size),2).ne.0) then
      call map_message(seve%e,rname,'Option /SIZE requires an even number arguments')
      call map_message(seve%e,rname,'/SIZE size1 number1 [size2 number2 ...]')
      error=.true.
      return
    else
      nsize = 0
      i = 1
      do while(uvt%in%nsize.lt.msize .and. i.lt.sic_narg(iopt_size))
        ! /SIZE argument SIZE and number of antennas of this size
        nsize = nsize+1
        ! Read first argument of pair: size
        call sic_r4(line,iopt_size,i,uvt%in%sizes(nsize),.true.,error)
        if (error) return
        i = i+1
        ! Read 2nd argument of pair: number of antennas with this part
        call sic_i4(line,iopt_size,i,uvt%in%nant_size(nsize),.true.,error)
        if (error) return
        i = i+1
      enddo
    endif
    check_nsize=0
    do i=1,nsize
      check_nsize=check_nsize+uvt%in%nant_size(i)
    enddo
    if (check_nsize.lt.nstat_in) then
      call map_message(seve%e,rname,'The number of defineds sizes does not match the number of used antennas')
      return
    endif
    uvt%in%nsize=nsize
  endif
  if (uvt%in%sizes(1).eq.0) then
    call map_message(seve%w,rname,'Antenna size unknown. No shadowing '//  &
    'warnings will be given.')
  endif
  !
  ! HORIZON option input  
  if (uvt%in%do_hori) then
    call sic_r4  (line,iopt_hori,1,hori,.true.,error)
    if (error) return
    if (hori.gt.90) then
      call map_message(seve%e,rname,'Sourve elevation cannot be higher than 90 degrees')
      hori = hori_min
      error=.true.
      return
    endif
    if (hori.lt.hori_min) then
      hori = hori_min 
      write (mess,'(a,1x,i2.0,1x,a)') 'Minimum elevation set to',hori_min,'degrees'
      call map_message(seve%w,rname,mess)
    endif
  endif
  uvt%in%horizon = hori
  !
  ! option /HOUR_ANGLE
  if (uvt%in%do_hour) then
    call sic_r4 (line,iopt_hour,1,hh1,.true.,error)
    if (error) return
    hh2=-hh1
    ! default is symetric wrt transit
    call sic_r4 (line,iopt_hour,2,hh2,.false.,error)
    if (error) return
    uvt%in%in_h1=min(hh1,hh2)
    uvt%in%in_h2=max(hh1,hh2)    
  endif
  !
  ! /INTEGRATION Option
  if (uvt%in%do_int) then
    call sic_r4 (line,iopt_int,1,integ_time,.true.,error)
    if (error) return
    if (integ_time.le.0) then
      call map_message(seve%e,rname,'integration time should be longer than 0')
      error=.true.
      return
    endif
  endif
  uvt%in%integ_time = integ_time
  write(mess,'(A,1PG10.3,A)') 'Integration time ',uvt%in%integ_time,' min'
  call map_message(seve%i,rname,mess)
  !
  inttime = uvt%in%integ_time*60. ! needed for atm computation in /weight, full mode
  !
  ! /WEIGHT option
  uvt%in%wkey = 1
  if (uvt%in%do_weight) then
    call sic_ke (line,iopt_weight,1,chain,nc,.true.,error)
    if (error) return
    call sic_ambigs(rname,chain,name,uvt%in%wkey,weight,mw,error)
    if (error) return
    call map_message(seve%i,rname,'Weighting mode is '//name)
    if (name.eq.'FULL') then
      call sic_r4 (line,iopt_weight,4,taut,.false.,error)
      if (taut.lt.0.or.taut.gt.5) then
        write(mess,'(A,1PG10.2,A)') 'Invalid zenith opacity ',taut,'; reset to 0.05'
        call map_message(seve%w,rname,mess)
        taut = 0.05
      endif
      call sic_r4 (line,iopt_weight,3,bandwidth,.true.,error)
      if (error) return
      call sic_r4 (line,iopt_weight,2,jy_per_k,.true.,error)
      if (error) return       
      ! Make sure the Frequencies are set properly by default
      if (freq.ne.freqs) then
        freqs = freq
        freqi = freq
        gim   = 0.0
      endif
      !
      call astro_check_tsys ! Verify input parameters
    else
      if (sic_present(iopt_weight,2)) then
        call map_message(seve%e,rname,'Too many arguments for option /WEIGHT')
        error=.true.
        return
      endif
    endif
  else
    bandwidth = 1.0
  endif
  !
  ! END OF COMMAND PARSING
  !
  flag = 0
  !
  ! START OF WORK
  !
  ! 1. Check that source goes above the elevation limit and that 
  !    there is no problem with hour angle limits
  decs = decd*pi/180.d0
  latitud = lonlat(2)
  hmin = astro_lever(sngl(decs),latitud,uvt%in%horizon)
  if (hmin.ge.0) then
    call map_message(seve%e,rname,'Source is not visible')
    error = .true.
    return
  endif
  hmax = -hmin
  ! Default range is rise to set
  uvt%in%h1=hmin
  uvt%in%h2=hmax
  ! Limit the range if requested
  if (uvt%in%do_hour) then
    if (uvt%in%in_h1.lt.hmin) then
      write(mess,'(A,1PG10.3)') 'Source rises only at ',hmin
      call map_message(seve%w,rname,mess)      
    endif
    uvt%in%h1=max(uvt%in%in_h1,hmin)
    if (uvt%in%in_h2.gt.hmax) then
      write(mess,'(A,1PG10.3)') 'Source sets at ',hmax
      call map_message(seve%w,rname,mess)
    endif
    uvt%in%h2=min(uvt%in%in_h2,hmax)
  endif
  !
  ! 2. Compute Hour angle range (and Time stamps)
  ! to allow any integration time
  frac = uvt%in%integ_time/60
  !
  nh = 0
  h = pi*uvt%in%h1/12.0           
  muv = abs(uvt%in%h2-uvt%in%h1)/frac + 2 ! Number of time stamps
  allocate(zch(muv),zsh(muv),stat=ier)
  !
  do while (h.le.pi*uvt%in%h2/12.0)
    ch = cos(h)
    sh = sin(h)
    nh = nh + 1
    zch(nh) = ch
    zsh(nh) = sh
    h = h+pi*frac/12.0
  enddo
  !
  ! Get best coverage from header Line of station file
  call uv_get_arraysize(rname,fstation,array,nskip,poff,error)
  if (error) return
  !
  if (uvt%in%do_frame) then
    ! Frame : Reset coverage and station list
    call uv_reset_plot(rname,uvt%in,array,extr,freq,error)
    array = extr ! Update limit ?
    if (error) return
    oldlis = ' '
  else
    oldlis = stalis
  endif
  !
  ! Get and plot stations
  if (uvt%in%do_frame) then
    call sic_get_real('page_x',px,error)
    if (px.gt.21) then
       call gr_exec('SET BOX 20 30 9 19')
    else
       call gr_exec('SET BOX 3 12 18 28')
    endif
    if (gr_error()) then
      error=.true.
      return
    endif
    !
    write(chain,'(A,4(1X,1PG13.6))') 'LIMITS ', &
      & -array+poff(1),array+poff(2),-array+poff(3),array+poff(4)
    ! poff depends on observatory station file format
    !
    call gr_exec1(chain)
    if (gr_error()) then
      error=.true.
      return
    endif
    do_station = .true.
  else
    do_station = .false.
  endif
  if (do_station) call gr_segm('ARRAY',error)
  ! Init found variable
  found = .false.
  ! Useful values for conversion/plots
  uvt%ang%sd = sin(decs)
  uvt%ang%cd = cos(decs)
  uvt%ang%sp = sin(pi*(lonlat(2))/180.0d0)
  uvt%ang%cp = cos(pi*(lonlat(2))/180.0d0)
  !
  ! Init the reading of the station file
  iline = 0
  nn = 0
  iused = 1
  nused = 0
  ier = sic_getlun (lun)
  ier = sic_open(lun,fstation,'OLD',.true.)
  if (ier.ne.0) then
    write (mess,'(a,1x,a)') 'Troubles opening station file:',fstation
    call map_message(seve%e,rname,trim(mess))
    goto 998
  endif
  nfilled=0
  xvla = 0
  yvla = 0
  zvla = 0
  !
  do while (.true.)
    read(lun,'(a)',iostat=ier) clu
    if (ier.lt.0)  exit      ! EOF
    if (ier.ne.0)  then
      call map_message(seve%e,rname,'Troubles reading station coordinates')
      goto 998  ! Error reading line
    endif
    iline = iline+1
    if (clu(1:1).eq.'!')  then
      if (index(clu,'MODE').ne.0) then
        nlu = index(clu,'=')+2
        cmode = clu(nlu:nlu+4)
      endif
      cycle  ! ignore comments
    endif
    if (iline.le.nskip) cycle ! ignore first line - number depends on file format
    nlu = len_trim(clu)
    if (nlu.eq.0)  cycle     ! ignore empty lines
    !
    select case(obsname)
    case ('BURE','NOEMA','SMA') 
      ! BURE format: 4 columns
      read(clu(1:nlu),*,iostat=ier)  name,xx,yy,zz
      tt = 0.0
    case ('VLA','JVLA')  
      ! VLA format: antenna size in Col 4, name in Col 5
      read(clu(1:nlu),*,iostat=ier)  dx,dy,dz,tt,name
      !
      ! Refer to the Center N01
      xvla = -1601185.553970d0
      yvla = -5041978.191573d0
      zvla =  3554876.382645d0 
      dx = dx-xvla
      dy = dy-yvla
      dz = dz-zvla        
      !
      ! Convert these DX,DY,DZ to our required XX,YY,ZZ
      xx =  uvt%ang%sp * dy - uvt%ang%cp * dz
      yy = -dx
      zz =  uvt%ang%cp * dy + uvt%ang%sp * dz
    case ('USER')
      if (cmode.eq.'GEO ') then
        read(clu(1:nlu),*,iostat=ier)  dx,dy,dz,tt,name
        !
        ! Refer to First Station
        if (iline.eq.nskip+1) then
          xvla = dx 
          yvla = dy 
          zvla = dz
        endif
        dx = dx-xvla
        dy = dy-yvla
        dz = dz-zvla        
        !
        ! Convert these DX,DY,DZ to our required XX,YY,ZZ
        xx =  uvt%ang%sp * dy - uvt%ang%cp * dz
        yy = -dx
        zz =  uvt%ang%cp * dy + uvt%ang%sp * dz
      else
        read(clu(1:nlu),*,iostat=ier)  name,xx,yy,zz,tt
      endif
    case default
      ! ALMA format: at least 5 columns (antenna size in column 5)
      read(clu(1:nlu),*,iostat=ier)  name,xx,yy,zz,tt
    end select 
    if (ier.ne.0) then
      call map_message(seve%w,rname,'Could not decode line: '//clu)
      cycle
    endif
    !
    take = .false.
    nn = nn+1
    if (uvt%in%do_all) then
      ntake = nn
      take = .true.
    else
      ntake = 0
      do i=1, nstat_in
        if (uvt%in%do_stations.and.nn.eq.istation(i)) then
          ! station entered by index and option station
          take=.true.
          ntake=i
          exit
        endif
        if (.not.uvt%in%do_stations) then
          ! station entered by name as command argument
          call uv_match_station(rname,uvt%in,name,stations_in(i),take,error)
          if (error) return
          if (take) then
            ntake=i
            exit
          endif
        endif
      enddo
    endif
    if (take) then
      ! Get the station coordinates
      nfilled=nfilled+1
      uvt%stations(ntake)%name = name
      uvt%stations(ntake)%x = xx
      uvt%stations(ntake)%y = yy
      uvt%stations(ntake)%z = zz
      uvt%stations(ntake)%t = tt
      uvt%stations(ntake)%found = .true.
      ! 
      ! Check size of the current antenna
      if (nused.ge.uvt%in%nant_size(iused)) then
        iused = iused+1
        nused = 0
      endif
      nused = nused+1
      uvt%stations(ntake)%asize = uvt%in%sizes(iused)
      !
      ! Plot the station position
      if (do_station) then
        call gr_set_marker (4,3,.3)
        if (uvt%in%do_size) then
          ! Compute marker size to try represent the respective size of the dish
          ! vs the size of the array:
          psize = uvt%stations(ntake)%asize*10/(2*array)  ! box is 10 cm...
          if (psize.gt.0.1) then
            call gr_set_marker (20,3,psize)
          endif
        endif
        ! Draw the marker
        xm(1) = yy
        ym(1) = zz*uvt%ang%cp-xx*uvt%ang%sp
        call gr4_marker(1,xm,ym,0.,-1.0)
      endif
    elseif (do_station) then     
      ! station not selected : only a square to mark the position
      call gr_set_marker(4,0,.1)
      xm(1) = yy
      ym(1) = zz*uvt%ang%cp-xx*uvt%ang%sp
      call gr4_marker(1,xm,ym,0.,-1.0)
    endif
  enddo  ! end of loop on station file lines
  !
  !
  close(unit=lun)
  call sic_frelun (lun)
  if (do_station) call gr_segm_close(error)
  !
  if (uvt%in%do_all) then
    stalis='ALL STATIONS'
    uvt%n_stations=nfilled
  else
    if (nstat_in.eq.nfilled) then
      uvt%n_stations=nstat_in
    else
      write (mess,'(a)') 'Problems with input station list'
      do i=1,nstat_in-1
        do j=i+1,nstat_in
          if (stations_in(i).eq.stations_in(j)) then
            write (mess,'(a,a,a)') 'Station ',trim(stations_in(i)),' requested several times'   
          endif
        enddo
      enddo
      call map_message(seve%e,rname,mess)
      error=.true.
      return
    endif
  ! Build the line with all stations that were entered AND which are found in station file
    k = 0
    do i=1, uvt%n_stations
      if (uvt%stations(i)%found) then
        stalis(k+1:) = uvt%stations(i)%name//'-'
        call sic_black(stalis,k)
        if (i.eq.floor(uvt%n_stations/2.)) then
          ! get index of half antenna list place
          nces=k
        endif
      else
        call map_message(seve%f,rname,'Station not found: '//uvt%stations(i)%name)
        error=.true.   ! for GTVIEW and other problems...
        return 
      endif
    enddo
    nc = k-1
  endif
  !
  if (uvt%in%do_offset.and.uvt%in%offset.gt.0.0.and.uvt%in%offset.lt.au_m) then
    write (delay_mess,102) uvt%in%offset
    call sic_noir(delay_mess,nc)
  else
    delay_mess=''
  endif
  !
  ! Draw legend:  stations used, source declination and frequency
  if (do_plot) then
    call gr_exec1('pen /colo '//char(ichar('0')+icolour))
    call astro_uv_legend (rname,freq,decs,& 
      & stalis,oldlis,delay_mess,uvt%n_stations, config_count,nc,nces,error)
    if (error) return
    !
    ! Plot coverage
    ! Consider setting marker size to equivalent dish size ?
    !   Too difficult for ALMA  (12 m for 12 km)
    ! size is a ratio
    call gr_exec('SET BOX 4 19 3 18')
    write(chain,'(A,4(1X,1PG13.6))') 'LIMITS ',-extr,extr,-extr,extr
    call gr_exec1(chain)
    if (gr_error()) then
      error=.true.
      return
    endif
    call gr_segm('UVTRACK',error)
  endif
  !
  uvt%stations(1)%t=uvt%stations(1)%t+uvt%in%offset
  nvis = 0
  table_ok = uvt%in%do_table
  if (table_ok) then
    ! Size of Output Table. Must be computed exactly, since we
    ! do not want null entries at the end. we must take into account here
    ! rejected samples due to shadowing and/or delay line THROW.
    ! First loops just to get the number of visilities
    do k = 1,nh
      ! need update for each h
      uvt%ang%zsh=zsh(k)
      uvt%ang%zch=zch(k)
      !
      ! Reset complete variable at each h
      do i=1,uvt%n_stations-1
        complete(i) = uvt%stations(i)%found
        do j=i+1,uvt%n_stations
          complete(j) = uvt%stations(j)%found
        enddo
      enddo
      !
      ! Check for shadowing
      do i=1,uvt%n_stations-1
        if (complete(i)) then
          do j=i+1,uvt%n_stations
            if (complete(j)) then
              call uv_check_shadow(rname,uvt%ang,uvt%stations(i),uvt%stations(j),complete(i),complete(j),error)
              ! complete = false means that antenna is shadowed at the present h
              if (error) return
            endif
          enddo
        endif
      enddo
      !
      ! Now, Take in account max delay of Delay lines
      do i=1,uvt%n_stations-1
        if (complete(i)) then
          do j=i+1,uvt%n_stations
            if (complete(j)) then
              delay_ok=.false.
              call uv_check_delay(rname,uvt%ang,uvt%stations(i),uvt%stations(j),uvt%stations(1),throw,delay_ok,error)
              if (error) return
              if (delay_ok) then
                nvis=nvis+1
              endif
            endif
          enddo
        endif
      enddo
    enddo
    !
    if (icount.eq.0) then
      write(mess,'(A,A,A,I0,A)')  &
        'Initialising ',trim(file),' with ',nvis,' (u,v) points'
      call map_message(seve%i,rname,mess)
      call astro_init_table(xtab,file,nvis,decs,freq,bandwidth,obsname,nfield,error)
    else
      write(mess,'(A,I0,A,A)')  &
        'Adding ',nvis,' (u,v) points to table ',trim(file)
      call map_message(seve%i,rname,mess)
      call astro_extend_table(xtab,file,nvis,decs,freq,error)
    endif
    if (error) then
      call map_message(seve%e,rname,'Cannot open output Table')
      call astro_close_table(xtab)
      return
    endif
    !
    allocate(myvisi(visi_size,nvis),stat=ier)
    if (ier.ne.0) then
      call map_message(seve%w,rname,'Memory allocation failure for Table')
      call astro_close_table(xtab)
      error = .true.
      return
    endif
  else
    allocate(myvisi(1,1),stat=ier)    ! To avoid stride initialization warning
  endif
  !
  call jjdate(jnow_utc, date)
  call ndatec(date, d_chain, error)
  call gag_fromdate(d_chain,idate,error)
  idate = idate+icount
  rdate = float(idate)
  !
  ! OK, redo for good now!
  ivisi = 0
  ih = 1.0/12.0/frac   ! A coverage every 5 minutes
  do k = 1,nh
    uvt%ang%zsh=zsh(k)
    uvt%ang%zch=zch(k)
    do_shadow = (mod(k,ih).eq.1)    ! Print shadowing only every 5 minutes
    do_cover  = do_plot .and. do_shadow   ! and UV coverage too, for speed.
    !
    ! Check for stations
    complete(1:uvt%n_stations) = uvt%stations(1:uvt%n_stations)%found
    !
    ! Source elevation
    !
    call amset(lonlat(2),amat)
    avec(1) = zch(k)*uvt%ang%cd
    avec(2) = zsh(k)*uvt%ang%cd
    avec(3) = uvt%ang%sd
    call matmul(amat,avec,bvec,1)
    call dangle(az,el,bvec)
    !
    if (uvt%in%wkey.eq.3) then
      ! Full mode for weight: atm computation
      call astro_setuv_weight(el)
    endif
    !
    ! Check for shadowing
    do i=1,uvt%n_stations-1
      if (complete(i)) then
        do j=i+1,uvt%n_stations
          if (complete(j)) then
            call uv_check_shadow(rname,uvt%ang,uvt%stations(i),uvt%stations(j), &
              & complete(i),complete(j),error)
            ! complete = false means that antenna is shadowed at the present h
            if (error) return
            if (do_shadow) then
              if (.not.(complete(i))) then
                write(mess,'(A,I0,A,I0)') 'Antenna ',i,' is shadowed by ',j
                call map_message(seve%d,rname,mess)
              else if  (.not.(complete(j))) then
                write(mess,'(A,I0,A,I0)') 'Antenna ',j,' is shadowed by ',i
                call map_message(seve%d,rname,mess)
              endif
            endif
          endif
        enddo
      endif
    enddo
    !
    ! Fill the table now and Plot, Take in account max delay of Delay lines
    jf = 0
    do i=1,uvt%n_stations-1
      if (complete(i)) then
        do j=i+1,uvt%n_stations
          if (complete(j)) then
            delay_ok=.false.
            call uv_check_delay(rname,uvt%ang,uvt%stations(i),uvt%stations(j),uvt%stations(1),throw,delay_ok,error)
            if (error) return
            psize = sqrt(uvt%stations(i)%asize*uvt%stations(j)%asize)*10/(2*extr)
            ! Plot 'bad' points (throw unable to follow delay) only if DO_SIZE
            call uv_do_baseline(rname,uvt%ang,uvt%stations(i),uvt%stations(j),uk,vk,wk,error)
            if (error) return
            !
            ! Plot Considerations
            if (do_cover) then
              if (.not.delay_ok) then
                if (uvt%in%do_size) then
                  ! Plot the excluded points in case of do_size
                  call gr_set_marker (4,1,0.05)
                  flag=0
                else
                  flag=1         ! do not plot
                endif
              else 
                flag=0
                if (psize.lt.0.0001 .or. .not.uvt%in%do_size) then
                  call gr_set_marker (4,0,0.05)
                else
                  call gr_set_marker (20,0,psize)
                endif
              endif
            endif
            !            
            uvmin = uvt%stations(i)%asize/2.+uvt%stations(j)%asize/2.
            if ((uk**2+vk**2).le.uvmin**2) then
              call map_message(seve%d,rname,'---- Y A UN PROBLEME ----')
            else
              if (table_ok.and.delay_ok) then
                ivisi = ivisi+1
                if (nfield.gt.1) then
                  jf = mod(k,nfield)+1
                  theoff = offs(:,jf) 
                endif
                call fill_table (uk,vk,wk,rdate,(uvt%in%integ_time*60*k),i,j,  &
                myvisi(:,ivisi),el,inttime,uvt%in%wkey,theoff)
              endif
              if (do_cover) then
                if (flag.eq.0) then
                  xm(1:2) = [uk,-uk]
                  ym(1:2) = [vk,-vk]
                  call gr4_marker(2,xm,ym,0.,-1.0)
                endif
                flag=0
              endif
            endif
          endif
        enddo
      endif
    enddo
    !
  enddo
  if (do_plot) then
    call gr_segm_close(error)
    call gr_pen(icolour=0,error=error)
  endif
  !
  if (table_ok) then
    call gdf_write_data(xtab,myvisi,error)
    call astro_close_table (xtab)
    deallocate (myvisi, stat=ier)
  endif
  return
  !
  998   continue
  call putios('E-UV_TRACK, ',ier)
  close(unit=lun)
  call sic_frelun (lun)
  return
  102   format (', DL set @ ',f12.5,' m')
end subroutine astro_uv
!
subroutine uv_do_baseline(rname,uvang,uvsta_i,uvsta_j,uk,vk,wk,error)
  use gbl_message
  use gkernel_interfaces
  use ast_astro
  use imager_interfaces, except_this=>uv_do_baseline
  !---------------------------------------------------------------------
  ! @ private
  !*
  ! ASTRO
  !
  ! compute baseline coordinates
  !!
  !---------------------------------------------------------------------
  character(len=*), intent(in)  :: rname        !! command name
  type(uv_track_angles_t), intent(in) :: uvang  !! current angle to compute distance
  type(uv_track_station_t), intent(in) :: uvsta_i,uvsta_j   !! current stations
  real(kind=4), intent(inout) :: uk,vk,wk       !! u,v,w coordinates
  logical, intent(inout) :: error               !! Logical error flag
  !
  ! Local ---
  real(kind=4) :: xx,yy,zz
  !
  ! Code ----
  xx = uvsta_j%x-uvsta_i%x
  yy = uvsta_j%y-uvsta_i%y
  zz = uvsta_j%z-uvsta_i%z
  uk = uvang%zsh*xx + uvang%zch*yy
  vk = uvang%sd*(-uvang%zch*xx+uvang%zsh*yy)+uvang%cd*zz
  wk = uvang%cd*(-uvang%zch*yy+xx*uvang%zch)+zz*uvang%sd
  !
end subroutine uv_do_baseline
!
subroutine uv_check_shadow(rname,uvang,uvsta_i,uvsta_j,ok_i,ok_j,error)
  use gbl_message
  use gkernel_interfaces
  use ast_astro
  use imager_interfaces, except_this=>uv_check_shadow
  !---------------------------------------------------------------------
  ! @ private
  !*
  ! ASTRO
  !
  ! check whether the 2 antennas on stations i,j have shadowing
  !!
  !---------------------------------------------------------------------
  character(len=*), intent(in)  :: rname     !! command name
  type(uv_track_angles_t), intent(in) :: uvang   !! current angle to compute distance
  type(uv_track_station_t), intent(in) :: uvsta_i,uvsta_j   !! current stations
  logical, intent(inout) :: ok_i,ok_j        !! Shadow flags
  logical, intent(inout) :: error            !! Logical error flag
  !
  ! Local ---
  real(kind=4) :: xx,yy,zz,uk,vk,uvmin,test
  !
  ! Code ----
  uvmin = uvsta_i%asize/2.+uvsta_j%asize/2.
  xx = uvsta_j%x-uvsta_i%x
  yy = uvsta_j%y-uvsta_i%y
  zz = uvsta_j%z-uvsta_i%z
  uk = uvang%zsh*xx + uvang%zch*yy
  vk = uvang%sd*(-uvang%zch*xx+uvang%zsh*yy)+uvang%cd*zz
  if ((uk**2+vk**2).le.uvmin**2) then
    ! shadowing happens, check who shadows who
    test = (xx*uvang%zch - yy*uvang%zsh)*uvang%cd + zz*uvang%sd
    if (test.gt.0.0) then
      ok_i = .false. 
    else
      ok_j = .false.
    endif
  endif
end subroutine uv_check_shadow
!
subroutine uv_check_delay(rname,uvang,uvsta_i,uvsta_j,uvsta_ref,throw,delay_ok,error)
  use gbl_message
  use gkernel_interfaces
  use ast_astro
  use imager_interfaces, except_this=>uv_check_delay
  !---------------------------------------------------------------------
  ! @ private
  !*
  ! ASTRO
  !
  ! check whether the delay is not bigger than the limit (for observatories using fixed delay lines)
  !!
  !---------------------------------------------------------------------
  character(len=*), intent(in)  :: rname     !! command name
  type(uv_track_angles_t), intent(in) :: uvang   !! current angle to compute distance
  type(uv_track_station_t), intent(in) :: uvsta_i,uvsta_j,uvsta_ref   !! current stations
  real(kind=4), intent(in) :: throw   !! Maximum allowed delay
  logical, intent(inout) :: delay_ok  !! Delay condition
  logical, intent(inout) :: error     !! Logical error flag
  !
  ! Local ---
  real(kind=4) :: xx,yy,zz,wkj,wki
  !
  ! Code ----
  xx = uvsta_j%x-uvsta_ref%x
  yy = uvsta_j%y-uvsta_ref%y
  zz = uvsta_j%z-uvsta_ref%z
  wkj = uvang%cd*(-uvang%zsh*yy+uvang%zch*xx)+uvang%sd*zz+uvsta_ref%t-uvsta_j%t
  !
  xx = uvsta_i%x-uvsta_ref%x
  yy = uvsta_i%y-uvsta_ref%y
  zz = uvsta_i%z-uvsta_ref%z
  wki = uvang%cd*(-uvang%zsh*yy+uvang%zch*xx)+uvang%sd*zz+uvsta_ref%t-uvsta_i%t
  !
  ! Count only visibility doable wrt delay lines
  if ((wkj.ge.0).and.(wkj.le.throw).and. (wki.ge.0).and.(wki.le.throw))  delay_ok=.true.
  ! 
end subroutine uv_check_delay
!
subroutine uv_match_station(rname,uvin,fname,istation,match,error)
  use gbl_message
  use gkernel_interfaces
  use ast_astro
  use imager_interfaces, except_this=>uv_match_station
  !---------------------------------------------------------------------
  ! @ private
  !*
  ! ASTRO
  !
  ! check if station of the current line in the file matches the requested station
  !!
  !---------------------------------------------------------------------
  character(len=*), intent(in)  :: rname     !! command name
  type(uv_track_in_t), intent(in) :: uvin
  character(len=*) :: fname         !! station name as in station file
  character(len=*) :: istation      !! station name as user input
  logical, intent(inout) :: match   !! Match indicator
  logical, intent(inout) :: error   !! Logical error flag
  !
  ! Local ---
  character(len=256) :: chain
  character(len=3) :: sname
  !
  ! Code ----
  if (fname.eq.istation) then
    match=.true.
  else if ((obsname.eq.'BURE'.or.obsname.eq.'NOEMA').and.uvin%three_digit_name_compatible) then
    ! 01-jul-2022. Mnemonic station names changed from [E,W,N]+2 digits to [E,W,N]+3 digits in station files
    ! The following trick has been written to ensure backward compatibility reasons
    ! Will be removed after a period of ~ 1--2 yr
    if (len_trim(fname).eq.4.and.len_trim(istation).eq.3.and.fname(2:2).eq.'0') then
      sname(1:1)=fname(1:1)
      sname(2:3)=fname(3:4)
      if (sname.eq.istation) then
        call map_message(seve%w,rname,'The 3 characters format for NOEMA stations is obsolescent')
        write (chain,'(a,1x,a,1x,a,1x,a)') 'Station',trim(istation),'is now called',trim(fname)
        call map_message(seve%w,rname,chain)
        match=.true.
      endif
    endif
  endif
  !
end subroutine uv_match_station
!
subroutine uv_reset_plot(rname,uvin,arr,lextr,ff,error)
  use gbl_message
  use gkernel_interfaces
  use ast_astro
  use imager_interfaces, except_this=>uv_reset_plot
  !---------------------------------------------------------------------
  ! @ private
  !*
  ! ASTRO
  !
  ! reset the plot upon /frame option
  !!
  !---------------------------------------------------------------------
  character(len=*), intent(in)  :: rname   !! command name
  type(uv_track_in_t), intent(in) :: uvin
  real(kind=4), intent(in) :: arr  !! Desired radius of displayed region - 0 means automatic
  real(kind=4), intent(inout) :: lextr  !! Radius of displayed region
  real(kind=8), intent(inout) :: ff     !! Unused
  logical, intent(inout) :: error       !! Logical error flag
  !
  ! Local
  character(len=256) :: chain
  !
  lextr = arr
  if (uvin%user_array.gt.0) then
    ! use user value
    lextr=uvin%user_array
  endif  
  call gr_exec ('CLEAR DIRECTORY')
  write(chain,'(A,4(1X,1PG13.6))') 'LIMITS ',-lextr,lextr,-lextr,lextr
  call gr_exec1(chain)
  if (gr_error()) then
    error=.true.
    return
  endif
  call gr_exec1('SET BOX 4 19 3 18')
  if (gr_error()) then
    error=.true.
    return
  endif
  call gr_exec1('TICKS 0 0 0 0 ')
  if (error .or. freq.eq.0.0) then
    error = .false.
    freq = 0.0
    call gr_exec1('BOX')
  else
    call uvbox (lextr,freq)
  endif
  !
end subroutine uv_reset_plot
!
subroutine uv_get_arraysize(rname,fsta,arr,nign,off,error)
  use gbl_message
  use gkernel_interfaces
  use ast_astro
  use imager_interfaces, except_this=>uv_get_arraysize
  !---------------------------------------------------------------------
  ! @ private
  !*
  ! ASTRO
  !
  ! extract useful info from station file
  !!
  !---------------------------------------------------------------------
  character(len=*), intent(in)  :: rname     !! command name
  character(len=*), intent(in) :: fsta       !! station file name
  real(kind=4), intent(inout) :: arr         !! Radius of configuration
  integer(kind=4), intent(inout) :: nign     !! Number of lines to be ignored at beginning of file
  real(kind=4), intent(inout) :: off(4)      !! offset wrt to origin to plot positions of stations
  logical, intent(inout) :: error            !! Logical error flag
  !
  ! Local ---
  integer(kind=4) :: ier,lun,iequal,i
  character(len=256) :: mess,clu
  real(8) :: value
  !
  ! Code ----
  ier = sic_getlun (lun)
  ier = sic_open(lun,fsta,'OLD',.true.)
  if (ier.ne.0) then
    write (mess,'(a,1x,a)') 'Troubles opening station file:',fsta
    call map_message(seve%e,rname,trim(mess))
    goto 998
  endif
  !
  select case(obsname)
  !
  case ('BURE','NOEMA','SMA') 
    read (lun,*,iostat=ier) arr
    nign=1
    off(1) = 0
    off(2) = 0
    off(3) = 0
    off(4) = 0
    if (ier.ne.0)  then
      write (mess,'(a,1x,a)') 'Troubles reading max baseline in',fsta
      call map_message(seve%e,rname,mess)
      write (mess,'(a,1x,a)') 'Make sure this file is made for current observatory:',obsname
      call map_message(seve%e,rname,mess)
      goto 998
    endif
  case ('ALMA','ACA') 
    ! Patch for ALMA configuration files
    ! Skip first 7 lines:
    do i=1,7
      read(lun,*,iostat=ier)
      if (ier.ne.0)  then
        write (mess,'(a,1x,a)') 'Troubles reading header part of',fsta
        call map_message(seve%e,rname,mess)
        write (mess,'(a,1x,a)') 'Make sure this file is made for current observatory:',obsname
        call map_message(seve%e,rname,mess)
        goto 998
      endif
    enddo
    read(lun,'(a)',iostat=ier) clu
    if (ier.ne.0)  then
      write (mess,'(a,1x,a)') 'Troubles reading max baseline line in',fsta
      call map_message(seve%e,rname,mess)
      write (mess,'(a,1x,a)') 'Make sure this file is made for current observatory:',obsname
      call map_message(seve%e,rname,mess)
      goto 998
    endif
    iequal = index(clu,'=')
    read(clu(iequal+1:),*,iostat=ier)  arr
    if (ier.ne.0)  then
      write (mess,'(a,1x,a)') 'Troubles reading max baseline in',fsta
      call map_message(seve%e,rname,mess)
      write (mess,'(a,1x,a)') 'Make sure this file is made for current observatory:',obsname
      call map_message(seve%e,rname,mess)
      goto 998
    endif
    arr = arr*1.2
    nign=9
    if (obsname.eq.'ALMA') then
      off(1) = 0
      off(2) = 0
      off(3) = -660
      off(4) = -660
    else if (obsname.eq.'ACA') then
      off(1) = -52
      off(2) = -52
      off(3) = -570
      off(4) = -570
    endif
  case ('JVLA','VLA') 
    read (lun,*,iostat=ier) arr
    off = 0
    nign = 1
  case ('USER')
    read (lun,*,iostat=ier)    ! Skip line
    call obs_read_key(lun,'RADIUS',value,error)
    arr = value
    off = 0
    nign = 8 ! Skip 8 lines
  case default
    arr = 0
    off = 0
    nign = 0
  end select 
  close(unit=lun)
  call sic_frelun (lun)
  return
  !
  998   continue
  call putios('E-UV_TRACK, ',ier)
  close(unit=lun)
  call sic_frelun (lun)
  !
end subroutine uv_get_arraysize
!
subroutine astro_uv_legend(rname,freq,decs,stalis,oldlis,del_mess,nused, config_count, nc,nces,error)
  use gbl_message
  use gkernel_interfaces
  use imager_interfaces, except_this=>astro_uv_legend
  use phys_const
  !---------------------------------------------------------------------
  ! @ private
  !
  !*
  ! ASTRO
  !
  ! Draw the legend (stations used, declination, frequency)
  ! at the right place according to the plot_page orientation
  !!
  !---------------------------------------------------------------------
  character(len=*), intent(in)  :: rname     !! command name
  real(kind=8), intent(in) :: freq           !! Frequency
  real(kind=8), intent(in) :: decs           !! Declination [radian]
  character(len=*), intent(in) :: stalis     !! list of used stations
  integer(kind=4), intent(in) :: nces        !! positions to split the displayed line if needed
  character(len=*), intent(in) :: oldlis     !! previous list of used stations
  character(len=*), intent(in) :: del_mess   !! message about delay if present
  integer(kind=4), intent(in) :: nused       !! number of used stations
  integer(kind=4), intent(inout) :: config_count    !! Running number of configurations being drawn
  integer(kind=4), intent(in) :: nc          !! Length of STALIS
  logical, intent(inout) :: error            !! Logical error flag
  !
  ! Local ---
  real(kind=4) :: px
  logical :: err
  character(len=200) :: chain,stafile
  integer(kind=4) :: ier
  !
  ! Code ----
  call sic_get_real('page_x',px,err)
  if (px.ge.30) then !landscape
    call gr_exec('SET BOX 20 30 3 9')
  else ! portrait
    call gr_exec('SET BOX 12 20 20 26')
  endif
  call gr_exec('limits 0 10 0 10')
  if (freq.gt.1e3) then
    write(chain,102) clight/freq/1d3
  else
    write(chain,100) freq
  endif
  call gr_exec('set char 0.5')
  call gr_exec1(chain)
  write(chain,101) sngl(decs*180d0/pi) !write in degrees
  call gr_exec1(chain)
  if (len_trim(del_mess).gt.0) then
    write(chain,103) trim(del_mess)
    call gr_exec1(chain)
  endif
  call gr_exec('set char /def')
100   format ('DRAW TEXT 1 1 "Frequency ',f5.1,' GHz" 6 /user')
102   format ('DRAW TEXT 1 1 "Wavelength ',f6.3,' microns" /user')
101   format ('DRAW TEXT 1 0 "Declination ',f5.1,' ^" 6 /user ')
103   format ('DRAW TEXT 1 2 "',a,' ^" 6 /user ')
  !
  ! Plot on two lines when more than 6 stations (and less than 13)
  call gr_exec('set char 0.4')
  if (oldlis.ne.stalis) then
    if (nused.gt.12.or.stalis.eq."ALL STATIONS") then ! ALMA or other observatory?
      config_count = config_count+2
      if (stalis.eq."ALL STATIONS") then
        chain = 'DRAW TEXT 1 1234 "'//stalis//'"   6 /user'
        write(chain(13:16),'(I4)') config_count
        call gr_exec1 (chain)
      else
        chain = 'DRAW TEXT 1 1234 "More than 12 antennas"   6 /user'
        write(chain(13:16),'(I4)') config_count
        call gr_exec1 (chain)
      endif
      config_count = config_count+1
      ier = sic_getlog('ASTRO_STATIONS',stafile)
      if (ier.ne.0) then
        call map_message(seve%e,rname,  &
             'Failure in translation of ASTRO_STATIONS logical')
        error = .true.
        return
      endif
      chain = 'DRAW TEXT 1 1234 "'//trim(stafile)//'"   6 /user'
      write(chain(13:16),'(I4)') config_count
      call gr_exec1 (chain)
    else if (nused.le.6) then !PDB = 1 line
      config_count = config_count+4
      chain = 'DRAW TEXT 1 1234 "'//stalis(1:nc) //'" 6 /user'
      write(chain(13:16),'(I4)') config_count
      call gr_exec1 (chain)
    else if (nused.le.12) then !NOEMA = 2 lines
      config_count = config_count+2
      chain = 'DRAW TEXT 1 1234 -"'//stalis(nces+1:nc) //'" 6 /user'
      write(chain(13:16),'(I4)') config_count
      call gr_exec1 (chain)
      config_count = config_count+1
      chain = 'DRAW TEXT 1 1234 "'//stalis(1:nces) //'" 6 /user'
      write(chain(13:16),'(I4)') config_count
      call gr_exec1 (chain)
    endif
  endif
  call gr_exec('set char /def')
  !
end subroutine astro_uv_legend
!
subroutine uvbox(base,freq)
  use phys_const
  use gkernel_interfaces, only : gr_error
  !---------------------------------------------------------------------
  ! @ private
  !*
  !   ASTRO
  ! Draw a Box with Lengths in Meters and kWave
  !!
  !---------------------------------------------------------------------
  real(kind=4), intent(in) :: base    !! Baseline length (m)
  real(kind=8), intent(in) :: freq    !! Frequency (MHz)
  !
  ! Local ---
  real(kind=4) :: x
  character(len=80) :: chain
  !
  ! Code ----
  call gr_exec1('SET BOX 4 19 3 18')
  if (gr_error()) return
  x = base*freq*1d6/clight
  write(chain,'(A,4(1X,1PG13.6))') 'LIMITS ',-x,x,-x,x
  call gr_exec1(chain)
  chain = 'DRAW TEXT 0 2.5 "U (k'//char(92)//'gl)" 5 /CHARACTER 8'
  call gr_exec1(chain)
  call gr_exec1('SET ORIENT 90.0')
  chain = 'DRAW TEXT 2.0 0 "V (k'//char(92)//'gl)" 5 /CHARACTER 6'
  call gr_exec1(chain)
  call gr_exec1('SET ORIENT 0')
  call gr_exec1('AXIS XU /LABEL P')
  call gr_exec1('AXIS YR /LABEL O')
  x = base
  write(chain,'(A,4(1X,1PG13.6))') 'LIMITS ',-x,x,-x,x
  call gr_exec1(chain)
  call gr_exec1('AXIS XL')
  call gr_exec1('AXIS YL')
  call gr_exec1('LABEL "U (meters)" /X')
  call gr_exec1('SET ORIENT 90.0')
  call gr_exec1('DRAW TEXT -2.0 0 "V (meters)" 5 /CHARACTER 4')
  call gr_exec1('SET ORIENT 0')
end subroutine uvbox
!
subroutine astro_close_table(x)
  use image_def
  use gkernel_interfaces, only : gdf_close_image
  !---------------------------------------------------------------------
  ! @ private
  !! ASTRO   Close the output table in UV_TRACK command
  ! To be re-written using
  !    gdf_write_image(header,array,error)
  ! AND may be also
  !    gdf_close_image(header,error)
  !---------------------------------------------------------------------
  type(gildas), intent(inout) :: x    !! Header of table to be closed
  !
  ! Local
  logical :: error
  !
  error = .false.
  call gdf_close_image(x,error)
end subroutine astro_close_table
!
subroutine astro_extend_table(x,name,nvis,dec,freq,error)
  use gildas_def
  use image_def
  use gkernel_interfaces
  use gbl_message
  use imager_interfaces, only : map_message
  !---------------------------------------------------------------------
  ! @ private
  !!  ASTRO   extend the UV table in UV_TRACK command
  !---------------------------------------------------------------------
  type(gildas),     intent(inout) :: x        !! UV Table header
  character(len=*), intent(in)    :: name     !! File name
  integer(kind=4),  intent(in)    :: nvis     !! Number of visibilities to add
  real(kind=8),     intent(in)    :: dec      !! Declination
  real(kind=8),     intent(in)    :: freq     !! Frequency
  logical,          intent(out)   :: error    !! Logical error flag
  !
  ! Local ---
  character(len=*), parameter :: rname='ASTRO_UV'
  character(len=80) :: chain
  integer(kind=index_length) :: mvis
  !
  ! Code ----
  call gildas_null(x, type='UVT')
  x%file = name
  x%loca%read = .false.
  !
  call gdf_read_gildas(x,name,'.uvt',error, data=.false.)
  if (error) return
  call gdf_close_image(x,error)
  !
  ! Couple of checks
  if (abs(x%gil%dec-dec).gt.1d-6) then
    call map_message(seve%e,rname,'Different declinations')
    error = .true.
  endif
  if (freq.ne.0.0 .and. (abs(freq-x%gil%freq*1d-3).gt.1d-6)) then
    call map_message(seve%e,rname,'Different frequencies')
    error = .true.
  endif
  if (error) goto 100
  !
  ! Compute new size, and remember there may be more preallocated data
  ! than used in the table to be appended
  write(chain,1001) x%gil%dim(2),nvis
1001 format('Old table size ',i8,' Adding ',i8)
  call map_message(seve%i,rname,chain)
  !
  mvis = x%gil%dim(2)+nvis
  !
  call gdf_extend_image (x,mvis,error)
  if (error) goto 100
  !
  x%gil%nvisi = mvis  ! Update number of visibilities
  call gdf_update_header(x,error)
  !
  ! Map only new region
  x%blc(1) = 1
  x%blc(2) = x%gil%dim(2)+1-nvis
  x%trc(1) = x%gil%dim(1)
  x%trc(2) = x%gil%dim(2)
  return
  !
  100   call map_message(seve%e,rname,'Table extension failed')
end subroutine astro_extend_table
!
subroutine astro_init_table(xima,name,nvis,dec,freq,band,obs,nfield,error)
  use gildas_def
  use image_def
  use gkernel_interfaces
  use gbl_format
  !---------------------------------------------------------------------
  ! @ private
  !! ASTRO  Initialize UV table in UV_TRACK command
  !---------------------------------------------------------------------
  type(gildas),     intent(inout) :: xima     !! Image structure
  character(len=*), intent(in)    :: name     !! File name
  integer(kind=4),  intent(in)    :: nvis     !! Number of visibilities to write
  real(kind=8),     intent(in)    :: dec      !! Declination
  real(kind=8),     intent(in)    :: freq     !! Frequency
  real(kind=4),     intent(in)    :: band     !! Frequency resolution
  character(len=*), intent(in)    :: obs      !! Current observatory
  integer(kind=4),  intent(in)    :: nfield   !! Number of fields
  logical,          intent(out)   :: error    !! Logical error flag
  !
  ! Local ---
  integer :: i, last
  real(kind=8) :: dummy(3)
  !
  call gildas_null(xima, type = 'UVT')
  error = .false.
  !
  xima%file = name
  xima%gil%blan_words = def_blan_words
  xima%gil%extr_words = def_extr_words
  xima%gil%desc_words = def_desc_words
  xima%gil%posi_words = def_posi_words
  xima%gil%proj_words = def_proj_words
  xima%gil%spec_words = def_spec_words
  xima%gil%reso_words = def_reso_words
  xima%gil%uvda_words = 2 ! Not Zero is enough
  !
  xima%gil%dim(2) = nvis
  !
  xima%gil%eval = 0.
  xima%gil%dim(2) = nvis            
  xima%gil%ref(2) = 0.
  xima%gil%inc(2) = 1.                 
  xima%gil%val(2) = 0.
  xima%gil%ndim = 2
  xima%char%unit = 'Jy'
  xima%char%syst = 'EQUATORIAL'
  xima%gil%ptyp = p_azimuthal
  xima%gil%pang = 0.0
  xima%gil%xaxi = 0
  xima%gil%yaxi = 0
  xima%gil%faxi = 1
  !
  xima%gil%dec = dec
  xima%gil%epoc = 2000.0
  xima%gil%a0 = xima%gil%ra
  xima%gil%d0 = xima%gil%dec
  xima%char%line = ' '
  xima%gil%fres = band
  if (freq.ne.0d0) then
    xima%gil%fima = (freq+12.0)*1d3
    xima%gil%freq = freq*1d3
  else
    xima%gil%fima = 102d3
    xima%gil%freq = 90d3
  endif
  xima%gil%val(1) = xima%gil%freq
  xima%gil%nchan = 1
  !
  ! Here define the order in which you want the extra "columns"
  xima%gil%column_pointer = 0
  xima%gil%column_size = 0
  xima%gil%column_pointer(code_uvt_u) = 1
  xima%gil%column_pointer(code_uvt_v) = 2
  xima%gil%column_pointer(code_uvt_w) = 3
  xima%gil%column_pointer(code_uvt_date) = 4
  xima%gil%column_pointer(code_uvt_time) = 5
  xima%gil%column_pointer(code_uvt_anti) = 6
  xima%gil%column_pointer(code_uvt_antj) = 7
  xima%gil%natom = 3
  xima%gil%nstokes = 1
  ! Extra columns
  xima%gil%fcol = 8
  last = xima%gil%fcol+xima%gil%natom * xima%gil%nchan 
  xima%gil%column_pointer(code_uvt_el) = last
  last = last+1
  xima%gil%column_pointer(code_uvt_int) = last
  if (nfield.gt.1) then
    last = last+1
    xima%gil%column_pointer(code_uvt_loff) = last
    last = last+1
    xima%gil%column_pointer(code_uvt_moff) = last
  endif
  do i=1,code_uvt_last
    if (xima%gil%column_pointer(i).ne.0) xima%gil%column_size(i) = 1
  enddo
  xima%gil%dim(1) = last
  !
  xima%gil%nvisi = nvis
  xima%gil%type_gdf = code_gdf_uvt
  call gdf_addteles(xima,'TELE',obs,dummy,error)
  call gdf_setuv (xima,error)
  xima%loca%size = xima%gil%dim(1) * xima%gil%dim(2)
  call gdf_create_image (xima,error)
end subroutine astro_init_table
!<FF>
!!subroutine newuvt_extend (xima,name,nvis,nn,ndobs,ndscan,error,lc)

!
subroutine fill_table (u,v,w,d,t,ideb,ifin,visi,el,time,wkey,offs)
!!subroutine fill_table (u,v,d,t,w,ideb,ifin,visi,e,dt,ph)
  use atm_params
  !---------------------------------------------------------------------
  ! @ private
  !! ASTRO  Add a visibility
  !---------------------------------------------------------------------
  real(kind=4),    intent(in)  :: u         !! U coordinate
  real(kind=4),    intent(in)  :: v         !! V
  real(kind=4),    intent(in)  :: w         !! W
  real(kind=4),    intent(in)  :: d         !! Date
  real(kind=4),    intent(in)  :: t         !! Time
  integer(kind=4), intent(in)  :: ideb      !! Start Antenna
  integer(kind=4), intent(in)  :: ifin      !! End Antenna
  real(kind=4),    intent(out) :: visi(:)   !! Visibility
  real(kind=8),    intent(in)  :: el        !! Elevation
  real(kind=4),    intent(in)  :: time      !! Integration time
  integer(kind=4), intent(in)  :: wkey      !! Code for Weights
  real(kind=4),    intent(in)  :: offs(2)   !! Offsets (radians)
  !
  ! 7 parameters:
  !  U, V, W, Date, Time, Ant1, Ant2
  ! 3 values:
  !  Real, Imag, Weight
  !  1.0, 0.0, 1.0
  !
  visi(1) = u
  visi(2) = v
  visi(3) = w
  visi(4) = d
  visi(5) = t
  visi(6) = ideb
  visi(7) = ifin
  visi(8) = 1.0
  visi(9) = 0.0
  if (wkey.eq.1) then
     visi(10) = 1.0
  elseif (wkey.eq.2) then
     visi(10) = sin(el)**2
  elseif (wkey.eq.3) then
     visi(10) = uvweight
  endif
  visi(11) = el
  visi(12) = time
  if (ubound(visi,1).gt.12) visi(13:14) = offs
end subroutine fill_table
!
subroutine matmul(mat,a,b,n)
  !---------------------------------------------------------------------
  ! @ private
  !
  !! ASTRO  3x3 Matrix x Vector multiplication - N gives the matrix shape
  !
  ! version 1.0  mpifr cyber edition  22 may 1977.  G.Haslam
  ! version 2.0  iram
  !
  ! this routine provides the transformation of vector a to vector b
  ! using the n dimensional direction cosine array, mat.
  !---------------------------------------------------------------------
  real(kind=8),    intent(in)  :: mat(3,3)  !! Matrix
  real(kind=8),    intent(in)  :: a(3)      !! Vector
  real(kind=8),    intent(out) :: b(3)      !! Product
  integer(kind=4), intent(in)  :: n         !! Direction
  ! Local
  integer(kind=4) :: i,j
  !
  if (n.gt.0) then
    do i=1,3
      b(i) = 0.d0
      do j=1,3
        b(i) = b(i)+mat(i,j)*a(j)
      enddo
    enddo
  else
    do i=1,3
      b(i) = 0.d0
      do j=1,3
        b(i) = b(i)+mat(j,i)*a(j)
      enddo
    enddo
  endif
end subroutine matmul
!
subroutine amset(obslat,amat)
  use ast_constant
  !---------------------------------------------------------------------
  ! @ private
  !
  !! ASTRO  provide transformation matrix from hour angle - dec into azimuth - elevation.
  !---------------------------------------------------------------------
  real(kind=8), intent(in)  :: obslat   !! iObservatory latitude in degrees
  real(kind=8), intent(out) :: amat(9)  !!
  ! Local
  real(kind=8) :: x1,y1,z1
  !
  x1=pi/180d0*obslat
  y1=dsin(x1)
  z1=dcos(x1)
  amat(1)=-y1
  amat(2)=0.d0
  amat(3)=z1
  amat(4)=0.d0
  amat(5)=-1.d0
  amat(6)=0.d0
  amat(7)=z1
  amat(8)=0.d0
  amat(9)=y1
end subroutine amset
!
subroutine dangle(along,alat,a)
  use ast_constant
  !---------------------------------------------------------------------
  ! @ private
  ! version 1.0  mpifr cyber edition  22 may 1977.
  ! see nod 2 manual page m 9.1
  ! c.g haslam       mar  1972.
  ! this routine recovers the longitude and latitude angles, along
  ! (0 - 360) and alat ( +.- 180) in degrees, which correspond to the
  ! vector a.
  !---------------------------------------------------------------------
  real(kind=8), intent(out) :: along  !
  real(kind=8), intent(out) :: alat   !
  real(kind=8), intent(in)  :: a(3)   !
  ! Local
  real(kind=8) :: aa
  !
  aa     = a(1)*a(1)+a(2)*a(2)
  aa     = dsqrt(aa)
  alat   = pi/2d0
  if (aa.ge.0.000001d0) then
    aa = a(3)/aa
    alat = datan(aa)           ! latitude in Radian
  endif
  !
  if (a(2).ne.0.d0 .or. a(1).ne.0.d0) then
    along = datan2(a(2),a(1))    ! longitude in Radian
  else
    along = 0.d0
  endif
end subroutine dangle
!
subroutine astro_check_tsys
  use atm_params
  use ast_astro
  use ast_telescope
  use gbl_message
  use imager_interfaces, only : map_message
  !
  character(len=*), parameter :: rname='UV_TRACK'
  character(len=120) :: mess
  ! integer :: ix
  !
  ! Approximate Tsys  -- 0.5 K per GHz at Zenith
  tsys = 0.5*freqs       ! Approximate Tsys at Zenith
  write(mess,'(A,F9.3,A)') 'Bandwidth    ',bandwidth,' MHz'
  call map_message(seve%i,rname,mess)
  write(mess,'(A,F9.3,A)') 'Frequency    ',freqs,' GHz '
  call map_message(seve%i,rname,mess)
  write(mess,'(A,F9.0,A)') 'Tsys zenith  ',tsys,' K'
  call map_message(seve%i,rname,mess)
  call astro_teles(freqs)
  jy_per_k = jypk 
  write(mess,'(A,F9.1,A)') 'Antenna gain ',jy_per_k,' Jy/K'
  call map_message(seve%i,rname,mess)
  ! ix = nint(inttime)
  ! write(mess,'(A,I9,A)')   'Integ.  Time ',ix,' s'
  ! call map_message(seve%i,rname,mess)
end subroutine astro_check_tsys
!
subroutine astro_setuv_weight(el)
  use gildas_def
  use gkernel_interfaces
  use atm_params
  !not here!  use atm_interfaces_public
  use ast_astro
  !---------------------------------------------------------------------
  ! @ private
  !*
  ! ASTRO
  !   Provide empirical noise estimate for weights of visibilities
  !!
  !---------------------------------------------------------------------
  real(kind=8), intent(in) :: el  !! Elevation (in Radians)
  !
  real(4) :: w
  !
  airmass = 1./sin(el)
  !
  ! Approximate Tsys  -- 0.5 K per GHz at Zenith
  tsys = 0.5*freqs       ! Approximate Tsys at Zenith
  tsys = exp(taut*airmass)*tsys  ! As a function of Airmass
  !
  ! Need  Integration time (in Seconds)
  ! Need  Bandwidth        (in MHz)
  ! Need  Antenna Jy/K conversion factor
  ! Additional 60 % time efficiency due to overhead on total time
  w = jy_per_k*tsys/sqrt(bandwidth * 0.6 * inttime)
  uvweight = 1./w**2
end subroutine astro_setuv_weight
!
function astro_lever(d,d0,el)
  !---------------------------------------------------------------------
  ! @ private
  !   Heure de lever d'une etoile de declinaison D a latitude D0
  !   D Declination in radians
  !   D0  Latitude in degrees
  !   EL  elevation limit in degrees
  !   ASTRO_LEVER Hour angle in Hours
  !
  ! PI/2-D0+EL < D  Circumpolaire
  ! D0-PI/2+EL < D < PI/2-D0+EL H = ACOS (TAN(D)/TAN(D0-PI/2))
  ! D < D0-PI/2+EL  Toujours couchee...
  !
  ! Formule applicable a la partie visible du ciel en projection
  ! sur un plan
  !---------------------------------------------------------------------
  real(kind=4) :: astro_lever       ! intent(out)
  real(kind=4), intent(in) :: d                 !! Declination (radians)
  real(kind=4), intent(in) :: d0                !! Latitude (degrees)
  real(kind=4), intent(in) :: el                !! Elevation limit (degrees)
  ! Local
  real(kind=4) :: dd,d1,d2,ee
  real(kind=8) :: pi
  parameter (pi=3.14159265358979323846d0)
  !
  if (d0.lt.0.) then
    d2 = -d
    d1 = -d0*pi/180.0
  else
    d2 = d
    d1 = d0*pi/180.0
  endif
  dd = d1-pi*0.5d0
  ee = el*pi/180.
  astro_lever = (-sin(ee)+sin(d2)*cos(dd))/(cos(d2)*sin(dd))
  if (astro_lever.le.-1.0) then
    astro_lever = -12.0            ! Circumpolar
  elseif (astro_lever.ge.1.0) then
    astro_lever = 0.0              ! Not visible
  else
    astro_lever = -12.0/pi*acos(astro_lever)
  endif
end function astro_lever
!
subroutine astro_uv_fields(nfields, offs)
  use gildas_def
  use image_def
  use gkernel_types
  use gbl_message
  !
  use gkernel_interfaces
  use imager_interfaces, except_this => astro_uv_fields
  use iso_c_binding
  !---------------------------------------------------------------------
  ! @ private-mandatory
  !*
  ! IMAGER    SIMULATE
  !
  !   Support command UV_TRACKS when a list of Offsets
  !   is available in Sim%Xoffset and Sim%Yoffset
  !!
  !---------------------------------------------------------------------
  integer, intent(inout) :: nfields  !! Number of fields
  real, allocatable, intent(inout) :: offs(:,:)  !! Offsets in radians (alpha,beta)
  !
  real(8), parameter :: pi=3.14159265358979323846d0
  real(4), parameter :: rad_to_sec=180.*3600./pi
  character(len=*), parameter :: rname='UV_FIELDS'
  !
  character(len=64) :: coff_x, coff_y
  character(len=16) :: chain
  integer :: nf, ier, i
  real(kind=8), allocatable :: raoff(:), deoff(:), rapos(:), depos(:)
  real(kind=4), allocatable :: tmp(:)
  logical :: found
  type(sic_descriptor_t) :: desc_x,desc_y
  !
  character(len=20) :: c20
  character(len=80) :: c80
  integer :: next
  type(c_ptr) :: cptr
  real(4), pointer :: r1ptr(:)
  real(8), pointer :: d1ptr(:)
  logical :: error
  !
  ! Code:
  nfields = 0
  if (allocated(offs)) deallocate(offs)
  !
  coff_x = 'SIM%XOFFSET'
  call sic_descriptor(coff_x,desc_x,found)  
  if (.not.found) return
  !
  coff_y = 'SIM%YOFFSET'
  call sic_descriptor(coff_y,desc_y,found)  
  if (.not.found) then
    call map_message(seve%e,rname,'Y pointing variable '//trim(coff_y)//' does not exist')
  !    error = .true.
    return
  endif
  !
  ! Unit is either ABS or Angle Unit (R, D, M, S) - Not fully coded yet...
  chain = 'SEC'
  !
  error = .false.
  if (any(desc_x%dims.ne.desc_y%dims)) then
    call map_message(seve%e,rname,'Pointing variables '//trim(coff_x)// &
      & ' and '// trim(coff_y)//' do not match')
    error = .true.
  else if (desc_x%ndim.ne.1) then
    call map_message(seve%e,rname,'Pointing variables '//trim(coff_x)// &
      & ' and '// trim(coff_y)//' must be of Rank 1')
    error = .true.
  endif
  if (error) return
  !
  nf = desc_x%dims(1)
  !
  allocate (raoff(nf),deoff(nf),offs(2,nf),rapos(nf),depos(nf),tmp(nf),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'Memory allocation error')
    error = .true.
    return
  endif
  !
  ! these are offsets, as specified by user
  call adtoad(desc_x%addr,cptr,1)
  if (desc_x%type.eq.fmt_r4) then
    call c_f_pointer(cptr,r1ptr,[nf])
    raoff(:) = r1ptr
  else if (desc_x%type.eq.fmt_r8) then
    call c_f_pointer(cptr,d1ptr,[nf])
    raoff(:) = d1ptr
  else
    call map_message(seve%e,rname,'Offset Pointing variables must be Real or Double')
    error = .true.
    return
  endif
  !
  call adtoad(desc_y%addr,cptr,1)
  if (desc_x%type.eq.fmt_r4) then
    call c_f_pointer(cptr,r1ptr,[nf])
    deoff(:) = r1ptr
  else if (desc_x%type.eq.fmt_r8) then
    call c_f_pointer(cptr,d1ptr,[nf])
    deoff(:) = d1ptr
  else
    call map_message(seve%e,rname,'Offset Pointing variables must be Real or Double')
    error = .true.
    return
  endif
  !
  ! Scale with appropriate angular unit.
  select case (chain)
  case ('RAD')
    offs(1,:) = raoff
    offs(2,:) = deoff
  case ('DEG')
    offs(1,:) = raoff*pi/180.d0
    offs(2,:) = deoff*pi/180.d0
  case ('MIN')
    offs(1,:) = raoff*pi/180.d0/60.d0
    offs(2,:) = deoff*pi/180.d0/60.d0
  case ('SEC')
    offs(1,:) = raoff*pi/180.d0/3600.d0
    offs(2,:) = deoff*pi/180.d0/3600.d0
  case default
    call map_message(seve%e,rname,'Unknown offset units '//trim(chain))
    error = .true.
    return
  end select     
  !
  ! List the Offsets
  call map_message(seve%i,rname,'Offsets : ')
  next = 1
  do i=1,nf
    write(c20,'(A,F8.2,A,F8.2,A)') "(",offs(1,i)*rad_to_sec,',',offs(2,i)*rad_to_sec,')'
    c80(next:) = c20
    next = next+20
    if (next.ge.80) then
      write(*,'(A)') c80
      next = 1
    endif
  enddo
  if (next.gt.1) write(*,'(A)') c80(1:next-1)
  !
  nfields = nf
end subroutine astro_uv_fields

*DECK SHELS
      SUBROUTINE SHELS (A, LDA, N, Q, B)
C***BEGIN PROLOGUE  SHELS
C***SUBSIDIARY
C***PURPOSE  Internal routine for SGMRES.
C***LIBRARY   SLATEC (SLAP)
C***CATEGORY  D2A4, D2B4
C***TYPE      SINGLE PRECISION (SHELS-S, DHELS-D)
C***KEYWORDS  GENERALIZED MINIMUM RESIDUAL, ITERATIVE PRECONDITION,
C             NON-SYMMETRIC LINEAR SYSTEM, SLAP, SPARSE
C***AUTHOR  Brown, Peter, (LLNL), pnbrown@llnl.gov
C           Hindmarsh, Alan, (LLNL), alanh@llnl.gov
C           Seager, Mark K., (LLNL), seager@llnl.gov
C             Lawrence Livermore National Laboratory
C             PO Box 808, L-60
C             Livermore, CA 94550 (510) 423-3141
C***DESCRIPTION
C        This routine is extracted from the LINPACK routine SGESL with
C        changes due to the fact that A is an upper Hessenberg matrix.
C
C        SHELS solves the least squares problem:
C
C                   MIN(B-A*X,B-A*X)
C
C        using the factors computed by SHEQR.
C
C *Usage:
C      INTEGER LDA, N
C      REAL A(LDA,N), Q(2*N), B(N+1)
C
C      CALL SHELS(A, LDA, N, Q, B)
C
C *Arguments:
C A       :IN       Real A(LDA,N)
C          The output from SHEQR which contains the upper
C          triangular factor R in the QR decomposition of A.
C LDA     :IN       Integer
C          The leading dimension of the array A.
C N       :IN       Integer
C          A is originally an (N+1) by N matrix.
C Q       :IN       Real Q(2*N)
C          The coefficients of the N Givens rotations
C          used in the QR factorization of A.
C B       :INOUT    Real B(N+1)
C          On input, B is the right hand side vector.
C          On output, B is the solution vector X.
C
C***SEE ALSO  SGMRES
C***ROUTINES CALLED  SAXPY
C***REVISION HISTORY  (YYMMDD)
C   871001  DATE WRITTEN
C   881213  Previous REVISION DATE
C   890915  Made changes requested at July 1989 CML Meeting.  (MKS)
C   890922  Numerous changes to prologue to make closer to SLATEC
C           standard.  (FNF)
C   890929  Numerous changes to reduce SP/DP differences.  (FNF)
C   910411  Prologue converted to Version 4.0 format.  (BAB)
C   910502  Added C***FIRST EXECUTABLE STATEMENT line.  (FNF)
C   910506  Made subsidiary to SGMRES.  (FNF)
C   920511  Added complete declaration section.  (WRB)
C***END PROLOGUE  SHELS
C         The following is for optimized compilation on LLNL/LTSS Crays.
CLLL. OPTIMIZE
C     .. Scalar Arguments ..
      INTEGER LDA, N
C     .. Array Arguments ..
      REAL A(LDA,*), B(*), Q(*)
C     .. Local Scalars ..
      REAL C, S, T, T1, T2
      INTEGER IQ, K, KB, KP1
C     .. External Subroutines ..
      EXTERNAL SAXPY
C***FIRST EXECUTABLE STATEMENT  SHELS
C
C         Minimize(B-A*X,B-A*X).  First form Q*B.
C
      DO 20 K = 1, N
         KP1 = K + 1
         IQ = 2*(K-1) + 1
         C = Q(IQ)
         S = Q(IQ+1)
         T1 = B(K)
         T2 = B(KP1)
         B(K) = C*T1 - S*T2
         B(KP1) = S*T1 + C*T2
 20   CONTINUE
C
C         Now solve  R*X = Q*B.
C
      DO 40 KB = 1, N
         K = N + 1 - KB
         B(K) = B(K)/A(K,K)
         T = -B(K)
         CALL SAXPY(K-1, T, A(1,K), 1, B(1), 1)
 40   CONTINUE
      RETURN
C------------- LAST LINE OF SHELS FOLLOWS ----------------------------
      END
*DECK SHEQR
      SUBROUTINE SHEQR (A, LDA, N, Q, INFO, IJOB)
C***BEGIN PROLOGUE  SHEQR
C***SUBSIDIARY
C***PURPOSE  Internal routine for SGMRES.
C***LIBRARY   SLATEC (SLAP)
C***CATEGORY  D2A4, D2B4
C***TYPE      SINGLE PRECISION (SHEQR-S, DHEQR-D)
C***KEYWORDS  GENERALIZED MINIMUM RESIDUAL, ITERATIVE PRECONDITION,
C             NON-SYMMETRIC LINEAR SYSTEM, SLAP, SPARSE
C***AUTHOR  Brown, Peter, (LLNL), pnbrown@llnl.gov
C           Hindmarsh, Alan, (LLNL), alanh@llnl.gov
C           Seager, Mark K., (LLNL), seager@llnl.gov
C             Lawrence Livermore National Laboratory
C             PO Box 808, L-60
C             Livermore, CA 94550 (510) 423-3141
C***DESCRIPTION
C        This   routine  performs  a QR   decomposition  of an  upper
C        Hessenberg matrix A using Givens  rotations.  There  are two
C        options  available: 1)  Performing  a fresh decomposition 2)
C        updating the QR factors by adding a row and  a column to the
C        matrix A.
C
C *Usage:
C      INTEGER LDA, N, INFO, IJOB
C      REAL A(LDA,N), Q(2*N)
C
C      CALL SHEQR(A, LDA, N, Q, INFO, IJOB)
C
C *Arguments:
C A      :INOUT    Real A(LDA,N)
C         On input, the matrix to be decomposed.
C         On output, the upper triangular matrix R.
C         The factorization can be written Q*A = R, where
C         Q is a product of Givens rotations and R is upper
C         triangular.
C LDA    :IN       Integer
C         The leading dimension of the array A.
C N      :IN       Integer
C         A is an (N+1) by N Hessenberg matrix.
C Q      :OUT      Real Q(2*N)
C         The factors c and s of each Givens rotation used
C         in decomposing A.
C INFO   :OUT      Integer
C         = 0  normal value.
C         = K  if  A(K,K) .eq. 0.0 .  This is not an error
C           condition for this subroutine, but it does
C           indicate that SHELS will divide by zero
C           if called.
C IJOB   :IN       Integer
C         = 1     means that a fresh decomposition of the
C                 matrix A is desired.
C         .ge. 2  means that the current decomposition of A
C                 will be updated by the addition of a row
C                 and a column.
C
C***SEE ALSO  SGMRES
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   871001  DATE WRITTEN
C   881213  Previous REVISION DATE
C   890915  Made changes requested at July 1989 CML Meeting.  (MKS)
C   890922  Numerous changes to prologue to make closer to SLATEC
C           standard.  (FNF)
C   890929  Numerous changes to reduce SP/DP differences.  (FNF)
C   910411  Prologue converted to Version 4.0 format.  (BAB)
C   910506  Made subsidiary to SGMRES.  (FNF)
C   920511  Added complete declaration section.  (WRB)
C***END PROLOGUE  SHEQR
C         The following is for optimized compilation on LLNL/LTSS Crays.
CLLL. OPTIMIZE
C     .. Scalar Arguments ..
      INTEGER IJOB, INFO, LDA, N
C     .. Array Arguments ..
      REAL A(LDA,*), Q(*)
C     .. Local Scalars ..
      REAL C, S, T, T1, T2
      INTEGER I, IQ, J, K, KM1, KP1, NM1
C     .. Intrinsic Functions ..
      INTRINSIC ABS, SQRT
C***FIRST EXECUTABLE STATEMENT  SHEQR
      IF (IJOB .GT. 1) GO TO 70
C   -------------------------------------------------------------------
C         A new factorization is desired.
C   -------------------------------------------------------------------
C         QR decomposition without pivoting.
C
      INFO = 0
      DO 60 K = 1, N
         KM1 = K - 1
         KP1 = K + 1
C
C           Compute K-th column of R.
C           First, multiply the K-th column of A by the previous
C           K-1 Givens rotations.
C
         IF (KM1 .LT. 1) GO TO 20
         DO 10 J = 1, KM1
            I = 2*(J-1) + 1
            T1 = A(J,K)
            T2 = A(J+1,K)
            C = Q(I)
            S = Q(I+1)
            A(J,K) = C*T1 - S*T2
            A(J+1,K) = S*T1 + C*T2
 10      CONTINUE
C
C         Compute Givens components C and S.
C
 20      CONTINUE
         IQ = 2*KM1 + 1
         T1 = A(K,K)
         T2 = A(KP1,K)
         IF( T2.EQ.0.0E0 ) THEN
            C = 1
            S = 0
         ELSEIF( ABS(T2).GE.ABS(T1) ) THEN
            T = T1/T2
            S = -1.0E0/SQRT(1.0E0+T*T)
            C = -S*T
         ELSE
            T = T2/T1
            C = 1.0E0/SQRT(1.0E0+T*T)
            S = -C*T
         ENDIF
         Q(IQ) = C
         Q(IQ+1) = S
         A(K,K) = C*T1 - S*T2
         IF( A(K,K).EQ.0.0E0 ) INFO = K
 60   CONTINUE
      RETURN
C   -------------------------------------------------------------------
C         The old factorization of a will be updated.  A row and a
C         column has been added to the matrix A.  N by N-1 is now
C         the old size of the matrix.
C   -------------------------------------------------------------------
 70   CONTINUE
      NM1 = N - 1
C   -------------------------------------------------------------------
C         Multiply the new column by the N previous Givens rotations.
C   -------------------------------------------------------------------
      DO 100 K = 1,NM1
         I = 2*(K-1) + 1
         T1 = A(K,N)
         T2 = A(K+1,N)
         C = Q(I)
         S = Q(I+1)
         A(K,N) = C*T1 - S*T2
         A(K+1,N) = S*T1 + C*T2
 100  CONTINUE
C   -------------------------------------------------------------------
C         Complete update of decomposition by forming last Givens
C         rotation, and multiplying it times the column
C         vector(A(N,N),A(NP1,N)).
C   -------------------------------------------------------------------
      INFO = 0
      T1 = A(N,N)
      T2 = A(N+1,N)
      IF ( T2.EQ.0.0E0 ) THEN
         C = 1
         S = 0
      ELSEIF( ABS(T2).GE.ABS(T1) ) THEN
         T = T1/T2
         S = -1.0E0/SQRT(1.0E0+T*T)
         C = -S*T
      ELSE
         T = T2/T1
         C = 1.0E0/SQRT(1.0E0+T*T)
         S = -C*T
      ENDIF
      IQ = 2*N - 1
      Q(IQ) = C
      Q(IQ+1) = S
      A(N,N) = C*T1 - S*T2
      IF (A(N,N) .EQ. 0.0E0) INFO = N
      RETURN
C------------- LAST LINE OF SHEQR FOLLOWS ----------------------------
      END
*DECK SINDG
      FUNCTION SINDG (X)
C***BEGIN PROLOGUE  SINDG
C***PURPOSE  Compute the sine of an argument in degrees.
C***LIBRARY   SLATEC (FNLIB)
C***CATEGORY  C4A
C***TYPE      SINGLE PRECISION (SINDG-S, DSINDG-D)
C***KEYWORDS  DEGREES, ELEMENTARY FUNCTIONS, FNLIB, SINE, TRIGONOMETRIC
C***AUTHOR  Fullerton, W., (LANL)
C***DESCRIPTION
C
C SINDG(X) evaluates the single precision sine of X where
C X is in degrees.
C
C***REFERENCES  (NONE)
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   770601  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890531  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C***END PROLOGUE  SINDG
C JUNE 1977 EDITION.   W. FULLERTON, C3, LOS ALAMOS SCIENTIFIC LAB.
      SAVE RADDEG
      DATA RADDEG / .017453292519943296E0 /
C
C***FIRST EXECUTABLE STATEMENT  SINDG
      SINDG = SIN (RADDEG*X)
C
      IF (MOD(X,90.).NE.0.) RETURN
      N = ABS(X)/90.0 + 0.5
      N = MOD (N, 2)
      IF (N.EQ.0) SINDG = 0.
      IF (N.EQ.1) SINDG = SIGN (1.0, SINDG)
C
      RETURN
      END
*DECK SINQB
      SUBROUTINE SINQB (N, X, WSAVE)
C***BEGIN PROLOGUE  SINQB
C***PURPOSE  Compute the unnormalized inverse of SINQF.
C***LIBRARY   SLATEC (FFTPACK)
C***CATEGORY  J1A3
C***TYPE      SINGLE PRECISION (SINQB-S)
C***KEYWORDS  FFTPACK, FOURIER TRANSFORM
C***AUTHOR  Swarztrauber, P. N., (NCAR)
C***DESCRIPTION
C
C  Subroutine SINQB computes the fast Fourier transform of quarter
C  wave data.  That is, SINQB computes a sequence from its
C  representation in terms of a sine series with odd wave numbers.
C  the transform is defined below at output parameter X.
C
C  SINQF is the unnormalized inverse of SINQB since a call of SINQB
C  followed by a call of SINQF will multiply the input sequence X
C  by 4*N.
C
C  The array WSAVE which is used by subroutine SINQB must be
C  initialized by calling subroutine SINQI(N,WSAVE).
C
C  Input Parameters
C
C  N       the length of the array X to be transformed.  The method
C          is most efficient when N is a product of small primes.
C
C  X       an array which contains the sequence to be transformed
C
C  WSAVE   a work array which must be dimensioned at least 3*N+15
C          in the program that calls SINQB.  The WSAVE array must be
C          initialized by calling subroutine SINQI(N,WSAVE), and a
C          different WSAVE array must be used for each different
C          value of N.  This initialization does not have to be
C          repeated so long as N remains unchanged.  Thus subsequent
C          transforms can be obtained faster than the first.
C
C  Output Parameters
C
C  X       For I=1,...,N
C
C               X(I)= the sum from K=1 to K=N of
C
C                 4*X(K)*SIN((2*K-1)*I*PI/(2*N))
C
C               a call of SINQB followed by a call of
C               SINQF will multiply the sequence X by 4*N.
C               Therefore SINQF is the unnormalized inverse
C               of SINQB.
C
C  WSAVE   contains initialization calculations which must not
C          be destroyed between calls of SINQB or SINQF.
C
C***REFERENCES  P. N. Swarztrauber, Vectorizing the FFTs, in Parallel
C                 Computations (G. Rodrigue, ed.), Academic Press,
C                 1982, pp. 51-83.
C***ROUTINES CALLED  COSQB
C***REVISION HISTORY  (YYMMDD)
C   790601  DATE WRITTEN
C   830401  Modified to use SLATEC library source file format.
C   860115  Modified by Ron Boisvert to adhere to Fortran 77 by
C           changing dummy array size declarations (1) to (*).
C   861211  REVISION DATE from Version 3.2
C   881128  Modified by Dick Valent to meet prologue standards.
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  SINQB
      DIMENSION X(*), WSAVE(*)
C***FIRST EXECUTABLE STATEMENT  SINQB
      IF (N .GT. 1) GO TO 101
      X(1) = 4.*X(1)
      RETURN
  101 NS2 = N/2
      DO 102 K=2,N,2
         X(K) = -X(K)
  102 CONTINUE
      CALL COSQB (N,X,WSAVE)
      DO 103 K=1,NS2
         KC = N-K
         XHOLD = X(K)
         X(K) = X(KC+1)
         X(KC+1) = XHOLD
  103 CONTINUE
      RETURN
      END
*DECK SINQF
      SUBROUTINE SINQF (N, X, WSAVE)
C***BEGIN PROLOGUE  SINQF
C***PURPOSE  Compute the forward sine transform with odd wave numbers.
C***LIBRARY   SLATEC (FFTPACK)
C***CATEGORY  J1A3
C***TYPE      SINGLE PRECISION (SINQF-S)
C***KEYWORDS  FFTPACK, FOURIER TRANSFORM
C***AUTHOR  Swarztrauber, P. N., (NCAR)
C***DESCRIPTION
C
C  Subroutine SINQF computes the fast Fourier transform of quarter
C  wave data.  That is, SINQF computes the coefficients in a sine
C  series representation with only odd wave numbers.  The transform
C  is defined below at output parameter X.
C
C  SINQB is the unnormalized inverse of SINQF since a call of SINQF
C  followed by a call of SINQB will multiply the input sequence X
C  by 4*N.
C
C  The array WSAVE which is used by subroutine SINQF must be
C  initialized by calling subroutine SINQI(N,WSAVE).
C
C  Input Parameters
C
C  N       the length of the array X to be transformed.  The method
C          is most efficient when N is a product of small primes.
C
C  X       an array which contains the sequence to be transformed
C
C  WSAVE   a work array which must be dimensioned at least 3*N+15
C          in the program that calls SINQF.  The WSAVE array must be
C          initialized by calling subroutine SINQI(N,WSAVE), and a
C          different WSAVE array must be used for each different
C          value of N.  This initialization does not have to be
C          repeated so long as N remains unchanged.  Thus subsequent
C          transforms can be obtained faster than the first.
C
C  Output Parameters
C
C  X       For I=1,...,N
C
C               X(I) = (-1)**(I-1)*X(N)
C
C                  + the sum from K=1 to K=N-1 of
C
C                  2*X(K)*SIN((2*I-1)*K*PI/(2*N))
C
C               A call of SINQF followed by a call of
C               SINQB will multiply the sequence X by 4*N.
C               Therefore SINQB is the unnormalized inverse
C               of SINQF.
C
C  WSAVE   contains initialization calculations which must not
C          be destroyed between calls of SINQF or SINQB.
C
C***REFERENCES  P. N. Swarztrauber, Vectorizing the FFTs, in Parallel
C                 Computations (G. Rodrigue, ed.), Academic Press,
C                 1982, pp. 51-83.
C***ROUTINES CALLED  COSQF
C***REVISION HISTORY  (YYMMDD)
C   790601  DATE WRITTEN
C   830401  Modified to use SLATEC library source file format.
C   860115  Modified by Ron Boisvert to adhere to Fortran 77 by
C           changing dummy array size declarations (1) to (*)
C   861211  REVISION DATE from Version 3.2
C   881128  Modified by Dick Valent to meet prologue standards.
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  SINQF
      DIMENSION X(*), WSAVE(*)
C***FIRST EXECUTABLE STATEMENT  SINQF
      IF (N .EQ. 1) RETURN
      NS2 = N/2
      DO 101 K=1,NS2
         KC = N-K
         XHOLD = X(K)
         X(K) = X(KC+1)
         X(KC+1) = XHOLD
  101 CONTINUE
      CALL COSQF (N,X,WSAVE)
      DO 102 K=2,N,2
         X(K) = -X(K)
  102 CONTINUE
      RETURN
      END
*DECK SINQI
      SUBROUTINE SINQI (N, WSAVE)
C***BEGIN PROLOGUE  SINQI
C***PURPOSE  Initialize a work array for SINQF and SINQB.
C***LIBRARY   SLATEC (FFTPACK)
C***CATEGORY  J1A3
C***TYPE      SINGLE PRECISION (SINQI-S)
C***KEYWORDS  FFTPACK, FOURIER TRANSFORM
C***AUTHOR  Swarztrauber, P. N., (NCAR)
C***DESCRIPTION
C
C  Subroutine SINQI initializes the array WSAVE which is used in
C  both SINQF and SINQB.  The prime factorization of N together with
C  a tabulation of the trigonometric functions are computed and
C  stored in WSAVE.
C
C  Input Parameter
C
C  N       the length of the sequence to be transformed.  The method
C          is most efficient when N is a product of small primes.
C
C  Output Parameter
C
C  WSAVE   a work array which must be dimensioned at least 3*N+15.
C          The same work array can be used for both SINQF and SINQB
C          as long as N remains unchanged.  Different WSAVE arrays
C          are required for different values of N.  The contents of
C          WSAVE must not be changed between calls of SINQF or SINQB.
C
C***REFERENCES  P. N. Swarztrauber, Vectorizing the FFTs, in Parallel
C                 Computations (G. Rodrigue, ed.), Academic Press,
C                 1982, pp. 51-83.
C***ROUTINES CALLED  COSQI
C***REVISION HISTORY  (YYMMDD)
C   790601  DATE WRITTEN
C   830401  Modified to use SLATEC library source file format.
C   860115  Modified by Ron Boisvert to adhere to Fortran 77 by
C           changing dummy array size declarations (1) to (*)
C   861211  REVISION DATE from Version 3.2
C   881128  Modified by Dick Valent to meet prologue standards.
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  SINQI
      DIMENSION WSAVE(*)
C***FIRST EXECUTABLE STATEMENT  SINQI
      CALL COSQI (N,WSAVE)
      RETURN
      END
*DECK SINT
      SUBROUTINE SINT (N, X, WSAVE)
C***BEGIN PROLOGUE  SINT
C***PURPOSE  Compute the sine transform of a real, odd sequence.
C***LIBRARY   SLATEC (FFTPACK)
C***CATEGORY  J1A3
C***TYPE      SINGLE PRECISION (SINT-S)
C***KEYWORDS  FFTPACK, FOURIER TRANSFORM
C***AUTHOR  Swarztrauber, P. N., (NCAR)
C***DESCRIPTION
C
C  Subroutine SINT computes the discrete Fourier sine transform
C  of an odd sequence X(I).  The transform is defined below at
C  output parameter X.
C
C  SINT is the unnormalized inverse of itself since a call of SINT
C  followed by another call of SINT will multiply the input sequence
C  X by 2*(N+1).
C
C  The array WSAVE which is used by subroutine SINT must be
C  initialized by calling subroutine SINTI(N,WSAVE).
C
C  Input Parameters
C
C  N       the length of the sequence to be transformed.  The method
C          is most efficient when N+1 is the product of small primes.
C
C  X       an array which contains the sequence to be transformed
C
C
C  WSAVE   a work array with dimension at least INT(3.5*N+16)
C          in the program that calls SINT.  The WSAVE array must be
C          initialized by calling subroutine SINTI(N,WSAVE), and a
C          different WSAVE array must be used for each different
C          value of N.  This initialization does not have to be
C          repeated so long as N remains unchanged.  Thus subsequent
C          transforms can be obtained faster than the first.
C
C  Output Parameters
C
C  X       For I=1,...,N
C
C               X(I)= the sum from K=1 to K=N
C
C                    2*X(K)*SIN(K*I*PI/(N+1))
C
C               A call of SINT followed by another call of
C               SINT will multiply the sequence X by 2*(N+1).
C               Hence SINT is the unnormalized inverse
C               of itself.
C
C  WSAVE   contains initialization calculations which must not be
C          destroyed between calls of SINT.
C
C***REFERENCES  P. N. Swarztrauber, Vectorizing the FFTs, in Parallel
C                 Computations (G. Rodrigue, ed.), Academic Press,
C                 1982, pp. 51-83.
C***ROUTINES CALLED  RFFTF
C***REVISION HISTORY  (YYMMDD)
C   790601  DATE WRITTEN
C   830401  Modified to use SLATEC library source file format.
C   860115  Modified by Ron Boisvert to adhere to Fortran 77 by
C           (a) changing dummy array size declarations (1) to (*),
C           (b) changing definition of variable SQRT3 by using
C               FORTRAN intrinsic function SQRT instead of a DATA
C               statement.
C   881128  Modified by Dick Valent to meet prologue standards.
C   891009  Removed unreferenced statement label.  (WRB)
C   891009  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  SINT
      DIMENSION X(*), WSAVE(*)
C***FIRST EXECUTABLE STATEMENT  SINT
      SQRT3 = SQRT(3.)
      IF (N-2) 101,102,103
  101 X(1) = X(1)+X(1)
      RETURN
  102 XH = SQRT3*(X(1)+X(2))
      X(2) = SQRT3*(X(1)-X(2))
      X(1) = XH
      RETURN
  103 NP1 = N+1
      NS2 = N/2
      WSAVE(1) = 0.
      KW = NP1
      DO 104 K=1,NS2
         KW = KW+1
         KC = NP1-K
         T1 = X(K)-X(KC)
         T2 = WSAVE(KW)*(X(K)+X(KC))
         WSAVE(K+1) = T1+T2
         WSAVE(KC+1) = T2-T1
  104 CONTINUE
      MODN = MOD(N,2)
      IF (MODN .NE. 0) WSAVE(NS2+2) = 4.*X(NS2+1)
      NF = NP1+NS2+1
      CALL RFFTF (NP1,WSAVE,WSAVE(NF))
      X(1) = .5*WSAVE(1)
      DO 105 I=3,N,2
         X(I-1) = -WSAVE(I)
         X(I) = X(I-2)+WSAVE(I-1)
  105 CONTINUE
      IF (MODN .NE. 0) RETURN
      X(N) = -WSAVE(N+1)
      RETURN
      END
*DECK SINTI
      SUBROUTINE SINTI (N, WSAVE)
C***BEGIN PROLOGUE  SINTI
C***PURPOSE  Initialize a work array for SINT.
C***LIBRARY   SLATEC (FFTPACK)
C***CATEGORY  J1A3
C***TYPE      SINGLE PRECISION (SINTI-S)
C***KEYWORDS  FFTPACK, FOURIER TRANSFORM
C***AUTHOR  Swarztrauber, P. N., (NCAR)
C***DESCRIPTION
C
C  Subroutine SINTI initializes the array WSAVE which is used in
C  subroutine SINT.  The prime factorization of N together with
C  a tabulation of the trigonometric functions are computed and
C  stored in WSAVE.
C
C  Input Parameter
C
C  N       the length of the sequence to be transformed.  The method
C          is most efficient when N+1 is a product of small primes.
C
C  Output Parameter
C
C  WSAVE   a work array with at least INT(3.5*N+16) locations.
C          Different WSAVE arrays are required for different values
C          of N.  The contents of WSAVE must not be changed between
C          calls of SINT.
C
C***REFERENCES  P. N. Swarztrauber, Vectorizing the FFTs, in Parallel
C                 Computations (G. Rodrigue, ed.), Academic Press,
C                 1982, pp. 51-83.
C***ROUTINES CALLED  RFFTI
C***REVISION HISTORY  (YYMMDD)
C   790601  DATE WRITTEN
C   830401  Modified to use SLATEC library source file format.
C   860115  Modified by Ron Boisvert to adhere to Fortran 77 by
C           (a) changing dummy array size declarations (1) to (*),
C           (b) changing references to intrinsic function FLOAT
C               to REAL, and
C           (c) changing definition of variable PI by using
C               FORTRAN intrinsic function ATAN instead of a DATA
C               statement.
C   881128  Modified by Dick Valent to meet prologue standards.
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890531  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  SINTI
      DIMENSION WSAVE(*)
C***FIRST EXECUTABLE STATEMENT  SINTI
      IF (N .LE. 1) RETURN
      PI = 4.*ATAN(1.)
      NP1 = N+1
      NS2 = N/2
      DT = PI/NP1
      KS = N+2
      KF = KS+NS2-1
      FK = 0.
      DO 101 K=KS,KF
         FK = FK+1.
         WSAVE(K) = 2.*SIN(FK*DT)
  101 CONTINUE
      CALL RFFTI (NP1,WSAVE(KF+1))
      RETURN
      END
*DECK SINTRP
      SUBROUTINE SINTRP (X, Y, XOUT, YOUT, YPOUT, NEQN, KOLD, PHI, IVC,
     +   IV, KGI, GI, ALPHA, OG, OW, OX, OY)
C***BEGIN PROLOGUE  SINTRP
C***PURPOSE  Approximate the solution at XOUT by evaluating the
C            polynomial computed in STEPS at XOUT.  Must be used in
C            conjunction with STEPS.
C***LIBRARY   SLATEC (DEPAC)
C***CATEGORY  I1A1B
C***TYPE      SINGLE PRECISION (SINTRP-S, DINTP-D)
C***KEYWORDS  ADAMS METHOD, DEPAC, INITIAL VALUE PROBLEMS, ODE,
C             ORDINARY DIFFERENTIAL EQUATIONS, PREDICTOR-CORRECTOR,
C             SMOOTH INTERPOLANT
C***AUTHOR  Watts, H. A., (SNLA)
C***DESCRIPTION
C
C   The methods in subroutine  STEPS  approximate the solution near  X
C   by a polynomial.  Subroutine  SINTRP  approximates the solution at
C   XOUT  by evaluating the polynomial there.  Information defining this
C   polynomial is passed from  STEPS  so  SINTRP  cannot be used alone.
C
C   Subroutine STEPS is completely explained and documented in the text,
C   "Computer Solution of Ordinary Differential Equations, the Initial
C   Value Problem"  by L. F. Shampine and M. K. Gordon.
C
C   Input to SINTRP --
C
C   The user provides storage in the calling program for the arrays in
C   the call list
C      DIMENSION Y(NEQN),YOUT(NEQN),YPOUT(NEQN),PHI(NEQN,16),OY(NEQN)
C                AND ALPHA(12),OG(13),OW(12),GI(11),IV(10)
C   and defines
C      XOUT -- point at which solution is desired.
C   The remaining parameters are defined in  STEPS  and passed to
C   SINTRP  from that subroutine
C
C   Output from  SINTRP --
C
C      YOUT(*) -- solution at  XOUT
C      YPOUT(*) -- derivative of solution at  XOUT
C   The remaining parameters are returned unaltered from their input
C   values.  Integration with  STEPS  may be continued.
C
C***REFERENCES  H. A. Watts, A smoother interpolant for DE/STEP, INTRP
C                 II, Report SAND84-0293, Sandia Laboratories, 1984.
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   840201  DATE WRITTEN
C   890831  Modified array declarations.  (WRB)
C   890831  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  SINTRP
C
      DIMENSION Y(*),YOUT(*),YPOUT(*),PHI(NEQN,16),OY(*)
      DIMENSION G(13),C(13),W(13),OG(13),OW(12),ALPHA(12),GI(11),IV(10)
C
C***FIRST EXECUTABLE STATEMENT  SINTRP
      KP1 = KOLD + 1
      KP2 = KOLD + 2
C
      HI = XOUT - OX
      H = X - OX
      XI = HI/H
      XIM1 = XI - 1.
C
C   INITIALIZE W(*) FOR COMPUTING G(*)
C
      XIQ = XI
      DO 10 IQ = 1,KP1
        XIQ = XI*XIQ
        TEMP1 = IQ*(IQ+1)
 10     W(IQ) = XIQ/TEMP1
C
C   COMPUTE THE DOUBLE INTEGRAL TERM GDI
C
      IF (KOLD .LE. KGI) GO TO 50
      IF (IVC .GT. 0) GO TO 20
      GDI = 1.0/TEMP1
      M = 2
      GO TO 30
 20   IW = IV(IVC)
      GDI = OW(IW)
      M = KOLD - IW + 3
 30   IF (M .GT. KOLD) GO TO 60
      DO 40 I = M,KOLD
 40     GDI = OW(KP2-I) - ALPHA(I)*GDI
      GO TO 60
 50   GDI = GI(KOLD)
C
C   COMPUTE G(*) AND C(*)
C
 60   G(1) = XI
      G(2) = 0.5*XI*XI
      C(1) = 1.0
      C(2) = XI
      IF (KOLD .LT. 2) GO TO 90
      DO 80 I = 2,KOLD
        ALP = ALPHA(I)
        GAMMA = 1.0 + XIM1*ALP
        L = KP2 - I
        DO 70 JQ = 1,L
 70       W(JQ) = GAMMA*W(JQ) - ALP*W(JQ+1)
        G(I+1) = W(1)
 80     C(I+1) = GAMMA*C(I)
C
C   DEFINE INTERPOLATION PARAMETERS
C
 90   SIGMA = (W(2) - XIM1*W(1))/GDI
      RMU = XIM1*C(KP1)/GDI
      HMU = RMU/H
C
C   INTERPOLATE FOR THE SOLUTION -- YOUT
C   AND FOR THE DERIVATIVE OF THE SOLUTION -- YPOUT
C
      DO 100 L = 1,NEQN
        YOUT(L) = 0.0
 100    YPOUT(L) = 0.0
      DO 120 J = 1,KOLD
        I = KP2 - J
        GDIF = OG(I) - OG(I-1)
        TEMP2 = (G(I) - G(I-1)) - SIGMA*GDIF
        TEMP3 = (C(I) - C(I-1)) + RMU*GDIF
        DO 110 L = 1,NEQN
          YOUT(L) = YOUT(L) + TEMP2*PHI(L,I)
 110      YPOUT(L) = YPOUT(L) + TEMP3*PHI(L,I)
 120    CONTINUE
      DO 130 L = 1,NEQN
        YOUT(L) = ((1.0 - SIGMA)*OY(L) + SIGMA*Y(L)) +
     1             H*(YOUT(L) + (G(1) - SIGMA*OG(1))*PHI(L,1))
 130    YPOUT(L) = HMU*(OY(L) - Y(L)) +
     1                (YPOUT(L) + (C(1) + RMU*OG(1))*PHI(L,1))
C
      RETURN
      END
*DECK SIR
      SUBROUTINE SIR (N, B, X, NELT, IA, JA, A, ISYM, MATVEC, MSOLVE,
     +   ITOL, TOL, ITMAX, ITER, ERR, IERR, IUNIT, R, Z, DZ, RWORK,
     +   IWORK)
C***BEGIN PROLOGUE  SIR
C***PURPOSE  Preconditioned Iterative Refinement Sparse Ax = b Solver.
C            Routine to solve a general linear system  Ax = b  using
C            iterative refinement with a matrix splitting.
C***LIBRARY   SLATEC (SLAP)
C***CATEGORY  D2A4, D2B4
C***TYPE      SINGLE PRECISION (SIR-S, DIR-D)
C***KEYWORDS  ITERATIVE PRECONDITION, LINEAR SYSTEM, SLAP, SPARSE
C***AUTHOR  Greenbaum, Anne, (Courant Institute)
C           Seager, Mark K., (LLNL)
C             Lawrence Livermore National Laboratory
C             PO BOX 808, L-60
C             Livermore, CA 94550 (510) 423-3141
C             seager@llnl.gov
C***DESCRIPTION
C
C *Usage:
C     INTEGER  N, NELT, IA(NELT), JA(NELT), ISYM, ITOL, ITMAX
C     INTEGER  ITER, IERR, IUNIT, IWORK(USER DEFINED)
C     REAL     B(N), X(N), A(NELT), TOL, ERR, R(N), Z(N), DZ(N),
C     REAL     RWORK(USER DEFINED)
C     EXTERNAL MATVEC, MSOLVE
C
C     CALL SIR(N, B, X, NELT, IA, JA, A, ISYM, MATVEC, MSOLVE, ITOL,
C    $     TOL, ITMAX, ITER, ERR, IERR, IUNIT, R, Z, DZ, RWORK, IWORK)
C
C *Arguments:
C N      :IN       Integer.
C         Order of the Matrix.
C B      :IN       Real B(N).
C         Right-hand side vector.
C X      :INOUT    Real X(N).
C         On input X is your initial guess for solution vector.
C         On output X is the final approximate solution.
C NELT   :IN       Integer.
C         Number of Non-Zeros stored in A.
C IA     :IN       Integer IA(NELT).
C JA     :IN       Integer JA(NELT).
C A      :IN       Real A(NELT).
C         These arrays contain the matrix data structure for A.
C         It could take any form.  See "Description", below,
C         for more details.
C ISYM   :IN       Integer.
C         Flag to indicate symmetric storage format.
C         If ISYM=0, all non-zero entries of the matrix are stored.
C         If ISYM=1, the matrix is symmetric, and only the upper
C         or lower triangle of the matrix is stored.
C MATVEC :EXT      External.
C         Name of a routine which performs the matrix vector multiply
C         Y = A*X given A and X.  The name of the MATVEC routine must
C         be declared external in the calling program.  The calling
C         sequence to MATVEC is:
C             CALL MATVEC( N, X, Y, NELT, IA, JA, A, ISYM )
C         Where N is the number of unknowns, Y is the product A*X
C         upon return, X is an input vector, NELT is the number of
C         non-zeros in the SLAP IA, JA, A storage for the matrix A.
C         ISYM is a flag which, if non-zero, denotes that A is
C         symmetric and only the lower or upper triangle is stored.
C MSOLVE :EXT      External.
C         Name of a routine which solves a linear system MZ = R for
C         Z given R with the preconditioning matrix M (M is supplied via
C         RWORK and IWORK arrays).  The name of the MSOLVE routine must
C         be declared external in the calling program.  The calling
C         sequence to MSOLVE is:
C             CALL MSOLVE(N, R, Z, NELT, IA, JA, A, ISYM, RWORK, IWORK)
C         Where N is the number of unknowns, R is the right-hand side
C         vector and Z is the solution upon return.  NELT, IA, JA, A and
C         ISYM are defined as above.  RWORK is a real array that can
C         be used to pass necessary preconditioning information and/or
C         workspace to MSOLVE.  IWORK is an integer work array for
C         the same purpose as RWORK.
C ITOL   :IN       Integer.
C         Flag to indicate type of convergence criterion.
C         If ITOL=1, iteration stops when the 2-norm of the residual
C         divided by the 2-norm of the right-hand side is less than TOL.
C         If ITOL=2, iteration stops when the 2-norm of M-inv times the
C         residual divided by the 2-norm of M-inv times the right hand
C         side is less than TOL, where M-inv is the inverse of the
C         diagonal of A.
C         ITOL=11 is often useful for checking and comparing different
C         routines.  For this case, the user must supply the "exact"
C         solution or a very accurate approximation (one with an error
C         much less than TOL) through a common block,
C             COMMON /SSLBLK/ SOLN( )
C         If ITOL=11, iteration stops when the 2-norm of the difference
C         between the iterative approximation and the user-supplied
C         solution divided by the 2-norm of the user-supplied solution
C         is less than TOL.  Note that this requires the user to set up
C         the "COMMON /SSLBLK/ SOLN(LENGTH)" in the calling routine.
C         The routine with this declaration should be loaded before the
C         stop test so that the correct length is used by the loader.
C         This procedure is not standard Fortran and may not work
C         correctly on your system (although it has worked on every
C         system the authors have tried).  If ITOL is not 11 then this
C         common block is indeed standard Fortran.
C TOL    :INOUT    Real.
C         Convergence criterion, as described above.  (Reset if IERR=4.)
C ITMAX  :IN       Integer.
C         Maximum number of iterations.
C ITER   :OUT      Integer.
C         Number of iterations required to reach convergence, or
C         ITMAX+1 if convergence criterion could not be achieved in
C         ITMAX iterations.
C ERR    :OUT      Real.
C         Error estimate of error in final approximate solution, as
C         defined by ITOL.
C IERR   :OUT      Integer.
C         Return error flag.
C           IERR = 0 => All went well.
C           IERR = 1 => Insufficient space allocated for WORK or IWORK.
C           IERR = 2 => Method failed to converge in ITMAX steps.
C           IERR = 3 => Error in user input.
C                       Check input values of N, ITOL.
C           IERR = 4 => User error tolerance set too tight.
C                       Reset to 500*R1MACH(3).  Iteration proceeded.
C           IERR = 5 => Preconditioning matrix, M, is not positive
C                       definite.  (r,z) < 0.
C           IERR = 6 => Matrix A is not positive definite.  (p,Ap) < 0.
C IUNIT  :IN       Integer.
C         Unit number on which to write the error at each iteration,
C         if this is desired for monitoring convergence.  If unit
C         number is 0, no writing will occur.
C R      :WORK     Real R(N).
C Z      :WORK     Real Z(N).
C DZ     :WORK     Real DZ(N).
C         Real arrays used for workspace.
C RWORK  :WORK     Real RWORK(USER DEFINED).
C         Real array that can be used by  MSOLVE.
C IWORK  :WORK     Integer IWORK(USER DEFINED).
C         Integer array that can be used by  MSOLVE.
C
C *Description:
C       The basic algorithm for iterative refinement (also known as
C       iterative improvement) is:
C
C            n+1    n    -1       n
C           X    = X  + M  (B - AX  ).
C
C           -1   -1
C       If M =  A then this  is the  standard  iterative  refinement
C       algorithm and the "subtraction" in the  residual calculation
C       should be done in double precision (which it is  not in this
C       routine).
C       If M = DIAG(A), the diagonal of A, then iterative refinement
C       is  known  as  Jacobi's  method.   The  SLAP  routine  SSJAC
C       implements this iterative strategy.
C       If M = L, the lower triangle of A, then iterative refinement
C       is known as Gauss-Seidel.   The SLAP routine SSGS implements
C       this iterative strategy.
C
C       This routine does  not care  what matrix data   structure is
C       used for  A and M.  It simply   calls  the MATVEC and MSOLVE
C       routines, with  the arguments as  described above.  The user
C       could write any type of structure and the appropriate MATVEC
C       and MSOLVE routines.  It is assumed  that A is stored in the
C       IA, JA, A  arrays in some fashion and  that M (or INV(M)) is
C       stored  in  IWORK  and  RWORK)  in  some fashion.   The SLAP
C       routines SSJAC and SSGS are examples of this procedure.
C
C       Two  examples  of  matrix  data structures  are the: 1) SLAP
C       Triad  format and 2) SLAP Column format.
C
C       =================== S L A P Triad format ===================
C
C       In  this   format only the  non-zeros are  stored.  They may
C       appear  in *ANY* order.   The user  supplies three arrays of
C       length NELT, where  NELT  is the number  of non-zeros in the
C       matrix:  (IA(NELT), JA(NELT),  A(NELT)).  For each  non-zero
C       the  user puts   the row  and  column index   of that matrix
C       element in the IA and JA arrays.  The  value of the non-zero
C       matrix  element is  placed in  the corresponding location of
C       the A  array.  This is  an extremely easy data  structure to
C       generate.  On  the other hand it  is  not too  efficient  on
C       vector  computers   for the  iterative  solution  of  linear
C       systems.  Hence, SLAP  changes this input  data structure to
C       the SLAP   Column  format for the  iteration (but   does not
C       change it back).
C
C       Here is an example of the  SLAP Triad   storage format for a
C       5x5 Matrix.  Recall that the entries may appear in any order.
C
C
C           5x5 Matrix      SLAP Triad format for 5x5 matrix on left.
C                              1  2  3  4  5  6  7  8  9 10 11
C       |11 12  0  0 15|   A: 51 12 11 33 15 53 55 22 35 44 21
C       |21 22  0  0  0|  IA:  5  1  1  3  1  5  5  2  3  4  2
C       | 0  0 33  0 35|  JA:  1  2  1  3  5  3  5  2  5  4  1
C       | 0  0  0 44  0|
C       |51  0 53  0 55|
C
C       =================== S L A P Column format ==================
C
C       In  this format   the non-zeros are    stored counting  down
C       columns (except  for the diagonal  entry, which must  appear
C       first in each "column") and are  stored in the real array A.
C       In other words,  for  each column    in the matrix   put the
C       diagonal  entry  in A.   Then   put  in the  other  non-zero
C       elements going   down the  column (except  the  diagonal) in
C       order.  The IA array holds the row index  for each non-zero.
C       The JA array holds the offsets into the IA, A arrays for the
C       beginning   of   each  column.      That is,   IA(JA(ICOL)),
C       A(JA(ICOL)) points to the beginning of the ICOL-th column in
C       IA and  A.  IA(JA(ICOL+1)-1), A(JA(ICOL+1)-1)  points to the
C       end of the ICOL-th column.  Note that we always have JA(N+1)
C       = NELT+1, where N is the number of columns in the matrix and
C       NELT is the number of non-zeros in the matrix.
C
C       Here is an example of the  SLAP Column  storage format for a
C       5x5 Matrix (in the A and IA arrays '|'  denotes the end of a
C       column):
C
C           5x5 Matrix      SLAP Column format for 5x5 matrix on left.
C                              1  2  3    4  5    6  7    8    9 10 11
C       |11 12  0  0 15|   A: 11 21 51 | 22 12 | 33 53 | 44 | 55 15 35
C       |21 22  0  0  0|  IA:  1  2  5 |  2  1 |  3  5 |  4 |  5  1  3
C       | 0  0 33  0 35|  JA:  1  4  6    8  9   12
C       | 0  0  0 44  0|
C       |51  0 53  0 55|
C
C *Examples:
C       See the SLAP routines SSJAC, SSGS
C
C *Cautions:
C     This routine will attempt to write to the Fortran logical output
C     unit IUNIT, if IUNIT .ne. 0.  Thus, the user must make sure that
C     this logical unit is attached to a file or terminal before calling
C     this routine with a non-zero value for IUNIT.  This routine does
C     not check for the validity of a non-zero IUNIT unit number.
C
C***SEE ALSO  SSJAC, SSGS
C***REFERENCES  1. Gene Golub and Charles Van Loan, Matrix Computations,
C                  Johns Hopkins University Press, Baltimore, Maryland,
C                  1983.
C               2. Mark K. Seager, A SLAP for the Masses, in
C                  G. F. Carey, Ed., Parallel Supercomputing: Methods,
C                  Algorithms and Applications, Wiley, 1989, pp.135-155.
C***ROUTINES CALLED  ISSIR, R1MACH
C***REVISION HISTORY  (YYMMDD)
C   871119  DATE WRITTEN
C   881213  Previous REVISION DATE
C   890915  Made changes requested at July 1989 CML Meeting.  (MKS)
C   890921  Removed TeX from comments.  (FNF)
C   890922  Numerous changes to prologue to make closer to SLATEC
C           standard.  (FNF)
C   890929  Numerous changes to reduce SP/DP differences.  (FNF)
C   891004  Added new reference.
C   910411  Prologue converted to Version 4.0 format.  (BAB)
C   910502  Removed MATVEC and MSOLVE from ROUTINES CALLED list.  (FNF)
C   920407  COMMON BLOCK renamed SSLBLK.  (WRB)
C   920511  Added complete declaration section.  (WRB)
C   920929  Corrected format of references.  (FNF)
C   921019  Changed 500.0 to 500 to reduce SP/DP differences.  (FNF)
C***END PROLOGUE  SIR
C     .. Scalar Arguments ..
      REAL ERR, TOL
      INTEGER IERR, ISYM, ITER, ITMAX, ITOL, IUNIT, N, NELT
C     .. Array Arguments ..
      REAL A(NELT), B(N), DZ(N), R(N), RWORK(*), X(N), Z(N)
      INTEGER IA(NELT), IWORK(*), JA(NELT)
C     .. Subroutine Arguments ..
      EXTERNAL MATVEC, MSOLVE
C     .. Local Scalars ..
      REAL BNRM, SOLNRM, TOLMIN
      INTEGER I, K
C     .. External Functions ..
      REAL R1MACH
      INTEGER ISSIR
      EXTERNAL R1MACH, ISSIR
C***FIRST EXECUTABLE STATEMENT  SIR
C
C         Check some of the input data.
C
      ITER = 0
      IERR = 0
      IF( N.LT.1 ) THEN
         IERR = 3
         RETURN
      ENDIF
      TOLMIN = 500*R1MACH(3)
      IF( TOL.LT.TOLMIN ) THEN
         TOL = TOLMIN
         IERR = 4
      ENDIF
C
C         Calculate initial residual and pseudo-residual, and check
C         stopping criterion.
      CALL MATVEC(N, X, R, NELT, IA, JA, A, ISYM)
      DO 10 I = 1, N
         R(I) = B(I) - R(I)
 10   CONTINUE
      CALL MSOLVE(N, R, Z, NELT, IA, JA, A, ISYM, RWORK, IWORK)
C
      IF( ISSIR(N, B, X, NELT, IA, JA, A, ISYM, MSOLVE, ITOL, TOL,
     $     ITMAX, ITER, ERR, IERR, IUNIT, R, Z, DZ, RWORK,
     $     IWORK, BNRM, SOLNRM) .NE. 0 ) GO TO 200
      IF( IERR.NE.0 ) RETURN
C
C         ***** iteration loop *****
C
      DO 100 K=1,ITMAX
         ITER = K
C
C         Calculate new iterate x, new residual r, and new
C         pseudo-residual z.
         DO 20 I = 1, N
            X(I) = X(I) + Z(I)
 20      CONTINUE
         CALL MATVEC(N, X, R, NELT, IA, JA, A, ISYM)
         DO 30 I = 1, N
            R(I) = B(I) - R(I)
 30      CONTINUE
         CALL MSOLVE(N, R, Z, NELT, IA, JA, A, ISYM, RWORK, IWORK)
C
C         check stopping criterion.
         IF( ISSIR(N, B, X, NELT, IA, JA, A, ISYM, MSOLVE, ITOL, TOL,
     $        ITMAX, ITER, ERR, IERR, IUNIT, R, Z, DZ, RWORK,
     $        IWORK, BNRM, SOLNRM) .NE. 0 ) GO TO 200
C
 100  CONTINUE
C
C         *****   end of loop  *****
C         Stopping criterion not satisfied.
      ITER = ITMAX + 1
      IERR = 2
C
 200  RETURN
C------------- LAST LINE OF SIR FOLLOWS -------------------------------
      END

subroutine setgon(line,error)
  use gildas_def
  use phys_const
  use gbl_message
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>setgon
  use greg_kernel
  use greg_poly
  use greg_types
  !---------------------------------------------------------------------
  ! @ private
  ! Support routine for command
  !   POLYGON [(File)Name]
  ! 1  [/PLOT]
  ! 2  [/VARIABLE]
  ! 3  [/FILL [Icolor]]
  ! 4  [/RESET]
  ! 5  [/HATCH [Ipen] [Angle] [Separ] [Phase]]
  !---------------------------------------------------------------------
  character(len=*), intent(in)  :: line
  logical,          intent(out) :: error
  ! Local
  integer(kind=4), parameter :: iname = 0
  integer(kind=4), parameter :: ivar  = 2
  character(len=*), parameter :: rname='POLYGON'
  character(len=filename_length) :: polyname
  logical :: plot,fill,hatch,new,reset,isfile
  type(polygon_drawing_t) :: drawing
  !
  error = .false.
  plot = sic_present(1,0)
  fill = sic_present(3,0)
  hatch = sic_present(5,0)
  reset = sic_present(4,0)
  new  = sic_present(0,1) .or. .not.(plot.or.fill.or.hatch) .or. gpoly%ngon.eq.0
  !
  if (reset) then
    call greg_poly_reset(gpoly,'POLY',error)
    return  ! Always
  endif
  !
  if (new) then
    call greg_poly_parsename(line,iname,ivar,isfile,polyname,error)
    if (error) return
    call greg_poly_define(rname,polyname,isfile,gpoly,'POLY',error)
    if (error)  return
  endif
  !
  ! Real plot if requested
  if (plot .or. fill .or. hatch) then
    call parse_polygon_drawing(rname,line,3,5,drawing,error)
    if (error)  return
    drawing%contoured = plot
    call greg_poly_plot(gpoly,drawing,error)
    if (error)  return
  endif
  !
end subroutine setgon
!
subroutine greg_poly_reset(poly,varname,error)
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>greg_poly_reset
  use greg_types
  !---------------------------------------------------------------------
  ! @ public
  !---------------------------------------------------------------------
  type(polygon_t),  intent(inout) :: poly     !
  character(len=*), intent(in)    :: varname  ! Support variable in Sic
  logical,          intent(inout) :: error    ! Input status preserved if no error here
  !
  poly%ngon = 0
  !
  call greg_poly_delvar(varname,error)
  if (error)  return
  !
end subroutine greg_poly_reset
!
subroutine greg_poly_delvar(varname,error)
  !---------------------------------------------------------------------
  ! @ private
  !  Delete the content of the polygon variable (NOT the structure
  ! itself: this is a program defined reserved name, always present)
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: varname  ! Support variable in Sic
  logical,          intent(inout) :: error    ! Input status preserved if no error here
  ! Local
  logical :: error2
  !
  error2 = .false.
  !
  if (varname.ne.'') then
    call sic_delvariable(trim(varname)//'%NXY',.false.,error2)
    call sic_delvariable(trim(varname)//'%X',.false.,error2)
    call sic_delvariable(trim(varname)//'%Y',.false.,error2)
    ! Also destroy those, they have no sense if polygon is updated
    call sic_delvariable(trim(varname)//'%SUM',.false.,error2)
    call sic_delvariable(trim(varname)//'%AREA',.false.,error2)
    call sic_delvariable(trim(varname)//'%RMS',.false.,error2)
    call sic_delvariable(trim(varname)//'%NPIX',.false.,error2)
    call sic_delvariable(trim(varname)//'%MIN',.false.,error2)
    call sic_delvariable(trim(varname)//'%MAX',.false.,error2)
    error2 = .false.  ! Not an error if not found
  endif
  !
  if (error2)  error = .true.
  !
end subroutine greg_poly_delvar
!
subroutine greg_poly_define(rname,srcname,srcisfile,poly,varname,error)
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>greg_poly_define
  use greg_types
  !---------------------------------------------------------------------
  ! @ public
  !  Define or define a polygon from a source (variable or file)
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: rname      !
  character(len=*), intent(in)    :: srcname    ! Source name
  logical,          intent(in)    :: srcisfile  ! Source is a file or variable?
  type(polygon_t),  intent(inout) :: poly       !
  character(len=*), intent(in)    :: varname    ! Support variable in Sic
  logical,          intent(inout) :: error      !
  !
  call greg_poly_load(rname,srcisfile,srcname,poly,error)
  if (error) then
    poly%ngon = 0
    continue  ! Also delete the variable for safety
  endif
  !
  call greg_poly_delvar(varname,error)
  if (error)  return
  !
  if (poly%ngon.ne.0 .and. varname.ne.'') then
    call sic_def_inte(trim(varname)//'%NXY',poly%ngon,0,1,.true.,error)
    call sic_def_dble(trim(varname)//'%X',poly%xgon,1,poly%ngon,.true.,error)
    call sic_def_dble(trim(varname)//'%Y',poly%ygon,1,poly%ngon,.true.,error)
    if (error)  return
  endif
  !
end subroutine greg_poly_define
!
subroutine greg_poly_plot1(poly,error)
  use gildas_def
  use gbl_message
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>greg_poly_plot1
  use greg_pen
  use greg_types
  !---------------------------------------------------------------------
  ! @ public-generic greg_poly_plot
  !  Draw the input polygon (contours only) with current pen
  !---------------------------------------------------------------------
  type(polygon_t), intent(in)    :: poly
  logical,         intent(inout) :: error
  ! Local
  type(polygon_drawing_t) :: drawing
  !
  drawing%contoured = .true.
  call inqpen(drawing%cpen)
  drawing%filled = .false.
  drawing%hatched = .false.
  !
  call greg_poly_plot2(poly,drawing,error)
  if (error)  return
  !
end subroutine greg_poly_plot1
!
subroutine greg_poly_plot2(poly,drawing,error)
  use gildas_def
  use gbl_message
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>greg_poly_plot2
  use greg_pen
  use greg_types
  !---------------------------------------------------------------------
  ! @ public-generic greg_poly_plot
  !  Draw the input polygon:
  !  - contoured, and/or
  !  - filled, and/or
  !  - hatched
  !---------------------------------------------------------------------
  type(polygon_t),         intent(in)    :: poly     !
  type(polygon_drawing_t), intent(in)    :: drawing  !
  logical,                 intent(inout) :: error    !
  ! Local
  integer(kind=4) :: icol_old,ipen_old
  integer(kind=size_length) :: ngon_sl
  !
  if (poly%ngon.le.2) then
    call greg_message(seve%e,'POLYGON','No polygon defined')
    error = .true.
    return
  endif
  !
  call inqcol(icol_old)
  call inqpen(ipen_old)
  if (penupd)  call setpen(cpen)
  !
  ! Contouring, filling and hatching can be combined, but we need 3
  ! different GTV segments with their own attributes each
  if (drawing%contoured) then
    call gtsegm('POLYGON',error)
    call setpen(drawing%cpen)
    !
    call gr8_connect(poly%ngon+1,poly%xgon,poly%ygon,0.d0,-1.d0)
    !
    call gtsegm_close(error)  ! Close the segment before resetting the color
    call setpen(ipen_old)
  endif
  !
  if (drawing%filled) then
    call gtsegm('POLYGON',error)
    call setcol(drawing%fcolor)
    !
    ngon_sl = poly%ngon+1
    call gr8_ufill(ngon_sl,poly%xgon,poly%ygon)
    !
    call gtsegm_close(error)
    call setcol(icol_old)
  endif
  !
  if (drawing%hatched) then
    call gtsegm('POLYGON',error)
    call setpen(drawing%hpen)
    !
    ngon_sl = poly%ngon+1
    call gr8_hatch('POLYGON',ngon_sl,poly%xgon,poly%ygon,  &
                   drawing%hangle,drawing%hsepar,drawing%hphase,error)
    if (error)  continue
    !
    call gtsegm_close(error)
    call setpen(ipen_old)
  endif
  !
end subroutine greg_poly_plot2
!
subroutine meanva(line,error)
  use gildas_def
  use gbl_message
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>meanva
  use greg_kernel
  use greg_poly
  use greg_rg
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  character(len=*), intent(in)  :: line
  logical,          intent(out) :: error
  ! Global
  include 'gbl_pi.inc'
  include 'gbl_memory.inc'
  ! Local
  character(len=*), parameter :: rname='MEAN'
  real(kind=4) :: sum,aire,mean,sigma,prev_sigma,minmax(2)
  integer(kind=4) :: npix
  real(kind=4) :: nsig_clip
  real(kind=4) :: b,eb,range,center
  logical :: clip,quiet
  !
  save sum,aire,sigma,npix,minmax  ! Support for Greg variables
  !
  error = .false.
  if (gpoly%ngon.le.2) then
    call greg_message(seve%e,rname,'No polygon defined')
    error = .true.
  endif
  if (rg%status.eq.code_pointer_null) then
    call greg_message(seve%e,rname,'No map loaded')
    error = .true.
  endif
  if (error) return
  !
  ! Define a variable to handle the result
  if (sic_varexist('POLY%AREA')) call sic_delvariable('POLY%AREA',.false.,error)
  call sic_def_real ('POLY%AREA',aire,0,0,.true.,error)
  if (sic_varexist('POLY%SUM')) call sic_delvariable('POLY%SUM',.false.,error)
  call sic_def_real ('POLY%SUM',sum,0,0,.true.,error)
  if (sic_varexist('POLY%RMS')) call sic_delvariable('POLY%RMS',.false.,error)
  call sic_def_real ('POLY%RMS',sigma,0,0,.true.,error)
  if (sic_varexist('POLY%NPIX')) call sic_delvariable('POLY%NPIX',.false.,error)
  call sic_def_inte('POLY%NPIX',npix,0,0,.true.,error)
  if (sic_varexist('POLY%MIN')) call sic_delvariable('POLY%MIN',.false.,error)
  call sic_def_real('POLY%MIN',minmax(1),0,0,.true.,error)
  if (sic_varexist('POLY%MAX')) call sic_delvariable('POLY%MAX',.false.,error)
  call sic_def_real('POLY%MAX',minmax(2),0,0,.true.,error)
  !
  b=cblank
  eb=eblank
  quiet = sic_present(0,1)
  clip = sic_present(1,0)
  if (clip) then
    call sic_r4 (line,1,1,nsig_clip,.true.,error)
    if (nsig_clip.le.0.0) then
      call greg_message(seve%e,rname,'Illegal clipping level')
      error = .true.
      return
    endif
  endif
  !
  call gr8_moments(rg%data,gpoly,b,eb,.false.,center,range,sum,aire,npix,  &
    mean,sigma,minmax)
  if (clip) then
    prev_sigma = maxr4
    do while (sigma.le.0.9*prev_sigma.and.sigma.gt.0)
      prev_sigma = sigma
      center = mean
      range  = sigma*nsig_clip
      call gr8_moments(rg%data,gpoly,b,eb,.true.,center,range,sum,aire,npix,  &
        mean,sigma,minmax)
    enddo
  endif
  if (quiet) return
  call print_mean(sum,aire,npix,mean,sigma,minmax)
end subroutine meanva
!
subroutine gr8_moments(z,poly,b,eb,clip,center,range,sum,aire,npix,mean,  &
  sigma,minmax)
  use phys_const
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>gr8_moments
  use greg_types
  use greg_rg
  !---------------------------------------------------------------------
  ! @ private
  ! Compute statistics about the regular grid array within a N-gon
  !---------------------------------------------------------------------
  real(kind=4),    intent(in)  :: z(*)       ! Regular grid array
  type(polygon_t), intent(in)  :: poly       ! Current polygon
  real(kind=4),    intent(in)  :: b          ! Blanking value
  real(kind=4),    intent(in)  :: eb         ! Tolerance on blanking
  logical,         intent(in)  :: clip       ! Clip out of range values
  real(kind=4),    intent(in)  :: center     ! Center of accepted interval
  real(kind=4),    intent(in)  :: range      ! Half width of accepted interval
  real(kind=4),    intent(out) :: sum        ! Integrated map value
  real(kind=4),    intent(out) :: aire       ! Area of polygon
  integer(kind=4), intent(out) :: npix       ! Number of interior pixels
  real(kind=4),    intent(out) :: mean       ! Mean map value
  real(kind=4),    intent(out) :: sigma      ! RMS value
  real(kind=4),    intent(out) :: minmax(2)  ! Min and max values
  ! Local
  real(kind=8) :: x,y,s1,s2,value
  integer(kind=4) :: i,j,s0,imin,imax,jmin,jmax
  !
  s0 = 0
  s1 = 0.
  s2 = 0.
  sigma = 0.
  mean = 0.
  !
  ! Avoid exploring all the Map by finding IMIN,IMAX,JMIN,JMAX
  if (rg%xinc.gt.0.) then
    imin = max (1,    int((poly%xgon1-rg%xval)/rg%xinc+rg%xref) )
    imax = min (rg%nx,int((poly%xgon2-rg%xval)/rg%xinc+rg%xref)+1 )
  else
    imin = max (1,    int((poly%xgon2-rg%xval)/rg%xinc+rg%xref) )
    imax = min (rg%nx,int((poly%xgon1-rg%xval)/rg%xinc+rg%xref)+1 )
  endif
  if (rg%yinc.gt.0.) then
    jmin = max (1,    int((poly%ygon1-rg%yval)/rg%yinc+rg%yref) )
    jmax = min (rg%ny,int((poly%ygon2-rg%yval)/rg%yinc+rg%yref)+1 )
  else
    jmin = max (1,    int((poly%ygon2-rg%yval)/rg%yinc+rg%yref) )
    jmax = min (rg%ny,int((poly%ygon1-rg%yval)/rg%yinc+rg%yref)+1 )
  endif
  !
  ! Now explore a reasonable part of the map
  if (eb.lt.0.0) then
    ! Blanking is disabled
    minmax(:) = z((jmin-1)*rg%nx+imin)  ! First value is valid
    do j=jmin,jmax
      do i=imin,imax
        value = z((j-1)*rg%nx+i)
        if (.not.clip.or.abs(value-center).le.range) then
          x = (i-rg%xref)*rg%xinc+rg%xval
          y = (j-rg%yref)*rg%yinc+rg%yval
          if (greg_poly_inside(x,y,poly)) then
            s0 = s0 + 1
            s1 = s1 + value
            s2 = s2 + value**2
            if (minmax(1).gt.value)  minmax(1) = value  ! Min
            if (minmax(2).lt.value)  minmax(2) = value  ! Max
          endif
        endif
      enddo
    enddo
  else
    ! Blanking is enabled
    minmax(:) = b  ! First valid value is not known
    do j=jmin,jmax
      do i=imin,imax
        value = z((j-1)*rg%nx+i)
        if (.not.clip.or.abs(value-center).le.range) then
          if (abs(value-b).gt.eb) then
            x = (i-rg%xref)*rg%xinc+rg%xval
            y = (j-rg%yref)*rg%yinc+rg%yval
            if (greg_poly_inside(x,y,poly)) then
              s0 = s0 + 1
              s1 = s1 + value
              s2 = s2 + value**2
              if (minmax(1).eq.b) then
                minmax(1) = value
              elseif (minmax(1).gt.value) then
                minmax(1) = value  ! Min
              endif
              if (minmax(2).eq.b) then
                minmax(2) = value
              elseif (minmax(2).lt.value) then
                minmax(2) = value  ! Max
              endif
            endif
          endif
        endif
      enddo
    enddo
  endif
  !
  x = abs(rg%xinc*rg%yinc)
  sum = s1*x
  aire = s0*x
  npix = s0
  if (s0.ne.0) then
    s1 = s1 / s0
    mean = s1  ! Downcast to single precision, do not reuse below
    s2 = s2 / s0
    sigma = sqrt(s2-s1**2)
  endif
end subroutine gr8_moments
!
subroutine print_mean(sum,aire,npix,mean,sigma,minmax)
  use phys_const
  use gbl_message
  use greg_interfaces, except_this=>print_mean
  use greg_wcs
  !---------------------------------------------------------------------
  ! @ private
  ! Print statistics about the regular grid array within a N-gon
  !---------------------------------------------------------------------
  real(kind=4),    intent(in) :: sum        ! Integrated map value
  real(kind=4),    intent(in) :: aire       ! Area of polygon
  integer(kind=4), intent(in) :: npix       ! Number of pixels within polygon
  real(kind=4),    intent(in) :: mean       ! Mean map value
  real(kind=4),    intent(in) :: sigma      ! RMS value
  real(kind=4),    intent(in) :: minmax(2)  ! Min and max values
  ! Local
  character(len=*), parameter :: rname='MEAN'
  character(len=80) :: chain
  !
  if (aire.le.0) then
    call greg_message(seve%e,rname,'No Valid Pixels Found inside Polygon')
    return
  endif
  if (gproj%type.ne.p_none) then
    if (u_angle.eq.u_degree) then
      write (chain,100) npix,aire*(180.0d0/pi)*(180.0d0/pi),  &
                        ' Arc. Deg. squared'
      call greg_message(seve%i,rname,chain)
      write(chain,101) sum*(180.0d0/pi)*(180.0d0/pi),  &
                       ' (Map Units * Arc. Deg. squared)'
      call greg_message(seve%i,rname,chain)
      !
    elseif (u_angle.eq.u_minute) then
      write (chain,100) npix,aire*(10800.0d0/pi)*(10800.0d0/pi),  &
                        ' Arc. Min. squared'
      call greg_message(seve%i,rname,chain)
      write(chain,101) sum*(10800.0d0/pi)*(10800.0d0/pi),  &
                       ' (Map Units * Arc. Min. squared)'
      call greg_message(seve%i,rname,chain)
      !
    elseif (u_angle.eq.u_second) then
      write (chain,100) npix,aire*6.48d5/pi*6.48d5/pi,  &
                        ' Arc. Sec. squared'
      call greg_message(seve%i,rname,chain)
      write(chain,101) sum*6.48d5/pi*6.48d5/pi,  &
                       ' (Map Units * Arc. Sec. squared)'
      call greg_message(seve%i,rname,chain)
      !
    else
      write (chain,100) npix,aire,' Radians squared'
      call greg_message(seve%i,rname,chain)
      write(chain,101) sum,' (Map Units * Radians squared)'
      call greg_message(seve%i,rname,chain)
    endif
  else
    write (chain,100) npix,aire,' User Units squared'
    call greg_message(seve%i,rname,chain)
    write(chain,101) sum,' (Map Units * User Units Squared)'
    call greg_message(seve%i,rname,chain)
  endif
  !
  write(chain,102) mean,sigma
  call greg_message(seve%i,rname,chain)
  !
  write(chain,103) minmax(1),minmax(2)
  call greg_message(seve%i,rname,chain)
  !
100 format('Found ',i0,' non-blanked pixels, of area:',1pg11.4,a)
101 format('Integrated intensity:',1pg13.6,a)
102 format('Mean value: ',1pg12.5,', r.m.s.: ',1pg12.5)
103 format('Min value: ',1pg12.5,', max value: ',1pg12.5)
end subroutine print_mean
!
subroutine greg_poly_loadsub(rname,poly,lun,chain,error)
  use gildas_def
  use gbl_message
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>greg_poly_loadsub
  use greg_types
  !---------------------------------------------------------------------
  ! @ private
  !  Defines a polygon, either from file, from variable, or with the
  ! cursor.
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: rname  ! Calling command name
  type(polygon_t),  intent(out)   :: poly   ! Defined polygon
  integer(kind=4),  intent(in)    :: lun    ! Logical unit number (0=>Cursor)
  character(len=*), intent(in)    :: chain  ! Variable name
  logical,          intent(inout) :: error  ! Logical error flag
  ! Local
  integer(kind=index_length) :: ng
  character(len=message_length) :: mess
  !
  ! Read from a file
  if (lun.ne.0) then
    ng = 0
    do while (.true.)
      ng = ng+1
      read(lun,*,err=99,end=20) poly%xgon(ng),poly%ygon(ng)
      if (ng.ge.mgon) then
        write (mess,'(A,I4)') 'Too many vertices, truncated to ',mgon-1
        call greg_message(seve%e,rname,mess)
        exit  ! loop
      endif
    enddo
20  poly%ngon = ng-1
    !
  elseif (chain.ne."") then
    call greg_poly_variable(rname,chain,poly,error)
    if (error)  return
    !
  else
    ! Use the cursor to set up the summits
    call greg_poly_cursor(rname,poly,error)
    if (error)  return
  endif
  !
  ! Setup the polygon data structure
  if (poly%ngon.ge.mgon) then
    call greg_message(seve%e,rname,'Too many vertices, truncated')
    error = .true.
  endif
  poly%xgon(poly%ngon+1) = poly%xgon(1)
  poly%ygon(poly%ngon+1) = poly%ygon(1)
  poly%xgon1 = poly%xgon(1)
  poly%xgon2 = poly%xgon(1)
  poly%ygon1 = poly%ygon(1)
  poly%ygon2 = poly%ygon(1)
  do ng=1,poly%ngon
    poly%dxgon(ng) = poly%xgon(ng+1)-poly%xgon(ng)
    if (poly%xgon(ng+1).lt.poly%xgon1) then
      poly%xgon1 = poly%xgon(ng+1)
    elseif (poly%xgon(ng+1).gt.poly%xgon2) then
      poly%xgon2 = poly%xgon(ng+1)
    endif
    poly%dygon(ng) = poly%ygon(ng+1)-poly%ygon(ng)
    if (poly%ygon(ng+1).lt.poly%ygon1) then
      poly%ygon1 = poly%ygon(ng+1)
    elseif (poly%ygon(ng+1).gt.poly%ygon2) then
      poly%ygon2 = poly%ygon(ng+1)
    endif
  enddo
  poly%yeps = (poly%ygon2-poly%ygon1)*1.d-9
  poly%xout = poly%xgon1-0.01*(poly%xgon2-poly%xgon1)
  return
  !
99 call greg_message(seve%e,rname,'Error reading input file')
  error = .true.
  !
end subroutine greg_poly_loadsub
!
subroutine greg_poly_variable(rname,varname,poly,error)
  use gbl_format
  use gbl_message
  use sic_types
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>greg_poly_variable
  use greg_types
  !---------------------------------------------------------------------
  ! @ private
  ! Define the polygon from a Sic variable name. The variables can be:
  !  - a real or double array of the form:
  !       VAR[NXY,2]  Real or Double
  !  - a structure of the form:
  !       VAR%NXY         Integer or Long
  !       VAR%X[VAR%NXY]  Real or Double
  !       VAR%Y[VAR%NXY]  Real or Double
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: rname    ! Calling routine name
  character(len=*), intent(in)    :: varname  ! Sic variable name
  type(polygon_t),  intent(out)   :: poly     ! Defined polygon
  logical,          intent(inout) :: error    ! Logical error flag
  ! Global
  include 'gbl_memory.inc'
  ! Local
  logical :: found
  type(sic_descriptor_t) :: descr
  integer(kind=4) :: formx,formy,ngon,lv
  integer(kind=address_length) :: ipx,ipy
  character(len=message_length) :: mess
  !
  lv = len_trim(varname)
  if (varname(lv:lv).eq.'%') lv = lv-1
  !
  found = .false.  ! Not verbose
  call sic_descriptor(varname(1:lv),descr,found)
  if (.not.found) then
    call greg_message(seve%e,rname,'No such variable '//varname)
    error = .true.
    return
  endif
  !
  if (descr%type.lt.0) then  ! Numeric
    if (descr%dims(2).ne.2 .or. descr%dims(3).gt.1) then
      call greg_message(seve%e,rname,'Variable must be of size [NXY,2]')
      error = .true.
      return
    endif
    ngon = descr%dims(1)
    ipx = gag_pointer(descr%addr,memory)
    formx = descr%type
    ipy = gag_pointer(descr%addr,memory)+descr%size/2  ! Generic R*4 and R*8
    formy = descr%type
    !
  elseif (descr%type.eq.0) then  ! Structure
    call sic_get_inte(varname(1:lv)//'%NXY',ngon,error)
    if (error) then
      call greg_message(seve%e,rname,'No such variable '//varname(1:lv)//'%NXY')
      return
    endif
    !
    found = .true.  ! Verbose
    call sic_descriptor(varname(1:lv)//'%X',descr,found)
    if (.not.found) then
      error = .true.
      return
    endif
    formx = descr%type
    ipx = gag_pointer(descr%addr,memory)
    !
    found = .true.  ! Verbose
    call sic_descriptor(varname(1:lv)//'%Y',descr,found)
    if (.not.found) then
      error = .true.
      return
    endif
    formy = descr%type
    ipy = gag_pointer(descr%addr,memory)
    !
  else
    call greg_message(seve%e,rname,'Unsupported variable type')
    error = .true.
    return
  endif
  !
  if (ngon.ge.mgon) then
    write (mess,'(A,I0)') 'Too many vertices, truncated to ',mgon-1
    call greg_message(seve%e,rname,mess)
    ngon = mgon-1
  elseif (ngon.le.0) then
    call greg_message(seve%e,rname,'Number of vertices must be positive')
    error = .true.
    return
  endif
  poly%ngon = ngon
  !
  if (formx.eq.fmt_r4) then
    call r4tor8(memory(ipx),poly%xgon,ngon)
  elseif (formx.eq.fmt_r8) then
    call r8tor8(memory(ipx),poly%xgon,ngon)
  else
    call greg_message(seve%e,rname,'Unsupported variable type')
    error = .true.
    return
  endif
  !
  if (formy.eq.fmt_r4) then
    call r4tor8(memory(ipy),poly%ygon,ngon)
  elseif (formy.eq.fmt_r8) then
    call r8tor8(memory(ipy),poly%ygon,ngon)
  else
    call greg_message(seve%e,rname,'Unsupported variable type')
    error = .true.
    return
  endif
  !
end subroutine greg_poly_variable
!
subroutine greg_poly_cursor(rname,poly,error)
  use gbl_message
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>greg_poly_cursor
  use greg_types
  !---------------------------------------------------------------------
  ! @ public
  ! Define a polygon with the cursor
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: rname  ! Calling command name
  type(polygon_t),  intent(out)   :: poly   !
  logical,          intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=1) :: code
  real(kind=8) :: xa,ya,xlast(2),ylast(2)
  real(kind=4) :: xcurse,ycurse
  integer(kind=4) :: oldpen,newpen
  character(len=message_length) :: mess
  !
  if (.not.gtg_curs()) then
    call greg_message(seve%e,rname,'No cursor available')
    error = .true.
    return
  endif
  !
  poly%ngon = 0
  newpen = 3  ! i.e. blue (by default)
  oldpen = gr_spen(newpen)
  do while (poly%ngon.lt.mgon-1)
    call gr_curs(xa,ya,xcurse,ycurse,code)
    if (code.eq.'H') then
      write (*,'(A)') 'Type H for help '
      write (*,'(A)') '     E to exit '
      write (*,'(A)') '     Q to abort (quit)'
      write (*,'(A)') '     C to correct the last vertex'
      write (*,'(A)') '     D to delete the last vertex'
      write (*,'(A)') '     anything else to set a new vertex'
      write (*,'(A)') 'Mouse Button Actions:'
      write (*,'(A)') '     Left   - set new vertex'
      write (*,'(A)') '     Middle - delete last vertex'
      write (*,'(A)') '     Right  - exit'
      !
    elseif (code.eq.'Q') then
      call greg_message(seve%e,rname,'Aborting.')
      if (poly%ngon.ge.2) then
        call gtdls
      endif
      poly%ngon = 0
      error = .true.
      goto 99
      !
    elseif (code.eq.'C') then
      ! ngon unchanged
      poly%xgon(poly%ngon) = xa
      poly%ygon(poly%ngon) = ya
      !
      write(mess,100) 'VERTEX',poly%ngon,xa,ya,'(corrected)'
      call greg_message(seve%r,rname,mess)
      !
      call gtdls  ! Destroy the POLYGON segment...
      call gr_segm('POLYGON',error)  ! .. and recreate a new one
      if (error)  goto 99
      call gr8_connect(poly%ngon,poly%xgon,poly%ygon,0.d0,-1.d0)
      call gtview('Update')
      !
    elseif (code.eq.'D' .or. code.eq.'&') then
      write(mess,101) 'VERTEX',poly%ngon,'deleted'
      call greg_message(seve%r,rname,mess)
      !
      poly%ngon = poly%ngon-1
      if (poly%ngon.lt.0)  poly%ngon = 0
      !
      if (poly%ngon.ge.2) then
        call gtdls  ! Destroy the POLYGON segment...
        call gr_segm('POLYGON',error)  ! .. and recreate a new one
        if (error)  goto 99
        call gr8_connect(poly%ngon,poly%xgon,poly%ygon,0.d0,-1.d0)
        call gtview('Update')
      endif
      !
    elseif (code.eq.'E' .or. code.eq.'*') then
      ! Exit i.e. finalize the polygon
      if (poly%ngon.le.2) then
        call greg_message(seve%e,rname,'Polygon has less than 3 points')
        error = .true.
        goto 99
      endif
      !
      xlast(1) = poly%xgon(poly%ngon)
      xlast(2) = poly%xgon(1)
      ylast(1) = poly%ygon(poly%ngon)
      ylast(2) = poly%ygon(1)
      call gr8_connect(2,xlast,ylast,0.d0,-1.d0)
      call gtsegm_close(error)
      goto 99
      !
    else
      ! Add a new vertex
      poly%ngon = poly%ngon+1
      poly%xgon(poly%ngon) = xa
      poly%ygon(poly%ngon) = ya
      !
      write(mess,100) 'VERTEX',poly%ngon,xa,ya
      call greg_message(seve%r,rname,mess)
      !
      ! Store in the metacode and plot
      if (poly%ngon.lt.2)  cycle  ! Do loop
      if (poly%ngon.eq.2) then
        call gr_segm('POLYGON',error)
        if (error)  goto 99
      endif
      ! Add the new points:
      call gr8_connect(2,poly%xgon(poly%ngon-1),poly%ygon(poly%ngon-1),0.d0,-1.d0)
      ! Do not close the segment: just draw its current points
      call gtview('Append')
      !
    endif
  enddo
  call greg_message(seve%e,rname,'Too many vertices, exiting from cursor mode')
  !
99 newpen = gr_spen(oldpen)
  !
100 format(2x,A,' #',I0,': ',2(1pg10.3,1x),A)
101 format(2x,A,' #',I0,': ',A)
end subroutine greg_poly_cursor
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine greg_poly_parsename(line,iname,ivar,isfile,name,error)
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>greg_poly_parsename
  use greg_types
  !---------------------------------------------------------------------
  ! @ public
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line
  integer(kind=4),  intent(in)    :: iname
  integer(kind=4),  intent(in)    :: ivar
  logical,          intent(out)   :: isfile
  character(len=*), intent(out)   :: name
  logical,          intent(inout) :: error
  !
  integer(kind=4) :: nc
  character(len=filename_length) :: chain
  !
  isfile = .false.
  if (sic_present(iname,1)) then
     call sic_ch(line,0,1,chain,nc,.true.,error)
     if (error) return
     if (.not.sic_present(ivar,0)) then
        isfile = .true.
        call sic_parse_file(chain,' ','.pol',name)
     else
        name = trim(chain)
     endif
  else
     name = ' '
  endif
  !
end subroutine greg_poly_parsename
!
subroutine greg_poly_load(rname,isfile,polyname,poly,error)
  use gbl_message
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>greg_poly_load
  use greg_types
  !---------------------------------------------------------------------
  ! @ public
  ! Load the polygon data into the poly structure
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: rname
  logical,          intent(in)    :: isfile
  character(len=*), intent(in)    :: polyname
  type(polygon_t),  intent(out)   :: poly ! *** JP in or inout?
  logical,          intent(inout) :: error
  !
  integer(kind=4) :: lun,ier
  !
  if (isfile) then
     ier = sic_getlun(lun)
     if (ier.ne.1) then
        error = .true.
        return
     endif
     ier = sic_open(lun,polyname,'OLD',.true.)
     if (ier.ne.0) then
        call greg_message(seve%e,rname,'Cannot open file '//polyname)
        call putios('E-POLYGON,  ',ier)
        error = .true.
        goto 100
     endif
  else
     lun = 0
  endif
  !
  ! Read polygon from file or from cursor
  call greg_poly_loadsub(rname,poly,lun,polyname,error)
  ! if (error) continue
  !
100 continue
  if (lun.ne.0) then
    ier = sic_close(lun)
    call sic_frelun(lun)
  endif
  !
end subroutine greg_poly_load
!
function greg_poly_isnull()
  use greg_poly
  !---------------------------------------------------------------------
  ! @ public
  ! Return .TRUE. if Greg polygon is not a polygon / not defined
  !---------------------------------------------------------------------
  logical :: greg_poly_isnull ! Function
  !
  greg_poly_isnull = gpoly%ngon.le.2
  !
end function greg_poly_isnull
!
subroutine greg_poly_get(poly)
  use greg_interfaces, except_this=>greg_poly_get
  use greg_poly
  use greg_types
  !---------------------------------------------------------------------
  ! @ public
  ! Return Greg internal polygon values copied input polygon
  !---------------------------------------------------------------------
  type(polygon_t), intent(out) :: poly
  !
  poly = gpoly
  !
end subroutine greg_poly_get
!
function greg_poly_inside(x0,y0,poly)
  use greg_interfaces, except_this=>greg_poly_inside
  use greg_types
  !---------------------------------------------------------------------
  ! @ public
  ! Find if a point is within a polygon.
  !
  ! This uses the Ray casting algorithm, counting how many times a ray
  ! starting from the point crosses the polygon boundaries. Note that
  ! there are critical conditions to be taken into account when the
  ! point is on a vertex or on a boundary or when the ray strikes
  ! through a vertex.
  ! References:
  !  https://en.wikipedia.org/wiki/Point_in_polygon
  !  https://rosettacode.org/wiki/Ray-casting_algorithm
  !---------------------------------------------------------------------
  logical :: greg_poly_inside ! Function value on return
  real(kind=8),    intent(in) :: x0,y0  ! Coordinate of point to test
  type(polygon_t), intent(in) :: poly   ! Polygon properties
  ! Local
  logical :: yin
  integer(kind=4) :: index,igon,jgon
  real(kind=8) :: slope,x,y,xx
  !
  ! Quick check
  if (x0.lt.poly%xgon1 .or. x0.gt.poly%xgon2 .or.  &
      y0.lt.poly%ygon1 .or. y0.gt.poly%ygon2) then
     greg_poly_inside = .false.
     return
  endif
  greg_poly_inside = .true.
  !
  ! Count intersection
  x = x0
  y = y0
  index = 0
  do igon=1,poly%ngon
     if (x0.eq.poly%xgon(igon) .and. y0.eq.poly%ygon(igon)) then
        ! On a vertex
        return  ! Inside
     endif
     ! Select segment igon to jgon
     if (igon.eq.poly%ngon) then
       jgon = 1       ! Close the polygon
     else
       jgon = igon+1  ! Next summit
     endif
     if (y0.eq.poly%ygon(igon) .or. y0.eq.poly%ygon(jgon)) then
      ! To avoid the "ray on vertex" problem, the point is moved upward
      ! of a small quantity. Otherwise it would always be considered to
      ! cross the 2 segments and might mess the intersection count.
       y = y0+poly%yeps
     else
       y = y0
     endif
     ! Check Y range
     if (y.le.poly%ygon(igon) .and. y.ge.poly%ygon(jgon)) then
        yin = .true.
     elseif (y.ge.poly%ygon(igon) .and. y.le.poly%ygon(jgon)) then
        yin = .true.
     else
        yin = .false.
     endif
     ! If Y is OK, check X
     if (yin) then
        if (poly%dxgon(igon).ne.0) then
           ! Polygon side is normal
           slope = poly%dygon(igon)/poly%dxgon(igon)
           if (slope.ne.0d0) then
              ! Lines intersect
              xx = (y-poly%ygon(igon))/slope + poly%xgon(igon)
              if (xx.lt.x) then  ! Cross the boundary
                 index = index+1
              elseif (xx.eq.x) then  ! On the boundary
                 return  ! Inside
              else  ! Does not cross the boundary
                 continue
              endif
           else
              ! Lines have same slope (i.e., horizontal)
              if (x.ge.poly%xgon(igon) .and. x.le.poly%xgon(jgon)) then
                 ! On edge
                 return  ! Inside
              elseif (x.le.poly%xgon(igon) .and. x.ge.poly%xgon(jgon)) then
                 ! On edge
                 return  ! Inside
              endif
           endif
        else
           ! Polygon side is vertical
           if (poly%xgon(igon).lt.x) then  ! Cross the boundary
              index = index+1
           elseif (poly%xgon(igon).eq.x) then  ! On the boundary
              return  ! Inside
           endif
        endif
     endif
  enddo ! igon
  greg_poly_inside = mod(index,2).eq.1
end function greg_poly_inside
!
subroutine greg_poly2mask(blank,inside,poly,nx,ny,xconv,yconv,r2d)
  use greg_interfaces, except_this=>greg_poly2mask
  use greg_types
  !---------------------------------------------------------------------
  ! @ public
  ! Mask part of a 2D array using a given boundary
  !---------------------------------------------------------------------
  real(kind=4),         intent(in)    :: blank ! Blanking value
  logical,              intent(in)    :: inside
  type(polygon_t),      intent(in)    :: poly
  integer(kind=4),      intent(in)    :: nx
  integer(kind=4),      intent(in)    :: ny
  real(kind=8), target, intent(in)    :: xconv(3)
  real(kind=8), target, intent(in)    :: yconv(3)
  real(kind=4),         intent(inout) :: r2d(nx,ny)
  ! Local
  real(kind=8) :: x,y
  real(kind=8), pointer :: xval,xinc,xref
  real(kind=8), pointer :: yval,yinc,yref
  integer(kind=4) :: ix,ixmin,ixmax
  integer(kind=4) :: iy,iymin,iymax
  !
  ! Avoid exploring all the array by finding ixmin,ixmax,iymin,iymax
  xref => xconv(1)
  xval => xconv(2)
  xinc => xconv(3)
  yref => yconv(1)
  yval => yconv(2)
  yinc => yconv(3)
  if (xinc.gt.0.) then
    ixmin = max (1, int((poly%xgon1-xval)/xinc+xref) )
    ixmax = min (nx,int((poly%xgon2-xval)/xinc+xref)+1 )
  else
    ixmin = max (1, int((poly%xgon2-xval)/xinc+xref) )
    ixmax = min (nx,int((poly%xgon1-xval)/xinc+xref)+1 )
  endif
  if (yinc.gt.0.) then
    iymin = max (1, int((poly%ygon1-yval)/yinc+yref) )
    iymax = min (ny,int((poly%ygon2-yval)/yinc+yref)+1 )
  else
    iymin = max (1, int((poly%ygon2-yval)/yinc+yref) )
    iymax = min (ny,int((poly%ygon1-yval)/yinc+yref)+1 )
  endif
  !
  if (.not.inside) then
    ! Mask the outside
    do iy=1,ny
      do ix=1,nx
        if (ix.lt.ixmin) then
          r2d(ix,iy) = blank
        elseif (ix.gt.ixmax) then
          r2d(ix,iy) = blank
        elseif (iy.gt.iymax) then
          r2d(ix,iy) = blank
        elseif (iy.lt.iymin) then
          r2d(ix,iy) = blank
        else
          x = (ix-xref)*xinc+xval
          y = (iy-yref)*yinc+yval
          if (.not.greg_poly_inside(x,y,poly)) then
            r2d(ix,iy) = blank
          endif
        endif
      enddo ! ix
    enddo ! iy
  else
    ! Mask the inside
    do iy=iymin,iymax
      do ix=ixmin,ixmax
        x = (ix-xref)*xinc+xval
        y = (iy-yref)*yinc+yval
        if (greg_poly_inside(x,y,poly)) then
          r2d(ix,iy) = blank
        endif
      enddo ! ix
    enddo ! iy
  endif
end subroutine greg_poly2mask
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

program example_gildas
  use gildas_def
  use gkernel_interfaces
  ! Local
  integer(kind=4) :: i
  real(kind=8) :: a
  real(kind=4) :: array(4)
  character(len=40) :: chain
  character(len=filename_length) :: file,name
  !
  call gildas_open
  call gildas_inte('I$',i,1)
  call gildas_dble('A$',a,1)
  call gildas_char('CHAIN$',chain)
  call gildas_real('ARRAY$',array,4)
  call gildas_char('FILE$',file)
  call gildas_char('OLD$',name)
  call gildas_close
  !
  if (a.lt.0.0 .or. a.gt.1.0) then
    call gagout('F-EXAMPLE, A is out of bounds')
    goto 100
  endif
  !
  write(6,*) i
  write(6,*) a
  write(6,*) chain
  write(6,*) array
  write(6,*) trim(file)
  write(6,*) trim(name)
  !
  ! Success
  call gagout('I-GDF, Successful completion')
  call sysexi(1)
  !
100 continue
  call sysexi(fatale)
end program example_gildas

subroutine sic_load(lang,help,scom,ccom,version)
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_load
  use sic_dictionaries
  use sic_interactions
  use gbl_message
  use gildas_def
  !---------------------------------------------------------------------
  ! @ public (but private in the context of new language initialization)
  !       Initialise a SIC vocabulary
  ! Arguments :
  !       LANG    C*(*)   Language name
  !       HELP    C*(*)   Logical name for help file
  !       SCOM    I       Signed number of commands and options
  !                       Negative means library only mode
  !       CCOM    C*(*)   Vocabulary
  !       VERSION C*(*)   Character string indicating the version number
  !                       and other relevant information
  !	#1	S.Guilloteau 	1-SEP-1989
  !		No log file in library only mode
  !---------------------------------------------------------------------
  character(len=*) :: lang          !
  character(len=*) :: help          !
  integer :: scom                   !
  character(len=*) :: ccom(1)       !
  character(len=*) :: version       !
  ! Local
  character(len=*), parameter :: rname='SIC_LOAD'
  integer :: jcom,ierr,i,ll
  logical :: error
  !
  ! First initialisations
  jcom = abs(scom)
  if (.not.loaded) then
    call sic_message(seve%f,rname,'SIC is not loaded, call SIC_OPT before')
    call sysexi(fatale)
  endif
  !
  ! Check the dimensions and language name
  ierr=0
  ! Check number of commands/options limit
  if (jcom+mbuilt(nlang).gt.mvocab)    ierr=ierr+1
  ! Check length of input commands
  if (len(ccom(1)).gt.command_length)  ierr=ierr+2
  ! Check number of languages
  if (nlang.ge.mlang)                  ierr=ierr+4
  ! Check language length
  ll = len_trim(lang)
  if (ll.gt.language_length)           ierr=ierr+8
  ! Check duplicate language name
  do i=1,nlang
    ! Ideally, should check LANGUAGES(I)%NAME(1:LL).EQ.LANG
    if (languages(i)%name.eq.lang)     ierr=ierr+16
  enddo
  if (ierr.ne.0) call fatal(ierr,lang)
  !
  ! Setup the "User" command language
  do i=1,jcom
    vocab(mbuilt(nlang)+i) = ccom(i)
  enddo
  nopt(0)          = mbuilt(nlang)+jcom
  nlang            = nlang+1
  mbuilt(nlang)    = nopt(0)
  languages(nlang)%name  = lang
  languages(nlang)%lname = ll
  languages(nlang)%help  = help
  languages(nlang)%prio  = 0        ! Means unset, automatic
  languages(nlang)%user  = .false.  ! Not a user language
  languages(nlang)%usym  => null()  ! No user language dictionary
  !
  ! Setup the options pointer for faster analysis
  call sic_load_options
  !
  ! Setup the internal short HELP when not in library only mode
  if (scom.le.0) then
    languages(nlang)%libmod = .true.
  else
    languages(nlang)%libmod = .false.
  endif
  languages(nlang)%mess = version
  !
  ! Recompute the language priorities
  error = .false.
  call parse_priority_recompute(error)
  if (error)  return
  !
end subroutine sic_load
!
subroutine fatal(ierr,lang)
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>fatal
  use gildas_def
  use sic_dictionaries
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer :: ierr                   !
  character(len=*) :: lang          !
  ! Local
  character(len=*), parameter :: rname='SIC'
  character(len=filename_length) :: mess
  !
  if (mod(ierr,2).eq.1) then
    write (mess,101) 'Language '//trim(lang)//' reached internal limit of ',  &
    mvocab,' total commands and options'
    call sic_message(seve%f,rname,mess)
    write (mess,101) 'This language can only define ',mvocab-mbuilt(nlang),  &
    ' commands or options'
    call sic_message(seve%f,rname,mess)
    if (ierr.eq.1) goto 999
    ierr = ierr-1
  endif
  if (mod(ierr,4).eq.2) then
    write(mess,101) 'Commands must be at most character * ',command_length
    call sic_message(seve%f,rname,mess)
    if (ierr.eq.2) goto 999
    ierr = ierr-2
  endif
  if (mod(ierr,8).eq.4) then
    call sic_message(seve%f,rname,'Too many languages')
    if (ierr.eq.4) goto 999
    ierr = ierr-4
  endif
  if (mod(ierr,16).eq.8) then
    write(mess,101) 'Language must be at most character * ',language_length
    call sic_message(seve%f,rname,mess)
    if (ierr.eq.8) goto 999
    ierr = ierr-8
  endif
  if (mod(ierr,32).eq.16) then
    call sic_message(seve%f,rname,'Duplicate language name '//lang)
    if (ierr.eq.16) goto 999
    ierr = ierr-16
  endif
  write (mess,101) 'Initialisation error number ',ierr
  call sic_message(seve%f,rname,mess)
999 call sic_message(seve%f,rname,'Language initialisation failure')
  call sysexi(fatale)
  !
101 format(a,i5,a)
end subroutine fatal
!
subroutine sic_loadcom(help,ccom,ctra,jcom,error)
  use sic_interfaces
  use sic_dependencies_interfaces
  use sic_dictionaries
  use gbl_message
  !---------------------------------------------------------------------
  ! @ no-interface (because of Ifort 9.0)
  !  Add a (list of) command(s) into a user language. Assume USER\
  ! language if no language is provided, define it if required. All
  ! other languages must have been defined before with DEFINE LANGUAGE
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: help     ! Logical name for help file
  character(len=*), intent(in)    :: ccom(*)  ! Vocabulary
  character(len=*), intent(in)    :: ctra(*)  ! Translation
  integer,          intent(in)    :: jcom     ! Number of commands in vocabulary
  logical,          intent(inout) :: error    ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='DEFINE COMMAND'
  character(len=1), parameter :: backslash=char(92)
  character(len=language_length) :: lname,lnamef,langs(mlang)
  character(len=32) :: cname
  logical :: found
  integer :: i,j,kcom,icom,islash,jlang
  !
  ! 0) FixMe! Handle correctly jcom>1 !!!
  !    Input 'ccom' must be scalar in particular because of language
  !    resolution ('lnamef')
  if (jcom.gt.1) then
    call sic_message(seve%e,rname,  &
      'Internal error, not implemented for more than 1 command')
    error = .true.
    return
  endif
  !
  ! 1) Check if a language is provided
  islash = index(ccom(1),backslash)
  if (islash.eq.0) then
    lname = 'USER'
    if (.not. any(languages(1:nlang)%name.eq.lname)) then
      ! USER\ language does not exist yet
      call sic_define_language(lname,' ',error)
      if (error)  return
    endif
  else
    lname = ccom(1)(1:islash-1)
    call sic_upper(lname)
  endif
  !
  ! 2) Check if it is a known language
  langs(1:nlang) = languages(1:nlang)%name
  call sic_ambigs(rname,lname,lnamef,jlang,langs,nlang,error)
  if (error)  return
  if (.not.languages(jlang)%user) then
    ! This is not a user language
    call sic_message(seve%e,rname,  &
      trim(lnamef)//'\ is not a user language, can not append')
    error = .true.
    return
  endif
  !
  ! 3) Update the user command language
  !
  ! Check the dimensions and language name
  if (mbuilt(nlang)+jcom.gt.mvocab) then
    call sic_message(seve%e,rname,'Too many commands')
    error = .true.
    return
  endif
  !
  ! Check duplicate names
  icom = 0
  do i=1,jcom
    found = .false.
    !
    islash = index(ccom(i),backslash)
    if (islash.gt.0) then
      cname = " "//ccom(i)(islash+1:)
    else
      cname = " "//ccom(i)
    endif
    !
    if (len_trim(cname).gt.command_length) then
      call sic_message(seve%e,rname,'Command name '//trim(cname)//' too long')
      error = .true.
      return
    endif
    !
    do j=mbuilt(jlang-1)+1,mbuilt(jlang)
      if (vocab(j).eq.cname) then
        found = .true.
        exit  ! Loop
      endif
    enddo
    if (.not.found) icom = icom+1
  enddo
  !
  ! Push all commands after USER ones
  do i=mbuilt(nlang),mbuilt(jlang)+1,-1
    vocab(i+icom) = vocab(i)
  enddo
  !
  ! Update pointers after USER ones
  nopt(0) = mbuilt(nlang)+icom  ! Total number of commands and options
  do i=jlang+1,nlang
    mbuilt(i) = mbuilt(i)+icom  ! Index of the last command of the language
  enddo
  !
  ! Insert/replace USER\ commands
  do i=1,jcom
    found = .false.
    !
    islash = index (ccom(i),backslash) ! Locate the 
    !
    if (islash.gt.0) then
      cname = " "//ccom(i)(islash+1:)
    else
      cname = " "//ccom(i)
    endif
    !
    do j=mbuilt(jlang-1)+1,mbuilt(jlang)
      if (vocab(j).eq.cname) then
        call sic_message(seve%w,rname,'Overwriting '//trim(lnamef)//'\ command '//cname)
        kcom = j
        found = .true.
      endif
    enddo
    if (.not.found) then
      mbuilt(jlang)        = mbuilt(jlang)+1
      vocab(mbuilt(jlang)) = cname
      kcom                 = mbuilt(jlang)
    endif
    !
    ! Set the command help file. If not defined, use the language help file.
    if (help.ne.' ') then
      help_text(kcom) = help
    else
      help_text(kcom) = languages(jlang)%help
    endif
    !
    ! Save the translation into the appropriate user language
    call sic_symdict_set(languages(jlang)%usym,cname(2:),ctra(i),error)
    if (error)  return
  enddo
  !
  ! (Re)set the options pointers for faster analysis
  call sic_load_options
  !
end subroutine sic_loadcom
!
subroutine sic_define_language(name,help,error)
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_define_language
  use sic_dictionaries
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! Define a new user language
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: name   ! Language name
  character(len=*), intent(in)    :: help   ! Help file
  logical,          intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='DEFINE LANGUAGE'
  integer :: lname,jlang,ier
  character(len=language_length) :: locname
  character(len=message_length) :: mess
  character(len=1), parameter :: backslash=char(92)
  !
  lname = len_trim(name)
  if (name(lname:lname).eq.backslash)  lname = lname-1
  !
  if (lname.gt.language_length) then
    write(mess,'(A,I2,A)')  &
      'Language name too long (max. ',language_length,' char.)'
    call sic_message(seve%e,rname,mess)
    error = .true.
    return
  endif
  !
  ! Setup the new user language
  if (nlang.ge.mlang) then
    call sic_message(seve%e,rname,'Too many languages')
    error = .true.
    return
  endif
  !
  locname = name(1:lname)
  call sic_upper(locname)
  !
  ! Protect against duplicate language name
  do jlang=1,nlang
    if (locname.eq.languages(jlang)%name) then
      call sic_message(seve%e,rname,"Duplicate language "//locname)
      error = .true.
      return
    endif
  enddo
  !
  nlang                  = nlang+1            ! Language index = total number of languages
  mbuilt(nlang)          = nopt(0)            ! Index of the last command of the language
  languages(nlang)%name  = locname            ! Language name
  languages(nlang)%lname = len_trim(locname)  ! Language length
  languages(nlang)%mess  = ' '                ! Short description
  languages(nlang)%help  = help               ! Help file
  languages(nlang)%prio  = 0                  ! Language priority set as automatic
  languages(nlang)%user  = .true.             ! It is a user language
  !
  ! Prepare its own dictionary of commands:
  allocate(languages(nlang)%usym,stat=ier)
  if (failed_allocate(rname,'dictionary',ier,error))  return
  call sic_symdict_init(languages(nlang)%usym,mucom,error)
  if (error)  return
  !
  ! Recompute the language priorities
  call parse_priority_recompute(error)
  if (error)  return
  !
  call sic_message(seve%d,rname,trim(locname)//'\ user language created')
  !
end subroutine sic_define_language
!
subroutine sic_load_options
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_load_options
  use sic_dictionaries
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! Setup or setup again the options pointer for faster analysis
  !---------------------------------------------------------------------
  ! Local
  character(len=*), parameter :: rname='SIC_LOAD'
  integer :: icom,k,jlang
  character(len=message_length) :: mess
  !
  hasopt(0) = 1  ! i.e. not 0 nor -1
  k = 0 ! Avoid initialization warning
  do icom=1,nopt(0)
    hasopt(icom) = 0
    if (vocab(icom)(1:1).ne.'/') then
      ! Found a new command
      k=icom
      !
      if (vocab(icom)(1:1).eq.'-')  then
        ! Command is declared with a leading "-": no options allowed at
        ! declaration time, but then any option at run time will be
        ! ignored (for e.g. HELP FOO /BAR)
        hasopt(k) = -1
      endif
      !
      jlang = 1
      do
        if (icom.le.mbuilt(jlang)) then
          ! Command is in language 'jlang'
          if (languages(jlang)%user) then
            ! 'jlang' is a user language. We can not forbid options for
            ! this command since the underlying command is unknown and can
            ! accept options.
            hasopt(k) = -1
          endif
          exit ! Loop
        endif
        jlang = jlang+1
      enddo
      !
      nopt(k)=0
    else
      ! Found an option of the current command
      if (hasopt(k).eq.-1) then
        mess = 'Command '//trim(vocab(icom)(2:))//' does not accept options'
        call sic_message(seve%f,rname,mess)
        call sysexi(fatale)
      endif
      hasopt(k) = +1
      nopt(k) = nopt(k)+1
    endif
  enddo
  !
end subroutine sic_load_options
!
subroutine sic_free_languages(error)
  use sic_interfaces, except_this=>sic_free_languages
  use sic_dictionaries
  !---------------------------------------------------------------------
  ! @ private
  ! Free the Sic languages
  !---------------------------------------------------------------------
  logical, intent(inout) :: error  !
  ! Local
  integer(kind=4) :: i,ier
  !
  do i=1,nlang
    if (languages(i)%user) then
      if (associated(languages(i)%usym)) then
        call sic_symdict_free(languages(i)%usym,error)
        ! if (error) continue
        deallocate(languages(i)%usym,stat=ier)
        if (ier.ne.0)  error=.true.
        ! if (error) continue
      endif
    endif
  enddo
  !
end subroutine sic_free_languages

program circle
  use gildas_def
  use image_def
  use gkernel_interfaces
  use gbl_format
  use gbl_message
  !---------------------------------------------------------------------
  ! GILDAS
  !  Make a circular average, to obtain a radial profile.
  !---------------------------------------------------------------------
  character(len=*), parameter :: pname = 'CIRCLE'
  ! Local
  character(len=filename_length) :: namex,namey
  logical :: error
  real(kind=4) :: center(2)
  integer(kind=4) :: i, j, n, npro, ier
  integer(kind=4), allocatable :: lena(:)
  real(kind=4), allocatable :: sum1(:),xcoor(:)
  type(gildas) :: x,y
  real(kind=8) :: yconv(6),xconv(3),azrange(2)
  integer :: ixaxis, ioff
  !
  call gildas_open
  call gildas_char('Y_NAME$',namey)
  call gildas_char('X_NAME$',namex)
  call gildas_real('CENTER$',center,2)
  call gildas_inte('PROFILE$',npro,1)
  call gildas_dble('AZIMUT$',azrange,2)
  call gildas_inte('X_AXIS$',ixaxis,1)
  call gildas_close
  !
  n = len_trim(namey)
  if (n.eq.0) goto 100
  n = len_trim(namex)
  if (n.eq.0) goto 100
  !
  if (ixaxis.eq.0) then
    ioff = 0
  else
    ioff = 1
  endif
  !
  call gildas_null(y)
  call gdf_read_gildas(y,namey,'.gdf',error,data=.false.)
  if (error) then
    call gag_message(seve%f,pname,'Cannot read input file '//trim(namey))
    goto 100
  endif
  if (abs(y%gil%inc(1)).ne.abs(y%gil%inc(2))) then
    call gag_message(seve%f,pname,'Can only work with equally sampled directions')
    goto 100
  endif
  !
  call gildas_null(x)
  call gdf_copy_header(y,x,error)
  x%gil%dim(1) = npro
  x%gil%dim(2) = y%gil%dim(3) + ioff
  x%gil%dim(3) = y%gil%dim(4)
  x%gil%inc(1) = abs(y%gil%inc(1))
  x%gil%convert(1,1) = 1.d0
  x%gil%convert(2,1) = 0.d0
  x%gil%convert(:,2) = y%gil%convert(:,3)
  x%gil%ref(2) = x%gil%ref(2) + ioff
  x%gil%convert(:,3) = x%gil%convert(:,4)
  yconv(1:3) = y%gil%convert(:,1)
  yconv(4:6) = y%gil%convert(:,2)
  xconv(1:3) = x%gil%convert(:,1)
  x%gil%dim(4) = 1
  x%char%code(1) = 'Radius'
  x%char%code(2) = y%char%code(3)
  x%char%code(3) = y%char%code(4)
  x%char%code(4) = ' '
  !
  call sic_parsef(namex,x%file,' ','.gdf')
  call gdf_create_image(x,error)
  !
  allocate (lena(npro),sum1(npro),stat=ier)
  if (ier.ne.0) goto 99
  allocate (y%r2d(y%gil%dim(1),y%gil%dim(2)),stat=ier)
  if (ier.ne.0) goto 99
  allocate (x%r2d(x%gil%dim(1),x%gil%dim(2)),stat=ier)
  if (ier.ne.0) goto 99
  !
  if (ioff.eq.1) then
    allocate(xcoor(x%gil%dim(1)),stat=ier)
    do i=1,x%gil%dim(1)
      xcoor(i) = (i-x%gil%ref(1))*x%gil%inc(1) + x%gil%val(1)
    enddo
  endif
  !
  ! Loop on input planes
  do j=1,y%gil%dim(4)
    x%blc(4) = 0
    x%trc(4) = 0
    x%blc(3) = j
    x%trc(3) = j
    x%r2d(:,:) = 0.
    do i=1,y%gil%dim(3)
      y%blc(4) = j
      y%trc(4) = j
      y%blc(3) = i
      y%trc(3) = i
      call gdf_read_data(y,y%r2d,error)
      if (error) goto 100
      !
      call radial(y%r2d,y%gil%dim(1),y%gil%dim(2),yconv,center,  &
                  x%r2d(:,i+ioff),x%gil%dim(1),xconv,         &
                  lena,sum1,x%gil%bval,x%gil%eval,azrange)
      if (ioff.eq.1) x%r2d(:,1) = xcoor(:)
    enddo
    call gdf_write_data(x,x%r2d,error)
  enddo
  !
  call gag_message(seve%i,pname,'Successful completion')
  call sysexi(1)  ! Success
  !
99 call gag_message(seve%f,pname,'Allocation error')
100 call sysexi (fatale)
end program circle
!
subroutine radial(y,nx,ny,yconv,center,p,np,xconv,nd,sd,bad,ebad,azrange)
  use gildas_def
  !---------------------------------------------------------------------
  !
  !---------------------------------------------------------------------
  integer(kind=index_length), intent(in)  :: nx,ny      ! Dimensions of input array
  real(kind=4),               intent(in)  :: y(nx,ny)   ! Input array
  real(kind=8),               intent(in)  :: yconv(6)   ! Conversion formula for input array
  real(kind=4),               intent(in)  :: center(2)  ! Center of circle
  integer(kind=index_length), intent(in)  :: np         ! Number of points in radial profile
  real(kind=4),               intent(out) :: p(np)      ! Output radial profile
  real(kind=8),               intent(in)  :: xconv(3)   ! Conversion formula for radial profile
  integer(kind=4),            intent(out) :: nd(np)     ! Work space
  real(kind=4),               intent(out) :: sd(np)     ! Work space
  real(kind=4),               intent(in)  :: bad        ! Blanking value
  real(kind=4),               intent(in)  :: ebad       ! Tolerance on blanking value
  real(kind=8),               intent(in)  :: azrange(2) ! Azimut range
  ! Local
  real(kind=8) :: xcent,ycent
  real(kind=8) :: xref,xval,xinc,yref,yval,yinc, pref,pval,pinc
  integer(kind=index_length) :: i,j,ip
  real(kind=8) :: dist,rp,xx,yy,pa,pi
  !
  pi = acos(-1.d0)
  xcent = center(1)
  ycent = center(2)
  xref = yconv(1)
  xval = yconv(2)
  xinc = yconv(3)
  yref = yconv(4)
  yval = yconv(5)
  yinc = yconv(6)
  pref = xconv(1)
  pval = xconv(2)
  pinc = xconv(3)
  !
  ! Clears work space
  do i=1,np
    sd(i) = 0.0
    nd(i) = 0
  enddo
  !
  ! Loop on pixels of input plane
  if (any(azrange.ne.0.d0)) then
    do j = 1,ny
      do i = 1,nx
        ! Ignore blanked pixels
        if ( abs(y(i,j)-bad).gt.ebad) then
          xx = (i-xref)*xinc+xval - xcent
          yy = (j-yref)*yinc+yval - ycent
          pa = atan2(yy,xx)
          if (pa.lt.0d0) pa = pa+2.d0*pi
          if (pa.ge.azrange(1) .and. pa.le.azrange(2)) then
            dist = (xx**2+yy**2)              
            rp   = (sqrt(dist)-pval)/pinc + pref
            ip   = int(rp)
            if (ip.le.np) then
              sd(ip) = sd(ip) + y(i,j)
              nd(ip) = nd(ip) + 1
            endif
          endif
        endif
      enddo
    enddo
  else
    do j = 1,ny
      do i = 1,nx
        ! Ignore blanked pixels
        if ( abs(y(i,j)-bad).gt.ebad) then
          dist = ((i-xref)*xinc+xval - xcent)**2 +  &
                 ((j-yref)*yinc+yval - ycent)**2
          rp   = (sqrt(dist)-pval)/pinc + pref
          ip   = int(rp)
          if (ip.le.np) then
            sd(ip) = sd(ip) + y(i,j)
            nd(ip) = nd(ip) + 1
          endif
        endif
      enddo
    enddo
  endif
  !
  ! Normalise the profile
  do i=1,np
    if (nd(i).gt.0) then
      p(i) = sd(i)/nd(i)
    else
      p(i) = bad
    endif
  enddo
end subroutine radial

subroutine write_all(fd,map,nsize,nfill,bval,eval,error)
  use gildas_def
  use gfits_interfaces
  use gfits_buf
  use gfits_types
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !---------------------------------------------------------------------
  type(gfits_hdesc_t),       intent(in)    :: fd          !
  integer(kind=size_length), intent(in)    :: nsize       ! Data size
  real(kind=4),              intent(in)    :: map(nsize)  ! Data array
  integer(kind=size_length), intent(out)   :: nfill       ! Number of written items
  real(kind=4),              intent(in)    :: bval        ! Blanking value
  real(kind=4),              intent(in)    :: eval        ! Blanking tolerance
  logical,                   intent(inout) :: error       ! Error flag
  !
  nfill = 0
  do while (nfill.lt.nsize)
    if (fd%snbit.eq.16) then
      call real_to_int2(buffer,1440,map,nsize,nfill,fd%bscal,fd%bzero,bval,eval)
    elseif (fd%snbit.eq.32) then
      call real_to_int4(buffer,720,map,nsize,nfill,fd%bscal,fd%bzero,bval,eval)
    elseif (fd%snbit.eq.-32) then
      call real_to_real4(buffer,720,map,nsize,nfill,bval,eval)
    endif
    call gfits_putbuf(buffer,2880,error)
    if (error) return
  enddo
end subroutine write_all

function lever(d,d0)
  !---------------------------------------------------------------------
  ! @ private
  !	Lever d'une etoile de declinaison D a latitude D0
  !
  !	PI/2-D0 < D	Circumpolaire
  !	D0-PI/2 < D < PI/2-D0	H = ACOS (TAN(D)/TAN(D0-PI/2))
  !	D < D0-PI/2	Toujours couchee...
  !
  ! Formule applicable a la partie visible du ciel en projection
  ! sur un plan
  !---------------------------------------------------------------------
  real*8 :: lever                   !
  real*8 :: d                       !
  real*8 :: d0                      !
  ! Global
  include 'gbl_pi.inc'
  ! Local
  real*8 :: dd,d1,d2
  real*8, parameter :: precision=1.0d-10
  !
  if (d0.lt.0.d0) then
    d2 = -d
    d1 = -d0
  else
    d2 = d
    d1 = d0
  endif
  dd = d1-pi*0.5d0
  if (d2.gt.-dd+precision) then
    lever = 2.d0*pi
  elseif (d2.lt.dd) then
    lever = -pi
  elseif (abs(d2+dd).le.precision) then
    lever = pi
  else
    lever = acos (tan(d2)/tan(dd))
  endif
end function lever

!
subroutine beam_unit_conversion(amethod)
  use clean_def
  use clean_default
  !----------------------------------------------------------------------
  ! @ private
  !
  ! IMAGER
  !   Major and Minor axes of beam are in seconds but the method structure
  !   assumes that its major and minor fields are in radian. So we need
  !   a conversion...
  !----------------------------------------------------------------------
  type (clean_par) :: amethod
  !
  real(kind=8), parameter :: pi=3.14159265358979323846d0
  real(kind=4), parameter :: sec_to_rad=pi/3600.0/180.0
  !
  amethod%major = beam_size(1)*sec_to_rad
  amethod%minor = beam_size(2)*sec_to_rad
  amethod%angle = beam_size(3)
  !
end subroutine beam_unit_conversion
!
subroutine copy_method(in,out)
  use clean_def
  !----------------------------------------------------------------------
  ! @ private
  !
  ! IMAGER
  !   Copy method
  !----------------------------------------------------------------------
  type (clean_par), intent(in) ::  in
  type (clean_par), intent(inout) ::  out
  !
  out%method = in%method
  out%verbose = in%verbose
  !
  out%gain = in%gain
  out%fres = in%fres
  out%ares = in%ares
  out%major = in%major
  out%minor = in%minor
  out%angle = in%angle
  out%ratio = in%ratio         ! MRC ratio
  out%spexp = in%spexp         ! Clark speed
  out%phat = in%phat           ! Prussian Hat
  out%smooth = in%smooth       ! Multi smooth
  out%converge = in%converge   ! Convergence
  out%mosaic = in%mosaic       ! Mosaic mode
  out%search = in%search       ! Mosaic search
  out%restor = in%restor       ! Mosaic restore
  out%trunca = in%trunca       ! Mosaic beam truncation
  out%m_iter = in%m_iter
  out%p_iter = in%p_iter
  out%ngoal = in%ngoal
  out%n_major = in%n_major
  out%nker = in%nker           ! Multiscale Kernel
  out%ninflate = in%ninflate   ! and inflation factor
  out%blc = in%blc
  out%trc = in%trc
  out%patch = in%patch
  out%do_mask = in%do_mask
  out%residual = in%residual   ! Add residual or not
  out%worry = in%worry         ! Worry convergence factor
  out%thresh = in%thresh       ! Sidelobe level for FIT
  out%gains = in%gains
  !
  out%nscale = in%nscale
  out%gsize = in%gsize
  ! 
  ! Pointer issue
  out%atten => in%atten
  ! Consequences
  !     box, beam0, bzone, n_iter, bshift, beam_min, beam_max, bgain, flux
  ! Variables
  !     Major, Minor, Angle
  ! Temporary
  !     Pflux, Pcycle, Qcycle, Pmrc, Pclean,
  ! Return
  !     Do_beam, Do_mask
end subroutine copy_method
!
subroutine copy_param(in,out)
  !--------------------------------------------------------------------
  ! @ private
  !
  ! IMAGER
  !   Copy only the parameters of the method, not the pointers to the
  !   work arrays
  !   Do not copy the Loop Gain, which is Method specific
  !--------------------------------------------------------------------
  use clean_def
  type (clean_par), intent(in) ::  in
  type (clean_par), intent(inout) ::  out
  !
  real :: gain
  ! 
  gain = out%gain
  call copy_method(in,out)
  out%gain = gain
end subroutine copy_param
!
subroutine mapping_print_debug(m)
  ! @ private
  use clean_def
  type (clean_par) :: m
  !
  write(*,*) m%gain, m%fres, m%ares,' Loop gain, Fres, Ares'
  write(*,*) m%major, m%minor, m%angle,' Major/Minor/Angle axis'
  write(*,*) m%beam_min, m%beam_max, m%bgain,   &
       &    ' Beam Min/Max Sidelobe'
  write(*,*) m%ratio, m%spexp, m%phat, m%smooth,   &
       &    ' MRC ratio, Speed, Phat, Multi ratio'
  write(*,*) m%flux, m%converge,' Cleaned Flux, Convergence number'
  write(*,*) m%search, m%restor, m%trunca,   &
       &    ' Threshold Search/Restore/Truncate'
  write(*,*) m%blc, m%trc,' BLC, TRC '
  write(*,*) m%box    ,' Cleaning Box'
  write(*,*) m%beam0, m%patch,' Beam center X,Y, Patch size'
  write(*,*) m%bzone  ,' Beam patch Zone'
  write(*,*) m%m_iter, m%p_iter, m%n_iter,   &
       &    ' Iterations Max/Pos/Actual'
  write(*,*) m%ngoal, m%n_major,' Max select, Max cycle'
  write(*,*) m%bshift ,' Beam shift'
  write(*,*) m%nker   ,' Kernel for Multi-Scale clean'
  write(*,*) 'Mos. Flux, Cycle, Query, Mrc, Clean, Beam/Mask'
  write(*,*) m%mosaic, m%pflux,m%pcycle ,m%qcycle,m%pmrc,m%pclean,   &
       &    m%do_mask
  write(*,*) m%first,m%last,m%iplane,m%ibeam,m%nlist,   &
       &    ' First/Last/Current  Beam List'
  write(*,*) m%method    ,' METHOD'
  write(*,*) m%worry     , 'WORRY'
end subroutine mapping_print_debug

*DECK DPLPMU
      SUBROUTINE DPLPMU (MRELAS, NVARS, LMX, LBM, NREDC, INFO, IENTER,
     +   ILEAVE, IOPT, NPP, JSTRT, IBASIS, IMAT, IBRC, IPR, IWR, IND,
     +   IBB, ANORM, EPS, UU, GG, RPRNRM, ERDNRM, DULNRM, THETA, COSTSC,
     +   XLAMDA, RHSNRM, AMAT, BASMAT, CSC, WR, RPRIM, WW, BU, BL, RHS,
     +   ERD, ERP, RZ, RG, COLNRM, COSTS, PRIMAL, DUALS, SINGLR, REDBAS,
     +   ZEROLV, STPEDG)
C***BEGIN PROLOGUE  DPLPMU
C***SUBSIDIARY
C***PURPOSE  Subsidiary to DSPLP
C***LIBRARY   SLATEC
C***TYPE      DOUBLE PRECISION (SPLPMU-S, DPLPMU-D)
C***AUTHOR  (UNKNOWN)
C***DESCRIPTION
C
C     THE EDITING REQUIRED TO CONVERT THIS SUBROUTINE FROM SINGLE TO
C     DOUBLE PRECISION INVOLVES THE FOLLOWING CHARACTER STRING CHANGES.
C
C     USE AN EDITING COMMAND (CHANGE) /STRING-1/(TO)STRING-2/.
C     /REAL (12 BLANKS)/DOUBLE PRECISION/,
C     /SASUM/DASUM/,/SCOPY/DCOPY/,/SDOT/DDOT/,
C     /.E0/.D0/
C
C     THIS SUBPROGRAM IS FROM THE DSPLP( ) PACKAGE.  IT PERFORMS THE
C     TASKS OF UPDATING THE PRIMAL SOLUTION, EDGE WEIGHTS, REDUCED
C     COSTS, AND MATRIX DECOMPOSITION.
C     IT IS THE MAIN PART OF THE PROCEDURE (MAKE MOVE AND UPDATE).
C
C     REVISED 821122-1100
C     REVISED YYMMDD
C
C***SEE ALSO  DSPLP
C***ROUTINES CALLED  DASUM, DCOPY, DDOT, DPLPDM, DPNNZR, DPRWPG, IDLOC,
C                    LA05BD, LA05CD, XERMSG
C***REVISION HISTORY  (YYMMDD)
C   811215  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890605  Removed unreferenced labels.  (WRB)
C   890606  Changed references from IPLOC to IDLOC.  (WRB)
C   890606  Removed unused COMMON block LA05DD.  (WRB)
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900315  CALLs to XERROR changed to CALLs to XERMSG.  (THJ)
C   900328  Added TYPE section.  (WRB)
C***END PROLOGUE  DPLPMU
      INTEGER IBASIS(*),IMAT(*),IBRC(LBM,2),IPR(*),IWR(*),IND(*),IBB(*)
      DOUBLE PRECISION AIJ,ALPHA,ANORM,COSTSC,ERDNRM,DULNRM,EPS,GAMMA,
     * GG,GQ,ONE,RPRNRM,RZJ,SCALR,THETA,TWO,UU,WP,XLAMDA,RHSNRM,
     * ZERO,AMAT(*),BASMAT(*),CSC(*),WR(*),RPRIM(*),WW(*),BU(*),BL(*),
     * RHS(*),ERD(*),ERP(*),RZ(*),RG(*),COSTS(*),PRIMAL(*),DUALS(*),
     * COLNRM(*),RCOST,DASUM,DDOT,CNORM
      LOGICAL SINGLR,REDBAS,PAGEPL,TRANS,ZEROLV,STPEDG
C
C***FIRST EXECUTABLE STATEMENT  DPLPMU
      ZERO=0.D0
      ONE=1.D0
      TWO=2.D0
      LPG=LMX-(NVARS+4)
C
C     UPDATE THE PRIMAL SOLUTION WITH A MULTIPLE OF THE SEARCH
C     DIRECTION.
      I=1
      N20002=MRELAS
      GO TO 20003
20002 I=I+1
20003 IF ((N20002-I).LT.0) GO TO 20004
      RPRIM(I)=RPRIM(I)-THETA*WW(I)
      GO TO 20002
C
C     IF EJECTED VARIABLE IS LEAVING AT AN UPPER BOUND,  THEN
C     TRANSLATE RIGHT HAND SIDE.
20004 IF (.NOT.(ILEAVE.LT.0)) GO TO 20006
      IBAS=IBASIS(ABS(ILEAVE))
      SCALR=RPRIM(ABS(ILEAVE))
      ASSIGN 20009 TO NPR001
      GO TO 30001
20009 IBB(IBAS)=ABS(IBB(IBAS))+1
C
C     IF ENTERING VARIABLE IS RESTRICTED TO ITS UPPER BOUND, TRANSLATE
C     RIGHT HAND SIDE.  IF THE VARIABLE DECREASED FROM ITS UPPER
C     BOUND, A SIGN CHANGE IS REQUIRED IN THE TRANSLATION.
20006 IF (.NOT.(IENTER.EQ.ILEAVE)) GO TO 20010
      IBAS=IBASIS(IENTER)
      SCALR=THETA
      IF (MOD(IBB(IBAS),2).EQ.0) SCALR=-SCALR
      ASSIGN 20013 TO NPR001
      GO TO 30001
20013 IBB(IBAS)=IBB(IBAS)+1
      GO TO 20011
20010 IBAS=IBASIS(IENTER)
C
C     IF ENTERING VARIABLE IS DECREASING FROM ITS UPPER BOUND,
C     COMPLEMENT ITS PRIMAL VALUE.
      IF (.NOT.(IND(IBAS).EQ.3.AND.MOD(IBB(IBAS),2).EQ.0)) GO TO 20014
      SCALR=-(BU(IBAS)-BL(IBAS))
      IF (IBAS.LE.NVARS) SCALR=SCALR/CSC(IBAS)
      ASSIGN 20017 TO NPR001
      GO TO 30001
20017 THETA=-SCALR-THETA
      IBB(IBAS)=IBB(IBAS)+1
20014 CONTINUE
      RPRIM(ABS(ILEAVE))=THETA
      IBB(IBAS)=-ABS(IBB(IBAS))
      I=IBASIS(ABS(ILEAVE))
      IBB(I)=ABS(IBB(I))
      IF(PRIMAL(ABS(ILEAVE)+NVARS).GT.ZERO) IBB(I)=IBB(I)+1
C
C     INTERCHANGE COLUMN POINTERS TO NOTE EXCHANGE OF COLUMNS.
20011 IBAS=IBASIS(IENTER)
      IBASIS(IENTER)=IBASIS(ABS(ILEAVE))
      IBASIS(ABS(ILEAVE))=IBAS
C
C     IF VARIABLE WAS EXCHANGED AT A ZERO LEVEL, MARK IT SO THAT
C     IT CAN'T BE BROUGHT BACK IN.  THIS IS TO HELP PREVENT CYCLING.
      IF(ZEROLV) IBASIS(IENTER)=-ABS(IBASIS(IENTER))
      RPRNRM=MAX(RPRNRM,DASUM(MRELAS,RPRIM,1))
      K=1
      N20018=MRELAS
      GO TO 20019
20018 K=K+1
20019 IF ((N20018-K).LT.0) GO TO 20020
C
C     SEE IF VARIABLES THAT WERE CLASSIFIED AS INFEASIBLE HAVE NOW
C     BECOME FEASIBLE.  THIS MAY REQUIRED TRANSLATING UPPER BOUNDED
C     VARIABLES.
      IF (.NOT.(PRIMAL(K+NVARS).NE.ZERO .AND.
     *          ABS(RPRIM(K)).LE.RPRNRM*ERP(K))) GO TO 20022
      IF (.NOT.(PRIMAL(K+NVARS).GT.ZERO)) GO TO 20025
      IBAS=IBASIS(K)
      SCALR=-(BU(IBAS)-BL(IBAS))
      IF(IBAS.LE.NVARS)SCALR=SCALR/CSC(IBAS)
      ASSIGN 20028 TO NPR001
      GO TO 30001
20028 RPRIM(K)=-SCALR
      RPRNRM=RPRNRM-SCALR
20025 PRIMAL(K+NVARS)=ZERO
20022 CONTINUE
      GO TO 20018
C
C     UPDATE REDUCED COSTS, EDGE WEIGHTS, AND MATRIX DECOMPOSITION.
20020 IF (.NOT.(IENTER.NE.ILEAVE)) GO TO 20029
C
C     THE INCOMING VARIABLE IS ALWAYS CLASSIFIED AS FEASIBLE.
      PRIMAL(ABS(ILEAVE)+NVARS)=ZERO
C
      WP=WW(ABS(ILEAVE))
      GQ=DDOT(MRELAS,WW,1,WW,1)+ONE
C
C     COMPUTE INVERSE (TRANSPOSE) TIMES SEARCH DIRECTION.
      TRANS=.TRUE.
      CALL LA05BD(BASMAT,IBRC,LBM,MRELAS,IPR,IWR,WR,GG,WW,TRANS)
C
C     UPDATE THE MATRIX DECOMPOSITION.  COL. ABS(ILEAVE) IS LEAVING.
C     THE ARRAY DUALS(*) CONTAINS INTERMEDIATE RESULTS FOR THE
C     INCOMING COLUMN.
      CALL LA05CD(BASMAT,IBRC,LBM,MRELAS,IPR,IWR,DUALS,GG,UU,
     * ABS(ILEAVE))
      REDBAS=.FALSE.
      IF (.NOT.(GG.LT.ZERO)) GO TO 20032
C
C     REDECOMPOSE BASIS MATRIX WHEN AN ERROR RETURN FROM
C     LA05CD( ) IS NOTED.  THIS WILL PROBABLY BE DUE TO
C     SPACE BEING EXHAUSTED, GG=-7.
      CALL DPLPDM(
     *MRELAS,NVARS,LMX,LBM,NREDC,INFO,IOPT,
     *IBASIS,IMAT,IBRC,IPR,IWR,IND,IBB,
     *ANORM,EPS,UU,GG,
     *AMAT,BASMAT,CSC,WR,
     *SINGLR,REDBAS)
      IF (.NOT.(SINGLR)) GO TO 20035
      NERR=26
      CALL XERMSG ('SLATEC', 'DPLPMU',
     +   'IN DSPLP, MOVED TO A SINGULAR POINT. THIS SHOULD NOT HAPPEN.',
     +   NERR, IOPT)
      INFO=-NERR
      RETURN
20035 CONTINUE
      GO TO 30002
20038 CONTINUE
20032 CONTINUE
C
C     IF STEEPEST EDGE PRICING IS USED, UPDATE REDUCED COSTS
C     AND EDGE WEIGHTS.
      IF (.NOT.(STPEDG)) GO TO 20039
C
C     COMPUTE COL. ABS(ILEAVE) OF THE NEW INVERSE (TRANSPOSE) MATRIX
C     HERE ABS(ILEAVE) POINTS TO THE EJECTED COLUMN.
C     USE ERD(*) FOR TEMP. STORAGE.
      CALL DCOPY(MRELAS,ZERO,0,ERD,1)
      ERD(ABS(ILEAVE))=ONE
      TRANS=.TRUE.
      CALL LA05BD(BASMAT,IBRC,LBM,MRELAS,IPR,IWR,WR,GG,ERD,TRANS)
C
C     COMPUTE UPDATED DUAL VARIABLES IN DUALS(*).
      ASSIGN 20042 TO NPR003
      GO TO 30003
C
C     COMPUTE THE DOT PRODUCT OF COL. J OF THE NEW INVERSE (TRANSPOSE)
C     WITH EACH NON-BASIC COLUMN.  ALSO COMPUTE THE DOT PRODUCT OF THE
C     INVERSE (TRANSPOSE) OF NON-UPDATED MATRIX (TIMES) THE
C     SEARCH DIRECTION WITH EACH NON-BASIC COLUMN.
C     RECOMPUTE REDUCED COSTS.
20042 PAGEPL=.TRUE.
      CALL DCOPY(NVARS+MRELAS,ZERO,0,RZ,1)
      NNEGRC=0
      J=JSTRT
20043 IF (.NOT.(IBB(J).LE.0)) GO TO 20045
      PAGEPL=.TRUE.
      RG(J)=ONE
      GO TO 20046
C
C     NONBASIC INDEPENDENT VARIABLES (COLUMN IN SPARSE MATRIX STORAGE)
20045 IF (.NOT.(J.LE.NVARS)) GO TO 20048
      RZJ=COSTS(J)*COSTSC
      ALPHA=ZERO
      GAMMA=ZERO
C
C     COMPUTE THE DOT PRODUCT OF THE SPARSE MATRIX NONBASIC COLUMNS
C     WITH THREE VECTORS INVOLVED IN THE UPDATING STEP.
      IF (.NOT.(J.EQ.1)) GO TO 20051
      ILOW=NVARS+5
      GO TO 20052
20051 ILOW=IMAT(J+3)+1
20052 IF (.NOT.(PAGEPL)) GO TO 20054
      IL1=IDLOC(ILOW,AMAT,IMAT)
      IF (.NOT.(IL1.GE.LMX-1)) GO TO 20057
      ILOW=ILOW+2
      IL1=IDLOC(ILOW,AMAT,IMAT)
20057 CONTINUE
      IPAGE=ABS(IMAT(LMX-1))
      GO TO 20055
20054 IL1=IHI+1
20055 IHI=IMAT(J+4)-(ILOW-IL1)
20060 IU1=MIN(LMX-2,IHI)
      IF (.NOT.(IL1.GT.IU1)) GO TO 20062
      GO TO 20061
20062 CONTINUE
      DO 10 I=IL1,IU1
      RZJ=RZJ-AMAT(I)*DUALS(IMAT(I))
      ALPHA=ALPHA+AMAT(I)*ERD(IMAT(I))
      GAMMA=GAMMA+AMAT(I)*WW(IMAT(I))
10    CONTINUE
      IF (.NOT.(IHI.LE.LMX-2)) GO TO 20065
      GO TO 20061
20065 CONTINUE
      IPAGE=IPAGE+1
      KEY=1
      CALL DPRWPG(KEY,IPAGE,LPG,AMAT,IMAT)
      IL1=NVARS+5
      IHI=IHI-LPG
      GO TO 20060
20061 PAGEPL=IHI.EQ.(LMX-2)
      RZ(J)=RZJ*CSC(J)
      ALPHA=ALPHA*CSC(J)
      GAMMA=GAMMA*CSC(J)
      RG(J)=MAX(RG(J)-TWO*ALPHA*GAMMA+ALPHA**2*GQ,ONE+ALPHA**2)
C
C     NONBASIC DEPENDENT VARIABLES (COLUMNS DEFINED IMPLICITLY)
      GO TO 20049
20048 PAGEPL=.TRUE.
      SCALR=-ONE
      IF(IND(J).EQ.2) SCALR=ONE
      I=J-NVARS
      ALPHA=SCALR*ERD(I)
      RZ(J)=-SCALR*DUALS(I)
      GAMMA=SCALR*WW(I)
      RG(J)=MAX(RG(J)-TWO*ALPHA*GAMMA+ALPHA**2*GQ,ONE+ALPHA**2)
20049 CONTINUE
20046 CONTINUE
C
      RCOST=RZ(J)
      IF (MOD(IBB(J),2).EQ.0) RCOST=-RCOST
      IF (.NOT.(IND(J).EQ.3)) GO TO 20068
      IF(BU(J).EQ.BL(J)) RCOST=ZERO
20068 CONTINUE
      IF (IND(J).EQ.4) RCOST=-ABS(RCOST)
      CNORM=ONE
      IF (J.LE.NVARS) CNORM=COLNRM(J)
      IF (RCOST+ERDNRM*DULNRM*CNORM.LT.ZERO) NNEGRC=NNEGRC+1
      J=MOD(J,MRELAS+NVARS)+1
      IF (.NOT.(NNEGRC.GE.NPP .OR. J.EQ.JSTRT)) GO TO 20071
      GO TO 20044
20071 CONTINUE
      GO TO 20043
20044 JSTRT=J
C
C     UPDATE THE EDGE WEIGHT FOR THE EJECTED VARIABLE.
      RG(ABS(IBASIS(IENTER)))= GQ/WP**2
C
C     IF MINIMUM REDUCED COST (DANTZIG) PRICING IS USED,
C     CALCULATE THE NEW REDUCED COSTS.
      GO TO 20040
C
C     COMPUTE THE UPDATED DUALS IN DUALS(*).
20039 ASSIGN 20074 TO NPR003
      GO TO 30003
20074 CALL DCOPY(NVARS+MRELAS,ZERO,0,RZ,1)
      NNEGRC=0
      J=JSTRT
      PAGEPL=.TRUE.
C
20075 IF (.NOT.(IBB(J).LE.0)) GO TO 20077
      PAGEPL=.TRUE.
      GO TO 20078
C
C     NONBASIC INDEPENDENT VARIABLE (COLUMN IN SPARSE MATRIX STORAGE)
20077 IF (.NOT.(J.LE.NVARS)) GO TO 20080
      RZ(J)=COSTS(J)*COSTSC
      IF (.NOT.(J.EQ.1)) GO TO 20083
      ILOW=NVARS+5
      GO TO 20084
20083 ILOW=IMAT(J+3)+1
20084 CONTINUE
      IF (.NOT.(PAGEPL)) GO TO 20086
      IL1=IDLOC(ILOW,AMAT,IMAT)
      IF (.NOT.(IL1.GE.LMX-1)) GO TO 20089
      ILOW=ILOW+2
      IL1=IDLOC(ILOW,AMAT,IMAT)
20089 CONTINUE
      IPAGE=ABS(IMAT(LMX-1))
      GO TO 20087
20086 IL1=IHI+1
20087 CONTINUE
      IHI=IMAT(J+4)-(ILOW-IL1)
20092 IU1=MIN(LMX-2,IHI)
      IF (.NOT.(IU1.GE.IL1 .AND.MOD(IU1-IL1,2).EQ.0)) GO TO 20094
      RZ(J)=RZ(J)-AMAT(IL1)*DUALS(IMAT(IL1))
      IL1=IL1+1
20094 CONTINUE
      IF (.NOT.(IL1.GT.IU1)) GO TO 20097
      GO TO 20093
20097 CONTINUE
C
C     UNROLL THE DOT PRODUCT LOOP TO A DEPTH OF TWO.  (THIS IS DONE
C     FOR INCREASED EFFICIENCY).
      DO 40 I=IL1,IU1,2
      RZ(J)=RZ(J)-AMAT(I)*DUALS(IMAT(I))-AMAT(I+1)*DUALS(IMAT(I+1))
40    CONTINUE
      IF (.NOT.(IHI.LE.LMX-2)) GO TO 20100
      GO TO 20093
20100 CONTINUE
      IPAGE=IPAGE+1
      KEY=1
      CALL DPRWPG(KEY,IPAGE,LPG,AMAT,IMAT)
      IL1=NVARS+5
      IHI=IHI-LPG
      GO TO 20092
20093 PAGEPL=IHI.EQ.(LMX-2)
      RZ(J)=RZ(J)*CSC(J)
C
C     NONBASIC DEPENDENT VARIABLES (COLUMNS DEFINED IMPLICITLY)
      GO TO 20081
20080 PAGEPL=.TRUE.
      SCALR=-ONE
      IF(IND(J).EQ.2) SCALR=ONE
      I=J-NVARS
      RZ(J)=-SCALR*DUALS(I)
20081 CONTINUE
20078 CONTINUE
C
      RCOST=RZ(J)
      IF (MOD(IBB(J),2).EQ.0) RCOST=-RCOST
      IF (.NOT.(IND(J).EQ.3)) GO TO 20103
      IF(BU(J).EQ.BL(J)) RCOST=ZERO
20103 CONTINUE
      IF (IND(J).EQ.4) RCOST=-ABS(RCOST)
      CNORM=ONE
      IF (J.LE.NVARS) CNORM=COLNRM(J)
      IF (RCOST+ERDNRM*DULNRM*CNORM.LT.ZERO) NNEGRC=NNEGRC+1
      J=MOD(J,MRELAS+NVARS)+1
      IF (.NOT.(NNEGRC.GE.NPP .OR. J.EQ.JSTRT)) GO TO 20106
      GO TO 20076
20106 CONTINUE
      GO TO 20075
20076 JSTRT=J
20040 CONTINUE
      GO TO 20030
C
C     THIS IS NECESSARY ONLY FOR PRINTING OF INTERMEDIATE RESULTS.
20029 ASSIGN 20109 TO NPR003
      GO TO 30003
20109 CONTINUE
20030 RETURN
C     PROCEDURE (TRANSLATE RIGHT HAND SIDE)
C
C     PERFORM THE TRANSLATION ON THE RIGHT-HAND SIDE.
30001 IF (.NOT.(IBAS.LE.NVARS)) GO TO 20110
      I=0
20113 CALL DPNNZR(I,AIJ,IPLACE,AMAT,IMAT,IBAS)
      IF (.NOT.(I.LE.0)) GO TO 20115
      GO TO 20114
20115 CONTINUE
      RHS(I)=RHS(I)-SCALR*AIJ*CSC(IBAS)
      GO TO 20113
20114 GO TO 20111
20110 I=IBAS-NVARS
      IF (.NOT.(IND(IBAS).EQ.2)) GO TO 20118
      RHS(I)=RHS(I)-SCALR
      GO TO 20119
20118 RHS(I)=RHS(I)+SCALR
20119 CONTINUE
20111 CONTINUE
      RHSNRM=MAX(RHSNRM,DASUM(MRELAS,RHS,1))
      GO TO NPR001, (20009,20013,20017,20028)
C     PROCEDURE (COMPUTE NEW PRIMAL)
C
C     COPY RHS INTO WW(*), SOLVE SYSTEM.
30002 CALL DCOPY(MRELAS,RHS,1,WW,1)
      TRANS = .FALSE.
      CALL LA05BD(BASMAT,IBRC,LBM,MRELAS,IPR,IWR,WR,GG,WW,TRANS)
      CALL DCOPY(MRELAS,WW,1,RPRIM,1)
      RPRNRM=DASUM(MRELAS,RPRIM,1)
      GO TO 20038
C     PROCEDURE (COMPUTE NEW DUALS)
C
C     SOLVE FOR DUAL VARIABLES. FIRST COPY COSTS INTO DUALS(*).
30003 I=1
      N20121=MRELAS
      GO TO 20122
20121 I=I+1
20122 IF ((N20121-I).LT.0) GO TO 20123
      J=IBASIS(I)
      IF (.NOT.(J.LE.NVARS)) GO TO 20125
      DUALS(I)=COSTSC*COSTS(J)*CSC(J) + XLAMDA*PRIMAL(I+NVARS)
      GO TO 20126
20125 DUALS(I)=XLAMDA*PRIMAL(I+NVARS)
20126 CONTINUE
      GO TO 20121
C
20123 TRANS=.TRUE.
      CALL LA05BD(BASMAT,IBRC,LBM,MRELAS,IPR,IWR,WR,GG,DUALS,TRANS)
      DULNRM=DASUM(MRELAS,DUALS,1)
      GO TO NPR003, (20042,20074,20109)
      END

program sort
  use gildas_def
  use gbl_format
  use image_def
  use gkernel_interfaces
  !---------------------------------------------------------------------
  ! GILDAS	Stand alone program
  !	Sort a table according to a given column
  !---------------------------------------------------------------------
  ! Global
  character(len=*), parameter :: pname = 'SORT'
  ! Local
  integer :: i,scol,nlin
  logical :: error, llin
  integer :: lt, ier
  integer(kind=4), allocatable :: iw(:)
  real(kind=4), allocatable :: rwork(:)
  character(len=filename_length) :: name
  character(len=12) :: algo,text
  type(gildas) :: x
  !
  ! Open parameter file
  call gildas_open
  call gildas_char('TABLE$',name)
  call gildas_inte('COLUMN$',scol,1)
  call gildas_char('ALGORITHM$',algo)
  call gildas_logi('LINE$',llin,1)
  call gildas_close
  !
  if (llin) then
    text = 'line'
    lt = 4
  else
    text = 'column'
    lt = 6
  endif
  !
  call gildas_null(x, type='TABLE')
  x%loca%read = .false.
  call gdf_read_gildas(x,name,'.tab',error,data=.true.)
  if (error) then
    call gagout('F-'//pname//',  Cannot read input file')
    goto 100
  endif
  if (scol.lt.1 .or. scol.gt.x%gil%dim(2)) then
    write(6,*) 'E-'//pname//',  Sorting '//text(1:lt)//' does not exist'
    call sysexi (fatale)
  endif
  !
  nlin = x%gil%dim(1)
  if (llin) then
    if (algo .eq. 'QUICK') then
      allocate (rwork(x%gil%dim(1)),stat=ier)
      call trione (x%r2d,x%gil%dim(1),x%gil%dim(2),scol,   &
     &        rwork,error)
      if (error) then
        call gagout ('F-'//pname//',  Table not sorted')
        goto 100
      endif
    else
      write(6,*) 'F-'//pname//',  Method not supported: '//algo
      goto 100
    endif
  else
    if (algo .eq. 'QUICK') then
      allocate (rwork(x%gil%dim(1)),iw(x%gil%dim(1)),stat=ier)
      call gr4_trie (x%r2d(:,scol),iw,nlin,error)
      if (error) then
        call gagout ('F-'//pname//',  Table not sorted')
        goto 100
      endif
      do i=1,scol-1
        call gr4_sort(x%r2d(:,i),rwork,iw,nlin)
      enddo
      do i=scol+1,x%gil%dim(2)
        call gr4_sort(x%r2d(:,i),rwork,iw,nlin)
      enddo
    elseif (algo .eq. 'HEAP') then
      allocate (rwork(x%gil%dim(1)),iw(x%gil%dim(1)),stat=ier)
      call heap (x%gil%dim(1),x%r2d(:,scol), iw)
      do i=1,scol-1
        call gr4_sort(x%r2d(:,i),rwork,iw,nlin)
      enddo
      do i=scol+1,x%gil%dim(2)
        call gr4_sort(x%r2d(:,i),rwork,iw,nlin)
      enddo
    else
      write (6,*) 'F-'//pname//',  Unsupported method: '//algo
      goto 100
    endif
  endif
  call gdf_write_image(x,x%r2d,error)
  !
  call gagout ('S-'//pname//',  Successful completion')
  call sysexi (1)
100 call sysexi (fatale)
end program sort
!
subroutine heap (n,cle,ipic)
  use gildas_def
  !---------------------------------------------------------------------
  !	Heap sort routine
  !---------------------------------------------------------------------
  integer(kind=index_length), intent(in) :: n  ! Size 
  real(4), intent(inout) :: cle(n)             ! Values
  integer, intent(inout) :: ipic(n)            ! Pointer
  ! Local
  real(4) :: ctemp
  integer :: m, k, i, ip, itemp
  ! Tri en epi. Algorithme publie par J. ARSAC
  !		(Premieres lecons de programmation,
  !		CEDIC/Fernand Nathan, 1980)
  ! Convergence en N*LOG2(N) garantie dans tous les cas
  ! ce qui n'est pas le cas de QUICKSORT...
  k=(n/2)+1
  ! Epi de K a N
21 if (k.eq.1) goto 29    ! Epi de 1 a N
  k=k-1
  i=k
23 ip=2*i
  if (ip.gt.n) goto 21         ! Epi de K a N
  if (ip.eq.n) goto 26
  if (cle(ip+1).gt.cle(ip)) ip=ip+1
26 if (cle(i).gt.cle(ip)) goto 21 ! Epi de K a N
  ctemp=cle(i)
  cle(i)=cle(ip)
  cle(ip)=ctemp
  itemp=ipic(i)
  ipic(i)=ipic(ip)
  ipic(ip)=itemp
  i=ip
  goto 23
29 m=n
  ! En place de M+1 a N. 		! Epi de 1 a N
30 continue
  if (m.eq.1) goto 49          ! Trie de 1 a N
  ctemp=cle(1)
  cle(1)=cle(m)
  cle(m)=ctemp
  itemp=ipic(1)
  ipic(1)=ipic(m)
  ipic(m)=itemp
  m=m-1
  i=1
  ! Epi de 1 a M sauf I
35 continue
  ip=2*i
  if (ip.gt.m) goto 30         ! Epi de 1 a M
  if (ip.eq.m) goto 39
  if (cle(ip+1).gt.cle(ip)) ip=ip+1
39 if (cle(i).gt.cle(ip)) goto 30 ! Epi de 1 a M
  ctemp=cle(i)
  cle(i)=cle(ip)
  cle(ip)=ctemp
  itemp=ipic(i)
  ipic(i)=ipic(ip)
  ipic(ip)=itemp
  i=ip
  goto 35
  ! Trie de 1 a N
49 continue
end subroutine heap
!
subroutine trione (x,nd,n,ix,work,error)
  use gildas_def
  !---------------------------------------------------------------------
  ! 	Sorting program that uses a quicksort algorithm.
  !	Sorts by column.
  !---------------------------------------------------------------------
  integer(kind=index_length), intent(in) :: nd ! First dimension of array
  integer(kind=index_length), intent(in) :: n  ! Second dimension of array
  real(4), intent(out) :: x(nd,n)              ! Array to be sorted
  integer, intent(in) :: ix                    ! Sort column
  real(4), intent(inout) :: work(nd)           ! Work array
  logical, intent(inout) :: error              ! Error flag
  ! Local
  integer :: maxstack,nstop
  parameter (maxstack=1000,nstop=15)
  integer(4) :: i, j, k
  integer(4) :: l, r, m, lstack(maxstack), rstack(maxstack), sp
  real(4) ::  key
  logical :: mgtl, lgtr, rgtm
  !
  if (n.le.nstop) goto 50
  sp = 0
  sp = sp + 1
  lstack(sp) = 1
  rstack(sp) = n
  !
  ! Sort a subrecord off the stack
  ! Set KEY = median of X(L), X(M), X(R)
  ! No! This is not reasonable, as systematic very inequal partitioning will
  ! occur in some cases (especially for nearly already sorted files)
  ! To fix this problem, I found (but I cannot prove it) that it is best to
  ! select the estimation of the median value from intermediate records. P.V.
1 l = lstack(sp)
  r = rstack(sp)
  sp = sp - 1
  m = (l + r) / 2
  !
  mgtl = x(ix,m) .gt. x(ix,l)
  rgtm = x(ix,r) .gt. x(ix,m)
  !
  ! Algorithm to select the median key. The original one from MONGO
  ! was completely wrong. P. Valiron, 24-Jan-84 .
  !
  !		   	MGTL	RGTM	LGTR	MGTL.EQV.LGTR	MEDIAN_KEY
  !
  !	KL < KM < KR	T	T	*	*		KM
  !	KL > KM > KR	F	F	*	*		KM
  !
  !	KL < KM > KR	T	F	F	F		KR
  !	KL < KM > KR	T	F	T	T		KL
  !
  !	KL > KM < KR	F	T	F	T		KL
  !	KL > KM < KR	F	T	T	F		KR
  !
  if (mgtl .eqv. rgtm) then
    key = x(ix,m)
  else
    lgtr = x(ix,l) .gt. x(ix,r)
    if (mgtl .eqv. lgtr) then
      key = x(ix,l)
    else
      key = x(ix,r)
    endif
  endif
  i = l
  j = r
  !
  ! Find a big record on the left
10 if (x(ix,i).ge.key) goto 11
  i = i + 1
  goto 10
11 continue
  ! Find a small record on the right
20 if (x(ix,j).le.key) goto 21
  j = j - 1
  goto 20
21 continue
  if (i.ge.j) goto 2
  !
  ! Exchange records
  call r4tor4(x(1,i),work,nd)
  call r4tor4(x(1,j),x(1,i),nd)
  call r4tor4(work,x(1,j),nd)
  i = i + 1
  j = j - 1
  goto 10
  !
  ! Subfile is partitioned into two halves, left .le. right
  ! Push the two halves on the stack
2 continue
  if (j-l+1 .gt. nstop) then
    sp = sp + 1
    if (sp.gt.maxstack) then
      write(6,*) 'E-SORT,  Stack overflow ',sp
      error = .true.
      return
    endif
    lstack(sp) = l
    rstack(sp) = j
  endif
  if (r-j .gt. nstop) then
    sp = sp + 1
    if (sp.gt.maxstack) then
      write(6,*) 'E-SORT,  Stack overflow ',sp
      error = .true.
      return
    endif
    lstack(sp) = j+1
    rstack(sp) = r
  endif
  !
  ! Anything left to process?
  if (sp.gt.0) goto 1
  !
50 continue
  !
  do j=n-1,1,-1
    k = j
    do i = j+1,n
      if (x(ix,j).le.x(ix,i)) exit ! I
      k = i
    enddo
    if (k.eq.j) cycle          ! J
    call r4tor4(x(1,j),work,nd)
    do i = j+1,k
      call r4tor4(x(1,i),x(1,i-1),nd)
    enddo
    call r4tor4(work,x(1,k),nd)
  enddo
  error = .false.
end subroutine trione

subroutine gtv_fillpoly(n,x,y,vert,error)
  use gtv_interfaces, except_this=>gtv_fillpoly
  use gtv_tree
  use gtv_buffers
  use gtv_graphic
  use gtv_plot
  use gbl_message
  !---------------------------------------------------------------------
  ! @ public
  !     Plot a filled polygon. Filling based on Horizontal scanning.
  !     or Vertical scanning if VERT = .TRUE.
  ! ---
  !   Threads status: thread safe
  !---------------------------------------------------------------------
  integer(kind=4), intent(in)    :: n      ! Number of points
  real(kind=4),    intent(in)    :: x(n)   !
  real(kind=4),    intent(in)    :: y(n)   !
  logical,         intent(in)    :: vert   ! Horizontal or vertical polygon?
  logical,         intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='GTV_FILLPOLY'
  integer :: seg_kind,ier
  !
  if (.not.awake .or. error_condition) return
  if (n.le.0)  return  ! No data
  !
  if (.not.associated(co_segment)) then
    call gtv_message(seve%e,rname,'Programming error: no segment opened')
    error = .true.
    return
  endif
  !
  ! First flush POLYL%X and POLYL%Y buffers if they are not empty
  call gtx_frxry(error)
  if (error) return
  !
  ! Do we need to save the current PENLUT in the metacode before starting
  ! to write the polygon?
  if (lut_static) then
    if (.not.associated(co_segment%head%lut)) then
      ! We have to save the current global PENLUT in the metacode
      call gt_penlut_segdata(error)  ! This sets co_segment%head%lut
      if (error)  return
    endif
  endif
  !
  ! Update minmax
  co_segment%head%gen%minmax(1) = min(minval(x),co_segment%head%gen%minmax(1))  ! xmin
  co_segment%head%gen%minmax(2) = max(maxval(x),co_segment%head%gen%minmax(2))  ! xmax
  co_segment%head%gen%minmax(3) = min(minval(y),co_segment%head%gen%minmax(3))  ! ymin
  co_segment%head%gen%minmax(4) = max(maxval(y),co_segment%head%gen%minmax(4))  ! ymax
  !
  if (vert) then
    seg_kind = seg_vfpoly
  else
    seg_kind = seg_hfpoly
  endif
  !
  call gtv_open_segments_for_writing_from_main()
  !
  if (.not.associated(co_segment_data)) then
    allocate(co_segment%data,stat=ier)
    if (ier.ne.0) then
      call gtv_message(seve%e,rname,'Internal error: allocation failure (1)')
      error = .true.
      goto 10
    endif
    co_segment_data => co_segment%data
  else
    allocate(co_segment_data%nextdata,stat=ier)
    if (ier.ne.0) then
      call gtv_message(seve%e,rname,'Internal error: allocation failure (2)')
      error = .true.
      goto 10
    endif
    co_segment_data => co_segment_data%nextdata
  endif
  co_segment_data%nextdata => null()
  !
  ! Store the data
  allocate(co_segment_data%poly%x(n),co_segment_data%poly%y(n),stat=ier)
  if (ier.ne.0) then
    call gtv_message(seve%e,rname,'Internal error: allocation failure (3)')
    error = .true.
    goto 10
  endif
  co_segment_data%kind = seg_kind
  co_segment_data%poly%n = n
  co_segment_data%poly%x = x
  co_segment_data%poly%y = y
  co_segment_data%poly%penlut => co_segment%head%lut  ! Which can be null()
  !
10 continue
  !
  call gtv_close_segments_for_writing_from_main()
  !
end subroutine gtv_fillpoly
!
subroutine gti_fillpoly(out,poly,vert)
  use gtv_types
  use gtv_tree
  use gtv_buffers
  use gtv_graphic
  use gtv_interfaces, except_this=>gti_fillpoly
  use gtv_protocol
  !---------------------------------------------------------------------
  ! @ private
  !   Draws a filled polygon. Filling based on Horizontal scanning.
  !---------------------------------------------------------------------
  type(gt_display),  intent(inout) :: out   ! Input gt_display
  type(gt_polyline), intent(in)    :: poly  !
  logical,           intent(in)    :: vert  !
  ! Local
  integer(kind=4) :: i
  integer(kind=4), allocatable :: x_poly(:),y_poly(:)
  !
  if (.not.awake .or. error_condition) return
  ! call gtx_pen(out,ipenx_i)
  !
  ! No device selected
  if (out%dev%protocol.eq.p_null)  return
  !
  if (associated(poly%penlut)) then
    ! LUT STATIC:
    ! Load the appropriate pen into the device
    call gtx_pen(out,out%icolou,poly%penlut)
  endif
  !
  ! Tracons...
  select case (out%dev%protocol)
  case(p_x)
    allocate(x_poly(poly%n),y_poly(poly%n))
    do i = 1,poly%n
      call world_to_pixel(out,poly%x(i),poly%y(i),x_poly(i),y_poly(i))
    enddo
    call x_fill_poly(out%x%graph_env,poly%n,x_poly,y_poly)
    deallocate(x_poly,y_poly)
    !
  case(p_postscript)
    call ps_fill(poly%n,poly%x,poly%y)
    !
  case(p_svg)
    call svg_fill(out,poly%n,poly%x,poly%y)
    !
  case(p_png)
    call png_fill(out,poly%n,poly%x,poly%y)
    !
  end select
  !
end subroutine gti_fillpoly
!
subroutine gi4_bltlis(lpoly,llv,npoly,nvert,xv,yv,iy,lnx,ixl,ixu)
  use gtv_interfaces, except_this=>gi4_bltlis
  !---------------------------------------------------------------------
  ! @ private
  ! From a list of polygons, BLTLIS makes a list of horizontal line
  ! segments included in the polygons. There might several segments
  ! to fill for a row crossed by a single polygon.
  !---------------------------------------------------------------------
  integer(kind=4), intent(in)  :: lpoly      ! Beginning polygon number
  integer(kind=4), intent(in)  :: llv        ! Beginning vertex number
  integer(kind=4), intent(in)  :: npoly      ! Number of polygons
  integer(kind=4), intent(in)  :: nvert(2)   ! Number of vertices in each polygon
  integer(kind=4), intent(in)  :: xv(1024)   ! X position of vertices
  integer(kind=4), intent(in)  :: yv(1024)   ! Y position of vertices
  integer(kind=4), intent(in)  :: iy         ! Row number
  integer(kind=4), intent(out) :: lnx        ! Number of segments
  integer(kind=4), intent(out) :: ixl(1024)  ! Low x index of segments
  integer(kind=4), intent(out) :: ixu(1024)  ! High x index of segments
  ! Local
  integer(kind=4) :: lp,ip,lv,nxe,y1,y2,i,j,ix,k
  logical :: sorted
  integer(kind=4), parameter :: xsegmax=1024  ! Should be greater or equal to ixl/ixu dimension
  real(kind=4) :: rx,ry,ang,angsum,xse(xsegmax)
  !
  lnx = 0
  lp = llv
  ry = iy
  do ip=lpoly,npoly
    lv = nvert(ip) + lp - 2
    ! find intersections
    nxe = 0
    do i=lp,lv
      y1 = yv(i)
      y2 = yv(i+1)
      if (y1.eq.y2) cycle  ! I
      if (iy.lt.y1 .and. iy.lt.y2) cycle  ! I
      if (iy.gt.y1 .and. iy.gt.y2) cycle  ! I
      if (nxe.eq.xsegmax)  cycle  ! Buffers will be exhausted. Silently skip
      nxe = nxe + 1
      xse(nxe) = float(xv(i+1)-xv(i)) * float(iy-y1) / float (y2-y1) + xv(i)
    enddo  ! I
    if (nxe.le.1) go to 70
    !
    ! Sort list (Catastrophically programmed)
    sorted = .false.
    do while (.not.sorted)
      sorted = .true.
      do i = 2,nxe
        if (xse(i-1).gt.xse(i)) then
          rx = xse(i-1)
          xse(i-1) = xse(i)
          xse(i) = rx
          sorted = .false.
        endif
      enddo
    enddo
    !
    ! which are interior
    do i=2,nxe
      rx = (xse(i-1) + xse(i)) / 2.0
      ix = nint (rx)
      ! test for on an edge
      do j=lp,lv
        if (iy.ne.yv(j)) go to 35
        if (ix.eq.xv(j)) go to 55
        if (ix.ge.xv(j) .and. ix.le.xv(j+1) .and. iy.eq.yv(j+1))  go to 55
        if (ix.le.xv(j) .and. ix.ge.xv(j+1) .and. iy.eq.yv(j+1))  go to 55
35      if (ix.ne.xv(j))  cycle
        if (iy.ge.yv(j) .and. iy.le.yv(j+1) .and. ix.eq.xv(j+1))  go to 55
        if (iy.le.yv(j) .and. iy.ge.yv(j+1) .and. ix.eq.xv(j+1))  go to 55
      enddo
      !
      angsum = 0.0
      do j = lp,lv
        call gi4_bltgle (rx, ry, xv(j), yv(j), xv(j+1), yv(j+1), ang)
        angsum = angsum + ang
      enddo
      if (abs(angsum).lt.180.) cycle   ! I
55    lnx = lnx + 1
      ixl(lnx) = nint (xse(i-1))
      ixu(lnx) = nint (xse(i))
    enddo                      ! I
70  lp = lv + 2
  enddo                        ! IP
  !
  if (lnx.le.0) go to 999
  !
  ! compress list
  i = 1
85 if (i.ge.lnx) go to 999
  i = i + 1
90 if (ixu(i-1).ne.ixl(i)) go to 85
  j = lnx - i
  ixu(i-1) = ixu(i)
  lnx = lnx - 1
  if (j.le.0) go to 999
  do k=i+1,i+j
    ixl(k-1) = ixl(k)
  enddo
  do k=i+1,i+j
    ixu(k-1) = ixu(k)
  enddo
  go to 90
  !
999 return
end subroutine gi4_bltlis
!
subroutine gi4_bltgle (xt, yt, x1, y1, x2, y2, ang)
  use gtv_interfaces, except_this=>gi4_bltgle
  !---------------------------------------------------------------------
  ! @ private
  !  Support routine for BLTLIS (INTEGER*4 version)
  !  Returns angle from A through a test position to B
  !  BLTGLE returns the angle in degrees from (X1, Y1) to (XT, YT) to
  ! (X2, Y2).
  !---------------------------------------------------------------------
  real(kind=4),    intent(in)  :: xt   ! Test position (X)
  real(kind=4),    intent(in)  :: yt   ! Test position (Y)
  integer(kind=4), intent(in)  :: x1   ! Mark position 1 (X)
  integer(kind=4), intent(in)  :: y1   ! Mark position 1 (Y)
  integer(kind=4), intent(in)  :: x2   ! Mark position 2 (X)
  integer(kind=4), intent(in)  :: y2   ! Mark position 2 (Y)
  real(kind=4),    intent(out) :: ang  ! Angle between 1 -> T -> 2
  ! Local
  real(kind=4) :: xx1, xx2, yy1, yy2, cross, dot
  real(kind=4), parameter :: r2d=57.29578e0
  !
  ! Vector coordinates
  xx1 = x1 - xt
  yy1 = y1 - yt
  xx2 = x2 - xt
  yy2 = y2 - yt
  ! CROSS prop SIN
  ! DOT prop COS
  cross = xx1 * yy2  -  xx2 * yy1
  dot   = xx1 * xx2  +  yy1 * yy2
  ang = 0.0
  if (cross.ne.0. .or. dot.ne.0.) ang = r2d * atan2 (cross, dot)
end subroutine gi4_bltgle
!
subroutine gr8_bltlis(lpoly,llv,npoly,nvert,xv,yv,iy,lnx,ixl,ixu)
  use gtv_interfaces, except_this=>gr8_bltlis
  !---------------------------------------------------------------------
  ! @ public
  ! From a list of polygons, BLTLIS makes a list of horizontal line
  ! segments included in the polygons. There might several segments
  ! to fill for a row crossed by a single polygon.
  !---------------------------------------------------------------------
  integer(kind=4), intent(in)  :: lpoly      ! Beginning polygon number
  integer(kind=4), intent(in)  :: llv        ! Beginning vertex number
  integer(kind=4), intent(in)  :: npoly      ! Number of polygons
  integer(kind=4), intent(in)  :: nvert(2)   ! Number of vertices in each polygon
  real(kind=8),    intent(in)  :: xv(1024)   ! X position of vertices
  real(kind=8),    intent(in)  :: yv(1024)   ! Y position of vertices
  real(kind=8),    intent(in)  :: iy         ! Row number
  integer(kind=4), intent(out) :: lnx        ! Number of segments
  real(kind=8),    intent(out) :: ixl(1024)  ! Low x index of segments
  real(kind=8),    intent(out) :: ixu(1024)  ! High x index of segments
  ! Local
  integer(kind=4) :: lp,ip,lv,nxe,i,j,k
  real(kind=8) :: y1,y2,ix
  logical :: sorted
  integer(kind=4), parameter :: xsegmax=1024  ! Should be greater or equal to ixl/ixu dimension
  real(kind=4) :: rx,ry,ang,angsum,xse(xsegmax)
  !
  lnx = 0
  lp = llv
  ry = iy
  do ip=lpoly,npoly
    lv = nvert(ip) + lp - 2
    ! find intersections
    nxe = 0
    do i=lp,lv
      y1 = yv(i)
      y2 = yv(i+1)
      if (y1.eq.y2) cycle  ! I
      if (iy.lt.y1 .and. iy.lt.y2) cycle  ! I
      if (iy.gt.y1 .and. iy.gt.y2) cycle  ! I
      if (nxe.eq.xsegmax)  cycle  ! Buffers will be exhausted. Silently skip
      nxe = nxe + 1
      xse(nxe) = (xv(i+1)-xv(i)) * (iy-y1) / (y2-y1) + xv(i)
    enddo  ! I
    if (nxe.le.1) go to 70
    !
    ! Sort list (Catastrophically programmed)
    sorted = .false.
    do while (.not.sorted)
      sorted = .true.
      do i = 2,nxe
        if (xse(i-1).gt.xse(i)) then
          rx = xse(i-1)
          xse(i-1) = xse(i)
          xse(i) = rx
          sorted = .false.
        endif
      enddo
    enddo
    !
    ! which are interior
    do i=2,nxe
      rx = (xse(i-1) + xse(i)) / 2.0
      ix = rx
      ! test for on an edge
      do j=lp,lv
        if (iy.ne.yv(j)) go to 35
        if (ix.eq.xv(j)) go to 55
        if (ix.ge.xv(j) .and. ix.le.xv(j+1) .and. iy.eq.yv(j+1))  go to 55
        if (ix.le.xv(j) .and. ix.ge.xv(j+1) .and. iy.eq.yv(j+1))  go to 55
35      if (ix.ne.xv(j))  cycle
        if (iy.ge.yv(j) .and. iy.le.yv(j+1) .and. ix.eq.xv(j+1))  go to 55
        if (iy.le.yv(j) .and. iy.ge.yv(j+1) .and. ix.eq.xv(j+1))  go to 55
      enddo
      !
      angsum = 0.0
      do j = lp,lv
        call gr8_bltgle (rx, ry, xv(j), yv(j), xv(j+1), yv(j+1), ang)
        angsum = angsum + ang
      enddo
      if (abs(angsum).lt.180.) cycle   ! I
55    lnx = lnx + 1
      ixl(lnx) = xse(i-1)
      ixu(lnx) = xse(i)
    enddo                      ! I
70  lp = lv + 2
  enddo                        ! IP
  !
  if (lnx.le.0) go to 999
  !
  ! compress list
  i = 1
85 if (i.ge.lnx) go to 999
  i = i + 1
90 if (ixu(i-1).ne.ixl(i)) go to 85
  j = lnx - i
  ixu(i-1) = ixu(i)
  lnx = lnx - 1
  if (j.le.0) go to 999
  do k=i+1,i+j
    ixl(k-1) = ixl(k)
  enddo
  do k=i+1,i+j
    ixu(k-1) = ixu(k)
  enddo
  go to 90
  !
999 return
end subroutine gr8_bltlis
!
subroutine gr8_bltgle (xt, yt, x1, y1, x2, y2, ang)
  use gtv_interfaces, except_this=> gr8_bltgle
  !---------------------------------------------------------------------
  ! @ private-mandatory (because symbol is used elsewhere)
  !  Support routine for BLTLIS (REAL*8 version)
  !  Returns angle from A through a test position to B
  !  BLTGLE returns the angle in degrees from (X1, Y1) to (XT, YT) to
  ! (X2, Y2).
  !---------------------------------------------------------------------
  real(kind=4), intent(in)  :: xt   ! Test position (X)
  real(kind=4), intent(in)  :: yt   ! Test position (Y)
  real(kind=8), intent(in)  :: x1   ! Mark position 1 (X)
  real(kind=8), intent(in)  :: y1   ! Mark position 1 (Y)
  real(kind=8), intent(in)  :: x2   ! Mark position 2 (X)
  real(kind=8), intent(in)  :: y2   ! Mark position 2 (Y)
  real(kind=4), intent(out) :: ang  ! Angle between 1 -> T -> 2
  ! Local
  real(kind=4) :: xx1, xx2, yy1, yy2, cross, dot
  real(kind=4), parameter :: r2d=57.29578e0
  !
  ! Vector coordinates
  xx1 = x1 - xt
  yy1 = y1 - yt
  xx2 = x2 - xt
  yy2 = y2 - yt
  ! CROSS prop SIN
  ! DOT prop COS
  cross = xx1 * yy2  -  xx2 * yy1
  dot   = xx1 * xx2  +  yy1 * yy2
  ang = 0.0
  if (cross.ne.0. .or. dot.ne.0.) ang = r2d * atan2 (cross, dot)
end subroutine gr8_bltgle
!
subroutine gr4_bltlis(lpoly,llv,npoly,nvert,xv,yv,iy,lnx,ixl,ixu)
  use gtv_interfaces, except_this=>gr4_bltlis
  !---------------------------------------------------------------------
  ! @ public
  ! From a list of polygons, BLTLIS makes a list of horizontal line
  ! segments included in the polygons. There might several segments
  ! to fill for a row crossed by a single polygon.
  !---------------------------------------------------------------------
  integer(kind=4), intent(in)  :: lpoly      ! Beginning polygon number
  integer(kind=4), intent(in)  :: llv        ! Beginning vertex number
  integer(kind=4), intent(in)  :: npoly      ! Number of polygons
  integer(kind=4), intent(in)  :: nvert(2)   ! Number of vertices in each polygon
  real(kind=4),    intent(in)  :: xv(1024)   ! X position of vertices
  real(kind=4),    intent(in)  :: yv(1024)   ! Y position of vertices
  real(kind=4),    intent(in)  :: iy         ! Row number
  integer(kind=4), intent(out) :: lnx        ! Number of segments
  real(kind=4),    intent(out) :: ixl(1024)  ! Low x index of segments
  real(kind=4),    intent(out) :: ixu(1024)  ! High x index of segments
  ! Local
  integer(kind=4) :: lp,ip,lv,nxe,i,j,k
  real(kind=4) :: y1,y2,ix
  logical :: sorted
  integer(kind=4), parameter :: xsegmax=1024  ! Should be greater or equal to ixl/ixu dimension
  real(kind=4) :: rx,ry,ang,angsum,xse(xsegmax)
  !
  lnx = 0
  lp = llv
  ry = iy
  do ip=lpoly,npoly
    lv = nvert(ip) + lp - 2
    ! find intersections
    nxe = 0
    do i=lp,lv
      y1 = yv(i)
      y2 = yv(i+1)
      if (y1.eq.y2) cycle  ! I
      if (iy.lt.y1 .and. iy.lt.y2) cycle  ! I
      if (iy.gt.y1 .and. iy.gt.y2) cycle  ! I
      if (nxe.eq.xsegmax)  cycle  ! Buffers will be exhausted. Silently skip
      nxe = nxe + 1
      xse(nxe) = (xv(i+1)-xv(i)) * (iy-y1) / (y2-y1) + xv(i)
    enddo  ! I
    if (nxe.le.1) go to 70
    !
    ! Sort list (Catastrophically programmed)
    sorted = .false.
    do while (.not.sorted)
      sorted = .true.
      do i = 2,nxe
        if (xse(i-1).gt.xse(i)) then
          rx = xse(i-1)
          xse(i-1) = xse(i)
          xse(i) = rx
          sorted = .false.
        endif
      enddo
    enddo
    !
    ! which are interior
    do i=2,nxe
      rx = (xse(i-1) + xse(i)) / 2.0
      ix = rx
      ! test for on an edge
      do j=lp,lv
        if (iy.ne.yv(j)) go to 35
        if (ix.eq.xv(j)) go to 55
        if (ix.ge.xv(j) .and. ix.le.xv(j+1) .and. iy.eq.yv(j+1))  go to 55
        if (ix.le.xv(j) .and. ix.ge.xv(j+1) .and. iy.eq.yv(j+1))  go to 55
35      if (ix.ne.xv(j))  cycle
        if (iy.ge.yv(j) .and. iy.le.yv(j+1) .and. ix.eq.xv(j+1))  go to 55
        if (iy.le.yv(j) .and. iy.ge.yv(j+1) .and. ix.eq.xv(j+1))  go to 55
      enddo
      !
      angsum = 0.0
      do j = lp,lv
        call gr4_bltgle (rx, ry, xv(j), yv(j), xv(j+1), yv(j+1), ang)
        angsum = angsum + ang
      enddo
      if (abs(angsum).lt.180.) cycle   ! I
55    lnx = lnx + 1
      ixl(lnx) = xse(i-1)
      ixu(lnx) = xse(i)
    enddo                      ! I
70  lp = lv + 2
  enddo                        ! IP
  !
  if (lnx.le.0) go to 999
  !
  ! compress list
  i = 1
85 if (i.ge.lnx) go to 999
  i = i + 1
90 if (ixu(i-1).ne.ixl(i)) go to 85
  j = lnx - i
  ixu(i-1) = ixu(i)
  lnx = lnx - 1
  if (j.le.0) go to 999
  do k=i+1,i+j
    ixl(k-1) = ixl(k)
  enddo
  do k=i+1,i+j
    ixu(k-1) = ixu(k)
  enddo
  go to 90
  !
999 return
end subroutine gr4_bltlis
!
subroutine gr4_bltgle (xt, yt, x1, y1, x2, y2, ang)
  use gtv_interfaces, except_this=> gr4_bltgle
  !---------------------------------------------------------------------
  ! @ private-mandatory (because symbol is used elsewhere)
  !  Support routine for BLTLIS (REAL*4 version)
  !  Returns angle from A through a test position to B
  !  BLTGLE returns the angle in degrees from (X1, Y1) to (XT, YT) to
  ! (X2, Y2).
  !---------------------------------------------------------------------
  real(kind=4), intent(in)  :: xt   ! Test position (X)
  real(kind=4), intent(in)  :: yt   ! Test position (Y)
  real(kind=4), intent(in)  :: x1   ! Mark position 1 (X)
  real(kind=4), intent(in)  :: y1   ! Mark position 1 (Y)
  real(kind=4), intent(in)  :: x2   ! Mark position 2 (X)
  real(kind=4), intent(in)  :: y2   ! Mark position 2 (Y)
  real(kind=4), intent(out) :: ang  ! Angle between 1 -> T -> 2
  ! Local
  real(kind=4) :: xx1, xx2, yy1, yy2, cross, dot
  real(kind=4), parameter :: r2d=57.29578e0
  !
  ! Vector coordinates
  xx1 = x1 - xt
  yy1 = y1 - yt
  xx2 = x2 - xt
  yy2 = y2 - yt
  ! CROSS prop SIN
  ! DOT prop COS
  cross = xx1 * yy2  -  xx2 * yy1
  dot   = xx1 * xx2  +  yy1 * yy2
  ang = 0.0
  if (cross.ne.0. .or. dot.ne.0.) ang = r2d * atan2 (cross, dot)
end subroutine gr4_bltgle

subroutine display_buffer(comm,line,error)
  use gkernel_interfaces
  use imager_interfaces, only : display_buffer_sub, map_message
  use clean_arrays
  use clean_def
  use clean_types
  use clean_support
  use clean_default
  use uvfit_data
  use gbl_message
  !----------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- Dispatching routine for SHOW Name [/DIRECTORY] and VIEW commands
  ! 
  !   Dispatch the action according to the Name argument.
  !!
  !----------------------------------------------------------------------
  character(len=*), intent(in)  :: comm       !! Command (SHOW or VIEW)
  character(len=*), intent(inout)  :: line    !! Command line
  logical,          intent(out) :: error      !! Logical error flag
  !
  ! Constants
  character(len=1), parameter :: question_mark='?'
  integer, parameter :: o_view_dir=1
  integer, parameter :: o_view_nopause=2
  integer, parameter :: o_view_over=3
  integer, parameter :: o_show_cont=1
  integer, parameter :: o_show_dir=2
  integer, parameter :: o_show_side=4
  integer, parameter :: o_show_over=3
  real(8), parameter :: pi=acos(-1d0)
  integer, parameter :: mnoise=3
  character(len=6), save :: comptype(2)=['PEAK  ','WIDTH ']
  character(len=6), save :: compmode='PEAK'
  character(len=6), save :: vuvfit='RESET '
  character(len=filename_length), save :: sed_file=' '
  !
  ! Local ---
  integer :: o_dir
  type(gildas) :: head
  integer :: o_args, na
  integer(kind=size_length) :: locasize
  type(sic_descriptor_t) :: descr
  type(gildas) :: htmp
  logical :: found, done, err, exist
  logical :: do_insert, do_loop, do_color, do_nopause, cont_do
  integer ntype,nc,is,istart,ic,i, code, iover, nt, narg
  real :: colour
  character(len=filename_length) :: argu,file,chain 
  real(4), save :: sed_freq=0
  character(len=512) :: exec_chain
  character(len=80) :: mess
  character(len=40) :: argu1,argu2,vover, dtype, topic !
  character(len=12) :: dnoise 
  character(len=8) :: cshort
  ! integer :: nnoise
  ! character(len=6) :: vnoise(mnoise)=['DIRTY ', 'CLEAN ', 'SKY   ']
  !
  ! This Boolean indicates if the LUT should be switched back to Dynamic
  ! logical, save :: reset_lut=.false.
  !
  integer :: iarg, kc
  integer :: l_axis, ioff, ier, itype
  real :: soff
  !
  ! Code ----
  o_args = 0
  iarg = 1
  do_nopause = .false.
  cont_do = .false.
  !
  do_loop = .false.
  if (comm.eq.'VIEW') then
    do_loop = view_do_loop
    ! Allow VIEW /NOPAUSE Args    as well as VIEW Args /NOPAUSE
    if (sic_narg(o_view_nopause).gt.0) then
      if (sic_narg(0).ne.0) then
        call map_message(seve%e,comm,'Invalid syntax in VIEW /NOPAUSE command')
        error = .true.
        return
      else
        o_args = o_view_nopause
      endif
      do_nopause = .true.
    else if (sic_narg(o_view_nopause).eq.0) then
      do_nopause = .true.
    endif
    if (sic_present(o_view_over,0)) then
      ! /OVERLAY Variable [Channel]
      ! IVIEW%cplane,  IVIEW%cont and IVIEW%rplane
      vover = 'CONTINUUM'
      call sic_ke(line,o_view_over,1,vover,iover,.false.,error)
      if (error) return
      call sic_let_char('IVIEW%CONT',vover,error)
      iover = 0
      call sic_i4(line,o_view_over,2,iover,.false.,error)
      if (error) return
      call sic_let_inte('IVIEW%CPLANE',iover,error)      
    else
      vover = ' '
      call sic_let_char('IVIEW%CONT',vover,error)
    endif
  else if (comm.eq.'SHOW') then
    ! Allow SHOW Args /SIDE as well as SHOW /SIDE Args
    if (sic_narg(o_show_side).gt.0) then
      if (sic_narg(0).ne.0) then
        call map_message(seve%e,comm,'Invalid syntax in SHOW /SIDE command')
        error = .true.
        return
      else
        o_args = o_show_side
      endif
    endif
    !
    if (sic_present(o_show_over,0)) then
      ! /OVERLAY Variable [Channel]
      ! show%cplane,  show%cont and show%rplane
      call sic_get_logi('DO_CONTOUR',cont_do,err)
      vover = 'CONTINUUM'
      call sic_ke(line,o_show_over,1,vover,iover,.false.,error)
      if (error) return
      call sic_let_char('SHOW%CONT',vover,error)
      iover = 0
      call sic_i4(line,o_show_over,2,iover,.false.,error)
      if (error) return
      call sic_let_inte('SHOW%CPLANE',iover,error)      
    else
      vover = ' '
      call sic_let_char('SHOW%CONT',vover,error)
    endif
    call sic_let_logi('IVIEW%FIRST',.true.,error)
  else
    call sic_let_logi('IVIEW%FIRST',.true.,error)
  endif  
  !
  ! Fall back to last Displayed item if no Argument is given
  if (.not.sic_present(o_args,1)) then
    if (len_trim(last_shown).eq.0) then
      cshort = comm(1:7)
      call map_message(seve%e,comm,'No data to re-'//trim(cshort)//' yet')
      error = .true.
      return
    endif
    argu = last_shown
    iarg = 0
  endif
  !
  ! Parse input line
  if (iarg.ne.0) then
    call sic_ke(line,o_args,iarg,argu,nc,.true.,error)
    if (error) return
  endif
  !
  ! Should we support 
  !   COMM Topic ?  
  ! as equal to 
  !   COMM ? Topic
  !
  topic = ' '
  call sic_ch(line,0,2,topic,nt,.false.,error)
  if (argu(1:1).eq.question_mark) then
    if (nt.gt.0) then
      chain = 'HELP '//comm//topic
      call exec_program(chain)
      return        
    endif
    argu1 = '@ i_'//comm
    call sic_lower(argu1)
    argu1 = trim(argu1) //' '//argu
    call exec_program(argu1) 
    call sic_ambigs_list(comm,seve%i,'Choices are:',vtype,vshow)
    return
  else if ((topic.eq.'?').or.(topic.eq.'??')) then
    call sic_lower(argu)
    chain = 'i_show_'//trim(argu)
    exist = sic_findfile(chain,file,'gag_pro:','.ima')
    if (exist) then
      argu1 = '@ i_show_'//trim(argu)//' '//topic
      call exec_program(argu1)
    else
      chain = 'HELP '//comm//argu
      call exec_program(chain)
    endif
    return
  else if (argu.eq.'UV') then
    argu = 'UV_DATA'    
  endif
!
! Code for non-ambiguous abbreviations (dangerous with variables...)
!      
!  call sic_ambigs(comm,argu,dtype,ntype,vtype,mtype,error)
!  if (error) then
!    error = .false.
!    ntype = 0
!  endif
  !
  ! Code for exact name matching - Will avoid taking an abbreviation
  ! of a keyword in place of a SIC variable...
  !
  dtype = argu
  ntype = 0
  na = len_trim(argu)
  if (argu(na:na).eq.':') then
    ! Short-cut for a CUBE internal name
    dtype = 'CUBE'
    call sic_ch(line,o_args,iarg,argu,na,.true.,error)
  else if (dtype.ne.'PV') then
    do is=1,mtype
      if (argu.eq.vtype(is)) then
        ntype = is
        dtype = vtype(ntype)
        exit
      endif
    enddo
    if (ntype.eq.0) then
      call sic_descriptor (argu,descr,found)    ! Checked
      if ((.not.found).and.(iarg.ne.0)) then
        call sic_ch(line,o_args,iarg,argu,nc,.true.,error)
        found = sic_findfile(argu,file,' ',' ')
        if (found) then
          dtype = 'FILENAME'
        else
          !call map_message(seve%w,comm, &
          !'Cannot '//trim(comm)//' '//trim(file)//' (no such file or SIC variable)')
          dtype = 'CUBE' ! Test for Cube
          ! last_shown = ' '
          ! error = .true.
          ! return
        endif
      endif
    endif
  endif
  !
  !
  ! Special cases first
  do_insert = sic_lire().eq.0
  done = .false.
  do_color = .false.  ! No Color LUT in most actions
  !
  exec_chain = ' '
  !
  select case (dtype)
  case ('UV_FIT')
    if (sic_present(o_args,2)) then
      call sic_ke(line,o_args,2,argu,nc,.false.,error)
      if (error) return
      if (argu(1:1).eq.question_mark) then
        exec_chain = '@ i_plotfit '//argu
      else
        nc = min(nc,6)
        if (argu(1:nc).eq.vuvfit(1:nc)) then
          exec_chain = '@ d_plotfit '
        else
          call map_message(seve%e,comm,'Invalid SHOW UV_FIT argument '//trim(argu))
          error = .true.
          return
        endif
      endif
    else
      if (huvfit%loca%size.eq.0) then
        call map_message(seve%e,comm,'No UV_FIT performed')
        error = .true.
      else 
        exec_chain = '@ p_plotfit UV_FIT'
      endif
    endif
    done = .true. 
  case ('SED')
    call sic_r4(line,0,2,sed_freq,.false.,error)
    if (error) return
    if (sic_present(0,3)) then
      call sic_ch(line,0,3,sed_file,nc,.false.,error)
    else if (sed_file.eq.' ') then
      sed_file = "'sed%name'"
    endif
    if (error) return
    nc = len_trim(sed_file)
    if (nc.eq.0) then
      call map_message(seve%e,comm,'No file name specified')
      error = .true.
      return
    endif
    write(argu2,*) sed_freq
    exec_chain = '@ p_show_sed '//sed_file(1:nc)//argu2//' COLOR'
    done = .true.
  case ('FLUX') 
    ! Pass arguments as they are given - DISPLAY\SHOW FLUX is 18 chars
    exec_chain = '@ p_show_flux '//line(19:)
    done = .true.
  case ('COMPOSITE') 
    argu = ' '
    call sic_ke(line,0,2,argu,nc,.false.,error)
    if (nc.ne.0) then
      kc = min(nc,6)
      if (argu(1:kc).eq.comptype(1)(1:kc)) then
        compmode = comptype(1)
      else if (argu(1:kc).eq.comptype(2)(1:kc)) then
        compmode = comptype(2)
      else
        call map_message(seve%e,comm,'No such mode '//argu(1:nc))
        error = .true.
        return
      endif
    endif
    exec_chain = '@ p_show_composite '//compmode
    done = .true.
  case ('FIELDS') 
    if (hprim%loca%size.eq.0 .or. comm.eq.'SHOW') then
      if (themap%nfields.eq.0) then
        call map_message(seve%e,comm,'No Mosaic loaded')
        error = .true.
      else
        exec_chain = '@ p_plot_fields FIELDS'
        done = .true.
      endif
    else
      call create_fields(error)
      if (error) return
      dtype = 'FIELDS'
    endif
  case ('PRIMARY') 
    !! Print *,'Calling Create Fields'
    call create_fields(error)
    if (error) return
    dtype = 'FIELDS'
    !
  case ('SELFCAL')
    is = sic_start(0,2)
    if (is.eq.0) then
      exec_chain = '@ p_show_selfcal '
    else
      exec_chain = '@ p_show_selfcal '//line(is:)
    endif
    done = .true.
  case('MOMENTS') 
    if (sic_present(o_args,2)) then
      call sic_ke(line,o_args,2,argu,nc,.true.,error)
      if (argu(1:1).eq.'?') then
        exec_chain = '@ i_show_moments '//argu
        done = .true.
        return
      endif
    endif
    exec_chain = '@ p_show_moments '
    done = .true.
    do_color = .false. ! ? unclear here...
  case ('NOISE','INTENSITY','STATISTIC','PV')
    if ((sic_narg(o_args).lt.2).and.(dtype.eq.'PV')) then
      exec_chain = '@ p_show_map PV'
      done = .true.
    else
      !
      dnoise = ' '
      istart = 2
      !
      if (sic_present(o_args,2)) then
        call sic_ke(line,o_args,2,argu,nc,.true.,error)
        if (error) return
        if (argu(1:1).eq.'?') then
          if (dtype.eq.'PV') then
            exec_chain = '@ i_show_pv '//argu
          else 
            exec_chain = '@ i_show_noise '//argu
          endif
          done = .true.
          return
        endif
        !
        if (dtype.eq.'PV') then
          narg = sic_narg(0)
          if (narg.eq.5) then
            dnoise = argu
            istart = 3
          else if (narg.ne.4) then
            call map_message(seve%e,comm,'Missing arguments to '//trim(comm)//' PV')
            error = .true.
            return
          endif
        else 
          dnoise = argu
          istart = 3
        endif
      endif
      !
      if (dnoise.eq.' ') then
        !
        ! Fall back on the last displayed or computed image
        if (last_shown.eq.'CLEAN' .or. last_shown.eq.'DIRTY' .or. last_shown.eq.'SKY') then
          dnoise = last_shown
        else  if (hsky%loca%size.ne.0) then
          dnoise = 'SKY'
        else  if (hclean%loca%size.ne.0) then
          dnoise = 'CLEAN'
        else if (hdirty%loca%size.ne.0) then
          dnoise = 'DIRTY'
        else
          call map_message(seve%e,comm,'No SKY, CLEAN or DIRTY image')
          error = .true.
          return
        endif
      endif
      !
      if (dtype.eq.'PV') then
        ! Next argument must be X or Y
        call sic_ke(line,o_args,istart,argu,nc,.true.,error)
        if (error) return
        if (argu.eq.'X') then
          l_axis = 1
        else if (argu.eq.'Y') then
          l_axis = 2
        else
          call map_message(seve%e,comm,'Invalid axis, must be X or Y')
          error = .true.
          return      
        endif
        !
        ! Then Offset along the other X or Y direction
        istart = istart+1
        call sic_r4(line,o_args,istart,soff,.true.,error)   
        if (error) return   
      else
        if (dtype.eq.'NOISE') then
          noise_type = 0
        else if (dtype.eq.'INTENSITY') then
          noise_type = 1
        else if (dtype.eq.'STATISTIC') then
          noise_type = -1
        endif
        !
        ! RMS plus Standard FIRST + LAST ...
        !
        chain = ' -1'   ! Negative noise guess
        if (sic_narg(o_args).ge.istart) then
          ic = 2
          do i=istart, sic_narg(o_args)
            call sic_ch(line,o_args,i,argu,nc,.true.,error)
            chain(ic:) = argu(1:nc)
            ic = ic+nc+2
          enddo
        endif      
      endif
      !   
      call gildas_null(head) 
      if ((dtype.eq.'PV').and.(hpv%gil%ndim.ne.0)) then
        deallocate(hpv%r2d)
        hpv%gil%ndim = 0
        call sic_delvariable('PV',.false.,error)
        error = .false.
      endif
      !
      if (dnoise.eq.'CLEAN') then
        locasize = hclean%loca%size
        if (dtype.eq.'PV') call gdf_copy_header(hclean,head,error)
        head%r3d => dclean
      else if (dnoise.eq.'SKY') then
        locasize = hsky%loca%size
        if (dtype.eq.'PV') call gdf_copy_header(hsky,head,error)
        head%r3d => dsky
      else if (dnoise.eq.'DIRTY') then
        locasize = hdirty%loca%size
        if (dtype.eq.'PV') call gdf_copy_header(hdirty,head,error)
        head%r3d => ddirty
      else if (sic_varexist(dnoise)) then
        locasize = -1
      else
        locasize = 0
      endif
      if (locasize.eq.0) then
        call map_message(seve%e,comm,'No '//trim(dnoise)//' image')
        error = .true.
        return
      endif
      if (dtype.eq.'NOISE'.or.dtype.eq.'INTENSITY'.or.dtype.eq.'STATISTIC') then
        if (comm.eq.'SHOW') then
          exec_chain = '@ p_show_noise '//dnoise//chain
          done = .true.
        else if (comm.eq.'VIEW') then
          exec_chain = '@ p_view_noise '//dnoise//chain
          done = .true.
        endif
      else if (dtype.eq.'PV') then
        if (locasize.eq.-1) then
          call map_message(seve%e,comm,'PV Only valid for DIRTY, CLEAN or SKY')
          error = .true.
          return
        endif
        !
        ! Extract from current data...
        ioff = (soff*pi/180/3600 - head%gil%val(l_axis)) / head%gil%inc(l_axis) + head%gil%ref(l_axis)
        if (ioff.lt.1 .or. ioff.gt.head%gil%dim(l_axis)) then
          call map_message(seve%e,comm,'Offset out of range')
          error = .true.
          return
        endif
        write(mess,'(A,I0,A,F10.2,A,I0)') 'Extracting along Axis ',l_axis,' at Offset ',soff,'", Plane ',ioff
        call map_message(seve%i,comm,mess)
        call gildas_null(hpv)
        if (l_axis.eq.1) then
          call gdf_transpose_header(head, hpv, '231', error)
          hpv%gil%ndim = 2
          allocate(hpv%r2d(hpv%gil%dim(1),hpv%gil%dim(2)),stat=ier)
          hpv%r2d(:,:) = head%r3d(ioff,:,:)
        else
          call gdf_transpose_header(head, hpv, '132', error)
          hpv%gil%ndim = 2
          allocate(hpv%r2d(hpv%gil%dim(1),hpv%gil%dim(2)),stat=ier)
          hpv%r2d(:,:) = head%r3d(:,ioff,:)
        endif
        hpv%gil%dim(3) = 1
        call sic_mapgildas('PV',hpv,error,hpv%r2d)
        exec_chain = '@ p_show_map PV'   
        !
        done = .true.
      endif
    endif
  case ('SUPPORT') 
    if (supportpol%ngon.ge.2) call greg_poly_plot(supportpol,error) 
    done = .true.
  case ('SNR')
    if (the_method%mosaic) then
      exec_chain = '@ p_snr '//comm
      done = .true.
    else
      call map_message(seve%e,comm,trim(comm)//' SNR only available in Mosaic mode')
      error = .true.
    endif
    do_color = .true.
  case ('SPECTRA') 
    argu = ' '
    call sic_ch(line,o_args,2,argu,nc,.false.,error)
    exec_chain = '@ p_spectra '//argu
    done = .true.
  case ('FILENAME') 
    !
    ! General [First [Last]] channel selection
    argu1 = ' '
    call sic_ch(line,o_args,2,argu1,nc,.false.,error)
    argu2 = argu1
    call sic_ch(line,o_args,3,argu2,nc,.false.,error)
    !
    if (file(1:1).eq.'/') then
      chain = 'DISPLAY\LOAD "'//trim(file)//'"'
    else
      chain = 'DISPLAY\LOAD '//trim(file)
    endif
    call exec_command(chain,error)
    if (error) return
    !!    last_shown = ' ' ! May be Needed ???
    !
    chain = 'DATA '//trim(argu1)//' '//trim(argu2)
    if (comm.eq.'SHOW') then
      nt = len_trim(chain)
      if (nt.ne.4) chain(nt+1:) = ' SCALE'  ! Use default scale in this case
      do_loop  = show_side 
      exec_chain = '@ p_show_map '//chain
      show_side = do_loop 
    else if (comm.eq.'INSPECT_3D') then
      exec_chain = '@ p_3view_map '//chain
    else  
      if (iarg.ne.0) then
        call sic_let_logi('IVIEW%DO%WINDOW',.true.,error)
        call sic_let_logi('IVIEW%DO%EXTREMA',.true.,error)
        call sic_let_logi('IVIEW%DO%FLUX',.true.,error)
        call sic_let_logi('IVIEW%DO%LINE',.true.,error)
        error = .false.
      endif
      if (do_nopause) view_do_loop = .false.
      exec_chain = '@ p_view_map '//chain
    endif
    last_shown = 'DATA'
    done = .true.
    do_color = .true.
  case ('SOURCES') 
    call show_sources_comm(line,error)
    done = .true.
  case ('CLEAN') 
    !
    ! Fall back onto SKY if CLEAN does not exist...
    argu = dtype
    call sic_descriptor (argu,descr,found)    ! Checked
    if (.not.found) then
      argu = 'SKY'
      call sic_descriptor (argu,descr,found)    ! Checked
      if (found) then
        dtype = 'SKY'
        call map_message(seve%w,comm,'No CLEAN data, falling back on SKY')
      endif
    endif
    do_color = .true.
  case ('BEAM')
    argu = dtype
    do_color = .true.
  case ('UV_DATA')
    !
    call gildas_null(htmp,type='UVT')
    call uv_buffer_finduv(code) 
    call gdf_copy_header(huv_current,htmp,error)
    call uvdata_select(comm,error)
    if (error) return
    !
    call display_uv(current_uvdata,line,error)
    done = .true.
    do_color = .false.
    ! Reset the previous UV data pointers
    call uv_buffer_resetuv(code) 
    call gdf_copy_header(htmp,huv_current,err)
  case ('COVERAGE')
    ntype = 1
    done = .false.
  case ('KEPLER')
    argu = ' '
    call sic_ch(line,o_args,2,argu,nc,.false.,error)
    exec_chain = '@ p_kepler_show '//argu
    done = .true.  
  case ('SIMULATION') 
    exec_chain = '@ p_simulate show '
    done = .true.  
  case default
    ! Any unknown variable - We must check what sort of data this is
    ! before calling any script (UV or datacube)
    do_color = .true.
    !
    dtype = 'MYDATA'
    call sub_load_var(comm,line,argu,dtype,itype,error)
    if (error) return
    call sic_descriptor (dtype,descr,found)
    !
    do_color = .true.
    if (associated(descr%head)) then    
      descr%head%file = argu
      if (abs(descr%head%gil%type_gdf).eq.abs(code_gdf_uvt)) then  
        ! This is a SHOW UV like plot...
!        argu1 = ' '
!        call sic_ch(line,o_args,2,argu1,nc,.false.,error)
!        argu2 = argu1
!        call sic_ch(line,o_args,3,argu2,nc,.false.,error)
        !
        chain = trim(dtype)//' '//trim(argu1)//' '//trim(argu2)
        call display_uv(chain,line,error)
        done = .true.
        do_color = .false.
      endif
    endif
  end select
  !
  ! Check error status
  if (error) return
  !
  ! In call cases -- Initialize o_dir
  o_dir = o_view_dir
  if (comm.eq.'SHOW') o_dir = o_show_dir
  !
  if (exec_chain.ne.' ') then
    call get_topdir(line,o_dir)
    call exec_program(exec_chain)
  endif
  if (comm.eq.'VIEW') view_do_loop = do_loop
  !
  if (.not.done) then
    if (comm.eq.'VIEW') then
      if (iarg.ne.0) then
        call sic_let_logi('IVIEW%DO%WINDOW',.true.,error)
        call sic_let_logi('IVIEW%DO%EXTREMA',.true.,error)
        call sic_let_logi('IVIEW%DO%FLUX',.true.,error)
      endif
    endif
    ! Display the buffer if not already done
    call display_buffer_sub(comm,ntype,dtype,line,o_args,o_dir,error)
    if (dtype.eq.'CLEAN' .or. dtype.eq.'DIRTY' .or. dtype.eq.'SKY') then
      last_shown = dtype
    else if (dtype.eq.'DATA') then
      last_shown = 'DATA'
    else if (dtype.eq.'MYDATA') then
      last_shown = 'MYDATA'
    endif
    !
  endif
  !
  ! Set the Color LUT if needed
  if (do_color) then
    call sic_get_real('SHOW_COLOR',colour,error)
    if (colour.ne.0) then
      call sic_let_real('COLOR[3]',colour,error)
      call exec_program('@ p_color')
    endif
  endif
  !
  ! Insert command if needed
  if (do_insert) call sic_insert_log(line)
  !
end subroutine display_buffer
!
subroutine display_buffer_sub(comm,ntype,dtype,line,o_args,o_dir,error)
  use gkernel_interfaces
  use imager_interfaces, only : display_uv, cct_integrate, map_message
  use clean_types
  use clean_arrays
  use clean_default
  use gbl_message
  !----------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER support routine for commands SHOW or VIEW Name
  !
  ! Display the specified buffer according to its type
  !!
  !----------------------------------------------------------------------
  character(len=*), intent(in) :: comm  !! Command name SHOW or VIEW
  integer, intent(in)  :: ntype         !! Buffer type
  character(len=*), intent(in) :: dtype !! Buffer name
  character(len=*), intent(in) :: line  !! Command line
  integer, intent(in) :: o_args         !! Where are the arguments ?
  integer, intent(in) :: o_dir          !! /DIRECTORY option location
  logical, intent(out) :: error         !! Logical error flag
  !
  ! Constants
  integer, parameter :: o_view_nopause=2
  integer, parameter :: o_show_cont=1
  integer, parameter :: o_show_over=3
  integer, parameter :: o_view_side=3
  integer, parameter :: o_show_side=4
  !
  ! Local ---
  character(len=40) :: argu1,argu2
  character(len=120) :: chain
  integer :: nc,first,last,ic
  logical :: do_loop, do_cont, cont_do, needed, err
  character(len=12) :: xtype,ytype
  !
  ! Code ----
  !
  ! Load into SIC buffer
  if (comm.eq.'SHOW' .and. ntype.eq.1) then
    !
    ! SHOW Coverage
    call sic_get_inte('FIRST',first,error)
    call sic_get_inte('LAST',last,error)
    call sic_get_char('XTYPE',xtype,nc,error)
    call sic_get_char('YTYPE',ytype,nc,error)
    call sic_let_char('XTYPE','u',error)
    call sic_let_char('YTYPE','v',error)
    if (first.eq.0 .and. last.eq.0) then
      ic = huv_current%gil%nchan/3
      call sic_let_inte('FIRST',ic,error)
      call sic_let_inte('LAST',ic,error)
    endif
    chain = 'UV'
    call display_uv (chain,line,error)
    call sic_let_char('XTYPE',xtype,error)
    call sic_let_char('YTYPE',ytype,error)
    call sic_let_inte('FIRST',first,error)
    call sic_let_inte('LAST',last,error)
    return
  endif
  !
  ! General [First [Last]] channel selection
  argu1 = ' '
  call sic_ch(line,o_args,2,argu1,nc,.false.,error)
  argu2 = argu1
  call sic_ch(line,o_args,3,argu2,nc,.false.,error)
  !
  ! Plot SIC buffer with adequate plotting procedure
  if (comm.eq.'SHOW' .or. comm.eq.'UV_FLAG') then
    if (dtype.eq.'UV_DATA') then
      if (argu1.eq."?" .and. argu2.eq.argu1) then
        call exec_program('@ i_show_uv')
        return
      endif
      chain = 'UV '! //trim(argu1)//' '//trim(argu2)
      call display_uv(chain,line,error)
    else if (dtype.eq.'CCT') then
      if (hcct%loca%size.eq.0) then
        call map_message(seve%e,comm,'No CCT buffer')
        error = .true.
        return
      endif
!      argu1 = ' '
!      call sic_ch(line,o_args,2,argu1,nc,.false.,error)
      call get_topdir(line,o_dir)
      call cct_integrate(comm,hcct,dcct,error)
      call exec_program('@ p_show_cct cct '//argu1)
    else if (dtype.eq.'BEAM' .or. dtype.eq.'FIELDS') then
      !
      ! SHOW BEAM [Field F|Plane P] [First Last]
      ! @ p_show_beam BEAM FIELD 16
      !   or
      ! @ p_show_beam BEAM PLANE 1 [First Last]
      !
      if (dtype.eq.'BEAM') then
        if (hbeam%loca%size.eq.0) then
          call map_message(seve%e,comm,'No BEAM buffer')
          error = .true.
          return
        endif
        needed = .false.
        if (hbeam%gil%ndim.eq.4) then
          needed = (hbeam%gil%dim(4).gt.1).and.(hbeam%gil%dim(3).gt.1)
        endif
      else
        if (hfields%loca%size.eq.0) then
          call map_message(seve%e,comm,'No FIELDS buffer')
          error = .true.
          return
        endif
        needed = .false.
        if (hfields%gil%ndim.eq.4) then
          needed = (hfields%gil%dim(4).gt.1).and.(hfields%gil%dim(3).gt.1)
        endif      
      endif
      if (needed.and.sic_narg(0).lt.3) then
        call map_message(seve%e,comm,'Missing PLANE or FIELD key and number')
        error = .true.
        return
      endif
      argu1 = 'PLANE'
      call sic_ke(line,o_args,2,argu1,nc,needed,error)
      argu2 = '1'
      call sic_ch(line,o_args,3,argu2,nc,needed,error)
      if (error) return
      !      
      call get_topdir(line,o_dir)
      call exec_program('@ p_show_beam '//dtype//trim(argu1)//' '//trim(argu2))
    else
      !
      do_loop = show_side
      if (sic_present(o_show_side,0)) show_side = .true.
      call sic_get_logi('DO_CONTOUR',cont_do,err)
      do_cont = cont_do
      if (sic_present(o_show_over,0)) then
        if (sic_present(o_show_cont,0)) call map_message(seve%w,comm, &
          & "Option /SHOW ignored when /OVERLAY present")
        do_cont = .false.
      else if (sic_present(o_show_cont,0)) then
        do_cont = .true.
        call sic_l4(line,o_show_cont,1,do_cont,.false.,error)
        if (error) return
      endif
      call sic_let_logi('DO_CONTOUR',do_cont,err)
      chain = trim(dtype)//' '//trim(argu1)//' '//trim(argu2)
      if (chain.ne.dtype) then
        nc = len_trim(chain)+2
        chain(nc+2:) = 'SCALE'
      endif
      call get_topdir(line,o_dir)
      call exec_program('@ p_show_map '//chain)
      call sic_let_logi('DO_CONTOUR',cont_do,err)
      show_side = do_loop
      !
    endif
  else if (comm.eq.'VIEW') then
    do_loop = view_do_loop
    select case (dtype)
    case ('UV_DATA')
      return
    case ('BEAM','FIELDS','PRIMARY')
      !
      ! VIEW BEAM|FIELDS|PRIMARY [Field F|Plane P] [First Last]
      ! @ p_view_beam BEAM FIELD 16
      !   or
      ! @ p_view_beam BEAM PLANE 1 
      !
      if (hbeam%loca%size.eq.0) then
        call map_message(seve%e,comm,'No BEAM buffer')
        error = .true.
        return
      endif
      needed = .false.
      if ((hbeam%gil%ndim.eq.4).and.(dtype.eq.'BEAM')) then
        needed = hbeam%gil%dim(4)*hbeam%gil%dim(3) .gt.1
      endif
      if (needed.and.sic_narg(0).lt.3) then
        call map_message(seve%e,comm,'Missing PLANE or FIELD key and number')
        error = .true.
        return
      endif
      argu1 = 'PLANE'
      call sic_ke(line,o_args,2,argu1,nc,needed,error)
      argu2 = '1'
      call sic_ch(line,o_args,3,argu2,nc,needed,error)
      if (error) return
      !      
      if (sic_present(o_view_nopause,0)) view_do_loop = .false.
      chain = '@ p_view_beam '//dtype//trim(argu1)//' '//trim(argu2)
    case ('CCT') 
      if (hcct%loca%size.eq.0) then
        call map_message(seve%e,comm,'No CCT buffer')
        error = .true.
        return
      endif
      call cct_integrate(comm,hcct,dcct,error)
      chain = '@ p_view_cct '//dtype//trim(argu1)//' '//trim(argu2)
    case default
      if (sic_present(o_view_nopause,0)) view_do_loop = .false.
      chain = '@ p_view_map '//dtype//trim(argu1)//' '//trim(argu2)
    end select
    !
    call get_topdir(line,o_dir)
    call exec_program(chain)
    view_do_loop = do_loop
  else if (comm.eq.'INSPECT_3D') then
    if (dtype.eq.'UV_DATA') then
      continue
    else if (dtype.eq.'CCT') then
      continue
    else
      chain = '@ p_3view_map '//dtype//trim(argu1)//' '//trim(argu2)
      call get_topdir(line,o_dir)
      call exec_program(chain)
    endif
  endif
  !
end subroutine display_buffer_sub
!
subroutine create_fields(error)
  use gkernel_interfaces
  use clean_arrays
  use clean_types
  use imager_interfaces, only : define_fields
  !----------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- internal routine for command SHOW FIELDS  
  !
  !     Create the FIELDS array (transposed version of the PRIMARY array)
  !!
  !----------------------------------------------------------------------
  logical, intent(out) :: error  !! Logical error flag
  !
  ! Local variables
  character(len=4) :: code
  integer(kind=index_length) :: nfirst,nsecon,nmiddl,nelems,nlast,iblock(5)
  integer :: ier
  logical :: found
  !
  if (hprim%loca%size.eq.0) then
    error = .true.
    return
  endif
  error = .false.
  !
  ! If it is allocated, it should be the right one, but play safe...
  if (allocated(dfields)) then
    found = .true.
    ! !Print *,'dfiels is already allocated ',hfields%loca%size, hprim%loca%size
    if (hfields%loca%size.ne.hprim%loca%size) then
      ! !Print *,'FIELDS is already allocated ',hfields%loca%size, hprim%loca%size
      ! !Print *,'   but it does not have the right size'
      deallocate(dfields)
      !
      found = .false.
    endif
  else
    ! !Print *,'Dfield not allocated '
    found = .false.
  endif
  !
  call gildas_null(hfields)
  !
  code = '231'
  call gdf_transpose_header(hprim,hfields,code,error)
  ! Determine chunk sizes from code and dimensions.
  call transpose_getblock(hprim%gil%dim,gdf_maxdims,code,iblock,error)
  if (error) return
  !
  ! With only one beam per frequency so far
  if (.not.allocated(dfields)) then
    allocate(dfields(hprim%gil%dim(2),hprim%gil%dim(3),hprim%gil%dim(1),hprim%gil%dim(4)),stat=ier)
    if (ier.ne.0) then
      error = .true.
      return
    endif
  endif
  !
  nelems = iblock(1)
  nfirst = iblock(2)
  nmiddl = iblock(3)
  nsecon = iblock(4)
  nlast  = iblock(5)
  call trans4all(dfields,dprim,nelems,nfirst,nmiddl,nsecon,nlast)
  !
  ! Set Type of First Axis
  hfields%gil%inc(3) = 1.0
  hfields%char%code(3) = 'FIELD'
  !
  ! If array was already there, the variables were there too
  if (found) return
  !
  ! That is a little too much. It also destroys other FIELDS% variables...
  ! FIELDS%N, FIELDS%CENTERS[2,Fields%N], and FIELDS%PRIMARY 
  call sic_delvariable('FIELDS',.false.,error)
  ! So re-create them
  call define_fields(themap,error)  
  call sic_mapgildas ('FIELDS',hfields,error,dfields)
  !
end subroutine create_fields
! 
subroutine get_size_factor(factor)
  use clean_default
  !----------------------------------------------------------------------
  ! @ private
  !* 
  ! IMAGER / VIEWER -- Support for the SET ANGLE_UNIT command
  !
  ! Return the Angle_Unit to User coordinates factor
  !!
  !----------------------------------------------------------------------
  real(kind=8), intent(out) :: factor  !! Scale 
  !
  real(kind=8), parameter :: pi=3.14159265358979323846d0
  real(8), parameter :: bunit(4)=[pi/180d0,pi/180.d0/60d0,pi/180d0/3600d0,1.d0]
  !
  factor = bunit(abs(iangle_unit))
end subroutine get_size_factor
!
subroutine display_set_comm(line,comm,error)
  use gkernel_interfaces
  use clean_types
  use clean_default
  use gbl_message
  use imager_interfaces, only : map_message
  !----------------------------------------------------------------------
  ! @ private
  !* 
  ! IMAGER / VIEWER  
  !      Support for the 
  !         SET ANGLE_UNIT command  
  !         SET TRAIL YES|NO  (keep or ignore Trailing column)  
  !         SET FORMAT GILDAS|FITS  
  !         SET COLOR  DARK|WHITE
  ! Fall back to GREG1\SET command for any other argument
  !!
  !----------------------------------------------------------------------
  character(len=*), intent(inout) :: line  !! Command line
  character(len=*), intent(in) :: comm     !! Command name
  logical, intent(inout) :: error          !! Logical error flag
  !
  ! Constants
  real(kind=8), parameter :: pi=3.14159265358979323846d0
  real(8), parameter :: bunit(4)=[pi/180d0,pi/180.d0/60d0,pi/180d0/3600d0,1.d0]
  character(len=8) :: cdark='DARK', cwhite='WHITE'
  character(len=32) :: avoc(4)
  character(len=24) :: aformat(-1:3)
  character(len=12) :: caunit(0:5), cformat(2), cfits(3)
  data caunit /'ABSOLUTE','DEGREE','MINUTE','SECOND','RADIAN','RELATIVE'/
  data avoc /'ANGLE_UNIT ','COLOR_MODEL','FORMAT','TRAIL'/
  data cformat/'GILDAS','FITS'/
  data cfits  /'NATIVE','VELOCITY','FREQUENCY'/  ! Order matters
  data aformat /'CSV','GILDAS','FITS','FITS VELOCITY','FITS FREQUENCY'/
  !
  ! Memory --
  character(len=8), save :: color_old='WHITE'
  !
  ! Local ---
  character(len=32) :: key, qmark
  character(len=12) :: argu
  integer :: ia,n,nq,ounit, narg
  logical :: default
  real(kind=8) :: factor
  character(len=128) :: myline
  !
  ! Code ----
  default = sic_present(1,0)
  narg = sic_narg(0)
  if (default.and.(narg.eq.0)) then
    ! SET /DEFAULT
    !   Reset GreG and Imager defaults
    ounit = abs(iangle_unit)
    iangle_unit = -3 
    factor = bunit(ounit)/bunit(abs(iangle_unit))
    area_size = area_size*factor
    area_center = area_center*factor
    !
    call gr_exec1('SET /DEFAULT')
    return
  endif
  !
  call sic_ke(line,0,1,key,n,.true.,error)
  if (error) return
  qmark = '?'
  call sic_ke(line,0,2,qmark,nq,.false.,error)
  if (error) return
  !
  if (key(1:n).eq.avoc(1)(1:n)) then
    !
    ounit = abs(iangle_unit)
    !
    if (default.and.(narg.eq.1)) then
      iangle_unit = -3
    else 
      !
      if (qmark.eq.'?')  then
        if (iangle_unit.lt.0) then
          call map_message(seve%i,'SET', &
          &   'Current display angle unit is ABSOLUTE if possible, ' &
          &   //caunit(-iangle_unit)//' otherwise')
        else
          call map_message(seve%i,'SET', &
          &   'Current display angle unit is '//caunit(iangle_unit))
        endif
        return
      else 
        key = qmark
        if (default) call map_message(seve%w,'SET', &
          & '/DEFAULT option ignored with argument')
        !
        call sic_ambigs ('SET ANGLE_UNIT',key,argu,n,caunit,6,error)
        if (error) return
        n = n-1
        if (n.eq.0) then
          iangle_unit = -abs(iangle_unit)
        else if (n.eq.5) then
          iangle_unit =  abs(iangle_unit)
        else
          iangle_unit = n
        endif
      endif
    endif
    !
    ! Reset unit and convert SIZE and CENTER
    factor = bunit(ounit)/bunit(abs(iangle_unit))
    area_size = area_size*factor
    area_center = area_center*factor
    !
    ! Reset all conversion formulas and displayed Units
    call exec_program('@ d_box')
  else if (key(1:n).eq.avoc(2)(1:n)) then
    if (qmark.eq.'?') then
      call map_message(seve%i,'SET COLOR',trim(color_model)//' color model')
    else
      call sic_ke(line,0,2,key,n,.false.,error)
      color_old = color_model
      if (key(1:n).eq.cdark(1:n)) then
        color_model = cdark
      else
        color_model = cwhite
      endif
      if (color_old.ne.color_model) call exec_program('@ gag_pro:set-colors '//color_model)
    endif
  else if (key(1:n).eq.avoc(3)(1:n)) then
    if (qmark.eq.'?') then
      call map_message(seve%i,'SET FORMAT','Current format is '//aformat(write_default))
      call map_message(seve%i,'SET FORMAT','Choices are: GILDAS, FITS, FITS VELOCITY, FITS FREQUENCY')
      return
    endif
    key = qmark
    call sic_ambigs ('SET FORMAT',key,argu,n,cformat,2,error)
    if (error) return
    if (key.eq.'GILDAS') then
      write_default = write_gildas
    else
      key = 'NATIVE'
      call sic_ke(line,0,3,key,n,.false.,error)
      if (error) return
      call sic_ambigs ('SET FORMAT',key,argu,n,cfits,3,error)
      if (error) return
      write_default = n
    endif
  else if (key(1:n).eq.avoc(4)(1:n)) then
    if (qmark.eq.'?') then
      if (read_trail) then
        call map_message(seve%i,'SET TRAIL','YES (trailing columns are read by default)')
      else
        call map_message(seve%i,'SET TRAIL','NO  (trailing columns are ignored)') 
      endif
    else
      call sic_l4(line,0,2,read_trail,.false.,error)
    endif
  else
    ! 
    if (key.eq.'?') then
      call sic_ambigs ('DISPLAY\SET',key,argu,n,avoc,3,error)
    endif
    ! GREG\SET fall back
    ia = index(line,' ') 
    myline = 'GREG1\SET'//line(ia:)
    call exec_command(myline,error)
  endif
end subroutine display_set_comm
!
subroutine get_topdir(line,o_dir)
  use gkernel_interfaces
  !----------------------------------------------------------------
  ! @ private
  !!   IMAGER -- Support routine for option /DIRECTORY of DISPLAY\ commands 
  !!    Create and/or move to the specified root directory
  !----------------------------------------------------------------
  character(len=*), intent(in) :: line  !! Command line
  integer, intent(in) :: o_dir          !! /DIRECTORY option number
  !
  ! Local ---
  character(len=64) :: cdir
  integer :: n
  logical :: error
  !
  ! Code ----
  error = .false.
  if (.not.sic_present(o_dir,1)) then
    call exec_string('GTVL\CHANGE DIRECTORY',error)
  else
    !
    call sic_ke(line,o_dir,1,cdir,n,.true.,error)
    if (error) return
    if (cdir(1:1).ne.'<') then
      cdir = '<'//cdir(1:n)
      n =n+1
    endif
    if (.not.gtexist(cdir(1:n))) then
      call exec_string('GTVL\CREATE DIRECTORY '//cdir(1:n),error)
      if (error) return
    endif
    call exec_string('GTVL\CHANGE DIRECTORY '//cdir(1:n),error)
  endif
end subroutine get_topdir
!

subroutine exec_task (buffer)
  use gildas_def
  use gbl_message
  use sic_interfaces, except_this=>exec_task
  use sic_interactions
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  character(len=*) :: buffer        !
  ! Local
  character(len=*), parameter :: rname='TASK'
  character(len=commandline_length) :: line
  character(len=12) :: lang
  character(len=12) :: comm
  logical :: error
  integer :: icode,ocode
  !
  line = buffer
  icode = code_exec
  goto 10
  !
entry play_task(buffer)
  line = buffer
  icode = code_play
  goto 10
  !
entry enter_task
  icode = code_enter
  goto 10
  !
10 continue
  !
  error = .false.
  do while(.true.)
    call sic_run (line,lang,comm,error,icode,ocode)
    if (ocode.ne.code_next) return
    if (lang.eq.'TASK') then
      call run_task(line,comm,error)
    elseif (lang.eq.'SIC') then
      call run_sic(line,comm,error)
    else
      call sic_message(seve%e,rname,'Language invalid in this context '//lang)
      error = .true.
    endif
    icode = code_run
  enddo
end subroutine exec_task
!
subroutine run_task (line,comm,error)
  use sic_interfaces, except_this=>run_task
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interactions
  !---------------------------------------------------------------------
  ! @ private-mandatory (because symbol is used elsewhere)
  ! Dispatch the command line
  ! Arguments :
  ! LINE  C*(*) Command line      Input/Output
  ! COMM  C*(*) Command       Input
  !---------------------------------------------------------------------
  character(len=*)              :: line   !
  character(len=*)              :: comm   !
  logical,          intent(out) :: error  ! Logical error flag
  !
  call sic_message(seve%c,'TASK',line)
  !
  error = .false.
  if (comm.eq.'GO') then
    tabort = .false.
    if (x_window) then
      call xgag_go(line,tabort)
      call xgag_wait
      call xgag_end(1,tabort)
      call end_dialog
    endif
  elseif (comm.eq.'CHARACTER') then
    call tchars (line,error)
  elseif (comm.eq.'FILE') then
    call tfiles (line,error)
  elseif (comm.eq.'REAL') then
    call treals (line,error)
  elseif (comm.eq.'INTEGER') then
    call tintes (line,error)
  elseif (comm.eq.'LOGICAL') then
    call tlogis (line,error)
  elseif (comm.eq.'VALUES') then
    call tvalue (line,error)
  elseif (comm.eq.'WRITE') then
    call twrite (line,error)
  elseif (comm.eq.'HELP') then
    call thelp (line,error)
  elseif (comm.eq.'MORE') then
    call tmore (line,error)
  else
    call sic_message(seve%e,'TASK','No code for '//comm)
    error = .true.
  endif
end subroutine run_task
!
function err_task (dummy)
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  logical :: err_task               !
  logical :: dummy                  !
  err_task = .false.
end function err_task
!
subroutine load_task
  use sic_interfaces, except_this=>load_task
  use gildas_def
  use sic_interactions
  use gbl_message
  use sic_dependencies_interfaces
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  ! Local
  character(len=*), parameter :: vers='3.0    10-Apr-2016   S.Guilloteau'
  character(len=4) :: cccc
  integer :: ier
  ! Language
  integer, parameter :: mtask=19
  character(len=12) :: vocab(mtask)
  ! Does order matter ?
  data vocab /                                        &
    '#GO',                                            &
    ' HELP',                                          &
    ' WRITE',                                         &
    ' LOGICAL',                                       &
    ' INTEGER',   '/RANGE','/INDEX','/CHOICE',        &
    ' REAL',      '/RANGE','/SEXAGESIMAL','/CHOICE',  &
    ' CHARACTER', '/CHOICE',                          &
    ' FILE',      '/OLD','/NEW',                      &
    ' MORE',     ' VALUES' /
  !
  call sic_begin('TASK','GAG_HELP_TASK',-mtask,vocab,vers,run_task,err_task)
  ier = sic_getlun (tlun)
  if (mod(ier,2).eq.0) then
    call sic_message(seve%f,'TASK','Error allocating unit for parameter file')
    call sysexi (fatale)
  endif
  ! Retrieves the default extension for tasks names on the current system
  call executable_extension(cccc)
  ! Add a leading point if extension is not nil.
  if (cccc.ne.' ') then
    taskext = '.'//cccc
  else
    taskext = ' '
  endif
end subroutine load_task
!
subroutine exit_task(error)
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>exit_task
  use sic_interactions
  !---------------------------------------------------------------------
  ! @ private
  !  Clean the TASK-related components
  !---------------------------------------------------------------------
  logical, intent(inout) :: error  ! Logical error flag
  !
  call sic_frelun(tlun)
  !
end subroutine exit_task
!
subroutine treals (line,error)
  use sic_dependencies_interfaces
  use gildas_def
  use sic_interactions
  use sic_interfaces, except_this=>treals
  use sic_types
  use gbl_format
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! GILDAS  Support routine for command
  ! TASK\REAL "Prompt text" Name = [Value]
  !
  ! Define a parameter of specified type (Real, Integer, Logical,
  ! Character, or File) name, and assign it a value if specified.
  ! Otherwise, prompt with the text for a value.
  !---------------------------------------------------------------------
  character(len=*)                :: line   !
  logical,          intent(inout) :: error  !
  ! Local
  character(len=*), parameter :: rname='TASK'
  integer :: nline,iarg,ntype,nc,ndim,i,j,np,iopt,istat
  integer(kind=index_length) :: dim(1)
  integer :: status,ier,jopt
  character(len=12) :: comm
  character(len=12) :: ctype
  character(len=32) :: name,cname
  character(len=4) :: equal
  character(len=80) :: invite
  logical :: translate,found
  integer :: lt,nk,type
  character(len=commandline_length) :: chain
  character(len=filename_length) :: expr,string
  character(len=64) :: variab
  real(8) :: r8
  type(sic_descriptor_t) :: descr
  integer(kind=address_length) :: ipnt
  integer(kind=1) :: membyt(1)
  !
  ntype = 1
  translate = .false.  ! Not used in this context
  ctype = 'REAL'
  iopt = 0
  if (sic_present(1,0)) then   ! /RANGE
    jopt = 1
  else
    jopt = 0
  endif
  if (sic_present(2,0)) then
    if (jopt.eq.1) goto 99
    jopt=2                     ! /SEXAGESIMAL
  endif
  if (sic_present(3,0)) then
    if (jopt.gt.0) goto 99
    jopt=3                     ! /CHOICE
  endif
  goto 10
  !
entry tintes (line,error)
  ntype = 2
  translate = .false.  ! Not used in this context
  ctype = 'INTEGER'
  iopt = 0
  if (sic_present(1,0)) then   ! /RANGE
    jopt = 1
  else
    jopt = 0
  endif
  if (sic_present(2,0)) then
    if (jopt.eq.1) goto 99
    jopt=2                     ! /INDEX
  endif
  if (sic_present(3,0)) then
    if (jopt.gt.0) goto 99
    jopt=3                     ! /CHOICE
  endif
  goto 10
  !
entry tlogis (line,error)
  ntype = 3
  translate = .false.  ! Not used in this context
  ctype = 'LOGICAL'
  iopt = 0
  jopt = 0
  goto 10
  !
entry tchars (line,error)
  ntype = 4
  translate = .false.
  ctype = 'CHARACTER'
  iopt = 0
  if (sic_present(1,0)) then   ! /CHOICE
    jopt = 1
  else
    jopt = 0
  endif
  goto 10
  !
entry tvalue (line,error)
  ntype = 5  ! Write a string
  translate = .false.
  ctype = 'VALUES'
  iopt = 0
  jopt = 0
  goto 10
  !
entry tfiles (line,error)
  ! Similar to characters, but logical names are translated.
  istat= 0
  ntype = 4
  translate = .true.
  ctype = 'FILE'
  jopt = 0
  ! OLD files
  iopt = 0
  if (sic_present(1,0)) then
    if (.not.sic_present(0,2)) iopt = 1
    istat = -1
    ! NEW files
  elseif (sic_present(2,0)) then
    if (.not.sic_present(0,2)) iopt = 2
    istat = +1
  else
    istat = 0
  endif
  goto 10
  !
  ! Get parameter name
10 if (npar.ge.mpar) goto 97
  call sic_ke (line,iopt,2,name,nc,.true.,error)
  if (error) return
  cname = name
  i = index(name,'[')
  if (i.ne.0) then
    if (ntype.eq.5) then
      call sic_message(seve%e,rname,'VALUES cannot have dimensions '//name)
      error = .true.
      return
    endif
    !
    j = index(name,']')
    !
    ! the following line forces a correct read with the I20 edit descriptor on IBM
    ! (the variable-length format is not apparently in the f77 norm)
    name(j:) = ','
    read (name(i+1:),*,iostat=ier) ndim
    if (ier.ne.0) then
      call sic_get_inte(name(i+1:j-1),ndim,error)
      if (error) goto 98
    endif
    ndim = ndim-1
    dim(1) = ndim+1
    ! then we clean the line
    name(i:) = ' '
  else
    ndim = 0
  endif
  npar  = npar+1
  tname(npar) = name
  ttype(npar) = ntype+10*ndim
!!  if (ntype.eq.5) ttype(npar) = 4 ! VALUES string
  !
  ! Define a SIC variable of specified type
  if (ntype.eq.1) then
    nreal = nreal + ndim + 1
    if (nreal.gt.mreal) goto 97
    tnumb(npar) = nreal
    if (ndim.ne.0) then
      call sic_def_dble (name,treal(nreal-ndim),1,dim,.false.,error)
    else
      call sic_def_dble (name,treal(nreal),0,dim,.false.,error)
    endif
  elseif (ntype.eq.2) then
    ninte = ninte + ndim + 1
    if (ninte.gt.minte) goto 97
    tnumb(npar) = ninte
    if (ndim.ne.0) then
      call sic_def_long (name,tinte(ninte-ndim),1,dim,.false.,error)
    else
      call sic_def_long (name,tinte(ninte),0,dim,.false.,error)
    endif
  elseif (ntype.eq.3) then
    nlogi = nlogi + ndim + 1
    if (nlogi.gt.mlogi) goto 97
    tnumb(npar) = nlogi
    if (ndim.eq.0) then
      call sic_def_logi (name,tlogi(nlogi),.false.,error)
    endif
  else
    nchar = nchar + ndim + 1
    if (nchar.gt.mchar) goto 97
    tnumb(npar) = nchar
    if (ndim.eq.0) then
      call sic_def_char (name,tchar(nchar),.false.,error)
    else
      call sic_def_charn (name,tchar(nchar-ndim),1,dim,.false.,error)
    endif
  endif
  if (error) then
    npar = npar-1
    return
  endif
  !
  ! Check for = sign and ignore it
  iarg = 3
  if (sic_present(iopt,iarg)) then
    equal = line(sic_start(iopt,iarg):sic_end(iopt,iarg))
    if (equal.eq.'=') iarg = iarg+1
  endif
  !
  ! Get prompt
  call sic_ch (line,iopt,1,invite,nc,.true.,error)
  if (error) goto 96
  tprom(npar) = invite(1:nc)
  !
  ! Check for X-Window mode
  if (x_window) then
    !
    np = sic_start(iopt,iarg)
    if (np.eq.0) then
      chain = 'LET '//name//'/PROMPT "'//invite(1:nc)//'"'
    else
      nk = sic_end(iopt,sic_narg(iopt))+1
      nk = max(np,nk)
      chain = 'LET '//trim(name)//' '//line(np:nk)//'/PROMPT "'//  &
      invite(1:nc)//'"'
    endif
    nc = len_trim(chain)
    !     Treat peculiar options:
    if (ctype.eq.'REAL') then
      if (jopt.eq.1) then
        chain(nc+1:)  = " /RANGE "
        nc=nc+8
        !     Look for /RANGE option for integer
        np = sic_start(1,1)
        nk = sic_end(1,sic_narg(1))+1
        chain(nc+1:)  = line(np:nk)
        nc = len_trim(chain)
      elseif (jopt.eq.2) then
        chain(nc+1:)  = " /SEXAGESIMAL "
        nc=nc+14
      elseif (jopt.eq.3) then
        chain(nc+1:)  = " /CHOICE "
        nc=nc+9
        !     Look for /CHOICE option for real
        np = sic_start(3,1)
        nk = sic_end(3,sic_narg(3))+1
        chain(nc+1:)  = line(np:nk)
        nc = len_trim(chain)
      endif
    elseif (ctype.eq.'INTEGER') then
      if (jopt.eq.1) then
        chain(nc+1:)  = " /RANGE "
        nc=nc+8
        !     Look for /RANGE option for integer
        np = sic_start(1,1)
        nk = sic_end(1,sic_narg(1))+1
        chain(nc+1:)  = line(np:nk)
        nc = len_trim(chain)
      elseif (jopt.eq.2) then
        chain(nc+1:)  = " /INDEX "
        nc=nc+8
        !     Look for /INDEX option for integer
        np = sic_start(2,1)
        nk = sic_end(2,sic_narg(2))+1
        chain(nc+1:)  = line(np:nk)
        nc = len_trim(chain)
      elseif (jopt.eq.3) then
        chain(nc+1:)  = " /CHOICE "
        nc=nc+9
        !     Look for /CHOICE option for integer
        np = sic_start(3,1)
        nk = sic_end(3,sic_narg(3))+1
        chain(nc+1:)  = line(np:nk)
        nc = len_trim(chain)
      endif
    elseif (ctype.eq.'CHARACTER') then
      !     Look for /CHOICE option for character strings
      if (jopt.eq.1) then
        np = sic_start(1,0)-1
        nk = sic_end(1,sic_narg(1))+1
        chain(nc+1:)  = line(np:nk)
        nc = len_trim(chain)
      endif
    elseif (ctype.eq.'FILE') then    !Automatically add the browser
      chain(nc+1:)  = " /FILE "
      nc=nc+7
    elseif (ctype.eq.'VALUES') then
      chain(nc+1:)  = " /NOQUOTE "
      nc=nc+10
    endif
    !
    call sic_blanc    (chain,nc)
    call sic_analyse  (comm,chain,nc,error)
    call xgag_variable(chain,nc,error)
    return
  endif
  !
  ! Check array argument IARG
  found = .false.
  if (ndim.ne.0 .and. sic_narg(iopt).eq.iarg) then
    call sic_ch (line,iopt,iarg,variab,nc,.true.,error)
    call sic_descriptor(variab,descr,found)    ! Checked
    if (found) then
      if (descr%dims(1).ne.ndim+1) found = .false.
    endif
    if (found) then
      type = descr%type
      ipnt = bytpnt(descr%addr,membyt)
      if (type.eq.fmt_r4) then
        if (ntype.eq.1) then
          call r4tor8(membyt(ipnt),treal(nreal-ndim),ndim+1)
        else
          found = .false.
        endif
      elseif (type.eq.fmt_r8) then
        if (ntype.eq.1) then
          call r8tor8(membyt(ipnt),treal(nreal-ndim),ndim+1)
        else
          found = .false.
        endif
      elseif (type.eq.fmt_i4) then
        if (ntype.eq.2) then
          call i4toi8(membyt(ipnt),tinte(ninte-ndim),ndim+1)
        elseif (ntype.eq.1) then
          call i4tor8(membyt(ipnt),treal(nreal-ndim),ndim+1)
        else
          found = .false.
        endif
      elseif (type.eq.fmt_i8) then
        if (ntype.eq.2) then
          call i8toi8(membyt(ipnt),tinte(ninte-ndim),ndim+1)
        elseif (ntype.eq.1) then
          call i8tor8(membyt(ipnt),treal(nreal-ndim),ndim+1)
        else
          found = .false.
        endif
      elseif (type.eq.fmt_l) then
        if (ntype.eq.3) then
          call l4tol4(membyt(ipnt),tlogi(nlogi-ndim),ndim+1)
        else
          found = .false.
        endif
      else
        found = .false.
      endif
    endif
  endif
  if (found) return
  !
  ! If not enough arguments, prompt for text
  if (.not.sic_present(iopt,iarg+ndim)) then
    write (*,'(A)') invite(1:nc)
    nline = len_trim(line)+1
20  call sic_wprn (ctype//cname//' = ',line(nline+1:),nc)
    if (nc.eq.0) goto 96
    !
    ! Check for help
    if (line(nline+1:nline+nc).eq.'?') then
      call tkeys(tprog,tname(npar))
      goto 20
    endif
    nline = min(nline+nc,len(line))
    call sic_blanc (line,nline)
    call sic_analyse (comm,line,nline,error)
    if (error) goto 96
  endif
  !
  ! Now assign the value
  if (ntype.eq.5) then  ! Values
    lt = 1
    string = ' '
    expr = ' '
    do i=iarg,sic_narg(iopt) !!,ndim
    !
    ! Get the string
      nc = 0
      error = .false.
      call sic_ch (line,iopt,i,expr,nc,.true.,error)
      ! the evaluate the expression
      r8 = 0.0
      call sic_math_dble (expr,nc,r8,error)
      if (error) goto 96
      call sic_dble_to_string(r8,string)
      !
      ! Add to argument string
      tchar(nchar)(lt:) = string
      lt = len_trim(tchar(nchar))+2
    enddo
    !
  else if (ntype.eq.4) then
    do i=0,ndim
      call sic_ch (line,iopt,iarg+i,tchar(nchar+i-ndim),nc,.true.,error)
      if (error) goto 96
      if (translate) status = parse_file(tchar(nchar+i-ndim),istat)
    enddo
  elseif (ntype.eq.3) then
    do i=0,ndim
      call sic_l4 (line,iopt,iarg+i,tlogi(nlogi+i-ndim),.true.,error)
      if (error) goto 96
    enddo
  elseif (ntype.eq.2) then
    do i=0,ndim
      call sic_i8 (line,iopt,iarg+i,tinte(ninte+i-ndim),.true.,error)
      if (error) goto 96
    enddo
  else
    do i=0,ndim
      call sic_r8 (line,iopt,iarg+i,treal(nreal+i-ndim),.true.,error)
      if (error) goto 96
    enddo
  endif
  return
  !
96 continue
  call sic_delvariable(tname(npar),.false.,error)
  npar = npar-1
  error = .true.
  return
99 call sic_message(seve%e,rname,'Incompatible options')
  error = .true.
  return
97 call sic_message(seve%e,rname,'Too many parameters')
  error = .true.
  return
98 call sic_message(seve%e,rname,'Invalid dimension '//name(i+1:j+1))
  error = .true.
  return
end subroutine treals
!
subroutine twrite(line,error)
  use sic_interfaces, except_this=>twrite
  use sic_interactions
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! GILDAS  Support routine for command
  ! TASK\WRITE Parameter
  !---------------------------------------------------------------------
  character(len=*)                :: line   !
  logical,          intent(inout) :: error  !
  ! Local
  integer :: i,j,ndim,ntype,nc
  character(len=16) :: name
  !
  call sic_ke (line,0,1,name,nc,.true.,error)
  if (error) return
  do i=1,npar
    if (name.eq.tname(i)) then
      ndim =ttype(i)/10
      ntype=ttype(i)-10*ndim
      write(tlun,'(A)') name
      if (ntype.eq.5) then
        write(tlun,'(A)') ( tchar(j)(1:len_trim(tchar(j))), j=tnumb(i)-ndim,tnumb(i) )
      else if (ntype.ge.4) then
        write(tlun,'(A)') ( tchar(j)(1:len_trim(tchar(j))), j=tnumb(i)-ndim,tnumb(i) )
      elseif (ntype.eq.3) then
        write(tlun,*)     ( tlogi(j),       j=tnumb(i)-ndim,tnumb(i) )
      elseif (ntype.eq.2) then
        write(tlun,*)     ( tinte(j),       j=tnumb(i)-ndim,tnumb(i) )
      else
        write(tlun,*)     ( treal(j),       j=tnumb(i)-ndim,tnumb(i) )
      endif
      return
    endif
  enddo
  call sic_message(seve%e,'TASK','Undefined parameter '//name)
  error = .true.
end subroutine twrite
!
subroutine tmore(line,error)
  use sic_interfaces, except_this=>tmore
  use sic_interactions
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  character(len=*) :: line          !
  logical :: error                  !
  ! Local
  character(len=1), parameter :: backslash=char(92)
  integer :: nt
  character(len=12) :: bouton,comm
  character(len=24) :: option
  character(len=64) :: texte
  !
  error = .false.
  !
  if (x_window) then
    bouton = 'Go'//char(0)
    comm = 'TASK'//backslash//'GO'//char(0)
    call sic_ch (line,0,1,texte,nt,.true.,error)
    if (error) return
    option = 'Parameters ...'//char(0)
    call xgag_more (bouton,comm,texte,option)
  endif
end subroutine tmore
!
subroutine thelp(line,error)
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>thelp
  !---------------------------------------------------------------------
  ! @ private
  ! Support routine for command:
  !   TASK\HELP  [TaskName [VarName]]
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line   ! Input command line
  logical,          intent(inout) :: error  !
  ! Local
  character(len=80) :: tname,vname
  integer(kind=4) :: nc
  !
  ! Parse task name
  tname = ' '
  call sic_ch (line,0,1,tname,nc,.false.,error)
  if (error) return
  !
  ! Parse variable name
  vname = ' '
  call sic_ch (line,0,2,vname,nc,.false.,error)
  if (error) return
  !
  call help_run(tname,vname,1,error)
  if (error)  return
  !
end subroutine thelp

!-----------------------------------------------------------------------
! First in this file, the subroutines which interact with the SIC
! symbols table. Then, the generic subroutines with interact with any
! symbol dictionary.
!-----------------------------------------------------------------------
!
subroutine sic_setsymbol(symb,tran,error)
  use gbl_message
  use sic_interfaces, except_this=>sic_setsymbol
  use sic_dictionaries
  use sic_interactions
  !---------------------------------------------------------------------
  ! @ public
  !   Add a new entry in the SIC symbol table
  !---------------------------------------------------------------------
  character(len=*), intent(in)  :: symb   ! Symbol name
  character(len=*), intent(in)  :: tran   ! Symbol translation
  logical,          intent(out) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='SYMBOL'
  !
  if (.not.loaded) then
    call sic_message(seve%e,rname,'SIC is not loaded')
    error = .true.
    return
  endif
  !
  call sic_symdict_set(symbols,symb,tran,error)
  if (error)  return
  !
  error = .false.
  !
end subroutine sic_setsymbol
!
subroutine sic_getsymbol(symb,tran,error)
  use sic_interfaces, except_this=>sic_getsymbol
  use sic_dictionaries
  !---------------------------------------------------------------------
  ! @ public-mandatory (because symbol is used elsewhere)
  ! Get a symbol definition from the SIC symbol table
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: symb   ! Symbol name
  character(len=*), intent(out)   :: tran   ! Symbol translation
  logical,          intent(inout) :: error  ! Logical error flag
  !
  call sic_symdict_get(symbols,symb,tran,error)
  if (error)  return
  !
end subroutine sic_getsymbol
!
subroutine sic_delsymbol(symb,error)
  use sic_interfaces, except_this=>sic_delsymbol
  use sic_dictionaries
  !---------------------------------------------------------------------
  ! @ private
  ! Remove a symbol from the SIC symbol table
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: symb   ! Symbol name
  logical,          intent(inout) :: error  ! Logical error flag
  !
  call sic_symdict_del(symbols,symb,error)
  if (error)  return
  !
end subroutine sic_delsymbol
!
subroutine sic_inisymbol(error)
  use sic_interfaces, except_this=>sic_inisymbol
  use sic_dictionaries
  !---------------------------------------------------------------------
  ! @ private
  ! Initialize the SIC symbol table
  !---------------------------------------------------------------------
  logical, intent(inout) :: error  ! Logical error flag
  !
  call sic_symdict_init(symbols,maxsym,error)
  !
end subroutine sic_inisymbol
!
subroutine sic_freesymbol(error)
  use sic_interfaces, except_this=>sic_freesymbol
  use sic_dictionaries
  !---------------------------------------------------------------------
  ! @ private
  ! Clean the SIC symbol table
  !---------------------------------------------------------------------
  logical, intent(inout) :: error  ! Logical error flag
  !
  call sic_symdict_free(symbols,error)
  !
end subroutine sic_freesymbol
!
!-----------------------------------------------------------------------
! Below this point, all the generic subroutines which work on any
! dictionary of type 'sic_symdict_t'
!-----------------------------------------------------------------------
!
subroutine sic_symdict_init(dict,msym,error)
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_symdict_init
  use sic_types
  !---------------------------------------------------------------------
  ! @ private
  !  Initialize any dictionary of type 'sic_symdict_t'
  !---------------------------------------------------------------------
  type(sic_symdict_t), intent(out)   :: dict   !
  integer(kind=4),     intent(in)    :: msym   ! Maximum number of elements
  logical,             intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='SYMBOL'
  integer(kind=4) :: ier
  !
  allocate(dict%name(msym),    &
           dict%trans(msym),   &
           dict%ltrans(msym),  &
           dict%pn(msym),stat=ier)
  if (ier.ne.0) then
    call sic_message(seve%e,rname,'Failed to allocate symbol arrays')
    error = .true.
    return
  endif
  !
  call gag_hasini(msym,dict%pf,dict%pn)
  !
  dict%msym = msym
  !
end subroutine sic_symdict_init
!
subroutine sic_symdict_free(dict,error)
  use gbl_message
  use sic_interfaces, except_this=>sic_symdict_free
  use sic_types
  !---------------------------------------------------------------------
  ! @ private
  ! Clean any dictionary of type 'sic_symdict_t'
  !---------------------------------------------------------------------
  type(sic_symdict_t), intent(inout) :: dict   !
  logical,             intent(inout) :: error  !
  ! Local
  character(len=*), parameter :: rname='SYMBOL'
  integer(kind=4) :: ier
  !
  dict%msym = 0
  !
  deallocate(dict%name,    &
             dict%trans,   &
             dict%ltrans,  &
             dict%pn,stat=ier)
  if (ier.ne.0) then
    call sic_message(seve%e,rname,'Failed to deallocate symbol arrays')
    error = .true.
    return
  endif
  !
end subroutine sic_symdict_free
!
subroutine sic_symdict_set(dict,symb,tran,error)
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_symdict_set
  use sic_types
  !---------------------------------------------------------------------
  ! @ private
  !  Add a new entry in the input symbol dictioanry
  !---------------------------------------------------------------------
  type(sic_symdict_t), intent(inout) :: dict   !
  character(len=*),    intent(in)    :: symb   ! Symbol name
  character(len=*),    intent(in)    :: tran   ! Symbol translation
  logical,             intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='SYMBOL'
  character(len=symbol_length) :: name
  integer(kind=4) :: lt,in,ier,kname,kstar
  character(len=message_length) :: mess
  !
  ! Define abbreviation
  lt = len_trim(tran)
  if (lt.gt.translation_length) then
    call sic_message(seve%e,rname,'Symbol definition too long')
    error = .true.
    return
  endif
  !
  ! Insert or replace in symbol dictionnary
  kstar = index(symb,'*')
  if (kstar.ne.0) then
    kstar = kstar-1
    name = symb(1:kstar)//symb(kstar+2:)
    kname = len_trim(symb)-1  ! Length of 'symb' (less the wilcard) for length check below
  else
    name = symb
    kname = len_trim(symb)  ! Length of 'symb' for length check below
  endif
  call sic_upper(name)
  !
  ! Reject symbols larger than symbol_length (should have been truncated
  ! before if required), not taking into account the wildcard
  if (kname.gt.symbol_length) then
    write(mess,'(A,A,A,I2,A)') "Symbol name '",name,  &
      "' too long (max ",symbol_length," chars)"
    call sic_message(seve%e,rname,mess)
    error = .true.
    return
  endif
  !
10 continue
  ier = gag_hasins(dict%msym,dict%pf,dict%pn,dict%name,name(1:kname),in)
  if (ier.eq.0) then
    call sic_message(seve%e,rname,'Invalid symbol name '//name)
    error = .true.
    return
  elseif (ier.eq.2) then
    call sic_message(seve%e,rname,'Too many symbols')
    error = .true.
    return
  endif
  !
  ! Put into symbol table
  dict%trans(in) = tran
  dict%ltrans(in) = lt
  !
  ! Loop if a stared symbol was used
  kname = kname-1
  if (kname.ge.kstar .and. kstar.ne.0) goto 10
  !
end subroutine sic_symdict_set
!
subroutine sic_symdict_get(dict,symb,tran,error)
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_symdict_get
  use sic_types
  !---------------------------------------------------------------------
  ! @ private
  ! Get a symbol definition
  !---------------------------------------------------------------------
  type(sic_symdict_t), intent(inout) :: dict   !
  character(len=*),    intent(in)    :: symb   ! Symbol name
  character(len=*),    intent(out)   :: tran   ! Symbol translation
  logical,             intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=symbol_length) :: name
  integer(kind=4) :: in,ier
  !
  name = symb
  call sic_upper(name)
  ier = gag_hasfin(dict%msym,dict%pf,dict%pn,dict%name,name,in)
  if (ier.ne.1) then
    error = .true.
  else
    tran = dict%trans(in)(1:dict%ltrans(in))
  endif
  !
end subroutine sic_symdict_get
!
subroutine sic_symdict_del(dict,symb,error)
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_symdict_del
  use sic_types
  !---------------------------------------------------------------------
  ! @ private
  ! Remove a symbol from the input dictionary
  !---------------------------------------------------------------------
  type(sic_symdict_t), intent(inout) :: dict   !
  character(len=*),    intent(in)    :: symb   ! Symbol name
  logical,             intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='SYMBOL'
  integer(kind=4) :: kstar,kname,ier
  character(len=symbol_length) :: name
  !
  kstar = index(symb,'*')
  if (kstar.ne.0) then
    kstar = kstar-1
    name = symb(1:kstar)//symb(kstar+2:)
  else
    name = symb
  endif
  call sic_upper(name)
  kname = len_trim(name)
  !
20 ier = gag_hasdel(dict%msym,dict%pf,dict%pn,dict%name,name(1:kname))
  if (ier.ne.1) then
    call sic_message(seve%e,rname,'Undefined symbol '//name)
    error = .true.
  endif
  !
  ! Loop if a stared symbol was used
  kname = kname-1
  if (kname.ge.kstar .and. kstar.ne.0) goto 20
  !
end subroutine sic_symdict_del

function sic_get_arg_count()
  !---------------------------------------------------------------------
  ! @ public
  !---------------------------------------------------------------------
  integer(kind=4) :: sic_get_arg_count  !  Function value on return
  ! Local
  integer(kind=4) :: iargc
  !
  sic_get_arg_count = iargc()  ! This is a GNU F77 extension...
end function sic_get_arg_count
!
subroutine sic_get_arg(n,arg)
  use gsys_interfaces, except_this=>sic_get_arg
  !---------------------------------------------------------------------
  ! @ public
  !   This machine dependent function retrieves the Nth argument of
  ! command line.
  !---------------------------------------------------------------------
  integer(kind=4),  intent(in)  :: n    ! Argument index
  character(len=*), intent(out) :: arg  ! Argument value
  ! Local
  integer(kind=4) :: narg
  !
  narg = sic_get_arg_count()
  !
  if (n.lt.1.or.n.gt.narg) then
    arg = ''
    return
  endif
  !
  call getarg(n,arg)  ! This is a GNU F77 extension...
  !
end subroutine sic_get_arg

subroutine equ_to_gal(ra,dec,raoff,decoff,equinox,l,b,loff,boff,error)
  use gbl_constant
  use gbl_message
  use gwcs_interfaces, except_this=>equ_to_gal
  !---------------------------------------------------------------------
  ! @ public
  !  Convert 1 position + 1 offset from Equatorial+Equinox to Galactic
  !---------------------------------------------------------------------
  real(kind=8), intent(in)    :: ra       !
  real(kind=8), intent(in)    :: dec      !
  real(kind=4), intent(in)    :: raoff    !
  real(kind=4), intent(in)    :: decoff   !
  real(kind=4), intent(in)    :: equinox  !
  real(kind=8), intent(out)   :: l        !
  real(kind=8), intent(out)   :: b        !
  real(kind=4), intent(out)   :: loff     !
  real(kind=4), intent(out)   :: boff     !
  logical,      intent(inout) :: error    !
  ! Local
  real(kind=8) :: oldcoord(2),incoord(2),outcoord(2),matrix(3,3)
  real(kind=4) :: oldin,oldout,inoff(2),outoff(2)
  save oldin,oldout,matrix,oldcoord,outcoord
  ! Data
  data oldin/0.0/, oldout/-1.0/
  !
  if (equinox.eq.equinox_null) then
    call gwcs_message(seve%e,'SYSTEM',  &
      'Cannot convert from EQUATORIAL with unknown Equinox to GALACTIC')
    error = .true.
    return
  endif
  !
  incoord(1) = ra
  incoord(2) = dec
  inoff(1) = raoff
  inoff(2) = decoff
  if (oldin.ne.equinox .or. oldout.ne.0.0) then
    call chgcoo ('EQ','GA',equinox,0.0,matrix)
    oldin = equinox
    oldout = 0.0
    call chgref (matrix,incoord,outcoord)
  elseif (incoord(1).ne.oldcoord(1) .or. incoord(2).ne.oldcoord(2)) then
    call chgref (matrix,incoord,outcoord)
  endif
  oldcoord(1) = incoord(1)
  oldcoord(2) = incoord(2)
  if (inoff(1).ne.0.0 .or. inoff(2).ne.0.0) then
    call chgoff (matrix,incoord,inoff,outcoord,outoff)
  else
    outoff(1)=0.0
    outoff(2)=0.0
  endif
  l = outcoord(1)
  b = outcoord(2)
  loff = outoff(1)
  boff = outoff(2)
end subroutine equ_to_gal
!
subroutine equ_gal_0d(ra,dec,equinox,l,b,error)
  use gbl_constant
  use gbl_message
  use gwcs_interfaces, except_this=>equ_gal_0d
  !---------------------------------------------------------------------
  ! @ public-generic equ_gal
  !  Convert 1 position from Equatorial+Equinox to Galactic
  !  Scalar version
  !---------------------------------------------------------------------
  real(kind=8),    intent(in)    :: ra       !
  real(kind=8),    intent(in)    :: dec      !
  real(kind=4),    intent(in)    :: equinox  !
  real(kind=8),    intent(out)   :: l        !
  real(kind=8),    intent(out)   :: b        !
  logical,         intent(inout) :: error    !
  ! Local
  real(kind=8) :: ra1(1),dec1(1),l1(1),b1(1)
  !
  ra1(1) = ra
  dec1(1) = dec
  call equ_gal_1d(ra1,dec1,equinox,l1,b1,1,error)
  if (error)  return
  l = l1(1)
  b = b1(1)
  !
end subroutine equ_gal_0d
!
subroutine equ_gal_1d(ra,dec,equinox,l,b,n,error)
  use gbl_constant
  use gbl_message
  use gwcs_interfaces, except_this=>equ_gal_1d
  !---------------------------------------------------------------------
  ! @ public-generic equ_gal
  !  Convert 1 position from Equatorial+Equinox to Galactic
  !  1D-array version
  !---------------------------------------------------------------------
  integer(kind=4), intent(in)    :: n         !
  real(kind=8),    intent(in)    :: ra(n)     !
  real(kind=8),    intent(in)    :: dec(n)    !
  real(kind=4),    intent(in)    :: equinox   !
  real(kind=8),    intent(out)   :: l(n)      !
  real(kind=8),    intent(out)   :: b(n)      !
  logical,         intent(inout) :: error     !
  ! Local
  integer(kind=4) :: i
  real(kind=8) :: in(2),out(2),matrix(3,3)
  !
  if (equinox.eq.equinox_null) then
    call gwcs_message(seve%e,'SYSTEM',  &
      'Cannot convert from EQUATORIAL with unknown Equinox to GALACTIC')
    error = .true.
    return
  endif
  !
  call chgcoo ('EQ','GA',equinox,0.0,matrix)
  do i=1,n
    in(1) = ra(i)
    in(2) = dec(i)
    call chgref (matrix,in,out)
    l(i) = out(1)
    b(i) = out(2)
  enddo
end subroutine equ_gal_1d
!
subroutine equ_gal_2d(ra,dec,equinox,l,b,n,m,error)
  use gbl_constant
  use gbl_message
  use gwcs_interfaces, except_this=>equ_gal_2d
  !---------------------------------------------------------------------
  ! @ public-generic equ_gal
  !  Convert 1 position from Equatorial+Equinox to Galactic
  !  2D-array version
  !---------------------------------------------------------------------
  integer(kind=4), intent(in)    :: n,m       !
  real(kind=8),    intent(in)    :: ra(n,m)   !
  real(kind=8),    intent(in)    :: dec(n,m)  !
  real(kind=4),    intent(in)    :: equinox   !
  real(kind=8),    intent(out)   :: l(n,m)    !
  real(kind=8),    intent(out)   :: b(n,m)    !
  logical,         intent(inout) :: error     !
  !
  call equ_gal_1d(ra,dec,equinox,l,b,n*m,error)
  !
end subroutine equ_gal_2d
!
subroutine gal_to_equ(l,b,loff,boff,ra,dec,raoff,decoff,equinox,error)
  use gbl_constant
  use gbl_message
  use gwcs_interfaces, except_this=>gal_to_equ
  !---------------------------------------------------------------------
  ! @ public
  !  Convert 1 position + 1 offset from Galactic to Equatorial+Equinox
  !---------------------------------------------------------------------
  real(kind=8), intent(in)    :: l        !
  real(kind=8), intent(in)    :: b        !
  real(kind=4), intent(in)    :: loff     !
  real(kind=4), intent(in)    :: boff     !
  real(kind=8), intent(out)   :: ra       !
  real(kind=8), intent(out)   :: dec      !
  real(kind=4), intent(out)   :: raoff    !
  real(kind=4), intent(out)   :: decoff   !
  real(kind=4), intent(in)    :: equinox  !
  logical,      intent(inout) :: error    !
  ! Local
  real(kind=8) :: oldcoord(2),incoord(2),outcoord(2),matrix(3,3)
  real(kind=4) :: oldin,oldout,inoff(2),outoff(2)
  save oldin,oldout,matrix,oldcoord,outcoord
  ! Data
  data oldin/0.0/, oldout/-1.0/
  !
  if (equinox.eq.equinox_null) then
    call gwcs_message(seve%e,'SYSTEM',  &
      'Cannot convert from GALACTIC to EQUATORIAL with unknown Equinox')
    error = .true.
    return
  endif
  !
  incoord(1) = l
  incoord(2) = b
  inoff(1) = loff
  inoff(2) = boff
  if (oldin.ne.0.0 .or. oldout.ne.equinox) then
    call chgcoo ('GA','EQ',0.0,equinox,matrix)
    oldin = 0.0
    oldout = equinox
    call chgref (matrix,incoord,outcoord)
  elseif (incoord(1).ne.oldcoord(1) .or. incoord(2).ne.oldcoord(2)) then
    call chgref (matrix,incoord,outcoord)
  endif
  oldcoord(1) = incoord(1)
  oldcoord(2) = incoord(2)
  if (inoff(1).ne.0.0 .or. inoff(2).ne.0.0) then
    call chgoff (matrix,incoord,inoff,outcoord,outoff)
  else
    outoff(1)=0.0
    outoff(2)=0.0
  endif
  ra = outcoord(1)
  dec = outcoord(2)
  raoff = outoff(1)
  decoff = outoff(2)
end subroutine gal_to_equ
!
subroutine gal_equ_0d(l,b,ra,dec,equinox,error)
  use gbl_constant
  use gbl_message
  use gwcs_interfaces, except_this=>gal_equ_0d
  !---------------------------------------------------------------------
  ! @ public-generic gal_equ
  !  Convert 1 position from Galactic to Equatorial+Equinox
  !  Scalar version
  !---------------------------------------------------------------------
  real(kind=8),    intent(in)    :: l        !
  real(kind=8),    intent(in)    :: b        !
  real(kind=8),    intent(out)   :: ra       !
  real(kind=8),    intent(out)   :: dec      !
  real(kind=4),    intent(in)    :: equinox  !
  logical,         intent(inout) :: error    !
  ! Local
  real(kind=8) :: l1(1),b1(1),ra1(1),dec1(1)
  !
  l1(1) = l
  b1(1) = b
  call gal_equ_1d(l1,b1,ra1,dec1,equinox,1,error)
  if (error)  return
  ra = ra1(1)
  dec = dec1(1)
end subroutine gal_equ_0d
!
subroutine gal_equ_1d(l,b,ra,dec,equinox,n,error)
  use gbl_constant
  use gbl_message
  use gwcs_interfaces, except_this=>gal_equ_1d
  !---------------------------------------------------------------------
  ! @ public-generic gal_equ
  !  Convert 1 position from Galactic to Equatorial+Equinox
  !  1D-array version
  !---------------------------------------------------------------------
  integer(kind=4), intent(in)    :: n        !
  real(kind=8),    intent(in)    :: l(n)     !
  real(kind=8),    intent(in)    :: b(n)     !
  real(kind=8),    intent(out)   :: ra(n)    !
  real(kind=8),    intent(out)   :: dec(n)   !
  real(kind=4),    intent(in)    :: equinox  !
  logical,         intent(inout) :: error    !
  ! Local
  integer(kind=4) :: i
  real(kind=8) :: in(2),out(2),matrix(3,3)
  !
  if (equinox.eq.equinox_null) then
    call gwcs_message(seve%e,'SYSTEM',  &
      'Cannot convert from GALACTIC to EQUATORIAL with unknown Equinox')
    error = .true.
    return
  endif
  !
  call chgcoo('GA','EQ',0.0,equinox,matrix)
  do i=1,n
    in(1) = l(i)
    in(2) = b(i)
    call chgref (matrix,in,out)
    ra(i) = out(1)
    dec(i) = out(2)
  enddo
end subroutine gal_equ_1d
!
subroutine gal_equ_2d(l,b,ra,dec,equinox,n,m,error)
  use gbl_constant
  use gbl_message
  use gwcs_interfaces, except_this=>gal_equ_2d
  !---------------------------------------------------------------------
  ! @ public-generic gal_equ
  !  Convert 1 position from Galactic to Equatorial+Equinox
  !  1D-array version
  !---------------------------------------------------------------------
  integer(kind=4), intent(in)    :: n,m       !
  real(kind=8),    intent(in)    :: l(n,m)    !
  real(kind=8),    intent(in)    :: b(n,m)    !
  real(kind=8),    intent(out)   :: ra(n,m)   !
  real(kind=8),    intent(out)   :: dec(n,m)  !
  real(kind=4),    intent(in)    :: equinox   !
  logical,         intent(inout) :: error     !
  !
  call gal_equ_1d(l,b,ra,dec,equinox,n*m,error)
  !
end subroutine gal_equ_2d
!
subroutine equ_to_equ(inra,indec,inroff,indoff,inequinox,ra,dec,  &
  raoff,decoff,equinox,error)
  use gbl_constant
  use gbl_message
  use gwcs_interfaces, except_this=>equ_to_equ
  !---------------------------------------------------------------------
  ! @ public
  !  Convert 1 position + 1 offset from Equatorial+Equinox to
  ! Equatorial+Equinox
  !---------------------------------------------------------------------
  real(kind=8), intent(in)    :: inra       !
  real(kind=8), intent(in)    :: indec      !
  real(kind=4), intent(in)    :: inroff     !
  real(kind=4), intent(in)    :: indoff     !
  real(kind=4), intent(in)    :: inequinox  !
  real(kind=8), intent(out)   :: ra         !
  real(kind=8), intent(out)   :: dec        !
  real(kind=4), intent(out)   :: raoff      !
  real(kind=4), intent(out)   :: decoff     !
  real(kind=4), intent(in)    :: equinox    !
  logical,      intent(inout) :: error      !
  ! Local
  real(kind=8) :: oldcoord(2),incoord(2),outcoord(2),matrix(3,3)
  real(kind=4) :: oldin,oldout,inoff(2),outoff(2)
  save oldin,oldout,matrix,oldcoord,outcoord
  ! Data
  data oldin/0.0/, oldout/-1.0/
  !
  if (inequinox.eq.equinox_null .neqv. equinox.eq.equinox_null) then
    ! Only one equinox is unknown. If both are unknown, this is accepted
    call gwcs_message(seve%e,'SYSTEM',  &
      'Cannot convert EQUATORIAL to/from EQUATORIAL with unknown Equinox')
    error = .true.
    return
  endif
  !
  incoord(1) = inra
  incoord(2) = indec
  inoff(1) = inroff
  inoff(2) = indoff
  if (oldin.ne.inequinox .or. oldout.ne.equinox) then
    call chgcoo ('EQ','EQ',inequinox,equinox,matrix)
    oldin = inequinox
    oldout = equinox
    call chgref (matrix,incoord,outcoord)
  elseif (incoord(1).ne.oldcoord(1) .or. incoord(2).ne.oldcoord(2)) then
    call chgref (matrix,incoord,outcoord)
  endif
  oldcoord(1) = incoord(1)
  oldcoord(2) = incoord(2)
  if (inoff(1).ne.0.0 .or. inoff(2).ne.0.0) then
    call chgoff (matrix,incoord,inoff,outcoord,outoff)
  else
    outoff(1)=0.0
    outoff(2)=0.0
  endif
  ra = outcoord(1)
  dec = outcoord(2)
  raoff = outoff(1)
  decoff = outoff(2)
  !
end subroutine equ_to_equ
!
subroutine equ_equ_0d(ra1,dec1,equinox1,ra2,dec2,equinox2,error)
  use gbl_constant
  use gbl_message
  use gwcs_interfaces, except_this=>equ_equ_0d
  !---------------------------------------------------------------------
  ! @ public-generic equ_equ
  !  Convert 1 position from Equatorial+Equinox to Equatorial+Equinox
  !  Scalar version
  !---------------------------------------------------------------------
  real(kind=8),    intent(in)    :: ra1       !
  real(kind=8),    intent(in)    :: dec1      !
  real(kind=4),    intent(in)    :: equinox1  !
  real(kind=8),    intent(out)   :: ra2       !
  real(kind=8),    intent(out)   :: dec2      !
  real(kind=4),    intent(in)    :: equinox2  !
  logical,         intent(inout) :: error     !
  ! Local
  real(kind=8) :: r1(1),d1(1),r2(1),d2(1)
  !
  r1(1) = ra1
  d1(1) = dec1
  call equ_equ_1d(r1,d1,equinox1,r2,d2,equinox2,1,error)
  if (error)  return
  ra2 = r2(1)
  dec2 = d2(1)
  !
end subroutine equ_equ_0d
!
subroutine equ_equ_1d(ra1,dec1,equinox1,ra2,dec2,equinox2,n,error)
  use gbl_constant
  use gbl_message
  use gwcs_interfaces, except_this=>equ_equ_1d
  !---------------------------------------------------------------------
  ! @ public-generic equ_equ
  !  Convert 1 position from Equatorial+Equinox to Equatorial+Equinox
  !  1D-array version
  !---------------------------------------------------------------------
  integer(kind=4), intent(in)    :: n         !
  real(kind=8),    intent(in)    :: ra1(n)    !
  real(kind=8),    intent(in)    :: dec1(n)   !
  real(kind=4),    intent(in)    :: equinox1  !
  real(kind=8),    intent(out)   :: ra2(n)    !
  real(kind=8),    intent(out)   :: dec2(n)   !
  real(kind=4),    intent(in)    :: equinox2  !
  logical,         intent(inout) :: error     !
  ! Local
  integer(kind=4) :: i
  real(kind=8) :: in(2),out(2),matrix(3,3)
  !
  if (equinox1.eq.equinox_null .neqv. equinox2.eq.equinox_null) then
    ! Only one equinox is unknown. If both are unknown, this is accepted
    ! since the operation is transparent (see below)
    call gwcs_message(seve%e,'SYSTEM',  &
      'Cannot convert EQUATORIAL to/from EQUATORIAL with unknown Equinox')
    error = .true.
    return
  endif
  !
  if (equinox1.ne.equinox2) then
    call chgcoo ('EQ','EQ',equinox1,equinox2,matrix)
    do i=1,n
      in(1) = ra1(i)
      in(2) = dec1(i)
      call chgref (matrix,in,out)
      ra2(i) = out(1)
      dec2(i) = out(2)
    enddo
  else
    do i=1,n
      ra2(i) = ra1(i)
      dec2(i) = dec1(i)
    enddo
  endif
end subroutine equ_equ_1d
!
subroutine equ_equ_2d(ra1,dec1,equinox1,ra2,dec2,equinox2,n,m,error)
  use gbl_constant
  use gbl_message
  use gwcs_interfaces, except_this=>equ_equ_2d
  !---------------------------------------------------------------------
  ! @ public-generic equ_equ
  !  Convert 1 position from Equatorial+Equinox to Equatorial+Equinox
  !  2D-array version
  !---------------------------------------------------------------------
  integer(kind=4), intent(in)    :: n,m        !
  real(kind=8),    intent(in)    :: ra1(n,m)   !
  real(kind=8),    intent(in)    :: dec1(n,m)  !
  real(kind=4),    intent(in)    :: equinox1   !
  real(kind=8),    intent(out)   :: ra2(n,m)   !
  real(kind=8),    intent(out)   :: dec2(n,m)  !
  real(kind=4),    intent(in)    :: equinox2   !
  logical,         intent(inout) :: error      !
  !
  call equ_equ_1d(ra1,dec1,equinox1,ra2,dec2,equinox2,n*m,error)
  !
end subroutine equ_equ_2d
!
subroutine chgcoo(oldtyp,newtyp,oldepo,newepo,matrix)
  use gwcs_interfaces, except_this=>chgcoo
  !---------------------------------------------------------------------
  ! @ public
  !  Change Coordinate system
  !------------------------------------------------------------------------
  character(len=2), intent(in)  :: oldtyp        ! Coordinate input type
  character(len=2), intent(in)  :: newtyp        ! Coordinate output type
  real(kind=4),     intent(in)  :: oldepo        ! Coordinate input epoch (if 'EQ')
  real(kind=4),     intent(in)  :: newepo        ! Coordinate output epoch (if 'EQ')
  real(kind=8),     intent(out) :: matrix(3,3)   ! Rotation Matrix
  ! Local
  real(kind=8) :: mat1(3,3), mat2(3,3)
  real(kind=8), parameter :: j2000=2451545.0d0        ! reference epoch (julian days)
  real(kind=8), parameter :: j1950=j2000-50*365.25d0  ! reference epoch (julian days)
  real(kind=8) :: jold, jnew, angles(6)
  real(kind=8), parameter :: pi=3.14159265358979323846d0
  real(kind=8), parameter :: halfpi=pi/2.0d0, twopi=2.d0*pi
  real(kind=8), parameter :: degrad=pi/180.0d0
  real(kind=8), parameter :: psi=degrad*33., theta=-degrad*62.6, phi=-degrad*282.25
  !
  ! Compute rotation matrix
  ! Precession only
  if (oldtyp.eq.'EQ' .and. newtyp.eq.'EQ') then
    if (oldepo .eq. newepo) return
    jold = j2000 + (oldepo-2000.d0)*365.25d0
    jnew = j2000 + (newepo-2000.d0)*365.25d0
    call qprec(jold,jnew,angles)
    call eulmat(-angles(1)+halfpi, angles(3), -angles(2)-halfpi, matrix)
    !
    ! Change of frame
  elseif (oldtyp.eq.'EQ' .and. newtyp.eq.'GA') then
    jold = j2000 + (oldepo-2000.d0)*365.25d0
    call qprec(jold,j1950,angles)
    call eulmat(-angles(1)+halfpi, angles(3), -angles(2)-halfpi, mat1)
    call eulmat(-phi, -theta, -psi, mat2)
    call mulmat(mat1, mat2, matrix)
  elseif (oldtyp.eq.'GA' .and. newtyp.eq.'EQ') then
    call eulmat(psi, theta, phi, mat1)
    jnew = j2000 + (newepo-2000.d0)*365.25d0
    call qprec(j1950,jnew,angles)
    call eulmat(-angles(1)+halfpi, angles(3), -angles(2)-halfpi, mat2)
    call mulmat(mat1, mat2, matrix)
  endif
  !
end subroutine chgcoo
!
subroutine chgref(matrix, oldref, newref)
  use gwcs_interfaces, except_this=>chgref
  !---------------------------------------------------------------------
  ! @ private
  ! Computes the coordinates of the reference direction in the new system
  !---------------------------------------------------------------------
  real(kind=8), intent(in)  :: matrix(3,3)  ! Rotation matrix
  real(kind=8), intent(in)  :: oldref(2)    ! Old coordinates (radians)
  real(kind=8), intent(out) :: newref(2)    ! New coordinates (radians)
  ! Local
  real(kind=8) :: xold(3), xnew(3)
  real(kind=8), parameter :: pi=3.14159265358979323846d0
  real(kind=8), parameter :: twopi=2.d0*pi
  !
  ! Go to cartesian
  xold(1) = cos(oldref(1)) * cos(oldref(2))
  xold(2) = sin(oldref(1)) * cos(oldref(2))
  xold(3) = sin(oldref(2))
  !
  ! Rotate
  call matvec(xold, matrix, xnew)
  !
  ! Back to spherical
  newref(1) = atan2(xnew(2), xnew(1))
  do while (newref(1) .lt. 0)
    newref(1) = newref(1) + twopi
  enddo
  do while (newref(1) .gt. twopi)
    newref(1) = newref(1) - twopi
  enddo
  newref(2) = atan2(xnew(3), sqrt(xnew(1)**2 + xnew(2)**2) )
  !
end subroutine chgref
!
subroutine chgoff(matrix,oldref,oldoff,newref,newoff)
  use gwcs_interfaces, except_this=>chgoff
  !---------------------------------------------------------------------
  ! @ private
  ! Compute offsets in the new system
  !------------------------------------------------------------------------
  real(kind=8), intent(in)  :: matrix(3,3)  ! Rotation matrix
  real(kind=8), intent(in)  :: oldref(2)    ! Old coordinates (radians)
  real(kind=4), intent(in)  :: oldoff(2)    ! Old offsets (radians)
  real(kind=8), intent(in)  :: newref(2)    ! New coordinates (radians)
  real(kind=4), intent(out) :: newoff(2)    ! New offsets (radians)
  ! Local
  real(kind=8) :: oldpos(2), newpos(2)
  !
  ! position in old coordinates
  oldpos(2) = oldref(2) + oldoff(2)
  oldpos(1) = oldref(1) + oldoff(1) / cos(oldpos(2))
  !
  ! rotate
  call chgref(matrix, oldpos, newpos)
  !
  ! new offsets
  newoff(2) = newpos(2) - newref(2)
  newoff(1) = (newpos(1) - newref(1)) * cos(newpos(2))
  !
end subroutine chgoff
!
subroutine qprec (ti,tf,angles)
  !---------------------------------------------------------------------
  ! @ public
  !  precession entre deux epoques selon Lieske et al (1977)
  !  from EPHAUT / BDL / C002 / 81-1
  !  modified 29 november 1984 by Michel Perault
  !  calcul de quantites liees aux deplacements precessionnels de
  !  l'equateur et de l'ecliptique entre deux epoques donnees
  !  en entree : TI epoque initiale (jours juliens)
  !              TF epoque finale (jours juliens)
  !  en sortie : ANGLES(1-3) quantites liees au deplacement precessionnel
  !              de l'equateur entre TI et TF (radian)
  !              ANGLES(4-6) quantites liees au deplacement precessionnel
  !              de l'ecliptique entre TI et TF (radian)
  !  notations : ANGLES(1) = DZETA
  !              ANGLES(2) = Z
  !              ANGLES(3) = TETA
  !              ANGLES(4) = petit PI
  !              ANGLES(5) = grand PI
  !              ANGLES(6) = P (precession generale en longitude)
  !  remarque  : les temps sont mesures en siecle julien a partir de
  !              l'epoque J2000.0 (JJ2451545)
  !---------------------------------------------------------------------
  real(kind=8), intent(in)  :: ti         !
  real(kind=8), intent(in)  :: tf         !
  real(kind=8), intent(out) :: angles(6)  !
  ! Local
  real(kind=8), parameter :: sdrad=0.4848136811095360d-5
  real(kind=8), parameter :: t0=2451545.d0, siecle=36525.d0
  real(kind=8) :: t,t2,pt,pt2,pt3
  real(kind=8) :: dzeta1,dzeta2,dzeta3,za1,za2,za3,teta1,teta2,teta3
  real(kind=8) :: ppia1,ppia2,ppia3,gpia0,gpia1,gpia2,pa1,pa2,pa3
  !
  angles(:)=0.d0
  if (ti.eq.tf) return
  !
  t=(ti-t0)/siecle
  t2=t*t
  pt=(tf-ti)/siecle
  pt2=pt*pt
  pt3=pt*pt2
  !  precession equatoriale
  dzeta1=(2306.2181d0+1.39656d0*t-0.139d-3*t2)*sdrad
  dzeta2=(0.30188d0-0.345d-3*t)*sdrad
  dzeta3=0.17998d-1*sdrad
  za1=dzeta1
  za2=(1.09468d0+0.66d-4*t)*sdrad
  za3=0.18203d-1*sdrad
  teta1=(2004.3109d0-0.8533d0*t-0.217d-3*t2)*sdrad
  teta2=(-0.42665d0-0.217d-3*t)*sdrad
  teta3=-0.41833d-1*sdrad
  angles(1)=dzeta1*pt+dzeta2*pt2+dzeta3*pt3
  angles(2)=za1*pt+za2*pt2+za3*pt3
  angles(3)=teta1*pt+teta2*pt2+teta3*pt3
  !  precession ecliptique
  ppia1=(47.0029d0-0.6603d-1*t+0.598d-3*t2)*sdrad
  ppia2=(-0.3302d-1+0.598d-3*t)*sdrad
  ppia3=0.6d-4*sdrad
  gpia0=(629554.982d0+3289.4789d0*t+0.60622d0*t2)*sdrad
  gpia1=(-869.8089d0-0.50491d0*t)*sdrad
  gpia2=0.3536d-1*sdrad
  pa1=(5029.0966d0+2.22226d0*t-0.42d-4*t2)*sdrad
  pa2=(1.11113d0-0.42d-4*t)*sdrad
  pa3=-0.6d-5*sdrad
  angles(4)=ppia1*pt+ppia2*pt2+ppia3*pt3
  angles(5)=gpia0+gpia1*pt+gpia2*pt2
  angles(6)=pa1*pt+pa2*pt2+pa3*pt3
  return
end subroutine qprec
!
subroutine b1950_to_j2000(obs_epoch,alpha,delta)
  use gwcs_interfaces, except_this=>b1950_to_j2000
  !---------------------------------------------------------------------
  ! @ public
  ! Convert Besselian coordinates to J2000, assuming zero proper motion,
  ! parallax, and radial velocity. Calls the general implementation of
  ! the formulas from Aoki et al AA 128, 263 (1983)
  !---------------------------------------------------------------------
  real(kind=4), intent(in)    :: obs_epoch  !
  real(kind=8), intent(inout) :: alpha      !
  real(kind=8), intent(inout) :: delta      !
  ! Local
  real(kind=8) :: observed_epoch
  real(kind=8) :: mu_alph,mu_delt,parallax,radvel
  !
  observed_epoch = obs_epoch
  mu_alph  = 0.d0
  mu_delt  = 0.d0
  parallax = 0.d0
  radvel   = 0.d0
  call full_b1950_to_j2000(observed_epoch,alpha,delta,mu_alph,mu_delt,  &
  parallax,radvel)
end subroutine b1950_to_j2000
!
subroutine full_b1950_to_j2000(obs_epoch,lambda,beta,mu_alph,mu_delt,  &
  parallax,radvel)
  use gwcs_interfaces, except_this=>full_b1950_to_j2000
  !---------------------------------------------------------------------
  ! @ private
  ! Convert Besselian coordinates to J2000.
  ! Implementation of the general formulas given in Aoki et al AA 128,
  ! 263 (1983), modified (not totally sure the modification is totally
  ! consistent, but the potentially remaining inconsistencies should be
  ! small for practical cases) to handle the case of a non-B1950 observing
  ! epoch.
  !
  ! NOT YET FINISHED, STILL RESTRICTED TO NO PM, NO PARALLAX, NO RV,
  ! BUT WORKS AS BEFORE IN THIS RESTRICTED CASE
  !---------------------------------------------------------------------
  real(kind=8), intent(in)    :: obs_epoch  !
  real(kind=8), intent(inout) :: lambda     !
  real(kind=8), intent(inout) :: beta       !
  real(kind=8), intent(in)    :: mu_alph    !
  real(kind=8), intent(in)    :: mu_delt    !
  real(kind=8), intent(in)    :: parallax   !
  real(kind=8), intent(in)    :: radvel     !
  ! Global
  real(kind=8), parameter :: pi=3.14159265358979323846d0
  ! Local
  integer(kind=4) :: i
  real(kind=8) :: mat_rr(9), mat_rv(9), mat_full(36)
  real(kind=8) :: s_0(2), x_0(3), v_0(3)
  real(kind=8) :: x_1(3), v_1(3), xv_1(6)
  real(kind=8) :: x(3), v(3), a_1(3), dt1
  real(kind=8) :: a_vec(3), aa, a_point(3), ap, b1950, tcent, jcent, dt
  real(kind=8) :: calp,salp,cdec,sdec
  equivalence (x_1(1),xv_1(1)),(v_1(1),xv_1(4))
  !
  data mat_rr/ 0.9999256782d0,  0.0111820609d0,  0.0048579479d0,  &
              -0.0111820610d0,  0.9999374784d0, -0.0000271474d0,  &
              -0.0048579477d0, -0.0000271765d0,  0.9999881997d0/
  data mat_rv/-0.00055d0,  0.23849d0, -0.43562d0,  &
              -0.23854d0, -0.00267d0,  0.01225d0,  &
               0.43574d0, -0.00854d0,  0.00212d0/
  data mat_full/ 0.9999256782d0,   0.0111820609d0,   0.0048579479d0,   &
                -0.00055d0,        0.23849d0,       -0.43562d0,        &
                -0.0111820610d0,   0.9999374784d0,  -0.0000271474d0,   &
                -0.23854d0,       -0.00267d0,        0.01225d0,        &
                -0.0048579477d0,  -0.0000271765d0,   0.9999881997d0,   &
                 0.43574d0,       -0.00854d0,        0.00212d0,        &
                +0.0000024239502, +0.0000000271066, +0.0000000117766,  &
                +0.99994704d0,    +0.01118251d0,    +0.00485767d0,     &
                -0.0000000271066, +0.0000024239788, -0.0000000000658,  &
                -0.01118251d0,    +0.99995883d0,    -0.00002714d0,     &
                -0.0000000117766, -0.0000000000659, +0.0000024241017,  &
                +0.00485767d0,    -0.00002718d0,    +1.00000956d0/
  data a_vec /-1.62557d-6, -0.31919d-6, -0.13843d-6/
  data a_point /1.245d-3, -1.580d-3, -0.659d-3/
  data b1950/2433282.42345905d0/, tcent/36524.2198781d0/, jcent/36525d0/
  !
  ! Compute rectangular position and velocity, in the old system
  s_0(1) = lambda
  s_0(2) = beta
  call rect (s_0, x_0)
  calp = cos(lambda)
  salp = sin(lambda)
  cdec = cos(beta)
  sdec = sin(beta)
  v_0(1) = 15*mu_alph*(-cdec*salp)+mu_delt*(-sdec*calp)
  v_0(2) = 15*mu_alph*(+cdec*calp)+mu_delt*(-sdec*salp)
  v_0(3) =                 0      +mu_delt*cdec
  do i=1,3
    v_0(i) = v_0(i)+21.094502*parallax*radvel*x_0(i)
  enddo
  ! Remove the E-terms of aberration and their variation's effect.
  dt1 = (obs_epoch-1950.0)*365.25/tcent
  do i=1,3
    a_1(i) = a_vec(i)+dt1*a_point(i)*pi/180d0/3600d0
  enddo
  aa = x_0(1)*a_1(1)+x_0(2)*a_1(2)+x_0(3)*a_1(3)
  do i=1, 3
    x_1(i) = x_0(i)*(1d0+aa) - a_1(i)
  enddo
  ap = x_0(1)*a_1(1)+x_0(2)*a_1(2)+x_0(3)*a_1(3)
  do i=1,3
    v_1(i) = v_0(i)-a_point(i)+ap*x_0(i)   ! Should that rather be X_1??
  enddo
  !
  call matvec (x_1, mat_rr, x)
  call matvec (x_1, mat_rv, v)
  dt = (obs_epoch-2000)*365.25/jcent
  do i=1, 3
    x(i) = x(i)+ dt*v(i)*pi/180d0/3600d0
  enddo
  call spher (x, s_0)
  lambda = s_0(1)
  beta = s_0(2)
  !
end subroutine full_b1950_to_j2000
!
subroutine do_precess(epoch, new_epoch, lambda, beta)
  use gwcs_interfaces, except_this=>do_precess
  !---------------------------------------------------------------------
  ! @ public
  !---------------------------------------------------------------------
  real(kind=4), intent(inout) :: epoch      !
  real(kind=4), intent(in)    :: new_epoch  !
  real(kind=8), intent(inout) :: lambda     !
  real(kind=8), intent(inout) :: beta       !
  ! Global
  real(kind=8), parameter :: pi=3.14159265358979323846d0
  ! Local
  real(kind=8), parameter :: j2000=2451545.0d0
  real(kind=8) :: s(2), x_0(3), x_1(3), matrix(9), psi, the, phi
  real(kind=8) :: angles(6), j0, j1
  !
  s(1) = lambda
  s(2) = beta
  call rect (s, x_0)
  j0 = j2000+(epoch-2000.0d0)*365.25d0 ! fixed epoch (julian days)
  j1 = j2000+(new_epoch-2000.0d0)*365.25d0 ! fixed epoch (julian days)
  call qprec(j0,j1,angles)
  psi = pi/2d0-angles(1)       ! Euler angles of transformation
  the = angles(3)
  phi = -pi/2d0-angles(2)
  call eulmat (psi,the,phi,matrix)
  call matvec (x_0, matrix, x_1)
  call spher (x_1, s)
  lambda = s(1)
  beta = s(2)
  epoch = new_epoch
  !
end subroutine do_precess
!
subroutine spher (x, a)
  !---------------------------------------------------------------------
  ! @ public
  !       CARTESIAN TO SPHERICAL COORDINATE CONVERSION
  !------------------------------------------------------------------------
  real(kind=8), intent(in)  :: x(3)  ! Cartesian coordinates
  real(kind=8), intent(out) :: a(2)  ! Spherical coordinates
  !
  if (x(1).eq.0d0 .and. x(2).eq.0d0) then
    a(1) = 0d0
    a(2) = atan2 (x(3), 0.d0)
  else
    a(1) = atan2(x(2), x(1))
    a(2) = atan2(x(3), sqrt(x(1)**2 + x(2)**2) )
  endif
end subroutine spher
!
subroutine rect (a, x)
  !---------------------------------------------------------------------
  ! @ public
  !       SPHERICAL TO CARTESIAN COORDINATES CONVERSION
  !---------------------------------------------------------------------
  real(kind=8), intent(in)  :: a(2)  ! Spherical coordinates
  real(kind=8), intent(out) :: x(3)  ! Cartesian coordinates
  !
  x(1) = cos(a(1)) * cos(a(2))
  x(2) = sin(a(1)) * cos(a(2))
  x(3) = sin(a(2))
end subroutine rect
!
subroutine eq1950_to_gal(a,d,lii,bii,n)
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !       Converts (A,D) (1950.0) in LII,BII
  !       Units are radians
  !---------------------------------------------------------------------
  real(kind=8),    intent(in)  :: a(*)    !
  real(kind=8),    intent(in)  :: d(*)    !
  real(kind=8),    intent(out) :: lii(*)  !
  real(kind=8),    intent(out) :: bii(*)  !
  integer(kind=4), intent(in)  :: n       !
  ! Local
  real(kind=8), parameter :: pi=3.14159265358979323846d0
  real(kind=8), parameter :: precision=1.0d-10
  real(kind=8), parameter :: c626=0.4601997847838517d0
  real(kind=8), parameter :: s626=0.8878153851364013d0
  real(kind=8) :: aa,cosa,sina,cosdec,sindec,expr
  integer(kind=4) :: i
  !
  ! Formulaes are in degrees (LANG K.R. page 504)
  !
  !       SIN(Bii)             = SIN(D)COS(62.6) - COS(D)SIN(A-282.25)SIN(62.6)
  !       COS(Bii)*COS(Lii-33) = COS(D)COS(A-282.25)
  !       COS(Bii)*SIN(Lii-33) = COS(D)SIN(A-282.25)COS(62.6) + SIN(D)SIN(62.6)
  !
  ! which is
  !  SIN(Bii)    = SIN(Dec)COS(90-DecGalPol)
  !               -COS(Dec)SIN(RA-(RAGalPol+90))SIN(DecGalPol)
  !  COS(Bii)*COS(Lii-(GlonRAPol-90)) = COS(Dec)COS(RA-(RAGalPol+90))
  !  COS(Bii)*SIN(Lii-(GlonRAPol-90)) =
  !                       COS(Dec)SIN(RA-(RAGalPol+90))COS(90-DecGalPol)
  !                     + SIN(Dec)SIN(90-DecGalPol)
  !
  do i=1,n
    aa = a(i)-282.25d0*pi/180.d0
    cosa = cos(aa)
    sina = sin(aa)
    cosdec = cos(d(i))
    sindec = sin(d(i))
    !
    expr = cosdec*sina
    bii(i) = asin (sindec*c626 - expr*s626)
    lii(i) = atan2( (expr*c626+sindec*s626),cosdec*cosa ) + 33.d0*pi/180.d0
    ! Force Lii to the usual [0,2*PI[ determination 11-APR-91 TF
    if (lii(i).lt.0) lii(i) = lii(i)+2*pi
  enddo
  !
end subroutine eq1950_to_gal
!
subroutine gal_to_eq1950(lii,bii,a,d,n)
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !       Converts Lii,Bii to (A,D) (1950.0)
  !       Units are radians
  !---------------------------------------------------------------------
  real(kind=8),    intent(in)  :: lii(*)  !
  real(kind=8),    intent(in)  :: bii(*)  !
  real(kind=8),    intent(out) :: a(*)    !
  real(kind=8),    intent(out) :: d(*)    !
  integer(kind=4), intent(in)  :: n       !
  ! Local
  real(kind=8), parameter :: pi=3.14159265358979323846d0
  real(kind=8), parameter :: precision=1.0d-10
  real(kind=8), parameter :: c626=0.4601997847838517d0
  real(kind=8), parameter :: s626=0.8878153851364013d0
  real(kind=8) :: ll,sinb,cosb,sinl,cosl,expr
  integer(kind=4) :: i
  !
  ! The conversion formulae are
  !       COS(D)SIN(A-282.25) = COS(Bii)SIN(Lii-33)COS(62.6) - SIN(Bii)SIN(62.6)
  !       COS(D)COS(A-282.25) = COS(Bii)COS(Lii-33)
  !       SIN(D)              = COS(Bii)SIN(Lii-33)SIN(62.6) + SIN(Bii)COS(62.6)
  !
  do i = 1,n
    ll   = lii(i) - 33.d0*pi/180.d0
    sinb = sin(bii(i))
    cosb = cos(bii(i))
    sinl = sin(ll)
    cosl = cos(ll)
    !
    expr = cosb*sinl
    d(i) = asin ( expr*s626 + sinb*c626 )
    a(i) = atan2 ( expr*c626-sinb*s626,cosb*cosl ) + 282.25d0*pi/180.d0
    ! Force RA to the usual [0,2*PI[ determination 11-APR-91 TF
    if (a(i).ge.2*pi) a(i) = a(i)-2*pi
  enddo
  !
end subroutine gal_to_eq1950

subroutine greg_corners(line,error)
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>greg_corners
  !---------------------------------------------------------------------
  ! @ private
  ! Support routine for command
  !   CORNERS
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line   ! Input command line
  logical,          intent(inout) :: error  ! Logical error flag
  !
  call gr_segm('CORNERS',error)
  if (error)  return
  !
  call gtl_corner(error)
  ! if (error)  continue
  !
  call gtsegm_close(error)
  if (error)  return
  !
end subroutine greg_corners

subroutine sic_grep(line,error)
  use gildas_def
  use sic_interfaces, except_this=>sic_grep
  !---------------------------------------------------------------------
  ! @ private
  ! Support routine for command
  !    SIC GREP Pattern File
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line
  logical,          intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='GREP'
  character(len=128) :: pattern
  character(len=filename_length) :: file
  integer(kind=4) :: nl
  !
  call sic_ch(line,0,2,pattern,nl,.true.,error)
  if (error)  return
  !
  call sic_ch(line,0,3,file,nl,.true.,error)
  if (error)  return
  !
  call sic_grep_do(file,pattern,error)
  if (error)  return
  !
end subroutine sic_grep
!
subroutine sic_grep_do(filename,pattern,error)
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_grep_do
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: filename
  character(len=*), intent(in)    :: pattern
  logical,          intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='GREP'
  character(len=filename_length) :: file
  integer(kind=4) :: ier,lun
  !
  call sic_parse_file(filename,' ','',file)
  !
  ier = sic_getlun(lun)
  if (mod(ier,2).eq.0) then
    error = .true.
    return
  endif
  ier = sic_open(lun,file,'OLD',.true.)
  if (ier.ne.0) then
    call sic_message(seve%e,rname,'Error opening '//file)
    call putios('E-GREP,  ',ier)
    close(unit=lun)
    call sic_frelun(lun)
    error = .true.
    return
  endif
  !
  call sic_grep_engine(lun,pattern,error)
  if (error)  continue
  !
  ier = sic_close(lun)
  call sic_frelun(lun)
  !
end subroutine sic_grep_do
!
subroutine sic_grep_engine(lun,pattern,error)
  use gbl_message
  use sic_interfaces, except_this=>sic_grep_engine
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4),  intent(in)    :: lun
  character(len=*), intent(in)    :: pattern
  logical,          intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='GREP'
  integer(kind=4) :: iline,ier
  integer(kind=4), parameter :: line_length=1024
  character(len=line_length) :: line
  character(len=message_length) :: mess
  ! Saved
  character(len=line_length), allocatable, save :: lines(:)
  integer(kind=4), save :: nmatch
  logical, save :: first=.true.
  !
  if (first) then
    call sic_defstructure('GREP',.true.,error)
    if (error)  return
    call sic_def_inte('GREP%N',nmatch,0,0,.true.,error)
    if (error)  return
    first = .false.
  endif
  call sic_delvariable('GREP%LINES',.false.,error)
  if (error)  error = .false.
  !
  iline = 0
  nmatch = 0
  do
    iline = iline+1
    read(lun,'(A)',iostat=ier)  line
    if (ier.lt.0)  exit
    if (ier.gt.0) then
      write(mess,'(A,I0)')  'Error reading file at line ',iline
      call sic_message(seve%e,rname,mess)
      error = .true.
      return
    endif
    if (index(line,trim(pattern)).le.0)  cycle
    nmatch = nmatch+1
    call reallocate_lines(lines,nmatch,error)
    if (error)  return
    lines(nmatch) = line
  enddo
  !
  if (nmatch.gt.0) then
    call sic_def_charn('GREP%LINES',lines,1,nmatch,.true.,error)
    if (error)  return
  endif
  !
contains
  !
  subroutine reallocate_lines(list,rsize,error)
    !-------------------------------------------------------------------
    !-------------------------------------------------------------------
    character(len=*), allocatable   :: list(:)
    integer(kind=4),  intent(in)    :: rsize  ! Requested size
    logical,          intent(inout) :: error
    !
    integer(kind=4), parameter :: lines_min_alloc=10
    character(len=line_length), allocatable :: tmp(:)
    integer(kind=4) :: osize,nsize,ilist
    !
    if (allocated(list)) then
      osize = size(list)
    else
      osize = 0
    endif
    if (osize.ge.rsize)  return
    !
    nsize = maxval( (/rsize,lines_min_alloc,2*osize/) )
    !
    if (osize.gt.0) then
      call move_alloc(from=list,to=tmp)
      ! => list is now deallocated
    endif
    !
    allocate(list(nsize))
    !
    if (osize.gt.0) then
      do ilist=1,osize
        list(ilist) = tmp(ilist)
      enddo
      deallocate(tmp)
    endif
    !
  end subroutine reallocate_lines
  !
end subroutine sic_grep_engine

subroutine conreg (nx,ny,z,frstd,vectd,lastd,flushd,ir,n,error)
  use gcont_interfaces, except_this=>conreg
  use gcont_contour
  !---------------------------------------------------------------------
  ! @ public-mandatory (because symbol is used elsewhere)
  !	Draw contour levels according to the parameters set up by
  !	subroutine MAP
  ! Arguments :
  !	NX	I	Number of X pixels			Input
  !	NY	I	Number of Y pixels			Input
  !	Z	R*4	Array of values				Input
  !	VECTD	Ext 	Vector drawing function			Input
  !	LASTD	Ext	End of contour drawing function		Input
  !	FRSTD	Ext	First vector drawing routine 		Input
  !	FLUSHD	Ext	A plot flushing routine			Input
  !	IR	I	Work space for contour storage
  !	N	I	Size of work space
  ! Subroutines :
  !	CONBIT
  !	STLINE
  !---------------------------------------------------------------------
  integer :: nx                     !
  integer :: ny                     !
  real :: z(*)                      !
  external :: frstd                 !
  external :: vectd                 !
  external :: lastd                 !
  external :: flushd                !
  integer :: ir(*)                  !
  integer :: n                      !
  logical, intent(inout) :: error   ! Error return
  ! Local
  integer :: i
  real :: contr
  !
  call conbdn
  !
  ! Get number of bits
  call conbit(nx,ny,error)
  if (error) return
  ! No packing version
  nr = n/2
  !
  ! Process each level
  do i=1,ncl
    contr = clev(i)*qlev
    if (clev(i).lt.0) then
      call frstd(2,error)
    else
      call frstd(1,error)
    endif
    if (error) return
    ! Draw all lines at this level.
    call stline(contr,nx,ny,z,vectd,lastd,ir,error)
    if (error) return
    call flushd (error)
    if (error) return
  enddo
end subroutine conreg
!
subroutine stline(conval,nx,ny,z,vectd,lastd,ir,error)
  use gcont_interfaces, except_this=>stline
  use gcont_contour
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! 	This routine finds the beginnings of all contour lines at
  !	level CONVAL. First the edges are searched for lines intersecting
  !	the edge (open lines) then the interior is searched for lines
  !	which do not intersect the edge (closed lines).  Beginnings are
  !	stored in IR to prevent retracing of lines.  If IR is filled,
  !	the search is stopped for this CONVAL.
  ! Arguments :
  !	CONVAL	R*4	Contour value				Input
  !	NX	I	Number of X pixels			Input
  !	NY	I	Number of Y pixels			Input
  !	Z	R*4	Array of values				Input
  !	VECTD	Ext	Vector drawing function
  !	LASTD	Ext	End of contour drawing function
  !	IR	I	Work space for contour storage
  ! Subroutines :
  !	DRLINE
  !---------------------------------------------------------------------
  real :: conval                    !
  integer :: nx                     !
  integer :: ny                     !
  real :: z(*)                      !
  external :: vectd                 !
  external :: lastd                 !
  integer :: ir(2,*)                !
  logical, intent(inout) :: error   ! Error return
  ! Local
  ! Array IR is now in argument list
  integer :: m,n,ip1,i,izcor,jp1,j,k
  character(len=12) :: chain
  !
  m = nx
  n = ny
  !!Print *,'STLINE ',nx,ny,' Max buffer ',nr, 'IOFFP' ,ioffp
  cv = conval
  !
  np2 = 0
  iss = 0
  do ip1=2,m
    i = ip1-1
    if (z(i).ge.cv .or. z(ip1).lt.cv) goto 101
    ix = ip1
    iy = 1
    idx = -1
    idy = 0
    is = 1
    !!Print *,'DRLINE 1 ',ix,iy,' ids ',idx,idy,is
    call drline (nx,ny,z,vectd,lastd,ir,error)
    if (error) return
101 izcor=(n-1)*nx
    if (z(izcor+ip1).ge.cv .or. z(izcor+i).lt.cv) cycle    ! IP1
    ix = i
    iy = n
    idx = 1
    idy = 0
    is = 5
    !!Print *,'DRLINE 2 ',ix,iy,' ids ',idx,idy,is
    call drline (nx,ny,z,vectd,lastd,ir,error)
    if (error) return
  enddo
  !
  do jp1=2,n
    j = jp1-1
    izcor=(j-1)*nx
    if (z(izcor+m).ge.cv .or. z((jp1-1)*nx+m).lt.cv) goto 103
    ix = m
    iy = jp1
    idx = 0
    idy = -1
    is = 7
    !!Print *,'DRLINE 3 ',ix,iy,' ids ',idx,idy,is
    call drline (nx,ny,z,vectd,lastd,ir,error)
    if (error) return
103 if (z((jp1-1)*nx+1).ge.cv .or. z(izcor+1).lt.cv)  cycle  ! JP1
    ix = 1
    iy = j
    idx = 0
    idy = 1
    is = 3
    !!Print *,'DRLINE 4 ',ix,iy,' ids ',idx,idy,is
    call drline (nx,ny,z,vectd,lastd,ir,error)
    if (error) return
  enddo                        ! JP1
  !
  iss = 1
  do jp1=3,n
    j = jp1-1
    izcor=(j-1)*nx
    do ip1=2,m
      i = ip1-1
      if (z(izcor+i).ge.cv .or. z(izcor+ip1).lt.cv) cycle  ! IP1
      if (.not.(z(izcor+i)  .eq.z(izcor+i)) .or.  &
          .not.(z(izcor+ip1).eq.z(izcor+ip1)))  cycle   ! IP1
      if (np2.eq.0) goto 106
      do k=1,np2
        if (ir(1,k).eq.ip1 .and. ir(2,k).eq.j)  goto 107
      enddo                    ! K
106   np2 = np2+1
      if (np2 .gt. nr) then
        write(chain,'(1PG11.4)') conval
        call gcont_message(seve%w,'RGMAP','Contour storage exhausted for '//  &
        chain)
        return
      endif
      ir(1,np2) = ip1
      ir(2,np2) = j
      ix = ip1
      iy = j
      idx = -1
      idy = 0
      is = 1
    !!Print *,'DRLINE 5 ',ix,iy,' ids ',idx,idy,is
      call drline (nx,ny,z,vectd,lastd,ir,error)
      if (error) return
107   continue
    enddo  ! IP1
  enddo  ! JP1
end subroutine stline
!
subroutine drline (nx,ny,z,vectd,lastd,ir,error)
  use gcont_contour
  use gcont_interfaces, only : gcont_message
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! 	This routine traces a contour line when given the beginning by STLINE.
  ! 	Transformations can be added by deleting the statement functions for
  ! 	FX and FY in DRLINE and MINMAX and adding external functions.
  ! 	X=1. at Z(1,J), X=FLOAT(M) at Z(M,J). X takes on non-integer values.
  ! 	Y=1. at Z(I,1), Y=FLOAT(N) at Z(I,N). Y takes on non-integer values.
  ! Arguments :
  !	NX	I	Number of pixels along X axis		Input
  !	NY	I	Number of pixels along Y axis		Input
  !	Z	R*4 (*)	Array of values				Input
  !	VECTD	Ext	Vector drawing function
  !	LASTD	Ext	End of contour drawing function
  !	IR	I (*)	Workspace for contour storage
  !		It is assumed that all the necessary setup
  !		have been done before the call to DRLINE
  ! Subroutines :
  !	VECTD, LASTD, ISHIFT
  !---------------------------------------------------------------------
  integer :: nx                     !
  integer :: ny                     !
  real :: z(*)                      !
  external :: vectd                 !
  external :: lastd                 !
  integer :: ir(2,*)                !
  logical, intent(inout) :: error   ! Error return
  ! Local
  integer :: m,n,ix0,iy0,is0,ix2,iy2,isub,isbig
  integer :: ix3,iy3,ix4,iy4
  real :: x,y,xold,yold,z1,z2,z3,z4
  character(len=80) :: mess
  logical :: ipen,ipeno
  !
  data ipen,ipeno /.true.,.true./
  !
  ! Statement functions
  !      FX(X,Y) = X and FY(X,Y) = Y
  !
  !      C(P1,P2) = (P1-CV)/(P1-P2)
  !     cut(cv,p1,p2) = (p1-cv)/(p1-p2)
  !
  ! Code
  m = nx
  n = ny
  !
  ix0 = ix
  iy0 = iy
  is0 = is
  !
  ix2 = ix+inx(is)
  iy2 = iy+iny(is)
  z1 = z((iy-1) *nx+ix )
  z2 = z((iy2-1)*nx+ix2)
  ipen = z1.eq.z1 .and. z2.eq.z2  ! Never connect with NaNs
  if (ioffp.ne.0) then  ! IOFFP is 1 when blanking must be checked, 0 if not
    ipen = ipen .and.  &
           abs(z1-spval).gt.epsval .and.  &
           abs(z2-spval).gt.epsval
  endif
  ipeno = ipen
  !
  if (idx.ne.0) then
    y = iy
    isub = ix+idx
    IF ((iy-1)*nx+ix.gt.NX*NY) Print *,'Invalid Z adress'
    IF ((iy-1)*nx+isub.gt.NX*NY) Print *,'Invalid Z adress ISUB,IY'
    x = cut(cv,z((iy-1)*nx+ix),z((iy-1)*nx+isub)) * float(idx) + float(ix)
    !*SG** if (.not.(x.eq.x)) x = float(ix)+float(idx)
  else
    x = ix
    isub = iy+idy
    IF ((iy-1)*nx+ix.gt.NX*NY) Print *,'Invalid Z adress'
    IF ((isub-1)*nx+ix.gt.NX*NY) Print *,'Invalid Z adress IX,ISUB'
    y = cut(cv,z((iy-1)*nx+ix),z((isub-1)*nx+ix)) * float(idy) + float(iy)
    !*SG** if (.not.(y.eq.y)) y = float(iy)+float(idy)
  endif
  call vectd (x,y,error)
  if (error) return
  ! call frstd (x,y)  ! (fx(x,y),fy(x,y))
  !
  ! Loop on pixels around
100 is = is+1
  if (is .gt. 8) is = is-8
  idx = inx(is)
  idy = iny(is)
  ix2 = ix+idx
  iy2 = iy+idy
  !
  ! The code below was crashing on complex images if the 
  !       if (np2.gt.nr) goto 120  
  ! line near the end of code was commented out... (see comments
  ! later)
  !
  !!if (iss .eq. 0) then
  !!  if (ix2.gt.m .or. iy2.gt.n .or. ix2.lt.1 .or. iy2.lt.1)  goto 120
  !!endif
  !
  ! With the line commended out, we must take care that 
  ! out of bound condition may happen even if ISS = 1
  if (ix2.gt.m .or. iy2.gt.n .or. ix2.lt.1 .or. iy2.lt.1)  then
    !
    ! Direct close for ISS = 0 (ISS=0 indicates the beginning of segments)
    if (iss.eq.0) goto 120
    !
    ! Close contour at edges if ISS = 1
    write(mess,'(A,I0,A,I0,A)') 'Contour exiting from edge (',ix,',',iy,')'
    call gcont_message(seve%d,'RGMAP',mess)
    np2 = np2+1
    if (np2.gt.nr) np2 = 1
    ir(1,np2) = ix
    ir(2,np2) = iy
    goto 120
  endif
  !
  if (cv.le.z((iy2-1)*nx+ix2)) then
    is = is+4
    ix = ix2
    iy = iy2
    goto 100
  endif
  if (is/2*2 .eq. is) goto 100
  !
  isbig = is+(8-is)/6*8
  ix3 = ix+inx(isbig-1)
  iy3 = iy+iny(isbig-1)
  ix4 = ix+inx(isbig-2)
  iy4 = iy+iny(isbig-2)
  ipeno = ipen
  if (iss .eq. 0) then
    if (ix3.gt.m .or. iy3.gt.n .or. ix3.lt.1 .or. iy3.lt.1)  goto 120
    if (ix4.gt.m .or. iy4.gt.n .or. ix4.lt.1 .or. iy4.lt.1)  goto 120
  endif

  z1 = z((iy -1)*nx+ix )
  z2 = z((iy2-1)*nx+ix2)
  z3 = z((iy3-1)*nx+ix3)
  z4 = z((iy4-1)*nx+ix4)
  ipen = z1.eq.z1 .and. z2.eq.z2 .and. z3.eq.z3 .and. z4.eq.z4  ! Never connect with NaNs
  if (ioffp.ne.0) then
    ipen = ipen .and.  &
           abs(z1-spval).gt.epsval .and.  &
           abs(z2-spval).gt.epsval .and.  &
           abs(z3-spval).gt.epsval .and.  &
           abs(z4-spval).gt.epsval
  endif
  !
  if (idx.ne.0) then
    y = iy
    isub = ix+idx
    x = cut(cv,z((iy-1)*nx+ix),z((iy-1)*nx+isub)) * float(idx) + float(ix)
    !*SG** if (.not.(x.eq.x)) x = float(ix)+float(idx)
  else
    x = ix
    isub = iy+idy
    y = cut(cv,z((iy-1)*nx+ix),z((isub-1)*nx+ix)) * float(idy) + float(iy)
    !*SG** if (.not.(y.eq.y)) y = float(iy)+float(idy)
  endif
  !
  if (ipen) then
    if (.not.ipeno) then
      call lastd (error)
      if (error) return
      call vectd (xold,yold,error)
      if (error) return
    endif
    call vectd (x,y,error)
    if (error) return
  endif
  !
  xold = x
  yold = y
  !
  ! Store start of contour
  if (is .eq. 1) then
    np2 = np2+1
    !! With the condition below, the previous error case near
    ! label 100 (the one with debug message) never happens
    !! if (np2.gt.nr) goto 120  
    if (np2.gt.nr) then
      np2 = 1
      ir(1,np2) = ix
      ir(2,np2) = iy
      goto 120
    else
      ir(1,np2) = ix
      ir(2,np2) = iy
    endif
  endif
  if (iss .eq. 0) goto 100
  if (ix.ne.ix0 .or. iy.ne.iy0 .or. is.ne.is0) goto 100
  !
  ! End of line
120 call lastd(error)
  !
contains
  function cut(cv,p1,p2)
    real(kind=4) :: cut  ! Function value on return
    real(kind=4), intent(in) :: cv  !
    real(kind=4), intent(in) :: p1  !
    real(kind=4), intent(in) :: p2  !
    cut = (p1-cv)/(p1-p2)
  end function cut
end subroutine drline
!
subroutine conblk(blank,value,tol)
  use gcont_interfaces, except_this=>conblk
  use gcont_contour
  !---------------------------------------------------------------------
  ! @ public
  !	Set blanking value for Regular mapping
  ! Arguments :
  !	BLANK	L	Blanking or not			Input
  !	VALUE	R*4	The blanking value		Input
  !	TOL	R*4	The tolerance			Input
  ! No subroutines
  !---------------------------------------------------------------------
  logical :: blank                  !
  real :: value                     !
  real :: tol                       !
  call conbdn
  !
  ! IOFFP .EQ. 0 means no blanking value
  ! SPVAL is the blanking value, and EPSVAL the tolerance
  !
  if (blank) then
    ioffp = 1
    spval = value
    epsval = tol
  else
    ioffp = 0
  endif
end subroutine conblk
!
subroutine conbit(nx,ny,error)
  use gcont_interfaces, except_this=>conbit
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !	Set up the Bit arithmetic for Regular mapping
  ! Arguments :
  !	NX	I	Number of I pixels		Input
  !	NY	I	Number of J Pixels		Input
  !	ERROR	L	Error return
  ! No subroutines
  !---------------------------------------------------------------------
  integer :: nx                     !
  integer :: ny                     !
  logical :: error                  !
  ! Local
  character(len=message_length) :: messag
  !
  ! Nonsmoothing Version
  if (nx.gt.1 .and. ny.gt.1 .and. nx.lt.32767 .and. ny.lt.32767)  return
  write (messag,1000) nx,ny
  call gcont_message(seve%e,'RGMAP',messag)
  error = .true.
  !
1000 format('Dimension error ',i12,' by ',i12)
end subroutine conbit
!
subroutine conlev(fact,array,n)
  use gcont_contour
  !---------------------------------------------------------------------
  ! @ public
  !	Setup the array of contour values
  ! Arguments :
  !	FACT	R*4	Multiplicative factor
  !	ARRAY	R*4	Contour value array
  !	N	I	Dimension of array
  ! No subroutine
  !---------------------------------------------------------------------
  real :: fact                      !
  real :: array(*)                  !
  integer :: n                      !
  ! Local
  integer :: i
  !
  qlev = fact
  ncl = min(n,maxcl)
  do i=1,ncl
    clev(i) = array(i)
  enddo
end subroutine conlev

subroutine curse(line,error)
  use gildas_def
  use phys_const
  use gbl_format
  use gbl_message
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>curse
  use sic_types
  use greg_kernel
  use greg_pen
  use greg_rg
  use greg_wcs
  !---------------------------------------------------------------------
  ! @ private
  ! GREG	Support routine for command
  !	DRAW	Code
  !		LINE	[X Y]	[/USER]	[/BOX]	[/CHARACTER] [/CLIP]
  !		MARKER
  !		ARROW
  !		TEXT	[X Y "texte a ecrire" [Center [Orientation]]]
  !		VALUE
  ! Uses the interactive cursor to perform various functions.
  !	The cursor routine of GREG is GR_CURS
  ! Arguments :
  !	LINE	C*(*)	Command line		Input
  !	ERROR	L	Logical error flag	Output
  !
  ! Force the line style to solid for the end of an arrow	PV, 17-jul-87
  !---------------------------------------------------------------------
  character(len=*) :: line          !
  logical :: error                  !
  ! Global
  include 'gbl_memory.inc'
  ! Local
  character(len=*), parameter :: rname='DRAW'
  character(len=1) :: c,cucode,code
  character(len=80) :: chain
  character(len=10) :: cc
  character(len=256) :: string,string1,string2
  real(kind=4) :: value,fact,xtmp,ytmp
  real(kind=8) :: x,y,angsav
  integer(kind=4) :: nchar,i,lire,nl,ibox,kbox,jbox,icom,n,length,w_angle
  integer(kind=4) :: savangle,nc
  logical :: cursormode,doclip_soft,doclip_hard
  character(len=12) :: clipmode,keyword
  character(len=256) :: dummy
  integer(kind=4) :: ndiv,ier
  character(len=1), parameter :: backslash=char(92)
  integer(kind=4), parameter :: ntextclipmodes=2
  character(len=*), parameter :: textclipmodes(ntextclipmodes) = (/ 'SOFT','HARD' /)
  integer(kind=4), parameter :: nmodes=7
  character(len=*), parameter :: modes(nmodes) = (/  &
   'ARROW   ','CENTER  ','LINE    ','MARKER  ','RELOCATE','TEXT    ','VALUE   ' /)
  integer(kind=4), parameter :: max_integ=2147483647
  ! Array support
  type(sic_descriptor_t) :: desc,desc1,desc2
  type(sic_descriptor_t) :: inca1,inca2,inca3
  integer(kind=address_length) :: ipt,ipx,ipy
  integer(kind=4) :: lpt,lpx,lpy,istart
  integer(kind=index_length) :: ii,npx,npy,npt
  logical :: found,opened
  real(kind=4) :: rrr
  integer(kind=4) :: icc
  real(kind=8) :: sux,suy
  !
  error = .false.
  !
  ! MUST initialize NPX and the INCARNATIONS...
  npx = 0
  !
  inca1%type = 0
  inca1%readonly = .false.
  inca1%addr = 0
  inca1%ndim = 0
  inca1%dims(:) = 0
  inca1%size = 0
  inca1%status = 0
  !
  inca2%type = 0
  inca2%readonly = .false.
  inca2%addr = 0
  inca2%ndim = 0
  inca2%dims(:) = 0
  inca2%size = 0
  inca2%status = 0
  !
  inca3%type = 0
  inca3%readonly = .false.
  inca3%addr = 0
  inca3%ndim = 0
  inca3%dims(:) = 0
  inca3%size = 0
  inca3%status = 0
  !
  w_angle=u_angle
  savangle=u_angle
  ndiv=360
  if (i_system.eq.type_eq .or. i_system.eq.type_ic) ndiv=24
  ! no use working if command is not appropriate:
  if (sic_present(0,3)) then
    call sic_ke (line,0,1,dummy,nc,.true.,error)
    if (error) return
    call sic_ambigs(rname,dummy,keyword,i,modes,nmodes,error)
    if (error)  return
    code = dummy(1:1)
  endif
  !
  ! Turn off clipping by default. Turn on clipping with option /CLIP.
  noclip = .not.sic_present(4,0)  ! Global variable
  lire = sic_lire()
  !
  call draw_parse_coordmode(line,kbox,ibox,error)
  if (error)  goto 999
  jbox = ibox  ! ibox = 0 means auto corner choice => jbox will be the chosen corner
  !
  ! Find factor
  if (kbox.eq.0) then
    fact = 1.
  elseif (kbox.eq.1) then
    fact = cdef*expand
  endif
  !
  ! Insufficient arguments : call the cursor
  icom = 0
  if (.not.sic_present(0,3)) then
    if (gtg_curs()) then
      cursormode= .true.
      call sic_ke (line,0,1,dummy,nc,.false.,error)
      code = dummy(1:1)
      goto 20
    else
      call greg_message(seve%e,rname,'Cursor not available on this device')
      goto 999
    endif
  else
    call sic_ke (line,0,1,dummy,nc,.false.,error)
    if (error) goto 999
    code = dummy(1:1)
    cursormode = .false.
    !
    if (kbox.eq.-1.or.kbox.le.-3) then  ! USER Coordinates
      ! X
      npx = 0
      call sic_ch(line,0,2,dummy,nc,.true.,error)
      if (error) goto 999
      if (dummy.eq.'*') then  ! Current pen X position
        ! No transformation, just ensure globals are updated. Use kbox==2 for this.
        call draw_setcursor_relative('X',dble(xp),2,0,error)
        if (error)  goto 999
      else
        found = .false.
        call sic_descriptor (dummy,desc,found)
        if (.not.found .or. desc_nelem(desc).le.1) then
          ! Not a Sic variable, or a scalar variable, or an array variable
          ! with single element
          call sic_r8(line,0,2,x,.false.,error)
          if (error) goto 999
          call draw_setcursor_relative('X',x,kbox,ibox,error)
          if (error)  goto 999
        else
          ! Array variable
          npx = desc%dims(1)
          call sic_incarnate(fmt_r8,desc,inca1,error)
          if (error) then
            call greg_message(seve%e,rname,'Invalid X Array Format')
            goto 999
          endif
          ipx = gag_pointer(inca1%addr,memory)
          lpx = 2
        endif
      endif
      ! Y
      npy = 0
      call sic_ch(line,0,3,dummy,nc,.true.,error)
      if (error) goto 999
      if (dummy.eq.'*') then  ! Current pen Y position
        ! No transformation, just ensure globals are updated. Use kbox==2 for this.
        call draw_setcursor_relative('Y',dble(yp),2,0,error)
        if (error)  goto 999
      else
        found = .false.
        call sic_descriptor(dummy,desc,found)
        if (.not.found .or. desc_nelem(desc).le.1) then
          ! Not a Sic variable, or a scalar variable, or an array variable
          ! with single element
          call sic_r8 (line,0,3,y,.false.,error)
          if (error) goto 999
          call draw_setcursor_relative('Y',y,kbox,ibox,error)
          if (error)  goto 999
        else
          ! Array variable
          npy = desc%dims(1)
          call sic_incarnate(fmt_r8,desc,inca2,error)
          if (error) then
            call greg_message(seve%e,rname,'Invalid Y Array Format')
            goto 999
          endif
          ipy = gag_pointer(inca2%addr,memory)
          lpy = 2
          if ( (npx.eq.0.and.npy.gt.0) .or. (npx.gt.0.and.npy.eq.0)) then
            call greg_message(seve%e,rname,'Two arrays or none')
            goto 999
          endif
          if (npy.ne.npx) then
            call greg_message(seve%e,rname,'Inconsistent sizes')
            goto 999
          endif
        endif
      endif
      !
    elseif (kbox.eq.-2) then  ! USER with ABSOLUTE
      ! X
      npx = 0
      lpx = 0
      ipx = 0
      call sic_ch(line,0,2,dummy,nc,.true.,error)
      if (error) goto 999
      found = .false.
      call sic_descriptor (dummy,inca1,found)
      if (.not.found) then
        call sic_ch(line,0,2,string1,length,.true.,error)
        if (error) goto 999
      else
        if (inca1%type.le.0) then
          call greg_message(seve%e,rname,'X Array must be of type CHAR')
          goto 999
        endif
        desc1%type=inca1%type
        desc1%addr=inca1%addr
        call destoc(desc1%type,desc1%addr,string1)
        if (inca1%ndim.gt.0) then
          npx = inca1%dims(1)
          lpx = inca1%type
          ipx = gag_pointer(inca1%addr,memory)
        endif
      endif
      ! Y
      npy = 0
      lpy = 0
      ipy = 0
      call sic_ch(line,0,3,dummy,nc,.true.,error)
      if (error) goto 999
      found = .false.
      call sic_descriptor (dummy,inca2,found)
      if (.not.found) then
        call sic_ch (line,0,3,string2,length,.true.,error)
        if (error) goto 999
      else
        if (inca2%type.le.0) then
          call greg_message(seve%e,rname,'Y Array must be of type CHAR')
          goto 999
        endif
        desc2%type=inca2%type
        desc2%addr=inca2%addr
        call destoc(desc2%type,desc2%addr,string2)
        if (inca2%ndim.gt.0) then
          npy = inca2%dims(1)
          lpy = inca2%type
          ipy = gag_pointer(inca2%addr,memory)
        endif
      endif
      if ( (npx.eq.0.and.npy.gt.0) .or. (npx.gt.0.and.npy.eq.0)) then
        call greg_message(seve%e,rname,'Two arrays or none')
        goto 999
      endif
      if (npy.ne.npx) then
        call greg_message(seve%e,rname,'Inconsistent sizes')
        goto 999
      endif
      if (npx.eq.0) then
        call draw_setcursor_absolute(string1,string2,kbox,error)
        if (error)  goto 999
      endif
      !
    else  ! BOX Coordinates or CHARACTER
      npx = 0  ! Arrays not supported
      npy = 0
      !
      ! Parse X value
      call sic_ch(line,0,2,dummy,nc,.true.,error)
      if (error) goto 999
      if (dummy.eq.'*') then  ! Current pen X position
        ! No transformation, just ensure globals are updated. Use kbox==2 for this.
        call draw_setcursor_relative('X',dble(xp),2,0,error)
        if (error)  goto 999
      else
        call sic_r8 (line,0,2,x,.true.,error)
        if (error) goto 999
        call draw_setcursor_relative('X',x,kbox,ibox,error)
        if (error)  goto 999
      endif
      ! Parse Y value
      call sic_ch (line,0,3,dummy,nc,.true.,error)
      if (error) goto 999
      if (dummy.eq.'*') then  ! Current pen Y position
        ! No transformation, just ensure globals are updated. Use kbox==2 for this.
        call draw_setcursor_relative('Y',dble(yp),2,0,error)
        if (error)  goto 999
      else
        call sic_r8 (line,0,3,y,.true.,error)
        if (error) goto 999
        call draw_setcursor_relative('Y',y,kbox,ibox,error)
        if (error)  goto 999
      endif
    endif
  endif
  !
  ! XCURSE,YCURSE Paper coordinates, UCURSE(1),UCURSE(2) User coordinates and
  ! Code are now defined if We are not in array mode (i.e., npx=0 , array mode
  ! not supported for /CHAR or /BOX modes)
10 continue
  if (sic_present(0,1)) then
    cursormode = .false.
  else
    code = cucode
  endif
  !
  ! Position
  if (code.eq.'R') then
    if (npx.eq.0) then         ! normal mode
      !!Print *,'Calling RELOCATE ',xcurse,ycurse
      call grelocate(xcurse,ycurse)
      error = gterrtst()
      if (error) goto 999
      call print_line(line,kbox,jbox,'RELOCATE',fact)
    else
      do ii=1,npx
        if (kbox.ne.-2) then
          call arraydraw1(code,memory(ipx),memory(ipy),kbox)
          ipx=ipx+lpx
          ipy=ipy+lpy
        else
          call arraydraw2(code,string1,lpx,string2,lpy,error)
          if (error) goto 999
          desc1%addr=desc1%addr+lpx
          call destoc(desc1%type,desc1%addr,string1)
          desc2%addr=desc2%addr+lpy
          call destoc(desc2%type,desc2%addr,string2)
        endif
      enddo
    endif
    !
    ! Line
  elseif (code.eq.'L') then
    call gtsegm('LINE',error)
    if (penupd) call setpen (cpen)
    icom = icom+1
    if (npx.eq.0) then         ! normal mode
      !!Print *,'Calling DRAW ',xcurse,ycurse
      call gdraw(xcurse,ycurse)
      error = gterrtst()
      if (error) goto 999
      call print_line(line,kbox,jbox,'LINE',fact)
    else                       ! array mode
      do ii=1,npx
        if (kbox.ne.-2) then
          call arraydraw1(code,memory(ipx),memory(ipy),kbox)
          ipx=ipx+lpx
          ipy=ipy+lpy
        else
          call arraydraw2(code,string1,lpx,string2,lpy,error)
          if (error) goto 999
          desc1%addr=desc1%addr+lpx
          call destoc(desc1%type,desc1%addr,string1)
          desc2%addr=desc2%addr+lpy
          call destoc(desc2%type,desc2%addr,string2)
        endif
      enddo
    endif
    call gtsegm_close(error)
    !
    ! Marker
  elseif (code.eq.'M') then
    call gtsegm('MARKER',error)
    if (penupd) call setpen(cpen)
    call setdas(1)
    icom = icom+1
    if (npx.eq.0) then
      call grelocate(xcurse,ycurse)
      call gr_point(nsides,istyle)
      error = gterrtst()
      if (error) goto 999
      call print_line(line,kbox,jbox,'MARKER',fact)
    else
      do ii=1,npx
        if (kbox.ne.-2) then
          call arraydraw1(code,memory(ipx),memory(ipy),kbox)
          ipx=ipx+lpx
          ipy=ipy+lpy
        else
          call arraydraw2(code,string1,lpx,string2,lpy,error)
          if (error) goto 999
          desc1%addr=desc1%addr+lpx
          call destoc(desc1%type,desc1%addr,string1)
          desc2%addr=desc2%addr+lpy
          call destoc(desc2%type,desc2%addr,string2)
        endif
      enddo
    endif
    call gtsegm_close(error)
    !
    ! Arrow
  elseif (code.eq.'A') then
    call gtsegm('ARROW',error)
    if (penupd) call setpen(cpen)
    if (npx.eq.0) then
      icom = icom+2            ! Creates two segments
      call garrow(xcurse,ycurse)
      error = gterrtst()
      if (error) goto 999
      call print_line(line,kbox,jbox,'ARROW',fact)
    else
      icom = icom+1            ! Creates one segment only!
      do ii=1,npx
        if (kbox.ne.-2) then
          call arraydraw1(code,memory(ipx),memory(ipy),kbox)
          ipx=ipx+lpx
          ipy=ipy+lpy
        else
          call arraydraw2(code,string1,lpx,string2,lpy,error)
          if (error) goto 999
          desc1%addr=desc1%addr+lpx
          call destoc(desc1%type,desc1%addr,string1)
          desc2%addr=desc2%addr+lpy
          call destoc(desc2%type,desc2%addr,string2)
        endif
      enddo
    endif
    call gtsegm_close(error)
    !
    ! Help
  elseif (code.eq.'H') then
    line = ' '
    call grelocate(xp,yp)
    error = gterrtst()
    if (error) goto 999
    noclip = .false.
    call greg_message(seve%i,rname,'Type HELP DRAW if you are lost...')
    cursormode = .false.
    goto 20
    !
    ! Exit
  elseif (code.eq.'E') then
    line = ' '
    call grelocate(xp,yp)
    error = gterrtst()
    if (error) goto 999
    noclip = .false.
    cursormode = .false.
    goto 20
    !
  elseif (code.eq.'T'.or.code.eq.'C') then  ! Text and Centered Text
    if (noclip) then
      doclip_soft = .false.
      doclip_hard = .false.
    else
      dummy = 'SOFT'  ! Default
      call sic_ke(line,4,1,dummy,nc,.false.,error)
      if (error)  return
      call sic_ambigs('DRAW /CLIP',dummy,clipmode,n,textclipmodes,ntextclipmodes,error)
      if (error)  return
      doclip_soft = clipmode.eq.'SOFT'
      doclip_hard = clipmode.eq.'HARD'
    endif
    !
    i = icente
    if (.not.sic_present(0,4)) then
      call sic_wprn('Text :',string,nchar)
      if (nchar.eq.0.and.npx.ne.0) then
        goto 999
      elseif (nchar.eq.0) then
        goto 20
      else
        ipt = 0
        npt = 0
        lpt = 0
      endif
    else
      call sic_ch (line,0,4,string,nc,.true.,error)
      if (error) goto 999
      ! Small patch to avoid to translate "A" even if A is a known
      ! variable...
      istart = sic_start(0,4)
      if (line(istart:istart).eq.'"') then
        found = .false.
        !
        ! Same patch if an implicit formatting was used
      elseif  (line(istart:istart).eq.'''') then
        found = .false.
      else
        found = .false.
        call sic_descriptor (string,inca3,found)
      endif
      if (.not.found) then
        nchar = nc
        ipt = 0
        npt = 0
        lpt = 0
      else
        ! Found a Sic variable
        npt = desc_nelem(inca3)
        ipt = gag_pointer(inca3%addr,memory)
        lpt = inca3%type
        if (npt.eq.1) then  ! Scalar-like character variable
          ! We can as well write a numeric variable as a formatted string...
          if (lpt.le.0) then
            ! Will write in shortest format the Array value:
            if (lpt.eq.fmt_r4) then
              call r4tor4(memory(ipt),rrr,1)
            elseif (lpt.eq.fmt_r8) then
              call r8tor4(memory(ipt),rrr,1)
            elseif (lpt.eq.fmt_i4) then
              call i4tor4(memory(ipt),rrr,1)
            else
              goto 998
            endif
            call conecd(rrr,string,nchar)
          else
            desc%type = lpt
            desc%addr = inca3%addr
            call destoc(desc%type,desc%addr,string)  ! First string is present
            nchar=lpt  ! or LENC(STRING) ?
          endif
          npt=0
          ipt=0
          lpt=0
        else  ! Array variable
          if (npx.eq.0) then
            call greg_message(seve%e,rname,'Three arrays or none')
            goto 999
          endif
          if (npt.ne.npx) then
            call greg_message(seve%e,rname,'Inconsistent sizes')
            goto 999
          endif
          if (lpt.le.0) then  ! Numeric array
            ! Will write in shortest format the numeric Array value:
            if (lpt.eq.fmt_r4) then
              call r4tor4(memory(ipt),rrr,1)
            elseif (lpt.eq.fmt_r8) then
              call r8tor4(memory(ipt),rrr,1)
            elseif (lpt.eq.fmt_i4) then
              call i4tor4(memory(ipt),rrr,1)
            else
              goto 998
            endif
            call conecd(rrr,string,nchar)
          else  ! Character array
            desc%type = lpt
            desc%addr = inca3%addr
            call destoc(desc%type,desc%addr,string)  ! First string is present
            nchar=lpt
          endif
        endif
      endif
    endif
    ! Find centering option
    if (code.eq.'C') then
      if (.not.sic_present(0,5)) then
        call sic_wprn('Centering code [0-9] :',cc,i)
        if (i.ne.0) then
          length = lenc(cc)
          i = 0
          read(cc(1:length),*,iostat=ier) i
          if (ier.ne.0 .or. i.lt.0 .or. i.gt.9) then
            call greg_message(seve%e,rname,'Invalid Centering Code')
            goto 20
          endif
        else
          i = icente
        endif
      else
        call sic_i4 (line,0,5,i,.true.,error)
        if (error) goto 999
      endif
    else
      ! centering option optional in text mode
      call sic_i4 (line,0,5,i,.false.,error)
      if (error) goto 999
    endif
    ! Orientation
    angsav = tangle
    if (sic_present(0,6)) then
      call sic_r8 (line,0,6,tangle,.true.,error)
      if (error) return
    endif
    !
    if (penupd) call setpen (cpen)
    icom = icom+1
    opened = .false.
    !
    if (npx.eq.0) then
      if (doclip_hard) then
        call grclip(xcurse,ycurse,icc)
      else
        icc = 0
      endif
      if (icc.ne.0) then
        call greg_message(seve%w,rname,'"'//string(1:nchar)//'"  was clipped')
      else
        call gtsegm('TEXT',error)
        if (error)  goto 999
        opened = .true.
        ! --- Almost identical to draw_text_relative, except coordinates ---
        ! --- are already translated from KBOX to physical ---
        if (i.eq.0) i = centre(xcurse,ycurse)
        call grelocate(xcurse,ycurse)
        call putlabel(nchar,string,i,tangle,doclip_soft)
        ! ---
        call print_text(line,kbox,jbox,'TEXT',fact,string(1:nchar),i,tangle)
      endif
    else
      do ii=1,npx
        !
        ! Text string
        if (lpt.ne.0) then
          if (lpt.lt.0) then
            if (lpt.eq.fmt_r4) then
              call r4tor4(memory(ipt),rrr,1)
            elseif (lpt.eq.fmt_r8) then
              call r8tor4(memory(ipt),rrr,1)
            elseif (lpt.eq.fmt_i4) then
              call i4tor4(memory(ipt),rrr,1)
            endif
            call conecd(rrr,string,nchar)
          else
            call destoc(desc%type,desc%addr,string)
          endif
        endif
        !
        ! Coordinates
        if (kbox.ne.-2) then
          ! Relative coordinates
          call r8tor8(memory(ipx),x,1)
          call r8tor8(memory(ipy),y,1)
        else
          ! Absolute coordinates converted to relative
          call destoc(desc1%type,desc1%addr,string1)
          call sic_sexa(string1,lpx,x,error)
          if (error)  goto 999
          if (i_system.eq.type_eq .or. i_system.eq.type_ic) then
            x = x*pi/12.0d0
          else
            x = x*pi/180.0d0
          endif
          call destoc(desc2%type,desc2%addr,string2)
          call sic_sexa(string2,lpy,y,error)
          if (error)  goto 999
          y = y*pi/180.0d0
          sux = x
          suy = y
          call abs_to_rel(gproj,sux,suy,x,y,1)
        endif
        !
        if (doclip_hard) then
          call us8_to_int(x,y,xtmp,ytmp,1)
          call grclip(xtmp,ytmp,icc)
        else
          icc = 0
        endif
        if (icc.ne.0) then
          call greg_message(seve%w,rname,'"'//string(1:nchar)//'"  was clipped')
        else
          if (.not.opened) then
            call gtsegm('TEXT',error)
            if (error)  goto 999
            opened = .true.
          endif
          call draw_text_relative(x,y,string,nchar,kbox,i,doclip_soft)
        endif
        !
        ! Next positions
        if (kbox.ne.-2) then
          ipx=ipx+lpx
          ipy=ipy+lpy
        else
          desc1%addr=desc1%addr+lpx
          desc2%addr=desc2%addr+lpy
        endif
        ! Next text string
        if (lpt.ne.0) then
          if (lpt.lt.0) then
            ! Will write in shortest format the Array value
            if (lpt.eq.fmt_r4 .or. lpt.eq.fmt_i4) then
              ipt=ipt+1
            elseif (lpt.eq.fmt_r8 .or. lpt.eq.fmt_i8) then
              ipt=ipt+2
            endif
          else
            desc%addr=desc%addr+lpt
          endif
        endif
      enddo
    endif
    tangle = angsav
    if (opened)  call gtsegm_close(error)
    !
    ! Map value
  elseif (code.eq.'V') then
    if (npx.eq.0)then
      if (rg%status.ne.code_pointer_null) then
        ! Regval is used
        call regval(rg%data,ucurse(1),ucurse(2),value,.true.)
      endif
      call print_position(w_angle)
    endif
    goto 20
    !
    ! Delete
  elseif (code.eq.'D' .and. icom.gt.0 .and. cursormode) then
    call gtdls
    penupd = .true.            ! To get proper pen attributes later
    gxp = -1e10
    gyp = -1e10
    error = gterrtst()
    if (error) goto 999
    call gtview('Update')  ! A segment was deleted: redraw all windows
    !
    icom = icom-1
    if (lire.eq.0) then
      chain = 'GTVL'//backslash//'CLEAR SEGMENT'
      call sic_log (chain,18,lire)
      call sic_insert (chain)
    endif
    goto 20
    !
    ! Anything else
  else
    if (code.eq.'0') then
      w_angle=u_radian
    elseif (code.eq.'1') then
      w_angle=u_degree
    elseif (code.eq.'2') then
      w_angle=u_minute
    elseif (code.eq.'3') then
      w_angle=u_second
    endif
    call print_position (w_angle)
    !     Pas de log:
    goto 20
  endif
  !
  ! Update the LOG file for this command
  if (lire.eq.0) then
    nl = lenc(line)
    call sic_blanc(line,nl)
    nl = nl+1
    line(nl:nl) = ' '
    nl = nl+1
    if (npx.eq.0) then         ! not in array mode
      if (kbox.eq.-3) then
        line(nl:) = ' /USER DEGREES'
        nl = nl+14
      elseif (kbox.eq.-4) then
        line(nl:) = ' /USER MINUTES'
        nl = nl+14
      elseif (kbox.eq.-5) then
        line(nl:) = ' /USER SECONDS'
        nl = nl+14
      elseif (kbox.eq.-2) then
        line(nl:) = ' /USER ABSOLUTE'
        nl = nl+15
      elseif (kbox.eq.-1) then
        line(nl:) = ' /USER'
        nl = nl+6
      elseif (kbox.eq.0) then
        c = char(jbox+ichar('0'))
        line(nl:) = ' /BOX '//c
        nl = nl+7
      else
        c = char(jbox+ichar('0'))
        line(nl:) = ' /CHARACTER '//c
        nl = nl+13
      endif
      if (sic_present(4,0)) then
        line(nl:) = ' /CLIP'
        nl = nl+6
      endif
    endif
    call sic_log (line,nl,lire)
    call sic_insert (line(1:nl))
  endif
  !
  ! Return if complete command
20 continue
  if (cursormode) then
    ! Else loop over with the cursor
    call gr_curs(ucurse(1),ucurse(2),xcurse,ycurse,cucode)
    error = (gterrtst().or.code.eq.char(3).or.sic_ctrlc())
    if (error) goto 999
    ! map codes returned by ButtonPress events to keycodes
    if (cucode.eq.'^') then
      cucode = 'R'
    elseif (code.eq.'&') then
      cucode = 'L'
    elseif (code.eq.'*') then
      cucode = 'E'
    endif
    ! Find position
    if (ibox.eq.0) jbox = voisin(xcurse,ycurse)
    cursor_code = cucode
    goto 10
  else
    if (rg%status.ne.code_pointer_null) then
      if (rg%xinc.ne.0) then
        x = (ucurse(1)-rg%xval)/rg%xinc + rg%xref
      else
        x = 0
      endif
      if (rg%yinc.ne.0) then
        y = (ucurse(2)-rg%yval)/rg%yinc + rg%yref
      else
        y = 0
      endif
      !     defines the PIX_CURS SIC variable associated, since we exit to
      !     the main program where this variable may be examined.
      if (abs(x).le.max_integ.and.abs(y).le.max_integ) then
        pixcurse(1) = nint(x)
        pixcurse(2) = nint(y)
      else
        pixcurse(1) = 0
        pixcurse(2) = 0
      endif
    else
      pixcurse(1) = 0
      pixcurse(2) = 0
    endif
    noclip =.false.
    ! Volatilize the incarnations
    call sic_volatile(inca3)
    call sic_volatile(inca2)
    call sic_volatile(inca1)
    return
  endif
  !
998 call greg_message(seve%e,rname,'Unsupported Array-to-Text Conversion')
999 error = .true.
  noclip =.false.
  ! Volatilize the incarnations
  call sic_volatile(inca3)
  call sic_volatile(inca2)
  call sic_volatile(inca1)
  return
end subroutine curse
!
subroutine draw_parse_coordmode(line,kbox,ibox,error)
  use gbl_message
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>draw_parse_coordmode
  use greg_kernel
  use greg_wcs
  !---------------------------------------------------------------------
  ! @ private
  ! Parse command line to retrieve the coordinates conversion mode, i.e.
  ! how the input coordinates have to be understood
  !
  !  kbox < 0: user coordinates
  !  kbox = 0: physical coordinates from box "corner"
  !  kbox = 1: character coordinates from box "corner"
  !
  !  ibox = -1   irrelevant
  !  ibox = 1-9  the box "corner" to be used if relevant
  !  ibox = 0    automatic corner choice if cursor mode, corner 1 otherwise
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line
  integer(kind=4),  intent(out)   :: kbox
  integer(kind=4),  intent(out)   :: ibox
  logical,          intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='DRAW'
  integer(kind=4) :: n,nc
  logical :: user,box,car
  character(len=12) :: argum,name
  character(len=8), parameter :: ctype(5) = (/  &
    'ABSOLUTE','SECONDS ','MINUTES ','DEGREES ','RADIANS ' /)
  integer(kind=4), parameter :: optuser=1
  integer(kind=4), parameter :: optbox =2
  integer(kind=4), parameter :: optchar=3
  !
  user = sic_present(optuser,0)
  box  = sic_present(optbox, 0)
  car  = sic_present(optchar,0)
  !
  ! Parse conflicting options
  ! /USER       (1,0)
  ! /BOX        (2,0)
  ! /CHAR       (3,0)
  ! /CLIP (4,0)
  !
  if ((user.and.car).or.(user.and.box).or.(car.and.box)) then
    call greg_message(seve%e,rname,'Conflicting options')
    error = .true.
    return
  endif
  !
  ! /USER [Unit]
  if (user) then
    ! Patch [Unit]
    ibox = -1  ! Irrelevant
    ! Change U_ANGLE units into (silly) KBOX units
    kbox = u_angle-6
    if (kbox.gt.-3) kbox=-1    ! see definition of U_SECOND, etc..
    !
    if (sic_present(optuser,1)) then
      if (gproj%type.eq.p_none.and.i_system.eq.type_un) then
        call greg_message(seve%e,rname,'USER unit ignored when no projection')
        error = .true.
        return
      else
        call sic_ke (line,optuser,1,argum,nc,.true.,error)
        if (error)  return
        call sic_ambigs('DRAW /USER',argum,name,n,ctype,5,error)
        if (error)  return
        if (n.eq.1) then
          kbox = -2            ! Absolute
        elseif (n.eq.2) then
          kbox = -5            ! Seconds
        elseif (n.eq.3) then
          kbox = -4            ! Minutes
        elseif (n.eq.4) then
          kbox = -3            ! Degrees
        elseif (n.eq.5) then
          kbox = -1            ! Radians
        endif
      endif
    endif
    !
  elseif (box) then  ! /BOX I
    ibox = 0
    call sic_i4 (line,optbox,1,ibox,.false.,error)
    if (error)  return
    ibox = min(max(ibox,0),9)
    kbox = 0
    !
  elseif (car) then  ! /CHAR I
    ibox = 0
    call sic_i4 (line,optchar,1,ibox,.false.,error)
    if (error)  return
    ibox = min(max(ibox,0),9)
    kbox = 1
    !
  else  ! Default mode: use SET COORDINATES
    ibox = iboxd
    if (ibox.ge.0) then  ! Coordinates are from reference corner
      kbox = ibox/10
      ibox = mod(ibox,10)
    else                 ! Coordinates are USER (IBOXD=-1), put KBOX according to SET ANGLE
      ibox = -1
      ! Change U_ANGLE units into (silly) KBOX units
      kbox = u_angle-6
      if (kbox.gt.-3) kbox=-1  ! see definition of U_SECOND, etc..
    endif
  endif
  !
end subroutine draw_parse_coordmode
!
subroutine draw_setcursor_relative(ckind,v,kbox,ibox,error)
  use phys_const
  use gbl_message
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>draw_setcursor_relative
  use greg_kernel
  !---------------------------------------------------------------------
  ! @ private
  ! Set the current cursor position (user and physical) according to
  ! relative coordinate 'v' and system of coordinates (kbox,ibox)
  !
  !  kbox < 0: user coordinates
  !  kbox = 0: physical coordinates from box "corner"
  !  kbox = 1: character coordinates from box "corner"
  !  kbox = 2: absolute physical coordinates on page
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: ckind  ! Coordinate kind ('X' or 'Y')
  real(kind=8),     intent(in)    :: v
  integer(kind=4),  intent(in)    :: kbox,ibox
  logical,          intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='DRAW_SETCURSOR_RELATIVE'
  real(kind=4) :: fact,gx,gy
  !
  if (kbox.eq.-1 .or. kbox.le.-3) then  ! /USER, all except ABSOLUTE
    if (ckind.eq.'X') then
      if (kbox.eq.-3) then
        ucurse(1) = v*pi/180.0d0
      elseif (kbox.eq.-4) then
        ucurse(1) = v*pi/180.0d0/60.0d0
      elseif (kbox.eq.-5) then
        ucurse(1) = v*pi/180.0d0/3600.0d0
      else
        ucurse(1) = v  ! ZZZ
      endif
      if (axis_xlog) then
        if (ucurse(1).gt.0) then
          xcurse = gx1 + gux * (log(ucurse(1))-lux)
        else if (gux.gt.0) then
          xcurse = gx1
        else
          xcurse = gx2
        endif
      else
        xcurse = gx1 + gux * (ucurse(1)-gux1)
      endif
    elseif (ckind.eq.'Y') then
      if (kbox.eq.-3) then
        ucurse(2) = v*pi/180.0d0
      elseif (kbox.eq.-4) then
        ucurse(2) = v*pi/180.0d0/60.0d0
      elseif (kbox.eq.-5) then
        ucurse(2) = v*pi/180.0d0/3600.0d0
      else
        ucurse(2) = v  ! ZZZ
      endif
      if (axis_ylog) then
        if (ucurse(2).gt.0) then
            ycurse = gy1 + guy * (log(ucurse(2))-luy)
        else if (guy.gt.0) then
            ycurse = gy1
        else
            ycurse = gy2
        endif
      else
        ycurse = gy1 + guy * (ucurse(2)-guy1)
      endif
    endif
    !
  elseif (kbox.eq.0 .or. kbox.eq.1) then  ! /BOX or /CHAR
    if (kbox.eq.1) then
      fact = cdef*expand
    else
      fact = 1.
    endif
    call corner(max(ibox,1),gx,gy)  ! Corner offset
    !
    if (ckind.eq.'X') then
      xcurse = v*fact + gx
      if (axis_xlog) then
        ucurse(1) = exp((xcurse-gx1)/gux + lux)
      else
        ucurse(1) = (xcurse-gx1)/gux + gux1
      endif
    elseif (ckind.eq.'Y') then
      ycurse = v*fact + gy
      if (axis_ylog) then
        ucurse(2) = exp((ycurse-gy1)/guy + luy)
      else
        ucurse(2) = (ycurse-gy1)/guy + guy1
      endif
    endif
    !
  elseif (kbox.eq.2) then  ! Absolute physical coordinates on page
    if (ckind.eq.'X') then
      xcurse = v
      if (axis_xlog) then
        ucurse(1) = exp((xcurse-gx1)/gux + lux)
      else
        ucurse(1) = (xcurse-gx1)/gux + gux1
      endif
    elseif (ckind.eq.'Y') then
      ycurse = v
      if (axis_ylog) then
        ucurse(2) = exp((ycurse-gy1)/guy + luy)
      else
        ucurse(2) = (ycurse-gy1)/guy + guy1
      endif
    endif
    !
  else
    call greg_message(seve%e,rname,'Not supported KBOX')
    error = .true.
    return
  endif
  !
end subroutine draw_setcursor_relative
!
subroutine draw_setcursor_absolute(xc,yc,kbox,error)
  use phys_const
  use gbl_message
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>draw_setcursor_absolute
  use greg_wcs
  !---------------------------------------------------------------------
  ! @ private
  ! Set the current cursor position (user and physical) according to
  ! absolute coordinates (xc,yc) and system of coordinates (kbox)
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: xc,yc  ! Sexagesimal absolute coordinates
  integer(kind=4),  intent(in)    :: kbox   !
  logical,          intent(inout) :: error  !
  ! Local
  character(len=*), parameter :: rname='DRAW_SETCURSOR_ABSOLUTE'
  real(kind=8) :: x,y,sux,suy
  !
  if (kbox.eq.-2) then
    ! X
    call sic_sexa(xc,len_trim(xc),x,error)
    if (error)  return
    if (i_system.eq.type_eq .or. i_system.eq.type_ic) then
      x = x*pi/12.0d0
    else
      x = x*pi/180.0d0
    endif
    ! Y
    call sic_sexa(yc,len_trim(yc),y,error)
    if (error)  return
    y = y*pi/180.0d0
    ! Absolute to relative
    sux = x
    suy = y
    call abs_to_rel(gproj,sux,suy,x,y,1)
    ! Final job. Use kbox=-1, i.e. coordinates are now RADIANS
    call draw_setcursor_relative('X',x,-1,0,error)
    if (error)  return
    call draw_setcursor_relative('Y',y,-1,0,error)
    if (error)  return
    !
  else
    call greg_message(seve%e,rname,'Not supported KBOX')
    error = .true.
    return
  endif
  !
end subroutine draw_setcursor_absolute
!
subroutine gr_curs(xa,ya,x,y,code)
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>gr_curs
  use greg_kernel
  !---------------------------------------------------------------------
  ! @ public
  !	Gives the cursor position in both coordinate systems
  !	The cursor is preset at plot position (X,Y).
  !	Code is always one upper case letter.
  ! Arguments :
  !	XA,YA	R*8	User coordinates		Output
  !	X,Y	R*4	Plot coordinates		Input/Output
  !	CODE	C*1	Character stroke		Output
  !---------------------------------------------------------------------
  real(kind=8) :: xa                      !
  real(kind=8) :: ya                      !
  real(kind=4) :: x                       !
  real(kind=4) :: y                       !
  character(len=*) :: code          !
  ! Local
  logical :: error
  !
  error = .false.
  call gtcurs(x,y,code,error)
  if (error) then
    code = 'E'
    return
  endif
  call gr8_phys_user(x,y,xa,ya,1)
  call sic_upper(code)
end subroutine gr_curs
!
subroutine arrow(xa,ya)
  use gildas_def
  use phys_const
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>arrow
  use greg_kernel
  use greg_pen
  !---------------------------------------------------------------------
  ! @ private
  ! GREG	Internal routine
  !	Draws an arrow from current pen position to (XA,YA) (User)
  !	Entry GARROW does the same thing for paper coordinates (XZ,YZ)
  ! Arguments :
  !	XA,YA	R*8	User coordinates		Input
  !	XZ,YZ	R*4	Plot coordinates		Input
  ! Subroutines :
  !	GDRAW
  !
  ! Force the line style to solid for the end of an arrow	PV, 17-jul-87
  !---------------------------------------------------------------------
  real(kind=8) :: xa                      !
  real(kind=8) :: ya                      !
  ! Local
  real(kind=4) :: xz,yz,x,y,size,size2,alpha,x0,y0
  real(kind=4) :: x_head(5),y_head(5),x_head_c(8),y_head_c(8)
  integer(kind=size_length) :: npts
  logical :: error
  !
  ! Convert to plot coordinates
  if (axis_xlog) then
    x = gx1 + gux * (log(xa)-lux)
  else
    x = gx1 + gux * (xa-gux1)
  endif
  if (axis_ylog) then
    y = gy1 + guy * (log(ya)-luy)
  else
    y = gy1 + guy * (ya-guy1)
  endif
  goto 10
  !
entry garrow(xz,yz)
  x = xz
  y = yz
  !
10 x0 = xp
  y0 = yp
  if (x.lt.x0) then
    alpha = atan((y-y0)/(x-x0))
  elseif (x.eq.x0) then
    if (y.gt.y0) then
      alpha=-pis/2.
    elseif (y.eq.y0) then
      alpha= pis
    elseif (y.lt.y0) then
      alpha= pis/2.
    endif
  else
    alpha = atan((y-y0)/(x-x0)) + pis
  endif
  !
  ! Current segment : draw the line
  !
  size = csymb * expand * 0.5
  size2 = size * 0.707
  call gdraw (x+size2*cos(alpha),y+size2*sin(alpha))
  ! Close the current segment...
  error = .false.
  call gtsegm_close(error)
  !
  ! ..and open a new one to plot the end ( with solid line style )
  call gtsegm('ARROW',error)
  if (penupd) call setpen(cpen)
  call setdas(1)
  ! Define arrow head polygon
  x_head(1) = x+size2*cos(alpha)
  y_head(1) = y+size2*sin(alpha)
  x_head(2) = x+size*1.732*cos(alpha+pis/6.)
  y_head(2) = y+size*1.732*sin(alpha+pis/6.)
  x_head(3) = x
  y_head(3) = y
  x_head(4) = x+size*1.732*cos(alpha-pis/6.)
  y_head(4) = y+size*1.732*sin(alpha-pis/6.)
  x_head(5) = x+size2*cos(alpha)
  y_head(5) = y+size2*sin(alpha)
  !
  ! Plot the head (clip if needed)
  npts = 5
  if (noclip) then
    x_head_c(1:5) = x_head(1:5)
    y_head_c(1:5) = y_head(1:5)
  else
    call clip_poly(npts,x_head,y_head,x_head_c,y_head_c)
  endif
  ! call grpoly(npts,x_head_c,y_head_c)
  call gr_fillpoly(npts,x_head_c,y_head_c)
  !
  call grelocate (x,y)
end subroutine arrow
!
subroutine regval(z,xa,ya,value,lecri)
  use gbl_message
  use greg_interfaces, except_this=>regval
  use greg_rg
  !---------------------------------------------------------------------
  ! @ private
  ! GREG 	Internal routine
  !	Computes the Regular Grid array value at user coordinates XA,YA
  ! Arguments :
  !	Z	R*4 (*)	Regular grid array		Input
  !	XA	R*8	X user coordinate 		Input
  !	YA	R*8	Y user coordinate		Input
  !	VALUE	R*4	Value at this position		Output
  !	LECRI	L	Logical flag for writing	Input
  !---------------------------------------------------------------------
  real(kind=4) :: z(*)                    !
  real(kind=8) :: xa                      !
  real(kind=8) :: ya                      !
  real(kind=4) :: value                   !
  logical :: lecri                  !
  ! Local
  real(kind=8) :: tmp
  integer(kind=4) :: i,j
  character(len=message_length) :: chain
  !
  ! Compute I and J corresponding to XA and YA
  tmp = (xa-rg%xval)/rg%xinc + rg%xref
  i = nint(tmp)
  tmp = (ya-rg%yval)/rg%yinc + rg%yref
  j = nint(tmp)
  if (i.le.rg%nx .and. j.le.rg%ny .and. i.gt.0 .and. j.gt.0) then
    value = z((j-1)*rg%nx+i)
    if (lecri) then
      write (chain,300) i,j,value
      call greg_message(seve%r,'VALUE',chain)
    endif
  endif
300 format('Map Value at Pixel (',i5,',',i5,')  = ',1pg11.4)
end subroutine regval
!
function voisin(x,y)
  use greg_kernel
  !---------------------------------------------------------------------
  ! @ private
  !  Find the nearest of the 9 significant points in BOX
  !---------------------------------------------------------------------
  integer(kind=4) :: voisin        !
  real(kind=4), intent(in) :: x,y  ! Absolute position of point
  ! Local
  integer(kind=4) :: i,j
  !
  if (x.lt.(0.75*gx1+0.25*gx2)) then
    i = 1
  elseif (x.gt.(0.75*gx2+0.25*gx1)) then
    i = 3
  else
    i = 2
  endif
  !
  if (y.lt.(0.75*gy1+0.25*gy2)) then
    j = 0
  elseif (y.gt.(0.75*gy2+0.25*gy1)) then
    j = 2
  else
    j = 1
  endif
  !
  voisin = 3*j+i
end function voisin
!
subroutine corner(k,x,y)
  use greg_interfaces, except_this=>corner
  use greg_kernel
  !---------------------------------------------------------------------
  ! @ private
  !  Returns the coordinate of the significant point number K
  !---------------------------------------------------------------------
  integer(kind=4), intent(in)  :: k    ! Point number
  real(kind=4),    intent(out) :: x,y  ! Coordinates
  ! Local
  integer(kind=4) :: i
  !
  i = mod(k,3)
  if (i.eq.1) then
    x = gx1
  elseif (i.eq.2) then
    x = 0.5*(gx1+gx2)
  else
    x = gx2
  endif
  if (i.eq.0) then
    i = k/3
  else
    i = k/3+1
  endif
  if (i.eq.1) then
    y = gy1
  elseif (i.eq.2) then
    y = 0.5*(gy1+gy2)
  else
    y = gy2
  endif
end subroutine corner
!
function centre(x,y)
  use greg_kernel
  !---------------------------------------------------------------------
  ! @ private
  ! Find the appropriate centering option
  !---------------------------------------------------------------------
  integer(kind=4) :: centre        !
  real(kind=4), intent(in) :: x,y  ! Absolute position of point
  ! Local
  integer(kind=4) :: i,j
  !
  if (x.lt.gx1) then
    i = 1
  elseif (x.gt.gx2) then
    i = 3
  else
    i = 2
  endif
  !
  if (y.lt.gy1) then
    j = 1
  elseif (y.gt.gy2) then
    j = 3
  else
    j = 2
  endif
  centre = 3*(j-1)+i
end function centre
!
subroutine arraydraw1(code,x,y,kbox)
  use phys_const
  use greg_interfaces
  use greg_kernel
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !     Draw what CODE indicates, at position X,Y in coordinate system KBOX
  !
  !     CODE    C*(*)    Drawing action (Relocate, Line, Marker, Arrow)
  !     X,Y     R*8      Coordinates
  !     KBOX    I        Coordinate system
  !---------------------------------------------------------------------
  character(len=1) :: code
  real(kind=8) :: x
  real(kind=8) :: y
  integer(kind=4) :: kbox
  !
  ucurse(1)=x
  ucurse(2)=y
  if (kbox.eq.-3) then
    ucurse(1)=x*pi/180.0d0
    ucurse(2)=y*pi/180.0d0
  elseif (kbox.eq.-4) then
    ucurse(1)=x*pi/180.0d0/60.0d0
    ucurse(2)=y*pi/180.0d0/60.0d0
  elseif (kbox.eq.-5) then
    ucurse(1)=x*pi/180.0d0/3600.0d0
    ucurse(2)=y*pi/180.0d0/3600.0d0
  endif
  if (axis_xlog) then
    xcurse = gx1 + gux * (log(ucurse(1))-lux)
  else
    xcurse = gx1 + gux * (ucurse(1)-gux1)
  endif
  if (axis_ylog) then
    ycurse = gy1 + guy * (log(ucurse(2))-luy)
  else
    ycurse = gy1 + guy * (ucurse(2)-guy1)
  endif
  if (code.eq.'R') then
    call grelocate(xcurse,ycurse)
  elseif (code.eq.'L') then
    call gdraw(xcurse,ycurse)
  elseif (code.eq.'M') then
    call grelocate(xcurse,ycurse)
    call gr_point(nsides,istyle)
  elseif (code.eq.'A') then
    call garrow2(xcurse,ycurse)
  endif
end subroutine arraydraw1
!
subroutine arraydraw2(code,cra,la,cdec,ld,error)
  use phys_const
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>arraydraw2
  use greg_kernel
  use greg_wcs
  !---------------------------------------------------------------------
  ! @ private
  !     Draw what CODE indicates, at absolute position defined by
  !     CRA and CDEC.
  !
  !     CODE    C*(*)    Drawing action (Relocate, Line, Marker, Arrow)
  !     CRA     C*(*)    String for X position
  !     LA      I        Length of CRA
  !     CDEC    C*(*)    String for Y position
  !     LD      I        Length of CDEC
  !---------------------------------------------------------------------
  character(len=1)                :: code   !
  character(len=*)                :: cra    !
  integer(kind=4)                 :: la     !
  character(len=*)                :: cdec   !
  integer(kind=4)                 :: ld     !
  logical,          intent(inout) :: error  ! Logical error flag
  !
  real(kind=8) :: sux,suy
  !
  call sic_sexa(cra,la,ucurse(1),error)
  if (error) return
  if (i_system.eq.type_eq .or. i_system.eq.type_ic) then
    ucurse(1) = ucurse(1)*pi/12.0d0
  else
    ucurse(1) = ucurse(1)*pi/180.0d0
  endif
  call sic_sexa(cdec,ld,ucurse(2),error)
  if (error) return
  ucurse(2) = ucurse(2)*pi/180.0d0
  sux = ucurse(1)
  suy = ucurse(2)
  call abs_to_rel(gproj,sux,suy,ucurse(1),ucurse(2),1)
  if (axis_xlog) then
    xcurse = gx1 + gux * (log(ucurse(1))-lux)
  else
    xcurse = gx1 + gux * (ucurse(1)-gux1)
  endif
  if (axis_ylog) then
    ycurse = gy1 + guy * (log(ucurse(2))-luy)
  else
    ycurse = gy1 + guy * (ucurse(2)-guy1)
  endif
  if (code.eq.'R') then
    call grelocate(xcurse,ycurse)
  elseif (code.eq.'L') then
    call gdraw(xcurse,ycurse)
  elseif (code.eq.'M') then
    call grelocate(xcurse,ycurse)
    call gr_point(nsides,istyle)
  elseif (code.eq.'A') then
    call garrow2(xcurse,ycurse)
  endif
end subroutine arraydraw2
!
subroutine draw_text_relative(x,y,string,nchar,kbox,ic,doclip_soft)
  use phys_const
  use greg_interfaces, except_this=>draw_text_relative
  use greg_kernel
  use greg_wcs
  !---------------------------------------------------------------------
  ! @ private
  !  Draw a TEXT, at position X,Y in coordinate system KBOX
  !---------------------------------------------------------------------
  real(kind=8),     intent(in) :: x,y          ! Coordinates
  character(len=*), intent(in) :: string       ! Text to be drawn
  integer(kind=4),  intent(in) :: nchar        ! Length of STRING
  integer(kind=4),  intent(in) :: kbox         ! Coordinate system
  integer(kind=4),  intent(in) :: ic           ! Centering code
  logical,          intent(in) :: doclip_soft  ! Soft clipping enabled?
  ! Local
  integer(kind=4) :: ii
  !
  if (kbox.eq.-3) then
    ucurse(1)=x*pi/180.0d0
    ucurse(2)=y*pi/180.0d0
  elseif (kbox.eq.-4) then
    ucurse(1)=x*pi/180.0d0/60.0d0
    ucurse(2)=y*pi/180.0d0/60.0d0
  elseif (kbox.eq.-5) then
    ucurse(1)=x*pi/180.0d0/3600.0d0
    ucurse(2)=y*pi/180.0d0/3600.0d0
  else
    ucurse(1)=x
    ucurse(2)=y
  endif
  if (axis_xlog) then
    xcurse = gx1 + gux * (log(ucurse(1))-lux)
  else
    xcurse = gx1 + gux * (ucurse(1)-gux1)
  endif
  if (axis_ylog) then
    ycurse = gy1 + guy * (log(ucurse(2))-luy)
  else
    ycurse = gy1 + guy * (ucurse(2)-guy1)
  endif
  call grelocate(xcurse,ycurse)
  ii = ic
  if (ii.eq.0) ii = centre(xcurse,ycurse)
  call putlabel(nchar,string,ii,tangle,doclip_soft)
end subroutine draw_text_relative
!
subroutine garrow2(xz,yz)
  use phys_const
  use greg_interfaces, except_this=>garrow2
  use greg_kernel
  use greg_pen
  !---------------------------------------------------------------------
  ! @ private
  ! GREG	Internal routine
  !	Draws an arrow from current pen position to (XZ,YZ)
  !	in paper coordinates (XZ,YZ)
  ! Arguments :
  !	XZ,YZ	R*4	Plot coordinates		Input
  !
  ! Does not change the line style to solid for the end of an arrow
  ! since it would create spurious segments
  !---------------------------------------------------------------------
  real(kind=4) :: xz                      !
  real(kind=4) :: yz                      !
  ! Local
  real(kind=4) :: x,y,size,size2,alpha,x0,y0
  !
  x = xz
  y = yz
  !
  x0 = xp
  y0 = yp
  if (x.lt.x0) then
    alpha = atan((y-y0)/(x-x0))
  elseif (x.eq.x0) then
    if (y.gt.y0) then
      alpha=-pis/2.
    elseif (y.eq.y0) then
      alpha= pis
    elseif (y.lt.y0) then
      alpha= pis/2.
    endif
  else
    alpha = atan((y-y0)/(x-x0)) + pis
  endif
  ! everything is drawn in the current segment, with same pen.
  size = csymb * expand * 0.5
  size2 = size * 0.707
  call gdraw (x+size2*cos(alpha),y+size2*sin(alpha))
  call gdraw (x+size*1.732*cos(alpha+pis/6.),y+size*1.732*sin(alpha+pis/6.) )
  call gdraw (x,y)
  call gdraw (x+size*1.732*cos(alpha-pis/6.),y+size*1.732*sin(alpha-pis/6.) )
  call gdraw (x+size2*cos(alpha),y+size2*sin(alpha) )
  call grelocate (x,y)
end subroutine garrow2
!
subroutine print_position (w_angle)
  use phys_const
  use greg_interfaces, except_this=>print_position
  use greg_kernel
  use greg_wcs
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !     Print current cursor position
  !
  !     W_ANGLE  I        Coordinate system                         Input
  !---------------------------------------------------------------------
  integer(kind=4) :: w_angle                !
  ! Local
  character(len=80) :: chain
  !
  write (chain,100) xcurse,ycurse
  call greg_message(seve%r,'VALUE',chain)
  if (gproj%type.ne.p_none.or.i_system.ne.type_un) then
    if (w_angle.eq.u_degree) then
      write (chain,200) ucurse(1)*180.0d0/pi,ucurse(2)*180.0d0/pi,' (Arc. Deg.)'
    elseif (w_angle.eq.u_minute) then
      write (chain,200) ucurse(1)*10800.0d0/pi,ucurse(2)*10800.0d0/pi,  &
      ' (Arc. Min.)'
    elseif (w_angle.eq.u_second) then
      write (chain,200) ucurse(1)*6.48d5/pi,ucurse(2)*6.48d5/pi,' (Arc. Sec.)'
    else
      write (chain,200) ucurse(1),ucurse(2),' (Rad.)'
    endif
    call sexfor (ucurse(1),ucurse(2))
  else
    write (chain,200) ucurse(1),ucurse(2)
  endif
  call greg_message(seve%r,'VALUE',chain)
  !
100 format('Physical Coordinates: ',1pg15.4,2x,1pg15.4)
200 format('    User Coordinates: ',1pg15.8,2x,1pg15.8,a)
end subroutine print_position
!
subroutine print_line(line,kbox,ibox,chain,fact)
  use phys_const
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>print_line
  use greg_kernel
  use greg_wcs
  !---------------------------------------------------------------------
  ! @ private
  !  Re-write the command line for a DRAW Code action
  !
  !  kbox < 0: user coordinates
  !  kbox = 0: physical coordinates from box "corner"
  !  kbox = 1: character coordinates from box "corner"
  !  kbox = 2: absolute physical coordinates on page
  !---------------------------------------------------------------------
  character(len=*), intent(out) :: line   ! Command line
  integer(kind=4),  intent(in)  :: kbox   ! Coordinate system
  integer(kind=4),  intent(in)  :: ibox   ! Box corner (if relevant according to KBOX)
  character(len=*), intent(in)  :: chain  ! Code of action (all but TEXT)
  real(kind=4),     intent(in)  :: fact   ! Scaling factor
  ! Local
  character(len=1), parameter :: backslash=char(92)
  character(len=13) :: sexag1,sexag2
  real(kind=8) :: x,y
  integer(kind=4) :: ndiv
  real(kind=4) :: gx,gy
  !
  if (kbox.eq.-1) then
    write(line,201) backslash,chain,ucurse(1),ucurse(2)
  elseif (kbox.eq.-5) then
    write(line,201) backslash,chain,ucurse(1)*6.48d5/pi,ucurse(2)*6.48d5/pi
  elseif (kbox.eq.-4) then
    write(line,201) backslash,chain,ucurse(1)*1.08d4/pi,ucurse(2)*1.08d4/pi
  elseif (kbox.eq.-3) then
    write(line,201) backslash,chain,ucurse(1)*180.0d0/pi,ucurse(2)*180.0d0/pi
  elseif (kbox.eq.-2) then
    call rel_to_abs(gproj,ucurse(1),ucurse(2),x,y,1)
    if (i_system.eq.type_eq .or. i_system.eq.type_ic) then
      ndiv=24
    else
      ndiv=360
    endif
    call sexag(sexag1,x,ndiv)
    call sexag(sexag2,y,360)
    write(line,301) backslash,chain,sexag1,sexag2
  else
    ! Coordinates from box corner
    call corner(max(ibox,1),gx,gy)
    write(line,101) backslash,chain,(xcurse-gx)/fact,(ycurse-gy)/fact
  endif
  !
101 format('GREG1',a1,'DRAW ',a,' ',1pg11.4,' ',1pg11.4)
201 format('GREG1',a1,'DRAW ',a,' ',1pg15.8,' ',1pg15.8)
301 format('GREG1',a1,'DRAW ',a,' ',a13,' ',a13)
end subroutine print_line
!
subroutine print_text(line,kbox,ibox,chain,fact,string,ic,ang)
  use phys_const
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>print_text
  use greg_kernel
  use greg_wcs
  !---------------------------------------------------------------------
  ! @ private
  !  Re-write the command line for a DRAW TEXT action
  !
  !  kbox < 0: user coordinates
  !  kbox = 0: physical coordinates from box "corner"
  !  kbox = 1: character coordinates from box "corner"
  !  kbox = 2: absolute physical coordinates on page
  !---------------------------------------------------------------------
  character(len=*), intent(out) :: line    ! Command line
  integer(kind=4),  intent(in)  :: kbox    ! Coordinate system
  integer(kind=4),  intent(in)  :: ibox    ! Box corner (if relevant according to KBOX)
  character(len=*), intent(in)  :: chain   ! Code of action (all but TEXT)
  real(kind=4),     intent(in)  :: fact    ! Scaling factor
  character(len=*), intent(in)  :: string  ! Text to be drawn
  integer(kind=4),  intent(in)  :: ic      ! Centering code
  real(kind=8),     intent(in)  :: ang     ! Orientation of text
  ! Local
  character(len=1), parameter :: backslash=char(92)
  character(len=13) :: sexag1,sexag2
  real(kind=8) :: x,y
  integer(kind=4) :: ndiv
  real(kind=4) :: gx,gy
  !
  if (kbox.eq.-1) then
    write(line,205) backslash,ucurse(1),ucurse(2),string,ic,ang
  elseif (kbox.eq.-3) then
    write(line,205) backslash,ucurse(1)*180.0d0/pi,ucurse(2)*180.0d0/pi,  &
    string,ic,ang
  elseif (kbox.eq.-4) then
    write(line,205) backslash,ucurse(1)*1.08d4/pi,ucurse(2)*1.08d4/pi,string,  &
    ic,ang
  elseif (kbox.eq.-5) then
    write(line,205) backslash,ucurse(1)*6.48d5/pi,ucurse(2)*6.48d5/pi,string,  &
    ic,ang
  elseif (kbox.eq.-2) then
    call rel_to_abs(gproj,ucurse(1),ucurse(2),x,y,1)
    call sexag(sexag1,x,ndiv)
    call sexag(sexag2,y,360)
    write(line,305) backslash,sexag1,sexag2,string,ic,ang
  else
    ! Coordinates from box corner
    call corner(max(ibox,1),gx,gy)
    write(line,105) backslash,(xcurse-gx)/fact,(ycurse-gy)/fact,string,ic,ang
  endif
  !
105 format('GREG1',a1,'DRAW TEXT ',1pg11.4,' ',1pg11.4,' "',a,'" ',i1,1x,1pg11.4)
205 format('GREG1',a1,'DRAW TEXT ',1pg15.8,' ',1pg15.8,' "',a,'" ',i1,1x,1pg11.4)
305 format('GREG1',a1,'DRAW TEXT ',a13,    ' ',a13,    ' "',a,'" ',i1,1x,1pg11.4)
end subroutine print_text
!
subroutine glook(line,error)
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>glook
  use greg_kernel
  use greg_pen
  use greg_rg
  !---------------------------------------------------------------------
  ! @ private
  ! GREG
  !     Support for command
  !     LOOK "command"
  !
  ! Calls the cursor, and execute the specified command each time it is
  ! pressed. The command can be a procedure (e.g. @my_look) and can test
  ! the pressed character which is added at the end as first argument.
  !---------------------------------------------------------------------
  character(len=*)                :: line   !
  logical,          intent(inout) :: error  !
  ! Local
  character(len=512) :: command
  character(len=1) :: cucode
  real(kind=8) :: x,y
  integer(kind=4) :: nc
  integer(kind=4), parameter :: max_integ=2147483647
  !
  if (.not.gtg_curs()) return
  call sic_ch(line,0,1,command,nc,.true.,error)
  if (error) return
  !
  ! Loop over with the cursor
  do while(.true.)
    call gr_curs(ucurse(1),ucurse(2),xcurse,ycurse,cucode)
    error = (gterrtst().or.cucode.eq.char(3).or.sic_ctrlc())
    if (error) return
    ! Codes returned by ButtonPress events to keycodes
    !         IF (CUCODE.EQ.'^') CUCODE = 'R'
    !         IF (CUCODE.EQ.'&') CUCODE = 'L'
    ! Remap * to Exit
    if (cucode.eq.'*') cucode = 'E'
    cursor_code = cucode
    !
    ! Return if EXIT
    if (cucode.eq.'E') exit
    !
    ! defines the PIX_CURS SIC variable if associated
    if (rg%status.ne.code_pointer_null) then
      if (rg%xinc.ne.0) then
        x = (ucurse(1)-rg%xval)/rg%xinc + rg%xref
      else
        x = 0
      endif
      if (rg%yinc.ne.0) then
        y = (ucurse(2)-rg%yval)/rg%yinc + rg%yref
      else
        y = 0
      endif
      if (abs(x).le.max_integ.and.abs(y).le.max_integ) then
        pixcurse(1) = nint(x)
        pixcurse(2) = nint(y)
      else
        pixcurse(1) = 0
        pixcurse(2) = 0
      endif
    else
      pixcurse(1) = 0
      pixcurse(2) = 0
    endif
    !
    command(nc+1:nc+4) = ' "'//cucode//'"'
    call exec_program(command)
  enddo
  call sic_insert(line)
end subroutine glook

module gildas_luns
  use gildas_def
  !---------------------------------------------------------------------
  ! Logical units reserved for Gildas, from stalun+1 to stalun+1+maxlun
  !---------------------------------------------------------------------
  integer(kind=4), parameter :: stalun=50      ! First lun used is stalun+1
  integer(kind=4), parameter :: maxlun=49      ! Maximum number of luns
  logical                        :: isused(maxlun)   = .false.  ! Use status of luns
  character(len=filename_length) :: lunfiles(maxlun) = ''       ! Last opened file names
  !
end module gildas_luns
!
function sic_open(unit,file,status,readonly)
  use gbl_message
  use gsys_interfaces, except_this=>sic_open
  use gildas_luns
  !---------------------------------------------------------------------
  ! @ public
  ! This machine dependent function opens a formatted file, and returns an
  ! error code. This Unix version simulates version numbers by renaming
  ! any existing file to a ~appended name.
  !---------------------------------------------------------------------
  integer(kind=4) :: sic_open  ! Return value
  integer(kind=4),  intent(in) :: unit      ! Fortran logical unit
  character(len=*), intent(in) :: file      ! File name
  character(len=*), intent(in) :: status    ! File status ('NEW', or 'OLD', or...)
  logical,          intent(in) :: readonly  ! Open as write protected?
  ! Local
  logical :: exist
  integer(kind=4) :: ilun,ier
  !
  call gsys_message(seve%d,'SIC_OPEN',  &
    'Opening file "'//trim(file)//'" with status '//trim(status))
  !
  if (status.eq.'NEW') then 
    inquire(file=file,exist=exist)
    if (exist) then
      ier = gag_filrename(file,trim(file)//'~')
    endif
  endif
  !
  if (status.eq.'APPEND') then
    open(unit=unit,file=file,status='OLD',form='FORMATTED',position='APPEND',  &
         action='READWRITE',iostat=sic_open)
  else
    if (readonly) then
      open(unit=unit,file=file,status=status,form='FORMATTED',action='READ',  &
           iostat=sic_open)
    else
      open(unit=unit,file=file,status=status,form='FORMATTED',  &
           action='READWRITE',iostat=sic_open)
    endif
  endif
  !
  ! Keep track of opened file for debugging purpose (SIC DEBUG LUN)
  ilun = unit-stalun
  if (ilun.ge.1 .and. ilun.le.maxlun) then
    ! This unit is in the range [STALUN+1:STALUN+MAXLUN] usable by Gildas
    ! program
    if (isused(ilun)) then
      ! This LUN was indeed reserved by SIC_GETLUN
      lunfiles(ilun) = file
    endif
  endif
  !
end function sic_open
!
function sic_flush(unit)
  !---------------------------------------------------------------------
  ! @ public
  ! This function flushes file buffer onto disk, and returns an error
  ! code.
  !---------------------------------------------------------------------
  integer(kind=4)             :: sic_flush  ! Flush status (0=success)
  integer(kind=4), intent(in) :: unit       ! Logical unit
#if defined(FORTRAN2003)
  flush(unit=unit,iostat=sic_flush)
#else
  sic_flush=0
#endif
  !
end function sic_flush
!
function sic_close(unit)
  use gildas_luns
  use gsys_interfaces, except_this=>sic_close
  !---------------------------------------------------------------------
  ! @ public
  ! This function closes a formatted file, and returns an error code.
  ! Following the Fortran norm, default closing STATUS:
  ! - is DELETE if unit has been opened with STATUS=SCRATCH,
  ! - is KEEP if unit has been opened with any other STATUS.
  ! Use unit=0 to close all units.
  !---------------------------------------------------------------------
  integer(kind=4) :: sic_close  ! Close status (0=success)
  integer(kind=4), intent(in) :: unit  ! Logical unit to close
  ! Local
  integer(kind=4) :: i,iunit,ier
  !
  if (unit.eq.0) then
    sic_close = 0
    do i=1,maxlun
      if (isused(i)) then
        iunit = i+stalun
        ier = sic_close_one(iunit)
        if (ier.ne.0)  sic_close = ier
      endif
    enddo
  else
    sic_close = sic_close_one(unit)
  endif
  !
end function sic_close
!
function sic_close_one(unit)
  !---------------------------------------------------------------------
  ! @ private
  ! This function closes a formatted file, and returns an error code.
  ! Following the Fortran norm, default closing STATUS:
  ! - is DELETE if unit has been opened with STATUS=SCRATCH,
  ! - is KEEP if unit has been opened with any other STATUS.
  !---------------------------------------------------------------------
  integer(kind=4)             :: sic_close_one  ! Close status (0=success)
  integer(kind=4), intent(in) :: unit           ! Logical unit to close
  !
  close(unit=unit,iostat=sic_close_one)
  !
end function sic_close_one
!
subroutine sic_frelun(unit)
  use gsys_interfaces, except_this=>sic_frelun
  !---------------------------------------------------------------------
  ! @ public
  ! This machine dependent function frees a Fortran logical unit obtained
  ! through a call to SIC_GETLUN. Error on close can not be retrieved,
  ! use GAG_FRELUN to do so.
  !---------------------------------------------------------------------
  integer(kind=4), intent(in) :: unit  ! Fortran logical unit to close
  ! Local
  integer(kind=4) :: ier
  !
  ier = gag_frelun(unit)
  !
end subroutine sic_frelun
!
function sic_getlun(unit)
  use gbl_message
  use gsys_interfaces, except_this=>sic_getlun
  use gildas_luns
  !---------------------------------------------------------------------
  ! @ public
  ! This machine dependent function returns a free Fortran logical unit in
  ! UNIT. The function value is an error code. For safe operation, all
  ! logical units used by the program should be obtained through calls to
  ! SIC_GETLUN. This portable version reserves all units between STALUN+1
  ! and STALUN+MAXLUN, which may interfere with the calling program. Safer
  ! equivalents can usually be obtained through system calls.
  !---------------------------------------------------------------------
  integer(kind=4) :: sic_getlun  ! Function value on return
  integer(kind=4), intent(out) :: unit  ! Unit obtained on return
  ! Local
  character(len=*), parameter :: rname='GETLUN'
  integer(kind=4) :: i
  !
  do i=1,maxlun
    if (.not.isused(i)) then
      unit = i+stalun
      isused(i) = .true.
      sic_getlun = 1
      return
    endif
  enddo
  ! Error return
  call gsys_message(seve%e,rname,'No more logical unit available')
  unit = 0
  sic_getlun = 0
  !
  ! Also display the list of reserved LUN (useful for e.g. programs which
  ! do not provide a prompt to call SIC DEBUG LUN)
  call gsys_message(seve%e,rname,'Reserved logical units are:')
  i = gag_stalun(0)
end function sic_getlun
!
function gag_frelun(unit)
  use gildas_def
  use gbl_message
  use gildas_luns
  !---------------------------------------------------------------------
  ! @ public
  ! This machine dependent function frees a Fortran logical unit obtained
  ! through a call to SIC_GETLUN. The function value is an error code.
  !---------------------------------------------------------------------
  integer(kind=4) :: gag_frelun  ! Function value on return
  integer(kind=4), intent(in) :: unit  ! Logical unit to close
  ! Local
  character(len=*), parameter :: rname='FRELUN'
  integer(kind=4) :: i
  logical :: status
  character(len=filename_length) :: file
  character(len=message_length) :: mess
  !
  i = unit-stalun
  if (i.ge.1 .and. i.le.maxlun) then
    gag_frelun = 1
    if (isused(i)) then
      isused(i) = .false.
      ! Was this lun Fortran closed?
      inquire(unit=unit,opened=status,name=file)
      if (status) then
        write(mess,'(A,I0,A,A)')  &
          'lun #',unit,' is still opened on file ',trim(file)
        call gsys_message(seve%w,rname,mess)
      endif
    endif
  else
    gag_frelun = 0
  endif
end function gag_frelun
!
function gag_stalun(unit)
  use gildas_luns
  use gsys_interfaces, except_this=>gag_stalun
  !---------------------------------------------------------------------
  ! @ public
  ! Stat input lun (or all if lun=0) and print out status of lun(s)
  !---------------------------------------------------------------------
  integer(kind=4) :: gag_stalun  ! Function value on return
  integer(kind=4), intent(in) :: unit  ! Unit to stat
  ! Local
  integer(kind=4) :: i,iunit
  !
  if (unit.eq.0) then
    do i=1,maxlun
      if (isused(i)) then
        iunit = i+stalun
        call gag_stalun_print(iunit)
      endif
    enddo
    gag_stalun = 0
  else
    call gag_stalun_print(unit)
    gag_stalun = 1
  endif
end function gag_stalun
!
subroutine gag_stalun_print(unit)
  use gildas_def
  use gbl_message
  use gsys_interfaces, except_this=>gag_stalun_print
  use gildas_luns
  !---------------------------------------------------------------------
  ! @ private
  ! Print out status of a single lun
  ! NB: the lun can be one not reserved by SIC_GETLUN
  !---------------------------------------------------------------------
  integer(kind=4), intent(in) :: unit  ! Unit to stat
  ! Local
  character(len=*), parameter :: rname='STALUN'
  character(len=filename_length) :: file
  logical :: isopened
  character(len=message_length) :: mess
  integer(kind=4) :: ilun
  !
  inquire(unit=unit,opened=isopened,name=file)
  !
  ilun = unit-stalun
  if (ilun.ge.1 .and. ilun.le.maxlun) then
    ! This is a SIC_GETLUN lun
    if (isopened) then
      write(mess,'(A,I2,2A)') 'Lun ',unit,' sic_opened on ',trim(lunfiles(ilun))
    elseif (lunfiles(ilun).ne.'') then
      write(mess,'(A,I2,3A)') 'Lun ',unit,' sic_closed (last sic_opened on ',trim(lunfiles(ilun)),')'
    else
      write(mess,'(A,I2,2A)') 'Lun ',unit,' sic_closed'
    endif
    !
  else
    ! This is not a SIC_GETLUN lun
    if (isopened) then
      write(mess,'(A,I2,2A)') 'Lun ',unit,' opened on ',trim(file)
    else
      write(mess,'(A,I2,A)')  'Lun ',unit,' closed'
    endif
  endif
  !
  call gsys_message(seve%r,rname,mess)
  !
end subroutine gag_stalun_print
!
function sic_purge(file,keep)
  !---------------------------------------------------------------------
  ! @ public
  ! This machine dependent function deletes all versions of a file except
  ! for the KEEP last ones, KEEP=0 being a supported case. The function
  ! value is an error code. This dummy version does nothing and should be
  ! replaced by an EMACS-like behaviour (using numbered backup files).
  !---------------------------------------------------------------------
  integer(kind=4) :: sic_purge  ! Return value
  character(len=*), intent(in) :: file       ! File name
  integer(kind=4),  intent(in) :: keep       ! Number of versions that should be kept
  !
  sic_purge = 1                ! SS$_NORMAL
end function sic_purge

subroutine wordre(lun,line,nl)
  use sic_interfaces, except_this=>wordre
  !---------------------------------------------------------------------
  ! @ private
  ! SIC   Internal routine
  !
  !       Writes a command line according to SIC syntax
  !       LUN     Logical unit number
  !       LINE    Command line to write
  !       NL      Length of line
  !---------------------------------------------------------------------
  integer :: lun                    !
  character(len=*) :: line          !
  integer :: nl                     !
  ! Local
  integer, parameter :: length=70
  integer :: n1,n2
  !
  n1 = 1
  n2 = length
10 continue
  if (n2.ge.nl) then
    write(lun,100) line(n1:nl)
    return
  endif
  write(lun,100) line(n1:n2), '-'
  n1 = n2+1
  n2 = n2+length
  goto 10
100 format(1x,20(a))
end subroutine wordre
!
subroutine sic_wpr (invite,string)
  use sic_interfaces, except_this=>sic_wpr
  use sic_interactions
  !---------------------------------------------------------------------
  ! @ public-mandatory (because symbol is used elsewhere)
  !  Read a character string with prompt
  !  Traps the empty string
  !  Traps <^Z> and returns "EXIT" instead
  !---------------------------------------------------------------------
  character(len=*) :: invite        ! Prompt for reading              Input
  character(len=*) :: string        ! String read                     Output
  ! Local
  integer :: n,nc
  !
10 continue
  if (edit_mode.and.inter_state) then
    nc = len(invite)
    call get_line(string,n,invite,nc)
  else
    write(6,101) invite
    read (5,102,err=10,end=20) string
  endif
  if (string.eq.' ') goto 10
  goto 30
20 string='EXIT'
30 if (inter_state) return
  write(6,101) invite,trim(string)
101 format(1x,a,' ',$)
102 format(a)
end subroutine sic_wpr
!
subroutine sic_wprn (invite,string,n)
  use sic_interfaces, except_this=>sic_wprn
  use sic_interactions
  !---------------------------------------------------------------------
  ! @ public
  !  Read a character string with prompt
  !  An empty string or a <^Z> returns N=0
  !---------------------------------------------------------------------
  character(len=*) :: invite        ! Prompt for reading              Input
  character(len=*) :: string        ! String read                     Output
  integer :: n                      ! Number of characters read       Output
  ! Local
  integer :: nc
  !
  if (edit_mode.and.inter_state) then
    nc = len(invite)
    call get_line(string,n,invite,nc)
  else
    write(6,101) invite
    read (5,'(A)',err=10,end=10) string
    n = len_trim(string)
  endif
  if (string.eq.' ') goto 20
  if (inter_state) return
  write(6,101) invite,trim(string)
  return
  !
10 string=' '
20 n = 0
  !
101 format(1x,a,' ',$)
end subroutine sic_wprn
!
subroutine sic_log (line,nl,lire)
  use sic_interfaces, except_this=>sic_log
  use sic_structures
  !---------------------------------------------------------------------
  ! @ public
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: line  !
  integer(kind=4),  intent(in) :: nl    !
  integer(kind=4),  intent(in) :: lire  !
  ! Local
  integer(kind=4) :: n1,n2
  integer(kind=4), parameter :: length=67
  !
  if (lire.ne.0) return
  if (lunlog.eq.0) return
  !
  n1 = 1
  n2 = length
  !
10 continue
  if (n2.ge.nl) then
    write(lunlog,101) line(n1:nl),nlire
    return
  endif
  write(lunlog,100) line(n1:n2), '-'
  n1 = n2+1
  n2 = n2+length
  goto 10
  !
100 format(20(a))
101 format(a,'      !',i2)
end subroutine sic_log

subroutine cdclose(ierror,lun)
  integer(kind=4) :: ierror                 !
  integer(kind=4) :: lun                    !
end subroutine cdclose
!
subroutine cddir(ierror,lun,s_dir,lines)
  integer(kind=4) :: ierror                 !
  integer(kind=4) :: lun                    !
  character(len=*) :: s_dir                 !
  integer(kind=4) :: lines                  !
end subroutine cddir
!
subroutine cdfclose(ierror,fid)
  integer(kind=4) :: ierror                 !
  integer(kind=4) :: fid                    !
end subroutine cdfclose
!
subroutine cdfopen(ierror,lun,s_file,fid,recl,bytes)
  integer(kind=4) :: ierror                 !
  integer(kind=4) :: lun                    !
  character(len=*) :: s_file                !
  integer(kind=4) :: fid                    !
  integer(kind=4) :: recl                   !
  integer(kind=4) :: bytes                  !
end subroutine cdfopen
!
subroutine cdfread(ierror,fid,startbyte,numbytes,array)
  integer(kind=4) :: ierror                 !
  integer(kind=4) :: fid                    !
  integer(kind=4) :: startbyte              !
  integer(kind=4) :: numbytes               !
  integer(kind=1) :: array(0:*)             !
end subroutine cdfread
!
subroutine cdgetblock(ierror,lun,block,array)
  integer(kind=4) :: ierror                 !
  integer(kind=4) :: lun                    !
  integer(kind=4) :: block                  !
  integer(kind=1) :: array(0:511)           !
end subroutine cdgetblock
!
subroutine cdgetdir(ierror,lun,block,att,lines)
  integer(kind=4) :: ierror                 !
  integer(kind=4) :: lun                    !
  integer(kind=4) :: block                  !
  integer(kind=4) :: att                    !
  integer(kind=4) :: lines                  !
end subroutine cdgetdir
!
subroutine cdgetdirline(ierror,lun,lineno,linebytes,linelen)
  integer(kind=4) :: ierror                  !
  integer(kind=4) :: lun                     !
  integer(kind=4) :: lineno                  !
  integer(kind=1) :: linebytes(0:*)          !
  integer(kind=4) :: linelen                 !
end subroutine cdgetdirline
!
subroutine cdgetlbs(ierror,lun,lbs,rootbeg,rootatt)
  integer(kind=4) :: ierror                 !Error flag
  integer(kind=4) :: lun                    !Logical unit number
  integer(kind=4) :: lbs                    !Logical block size
  integer(kind=4) :: rootbeg                !Starting block of root
  integer(kind=4) :: rootatt                !Attribute blocks in root
end subroutine cdgetlbs
!
subroutine cdgetlun(ierror,lun,lindex)
  integer(kind=4) :: ierror                 !
  integer(kind=4) :: lun                    !
  integer(kind=4) :: lindex                 !
end subroutine cdgetlun
!
subroutine cdopen(ierror,lun,s_name)
  integer(kind=4) :: ierror                 !
  integer(kind=4) :: lun                    !
  character(len=*) :: s_name                !
end subroutine cdopen
!
subroutine smvb(from,length,to)
  integer(kind=1) :: from(*)                !
  integer(kind=4) :: length                 !
  integer(kind=1) :: to(*)                  !
end subroutine smvb

subroutine mos_primary (prim,primary,bsize)
  use image_def
  use gkernel_interfaces
  use gkernel_types
  !--------------------------------------------------------------
  !*
  ! IMAGER -- Support routine for MOSAIC
  !
  ! Mosaic and Primary beam support.
  ! Compute a Gaussian primary beam
  !!
  !--------------------------------------------------------------
  type(gildas), intent(in) :: prim         !! Primary beam header
  real, intent(inout) :: primary(prim%gil%dim(1),prim%gil%dim(2)) !! Values
  real, intent(in) :: bsize                !! Primary beam size in radian
  !
  ! Local
  real :: offx,offy,beamx,beamy
  real, allocatable :: factorx(:),factory(:)
  real(8) :: doffx, doffy
  integer :: j, ier
  type(projection_t) :: proj
  logical :: error
  !
  allocate (factory(prim%gil%dim(2)), factorx(prim%gil%dim(1)), stat=ier)
  !
  error = .false.
  call gwcs_projec(prim%gil%a0,prim%gil%d0,prim%gil%pang,prim%gil%ptyp,proj,error)
  call abs_to_rel(proj,prim%gil%ra,prim%gil%dec,doffx,doffy,1)
  offx = doffx/prim%gil%inc(1)
  offy = doffy/prim%gil%inc(2)
  !
  beamx = prim%gil%inc(1)/bsize*2.0*sqrt(log(2.0))
  beamy = prim%gil%inc(2)/bsize*2.0*sqrt(log(2.0))
  !
  do j=1,prim%gil%dim(2)
     factory(j) = exp(-((j-prim%gil%ref(2)-offy)*beamy)**2)
  enddo
  !
  do j=1,prim%gil%dim(1)
     factorx(j) = exp(-((j-prim%gil%ref(1)-offx)*beamx)**2)
  enddo
  !
  do j=1,prim%gil%dim(2)
     primary(:,j) = factorx * factory(j)
  enddo
  deallocate (factorx, factory)
end subroutine mos_primary
!
subroutine mos_inverse (n,weight,thre)
  !! IMAGER -- Returns the inverse for the weights for Mosaic
  integer, intent(in) :: n          !! Size of problem
  real, intent(inout) :: weight(n)  !! Weight to be inversed
  real, intent(in) :: thre          !! Threhsold
  ! Local
  integer :: i
  !
  do i=1,n
    if (weight(i).ge.thre) then
      weight(i) = 1.0/weight(i)
    else
      weight(i) = 10.0
    endif
  enddo
end subroutine mos_inverse
!
subroutine mos_addsq (n,nf,weight,lobe)
  !! IMAGER -- Increment weights by Square of primary beam
  integer, intent(in) :: n                      !! Size of arrays
  integer, intent(in) :: nf                     !! Number of fields
  real, intent(inout) :: weight(n)              !! Total weight
  real, intent(in) :: lobe(nf,n)                !! Primary beam array
  ! Local
  integer :: i,if
  !
  do i=1,n
    do if=1,nf
      weight(i) = weight(i)+lobe(if,i)*lobe(if,i)
    enddo
  enddo
end subroutine mos_addsq
!
subroutine mosaic_loadfield (visi,np,nv,ixoff,iyoff,nf,doff,voff,uvmax,uvmin)
  !----------------------------------------------------------------------
  ! @ public-mandatory
  !
  ! IMAGER  --  MOSAIC routines
  !
  !     Load field coordinates into work arrays after sorting.
  !!
  !----------------------------------------------------------------------
  integer, intent(in)  :: np              !! Size of a visibility
  integer, intent(in)  :: nv              !! Number of visibilities
  real, intent(in) :: visi(np,nv)         !! Input visibilities
  integer, intent(in)  :: ixoff           !! X pointer
  integer, intent(in)  :: iyoff           !! Y pointer
  integer, intent(out) :: nf              !! Number of fields
  real(kind=4), intent(out) :: doff(:,:)  !! Fields offsets
  integer, intent(out) :: voff(:)         !! Fields visibility offsets
  real, intent(inout) :: uvmax            !! Maximum length
  real, intent(inout) :: uvmin            !! Minimum baseline
  !
  ! Local ---
  integer :: iv, mfi, nfi
  real(4) :: uv
  !
  ! Code ----
  ! Scan how many fields
  nfi = 1
  mfi = ubound(doff,2)
  uvmax = 0
  uvmin = 1e36
  !
  doff(1,1) = visi(ixoff,1)
  doff(2,1) = visi(iyoff,1)
  voff(1) = 1
  nfi = 1
  !
  ! Fields are ordered here, so any change is a new one
  do iv=2,nv
    if (visi(ixoff,iv).ne.doff(1,nfi) .or. &
      & visi(iyoff,iv).ne.doff(2,nfi) ) then
      !
      ! New field
      if (nfi.eq.mfi) then
        Print *,'Programming error : number of fields exceeded ',mfi,' at visi ',iv
        Print *,'DOFF x ',doff(1,1:nfi)
        Print *,'DOFF Y ',doff(2,1:nfi)
        Print *,'Visi   ',visi(ixoff,iv),visi(iyoff,iv)
        Print *,'NP ',np,' IX IY ',ixoff,iyoff
      endif
      !
      nfi = nfi+1
      doff(1,nfi) = visi(ixoff,iv)
      doff(2,nfi) = visi(iyoff,iv)
      voff(nfi) = iv
    endif
    !
    uv = visi(1,iv)**2 + visi(2,iv)**2
    if (uv.ne.0) then
      uvmax = max(uv,uvmax)
      uvmin = min(uv,uvmin)
    endif
    !
  enddo
  !
  ! And set the last one
  voff(nfi+1) = nv+1
  !
  uvmax = sqrt(uvmax)
  uvmin = sqrt(uvmin)
end subroutine mosaic_loadfield
!
subroutine mosaic_getfields (visi,np,nv,ixoff,iyoff,itele,nf,doff,jtele)
  !----------------------------------------------------------------------
  ! @ public-mandatory
  !*
  ! IMAGER  --   MOSAIC routines
  !
  !     Count number of fields and Get their coordinates
  !     and telescope IDs
  !!
  !----------------------------------------------------------------------
  integer, intent(in)  :: np                   !! Size of a visibility
  integer, intent(in)  :: nv                   !! Number of visibilities
  real, intent(inout)  :: visi(np,nv)          !! Input visibilities
  integer, intent(in)  :: ixoff                !! X pointer
  integer, intent(in)  :: iyoff                !! Y pointer
  integer, intent(in)  :: itele                !! Telescope pointer
  integer, intent(out) :: nf                   !! Number of fields
  real, intent(out), allocatable :: doff(:,:)  !! Field offsets
  integer, intent(out), allocatable :: jtele(:) !! Telescope number
  !
  ! Tolerance precision for phase center: 0.1 mas, to keep
  ! direction changes due to typical Proper Motions
  real(kind=4), parameter :: off_tol=1E-4*acos(-1.0)/180.0/3600.0
  !
  ! Local ---
  integer :: iv, mfi, nfi, kfi, ifi, ier
  real(kind=4), allocatable :: dtmp(:,:)
  real, allocatable :: dtel(:), rtel(:)
  !
  ! Code ----
  !
  ! Scan how many fields
  nfi = 1
  mfi = 100
  !
  if (allocated(doff)) deallocate(doff)        ! Safety measure
  if (allocated(jtele)) deallocate(jtele)        ! Safety measure
  allocate(dtmp(2,mfi),dtel(mfi),stat=ier)
  dtmp(1,1) = visi(ixoff,1)
  dtmp(2,1) = visi(iyoff,1)
  if (itele.ne.0) dtel(1) = visi(itele,1)
  nfi = 1
  !
  ! Fields are not ordered here
  do iv=2,nv
    kfi = 0
    do ifi=1,nfi
      if (abs(visi(ixoff,iv)-dtmp(1,ifi)).le.off_tol .and. &
        & abs(visi(iyoff,iv)-dtmp(2,ifi)).le.off_tol ) then
        if (itele.ne.0) then
          if (visi(itele,iv).eq.dtel(ifi)) then
            visi(ixoff,iv) = dtmp(1,ifi)
            visi(iyoff,iv) = dtmp(2,ifi)
            kfi = ifi
            exit
          endif
        else
          visi(ixoff,iv) = dtmp(1,ifi)
          visi(iyoff,iv) = dtmp(2,ifi)
          kfi = ifi
          exit
        endif
      endif
    enddo
    !
    ! New field
    if (kfi.eq.0) then
      if (nfi.eq.mfi) then
        allocate(doff(2,mfi),rtel(mfi),stat=ier)
        doff(:,:) = dtmp(:,:)
        rtel(:) = dtel(:)
        deallocate(dtmp,dtel)
        allocate(dtmp(2,2*mfi),dtel(2*mfi),stat=ier)
        dtmp(:,1:mfi) = doff
        dtel(1:mfi) = rtel
        deallocate(doff,rtel)
        mfi = 2*mfi
      endif
      nfi = nfi+1
      dtmp(1,nfi) = visi(ixoff,iv)
      dtmp(2,nfi) = visi(iyoff,iv)
      if (itele.ne.0) dtel(nfi) = visi(itele,iv)
    endif
  enddo
  !
  nf = nfi
  allocate(doff(2,nf),jtele(nf),stat=ier)
  doff(:,:) = dtmp(1:2,1:nf)
  if (itele.eq.0) then
    jtele = 1
  else
    jtele(:) = dtel(1:nf)
    jtele = mod(jtele,100)
  endif
end subroutine mosaic_getfields

subroutine sexag(ch,rr8,ndiv)
  use phys_const
  use gsys_interfaces, except_this=>sexag
  !---------------------------------------------------------------------
  ! @ public (obsolescent since 19-mar-2015, use rad2sexa instead)
  !  Writes an angle in sexagesimal notation. The number of characters
  ! updated are limited to 13.
  !---------------------------------------------------------------------
  character(len=*), intent(out) :: ch    ! Formatted string
  real(kind=8),     intent(in)  :: rr8   ! Angle in radians
  integer(kind=4),  intent(in)  :: ndiv  ! Number of divisions per turn (24/360)
  ! Local
  integer(kind=4) :: nchar
  real(kind=8) :: r8
  !
  ch = ' '
  nchar=min(len(ch),13)
  if (ndiv.eq.360) then
    r8 = rr8*1.8d2*3.6d3/pi
    call gag_cflab1 (ch, r8, nchar, 2)
  else
    r8 = rr8
10  r8 = r8+2.d0*pi
    if (r8.lt.0.d0) goto 10
    r8 = dmod(r8,2.d0*pi)*1.2d1*3.6d3/pi
    call gag_cflab1 (ch, r8, nchar, 3)
  endif
end subroutine sexag
!
subroutine deg2sexa(d8,ndiv,ch,ndig,left)
  use phys_const
  use gsys_interfaces, except_this=>deg2sexa
  !---------------------------------------------------------------------
  ! @ public
  !  Write an angle (degrees) in sexagesimal notation.
  !---------------------------------------------------------------------
  real(kind=8),     intent(in)           :: d8    ! [Deg] Angle
  integer(kind=4),  intent(in)           :: ndiv  ! [   ] Number of div. per turn (24/360)
  character(len=*), intent(out)          :: ch    ! [   ] Formatted string
  integer(kind=4),  intent(in), optional :: ndig  ! [   ] Number of digits desired
  logical,          intent(in), optional :: left  ! [   ] Left justify the output string?
  ! Local
  logical :: doleft
  !
  doleft = .false.  ! Default
  if (present(left))  doleft = left
  !
  if (present(ndig)) then
    call rad2sexa(d8*rad_per_deg,ndiv,ch,ndig,left=doleft)
  else
    call rad2sexa(d8*rad_per_deg,ndiv,ch,left=doleft)
  endif
  !
end subroutine deg2sexa
!
subroutine rad2sexa(rr8,ndiv,ch,ndig,left)
  use phys_const
  use gsys_interfaces, except_this=>rad2sexa
  !---------------------------------------------------------------------
  ! @ public
  !  Write an angle (radians) in sexagesimal notation.
  !  The number of digits in the fractional part is controled by 'ndig'.
  ! If absent, the string will be filled with as many digits as
  ! possible, for example if you want a 3 digits fractional part, use
  !  -DDD:MM:SS.SSS = 14 characters (360 divisions per turn)
  !  -HH:MM:SS.SSS = 13 characters (24 divisions per turn)
  !---------------------------------------------------------------------
  real(kind=8),     intent(in)           :: rr8   ! [Rad] Angle
  integer(kind=4),  intent(in)           :: ndiv  ! [   ] Number of div. per turn (24/360)
  character(len=*), intent(out)          :: ch    ! [   ] Formatted string
  integer(kind=4),  intent(in), optional :: ndig  ! [   ] Number of digits desired
  logical,          intent(in), optional :: left  ! [   ] Left justify the output string?
  ! Local
  integer(kind=4) :: nchar,ndigi
  real(kind=8) :: r8
  !
  ch = ' '
  nchar = len(ch)
  if (present(ndig)) then
    ndigi = ndig
  else
    if (ndiv.eq.360) then
      ndigi = nchar-11  ! "-DDD:MM:SS." = 11 characters reserved before digits
    else
      ndigi = nchar-10  ! "-HH:MM:SS." = 10 characters reserved before digits
    endif
  endif
  !
  if (ndiv.eq.360) then
    ! Degrees
    r8 = rr8 * sec_per_rad
    call gag_cflab1(ch,r8,nchar,ndigi)
  else
    ! Hour angle
    r8 = rr8
    do while (r8.lt.0.d0)
      r8 = r8+2.d0*pi
    enddo
    r8 = mod(r8,2.d0*pi) * hang_per_rad*3.6d3
    call gag_cflab1(ch,r8,nchar,ndigi)
  endif
  !
  ! Historical default is right-justified by gag_cflab1
  if (present(left)) then
    if (left) then
      ch = adjustl(ch)
    endif
  endif
  !
end subroutine rad2sexa
!
subroutine deg2dms(r8,d,m,s)
  !---------------------------------------------------------------------
  ! @ public
  !  Split a floating point value in degreee-minute-seconds numerical
  ! values. No assumption on the input value unit.
  !---------------------------------------------------------------------
  real(kind=8),    intent(in)  :: r8
  integer(kind=4), intent(out) :: d
  integer(kind=4), intent(out) :: m
  real(kind=8),    intent(out) :: s
  ! Local
  real(kind=8) :: v
  !
  v = abs(r8)
  !
  ! Degree
  d = floor(v)
  v = (v-d)*60.d0
  !
  ! Minute
  m  = floor(v)
  !
  ! Seconds
  s = (v-m)*60.d0
  !
  if (r8.lt.0.d0) then
    d = -d
    m = -m
    s = -s
  endif
  !
end subroutine deg2dms
!
subroutine gag_cflab (chrstr,x,w,d)
  !---------------------------------------------------------------------
  ! @ private
  !  Convert floating point value to a display of the form of the
  ! "Babylonian" ddd mm ss.s, where each field represents a sexagesimal
  ! increment over its successor. The value X must be in the units of
  ! the rightmost field.  For instance, X must be in seconds of time for
  ! hours, minutes, seconds display.
  !---------------------------------------------------------------------
  character(len=*), intent(out)   :: chrstr  ! Formatted string
  real(kind=8),     intent(in)    :: x       ! Input number
  integer(kind=4),  intent(inout) :: w       ! Length of string
  integer(kind=4),  intent(in)    :: d       ! Number of decimals
  ! Local
  real(kind=8) :: y
  integer(kind=4) :: h, m, s
  integer(kind=4) :: lh, lm, ls, dd
  integer(kind=8) :: f,fd
  character(len=20) :: th
  character(len=30) :: ts  ! Seconds+fractional part: arbitrary long
  character(len=2) :: tm
  logical :: short
  character(len=20) :: forma
  !
  short = .true.
  goto 1
  !
entry gag_cflab1 (chrstr, x, w, d)
  short = .false.
  !
1 y = abs (x)
  ! Hour
  h = y
  h = h / 3600
  y = y - (3600*h)
  ! Minute
  m = y
  m = m / 60
  y = y - (60*m)
  ! Second
  s = y
  y = y - s
  ! Rounding of the fractional part. This technique is limited to the 18 decimal
  ! digits stored in an I*8 for the fractional part (beyond 18, 'fd' overflows).
  ! Not a big problem since this is much further than the input R*8 precision.
  dd = min(max(0,d),18)
  fd = 10_8**dd
  f = fd*y + 0.5d0
  if (f .ge. fd) then
    f = f - fd
    s = s + 1
  endif
  if (s .gt. 59) then
    s = 0
    m = m + 1
  endif
  if (m .gt. 59) then
    m = 0
    h = h + 1
  endif
  if (x .lt. 0.d0) h = -h
  write(ts,'(I2.2,A1)') s,'.'
  if (dd.eq.0) then
    dd = -1
  else
    write(forma,'(A,I0,A,I0,A)')  '(I',dd,'.',dd,')'
    write(ts(4:3+dd),forma) f
  endif
  ls = dd+3
  !
  write(tm,'(I2.2)') m
  lm = 2
  !
  if ((h .eq. 0) .and. (x .ge. 0.d0)) then
    th = '00'
    lh = 2
  elseif ((h .eq. 0) .and. (x .lt. 0.d0)) then
    th = '-00'
    lh = 3
  else
    lh = alog10 (1.0 * abs(h) + .0001) + 1
    if (lh .eq. 1) lh = lh + 1 ! LH at least 2
    if (h .lt. 0) then
      lh = lh + 1              ! Allow for sign
      if (lh.eq.2) then
        write(th,132) h
      elseif (lh.eq.3) then
        write(th,133) h
      elseif (lh.eq.4) then
        write(th,134) h
      else
        write(th,120) h
      endif
    else
      if (lh.eq.2) then
        write(th,122) h
      elseif (lh.eq.3) then
        write(th,123) h
      elseif (lh.eq.4) then
        write(th,124) h
      else
        write(th,120) h
      endif
    endif
  endif
  !
  ! Short left justified format
  if (short) then
    chrstr(1:lh) = th
    chrstr(lh+1:lh+1) = ' '
    chrstr(lh+2:lh+3) = tm
    chrstr(lh+4:lh+4) = ' '
    chrstr(lh+5:w) = ts
    w = lh+lm+ls+2
  else
    !
    ! Long right justified format
    if (w .ge. lh+lm+ls+2) then
      chrstr (1:w-ls-lh-4) = ' '
      chrstr (w-ls-4-lh+1 : w-ls-4) = th
      chrstr (w-ls-3      : w-ls-3) = ':'
      chrstr (w-ls-2      : w-ls-1) = tm
      chrstr (w-ls        : w-ls)   = ':'
      chrstr (w-ls+1      : w)      = ts
    elseif (w .ge. lh+lm+1) then
      chrstr (1:w-3-lh) = ' '
      chrstr (w-3-lh+1 : w-3) = th
      chrstr (w-2      : w-2) = ':'
      chrstr (w-1      : w)   = tm
    elseif (w .ge. lh) then
      chrstr (1:w-lh) = ' '
      chrstr (w-lh+1 : w) = th
    else
      chrstr(1:w) = '*************'
    endif
  endif
  !
120 format (i10)
122 format (i2.2)
123 format (i3.2)
124 format (i4.2)
  !
132 format (i2.1)
133 format (i3.2)
134 format (i4.3)
end subroutine gag_cflab

*DECK SCG
      SUBROUTINE SCG (N, B, X, NELT, IA, JA, A, ISYM, MATVEC, MSOLVE,
     +   ITOL, TOL, ITMAX, ITER, ERR, IERR, IUNIT, R, Z, P, DZ, RWORK,
     +   IWORK)
C***BEGIN PROLOGUE  SCG
C***PURPOSE  Preconditioned Conjugate Gradient Sparse Ax=b Solver.
C            Routine to solve a symmetric positive definite linear
C            system  Ax = b  using the Preconditioned Conjugate
C            Gradient method.
C***LIBRARY   SLATEC (SLAP)
C***CATEGORY  D2B4
C***TYPE      SINGLE PRECISION (SCG-S, DCG-D)
C***KEYWORDS  ITERATIVE PRECONDITION, SLAP, SPARSE,
C             SYMMETRIC LINEAR SYSTEM
C***AUTHOR  Greenbaum, Anne, (Courant Institute)
C           Seager, Mark K., (LLNL)
C             Lawrence Livermore National Laboratory
C             PO BOX 808, L-60
C             Livermore, CA 94550 (510) 423-3141
C             seager@llnl.gov
C***DESCRIPTION
C
C *Usage:
C     INTEGER  N, NELT, IA(NELT), JA(NELT), ISYM, ITOL, ITMAX
C     INTEGER  ITER, IERR, IUNIT, IWORK(USER DEFINED)
C     REAL     B(N), X(N), A(NELT), TOL, ERR, R(N), Z(N)
C     REAL     P(N), DZ(N), RWORK(USER DEFINED)
C     EXTERNAL MATVEC, MSOLVE
C
C     CALL SCG(N, B, X, NELT, IA, JA, A, ISYM, MATVEC, MSOLVE,
C    $     ITOL, TOL, ITMAX, ITER, ERR, IERR, IUNIT, R, Z, P, DZ,
C    $     RWORK, IWORK )
C
C *Arguments:
C N      :IN       Integer.
C         Order of the Matrix.
C B      :IN       Real B(N).
C         Right-hand side vector.
C X      :INOUT    Real X(N).
C         On input X is your initial guess for solution vector.
C         On output X is the final approximate solution.
C NELT   :IN       Integer.
C         Number of Non-Zeros stored in A.
C IA     :IN       Integer IA(NELT).
C JA     :IN       Integer JA(NELT).
C A      :IN       Real A(NELT).
C         These arrays contain the matrix data structure for A.
C         It could take any form.  See "Description", below,
C         for more details.
C ISYM   :IN       Integer.
C         Flag to indicate symmetric storage format.
C         If ISYM=0, all non-zero entries of the matrix are stored.
C         If ISYM=1, the matrix is symmetric, and only the upper
C         or lower triangle of the matrix is stored.
C MATVEC :EXT      External.
C         Name of a routine which performs the matrix vector multiply
C         Y = A*X given A and X.  The name of the MATVEC routine must
C         be declared external in the calling program.  The calling
C         sequence to MATVEC is:
C
C             CALL MATVEC( N, X, Y, NELT, IA, JA, A, ISYM )
C
C         Where N is the number of unknowns, Y is the product A*X
C         upon return X is an input vector, NELT is the number of
C         non-zeros in the SLAP IA, JA, A storage for the matrix A.
C         ISYM is a flag which, if non-zero, denotest that A is
C         symmetric and only the lower or upper triangle is stored.
C MSOLVE :EXT      External.
C         Name of a routine which solves a linear system MZ = R for
C         Z given R with the preconditioning matrix M (M is supplied via
C         RWORK and IWORK arrays).  The name of the MSOLVE routine must
C         be declared external in the calling program.  The calling
C         sequence to MSOLVE is:
C
C             CALL MSOLVE(N, R, Z, NELT, IA, JA, A, ISYM, RWORK, IWORK)
C
C         Where N is the number of unknowns, R is the right-hand side
C         vector and Z is the solution upon return.  NELT, IA, JA, A and
C         ISYM are defined as above.  RWORK is a real array that can
C         be used to pass necessary preconditioning information and/or
C         workspace to MSOLVE.  IWORK is an integer work array for
C         the same purpose as RWORK.
C ITOL   :IN       Integer.
C         Flag to indicate type of convergence criterion.
C         If ITOL=1, iteration stops when the 2-norm of the residual
C         divided by the 2-norm of the right-hand side is less than TOL.
C         If ITOL=2, iteration stops when the 2-norm of M-inv times the
C         residual divided by the 2-norm of M-inv times the right hand
C         side is less than TOL, where M-inv is the inverse of the
C         diagonal of A.
C         ITOL=11 is often useful for checking and comparing different
C         routines.  For this case, the user must supply the "exact"
C         solution or a very accurate approximation (one with an error
C         much less than TOL) through a common block,
C             COMMON /SSLBLK/ SOLN( )
C         If ITOL=11, iteration stops when the 2-norm of the difference
C         between the iterative approximation and the user-supplied
C         solution divided by the 2-norm of the user-supplied solution
C         is less than TOL.  Note that this requires the user to set up
C         the "COMMON /SSLBLK/ SOLN(LENGTH)" in the calling routine.
C         The routine with this declaration should be loaded before the
C         stop test so that the correct length is used by the loader.
C         This procedure is not standard Fortran and may not work
C         correctly on your system (although it has worked on every
C         system the authors have tried).  If ITOL is not 11 then this
C         common block is indeed standard Fortran.
C TOL    :INOUT    Real.
C         Convergence criterion, as described above.  (Reset if IERR=4.)
C ITMAX  :IN       Integer.
C         Maximum number of iterations.
C ITER   :OUT      Integer.
C         Number of iterations required to reach convergence, or
C         ITMAX+1 if convergence criterion could not be achieved in
C         ITMAX iterations.
C ERR    :OUT      Real.
C         Error estimate of error in final approximate solution, as
C         defined by ITOL.
C IERR   :OUT      Integer.
C         Return error flag.
C           IERR = 0 => All went well.
C           IERR = 1 => Insufficient space allocated for WORK or IWORK.
C           IERR = 2 => Method failed to converge in ITMAX steps.
C           IERR = 3 => Error in user input.
C                       Check input values of N, ITOL.
C           IERR = 4 => User error tolerance set too tight.
C                       Reset to 500*R1MACH(3).  Iteration proceeded.
C           IERR = 5 => Preconditioning matrix, M, is not positive
C                       definite.  (r,z) < 0.
C           IERR = 6 => Matrix A is not positive definite.  (p,Ap) < 0.
C IUNIT  :IN       Integer.
C         Unit number on which to write the error at each iteration,
C         if this is desired for monitoring convergence.  If unit
C         number is 0, no writing will occur.
C R      :WORK     Real R(N).
C Z      :WORK     Real Z(N).
C P      :WORK     Real P(N).
C DZ     :WORK     Real DZ(N).
C         Real arrays used for workspace.
C RWORK  :WORK     Real RWORK(USER DEFINED).
C         Real array that can be used by  MSOLVE.
C IWORK  :WORK     Integer IWORK(USER DEFINED).
C         Integer array that can be used by  MSOLVE.
C
C *Description
C       This routine does  not care  what matrix data   structure is
C       used for  A and M.  It simply   calls  the MATVEC and MSOLVE
C       routines, with  the arguments as  described above.  The user
C       could write any type of structure and the appropriate MATVEC
C       and MSOLVE routines.  It is assumed  that A is stored in the
C       IA, JA, A  arrays in some fashion and  that M (or INV(M)) is
C       stored  in  IWORK  and  RWORK   in  some fashion.   The SLAP
C       routines SSDCG and SSICCG are examples of this procedure.
C
C       Two  examples  of  matrix  data structures  are the: 1) SLAP
C       Triad  format and 2) SLAP Column format.
C
C       =================== S L A P Triad format ===================
C
C       In  this   format only the  non-zeros are  stored.  They may
C       appear  in *ANY* order.   The user  supplies three arrays of
C       length NELT, where  NELT  is the number  of non-zeros in the
C       matrix:  (IA(NELT), JA(NELT),  A(NELT)).  For each  non-zero
C       the  user puts   the row  and  column index   of that matrix
C       element in the IA and JA arrays.  The  value of the non-zero
C       matrix  element is  placed in  the corresponding location of
C       the A  array.  This is  an extremely easy data  structure to
C       generate.  On  the other hand it  is  not too  efficient  on
C       vector  computers   for the  iterative  solution  of  linear
C       systems.  Hence, SLAP  changes this input  data structure to
C       the SLAP   Column  format for the  iteration (but   does not
C       change it back).
C
C       Here is an example of the  SLAP Triad   storage format for a
C       5x5 Matrix.  Recall that the entries may appear in any order.
C
C           5x5 Matrix      SLAP Triad format for 5x5 matrix on left.
C                              1  2  3  4  5  6  7  8  9 10 11
C       |11 12  0  0 15|   A: 51 12 11 33 15 53 55 22 35 44 21
C       |21 22  0  0  0|  IA:  5  1  1  3  1  5  5  2  3  4  2
C       | 0  0 33  0 35|  JA:  1  2  1  3  5  3  5  2  5  4  1
C       | 0  0  0 44  0|
C       |51  0 53  0 55|
C
C       =================== S L A P Column format ==================
C
C       In  this format   the non-zeros are    stored counting  down
C       columns (except  for the diagonal  entry, which must  appear
C       first in each "column") and are  stored in the real array A.
C       In other words,  for  each column    in the matrix   put the
C       diagonal  entry  in A.   Then   put  in the  other  non-zero
C       elements going   down the  column (except  the  diagonal) in
C       order.  The IA array holds the row index  for each non-zero.
C       The JA array holds the offsets into the IA, A arrays for the
C       beginning   of   each  column.      That is,   IA(JA(ICOL)),
C       A(JA(ICOL)) points to the beginning of the ICOL-th column in
C       IA and  A.  IA(JA(ICOL+1)-1), A(JA(ICOL+1)-1)  points to the
C       end of the ICOL-th column.  Note that we always have JA(N+1)
C       = NELT+1, where N is the number of columns in the matrix and
C       NELT is the number of non-zeros in the matrix.
C
C       Here is an example of the  SLAP Column  storage format for a
C       5x5 Matrix (in the A and IA arrays '|'  denotes the end of a
C       column):
C
C           5x5 Matrix      SLAP Column format for 5x5 matrix on left.
C                              1  2  3    4  5    6  7    8    9 10 11
C       |11 12  0  0 15|   A: 11 21 51 | 22 12 | 33 53 | 44 | 55 15 35
C       |21 22  0  0  0|  IA:  1  2  5 |  2  1 |  3  5 |  4 |  5  1  3
C       | 0  0 33  0 35|  JA:  1  4  6    8  9   12
C       | 0  0  0 44  0|
C       |51  0 53  0 55|
C
C *Cautions:
C     This routine will attempt to write to the Fortran logical output
C     unit IUNIT, if IUNIT .ne. 0.  Thus, the user must make sure that
C     this logical unit is attached to a file or terminal before calling
C     this routine with a non-zero value for IUNIT.  This routine does
C     not check for the validity of a non-zero IUNIT unit number.
C
C***SEE ALSO  SSDCG, SSICCG
C***REFERENCES  1. Louis Hageman and David Young, Applied Iterative
C                  Methods, Academic Press, New York, 1981.
C               2. Concus, Golub and O'Leary, A Generalized Conjugate
C                  Gradient Method for the Numerical Solution of
C                  Elliptic Partial Differential Equations, in Sparse
C                  Matrix Computations, Bunch and Rose, Eds., Academic
C                  Press, New York, 1979.
C               3. Mark K. Seager, A SLAP for the Masses, in
C                  G. F. Carey, Ed., Parallel Supercomputing: Methods,
C                  Algorithms and Applications, Wiley, 1989, pp.135-155.
C***ROUTINES CALLED  ISSCG, R1MACH, SAXPY, SCOPY, SDOT
C***REVISION HISTORY  (YYMMDD)
C   871119  DATE WRITTEN
C   881213  Previous REVISION DATE
C   890915  Made changes requested at July 1989 CML Meeting.  (MKS)
C   890921  Removed TeX from comments.  (FNF)
C   890922  Numerous changes to prologue to make closer to SLATEC
C           standard.  (FNF)
C   890929  Numerous changes to reduce SP/DP differences.  (FNF)
C   891004  Added new reference.
C   910411  Prologue converted to Version 4.0 format.  (BAB)
C   910502  Removed MATVEC and MSOLVE from ROUTINES CALLED list.  (FNF)
C   920407  COMMON BLOCK renamed SSLBLK.  (WRB)
C   920511  Added complete declaration section.  (WRB)
C   920929  Corrected format of references.  (FNF)
C   921019  Changed 500.0 to 500 to reduce SP/DP differences.  (FNF)
C***END PROLOGUE  SCG
C     .. Scalar Arguments ..
      REAL ERR, TOL
      INTEGER IERR, ISYM, ITER, ITMAX, ITOL, IUNIT, N, NELT
C     .. Array Arguments ..
      REAL A(NELT), B(N), DZ(N), P(N), R(N), RWORK(*), X(N), Z(N)
      INTEGER IA(NELT), IWORK(*), JA(NELT)
C     .. Subroutine Arguments ..
      EXTERNAL MATVEC, MSOLVE
C     .. Local Scalars ..
      REAL AK, AKDEN, BK, BKDEN, BKNUM, BNRM, SOLNRM, TOLMIN
      INTEGER I, K
C     .. External Functions ..
      REAL R1MACH, SDOT
      INTEGER ISSCG
      EXTERNAL R1MACH, SDOT, ISSCG
C     .. External Subroutines ..
      EXTERNAL SAXPY, SCOPY
C***FIRST EXECUTABLE STATEMENT  SCG
C
C         Check some of the input data.
C
      ITER = 0
      IERR = 0
      IF( N.LT.1 ) THEN
         IERR = 3
         RETURN
      ENDIF
      TOLMIN = 500*R1MACH(3)
      IF( TOL.LT.TOLMIN ) THEN
         TOL = TOLMIN
         IERR = 4
      ENDIF
C
C         Calculate initial residual and pseudo-residual, and check
C         stopping criterion.
      CALL MATVEC(N, X, R, NELT, IA, JA, A, ISYM)
      DO 10 I = 1, N
         R(I) = B(I) - R(I)
 10   CONTINUE
      CALL MSOLVE(N, R, Z, NELT, IA, JA, A, ISYM, RWORK, IWORK)
C
      IF( ISSCG(N, B, X, NELT, IA, JA, A, ISYM, MSOLVE, ITOL, TOL,
     $     ITMAX, ITER, ERR, IERR, IUNIT, R, Z, P, DZ,
     $     RWORK, IWORK, AK, BK, BNRM, SOLNRM) .NE. 0 ) GO TO 200
      IF( IERR.NE.0 ) RETURN
C
C         ***** Iteration loop *****
C
      DO 100 K=1,ITMAX
         ITER = K
C
C         Calculate coefficient bk and direction vector p.
         BKNUM = SDOT(N, Z, 1, R, 1)
         IF( BKNUM.LE.0.0E0 ) THEN
            IERR = 5
            RETURN
         ENDIF
         IF(ITER .EQ. 1) THEN
            CALL SCOPY(N, Z, 1, P, 1)
         ELSE
            BK = BKNUM/BKDEN
            DO 20 I = 1, N
               P(I) = Z(I) + BK*P(I)
 20         CONTINUE
         ENDIF
         BKDEN = BKNUM
C
C         Calculate coefficient ak, new iterate x, new residual r,
C         and new pseudo-residual z.
         CALL MATVEC(N, P, Z, NELT, IA, JA, A, ISYM)
         AKDEN = SDOT(N, P, 1, Z, 1)
         IF( AKDEN.LE.0.0E0 ) THEN
            IERR = 6
            RETURN
         ENDIF
         AK = BKNUM/AKDEN
         CALL SAXPY(N, AK, P, 1, X, 1)
         CALL SAXPY(N, -AK, Z, 1, R, 1)
         CALL MSOLVE(N, R, Z, NELT, IA, JA, A, ISYM, RWORK, IWORK)
C
C         check stopping criterion.
         IF( ISSCG(N, B, X, NELT, IA, JA, A, ISYM, MSOLVE, ITOL, TOL,
     $        ITMAX, ITER, ERR, IERR, IUNIT, R, Z, P, DZ, RWORK,
     $        IWORK, AK, BK, BNRM, SOLNRM) .NE. 0 ) GO TO 200
C
 100  CONTINUE
C
C         *****   end of loop  *****
C
C         stopping criterion not satisfied.
      ITER = ITMAX + 1
      IERR = 2
C
 200  RETURN
C------------- LAST LINE OF SCG FOLLOWS -----------------------------
      END
*DECK SCGN
      SUBROUTINE SCGN (N, B, X, NELT, IA, JA, A, ISYM, MATVEC, MTTVEC,
     +   MSOLVE, ITOL, TOL, ITMAX, ITER, ERR, IERR, IUNIT, R, Z, P, ATP,
     +   ATZ, DZ, ATDZ, RWORK, IWORK)
C***BEGIN PROLOGUE  SCGN
C***PURPOSE  Preconditioned CG Sparse Ax=b Solver for Normal Equations.
C            Routine to solve a general linear system  Ax = b  using the
C            Preconditioned Conjugate Gradient method applied to the
C            normal equations  AA'y = b, x=A'y.
C***LIBRARY   SLATEC (SLAP)
C***CATEGORY  D2A4, D2B4
C***TYPE      SINGLE PRECISION (SCGN-S, DCGN-D)
C***KEYWORDS  ITERATIVE PRECONDITION, NON-SYMMETRIC LINEAR SYSTEM SOLVE,
C             NORMAL EQUATIONS., SLAP, SPARSE
C***AUTHOR  Greenbaum, Anne, (Courant Institute)
C           Seager, Mark K., (LLNL)
C             Lawrence Livermore National Laboratory
C             PO BOX 808, L-60
C             Livermore, CA 94550 (510) 423-3141
C             seager@llnl.gov
C***DESCRIPTION
C
C *Usage:
C     INTEGER  N, NELT, IA(NELT), JA(NELT), ISYM, ITOL, ITMAX
C     INTEGER  ITER, IERR, IUNIT, IWORK(USER DEFINED)
C     REAL     B(N), X(N), A(NELT), TOL, ERR, R(N), Z(N)
C     REAL     P(N), ATP(N), ATZ(N), DZ(N), ATDZ(N)
C     REAL     RWORK(USER DEFINED)
C     EXTERNAL MATVEC, MTTVEC, MSOLVE
C
C     CALL SCGN(N, B, X, NELT, IA, JA, A, ISYM, MATVEC, MTTVEC,
C    $     MSOLVE, ITOL, TOL, ITMAX, ITER, ERR, IERR, IUNIT, R,
C    $     Z, P, ATP, ATZ, DZ, ATDZ, RWORK, IWORK)
C
C *Arguments:
C N      :IN       Integer
C         Order of the Matrix.
C B      :IN       Real B(N).
C         Right-hand side vector.
C X      :INOUT    Real X(N).
C         On input X is your initial guess for solution vector.
C         On output X is the final approximate solution.
C NELT   :IN       Integer.
C         Number of Non-Zeros stored in A.
C IA     :IN       Integer IA(NELT).
C JA     :IN       Integer JA(NELT).
C A      :IN       Real A(NELT).
C         These arrays contain the matrix data structure for A.
C         It could take any form.  See "Description", below,
C         for more details.
C ISYM   :IN       Integer.
C         Flag to indicate symmetric storage format.
C         If ISYM=0, all non-zero entries of the matrix are stored.
C         If ISYM=1, the matrix is symmetric, and only the upper
C         or lower triangle of the matrix is stored.
C MATVEC :EXT      External.
C         Name of a routine which performs the matrix vector multiply
C         y = A*X given A and X.  The name of the MATVEC routine must
C         be declared external in the calling program.  The calling
C         sequence to MATVEC is:
C             CALL MATVEC( N, X, Y, NELT, IA, JA, A, ISYM )
C         Where N is the number of unknowns, Y is the product A*X
C         upon return X is an input vector, NELT is the number of
C         non-zeros in the SLAP-Column IA, JA, A storage for the matrix
C         A.  ISYM is a flag which, if non-zero, denotes that A is
C         symmetric and only the lower or upper triangle is stored.
C MTTVEC :EXT      External.
C         Name of a routine which performs the matrix transpose vector
C         multiply y = A'*X given A and X (where ' denotes transpose).
C         The name of the MTTVEC routine must be declared external in
C         the calling program.  The calling sequence to MTTVEC is the
C         same as that for MATVEC, viz.:
C             CALL MTTVEC( N, X, Y, NELT, IA, JA, A, ISYM )
C         Where N is the number of unknowns, Y is the product A'*X
C         upon return X is an input vector, NELT is the number of
C         non-zeros in the SLAP-Column IA, JA, A storage for the matrix
C         A.  ISYM is a flag which, if non-zero, denotes that A is
C         symmetric and only the lower or upper triangle is stored.
C MSOLVE :EXT      External.
C         Name of a routine which solves a linear system MZ = R for
C         Z given R with the preconditioning matrix M (M is supplied via
C         RWORK and IWORK arrays).  The name of the MSOLVE routine must
C         be declared external in the calling program.  The calling
C         sequence to MSOLVE is:
C             CALL MSOLVE(N, R, Z, NELT, IA, JA, A, ISYM, RWORK, IWORK)
C         Where N is the number of unknowns, R is the right-hand side
C         vector and Z is the solution upon return.  NELT, IA, JA, A and
C         ISYM are defined as above.  RWORK is a real array that can
C         be used to pass necessary preconditioning information and/or
C         workspace to MSOLVE.  IWORK is an integer work array for
C         the same purpose as RWORK.
C ITOL   :IN       Integer.
C         Flag to indicate type of convergence criterion.
C         If ITOL=1, iteration stops when the 2-norm of the residual
C         divided by the 2-norm of the right-hand side is less than TOL.
C         If ITOL=2, iteration stops when the 2-norm of M-inv times the
C         residual divided by the 2-norm of M-inv times the right hand
C         side is less than TOL, where M-inv is the inverse of the
C         diagonal of A.
C         ITOL=11 is often useful for checking and comparing different
C         routines.  For this case, the user must supply the "exact"
C         solution or a very accurate approximation (one with an error
C         much less than TOL) through a common block,
C             COMMON /SSLBLK/ SOLN( )
C         If ITOL=11, iteration stops when the 2-norm of the difference
C         between the iterative approximation and the user-supplied
C         solution divided by the 2-norm of the user-supplied solution
C         is less than TOL.  Note that this requires the user to set up
C         the "COMMON /SSLBLK/ SOLN(LENGTH)" in the calling routine.
C         The routine with this declaration should be loaded before the
C         stop test so that the correct length is used by the loader.
C         This procedure is not standard Fortran and may not work
C         correctly on your system (although it has worked on every
C         system the authors have tried).  If ITOL is not 11 then this
C         common block is indeed standard Fortran.
C TOL    :INOUT    Real.
C         Convergence criterion, as described above.  (Reset if IERR=4.)
C ITMAX  :IN       Integer.
C         Maximum number of iterations.
C ITER   :OUT      Integer.
C         Number of iterations required to reach convergence, or
C         ITMAX+1 if convergence criterion could not be achieved in
C         ITMAX iterations.
C ERR    :OUT      Real.
C         Error estimate of error in final approximate solution, as
C         defined by ITOL.
C IERR   :OUT      Integer.
C         Return error flag.
C           IERR = 0 => All went well.
C           IERR = 1 => Insufficient space allocated for WORK or IWORK.
C           IERR = 2 => Method failed to converge in ITMAX steps.
C           IERR = 3 => Error in user input.
C                       Check input values of N, ITOL.
C           IERR = 4 => User error tolerance set too tight.
C                       Reset to 500*R1MACH(3).  Iteration proceeded.
C           IERR = 5 => Preconditioning matrix, M, is not positive
C                       definite.  (r,z) < 0.
C           IERR = 6 => Matrix A is not positive definite.  (p,Ap) < 0.
C IUNIT  :IN       Integer.
C         Unit number on which to write the error at each iteration,
C         if this is desired for monitoring convergence.  If unit
C         number is 0, no writing will occur.
C R      :WORK     Real R(N).
C Z      :WORK     Real Z(N).
C P      :WORK     Real P(N).
C ATP    :WORK     Real ATP(N).
C ATZ    :WORK     Real ATZ(N).
C DZ     :WORK     Real DZ(N).
C ATDZ   :WORK     Real ATDZ(N).
C         Real arrays used for workspace.
C RWORK  :WORK     Real RWORK(USER DEFINED).
C         Real array that can be used by  MSOLVE.
C IWORK  :WORK     Integer IWORK(USER DEFINED).
C         Integer array that can be used by  MSOLVE.
C
C *Description:
C       This  routine applies the  preconditioned conjugate gradient
C       (PCG) method to a non-symmetric system of equations Ax=b. To
C       do this the normal equations are solved:
C               AA' y  = b, where  x  = A'y.
C       In PCG method the iteration count is determined by condition
C                               -1
C       number of the  matrix (M  A).   In the  situation where  the
C       normal equations are  used  to solve a  non-symmetric system
C       the condition number depends on  AA' and should therefore be
C       much worse than that of A.  This is the conventional wisdom.
C       When one has a good preconditioner for AA' this may not hold.
C       The latter is the situation when SCGN should be tried.
C
C       If one is trying to solve  a symmetric system, SCG should be
C       used instead.
C
C       This routine does  not care  what matrix data   structure is
C       used for A and M.  It simply calls MATVEC, MTTVEC and MSOLVE
C       routines, with arguments as described above.  The user could
C       write any type of structure, and  appropriate MATVEC, MTTVEC
C       and MSOLVE routines.  It is assumed  that A is stored in the
C       IA, JA, A  arrays in some fashion and  that M (or INV(M)) is
C       stored  in  IWORK  and  RWORK)  in  some fashion.   The SLAP
C       routines SSDCGN and SSLUCN are examples of this procedure.
C
C       Two  examples  of  matrix  data structures  are the: 1) SLAP
C       Triad  format and 2) SLAP Column format.
C
C       =================== S L A P Triad format ===================
C
C       In  this   format only the  non-zeros are  stored.  They may
C       appear  in *ANY* order.   The user  supplies three arrays of
C       length NELT, where  NELT  is the number  of non-zeros in the
C       matrix:  (IA(NELT), JA(NELT),  A(NELT)).  For each  non-zero
C       the  user puts   the row  and  column index   of that matrix
C       element in the IA and JA arrays.  The  value of the non-zero
C       matrix  element is  placed in  the corresponding location of
C       the A  array.  This is  an extremely easy data  structure to
C       generate.  On  the other hand it  is  not too  efficient  on
C       vector  computers   for the  iterative  solution  of  linear
C       systems.  Hence, SLAP  changes this input  data structure to
C       the SLAP   Column  format for the  iteration (but   does not
C       change it back).
C
C       Here is an example of the  SLAP Triad   storage format for a
C       5x5 Matrix.  Recall that the entries may appear in any order.
C
C           5x5 Matrix      SLAP Triad format for 5x5 matrix on left.
C                              1  2  3  4  5  6  7  8  9 10 11
C       |11 12  0  0 15|   A: 51 12 11 33 15 53 55 22 35 44 21
C       |21 22  0  0  0|  IA:  5  1  1  3  1  5  5  2  3  4  2
C       | 0  0 33  0 35|  JA:  1  2  1  3  5  3  5  2  5  4  1
C       | 0  0  0 44  0|
C       |51  0 53  0 55|
C
C       =================== S L A P Column format ==================
C
C       In  this format   the non-zeros are    stored counting  down
C       columns (except  for the diagonal  entry, which must  appear
C       first in each "column") and are  stored in the real array A.
C       In other words,  for  each column    in the matrix   put the
C       diagonal  entry  in A.   Then   put  in the  other  non-zero
C       elements going   down the  column (except  the  diagonal) in
C       order.  The IA array holds the row index  for each non-zero.
C       The JA array holds the offsets into the IA, A arrays for the
C       beginning   of   each  column.      That is,   IA(JA(ICOL)),
C       A(JA(ICOL)) points to the beginning of the ICOL-th column in
C       IA and  A.  IA(JA(ICOL+1)-1), A(JA(ICOL+1)-1)  points to the
C       end of the ICOL-th column.  Note that we always have JA(N+1)
C       = NELT+1, where N is the number of columns in the matrix and
C       NELT is the number of non-zeros in the matrix.
C
C       Here is an example of the  SLAP Column  storage format for a
C       5x5 Matrix (in the A and IA arrays '|'  denotes the end of a
C       column):
C
C           5x5 Matrix      SLAP Column format for 5x5 matrix on left.
C                              1  2  3    4  5    6  7    8    9 10 11
C       |11 12  0  0 15|   A: 11 21 51 | 22 12 | 33 53 | 44 | 55 15 35
C       |21 22  0  0  0|  IA:  1  2  5 |  2  1 |  3  5 |  4 |  5  1  3
C       | 0  0 33  0 35|  JA:  1  4  6    8  9   12
C       | 0  0  0 44  0|
C       |51  0 53  0 55|
C
C *Cautions:
C     This routine will attempt to write to the Fortran logical output
C     unit IUNIT, if IUNIT .ne. 0.  Thus, the user must make sure that
C     this logical unit is attached to a file or terminal before calling
C     this routine with a non-zero value for IUNIT.  This routine does
C     not check for the validity of a non-zero IUNIT unit number.
C
C***SEE ALSO  SSDCGN, SSLUCN, ISSCGN
C***REFERENCES  1. Mark K. Seager, A SLAP for the Masses, in
C                  G. F. Carey, Ed., Parallel Supercomputing: Methods,
C                  Algorithms and Applications, Wiley, 1989, pp.135-155.
C***ROUTINES CALLED  ISSCGN, R1MACH, SAXPY, SCOPY, SDOT
C***REVISION HISTORY  (YYMMDD)
C   871119  DATE WRITTEN
C   881213  Previous REVISION DATE
C   890915  Made changes requested at July 1989 CML Meeting.  (MKS)
C   890921  Removed TeX from comments.  (FNF)
C   890922  Numerous changes to prologue to make closer to SLATEC
C           standard.  (FNF)
C   890929  Numerous changes to reduce SP/DP differences.  (FNF)
C   891004  Added new reference.
C   910411  Prologue converted to Version 4.0 format.  (BAB)
C   910502  Removed MATVEC, MTTVEC and MSOLVE from ROUTINES CALLED
C           list.  (FNF)
C   920407  COMMON BLOCK renamed SSLBLK.  (WRB)
C   920511  Added complete declaration section.  (WRB)
C   920929  Corrected format of reference.  (FNF)
C   921019  Changed 500.0 to 500 to reduce SP/DP differences.  (FNF)
C   921113  Corrected C***CATEGORY line.  (FNF)
C***END PROLOGUE  SCGN
C     .. Scalar Arguments ..
      REAL ERR, TOL
      INTEGER IERR, ISYM, ITER, ITMAX, ITOL, IUNIT, N, NELT
C     .. Array Arguments ..
      REAL A(N), ATDZ(N), ATP(N), ATZ(N), B(N), DZ(N), P(N), R(N),
     +     RWORK(*), X(N), Z(N)
      INTEGER IA(NELT), IWORK(*), JA(NELT)
C     .. Subroutine Arguments ..
      EXTERNAL MATVEC, MSOLVE, MTTVEC
C     .. Local Scalars ..
      REAL AK, AKDEN, BK, BKDEN, BKNUM, BNRM, SOLNRM, TOLMIN
      INTEGER I, K
C     .. External Functions ..
      REAL R1MACH, SDOT
      INTEGER ISSCGN
      EXTERNAL R1MACH, SDOT, ISSCGN
C     .. External Subroutines ..
      EXTERNAL SAXPY, SCOPY
C***FIRST EXECUTABLE STATEMENT  SCGN
C
C         Check user input.
C
      ITER = 0
      IERR = 0
      IF( N.LT.1 ) THEN
         IERR = 3
         RETURN
      ENDIF
      TOLMIN = 500*R1MACH(3)
      IF( TOL.LT.TOLMIN ) THEN
         TOL = TOLMIN
         IERR = 4
      ENDIF
C         Calculate initial residual and pseudo-residual, and check
C         stopping criterion.
      CALL MATVEC(N, X, R, NELT, IA, JA, A, ISYM)
      DO 10 I = 1, N
         R(I) = B(I) - R(I)
 10   CONTINUE
      CALL MSOLVE(N, R, Z, NELT, IA, JA, A, ISYM, RWORK, IWORK)
      CALL MTTVEC(N, Z, ATZ, NELT, IA, JA, A, ISYM)
C
      IF( ISSCGN(N, B, X, NELT, IA, JA, A, ISYM, MATVEC, MTTVEC, MSOLVE,
     $     ITOL, TOL, ITMAX, ITER, ERR, IERR, IUNIT, R, Z, P, ATP, ATZ,
     $     DZ, ATDZ, RWORK, IWORK, AK, BK, BNRM, SOLNRM) .NE. 0 )
     $     GO TO 200
      IF( IERR.NE.0 ) RETURN
C
C         ***** iteration loop *****
C
      DO 100 K=1,ITMAX
         ITER = K
C
C         Calculate coefficient BK and direction vector P.
         BKNUM = SDOT(N, Z, 1, R, 1)
         IF( BKNUM.LE.0.0E0 ) THEN
            IERR = 6
            RETURN
         ENDIF
         IF(ITER .EQ. 1) THEN
            CALL SCOPY(N, Z, 1, P, 1)
         ELSE
            BK = BKNUM/BKDEN
            DO 20 I = 1, N
               P(I) = Z(I) + BK*P(I)
 20         CONTINUE
         ENDIF
         BKDEN = BKNUM
C
C         Calculate coefficient AK, new iterate X, new residual R,
C         and new pseudo-residual ATZ.
         IF(ITER .NE. 1) CALL SAXPY(N, BK, ATP, 1, ATZ, 1)
         CALL SCOPY(N, ATZ, 1, ATP, 1)
         AKDEN = SDOT(N, ATP, 1, ATP, 1)
         IF( AKDEN.LE.0.0E0 ) THEN
            IERR = 6
            RETURN
         ENDIF
         AK = BKNUM/AKDEN
         CALL SAXPY(N, AK, ATP, 1, X, 1)
         CALL MATVEC(N, ATP, Z, NELT, IA, JA, A, ISYM)
         CALL SAXPY(N, -AK, Z, 1, R, 1)
         CALL MSOLVE(N, R, Z, NELT, IA, JA, A, ISYM, RWORK, IWORK)
         CALL MTTVEC(N, Z, ATZ, NELT, IA, JA, A, ISYM)
C
C         check stopping criterion.
         IF( ISSCGN(N, B, X, NELT, IA, JA, A, ISYM, MATVEC, MTTVEC,
     $        MSOLVE, ITOL, TOL, ITMAX, ITER, ERR, IERR, IUNIT, R,
     $        Z, P, ATP, ATZ, DZ, ATDZ, RWORK, IWORK, AK, BK, BNRM,
     $        SOLNRM) .NE. 0) GOTO 200
C
 100  CONTINUE
C
C         *****   end of loop  *****
C
C         stopping criterion not satisfied.
      ITER = ITMAX + 1
C
 200  RETURN
C------------- LAST LINE OF SCGN FOLLOWS ----------------------------
      END
*DECK SCGS
      SUBROUTINE SCGS (N, B, X, NELT, IA, JA, A, ISYM, MATVEC, MSOLVE,
     +   ITOL, TOL, ITMAX, ITER, ERR, IERR, IUNIT, R, R0, P, Q, U, V1,
     +   V2, RWORK, IWORK)
C***BEGIN PROLOGUE  SCGS
C***PURPOSE  Preconditioned BiConjugate Gradient Squared Ax=b Solver.
C            Routine to solve a Non-Symmetric linear system  Ax = b
C            using the Preconditioned BiConjugate Gradient Squared
C            method.
C***LIBRARY   SLATEC (SLAP)
C***CATEGORY  D2A4, D2B4
C***TYPE      SINGLE PRECISION (SCGS-S, DCGS-D)
C***KEYWORDS  BICONJUGATE GRADIENT, ITERATIVE PRECONDITION,
C             NON-SYMMETRIC LINEAR SYSTEM, SLAP, SPARSE
C***AUTHOR  Greenbaum, Anne, (Courant Institute)
C           Seager, Mark K., (LLNL)
C             Lawrence Livermore National Laboratory
C             PO BOX 808, L-60
C             Livermore, CA 94550 (510) 423-3141
C             seager@llnl.gov
C***DESCRIPTION
C
C *Usage:
C      INTEGER N, NELT, IA(NELT), JA(NELT), ISYM, ITOL, ITMAX
C      INTEGER ITER, IERR, IUNIT, IWORK(USER DEFINED)
C      REAL    B(N), X(N), A(NELT), TOL, ERR, R(N), R0(N), P(N)
C      REAL    Q(N), U(N), V1(N), V2(N), RWORK(USER DEFINED)
C      EXTERNAL MATVEC, MSOLVE
C
C      CALL SCGS(N, B, X, NELT, IA, JA, A, ISYM, MATVEC,
C     $     MSOLVE, ITOL, TOL, ITMAX, ITER, ERR, IERR, IUNIT,
C     $     R, R0, P, Q, U, V1, V2, RWORK, IWORK)
C
C *Arguments:
C N      :IN       Integer
C         Order of the Matrix.
C B      :IN       Real B(N).
C         Right-hand side vector.
C X      :INOUT    Real X(N).
C         On input X is your initial guess for solution vector.
C         On output X is the final approximate solution.
C NELT   :IN       Integer.
C         Number of Non-Zeros stored in A.
C IA     :IN       Integer IA(NELT).
C JA     :IN       Integer JA(NELT).
C A      :IN       Real A(NELT).
C         These arrays contain the matrix data structure for A.
C         It could take any form.  See "Description", below,
C         for more details.
C ISYM   :IN       Integer.
C         Flag to indicate symmetric storage format.
C         If ISYM=0, all non-zero entries of the matrix are stored.
C         If ISYM=1, the matrix is symmetric, and only the upper
C         or lower triangle of the matrix is stored.
C MATVEC :EXT      External.
C         Name of a routine which  performs the matrix vector multiply
C         operation  Y = A*X  given A and X.  The  name of  the MATVEC
C         routine must  be declared external  in the  calling program.
C         The calling sequence of MATVEC is:
C             CALL MATVEC( N, X, Y, NELT, IA, JA, A, ISYM )
C         Where N is the number of unknowns, Y is the product A*X upon
C         return,  X is an input  vector.  NELT, IA,  JA,  A and  ISYM
C         define the SLAP matrix data structure: see Description,below.
C MSOLVE :EXT      External.
C         Name of a routine which solves a linear system MZ = R  for Z
C         given R with the preconditioning matrix M (M is supplied via
C         RWORK  and IWORK arrays).   The name  of  the MSOLVE routine
C         must be declared  external  in the  calling   program.   The
C         calling sequence of MSOLVE is:
C             CALL MSOLVE(N, R, Z, NELT, IA, JA, A, ISYM, RWORK, IWORK)
C         Where N is the number of unknowns, R is  the right-hand side
C         vector, and Z is the solution upon return.  NELT,  IA, JA, A
C         and  ISYM define the SLAP  matrix  data structure: see
C         Description, below.  RWORK is a  real array that can be used
C         to  pass   necessary  preconditioning     information and/or
C         workspace to MSOLVE.  IWORK is an integer work array for the
C         same purpose as RWORK.
C ITOL   :IN       Integer.
C         Flag to indicate type of convergence criterion.
C         If ITOL=1, iteration stops when the 2-norm of the residual
C         divided by the 2-norm of the right-hand side is less than TOL.
C         This routine must calculate the residual from R = A*X - B.
C         This is unnatural and hence expensive for this type of iter-
C         ative method.  ITOL=2 is *STRONGLY* recommended.
C         If ITOL=2, iteration stops when the 2-norm of M-inv times the
C         residual divided by the 2-norm of M-inv times the right hand
C         side is less than TOL, where M-inv time a vector is the pre-
C         conditioning step.  This is the *NATURAL* stopping for this
C         iterative method and is *STRONGLY* recommended.
C         ITOL=11 is often useful for checking and comparing different
C         routines.  For this case, the user must supply the "exact"
C         solution or a very accurate approximation (one with an error
C         much less than TOL) through a common block,
C             COMMON /SSLBLK/ SOLN( )
C         If ITOL=11, iteration stops when the 2-norm of the difference
C         between the iterative approximation and the user-supplied
C         solution divided by the 2-norm of the user-supplied solution
C         is less than TOL.
C TOL    :INOUT    Real.
C         Convergence criterion, as described above.  (Reset if IERR=4.)
C ITMAX  :IN       Integer.
C         Maximum number of iterations.
C ITER   :OUT      Integer.
C         Number of iterations required to reach convergence, or
C         ITMAX+1 if convergence criterion could not be achieved in
C         ITMAX iterations.
C ERR    :OUT      Real.
C         Error estimate of error in final approximate solution, as
C         defined by ITOL.
C IERR   :OUT      Integer.
C         Return error flag.
C           IERR = 0 => All went well.
C           IERR = 1 => Insufficient space allocated for WORK or IWORK.
C           IERR = 2 => Method failed to converge in ITMAX steps.
C           IERR = 3 => Error in user input.
C                       Check input values of N, ITOL.
C           IERR = 4 => User error tolerance set too tight.
C                       Reset to 500*R1MACH(3).  Iteration proceeded.
C           IERR = 5 => Breakdown of the method detected.
C                       (r0,r) approximately 0.
C           IERR = 6 => Stagnation of the method detected.
C                       (r0,v) approximately 0.
C IUNIT  :IN       Integer.
C         Unit number on which to write the error at each iteration,
C         if this is desired for monitoring convergence.  If unit
C         number is 0, no writing will occur.
C R      :WORK     Real R(N).
C R0     :WORK     Real R0(N).
C P      :WORK     Real P(N).
C Q      :WORK     Real Q(N).
C U      :WORK     Real U(N).
C V1     :WORK     Real V1(N).
C V2     :WORK     Real V2(N).
C         Real arrays used for workspace.
C RWORK  :WORK     Real RWORK(USER DEFINED).
C         Real array that can be used for workspace in MSOLVE.
C IWORK  :WORK     Integer IWORK(USER DEFINED).
C         Integer array that can be used for workspace in MSOLVE.
C
C *Description
C       This routine does  not care  what matrix data   structure is
C       used for  A and M.  It simply   calls  the MATVEC and MSOLVE
C       routines, with  the arguments as  described above.  The user
C       could write any type of structure and the appropriate MATVEC
C       and MSOLVE routines.  It is assumed  that A is stored in the
C       IA, JA, A  arrays in some fashion and  that M (or INV(M)) is
C       stored  in  IWORK  and  RWORK   in  some fashion.   The SLAP
C       routines SSDBCG and SSLUCS are examples of this procedure.
C
C       Two  examples  of  matrix  data structures  are the: 1) SLAP
C       Triad  format and 2) SLAP Column format.
C
C       =================== S L A P Triad format ===================
C
C       In  this   format only the  non-zeros are  stored.  They may
C       appear  in *ANY* order.   The user  supplies three arrays of
C       length NELT, where  NELT  is the number  of non-zeros in the
C       matrix:  (IA(NELT), JA(NELT),  A(NELT)).  For each  non-zero
C       the  user puts   the row  and  column index   of that matrix
C       element in the IA and JA arrays.  The  value of the non-zero
C       matrix  element is  placed in  the corresponding location of
C       the A  array.  This is  an extremely easy data  structure to
C       generate.  On  the other hand it  is  not too  efficient  on
C       vector  computers   for the  iterative  solution  of  linear
C       systems.  Hence, SLAP  changes this input  data structure to
C       the SLAP   Column  format for the  iteration (but   does not
C       change it back).
C
C       Here is an example of the  SLAP Triad   storage format for a
C       5x5 Matrix.  Recall that the entries may appear in any order.
C
C           5x5 Matrix      SLAP Triad format for 5x5 matrix on left.
C                              1  2  3  4  5  6  7  8  9 10 11
C       |11 12  0  0 15|   A: 51 12 11 33 15 53 55 22 35 44 21
C       |21 22  0  0  0|  IA:  5  1  1  3  1  5  5  2  3  4  2
C       | 0  0 33  0 35|  JA:  1  2  1  3  5  3  5  2  5  4  1
C       | 0  0  0 44  0|
C       |51  0 53  0 55|
C
C       =================== S L A P Column format ==================
C
C       In  this format   the non-zeros are    stored counting  down
C       columns (except  for the diagonal  entry, which must  appear
C       first in each "column") and are  stored in the real array A.
C       In other words,  for  each column    in the matrix   put the
C       diagonal  entry  in A.   Then   put  in the  other  non-zero
C       elements going   down the  column (except  the  diagonal) in
C       order.  The IA array holds the row index  for each non-zero.
C       The JA array holds the offsets into the IA, A arrays for the
C       beginning   of   each  column.      That is,   IA(JA(ICOL)),
C       A(JA(ICOL)) points to the beginning of the ICOL-th column in
C       IA and  A.  IA(JA(ICOL+1)-1), A(JA(ICOL+1)-1)  points to the
C       end of the ICOL-th column.  Note that we always have JA(N+1)
C       = NELT+1, where N is the number of columns in the matrix and
C       NELT is the number of non-zeros in the matrix.
C
C       Here is an example of the  SLAP Column  storage format for a
C       5x5 Matrix (in the A and IA arrays '|'  denotes the end of a
C       column):
C
C           5x5 Matrix      SLAP Column format for 5x5 matrix on left.
C                              1  2  3    4  5    6  7    8    9 10 11
C       |11 12  0  0 15|   A: 11 21 51 | 22 12 | 33 53 | 44 | 55 15 35
C       |21 22  0  0  0|  IA:  1  2  5 |  2  1 |  3  5 |  4 |  5  1  3
C       | 0  0 33  0 35|  JA:  1  4  6    8  9   12
C       | 0  0  0 44  0|
C       |51  0 53  0 55|
C
C *Cautions:
C     This routine will attempt to write to the Fortran logical output
C     unit IUNIT, if IUNIT .ne. 0.  Thus, the user must make sure that
C     this logical unit is attached to a file or terminal before calling
C     this routine with a non-zero value for IUNIT.  This routine does
C     not check for the validity of a non-zero IUNIT unit number.
C
C***SEE ALSO  SSDCGS, SSLUCS
C***REFERENCES  1. P. Sonneveld, CGS, a fast Lanczos-type solver
C                  for nonsymmetric linear systems, Delft University
C                  of Technology Report 84-16, Department of Mathe-
C                  matics and Informatics, Delft, The Netherlands.
C               2. E. F. Kaasschieter, The solution of non-symmetric
C                  linear systems by biconjugate gradients or conjugate
C                  gradients squared,  Delft University of Technology
C                  Report 86-21, Department of Mathematics and Informa-
C                  tics, Delft, The Netherlands.
C               3. Mark K. Seager, A SLAP for the Masses, in
C                  G. F. Carey, Ed., Parallel Supercomputing: Methods,
C                  Algorithms and Applications, Wiley, 1989, pp.135-155.
C***ROUTINES CALLED  ISSCGS, R1MACH, SAXPY, SDOT
C***REVISION HISTORY  (YYMMDD)
C   871119  DATE WRITTEN
C   881213  Previous REVISION DATE
C   890915  Made changes requested at July 1989 CML Meeting.  (MKS)
C   890921  Removed TeX from comments.  (FNF)
C   890922  Numerous changes to prologue to make closer to SLATEC
C           standard.  (FNF)
C   890929  Numerous changes to reduce SP/DP differences.  (FNF)
C   891004  Added new reference.
C   910411  Prologue converted to Version 4.0 format.  (BAB)
C   910502  Removed MATVEC and MSOLVE from ROUTINES CALLED list.  (FNF)
C   920407  COMMON BLOCK renamed SSLBLK.  (WRB)
C   920511  Added complete declaration section.  (WRB)
C   920929  Corrected format of references.  (FNF)
C   921019  Changed 500.0 to 500 to reduce SP/DP differences.  (FNF)
C   921113  Corrected C***CATEGORY line.  (FNF)
C***END PROLOGUE  SCGS
C     .. Scalar Arguments ..
      REAL ERR, TOL
      INTEGER IERR, ISYM, ITER, ITMAX, ITOL, IUNIT, N, NELT
C     .. Array Arguments ..
      REAL A(NELT), B(N), P(N), Q(N), R(N), R0(N), RWORK(*), U(N),
     +     V1(N), V2(N), X(N)
      INTEGER IA(NELT), IWORK(*), JA(NELT)
C     .. Subroutine Arguments ..
      EXTERNAL MATVEC, MSOLVE
C     .. Local Scalars ..
      REAL AK, AKM, BK, BNRM, FUZZ, RHON, RHONM1, SIGMA, SOLNRM, TOLMIN
      INTEGER I, K
C     .. External Functions ..
      REAL R1MACH, SDOT
      INTEGER ISSCGS
      EXTERNAL R1MACH, SDOT, ISSCGS
C     .. External Subroutines ..
      EXTERNAL SAXPY
C     .. Intrinsic Functions ..
      INTRINSIC ABS
C***FIRST EXECUTABLE STATEMENT  SCGS
C
C         Check some of the input data.
C
      ITER = 0
      IERR = 0
      IF( N.LT.1 ) THEN
         IERR = 3
         RETURN
      ENDIF
      TOLMIN = 500*R1MACH(3)
      IF( TOL.LT.TOLMIN ) THEN
         TOL = TOLMIN
         IERR = 4
      ENDIF
C
C         Calculate initial residual and pseudo-residual, and check
C         stopping criterion.
      CALL MATVEC(N, X, R, NELT, IA, JA, A, ISYM)
      DO 10 I = 1, N
         V1(I)  = R(I) - B(I)
 10   CONTINUE
      CALL MSOLVE(N, V1, R, NELT, IA, JA, A, ISYM, RWORK, IWORK)
C
      IF( ISSCGS(N, B, X, NELT, IA, JA, A, ISYM, MATVEC, MSOLVE,
     $     ITOL, TOL, ITMAX, ITER, ERR, IERR, IUNIT, R, R0, P, Q,
     $     U, V1, V2, RWORK, IWORK, AK, BK, BNRM, SOLNRM) .NE. 0 )
     $     GO TO 200
      IF( IERR.NE.0 ) RETURN
C
C         Set initial values.
C
      FUZZ = R1MACH(3)**2
      DO 20 I = 1, N
         R0(I) = R(I)
 20   CONTINUE
      RHONM1 = 1
C
C         ***** ITERATION LOOP *****
C
      DO 100 K=1,ITMAX
         ITER = K
C
C         Calculate coefficient BK and direction vectors U, V and P.
         RHON = SDOT(N, R0, 1, R, 1)
         IF( ABS(RHONM1).LT.FUZZ ) GOTO 998
         BK = RHON/RHONM1
         IF( ITER.EQ.1 ) THEN
            DO 30 I = 1, N
               U(I) = R(I)
               P(I) = R(I)
 30         CONTINUE
         ELSE
            DO 40 I = 1, N
               U(I) = R(I) + BK*Q(I)
               V1(I) = Q(I) + BK*P(I)
 40         CONTINUE
            DO 50 I = 1, N
               P(I) = U(I) + BK*V1(I)
 50         CONTINUE
         ENDIF
C
C         Calculate coefficient AK, new iterate X, Q
         CALL MATVEC(N, P, V2, NELT, IA, JA, A, ISYM)
         CALL MSOLVE(N, V2, V1, NELT, IA, JA, A, ISYM, RWORK, IWORK)
         SIGMA = SDOT(N, R0, 1, V1, 1)
         IF( ABS(SIGMA).LT.FUZZ ) GOTO 999
         AK = RHON/SIGMA
         AKM = -AK
         DO 60 I = 1, N
            Q(I) = U(I) + AKM*V1(I)
 60      CONTINUE
         DO 70 I = 1, N
            V1(I) = U(I) + Q(I)
 70      CONTINUE
C         X = X - ak*V1.
         CALL SAXPY( N, AKM, V1, 1, X, 1 )
C                     -1
C         R = R - ak*M  *A*V1
         CALL MATVEC(N, V1, V2, NELT, IA, JA, A, ISYM)
         CALL MSOLVE(N, V2, V1, NELT, IA, JA, A, ISYM, RWORK, IWORK)
         CALL SAXPY( N, AKM, V1, 1, R, 1 )
C
C         check stopping criterion.
         IF( ISSCGS(N, B, X, NELT, IA, JA, A, ISYM, MATVEC, MSOLVE,
     $        ITOL, TOL, ITMAX, ITER, ERR, IERR, IUNIT, R, R0, P, Q,
     $        U, V1, V2, RWORK, IWORK, AK, BK, BNRM, SOLNRM) .NE. 0 )
     $        GO TO 200
C
C         Update RHO.
         RHONM1 = RHON
 100  CONTINUE
C
C         *****   end of loop  *****
C         Stopping criterion not satisfied.
      ITER = ITMAX + 1
      IERR = 2
 200  RETURN
C
C         Breakdown of method detected.
 998  IERR = 5
      RETURN
C
C         Stagnation of method detected.
 999  IERR = 6
      RETURN
C------------- LAST LINE OF SCGS FOLLOWS ----------------------------
      END
*DECK SCHDC
      SUBROUTINE SCHDC (A, LDA, P, WORK, JPVT, JOB, INFO)
C***BEGIN PROLOGUE  SCHDC
C***PURPOSE  Compute the Cholesky decomposition of a positive definite
C            matrix.  A pivoting option allows the user to estimate the
C            condition number of a positive definite matrix or determine
C            the rank of a positive semidefinite matrix.
C***LIBRARY   SLATEC (LINPACK)
C***CATEGORY  D2B1B
C***TYPE      SINGLE PRECISION (SCHDC-S, DCHDC-D, CCHDC-C)
C***KEYWORDS  CHOLESKY DECOMPOSITION, LINEAR ALGEBRA, LINPACK, MATRIX,
C             POSITIVE DEFINITE
C***AUTHOR  Dongarra, J., (ANL)
C           Stewart, G. W., (U. of Maryland)
C***DESCRIPTION
C
C     SCHDC computes the Cholesky decomposition of a positive definite
C     matrix.  A pivoting option allows the user to estimate the
C     condition of a positive definite matrix or determine the rank
C     of a positive semidefinite matrix.
C
C     On Entry
C
C         A      REAL(LDA,P).
C                A contains the matrix whose decomposition is to
C                be computed.  Only the upper half of A need be stored.
C                The lower part of the array A is not referenced.
C
C         LDA    INTEGER.
C                LDA is the leading dimension of the array A.
C
C         P      INTEGER.
C                P is the order of the matrix.
C
C         WORK   REAL.
C                WORK is a work array.
C
C         JPVT   INTEGER(P).
C                JPVT contains integers that control the selection
C                of the pivot elements, if pivoting has been requested.
C                Each diagonal element A(K,K)
C                is placed in one of three classes according to the
C                value of JPVT(K).
C
C                   If JPVT(K) .GT. 0, then X(K) is an initial
C                                      element.
C
C                   If JPVT(K) .EQ. 0, then X(K) is a free element.
C
C                   If JPVT(K) .LT. 0, then X(K) is a final element.
C
C                Before the decomposition is computed, initial elements
C                are moved by symmetric row and column interchanges to
C                the beginning of the array A and final
C                elements to the end.  Both initial and final elements
C                are frozen in place during the computation and only
C                free elements are moved.  At the K-th stage of the
C                reduction, if A(K,K) is occupied by a free element
C                it is interchanged with the largest free element
C                A(L,L) with L .GE. K.  JPVT is not referenced if
C                JOB .EQ. 0.
C
C        JOB     INTEGER.
C                JOB is an integer that initiates column pivoting.
C                If JOB .EQ. 0, no pivoting is done.
C                If JOB .NE. 0, pivoting is done.
C
C     On Return
C
C         A      A contains in its upper half the Cholesky factor
C                of the matrix A as it has been permuted by pivoting.
C
C         JPVT   JPVT(J) contains the index of the diagonal element
C                of a that was moved into the J-th position,
C                provided pivoting was requested.
C
C         INFO   contains the index of the last positive diagonal
C                element of the Cholesky factor.
C
C     For positive definite matrices INFO = P is the normal return.
C     For pivoting with positive semidefinite matrices INFO will
C     in general be less than P.  However, INFO may be greater than
C     the rank of A, since rounding error can cause an otherwise zero
C     element to be positive.  Indefinite systems will always cause
C     INFO to be less than P.
C
C***REFERENCES  J. J. Dongarra, J. R. Bunch, C. B. Moler, and G. W.
C                 Stewart, LINPACK Users' Guide, SIAM, 1979.
C***ROUTINES CALLED  SAXPY, SSWAP
C***REVISION HISTORY  (YYMMDD)
C   790319  DATE WRITTEN
C   890313  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900326  Removed duplicate information from DESCRIPTION section.
C           (WRB)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  SCHDC
      INTEGER LDA,P,JPVT(*),JOB,INFO
      REAL A(LDA,*),WORK(*)
C
      INTEGER PU,PL,PLP1,J,JP,JT,K,KB,KM1,KP1,L,MAXL
      REAL TEMP
      REAL MAXDIA
      LOGICAL SWAPK,NEGK
C***FIRST EXECUTABLE STATEMENT  SCHDC
      PL = 1
      PU = 0
      INFO = P
      IF (JOB .EQ. 0) GO TO 160
C
C        PIVOTING HAS BEEN REQUESTED. REARRANGE THE
C        THE ELEMENTS ACCORDING TO JPVT.
C
         DO 70 K = 1, P
            SWAPK = JPVT(K) .GT. 0
            NEGK = JPVT(K) .LT. 0
            JPVT(K) = K
            IF (NEGK) JPVT(K) = -JPVT(K)
            IF (.NOT.SWAPK) GO TO 60
               IF (K .EQ. PL) GO TO 50
                  CALL SSWAP(PL-1,A(1,K),1,A(1,PL),1)
                  TEMP = A(K,K)
                  A(K,K) = A(PL,PL)
                  A(PL,PL) = TEMP
                  PLP1 = PL + 1
                  IF (P .LT. PLP1) GO TO 40
                  DO 30 J = PLP1, P
                     IF (J .GE. K) GO TO 10
                        TEMP = A(PL,J)
                        A(PL,J) = A(J,K)
                        A(J,K) = TEMP
                     GO TO 20
   10                CONTINUE
                     IF (J .EQ. K) GO TO 20
                        TEMP = A(K,J)
                        A(K,J) = A(PL,J)
                        A(PL,J) = TEMP
   20                CONTINUE
   30             CONTINUE
   40             CONTINUE
                  JPVT(K) = JPVT(PL)
                  JPVT(PL) = K
   50          CONTINUE
               PL = PL + 1
   60       CONTINUE
   70    CONTINUE
         PU = P
         IF (P .LT. PL) GO TO 150
         DO 140 KB = PL, P
            K = P - KB + PL
            IF (JPVT(K) .GE. 0) GO TO 130
               JPVT(K) = -JPVT(K)
               IF (PU .EQ. K) GO TO 120
                  CALL SSWAP(K-1,A(1,K),1,A(1,PU),1)
                  TEMP = A(K,K)
                  A(K,K) = A(PU,PU)
                  A(PU,PU) = TEMP
                  KP1 = K + 1
                  IF (P .LT. KP1) GO TO 110
                  DO 100 J = KP1, P
                     IF (J .GE. PU) GO TO 80
                        TEMP = A(K,J)
                        A(K,J) = A(J,PU)
                        A(J,PU) = TEMP
                     GO TO 90
   80                CONTINUE
                     IF (J .EQ. PU) GO TO 90
                        TEMP = A(K,J)
                        A(K,J) = A(PU,J)
                        A(PU,J) = TEMP
   90                CONTINUE
  100             CONTINUE
  110             CONTINUE
                  JT = JPVT(K)
                  JPVT(K) = JPVT(PU)
                  JPVT(PU) = JT
  120          CONTINUE
               PU = PU - 1
  130       CONTINUE
  140    CONTINUE
  150    CONTINUE
  160 CONTINUE
      DO 270 K = 1, P
C
C        REDUCTION LOOP.
C
         MAXDIA = A(K,K)
         KP1 = K + 1
         MAXL = K
C
C        DETERMINE THE PIVOT ELEMENT.
C
         IF (K .LT. PL .OR. K .GE. PU) GO TO 190
            DO 180 L = KP1, PU
               IF (A(L,L) .LE. MAXDIA) GO TO 170
                  MAXDIA = A(L,L)
                  MAXL = L
  170          CONTINUE
  180       CONTINUE
  190    CONTINUE
C
C        QUIT IF THE PIVOT ELEMENT IS NOT POSITIVE.
C
         IF (MAXDIA .GT. 0.0E0) GO TO 200
            INFO = K - 1
            GO TO 280
  200    CONTINUE
         IF (K .EQ. MAXL) GO TO 210
C
C           START THE PIVOTING AND UPDATE JPVT.
C
            KM1 = K - 1
            CALL SSWAP(KM1,A(1,K),1,A(1,MAXL),1)
            A(MAXL,MAXL) = A(K,K)
            A(K,K) = MAXDIA
            JP = JPVT(MAXL)
            JPVT(MAXL) = JPVT(K)
            JPVT(K) = JP
  210    CONTINUE
C
C        REDUCTION STEP. PIVOTING IS CONTAINED ACROSS THE ROWS.
C
         WORK(K) = SQRT(A(K,K))
         A(K,K) = WORK(K)
         IF (P .LT. KP1) GO TO 260
         DO 250 J = KP1, P
            IF (K .EQ. MAXL) GO TO 240
               IF (J .GE. MAXL) GO TO 220
                  TEMP = A(K,J)
                  A(K,J) = A(J,MAXL)
                  A(J,MAXL) = TEMP
               GO TO 230
  220          CONTINUE
               IF (J .EQ. MAXL) GO TO 230
                  TEMP = A(K,J)
                  A(K,J) = A(MAXL,J)
                  A(MAXL,J) = TEMP
  230          CONTINUE
  240       CONTINUE
            A(K,J) = A(K,J)/WORK(K)
            WORK(J) = A(K,J)
            TEMP = -A(K,J)
            CALL SAXPY(J-K,TEMP,WORK(KP1),1,A(KP1,J),1)
  250    CONTINUE
  260    CONTINUE
  270 CONTINUE
  280 CONTINUE
      RETURN
      END
*DECK SCHDD
      SUBROUTINE SCHDD (R, LDR, P, X, Z, LDZ, NZ, Y, RHO, C, S, INFO)
C***BEGIN PROLOGUE  SCHDD
C***PURPOSE  Downdate an augmented Cholesky decomposition or the
C            triangular factor of an augmented QR decomposition.
C***LIBRARY   SLATEC (LINPACK)
C***CATEGORY  D7B
C***TYPE      SINGLE PRECISION (SCHDD-S, DCHDD-D, CCHDD-C)
C***KEYWORDS  CHOLESKY DECOMPOSITION, DOWNDATE, LINEAR ALGEBRA, LINPACK,
C             MATRIX
C***AUTHOR  Stewart, G. W., (U. of Maryland)
C***DESCRIPTION
C
C     SCHDD downdates an augmented Cholesky decomposition or the
C     triangular factor of an augmented QR decomposition.
C     Specifically, given an upper triangular matrix R of order P, a
C     row vector X, a column vector Z, and a scalar Y, SCHDD
C     determines an orthogonal matrix U and a scalar ZETA such that
C
C                        (R   Z )     (RR  ZZ)
C                    U * (      )  =  (      ) ,
C                        (0 ZETA)     ( X   Y)
C
C     where RR is upper triangular.  If R and Z have been obtained
C     from the factorization of a least squares problem, then
C     RR and ZZ are the factors corresponding to the problem
C     with the observation (X,Y) removed.  In this case, if RHO
C     is the norm of the residual vector, then the norm of
C     the residual vector of the downdated problem is
C     SQRT(RHO**2 - ZETA**2). SCHDD will simultaneously downdate
C     several triplets (Z,Y,RHO) along with R.
C     For a less terse description of what SCHDD does and how
C     it may be applied, see the LINPACK guide.
C
C     The matrix U is determined as the product U(1)*...*U(P)
C     where U(I) is a rotation in the (P+1,I)-plane of the
C     form
C
C                       ( C(I)     -S(I)     )
C                       (                    ) .
C                       ( S(I)       C(I)    )
C
C     The rotations are chosen so that C(I) is real.
C
C     The user is warned that a given downdating problem may
C     be impossible to accomplish or may produce
C     inaccurate results.  For example, this can happen
C     if X is near a vector whose removal will reduce the
C     rank of R.  Beware.
C
C     On Entry
C
C         R      REAL(LDR,P), where LDR .GE. P.
C                R contains the upper triangular matrix
C                that is to be downdated.  The part of  R
C                below the diagonal is not referenced.
C
C         LDR    INTEGER.
C                LDR is the leading dimension of the array R.
C
C         P      INTEGER.
C                P is the order of the matrix R.
C
C         X      REAL(P).
C                X contains the row vector that is to
C                be removed from R.  X is not altered by SCHDD.
C
C         Z      REAL(LDZ,NZ), where LDZ .GE. P.
C                Z is an array of NZ P-vectors which
C                are to be downdated along with R.
C
C         LDZ    INTEGER.
C                LDZ is the leading dimension of the array Z.
C
C         NZ     INTEGER.
C                NZ is the number of vectors to be downdated
C                NZ may be zero, in which case Z, Y, and RHO
C                are not referenced.
C
C         Y      REAL(NZ).
C                Y contains the scalars for the downdating
C                of the vectors Z.  Y is not altered by SCHDD.
C
C         RHO    REAL(NZ).
C                RHO contains the norms of the residual
C                vectors that are to be downdated.
C
C     On Return
C
C         R
C         Z      contain the downdated quantities.
C         RHO
C
C         C      REAL(P).
C                C contains the cosines of the transforming
C                rotations.
C
C         S      REAL(P).
C                S contains the sines of the transforming
C                rotations.
C
C         INFO   INTEGER.
C                INFO is set as follows.
C
C                   INFO = 0  if the entire downdating
C                             was successful.
C
C                   INFO =-1  if R could not be downdated.
C                             In this case, all quantities
C                             are left unaltered.
C
C                   INFO = 1  if some RHO could not be
C                             downdated.  The offending RHOs are
C                             set to -1.
C
C***REFERENCES  J. J. Dongarra, J. R. Bunch, C. B. Moler, and G. W.
C                 Stewart, LINPACK Users' Guide, SIAM, 1979.
C***ROUTINES CALLED  SDOT, SNRM2
C***REVISION HISTORY  (YYMMDD)
C   780814  DATE WRITTEN
C   890831  Modified array declarations.  (WRB)
C   890831  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900326  Removed duplicate information from DESCRIPTION section.
C           (WRB)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  SCHDD
      INTEGER LDR,P,LDZ,NZ,INFO
      REAL R(LDR,*),X(*),Z(LDZ,*),Y(*),S(*)
      REAL RHO(*),C(*)
C
      INTEGER I,II,J
      REAL A,ALPHA,AZETA,NORM,SNRM2
      REAL SDOT,T,ZETA,B,XX
C
C     SOLVE THE SYSTEM TRANS(R)*A = X, PLACING THE RESULT
C     IN THE ARRAY S.
C
C***FIRST EXECUTABLE STATEMENT  SCHDD
      INFO = 0
      S(1) = X(1)/R(1,1)
      IF (P .LT. 2) GO TO 20
      DO 10 J = 2, P
         S(J) = X(J) - SDOT(J-1,R(1,J),1,S,1)
         S(J) = S(J)/R(J,J)
   10 CONTINUE
   20 CONTINUE
      NORM = SNRM2(P,S,1)
      IF (NORM .LT. 1.0E0) GO TO 30
         INFO = -1
      GO TO 120
   30 CONTINUE
         ALPHA = SQRT(1.0E0-NORM**2)
C
C        DETERMINE THE TRANSFORMATIONS.
C
         DO 40 II = 1, P
            I = P - II + 1
            SCALE = ALPHA + ABS(S(I))
            A = ALPHA/SCALE
            B = S(I)/SCALE
            NORM = SQRT(A**2+B**2)
            C(I) = A/NORM
            S(I) = B/NORM
            ALPHA = SCALE*NORM
   40    CONTINUE
C
C        APPLY THE TRANSFORMATIONS TO R.
C
         DO 60 J = 1, P
            XX = 0.0E0
            DO 50 II = 1, J
               I = J - II + 1
               T = C(I)*XX + S(I)*R(I,J)
               R(I,J) = C(I)*R(I,J) - S(I)*XX
               XX = T
   50       CONTINUE
   60    CONTINUE
C
C        IF REQUIRED, DOWNDATE Z AND RHO.
C
         IF (NZ .LT. 1) GO TO 110
         DO 100 J = 1, NZ
            ZETA = Y(J)
            DO 70 I = 1, P
               Z(I,J) = (Z(I,J) - S(I)*ZETA)/C(I)
               ZETA = C(I)*ZETA - S(I)*Z(I,J)
   70       CONTINUE
            AZETA = ABS(ZETA)
            IF (AZETA .LE. RHO(J)) GO TO 80
               INFO = 1
               RHO(J) = -1.0E0
            GO TO 90
   80       CONTINUE
               RHO(J) = RHO(J)*SQRT(1.0E0-(AZETA/RHO(J))**2)
   90       CONTINUE
  100    CONTINUE
  110    CONTINUE
  120 CONTINUE
      RETURN
      END
*DECK SCHEX
      SUBROUTINE SCHEX (R, LDR, P, K, L, Z, LDZ, NZ, C, S, JOB)
C***BEGIN PROLOGUE  SCHEX
C***PURPOSE  Update the Cholesky factorization  A=TRANS(R)*R  of A
C            positive definite matrix A of order P under diagonal
C            permutations of the form TRANS(E)*A*E, where E is a
C            permutation matrix.
C***LIBRARY   SLATEC (LINPACK)
C***CATEGORY  D7B
C***TYPE      SINGLE PRECISION (SCHEX-S, DCHEX-D, CCHEX-C)
C***KEYWORDS  CHOLESKY DECOMPOSITION, EXCHANGE, LINEAR ALGEBRA, LINPACK,
C             MATRIX, POSITIVE DEFINITE
C***AUTHOR  Stewart, G. W., (U. of Maryland)
C***DESCRIPTION
C
C     SCHEX updates the Cholesky factorization
C
C                   A = TRANS(R)*R
C
C     of a positive definite matrix A of order P under diagonal
C     permutations of the form
C
C                   TRANS(E)*A*E
C
C     where E is a permutation matrix.  Specifically, given
C     an upper triangular matrix R and a permutation matrix
C     E (which is specified by K, L, and JOB), SCHEX determines
C     an orthogonal matrix U such that
C
C                           U*R*E = RR,
C
C     where RR is upper triangular.  At the users option, the
C     transformation U will be multiplied into the array Z.
C     If A = TRANS(X)*X, so that R is the triangular part of the
C     QR factorization of X, then RR is the triangular part of the
C     QR factorization of X*E, i.e., X with its columns permuted.
C     For a less terse description of what SCHEX does and how
C     it may be applied, see the LINPACK guide.
C
C     The matrix Q is determined as the product U(L-K)*...*U(1)
C     of plane rotations of the form
C
C                           (    C(I)       S(I) )
C                           (                    ) ,
C                           (    -S(I)      C(I) )
C
C     where C(I) is real.  The rows these rotations operate on
C     are described below.
C
C     There are two types of permutations, which are determined
C     by the value of JOB.
C
C     1. Right circular shift (JOB = 1).
C
C         The columns are rearranged in the following order.
C
C                1,...,K-1,L,K,K+1,...,L-1,L+1,...,P.
C
C         U is the product of L-K rotations U(I), where U(I)
C         acts in the (L-I,L-I+1)-plane.
C
C     2. Left circular shift (JOB = 2).
C         The columns are rearranged in the following order
C
C                1,...,K-1,K+1,K+2,...,L,K,L+1,...,P.
C
C         U is the product of L-K rotations U(I), where U(I)
C         acts in the (K+I-1,K+I)-plane.
C
C     On Entry
C
C         R      REAL(LDR,P), where LDR .GE. P.
C                R contains the upper triangular factor
C                that is to be updated.  Elements of R
C                below the diagonal are not referenced.
C
C         LDR    INTEGER.
C                LDR is the leading dimension of the array R.
C
C         P      INTEGER.
C                P is the order of the matrix R.
C
C         K      INTEGER.
C                K is the first column to be permuted.
C
C         L      INTEGER.
C                L is the last column to be permuted.
C                L must be strictly greater than K.
C
C         Z      REAL(LDZ,NZ), where LDZ.GE.P.
C                Z is an array of NZ P-vectors into which the
C                transformation U is multiplied.  Z is
C                not referenced if NZ = 0.
C
C         LDZ    INTEGER.
C                LDZ is the leading dimension of the array Z.
C
C         NZ     INTEGER.
C                NZ is the number of columns of the matrix Z.
C
C         JOB    INTEGER.
C                JOB determines the type of permutation.
C                       JOB = 1  right circular shift.
C                       JOB = 2  left circular shift.
C
C     On Return
C
C         R      contains the updated factor.
C
C         Z      contains the updated matrix Z.
C
C         C      REAL(P).
C                C contains the cosines of the transforming rotations.
C
C         S      REAL(P).
C                S contains the sines of the transforming rotations.
C
C***REFERENCES  J. J. Dongarra, J. R. Bunch, C. B. Moler, and G. W.
C                 Stewart, LINPACK Users' Guide, SIAM, 1979.
C***ROUTINES CALLED  SROTG
C***REVISION HISTORY  (YYMMDD)
C   780814  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890531  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900326  Removed duplicate information from DESCRIPTION section.
C           (WRB)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  SCHEX
      INTEGER LDR,P,K,L,LDZ,NZ,JOB
      REAL R(LDR,*),Z(LDZ,*),S(*)
      REAL C(*)
C
      INTEGER I,II,IL,IU,J,JJ,KM1,KP1,LMK,LM1
      REAL T
C
C     INITIALIZE
C
C***FIRST EXECUTABLE STATEMENT  SCHEX
      KM1 = K - 1
      KP1 = K + 1
      LMK = L - K
      LM1 = L - 1
C
C     PERFORM THE APPROPRIATE TASK.
C
      GO TO (10,130), JOB
C
C     RIGHT CIRCULAR SHIFT.
C
   10 CONTINUE
C
C        REORDER THE COLUMNS.
C
         DO 20 I = 1, L
            II = L - I + 1
            S(I) = R(II,L)
   20    CONTINUE
         DO 40 JJ = K, LM1
            J = LM1 - JJ + K
            DO 30 I = 1, J
               R(I,J+1) = R(I,J)
   30       CONTINUE
            R(J+1,J+1) = 0.0E0
   40    CONTINUE
         IF (K .EQ. 1) GO TO 60
            DO 50 I = 1, KM1
               II = L - I + 1
               R(I,K) = S(II)
   50       CONTINUE
   60    CONTINUE
C
C        CALCULATE THE ROTATIONS.
C
         T = S(1)
         DO 70 I = 1, LMK
            CALL SROTG(S(I+1),T,C(I),S(I))
            T = S(I+1)
   70    CONTINUE
         R(K,K) = T
         DO 90 J = KP1, P
            IL = MAX(1,L-J+1)
            DO 80 II = IL, LMK
               I = L - II
               T = C(II)*R(I,J) + S(II)*R(I+1,J)
               R(I+1,J) = C(II)*R(I+1,J) - S(II)*R(I,J)
               R(I,J) = T
   80       CONTINUE
   90    CONTINUE
C
C        IF REQUIRED, APPLY THE TRANSFORMATIONS TO Z.
C
         IF (NZ .LT. 1) GO TO 120
         DO 110 J = 1, NZ
            DO 100 II = 1, LMK
               I = L - II
               T = C(II)*Z(I,J) + S(II)*Z(I+1,J)
               Z(I+1,J) = C(II)*Z(I+1,J) - S(II)*Z(I,J)
               Z(I,J) = T
  100       CONTINUE
  110    CONTINUE
  120    CONTINUE
      GO TO 260
C
C     LEFT CIRCULAR SHIFT
C
  130 CONTINUE
C
C        REORDER THE COLUMNS
C
         DO 140 I = 1, K
            II = LMK + I
            S(II) = R(I,K)
  140    CONTINUE
         DO 160 J = K, LM1
            DO 150 I = 1, J
               R(I,J) = R(I,J+1)
  150       CONTINUE
            JJ = J - KM1
            S(JJ) = R(J+1,J+1)
  160    CONTINUE
         DO 170 I = 1, K
            II = LMK + I
            R(I,L) = S(II)
  170    CONTINUE
         DO 180 I = KP1, L
            R(I,L) = 0.0E0
  180    CONTINUE
C
C        REDUCTION LOOP.
C
         DO 220 J = K, P
            IF (J .EQ. K) GO TO 200
C
C              APPLY THE ROTATIONS.
C
               IU = MIN(J-1,L-1)
               DO 190 I = K, IU
                  II = I - K + 1
                  T = C(II)*R(I,J) + S(II)*R(I+1,J)
                  R(I+1,J) = C(II)*R(I+1,J) - S(II)*R(I,J)
                  R(I,J) = T
  190          CONTINUE
  200       CONTINUE
            IF (J .GE. L) GO TO 210
               JJ = J - K + 1
               T = S(JJ)
               CALL SROTG(R(J,J),T,C(JJ),S(JJ))
  210       CONTINUE
  220    CONTINUE
C
C        APPLY THE ROTATIONS TO Z.
C
         IF (NZ .LT. 1) GO TO 250
         DO 240 J = 1, NZ
            DO 230 I = K, LM1
               II = I - KM1
               T = C(II)*Z(I,J) + S(II)*Z(I+1,J)
               Z(I+1,J) = C(II)*Z(I+1,J) - S(II)*Z(I,J)
               Z(I,J) = T
  230       CONTINUE
  240    CONTINUE
  250    CONTINUE
  260 CONTINUE
      RETURN
      END
*DECK SCHKW
      SUBROUTINE SCHKW (NAME, LOCIW, LENIW, LOCW, LENW, IERR, ITER, ERR)
C***BEGIN PROLOGUE  SCHKW
C***SUBSIDIARY
C***PURPOSE  SLAP WORK/IWORK Array Bounds Checker.
C            This routine checks the work array lengths and interfaces
C            to the SLATEC error handler if a problem is found.
C***LIBRARY   SLATEC (SLAP)
C***CATEGORY  R2
C***TYPE      SINGLE PRECISION (SCHKW-S, DCHKW-D)
C***KEYWORDS  ERROR CHECKING, SLAP, WORKSPACE CHECKING
C***AUTHOR  Seager, Mark K., (LLNL)
C             Lawrence Livermore National Laboratory
C             PO BOX 808, L-60
C             Livermore, CA 94550 (510) 423-3141
C             seager@llnl.gov
C***DESCRIPTION
C
C *Usage:
C     CHARACTER*(*) NAME
C     INTEGER LOCIW, LENIW, LOCW, LENW, IERR, ITER
C     REAL    ERR
C
C     CALL SCHKW( NAME, LOCIW, LENIW, LOCW, LENW, IERR, ITER, ERR )
C
C *Arguments:
C NAME   :IN       Character*(*).
C         Name of the calling routine.  This is used in the output
C         message, if an error is detected.
C LOCIW  :IN       Integer.
C         Location of the first free element in the integer workspace
C         array.
C LENIW  :IN       Integer.
C         Length of the integer workspace array.
C LOCW   :IN       Integer.
C         Location of the first free element in the real workspace
C         array.
C LENRW  :IN       Integer.
C         Length of the real workspace array.
C IERR   :OUT      Integer.
C         Return error flag.
C               IERR = 0 => All went well.
C               IERR = 1 => Insufficient storage allocated for
C                           WORK or IWORK.
C ITER   :OUT      Integer.
C         Set to zero on return.
C ERR    :OUT      Real.
C         Set to the smallest positive magnitude if all went well.
C         Set to a very large number if an error is detected.
C
C***REFERENCES  (NONE)
C***ROUTINES CALLED  R1MACH, XERMSG
C***REVISION HISTORY  (YYMMDD)
C   880225  DATE WRITTEN
C   881213  Previous REVISION DATE
C   890915  Made changes requested at July 1989 CML Meeting.  (MKS)
C   890922  Numerous changes to prologue to make closer to SLATEC
C           standard.  (FNF)
C   890929  Numerous changes to reduce SP/DP differences.  (FNF)
C   900805  Changed XERRWV calls to calls to XERMSG.  (RWC)
C   910411  Prologue converted to Version 4.0 format.  (BAB)
C   910502  Corrected XERMSG calls to satisfy Section 6.2.2 of ANSI
C           X3.9-1978.  (FNF)
C   910506  Made subsidiary.  (FNF)
C   920511  Added complete declaration section.  (WRB)
C   921015  Added code to initialize ITER and ERR when IERR=0.  (FNF)
C***END PROLOGUE  SCHKW
C     .. Scalar Arguments ..
      REAL ERR
      INTEGER IERR, ITER, LENIW, LENW, LOCIW, LOCW
      CHARACTER NAME*(*)
C     .. Local Scalars ..
      CHARACTER XERN1*8, XERN2*8, XERNAM*8
C     .. External Functions ..
      REAL R1MACH
      EXTERNAL R1MACH
C     .. External Subroutines ..
      EXTERNAL XERMSG
C***FIRST EXECUTABLE STATEMENT  SCHKW
C
C         Check the Integer workspace situation.
C
      IERR = 0
      ITER = 0
      ERR = R1MACH(1)
      IF( LOCIW.GT.LENIW ) THEN
         IERR = 1
         ERR = R1MACH(2)
         XERNAM = NAME
         WRITE (XERN1, '(I8)') LOCIW
         WRITE (XERN2, '(I8)') LENIW
         CALL XERMSG ('SLATEC', 'SCHKW',
     $      'In ' // XERNAM // ', INTEGER work array too short.  ' //
     $      'IWORK needs ' // XERN1 // '; have allocated ' // XERN2,
     $      1, 1)
      ENDIF
C
C         Check the Real workspace situation.
      IF( LOCW.GT.LENW ) THEN
         IERR = 1
         ERR = R1MACH(2)
         XERNAM = NAME
         WRITE (XERN1, '(I8)') LOCW
         WRITE (XERN2, '(I8)') LENW
         CALL XERMSG ('SLATEC', 'SCHKW',
     $      'In ' // XERNAM // ', REAL work array too short.  ' //
     $      'RWORK needs ' // XERN1 // '; have allocated ' // XERN2,
     $      1, 1)
      ENDIF
      RETURN
C------------- LAST LINE OF SCHKW FOLLOWS ----------------------------
      END
*DECK SCHUD
      SUBROUTINE SCHUD (R, LDR, P, X, Z, LDZ, NZ, Y, RHO, C, S)
C***BEGIN PROLOGUE  SCHUD
C***PURPOSE  Update an augmented Cholesky decomposition of the
C            triangular part of an augmented QR decomposition.
C***LIBRARY   SLATEC (LINPACK)
C***CATEGORY  D7B
C***TYPE      SINGLE PRECISION (SCHUD-S, DCHUD-D, CCHUD-C)
C***KEYWORDS  CHOLESKY DECOMPOSITION, LINEAR ALGEBRA, LINPACK, MATRIX,
C             UPDATE
C***AUTHOR  Stewart, G. W., (U. of Maryland)
C***DESCRIPTION
C
C     SCHUD updates an augmented Cholesky decomposition of the
C     triangular part of an augmented QR decomposition.  Specifically,
C     given an upper triangular matrix R of order P, a row vector
C     X, a column vector Z, and a scalar Y, SCHUD determines a
C     unitary matrix U and a scalar ZETA such that
C
C
C                              (R  Z)     (RR   ZZ )
C                         U  * (    )  =  (        ) ,
C                              (X  Y)     ( 0  ZETA)
C
C     where RR is upper triangular.  If R and Z have been
C     obtained from the factorization of a least squares
C     problem, then RR and ZZ are the factors corresponding to
C     the problem with the observation (X,Y) appended.  In this
C     case, if RHO is the norm of the residual vector, then the
C     norm of the residual vector of the updated problem is
C     SQRT(RHO**2 + ZETA**2).  SCHUD will simultaneously update
C     several triplets (Z,Y,RHO).
C     For a less terse description of what SCHUD does and how
C     it may be applied, see the LINPACK guide.
C
C     The matrix U is determined as the product U(P)*...*U(1),
C     where U(I) is a rotation in the (I,P+1) plane of the
C     form
C
C                       (     C(I)      S(I) )
C                       (                    ) .
C                       (    -S(I)      C(I) )
C
C     The rotations are chosen so that C(I) is real.
C
C     On Entry
C
C         R      REAL(LDR,P), where LDR .GE. P.
C                R contains the upper triangular matrix
C                that is to be updated.  The part of R
C                below the diagonal is not referenced.
C
C         LDR    INTEGER.
C                LDR is the leading dimension of the array R.
C
C         P      INTEGER.
C                P is the order of the matrix R.
C
C         X      REAL(P).
C                X contains the row to be added to R.  X is
C                not altered by SCHUD.
C
C         Z      REAL(LDZ,NZ), where LDZ .GE. P.
C                Z is an array containing NZ P-vectors to
C                be updated with R.
C
C         LDZ    INTEGER.
C                LDZ is the leading dimension of the array Z.
C
C         NZ     INTEGER.
C                NZ is the number of vectors to be updated.
C                NZ may be zero, in which case Z, Y, and RHO
C                are not referenced.
C
C         Y      REAL(NZ).
C                Y contains the scalars for updating the vectors
C                Z.  Y is not altered by SCHUD.
C
C         RHO    REAL(NZ).
C                RHO contains the norms of the residual
C                vectors that are to be updated.  If RHO(J)
C                is negative, it is left unaltered.
C
C     On Return
C
C         RC
C         RHO    contain the updated quantities.
C         Z
C
C         C      REAL(P).
C                C contains the cosines of the transforming
C                rotations.
C
C         S      REAL(P).
C                S contains the sines of the transforming
C                rotations.
C
C***REFERENCES  J. J. Dongarra, J. R. Bunch, C. B. Moler, and G. W.
C                 Stewart, LINPACK Users' Guide, SIAM, 1979.
C***ROUTINES CALLED  SROTG
C***REVISION HISTORY  (YYMMDD)
C   780814  DATE WRITTEN
C   890831  Modified array declarations.  (WRB)
C   890831  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900326  Removed duplicate information from DESCRIPTION section.
C           (WRB)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  SCHUD
      INTEGER LDR,P,LDZ,NZ
      REAL RHO(*),C(*)
      REAL R(LDR,*),X(*),Z(LDZ,*),Y(*),S(*)
C
      INTEGER I,J,JM1
      REAL AZETA,SCALE
      REAL T,XJ,ZETA
C
C     UPDATE R.
C
C***FIRST EXECUTABLE STATEMENT  SCHUD
      DO 30 J = 1, P
         XJ = X(J)
C
C        APPLY THE PREVIOUS ROTATIONS.
C
         JM1 = J - 1
         IF (JM1 .LT. 1) GO TO 20
         DO 10 I = 1, JM1
            T = C(I)*R(I,J) + S(I)*XJ
            XJ = C(I)*XJ - S(I)*R(I,J)
            R(I,J) = T
   10    CONTINUE
   20    CONTINUE
C
C        COMPUTE THE NEXT ROTATION.
C
         CALL SROTG(R(J,J),XJ,C(J),S(J))
   30 CONTINUE
C
C     IF REQUIRED, UPDATE Z AND RHO.
C
      IF (NZ .LT. 1) GO TO 70
      DO 60 J = 1, NZ
         ZETA = Y(J)
         DO 40 I = 1, P
            T = C(I)*Z(I,J) + S(I)*ZETA
            ZETA = C(I)*ZETA - S(I)*Z(I,J)
            Z(I,J) = T
   40    CONTINUE
         AZETA = ABS(ZETA)
         IF (AZETA .EQ. 0.0E0 .OR. RHO(J) .LT. 0.0E0) GO TO 50
            SCALE = AZETA + RHO(J)
            RHO(J) = SCALE*SQRT((AZETA/SCALE)**2+(RHO(J)/SCALE)**2)
   50    CONTINUE
   60 CONTINUE
   70 CONTINUE
      RETURN
      END
*DECK SCLOSM
      SUBROUTINE SCLOSM (IPAGE)
C***BEGIN PROLOGUE  SCLOSM
C***SUBSIDIARY
C***PURPOSE  Subsidiary to SPLP
C***LIBRARY   SLATEC
C***TYPE      ALL (SCLOSM-A)
C***AUTHOR  (UNKNOWN)
C***DESCRIPTION
C
C     1. UNLOAD, RELEASE, OR CLOSE UNIT NUMBER IPAGEF.
C
C***SEE ALSO  SPLP
C***ROUTINES CALLED  XERMSG
C***REVISION HISTORY  (YYMMDD)
C   811215  DATE WRITTEN
C   890605  Corrected references to XERRWV.  (WRB)
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900402  Added TYPE section.  (WRB)
C   900510  Convert XERRWV calls to XERMSG calls.  (RWC)
C***END PROLOGUE  SCLOSM
      CHARACTER*8 XERN1
C
C***FIRST EXECUTABLE STATEMENT  SCLOSM
      IPAGEF=IPAGE
      CLOSE(UNIT=IPAGEF,IOSTAT=IOS,ERR=100,STATUS='KEEP')
      RETURN
C
  100 WRITE (XERN1, '(I8)') IOS
      CALL XERMSG ('SLATEC', 'SCLOSM',
     *   'IN SPLP, CLOSE HAS ERROR FLAG = ' // XERN1, 100, 1)
      RETURN
      END
*DECK SCOEF
      SUBROUTINE SCOEF (YH, YP, NCOMP, NROWB, NFC, NIC, B, BETA, COEF,
     +   INHOMO, RE, AE, BY, CVEC, WORK, IWORK, IFLAG, NFCC)
C***BEGIN PROLOGUE  SCOEF
C***SUBSIDIARY
C***PURPOSE  Subsidiary to BVSUP
C***LIBRARY   SLATEC
C***TYPE      SINGLE PRECISION (SCOEF-S, DCOEF-D)
C***AUTHOR  Watts, H. A., (SNLA)
C***DESCRIPTION
C
C **********************************************************************
C INPUT TO SCOEF
C **********************************************************************
C
C     YH = Matrix of homogeneous solutions.
C     YP = Vector containing particular solution.
C     NCOMP = Number of components per solution vector.
C     NROWB = First dimension of B in calling program.
C     NFC = Number of base solution vectors.
C     NFCC = 2*NFC for the special treatment of complex valued
C            equations. Otherwise, NFCC=NFC.
C     NIC = Number of specified initial conditions.
C     B = Boundary condition matrix at X = Xfinal.
C     BETA = Vector of nonhomogeneous boundary conditions at X = Xfinal.
C              1 - Nonzero particular solution
C     INHOMO = 2 - Zero particular solution
C              3 - Eigenvalue problem
C     RE = Relative error tolerance
C     AE = Absolute error tolerance
C     BY = Storage space for the matrix  B*YH
C     CVEC = Storage space for the vector  BETA-B*YP
C     WORK = Real array of internal storage. Dimension must be .GE.
C            NFCC*(NFCC+4)
C     IWORK = Integer array of internal storage. Dimension must be .GE.
C             3+NFCC
C
C **********************************************************************
C OUTPUT FROM SCOEF
C **********************************************************************
C
C     COEF = Array containing superposition constants.
C     IFLAG = Indicator of success from SUDS in solving the
C             boundary equations
C           = 0 Boundary equations are solved
C           = 1 Boundary equations appear to have many solutions
C           = 2 Boundary equations appear to be inconsistent
C           = 3 For this value of an eigenparameter, the boundary
C               equations have only the zero solution.
C
C **********************************************************************
C
C     Subroutine SCOEF solves for the superposition constants from the
C     linear equations defined by the boundary conditions at X = Xfinal.
C
C                          B*YP + B*YH*COEF = BETA
C
C **********************************************************************
C
C***SEE ALSO  BVSUP
C***ROUTINES CALLED  SDOT, SUDS, XGETF, XSETF
C***COMMON BLOCKS    ML5MCO
C***REVISION HISTORY  (YYMMDD)
C   750601  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890831  Modified array declarations.  (WRB)
C   890921  Realigned order of variables in certain COMMON blocks.
C           (WRB)
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900328  Added TYPE section.  (WRB)
C   910722  Updated AUTHOR section.  (ALS)
C***END PROLOGUE  SCOEF
C
      DIMENSION YH(NCOMP,*),YP(*),B(NROWB,*),BETA(*),
     1          COEF(*),BY(NFCC,*),CVEC(*),WORK(*),IWORK(*)
C
      COMMON /ML5MCO/ URO,SRU,EPS,SQOVFL,TWOU,FOURU,LPAR
C
C     SET UP MATRIX  B*YH  AND VECTOR  BETA - B*YP
C
C***FIRST EXECUTABLE STATEMENT  SCOEF
      NCOMP2=NCOMP/2
      DO 7 K = 1,NFCC
      DO 1 J = 1,NFC
      L=J
      IF (NFC .NE. NFCC) L=2*J-1
    1 BY(K,L) = SDOT(NCOMP,B(K,1),NROWB,YH(1,J),1)
      IF (NFC .EQ. NFCC) GO TO 3
      DO 2 J=1,NFC
      L=2*J
      BYKL=SDOT(NCOMP2,B(K,1),NROWB,YH(NCOMP2+1,J),1)
      BY(K,L)=SDOT(NCOMP2,B(K,NCOMP2+1),NROWB,YH(1,J),1) - BYKL
    2 CONTINUE
    3 GO TO (4,5,6), INHOMO
C     CASE 1
    4 CVEC(K) = BETA(K) - SDOT(NCOMP,B(K,1),NROWB,YP,1)
      GO TO 7
C     CASE 2
    5 CVEC(K) = BETA(K)
      GO TO 7
C     CASE 3
    6 CVEC(K) = 0.
    7 CONTINUE
      CONS=ABS(CVEC(1))
      BYS=ABS(BY(1,1))
C
C **********************************************************************
C     SOLVE LINEAR SYSTEM
C
      IFLAG=0
      MLSO=0
      IF (INHOMO .EQ. 3) MLSO=1
      KFLAG = 0.5 * LOG10(EPS)
      CALL XGETF(NF)
      CALL XSETF(0)
   10 CALL SUDS(BY,COEF,CVEC,NFCC,NFCC,NFCC,KFLAG,MLSO,WORK,IWORK)
      IF (KFLAG .NE. 3) GO TO 13
      KFLAG=1
      IFLAG=1
      GO TO 10
   13 IF (KFLAG .EQ. 4) IFLAG=2
      CALL XSETF(NF)
      IF (NFCC .EQ. 1) GO TO 25
      IF (INHOMO .NE. 3) RETURN
      IF (IWORK(1) .LT. NFCC) GO TO 17
      IFLAG=3
      DO 14 K=1,NFCC
   14 COEF(K)=0.
      COEF(NFCC)=1.
      NFCCM1=NFCC-1
      DO 15 K=1,NFCCM1
      J=NFCC-K
      L=NFCC-J+1
      GAM=SDOT(L,BY(J,J),NFCC,COEF(J),1)/(WORK(J)*BY(J,J))
      DO 15 I=J,NFCC
   15 COEF(I)=COEF(I)+GAM*BY(J,I)
      RETURN
   17 DO 20 K=1,NFCC
      KI=4*NFCC+K
   20 COEF(K)=WORK(KI)
      RETURN
C
C **********************************************************************
C     TESTING FOR EXISTENCE AND UNIQUENESS OF BOUNDARY-VALUE PROBLEM
C     SOLUTION IN A SCALAR CASE
C
   25 BN = 0.
      UN = 0.
      YPN=0.
      DO 30 K = 1,NCOMP
      UN = MAX(UN,ABS(YH(K,1)))
      YPN=MAX(YPN,ABS(YP(K)))
   30 BN = MAX(BN,ABS(B(1,K)))
      BBN = MAX(BN,ABS(BETA(1)))
      IF (BYS .GT. 10.*(RE*UN + AE)*BN)  GO TO 35
      BRN = BBN / BN * BYS
      IF (CONS .GE. 0.1*BRN  .AND.  CONS .LE. 10.*BRN) IFLAG=1
      IF (CONS .GT. 10.*BRN) IFLAG=2
      IF (CONS  .LE.  RE*ABS(BETA(1))+AE + (RE*YPN+AE)*BN) IFLAG=1
      IF (INHOMO .EQ. 3) COEF(1)=1.
      RETURN
   35 IF (INHOMO .NE. 3) RETURN
      IFLAG=3
      COEF(1)=1.
      RETURN
      END
      SUBROUTINE SCOPYM (N, SX, INCX, SY, INCY)
C***BEGIN PROLOGUE  SCOPYM
C***PURPOSE  Copy the negative of a vector to a vector.
C***LIBRARY   SLATEC (BLAS)
C***CATEGORY  D1A5
C***TYPE      SINGLE PRECISION (SCOPYM-S, DCOPYM-D)
C***KEYWORDS  BLAS, COPY, VECTOR
C***AUTHOR  Kahaner, D. K., (NBS)
C***DESCRIPTION
C
C       Description of Parameters
C           The * Flags Output Variables
C
C       N   Number of elements in vector(s)
C      SX   Real vector with N elements
C    INCX   Storage spacing between elements of SX
C      SY*  Real negative copy of SX
C    INCY   Storage spacing between elements of SY
C
C      ***  Note that SY = -SX  ***
C
C     Copy negative of real SX to real SY.  For I=0 to N-1,
C     copy  -SX(LX+I*INCX) to SY(LY+I*INCY), where LX=1 if
C     INCX .GE. 0, else LX = 1+(1-N)*INCX, and LY is defined
C     in a similar way using INCY.
C
C***REFERENCES  (NONE)
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   801001  DATE WRITTEN
C   890831  Modified array declarations.  (WRB)
C   890831  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   920310  Corrected definition of LX in DESCRIPTION.  (WRB)
C***END PROLOGUE  SCOPYM
      REAL SX(*),SY(*)
C***FIRST EXECUTABLE STATEMENT  SCOPYM
      IF (N .LE. 0) RETURN
      IF (INCX .EQ. INCY) then
         IF (INCX-1) 5,20,60
      endif
C
C     Code for unequal or nonpositive increments.
C
    5 IX=1
      IY=1
      IF (INCX .LT. 0) IX = (-N+1)*INCX + 1
      IF (INCY .LT. 0) IY = (-N+1)*INCY + 1
      DO 10 I = 1,N
        SY(IY) = -SX(IX)
        IX = IX + INCX
        IY = IY + INCY
   10 CONTINUE
      RETURN
C
C     Code for both increments equal to 1.
C
C     Clean-up loop so remaining vector length is a multiple of 7.
C
   20 M = MOD(N,7)
      IF (M .EQ. 0) GO TO 40
      DO 30 I = 1,M
        SY(I) = -SX(I)
   30 CONTINUE
      IF (N .LT. 7) RETURN
   40 MP1 = M + 1
      DO 50 I = MP1,N,7
        SY(I) = -SX(I)
        SY(I+1) = -SX(I+1)
        SY(I+2) = -SX(I+2)
        SY(I+3) = -SX(I+3)
        SY(I+4) = -SX(I+4)
        SY(I+5) = -SX(I+5)
        SY(I+6) = -SX(I+6)
   50 CONTINUE
      RETURN
C
C     Code for equal, positive, non-unit increments.
C
   60 NS = N*INCX
      DO 70 I = 1,NS,INCX
        SY(I) = -SX(I)
   70 CONTINUE
      RETURN
      END
*DECK SCOV
      SUBROUTINE SCOV (FCN, IOPT, M, N, X, FVEC, R, LDR, INFO, WA1, WA2,
     +   WA3, WA4)
C***BEGIN PROLOGUE  SCOV
C***PURPOSE  Calculate the covariance matrix for a nonlinear data
C            fitting problem.  It is intended to be used after a
C            successful return from either SNLS1 or SNLS1E.
C***LIBRARY   SLATEC
C***CATEGORY  K1B1
C***TYPE      SINGLE PRECISION (SCOV-S, DCOV-D)
C***KEYWORDS  COVARIANCE MATRIX, NONLINEAR DATA FITTING,
C             NONLINEAR LEAST SQUARES
C***AUTHOR  Hiebert, K. L., (SNLA)
C***DESCRIPTION
C
C  1. Purpose.
C
C     SCOV calculates the covariance matrix for a nonlinear data
C     fitting problem.  It is intended to be used after a
C     successful return from either SNLS1 or SNLS1E. SCOV
C     and SNLS1 (and SNLS1E) have compatible parameters.  The
C     required external subroutine, FCN, is the same
C     for all three codes, SCOV, SNLS1, and SNLS1E.
C
C  2. Subroutine and Type Statements.
C
C     SUBROUTINE SCOV(FCN,IOPT,M,N,X,FVEC,R,LDR,INFO,
C                     WA1,WA2,WA3,WA4)
C     INTEGER IOPT,M,N,LDR,INFO
C     REAL X(N),FVEC(M),R(LDR,N),WA1(N),WA2(N),WA3(N),WA4(M)
C     EXTERNAL FCN
C
C  3. Parameters.
C
C       FCN is the name of the user-supplied subroutine which calculates
C         the functions.  If the user wants to supply the Jacobian
C         (IOPT=2 or 3), then FCN must be written to calculate the
C         Jacobian, as well as the functions.  See the explanation
C         of the IOPT argument below.  FCN must be declared in an
C         EXTERNAL statement in the calling program and should be
C         written as follows.
C
C         SUBROUTINE FCN(IFLAG,M,N,X,FVEC,FJAC,LDFJAC)
C         INTEGER IFLAG,LDFJAC,M,N
C         REAL X(N),FVEC(M)
C         ----------
C         FJAC and LDFJAC may be ignored     , if IOPT=1.
C         REAL FJAC(LDFJAC,N)                , if IOPT=2.
C         REAL FJAC(N)                       , if IOPT=3.
C         ----------
C           IFLAG will never be zero when FCN is called by SCOV.
C         RETURN
C         ----------
C           If IFLAG=1, calculate the functions at X and return
C           this vector in FVEC.
C         RETURN
C         ----------
C           If IFLAG=2, calculate the full Jacobian at X and return
C           this matrix in FJAC.  Note that IFLAG will never be 2 unless
C           IOPT=2.  FVEC contains the function values at X and must
C           not be altered.  FJAC(I,J) must be set to the derivative
C           of FVEC(I) with respect to X(J).
C         RETURN
C         ----------
C           If IFLAG=3, calculate the LDFJAC-th row of the Jacobian
C           and return this vector in FJAC.  Note that IFLAG will
C           never be 3 unless IOPT=3.  FJAC(J) must be set to
C           the derivative of FVEC(LDFJAC) with respect to X(J).
C         RETURN
C         ----------
C         END
C
C
C         The value of IFLAG should not be changed by FCN unless the
C         user wants to terminate execution of SCOV.  In this case, set
C         IFLAG to a negative integer.
C
C
C    IOPT is an input variable which specifies how the Jacobian will
C         be calculated.  If IOPT=2 or 3, then the user must supply the
C         Jacobian, as well as the function values, through the
C         subroutine FCN.  If IOPT=2, the user supplies the full
C         Jacobian with one call to FCN.  If IOPT=3, the user supplies
C         one row of the Jacobian with each call.  (In this manner,
C         storage can be saved because the full Jacobian is not stored.)
C         If IOPT=1, the code will approximate the Jacobian by forward
C         differencing.
C
C       M is a positive integer input variable set to the number of
C         functions.
C
C       N is a positive integer input variable set to the number of
C         variables.  N must not exceed M.
C
C       X is an array of length N.  On input X must contain the value
C         at which the covariance matrix is to be evaluated.  This is
C         usually the value for X returned from a successful run of
C         SNLS1 (or SNLS1E).  The value of X will not be changed.
C
C    FVEC is an output array of length M which contains the functions
C         evaluated at X.
C
C       R is an output array.  For IOPT=1 and 2, R is an M by N array.
C         For IOPT=3, R is an N by N array.  On output, if INFO=1,
C         the upper N by N submatrix of R contains the covariance
C         matrix evaluated at X.
C
C     LDR is a positive integer input variable which specifies
C         the leading dimension of the array R.  For IOPT=1 and 2,
C         LDR must not be less than M.  For IOPT=3, LDR must not
C         be less than N.
C
C    INFO is an integer output variable.  If the user has terminated
C         execution, INFO is set to the (negative) value of IFLAG.  See
C         description of FCN. Otherwise, INFO is set as follows.
C
C         INFO = 0 Improper input parameters (M.LE.0 or N.LE.0).
C
C         INFO = 1 Successful return.  The covariance matrix has been
C                  calculated and stored in the upper N by N
C                  submatrix of R.
C
C         INFO = 2 The Jacobian matrix is singular for the input value
C                  of X.  The covariance matrix cannot be calculated.
C                  The upper N by N submatrix of R contains the QR
C                  factorization of the Jacobian (probably not of
C                  interest to the user).
C
C     WA1 is a work array of length N.
C     WA2 is a work array of length N.
C     WA3 is a work array of length N.
C     WA4 is a work array of length M.
C
C***REFERENCES  (NONE)
C***ROUTINES CALLED  ENORM, FDJAC3, QRFAC, RWUPDT, XERMSG
C***REVISION HISTORY  (YYMMDD)
C   810522  DATE WRITTEN
C   890505  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900315  CALLs to XERROR changed to CALLs to XERMSG.  (THJ)
C   900510  Fixed an error message.  (RWC)
C***END PROLOGUE  SCOV
C
C     REVISED 820707-1100
C     REVISED YYMMDD HHMM
C
      INTEGER I,IDUM,IFLAG,INFO,IOPT,J,K,KP1,LDR,M,N,NM1,NROW
      REAL X(*),R(LDR,*),FVEC(*),WA1(*),WA2(*),WA3(*),WA4(*)
      EXTERNAL FCN
      REAL ONE,SIGMA,TEMP,ZERO
      LOGICAL SING
      SAVE ZERO, ONE
      DATA ZERO/0.E0/,ONE/1.E0/
C***FIRST EXECUTABLE STATEMENT  SCOV
      SING=.FALSE.
      IFLAG=0
      IF (M.LE.0 .OR. N.LE.0) GO TO 300
C
C     CALCULATE SIGMA = (SUM OF THE SQUARED RESIDUALS) / (M-N)
      IFLAG=1
      CALL FCN(IFLAG,M,N,X,FVEC,R,LDR)
      IF (IFLAG.LT.0) GO TO 300
      TEMP=ENORM(M,FVEC)
      SIGMA=ONE
      IF (M.NE.N) SIGMA=TEMP*TEMP/(M-N)
C
C     CALCULATE THE JACOBIAN
      IF (IOPT.EQ.3) GO TO 200
C
C     STORE THE FULL JACOBIAN USING M*N STORAGE
      IF (IOPT.EQ.1) GO TO 100
C
C     USER SUPPLIES THE JACOBIAN
      IFLAG=2
      CALL FCN(IFLAG,M,N,X,FVEC,R,LDR)
      GO TO 110
C
C     CODE APPROXIMATES THE JACOBIAN
100   CALL FDJAC3(FCN,M,N,X,FVEC,R,LDR,IFLAG,ZERO,WA4)
110   IF (IFLAG.LT.0) GO TO 300
C
C     COMPUTE THE QR DECOMPOSITION
      CALL QRFAC(M,N,R,LDR,.FALSE.,IDUM,1,WA1,WA1,WA1)
      DO 120 I=1,N
120   R(I,I)=WA1(I)
      GO TO 225
C
C     COMPUTE THE QR FACTORIZATION OF THE JACOBIAN MATRIX CALCULATED ONE
C     ROW AT A TIME AND STORED IN THE UPPER TRIANGLE OF R.
C     ( (Q TRANSPOSE)*FVEC IS ALSO CALCULATED BUT NOT USED.)
200   CONTINUE
      DO 210 J=1,N
      WA2(J)=ZERO
      DO 205 I=1,N
      R(I,J)=ZERO
205   CONTINUE
210   CONTINUE
      IFLAG=3
      DO 220 I=1,M
      NROW = I
      CALL FCN(IFLAG,M,N,X,FVEC,WA1,NROW)
      IF (IFLAG.LT.0) GO TO 300
      TEMP=FVEC(I)
      CALL RWUPDT(N,R,LDR,WA1,WA2,TEMP,WA3,WA4)
220   CONTINUE
C
C     CHECK IF R IS SINGULAR.
225   CONTINUE
      DO 230 I=1,N
      IF (R(I,I).EQ.ZERO) SING=.TRUE.
230   CONTINUE
      IF (SING) GO TO 300
C
C     R IS UPPER TRIANGULAR.  CALCULATE (R TRANSPOSE) INVERSE AND STORE
C     IN THE UPPER TRIANGLE OF R.
      IF (N.EQ.1) GO TO 275
      NM1=N-1
      DO 270 K=1,NM1
C
C     INITIALIZE THE RIGHT-HAND SIDE (WA1(*)) AS THE K-TH COLUMN OF THE
C     IDENTITY MATRIX.
      DO 240 I=1,N
      WA1(I)=ZERO
240   CONTINUE
      WA1(K)=ONE
C
      R(K,K)=WA1(K)/R(K,K)
      KP1=K+1
      DO 260 I=KP1,N
C
C     SUBTRACT R(K,I-1)*R(I-1,*) FROM THE RIGHT-HAND SIDE, WA1(*).
      DO 250 J=I,N
      WA1(J)=WA1(J)-R(K,I-1)*R(I-1,J)
250   CONTINUE
      R(K,I)=WA1(I)/R(I,I)
260   CONTINUE
270   CONTINUE
275   R(N,N)=ONE/R(N,N)
C
C     CALCULATE R-INVERSE * (R TRANSPOSE) INVERSE AND STORE IN THE UPPER
C     TRIANGLE OF R.
      DO 290 I=1,N
      DO 290 J=I,N
      TEMP=ZERO
      DO 280 K=J,N
      TEMP=TEMP+R(I,K)*R(J,K)
280   CONTINUE
      R(I,J)=TEMP*SIGMA
290   CONTINUE
      INFO=1
C
300   CONTINUE
      IF (M.LE.0 .OR. N.LE.0) INFO=0
      IF (IFLAG.LT.0) INFO=IFLAG
      IF (SING) INFO=2
      IF (INFO .LT. 0) CALL XERMSG ('SLATEC', 'SCOV',
     +   'EXECUTION TERMINATED BECAUSE USER SET IFLAG NEGATIVE.', 1, 1)
      IF (INFO .EQ. 0) CALL XERMSG ('SLATEC', 'SCOV',
     +   'INVALID INPUT PARAMETER.', 2, 1)
      IF (INFO .EQ. 2) CALL XERMSG ('SLATEC', 'SCOV',
     +   'SINGULAR JACOBIAN MATRIX, COVARIANCE MATRIX CANNOT BE ' //
     +   'CALCULATED.', 1, 1)
      RETURN
      END
*DECK SCPPLT
      SUBROUTINE SCPPLT (N, NELT, IA, JA, A, ISYM, IUNIT)
C***BEGIN PROLOGUE  SCPPLT
C***PURPOSE  Printer Plot of SLAP Column Format Matrix.
C            Routine to print out a SLAP Column format matrix in a
C            "printer plot" graphical representation.
C***LIBRARY   SLATEC (SLAP)
C***CATEGORY  N1
C***TYPE      SINGLE PRECISION (SCPPLT-S, DCPPLT-D)
C***KEYWORDS  DIAGNOSTICS, LINEAR SYSTEM, SLAP SPARSE
C***AUTHOR  Seager, Mark K., (LLNL)
C             Lawrence Livermore National Laboratory
C             PO BOX 808, L-60
C             Livermore, CA 94550 (510) 423-3141
C             seager@llnl.gov
C***DESCRIPTION
C
C *Usage:
C     INTEGER N, NELT, IA(NELT), JA(NELT), ISYM, IUNIT
C     REAL    A(NELT)
C
C     CALL SCPPLT( N, NELT, IA, JA, A, ISYM, IUNIT )
C
C *Arguments:
C N      :IN       Integer
C         Order of the Matrix.
C         If N.gt.MAXORD, only the leading MAXORD x MAXORD
C         submatrix will be printed.  (Currently MAXORD = 225.)
C NELT   :IN       Integer.
C         Number of non-zeros stored in A.
C IA     :IN       Integer IA(NELT).
C JA     :IN       Integer JA(NELT).
C A      :IN       Real A(NELT).
C         These arrays should hold the matrix A in the SLAP
C         Column format.  See "Description", below.
C ISYM   :IN       Integer.
C         Flag to indicate symmetric storage format.
C         If ISYM=0, all non-zero entries of the matrix are stored.
C         If ISYM=1, the matrix is symmetric, and only the lower
C         triangle of the matrix is stored.
C IUNIT  :IN       Integer.
C         Fortran logical I/O device unit number to write the matrix
C         to.  This unit must be connected in a system dependent fashion
C         to a file or the console or you will get a nasty message
C         from the Fortran I/O libraries.
C
C *Description:
C       This routine prints out a SLAP  Column format matrix  to the
C       Fortran logical I/O unit   number  IUNIT.  The  numbers them
C       selves  are not printed  out, but   rather  a one  character
C       representation of the numbers.   Elements of the matrix that
C       are not represented in the (IA,JA,A)  arrays are  denoted by
C       ' ' character (a blank).  Elements of A that are *ZERO* (and
C       hence  should  really not be  stored) are  denoted  by a '0'
C       character.  Elements of A that are *POSITIVE* are denoted by
C       'D' if they are Diagonal elements  and '#' if  they are off
C       Diagonal  elements.  Elements of  A that are *NEGATIVE* are
C       denoted by 'N'  if they  are Diagonal  elements and  '*' if
C       they are off Diagonal elements.
C
C       =================== S L A P Column format ==================
C
C       This routine  requires that  the matrix A  be stored in  the
C       SLAP Column format.  In this format the non-zeros are stored
C       counting down columns (except for  the diagonal entry, which
C       must appear first in each  "column")  and are stored  in the
C       real array A.  In other words, for each column in the matrix
C       put the diagonal entry in A.  Then put in the other non-zero
C       elements going down   the  column (except  the diagonal)  in
C       order.  The IA array holds the row  index for each non-zero.
C       The JA array holds the offsets into the IA, A arrays for the
C       beginning of   each    column.    That  is,    IA(JA(ICOL)),
C       A(JA(ICOL)) points to the beginning of the ICOL-th column in
C       IA and  A.  IA(JA(ICOL+1)-1),  A(JA(ICOL+1)-1) points to the
C       end  of   the ICOL-th  column.  Note   that  we  always have
C       JA(N+1) = NELT+1, where  N  is the number of columns in  the
C       matrix and  NELT   is the number of non-zeros in the matrix.
C
C       Here is an example of the  SLAP Column  storage format for a
C       5x5 Matrix (in the A and IA arrays '|'  denotes the end of a
C       column):
C
C           5x5 Matrix      SLAP Column format for 5x5 matrix on left.
C                              1  2  3    4  5    6  7    8    9 10 11
C       |11 12  0  0 15|   A: 11 21 51 | 22 12 | 33 53 | 44 | 55 15 35
C       |21 22  0  0  0|  IA:  1  2  5 |  2  1 |  3  5 |  4 |  5  1  3
C       | 0  0 33  0 35|  JA:  1  4  6    8  9   12
C       | 0  0  0 44  0|
C       |51  0 53  0 55|
C
C *Cautions:
C     This routine will attempt to write to the Fortran logical output
C     unit IUNIT, if IUNIT .ne. 0.  Thus, the user must make sure that
C     this logical unit is attached to a file or terminal before calling
C     this routine with a non-zero value for IUNIT.  This routine does
C     not check for the validity of a non-zero IUNIT unit number.
C
C *Portability:
C     This routine, as distributed, can generate lines up to 229
C     characters long.  Some Fortran systems have more restricted
C     line lengths.  Change parameter MAXORD and the large number
C     in FORMAT 1010 to reduce this line length.
C
C***REFERENCES  (NONE)
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   871119  DATE WRITTEN
C   881213  Previous REVISION DATE
C   890915  Made changes requested at July 1989 CML Meeting.  (MKS)
C   890922  Numerous changes to prologue to make closer to SLATEC
C           standard.  (FNF)
C   890929  Numerous changes to reduce SP/DP differences.  (FNF)
C   910411  Prologue converted to Version 4.0 format.  (BAB)
C   920511  Added complete declaration section.  (WRB)
C   921007  Replaced hard-wired 225 with parameter MAXORD.  (FNF)
C   921021  Corrected syntax of CHARACTER declaration.  (FNF)
C   930701  Updated CATEGORY section.  (FNF, WRB)
C***END PROLOGUE  SCPPLT
C     .. Scalar Arguments ..
      INTEGER ISYM, IUNIT, N, NELT
C     .. Array Arguments ..
      REAL A(NELT)
      INTEGER IA(NELT), JA(NELT)
C     .. Parameters ..
      INTEGER  MAXORD
      PARAMETER (MAXORD=225)
C     .. Local Scalars ..
      INTEGER I, ICOL, IROW, J, JBGN, JEND, NMAX
C     .. Local Arrays ..
      CHARACTER CHMAT(MAXORD)*(MAXORD)
C     .. Intrinsic Functions ..
      INTRINSIC MIN, MOD, REAL
C***FIRST EXECUTABLE STATEMENT  SCPPLT
C
C         Set up the character matrix...
C
      NMAX = MIN( MAXORD, N )
      DO 10 I = 1, NMAX
         CHMAT(I)(1:NMAX) = ' '
 10   CONTINUE
      DO 30 ICOL = 1, NMAX
         JBGN = JA(ICOL)
         JEND = JA(ICOL+1)-1
         DO 20 J = JBGN, JEND
            IROW = IA(J)
            IF( IROW.LE.NMAX ) THEN
               IF( ISYM.NE.0 ) THEN
C         Put in non-sym part as well...
                  IF( A(J).EQ.0.0E0 ) THEN
                     CHMAT(IROW)(ICOL:ICOL) = '0'
                  ELSEIF( A(J).GT.0.0E0 ) THEN
                     CHMAT(IROW)(ICOL:ICOL) = '#'
                  ELSE
                     CHMAT(IROW)(ICOL:ICOL) = '*'
                  ENDIF
               ENDIF
               IF( IROW.EQ.ICOL ) THEN
C         Diagonal entry.
                  IF( A(J).EQ.0.0E0 ) THEN
                     CHMAT(IROW)(ICOL:ICOL) = '0'
                  ELSEIF( A(J).GT.0.0E0 ) THEN
                     CHMAT(IROW)(ICOL:ICOL) = 'D'
                  ELSE
                     CHMAT(IROW)(ICOL:ICOL) = 'N'
                  ENDIF
               ELSE
C         Off-Diagonal entry
                  IF( A(J).EQ.0.0E0 ) THEN
                     CHMAT(IROW)(ICOL:ICOL) = '0'
                  ELSEIF( A(J).GT.0.0E0 ) THEN
                     CHMAT(IROW)(ICOL:ICOL) = '#'
                  ELSE
                     CHMAT(IROW)(ICOL:ICOL) = '*'
                  ENDIF
               ENDIF
            ENDIF
 20      CONTINUE
 30   CONTINUE
C
C         Write out the heading.
      WRITE(IUNIT,1000) N, NELT, REAL(NELT)/(N*N)
      WRITE(IUNIT,1010) (MOD(I,10),I=1,NMAX)
C
C         Write out the character representations matrix elements.
      DO 40 IROW = 1, NMAX
         WRITE(IUNIT,1020) IROW, CHMAT(IROW)(1:NMAX)
 40   CONTINUE
      RETURN
C
 1000 FORMAT(/'**** Picture of Column SLAP matrix follows ****'/
     $     ' N, NELT and Density = ',2I10,E16.7)
C      The following assumes MAXORD.le.225.
 1010 FORMAT(4X,225(I1))
 1020 FORMAT(1X,I3,A)
C------------- LAST LINE OF SCPPLT FOLLOWS ----------------------------
      END

subroutine vector_header(line,error)
  use image_def
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>vector_header
  use gbl_message
  use sic_structures
  use sic_dictionaries
  use sic_types
  !---------------------------------------------------------------------
  ! @ private
  !  Support routine for command
  !  VECTOR\HEADER GDFFile|FITSFile|SicVariable
  ! 1 /EXTREMA         Add/update the extrema section
  ! 2 /TELESCOPE Name  Add/update the telescope section
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line   ! Input command line
  logical,          intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='HEADER'
  integer(kind=4), parameter :: optextr=1
  integer(kind=4), parameter :: opttele=2
  logical :: doextr,dotele,dohead,needdata,readonly
  type(gildas), target :: mine
  type(gildas), pointer :: theheader
  integer(kind=4) :: i, n, ier, what
  real(kind=4), allocatable :: mydata(:,:)
  integer(kind=size_length) :: asize
  character(len=filename_length) :: chain
  type(sic_descriptor_t) :: desc
  logical :: found
  !
  if (.not.sic_present(0,1)) then
    call sic_message(seve%e,rname,'Missing file name as argument')
!    call sic_message(seve%e,rname,  &
!      'Use [GREG3\]IMAGE (with no argument) to list the IMAGE header')
    error = .true.
    return
  endif
  !
  ! Command line parsing
  call gildas_null(mine)
  call sic_ch(line,0,1,chain,n,.true.,error)
  if (error) return
  doextr = sic_present(optextr,0)
  dotele = sic_present(opttele,0)
  dohead = (.not.doextr) .and. (.not.dotele)
  needdata = doextr
  readonly = .true.
  theheader => null()
  !
  ! Check if file or header variable. 1=GDF, 2=FITS, 3=variable
  if (sic_query_file(chain,' ',' ',mine%file)) then
    call gag_file_guess(rname,mine%file,what,error)
    if (error)  return
    if (what.eq.0) then
      call sic_message(seve%w,rname,'File '//trim(chain)//' is neither GDF nor FITS')
      return
    endif
    readonly = what.eq.2
  else
    call sic_descriptor(chain,desc,found)
    if (.not.found) then
      call sic_message(seve%w,rname,'No such file or variable '//chain)
      return
    endif
    if (.not.associated(desc%head)) then
      call sic_message(seve%w,rname,  &
        'Variable '//trim(chain)//' does not provide a header')
      return
    endif
    what = 3
    readonly = desc%readonly
  endif
  !
  ! Read GDF if relevant
  select case (what)
  case (1)
    call gdf_read_header(mine,error) ! Just read header
    if (error) return
    theheader => mine
    if (needdata) then
      if (mine%gil%type_gdf.eq.code_gdf_uvt) then
        allocate(mydata(mine%gil%dim(1),mine%gil%dim(2)),stat=ier)
        call gdf_read_data(mine,mydata,error)
        if (error)  return
        mine%loca%addr = locwrd(mydata)
      elseif (mine%gil%type_gdf.eq.code_gdf_tuv) then
        allocate(mydata(mine%gil%dim(1),2),stat=ier)
        mine%blc(2) = 1
        mine%trc(2) = 2
        call gdf_read_data(mine,mydata,error)
        if (error)  return
        mine%loca%addr = locwrd(mydata)
      else
        ! The Real*8 case is not well treated yet...
        asize = 1
        do i=1,mine%gil%ndim
          asize = asize*mine%gil%dim(i)
        enddo
        allocate(mydata(asize,1),stat=ier)
        if (failed_allocate(rname,'data',ier,error))  return
        call gdf_read_data(mine,mydata,error)
        if (error)  return
        mine%loca%addr = locwrd(mydata)
      endif
    endif
  case (2)
    theheader => null()
    if (needdata) then
      call sic_message(seve%w,rname,'Can not access data on FITS files')
      goto 10
    endif
  case (3)
    theheader => desc%head
    if (needdata .and. desc%addr.eq.ptr_null) then
      call sic_message(seve%w,rname,trim(chain)//' does not provide data')
      goto 10
    endif
    desc%head%loca%addr = desc%addr
    desc%head%loca%size = desc%size
  end select
  !
  ! /EXTREMA
  if (doextr) then
    if (readonly) then
      if (what.eq.3) then ! A SIC variable
        call sic_message(seve%w,rname,trim(chain)//' is read-only, changed in memory only')
      else
        call sic_message(seve%e,rname,trim(chain)//' is read-only')
        goto 10
      endif
    endif
    if (abs(theheader%gil%type_gdf).eq.code_gdf_uvt) then
      call gdf_get_baselines (theheader,error)
      if (error)  goto 10
    else
      call gdf_get_extrema (theheader,error)
      if (error)  goto 10
    endif
  endif
  !
  ! /TELESCOPE
  if (dotele) then
    if (readonly) then
      call sic_message(seve%w,rname,trim(chain)//' is read-only')
      goto 10
    endif
    call vector_header_telescope(line,theheader,error)
    if (error)  goto 10
  endif
  !
  ! No option (display header)
  if (dohead) then
    if (what.eq.2) then
      call gdf_fits_header(chain,error)
    else
      call gdf_print_header(theheader)
    endif
  endif
  !
  ! Free
10 continue
  if (what.eq.1) then
    if (doextr .or. dotele) then
      call gdf_update_header(theheader,error)
      if (error)  continue
    endif
    call gdf_close_image(mine,error)   ! Do not forget
    if (error)  return
  endif
  if (allocated(mydata))  deallocate(mydata)  ! Useless
  !
end subroutine vector_header
!
subroutine vector_header_telescope(line,img,error)
  use image_def
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>vector_header_telescope
  !---------------------------------------------------------------------
  ! @ private
  ! Support routine for command
  !   V\HEADER File /TELESCOPE [+-]Name1 ... [+-]NameN
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line
  type(gildas),     intent(inout) :: img
  logical,          intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='HEADER'
  integer(kind=4), parameter :: opttele=2
  character(len=24) :: teles
  integer(kind=4) :: iarg,n
  logical :: add
  real(kind=8) :: dummy(3)
  !
  do iarg=1,max(1,sic_narg(opttele))
    call sic_ke(line,opttele,iarg,teles,n,.true.,error)
    if (error)  return
    !
    if (teles(1:1).eq.'+') then
      add = .true.
      teles = teles(2:)
    elseif (teles(1:1).eq.'-') then
      add = .false.
      teles = teles(2:)
    else
      add = .true.
    endif
    !
    if (add) then
      call gdf_addteles(img,'TELE',teles,dummy,error)
    else
      call gdf_rmteles(img,teles,error)
    endif
    if (error)  return
  enddo
  !
end subroutine vector_header_telescope
!
subroutine gdf_fits_header(file,error)
  use image_def
  use sic_dependencies_interfaces
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !  Support routine for command VECTOR\HEADER File
  !    for FITS file format
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: file
  logical, intent(inout) :: error
  !
  integer :: flun,ier, i,j
  integer(kind=4) :: farray(20,36)
  character(len=8) :: fkeyw
  character(len=80) :: fline
  character(len=filename_length) :: fich
  !
  ier = sic_getlun(flun)
  call sic_parse_file(file,' ',' ',fich)
  open(unit=flun,file=trim(fich),recl=720*facunf,status='OLD',form='UNFORMATTED',  &
       access='DIRECT',action='READ',iostat=ier)
  if (ier.ne.0) then
    call putios('E-OPEN,  ',ier)
    call sic_frelun(flun)
    error = .true.
    return
  endif
  !
  read(flun,rec=1) farray
  call bytoch(farray(1:20,1),fkeyw,8)
  if (fkeyw.ne.'SIMPLE ') then
    error = .true.
    close(unit=flun)
    call sic_frelun(flun)
    return
  endif
  !
  j = 1
  do
    do i=1,36
      call bytoch(farray(1:20,i),fline,80)
      write(*,'(a)') trim(fline)
      if (fline(1:4).eq.'END ') exit
    enddo
    if (fline(1:4).eq.'END ') exit
    j = j+1
    read(flun,rec=j) farray
  enddo
  !
  close(unit=flun)
  call sic_frelun(flun)
  error = .false.
end subroutine gdf_fits_header
!

subroutine mosaic_restore(line,huv_call,error)
  use clean_arrays
  use clean_types
  use clean_default
  use gbl_message
  use gkernel_interfaces
  use imager_interfaces, except_this => mosaic_restore
  !-------------------------------------int--------------------------------
  ! @ private
  !*
  ! IMAGER - Restore (like in UV_RESTORE) a mosaic image
  !
  ! Required input: 
  !   the CCT table  
  !   the RESIDUAL image, obtained either
  !       by imaging the UV table obtained by UV_RESIDUAL,
  !    or by using UV_MAP, computing the residuals "on-the-fly" in the
  !       Sault et al method.
  !   the PRIMARY beams  
  ! Output  
  !   the restored SKY image
  !!
  !---------------------------------------------------------------------
  character(len=*), intent(inout) :: line   !! Command line
  type(gildas), intent(inout) :: huv_call   !! UV Header & Data
  logical, intent(inout) :: error           !! Logical error flag
  !
  character(len=*), parameter :: task='MOSAIC_RESTORE'
  type(gildas) :: huv_tmp
  real, pointer :: prima(:,:,:)
  real, pointer :: resid(:,:)
  real, pointer :: clean(:,:)
  real, allocatable, target :: duv_tmp(:,:)
  real, allocatable :: response(:,:)
  integer :: nx,ny,np,nc,ic,ip,ier,nu,nv
  real :: wr, wr2, wmax, outside, old_bmin
  logical :: zero, err
  !
  logical, parameter :: do_clean=.true.
  logical, parameter :: subtract=.true.
  logical, parameter :: use_file=.false.
  integer, parameter :: nblock=1
  logical :: do_resi
  !
  integer :: mcol(2), nb, wcol
  integer :: debug
  !
  call imager_tree('MOSAIC_RESTORE',.false.)
  ! Code ----
  debug = 0
  call sic_get_inte('DEBUG_RESTORE',debug,error)
  if (debug.ne.0) call map_message(seve%i,task,'Calling MOSAIC_RESTORE in mosaic_restore.f90',seve%e)
  if (mosaic_mode.eq.'SAULT') &
    & call map_message(seve%e,task,'Cannot restore Mosaic in SAULT mode (incorrect result)',seve%e)
  !
  error = .false.
  ! Compute the primary beams if not done
  if (hprim%loca%size.eq.0) then
    call map_message(seve%e,task,'Primary beams undefined')
    error = .true.
    return
  endif
  !
  ! At this stage, we may not have a CLEAN image, so we  may derive the stuff from 
  ! the PRIMARY beam, but the CLEAN beam can be undefined
  call sky_as_clean(task,error)
  if (error) return
  if (debug.gt.0) call map_message(seve%i,'MOSAIC_RESTORE','Done SKY_AS_CLEAN',seve%e)
  !
  ! Find out how many beams are required
  call print_buffer_asso('UV Call before UVMAP_COLS',huv_call)
  mcol = huv_call%img%bounds
  wcol = huv_call%img%weight
  nx = hsky%gil%dim(1)
  ny = hsky%gil%dim(2)
  call print_buffer_asso('UV Call before DEFINE_BEAMS',huv_call)
  call define_beams(task,themap%beam,nx,ny,huv_call,mcol,nb,error)
  if (error) return
  !
  call gildas_null(huv_tmp,type='UVT')
  call gdf_copy_header(huv_call, huv_tmp, error)
  !
  ! Compute the UV Residual (if needed) and the pure CLEAN part
  do_resi = huv_call%gil%column_pointer(code_uvt_id).eq.0   &
    & .or. mosaic_mode.eq.'GUETH'
  do_resi = .TRUE.  ! Test -  mosaic_uvmap does the job in all cases...
  !
  ! Extract the range of channels
  call uv_extract_header(huv_tmp, mcol)
  nu = huv_tmp%gil%dim(1)
  nv = huv_tmp%gil%nvisi
  allocate(huv_tmp%r2d(nu,nv),duv_tmp(nu,nv),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,task,'UV Tmp allocation error')
    error = .true.
    return
  endif
  call uv_extract_sub(huv_call,huv_tmp,use_file,nblock,mcol,error)
  if (error) return
  !
  huv_tmp%img%bounds = [1,huv_tmp%gil%nchan]
  mcol = huv_tmp%img%bounds
  wcol = huv_call%img%weight-huv_call%img%bounds(1)
  !
  call map_message(seve%i,task,'Computing UV residuals')
  call print_buffer_asso('UV Call before SUB_UV_RESIDUAL',huv_call)
  !
  ! As do_clean is TRUE, Clean components are added to the Residual
  call sub_uv_residual(task,line,0,huv_tmp,huv_tmp%r2d, &
    & duv_tmp,do_clean,do_resi,subtract,error)
  if (error) return
  deallocate(huv_tmp%r2d,stat=ier)
  huv_tmp%r2d => duv_tmp 
  if (debug.gt.0) call map_message(seve%i,task,'Done SUB_UV_RESIDUAL',seve%e)
  !
  call map_message(seve%i,task,'Imaging residuals')
  !
  ! Perform the Imaging
  old_bmin = default_map%truncate
  default_map%truncate = hprim%gil%inc(1)
  !
  ! We use the default "mosaic_uvmap" routine, but use the RESIDUAL image 
  !
  ! We should apply the JvM factor per beam and per field at this stage
  !
  call define_beams(task,themap%beam,nx,ny,huv_tmp,mcol,nb,error)
  if (error) return
  !
  call mosaic_uvmap(task,line,huv_tmp,error)
  if (debug.gt.0) call map_message(seve%i,task,'Done MOSAIC_UVMAP',seve%e)
  nullify(huv_tmp%r2d)
  deallocate(duv_tmp,stat=ier)
  !
  default_map%truncate = old_bmin
  !
  ! At this stage : DIRTY is the RESIDUAL...
  call gdf_copy_header(hdirty,hresid,error)
  hresid%r3d => dresid 
  !
  prima => dprim(:,:,:,1)
  np = hprim%gil%dim(1)
  nc = hresid%gil%dim(3)
  ny = hresid%gil%dim(2)
  nx = hresid%gil%dim(1)
  !
  ! Compute the "weight" function 1/N
  !
  ! Restore weight (default 20 % level of peak response)
  wr = 0.2       !Just in case this is not initialized
  call sic_get_real('CLEAN_TRUNCATE',wr,error)
  wr2 = wr**2 
  allocate(response(nx,ny),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,task,'Memory allocation error')
    error = .true.
    return
  endif
  ! This allows CLEAN_TRUNCATE to be negative for tests, so that
  ! noise amplification is limited outside of -CLEAN_TRUNCATE
  if (wr.ge.0.) then  
    outside = 0.0
  else 
    outside = 1.0/wr2 
  endif
  !
  response = 0
  do ip=1,np
    response(:,:) = response(:,:)+prima(ip,:,:)**2
  enddo
  !
  ! The default normalization is to the peak of a single beam,
  ! so that the peak response is in general > 1
  !
  ! We assume WR (CLEAN_TRUNCATE) refers to the peak response
  ! Setting WM = 1 would assume it refers to one Field only, i.e.
  ! the level of one primary beam.
  wmax = maxval(response)
  where (response.gt.wr2*wmax) 
    response = 1./response 
  else where
    response = outside
  end where
  !
  ! For test, can reset CLEAN or RESID, as well as keeping UV residual if needed
  ! This is controlled by user_method%residual (SIC variable CLEAN_RESIDUAL)
  !
  ! Loop on channels
  do ic=1,nc
    resid => hresid%r3d(:,:,ic)
    clean => hsky%r3d(:,:,ic)
    ! Mosaic case
    ! We should apply the JvM factor per beam and per field
    ! This is not possible at this stage, it should be done before
    if (user_method%residual.ne.1) clean = clean + resid*response
    where (response.eq.0) clean = hsky%gil%bval ! Undefined pixel there
  enddo
  !
  call sic_delvariable ('SKY',.false.,error)
  ! Redefine CLEAN data set 
  call sic_mapgildas('SKY',hsky,error,dsky)       ! Clean buffers
  hsky%loca%size = hdirty%loca%size
  !
  if (debug.gt.0) call map_message(seve%i,task,'Done adding residuals',seve%e)
  call cube_minmax('SKY',hsky,error)
  !
  ! Must clean in some way the intermediate UV_BUFFERS and
  ! re-associate the HUV header - Use a new UV_DISCARD_BUFFER tool
  ! to factorize that.
  !
  zero = .false. 
  call sic_get_logi('ZERO_KEEPUV',zero,err)
  !
  if (.not.zero) then
    !call uv_dump_buffers(task//' before')
    !Print *,'Discarding UV buffers '
!!    call uv_discard_buffers(duv_previous, duv_next, error)
    !call uv_dump_buffers(task//' after')
!!    call gdf_copy_header(huv_save,huv_current,error)
    !
  else
    call map_message(seve%w,task,'Keeping UV residuals')
!!    call uv_clean_buffers (duv_previous, duv_next,error)
    if (error) return
    !
    ! Resize UV data and redefine SIC variables 
!!    huv_current%gil%nvisi = ubound(duv,2)
!!    huv_current%gil%dim(2) = huv_current%gil%nvisi
    !
    ! UV data has changed, but no new Weights
!!    call uv_new_data
    !
  endif
  !
!  ! Some how, CLEAN does not work properly after this
! No longer true as far as I know -25-May-2022
!  call map_message(seve%w,task,'--- Temporary: please repeat UV_MAP if a new CLEAN is needed ---')
  call imager_tree('MOSAIC_RESTORE',.true.)
  !  
end subroutine mosaic_restore

subroutine sky_as_clean(rname,error)
  use clean_arrays
  use gbl_message
  use imager_interfaces, only : map_message
  !---------------------------------------------------------------------
  ! @ private
  !
  !! IMAGER --  Create the SKY brightness like the CLEAN image
  !---------------------------------------------------------------------  
  character(len=*), intent(in) :: rname   !! Caller name
  logical, intent(inout) :: error         !! Logical error flag
  !
  integer :: ier
  !
  if (allocated(dsky)) then
    if (any(hsky%gil%dim.ne.hdirty%gil%dim)) then
      ! That may happen if some READ SKY has been done
      ! Print *,'Programming error - Sky & Dirty mismatch'
      deallocate(dsky)
    else
      call map_message(seve%i,rname,'Re-using sky memory')
    endif
    call sic_delvariable('SKY',.false.,error)
  endif
  !
  call gdf_copy_header(hdirty,hsky,error) 
  if (error) return
  hsky%gil%bval = 1.234567E38
  hsky%gil%eval = 0
  hsky%gil%blan_words = 2
  !
  ! Allocate if needed
  if (.not.allocated(dsky)) then
    allocate (dsky(hsky%gil%dim(1), hsky%gil%dim(2), hsky%gil%dim(3)), stat=ier)
    if (ier.ne.0) then
      call map_message(seve%e,rname,'Memory allocation error')
      error = .true.
      return
    endif
  endif
  !
  ! Set the proper pointer
  hsky%r3d => dsky 
  !
end subroutine sky_as_clean

*DECK DOGLEG
      SUBROUTINE DOGLEG (N, R, LR, DIAG, QTB, DELTA, X, WA1, WA2)
C***BEGIN PROLOGUE  DOGLEG
C***SUBSIDIARY
C***PURPOSE  Subsidiary to SNSQ and SNSQE
C***LIBRARY   SLATEC
C***TYPE      SINGLE PRECISION (DOGLEG-S, DDOGLG-D)
C***AUTHOR  (UNKNOWN)
C***DESCRIPTION
C
C     Given an M by N matrix A, an N by N nonsingular DIAGONAL
C     matrix D, an M-vector B, and a positive number DELTA, the
C     problem is to determine the convex combination X of the
C     Gauss-Newton and scaled gradient directions that minimizes
C     (A*X - B) in the least squares sense, subject to the
C     restriction that the Euclidean norm of D*X be at most DELTA.
C
C     This subroutine completes the solution of the problem
C     if it is provided with the necessary information from the
C     QR factorization of A. That is, if A = Q*R, where Q has
C     orthogonal columns and R is an upper triangular matrix,
C     then DOGLEG expects the full upper triangle of R and
C     the first N components of (Q TRANSPOSE)*B.
C
C     The subroutine statement is
C
C       SUBROUTINE DOGLEG(N,R,LR,DIAG,QTB,DELTA,X,WA1,WA2)
C
C     where
C
C       N is a positive integer input variable set to the order of R.
C
C       R is an input array of length LR which must contain the upper
C         triangular matrix R stored by rows.
C
C       LR is a positive integer input variable not less than
C         (N*(N+1))/2.
C
C       DIAG is an input array of length N which must contain the
C         diagonal elements of the matrix D.
C
C       QTB is an input array of length N which must contain the first
C         N elements of the vector (Q TRANSPOSE)*B.
C
C       DELTA is a positive input variable which specifies an upper
C         bound on the Euclidean norm of D*X.
C
C       X is an output array of length N which contains the desired
C         convex combination of the Gauss-Newton direction and the
C         scaled gradient direction.
C
C       WA1 and WA2 are work arrays of length N.
C
C***SEE ALSO  SNSQ, SNSQE
C***ROUTINES CALLED  ENORM, R1MACH
C***REVISION HISTORY  (YYMMDD)
C   800301  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890831  Modified array declarations.  (WRB)
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900326  Removed duplicate information from DESCRIPTION section.
C           (WRB)
C   900328  Added TYPE section.  (WRB)
C***END PROLOGUE  DOGLEG
      INTEGER N,LR
      REAL DELTA
      REAL R(LR),DIAG(*),QTB(*),X(*),WA1(*),WA2(*)
      INTEGER I,J,JJ,JP1,K,L
      REAL ALPHA,BNORM,EPSMCH,GNORM,ONE,QNORM,SGNORM,SUM,TEMP,ZERO
      REAL R1MACH,ENORM
      SAVE ONE, ZERO
      DATA ONE,ZERO /1.0E0,0.0E0/
C***FIRST EXECUTABLE STATEMENT  DOGLEG
      EPSMCH = R1MACH(4)
C
C     FIRST, CALCULATE THE GAUSS-NEWTON DIRECTION.
C
      JJ = (N*(N + 1))/2 + 1
      DO 50 K = 1, N
         J = N - K + 1
         JP1 = J + 1
         JJ = JJ - K
         L = JJ + 1
         SUM = ZERO
         IF (N .LT. JP1) GO TO 20
         DO 10 I = JP1, N
            SUM = SUM + R(L)*X(I)
            L = L + 1
   10       CONTINUE
   20    CONTINUE
         TEMP = R(JJ)
         IF (TEMP .NE. ZERO) GO TO 40
         L = J
         DO 30 I = 1, J
            TEMP = MAX(TEMP,ABS(R(L)))
            L = L + N - I
   30       CONTINUE
         TEMP = EPSMCH*TEMP
         IF (TEMP .EQ. ZERO) TEMP = EPSMCH
   40    CONTINUE
         X(J) = (QTB(J) - SUM)/TEMP
   50    CONTINUE
C
C     TEST WHETHER THE GAUSS-NEWTON DIRECTION IS ACCEPTABLE.
C
      DO 60 J = 1, N
         WA1(J) = ZERO
         WA2(J) = DIAG(J)*X(J)
   60    CONTINUE
      QNORM = ENORM(N,WA2)
      IF (QNORM .LE. DELTA) GO TO 140
C
C     THE GAUSS-NEWTON DIRECTION IS NOT ACCEPTABLE.
C     NEXT, CALCULATE THE SCALED GRADIENT DIRECTION.
C
      L = 1
      DO 80 J = 1, N
         TEMP = QTB(J)
         DO 70 I = J, N
            WA1(I) = WA1(I) + R(L)*TEMP
            L = L + 1
   70       CONTINUE
         WA1(J) = WA1(J)/DIAG(J)
   80    CONTINUE
C
C     CALCULATE THE NORM OF THE SCALED GRADIENT DIRECTION,
C     NORMALIZE, AND RESCALE THE GRADIENT.
C
      GNORM = ENORM(N,WA1)
      SGNORM = ZERO
      ALPHA = DELTA/QNORM
      IF (GNORM .EQ. ZERO) GO TO 120
      DO 90 J = 1, N
         WA1(J) = (WA1(J)/GNORM)/DIAG(J)
   90    CONTINUE
C
C     CALCULATE THE POINT ALONG THE SCALED GRADIENT
C     AT WHICH THE QUADRATIC IS MINIMIZED.
C
      L = 1
      DO 110 J = 1, N
         SUM = ZERO
         DO 100 I = J, N
            SUM = SUM + R(L)*WA1(I)
            L = L + 1
  100       CONTINUE
         WA2(J) = SUM
  110    CONTINUE
      TEMP = ENORM(N,WA2)
      SGNORM = (GNORM/TEMP)/TEMP
C
C     TEST WHETHER THE SCALED GRADIENT DIRECTION IS ACCEPTABLE.
C
      ALPHA = ZERO
      IF (SGNORM .GE. DELTA) GO TO 120
C
C     THE SCALED GRADIENT DIRECTION IS NOT ACCEPTABLE.
C     FINALLY, CALCULATE THE POINT ALONG THE DOGLEG
C     AT WHICH THE QUADRATIC IS MINIMIZED.
C
      BNORM = ENORM(N,QTB)
      TEMP = (BNORM/GNORM)*(BNORM/QNORM)*(SGNORM/DELTA)
      TEMP = TEMP - (DELTA/QNORM)*(SGNORM/DELTA)**2
     1       + SQRT((TEMP-(DELTA/QNORM))**2
     2              +(ONE-(DELTA/QNORM)**2)*(ONE-(SGNORM/DELTA)**2))
      ALPHA = ((DELTA/QNORM)*(ONE - (SGNORM/DELTA)**2))/TEMP
  120 CONTINUE
C
C     FORM APPROPRIATE CONVEX COMBINATION OF THE GAUSS-NEWTON
C     DIRECTION AND THE SCALED GRADIENT DIRECTION.
C
      TEMP = (ONE - ALPHA)*MIN(SGNORM,DELTA)
      DO 130 J = 1, N
         X(J) = TEMP*WA1(J) + ALPHA*X(J)
  130    CONTINUE
  140 CONTINUE
      RETURN
C
C     LAST CARD OF SUBROUTINE DOGLEG.
C
      END
*DECK DOHTRL
      SUBROUTINE DOHTRL (Q, N, NRDA, DIAG, IRANK, DIV, TD)
C***BEGIN PROLOGUE  DOHTRL
C***SUBSIDIARY
C***PURPOSE  Subsidiary to DBVSUP and DSUDS
C***LIBRARY   SLATEC
C***TYPE      DOUBLE PRECISION (OHTROL-S, DOHTRL-D)
C***AUTHOR  Watts, H. A., (SNLA)
C***DESCRIPTION
C
C     For a rank deficient problem, additional orthogonal
C     HOUSEHOLDER transformations are applied to the left side
C     of Q to further reduce the triangular form.
C     Thus, after application of the routines DORTHR and DOHTRL
C     to the original matrix, the result is a nonsingular
C     triangular matrix while the remainder of the matrix
C     has been zeroed out.
C
C***SEE ALSO  DBVSUP, DSUDS
C***ROUTINES CALLED  DDOT
C***REVISION HISTORY  (YYMMDD)
C   750601  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890831  Modified array declarations.  (WRB)
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900328  Added TYPE section.  (WRB)
C   910722  Updated AUTHOR section.  (ALS)
C***END PROLOGUE  DOHTRL
      DOUBLE PRECISION DDOT
      INTEGER IRANK, IRP, J, K, KIR, KIRM, L, N, NMIR, NRDA
      DOUBLE PRECISION DD, DIAG(*), DIAGK, DIV(*), Q(NRDA,*), QS, SIG,
     1     SQD, TD(*), TDV
C***FIRST EXECUTABLE STATEMENT  DOHTRL
      NMIR = N - IRANK
      IRP = IRANK + 1
      DO 40 K = 1, IRANK
         KIR = IRP - K
         DIAGK = DIAG(KIR)
         SIG = (DIAGK*DIAGK) + DDOT(NMIR,Q(IRP,KIR),1,Q(IRP,KIR),1)
         DD = SIGN(SQRT(SIG),-DIAGK)
         DIV(KIR) = DD
         TDV = DIAGK - DD
         TD(KIR) = TDV
         IF (K .EQ. IRANK) GO TO 30
            KIRM = KIR - 1
            SQD = DD*DIAGK - SIG
            DO 20 J = 1, KIRM
               QS = ((TDV*Q(KIR,J))
     1               + DDOT(NMIR,Q(IRP,J),1,Q(IRP,KIR),1))/SQD
               Q(KIR,J) = Q(KIR,J) + QS*TDV
               DO 10 L = IRP, N
                  Q(L,J) = Q(L,J) + QS*Q(L,KIR)
   10          CONTINUE
   20       CONTINUE
   30    CONTINUE
   40 CONTINUE
      RETURN
      END
*DECK DOMN
      SUBROUTINE DOMN (N, B, X, NELT, IA, JA, A, ISYM, MATVEC, MSOLVE,
     +   NSAVE, ITOL, TOL, ITMAX, ITER, ERR, IERR, IUNIT, R, Z, P, AP,
     +   EMAP, DZ, CSAV, RWORK, IWORK)
C***BEGIN PROLOGUE  DOMN
C***PURPOSE  Preconditioned Orthomin Sparse Iterative Ax=b Solver.
C            Routine to solve a general linear system  Ax = b  using
C            the Preconditioned Orthomin method.
C***LIBRARY   SLATEC (SLAP)
C***CATEGORY  D2A4, D2B4
C***TYPE      DOUBLE PRECISION (SOMN-S, DOMN-D)
C***KEYWORDS  ITERATIVE PRECONDITION, NON-SYMMETRIC LINEAR SYSTEM,
C             ORTHOMIN, SLAP, SPARSE
C***AUTHOR  Greenbaum, Anne, (Courant Institute)
C           Seager, Mark K., (LLNL)
C             Lawrence Livermore National Laboratory
C             PO BOX 808, L-60
C             Livermore, CA 94550 (510) 423-3141
C             seager@llnl.gov
C***DESCRIPTION
C
C *Usage:
C     INTEGER  N, NELT, IA(NELT), JA(NELT), ISYM, NSAVE, ITOL, ITMAX
C     INTEGER  ITER, IERR, IUNIT, IWORK(USER DEFINED)
C     DOUBLE PRECISION B(N), X(N), A(NELT), TOL, ERR, R(N), Z(N)
C     DOUBLE PRECISION P(N,0:NSAVE), AP(N,0:NSAVE), EMAP(N,0:NSAVE)
C     DOUBLE PRECISION DZ(N), CSAV(NSAVE), RWORK(USER DEFINED)
C     EXTERNAL MATVEC, MSOLVE
C
C     CALL DOMN(N, B, X, NELT, IA, JA, A, ISYM, MATVEC, MSOLVE,
C    $     NSAVE, ITOL, TOL, ITMAX, ITER, ERR, IERR, IUNIT, R,
C    $     Z, P, AP, EMAP, DZ, CSAV, RWORK, IWORK)
C
C *Arguments:
C N      :IN       Integer.
C         Order of the Matrix.
C B      :IN       Double Precision B(N).
C         Right-hand side vector.
C X      :INOUT    Double Precision X(N).
C         On input X is your initial guess for solution vector.
C         On output X is the final approximate solution.
C NELT   :IN       Integer.
C         Number of Non-Zeros stored in A.
C IA     :IN       Integer IA(NELT).
C JA     :IN       Integer JA(NELT).
C A      :IN       Double Precision A(NELT).
C         These arrays contain the matrix data structure for A.
C         It could take any form.  See "Description", below, for more
C         details.
C ISYM   :IN       Integer.
C         Flag to indicate symmetric storage format.
C         If ISYM=0, all non-zero entries of the matrix are stored.
C         If ISYM=1, the matrix is symmetric, and only the upper
C         or lower triangle of the matrix is stored.
C MATVEC :EXT      External.
C         Name of a routine which performs the matrix vector multiply
C         Y = A*X given A and X.  The name of the MATVEC routine must
C         be declared external in the calling program.  The calling
C         sequence to MATVEC is:
C             CALL MATVEC( N, X, Y, NELT, IA, JA, A, ISYM )
C         Where N is the number of unknowns, Y is the product A*X
C         upon return X is an input vector, NELT is the number of
C         non-zeros in the SLAP IA, JA, A storage for the matrix A.
C         ISYM is a flag which, if non-zero, denotest that A is
C         symmetric and only the lower or upper triangle is stored.
C MSOLVE :EXT      External.
C         Name of a routine which solves a linear system MZ = R for
C         Z given R with the preconditioning matrix M (M is supplied via
C         RWORK and IWORK arrays).  The name of the MSOLVE routine must
C         be declared external in the calling program.  The calling
C         sequence to MSOLVE is:
C             CALL MSOLVE(N, R, Z, NELT, IA, JA, A, ISYM, RWORK, IWORK)
C         Where N is the number of unknowns, R is the right-hand side
C         vector and Z is the solution upon return.  NELT, IA, JA, A and
C         ISYM are defined as above.  RWORK is a double precision array
C         that can be used to pass necessary preconditioning information
C         and/or workspace to MSOLVE.  IWORK is an integer work array
C         for the same purpose as RWORK.
C NSAVE  :IN       Integer.
C         Number of  direction vectors to save and orthogonalize
C         against.  NSAVE >= 0.
C ITOL   :IN       Integer.
C         Flag to indicate type of convergence criterion.
C         If ITOL=1, iteration stops when the 2-norm of the residual
C         divided by the 2-norm of the right-hand side is less than TOL.
C         If ITOL=2, iteration stops when the 2-norm of M-inv times the
C         residual divided by the 2-norm of M-inv times the right hand
C         side is less than TOL, where M-inv is the inverse of the
C         diagonal of A.
C         ITOL=11 is often useful for checking and comparing different
C         routines.  For this case, the user must supply the "exact"
C         solution or a very accurate approximation (one with an error
C         much less than TOL) through a common block,
C             COMMON /DSLBLK/ SOLN( )
C         If ITOL=11, iteration stops when the 2-norm of the difference
C         between the iterative approximation and the user-supplied
C         solution divided by the 2-norm of the user-supplied solution
C         is less than TOL.  Note that this requires the user to set up
C         the "COMMON /DSLBLK/ SOLN(LENGTH)" in the calling routine.
C         The routine with this declaration should be loaded before the
C         stop test so that the correct length is used by the loader.
C         This procedure is not standard Fortran and may not work
C         correctly on your system (although it has worked on every
C         system the authors have tried).  If ITOL is not 11 then this
C         common block is indeed standard Fortran.
C TOL    :INOUT    Double Precision.
C         Convergence criterion, as described above.  (Reset if IERR=4.)
C ITMAX  :IN       Integer.
C         Maximum number of iterations.
C ITER   :OUT      Integer.
C         Number of iterations required to reach convergence, or
C         ITMAX+1 if convergence criterion could not be achieved in
C         ITMAX iterations.
C ERR    :OUT      Double Precision.
C         Error estimate of error in final approximate solution, as
C         defined by ITOL.
C IERR   :OUT      Integer.
C         Return error flag.
C           IERR = 0 => All went well.
C           IERR = 1 => Insufficient space allocated for WORK or IWORK.
C           IERR = 2 => Method failed to converge in ITMAX steps.
C           IERR = 3 => Error in user input.
C                       Check input values of N, ITOL.
C           IERR = 4 => User error tolerance set too tight.
C                       Reset to 500*D1MACH(3).  Iteration proceeded.
C           IERR = 5 => Preconditioning matrix, M, is not positive
C                       definite.  (r,z) < 0.
C           IERR = 6 => Breakdown of method detected.
C                       (p,Ap) < epsilon**2.
C IUNIT  :IN       Integer.
C         Unit number on which to write the error at each iteration,
C         if this is desired for monitoring convergence.  If unit
C         number is 0, no writing will occur.
C R      :WORK     Double Precision R(N).
C Z      :WORK     Double Precision Z(N).
C P      :WORK     Double Precision P(N,0:NSAVE).
C AP     :WORK     Double Precision AP(N,0:NSAVE).
C EMAP   :WORK     Double Precision EMAP(N,0:NSAVE).
C DZ     :WORK     Double Precision DZ(N).
C CSAV   :WORK     Double Precision CSAV(NSAVE)
C         Double Precision arrays used for workspace.
C RWORK  :WORK     Double Precision RWORK(USER DEFINED).
C         Double Precision array that can be used for workspace in
C         MSOLVE.
C IWORK  :WORK     Integer IWORK(USER DEFINED).
C         Integer array that can be used for workspace in MSOLVE.
C
C *Description
C       This routine does  not care  what matrix data   structure is
C       used for  A and M.  It simply   calls  the MATVEC and MSOLVE
C       routines, with  the arguments as  described above.  The user
C       could write any type of structure and the appropriate MATVEC
C       and MSOLVE routines.  It is assumed  that A is stored in the
C       IA, JA, A  arrays in some fashion and  that M (or INV(M)) is
C       stored  in  IWORK  and  RWORK)  in  some fashion.   The SLAP
C       routines DSDOMN and DSLUOM are examples of this procedure.
C
C       Two  examples  of  matrix  data structures  are the: 1) SLAP
C       Triad  format and 2) SLAP Column format.
C
C       =================== S L A P Triad format ===================
C       In  this   format only the  non-zeros are  stored.  They may
C       appear  in *ANY* order.   The user  supplies three arrays of
C       length NELT, where  NELT  is the number  of non-zeros in the
C       matrix:  (IA(NELT), JA(NELT),  A(NELT)).  For each  non-zero
C       the  user puts   the row  and  column index   of that matrix
C       element in the IA and JA arrays.  The  value of the non-zero
C       matrix  element is  placed in  the corresponding location of
C       the A  array.  This is  an extremely easy data  structure to
C       generate.  On  the other hand it  is  not too  efficient  on
C       vector  computers   for the  iterative  solution  of  linear
C       systems.  Hence, SLAP  changes this input  data structure to
C       the SLAP   Column  format for the  iteration (but   does not
C       change it back).
C
C       Here is an example of the  SLAP Triad   storage format for a
C       5x5 Matrix.  Recall that the entries may appear in any order.
C
C           5x5 Matrix      SLAP Triad format for 5x5 matrix on left.
C                              1  2  3  4  5  6  7  8  9 10 11
C       |11 12  0  0 15|   A: 51 12 11 33 15 53 55 22 35 44 21
C       |21 22  0  0  0|  IA:  5  1  1  3  1  5  5  2  3  4  2
C       | 0  0 33  0 35|  JA:  1  2  1  3  5  3  5  2  5  4  1
C       | 0  0  0 44  0|
C       |51  0 53  0 55|
C
C       =================== S L A P Column format ==================
C
C       In  this format   the non-zeros are    stored counting  down
C       columns (except  for the diagonal  entry, which must  appear
C       first  in each "column") and are  stored in the  double pre-
C       cision array  A. In  other  words,  for each  column  in the
C       matrix  first put  the diagonal entry in A.  Then put in the
C       other non-zero  elements going  down the column  (except the
C       diagonal)  in order.  The IA array  holds the  row index for
C       each non-zero.  The JA array  holds the offsets into the IA,
C       A  arrays  for  the  beginning  of  each  column.  That  is,
C       IA(JA(ICOL)),A(JA(ICOL)) are the first elements of the ICOL-
C       th column in IA and A, and IA(JA(ICOL+1)-1), A(JA(ICOL+1)-1)
C       are  the last elements of the ICOL-th column.   Note that we
C       always have JA(N+1)=NELT+1, where N is the number of columns
C       in the matrix  and NELT  is the number  of non-zeros  in the
C       matrix.
C
C       Here is an example of the  SLAP Column  storage format for a
C       5x5 Matrix (in the A and IA arrays '|'  denotes the end of a
C       column):
C
C           5x5 Matrix      SLAP Column format for 5x5 matrix on left.
C                              1  2  3    4  5    6  7    8    9 10 11
C       |11 12  0  0 15|   A: 11 21 51 | 22 12 | 33 53 | 44 | 55 15 35
C       |21 22  0  0  0|  IA:  1  2  5 |  2  1 |  3  5 |  4 |  5  1  3
C       | 0  0 33  0 35|  JA:  1  4  6    8  9   12
C       | 0  0  0 44  0|
C       |51  0 53  0 55|
C
C *Cautions:
C     This routine will attempt to write to the Fortran logical output
C     unit IUNIT, if IUNIT .ne. 0.  Thus, the user must make sure that
C     this logical unit is attached to a file or terminal before calling
C     this routine with a non-zero value for IUNIT.  This routine does
C     not check for the validity of a non-zero IUNIT unit number.
C
C***SEE ALSO  DSDOMN, DSLUOM, ISDOMN
C***REFERENCES  1. Mark K. Seager, A SLAP for the Masses, in
C                  G. F. Carey, Ed., Parallel Supercomputing: Methods,
C                  Algorithms and Applications, Wiley, 1989, pp.135-155.
C***ROUTINES CALLED  D1MACH, DAXPY, DCOPY, DDOT, ISDOMN
C***REVISION HISTORY  (YYMMDD)
C   890404  DATE WRITTEN
C   890404  Previous REVISION DATE
C   890915  Made changes requested at July 1989 CML Meeting.  (MKS)
C   890922  Numerous changes to prologue to make closer to SLATEC
C           standard.  (FNF)
C   890929  Numerous changes to reduce SP/DP differences.  (FNF)
C   891004  Added new reference.
C   910411  Prologue converted to Version 4.0 format.  (BAB)
C   910502  Removed MATVEC and MSOLVE from ROUTINES CALLED list.  (FNF)
C   920407  COMMON BLOCK renamed DSLBLK.  (WRB)
C   920511  Added complete declaration section.  (WRB)
C   920929  Corrected format of reference.  (FNF)
C   921019  Changed 500.0 to 500 to reduce SP/DP differences.  (FNF)
C   921113  Corrected C***CATEGORY line.  (FNF)
C   930326  Removed unused variable.  (FNF)
C***END PROLOGUE  DOMN
C     .. Scalar Arguments ..
      DOUBLE PRECISION ERR, TOL
      INTEGER IERR, ISYM, ITER, ITMAX, ITOL, IUNIT, N, NELT, NSAVE
C     .. Array Arguments ..
      DOUBLE PRECISION A(NELT), AP(N,0:NSAVE), B(N), CSAV(NSAVE),
     +                 DZ(N), EMAP(N,0:NSAVE), P(N,0:NSAVE), R(N),
     +                 RWORK(*), X(N), Z(N)
      INTEGER IA(NELT), IWORK(*), JA(NELT)
C     .. Subroutine Arguments ..
      EXTERNAL MATVEC, MSOLVE
C     .. Local Scalars ..
      DOUBLE PRECISION AK, AKDEN, AKNUM, BKL, BNRM, FUZZ, SOLNRM
      INTEGER I, IP, IPO, K, L, LMAX
C     .. External Functions ..
      DOUBLE PRECISION D1MACH, DDOT
      INTEGER ISDOMN
      EXTERNAL D1MACH, DDOT, ISDOMN
C     .. External Subroutines ..
      EXTERNAL DAXPY, DCOPY
C     .. Intrinsic Functions ..
      INTRINSIC ABS, MIN, MOD
C***FIRST EXECUTABLE STATEMENT  DOMN
C
C         Check some of the input data.
C
      ITER = 0
      IERR = 0
      IF( N.LT.1 ) THEN
         IERR = 3
         RETURN
      ENDIF
      FUZZ = D1MACH(3)
      IF( TOL.LT.500*FUZZ ) THEN
         TOL = 500*FUZZ
         IERR = 4
      ENDIF
      FUZZ = FUZZ*FUZZ
C
C         Calculate initial residual and pseudo-residual, and check
C         stopping criterion.
      CALL MATVEC(N, X, R, NELT, IA, JA, A, ISYM)
      DO 10 I = 1, N
         R(I)  = B(I) - R(I)
 10   CONTINUE
      CALL MSOLVE(N, R, Z, NELT, IA, JA, A, ISYM, RWORK, IWORK)
C
      IF( ISDOMN(N, B, X, NELT, IA, JA, A, ISYM, MSOLVE, NSAVE,
     $     ITOL, TOL, ITMAX, ITER, ERR, IERR, IUNIT,
     $     R, Z, P, AP, EMAP, DZ, CSAV,
     $     RWORK, IWORK, AK, BNRM, SOLNRM) .NE. 0 ) GO TO 200
      IF( IERR.NE.0 ) RETURN
C
C
C         ***** iteration loop *****
C
CVD$R NOVECTOR
CVD$R NOCONCUR
      DO 100 K = 1, ITMAX
         ITER = K
         IP = MOD( ITER-1, NSAVE+1 )
C
C         calculate direction vector p, a*p, and (m-inv)*a*p,
C         and save if desired.
         CALL DCOPY(N, Z, 1, P(1,IP), 1)
         CALL MATVEC(N, P(1,IP), AP(1,IP), NELT, IA, JA, A, ISYM)
         CALL MSOLVE(N, AP(1,IP), EMAP(1,IP), NELT, IA, JA, A, ISYM,
     $        RWORK, IWORK)
         IF( NSAVE.EQ.0 ) THEN
            AKDEN = DDOT(N, EMAP, 1, EMAP, 1)
         ELSE
            IF( ITER.GT.1 ) THEN
               LMAX = MIN( NSAVE, ITER-1 )
               DO 20 L = 1, LMAX
                  IPO = MOD(IP+(NSAVE+1-L),NSAVE+1)
                  BKL = DDOT(N, EMAP(1,IP), 1, EMAP(1,IPO), 1)
                  BKL = BKL*CSAV(L)
                  CALL DAXPY(N, -BKL,    P(1,IPO), 1,    P(1,IP), 1)
                  CALL DAXPY(N, -BKL,   AP(1,IPO), 1,   AP(1,IP), 1)
                  CALL DAXPY(N, -BKL, EMAP(1,IPO), 1, EMAP(1,IP), 1)
 20            CONTINUE
               IF( NSAVE.GT.1 ) THEN
                  DO 30 L = NSAVE-1, 1, -1
                     CSAV(L+1) = CSAV(L)
 30               CONTINUE
               ENDIF
            ENDIF
            AKDEN = DDOT(N, EMAP(1,IP), 1, EMAP(1,IP), 1)
            IF( ABS(AKDEN).LT.FUZZ ) THEN
               IERR = 6
               RETURN
            ENDIF
            CSAV(1) = 1.0D0/AKDEN
C
C         calculate coefficient ak, new iterate x, new residual r, and
C         new pseudo-residual z.
         ENDIF
         AKNUM = DDOT(N, Z, 1, EMAP(1,IP), 1)
         AK = AKNUM/AKDEN
         CALL DAXPY(N,  AK,    P(1,IP), 1, X, 1)
         CALL DAXPY(N, -AK,   AP(1,IP), 1, R, 1)
         CALL DAXPY(N, -AK, EMAP(1,IP), 1, Z, 1)
C
C         check stopping criterion.
         IF( ISDOMN(N, B, X, NELT, IA, JA, A, ISYM, MSOLVE, NSAVE,
     $        ITOL, TOL, ITMAX, ITER, ERR, IERR, IUNIT,
     $        R, Z, P, AP, EMAP, DZ, CSAV,
     $        RWORK, IWORK, AK, BNRM, SOLNRM) .NE. 0 ) GO TO 200
C
 100  CONTINUE
C
C         *****   end of loop  *****
C
C         Stopping criterion not satisfied.
      ITER = ITMAX + 1
      IERR = 2
C
 200  RETURN
C------------- LAST LINE OF DOMN FOLLOWS ----------------------------
      END
*DECK DORTH
      SUBROUTINE DORTH (VNEW, V, HES, N, LL, LDHES, KMP, SNORMW)
C***BEGIN PROLOGUE  DORTH
C***SUBSIDIARY
C***PURPOSE  Internal routine for DGMRES.
C***LIBRARY   SLATEC (SLAP)
C***CATEGORY  D2A4, D2B4
C***TYPE      DOUBLE PRECISION (SORTH-S, DORTH-D)
C***KEYWORDS  GENERALIZED MINIMUM RESIDUAL, ITERATIVE PRECONDITION,
C             NON-SYMMETRIC LINEAR SYSTEM, SLAP, SPARSE
C***AUTHOR  Brown, Peter, (LLNL), pnbrown@llnl.gov
C           Hindmarsh, Alan, (LLNL), alanh@llnl.gov
C           Seager, Mark K., (LLNL), seager@llnl.gov
C             Lawrence Livermore National Laboratory
C             PO Box 808, L-60
C             Livermore, CA 94550 (510) 423-3141
C***DESCRIPTION
C        This routine  orthogonalizes  the  vector  VNEW  against the
C        previous KMP  vectors in the   V array.  It uses  a modified
C        Gram-Schmidt   orthogonalization procedure with  conditional
C        reorthogonalization.
C
C *Usage:
C      INTEGER N, LL, LDHES, KMP
C      DOUBLE PRECISION VNEW(N), V(N,LL), HES(LDHES,LL), SNORMW
C
C      CALL DORTH(VNEW, V, HES, N, LL, LDHES, KMP, SNORMW)
C
C *Arguments:
C VNEW   :INOUT    Double Precision VNEW(N)
C         On input, the vector of length N containing a scaled
C         product of the Jacobian and the vector V(*,LL).
C         On output, the new vector orthogonal to V(*,i0) to V(*,LL),
C         where i0 = max(1, LL-KMP+1).
C V      :IN       Double Precision V(N,LL)
C         The N x LL array containing the previous LL
C         orthogonal vectors V(*,1) to V(*,LL).
C HES    :INOUT    Double Precision HES(LDHES,LL)
C         On input, an LL x LL upper Hessenberg matrix containing,
C         in HES(I,K), K.lt.LL, the scaled inner products of
C         A*V(*,K) and V(*,i).
C         On return, column LL of HES is filled in with
C         the scaled inner products of A*V(*,LL) and V(*,i).
C N      :IN       Integer
C         The order of the matrix A, and the length of VNEW.
C LL     :IN       Integer
C         The current order of the matrix HES.
C LDHES  :IN       Integer
C         The leading dimension of the HES array.
C KMP    :IN       Integer
C         The number of previous vectors the new vector VNEW
C         must be made orthogonal to (KMP .le. MAXL).
C SNORMW :OUT      DOUBLE PRECISION
C         Scalar containing the l-2 norm of VNEW.
C
C***SEE ALSO  DGMRES
C***ROUTINES CALLED  DAXPY, DDOT, DNRM2
C***REVISION HISTORY  (YYMMDD)
C   890404  DATE WRITTEN
C   890404  Previous REVISION DATE
C   890915  Made changes requested at July 1989 CML Meeting.  (MKS)
C   890922  Numerous changes to prologue to make closer to SLATEC
C           standard.  (FNF)
C   890929  Numerous changes to reduce SP/DP differences.  (FNF)
C   910411  Prologue converted to Version 4.0 format.  (BAB)
C   910506  Made subsidiary to DGMRES.  (FNF)
C   920511  Added complete declaration section.  (WRB)
C***END PROLOGUE  DORTH
C         The following is for optimized compilation on LLNL/LTSS Crays.
CLLL. OPTIMIZE
C     .. Scalar Arguments ..
      DOUBLE PRECISION SNORMW
      INTEGER KMP, LDHES, LL, N
C     .. Array Arguments ..
      DOUBLE PRECISION HES(LDHES,*), V(N,*), VNEW(*)
C     .. Local Scalars ..
      DOUBLE PRECISION ARG, SUMDSQ, TEM, VNRM
      INTEGER I, I0
C     .. External Functions ..
      DOUBLE PRECISION DDOT, DNRM2
      EXTERNAL DDOT, DNRM2
C     .. External Subroutines ..
      EXTERNAL DAXPY
C     .. Intrinsic Functions ..
      INTRINSIC MAX, SQRT
C***FIRST EXECUTABLE STATEMENT  DORTH
C
C         Get norm of unaltered VNEW for later use.
C
      VNRM = DNRM2(N, VNEW, 1)
C   -------------------------------------------------------------------
C         Perform the modified Gram-Schmidt procedure on VNEW =A*V(LL).
C         Scaled inner products give new column of HES.
C         Projections of earlier vectors are subtracted from VNEW.
C   -------------------------------------------------------------------
      I0 = MAX(1,LL-KMP+1)
      DO 10 I = I0,LL
         HES(I,LL) = DDOT(N, V(1,I), 1, VNEW, 1)
         TEM = -HES(I,LL)
         CALL DAXPY(N, TEM, V(1,I), 1, VNEW, 1)
 10   CONTINUE
C   -------------------------------------------------------------------
C         Compute SNORMW = norm of VNEW.  If VNEW is small compared
C         to its input value (in norm), then reorthogonalize VNEW to
C         V(*,1) through V(*,LL).  Correct if relative correction
C         exceeds 1000*(unit roundoff).  Finally, correct SNORMW using
C         the dot products involved.
C   -------------------------------------------------------------------
      SNORMW = DNRM2(N, VNEW, 1)
      IF (VNRM + 0.001D0*SNORMW .NE. VNRM) RETURN
      SUMDSQ = 0
      DO 30 I = I0,LL
         TEM = -DDOT(N, V(1,I), 1, VNEW, 1)
         IF (HES(I,LL) + 0.001D0*TEM .EQ. HES(I,LL)) GO TO 30
         HES(I,LL) = HES(I,LL) - TEM
         CALL DAXPY(N, TEM, V(1,I), 1, VNEW, 1)
         SUMDSQ = SUMDSQ + TEM**2
 30   CONTINUE
      IF (SUMDSQ .EQ. 0.0D0) RETURN
      ARG = MAX(0.0D0,SNORMW**2 - SUMDSQ)
      SNORMW = SQRT(ARG)
C
      RETURN
C------------- LAST LINE OF DORTH FOLLOWS ----------------------------
      END
*DECK DORTHR
      SUBROUTINE DORTHR (A, N, M, NRDA, IFLAG, IRANK, ISCALE, DIAG,
     +   KPIVOT, SCALES, ROWS, RS)
C***BEGIN PROLOGUE  DORTHR
C***SUBSIDIARY
C***PURPOSE  Subsidiary to DBVSUP and DSUDS
C***LIBRARY   SLATEC
C***TYPE      DOUBLE PRECISION (ORTHOR-S, DORTHR-D)
C***AUTHOR  Watts, H. A., (SNLA)
C***DESCRIPTION
C
C   Reduction of the matrix A to lower triangular form by a sequence of
C   orthogonal HOUSEHOLDER transformations post-multiplying A.
C
C *********************************************************************
C   INPUT
C *********************************************************************
C
C     A -- Contains the matrix to be decomposed, must be dimensioned
C           NRDA by N.
C     N -- Number of rows in the matrix, N greater or equal to 1.
C     M -- Number of columns in the matrix, M greater or equal to N.
C     IFLAG -- Indicates the uncertainty in the matrix data.
C             = 0 when the data is to be treated as exact.
C             =-K when the data is assumed to be accurate to about
C                 K digits.
C     ISCALE -- Scaling indicator.
C               =-1 if the matrix is to be pre-scaled by
C               columns when appropriate.
C               Otherwise no scaling will be attempted.
C     NRDA -- Row dimension of A, NRDA greater or equal to N.
C     DIAG,KPIVOT,ROWS, -- Arrays of length at least N used internally
C          RS,SCALES         (except for SCALES which is M).
C
C *********************************************************************
C   OUTPUT
C *********************************************************************
C
C     IFLAG - Status indicator
C            =1 for successful decomposition.
C            =2 if improper input is detected.
C            =3 if rank of the matrix is less than N.
C     A -- Contains the reduced matrix in the strictly lower triangular
C          part and transformation information.
C     IRANK -- Contains the numerically determined matrix rank.
C     DIAG -- Contains the diagonal elements of the reduced
C             triangular matrix.
C     KPIVOT -- Contains the pivotal information, the column
C               interchanges performed on the original matrix are
C               recorded here.
C     SCALES -- Contains the column scaling parameters.
C
C *********************************************************************
C
C***SEE ALSO  DBVSUP, DSUDS
C***REFERENCES  G. Golub, Numerical methods for solving linear least
C                 squares problems, Numerische Mathematik 7, (1965),
C                 pp. 206-216.
C               P. Businger and G. Golub, Linear least squares
C                 solutions by Householder transformations, Numerische
C                 Mathematik  7, (1965), pp. 269-276.
C***ROUTINES CALLED  D1MACH, DCSCAL, DDOT, XERMSG
C***REVISION HISTORY  (YYMMDD)
C   750601  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900315  CALLs to XERROR changed to CALLs to XERMSG.  (THJ)
C   900328  Added TYPE section.  (WRB)
C   910408  Updated the AUTHOR and REFERENCES sections.  (WRB)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  DORTHR
      DOUBLE PRECISION DDOT, D1MACH
      INTEGER IFLAG, IRANK, ISCALE, J, JROW, K, KP, KPIVOT(*), L, M,
     1     MK, N, NRDA
      DOUBLE PRECISION A(NRDA,*), ACC, AKK, ANORM, AS, ASAVE, DIAG(*),
     1     DIAGK, DUM, ROWS(*), RS(*), RSS, SAD, SCALES(*), SIG, SIGMA,
     2     SRURO, URO
C
C     ******************************************************************
C
C          MACHINE PRECISION (COMPUTER UNIT ROUNDOFF VALUE) IS DEFINED
C          BY THE FUNCTION D1MACH.
C
C     ******************************************************************
C
C***FIRST EXECUTABLE STATEMENT  DORTHR
      URO = D1MACH(4)
      IF (M .GE. N .AND. N .GE. 1 .AND. NRDA .GE. N) GO TO 10
         IFLAG = 2
         CALL XERMSG ('SLATEC', 'DORTHR', 'INVALID INPUT PARAMETERS.',
     +      2, 1)
      GO TO 150
   10 CONTINUE
C
         ACC = 10.0D0*URO
         IF (IFLAG .LT. 0) ACC = MAX(ACC,10.0D0**IFLAG)
         SRURO = SQRT(URO)
         IFLAG = 1
         IRANK = N
C
C        COMPUTE NORM**2 OF JTH ROW AND A MATRIX NORM
C
         ANORM = 0.0D0
         DO 20 J = 1, N
            KPIVOT(J) = J
            ROWS(J) = DDOT(M,A(J,1),NRDA,A(J,1),NRDA)
            RS(J) = ROWS(J)
            ANORM = ANORM + ROWS(J)
   20    CONTINUE
C
C        PERFORM COLUMN SCALING ON A WHEN SPECIFIED
C
         CALL DCSCAL(A,NRDA,N,M,SCALES,DUM,ROWS,RS,ANORM,SCALES,ISCALE,
     1               1)
C
         ANORM = SQRT(ANORM)
C
C
C        CONSTRUCTION OF LOWER TRIANGULAR MATRIX AND RECORDING OF
C        ORTHOGONAL TRANSFORMATIONS
C
C
         DO 130 K = 1, N
C           BEGIN BLOCK PERMITTING ...EXITS TO 80
               MK = M - K + 1
C           ...EXIT
               IF (K .EQ. N) GO TO 80
               KP = K + 1
C
C              SEARCHING FOR PIVOTAL ROW
C
               DO 60 J = K, N
C                 BEGIN BLOCK PERMITTING ...EXITS TO 50
                     IF (ROWS(J) .GE. SRURO*RS(J)) GO TO 30
                        ROWS(J) = DDOT(MK,A(J,K),NRDA,A(J,K),NRDA)
                        RS(J) = ROWS(J)
   30                CONTINUE
                     IF (J .EQ. K) GO TO 40
C                 ......EXIT
                        IF (SIGMA .GE. 0.99D0*ROWS(J)) GO TO 50
   40                CONTINUE
                     SIGMA = ROWS(J)
                     JROW = J
   50             CONTINUE
   60          CONTINUE
C           ...EXIT
               IF (JROW .EQ. K) GO TO 80
C
C              PERFORM ROW INTERCHANGE
C
               L = KPIVOT(K)
               KPIVOT(K) = KPIVOT(JROW)
               KPIVOT(JROW) = L
               ROWS(JROW) = ROWS(K)
               ROWS(K) = SIGMA
               RSS = RS(K)
               RS(K) = RS(JROW)
               RS(JROW) = RSS
               DO 70 L = 1, M
                  ASAVE = A(K,L)
                  A(K,L) = A(JROW,L)
                  A(JROW,L) = ASAVE
   70          CONTINUE
   80       CONTINUE
C
C           CHECK RANK OF THE MATRIX
C
            SIG = DDOT(MK,A(K,K),NRDA,A(K,K),NRDA)
            DIAGK = SQRT(SIG)
            IF (DIAGK .GT. ACC*ANORM) GO TO 90
C
C              RANK DEFICIENT PROBLEM
               IFLAG = 3
               IRANK = K - 1
               CALL XERMSG ('SLATEC', 'DORTHR',
     +            'RANK OF MATRIX IS LESS THAN THE NUMBER OF ROWS.', 1,
     +            1)
C        ......EXIT
               GO TO 140
   90       CONTINUE
C
C           CONSTRUCT AND APPLY TRANSFORMATION TO MATRIX A
C
            AKK = A(K,K)
            IF (AKK .GT. 0.0D0) DIAGK = -DIAGK
            DIAG(K) = DIAGK
            A(K,K) = AKK - DIAGK
            IF (K .EQ. N) GO TO 120
               SAD = DIAGK*AKK - SIG
               DO 110 J = KP, N
                  AS = DDOT(MK,A(K,K),NRDA,A(J,K),NRDA)/SAD
                  DO 100 L = K, M
                     A(J,L) = A(J,L) + AS*A(K,L)
  100             CONTINUE
                  ROWS(J) = ROWS(J) - A(J,K)**2
  110          CONTINUE
  120       CONTINUE
  130    CONTINUE
  140    CONTINUE
  150 CONTINUE
C
C
      RETURN
      END

module gfits_interfaces_private
  interface
    subroutine vai4ie (inpu,oupu,ni)
      !---------------------------------------------------------------------
      ! @ private
      ! Simple copy: vax and swapped IEEE I4 are identical. Provided for
      ! generality
      !---------------------------------------------------------------------
      integer(kind=4) :: ni        ! Number of items
      integer(kind=4) :: inpu(ni)  ! Input array
      integer(kind=4) :: oupu(ni)  ! Output array
    end subroutine vai4ie
  end interface
  !
  interface
    subroutine vai4ie_sl (inpu,oupu,ni)
      use gildas_def
      !---------------------------------------------------------------------
      ! @ private
      ! Simple copy: vax and swapped IEEE I4 are identical. Provided for
      ! generality
      !---------------------------------------------------------------------
      integer(kind=size_length) :: ni        ! Number of items
      integer(kind=4) :: inpu(ni)  ! Input array
      integer(kind=4) :: oupu(ni)  ! Output array
    end subroutine vai4ie_sl
  end interface
  !
  interface
    subroutine gfits_skip_hdu(fd,ihdu,list,error)
      use gildas_def
      use gbl_message
      use gfits_types
      !---------------------------------------------------------------------
      ! @ private
      ! Skip entirely the current HDU. Optionaly list its contents.
      !---------------------------------------------------------------------
      type(gfits_hdesc_t), intent(inout) :: fd     !
      integer(kind=4),     intent(in)    :: ihdu   ! HDU we are skipping (1=Primary)
      logical,             intent(in)    :: list   !
      logical,             intent(inout) :: error  ! Error flag
    end subroutine gfits_skip_hdu
  end interface
  !
  interface
    subroutine gfits_setsort(fh,error)
      use gfits_types
      !---------------------------------------------------------------------
      ! @ private
      !  Compute the sorting list of the input fits header (fh%sort)
      !  Remark: fh%sort() must contain the unsorted elements before
      ! entering gi0_quicksort_index_with_user_gtge. It can be partially
      ! sorted, or not at all, this will work.
      !---------------------------------------------------------------------
      type(gfits_hdict_t), intent(inout) :: fh
      logical,             intent(inout) :: error
    end subroutine gfits_setsort
  end interface
  !
  interface
    subroutine gfits_find_value(fh,key,found,value,error)
      use gfits_types
      !---------------------------------------------------------------------
      ! @ private
      ! Get the value in the dictionary from the given key. Output is the
      ! raw character string (not evaluated).
      !---------------------------------------------------------------------
      type(gfits_hdict_t), intent(in)    :: fh
      character(len=*),    intent(in)    :: key
      logical,             intent(out)   :: found
      character(len=*),    intent(out)   :: value
      logical,             intent(inout) :: error
    end subroutine gfits_find_value
  end interface
  !
  interface
    subroutine gfits_putrec(buff,error)
      use gfits_buf
      use gbl_message
      !---------------------------------------------------------------------
      ! @ private
      ! Write one logical FITS record
      !---------------------------------------------------------------------
      integer(kind=1), intent(in)    :: buff(2880)  ! I/O buffer
      logical,         intent(inout) :: error       ! Error flag
    end subroutine gfits_putrec
  end interface
  !
  interface
    subroutine gfits_getrec(buff,error)
      !---------------------------------------------------------------------
      ! @ private
      ! Read one logical FITS record (verbose mode)
      !---------------------------------------------------------------------
      integer(kind=1), intent(out)   :: buff(2880)  ! I/O buffer
      logical,         intent(inout) :: error       ! Error flag
    end subroutine gfits_getrec
  end interface
  !
  interface
    subroutine fgetrecquiet(buff,error,eof)
      !---------------------------------------------------------------------
      ! @ private
      ! Read one logical FITS record (quiet mode)
      !---------------------------------------------------------------------
      integer(kind=1), intent(out)   :: buff(2880)  ! I/O buffer
      logical,         intent(inout) :: error       ! Error flag
      logical,         intent(out)   :: eof         ! End of file flag
    end subroutine fgetrecquiet
  end interface
  !
  interface
    subroutine fgetrec_sub(buff,error,eof,quiet)
      use gfits_buf
      use gbl_message
      !---------------------------------------------------------------------
      ! @ private
      ! FITS  Internal routine
      !       Read one logical FITS record
      !---------------------------------------------------------------------
      integer(kind=1), intent(out)   :: buff(2880)  ! I/O buffer
      logical,         intent(inout) :: error       ! Error flag
      logical,         intent(out)   :: eof         ! End of file flag
      logical,         intent(in)    :: quiet       ! Verbosity flag
    end subroutine fgetrec_sub
  end interface
  !
  interface
    subroutine fseefilepos()
      use gildas_def
      use gfits_buf
      use gbl_message
      !---------------------------------------------------------------------
      ! @ private
      ! Used while debugging.
      !---------------------------------------------------------------------
    end subroutine fseefilepos
  end interface
  !
  interface
    subroutine gfits_message(mkind,procname,message)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ private
      ! Messaging facility for the current library. Calls the low-level
      ! (internal) messaging routine with its own identifier.
      !---------------------------------------------------------------------
      integer,          intent(in) :: mkind     ! Message kind
      character(len=*), intent(in) :: procname  ! Name of calling procedure
      character(len=*), intent(in) :: message   ! Message string
    end subroutine gfits_message
  end interface
  !
  interface
    subroutine ieee64_to_dble (ieee64,ni,map,ndata,nfill,bscal,bzero,bval)
      use gildas_def
      !---------------------------------------------------------------------
      ! @ private
      ! Convert 8-bytes floating point numbers to native format (double
      ! precision).
      !---------------------------------------------------------------------
      real(kind=8),              intent(in)    :: ieee64(*)   ! Input buffer in IEEE format
      integer(kind=size_length), intent(in)    :: ni          ! Buffer size
      integer(kind=size_length), intent(in)    :: ndata       ! Output array size
      real(kind=8),              intent(out)   :: map(ndata)  ! Output array
      integer(kind=size_length), intent(inout) :: nfill       ! Counter in output array
      real(kind=8),              intent(in)    :: bscal       ! Scaling factor
      real(kind=8),              intent(in)    :: bzero       ! Offset
      real(kind=8),              intent(in)    :: bval        ! Blanking value
    end subroutine ieee64_to_dble
  end interface
  !
  interface
    subroutine dble_to_ieee64 (ieee64,ni,map,ndata,nfill,bval,eval)
      use gildas_def
      !---------------------------------------------------------------------
      ! @ private
      ! Blanking values are NOT correctly translated to a NaN in present
      ! version. This must be fixed before floating FITS can be routinely
      ! written!!!
      !---------------------------------------------------------------------
      real(kind=8),              intent(out)   :: ieee64(*)   ! Output buffer in IEEE format
      integer(kind=size_length), intent(in)    :: ni          ! Buffer size
      integer(kind=size_length), intent(in)    :: ndata       ! Input array size
      real(kind=8),              intent(in)    :: map(ndata)  ! Input array
      integer(kind=size_length), intent(inout) :: nfill       ! Counter in output array
      real(kind=8),              intent(in)    :: bval        ! Blanking value
      real(kind=8),              intent(in)    :: eval        ! Blanking tolerance
    end subroutine dble_to_ieee64
  end interface
  !
end module gfits_interfaces_private

module plait_common
  integer(kind=4), parameter :: sp=4
  integer(kind=4), parameter :: dp=8
  character(len=*), parameter :: rname = 'PLAIT'
  real(kind=sp), parameter :: wfunc_thres = 1.e-3_sp
end module plait_common
!
subroutine plait_comm(line,comm,error)
  use image_def
  use gkernel_interfaces
  use gbl_message
  use imager_interfaces, only : map_message
  !--------------------------------------------------------------------
  !*
  ! IMAGER -- Support for PLAIT command  
  ! PLAIT Output In1 Angle1 Length1 In2 Angle2 Length2 ...
  !
  ! Elaborated on original ideas from Ch. Nieten, 
  !   see https://articles.adsabs.harvard.edu/pdf/2000ASPC..217...72N
  ! and the NOD2 package, namely the "Basket Weaving" technique described
  ! in Emerson & Graeve 1988, 
  !   see https://articles.adsabs.harvard.edu/pdf/1988A%26A...190..353E.
  !
  ! Initial coding P. Hily-Blant feb-2005  
  ! Documented and Cleaned    Stéphane Guilloteau May-2023
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: line  !! Command line
  character(len=*), intent(in) :: comm  !! Command name
  logical :: error                      !! Logical error flag
  !
  integer(kind=4), parameter :: mmap=5
  !
  ! Local ---
  type(gildas) :: cin(mmap)
  type(gildas) :: cout 
  real :: thres(2)
  real :: theta(mmap)
  real :: length(mmap)
  logical :: dump
  integer :: i, nmap, narg, n
  !
  ! Code ----
  narg = sic_narg(0)
  if (mod(narg,3).ne.1) then
    call map_message(seve%e,comm,'Invalid number of arguments')
    error = .true.
    return
  endif
  if (narg.lt.7) then
    call map_message(seve%e,comm,'Insufficient number of arguments')
    error = .true.
    return
  endif
  if (narg.gt.3*mmap+1) then
    call map_message(seve%e,comm,'Too many arguments')
    error = .true.
    return
  endif
  !
  nmap = (narg-1)/3
  !
  call gildas_null(cout)
  !
  call sic_ch(line,0,1,cout%file,n,.true.,error)
  if (error) return
  !
  do i=1,nmap 
    call gildas_null(cin(i))
    call sic_ch(line,0,3*i-1,cin(i)%file,n,.true.,error)
    if (error) return
    call sic_r4(line,0,3*i,theta(i),.true.,error)
    if (error) return
    call sic_r4(line,0,3*i+1,length(i),.true.,error)
  enddo
  thres = 0.0 ! No cutoff ?
  dump = .false.
  call sic_get_logi('DUMP',dump,error)
  call plait_routine(nmap,cin,cout,theta,length,thres,dump,error)
contains
!
subroutine plait_check(next,prev,error)
  use plait_common
  use image_def
  !---------------------------------------------------------------------
  !! IMAGER -- PLAIT --  Check that input cubes have identical dimensions
  !---------------------------------------------------------------------
  type(gildas), intent(in) :: prev    !! First cube header
  type(gildas), intent(in) :: next    !! Second cube header
  logical,      intent(out) :: error  !! Logical error flag
  !
  error = .false.
  if (next%gil%ndim.ne.prev%gil%ndim) then
    error = .true.
    return
  endif
  if (.not.all(next%gil%dim.eq.prev%gil%dim)) then
    error = .true.
  endif
end subroutine plait_check
!
function plait_wfunc(r,width)
  use plait_common
  use phys_const
  !---------------------------------------------------------------------
  !! IMAGER -- PLAIT -- Weighting function
  !---------------------------------------------------------------------
  real(kind=sp) :: plait_wfunc
  real(kind=sp), intent(in) :: r        !! Current distance in Fourier plane
  real(kind=sp), intent(in) :: width    !! Width up to which to down-scale weight
  !
  ! Local ---
  real(kind=sp) :: zsc
  !
  ! Code ----
  plait_wfunc = 1.0_sp
  if (width.eq.0.0) return
  zsc = r*width
  if (abs(zsc).ge.1.0_sp) return
  zsc = zsc*pi*0.5_sp
  plait_wfunc = max(wfunc_thres,(sin(zsc))**2)
end function plait_wfunc
!
subroutine plait_weight(w,theta,scale,head)
  use plait_common
  use image_def
  use phys_const
  !---------------------------------------------------------------------
  !! IMAGER -- PLAIT -- Computes Weighting image
  !---------------------------------------------------------------------
  real(kind=4),  intent(inout) :: w(:,:)    !! Data
  real(kind=sp), intent(in)    :: theta     !! Scanning angle
  real(kind=sp), intent(in)    :: scale     !! Correlation Scale  
  type(gildas),  intent(in)    :: head      !! Data header
  !
  ! Local ---
  integer(kind=4) :: i,j,m,n
  real(kind=sp) :: phi,cphi,sphi
  real(kind=sp) :: x(head%gil%dim(1)),y(head%gil%dim(2))
  real(kind=sp) :: d
  real(kind=sp) :: dx,dy,xinc,yinc
  !
  ! Code ----
  n = head%gil%dim(1)
  m = head%gil%dim(2)
  xinc = head%gil%convert(3,1)
  yinc = head%gil%convert(3,2)
  ! orientation of weighting in FT space
  phi  = theta * pi / 180._sp
  cphi = cos(phi)
  sphi = sin(phi)
  ! discretization of axes in FT space
  ! Why is it (n-1) ? (S.G.)
  dx   = 1.0_sp / (xinc*(n-1))
  dy   = 1.0_sp / (yinc*(m-1))
  do i=1,n
    x(i) = (i-1-(i/(n/2+1))*(n-1))
  enddo
  do j=1,m
    y(j) = (j-1-(j/(m/2+1))*(m-1))
  enddo
  ! Make it N,M
  dx   = 1.0_sp / (xinc*n) 
  dy   = 1.0_sp / (yinc*m)
  do i=1,n
    x(i) = (i-1-(i/(n/2+1))*n)
  enddo
  do j=1,m
    y(j) = (j-1-(j/(m/2+1))*m)
  enddo
  !
  x = x * dx * cphi
  y = y * dy * sphi
  ! DX and DY are redefined in the loops
  !   DX+DY is a strange "distance", but in a Rectangular
  ! scanning, it is null in one direction, due to the sin/cos
  do i=1,n
    dx = x(i)
    do j=1,m
      dy = y(j)
      d  = dx + dy
      w(i,j) = plait_wfunc(d,scale)
    enddo
  enddo
end subroutine plait_weight
!
subroutine plait_cutoff(a,lower,upper,bval)
  use plait_common
  !---------------------------------------------------------------------
  !! IMAGER -- PLAIT -- Blank pixels outside of interval
  !---------------------------------------------------------------------
  real(kind=sp), intent(in)    :: lower  !! Lower bound
  real(kind=sp), intent(in)    :: upper  !! Upper bound 
  real(kind=sp), intent(in)    :: bval   !! Blanking value
  real(kind=sp), intent(inout) :: a(:,:,:)  !! Data
  !
  if ((lower.eq.0._sp).and.(upper.eq.0._sp)) return
  where (a.lt.lower.or.a.gt.upper) a = bval
  !
end subroutine plait_cutoff
!
subroutine plait_replace(a,b,bval,eval)
  use plait_common
  !---------------------------------------------------------------------
  !! IMAGER -- PLAIT -- Replace Blank B array value
  !---------------------------------------------------------------------
  real(kind=4),  intent(in)    :: b(:,:,:)  !! Input (unblanked) cube
  real(kind=4),  intent(inout) :: a(:,:,:)  !! Input/Ouput blanked cube
  real(kind=sp), intent(in)    :: bval,eval  !! Blanking value and tolerance
  !
  where (abs(a-bval).le.eval) a = b
  !
end subroutine plait_replace
!
subroutine plait_norm(a,w,bval,eval)
  use plait_common
  !---------------------------------------------------------------------
  !! IMAGER -- PLAIT -- Normalize the output of FFTs
  !---------------------------------------------------------------------
  complex(kind=4), intent(inout) :: a(:,:,:)      !! Data
  real(kind=sp),   intent(in)    :: w(:,:)        !! Weight array
  real(kind=4),    intent(in)    :: bval,eval     !! Blanking
  ! Local
  integer(kind=4) :: i,dim3
  !
  dim3 = size(a,3)
  do i=1,dim3
    where (w.ne.0._sp.and.abs(a(:,:,i)-bval).gt.eval) &
        &  a(:,:,i) = a(:,:,i) / w
  enddo
end subroutine plait_norm
!
subroutine plait_add(aa,ww,head,a1)
  use plait_common
  use image_def
  !---------------------------------------------------------------------
  !! IMAGER -- PLAIT -- Accumulate a cube taking into account Blanking
  !---------------------------------------------------------------------
  real(kind=4),    intent(inout) :: aa(:,:,:)  !! Accumulated data
  integer(kind=4), intent(inout) :: ww(:,:,:)  !! Accumulated weights
  type(gildas),    intent(in)    :: head  !! Header of cube, 
  !! that defines dimensions and Blanking
  real(kind=4),    intent(in)    :: a1(:,:,:)  !! Data to be added
  !
  ! Local ---
  integer(kind=4) :: mask(head%gil%dim(1),head%gil%dim(2))
  real(kind=sp) :: bval , eval
  integer(kind=4) :: i
  !
  ! Code ----
  bval = head%gil%bval
  eval = head%gil%eval
  do i=1,head%gil%dim(3)
    !
    mask = 0
    where (abs(a1(:,:,i)-bval).gt.eval) mask = 1
    ww(:,:,i) = ww(:,:,i) + mask
    aa(:,:,i) = aa(:,:,i) + a1(:,:,i) * mask
    !
  enddo
  !
end subroutine plait_add
!
subroutine plait_mean(w,a,bval,eval)
  use gkernel_interfaces
  use plait_common
  use gbl_message
  !---------------------------------------------------------------------
  !! IMAGER -- PLAIT  -- Compute Mean from Weights and Accumulated values.  
  !! If the means contains Blanked pixels, return
  ! IF THE MEAN CONTAINS BLANKED PIXEL(S) RETURN
  !---------------------------------------------------------------------
  real(kind=sp),   intent(in)    :: bval,eval  !! Blanking values
  real(kind=sp),   intent(inout) :: a(:,:,:)   !! Input cube
  integer(kind=4), intent(in)    :: w(:,:,:)   !! Input weights
  !
  ! First, check if any zero in weights
  if (minval(w).eq.0) then
    call map_message(seve%e,'PLAIT','Blanked pixels in sum of Images')
    return
  endif
  ! No zero in w : computes the MEAN
  where (abs(a-bval).gt.eval) a = a / w
  !
end subroutine plait_mean
!
subroutine plait_routine(nmap,cin,cout,theta,length,thres,dump,error)
  use image_def
  use gkernel_interfaces
  use plait_common
  use imager_interfaces, only : map_message
  !---------------------------------------------------------------------
  !*
  ! IMAGER -- Support routine for command PLAIT  
  !   Basket-weaving of several images.
  !!
  !---------------------------------------------------------------------
  integer, intent(in) :: nmap                     !! Number of input images
  type(gildas), intent(inout) :: cin(nmap)        !! Input files
  type(gildas), intent(inout) :: cout             !! Output file
  real(kind=sp), intent(in) :: length(nmap)       !! Scanning lengths
  real(kind=sp), intent(in) :: theta(nmap)        !! Scanning angles
  real(kind=sp), intent(in) :: thres(2)           !! Threshold
  logical, intent(in) :: dump                     !! Debug ?
  logical, intent(out) :: error   !! Logical error flag
  !
  ! Local ---
  real(kind=sp) :: blan(2)
  integer(kind=4) :: i,j,ier
  integer(kind=4) :: dim(3),maxdim
  character(len=256) :: message
  complex(kind=4), allocatable :: b(:,:,:),res(:,:,:)
  real(kind=4),    allocatable :: a(:,:,:),som(:,:,:)
  integer(kind=4), allocatable :: w3d(:,:,:)
  real(kind=sp),   allocatable :: w2d(:,:),norm(:,:)
  real(kind=4),    allocatable :: wfft(:)
  type(gildas) :: hdump
  !
  ! Code ----
  blan(2) = -1.0
  !
  ! Check that input files exist
  error = .false.
  do i=1,nmap
    ier = gag_inquire(cin(i)%file,len_trim(cin(i)%file))
    if (ier.ne.0) then
      message = 'Input cube '//char(48+i)//' ' &
        &        //cin(i)%file(1:len_trim(cin(i)%file))//' not found'
      call map_message(seve%e,rname,message)
      error = .true.
    endif
  enddo
  if (error) return
  !
  ! Check that input cubes match
  i = 1
  call gdf_read_header(cin(i),error)
  if (gildas_error(cin(i),rname,error)) return
  do i=2,nmap
    call gdf_read_header(cin(i),error)
    if (gildas_error(cin(i),rname,error)) return
    call plait_check(cin(i),cin(1),error)
    if (error) then
      call map_message(seve%e,rname,'Input cubes dimensions do not match')
      return
    endif
    !
    ! Setup a default blanking
    if (blan(2).lt.0) then
      if (cin(i)%gil%eval.ge.0) then
        blan(1) = cin(i)%gil%bval
        blan(2) = cin(i)%gil%eval
      endif
    endif
  enddo
  dim(1:3) = cin(1)%gil%dim(1:3)
  maxdim = 2*maxval(dim)
  !
  ! Allocating memory (by steps, to avoid warnings...
  allocate(w2d(dim(1),dim(2)), norm(dim(1),dim(2)), w3d(dim(1),dim(2),dim(3)),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'Buffer allocation errror')
    error = .true.
    return
  endif
  allocate(a(dim(1),dim(2),dim(3)), b(dim(1),dim(2),dim(3)), stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'Buffer allocation errror')
    error = .true.
    return
  endif
  allocate(res(dim(1),dim(2),dim(3)),som(dim(1),dim(2),dim(3)), wfft(maxdim), stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'Buffer allocation errror')
    error = .true.
    return
  endif
  if (dump) then
    call gildas_null(hdump)
    call gdf_copy_header(cin(1),hdump,error)
    hdump%gil%ndim = 2
  endif
  !
  ! Compute the mean of input cubes
  w3d = 0.
  som = 0.
  do i=1,nmap
    call gdf_read_data(cin(i),a,error)
    if (gildas_error(cin(i),rname,error)) return
    call plait_cutoff(a,thres(1),thres(2),blan(1))
    call plait_add(som,w3d,cin(i),a)
  enddo
  call plait_mean(w3d,som,blan(1),blan(2))
  !
  ! Perform the plait algorithm
  !
  res  = 0. 
  do i=1,nmap
    wfft = 0. 
    call gdf_read_data(cin(i),a,error)
    if (gildas_error(cin(i),rname,error)) return
    !
    ! Why should we cut with a Threshold ?
    !   It seems more natural to cut if the data deviates from the mean
    ! by more than the threshold ? 
    call plait_cutoff(a,thres(1),thres(2),blan(1))
    ! Replace by Mean if Thresholded
    call plait_replace(a,som,blan(1),blan(2))
    b = cmplx(a,0.)
    ! Compute the weighting function in Fourier plane
    call plait_weight(w2d,theta(i),length(i),cin(i))
    if (dump) then
      write(hdump%file,'(A,i0)') 'weight-',i
      call gdf_write_image(hdump,w2d,error)
    endif
    ! Apply it to the data
    do j=1,dim(3)
      call fourt(b(:,:,j),dim(1:2),2,1,1,wfft)
    enddo
    ! Add to the Fourier values
    do j=1,dim(3)
      res(:,:,j) = res(:,:,j) + b(:,:,j)*w2d
    enddo
    ! Increment the norm
    norm(:,:) = norm + w2d
  enddo
  ! Normalize the Fourier values
  call plait_norm(res,norm,blan(1),blan(2))
  wfft = cmplx(0.,kind(0.))
  ! Transform back to Image plane
  do j=1,dim(3)
    call fourt(res(:,:,j),dim(1:2),2,-1,1,wfft)
  enddo
  a(:,:,:) = real(res)
  a = a / (dim(1)*dim(2))
  !
  ! Write result in output image
  !
  call gdf_copy_header(cin(1),cout,error)
  call gdf_write_image(cout,a,error)
  if (gildas_error(cout,rname,error)) return
  deallocate(w2d,norm,w3d,a,b,res,som,wfft,stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'Deallocation error')
  endif
  do i=1,nmap
    call gdf_close_image(cin(i),error)
  enddo
end subroutine plait_routine
!
end subroutine plait_comm

*DECK STEPS
      SUBROUTINE STEPS (F, NEQN, Y, X, H, EPS, WT, START, HOLD, K, KOLD,
     +   CRASH, PHI, P, YP, PSI, ALPHA, BETA, SIG, V, W, G, PHASE1, NS,
     +   NORND, KSTEPS, TWOU, FOURU, XOLD, KPREV, IVC, IV, KGI, GI,
     +   RPAR, IPAR)
C***BEGIN PROLOGUE  STEPS
C***PURPOSE  Integrate a system of first order ordinary differential
C            equations one step.
C***LIBRARY   SLATEC (DEPAC)
C***CATEGORY  I1A1B
C***TYPE      SINGLE PRECISION (STEPS-S, DSTEPS-D)
C***KEYWORDS  ADAMS METHOD, DEPAC, INITIAL VALUE PROBLEMS, ODE,
C             ORDINARY DIFFERENTIAL EQUATIONS, PREDICTOR-CORRECTOR
C***AUTHOR  Shampine, L. F., (SNLA)
C           Gordon, M. K., (SNLA)
C             MODIFIED BY H.A. WATTS
C***DESCRIPTION
C
C   Written by L. F. Shampine and M. K. Gordon
C
C   Abstract
C
C   Subroutine  STEPS  is normally used indirectly through subroutine
C   DEABM .  Because  DEABM  suffices for most problems and is much
C   easier to use, using it should be considered before using  STEPS
C   alone.
C
C   Subroutine STEPS integrates a system of  NEQN  first order ordinary
C   differential equations one step, normally from X to X+H, using a
C   modified divided difference form of the Adams Pece formulas.  Local
C   extrapolation is used to improve absolute stability and accuracy.
C   The code adjusts its order and step size to control the local error
C   per unit step in a generalized sense.  Special devices are included
C   to control roundoff error and to detect when the user is requesting
C   too much accuracy.
C
C   This code is completely explained and documented in the text,
C   Computer Solution of Ordinary Differential Equations, The Initial
C   Value Problem  by L. F. Shampine and M. K. Gordon.
C   Further details on use of this code are available in "Solving
C   Ordinary Differential Equations with ODE, STEP, and INTRP",
C   by L. F. Shampine and M. K. Gordon, SLA-73-1060.
C
C
C   The parameters represent --
C      F -- subroutine to evaluate derivatives
C      NEQN -- number of equations to be integrated
C      Y(*) -- solution vector at X
C      X -- independent variable
C      H -- appropriate step size for next step.  Normally determined by
C           code
C      EPS -- local error tolerance
C      WT(*) -- vector of weights for error criterion
C      START -- logical variable set .TRUE. for first step,  .FALSE.
C           otherwise
C      HOLD -- step size used for last successful step
C      K -- appropriate order for next step (determined by code)
C      KOLD -- order used for last successful step
C      CRASH -- logical variable set .TRUE. when no step can be taken,
C           .FALSE. otherwise.
C      YP(*) -- derivative of solution vector at  X  after successful
C           step
C      KSTEPS -- counter on attempted steps
C      TWOU -- 2.*U where U is machine unit roundoff quantity
C      FOURU -- 4.*U where U is machine unit roundoff quantity
C      RPAR,IPAR -- parameter arrays which you may choose to use
C            for communication between your program and subroutine F.
C            They are not altered or used by STEPS.
C   The variables X,XOLD,KOLD,KGI and IVC and the arrays Y,PHI,ALPHA,G,
C   W,P,IV and GI are required for the interpolation subroutine SINTRP.
C   The remaining variables and arrays are included in the call list
C   only to eliminate local retention of variables between calls.
C
C   Input to STEPS
C
C      First call --
C
C   The user must provide storage in his calling program for all arrays
C   in the call list, namely
C
C     DIMENSION Y(NEQN),WT(NEQN),PHI(NEQN,16),P(NEQN),YP(NEQN),PSI(12),
C    1  ALPHA(12),BETA(12),SIG(13),V(12),W(12),G(13),GI(11),IV(10),
C    2  RPAR(*),IPAR(*)
C
C    **Note**
C
C   The user must also declare  START ,  CRASH ,  PHASE1  and  NORND
C   logical variables and  F  an EXTERNAL subroutine, supply the
C   subroutine  F(X,Y,YP)  to evaluate
C      DY(I)/DX = YP(I) = F(X,Y(1),Y(2),...,Y(NEQN))
C   and initialize only the following parameters.
C      NEQN -- number of equations to be integrated
C      Y(*) -- vector of initial values of dependent variables
C      X -- initial value of the independent variable
C      H -- nominal step size indicating direction of integration
C           and maximum size of step.  Must be variable
C      EPS -- local error tolerance per step.  Must be variable
C      WT(*) -- vector of non-zero weights for error criterion
C      START -- .TRUE.
C      YP(*) -- vector of initial derivative values
C      KSTEPS -- set KSTEPS to zero
C      TWOU -- 2.*U where U is machine unit roundoff quantity
C      FOURU -- 4.*U where U is machine unit roundoff quantity
C   Define U to be the machine unit roundoff quantity by calling
C   the function routine  R1MACH,  U = R1MACH(4), or by
C   computing U so that U is the smallest positive number such
C   that 1.0+U .GT. 1.0.
C
C   STEPS  requires that the L2 norm of the vector with components
C   LOCAL ERROR(L)/WT(L)  be less than  EPS  for a successful step.  The
C   array  WT  allows the user to specify an error test appropriate
C   for his problem.  For example,
C      WT(L) = 1.0  specifies absolute error,
C            = ABS(Y(L))  error relative to the most recent value of the
C                 L-th component of the solution,
C            = ABS(YP(L))  error relative to the most recent value of
C                 the L-th component of the derivative,
C            = MAX(WT(L),ABS(Y(L)))  error relative to the largest
C                 magnitude of L-th component obtained so far,
C            = ABS(Y(L))*RELERR/EPS + ABSERR/EPS  specifies a mixed
C                 relative-absolute test where  RELERR  is relative
C                 error,  ABSERR  is absolute error and  EPS =
C                 MAX(RELERR,ABSERR) .
C
C      Subsequent calls --
C
C   Subroutine  STEPS  is designed so that all information needed to
C   continue the integration, including the step size  H  and the order
C   K , is returned with each step.  With the exception of the step
C   size, the error tolerance, and the weights, none of the parameters
C   should be altered.  The array  WT  must be updated after each step
C   to maintain relative error tests like those above.  Normally the
C   integration is continued just beyond the desired endpoint and the
C   solution interpolated there with subroutine  SINTRP .  If it is
C   impossible to integrate beyond the endpoint, the step size may be
C   reduced to hit the endpoint since the code will not take a step
C   larger than the  H  input.  Changing the direction of integration,
C   i.e., the sign of  H , requires the user set  START = .TRUE. before
C   calling  STEPS  again.  This is the only situation in which  START
C   should be altered.
C
C   Output from STEPS
C
C      Successful Step --
C
C   The subroutine returns after each successful step with  START  and
C   CRASH  set .FALSE. .  X  represents the independent variable
C   advanced one step of length  HOLD  from its value on input and  Y
C   the solution vector at the new value of  X .  All other parameters
C   represent information corresponding to the new  X  needed to
C   continue the integration.
C
C      Unsuccessful Step --
C
C   When the error tolerance is too small for the machine precision,
C   the subroutine returns without taking a step and  CRASH = .TRUE. .
C   An appropriate step size and error tolerance for continuing are
C   estimated and all other information is restored as upon input
C   before returning.  To continue with the larger tolerance, the user
C   just calls the code again.  A restart is neither required nor
C   desirable.
C
C***REFERENCES  L. F. Shampine and M. K. Gordon, Solving ordinary
C                 differential equations with ODE, STEP, and INTRP,
C                 Report SLA-73-1060, Sandia Laboratories, 1973.
C***ROUTINES CALLED  HSTART, R1MACH
C***REVISION HISTORY  (YYMMDD)
C   740101  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890831  Modified array declarations.  (WRB)
C   890831  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  STEPS
C
      LOGICAL START,CRASH,PHASE1,NORND
      DIMENSION Y(*),WT(*),PHI(NEQN,16),P(*),YP(*),PSI(12),
     1  ALPHA(12),BETA(12),SIG(13),V(12),W(12),G(13),GI(11),IV(10),
     2  RPAR(*),IPAR(*)
      DIMENSION TWO(13),GSTR(13)
      EXTERNAL F
      SAVE TWO, GSTR
C
      DATA  TWO(1),TWO(2),TWO(3),TWO(4),TWO(5),TWO(6),TWO(7),TWO(8),
     1      TWO(9),TWO(10),TWO(11),TWO(12),TWO(13) /2.0,4.0,8.0,16.0,
     2      32.0,64.0,128.0,256.0,512.0,1024.0,2048.0,4096.0,8192.0/
      DATA  GSTR(1),GSTR(2),GSTR(3),GSTR(4),GSTR(5),GSTR(6),GSTR(7),
     1      GSTR(8),GSTR(9),GSTR(10),GSTR(11),GSTR(12),GSTR(13)/0.500,
     2      0.0833,0.0417,0.0264,0.0188,0.0143,0.0114,0.00936,0.00789,
     3      0.00679,0.00592,0.00524,0.00468/
C
C
C       ***     BEGIN BLOCK 0     ***
C   CHECK IF STEP SIZE OR ERROR TOLERANCE IS TOO SMALL FOR MACHINE
C   PRECISION.  IF FIRST STEP, INITIALIZE PHI ARRAY AND ESTIMATE A
C   STARTING STEP SIZE.
C                   ***
C
C   IF STEP SIZE IS TOO SMALL, DETERMINE AN ACCEPTABLE ONE
C
C***FIRST EXECUTABLE STATEMENT  STEPS
      CRASH = .TRUE.
      IF(ABS(H) .GE. FOURU*ABS(X)) GO TO 5
      H = SIGN(FOURU*ABS(X),H)
      RETURN
 5    P5EPS = 0.5*EPS
C
C   IF ERROR TOLERANCE IS TOO SMALL, INCREASE IT TO AN ACCEPTABLE VALUE
C
      ROUND = 0.0
      DO 10 L = 1,NEQN
 10     ROUND = ROUND + (Y(L)/WT(L))**2
      ROUND = TWOU*SQRT(ROUND)
      IF(P5EPS .GE. ROUND) GO TO 15
      EPS = 2.0*ROUND*(1.0 + FOURU)
      RETURN
 15   CRASH = .FALSE.
      G(1) = 1.0
      G(2) = 0.5
      SIG(1) = 1.0
      IF(.NOT.START) GO TO 99
C
C   INITIALIZE.  COMPUTE APPROPRIATE STEP SIZE FOR FIRST STEP
C
C     CALL F(X,Y,YP,RPAR,IPAR)
C     SUM = 0.0
      DO 20 L = 1,NEQN
        PHI(L,1) = YP(L)
   20   PHI(L,2) = 0.0
C20     SUM = SUM + (YP(L)/WT(L))**2
C     SUM = SQRT(SUM)
C     ABSH = ABS(H)
C     IF(EPS .LT. 16.0*SUM*H*H) ABSH = 0.25*SQRT(EPS/SUM)
C     H = SIGN(MAX(ABSH,FOURU*ABS(X)),H)
C
      U = R1MACH(4)
      BIG = SQRT(R1MACH(2))
      CALL HSTART (F,NEQN,X,X+H,Y,YP,WT,1,U,BIG,
     1             PHI(1,3),PHI(1,4),PHI(1,5),PHI(1,6),RPAR,IPAR,H)
C
      HOLD = 0.0
      K = 1
      KOLD = 0
      KPREV = 0
      START = .FALSE.
      PHASE1 = .TRUE.
      NORND = .TRUE.
      IF(P5EPS .GT. 100.0*ROUND) GO TO 99
      NORND = .FALSE.
      DO 25 L = 1,NEQN
 25     PHI(L,15) = 0.0
 99   IFAIL = 0
C       ***     END BLOCK 0     ***
C
C       ***     BEGIN BLOCK 1     ***
C   COMPUTE COEFFICIENTS OF FORMULAS FOR THIS STEP.  AVOID COMPUTING
C   THOSE QUANTITIES NOT CHANGED WHEN STEP SIZE IS NOT CHANGED.
C                   ***
C
 100  KP1 = K+1
      KP2 = K+2
      KM1 = K-1
      KM2 = K-2
C
C   NS IS THE NUMBER OF STEPS TAKEN WITH SIZE H, INCLUDING THE CURRENT
C   ONE.  WHEN K.LT.NS, NO COEFFICIENTS CHANGE
C
      IF(H .NE. HOLD) NS = 0
      IF (NS.LE.KOLD) NS = NS+1
      NSP1 = NS+1
      IF (K .LT. NS) GO TO 199
C
C   COMPUTE THOSE COMPONENTS OF ALPHA(*),BETA(*),PSI(*),SIG(*) WHICH
C   ARE CHANGED
C
      BETA(NS) = 1.0
      REALNS = NS
      ALPHA(NS) = 1.0/REALNS
      TEMP1 = H*REALNS
      SIG(NSP1) = 1.0
      IF(K .LT. NSP1) GO TO 110
      DO 105 I = NSP1,K
        IM1 = I-1
        TEMP2 = PSI(IM1)
        PSI(IM1) = TEMP1
        BETA(I) = BETA(IM1)*PSI(IM1)/TEMP2
        TEMP1 = TEMP2 + H
        ALPHA(I) = H/TEMP1
        REALI = I
 105    SIG(I+1) = REALI*ALPHA(I)*SIG(I)
 110  PSI(K) = TEMP1
C
C   COMPUTE COEFFICIENTS G(*)
C
C   INITIALIZE V(*) AND SET W(*).
C
      IF(NS .GT. 1) GO TO 120
      DO 115 IQ = 1,K
        TEMP3 = IQ*(IQ+1)
        V(IQ) = 1.0/TEMP3
 115    W(IQ) = V(IQ)
      IVC = 0
      KGI = 0
      IF (K .EQ. 1) GO TO 140
      KGI = 1
      GI(1) = W(2)
      GO TO 140
C
C   IF ORDER WAS RAISED, UPDATE DIAGONAL PART OF V(*)
C
 120  IF(K .LE. KPREV) GO TO 130
      IF (IVC .EQ. 0) GO TO 122
      JV = KP1 - IV(IVC)
      IVC = IVC - 1
      GO TO 123
 122  JV = 1
      TEMP4 = K*KP1
      V(K) = 1.0/TEMP4
      W(K) = V(K)
      IF (K .NE. 2) GO TO 123
      KGI = 1
      GI(1) = W(2)
 123  NSM2 = NS-2
      IF(NSM2 .LT. JV) GO TO 130
      DO 125 J = JV,NSM2
        I = K-J
        V(I) = V(I) - ALPHA(J+1)*V(I+1)
 125    W(I) = V(I)
      IF (I .NE. 2) GO TO 130
      KGI = NS - 1
      GI(KGI) = W(2)
C
C   UPDATE V(*) AND SET W(*)
C
 130  LIMIT1 = KP1 - NS
      TEMP5 = ALPHA(NS)
      DO 135 IQ = 1,LIMIT1
        V(IQ) = V(IQ) - TEMP5*V(IQ+1)
 135    W(IQ) = V(IQ)
      G(NSP1) = W(1)
      IF (LIMIT1 .EQ. 1) GO TO 137
      KGI = NS
      GI(KGI) = W(2)
 137  W(LIMIT1+1) = V(LIMIT1+1)
      IF (K .GE. KOLD) GO TO 140
      IVC = IVC + 1
      IV(IVC) = LIMIT1 + 2
C
C   COMPUTE THE G(*) IN THE WORK VECTOR W(*)
C
 140  NSP2 = NS + 2
      KPREV = K
      IF(KP1 .LT. NSP2) GO TO 199
      DO 150 I = NSP2,KP1
        LIMIT2 = KP2 - I
        TEMP6 = ALPHA(I-1)
        DO 145 IQ = 1,LIMIT2
 145      W(IQ) = W(IQ) - TEMP6*W(IQ+1)
 150    G(I) = W(1)
 199    CONTINUE
C       ***     END BLOCK 1     ***
C
C       ***     BEGIN BLOCK 2     ***
C   PREDICT A SOLUTION P(*), EVALUATE DERIVATIVES USING PREDICTED
C   SOLUTION, ESTIMATE LOCAL ERROR AT ORDER K AND ERRORS AT ORDERS K,
C   K-1, K-2 AS IF CONSTANT STEP SIZE WERE USED.
C                   ***
C
C   INCREMENT COUNTER ON ATTEMPTED STEPS
C
      KSTEPS = KSTEPS + 1
C
C   CHANGE PHI TO PHI STAR
C
      IF(K .LT. NSP1) GO TO 215
      DO 210 I = NSP1,K
        TEMP1 = BETA(I)
        DO 205 L = 1,NEQN
 205      PHI(L,I) = TEMP1*PHI(L,I)
 210    CONTINUE
C
C   PREDICT SOLUTION AND DIFFERENCES
C
 215  DO 220 L = 1,NEQN
        PHI(L,KP2) = PHI(L,KP1)
        PHI(L,KP1) = 0.0
 220    P(L) = 0.0
      DO 230 J = 1,K
        I = KP1 - J
        IP1 = I+1
        TEMP2 = G(I)
        DO 225 L = 1,NEQN
          P(L) = P(L) + TEMP2*PHI(L,I)
 225      PHI(L,I) = PHI(L,I) + PHI(L,IP1)
 230    CONTINUE
      IF(NORND) GO TO 240
      DO 235 L = 1,NEQN
        TAU = H*P(L) - PHI(L,15)
        P(L) = Y(L) + TAU
 235    PHI(L,16) = (P(L) - Y(L)) - TAU
      GO TO 250
 240  DO 245 L = 1,NEQN
 245    P(L) = Y(L) + H*P(L)
 250  XOLD = X
      X = X + H
      ABSH = ABS(H)
      CALL F(X,P,YP,RPAR,IPAR)
C
C   ESTIMATE ERRORS AT ORDERS K,K-1,K-2
C
      ERKM2 = 0.0
      ERKM1 = 0.0
      ERK = 0.0
      DO 265 L = 1,NEQN
        TEMP3 = 1.0/WT(L)
        TEMP4 = YP(L) - PHI(L,1)
        IF(KM2)265,260,255
 255    ERKM2 = ERKM2 + ((PHI(L,KM1)+TEMP4)*TEMP3)**2
 260    ERKM1 = ERKM1 + ((PHI(L,K)+TEMP4)*TEMP3)**2
 265    ERK = ERK + (TEMP4*TEMP3)**2
      IF(KM2)280,275,270
 270  ERKM2 = ABSH*SIG(KM1)*GSTR(KM2)*SQRT(ERKM2)
 275  ERKM1 = ABSH*SIG(K)*GSTR(KM1)*SQRT(ERKM1)
 280  TEMP5 = ABSH*SQRT(ERK)
      ERR = TEMP5*(G(K)-G(KP1))
      ERK = TEMP5*SIG(KP1)*GSTR(K)
      KNEW = K
C
C   TEST IF ORDER SHOULD BE LOWERED
C
      IF(KM2)299,290,285
 285  IF(MAX(ERKM1,ERKM2) .LE. ERK) KNEW = KM1
      GO TO 299
 290  IF(ERKM1 .LE. 0.5*ERK) KNEW = KM1
C
C   TEST IF STEP SUCCESSFUL
C
 299  IF(ERR .LE. EPS) GO TO 400
C       ***     END BLOCK 2     ***
C
C       ***     BEGIN BLOCK 3     ***
C   THE STEP IS UNSUCCESSFUL.  RESTORE  X, PHI(*,*), PSI(*) .
C   IF THIRD CONSECUTIVE FAILURE, SET ORDER TO ONE.  IF STEP FAILS MORE
C   THAN THREE TIMES, CONSIDER AN OPTIMAL STEP SIZE.  DOUBLE ERROR
C   TOLERANCE AND RETURN IF ESTIMATED STEP SIZE IS TOO SMALL FOR MACHINE
C   PRECISION.
C                   ***
C
C   RESTORE X, PHI(*,*) AND PSI(*)
C
      PHASE1 = .FALSE.
      X = XOLD
      DO 310 I = 1,K
        TEMP1 = 1.0/BETA(I)
        IP1 = I+1
        DO 305 L = 1,NEQN
 305      PHI(L,I) = TEMP1*(PHI(L,I) - PHI(L,IP1))
 310    CONTINUE
      IF(K .LT. 2) GO TO 320
      DO 315 I = 2,K
 315    PSI(I-1) = PSI(I) - H
C
C   ON THIRD FAILURE, SET ORDER TO ONE.  THEREAFTER, USE OPTIMAL STEP
C   SIZE
C
 320  IFAIL = IFAIL + 1
      TEMP2 = 0.5
      IF(IFAIL - 3) 335,330,325
 325  IF(P5EPS .LT. 0.25*ERK) TEMP2 = SQRT(P5EPS/ERK)
 330  KNEW = 1
 335  H = TEMP2*H
      K = KNEW
      NS = 0
      IF(ABS(H) .GE. FOURU*ABS(X)) GO TO 340
      CRASH = .TRUE.
      H = SIGN(FOURU*ABS(X),H)
      EPS = EPS + EPS
      RETURN
 340  GO TO 100
C       ***     END BLOCK 3     ***
C
C       ***     BEGIN BLOCK 4     ***
C   THE STEP IS SUCCESSFUL.  CORRECT THE PREDICTED SOLUTION, EVALUATE
C   THE DERIVATIVES USING THE CORRECTED SOLUTION AND UPDATE THE
C   DIFFERENCES.  DETERMINE BEST ORDER AND STEP SIZE FOR NEXT STEP.
C                   ***
 400  KOLD = K
      HOLD = H
C
C   CORRECT AND EVALUATE
C
      TEMP1 = H*G(KP1)
      IF(NORND) GO TO 410
      DO 405 L = 1,NEQN
        TEMP3 = Y(L)
        RHO = TEMP1*(YP(L) - PHI(L,1)) - PHI(L,16)
        Y(L) = P(L) + RHO
        PHI(L,15) = (Y(L) - P(L)) - RHO
 405    P(L) = TEMP3
      GO TO 420
 410  DO 415 L = 1,NEQN
        TEMP3 = Y(L)
        Y(L) = P(L) + TEMP1*(YP(L) - PHI(L,1))
 415    P(L) = TEMP3
 420  CALL F(X,Y,YP,RPAR,IPAR)
C
C   UPDATE DIFFERENCES FOR NEXT STEP
C
      DO 425 L = 1,NEQN
        PHI(L,KP1) = YP(L) - PHI(L,1)
 425    PHI(L,KP2) = PHI(L,KP1) - PHI(L,KP2)
      DO 435 I = 1,K
        DO 430 L = 1,NEQN
 430      PHI(L,I) = PHI(L,I) + PHI(L,KP1)
 435    CONTINUE
C
C   ESTIMATE ERROR AT ORDER K+1 UNLESS:
C     IN FIRST PHASE WHEN ALWAYS RAISE ORDER,
C     ALREADY DECIDED TO LOWER ORDER,
C     STEP SIZE NOT CONSTANT SO ESTIMATE UNRELIABLE
C
      ERKP1 = 0.0
      IF(KNEW .EQ. KM1  .OR.  K .EQ. 12) PHASE1 = .FALSE.
      IF(PHASE1) GO TO 450
      IF(KNEW .EQ. KM1) GO TO 455
      IF(KP1 .GT. NS) GO TO 460
      DO 440 L = 1,NEQN
 440    ERKP1 = ERKP1 + (PHI(L,KP2)/WT(L))**2
      ERKP1 = ABSH*GSTR(KP1)*SQRT(ERKP1)
C
C   USING ESTIMATED ERROR AT ORDER K+1, DETERMINE APPROPRIATE ORDER
C   FOR NEXT STEP
C
      IF(K .GT. 1) GO TO 445
      IF(ERKP1 .GE. 0.5*ERK) GO TO 460
      GO TO 450
 445  IF(ERKM1 .LE. MIN(ERK,ERKP1)) GO TO 455
      IF(ERKP1 .GE. ERK  .OR.  K .EQ. 12) GO TO 460
C
C   HERE ERKP1 .LT. ERK .LT. MAX(ERKM1,ERKM2) ELSE ORDER WOULD HAVE
C   BEEN LOWERED IN BLOCK 2.  THUS ORDER IS TO BE RAISED
C
C   RAISE ORDER
C
 450  K = KP1
      ERK = ERKP1
      GO TO 460
C
C   LOWER ORDER
C
 455  K = KM1
      ERK = ERKM1
C
C   WITH NEW ORDER DETERMINE APPROPRIATE STEP SIZE FOR NEXT STEP
C
 460  HNEW = H + H
      IF(PHASE1) GO TO 465
      IF(P5EPS .GE. ERK*TWO(K+1)) GO TO 465
      HNEW = H
      IF(P5EPS .GE. ERK) GO TO 465
      TEMP2 = K+1
      R = (P5EPS/ERK)**(1.0/TEMP2)
      HNEW = ABSH*MAX(0.5,MIN(0.9,R))
      HNEW = SIGN(MAX(HNEW,FOURU*ABS(X)),H)
 465  H = HNEW
      RETURN
C       ***     END BLOCK 4     ***
      END
*DECK STIN
      SUBROUTINE STIN (N, NELT, IA, JA, A, ISYM, SOLN, RHS, IUNIT, JOB)
C***BEGIN PROLOGUE  STIN
C***PURPOSE  Read in SLAP Triad Format Linear System.
C            Routine to read in a SLAP Triad format matrix and right
C            hand side and solution to the system, if known.
C***LIBRARY   SLATEC (SLAP)
C***CATEGORY  N1
C***TYPE      SINGLE PRECISION (STIN-S, DTIN-D)
C***KEYWORDS  DIAGNOSTICS, LINEAR SYSTEM, SLAP SPARSE
C***AUTHOR  Seager, Mark K., (LLNL)
C             Lawrence Livermore National Laboratory
C             PO BOX 808, L-60
C             Livermore, CA 94550 (510) 423-3141
C             seager@llnl.gov
C***DESCRIPTION
C
C *Usage:
C     INTEGER N, NELT, IA(NELT), JA(NELT), ISYM, IUNIT, JOB
C     REAL    A(NELT), SOLN(N), RHS(N)
C
C     CALL STIN( N, NELT, IA, JA, A, ISYM, SOLN, RHS, IUNIT, JOB )
C
C *Arguments:
C N      :OUT      Integer
C         Order of the Matrix.
C NELT   :INOUT    Integer.
C         On input NELT is the maximum number of non-zeros that
C         can be stored in the IA, JA, A arrays.
C         On output NELT is the number of non-zeros stored in A.
C IA     :OUT      Integer IA(NELT).
C JA     :OUT      Integer JA(NELT).
C A      :OUT      Real A(NELT).
C         On output these arrays hold the matrix A in the SLAP
C         Triad format.  See "Description", below.
C ISYM   :OUT      Integer.
C         Flag to indicate symmetric storage format.
C         If ISYM=0, all non-zero entries of the matrix are stored.
C         If ISYM=1, the matrix is symmetric, and only the lower
C         triangle of the matrix is stored.
C SOLN   :OUT      Real SOLN(N).
C         The solution to the linear system, if present.  This array
C         is accessed if and only if JOB to read it in, see below.
C         If the user requests that SOLN be read in, but it is not in
C         the file, then it is simply zeroed out.
C RHS    :OUT      Real RHS(N).
C         The right hand side vector.  This array is accessed if and
C         only if JOB is set to read it in, see below.
C         If the user requests that RHS be read in, but it is not in
C         the file, then it is simply zeroed out.
C IUNIT  :IN       Integer.
C         Fortran logical I/O device unit number to write the matrix
C         to.  This unit must be connected in a system dependent fashion
C         to a file or the console or you will get a nasty message
C         from the Fortran I/O libraries.
C JOB    :INOUT    Integer.
C         Flag indicating what I/O operations to perform.
C         On input JOB indicates what Input operations to try to
C         perform.
C         JOB = 0 => Read only the matrix.
C         JOB = 1 => Read matrix and RHS (if present).
C         JOB = 2 => Read matrix and SOLN (if present).
C         JOB = 3 => Read matrix, RHS and SOLN (if present).
C         On output JOB indicates what operations were actually
C         performed.
C         JOB = 0 => Read in only the matrix.
C         JOB = 1 => Read in the matrix and RHS.
C         JOB = 2 => Read in the matrix and SOLN.
C         JOB = 3 => Read in the matrix, RHS and SOLN.
C
C *Description:
C       The format for the  input is as follows.  On  the first line
C       are counters and flags: N, NELT, ISYM, IRHS, ISOLN.  N, NELT
C       and ISYM are described above.  IRHS is  a flag indicating if
C       the RHS was  written out (1 is  yes, 0 is  no).  ISOLN  is a
C       flag indicating if the SOLN was written out  (1 is yes, 0 is
C       no).  The format for the fist line is: 5i10.  Then comes the
C       NELT Triad's IA(I), JA(I) and A(I), I = 1, NELT.  The format
C       for  these lines is   :  1X,I5,1X,I5,1X,E16.7.   Then  comes
C       RHS(I), I = 1, N, if IRHS = 1.  Then  comes SOLN(I), I  = 1,
C       N, if ISOLN = 1.  The format for these lines is: 1X,E16.7.
C
C       =================== S L A P Triad format ===================
C       This routine requires that the  matrix A be   stored in  the
C       SLAP  Triad format.  In  this format only the non-zeros  are
C       stored.  They may appear in  *ANY* order.  The user supplies
C       three arrays of  length NELT, where  NELT is  the number  of
C       non-zeros in the matrix: (IA(NELT), JA(NELT), A(NELT)).  For
C       each non-zero the user puts the row and column index of that
C       matrix element  in the IA and  JA arrays.  The  value of the
C       non-zero  matrix  element is  placed   in  the corresponding
C       location of the A array.   This is  an  extremely  easy data
C       structure to generate.  On  the  other hand it   is  not too
C       efficient on vector computers for  the iterative solution of
C       linear systems.  Hence,   SLAP changes   this  input    data
C       structure to the SLAP Column format  for  the iteration (but
C       does not change it back).
C
C       Here is an example of the  SLAP Triad   storage format for a
C       5x5 Matrix.  Recall that the entries may appear in any order.
C
C           5x5 Matrix      SLAP Triad format for 5x5 matrix on left.
C                              1  2  3  4  5  6  7  8  9 10 11
C       |11 12  0  0 15|   A: 51 12 11 33 15 53 55 22 35 44 21
C       |21 22  0  0  0|  IA:  5  1  1  3  1  5  5  2  3  4  2
C       | 0  0 33  0 35|  JA:  1  2  1  3  5  3  5  2  5  4  1
C       | 0  0  0 44  0|
C       |51  0 53  0 55|
C
C *Cautions:
C     This routine will attempt to write to the Fortran logical output
C     unit IUNIT, if IUNIT .ne. 0.  Thus, the user must make sure that
C     this logical unit is attached to a file or terminal before calling
C     this routine with a non-zero value for IUNIT.  This routine does
C     not check for the validity of a non-zero IUNIT unit number.
C***REFERENCES  (NONE)
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   871119  DATE WRITTEN
C   881213  Previous REVISION DATE
C   890915  Made changes requested at July 1989 CML Meeting.  (MKS)
C   890922  Numerous changes to prologue to make closer to SLATEC
C           standard.  (FNF)
C   890929  Numerous changes to reduce SP/DP differences.  (FNF)
C   910411  Prologue converted to Version 4.0 format.  (BAB)
C   920511  Added complete declaration section.  (WRB)
C   930701  Updated CATEGORY section.  (FNF, WRB)
C***END PROLOGUE  STIN
C     .. Scalar Arguments ..
      INTEGER ISYM, IUNIT, JOB, N, NELT
C     .. Array Arguments ..
      REAL A(NELT), RHS(N), SOLN(N)
      INTEGER IA(NELT), JA(NELT)
C     .. Local Scalars ..
      INTEGER I, IRHS, ISOLN, JOBRET, NELTMX
C     .. Intrinsic Functions ..
      INTRINSIC MIN
C***FIRST EXECUTABLE STATEMENT  STIN
C
C         Read in the information heading.
C
      NELTMX = NELT
      READ(IUNIT,1000) N, NELT, ISYM, IRHS, ISOLN
      NELT = MIN( NELT, NELTMX )
C
C         Read in the matrix non-zeros in Triad format.
      DO 10 I = 1, NELT
         READ(IUNIT,1010) IA(I), JA(I), A(I)
 10   CONTINUE
C
C         If requested, read in the rhs.
      JOBRET = 0
      IF( JOB.EQ.1 .OR. JOB.EQ.3 ) THEN
C
C         Check to see if rhs is in the file.
         IF( IRHS.EQ.1 ) THEN
            JOBRET = 1
            READ(IUNIT,1020) (RHS(I),I=1,N)
         ELSE
            DO 20 I = 1, N
               RHS(I) = 0
 20         CONTINUE
         ENDIF
      ENDIF
C
C         If requested, read in the solution.
      IF( JOB.GT.1 ) THEN
C
C         Check to see if solution is in the file.
         IF( ISOLN.EQ.1 ) THEN
            JOBRET = JOBRET + 2
            READ(IUNIT,1020) (SOLN(I),I=1,N)
         ELSE
            DO 30 I = 1, N
               SOLN(I) = 0
 30         CONTINUE
         ENDIF
      ENDIF
C
      JOB = JOBRET
      RETURN
 1000 FORMAT(5I10)
 1010 FORMAT(1X,I5,1X,I5,1X,E16.7)
 1020 FORMAT(1X,E16.7)
C------------- LAST LINE OF STIN FOLLOWS ----------------------------
      END
*DECK STOD
      SUBROUTINE STOD (NEQ, Y, YH, NYH, YH1, EWT, SAVF, ACOR, WM, IWM,
     +   F, JAC, RPAR, IPAR)
C***BEGIN PROLOGUE  STOD
C***SUBSIDIARY
C***PURPOSE  Subsidiary to DEBDF
C***LIBRARY   SLATEC
C***TYPE      SINGLE PRECISION (STOD-S, DSTOD-D)
C***AUTHOR  Watts, H. A., (SNLA)
C***DESCRIPTION
C
C   STOD integrates a system of first order odes over one step in the
C   integrator package DEBDF.
C ----------------------------------------------------------------------
C STOD  performs one step of the integration of an initial value
C problem for a system of ordinary differential equations.
C Note.. STOD  is independent of the value of the iteration method
C indicator MITER, when this is .NE. 0, and hence is independent
C of the type of chord method used, or the Jacobian structure.
C Communication with STOD  is done with the following variables..
C
C Y      = An array of length .GE. n used as the Y argument in
C          all calls to F and JAC.
C NEQ    = Integer array containing problem size in NEQ(1), and
C          passed as the NEQ argument in all calls to F and JAC.
C YH     = An NYH by LMAX array containing the dependent variables
C          and their approximate scaled derivatives, where
C          LMAX = MAXORD + 1.  YH(I,J+1) contains the approximate
C          J-th derivative of Y(I), scaled by H**J/Factorial(j)
C          (J = 0,1,...,NQ).  On entry for the first step, the first
C          two columns of YH must be set from the initial values.
C NYH    = A constant integer .GE. N, the first dimension of YH.
C YH1    = A one-dimensional array occupying the same space as YH.
C EWT    = An array of N elements with which the estimated local
C          errors in YH are compared.
C SAVF   = An array of working storage, of length N.
C ACOR   = A work array of length N, used for the accumulated
C          corrections.  On a successful return, ACOR(I) contains
C          the estimated one-step local error in Y(I).
C WM,IWM = Real and integer work arrays associated with matrix
C          operations in chord iteration (MITER .NE. 0).
C PJAC   = Name of routine to evaluate and preprocess Jacobian matrix
C          if a chord method is being used.
C SLVS   = Name of routine to solve linear system in chord iteration.
C H      = The step size to be attempted on the next step.
C          H is altered by the error control algorithm during the
C          problem.  H can be either positive or negative, but its
C          sign must remain constant throughout the problem.
C HMIN   = The minimum absolute value of the step size H to be used.
C HMXI   = Inverse of the maximum absolute value of H to be used.
C          HMXI = 0.0 is allowed and corresponds to an infinite HMAX.
C          HMIN and HMXI may be changed at any time, but will not
C          take effect until the next change of H is considered.
C TN     = The independent variable. TN is updated on each step taken.
C JSTART = An integer used for input only, with the following
C          values and meanings..
C               0  Perform the first step.
C           .GT.0  Take a new step continuing from the last.
C              -1  Take the next step with a new value of H, MAXORD,
C                    N, METH, MITER, and/or matrix parameters.
C              -2  Take the next step with a new value of H,
C                    but with other inputs unchanged.
C          On return, JSTART is set to 1 to facilitate continuation.
C KFLAG  = a completion code with the following meanings..
C               0  The step was successful.
C              -1  The requested error could not be achieved.
C              -2  Corrector convergence could not be achieved.
C          A return with KFLAG = -1 or -2 means either
C          ABS(H) = HMIN or 10 consecutive failures occurred.
C          On a return with KFLAG negative, the values of TN and
C          the YH array are as of the beginning of the last
C          step, and H is the last step size attempted.
C MAXORD = The maximum order of integration method to be allowed.
C METH/MITER = The method flags.  See description in driver.
C N      = The number of first-order differential equations.
C ----------------------------------------------------------------------
C
C***SEE ALSO  DEBDF
C***ROUTINES CALLED  CFOD, PJAC, SLVS, VNWRMS
C***COMMON BLOCKS    DEBDF1
C***REVISION HISTORY  (YYMMDD)
C   800901  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900328  Added TYPE section.  (WRB)
C   910722  Updated AUTHOR section.  (ALS)
C   920422  Changed DIMENSION statement.  (WRB)
C***END PROLOGUE  STOD
      EXTERNAL F, JAC
C
CLLL. OPTIMIZE
      INTEGER NEQ, NYH, IWM, I, I1, IALTH, IER, IOWND, IREDO, IRET,
     1   IPUP, J, JB, JSTART, KFLAG, L, LMAX, M, MAXORD, MEO, METH,
     2   MITER, N, NCF, NEWQ, NFE, NJE, NQ, NQNYH, NQU, NST, NSTEPJ
      REAL Y, YH, YH1, EWT, SAVF, ACOR, WM,
     1   ROWND, CONIT, CRATE, EL, ELCO, HOLD, RC, RMAX, TESCO,
     2   EL0, H, HMIN, HMXI, HU, TN, UROUND,
     3   DCON, DDN, DEL, DELP, DSM, DUP, EXDN, EXSM, EXUP,
     4   R, RH, RHDN, RHSM, RHUP, TOLD, VNWRMS
      DIMENSION         Y(*), YH(NYH,*), YH1(*), EWT(*), SAVF(*),
     1   ACOR(*), WM(*), IWM(*), RPAR(*), IPAR(*)
      COMMON /DEBDF1/ ROWND, CONIT, CRATE, EL(13), ELCO(13,12),
     1   HOLD, RC, RMAX, TESCO(3,12),
     2   EL0, H, HMIN, HMXI, HU, TN, UROUND, IOWND(7), KSTEPS, IOD(6),
     3   IALTH, IPUP, LMAX, MEO, NQNYH, NSTEPJ,
     4   IER, JSTART, KFLAG, L, METH, MITER, MAXORD, N, NQ, NST, NFE,
     5   NJE, NQU
C
C
C***FIRST EXECUTABLE STATEMENT  STOD
      KFLAG = 0
      TOLD = TN
      NCF = 0
      IF (JSTART .GT. 0) GO TO 200
      IF (JSTART .EQ. -1) GO TO 100
      IF (JSTART .EQ. -2) GO TO 160
C-----------------------------------------------------------------------
C ON THE FIRST CALL, THE ORDER IS SET TO 1, AND OTHER VARIABLES ARE
C INITIALIZED.  RMAX IS THE MAXIMUM RATIO BY WHICH H CAN BE INCREASED
C IN A SINGLE STEP.  IT IS INITIALLY 1.E4 TO COMPENSATE FOR THE SMALL
C INITIAL H, BUT THEN IS NORMALLY EQUAL TO 10.  IF A FAILURE
C OCCURS (IN CORRECTOR CONVERGENCE OR ERROR TEST), RMAX IS SET AT 2
C FOR THE NEXT INCREASE.
C-----------------------------------------------------------------------
      LMAX = MAXORD + 1
      NQ = 1
      L = 2
      IALTH = 2
      RMAX = 10000.0E0
      RC = 0.0E0
      EL0 = 1.0E0
      CRATE = 0.7E0
      DELP = 0.0E0
      HOLD = H
      MEO = METH
      NSTEPJ = 0
      IRET = 3
      GO TO 140
C-----------------------------------------------------------------------
C THE FOLLOWING BLOCK HANDLES PRELIMINARIES NEEDED WHEN JSTART = -1.
C IPUP IS SET TO MITER TO FORCE A MATRIX UPDATE.
C IF AN ORDER INCREASE IS ABOUT TO BE CONSIDERED (IALTH = 1),
C IALTH IS RESET TO 2 TO POSTPONE CONSIDERATION ONE MORE STEP.
C IF THE CALLER HAS CHANGED METH, CFOD  IS CALLED TO RESET
C THE COEFFICIENTS OF THE METHOD.
C IF THE CALLER HAS CHANGED MAXORD TO A VALUE LESS THAN THE CURRENT
C ORDER NQ, NQ IS REDUCED TO MAXORD, AND A NEW H CHOSEN ACCORDINGLY.
C IF H IS TO BE CHANGED, YH MUST BE RESCALED.
C IF H OR METH IS BEING CHANGED, IALTH IS RESET TO L = NQ + 1
C TO PREVENT FURTHER CHANGES IN H FOR THAT MANY STEPS.
C-----------------------------------------------------------------------
 100  IPUP = MITER
      LMAX = MAXORD + 1
      IF (IALTH .EQ. 1) IALTH = 2
      IF (METH .EQ. MEO) GO TO 110
      CALL CFOD  (METH, ELCO, TESCO)
      MEO = METH
      IF (NQ .GT. MAXORD) GO TO 120
      IALTH = L
      IRET = 1
      GO TO 150
 110  IF (NQ .LE. MAXORD) GO TO 160
 120  NQ = MAXORD
      L = LMAX
      DO 125 I = 1,L
 125    EL(I) = ELCO(I,NQ)
      NQNYH = NQ*NYH
      RC = RC*EL(1)/EL0
      EL0 = EL(1)
      CONIT = 0.5E0/(NQ+2)
      DDN = VNWRMS (N, SAVF, EWT)/TESCO(1,L)
      EXDN = 1.0E0/L
      RHDN = 1.0E0/(1.3E0*DDN**EXDN + 0.0000013E0)
      RH = MIN(RHDN,1.0E0)
      IREDO = 3
      IF (H .EQ. HOLD) GO TO 170
      RH = MIN(RH,ABS(H/HOLD))
      H = HOLD
      GO TO 175
C-----------------------------------------------------------------------
C CFOD  IS CALLED TO GET ALL THE INTEGRATION COEFFICIENTS FOR THE
C CURRENT METH.  THEN THE EL VECTOR AND RELATED CONSTANTS ARE RESET
C WHENEVER THE ORDER NQ IS CHANGED, OR AT THE START OF THE PROBLEM.
C-----------------------------------------------------------------------
 140  CALL CFOD  (METH, ELCO, TESCO)
 150  DO 155 I = 1,L
 155    EL(I) = ELCO(I,NQ)
      NQNYH = NQ*NYH
      RC = RC*EL(1)/EL0
      EL0 = EL(1)
      CONIT = 0.5E0/(NQ+2)
      GO TO (160, 170, 200), IRET
C-----------------------------------------------------------------------
C IF H IS BEING CHANGED, THE H RATIO RH IS CHECKED AGAINST
C RMAX, HMIN, AND HMXI, AND THE YH ARRAY RESCALED.  IALTH IS SET TO
C L = NQ + 1 TO PREVENT A CHANGE OF H FOR THAT MANY STEPS, UNLESS
C FORCED BY A CONVERGENCE OR ERROR TEST FAILURE.
C-----------------------------------------------------------------------
 160  IF (H .EQ. HOLD) GO TO 200
      RH = H/HOLD
      H = HOLD
      IREDO = 3
      GO TO 175
 170  RH = MAX(RH,HMIN/ABS(H))
 175  RH = MIN(RH,RMAX)
      RH = RH/MAX(1.0E0,ABS(H)*HMXI*RH)
      R = 1.0E0
      DO 180 J = 2,L
        R = R*RH
        DO 180 I = 1,N
 180      YH(I,J) = YH(I,J)*R
      H = H*RH
      RC = RC*RH
      IALTH = L
      IF (IREDO .EQ. 0) GO TO 680
C-----------------------------------------------------------------------
C THIS SECTION COMPUTES THE PREDICTED VALUES BY EFFECTIVELY
C MULTIPLYING THE YH ARRAY BY THE PASCAL TRIANGLE MATRIX.
C RC IS THE RATIO OF NEW TO OLD VALUES OF THE COEFFICIENT  H*EL(1).
C WHEN RC DIFFERS FROM 1 BY MORE THAN 30 PERCENT, IPUP IS SET TO MITER
C TO FORCE PJAC TO BE CALLED, IF A JACOBIAN IS INVOLVED.
C IN ANY CASE, PJAC IS CALLED AT LEAST EVERY 20-TH STEP.
C-----------------------------------------------------------------------
 200  IF (ABS(RC-1.0E0) .GT. 0.3E0) IPUP = MITER
      IF (NST .GE. NSTEPJ+20) IPUP = MITER
      TN = TN + H
      I1 = NQNYH + 1
      DO 215 JB = 1,NQ
        I1 = I1 - NYH
        DO 210 I = I1,NQNYH
 210      YH1(I) = YH1(I) + YH1(I+NYH)
 215    CONTINUE
      KSTEPS = KSTEPS + 1
C-----------------------------------------------------------------------
C UP TO 3 CORRECTOR ITERATIONS ARE TAKEN.  A CONVERGENCE TEST IS
C MADE ON THE R.M.S. NORM OF EACH CORRECTION, WEIGHTED BY THE ERROR
C WEIGHT VECTOR EWT.  THE SUM OF THE CORRECTIONS IS ACCUMULATED IN THE
C VECTOR ACOR(I).  THE YH ARRAY IS NOT ALTERED IN THE CORRECTOR LOOP.
C-----------------------------------------------------------------------
 220  M = 0
      DO 230 I = 1,N
 230    Y(I) = YH(I,1)
      CALL F (TN, Y, SAVF, RPAR, IPAR)
      NFE = NFE + 1
      IF (IPUP .LE. 0) GO TO 250
C-----------------------------------------------------------------------
C IF INDICATED, THE MATRIX P = I - H*EL(1)*J IS REEVALUATED AND
C PREPROCESSED BEFORE STARTING THE CORRECTOR ITERATION.  IPUP IS SET
C TO 0 AS AN INDICATOR THAT THIS HAS BEEN DONE.
C-----------------------------------------------------------------------
      IPUP = 0
      RC = 1.0E0
      NSTEPJ = NST
      CRATE = 0.7E0
      CALL PJAC (NEQ, Y, YH, NYH, EWT, ACOR, SAVF, WM, IWM, F, JAC,
     1          RPAR, IPAR)
      IF (IER .NE. 0) GO TO 430
 250  DO 260 I = 1,N
 260    ACOR(I) = 0.0E0
 270  IF (MITER .NE. 0) GO TO 350
C-----------------------------------------------------------------------
C IN THE CASE OF FUNCTIONAL ITERATION, UPDATE Y DIRECTLY FROM
C THE RESULT OF THE LAST FUNCTION EVALUATION.
C-----------------------------------------------------------------------
      DO 290 I = 1,N
        SAVF(I) = H*SAVF(I) - YH(I,2)
 290    Y(I) = SAVF(I) - ACOR(I)
      DEL = VNWRMS (N, Y, EWT)
      DO 300 I = 1,N
        Y(I) = YH(I,1) + EL(1)*SAVF(I)
 300    ACOR(I) = SAVF(I)
      GO TO 400
C-----------------------------------------------------------------------
C IN THE CASE OF THE CHORD METHOD, COMPUTE THE CORRECTOR ERROR,
C AND SOLVE THE LINEAR SYSTEM WITH THAT AS RIGHT-HAND SIDE AND
C P AS COEFFICIENT MATRIX.
C-----------------------------------------------------------------------
 350  DO 360 I = 1,N
 360    Y(I) = H*SAVF(I) - (YH(I,2) + ACOR(I))
      CALL SLVS (WM, IWM, Y, SAVF)
      IF (IER .NE. 0) GO TO 410
      DEL = VNWRMS (N, Y, EWT)
      DO 380 I = 1,N
        ACOR(I) = ACOR(I) + Y(I)
 380    Y(I) = YH(I,1) + EL(1)*ACOR(I)
C-----------------------------------------------------------------------
C TEST FOR CONVERGENCE.  IF M.GT.0, AN ESTIMATE OF THE CONVERGENCE
C RATE CONSTANT IS STORED IN CRATE, AND THIS IS USED IN THE TEST.
C-----------------------------------------------------------------------
 400  IF (M .NE. 0) CRATE = MAX(0.2E0*CRATE,DEL/DELP)
      DCON = DEL*MIN(1.0E0,1.5E0*CRATE)/(TESCO(2,NQ)*CONIT)
      IF (DCON .LE. 1.0E0) GO TO 450
      M = M + 1
      IF (M .EQ. 3) GO TO 410
      IF (M .GE. 2 .AND. DEL .GT. 2.0E0*DELP) GO TO 410
      DELP = DEL
      CALL F (TN, Y, SAVF, RPAR, IPAR)
      NFE = NFE + 1
      GO TO 270
C-----------------------------------------------------------------------
C THE CORRECTOR ITERATION FAILED TO CONVERGE IN 3 TRIES.
C IF MITER .NE. 0 AND THE JACOBIAN IS OUT OF DATE, PJAC IS CALLED FOR
C THE NEXT TRY.  OTHERWISE THE YH ARRAY IS RETRACTED TO ITS VALUES
C BEFORE PREDICTION, AND H IS REDUCED, IF POSSIBLE.  IF H CANNOT BE
C REDUCED OR 10 FAILURES HAVE OCCURRED, EXIT WITH KFLAG = -2.
C-----------------------------------------------------------------------
 410  IF (IPUP .EQ. 0) GO TO 430
      IPUP = MITER
      GO TO 220
 430  TN = TOLD
      NCF = NCF + 1
      RMAX = 2.0E0
      I1 = NQNYH + 1
      DO 445 JB = 1,NQ
        I1 = I1 - NYH
        DO 440 I = I1,NQNYH
 440      YH1(I) = YH1(I) - YH1(I+NYH)
 445    CONTINUE
      IF (ABS(H) .LE. HMIN*1.00001E0) GO TO 670
      IF (NCF .EQ. 10) GO TO 670
      RH = 0.25E0
      IPUP = MITER
      IREDO = 1
      GO TO 170
C-----------------------------------------------------------------------
C THE CORRECTOR HAS CONVERGED.  IPUP IS SET TO -1 IF MITER .NE. 0,
C TO SIGNAL THAT THE JACOBIAN INVOLVED MAY NEED UPDATING LATER.
C THE LOCAL ERROR TEST IS MADE AND CONTROL PASSES TO STATEMENT 500
C IF IT FAILS.
C-----------------------------------------------------------------------
 450  IF (MITER .NE. 0) IPUP = -1
      IF (M .EQ. 0) DSM = DEL/TESCO(2,NQ)
      IF (M .GT. 0) DSM = VNWRMS (N, ACOR, EWT)/TESCO(2,NQ)
      IF (DSM .GT. 1.0E0) GO TO 500
C-----------------------------------------------------------------------
C AFTER A SUCCESSFUL STEP, UPDATE THE YH ARRAY.
C CONSIDER CHANGING H IF IALTH = 1.  OTHERWISE DECREASE IALTH BY 1.
C IF IALTH IS THEN 1 AND NQ .LT. MAXORD, THEN ACOR IS SAVED FOR
C USE IN A POSSIBLE ORDER INCREASE ON THE NEXT STEP.
C IF A CHANGE IN H IS CONSIDERED, AN INCREASE OR DECREASE IN ORDER
C BY ONE IS CONSIDERED ALSO.  A CHANGE IN H IS MADE ONLY IF IT IS BY A
C FACTOR OF AT LEAST 1.1.  IF NOT, IALTH IS SET TO 3 TO PREVENT
C TESTING FOR THAT MANY STEPS.
C-----------------------------------------------------------------------
      KFLAG = 0
      IREDO = 0
      NST = NST + 1
      HU = H
      NQU = NQ
      DO 470 J = 1,L
        DO 470 I = 1,N
 470      YH(I,J) = YH(I,J) + EL(J)*ACOR(I)
      IALTH = IALTH - 1
      IF (IALTH .EQ. 0) GO TO 520
      IF (IALTH .GT. 1) GO TO 690
      IF (L .EQ. LMAX) GO TO 690
      DO 490 I = 1,N
 490    YH(I,LMAX) = ACOR(I)
      GO TO 690
C-----------------------------------------------------------------------
C THE ERROR TEST FAILED.  KFLAG KEEPS TRACK OF MULTIPLE FAILURES.
C RESTORE TN AND THE YH ARRAY TO THEIR PREVIOUS VALUES, AND PREPARE
C TO TRY THE STEP AGAIN.  COMPUTE THE OPTIMUM STEP SIZE FOR THIS OR
C ONE LOWER ORDER.  AFTER 2 OR MORE FAILURES, H IS FORCED TO DECREASE
C BY A FACTOR OF 0.2 OR LESS.
C-----------------------------------------------------------------------
 500  KFLAG = KFLAG - 1
      TN = TOLD
      I1 = NQNYH + 1
      DO 515 JB = 1,NQ
        I1 = I1 - NYH
        DO 510 I = I1,NQNYH
 510      YH1(I) = YH1(I) - YH1(I+NYH)
 515    CONTINUE
      RMAX = 2.0E0
      IF (ABS(H) .LE. HMIN*1.00001E0) GO TO 660
      IF (KFLAG .LE. -3) GO TO 640
      IREDO = 2
      RHUP = 0.0E0
      GO TO 540
C-----------------------------------------------------------------------
C REGARDLESS OF THE SUCCESS OR FAILURE OF THE STEP, FACTORS
C RHDN, RHSM, AND RHUP ARE COMPUTED, BY WHICH H COULD BE MULTIPLIED
C AT ORDER NQ - 1, ORDER NQ, OR ORDER NQ + 1, RESPECTIVELY.
C IN THE CASE OF FAILURE, RHUP = 0.0 TO AVOID AN ORDER INCREASE.
C THE LARGEST OF THESE IS DETERMINED AND THE NEW ORDER CHOSEN
C ACCORDINGLY.  IF THE ORDER IS TO BE INCREASED, WE COMPUTE ONE
C ADDITIONAL SCALED DERIVATIVE.
C-----------------------------------------------------------------------
 520  RHUP = 0.0E0
      IF (L .EQ. LMAX) GO TO 540
      DO 530 I = 1,N
 530    SAVF(I) = ACOR(I) - YH(I,LMAX)
      DUP = VNWRMS (N, SAVF, EWT)/TESCO(3,NQ)
      EXUP = 1.0E0/(L+1)
      RHUP = 1.0E0/(1.4E0*DUP**EXUP + 0.0000014E0)
 540  EXSM = 1.0E0/L
      RHSM = 1.0E0/(1.2E0*DSM**EXSM + 0.0000012E0)
      RHDN = 0.0E0
      IF (NQ .EQ. 1) GO TO 560
      DDN = VNWRMS (N, YH(1,L), EWT)/TESCO(1,NQ)
      EXDN = 1.0E0/NQ
      RHDN = 1.0E0/(1.3E0*DDN**EXDN + 0.0000013E0)
 560  IF (RHSM .GE. RHUP) GO TO 570
      IF (RHUP .GT. RHDN) GO TO 590
      GO TO 580
 570  IF (RHSM .LT. RHDN) GO TO 580
      NEWQ = NQ
      RH = RHSM
      GO TO 620
 580  NEWQ = NQ - 1
      RH = RHDN
      IF (KFLAG .LT. 0 .AND. RH .GT. 1.0E0) RH = 1.0E0
      GO TO 620
 590  NEWQ = L
      RH = RHUP
      IF (RH .LT. 1.1E0) GO TO 610
      R = EL(L)/L
      DO 600 I = 1,N
 600    YH(I,NEWQ+1) = ACOR(I)*R
      GO TO 630
 610  IALTH = 3
      GO TO 690
 620  IF ((KFLAG .EQ. 0) .AND. (RH .LT. 1.1E0)) GO TO 610
      IF (KFLAG .LE. -2) RH = MIN(RH,0.2E0)
C-----------------------------------------------------------------------
C IF THERE IS A CHANGE OF ORDER, RESET NQ, L, AND THE COEFFICIENTS.
C IN ANY CASE H IS RESET ACCORDING TO RH AND THE YH ARRAY IS RESCALED.
C THEN EXIT FROM 680 IF THE STEP WAS OK, OR REDO THE STEP OTHERWISE.
C-----------------------------------------------------------------------
      IF (NEWQ .EQ. NQ) GO TO 170
 630  NQ = NEWQ
      L = NQ + 1
      IRET = 2
      GO TO 150
C-----------------------------------------------------------------------
C CONTROL REACHES THIS SECTION IF 3 OR MORE FAILURES HAVE OCCURRED.
C IF 10 FAILURES HAVE OCCURRED, EXIT WITH KFLAG = -1.
C IT IS ASSUMED THAT THE DERIVATIVES THAT HAVE ACCUMULATED IN THE
C YH ARRAY HAVE ERRORS OF THE WRONG ORDER.  HENCE THE FIRST
C DERIVATIVE IS RECOMPUTED, AND THE ORDER IS SET TO 1.  THEN
C H IS REDUCED BY A FACTOR OF 10, AND THE STEP IS RETRIED,
C UNTIL IT SUCCEEDS OR H REACHES HMIN.
C-----------------------------------------------------------------------
 640  IF (KFLAG .EQ. -10) GO TO 660
      RH = 0.1E0
      RH = MAX(HMIN/ABS(H),RH)
      H = H*RH
      DO 645 I = 1,N
 645    Y(I) = YH(I,1)
      CALL F (TN, Y, SAVF, RPAR, IPAR)
      NFE = NFE + 1
      DO 650 I = 1,N
 650    YH(I,2) = H*SAVF(I)
      IPUP = MITER
      IALTH = 5
      IF (NQ .EQ. 1) GO TO 200
      NQ = 1
      L = 2
      IRET = 3
      GO TO 150
C-----------------------------------------------------------------------
C ALL RETURNS ARE MADE THROUGH THIS SECTION.  H IS SAVED IN HOLD
C TO ALLOW THE CALLER TO CHANGE H ON THE NEXT STEP.
C-----------------------------------------------------------------------
 660  KFLAG = -1
      GO TO 700
 670  KFLAG = -2
      GO TO 700
 680  RMAX = 10.0E0
 690  R = 1.0E0/TESCO(2,NQU)
      DO 695 I = 1,N
 695    ACOR(I) = ACOR(I)*R
 700  HOLD = H
      JSTART = 1
      RETURN
C----------------------- END OF SUBROUTINE STOD  -----------------------
      END
*DECK STOR1
      SUBROUTINE STOR1 (U, YH, V, YP, NTEMP, NDISK, NTAPE)
C***BEGIN PROLOGUE  STOR1
C***SUBSIDIARY
C***PURPOSE  Subsidiary to BVSUP
C***LIBRARY   SLATEC
C***TYPE      SINGLE PRECISION (STOR1-S, DSTOR1-D)
C***AUTHOR  Watts, H. A., (SNLA)
C***DESCRIPTION
C
C **********************************************************************
C             0 -- Storage at output points.
C     NTEMP =
C             1 -- Temporary storage
C **********************************************************************
C
C***SEE ALSO  BVSUP
C***ROUTINES CALLED  (NONE)
C***COMMON BLOCKS    ML8SZ
C***REVISION HISTORY  (YYMMDD)
C   750601  DATE WRITTEN
C   890921  Realigned order of variables in certain COMMON blocks.
C           (WRB)
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900328  Added TYPE section.  (WRB)
C   910722  Updated AUTHOR section.  (ALS)
C***END PROLOGUE  STOR1
      DIMENSION U(*),YH(*),V(*),YP(*)
C
C **********************************************************************
C
      COMMON /ML8SZ/ C,XSAV,IGOFX,INHOMO,IVP,NCOMP,NFC
C
C **********************************************************************
C
C***FIRST EXECUTABLE STATEMENT  STOR1
      NCTNF = NCOMP * NFC
      DO 10 J = 1,NCTNF
   10 U(J) = YH(J)
      IF (INHOMO .EQ. 1)  GO TO 30
C
C   ZERO PARTICULAR SOLUTION
C
      IF (NTEMP .EQ. 1)  RETURN
      DO 20 J = 1,NCOMP
   20 V(J) = 0.
      GO TO 70
C
C   NONZERO PARTICULAR SOLUTION
C
   30 IF (NTEMP .EQ. 0)  GO TO 50
C
      DO 40 J = 1,NCOMP
   40 V(J) = YP(J)
      RETURN
C
   50 DO 60 J = 1,NCOMP
   60 V(J) = C * YP(J)
C
C  IS OUTPUT INFORMATION TO BE WRITTEN TO DISK
C
   70 IF (NDISK .EQ. 1)  WRITE (NTAPE) (V(J),J=1,NCOMP),(U(J),J=1,NCTNF)
C
      RETURN
      END
*DECK STOUT
      SUBROUTINE STOUT (N, NELT, IA, JA, A, ISYM, SOLN, RHS, IUNIT, JOB)
C***BEGIN PROLOGUE  STOUT
C***PURPOSE  Write out SLAP Triad Format Linear System.
C            Routine to write out a SLAP Triad format matrix and right
C            hand side and solution to the system, if known.
C***LIBRARY   SLATEC (SLAP)
C***CATEGORY  N1
C***TYPE      SINGLE PRECISION (STOUT-S, DTOUT-D)
C***KEYWORDS  DIAGNOSTICS, LINEAR SYSTEM, SLAP SPARSE
C***AUTHOR  Seager, Mark K., (LLNL)
C             Lawrence Livermore National Laboratory
C             PO BOX 808, L-60
C             Livermore, CA 94550 (510) 423-3141
C             seager@llnl.gov
C***DESCRIPTION
C
C *Usage:
C     INTEGER N, NELT, IA(NELT), JA(NELT), ISYM, IUNIT, JOB
C     REAL    A(NELT), SOLN(N), RHS(N)
C
C     CALL STOUT( N, NELT, IA, JA, A, ISYM, SOLN, RHS, IUNIT, JOB )
C
C *Arguments:
C N      :IN       Integer
C         Order of the Matrix.
C NELT   :IN       Integer.
C         Number of non-zeros stored in A.
C IA     :IN       Integer IA(NELT).
C JA     :IN       Integer JA(NELT).
C A      :IN       Real A(NELT).
C         These arrays should hold the matrix A in the SLAP
C         Triad format.  See "Description", below.
C ISYM   :IN       Integer.
C         Flag to indicate symmetric storage format.
C         If ISYM=0, all non-zero entries of the matrix are stored.
C         If ISYM=1, the matrix is symmetric, and only the lower
C         triangle of the matrix is stored.
C SOLN   :IN       Real SOLN(N).
C         The solution to the linear system, if known.  This array
C         is accessed if and only if JOB is set to print it out,
C         see below.
C RHS    :IN       Real RHS(N).
C         The right hand side vector.  This array is accessed if and
C         only if JOB is set to print it out, see below.
C IUNIT  :IN       Integer.
C         Fortran logical I/O device unit number to write the matrix
C         to.  This unit must be connected in a system dependent fashion
C         to a file or the console or you will get a nasty message
C         from the Fortran I/O libraries.
C JOB    :IN       Integer.
C         Flag indicating what I/O operations to perform.
C         JOB = 0 => Print only the matrix.
C             = 1 => Print matrix and RHS.
C             = 2 => Print matrix and SOLN.
C             = 3 => Print matrix, RHS and SOLN.
C
C *Description:
C       The format for the output is as follows.  On  the first line
C       are counters and flags: N, NELT, ISYM, IRHS, ISOLN.  N, NELT
C       and ISYM are described above.  IRHS is  a flag indicating if
C       the RHS was  written out (1 is  yes, 0 is  no).  ISOLN  is a
C       flag indicating if the SOLN was written out  (1 is yes, 0 is
C       no).  The format for the fist line is: 5i10.  Then comes the
C       NELT Triad's IA(I), JA(I) and A(I), I = 1, NELT.  The format
C       for  these lines is   :  1X,I5,1X,I5,1X,E16.7.   Then  comes
C       RHS(I), I = 1, N, if IRHS = 1.  Then  comes SOLN(I), I  = 1,
C       N, if ISOLN = 1.  The format for these lines is: 1X,E16.7.
C
C       =================== S L A P Triad format ===================
C       This routine requires that the  matrix A be   stored in  the
C       SLAP  Triad format.  In  this format only the non-zeros  are
C       stored.  They may appear in  *ANY* order.  The user supplies
C       three arrays of  length NELT, where  NELT is  the number  of
C       non-zeros in the matrix: (IA(NELT), JA(NELT), A(NELT)).  For
C       each non-zero the user puts the row and column index of that
C       matrix element  in the IA and  JA arrays.  The  value of the
C       non-zero  matrix  element is  placed   in  the corresponding
C       location of the A array.   This is  an  extremely  easy data
C       structure to generate.  On  the  other hand it   is  not too
C       efficient on vector computers for  the iterative solution of
C       linear systems.  Hence,   SLAP changes   this  input    data
C       structure to the SLAP Column format  for  the iteration (but
C       does not change it back).
C
C       Here is an example of the  SLAP Triad   storage format for a
C       5x5 Matrix.  Recall that the entries may appear in any order.
C
C           5x5 Matrix      SLAP Triad format for 5x5 matrix on left.
C                              1  2  3  4  5  6  7  8  9 10 11
C       |11 12  0  0 15|   A: 51 12 11 33 15 53 55 22 35 44 21
C       |21 22  0  0  0|  IA:  5  1  1  3  1  5  5  2  3  4  2
C       | 0  0 33  0 35|  JA:  1  2  1  3  5  3  5  2  5  4  1
C       | 0  0  0 44  0|
C       |51  0 53  0 55|
C
C *Cautions:
C     This routine will attempt to write to the Fortran logical output
C     unit IUNIT, if IUNIT .ne. 0.  Thus, the user must make sure that
C     this logical unit is attached to a file or terminal before calling
C     this routine with a non-zero value for IUNIT.  This routine does
C     not check for the validity of a non-zero IUNIT unit number.
C***REFERENCES  (NONE)
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   871119  DATE WRITTEN
C   881213  Previous REVISION DATE
C   890915  Made changes requested at July 1989 CML Meeting.  (MKS)
C   890922  Numerous changes to prologue to make closer to SLATEC
C           standard.  (FNF)
C   890929  Numerous changes to reduce SP/DP differences.  (FNF)
C   910411  Prologue converted to Version 4.0 format.  (BAB)
C   920511  Added complete declaration section.  (WRB)
C   930701  Updated CATEGORY section.  (FNF, WRB)
C***END PROLOGUE  STOUT
C     .. Scalar Arguments ..
      INTEGER ISYM, IUNIT, JOB, N, NELT
C     .. Array Arguments ..
      REAL A(NELT), RHS(N), SOLN(N)
      INTEGER IA(NELT), JA(NELT)
C     .. Local Scalars ..
      INTEGER I, IRHS, ISOLN
C***FIRST EXECUTABLE STATEMENT  STOUT
C
C         If RHS and SOLN are to be printed also.
C         Write out the information heading.
C
      IRHS = 0
      ISOLN = 0
      IF( JOB.EQ.1 .OR. JOB.EQ.3 ) IRHS = 1
      IF( JOB.GT.1 ) ISOLN = 1
      WRITE(IUNIT,1000) N, NELT, ISYM, IRHS, ISOLN
C
C         Write out the matrix non-zeros in Triad format.
      DO 10 I = 1, NELT
         WRITE(IUNIT,1010) IA(I), JA(I), A(I)
 10   CONTINUE
C
C         If requested, write out the rhs.
      IF( IRHS.EQ.1 ) THEN
         WRITE(IUNIT,1020) (RHS(I),I=1,N)
      ENDIF
C
C         If requested, write out the solution.
      IF( ISOLN.EQ.1 ) THEN
         WRITE(IUNIT,1020) (SOLN(I),I=1,N)
      ENDIF
      RETURN
 1000 FORMAT(5I10)
 1010 FORMAT(1X,I5,1X,I5,1X,E16.7)
 1020 FORMAT(1X,E16.7)
C------------- LAST LINE OF STOUT FOLLOWS ----------------------------
      END
*DECK STRCO
      SUBROUTINE STRCO (T, LDT, N, RCOND, Z, JOB)
C***BEGIN PROLOGUE  STRCO
C***PURPOSE  Estimate the condition number of a triangular matrix.
C***LIBRARY   SLATEC (LINPACK)
C***CATEGORY  D2A3
C***TYPE      SINGLE PRECISION (STRCO-S, DTRCO-D, CTRCO-C)
C***KEYWORDS  CONDITION NUMBER, LINEAR ALGEBRA, LINPACK,
C             TRIANGULAR MATRIX
C***AUTHOR  Moler, C. B., (U. of New Mexico)
C***DESCRIPTION
C
C     STRCO estimates the condition of a real triangular matrix.
C
C     On Entry
C
C        T       REAL(LDT,N)
C                T contains the triangular matrix.  The zero
C                elements of the matrix are not referenced, and
C                the corresponding elements of the array can be
C                used to store other information.
C
C        LDT     INTEGER
C                LDT is the leading dimension of the array T.
C
C        N       INTEGER
C                N is the order of the system.
C
C        JOB     INTEGER
C                = 0         T  is lower triangular.
C                = nonzero   T  is upper triangular.
C
C     On Return
C
C        RCOND   REAL
C                an estimate of the reciprocal condition of  T .
C                For the system  T*X = B , relative perturbations
C                in  T  and  B  of size  EPSILON  may cause
C                relative perturbations in  X  of size  EPSILON/RCOND .
C                If  RCOND  is so small that the logical expression
C                           1.0 + RCOND .EQ. 1.0
C                is true, then  T  may be singular to working
C                precision.  In particular,  RCOND  is zero  if
C                exact singularity is detected or the estimate
C                underflows.
C
C        Z       REAL(N)
C                a work vector whose contents are usually unimportant.
C                If  T  is close to a singular matrix, then  Z  is
C                an approximate null vector in the sense that
C                NORM(A*Z) = RCOND*NORM(A)*NORM(Z) .
C
C***REFERENCES  J. J. Dongarra, J. R. Bunch, C. B. Moler, and G. W.
C                 Stewart, LINPACK Users' Guide, SIAM, 1979.
C***ROUTINES CALLED  SASUM, SAXPY, SSCAL
C***REVISION HISTORY  (YYMMDD)
C   780814  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890831  Modified array declarations.  (WRB)
C   890831  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900326  Removed duplicate information from DESCRIPTION section.
C           (WRB)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  STRCO
      INTEGER LDT,N,JOB
      REAL T(LDT,*),Z(*)
      REAL RCOND
C
      REAL W,WK,WKM,EK
      REAL TNORM,YNORM,S,SM,SASUM
      INTEGER I1,J,J1,J2,K,KK,L
      LOGICAL LOWER
C***FIRST EXECUTABLE STATEMENT  STRCO
      LOWER = JOB .EQ. 0
C
C     COMPUTE 1-NORM OF T
C
      TNORM = 0.0E0
      DO 10 J = 1, N
         L = J
         IF (LOWER) L = N + 1 - J
         I1 = 1
         IF (LOWER) I1 = J
         TNORM = MAX(TNORM,SASUM(L,T(I1,J),1))
   10 CONTINUE
C
C     RCOND = 1/(NORM(T)*(ESTIMATE OF NORM(INVERSE(T)))) .
C     ESTIMATE = NORM(Z)/NORM(Y) WHERE  T*Z = Y  AND  TRANS(T)*Y = E .
C     TRANS(T)  IS THE TRANSPOSE OF T .
C     THE COMPONENTS OF  E  ARE CHOSEN TO CAUSE MAXIMUM LOCAL
C     GROWTH IN THE ELEMENTS OF Y .
C     THE VECTORS ARE FREQUENTLY RESCALED TO AVOID OVERFLOW.
C
C     SOLVE TRANS(T)*Y = E
C
      EK = 1.0E0
      DO 20 J = 1, N
         Z(J) = 0.0E0
   20 CONTINUE
      DO 100 KK = 1, N
         K = KK
         IF (LOWER) K = N + 1 - KK
         IF (Z(K) .NE. 0.0E0) EK = SIGN(EK,-Z(K))
         IF (ABS(EK-Z(K)) .LE. ABS(T(K,K))) GO TO 30
            S = ABS(T(K,K))/ABS(EK-Z(K))
            CALL SSCAL(N,S,Z,1)
            EK = S*EK
   30    CONTINUE
         WK = EK - Z(K)
         WKM = -EK - Z(K)
         S = ABS(WK)
         SM = ABS(WKM)
         IF (T(K,K) .EQ. 0.0E0) GO TO 40
            WK = WK/T(K,K)
            WKM = WKM/T(K,K)
         GO TO 50
   40    CONTINUE
            WK = 1.0E0
            WKM = 1.0E0
   50    CONTINUE
         IF (KK .EQ. N) GO TO 90
            J1 = K + 1
            IF (LOWER) J1 = 1
            J2 = N
            IF (LOWER) J2 = K - 1
            DO 60 J = J1, J2
               SM = SM + ABS(Z(J)+WKM*T(K,J))
               Z(J) = Z(J) + WK*T(K,J)
               S = S + ABS(Z(J))
   60       CONTINUE
            IF (S .GE. SM) GO TO 80
               W = WKM - WK
               WK = WKM
               DO 70 J = J1, J2
                  Z(J) = Z(J) + W*T(K,J)
   70          CONTINUE
   80       CONTINUE
   90    CONTINUE
         Z(K) = WK
  100 CONTINUE
      S = 1.0E0/SASUM(N,Z,1)
      CALL SSCAL(N,S,Z,1)
C
      YNORM = 1.0E0
C
C     SOLVE T*Z = Y
C
      DO 130 KK = 1, N
         K = N + 1 - KK
         IF (LOWER) K = KK
         IF (ABS(Z(K)) .LE. ABS(T(K,K))) GO TO 110
            S = ABS(T(K,K))/ABS(Z(K))
            CALL SSCAL(N,S,Z,1)
            YNORM = S*YNORM
  110    CONTINUE
         IF (T(K,K) .NE. 0.0E0) Z(K) = Z(K)/T(K,K)
         IF (T(K,K) .EQ. 0.0E0) Z(K) = 1.0E0
         I1 = 1
         IF (LOWER) I1 = K + 1
         IF (KK .GE. N) GO TO 120
            W = -Z(K)
            CALL SAXPY(N-KK,W,T(I1,K),1,Z(I1),1)
  120    CONTINUE
  130 CONTINUE
C     MAKE ZNORM = 1.0
      S = 1.0E0/SASUM(N,Z,1)
      CALL SSCAL(N,S,Z,1)
      YNORM = S*YNORM
C
      IF (TNORM .NE. 0.0E0) RCOND = YNORM/TNORM
      IF (TNORM .EQ. 0.0E0) RCOND = 0.0E0
      RETURN
      END
*DECK STRDI
      SUBROUTINE STRDI (T, LDT, N, DET, JOB, INFO)
C***BEGIN PROLOGUE  STRDI
C***PURPOSE  Compute the determinant and inverse of a triangular matrix.
C***LIBRARY   SLATEC (LINPACK)
C***CATEGORY  D2A3, D3A3
C***TYPE      SINGLE PRECISION (STRDI-S, DTRDI-D, CTRDI-C)
C***KEYWORDS  DETERMINANT, INVERSE, LINEAR ALGEBRA, LINPACK, MATRIX,
C             TRIANGULAR
C***AUTHOR  Moler, C. B., (U. of New Mexico)
C***DESCRIPTION
C
C     STRDI computes the determinant and inverse of a real
C     triangular matrix.
C
C     On Entry
C
C        T       REAL(LDT,N)
C                T contains the triangular matrix.  The zero
C                elements of the matrix are not referenced, and
C                the corresponding elements of the array can be
C                used to store other information.
C
C        LDT     INTEGER
C                LDT is the leading dimension of the array T.
C
C        N       INTEGER
C                N is the order of the system.
C
C        JOB     INTEGER
C                = 010       no det, inverse of lower triangular.
C                = 011       no det, inverse of upper triangular.
C                = 100       det, no inverse.
C                = 110       det, inverse of lower triangular.
C                = 111       det, inverse of upper triangular.
C
C     On Return
C
C        T       inverse of original matrix if requested.
C                Otherwise unchanged.
C
C        DET     REAL(2)
C                determinant of original matrix if requested.
C                Otherwise not referenced.
C                Determinant = DET(1) * 10.0**DET(2)
C                with  1.0 .LE. ABS(DET(1)) .LT. 10.0
C                or  DET(1) .EQ. 0.0 .
C
C        INFO    INTEGER
C                INFO contains zero if the system is nonsingular
C                and the inverse is requested.
C                Otherwise INFO contains the index of
C                a zero diagonal element of T.
C
C***REFERENCES  J. J. Dongarra, J. R. Bunch, C. B. Moler, and G. W.
C                 Stewart, LINPACK Users' Guide, SIAM, 1979.
C***ROUTINES CALLED  SAXPY, SSCAL
C***REVISION HISTORY  (YYMMDD)
C   780814  DATE WRITTEN
C   890831  Modified array declarations.  (WRB)
C   890831  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900326  Removed duplicate information from DESCRIPTION section.
C           (WRB)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  STRDI
      INTEGER LDT,N,JOB,INFO
      REAL T(LDT,*),DET(2)
C
      REAL TEMP
      REAL TEN
      INTEGER I,J,K,KB,KM1,KP1
C***FIRST EXECUTABLE STATEMENT  STRDI
C
C        COMPUTE DETERMINANT
C
         IF (JOB/100 .EQ. 0) GO TO 70
            DET(1) = 1.0E0
            DET(2) = 0.0E0
            TEN = 10.0E0
            DO 50 I = 1, N
               DET(1) = T(I,I)*DET(1)
               IF (DET(1) .EQ. 0.0E0) GO TO 60
   10          IF (ABS(DET(1)) .GE. 1.0E0) GO TO 20
                  DET(1) = TEN*DET(1)
                  DET(2) = DET(2) - 1.0E0
               GO TO 10
   20          CONTINUE
   30          IF (ABS(DET(1)) .LT. TEN) GO TO 40
                  DET(1) = DET(1)/TEN
                  DET(2) = DET(2) + 1.0E0
               GO TO 30
   40          CONTINUE
   50       CONTINUE
   60       CONTINUE
   70    CONTINUE
C
C        COMPUTE INVERSE OF UPPER TRIANGULAR
C
         IF (MOD(JOB/10,10) .EQ. 0) GO TO 170
            IF (MOD(JOB,10) .EQ. 0) GO TO 120
                  DO 100 K = 1, N
                     INFO = K
                     IF (T(K,K) .EQ. 0.0E0) GO TO 110
                     T(K,K) = 1.0E0/T(K,K)
                     TEMP = -T(K,K)
                     CALL SSCAL(K-1,TEMP,T(1,K),1)
                     KP1 = K + 1
                     IF (N .LT. KP1) GO TO 90
                     DO 80 J = KP1, N
                        TEMP = T(K,J)
                        T(K,J) = 0.0E0
                        CALL SAXPY(K,TEMP,T(1,K),1,T(1,J),1)
   80                CONTINUE
   90                CONTINUE
  100             CONTINUE
                  INFO = 0
  110          CONTINUE
            GO TO 160
  120       CONTINUE
C
C              COMPUTE INVERSE OF LOWER TRIANGULAR
C
               DO 150 KB = 1, N
                  K = N + 1 - KB
                  INFO = K
                  IF (T(K,K) .EQ. 0.0E0) GO TO 180
                  T(K,K) = 1.0E0/T(K,K)
                  TEMP = -T(K,K)
                  IF (K .NE. N) CALL SSCAL(N-K,TEMP,T(K+1,K),1)
                  KM1 = K - 1
                  IF (KM1 .LT. 1) GO TO 140
                  DO 130 J = 1, KM1
                     TEMP = T(K,J)
                     T(K,J) = 0.0E0
                     CALL SAXPY(N-K+1,TEMP,T(K,K),1,T(K,J),1)
  130             CONTINUE
  140             CONTINUE
  150          CONTINUE
               INFO = 0
  160       CONTINUE
  170    CONTINUE
  180 CONTINUE
      RETURN
      END
*DECK STRSL
      SUBROUTINE STRSL (T, LDT, N, B, JOB, INFO)
C***BEGIN PROLOGUE  STRSL
C***PURPOSE  Solve a system of the form  T*X=B or TRANS(T)*X=B, where
C            T is a triangular matrix.
C***LIBRARY   SLATEC (LINPACK)
C***CATEGORY  D2A3
C***TYPE      SINGLE PRECISION (STRSL-S, DTRSL-D, CTRSL-C)
C***KEYWORDS  LINEAR ALGEBRA, LINPACK, TRIANGULAR LINEAR SYSTEM,
C             TRIANGULAR MATRIX
C***AUTHOR  Stewart, G. W., (U. of Maryland)
C***DESCRIPTION
C
C     STRSL solves systems of the form
C
C                   T * X = B
C     or
C                   TRANS(T) * X = B
C
C     where T is a triangular matrix of order N.  Here TRANS(T)
C     denotes the transpose of the matrix T.
C
C     On Entry
C
C         T         REAL(LDT,N)
C                   T contains the matrix of the system.  The zero
C                   elements of the matrix are not referenced, and
C                   the corresponding elements of the array can be
C                   used to store other information.
C
C         LDT       INTEGER
C                   LDT is the leading dimension of the array T.
C
C         N         INTEGER
C                   N is the order of the system.
C
C         B         REAL(N).
C                   B contains the right hand side of the system.
C
C         JOB       INTEGER
C                   JOB specifies what kind of system is to be solved.
C                   If JOB is
C
C                        00   solve T*X=B, T lower triangular,
C                        01   solve T*X=B, T upper triangular,
C                        10   solve TRANS(T)*X=B, T lower triangular,
C                        11   solve TRANS(T)*X=B, T upper triangular.
C
C     On Return
C
C         B         B contains the solution, if INFO .EQ. 0.
C                   Otherwise B is unaltered.
C
C         INFO      INTEGER
C                   INFO contains zero if the system is nonsingular.
C                   Otherwise INFO contains the index of
C                   the first zero diagonal element of T.
C
C***REFERENCES  J. J. Dongarra, J. R. Bunch, C. B. Moler, and G. W.
C                 Stewart, LINPACK Users' Guide, SIAM, 1979.
C***ROUTINES CALLED  SAXPY, SDOT
C***REVISION HISTORY  (YYMMDD)
C   780814  DATE WRITTEN
C   890831  Modified array declarations.  (WRB)
C   890831  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900326  Removed duplicate information from DESCRIPTION section.
C           (WRB)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  STRSL
      INTEGER LDT,N,JOB,INFO
      REAL T(LDT,*),B(*)
C
C
      REAL SDOT,TEMP
      INTEGER CASE,J,JJ
C***FIRST EXECUTABLE STATEMENT  STRSL
C
C        CHECK FOR ZERO DIAGONAL ELEMENTS.
C
         DO 10 INFO = 1, N
            IF (T(INFO,INFO) .EQ. 0.0E0) GO TO 150
   10    CONTINUE
         INFO = 0
C
C        DETERMINE THE TASK AND GO TO IT.
C
         CASE = 1
         IF (MOD(JOB,10) .NE. 0) CASE = 2
         IF (MOD(JOB,100)/10 .NE. 0) CASE = CASE + 2
         GO TO (20,50,80,110), CASE
C
C        SOLVE T*X=B FOR T LOWER TRIANGULAR
C
   20    CONTINUE
            B(1) = B(1)/T(1,1)
            IF (N .LT. 2) GO TO 40
            DO 30 J = 2, N
               TEMP = -B(J-1)
               CALL SAXPY(N-J+1,TEMP,T(J,J-1),1,B(J),1)
               B(J) = B(J)/T(J,J)
   30       CONTINUE
   40       CONTINUE
         GO TO 140
C
C        SOLVE T*X=B FOR T UPPER TRIANGULAR.
C
   50    CONTINUE
            B(N) = B(N)/T(N,N)
            IF (N .LT. 2) GO TO 70
            DO 60 JJ = 2, N
               J = N - JJ + 1
               TEMP = -B(J+1)
               CALL SAXPY(J,TEMP,T(1,J+1),1,B(1),1)
               B(J) = B(J)/T(J,J)
   60       CONTINUE
   70       CONTINUE
         GO TO 140
C
C        SOLVE TRANS(T)*X=B FOR T LOWER TRIANGULAR.
C
   80    CONTINUE
            B(N) = B(N)/T(N,N)
            IF (N .LT. 2) GO TO 100
            DO 90 JJ = 2, N
               J = N - JJ + 1
               B(J) = B(J) - SDOT(JJ-1,T(J+1,J),1,B(J+1),1)
               B(J) = B(J)/T(J,J)
   90       CONTINUE
  100       CONTINUE
         GO TO 140
C
C        SOLVE TRANS(T)*X=B FOR T UPPER TRIANGULAR.
C
  110    CONTINUE
            B(1) = B(1)/T(1,1)
            IF (N .LT. 2) GO TO 130
            DO 120 J = 2, N
               B(J) = B(J) - SDOT(J-1,T(1,J),1,B(1),1)
               B(J) = B(J)/T(J,J)
  120       CONTINUE
  130       CONTINUE
  140    CONTINUE
  150 CONTINUE
      RETURN
      END
*DECK STWAY
      SUBROUTINE STWAY (U, V, YHP, INOUT, STOWA)
C***BEGIN PROLOGUE  STWAY
C***SUBSIDIARY
C***PURPOSE  Subsidiary to BVSUP
C***LIBRARY   SLATEC
C***TYPE      SINGLE PRECISION (STWAY-S, DSTWAY-D)
C***AUTHOR  Watts, H. A., (SNLA)
C***DESCRIPTION
C
C  This subroutine stores (recalls) integration data in the event
C  that a restart is needed (the homogeneous solution vectors become
C  too dependent to continue)
C
C***SEE ALSO  BVSUP
C***ROUTINES CALLED  STOR1
C***COMMON BLOCKS    ML15TO, ML18JR, ML8SZ
C***REVISION HISTORY  (YYMMDD)
C   750601  DATE WRITTEN
C   890921  Realigned order of variables in certain COMMON blocks.
C           (WRB)
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900328  Added TYPE section.  (WRB)
C   910722  Updated AUTHOR section.  (ALS)
C***END PROLOGUE  STWAY
C
      DIMENSION U(*),V(*),YHP(*),STOWA(*)
C
      COMMON /ML8SZ/ C,XSAV,IGOFX,INHOMO,IVP,NCOMP,NFC
      COMMON /ML15TO/ PX,PWCND,TND,X,XBEG,XEND,XOT,XOP,INFO(15),ISTKOP,
     1                KNSWOT,KOP,LOTJP,MNSWOT,NSWOT
      COMMON /ML18JR/ AE,RE,TOL,NXPTS,NIC,NOPG,MXNON,NDISK,NTAPE,NEQ,
     1                INDPVT,INTEG,NPS,NTP,NEQIVP,NUMORT,NFCC,
     2                ICOCO
C
C***FIRST EXECUTABLE STATEMENT  STWAY
      IF (INOUT .EQ. 1) GO TO 100
C
C     SAVE IN STOWA ARRAY AND ISTKOP
C
      KS=NFC*NCOMP
      CALL STOR1(STOWA,U,STOWA(KS+1),V,1,0,0)
      KS=KS+NCOMP
      IF (NEQIVP .EQ. 0) GO TO 50
      DO 25 J=1,NEQIVP
      KSJ=KS+J
   25 STOWA(KSJ)=YHP(KSJ)
   50 KS=KS+NEQIVP
      STOWA(KS+1)=X
      ISTKOP=KOP
      IF (XOP .EQ. X) ISTKOP=KOP+1
      RETURN
C
C     RECALL FROM STOWA ARRAY AND ISTKOP
C
  100 KS=NFC*NCOMP
      CALL STOR1(YHP,STOWA,YHP(KS+1),STOWA(KS+1),1,0,0)
      KS=KS+NCOMP
      IF (NEQIVP .EQ. 0) GO TO 150
      DO 125 J=1,NEQIVP
      KSJ=KS+J
  125 YHP(KSJ)=STOWA(KSJ)
  150 KS=KS+NEQIVP
      X=STOWA(KS+1)
      INFO(1)=0
      KO=KOP-ISTKOP
      KOP=ISTKOP
      IF (NDISK .EQ. 0  .OR.  KO .EQ. 0) RETURN
      DO 175 K=1,KO
  175 BACKSPACE NTAPE
      RETURN
      END

module gag_separators
  !---------------------------------------------------------------------
  ! SIC   Callable Routine
  !     Returns the characters used as Separators in path names.
  !     This allows multi-OS support where the directory names are separated
  !     by either / (Unix), \ (Windows), or : (MAC-OS)
  !---------------------------------------------------------------------
  character(len=1), parameter :: backsl=char(92)
  !
#if defined(WIN32)
  character(len=1), parameter :: insep='/'         !
  character(len=1), parameter :: ousep=backsl      !
  character(len=1), parameter :: disep=backsl      !
#elif defined(MAC)
  character(len=1), parameter :: insep=backsl      !
  character(len=1), parameter :: ousep=':'         !
  character(len=1), parameter :: disep=':'         !
#else
  character(len=1), parameter :: insep=backsl      !
  character(len=1), parameter :: ousep='/'         !
  character(len=1), parameter :: disep='/'         !
#endif
end module gag_separators
!
function sic_getlog_i4(chain,trans)
  use gbl_message
  use gsys_interfaces, except_this=>sic_getlog_i4
  !---------------------------------------------------------------------
  ! @ public-generic sic_getlog
  !  Translate a logical value. Function value on return is:
  !    0 if found and translated               ('trans' modified in return)
  !    1 if not found                          ('trans' not modified in return)
  !    2 if found but error during translation ('trans' not modified in return)
  ! ---
  !  I*4 version
  !---------------------------------------------------------------------
  integer(kind=4) :: sic_getlog_i4  ! Function value on return
  character(len=*), intent(in)    :: chain  ! Logical name (e.g. 'SPACE_GILDAS')
  integer(kind=4),  intent(inout) :: trans  ! Output value
  ! Local
  character(len=*), parameter :: rname='GETLOG'
  integer(kind=8) :: i8
  integer(kind=4) :: i4
  logical :: error
  character(len=message_length) :: mess
  !
  i8 = trans
  sic_getlog_i4 = sic_getlog_i8(chain,i8)
  if (sic_getlog_i4.ne.0)  return
  !
  error = .false.
  call i8toi4_fini(i8,i4,1,error)
  if (error) then
    ! 'i8' does not fit in 'i4'. Error, let 'trans' unchanged.
    write(mess,'(A,A,A,I0)') 'Failed decoding ',trim(chain),', default to ',trans
    call gsys_message(seve%w,rname,mess)
    sic_getlog_i4 = 2
    return
  endif
  !
  trans = i4
  !
end function sic_getlog_i4
!
function sic_getlog_i8(chain,trans)
  use gbl_message
  use gsys_interfaces, except_this=>sic_getlog_i8
  !---------------------------------------------------------------------
  ! @ public-generic sic_getlog
  !  Translate a logical value. Function value on return is:
  !    0 if found and translated               ('trans' modified in return)
  !    1 if not found                          ('trans' not modified in return)
  !    2 if found but error during translation ('trans' not modified in return)
  ! ---
  !  I*8 version
  !---------------------------------------------------------------------
  integer(kind=4) :: sic_getlog_i8  ! Function value on return
  character(len=*), intent(in)    :: chain  ! Logical name (e.g. 'SPACE_GILDAS')
  integer(kind=8),  intent(inout) :: trans  ! Output value
  ! Local
  character(len=*), parameter :: rname='GETLOG'
  integer(kind=8) :: i8
  real(kind=8) :: r8
  integer(kind=4) :: ier
  character(len=512) :: string
  character(len=message_length) :: mess
  !
  sic_getlog_i8 = sic_getlog_ch(chain,string)
  if (sic_getlog_i8.eq.1)  return  ! Not found
  !
  ! Try to decode as integer
  read(string,'(I20)',iostat=ier)  i8
  if (ier.eq.0) then  ! Success
    sic_getlog_i8 = 0
    trans = i8
    return
  endif
  !
  ! Try to decode as float, rounded
  read(string,*,iostat=ier)  r8
  if (ier.eq.0) then  ! Success
    sic_getlog_i8 = 0
    trans = nint(r8)
    return
  endif
  !
  write(mess,'(A,A,A,I0)') 'Failed decoding ',trim(chain),', default to ',trans
  call gsys_message(seve%w,rname,mess)
  sic_getlog_i8 = 2  ! Error during translation
  !
end function sic_getlog_i8
!
function sic_getlog_r4(chain,trans)
  use gbl_message
  use gsys_interfaces, except_this=>sic_getlog_r4
  !---------------------------------------------------------------------
  ! @ public-generic sic_getlog
  !  Translate a logical value. Function value on return is:
  !    0 if found and translated               ('trans' modified in return)
  !    1 if not found                          ('trans' not modified in return)
  !    2 if found but error during translation ('trans' not modified in return)
  ! ---
  !  R*4 version
  !---------------------------------------------------------------------
  integer(kind=4) :: sic_getlog_r4  ! Function value on return
  character(len=*), intent(in)    :: chain  ! Logical name (e.g. 'SPACE_GILDAS')
  real(kind=4),     intent(inout) :: trans  ! Output value
  ! Local
  character(len=*), parameter :: rname='GETLOG'
  integer(kind=4) :: ier
  character(len=512) :: string
  real(kind=8) :: r4
  character(len=message_length) :: mess
  !
  sic_getlog_r4 = sic_getlog_ch(chain,string)
  if (sic_getlog_r4.eq.1)  return  ! Not found
  !
  ! Try to decode as float
  read(string,*,iostat=ier)  r4
  if (ier.eq.0) then  ! Success
    sic_getlog_r4 = 0
    trans = r4
    return
  endif
  !
  write(mess,'(A,A,A,1PG12.5)') 'Failed decoding ',trim(chain),', default to ',trans
  call gsys_message(seve%w,rname,mess)
  sic_getlog_r4 = 2  ! Error during translation
  !
end function sic_getlog_r4
!
function sic_getlog_r8(chain,trans)
  use gbl_message
  use gsys_interfaces, except_this=>sic_getlog_r8
  !---------------------------------------------------------------------
  ! @ public-generic sic_getlog
  !  Translate a logical value. Function value on return is:
  !    0 if found and translated               ('trans' modified in return)
  !    1 if not found                          ('trans' not modified in return)
  !    2 if found but error during translation ('trans' not modified in return)
  ! ---
  !  R*8 version
  !---------------------------------------------------------------------
  integer(kind=4) :: sic_getlog_r8  ! Function value on return
  character(len=*), intent(in)    :: chain  ! Logical name (e.g. 'SPACE_GILDAS')
  real(kind=8),     intent(inout) :: trans  ! Output value
  ! Local
  character(len=*), parameter :: rname='GETLOG'
  integer(kind=4) :: ier
  character(len=512) :: string
  real(kind=8) :: r8
  character(len=message_length) :: mess
  !
  sic_getlog_r8 = sic_getlog_ch(chain,string)
  if (sic_getlog_r8.eq.1)  return  ! Not found
  !
  ! Try to decode as float
  read(string,*,iostat=ier)  r8
  if (ier.eq.0) then  ! Success
    sic_getlog_r8 = 0
    trans = r8
    return
  endif
  !
  write(mess,'(A,A,A,1PG12.5)') 'Failed decoding ',trim(chain),', default to ',trans
  call gsys_message(seve%w,rname,mess)
  sic_getlog_r8 = 2  ! Error during translation
  !
end function sic_getlog_r8
!
function sic_getlog_l(chain,trans)
  use gbl_message
  use gsys_interfaces, except_this=>sic_getlog_l
  !---------------------------------------------------------------------
  ! @ public-generic sic_getlog
  !  Translate a logical value. Function value on return is:
  !    0 if found and translated               ('trans' modified in return)
  !    1 if not found                          ('trans' not modified in return)
  !    2 if found but error during translation ('trans' not modified in return)
  ! ---
  !  Logical (boolean) version. Supported keywords are (case-
  ! insensitive): YES, Y, NO, N
  !---------------------------------------------------------------------
  integer(kind=4) :: sic_getlog_l  ! Function value on return
  character(len=*), intent(in)    :: chain  ! Logical name (e.g. 'SPACE_GILDAS')
  logical,          intent(inout) :: trans  ! Output value
  ! Local
  character(len=*), parameter :: rname='GETLOG'
  integer(kind=4) :: nc
  character(len=512) :: string
  character(len=message_length) :: mess
  !
  sic_getlog_l = sic_getlog_ch(chain,string)
  if (sic_getlog_l.eq.1)  return  ! Not found
  !
  call sic_upper(string)
  nc = len_trim(string)
  if (string(1:nc).eq.'YES' .or. string(1:nc).eq.'Y') then
    sic_getlog_l = 0
    trans = .true.
  elseif (string(1:nc).eq.'NO' .or. string(1:nc).eq.'N') then
    sic_getlog_l = 0
    trans = .false.
  else
    write(mess,'(A,A,A,L)') 'Failed decoding ',trim(chain),', default to ',trans
    call gsys_message(seve%w,rname,mess)
    sic_getlog_l = 2  ! Error during translation
    ! 'trans' not modified
  endif
  !
end function sic_getlog_l
!
function sic_ramlog(chain,trans)
  use gbl_message
  use gsys_interfaces, except_this=>sic_ramlog
  !---------------------------------------------------------------------
  ! @ public
  !  Decode a Sic logical as a RAM space, computed in MiB. 3 syntaxes
  ! are allowed:
  !
  ! No unit: default MiB
  !   SPACE_GILDAS  256    ! [MiB] Absolute value
  !
  ! Explicit unit:
  !   SPACE_GILDAS  256MB  ! Supported units: TB GB MB kB TiB GiB MiB kiB
  !
  ! Percent of total RAM:
  !   SPACE_GILDAS  50%    ! [  ] Relative value in fraction of the total
  !                              RAM size
  !
  ! The value can be integer or floating point. The unit or percent can
  ! be separated from the value by 0 or more blanks.
  !
  ! Function value on return is:
  !    0 if found and translated               ('trans' modified in return)
  !    1 if not found                          ('trans' not modified in return)
  !    2 if found but error during translation ('trans' not modified in return)
  !---------------------------------------------------------------------
  integer(kind=4) :: sic_ramlog  ! Function value on return
  character(len=*), intent(in)    :: chain  ! Logical name (e.g. 'SPACE_GILDAS')
  real(kind=4),     intent(inout) :: trans  ! Output value
  ! Local
  character(len=*), parameter :: rname='RAMLOG'
  integer(kind=4) :: ier,nc
  character(len=512) :: string
  real(kind=8) :: factor,value
  integer(kind=8) :: ram
  character(len=message_length) :: mess
  real(kind=8), parameter :: MiB=1048576.d0  ! Number of bytes in 1 MiB (1024**2)
  !
  sic_ramlog = sic_getlog_ch(chain,string)
  if (sic_ramlog.ne.0)  return  ! Not found
  !
  nc = len_trim(string)
  if (string(nc:nc).eq.'%') then
    call gag_ramsize(ram)
    if (ram.le.0) then
      write(mess,'(A,A,A,F0.2,A)')  &
        'Could not get RAM size for your OS, ',trim(chain),' defaults to ',trans,' MiB'
      call gsys_message(seve%w,rname,mess)
      sic_ramlog = 2
      return
    endif
    factor = ram/1d2
    nc = nc-1
    !
  elseif (len_trim(string).lt.3) then  ! Too small to store Value + Unit => No unit
    factor = 1.d0             ! Default MiB
    !
  elseif (string(nc-2:nc).eq.'TiB') then
    factor = 1.024d3*1.024d3  ! TiB to MiB
    nc = nc-3
  elseif (string(nc-2:nc).eq.'GiB') then
    factor = 1.024d3          ! GiB to MiB
    nc = nc-3
  elseif (string(nc-2:nc).eq.'MiB') then
    factor = 1.d0             ! MiB
    nc = nc-3
  elseif (string(nc-2:nc).eq.'kiB') then
    factor = 1.d0/1.024d3     ! kiB to MiB
    nc = nc-3
    !
  elseif (string(nc-1:nc).eq.'TB') then
    factor = 1.d12/MiB  ! TB to MiB
    nc = nc-2
  elseif (string(nc-1:nc).eq.'GB') then
    factor = 1.d9/MiB  ! GB to MiB
    nc = nc-2
  elseif (string(nc-1:nc).eq.'MB') then
    factor = 1.d6/MiB  ! MB to MiB
    nc = nc-2
  elseif (string(nc-1:nc).eq.'kB') then
    factor = 1.d3/MiB  ! kB to MiB
    nc = nc-2
    !
  else  ! No unit
    factor = 1.d0      ! Default MiB
  endif
  !
  ! Decode from int or float e.g. 123 or 123.456 or 1.23456E+02
  read(string(1:nc),*,iostat=ier)  value
  if (ier.ne.0) then
    write(mess,'(A,A,F0.2,A)')  &
      trim(chain),' not understood, defaults to ',trans,' MiB'
    call gsys_message(seve%w,rname,mess)
    sic_ramlog = 2
    return
  endif
  value = value*factor
  !
  ! Sanity check. We could also check if requesting more than the RAM,
  ! but RAM size is not fully portable and raise warnings if not.
  if (value.le.0.d0) then
    write(mess,'(A,A,F0.2,A)')  &
      trim(chain),' can not be negative, defaults to ',trans,' MiB'
    call gsys_message(seve%w,rname,mess)
    sic_ramlog = 2
    return
  endif
  !
  sic_ramlog = 0
  trans = value
  !
end function sic_ramlog
!
function sic_getlog_ch(name,trans)
  use gsys_interfaces, except_this=>sic_getlog_ch
  !---------------------------------------------------------------------
  ! @ public-generic sic_getlog
  !  Translate a logical value. Function value on return is:
  !    0 if found and translated ('trans' modified in return)
  !    1 if not found            ('trans' not modified in return)
  ! ---
  !  C*(*) version
  !---------------------------------------------------------------------
  integer(kind=4) :: sic_getlog_ch  ! Function value on return
  character(len=*), intent(in)    :: name   ! Logical name
  character(len=*), intent(inout) :: trans  ! Output value
  ! Local
  character(len=path_length) :: string
  !
  string = name
  sic_getlog_ch = sic_getlog_inplace(string)
  if (sic_getlog_ch.eq.0)  trans = string
  !
end function sic_getlog_ch
!
function sic_getlog_inplace(name)
  use gsys_interfaces, except_this=>sic_getlog_inplace
  !---------------------------------------------------------------------
  ! @ public-generic sic_getlog
  !  Translate a logical value. Function value on return is:
  !    0 if found and translated ('name' modified in return)
  !    1 if not found            ('name' not modified in return)
  !  OBSOLESCENT, USE 2 ARGUMENTS INSTEAD  !!!
  ! ---
  !  C*(*) version, obsolescent calling sequence which replaces the
  ! value in place.
  !---------------------------------------------------------------------
  integer(kind=4) :: sic_getlog_inplace
  character(len=*), intent(inout) :: name  ! Output value
  ! Local
  integer(kind=4) :: coderr
  !
  call sic_handlelog(name,' ',1,coderr)
  if (coderr.eq.1) then
    sic_getlog_inplace = 0
  else
    sic_getlog_inplace = 1
  endif
end function sic_getlog_inplace
!
function sic_setlog(name,trans)
  use gsys_interfaces, except_this=>sic_setlog
  !---------------------------------------------------------------------
  ! @ public
  !---------------------------------------------------------------------
  integer(kind=4) :: sic_setlog
  character(len=*), intent(in) :: name   !
  character(len=*), intent(in) :: trans  !
  ! Local
  character(len=512) :: ident
  integer(kind=4) :: coderr
  !
  ident = name
  call sic_handlelog(ident,trans,0,coderr)
  sic_setlog = coderr
end function sic_setlog
!
subroutine sic_handlelog(name,trans,codeop,coderr)
  use gildas_def
  use gbl_message
  use gsys_interfaces, except_this=>sic_handlelog
  !---------------------------------------------------------------------
  ! @ private
  !
  !     Get or Set a log name according to Code Op
  !
  ! Simulates recursive translation of a VMS logical name by looking into
  ! a dictionary in the user's path. The calling list should probably be
  ! modified to include the string length.
  ! Three dictionaries are used: a global dictionary contains site independent
  ! definitions, a local one is defined at installation level and a user
  ! specific one can be used by any individual user to customize his
  ! definitions. Local definitions override more global definitions, so the
  ! user has the final say.
  !---------------------------------------------------------------------
  character(len=*), intent(inout) :: name     !
  character(len=*), intent(in)    :: trans    !
  integer(kind=4),  intent(in)    :: codeop   !
  integer(kind=4),  intent(out)   :: coderr   !
  character(len=*), intent(in)    :: pattern  ! For sic_listlog
  ! Local
  character(len=*), parameter :: rname='GTLGTR'
  integer(kind=4), parameter :: maxlog=500
  integer(kind=4), parameter :: tab=9
  integer(kind=4) :: ll,in,ier,ik,il
  logical :: first,nodict,found
  integer(kind=4) :: pflog(0:27)          ! Alphabetic pointers PF(27)=number of
  integer(kind=4) :: pnlog(maxlog)        ! Chained pointers
  character(len=512) :: ident             !
  character(len=512) :: diclog(maxlog)    ! Identifiers (logical names)
  character(len=512) :: translog(maxlog)  ! Translation for identifiers
  character(len=512) :: upattern
  character(len=1) :: psepar
  logical :: error
  logical :: ispath
  integer(kind=4) :: list(maxlog)
  !
  save                         ! Needed!
  ! Data
  data first /.true./
  data nodict /.false./
  data diclog /maxlog*' '/
  data translog /maxlog*' '/
  data pflog /28*0/
  data pnlog /maxlog*0/
  data psepar /';'/            ! Path separator in a list of paths
  !
  if (codeop.eq.1) then
    coderr = 0                 ! Default value
    !
    ! On first call, open the dictionary
    if (first) then
      error = .false.
      call load_dict(maxlog,pflog,pnlog,diclog,translog,error)
      if (error) nodict = .true.
      first  = .false.
    endif
    ier = sic_expenv (name)
    if (ier.eq.1) coderr = 1
    !
    ! Return if no dictionary could be found
    if (nodict) return
    !
    ! Look for translation
    ident = name
    call sic_upper(ident)
    ier = gag_hasfin(maxlog,pflog,pnlog,diclog,ident,in)
    if (mod(ier,2).ne.0) then
      name=translog(in)
      !
      ! With the original code ( NAME = TRANSLOG(IN) )
      !     GAG_HELP_SIC is replaced by
      !            GAG_HELP:SICHELP.HLP
      !     which in turn is converted by SIC_PARSEF into
      !            /users/gag/NOV95/help/sichelp.hlp
      coderr = 1
    endif
    ier = sic_expenv (name)
    if (ier.eq.1) coderr = 1
    ! Print *,'Log: ',sic_getlog,' ',trim(name)
    return
  else
    !
    ! Set a logical name
    ! On first call, open the dictionary
    if (first) then
      error = .false.
      call load_dict(maxlog,pflog,pnlog,diclog,translog,error)
      first  = .false.
    endif
    !
    ident = name
    ll = lenc(ident)
    call sic_upper(ident)
    coderr  = gag_hasins(maxlog,pflog,pnlog,diclog,ident,in)
    if (coderr.eq.0) then
      call gsys_message(seve%e,rname,'Invalid logical name '//ident)
    elseif (mod(coderr,2).eq.0) then
      call gsys_message(seve%w,rname,'Too many logical names: '//  &
      trim(ident)//' ignored')
    else
      ispath = ident(ll:ll).eq.':'
      call gag_setcleanlog (trans,translog(in),ispath)
      !
      nodict = .false.
      coderr = 1
      call gsys_message(seve%d,rname,'Set '//ident(:ll)//' to '//translog(in))
    endif
  endif
  return
  !
entry sic_listlog(pattern)
  !---------------------------------------------------------------------
  ! @ private
  !  Make a list of the LOGICAL symbols and their translations, using
  ! the input pattern. Use * to list all symbols
  !---------------------------------------------------------------------
  upattern = pattern
  call sic_upper(upattern)
  !
  ! Check if one is listing all variables
  found = .false.
  call gag_haslis(maxlog,pflog,pnlog,list,in)
  do il=1,in
    ik = list(il)
    !
    ! Check if name matches the pattern
    if (.not.match_string(diclog(ik),upattern))  cycle
    !
    write(*,'(A,T22,A,A)') trim(diclog(ik)),' = ',trim(translog(ik))
    found = .true.
  enddo
  !
  if (.not.found)  call gsys_message(seve%w,rname,'No logical name found')
  !
end subroutine sic_handlelog
!
function sic_get_npath(paths,sep)
  use gsys_interfaces, except_this=>sic_get_npath
  !---------------------------------------------------------------------
  ! @ private
  ! Return number of paths in a list of paths PATHS separated by SEP.
  ! Return 0 if input string is empty. Take care that PATHS may or may not
  ! end with a SEP.
  !---------------------------------------------------------------------
  integer(kind=4) :: sic_get_npath  !
  character(len=*), intent(in) :: paths  ! Paths list
  character(len=*), intent(in) :: sep    ! Separator (assume len=1)
  ! Local
  integer(kind=4) :: pa,pr          ! Position absolute and relative
  integer(kind=4) :: pl
  !
  sic_get_npath = 0
  pl = lenc(paths)
  if (pl.eq.0) return
  !
  pa = 0
  do
    sic_get_npath = sic_get_npath+1
    pr = index(paths(pa+1:),sep)
    pa = pa+pr
    if (pr.eq.0 .or. pa.eq.pl) exit
    ! No more separators .OR. last separator is at EOL: stop incrementing
  enddo
  !
end function sic_get_npath
!
subroutine sic_get_path(paths,sep,n,istart,iend)
  use gsys_interfaces, except_this=>sic_get_path
  !---------------------------------------------------------------------
  ! @ private
  ! Return Nth path indices in a list of paths PATHS separated by SEP.
  ! Return indexes for an empty string if such a path does not exist.
  !---------------------------------------------------------------------
  character(len=*), intent(in)  :: paths   ! Paths list
  character(len=*), intent(in)  :: sep     ! Separator (assume len=1)
  integer(kind=4),  intent(in)  :: n       ! Position
  integer(kind=4),  intent(out) :: istart  ! Beginning of string
  integer(kind=4),  intent(out) :: iend    ! End of string
  ! Local
  integer(kind=4) :: i,s1,s2,pl
  !
  pl = lenc(paths)
  s1 = 0
  s2 = 0
  !
  do i=1,n
    s1 = s2
    s2 = s2+index(paths(s2+1:),sep)
    if (s2.eq.s1) s2=pl+1      ! No more SEP, stuck S2 just after EOL
  enddo
  !
  istart = s1+1
  iend   = s2-1
  ! We may have ISTART>IEND, which means there was two contiguous separators
  !
end subroutine sic_get_path
!
subroutine load_dict(maxlog,pflog,pnlog,diclog,translog,error)
  use gildas_def
  use gbl_message
  use gsys_interfaces, except_this=>load_dict
  !---------------------------------------------------------------------
  ! @ private
  !  Fills the internal dictionary, reading from the three possible
  ! configuration files.
  !---------------------------------------------------------------------
  integer(kind=4),    intent(in)    :: maxlog            !
  integer(kind=4),    intent(out)   :: pflog(0:27)       ! Alphabetic pointers PF(27)=number of
  integer(kind=4),    intent(out)   :: pnlog(maxlog)     ! Chained pointers
  character(len=512), intent(inout) :: diclog(maxlog)    ! Identifiers
  character(len=512), intent(inout) :: translog(maxlog)  ! Translation for identifiers
  logical,            intent(inout) :: error             !
  ! Local
  character(len=*), parameter :: rname='DICT'
  integer(kind=4) :: i,ier,in,iunit,l,ll,status,mdict,kk
  character(len=filename_length) :: filnam
  character(len=512) :: line,ident
  logical :: ispath
  !
  status = sic_getlun(iunit)
  if (mod(status,2).eq.0) then
    error = .true.
    return
  endif
  mdict = 3                    ! Have a User dictionary too...
  ! Initialize dictionary structure
  call gag_hasini(maxlog,pflog,pnlog)
  do i=1,mdict
    if (i.eq.1) then
      status = dictname('GLOBAL',filnam)
      if (mod(status,2).eq.0) then
        call gsys_message(seve%f,rname,'No global logical name table')
        call sysexi(fatale)
      endif
    elseif (i.eq.2) then
      status = dictname('LOCAL',filnam)
      if (mod(status,2).eq.0) then
        call gsys_message(seve%w,rname,'No local logical name table')
        goto 30
      endif
    elseif (i.eq.3) then
      status = dictname('USER',filnam)
      if (mod(status,2).ne.0) then
        call gsys_message(seve%d,rname,'Using user defined logical name '//  &
        'table '//filnam)
      else
        call gsys_message(seve%d,rname,'No user defined logical name table')
        goto 30
      endif
    endif
    status = sic_open(iunit,filnam,'OLD',.true.)
    if (status.ne.0) then
      call putios ('E-DICT,  ',status)
      call sic_frelun(iunit)
      error = .true.
      return
    endif
    !
    ! Read dictionary
80  continue
    read (iunit,'(A)',end=90) line
    in = lenc(line)
    call gtlblanc (line,in)
    if (in.eq.0) goto 80
    ll = index(line,' ')
    l  = lenc(line)
    if (ll.le.0.or.ll+1.gt.l) goto 80
    !
    ! Insert or replace in symbol dictionnary
    ident = line(1:ll)
    call sic_upper(ident)
    ier = gag_hasins(maxlog,pflog,pnlog,diclog,ident,in)
    if (ier.eq.0) then
      call gsys_message(seve%e,rname,'Invalid logical name '//ident)
    elseif (mod(ier,2).eq.0) then
      call gsys_message(seve%w,rname,'Too many logical names: '//   &
      trim(ident)//' ignored')
    else
      ! Put into symbol table
      kk = len_trim(ident)
      ispath = ident(kk:kk).eq.':'
      call gag_setcleanlog(line(ll+1:l),translog(in),ispath)
      !!print *,trim(ident)//' == '//trim(translog(in))
    endif
    goto 80
    !
90  close (iunit)
30  continue
  enddo
  call sic_frelun (iunit)
end subroutine load_dict
!
subroutine gtlblanc(c,n)
  use gsys_interfaces, except_this=>gtlblanc
  !---------------------------------------------------------------------
  ! @ private
  !  Reduce the character string C to the standard SIC internal syntax.
  !  Suppress all unecessary separators.
  !  Ignores and destroys comments.
  !---------------------------------------------------------------------
  character(len=*), intent(inout) :: c  ! Character string to be formatted
  integer(kind=4),  intent(inout) :: n  ! Length of C
  ! Local
  integer(kind=4) :: i,nl
  logical :: lo,li
  integer(kind=4), parameter :: tab=9
  !
  if (n.eq.0) return
  !
  lo = .true.
  nl = n
  n = 0
  i = 1
  !
  do while (i.le.nl)
    !
    ! Suppress redondant separators
    li=.false.
    if (c(i:i).ne.' ' .and. c(i:i).ne.char(tab)) goto 20
    ! Space separator
    li=.true.
    ! Not the first one
    if (lo)  go to 100
    ! First one
    c(i:i)=' '
    goto 30
    !
    ! Skip comment area
20  continue
    if (c(i:i).eq.'!') then
      goto 200
    endif
    !
    ! Reset input character string
30  n=n+1
    if (i.ne.n) c(n:n)=c(i:i)
    if (i.gt.n) c(i:i)=' '
100 lo=li
    !
    ! End of loop
    i = i+1
  enddo
  !
  ! Remove trailing separators if any
200 continue
  if (n.ne.0) then
    if (c(n:n).eq.' ') n=n-1
  endif
  ! Clean up end of line
  if (n.lt.len(c)) c(n+1:) = ' '
end subroutine gtlblanc
!
function dictname(dtype,file)
  use gsys_interfaces, except_this=>dictname
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ public
  !
  ! This system dependent routine returns the full names (including
  ! path) of the (internal) logical name definition files.
  ! Known dictionary types as input are 'GLOBAL', 'LOCAL', or 'USER'.
  ! Any other kind raises an error.
  !
  ! This version for Unix.
  !---------------------------------------------------------------------
  integer(kind=4) :: dictname             !
  character(len=*), intent(in)  :: dtype  ! Dictionary type
  character(len=*), intent(out) :: file   ! Associated file
  ! Local
  character(len=*), parameter :: rname='DICTNAME'
  character(len=2048) :: chain  ! The path can be rather long...
  character(len=16) :: name
  character(len=1) :: psep
  integer(kind=4) :: i,j,l
  logical :: success
  integer(kind=4), parameter :: errcode=12
  !
  chain=' '
  !
#if defined(WIN32)
  psep = ';'
#else
  psep = ':'
#endif
  dictname = 1                 ! Success value
  !
  if (dtype.eq.'GLOBAL'.or.dtype.eq.'LOCAL') then
    ! First search for a GAG_PATH environment variable
    call sic_getenv('GAG_PATH',chain)
    l = lenc(chain)
    ! If GAG_PATH isn't set: fatale
    if (l.eq.0) then
      call gsys_message(seve%f,rname,'Environment variable $GAG_PATH is '//  &
      'not set')
      call sysexi(fatale)
    endif
    ! Look for dictionary file in GAG_PATH
    i = 1
    if (dtype.eq.'GLOBAL') then
      name = 'gag.dico.gbl'
    elseif (dtype.eq.'LOCAL') then
      name = 'gag.dico.lcl'
    endif
    do while (i.le.l)
      j = index(chain(i:l),psep)
      if (j.gt.0) then
        file = chain(i:i+j-2)//'/'//name
        i = i+j
      else
        file = chain(i:l)//'/'//name
        i = l+1
      endif
      inquire (file=file,exist=success)
      if (success) return
    enddo
    ! Nothing found. Generate an error and return.
    call gsys_message(seve%e,rname,'Did not found '//trim(name)//' in '//  &
    '$GAG_PATH')
    dictname = errcode
    file = ' '
  !
  elseif (dtype.eq.'USER') then
    call sic_getenv('HOME',chain)
    file = trim(chain)//'/'//'.gag.dico'
    inquire (file=file,exist=success)
    if (.not.success) dictname = errcode
  !
  else
    call gsys_message(seve%e,rname,'Internal error, no such dictionary '//  &
      dtype)
    dictname = errcode
    file = ' '
  endif
end function dictname
!
function sic_expenv(name)
  use gsys_interfaces, except_this=>sic_expenv
  !---------------------------------------------------------------------
  ! @ private
  !
  ! This Unix specific routine expands environment variables in file names.
  ! Environment variables begin with a $ sign. They are terminated by a /
  ! sign.
  !---------------------------------------------------------------------
  integer(kind=4) :: sic_expenv  !
  character(len=*), intent(inout) :: name  !
  ! Local
  character(len=path_length) :: line
  !
  call sic_resolve_env (name,line)
  if (name.eq.line) then
    sic_expenv = 0
  else
    sic_expenv = 1
  endif
  name = line
end function sic_expenv
!
subroutine sic_ctrans (name,nn,trans,np)
  use gsys_interfaces, except_this=>sic_ctrans
  use gildas_def
  !---------------------------------------------------------------------
  ! @ private
  !     Returns the translation (TRANS(1:NP)) of a Logical name (NAME(1:NN))
  !     NAME and TRANS are assumed to be C Strings, i.e. Byte arrays.
  !---------------------------------------------------------------------
  integer(kind=1), intent(in)    :: name(*)   !
  integer(kind=4), intent(in)    :: nn        !
  integer(kind=1), intent(out)   :: trans(*)  !
  integer(kind=4), intent(inout) :: np        !
  ! Global
  include 'gbl_memory.inc'
  ! Local
  character(len=512) :: tmp
  integer(kind=4) :: im,ier
  integer(kind=address_length) :: il,ip
  !
  il = locstr(tmp)
  ip = bytpnt(il,membyt)
  call bytoby(name,membyt(ip),nn)
  tmp(nn+1:) = ' '
  ier = sic_getlog(tmp)
  im = min(lenc(tmp),np)
  tmp(im+1:im+1) = char(0)
  call bytoby(membyt(ip),trans,im+1)
  np = im
end subroutine sic_ctrans
!
subroutine gag_separ(ins,ous,dis)
  use gag_separators
  !---------------------------------------------------------------------
  ! @ public
  !     Returns the characters used as Separators in path names.
  !     This allows multi-OS support where the directory names are separated
  !     by either / (Unix), \ (Windows), or : (MAC-OS)
  !---------------------------------------------------------------------
  character(len=1), intent(out) :: ins         !
  character(len=1), intent(out) :: ous         !
  character(len=1), intent(out) :: dis         !
  ! Local
  ins = insep
  ous = ousep
  dis = disep
end subroutine gag_separ
!
subroutine gag_release(ostring)
  use gsys_interfaces, except_this=>gag_release
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ public
  !   Return a string with the release name, date, system, and branch.
  ! Read the string in GAG_VERSION symbol, and optionally replace the
  ! release date by the calling executable date if in HEAD version.
  !---------------------------------------------------------------------
  character(len=*), intent(out) :: ostring  ! Output string
  ! Local
  logical :: found
  character(len=filename_length) :: progname,fullname
  character(len=128) :: version,timestr,prefix,suffix
  integer(kind=4) :: filetime,p1,p2,ier
  !
  version = ''
  ier = sic_getlog('GAG_VERSION',version)
  !
  call getarg(0,progname)  ! NB: progname may be empty if Python master
  found = gag_which(progname,'$PATH',fullname)
  !
  ! Change version date to binary date if "dev":
  if (version(1:4).eq."dev " .and. found) then
    !
    ier = gag_mdate(fullname,filetime)
    !
    if (ier.eq.0) then
      call sic_c_datetime_from_raw(filetime,timestr)
      call sic_lower(timestr)
      !
      ! Split VERSION. May be:
      !     "dev (22oct07 09:27 cest) (pc-fedora6-ifort) source tree"
      ! OR
      !     "dev (pc-fedora6-ifort) source tree"
      !
      p1 = index(version,'(',.true.)   ! Backward search
      prefix = version(:p1-1)  ! = "dev (15oct07 10:41)" or "dev"
      suffix = version(p1:)    ! = "(pc-fedora6-ifort) source tree"
      !
      ! Search if PREFIX is "dev" or "dev (15oct07 10:41)"
      p1 = index(prefix,'(')
      p2 = index(prefix,')')
      if (p1.eq.0) then
        prefix = trim(prefix)//' ('//trim(timestr)//')'
      else
        prefix = prefix(:p1)//trim(timestr)//prefix(p2:)
      endif
      !
      version = trim(prefix)//' '//suffix
    endif
  endif
  !
  ! Echo the Gildas version
  ostring = 'IMAGER specific GILDAS Version: '//version
  !
end subroutine gag_release
!
subroutine gag_setcleanlog (input,output,ispath)
  use gsys_interfaces, except_this=>gag_setcleanlog
  use gag_separators
  !---------------------------------------------------------------------
  ! @ private
  ! Perform a good cleaning on the Logical name definitions to 
  ! use the appropriate system dependent separators.
  !
  ! A better job can be done using the code marked !!BETTER
  ! but that does not seem to be required.
  !---------------------------------------------------------------------
  character(len=*), intent(in)  :: input
  character(len=*), intent(out) :: output
  logical,          intent(in)  :: ispath
  ! Local
  character(len=1), parameter :: psepar=';'
  integer(kind=4) :: ier,i,j,itot,i1,i2,j1,j2,l
  character(len=512) :: path1, path2
  !
  output = input
  ier = sic_expenv(output)
  if (.not.ispath) return
  !
  !
  ! 1/ Perform some cleaning on paths separator, and
  !    add terminating path character.
  i = len_trim(output)
  ! Next line ensure not changing presence or absence of ';' at EOL
  if (output(i:i).ne.psepar) i=i+1
  do
     if (i.eq.0) then
        ! All done
        exit
     elseif (i.eq.1) then
        ! Remove ';' at beginning:
        output=output(2:)
     elseif (output(i-1:i-1).eq.psepar) then
        ! Remove duplicates ';'
        output(i-1:)=output(i:)
     elseif (output(i-1:i-1).eq.':') then
        ! A paths-list symbol: skip
     elseif (output(i-1:i-1).eq.insep) then
        ! Switch "\" into "/" (linux example)
        output(i-1:i-1) = ousep
     elseif (output(i-1:i-1).ne.ousep) then
        ! Add "/" at end if absent (linux example)
        output(i+1:) = output(i:)
        output(i:i)  = ousep
        i=i+1
     endif
     l = i-1
     i = index(output(:l),psepar,.true.)
     j = index(output(:l),insep,.true.) !BETTER
     if (j.gt.i) i = j+1                !BETTER
  enddo
  !
  ! 2/ Remove duplicate paths
  i = 1
  itot = sic_get_npath(output,psepar)
  do
     if (i.ge.itot) exit
     call sic_get_path(output,psepar,i,i1,i2)
     path1 = output(i1:i2)
     j = i+1
     do
        if (j.gt.itot) exit
        call sic_get_path(output,psepar,j,j1,j2)
        path2 = output(j1:j2)
        if (path1.eq.path2) then
           output(j1:)=output(j2+2:)
           itot = sic_get_npath(output,psepar)
           cycle
        endif
        j = j+1
     enddo
     i = i+1
  enddo
end subroutine gag_setcleanlog

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module sic_interactions
  use gildas_def
  !--------------------------------------------------------------------
  ! Support for low level interactions with SIC: interaction mode,
  ! terminal characteristics, stack or tasks support.
  ! For portability, SAVE Fortran variables which are target of SIC
  ! variables.
  !--------------------------------------------------------------------
  !
  ! Command line execution:
  ! - input codes
  integer(kind=4), parameter :: code_run   =  0
  integer(kind=4), parameter :: code_exec  = -1
  integer(kind=4), parameter :: code_enter =  1
  integer(kind=4), parameter :: code_play  =  2
  ! - output codes
  integer(kind=4), parameter :: code_next  =  0
  integer(kind=4), parameter :: code_end   = -1
  integer(kind=4), parameter :: code_exit  =  1
  !
  ! Defines if orders reading on unit 5 is interactive or not and if
  ! <^C> has been typed or not.
  logical, save :: inter_state=.true.     ! Session is interactive
  logical :: edit_mode                    ! Line editing is possible
  logical :: loaded=.false.               ! SIC has been initialized
  logical, save :: lexist                 ! File exists...
  logical :: lxwindow                     ! X-Window input mode (current)
  logical, save :: sic_window=.true.      ! X-Window input mode (keyboard)
  logical, save :: sic_initwindow=.true.  ! Initial default menu and plotting window
  integer(kind=8), save :: sic_ramsize=0  ! Support for SIC%RAMSIZE
  integer(kind=8), save :: sic_cachel(4)=0   ! Support for SIC%CACHEL(1:4)
  logical,         save :: sic_omp_compiled  ! Support for SIC%OPENMP%ACTIVE
  integer(kind=4), save :: sic_omp_ncores    ! Support for SIC%OPENMP%NCORES (number of physical cores)
  integer(kind=4), save :: sic_omp_mthreads  ! Support for SIC%OPENMP%MTHREADS
  integer(kind=4), save :: sic_omp_nthreads  ! Support for SIC%OPENMP%NTHREADS
  !
  ! Terminal characteristics
  integer(kind=4) :: sicprecis          ! Code for precision in computations
  integer(kind=4) :: sicinteger         ! Default SIC INTEGER (short or long)
  integer(kind=4) :: siclun=0           ! Support for SIC OUTPUT
  character(len=256), save :: tt_edit   ! Editor name
  character(len=filename_length), save :: cur_dir  ! Current working directory
  character(len=8), save :: sic_precis  ! Arithmetic precision
  logical :: sicsystemerror             ! Error from command SIC\SYSTEM ignored or not?
  !
  ! Editor codes
  integer, parameter :: p_tpu=1     !
  integer, parameter :: p_edt=-1    !
  integer, parameter :: p_auto=0    !
  integer, parameter :: p_emacs=2   ! Emacs
  integer, parameter :: p_vi=-2     ! Vi
  !
  ! Characteristics for one line on screen
  integer, parameter :: eline=24    ! Edit line number
  integer, parameter :: mscreen=40  ! Width of the screen
  integer :: jchar                  ! Character counter
  integer :: jfirst                 ! Leftmost visible character
  integer :: jlast                  ! Rightmost visible character
  integer :: jscreen                ! Current character position on screen
  logical :: updscr                 !
  !
  ! Prompt attributes
  integer(kind=4), parameter :: gpr_base_length=64    ! Max prompt length offered to programmer
  integer(kind=4), parameter :: gpr_suffix_length=5   ! Max prompt suffix length e.g. "_99> "
  integer(kind=4), parameter :: gprompt_length=gpr_base_length+gpr_suffix_length
  character(len=gprompt_length) :: gprompt_master     ! e.g. "SIC"
  character(len=gprompt_length) :: gprompt_base       ! e.g. "SIC" or "procname"
  character(len=gprompt_length) :: gprompt            ! e.g. "SIC_3> " or "procname_3> "
  integer(kind=4)               :: lgprompt_base      ! Length of gprompt_base
  integer(kind=4)               :: lgprompt           ! Length of gprompt with a terminating whitespace included
  integer(kind=4)               :: gprompt_nlire_old  ! Last level used for building gprompt_curr
  !
  ! Stack
  integer, parameter :: maxlin=300           ! Maximum number of lines
  integer :: iend                            ! Last line in buffer
  integer :: istart                          ! First line in buffer
  integer(kind=address_length) :: jstart     ! First byte in buffer
  integer(kind=address_length) :: iloc       ! Insertion location
  integer(kind=address_length) :: stack_desc(2,maxlin) ! Character descriptors
  integer(kind=address_length) :: stack_addr ! Adress of stack
  integer :: maxbyt                          ! Length of stack
  logical :: logbuf=.true.                   ! Stack status
  !
  ! Xgag
  integer, parameter :: m_commands=256              !
  integer, parameter :: x_cmdlen  =filename_length  ! Must be synchronized with CHAINLENGTH in gcore
  integer, parameter :: x_cholen  =8                ! 32 Characters for choices.
  integer, parameter :: m_choices =128              !
  integer(kind=address_length) :: x_variab(2,m_commands) ! Variable names
  integer(kind=address_length) :: x_string(2,m_commands) ! Variable values
  integer(kind=address_length) :: x_choice(2,m_choices)  ! Possible choices
  integer :: x_vtypes(m_commands)            ! Type of variables
  integer :: x_commands                      ! Number of variables
  integer :: x_choices                       ! Number of choices
  integer :: x_mode                          ! Mode indicator
  integer :: x_group                         ! Group indicator
  integer :: noptscr                         ! Number of optional screens
  integer :: xlun                            ! Unit for "save" file
  integer :: x_number(m_commands)            ! Variable number
  !
  integer, parameter :: slider_offset=32000  !
  integer, parameter :: upper_offset=10000   !
  integer, parameter :: lower_offset=20000   !
  integer, parameter :: quote_offset=64000   ! Sufficient ?
  integer, parameter :: resize_offset=128000 !
  !
  ! Tasks support
  integer(kind=4), parameter :: mpar=2048   ! Maximum number of input values in par files
  integer(kind=4), parameter :: mreal=2048  ! Maximum number of input reals  in par files
  integer(kind=4), parameter :: minte=128   ! Same for integers
  integer(kind=4), parameter :: mlogi=128   ! Same for logicals
  integer(kind=4), parameter :: mchar=128   ! Same for character strings
  !
  logical, save :: run_window         ! Parameter in X-Window mode (default)
  logical :: x_window                 ! Parameter in X-Window mode (current)
  logical, save :: tee                ! Tee to screen ?
  integer(kind=4) :: piperr           ! Type of Pipe fo STDERR
  !
  integer(kind=4)         :: tlun        ! Logical unit for parameter file
  logical                 :: tabort      ! Error flag in parameter checks
  real(kind=8),                   save :: treal(mreal)  ! Space for real parameters
  integer(kind=8),                save :: tinte(minte)  ! Space for integer parameters
  logical,                        save :: tlogi(mlogi)  ! Space for logical parameters
  character(len=filename_length), save :: tchar(mchar)  ! Space for character parameters
  integer(kind=4)         :: nreal       !
  integer(kind=4)         :: ninte       !
  integer(kind=4)         :: nlogi       !
  integer(kind=4)         :: nchar       !
  integer(kind=4)         :: npar        !
  character(len=80)       :: tprom(mpar) ! Space for prompt
  character(len=16)       :: tname(mpar) ! Name of parameters
  character(len=16)       :: tprog       ! Name of task
  character(len=4)        :: taskext     ! Task name extension (changes with systems)
  character(len=64)       :: last_task   ! Last Task
  character(len=64), save :: task_node   ! Executor node name
  integer(kind=4)         :: ttype(mpar) ! Type of parameter
  integer(kind=4)         :: tnumb(mpar) ! Number of parameter
  !
  ! Help File name 
  character(len=256), save :: help_text_file=char(0)
end module sic_interactions
!
module let_options
  !
  integer(kind=4), parameter :: mopt=16
  !
  ! Code for options of the LET command (alphabetic order). Must match
  ! declaration in subroutine sic_build.
  integer(kind=4), parameter :: optchoice  = 1   ! /CHOICE
  integer(kind=4), parameter :: optfile    = 2   ! /FILE
  integer(kind=4), parameter :: optformat  = 3   ! /FORMAT
  integer(kind=4), parameter :: optformula = 4   ! /FORMULA
  integer(kind=4), parameter :: optindex   = 5   ! /INDEX
  integer(kind=4), parameter :: optlower   = 6   ! /LOWER
  integer(kind=4), parameter :: optnew     = 7   ! /NEW
  integer(kind=4), parameter :: optnoquote = 8   ! /NOQUOTE
  integer(kind=4), parameter :: optprompt  = 9   ! /PROMPT
  integer(kind=4), parameter :: optrange   = 10  ! /RANGE
  integer(kind=4), parameter :: optreplace = 11  ! /REPLACE
  integer(kind=4), parameter :: optresize  = 12  ! /RESIZE
  integer(kind=4), parameter :: optsexage  = 13  ! /SEXAGESIMAL
  integer(kind=4), parameter :: optstatus  = 14  ! /STATUS
  integer(kind=4), parameter :: optupper   = 15  ! /UPPER
  integer(kind=4), parameter :: optwhere   = 16  ! /WHERE
  !
  ! Option names. This duplicates the actual declaration in subroutine
  ! sic_build, but there is no obvious solution given the way we declare
  ! and use options for now.
  character(len=12), parameter :: optnames(mopt) = (/             &
    '/CHOICE     ','/FILE       ','/FORMAT     ','/FORMULA    ',  &
    '/INDEX      ','/LOWER      ','/NEW        ','/NOQUOTE    ',  &
    '/PROMPT     ','/RANGE      ','/REPLACE    ','/RESIZE     ',  &
    '/SEXAGESIMAL','/STATUS     ','/UPPER      ','/WHERE      '   /)
  !
end module let_options
!
module sic_python
  !---------------------------------------------------------------------
  ! @ private
  ! SIC-Python binding support variables
  !---------------------------------------------------------------------
  !
  ! 'ismaster' flag:
  ! - if it is found .true., it has been changed by the building
  !   routines which are invoked when starting a Gildas program as
  !   master,
  ! - if it is found .false., it has not been changed i.e. Gildas
  !   program is slave.
  ! - is used as support variable for SIC%MASTER
  !
  logical, save :: gildas_ismaster=.false.
  !
end module sic_python
!
module sic_adjust
  use gildas_def
  use sic_expressions, only: formula_length
  !---------------------------------------------------------------------
  ! For ALL methods, unless specified
  !---------------------------------------------------------------------
  integer, parameter :: adj_m=2*26             ! Maximum number of variables
  integer, save :: adj_n                       ! Current number of variables
  integer, save :: ndata                       ! Number of data points
  integer, save :: adj_ncall                   ! Number of function calls (book-keeping)
  real(8), save :: adj_user(adj_m)             ! Parameter values
  real(8), save :: adj_guess(adj_m)            ! Initial guesses
  real(8), save :: adj_step(adj_m)             ! Step for adjustment or gradients
  real(8), save :: adj_errors(adj_m)           ! Parameter errors
  real(8), save :: adj_prog(adj_m)             ! Parameter (working) values
  real(8), save :: adj_lower(adj_m)            ! Lower bounds
  real(8), save :: adj_upper(adj_m)            ! Upper bounds
  integer, save :: adj_bound(adj_m)            ! Bound flags
  character(len=commandline_length), save :: diff_expression  ! Command to execute
  character(len=64), save :: adj_names(adj_m)  ! Parameter names
  character(len=16), save :: adj_root='MFIT'   ! Root name
  integer(4), save :: adj_lroot=4              ! Length of Root name
  integer(1), save :: membyt(8)                ! Address reference
  integer(kind=address_length), save :: adj_exec  ! Address for ADJUST function
  integer(kind=address_length), save :: cur_exec  ! Address of Currently called function
  integer(kind=address_length), save :: fun_exec  ! Address for MFIT function
  !
  ! For Simplex and Powell methods
  real(4) :: press_sum         ! Sum of squares
  ! real(4) :: press_para(27)    ! Variables - unused
  integer :: press_pdim        ! Number of variables
  integer :: press_itmax       ! Maximum number of iterations
  logical, save :: press_error
  !
  ! For MCMC
  real(8) :: adj_chi2          ! Chi2 value
  integer, save :: adj_length=10               ! Length of MCMC run
  integer, save :: adj_walkers=0               ! Number of Walkers
  integer, save :: adj_over=4                  ! Number of Walkers per parameter
  logical :: adj_restart       ! Restart status
  !
  ! For the results
  character(len=formula_length), save :: math_expression  ! Support for MFIT%MATH (formula)
  !
  real(8), allocatable, save :: dvec(:)    ! Difference array
  real(8), allocatable, save :: wvec(:)    ! Weight array
end module sic_adjust
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine maskon(line,error)
  use gildas_def
  use gbl_message
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>maskon
  use greg_kernel
  use greg_poly
  use greg_rg
  !---------------------------------------------------------------------
  ! @ private
  ! GreG Support routine for command
  !  GREG2\MASK [IN|OUT] [/BLANKING Bval]
  ! Mask the inside or the outside of a polygon
  !---------------------------------------------------------------------
  character(len=*), intent(in)  :: line   ! Input command line
  logical,          intent(out) :: error  ! Logical error flag
  ! Global
  include 'gbl_memory.inc'
  ! Local
  character(len=*), parameter :: rname='MASK'
  real(kind=4) :: blank
  logical :: in
  integer(kind=4) :: nc,ier,ikey
  character(len=6) :: argum,key
  real(kind=8) :: xconv(3),yconv(3)
  real(kind=4), pointer :: rgbuf(:,:)
  character(len=3), parameter :: inout(2) = (/ 'IN ','OUT' /)
  !
  error = .false.
  if (gpoly%ngon.le.2) then
    call greg_message(seve%e,rname,'No polygon defined')
    error = .true.
  endif
  if (rg%status.eq.code_pointer_null) then
    call greg_message(seve%e,rname,'No regular map loaded')
    error = .true.
  endif
  blank = cblank
  if (eblank.lt.0 .and. .not.sic_present(1,1)) then
    call greg_message(seve%e,rname,'No blanking value')
    error = .true.
  endif
  if (error) return
  call sic_r4 (line,1,1,blank,.false.,error)
  if (error) return
  !
  argum = 'OUT'
  call sic_ke(line,0,1,argum,nc,.false.,error)
  if (error) return
  call sic_ambigs(rname,argum,key,ikey,inout,2,error)
  if (error)  return
  in = key.eq.'IN'
  !
  if (rg%status.eq.code_pointer_associated) then
    ! 'rg%data' is currently used as pointer to data which is not
    ! under our control. Let's allocate our own data
    allocate(rgbuf(rg%nx,rg%ny),stat=ier)
    error = ier.ne.0
    if (error) return
    ! Duplicate data
    call r4tor4(rg%data,rgbuf,rg%nx*rg%ny)
    ! Point to our new buffer
    call reassociate_rgdata(rgbuf,rg%nx,rg%ny,error)
    if (error)  return
    rg%status = code_pointer_allocated  ! Steal the rgbuf allocation
  endif
  !
  xconv(:) = (/ rg%xref,rg%xval,rg%xinc /)
  yconv(:) = (/ rg%yref,rg%yval,rg%yinc /)
  call greg_poly2mask(blank,in,gpoly,rg%nx,rg%ny,xconv,yconv,rg%data)
end subroutine maskon
!
subroutine gr8_glmsk(poly,msk,nx,ny,xconv,yconv,box)
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>gr8_glmsk
  use greg_types
  !---------------------------------------------------------------------
  ! @ public
  !  Return a mask from the current polygon (L version)
  !---------------------------------------------------------------------
  type(polygon_t), intent(in)    :: poly        ! Polygon description
  integer(kind=4), intent(in)    :: nx,ny       ! Size of mask
  logical,         intent(out)   :: msk(nx,ny)  ! Mask to be set
  real(kind=8),    intent(in)    :: xconv(3)    ! Conversion along X
  real(kind=8),    intent(in)    :: yconv(3)    ! Conversion along Y
  integer(kind=4), intent(inout) :: box(4)      ! Mask boundary (xblc,yblc,xtrc,ytrc)
  ! Local
  real(kind=8) :: x,y,xinc,yinc,xval,yval,xref,yref
  integer(kind=4) :: i,j,imin,imax,jmin,jmax
  !
  if (poly%ngon.lt.3) then
    do j=1,ny
      do i=1,nx
        msk(i,j) = .false.
      enddo
    enddo
    do j=box(2),box(4)
      do i=box(1),box(3)
        msk(i,j) = .true.
      enddo
    enddo
    return
  endif
  !
  xref = xconv(1)
  xval = xconv(2)
  xinc = xconv(3)
  yref = yconv(1)
  yval = yconv(2)
  yinc = yconv(3)
  !
  ! Avoid exploring all the Map by finding IMIN,IMAX,JMIN,JMAX
  if (xinc.gt.0.) then
    imin = max (1, int((poly%xgon1-xval)/xinc+xref) )
    imax = min (nx,int((poly%xgon2-xval)/xinc+xref)+1 )
  else
    imin = max (1, int((poly%xgon2-xval)/xinc+xref) )
    imax = min (nx,int((poly%xgon1-xval)/xinc+xref)+1 )
  endif
  if (yinc.gt.0.) then
    jmin = max (1, int((poly%ygon1-yval)/yinc+yref) )
    jmax = min (ny,int((poly%ygon2-yval)/yinc+yref)+1 )
  else
    jmin = max (1, int((poly%ygon2-yval)/yinc+yref) )
    jmax = min (ny,int((poly%ygon1-yval)/yinc+yref)+1 )
  endif
  !
  do j=1,ny
    do i=1,nx
      msk(i,j) = .false.
    enddo
  enddo
  !
  ! Mask the inside
  do j=jmin,jmax
    do i=imin,imax
      x = (i-xref)*xinc+xval
      y = (j-yref)*yinc+yval
      msk(i,j) = greg_poly_inside(x,y,poly)
    enddo
  enddo
  box(1) = imin
  box(2) = jmin
  box(3) = imax
  box(4) = jmax
end subroutine gr8_glmsk
!
subroutine gr8_gimsk(poly,msk,nx,ny,xconv,yconv,box)
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>gr8_gimsk
  use greg_types
  !---------------------------------------------------------------------
  ! @ public
  !  Return a mask from the current polygon (I*4 version)
  !---------------------------------------------------------------------
  type(polygon_t), intent(in)    :: poly        ! Polygon description
  integer(kind=4), intent(in)    :: nx,ny       ! Size of mask
  integer(kind=4), intent(out)   :: msk(nx,ny)  ! Mask to be set
  real(kind=8),    intent(in)    :: xconv(3)    ! Conversion along X
  real(kind=8),    intent(in)    :: yconv(3)    ! Conversion along Y
  integer(kind=4), intent(inout) :: box(4)      ! Mask boundary (xblc,yblc,xtrc,ytrc)
  ! Local
  real(kind=8) :: x,y,xinc,yinc,xval,yval,xref,yref
  integer(kind=4) :: i,j,imin,imax,jmin,jmax
  !
  if (poly%ngon.lt.3) then
    do j=1,ny
      do i=1,nx
        msk(i,j) = 0
      enddo
    enddo
    do j=box(2),box(4)
      do i=box(1),box(3)
        msk(i,j) = 1
      enddo
    enddo
    return
  endif
  !
  xref = xconv(1)
  xval = xconv(2)
  xinc = xconv(3)
  yref = yconv(1)
  yval = yconv(2)
  yinc = yconv(3)
  !
  ! Avoid exploring all the Map by finding IMIN,IMAX,JMIN,JMAX
  if (xinc.gt.0.) then
    imin = max (1, int((poly%xgon1-xval)/xinc+xref) )
    imax = min (nx,int((poly%xgon2-xval)/xinc+xref)+1 )
  else
    imin = max (1, int((poly%xgon2-xval)/xinc+xref) )
    imax = min (nx,int((poly%xgon1-xval)/xinc+xref)+1 )
  endif
  if (yinc.gt.0.) then
    jmin = max (1, int((poly%ygon1-yval)/yinc+yref) )
    jmax = min (ny,int((poly%ygon2-yval)/yinc+yref)+1 )
  else
    jmin = max (1, int((poly%ygon2-yval)/yinc+yref) )
    jmax = min (ny,int((poly%ygon1-yval)/yinc+yref)+1 )
  endif
  !
  do j=1,ny
    do i=1,nx
      msk(i,j) = 0
    enddo
  enddo
  !
  ! Mask the inside
  do j=jmin,jmax
    do i=imin,imax
      x = (i-xref)*xinc+xval
      y = (j-yref)*yinc+yval
      if ( greg_poly_inside(x,y,poly) ) then
        msk(i,j) = 1
      endif
    enddo
  enddo
  box(1) = imin
  box(2) = jmin
  box(3) = imax
  box(4) = jmax
end subroutine gr8_gimsk
!
subroutine gr8_inout(poly,x,y,flag,n,where)
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>gr8_inout
  use greg_types
  !---------------------------------------------------------------------
  ! @ public
  !  Return 1 if inside, 0 if not
  !---------------------------------------------------------------------
  type(polygon_t), intent(in)    :: poly     ! Polygon description
  integer(kind=4), intent(in)    :: n        ! Number of points
  real(kind=8),    intent(in)    :: x(n)     ! X coordinates
  real(kind=8),    intent(in)    :: y(n)     ! Y coordinates
  real(kind=8),    intent(inout) :: flag(n)  ! Inside-out
  logical,         intent(in)    :: where    ! Test inside (.TRUE.) or Outside
  ! Local
  real(kind=8) :: xx,yy
  integer(kind=4) :: i
  !
  if (where) then
    do i=1,n
      xx = x(i)
      yy = y(i)
      if ( greg_poly_inside(xx,yy,poly) ) then
        flag(i) = 0.d0
      endif
    enddo
  else
    do i=1,n
      xx = x(i)
      yy = y(i)
      if ( .not.greg_poly_inside(xx,yy,poly) ) then
        flag(i) = 0.d0
      endif
    enddo
  endif
end subroutine gr8_inout
!
subroutine gr4_inout(poly,x,y,flag,n,where)
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>gr4_inout
  use greg_types
  !---------------------------------------------------------------------
  ! @ public
  !  Return 1 if inside, 0 if not
  !---------------------------------------------------------------------
  type(polygon_t), intent(in)    :: poly     ! Polygon description
  integer(kind=4), intent(in)    :: n        ! Number of points
  real(kind=4),    intent(in)    :: x(n)     ! X coordinates
  real(kind=4),    intent(in)    :: y(n)     ! Y coordinates
  real(kind=4),    intent(inout) :: flag(n)  ! Inside-out
  logical,         intent(in)    :: where    ! Test inside (.TRUE.) or Outside
  ! Local
  real(kind=8) :: xx,yy
  integer(kind=4) :: i
  !
  if (where) then
    do i=1,n
      xx = x(i)
      yy = y(i)
      if ( greg_poly_inside(xx,yy,poly) ) then
        flag(i) = 0.0
      endif
    enddo
  else
    do i=1,n
      xx = x(i)
      yy = y(i)
      if ( .not.greg_poly_inside(xx,yy,poly) ) then
        flag(i) = 0.0
      endif
    enddo
  endif
end subroutine gr4_inout

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Specific Fortran routines and module used for Python binding support.
! These routines are not Python-specific and could be made public (and
! moved) at some point.
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!  Always compile this file, with or without Python. This ensures that
! the interface files are the same in both configuration. We had
! problem with the previous scheme (this file was not compiled if
! Python was disabled) when compiling the same sources for different
! configurations.
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
subroutine gmaster_set_ismaster(ismaster)
  use sic_python
  !---------------------------------------------------------------------
  ! @ private
  ! Python binding private routine.
  ! Set the Gildas programs master status
  !---------------------------------------------------------------------
  logical, intent(in) :: ismaster  !
  !
  gildas_ismaster = ismaster
  !
end subroutine gmaster_set_ismaster
!
function gmaster_get_ismaster()
  use sic_python
  !---------------------------------------------------------------------
  ! @ private
  ! Python binding private routine.
  ! Get the Gildas programs master status
  !---------------------------------------------------------------------
  integer :: gmaster_get_ismaster  ! Function value on return
  !
  if (gildas_ismaster) then
    gmaster_get_ismaster = 1
  else
    gmaster_get_ismaster = 0
  endif
  !
end function gmaster_get_ismaster
!
#if defined(GAG_USE_PYTHON)
!
subroutine gmaster_build_sic(flag)
  use sic_interfaces, except_this=>gmaster_build_sic
  !---------------------------------------------------------------------
  ! @private
  ! Python binding private routine.
  ! Initialize Gildas with SIC as slave
  !---------------------------------------------------------------------
  integer :: flag           ! Error flag
  ! Local
  logical :: error
  !
  flag = 0
  error = .false.
  !
  call sense_inter_state  ! Define some usefull globals
  call gmaster_set_hide_gui
  call gmaster_set_hide_welcome
  call gmaster_build(sic_pack_set,error)
  !
  if (error) flag = 1
  !
end subroutine gmaster_build_sic
!
function sic_verify()
  use sic_structures
  !---------------------------------------------------------------------
  ! @ private
  ! Return the SIC%VERIFY status
  !---------------------------------------------------------------------
  logical :: sic_verify  ! Function value on return
  !
  sic_verify = lverif
  !
end function sic_verify
!
function sic_varlevel()
  use sic_dictionaries
  !---------------------------------------------------------------------
  ! @ public (for Python port)
  ! Retrieve current execution level
  !---------------------------------------------------------------------
  integer :: sic_varlevel  ! Function value on return
  !
  sic_varlevel = var_level
  !
end function sic_varlevel
!
function sic_dictsize()
  use sic_dictionaries
  !---------------------------------------------------------------------
  ! @ public (for Python port)
  ! Retrieve size of SIC hashing list (dictionary)
  !---------------------------------------------------------------------
  integer :: sic_dictsize  ! Function value on return
  !
  sic_dictsize = pfvar(27)
  !
end function sic_dictsize
!
subroutine sic_typecodes(fmt_r4_out,fmt_r8_out,fmt_i4_out,fmt_i8_out,  &
  fmt_l_out,fmt_by_out,fmt_c4_out)
  use gbl_format
  !---------------------------------------------------------------------
  ! @ public (for Python port)
  ! Retrieve SIC type codes
  !---------------------------------------------------------------------
  integer, intent(out) :: fmt_r4_out  !
  integer, intent(out) :: fmt_r8_out  !
  integer, intent(out) :: fmt_i4_out  !
  integer, intent(out) :: fmt_i8_out  !
  integer, intent(out) :: fmt_l_out   !
  integer, intent(out) :: fmt_by_out  !
  integer, intent(out) :: fmt_c4_out  !
  !
  fmt_r4_out = FMT_R4
  fmt_r8_out = FMT_R8
  fmt_i4_out = FMT_I4
  fmt_i8_out = FMT_I8
  fmt_l_out  = FMT_L
  fmt_by_out = FMT_BY
  fmt_c4_out = FMT_C4
  !
end subroutine sic_typecodes
!
subroutine sic_descptr(varname,level,address)
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_descptr
  use gildas_def
  use sic_structures
  use sic_dictionaries
  use sic_types
  !---------------------------------------------------------------------
  ! @ public (for Python port)
  ! Gives back descriptor memory address, given the SIC name.
  ! It is called once or twice, but only at variable initialization.
  ! Return address = -1 means that variable was not found (can be an
  ! error or not depending on the caller).
  !---------------------------------------------------------------------
  character(len=*),             intent(in)  :: varname  !
  integer,                      intent(in)  :: level    !
  integer(kind=address_length), intent(out) :: address  !
  ! Local
  type(sic_identifier_t) :: var
  integer :: ier, in
  integer(kind=address_length) :: descr(6+sic_maxdims)
  save  descr  ! Because C code will reaccess its values later on
  !
  if (varname.eq.' ')  return
  !
  var%name = varname
  var%lname = len_trim(varname)
  var%level = level
  ier = sic_hasfin(maxvar,pfvar,pnvar,dicvar,var,in)
  if (ier.ne.1) then
     address = -1
     return
  endif
  !
  ! Fill my local descriptor. Unefficient?
  descr(1) = dicvar(in)%desc%type
  descr(2) = dicvar(in)%desc%addr
  descr(3) = dicvar(in)%desc%size
  descr(4) = dicvar(in)%desc%status
  if (dicvar(in)%desc%readonly) then
    descr(5) = 1
  else
    descr(5) = 0
  endif
  descr(6) = dicvar(in)%desc%ndim
  descr(7:6+sic_maxdims) = dicvar(in)%desc%dims(1:sic_maxdims)
  !
  ! And return the address of my local (but saved) descriptor
  address = locwrd(descr)
  !
end subroutine sic_descptr
!
subroutine sic_getname(varnum,varname,namelength,varlevel)
  use sic_dependencies_interfaces
  use gildas_def
  use sic_structures
  use sic_dictionaries
  !---------------------------------------------------------------------
  ! @ public (for Python port)
  ! Retrieve variable name from its number in dictionary
  !---------------------------------------------------------------------
  integer,                       intent(in)  :: varnum      !
  character(len=varname_length), intent(out) :: varname     !
  integer,                       intent(out) :: namelength  !
  integer,                       intent(out) :: varlevel    !
  ! Local
  integer :: list(maxvar),in,ik
  !
  call gag_haslis(maxvar,pfvar,pnvar,list,in)
  ik         = list(varnum)
  varname    = dicvar(ik)%id%name
  namelength = len_trim(varname)
  varlevel   = dicvar(ik)%id%level
  !
end subroutine sic_getname
!
subroutine sic_run_python(line,reentrant,error)
  use gildas_def
  use gbl_message
  use sic_interfaces, except_this=>sic_run_python
  use sic_structures
  !---------------------------------------------------------------------
  ! @ private
  !  Support routine for command
  !   SIC\PYTHON
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line       ! Input command line
  logical,          intent(in)    :: reentrant  ! Allow (re)entrant call to Python prompt
  logical,          intent(inout) :: error      ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='PYTHON'
  integer(kind=4), parameter :: code_next=0  ! See module 'sic_interpreter'
  character(len=132) :: comarg
  integer(kind=4), parameter :: margs=20  ! Maximum number of arguments (Python command line)
  integer(kind=4) :: nc,largs(margs),nargs,iarg,ier
  character(len=filename_length) :: fich
  character(len=filename_length) :: args(margs)  ! Each arg is at most a file name (Python command line)
  logical :: found
  !
  if (sic_present(0,1)) then
    ! One or more arguments have been passed
    call sic_ch(line,0,1,comarg,nc,.true.,error)
    if (error)  return
    if (comarg(nc-2:nc).eq.'.py') then
      ! 1st argument ends with '.py'
      call find_procedure(comarg,fich,found)
      if (found) then
        ! Store filename and args in 'COMARG'
        call sic_ch(line,0,1,args(1),largs(1),.true.,error)
        nargs = min(margs,sic_narg(0))
        do iarg=2,nargs
          call sic_st(line,0,iarg,args(iarg),largs(iarg),.true.,error)
          if (error)  exit  ! Exit loop
        enddo
        call gpy_execfile(fich,len_trim(fich),args,largs,len(args(1)),nargs,ier)
        if (ier.ne.0) error = .true.
      else
        call sic_message(seve%e,rname,'No such file '//comarg(1:nc))
        error = .true.
        return
      endif
    else
      ! Arguments are a command
      comarg = line(ccomm%ibeg(2):ccomm%iend(ccomm%nword))
      nc = len_trim(comarg)
      call gpy_exec(comarg,nc,ier)
      if (ier.ne.0) error = .true.
    endif
    !
  elseif (reentrant) then
    ! No argument passed
    call gpy_interact()
    !
  else
    call sic_message(seve%e,'PYTHON',  &
      'Entering Python prompt is invalid in this context')
    error = .true.
    return
  endif
  !
end subroutine sic_run_python
#else
subroutine sic_run_python(line,reentrant,error)
  use gbl_message
  use sic_interfaces, except_this=>sic_run_python
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line       ! Input command line
  logical,          intent(in)    :: reentrant  ! Allow (re)entrant call to Python prompt
  logical,          intent(inout) :: error      ! Logical error flag
  ! Local
  integer(kind=4), parameter :: code_next=0  ! See module 'sic_interpreter'
  !
  call sic_message(seve%e,'PYTHON','SIC not compiled with Python binding')
  error = .true. ! Test 
!  error = .false.  ! Not sure why...
end subroutine sic_run_python
#endif

program table_margin
  use gildas_def
  use gbl_format
  use image_def
  use gkernel_interfaces
  use gbl_message
  !---------------------------------------------------------------------
  ! GILDAS	Stand alone program
  !
  !	  Marginalize a table of values depending of n (> 2) variables
  ! to obtain a table of values of 2 variables. The marginalization
  ! can be by selecting the Min (appropriate for Chi^2), the Max
  ! (appropriate for Likelikhood) the Mean or the Sum.
  !---------------------------------------------------------------------
  ! Global
  character(len=*), parameter :: rname = 'MARGINALIZE'
  integer, parameter :: code_min=1, code_max=2, code_sum=3, code_mean=4
  ! Local
  real :: blank
  integer :: cols(3)
  logical :: error
  integer :: i, code
  character(len=filename_length) :: iname, oname
  character(len=12) :: algo
  character(len=120) :: mess  
  type(gildas) :: hin, hout
  !
  ! Open parameter file
  call gildas_open
  call gildas_char('TABLE_IN$',iname)
  call gildas_char('TABLE_OUT$',oname)
  call gildas_inte('COLUMNS$',cols,3)
  call gildas_char('METHOD$',algo)
  call gildas_real('BLANKING$',blank,1)
  call gildas_close
  !
  call gildas_null(hin, type='TABLE')
  !
  hin%loca%read = .false.
  call gdf_read_gildas(hin,iname,'.tab',error,data=.true.)
  if (error) then
    call gag_message(seve%e,rname,'Cannot read input file')
    call sysexi(fatale)
  endif
  do i=1,3
    if (cols(i).lt.1 .or. cols(i).gt.hin%gil%dim(2)) then
      write(mess,'(A,I0,A)') 'Column ',i,' does not exist'
      call gag_message(seve%e,rname,mess)
      error = .true.
    endif
  enddo
  if (error) call sysexi (fatale)
  call sic_upper(algo)
  select case(algo)
  case ('MIN')
    code = code_min
  case ('MAX')
    code = code_max
  case ('SUM')
    code = code_sum    
  case ('MEAN')
    code = code_mean
  case default
    code = 0
    call gag_message(seve%e,rname,'Invalid method '//algo)
    call sysexi(fatale)
  end select
  !
  call gildas_null(hout, type='TABLE')
  hout%gil%bval = blank
  !
  call sub_table_margin(hin,hout,cols(1),cols(2),cols(3),code,error)
  if (error) call sysexi(fatale)
  !
  call sic_parsef(oname,hout%file,' ','.tab')
  call gdf_write_image(hout,hout%r2d,error)
  if (error) call sysexi(fatale)
  call gagout ('S-'//rname//', Succesful completion')
  !
contains
!
subroutine sub_table_margin(hin,hout,ipx,ipy,ipz,code,error)
  use image_def
  use gbl_message
  use gkernel_interfaces
  !
  type(gildas), intent(in) :: hin     ! Input table
  type(gildas), intent(inout) :: hout ! Output table
  integer, intent(in) :: ipx,ipy,ipz  ! Column pointers
  integer, intent(in) :: code         ! Marginalization code
  logical, intent(inout) :: error     ! Error flag
  !
  character(len=*), parameter :: rname = 'TABLE_PROJECT'
  integer, parameter :: maxsiz=8192**2
  ! Local
  integer(kind=size_length) :: ixy
  integer :: nfx,nfy,ier
  real(8) :: incx,incy
  real(8) :: xmin,xmax,ymin,ymax
  real(8) :: conv(6)
  real(4) :: blank, cblank, eblank
  !
  ! We need a Blanking value, specified in hout%gil%blank
  eblank = -1.0
  cblank = hout%gil%bval ! Does not matter
  blank = hout%gil%bval
  !
  ixy = hin%gil%dim(1)
  call find_inc4(hin%r2d(:,ipx),ixy,xmin,xmax,incx,eblank,cblank)
  call find_inc4(hin%r2d(:,ipy),ixy,ymin,ymax,incy,eblank,cblank)
  !
  ! Find Map size
  nfx  = nint((xmax-xmin)/abs(incx))+1
  nfy  = nint((ymax-ymin)/abs(incy))+1
  if (nfx.le.1 .or. nfy.le.1) then
    call gag_message(seve%e,rname,'No resulting projection')
    Print *,'X ',xmin,xmax,incx, nfx
    Print *,'Y ',ymin,ymax,incy, nfy
    error = .true.
  else if (int(nfx,8)*int(nfy,8).gt.maxsiz**2) then
    call gag_message(seve%e,rname,'Unrealistically large projection')
    call gag_message(seve%e,rname,'Perhaps data is not regularly spaced')
    error = .true.
  endif
  if (error) return
  !
  ! Axis conversion semigroup
  conv(1)=1.0d0
  conv(2)=xmin
  conv(3)=abs(incx)
  conv(4)=1.0d0
  conv(5)=ymin
  conv(6)=abs(incy)
  !
  hout%gil%dim(1) = nfx*nfy
  hout%gil%dim(2) = 3
  allocate(hout%r2d(nfx*nfy,3),stat=ier)
  if (ier.ne.0) then
    call gag_message(seve%e,rname,'Memory allocation error')
    error = .true.
    return
  endif
  !
  ! Computes RGDATA and update several CONPLOT common values
  call rgfromxyz(hout%r2d,nfx,nfy, &
    & hin%r2d(:,ipx),hin%r2d(:,ipy),hin%r2d(:,ipz), &
    & ixy,conv,eblank,cblank,blank,code)
  !
  ! Write the output Table in caller 
end subroutine sub_table_margin
!
subroutine rgfromxyz(rg,nx,ny,x,y,z,n,conv,eb,cb,b,key)
  use gildas_def
  !---------------------------------------------------------------------
  ! Puts Z=F(X,Y) if X and Y are not in a blanked interval;
  !   Z=B where no X,Y
  !---------------------------------------------------------------------
  integer, intent(in)  :: nx                   ! X grid size
  integer, intent(in)  :: ny                   ! Y grid size
  real(4), intent(out)  :: rg(nx,ny,3)         ! Gridded values
  integer(kind=size_length), intent(in) :: n   ! Number of points
  real(4), intent(in)  :: x(n)                 !
  real(4), intent(in)  :: y(n)                 !
  real(4) , intent(in) :: z(n)                 !
  real(8), intent(in)  :: conv(6)              ! Conversion formula
  real(4), intent(in)  :: eb                   ! Blanking tolerance
  real(4), intent(in)  :: cb                   ! Blanking
  real(4), intent(in)  :: b                    ! Default value
  integer, intent(in) :: key  ! Reduction Operation code
  !
  integer, parameter :: code_min=1, code_max=2, code_sum=3, code_mean=4
  ! Local
  integer :: i,j
  integer(kind=size_length) :: k
  integer :: ip(nx,ny)  ! Automatic array
  real(8) :: l1,l2
  integer :: code
  !
  rg(:,:,3) = b
  ip(:,:) = 0
  !
  code = key
  if (key.eq.code_mean) code=code_sum
  !
  if (eb.lt.0.0d0) then
    do k=1,n
      l1=(x(k)-conv(2))/conv(3) + conv(1)
      i=nint(l1)
      l2=(y(k)-conv(5))/conv(6) + conv(4)
      j=nint(l2)      
      if (ip(i,j).eq.0) then
        rg(i,j,1)=x(k)
        rg(i,j,2)=y(k)
        rg(i,j,3)=z(k)
        ip(i,j)=1
      else
        if (code.eq.code_min) then
          rg(i,j,3) = min(rg(i,j,3),z(k))
        else if (code.eq.code_max) then
          rg(i,j,3) = max(rg(i,j,3),z(k))
        else if (code.eq.code_sum) then
          rg(i,j,3) = rg(i,j,3) + z(k)
          ip(i,j)= ip(i,j)+1
        endif
      endif
    enddo
  else
    do k=1,n
      if (abs(x(k)-cb).gt.eb.or.abs(y(k)-cb).gt.eb) then
        l1=(x(k)-conv(2))/conv(3) + conv(1)
        i=nint(l1)
        l2=(y(k)-conv(5))/conv(6) + conv(4)
        j=nint(l2)
        if (ip(i,j).eq.0) then
          rg(i,j,1)=x(k)
          rg(i,j,2)=y(k)
          rg(i,j,3)=z(k)
          ip(i,j)=1
        else
          if (code.eq.code_min) then
            rg(i,j,3) = min(rg(i,j,3),z(k))
          else if (code.eq.code_max) then
            rg(i,j,3) = max(rg(i,j,3),z(k))
          else if (code.eq.code_sum) then
            rg(i,j,3) = rg(i,j,3) + z(k)
            ip(i,j)= ip(i,j)+1
          endif
        endif
      endif
    enddo
  endif
  !
  if (key.eq.code_mean) then
    do j=1,ny
      do i=1,nx
        if (ip(i,j).ne.0) then
          rg(i,j,3) = rg(i,j,3)/ip(i,j)
        endif
      enddo
    enddo
  endif
end subroutine rgfromxyz
!
subroutine find_inc4 (input,ixy,xmin,xmax,xinc,eblank,cblank)
  use gildas_def
  use gkernel_interfaces
  !---------------------------------------------------------------------
  ! Find the increment from X,Y values which are regularly sampled
  !---------------------------------------------------------------------
  integer(kind=size_length), intent(in) :: ixy  ! Number of values
  real(4), intent(in) :: input(ixy)             ! Values
  real(8), intent(out) :: xmin                  ! Minimum
  real(8), intent(out)  :: xmax                 ! Maximum
  real(8), intent(out)  :: xinc                 ! Step
  real(4), intent(in) :: eblank                 ! Blanking tolerance
  real(4), intent(in) :: cblank                 ! Blanking
  ! Local
  real(4), allocatable :: value(:) 
  integer(kind=size_length) :: nval,i,j,nmin,nmax
  integer :: ier
  real(4) :: rmin,rmax
  real(8) :: l1,l2
  logical :: found
  !
  nval = 1
  allocate (value(ixy), stat=ier)
  value(1) = input(1)
  !
  do i=2,ixy
    found = .false.
    do j=1,nval
      if (input(i).eq.value(j)) then
        found = .true.
        exit
      endif
    enddo
    if (.not.found) then
      nval  = nval+1
      value(nval) = input(i)
    endif
  enddo
  !
  call gr4_minmax(nval,value,cblank,eblank,rmin,rmax,nmin,nmax)
  xmin = rmin
  xmax = rmax
  !
  xinc = xmax-xmin
  if (eblank.lt.0.0d0) then
    do i=1,nval-1
      l1=value(i)
      do j=i+1,nval
        l2 = value(j)
        xinc = min(xinc,abs(l1-l2))
      enddo
    enddo
  else
    do i=1,nval-1
      l1=value(i)
      if (abs(l1-cblank).gt.eblank) then
        do j=i+1,nval
          l2 = value(j)
          if (abs(l2-cblank).gt.eblank) then
            xinc = min(xinc,abs(l1-l2))
          endif
        enddo
      endif
    enddo
  endif
  deallocate (value)
end subroutine find_inc4

end program table_margin

subroutine conint (ndp,xd,yd,zd,ncp,ipc,pd)
  !---------------------------------------------------------------------
  ! @ public
  !	This subroutine estimates partial derivatives of the first and
  !	second order at the data points.
  ! Arguments :
  !	NDP	I	Number of data points			Input
  !	XD	R*4 (*)	Array of X coordinates			Input
  !	YD	R*4 (*)	Array of Y coordinates			Input
  !	ZD	R*4 (*)	Array of values				Input
  !	NCP	I	Number of data points to be used for
  !			estimation of partial derivatives at
  !			each data point				Input
  !	IPC	I (*)	Array containing the point numbers of
  !			NCP data points closest to each of the
  !			NDP data point.				Input
  !	PD	R*4 (*) Array of dimension 5*NDP, where the
  !			estimated ZX, ZY, ZXX, ZXY, and ZYY
  !			values at the data points are to be
  !			stored.					Output
  ! No subroutines referenced
  !---------------------------------------------------------------------
  integer :: ndp                    !
  real :: xd(ndp)                   !
  real :: yd(ndp)                   !
  real :: zd(ndp)                   !
  integer :: ncp                    !
  integer :: ipc(*)                 !
  real :: pd(*)                     !
  ! Local
  real :: nmx, nmy, nmz, nmxx, nmxy, nmyx, nmyy
  integer :: ncpm1, ip0, jipc0, ic1, jipc, ipi, ic2mn
  real :: x0, y0, z0, dx1, dy1, dz1
  integer :: ic2, jpd0, jpd
  real :: dx2, dy2, dz2, dnmx, dnmy, dnmz
  real :: zx0, zy0, dzx1, dzy1, dzx2, dzy2
  real :: dnmxx, dnmxy, dnmyx, dnmyy
  !
  ! Preliminary processing
  !
  ncpm1 = ncp-1
  !
  ! Estimation of ZX and ZY
  !
  do ip0=1,ndp
    x0 = xd(ip0)
    y0 = yd(ip0)
    z0 = zd(ip0)
    nmx = 0.0
    nmy = 0.0
    nmz = 0.0
    jipc0 = ncp*(ip0-1)
    do ic1=1,ncpm1
      jipc = jipc0+ic1
      ipi = ipc(jipc)
      dx1 = xd(ipi)-x0
      dy1 = yd(ipi)-y0
      dz1 = zd(ipi)-z0
      ic2mn = ic1+1
      do ic2=ic2mn,ncp
        jipc = jipc0+ic2
        ipi = ipc(jipc)
        dx2 = xd(ipi)-x0
        dy2 = yd(ipi)-y0
        dnmz = dx1*dy2-dy1*dx2
        if (dnmz .eq. 0.0) cycle   ! IC2
        dz2 = zd(ipi)-z0
        dnmx = dy1*dz2-dz1*dy2
        dnmy = dz1*dx2-dx1*dz2
        if (dnmz .ge. 0.0) go to  100
        dnmx = -dnmx
        dnmy = -dnmy
        dnmz = -dnmz
100     nmx = nmx+dnmx
        nmy = nmy+dnmy
        nmz = nmz+dnmz
      enddo                    ! IC2
    enddo                      ! IC1
    jpd0 = 5*ip0
    pd(jpd0-4) = -nmx/nmz
    pd(jpd0-3) = -nmy/nmz
  enddo                        ! IP0
  !
  ! Estimation of ZXX, ZXY, and ZYY
  !
  do ip0=1,ndp
    jpd0 = jpd0+5
    x0 = xd(ip0)
    jpd0 = 5*ip0
    y0 = yd(ip0)
    zx0 = pd(jpd0-4)
    zy0 = pd(jpd0-3)
    nmxx = 0.0
    nmxy = 0.0
    nmyx = 0.0
    nmyy = 0.0
    nmz = 0.0
    jipc0 = ncp*(ip0-1)
    do ic1=1,ncpm1
      jipc = jipc0+ic1
      ipi = ipc(jipc)
      dx1 = xd(ipi)-x0
      dy1 = yd(ipi)-y0
      jpd = 5*ipi
      dzx1 = pd(jpd-4)-zx0
      dzy1 = pd(jpd-3)-zy0
      ic2mn = ic1+1
      do ic2=ic2mn,ncp
        jipc = jipc0+ic2
        ipi = ipc(jipc)
        dx2 = xd(ipi)-x0
        dy2 = yd(ipi)-y0
        dnmz = dx1*dy2-dy1*dx2
        if (dnmz .eq. 0.0) cycle   ! IC2
        jpd = 5*ipi
        dzx2 = pd(jpd-4)-zx0
        dzy2 = pd(jpd-3)-zy0
        dnmxx = dy1*dzx2-dzx1*dy2
        dnmxy = dzx1*dx2-dx1*dzx2
        dnmyx = dy1*dzy2-dzy1*dy2
        dnmyy = dzy1*dx2-dx1*dzy2
        if (dnmz .ge. 0.0) go to  140
        dnmxx = -dnmxx
        dnmxy = -dnmxy
        dnmyx = -dnmyx
        dnmyy = -dnmyy
        dnmz = -dnmz
140     nmxx = nmxx+dnmxx
        nmxy = nmxy+dnmxy
        nmyx = nmyx+dnmyx
        nmyy = nmyy+dnmyy
        nmz = nmz+dnmz
      enddo                    ! IC2
    enddo                      ! IC1
    pd(jpd0-2) = -nmxx/nmz
    pd(jpd0-1) = -(nmxy+nmyx)/(2.0*nmz)
    pd(jpd0) = -nmyy/nmz
  enddo                        ! IP0
end subroutine conint

subroutine sic_diff(line,error)
  use gildas_def
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_diff
  use sic_dictionaries
  !---------------------------------------------------------------------
  ! @ private
  !  Support routine for command
  !    SIC\DIFF Header1 Header2
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line   !
  logical,          intent(inout) :: error  !
  ! Local
  character(len=*), parameter :: rname='DIFF'
  integer(kind=4), parameter :: typenone=0,typevar=1,typefile=2
  integer(kind=4) :: type1,type2
  type(sic_descriptor_t) :: desc1,desc2
  real(kind=4) :: datatol
  logical, save :: differ
  logical, save :: first=.true.
  !
  type1 = typenone
  type2 = typenone
  !
  call getarg(1,type1,desc1,error)
  if (error)  return
  call getarg(2,type2,desc2,error)
  if (error)  goto 10
  datatol = 1e-6
  !
  call sic_diff_descriptors(desc1,desc2,datatol,differ,error)
  if (error)  goto 10
  !
  if (first) then
    call sic_def_logi('SIC%DIFF',differ,.true.,error)
    if (error)  return
    first = .false.
  endif
  !
10 continue
  ! Cleaning
  call closearg(type1,desc1)
  call closearg(type2,desc2)
  !
contains
  !
  subroutine getarg(iarg,argtype,desc,error)
    use sic_types
    !-------------------------------------------------------------------
    ! If the argument provides a header, return a pointer to this
    ! header, or return a null pointer if not.
    !-------------------------------------------------------------------
    integer(kind=4),        intent(in)    :: iarg     ! Argument number on command line
    integer(kind=4),        intent(inout) :: argtype  !
    type(sic_descriptor_t), intent(out)   :: desc     !
    logical,                intent(inout) :: error    !
    ! Local
    character(len=filename_length) :: name
    integer(kind=4) :: nc,ier,ivar
    type(sic_identifier_t) :: var
    !
    call sic_ch(line,0,iarg,name,nc,.true.,error)
    if (error) return
    !
    ! Guess if a Variable or a File
    var%name = name
    var%lname = len_trim(name)
    var%level = var_level
    ier = sic_hasfin(maxvar,pfvar,pnvar,dicvar,var,ivar)
    if (ier.ne.1) then
      var%level = 0
      ier = sic_hasfin(maxvar,pfvar,pnvar,dicvar,var,ivar)
    endif
    if (ier.eq.1) then
      ! Found a variable
      argtype = typevar
      call copy_descr(dicvar(ivar)%desc,desc,error)
      if (error)  return
    else
      ! Must be a file name. Will raise an error if not.
      ! Build a hand-made descriptor, will need special cleaning later on
      !
      allocate(desc%head)           ! Allocated, will be cleaned after use
      call gildas_null(desc%head)
      call gdf_read_gildas(desc%head,name,'.gdf',error,data=.true.,rank=0)
      if (error) then
        deallocate(desc%head)
        return
      endif
      desc%addr = desc%head%loca%addr
      desc%type = desc%head%gil%form
      desc%ndim = desc%head%gil%ndim
      desc%dims(1:desc%ndim) = desc%head%gil%dim(1:desc%ndim)
      ! Other elements not needed in sic_diff_datadescr
      !
      argtype = typefile
      !
    endif
  end subroutine getarg
  !
  subroutine closearg(argtype,desc)
    !-------------------------------------------------------------------
    ! Perform the necessary cleaning depending on argument type
    !-------------------------------------------------------------------
    integer(kind=4),        intent(in)    :: argtype  !
    type(sic_descriptor_t), intent(inout) :: desc     !
    ! Local
    logical :: error2
    !
    select case (argtype)
    case (typefile)
      error2 = .false.
      call gdf_close_image(desc%head,error2)
      if (error2) continue
      if (associated(desc%head%r1d))  deallocate(desc%head%r1d)
      ! ZZZ if image format is not R*4, we have a leak here.
      deallocate(desc%head)  ! Trick here: was allocated
    end select
    !
  end subroutine closearg
  !
end subroutine sic_diff
!
subroutine sic_diff_descriptors(desc1,desc2,datatol,differ,error)
  use gbl_message
  use sic_types
  use sic_interfaces, except_this=>sic_diff_descriptors
  !---------------------------------------------------------------------
  ! @ private
  ! Show the differences between two SIC variables
  !---------------------------------------------------------------------
  type(sic_descriptor_t), intent(in)    :: desc1,desc2
  real(kind=4),           intent(in)    :: datatol
  logical,                intent(out)   :: differ
  logical,                intent(inout) :: error
  ! Local
  logical :: do1,do2
  !
  differ = .false.  ! Default
  !
  do1 = associated(desc1%head)
  do2 = associated(desc2%head)
  if (do1 .and. do2) then
    call sic_diff_headers(desc1%head,desc2%head,differ,error)
  elseif (do1 .and. .not.do2) then
    call sic_message(seve%r,'DIFF','Only first argument provides a header')
    differ = .true.
  elseif (.not.do1 .and. do2) then
    call sic_message(seve%r,'DIFF','Only second argument provides a header')
    differ = .true.
  endif  ! Else both have no header => no message
  !
  do1 = desc1%addr.ne.ptr_null
  do2 = desc2%addr.ne.ptr_null
  if (do1 .and. do2) then
    call sic_diff_datadescr(desc1,desc2,datatol,differ,error)
  elseif (do1 .and. .not.do2) then
    call sic_message(seve%r,'DIFF','Only first argument provides data')
    differ = .true.
  elseif (.not.do1 .and. do2) then
    call sic_message(seve%r,'DIFF','Only second argument provides data')
    differ = .true.
  endif  ! Else both have no data => no message
  !
  if (.not.differ) then
    call sic_message(seve%i,'DIFF','Arguments have no difference')
  endif
  !
end subroutine sic_diff_descriptors
!
subroutine sic_diff_headers(h1,h2,differ,error)
  use image_def
  use sic_interfaces, except_this=>sic_diff_headers
  !---------------------------------------------------------------------
  ! @ private
  ! Show the differences between two GDF headers
  !---------------------------------------------------------------------
  type(gildas), intent(in)    :: h1,h2
  logical,      intent(inout) :: differ
  logical,      intent(inout) :: error
  !
  call sic_diff_general(h1,h2,differ,error)
  if (error)  return
  call sic_diff_dimension(h1,h2,differ,error)
  if (error)  return
  call sic_diff_blanking(h1,h2,differ,error)
  if (error)  return
  call sic_diff_extrema(h1,h2,differ,error)
  if (error)  return
  call sic_diff_coordinate(h1,h2,differ,error)
  if (error)  return
  call sic_diff_description(h1,h2,differ,error)
  if (error)  return
  call sic_diff_position(h1,h2,differ,error)
  if (error)  return
  call sic_diff_projection(h1,h2,differ,error)
  if (error)  return
  call sic_diff_spectroscopy(h1,h2,differ,error)
  if (error)  return
  call sic_diff_resolution(h1,h2,differ,error)
  if (error)  return
  call sic_diff_noise(h1,h2,differ,error)
  if (error)  return
  call sic_diff_astrometry(h1,h2,differ,error)
  if (error)  return
  call sic_diff_telescope(h1,h2,differ,error)
  if (error)  return
  call sic_diff_uvdescr(h1,h2,differ,error)
  if (error)  return
  !
end subroutine sic_diff_headers
!
subroutine sic_diff_general(h1,h2,differ,error)
  use gbl_message
  use image_def
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_diff_general
  !---------------------------------------------------------------------
  ! @ private
  !  Print the differences between 2 headers (section GENERAL)
  !---------------------------------------------------------------------
  type(gildas), intent(in)    :: h1,h2
  logical,      intent(inout) :: differ
  logical,      intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='DIFF'
  character(len=*), parameter :: secname='General'
  logical :: secwarned
  !
  secwarned = .false.
  call gag_diff_elem(rname,secname,secwarned,'TYPE:',       h1%char%type,      h2%char%type)
  call gag_diff_elem(rname,secname,secwarned,'VERSION_GDF:',h1%gil%version_gdf,h2%gil%version_gdf)
  call gag_diff_elem(rname,secname,secwarned,'TYPE_GDF:',   h1%gil%type_gdf,   h2%gil%type_gdf)
  call gag_diff_elem(rname,secname,secwarned,'FORMAT:',     h1%gil%form,       h2%gil%form)
  if (secwarned)  differ = .true.
  !
end subroutine sic_diff_general
!
subroutine sic_diff_dimension(h1,h2,differ,error)
  use gbl_message
  use image_def
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_diff_dimension
  !---------------------------------------------------------------------
  ! @ private
  !  Print the differences between 2 headers (section DIMENSION)
  !---------------------------------------------------------------------
  type(gildas), intent(in)    :: h1,h2
  logical,      intent(inout) :: differ
  logical,      intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='DIFF'
  character(len=*), parameter :: secname='Dimension'
  logical :: secwarned
  character(len=64) :: elname
  integer(kind=4) :: idime
  !
  if (sic_diff_presec(secname,h1%gil%dim_words,h2%gil%dim_words,differ))  return
  !
  secwarned = .false.
  call gag_diff_elem(rname,secname,secwarned,'NDIM:',h1%gil%ndim,h2%gil%ndim)
  do idime=1,min(h1%gil%ndim,h2%gil%ndim)
    write(elname,'(A,I0,A)') 'DIM[',idime,']:'
    call gag_diff_elem(rname,secname,secwarned,elname,h1%gil%dim(idime),h2%gil%dim(idime))
  enddo
  if (secwarned)  differ = .true.
  !
end subroutine sic_diff_dimension
!
subroutine sic_diff_blanking(h1,h2,differ,error)
  use gbl_message
  use image_def
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_diff_blanking
  !---------------------------------------------------------------------
  ! @ private
  !  Print the differences between 2 headers (section BLANKING)
  !---------------------------------------------------------------------
  type(gildas), intent(in)    :: h1,h2
  logical,      intent(inout) :: differ
  logical,      intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='DIFF'
  character(len=*), parameter :: secname='Blanking'
  logical :: secwarned
  !
  if (sic_diff_presec(secname,h1%gil%blan_words,h2%gil%blan_words,differ))  return
  !
  secwarned = .false.
  call gag_diff_elem(rname,secname,secwarned,'BLANK[1]:',h1%gil%bval,h2%gil%bval)
  call gag_diff_elem(rname,secname,secwarned,'BLANK[2]:',h1%gil%eval,h2%gil%eval)
  if (secwarned)  differ = .true.
  !
end subroutine sic_diff_blanking
!
subroutine sic_diff_extrema(h1,h2,differ,error)
  use gbl_message
  use image_def
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_diff_extrema
  !---------------------------------------------------------------------
  ! @ private
  !  Print the differences between 2 headers (section EXTREMA)
  !---------------------------------------------------------------------
  type(gildas), intent(in)    :: h1,h2
  logical,      intent(inout) :: differ
  logical,      intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='DIFF'
  character(len=*), parameter :: secname='Extrema'
  logical :: secwarned
  character(len=64) :: elname
  integer(kind=4) :: idime
  !
  if (sic_diff_presec(secname,h1%gil%extr_words,h2%gil%extr_words,differ))  return
  !
  secwarned = .false.
  call gag_diff_elem(rname,secname,secwarned,'MIN:',h1%gil%rmin,h2%gil%rmin)
  call gag_diff_elem(rname,secname,secwarned,'MAX:',h1%gil%rmax,h2%gil%rmax)
  do idime=1,min(h1%gil%ndim,h2%gil%ndim)
    write(elname,'(A,I0,A)') 'MINLOC[',idime,']:'
    call gag_diff_elem(rname,secname,secwarned,elname,h1%gil%minloc(idime),h2%gil%minloc(idime))
    write(elname,'(A,I0,A)') 'MAXLOC[',idime,']:'
    call gag_diff_elem(rname,secname,secwarned,elname,h1%gil%maxloc(idime),h2%gil%maxloc(idime))
  enddo
  if (secwarned)  differ = .true.
  !
end subroutine sic_diff_extrema
!
subroutine sic_diff_coordinate(h1,h2,differ,error)
  use gbl_message
  use image_def
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_diff_coordinate
  !---------------------------------------------------------------------
  ! @ private
  !  Print the differences between 2 headers (section COORDINATE)
  !---------------------------------------------------------------------
  type(gildas), intent(in)    :: h1,h2
  logical,      intent(inout) :: differ
  logical,      intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='DIFF'
  character(len=*), parameter :: secname='Coordinate'
  logical :: secwarned
  character(len=64) :: elname
  integer(kind=4) :: idime
  !
  if (sic_diff_presec(secname,h1%gil%coor_words,h2%gil%coor_words,differ))  return
  !
  secwarned = .false.
  do idime=1,min(h1%gil%ndim,h2%gil%ndim)
    write(elname,'(A,I0,A,I0,A)') 'CONVERT[1,',idime,'] (REF',idime,'):'
    call gag_diff_elem(rname,secname,secwarned,elname,h1%gil%convert(1,idime),h2%gil%convert(1,idime))
    write(elname,'(A,I0,A,I0,A)') 'CONVERT[2,',idime,'] (VAL',idime,'):'
    call gag_diff_elem(rname,secname,secwarned,elname,h1%gil%convert(2,idime),h2%gil%convert(2,idime))
    write(elname,'(A,I0,A,I0,A)') 'CONVERT[3,',idime,'] (INC',idime,'):'
    call gag_diff_elem(rname,secname,secwarned,elname,h1%gil%convert(3,idime),h2%gil%convert(3,idime))
  enddo
  if (secwarned)  differ = .true.
  !
end subroutine sic_diff_coordinate
!
subroutine sic_diff_description(h1,h2,differ,error)
  use gbl_message
  use image_def
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_diff_description
  !---------------------------------------------------------------------
  ! @ private
  !  Print the differences between 2 headers (section DESCRIPTION)
  !---------------------------------------------------------------------
  type(gildas), intent(in)    :: h1,h2
  logical,      intent(inout) :: differ
  logical,      intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='DIFF'
  character(len=*), parameter :: secname='Description'
  logical :: secwarned
  character(len=64) :: elname
  integer(kind=4) :: idime
  !
  if (sic_diff_presec(secname,h1%gil%desc_words,h2%gil%desc_words,differ))  return
  !
  secwarned = .false.
  call gag_diff_elem(rname,secname,secwarned,'UNIT:',h1%char%unit,h2%char%unit)
  do idime=1,min(h1%gil%ndim,h2%gil%ndim)
    write(elname,'(A,I0,A)') 'UNIT',idime,':'
    call gag_diff_elem(rname,secname,secwarned,elname,h1%char%code(idime),h2%char%code(idime))
  enddo
  if (secwarned)  differ = .true.
  !
end subroutine sic_diff_description
!
subroutine sic_diff_position(h1,h2,differ,error)
  use gbl_message
  use image_def
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_diff_position
  !---------------------------------------------------------------------
  ! @ private
  !  Print the differences between 2 headers (section POSITION)
  !---------------------------------------------------------------------
  type(gildas), intent(in)    :: h1,h2
  logical,      intent(inout) :: differ
  logical,      intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='DIFF'
  character(len=*), parameter :: secname='Position'
  logical :: secwarned
  !
  if (sic_diff_presec(secname,h1%gil%posi_words,h2%gil%posi_words,differ))  return
  !
  secwarned = .false.
  call gag_diff_elem(rname,secname,secwarned,'SOURCE:', h1%char%name,h2%char%name)
  call gag_diff_elem(rname,secname,secwarned,'SYSTEM:', h1%char%syst,h2%char%syst)
  call gag_diff_elem(rname,secname,secwarned,'RA:',     h1%gil%ra,   h2%gil%ra)
  call gag_diff_elem(rname,secname,secwarned,'DEC:',    h1%gil%dec,  h2%gil%dec)
  call gag_diff_elem(rname,secname,secwarned,'LII:',    h1%gil%lii,  h2%gil%lii)
  call gag_diff_elem(rname,secname,secwarned,'BII:',    h1%gil%bii,  h2%gil%bii)
  call gag_diff_elem(rname,secname,secwarned,'EQUINOX:',h1%gil%epoc, h2%gil%epoc)
  if (secwarned)  differ = .true.
  !
end subroutine sic_diff_position
!
subroutine sic_diff_projection(h1,h2,differ,error)
  use gbl_message
  use image_def
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_diff_projection
  !---------------------------------------------------------------------
  ! @ private
  !  Print the differences between 2 headers (section PROJECTION)
  !---------------------------------------------------------------------
  type(gildas), intent(in)    :: h1,h2
  logical,      intent(inout) :: differ
  logical,      intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='DIFF'
  character(len=*), parameter :: secname='Projection'
  logical :: secwarned
  !
  if (sic_diff_presec(secname,h1%gil%proj_words,h2%gil%proj_words,differ))  return
  !
  secwarned = .false.
  call gag_diff_elem(rname,secname,secwarned,'A0:',    h1%gil%a0,  h2%gil%a0)
  call gag_diff_elem(rname,secname,secwarned,'D0:',    h1%gil%d0,  h2%gil%d0)
  call gag_diff_elem(rname,secname,secwarned,'ANGLE:', h1%gil%pang,h2%gil%pang)
  call gag_diff_elem(rname,secname,secwarned,'PTYPE:', projnam(h1%gil%ptyp),projnam(h2%gil%ptyp))
  call gag_diff_elem(rname,secname,secwarned,'X_AXIS:',h1%gil%xaxi,h2%gil%xaxi)
  call gag_diff_elem(rname,secname,secwarned,'Y_AXIS:',h1%gil%yaxi,h2%gil%yaxi)
  if (secwarned)  differ = .true.
  !
end subroutine sic_diff_projection
!
subroutine sic_diff_spectroscopy(h1,h2,differ,error)
  use gbl_message
  use image_def
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_diff_spectroscopy
  !---------------------------------------------------------------------
  ! @ private
  !  Print the differences between 2 headers (section SPECTROSCOPY)
  !---------------------------------------------------------------------
  type(gildas), intent(in)    :: h1,h2
  logical,      intent(inout) :: differ
  logical,      intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='DIFF'
  character(len=*), parameter :: secname='Spectroscopy'
  logical :: secwarned
  !
  if (sic_diff_presec(secname,h1%gil%spec_words,h2%gil%spec_words,differ))  return
  !
  secwarned = .false.
  call gag_diff_elem(rname,secname,secwarned,'LINE:',   h1%char%line,h2%char%line)
  call gag_diff_elem(rname,secname,secwarned,'FREQRES:',h1%gil%fres, h2%gil%fres)
  call gag_diff_elem(rname,secname,secwarned,'IMAGFRE:',h1%gil%fima, h2%gil%fima)
  call gag_diff_elem(rname,secname,secwarned,'RESTFRE:',h1%gil%freq, h2%gil%freq)
  call gag_diff_elem(rname,secname,secwarned,'VELRES:', h1%gil%vres, h2%gil%vres)
  call gag_diff_elem(rname,secname,secwarned,'VELOFF:', h1%gil%voff, h2%gil%voff)
  call gag_diff_elem(rname,secname,secwarned,'F_AXIS:', h1%gil%faxi, h2%gil%faxi)
  call gag_diff_elem(rname,secname,secwarned,'DOPPLER:',h1%gil%dopp, h2%gil%dopp)
  call gag_diff_elem(rname,secname,secwarned,'VTYPE:',  h1%gil%vtyp, h2%gil%vtyp)
  if (secwarned)  differ = .true.
  !
end subroutine sic_diff_spectroscopy
!
subroutine sic_diff_resolution(h1,h2,differ,error)
  use gbl_message
  use image_def
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_diff_resolution
  !---------------------------------------------------------------------
  ! @ private
  !  Print the differences between 2 headers (section RESOLUTION)
  !---------------------------------------------------------------------
  type(gildas), intent(in)    :: h1,h2
  logical,      intent(inout) :: differ
  logical,      intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='DIFF'
  character(len=*), parameter :: secname='Resolution'
  logical :: secwarned
  !
  if (sic_diff_presec(secname,h1%gil%reso_words,h2%gil%reso_words,differ))  return
  !
  secwarned = .false.
  call gag_diff_elem(rname,secname,secwarned,'MAJOR:',h1%gil%majo,h2%gil%majo)
  call gag_diff_elem(rname,secname,secwarned,'MINOR:',h1%gil%mino,h2%gil%mino)
  call gag_diff_elem(rname,secname,secwarned,'PA:',   h1%gil%posa,h2%gil%posa)
  if (secwarned)  differ = .true.
  !
end subroutine sic_diff_resolution
!
subroutine sic_diff_noise(h1,h2,differ,error)
  use gbl_message
  use image_def
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_diff_noise
  !---------------------------------------------------------------------
  ! @ private
  !  Print the differences between 2 headers (section NOISE)
  !---------------------------------------------------------------------
  type(gildas), intent(in)    :: h1,h2
  logical,      intent(inout) :: differ
  logical,      intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='DIFF'
  character(len=*), parameter :: secname='Noise'
  logical :: secwarned
  !
  if (sic_diff_presec(secname,h1%gil%nois_words,h2%gil%nois_words,differ))  return
  !
  secwarned = .false.
  call gag_diff_elem(rname,secname,secwarned,'NOISE:',h1%gil%noise,h2%gil%noise)
  call gag_diff_elem(rname,secname,secwarned,'RMS:',  h1%gil%rms,  h2%gil%rms)
  if (secwarned)  differ = .true.
  !
end subroutine sic_diff_noise
!
subroutine sic_diff_astrometry(h1,h2,differ,error)
  use gbl_message
  use image_def
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_diff_astrometry
  !---------------------------------------------------------------------
  ! @ private
  !  Print the differences between 2 headers (section ASTROMETRY)
  !---------------------------------------------------------------------
  type(gildas), intent(in)    :: h1,h2
  logical,      intent(inout) :: differ
  logical,      intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='DIFF'
  character(len=*), parameter :: secname='Astrometry'
  logical :: secwarned
  !
  if (sic_diff_presec(secname,h1%gil%astr_words,h2%gil%astr_words,differ))  return
  !
  secwarned = .false.
  call gag_diff_elem(rname,secname,secwarned,'MU[1]:',   h1%gil%mura,    h2%gil%mura)
  call gag_diff_elem(rname,secname,secwarned,'MU[2]:',   h1%gil%mudec,   h2%gil%mudec)
  call gag_diff_elem(rname,secname,secwarned,'PARALLAX:',h1%gil%parallax,h2%gil%parallax)
  if (secwarned)  differ = .true.
  !
end subroutine sic_diff_astrometry
!
subroutine sic_diff_telescope(h1,h2,differ,error)
  use gbl_message
  use image_def
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_diff_telescope
  !---------------------------------------------------------------------
  ! @ private
  !  Print the differences between 2 headers (section TELESCOPE)
  !---------------------------------------------------------------------
  type(gildas), intent(in)    :: h1,h2
  logical,      intent(inout) :: differ
  logical,      intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='DIFF'
  character(len=*), parameter :: secname='Telescope'
  logical :: secwarned
  character(len=64) :: elname
  integer(kind=4) :: itel
  !
  if (sic_diff_presec(secname,h1%gil%tele_words,h2%gil%tele_words,differ))  return
  !
  secwarned = .false.
  call gag_diff_elem(rname,secname,secwarned,'NTEL:',h1%gil%nteles,h2%gil%nteles)
  do itel=1,min(h1%gil%nteles,h2%gil%nteles)
    write(elname,'(A,I0,A)') 'TEL',itel,'%NAME:'
    call gag_diff_elem(rname,secname,secwarned,elname,h1%gil%teles(itel)%ctele,h2%gil%teles(itel)%ctele)
  enddo
  if (secwarned)  differ = .true.
  !
end subroutine sic_diff_telescope
!
subroutine sic_diff_uvdescr(h1,h2,differ,error)
  use gbl_message
  use image_def
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_diff_uvdescr
  !---------------------------------------------------------------------
  ! @ private
  !  Print the differences between 2 headers (section UV_DATA
  ! description)
  !---------------------------------------------------------------------
  type(gildas), intent(in)    :: h1,h2
  logical,      intent(inout) :: differ
  logical,      intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='DIFF'
  character(len=*), parameter :: secname='UV Description'
  logical :: secwarned
  !
  if (sic_diff_presec(secname,h1%gil%uvda_words,h2%gil%uvda_words,differ))  return
  !
  secwarned = .false.
  call gag_diff_elem(rname,secname,secwarned,'VERSION_UV:',h1%gil%version_uv,h2%gil%version_uv)
  call gag_diff_elem(rname,secname,secwarned,'NCHAN:',     h1%gil%nchan,     h2%gil%nchan)
  call gag_diff_elem(rname,secname,secwarned,'NVISI:',     h1%gil%nvisi,     h2%gil%nvisi)
  call gag_diff_elem(rname,secname,secwarned,'NSTOKES:',   h1%gil%nstokes,   h2%gil%nstokes)
  call gag_diff_elem(rname,secname,secwarned,'NATOM:',     h1%gil%natom,     h2%gil%natom)
  call gag_diff_elem(rname,secname,secwarned,'BASEMIN:',   h1%gil%basemin,   h2%gil%basemin)
  call gag_diff_elem(rname,secname,secwarned,'BASEMAX:',   h1%gil%basemax,   h2%gil%basemax)
  if (secwarned)  differ = .true.
  !
end subroutine sic_diff_uvdescr
!
function sic_diff_presec(secname,len1,len2,differ)
  use gbl_message
  use sic_interfaces, except_this=>sic_diff_presec
  !---------------------------------------------------------------------
  ! @ private
  ! Return .true. if the section is absent from 1 or from the 2 headers
  !---------------------------------------------------------------------
  logical :: sic_diff_presec
  character(len=*), intent(in)    :: secname    ! Section name
  integer(kind=4),  intent(in)    :: len1,len2  ! Section lengths
  logical,          intent(inout) :: differ     !
  !
  if (len1.le.0 .and. len2.le.0) then
    sic_diff_presec = .true.
  elseif (len1.gt.0 .and. len2.le.0) then
    call sic_message(seve%r,'DIFF','Only in first header: '//(secname)//' section')
    sic_diff_presec = .true.
  elseif (len1.le.0 .and. len2.gt.0) then
    call sic_message(seve%r,'DIFF','Only in second header: '//(secname)//' section')
    sic_diff_presec = .true.
  else
    sic_diff_presec = .false.
  endif
  if (len1.le.0 .neqv. len2.le.0)  differ = .true.
  !
end function sic_diff_presec
!
subroutine sic_diff_datadescr(desc1,desc2,datatol,differ,error)
  use sic_interfaces, except_this=>sic_diff_datadescr
  use sic_types
  !---------------------------------------------------------------------
  ! @ private
  ! Show the differences between the data of two SIC variables
  !---------------------------------------------------------------------
  type(sic_descriptor_t), intent(in)    :: desc1,desc2
  real(kind=4),           intent(in)    :: datatol
  logical,                intent(inout) :: differ
  logical,                intent(inout) :: error
  ! Local
  logical :: isuvt1,istuv1,isuvt2,istuv2
  !
  isuvt1 = isuv(desc1,1)
  istuv1 = isuv(desc1,2)
  isuvt2 = isuv(desc2,1)
  istuv2 = isuv(desc2,2)
  !
  if (isuvt1.and.isuvt2) then
    ! Both are UVT tables
    call sic_diff_uvt(desc1,desc2,datatol,differ,error)
! elseif (istuv1.and.istuv2) then
!   ! Both are UVT tables
!   call sic_diff_tuv(desc1,desc2,datatol,error) => to be implemented
  else
    ! Maybe be non-gdf or images or mix of inconsistant data: basic comparison
    call sic_diff_image(desc1,desc2,datatol,differ,error)
  endif
  !
contains
  logical function isuv(desc,idime)
    type(sic_descriptor_t), intent(in) :: desc
    integer(kind=4),        intent(in) :: idime
    isuv = associated(desc%head) .and. &
          (desc%head%char%code(idime).eq.'UV-DATA' .or. &
           desc%head%char%code(idime).eq.'UV-RAW')
  end function isuv
  !
end subroutine sic_diff_datadescr
!
subroutine sic_diff_uvt(desc1,desc2,datatol,differ,error)
  use gbl_message
  use sic_interfaces, except_this=>sic_diff_uvt
  use sic_types
  !---------------------------------------------------------------------
  ! @ private
  ! Show the differences between the data of two UVT variables
  !---------------------------------------------------------------------
  type(sic_descriptor_t), intent(in)    :: desc1,desc2
  real(kind=4),           intent(in)    :: datatol
  logical,                intent(inout) :: differ
  logical,                intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='DIFF'
  integer(kind=4) :: icol
  logical :: secwarned
  !
  if (desc1%head%gil%nvisi.ne.desc2%head%gil%nvisi) then
    call sic_message(seve%w,rname,  &
      'Number of visibilities do not match, can not compare UV data')
    differ = .true.
    return
  endif
  !
  secwarned = .false.
  do icol=1,code_uvt_last
    call sic_diff_uvtcolumn(desc1,desc2,icol,datatol,secwarned,error)
    if (error)  return
  enddo
  if (secwarned)  differ = .true.
  !
  ! And now compare the UV data itself
  call sic_diff_uvtdata(desc1,desc2,datatol,differ,error)
  if (error)  return
  !
end subroutine sic_diff_uvt
!
subroutine sic_diff_uvtcolumn(desc1,desc2,colid,datatol,secwarned,error)
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_diff_uvtcolumn
  use sic_types
  !---------------------------------------------------------------------
  ! @ private
  ! Show the differences between the data of two UV columns variables
  !---------------------------------------------------------------------
  type(sic_descriptor_t), intent(in)    :: desc1,desc2
  integer(kind=4),        intent(in)    :: colid
  real(kind=4),           intent(in)    :: datatol
  logical,                intent(inout) :: secwarned
  logical,                intent(inout) :: error
  ! Global
  include 'gbl_memory.inc'
  ! Local
  character(len=*), parameter :: rname='DIFF'
  logical :: hascol1,hascol2,same
  integer(kind=address_length) :: ipnt1,ipnt2
  integer(kind=4) :: colptr1,colptr2,ndata1,ndata2,nvisi1,nvisi2
  character(len=8) :: colname
  character(len=message_length) :: mess
  ! UV column names must match UV column codes
  !
  colname = uv_column_name(colid)
  hascol1 = desc1%head%gil%column_size(colid).gt.0
  hascol2 = desc2%head%gil%column_size(colid).gt.0
  if (hascol1 .and. .not.hascol2) then
    same = .false.
    mess = 'Only in first UV table: '//(colname)//' column'
  elseif (.not.hascol1 .and. hascol2) then
    same = .false.
    mess = 'Only in second UV table: '//(colname)//' column'
  elseif (hascol1.and.hascol2) then
    ipnt1 = gag_pointer(desc1%addr,memory)
    ipnt2 = gag_pointer(desc2%addr,memory)
    ndata1 = desc1%head%gil%dim(1)
    ndata2 = desc2%head%gil%dim(1)
    nvisi1 = desc1%head%gil%nvisi
    nvisi2 = desc2%head%gil%nvisi
    colptr1 = desc1%head%gil%column_pointer(colid)
    colptr2 = desc2%head%gil%column_pointer(colid)
    call sic_diff_uvtcolumn_ptr(memory(ipnt1),ndata1,nvisi1,colptr1,  &
                                memory(ipnt2),ndata2,nvisi2,colptr2,  &
                                datatol,same)
    mess = colname//' column data'
  else
    ! If both absent => no message
    same = .true.
  endif
  !
  if (.not.same) then
    if (.not.secwarned) then
      call sic_message(seve%r,rname,'UV DAPS differ')
      secwarned = .true.
    endif
    call sic_message(seve%r,rname,'  '//mess)
  endif
  !
end subroutine sic_diff_uvtcolumn
!
subroutine sic_diff_uvtcolumn_ptr(data1,ndata1,nvisi1,colptr1,  &
                                  data2,ndata2,nvisi2,colptr2,  &
                                  datatol,same)
  use sic_dependencies_interfaces
  !---------------------------------------------------------------------
  ! @ no-interface
  ! Show the differences between the data of two UV columns variables
  !---------------------------------------------------------------------
  integer(kind=4), intent(in)  :: ndata1,ndata2
  integer(kind=4), intent(in)  :: nvisi1,nvisi2
  real(kind=4),    intent(in)  :: data1(ndata1,nvisi1)
  real(kind=4),    intent(in)  :: data2(ndata2,nvisi2)
  integer(kind=4), intent(in)  :: colptr1,colptr2
  real(kind=4),    intent(in)  :: datatol
  logical,         intent(out) :: same
  ! Local
  integer(kind=4) :: ivisi
  !
  same = .true.
  do ivisi=1,min(nvisi1,nvisi2)
    if (.not.nearly_equal(data1(colptr1,ivisi),data2(colptr2,ivisi),datatol)) then
      same = .false.
      return
    endif
  enddo
  !
end subroutine sic_diff_uvtcolumn_ptr
!
subroutine sic_diff_uvtdata(desc1,desc2,datatol,differ,error)
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_diff_uvtdata
  use sic_types
  !---------------------------------------------------------------------
  ! @ private
  ! Show the differences between the data of two UV columns variables
  !---------------------------------------------------------------------
  type(sic_descriptor_t), intent(in)    :: desc1,desc2
  real(kind=4),           intent(in)    :: datatol
  logical,                intent(inout) :: differ
  logical,                intent(inout) :: error
  ! Global
  include 'gbl_memory.inc'
  ! Local
  character(len=*), parameter :: rname='DIFF'
  logical :: same
  integer(kind=address_length) :: ipnt1,ipnt2
  integer(kind=4) :: fcol1,lcol1,ndata1,nvisi1
  integer(kind=4) :: fcol2,lcol2,ndata2,nvisi2
  !
  fcol1 = desc1%head%gil%fcol
  lcol1 = desc1%head%gil%lcol
  fcol2 = desc2%head%gil%fcol
  lcol2 = desc2%head%gil%lcol
  !
  if (lcol1-fcol1.ne.lcol2-fcol2) then
    ! UV data block sizes differ. It might be different number of channels,
    ! different number of atoms per channel, or stokes, etc...
    call sic_message(seve%w,rname,'UV data block sizes differ, can not compare UV data')
    differ = .true.
    return
  endif
  !
  ipnt1 = gag_pointer(desc1%addr,memory)
  ipnt2 = gag_pointer(desc2%addr,memory)
  ndata1 = desc1%head%gil%dim(1)
  ndata2 = desc2%head%gil%dim(1)
  nvisi1 = desc1%head%gil%nvisi
  nvisi2 = desc2%head%gil%nvisi
  !
  call sic_diff_uvtdata_ptr(memory(ipnt1),ndata1,nvisi1,fcol1,lcol1,  &
                            memory(ipnt2),ndata2,nvisi2,fcol2,lcol2,  &
                            datatol,same)
  if (.not.same) then
    call sic_message(seve%r,rname,'UV DATA differ')
    differ = .true.
  endif
  !
end subroutine sic_diff_uvtdata
!
subroutine sic_diff_uvtdata_ptr(data1,ndata1,nvisi1,fcol1,lcol1,  &
                                data2,ndata2,nvisi2,fcol2,lcol2,  &
                                datatol,same)
  use gildas_def
  use sic_dependencies_interfaces
  !---------------------------------------------------------------------
  ! @ no-interface
  ! Show the differences between the data of two UV variables
  !---------------------------------------------------------------------
  integer(kind=4), intent(in)  :: ndata1,ndata2
  integer(kind=4), intent(in)  :: nvisi1,nvisi2
  real(kind=4),    intent(in)  :: data1(ndata1,nvisi1)
  real(kind=4),    intent(in)  :: data2(ndata2,nvisi2)
  integer(kind=4), intent(in)  :: fcol1,fcol2
  integer(kind=4), intent(in)  :: lcol1,lcol2
  real(kind=4),    intent(in)  :: datatol
  logical,         intent(out) :: same
  ! Local
  integer(kind=4) :: ivisi
  integer(kind=size_length) :: ncol
  !
  same = .true.
  ncol = lcol1-fcol1+1
  do ivisi=1,min(nvisi1,nvisi2)
    if (.not.nearly_equal(data1(fcol1:lcol1,ivisi),  &
                          data2(fcol2:lcol2,ivisi),  &
                          ncol,datatol)) then
      same = .false.
      return
    endif
  enddo
  !
end subroutine sic_diff_uvtdata_ptr
!
subroutine sic_diff_image(desc1,desc2,datatol,differ,error)
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_diff_image
  use sic_types
  !---------------------------------------------------------------------
  ! @ private
  ! Show the differences between the data of two SIC variables
  !---------------------------------------------------------------------
  type(sic_descriptor_t), intent(in)    :: desc1,desc2
  real(kind=4),           intent(in)    :: datatol
  logical,                intent(inout) :: differ
  logical,                intent(inout) :: error
  ! Global
  include 'gbl_memory.inc'
  ! Local
  character(len=*), parameter :: rname='DIFF'
  character(len=*), parameter :: secname='Data descriptor'
  logical :: secwarned,same
  integer(kind=4) :: idime
  character(len=64) :: elname
  integer(kind=size_length) :: ndata1,ndata2
  integer(kind=address_length) :: ipnt1,ipnt2
  !
  secwarned = .false.
  call gag_diff_elem(rname,secname,secwarned,'TYPE:',desc1%type,desc2%type)
  call gag_diff_elem(rname,secname,secwarned,'NDIM:',desc1%ndim,desc2%ndim)
  do idime=1,min(desc1%ndim,desc2%ndim)
    write(elname,'(A,I0,A)') 'DIM[',idime,']:'
    call gag_diff_elem(rname,secname,secwarned,elname,desc1%dims(idime),desc2%dims(idime))
  enddo
  ndata1 = desc_nelem(desc1)
  ndata2 = desc_nelem(desc2)
  !
  if (desc1%type.ne.desc2%type .or. ndata1.ne.ndata2) then
    ! Only compare same data kind and size
    call sic_message(seve%w,rname,'Data not compared (incompatible data type or size)')
    differ = .true.
    return
  endif
  !
  ipnt1 = gag_pointer(desc1%addr,memory)
  ipnt2 = gag_pointer(desc2%addr,memory)
  select case (desc1%type)
  case (fmt_r4)
    ! ZZZ pass custom 'datatol'
    call gag_diff_datar4(rname,memory(ipnt1),memory(ipnt2),ndata1,same)
    if (.not.same)  differ = .true.
  case default
    call sic_message(seve%w,rname,'Data not compared (only R*4 implemented)')
  end select
  if (error)  return
  !
end subroutine sic_diff_image

subroutine mtskip(chan,nskip,ncoun,end_tape,err)
  use gsys_interfaces, except_this=>mtskip
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! FITS  Internal routine
  !       Skip tape-marks and return count and status
  !       This entry should only be called when END_OF_FILE is
  !       already .TRUE.
  ! Arguments :
  !       CHAN     I      I/O Channel
  !       NSKIP    I      Number of files to skip         Input
  !       NCOUN    I      Number of tape mark skipped     Output
  !       END_TAPE L      End-of-Tape reached             Output
  !       ERR      L      Logical error flag              Output
  !---------------------------------------------------------------------
  integer(kind=4) :: chan           !
  integer(kind=2) :: nskip          !
  integer(kind=4) :: ncoun          !
  logical         :: end_tape       !
  logical         :: err            !
  integer(kind=4) :: nbuf           !
  integer(kind=1) :: buf(*)         ! NBUF normally
  logical         :: end_file       !
  integer(kind=4) :: block          !
  !*----------------------------------------------------------------------
  ! Skip a record
  !
entry mtskbl (chan,nskip,ncoun,end_file,end_tape,err)
  !
entry mtend(chan,end_tape,err)
  !----------------------------------------------------------------------
  ! UTIL  Internal routine
  !       Move to end of current file on tape
  ! Arguments
  !       CHAN    I       I/O channel                     Input
  !       END_TAPE L      End of tape reached
  !       ERR     L       logical error flag              Output
  !----------------------------------------------------------------------
  !
entry mtinit (chan,err)
  !----------------------------------------------------------------------
  ! UTIL  Internal routine
  !       Init a magnetic tape
  ! Arguments
  !       CHAN    I       I/O channel                     Input
  !       ERR     L       logical error flag              Output
  !----------------------------------------------------------------------
  !
entry mtrewi (chan,err)
  !----------------------------------------------------------------------
  ! UTIL  Internal routine
  !       Rewind a magtape
  ! Arguments
  !       CHAN    I       i/o channel                     Input
  !       ERR     L       logical error flag              Output
  !----------------------------------------------------------------------
  !
entry mtmark(chan,err)
  !----------------------------------------------------------------------
  ! SAS   Utility routine
  !       Writes an end-of-tape marker at current tape position
  !       and leave tape at end of tape.
  ! Arguments :
  !       CHAN    I       I/O Channel assigned to tape    Input
  !       ERR     L       Logical error flag              Output
  !----------------------------------------------------------------------
entry mteof(chan,err)
  !----------------------------------------------------------------------
  ! SAS   Utility routine
  !       Writes an end-of-file marker at current tape position
  !       and leave tape at end of tape.
  ! Arguments :
  !       CHAN    I       I/O Channel assigned to tape    Input
  !       ERR     L       Logical error flag              Output
  !----------------------------------------------------------------------
entry mtwrit (chan,buf,nbuf,err)
  !----------------------------------------------------------------------
  ! UTIL  Internal routine
  !       Writes buffer to I/O channel
  ! Arguments :
  !       CHAN    I       I/O channel                     Input
  !       BUF     L*1(*)  Buffer to be written            Input
  !       NBUF    I       Number of bytes in BUFFER       Input
  !       ERR     L       Logical error flag              Output
  !----------------------------------------------------------------------
entry mtread (chan,buf,nbuf,end_file,end_tape,err)
  !----------------------------------------------------------------------
  ! UTIL  Internal routine
  !       Read buffer from I/O channel
  ! Arguments :
  !       CHAN    I       I/O channel                     Input
  !       BUF     L*1(*)  Buffer to be written            Input
  !       NBUF    I       Number of bytes in BUF          Input
  !       END_FILE L      End of file flag                Output
  !       END_TAPE L      End of tape flag                Output
  !       ERR     L       Logical error flag              Output
  !----------------------------------------------------------------------
entry mtflus (chan,err)
  !----------------------------------------------------------------------
  ! UTIL  : Internal routine
  !       Flush output buffer for blocked-I/O
  !----------------------------------------------------------------------
entry mtblock (block)
  !----------------------------------------------------------------------
  ! UTIL  : Internal routine
  !       Specify blocking factor for tape write
  !----------------------------------------------------------------------
  call gsys_message(seve%e,'TAPE','Tape routines have not yet been implemented')
  err = .true.
end subroutine mtskip
!
subroutine mtmoun (tape,dens,chan,err)
  use gsys_interfaces, except_this=>mtmoun
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! UTIL  Internal routine
  !       Tries to mount a tape on device "TAPE", which
  !       must be assigned to a generic name of tape devices.
  ! Arguments :
  !       TAPE    C*(*)   Tape device logical name        Input
  !       CHAN    I       I/O channel assigned            Output
  !       ERR     L       Logical error flag              Input
  !---------------------------------------------------------------------
  character(len=*) :: tape          !
  integer(kind=4)  :: dens          !
  integer(kind=4)  :: chan          !
  logical          :: err           !
  !
entry mtdism (tape,chan,err)
  !----------------------------------------------------------------------
  ! SAS   Internal routine
  !       Dismount a tape on given channel, and frees the corresponding
  !       I/O channel
  ! Arguments :
  !       TAPE    C*(*)   Logical name of tape drive              Input
  !       CHAN    I       I/O Channel assigned to tape            Input
  !       ERR     L       Logical error flag                      Output
  !----------------------------------------------------------------------
  call gsys_message(seve%e,'TAPE','Tape routines have not yet been implemented')
  err = .true.
end subroutine mtmoun

subroutine sic_lower(c)
  !---------------------------------------------------------------------
  ! @ public
  !  Converts a character string to lowercase.
  !---------------------------------------------------------------------
  character(len=*), intent(inout) :: c  ! Character string
  ! Local
  integer(kind=4) :: i,ic
  do i=1,len(c)
    if (c(i:i).ge.'A' .and. c(i:i).le.'Z') then
      ic = ichar(c(i:i))+ichar('a')-ichar('A')
      c(i:i)=char(ic)
    endif
  enddo
end subroutine sic_lower
!
subroutine sic_upper(c)
  !---------------------------------------------------------------------
  ! @ public
  !  Converts a character string to uppercase.
  !  Slow if called frequently to convert a single character.
  !---------------------------------------------------------------------
  character(len=*), intent(inout) :: c  ! Character string
  ! Local
  integer(kind=4) :: i,ic
  !
  do i=1,len(c)
    if (c(i:i).ge.'a' .and. c(i:i).le.'z') then
      ic=ichar(c(i:i))+ichar('A')-ichar('a')
      c(i:i)=char(ic)
    endif
  enddo
end subroutine sic_upper
!
function lenc(c)
  !---------------------------------------------------------------------
  ! @ public
  !  Returns the location of the last non-blank character in a string.
  !---------------------------------------------------------------------
  integer(kind=4) :: lenc  ! Function value on return
  character(len=*), intent(in) :: c  ! Character string
  ! Local
  integer(kind=4) :: i
  !
  do i=len(c),1,-1
    if (ichar(c(i:i)).gt.32) then
      lenc = i
      return
    endif
  enddo
  lenc = 0
end function lenc
!
subroutine sic_blanc(c,n)
  !---------------------------------------------------------------------
  ! @ public
  !   Reduce the character string C to the standard SIC internal syntax.
  !   Suppress all unecessary separators.
  !   Character strings "abcd... " are not modified.
  !   Convert to upper case all characters.
  !   Ignores and destroys comments.
  !---------------------------------------------------------------------
  character(len=*), intent(inout) :: c  ! Character string to be formatted
  integer(kind=4),  intent(inout) :: n  ! Length of C
  ! Local
  integer(kind=4) :: i,nl
  logical :: lo,li,chaine,some
  integer(kind=4), parameter :: tab=9
  !
  if (n.eq.0) return
  !
  li = .false.
  lo = .true.
  chaine = .false.
  some = .false.
  nl = n
  n = 0
  i = 1
  !
  do while (i.le.nl)
    !
    ! Skip character strings
    if (c(i:i).eq.'"') then
      chaine=.not.chaine
    endif
    if (chaine) goto 30
    !
    ! Suppress redondant separators
    li=.false.
    if (c(i:i).ne.' ' .and. c(i:i).ne.char(tab)) goto 20
    ! Space separator
    li=.true.
    ! Not the first one
    if (lo)  goto 100
    ! First one
    c(i:i) = ' '
    goto 30
    !
    ! Skip comment area
20  continue
    if (c(i:i).eq.'!') then
      some=.true.
      exit  ! while loop
    endif
    !
    ! Reset input character string
30  n=n+1
    if (i.ne.n) c(n:n) = c(i:i)
    if (i.gt.n) c(i:i) = ' '
100 lo=li
    !
    ! End of loop
    i = i+1
  enddo
  !
  ! Remove trailing separators if any
  if (n.ne.0) then
    if (c(n:n).eq.' ') n=n-1
  endif
  ! Clean up end of line
  if (n.lt.nl) c(n+1:) = ' '
  if (some) n=max(n,1)
end subroutine sic_blanc
!
subroutine sic_next(line,par,lpar,npar,dotab)
  !---------------------------------------------------------------------
  ! @ public
  !  Returns the next "word" of the command line. Words are separated
  ! by blanks, but also optionally by tabulations.
  !---------------------------------------------------------------------
  character(len=*),  intent(in)    :: line   ! Line to be analysed
  character(len=*),  intent(out)   :: par    ! Next word found
  integer(kind=4),   intent(out)   :: lpar   ! Length of word found
  integer(kind=4),   intent(inout) :: npar   ! Start point for analysis, updated for subsequent call
  logical, optional, intent(in)    :: dotab  ! Take also tabulations as separator?
  ! Local
  character(len=1), parameter :: space=' '
  character(len=1), parameter :: tabul=char(9)
  logical :: lw1, lw2, chaine,checktab
  integer(kind=4) :: l1,j,l2
  !
  if (present(dotab)) then
    checktab = dotab
  else
    checktab = .false.
  endif
  chaine = .false.
  lw1 = .false.
  lw2 = .true.
  l1 = 0
  do j = 1,len(line)
    !
    ! Character strings
    if (line(j:j).eq.'"') then
      if (.not.chaine) then
        l1 = j
        chaine = .true.
        goto 10
      endif
      l2 = j
      goto 20
    endif
    if (chaine) goto 10
    !
    ! Usual delimiters
    lw1 = line(j:j).eq.space .or. (checktab.and.line(j:j).eq.tabul)
    if (.not.lw1.and.lw2) then
      l1 = j
    elseif (lw1.and..not.lw2) then
      l2 = j-1
      goto 20
    endif
10  lw2 = lw1
  enddo
  l2 = j-1
  !
20 continue
  if (l1.gt.0) then
    lpar = l2 - l1 + 1
    npar = npar + lpar + 1
    if (.not.chaine) then
      par = line(l1:l2)
    else
      lpar = lpar-2
      par = line(l1+1:l2-1)
    endif
  else
    lpar = 0
  endif
end subroutine sic_next
!
subroutine sic_noir(cin,np)
  !---------------------------------------------------------------------
  ! @ public
  !  Reduce all separators to one.
  !---------------------------------------------------------------------
  character(len=*), intent(inout) :: cin  ! Character string
  integer(kind=4),  intent(out)   :: np   ! Length of string
  ! Local
  integer(kind=4), parameter :: tab=9
  integer(kind=4) :: n,ni,i
  logical :: lo,li
  !
  ! Reduit les Separateurs
  lo = .false.
  ni = len_trim(cin)
  n  = 0
  do i=1,ni
    li=.true.
    if (cin(i:i).ne.' ' .and. cin(i:i).ne.char(9)) then
      n = n+1
      cin(n:n) = cin(i:i)
    else
      !
      ! C'est un blanc
      li=.false.
      if (lo) then
        ! C'est le premier
        n = n+1
        cin(n:n) = ' '
      endif
    endif
    lo = li
  enddo
  cin(n+1:) = ' '
  np = n
end subroutine sic_noir
!
subroutine sic_black(cin,np)
  !---------------------------------------------------------------------
  ! @ public
  !   Suppress all separators
  !---------------------------------------------------------------------
  character(len=*), intent(inout) :: cin  ! Character string
  integer(kind=4),  intent(out)   :: np   ! Length of string
  ! Local
  integer(kind=4), parameter :: tab=9
  integer(kind=4) :: n,ni,i
  !
  ! Reduit les Separateurs
  n  = 0
  ni = len_trim(cin)
  do i=1,ni
    if (cin(i:i).ne.' ' .and. cin(i:i).ne.char(9)) then
      n = n+1
      cin(n:n) = cin(i:i)
    endif
  enddo
  if (n.lt.ni) cin(n+1:) = ' '
  np = n
end subroutine sic_black
!
subroutine sic_upcase(c,n)
  !---------------------------------------------------------------------
  ! @ public
  !   Reduce the character string C to the standard SIC internal syntax.
  !   Suppress all unecessary separators.
  !   Character strings "abcd... " are not modified.
  !   Convert to upper case all characters.
  !   Ignores and destroys comments.
  !---------------------------------------------------------------------
  character(len=*), intent(inout) :: c  ! Character string to be formatted
  integer(kind=4),  intent(inout) :: n  ! Length of string
  ! Local
  integer(kind=4) :: i,nl,ic
  logical :: lo,li,chaine,some
  integer(kind=4), parameter :: tab=9
  !
  if (n.eq.0) return
  !
  lo = .true.
  chaine = .false.
  some = .false.
  nl = n
  n = 0
  i = 1
  li = .false.
  !
  do while (i.le.nl)
    !
    ! Skip character strings
    if (c(i:i).eq.'"') then
      chaine=.not.chaine
    endif
    if (chaine) goto 30
    !
    ! Convert to upper case
    if (c(i:i).ge.'a' .and. c(i:i).le.'z') then
      ic = ichar(c(i:i))-ichar('a')+ichar('A')
      c(i:i)=char(ic)
    endif
    !
    ! Suppress redondant separators
    li=.false.
    if (c(i:i).ne.' ' .and. c(i:i).ne.char(tab)) goto 20
    ! Space separator
    li=.true.
    ! Not the first one
    if (lo)  goto 100
    ! First one
    c(i:i) = ' '
    goto 30
    !
    ! Skip comment area
20  continue
    if (c(i:i).eq.'!') then
      some=.true.
      exit  ! while loop
    endif
    !
    ! Reset input character string
30  n=n+1
    if (i.ne.n) c(n:n) = c(i:i)
    if (i.gt.n) c(i:i) = ' '
100 lo=li
    !
    ! End of loop
    i = i+1
  enddo
  !
  ! Remove trailing separators if any
  if (n.ne.0) then
    if (c(n:n).eq.' ') n=n-1
  endif
  ! Clean up end of line
  if (n.lt.nl) c(n+1:) = ' '
  if (some) n=max(n,1)
end subroutine sic_upcase
!
subroutine sic_separ(separ,line,par,lpar,npar)
  !---------------------------------------------------------------------
  ! @ public
  !  Returns the next "word" of the command line
  !---------------------------------------------------------------------
  character(len=1), intent(in)    :: separ  !
  character(len=*), intent(in)    :: line   !
  character(len=*), intent(out)   :: par    !
  integer(kind=4),  intent(out)   :: lpar   !
  integer(kind=4),  intent(inout) :: npar   !
  ! Local
  logical :: lw1, lw2, list_directed
  character(len=1) :: chaine, lsepar, csepar
  integer(kind=4) :: l1,j,l2,lj, ll
  !
  if (ichar(separ).eq.0) then
    list_directed = .true.
    lsepar = ' '
    chaine = ' '
    csepar = ','
  else
    list_directed = .false.
    lsepar = separ
  endif
  !
  lw1 = .false.
  lw2 = .true.
  l1 = 0
  l2 = -1
  lj = len_trim(line)
  !
  if (list_directed) then
    !!Print *,line(:lj)//'!'
    !
    do j = 1,lj
      !
      ! Character strings if needed...
      if (chaine.ne.' ') then
        ! We are in a string, is it the closing key ?
        if (line(j:j).eq.chaine) then
          l2 = j
          exit
        endif
        lw2 = lw1
        cycle
      else
        ! Is it an opening key
        if (line(j:j).eq.'"') then
          l1 = j
          chaine = '"'
          lw2 = lw1
          cycle
        else if (line(j:j).eq."'") then
          l1 = j
          chaine = "'"
          lw2 = lw1
          cycle
        endif
      endif
      !
      ! Termination delimiter
      if (line(j:j).eq.csepar) then
        l2 = j-1
        exit
      endif
      !
      ! Usual delimiters
      lw1 = line(j:j).eq.lsepar
      if (.not.lw1.and.lw2) then
        l1 = j
      elseif (lw1.and..not.lw2) then
        l2 = j-1
        exit
      endif
      lw2 = lw1
    enddo
    !
    if (l2.eq.-1) l2 = lj
    !
    if (l1.gt.0) then
      if (chaine.eq.' ') then
        lpar = l2 - l1 + 1
        par = line(l1:l2)
      else
        lpar = l2 - l1 - 1
        par = line(l1+1:l2-1)
      endif
      !
      ! Skip things until next non-delimiter
      do j=l2+1,lj
        !!Print *,l2,j,line(1:j)//'!'
        if (line(j:j).eq.csepar) then
          npar = npar+j
          exit
        else if (line(j:j).ne." ") then
          npar = npar+j-1
          exit
        endif
      enddo
      !!Print *,'NPAR final ',npar
   else
      lpar = 0
    endif
    !
  else
    !
    do j = 1,lj
      !
      ! Usual simple delimiters, no strings...
      lw1 = line(j:j).eq.lsepar
      if (.not.lw1.and.lw2) then
        l1 = j
      elseif (lw1.and..not.lw2) then
        l2 = j-1
        exit
      endif
      lw2 = lw1
    enddo
    if (l2.eq.-1) l2 = lj
    !
    if (l1.gt.0) then
      lpar = l2 - l1 + 1
      npar = npar + lpar + 1
      par = line(l1:l2)
    else
      lpar = 0
    endif
  endif
end subroutine sic_separ

!    
!> Tools that should be in SIC  
subroutine no_logstack
  !* 
  ! IMAGER -- Ensure that previous command is not written in the 
  !  Stack or LogFile.
  !  Some otherwise "normal" commands require this after some
  !  interactive use
  !!
  character(len=12) :: comm, argum
  logical :: error
  integer :: nc
  !
  !! The trick is to parse a command with a '*NAME' definition
  !! so that SIC\ considers nothing should be done.
  error = .false.
  argum = 'LOG' ! 'MASK' or any command with a '*COMM' definition
  nc = len_trim(argum)
  comm = ' '
  call sic_analyse(comm,argum,nc,error)
end subroutine no_logstack
!
subroutine log_stack_comm(line,error)
  use gkernel_interfaces, only : sic_ch, sic_insert, sic_log
  use imager_interfaces, only : map_message
  use gbl_message
  !----------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- Support routine for command  
  !    [CLEAN\]LOG "Command Argums... /Option..." B|F|S
  !
  ! Insert a command line in Stack and/or Log file
  !!
  !----------------------------------------------------------------------
  character(len=*), intent(in) :: line  !! Command line 
  logical, intent(inout) :: error       !! Logical Error Flag
  !
  character(len=1024) :: string
  character(len=1) :: code
  integer :: ns, nc
  !
  if (error) return ! In case called from a code with initial error
  call sic_ch(line,0,1,string,ns,.true.,error)
  if (error) return
  !
  code = 'B'
  call sic_ke(line,0,2,code,nc,.false.,error)
  select case (code)
  case ('B')
    call sic_insert(string(1:ns))
    call sic_log(string,ns,0)
  case ('S')
    call sic_insert(string(1:ns))
  case ('L')
    call sic_log(string,ns,0)
  case default
    call map_message(seve%e,'LOG','Invalid mode, should be B[oth] S[tack] or L[og]')
    error = .true.
  end select
end subroutine log_stack_comm
!
subroutine sic_insert_log(line)
  use gkernel_interfaces, only : sic_insert, sic_log
  !----------------------------------------------------------------------
  ! @ private
  !*
  !   IMAGER -- Utility routine for command LOG  
  !   Insert command line in Stack and Log file
  !!
  !----------------------------------------------------------------------
  character(len=*), intent(in) :: line  !! Line to be inserted.
  !
  integer :: nl
  !
  nl = len_trim(line)
  call sic_insert(line(1:nl))
  call sic_log(line,nl,0)
end subroutine sic_insert_log

program primes
  use gkernel_interfaces
  !---------------------------------------------------------------------
  !  Compute the primes numbers from 1 to p (defined below). This
  ! program is easily (auto)parallelizable. This is its only purpose.
  !---------------------------------------------------------------------
  integer(kind=4) :: status
  integer(kind=8) :: m,i,j,up
  integer(kind=8), allocatable :: list(:)
  logical :: p
  !
  p = .false.
  m = 2000000  ! Use explicit, non-customizable value. If 'm' not known
               ! at compilation time, ifort won't auto-parallelize the
               ! loops, assuming there are chances that the cost is too
               ! high (because of the -par-threshold100 conservative
               ! option)
  !
  allocate(list(m),stat=status)
  if (status.ne.0) then
    call gagout('Failed to allocate the list array')
    stop
  endif
  !
  list(1) = 0
  do i=2,m  ! Safe for auto-parallelization
    list(i) = i
  enddo
  !
  do i=2,m  ! Safe for auto-parallelization
    up = int(sqrt(real(i,kind=8)),kind=8)
    do j=2,up  ! Not safe for auto-parallelization
      if (list(i).ne.j .and. mod(list(i),j).eq.0) then
        list(i) = 0
      endif
    enddo
  enddo
  !
  if (p) then
    do i=1,m
      if (list(i).ne.0) then
        write(*,*) list(i)
      endif
    enddo
  endif
  !
  deallocate(list)
  !
end program primes

subroutine sic_math_logi (chain,nch,logi,error)
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_math_logi
  use gildas_def
  use sic_expressions
  use sic_types
  use gbl_format
  use gbl_message
  !---------------------------------------------------------------------
  ! @ public
  ! Decode a string as a logical argument :
  !  Attempt to read it
  !  Find if it is a variable
  !  Compute logical expressions.
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: chain  !
  integer(kind=4),  intent(in)    :: nch    !
  logical,          intent(out)   :: logi   !
  logical,          intent(inout) :: error  !
  ! Local
  character(len=*), parameter :: rname='LOGICAL'
  logical, save :: value  ! Subject to a locwrd()
  integer :: max_level,last_node,type,min_level,tree(formula_length*2)
  type(sic_descriptor_t) :: operand(0:maxoper),result
  character(len=256) :: expres
  integer :: nex, ia, ib, ic
  ! Data
  ! data result/9*0/
!!  Print *,'SIC_MATH_LOGI '//trim(chain)
  !
  if (nch.le.0) then
    call sic_message(seve%e,rname,'String is empty')
    error = .true.
    return
  endif
  !
  call sic_add_expr(chain,nch,expres,nex,error)
  if (error) return
  !
  call sic_get_logi (expres(1:nex),value,error)
  if (.not.error) then
    logi = value
    return
  endif
  !
  ! This works for Logical Expressions, but this code is used in
  !   LET LOGI FILE(SomeThing) 
  !   SAY FILE(SomeThing) /FORMAT L
  ! but not in the implicit formatting like
  !   SAY 'FILE(SomeThing)'
  ! which goes through a different parsing code
  ia = index(expres,'FILE(') 
  if (ia.ne.0) then
    ! We have a FILE function, convert back to initial case
    ib = ia+5
    ic = index(expres(ib:),')')
    if (ic.gt.0) expres(ib:ib+ic) = chain(ib:ib+ic)
  endif
  !
  ! Analyse logical expression
  error = .false.
  call build_tree(expres,nex,operand,tree,last_node,max_level,min_level,error)
  if (error) then
    call sic_message(seve%e,rname,'Invalid logical expression '//expres(1:nex))
    return
  endif
  !
  result%type = fmt_l
  result%readonly = .false.
  result%addr = locwrd (value)
  result%ndim = 0
  result%size = 1
  call evaluate_tree(operand,tree,last_node,max_level,min_level,result,type,  &
    error)
  if (error) then
    logi = .false.
    call sic_message(seve%e,rname,'Error evaluating '//expres(1:nex))
  else
    logi = value
  endif
end subroutine sic_math_logi
!
subroutine sic_math_long (chain,nch,argum,error)
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_math_long
  use gildas_def
  use sic_expressions
  use sic_types
  use gbl_format
  use gbl_message
  !---------------------------------------------------------------------
  ! @ public
  ! Decode a string as a long integer :
  !  Attempt to read it
  !  Find if it is a variable
  !  Compute arithmetic expressions.
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: chain  !
  integer(kind=4),  intent(in)    :: nch    !
  integer(kind=8),  intent(out)   :: argum  !
  logical,          intent(inout) :: error  !
  ! Local
  character(len=*), parameter :: rname='DECODE'
  integer :: max_level,last_node,type,ifirst,min_level,i
  type(sic_descriptor_t) :: operand(0:maxoper),result
  integer :: tree(formula_length*2)
  integer(kind=8) :: value
  character(len=256) :: expres
  integer :: nex, ier
  ! Data
  save value                   ! Subject to a LOCWRD
  save result,operand,last_node,tree
  ! data result/9*0/
  !
  if (nch.le.0) then
    call sic_message(seve%e,rname,'String is empty')
    error = .true.
    return
  endif
  !
  call sic_add_expr(chain,nch,expres,nex,error)
  if (error) return
  !
  ! Protect against -D01 being interpreted as -0.000D+01
  if (expres(1:1).eq.'+' .or. expres(1:1).eq.'-') then
    ifirst = 2
  else
    ifirst = 1
  endif
  !
  ! This test is a protection against the stupid FORTRAN convention of 1+1=1E+1
  do i = ifirst,nex
    if ( (expres(i:i).lt.'0').or.(expres(i:i).gt.'9') ) goto 10
  enddo
  ! Ask the Fortran runtime to read a literal value. Do not use format '*'
  ! because the Intel Fortran Compiler reads the value '1.9' with no error,
  ! and as integer value '1' (and not '2')
  read (expres(1:nex),'(I20)',iostat=ier) value
  if (ier.ne.0) goto 10
  argum = value
  return
  !
  ! Try a variable
10 call sic_get_long (expres(1:nex),argum,error)
  if (.not.error) return
  !
  ! Analyse arithmetic expression
  ! print *,'Calling BUILD TREE'
  call build_tree(expres,nex,operand,tree,last_node,max_level,min_level,error)
  if (error) then
    call sic_message(seve%e,rname,'Invalid arithmetic expression '//  &
    expres(1:nex))
    return
  endif
  !
  result%type = fmt_i8
  result%readonly = .false.
  result%addr = locwrd (value)
  result%ndim = 0
  result%size = 2
  call evaluate_tree(operand,tree,last_node,max_level,min_level,result,type,  &
    error)
  if (error) then
    call sic_message(seve%e,rname,'Error computing '//expres(1:nex))
  else
    argum = value
  endif
end subroutine sic_math_long
!
subroutine sic_math_inte (chain,nch,argum,error)
  use gbl_message
  use sic_interfaces, except_this=>sic_math_inte
  !---------------------------------------------------------------------
  ! @ public
  ! Decode a string as a normal integer :
  !  Attempt to read it
  !  Find if it is a variable
  !  Compute arithmetic expressions.
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: chain  !
  integer(kind=4),  intent(in)    :: nch    !
  integer(kind=4),  intent(out)   :: argum  !
  logical,          intent(inout) :: error  !
  ! Local
  integer(kind=8), parameter :: mini4=-2147483648_8  ! -2**31
  integer(kind=8), parameter :: maxi4=2147483647_8  ! 2**31-1
  integer(kind=8) :: i8
  character(len=message_length) :: mess
  !
  call sic_math_long(chain,nch,i8,error)
  if (error)  return
  !
  if (i8.lt.mini4 .or. i8.gt.maxi4) then
    write(mess,'(A,I0,A)')  &
      'Value ',i8,' is too large to accomodate in an INTEGER*4'
    call sic_message(seve%e,'MATH',mess)
    error = .true.
    return
  endif
  argum = int(i8,kind=4)
  !
end subroutine sic_math_inte
!
subroutine sic_math_dble (chain,nch,argum,error)
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_math_dble
  use gildas_def
  use sic_expressions
  use sic_types
  use gbl_format
  use gbl_message
  !---------------------------------------------------------------------
  ! @ public
  ! Decode a string as a double precision float :
  !  Attempt to read it
  !  Find if it is a variable
  ! Compute arithmetic expressions.
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: chain  !
  integer(kind=4),  intent(in)    :: nch    !
  real(kind=8),     intent(out)   :: argum  !
  logical,          intent(inout) :: error  !
  ! Local
  character(len=*), parameter :: rname='DECODE'
  integer :: max_level,last_node,type,ifirst,min_level,i
  type(sic_descriptor_t) :: operand(0:maxoper),result
  integer :: tree(formula_length*2)
  real(8) :: value
  character(len=256) :: expres
  integer :: nex, ier
  ! Data
  save value                   ! Subject to a LOCWRD
  save result,operand,last_node,tree
  ! data result/9*0/
  !
  if (nch.le.0) then
    call sic_message(seve%e,rname,'String is empty')
    error = .true.
    return
  endif
  !
  call sic_add_expr(chain,nch,expres,nex,error)
  if (error) return
  !
  ! Protect against -D01 being interpreted as -0.000D+01
  if (expres(1:1).eq.'+' .or. expres(1:1).eq.'-') then
    ifirst = 2
  else
    ifirst = 1
  endif
  !
  ! This test is a protection against the stupid FORTRAN convention of 1+1=1E+1
  do i = ifirst,nex
    if ( (expres(i:i).lt.'0').or.(expres(i:i).gt.'9') ) goto 10
  enddo
  !
  ! The Iostat code encompasses the EOF case
  ! The end=10 is to prevent against the string being "-" or "+"
  ! otherwise, the program crashes by "End of file" in these cases.
  read (expres(1:nex),*,iostat=ier) value
  if (ier.ne.0) goto 10
  argum = value
  return
  !
  ! Try a variable
10 call sic_get_dble (expres(1:nex),argum,error)
  if (.not.error) return
  !
  ! Analyse arithmetic expression
  ! print *,'Calling BUILD TREE'
  call build_tree(expres,nex,operand,tree,last_node,max_level,min_level,error)
  if (error) then
    call sic_message(seve%e,rname,'Invalid arithmetic expression '//  &
    expres(1:nex))
    return
  endif
  !
  result%type = fmt_r8
  result%readonly = .false.
  result%addr = locwrd (value)
  result%ndim = 0
  result%size = 2
  call evaluate_tree(operand,tree,last_node,max_level,min_level,result,type,  &
    error)
  if (error) then
    call sic_message(seve%e,rname,'Error computing '//expres(1:nex))
  else
    argum = value
  endif
end subroutine sic_math_dble
!
subroutine sic_math_real (chain,nch,argum,error)
  use sic_interfaces, except_this=>sic_math_real
  !---------------------------------------------------------------------
  ! @ public
  ! Decode a string as a single precision float :
  !  Attempt to read it
  !  Find if it is a variable
  ! Compute arithmetic expressions.
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: chain  !
  integer(kind=4),  intent(in)    :: nch    !
  real(kind=4),     intent(out)   :: argum  !
  logical,          intent(inout) :: error  !
  ! Local
  real(kind=8) :: r8
  !
  call sic_math_dble(chain,nch,r8,error)
  if (error)  return
  !
  argum = real(r8,kind=4)
  !
end subroutine sic_math_real
!
subroutine sic_math (chain,nch,argum,error)
  use sic_interfaces, except_this=>sic_math
  !---------------------------------------------------------------------
  ! @ public obsolete
  !  Use one of the following routines to evaluate a Sic expression
  ! in a variable:
  !   sic_math_logi
  !   sic_math_inte
  !   sic_math_long
  !   sic_math_real
  !   sic_math_dble
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: chain  !
  integer(kind=4),  intent(in)    :: nch    !
  real(kind=8),     intent(out)   :: argum  !
  logical,          intent(inout) :: error  !
  !
  call sic_math_dble(chain,nch,argum,error)
  !
end subroutine sic_math
!
subroutine sic_math_auto (chain,nch,argum,ocode,error)
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_math_auto
  use gildas_def
  use sic_expressions
  use sic_types
  use gbl_format
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !  Decode a string as a double precision OR LOGICAL argument :
  !   Attempt to read it
  !   Find if it is a variable
  !   Compute arithmetic expressions.
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: chain  !
  integer(kind=4),  intent(in)    :: nch    !
  real(kind=8),     intent(out)   :: argum  ! 2 words buffer for output result
  integer(kind=4),  intent(out)   :: ocode  ! Format of output result
  logical,          intent(inout) :: error  !
  ! Local
  character(len=*), parameter :: rname='DECODE'
  integer :: max_level,last_node,type,ifirst,min_level,i
  type(sic_descriptor_t) :: operand(0:maxoper),result
  real(8) :: value
  character(len=message_length) :: cbuf
  character(len=256) :: expres
  integer :: nex,ier,tree(formula_length*2)
  ! Data
  save value                   ! Subject to a LOCWRD
  save result,operand,last_node,tree
  ! data result/9*0/
  !
  ocode = 0
  if (nch.le.0) return
  !
  call sic_add_expr(chain,nch,expres,nex,error)
  if (error) return
  !
  ! Protect against -D01 being interpreted as -0.000D+01
  ifirst = 1
  if (expres(ifirst:ifirst).eq.'+' .or. expres(ifirst:ifirst).eq.'-') then
    ifirst = 2
  else
    ifirst = 1
  endif
  !
  ! This test is a protection against the stupid FORTRAN convention of 1+1=1E+1
  do i = ifirst,nex
    if ( (expres(i:i).lt.'0').or.(expres(i:i).gt.'9') ) goto 10
  enddo
  read (expres(1:nex),*,iostat=ier) value
  if (ier.ne.0) goto 10
  argum = value
  ocode = fmt_r8
  return
  !
  ! Try a variable
10 continue
  call sic_get_auto (expres(1:nex),argum,ocode,error)
  if (.not.error)  return
  !
  ! Analyse arithmetic expression
  error = .false.
  call build_tree(expres,nex,operand,tree,last_node,max_level,min_level,error)
  if (error) then
    ocode = fmt_un
    call sic_message(seve%e,rname,'Invalid arithmetic expression '//  &
    expres(1:nex))
    return
  endif
  !
  ! We set RESULT%type to FMT_UN (Unknown) so that the result
  ! can be REAL*8 OR Logical, to be decided by EVALUATE_TREE
  !
  result%type = fmt_un
  result%readonly = .false.
  result%addr = locwrd (value)
  result%ndim = 0
  result%size = 2
  call evaluate_tree(operand,tree,last_node,max_level,min_level,result,type,  &
    error)
  if (error) then
    ocode = fmt_un
    call sic_message(seve%e,rname,'Error computing '//expres(1:nex))
    return
  endif
  !
  if (result%type.eq.fmt_l) then
    ocode = fmt_l
    call l4tol4(value,argum,2)
  elseif (result%type.eq.fmt_r4) then
    ocode = fmt_r4
    call r4tor4(value,argum,1)
  elseif (result%type.eq.fmt_i4) then
    ocode = fmt_i8
    call i4toi8(value,argum,1)
  elseif (result%type.eq.fmt_r8) then
    ocode = fmt_r8
    argum = value
  elseif (result%type.eq.fmt_i8) then
    ocode = fmt_i8
    call i8toi8(value,argum,1)
  else
    write(cbuf,'(A,I6)') 'Unsupported type ',result%type
    call sic_message(seve%w,rname,cbuf)
    ocode = 1
    argum = value
  endif
  !
end subroutine sic_math_auto
!
subroutine sic_math_desc(chain,nch,ofmt,osize,desc,error)
  use gbl_format
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_math_desc
  use sic_dictionaries
  use sic_expressions
  !---------------------------------------------------------------------
  ! @ private
  !  Evaluate an expression and return the descriptor of the result. The
  ! result can be an array.
  ! The result can be a scratch variable, it is the responsibility of
  ! the caller to free it afterwards.
  ! ---
  !  This subroutine is a factorization of LET /WHERE XXX (parsing of
  ! the 'XXX' vectorized condition). It may need modification to make
  ! it fully generic.
  !---------------------------------------------------------------------
  character(len=*),          intent(in)           :: chain  !
  integer(kind=4),           intent(in)           :: nch    !
  integer(kind=4),           intent(in)           :: ofmt   ! Output result format
  integer(kind=size_length), intent(in), optional :: osize  ! Output size
  type(sic_descriptor_t),    intent(out)          :: desc   !
  logical,                   intent(inout)        :: error  !
  ! Local
  character(len=*), parameter :: rname='SIC'
  integer(kind=4) :: ier,ilen,itype,last_node,max_level,min_level
  integer(kind=4) :: tree(formula_length*2),ioper
  character(len=1024) :: expres
  type(sic_descriptor_t) :: operand(0:maxoper)
  integer(kind=size_length) :: esize
  character(len=message_length) :: mess
  !
  ! Analyze the expression
  call sic_add_expr(chain,nch,expres,ilen,error)
  if (error)  return
  call build_tree(expres(1:ilen),ilen,operand,tree,last_node,max_level,  &
    min_level,error)
  if (error)  return  ! Let the caller issue a relevant message
  !
  ! Operands are now parsed. Need to prepare the descriptor for the result.
  ! What is the size of the expression? Assume it has the largest size of all
  ! involved operands... Is this correct? Note that this is basically
  ! pre-guessing what size evaluate_tree needs... Could this be automatic?
  ! Assume there is only one node in the expression:
  esize = 1
  do ioper=1,tree(5)  ! tree(5) is the number of operands of the first node
                      ! tree(6) is the first operand,
                      ! tree(7) is the second operand, etc
    esize = max( esize, desc_nelem(operand(tree(5+ioper))) )
  enddo
  if (present(osize)) then
    if (esize.eq.osize) then
      ! Input operand has requested size. The resulting descriptor will have
      ! same size as the expression.
      desc%ndim = 1
      desc%dims(:) = esize
    elseif (esize.eq.1 .and. osize.gt.1) then
      ! The expression is scalar but osize is larger. The resulting descriptor
      ! will have size 'osize'. Sic will duplicate the scalar expression evaluation
      ! as many times as needed in the result.
      desc%ndim = 1
      desc%dims(1) = osize
    else
      write(mess,'(A,2(1X,I0))')  &
        'Mathematics on arrays of inconsistent dimensions',osize,esize
      call sic_message(seve%e,rname,mess)
      error = .true.
      return
    endif
  else
    ! Output size not constrained, the resulting descriptor will have same
    ! size as the expression
    desc%ndim = 1
    desc%dims(:) = esize
  endif
  !
  desc%type = ofmt
  desc%status = scratch_operand
  desc%readonly = .false.
  desc%size = desc_nelem(desc)
  if (desc%type.eq.fmt_r8 .or. desc%type.eq.fmt_i8 .or. desc%type.eq.fmt_c4) then
    desc%size = 2*desc%size
  endif
  ier = sic_getvm(desc%size,desc%addr)
  if (ier.ne.1) then
    call sic_message(seve%e,rname,'Memory allocation failure')
    error = .true.
    return
  endif
  !
  ! Then compute it...
  call evaluate_tree(operand,tree,last_node,max_level,min_level,  &
     desc,itype,error)
  if (error) then
    call sic_volatile(desc)
    return
  endif
  !
  ! If an error is returned, the caller has nothing to free.
  !
end subroutine sic_math_desc
!
subroutine sic_sexa(line,nline,value,error)
  use sic_interfaces, except_this=>sic_sexa
  use gbl_message
  !---------------------------------------------------------------------
  ! @ public
  !  Decode a generalized sexagesimal notation
  !  Expression_1[:Expression_2[:Expression_3]]
  !  The unit of Expression_1 (Degrees or hours) is used for the result.
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line   !
  integer(kind=4),  intent(in)    :: nline  !
  real(kind=8),     intent(out)   :: value  !
  logical,          intent(inout) :: error  !
  ! Local
  character(len=*), parameter :: rname='SEXA'
  real(8) :: value1,sign
  integer :: nf,nl,nc,ic
  character(len=64) :: chain
  !
  ! First, get the real string to be decoded:
  nl = index(line(1:nline),':')
  if (nl.eq.0) then
    ! No column, try a character variable
    call sic_get_char(line(1:nline),chain,nc,error)
    if (error) then
      ! Not a character variable
      error = .false.
      chain = line(1:nline)
      nc = nline
    else
      ! A character variable as been read
      nl = index(chain(1:nc),':')
    endif
    if (nl.eq.0) then
      ! No column, just try a numeric variable, a plain numeric value, a formulae...
      call sic_math_dble(chain,nc,value,error)
      return
    endif
  else
    chain = line(1:nline)
    nc = nline
  endif
  !
  ! Then, start decoding
  if (nl.eq.1 .or. nl.eq.nc) then
    call sic_message(seve%e,rname,'Syntax error')
    error = .true.
    return
  endif
  !
  ! Decode HOURS/DEGREES
  call sic_math_dble(chain,nl-1,value,error)
  if (error) return
  if (value.gt.0d0) then
    sign = 1.0d0
  elseif (value.lt.0d0) then
    sign = -1.0d0
    value = -value
  else
    ! Value is 0. Need to keep track of sign, if any.
    ! Ignore leading blank:
    ic = 1
    do while (chain(ic:ic).eq.' ')
      ic = ic+1
    enddo
    if (chain(ic:ic).eq.'-') then
      sign = -1.0d0
    else
      sign = 1.0d0
    endif
  endif
  !
  ! Decode MINUTES
  nf = nl+1
  nl = index(chain(nf:nc),':')
  if (nl.eq.1 .or. nl+nf-1.eq.nc) then
    call sic_message(seve%e,rname,'Syntax error')
    error = .true.
  endif
  if (nl.eq.0) then
    call sic_math_dble(chain(nf:),nc-nf+1,value1,error)
  else
    call sic_math_dble(chain(nf:),nl-1,value1,error)
  endif
  if (error) return
  if (value1.lt.0.d0 .or. value1.ge.60.d0) then
    call sic_message(seve%e,rname,'Invalid minute field in '//chain)
    error = .true.
    return
  endif
  value = value + value1/60.d0
  if (nl.eq.0) then
    ! No SECONDS field: return now
    value = sign * value
    return
  endif
  !
  ! Decode SECONDS
  nf = nf+nl
  call sic_math_dble(chain(nf:),nc-nf+1,value1,error)
  if (error) return
  if (value1.lt.0.d0 .or. value1.ge.60.d0) then
    call sic_message(seve%e,rname,'Invalid second field in '//chain)
    error = .true.
    return
  endif
  value = sign * (value + value1/3600.d0)
  !
end subroutine sic_sexa
!
subroutine sic_vtype(namein,vtype,reado,error)
  use sic_interfaces, except_this=>sic_vtype
  use gildas_def
  use sic_structures
  use sic_dictionaries
  use sic_interactions
  use sic_types
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  character(len=*) :: namein        !
  integer :: vtype                  !
  logical :: reado                  !
  logical :: error                  !
  ! Global
  include 'gbl_memory.inc'
  ! Local
  type(sic_identifier_t) :: var
  integer(kind=4) :: i,ier,in
  type(sic_dimensions_t) :: spec
  integer(kind=4) :: impvars(sic_maxdims)
  !
  ! Parse dimensions
  error = .false.
  spec%do%strict   = .true.   ! Can not be an expression like A[1].eq.B[1]
  spec%do%range    = .true.
  spec%do%subset   = .true.   ! A[2,] allowed, like in LET i[,1] 1 2 /PROMPT "Text"
  spec%do%implicit = .true.
  spec%do%twospec  = .false.  ! e.g. A[i][j:k] forbidden
  call sic_parse_var(namein,var,spec,impvars,error)
  if (error) return
  !
  ! Search first in local table
  var%level = var_level
  ier = sic_hasfin(maxvar,pfvar,pnvar,dicvar,var,in)
  if (ier.ne.1 .and. var_level.ne.0) then
    var%level = 0
    ier = sic_hasfin(maxvar,pfvar,pnvar,dicvar,var,in)
  endif
  if (ier.ne.1) then
    ! CALL GAGOUT('E-LET,  No such variable '//NAMEIN)
    error =.true.
    return
  endif
  !
  ! Check number of dimensions
  if (spec%done(1)%ndim.gt.dicvar(in)%desc%ndim) then
    ! This test is not correct for substring specification. Should use
    ! extract_descr (via sic_descriptor?) which does the correct tests, and
    ! get rid of the sic_vtype subroutine.
    call sic_message(seve%e,'LET','Too many dimensions for variable '//  &
    namein)
    error = .true.
    return
  endif
  !
  ! Check whether it is readonly
  vtype = dicvar(in)%desc%type
  reado = dicvar(in)%desc%readonly
  !
  if (spec%done(1)%implicit) then
    ! Clean implicit variables from dictionary
    do i=1,spec%done(1)%ndim
      if (impvars(i).eq.0)  cycle  ! No variable defined (unnamed dimension)
      in = impvars(i)
      call sic_zapvariable(in,.true.,.true.,error)
    enddo
  endif
end subroutine sic_vtype

subroutine gdf_gauss2d_convolution(h,a2,b2,t2,error)
  use image_def
  use phys_const
  use gio_dependencies_interfaces
  !---------------------------------------------------------------------
  ! @ public
  !   Convolve the resolution section of the input header by a 2D
  ! gaussian. Results are saved in the header itself.
  !   All input and output angles use GDF convention i.e. from North to
  ! East. The convolution position angle should be defined in the same
  ! frame as the input header is defined.
  !---------------------------------------------------------------------
  type(gildaS), intent(inout) :: h      !
  real(kind=4), intent(in)    :: a2     ! [same as h%gil%major] Convolution major axis
  real(kind=4), intent(in)    :: b2     ! [same as h%gil%major] Convolution minor axis
  real(kind=4), intent(in)    :: t2     ! [rad]                 Convolution position angle
  logical,      intent(inout) :: error  ! Logical error flag
  ! Local
  real(kind=4) :: a3,b3,u1,u2,u3,shift,sig
  !
  ! If no resolution section, nothing to be done
  if (h%gil%reso_words.le.0)  return
  !
  ! Need to convert GDF angles to Fortran/math convention
  if (h%gil%inc(h%gil%yaxi).gt.0.d0) then
    shift = +pi/2.
  else
    shift = -pi/2.
  endif
  if (h%gil%inc(h%gil%xaxi)*h%gil%inc(h%gil%yaxi).lt.0.d0) then
    sig = +1.
  else
    sig = -1.
  endif
  !
  u1 = sig*h%gil%posa + shift
  u2 = sig*t2 + shift
  !
  call gauss2d_convolution(h%gil%majo,h%gil%mino,u1,  &
                           a2,b2,u2,  &
                           a3,b3,u3,error)
  if (error)  return
  !
  h%gil%majo = a3
  h%gil%mino = b3
  h%gil%posa = sig*(u3 - shift)  ! Back to GDF convention
  !
  ! Angle modulated in [-pi/2,pi/2], because the gaussian is kept identical
  ! with a pi rotation
  h%gil%posa = modulo(h%gil%posa+pi/2.,pi)-pi/2.
  !
end subroutine gdf_gauss2d_convolution
!
subroutine gdf_gauss2d_deconvolution(h,a3,b3,t3,a2,b2,t2,error)
  use image_def
  use phys_const
  use gbl_message
  use gio_dependencies_interfaces
  use gio_interfaces, except_this=>gdf_gauss2d_deconvolution
  !---------------------------------------------------------------------
  ! @ public
  !   Compute the convolution kernel needed to reach the desired
  ! resolution starting from the input header resolution section.
  !   All input and output angles use GDF convention i.e. from North to
  ! East. The goal position angle should be defined in the same
  ! frame as the input header is defined.
  !---------------------------------------------------------------------
  type(gildaS), intent(in)    :: h      !
  real(kind=4), intent(in)    :: a3     ! [same as h%gil%major] Goal major axis
  real(kind=4), intent(in)    :: b3     ! [same as h%gil%major] Goal minor axis
  real(kind=4), intent(in)    :: t3     ! [rad]                 Goal position angle
  real(kind=4), intent(out)   :: a2     ! [same as h%gil%major] Convolution major axis
  real(kind=4), intent(out)   :: b2     ! [same as h%gil%major] Convolution minor axis
  real(kind=4), intent(out)   :: t2     ! [rad]                 Convolution position angle
  logical,      intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='GAUSS2D'
  real(kind=4) :: u1,u2,u3,shift,sig
  !
  if (h%gil%reso_words.le.0) then
    call gio_message(seve%e,rname,'No resolution section')
    error = .true.
    return
  endif
  !
  ! Need to convert GDF angles to Fortran/math convention
  if (h%gil%inc(h%gil%yaxi).gt.0.d0) then
    shift = +pi/2.
  else
    shift = -pi/2.
  endif
  if (h%gil%inc(h%gil%xaxi)*h%gil%inc(h%gil%yaxi).lt.0.d0) then
    sig = +1.
  else
    sig = -1.
  endif
  !
  u1 = sig*h%gil%posa + shift
  u3 = sig*t3 + shift
  !
  call gauss2d_deconvolution(h%gil%majo,h%gil%mino,u1,  &
                             a3,b3,u3,  &
                             a2,b2,u2,error)
  if (error)  return
  !
  ! Back to GDF convention
  t2 = sig*(u2-shift)
  !
  ! Angle modulated in [-pi,pi]
  t2 = modulo(t2+pi,twopi)-pi
  !
end subroutine gdf_gauss2d_deconvolution

subroutine setdas(n)
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>setdas
  use greg_pen
  use greg_kernel
  use greg_wcs
  !---------------------------------------------------------------------
  ! @ private
  ! GREG	Internal routines
  !	This is a set of routines and entry points used to communicate
  !	with GREG internal commons without addressing the common
  !	themselves.
  !
  !	SETDAS	Calls GTEDIT with the dashed pattern N and other pen
  !		attributes of the current PENCIL. The modification is
  !		only valid until the next call to SETPEN. Sets PENUPD.
  !		HINT! SETDAS is inactive if the dashed pattern N has
  !		already been selected by a previous call to SETPEN or
  !		SETDAS.
  !	SETWEI	Idem for the weight attribute
  !	SETCOL	Idem for the colour attribute
  !
  !	INQDAS	Returns the current dashed pattern in use
  !		(Current pen, possibly altered by SETDAS)
  !	INQWEI	Idem for the weight attribute
  !	INQCOL	Idem for the colour attribute
  !
  !	SETPEN	Calls GTEDIT with the attributes of the current PENCIL.
  !		Resets any alterations by SETDAS, SETWEI, SETCOL.
  !		Resets the PENUPD flag which is set by PENCIL and by
  !		calls to SETDAS, SETWEI, SETCOL and SETPHYSICAL.
  !		To open a new segment with pen N :
  !			CALL GTSEGM('INQUIRE',ERROR)
  !			CALL SETPEN (N)
  !		To open a new segment with the current pen IPEN :
  !			CALL GTSEGM('INQUIRE',ERROR)
  !			IF (PENUPD) CALL SETPEN (IPEN)
  !---------------------------------------------------------------------
  integer :: n                      !
  ! Local
  integer :: ioldpt
  real*4 :: arg, arg2, sizex, sizey, oldwei, newwei, curwei
  real*8 :: darg1, darg2
  integer :: ns,is
  real :: size
  logical :: error
  !
  ! Dashed pattern
  ioldpt = cdashe
  cdashe = max(mindashed,min(n,maxdashed))
  if (cdashe.ne.ioldpt) then
    penupd = .true.
    goto 1000
  endif
  return
  !
entry inqdas(n)
  n = cdashe
  return
  !
entry setwei(newwei)  ! Thickening factor
  ! Beware: NEWWEI and CWEIGH must be the actual line width (cm),
  ! not the Greg weight number
  oldwei = cweigh
  cweigh = newwei
  if (cweigh.ne.oldwei) then
    penupd = .true.
    goto 1000
  endif
  return
  !
entry inqwei(curwei)
  curwei = cweigh
  return
  !
  ! Colour
entry setcol(n)
  ! Beware: N and CCOLOU must be GTV internal id for the
  ! color, not the Greg color number
  ioldpt = ccolou
  ccolou = n
  if (ccolou.ne.ioldpt) then
    penupd = .true.
    goto 1000
  endif
  return
  !
entry inqcol(n)
  n = ccolou
  return
  !
  ! Set Pencil
entry setpen(n)
  cpen = n
  cdashe = ldashe(cpen)
  cweigh = lweigh(cpen)
  ccolou = lcolou(cpen)
  penupd = .false.
1000 call gtedit(cdashe,cweigh,ccolou,0,.true.)
  return
  !
  ! Segment depth
entry setdepth(n)
  ! Note: no global for current depth: specific call to gtedit
  call gtedit(cdashe,cweigh,ccolou,n,.true.)
  return
  !
entry inqpen(n)
  n = cpen
  return
  !
  ! Angle
entry setang(arg,arg2)
  tangle = arg
  sangle = arg2
  return
entry inqang(arg,arg2)
  arg = tangle
  arg2= sangle
  return
  !
  ! Expand
entry setexp(arg)
  expand = arg
  return
entry inqexp(arg)
  arg = expand
  return
  !
  ! Symbol Size
entry setsym(arg)
  csymb = arg
  return
entry inqsym(arg)
  arg = csymb
  return
  !
  ! Symbol style
entry setsty(n)
  istyle = max(0,min(n,4))
  return
entry inqsty(n)
  n = istyle
  return
  !
  ! Symbol type
entry setnsides(n)
  nsides = min(max(0,n),10000)
  return
entry inqnsides(n)
  n = nsides
  return
  !
  ! Physical limits
entry setphysical(sizex,sizey)
  lx1 = 0.0
  ly1 = 0.0
  lx2 = min(sizex,160.)
  ly2 = min(sizey,160.)
  error = .false.
  call gt_setphysical(lx2,ly2,error)
  if (error)  continue
  gxp = -1e10                  ! Reset pen position to
  gyp = -1e10                  ! undefined...
  penupd = .true.              ! As GTINIT resets the virtual pen
  xcurse = lx2*0.5
  ycurse = ly2*0.5
  return
  !
  ! Blanking
entry setbla(darg1,darg2)
  cblank = darg1
  eblank = darg2
  return
  !
  ! Public entry points
entry gr_get_physical(sizex,sizey)
  !---------------------------------------------------------------------
  ! @ public
  !---------------------------------------------------------------------
  sizex = lx2
  sizey = ly2
  return
  !
entry gr_set_marker(ns,is,size)
  !---------------------------------------------------------------------
  ! @ public
  !---------------------------------------------------------------------
  nsides = min(max(0,ns),10000)
  istyle = max(0,min(is,3))
  csymb = size
  return
  !
entry gr_get_marker(ns,is,size)
  !---------------------------------------------------------------------
  ! @ public
  !---------------------------------------------------------------------
  ns = nsides
  is = istyle
  size = csymb
end subroutine setdas
!
subroutine setsys(system,equinox)
  use gbl_constant
  use greg_wcs
  !---------------------------------------------------------------------
  ! @ private
  !  Set the internal coordinate system (and equinox if relevant)
  !  Do not use out of Greg. Use gr8_system instead.
  !---------------------------------------------------------------------
  integer(kind=4), intent(in)           :: system
  real(kind=4),    intent(in), optional :: equinox
  !
  select case (system)
  case (type_eq,type_ga,type_ic)
    i_system = system
  case default
    i_system = type_un
  end select
  !
  if (i_system.eq.type_eq) then
    if (present(equinox)) then
      i_equinox = equinox
    else
      i_equinox = i_equinox_def
    endif
  endif
  !
end subroutine setsys

subroutine astro_observatory_command(line,error)
  use gbl_message
  use gkernel_interfaces
  use imager_interfaces, except_this=>astro_observatory_command
  use ast_params
  use ast_astro
  use ast_telescope
  !---------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER: Support routine for command  
  ! 
  ! ARRAY name [subname size] | Long Lat Altitude [Sun-Avoidance]
  ! 
  ! Derived from ASTRO code, but with a reduced list of Observatories,
  ! restricted to Interferometers.
  !!
  !---------------------------------------------------------------------
  character(len=*), intent(in)  :: line   !
  !! Command line
  logical,          intent(out) :: error  
  !! Logical error flag
  !
  ! Constants
  character(len=*), parameter :: rname='ARRAY' 
  integer(kind=4), parameter :: mobs=11   ! 38
  character(len=12) :: knownobs(mobs)
!  data knownobs /  &
!    'BURE','PDBI','NOEMA','PICOVELETA','VELETA','30M',  &  ! IRAM ones first
!    'ACA','ALMA','APEX','ATF','CARMA','CSO','EFFELSBERG','FAST','FCRAO','GBT',  &
!    'GI2T','HAYSTACK','HHT','IOTA','JCMT','KITTPEAK','KOSMA','LASILLA',         &
!    'MAUNAKEA','MEDICINA','NRO','NOBEYAMA','PARANAL','PTI','SEST','SMA','SMT',  &
!    'TRAO','VLA','VLT','WESTFORD','YEBES' /
  !
  ! USER must be first to allow a User defined array
  data knownobs /'USER','ACA','ALMA','NOEMA','PARANAL','VLT','VLTI','IOTA','PTI','VLA','SMA'/ 
  !
  ! Local ---
  character(len=12) :: argum, previous
  integer(kind=4) :: nc,ier,nk
  character(len=24) :: clon,clat,fich,more
  real(kind=8) :: alti,slim
  integer(kind=4) :: date(7)
  !
  ! Code ----
  previous=obsname
  error = .false.
  if (sic_narg(0).eq.0) then
    !
    ! No argument == decode GAG_ASTRO_OBS
    !
    ier = sic_getlog('GAG_ASTRO_OBS',argum)
    if (ier.ne.0) then
      call astro_message(seve%e,rname,  &
        'Failure in translation of GAG_ASTRO_OBS logical')
      error = .true.
      return
    endif
  endif
  call sic_ke (line,0,1,argum,nc,.false.,error)
  if (error) return
  if (argum.eq.'?') then
    ! sic_ambigs_list required to keep "observatory ?" working with the use of sic_ambigs_sub
    call sic_ambigs_list(rname,seve%i,'Choices are:',knownobs)
    return
  endif
  call sic_ambigs_sub(rname,argum,obsname,nk,knownobs,mobs,error)
  if (error) return
  if (nk.eq.1) then
    fich = 'user'
    if (sic_present(0,2)) then
      call sic_ch(line,0,2,more,nc,.false.,error)
      fich = 'user-'//more(1:nc)
    endif
    call astro_observatory_user(trim(fich),diam,error)
    if (error) return
    config_prefix = trim(fich)//'-'
    ier = sic_setlog('astro_stations',config_prefix)
    call astro_message(seve%i,rname,'Selected '//trim(obsname)//' observatory')
  else if (nk.gt.1) then
    !name of the observatory is recognized
    call astro_observatory_byname (obsname,error)
    if (error)  return
    call astro_message(seve%i,rname,'Selected '//trim(obsname)//' observatory')
  else
    !
    ! Do not recognize the observatory name == decode coordinates
    call sic_ch(line,0,1,clon,nc,.true.,error)
    if (error)  return
    call sic_ch(line,0,2,clat,nc,.true.,error)
    if (error)  return
    call sic_r8(line,0,3,alti,.true.,error)
    if (error) return
    slim = 30.d0
    call sic_r8(line,0,4,slim,.false.,error)
    if (error) return
    call astro_observatory_bychcoords(clon,clat,alti,slim,error)
    if (error)  return
  endif
  ! Make sure the Ephemeris are available
  call astro_init
  !
  call utc (date)            ! read UTC from system clock
  call do_astro_time(jnow_utc,d_ut1,d_tdt,error)
  !
  config_count = 0
end subroutine astro_observatory_command
!
subroutine astro_observatory_byname(arg,error)
  use gbl_message
  use gkernel_interfaces
  use ast_astro
  use ast_telescope
  !---------------------------------------------------------------------
  ! @ private
  !
  !!  Set the Astro observatory given its name
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: arg      !! Telescope name
  logical,          intent(inout) :: error    !! Logical error flag
  !
  ! Local ---
  character(len=*), parameter :: rname='OBSERVATORY'
  real(4) :: beamsize, factor
  integer :: ier
  logical :: sim_exist
  real(8) :: xyz(3)
  character(len=80) :: mess
  !
  ! Code ----
  teles = arg  ! arg can be smaller or larger than 4 characters, truncate here
  freq = 100.d0
  sim_exist = sic_varexist('SIM%FNU')
  if (sim_exist) call sic_get_dble('SIM%FNU',freq,error)
  !
  config_prefix = 'astro_stations'
  call gwcs_observatory(arg,lonlat,altitude,slimit,diam,error)
  factor = 1.155   ! Default beamsize in Lambda/Diam
  select case (teles)
  case ('ALMA')
    config_prefix = 'alma-current-'
    call astro_message(seve%i,rname,'Available configurations 1 to 10')
    factor = 1.13
  case ('ACA')
    config_prefix = 'aca-current-'
    call astro_message(seve%i,rname,'Available configurations I and NS')
    factor = 1.13
  case ('NOEM')
    config_prefix = 'noema-12'
    call astro_message(seve%i,rname,'Available configurations A, B, C, D')
    factor = 1.22
  case ('VLA','JVLA','EVLA') 
    freq = 10.d0
    config_prefix = 'vla-'
    call astro_message(seve%i,rname,'Available configurations A, BnA, B, CnB, C, DnC, D')
  case ('NGVL') 
    freq = 40.d0
    config_prefix = 'ngvla-'
    call astro_message(seve%i,rname,'Available configurations Core, Long, Main, Mid, Sba, Spiral')
  case ('PARA','VLT ','VLTI')
    call astro_message(seve%i,rname,  &
      &  'Frequency set to 299.792458 THz = 1 micron')
    freq = 299792.458d0
  case ('IOTA')
    call astro_message(seve%i,rname,  &
      &  'Frequency set to 187.370286 THz = 1.6 micron')
    freq = 187370.286d0
  case ('PTI ')
    call astro_message(seve%i,rname,'Frequency set to 136.269299 THz = '//  &
       & '2.2 micron')
    freq = 136269.299d0
  case ('GI2T')
    call astro_message(seve%i,rname,'Frequency set to 500 THz = '//  &
       & '0.6 micron')
    freq = 499653.8397d0
  end select
  ier = sic_setlog('astro_stations',config_prefix)
  !
  beamsize = factor*(299792458D0/freq/1d9)/diam*180*3600/acos(-1d0)
  !
  if (sim_exist) then
    call sic_let_dble('SIM%FNU',freq,error)
    call sic_let_real('SIM%PRIMARY',beamsize,error)
  endif
  !
  call gwcs_lonlat2geo(lonlat(1),lonlat(2),altitude,xyz)
  !
  write(mess,'(A,3(1X,F0.8))') 'XYZ',xyz
  call astro_message(seve%i,'OBSERVATORY',mess)
end subroutine astro_observatory_byname
!
subroutine astro_observatory_bychcoords(clon,clat,alt,slim,error)
  use gbl_message
  use gkernel_interfaces
  use imager_interfaces, only : astro_observatory_byr8coords
  !---------------------------------------------------------------------
  ! @ private
  !
  !!  Set Astro observatory given its longitude/latitude (sexagesimal
  !! strings), altitude and avoidance
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: clon     !! Telescope longitude (sexagesimal string)
  character(len=*), intent(in)    :: clat     !! Telescope latitude (sexagesimal string)
  real(kind=8),     intent(in)    :: alt      !! Altitude [km]
  real(kind=8),     intent(in)    :: slim     !! Sun avoidance
  logical,          intent(inout) :: error    !! Logical error flag
  !
  ! Local ---
  integer(kind=4) :: llon,llat
  real(kind=8) :: lon,lat
  !
  ! Code ----
  llon = len_trim(clon)
  call sic_sexa(clon(1:llon),llon,lon,error)
  if (error) return
  !
  llat = len_trim(clat)
  call sic_sexa(clat(1:llat),llat,lat,error)
  if (error) return
  !
  call astro_observatory_byr8coords(lon,lat,alt,slim,error)
  if (error)  return
  !
end subroutine astro_observatory_bychcoords
!
subroutine astro_observatory_byr8coords(lon,lat,alt,slim,error)
  use gbl_message
  use gkernel_interfaces
  use ast_astro
  !---------------------------------------------------------------------
  ! @ private
  !!  Set Astro observatory given its longitude/latitude (float values),
  !! altitude and avoidance
  !---------------------------------------------------------------------
  real(kind=8), intent(in)    :: lon      !! Telescope longitude [deg]
  real(kind=8), intent(in)    :: lat      !! Telescope latitude [deg]
  real(kind=8), intent(in)    :: alt      !! Altitude [km]
  real(kind=8), intent(in)    :: slim     !! Sun avoidance
  logical,      intent(inout) :: error    !! Logical error flag
  !
  ! Local ---
  real(8) :: xyz(3)
  character(len=message_length) :: mess
  !
  ! Code ----
  if (abs(lat).gt.90.d0) then
    call astro_message(seve%e,'OBSERVATORY','Latitude must be < 90 degrees')
    error = .true.
    return
  endif
  !
  lonlat(1) = lon
  lonlat(2) = lat
  altitude = alt
  slimit = slim
  obsname = "USER"
  !
  call gwcs_lonlat2geo(lon,lat,alt,xyz)
  !
  write(mess,'(A,3(1X,F0.8))') 'XYZ',xyz
  call astro_message(seve%i,'OBSERVATORY',mess)
end subroutine astro_observatory_byr8coords
!
subroutine astro_message(seve,comm,mess)
  use imager_interfaces, only : map_message
  !! Remap to MAP_MESSAGE
  integer, intent(in) :: seve
  character(len=*), intent(in) :: comm
  character(len=*), intent(in) :: mess
  !
  call map_message(seve,comm,mess)
end subroutine astro_message
!
subroutine astro_teles(freqs)
  use ast_astro
  use ast_telescope
  use gkernel_interfaces
  !
  real(4), intent(in) :: freqs ! Frequency in GHz
  !
  real(4), parameter  :: pi=acos(-1.D0)
  real(4) :: Ruze=0.8 ! Ruze reduction factor
  real(4) :: surface_rms  ! Surface error
  real(4) :: lambda   ! Wavelength
  real(4) :: beamsize ! Beamsize (FWHM)
  real(4) :: factor   ! Beamsize in Lambda/Diameter
  real(4) :: omega    ! Beam solid angle (radian)
  real(4) :: taper    ! Edge taper (dB)
  real(4) :: aeff     ! Effective area
  real(4) :: loss     ! Surface error loss
  logical :: sim_exist, error
  !
  freq = freqs ! Setup Frequency
  aeff = 0.7   ! Typical value
  lambda = 299792458D0/freq*1D-9
  factor = 1.13d0
  !
  !! Print *,'FREQS ',freqs,' GHZ ; Lambda ',lambda,' m ; Diam ',diam,' m'
  select case (teles)
  case ('NOEM') 
    factor = 1.22
    surface_rms = 35E-6 ! 25 microns
    taper = 15.
  case ('30M')
    surface_rms = 50E-6
    taper = 12.
  case ('ALMA','ACA')
    surface_rms = 20
    taper = 8.
  case ('VLA','JVLA','EVLA') 
    surface_rms = 1E-3 !  1 mm 
    taper = 12.
  case default
    surface_rms = lambda/16.
    taper = 10.
  end select
  factor = 1.02+0.0135*taper             ! Resolution factor from edge taper
  !
  beamsize = factor*lambda/diam          ! In radians
  omega    = pi*beamsize**2/4/log(2.)    ! Omega X Aeff = Lambda^2
  loss = exp(-(4.0d0*pi*Ruze*surface_rms/lambda)**2)
  aeff = loss*lambda**2/omega
  !! Print *,'Surface_rms ',surface_rms,' R ',loss,'Aeff ',aeff,' Diam ',diam
  jypk = 2.*1.38E3/aeff
  !! Print *,'JYPK ',jypk,' Aeff ',aeff,' Beamsize ',beamsize,' " '
  beamsize = beamsize*180*3600/pi        ! In arcseconds
  sim_exist = sic_varexist('SIM%FNU')
  if (sim_exist) then
    error = .false.
    call sic_let_dble('SIM%FNU',freq,error)
    call sic_let_real('SIM%PRIMARY',beamsize,error)
  endif
end subroutine astro_teles
!
subroutine astro_observatory_user(file,diam,error)
  use gbl_message
  use gkernel_interfaces, only : sic_getlun
  use imager_interfaces, only : obs_read_key, astro_observatory_byr8coords
  !---------------------------------------------------------------------
  ! @ private
  !
  !! USER defined Observatory - Search for a "user-"'name'".cfg" file 
  !! with Observatory Coordinates
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: file  !! Array configuration file
  real, intent(inout) :: diam           !! Antenna diameter
  logical, intent(inout) :: error       !! Error flhg
  !
  ! Local --
  character(len=*), parameter :: rname='ARRAY'
  character(len=32) :: chain
  integer :: lun,ier,jer,ic
  logical :: exist
  real(8) :: alt,lon,lat,slim,radius,diameter
  !
  ! Code ---
  inquire(file=file//'.cfg',exist=exist)
  if (.not.exist) then
    call astro_message(seve%e,rname,'No "user.cfg" file')
    error = .true.
    return
  endif
  ier = sic_getlun(lun)
  open(unit=lun,file=file//'.cfg',status='old')
  jer = 0
  ! Skip first line
  read(lun,'(A)') chain
  !
  error = .false.
  ! m
  call obs_read_key(lun,'RADIUS',radius,error)
  call obs_read_key(lun,'ALTITUDE',alt,error)
  ! Longitude & Latitude are in Degrees
  call obs_read_key(lun,'LONGITUDE',lon,error)
  call obs_read_key(lun,'LATITUDE',lat,error)
  call obs_read_key(lun,'DIAMETER',diameter,error)
  !
  close(unit=lun)
  call sic_frelun(lun)
  if (error) then
    call astro_message(seve%e,rname,'Invalid format for "user.cfg" file')
    error = .true.
    return
  endif
  !
  slim = 0.
  alt = alt*1d-3 ! Altitude is read in m, but converted to km
  call astro_observatory_byr8coords(lon,lat,alt,slim,error)
  diam = diameter
end subroutine astro_observatory_user
!
subroutine obs_read_key(lun,key,value,error)
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !! Read value corresponding to KEY in next line of file on LUN
  !---------------------------------------------------------------------
  integer,  intent(in) :: lun             !! Logical unit number
  character(len=*), intent(in) :: key     !! Expected key
  real(kind=8), intent(out) :: value      !! Returned value
  logical, intent(inout) :: error         !! Error flag
  !
  ! Local
  character(len=80) :: chain
  integer :: ic,ier
  !
  if (error) return ! Previous error, skip
  read(lun,'(A)',iostat=ier) chain
  error = .true.
  if (ier.ne.0) return
  !
  ic = index(chain,key) 
  if (ic.eq.3) then
    ic = index(chain,'=') 
    if (ic.ne.0) then
      ic = ic+1
      read(chain(ic:),*,iostat=ier) value
      if (ier.eq.0) error = .false. 
    endif
  endif
  if (error) call astro_message(seve%e,'ARRAY','Invalid format, expected "'//key//' = Value"')
end subroutine obs_read_key

function desc_nelem(desc)
  use gildas_def
  use sic_types
  !---------------------------------------------------------------------
  ! @ public
  ! Return the number of elements from the input descriptor
  !---------------------------------------------------------------------
  integer(kind=size_length) :: desc_nelem
  type(sic_descriptor_t), intent(in) :: desc
  ! Local
  integer(kind=4) :: jdim
  !
  desc_nelem = 1
  do jdim=1,desc%ndim
    desc_nelem = desc_nelem*desc%dims(jdim)
  enddo
  !
end function desc_nelem
!
function desc_nword(desc)
  use gildas_def
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>desc_nword
  use sic_types
  !---------------------------------------------------------------------
  ! @ public
  ! Return the number of 4 bytes words from the input descriptor.
  ! Usually suited for the desc%size value.
  !---------------------------------------------------------------------
  integer(kind=size_length) :: desc_nword
  type(sic_descriptor_t), intent(in) :: desc
  !
  if (desc%type.eq.fmt_i4 .or. desc%type.eq.fmt_r4 .or. desc%type.eq.fmt_l) then
    desc_nword = desc_nelem(desc)
  elseif (desc%type.eq.fmt_i8 .or. desc%type.eq.fmt_r8 .or. desc%type.eq.fmt_c4) then
    desc_nword = 2*desc_nelem(desc)
  elseif (desc%type.eq.fmt_c8) then
    desc_nword = 4*desc_nelem(desc)
  elseif (desc%type.eq.fmt_by) then
    desc_nword = (desc_nelem(desc)+3)/4
  elseif (desc%type.gt.0) then
    desc_nword = (desc_nelem(desc)*desc%type+3)/4
  else
    ! 0 = header (no data), or uncatched cases...
    desc_nword = 0
  endif
  !
end function desc_nword
!
function desc_size(desc)
  use gildas_def
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>desc_size
  use sic_types
  !---------------------------------------------------------------------
  ! @ public
  ! Return the whole data size in bytes
  !---------------------------------------------------------------------
  integer(kind=size_length) :: desc_size
  type(sic_descriptor_t), intent(in) :: desc
  !
  desc_size = desc_nelem(desc) * gag_sizeof(desc%type)
  !
end function desc_size
!
function desc_2gelems(desc)
  use gildas_def
  use sic_interfaces, except_this=>desc_2gelems
  use sic_types
  !---------------------------------------------------------------------
  ! @ private
  ! Return .true. if the data has more than 2 giga-elements
  !---------------------------------------------------------------------
  logical :: desc_2gelems  ! Function value on return
  type(sic_descriptor_t), intent(in) :: desc
  ! Local
  integer(kind=8), parameter :: maxi4=2147483647_8 ! 2**31-1
  !
  desc_2gelems = desc_nelem(desc).gt.maxi4
end function desc_2gelems
!
function desc_2gbytes(desc)
  use gildas_def
  use sic_interfaces, except_this=>desc_2gbytes
  use sic_types
  !---------------------------------------------------------------------
  ! @ private
  ! Return .true. if the data is larger than 2 GB (bytes, not 4-bytes
  ! words)
  !---------------------------------------------------------------------
  logical :: desc_2gbytes  ! Function value on return
  type(sic_descriptor_t), intent(in) :: desc
  ! Local
  integer(kind=8), parameter :: size4max=2147483647  ! 2**31-1
  !
  desc_2gbytes = desc_size(desc).gt.size4max
end function desc_2gbytes
!
subroutine desc_toobig(desc,error)
  use gildas_def
  use gbl_message
  use sic_interfaces, except_this=>desc_toobig
  use sic_types
  !---------------------------------------------------------------------
  ! @ private
  ! Return an error if the image is too large to be opened on the
  ! current system
  !---------------------------------------------------------------------
  type(sic_descriptor_t), intent(in)    :: desc
  logical,                intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='SIC'
  !
#if defined(BITS64)
  ! There maybe limits on the number of elements
  if (desc_2gelems(desc)) then
    if (index_length.eq.8) then
      ! Ok
      continue
    else
      call gio_message(seve%e,rname,  &
      'Images or UV tables of more than 2**31-1 elements not supported')
      error = .true.
      return
    endif
  endif
#else
  if (desc_2gbytes(desc)) then
    ! File is larger than 2 GB. We can think to use the blc and trc,
    ! but there are offsets in bytes which are computed by the
    ! file access layer (even if the underlying operating system is
    ! purely 64 bits) that overflow.
    !
    ! So even having moffs being of kind=size_length set to 64 bits
    ! does not help
    error = .true.
    call gio_message(seve%e,rname,  &
      'Files larger than 2 GB are not supported under 32 bits architecture')
  endif
#endif
  !
end subroutine desc_toobig
!
subroutine copy_descr(in,out,error)
  use sic_types
  !---------------------------------------------------------------------
  ! @ private
  ! Produce an exact copy of a descriptor.
  !---------------------------------------------------------------------
  type(sic_descriptor_t), intent(in)    :: in
  type(sic_descriptor_t), intent(out)   :: out
  logical,                intent(inout) :: error
  !
  out%type     = in%type
  out%ndim     = in%ndim
  out%dims(:)  = in%dims(:)
  out%addr     = in%addr
  out%head    => in%head
  out%size     = in%size
  out%status   = in%status
  out%readonly = in%readonly
  !
end subroutine copy_descr
!
subroutine sic_descriptor(namein,desc,found)
  use sic_interfaces, except_this=>sic_descriptor
  use gildas_def
  use sic_structures
  use sic_dictionaries
  use sic_types
  !---------------------------------------------------------------------
  ! @ public
  !   Retrieve the descriptor of an existing variable
  !  Returns FOUND = .FALSE. if no such variable exists
  !  Automatic transposition is not allowed at this stage
  !---------------------------------------------------------------------
  character(len=*),       intent(in)    :: namein  ! Variable name
  type(sic_descriptor_t), intent(out)   :: desc    ! Descriptor as array
  logical,                intent(inout) :: found   ! Verbose (in) / Found (out)
  ! Local
  type(sic_identifier_t) :: var
  integer(kind=4) :: in,ier
  type(sic_dimensions_t) :: spec
  logical :: error,verbose
  !
  ! Check syntax and analyse dimensions.
  verbose = found
  found = .false.
  if (namein.eq.' ') return
  !
  spec%do%strict   = .false.  ! Can be an expression silently rejected for later parsing
  spec%do%range    = .true.   ! e.g. A[3:5] allowed
  spec%do%subset   = .true.   ! e.g. A[2,] allowed
  spec%do%implicit = .false.  ! e.g. A[i] forbidden
  spec%do%twospec  = .true.   ! e.g. A[i][j:k] allowed
  error = .false.
  call sic_parse_dim(namein,var,spec,verbose,error)
  if (error) return
  !
  ! Find variable
  var%level = var_level
  ier = sic_hasfin(maxvar,pfvar,pnvar,dicvar,var,in)
  if (ier.ne.1) then
    var%level = 0
    ier = sic_hasfin(maxvar,pfvar,pnvar,dicvar,var,in)
    if (ier.ne.1) return
  endif
  !
  ! Copy descriptor
  ! print *,'SIC-DESCRIPTOR '
  call extract_descr(desc,dicvar(in)%desc,spec%done,var%name,.false.,0,error)
  if (error) return
  !
  found = .true.
  !
end subroutine sic_descriptor
!
subroutine sic_materialize(namein,desc,found)
  use sic_interfaces, except_this=>sic_materialize
  use gildas_def
  use sic_structures
  use sic_dictionaries
  use sic_types
  !---------------------------------------------------------------------
  ! @ public
  !   Retrieve the descriptor of an existing variable or of an
  ! incarnation of an expression (including automatic transposition)
  !---------------------------------------------------------------------
  character(len=*),       intent(in)    :: namein  ! Variable name
  type(sic_descriptor_t), intent(out)   :: desc    ! Descriptor
  logical,                intent(inout) :: found   ! Verbose (in) / Found (out)
  ! Local
  type(sic_identifier_t) :: var
  integer(kind=4) :: in,ier
  type(sic_dimensions_t) :: spec
  logical :: error,verbose
  !
  ! Check syntax and analyse dimensions.
  verbose = found
  found = .false.
  if (namein.eq.' ')  return
  !
  spec%do%strict   = .false.  ! Can be an expression silently rejected for later parsing
  spec%do%range    = .true.   ! e.g. A[3:5] allowed
  spec%do%subset   = .true.   ! e.g. A[2,] allowed
  spec%do%implicit = .false.  ! e.g. A[i] forbidden
  spec%do%twospec  = .true.   ! e.g. A[i][j:k] allowed
  error = .false.
  call sic_parse_dim(namein,var,spec,verbose,error)
  if (error) return
  !
  ! Find variable
  var%level = var_level
  ier = sic_hasfin(maxvar,pfvar,pnvar,dicvar,var,in)
  if (ier.ne.1) then
    var%level = 0
    ier = sic_hasfin(maxvar,pfvar,pnvar,dicvar,var,in)
    if (ier.ne.1) return
  endif
  !
  ! Copy descriptor
  ! Print *,'SIC-MATERIALIZE '
  call extract_descr(desc,dicvar(in)%desc,spec%done,var%name,.true.,0,error)
  if (error) return
  found = .true.
  !
end subroutine sic_materialize
!
function sic_varexist(name)
  use sic_interfaces, except_this=>sic_varexist
  use gildas_def
  use sic_dictionaries
  use sic_types
  !---------------------------------------------------------------------
  ! @ public
  !   Check if the input variable exists
  !---------------------------------------------------------------------
  logical :: sic_varexist  ! Function value on return
  character(len=*), intent(in) :: name  ! Variable name
  ! Local
  type(sic_identifier_t) :: var
  integer(kind=4) :: in,ier
  type(sic_dimensions_t) :: spec
  logical :: error,verbose
  !
  sic_varexist = .false.
  !
  if (name.eq.' ') return
  !
  ! Check syntax and analyse dimensions.
  error = .false.
  verbose  = .false.
  spec%do%strict   = .true.   ! Can not be an expression like A[1].eq.B[1]
  spec%do%range    = .true.   ! e.g. A[3:5] allowed
  spec%do%subset   = .true.   ! e.g. A[2,] allowed
  spec%do%implicit = .false.  ! e.g. A[i] forbidden
  spec%do%twospec  = .true.   ! e.g. A[i][j:k] allowed
  call sic_parse_dim(name,var,spec,verbose,error)
  if (error) return
  !
  ! Find variable
  var%level = var_level
  ier = sic_hasfin(maxvar,pfvar,pnvar,dicvar,var,in)
  if (ier.ne.1) then
    var%level = 0
    ier = sic_hasfin(maxvar,pfvar,pnvar,dicvar,var,in)
    if (ier.ne.1) return
  endif
  !
  sic_varexist = .true.
  !
end function sic_varexist
!
function sic_level(namein)
  use sic_interfaces, except_this=>sic_level
  use gildas_def
  use sic_structures
  use sic_dictionaries
  use sic_types
  !---------------------------------------------------------------------
  ! @ public
  !  Retrieve the level of a variable
  !---------------------------------------------------------------------
  integer(kind=4) :: sic_level  ! Function value on return
  character(len=*), intent(in) :: namein  ! Variable name
  ! Local
  type(sic_identifier_t) :: var
  integer(kind=4) :: in,ier
  type(sic_dimensions_t) :: spec
  logical :: verbose,error
  !
  ! Check syntax and analyse dimensions.
  sic_level = -1
  if (namein.eq.' ')  return
  !
  spec%do%strict   = .true.   ! Can not be an expression like A[1].eq.B[1]
  spec%do%range    = .true.   ! e.g. A[3:5] allowed
  spec%do%subset   = .true.   ! e.g. A[2,] allowed
  spec%do%implicit = .false.  ! e.g. A[i] not allowed
  spec%do%twospec  = .true.   ! e.g. A[i][j:k] allowed
  verbose  = .true.
  error = .false.
  call sic_parse_dim(namein,var,spec,verbose,error)
  if (error) return
  !
  ! Find variable
  var%level = var_level
  ier = sic_hasfin(maxvar,pfvar,pnvar,dicvar,var,in)
  if (ier.ne.1) then
    var%level = 0
    ier = sic_hasfin(maxvar,pfvar,pnvar,dicvar,var,in)
    if (ier.eq.1) sic_level = 0
  else
    sic_level = var_level
  endif
  !
end function sic_level
!
subroutine extract_descr(out,in,spec,name,inca,form,error)
  use sic_interfaces, except_this=>extract_descr
  use sic_types
  !---------------------------------------------------------------------
  ! @ private
  ! From the original full variable descriptor, extract the partial
  ! variable descriptor according to specified dimensions or substring
  !---------------------------------------------------------------------
  type(sic_descriptor_t)                     :: out      ! Resulting descriptor
  type(sic_descriptor_t)                     :: in       ! Descriptor of variable
  type(sic_dimensions_done_t), intent(inout) :: spec(2)  ! Dimension specifications
  character(len=*),            intent(in)    :: name     ! Name of variable
  logical,                     intent(in)    :: inca     ! Allow Incarnation
  integer(kind=4),             intent(in)    :: form     ! Incarnation type
  logical,                     intent(inout) :: error    ! Logical error flag
  ! Local
  integer(kind=4) :: aspec,sspec
  type(sic_descriptor_t) :: in2
  !
  if (spec(1)%ndim.eq.0) then
    ! No specification given
    aspec = 0
    sspec = 0
  elseif (spec(2)%ndim.eq.0) then
    ! One specification given. Subarray or substring?
    if (in%ndim.gt.0) then
      ! Variable is an array => subarray specification
      aspec = 1
      sspec = 0
    elseif (in%type.gt.0) then
      ! Variable is a scalar string => substring specification
      aspec = 0
      sspec = 1
    else
      ! Variable is a scalar numeric => invalid (rejected in extract_descr_subarray)
      aspec = 1
      sspec = 0
    endif
  else
    ! Two specifications given
    aspec = 1  ! First must be for subarray
    sspec = 2  ! Second must be for substring
    ! More checks later
  endif
  !
  ! Get descriptor or define incarnation
  if (aspec.eq.0) then
    ! No subarray specification, return full array
    out = in
  else
    ! Partial array, must do some work
    call extract_descr_subarray(out,in,spec(aspec),name,inca,form,error)
    if (error)  return
  endif
  !
  if (sspec.ne.0) then
    in2 = out
    call extract_descr_substring(out,in2,spec(sspec),name,error)
    if (error) then
      call sic_volatile(in2)
      return
    endif
  endif
  !
end subroutine extract_descr
!
subroutine extract_descr_subarray(out,in,spec,name,inca,form,error)
  use gildas_def
  use gbl_format
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>extract_descr_subarray
  use sic_dictionaries
  use sic_types
  !---------------------------------------------------------------------
  ! @ private
  !  Get sub-array descriptor according to specified dimensions
  !---------------------------------------------------------------------
  type(sic_descriptor_t)                     :: out   ! Resulting descriptor
  type(sic_descriptor_t)                     :: in    ! Descriptor of variable
  type(sic_dimensions_done_t), intent(inout) :: spec  ! Subarray specification
  character(len=*),            intent(in)    :: name  ! Name of variable
  logical,                     intent(in)    :: inca  ! Allow Incarnation
  integer(kind=4),             intent(in)    :: form  ! Incarnation type
  logical,                     intent(inout) :: error ! Logical error flag
  ! Global
  include 'gbl_memory.inc'
  ! Local
  character(len=*), parameter :: rname='PARSE'
  integer(kind=4) :: i,j,ier,item_size,type
  integer(kind=address_length) :: ipntin,ipntout
  integer(kind=size_length) :: size,offset
  character(len=message_length) :: mess
  logical :: transpose
  !
  if (spec%ndim.gt.in%ndim) then
    write(mess,'(3A,I0,A)')  &
      'Variable ',trim(name),' has only ',in%ndim,' dimensions'
    call sic_message(seve%e,rname,mess)
    error = .true.
    return
  endif
  !
  transpose = .false.
  !
  ! 1) Check for unspecified leading dimensions
  if (spec%ndim.lt.in%ndim) then
    ! Shift explicit dimensions, and fill the unspecified ones with the
    ! dummy value 0
    do i=spec%ndim,1,-1
      spec%dims(i+in%ndim-spec%ndim,1) = spec%dims(i,1)
      spec%dims(i+in%ndim-spec%ndim,2) = spec%dims(i,2)
    enddo
    do i=in%ndim-spec%ndim,1,-1
      spec%dims(i,1) = 0
      spec%dims(i,2) = 0
    enddo
    spec%ndim = in%ndim
  endif
  !
  offset = 0
  do i=spec%ndim,1,-1
    ! Replace dummy sizes with array bounds for the dimension
    if (spec%dims(i,1).eq.0) spec%dims(i,1) = 1
    if (spec%dims(i,2).eq.0) spec%dims(i,2) = in%dims(i)
    ! Check for out of bound limits
    if (spec%dims(i,1).gt.in%dims(i)) then
      write (mess,102) spec%dims(i,1),i,in%dims(i),trim(name)
      call sic_message(seve%e,rname,mess)
      error = .true.
      return
    elseif (spec%dims(i,2).gt.in%dims(i)) then
      write (mess,102) spec%dims(i,2),i,in%dims(i),trim(name)
      call sic_message(seve%e,rname,mess)
      error = .true.
      return
    endif
    offset = offset+spec%dims(i,1)-1
    if (i.gt.1) offset = offset*in%dims(i-1)
  enddo
  !
  size = 1
  do i=1,spec%ndim
    size = size*(spec%dims(i,2)-spec%dims(i,1)+1)
  enddo
  ! Convert to byte and word units
  type = in%type
  if (type.eq.fmt_r8 .or. type.eq.fmt_c4 .or. type.eq.fmt_i8) then ! Double
    item_size = 8
    size   = 2*size
  elseif (type.gt.0) then      ! Char
    item_size = type
    size   = (size*type+3)/4
  else                         ! Anything else
    item_size = 4
  endif
  offset = offset*item_size
  !! Not yet ipmlemented
  if (form.ne.0 .and. type.ne.form) then
    call sic_message(seve%e,rname,'Incarnation not yet implemented')
    error = .true.
    return
  endif
  ! Fill output descriptor
  out = in
  out%size = size
  ! Test for "implicit transposition" (in fact non contiguous sub-arrays)
  ! like A[1,3:5]
  ! Beware, it is a bit tricky...
  !
  do i=1,spec%ndim-1
    !
    ! Sub-array in dimension I
    if (spec%dims(i,1).ne.1.or.spec%dims(i,2).ne.in%dims(i)) then
      ! Check if remaining dimensions degenerate to zero
      do j=i,spec%ndim
        if (spec%dims(j,1).ne.spec%dims(j,2)) then
          transpose = .true.
        endif
      enddo
    endif
  enddo
  !
  ! Output descriptor must include the degenerate dimensions at this stage,
  ! it is needed for the TRANSPOSE case
  out%dims = 0
  do i=1,spec%ndim
    out%dims(i) = spec%dims(i,2)-spec%dims(i,1)+1
  enddo
  !
  if (.not.transpose) then     ! Can use a pointer to input array
    out%addr = in%addr+offset
  elseif  (.not.inca) then
    ! Message is not allowed here
    ! call gagout('E-PARSE,  Transposition not allowed here')
    error = .true.
    return
  else
    ! General case, must allocate some memory and copy
    ier = sic_getvm (out%size,out%addr)
    if (ier.ne.1) goto 99
    out%status = scratch_operand
    !
    ! This could be suppressed when the subarray will only be used as a
    ! target... Also, one could look for bigger contiguous chunks.
    ipntin  = gag_pointer(in%addr,memory)
    ipntout = gag_pointer(out%addr,memory)
    call extract_array(memory(ipntin),in%ndim,in%dims,spec%dims,item_size,  &
      memory(ipntout),out%ndim,out%dims,error)
  endif
  !
  ! Suppress degenerate dimensions in the output descriptor
  out%ndim = 0
  do i=1,spec%ndim
    if (spec%dims(i,1).lt.spec%dims(i,2)) then
      out%ndim = out%ndim+1
      out%dims(out%ndim) = spec%dims(i,2)-spec%dims(i,1)+1
    endif
  enddo
  do i=out%ndim+1,sic_maxdims
    out%dims(i) = 0
  enddo
  !
  return
  !
99 error = .true.
  return
  !
102 format('Index ',i0,' exceed dimension #',i1,' (',i0,') of ',a)
end subroutine extract_descr_subarray
!
subroutine extract_descr_substring(out,in,spec,name,error)
  use gbl_message
  use sic_interfaces, except_this=>extract_descr_substring
  use sic_dictionaries
  use sic_types
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(sic_descriptor_t),      intent(inout) :: out    ! Resulting descriptor
  type(sic_descriptor_t),      intent(in)    :: in     ! Descriptor of variable
  type(sic_dimensions_done_t), intent(inout) :: spec   ! Substring specification
  character(len=*),            intent(in)    :: name   ! Name of variable
  logical,                     intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='PARSE'
  character(len=message_length) :: mess
  integer(kind=4) :: nchar
  !
  ! Check input variable
  if (in%type.le.0) then
    call sic_message(seve%e,rname,  &
      'Invalid substring specification on non-character string')
    error = .true.
    return
  endif
  if (in%ndim.ne.0) then
    call sic_message(seve%e,rname,'Can not extract substring from array')
    error = .true.
    return
  endif
  if (in%status.eq.scratch_operand) then
    ! This should never happen! Substring are always extracted from scalar
    ! strings (checked above). extract_descr_subarray does not build a scratch
    ! array for a scalar value.
    ! If this would happen, I do not now what we should do, because the
    ! resulting substring descriptor would not reflect the input scratch
    ! array, and we would not clean it properly afterwards.
    call sic_message(seve%e,rname,  &
      'Can not extract substring from scratch variable')
    error = .true.
    return
  endif
  !
  ! Check substring specification
  if (.not.spec%range) then
    call sic_message(seve%e,rname,'Substring specification must provide a range')
    error = .true.
    return
  endif
  if (spec%ndim.ne.1) then
    call sic_message(seve%e,rname,'Substring specification must be 1D')
    error = .true.
    return
  endif
  if (spec%dims(1,1).eq.0) spec%dims(1,1) = 1
  if (spec%dims(1,2).eq.0) spec%dims(1,2) = in%type
  if (spec%dims(1,1).gt.in%type) then
    write (mess,102) spec%dims(1,1),in%type,trim(name)
    call sic_message(seve%e,rname,mess)
    error = .true.
    return
  elseif (spec%dims(1,2).gt.in%type) then
    write (mess,102) spec%dims(1,2),in%type,trim(name)
    call sic_message(seve%e,rname,mess)
    error = .true.
    return
  endif
  nchar = spec%dims(1,2)-spec%dims(1,1)+1
  if (nchar.le.0) then
    call sic_message(seve%e,rname,'Negative-length substring')
    error = .true.
    return
  endif
  !
  out%type     = nchar
  out%ndim     = 0
  out%dims(:)  = 0
  out%addr     = in%addr+spec%dims(1,1)-1
  out%size     = (nchar+3)/4  ! Not sure which sense this makes
  out%status   = in%status
  out%readonly = in%readonly
  !
102 format('Index ',i0,' exceeds length ',I0,' of string ',a)
end subroutine extract_descr_substring
!
subroutine sic_parse_dim(string,var,spec,verbose,error)
  use sic_interfaces, except_this=>sic_parse_dim
  use gildas_def
  use gbl_message
  use sic_types
  use sic_dictionaries
  !---------------------------------------------------------------------
  ! @ private
  !  Parse the dimension field of an input variable e.g. NAME[i,j][k:l]
  ! On return fill:
  !   var%name
  !   var%lname
  !   specifications description (subarray and/or substring)
  !---------------------------------------------------------------------
  character(len=*),       intent(in)    :: string    ! String to parse
  type(sic_identifier_t), intent(out)   :: var       ! Parsed variable
  type(sic_dimensions_t), intent(inout) :: spec      ! Dimensions specifications
  logical,                intent(in)    :: verbose   ! Verbose work?
  logical,                intent(inout) :: error     ! Error flag
  ! Local
  character(len=*), parameter :: rname='DIMENSION'
  integer(kind=4) :: iopen1,iopen2,iclose,idime
  character(len=message_length) :: mess
  !
  ! Parse name from dimensions...
  error = .false.
  do idime=1,2
    spec%done(idime)%ndim = 0
    spec%done(idime)%dims(:,:) = 0
    spec%done(idime)%range = .false.  ! No range found
    spec%done(idime)%implicit = .false.  ! No implicit dimension found
  enddo
  !
  iopen1 = index_obracket(string)
  !
  if (iopen1.eq.0) then
    ! Standard variable name (no opening "[")
    var%lname = len_trim(string)
    if (var%lname.gt.len(var%name)) then
      ! Silent error. May be a large expression.
      ! ZZZ what about the 'verbose' flag?
      error = .true.
      return
    endif
    var%name = string
    return
  endif
  !
  ! Variable has a "["
  if (iopen1.gt.len(var%name)+1) then
    error = .true.
    return
  endif
  !
  var%name = string(1:iopen1-1)
  var%lname = iopen1-1
  !
  ! Parse 1st group of []
  call sic_parse_dim_group(1,iopen1,iclose,error)
  if (error)  return
  !
  if (spec%do%twospec) then
    ! Parse 2nd group of []
    iopen2 = index_obracket(string(iopen1+1:))  ! Relative from previous "["
    if (iopen2.gt.0) then
      ! Found a second "["
      iopen2 = iopen1+iopen2               ! Absolute from beginning of string
      if (iopen2.le.iclose) then
        ! e.g. A[B[1]] not supported
        call sic_message(seve%e,rname,'Invalid syntax')
        error = .true.
        return
      elseif (iopen2.eq.iclose+1) then
        ! 2nd opening "[" is glued to previous closing "]" => there is a 2nd group
        call sic_parse_dim_group(2,iopen2,iclose,error)
        if (error)  return
      else
        ! There is a 2nd opening "[" but further in the string
        ! May be an expression e.g. 'A[1].eq.A[2]'
        if (spec%do%strict)  &
          call sic_message(seve%e,rname,'Invalid variable name '//string)
        error = .true.
        return
      endif
    endif
  endif
  !
  ! Final sanity check
  if (iclose.ne.len_trim(string)) then
    ! May be an expression e.g. 'A[1].eq.0'
    if (spec%do%strict)  &
      call sic_message(seve%e,rname,'Invalid variable name '//string)
    error = .true.
    return
  endif
  !
contains
  function index_obracket(string)
    !-------------------------------------------------------------------
    ! Return the position of the next opening bracket in string, taking
    ! into account double-quoted string. Result should be identical to
    !   index(string,'[')
    ! is there is no double quotes involved. Return 0 if no bracket is
    ! found.
    !-------------------------------------------------------------------
    integer(kind=4) :: index_obracket  ! Function value on return
    character(len=*), intent(in) :: string
    ! Local
    integer(kind=4) :: icha
    logical :: inchain
    !
    inchain = .false.
    index_obracket = 0
    do icha=1,len(string)
      if (string(icha:icha).eq.'"') then
        inchain = .not.inchain
        cycle  ! icha
      endif
      if (inchain) cycle  ! icha
      !
      if (string(icha:icha).eq.'[') then
        index_obracket = icha
        return
      endif
    enddo
    !
  end function index_obracket
  !
  subroutine sic_parse_dim_group(igroup,iopen,iclose,error)
    use sic_interfaces
    use sic_types
    integer(kind=4), intent(in)    :: igroup
    integer(kind=4), intent(in)    :: iopen
    integer(kind=4), intent(out)   :: iclose
    logical,         intent(inout) :: error
    ! Local
    integer(kind=4) :: icomma,istart
    !
    iclose = index(string(iopen:),']')  ! Relative from iopen
    if (iclose.eq.0) then
      if (verbose)  call sic_message(seve%e,rname,'Missing closing bracket')
      error = .true.
      return
    endif
    iclose = iopen+iclose-1  ! Absolute from beginning of string
    !
    istart = iopen
    do while (istart.lt.iclose)
      !
      icomma = index(string(istart+1:iclose),',')
      if (icomma.eq.0) icomma=iclose-istart  ! For last dimension
      !
      if (icomma.ne.1) then
        call sic_decode_dims(string(istart+1:),icomma-1,  &
          spec%done(igroup)%dims,      &
          spec%done(igroup)%ndim,      &
          spec%do%range,               &
          spec%do%implicit,            &
          spec%done(igroup)%range,     &
          spec%done(igroup)%implicit,  &
          spec%done(igroup)%vars,      &
          verbose,error)
        if (error) return
      elseif (spec%do%subset) then  ! icomma.eq.1, and subset is allowed
        spec%done(igroup)%ndim = spec%done(igroup)%ndim+1
        spec%done(igroup)%dims(spec%done(igroup)%ndim,1) = 0
        spec%done(igroup)%dims(spec%done(igroup)%ndim,2) = 0
      else                  ! icomma.eq.1, but subset is not allowed
        write(mess,'(A,I2,A)') 'Subset not allowed in this context '//  &
          '(dimension #',spec%done(igroup)%ndim+1,')'
        call sic_message(seve%e,rname,mess)
        error = .true.
        return
      endif
      !
      istart = istart+icomma
    enddo
  end subroutine sic_parse_dim_group
  !
end subroutine sic_parse_dim
!
subroutine sic_decode_dims(chain,lc,dim,ndim,range,implicit,has_range,  &
  has_implicit,dimvars,verbose,error)
  use gildas_def
  use sic_interfaces, except_this=>sic_decode_dims
  use sic_structures
  use sic_dictionaries
  use sic_types
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! Parse one dimension of an input variable i:j
  !---------------------------------------------------------------------
  character(len=*),           intent(in)    :: chain     ! String to parse
  integer,                    intent(in)    :: lc        ! Length of input string
  integer(kind=index_length), intent(inout) :: dim(sic_maxdims,2)  ! The dimensions parsed
  integer,                    intent(inout) :: ndim      ! The Nth dimension being parsed
  logical,                    intent(in)    :: range     ! Accept a dimension range
  logical,                    intent(in)    :: implicit  ! Accept implicit dimension
  logical,                    intent(inout) :: has_range             ! Some range found?
  logical,                    intent(inout) :: has_implicit          ! Implicit dimension found?
  type(sic_identifier_t),     intent(inout) :: dimvars(sic_maxdims)  ! Name of implicit dimension
  logical,                    intent(in)    :: verbose   ! Print messages
  logical,                    intent(inout) :: error     ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='DIMENSION'
  type(sic_identifier_t) :: var
  character(len=message_length) :: mess
  integer :: j,imin,imax,i1(2),i2(2),icolon,ier
  logical :: error2
  !
  if (ndim.eq.sic_maxdims) then
    if (verbose) call sic_message(seve%e,rname,'Too many dimensions')
    error = .true.
    return
  endif
  ndim = ndim+1
  !
  if (lc.le.0) then
    dim(ndim,1) = 0
    dim(ndim,2) = 0
    return
  endif
  !
  ! Check for an index range: A[1:3]
  icolon = index(chain(1:lc),':')
  if (icolon.ne.0) then
    has_range = .true.
    if (.not.range) then
      if (verbose) then
        call sic_message(seve%e,rname,'Index range not supported in '//  &
        'this context')
      endif
      error = .true.
      return
    endif
    if (icolon.eq.1) then         ! A[:3]
      dim(ndim,1) = 0        ! 0-->1
      imin = 2
      imax = 2
      i1(2) = 2
      i2(2) = lc
    elseif (icolon.eq.lc) then    ! A[3:]
      imin = 1
      imax = 1
      i1(1) = 1
      i2(1) = icolon-1
      dim(ndim,2) = 0        ! Use full dim
    else
      imin = 1
      imax = 2
      i1(1) = 1
      i2(1) = icolon-1
      i1(2) = icolon+1
      i2(2) = lc
    endif
  else
    imin = 1
    imax = 2
    i1(1) = 1
    i2(1) = lc
    i1(2) = 1
    i2(2) = lc
  endif
  !
  do j=imin,imax
    ! Distinguish plain numbers from variables (assumes ASCII set).
    if (chain(i1(j):i1(j)).lt.'A') then
      read(chain(i1(j):i2(j)),*,iostat=ier) dim(ndim,j)
      if (ier.ne.0) then
        if (verbose)  &
          call sic_message(seve%e,rname,'Invalid dimension: '//chain(i1(j):i2(j)))
        error = .true.
        return
      endif
      if (dim(ndim,j).lt.1) then
        if (verbose) then
          write(mess,'(A,I1,A,I0)') 'Out of bound dimension #',ndim,': ',dim(ndim,j)
          call sic_message(seve%e,rname,mess)
        endif
        error = .true.
        return
      endif
      !
    elseif (icolon.gt.varname_length) then
      if (verbose)  &
        call sic_message(seve%e,rname,'Invalid dimension: '//chain(i1(j):i2(j)))
      error = .true.
      return
      !
    else
      var%name = chain(i1(j):i2(j))
      var%lname = i2(j)-i1(j)+1
      call intege(var,dim(ndim,j),error2)
      if (error2) then
        ! Try an implicit variable, unless a range was specified
        if (implicit .and. icolon.eq.0) then
          has_implicit = .true.
          dimvars(ndim)%name = var%name
          dimvars(ndim)%lname = var%lname
          dim(ndim,j) = -1
        else
          if (verbose)  call sic_message(seve%e,rname,'Invalid dimension: '//var%name)
          error = .true.
          return
        endif
      else
        if (dim(ndim,j).lt.1) then
          if (verbose) then
            write(mess,'(A,I1,A,I0)') 'Out of bound dimension #',ndim,': ',dim(ndim,j)
            call sic_message(seve%e,rname,mess)
          endif
          error = .true.
          return
        endif
      endif
    endif
  enddo
  !
  if (imin.lt.imax) then
    if (dim(ndim,1).gt.dim(ndim,2)) then
      if (verbose)  &
        call sic_message(seve%e,rname,'Invalid dimension: '//chain(i1(1):i2(2)))
      error = .true.
      return
    endif
  endif
  !
end subroutine sic_decode_dims
!
subroutine sic_parse_var(namein,var,spec,impvars,error)
  use sic_interfaces, except_this=>sic_parse_var
  use gildas_def
  use sic_structures
  use sic_dictionaries
  use sic_types
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! SIC
  !   Parse the dimension field of a variable for implicit dimensions
  ! NAME[i,j].
  !   Define the support variables for the implicit (named) dimensions
  ! in the Sic variables dictionary.
  ! On return fill:
  !   var%name
  !   var%lname
  !   specifications description (subarray and/or substring)
  !---------------------------------------------------------------------
  character(len=*),           intent(in)    :: namein    ! String to parse
  type(sic_identifier_t),     intent(out)   :: var       ! Variable name
  type(sic_dimensions_t),     intent(inout) :: spec      ! Dimensions specifications
  integer(kind=4),            intent(out)   :: impvars(sic_maxdims)  ! Id. of implicit variables
  logical,                    intent(inout) :: error     ! Logical error flag
  ! Local
  integer :: i,in,ier,var_last
  logical :: verbose
  !
  ! Default values if early return
  impvars(:) = 0
  !
  verbose = .true.
  call sic_parse_dim(namein,var,spec,verbose,error)
  if (error)  return
  !
  ! Check consistency of implicit/explicit dimensions. Implicit already
  ! parsed in sic_decode_dims
  do i=1,spec%done(1)%ndim
    if (spec%done(1)%dims(i,1).gt.0 .and. spec%done(1)%implicit) then
      error = .true.
      call sic_message(seve%e,'DIMENSION',  &
        'Invalid mixture of implicit and explicit dimensions')
      return
    endif
  enddo
  if (.not.spec%done(1)%implicit) then
    ! No implicit variables. Nothing more to do, leave
    return
  endif
  !
  ! Loop over implicit (temporary) variables
  var_last = var_n  ! Keep track for error recovery
  do i=1,spec%done(1)%ndim
    if (spec%done(1)%dims(i,1).ne.-1)  cycle  ! Not an implicit named dimension
    !
    spec%done(1)%vars(i)%level = var_level
    ier = sic_hasfin(maxvar,pfvar,pnvar,dicvar,spec%done(1)%vars(i),in)
    if (ier.eq.1) then
      call sic_message(seve%e,'IMPLICIT','Variable '//  &
        trim(spec%done(1)%vars(i)%name)//' already exists')
      goto 98
    endif
    !
    if (index(spec%done(1)%vars(i)%name,'%').gt.0) then
      ! Implicit variables can not be (or seem to be) member of a structure
      ! (whatever the parent structure exists or not)
      call sic_message(seve%e,'IMPLICIT','Invalid implicit variable name '//  &
        spec%done(1)%vars(i)%name)
      goto 98
    endif
    ier = sic_hasins('IMPLICIT',maxvar,pfvar,pnvar,dicvar,spec%done(1)%vars(i),in)
    if (ier.eq.0 .or. ier.eq.2)  goto 98
    dicvar(in)%desc%status = empty_operand  ! Not yet allocated
    dicvar(in)%desc%size = 0
    spec%done(1)%dims(i,1) = 1
    impvars(i) = in
    var_n = var_n+1
    var_pointer (var_n) = in
  enddo
  return
  !
98 continue
  ! Error: clean up implicit variables
  do i=1,spec%done(1)%ndim
    if (impvars(i).eq.0)  cycle  ! No variable defined
    ! Set user=.false., we will reset var_n by hand right after
    call sic_zapvariable(impvars(i),.false.,.true.,error)
  enddo
  var_n = var_last
  error = .true.
  !
end subroutine sic_parse_var
!
subroutine sic_parse_char(string,var,nchar,spec,verbose,error)
  use sic_interfaces, except_this=>sic_parse_char
  use gildas_def
  use sic_structures
  use sic_dictionaries
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !  Parse the size field of a character variable NAME*i
  ! On return fill:
  !   var%name
  !   var%lname
  !   nchar      (string length)
  !   specifications description (subarray and/or substring)
  !---------------------------------------------------------------------
  character(len=*),       intent(in)    :: string   ! String to parse
  type(sic_identifier_t), intent(out)   :: var      ! Variable
  integer(kind=4),        intent(out)   :: nchar    ! String length
  type(sic_dimensions_t), intent(inout) :: spec     ! Dimensions specifications
  logical,                intent(in)    :: verbose  ! Verbose work?
  logical,                intent(inout) :: error    ! Error flag
  ! Local
  character(len=*), parameter :: rname='DIMENSION'
  integer(kind=4) :: i,ier
  !
  ! Parse name from dimensions...
  call sic_parse_dim(string,var,spec,verbose,error)
  if (error) return
  !
  ! Parse name from string length
  i = index(var%name(1:var%lname),'*')
  if (i.eq.0) then
    call sic_message(seve%e,rname,'Missing character size')
    error = .true.
    return
  elseif (i.gt.len(var%name)) then
    call sic_message(seve%e,rname,'Invalid variable name '//var%name(1:i-1))
    error = .true.
    return
  endif
  read (var%name(i+1:var%lname),*,iostat=ier) nchar
  if (ier.ne.0 .or. nchar.le.0) then
    ! NB: this also traps empty string length
    call sic_message(seve%e,rname,'Invalid string length '//var%name(i+1:var%lname))
    error = .true.
    return
  endif
  ! n = nchar/4
  ! if (4*n.ne.nchar) nchar=4*(n+1)
  var%name = var%name(1:i-1)
  var%lname = i-1
  error = .false.
end subroutine sic_parse_char
!
subroutine i4_index(in,x,dim)
  use sic_interfaces
  use gildas_def
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  ! This version for sic_maxdims==7
  !---------------------------------------------------------------------
  integer(kind=4),            intent(in)  :: in      ! Which dimension?
  integer(kind=4),            intent(out) :: x(*)    !
  integer(kind=index_length), intent(in)  :: dim(7)  ! Dimensions
  ! Local
  integer(kind=index_length) :: i1,i2,i3,i4,i5,i6,i7,i
  integer(kind=index_length) :: kdim(7)
  !
  do i=1,7
    kdim(i) = dim(i)
    if (kdim(i).le.0) kdim(i) = 1
  enddo
  !
  if (in.eq.1) then
    i = 0
    do i7=1,kdim(7)
      do i6=1,kdim(6)
        do i5=1,kdim(5)
          do i4=1,kdim(4)
            do i3=1,kdim(3)
              do i2=1,kdim(2)
                do i1=1,kdim(1)
                  i = i+1
                  x(i) = i1
                enddo
              enddo
            enddo
          enddo
        enddo
      enddo
    enddo
  elseif (in.eq.2) then
    i = 0
    do i7=1,kdim(7)
      do i6=1,kdim(6)
        do i5=1,kdim(5)
          do i4=1,kdim(4)
            do i3=1,kdim(3)
              do i2=1,kdim(2)
                do i1=1,kdim(1)
                  i = i+1
                  x(i) = i2
                enddo
              enddo
            enddo
          enddo
        enddo
      enddo
    enddo
  elseif (in.eq.3) then
    i = 0
    do i7=1,kdim(7)
      do i6=1,kdim(6)
        do i5=1,kdim(5)
          do i4=1,kdim(4)
            do i3=1,kdim(3)
              do i2=1,kdim(2)
                do i1=1,kdim(1)
                  i = i+1
                  x(i) = i3
                enddo
              enddo
            enddo
          enddo
        enddo
      enddo
    enddo
  elseif (in.eq.4) then
    i = 0
    do i7=1,kdim(7)
      do i6=1,kdim(6)
        do i5=1,kdim(5)
          do i4=1,kdim(4)
            do i3=1,kdim(3)
              do i2=1,kdim(2)
                do i1=1,kdim(1)
                  i = i+1
                  x(i) = i4
                enddo
              enddo
            enddo
          enddo
        enddo
      enddo
    enddo
  elseif (in.eq.5) then
    i = 0
    do i7=1,kdim(7)
      do i6=1,kdim(6)
        do i5=1,kdim(5)
          do i4=1,kdim(4)
            do i3=1,kdim(3)
              do i2=1,kdim(2)
                do i1=1,kdim(1)
                  i = i+1
                  x(i) = i5
                enddo
              enddo
            enddo
          enddo
        enddo
      enddo
    enddo
  elseif (in.eq.6) then
    i = 0
    do i7=1,kdim(7)
      do i6=1,kdim(6)
        do i5=1,kdim(5)
          do i4=1,kdim(4)
            do i3=1,kdim(3)
              do i2=1,kdim(2)
                do i1=1,kdim(1)
                  i = i+1
                  x(i) = i6
                enddo
              enddo
            enddo
          enddo
        enddo
      enddo
    enddo
  elseif (in.eq.7) then
    i = 0
    do i7=1,kdim(7)
      do i6=1,kdim(6)
        do i5=1,kdim(5)
          do i4=1,kdim(4)
            do i3=1,kdim(3)
              do i2=1,kdim(2)
                do i1=1,kdim(1)
                  i = i+1
                  x(i) = i7
                enddo
              enddo
            enddo
          enddo
        enddo
      enddo
    enddo
  endif
end subroutine i4_index
!
subroutine i8_index(in,x,dim)
  use sic_interfaces
  use gildas_def
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  ! This version for sic_maxdims==7
  !---------------------------------------------------------------------
  integer(kind=4),            intent(in)  :: in      ! Which dimension?
  integer(kind=8),            intent(out) :: x(*)    !
  integer(kind=index_length), intent(in)  :: dim(7)  ! Dimensions
  ! Local
  integer(kind=index_length) :: i1,i2,i3,i4,i5,i6,i7,i
  integer(kind=index_length) :: kdim(7)
  !
  do i=1,7
    kdim(i) = dim(i)
    if (kdim(i).le.0) kdim(i) = 1
  enddo
  !
  if (in.eq.1) then
    i = 0
    do i7=1,kdim(7)
      do i6=1,kdim(6)
        do i5=1,kdim(5)
          do i4=1,kdim(4)
            do i3=1,kdim(3)
              do i2=1,kdim(2)
                do i1=1,kdim(1)
                  i = i+1
                  x(i) = i1
                enddo
              enddo
            enddo
          enddo
        enddo
      enddo
    enddo
  elseif (in.eq.2) then
    i = 0
    do i7=1,kdim(7)
      do i6=1,kdim(6)
        do i5=1,kdim(5)
          do i4=1,kdim(4)
            do i3=1,kdim(3)
              do i2=1,kdim(2)
                do i1=1,kdim(1)
                  i = i+1
                  x(i) = i2
                enddo
              enddo
            enddo
          enddo
        enddo
      enddo
    enddo
  elseif (in.eq.3) then
    i = 0
    do i7=1,kdim(7)
      do i6=1,kdim(6)
        do i5=1,kdim(5)
          do i4=1,kdim(4)
            do i3=1,kdim(3)
              do i2=1,kdim(2)
                do i1=1,kdim(1)
                  i = i+1
                  x(i) = i3
                enddo
              enddo
            enddo
          enddo
        enddo
      enddo
    enddo
  elseif (in.eq.4) then
    i = 0
    do i7=1,kdim(7)
      do i6=1,kdim(6)
        do i5=1,kdim(5)
          do i4=1,kdim(4)
            do i3=1,kdim(3)
              do i2=1,kdim(2)
                do i1=1,kdim(1)
                  i = i+1
                  x(i) = i4
                enddo
              enddo
            enddo
          enddo
        enddo
      enddo
    enddo
  elseif (in.eq.5) then
    i = 0
    do i7=1,kdim(7)
      do i6=1,kdim(6)
        do i5=1,kdim(5)
          do i4=1,kdim(4)
            do i3=1,kdim(3)
              do i2=1,kdim(2)
                do i1=1,kdim(1)
                  i = i+1
                  x(i) = i5
                enddo
              enddo
            enddo
          enddo
        enddo
      enddo
    enddo
  elseif (in.eq.6) then
    i = 0
    do i7=1,kdim(7)
      do i6=1,kdim(6)
        do i5=1,kdim(5)
          do i4=1,kdim(4)
            do i3=1,kdim(3)
              do i2=1,kdim(2)
                do i1=1,kdim(1)
                  i = i+1
                  x(i) = i6
                enddo
              enddo
            enddo
          enddo
        enddo
      enddo
    enddo
  elseif (in.eq.7) then
    i = 0
    do i7=1,kdim(7)
      do i6=1,kdim(6)
        do i5=1,kdim(5)
          do i4=1,kdim(4)
            do i3=1,kdim(3)
              do i2=1,kdim(2)
                do i1=1,kdim(1)
                  i = i+1
                  x(i) = i7
                enddo
              enddo
            enddo
          enddo
        enddo
      enddo
    enddo
  endif
end subroutine i8_index
!
subroutine sic_incarnate_desc(form,desc,inca,error)
  use gildas_def
  use gbl_format
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_incarnate_desc
  use sic_dictionaries
  use sic_types
  !---------------------------------------------------------------------
  ! @ public-generic sic_incarnate
  !  Creates an "incarnation" of a variable under a specified type
  ! (REAL, DOUBLE, INTEGER...).
  ! DESC and INCA can be the same descriptor if needed (=> do not
  ! put INTENT statements).
  !---------------------------------------------------------------------
  integer(kind=4),        intent(in)    :: form   ! Format of the desired incarnation
  type(sic_descriptor_t), intent(in)    :: desc   ! Input descriptor of the variable
  type(sic_descriptor_t), intent(inout) :: inca   ! Descriptor of the incarnation
  logical,                intent(out)   :: error  ! Logical error flag
  ! Global
  include 'gbl_memory.inc'
  ! Local
  character(len=*), parameter :: rname='INCARNATE'
  integer :: type,ier
  integer(kind=size_length) :: np
  integer(kind=address_length) :: ipnta,ipntb,addr
  !
  error = .false.
  type = desc%type
  if (type.eq.form) then
    inca = desc
    !
  elseif (form.eq.fmt_r4) then
    if (type.eq.fmt_r8) then
      ! R8 -> R4
      addr = desc%addr
      np   = desc%size/2
      inca%size = np
      inca%ndim = desc%ndim
      inca%dims(:) = desc%dims(:)
      inca%status = scratch_operand
      ier = sic_getvm(inca%size,inca%addr)
      if (ier.ne.1) goto 99
      ipnta = gag_pointer(addr,memory)
      ipntb = gag_pointer(inca%addr,memory)
      call r8tor4_sl(memory(ipnta),memory(ipntb),np)
    elseif (type.eq.fmt_i4) then
      ! I4 -> R4
      addr = desc%addr
      np   = desc%size
      inca%size = np
      inca%ndim = desc%ndim
      inca%dims(:) = desc%dims(:)
      inca%status = scratch_operand
      ier = sic_getvm(inca%size,inca%addr)
      if (ier.ne.1) goto 99
      ipnta = gag_pointer(addr,memory)
      ipntb = gag_pointer(inca%addr,memory)
      call i4tor4_sl(memory(ipnta),memory(ipntb),np)
    elseif (type.eq.fmt_i8) then
      ! I8 -> R4
      addr = desc%addr
      np   = desc%size/2
      inca%size = np
      inca%ndim = desc%ndim
      inca%dims(:) = desc%dims(:)
      inca%status = scratch_operand
      ier = sic_getvm(inca%size,inca%addr)
      if (ier.ne.1) goto 99
      ipnta = gag_pointer(addr,memory)
      ipntb = gag_pointer(inca%addr,memory)
      call i8tor4_sl(memory(ipnta),memory(ipntb),np)
    elseif (type.eq.fmt_c4) then
      ! C4 -> R4
      call sic_message(seve%e,rname,'Cannot convert COMPLEX*4 to REAL*4')
      error = .true.
      return
    else
      call sic_message(seve%e,rname,'Bad variable type (1)')
      error = .true.
      return
    endif
  elseif (form.eq.fmt_r8) then
    if (type.eq.fmt_r4) then
      ! R4 -> R8
      addr = desc%addr
      np   = desc%size
      inca%size = np*2
      inca%ndim = desc%ndim
      inca%dims(:) = desc%dims(:)
      inca%status = scratch_operand
      ier = sic_getvm(inca%size,inca%addr)
      if (ier.ne.1) goto 99
      ipnta = gag_pointer(addr,memory)
      ipntb = gag_pointer(inca%addr,memory)
      call r4tor8_sl(memory(ipnta),memory(ipntb),np)
    elseif (type.eq.fmt_i4) then
      ! I4 -> R8
      addr = desc%addr
      np   = desc%size
      inca%size = 2*np
      inca%ndim = desc%ndim
      inca%dims(:) = desc%dims(:)
      inca%status = scratch_operand
      ier = sic_getvm(inca%size,inca%addr)
      if (ier.ne.1) goto 99
      ipnta = gag_pointer(addr,memory)
      ipntb = gag_pointer(inca%addr,memory)
      call i4tor8_sl(memory(ipnta),memory(ipntb),np)
    elseif (type.eq.fmt_i8) then
      ! I8 -> R8
      addr = desc%addr
      np   = desc%size/2
      inca%size = 2*np
      inca%ndim = desc%ndim
      inca%dims(:) = desc%dims(:)
      inca%status = scratch_operand
      ier = sic_getvm(inca%size,inca%addr)
      if (ier.ne.1) goto 99
      ipnta = gag_pointer(addr,memory)
      ipntb = gag_pointer(inca%addr,memory)
      call i8tor8_sl(memory(ipnta),memory(ipntb),np)
    elseif (type.eq.fmt_c4) then
      ! C4 -> R8
      call sic_message(seve%e,rname,'Cannot convert COMPLEX*4 to REAL*8')
      error = .true.
      return
    else
      call sic_message(seve%e,rname,'Bad variable type (2)')
      error = .true.
      return
    endif
  elseif (form.eq.fmt_i4) then
    if (type.eq.fmt_r8) then
      ! R8 -> I4
      addr = desc%addr
      np   = desc%size/2
      inca%size = np
      inca%ndim = desc%ndim
      inca%dims(:) = desc%dims(:)
      inca%status = scratch_operand
      ier = sic_getvm(inca%size,inca%addr)
      if (ier.ne.1) goto 99
      ipnta = gag_pointer(addr,memory)
      ipntb = gag_pointer(inca%addr,memory)
      call r8toi4_fini_sl(memory(ipnta),memory(ipntb),np,error)
      if (error)  return
    elseif (type.eq.fmt_r4) then
      ! R4 -> I4
      addr = desc%addr
      np   = desc%size
      inca%size = np
      inca%ndim = desc%ndim
      inca%dims(:) = desc%dims(:)
      inca%status = scratch_operand
      ier = sic_getvm(inca%size,inca%addr)
      if (ier.ne.1) goto 99
      ipnta = gag_pointer(addr,memory)
      ipntb = gag_pointer(inca%addr,memory)
      call r4toi4_fini_sl(memory(ipnta),memory(ipntb),np,error)
      if (error)  return
    elseif (type.eq.fmt_i8) then
      ! I8 -> I4
      addr = desc%addr
      np   = desc%size/2
      inca%size = np
      inca%ndim = desc%ndim
      inca%dims(:) = desc%dims(:)
      inca%status = scratch_operand
      ier = sic_getvm(inca%size,inca%addr)
      if (ier.ne.1) goto 99
      ipnta = gag_pointer(addr,memory)
      ipntb = gag_pointer(inca%addr,memory)
      call i8toi4_fini_sl(memory(ipnta),memory(ipntb),np,error)
      if (error)  return
    elseif (type.eq.fmt_c4) then
      ! C4 -> I4
      call sic_message(seve%e,rname,'Cannot convert COMPLEX*4 to INTEGER*4')
      error = .true.
      return
    else
      call sic_message(seve%e,rname,'Bad variable type (3)')
      error = .true.
      return
    endif
  elseif (form.eq.fmt_i8) then
    if (type.eq.fmt_r8) then
      ! R8 -> I8
      addr = desc%addr
      np   = desc%size/2
      inca%size = np*2
      inca%ndim = desc%ndim
      inca%dims(:) = desc%dims(:)
      inca%status = scratch_operand
      ier = sic_getvm(inca%size,inca%addr)
      if (ier.ne.1) goto 99
      ipnta = gag_pointer(addr,memory)
      ipntb = gag_pointer(inca%addr,memory)
      call r8toi8_fini_sl(memory(ipnta),memory(ipntb),np,error)
      if (error)  return
    elseif (type.eq.fmt_r4) then
      ! R4 -> I8
      addr = desc%addr
      np   = desc%size
      inca%size = np*2
      inca%ndim = desc%ndim
      inca%dims(:) = desc%dims(:)
      inca%status = scratch_operand
      ier = sic_getvm(inca%size,inca%addr)
      if (ier.ne.1) goto 99
      ipnta = gag_pointer(addr,memory)
      ipntb = gag_pointer(inca%addr,memory)
      call r4toi8_fini_sl(memory(ipnta),memory(ipntb),np,error)
      if (error)  return
    elseif (type.eq.fmt_i4) then
      ! I4 -> I8
      addr = desc%addr
      np   = desc%size
      inca%size = np*2
      inca%ndim = desc%ndim
      inca%dims(:) = desc%dims(:)
      inca%status = scratch_operand
      ier = sic_getvm(inca%size,inca%addr)
      if (ier.ne.1) goto 99
      ipnta = gag_pointer(addr,memory)
      ipntb = gag_pointer(inca%addr,memory)
      call i4toi8_sl(memory(ipnta),memory(ipntb),np)
    elseif (type.eq.fmt_c4) then
      ! C4 -> I8
      call sic_message(seve%e,rname,'Cannot convert COMPLEX*4 to INTEGER*8')
      error = .true.
      return
    else
      call sic_message(seve%e,rname,'Bad variable type (4)')
      error = .true.
      return
    endif
  elseif (form.eq.fmt_c4) then
    call sic_message(seve%e,rname,'Cannot convert to COMPLEX*4 (not implemented)')
    error = .true.
    return
  else
    call sic_message(seve%e,rname,'Bad incarnation type')
    error = .true.
    return
  endif
  error = .false.
  inca%type = form
  inca%readonly = desc%readonly  ! For symmetry with sic_materialize, which also
    ! reuse the readonly code on the input descriptor. Using a different readonly
    ! code can result in erroneous differences in sic_notsamedesc.
  return
  !
99 call sic_message(seve%e,rname,'Memory allocation failure')
  error =.true.
end subroutine sic_incarnate_desc
!
subroutine sic_incarnate_i4(i4,inca,error)
  use gbl_format
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_incarnate_i4
  use sic_dictionaries
  use sic_types
  !---------------------------------------------------------------------
  ! @ public-generic sic_incarnate
  !  Creates an "incarnation" of an explicit I*4 value
  !---------------------------------------------------------------------
  integer(kind=4),        intent(in)    :: i4     ! The value to be incarnated
  type(sic_descriptor_t), intent(out)   :: inca   ! Descriptor of the incarnation
  logical,                intent(inout) :: error  ! Logical error flag
  ! Global
  include 'gbl_memory.inc'
  ! Local
  integer(kind=4) :: ier
  integer(kind=address_length) :: ip
  !
  inca%type = fmt_i4
  inca%size = 1
  inca%ndim = 0
  inca%dims(:) = 0
  inca%readonly = .true.
  ier = sic_getvm(inca%size,inca%addr)
  if (ier.ne.1)  then
    error = .true.
    return
  endif
  inca%status = scratch_operand
  ip = gag_pointer(inca%addr,memory)
  call i4toi4(i4,memory(ip),1)
  !
end subroutine sic_incarnate_i4
!
subroutine sic_incarnate_i8(i8,inca,error)
  use gbl_format
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_incarnate_i8
  use sic_dictionaries
  use sic_types
  !---------------------------------------------------------------------
  ! @ public-generic sic_incarnate
  !  Creates an "incarnation" of an explicit I*8 value
  !---------------------------------------------------------------------
  integer(kind=8),        intent(in)    :: i8     ! The value to be incarnated
  type(sic_descriptor_t), intent(out)   :: inca   ! Descriptor of the incarnation
  logical,                intent(inout) :: error  ! Logical error flag
  ! Global
  include 'gbl_memory.inc'
  ! Local
  integer(kind=4) :: ier
  integer(kind=address_length) :: ip
  !
  inca%type = fmt_i8
  inca%size = 2
  inca%ndim = 0
  inca%dims(:) = 0
  inca%readonly = .true.
  ier = sic_getvm(inca%size,inca%addr)
  if (ier.ne.1)  then
    error = .true.
    return
  endif
  inca%status = scratch_operand
  ip = gag_pointer(inca%addr,memory)
  call i8toi8(i8,memory(ip),1)
  !
end subroutine sic_incarnate_i8
!
subroutine sic_incarnate_r8(r8,inca,error)
  use gbl_format
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_incarnate_r8
  use sic_dictionaries
  use sic_types
  !---------------------------------------------------------------------
  ! @ public-generic sic_incarnate
  !  Creates an "incarnation" of an explicit R*8 value
  !---------------------------------------------------------------------
  real(kind=8),           intent(in)    :: r8     ! The value to be incarnated
  type(sic_descriptor_t), intent(out)   :: inca   ! Descriptor of the incarnation
  logical,                intent(inout) :: error  ! Logical error flag
  ! Global
  include 'gbl_memory.inc'
  ! Local
  integer(kind=4) :: ier
  integer(kind=address_length) :: ip
  !
  inca%type = fmt_r8
  inca%size = 2
  inca%ndim = 0
  inca%dims(:) = 0
  inca%readonly = .true.
  ier = sic_getvm(inca%size,inca%addr)
  if (ier.ne.1)  then
    error = .true.
    return
  endif
  inca%status = scratch_operand
  ip = gag_pointer(inca%addr,memory)
  call r8tor8(r8,memory(ip),1)
  !
end subroutine sic_incarnate_r8
!
subroutine sic_incarnate_l4(l4,inca,error)
  use gbl_format
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_incarnate_l4
  use sic_dictionaries
  use sic_types
  !---------------------------------------------------------------------
  ! @ public-generic sic_incarnate
  !  Creates an "incarnation" of an explicit L*4 value
  !---------------------------------------------------------------------
  logical,                intent(in)    :: l4     ! The value to be incarnated
  type(sic_descriptor_t), intent(out)   :: inca   ! Descriptor of the incarnation
  logical,                intent(inout) :: error  ! Logical error flag
  ! Local
  logical :: found
  !
  found = .true.  ! Verbose
  if (l4) then
    call sic_descriptor('YES',inca,found)
  else
    call sic_descriptor('NO',inca,found)
  endif
end subroutine sic_incarnate_l4
!
subroutine sic_incarnate_ch(ch,inca,error)
  use gbl_format
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_incarnate_ch
  use sic_dictionaries
  use sic_types
  !---------------------------------------------------------------------
  ! @ public-generic sic_incarnate
  !  Creates an "incarnation" of an explicit C*(*) value
  !---------------------------------------------------------------------
  character(len=*),       intent(in)    :: ch     ! The string to be incarnated
  type(sic_descriptor_t), intent(out)   :: inca   ! Descriptor of the incarnation
  logical,                intent(inout) :: error  ! Logical error flag
  ! Global
  include 'gbl_memory.inc'
  ! Local
  integer(kind=4) :: ier,lch
  integer(kind=address_length) :: ip
  !
  lch = len(ch)
  inca%type = lch
  inca%size = (lch+3)/4
  inca%ndim = 0
  inca%dims(:) = 0
  inca%readonly = .true.
  ier = sic_getvm(inca%size,inca%addr)
  if (ier.ne.1)  then
    error = .true.
    return
  endif
  inca%status = scratch_operand
  ip = bytpnt(inca%addr,membyt)
  call bytoby(ch,membyt(ip),lch)
  !
end subroutine sic_incarnate_ch
!
subroutine sic_volatile(desc)
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_volatile
  use sic_dictionaries
  use sic_types
  !---------------------------------------------------------------------
  ! @ public
  ! Free data associated to a variable if it is Scratch
  !---------------------------------------------------------------------
  type(sic_descriptor_t), intent(in) :: desc  !
  !
  if (desc%status.eq.scratch_operand) then
    ! print *,'Freeing Scratch ',desc
    call free_vm(desc%size,desc%addr)
  endif
  !
end subroutine sic_volatile
!
function sic_notsamedesc(one,two)
  use sic_types
  !---------------------------------------------------------------------
  ! @ public
  ! Check if two descriptors are equal
  !---------------------------------------------------------------------
  logical :: sic_notsamedesc  ! Function value on return
  type(sic_descriptor_t), intent(in) :: one  !
  type(sic_descriptor_t), intent(in) :: two  !
  !
  sic_notsamedesc = one%type.ne.two%type           .or.  &
                    one%ndim.ne.two%ndim           .or.  &
                    any(one%dims.ne.two%dims)      .or.  &
                    one%addr.ne.two%addr           .or.  &
                    one%size.ne.two%size           .or.  &
                    one%status.ne.two%status       .or.  &
                    (one%readonly.neqv.two%readonly)
  !
end function sic_notsamedesc
!
subroutine intege(var,inte,error)
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>intege
  use gildas_def
  use sic_structures
  use sic_dictionaries
  use sic_types
  use gbl_format
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! Translate the input variable to an integer value. The routine makes
  ! sure that it is really a scalar numeric variable, and cast it to an
  ! integer if needed.
  !---------------------------------------------------------------------
  type(sic_identifier_t),     intent(inout) :: var    ! Variable to translate
  integer(kind=index_length), intent(out)   :: inte   ! Integer value on return
  logical,                    intent(out)   :: error  ! Logical error flag
  ! Global
  include 'gbl_memory.inc'
  ! Local
  integer*8 :: long
  integer :: in,type,ier
  integer(kind=address_length) :: ipnt
  type(sic_descriptor_t) :: descr
  character(len=message_length) :: mess
  !
  if (var%lname.gt.varname_length) then
    error = .true.
    return
  endif
  !
  ! Search for this variable
  var%level = var_level
  ier = sic_hasfin(maxvar,pfvar,pnvar,dicvar,var,in)
  if (ier.ne.1) then
    var%level = 0
    ier = sic_hasfin(maxvar,pfvar,pnvar,dicvar,var,in)
    if (ier.ne.1) then
      error = .true.
      return
    endif
  endif
  !
  error = .false.
  descr = dicvar(in)%desc
  type = descr%type
  ipnt = gag_pointer(descr%addr,memory)
  if (type.ge.0) then
    error = .true.
  elseif (descr%ndim.ne.0) then
    error = .true.
  elseif (type.eq.fmt_r4) then
    call r4toi8_fini(memory(ipnt),long,1,error)
  elseif (type.eq.fmt_r8) then
    call r8toi8_fini(memory(ipnt),long,1,error)
  elseif (type.eq.fmt_i4) then
    call i4toi8(memory(ipnt),long,1)
  elseif (type.eq.fmt_i8) then
    call i8toi8(memory(ipnt),long,1)
  else
    error = .true.
  endif
  if (error)  return
  !
  inte = long
  if (inte.ne.long) then
    ! One solution might be that this subroutine returns a long integer...
    write(mess,'(A,I0,A)')  &
      'Can not downcast long integer value ',long,' to standard integer'
    call sic_message(seve%e,'DIMENSION',mess)
    error = .true.
    return
  endif
  !
end subroutine intege
!
subroutine extract_array(in,ndin,indim,inoff,item_size,out,ndout,outdim,error)
  use sic_interfaces
  use gildas_def
  use sic_dictionaries
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !   Extract a subarray variable with arbitrary bounds and element size
  !   Valid for a maximum of 4 dimensions
  ! Code is not optimized, but could be at 2 different levels
  ! - moving constant instructions at the upper loop level (the compiler
  !   probably does it)
  ! - suppressing the inner loop
  ! This version for sic_maxdims==7
  !---------------------------------------------------------------------
  integer(kind=1),            intent(in)    :: in(*)       ! Input value array
  integer(kind=4)                           :: ndin        ! Number of dimensions to input variable (unused)
  integer(kind=index_length), intent(in)    :: indim(7)    ! Dimensions of input array
  integer(kind=index_length), intent(in)    :: inoff(7,2)  ! Offsets of subarray within input array
  integer(kind=4),            intent(in)    :: item_size   ! Size (in bytes) of array elements
  integer(kind=1),            intent(out)   :: out(*)      ! Output buffer
  integer(kind=4)                           :: ndout       ! Number of dimensions of output array (unused)
  integer(kind=index_length), intent(in)    :: outdim(7)   ! Dimensions of output array
  logical,                    intent(inout) :: error       ! Logical error flag
  ! Local
  integer(kind=index_length) :: i1,i2,i3,i4,i5,i6,i7
  integer(kind=8) :: off_in,off_out  ! Offsets in the arrays. Use kind=8 integers
  ! because kind=size_length=4 is not enough under 32 bits machines: limit would
  ! be arrays of 2**31-1 bytes = 2**29 real*4 words or 2**28 real*8 words...
  !
  do i7=1,max(outdim(7),1)
    do i6=1,max(outdim(6),1)
      do i5=1,max(outdim(5),1)
        do i4=1,max(outdim(4),1)
          do i3=1,max(outdim(3),1)
            do i2=1,max(outdim(2),1)
              do i1=1,max(outdim(1),1)
                off_in =         (i7+max(inoff(7,1),1)-2) *indim(6)
                off_in = (off_in+(i6+max(inoff(6,1),1)-2))*indim(5)
                off_in = (off_in+(i5+max(inoff(5,1),1)-2))*indim(4)
                off_in = (off_in+(i4+max(inoff(4,1),1)-2))*indim(3)
                off_in = (off_in+(i3+max(inoff(3,1),1)-2))*indim(2)
                off_in = (off_in+(i2+max(inoff(2,1),1)-2))*indim(1)
                off_in = (off_in+(i1+max(inoff(1,1),1)-2))*item_size+1
                !
                off_out =          (i7-1) *outdim(6)
                off_out = (off_out+(i6-1))*outdim(5)
                off_out = (off_out+(i5-1))*outdim(4)
                off_out = (off_out+(i4-1))*outdim(3)
                off_out = (off_out+(i3-1))*outdim(2)
                off_out = (off_out+(i2-1))*outdim(1)
                off_out = (off_out+(i1-1))*item_size+1
                ! Avoid calling a subroutine
                ! call bytoby(in(off_in),out(off_out),item_size)
                out(off_out:off_out+item_size-1) = in(off_in:off_in+item_size-1)
              enddo
            enddo
          enddo
        enddo
      enddo
    enddo
  enddo
  !
end subroutine extract_array
!
subroutine copy_back(in,out,ndim,dim,name,error)
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>copy_back
  use gildas_def
  use sic_structures
  use sic_dictionaries
  use sic_types
  use gbl_message
  use gbl_format
  !---------------------------------------------------------------------
  ! @ private
  !  Copy back from scratch contiguous incarnation of a subarray to the
  ! relevant fraction of the original variable.
  !---------------------------------------------------------------------
  type(sic_descriptor_t),     intent(in)    :: in     ! Descriptor of scratch incarnation of subarray
  type(sic_descriptor_t),     intent(in)    :: out    ! Descriptor of the permanent variable
  integer,                    intent(in)    :: ndim   ! Number of fixed indexes
  integer(kind=index_length), intent(in)    :: dim(sic_maxdims,2)  ! Fixed indexes
  character(len=*),           intent(in)    :: name   ! Name of variable
  logical,                    intent(inout) :: error  ! Logical error flag
  ! Global
  include 'gbl_memory.inc'
  ! Local
  character(len=*), parameter :: rname='LET'
  integer :: i,j,type,item_size
  type(sic_descriptor_t) :: new_in
  integer(kind=address_length) :: ipntin,ipntout
  character(len=message_length) :: mess
  !
  if (error) then
    ! Caller is in error condition:
    ! - do not modify the error flag
    ! - do not do anything here
    return
  endif
  !
  new_in = in
  !
  ! Check for some internal logic errors. Remove when fully tested?
  ! Full arrays should have been filled
  if (ndim.eq.0) then
    call sic_message(seve%e,rname,'Copying back a full copy of '//name)
    error = .true.
    return
  endif
  !
  ! Restore degenerate input dimensions
  j = 0
  do i=1,ndim
    ! Dummy sizes should have been substituted earlier
    if (dim(i,1).eq.0.or.dim(i,2).eq.0) then
      call sic_message(seve%e,rname,'Dummy dimensions remaining in COPY_BACK')
      error = .true.
      return
    elseif (dim(i,1).eq.dim(i,2)) then
      new_in%dims(i) = 1
      j = j+1
    elseif ((dim(i,2)-dim(i,1)+1).eq.in%dims(i-j)) then
      new_in%dims(i) = in%dims(i-j)
    else
      call sic_message(seve%e,rname,'Internal logic error detected in '//  &
      'COPY_BACK')
      error = .true.
      return
    endif
  enddo
  if (ndim.gt.out%ndim) then
    call sic_message(seve%e,rname,'Inconsistent number of dimensions '//  &
    'between scratch and permanent')
    call sic_message(seve%e,rname,'incarnations for '//name)
    write(mess,*) ndim,in%ndim,out%ndim
    call sic_message(seve%e,rname,mess)
    error = .true.
    return
  endif
  new_in%ndim = out%ndim
  !
  ! Compute element size in byte units
  type = in%type
  if (type.eq.fmt_r8 .or. type.eq.fmt_c4 .or. type.eq.fmt_i8) then ! Double
    item_size = 8
  elseif (type.gt.0) then      ! Char
    item_size = type
  else                         ! Anything else
    item_size = 4
  endif
  !
  ! Immerse a subarray. Not at all optimised.
  ipntin  = gag_pointer(in%addr,memory)
  ipntout = gag_pointer(out%addr,memory)
  call plunge_array(memory(ipntin),new_in%ndim,new_in%dims,dim,  &
    item_size,memory(ipntout),out%ndim,out%dims,error)
end subroutine copy_back
!
subroutine plunge_array(in,ndin,indim,outoff,item_size,out,ndout,outdim,error)
  use sic_interfaces
  use gildas_def
  use sic_dictionaries
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  ! Plunge an array into a bigger one.
  ! Code is not optimized, but could be at 2 different levels
  ! - moving constant instructions at the upper loop level (the compiler
  !   probably does it)
  ! - suppressing the inner loop
  ! This version for sic_maxdims==7
  !---------------------------------------------------------------------
  integer(kind=1),            intent(in)    :: in(*)        ! Input array
  integer(kind=4)                           :: ndin         ! Unused, but could be
  integer(kind=index_length), intent(in)    :: indim(7)     ! Array dimensions
  integer(kind=index_length), intent(in)    :: outoff(7,2)  ! Array position
  integer(kind=4),            intent(in)    :: item_size    ! Size of element in Bytes
  integer(kind=1),            intent(out)   :: out(*)       ! Output array
  integer(kind=4)                           :: ndout        ! Unused, but could be
  integer(kind=index_length), intent(in)    :: outdim(7)    ! Array dimensions
  logical,                    intent(inout) :: error        ! Unused
  ! Local
  integer(kind=index_length) :: i1,i2,i3,i4,i5,i6,i7
  integer(kind=8) :: off_in,off_out  ! Offsets in the arrays. Use kind=8 integers
  ! because kind=size_length=4 is not enough under 32 bits machines: limit would
  ! be arrays of 2**31-1 bytes = 2**29 real*4 words or 2**28 real*8 words...
  !
  do i7=1,max(indim(7),1)
    do i6=1,max(indim(6),1)
      do i5=1,max(indim(5),1)
        do i4=1,max(indim(4),1)
          do i3=1,max(indim(3),1)
            do i2=1,max(indim(2),1)
              do i1=1,max(indim(1),1)
                off_out =            (i7+max(outoff(7,1),1)-2) *outdim(6)
                off_out = (off_out + (i6+max(outoff(6,1),1)-2))*outdim(5)
                off_out = (off_out + (i5+max(outoff(5,1),1)-2))*outdim(4)
                off_out = (off_out + (i4+max(outoff(4,1),1)-2))*outdim(3)
                off_out = (off_out + (i3+max(outoff(3,1),1)-2))*outdim(2)
                off_out = (off_out + (i2+max(outoff(2,1),1)-2))*outdim(1)
                off_out = (off_out + (i1+max(outoff(1,1),1)-2))*item_size+1
                !
                off_in =         (i7-1) *indim(6)
                off_in = (off_in+(i6-1))*indim(5)
                off_in = (off_in+(i5-1))*indim(4)
                off_in = (off_in+(i4-1))*indim(3)
                off_in = (off_in+(i3-1))*indim(2)
                off_in = (off_in+(i2-1))*indim(1)
                off_in = (off_in+(i1-1))*item_size+1
                ! Avoid calling a subroutine
                ! call bytoby(in(off_in),out(off_out),item_size)
                out(off_out:off_out+item_size-1) = in(off_in:off_in+item_size-1)
              enddo
            enddo
          enddo
        enddo
      enddo
    enddo
  enddo
  !
end subroutine plunge_array

subroutine selfcal_comm(line,comm,error)
  use gkernel_interfaces
  !---------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- Support for command SELFCAL
  !
  !   This actually cannot be in the CLEAN\ language, because it implies
  !   re-entrancy of RUN_CLEAN - Not a big issue, but currently forbidden 
  !   by our coding practice, so we place it the ADVANCED\ language
  !!
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: comm        !! Command name
  character(len=*), intent(inout) :: line     !! Command line
  logical, intent(inout) :: error             !! Logical error flag
  !
  ! Local ---
  character(len=256) :: argum
  integer :: na
  logical :: do_insert
  !
  ! Code ----
  do_insert = sic_lire().eq.0
  if (sic_present(1,0)) then
    call exec_program('@ p_selfcal /WIDGET')
  else
    if (sic_narg(0).eq.0) then
      call sic_get_char('SELF_MODE',argum,na,error)
    else
      ! Pass all arguments "as they are"
      na = index(line,trim(comm))+8
      argum = line(na:)
    endif
    call exec_program('@ p_selfcal '//argum)
  endif
  if (do_insert) call sic_insert_log(line)
end subroutine selfcal_comm
!
subroutine init_selfcal(rname,line,error)
  use clean_arrays
  use clean_default
  use gbl_message
  use gkernel_interfaces
  use imager_interfaces, except_this => init_selfcal
  !---------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- Support for command 
  ! UV_SELF /RANGE [Min Max Type]
  !
  ! Create the Self-Calibration UV tables from the current one
  ! by averaging the specified range of channels.  
  !     a)  hself_calib and hself_raw : the continuum compressed line UV data   
  !     b)  Hself : the Continuum UV data  
  !!
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: rname     !! Caller name
  character(len=*), intent(inout) :: line   !! Command line
  logical, intent(inout) :: error           !! Logical error flag
  !
  ! Constants
  integer, parameter :: opt_rang=1
  integer(kind=4), parameter :: mtype=3
  integer, parameter :: mranges=50
  character(len=12) :: types(mtype),mytype
  data types /'CHANNEL','VELOCITY','FREQUENCY'/
  !
  ! Local ---
  integer :: SELF_COMPRESS    ! Test variable
  logical :: SELF_DEBUG=.false.
  character(len=12) :: comm='UV_COMPRESS '
  integer :: ni,nt,nu,nv,nchan,ncomp
  integer :: channels(3)
  integer, allocatable :: chflag(:)
  !
  integer :: itype
  character(len=12) :: ctype
  integer :: ndim, ier
  real(8) :: drange(mranges)
  integer :: nc(mranges),numchan,ntmp,i
  !
  real :: cpu0, cpu1
  real :: uvmax, uvmin, field
  integer :: nline, n, narg
  logical :: sorted, shift, needed
  real(kind=8) :: new(3)
  character(len=80) :: chain, acomm, string
  !
  ! Code ----
  call map_message(seve%t,rname,'Init_Selfcal -- Starting ',seve%e)
  SELF_COMPRESS = 0
  call sic_get_inte('SELF_COMPRESS',SELF_COMPRESS,error)
  call sic_get_logi('DEBUG_SELF',self_debug,error)
  error = .false.
  !
  ! Code
  call map_message(seve%i,rname,'Initializing the "selfcal" UV data set',seve%w)
  !
  ! Erase current Self-Calibration UV tables
  if (associated(duvself)) then
    if (associated(duvself,duvcalib)) then
      nullify(duvself)
    else
      deallocate(duvself)
    endif
  endif
  if (allocated(duvcalib)) deallocate(duvcalib)
  if (allocated(duvraw)) deallocate(duvraw)
  call sic_delvariable('UVRAW',.false.,error) 
  call sic_delvariable('UVCALIB',.false.,error) 
  call sic_delvariable('UVSELF',.false.,error) 
  error = .false.
  !
  ! Decode the command line arguments
  numchan = max(sic_narg(opt_rang),0)
  nc = 0
  if (mod(numchan,2).eq.0) then
    !  Default CTYPE is CHANNEL
    mytype = 'CHANNEL'
  else if (numchan.eq.1) then
    call sic_ch(line,opt_rang,numchan,ctype,ndim,.true.,error)
    if (ctype.ne.'*') then
      call map_message(seve%e,rname,'/RANGE option syntax error')
      error = .true.
      return
    endif
    numchan = 0
  else
    call sic_ke(line,opt_rang,numchan,ctype,ndim,.true.,error)
    if (error) return
    call sic_ambigs(rname,ctype,mytype,itype,types,mtype,error)
    if (error)  return
    numchan = numchan-1
  endif
  !
  do i=1,numchan
    call sic_r8(line,opt_rang,i,drange(i),.true.,error)
    if (error) return
  enddo
  !
  ! Then, shift, rotate and sort the initial UV Table
  narg = sic_narg(0)
  string = defmap_center
  n = len_trim(string)
  !
  if (narg.eq.0) then
    if (n.ne.0) then
      line = 'CALIBRATE'//char(92)//trim(rname)//' '//string(1:n)
      nline = len_trim(line)
      call sic_analyse(acomm,line,nline,error)
      if (error) return
    endif
  endif
  call map_center(line,rname,huv_current,shift,new,error)
  if (error) return
  !
  call gag_cpu(cpu0)
  needed = themap%uniform(2).ne.0
  call uv_sort (huv_current,duv,error,sorted,shift,new,uvmax,uvmin,needed)
  if (error) return
  if (.not.sorted) then
    ! Redefine SIC variables (mandatory)
    call map_uvgildas ('UV',huv_current,error,duv)
    call gag_cpu(cpu1)
    write(chain,'(A,F9.2)') 'Finished sorting ',cpu1-cpu0
    call map_message(seve%i,rname,chain)
  endif
  !
  ! Now, define the Raw UV table
  call gildas_null(hself_raw,type='UVT')
  call gildas_null(hself_calib,type='UVT')
  call gildas_null(hself_self,type='UVT')
  !
  hself_calib%gil%nchan = 0 ! No known channel in Calib
  !
  IF (SELF_COMPRESS.eq.0) THEN
    !
    ! Here we use the UV_AVERAGE method - Single channel output
    huv_current%r2d => duv
    ndim = huv_current%gil%nlead+3+huv_current%gil%ntrail
    allocate(duvraw(ndim,huv_current%gil%dim(2)),duvcalib(ndim,huv_current%gil%dim(2)),stat=ier)
    if (ier.ne.0) then
      call map_message(seve%e,rname,'Self Calibration UV table allocation error')
      error = .true.
      return
    endif
    hself_raw%r2d => duvraw
    !
    ! At this stage, we should reset MAP_CENTER...
    acomm = 'LET MAP_CENTER " "'
    call exec_command(acomm,error)
    !
    ! Convert range to channels
    nc = 0
    if (numchan.eq.0) then
      numchan = 2
      nc(1) = 1
      nc(2) = huv_current%gil%nchan 
      !
      ! Could use here the same limit as defined by UV_CHECK BEAM
      call channel_restrict(rname,nc(1),nc(2),error)
      error = .false.
    else if (mytype.eq.'CHANNEL') then
      nc(1:numchan) = nint(drange(1:numchan))
    else if (mytype.eq.'VELOCITY') then
      ! drange = nc - y%gil%ref(y%gil%faxi) ) * y%gil%vres + y%gil%voff 
      nc(1:numchan) = (drange(1:numchan) - huv_current%gil%voff) / huv_current%gil%vres + huv_current%gil%ref(huv_current%gil%faxi)
    else if (mytype.eq.'FREQUENCY') then
      ! drange = nc - y%gil%ref(y%gil%faxi) ) * y%gil%vres + y%gil%voff 
      nc(1:numchan) = (drange(1:numchan) - huv_current%gil%freq) / huv_current%gil%fres + huv_current%gil%ref(huv_current%gil%faxi)
    else
      call map_message(seve%e,rname,"Type of value '"//trim(mytype)//"' not supported")
      error = .true.
      defmap_center = string
      return
    endif
    !
    do i=2,numchan,2
      if (nc(i).lt.nc(i-1)) then
        ntmp = nc(i)
        nc(i) = nc(i-1)
        nc(i-1) = ntmp
      endif
    enddo
    !SG
    huv_current%img%bounds(1) = nc(1)       ! Update the Bounds values
    huv_current%img%bounds(2) = nc(numchan) ! Update the Bounds values
    if (.not.allocated(huv_current%img%flags)) then
!!      Print *,'PROGRAM ERROR, huv_current%img%flags not allocated'
      allocate (huv_current%img%flags(huv_current%gil%nchan))
      huv_current%img%flags = 1
    endif
    !
    call do_uv_average(rname,huv_current,hself_raw,numchan,nc,error)
    ! Copy to UVCALIB & UVSELF
    call gdf_copy_header(hself_raw,hself_calib,error)
    call gdf_copy_header(hself_raw,hself_self,error)
    duvcalib(:,:) = duvraw(:,:)     ! A Physical copy
    duvself => duvcalib             ! A Pointer : no difference since only 1 channel
    hself_self%r2d => duvself
    call map_uvgildas ('UVSELF',hself_self,error,duvself)
  else
    !
    ! Here, we shall use the UV_COMPRESS approach 
    ! combined with the UV_CONTINUUM methodology
    call gdf_copy_header(huv_current,hself_raw,error)
    if (.not.associated(huv_current%r2d,duv)) then
      call map_message(seve%e,rname,'HUV_Current not associated to DUV - Attempting to process')
      huv_current%r2d => duv
    endif
    ncomp = max(0,SELF_COMPRESS)
    field = 0.0
    call sub_cont_average(comm,huv_current,hself_raw,ncomp,field,error)
    ! !call gdf_print_header (hself_raw) 
    !
    ! Work with complete structure
    hself_raw%gil%dim(1) = 3*hself_raw%gil%nchan + 7 + hself_raw%gil%ntrail ! and nothing more ...
    if (hself_raw%gil%ntrail.ne.0) then
      do i=1,code_uvt_last
        if (hself_raw%gil%column_pointer(i).gt.hself_raw%gil%lcol) hself_raw%gil%column_pointer(i) =  &
          & hself_raw%gil%column_pointer(i) + hself_raw%gil%dim(1) - huv_current%gil%dim(1)
      enddo
    endif
    !
    ni = huv_current%gil%dim(1)
    nu = hself_raw%gil%dim(1)
    nv = hself_raw%gil%dim(2)
    nt = hself_raw%gil%ntrail
    nchan = hself_raw%gil%nchan
    !
    allocate(duvraw(hself_raw%gil%dim(1),huv_current%gil%dim(2)),stat=ier)
    if (ier.ne.0) then
      call map_message(seve%e,rname,'Self Calibration UV table allocation error')
      error = .true.
      return
    endif
    call compress_uv (duvraw,nu,nv,nchan,duv,ni,ncomp,nt,huv_current%img%flags)   
    !
    ! Copy this one to CALIB area
    call gdf_copy_header(hself_raw,hself_calib,error)
    allocate(duvcalib(hself_raw%gil%dim(1),huv_current%gil%dim(2)),stat=ier)
    if (ier.ne.0) then
      call map_message(seve%e,rname,'CALIB Memory allocation error')
      error = .true.
      return
    endif
    duvcalib(:,:) = duvraw(:,:)
    call map_uvgildas('UVCALIB',hself_calib,error,duvcalib)
    !
    call map_uvgildas('UVRAW',hself_raw,error,duvraw)
    !
    if (nchan.gt.1) then
      !
      ! The convert the table to a Continuum one
      channels = [1,nchan,1]
      call uv_cont_header(rname,hself_calib,hself_self,channels,expand_cont,error)
      if (error) return
      ! and then the data
      allocate(duvself(hself_self%gil%dim(1),hself_self%gil%dim(2)),chflag(nchan),stat=ier) 
      if (ier.ne.0) then
        call map_message(seve%e,rname,'SELF Memory allocation error')
        error = .true.
        return
      endif
      chflag = 1
      ! 1=code_uvt, specifying UV Table shape
      hself_self%r2d => duvself
      hself_calib%r2d => duvcalib
      call t_continuum(hself_calib,hself_self,channels,1,error) ! No: ,spindex,ofreq)
      if (error) return
    else
      !
      ! Just point to that
      call gdf_copy_header(hself_calib,hself_self,error)
      duvself => duvcalib
    endif
    call map_uvgildas ('UVSELF',hself_self,error,duvself)
  ENDIF
  !
  if (self_debug) then
    Print *,'EXPAND_CONT ',expand_cont,' SELF_COMPRESS ',self_compress
    read(*,*) expand_cont
  endif
  !
  ! At this stage, we should reset MAP_CENTER again...
  defmap_center = string
  !
  ! And force Weight re-computation
  do_weig = .true.
  call map_message(seve%t,rname,'Init_Selfcal -- Ending ',-2)
end subroutine init_selfcal
!
subroutine do_uv_average(rname,hin,hou,numchan,nc,error)
  use gildas_def
  use gkernel_interfaces
  use imager_interfaces, only : map_message, sub_uv_average
  use image_def
  use gbl_format
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER --  Support for command SELFCAL
  !
  !   Average all selected line channels to 1 continuum channel
  !   Driver routine: prepare header and call per-visibility processing
  !   subroutine
  !!
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: rname     !! Caller
  type(gildas), intent(in) :: hin           !! Input raw visibility header
  type(gildas), intent(inout) :: hou        !! Output Self-Cal header
  integer, intent(in) :: numchan            !! Number of channel ranges
  integer, intent(in) :: nc(numchan)        !! Channel ranges
  logical, intent(out) :: error             !! Logical error flag
  !
  ! Local ---
  character(len=filename_length) :: text
  integer(4) :: nchan, nsum, i
  real(8) :: freq
  !
  ! Code ----
  error = .false.
  !
  if (hin%loca%size.eq.0 .or. .not.associated(hin%r2d)) then
    call map_message(seve%e,rname,'Input UV data is not allocated')
    error = .true.
    return
  endif
  !
  ! Define number of channels being added and effective mean channel
  nchan = 0
  nsum = 0
  do i=2,numchan,2
    nchan = nc(i)-nc(i-1)+1+nchan
    nsum = (nc(i)+nc(i-1))*(nc(i)-nc(i-1)+1)/2+nsum
    if (i.eq.2) then
      write (text,'(2(A,I0))') 'Averaging channels from ',   &
              nc(i-1),' to ',nc(i)
    else
      write (text,'(2(A,I0))') '              and  from ',   &
              nc(i-1),' to ',nc(i)
    endif
    call map_message(seve%i,rname,text)
  enddo
  !
  ! Define output image
  call gdf_copy_header (hin, hou, error)
  !
  ! Do not forget trailing columns
  hou%gil%dim(1) = 10+hou%gil%ntrail
  hou%gil%inc(1) = hou%gil%inc(1)*nchan
  hou%gil%ref(1) = 1.d0-(float(nsum)/nchan-hou%gil%ref(1))/nchan
  hou%gil%vres = nchan*hou%gil%vres
  hou%gil%fres = nchan*hou%gil%fres
  hou%gil%nchan = 1
  call gdf_uv_shift_columns(hin,hou)
  call gdf_setuv (hou, error)
  if (error) return
  !
  ! Bring reference channel to 1
  freq = (1.d0-hou%gil%ref(1))*hou%gil%inc(1) + hou%gil%val(1)
  hou%gil%ref(1) = 1.
  hou%gil%val(1) = freq
  ! Set Frequency accordingly
  hou%gil%freq = freq
  !
  if (.not.allocated(hin%img%flags)) call map_message(seve%e,rname, &
    & 'Flags not allocated')
  call sub_uv_average (hou%r2d, hou%gil%dim(1),hou%gil%dim(2),   &
   &    hou%gil%nlead,  hou%gil%ntrail,               &
   &    hin%r2d ,hin%gil%dim(1),nc,numchan, hin%img%flags)
  hou%loca%size = hou%gil%dim(1) * hou%gil%dim(2)
end subroutine do_uv_average
!
subroutine sub_uv_average (out,nx,nv,nlead,ntrail,inp,ny,nc,num,goodch)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- Support for command SELFCAL  
  !   Average all selected line channels to 1 continuum channel
  !!
  !---------------------------------------------------------------------
  integer(kind=index_length) :: nx    !! Size of output visibility
  integer(kind=index_length) :: nv    !! Number of visibilities
  integer, intent(in) :: nlead        !! Leading columns
  integer, intent(in) :: ntrail       !! Trailing columns
  real :: out(nx,nv)                  !! Output visibilities
  integer(kind=index_length) :: ny    !! Size of input visibility
  real :: inp(ny,nv)                  !! Input visibilities
  integer :: num                      !! Number of ranges times 2
  integer :: nc(num)                  !! Range boundaries
  integer :: goodch(:)                !! Channel flags
  !
  ! Local ---
  integer :: k,kk,l
  integer(kind=index_length) :: j
  real :: a,b,c
  !
  ! Code ----
  do j=1,nv
    out(1:nlead,j) = inp(1:nlead,j)
    a = 0.0
    b = 0.0
    c = 0.0
    do l=2,num,2
      do k=nc(l-1),nc(l)
        if (goodch(k).gt.0) then
          kk = nlead+3*k
          if (inp(kk,j).gt.0) then
            a = a+inp(kk-2,j)*inp(kk,j)
            b = b+inp(kk-1,j)*inp(kk,j)
            c = c+inp(kk  ,j)
          endif
        endif
      enddo
    enddo
    if (c.ne.0.0) then
      out(8,j) =a/c
      out(9,j) =b/c
      out(10,j)=c              ! time*band
    else
      out(8,j) =0.0
      out(9,j) =0.0
      out(10,j)=0.0
    endif
    if (ntrail.gt.0) out(11:nx,j) = inp(ny-ntrail+1:ny,j)
  enddo
end subroutine sub_uv_average
!
subroutine switch_uv_cont(line,comm,do_cct,error)
  use gildas_def 
  use clean_arrays
  use gbl_message
  use gkernel_interfaces
  use imager_interfaces, except_this => switch_uv_cont
  !---------------------------------------------------------------------
  ! @ private
  !
  ! IMAGER --  Support for command UV_MAP /CONT (and UV_SELF)
  !
  ! Temporarily point towards the "continuum" UV data
  !---------------------------------------------------------------------
  character(len=*), intent(inout) :: line     !! Command line
  character(len=*), intent(in)    :: comm     !! Command name
  logical, intent(in) :: do_cct     !! Remove Clean Components before ?
  logical, intent(inout) :: error   !! Logical error flag
  !
  ! Constants
  ! ' UV_MAP', '/TRUNCATE',  '/FIELDS', '/RANGE', '/CONTINUUM', '/INDEX'
  integer, parameter :: o_trunc=1
  integer, parameter :: o_field=2
  integer, parameter :: o_range=3
  integer, parameter :: o_cont=4
  integer, parameter :: o_index=5
  !
  ! Local ---
  integer :: channels(3)
  integer :: ier
  !
  ! Code ----
  !
  ! Select the data set. Can be UV_DATA, UV_MODEL, or UV_RESIDUAL
  ! We may have an issue about data sorting here,
  ! as well as Weight re-computation
  call uvdata_select(comm,error)
  if (error) return
  !
  if (do_cct) then
    ! The UV data may have changed since last UV_MAP /CONT command
    if (huv_cont%loca%size.eq.0) then
      call map_message(seve%e,comm,'Continuum UV data not defined')
      error = .true.
      return
    endif
    ! Take the imaging mode from previous values
    if (.not.associated(huv_cont%r2d,duvc)) then  !
      call map_message(seve%w,comm,'UVCONT Pointer not associated',seve%e)
      huv_cont%r2d => duvc
      do_weig = .true.
    endif
    call print_imaging(comm,'Continuum DO_CCT ',huv_cont%img)
  else
    call sub_uvcont_header(line,error,huv_cont,channels,o_cont,o_index,o_range)
    if (error) return
    call print_imaging(comm,'UV_CONT',huv_cont%img)
    !
    if (allocated(duvc)) deallocate(duvc)
    allocate(duvc(huv_cont%gil%dim(1),huv_cont%gil%dim(2)),stat=ier)
    huv_cont%loca%size = huv_cont%gil%dim(1)*huv_cont%gil%dim(2)
    huv_cont%r2d => duvc      ! Could use pointer directly
    huv_current%r2d => duv    ! Normally verified
    call sub_uvcont_data(line,huv_cont,huv_current,channels,o_index,error)
    if (error) return
    !
    ! Save the range of channels and imaging mode.
    huv_cont%img = huv_current%img      !SG
    huv_cont%img%bounds = channels(1:2) !SG
    huv_cont%img%mode = code_img_cont   !SG
    !
    ! Weights must be recomputed
    do_weig = .true.
    call sic_delvariable('UVCONT',.false.,error)
    call sic_mapgildas('UVCONT',huv_cont,error,duvc)
  endif
end subroutine switch_uv_cont
!
subroutine uvdebug_pointers(name,text,huvl)
  use image_def
  use gbl_message
  use imager_interfaces, only : map_message
  !! IMAGER - Debug the Mosaic offset pointers
  character(len=*), intent(in) :: name    !! Caller name
  character(len=*), intent(in) :: text    !! Buffers name
  type (gildas), intent(in) :: huvl       !! UV header
  !
  character(len=80) :: chain
  !
  write(chain,'(A,I6,I6,A,I6,I6,A,I4)') ', X (Point) ',&
    & huvl%gil%column_pointer(code_uvt_xoff), &
    & huvl%gil%column_pointer(code_uvt_yoff), &
    & ',  L (phase) ', &
    & huvl%gil%column_pointer(code_uvt_loff), &
    & huvl%gil%column_pointer(code_uvt_moff), &
    & ',  ID (Source) ', &
    & huvl%gil%column_pointer(code_uvt_id)
  call map_message(seve%d,name,text//chain,seve%e)
end subroutine uvdebug_pointers
!
!
subroutine no_mosaic(rname)
  use clean_def
  use clean_default
  use clean_arrays
  use gbl_message
  use gkernel_interfaces
  use imager_interfaces, only : map_message
  !---------------------------------------------------------------------  !
  ! @ private
  !*
  ! IMAGER -- Switch back prompt to IMAGER>
  !!
  !---------------------------------------------------------------------  !
  character(len=*), intent(in) :: rname  !! Caller name
  !
  logical :: error
  !
  if (user_method%mosaic) then
    call map_message(seve%i,rname,'Switching to NORMAL mode')
    call gprompt_set('IMAGER')
    user_method%trunca = 0.0
    call sic_delvariable('PRIMARY',.false.,error)
    hprim%gil%dim(1) = 1
    user_method%mosaic = .false.
  endif
end subroutine no_mosaic
!

# Adjust list of files as desired, according to files
# found on GitHub on url below
for x in define-system.sh gildas-env.sh Makefile.def; do
  echo $x
  #
  # Step 1: Download the specified patch from GitHub
  rm ~/Downloads/patch-admin-$x.diff.zip
  open https://downgit.github.io/#/home?url=https://github.com/macports/macports-ports/blob/master/science/gildas/files/patch-admin-$x.diff
  # (almost) Ensure download is complete
  sleep 3
  # then Unzip it
  mv ~/Downloads/patch-admin-$x.diff.zip ./
  rm patch-admin-$x.diff
  unzip patch-admin-$x.diff.zip
  rm patch-admin-$x.diff.zip
  #
  # Step 2: Apply the patch
  cp $IRAM_ROOT/admin/$x ./
  patch -o $x.orig $x patch-admin-$x.diff
done 
#
# At this step, the .orig files contains what is appropriate for MacPorts according to GILDAS
#
# Step 3: Customize the .orig files for IMAGER
# 3.1 Makefile.def
sed 's/LATEX2HTML = latex2html/LATEX2HTML = makehtml/g' Makefile.def.orig > Maketmp.def
diff Maketmp.def Makefile.def.orig
mv Maketmp.def Makefile.def.orig
#
# 3.2 Makefile.build
sed 's/$(LATEX2HTML) -dir $@ $</$(LATEX2HTML) $</' $IRAM_ROOT/admin/Makefile.build > Makefile.build.orig
#
# 3.3 Convert gildas-env.sh to imager-env.sh
sed 's/gildas/imager/g; s/GILDAS/IMAGER/g' gildas-env.sh.orig > imager-env.a.tmp
sed 's/J. Pety <pety@iram.fr>/S.Guilloteau <stephane.guilloteau@u-bordeaux.fr>/g; s|http://www.iram.fr/IRAMFR/IMAGER>|https://imager.oasu.u-bordeaux.fr>|g' imager-env.a.tmp > imager-env.b.tmp
echo '# Script Cloned from gildas-env.sh (J.Pety pety@iram.fr), but customized for IMAGER' > imager-env.sh.orig
cat imager-env.b.tmp >> imager-env.sh.orig
rm imager-env.b.tmp imager-env.a.tmp

###########################################################################
#
# This file defines useful bash functions for GILDAS/USERS interaction
# at IRAM Grenoble.
#
# Warnings:
#
#   This files is loaded very early in the logging process.
#   You thus must put here only fonction and variable definitions.
#
#   Forbidden stuffs: 
#      1. DISPLAY and KEYBOARD related variable definitions.
#      2. Any executable commands.
#
# J.Pety and P.Dumontroty 2004
#
###########################################################################
#
# This function loads the GILDAS environment of the corresponding version.
# Type "gagiram -h" for more details. 
#
function gagiram() { 
    export gaghome=~gildas/gildas
    source $gaghome/gildas-admin/source-gag.sh "$@"
    set --
    if [ -f ~gildas/bin/set-iram-gag-search-path ]; then
        source ~gildas/bin/set-iram-gag-search-path
    fi
}
#
function gagiramgit() { 
    # Non-public function which loads Gildas compiled from git
    export gaghome=~gildas/gildas-git
    source $gaghome/gildas-admin/source-gag.sh "$@"
    set --
    if [ -f ~gildas/bin/set-iram-gag-search-path ]; then
        source ~gildas/bin/set-iram-gag-search-path
    fi
}
#
# This function enables easy browsing of the GILDAS source or executable 
# tree. $gagsrcdir and $gagexedir must be defined. You can use 
# "gagiram -ms" or "gagiram -me" to define them. 
# Type "go -h" for more details.
#
function go() {
    if [ -z "$gagadmdir" ]; then
	echo 'Please select first a GILDAS version using gagiram' 1>&2
    else
	source $gagadmdir/go.sh "$@"
    fi
}
#
# Gfortran compiler is different from one OS to another
if [ `cut -d" " -f1 /etc/redhat-release` = "CentOS" ]; then
    GAGIRAM_GFORTRAN=gfortran81  # For CentOS 7.4
else
    GAGIRAM_GFORTRAN=gfortran62  # for Scientific Linux 6.4 and 6.8
fi
#
# Shortcut for parallel version compiled at IRAM. This hides details
# about compiler (kind and version) and config used:
function gagpara() {
    gagiram -c $GAGIRAM_GFORTRAN -o openmp "$@"
}
#
# Shortcut for profiling version compiled at IRAM. This hides details
# about compiler (kind and version) and config used:
function gagprofile() {
    gagiram -c $GAGIRAM_GFORTRAN -o profile "$@"
}
#
# Shortcut for sanitizer version compiled at IRAM. This hides details
# about compiler (kind and version) and config used:
function gagsanitize() {
    gagiram -c $GAGIRAM_GFORTRAN -o sanitize "$@"
}
#
# GIT public shortcuts
function gitiram() {  # Default is parallel version
    gagiramgit -c $GAGIRAM_GFORTRAN -o openmp "$@"
}
function gitpara() {
    gagiramgit -c $GAGIRAM_GFORTRAN -o openmp "$@"
}
function gitserial() {
    gagiramgit -c $GAGIRAM_GFORTRAN "$@"
}
#
# PIIC shortcut
function gagpiic() {
    export gaghome=~gildas/piic
    source $gaghome/gildas-admin/source-gag.sh "$@"
    set --
    if [ -f ~gildas/bin/set-iram-gag-search-path ]; then
        source ~gildas/bin/set-iram-gag-search-path
    fi
}
#
export -f gagiram gagiramgit go gagpara gagprofile gagsanitize gitiram gitpara gitserial gagpiic
export GAGIRAM_GFORTRAN
#
# The next command automatically loads the environment variables
# needed for the default GILDAS version (ie last fully compiled).
# That standard IRAM users will have a working GILDAS version without
# any personal customization. The user (in particular developers) may
# decide to avoid this just by creating the following file:
# $HOME/.no-initial-gagiram
#
if [ ! -e $HOME/.no-initial-gagiram ]; then
    gagiram > /dev/null 2>&1
fi
#
###########################################################################

# No change usually
# for fdir in gchar gcont gcore ggtk ggui gkernel gwindows # gx11 gmotif

for fdir in gfits gio gmath greg gsys gtv gwcs gwidget gwindows gxml gcore ggtk sic
do
  echo $fdir
  source diff-f90.sh kernel/lib/$fdir > DIFF-GILDAS/diff-$fdir.txt
  cd $OLDPWD
  source diff-c.sh kernel/lib/$fdir >> DIFF-GILDAS/diff-$fdir.txt
  cd $OLDPWD
done

#!/bin/sh
b=${1%.*} 
echo "Processing HTML documentation for " $b
#
pdflatex $b
bibtex $b
pdflatex $b
pdflatex $b
latex2html $b
rm $b/tmp-jax.html
cd $b
#
for file in `ls -1 *.html`
  do
    echo $file
    #  echo "${file:0:10}"
    mv $file tmp-jax.html
    plug-jax < tmp-jax.html > $file
  done
cp $b.html index.html
cp $b.css tmp.css
sed -e 's/50em/80em/' tmp.css > $b.css 
cd ..
if [ ! -d "$gagsrcdir/integ/doc/html/$b-html" ]; then
  mkdir $gagsrcdir/integ/doc/html/$b-html
fi
cp $b/* $gagsrcdir/integ/doc/html/$b-html/

echo '# Cloned from gildas-env.sh, but replacing "gildas" with "imager" to avoid name collisions.' > test-env.sh
cat gildas-env.sh >> test-env.sh
sed -i '' -e 's/gildas-/imager-/g' test-env.sh
sed -i '' -e 's/GILDAS/IMAGER/g' test-env.sh
sed -i '' -e 's/J. Pety <pety@iram.fr>/S. Guilloteau <stephane.guilloteau@u-bordeaux.fr/g' test-env.sh
sed -i '' -e 's#http://www.iram.fr/IRAMFR/IMAGER>#https://imager.oasu.u-bordeaux.fr>#g' test-env.sh
